<?php

class FornecedorForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Fornecedor';
    private static $primaryKey = 'id';
    private static $formName = 'form_FornecedorForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de fornecedor");


        $id = new TEntry('id');
        $pessoa_tipo_id = new TDBCombo('pessoa_tipo_id', 'kraftsoft', 'PessoaTipo', 'id', '{descricao}','descricao asc'  );
        $fornecedor_classificacao_id = new TDBCombo('fornecedor_classificacao_id', 'kraftsoft', 'FornecedorClassificacao', 'id', '{descricao}','descricao asc'  );
        $notafiscal_crt_id = new TDBCombo('notafiscal_crt_id', 'kraftsoft', 'NotafiscalCrt', 'id', '{descricao}','id asc'  );
        $nome = new TEntry('nome');
        $razao_social = new TEntry('razao_social');
        $cpf_cnpj = new TEntry('cpf_cnpj');
        $insc_estadual = new TEntry('insc_estadual');
        $insc_municipal = new TEntry('insc_municipal');
        $fone = new TEntry('fone');
        $email = new TEntry('email');
        $site = new TEntry('site');
        $notafiscal_indiedest_id = new TDBCombo('notafiscal_indiedest_id', 'kraftsoft', 'NotafiscalIndiedest', 'id', '{descricao}','descricao asc'  );
        $observacoes = new TText('observacoes');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $cep = new TEntry('cep');
        $logradouro = new TEntry('logradouro');
        $cidade_id = new TDBCombo('cidade_id', 'kraftsoft', 'Cidade', 'id', '{nome}','nome asc'  );
        $bairro = new TEntry('bairro');
        $numero = new TEntry('numero');
        $complemento = new TEntry('complemento');
        $fornecedor_contato_fornecedor_tipo_contato = new TEntry('fornecedor_contato_fornecedor_tipo_contato');
        $fornecedor_contato_fornecedor_id = new THidden('fornecedor_contato_fornecedor_id');
        $fornecedor_contato_fornecedor_nome = new TEntry('fornecedor_contato_fornecedor_nome');
        $fornecedor_contato_fornecedor_fone = new TEntry('fornecedor_contato_fornecedor_fone');
        $button_adicionar_fornecedor_contato_fornecedor = new TButton('button_adicionar_fornecedor_contato_fornecedor');

        $pessoa_tipo_id->addValidation("Pessoa tipo id", new TRequiredValidator()); 
        $nome->addValidation("Nome", new TRequiredValidator()); 

        $button_adicionar_fornecedor_contato_fornecedor->setAction(new TAction([$this, 'onAddDetailFornecedorContatoFornecedor'],['static' => 1]), "Adicionar");
        $button_adicionar_fornecedor_contato_fornecedor->addStyleClass('btn-default');
        $button_adicionar_fornecedor_contato_fornecedor->setImage('fas:plus #2ecc71');
        $notafiscal_crt_id->enableSearch();
        $notafiscal_indiedest_id->enableSearch();

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $cep->setSize('100%');
        $nome->setSize('100%');
        $fone->setSize('100%');
        $site->setSize('100%');
        $email->setSize('100%');
        $bairro->setSize('100%');
        $numero->setSize('100%');
        $cpf_cnpj->setSize('100%');
        $criado_em->setSize('100%');
        $cidade_id->setSize('100%');
        $criado_por->setSize('100%');
        $logradouro->setSize('100%');
        $alterado_em->setSize('100%');
        $complemento->setSize('100%');
        $razao_social->setSize('100%');
        $alterado_por->setSize('100%');
        $insc_estadual->setSize('100%');
        $pessoa_tipo_id->setSize('100%');
        $insc_municipal->setSize('100%');
        $observacoes->setSize('100%', 110);
        $notafiscal_crt_id->setSize('100%');
        $notafiscal_indiedest_id->setSize('100%');
        $fornecedor_classificacao_id->setSize('100%');
        $fornecedor_contato_fornecedor_id->setSize(200);
        $fornecedor_contato_fornecedor_nome->setSize('100%');
        $fornecedor_contato_fornecedor_fone->setSize('100%');
        $fornecedor_contato_fornecedor_tipo_contato->setSize('100%');

        $button_adicionar_fornecedor_contato_fornecedor->id = '619c20ad38f3e';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Pessoa tipo:", '#ff0000', '14px', null, '100%'),$pessoa_tipo_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Classificação:", null, '14px', null, '100%'),$fornecedor_classificacao_id],[new TLabel("Regime Tributário:", null, '14px', null),$notafiscal_crt_id]);
        $row2->layout = ['col-sm-6',' col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome],[new TLabel("Razão Social:", null, '14px', null, '100%'),$razao_social]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("CPF/CNPJ:", null, '14px', null, '100%'),$cpf_cnpj],[new TLabel("Inscrição Estadual:", null, '14px', null, '100%'),$insc_estadual]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Inscrição Municipal:", null, '14px', null, '100%'),$insc_municipal],[new TLabel("Fone:", null, '14px', null, '100%'),$fone]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("E-Mail:", null, '14px', null, '100%'),$email],[new TLabel("Site:", null, '14px', null, '100%'),$site]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([new TLabel("Indicador da IE:", null, '14px', null),$notafiscal_indiedest_id]);
        $row7->layout = ['col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Observações:", null, '14px', null, '100%'),$observacoes]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row10->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Endereço");
        $row11 = $this->form->addFields([new TLabel("CEP:", null, '14px', null, '100%'),$cep],[new TLabel("Logradouro:", null, '14px', null, '100%'),$logradouro]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->form->addFields([new TLabel("Cidade:", null, '14px', null, '100%'),$cidade_id],[new TLabel("Bairro:", null, '14px', null, '100%'),$bairro]);
        $row12->layout = ['col-sm-6','col-sm-6'];

        $row13 = $this->form->addFields([new TLabel("Número:", null, '14px', null, '100%'),$numero],[new TLabel("Complemento:", null, '14px', null, '100%'),$complemento]);
        $row13->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("Contatos");

        $this->detailFormFornecedorContatoFornecedor = new BootstrapFormBuilder('detailFormFornecedorContatoFornecedor');
        $this->detailFormFornecedorContatoFornecedor->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormFornecedorContatoFornecedor->setProperty('class', 'form-horizontal builder-detail-form');

        $row14 = $this->detailFormFornecedorContatoFornecedor->addFields([new TLabel("Tipo de Contato:", null, '14px', null, '100%'),$fornecedor_contato_fornecedor_tipo_contato,$fornecedor_contato_fornecedor_id],[new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$fornecedor_contato_fornecedor_nome],[new TLabel("Fone:", null, '14px', null, '100%'),$fornecedor_contato_fornecedor_fone]);
        $row14->layout = [' col-sm-4',' col-sm-6','col-sm-2'];

        $row15 = $this->detailFormFornecedorContatoFornecedor->addFields([$button_adicionar_fornecedor_contato_fornecedor]);
        $row15->layout = [' col-sm-12'];

        $row16 = $this->detailFormFornecedorContatoFornecedor->addFields([new THidden('fornecedor_contato_fornecedor__row__id')]);
        $this->fornecedor_contato_fornecedor_criteria = new TCriteria();

        $this->fornecedor_contato_fornecedor_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->fornecedor_contato_fornecedor_list->disableHtmlConversion();;
        $this->fornecedor_contato_fornecedor_list->generateHiddenFields();
        $this->fornecedor_contato_fornecedor_list->setId('fornecedor_contato_fornecedor_list');

        $this->fornecedor_contato_fornecedor_list->disableDefaultClick();
        $this->fornecedor_contato_fornecedor_list->style = 'width:100%';
        $this->fornecedor_contato_fornecedor_list->class .= ' table-bordered';

        $column_fornecedor_contato_fornecedor_tipo_contato = new TDataGridColumn('tipo_contato', "Tipo de Contato", 'left');
        $column_fornecedor_contato_fornecedor_nome = new TDataGridColumn('nome', "Nome", 'left');
        $column_fornecedor_contato_fornecedor_fone = new TDataGridColumn('fone', "Fone", 'left');

        $column_fornecedor_contato_fornecedor__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_fornecedor_contato_fornecedor__row__data->setVisibility(false);

        $action_onEditDetailFornecedorContato = new TDataGridAction(array('FornecedorForm', 'onEditDetailFornecedorContato'));
        $action_onEditDetailFornecedorContato->setUseButton(false);
        $action_onEditDetailFornecedorContato->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailFornecedorContato->setLabel("Editar");
        $action_onEditDetailFornecedorContato->setImage('far:edit #478fca');
        $action_onEditDetailFornecedorContato->setFields(['__row__id', '__row__data']);

        $this->fornecedor_contato_fornecedor_list->addAction($action_onEditDetailFornecedorContato);
        $action_onDeleteDetailFornecedorContato = new TDataGridAction(array('FornecedorForm', 'onDeleteDetailFornecedorContato'));
        $action_onDeleteDetailFornecedorContato->setUseButton(false);
        $action_onDeleteDetailFornecedorContato->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailFornecedorContato->setLabel("Excluir");
        $action_onDeleteDetailFornecedorContato->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailFornecedorContato->setFields(['__row__id', '__row__data']);

        $this->fornecedor_contato_fornecedor_list->addAction($action_onDeleteDetailFornecedorContato);

        $this->fornecedor_contato_fornecedor_list->addColumn($column_fornecedor_contato_fornecedor_tipo_contato);
        $this->fornecedor_contato_fornecedor_list->addColumn($column_fornecedor_contato_fornecedor_nome);
        $this->fornecedor_contato_fornecedor_list->addColumn($column_fornecedor_contato_fornecedor_fone);

        $this->fornecedor_contato_fornecedor_list->addColumn($column_fornecedor_contato_fornecedor__row__data);

        $this->fornecedor_contato_fornecedor_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->fornecedor_contato_fornecedor_list);
        $this->detailFormFornecedorContatoFornecedor->addContent([$tableResponsiveDiv]);
        $row17 = $this->form->addFields([$this->detailFormFornecedorContatoFornecedor]);
        $row17->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['FornecedorList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Cadastros Diversos","Cadastro de fornecedor"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailFornecedorContatoFornecedor($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Nome", 'name'=>"fornecedor_contato_fornecedor_nome", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->fornecedor_contato_fornecedor__row__id) ? $data->fornecedor_contato_fornecedor__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new FornecedorContato();
            $grid_data->__row__id = $__row__id;
            $grid_data->tipo_contato = $data->fornecedor_contato_fornecedor_tipo_contato;
            $grid_data->id = $data->fornecedor_contato_fornecedor_id;
            $grid_data->nome = $data->fornecedor_contato_fornecedor_nome;
            $grid_data->fone = $data->fornecedor_contato_fornecedor_fone;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['tipo_contato'] =  $param['fornecedor_contato_fornecedor_tipo_contato'] ?? null;
            $__row__data['__display__']['id'] =  $param['fornecedor_contato_fornecedor_id'] ?? null;
            $__row__data['__display__']['nome'] =  $param['fornecedor_contato_fornecedor_nome'] ?? null;
            $__row__data['__display__']['fone'] =  $param['fornecedor_contato_fornecedor_fone'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->fornecedor_contato_fornecedor_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('fornecedor_contato_fornecedor_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->fornecedor_contato_fornecedor_tipo_contato = '';
            $data->fornecedor_contato_fornecedor_id = '';
            $data->fornecedor_contato_fornecedor_nome = '';
            $data->fornecedor_contato_fornecedor_fone = '';
            $data->fornecedor_contato_fornecedor__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#619c20ad38f3e');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailFornecedorContato($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->fornecedor_contato_fornecedor_tipo_contato = $__row__data->__display__->tipo_contato ?? null;
            $data->fornecedor_contato_fornecedor_id = $__row__data->__display__->id ?? null;
            $data->fornecedor_contato_fornecedor_nome = $__row__data->__display__->nome ?? null;
            $data->fornecedor_contato_fornecedor_fone = $__row__data->__display__->fone ?? null;
            $data->fornecedor_contato_fornecedor__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#619c20ad38f3e');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailFornecedorContato($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->fornecedor_contato_fornecedor_tipo_contato = '';
            $data->fornecedor_contato_fornecedor_id = '';
            $data->fornecedor_contato_fornecedor_nome = '';
            $data->fornecedor_contato_fornecedor_fone = '';
            $data->fornecedor_contato_fornecedor__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('fornecedor_contato_fornecedor_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Fornecedor(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $fornecedor_contato_fornecedor_items = $this->storeMasterDetailItems('FornecedorContato', 'fornecedor_id', 'fornecedor_contato_fornecedor', $object, $param['fornecedor_contato_fornecedor_list___row__data'] ?? [], $this->form, $this->fornecedor_contato_fornecedor_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->fornecedor_contato_fornecedor_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('FornecedorList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Fornecedor($key); // instantiates the Active Record 

                $fornecedor_contato_fornecedor_items = $this->loadMasterDetailItems('FornecedorContato', 'fornecedor_id', 'fornecedor_contato_fornecedor', $object, $this->form, $this->fornecedor_contato_fornecedor_list, $this->fornecedor_contato_fornecedor_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

