<?php

class PedidoEventoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'PedidoEvento';
    private static $primaryKey = 'id';
    private static $formName = 'form_PedidoEventoForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de pedido evento");


        $tipo = new TEntry('tipo');
        $id = new TEntry('id');
        $system_unit_id = new THidden('system_unit_id');
        $notafiscal_id = new THidden('notafiscal_id');
        $system_users_id = new THidden('system_users_id');
        $nseqevento = new TEntry('nseqevento');
        $protocolo = new TEntry('protocolo');
        $serie = new TEntry('serie');
        $numero = new TEntry('numero');
        $chave = new TEntry('chave');
        $descricao = new TText('descricao');


        $tipo->setMaxLength(30);
        $chave->setMaxLength(50);
        $protocolo->setMaxLength(20);

        $tipo->setValue($param["tipo"] ?? "");
        $notafiscal_id->setValue($param["notafiscal_id"] ?? "");
        $system_users_id->setValue(TSession::getValue("userid"));
        $system_unit_id->setValue(TSession::getValue("userunitid"));
        $descricao->setValue('erro ao cadastrar itens na nota fiscal');

        $id->setEditable(false);
        $tipo->setEditable(false);
        $serie->setEditable(false);
        $chave->setEditable(false);
        $numero->setEditable(false);
        $protocolo->setEditable(false);
        $nseqevento->setEditable(false);

        $id->setSize(100);
        $tipo->setSize('100%');
        $serie->setSize('100%');
        $chave->setSize('100%');
        $numero->setSize('100%');
        $protocolo->setSize('100%');
        $notafiscal_id->setSize(200);
        $nseqevento->setSize('100%');
        $system_unit_id->setSize(200);
        $system_users_id->setSize(200);
        $descricao->setSize('100%', 110);


        $row1 = $this->form->addFields([new TLabel("Tipo:", null, '14px', null, '100%'),$tipo,$id,$system_unit_id,$notafiscal_id,$system_users_id],[new TLabel("Sequencia:", null, '14px', null, '100%'),$nseqevento],[new TLabel("Protocolo:", null, '14px', null, '100%'),$protocolo],[new TLabel("Serie:", null, '14px', null, '100%'),$serie],[new TLabel("Numero:", null, '14px', null),$numero],[new TLabel("Chave:", null, '14px', null, '100%'),$chave]);
        $row1->layout = ['col-sm-2','col-sm-2',' col-sm-4',' col-sm-2','col-sm-2',' col-sm-12'];

        $row2 = $this->form->addContent([new TFormSeparator("Atenção", '#F44336', '18', '#9E9E9E')]);
        $row3 = $this->form->addFields([new TLabel("Gostaríamos de informar que sua solicitação não garante automaticamente a realização do evento junto à SEFAZ (Secretaria da Fazenda). Pedimos que acompanhe a lista de eventos solicitados, pois é nela que você encontrará o retorno da SEFAZ.", null, '14px', null),new TLabel("<hr>", null, '14px', null, '100%'),new TLabel("Descricao:", null, '14px', null, '100%'),$descricao]);
        $row3->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar Solicitação", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-success'); 

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['NotafiscalList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new PedidoEvento(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('PedidoEventoList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new PedidoEvento($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

   TTransaction::open(self::$database);

                    $objeto = Notafiscal::find($param['key']);

                    $Sequencia = PedidoEvento::where('notafiscal_id', '=', $param['key'])
                    ->where('tipo', '=', 'carta')->orderBy('id', 'desc')->first();
                    if($Sequencia->nseqevento){
                    $nseqevento  = $Sequencia->nseqevento + 1;
                    }else{

                    $nseqevento  = 1;
                    }

    TTransaction::close();

                $object = new stdClass();
                $object->chave = $objeto->chave;
                $object->protocolo = $objeto->protocolo_envio;
                $object->serie = $objeto->serie;
                $object->numero = $objeto->numero;
                if($param['tipo']=='carta'){
                $object->nseqevento = $nseqevento ;

                }else{

                $object->nseqevento = 1; 

                }
        TForm::sendData(self::$formName, $object);
    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

