<?php

class ServicoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Produto';
    private static $primaryKey = 'id';
    private static $formName = 'form_ServicoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de serviço");

        $criteria_produto_grupo_id = new TCriteria();

        $filterVar = TipoRecurso::Servico;
        $criteria_produto_grupo_id->add(new TFilter('tipo_recurso_id', '=', $filterVar)); 

        $id = new TEntry('id');
        $tipo_recurso_id = new THidden('tipo_recurso_id');
        $nome = new TEntry('nome');
        $produto_grupo_id = new TDBCombo('produto_grupo_id', 'kraftsoft', 'ProdutoGrupo', 'id', '{descricao}','descricao asc' , $criteria_produto_grupo_id );
        $produtogrupo_subgrupo_id = new TCombo('produtogrupo_subgrupo_id');
        $unidade_medida_id = new THidden('unidade_medida_id');
        $obs = new TText('obs');
        $habilitado_id = new TRadioGroup('habilitado_id');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $ncm = new TEntry('ncm');
        $cest = new TEntry('cest');
        $notafiscal_item_orig_id = new TDBCombo('notafiscal_item_orig_id', 'kraftsoft', 'NotafiscalItemOrig', 'id', '{descricao}','codigo asc'  );
        $produto_filial_produto_system_unit_id = new TDBCombo('produto_filial_produto_system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $produto_filial_produto_id = new THidden('produto_filial_produto_id');
        $produto_filial_produto_margem = new TNumeric('produto_filial_produto_margem', '2', ',', '.' );
        $produto_filial_produto_preco_venda = new TNumeric('produto_filial_produto_preco_venda', '2', ',', '.' );
        $produto_filial_produto_valor_custo = new TNumeric('produto_filial_produto_valor_custo', '2', ',', '.' );
        $button_adicionar_produto_filial_produto = new TButton('button_adicionar_produto_filial_produto');

        $produto_grupo_id->setChangeAction(new TAction([$this,'onChangeproduto_grupo_id']));

        $produto_filial_produto_margem->setExitAction(new TAction([$this,'onExitMargem']));
        $produto_filial_produto_preco_venda->setExitAction(new TAction([$this,'onExitPrecoVenda']));
        $produto_filial_produto_valor_custo->setExitAction(new TAction([$this,'onExitPrecoCusto']));

        $nome->addValidation("Nome", new TRequiredValidator()); 
        $habilitado_id->addValidation("Habilitado", new TRequiredValidator()); 

        $unidade_medida_id->setValue(UnidadeMedida::UNIDADE);
        $habilitado_id->addItems(["1"=>"Sim","2"=>"Não"]);
        $habilitado_id->setLayout('horizontal');
        $habilitado_id->setUseButton();
        $button_adicionar_produto_filial_produto->setAction(new TAction([$this, 'onAddDetailProdutoFilialProduto'],['static' => 1]), "Adicionar");
        $button_adicionar_produto_filial_produto->addStyleClass('btn-default');
        $button_adicionar_produto_filial_produto->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $produto_grupo_id->enableSearch();
        $notafiscal_item_orig_id->enableSearch();
        $produtogrupo_subgrupo_id->enableSearch();

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize('100%');
        $ncm->setSize('100%');
        $nome->setSize('100%');
        $cest->setSize('100%');
        $obs->setSize('100%', 110);
        $habilitado_id->setSize(80);
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $tipo_recurso_id->setSize(200);
        $alterado_por->setSize('100%');
        $unidade_medida_id->setSize(200);
        $produto_grupo_id->setSize('100%');
        $produto_filial_produto_id->setSize(200);
        $notafiscal_item_orig_id->setSize('100%');
        $produtogrupo_subgrupo_id->setSize('100%');
        $produto_filial_produto_margem->setSize('100%');
        $produto_filial_produto_preco_venda->setSize('100%');
        $produto_filial_produto_valor_custo->setSize('100%');
        $produto_filial_produto_system_unit_id->setSize('100%');

        $button_adicionar_produto_filial_produto->id = '61f9a7da2586a';

        $this->form->appendPage("Dados Gerais");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id,$tipo_recurso_id],[new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome]);
        $row1->layout = [' col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Grupo:", null, '14px', null, '100%'),$produto_grupo_id],[new TLabel("SubGrupo:", null, '14px', null, '100%'),$produtogrupo_subgrupo_id]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([$unidade_medida_id]);
        $row3->layout = [' col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$obs]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->form->addFields([new TLabel("Habilitado:", '#FF0000', '14px', null, '100%'),$habilitado_id]);
        $row5->layout = ['col-sm-6'];

        $row6 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row7 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row7->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Fiscal");
        $row8 = $this->form->addFields([new TLabel("NCM:", null, '14px', null, '100%'),$ncm],[new TLabel("CEST:", null, '14px', null, '100%'),$cest]);
        $row8->layout = ['col-sm-6','col-sm-6'];

        $row9 = $this->form->addFields([new TLabel("Origem:", null, '14px', null, '100%'),$notafiscal_item_orig_id]);
        $row9->layout = [' col-sm-12'];

        $this->form->appendPage("Regras por Filial");

        $this->detailFormProdutoFilialProduto = new BootstrapFormBuilder('detailFormProdutoFilialProduto');
        $this->detailFormProdutoFilialProduto->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormProdutoFilialProduto->setProperty('class', 'form-horizontal builder-detail-form');

        $row10 = $this->detailFormProdutoFilialProduto->addFields([new TLabel("Filial:", '#ff0000', '14px', null, '100%'),$produto_filial_produto_system_unit_id,$produto_filial_produto_id],[new TLabel("Margem (%):", null, '14px', null, '100%'),$produto_filial_produto_margem]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->detailFormProdutoFilialProduto->addFields([new TLabel("Preço Venda:", '#ff0000', '14px', null, '100%'),$produto_filial_produto_preco_venda],[new TLabel("Valor Custo:", null, '14px', null, '100%'),$produto_filial_produto_valor_custo]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->detailFormProdutoFilialProduto->addFields([$button_adicionar_produto_filial_produto]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->detailFormProdutoFilialProduto->addFields([new THidden('produto_filial_produto__row__id')]);
        $this->produto_filial_produto_criteria = new TCriteria();

        $this->produto_filial_produto_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->produto_filial_produto_list->disableHtmlConversion();;
        $this->produto_filial_produto_list->generateHiddenFields();
        $this->produto_filial_produto_list->setId('produto_filial_produto_list');

        $this->produto_filial_produto_list->style = 'width:100%';
        $this->produto_filial_produto_list->class .= ' table-bordered';

        $column_produto_filial_produto_system_unit_name = new TDataGridColumn('system_unit->name', "Filial", 'left');
        $column_produto_filial_produto_preco_venda_transformed = new TDataGridColumn('preco_venda', "Preço Venda", 'right');
        $column_produto_filial_produto_valor_custo_transformed = new TDataGridColumn('valor_custo', "Valor Custo", 'right');
        $column_produto_filial_produto_alterado_em_transformed = new TDataGridColumn('alterado_em', "Alterado Em", 'left');

        $column_produto_filial_produto__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_produto_filial_produto__row__data->setVisibility(false);

        $action_onEditDetailProdutoFilial = new TDataGridAction(array('ServicoForm', 'onEditDetailProdutoFilial'));
        $action_onEditDetailProdutoFilial->setUseButton(true);
        $action_onEditDetailProdutoFilial->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailProdutoFilial->setLabel("Editar");
        $action_onEditDetailProdutoFilial->setImage('far:edit #478fca');
        $action_onEditDetailProdutoFilial->setFields(['__row__id', '__row__data']);

        $this->produto_filial_produto_list->addAction($action_onEditDetailProdutoFilial);
        $action_onDeleteDetailProdutoFilial = new TDataGridAction(array('ServicoForm', 'onDeleteDetailProdutoFilial'));
        $action_onDeleteDetailProdutoFilial->setUseButton(true);
        $action_onDeleteDetailProdutoFilial->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailProdutoFilial->setLabel("Excluir");
        $action_onDeleteDetailProdutoFilial->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailProdutoFilial->setFields(['__row__id', '__row__data']);

        $this->produto_filial_produto_list->addAction($action_onDeleteDetailProdutoFilial);
        $action_onShow = new TDataGridAction(array('ProdutoEnderecamentoFormList', 'onShow'));
        $action_onShow->setUseButton(true);
        $action_onShow->setButtonClass('btn btn-default btn-sm');
        $action_onShow->setLabel("Endereçamento");
        $action_onShow->setImage('fas:sitemap #009688');
        $action_onShow->setFields(['__row__id', '__row__data']);
        $action_onShow->setDisplayCondition('ServicoForm::onExibeEnderecamento');
        $action_onShow->setParameter('produto_form_produto_filial_id', '{id}');
        $this->produto_filial_produto_list->addAction($action_onShow);

        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_system_unit_name);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_preco_venda_transformed);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_valor_custo_transformed);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_alterado_em_transformed);

        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto__row__data);

        $this->produto_filial_produto_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->produto_filial_produto_list);
        $this->detailFormProdutoFilialProduto->addContent([$tableResponsiveDiv]);

        $column_produto_filial_produto_preco_venda_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_produto_filial_produto_valor_custo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_produto_filial_produto_alterado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });        $row14 = $this->form->addFields([$this->detailFormProdutoFilialProduto]);
        $row14->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ServicoList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Cadastros Diversos","Cadastro de serviço"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onChangeproduto_grupo_id($param)
    {
        try
        {

            if (isset($param['produto_grupo_id']) && $param['produto_grupo_id'])
            { 
                $criteria = TCriteria::create(['produto_grupo_id' => $param['produto_grupo_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'produtogrupo_subgrupo_id', 'kraftsoft', 'ProdutogrupoSubgrupo', 'id', '{descricao}', 'descricao asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'produtogrupo_subgrupo_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public static function onExitMargem($param = null) 
    {
        try 
        {
           self::onExitPrecoCusto($param);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitPrecoVenda($param = null) 
    {
        try 
        {
        /*

        Por exemplo, se o preço de venda de um produto é R$ 100,00 e o custo total para produzi-lo é R$ 70,00, o lucro bruto é de R$ 30,00. 
        A margem de lucro seria calculada assim: (30 ÷ 100) x 100 = 30%. Portanto, a margem de lucro é de 30%.

        */

        // $produto_filial_produto_preco_venda = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_preco_venda']));
        // $produto_filial_produto_valor_custo = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_valor_custo']));

        // $produto_filial_produto_margem = (( $produto_filial_produto_preco_venda - $produto_filial_produto_valor_custo ) / 100) * 100;

        // $object = new stdClass();
        // $object->produto_filial_produto_margem = number_format($produto_filial_produto_margem, 2, ',', '.');
        // TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitPrecoCusto($param = null) 
    {
        try 
        {
            $produto_filial_produto_margem = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_margem']));
            $produto_filial_produto_valor_custo = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_valor_custo']));

            $produto_filial_produto_preco_venda = $produto_filial_produto_valor_custo + (( $produto_filial_produto_margem * $produto_filial_produto_valor_custo ) / 100);

            $object = new stdClass();
            $object->produto_filial_produto_preco_venda = number_format($produto_filial_produto_preco_venda, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailProdutoFilialProduto($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"System unit id", 'name'=>"produto_filial_produto_system_unit_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Preço Venda", 'name'=>"produto_filial_produto_preco_venda", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->produto_filial_produto__row__id) ? $data->produto_filial_produto__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ProdutoFilial();
            $grid_data->__row__id = $__row__id;
            $grid_data->system_unit_id = $data->produto_filial_produto_system_unit_id;
            $grid_data->id = $data->produto_filial_produto_id;
            $grid_data->margem = $data->produto_filial_produto_margem;
            $grid_data->preco_venda = $data->produto_filial_produto_preco_venda;
            $grid_data->valor_custo = $data->produto_filial_produto_valor_custo;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['system_unit_id'] =  $param['produto_filial_produto_system_unit_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['produto_filial_produto_id'] ?? null;
            $__row__data['__display__']['margem'] =  $param['produto_filial_produto_margem'] ?? null;
            $__row__data['__display__']['preco_venda'] =  $param['produto_filial_produto_preco_venda'] ?? null;
            $__row__data['__display__']['valor_custo'] =  $param['produto_filial_produto_valor_custo'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->produto_filial_produto_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('produto_filial_produto_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->produto_filial_produto_system_unit_id = '';
            $data->produto_filial_produto_id = '';
            $data->produto_filial_produto_margem = '';
            $data->produto_filial_produto_preco_venda = '';
            $data->produto_filial_produto_valor_custo = '';
            $data->produto_filial_produto__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61f9a7da2586a');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailProdutoFilial($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->produto_filial_produto_system_unit_id = $__row__data->__display__->system_unit_id ?? null;
            $data->produto_filial_produto_id = $__row__data->__display__->id ?? null;
            $data->produto_filial_produto_margem = $__row__data->__display__->margem ?? null;
            $data->produto_filial_produto_preco_venda = $__row__data->__display__->preco_venda ?? null;
            $data->produto_filial_produto_valor_custo = $__row__data->__display__->valor_custo ?? null;
            $data->produto_filial_produto__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61f9a7da2586a');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailProdutoFilial($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->produto_filial_produto_system_unit_id = '';
            $data->produto_filial_produto_id = '';
            $data->produto_filial_produto_margem = '';
            $data->produto_filial_produto_preco_venda = '';
            $data->produto_filial_produto_valor_custo = '';
            $data->produto_filial_produto__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('produto_filial_produto_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onExibeEnderecamento($object)
    {
        try 
        {
            if(!$object->id==null)
            {
                return true;
            }

            return false;
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Produto(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            if ($object->id==0)
            {
              $object->ativo_id = Ativo::Ativo;
            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $produto_filial_produto_items = $this->storeMasterDetailItems('ProdutoFilial', 'produto_id', 'produto_filial_produto', $object, $param['produto_filial_produto_list___row__data'] ?? [], $this->form, $this->produto_filial_produto_list, function($masterObject, $detailObject){ 

                //code here
                //buscando tabelas de preço com este produto para recalcular os valores..
                $listatabelaprecoprod = TabelaPrecoProduto::where('produto_filial_id', '=', $detailObject->id)->load();

                if ($listatabelaprecoprod)
                {
                    foreach ($listatabelaprecoprod as $tabelaprecoprod)
                    {
                        $tabelaprecoprod->preco_venda = TabelaPreco::calcula_preco_tabela($tabelaprecoprod->tabela_preco->tabela_preco_tipo_alteracao_id,
                                                                                          $detailObject->preco_venda,
                                                                                          $tabelaprecoprod->valor_parametro);

                        $tabelaprecoprod->store();
                    }
                }

            }, $this->produto_filial_produto_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ServicoList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Produto($key); // instantiates the Active Record 

                $produto_filial_produto_items = $this->loadMasterDetailItems('ProdutoFilial', 'produto_id', 'produto_filial_produto', $object, $this->form, $this->produto_filial_produto_list, $this->produto_filial_produto_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $obj = new stdClass();

        if (empty($obj->id))
        {
          $obj->permite_desconto = Resposta::Nao;
          $obj->tipo_recurso_id = TipoRecurso::Produto;

          TForm::sendData(self::$formName, $obj); 
        }

    }

    public function onShow($param = null)
    {

        $obj = new stdClass();

        if (empty($obj->id))
        {
          $obj->permite_desconto = Resposta::Nao;
          $obj->tipo_recurso_id = TipoRecurso::Servico;
          $obj->notafiscal_item_orig_id = NotafiscalItemOrig::Zero;
          $obj->produto_tipo_id = ProdutoTipo::Simples;
          $obj->habilitado_id = Resposta::Sim;

          TForm::sendData(self::$formName, $obj); 
        }

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->produto_grupo_id))
            {
                $value = $object->produto_grupo_id;

                $obj->produto_grupo_id = $value;
            }
            if(isset($object->produtogrupo_subgrupo_id))
            {
                $value = $object->produtogrupo_subgrupo_id;

                $obj->produtogrupo_subgrupo_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->produto_grupo_id))
            {
                $value = $object->produto_grupo_id;

                $obj->produto_grupo_id = $value;
            }
            if(isset($object->produtogrupo_subgrupo_id))
            {
                $value = $object->produtogrupo_subgrupo_id;

                $obj->produtogrupo_subgrupo_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

