<?php
/**
 * CertificadoAgendamentosCalendarForm Form
 * @author  <your name here>
 */
class CertificadoAgendamentosCalendarFormView extends TPage
{
    private $fc;

    /**
     * Page constructor
     */
    public function __construct($param = null)
    {
        parent::__construct();

        $this->fc = new TFullCalendar(date('Y-m-d'), 'month');
        $this->fc->enableDays([0,1,2,3,4,5,6]);
        $this->fc->setReloadAction(new TAction(array($this, 'getEvents'), $param));
        $this->fc->setDayClickAction(new TAction(array('CertificadoAgendamentosCalendarForm', 'onStartEdit')));
        $this->fc->setEventClickAction(new TAction(array('CertificadoAgendamentosCalendarForm', 'onEdit')));
        $this->fc->setEventUpdateAction(new TAction(array('CertificadoAgendamentosCalendarForm', 'onUpdateEvent')));
        $this->fc->setCurrentView('agendaWeek');
        $this->fc->setTimeRange('07:00', '19:00');
        $this->fc->enablePopover('Informações', "Cliente: {certificado_venda->cliente->nome} 
<br>
Agente:  {certificado_venda->certificado_agente_registro->nome} 
<br>
Parceiro:  {certificado_venda->parceiro->nome} 
<br>
Tipo Atendimento:  {certificado_venda->certificado_tipo_atendimento->descricao} ");
        $this->fc->setOption('slotTime', "00:30:00");
        $this->fc->setOption('slotDuration', "00:30:00");
        $this->fc->setOption('slotLabelInterval', 30);

        parent::add( $this->fc );
    }

    /**
     * Output events as an json
     */
    public static function getEvents($param=NULL)
    {
        $return = array();
        try
        {
            TTransaction::open('kraftsoft');

            $criteria = new TCriteria(); 

            $criteria->add(new TFilter('data_hora_inicial', '<=', substr($param['end'], 0, 10).' 23:59:59'));
            $criteria->add(new TFilter('data_hora_final', '>=', substr($param['start'], 0, 10).' 00:00:00'));

            $filterVar = TSession::getValue("userunitid");
            $criteria->add(new TFilter('certificado_venda_id', 'in', "(SELECT id FROM certificado_venda WHERE system_unit_id = '{$filterVar}')")); 

            $events = CertificadoAgendamentos::getObjects($criteria);

            if ($events)
            {
                foreach ($events as $event)
                {
                    $event_array = $event->toArray();
                    $event_array['start'] = str_replace( ' ', 'T', $event_array['data_hora_inicial']);
                    $event_array['end'] = str_replace( ' ', 'T', $event_array['data_hora_final']);
                    $event_array['id'] = $event->id;
                    $event_array['color'] = $event->render("{cor}");
                    $event_array['title'] = TFullCalendar::renderPopover($event->render("{titulo} "), $event->render("Informações"), $event->render("Cliente: {certificado_venda->cliente->nome} 
<br>
Agente:  {certificado_venda->certificado_agente_registro->nome} 
<br>
Parceiro:  {certificado_venda->parceiro->nome} 
<br>
Tipo Atendimento:  {certificado_venda->certificado_tipo_atendimento->descricao} "));

                    $return[] = $event_array;
                }
            }
            TTransaction::close();
            echo json_encode($return);
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    /**
     * Reconfigure the callendar
     */
    public function onReload($param = null)
    {
        if (isset($param['view']))
        {
            $this->fc->setCurrentView($param['view']);
        }

        if (isset($param['date']))
        {
            $this->fc->setCurrentDate($param['date']);
        }
    }

}

