<?php

class CertificadoVendaForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'CertificadoVenda';
    private static $primaryKey = 'id';
    private static $formName = 'form_CertificadoVendaForm';

    use BuilderMasterDetailTrait;
    use Adianti\Base\AdiantiFileSaveTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de venda de certificado");

        $criteria_produto_id = new TCriteria();

        if(!empty($param["certificadora_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_id', $param["certificadora_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_id');

        $criteria_produto_id->add(new TFilter('id', 'in', "(SELECT produto_id FROM certificadora_produtos WHERE certificadora_id = '{$filterVar}')")); 

        $certificado_venda_situacao_id = new TDBArrowStep('certificado_venda_situacao_id', 'kraftsoft', 'CertificadoVendaSituacao', 'id', '{descricao}','ordem asc'  );
        $id = new TEntry('id');
        $certificadora_id = new TDBCombo('certificadora_id', 'kraftsoft', 'Certificadora', 'id', '{nome}','nome asc'  );
        $data_emissao = new TDate('data_emissao');
        $data_pagamento = new TDate('data_pagamento');
        $data_hora_agendamento = new TDateTime('data_hora_agendamento');
        $comissao_total = new TNumeric('comissao_total', '2', ',', '.' );
        $valor_total = new TNumeric('valor_total', '2', ',', '.' );
        $protocolo_emissao = new TEntry('protocolo_emissao');
        $cliente_id = new TSeekButton('cliente_id');
        $cliente_nome = new TEntry('cliente_nome');
        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc' , $criteria_produto_id );
        $valor_cliente = new TNumeric('valor_cliente', '2', ',', '.' );
        $data_vencimento_certificado = new TDate('data_vencimento_certificado');
        $certificado_tipo_atendimento_id = new TDBCombo('certificado_tipo_atendimento_id', 'kraftsoft', 'CertificadoTipoAtendimento', 'id', '{descricao}','descricao asc'  );
        $valor_externo = new TNumeric('valor_externo', '2', ',', '.' );
        $custo_externo = new TNumeric('custo_externo', '2', ',', '.' );
        $parceiro_id = new TDBCombo('parceiro_id', 'kraftsoft', 'Parceiro', 'id', '{nome}','nome asc'  );
        $certificado_tipo_repasse_id = new TDBCombo('certificado_tipo_repasse_id', 'kraftsoft', 'CertificadoTipoRepasse', 'id', '{descricao}','descricao asc'  );
        $parceiro_comissao_percentual = new TNumeric('parceiro_comissao_percentual', '2', ',', '.' );
        $certificado_venda_modalidade_id = new TDBCombo('certificado_venda_modalidade_id', 'kraftsoft', 'CertificadoVendaModalidade', 'id', '{descricao}','descricao asc'  );
        $certificado_venda_tipomodalidade_id = new TDBCombo('certificado_venda_tipomodalidade_id', 'kraftsoft', 'CertificadoVendaTipomodalidade', 'id', '{descricao}','descricao asc'  );
        $parceiro_valor_repasse = new TNumeric('parceiro_valor_repasse', '2', ',', '.' );
        $certificado_agente_registro_id = new TDBCombo('certificado_agente_registro_id', 'kraftsoft', 'CertificadoAgenteRegistro', 'id', '{nome}','nome asc'  );
        $agente_comissao_percentual = new TNumeric('agente_comissao_percentual', '2', ',', '.' );
        $agente_comissao_valor = new TNumeric('agente_comissao_valor', '2', ',', '.' );
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $vendedor_comissao_percentual = new TNumeric('vendedor_comissao_percentual', '2', ',', '.' );
        $vendedor_comissao_valor = new TNumeric('vendedor_comissao_valor', '2', ',', '.' );
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $system_unit_id = new THidden('system_unit_id');
        $valor_custo = new THidden('valor_custo');
        $lucro_total = new THidden('lucro_total');
        $tabela_preco_id = new THidden('tabela_preco_id');
        $valor_produto = new THidden('valor_produto');
        $certificado_venda_documentos_certificado_venda_descricao_arquivo = new TEntry('certificado_venda_documentos_certificado_venda_descricao_arquivo');
        $certificado_venda_documentos_certificado_venda_id = new THidden('certificado_venda_documentos_certificado_venda_id');
        $certificado_venda_documentos_certificado_venda_arquivo = new TFile('certificado_venda_documentos_certificado_venda_arquivo');
        $button_adicionar_certificado_venda_documentos_certificado_venda = new TButton('button_adicionar_certificado_venda_documentos_certificado_venda');
        $certificado_venda_formapgto_certificado_venda_forma_pagamento_id = new TDBCombo('certificado_venda_formapgto_certificado_venda_forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $certificado_venda_formapgto_certificado_venda_id = new THidden('certificado_venda_formapgto_certificado_venda_id');
        $certificado_venda_formapgto_certificado_venda_valor = new TNumeric('certificado_venda_formapgto_certificado_venda_valor', '2', ',', '.' );
        $button_adicionar_certificado_venda_formapgto_certificado_venda = new TButton('button_adicionar_certificado_venda_formapgto_certificado_venda');
        $observacao = new TText('observacao');

        $certificadora_id->setChangeAction(new TAction([$this,'onExitCertificadora']));
        $produto_id->setChangeAction(new TAction([$this,'onExitProduto']));
        $parceiro_id->setChangeAction(new TAction([$this,'onExitParceiro']));
        $certificado_agente_registro_id->setChangeAction(new TAction([$this,'onExitAgenteRegistro']));
        $vendedor_id->setChangeAction(new TAction([$this,'onVendedorExit']));

        $valor_cliente->setExitAction(new TAction([$this,'onExitValorCliente']));

        $certificadora_id->addValidation("Certificadora", new TRequiredValidator()); 
        $cliente_id->addValidation("Cliente", new TRequiredValidator()); 
        $produto_id->addValidation("Produto", new TRequiredValidator()); 
        $certificado_tipo_atendimento_id->addValidation("Tipo de Atendimento", new TRequiredValidator()); 
        $certificado_agente_registro_id->addValidation("Agente de Registro", new TRequiredValidator()); 

        $certificado_venda_situacao_id->setColorColumn('cor');
        $certificado_venda_situacao_id->setFilledColor('#fd9308');
        $certificado_venda_situacao_id->setFilledFontColor('#ffffff');
        $certificado_venda_situacao_id->setUnfilledColor('#d3d3d3');
        $certificado_venda_situacao_id->setUnfilledFontColor('#333333');
        $certificado_venda_documentos_certificado_venda_arquivo->enableFileHandling();
        $button_adicionar_certificado_venda_formapgto_certificado_venda->setAction(new TAction([$this, 'onAddDetailCertificadoVendaFormapgtoCertificadoVenda'],['static' => 1]), "Adicionar");
        $button_adicionar_certificado_venda_documentos_certificado_venda->setAction(new TAction([$this, 'onAddDetailCertificadoVendaDocumentosCertificadoVenda'],['static' => 1]), "Adicionar");

        $button_adicionar_certificado_venda_formapgto_certificado_venda->addStyleClass('btn-default');
        $button_adicionar_certificado_venda_documentos_certificado_venda->addStyleClass('btn-default');

        $button_adicionar_certificado_venda_formapgto_certificado_venda->setImage('fas:plus #2ecc71');
        $button_adicionar_certificado_venda_documentos_certificado_venda->setImage('fas:plus #2ecc71');

        $data_emissao->setMask('dd/mm/yyyy');
        $data_pagamento->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_hora_agendamento->setMask('dd/mm/yyyy hh:ii');
        $data_vencimento_certificado->setMask('dd/mm/yyyy');

        $data_emissao->setDatabaseMask('yyyy-mm-dd');
        $data_pagamento->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_hora_agendamento->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_vencimento_certificado->setDatabaseMask('yyyy-mm-dd');

        $produto_id->enableSearch();
        $parceiro_id->enableSearch();
        $vendedor_id->enableSearch();
        $certificadora_id->enableSearch();
        $certificado_agente_registro_id->enableSearch();
        $certificado_tipo_atendimento_id->enableSearch();
        $certificado_venda_formapgto_certificado_venda_forma_pagamento_id->enableSearch();

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $valor_total->setEditable(false);
        $alterado_em->setEditable(false);
        $cliente_nome->setEditable(false);
        $alterado_por->setEditable(false);
        $comissao_total->setEditable(false);
        $data_hora_agendamento->setEditable(false);
        $agente_comissao_valor->setEditable(false);
        $parceiro_valor_repasse->setEditable(false);
        $vendedor_comissao_valor->setEditable(false);
        $agente_comissao_percentual->setEditable(false);
        $data_vencimento_certificado->setEditable(false);
        $certificado_tipo_repasse_id->setEditable(false);
        $parceiro_comissao_percentual->setEditable(false);
        $vendedor_comissao_percentual->setEditable(false);
        $certificado_venda_situacao_id->setEditable(false);
        $certificado_venda_modalidade_id->setEditable(false);
        $certificado_venda_tipomodalidade_id->setEditable(false);

        $id->setSize('100%');
        $cliente_id->setSize(100);
        $valor_custo->setSize(200);
        $lucro_total->setSize(200);
        $criado_em->setSize('100%');
        $produto_id->setSize('100%');
        $criado_por->setSize('100%');
        $valor_produto->setSize(200);
        $valor_total->setSize('100%');
        $parceiro_id->setSize('100%');
        $vendedor_id->setSize('100%');
        $alterado_em->setSize('100%');
        $system_unit_id->setSize(200);
        $data_emissao->setSize('100%');
        $alterado_por->setSize('100%');
        $tabela_preco_id->setSize(200);
        $valor_cliente->setSize('100%');
        $valor_externo->setSize('100%');
        $custo_externo->setSize('100%');
        $data_pagamento->setSize('100%');
        $comissao_total->setSize('100%');
        $observacao->setSize('100%', 70);
        $certificadora_id->setSize('100%');
        $protocolo_emissao->setSize('100%');
        $data_hora_agendamento->setSize('100%');
        $agente_comissao_valor->setSize('100%');
        $parceiro_valor_repasse->setSize('100%');
        $vendedor_comissao_valor->setSize('100%');
        $cliente_nome->setSize('calc(100% - 120px)');
        $agente_comissao_percentual->setSize('100%');
        $data_vencimento_certificado->setSize('100%');
        $certificado_tipo_repasse_id->setSize('100%');
        $parceiro_comissao_percentual->setSize('100%');
        $vendedor_comissao_percentual->setSize('100%');
        $certificado_agente_registro_id->setSize('100%');
        $certificado_tipo_atendimento_id->setSize('100%');
        $certificado_venda_modalidade_id->setSize('100%');
        $certificado_venda_situacao_id->setSize('100%', 55);
        $certificado_venda_tipomodalidade_id->setSize('100%');
        $certificado_venda_formapgto_certificado_venda_id->setSize(200);
        $certificado_venda_documentos_certificado_venda_id->setSize(200);
        $certificado_venda_formapgto_certificado_venda_valor->setSize('100%');
        $certificado_venda_documentos_certificado_venda_arquivo->setSize('100%');
        $certificado_venda_documentos_certificado_venda_descricao_arquivo->setSize('100%');
        $certificado_venda_formapgto_certificado_venda_forma_pagamento_id->setSize('100%');

        $button_adicionar_certificado_venda_formapgto_certificado_venda->id = '6313bc3e3eecf';
        $button_adicionar_certificado_venda_documentos_certificado_venda->id = '63132a29ec6c3';

        $seed = AdiantiApplicationConfig::get()['general']['seed'];
        $cliente_id_seekAction = new TAction(['ClienteSeekWindow', 'onShow']);
        $seekFilters = [];
        $seekFields = base64_encode(serialize([
            ['name'=> 'cliente_id', 'column'=>'{id}'],
            ['name'=> 'cliente_nome', 'column'=>'{nome}'],
            ['name'=> 'parceiro_id', 'column'=>'{certificado_cliente_parceiro_to_string}']
        ]));

        $seekFilters = base64_encode(serialize($seekFilters));
        $cliente_id_seekAction->setParameter('_seek_fields', $seekFields);
        $cliente_id_seekAction->setParameter('_seek_filters', $seekFilters);
        $cliente_id_seekAction->setParameter('_seek_hash', md5($seed.$seekFields.$seekFilters));
        $cliente_id->setAction($cliente_id_seekAction);

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$certificado_venda_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Certificadora:", '#FF0000', '14px', null, '100%'),$certificadora_id]);
        $row2->layout = ['col-sm-4',' col-sm-8'];

        $row3 = $this->form->addFields([new TLabel("Data Emissão:", null, '14px', null, '100%'),$data_emissao],[new TLabel("Data Pagamento:", null, '14px', null, '100%'),$data_pagamento],[new TLabel("Data/Hora Agendamento:", null, '14px', null, '100%'),$data_hora_agendamento]);
        $row3->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Total em Comissões:", null, '14px', null),$comissao_total],[new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$valor_total],[new TLabel("Protocolo Emissão:", null, '14px', null),$protocolo_emissao]);
        $row4->layout = ['col-sm-4','col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([new TLabel("Cliente:", '#ff0000', '14px', null, '100%'),$cliente_id,$cliente_nome]);
        $row5->layout = [' col-sm-12'];

        $bcontainer_63149f58ef22f = new BContainer('bcontainer_63149f58ef22f');
        $this->bcontainer_63149f58ef22f = $bcontainer_63149f58ef22f;

        $bcontainer_63149f58ef22f->setTitle("Produto", '#333', '18px', '', '#fff');
        $bcontainer_63149f58ef22f->setBorderColor('#c0c0c0');

        $row6 = $bcontainer_63149f58ef22f->addFields([new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$produto_id],[new TLabel("Valor Cliente:", null, '14px', null),$valor_cliente],[new TLabel("Data Vencimento Certificado:", null, '14px', null, '100%'),$data_vencimento_certificado]);
        $row6->layout = [' col-sm-7',' col-sm-2',' col-sm-3'];

        $row7 = $this->form->addFields([$bcontainer_63149f58ef22f]);
        $row7->layout = [' col-sm-12'];

        $bcontainer_63132637a53cf = new BContainer('bcontainer_63132637a53cf');
        $this->bcontainer_63132637a53cf = $bcontainer_63132637a53cf;

        $bcontainer_63132637a53cf->setTitle("Atendimento", '#333', '18px', '', '#fff');
        $bcontainer_63132637a53cf->setBorderColor('#c0c0c0');

        $row8 = $bcontainer_63132637a53cf->addFields([new TLabel("Tipo de Atendimento:", '#FF0000', '14px', null, '100%'),$certificado_tipo_atendimento_id],[new TLabel("Valor Externo:", null, '14px', null, '100%'),$valor_externo],[new TLabel("Custo Externo:", null, '14px', null, '100%'),$custo_externo]);
        $row8->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row9 = $this->form->addFields([$bcontainer_63132637a53cf]);
        $row9->layout = [' col-sm-12'];

        $bcontainer_6312bdca9b797 = new BContainer('bcontainer_6312bdca9b797');
        $this->bcontainer_6312bdca9b797 = $bcontainer_6312bdca9b797;

        $bcontainer_6312bdca9b797->setTitle("Parceiro", '#333', '18px', '', '#fff');
        $bcontainer_6312bdca9b797->setBorderColor('#c0c0c0');

        $row10 = $bcontainer_6312bdca9b797->addFields([new TLabel("Parceiro:", null, '14px', null, '100%'),$parceiro_id],[new TLabel("Tipo Repasse:", null, '14px', null, '100%'),$certificado_tipo_repasse_id],[new TLabel("Percentual Comissão (%):", null, '14px', null, '100%'),$parceiro_comissao_percentual]);
        $row10->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row11 = $bcontainer_6312bdca9b797->addFields([new TLabel("Modalidade:", null, '14px', null, '100%'),$certificado_venda_modalidade_id],[new TLabel("Tipo de Modalidade:", null, '14px', null, '100%'),$certificado_venda_tipomodalidade_id],[new TLabel("Valor Repasse (R$):", null, '14px', null, '100%'),$parceiro_valor_repasse]);
        $row11->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row12 = $this->form->addFields([$bcontainer_6312bdca9b797]);
        $row12->layout = [' col-sm-12'];

        $bcontainer_6312c0469b79f = new BContainer('bcontainer_6312c0469b79f');
        $this->bcontainer_6312c0469b79f = $bcontainer_6312c0469b79f;

        $bcontainer_6312c0469b79f->setTitle("Agente de Registro", '#333', '18px', '', '#fff');
        $bcontainer_6312c0469b79f->setBorderColor('#c0c0c0');

        $row13 = $bcontainer_6312c0469b79f->addFields([new TLabel("Agente de Registro:", '#ff0000', '14px', null, '100%'),$certificado_agente_registro_id],[new TLabel("Percentual Comissão (%):", null, '14px', null),$agente_comissao_percentual],[new TLabel("Valor Comissão (R$):", null, '14px', null),$agente_comissao_valor]);
        $row13->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row14 = $this->form->addFields([$bcontainer_6312c0469b79f]);
        $row14->layout = [' col-sm-12'];

        $bcontainer_6312c4da9b7a9 = new BContainer('bcontainer_6312c4da9b7a9');
        $this->bcontainer_6312c4da9b7a9 = $bcontainer_6312c4da9b7a9;

        $bcontainer_6312c4da9b7a9->setTitle("Vendedor", '#333', '18px', '', '#fff');
        $bcontainer_6312c4da9b7a9->setBorderColor('#c0c0c0');

        $row15 = $bcontainer_6312c4da9b7a9->addFields([new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id],[new TLabel("Percentual Comissão (%):", null, '14px', null, '100%'),$vendedor_comissao_percentual],[new TLabel("Valor Comissão (R$):", null, '14px', null, '100%'),$vendedor_comissao_valor]);
        $row15->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row16 = $this->form->addFields([$bcontainer_6312c4da9b7a9]);
        $row16->layout = [' col-sm-12'];

        $bcontainer_6312bafb9b78f = new BContainer('bcontainer_6312bafb9b78f');
        $this->bcontainer_6312bafb9b78f = $bcontainer_6312bafb9b78f;

        $bcontainer_6312bafb9b78f->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_6312bafb9b78f->setBorderColor('#c0c0c0');

        $row17 = $bcontainer_6312bafb9b78f->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row17->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row18 = $this->form->addFields([$bcontainer_6312bafb9b78f]);
        $row18->layout = [' col-sm-12'];

        $row19 = $this->form->addFields([$system_unit_id,$valor_custo,$lucro_total,$tabela_preco_id,$valor_produto]);
        $row19->layout = [' col-sm-12'];

        $this->form->appendPage("Documentos");

        $this->detailFormCertificadoVendaDocumentosCertificadoVenda = new BootstrapFormBuilder('detailFormCertificadoVendaDocumentosCertificadoVenda');
        $this->detailFormCertificadoVendaDocumentosCertificadoVenda->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormCertificadoVendaDocumentosCertificadoVenda->setProperty('class', 'form-horizontal builder-detail-form');

        $row20 = $this->detailFormCertificadoVendaDocumentosCertificadoVenda->addFields([new TLabel("Descrição do Arquivo:", '#ff0000', '14px', null, '100%'),$certificado_venda_documentos_certificado_venda_descricao_arquivo,$certificado_venda_documentos_certificado_venda_id],[new TLabel("Arquivo:", '#ff0000', '14px', null, '100%'),$certificado_venda_documentos_certificado_venda_arquivo]);
        $row20->layout = ['col-sm-6','col-sm-6'];

        $row21 = $this->detailFormCertificadoVendaDocumentosCertificadoVenda->addFields([$button_adicionar_certificado_venda_documentos_certificado_venda]);
        $row21->layout = [' col-sm-12'];

        $row22 = $this->detailFormCertificadoVendaDocumentosCertificadoVenda->addFields([new THidden('certificado_venda_documentos_certificado_venda__row__id')]);
        $this->certificado_venda_documentos_certificado_venda_criteria = new TCriteria();

        $this->certificado_venda_documentos_certificado_venda_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->certificado_venda_documentos_certificado_venda_list->disableHtmlConversion();;
        $this->certificado_venda_documentos_certificado_venda_list->generateHiddenFields();
        $this->certificado_venda_documentos_certificado_venda_list->setId('certificado_venda_documentos_certificado_venda_list');

        $this->certificado_venda_documentos_certificado_venda_list->style = 'width:100%';
        $this->certificado_venda_documentos_certificado_venda_list->class .= ' table-bordered';

        $column_certificado_venda_documentos_certificado_venda_descricao_arquivo = new TDataGridColumn('descricao_arquivo', "Descrição do Arquivo", 'left');
        $column_certificado_venda_documentos_certificado_venda_arquivo = new TDataGridColumn('arquivo', "Arquivo", 'left');

        $column_certificado_venda_documentos_certificado_venda__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_certificado_venda_documentos_certificado_venda__row__data->setVisibility(false);

        $action_onEditDetailCertificadoVendaDocumentos = new TDataGridAction(array('CertificadoVendaForm', 'onEditDetailCertificadoVendaDocumentos'));
        $action_onEditDetailCertificadoVendaDocumentos->setUseButton(false);
        $action_onEditDetailCertificadoVendaDocumentos->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailCertificadoVendaDocumentos->setLabel("Editar");
        $action_onEditDetailCertificadoVendaDocumentos->setImage('far:edit #478fca');
        $action_onEditDetailCertificadoVendaDocumentos->setFields(['__row__id', '__row__data']);

        $this->certificado_venda_documentos_certificado_venda_list->addAction($action_onEditDetailCertificadoVendaDocumentos);
        $action_onDeleteDetailCertificadoVendaDocumentos = new TDataGridAction(array('CertificadoVendaForm', 'onDeleteDetailCertificadoVendaDocumentos'));
        $action_onDeleteDetailCertificadoVendaDocumentos->setUseButton(false);
        $action_onDeleteDetailCertificadoVendaDocumentos->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailCertificadoVendaDocumentos->setLabel("Excluir");
        $action_onDeleteDetailCertificadoVendaDocumentos->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailCertificadoVendaDocumentos->setFields(['__row__id', '__row__data']);

        $this->certificado_venda_documentos_certificado_venda_list->addAction($action_onDeleteDetailCertificadoVendaDocumentos);

        $this->certificado_venda_documentos_certificado_venda_list->addColumn($column_certificado_venda_documentos_certificado_venda_descricao_arquivo);
        $this->certificado_venda_documentos_certificado_venda_list->addColumn($column_certificado_venda_documentos_certificado_venda_arquivo);

        $this->certificado_venda_documentos_certificado_venda_list->addColumn($column_certificado_venda_documentos_certificado_venda__row__data);

        $this->certificado_venda_documentos_certificado_venda_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->certificado_venda_documentos_certificado_venda_list);
        $this->detailFormCertificadoVendaDocumentosCertificadoVenda->addContent([$tableResponsiveDiv]);
        $row23 = $this->form->addFields([$this->detailFormCertificadoVendaDocumentosCertificadoVenda]);
        $row23->layout = [' col-sm-12'];

        $this->form->appendPage("Forma de Pagamento");

        $this->detailFormCertificadoVendaFormapgtoCertificadoVenda = new BootstrapFormBuilder('detailFormCertificadoVendaFormapgtoCertificadoVenda');
        $this->detailFormCertificadoVendaFormapgtoCertificadoVenda->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormCertificadoVendaFormapgtoCertificadoVenda->setProperty('class', 'form-horizontal builder-detail-form');

        $row24 = $this->detailFormCertificadoVendaFormapgtoCertificadoVenda->addFields([new TLabel("Forma de Pagamento", '#ff0000', '14px', null, '100%'),$certificado_venda_formapgto_certificado_venda_forma_pagamento_id,$certificado_venda_formapgto_certificado_venda_id],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$certificado_venda_formapgto_certificado_venda_valor]);
        $row24->layout = ['col-sm-6','col-sm-6'];

        $row25 = $this->detailFormCertificadoVendaFormapgtoCertificadoVenda->addFields([$button_adicionar_certificado_venda_formapgto_certificado_venda]);
        $row25->layout = [' col-sm-12'];

        $row26 = $this->detailFormCertificadoVendaFormapgtoCertificadoVenda->addFields([new THidden('certificado_venda_formapgto_certificado_venda__row__id')]);
        $this->certificado_venda_formapgto_certificado_venda_criteria = new TCriteria();

        $this->certificado_venda_formapgto_certificado_venda_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->certificado_venda_formapgto_certificado_venda_list->disableHtmlConversion();;
        $this->certificado_venda_formapgto_certificado_venda_list->generateHiddenFields();
        $this->certificado_venda_formapgto_certificado_venda_list->setId('certificado_venda_formapgto_certificado_venda_list');

        $this->certificado_venda_formapgto_certificado_venda_list->style = 'width:100%';
        $this->certificado_venda_formapgto_certificado_venda_list->class .= ' table-bordered';

        $column_certificado_venda_formapgto_certificado_venda_forma_pagamento_descricao = new TDataGridColumn('forma_pagamento->descricao', "Forma de Pagamento", 'left');
        $column_certificado_venda_formapgto_certificado_venda_valor_transformed = new TDataGridColumn('valor', "Valor", 'left');

        $column_certificado_venda_formapgto_certificado_venda__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_certificado_venda_formapgto_certificado_venda__row__data->setVisibility(false);

        $action_onEditDetailCertificadoVendaFormapgto = new TDataGridAction(array('CertificadoVendaForm', 'onEditDetailCertificadoVendaFormapgto'));
        $action_onEditDetailCertificadoVendaFormapgto->setUseButton(false);
        $action_onEditDetailCertificadoVendaFormapgto->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailCertificadoVendaFormapgto->setLabel("Editar");
        $action_onEditDetailCertificadoVendaFormapgto->setImage('far:edit #478fca');
        $action_onEditDetailCertificadoVendaFormapgto->setFields(['__row__id', '__row__data']);

        $this->certificado_venda_formapgto_certificado_venda_list->addAction($action_onEditDetailCertificadoVendaFormapgto);
        $action_onDeleteDetailCertificadoVendaFormapgto = new TDataGridAction(array('CertificadoVendaForm', 'onDeleteDetailCertificadoVendaFormapgto'));
        $action_onDeleteDetailCertificadoVendaFormapgto->setUseButton(false);
        $action_onDeleteDetailCertificadoVendaFormapgto->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailCertificadoVendaFormapgto->setLabel("Excluir");
        $action_onDeleteDetailCertificadoVendaFormapgto->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailCertificadoVendaFormapgto->setFields(['__row__id', '__row__data']);

        $this->certificado_venda_formapgto_certificado_venda_list->addAction($action_onDeleteDetailCertificadoVendaFormapgto);

        $this->certificado_venda_formapgto_certificado_venda_list->addColumn($column_certificado_venda_formapgto_certificado_venda_forma_pagamento_descricao);
        $this->certificado_venda_formapgto_certificado_venda_list->addColumn($column_certificado_venda_formapgto_certificado_venda_valor_transformed);

        $this->certificado_venda_formapgto_certificado_venda_list->addColumn($column_certificado_venda_formapgto_certificado_venda__row__data);

        $this->certificado_venda_formapgto_certificado_venda_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->certificado_venda_formapgto_certificado_venda_list);
        $this->detailFormCertificadoVendaFormapgtoCertificadoVenda->addContent([$tableResponsiveDiv]);

        $column_certificado_venda_formapgto_certificado_venda_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row27 = $this->form->addFields([$this->detailFormCertificadoVendaFormapgtoCertificadoVenda]);
        $row27->layout = [' col-sm-12'];

        $this->form->appendPage("Observações");
        $row28 = $this->form->addFields([new TLabel("Observações:", null, '14px', null),$observacao]);
        $row28->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_oncalcular = $this->form->addAction("Calcular", new TAction([$this, 'onCalcular']), 'fas:calculator #009688');
        $this->btn_oncalcular = $btn_oncalcular;

        $btn_onvisualizacertificadovenda = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizaCertificadoVenda']), 'fas:bars #000000');
        $this->btn_onvisualizacertificadovenda = $btn_onvisualizacertificadovenda;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['CertificadoVendaList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Certificação Digital","Cadastro de venda de certificado Digital"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitValorCliente($param = null) 
    {
        try 
        {
           //CertificadoVendaForm::CalculaTotal($param);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitCertificadora($param = null) 
    {
        try 
        {
                $criteria_produto_id = new TCriteria();
                $criteria_produto_id->add(new TFilter('id', 'in', "(SELECT produto_id FROM certificadora_produtos WHERE certificadora_id = '{$param['certificadora_id']}')"));

                TDBCombo::reloadFromModel(self::$formName, //'formName do formulario pai'
                                         'produto_id', //'field do formulario pai'
                                         'kraftsoft', //$database
                                         'Produto', //$model (classe)
                                         'id', //$key (campo id)
                                         '{nome}', //$value
                                         'nome asc', //$ordercolumn = NULL
                                         $criteria_produto_id, // $criteria = NULL
                                         null);

                TTransaction::open(self::$database);                         
                $primeiro_produto_certificadora = CertificadoraProdutos::where('certificadora_id', '=', $param['certificadora_id'])->first();                                            
                TTransaction::close();

                if ($primeiro_produto_certificadora)
                {
                    $novoparam = $param;
                    $novoparam['produto_id'] = $primeiro_produto_certificadora->produto_id; 

                    CertificadoVendaForm::CalculaValorProduto($novoparam);                                         
                }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitProduto($param = null) 
    {
        try 
        {   
            $novoparam = CertificadoVendaForm::CalculaValorProduto($param);
            $novoparam = CertificadoVendaForm::CarregaParceiro($novoparam); 
            //CertificadoVendaForm::CalculaTotal($novoparam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitParceiro($param = null) 
    {
        try 
        {
            if (isset($param['parceiro_id']) && $param['parceiro_id'])
            {    
                $novoparam = CertificadoVendaForm::CarregaParceiro($param);  
                $novoparam = CertificadoVendaForm::CalculaValorProduto($novoparam);      
                //CertificadoVendaForm::CalculaTotal($novoparam);
            }
            else
            {
                $object = new stdClass();
                $object->tabela_preco_id                     = '';
                $object->certificado_tipo_repasse_id         = '';
                $object->certificado_venda_modalidade_id     = '';
                $object->certificado_venda_tipomodalidade_id = '';                                
                $object->parceiro_comissao_percentual        = '0,00';
                $object->parceiro_valor_repasse              = '0,00';
                TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitAgenteRegistro($param = null) 
    {
        try 
        {
            if (isset($param['certificado_agente_registro_id']) && $param['certificado_agente_registro_id'])
            {            
              $novoparam = CertificadoVendaForm::CarregaAgenteRegistro($param);  
             // CertificadoVendaForm::CalculaTotal($novoparam);
            }
            else
            {
                $object = new stdClass();
                $object->agente_comissao_percentual = '0,00';
                $object->agente_comissao_valor      = '0,00';
                TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onVendedorExit($param = null) 
    {
        try 
        {
            if (isset($param['vendedor_id']))
            {            
              $novoparam = CertificadoVendaForm::CarregaVendedor($param);  
             // CertificadoVendaForm::CalculaTotal($novoparam);
            }
            else
            {
                $object = new stdClass();
                $object->veneddor_comissao_percentual = '0,00';
                $object->vendedor_comissao_valor      = '0,00';
                TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailCertificadoVendaDocumentosCertificadoVenda($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Descrição do Arquivo", 'name'=>"certificado_venda_documentos_certificado_venda_descricao_arquivo", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Arquivo", 'name'=>"certificado_venda_documentos_certificado_venda_arquivo", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->certificado_venda_documentos_certificado_venda__row__id) ? $data->certificado_venda_documentos_certificado_venda__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new CertificadoVendaDocumentos();
            $grid_data->__row__id = $__row__id;
            $grid_data->descricao_arquivo = $data->certificado_venda_documentos_certificado_venda_descricao_arquivo;
            $grid_data->id = $data->certificado_venda_documentos_certificado_venda_id;
            $grid_data->arquivo = $data->certificado_venda_documentos_certificado_venda_arquivo;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['descricao_arquivo'] =  $param['certificado_venda_documentos_certificado_venda_descricao_arquivo'] ?? null;
            $__row__data['__display__']['id'] =  $param['certificado_venda_documentos_certificado_venda_id'] ?? null;
            $__row__data['__display__']['arquivo'] =  $param['certificado_venda_documentos_certificado_venda_arquivo'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->certificado_venda_documentos_certificado_venda_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('certificado_venda_documentos_certificado_venda_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->certificado_venda_documentos_certificado_venda_descricao_arquivo = '';
            $data->certificado_venda_documentos_certificado_venda_id = '';
            $data->certificado_venda_documentos_certificado_venda_arquivo = '';
            $data->certificado_venda_documentos_certificado_venda__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63132a29ec6c3');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailCertificadoVendaFormapgtoCertificadoVenda($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Forma pagamento id", 'name'=>"certificado_venda_formapgto_certificado_venda_forma_pagamento_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor", 'name'=>"certificado_venda_formapgto_certificado_venda_valor", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->certificado_venda_formapgto_certificado_venda__row__id) ? $data->certificado_venda_formapgto_certificado_venda__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new CertificadoVendaFormapgto();
            $grid_data->__row__id = $__row__id;
            $grid_data->forma_pagamento_id = $data->certificado_venda_formapgto_certificado_venda_forma_pagamento_id;
            $grid_data->id = $data->certificado_venda_formapgto_certificado_venda_id;
            $grid_data->valor = $data->certificado_venda_formapgto_certificado_venda_valor;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['forma_pagamento_id'] =  $param['certificado_venda_formapgto_certificado_venda_forma_pagamento_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['certificado_venda_formapgto_certificado_venda_id'] ?? null;
            $__row__data['__display__']['valor'] =  $param['certificado_venda_formapgto_certificado_venda_valor'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->certificado_venda_formapgto_certificado_venda_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('certificado_venda_formapgto_certificado_venda_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->certificado_venda_formapgto_certificado_venda_forma_pagamento_id = '';
            $data->certificado_venda_formapgto_certificado_venda_id = '';
            $data->certificado_venda_formapgto_certificado_venda_valor = '';
            $data->certificado_venda_formapgto_certificado_venda__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6313bc3e3eecf');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailCertificadoVendaDocumentos($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->certificado_venda_documentos_certificado_venda_descricao_arquivo = $__row__data->__display__->descricao_arquivo ?? null;
            $data->certificado_venda_documentos_certificado_venda_id = $__row__data->__display__->id ?? null;
            $data->certificado_venda_documentos_certificado_venda_arquivo = $__row__data->__display__->arquivo ?? null;
            $data->certificado_venda_documentos_certificado_venda__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63132a29ec6c3');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailCertificadoVendaDocumentos($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->certificado_venda_documentos_certificado_venda_descricao_arquivo = '';
            $data->certificado_venda_documentos_certificado_venda_id = '';
            $data->certificado_venda_documentos_certificado_venda_arquivo = '';
            $data->certificado_venda_documentos_certificado_venda__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('certificado_venda_documentos_certificado_venda_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailCertificadoVendaFormapgto($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->certificado_venda_formapgto_certificado_venda_forma_pagamento_id = $__row__data->__display__->forma_pagamento_id ?? null;
            $data->certificado_venda_formapgto_certificado_venda_id = $__row__data->__display__->id ?? null;
            $data->certificado_venda_formapgto_certificado_venda_valor = $__row__data->__display__->valor ?? null;
            $data->certificado_venda_formapgto_certificado_venda__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6313bc3e3eecf');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailCertificadoVendaFormapgto($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->certificado_venda_formapgto_certificado_venda_forma_pagamento_id = '';
            $data->certificado_venda_formapgto_certificado_venda_id = '';
            $data->certificado_venda_formapgto_certificado_venda_valor = '';
            $data->certificado_venda_formapgto_certificado_venda__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('certificado_venda_formapgto_certificado_venda_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            //recalculando...
            CertificadoVendaForm::CalculaTotal($param);            

            $this->form->validate(); // validate form data

            $object = new CertificadoVenda(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            if ($object->valor_total==0)
            {
               throw new Exception("Valor total não pode ser zero!");  
            }              

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $certificado_venda_formapgto_certificado_venda_items = $this->storeMasterDetailItems('CertificadoVendaFormapgto', 'certificado_venda_id', 'certificado_venda_formapgto_certificado_venda', $object, $param['certificado_venda_formapgto_certificado_venda_list___row__data'] ?? [], $this->form, $this->certificado_venda_formapgto_certificado_venda_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->certificado_venda_formapgto_certificado_venda_criteria); 

            $certificado_venda_documentos_certificado_venda_items = $this->storeMasterDetailItems('CertificadoVendaDocumentos', 'certificado_venda_id', 'certificado_venda_documentos_certificado_venda', $object, $param['certificado_venda_documentos_certificado_venda_list___row__data'] ?? [], $this->form, $this->certificado_venda_documentos_certificado_venda_list, function($masterObject, $detailObject){ 

                //code here

                $detailObject->store();
                $dataFile = new stdClass();
                $dataFile->arquivo = $detailObject->arquivo;
                $this->saveFile($detailObject, $dataFile, 'arquivo', 'certificacao_arquivos');

            }, $this->certificado_venda_documentos_certificado_venda_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               CertificadoVenda::Evento_VendaCertificadoIncluidaOuAlterada,
                                               $object,
                                               'Venda de certificado cliente '.$object->cliente->nome.' , '.
                                               'Produto: '.$object->produto->nome.' , '.
                                               'Valor: R$ '.number_format($object->valor_total,2, ',', '.')); 
            TTransaction::close();       

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public static function onCalcular($param = null) 
    {
        try 
        {
            CertificadoVendaForm::CalculaTotal($param);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onVisualizaCertificadoVenda($param = null) 
    {
        try 
        {
            $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve a venda para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('CertificadoVendaFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new CertificadoVenda($key); // instantiates the Active Record 

                $certificado_venda_formapgto_certificado_venda_items = $this->loadMasterDetailItems('CertificadoVendaFormapgto', 'certificado_venda_id', 'certificado_venda_formapgto_certificado_venda', $object, $this->form, $this->certificado_venda_formapgto_certificado_venda_list, $this->certificado_venda_formapgto_certificado_venda_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $certificado_venda_documentos_certificado_venda_items = $this->loadMasterDetailItems('CertificadoVendaDocumentos', 'certificado_venda_id', 'certificado_venda_documentos_certificado_venda', $object, $this->form, $this->certificado_venda_documentos_certificado_venda_list, $this->certificado_venda_documentos_certificado_venda_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                $criteria_produto_id = new TCriteria();
                $criteria_produto_id->add(new TFilter('id', 'in', "(SELECT produto_id FROM certificadora_produtos WHERE certificadora_id = '{$object->certificadora_id}')"));

                TDBCombo::reloadFromModel(self::$formName, //'formName do formulario pai'
                                         'produto_id', //'field do formulario pai'
                                         'kraftsoft', //$database
                                         'Produto', //$model (classe)
                                         'id', //$key (campo id)
                                         '{nome}', //$value
                                         'nome asc', //$ordercolumn = NULL
                                         $criteria_produto_id, // $criteria = NULL
                                         null);

                $dados = new stdClass();
                $dados->cliente_nome = $object->cliente->nome;
                $dados->produto_id = $object->produto->id;
                TForm::sendData(self::$formName, $dados);

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->certificado_venda_situacao_id = CertificadoVendaSituacao::AguardandoAtendimento;
        $object->system_unit_id = TSession::getValue('userunitid');
        $object->certificado_tipo_atendimento_id = CertificadoTipoAtendimento::Remoto;

        //zerando os campos de valor..
        $object->valor_externo = '0,00';
        $object->custo_externo = '0,00';
        $object->valor_custo = '0,00';
        $object->valor_produto = '0,00';
        $object->valor_cliente = '0,00';
        $object->parceiro_comissao_percentual = '0,00';
        $object->parceiro_valor_repasse = '0,00';
        $object->agente_comissao_percentual = '0,00';
        $object->agente_comissao_valor = '0,00';
        $object->vendedor_comissao_percentual = '0,00';
        $object->vendedor_comissao_valor = '0,00';     
        $object->comissao_total = '0,00';
        $object->valor_total = '0,00';     
        $object->lucro_total = '0,00';

        TForm::sendData(self::$formName, $object);
    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

    public static function CalculaValorProduto($param = null) 
    {
        try 
        {
            if (isset($param['produto_id']))
            {
                TTransaction::open(self::$database);

                $object = new stdClass();

                //trazer o preço da filial..
                $produtofilial = ProdutoFilial::where('produto_id', '=', $param['produto_id'])
                                              ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                              ->first();

                //veificando se o parceiro possui tabela de preço vinculada...
                $tabelaprecoprod = TabelaPrecoProduto::where('produto_filial_id', '=', $produtofilial->id)
                                                     ->where('tabela_preco_id', '=', $param['tabela_preco_id'])
                                                     ->first();   

                if ($tabelaprecoprod)
                {
                    $valorproduto = $tabelaprecoprod->preco_venda;    
                }
                else
                {
                   $valorproduto = $produtofilial->preco_venda;
                }

                $valor_custo = 0;
                $data_vencimento = null;

                //trazendo o custo do produto 
                if (isset($param['certificadora_id']))
                {
                    $certificadora_produto = CertificadoraProdutos::where('produto_id', '=', $param['produto_id'])
                                                                   ->where('certificadora_id', '=', $param['certificadora_id'])->first();   

                    $valor_custo = $certificadora_produto->valor_custo;                                                                 

                    //calculando o vencimento do certificado
                    // $primeiro_vencimento = TDate::date2us(date('d/m/Y'));
                    $data_vencimento = new DateTime();
                    $data_vencimento->modify( '+ '.$certificadora_produto->qtde_dias_vencimento.' days' );
                }

                $object->valor_produto = number_format($valorproduto, 2, ',', '.');
                $object->valor_cliente = number_format($valorproduto, 2, ',', '.');                
                $object->valor_custo = $valor_custo;
                $object->data_vencimento_certificado = $data_vencimento->format('d/m/Y');

                TTransaction::close();                

                TForm::sendData(self::$formName, $object);

                //jogando os valores para param pois vai precisar dentro de outras chamadas...
                $param['valor_produto'] = $valorproduto;
                $param['valor_cliente'] = $valorproduto;                
                $param['valor_custo']   = $valor_custo;                    

                return $param;
            }
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function CarregaParceiro($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $object = new stdClass();

            $parceiro_id = (isset($param['parceiro_id'])) ? $param['parceiro_id'] : 0;   
            $parceiro = Parceiro::find($parceiro_id);

            if ($parceiro)
            {
                $object->tabela_preco_id                     = $parceiro->tabela_preco_id;
                $object->certificado_tipo_repasse_id         = $parceiro->certificado_venda_modalidade->certificado_tipo_repasse_id;
                $object->certificado_venda_modalidade_id     = $parceiro->certificado_venda_modalidade_id;
                $object->certificado_venda_tipomodalidade_id = $parceiro->certificado_venda_modalidade->certificado_venda_tipomodalidade_id;                                
                $object->parceiro_comissao_percentual        = number_format($parceiro->comissao_percentual, 2, ',', '.');
                $object->vendedor_id                         = $parceiro->vendedor_id;    

            }

            TTransaction::close();                

            TForm::sendData(self::$formName, $object);

            //carregando o param com os novos valores...
            $param['tabela_preco_id'] = (isset($parceiro->tabela_preco_id)) ? $parceiro->tabela_preco_id : '';  
            $param['certificado_tipo_repasse_id'] = (isset($parceiro->certificado_venda_modalidade->certificado_tipo_repasse_id)) ? $parceiro->certificado_venda_modalidade->certificado_tipo_repasse_id : ''; 
            $param['certificado_venda_modalidade_id'] = (isset($parceiro->certificado_venda_modalidade_id)) ? $parceiro->certificado_venda_modalidade_id : ''; 
            $param['certificado_venda_tipomodalidade_id'] = (isset($parceiro->certificado_venda_modalidade->certificado_venda_tipomodalidade_id)) ? $parceiro->certificado_venda_modalidade->certificado_venda_tipomodalidade_id : '';  
            $param['parceiro_comissao_percentual'] = (isset($parceiro->comissao_percentual)) ? $parceiro->comissao_percentual : '';                   

            return $param;
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function CalculaTotal($param = null) 
    {
        try 
        {

            $valor_externo = (double) $param['valor_externo'];
            $custo_externo = (double) $param['custo_externo'];
            $custo_produto = (double) $param['valor_custo'];
            $valor_produto = (double) $param['valor_produto'];
            $valor_cliente = (double) $param['valor_cliente'];  
            $perc_vendedor = (double) $param['vendedor_comissao_percentual'];  
            $perc_agente   = (double) $param['agente_comissao_percentual'];   
            $tiporepasse   = '';    

            $parceirovalorrepasse = 0;
            $parceiropercentualcomissao = 0;
            $valortotal = 0;
            $valorcomissaoagente = 0;
            $valorcomissaovendedor = 0;

            if (isset($param['parceiro_id']) && $param['parceiro_id'])
            {
                $tiporepasse                = $param['certificado_tipo_repasse_id']; 
                $modalidade                 = $param['certificado_venda_modalidade_id']; 
                $tipomodalidade             = $param['certificado_venda_tipomodalidade_id']; 
                $parceiropercentualcomissao = $param['parceiro_comissao_percentual']; 

                if ($tiporepasse==CertificadoTipoRepasse::PosPago)
                {
                  $valor_cliente = 0;
                  $valortotal = $valor_produto;
                }
                else
                {
                  $valortotal = $valor_cliente;
                }                

                if ($tipomodalidade == CertificadoVendaTipomodalidade::PercentualVenda)
                {
                    $parceirovalorrepasse = (($valor_produto * $parceiropercentualcomissao) / 100);
                }
                else
                {
                    if ($valor_cliente>0)
                    {
                        $parceirovalorrepasse = ($valor_cliente - $valor_produto);
                    }
                    else
                    {
                        $parceirovalorrepasse = $valor_produto;                        
                    }
                }
            }
            else
            {
                $valortotal = $valor_cliente;   
            }

            $valortotal = (double) str_replace(',', '.', str_replace('.', '', $valortotal));
            $valor_externo = (double) str_replace(',', '.', str_replace('.', '', $valor_externo));

            $valortotal += $valor_externo;

            //comissoes...
            $valorcomissaoagente = (($valor_produto * $perc_agente) / 100);
            $valorcomissaovendedor = (($valor_produto * $perc_vendedor) / 100);            
            $totalcomissoes = $valorcomissaoagente+$valorcomissaovendedor;

            if ($tiporepasse==CertificadoTipoRepasse::PrePago)
            {
                $totalcomissoes += $parceirovalorrepasse;
            }

            //calculando o lucro...
            $lucro = $valortotal
                     - $custo_externo
                     - $custo_produto
                     - $totalcomissoes;

            // echo '<pre>';
            // echo 'total '.$valortotal;
            // echo 'valor cliente '.$valor_cliente;
            // echo 'externo '.$custo_externo;
            // echo 'custo prod '.$custo_produto;
            // echo 'comissoes '.$totalcomissoes;
            // echo 'lucro '.$lucro;            

            //passando os valores para tela...
            $object = new stdClass();
            $object->parceiro_valor_repasse = number_format($parceirovalorrepasse, 2, ',', '.');
            $object->valor_cliente = number_format($valor_cliente, 2, ',', '.'); 
            $object->valor_total = number_format($valortotal, 2, ',', '.');
            $object->lucro_total = $lucro;//number_format($lucro, 2, ',', '.');
            $object->comissao_total = number_format($totalcomissoes, 2, ',', '.'); 
            $object->agente_comissao_valor = number_format($valorcomissaoagente, 2, ',', '.'); 
            $object->vendedor_comissao_valor = number_format($valorcomissaovendedor, 2, ',', '.');             

            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function CarregaAgenteRegistro($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);
            $agente = CertificadoAgenteRegistro::find($param['certificado_agente_registro_id']);
            TTransaction::close();

            $object = new stdClass();

            $perc_comissao_agente = (isset($agente->percentual_comissao)) ? $agente->percentual_comissao : 0;
            $object->agente_comissao_percentual = number_format($perc_comissao_agente, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

            $param['agente_comissao_percentual'] = $perc_comissao_agente;
            return $param;

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function CarregaVendedor($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);
            $vendedor = Vendedor::find($param['vendedor_id']);
            TTransaction::close();

            $object = new stdClass();

            $perc_comissao_vendedor = (isset($vendedor->percentual_comissao)) ? $vendedor->percentual_comissao : 0;
            $object->vendedor_comissao_percentual = number_format($perc_comissao_vendedor, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

            $param['vendedor_comissao_percentual'] = $perc_comissao_vendedor;
            return $param;            
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

