<?php

class CertificadoVendaFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'CertificadoVenda';
    private static $primaryKey = 'id';
    private static $formName = 'formView_CertificadoVenda';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $certificado_venda = new CertificadoVenda($param['key']);
        // define the form title
        $this->form->setFormTitle("Venda de Certificado Digital");

        $transformed_certificado_venda_data_emissao = call_user_func(function($value, $object, $row) 
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        }, $certificado_venda->data_emissao, $certificado_venda, null);    

        $transformed_certificado_venda_data_pagamento = call_user_func(function($value, $object, $row) 
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        }, $certificado_venda->data_pagamento, $certificado_venda, null);    

        $transformed_certificado_venda_certificado_tipo_atendimento_descricao = call_user_func(function($value, $object, $row) 
        {
            if($value === true || $value == 't' || $value === 1 || $value == '1' || $value == 's' || $value == 'S' || $value == 'T')
            {
                return 'Sim';
            }
            elseif($value === false || $value == 'f' || $value === 0 || $value == '0' || $value == 'n' || $value == 'N' || $value == 'F')   
            {
                return 'Não';
            }

            return $value;

        }, $certificado_venda->certificado_tipo_atendimento->descricao, $certificado_venda, null);

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'CertificadoVendaSituacao', 'id', '{descricao}','ordem asc' );
        $label2 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($certificado_venda->id, '', '15px', '');
        $lbcertificadora = new TLabel("Certificadora:", '', '15px', 'B', '100%');
        $txtcertificadora = new TTextDisplay($certificado_venda->certificadora->nome, '', '15px', '');
        $lbdataemissao = new TLabel("Data Emissão:", '', '15px', 'B', '100%');
        $txtdataemissao = new TTextDisplay($transformed_certificado_venda_data_emissao, '', '15px', '');
        $label3 = new TLabel("Data de Pagamento:", '', '15px', 'B', '100%');
        $txtdatapagamento = new TTextDisplay($transformed_certificado_venda_data_pagamento, '', '15px', '');
        $lbagendamento = new TLabel("Data/Hora Agendamento:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay(TDateTime::convertToMask($certificado_venda->data_hora_agendamento, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbtotalcomissoes = new TLabel("Total em Comissões:", '', '15px', 'B', '100%');
        $text31 = new TTextDisplay(number_format((double)$certificado_venda->comissao_total, '2', ',', '.'), '', '15px', '');
        $lbvlrtotal = new TLabel("Valor Total:", '', '15px', 'B', '100%');
        $text30 = new TTextDisplay(number_format((double)$certificado_venda->valor_total, '2', ',', '.'), '', '15px', '');
        $lbprotocoloemissao = new TLabel("Protocolo Emissão:", '', '15px', 'B', '100%');
        $txtprotocoloemissao = new TTextDisplay($certificado_venda->protocolo_emissao, '', '15px', '');
        $label12 = new TLabel("Cliente:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($certificado_venda->cliente->nome, '', '15px', '');
        $lbproduto = new TLabel("Produto:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($certificado_venda->produto->nome, '', '15px', '');
        $lbvlrcliente = new TLabel("Valor Cliente:", '', '15px', 'B', '100%');
        $text33 = new TTextDisplay(number_format((double)$certificado_venda->valor_cliente, '2', ',', '.'), '', '15px', '');
        $lbvencimentocertificado = new TLabel("Data Vencimento Certificado:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(TDate::convertToMask($certificado_venda->data_vencimento_certificado, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbatendimentoexterno = new TLabel("Tipo Atendimento:", '', '15px', 'B', '100%');
        $text27 = new TTextDisplay($transformed_certificado_venda_certificado_tipo_atendimento_descricao, '', '15px', '');
        $lbvlrexterno = new TLabel("Valor Externo:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay(number_format((double)$certificado_venda->valor_externo, '2', ',', '.'), '', '15px', '');
        $lbcustoexterno = new TLabel("Custo Externo:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(number_format((double)$certificado_venda->custo_externo, '2', ',', '.'), '', '15px', '');
        $lbparceiro = new TLabel("Parceiro:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($certificado_venda->parceiro->nome, '', '15px', '');
        $lbtiporepasse = new TLabel("Tipo Repasse:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay($certificado_venda->certificado_tipo_repasse->descricao, '', '15px', '');
        $lbparccomissaoperc = new TLabel("Comissão Percentual:", '', '15px', 'B', '100%');
        $text28 = new TTextDisplay(number_format((double)$certificado_venda->parceiro_comissao_percentual, '2', ',', '.'), '', '15px', '');
        $lbmodalidade = new TLabel("Modalidade:", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay($certificado_venda->certificado_venda_modalidade->descricao, '', '15px', '');
        $lbtipomodalidade = new TLabel("Tipo de Modalidade:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($certificado_venda->certificado_venda_tipomodalidade->descricao, '', '15px', '');
        $lbparcvlrrepasse = new TLabel("Valor Repasse:", '', '15px', 'B', '100%');
        $text29 = new TTextDisplay(number_format((double)$certificado_venda->parceiro_valor_repasse, '2', ',', '.'), '', '15px', '');
        $lbagenteregistro = new TLabel("Agente de  Registro:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay($certificado_venda->certificado_agente_registro->nome, '', '15px', '');
        $label38 = new TLabel("Percentual Comissão (%) :", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay(number_format((double)$certificado_venda->agente_comissao_percentual, '2', ',', '.'), '', '15px', '');
        $label40 = new TLabel("Valor Comissão:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay(number_format((double)$certificado_venda->agente_comissao_valor, '2', ',', '.'), '', '15px', '');
        $label42 = new TLabel("Vendedor:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($certificado_venda->vendedor->nome, '', '15px', '');
        $label44 = new TLabel("Comissão Percentual:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay(number_format((double)$certificado_venda->vendedor_comissao_percentual, '2', ',', '.'), '', '15px', '');
        $label46 = new TLabel("Comissão Valor:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay(number_format((double)$certificado_venda->vendedor_comissao_valor, '2', ',', '.'), '', '15px', '');
        $label48 = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(TDateTime::convertToMask($certificado_venda->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label50 = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay($certificado_venda->criado_por, '', '15px', '');
        $label52 = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(TDateTime::convertToMask($certificado_venda->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label54 = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay($certificado_venda->alterado_por, '', '15px', '');
        $lblobs = new TLabel("Observações:", '', '12px', '', '100%');
        $txtobs = new TTextDisplay($certificado_venda->observacao, '', '12px', '');

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($certificado_venda->certificado_venda_situacao_id);

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$label2,$text1],[$lbcertificadora,$txtcertificadora]);
        $row2->layout = [' col-sm-4',' col-sm-8'];

        $row3 = $this->form->addFields([$lbdataemissao,$txtdataemissao],[$label3,$txtdatapagamento],[$lbagendamento,$text14]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([$lbtotalcomissoes,$text31],[$lbvlrtotal,$text30],[$lbprotocoloemissao,$txtprotocoloemissao]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$label12,$text3]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row7 = $this->form->addContent([new TFormSeparator("Produto", '#333', '18', '#eee')]);
        $row8 = $this->form->addFields([$lbproduto,$text4],[$lbvlrcliente,$text33],[$lbvencimentocertificado,$text15]);
        $row8->layout = [' col-sm-7',' col-sm-2',' col-sm-3'];

        $row9 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row10 = $this->form->addContent([new TFormSeparator("Atendimento", '#333', '18', '#eee')]);
        $row11 = $this->form->addFields([$lbatendimentoexterno,$text27],[$lbvlrexterno,$text16],[$lbcustoexterno,$text17]);
        $row11->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row12 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row13 = $this->form->addContent([new TFormSeparator("Parceiro", '#333', '18', '#eee')]);
        $row14 = $this->form->addFields([$lbparceiro,$text5],[$lbtiporepasse,$text10],[$lbparccomissaoperc,$text28],[$lbmodalidade,$text8],[$lbtipomodalidade,$text9],[$lbparcvlrrepasse,$text29]);
        $row14->layout = [' col-sm-4',' col-sm-4',' col-sm-4',' col-sm-4',' col-sm-4',' col-sm-4'];

        $row15 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row16 = $this->form->addContent([new TFormSeparator("Agente de Registro", '#333', '18', '#eee')]);
        $row17 = $this->form->addFields([$lbagenteregistro,$text6],[$label38,$text23],[$label40,$text24]);
        $row17->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row18 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row19 = $this->form->addContent([new TFormSeparator("Vendedor", '#333', '18', '#eee')]);
        $row20 = $this->form->addFields([$label42,$text11],[$label44,$text25],[$label46,$text26]);
        $row20->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row21 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row22 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row23 = $this->form->addFields([$label48,$text18],[$label50,$text21],[$label52,$text22],[$label54,$text20]);
        $row23->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Documentos");

        $this->certificado_venda_documentos_certificado_venda_id_list = new TQuickGrid;
        $this->certificado_venda_documentos_certificado_venda_id_list->disableHtmlConversion();
        $this->certificado_venda_documentos_certificado_venda_id_list->style = 'width:100%';
        $this->certificado_venda_documentos_certificado_venda_id_list->disableDefaultClick();

        $action_onBaixarArquivoDoc = new TDataGridAction(array('CertificadoVendaFormView', 'onBaixarArquivoDoc'));
        $action_onBaixarArquivoDoc->setUseButton(true);
        $action_onBaixarArquivoDoc->setButtonClass('btn btn-default btn-sm');
        $action_onBaixarArquivoDoc->setLabel("Baixar");
        $action_onBaixarArquivoDoc->setImage('fas:download #000000');
        $action_onBaixarArquivoDoc->setField('id');

        $this->certificado_venda_documentos_certificado_venda_id_list->addAction($action_onBaixarArquivoDoc);

        $column_descricao_arquivo = $this->certificado_venda_documentos_certificado_venda_id_list->addQuickColumn("Descrição do Arquivo", 'descricao_arquivo', 'left');
        $column_arquivo = $this->certificado_venda_documentos_certificado_venda_id_list->addQuickColumn("Arquivo", 'arquivo', 'left');

        $this->certificado_venda_documentos_certificado_venda_id_list->createModel();

        $criteria_certificado_venda_documentos_certificado_venda_id = new TCriteria();
        $criteria_certificado_venda_documentos_certificado_venda_id->add(new TFilter('certificado_venda_id', '=', $certificado_venda->id));

        $criteria_certificado_venda_documentos_certificado_venda_id->setProperty('order', 'id desc');

        $certificado_venda_documentos_certificado_venda_id_items = CertificadoVendaDocumentos::getObjects($criteria_certificado_venda_documentos_certificado_venda_id);

        $this->certificado_venda_documentos_certificado_venda_id_list->addItems($certificado_venda_documentos_certificado_venda_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->certificado_venda_documentos_certificado_venda_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Forma de Pagamento");

        $this->certificado_venda_formapgto_certificado_venda_id_list = new TQuickGrid;
        $this->certificado_venda_formapgto_certificado_venda_id_list->disableHtmlConversion();
        $this->certificado_venda_formapgto_certificado_venda_id_list->style = 'width:100%';
        $this->certificado_venda_formapgto_certificado_venda_id_list->disableDefaultClick();

        $column_forma_pagamento_descricao = $this->certificado_venda_formapgto_certificado_venda_id_list->addQuickColumn("Forma Pagamento", 'forma_pagamento->descricao', 'left');
        $column_valor_transformed = $this->certificado_venda_formapgto_certificado_venda_id_list->addQuickColumn("Valor", 'valor', 'left');

        $column_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->certificado_venda_formapgto_certificado_venda_id_list->createModel();

        $criteria_certificado_venda_formapgto_certificado_venda_id = new TCriteria();
        $criteria_certificado_venda_formapgto_certificado_venda_id->add(new TFilter('certificado_venda_id', '=', $certificado_venda->id));

        $criteria_certificado_venda_formapgto_certificado_venda_id->setProperty('order', 'id desc');

        $certificado_venda_formapgto_certificado_venda_id_items = CertificadoVendaFormapgto::getObjects($criteria_certificado_venda_formapgto_certificado_venda_id);

        $this->certificado_venda_formapgto_certificado_venda_id_list->addItems($certificado_venda_formapgto_certificado_venda_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->certificado_venda_formapgto_certificado_venda_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Observações");
        $row24 = $this->form->addFields([$lblobs,$txtobs]);
        $row24->layout = [' col-sm-12'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        $btnCertificadoVendaFormOnEditAction = new TAction(['CertificadoVendaForm', 'onEdit'],['key'=>$certificado_venda->id]);
        $btnCertificadoVendaFormOnEditLabel = new TLabel("Editar");

        $btnCertificadoVendaFormOnEdit = $this->form->addHeaderAction($btnCertificadoVendaFormOnEditLabel, $btnCertificadoVendaFormOnEditAction, 'fas:edit #2196F3'); 
        $btnCertificadoVendaFormOnEditLabel->setFontSize('12px'); 
        $btnCertificadoVendaFormOnEditLabel->setFontColor('#333'); 

        $btn_onaguardandoaprovacaoAction = new TAction([$this, 'onAguardandoAprovacao'],['key'=>$certificado_venda->id]);
        $btn_onaguardandoaprovacaoLabel = new TLabel("Aguardando Aprovação");

        $btn_onaguardandoaprovacao = $this->form->addHeaderAction($btn_onaguardandoaprovacaoLabel, $btn_onaguardandoaprovacaoAction, 'fas:clock #FFC107'); 
        $btn_onaguardandoaprovacaoLabel->setFontSize('12px'); 
        $btn_onaguardandoaprovacaoLabel->setFontColor('#333'); 

        $btn_onfinalizaratendimentoAction = new TAction([$this, 'onFinalizarAtendimento'],['key'=>$certificado_venda->id]);
        $btn_onfinalizaratendimentoLabel = new TLabel("Finalizar Atendimento");

        $btn_onfinalizaratendimento = $this->form->addHeaderAction($btn_onfinalizaratendimentoLabel, $btn_onfinalizaratendimentoAction, 'fas:fingerprint #009688'); 
        $btn_onfinalizaratendimentoLabel->setFontSize('12px'); 
        $btn_onfinalizaratendimentoLabel->setFontColor('#333'); 

        $btn_oncopiarprotocoloAction = new TAction([$this, 'onCopiarProtocolo'],['key'=>$certificado_venda->id]);
        $btn_oncopiarprotocoloLabel = new TLabel("Copiar Protocolo");

        $btn_oncopiarprotocolo = $this->form->addHeaderAction($btn_oncopiarprotocoloLabel, $btn_oncopiarprotocoloAction, 'fas:copy #CDDC39'); 
        $btn_oncopiarprotocoloLabel->setFontSize('12px'); 
        $btn_oncopiarprotocoloLabel->setFontColor('#333'); 

        $btn_oncancelarAction = new TAction([$this, 'onCancelar'],['key'=>$certificado_venda->id]);
        $btn_oncancelarLabel = new TLabel("Cancelar");

        $btn_oncancelar = $this->form->addHeaderAction($btn_oncancelarLabel, $btn_oncancelarAction, 'fas:window-close #CE0D0D'); 
        $btn_oncancelarLabel->setFontSize('12px'); 
        $btn_oncancelarLabel->setFontColor('#333'); 

        $btn_ondesfazeratendimentoAction = new TAction([$this, 'onDesfazerAtendimento'],['key'=>$certificado_venda->id]);
        $btn_ondesfazeratendimentoLabel = new TLabel("Desfazer Atendimento");

        $btn_ondesfazeratendimento = $this->form->addHeaderAction($btn_ondesfazeratendimentoLabel, $btn_ondesfazeratendimentoAction, 'fas:backward #9C27B0'); 
        $btn_ondesfazeratendimentoLabel->setFontSize('12px'); 
        $btn_ondesfazeratendimentoLabel->setFontColor('#333'); 

        $btnCertificadoVendaListOnShowAction = new TAction(['CertificadoVendaList', 'onShow']);
        $btnCertificadoVendaListOnShowLabel = new TLabel("Voltar");

        $btnCertificadoVendaListOnShow = $this->form->addHeaderAction($btnCertificadoVendaListOnShowLabel, $btnCertificadoVendaListOnShowAction, 'fas:arrow-left #000000'); 
        $btnCertificadoVendaListOnShowLabel->setFontSize('12px'); 
        $btnCertificadoVendaListOnShowLabel->setFontColor('#333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Certificação Digital","Venda de Certificado Digital"]));
        }
        $container->add($this->form);

        if ($certificado_venda->certificado_venda_situacao_id==CertificadoVendaSituacao::Cancelado)
        {
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_finalizar_atendimento").style.display = "none";');
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');            
            TScript::create('document.getElementById("tbutton_desfazer_atendimento").style.display = "none";');      
            TScript::create('document.getElementById("tbutton_copiar_protocolo").style.display = "none";');          
            TScript::create('document.getElementById("tbutton_aguardando_aprovacao").style.display = "none";');                      
        }

        if($certificado_venda->certificado_venda_situacao_id==CertificadoVendaSituacao::Atendido)
        {
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_finalizar_atendimento").style.display = "none";');
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');            
            TScript::create('document.getElementById("tbutton_aguardando_aprovação").style.display = "none";');                                  
        }

        if($certificado_venda->certificado_venda_situacao_id==CertificadoVendaSituacao::AguardandoAtendimento)
        {
            TScript::create('document.getElementById("tbutton_desfazer_atendimento").style.display = "none";');          
            TScript::create('document.getElementById("tbutton_copiar_protocolo").style.display = "none";');          
        }   

        if($certificado_venda->certificado_venda_situacao_id==CertificadoVendaSituacao::AguardandoAprovacao)
        {
            TScript::create('document.getElementById("tbutton_desfazer_atendimento").style.display = "none";');          
            TScript::create('document.getElementById("tbutton_copiar_protocolo").style.display = "none";');    
            TScript::create('document.getElementById("tbutton_aguardando_aprovação").style.display = "none";'); 
        }           

        TTransaction::close();
        parent::add($container);

    }

    public static function onBaixarArquivoDoc($param = null) 
    {
        try 
        {

            $id = $param['id']; 
            TTransaction::open('kraftsoft'); 
            $certdoc = CertificadoVendaDocumentos::find($id);
            TTransaction::close();                     

            $arq = "app/kraft_arquivos/".$certdoc->arquivo;

            //echo 'arq '.$arq;

            TPage::openFile($arq);

            // if (strtolower(substr($certdoc->arquivo, -4)) == 'html')
            // {
            //     $win = TWindow::create( $object->filename, 0.8, 0.8 );
            //     $win->add( file_get_contents( "files/documents/{$id}/".$object->filename ) );
            //     $win->show();
            // }
            // else
            // {
                // TPage::openFile("app/kraft_arquivos/certificacao_arquivos/{$id}/".$certdoc->arquivo);
            // }

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onAguardandoAprovacao($param = null) 
    {
        try 
        {
            new TQuestion("Confirma aguardando aprovação?", new TAction([__CLASS__, 'onAguardandoAprovacaoYes'], $param), new TAction([__CLASS__, 'onAguardandoAprovacaoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onFinalizarAtendimento($param = null) 
    {
        try 
        {
           new TQuestion("Deseja finalizar o atendimento?", new TAction([__CLASS__, 'onFinalizarAtendimentoYes'], $param), new TAction([__CLASS__, 'onFinalizarAtendimentoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onCopiarProtocolo($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $certvenda = CertificadoVenda::find($param['key']);     

            if($certvenda) 
            {        
                $texto = $certvenda->certificadora->texto_emissao;

                $texto = str_replace('{protocolo_emissao}',$certvenda->protocolo_emissao,$texto);
                $texto = str_replace('{cliente_nome}',$certvenda->cliente->nome,$texto);
                $texto = str_replace('{cliente_cpf_cnpj}',Funcoes::mascaraCpfCnpj($certvenda->cliente->cpf_cnpj),$texto);
                $texto = str_replace('{produto_nome}',$certvenda->produto->nome,$texto);

                // $texto =   "Informamos que o seu Certificado Digital foi aprovado com sucesso.".  
                //             " Vá em (https://safeweb.com.br/suporte) para acessar o passo a passo e proceder com a instalação.".
                //             " DADOS DO CERTIFICADO DIGITAL:". 
                //             " Nome Completo: ".$certvenda->cliente->nome.
                //             " CPF/CNPJ: ".$certvenda->cliente->cpf_cnpj.
                //             " Protocolo: ".$certvenda->protocolo_emissao.
                //             " Tipo: ".$certvenda->produto->nome.";";

                TScript::create("navigator.clipboard.writeText('$texto');");     

                TToast::show('success', "Mensagem copiada com sucesso!", 'topRight', 'far:check-circle');  
            }

           TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onCancelar($param = null) 
    {
        try 
        {
            new TQuestion("Deseja cancelar a venda?", new TAction([__CLASS__, 'onCancelarYes'], $param), new TAction([__CLASS__, 'onCancelarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onDesfazerAtendimento($param = null) 
    {
        try 
        {
            new TQuestion("Deseja desfazer o atedimento?", new TAction([__CLASS__, 'onDesfazerAtendimentoYes'], $param), new TAction([__CLASS__, 'onDesfazerAtendimentoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onFinalizarAtendimentoYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $certvenda = CertificadoVenda::find($param['key']);     

            if($certvenda) 
            {
                //fazendo validações...
                if ($certvenda->data_vencimento_certificado==null)
                {
                   throw new Exception("Informe a data de vencimento do certificado!");  
                }  

                if ($certvenda->data_emissao==null)
                {
                   throw new Exception("Informe a data de emissão do certificado!");  
                }                  

                if ($certvenda->protocolo_emissao==null)
                {
                   throw new Exception("Informe o protocolo de emissão!");  
                }                  

                $listacertformapgto = CertificadoVendaFormapgto::where('certificado_venda_id', '=', $certvenda->id)->load();

                if ($certvenda->parceiro_id != null) 
                {
                    if ((!$listacertformapgto) && ($certvenda->certificado_tipo_repasse_id==CertificadoTipoRepasse::PrePago))
                    {
                       throw new Exception("Forma de pagamento não informada!");  
                    }                      
                }

                if (!$listacertformapgto && $certvenda->parceiro_id == null)
                {
                   throw new Exception("Forma de pagamento não informada!");  
                }

                //recalculando o vencimento do certificado...
                $certificadora_produto = CertificadoraProdutos::where('produto_id', '=', $certvenda->produto_id)
                                                               ->where('certificadora_id', '=', $certvenda->certificadora_id)->first();                   
                if ($certificadora_produto)
                {
                    $data_vencimento = new DateTime($certvenda->data_emissao);
                    $data_vencimento->modify( '+ '.$certificadora_produto->qtde_dias_vencimento.' days' );  
                    $certvenda->data_vencimento_certificado = $data_vencimento->format('Y-m-d');
                }

                $certvenda->certificado_venda_situacao_id=CertificadoVendaSituacao::Atendido;
                $certvenda->store();

                //salvando o historico na tabela de certificado cliente
                $certificadocliente = new CertificadoCliente;
                $certificadocliente->cliente_id                       = $certvenda->cliente_id;
                $certificadocliente->parceiro_id                      = $certvenda->parceiro_id;
                $certificadocliente->produto_id                       = $certvenda->produto_id;
                $certificadocliente->data_vencimento_certificado      = $certvenda->data_vencimento_certificado;                
                $certificadocliente->certificado_venda_id             = $certvenda->id;                                
                $certificadocliente->certificado_cliente_situacao_id  = CertificadoClienteSituacao::AguardandoRenovacao;                                                
                $certificadocliente->store();
            }

            TTransaction::close();

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               CertificadoVenda::Evento_VendaCertificadoFinalizada,
                                               $certvenda,
                                               'Venda de certificado cliente '.$certvenda->cliente->nome.' , '.
                                               'Produto: '.$certvenda->produto->nome.' , '.
                                               'Valor: R$ '.number_format($certvenda->valor_total,2, ',', '.').' , '.
                                               'Data emissão: '.TDate::date2br($certvenda->data_emissao).' , '.
                                               'Protocolo: '.$certvenda->protocolo_emissao); 
            TTransaction::close();                

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $certvenda->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onFinalizarAtendimentoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $certvenda = CertificadoVenda::find($param['key']);     

            if($certvenda) 
            {
                $certvenda->certificado_venda_situacao_id=CertificadoVendaSituacao::Cancelado;
                $certvenda->store();
            }

            TTransaction::close();

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               CertificadoVenda::Evento_VendaCertificadoCancelada,
                                               $certvenda,
                                               'Venda de certificado cliente '.$certvenda->cliente->nome.' , '.
                                               'Produto: '.$certvenda->produto->nome.' , '.
                                               'Valor: R$ '.number_format($certvenda->valor_total,2, ',', '.')); 
            TTransaction::close();                

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $certvenda->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarNo($param = null) 
    {
        try 
        {

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onDesfazerAtendimentoYes($param = null) 
    {
        try 
        {

            //validando a permissão...
            SystemProgramPermissoes::ValidaPermissaoEspecial('CertificadoVendaFormView',
                                                             CertificadoVenda::Permissao_DesfazerAtendimento,
                                                             TSession::getValue('userid'),
                                                             TSession::getValue('userunitid'));            

            TTransaction::open(self::$database);

            $certvenda = CertificadoVenda::find($param['key']);     

            if($certvenda) 
            {
                $certvenda->certificado_venda_situacao_id=CertificadoVendaSituacao::AguardandoAtendimento;
                $certvenda->store();

                //deletando o registro do certificado do cliente...
                $certificadocliente = CertificadoCliente::where('certificado_venda_id', '=', $certvenda->id)->first();

                if ($certificadocliente)
                {
                    $certificadocliente->delete();
                }
            }

            TTransaction::close();

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               CertificadoVenda::Evento_VendaCertificadoDesfeita,
                                               $certvenda,
                                               'Venda de certificado cliente '.$certvenda->cliente->nome.' , '.
                                               'Produto: '.$certvenda->produto->nome.' , '.
                                               'Valor: R$ '.number_format($certvenda->valor_total,2, ',', '.')); 
            TTransaction::close();                   

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $certvenda->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onDesfazerAtendimentoNo($param = null) 
    {
        try 
        {

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onAguardandoAprovacaoYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $certvenda = CertificadoVenda::find($param['key']);     

            if($certvenda) 
            {
                $certvenda->certificado_venda_situacao_id=CertificadoVendaSituacao::AguardandoAprovacao;
                $certvenda->store();
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $certvenda->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onAguardandoAprovacaoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

