<?php

class CertificadoraForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Certificadora';
    private static $primaryKey = 'id';
    private static $formName = 'form_CertificadoraForm';

    use BuilderMasterDetailFieldListTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de certificadora");


        $id = new TEntry('id');
        $nome = new TEntry('nome');
        $texto_emissao = new TText('texto_emissao');
        $certificadora_produtos_certificadora_id = new THidden('certificadora_produtos_certificadora_id[]');
        $certificadora_produtos_certificadora___row__id = new THidden('certificadora_produtos_certificadora___row__id[]');
        $certificadora_produtos_certificadora___row__data = new THidden('certificadora_produtos_certificadora___row__data[]');
        $certificadora_produtos_certificadora_produto_id = new TDBCombo('certificadora_produtos_certificadora_produto_id[]', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc'  );
        $certificadora_produtos_certificadora_valor_custo = new TNumeric('certificadora_produtos_certificadora_valor_custo[]', '2', ',', '.' );
        $certificadora_produtos_certificadora_qtde_dias_vencimento = new TEntry('certificadora_produtos_certificadora_qtde_dias_vencimento[]');
        $this->fieldList_64107c1f7d69d = new TFieldList();
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $this->fieldList_64107c1f7d69d->addField(null, $certificadora_produtos_certificadora_id, []);
        $this->fieldList_64107c1f7d69d->addField(null, $certificadora_produtos_certificadora___row__id, ['uniqid' => true]);
        $this->fieldList_64107c1f7d69d->addField(null, $certificadora_produtos_certificadora___row__data, []);
        $this->fieldList_64107c1f7d69d->addField(new TLabel("Produto", null, '14px', null), $certificadora_produtos_certificadora_produto_id, ['width' => '50%']);
        $this->fieldList_64107c1f7d69d->addField(new TLabel("Valor Custo", null, '14px', null), $certificadora_produtos_certificadora_valor_custo, ['width' => '50%']);
        $this->fieldList_64107c1f7d69d->addField(new TLabel("Qtde. Dias Vencimento Certificado", null, '14px', null), $certificadora_produtos_certificadora_qtde_dias_vencimento, ['width' => '100%']);

        $this->fieldList_64107c1f7d69d->width = '100%';
        $this->fieldList_64107c1f7d69d->setFieldPrefix('certificadora_produtos_certificadora');
        $this->fieldList_64107c1f7d69d->name = 'fieldList_64107c1f7d69d';

        $this->criteria_fieldList_64107c1f7d69d = new TCriteria();
        $this->default_item_fieldList_64107c1f7d69d = new stdClass();

        $this->form->addField($certificadora_produtos_certificadora_id);
        $this->form->addField($certificadora_produtos_certificadora___row__id);
        $this->form->addField($certificadora_produtos_certificadora___row__data);
        $this->form->addField($certificadora_produtos_certificadora_produto_id);
        $this->form->addField($certificadora_produtos_certificadora_valor_custo);
        $this->form->addField($certificadora_produtos_certificadora_qtde_dias_vencimento);

        $this->fieldList_64107c1f7d69d->setRemoveAction(null, 'fas:times #dd5a43', "Excluír");

        $nome->addValidation("Nome", new TRequiredValidator()); 
        $certificadora_produtos_certificadora_produto_id->addValidation("Produto id", new TRequiredListValidator()); 

        $certificadora_produtos_certificadora_produto_id->enableSearch();
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $nome->setSize('100%');
        $alterado_em->setSize(150);
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_por->setSize('100%');
        $texto_emissao->setSize('100%', 200);
        $certificadora_produtos_certificadora_produto_id->setSize('100%');
        $certificadora_produtos_certificadora_valor_custo->setSize('100%');
        $certificadora_produtos_certificadora_qtde_dias_vencimento->setSize('100%');

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id]);
        $row1->layout = ['col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Mensagem de envio do protocolo:", null, '14px', null),$texto_emissao,new TLabel("Informe as tags {protocolo_emissao}, {cliente_nome}, {cliente_cpf_cnpj}, {produto_nome} no texto para ele trocar pelos respectivos campos  quando gerar o texto", '#F44336', '12px', 'I')]);
        $row3->layout = [' col-sm-12'];

        $row4 = $this->form->addContent([new TFormSeparator("Produtos", '#333', '18', '#eee')]);
        $row5 = $this->form->addFields([$this->fieldList_64107c1f7d69d]);
        $row5->layout = [' col-sm-12'];

        $bcontainer_641079b87d695 = new BContainer('bcontainer_641079b87d695');
        $this->bcontainer_641079b87d695 = $bcontainer_641079b87d695;

        $bcontainer_641079b87d695->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_641079b87d695->setBorderColor('#c0c0c0');

        $row6 = $bcontainer_641079b87d695->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row6->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row7 = $this->form->addFields([$bcontainer_641079b87d695]);
        $row7->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['CertificadoraHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Certificação Digital","Cadastro de certificadora"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Certificadora(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $certificadora_produtos_certificadora_items = $this->storeItems('CertificadoraProdutos', 'certificadora_id', $object, $this->fieldList_64107c1f7d69d, function($masterObject, $detailObject){ 

                //code here

            }, $this->criteria_fieldList_64107c1f7d69d); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('CertificadoraHeaderList', 'onShow', $loadPageParam); 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Certificadora($key); // instantiates the Active Record 

                $this->fieldList_64107c1f7d69d_items = $this->loadItems('CertificadoraProdutos', 'certificadora_id', $object, $this->fieldList_64107c1f7d69d, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }, $this->criteria_fieldList_64107c1f7d69d); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $this->fieldList_64107c1f7d69d->addHeader();
        $this->fieldList_64107c1f7d69d->addDetail($this->default_item_fieldList_64107c1f7d69d);

        $this->fieldList_64107c1f7d69d->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    }

    public function onShow($param = null)
    {
        $this->fieldList_64107c1f7d69d->addHeader();
        $this->fieldList_64107c1f7d69d->addDetail($this->default_item_fieldList_64107c1f7d69d);

        $this->fieldList_64107c1f7d69d->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

