<?php

class ParceiroForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Parceiro';
    private static $primaryKey = 'id';
    private static $formName = 'form_ParceiroForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Parceiro");


        $id = new TEntry('id');
        $cpf_cnpj = new TEntry('cpf_cnpj');
        $nome = new TEntry('nome');
        $razao_social = new TEntry('razao_social');
        $certificado_venda_modalidade_id = new TDBCombo('certificado_venda_modalidade_id', 'kraftsoft', 'CertificadoVendaModalidade', 'id', '{descricao}','descricao asc'  );
        $tabela_preco_id = new TDBCombo('tabela_preco_id', 'kraftsoft', 'TabelaPreco', 'id', '{descricao}','descricao asc'  );
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $comissao_percentual = new TNumeric('comissao_percentual', '2', ',', '.' );
        $fone = new TEntry('fone');
        $email = new TEntry('email');
        $contato = new TEntry('contato');
        $contato_fone = new TEntry('contato_fone');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $cep = new TEntry('cep');
        $logradouro = new TEntry('logradouro');
        $bairro = new TEntry('bairro');
        $cidade = new TEntry('cidade');
        $estado = new TEntry('estado');
        $banco_id = new TDBCombo('banco_id', 'kraftsoft', 'Banco', 'id', '{nome}','nome asc'  );
        $banco_agencia = new TEntry('banco_agencia');
        $banco_conta = new TEntry('banco_conta');
        $banco_cpfcnpj = new TEntry('banco_cpfcnpj');
        $banco_nome_titular = new TEntry('banco_nome_titular');
        $chave_pix_tipo_id = new TDBCombo('chave_pix_tipo_id', 'kraftsoft', 'ChavePixTipo', 'id', '{descricao}','descricao asc'  );
        $banco_chavepix = new TEntry('banco_chavepix');

        $cpf_cnpj->addValidation("CPF/CNPJ", new TRequiredValidator()); 
        $nome->addValidation("Nome", new TRequiredValidator()); 
        $certificado_venda_modalidade_id->addValidation("Certificado venda modalidade id", new TRequiredValidator()); 

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $banco_id->enableSearch();
        $vendedor_id->enableSearch();
        $tabela_preco_id->enableSearch();
        $chave_pix_tipo_id->enableSearch();
        $certificado_venda_modalidade_id->enableSearch();

        $id->setSize(100);
        $cep->setSize('100%');
        $nome->setSize('100%');
        $fone->setSize('100%');
        $email->setSize('100%');
        $bairro->setSize('100%');
        $cidade->setSize('100%');
        $estado->setSize('100%');
        $contato->setSize('100%');
        $cpf_cnpj->setSize('100%');
        $banco_id->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $logradouro->setSize('100%');
        $vendedor_id->setSize('100%');
        $alterado_em->setSize('100%');
        $banco_conta->setSize('100%');
        $razao_social->setSize('100%');
        $contato_fone->setSize('100%');
        $alterado_por->setSize('100%');
        $banco_agencia->setSize('100%');
        $banco_cpfcnpj->setSize('100%');
        $banco_chavepix->setSize('100%');
        $tabela_preco_id->setSize('100%');
        $chave_pix_tipo_id->setSize('100%');
        $banco_nome_titular->setSize('100%');
        $comissao_percentual->setSize('100%');
        $certificado_venda_modalidade_id->setSize('100%');


        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("CPF/CNPJ:", '#ff0000', '14px', null, '100%'),$cpf_cnpj]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome],[new TLabel("Razão Social:", null, '14px', null, '100%'),$razao_social]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Modalidade de Parceria:", '#ff0000', '14px', null, '100%'),$certificado_venda_modalidade_id],[new TLabel("Tabela de Preço:", null, '14px', null, '100%'),$tabela_preco_id]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id],[new TLabel("Percentual de Comissão :", null, '14px', null, '100%'),$comissao_percentual]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Fone:", null, '14px', null, '100%'),$fone],[new TLabel("E-Mail:", null, '14px', null, '100%'),$email]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Contato:", null, '14px', null, '100%'),$contato],[new TLabel("Fone Contato:", null, '14px', null, '100%'),$contato_fone]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_630e9f55f9f11 = new BContainer('bcontainer_630e9f55f9f11');
        $this->bcontainer_630e9f55f9f11 = $bcontainer_630e9f55f9f11;

        $bcontainer_630e9f55f9f11->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_630e9f55f9f11->setBorderColor('#c0c0c0');

        $row7 = $bcontainer_630e9f55f9f11->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row7->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row8 = $this->form->addFields([$bcontainer_630e9f55f9f11]);
        $row8->layout = [' col-sm-12'];

        $this->form->appendPage("Endereço");
        $row9 = $this->form->addFields([new TLabel("CEP:", null, '14px', null, '100%'),$cep]);
        $row9->layout = ['col-sm-6'];

        $row10 = $this->form->addFields([new TLabel("Logradouro:", null, '14px', null, '100%'),$logradouro],[new TLabel("Bairro:", null, '14px', null, '100%'),$bairro]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->form->addFields([new TLabel("Cidade:", null, '14px', null, '100%'),$cidade],[new TLabel("Estado:", null, '14px', null, '100%'),$estado]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("Dados Bancários");
        $row12 = $this->form->addFields([new TLabel("Banco:", null, '14px', null),$banco_id]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->form->addFields([new TLabel("Agência:", null, '14px', null),$banco_agencia],[new TLabel("Conta:", null, '14px', null),$banco_conta]);
        $row13->layout = [' col-sm-6',' col-sm-6'];

        $row14 = $this->form->addFields([new TLabel("CPF/CNPJ:", null, '14px', null),$banco_cpfcnpj],[new TLabel("Nome Titular:", null, '14px', null),$banco_nome_titular]);
        $row14->layout = [' col-sm-6',' col-sm-6'];

        $row15 = $this->form->addFields([new TLabel("Tipo Chave PIX:", null, '14px', null),$chave_pix_tipo_id],[new TLabel("Chave PIX:", null, '14px', null),$banco_chavepix]);
        $row15->layout = [' col-sm-6',' col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ParceiroList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Certificação Digital","Cadastro de Parceiro"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Parceiro(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ParceiroList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Parceiro($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

