<?php

class ClienteClassificacaoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ClienteClassificacao';
    private static $primaryKey = 'id';
    private static $formName = 'form_ClienteClassificacaoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de classificação de cliente ");


        $descricao = new TEntry('descricao');
        $id = new THidden('id');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $cliente_classificacao_subgrupo_cliente_classificacao_descricao = new TEntry('cliente_classificacao_subgrupo_cliente_classificacao_descricao');
        $cliente_classificacao_subgrupo_cliente_classificacao_id = new THidden('cliente_classificacao_subgrupo_cliente_classificacao_id');
        $button_adicionar_cliente_classificacao_subgrupo_cliente_classificacao = new TButton('button_adicionar_cliente_classificacao_subgrupo_cliente_classificacao');

        $descricao->addValidation("Descrição", new TRequiredValidator()); 

        $button_adicionar_cliente_classificacao_subgrupo_cliente_classificacao->setAction(new TAction([$this, 'onAddDetailClienteClassificacaoSubgrupoClienteClassificacao'],['static' => 1]), "Adicionar");
        $button_adicionar_cliente_classificacao_subgrupo_cliente_classificacao->addStyleClass('btn-default');
        $button_adicionar_cliente_classificacao_subgrupo_cliente_classificacao->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(200);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $cliente_classificacao_subgrupo_cliente_classificacao_id->setSize(200);
        $cliente_classificacao_subgrupo_cliente_classificacao_descricao->setSize('100%');

        $button_adicionar_cliente_classificacao_subgrupo_cliente_classificacao->id = '61732e4373fbb';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao,$id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Criado em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null),$criado_por],[new TLabel("Alterado em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null),$alterado_por]);
        $row2->layout = ['col-sm-2','col-sm-4','col-sm-2','col-sm-4'];

        $this->form->appendPage("Sub-Grupos");

        $this->detailFormClienteClassificacaoSubgrupoClienteClassificacao = new BootstrapFormBuilder('detailFormClienteClassificacaoSubgrupoClienteClassificacao');
        $this->detailFormClienteClassificacaoSubgrupoClienteClassificacao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormClienteClassificacaoSubgrupoClienteClassificacao->setProperty('class', 'form-horizontal builder-detail-form');

        $row3 = $this->detailFormClienteClassificacaoSubgrupoClienteClassificacao->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$cliente_classificacao_subgrupo_cliente_classificacao_descricao,$cliente_classificacao_subgrupo_cliente_classificacao_id]);
        $row3->layout = [' col-sm-12'];

        $row4 = $this->detailFormClienteClassificacaoSubgrupoClienteClassificacao->addFields([$button_adicionar_cliente_classificacao_subgrupo_cliente_classificacao]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->detailFormClienteClassificacaoSubgrupoClienteClassificacao->addFields([new THidden('cliente_classificacao_subgrupo_cliente_classificacao__row__id')]);
        $this->cliente_classificacao_subgrupo_cliente_classificacao_criteria = new TCriteria();

        $this->cliente_classificacao_subgrupo_cliente_classificacao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->disableHtmlConversion();;
        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->generateHiddenFields();
        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->setId('cliente_classificacao_subgrupo_cliente_classificacao_list');

        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->style = 'width:100%';
        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->class .= ' table-bordered';

        $column_cliente_classificacao_subgrupo_cliente_classificacao_descricao = new TDataGridColumn('descricao', "Descrição", 'left');
        $column_cliente_classificacao_subgrupo_cliente_classificacao_criado_em_transformed = new TDataGridColumn('criado_em', "Criado em", 'left');
        $column_cliente_classificacao_subgrupo_cliente_classificacao_alterado_em_transformed = new TDataGridColumn('alterado_em', "Alterado em", 'left');

        $column_cliente_classificacao_subgrupo_cliente_classificacao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_cliente_classificacao_subgrupo_cliente_classificacao__row__data->setVisibility(false);

        $action_onEditDetailClienteClassificacaoSubgrupo = new TDataGridAction(array('ClienteClassificacaoForm', 'onEditDetailClienteClassificacaoSubgrupo'));
        $action_onEditDetailClienteClassificacaoSubgrupo->setUseButton(false);
        $action_onEditDetailClienteClassificacaoSubgrupo->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailClienteClassificacaoSubgrupo->setLabel("Editar");
        $action_onEditDetailClienteClassificacaoSubgrupo->setImage('far:edit #478fca');
        $action_onEditDetailClienteClassificacaoSubgrupo->setFields(['__row__id', '__row__data']);

        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->addAction($action_onEditDetailClienteClassificacaoSubgrupo);
        $action_onDeleteDetailClienteClassificacaoSubgrupo = new TDataGridAction(array('ClienteClassificacaoForm', 'onDeleteDetailClienteClassificacaoSubgrupo'));
        $action_onDeleteDetailClienteClassificacaoSubgrupo->setUseButton(false);
        $action_onDeleteDetailClienteClassificacaoSubgrupo->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailClienteClassificacaoSubgrupo->setLabel("Excluir");
        $action_onDeleteDetailClienteClassificacaoSubgrupo->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailClienteClassificacaoSubgrupo->setFields(['__row__id', '__row__data']);

        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->addAction($action_onDeleteDetailClienteClassificacaoSubgrupo);

        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->addColumn($column_cliente_classificacao_subgrupo_cliente_classificacao_descricao);
        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->addColumn($column_cliente_classificacao_subgrupo_cliente_classificacao_criado_em_transformed);
        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->addColumn($column_cliente_classificacao_subgrupo_cliente_classificacao_alterado_em_transformed);

        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->addColumn($column_cliente_classificacao_subgrupo_cliente_classificacao__row__data);

        $this->cliente_classificacao_subgrupo_cliente_classificacao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->cliente_classificacao_subgrupo_cliente_classificacao_list);
        $this->detailFormClienteClassificacaoSubgrupoClienteClassificacao->addContent([$tableResponsiveDiv]);

        $column_cliente_classificacao_subgrupo_cliente_classificacao_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_cliente_classificacao_subgrupo_cliente_classificacao_alterado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });        $row6 = $this->form->addFields([$this->detailFormClienteClassificacaoSubgrupoClienteClassificacao]);
        $row6->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ClienteClassificacaoHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Cliente","Cadastro de classificação de cliente "]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailClienteClassificacaoSubgrupoClienteClassificacao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Descrição", 'name'=>"cliente_classificacao_subgrupo_cliente_classificacao_descricao", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->cliente_classificacao_subgrupo_cliente_classificacao__row__id) ? $data->cliente_classificacao_subgrupo_cliente_classificacao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ClienteClassificacaoSubgrupo();
            $grid_data->__row__id = $__row__id;
            $grid_data->descricao = $data->cliente_classificacao_subgrupo_cliente_classificacao_descricao;
            $grid_data->id = $data->cliente_classificacao_subgrupo_cliente_classificacao_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['descricao'] =  $param['cliente_classificacao_subgrupo_cliente_classificacao_descricao'] ?? null;
            $__row__data['__display__']['id'] =  $param['cliente_classificacao_subgrupo_cliente_classificacao_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->cliente_classificacao_subgrupo_cliente_classificacao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('cliente_classificacao_subgrupo_cliente_classificacao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->cliente_classificacao_subgrupo_cliente_classificacao_descricao = '';
            $data->cliente_classificacao_subgrupo_cliente_classificacao_id = '';
            $data->cliente_classificacao_subgrupo_cliente_classificacao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61732e4373fbb');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailClienteClassificacaoSubgrupo($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->cliente_classificacao_subgrupo_cliente_classificacao_descricao = $__row__data->__display__->descricao ?? null;
            $data->cliente_classificacao_subgrupo_cliente_classificacao_id = $__row__data->__display__->id ?? null;
            $data->cliente_classificacao_subgrupo_cliente_classificacao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61732e4373fbb');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailClienteClassificacaoSubgrupo($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->cliente_classificacao_subgrupo_cliente_classificacao_descricao = '';
            $data->cliente_classificacao_subgrupo_cliente_classificacao_id = '';
            $data->cliente_classificacao_subgrupo_cliente_classificacao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('cliente_classificacao_subgrupo_cliente_classificacao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ClienteClassificacao(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);
            $object->ativo_id = Ativo::Ativo;

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $cliente_classificacao_subgrupo_cliente_classificacao_items = $this->storeMasterDetailItems('ClienteClassificacaoSubgrupo', 'cliente_classificacao_id', 'cliente_classificacao_subgrupo_cliente_classificacao', $object, $param['cliente_classificacao_subgrupo_cliente_classificacao_list___row__data'] ?? [], $this->form, $this->cliente_classificacao_subgrupo_cliente_classificacao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->cliente_classificacao_subgrupo_cliente_classificacao_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ClienteClassificacaoHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ClienteClassificacao($key); // instantiates the Active Record 

                $cliente_classificacao_subgrupo_cliente_classificacao_items = $this->loadMasterDetailItems('ClienteClassificacaoSubgrupo', 'cliente_classificacao_id', 'cliente_classificacao_subgrupo_cliente_classificacao', $object, $this->form, $this->cliente_classificacao_subgrupo_cliente_classificacao_list, $this->cliente_classificacao_subgrupo_cliente_classificacao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

