<?php

class ClienteEspelhoFinanceiro extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Cliente';
    private static $primaryKey = 'id';
    private static $formName = 'form_ClienteEspelhoFinanceiro';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Espelho Financeiro de Cliente");

        $criteria_vendas_quantidade = new TCriteria();
        $criteria_vendas_valortotal = new TCriteria();
        $criteria_vendas_valormaior = new TCriteria();
        $criteria_vendas_datamaior = new TCriteria();
        $criteria_vendas_dataultima = new TCriteria();

        if(!empty($param["key"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_id', $param["key"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_id');
        $criteria_vendas_quantidade->add(new TFilter('cliente.id', '=', $filterVar)); 
        if(!empty($param["key"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_id', $param["key"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_id');
        $criteria_vendas_valortotal->add(new TFilter('cliente.id', '=', $filterVar)); 
        if(!empty($param["key"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_id', $param["key"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_id');
        $criteria_vendas_valormaior->add(new TFilter('cliente.id', '=', $filterVar)); 
        if(!empty($param["key"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_id', $param["key"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_id');
        $criteria_vendas_datamaior->add(new TFilter('cliente.id', '=', $filterVar)); 
        if(!empty($param["key"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_id', $param["key"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_id');
        $criteria_vendas_dataultima->add(new TFilter('cliente.id', '=', $filterVar)); 

        TSession::setValue('cliente_id',$param['key']);    

        $id = new TEntry('id');
        $pessoa_tipo_id = new TDBCombo('pessoa_tipo_id', 'kraftsoft', 'PessoaTipo', 'id', '{descricao}','descricao asc'  );
        $nome = new TEntry('nome');
        $cpf_cnpj = new TEntry('cpf_cnpj');
        $rg = new TEntry('rg');
        $limite_credito = new TNumeric('limite_credito', '2', ',', '.' );
        $limite_utilizado = new TNumeric('limite_utilizado', '2', ',', '.' );
        $limite_disponivel = new TNumeric('limite_disponivel', '2', ',', '.' );
        $limite_vencido = new TNumeric('limite_vencido', '2', ',', '.' );
        $vendas_quantidade = new BIndicator('vendas_quantidade');
        $vendas_valortotal = new BIndicator('vendas_valortotal');
        $vendas_valormaior = new BIndicator('vendas_valormaior');
        $vendas_datamaior = new BIndicator('vendas_datamaior');
        $vendas_dataultima = new BIndicator('vendas_dataultima');
        $bpage_clientevendalist = new BPageContainer();
        $bpage_clientecontasreclist = new BPageContainer();
        $bpc_historico_limite = new BPageContainer();
        $cobranca_fones = new TEntry('cobranca_fones');
        $cliente_situacao_id = new TDBCombo('cliente_situacao_id', 'kraftsoft', 'ClienteSituacao', 'id', '{descricao}','descricao asc'  );
        $observacoes_financeiro = new TText('observacoes_financeiro');

        $pessoa_tipo_id->addValidation("Pessoa tipo id", new TRequiredValidator()); 
        $nome->addValidation("Nome", new TRequiredValidator()); 
        $cliente_situacao_id->addValidation("Cliente situacao id", new TRequiredValidator()); 

        $pessoa_tipo_id->enableSearch();
        $cliente_situacao_id->enableSearch();

        $bpage_clientevendalist->setAction(new TAction(['ClienteVendaList', 'onShow'], $param));
        $bpage_clientecontasreclist->setAction(new TAction(['ClienteContasrecList', 'onShow'], $param));
        $bpc_historico_limite->setAction(new TAction(['ClienteHistoricoLimiteHeaderList', 'onShow'], $param));

        $bpc_historico_limite->setId('b63fa36df8bb05');
        $bpage_clientevendalist->setId('b63a8bad478ba5');
        $bpage_clientecontasreclist->setId('b63a970777852d');

        $id->setEditable(false);
        $rg->setEditable(false);
        $nome->setEditable(false);
        $cpf_cnpj->setEditable(false);
        $pessoa_tipo_id->setEditable(false);
        $limite_credito->setEditable(false);
        $limite_vencido->setEditable(false);
        $limite_utilizado->setEditable(false);
        $limite_disponivel->setEditable(false);

        $id->setSize(100);
        $rg->setSize('100%');
        $nome->setSize('100%');
        $cpf_cnpj->setSize('100%');
        $pessoa_tipo_id->setSize('100%');
        $limite_credito->setSize('100%');
        $limite_vencido->setSize('100%');
        $cobranca_fones->setSize('100%');
        $limite_utilizado->setSize('100%');
        $limite_disponivel->setSize('100%');
        $cliente_situacao_id->setSize('100%');
        $bpc_historico_limite->setSize('100%');
        $bpage_clientevendalist->setSize('100%');
        $bpage_clientecontasreclist->setSize('100%');
        $observacoes_financeiro->setSize('100%', 70);

        $vendas_quantidade->setDatabase('kraftsoft');
        $vendas_quantidade->setFieldValue("cliente.vendas_quantidade");
        $vendas_quantidade->setModel('Cliente');
        $vendas_quantidade->setTotal('sum');
        $vendas_quantidade->setColors('#16A085', '#ffffff', '#1ABC9C', '#ffffff');
        $vendas_quantidade->setTitle("Quantidade de Vendas", '#ffffff', '18', '');
        $vendas_quantidade->setCriteria($criteria_vendas_quantidade);
        $vendas_quantidade->setValueSize("30");
        $vendas_quantidade->setValueColor("#ffffff", 'B');
        $vendas_quantidade->setSize('100%', 95);
        $vendas_quantidade->setLayout('vertical', 'center');

        $vendas_valortotal->setDatabase('kraftsoft');
        $vendas_valortotal->setFieldValue("cliente.vendas_valortotal");
        $vendas_valortotal->setModel('Cliente');
        $vendas_valortotal->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $vendas_valortotal->setTotal('sum');
        $vendas_valortotal->setColors('#27AE60', '#FFFFFF', '#2ECC71', '#FFFFFF');
        $vendas_valortotal->setTitle("Valor total em vendas", '#FFFFFF', '18', '');
        $vendas_valortotal->setCriteria($criteria_vendas_valortotal);
        $vendas_valortotal->setValueSize("30");
        $vendas_valortotal->setValueColor("#FFFFFF", 'B');
        $vendas_valortotal->setSize('100%', 95);
        $vendas_valortotal->setLayout('vertical', 'center');

        $vendas_valormaior->setDatabase('kraftsoft');
        $vendas_valormaior->setFieldValue("cliente.vendas_valormaior");
        $vendas_valormaior->setModel('Cliente');
        $vendas_valormaior->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $vendas_valormaior->setTotal('sum');
        $vendas_valormaior->setColors('#3498DB', '#FFFFFF', '#2980B9', '#FFFFFF');
        $vendas_valormaior->setTitle("Valor da maior venda", '#FFFFFF', '18', '');
        $vendas_valormaior->setCriteria($criteria_vendas_valormaior);
        $vendas_valormaior->setValueSize("30");
        $vendas_valormaior->setValueColor("#FFFFFF", 'B');
        $vendas_valormaior->setSize('100%', 95);
        $vendas_valormaior->setLayout('vertical', 'center');

        $vendas_datamaior->setDatabase('kraftsoft');
        $vendas_datamaior->setFieldValue("cliente.vendas_datamaior");
        $vendas_datamaior->setModel('Cliente');
        $vendas_datamaior->setTransformerValue(function($value)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });
        $vendas_datamaior->setTotal('max');
        $vendas_datamaior->setColors('#2980B9', '#FFFFFF', '#3498DB', '#FFFFFF');
        $vendas_datamaior->setTitle("Data da maior venda", '#FFFFFF', '18', '');
        $vendas_datamaior->setCriteria($criteria_vendas_datamaior);
        $vendas_datamaior->setValueSize("30");
        $vendas_datamaior->setValueColor("#FFFFFF", 'B');
        $vendas_datamaior->setSize('100%', 95);
        $vendas_datamaior->setLayout('vertical', 'center');

        $vendas_dataultima->setDatabase('kraftsoft');
        $vendas_dataultima->setFieldValue("cliente.vendas_dataultima");
        $vendas_dataultima->setModel('Cliente');
        $vendas_dataultima->setTransformerValue(function($value)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });
        $vendas_dataultima->setTotal('max');
        $vendas_dataultima->setColors('#9B59B6', '#FFFFFF', '#8E44AD', '#FFFFFF');
        $vendas_dataultima->setTitle("Data ultima venda", '#FFFFFF', '18', '');
        $vendas_dataultima->setCriteria($criteria_vendas_dataultima);
        $vendas_dataultima->setValueSize("30");
        $vendas_dataultima->setValueColor("#FFFFFF", 'B');
        $vendas_dataultima->setSize('100%', 95);
        $vendas_dataultima->setLayout('vertical', 'center');

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpage_clientevendalist->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpage_clientecontasreclist->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_historico_limite->add($loadingContainer);

        $this->bpage_clientevendalist = $bpage_clientevendalist;
        $this->bpage_clientecontasreclist = $bpage_clientecontasreclist;
        $this->bpc_historico_limite = $bpc_historico_limite;

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Tipo Pessoa:", '#000000', '14px', null, '100%'),$pessoa_tipo_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Nome:", '#000000', '14px', null, '100%'),$nome],[]);
        $row2->layout = [' col-sm-6',' col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("CPF/CNPJ:", null, '14px', null, '100%'),$cpf_cnpj],[new TLabel("RG:", null, '14px', null, '100%'),$rg]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Limite de Crédito:", null, '14px', null, '100%'),$limite_credito],[new TLabel("Limite Utilizado:", null, '14px', null, '100%'),$limite_utilizado],[new TLabel("Limite Disponível:", null, '14px', null, '100%'),$limite_disponivel],[new TLabel("Limite Vencido:", null, '14px', null, '100%'),$limite_vencido]);
        $row4->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row5 = $this->form->addFields([$vendas_quantidade],[$vendas_valortotal]);
        $row5->layout = [' col-sm-6',' col-sm-6'];

        $row6 = $this->form->addFields([$vendas_valormaior],[$vendas_datamaior],[$vendas_dataultima]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $tab_vendas = new BootstrapFormBuilder('tab_vendas');
        $this->tab_vendas = $tab_vendas;
        $tab_vendas->setProperty('style', 'border:none; box-shadow:none;');

        $tab_vendas->appendPage("Vendas");

        $tab_vendas->addFields([new THidden('current_tab_tab_vendas')]);
        $tab_vendas->setTabFunction("$('[name=current_tab_tab_vendas]').val($(this).attr('data-current_page'));");

        $row7 = $tab_vendas->addFields([$bpage_clientevendalist]);
        $row7->layout = [' col-sm-12'];

        $tab_vendas->appendPage("Contas a Receber");
        $row8 = $tab_vendas->addFields([$bpage_clientecontasreclist]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addFields([$tab_vendas]);
        $row9->layout = [' col-sm-12'];

        $row10 = $this->form->addFields([$bpc_historico_limite]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->form->addFields([new TLabel("Fones Cobrança:", null, '14px', null, '100%'),$cobranca_fones],[new TLabel("Situação:", '#ff0000', '14px', null, '100%'),$cliente_situacao_id]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->form->addFields([new TLabel("Observacoes financeiro:", null, '14px', null, '100%'),$observacoes_financeiro]);
        $row12->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ClienteEspelhoFinanceiro]');
        $style->width = '90% !important';   
        $style->show(true);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Cliente(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->store(); // save the object 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            new TMessage('info', "Registro salvo", $messageAction); 

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Cliente($key); // instantiates the Active Record 

                                $this->bpage_clientevendalist->setParameter('key', $object->id);
                $this->bpage_clientecontasreclist->setParameter('key', $object->id);
                $this->bpc_historico_limite->setParameter('cliente_id', $object->id);

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

