<?php

class ClienteForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Cliente';
    private static $primaryKey = 'id';
    private static $formName = 'form_ClienteForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de cliente");


        $id = new TEntry('id');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $bhelper_61fa8bf5b958d = new BHelper();
        $cliente_classificacao_id = new TDBCombo('cliente_classificacao_id', 'kraftsoft', 'ClienteClassificacao', 'id', '{descricao}','descricao asc'  );
        $cliente_classificacao_subgrupo_id = new TCombo('cliente_classificacao_subgrupo_id');
        $nome = new TEntry('nome');
        $razao_social = new TEntry('razao_social');
        $pessoa_tipo_id = new TDBCombo('pessoa_tipo_id', 'kraftsoft', 'PessoaTipo', 'id', '{descricao}','descricao asc'  );
        $cpf_cnpj = new TEntry('cpf_cnpj');
        $button_ = new TButton('button_');
        $bhelper_61fc7b55d4ecf = new BHelper();
        $rg = new TEntry('rg');
        $cliente_exterior = new TRadioGroup('cliente_exterior');
        $insc_municipal = new TEntry('insc_municipal');
        $insc_estadual = new TEntry('insc_estadual');
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $data_nascimento = new TDate('data_nascimento');
        $fone = new TEntry('fone');
        $email = new TEntry('email');
        $notafiscal_crt_id = new TDBCombo('notafiscal_crt_id', 'kraftsoft', 'NotafiscalCrt', 'id', '{descricao}','descricao asc'  );
        $notafiscal_indiedest_id = new TDBCombo('notafiscal_indiedest_id', 'kraftsoft', 'NotafiscalIndiedest', 'id', '{descricao}','descricao asc'  );
        $observacoes = new TText('observacoes');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $cliente_endereco_cliente_cep = new TEntry('cliente_endereco_cliente_cep');
        $button_buscar_cep_cliente_endereco_cliente = new TButton('button_buscar_cep_cliente_endereco_cliente');
        $cliente_endereco_cliente_id = new THidden('cliente_endereco_cliente_id');
        $cliente_endereco_cliente_logradouro = new TEntry('cliente_endereco_cliente_logradouro');
        $cliente_endereco_cliente_cidade_estado_id = new TDBCombo('cliente_endereco_cliente_cidade_estado_id', 'kraftsoft', 'Estado', 'id', '{sigla}','id asc'  );
        $cliente_endereco_cliente_cidade_id = new TCombo('cliente_endereco_cliente_cidade_id');
        $cliente_endereco_cliente_bairro = new TEntry('cliente_endereco_cliente_bairro');
        $cliente_endereco_cliente_numero = new TEntry('cliente_endereco_cliente_numero');
        $cliente_endereco_cliente_complemento = new TEntry('cliente_endereco_cliente_complemento');
        $cliente_endereco_cliente_principal = new TDBCombo('cliente_endereco_cliente_principal', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $cliente_endereco_cliente_codigo_ibge = new TEntry('cliente_endereco_cliente_codigo_ibge');
        $cliente_endereco_cliente_ibge_estado = new TEntry('cliente_endereco_cliente_ibge_estado');
        $button_adicionar_cliente_endereco_cliente = new TButton('button_adicionar_cliente_endereco_cliente');
        $utilizar_endereco_cobranca = new TDBCombo('utilizar_endereco_cobranca', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $cobranca_cnpj = new TEntry('cobranca_cnpj');
        $cobranca_nome = new TEntry('cobranca_nome');
        $cobranca_cep = new TEntry('cobranca_cep');
        $cobranca_endereco = new TEntry('cobranca_endereco');
        $cobranca_bairro = new TEntry('cobranca_bairro');
        $cobranca_uf = new TEntry('cobranca_uf');
        $cobranca_cidade = new TEntry('cobranca_cidade');
        $cobranca_fones = new TEntry('cobranca_fones');
        $conjuge = new TEntry('conjuge');
        $conjuge_cpf = new TEntry('conjuge_cpf');
        $nome_pai = new TEntry('nome_pai');
        $nome_mae = new TEntry('nome_mae');
        $local_trabalho = new TEntry('local_trabalho');
        $renda = new TNumeric('renda', '2', ',', '.' );
        $tempo_trabalho = new TEntry('tempo_trabalho');
        $residencia_propria = new TDBCombo('residencia_propria', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $cliente_contato_cliente_tipo_contato = new TEntry('cliente_contato_cliente_tipo_contato');
        $cliente_contato_cliente_id = new THidden('cliente_contato_cliente_id');
        $cliente_contato_cliente_nome = new TEntry('cliente_contato_cliente_nome');
        $cliente_contato_cliente_fone = new TEntry('cliente_contato_cliente_fone');
        $button_adicionar_cliente_contato_cliente = new TButton('button_adicionar_cliente_contato_cliente');
        $tabela_preco_id = new TDBCombo('tabela_preco_id', 'kraftsoft', 'TabelaPreco', 'id', '{descricao}','descricao asc'  );

        $cliente_classificacao_id->setChangeAction(new TAction([$this,'onChangecliente_classificacao_id']));
        $cliente_endereco_cliente_cidade_estado_id->setChangeAction(new TAction([$this,'onChangecliente_endereco_cliente_cidade_estado_id']));
        $pessoa_tipo_id->setChangeAction(new TAction([$this,'OnChangePessoaTipo']));

        $system_unit_id->addValidation("Filial de Origem", new TRequiredValidator()); 
        $cliente_classificacao_id->addValidation("Classificação", new TRequiredValidator()); 
        $nome->addValidation("Nome", new TRequiredValidator()); 
        $pessoa_tipo_id->addValidation("Tipo Pessoa", new TRequiredValidator()); 
        $notafiscal_indiedest_id->addValidation("Contribuinte Fiscal", new TRequiredValidator()); 
        $utilizar_endereco_cobranca->addValidation("Utilizar Endereço de Cobrança", new TRequiredValidator()); 

        $cliente_exterior->addItems(["S"=>"Sim","N"=>"Não"]);
        $cliente_exterior->setLayout('horizontal');
        $cliente_exterior->setUseButton();
        $bhelper_61fa8bf5b958d->enableHover();
        $bhelper_61fc7b55d4ecf->enableHover();

        $bhelper_61fa8bf5b958d->setSide("top");
        $bhelper_61fc7b55d4ecf->setSide("top");

        $bhelper_61fa8bf5b958d->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_61fc7b55d4ecf->setIcon(new TImage("fas:question #2196F3"));

        $bhelper_61fc7b55d4ecf->setTitle("CPF/CNPJ");
        $bhelper_61fa8bf5b958d->setTitle("Classificação de Clientes");

        $bhelper_61fc7b55d4ecf->setContent("Informe o CNPJ ou CNPJ sem pontos ou barras");
        $bhelper_61fa8bf5b958d->setContent("Classificação é também conhecido como grupo, ou segmentação do seu cliente. Ex: Padarias, Armazens, Etc.");

        $email->setInnerIcon(new TImage('fas:mail-bulk #000000'), 'right');
        $fone->setInnerIcon(new TImage('fas:blender-phone #000000'), 'right');

        $tabela_preco_id->enableSearch();
        $cliente_classificacao_id->enableSearch();
        $cliente_endereco_cliente_cidade_id->enableSearch();

        $data_nascimento->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $data_nascimento->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $button_->setAction(new TAction([$this, 'onConsultaCnpj']), "");
        $button_buscar_cep_cliente_endereco_cliente->setAction(new TAction([$this, 'onBuscarCEP']), "Buscar CEP");
        $button_adicionar_cliente_contato_cliente->setAction(new TAction([$this, 'onAddDetailClienteContatoCliente'],['static' => 1]), "Adicionar");
        $button_adicionar_cliente_endereco_cliente->setAction(new TAction([$this, 'onAddDetailClienteEnderecoCliente'],['static' => 1]), "Adicionar");

        $button_->addStyleClass('btn-default');
        $button_adicionar_cliente_contato_cliente->addStyleClass('btn-default');
        $button_adicionar_cliente_endereco_cliente->addStyleClass('btn-default');
        $button_buscar_cep_cliente_endereco_cliente->addStyleClass('btn-warning');

        $button_->setImage('fas:search #000000');
        $button_adicionar_cliente_contato_cliente->setImage('fas:plus #2ecc71');
        $button_adicionar_cliente_endereco_cliente->setImage('fas:plus #2ecc71');
        $button_buscar_cep_cliente_endereco_cliente->setImage('fas:search #000000');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize('100%');
        $rg->setSize('100%');
        $nome->setSize('100%');
        $fone->setSize('100%');
        $email->setSize('100%');
        $renda->setSize('100%');
        $cpf_cnpj->setSize('85%');
        $conjuge->setSize('100%');
        $nome_pai->setSize('100%');
        $nome_mae->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $vendedor_id->setSize('100%');
        $alterado_em->setSize('100%');
        $cobranca_uf->setSize('100%');
        $conjuge_cpf->setSize('100%');
        $razao_social->setSize('100%');
        $cliente_exterior->setSize(80);
        $alterado_por->setSize('100%');
        $cobranca_cep->setSize('100%');
        $insc_estadual->setSize('100%');
        $cobranca_cnpj->setSize('100%');
        $cobranca_nome->setSize('100%');
        $system_unit_id->setSize('100%');
        $pessoa_tipo_id->setSize('100%');
        $insc_municipal->setSize('100%');
        $cobranca_fones->setSize('100%');
        $local_trabalho->setSize('100%');
        $tempo_trabalho->setSize('100%');
        $data_nascimento->setSize('100%');
        $cobranca_bairro->setSize('100%');
        $cobranca_cidade->setSize('100%');
        $tabela_preco_id->setSize('100%');
        $observacoes->setSize('100%', 110);
        $notafiscal_crt_id->setSize('100%');
        $cobranca_endereco->setSize('100%');
        $residencia_propria->setSize('100%');
        $bhelper_61fa8bf5b958d->setSize('10');
        $bhelper_61fc7b55d4ecf->setSize('10');
        $notafiscal_indiedest_id->setSize('100%');
        $cliente_contato_cliente_id->setSize(200);
        $cliente_classificacao_id->setSize('100%');
        $cliente_endereco_cliente_id->setSize(200);
        $cliente_endereco_cliente_cep->setSize(500);
        $utilizar_endereco_cobranca->setSize('100%');
        $cliente_contato_cliente_nome->setSize('100%');
        $cliente_contato_cliente_fone->setSize('100%');
        $cliente_endereco_cliente_bairro->setSize('100%');
        $cliente_endereco_cliente_numero->setSize('100%');
        $cliente_classificacao_subgrupo_id->setSize('100%');
        $cliente_endereco_cliente_cidade_id->setSize('100%');
        $cliente_endereco_cliente_principal->setSize('100%');
        $cliente_endereco_cliente_logradouro->setSize('100%');
        $cliente_endereco_cliente_complemento->setSize('100%');
        $cliente_endereco_cliente_codigo_ibge->setSize('100%');
        $cliente_endereco_cliente_ibge_estado->setSize('100%');
        $cliente_contato_cliente_tipo_contato->setSize('100%');
        $cliente_endereco_cliente_cidade_estado_id->setSize('100%');

        $button_adicionar_cliente_contato_cliente->id = '63810bae2c828';
        $button_adicionar_cliente_endereco_cliente->id = '61756012cb8f6';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Filial de Origem:", '#FF0000', '14px', null),$system_unit_id]);
        $row1->layout = [' col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Classificação", '#FF0000', '14px', null),$bhelper_61fa8bf5b958d,$cliente_classificacao_id],[new TLabel("Classificação Sub-Grupo:", null, '14px', null),$cliente_classificacao_subgrupo_id]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome],[new TLabel("Razão Social:", null, '14px', null, '100%'),$razao_social]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Tipo Pessoa:", '#ff0000', '14px', null, '100%'),$pessoa_tipo_id],[new TLabel("CPF/CNPJ:", '#FF0000', '14px', null, '100%'),$cpf_cnpj,$button_,$bhelper_61fc7b55d4ecf]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("RG:", null, '14px', null, '100%'),$rg],[new TLabel("Cliente mora no exterior:", null, '14px', null, '100%'),$cliente_exterior]);
        $row5->layout = ['col-sm-6',' col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Inscrição Municipal:", null, '14px', null, '100%'),$insc_municipal],[new TLabel("Inscrição Estadual:", null, '14px', null, '100%'),$insc_estadual]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id],[new TLabel("Data Nascimento:", null, '14px', null, '100%'),$data_nascimento]);
        $row7->layout = ['col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Fone:", null, '14px', null, '100%'),$fone],[new TLabel("E-Mail:", null, '14px', null, '100%'),$email]);
        $row8->layout = ['col-sm-6','col-sm-6'];

        $row9 = $this->form->addContent([new TFormSeparator("Fiscal", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([new TLabel("Regime:", null, '14px', null, '100%'),$notafiscal_crt_id],[new TLabel("Contribuinte:", '#ff0000', '14px', null, '100%'),$notafiscal_indiedest_id]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->form->addFields([new TLabel("Observacoes:", null, '14px', null, '100%'),$observacoes]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row13 = $this->form->addFields([new TLabel("Criado em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null),$criado_por],[new TLabel("Alterado em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null),$alterado_por]);
        $row13->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Endereços");

        $this->detailFormClienteEnderecoCliente = new BootstrapFormBuilder('detailFormClienteEnderecoCliente');
        $this->detailFormClienteEnderecoCliente->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormClienteEnderecoCliente->setProperty('class', 'form-horizontal builder-detail-form');

        $row14 = $this->detailFormClienteEnderecoCliente->addFields([new TLabel("CEP (Informe sem caracteres, apenas números):", null, '14px', 'B', '100%'),$cliente_endereco_cliente_cep,$button_buscar_cep_cliente_endereco_cliente,$cliente_endereco_cliente_id],[new TLabel("Logradouro:", '#ff0000', '14px', null, '100%'),$cliente_endereco_cliente_logradouro]);
        $row14->layout = [' col-sm-6','col-sm-6'];

        $row15 = $this->detailFormClienteEnderecoCliente->addFields([new TLabel("Estado:", '#FF0000', '14px', null),$cliente_endereco_cliente_cidade_estado_id],[new TLabel("Cidade:", '#ff0000', '14px', null, '100%'),$cliente_endereco_cliente_cidade_id],[new TLabel("Bairro:", null, '14px', null, '100%'),$cliente_endereco_cliente_bairro]);
        $row15->layout = [' col-sm-1',' col-sm-5','col-sm-6'];

        $row16 = $this->detailFormClienteEnderecoCliente->addFields([new TLabel("Número:", null, '14px', null, '100%'),$cliente_endereco_cliente_numero],[new TLabel("Complemento", null, '14px', null),$cliente_endereco_cliente_complemento]);
        $row16->layout = ['col-sm-6','col-sm-6'];

        $row17 = $this->detailFormClienteEnderecoCliente->addFields([new TLabel("Principal:", '#ff0000', '14px', null, '100%'),$cliente_endereco_cliente_principal],[new TLabel("IBGE: ", null, '14px', 'B'),$cliente_endereco_cliente_codigo_ibge],[new TLabel("CUF:", null, '14px', 'B'),$cliente_endereco_cliente_ibge_estado]);
        $row17->layout = ['col-sm-6',' col-sm-3',' col-sm-3'];

        $row18 = $this->detailFormClienteEnderecoCliente->addFields([$button_adicionar_cliente_endereco_cliente]);
        $row18->layout = [' col-sm-12'];

        $row19 = $this->detailFormClienteEnderecoCliente->addFields([new THidden('cliente_endereco_cliente__row__id')]);
        $this->cliente_endereco_cliente_criteria = new TCriteria();

        $this->cliente_endereco_cliente_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->cliente_endereco_cliente_list->disableHtmlConversion();;
        $this->cliente_endereco_cliente_list->generateHiddenFields();
        $this->cliente_endereco_cliente_list->setId('cliente_endereco_cliente_list');

        $this->cliente_endereco_cliente_list->disableDefaultClick();
        $this->cliente_endereco_cliente_list->style = 'width:100%';
        $this->cliente_endereco_cliente_list->class .= ' table-bordered';

        $column_cliente_endereco_cliente_logradouro = new TDataGridColumn('logradouro', "Logradouro", 'left');
        $column_cliente_endereco_cliente_fk_principal_descricao = new TDataGridColumn('fk_principal->descricao', "Principal", 'left');
        $column_cliente_endereco_cliente_cidade_nome = new TDataGridColumn('cidade->nome', "Cidade", 'left');
        $column_cliente_endereco_cliente_bairro = new TDataGridColumn('bairro', "Bairro", 'left');
        $column_cliente_endereco_cliente_cep = new TDataGridColumn('cep', "CEP", 'left');
        $column_cliente_endereco_cliente_numero = new TDataGridColumn('numero', "Número", 'left');

        $column_cliente_endereco_cliente__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_cliente_endereco_cliente__row__data->setVisibility(false);

        $action_onEditDetailClienteEndereco = new TDataGridAction(array('ClienteForm', 'onEditDetailClienteEndereco'));
        $action_onEditDetailClienteEndereco->setUseButton(false);
        $action_onEditDetailClienteEndereco->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailClienteEndereco->setLabel("Editar");
        $action_onEditDetailClienteEndereco->setImage('far:edit #478fca');
        $action_onEditDetailClienteEndereco->setFields(['__row__id', '__row__data']);

        $this->cliente_endereco_cliente_list->addAction($action_onEditDetailClienteEndereco);
        $action_onDeleteDetailClienteEndereco = new TDataGridAction(array('ClienteForm', 'onDeleteDetailClienteEndereco'));
        $action_onDeleteDetailClienteEndereco->setUseButton(false);
        $action_onDeleteDetailClienteEndereco->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailClienteEndereco->setLabel("Excluir");
        $action_onDeleteDetailClienteEndereco->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailClienteEndereco->setFields(['__row__id', '__row__data']);

        $this->cliente_endereco_cliente_list->addAction($action_onDeleteDetailClienteEndereco);

        $this->cliente_endereco_cliente_list->addColumn($column_cliente_endereco_cliente_logradouro);
        $this->cliente_endereco_cliente_list->addColumn($column_cliente_endereco_cliente_fk_principal_descricao);
        $this->cliente_endereco_cliente_list->addColumn($column_cliente_endereco_cliente_cidade_nome);
        $this->cliente_endereco_cliente_list->addColumn($column_cliente_endereco_cliente_bairro);
        $this->cliente_endereco_cliente_list->addColumn($column_cliente_endereco_cliente_cep);
        $this->cliente_endereco_cliente_list->addColumn($column_cliente_endereco_cliente_numero);

        $this->cliente_endereco_cliente_list->addColumn($column_cliente_endereco_cliente__row__data);

        $this->cliente_endereco_cliente_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->cliente_endereco_cliente_list);
        $this->detailFormClienteEnderecoCliente->addContent([$tableResponsiveDiv]);
        $row20 = $this->form->addFields([$this->detailFormClienteEnderecoCliente]);
        $row20->layout = [' col-sm-12'];

        $this->form->appendPage("Endereço de Cobrança");
        $row21 = $this->form->addFields([new TLabel("Utilizar Endereço de Cobrança:", '#ff0000', '14px', null, '100%'),$utilizar_endereco_cobranca],[new TLabel("CNPJ Cobrança:", null, '14px', null, '100%'),$cobranca_cnpj]);
        $row21->layout = ['col-sm-6','col-sm-6'];

        $row22 = $this->form->addFields([new TLabel("Nome Cobrança:", null, '14px', null, '100%'),$cobranca_nome],[new TLabel("CEP Cobrança:", null, '14px', null, '100%'),$cobranca_cep]);
        $row22->layout = ['col-sm-6','col-sm-6'];

        $row23 = $this->form->addFields([new TLabel("Endereço de Cobrança:", null, '14px', null, '100%'),$cobranca_endereco],[new TLabel("Bairro Cobrança:", null, '14px', null, '100%'),$cobranca_bairro]);
        $row23->layout = ['col-sm-6','col-sm-6'];

        $row24 = $this->form->addFields([new TLabel("UF Cobrança:", null, '14px', null, '100%'),$cobranca_uf],[new TLabel("Cidade Cobrança:", null, '14px', null, '100%'),$cobranca_cidade]);
        $row24->layout = ['col-sm-6','col-sm-6'];

        $row25 = $this->form->addFields([new TLabel("Fones Cobrança:", null, '14px', null, '100%'),$cobranca_fones]);
        $row25->layout = [' col-sm-12'];

        $this->form->appendPage("Complementares");
        $row26 = $this->form->addFields([new TLabel("Conjuge:", null, '14px', null, '100%'),$conjuge],[new TLabel("CPF Conjuge:", null, '14px', null, '100%'),$conjuge_cpf]);
        $row26->layout = ['col-sm-6','col-sm-6'];

        $row27 = $this->form->addFields([new TLabel("Nome Pai:", null, '14px', null, '100%'),$nome_pai],[new TLabel("Nome Mãe:", null, '14px', null, '100%'),$nome_mae]);
        $row27->layout = ['col-sm-6','col-sm-6'];

        $row28 = $this->form->addFields([new TLabel("Local de Trabalho:", null, '14px', null, '100%'),$local_trabalho],[new TLabel("Renda:", null, '14px', null, '100%'),$renda]);
        $row28->layout = ['col-sm-6','col-sm-6'];

        $row29 = $this->form->addFields([new TLabel("Tempo de Trabalho:", null, '14px', null, '100%'),$tempo_trabalho],[new TLabel("Residência Própria:", null, '14px', null, '100%'),$residencia_propria]);
        $row29->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("Contatos");

        $this->detailFormClienteContatoCliente = new BootstrapFormBuilder('detailFormClienteContatoCliente');
        $this->detailFormClienteContatoCliente->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormClienteContatoCliente->setProperty('class', 'form-horizontal builder-detail-form');

        $row30 = $this->detailFormClienteContatoCliente->addFields([new TLabel("Tipo de Contato:", null, '14px', null, '100%'),$cliente_contato_cliente_tipo_contato,$cliente_contato_cliente_id],[new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$cliente_contato_cliente_nome]);
        $row30->layout = ['col-sm-6','col-sm-6'];

        $row31 = $this->detailFormClienteContatoCliente->addFields([new TLabel("Fone:", null, '14px', null, '100%'),$cliente_contato_cliente_fone],[]);
        $row31->layout = ['col-sm-6','col-sm-6'];

        $row32 = $this->detailFormClienteContatoCliente->addFields([$button_adicionar_cliente_contato_cliente]);
        $row32->layout = [' col-sm-12'];

        $row33 = $this->detailFormClienteContatoCliente->addFields([new THidden('cliente_contato_cliente__row__id')]);
        $this->cliente_contato_cliente_criteria = new TCriteria();

        $this->cliente_contato_cliente_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->cliente_contato_cliente_list->disableHtmlConversion();;
        $this->cliente_contato_cliente_list->generateHiddenFields();
        $this->cliente_contato_cliente_list->setId('cliente_contato_cliente_list');

        $this->cliente_contato_cliente_list->style = 'width:100%';
        $this->cliente_contato_cliente_list->class .= ' table-bordered';

        $column_cliente_contato_cliente_tipo_contato = new TDataGridColumn('tipo_contato', "Tipo de Contato", 'left');
        $column_cliente_contato_cliente_nome = new TDataGridColumn('nome', "Nome", 'left');
        $column_cliente_contato_cliente_fone = new TDataGridColumn('fone', "Fone", 'left');

        $column_cliente_contato_cliente__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_cliente_contato_cliente__row__data->setVisibility(false);

        $action_onEditDetailClienteContato = new TDataGridAction(array('ClienteForm', 'onEditDetailClienteContato'));
        $action_onEditDetailClienteContato->setUseButton(false);
        $action_onEditDetailClienteContato->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailClienteContato->setLabel("Editar");
        $action_onEditDetailClienteContato->setImage('far:edit #478fca');
        $action_onEditDetailClienteContato->setFields(['__row__id', '__row__data']);

        $this->cliente_contato_cliente_list->addAction($action_onEditDetailClienteContato);
        $action_onDeleteDetailClienteContato = new TDataGridAction(array('ClienteForm', 'onDeleteDetailClienteContato'));
        $action_onDeleteDetailClienteContato->setUseButton(false);
        $action_onDeleteDetailClienteContato->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailClienteContato->setLabel("Excluir");
        $action_onDeleteDetailClienteContato->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailClienteContato->setFields(['__row__id', '__row__data']);

        $this->cliente_contato_cliente_list->addAction($action_onDeleteDetailClienteContato);

        $this->cliente_contato_cliente_list->addColumn($column_cliente_contato_cliente_tipo_contato);
        $this->cliente_contato_cliente_list->addColumn($column_cliente_contato_cliente_nome);
        $this->cliente_contato_cliente_list->addColumn($column_cliente_contato_cliente_fone);

        $this->cliente_contato_cliente_list->addColumn($column_cliente_contato_cliente__row__data);

        $this->cliente_contato_cliente_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->cliente_contato_cliente_list);
        $this->detailFormClienteContatoCliente->addContent([$tableResponsiveDiv]);
        $row34 = $this->form->addFields([$this->detailFormClienteContatoCliente]);
        $row34->layout = [' col-sm-12'];

        $this->form->appendPage("Outras Informações");
        $row35 = $this->form->addFields([new TLabel("Tabela de Preço:", null, '14px', null),$tabela_preco_id]);
        $row35->layout = [' col-sm-6'];

        $email->addValidation('email', new TEmailValidator);
        //$cpf_cnpj->addValidation('cpf_cnpj', new TCPFValidator);
        //$cpf_cnpj->addValidation('cpf_cnpj', new TCNPJValidator);

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ClienteList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Cliente","Cadastro de cliente"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onChangecliente_classificacao_id($param)
    {
        try
        {

            if (isset($param['cliente_classificacao_id']) && $param['cliente_classificacao_id'])
            { 
                $criteria = TCriteria::create(['cliente_classificacao_id' => $param['cliente_classificacao_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'cliente_classificacao_subgrupo_id', 'kraftsoft', 'ClienteClassificacaoSubgrupo', 'id', '{descricao}', 'descricao asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'cliente_classificacao_subgrupo_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public static function onChangecliente_endereco_cliente_cidade_estado_id($param)
    {
        try
        {

            if (isset($param['cliente_endereco_cliente_cidade_estado_id']) && $param['cliente_endereco_cliente_cidade_estado_id'])
            { 
                $criteria = TCriteria::create(['estado_id' => $param['cliente_endereco_cliente_cidade_estado_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'cliente_endereco_cliente_cidade_id', 'kraftsoft', 'Cidade', 'id', '{nome}', 'id asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'cliente_endereco_cliente_cidade_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public static function OnChangePessoaTipo($param = null) 
    {
        try 
        {

            //code here
            if( isset($param['key']) && $param['key'] == PessoaTipo::Fisica)
            {
                TScript::create( " $('input[name=cpf_cnpj]').off();
                                   $('input[name=cpf_cnpj]').val('');
                                   $('input[name=cpf_cnpj]').keypress(function() {  tentry_mask(this, event, '999.999.999-99') }); " );

                $obj = new stdClass();
                $obj->notafiscal_indiedest_id = NotafiscalIndiedest::NaoContribuinte;                                   
                TForm::sendData(self::$formName, $obj); 
            }
            elseif( isset($param['key']) && $param['key'] == PessoaTipo::Juridica)
            {
                TScript::create( " $('input[name=cpf_cnpj]').off();
                                   $('input[name=cpf_cnpj]').val('');
                                   $('input[name=cpf_cnpj]').keypress(function() {  tentry_mask(this, event, '99.999.999/9999-99') }); " );

                $obj = new stdClass();                 
                //$obj->notafiscal_indiedest_id = NotafiscalIndiedest::ContribuinteICMS;                                                                      
                TForm::sendData(self::$formName, $obj); 
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onConsultaCnpj($param = null) 
    {
        try 
        {
            //$dados = NuvemFiscal::ConsultaCnpj(Funcoes::sonumeros($param['cpf_cnpj']));

            if($param['pessoa_tipo_id'] != PessoaTipo::Juridica)
            {
                throw new Exception('A busca de CNPJ é apenas para pessoa júridica! ');
            }

            TTransaction::open(self::$database);

            $dadoscnpj = CNPJService::get($param['cpf_cnpj']);

            if(!$dadoscnpj)
            {
                throw new Exception('CNPJ não encontrado!');
            }  

            $formData = new stdClass();
            $formData->nome = $dadoscnpj->razao_social;
            $formData->razao_social = $dadoscnpj->razao_social;
            $formData->fone = $dadoscnpj->ddd_telefone_1;

            //incluindo o endereço....
            $formData->cliente_endereco_cliente_cep = $dadoscnpj->cep;
            $formData->cliente_endereco_cliente_logradouro = $dadoscnpj->logradouro ?? 'Logradouro';
            $formData->cliente_endereco_cliente_bairro = $dadoscnpj->bairro;
            $formData->cliente_endereco_cliente_numero = $dadoscnpj->numero;
            $formData->cliente_endereco_cliente_principal = 1;
            $formData->cliente_endereco_cliente_complemento = $dadoscnpj->complemento;
            $formData->cliente_endereco_cliente_cidade_estado_id = $dadoscnpj->estado_id ?? null;
            $formData->cliente_endereco_cliente_cidade_id = $dadoscnpj->cidade_id ?? null;   
            $formData->cliente_endereco_cliente_id = '';

            $clienteForm = new ClienteForm([]);
            $clienteForm->setIsWrapped(true);

            $clienteForm->onAddDetailClienteEnderecoCliente([
                                                        'customFormData' => $formData,
                                                        // simulando os dados enviados de forma bruta do formulário detalhe
                                                        // ou seja, valores formatados
                                                        'cliente_endereco_cliente_cep' => $formData->cliente_endereco_cliente_cep,
                                                        'cliente_endereco_cliente_logradouro' => $formData->cliente_endereco_cliente_logradouro,
                                                        'cliente_endereco_cliente_bairro' => $formData->cliente_endereco_cliente_bairro,
                                                        'cliente_endereco_cliente_numero' => $formData->cliente_endereco_cliente_numero,
                                                        'cliente_endereco_cliente_complemento' => $formData->cliente_endereco_cliente_complemento,
                                                        'cliente_endereco_cliente_cidade_estado_id' => $formData->cliente_endereco_cliente_cidade_estado_id,
                                                        'cliente_endereco_cliente_cidade_id' => $formData->cliente_endereco_cliente_cidade_id,
                                                        'cliente_endereco_cliente_id' => $formData->cliente_endereco_cliente_id

                                                    ]);

            $formData->cliente_endereco_cliente_cep = '';
            $formData->cliente_endereco_cliente_logradouro = '';
            $formData->cliente_endereco_cliente_bairro = '';
            $formData->cliente_endereco_cliente_numero = '';
            $formData->cliente_endereco_cliente_principal = '';
            $formData->cliente_endereco_cliente_complemento = '';
            $formData->cliente_endereco_cliente_cidade_estado_id = '';
            $formData->cliente_endereco_cliente_cidade_id = '';                                                       

            TForm::sendData(self::$formName, $formData);                        

            //</generatedAutoCode>

            //</detailForm-1768081-14571079-ClearDataOnAddAutoCode> //</hideLine>
            //<generatedAutoCode>

            //</generatedAutoCode>

            //</detailForm-1768081-14571079-SendDataOnAddAutoCode> //</hideLine>
            //<generatedAutoCode>

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onBuscarCEP($param = null) 
    {
        try 
        {
            if(!empty($param['cliente_endereco_cliente_cep']))
            {
                TTransaction::open(self::$database);
                $dadosCep = CEPService::get($param['cliente_endereco_cliente_cep']);
                TTransaction::close();

                TDBCombo::reloadFromModel(self::$formName, //'formName do formulario pai'
                                         'cliente_endereco_cliente_cidade_estado_id', //'field do formulario pai'
                                         'kraftsoft', //$database
                                         'Estado', //$model (classe)
                                         'id', //$key (campo id)
                                         'sigla', //$value
                                         'sigla asc', //$ordercolumn = NULL
                                         null, // $criteria = NULL
                                         null);

                // TDBCombo::reloadFromModel(self::$formName, //'formName do formulario pai'
                //                          'cliente_endereco_cliente_cidade_id', //'field do formulario pai'
                //                          'kraftsoft', //$database
                //                          'Cidade', //$model (classe)
                //                          'id', //$key (campo id)
                //                          'nome', //$value
                //                          'nome asc', //$ordercolumn = NULL
                //                          null, // $criteria = NULL
                //                          null);                                         

                if($dadosCep)
                {

                  $object = new stdClass();

                  $object->cliente_endereco_cliente_cidade_estado_id = $dadosCep->estado_id;
                  $object->cliente_endereco_cliente_cidade_id = $dadosCep->cidade_id;
                  $object->cliente_endereco_cliente_logradouro = $dadosCep->rua;
                  $object->cliente_endereco_cliente_bairro = $dadosCep->bairro;

                  TForm::sendData(self::$formName, $object);    

                //   $this->fireEvents($object);
                }
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailClienteEnderecoCliente($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if(!empty($param['customFormData']))
            {
                $data = $param['customFormData'];
            }            

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Logradouro", 'name'=>"cliente_endereco_cliente_logradouro", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Estado", 'name'=>"cliente_endereco_cliente_cidade_estado_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Cidade", 'name'=>"cliente_endereco_cliente_cidade_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Principal", 'name'=>"cliente_endereco_cliente_principal", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->cliente_endereco_cliente__row__id) ? $data->cliente_endereco_cliente__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ClienteEndereco();
            $grid_data->__row__id = $__row__id;
            $grid_data->cep = $data->cliente_endereco_cliente_cep;
            $grid_data->id = $data->cliente_endereco_cliente_id;
            $grid_data->logradouro = $data->cliente_endereco_cliente_logradouro;
            $grid_data->cidade_estado_id = $data->cliente_endereco_cliente_cidade_estado_id;
            $grid_data->cidade_id = $data->cliente_endereco_cliente_cidade_id;
            $grid_data->bairro = $data->cliente_endereco_cliente_bairro;
            $grid_data->numero = $data->cliente_endereco_cliente_numero;
            $grid_data->complemento = $data->cliente_endereco_cliente_complemento;
            $grid_data->principal = $data->cliente_endereco_cliente_principal;
            $grid_data->codigo_ibge = $data->cliente_endereco_cliente_codigo_ibge;
            $grid_data->ibge_estado = $data->cliente_endereco_cliente_ibge_estado;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['cep'] =  $param['cliente_endereco_cliente_cep'] ?? null;
            $__row__data['__display__']['id'] =  $param['cliente_endereco_cliente_id'] ?? null;
            $__row__data['__display__']['logradouro'] =  $param['cliente_endereco_cliente_logradouro'] ?? null;
            $__row__data['__display__']['cidade_estado_id'] =  $param['cliente_endereco_cliente_cidade_estado_id'] ?? null;
            $__row__data['__display__']['cidade_id'] =  $param['cliente_endereco_cliente_cidade_id'] ?? null;
            $__row__data['__display__']['bairro'] =  $param['cliente_endereco_cliente_bairro'] ?? null;
            $__row__data['__display__']['numero'] =  $param['cliente_endereco_cliente_numero'] ?? null;
            $__row__data['__display__']['complemento'] =  $param['cliente_endereco_cliente_complemento'] ?? null;
            $__row__data['__display__']['principal'] =  $param['cliente_endereco_cliente_principal'] ?? null;
            $__row__data['__display__']['codigo_ibge'] =  $param['cliente_endereco_cliente_codigo_ibge'] ?? null;
            $__row__data['__display__']['ibge_estado'] =  $param['cliente_endereco_cliente_ibge_estado'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->cliente_endereco_cliente_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('cliente_endereco_cliente_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->cliente_endereco_cliente_cep = '';
            $data->cliente_endereco_cliente_id = '';
            $data->cliente_endereco_cliente_logradouro = '';
            $data->cliente_endereco_cliente_cidade_estado_id = '';
            $data->cliente_endereco_cliente_cidade_id = '';
            $data->cliente_endereco_cliente_bairro = '';
            $data->cliente_endereco_cliente_numero = '';
            $data->cliente_endereco_cliente_complemento = '';
            $data->cliente_endereco_cliente_principal = '';
            $data->cliente_endereco_cliente_codigo_ibge = '';
            $data->cliente_endereco_cliente_ibge_estado = '';
            $data->cliente_endereco_cliente__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61756012cb8f6');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailClienteContatoCliente($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Nome", 'name'=>"cliente_contato_cliente_nome", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->cliente_contato_cliente__row__id) ? $data->cliente_contato_cliente__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ClienteContato();
            $grid_data->__row__id = $__row__id;
            $grid_data->tipo_contato = $data->cliente_contato_cliente_tipo_contato;
            $grid_data->id = $data->cliente_contato_cliente_id;
            $grid_data->nome = $data->cliente_contato_cliente_nome;
            $grid_data->fone = $data->cliente_contato_cliente_fone;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['tipo_contato'] =  $param['cliente_contato_cliente_tipo_contato'] ?? null;
            $__row__data['__display__']['id'] =  $param['cliente_contato_cliente_id'] ?? null;
            $__row__data['__display__']['nome'] =  $param['cliente_contato_cliente_nome'] ?? null;
            $__row__data['__display__']['fone'] =  $param['cliente_contato_cliente_fone'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->cliente_contato_cliente_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('cliente_contato_cliente_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->cliente_contato_cliente_tipo_contato = '';
            $data->cliente_contato_cliente_id = '';
            $data->cliente_contato_cliente_nome = '';
            $data->cliente_contato_cliente_fone = '';
            $data->cliente_contato_cliente__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63810bae2c828');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailClienteEndereco($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->cliente_endereco_cliente_cep = $__row__data->__display__->cep ?? null;
            $data->cliente_endereco_cliente_id = $__row__data->__display__->id ?? null;
            $data->cliente_endereco_cliente_logradouro = $__row__data->__display__->logradouro ?? null;
            $data->cliente_endereco_cliente_cidade_estado_id = $__row__data->__display__->cidade_estado_id ?? null;
            $data->cliente_endereco_cliente_cidade_id = $__row__data->__display__->cidade_id ?? null;
            $data->cliente_endereco_cliente_bairro = $__row__data->__display__->bairro ?? null;
            $data->cliente_endereco_cliente_numero = $__row__data->__display__->numero ?? null;
            $data->cliente_endereco_cliente_complemento = $__row__data->__display__->complemento ?? null;
            $data->cliente_endereco_cliente_principal = $__row__data->__display__->principal ?? null;
            $data->cliente_endereco_cliente_codigo_ibge = $__row__data->__display__->codigo_ibge ?? null;
            $data->cliente_endereco_cliente_ibge_estado = $__row__data->__display__->ibge_estado ?? null;
            $data->cliente_endereco_cliente__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61756012cb8f6');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailClienteEndereco($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->cliente_endereco_cliente_cep = '';
            $data->cliente_endereco_cliente_id = '';
            $data->cliente_endereco_cliente_logradouro = '';
            $data->cliente_endereco_cliente_cidade_estado_id = '';
            $data->cliente_endereco_cliente_cidade_id = '';
            $data->cliente_endereco_cliente_bairro = '';
            $data->cliente_endereco_cliente_numero = '';
            $data->cliente_endereco_cliente_complemento = '';
            $data->cliente_endereco_cliente_principal = '';
            $data->cliente_endereco_cliente_codigo_ibge = '';
            $data->cliente_endereco_cliente_ibge_estado = '';
            $data->cliente_endereco_cliente__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('cliente_endereco_cliente_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailClienteContato($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->cliente_contato_cliente_tipo_contato = $__row__data->__display__->tipo_contato ?? null;
            $data->cliente_contato_cliente_id = $__row__data->__display__->id ?? null;
            $data->cliente_contato_cliente_nome = $__row__data->__display__->nome ?? null;
            $data->cliente_contato_cliente_fone = $__row__data->__display__->fone ?? null;
            $data->cliente_contato_cliente__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63810bae2c828');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailClienteContato($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->cliente_contato_cliente_tipo_contato = '';
            $data->cliente_contato_cliente_id = '';
            $data->cliente_contato_cliente_nome = '';
            $data->cliente_contato_cliente_fone = '';
            $data->cliente_contato_cliente__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('cliente_contato_cliente_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Cliente(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //validação de CPF e CNPJ
            if ($data->cliente_exterior=='N')
            {
                if($data->pessoa_tipo_id == PessoaTipo::Fisica)
                { 
                  (new TCPFValidator())->validate('CPF/CNPJ',$data->cpf_cnpj);
                }

                if($data->pessoa_tipo_id == PessoaTipo::Juridica)
                {
                  (new TCNPJValidator())->validate('CPF/CNPJ',$data->cpf_cnpj);
                }
            }

            if ($data->id=='')
            {
              $object->cliente_situacao_id = ClienteSituacao::Ativo;
            }

            //se for pessoa juridica, validar informações obrigatorias...
            if($data->pessoa_tipo_id == PessoaTipo::Juridica)
            { 
                if ($data->razao_social==null)
                {
                  throw new Exception("Informe a razão social da empresa!");                    
                }

                // if ($data->notafiscal_crt_id==null)
                // {
                //   throw new Exception("Informe o Regime da empresa!");
                // }
                // retirado por um tempo ate implementar o uso..
            }

            $object->cpf_cnpj = Funcoes::limpaCPF_CNPJ($object->cpf_cnpj);

            //verificando se já existe algum cliente com este CPF/CNPJ
            $clienterepetido = Cliente::where('cpf_cnpj', '=', $object->cpf_cnpj)->first();

            if (($clienterepetido) and isset($clienterepetido->id))
            {
                if ($clienterepetido->id != $object->id)
                {
                  throw new Exception("Já existe um cliente com este CPF/CNPJ! Id: ".$clienterepetido->id);                   
                }
            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $cliente_contato_cliente_items = $this->storeMasterDetailItems('ClienteContato', 'cliente_id', 'cliente_contato_cliente', $object, $param['cliente_contato_cliente_list___row__data'] ?? [], $this->form, $this->cliente_contato_cliente_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->cliente_contato_cliente_criteria); 

            $cliente_endereco_cliente_items = $this->storeMasterDetailItems('ClienteEndereco', 'cliente_id', 'cliente_endereco_cliente', $object, $param['cliente_endereco_cliente_list___row__data'] ?? [], $this->form, $this->cliente_endereco_cliente_list, function($masterObject, $detailObject){ 

                //code here
                Funcoes::SalvarUsuarioCadastro($detailObject);

                if ($detailObject->id==0)
                {
                  $detailObject->ativo_id = Ativo::Ativo;
                }                

            }, $this->cliente_endereco_cliente_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ClienteList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Cliente($key); // instantiates the Active Record 

                $object->cpf_cnpj = Funcoes::mascaraCpfCnpj($object->cpf_cnpj);

                $cliente_contato_cliente_items = $this->loadMasterDetailItems('ClienteContato', 'cliente_id', 'cliente_contato_cliente', $object, $this->form, $this->cliente_contato_cliente_list, $this->cliente_contato_cliente_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $cliente_endereco_cliente_items = $this->loadMasterDetailItems('ClienteEndereco', 'cliente_id', 'cliente_endereco_cliente', $object, $this->form, $this->cliente_endereco_cliente_list, $this->cliente_endereco_cliente_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                    $objectItems->cliente_endereco_cliente_cidade_estado_id = null;
                    if(isset($detailObject->cidade->estado->id) && $detailObject->cidade->estado->id)
                    {
                        $objectItems->__display__->cidade_estado_id = $detailObject->cidade->estado->id;
                    }

                    $objectItems->cliente_endereco_cliente_cidade_id = null;
                    if(isset($detailObject->cidade_id) && $detailObject->cidade_id)
                    {
                        $objectItems->__display__->cidade_id = $detailObject->cidade_id;
                    }

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $obj = new stdClass();

        if (empty($obj->id))
        {
          $obj->utilizar_endereco_cobranca = Resposta::Nao;
          $obj->cliente_endereco_cliente_principal = Resposta::Sim;
          $obj->system_unit_id = TSession::getValue('userunitid');
          $obj->cliente_exterior='N';

          TForm::sendData(self::$formName, $obj); 
        }
    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->cliente_classificacao_id))
            {
                $value = $object->cliente_classificacao_id;

                $obj->cliente_classificacao_id = $value;
            }
            if(isset($object->cliente_classificacao_subgrupo_id))
            {
                $value = $object->cliente_classificacao_subgrupo_id;

                $obj->cliente_classificacao_subgrupo_id = $value;
            }
            if(isset($object->cliente_endereco_cliente_cidade_estado_id))
            {
                $value = $object->cliente_endereco_cliente_cidade_estado_id;

                $obj->cliente_endereco_cliente_cidade_estado_id = $value;
            }
            if(isset($object->cliente_endereco_cliente_cidade_id))
            {
                $value = $object->cliente_endereco_cliente_cidade_id;

                $obj->cliente_endereco_cliente_cidade_id = $value;
            }
            if(isset($object->pessoa_tipo_id))
            {
                $value = $object->pessoa_tipo_id;

                $obj->pessoa_tipo_id = $value;
            }
            if(isset($object->cpf_cnpj))
            {
                $value = $object->cpf_cnpj;

                $obj->cpf_cnpj = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->cliente_classificacao_id))
            {
                $value = $object->cliente_classificacao_id;

                $obj->cliente_classificacao_id = $value;
            }
            if(isset($object->cliente_classificacao_subgrupo_id))
            {
                $value = $object->cliente_classificacao_subgrupo_id;

                $obj->cliente_classificacao_subgrupo_id = $value;
            }
            if(isset($object->cliente_endereco->cliente->cidade->estado->id))
            {
                $value = $object->cliente_endereco->cliente->cidade->estado->id;

                $obj->cliente_endereco_cliente_cidade_estado_id = $value;
            }
            if(isset($object->cliente_endereco->cliente->cidade_id))
            {
                $value = $object->cliente_endereco->cliente->cidade_id;

                $obj->cliente_endereco_cliente_cidade_id = $value;
            }
            if(isset($object->pessoa_tipo_id))
            {
                $value = $object->pessoa_tipo_id;

                $obj->pessoa_tipo_id = $value;
            }
            if(isset($object->cpf_cnpj))
            {
                $value = $object->cpf_cnpj;

                $obj->cpf_cnpj = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

