<?php

class ClienteReport extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_ClienteReport';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Relatório de clientes");


        $nome = new TEntry('nome');
        $cnpj_cpf = new TEntry('cnpj_cpf');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );


        $system_unit_id->enableSearch();
        $nome->setSize('100%');
        $cnpj_cpf->setSize('100%');
        $system_unit_id->setSize('100%');


        $row1 = $this->form->addFields([new TLabel("Nome:", null, '14px', null),$nome],[new TLabel("CNP/CPF:", null, '14px', null),$cnpj_cpf]);
        $row1->layout = [' col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Filial de Origem:", null, '14px', null),$system_unit_id]);
        $row2->layout = [' col-sm-12'];

        // create the form actions
        $btn_ongerarplanilha = $this->form->addAction("Gerar Planilha", new TAction([$this, 'onGerarPlanilha']), 'fas:rocket #ffffff');
        $this->btn_ongerarplanilha = $btn_ongerarplanilha;
        $btn_ongerarplanilha->addStyleClass('btn-primary'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Cliente","Relatório de clientes"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onGerarPlanilha($param = null) 
    {
        try
        {
            TTransaction::open('kraftsoft');

            $arquivo = 'app/output/'.uniqid().'.xls';

            $largura_colunas = [300,300,300,200];

            $planilha = new TTableWriterXLS($largura_colunas);
            $planilha->addRow();
            $planilha->addCell('Nome', 'center', 'title');
            $planilha->addCell('CNPJ/CPF', 'center', 'title');
            $planilha->addCell('Endereço', 'center', 'title');
            $planilha->addCell('Fone', 'center', 'title');
            $planilha->addCell('Filial de Origem', 'center', 'title');

            $conn = TTransaction::get();

            $sql = 'SELECT e.logradouro as endereco_cliente,
                    nome as nome_cliente,
                    cpf_cnpj as cpf_cnpj,
                    fone
                    FROM cliente c
                    INNER JOIN cliente_endereco e on c.id = e.cliente_id;
                ';

            $lista_cliente = $conn->query($sql);

            foreach($lista_cliente as $cliente)
            {
                $planilha->addRow();
                $planilha->addCell($cliente['nome_cliente'], 'center', 'data');
                $planilha->addCell($cliente['cpf_cnpj'], 'center', 'data');
                $planilha->addCell($cliente['endereco_cliente'], 'center', 'data');
                $planilha->addCell($cliente['fone'], 'center', 'data');
            }

            $planilha->save($arquivo);

            TPage::openFile($arquivo);

            TTransaction::close();

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

        $obj = new stdClass();

        $obj->system_unit_id = TSession::getValue('userunitid');

        TForm::sendData(self::$formName, $obj); 

    } 

}

