<?php

class NotaFiscalCompraForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NotaFiscalCompra';
    private static $primaryKey = 'id';
    private static $formName = 'form_NotaFiscalCompraForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de nota fiscal de compra");

        $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id = new TCriteria();
        $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        TSession::setValue('nota_fiscal_compra_id', null);

        $nota_fiscal_compra_situacao_id = new TDBArrowStep('nota_fiscal_compra_situacao_id', 'kraftsoft', 'NotaFiscalCompraSituacao', 'id', '{descricao}','id asc'  );
        $id = new TEntry('id');
        $numero = new TEntry('numero');
        $serie = new TEntry('serie');
        $data_emissao = new TDateTime('data_emissao');
        $data_saida = new TDateTime('data_saida');
        $notafiscal_mod_id = new TDBCombo('notafiscal_mod_id', 'kraftsoft', 'NotafiscalMod', 'id', '{descricao}','descricao asc'  );
        $natop = new TDBCombo('natop', 'kraftsoft', 'NaturezaOperacao', 'descricao', '{descricao}','descricao asc'  );
        $notafiscal_finnfe_id = new TDBCombo('notafiscal_finnfe_id', 'kraftsoft', 'NotafiscalFinnfe', 'id', '{descricao}','descricao asc'  );
        $notafiscal_indpres_id = new TDBCombo('notafiscal_indpres_id', 'kraftsoft', 'NotafiscalIndpres', 'id', '{descricao}','descricao asc'  );
        $notafiscal_modfrete_id = new TDBCombo('notafiscal_modfrete_id', 'kraftsoft', 'NotafiscalModfrete', 'id', '{descricao}','descricao asc'  );
        $chave = new TEntry('chave');
        $infcpl = new TText('infcpl');
        $infadfisco = new TText('infadfisco');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $notafiscal_indfinal_id = new THidden('notafiscal_indfinal_id');
        $notafiscal_tipodocumento_id = new THidden('notafiscal_tipodocumento_id');
        $notafiscal_iddest_id = new THidden('notafiscal_iddest_id');
        $fornecedor_id = new TDBCombo('fornecedor_id', 'kraftsoft', 'Fornecedor', 'id', '{nome} - {cpf_cnpj}','nome asc'  );
        $cliente_nome = new THidden('cliente_nome');
        $cliente_cpfcnpj = new TEntry('cliente_cpfcnpj');
        $cliente_inscest = new TEntry('cliente_inscest');
        $cliente_inscmuni = new TEntry('cliente_inscmuni');
        $notafiscal_crt_id = new TDBCombo('notafiscal_crt_id', 'kraftsoft', 'NotafiscalCrt', 'id', '{descricao}','descricao asc'  );
        $notafiscal_indiedest_id = new TDBCombo('notafiscal_indiedest_id', 'kraftsoft', 'NotafiscalIndiedest', 'id', '{descricao}','descricao asc'  );
        $cliente_cep = new TEntry('cliente_cep');
        $cliente_endereco = new TEntry('cliente_endereco');
        $cliente_numero = new TEntry('cliente_numero');
        $cliente_complemento = new TEntry('cliente_complemento');
        $cliente_bairro = new TEntry('cliente_bairro');
        $cliente_cidade = new TEntry('cliente_cidade');
        $cliente_estado = new TEntry('cliente_estado');
        $cliente_cidade_codibge = new TEntry('cliente_cidade_codibge');
        $button_novo_item = new TButton('button_novo_item');
        $lista_itens = new BPageContainer();
        $notafiscal_indpag_id = new TDBCombo('notafiscal_indpag_id', 'kraftsoft', 'NotafiscalIndpag', 'id', '{descricao}','descricao asc'  );
        $nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id = new TDBCombo('nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id', 'kraftsoft', 'NotafiscalTpag', 'id', '{descricao}','tpag asc'  );
        $nota_fiscal_compra_pag_nota_fiscal_compra_id = new THidden('nota_fiscal_compra_pag_nota_fiscal_compra_id');
        $nota_fiscal_compra_pag_nota_fiscal_compra_vpag = new TNumeric('nota_fiscal_compra_pag_nota_fiscal_compra_vpag', '2', ',', '.' );
        $nota_fiscal_compra_pag_nota_fiscal_compra_xpag = new TEntry('nota_fiscal_compra_pag_nota_fiscal_compra_xpag');
        $button_adicionar_nota_fiscal_compra_pag_nota_fiscal_compra = new TButton('button_adicionar_nota_fiscal_compra_pag_nota_fiscal_compra');
        $fatura_numero = new TEntry('fatura_numero');
        $fatura_valor_original = new TNumeric('fatura_valor_original', '2', ',', '.' );
        $fatura_valor_desconto = new TNumeric('fatura_valor_desconto', '2', ',', '.' );
        $fatura_valor_liquido = new TNumeric('fatura_valor_liquido', '2', ',', '.' );
        $nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id = new TDBCombo('nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $nota_fiscal_compra_dup_nota_fiscal_compra_ndup = new TEntry('nota_fiscal_compra_dup_nota_fiscal_compra_ndup');
        $nota_fiscal_compra_dup_nota_fiscal_compra_parcela = new TEntry('nota_fiscal_compra_dup_nota_fiscal_compra_parcela');
        $nota_fiscal_compra_dup_nota_fiscal_compra_dvenc = new TDate('nota_fiscal_compra_dup_nota_fiscal_compra_dvenc');
        $nota_fiscal_compra_dup_nota_fiscal_compra_vdup = new TNumeric('nota_fiscal_compra_dup_nota_fiscal_compra_vdup', '2', ',', '.' );
        $nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id = new TDBCombo('nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id', 'kraftsoft', 'PlanoConta', 'id', '{numero}  - {descricao}','numero asc' , $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id );
        $nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id = new TDBCombo('nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id', 'kraftsoft', 'CentroCusto', 'id', '{numero}  - {descricao}','numero asc' , $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id );
        $button_adicionar_nota_fiscal_compra_dup_nota_fiscal_compra = new TButton('button_adicionar_nota_fiscal_compra_dup_nota_fiscal_compra');
        $nota_fiscal_compra_dup_nota_fiscal_compra_id = new THidden('nota_fiscal_compra_dup_nota_fiscal_compra_id');
        $icms_basecalc = new TNumeric('icms_basecalc', '2', ',', '.' );
        $icms_valor = new TNumeric('icms_valor', '2', ',', '.' );
        $icms_subst_base_calc = new TNumeric('icms_subst_base_calc', '2', ',', '.' );
        $icms_subst_valor = new TNumeric('icms_subst_valor', '2', ',', '.' );
        $frete_valor = new TNumeric('frete_valor', '2', ',', '.' );
        $seguro_valor = new TNumeric('seguro_valor', '2', ',', '.' );
        $ipi_valor = new TNumeric('ipi_valor', '2', ',', '.' );
        $desconto_valor = new TNumeric('desconto_valor', '2', ',', '.' );
        $outras_despesas = new TNumeric('outras_despesas', '2', ',', '.' );
        $ipi_vipidevol = new TNumeric('ipi_vipidevol', '2', ',', '.' );
        $valor_total_produtos = new TNumeric('valor_total_produtos', '2', ',', '.' );
        $valor_total_nota = new TNumeric('valor_total_nota', '2', ',', '.' );
        $vtroco = new TNumeric('vtroco', '2', ',', '.' );

        $fornecedor_id->setChangeAction(new TAction([$this,'onExitFornecedor']));

        $numero->addValidation("Número", new TRequiredValidator()); 
        $notafiscal_mod_id->addValidation("Modelo ", new TRequiredValidator()); 
        $fornecedor_id->addValidation("Fornecedor", new TRequiredValidator()); 

        $nota_fiscal_compra_situacao_id->setColorColumn('cor');
        $nota_fiscal_compra_situacao_id->setFilledColor('#fd9308');
        $nota_fiscal_compra_situacao_id->setFilledFontColor('#ffffff');
        $nota_fiscal_compra_situacao_id->setUnfilledColor('#d3d3d3');
        $nota_fiscal_compra_situacao_id->setUnfilledFontColor('#333333');
        $lista_itens->setId('b63821988e74d6');
        $button_novo_item->addStyleClass('btn-default');
        $button_adicionar_nota_fiscal_compra_pag_nota_fiscal_compra->addStyleClass('btn-default');
        $button_adicionar_nota_fiscal_compra_dup_nota_fiscal_compra->addStyleClass('btn-default');

        $button_novo_item->setImage('fas:plus #000000');
        $button_adicionar_nota_fiscal_compra_pag_nota_fiscal_compra->setImage('fas:plus #2ecc71');
        $button_adicionar_nota_fiscal_compra_dup_nota_fiscal_compra->setImage('fas:plus #2ecc71');

        $button_novo_item->setAction(new TAction([$this, 'onNovoItem']), "Novo Item");
        $lista_itens->setAction(new TAction(['NotaFiscalCompraItensSimpleList', 'onShow']));
        $button_adicionar_nota_fiscal_compra_pag_nota_fiscal_compra->setAction(new TAction([$this, 'onAddDetailNotaFiscalCompraPagNotaFiscalCompra'],['static' => 1]), "Adicionar");
        $button_adicionar_nota_fiscal_compra_dup_nota_fiscal_compra->setAction(new TAction([$this, 'onAddDetailNotaFiscalCompraDupNotaFiscalCompra'],['static' => 1]), "Adicionar");

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $data_saida->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_emissao->setMask('dd/mm/yyyy hh:ii');
        $nota_fiscal_compra_dup_nota_fiscal_compra_dvenc->setMask('dd/mm/yyyy');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_saida->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_emissao->setDatabaseMask('yyyy-mm-dd hh:ii');
        $nota_fiscal_compra_dup_nota_fiscal_compra_dvenc->setDatabaseMask('yyyy-mm-dd');

        $natop->enableSearch();
        $fornecedor_id->enableSearch();
        $notafiscal_mod_id->enableSearch();
        $notafiscal_crt_id->enableSearch();
        $notafiscal_finnfe_id->enableSearch();
        $notafiscal_indpag_id->enableSearch();
        $notafiscal_indpres_id->enableSearch();
        $notafiscal_modfrete_id->enableSearch();
        $notafiscal_indiedest_id->enableSearch();
        $nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id->enableSearch();
        $nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id->enableSearch();
        $nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id->enableSearch();
        $nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id->enableSearch();

        $id->setEditable(false);
        $vtroco->setEditable(false);
        $criado_em->setEditable(false);
        $ipi_valor->setEditable(false);
        $criado_por->setEditable(false);
        $icms_valor->setEditable(false);
        $alterado_em->setEditable(false);
        $frete_valor->setEditable(false);
        $alterado_por->setEditable(false);
        $seguro_valor->setEditable(false);
        $icms_basecalc->setEditable(false);
        $ipi_vipidevol->setEditable(false);
        $desconto_valor->setEditable(false);
        $cliente_cpfcnpj->setEditable(false);
        $outras_despesas->setEditable(false);
        $icms_subst_valor->setEditable(false);
        $valor_total_nota->setEditable(false);
        $icms_subst_base_calc->setEditable(false);
        $valor_total_produtos->setEditable(false);
        $nota_fiscal_compra_situacao_id->setEditable(false);

        $id->setSize('100%');
        $serie->setSize('100%');
        $natop->setSize('100%');
        $chave->setSize('100%');
        $numero->setSize('100%');
        $vtroco->setSize('100%');
        $criado_em->setSize('100%');
        $cliente_nome->setSize(200);
        $ipi_valor->setSize('100%');
        $data_saida->setSize('100%');
        $infcpl->setSize('100%', 70);
        $criado_por->setSize('100%');
        $icms_valor->setSize('100%');
        $alterado_em->setSize('100%');
        $cliente_cep->setSize('100%');
        $lista_itens->setSize('100%');
        $frete_valor->setSize('100%');
        $data_emissao->setSize('100%');
        $alterado_por->setSize('100%');
        $seguro_valor->setSize('100%');
        $fornecedor_id->setSize('100%');
        $fatura_numero->setSize('100%');
        $icms_basecalc->setSize('100%');
        $ipi_vipidevol->setSize('100%');
        $infadfisco->setSize('100%', 70);
        $cliente_numero->setSize('100%');
        $cliente_bairro->setSize('100%');
        $cliente_cidade->setSize('100%');
        $cliente_estado->setSize('100%');
        $desconto_valor->setSize('100%');
        $cliente_cpfcnpj->setSize('100%');
        $cliente_inscest->setSize('100%');
        $outras_despesas->setSize('100%');
        $cliente_inscmuni->setSize('100%');
        $cliente_endereco->setSize('100%');
        $icms_subst_valor->setSize('100%');
        $valor_total_nota->setSize('100%');
        $notafiscal_mod_id->setSize('100%');
        $notafiscal_iddest_id->setSize(200);
        $notafiscal_crt_id->setSize('100%');
        $notafiscal_indfinal_id->setSize(200);
        $cliente_complemento->setSize('100%');
        $notafiscal_finnfe_id->setSize('100%');
        $notafiscal_indpag_id->setSize('100%');
        $fatura_valor_liquido->setSize('100%');
        $icms_subst_base_calc->setSize('100%');
        $valor_total_produtos->setSize('100%');
        $notafiscal_indpres_id->setSize('100%');
        $fatura_valor_original->setSize('100%');
        $fatura_valor_desconto->setSize('100%');
        $notafiscal_modfrete_id->setSize('100%');
        $cliente_cidade_codibge->setSize('100%');
        $notafiscal_indiedest_id->setSize('100%');
        $notafiscal_tipodocumento_id->setSize(200);
        $nota_fiscal_compra_situacao_id->setSize('100%', 55);
        $nota_fiscal_compra_pag_nota_fiscal_compra_id->setSize(200);
        $nota_fiscal_compra_dup_nota_fiscal_compra_id->setSize(200);
        $nota_fiscal_compra_pag_nota_fiscal_compra_vpag->setSize('100%');
        $nota_fiscal_compra_pag_nota_fiscal_compra_xpag->setSize('100%');
        $nota_fiscal_compra_dup_nota_fiscal_compra_ndup->setSize('100%');
        $nota_fiscal_compra_dup_nota_fiscal_compra_vdup->setSize('100%');
        $nota_fiscal_compra_dup_nota_fiscal_compra_dvenc->setSize('100%');
        $nota_fiscal_compra_dup_nota_fiscal_compra_parcela->setSize('100%');
        $nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id->setSize('100%');
        $nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id->setSize('100%');
        $nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id->setSize('100%');
        $nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id->setSize('100%');

        $button_adicionar_nota_fiscal_compra_pag_nota_fiscal_compra->id = '637ffa66d0929';
        $button_adicionar_nota_fiscal_compra_dup_nota_fiscal_compra->id = '637ffaabd092d';

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $lista_itens->add($loadingContainer);

        $this->lista_itens = $lista_itens;

        $this->form->appendPage("Geral");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$nota_fiscal_compra_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Número:", '#ff0000', '14px', null, '100%'),$numero],[new TLabel("Série:", null, '14px', null, '100%'),$serie]);
        $row2->layout = ['col-sm-4','col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Data Emissão:", null, '14px', null, '100%'),$data_emissao],[new TLabel("Data Saída:", null, '14px', null, '100%'),$data_saida],[new TLabel("Modelo:", '#FF0000', '14px', null),$notafiscal_mod_id]);
        $row3->layout = [' col-sm-4',' col-sm-4','col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Natureza Operação:", null, '14px', null, '100%'),$natop],[new TLabel("Finalidade de Emissão:", null, '14px', null),$notafiscal_finnfe_id],[new TLabel("Indicador de Presença:", null, '14px', null),$notafiscal_indpres_id]);
        $row4->layout = ['col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([new TLabel("Modalidade do Frete:", null, '14px', null),$notafiscal_modfrete_id],[new TLabel("Chave:", null, '14px', null),$chave],[]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addFields([new TLabel("Informações complementares:", null, '14px', null, '100%'),$infcpl],[new TLabel("Informações do fisco:", null, '14px', null, '100%'),$infadfisco]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_637ff095d090f = new BContainer('bcontainer_637ff095d090f');
        $this->bcontainer_637ff095d090f = $bcontainer_637ff095d090f;

        $bcontainer_637ff095d090f->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_637ff095d090f->setBorderColor('#c0c0c0');

        $row7 = $bcontainer_637ff095d090f->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row7->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row8 = $this->form->addFields([$bcontainer_637ff095d090f]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addFields([$notafiscal_indfinal_id,$notafiscal_tipodocumento_id],[$notafiscal_iddest_id]);
        $row9->layout = [' col-sm-6','col-sm-6'];

        $this->form->appendPage("Fornecedor");
        $row10 = $this->form->addFields([new TLabel("Fornecedor:", '#ff0000', '14px', null, '100%'),$fornecedor_id,$cliente_nome],[new TLabel("CPF/CNPJ:", null, '14px', null, '100%'),$cliente_cpfcnpj]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->form->addFields([new TLabel("Inscrição Estadual:", null, '14px', null, '100%'),$cliente_inscest],[new TLabel("Inscrição Municipal:", null, '14px', null, '100%'),$cliente_inscmuni]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->form->addFields([new TLabel("CRT (Código de Regime Tributário):", null, '14px', null, '100%'),$notafiscal_crt_id],[new TLabel("Indicador da IE do destinatário:", null, '14px', null),$notafiscal_indiedest_id]);
        $row12->layout = ['col-sm-6',' col-sm-6'];

        $row13 = $this->form->addContent([new TFormSeparator("Endereço", '#333', '18', '#eee')]);
        $row14 = $this->form->addFields([new TLabel("CEP:", null, '14px', null, '100%'),$cliente_cep],[new TLabel("Endereço:", null, '14px', null, '100%'),$cliente_endereco]);
        $row14->layout = ['col-sm-6','col-sm-6'];

        $row15 = $this->form->addFields([new TLabel("Número:", null, '14px', null, '100%'),$cliente_numero],[new TLabel("Complemento:", null, '14px', null, '100%'),$cliente_complemento]);
        $row15->layout = ['col-sm-6','col-sm-6'];

        $row16 = $this->form->addFields([new TLabel("Bairro:", null, '14px', null, '100%'),$cliente_bairro],[new TLabel("Cidade:", null, '14px', null, '100%'),$cliente_cidade]);
        $row16->layout = ['col-sm-6','col-sm-6'];

        $row17 = $this->form->addFields([new TLabel("Estado:", null, '14px', null, '100%'),$cliente_estado],[new TLabel("Código IBGE Cidade:", null, '14px', null),$cliente_cidade_codibge]);
        $row17->layout = ['col-sm-6',' col-sm-6'];

        $this->form->appendPage("Produtos");
        $row18 = $this->form->addFields([$button_novo_item],[],[]);
        $row18->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row19 = $this->form->addFields([$lista_itens]);
        $row19->layout = [' col-sm-12'];

        $this->form->appendPage("Pagamentos");
        $row20 = $this->form->addFields([new TLabel("Indicador de Pagamento:", null, '14px', null),$notafiscal_indpag_id]);
        $row20->layout = [' col-sm-12'];

        $row21 = $this->form->addContent([new TFormSeparator("Meios de Pagamento", '#333', '18', '#eee')]);

        $this->detailFormNotaFiscalCompraPagNotaFiscalCompra = new BootstrapFormBuilder('detailFormNotaFiscalCompraPagNotaFiscalCompra');
        $this->detailFormNotaFiscalCompraPagNotaFiscalCompra->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotaFiscalCompraPagNotaFiscalCompra->setProperty('class', 'form-horizontal builder-detail-form');

        $row22 = $this->detailFormNotaFiscalCompraPagNotaFiscalCompra->addFields([new TLabel("Tipo de pagamento:", null, '14px', null),$nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id,$nota_fiscal_compra_pag_nota_fiscal_compra_id],[new TLabel("Valor:", null, '14px', null),$nota_fiscal_compra_pag_nota_fiscal_compra_vpag]);
        $row22->layout = [' col-sm-6','col-sm-6'];

        $row23 = $this->detailFormNotaFiscalCompraPagNotaFiscalCompra->addFields([new TLabel("Descrição meio de pagamento 99 (Outros):", null, '14px', null),$nota_fiscal_compra_pag_nota_fiscal_compra_xpag]);
        $row23->layout = [' col-sm-12'];

        $row24 = $this->detailFormNotaFiscalCompraPagNotaFiscalCompra->addFields([$button_adicionar_nota_fiscal_compra_pag_nota_fiscal_compra]);
        $row24->layout = [' col-sm-12'];

        $row25 = $this->detailFormNotaFiscalCompraPagNotaFiscalCompra->addFields([new THidden('nota_fiscal_compra_pag_nota_fiscal_compra__row__id')]);
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_criteria = new TCriteria();

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->disableHtmlConversion();;
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->generateHiddenFields();
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->setId('nota_fiscal_compra_pag_nota_fiscal_compra_list');

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->style = 'width:100%';
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->class .= ' table-bordered';

        $column_nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_descricao = new TDataGridColumn('notafiscal_tpag->descricao', "Tipo de pagamento", 'left');
        $column_nota_fiscal_compra_pag_nota_fiscal_compra_vpag_transformed = new TDataGridColumn('vpag', "Valor", 'left');

        $column_nota_fiscal_compra_pag_nota_fiscal_compra__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_nota_fiscal_compra_pag_nota_fiscal_compra__row__data->setVisibility(false);

        $column_nota_fiscal_compra_pag_nota_fiscal_compra_vpag_transformed->enableTotal('sum', 'R$', 2, ',', '.');

        $action_onEditDetailNotaFiscalCompraPag = new TDataGridAction(array('NotaFiscalCompraForm', 'onEditDetailNotaFiscalCompraPag'));
        $action_onEditDetailNotaFiscalCompraPag->setUseButton(false);
        $action_onEditDetailNotaFiscalCompraPag->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotaFiscalCompraPag->setLabel("Editar");
        $action_onEditDetailNotaFiscalCompraPag->setImage('far:edit #478fca');
        $action_onEditDetailNotaFiscalCompraPag->setFields(['__row__id', '__row__data']);

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->addAction($action_onEditDetailNotaFiscalCompraPag);
        $action_onDeleteDetailNotaFiscalCompraPag = new TDataGridAction(array('NotaFiscalCompraForm', 'onDeleteDetailNotaFiscalCompraPag'));
        $action_onDeleteDetailNotaFiscalCompraPag->setUseButton(false);
        $action_onDeleteDetailNotaFiscalCompraPag->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotaFiscalCompraPag->setLabel("Excluir");
        $action_onDeleteDetailNotaFiscalCompraPag->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotaFiscalCompraPag->setFields(['__row__id', '__row__data']);

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->addAction($action_onDeleteDetailNotaFiscalCompraPag);

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_descricao);
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_pag_nota_fiscal_compra_vpag_transformed);

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_pag_nota_fiscal_compra__row__data);

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->nota_fiscal_compra_pag_nota_fiscal_compra_list);
        $this->detailFormNotaFiscalCompraPagNotaFiscalCompra->addContent([$tableResponsiveDiv]);

        $column_nota_fiscal_compra_pag_nota_fiscal_compra_vpag_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row26 = $this->form->addFields([$this->detailFormNotaFiscalCompraPagNotaFiscalCompra]);
        $row26->layout = [' col-sm-12'];

        $this->form->appendPage("Cobrança");
        $row27 = $this->form->addContent([new TFormSeparator("Dados da Fatura", '#333', '18', '#eee')]);
        $row28 = $this->form->addFields([new TLabel("Número:", null, '14px', null),$fatura_numero],[new TLabel("Valor Original:", null, '14px', null),$fatura_valor_original],[new TLabel("Valor Desconto:", null, '14px', null),$fatura_valor_desconto],[new TLabel("Valor Líquido:", null, '14px', null),$fatura_valor_liquido]);
        $row28->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row29 = $this->form->addContent([new TFormSeparator("Vencimentos", '#333', '18', '#eee')]);

        $this->detailFormNotaFiscalCompraDupNotaFiscalCompra = new BootstrapFormBuilder('detailFormNotaFiscalCompraDupNotaFiscalCompra');
        $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->setProperty('class', 'form-horizontal builder-detail-form');

        $row30 = $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->addFields([new TLabel("Forma de Pagamento:", '#F44336', '14px', null),$nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id],[new TLabel("Nº Documento:", '#F44336', '14px', null, '100%'),$nota_fiscal_compra_dup_nota_fiscal_compra_ndup]);
        $row30->layout = [' col-sm-8','col-sm-4'];

        $row31 = $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->addFields([new TLabel("Parcela:", null, '14px', null),$nota_fiscal_compra_dup_nota_fiscal_compra_parcela],[new TLabel("Vencimento:", '#F44336', '14px', null, '100%'),$nota_fiscal_compra_dup_nota_fiscal_compra_dvenc],[new TLabel("Valor:", '#F44336', '14px', null, '100%'),$nota_fiscal_compra_dup_nota_fiscal_compra_vdup]);
        $row31->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row32 = $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->addFields([new TLabel("Plano de Conta:", null, '14px', null),$nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id],[new TLabel("Centro de Custo:", null, '14px', null),$nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id]);
        $row32->layout = [' col-sm-6','col-sm-6'];

        $row33 = $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->addFields([$button_adicionar_nota_fiscal_compra_dup_nota_fiscal_compra,$nota_fiscal_compra_dup_nota_fiscal_compra_id]);
        $row33->layout = [' col-sm-12'];

        $row34 = $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->addFields([new THidden('nota_fiscal_compra_dup_nota_fiscal_compra__row__id')]);
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_criteria = new TCriteria();

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->disableHtmlConversion();;
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->generateHiddenFields();
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->setId('nota_fiscal_compra_dup_nota_fiscal_compra_list');

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->style = 'width:100%';
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->class .= ' table-bordered';

        $column_nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_descricao = new TDataGridColumn('forma_pagamento->descricao', "Forma de Pagamento", 'left');
        $column_nota_fiscal_compra_dup_nota_fiscal_compra_alterado_em = new TDataGridColumn('alterado_em', "Parcela", 'left');
        $column_nota_fiscal_compra_dup_nota_fiscal_compra_ndup = new TDataGridColumn('ndup', "Nº Documento", 'left');
        $column_nota_fiscal_compra_dup_nota_fiscal_compra_dvenc_transformed = new TDataGridColumn('dvenc', "Vencimento", 'left');
        $column_nota_fiscal_compra_dup_nota_fiscal_compra_vdup_transformed = new TDataGridColumn('vdup', "Valor", 'left');

        $column_nota_fiscal_compra_dup_nota_fiscal_compra__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_nota_fiscal_compra_dup_nota_fiscal_compra__row__data->setVisibility(false);

        $column_nota_fiscal_compra_dup_nota_fiscal_compra_vdup_transformed->enableTotal('sum', 'R$', 2, ',', '.');

        $action_onEditDetailNotaFiscalCompraDup = new TDataGridAction(array('NotaFiscalCompraForm', 'onEditDetailNotaFiscalCompraDup'));
        $action_onEditDetailNotaFiscalCompraDup->setUseButton(false);
        $action_onEditDetailNotaFiscalCompraDup->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotaFiscalCompraDup->setLabel("Editar");
        $action_onEditDetailNotaFiscalCompraDup->setImage('far:edit #478fca');
        $action_onEditDetailNotaFiscalCompraDup->setFields(['__row__id', '__row__data']);

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addAction($action_onEditDetailNotaFiscalCompraDup);
        $action_onDeleteDetailNotaFiscalCompraDup = new TDataGridAction(array('NotaFiscalCompraForm', 'onDeleteDetailNotaFiscalCompraDup'));
        $action_onDeleteDetailNotaFiscalCompraDup->setUseButton(false);
        $action_onDeleteDetailNotaFiscalCompraDup->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotaFiscalCompraDup->setLabel("Excluir");
        $action_onDeleteDetailNotaFiscalCompraDup->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotaFiscalCompraDup->setFields(['__row__id', '__row__data']);

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addAction($action_onDeleteDetailNotaFiscalCompraDup);

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_descricao);
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_dup_nota_fiscal_compra_alterado_em);
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_dup_nota_fiscal_compra_ndup);
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_dup_nota_fiscal_compra_dvenc_transformed);
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_dup_nota_fiscal_compra_vdup_transformed);

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addColumn($column_nota_fiscal_compra_dup_nota_fiscal_compra__row__data);

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->nota_fiscal_compra_dup_nota_fiscal_compra_list);
        $this->detailFormNotaFiscalCompraDupNotaFiscalCompra->addContent([$tableResponsiveDiv]);

        $column_nota_fiscal_compra_dup_nota_fiscal_compra_dvenc_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_nota_fiscal_compra_dup_nota_fiscal_compra_vdup_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row35 = $this->form->addFields([$this->detailFormNotaFiscalCompraDupNotaFiscalCompra]);
        $row35->layout = [' col-sm-12'];

        $this->form->appendPage("Totais");
        $row36 = $this->form->addFields([new TLabel("Base de cálculo do ICMS:", null, '14px', null, '100%'),$icms_basecalc],[new TLabel("Total do ICMS:", null, '14px', null, '100%'),$icms_valor],[new TLabel("Base de cálculo do ICMS ST:", null, '14px', null, '100%'),$icms_subst_base_calc],[new TLabel("Total do ICMS ST:", null, '14px', null, '100%'),$icms_subst_valor]);
        $row36->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row37 = $this->form->addFields([new TLabel("Total do Frete:", null, '14px', null, '100%'),$frete_valor],[new TLabel("Total do Seguro:", null, '14px', null, '100%'),$seguro_valor],[new TLabel("Total do IPI:", null, '14px', null, '100%'),$ipi_valor],[new TLabel("Total Desconto:", null, '14px', null, '100%'),$desconto_valor]);
        $row37->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row38 = $this->form->addFields([new TLabel("Outras Despesas:", null, '14px', null, '100%'),$outras_despesas],[new TLabel("Total IPI Devolvido:", null, '14px', null, '100%'),$ipi_vipidevol]);
        $row38->layout = ['col-sm-3',' col-sm-3'];

        $row39 = $this->form->addFields([new TLabel("Total Produtos:", null, '14px', null, '100%'),$valor_total_produtos],[new TLabel("Total Nota:", null, '14px', null, '100%'),$valor_total_nota],[new TLabel("Troco:", null, '14px', null, '100%'),$vtroco]);
        $row39->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacao = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacao']), 'fas:bars #000000');
        $this->btn_onvisualizacao = $btn_onvisualizacao;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['NotaFiscalCompraList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Compras","Cadastro de nota fiscal de compra"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitFornecedor($param = null) 
    {
        try 
        {
            if (isset($param['fornecedor_id']) && $param['fornecedor_id'])
            {
                TTransaction::open(self::$database);

                $fornecedor = Fornecedor::find($param['fornecedor_id']);

                if($fornecedor)
                {
                    $object = new stdClass();

                    if ($fornecedor->pessoa_tipo_id==PessoaTipo::Fisica) 
                    {
                      $object->cliente_nome = $fornecedor->nome;
                    }
                    else
                    {
                      $object->cliente_nome = $fornecedor->razao_social;
                    }

                    $object->cliente_cpfcnpj         = Funcoes::mascaraCpfCnpj($fornecedor->cpf_cnpj);
                    $object->cliente_inscest         = $fornecedor->insc_estadual;
                    $object->cliente_inscmuni        = $fornecedor->insc_municipal;
                    $object->cliente_fone            = $fornecedor->fone;
                    $object->notafiscal_crt_id       = $fornecedor->notafiscal_crt_id;

                    $object->notafiscal_indiedest_id = $fornecedor->notafiscal_indiedest_id;

                    if($fornecedor->notafiscal_indiedest_id == NotafiscalIndiedest::NaoContribuinte)
                    {
                        $object->notafiscal_indfinal_id = NotafiscalIndfinal::Sim;                        
                    }
                    else
                    {
                        $object->notafiscal_indfinal_id = NotafiscalIndfinal::Nao;
                    }

            	    $object->cliente_endereco = $fornecedor->logradouro;
                    $object->cliente_complemento = $fornecedor->complemento;
                    $object->cliente_numero = $fornecedor->numero;
                    $object->cliente_bairro = $fornecedor->bairro;
                    $object->cliente_cep = $fornecedor->cep;
                    $object->cliente_cidade = $fornecedor->cidade->nome;
                    $object->cliente_cidade_codibge = $fornecedor->cidade->codigo_ibge;
                    $object->cliente_estado = $fornecedor->cidade->estado->sigla;

                    TForm::sendData(self::$formName, $object);

                }

                TTransaction::close();
            }
            else
            {
                 $object = new stdClass();

                 $object->cliente_nome            = '';
                 $object->cliente_cpfcnpj         = '';
                 $object->cliente_inscest         = '';
                 $object->cliente_inscmuni        = '';
                 $object->cliente_fone            = '';
                 $object->notafiscal_crt_id       = '';
                //  $object->notafiscal_indiedest_id = '';

                 $object->cliente_endereco        = '';
                 $object->cliente_complemento     = '';
                 $object->cliente_numero          = '';
                 $object->cliente_bairro          = '';
                 $object->cliente_cep             = '';
                 $object->cliente_cidade          = '';
                 $object->cliente_cidade_codibge  = '';
                 $object->cliente_estado          = '';    

                 TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onNovoItem($param = null) 
    {
        try 
        {
            if($param['id'] == '')
            {
                throw new Exception('Favor salvar a nota antes de adicionar itens nela.');
            }

            TApplication::loadPage('NotaFiscalCompraItensForm', 'onShow', ['nota_fiscal_compra_id' => $param['id']]);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailNotaFiscalCompraPagNotaFiscalCompra($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $__row__id = !empty($data->nota_fiscal_compra_pag_nota_fiscal_compra__row__id) ? $data->nota_fiscal_compra_pag_nota_fiscal_compra__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotaFiscalCompraPag();
            $grid_data->__row__id = $__row__id;
            $grid_data->notafiscal_tpag_id = $data->nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id;
            $grid_data->id = $data->nota_fiscal_compra_pag_nota_fiscal_compra_id;
            $grid_data->vpag = $data->nota_fiscal_compra_pag_nota_fiscal_compra_vpag;
            $grid_data->xpag = $data->nota_fiscal_compra_pag_nota_fiscal_compra_xpag;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['notafiscal_tpag_id'] =  $param['nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['nota_fiscal_compra_pag_nota_fiscal_compra_id'] ?? null;
            $__row__data['__display__']['vpag'] =  $param['nota_fiscal_compra_pag_nota_fiscal_compra_vpag'] ?? null;
            $__row__data['__display__']['xpag'] =  $param['nota_fiscal_compra_pag_nota_fiscal_compra_xpag'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->nota_fiscal_compra_pag_nota_fiscal_compra_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('nota_fiscal_compra_pag_nota_fiscal_compra_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_id = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_vpag = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_xpag = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#637ffa66d0929');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNotaFiscalCompraDupNotaFiscalCompra($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            //não deixar incluir plano de conta ou centro de custo SINTETICO, apenas ANALITICO...
            $plano_conta_id = $param['nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id'];
            $centro_custo_id = $param['nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id'];

            ContabilLancamentos::ValidaLancamentoContabil($plano_conta_id,$centro_custo_id,PlanoContaOrigem::Devedora);            

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Forma de Pagamento", 'name'=>"nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Nº Documento", 'name'=>"nota_fiscal_compra_dup_nota_fiscal_compra_ndup", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Vencimento", 'name'=>"nota_fiscal_compra_dup_nota_fiscal_compra_dvenc", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor", 'name'=>"nota_fiscal_compra_dup_nota_fiscal_compra_vdup", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->nota_fiscal_compra_dup_nota_fiscal_compra__row__id) ? $data->nota_fiscal_compra_dup_nota_fiscal_compra__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotaFiscalCompraDup();
            $grid_data->__row__id = $__row__id;
            $grid_data->forma_pagamento_id = $data->nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id;
            $grid_data->ndup = $data->nota_fiscal_compra_dup_nota_fiscal_compra_ndup;
            $grid_data->parcela = $data->nota_fiscal_compra_dup_nota_fiscal_compra_parcela;
            $grid_data->dvenc = $data->nota_fiscal_compra_dup_nota_fiscal_compra_dvenc;
            $grid_data->vdup = $data->nota_fiscal_compra_dup_nota_fiscal_compra_vdup;
            $grid_data->plano_conta_id = $data->nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id;
            $grid_data->centro_custo_id = $data->nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id;
            $grid_data->id = $data->nota_fiscal_compra_dup_nota_fiscal_compra_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['forma_pagamento_id'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id'] ?? null;
            $__row__data['__display__']['ndup'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_ndup'] ?? null;
            $__row__data['__display__']['parcela'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_parcela'] ?? null;
            $__row__data['__display__']['dvenc'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_dvenc'] ?? null;
            $__row__data['__display__']['vdup'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_vdup'] ?? null;
            $__row__data['__display__']['plano_conta_id'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id'] ?? null;
            $__row__data['__display__']['centro_custo_id'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['nota_fiscal_compra_dup_nota_fiscal_compra_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->nota_fiscal_compra_dup_nota_fiscal_compra_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('nota_fiscal_compra_dup_nota_fiscal_compra_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_ndup = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_parcela = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_dvenc = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_vdup = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#637ffaabd092d');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailNotaFiscalCompraPag($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id = $__row__data->__display__->notafiscal_tpag_id ?? null;
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_id = $__row__data->__display__->id ?? null;
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_vpag = $__row__data->__display__->vpag ?? null;
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_xpag = $__row__data->__display__->xpag ?? null;
            $data->nota_fiscal_compra_pag_nota_fiscal_compra__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#637ffa66d0929');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotaFiscalCompraPag($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_notafiscal_tpag_id = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_id = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_vpag = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra_xpag = '';
            $data->nota_fiscal_compra_pag_nota_fiscal_compra__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('nota_fiscal_compra_pag_nota_fiscal_compra_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNotaFiscalCompraDup($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id = $__row__data->__display__->forma_pagamento_id ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_ndup = $__row__data->__display__->ndup ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_parcela = $__row__data->__display__->parcela ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_dvenc = $__row__data->__display__->dvenc ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_vdup = $__row__data->__display__->vdup ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id = $__row__data->__display__->plano_conta_id ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id = $__row__data->__display__->centro_custo_id ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_id = $__row__data->__display__->id ?? null;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#637ffaabd092d');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotaFiscalCompraDup($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_forma_pagamento_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_ndup = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_parcela = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_dvenc = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_vdup = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_plano_conta_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_centro_custo_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra_id = '';
            $data->nota_fiscal_compra_dup_nota_fiscal_compra__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('nota_fiscal_compra_dup_nota_fiscal_compra_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new NotaFiscalCompra(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);   

            if($data->id == "")
            {
                $object->system_unit_id = TSession::getValue('userunitid'); 
            }            

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $nota_fiscal_compra_dup_nota_fiscal_compra_items = $this->storeMasterDetailItems('NotaFiscalCompraDup', 'nota_fiscal_compra_id', 'nota_fiscal_compra_dup_nota_fiscal_compra', $object, $param['nota_fiscal_compra_dup_nota_fiscal_compra_list___row__data'] ?? [], $this->form, $this->nota_fiscal_compra_dup_nota_fiscal_compra_list, function($masterObject, $detailObject){ 

                //code here

                Funcoes::SalvarUsuarioCadastro($detailObject);

            }, $this->nota_fiscal_compra_dup_nota_fiscal_compra_criteria); 

            $nota_fiscal_compra_pag_nota_fiscal_compra_items = $this->storeMasterDetailItems('NotaFiscalCompraPag', 'nota_fiscal_compra_id', 'nota_fiscal_compra_pag_nota_fiscal_compra', $object, $param['nota_fiscal_compra_pag_nota_fiscal_compra_list___row__data'] ?? [], $this->form, $this->nota_fiscal_compra_pag_nota_fiscal_compra_list, function($masterObject, $detailObject){ 

                //code here

                Funcoes::SalvarUsuarioCadastro($detailObject);

            }, $this->nota_fiscal_compra_pag_nota_fiscal_compra_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacao($param = null) 
    {
        try 
        {
            $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve a nota para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('NotaFiscalCompraFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new NotaFiscalCompra($key); // instantiates the Active Record 

                TSession::setValue('nota_fiscal_compra_id', $object->id);

                $nota_fiscal_compra_dup_nota_fiscal_compra_items = $this->loadMasterDetailItems('NotaFiscalCompraDup', 'nota_fiscal_compra_id', 'nota_fiscal_compra_dup_nota_fiscal_compra', $object, $this->form, $this->nota_fiscal_compra_dup_nota_fiscal_compra_list, $this->nota_fiscal_compra_dup_nota_fiscal_compra_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $nota_fiscal_compra_pag_nota_fiscal_compra_items = $this->loadMasterDetailItems('NotaFiscalCompraPag', 'nota_fiscal_compra_id', 'nota_fiscal_compra_pag_nota_fiscal_compra', $object, $this->form, $this->nota_fiscal_compra_pag_nota_fiscal_compra_list, $this->nota_fiscal_compra_pag_nota_fiscal_compra_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->nota_fiscal_compra_situacao_id  = NotaFiscalCompraSituacao::EmDigitacao;

        $object->notafiscal_iddest_id        = NotafiscalIddest::OperacaoInterna;
        // $object->notafiscal_tpimp_id         = NotafiscalTpimp::Paisagem;
        $object->notafiscal_tpemis_id        = NotafiscalTpemis::Normal;
        $object->notafiscal_finnfe_id        = NotafiscalFinnfe::NfeNormal;
        $object->notafiscal_indfinal_id      = NotafiscalIndfinal::Nao;
        $object->notafiscal_indpres_id       = NotafiscalIndpres::NaoSeAplica;
        $object->notafiscal_indpag_id        = NotafiscalIndpag::PagamentoAVista;
        $object->notafiscal_mod_id           = NotafiscalMod::NFe;
        $object->notafiscal_modfrete_id      = NotafiscalModfrete::SemOcorrencia;
        $object->notafiscal_tipodocumento_id = NotafiscalTipodocumento::Saida;
        $object->data_emissao                = date('d/m/Y H:i');
        $object->data_saida                  = date('d/m/Y H:i');

        TTransaction::open(self::$database);

        $filial = SystemUnit::find(TSession::getValue('userunitid'));

        if($filial)
        {
            $object->notafiscal_crt_id   = $filial->notafiscal_crt_id;
            $object->notafiscal_tpimp_id = $filial->nfe_tpimp_id;
            $object->notafiscal_tpamb_id = $filial->nfe_tpamb_id;  

            $natureza = NaturezaOperacao::find($filial->natureza_operacao_compra_id);

            if(!is_null($natureza))
            {
                $object->natop = $natureza->descricao;
                $object->notafiscal_indfinal_id = $natureza->consumidor_final_id;
                $object->infcpl = $natureza->obs_padrao;
            }

        }

        TTransaction::close();

        TForm::sendData(self::$formName, $object);

        TSession::setValue('nfcompra_aba_items', false);

        // $this->fireEvents($object);

        // $object = new stdClass();
        // $object->serie = $idserie;

        // TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

