<?php

class NotaFiscalCompraFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NotaFiscalCompra';
    private static $primaryKey = 'id';
    private static $formName = 'formView_NotaFiscalCompra';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $nota_fiscal_compra = new NotaFiscalCompra($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Nota Fiscal de Compra");

        $tdbarrowstep4 = new TDBArrowStep('tdbarrowstep4', 'kraftsoft', 'NotaFiscalCompraSituacao', 'id', '{descricao}','id asc' );
        $lbid = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($nota_fiscal_compra->id, '', '15px', '');
        $lbnumero = new TLabel("Número:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($nota_fiscal_compra->numero, '', '15px', '');
        $lbserie = new TLabel("serie:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay($nota_fiscal_compra->serie, '', '15px', '');
        $lbdataemissao = new TLabel("Data Emissão:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay(TDateTime::convertToMask($nota_fiscal_compra->data_emissao, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbdatasaida = new TLabel("Data Saída:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(TDateTime::convertToMask($nota_fiscal_compra->data_saida, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbmodelo = new TLabel("Modelo:", '', '15px', 'B', '100%');
        $txtmodelo = new TTextDisplay($nota_fiscal_compra->notafiscal_mod->descricao, '', '15px', '');
        $lbnatop = new TLabel("Natureza Operação:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($nota_fiscal_compra->natop, '', '15px', '');
        $lbfinalidade = new TLabel("Finalidade de Emissão:", '', '15px', 'B', '100%');
        $txtfinalidade = new TTextDisplay($nota_fiscal_compra->notafiscal_finnfe->descricao, '', '15px', '');
        $lbindpres = new TLabel("Indicador de Presença:", '', '15px', 'B', '100%');
        $txtindpres = new TTextDisplay($nota_fiscal_compra->notafiscal_indpres->descricao, '', '15px', '');
        $label8 = new TLabel("Modalidade do Frete:", '', '15px', 'B', '100%');
        $txtmodfrete = new TTextDisplay($nota_fiscal_compra->notafiscal_modfrete->descricao, '', '15px', '');
        $lbchave = new TLabel("Chave:", '', '15px', 'B', '100%');
        $txtchave = new TTextDisplay($nota_fiscal_compra->chave, '', '15px', '');
        $label32 = new TLabel("Fornecedor:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($nota_fiscal_compra->fornecedor_xml, '', '15px', '');
        $label34 = new TLabel("CPF/CNPJ:", '', '15px', 'B', '100%');
        $text48 = new TTextDisplay($nota_fiscal_compra->cliente_cpfcnpj, '', '15px', '');
        $lbinscestadual = new TLabel("Inscrição Estadual:", '', '15px', 'B', '100%');
        $text49 = new TTextDisplay($nota_fiscal_compra->cliente_inscest, '', '15px', '');
        $lbinscmuni = new TLabel("Inscrição Municipal:", '', '15px', 'B', '100%');
        $txtinscmuni = new TTextDisplay($nota_fiscal_compra->cliente_inscmuni, '', '15px', '');
        $lbcrt = new TLabel("CRT (Código de Regime Tributário):", '', '15px', 'B', '100%');
        $text38 = new TTextDisplay($nota_fiscal_compra->notafiscal_crt->descricao, '', '15px', '');
        $lbiedest = new TLabel("Indicador da IE do destinatário:", '', '15px', 'B', '100%');
        $txtindiedest = new TTextDisplay($nota_fiscal_compra->notafiscal_indiedest->descricao, '', '15px', '');
        $lbcep = new TLabel("CEP:", '', '15px', 'B', '100%');
        $text45 = new TTextDisplay($nota_fiscal_compra->cliente_cep, '', '15px', '');
        $lbendereco = new TLabel("Endereço:", '', '15px', 'B', '100%');
        $text40 = new TTextDisplay($nota_fiscal_compra->cliente_endereco, '', '15px', '');
        $lbendnumero = new TLabel("Número:", '', '15px', 'B', '100%');
        $text42 = new TTextDisplay($nota_fiscal_compra->cliente_numero, '', '15px', '');
        $lbcomplemento = new TLabel("Complemento:", '', '15px', 'B', '100%');
        $text41 = new TTextDisplay($nota_fiscal_compra->cliente_complemento, '', '15px', '');
        $lbbairro = new TLabel("Bairro:", '', '15px', 'B', '100%');
        $text43 = new TTextDisplay($nota_fiscal_compra->cliente_bairro, '', '15px', '');
        $lbcidade = new TLabel("Cidade:", '', '15px', 'B', '100%');
        $text44 = new TTextDisplay($nota_fiscal_compra->cliente_cidade, '', '15px', '');
        $lbestado = new TLabel("Estado:", '', '15px', 'B', '100%');
        $text46 = new TTextDisplay($nota_fiscal_compra->cliente_estado, '', '15px', '');
        $label58 = new TLabel("Código IBGE Cidade:", '', '15px', 'B', '100%');
        $txtcidadecodibge = new TTextDisplay($nota_fiscal_compra->cliente_cidade_codibge, '', '15px', '');
        $lbindpag = new TLabel("Indicador de Pagamento:", '', '15px', 'B', '100%');
        $txtindpag = new TTextDisplay($nota_fiscal_compra->notafiscal_indpag->descricao, '', '15px', '');
        $lbbasecalcicms = new TLabel("Base de cálculo do ICMS:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(number_format((double)$nota_fiscal_compra->icms_basecalc, '2', ',', '.'), '', '15px', '');
        $label4 = new TLabel("Total do ICMS:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay(number_format((double)$nota_fiscal_compra->icms_valor, '2', ',', '.'), '', '15px', '');
        $lbbasecalcicmsst = new TLabel("Base de cálculo do ICMS ST:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(number_format((double)$nota_fiscal_compra->icms_subst_base_calc, '2', ',', '.'), '', '15px', '');
        $lbicmssubstvalor = new TLabel("Total do ICMS ST:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(number_format((double)$nota_fiscal_compra->icms_subst_valor, '2', ',', '.'), '', '15px', '');
        $label10 = new TLabel("Total do Frete:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay(number_format((double)$nota_fiscal_compra->frete_valor, '2', ',', '.'), '', '15px', '');
        $lbtotseguro = new TLabel("Total do Seguro:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay(number_format((double)$nota_fiscal_compra->seguro_valor, '2', ',', '.'), '', '15px', '');
        $lbtotipi = new TLabel("Total do IPI:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(number_format((double)$nota_fiscal_compra->ipi_valor, '2', ',', '.'), '', '15px', '');
        $lbtotdesconto = new TLabel("Total Desconto:", '', '15px', 'B', '100%');
        $txtdesconto = new TTextDisplay($nota_fiscal_compra->desconto_valor, '', '15px', '');
        $label18 = new TLabel("Outras Despesas:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(number_format((double)$nota_fiscal_compra->outras_despesas, '2', ',', '.'), '', '15px', '');
        $lbipidevol = new TLabel("Total IPI Devolvido:", '', '15px', 'B', '100%');
        $txtipidevol = new TTextDisplay($nota_fiscal_compra->ipi_vipidevol, '', '15px', '');
        $label22 = new TLabel("Total Produtos:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay(number_format((double)$nota_fiscal_compra->valor_total_produtos, '2', ',', '.'), '', '15px', '');
        $label24 = new TLabel("Total Nota:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay(number_format((double)$nota_fiscal_compra->valor_total_nota, '2', ',', '.'), '', '15px', '');
        $lbinfcpl = new TLabel("Informações complementares:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay($nota_fiscal_compra->infcpl, '', '15px', '');
        $infadfisco = new TLabel("Informações do fisco:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($nota_fiscal_compra->infadfisco, '', '15px', '');
        $label2 = new TLabel("Observações de importação XML:", '', '15px', 'B', '100%');
        $text39 = new TTextDisplay($nota_fiscal_compra->obs_importacao_xml, '', '15px', '');
        $lbcriadoem = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay(TDateTime::convertToMask($nota_fiscal_compra->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbcriadopor = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($nota_fiscal_compra->criado_por, '', '15px', '');
        $lbalteradoem = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay(TDateTime::convertToMask($nota_fiscal_compra->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbalteradopor = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay($nota_fiscal_compra->alterado_por, '', '15px', '');

        $tdbarrowstep4->setEditable(false);
        $tdbarrowstep4->setColorColumn('cor');
        $tdbarrowstep4->setFilledColor('#fd9308');
        $tdbarrowstep4->setFilledFontColor('#ffffff');
        $tdbarrowstep4->setUnfilledColor('#d3d3d3');
        $tdbarrowstep4->setUnfilledFontColor('#333333');
        $tdbarrowstep4->setWidth('100%');
        $tdbarrowstep4->setHeight('60');
        $tdbarrowstep4->setValue($nota_fiscal_compra->nota_fiscal_compra_situacao_id);

        $row1 = $this->form->addFields([$tdbarrowstep4]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$lbid,$text1],[$lbnumero,$text4],[$lbserie,$text23]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([$lbdataemissao,$text5],[$lbdatasaida,$text12],[$lbmodelo,$txtmodelo]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([$lbnatop,$text11],[$lbfinalidade,$txtfinalidade],[$lbindpres,$txtindpres]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$label8,$txtmodfrete],[$lbchave,$txtchave]);
        $row5->layout = [' col-sm-4',' col-sm-4'];

        $tab_642336999c71d = new BootstrapFormBuilder('tab_642336999c71d');
        $this->tab_642336999c71d = $tab_642336999c71d;
        $tab_642336999c71d->setProperty('style', 'border:none; box-shadow:none;');

        $tab_642336999c71d->appendPage("Produtos");

        $tab_642336999c71d->addFields([new THidden('current_tab_tab_642336999c71d')]);
        $tab_642336999c71d->setTabFunction("$('[name=current_tab_tab_642336999c71d]').val($(this).attr('data-current_page'));");

        $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list = new TQuickGrid;
        $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->disableHtmlConversion();
        $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->style = 'width:100%';
        $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->disableDefaultClick();

        $action_onShow = new TDataGridAction(array('NotaFiscalCompraVincularProduto', 'onShow'));
        $action_onShow->setUseButton(true);
        $action_onShow->setButtonClass('btn btn-default btn-sm');
        $action_onShow->setLabel("Vincular Produto");
        $action_onShow->setImage('fas:link #E91E63');
        $action_onShow->setField('id');
        $action_onShow->setDisplayCondition('NotaFiscalCompraFormView::onExibeVincularProduto');
        $action_onShow->setParameter('key', '{id}');
        $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addAction($action_onShow);

        $column_produto_xml = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("Produto", 'produto_xml', 'left' , '20%');
        $column_ncm = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("NCM", 'ncm', 'left');
        $column_cfop = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("CFOP", 'cfop', 'left');
        $column_ucom = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("Unidade", 'ucom', 'left');
        $column_qcom_transformed = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("Quantidade", 'qcom', 'left');
        $column_vuncom_transformed = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("Valor Unit.", 'vuncom', 'left');
        $column_vprod_transformed = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("Valor Total", 'vprod', 'left');
        $column_xped = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("Nº Pedido", 'xped', 'left');
        $column_nitemped = $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addQuickColumn("Nº Item Pedido", 'nitemped', 'left');

        $column_qcom_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_vuncom_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_vprod_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->createModel();

        $criteria_nota_fiscal_compra_itens_nota_fiscal_compra_id = new TCriteria();
        $criteria_nota_fiscal_compra_itens_nota_fiscal_compra_id->add(new TFilter('nota_fiscal_compra_id', '=', $nota_fiscal_compra->id));

        $criteria_nota_fiscal_compra_itens_nota_fiscal_compra_id->setProperty('order', 'id desc');

        $nota_fiscal_compra_itens_nota_fiscal_compra_id_items = NotaFiscalCompraItens::getObjects($criteria_nota_fiscal_compra_itens_nota_fiscal_compra_id);

        $this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list->addItems($nota_fiscal_compra_itens_nota_fiscal_compra_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->nota_fiscal_compra_itens_nota_fiscal_compra_id_list));

        $tab_642336999c71d->addContent([$panel]);

        $tab_642336999c71d->appendPage("Fornecedor");
        $row6 = $tab_642336999c71d->addFields([$label32,$text3],[$label34,$text48]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $tab_642336999c71d->addFields([$lbinscestadual,$text49],[$lbinscmuni,$txtinscmuni]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $tab_642336999c71d->addFields([$lbcrt,$text38],[$lbiedest,$txtindiedest]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        $row9 = $tab_642336999c71d->addFields([$lbcep,$text45],[$lbendereco,$text40]);
        $row9->layout = [' col-sm-6','col-sm-6'];

        $row10 = $tab_642336999c71d->addFields([$lbendnumero,$text42],[$lbcomplemento,$text41]);
        $row10->layout = [' col-sm-6','col-sm-6'];

        $row11 = $tab_642336999c71d->addFields([$lbbairro,$text43],[$lbcidade,$text44]);
        $row11->layout = [' col-sm-6','col-sm-6'];

        $row12 = $tab_642336999c71d->addFields([$lbestado,$text46],[$label58,$txtcidadecodibge]);
        $row12->layout = [' col-sm-6','col-sm-6'];

        $tab_642336999c71d->appendPage("Pagamentos");
        $row13 = $tab_642336999c71d->addFields([$lbindpag,$txtindpag]);
        $row13->layout = [' col-sm-12'];

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list = new TQuickGrid;
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list->disableHtmlConversion();
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list->style = 'width:100%';
        $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list->disableDefaultClick();

        $column_notafiscal_tpag_descricao = $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list->addQuickColumn("Tipo de Pagamento", 'notafiscal_tpag->descricao', 'left');
        $column_vpag_transformed = $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list->addQuickColumn("Valor", 'vpag', 'left');

        $column_vpag_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list->createModel();

        $criteria_nota_fiscal_compra_pag_nota_fiscal_compra_id = new TCriteria();
        $criteria_nota_fiscal_compra_pag_nota_fiscal_compra_id->add(new TFilter('nota_fiscal_compra_id', '=', $nota_fiscal_compra->id));

        $criteria_nota_fiscal_compra_pag_nota_fiscal_compra_id->setProperty('order', 'id desc');

        $nota_fiscal_compra_pag_nota_fiscal_compra_id_items = NotaFiscalCompraPag::getObjects($criteria_nota_fiscal_compra_pag_nota_fiscal_compra_id);

        $this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list->addItems($nota_fiscal_compra_pag_nota_fiscal_compra_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->nota_fiscal_compra_pag_nota_fiscal_compra_id_list));

        $tab_642336999c71d->addContent([$panel]);

        $tab_642336999c71d->appendPage("Cobrança");

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list = new TQuickGrid;
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->disableHtmlConversion();
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->style = 'width:100%';
        $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->disableDefaultClick();

        $column_forma_pagamento_descricao = $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addQuickColumn("Forma de Pagamento", 'forma_pagamento->descricao', 'left');
        $column_ndup = $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addQuickColumn("Nº Documento", 'ndup', 'left');
        $column_parcela = $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addQuickColumn("Parcela", 'parcela', 'left');
        $column_vdup_transformed = $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addQuickColumn("Valor", 'vdup', 'left');
        $column_dvenc_transformed = $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addQuickColumn("Vencimento", 'dvenc', 'left');
        $column_plano_conta_descricao = $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addQuickColumn("Plano de Conta", 'plano_conta->descricao', 'left');
        $column_centro_custo_descricao = $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addQuickColumn("Centro de Custo", 'centro_custo->descricao', 'left');

        $column_vdup_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_dvenc_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->createModel();

        $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_id = new TCriteria();
        $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_id->add(new TFilter('nota_fiscal_compra_id', '=', $nota_fiscal_compra->id));

        $criteria_nota_fiscal_compra_dup_nota_fiscal_compra_id->setProperty('order', 'id desc');

        $nota_fiscal_compra_dup_nota_fiscal_compra_id_items = NotaFiscalCompraDup::getObjects($criteria_nota_fiscal_compra_dup_nota_fiscal_compra_id);

        $this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list->addItems($nota_fiscal_compra_dup_nota_fiscal_compra_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->nota_fiscal_compra_dup_nota_fiscal_compra_id_list));

        $tab_642336999c71d->addContent([$panel]);

        $tab_642336999c71d->appendPage("Totais");
        $row14 = $tab_642336999c71d->addFields([$lbbasecalcicms,$text15],[$label4,$text16],[$lbbasecalcicmsst,$text17],[$lbicmssubstvalor,$text18]);
        $row14->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row15 = $tab_642336999c71d->addFields([$label10,$text19],[$lbtotseguro,$text20],[$lbtotipi,$text22],[$lbtotdesconto,$txtdesconto]);
        $row15->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row16 = $tab_642336999c71d->addFields([$label18,$text21],[$lbipidevol,$txtipidevol],[]);
        $row16->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row17 = $tab_642336999c71d->addFields([$label22,$text24],[$label24,$text25],[]);
        $row17->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row18 = $this->form->addFields([$tab_642336999c71d]);
        $row18->layout = [' col-sm-12'];

        $row19 = $this->form->addFields([$lbinfcpl,$text13],[$infadfisco,$text14]);
        $row19->layout = [' col-sm-6','col-sm-6'];

        $row20 = $this->form->addFields([$label2,$text39]);
        $row20->layout = [' col-sm-12'];

        $row21 = $this->form->addContent([new TFormSeparator("Histórico de Atualizações", '#333', '18', '#eee')]);
        $row22 = $this->form->addFields([$lbcriadoem,$text6],[$lbcriadopor,$text9],[$lbalteradoem,$text10],[$lbalteradopor,$text8]);
        $row22->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        if(!empty($param['current_tab_tab_642336999c71d']))
        {
            $this->tab_642336999c71d->setCurrentPage($param['current_tab_tab_642336999c71d']);
        }

        $btnNotaFiscalCompraFormOnEditAction = new TAction(['NotaFiscalCompraForm', 'onEdit'],['key'=>$nota_fiscal_compra->id]);
        $btnNotaFiscalCompraFormOnEditLabel = new TLabel("Editar");

        $btnNotaFiscalCompraFormOnEdit = $this->form->addHeaderAction($btnNotaFiscalCompraFormOnEditLabel, $btnNotaFiscalCompraFormOnEditAction, 'fas:edit #2196F3'); 
        $btnNotaFiscalCompraFormOnEditLabel->setFontSize('12px'); 
        $btnNotaFiscalCompraFormOnEditLabel->setFontColor('#333'); 

        $btnVincularFornecedorAction = new TAction(['NotaFiscalCompraVincularFornecedor', 'onShow'],['key'=>$nota_fiscal_compra->id]);
        $btnVincularFornecedorLabel = new TLabel("Vincular Fornecedor");

        $btnVincularFornecedor = $this->form->addHeaderAction($btnVincularFornecedorLabel, $btnVincularFornecedorAction, 'fas:link #F44336'); 
        $btnVincularFornecedorLabel->setFontSize('12px'); 
        $btnVincularFornecedorLabel->setFontColor('#333'); 

        $btn_onfinalizarentradaAction = new TAction([$this, 'onFinalizarEntrada'],['key'=>$nota_fiscal_compra->id]);
        $btn_onfinalizarentradaLabel = new TLabel("Finalizar Entrada");

        $btn_onfinalizarentrada = $this->form->addHeaderAction($btn_onfinalizarentradaLabel, $btn_onfinalizarentradaAction, 'fas:check-circle #4CAF50'); 
        $btn_onfinalizarentradaLabel->setFontSize('12px'); 
        $btn_onfinalizarentradaLabel->setFontColor('#333'); 

        $btnEstornarEntradaAction = new TAction([$this, 'onEstornarEntrada'],['key'=>$nota_fiscal_compra->id]);
        $btnEstornarEntradaLabel = new TLabel("Estornar entrada");

        $btnEstornarEntrada = $this->form->addHeaderAction($btnEstornarEntradaLabel, $btnEstornarEntradaAction, 'fas:ban #E91E63'); 
        $btnEstornarEntradaLabel->setFontSize('12px'); 
        $btnEstornarEntradaLabel->setFontColor('#333'); 

        $btnNotaFiscalCompraListOnShowAction = new TAction(['NotaFiscalCompraList', 'onShow']);
        $btnNotaFiscalCompraListOnShowLabel = new TLabel("Voltar");

        $btnNotaFiscalCompraListOnShow = $this->form->addHeaderAction($btnNotaFiscalCompraListOnShowLabel, $btnNotaFiscalCompraListOnShowAction, 'fas:arrow-left #000000'); 
        $btnNotaFiscalCompraListOnShowLabel->setFontSize('12px'); 
        $btnNotaFiscalCompraListOnShowLabel->setFontColor('#333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Compras","Visualizar Nota Fiscal de Compra"]));
        }
        $container->add($this->form);

        if($nota_fiscal_compra->nota_fiscal_compra_situacao_id==NotaFiscalCompraSituacao::Finalizada
        or $nota_fiscal_compra->nota_fiscal_compra_situacao_id==NotaFiscalCompraSituacao::Cancelada)
        {
            TScript::create('document.getElementById("tbutton_finalizar_entrada").style.display = "none";');
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
        } 

        if (!$nota_fiscal_compra->fornecedor_id == null)
        {
            $btnVincularFornecedor->style = 'display:none';
        }

        if($nota_fiscal_compra->nota_fiscal_compra_situacao_id!=NotaFiscalCompraSituacao::Finalizada)        
        {
          $btnEstornarEntrada->style = 'display:none';  
        }

        TTransaction::close();
        parent::add($container);

    }

    public static function onExibeVincularProduto($object)
    {
        try 
        {
            if ($object->produto_id == null)
            {
                return true;
            }

            return false;
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onFinalizarEntrada($param = null) 
    {        
        try 
        {
            new TQuestion("Deseja finalizar a entrada? Não será mais possivel fazer alterações.", new TAction([__CLASS__, 'onFinalizarYes'], $param), new TAction([__CLASS__, 'onFinalizarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onEstornarEntrada($param = null) 
    {
        
        try 
        {
            new TQuestion("Deseja estornar a entrada?", new TAction([__CLASS__, 'onEstornarEntradaYes'], $param), new TAction([__CLASS__, 'onEstornarEntradaNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onFinalizarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = NotaFiscalCompra::find($param['key']);

            $passou = false;

            if($nota)
            {

                if ($nota->fornecedor_id ==null)
                {
                    throw new exception('O Fornecedor desta nota ainda não foi vinculado!');
                }                

                $itens = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $nota->id)->load();

                if ($itens)
                {
                    foreach ($itens as $item) 
                    {                
                        if ($item->produto_id ==null)
                        {
                            throw new exception('Existe(m) item(s) nesta nota ainda não vinculado(s)!');
                        }  

                        if ($item->estoque_deposito_id == null)
                        {
                            throw new exception('Existe(m) item(s) nesta nota sem depósitos vinculado(s)!');
                        }                          
                    }
                }
                else
                {
                    throw new exception('Não existe produtos nesta nota fiscal!');                    
                }

                //analisando duplicatas para o contas a pagar...
                 $lista_dup = NotaFiscalCompraDup::where('nota_fiscal_compra_id', '=', $nota->id)->load();

                 if ($lista_dup)
                 {   
                     $fp_semvinculo = false;

                     foreach ($lista_dup as $dup)
                     {
                        if ($dup->forma_pagamento_id==null)
                        {
                            $fp_semvinculo = true;
                        }
                     }

                     if ($fp_semvinculo)                 
                     {
                      throw new exception(' Existe(m) parcela(s) para vincular a forma de pagamento do contas a pagar!');
                     }
                 }                
                echo 'Nota estoque' . '</br>';
                //lançando o estoque...
                NotaFiscalCompra::LancamentoEstoque($nota,
                                                    'Entrada de nota fiscal de compra Id: '.$nota->id,
                                                    EstoqueTipoMovimentacao::Entrada);
                echo 'Nota contas a pagar' . '</br>';
                //lançando o contas a pagar
                NotaFiscalCompra::GerarContasAPagar($nota);
                echo 'Nota atualizar custos' . '</br>';
                NotaFiscalCompra::AtualizaCustoProduto($nota);
                echo 'Nota fornecedor' . '</br>';
                NotaFiscalCompra::VinculaProdutosFornecedor($nota);
                echo 'Nota Situacao' . '</br>';
                $nota->nota_fiscal_compra_situacao_id=NotaFiscalCompraSituacao::Finalizada;
                echo 'Nota store' . '</br>';
                $nota->store();                    

                $passou = true;
            }

            TTransaction::close();

            if ($passou)
            {
                TTransaction::open(self::$database);

                //verificação de evento..
                Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                                   NotaFiscalCompra::Evento_NotaEntradaIncluida,
                                                   $nota,
                                                   'Nota fiscal do fornecedor '.$nota->fornecedor->nome.' , '.
                                                   'Valor da nota: R$ '.number_format($nota->valor_total_nota,2, ',', '.')); 

                TTransaction::close();                 
            }

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $nota->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');              

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onFinalizarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEstornarEntradaYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = NotaFiscalCompra::find($param['key']);    

            if($nota) 
            {
                NotaFiscalCompra::EstornarNotaCompra($nota);
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $nota->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEstornarEntradaNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

