<?php

class NotaFiscalCompraImportarXML extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_NotaFiscalCompraImportarXML';

    use Adianti\Base\AdiantiFileSaveTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Importar XML de nota fiscal compra");


        $file_xml = new TFile('file_xml');

        $file_xml->setCompleteAction(new TAction([$this,'onUploadXML']));

        $file_xml->setSize('100%');
        $file_xml->enableFileHandling();
        $file_xml->setAllowedExtensions(["xml"]);


        $row1 = $this->form->addFields([$file_xml]);
        $row1->layout = [' col-sm-12'];

        // create the form actions

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=NotaFiscalCompraImportarXML]');
        $style->width = '50% !important';   
        $style->show(true);

    }

    public static function onUploadXML($param = null) 
    {
        try 
        {
             $fileName = json_decode(urldecode($param['file_xml']))->fileName;
             $xmlread = new LeituraXmlNFe($fileName);

            //  $resultado = '';

             TTransaction::open('kraftsoft');
             $notacompra = NotaFiscalCompra::ImportarArquivoXML($xmlread,$fileName);
             TTransaction::close();   

             new TMessage('info', 'Análise da nota fiscal: <br>'.$notacompra->obs_importacao_xml);    

            $pageParam = ['key' => $notacompra->id]; // ex.: = ['key' => 10]
            TApplication::loadPage('NotaFiscalCompraFormView', 'OnShow', $pageParam);             

            //  var_dump($resultado);

            //  $object = new stdClass();
            //  $object->belement_resultado->add($resultado);
            //  TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {  
            TTransaction::rollback();
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {               

    } 

}

