<?php

class NotaFiscalCompraItensForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NotaFiscalCompraItens';
    private static $primaryKey = 'id';
    private static $formName = 'form_NotaFiscalCompraItensForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Item de nota fiscal de compra");

        $criteria_produto_id = new TCriteria();
        $criteria_estoque_deposito_id = new TCriteria();

        $filterVar = Resposta::Sim;
        $criteria_produto_id->add(new TFilter('habilitado_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_estoque_deposito_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $cprod = new TEntry('cprod');
        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc' , $criteria_produto_id );
        $cean = new TEntry('cean');
        $ncm = new TEntry('ncm');
        $cfop = new TEntry('cfop');
        $ucom = new TEntry('ucom');
        $qcom = new TNumeric('qcom', '2', ',', '.' );
        $vuncom = new TNumeric('vuncom', '2', ',', '.' );
        $xped = new TEntry('xped');
        $nitemped = new TEntry('nitemped');
        $vfrete = new TNumeric('vfrete', '2', ',', '.' );
        $vdesc = new TNumeric('vdesc', '2', ',', '.' );
        $vseg = new TNumeric('vseg', '2', ',', '.' );
        $estoque_deposito_id = new TDBCombo('estoque_deposito_id', 'kraftsoft', 'EstoqueDeposito', 'id', '{descricao}','descricao asc' , $criteria_estoque_deposito_id );
        $produto_lote_id = new TDBCombo('produto_lote_id', 'kraftsoft', 'ProdutoLote', 'id', '{numero}','numero asc'  );
        $id = new THidden('id');
        $nota_fiscal_compra_id = new THidden('nota_fiscal_compra_id');
        $xprod = new THidden('xprod');
        $icms_cst = new TDBCombo('icms_cst', 'kraftsoft', 'CstIcms', 'cst_numero', '{descricao}','descricao asc'  );
        $notafiscal_item_orig_id = new TDBCombo('notafiscal_item_orig_id', 'kraftsoft', 'NotafiscalItemOrig', 'id', '{descricao}','id asc'  );
        $icms_basecalc = new TNumeric('icms_basecalc', '2', ',', '.' );
        $icms_aliquota = new TNumeric('icms_aliquota', '2', ',', '.' );
        $icms_valor = new TNumeric('icms_valor', '2', ',', '.' );
        $icms_vbcst = new TNumeric('icms_vbcst', '2', ',', '.' );
        $icms_picmsst = new TNumeric('icms_picmsst', '2', ',', '.' );
        $icms_vicmsst = new TNumeric('icms_vicmsst', '2', ',', '.' );
        $ipi_cst = new TDBCombo('ipi_cst', 'kraftsoft', 'CstIpi', 'cst_numero', '{descricao}','cst_numero asc'  );
        $ipi_valor_base = new TNumeric('ipi_valor_base', '2', ',', '.' );
        $ipi_aliquota = new TNumeric('ipi_aliquota', '2', ',', '.' );
        $ipi_valor = new TNumeric('ipi_valor', '2', ',', '.' );
        $extipi = new TNumeric('extipi', '2', ',', '.' );
        $ipi_pdevol = new TNumeric('ipi_pdevol', '2', ',', '.' );
        $ipi_vipidevol = new TNumeric('ipi_vipidevol', '2', ',', '.' );

        $produto_id->setChangeAction(new TAction([$this,'onChangeProduto']));

        $qcom->setExitAction(new TAction([$this,'onExitQuantidade']));
        $vuncom->setExitAction(new TAction([$this,'onExitValorUnitario']));

        $produto_id->addValidation("Produto id", new TRequiredValidator()); 
        $qcom->addValidation("Quantidade", new TRequiredValidator()); 
        $vuncom->addValidation("Valor Unitário", new TRequiredValidator()); 
        $estoque_deposito_id->addValidation("Depósito", new TRequiredValidator()); 
        $notafiscal_item_orig_id->addValidation("Notafiscal item orig id", new TRequiredValidator()); 

        $ipi_cst->enableSearch();
        $icms_cst->enableSearch();
        $produto_id->enableSearch();
        $produto_lote_id->enableSearch();
        $estoque_deposito_id->enableSearch();
        $notafiscal_item_orig_id->enableSearch();

        $id->setSize(200);
        $xprod->setSize(200);
        $ncm->setSize('100%');
        $cean->setSize('100%');
        $cfop->setSize('100%');
        $ucom->setSize('100%');
        $qcom->setSize('100%');
        $xped->setSize('100%');
        $vseg->setSize('100%');
        $cprod->setSize('100%');
        $vdesc->setSize('100%');
        $vuncom->setSize('100%');
        $vfrete->setSize('100%');
        $extipi->setSize('100%');
        $ipi_cst->setSize('100%');
        $nitemped->setSize('100%');
        $icms_cst->setSize('100%');
        $ipi_valor->setSize('100%');
        $produto_id->setSize('100%');
        $icms_valor->setSize('100%');
        $icms_vbcst->setSize('100%');
        $ipi_pdevol->setSize('100%');
        $icms_picmsst->setSize('100%');
        $icms_vicmsst->setSize('100%');
        $ipi_aliquota->setSize('100%');
        $icms_basecalc->setSize('100%');
        $icms_aliquota->setSize('100%');
        $ipi_vipidevol->setSize('100%');
        $ipi_valor_base->setSize('100%');
        $produto_lote_id->setSize('100%');
        $nota_fiscal_compra_id->setSize(200);
        $estoque_deposito_id->setSize('100%');
        $notafiscal_item_orig_id->setSize('100%');


        $this->form->appendPage("Dados");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Código:", null, '14px', null),$cprod],[new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$produto_id]);
        $row1->layout = [' col-sm-4',' col-sm-8'];

        $row2 = $this->form->addFields([new TLabel("EAN:", null, '14px', null, '100%'),$cean],[new TLabel("NCM:", null, '14px', null, '100%'),$ncm],[new TLabel("CFOP:", null, '14px', null, '100%'),$cfop]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Unidade:", null, '14px', null, '100%'),$ucom],[new TLabel("Quantidade:", '#FF0000', '14px', null, '100%'),$qcom],[new TLabel("Valor Unitário:", '#FF0000', '14px', null, '100%'),$vuncom]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Nº pedido:", null, '14px', null, '100%'),$xped],[new TLabel("Item pedido:", null, '14px', null, '100%'),$nitemped]);
        $row4->layout = [' col-sm-6',' col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Frete:", null, '14px', null, '100%'),$vfrete],[new TLabel("Desconto:", null, '14px', null, '100%'),$vdesc],[new TLabel("Seguro:", null, '14px', null, '100%'),$vseg]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addContent([new TFormSeparator("Estoque", '#333', '18', '#eee')]);
        $row7 = $this->form->addFields([new TLabel("Depósito:", '#FF0000', '14px', null),$estoque_deposito_id],[new TLabel("Lote:", null, '14px', null),$produto_lote_id]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([$id,$nota_fiscal_compra_id],[$xprod]);
        $row8->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("ICMS");
        $row9 = $this->form->addFields([new TLabel("CST:", '#F44336', '14px', null, '100%'),$icms_cst],[new TLabel("Origem:", '#ff0000', '14px', null, '100%'),$notafiscal_item_orig_id]);
        $row9->layout = ['col-sm-6','col-sm-6'];

        $row10 = $this->form->addFields([new TLabel("Base de cálculo ICMS:", null, '14px', null, '100%'),$icms_basecalc],[new TLabel("Aliquota ICMS:", null, '14px', null, '100%'),$icms_aliquota],[new TLabel("Valor ICMS:", null, '14px', null, '100%'),$icms_valor]);
        $row10->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row11 = $this->form->addContent([new TFormSeparator("Substituição Tributária", '#333', '18', '#eee')]);
        $row12 = $this->form->addFields([new TLabel("Base de cálculo ICMS ST:", null, '14px', null),$icms_vbcst],[new TLabel("Aliquota ICMS ST:", null, '14px', null),$icms_picmsst],[new TLabel("Valor ICMS ST:", null, '14px', null),$icms_vicmsst]);
        $row12->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $this->form->appendPage("IPI");
        $row13 = $this->form->addFields([new TLabel("CST:", '#F44336', '14px', null),$ipi_cst]);
        $row13->layout = [' col-sm-12'];

        $row14 = $this->form->addFields([new TLabel("Valor Base:", null, '14px', null),$ipi_valor_base],[new TLabel("Aliquota:", null, '14px', null),$ipi_aliquota],[new TLabel("Valor:", null, '14px', null),$ipi_valor],[new TLabel("Exceção IPI:", null, '14px', null),$extipi]);
        $row14->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row15 = $this->form->addContent([new TFormSeparator("IPI Devolvido", '#333', '18', '#eee')]);
        $row16 = $this->form->addFields([new TLabel("Percentual da mercadoria devolvida:", null, '14px', null),$ipi_pdevol],[new TLabel("Valor do IPI devolvido:", null, '14px', null),$ipi_vipidevol]);
        $row16->layout = [' col-sm-3','col-sm-3'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=NotaFiscalCompraItensForm]');
        $style->width = '80% !important';   
        $style->show(true);

    }

    public static function onExitQuantidade($param = null) 
    {
        try 
        {
            $qcom = (double) str_replace(',', '.', str_replace('.', '', $param['qcom']));
            $vuncom = (double) str_replace(',', '.', str_replace('.', '', $param['vuncom']));

            $vprod = $qcom * $vuncom ;
            $object = new stdClass();
            $object->vprod = number_format($vprod, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitValorUnitario($param = null) 
    {
        try 
        {
            $qcom = (double) str_replace(',', '.', str_replace('.', '', $param['qcom']));
            $vuncom = (double) str_replace(',', '.', str_replace('.', '', $param['vuncom']));

            $vprod = $qcom * $vuncom ;
            $object = new stdClass();
            $object->vprod = number_format($vprod, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onChangeProduto($param = null) 
    {
        try 
        {
            if (isset($param['produto_id']) && $param['produto_id'])
            {
                TTransaction::open(self::$database);

                $produto = Produto::find($param['produto_id']);

                if($produto)
                {
                    $object = new stdClass();
                    $object->cean = $produto->codigo_EAN;

                    $object->cprod = $produto->id;
                    $object->xprod = $produto->nome;
                    $object->ncm = $produto->ncm;
                    $object->ucom = $produto->unidade_medida->sigla;
                    $object->utrib = $produto->unidade_medida->sigla;
                    $object->xprod = $produto->nome;    

                    $object->vuncom = number_format(0, 2, ',', '.');    

                    //trazer o produto filial para pegar o deposito e o custo atual..
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $param['produto_id'])
                                                  ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                  ->first();

                    if($produtofilial)
                    {
                        $object->estoque_deposito_id = $produtofilial->estoque_deposito_padrao_id;
                    }

                    //verificando a exceção da natureza...
                    $naturezaexcecaoICMS = funcaoNFE::VerificaExcecaoNatureza($param['nota_fiscal_compra_id'],
                                                                              $produto->id,
                                                                              $param['notafiscal_item_orig_id'],
                                                                              $produto->ncm,
                                                                              'compras');

                    if ($naturezaexcecaoICMS)
                    {
                        $object->cfop = $naturezaexcecaoICMS->cfop;
                        $object->icms_cst = $naturezaexcecaoICMS->cst_icms->cst_numero; 
                        // $object->pis_cst = $naturezaexcecaoICMS->cst_pis->cst_numero;
                        // $object->cofins_cst = $naturezaexcecaoICMS->cst_cofins->cst_numero;
                        $object->ipi_cst = $naturezaexcecaoICMS->cst_ipi->cst_numero;                
                        $object->icms_aliquota = $naturezaexcecaoICMS->icms_aliquota;
                        $object->ipi_aliquota = $naturezaexcecaoICMS->ipi_aliquota;
                        // $object->pis_aliquota = $naturezaexcecaoICMS->pis_aliquota;
                        // $object->cofins_aliquota = $naturezaexcecaoICMS->cofins_aliquota;
                        // $object->pis_valor_base = $naturezaexcecaoICMS->pis_base;
                        // $object->cofins_valor_base = $naturezaexcecaoICMS->cofins_base;
                        $object->icms_predbc = $naturezaexcecaoICMS->icms_pRedBC;
                        $object->icms_basecalc = $naturezaexcecaoICMS->icms_base;
                        $object->icms_pst = $naturezaexcecaoICMS->icms_pST;
                        $object->icms_pcredsn = $naturezaexcecaoICMS->icms_pCredSN;
                        $object->icms_pmvast = $naturezaexcecaoICMS->icms_pMVAST;
                        $object->icms_picmsst = $naturezaexcecaoICMS->icms_pICMSST;
                        $object->icms_vbcst = $naturezaexcecaoICMS->icms_baseST;

                        // $object->notafiscal_item_modbc_id = $naturezaexcecaoICMS->notafiscal_item_modbc_id;
                        // $object->notafiscal_item_modbcst_id = $naturezaexcecaoICMS->notafiscal_item_modbcst_id;
                        // $object->notafiscal_item_motDesICMS_id = $naturezaexcecaoICMS->notafiscal_item_motDesICMS_id;                        
                    }

                    //$unidade = UnidadeMedida::Find($produto->unidade_medida_id);

                    TForm::sendData(self::$formName, $object);

                }

                TTransaction::close();
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new NotaFiscalCompraItens(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->utrib    = $data->ucom;
            $object->qtrib    = $data->qcom;
            $object->vuntrib  = $data->vuncom;
            $object->ceantrib = $data->cean;

            $object->vprod = $data->qcom * $data->vuncom;

            // $produto = Produto::find($data->produto_id);
            // if($produto){
            //     $object->xprod = $produto->nome;    
            // }

            $object->store(); // save the object 

            NotaFiscalCompra::atualiza_totais_nota($object->nota_fiscal_compra_id);

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

            TSession::setValue('nfcompra_aba_items', true);

            $pageParam = ['key' => $object->nota_fiscal_compra_id]; // ex.: = ['key' => 10]
            TApplication::loadPage('NotaFiscalCompraForm', 'onEdit', $pageParam);

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new NotaFiscalCompraItens($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->nota_fiscal_compra_id = $param['nota_fiscal_compra_id'];
        $object->qcom = '1,00';
        $object->vuncom = '0,00';
        $object->vprod = '0,00';
        $object->vdesc = '0,00';
        $object->vseg = '0,00';
        $object->vfrete = '0,00';
        $object->vuntrib = '0,00';
        $object->icms_aliquota = '0,00';
        $object->icms_valor = '0,00';
        $object->icms_basecalc = '0,00';
        $object->notafiscal_item_indtot_id = NotafiscalItemIndtot::Um;
        $object->notafiscal_item_orig_id = NotafiscalItemOrig::Zero;

        TTransaction::open(self::$database);

        $nota = NotaFiscalCompra::find($param['nota_fiscal_compra_id']);   

        $filial = SystemUnit::find(TSession::getValue('userunitid'));

        if($nota)
        {
            $natureza = NaturezaOperacao::find($filial->natureza_operacao_compra_id);

            if(!is_null($natureza))
            {
                $object->cfop = $natureza->cfop;
                $object->icms_cst = $natureza->cst_icms->cst_numero; 
                // $object->pis_cst = $natureza->cst_pis->cst_numero;
                // $object->cofins_cst = $natureza->cst_cofins->cst_numero;
                $object->ipi_cst = $natureza->cst_ipi->cst_numero;                
                $object->icms_aliquota = $natureza->icms_aliquota;
                $object->ipi_aliquota = $natureza->ipi_aliquota;
                // $object->pis_aliquota = $natureza->pis_aliquota;
                // $object->cofins_aliquota = $natureza->cofins_aliquota;
                // $object->pis_valor_base = $natureza->pis_base;
                // $object->cofins_valor_base = $natureza->cofins_base;
                $object->icms_predbc = $natureza->icms_pRedBC;
                $object->icms_basecalc = $natureza->icms_base;
                $object->icms_pst = $natureza->icms_pST;
                $object->icms_pcredsn = $natureza->icms_pCredSN;
                $object->icms_pmvast = $natureza->icms_pMVAST;
                $object->icms_picmsst = $natureza->icms_pICMSST;
                $object->icms_vbcst = $natureza->icms_baseST;

                // $object->notafiscal_item_modbc_id = $natureza->notafiscal_item_modbc_id;
                // $object->notafiscal_item_modbcst_id = $natureza->notafiscal_item_modbcst_id;
                // $object->notafiscal_item_motDesICMS_id = $natureza->notafiscal_item_motDesICMS_id;
            }
        }

        TTransaction::close();

        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

