<?php

class NotaFiscalCompraVincularFornecedor extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_NotaFiscalCompraVincularFornecedor';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Vincular fornecedor a nota fiscal de compra");


        $cpf_cnpj = new TEntry('cpf_cnpj');
        $nome = new TEntry('nome');
        $inscricao_estadual = new TEntry('inscricao_estadual');
        $inscricao_municipal = new TEntry('inscricao_municipal');
        $cep = new TEntry('cep');
        $endereco = new TEntry('endereco');
        $numero = new TEntry('numero');
        $bairro = new TEntry('bairro');
        $cidade = new TEntry('cidade');
        $estado = new TEntry('estado');
        $fone = new TEntry('fone');
        $complemento = new TEntry('complemento');
        $button_opcao_1_cadastrar_novo_fornecedor = new TButton('button_opcao_1_cadastrar_novo_fornecedor');
        $fornecedor_id = new TDBCombo('fornecedor_id', 'kraftsoft', 'Fornecedor', 'id', '{nome} -{cpf_cnpj}','nome asc'  );
        $button_opcao_2_vincular_fornecedor_ja_cadastrado = new TButton('button_opcao_2_vincular_fornecedor_ja_cadastrado');
        $nota_fiscal_compra_id = new THidden('nota_fiscal_compra_id');

        $cpf_cnpj->addValidation("CPF/CNPJ", new TRequiredValidator()); 
        $nome->addValidation("Nome", new TRequiredValidator()); 

        $fornecedor_id->enableSearch();
        $button_opcao_1_cadastrar_novo_fornecedor->setAction(new TAction([$this, 'onBtnCadastrarNovoFornecedor']), "Opção 1: Cadastrar novo fornecedor");
        $button_opcao_2_vincular_fornecedor_ja_cadastrado->setAction(new TAction([$this, 'onBtnVincularFornecedorCadastrado']), "Opção 2: Vincular fornecedor já cadastrado");

        $button_opcao_1_cadastrar_novo_fornecedor->addStyleClass('btn-primary');
        $button_opcao_2_vincular_fornecedor_ja_cadastrado->addStyleClass('btn-success');

        $button_opcao_1_cadastrar_novo_fornecedor->setImage('fas:plus-circle #FFFFFF');
        $button_opcao_2_vincular_fornecedor_ja_cadastrado->setImage('fas:exchange-alt #FFFFFF');

        $cep->setSize('100%');
        $nome->setSize('100%');
        $fone->setSize('100%');
        $numero->setSize('100%');
        $bairro->setSize('100%');
        $cidade->setSize('100%');
        $estado->setSize('100%');
        $cpf_cnpj->setSize('100%');
        $endereco->setSize('100%');
        $complemento->setSize('100%');
        $fornecedor_id->setSize('100%');
        $inscricao_estadual->setSize('100%');
        $nota_fiscal_compra_id->setSize(200);
        $inscricao_municipal->setSize('100%');


        $row1 = $this->form->addContent([new TFormSeparator("Opção 1: Cadastrar novo fornecedor", '#E91E63', '18', '#eee')]);
        $row2 = $this->form->addFields([new TLabel("CPF/CNPJ:", '#F44336', '14px', null, '100%'),$cpf_cnpj],[new TLabel("Nome:", '#F44336', '14px', null),$nome]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Inscrição Estadual:", null, '14px', null),$inscricao_estadual],[new TLabel("Inscrição Municipal:", null, '14px', null),$inscricao_municipal]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("CEP:", null, '14px', null),$cep],[new TLabel("Endereço:", null, '14px', null),$endereco]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Número:", null, '14px', null),$numero],[new TLabel("Bairro:", null, '14px', null),$bairro]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Cidade:", null, '14px', null),$cidade],[new TLabel("Estado:", null, '14px', null),$estado]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([new TLabel("Fone:", null, '14px', null),$fone],[new TLabel("Complemento:", null, '14px', null),$complemento]);
        $row7->layout = ['col-sm-6',' col-sm-6'];

        $row8 = $this->form->addFields([$button_opcao_1_cadastrar_novo_fornecedor]);
        $row8->layout = ['col-sm-3'];

        $row9 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row10 = $this->form->addContent([new TFormSeparator("Opção 2 - Vincular fornecedor já cadastrado", '#E91E63', '18', '#eee')]);
        $row11 = $this->form->addFields([new TLabel("Fornecedor:", null, '14px', null),$fornecedor_id]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->form->addFields([$button_opcao_2_vincular_fornecedor_ja_cadastrado]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->form->addFields([$nota_fiscal_compra_id]);
        $row13->layout = [' col-sm-12'];

        // create the form actions

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=NotaFiscalCompraVincularFornecedor]');
        $style->width = '70% !important';   
        $style->show(true);

    }

    public  function onBtnCadastrarNovoFornecedor($param = null) 
    {
        try 
        {
            TTransaction::open('kraftsoft'); // open a transaction

            $this->form->validate(); // validate form data         
            $data = $this->form->getData(); // get form data as array

            $fornecedor = new Fornecedor();

            $fornecedor->nome = $data->nome;                 
            $fornecedor->razao_social = $data->nome;
            $fornecedor->cpf_cnpj = $data->cpf_cnpj;   

            if(strlen(Funcoes::limpaCPF_CNPJ($data->cpf_cnpj)) == 11)
            {
                $fornecedor->pessoa_tipo_id = PessoaTipo::Fisica;    
            }
            else
            {
                $fornecedor->pessoa_tipo_id = PessoaTipo::Juridica;
            }

            $fornecedor->insc_estadual = $data->inscricao_estadual;  
            $fornecedor->insc_municipal = $data->inscricao_municipal; 
            $fornecedor->fone = $data->fone;                 
            $fornecedor->logradouro = $data->endereco;             
            $fornecedor->cep = $data->cep;             

            $dadosCep = CEPService::get($fornecedor->cep);

            if ($dadosCep)
            {
                $fornecedor->cidade_id = $dadosCep->cidade_id;
            }

            $fornecedor->estado = $data->estado;               
            $fornecedor->numero = $data->numero;               
            $fornecedor->bairro = $data->bairro;               
            $fornecedor->complemento = $data->complemento;                      

            Funcoes::SalvarUsuarioCadastro($fornecedor);   

            $fornecedor->store();

            //vincular o fornecedor a nota fiscal de compra..
            $notacompra = NotaFiscalCompra::find($param['nota_fiscal_compra_id']);
            $notacompra->fornecedor_id = $fornecedor->id;
            $notacompra->store();

            //analisar a situação da nota...
            NotaFiscalCompra::AnalisaVinculosNota($notacompra->id);

            TTransaction::close();

            TToast::show('success', "Fornecedor criado e vinculado com sucesso!", 'topRight', 'far:check-circle');

            $pageParam = ['key' => $param['nota_fiscal_compra_id']]; // ex.: = ['key' => 10]

            TApplication::loadPage('NotaFiscalCompraFormView', 'OnShow', $pageParam);    

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onBtnVincularFornecedorCadastrado($param = null) 
    {
        try 
        {
            TTransaction::open('kraftsoft'); // open a transaction

            // $this->form->validate(); // validate form data         
            // $data = $this->form->getData(); // get form data as array

            (new TRequiredValidator)->validate('Fornecedor', $param['fornecedor_id'] );

            //vincular o fornecedor a nota fiscal de compra..
            $notacompra = NotaFiscalCompra::find($param['nota_fiscal_compra_id']);
            $notacompra->fornecedor_id = $param['fornecedor_id'];
            $notacompra->store();

            //analisar a situação da nota...
            NotaFiscalCompra::AnalisaVinculosNota($notacompra->id);

            TTransaction::close();

            TToast::show('success', "Fornecedor vinculado com sucesso!", 'topRight', 'far:check-circle');

            $pageParam = ['key' => $param['nota_fiscal_compra_id']]; // ex.: = ['key' => 10]

            TApplication::loadPage('NotaFiscalCompraFormView', 'OnShow', $pageParam);     

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {               

        TTransaction::open('kraftsoft');
        $notacompra = NotaFiscalCompra::find($param['key']);
        TTransaction::close();

        if ($notacompra)
        {
            $object = new stdClass();

            $object->nota_fiscal_compra_id = $param['key'];    
            $object->nome                  = $notacompra->cliente_nome;
            $object->cpf_cnpj              = Funcoes::mascaraCpfCnpj($notacompra->cliente_cpfcnpj);
            $object->inscricao_estadual    = $notacompra->cliente_inscest;
            $object->inscricao_municipal   = $notacompra->cliente_inscmuni;
            $object->fone                  = $notacompra->cliente_fone;
            $object->endereco              = $notacompra->cliente_endereco;
            $object->cep                   = $notacompra->cliente_cep; 
            $object->cidade                = $notacompra->cliente_cidade;    
            $object->estado                = $notacompra->cliente_estado;
            $object->numero                = $notacompra->cliente_numero;
            $object->bairro                = $notacompra->cliente_bairro;
            $object->complemento           = $notacompra->cliente_complemento;
            TForm::sendData(self::$formName, $object);

        }
        else 
        {
            throw new Exception('Nota fiscal de compra não encontrada!');
        }

    } 

}

