<?php

class AjudaForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_AjudaForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Ajuda");


        $img_ilustracao = new TImage('app/files/kraft_arquivos/img/ajuda.png');
        $texto_ajuda = new BElement('div');


        $texto_ajuda->setSize('100%', 700);

        $img_ilustracao->width = '100%';
        $img_ilustracao->height = '300px';

        $this->img_ilustracao = $img_ilustracao;
        $this->texto_ajuda = $texto_ajuda;

        $row1 = $this->form->addFields([$img_ilustracao],[$texto_ajuda]);
        $row1->layout = ['col-sm-3',' col-sm-9'];

        // create the form actions

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=AjudaForm]');
        $style->width = '60% !important';   
        $style->show(true);

    }

    public function onShow($param = null)
    {               

        $id_ajuda = $param['id_ajuda'];

        switch ($id_ajuda) {
            case '1':
                $ajuda = TabelaPreco::informacoes_ajuda();
                break;

            case '2':
                $ajuda = ProdutoGrupo::informacoes_ajuda();
                break;        

            case '3':
                $ajuda = ClienteClassificacao::informacoes_ajuda();
                break;                   

            default:
                $ajuda = 'Informação de ajuda ainda não implementada!';
                break;
        }

        //jogando para o componente na tela..
        $this->texto_ajuda->add($ajuda);

    } 

}

