<?php

class ApiDocumentosForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ApiDocumentos';
    private static $primaryKey = 'id';
    private static $formName = 'form_ApiDocumentosForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de API de documentos");


        $id = new TEntry('id');
        $descricao = new THidden('descricao');
        $integradores_id = new TDBCombo('integradores_id', 'kraftsoft', 'Integradores', 'id', '{nome}','nome asc'  );
        $token_api = new TEntry('token_api');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id = new TCombo('apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id');
        $apidocumentos_integradoresservicos_api_documentos_id = new THidden('apidocumentos_integradoresservicos_api_documentos_id');
        $button_adicionar_apidocumentos_integradoresservicos_api_documentos = new TButton('button_adicionar_apidocumentos_integradoresservicos_api_documentos');

        $integradores_id->setChangeAction(new TAction([$this,'onChangeintegradores_id']));

        $integradores_id->addValidation("Integradores id", new TRequiredValidator()); 
        $token_api->addValidation("Token API", new TRequiredValidator()); 

        $button_adicionar_apidocumentos_integradoresservicos_api_documentos->setAction(new TAction([$this, 'onAddDetailApidocumentosIntegradoresservicosApiDocumentos'],['static' => 1]), "Adicionar");
        $button_adicionar_apidocumentos_integradoresservicos_api_documentos->addStyleClass('btn-default');
        $button_adicionar_apidocumentos_integradoresservicos_api_documentos->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $descricao->setSize(200);
        $token_api->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $integradores_id->setSize('100%');
        $apidocumentos_integradoresservicos_api_documentos_id->setSize(200);
        $apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id->setSize('100%');

        $button_adicionar_apidocumentos_integradoresservicos_api_documentos->id = '61ffb2fef1e61';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id,$descricao],[]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Integrador:", '#ff0000', '14px', null, '100%'),$integradores_id]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Token API:", '#ff0000', '14px', null, '100%'),$token_api]);
        $row3->layout = [' col-sm-12'];

        $row4 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row5 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row5->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Serviços");

        $this->detailFormApidocumentosIntegradoresservicosApiDocumentos = new BootstrapFormBuilder('detailFormApidocumentosIntegradoresservicosApiDocumentos');
        $this->detailFormApidocumentosIntegradoresservicosApiDocumentos->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormApidocumentosIntegradoresservicosApiDocumentos->setProperty('class', 'form-horizontal builder-detail-form');

        $row6 = $this->detailFormApidocumentosIntegradoresservicosApiDocumentos->addFields([new TLabel("Serviço:", '#ff0000', '14px', null, '100%'),$apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id,$apidocumentos_integradoresservicos_api_documentos_id],[]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->detailFormApidocumentosIntegradoresservicosApiDocumentos->addFields([$button_adicionar_apidocumentos_integradoresservicos_api_documentos]);
        $row7->layout = [' col-sm-12'];

        $row8 = $this->detailFormApidocumentosIntegradoresservicosApiDocumentos->addFields([new THidden('apidocumentos_integradoresservicos_api_documentos__row__id')]);
        $this->apidocumentos_integradoresservicos_api_documentos_criteria = new TCriteria();

        $this->apidocumentos_integradoresservicos_api_documentos_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->apidocumentos_integradoresservicos_api_documentos_list->disableHtmlConversion();;
        $this->apidocumentos_integradoresservicos_api_documentos_list->generateHiddenFields();
        $this->apidocumentos_integradoresservicos_api_documentos_list->setId('apidocumentos_integradoresservicos_api_documentos_list');

        $this->apidocumentos_integradoresservicos_api_documentos_list->style = 'width:100%';
        $this->apidocumentos_integradoresservicos_api_documentos_list->class .= ' table-bordered';

        $column_apidocumentos_integradoresservicos_api_documentos_integradores_servicos_descricao = new TDataGridColumn('integradores_servicos->descricao', "Serviço", 'left');

        $column_apidocumentos_integradoresservicos_api_documentos__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_apidocumentos_integradoresservicos_api_documentos__row__data->setVisibility(false);

        $action_onEditDetailApidocumentosIntegradoresservicos = new TDataGridAction(array('ApiDocumentosForm', 'onEditDetailApidocumentosIntegradoresservicos'));
        $action_onEditDetailApidocumentosIntegradoresservicos->setUseButton(false);
        $action_onEditDetailApidocumentosIntegradoresservicos->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailApidocumentosIntegradoresservicos->setLabel("Editar");
        $action_onEditDetailApidocumentosIntegradoresservicos->setImage('far:edit #478fca');
        $action_onEditDetailApidocumentosIntegradoresservicos->setFields(['__row__id', '__row__data']);

        $this->apidocumentos_integradoresservicos_api_documentos_list->addAction($action_onEditDetailApidocumentosIntegradoresservicos);
        $action_onDeleteDetailApidocumentosIntegradoresservicos = new TDataGridAction(array('ApiDocumentosForm', 'onDeleteDetailApidocumentosIntegradoresservicos'));
        $action_onDeleteDetailApidocumentosIntegradoresservicos->setUseButton(false);
        $action_onDeleteDetailApidocumentosIntegradoresservicos->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailApidocumentosIntegradoresservicos->setLabel("Excluir");
        $action_onDeleteDetailApidocumentosIntegradoresservicos->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailApidocumentosIntegradoresservicos->setFields(['__row__id', '__row__data']);

        $this->apidocumentos_integradoresservicos_api_documentos_list->addAction($action_onDeleteDetailApidocumentosIntegradoresservicos);

        $this->apidocumentos_integradoresservicos_api_documentos_list->addColumn($column_apidocumentos_integradoresservicos_api_documentos_integradores_servicos_descricao);

        $this->apidocumentos_integradoresservicos_api_documentos_list->addColumn($column_apidocumentos_integradoresservicos_api_documentos__row__data);

        $this->apidocumentos_integradoresservicos_api_documentos_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->apidocumentos_integradoresservicos_api_documentos_list);
        $this->detailFormApidocumentosIntegradoresservicosApiDocumentos->addContent([$tableResponsiveDiv]);
        $row9 = $this->form->addFields([$this->detailFormApidocumentosIntegradoresservicosApiDocumentos]);
        $row9->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ApiDocumentosHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Configurações","Cadastro de API de documentos"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onChangeintegradores_id($param)
    {
        try
        {

            if (isset($param['integradores_id']) && $param['integradores_id'])
            { 
                $criteria = TCriteria::create(['integradores_id' => $param['integradores_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id', 'kraftsoft', 'IntegradoresServicos', 'id', '{descricao}', 'descricao asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public  function onAddDetailApidocumentosIntegradoresservicosApiDocumentos($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Integradores servicos id", 'name'=>"apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->apidocumentos_integradoresservicos_api_documentos__row__id) ? $data->apidocumentos_integradoresservicos_api_documentos__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ApidocumentosIntegradoresservicos();
            $grid_data->__row__id = $__row__id;
            $grid_data->integradores_servicos_id = $data->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id;
            $grid_data->id = $data->apidocumentos_integradoresservicos_api_documentos_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['integradores_servicos_id'] =  $param['apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['apidocumentos_integradoresservicos_api_documentos_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->apidocumentos_integradoresservicos_api_documentos_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('apidocumentos_integradoresservicos_api_documentos_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id = '';
            $data->apidocumentos_integradoresservicos_api_documentos_id = '';
            $data->apidocumentos_integradoresservicos_api_documentos__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61ffb2fef1e61');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailApidocumentosIntegradoresservicos($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id = $__row__data->__display__->integradores_servicos_id ?? null;
            $data->apidocumentos_integradoresservicos_api_documentos_id = $__row__data->__display__->id ?? null;
            $data->apidocumentos_integradoresservicos_api_documentos__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61ffb2fef1e61');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailApidocumentosIntegradoresservicos($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id = '';
            $data->apidocumentos_integradoresservicos_api_documentos_id = '';
            $data->apidocumentos_integradoresservicos_api_documentos__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('apidocumentos_integradoresservicos_api_documentos_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ApiDocumentos(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->descricao = 'Serviços: ';
            $object->system_unit_id = TSession::getValue('userunitid');
            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $apidocumentos_integradoresservicos_api_documentos_items = $this->storeMasterDetailItems('ApidocumentosIntegradoresservicos', 'api_documentos_id', 'apidocumentos_integradoresservicos_api_documentos', $object, $param['apidocumentos_integradoresservicos_api_documentos_list___row__data'] ?? [], $this->form, $this->apidocumentos_integradoresservicos_api_documentos_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->apidocumentos_integradoresservicos_api_documentos_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data

            //preenchendo o campo descrição automaticamente...
            $descricao = 'Serviços: ';

            //carregando a lista de serviços...
            $listaapiintegradorservicos = ApidocumentosIntegradoresservicos::where('api_documentos_id', '=', $object->id)->load();

            foreach($listaapiintegradorservicos as $apiintegradorservico)
            {
              $descricao = $descricao.' | '.$apiintegradorservico->integradores_servicos->descricao;
            }

            $object->descricao = $descricao;
            $object->store();            

            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ApiDocumentosHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ApiDocumentos($key); // instantiates the Active Record 

                $apidocumentos_integradoresservicos_api_documentos_items = $this->loadMasterDetailItems('ApidocumentosIntegradoresservicos', 'api_documentos_id', 'apidocumentos_integradoresservicos_api_documentos', $object, $this->form, $this->apidocumentos_integradoresservicos_api_documentos_list, $this->apidocumentos_integradoresservicos_api_documentos_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                    $objectItems->integradores_id = null;
                    if(isset($detailObject->integradores_id) && $detailObject->integradores_id)
                    {
                        $objectItems->__display__->integradores_id = $detailObject->integradores_id;
                    }

                    $objectItems->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id = null;
                    if(isset($detailObject->integradores_servicos_id) && $detailObject->integradores_servicos_id)
                    {
                        $objectItems->__display__->integradores_servicos_id = $detailObject->integradores_servicos_id;
                    }

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->integradores_id))
            {
                $value = $object->integradores_id;

                $obj->integradores_id = $value;
            }
            if(isset($object->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id))
            {
                $value = $object->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id;

                $obj->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->integradores_id))
            {
                $value = $object->integradores_id;

                $obj->integradores_id = $value;
            }
            if(isset($object->apidocumentos_integradoresservicos->api_documentos->integradores_servicos_id))
            {
                $value = $object->apidocumentos_integradoresservicos->api_documentos->integradores_servicos_id;

                $obj->apidocumentos_integradoresservicos_api_documentos_integradores_servicos_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

