<?php

class ConfiguracoesForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Configuracoes';
    private static $primaryKey = 'id';
    private static $formName = 'form_ConfiguracoesForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Configurações");


        $id = new THidden('id');
        $forma_pagamento_id_dinheiro_caixa = new TDBCombo('forma_pagamento_id_dinheiro_caixa', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $forma_pagamento_id_titulos_cpag_nf = new TDBCombo('forma_pagamento_id_titulos_cpag_nf', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $configuracoes_filial_configuracoes_id = new THidden('configuracoes_filial_configuracoes_id');
        $configuracoes_filial_configuracoes_system_unit_id = new TDBCombo('configuracoes_filial_configuracoes_system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id = new TDBCombo('configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id', 'kraftsoft', 'ProdutoEtiquetaConfiguracoes', 'id', '{id}','id asc'  );
        $configuracoes_filial_configuracoes_centro_custo_mascara = new TEntry('configuracoes_filial_configuracoes_centro_custo_mascara');
        $configuracoes_filial_configuracoes_plano_conta_mascara = new TEntry('configuracoes_filial_configuracoes_plano_conta_mascara');
        $configuracoes_filial_configuracoes_centro_custo_crec_id = new TCombo('configuracoes_filial_configuracoes_centro_custo_crec_id');
        $configuracoes_filial_configuracoes_plano_conta_crec_id = new TCombo('configuracoes_filial_configuracoes_plano_conta_crec_id');
        $configuracoes_filial_configuracoes_cpag_usa_plano_contas_id = new TRadioGroup('configuracoes_filial_configuracoes_cpag_usa_plano_contas_id');
        $configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id = new TRadioGroup('configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id');
        $configuracoes_filial_configuracoes_venda_apenas_com_estoque_id = new TRadioGroup('configuracoes_filial_configuracoes_venda_apenas_com_estoque_id');
        $configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id = new TDBCombo('configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id', 'kraftsoft', 'NotafiscalCprodPadrao', 'id', '{descricao}','descricao asc'  );
        $configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id = new TDBCombo('configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id', 'kraftsoft', 'NotafiscalCprodPadrao', 'id', '{descricao}','descricao asc'  );
        $configuracoes_filial_configuracoes_produto_margem_padrao = new TNumeric('configuracoes_filial_configuracoes_produto_margem_padrao', '2', ',', '.' );
        $configuracoes_filial_configuracoes_info_complementar_orcamento = new THtmlEditor('configuracoes_filial_configuracoes_info_complementar_orcamento');
        $button_adicionar_configuracoes_filial_configuracoes = new TButton('button_adicionar_configuracoes_filial_configuracoes');

        $configuracoes_filial_configuracoes_system_unit_id->setChangeAction(new TAction([$this,'onChangeconfiguracoes_filial_configuracoes_system_unit_id']));

        $button_adicionar_configuracoes_filial_configuracoes->setAction(new TAction([$this, 'onAddDetailConfiguracoesFilialConfiguracoes'],['static' => 1]), "Adicionar");
        $button_adicionar_configuracoes_filial_configuracoes->addStyleClass('btn-default');
        $button_adicionar_configuracoes_filial_configuracoes->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $configuracoes_filial_configuracoes_cpag_usa_plano_contas_id->addItems(["1"=>"Sim","2"=>"Não"]);
        $configuracoes_filial_configuracoes_venda_apenas_com_estoque_id->addItems(["1"=>"Sim","2"=>"Não"]);
        $configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id->addItems(["1"=>"Sim","2"=>"Não"]);

        $configuracoes_filial_configuracoes_cpag_usa_plano_contas_id->setLayout('horizontal');
        $configuracoes_filial_configuracoes_venda_apenas_com_estoque_id->setLayout('horizontal');
        $configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id->setLayout('horizontal');

        $configuracoes_filial_configuracoes_cpag_usa_plano_contas_id->setUseButton();
        $configuracoes_filial_configuracoes_venda_apenas_com_estoque_id->setUseButton();
        $configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id->setUseButton();

        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $forma_pagamento_id_dinheiro_caixa->enableSearch();
        $forma_pagamento_id_titulos_cpag_nf->enableSearch();
        $configuracoes_filial_configuracoes_system_unit_id->enableSearch();
        $configuracoes_filial_configuracoes_plano_conta_crec_id->enableSearch();
        $configuracoes_filial_configuracoes_centro_custo_crec_id->enableSearch();
        $configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id->enableSearch();
        $configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id->enableSearch();
        $configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id->enableSearch();

        $id->setSize(200);
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $forma_pagamento_id_dinheiro_caixa->setSize('100%');
        $forma_pagamento_id_titulos_cpag_nf->setSize('100%');
        $configuracoes_filial_configuracoes_id->setSize(200);
        $configuracoes_filial_configuracoes_system_unit_id->setSize('100%');
        $configuracoes_filial_configuracoes_plano_conta_mascara->setSize('100%');
        $configuracoes_filial_configuracoes_plano_conta_crec_id->setSize('100%');
        $configuracoes_filial_configuracoes_centro_custo_mascara->setSize('100%');
        $configuracoes_filial_configuracoes_centro_custo_crec_id->setSize('100%');
        $configuracoes_filial_configuracoes_produto_margem_padrao->setSize('100%');
        $configuracoes_filial_configuracoes_venda_apenas_com_estoque_id->setSize(80);
        $configuracoes_filial_configuracoes_cpag_usa_plano_contas_id->setSize('100%');
        $configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id->setSize('100%');
        $configuracoes_filial_configuracoes_info_complementar_orcamento->setSize('100%', 110);
        $configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id->setSize('100%');
        $configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id->setSize(80);
        $configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id->setSize('100%');

        $button_adicionar_configuracoes_filial_configuracoes->id = '6346920170d4b';

        $this->form->appendPage("Configurações Gerais");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$id]);
        $row1->layout = ['col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Forma pagamento padrão dinheiro caixa:", null, '14px', null, '100%'),$forma_pagamento_id_dinheiro_caixa]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Forma pagamento padrão para titulos de nota fiscal de compra (ao importar XML):", null, '14px', null, '100%'),$forma_pagamento_id_titulos_cpag_nf]);
        $row3->layout = [' col-sm-12'];

        $bcontainer_6346911270d3e = new BContainer('bcontainer_6346911270d3e');
        $this->bcontainer_6346911270d3e = $bcontainer_6346911270d3e;

        $bcontainer_6346911270d3e->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_6346911270d3e->setBorderColor('#c0c0c0');

        $row4 = $bcontainer_6346911270d3e->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row4->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row5 = $this->form->addFields([$bcontainer_6346911270d3e]);
        $row5->layout = [' col-sm-12'];

        $this->form->appendPage("Configurações por Filial");

        $this->detailFormConfiguracoesFilialConfiguracoes = new BootstrapFormBuilder('detailFormConfiguracoesFilialConfiguracoes');
        $this->detailFormConfiguracoesFilialConfiguracoes->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormConfiguracoesFilialConfiguracoes->setProperty('class', 'form-horizontal builder-detail-form');

        $row6 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([$configuracoes_filial_configuracoes_id,new TLabel("Filial:", '#E50808', '14px', null),$configuracoes_filial_configuracoes_system_unit_id],[new TLabel("Configuração de etiqueta de produto:", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([new TLabel("Máscara de Centro de Custo:", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_centro_custo_mascara],[new TLabel("Máscara de Plano de Conta:", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_plano_conta_mascara]);
        $row7->layout = ['col-sm-6','col-sm-6'];

        $row8 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([new TLabel("Centro de Custo de Contas a receber de venda:", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_centro_custo_crec_id],[new TLabel("Plano de Conta de Contas a receber de venda:", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_plano_conta_crec_id]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        $row9 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([new TLabel("Obriga uso de plano de contas no contas a pagar", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_cpag_usa_plano_contas_id],[new TLabel("Alertar sobre inclusão de itens repetidos no orçamento e na venda", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id],[new TLabel("Permitir apenas venda com estoque disponível", null, '14px', null, '100%'),$configuracoes_filial_configuracoes_venda_apenas_com_estoque_id]);
        $row9->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row10 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([new TLabel("Código padrão do produto na impressão do orçamento", null, '14px', null),$configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id],[new TLabel("Código padrão do produto na impressão da venda", null, '14px', null),$configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id]);
        $row10->layout = [' col-sm-6','col-sm-6'];

        $row11 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([new TLabel("Margem padrão para produtos na entrada de nota (apenas para produtos novos)", null, '14px', null),$configuracoes_filial_configuracoes_produto_margem_padrao],[]);
        $row11->layout = [' col-sm-6','col-sm-6'];

        $row12 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([new TLabel("Informações complementares na impressão do orçamento", null, '14px', null),$configuracoes_filial_configuracoes_info_complementar_orcamento]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([$button_adicionar_configuracoes_filial_configuracoes]);
        $row13->layout = [' col-sm-12'];

        $row14 = $this->detailFormConfiguracoesFilialConfiguracoes->addFields([new THidden('configuracoes_filial_configuracoes__row__id')]);
        $this->configuracoes_filial_configuracoes_criteria = new TCriteria();

        $this->configuracoes_filial_configuracoes_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->configuracoes_filial_configuracoes_list->disableHtmlConversion();;
        $this->configuracoes_filial_configuracoes_list->generateHiddenFields();
        $this->configuracoes_filial_configuracoes_list->setId('configuracoes_filial_configuracoes_list');

        $this->configuracoes_filial_configuracoes_list->style = 'width:100%';
        $this->configuracoes_filial_configuracoes_list->class .= ' table-bordered';

        $column_configuracoes_filial_configuracoes_id = new TDataGridColumn('id', "Id", 'center' , '70px');
        $column_configuracoes_filial_configuracoes_system_unit_name = new TDataGridColumn('system_unit->name', "Filial", 'left');
        $column_configuracoes_filial_configuracoes_criado_em_transformed = new TDataGridColumn('criado_em', "Criado Em", 'left');
        $column_configuracoes_filial_configuracoes_alterado_em_transformed = new TDataGridColumn('alterado_em', "Alterado Em", 'left');

        $column_configuracoes_filial_configuracoes__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_configuracoes_filial_configuracoes__row__data->setVisibility(false);

        $action_onEditDetailConfiguracoesFilial = new TDataGridAction(array('ConfiguracoesForm', 'onEditDetailConfiguracoesFilial'));
        $action_onEditDetailConfiguracoesFilial->setUseButton(false);
        $action_onEditDetailConfiguracoesFilial->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailConfiguracoesFilial->setLabel("Editar");
        $action_onEditDetailConfiguracoesFilial->setImage('far:edit #478fca');
        $action_onEditDetailConfiguracoesFilial->setFields(['__row__id', '__row__data']);

        $this->configuracoes_filial_configuracoes_list->addAction($action_onEditDetailConfiguracoesFilial);
        $action_onDeleteDetailConfiguracoesFilial = new TDataGridAction(array('ConfiguracoesForm', 'onDeleteDetailConfiguracoesFilial'));
        $action_onDeleteDetailConfiguracoesFilial->setUseButton(false);
        $action_onDeleteDetailConfiguracoesFilial->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailConfiguracoesFilial->setLabel("Excluir");
        $action_onDeleteDetailConfiguracoesFilial->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailConfiguracoesFilial->setFields(['__row__id', '__row__data']);

        $this->configuracoes_filial_configuracoes_list->addAction($action_onDeleteDetailConfiguracoesFilial);

        $this->configuracoes_filial_configuracoes_list->addColumn($column_configuracoes_filial_configuracoes_id);
        $this->configuracoes_filial_configuracoes_list->addColumn($column_configuracoes_filial_configuracoes_system_unit_name);
        $this->configuracoes_filial_configuracoes_list->addColumn($column_configuracoes_filial_configuracoes_criado_em_transformed);
        $this->configuracoes_filial_configuracoes_list->addColumn($column_configuracoes_filial_configuracoes_alterado_em_transformed);

        $this->configuracoes_filial_configuracoes_list->addColumn($column_configuracoes_filial_configuracoes__row__data);

        $this->configuracoes_filial_configuracoes_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->configuracoes_filial_configuracoes_list);
        $this->detailFormConfiguracoesFilialConfiguracoes->addContent([$tableResponsiveDiv]);

        $column_configuracoes_filial_configuracoes_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_configuracoes_filial_configuracoes_alterado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });        $row15 = $this->form->addFields([$this->detailFormConfiguracoesFilialConfiguracoes]);
        $row15->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ConfiguracoesForm]');
        $style->width = '80% !important';   
        $style->show(true);

    }

    public static function onChangeconfiguracoes_filial_configuracoes_system_unit_id($param)
    {
        try
        {

            if (isset($param['configuracoes_filial_configuracoes_system_unit_id']) && $param['configuracoes_filial_configuracoes_system_unit_id'])
            { 
                $criteria = TCriteria::create(['system_unit_id' => $param['configuracoes_filial_configuracoes_system_unit_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'configuracoes_filial_configuracoes_centro_custo_crec_id', 'kraftsoft', 'CentroCusto', 'id', '{descricao}', 'numero asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'configuracoes_filial_configuracoes_centro_custo_crec_id'); 
            }  

            if (isset($param['configuracoes_filial_configuracoes_system_unit_id']) && $param['configuracoes_filial_configuracoes_system_unit_id'])
            { 
                $criteria = TCriteria::create(['system_unit_id' => $param['configuracoes_filial_configuracoes_system_unit_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'configuracoes_filial_configuracoes_plano_conta_crec_id', 'kraftsoft', 'PlanoConta', 'id', '{descricao}', 'numero asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'configuracoes_filial_configuracoes_plano_conta_crec_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public  function onAddDetailConfiguracoesFilialConfiguracoes($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Filial", 'name'=>"configuracoes_filial_configuracoes_system_unit_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->configuracoes_filial_configuracoes__row__id) ? $data->configuracoes_filial_configuracoes__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ConfiguracoesFilial();
            $grid_data->__row__id = $__row__id;
            $grid_data->id = $data->configuracoes_filial_configuracoes_id;
            $grid_data->system_unit_id = $data->configuracoes_filial_configuracoes_system_unit_id;
            $grid_data->produto_etiqueta_configuracoes_id = $data->configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id;
            $grid_data->centro_custo_mascara = $data->configuracoes_filial_configuracoes_centro_custo_mascara;
            $grid_data->plano_conta_mascara = $data->configuracoes_filial_configuracoes_plano_conta_mascara;
            $grid_data->centro_custo_crec_id = $data->configuracoes_filial_configuracoes_centro_custo_crec_id;
            $grid_data->plano_conta_crec_id = $data->configuracoes_filial_configuracoes_plano_conta_crec_id;
            $grid_data->cpag_usa_plano_contas_id = $data->configuracoes_filial_configuracoes_cpag_usa_plano_contas_id;
            $grid_data->informar_duplicidade_de_item_venda_id = $data->configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id;
            $grid_data->venda_apenas_com_estoque_id = $data->configuracoes_filial_configuracoes_venda_apenas_com_estoque_id;
            $grid_data->notafiscal_cprod_padrao_orcamento_id = $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id;
            $grid_data->notafiscal_cprod_padrao_venda_id = $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id;
            $grid_data->produto_margem_padrao = $data->configuracoes_filial_configuracoes_produto_margem_padrao;
            $grid_data->info_complementar_orcamento = $data->configuracoes_filial_configuracoes_info_complementar_orcamento;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['id'] =  $param['configuracoes_filial_configuracoes_id'] ?? null;
            $__row__data['__display__']['system_unit_id'] =  $param['configuracoes_filial_configuracoes_system_unit_id'] ?? null;
            $__row__data['__display__']['produto_etiqueta_configuracoes_id'] =  $param['configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id'] ?? null;
            $__row__data['__display__']['centro_custo_mascara'] =  $param['configuracoes_filial_configuracoes_centro_custo_mascara'] ?? null;
            $__row__data['__display__']['plano_conta_mascara'] =  $param['configuracoes_filial_configuracoes_plano_conta_mascara'] ?? null;
            $__row__data['__display__']['centro_custo_crec_id'] =  $param['configuracoes_filial_configuracoes_centro_custo_crec_id'] ?? null;
            $__row__data['__display__']['plano_conta_crec_id'] =  $param['configuracoes_filial_configuracoes_plano_conta_crec_id'] ?? null;
            $__row__data['__display__']['cpag_usa_plano_contas_id'] =  $param['configuracoes_filial_configuracoes_cpag_usa_plano_contas_id'] ?? null;
            $__row__data['__display__']['informar_duplicidade_de_item_venda_id'] =  $param['configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id'] ?? null;
            $__row__data['__display__']['venda_apenas_com_estoque_id'] =  $param['configuracoes_filial_configuracoes_venda_apenas_com_estoque_id'] ?? null;
            $__row__data['__display__']['notafiscal_cprod_padrao_orcamento_id'] =  $param['configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id'] ?? null;
            $__row__data['__display__']['notafiscal_cprod_padrao_venda_id'] =  $param['configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id'] ?? null;
            $__row__data['__display__']['produto_margem_padrao'] =  $param['configuracoes_filial_configuracoes_produto_margem_padrao'] ?? null;
            $__row__data['__display__']['info_complementar_orcamento'] =  $param['configuracoes_filial_configuracoes_info_complementar_orcamento'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->configuracoes_filial_configuracoes_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('configuracoes_filial_configuracoes_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->configuracoes_filial_configuracoes_id = '';
            $data->configuracoes_filial_configuracoes_system_unit_id = '';
            $data->configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id = '';
            $data->configuracoes_filial_configuracoes_centro_custo_mascara = '';
            $data->configuracoes_filial_configuracoes_plano_conta_mascara = '';
            $data->configuracoes_filial_configuracoes_centro_custo_crec_id = '';
            $data->configuracoes_filial_configuracoes_plano_conta_crec_id = '';
            $data->configuracoes_filial_configuracoes_cpag_usa_plano_contas_id = '';
            $data->configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id = '';
            $data->configuracoes_filial_configuracoes_venda_apenas_com_estoque_id = '';
            $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id = '';
            $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id = '';
            $data->configuracoes_filial_configuracoes_produto_margem_padrao = '';
            $data->configuracoes_filial_configuracoes_info_complementar_orcamento = '';
            $data->configuracoes_filial_configuracoes__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6346920170d4b');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailConfiguracoesFilial($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->configuracoes_filial_configuracoes_id = $__row__data->__display__->id ?? null;
            $data->configuracoes_filial_configuracoes_system_unit_id = $__row__data->__display__->system_unit_id ?? null;
            $data->configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id = $__row__data->__display__->produto_etiqueta_configuracoes_id ?? null;
            $data->configuracoes_filial_configuracoes_centro_custo_mascara = $__row__data->__display__->centro_custo_mascara ?? null;
            $data->configuracoes_filial_configuracoes_plano_conta_mascara = $__row__data->__display__->plano_conta_mascara ?? null;
            $data->configuracoes_filial_configuracoes_centro_custo_crec_id = $__row__data->__display__->centro_custo_crec_id ?? null;
            $data->configuracoes_filial_configuracoes_plano_conta_crec_id = $__row__data->__display__->plano_conta_crec_id ?? null;
            $data->configuracoes_filial_configuracoes_cpag_usa_plano_contas_id = $__row__data->__display__->cpag_usa_plano_contas_id ?? null;
            $data->configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id = $__row__data->__display__->informar_duplicidade_de_item_venda_id ?? null;
            $data->configuracoes_filial_configuracoes_venda_apenas_com_estoque_id = $__row__data->__display__->venda_apenas_com_estoque_id ?? null;
            $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id = $__row__data->__display__->notafiscal_cprod_padrao_orcamento_id ?? null;
            $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id = $__row__data->__display__->notafiscal_cprod_padrao_venda_id ?? null;
            $data->configuracoes_filial_configuracoes_produto_margem_padrao = $__row__data->__display__->produto_margem_padrao ?? null;
            $data->configuracoes_filial_configuracoes_info_complementar_orcamento = $__row__data->__display__->info_complementar_orcamento ?? null;
            $data->configuracoes_filial_configuracoes__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6346920170d4b');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailConfiguracoesFilial($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->configuracoes_filial_configuracoes_id = '';
            $data->configuracoes_filial_configuracoes_system_unit_id = '';
            $data->configuracoes_filial_configuracoes_produto_etiqueta_configuracoes_id = '';
            $data->configuracoes_filial_configuracoes_centro_custo_mascara = '';
            $data->configuracoes_filial_configuracoes_plano_conta_mascara = '';
            $data->configuracoes_filial_configuracoes_centro_custo_crec_id = '';
            $data->configuracoes_filial_configuracoes_plano_conta_crec_id = '';
            $data->configuracoes_filial_configuracoes_cpag_usa_plano_contas_id = '';
            $data->configuracoes_filial_configuracoes_informar_duplicidade_de_item_venda_id = '';
            $data->configuracoes_filial_configuracoes_venda_apenas_com_estoque_id = '';
            $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_orcamento_id = '';
            $data->configuracoes_filial_configuracoes_notafiscal_cprod_padrao_venda_id = '';
            $data->configuracoes_filial_configuracoes_produto_margem_padrao = '';
            $data->configuracoes_filial_configuracoes_info_complementar_orcamento = '';
            $data->configuracoes_filial_configuracoes__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('configuracoes_filial_configuracoes_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Configuracoes(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $configuracoes_filial_configuracoes_items = $this->storeMasterDetailItems('ConfiguracoesFilial', 'configuracoes_id', 'configuracoes_filial_configuracoes', $object, $param['configuracoes_filial_configuracoes_list___row__data'] ?? [], $this->form, $this->configuracoes_filial_configuracoes_list, function($masterObject, $detailObject){ 

                Funcoes::SalvarUsuarioCadastro($detailObject);

            }, $this->configuracoes_filial_configuracoes_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Configuracoes($key); // instantiates the Active Record 

                $configuracoes_filial_configuracoes_items = $this->loadMasterDetailItems('ConfiguracoesFilial', 'configuracoes_id', 'configuracoes_filial_configuracoes', $object, $this->form, $this->configuracoes_filial_configuracoes_list, $this->configuracoes_filial_configuracoes_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                    $objectItems->configuracoes_filial_configuracoes_system_unit_id = null;
                    if(isset($detailObject->system_unit_id) && $detailObject->system_unit_id)
                    {
                        $objectItems->__display__->system_unit_id = $detailObject->system_unit_id;
                    }

                    $objectItems->configuracoes_filial_configuracoes_plano_conta_crec_id = null;
                    if(isset($detailObject->plano_conta_crec_id) && $detailObject->plano_conta_crec_id)
                    {
                        $objectItems->__display__->plano_conta_crec_id = $detailObject->plano_conta_crec_id;
                    }

                    $objectItems->configuracoes_filial_configuracoes_system_unit_id = null;
                    if(isset($detailObject->system_unit_id) && $detailObject->system_unit_id)
                    {
                        $objectItems->__display__->system_unit_id = $detailObject->system_unit_id;
                    }

                    $objectItems->configuracoes_filial_configuracoes_centro_custo_crec_id = null;
                    if(isset($detailObject->centro_custo_crec_id) && $detailObject->centro_custo_crec_id)
                    {
                        $objectItems->__display__->centro_custo_crec_id = $detailObject->centro_custo_crec_id;
                    }

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        //se já existir registro de config, carregar..
        TTransaction::open(self::$database); // open a transaction
        $config = Configuracoes::where('id', '>', 0)->first();
        TTransaction::close();      

        if($config)
        {
            $param['key'] = $config->id;

            $this->onEdit($param);

            /* BLOCO ISOLADO POR BUG DO BUILDER QUE NÃO DEIXA APAGAR A LINHA QUE FOI COPIADA DE OUTRO METODO....
                $configuracoes_filial_configuracoes_items = $this->loadMasterDetailItems('ConfiguracoesFilial', 'configuracoes_id', 'configuracoes_filial_configuracoes', $object, $this->form, $this->configuracoes_filial_configuracoes_list, $this->configuracoes_filial_configuracoes_criteria, function($masterObject, $detailObject, $objectItems){ //</blockLine>
                    //</autoCode>
                }); //</blockLine>            
            */  
        }
    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->configuracoes_filial_configuracoes_system_unit_id))
            {
                $value = $object->configuracoes_filial_configuracoes_system_unit_id;

                $obj->configuracoes_filial_configuracoes_system_unit_id = $value;
            }
            if(isset($object->configuracoes_filial_configuracoes_centro_custo_crec_id))
            {
                $value = $object->configuracoes_filial_configuracoes_centro_custo_crec_id;

                $obj->configuracoes_filial_configuracoes_centro_custo_crec_id = $value;
            }
            if(isset($object->configuracoes_filial_configuracoes_plano_conta_crec_id))
            {
                $value = $object->configuracoes_filial_configuracoes_plano_conta_crec_id;

                $obj->configuracoes_filial_configuracoes_plano_conta_crec_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->configuracoes_filial->configuracoes->system_unit_id))
            {
                $value = $object->configuracoes_filial->configuracoes->system_unit_id;

                $obj->configuracoes_filial_configuracoes_system_unit_id = $value;
            }
            if(isset($object->configuracoes_filial->configuracoes->centro_custo_crec_id))
            {
                $value = $object->configuracoes_filial->configuracoes->centro_custo_crec_id;

                $obj->configuracoes_filial_configuracoes_centro_custo_crec_id = $value;
            }
            if(isset($object->configuracoes_filial->configuracoes->plano_conta_crec_id))
            {
                $value = $object->configuracoes_filial->configuracoes->plano_conta_crec_id;

                $obj->configuracoes_filial_configuracoes_plano_conta_crec_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

