<?php

class DispositivosForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Dispositivos';
    private static $primaryKey = 'id';
    private static $formName = 'form_DispositivosForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de dispositivos");


        $id = new TEntry('id');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $token = new TEntry('token');
        $button_gerar = new TButton('button_gerar');
        $serial_dispositivo = new TEntry('serial_dispositivo');
        $data_hora_ultima_sincronizacao = new TDateTime('data_hora_ultima_sincronizacao');
        $ip_sincronizacao = new TEntry('ip_sincronizacao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $system_unit_id->addValidation("System unit id", new TRequiredValidator()); 
        $token->addValidation("Token", new TRequiredValidator()); 

        $system_unit_id->enableSearch();
        $token->setMaxLength(100);
        $button_gerar->setAction(new TAction([$this, 'onGerarToken']), "Gerar");
        $button_gerar->addStyleClass('btn-default');
        $button_gerar->setImage('fas:unlock-alt #2196F3');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_hora_ultima_sincronizacao->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_hora_ultima_sincronizacao->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $token->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $ip_sincronizacao->setEditable(false);
        $serial_dispositivo->setEditable(false);
        $data_hora_ultima_sincronizacao->setEditable(false);

        $id->setSize(100);
        $token->setSize('80%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $system_unit_id->setSize('100%');
        $ip_sincronizacao->setSize('100%');
        $serial_dispositivo->setSize('100%');
        $data_hora_ultima_sincronizacao->setSize(150);


        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Filial:", '#ff0000', '14px', null, '100%'),$system_unit_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Token:", '#ff0000', '14px', null, '100%'),$token,$button_gerar],[new TLabel("Serial Dispositivo:", null, '14px', null, '100%'),$serial_dispositivo]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_6312b4189d439 = new BContainer('bcontainer_6312b4189d439');
        $this->bcontainer_6312b4189d439 = $bcontainer_6312b4189d439;

        $bcontainer_6312b4189d439->setTitle("Ultima Sincronização", '#333', '18px', '', '#fff');
        $bcontainer_6312b4189d439->setBorderColor('#c0c0c0');

        $row3 = $bcontainer_6312b4189d439->addFields([new TLabel("Data/Hora Ultima Sincronização:", null, '14px', null, '100%'),$data_hora_ultima_sincronizacao],[new TLabel("IP Sincronização:", null, '14px', null, '100%'),$ip_sincronizacao]);
        $row3->layout = [' col-sm-6',' col-sm-6'];

        $row4 = $this->form->addFields([$bcontainer_6312b4189d439]);
        $row4->layout = [' col-sm-12'];

        $bcontainer_6312b37b9d433 = new BContainer('bcontainer_6312b37b9d433');
        $this->bcontainer_6312b37b9d433 = $bcontainer_6312b37b9d433;

        $bcontainer_6312b37b9d433->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_6312b37b9d433->setBorderColor('#c0c0c0');

        $row5 = $bcontainer_6312b37b9d433->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row5->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row6 = $this->form->addFields([$bcontainer_6312b37b9d433]);
        $row6->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['DispositivosList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Configurações","Cadastro de dispositivos"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onGerarToken($param = null) 
    {
        try 
        {
            $obj = new stdClass();
            $obj->token = Funcoes::geraToken(50);
            TForm::sendData(self::$formName, $obj);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Dispositivos(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('DispositivosList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Dispositivos($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

