<?php

class EventosForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Eventos';
    private static $primaryKey = 'id';
    private static $formName = 'form_EventosForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Alertas");


        $id = new TEntry('id');
        $system_program_id = new TDBCombo('system_program_id', 'kraftsoft', 'SystemProgram', 'id', '{name}','name asc'  );
        $descricao = new TEntry('descricao');
        $email_template_id = new TDBCombo('email_template_id', 'kraftsoft', 'EmailTemplate', 'id', '{titulo}','titulo asc'  );
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $eventos_systemuser_eventos_system_users_id = new TDBCombo('eventos_systemuser_eventos_system_users_id', 'kraftsoft', 'SystemUsers', 'id', '{name}','name asc'  );
        $eventos_systemuser_eventos_system_unit_id = new TDBCombo('eventos_systemuser_eventos_system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $eventos_systemuser_eventos_enviar_email = new TCheckButton('eventos_systemuser_eventos_enviar_email');
        $eventos_systemuser_eventos_id = new THidden('eventos_systemuser_eventos_id');
        $button_adicionar_eventos_systemuser_eventos = new TButton('button_adicionar_eventos_systemuser_eventos');

        $descricao->addValidation("Descrição (Cadastro Restrito)", new TRequiredValidator()); 

        $eventos_systemuser_eventos_enviar_email->setUseSwitch(true, 'blue');
        $eventos_systemuser_eventos_enviar_email->setIndexValue("1");
        $button_adicionar_eventos_systemuser_eventos->setAction(new TAction([$this, 'onAddDetailEventosSystemuserEventos'],['static' => 1]), "Adicionar");
        $button_adicionar_eventos_systemuser_eventos->addStyleClass('btn-default');
        $button_adicionar_eventos_systemuser_eventos->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $system_program_id->enableSearch();
        $email_template_id->enableSearch();
        $eventos_systemuser_eventos_system_unit_id->enableSearch();
        $eventos_systemuser_eventos_system_users_id->enableSearch();

        $id->setEditable(false);
        $descricao->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $system_program_id->setEditable(false);

        $id->setSize(100);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $system_program_id->setSize('100%');
        $email_template_id->setSize('100%');
        $eventos_systemuser_eventos_id->setSize(200);
        $eventos_systemuser_eventos_system_unit_id->setSize('100%');
        $eventos_systemuser_eventos_system_users_id->setSize('100%');

        $button_adicionar_eventos_systemuser_eventos->id = '638cf71a9b073';

        $this->form->appendPage("Evento");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("System program (Tela):", '#FF0000', '14px', null),$system_program_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Template de E-mail:", null, '14px', null),$email_template_id]);
        $row3->layout = [' col-sm-12'];

        $row4 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row5 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row5->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Usuários alertados quando este evento ocorrer");

        $this->detailFormEventosSystemuserEventos = new BootstrapFormBuilder('detailFormEventosSystemuserEventos');
        $this->detailFormEventosSystemuserEventos->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormEventosSystemuserEventos->setProperty('class', 'form-horizontal builder-detail-form');

        $row6 = $this->detailFormEventosSystemuserEventos->addFields([new TLabel("Usuário:", '#ff0000', '14px', null, '100%'),$eventos_systemuser_eventos_system_users_id],[new TLabel("Filial:", '#ff0000', '14px', null, '100%'),$eventos_systemuser_eventos_system_unit_id],[new TLabel("Enviar E-mail:", null, '14px', null, '100%'),$eventos_systemuser_eventos_enviar_email]);
        $row6->layout = [' col-sm-5',' col-sm-5',' col-sm-2'];

        $row7 = $this->detailFormEventosSystemuserEventos->addFields([],[$eventos_systemuser_eventos_id]);
        $row7->layout = ['col-sm-6','col-sm-6'];

        $row8 = $this->detailFormEventosSystemuserEventos->addFields([$button_adicionar_eventos_systemuser_eventos]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->detailFormEventosSystemuserEventos->addFields([new THidden('eventos_systemuser_eventos__row__id')]);
        $this->eventos_systemuser_eventos_criteria = new TCriteria();

        $this->eventos_systemuser_eventos_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->eventos_systemuser_eventos_list->disableHtmlConversion();;
        $this->eventos_systemuser_eventos_list->generateHiddenFields();
        $this->eventos_systemuser_eventos_list->setId('eventos_systemuser_eventos_list');

        $this->eventos_systemuser_eventos_list->style = 'width:100%';
        $this->eventos_systemuser_eventos_list->class .= ' table-bordered';

        $column_eventos_systemuser_eventos_system_users_name = new TDataGridColumn('system_users->name', "Usuário", 'left');
        $column_eventos_systemuser_eventos_system_unit_name = new TDataGridColumn('system_unit->name', "Filial", 'left');
        $column_eventos_systemuser_eventos_enviar_email_transformed = new TDataGridColumn('enviar_email', "Enviar E-mail", 'left');

        $column_eventos_systemuser_eventos__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_eventos_systemuser_eventos__row__data->setVisibility(false);

        $action_onEditDetailEventosSystemuser = new TDataGridAction(array('EventosForm', 'onEditDetailEventosSystemuser'));
        $action_onEditDetailEventosSystemuser->setUseButton(false);
        $action_onEditDetailEventosSystemuser->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailEventosSystemuser->setLabel("Editar");
        $action_onEditDetailEventosSystemuser->setImage('far:edit #478fca');
        $action_onEditDetailEventosSystemuser->setFields(['__row__id', '__row__data']);

        $this->eventos_systemuser_eventos_list->addAction($action_onEditDetailEventosSystemuser);
        $action_onDeleteDetailEventosSystemuser = new TDataGridAction(array('EventosForm', 'onDeleteDetailEventosSystemuser'));
        $action_onDeleteDetailEventosSystemuser->setUseButton(false);
        $action_onDeleteDetailEventosSystemuser->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailEventosSystemuser->setLabel("Excluir");
        $action_onDeleteDetailEventosSystemuser->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailEventosSystemuser->setFields(['__row__id', '__row__data']);

        $this->eventos_systemuser_eventos_list->addAction($action_onDeleteDetailEventosSystemuser);

        $this->eventos_systemuser_eventos_list->addColumn($column_eventos_systemuser_eventos_system_users_name);
        $this->eventos_systemuser_eventos_list->addColumn($column_eventos_systemuser_eventos_system_unit_name);
        $this->eventos_systemuser_eventos_list->addColumn($column_eventos_systemuser_eventos_enviar_email_transformed);

        $this->eventos_systemuser_eventos_list->addColumn($column_eventos_systemuser_eventos__row__data);

        $this->eventos_systemuser_eventos_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->eventos_systemuser_eventos_list);
        $this->detailFormEventosSystemuserEventos->addContent([$tableResponsiveDiv]);

        $column_eventos_systemuser_eventos_enviar_email_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if($value === true || $value == 't' || $value === 1 || $value == '1' || $value == 's' || $value == 'S' || $value == 'T')
            {
                return 'Sim';
            }
            elseif($value === false || $value == 'f' || $value === 0 || $value == '0' || $value == 'n' || $value == 'N' || $value == 'F')   
            {
                return 'Não';
            }

            return $value;

        });        $row10 = $this->form->addFields([$this->detailFormEventosSystemuserEventos]);
        $row10->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['EventosHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Configurações","Alertas para eventos"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailEventosSystemuserEventos($param = null) 
    {
        try
        {
            $data = $this->form->getData();

                $errors = [];
                $requiredFields = [];
                $requiredFields[] = ['label'=>"System users id", 'name'=>"eventos_systemuser_eventos_system_users_id", 'class'=>'TRequiredValidator', 'value'=>[]];
                $requiredFields[] = ['label'=>"System unit id", 'name'=>"eventos_systemuser_eventos_system_unit_id", 'class'=>'TRequiredValidator', 'value'=>[]];
                foreach($requiredFields as $requiredField)
                {
                    try
                    {
                        (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                    }
                    catch(Exception $e)
                    {
                        $errors[] = $e->getMessage() . '.';
                    }
                 }
                 if(count($errors) > 0)
                 {
                     throw new Exception(implode('<br>', $errors));
                 }

                $__row__id = !empty($data->eventos_systemuser_eventos__row__id) ? $data->eventos_systemuser_eventos__row__id : 'b'.uniqid();

                TTransaction::open(self::$database);

                $grid_data = new EventosSystemuser();
                $grid_data->__row__id = $__row__id;
                $grid_data->system_users_id = $data->eventos_systemuser_eventos_system_users_id;
                $grid_data->system_unit_id = $data->eventos_systemuser_eventos_system_unit_id;
                $grid_data->enviar_email = $data->eventos_systemuser_eventos_enviar_email;
                $grid_data->id = $data->eventos_systemuser_eventos_id;

                $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
                $__row__data['__row__id'] = $__row__id;
                $__row__data['__display__']['system_users_id'] =  $param['eventos_systemuser_eventos_system_users_id'] ?? null;
                $__row__data['__display__']['system_unit_id'] =  $param['eventos_systemuser_eventos_system_unit_id'] ?? null;
                $__row__data['__display__']['enviar_email'] =  $param['eventos_systemuser_eventos_enviar_email'] ?? null;
                $__row__data['__display__']['id'] =  $param['eventos_systemuser_eventos_id'] ?? null;

                $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
                $row = $this->eventos_systemuser_eventos_list->addItem($grid_data);
                $row->id = $grid_data->__row__id;

                TDataGrid::replaceRowById('eventos_systemuser_eventos_list', $grid_data->__row__id, $row);

                TTransaction::close();

                $data = new stdClass;
                $data->eventos_systemuser_eventos_system_users_id = '';
                $data->eventos_systemuser_eventos_system_unit_id = '';
                $data->eventos_systemuser_eventos_enviar_email = '';
                $data->eventos_systemuser_eventos_id = '';
                $data->eventos_systemuser_eventos__row__id = '';

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#638cf71a9b073');
                   if(typeof element.attr('add') != 'undefined')
                   {
                       element.html(base64_decode(element.attr('add')));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailEventosSystemuser($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));
                $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

                $data = new stdClass;
                $data->eventos_systemuser_eventos_system_users_id = $__row__data->__display__->system_users_id ?? null;
                $data->eventos_systemuser_eventos_system_unit_id = $__row__data->__display__->system_unit_id ?? null;
                $data->eventos_systemuser_eventos_enviar_email = $__row__data->__display__->enviar_email ?? null;
                $data->eventos_systemuser_eventos_id = $__row__data->__display__->id ?? null;
                $data->eventos_systemuser_eventos__row__id = $__row__data->__row__id;

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#638cf71a9b073');
                   if(!element.attr('add')){
                       element.attr('add', base64_encode(element.html()));
                   }
                   element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
                   if(!element.attr('edit')){
                       element.attr('edit', base64_encode(element.html()));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onDeleteDetailEventosSystemuser($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));

                $data = new stdClass;
                $data->eventos_systemuser_eventos_system_users_id = '';
                $data->eventos_systemuser_eventos_system_unit_id = '';
                $data->eventos_systemuser_eventos_enviar_email = '';
                $data->eventos_systemuser_eventos_id = '';
                $data->eventos_systemuser_eventos__row__id = '';

                TForm::sendData(self::$formName, $data);

                TDataGrid::removeRowById('eventos_systemuser_eventos_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Eventos(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $eventos_systemuser_eventos_items = $this->storeMasterDetailItems('EventosSystemuser', 'eventos_id', 'eventos_systemuser_eventos', $object, $param['eventos_systemuser_eventos_list___row__data'] ?? [], $this->form, $this->eventos_systemuser_eventos_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->eventos_systemuser_eventos_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('EventosHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Eventos($key); // instantiates the Active Record 

                $eventos_systemuser_eventos_items = $this->loadMasterDetailItems('EventosSystemuser', 'eventos_id', 'eventos_systemuser_eventos', $object, $this->form, $this->eventos_systemuser_eventos_list, $this->eventos_systemuser_eventos_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 


                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

