<?php

class FilialForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'SystemUnit';
    private static $primaryKey = 'id';
    private static $formName = 'form_FilialForm';

    use Adianti\Base\AdiantiFileSaveTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Filial");

        $criteria_nfe_api_documentos_id = new TCriteria();
        $criteria_nfe_homologacao_series_id = new TCriteria();
        $criteria_nfe_producao_series_id = new TCriteria();
        $criteria_nfce_api_documentos_id = new TCriteria();
        $criteria_nfce_homologacao_series_id = new TCriteria();
        $criteria_nfce_producao_series_id = new TCriteria();
        $criteria_mdfe_api_documentos_id = new TCriteria();
        $criteria_mdfe_homologacao_series_id = new TCriteria();
        $criteria_mdfe_producao_series_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_nfe_api_documentos_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        if(!empty($param["id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_system_unit_id', $param["id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_system_unit_id');
        $criteria_nfe_homologacao_series_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = NotafiscalMod::NFe;
        $criteria_nfe_homologacao_series_id->add(new TFilter('notafiscal_mod_id', '=', $filterVar)); 
        $filterVar = NotafiscalTpamb::Homologacao;
        $criteria_nfe_homologacao_series_id->add(new TFilter('notafiscal_tpamb_id', '=', $filterVar)); 
        if(!empty($param["id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_system_unit_id', $param["id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_system_unit_id');
        $criteria_nfe_producao_series_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = NotafiscalMod::NFe;
        $criteria_nfe_producao_series_id->add(new TFilter('notafiscal_mod_id', '=', $filterVar)); 
        $filterVar = NotafiscalTpamb::Producao;
        $criteria_nfe_producao_series_id->add(new TFilter('notafiscal_tpamb_id', '=', $filterVar)); 
        if(!empty($param["id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_system_unit_id', $param["id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_system_unit_id');
        $criteria_nfce_api_documentos_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        if(!empty($param["id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_system_unit_id', $param["id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_system_unit_id');
        $criteria_nfce_homologacao_series_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = NotafiscalMod::NFCe;
        $criteria_nfce_homologacao_series_id->add(new TFilter('notafiscal_mod_id', '=', $filterVar)); 
        $filterVar = NotafiscalTpamb::Homologacao;
        $criteria_nfce_homologacao_series_id->add(new TFilter('notafiscal_tpamb_id', '=', $filterVar)); 
        if(!empty($param["id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_system_unit_id', $param["id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_system_unit_id');
        $criteria_nfce_producao_series_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = NotafiscalMod::NFCe;
        $criteria_nfce_producao_series_id->add(new TFilter('notafiscal_mod_id', '=', $filterVar)); 
        $filterVar = NotafiscalTpamb::Producao;
        $criteria_nfce_producao_series_id->add(new TFilter('notafiscal_tpamb_id', '=', $filterVar)); 
        if(!empty($param["id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_system_unit_id', $param["id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_system_unit_id');
        $criteria_mdfe_api_documentos_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = MdfeTpamb::Homologacao;
        $criteria_mdfe_homologacao_series_id->add(new TFilter('mdfe_tpamb_id', '=', $filterVar)); 
        $filterVar = MdfeTpamb::Producao;
        $criteria_mdfe_producao_series_id->add(new TFilter('mdfe_tpamb_id', '=', $filterVar)); 

        $cnpj = new TEntry('cnpj');
        $button_buscar = new TButton('button_buscar');
        $name = new TEntry('name');
        $razao_social = new TEntry('razao_social');
        $notafiscal_crt_id = new TDBCombo('notafiscal_crt_id', 'kraftsoft', 'NotafiscalCrt', 'id', '{descricao}','descricao asc'  );
        $sn_matriz = new TCombo('sn_matriz');
        $inscricao_estadual = new TEntry('inscricao_estadual');
        $inscricao_municipal = new TEntry('inscricao_municipal');
        $fone = new TEntry('fone');
        $email = new TEntry('email');
        $notafiscal_cprod_padrao_id = new TDBCombo('notafiscal_cprod_padrao_id', 'kraftsoft', 'NotafiscalCprodPadrao', 'id', '{descricao}','id asc'  );
        $cnae = new TEntry('cnae');
        $id = new THidden('id');
        $connection_name = new THidden('connection_name');
        $end_cep = new TEntry('end_cep');
        $end_municipio = new TEntry('end_municipio');
        $end_mun_codibge = new TEntry('end_mun_codibge');
        $end_uf = new TEntry('end_uf');
        $end_logradouro = new TEntry('end_logradouro');
        $end_bairro = new TEntry('end_bairro');
        $end_numero = new TEntry('end_numero');
        $end_complemento = new TEntry('end_complemento');
        $vendas_natureza_operacao_id = new TDBCombo('vendas_natureza_operacao_id', 'kraftsoft', 'NaturezaOperacao', 'id', '{descricao}','descricao asc'  );
        $nfe_tpimp_id = new TDBCombo('nfe_tpimp_id', 'kraftsoft', 'NotafiscalTpimp', 'id', '{descricao}','descricao asc'  );
        $nfe_tpamb_id = new TDBCombo('nfe_tpamb_id', 'kraftsoft', 'NotafiscalTpamb', 'id', '{descricao}','descricao asc'  );
        $nfe_api_documentos_id = new TDBCombo('nfe_api_documentos_id', 'kraftsoft', 'ApiDocumentos', 'id', '{id} - {integradores->nome} - {descricao}','descricao asc' , $criteria_nfe_api_documentos_id );
        $nfe_homologacao_series_id = new TDBCombo('nfe_homologacao_series_id', 'kraftsoft', 'NotafiscalSeries', 'id', '{serie}  - Sequencial: {sequencial}','serie asc' , $criteria_nfe_homologacao_series_id );
        $nfe_producao_series_id = new TDBCombo('nfe_producao_series_id', 'kraftsoft', 'NotafiscalSeries', 'id', '{serie}  - Sequencial: {sequencial}','serie asc' , $criteria_nfe_producao_series_id );
        $nfce_natureza_operacao_id = new TDBCombo('nfce_natureza_operacao_id', 'kraftsoft', 'NaturezaOperacao', 'id', '{descricao}','descricao asc'  );
        $nfce_tpimp_id = new TDBCombo('nfce_tpimp_id', 'kraftsoft', 'NotafiscalTpimp', 'id', '{descricao}','descricao asc'  );
        $nfce_tpamb_id = new TDBCombo('nfce_tpamb_id', 'kraftsoft', 'NotafiscalTpamb', 'id', '{descricao}','descricao asc'  );
        $nfce_api_documentos_id = new TDBCombo('nfce_api_documentos_id', 'kraftsoft', 'ApiDocumentos', 'id', '{id} - {integradores->nome}  - {descricao}','descricao asc' , $criteria_nfce_api_documentos_id );
        $nfce_homologacao_series_id = new TDBCombo('nfce_homologacao_series_id', 'kraftsoft', 'NotafiscalSeries', 'id', '{serie}  - Sequencial: {sequencial}','serie asc' , $criteria_nfce_homologacao_series_id );
        $nfce_producao_series_id = new TDBCombo('nfce_producao_series_id', 'kraftsoft', 'NotafiscalSeries', 'id', '{serie}  - Sequencial: {sequencial}','serie asc' , $criteria_nfce_producao_series_id );
        $nfce_id_csc_homologacao = new TEntry('nfce_id_csc_homologacao');
        $nfce_csc_homologacao = new TEntry('nfce_csc_homologacao');
        $nfce_id_csc_producao = new TEntry('nfce_id_csc_producao');
        $nfce_csc_producao = new TEntry('nfce_csc_producao');
        $mdfe_api_documentos_id = new TDBCombo('mdfe_api_documentos_id', 'kraftsoft', 'ApiDocumentos', 'id', '{id} - {integradores->nome}  - {descricao}','descricao asc' , $criteria_mdfe_api_documentos_id );
        $mdfe_homologacao_series_id = new TDBCombo('mdfe_homologacao_series_id', 'kraftsoft', 'MdfeSeries', 'id', '{serie}  - Sequencial: {sequencial}','serie asc' , $criteria_mdfe_homologacao_series_id );
        $mdfe_producao_series_id = new TDBCombo('mdfe_producao_series_id', 'kraftsoft', 'MdfeSeries', 'id', '{serie}  - Sequencial: {sequencial}','serie asc' , $criteria_mdfe_producao_series_id );
        $mdfe_tpamb_id = new TDBCombo('mdfe_tpamb_id', 'kraftsoft', 'MdfeTpamb', 'id', '{descricao}','descricao asc'  );
        $mdfe_estadoini_id = new TDBCombo('mdfe_estadoini_id', 'kraftsoft', 'Estado', 'id', '{nome}','nome asc'  );
        $veiculo_id = new TDBCombo('veiculo_id', 'kraftsoft', 'Veiculo', 'id', '{modelo_marca}','modelo_marca asc'  );
        $natureza_operacao_compra_id = new TDBCombo('natureza_operacao_compra_id', 'kraftsoft', 'NaturezaOperacao', 'id', '{descricao}','descricao asc'  );
        $aliquota_iss = new TNumeric('aliquota_iss', '2', ',', '.' );
        $aliquota_irrf = new TNumeric('aliquota_irrf', '2', ',', '.' );
        $aliquota_csll = new TNumeric('aliquota_csll', '2', ',', '.' );
        $pc_credito_sn = new TNumeric('pc_credito_sn', '2', ',', '.' );
        $certificadoA1 = new TFile('certificadoA1');
        $senha_certificado = new TEntry('senha_certificado');
        $token_api = new TEntry('token_api');
        $button_gerar = new TButton('button_gerar');
        $button_copiar = new TButton('button_copiar');
        $logo = new TImageCropper('logo');
        $contador_nome = new TEntry('contador_nome');
        $contador_documento = new TEntry('contador_documento');
        $contador_celular = new TEntry('contador_celular');
        $contador_email = new TEntry('contador_email');
        $config_host = new TEntry('config_host');
        $config_port = new TEntry('config_port');
        $config_user = new TEntry('config_user');
        $config_password = new TPassword('config_password');
        $config_replyname = new TEntry('config_replyname');
        $config_replyto = new TEntry('config_replyto');

        $cnpj->addValidation("Cnpj", new TRequiredValidator()); 
        $name->addValidation("Name", new TRequiredValidator()); 
        $razao_social->addValidation("Razão Social", new TRequiredValidator()); 
        $sn_matriz->addValidation("Matriz", new TRequiredValidator()); 

        $cnpj->setMask('99.999.999/9999-99', true);
        $sn_matriz->addItems(["S"=>"Sim","N"=>"Não"]);
        $token_api->setEditable(false);
        $logo->setAllowedExtensions(["jpg","jpeg","png","gif"]);
        $logo->setImagePlaceholder(new TImage("fas:file-upload #dde5ec"));
        $sn_matriz->setValue('N');
        $notafiscal_cprod_padrao_id->setValue('N');

        $logo->enableFileHandling();
        $certificadoA1->enableFileHandling();

        $button_buscar->setAction(new TAction([$this, 'onBuscarCNPJ']), "Buscar");
        $button_gerar->setAction(new TAction([$this, 'onGerarTokenAPI']), "Gerar");
        $button_copiar->setAction(new TAction([$this, 'onCopiarToken']), "Copiar");

        $button_gerar->addStyleClass('btn-default');
        $button_buscar->addStyleClass('btn-default');
        $button_copiar->addStyleClass('btn-default');

        $button_copiar->setImage('fas:copy #009688');
        $button_buscar->setImage('fas:search #000000');
        $button_gerar->setImage('fas:unlock-alt #2196F3');

        $veiculo_id->enableSearch();
        $mdfe_tpamb_id->enableSearch();
        $mdfe_estadoini_id->enableSearch();
        $mdfe_api_documentos_id->enableSearch();
        $mdfe_producao_series_id->enableSearch();
        $mdfe_homologacao_series_id->enableSearch();
        $natureza_operacao_compra_id->enableSearch();

        $cnpj->setMaxLength(14);
        $aliquota_iss->setMaxLength(12);
        $razao_social->setMaxLength(255);
        $aliquota_irrf->setMaxLength(12);
        $aliquota_csll->setMaxLength(12);
        $pc_credito_sn->setMaxLength(12);
        $inscricao_estadual->setMaxLength(255);
        $inscricao_municipal->setMaxLength(255);

        $id->setSize(200);
        $cnpj->setSize('75%');
        $name->setSize('100%');
        $fone->setSize('100%');
        $cnae->setSize('100%');
        $logo->setSize(80, 80);
        $email->setSize('100%');
        $end_uf->setSize('100%');
        $end_cep->setSize('100%');
        $token_api->setSize('83%');
        $sn_matriz->setSize('100%');
        $end_bairro->setSize('100%');
        $end_numero->setSize('100%');
        $veiculo_id->setSize('100%');
        $config_host->setSize('100%');
        $config_port->setSize('100%');
        $config_user->setSize('100%');
        $razao_social->setSize('100%');
        $connection_name->setSize(200);
        $nfe_tpimp_id->setSize('100%');
        $nfe_tpamb_id->setSize('100%');
        $aliquota_iss->setSize('100%');
        $end_municipio->setSize('100%');
        $nfce_tpimp_id->setSize('100%');
        $nfce_tpamb_id->setSize('100%');
        $mdfe_tpamb_id->setSize('100%');
        $aliquota_irrf->setSize('100%');
        $aliquota_csll->setSize('100%');
        $pc_credito_sn->setSize('100%');
        $certificadoA1->setSize('100%');
        $contador_nome->setSize('100%');
        $end_logradouro->setSize('100%');
        $contador_email->setSize('100%');
        $config_replyto->setSize('100%');
        $end_mun_codibge->setSize('100%');
        $end_complemento->setSize('100%');
        $config_password->setSize('100%');
        $contador_celular->setSize('100%');
        $config_replyname->setSize('100%');
        $notafiscal_crt_id->setSize('100%');
        $nfce_csc_producao->setSize('100%');
        $mdfe_estadoini_id->setSize('100%');
        $senha_certificado->setSize('100%');
        $inscricao_estadual->setSize('100%');
        $contador_documento->setSize('100%');
        $inscricao_municipal->setSize('100%');
        $nfce_csc_homologacao->setSize('100%');
        $nfce_id_csc_producao->setSize('100%');
        $nfe_api_documentos_id->setSize('100%');
        $nfe_producao_series_id->setSize('100%');
        $nfce_api_documentos_id->setSize('100%');
        $mdfe_api_documentos_id->setSize('100%');
        $nfce_producao_series_id->setSize('100%');
        $nfce_id_csc_homologacao->setSize('100%');
        $mdfe_producao_series_id->setSize('100%');
        $nfe_homologacao_series_id->setSize('100%');
        $nfce_natureza_operacao_id->setSize('100%');
        $notafiscal_cprod_padrao_id->setSize('100%');
        $nfce_homologacao_series_id->setSize('100%');
        $mdfe_homologacao_series_id->setSize('100%');
        $vendas_natureza_operacao_id->setSize('100%');
        $natureza_operacao_compra_id->setSize('100%');


        $token_api->id = 'edt_token_api';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Cnpj *:", '#F70800', '14px', null, '100%'),$cnpj,$button_buscar],[new TLabel("Nome *:", '#F70800', '14px', null, '100%'),$name],[new TLabel("Razão Social *:", '#F70800', '14px', null, '100%'),$razao_social]);
        $row1->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row2 = $this->form->addFields([new TLabel("Regime Tributário *:", '#FF0000', '14px', null),$notafiscal_crt_id],[new TLabel("Matriz *:", '#F70800', '14px', null, '100%'),$sn_matriz],[new TLabel("Inscrição Estadual:", null, '14px', null, '100%'),$inscricao_estadual]);
        $row2->layout = [' col-sm-4','col-sm-4','col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Inscrição Municipal:", null, '14px', null, '100%'),$inscricao_municipal],[new TLabel("Telefone:", null, '14px', null),$fone],[new TLabel("E-mail:", null, '14px', null),$email]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Código padrão do produto para danfe da NFe/NFC-e:", null, '14px', null),$notafiscal_cprod_padrao_id],[new TLabel("CNAE:", null, '14px', null),$cnae]);
        $row4->layout = ['col-sm-4',' col-sm-3'];

        $row5 = $this->form->addFields([$id],[$connection_name]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("Endereço");
        $row6 = $this->form->addFields([new TLabel("CEP:", null, '14px', null),$end_cep],[new TLabel("Município:", null, '14px', null),$end_municipio],[new TLabel("Código IBGE:", null, '14px', null),$end_mun_codibge],[new TLabel("UF:", null, '14px', null),$end_uf]);
        $row6->layout = ['col-sm-4','col-sm-4',' col-sm-2','col-sm-2'];

        $row7 = $this->form->addFields([new TLabel("Logradouro:", null, '14px', null),$end_logradouro],[new TLabel("Bairro:", null, '14px', null),$end_bairro],[new TLabel("Número:", null, '14px', null),$end_numero]);
        $row7->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row8 = $this->form->addFields([new TLabel("Complemento:", null, '14px', null),$end_complemento]);
        $row8->layout = [' col-sm-12'];

        $this->form->appendPage("Fiscal NF-e");
        $row9 = $this->form->addFields([new TLabel("Natureza Operação Venda:", null, '14px', null),$vendas_natureza_operacao_id],[new TLabel("Tipo Impressão:", null, '14px', null),$nfe_tpimp_id],[new TLabel("Tipo Ambiente:", null, '14px', null),$nfe_tpamb_id],[new TLabel("API de Integração:", null, '14px', null),$nfe_api_documentos_id]);
        $row9->layout = [' col-sm-6',' col-sm-6',' col-sm-6',' col-sm-6'];

        $row10 = $this->form->addFields([new TLabel("Série Homologação:", null, '14px', null),$nfe_homologacao_series_id],[new TLabel("Série Produção:", null, '14px', null),$nfe_producao_series_id]);
        $row10->layout = [' col-sm-6',' col-sm-6'];

        $this->form->appendPage("Fiscal NFC-e");
        $row11 = $this->form->addFields([new TLabel("Natureza Operação NFC-e:", null, '14px', null),$nfce_natureza_operacao_id],[new TLabel("Tipo Impressão:", null, '14px', null),$nfce_tpimp_id],[new TLabel("Tipo Ambiente:", null, '14px', null),$nfce_tpamb_id],[new TLabel("API  de Integração:", null, '14px', null),$nfce_api_documentos_id]);
        $row11->layout = ['col-sm-6','col-sm-6','col-sm-6',' col-sm-6'];

        $row12 = $this->form->addFields([new TLabel("Série Homologação:", null, '14px', null),$nfce_homologacao_series_id],[new TLabel("Série Produção:", null, '14px', null),$nfce_producao_series_id]);
        $row12->layout = [' col-sm-6',' col-sm-6'];

        $row13 = $this->form->addFields([new TLabel("ID CSC Homologação:", null, '14px', null),$nfce_id_csc_homologacao],[new TLabel("CSC Homologação:", null, '14px', null),$nfce_csc_homologacao]);
        $row13->layout = [' col-sm-6',' col-sm-6'];

        $row14 = $this->form->addFields([new TLabel("ID CSC Produção:", null, '14px', null),$nfce_id_csc_producao],[new TLabel("CSC Produção:", null, '14px', null),$nfce_csc_producao]);
        $row14->layout = [' col-sm-6',' col-sm-6'];

        $this->form->appendPage("MDF-e");
        $row15 = $this->form->addFields([new TLabel("API de Integração:", null, '14px', null),$mdfe_api_documentos_id]);
        $row15->layout = [' col-sm-12'];

        $row16 = $this->form->addFields([new TLabel("Série Homologação:", null, '14px', null),$mdfe_homologacao_series_id],[new TLabel("Série Produção:", null, '14px', null),$mdfe_producao_series_id]);
        $row16->layout = ['col-sm-6','col-sm-6'];

        $row17 = $this->form->addFields([new TLabel("Tipo Ambiente:", null, '14px', null),$mdfe_tpamb_id],[new TLabel("UF Inicial Padrão:", null, '14px', null),$mdfe_estadoini_id]);
        $row17->layout = [' col-sm-6','col-sm-6'];

        $row18 = $this->form->addFields([new TLabel("Veículo padrão:", null, '14px', null),$veiculo_id]);
        $row18->layout = ['col-sm-6'];

        $this->form->appendPage("Compras");
        $row19 = $this->form->addFields([new TLabel("Natureza operação padrão de compras:", null, '14px', null),$natureza_operacao_compra_id]);
        $row19->layout = [' col-sm-12'];

        $this->form->appendPage("Fiscal Aliquotas");
        $row20 = $this->form->addFields([new TLabel("Alíquota de ISS:", null, '14px', null, '100%'),$aliquota_iss],[new TLabel("Alíquota de IRRF:", null, '14px', null, '100%'),$aliquota_irrf],[new TLabel("Alíquota de CSLL:", null, '14px', null, '100%'),$aliquota_csll]);
        $row20->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row21 = $this->form->addFields([new TLabel("% de crédito do ICMS SN:", null, '14px', null, '100%'),$pc_credito_sn]);
        $row21->layout = ['col-sm-4'];

        $this->form->appendPage("Certificado Digital");
        $row22 = $this->form->addFields([new TLabel("Certificado (A1):", null, '14px', null),$certificadoA1],[new TLabel("Senha Certificado:", null, '14px', null),$senha_certificado]);
        $row22->layout = [' col-sm-6',' col-sm-6'];

        $this->form->appendPage("Outras Informações");
        $row23 = $this->form->addFields([new TLabel("Token API:", null, '14px', null, '100%'),$token_api,$button_gerar,$button_copiar]);
        $row23->layout = [' col-sm-12'];

        $row24 = $this->form->addFields([new TLabel("Logo:", null, '14px', null, '100%'),$logo]);
        $row24->layout = [' col-sm-12'];

        $this->form->appendPage("Contabilidade");
        $row25 = $this->form->addFields([new TLabel("Nome: ", null, '14px', null),$contador_nome],[new TLabel("Documento:", null, '14px', null),$contador_documento],[new TLabel("Celular:", null, '14px', null),$contador_celular],[new TLabel("Email:", null, '14px', null),$contador_email]);
        $row25->layout = [' col-sm-5',' col-sm-4',' col-sm-3',' col-sm-12'];

        $row26 = $this->form->addContent([new TFormSeparator("Configurações SMTP", '#FF9800', '18', '#673AB7')]);
        $row27 = $this->form->addFields([new TLabel(new TImage('fas:globe #4CAF50')."HOST: ", '#4CAF50', '14px', 'B'),$config_host],[new TLabel(new TImage('fas:door-closed #03A9F4')."PORTA:", null, '14px', 'B'),$config_port],[new TLabel(new TImage('fas:envelope #03A9F4')."USUÁRIO E-MAIL: ", '#2196F3', '14px', 'B'),$config_user],[new TLabel(new TImage('fas:key #673AB7')."SENHA: ", '#3F51B5', '14px', 'B'),$config_password],[new TLabel("REMETENTE:", null, '14px', null),$config_replyname],[new TLabel(new TImage('fas:envelope-open-text #4CAF50')."E-MAIL RESPOSTA: ", '#4CAF50', '14px', 'B'),$config_replyto]);
        $row27->layout = ['col-sm-8','col-sm-4','col-sm-8','col-sm-4',' col-sm-4',' col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['FilialList', 'onShow']), 'fas:arrow-alt-circle-left #000000');
        $this->btn_onshow = $btn_onshow;

        $btn_onenviarnuvemfiscal = $this->form->addAction("Enviar Nuvem Fiscal", new TAction([$this, 'onenviarNuvemFiscal']), 'far:circle #000000');
        $this->btn_onenviarnuvemfiscal = $btn_onenviarnuvemfiscal;

        $btn_oncertificado = $this->form->addAction("Certificado Digital", new TAction([$this, 'onCertificado']), 'far:circle #000000');
        $this->btn_oncertificado = $btn_oncertificado;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Configurações","Cadastro de Filial"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onBuscarCNPJ($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $dadoscnpj = CNPJService::get($param['cnpj']);

            if(!$dadoscnpj)
            {
                throw new Exception('CNPJ não encontrado!');
            }  

            $formData = new stdClass();
            $formData->name = $dadoscnpj->razao_social;
            $formData->razao_social = $dadoscnpj->razao_social;
            $formData->fone = $dadoscnpj->ddd_telefone_1;

            //incluindo o endereço....
            $formData->end_cep = $dadoscnpj->cep;
            $formData->end_logradouro = $dadoscnpj->logradouro ?? 'Logradouro';
            $formData->end_bairro = $dadoscnpj->bairro;
            $formData->end_numero = $dadoscnpj->numero;
            $formData->end_complemento = $dadoscnpj->complemento;
            $formData->end_uf = Estado::find($dadoscnpj->estado_id)->sigla;

            $cidade = Cidade::find($dadoscnpj->cidade_id);

            $formData->end_municipio = $cidade->nome;   
            $formData->end_mun_codibge = $cidade->codigo_ibge;

            TForm::sendData(self::$formName, $formData);       

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarTokenAPI($param = null) 
    {
        try 
        {
            $obj = new stdClass();
            $obj->token_api = Funcoes::geraToken(50);
            TForm::sendData(self::$formName, $obj);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCopiarToken($param = null) 
    {
        try 
        {
            TScript::create("textoCopiado = document.getElementById('edt_token_api');
                             textoCopiado.select();
                             textoCopiado.setSelectionRange(0, 99999);
                             document.execCommand('copy');"
                             );

         //   TScript::create("navigator.clipboard.readText(document.getElementById('edt_token_api'));");

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $data = $this->form->getData();

            $validator = new TCNPJValidator;
            $validator->validate('CNPJ', $data->cnpj);            

            $this->form->validate(); // validate form data

            $object = new SystemUnit(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $certificadoA1_dir = 'certificados';
            $logo_dir = 'app/files/kraft_arquivos/logo';  

            $object->store(); // save the object 

            $this->saveFile($object, $data, 'certificadoA1', $certificadoA1_dir);
            $this->saveFile($object, $data, 'logo', $logo_dir);
            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('FilialList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public static function onenviarNuvemFiscal($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            NuvemFiscal::CadastrarAtualizarEmpresa($param['id']);

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onCertificado($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            NuvemFiscal::VincularCertificado($param['id']);

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new SystemUnit($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->aliquota_pis    = '0,00';
        $object->aliquota_csll   = '0,00';
        $object->aliquota_irrf   = '0,00';
        $object->aliquota_iss    = '0,00';
        $object->aliquota_cofins = '0,00';
        $object->pc_credito_sn   = '0,00';  

        //TTransaction::open(self::$database);

 //       $empresa = Empresa::where('id', '>', 0)->first();
//        if($empresa){
//            $object->empresa_id = $empresa->id;    
//        }

        //TTransaction::close();

        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

