<?php

class HistoricoAtualizacoesSistema extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_HistoricoAtualizacoesSistema';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Histórico de Atualizações do sistema");


        $belement_historico = new BElement('div');


        $belement_historico->setSize('100%', 80);

        $this->belement_historico = $belement_historico;

        $html = '<h4>
                 Símbolo : Significado
                 <br>
                 [+]  : Novo recurso
                 <br>
                 [*]  : Recurso modificado/melhorado
                 <br>
                 [-]  : Correção 
                 <br>
                 -----------------------------------------------------------------------
                </h4>
                <ol>
                    <li>
                       Atualizações Versão 1.27 : 26/04/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido opção para estorno de nota fiscal de entrada.
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.29 : 24/04/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido recurso para envio de email da negociação no CRM.
                       <br>
                       [+] Incluido recurso para envio de email de orçamento de venda.
                       <br>
                       [+] Incluído relatório de guia de separação de venda com o endereço do estoque.
                       <br
                       [+] Incluído impressão de etique de envio dentro da venda. 
                    </li>       
                    <br>                 
                    <li>
                       Atualizações Versão 1.28 : 30/03/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido opção de importação de XML no módulo de compras.
                       <br>
                       [+] Incluído calendário de pagamentos.
                       <br>
                       [+] Incluído opção de sugestão de inclusão de item duplicado no orçamento e na venda.
                       <br>
                       [+] Incluído opção para não permitir venda sem estoque disponivel.
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.27 : 23/03/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Criado cadastros de certificadora e incluido na venda de certificado.
                       <br>
                       [*] Melhorado relatório de parceiro de venda de certificado.
                    </li>       
                    <br>                 
                    <li>
                       Atualizações Versão 1.26 : 19/03/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido novas opções para envio de notas fiscais para o exterior.
                    </li>       
                    <br>                 
                    <li>
                       Atualizações Versão 1.25 : 25/02/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluído tela de visualização de detalhes do produto com histórico de compras, vendas e indicadores.
                       <br>
                       [+] Incluído evento para alerta de estoque minimo.
                       <br>
                       [*] Incluído configuração para obrigar informar plano de contas e centro de custo no contas a pagar.
                       <br>
                       [+] Incluído no espelho financeiro do cliente o cadastro de limites de crédito.
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.24 : 23/02/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Reformulado módulo de CRM com varios novos recursos.
                       <br>
                       [*] Incluído atualização de custos de produto na entrada da nota.
                       <br>
                       [*] Incluído calculo de valor de venda pela margem dentro do cadastro do produto.
                       <br>
                       [*] Salvando o cpf e cnpj de cliente sem mascara no banco de dados.
                       <br>
                        [+] Incluído relatório de estoque de produtos.
                    </li>       
                    <br>                 
                    <li>
                       Atualizações Versão 1.23 : 20/02/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido recurso de contingência na nota fiscal modelo 55.
                       <br>
                       [*] Incluido recurso de baixa de titulos em bloco no contas a pagar e receber.
                       <br>
                       [+] Incluido recurso de anexo de documentos no contas a pagar e receber.
                       <br>
                       [*] Incluido novos campos para facilitar o parcelamento de titulos em bloco de contas a pagar e receber.
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.22 : 15/02/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido recurso de clonagem de produto e clonagem de ficha técnica de produto.
                    </li>       
                    <br>                   
                    <li>
                       Atualizações Versão 1.21 : 14/02/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [*] Incluido recurso de estorno de venda.
                       <br>
                       [*] Ajuste nos relatorios de certificação.
                       <br>
                       [*] Criado nova situação na emissão de certificados: aguardando aprovação 
                    </li>       
                    <br>                   
                    <li>
                       Atualizações Versão 1.20 : 20/01/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [*] Implementado novos campos no cadastro de produtos.
                       <br>
                       [+] Incluído cadastro de ficha técnica do produto visando módulo de produção futuro.
                    </li>       
                    <br>                   
                    <li>
                       Atualizações Versão 1.19 : 08/01/2023
                       <br>
                       [-] Diversas correções.
                       <br>
                       [*] implementado saldo no periodo na consulta de lançamentos em conta corrente.
                       <br>
                       [*] Incluido dois novos painels no dashboard financeiro: contas a pagar x contas a receber geral do mês. 
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.18 : 26/12/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [*] Implementado resumo de vendas e consulta das vendas e contas a receber na tela de espelho financeiro do cliente.
                       <br>
                       [*] Criado botões de atalho na consulta de contas a pagar e receber para visualizar vencidos e vencendo no dia. 
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.17 : 25/12/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [*] Adicionado opção para habilitar e desabilitar produtos.
                       <br>
                       [*] Criado opções de CFOP para fora do estado na natureza de operação.      
                       <br>
                       [*] Adicionado verificação de tabela de preço de cliente na venda.                       
                       <br>
                       [+] Criado tela para visualizar as vendas em Kanban     
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.16 : 20/12/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Adicionado relatório de notas fiscais.
                       <br>
                       [+] Adicionado relatório de notas fiscais de compra.                       
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.15 : 29/11/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Criado opção de CST de ICMS para não contribuinte na natureza de operação.
                       <br>
                       [+] Liberado módulo de nota fiscal de compra.
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.14 : 25/11/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                    </li>       
                    <br>                 
                    <li>
                       Atualizações Versão 1.13 : 20/11/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Finalizado módulo de MDF-e.
                       <br>
                       [+] Incluído exceções de natureza de operação para ICMS.
                       <br> 
                       [+] Incluído processo de histórico de cobrança para o contas a receber com relatório.
                       <br>                        
                    </li>       
                    <br>                 
                    <li>
                       Atualizações Versão 1.12 : 04/11/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido geração de parcelas dentro da venda para cada forma de pagamento.
                       <br>
                       [+] Incluido linha do tempo para situações de venda.
                       <br>                         
                    </li>       
                    <br>                  
                    <li>
                       Atualizações Versão 1.11 : 30/10/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Incluido campos de valor, estoque disponivel e estoque reservado na tela de consulta de produtos para venda.
                       <br>                       
                    </li>       
                    <br>                    
                    <li>
                       Atualizações Versão 1.10 : 23/10/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Criado consulta de produtos por cards, ideal para quem utiliza imagem nos produtos.
                       <br>
                    </li>       
                    <br>                    
                    <li>
                       Atualizações Versão 1.09 : 18/10/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Liberado módulo de contas a pagar e relatorios;
                       <br>       
                       [+] Liberado módulo de contas a receber e relatorios;
                       <br>                              
                       [+] Liberado módulo de contas a lançamentos em conta corrente;
                       <br>                              
                       [*] Criado novos indicadores no dashboard de vendas;
                       <br>                              
                       [+] Criado dashboard financeiro;
                       <br>                              
                       [+] Criado recurso para indicadores personalizados com painel de dashboard;
                       <br>                                                     
                       [+] Criado permissões especiais para eventos especificos;
                       <br>          
                       [+] Criado cadastro de metas de vendas;
                       <br>  
                       [+] Criado módulo de certificação digital;
                       <br>       
                       [+] Criado módulo de estoque (controle de depositos e lotes);
                       <br>          
                       [*] Alterado módulo de vendas para realizar controle de estoque;
                       <br>          
                    </li>       
                    <br>                 
                    <li>
                       Atualizações Versão 1.08 : 18/08/2022
                       <br>
                       [-] Diversas correções.
                       <br>
                       [+] Criado tela de espelho financeiro de cliente.
                       <br>       
                       [+] Alterado o layout do sistema para um mais moderno.
                       <br>       
                    </li>       
                    <br>          
                    <li>
                       Atualizações Versão 1.07 : 17/05/2022
                       <br>
                       [-] Correção na geração da carta de correção da NF-e que não estava salvando os dados ao confirmar.
                       <br>
                    </li>       
                    <br>      
                    <li>
                       Atualizações Versão 1.06 : 29/04/2022
                       <br>
                       [*] Ajustado tela de nfe para também incluir cliente por tela de busca (similar ao nfce).
                       <br>
                       [+] Implementado faturamento de vendas.
                       <br>
                       [-] Correções e ajustes diversos.
                       <br>
                    </li>       
                    <br>      
                    <li>
                       Atualizações Versão 1.05 : 21/04/2022
                       <br>
                       [-] Correção na edição de nota fiscal que as vezes voltava na tela errada (nfe e nfce).
                       <br>
                    </li>       
                    <br>     
                    <li>
                       Atualizações Versão 1.04 : 18/04/2022
                       <br>
                       [-] Correções diversas no modulo de nota fiscal.
                       <br>
                       [+] inclusão de módulo de nota fiscal de consumidor.
                       <br>
                       [+] Inclusão de módulo de vendas.
                       <br>
                       [+] Inclusão de módulo de caixa monitor.
                       <br>
                    </li>       
                    <br> 
                    <li>
                       Atualizações Versão 1.03 : 18/03/2022
                       <br>
                       [-] Correções diversas no modulo de nota fiscal.
                       <br>
                       [+] Incluido validações no cadastro de clientes para pessoa juridica.
                       <br>
                    </li>   
                    <br> 
                    <li>
                       Atualizações Versão 1.02 : 04/03/2022
                       <br>
                       [-] Correções diversas no modulo de nota fiscal.
                       <br>
                       [+] Incluido campos de pessoas autorizadas na nfe.
                       <br>
                       [+] Liberado modulo CRM.
                    </li>    
                    <br>      
                    <li>
                       Atualizações Versão 1.01 : 25/02/2022
                       <br>
                       [-] Correção de erro na nota fiscal.
                    </li>    
                    <br>          
                    <li>
                       Atualizações Versão 1.00 : 22/02/2022
                       <br>
                       [+] Criação de arquivo changelog.
                       <br>
                       [*] Melhorias na tela de consulta e cadastro da nfe.
                       <br>
                       [+] Adicionado opção de clonagem de nota.
                       <br>
                    </li>
                    <br>      
                </ol>';

        $belement_historico->add($html);

        $row1 = $this->form->addFields([$belement_historico]);
        $row1->layout = [' col-sm-12'];

        // create the form actions

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=HistoricoAtualizacoesSistema]');
        $style->width = '50% !important';   
        $style->show(true);

    }

    public function onShow($param = null)
    {               

    } 

}

