<?php

class IntegradoresForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Integradores';
    private static $primaryKey = 'id';
    private static $formName = 'form_IntegradoresForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de integradores");


        $id = new TEntry('id');
        $nome = new TEntry('nome');
        $criado_em = new TDateTime('criado_em');
        $alterado_por = new TEntry('alterado_por');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $integradores_servicos_integradores_descricao = new TEntry('integradores_servicos_integradores_descricao');
        $integradores_servicos_integradores_id = new THidden('integradores_servicos_integradores_id');
        $integradores_servicos_integradores_criado_em = new TDateTime('integradores_servicos_integradores_criado_em');
        $button_adicionar_integradores_servicos_integradores = new TButton('button_adicionar_integradores_servicos_integradores');

        $nome->addValidation("Nome", new TRequiredValidator()); 

        $id->setEditable(false);
        $button_adicionar_integradores_servicos_integradores->setAction(new TAction([$this, 'onAddDetailIntegradoresServicosIntegradores'],['static' => 1]), "Adicionar");
        $button_adicionar_integradores_servicos_integradores->addStyleClass('btn-default');
        $button_adicionar_integradores_servicos_integradores->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $integradores_servicos_integradores_criado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $integradores_servicos_integradores_criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setSize(100);
        $nome->setSize('100%');
        $criado_em->setSize(150);
        $alterado_em->setSize(150);
        $criado_por->setSize('100%');
        $alterado_por->setSize('100%');
        $integradores_servicos_integradores_id->setSize(200);
        $integradores_servicos_integradores_criado_em->setSize(150);
        $integradores_servicos_integradores_descricao->setSize('100%');

        $button_adicionar_integradores_servicos_integradores->id = '657c8466fdf7a';

        $this->form->appendPage("Aba 657c842bfdf72");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("Aba 657c842bfdf75");

        $this->detailFormIntegradoresServicosIntegradores = new BootstrapFormBuilder('detailFormIntegradoresServicosIntegradores');
        $this->detailFormIntegradoresServicosIntegradores->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormIntegradoresServicosIntegradores->setProperty('class', 'form-horizontal builder-detail-form');

        $row4 = $this->detailFormIntegradoresServicosIntegradores->addFields([new TFormSeparator("Detail", '#333', '18', '#eee')]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->detailFormIntegradoresServicosIntegradores->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$integradores_servicos_integradores_descricao,$integradores_servicos_integradores_id],[new TLabel("Criado Em:", null, '14px', null, '100%'),$integradores_servicos_integradores_criado_em]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->detailFormIntegradoresServicosIntegradores->addFields([$button_adicionar_integradores_servicos_integradores]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->detailFormIntegradoresServicosIntegradores->addFields([new THidden('integradores_servicos_integradores__row__id')]);
        $this->integradores_servicos_integradores_criteria = new TCriteria();

        $this->integradores_servicos_integradores_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->integradores_servicos_integradores_list->disableHtmlConversion();;
        $this->integradores_servicos_integradores_list->generateHiddenFields();
        $this->integradores_servicos_integradores_list->setId('integradores_servicos_integradores_list');

        $this->integradores_servicos_integradores_list->style = 'width:100%';
        $this->integradores_servicos_integradores_list->class .= ' table-bordered';

        $column_integradores_servicos_integradores_descricao = new TDataGridColumn('descricao', "Descrição", 'left');
        $column_integradores_servicos_integradores_criado_em = new TDataGridColumn('criado_em', "Criado Em", 'left');
        $column_integradores_servicos_integradores_alterado_por = new TDataGridColumn('alterado_por', "Alterado Por", 'left');
        $column_integradores_servicos_integradores_criado_por = new TDataGridColumn('criado_por', "Criado Por", 'left');
        $column_integradores_servicos_integradores_alterado_em = new TDataGridColumn('alterado_em', "Alterado Em", 'left');

        $column_integradores_servicos_integradores__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_integradores_servicos_integradores__row__data->setVisibility(false);

        $action_onEditDetailIntegradoresServicos = new TDataGridAction(array('IntegradoresForm', 'onEditDetailIntegradoresServicos'));
        $action_onEditDetailIntegradoresServicos->setUseButton(false);
        $action_onEditDetailIntegradoresServicos->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailIntegradoresServicos->setLabel("Editar");
        $action_onEditDetailIntegradoresServicos->setImage('far:edit #478fca');
        $action_onEditDetailIntegradoresServicos->setFields(['__row__id', '__row__data']);

        $this->integradores_servicos_integradores_list->addAction($action_onEditDetailIntegradoresServicos);
        $action_onDeleteDetailIntegradoresServicos = new TDataGridAction(array('IntegradoresForm', 'onDeleteDetailIntegradoresServicos'));
        $action_onDeleteDetailIntegradoresServicos->setUseButton(false);
        $action_onDeleteDetailIntegradoresServicos->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailIntegradoresServicos->setLabel("Excluir");
        $action_onDeleteDetailIntegradoresServicos->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailIntegradoresServicos->setFields(['__row__id', '__row__data']);

        $this->integradores_servicos_integradores_list->addAction($action_onDeleteDetailIntegradoresServicos);

        $this->integradores_servicos_integradores_list->addColumn($column_integradores_servicos_integradores_descricao);
        $this->integradores_servicos_integradores_list->addColumn($column_integradores_servicos_integradores_criado_em);
        $this->integradores_servicos_integradores_list->addColumn($column_integradores_servicos_integradores_alterado_por);
        $this->integradores_servicos_integradores_list->addColumn($column_integradores_servicos_integradores_criado_por);
        $this->integradores_servicos_integradores_list->addColumn($column_integradores_servicos_integradores_alterado_em);

        $this->integradores_servicos_integradores_list->addColumn($column_integradores_servicos_integradores__row__data);

        $this->integradores_servicos_integradores_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->integradores_servicos_integradores_list);
        $this->detailFormIntegradoresServicosIntegradores->addContent([$tableResponsiveDiv]);
        $row8 = $this->form->addFields([$this->detailFormIntegradoresServicosIntegradores]);
        $row8->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['IntegradoresList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

    }

    public  function onAddDetailIntegradoresServicosIntegradores($param = null) 
    {
        try
        {
            $data = $this->form->getData();

                $errors = [];
                $requiredFields = [];
                $requiredFields[] = ['label'=>"Descrição", 'name'=>"integradores_servicos_integradores_descricao", 'class'=>'TRequiredValidator', 'value'=>[]];
                foreach($requiredFields as $requiredField)
                {
                    try
                    {
                        (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                    }
                    catch(Exception $e)
                    {
                        $errors[] = $e->getMessage() . '.';
                    }
                 }
                 if(count($errors) > 0)
                 {
                     throw new Exception(implode('<br>', $errors));
                 }

                $__row__id = !empty($data->integradores_servicos_integradores__row__id) ? $data->integradores_servicos_integradores__row__id : 'b'.uniqid();

                TTransaction::open(self::$database);

                $grid_data = new IntegradoresServicos();
                $grid_data->__row__id = $__row__id;
                $grid_data->descricao = $data->integradores_servicos_integradores_descricao;
                $grid_data->id = $data->integradores_servicos_integradores_id;
                $grid_data->criado_em = $data->integradores_servicos_integradores_criado_em;

                $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
                $__row__data['__row__id'] = $__row__id;
                $__row__data['__display__']['descricao'] =  $param['integradores_servicos_integradores_descricao'] ?? null;
                $__row__data['__display__']['id'] =  $param['integradores_servicos_integradores_id'] ?? null;
                $__row__data['__display__']['criado_em'] =  $param['integradores_servicos_integradores_criado_em'] ?? null;

                $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
                $row = $this->integradores_servicos_integradores_list->addItem($grid_data);
                $row->id = $grid_data->__row__id;

                TDataGrid::replaceRowById('integradores_servicos_integradores_list', $grid_data->__row__id, $row);

                TTransaction::close();

                $data = new stdClass;
                $data->integradores_servicos_integradores_descricao = '';
                $data->integradores_servicos_integradores_id = '';
                $data->integradores_servicos_integradores_criado_em = '';
                $data->integradores_servicos_integradores__row__id = '';

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#657c8466fdf7a');
                   if(typeof element.attr('add') != 'undefined')
                   {
                       element.html(base64_decode(element.attr('add')));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailIntegradoresServicos($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));
                $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

                $data = new stdClass;
                $data->integradores_servicos_integradores_descricao = $__row__data->__display__->descricao ?? null;
                $data->integradores_servicos_integradores_id = $__row__data->__display__->id ?? null;
                $data->integradores_servicos_integradores_criado_em = $__row__data->__display__->criado_em ?? null;
                $data->integradores_servicos_integradores__row__id = $__row__data->__row__id;

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#657c8466fdf7a');
                   if(!element.attr('add')){
                       element.attr('add', base64_encode(element.html()));
                   }
                   element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
                   if(!element.attr('edit')){
                       element.attr('edit', base64_encode(element.html()));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onDeleteDetailIntegradoresServicos($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));

                $data = new stdClass;
                $data->integradores_servicos_integradores_descricao = '';
                $data->integradores_servicos_integradores_id = '';
                $data->integradores_servicos_integradores_criado_em = '';
                $data->integradores_servicos_integradores__row__id = '';

                TForm::sendData(self::$formName, $data);

                TDataGrid::removeRowById('integradores_servicos_integradores_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Integradores(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $integradores_servicos_integradores_items = $this->storeMasterDetailItems('IntegradoresServicos', 'integradores_id', 'integradores_servicos_integradores', $object, $param['integradores_servicos_integradores_list___row__data'] ?? [], $this->form, $this->integradores_servicos_integradores_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->integradores_servicos_integradores_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('IntegradoresList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();"); 
        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Integradores($key); // instantiates the Active Record 

                $integradores_servicos_integradores_items = $this->loadMasterDetailItems('IntegradoresServicos', 'integradores_id', 'integradores_servicos_integradores', $object, $this->form, $this->integradores_servicos_integradores_list, $this->integradores_servicos_integradores_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

