<?php

class PainelIndicadoresForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'PainelIndicadores';
    private static $primaryKey = 'id';
    private static $formName = 'form_PainelIndicadoresForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de painel de indicadores");


        $id = new TEntry('id');
        $descricao = new TEntry('descricao');
        $painel_indicador_usuario_painel_indicadores_indicador_personalizado_id = new TDBCombo('painel_indicador_usuario_painel_indicadores_indicador_personalizado_id', 'kraftsoft', 'IndicadorPersonalizado', 'id', '{descricao}','descricao asc'  );
        $painel_indicador_usuario_painel_indicadores_id = new THidden('painel_indicador_usuario_painel_indicadores_id');
        $painel_indicador_usuario_painel_indicadores_system_users_id = new TDBCombo('painel_indicador_usuario_painel_indicadores_system_users_id', 'kraftsoft', 'SystemUsers', 'id', '{name}','name asc'  );
        $button_adicionar_painel_indicador_usuario_painel_indicadores = new TButton('button_adicionar_painel_indicador_usuario_painel_indicadores');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $descricao->addValidation("Descrição", new TRequiredValidator()); 

        $button_adicionar_painel_indicador_usuario_painel_indicadores->setAction(new TAction([$this, 'onAddDetailPainelIndicadorUsuarioPainelIndicadores'],['static' => 1]), "Adicionar");
        $button_adicionar_painel_indicador_usuario_painel_indicadores->addStyleClass('btn-default');
        $button_adicionar_painel_indicador_usuario_painel_indicadores->setImage('fas:plus #2ecc71');
        $painel_indicador_usuario_painel_indicadores_system_users_id->enableSearch();
        $painel_indicador_usuario_painel_indicadores_indicador_personalizado_id->enableSearch();

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $painel_indicador_usuario_painel_indicadores_id->setSize(200);
        $painel_indicador_usuario_painel_indicadores_system_users_id->setSize('100%');
        $painel_indicador_usuario_painel_indicadores_indicador_personalizado_id->setSize('100%');

        $button_adicionar_painel_indicador_usuario_painel_indicadores->id = '633e1f85183d4';

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id]);
        $row1->layout = ['col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addContent([new TFormSeparator("Indicadores e usuários para este painel", '#333', '18', '#eee')]);

        $this->detailFormPainelIndicadorUsuarioPainelIndicadores = new BootstrapFormBuilder('detailFormPainelIndicadorUsuarioPainelIndicadores');
        $this->detailFormPainelIndicadorUsuarioPainelIndicadores->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormPainelIndicadorUsuarioPainelIndicadores->setProperty('class', 'form-horizontal builder-detail-form');

        $row4 = $this->detailFormPainelIndicadorUsuarioPainelIndicadores->addFields([new TLabel("Indicador personalizado:", '#ff0000', '14px', null, '100%'),$painel_indicador_usuario_painel_indicadores_indicador_personalizado_id,$painel_indicador_usuario_painel_indicadores_id],[new TLabel("Usuário:", '#ff0000', '14px', null, '100%'),$painel_indicador_usuario_painel_indicadores_system_users_id]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->detailFormPainelIndicadorUsuarioPainelIndicadores->addFields([$button_adicionar_painel_indicador_usuario_painel_indicadores]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->detailFormPainelIndicadorUsuarioPainelIndicadores->addFields([new THidden('painel_indicador_usuario_painel_indicadores__row__id')]);
        $this->painel_indicador_usuario_painel_indicadores_criteria = new TCriteria();

        $this->painel_indicador_usuario_painel_indicadores_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->painel_indicador_usuario_painel_indicadores_list->disableHtmlConversion();;
        $this->painel_indicador_usuario_painel_indicadores_list->generateHiddenFields();
        $this->painel_indicador_usuario_painel_indicadores_list->setId('painel_indicador_usuario_painel_indicadores_list');

        $this->painel_indicador_usuario_painel_indicadores_list->disableDefaultClick();
        $this->painel_indicador_usuario_painel_indicadores_list->style = 'width:100%';
        $this->painel_indicador_usuario_painel_indicadores_list->class .= ' table-bordered';

        $column_painel_indicador_usuario_painel_indicadores_indicador_personalizado_descricao = new TDataGridColumn('indicador_personalizado->descricao', "Indicador personalizado", 'left');
        $column_painel_indicador_usuario_painel_indicadores_system_users_name = new TDataGridColumn('system_users->name', "Usuário", 'left');

        $column_painel_indicador_usuario_painel_indicadores__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_painel_indicador_usuario_painel_indicadores__row__data->setVisibility(false);

        $action_onEditDetailPainelIndicadorUsuario = new TDataGridAction(array('PainelIndicadoresForm', 'onEditDetailPainelIndicadorUsuario'));
        $action_onEditDetailPainelIndicadorUsuario->setUseButton(false);
        $action_onEditDetailPainelIndicadorUsuario->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailPainelIndicadorUsuario->setLabel("Editar");
        $action_onEditDetailPainelIndicadorUsuario->setImage('far:edit #478fca');
        $action_onEditDetailPainelIndicadorUsuario->setFields(['__row__id', '__row__data']);

        $this->painel_indicador_usuario_painel_indicadores_list->addAction($action_onEditDetailPainelIndicadorUsuario);
        $action_onDeleteDetailPainelIndicadorUsuario = new TDataGridAction(array('PainelIndicadoresForm', 'onDeleteDetailPainelIndicadorUsuario'));
        $action_onDeleteDetailPainelIndicadorUsuario->setUseButton(false);
        $action_onDeleteDetailPainelIndicadorUsuario->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailPainelIndicadorUsuario->setLabel("Excluir");
        $action_onDeleteDetailPainelIndicadorUsuario->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailPainelIndicadorUsuario->setFields(['__row__id', '__row__data']);

        $this->painel_indicador_usuario_painel_indicadores_list->addAction($action_onDeleteDetailPainelIndicadorUsuario);

        $this->painel_indicador_usuario_painel_indicadores_list->addColumn($column_painel_indicador_usuario_painel_indicadores_indicador_personalizado_descricao);
        $this->painel_indicador_usuario_painel_indicadores_list->addColumn($column_painel_indicador_usuario_painel_indicadores_system_users_name);

        $this->painel_indicador_usuario_painel_indicadores_list->addColumn($column_painel_indicador_usuario_painel_indicadores__row__data);

        $this->painel_indicador_usuario_painel_indicadores_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->painel_indicador_usuario_painel_indicadores_list);
        $this->detailFormPainelIndicadorUsuarioPainelIndicadores->addContent([$tableResponsiveDiv]);
        $row7 = $this->form->addFields([$this->detailFormPainelIndicadorUsuarioPainelIndicadores]);
        $row7->layout = [' col-sm-12'];

        $bcontainer_633d582355a08 = new BContainer('bcontainer_633d582355a08');
        $this->bcontainer_633d582355a08 = $bcontainer_633d582355a08;

        $bcontainer_633d582355a08->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_633d582355a08->setBorderColor('#c0c0c0');

        $row8 = $bcontainer_633d582355a08->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row8->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row9 = $this->form->addFields([$bcontainer_633d582355a08]);
        $row9->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['PainelIndicadoresHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Configurações","Cadastro de painel de indicadores"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailPainelIndicadorUsuarioPainelIndicadores($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Indicador personalizado id", 'name'=>"painel_indicador_usuario_painel_indicadores_indicador_personalizado_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"System users id", 'name'=>"painel_indicador_usuario_painel_indicadores_system_users_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->painel_indicador_usuario_painel_indicadores__row__id) ? $data->painel_indicador_usuario_painel_indicadores__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new PainelIndicadorUsuario();
            $grid_data->__row__id = $__row__id;
            $grid_data->indicador_personalizado_id = $data->painel_indicador_usuario_painel_indicadores_indicador_personalizado_id;
            $grid_data->id = $data->painel_indicador_usuario_painel_indicadores_id;
            $grid_data->system_users_id = $data->painel_indicador_usuario_painel_indicadores_system_users_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['indicador_personalizado_id'] =  $param['painel_indicador_usuario_painel_indicadores_indicador_personalizado_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['painel_indicador_usuario_painel_indicadores_id'] ?? null;
            $__row__data['__display__']['system_users_id'] =  $param['painel_indicador_usuario_painel_indicadores_system_users_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->painel_indicador_usuario_painel_indicadores_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('painel_indicador_usuario_painel_indicadores_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->painel_indicador_usuario_painel_indicadores_indicador_personalizado_id = '';
            $data->painel_indicador_usuario_painel_indicadores_id = '';
            $data->painel_indicador_usuario_painel_indicadores_system_users_id = '';
            $data->painel_indicador_usuario_painel_indicadores__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#633e1f85183d4');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailPainelIndicadorUsuario($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->painel_indicador_usuario_painel_indicadores_indicador_personalizado_id = $__row__data->__display__->indicador_personalizado_id ?? null;
            $data->painel_indicador_usuario_painel_indicadores_id = $__row__data->__display__->id ?? null;
            $data->painel_indicador_usuario_painel_indicadores_system_users_id = $__row__data->__display__->system_users_id ?? null;
            $data->painel_indicador_usuario_painel_indicadores__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#633e1f85183d4');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailPainelIndicadorUsuario($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->painel_indicador_usuario_painel_indicadores_indicador_personalizado_id = '';
            $data->painel_indicador_usuario_painel_indicadores_id = '';
            $data->painel_indicador_usuario_painel_indicadores_system_users_id = '';
            $data->painel_indicador_usuario_painel_indicadores__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('painel_indicador_usuario_painel_indicadores_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new PainelIndicadores(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $painel_indicador_usuario_painel_indicadores_items = $this->storeMasterDetailItems('PainelIndicadorUsuario', 'painel_indicadores_id', 'painel_indicador_usuario_painel_indicadores', $object, $param['painel_indicador_usuario_painel_indicadores_list___row__data'] ?? [], $this->form, $this->painel_indicador_usuario_painel_indicadores_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->painel_indicador_usuario_painel_indicadores_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('PainelIndicadoresHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new PainelIndicadores($key); // instantiates the Active Record 

                $painel_indicador_usuario_painel_indicadores_items = $this->loadMasterDetailItems('PainelIndicadorUsuario', 'painel_indicadores_id', 'painel_indicador_usuario_painel_indicadores', $object, $this->form, $this->painel_indicador_usuario_painel_indicadores_list, $this->painel_indicador_usuario_painel_indicadores_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

