<?php

class PermissoesEspeciaisForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'SystemProgramPermissoes';
    private static $primaryKey = 'id';
    private static $formName = 'form_PermissoesEspeciaisForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de permissões especiais");


        $id = new TEntry('id');
        $system_program_id = new TDBCombo('system_program_id', 'kraftsoft', 'SystemProgram', 'id', '{name}','name asc'  );
        $descricao = new TEntry('descricao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $system_group_program_permissoes_system_program_permissoes_system_group_id = new TDBCombo('system_group_program_permissoes_system_program_permissoes_system_group_id', 'kraftsoft', 'SystemGroup', 'id', '{name}','name asc'  );
        $system_group_program_permissoes_system_program_permissoes_id = new THidden('system_group_program_permissoes_system_program_permissoes_id');
        $system_group_program_permissoes_system_program_permissoes_system_unit_id = new TDBCombo('system_group_program_permissoes_system_program_permissoes_system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $button_adicionar_system_group_program_permissoes_system_program_permissoes = new TButton('button_adicionar_system_group_program_permissoes_system_program_permissoes');
        $system_user_program_permissoes_system_program_permissoes_system_users_id = new TDBCombo('system_user_program_permissoes_system_program_permissoes_system_users_id', 'kraftsoft', 'SystemUsers', 'id', '{name}','name asc'  );
        $system_user_program_permissoes_system_program_permissoes_id = new THidden('system_user_program_permissoes_system_program_permissoes_id');
        $system_user_program_permissoes_system_program_permissoes_system_unit_id = new TDBCombo('system_user_program_permissoes_system_program_permissoes_system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $button_adicionar_system_user_program_permissoes_system_program_permissoes = new TButton('button_adicionar_system_user_program_permissoes_system_program_permissoes');

        $system_program_id->addValidation("System program", new TRequiredValidator()); 
        $descricao->addValidation("Descrição", new TRequiredValidator()); 

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $button_adicionar_system_user_program_permissoes_system_program_permissoes->setAction(new TAction([$this, 'onAddDetailSystemUserProgramPermissoesSystemProgramPermissoes'],['static' => 1]), "Adicionar");
        $button_adicionar_system_group_program_permissoes_system_program_permissoes->setAction(new TAction([$this, 'onAddDetailSystemGroupProgramPermissoesSystemProgramPermissoes'],['static' => 1]), "Adicionar");

        $button_adicionar_system_user_program_permissoes_system_program_permissoes->addStyleClass('btn-default');
        $button_adicionar_system_group_program_permissoes_system_program_permissoes->addStyleClass('btn-default');

        $button_adicionar_system_user_program_permissoes_system_program_permissoes->setImage('fas:plus #2ecc71');
        $button_adicionar_system_group_program_permissoes_system_program_permissoes->setImage('fas:plus #2ecc71');

        $system_program_id->enableSearch();
        $system_user_program_permissoes_system_program_permissoes_system_unit_id->enableSearch();
        $system_group_program_permissoes_system_program_permissoes_system_unit_id->enableSearch();
        $system_user_program_permissoes_system_program_permissoes_system_users_id->enableSearch();
        $system_group_program_permissoes_system_program_permissoes_system_group_id->enableSearch();

        $id->setEditable(false);
        $descricao->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $system_program_id->setEditable(false);

        $id->setSize(100);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $system_program_id->setSize('100%');
        $system_user_program_permissoes_system_program_permissoes_id->setSize(200);
        $system_group_program_permissoes_system_program_permissoes_id->setSize(200);
        $system_user_program_permissoes_system_program_permissoes_system_unit_id->setSize('100%');
        $system_group_program_permissoes_system_program_permissoes_system_unit_id->setSize('100%');
        $system_user_program_permissoes_system_program_permissoes_system_users_id->setSize('100%');
        $system_group_program_permissoes_system_program_permissoes_system_group_id->setSize('100%');

        $button_adicionar_system_user_program_permissoes_system_program_permissoes->id = '63433658bf95c';
        $button_adicionar_system_group_program_permissoes_system_program_permissoes->id = '6343359bbf953';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("System program (Tela):", '#ff0000', '14px', null, '100%'),$system_program_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição Permissão:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $bcontainer_63433373bf946 = new BContainer('bcontainer_63433373bf946');
        $this->bcontainer_63433373bf946 = $bcontainer_63433373bf946;

        $bcontainer_63433373bf946->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_63433373bf946->setBorderColor('#c0c0c0');

        $row3 = $bcontainer_63433373bf946->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row3->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row4 = $this->form->addFields([$bcontainer_63433373bf946]);
        $row4->layout = [' col-sm-12'];

        $this->form->appendPage("Grupos");

        $this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes = new BootstrapFormBuilder('detailFormSystemGroupProgramPermissoesSystemProgramPermissoes');
        $this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes->setProperty('class', 'form-horizontal builder-detail-form');

        $row5 = $this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes->addFields([new TLabel("Grupo de Usuário:", '#ff0000', '14px', null, '100%'),$system_group_program_permissoes_system_program_permissoes_system_group_id,$system_group_program_permissoes_system_program_permissoes_id],[new TLabel("Filial:", '#FF0000', '14px', null),$system_group_program_permissoes_system_program_permissoes_system_unit_id]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes->addFields([$button_adicionar_system_group_program_permissoes_system_program_permissoes]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes->addFields([new THidden('system_group_program_permissoes_system_program_permissoes__row__id')]);
        $this->system_group_program_permissoes_system_program_permissoes_criteria = new TCriteria();

        $this->system_group_program_permissoes_system_program_permissoes_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->system_group_program_permissoes_system_program_permissoes_list->disableHtmlConversion();;
        $this->system_group_program_permissoes_system_program_permissoes_list->generateHiddenFields();
        $this->system_group_program_permissoes_system_program_permissoes_list->setId('system_group_program_permissoes_system_program_permissoes_list');

        $this->system_group_program_permissoes_system_program_permissoes_list->style = 'width:100%';
        $this->system_group_program_permissoes_system_program_permissoes_list->class .= ' table-bordered';

        $column_system_group_program_permissoes_system_program_permissoes_system_group_name = new TDataGridColumn('system_group->name', "Grupo", 'left');
        $column_system_group_program_permissoes_system_program_permissoes_system_unit_name = new TDataGridColumn('system_unit->name', "Filial", 'left');

        $column_system_group_program_permissoes_system_program_permissoes__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_system_group_program_permissoes_system_program_permissoes__row__data->setVisibility(false);

        $action_onEditDetailSystemGroupProgramPermissoes = new TDataGridAction(array('PermissoesEspeciaisForm', 'onEditDetailSystemGroupProgramPermissoes'));
        $action_onEditDetailSystemGroupProgramPermissoes->setUseButton(false);
        $action_onEditDetailSystemGroupProgramPermissoes->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailSystemGroupProgramPermissoes->setLabel("Editar");
        $action_onEditDetailSystemGroupProgramPermissoes->setImage('far:edit #478fca');
        $action_onEditDetailSystemGroupProgramPermissoes->setFields(['__row__id', '__row__data']);

        $this->system_group_program_permissoes_system_program_permissoes_list->addAction($action_onEditDetailSystemGroupProgramPermissoes);
        $action_onDeleteDetailSystemGroupProgramPermissoes = new TDataGridAction(array('PermissoesEspeciaisForm', 'onDeleteDetailSystemGroupProgramPermissoes'));
        $action_onDeleteDetailSystemGroupProgramPermissoes->setUseButton(false);
        $action_onDeleteDetailSystemGroupProgramPermissoes->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailSystemGroupProgramPermissoes->setLabel("Excluir");
        $action_onDeleteDetailSystemGroupProgramPermissoes->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailSystemGroupProgramPermissoes->setFields(['__row__id', '__row__data']);

        $this->system_group_program_permissoes_system_program_permissoes_list->addAction($action_onDeleteDetailSystemGroupProgramPermissoes);

        $this->system_group_program_permissoes_system_program_permissoes_list->addColumn($column_system_group_program_permissoes_system_program_permissoes_system_group_name);
        $this->system_group_program_permissoes_system_program_permissoes_list->addColumn($column_system_group_program_permissoes_system_program_permissoes_system_unit_name);

        $this->system_group_program_permissoes_system_program_permissoes_list->addColumn($column_system_group_program_permissoes_system_program_permissoes__row__data);

        $this->system_group_program_permissoes_system_program_permissoes_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->system_group_program_permissoes_system_program_permissoes_list);
        $this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes->addContent([$tableResponsiveDiv]);
        $row8 = $this->form->addFields([$this->detailFormSystemGroupProgramPermissoesSystemProgramPermissoes]);
        $row8->layout = [' col-sm-12'];

        $this->form->appendPage("Usuários");

        $this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes = new BootstrapFormBuilder('detailFormSystemUserProgramPermissoesSystemProgramPermissoes');
        $this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes->setProperty('class', 'form-horizontal builder-detail-form');

        $row9 = $this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes->addFields([new TLabel("Usuário:", '#ff0000', '14px', null, '100%'),$system_user_program_permissoes_system_program_permissoes_system_users_id,$system_user_program_permissoes_system_program_permissoes_id],[new TLabel("Filial:", '#FF0000', '14px', null),$system_user_program_permissoes_system_program_permissoes_system_unit_id]);
        $row9->layout = ['col-sm-6','col-sm-6'];

        $row10 = $this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes->addFields([$button_adicionar_system_user_program_permissoes_system_program_permissoes]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes->addFields([new THidden('system_user_program_permissoes_system_program_permissoes__row__id')]);
        $this->system_user_program_permissoes_system_program_permissoes_criteria = new TCriteria();

        $this->system_user_program_permissoes_system_program_permissoes_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->system_user_program_permissoes_system_program_permissoes_list->disableHtmlConversion();;
        $this->system_user_program_permissoes_system_program_permissoes_list->generateHiddenFields();
        $this->system_user_program_permissoes_system_program_permissoes_list->setId('system_user_program_permissoes_system_program_permissoes_list');

        $this->system_user_program_permissoes_system_program_permissoes_list->style = 'width:100%';
        $this->system_user_program_permissoes_system_program_permissoes_list->class .= ' table-bordered';

        $column_system_user_program_permissoes_system_program_permissoes_system_users_name = new TDataGridColumn('system_users->name', "Usuário", 'left');
        $column_system_user_program_permissoes_system_program_permissoes_system_unit_name = new TDataGridColumn('system_unit->name', "Filial", 'left');

        $column_system_user_program_permissoes_system_program_permissoes__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_system_user_program_permissoes_system_program_permissoes__row__data->setVisibility(false);

        $action_onEditDetailSystemUserProgramPermissoes = new TDataGridAction(array('PermissoesEspeciaisForm', 'onEditDetailSystemUserProgramPermissoes'));
        $action_onEditDetailSystemUserProgramPermissoes->setUseButton(false);
        $action_onEditDetailSystemUserProgramPermissoes->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailSystemUserProgramPermissoes->setLabel("Editar");
        $action_onEditDetailSystemUserProgramPermissoes->setImage('far:edit #478fca');
        $action_onEditDetailSystemUserProgramPermissoes->setFields(['__row__id', '__row__data']);

        $this->system_user_program_permissoes_system_program_permissoes_list->addAction($action_onEditDetailSystemUserProgramPermissoes);
        $action_onDeleteDetailSystemUserProgramPermissoes = new TDataGridAction(array('PermissoesEspeciaisForm', 'onDeleteDetailSystemUserProgramPermissoes'));
        $action_onDeleteDetailSystemUserProgramPermissoes->setUseButton(false);
        $action_onDeleteDetailSystemUserProgramPermissoes->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailSystemUserProgramPermissoes->setLabel("Excluir");
        $action_onDeleteDetailSystemUserProgramPermissoes->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailSystemUserProgramPermissoes->setFields(['__row__id', '__row__data']);

        $this->system_user_program_permissoes_system_program_permissoes_list->addAction($action_onDeleteDetailSystemUserProgramPermissoes);

        $this->system_user_program_permissoes_system_program_permissoes_list->addColumn($column_system_user_program_permissoes_system_program_permissoes_system_users_name);
        $this->system_user_program_permissoes_system_program_permissoes_list->addColumn($column_system_user_program_permissoes_system_program_permissoes_system_unit_name);

        $this->system_user_program_permissoes_system_program_permissoes_list->addColumn($column_system_user_program_permissoes_system_program_permissoes__row__data);

        $this->system_user_program_permissoes_system_program_permissoes_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->system_user_program_permissoes_system_program_permissoes_list);
        $this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes->addContent([$tableResponsiveDiv]);
        $row12 = $this->form->addFields([$this->detailFormSystemUserProgramPermissoesSystemProgramPermissoes]);
        $row12->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['PermissoesEspeciaisList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Configurações","Cadastro de permissões especiais"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailSystemGroupProgramPermissoesSystemProgramPermissoes($param = null) 
    {
        try
        {
            $data = $this->form->getData();

                $errors = [];
                $requiredFields = [];
                $requiredFields[] = ['label'=>"Grupo de Usuário", 'name'=>"system_group_program_permissoes_system_program_permissoes_system_group_id", 'class'=>'TRequiredValidator', 'value'=>[]];
                $requiredFields[] = ['label'=>"Filial", 'name'=>"system_group_program_permissoes_system_program_permissoes_system_unit_id", 'class'=>'TRequiredValidator', 'value'=>[]];
                foreach($requiredFields as $requiredField)
                {
                    try
                    {
                        (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                    }
                    catch(Exception $e)
                    {
                        $errors[] = $e->getMessage() . '.';
                    }
                 }
                 if(count($errors) > 0)
                 {
                     throw new Exception(implode('<br>', $errors));
                 }

                $__row__id = !empty($data->system_group_program_permissoes_system_program_permissoes__row__id) ? $data->system_group_program_permissoes_system_program_permissoes__row__id : 'b'.uniqid();

                TTransaction::open(self::$database);

                $grid_data = new SystemGroupProgramPermissoes();
                $grid_data->__row__id = $__row__id;
                $grid_data->system_group_id = $data->system_group_program_permissoes_system_program_permissoes_system_group_id;
                $grid_data->id = $data->system_group_program_permissoes_system_program_permissoes_id;
                $grid_data->system_unit_id = $data->system_group_program_permissoes_system_program_permissoes_system_unit_id;

                $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
                $__row__data['__row__id'] = $__row__id;
                $__row__data['__display__']['system_group_id'] =  $param['system_group_program_permissoes_system_program_permissoes_system_group_id'] ?? null;
                $__row__data['__display__']['id'] =  $param['system_group_program_permissoes_system_program_permissoes_id'] ?? null;
                $__row__data['__display__']['system_unit_id'] =  $param['system_group_program_permissoes_system_program_permissoes_system_unit_id'] ?? null;

                $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
                $row = $this->system_group_program_permissoes_system_program_permissoes_list->addItem($grid_data);
                $row->id = $grid_data->__row__id;

                TDataGrid::replaceRowById('system_group_program_permissoes_system_program_permissoes_list', $grid_data->__row__id, $row);

                TTransaction::close();

                $data = new stdClass;
                $data->system_group_program_permissoes_system_program_permissoes_system_group_id = '';
                $data->system_group_program_permissoes_system_program_permissoes_id = '';
                $data->system_group_program_permissoes_system_program_permissoes_system_unit_id = '';
                $data->system_group_program_permissoes_system_program_permissoes__row__id = '';

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#6343359bbf953');
                   if(typeof element.attr('add') != 'undefined')
                   {
                       element.html(base64_decode(element.attr('add')));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailSystemUserProgramPermissoesSystemProgramPermissoes($param = null) 
    {
        try
        {
            $data = $this->form->getData();

                $errors = [];
                $requiredFields = [];
                $requiredFields[] = ['label'=>"Usuário", 'name'=>"system_user_program_permissoes_system_program_permissoes_system_users_id", 'class'=>'TRequiredValidator', 'value'=>[]];
                $requiredFields[] = ['label'=>"Filial", 'name'=>"system_user_program_permissoes_system_program_permissoes_system_unit_id", 'class'=>'TRequiredValidator', 'value'=>[]];
                foreach($requiredFields as $requiredField)
                {
                    try
                    {
                        (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                    }
                    catch(Exception $e)
                    {
                        $errors[] = $e->getMessage() . '.';
                    }
                 }
                 if(count($errors) > 0)
                 {
                     throw new Exception(implode('<br>', $errors));
                 }

                $__row__id = !empty($data->system_user_program_permissoes_system_program_permissoes__row__id) ? $data->system_user_program_permissoes_system_program_permissoes__row__id : 'b'.uniqid();

                TTransaction::open(self::$database);

                $grid_data = new SystemUserProgramPermissoes();
                $grid_data->__row__id = $__row__id;
                $grid_data->system_users_id = $data->system_user_program_permissoes_system_program_permissoes_system_users_id;
                $grid_data->id = $data->system_user_program_permissoes_system_program_permissoes_id;
                $grid_data->system_unit_id = $data->system_user_program_permissoes_system_program_permissoes_system_unit_id;

                $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
                $__row__data['__row__id'] = $__row__id;
                $__row__data['__display__']['system_users_id'] =  $param['system_user_program_permissoes_system_program_permissoes_system_users_id'] ?? null;
                $__row__data['__display__']['id'] =  $param['system_user_program_permissoes_system_program_permissoes_id'] ?? null;
                $__row__data['__display__']['system_unit_id'] =  $param['system_user_program_permissoes_system_program_permissoes_system_unit_id'] ?? null;

                $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
                $row = $this->system_user_program_permissoes_system_program_permissoes_list->addItem($grid_data);
                $row->id = $grid_data->__row__id;

                TDataGrid::replaceRowById('system_user_program_permissoes_system_program_permissoes_list', $grid_data->__row__id, $row);

                TTransaction::close();

                $data = new stdClass;
                $data->system_user_program_permissoes_system_program_permissoes_system_users_id = '';
                $data->system_user_program_permissoes_system_program_permissoes_id = '';
                $data->system_user_program_permissoes_system_program_permissoes_system_unit_id = '';
                $data->system_user_program_permissoes_system_program_permissoes__row__id = '';

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#63433658bf95c');
                   if(typeof element.attr('add') != 'undefined')
                   {
                       element.html(base64_decode(element.attr('add')));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailSystemGroupProgramPermissoes($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));
                $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

                $data = new stdClass;
                $data->system_group_program_permissoes_system_program_permissoes_system_group_id = $__row__data->__display__->system_group_id ?? null;
                $data->system_group_program_permissoes_system_program_permissoes_id = $__row__data->__display__->id ?? null;
                $data->system_group_program_permissoes_system_program_permissoes_system_unit_id = $__row__data->__display__->system_unit_id ?? null;
                $data->system_group_program_permissoes_system_program_permissoes__row__id = $__row__data->__row__id;

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#6343359bbf953');
                   if(!element.attr('add')){
                       element.attr('add', base64_encode(element.html()));
                   }
                   element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
                   if(!element.attr('edit')){
                       element.attr('edit', base64_encode(element.html()));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onDeleteDetailSystemGroupProgramPermissoes($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));

                $data = new stdClass;
                $data->system_group_program_permissoes_system_program_permissoes_system_group_id = '';
                $data->system_group_program_permissoes_system_program_permissoes_id = '';
                $data->system_group_program_permissoes_system_program_permissoes_system_unit_id = '';
                $data->system_group_program_permissoes_system_program_permissoes__row__id = '';

                TForm::sendData(self::$formName, $data);

                TDataGrid::removeRowById('system_group_program_permissoes_system_program_permissoes_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailSystemUserProgramPermissoes($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));
                $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

                $data = new stdClass;
                $data->system_user_program_permissoes_system_program_permissoes_system_users_id = $__row__data->__display__->system_users_id ?? null;
                $data->system_user_program_permissoes_system_program_permissoes_id = $__row__data->__display__->id ?? null;
                $data->system_user_program_permissoes_system_program_permissoes_system_unit_id = $__row__data->__display__->system_unit_id ?? null;
                $data->system_user_program_permissoes_system_program_permissoes__row__id = $__row__data->__row__id;

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#63433658bf95c');
                   if(!element.attr('add')){
                       element.attr('add', base64_encode(element.html()));
                   }
                   element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
                   if(!element.attr('edit')){
                       element.attr('edit', base64_encode(element.html()));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onDeleteDetailSystemUserProgramPermissoes($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));

                $data = new stdClass;
                $data->system_user_program_permissoes_system_program_permissoes_system_users_id = '';
                $data->system_user_program_permissoes_system_program_permissoes_id = '';
                $data->system_user_program_permissoes_system_program_permissoes_system_unit_id = '';
                $data->system_user_program_permissoes_system_program_permissoes__row__id = '';

                TForm::sendData(self::$formName, $data);

                TDataGrid::removeRowById('system_user_program_permissoes_system_program_permissoes_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new SystemProgramPermissoes(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $system_user_program_permissoes_system_program_permissoes_items = $this->storeMasterDetailItems('SystemUserProgramPermissoes', 'system_program_permissoes_id', 'system_user_program_permissoes_system_program_permissoes', $object, $param['system_user_program_permissoes_system_program_permissoes_list___row__data'] ?? [], $this->form, $this->system_user_program_permissoes_system_program_permissoes_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->system_user_program_permissoes_system_program_permissoes_criteria); 

            $system_group_program_permissoes_system_program_permissoes_items = $this->storeMasterDetailItems('SystemGroupProgramPermissoes', 'system_program_permissoes_id', 'system_group_program_permissoes_system_program_permissoes', $object, $param['system_group_program_permissoes_system_program_permissoes_list___row__data'] ?? [], $this->form, $this->system_group_program_permissoes_system_program_permissoes_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->system_group_program_permissoes_system_program_permissoes_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('PermissoesEspeciaisList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new SystemProgramPermissoes($key); // instantiates the Active Record 

                $system_user_program_permissoes_system_program_permissoes_items = $this->loadMasterDetailItems('SystemUserProgramPermissoes', 'system_program_permissoes_id', 'system_user_program_permissoes_system_program_permissoes', $object, $this->form, $this->system_user_program_permissoes_system_program_permissoes_list, $this->system_user_program_permissoes_system_program_permissoes_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $system_group_program_permissoes_system_program_permissoes_items = $this->loadMasterDetailItems('SystemGroupProgramPermissoes', 'system_program_permissoes_id', 'system_group_program_permissoes_system_program_permissoes', $object, $this->form, $this->system_group_program_permissoes_system_program_permissoes_list, $this->system_group_program_permissoes_system_program_permissoes_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

