<?php

class XmlContadorForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'XmlContador';
    private static $primaryKey = 'id';
    private static $formName = 'form_XmlContadorForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::setSize(0.35, null);
        parent::setTitle("Cadastro de XML Contabilidade");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de XML Contabilidade");


        $id = new TEntry('id');
        $system_user_id = new THidden('system_user_id');
        $system_unit_id = new THidden('system_unit_id');
        $data_solicitacao = new THidden('data_solicitacao');
        $created_at = new THidden('created_at');
        $data_inicio = new TDate('data_inicio');
        $data_fim = new TDate('data_fim');
        $info_registros = new TEntry('info_registros');

        $data_inicio->setExitAction(new TAction([$this,'OnbuscaInicio']));
        $data_fim->setExitAction(new TAction([$this,'OnBuscaDados']));

        $id->setEditable(false);
        $data_fim->setMask('dd/mm/yyyy');
        $data_inicio->setMask('dd/mm/yyyy');

        $data_fim->setDatabaseMask('yyyy-mm-dd');
        $data_inicio->setDatabaseMask('yyyy-mm-dd');

        $created_at->setValue(date('Y-m-d H:i:s'));
        $data_solicitacao->setValue(date('Y-m-d H:i'));
        $system_user_id->setValue(TSession::getValue("userid"));
        $system_unit_id->setValue(TSession::getValue("userunitid"));

        $id->setSize(100);
        $data_fim->setSize(110);
        $created_at->setSize(200);
        $data_inicio->setSize(110);
        $system_user_id->setSize(200);
        $system_unit_id->setSize(200);
        $data_solicitacao->setSize(200);
        $info_registros->setSize('100%');

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id,$system_user_id,$system_unit_id,$data_solicitacao,$created_at],[new TLabel(new TImage('fas:calendar-alt #FF9800')."Data inicio:", '#FF9800', '14px', 'B', '100%'),$data_inicio],[new TLabel(new TImage('fas:calendar-check #009688')."Data fim:", '#009688', '14px', 'B', '100%'),$data_fim],[new TLabel(new TImage('fas:info-circle #2196F3')."Informações da busca:", '#03A9F4', '14px', 'B'),$info_registros]);
        $row1->layout = ['col-sm-2','col-sm-3','col-sm-3',' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Enviar solitação de arquivo", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-success'); 

        $btn_onshow = $this->form->addAction("Fechar", new TAction(['XmlContadorList', 'onShow']), 'fas:door-open #F44336');
        $this->btn_onshow = $btn_onshow;

        parent::add($this->form);

    }

    public static function OnbuscaInicio($param = null) 
    {
        try 
        {
         $data1= explode('/',$param['data_inicio']);
        $data2= explode('/',$param['data_fim']);

    // Data válida, continue com a conversão e consulta
     $startDate =$data1[2].'-'.$data1[1].'-'.$data1[0]. ' 00:00:00'; // Data de início
     $endDate = $data2[2].'-'.$data2[1].'-'.$data2[0]. ' 23:59:59'; 

          TTransaction::open(self::$database);

        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', TSession::getValue("userunitid")));
        $criteria->add(new TFilter('data_emissao', '>=', $dataInicio));
        $criteria->add(new TFilter('data_emissao', '<=', $dataFim));
        $criteria->add(new TFilter('status', '!=',''));
        $subCriteria1 = new TCriteria;
        $subCriteria1->add(new TFilter('status', '=', 'Cancelado'));

        $subCriteria2 = new TCriteria;
        $subCriteria2->add(new TFilter('status', '=', 'Autorizado'));

        $criteria->add($subCriteria1, TExpression::OR_OPERATOR);
        $criteria->add($subCriteria2, TExpression::OR_OPERATOR);
        // Crie um objeto TRepository para a tabela Notafiscal
        $repository = new TRepository('Notafiscal');

    $Notas = $repository->load($criteria);

    TTransaction::close();

if( count($Notas)==0){

    $mensagem= "Não foram encontrados XML no período selecionado";

           $object = new stdClass();
        $object->info_registros = $mensagem;

        TForm::sendData(self::$formName, $object);
}else{
if( count($Notas)==1){

    $xml=' XML';
}else{

    $xml=' XMLs'; 
}
}

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function OnBuscaDados($param = null) 
    {
        try 
        {
        $data1= explode('/',$param['data_inicio']);
        $data2= explode('/',$param['data_fim']);

    // Data válida, continue com a conversão e consulta
     $startDate =$data1[2].'-'.$data1[1].'-'.$data1[0]. ' 00:00:00'; // Data de início
     $endDate = $data2[2].'-'.$data2[1].'-'.$data2[0]. ' 23:59:59'; 

     TTransaction::open(self::$database);

        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', TSession::getValue("userunitid")));
        $criteria->add(new TFilter('data_emissao', '>=', $dataInicio));
        $criteria->add(new TFilter('data_emissao', '<=', $dataFim));
        $criteria->add(new TFilter('status', '!=',''));
        $subCriteria1 = new TCriteria;
        $subCriteria1->add(new TFilter('status', '=', 'Cancelado'));

        $subCriteria2 = new TCriteria;
        $subCriteria2->add(new TFilter('status', '=', 'Autorizado'));

        $criteria->add($subCriteria1, TExpression::OR_OPERATOR);
        $criteria->add($subCriteria2, TExpression::OR_OPERATOR);
        // Crie um objeto TRepository para a tabela Notafiscal
        $repository = new TRepository('Notafiscal');

    $Notas = $repository->load($criteria);

    TTransaction::close();

if( count($Notas)==0){

    $mensagem= "Não foram encontrados XML no período selecionado";

           $object = new stdClass();
        $object->info_registros = $mensagem;

        TForm::sendData(self::$formName, $object);
}else{
if( count($Notas)==1){

    $xml=' XML';
}else{

    $xml=' XMLs'; 
}
    // echo "SQL Query: " . $criteria->dump() . "<br>";
    // echo "Results Count: " . count($Notas);

 $mensagem = "Foram localizados " .  count($Notas) ." ".$xml.   " no período selecionado de " . $param['data_inicio'] . " até " . $param['data_fim'];

        $object = new stdClass();
        $object->info_registros = $mensagem;

        TForm::sendData(self::$formName, $object);
}

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new XmlContador(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

                    $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
                  $send= new GerarArquivosContadorXML($data->id);
                    $send->create();

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('XmlContadorList', 'onShow', $loadPageParam); 

                TWindow::closeWindow(parent::getId()); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new XmlContador($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

