<?php

class BuscaAgendaGlobalAtividadeForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_BuscaAgendaGlobalAtividadeForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Agenda Global");


        $funil_id = new TDBCombo('funil_id', 'kraftsoft', 'Funil', 'id', '{descricao}','descricao asc'  );
        $funil_etapas_id = new TCombo('funil_etapas_id');
        $titulo = new TEntry('titulo');
        $contato = new TEntry('contato');
        $cliente_id = new TDBUniqueSearch('cliente_id', 'kraftsoft', 'Cliente', 'id', 'nome','nome asc'  );
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $data_abertura_inicial = new TDate('data_abertura_inicial');
        $data_abertura_final = new TDate('data_abertura_final');
        $negocio_tipo_atividade_id = new TDBCombo('negocio_tipo_atividade_id', 'kraftsoft', 'NegocioTipoAtividade', 'id', '{icone_formatado}  {descricao}','descricao asc'  );
        $button_buscar = new TButton('button_buscar');
        $calendario = new BPageContainer();

        $funil_id->setChangeAction(new TAction([$this,'onChangefunil_id']));

        $cliente_id->setMinLength(2);
        $cliente_id->setFilterColumns(["cpf_cnpj","razao_social","nome"]);
        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search #FFFFFF');
        $calendario->setId('b63f629d41cb97');
        $data_abertura_final->setDatabaseMask('yyyy-mm-dd');
        $data_abertura_inicial->setDatabaseMask('yyyy-mm-dd');

        $button_buscar->setAction(new TAction(['BuscaAgendaGlobalAtividadeForm', 'onShow']), "Buscar");
        $calendario->setAction(new TAction(['NegocioAtividadeGlobalCalendarFormView', 'onReload'], $param));

        $cliente_id->setMask('{nome}');
        $data_abertura_final->setMask('dd/mm/yyyy');
        $data_abertura_inicial->setMask('dd/mm/yyyy');

        $funil_id->enableSearch();
        $vendedor_id->enableSearch();
        $funil_etapas_id->enableSearch();
        $negocio_tipo_atividade_id->enableSearch();

        $titulo->setValue($param["titulo"] ?? "");
        $contato->setValue($param["contato"] ?? "");
        $funil_id->setValue($param["funil_id"] ?? "");
        $cliente_id->setValue($param["cliente_id"] ?? "");
        $vendedor_id->setValue($param["vendedor_id"] ?? "");
        $funil_etapas_id->setValue($param["funil_etapas_id"] ?? "");
        $data_abertura_final->setValue($param["data_abertura_final"] ?? "");
        $data_abertura_inicial->setValue($param["data_abertura_inicial"] ?? "");
        $negocio_tipo_atividade_id->setValue($param["negocio_tipo_atividade_id"] ?? "");

        $titulo->setSize('100%');
        $contato->setSize('100%');
        $funil_id->setSize('100%');
        $cliente_id->setSize('100%');
        $calendario->setSize('100%');
        $vendedor_id->setSize('100%');
        $funil_etapas_id->setSize('100%');
        $data_abertura_final->setSize('100%');
        $data_abertura_inicial->setSize('100%');
        $negocio_tipo_atividade_id->setSize('100%');

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $calendario->add($loadingContainer);

        $this->calendario = $calendario;

        $row1 = $this->form->addFields([new TLabel("Funil:", null, '14px', null, '100%'),$funil_id],[new TLabel("Etapa Funil:", null, '14px', null, '100%'),$funil_etapas_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Título:", null, '14px', null, '100%'),$titulo],[new TLabel("Contato:", null, '14px', null, '100%'),$contato]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Cliente:", null, '14px', null, '100%'),$cliente_id],[new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Data abertura inicial:", null, '14px', null, '100%'),$data_abertura_inicial],[new TLabel("Data abertura final:", null, '14px', null, '100%'),$data_abertura_final],[new TLabel("Tipo Atividade", null, '14px', null, '100%'),$negocio_tipo_atividade_id]);
        $row4->layout = [' col-sm-3',' col-sm-3',' col-sm-6'];

        $row5 = $this->form->addFields([$button_buscar],[],[]);
        $row5->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row6 = $this->form->addFields([$calendario]);
        $row6->layout = [' col-sm-12'];

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["CRM","Agenda Global"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onChangefunil_id($param)
    {
        try
        {

            if (isset($param['funil_id']) && $param['funil_id'])
            { 
                $criteria = TCriteria::create(['funil_id' => $param['funil_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'funil_etapas_id', 'kraftsoft', 'FunilEtapas', 'id', '{descricao}', 'descricao asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'funil_etapas_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public function onShow($param = null)
    {               

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->funil_id))
            {
                $value = $object->funil_id;

                $obj->funil_id = $value;
            }
            if(isset($object->funil_etapas_id))
            {
                $value = $object->funil_etapas_id;

                $obj->funil_etapas_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->funil_id))
            {
                $value = $object->funil_id;

                $obj->funil_id = $value;
            }
            if(isset($object->funil_etapas_id))
            {
                $value = $object->funil_etapas_id;

                $obj->funil_etapas_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

}

