<?php

class BuscaKanbanNegocioForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_BuscaKanbanNegocioForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Agenda Global");


        $funil_id = new TDBCombo('funil_id', 'kraftsoft', 'Funil', 'id', '{descricao}','descricao asc'  );
        $negocio_origem_id = new TDBCombo('negocio_origem_id', 'kraftsoft', 'NegocioOrigem', 'id', '{descricao}','descricao asc'  );
        $titulo = new TEntry('titulo');
        $contato = new TEntry('contato');
        $cliente_id = new TDBUniqueSearch('cliente_id', 'kraftsoft', 'Cliente', 'id', 'nome','nome asc'  );
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $data_abertura_inicial = new TDate('data_abertura_inicial');
        $data_abertura_final = new TDate('data_abertura_final');
        $arquivado = new TDBCombo('arquivado', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $button_buscar = new TButton('button_buscar');
        $kanban = new BPageContainer();


        $cliente_id->setMinLength(2);
        $cliente_id->setFilterColumns(["cpf_cnpj","razao_social","nome"]);
        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search #FFFFFF');
        $kanban->setId('b63f73c219ab16');
        $data_abertura_final->setDatabaseMask('yyyy-mm-dd');
        $data_abertura_inicial->setDatabaseMask('yyyy-mm-dd');

        $kanban->setAction(new TAction(['NegocioKanbanView', 'onShow'], $param));
        $button_buscar->setAction(new TAction(['BuscaKanbanNegocioForm', 'onShow']), "Buscar");

        $cliente_id->setMask('{nome}');
        $data_abertura_final->setMask('dd/mm/yyyy');
        $data_abertura_inicial->setMask('dd/mm/yyyy');

        $funil_id->enableSearch();
        $arquivado->enableSearch();
        $vendedor_id->enableSearch();
        $negocio_origem_id->enableSearch();

        $titulo->setValue($param["titulo"] ?? "");
        $contato->setValue($param["contato"] ?? "");
        $funil_id->setValue($param["funil_id"] ?? "");
        $arquivado->setValue($param["arquivado"] ?? "");
        $cliente_id->setValue($param["cliente_id"] ?? "");
        $vendedor_id->setValue($param["vendedor_id"] ?? "");
        $negocio_origem_id->setValue($param["negocio_origem_id"] ?? "");
        $data_abertura_final->setValue($param["data_abertura_final"] ?? "");
        $data_abertura_inicial->setValue($param["data_abertura_inicial"] ?? "");

        $titulo->setSize('100%');
        $kanban->setSize('100%');
        $contato->setSize('100%');
        $funil_id->setSize('100%');
        $arquivado->setSize('100%');
        $cliente_id->setSize('100%');
        $vendedor_id->setSize('100%');
        $negocio_origem_id->setSize('100%');
        $data_abertura_final->setSize('100%');
        $data_abertura_inicial->setSize('100%');

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $kanban->add($loadingContainer);

        $this->kanban = $kanban;

        $row1 = $this->form->addFields([new TLabel("Funil:", null, '14px', null, '100%'),$funil_id],[new TLabel("Origem:", null, '14px', null, '100%'),$negocio_origem_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Título:", null, '14px', null, '100%'),$titulo],[new TLabel("Contato:", null, '14px', null, '100%'),$contato]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Cliente:", null, '14px', null, '100%'),$cliente_id],[new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Data abertura inicial:", null, '14px', null, '100%'),$data_abertura_inicial],[new TLabel("Data abertura final:", null, '14px', null, '100%'),$data_abertura_final]);
        $row4->layout = [' col-sm-6',' col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Arquivado:", null, '14px', null),$arquivado],[]);
        $row5->layout = [' col-sm-6',' col-sm-6'];

        $row6 = $this->form->addFields([$button_buscar],[],[]);
        $row6->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row7 = $this->form->addFields([$kanban]);
        $row7->layout = [' col-sm-12'];

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["CRM","Kanban"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onShow($param = null)
    {               

    } 

}

