<?php

class FunilForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Funil';
    private static $primaryKey = 'id';
    private static $formName = 'form_FunilForm';

    use BuilderMasterDetailFieldListTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de funil");


        $id = new TEntry('id');
        $descricao = new TEntry('descricao');
        $funil_etapas_funil_id = new THidden('funil_etapas_funil_id[]');
        $funil_etapas_funil___row__id = new THidden('funil_etapas_funil___row__id[]');
        $funil_etapas_funil___row__data = new THidden('funil_etapas_funil___row__data[]');
        $funil_etapas_funil_descricao = new TEntry('funil_etapas_funil_descricao[]');
        $funil_etapas_funil_numero_etapa = new TEntry('funil_etapas_funil_numero_etapa[]');
        $funil_etapas_funil_cor_etapa = new TColor('funil_etapas_funil_cor_etapa[]');
        $funil_etapas_funil_cor_negocio = new TColor('funil_etapas_funil_cor_negocio[]');
        $funil_etapas_funil_kanban = new TCombo('funil_etapas_funil_kanban[]');
        $funil_etapas_funil_permite_edicao = new TCombo('funil_etapas_funil_permite_edicao[]');
        $funil_etapas_funil_permite_exclusao = new TCombo('funil_etapas_funil_permite_exclusao[]');
        $funil_etapas_funil_etapa_ganha = new TCombo('funil_etapas_funil_etapa_ganha[]');
        $funil_etapas_funil_etapa_perde = new TCombo('funil_etapas_funil_etapa_perde[]');
        $this->fieldList_62168a4a2d6d3 = new TFieldList();
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $this->fieldList_62168a4a2d6d3->addField(null, $funil_etapas_funil_id, []);
        $this->fieldList_62168a4a2d6d3->addField(null, $funil_etapas_funil___row__id, ['uniqid' => true]);
        $this->fieldList_62168a4a2d6d3->addField(null, $funil_etapas_funil___row__data, []);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Descrição", null, '14px', null), $funil_etapas_funil_descricao, ['width' => '25%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Número Etapa", null, '14px', null), $funil_etapas_funil_numero_etapa, ['width' => '5%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Cor Etapa", null, '14px', null), $funil_etapas_funil_cor_etapa, ['width' => '10%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Cor Negócio", null, '14px', null), $funil_etapas_funil_cor_negocio, ['width' => '10%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Kanban", null, '14px', null), $funil_etapas_funil_kanban, ['width' => '10%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Permite Edição", null, '14px', null), $funil_etapas_funil_permite_edicao, ['width' => '10%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Permite Exclusão", null, '14px', null), $funil_etapas_funil_permite_exclusao, ['width' => '10%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Etapa Ganha", null, '14px', null), $funil_etapas_funil_etapa_ganha, ['width' => '10%']);
        $this->fieldList_62168a4a2d6d3->addField(new TLabel("Etapa Perde", null, '14px', null), $funil_etapas_funil_etapa_perde, ['width' => '10%']);

        $this->fieldList_62168a4a2d6d3->width = '100%';
        $this->fieldList_62168a4a2d6d3->setFieldPrefix('funil_etapas_funil');
        $this->fieldList_62168a4a2d6d3->name = 'fieldList_62168a4a2d6d3';

        $this->criteria_fieldList_62168a4a2d6d3 = new TCriteria();
        $this->default_item_fieldList_62168a4a2d6d3 = new stdClass();

        $this->form->addField($funil_etapas_funil_id);
        $this->form->addField($funil_etapas_funil___row__id);
        $this->form->addField($funil_etapas_funil___row__data);
        $this->form->addField($funil_etapas_funil_descricao);
        $this->form->addField($funil_etapas_funil_numero_etapa);
        $this->form->addField($funil_etapas_funil_cor_etapa);
        $this->form->addField($funil_etapas_funil_cor_negocio);
        $this->form->addField($funil_etapas_funil_kanban);
        $this->form->addField($funil_etapas_funil_permite_edicao);
        $this->form->addField($funil_etapas_funil_permite_exclusao);
        $this->form->addField($funil_etapas_funil_etapa_ganha);
        $this->form->addField($funil_etapas_funil_etapa_perde);

        $this->fieldList_62168a4a2d6d3->setRemoveAction(null, 'fas:times #dd5a43', "Excluír");

        $funil_etapas_funil_descricao->addValidation("Descrição", new TRequiredListValidator()); 
        $funil_etapas_funil_numero_etapa->addValidation("Número Etapa", new TRequiredListValidator()); 

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $funil_etapas_funil_kanban->addItems(["S"=>"Sim","N"=>"Não"]);
        $funil_etapas_funil_etapa_ganha->addItems(["S"=>"Sim","N"=>"Não"]);
        $funil_etapas_funil_etapa_perde->addItems(["S"=>"Sim","N"=>"Não"]);
        $funil_etapas_funil_permite_edicao->addItems(["S"=>"Sim","N"=>"Não"]);
        $funil_etapas_funil_permite_exclusao->addItems(["S"=>"Sim","N"=>"Não"]);

        $funil_etapas_funil_kanban->enableSearch();
        $funil_etapas_funil_etapa_ganha->enableSearch();
        $funil_etapas_funil_etapa_perde->enableSearch();
        $funil_etapas_funil_permite_edicao->enableSearch();
        $funil_etapas_funil_permite_exclusao->enableSearch();

        $id->setSize(100);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $funil_etapas_funil_kanban->setSize('100%');
        $funil_etapas_funil_descricao->setSize('100%');
        $funil_etapas_funil_cor_etapa->setSize('100%');
        $funil_etapas_funil_cor_negocio->setSize('100%');
        $funil_etapas_funil_etapa_ganha->setSize('100%');
        $funil_etapas_funil_etapa_perde->setSize('100%');
        $funil_etapas_funil_numero_etapa->setSize('100%');
        $funil_etapas_funil_permite_edicao->setSize('100%');
        $funil_etapas_funil_permite_exclusao->setSize('100%');


        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", null, '14px', null),$descricao]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addContent([new TFormSeparator("Etapas", '#333', '18', '#eee')]);
        $row4 = $this->form->addFields([$this->fieldList_62168a4a2d6d3]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row6 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row6->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['FunilHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["CRM","Cadastro de funil"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Funil(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $funil_etapas_funil_items = $this->storeItems('FunilEtapas', 'funil_id', $object, $this->fieldList_62168a4a2d6d3, function($masterObject, $detailObject){ 

                //code here

            }, $this->criteria_fieldList_62168a4a2d6d3); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('FunilHeaderList', 'onShow', $loadPageParam); 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Funil($key); // instantiates the Active Record 

                $this->fieldList_62168a4a2d6d3_items = $this->loadItems('FunilEtapas', 'funil_id', $object, $this->fieldList_62168a4a2d6d3, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }, $this->criteria_fieldList_62168a4a2d6d3); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $this->fieldList_62168a4a2d6d3->addHeader();
        $this->fieldList_62168a4a2d6d3->addDetail($this->default_item_fieldList_62168a4a2d6d3);

        $this->fieldList_62168a4a2d6d3->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    }

    public function onShow($param = null)
    {
        $this->fieldList_62168a4a2d6d3->addHeader();
        $this->fieldList_62168a4a2d6d3->addDetail($this->default_item_fieldList_62168a4a2d6d3);

        $this->fieldList_62168a4a2d6d3->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

