<?php
/**
 * NegocioAtividadeGlobalCalendarForm Form
 * @author  <your name here>
 */
class NegocioAtividadeGlobalCalendarFormView extends TPage
{
    private $fc;

    /**
     * Page constructor
     */
    public function __construct($param = null)
    {
        parent::__construct();

        TSession::setValue(__CLASS__.'load_filter_negocio_tipo_atividade_id', null);
        TSession::setValue(__CLASS__.'load_filter_negocio_id', null);
        TSession::setValue(__CLASS__.'load_filter_negocio_id_1', null);
        TSession::setValue(__CLASS__.'load_filter_negocio_id_2', null);
        TSession::setValue(__CLASS__.'load_filter_negocio_id_3', null);
        TSession::setValue(__CLASS__.'load_filter_negocio_id_4', null);
        TSession::setValue(__CLASS__.'load_filter_negocio_id_5', null);
        TSession::setValue(__CLASS__.'load_filter_negocio_id_6', null);

        $this->fc = new TFullCalendar(date('Y-m-d'), 'month');
        $this->fc->enableDays([1,2,3,4,5]);
        $this->fc->setReloadAction(new TAction(array($this, 'getEvents'), $param));
        $this->fc->setDayClickAction(new TAction(array('NegocioAtividadeGlobalCalendarForm', 'onStartEdit')));
        $this->fc->setEventClickAction(new TAction(array('NegocioAtividadeGlobalCalendarForm', 'onEdit')));
        $this->fc->setEventUpdateAction(new TAction(array('NegocioAtividadeGlobalCalendarForm', 'onUpdateEvent')));
        $this->fc->setCurrentView('agendaWeek');
        $this->fc->setTimeRange('07:00', '19:00');
        $this->fc->enablePopover('Informações', " {descricao} <br>
 {observacao} ");
        $this->fc->setOption('slotTime', "00:30:00");
        $this->fc->setOption('slotDuration', "00:30:00");
        $this->fc->setOption('slotLabelInterval', 30);

        parent::add( $this->fc );
    }

    /**
     * Output events as an json
     */
    public static function getEvents($param=NULL)
    {
        $return = array();
        try
        {
            TTransaction::open('kraftsoft');

            $criteria = new TCriteria(); 

            $criteria->add(new TFilter('horario_inicial', '<=', substr($param['end'], 0, 10).' 23:59:59'));
            $criteria->add(new TFilter('horario_final', '>=', substr($param['start'], 0, 10).' 00:00:00'));

            if(!empty($param['clear_session_filters']))
            {
                TSession::setValue(__CLASS__.'load_filter_negocio_tipo_atividade_id', null);
                TSession::setValue(__CLASS__.'load_filter_negocio_id', null);
                TSession::setValue(__CLASS__.'load_filter_negocio_id_1', null);
                TSession::setValue(__CLASS__.'load_filter_negocio_id_2', null);
                TSession::setValue(__CLASS__.'load_filter_negocio_id_3', null);
                TSession::setValue(__CLASS__.'load_filter_negocio_id_4', null);
                TSession::setValue(__CLASS__.'load_filter_negocio_id_5', null);
                TSession::setValue(__CLASS__.'load_filter_negocio_id_6', null);
            }

            if(!empty($param["negocio_tipo_atividade_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_tipo_atividade_id', $param["negocio_tipo_atividade_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_tipo_atividade_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_tipo_atividade_id', '=', $filterVar)); 
            }
            if(!empty($param["funil_etapas_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_id', $param["funil_etapas_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_id');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_id', 'in', "(SELECT id FROM negocio WHERE funil_etapas_id = '{$filterVar}')")); 
            }
            if(!empty($param["titulo"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_id_1', $param["titulo"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_id_1');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_id', 'in', "(SELECT id FROM negocio WHERE titulo like '%{$filterVar}%')")); 
            }
            if(!empty($param["contato"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_id_2', $param["contato"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_id_2');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_id', 'in', "(SELECT id FROM negocio WHERE contato_nome like '%{$filterVar}%')")); 
            }
            if(!empty($param["cliente_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_id_3', $param["cliente_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_id_3');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_id', 'in', "(SELECT id FROM negocio WHERE cliente_id = '{$filterVar}')")); 
            }
            if(!empty($param["vendedor_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_id_4', $param["vendedor_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_id_4');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_id', 'in', "(SELECT id FROM negocio WHERE vendedor_id = '{$filterVar}')")); 
            }
            if(!empty($param["data_abertura_inicial"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_id_5', $param["data_abertura_inicial"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_id_5');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_id', 'in', "(SELECT id FROM negocio WHERE data_abertura >= '{$filterVar}')")); 
            }
            if(!empty($param["data_abertura_final"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_id_6', $param["data_abertura_final"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_id_6');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteria->add(new TFilter('negocio_id', 'in', "(SELECT id FROM negocio WHERE data_abertura <= '{$filterVar}')")); 
            }

            $events = NegocioAtividade::getObjects($criteria);

            if ($events)
            {
                foreach ($events as $event)
                {
                    $event_array = $event->toArray();
                    $event_array['start'] = str_replace( ' ', 'T', $event_array['horario_inicial']);
                    $event_array['end'] = str_replace( ' ', 'T', $event_array['horario_final']);
                    $event_array['id'] = $event->id;
                    $event_array['color'] = $event->render("{negocio_tipo_atividade->cor}");
                    $event_array['title'] = TFullCalendar::renderPopover($event->render("{negocio_tipo_atividade->icone_formatado}  {negocio_tipo_atividade->descricao}  ({negocio->contato_nome}) "), $event->render("Informações"), $event->render(" {descricao} <br>
 {observacao} "));

                    $return[] = $event_array;
                }
            }
            TTransaction::close();
            echo json_encode($return);
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    /**
     * Reconfigure the callendar
     */
    public function onReload($param = null)
    {
        if (isset($param['view']))
        {
            $this->fc->setCurrentView($param['view']);
        }

        if (isset($param['date']))
        {
            $this->fc->setCurrentDate($param['date']);
        }
    }

}

