<?php

class NegocioFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Negocio';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Negocio';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $negocio = new Negocio($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Negócio #{$param['key']}");

        $criteria_tdbarrowstep2 = new TCriteria();

        $filterVar = $negocio->funil_id;
        $criteria_tdbarrowstep2->add(new TFilter('funil_id', '=', $filterVar)); 

        TSession::setValue('negocio_id', $negocio->id);

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'FunilEtapas', 'id', '{descricao}','numero_etapa asc' , $criteria_tdbarrowstep2);
        $label2 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($negocio->id, '', '15px', '');
        $label4 = new TLabel("Origem", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($negocio->negocio_origem->descricao, '', '15px', '');
        $label6 = new TLabel("Data Abertura:", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay(TDate::convertToMask($negocio->data_abertura, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbdatafechamento = new TLabel("Data Fechamento:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay(TDate::convertToMask($negocio->data_fechamento, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbtitulo = new TLabel("Titulo:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($negocio->titulo, '', '15px', '');
        $lbfunil = new TLabel("Funil:", '', '15px', 'B', '100%');
        $txtfunildescricao = new TTextDisplay($negocio->funil_etapas->funil->descricao, '', '15px', '');
        $lbetapa = new TLabel("Etapa:", '', '15px', 'B', '100%');
        $txtetapacor = new TTextDisplay($negocio->etapa_cor, '', '15px', '');
        $lbarquivado = new TLabel("Arquivado:", '', '15px', 'B', '100%');
        $txtarquivado = new TTextDisplay($negocio->arquivado_cor, '', '15px', '');
        $lbnomecontato = new TLabel("Nome Contato:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay($negocio->contato_nome, '', '15px', '');
        $label20 = new TLabel("Fone Contato:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay($negocio->contato_fone, '', '15px', '');
        $lbemailcontato = new TLabel("E-mail contato:", '', '15px', 'B', '100%');
        $txtcontatoemail = new TTextDisplay($negocio->contato_email, '', '15px', '');
        $label16 = new TLabel("Data Fechamento Esperada:", '', '15px', 'B');
        $text21 = new TTextDisplay(TDate::convertToMask($negocio->data_fechamento_esperada, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label22 = new TLabel("Orcamento id:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay($negocio->orcamento_id, '', '15px', '');
        $label8 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay(number_format((double)$negocio->valor, '2', ',', '.'), '', '15px', '');
        $label18 = new TLabel("Arquivado:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay($negocio->fk_arquivado->descricao, '', '15px', '');
        $label24 = new TLabel("Cliente:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay($negocio->cliente->nome, '', '15px', '');
        $label26 = new TLabel("Vendedor:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay($negocio->vendedor->nome, '', '15px', '');
        $label36 = new TLabel("Motivo Perda:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay($negocio->negocio_motivo_perda->descricao, '', '15px', '');
        $label38 = new TLabel("Comentário Motivo Perda:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($negocio->comentarios_motivo_perda, '', '15px', '');
        $bpc_timeline = new BPageContainer();
        $bpc_atividades = new BPageContainer();
        $bpc_produtos = new BPageContainer();
        $bpc_notas = new BPageContainer();
        $bpc_arquivos = new BPageContainer();
        $label28 = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(TDateTime::convertToMask($negocio->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label30 = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($negocio->criado_por, '', '15px', '');
        $label32 = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(TDateTime::convertToMask($negocio->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label34 = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay($negocio->alterado_por, '', '15px', '');

        $tdbarrowstep2->setAction(new TAction([$this,'onChangeEtapa']));

        $tdbarrowstep2->setColorColumn('cor_etapa');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($negocio->funil_etapas_id);
        $bpc_notas->setSize('100%');
        $bpc_timeline->setSize('100%');
        $bpc_produtos->setSize('100%');
        $bpc_arquivos->setSize('100%');
        $bpc_atividades->setSize('100%');

        $bpc_timeline->setAction(new TAction(['NegocioTimeline', 'onShow'], ['negocio_id' => $negocio->id]));
        $bpc_notas->setAction(new TAction(['NegocioNotasHeaderList', 'onShow'], ['negocio_id' => $negocio->id]));
        $bpc_produtos->setAction(new TAction(['NegocioItensHeaderList', 'onShow'], ['negocio_id' => $negocio->id]));
        $bpc_arquivos->setAction(new TAction(['NegocioArquivosHeaderList', 'onShow'], ['negocio_id' => $negocio->id]));
        $bpc_atividades->setAction(new TAction(['NegocioAtividadeCalendarFormView', 'onReload'], ['negocio_id' => $negocio->id]));

        $bpc_notas->setId('b63f53204938fd');
        $bpc_produtos->setId('b63f4a2642192c');
        $bpc_arquivos->setId('b63f5345b53424');
        $bpc_atividades->setId('b63f53d4ad28d1');
        $bpc_timeline->setId('container_timeline');

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_timeline->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_atividades->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_produtos->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_notas->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_arquivos->add($loadingContainer);


        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$label2,$text1],[$label4,$text3],[$label6,$text7],[$lbdatafechamento,$text9]);
        $row2->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([$lbtitulo,$text5],[$lbfunil,$txtfunildescricao],[$lbetapa,$txtetapacor],[$lbarquivado,$txtarquivado]);
        $row3->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row4 = $this->form->addFields([$lbnomecontato,$text16],[$label20,$text17],[$lbemailcontato,$txtcontatoemail]);
        $row4->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row5 = $this->form->addFields([$label16,$text21],[$label22,$text25],[$label8,$text6],[$label18,$text19]);
        $row5->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row6 = $this->form->addFields([$label24,$text26],[$label26,$text22]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([$label36,$text10],[$label38,$text11]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);

        $tab_63f4a23f0e0d6 = new BootstrapFormBuilder('tab_63f4a23f0e0d6');
        $this->tab_63f4a23f0e0d6 = $tab_63f4a23f0e0d6;
        $tab_63f4a23f0e0d6->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63f4a23f0e0d6->appendPage("Atividades");

        $tab_63f4a23f0e0d6->addFields([new THidden('current_tab_tab_63f4a23f0e0d6')]);
        $tab_63f4a23f0e0d6->setTabFunction("$('[name=current_tab_tab_63f4a23f0e0d6]').val($(this).attr('data-current_page'));");

        $row9 = $tab_63f4a23f0e0d6->addFields([$bpc_atividades]);
        $row9->layout = [' col-sm-12'];

        $tab_63f4a23f0e0d6->appendPage("Produtos");
        $row10 = $tab_63f4a23f0e0d6->addFields([$bpc_produtos]);
        $row10->layout = [' col-sm-12'];

        $tab_63f4a23f0e0d6->appendPage("Notas");
        $row11 = $tab_63f4a23f0e0d6->addFields([$bpc_notas]);
        $row11->layout = [' col-sm-12'];

        $tab_63f4a23f0e0d6->appendPage("Arquivos");
        $row12 = $tab_63f4a23f0e0d6->addFields([$bpc_arquivos]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->form->addFields([$bpc_timeline],[$tab_63f4a23f0e0d6]);
        $row13->layout = [' col-sm-4',' col-sm-8'];

        $row14 = $this->form->addContent([new TFormSeparator("Histórico de Atualizações", '#333', '18', '#eee')]);
        $row15 = $this->form->addFields([$label28,$text12],[$label30,$text14],[$label32,$text15],[$label34,$text13]);
        $row15->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        if(!empty($param['current_tab_tab_63f4a23f0e0d6']))
        {
            $this->tab_63f4a23f0e0d6->setCurrentPage($param['current_tab_tab_63f4a23f0e0d6']);
        }

        $btnEditarAction = new TAction(['NegocioForm', 'onEdit'],['key'=>$negocio->id]);
        $btnEditarLabel = new TLabel("Editar");

        $btnEditar = $this->form->addHeaderAction($btnEditarLabel, $btnEditarAction, 'fas:edit #03A9F4'); 
        $btnEditarLabel->setFontSize('14px'); 
        $btnEditarLabel->setFontColor('#333'); 

        $btnNegocioEmailFormOnShowAction = new TAction(['NegocioEmailForm', 'onShow'],['negocio_id'=>$negocio->id]);
        $btnNegocioEmailFormOnShowLabel = new TLabel("Enviar E-mail");

        $btnNegocioEmailFormOnShow = $this->form->addHeaderAction($btnNegocioEmailFormOnShowLabel, $btnNegocioEmailFormOnShowAction, 'fas:envelope #E91E63'); 
        $btnNegocioEmailFormOnShowLabel->setFontSize('12px'); 
        $btnNegocioEmailFormOnShowLabel->setFontColor('#333'); 

        $btnGerarOrcamentoAction = new TAction([$this, 'onGerarOrcamento'],['key'=>$negocio->id]);
        $btnGerarOrcamentoLabel = new TLabel("Gerar Orçamento");

        $btnGerarOrcamento = $this->form->addHeaderAction($btnGerarOrcamentoLabel, $btnGerarOrcamentoAction, 'fas:money-bill #8BC34A'); 
        $btnGerarOrcamentoLabel->setFontSize('14px'); 
        $btnGerarOrcamentoLabel->setFontColor('#333'); 

        $btnArquivarAction = new TAction([$this, 'onArquivar'],['key'=>$negocio->id]);
        $btnArquivarLabel = new TLabel("Arquivar");

        $btnArquivar = $this->form->addHeaderAction($btnArquivarLabel, $btnArquivarAction, 'fas:file-archive #673AB7'); 
        $btnArquivarLabel->setFontSize('12px'); 
        $btnArquivarLabel->setFontColor('#333'); 

        $btnDesarquivarAction = new TAction([$this, 'onDesarquivar'],['key'=>$negocio->id]);
        $btnDesarquivarLabel = new TLabel("Desarquivar");

        $btnDesarquivar = $this->form->addHeaderAction($btnDesarquivarLabel, $btnDesarquivarAction, 'fas:file-alt #8BC34A'); 
        $btnDesarquivarLabel->setFontSize('12px'); 
        $btnDesarquivarLabel->setFontColor('#333'); 

        $btnExcluirAction = new TAction([$this, 'onExcluir'],['key'=>$negocio->id]);
        $btnExcluirLabel = new TLabel("Excluir");

        $btnExcluir = $this->form->addHeaderAction($btnExcluirLabel, $btnExcluirAction, 'fas:trash-alt #F44336'); 
        $btnExcluirLabel->setFontSize('14px'); 
        $btnExcluirLabel->setFontColor('#333'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        if (!NegocioService::PodeEditar($negocio->id))
        {
            // $btnEditar->disabled = 1; //se quiser só desabilitar o botão
            $btnEditar->style = 'display:none';
        }

        if (!NegocioService::PodeExcluir($negocio->id))
        {
            // $btnEditar->disabled = 1;
            $btnExcluir->style = 'display:none';
        }

        if ($negocio->orcamento_id>0)
        {
          $btnGerarOrcamento->style = 'display:none';  
          $btnExcluir->style = 'display:none';
        //   $btnEditar->style = 'display:none';
        }

        if ($negocio->arquivado==Resposta::Sim)
        {
          $btnArquivar->style = 'display:none';  
        }        
        else
        {
          $btnDesarquivar->style = 'display:none';              
        }

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=NegocioFormView]');
        $style->width = '100% !important';   
        $style->show(true);

    }

    public static function onChangeEtapa($param = null) 
    {
        try 
        {
            if(!empty($param['key']))
            {

                TTransaction::open(self::$database);

                $negocio = new Negocio(TSession::getValue('negocio_id'));
                $negocio->funil_etapas_id = $param['key'];
                $negocio->store();

                $negocioEtapaHistorico = new NegocioEtapasHistorico();
                $negocioEtapaHistorico->funil_etapas_id = $negocio->funil_etapas_id;
                $negocioEtapaHistorico->negocio_id = $negocio->id;

                Funcoes::SalvarUsuarioCadastro($negocioEtapaHistorico);

                $negocioEtapaHistorico->store();

                TTransaction::close();

                new TMessage('info', 'Etapa alterada com sucesso!', new TAction(['NegocioFormView', 'onShow'], ['key'=>$negocio->id]));

            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onGerarOrcamento($param = null) 
    {
        try 
        {
            new TQuestion("Deseja gerar orçamento?", new TAction([__CLASS__, 'onGerarOrcamentoYes'], $param), new TAction([__CLASS__, 'onGerarOrcamentoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onArquivar($param = null) 
    {
        try 
        {
            if(isset($param['arquivar']) && $param['arquivar'] == 1)
            {
                try
                {
                    $key = $param['key'];
                    TTransaction::open(self::$database);

                    $negocio = new Negocio($key, FALSE);

                    $negocio->arquivado = Resposta::Sim;
                    $negocio->store();

                    TTransaction::close();

                    // Código gerado pelo snippet: "Mensagem Toast"
                    TToast::show("success", "Negócio arquivado com sucesso!", "topRight", "fas fa-check");

                    TApplication::loadPage(__CLASS__, 'onShow', ['key' => $negocio->id]);

                }
                catch (Exception $e) // in case of exception
                {
                    // shows the exception error message
                    new TMessage('error', $e->getMessage());
                    // undo all pending operations
                    TTransaction::rollback();
                }
            }
            else
            {
                // define the delete action
                $action = new TAction(array($this, 'onArquivar'));
                $action->setParameters($param); // pass the key paramseter ahead
                $action->setParameter('arquivar', 1);
                // shows a dialog to the user
                new TQuestion('Deseja arquivar este negócio?', $action);   
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onDesarquivar($param = null) 
    {
        try 
        {
            if(isset($param['desarquivar']) && $param['desarquivar'] == 1)
            {
                try
                {
                    $key = $param['key'];
                    TTransaction::open(self::$database);

                    $negocio = new Negocio($key, FALSE);

                    $negocio->arquivado = Resposta::Nao;
                    $negocio->store();

                    TTransaction::close();

                    // Código gerado pelo snippet: "Mensagem Toast"
                    TToast::show("success", "Negócio desarquivado com sucesso!", "topRight", "fas fa-check");

                    TApplication::loadPage(__CLASS__, 'onShow', ['key' => $negocio->id]);

                }
                catch (Exception $e) // in case of exception
                {
                    // shows the exception error message
                    new TMessage('error', $e->getMessage());
                    // undo all pending operations
                    TTransaction::rollback();
                }
            }
            else
            {
                // define the delete action
                $action = new TAction(array($this, 'onDesarquivar'));
                $action->setParameters($param); // pass the key paramseter ahead
                $action->setParameter('desarquivar', 1);
                // shows a dialog to the user
                new TQuestion('Deseja desarquivar este negócio?', $action);   
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onExcluir($param = null) 
    {
        try 
        {
            if(isset($param['delete']) && $param['delete'] == 1)
            {
                try
                {
                    $key = TSession::getValue('negocio_id');
                    TTransaction::open(self::$database);

                    $object = new Negocio($key, FALSE);

                    $object->delete();

                    TTransaction::close();

                    new TMessage('info', 'Negociação excluída!', new TAction(['NegocioList', 'onShow']));
                }
                catch (Exception $e) // in case of exception
                {
                    // shows the exception error message
                    new TMessage('error', $e->getMessage());
                    // undo all pending operations
                    TTransaction::rollback();
                }
            }
            else
            {
                // define the delete action
                $action = new TAction(array('NegocioFormView', 'onExcluir'));
                $action->setParameters($param); // pass the key paramseter ahead
                $action->setParameter('delete', 1);
                // shows a dialog to the user
                new TQuestion('Você tem certeza que quer excluir?', $action);   
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public  function onGerarOrcamentoYes($param = null) 
    {
        try 
        {
            //code here
            TTransaction::open(self::$database);

            $negocio = Negocio::find($param['key']);

            if($negocio)
            {
                Negocio::GerarOrcamento($negocio);
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $negocio->id]);

            TToast::show('success', "Orçamento gerado com sucesso!", 'topRight', 'far:check-circle');
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onGerarOrcamentoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

