<?php

class NegocioKanbanView extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Negocio';
    private static $primaryKey = 'id';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        try
        {
            parent::__construct();

            $kanban = new TKanban;
            $kanban->setItemDatabase(self::$database);
            $kanban->enableTopScrollbar();

            $criteriaStage = new TCriteria();
            $criteriaItem = new TCriteria();

            $criteriaStage->setProperty('order', 'numero_etapa asc');
            $criteriaItem->setProperty('order', 'ordem asc');

            TSession::setValue(__CLASS__.'load_filter_funil_id', null);

            if(!empty($param["funil_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_funil_id', $param["funil_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_funil_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaStage->add(new TFilter('funil_id', '=', $filterVar)); 
            }

            $filterVar = "S";
            $criteriaStage->add(new TFilter('kanban', '=', $filterVar)); 

            TSession::setValue(__CLASS__.'load_filter_arquivado', null);
            TSession::setValue(__CLASS__.'load_filter_negocio_origem_id', null);
            TSession::setValue(__CLASS__.'load_filter_titulo', null);
            TSession::setValue(__CLASS__.'load_filter_contato_nome', null);
            TSession::setValue(__CLASS__.'load_filter_cliente_id', null);
            TSession::setValue(__CLASS__.'load_filter_vendedor_id', null);

            if(!empty($param["arquivado"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_arquivado', $param["arquivado"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_arquivado');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('arquivado', '=', $filterVar)); 
            }
            if(!empty($param["negocio_origem_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_negocio_origem_id', $param["negocio_origem_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_negocio_origem_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('negocio_origem_id', '=', $filterVar)); 
            }
            if(!empty($param["titulo"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_titulo', $param["titulo"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_titulo');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('titulo', 'like', "%{$filterVar}%")); 
            }
            if(!empty($param["contato"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_contato_nome', $param["contato"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_contato_nome');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('contato_nome', 'like', "%{$filterVar}%")); 
            }
            if(!empty($param["cliente_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_cliente_id', $param["cliente_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_cliente_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('cliente_id', '=', $filterVar)); 
            }
            if(!empty($param["vendedor_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_vendedor_id', $param["vendedor_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_vendedor_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('vendedor_id', '=', $filterVar)); 
            }

            $filterVar = Ativo::Ativo;
            $criteriaItem->add(new TFilter('ativo_id', '=', $filterVar)); 
            $filterVar = "N";
            $criteriaItem->add(new TFilter('funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_ganha = '{$filterVar}')")); 
            $filterVar = "N";
            $criteriaItem->add(new TFilter('funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_perde = '{$filterVar}')")); 

            TTransaction::open(self::$database);
            $stages = FunilEtapas::getObjects($criteriaStage);
            $items  = Negocio::getObjects($criteriaItem);

            if($stages)
            {
                foreach ($stages as $key => $stage)
                {

                    $kanban->addStage($stage->id, "{descricao}", $stage ,$stage->cor_etapa);

                    if ($stage->etapa_ganha=='S')
                    {
                        $criteria_negocios_finalizados = new TCriteria;
                        $criteria_negocios_finalizados->add(new TFilter('funil_etapas_id', '=', $stage->id));
                        $criteria_negocios_finalizados->setProperty('limit', 10);
                        $criteria_negocios_finalizados->setProperty('order', 'data_fechamento asc');

                        $negocios_finalizados = Negocio::getObjects($criteria_negocios_finalizados);
                        $items = array_merge($negocios_finalizados, $items);
                    }

                }    
            }

            if($items)
            {
                foreach ($items as $key => $item)
                {

                    $item->valor = call_user_func(function($value, $object, $row) 
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $item->valor, $item, null);

                    $item->data_abertura = call_user_func(function($value, $object, $row) 
                    {
                        if(!empty(trim($value)))
                        {
                            try
                            {
                                $date = new DateTime($value);
                                return $date->format('d/m/Y');
                            }
                            catch (Exception $e)
                            {
                                return $value;
                            }
                        }
                    }, $item->data_abertura, $item, null);

                    $kanban->addItem($item->id, $item->funil_etapas_id, "#{id} - {titulo} ", "<b>Data abertura:</b> {data_abertura}
<br>
<b>Data fechamento esperada:</b> {data_fechamento_esperada}
<br>
<b>Contato: </b>{contato_nome}
<br>
<b>Valor:</b>{valor} ", $item->funil_etapas->cor_negocio, $item);

                }    
            }

            $kanbanStageAction_NegociosArquivadosList_onShow = new TAction(['NegociosArquivadosList', 'onShow']);

            $kanban->addStageAction("Arquivados", $kanbanStageAction_NegociosArquivadosList_onShow, 'fas:file-archive #673AB7');

            $kanbanStageShortcut_NegocioForm_onShow = new TAction(['NegocioForm', 'onShow']);

            $kanban->addStageShortcut("Novo Negócio", $kanbanStageShortcut_NegocioForm_onShow, 'fas:money-bill #000000');

            $kanbanItemAction_NegocioFormView_onShow = new TAction(['NegocioFormView', 'onShow']);
            $kanbanItemAction_NegocioFormView_onShow->setParameter("id", "key");

            $kanban->addItemAction("Visualizar", $kanbanItemAction_NegocioFormView_onShow, 'fas:search-plus #2196F3');
            $kanbanItemAction_NegocioKanbanView_onDeleteNegocio = new TAction(['NegocioKanbanView', 'onDeleteNegocio']);

            $kanban->addItemAction("Apagar", $kanbanItemAction_NegocioKanbanView_onDeleteNegocio, 'fas:trash-alt #DD5A43','NegocioKanbanView::onExibirExcluir');
            $kanbanItemAction_NegocioKanbanView_onArquivarNegocio = new TAction(['NegocioKanbanView', 'onArquivarNegocio']);

            $kanban->addItemAction("Arquivar", $kanbanItemAction_NegocioKanbanView_onArquivarNegocio, 'fas:file-archive #673AB7','NegocioKanbanView::OnExibeBotaoAquivar');

            //$kanban->setTemplatePath('app/resources/card.html');

            $kanban->setItemDropAction(new TAction([__CLASS__, 'onUpdateItemDrop']));
            TTransaction::close();

            $container = new TVBox;

            $container->style = 'width: 100%';
            $container->class = 'form-container';
            if(empty($param['target_container']))
            {
                $container->add(TBreadCrumb::create(["CRM","Negócios"]));
            }
            $container->add($kanban);

            parent::add($container);
        }
        catch(Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onDeleteNegocio($param = null) 
    {
        try 
        {
            if(isset($param['delete']) && $param['delete'] == 1)
            {
                try
                {
                    $key = $param['key'];
                    TTransaction::open(self::$database);

                    $object = new Negocio($key, FALSE);

                    $object->delete();

                    // $object->ativo_id = Ativo::Inativo;
                    // $object->store();

                    TTransaction::close();

                    // Código gerado pelo snippet: "Mensagem Toast"
                    TToast::show("success", "Negócio excluído com sucesso!", "topRight", "fas fa-check");

                    TScript::create("$(\"div[item_id='{$key}']\").remove();");
                }
                catch (Exception $e) // in case of exception
                {
                    // shows the exception error message
                    new TMessage('error', $e->getMessage());
                    // undo all pending operations
                    TTransaction::rollback();
                }
            }
            else
            {
                // define the delete action
                $action = new TAction(array($this, 'onDeleteNegocio'));
                $action->setParameters($param); // pass the key paramseter ahead
                $action->setParameter('delete', 1);
                // shows a dialog to the user
                new TQuestion(AdiantiCoreTranslator::translate('Do you really want to delete ?'), $action);   
            }
            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onExibirExcluir($object)
    {
        try 
        {
            // if($object)
            // {
            //     return true;
            // }

            return false;
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onArquivarNegocio($param = null) 
    {
        try 
        {
            if(isset($param['arquivar']) && $param['arquivar'] == 1)
            {
                try
                {
                    $key = $param['key'];
                    TTransaction::open(self::$database);

                    $object = new Negocio($key, FALSE);

                    $object->arquivado = Resposta::Sim;
                    $object->store();

                    TTransaction::close();

                    // Código gerado pelo snippet: "Mensagem Toast"
                    TToast::show("success", "Negócio arquivado com sucesso!", "topRight", "fas fa-check");

                    TScript::create("$(\"div[item_id='{$key}']\").remove();");
                }
                catch (Exception $e) // in case of exception
                {
                    // shows the exception error message
                    new TMessage('error', $e->getMessage());
                    // undo all pending operations
                    TTransaction::rollback();
                }
            }
            else
            {
                // define the delete action
                $action = new TAction(array($this, 'onArquivarNegocio'));
                $action->setParameters($param); // pass the key paramseter ahead
                $action->setParameter('arquivar', 1);
                // shows a dialog to the user
                new TQuestion('Deseja arquivar este negócio?', $action);   
            }
            //</autoCode>
            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function OnExibeBotaoAquivar($object)
    {
        try 
        {
            //return true;

            // $funil_etapa = FunilEtapas::Find($object->funil_etapas_id);

            // if($funil_etapa->ultima_etapa==Resposta::Sim)
            // {
            //     return true;
            // }
            // else
            // {
                return false;
            // }
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    /**
     * Update item on drop
     */
    public static function onUpdateItemDrop($param)
    {
        try
        {
            TTransaction::open(self::$database);

            if (!empty($param['order']))
            {
                foreach ($param['order'] as $key => $id)
                {
                    $sequence = ++$key;

                    $item = new Negocio($id);
                    $item->ordem = $sequence;
                    $item->funil_etapas_id = $param['stage_id'];

                    $item->store();

                    if($id == $param['key'])
                    {
                        TScript::create("$(\"div[item_id='{$param['key']}']\").css('border-top', '3px solid {$item->funil_etapas->cor_negocio}');");
                    }

                    //se for etapa final, preencher a data de fechamento, se não for limpar o campo...
                    $funil_etapa = FunilEtapas::Find($item->funil_etapas_id);

                    if($funil_etapa->etapa_ganha=='S')
                    {
                        $item->data_fechamento = date('d/m/y');
                    }  
                    else
                    {
                        $item->data_fechamento = null;
                    }

                    $item->store();

                    //historico..                    
                    $negocioEtapaHistorico = new NegocioEtapasHistorico();
                    $negocioEtapaHistorico->funil_etapas_id = $item->funil_etapas_id;
                    $negocioEtapaHistorico->negocio_id = $item->id;

                    Funcoes::SalvarUsuarioCadastro($negocioEtapaHistorico);

                    $negocioEtapaHistorico->store();

                }

                TTransaction::close();
            }
        }
        catch (Exception $e)
        {
            TTransaction::rollback();
            new TMessage('error', $e->getMessage());
        }
    }
    public function onShow($param = null)
    {

    } 

}

