<?php

class DashboardCRM extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_DashboardCRM';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Dashboard CRM");

        $criteria_qtde_neg_ganhos = new TCriteria();
        $criteria_vlr_neg_ganhos = new TCriteria();
        $criteria_ind_qtde_total_neg_ativos = new TCriteria();
        $criteria_ind_vlr_total_neg_ativos = new TCriteria();
        $criteria_ind_qtde_total_neg_perdidos = new TCriteria();
        $criteria_ind_vlr_total_neg_perdidos = new TCriteria();
        $criteria_bbar_neg_etapa = new TCriteria();
        $criteria_qtde_neg_etapa = new TCriteria();
        $criteria_qtde_origem = new TCriteria();
        $criteria_motivos_neg_perdidos = new TCriteria();

        $filterVar = Ativo::Ativo;
        $criteria_qtde_neg_ganhos->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = "S";
        $criteria_qtde_neg_ganhos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_ganha = '{$filterVar}')")); 
        $filterVar = Ativo::Ativo;
        $criteria_vlr_neg_ganhos->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = "S";
        $criteria_vlr_neg_ganhos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_ganha = '{$filterVar}')")); 
        $filterVar = Resposta::Nao;
        $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.arquivado', '=', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = "N";
        $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_ganha = '{$filterVar}')")); 
        $filterVar = "N";
        $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_perde = '{$filterVar}')")); 
        $filterVar = "N";
        $criteria_ind_vlr_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_ganha = '{$filterVar}')")); 
        $filterVar = "N";
        $criteria_ind_vlr_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_perde = '{$filterVar}')")); 
        $filterVar = "S";
        $criteria_ind_qtde_total_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_perde = '{$filterVar}')")); 
        $filterVar = Ativo::Ativo;
        $criteria_ind_qtde_total_neg_perdidos->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = "S";
        $criteria_ind_vlr_total_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE etapa_perde = '{$filterVar}')")); 
        $filterVar = Ativo::Ativo;
        $criteria_ind_vlr_total_neg_perdidos->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_bbar_neg_etapa->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_qtde_neg_etapa->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_qtde_origem->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_motivos_neg_perdidos->add(new TFilter('negocio.ativo_id', '=', $filterVar)); 

        $data_inicial = new TDate('data_inicial');
        $data_final = new TDate('data_final');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $funil_id = new TDBCombo('funil_id', 'kraftsoft', 'VwFunilFilial', 'id', '{descricao}','id asc'  );
        $funil_etapa_id = new TDBCombo('funil_etapa_id', 'kraftsoft', 'FunilEtapas', 'id', '{descricao}','descricao asc'  );
        $button_buscar = new TButton('button_buscar');
        $qtde_neg_ganhos = new BIndicator('qtde_neg_ganhos');
        $vlr_neg_ganhos = new BIndicator('vlr_neg_ganhos');
        $ind_qtde_total_neg_ativos = new BIndicator('ind_qtde_total_neg_ativos');
        $ind_vlr_total_neg_ativos = new BIndicator('ind_vlr_total_neg_ativos');
        $ind_qtde_total_neg_perdidos = new BIndicator('ind_qtde_total_neg_perdidos');
        $ind_vlr_total_neg_perdidos = new BIndicator('ind_vlr_total_neg_perdidos');
        $bbar_neg_etapa = new BBarChart('bbar_neg_etapa');
        $qtde_neg_etapa = new BPieChart('qtde_neg_etapa');
        $qtde_origem = new BBarChart('qtde_origem');
        $motivos_neg_perdidos = new BBarChart('motivos_neg_perdidos');

        $system_unit_id->setChangeAction(new TAction([$this,'OnChangeFilial']));
        $funil_id->setChangeAction(new TAction([$this,'OnChangeFunil']));

        $system_unit_id->addValidation("Filial", new TRequiredValidator()); 
        $funil_id->addValidation("Funil", new TRequiredValidator()); 

        $button_buscar->setAction(new TAction(['DashboardCRM', 'onShow']), "Buscar");
        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search #FFFFFF');
        $data_final->setMask('dd/mm/yyyy');
        $data_inicial->setMask('dd/mm/yyyy');

        $data_final->setDatabaseMask('yyyy-mm-dd');
        $data_inicial->setDatabaseMask('yyyy-mm-dd');

        $funil_id->setDefaultOption(false);
        $system_unit_id->setDefaultOption(false);

        $funil_id->setSize('100%');
        $data_final->setSize('100%');
        $data_inicial->setSize('100%');
        $system_unit_id->setSize('100%');
        $funil_etapa_id->setSize('100%');

        $funil_id->setValue($param["funil_id"] ?? "");
        $data_final->setValue($param["data_final"] ?? "");
        $data_inicial->setValue($param["data_inicial"] ?? "");
        $system_unit_id->setValue($param["system_unit_id"] ?? "");
        $funil_etapa_id->setValue($param["funil_etapa_id"] ?? "");

        $qtde_neg_ganhos->setDatabase('kraftsoft');
        $qtde_neg_ganhos->setFieldValue("negocio.id");
        $qtde_neg_ganhos->setModel('Negocio');
        $qtde_neg_ganhos->setTotal('count');
        $qtde_neg_ganhos->setColors('#009688', '#ffffff', '#009688', '#ffffff');
        $qtde_neg_ganhos->setTitle("Quantidade de Negócios Ganhos", '#ffffff', '20', '');
        $qtde_neg_ganhos->setCriteria($criteria_qtde_neg_ganhos);
        $qtde_neg_ganhos->setIcon(new TImage('fas:bookmark #ffffff'));
        $qtde_neg_ganhos->setValueSize("20");
        $qtde_neg_ganhos->setValueColor("#ffffff", 'B');
        $qtde_neg_ganhos->setSize('100%', 95);
        $qtde_neg_ganhos->setLayout('horizontal', 'left');

        $vlr_neg_ganhos->setDatabase('kraftsoft');
        $vlr_neg_ganhos->setFieldValue("negocio.valor");
        $vlr_neg_ganhos->setModel('Negocio');
        $vlr_neg_ganhos->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $vlr_neg_ganhos->setTotal('sum');
        $vlr_neg_ganhos->setColors('#03A9F4', '#ffffff', '#03A9F4', '#ffffff');
        $vlr_neg_ganhos->setTitle("Total de  negócios ganhos", '#ffffff', '20', '');
        $vlr_neg_ganhos->setCriteria($criteria_vlr_neg_ganhos);
        $vlr_neg_ganhos->setIcon(new TImage('fas:money-bill #ffffff'));
        $vlr_neg_ganhos->setValueSize("20");
        $vlr_neg_ganhos->setValueColor("#ffffff", 'B');
        $vlr_neg_ganhos->setSize('100%', 95);
        $vlr_neg_ganhos->setLayout('horizontal', 'left');

        $ind_qtde_total_neg_ativos->setDatabase('kraftsoft');
        $ind_qtde_total_neg_ativos->setFieldValue("negocio.id");
        $ind_qtde_total_neg_ativos->setModel('Negocio');
        $ind_qtde_total_neg_ativos->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $ind_qtde_total_neg_ativos->setTotal('count');
        $ind_qtde_total_neg_ativos->setColors('#FFC107', '#ffffff', '#FFC107', '#ffffff');
        $ind_qtde_total_neg_ativos->setTitle("Negócios Ativos", '#ffffff', '15', '');
        $ind_qtde_total_neg_ativos->setCriteria($criteria_ind_qtde_total_neg_ativos);
        $ind_qtde_total_neg_ativos->setIcon(new TImage('fas:shopping-basket #ffffff'));
        $ind_qtde_total_neg_ativos->setValueSize("25");
        $ind_qtde_total_neg_ativos->setValueColor("#ffffff", 'B');
        $ind_qtde_total_neg_ativos->setSize('100%', 95);
        $ind_qtde_total_neg_ativos->setLayout('horizontal', 'left');

        $ind_vlr_total_neg_ativos->setDatabase('kraftsoft');
        $ind_vlr_total_neg_ativos->setFieldValue("negocio.valor");
        $ind_vlr_total_neg_ativos->setModel('Negocio');
        $ind_vlr_total_neg_ativos->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $ind_vlr_total_neg_ativos->setTotal('sum');
        $ind_vlr_total_neg_ativos->setColors('#8BC34A', '#ffffff', '#8BC34A', '#ffffff');
        $ind_vlr_total_neg_ativos->setTitle("Val. Negociados Ativos", '#ffffff', '15', '');
        $ind_vlr_total_neg_ativos->setCriteria($criteria_ind_vlr_total_neg_ativos);
        $ind_vlr_total_neg_ativos->setIcon(new TImage('fas:money-bill-wave #ffffff'));
        $ind_vlr_total_neg_ativos->setValueSize("25");
        $ind_vlr_total_neg_ativos->setValueColor("#ffffff", 'B');
        $ind_vlr_total_neg_ativos->setSize('100%', 95);
        $ind_vlr_total_neg_ativos->setLayout('horizontal', 'left');

        $ind_qtde_total_neg_perdidos->setDatabase('kraftsoft');
        $ind_qtde_total_neg_perdidos->setFieldValue("negocio.id");
        $ind_qtde_total_neg_perdidos->setModel('Negocio');
        $ind_qtde_total_neg_perdidos->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $ind_qtde_total_neg_perdidos->setTotal('count');
        $ind_qtde_total_neg_perdidos->setColors('#F44336', '#ffffff', '#F44336', '#ffffff');
        $ind_qtde_total_neg_perdidos->setTitle("Negócios Perdidos", '#ffffff', '15', '');
        $ind_qtde_total_neg_perdidos->setCriteria($criteria_ind_qtde_total_neg_perdidos);
        $ind_qtde_total_neg_perdidos->setIcon(new TImage('fas:angry #ffffff'));
        $ind_qtde_total_neg_perdidos->setValueSize("25");
        $ind_qtde_total_neg_perdidos->setValueColor("#ffffff", 'B');
        $ind_qtde_total_neg_perdidos->setSize('100%', 95);
        $ind_qtde_total_neg_perdidos->setLayout('horizontal', 'left');

        $ind_vlr_total_neg_perdidos->setDatabase('kraftsoft');
        $ind_vlr_total_neg_perdidos->setFieldValue("negocio.valor");
        $ind_vlr_total_neg_perdidos->setModel('Negocio');
        $ind_vlr_total_neg_perdidos->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $ind_vlr_total_neg_perdidos->setTotal('sum');
        $ind_vlr_total_neg_perdidos->setColors('#E91E63', '#ffffff', '#E91E63', '#ffffff');
        $ind_vlr_total_neg_perdidos->setTitle("Valor Perdido", '#ffffff', '15', '');
        $ind_vlr_total_neg_perdidos->setCriteria($criteria_ind_vlr_total_neg_perdidos);
        $ind_vlr_total_neg_perdidos->setIcon(new TImage('fas:money-check-alt #ffffff'));
        $ind_vlr_total_neg_perdidos->setValueSize("25");
        $ind_vlr_total_neg_perdidos->setValueColor("#ffffff", 'B');
        $ind_vlr_total_neg_perdidos->setSize('100%', 95);
        $ind_vlr_total_neg_perdidos->setLayout('horizontal', 'left');

        $bbar_neg_etapa->setDatabase('kraftsoft');
        $bbar_neg_etapa->setFieldValue("negocio.valor");
        $bbar_neg_etapa->setFieldGroup(["funil_etapas.descricao"]);
        $bbar_neg_etapa->setModel('Negocio');
        $bbar_neg_etapa->setTitle("Valor de negócios ativos por etapa");
        $bbar_neg_etapa->setTransformerValue(function($value, $row, $data)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bbar_neg_etapa->setLayout('vertical');
        $bbar_neg_etapa->setJoins([
             'funil_etapas' => ['negocio.funil_etapas_id', 'funil_etapas.id']
        ]);
        $bbar_neg_etapa->setTotal('sum');
        $bbar_neg_etapa->showLegend(true);
        $bbar_neg_etapa->enableOrderByValue('asc');
        $bbar_neg_etapa->setCriteria($criteria_bbar_neg_etapa);
        $bbar_neg_etapa->setLabelValue("Valor");
        $bbar_neg_etapa->setSize('100%', 280);
        $bbar_neg_etapa->disableZoom();

        $qtde_neg_etapa->setDatabase('kraftsoft');
        $qtde_neg_etapa->setFieldValue("negocio.id");
        $qtde_neg_etapa->setFieldGroup("funil_etapas.descricao");
        $qtde_neg_etapa->setModel('Negocio');
        $qtde_neg_etapa->setTitle("Quantidade de negócios por etapa");
        $qtde_neg_etapa->setJoins([
             'funil_etapas' => ['negocio.funil_etapas_id', 'funil_etapas.id']
        ]);
        $qtde_neg_etapa->setTotal('count');
        $qtde_neg_etapa->showLegend(true);
        $qtde_neg_etapa->enableOrderByValue('asc');
        $qtde_neg_etapa->setCriteria($criteria_qtde_neg_etapa);
        $qtde_neg_etapa->setSize('100%', 280);
        $qtde_neg_etapa->disableZoom();

        $qtde_origem->setDatabase('kraftsoft');
        $qtde_origem->setFieldValue("negocio.id");
        $qtde_origem->setFieldGroup(["negocio_origem.descricao"]);
        $qtde_origem->setModel('Negocio');
        $qtde_origem->setTitle("Quantidade de negócios por origem");
        $qtde_origem->setLayout('horizontal');
        $qtde_origem->setJoins([
             'negocio_origem' => ['negocio.negocio_origem_id', 'negocio_origem.id']
        ]);
        $qtde_origem->setTotal('count');
        $qtde_origem->showLegend(true);
        $qtde_origem->enableOrderByValue('asc');
        $qtde_origem->setCriteria($criteria_qtde_origem);
        $qtde_origem->setSize('100%', 280);
        $qtde_origem->disableZoom();

        $motivos_neg_perdidos->setDatabase('kraftsoft');
        $motivos_neg_perdidos->setFieldValue("negocio.id");
        $motivos_neg_perdidos->setFieldGroup(["negocio_motivo_perda.descricao"]);
        $motivos_neg_perdidos->setModel('Negocio');
        $motivos_neg_perdidos->setTitle(" Motivos de perdas de negócio");
        $motivos_neg_perdidos->setLayout('vertical');
        $motivos_neg_perdidos->setJoins([
             'negocio_motivo_perda' => ['negocio.negocio_motivo_perda_id', 'negocio_motivo_perda.id']
        ]);
        $motivos_neg_perdidos->setTotal('count');
        $motivos_neg_perdidos->showLegend(true);
        $motivos_neg_perdidos->enableOrderByValue('asc');
        $motivos_neg_perdidos->setCriteria($criteria_motivos_neg_perdidos);
        $motivos_neg_perdidos->setSize('100%', 280);
        $motivos_neg_perdidos->disableZoom();

        $row1 = $this->form->addContent([new TFormSeparator("Filtros", '#333', '18', '#eee')]);
        $row2 = $this->form->addFields([new TLabel("Data abertura inicial:", null, '14px', null, '100%'),$data_inicial],[new TLabel("Data abertura final:", null, '14px', null, '100%'),$data_final],[new TLabel("Filial:", null, '14px', null),$system_unit_id]);
        $row2->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Funil:", null, '14px', null),$funil_id],[new TLabel("Etapa:", null, '14px', null),$funil_etapa_id]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([$button_buscar]);
        $row4->layout = ['col-sm-3'];

        $row5 = $this->form->addFields([$qtde_neg_ganhos],[$vlr_neg_ganhos]);
        $row5->layout = [' col-sm-6',' col-sm-6'];

        $row6 = $this->form->addFields([$ind_qtde_total_neg_ativos],[$ind_vlr_total_neg_ativos],[$ind_qtde_total_neg_perdidos],[$ind_vlr_total_neg_perdidos]);
        $row6->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row7 = $this->form->addFields([$bbar_neg_etapa],[$qtde_neg_etapa]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([$qtde_origem],[$motivos_neg_perdidos]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        if(!isset($param['data_inicial']) && $data_inicial->getValue())
        {
            $_POST['data_inicial'] = $data_inicial->getValue();
        }
        if(!isset($param['data_final']) && $data_final->getValue())
        {
            $_POST['data_final'] = $data_final->getValue();
        }
        if(!isset($param['system_unit_id']) && $system_unit_id->getValue())
        {
            $_POST['system_unit_id'] = $system_unit_id->getValue();
        }
        if(!isset($param['funil_id']) && $funil_id->getValue())
        {
            $_POST['funil_id'] = $funil_id->getValue();
        }
        if(!isset($param['funil_etapa_id']) && $funil_etapa_id->getValue())
        {
            $_POST['funil_etapa_id'] = $funil_etapa_id->getValue();
        }

        $searchData = $this->form->getData();
        $this->form->setData($searchData);

        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_qtde_neg_ganhos->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_qtde_neg_ganhos->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_qtde_neg_ganhos->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_qtde_neg_ganhos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_qtde_neg_ganhos->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_vlr_neg_ganhos->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_vlr_neg_ganhos->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_vlr_neg_ganhos->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_vlr_neg_ganhos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_vlr_neg_ganhos->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_ativos->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_ativos->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_ativos->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_ativos->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_perdidos->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_perdidos->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_perdidos->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_ind_qtde_total_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_perdidos->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_perdidos->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_perdidos->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_ind_vlr_total_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_neg_etapa->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_bbar_neg_etapa->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_bbar_neg_etapa->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_bbar_neg_etapa->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_bbar_neg_etapa->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_qtde_neg_etapa->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_qtde_neg_etapa->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_qtde_neg_etapa->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_qtde_neg_etapa->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_qtde_neg_etapa->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_qtde_origem->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_qtde_origem->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_qtde_origem->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_qtde_origem->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_qtde_origem->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_motivos_neg_perdidos->add(new TFilter('negocio.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_motivos_neg_perdidos->add(new TFilter('negocio.data_abertura', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_motivos_neg_perdidos->add(new TFilter('negocio.data_abertura', '<=', $filterVar)); 
        }
        $filterVar = $searchData->funil_id;
        if($filterVar)
        {
            $criteria_motivos_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', 'in', "(SELECT id FROM funil_etapas WHERE funil_id = '$filterVar')")); 
        }
        $filterVar = $searchData->funil_etapa_id;
        if($filterVar)
        {
            $criteria_motivos_neg_perdidos->add(new TFilter('negocio.funil_etapas_id', '=', $filterVar)); 
        }

        BChart::generate($qtde_neg_ganhos, $vlr_neg_ganhos, $ind_qtde_total_neg_ativos, $ind_vlr_total_neg_ativos, $ind_qtde_total_neg_perdidos, $ind_vlr_total_neg_perdidos, $bbar_neg_etapa, $qtde_neg_etapa, $qtde_origem, $motivos_neg_perdidos);

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Dashboards","Dashboard CRM"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function OnChangeFilial($param = null) 
    {
        try 
        {
            //code here

            //TSession::setValue('filial_dashcrm_id', $param['system_unit_id']);

            // echo "<pre>";
            // echo('system unit id '.TSession::getValue('filial_dashcrm_id'));
            // echo "</pre>";            

            $criteria = new TCriteria();
            $criteria->add(new TFilter('system_unit_id', '=', $param['system_unit_id'])); 

            TDBCombo::reloadFromModel(self::$formName, 'funil_id', 'kraftsoft', 'VwFunilFilial', 'id', '{descricao}', 'id asc', $criteria, FALSE); 

            //TDBCombo::reloadFromModel('formName do formulario pai', 'field do formulario pai', $database, $model, $key, $value, 
                                     //$ordercolumn = NULL, $criteria = NULL,'permite selecao vazia TRUE/FALSE')

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function OnChangeFunil($param = null) 
    {
        try 
        {
            //code here

            $criteria = new TCriteria();
            $criteria->add(new TFilter('funil_id', '=', $param['funil_id'])); 

            TDBCombo::reloadFromModel(self::$formName, 'funil_etapa_id', 'kraftsoft', 'FunilEtapas', 'id', '{descricao}', 'id asc', $criteria, TRUE); 

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {               

    } 

}

