<?php

class DashboardCertificacaoDigital extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_DashboardCertificacaoDigital';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Dashboard Certificação Digital");

        $criteria_qtde_cert_emitidos = new TCriteria();
        $criteria_vlr_faturamento = new TCriteria();
        $criteria_vlr_comissoes = new TCriteria();
        $criteria_qtde_aguardando_emissao = new TCriteria();
        $criteria_qtde_vencendo = new TCriteria();
        $criteria_qtde_vencidos = new TCriteria();
        $criteria_bbar_tipo_atendimento = new TCriteria();
        $criteria_bbar_emissoes_agentes = new TCriteria();
        $criteria_bbar_emissoes_parceiros = new TCriteria();
        $criteria_bbar_vendas_tipo_certificado = new TCriteria();

        $filterVar = CertificadoVendaSituacao::Atendido;
        $criteria_qtde_cert_emitidos->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 
        $filterVar = CertificadoVendaSituacao::Atendido;
        $criteria_vlr_faturamento->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 
        $filterVar = CertificadoVendaSituacao::Atendido;
        $criteria_vlr_comissoes->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 
        $filterVar = CertificadoVendaSituacao::AguardandoAtendimento;
        $criteria_qtde_aguardando_emissao->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 
        $filterVar = CertificadoClienteSituacao::AguardandoRenovacao;
        $criteria_qtde_vencendo->add(new TFilter('certificado_cliente.certificado_cliente_situacao_id', '=', $filterVar)); 
        $filterVar = date('Y-m-d');
        $criteria_qtde_vencendo->add(new TFilter('certificado_cliente.data_vencimento_certificado', '>=', $filterVar)); 
        $filterVar = date('Y-m-d')+30;
        $criteria_qtde_vencendo->add(new TFilter('certificado_cliente.data_vencimento_certificado', '<=', $filterVar)); 
        $filterVar = CertificadoClienteSituacao::AguardandoRenovacao;
        $criteria_qtde_vencidos->add(new TFilter('certificado_cliente.certificado_cliente_situacao_id', '=', $filterVar)); 
        $filterVar = date('Y-m-d');
        $criteria_qtde_vencidos->add(new TFilter('certificado_cliente.data_vencimento_certificado', '<=', $filterVar)); 
        $filterVar = CertificadoVendaSituacao::Atendido;
        $criteria_bbar_tipo_atendimento->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 
        $filterVar = CertificadoVendaSituacao::Atendido;
        $criteria_bbar_emissoes_agentes->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 
        $filterVar = CertificadoVendaSituacao::Atendido;
        $criteria_bbar_emissoes_parceiros->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 
        $filterVar = CertificadoVendaSituacao::Atendido;
        $criteria_bbar_vendas_tipo_certificado->add(new TFilter('certificado_venda.certificado_venda_situacao_id', '=', $filterVar)); 

        $data_emissao_inicial = new TDate('data_emissao_inicial');
        $data_emissao_final = new TDate('data_emissao_final');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $button_buscar = new TButton('button_buscar');
        $qtde_cert_emitidos = new BIndicator('qtde_cert_emitidos');
        $vlr_faturamento = new BIndicator('vlr_faturamento');
        $vlr_comissoes = new BIndicator('vlr_comissoes');
        $qtde_aguardando_emissao = new BIndicator('qtde_aguardando_emissao');
        $qtde_vencendo = new BIndicator('qtde_vencendo');
        $qtde_vencidos = new BIndicator('qtde_vencidos');
        $bbar_tipo_atendimento = new BBarChart('bbar_tipo_atendimento');
        $bbar_emissoes_agentes = new BBarChart('bbar_emissoes_agentes');
        $bbar_emissoes_parceiros = new BBarChart('bbar_emissoes_parceiros');
        $bbar_vendas_tipo_certificado = new BBarChart('bbar_vendas_tipo_certificado');
        $pc_ultimos_agendamentos = new BPageContainer();

        $system_unit_id->setChangeAction(new TAction([$this,'onExitFilial']));

        $system_unit_id->enableSearch();
        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search #FFFFFF');
        $pc_ultimos_agendamentos->setId('b6325a4b19b187');
        $data_emissao_final->setMask('dd/mm/yyyy');
        $data_emissao_inicial->setMask('dd/mm/yyyy');

        $data_emissao_final->setValue(date('d/m/Y'));
        $data_emissao_inicial->setValue(date('d/m/Y'));

        $data_emissao_final->setDatabaseMask('yyyy-mm-dd');
        $data_emissao_inicial->setDatabaseMask('yyyy-mm-dd');

        $button_buscar->setAction(new TAction(['DashboardCertificacaoDigital', 'onShow']), "Buscar");
        $pc_ultimos_agendamentos->setAction(new TAction(['CertificadoAgendamentosSimpleList', 'onShow']));

        $system_unit_id->setSize('100%');
        $data_emissao_final->setSize('100%');
        $data_emissao_inicial->setSize('100%');
        $pc_ultimos_agendamentos->setSize('100%');

        $qtde_cert_emitidos->setDatabase('kraftsoft');
        $qtde_cert_emitidos->setFieldValue("certificado_venda.id");
        $qtde_cert_emitidos->setModel('CertificadoVenda');
        $qtde_cert_emitidos->setTotal('count');
        $qtde_cert_emitidos->setColors('#9B59B6', '#ffffff', '#8E44AD', '#ffffff');
        $qtde_cert_emitidos->setTitle("Qtde de Certificados Emitidos", '#ffffff', '15', '');
        $qtde_cert_emitidos->setCriteria($criteria_qtde_cert_emitidos);
        $qtde_cert_emitidos->setIcon(new TImage('fas:bookmark #ffffff'));
        $qtde_cert_emitidos->setValueSize("20");
        $qtde_cert_emitidos->setValueColor("#ffffff", 'B');
        $qtde_cert_emitidos->setSize('100%', 95);
        $qtde_cert_emitidos->setLayout('horizontal', 'left');

        $vlr_faturamento->setDatabase('kraftsoft');
        $vlr_faturamento->setFieldValue("certificado_venda.valor_total");
        $vlr_faturamento->setModel('CertificadoVenda');
        $vlr_faturamento->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $vlr_faturamento->setTotal('sum');
        $vlr_faturamento->setColors('#27ae60', '#ffffff', '#2ecc71', '#ffffff');
        $vlr_faturamento->setTitle("faturamento", '#ffffff', '20', '');
        $vlr_faturamento->setCriteria($criteria_vlr_faturamento);
        $vlr_faturamento->setIcon(new TImage('fas:shopping-basket #ffffff'));
        $vlr_faturamento->setValueSize("20");
        $vlr_faturamento->setValueColor("#ffffff", 'B');
        $vlr_faturamento->setSize('100%', 95);
        $vlr_faturamento->setLayout('horizontal', 'left');

        $vlr_comissoes->setDatabase('kraftsoft');
        $vlr_comissoes->setFieldValue("certificado_venda.comissao_total");
        $vlr_comissoes->setModel('CertificadoVenda');
        $vlr_comissoes->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $vlr_comissoes->setTotal('sum');
        $vlr_comissoes->setColors('#E67E22', '#ffffff', '#D35400', '#ffffff');
        $vlr_comissoes->setTitle("COMISSÕES", '#ffffff', '20', '');
        $vlr_comissoes->setCriteria($criteria_vlr_comissoes);
        $vlr_comissoes->setIcon(new TImage('fas:money-bill #ffffff'));
        $vlr_comissoes->setValueSize("20");
        $vlr_comissoes->setValueColor("#ffffff", 'B');
        $vlr_comissoes->setSize('100%', 95);
        $vlr_comissoes->setLayout('horizontal', 'left');

        $qtde_aguardando_emissao->setDatabase('kraftsoft');
        $qtde_aguardando_emissao->setFieldValue("certificado_venda.id");
        $qtde_aguardando_emissao->setModel('CertificadoVenda');
        $qtde_aguardando_emissao->setTotal('count');
        $qtde_aguardando_emissao->setColors('#81ECEC', '#ffffff', '#00CEC9', '#ffffff');
        $qtde_aguardando_emissao->setTitle("Aguardando Emissão", '#ffffff', '20', '');
        $qtde_aguardando_emissao->setCriteria($criteria_qtde_aguardando_emissao);
        $qtde_aguardando_emissao->setIcon(new TImage('fas:fingerprint #ffffff'));
        $qtde_aguardando_emissao->setValueSize("20");
        $qtde_aguardando_emissao->setValueColor("#ffffff", 'B');
        $qtde_aguardando_emissao->setSize('100%', 95);
        $qtde_aguardando_emissao->setLayout('horizontal', 'left');

        $qtde_vencendo->setDatabase('kraftsoft');
        $qtde_vencendo->setFieldValue("certificado_cliente.id");
        $qtde_vencendo->setModel('CertificadoCliente');
        $qtde_vencendo->setTotal('count');
        $qtde_vencendo->setColors('#95A5A6', '#ffffff', '#7F8C8D', '#ffffff');
        $qtde_vencendo->setTitle("Vencendo em até 30 dias", '#ffffff', '19', '');
        $qtde_vencendo->setCriteria($criteria_qtde_vencendo);
        $qtde_vencendo->setIcon(new TImage('fas:calendar-times #ffffff'));
        $qtde_vencendo->setValueSize("20");
        $qtde_vencendo->setValueColor("#ffffff", 'B');
        $qtde_vencendo->setSize('100%', 95);
        $qtde_vencendo->setLayout('horizontal', 'left');

        $qtde_vencidos->setDatabase('kraftsoft');
        $qtde_vencidos->setFieldValue("certificado_cliente.id");
        $qtde_vencidos->setModel('CertificadoCliente');
        $qtde_vencidos->setTotal('count');
        $qtde_vencidos->setColors('#E74C3C', '#ffffff', '#C0392B', '#ffffff');
        $qtde_vencidos->setTitle("vencidos", '#ffffff', '20', '');
        $qtde_vencidos->setCriteria($criteria_qtde_vencidos);
        $qtde_vencidos->setIcon(new TImage('fas:shopping-basket #ffffff'));
        $qtde_vencidos->setValueSize("20");
        $qtde_vencidos->setValueColor("#ffffff", 'B');
        $qtde_vencidos->setSize('100%', 95);
        $qtde_vencidos->setLayout('horizontal', 'left');

        $bbar_tipo_atendimento->setDatabase('kraftsoft');
        $bbar_tipo_atendimento->setFieldValue("certificado_venda.id");
        $bbar_tipo_atendimento->setFieldGroup(["certificado_tipo_atendimento.descricao"]);
        $bbar_tipo_atendimento->setModel('CertificadoVenda');
        $bbar_tipo_atendimento->setTitle("Tipos de Atendimentos");
        $bbar_tipo_atendimento->setLayout('horizontal');
        $bbar_tipo_atendimento->setJoins([
             'certificado_tipo_atendimento' => ['certificado_venda.certificado_tipo_atendimento_id', 'certificado_tipo_atendimento.id']
        ]);
        $bbar_tipo_atendimento->setTotal('count');
        $bbar_tipo_atendimento->showLegend(true);
        $bbar_tipo_atendimento->enableOrderByValue('asc');
        $bbar_tipo_atendimento->setCriteria($criteria_bbar_tipo_atendimento);
        $bbar_tipo_atendimento->setSize('100%', 280);
        $bbar_tipo_atendimento->disableZoom();

        $bbar_emissoes_agentes->setDatabase('kraftsoft');
        $bbar_emissoes_agentes->setFieldValue("certificado_venda.id");
        $bbar_emissoes_agentes->setFieldGroup(["certificado_agente_registro.nome"]);
        $bbar_emissoes_agentes->setModel('CertificadoVenda');
        $bbar_emissoes_agentes->setTitle("Emissões por Agentes");
        $bbar_emissoes_agentes->setLayout('vertical');
        $bbar_emissoes_agentes->setJoins([
             'certificado_agente_registro' => ['certificado_venda.certificado_agente_registro_id', 'certificado_agente_registro.id']
        ]);
        $bbar_emissoes_agentes->setTotal('count');
        $bbar_emissoes_agentes->showLegend(true);
        $bbar_emissoes_agentes->enableOrderByValue('asc');
        $bbar_emissoes_agentes->setCriteria($criteria_bbar_emissoes_agentes);
        $bbar_emissoes_agentes->setSize('100%', 280);
        $bbar_emissoes_agentes->disableZoom();

        $bbar_emissoes_parceiros->setDatabase('kraftsoft');
        $bbar_emissoes_parceiros->setFieldValue("certificado_venda.id");
        $bbar_emissoes_parceiros->setFieldGroup(["parceiro.nome"]);
        $bbar_emissoes_parceiros->setModel('CertificadoVenda');
        $bbar_emissoes_parceiros->setTitle("Emissões por Parceiros");
        $bbar_emissoes_parceiros->setLayout('vertical');
        $bbar_emissoes_parceiros->setJoins([
             'parceiro' => ['certificado_venda.parceiro_id', 'parceiro.id']
        ]);
        $bbar_emissoes_parceiros->setTotal('count');
        $bbar_emissoes_parceiros->showLegend(true);
        $bbar_emissoes_parceiros->enableOrderByValue('asc');
        $bbar_emissoes_parceiros->setCriteria($criteria_bbar_emissoes_parceiros);
        $bbar_emissoes_parceiros->setSize('100%', 280);
        $bbar_emissoes_parceiros->disableZoom();

        $bbar_vendas_tipo_certificado->setDatabase('kraftsoft');
        $bbar_vendas_tipo_certificado->setFieldValue("certificado_venda.id");
        $bbar_vendas_tipo_certificado->setFieldGroup(["produto.nome"]);
        $bbar_vendas_tipo_certificado->setModel('CertificadoVenda');
        $bbar_vendas_tipo_certificado->setTitle("Vendas por Tipo de Certificado");
        $bbar_vendas_tipo_certificado->setLayout('vertical');
        $bbar_vendas_tipo_certificado->setJoins([
             'produto' => ['certificado_venda.produto_id', 'produto.id']
        ]);
        $bbar_vendas_tipo_certificado->setTotal('count');
        $bbar_vendas_tipo_certificado->showLegend(true);
        $bbar_vendas_tipo_certificado->enableOrderByValue('asc');
        $bbar_vendas_tipo_certificado->setCriteria($criteria_bbar_vendas_tipo_certificado);
        $bbar_vendas_tipo_certificado->setSize('100%', 280);
        $bbar_vendas_tipo_certificado->disableZoom();

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $pc_ultimos_agendamentos->add($loadingContainer);

        $this->pc_ultimos_agendamentos = $pc_ultimos_agendamentos;

        $bcontainer_63259b1a2af69 = new BContainer('bcontainer_63259b1a2af69');
        $this->bcontainer_63259b1a2af69 = $bcontainer_63259b1a2af69;

        $bcontainer_63259b1a2af69->setTitle("Filtros", '#333', '18px', '', '#fff');
        $bcontainer_63259b1a2af69->setBorderColor('#c0c0c0');

        $row1 = $bcontainer_63259b1a2af69->addFields([new TLabel("Data Emissão Inicial:", null, '14px', null),$data_emissao_inicial],[new TLabel("Data Emissão Final:", null, '14px', null),$data_emissao_final],[new TLabel("Filial:", null, '14px', null),$system_unit_id]);
        $row1->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row2 = $bcontainer_63259b1a2af69->addFields([$button_buscar],[],[]);
        $row2->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row3 = $this->form->addFields([$bcontainer_63259b1a2af69]);
        $row3->layout = [' col-sm-12'];

        $row4 = $this->form->addFields([$qtde_cert_emitidos],[$vlr_faturamento],[$vlr_comissoes]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$qtde_aguardando_emissao],[$qtde_vencendo],[$qtde_vencidos]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addFields([$bbar_tipo_atendimento],[$bbar_emissoes_agentes]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([$bbar_emissoes_parceiros],[$bbar_vendas_tipo_certificado]);
        $row7->layout = ['col-sm-6',' col-sm-6'];

        $row8 = $this->form->addContent([new TFormSeparator("Agendamentos", '#333', '18', '#eee')]);
        $row9 = $this->form->addFields([$pc_ultimos_agendamentos]);
        $row9->layout = [' col-sm-12'];

        if(!isset($param['data_emissao_inicial']) && $data_emissao_inicial->getValue())
        {
            $_POST['data_emissao_inicial'] = $data_emissao_inicial->getValue();
        }
        if(!isset($param['data_emissao_final']) && $data_emissao_final->getValue())
        {
            $_POST['data_emissao_final'] = $data_emissao_final->getValue();
        }

        $searchData = $this->form->getData();
        $this->form->setData($searchData);

        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_qtde_cert_emitidos->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_inicial;
        if($filterVar)
        {
            $criteria_qtde_cert_emitidos->add(new TFilter('certificado_venda.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_final;
        if($filterVar)
        {
            $criteria_qtde_cert_emitidos->add(new TFilter('certificado_venda.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_vlr_faturamento->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_inicial;
        if($filterVar)
        {
            $criteria_vlr_faturamento->add(new TFilter('certificado_venda.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_final;
        if($filterVar)
        {
            $criteria_vlr_faturamento->add(new TFilter('certificado_venda.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_vlr_comissoes->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_inicial;
        if($filterVar)
        {
            $criteria_vlr_comissoes->add(new TFilter('certificado_venda.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_final;
        if($filterVar)
        {
            $criteria_vlr_comissoes->add(new TFilter('certificado_venda.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_qtde_aguardando_emissao->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_qtde_vencendo->add(new TFilter('certificado_cliente.cliente_id', 'in', "(SELECT id FROM cliente WHERE system_unit_id = '$filterVar')")); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_qtde_vencidos->add(new TFilter('certificado_cliente.cliente_id', 'in', "(SELECT id FROM cliente WHERE system_unit_id = '$filterVar')")); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_tipo_atendimento->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_inicial;
        if($filterVar)
        {
            $criteria_bbar_tipo_atendimento->add(new TFilter('certificado_venda.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_final;
        if($filterVar)
        {
            $criteria_bbar_tipo_atendimento->add(new TFilter('certificado_venda.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_emissoes_agentes->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_inicial;
        if($filterVar)
        {
            $criteria_bbar_emissoes_agentes->add(new TFilter('certificado_venda.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_final;
        if($filterVar)
        {
            $criteria_bbar_emissoes_agentes->add(new TFilter('certificado_venda.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_emissoes_parceiros->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_inicial;
        if($filterVar)
        {
            $criteria_bbar_emissoes_parceiros->add(new TFilter('certificado_venda.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_final;
        if($filterVar)
        {
            $criteria_bbar_emissoes_parceiros->add(new TFilter('certificado_venda.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_vendas_tipo_certificado->add(new TFilter('certificado_venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_inicial;
        if($filterVar)
        {
            $criteria_bbar_vendas_tipo_certificado->add(new TFilter('certificado_venda.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_emissao_final;
        if($filterVar)
        {
            $criteria_bbar_vendas_tipo_certificado->add(new TFilter('certificado_venda.data_emissao', '<=', $filterVar)); 
        }

        BChart::generate($qtde_cert_emitidos, $vlr_faturamento, $vlr_comissoes, $qtde_aguardando_emissao, $qtde_vencendo, $qtde_vencidos, $bbar_tipo_atendimento, $bbar_emissoes_agentes, $bbar_emissoes_parceiros, $bbar_vendas_tipo_certificado);

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Dashboards","Dashboard Certificação Digital"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitFilial($param = null) 
    {
        try 
        {
            TSession::setValue('dashboard_certificacao_filial_id', $param['system_unit_id']);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {               

        // $object = new stdClass();
        // $object->system_unit_id = TSession::getValue('userunitid');
        // TForm::sendData(self::$formName, $object);

    } 

}

