<?php

class DashboardFinanceiro extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_DashboardFinanceiro';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Dashborad Financeiro");

        $criteria_bind_contaspag_mes = new TCriteria();
        $criteria_bind_contasrec_mes = new TCriteria();
        $criteria_bind_contasrec_pagos = new TCriteria();
        $criteria_bind_contasrec_vencidas = new TCriteria();
        $criteria_bind_contasrec_avencer = new TCriteria();
        $criteria_bind_contaspag_pagas = new TCriteria();
        $criteria_bind_contaspag_vencidas = new TCriteria();
        $criteria_bind_contaspag_avencer = new TCriteria();
        $criteria_bbar_planoconta_receitas = new TCriteria();
        $criteria_bbar_planocontas_despesas = new TCriteria();

        $filterVar = ContaspagSituacao::Cancelado;
        $criteria_bind_contaspag_mes->add(new TFilter('contaspag.contaspag_situacao_id', '!=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_contaspag_mes->add(new TFilter('MONTH(contaspag.data_vencimento)', '=', $filterVar)); 
        $filterVar = ContasrecSituacao::Cancelado;
        $criteria_bind_contasrec_mes->add(new TFilter('contasrec.contasrec_situacao_id', '!=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_contasrec_mes->add(new TFilter('MONTH(contasrec.data_vencimento)', '=', $filterVar)); 
        $filterVar = ContasrecSituacao::Pago;
        $criteria_bind_contasrec_pagos->add(new TFilter('contasrec.contasrec_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_contasrec_pagos->add(new TFilter('MONTH(contasrec.data_pagamento)', '=', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_bind_contasrec_pagos->add(new TFilter('contasrec.ativo_id', '=', $filterVar)); 
        $filterVar = ContasrecSituacao::EmAberto;
        $criteria_bind_contasrec_vencidas->add(new TFilter('contasrec.contasrec_situacao_id', '=', $filterVar)); 
        $filterVar = date('Y-m-d');
        $criteria_bind_contasrec_vencidas->add(new TFilter('contasrec.data_vencimento', '<', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_bind_contasrec_vencidas->add(new TFilter('contasrec.ativo_id', '=', $filterVar)); 
        $filterVar = ContasrecSituacao::EmAberto;
        $criteria_bind_contasrec_avencer->add(new TFilter('contasrec.contasrec_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_contasrec_avencer->add(new TFilter('MONTH(contasrec.data_vencimento)', '=', $filterVar)); 
        $filterVar = date('Y-m-d');
        $criteria_bind_contasrec_avencer->add(new TFilter('contasrec.data_vencimento', '>=', $filterVar)); 
        $filterVar = Ativo::Ativo;
        $criteria_bind_contasrec_avencer->add(new TFilter('contasrec.ativo_id', '=', $filterVar)); 
        $filterVar = ContaspagSituacao::Pago;
        $criteria_bind_contaspag_pagas->add(new TFilter('contaspag.contaspag_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_contaspag_pagas->add(new TFilter('MONTH(contaspag.data_pagamento)', '=', $filterVar)); 
        $filterVar = ContaspagSituacao::EmAberto;
        $criteria_bind_contaspag_vencidas->add(new TFilter('contaspag.contaspag_situacao_id', '=', $filterVar)); 
        $filterVar = date('Y-m-d');
        $criteria_bind_contaspag_vencidas->add(new TFilter('contaspag.data_vencimento', '<', $filterVar)); 
        $filterVar = ContaspagSituacao::EmAberto;
        $criteria_bind_contaspag_avencer->add(new TFilter('contaspag.contaspag_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_contaspag_avencer->add(new TFilter('MONTH(contaspag.data_vencimento)', '=', $filterVar)); 
        $filterVar = date('Y-m-d');
        $criteria_bind_contaspag_avencer->add(new TFilter('contaspag.data_vencimento', '>=', $filterVar)); 
        $filterVar = ContabilLancamentosTipo::Credito;
        $criteria_bbar_planoconta_receitas->add(new TFilter('contabil_lancamentos.contabil_lancamentos_tipo_id', '=', $filterVar)); 
        $filterVar = ContabilLancamentosSituacao::Liquidado;
        $criteria_bbar_planoconta_receitas->add(new TFilter('contabil_lancamentos.contabil_lancamentos_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bbar_planoconta_receitas->add(new TFilter('MONTH(contabil_lancamentos.data_lancamento)', '=', $filterVar)); 
        $filterVar = ContabilLancamentosTipo::Debito;
        $criteria_bbar_planocontas_despesas->add(new TFilter('contabil_lancamentos.contabil_lancamentos_tipo_id', '=', $filterVar)); 
        $filterVar = ContabilLancamentosSituacao::Liquidado;
        $criteria_bbar_planocontas_despesas->add(new TFilter('contabil_lancamentos.contabil_lancamentos_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bbar_planocontas_despesas->add(new TFilter('MONTH(contabil_lancamentos.data_lancamento)', '=', $filterVar)); 

        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $button_buscar = new TButton('button_buscar');
        $bind_contaspag_mes = new BIndicator('bind_contaspag_mes');
        $bind_contasrec_mes = new BIndicator('bind_contasrec_mes');
        $bind_contasrec_pagos = new BIndicator('bind_contasrec_pagos');
        $bind_contasrec_vencidas = new BIndicator('bind_contasrec_vencidas');
        $bind_contasrec_avencer = new BIndicator('bind_contasrec_avencer');
        $bind_contaspag_pagas = new BIndicator('bind_contaspag_pagas');
        $bind_contaspag_vencidas = new BIndicator('bind_contaspag_vencidas');
        $bind_contaspag_avencer = new BIndicator('bind_contaspag_avencer');
        $belement_mov_contacorrente = new BElement('div');
        $bbar_planoconta_receitas = new BBarChart('bbar_planoconta_receitas');
        $bbar_planocontas_despesas = new BBarChart('bbar_planocontas_despesas');


        $system_unit_id->setDefaultOption(false);
        $system_unit_id->enableSearch();
        $button_buscar->setAction(new TAction(['DashboardFinanceiro', 'onShow']), "Buscar");
        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search #FFFFFF');
        $system_unit_id->setSize('100%');
        $belement_mov_contacorrente->setSize('100%', 80);

        $bind_contaspag_mes->setDatabase('kraftsoft');
        $bind_contaspag_mes->setFieldValue("contaspag.valor");
        $bind_contaspag_mes->setModel('Contaspag');
        $bind_contaspag_mes->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contaspag_mes->setTotal('sum');
        $bind_contaspag_mes->setColors('#E74C3C', '#FFFFFF', '#C0392B', '#FFFFFF');
        $bind_contaspag_mes->setTitle("contas a pagar (Mês)", '#FFFFFF', '17', '');
        $bind_contaspag_mes->setDescription("Contas a pagar neste mês", '15');
        $bind_contaspag_mes->setCriteria($criteria_bind_contaspag_mes);
        $bind_contaspag_mes->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_contaspag_mes->setValueSize("27");
        $bind_contaspag_mes->setValueColor("#FFFFFF", 'B');
        $bind_contaspag_mes->setSize('100%', 95);
        $bind_contaspag_mes->setLayout('horizontal', 'left');

        $bind_contasrec_mes->setDatabase('kraftsoft');
        $bind_contasrec_mes->setFieldValue("contasrec.valor");
        $bind_contasrec_mes->setModel('Contasrec');
        $bind_contasrec_mes->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contasrec_mes->setTotal('sum');
        $bind_contasrec_mes->setColors('#1ABC9C', '#FFFFFF', '#16A085', '#FFFFFF');
        $bind_contasrec_mes->setTitle("contas a receber (Mês)", '#FFFFFF', '17', '');
        $bind_contasrec_mes->setDescription("Contas a receber neste mês", '15');
        $bind_contasrec_mes->setCriteria($criteria_bind_contasrec_mes);
        $bind_contasrec_mes->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_contasrec_mes->setValueSize("27");
        $bind_contasrec_mes->setValueColor("#FFFFFF", 'B');
        $bind_contasrec_mes->setSize('100%', 95);
        $bind_contasrec_mes->setLayout('horizontal', 'left');

        $bind_contasrec_pagos->setDatabase('kraftsoft');
        $bind_contasrec_pagos->setFieldValue("contasrec.valor_pago");
        $bind_contasrec_pagos->setModel('Contasrec');
        $bind_contasrec_pagos->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contasrec_pagos->setTotal('sum');
        $bind_contasrec_pagos->setColors('#27ae60', '#ffffff', '#2ecc71', '#ffffff');
        $bind_contasrec_pagos->setTitle("contas a receber (pagas)", '#ffffff', '19', '');
        $bind_contasrec_pagos->setDescription("Contas a receber pagas neste mês", '15');
        $bind_contasrec_pagos->setCriteria($criteria_bind_contasrec_pagos);
        $bind_contasrec_pagos->setIcon(new TImage('fas:dollar-sign #ffffff'));
        $bind_contasrec_pagos->setValueSize("24");
        $bind_contasrec_pagos->setValueColor("#ffffff", 'B');
        $bind_contasrec_pagos->setSize('100%', 95);
        $bind_contasrec_pagos->setLayout('horizontal', 'left');

        $bind_contasrec_vencidas->setDatabase('kraftsoft');
        $bind_contasrec_vencidas->setFieldValue("contasrec.valor");
        $bind_contasrec_vencidas->setModel('Contasrec');
        $bind_contasrec_vencidas->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contasrec_vencidas->setTotal('sum');
        $bind_contasrec_vencidas->setColors('#E74C3C', '#FFFFFF', '#C0392B', '#FFFFFF');
        $bind_contasrec_vencidas->setTitle("contas a receber (vencidas)", '#FFFFFF', '17', '');
        $bind_contasrec_vencidas->setDescription("Contas a receber vencidas geral", '15');
        $bind_contasrec_vencidas->setCriteria($criteria_bind_contasrec_vencidas);
        $bind_contasrec_vencidas->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_contasrec_vencidas->setValueSize("26");
        $bind_contasrec_vencidas->setValueColor("#FFFFFF", 'B');
        $bind_contasrec_vencidas->setSize('100%', 95);
        $bind_contasrec_vencidas->setLayout('horizontal', 'left');

        $bind_contasrec_avencer->setDatabase('kraftsoft');
        $bind_contasrec_avencer->setFieldValue("contasrec.valor");
        $bind_contasrec_avencer->setModel('Contasrec');
        $bind_contasrec_avencer->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contasrec_avencer->setTotal('sum');
        $bind_contasrec_avencer->setColors('#74B9FF', '#FFFFFF', '#0984E3', '#FFFFFF');
        $bind_contasrec_avencer->setTitle("contas a receber (à vencer)", '#FFFFFF', '17', '');
        $bind_contasrec_avencer->setDescription("Contas a receber à vencer neste mês", '15');
        $bind_contasrec_avencer->setCriteria($criteria_bind_contasrec_avencer);
        $bind_contasrec_avencer->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_contasrec_avencer->setValueSize("27");
        $bind_contasrec_avencer->setValueColor("#FFFFFF", 'B');
        $bind_contasrec_avencer->setSize('100%', 95);
        $bind_contasrec_avencer->setLayout('horizontal', 'left');

        $bind_contaspag_pagas->setDatabase('kraftsoft');
        $bind_contaspag_pagas->setFieldValue("contaspag.valor_pago");
        $bind_contaspag_pagas->setModel('Contaspag');
        $bind_contaspag_pagas->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contaspag_pagas->setTotal('sum');
        $bind_contaspag_pagas->setColors('#27AE60', '#FFFFFF', '#2ECC71', '#FFFFFF');
        $bind_contaspag_pagas->setTitle("contas a pagar (pagas)", '#FFFFFF', '19', '');
        $bind_contaspag_pagas->setDescription("Contas a pagar pagas neste mês", '15');
        $bind_contaspag_pagas->setCriteria($criteria_bind_contaspag_pagas);
        $bind_contaspag_pagas->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_contaspag_pagas->setValueSize("24");
        $bind_contaspag_pagas->setValueColor("#FFFFFF", 'B');
        $bind_contaspag_pagas->setSize('100%', 95);
        $bind_contaspag_pagas->setLayout('horizontal', 'left');

        $bind_contaspag_vencidas->setDatabase('kraftsoft');
        $bind_contaspag_vencidas->setFieldValue("contaspag.valor");
        $bind_contaspag_vencidas->setModel('Contaspag');
        $bind_contaspag_vencidas->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contaspag_vencidas->setTotal('sum');
        $bind_contaspag_vencidas->setColors('#E74C3C', '#FFFFFF', '#C0392B', '#FFFFFF');
        $bind_contaspag_vencidas->setTitle("contas a pagar (vencidas)", '#FFFFFF', '17', '');
        $bind_contaspag_vencidas->setDescription("Contas a pagar vencidas geral", '15');
        $bind_contaspag_vencidas->setCriteria($criteria_bind_contaspag_vencidas);
        $bind_contaspag_vencidas->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_contaspag_vencidas->setValueSize("26");
        $bind_contaspag_vencidas->setValueColor("#FFFFFF", 'B');
        $bind_contaspag_vencidas->setSize('100%', 95);
        $bind_contaspag_vencidas->setLayout('horizontal', 'left');

        $bind_contaspag_avencer->setDatabase('kraftsoft');
        $bind_contaspag_avencer->setFieldValue("contaspag.valor");
        $bind_contaspag_avencer->setModel('Contaspag');
        $bind_contaspag_avencer->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_contaspag_avencer->setTotal('sum');
        $bind_contaspag_avencer->setColors('#74B9FF', '#FFFFFF', '#0984E3', '#FFFFFF');
        $bind_contaspag_avencer->setTitle("contas a pagar (à vencer)", '#FFFFFF', '17', '');
        $bind_contaspag_avencer->setDescription("Contas a pagar à vencer neste mês", '15');
        $bind_contaspag_avencer->setCriteria($criteria_bind_contaspag_avencer);
        $bind_contaspag_avencer->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_contaspag_avencer->setValueSize("27");
        $bind_contaspag_avencer->setValueColor("#FFFFFF", 'B');
        $bind_contaspag_avencer->setSize('100%', 95);
        $bind_contaspag_avencer->setLayout('horizontal', 'left');

        $bbar_planoconta_receitas->setDatabase('kraftsoft');
        $bbar_planoconta_receitas->setFieldValue("contabil_lancamentos.valor");
        $bbar_planoconta_receitas->setFieldGroup(["plano_conta.descricao"]);
        $bbar_planoconta_receitas->setModel('ContabilLancamentos');
        $bbar_planoconta_receitas->setTitle("🟢 PLANO DE CONTAS x RECEITAS x MÊS");
        $bbar_planoconta_receitas->setTransformerValue(function($value, $row, $data)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bbar_planoconta_receitas->setLayout('horizontal');
        $bbar_planoconta_receitas->setJoins([
             'plano_conta' => ['contabil_lancamentos.plano_conta_id', 'plano_conta.id']
        ]);
        $bbar_planoconta_receitas->setTotal('sum');
        $bbar_planoconta_receitas->showLegend(true);
        $bbar_planoconta_receitas->enableOrderByValue('asc');
        $bbar_planoconta_receitas->setCriteria($criteria_bbar_planoconta_receitas);
        $bbar_planoconta_receitas->setLabelValue("Valor");
        $bbar_planoconta_receitas->setSize('100%', 280);
        $bbar_planoconta_receitas->disableZoom();

        $bbar_planocontas_despesas->setDatabase('kraftsoft');
        $bbar_planocontas_despesas->setFieldValue("contabil_lancamentos.valor");
        $bbar_planocontas_despesas->setFieldGroup(["plano_conta.descricao"]);
        $bbar_planocontas_despesas->setModel('ContabilLancamentos');
        $bbar_planocontas_despesas->setTitle("🔴 PLANO DE CONTAS x DESPESAS x MÊS");
        $bbar_planocontas_despesas->setTransformerValue(function($value, $row, $data)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bbar_planocontas_despesas->setLayout('horizontal');
        $bbar_planocontas_despesas->setJoins([
             'plano_conta' => ['contabil_lancamentos.plano_conta_id', 'plano_conta.id']
        ]);
        $bbar_planocontas_despesas->setTotal('sum');
        $bbar_planocontas_despesas->showLegend(true);
        $bbar_planocontas_despesas->enableOrderByValue('asc');
        $bbar_planocontas_despesas->setCriteria($criteria_bbar_planocontas_despesas);
        $bbar_planocontas_despesas->setLabelValue("Valor");
        $bbar_planocontas_despesas->setSize('100%', 280);
        $bbar_planocontas_despesas->disableZoom();

        $this->belement_mov_contacorrente = $belement_mov_contacorrente;

        $html = new THtmlRenderer('app/resources/dashboards/grafico_colunas.html');
        $data = array();
        $data[] = [ 'MÊS', 'ENTRADAS R$', 'SAÍDAS R$', 'SALDO R$' ];

        $ano_atual = date('Y');
        $mes_atual = date('m');

        if (isset($param['system_unit_id']))
        {
            $system_unit_id_filtro = $param['system_unit_id'];    
        }

        if (!isset($system_unit_id_filtro))
        {
            $system_unit_id_filtro = 0;
        }

        TTransaction::open('kraftsoft');

        // if ($mes_atual >= '1')
        // {
            $jan_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '1')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $jan_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '1')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');
            $jan_saldo    = ($jan_entradas-$jan_saidas);

            $data[] = [ 'Janeiro', $jan_entradas, $jan_saidas, $jan_saldo ];
        // }

        // if ($mes_atual >= '2')
        // {
            $fev_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '2')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $fev_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '2')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $fev_saldo    = ($fev_entradas-$fev_saidas);

            $data[] = [ 'Fevereiro', $fev_entradas, $fev_saidas, $fev_saldo ];
        // }

        // if ($mes_atual >= '3')
        // {
            $mar_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '3')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $mar_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '3')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $mar_saldo    = ($mar_entradas-$mar_saidas);

            $data[] = [ 'Março', $mar_entradas, $mar_saidas, $mar_saldo ];
        // }

        // if ($mes_atual >= '4')
        // {
            $abr_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '4')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $abr_saidas    = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '4')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $abr_saldo    = ($abr_entradas-$abr_saidas);

            $data[] = [ 'Abril', $abr_entradas, $abr_saidas, $abr_saldo ];
        // }

        // if ($mes_atual >= '5')
        // {
            $mai_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '5')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $mai_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '5')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $mai_saldo    = ($mai_entradas-$mai_saidas);

            $data[] = [ 'Maio', $mai_entradas, $mai_saidas, $mai_saldo ];
        // }

        // if ($mes_atual >= '6')
        // {
            $jun_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '6')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $jun_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '6')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $jun_saldo    = ($jun_entradas-$jun_saidas);

            $data[] = [ 'Junho', $jun_entradas, $jun_saidas, $jun_saldo ];
        // }

        // if ($mes_atual >= '7')
        // {
            $jul_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '7')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $jul_saidas    = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '7')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $jul_saldo    = ($jul_entradas-$jul_saidas);

            $data[] = [ 'Julho', $jul_entradas, $jul_saidas, $jul_saldo ];
        // }

        // if ($mes_atual >= '8')
        // {
            $ago_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '8')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $ago_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '8')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $ago_saldo    = ($ago_entradas-$ago_saidas);

            $data[] = [ 'Agosto', $ago_entradas, $ago_saidas, $ago_saldo ];
        // }

        // if ($mes_atual >= '9')
        // {
            $set_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '9')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $set_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '9')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $set_saldo    = ($set_entradas-$set_saidas);

            $data[] = [ 'Setembro', $set_entradas, $set_saidas, $set_saldo ];
        // }

        // if ($mes_atual >= '10')
        // {
            $out_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '10')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $out_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '10')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $out_saldo    = ($out_entradas-$out_saidas);

            $data[] = [ 'Outubro', $out_entradas, $out_saidas, $out_saldo ];
        // }

        // if ($mes_atual >= '11')
        // {
            $nov_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '11')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $nov_saidas   = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '11')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $nov_saldo    = ($nov_entradas-$nov_saidas);

            $data[] = [ 'Novembro', $nov_entradas, $nov_saidas, $nov_saldo ];
        // }

        // if ($mes_atual >= '12')
        // {
            $dez_entradas = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '12')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $dez_saidas    = (double) ContaCorrenteLancamentos::where('MONTH(data_lancamento)', '=', '12')
                                                             ->where("YEAR(data_lancamento)", '=',  $ano_atual)
                                                             ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                             ->where('deletado_em', 'is', NULL)
                                                             ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id_filtro})")
                                                             ->sumBy('valor');

            $dez_saldo    = ($dez_entradas-$dez_saidas);

            $data[] = [ 'Dezembro', $dez_entradas, $dez_saidas, $dez_saldo ];
        // }

        //var_dump($data);

        $html->enableSection('main', array('data'   => json_encode($data),
                                           'width'  => '100%',
                                           'height' => '300px',
                                           'title'  => '🟢 MOVIMENTAÇÃO EM CONTA CORRENTE (RECEITAS x DESPESAS e SALDO) POR MÊS',
                                           'ytitle' => 'TOTAL', 
                                           'xtitle' => 'MÊS',
                                           'uniqid' => uniqid()));

        $belement_mov_contacorrente->add($html);

        TTransaction::close();

        $row1 = $this->form->addContent([new TFormSeparator("Filtros", '#333', '18', '#eee')]);
        $row2 = $this->form->addFields([new TLabel("Filial:", null, '14px', null, '100%'),$system_unit_id],[$button_buscar]);
        $row2->layout = [' col-sm-12','col-sm-2'];

        $row3 = $this->form->addContent([new TFormSeparator("Contas a Pagar x Contas a Receber", '#333', '18', '#eee')]);
        $row4 = $this->form->addFields([$bind_contaspag_mes],[$bind_contasrec_mes]);
        $row4->layout = [' col-sm-6',' col-sm-6'];

        $row5 = $this->form->addContent([new TFormSeparator("Contas a Receber", '#333', '18', '#eee')]);
        $row6 = $this->form->addFields([$bind_contasrec_pagos],[$bind_contasrec_vencidas],[$bind_contasrec_avencer]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->form->addContent([new TFormSeparator("Contas a Pagar", '#333', '18', '#eee')]);
        $row8 = $this->form->addFields([$bind_contaspag_pagas],[$bind_contaspag_vencidas],[$bind_contaspag_avencer]);
        $row8->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row9 = $this->form->addContent([new TFormSeparator("Movimentação em conta corrente", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([$belement_mov_contacorrente]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->form->addContent([new TFormSeparator("Plano de Contas", '#333', '18', '#eee')]);
        $row12 = $this->form->addFields([$bbar_planoconta_receitas],[$bbar_planocontas_despesas]);
        $row12->layout = [' col-sm-6','col-sm-6'];

        $searchData = $this->form->getData();
        $this->form->setData($searchData);

        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contaspag_mes->add(new TFilter('contaspag.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contasrec_mes->add(new TFilter('contasrec.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contasrec_pagos->add(new TFilter('contasrec.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contasrec_vencidas->add(new TFilter('contasrec.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contasrec_avencer->add(new TFilter('contasrec.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contaspag_pagas->add(new TFilter('contaspag.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contaspag_vencidas->add(new TFilter('contaspag.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_contaspag_avencer->add(new TFilter('contaspag.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_planoconta_receitas->add(new TFilter('contabil_lancamentos.plano_conta_id', 'in', "(SELECT id FROM plano_conta WHERE system_unit_id = '$filterVar')")); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_planocontas_despesas->add(new TFilter('contabil_lancamentos.plano_conta_id', 'in', "(SELECT id FROM plano_conta WHERE system_unit_id = '$filterVar')")); 
        }

        BChart::generate($bind_contaspag_mes, $bind_contasrec_mes, $bind_contasrec_pagos, $bind_contasrec_vencidas, $bind_contasrec_avencer, $bind_contaspag_pagas, $bind_contaspag_vencidas, $bind_contaspag_avencer, $bbar_planoconta_receitas, $bbar_planocontas_despesas);

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Dashboards","Dashborad Financeiro"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onShow($param = null)
    {               

    } 

}

