<?php

class DashboardFiscal extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_DashboardFiscal';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Dashboard Fiscal");

        $criteria_ind_qtde_notas_emitidas = new TCriteria();
        $criteria_ind_vlr_notas_emitidas = new TCriteria();
        $criteria_barra_total_por_filial = new TCriteria();

        $filterVar = NotafiscalSituacao::Autorizada;
        $criteria_ind_qtde_notas_emitidas->add(new TFilter('notafiscal.notafiscal_situacao_id', '=', $filterVar)); 
        $filterVar = NotafiscalSituacao::Autorizada;
        $criteria_ind_vlr_notas_emitidas->add(new TFilter('notafiscal.notafiscal_situacao_id', '=', $filterVar)); 
        $filterVar = NotafiscalSituacao::Autorizada;
        $criteria_barra_total_por_filial->add(new TFilter('notafiscal.notafiscal_situacao_id', '=', $filterVar)); 

        $data_inicial = new TDate('data_inicial');
        $data_final = new TDate('data_final');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $button_buscar = new TButton('button_buscar');
        $ind_qtde_notas_emitidas = new BIndicator('ind_qtde_notas_emitidas');
        $ind_vlr_notas_emitidas = new BIndicator('ind_vlr_notas_emitidas');
        $barra_total_por_filial = new BBarChart('barra_total_por_filial');


        $system_unit_id->enableSearch();
        $button_buscar->setAction(new TAction(['DashboardFiscal', 'onShow']), "Buscar");
        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search #FFFFFF');
        $data_final->setMask('dd/mm/yyyy');
        $data_inicial->setMask('dd/mm/yyyy');

        $data_final->setDatabaseMask('yyyy-mm-dd');
        $data_inicial->setDatabaseMask('yyyy-mm-dd');

        $data_final->setSize('100%');
        $data_inicial->setSize('100%');
        $system_unit_id->setSize('100%');

        $ind_qtde_notas_emitidas->setDatabase('kraftsoft');
        $ind_qtde_notas_emitidas->setFieldValue("notafiscal.id");
        $ind_qtde_notas_emitidas->setModel('Notafiscal');
        $ind_qtde_notas_emitidas->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $ind_qtde_notas_emitidas->setTotal('count');
        $ind_qtde_notas_emitidas->setColors('#3498DB', '#ffffff', '#2980B9', '#ffffff');
        $ind_qtde_notas_emitidas->setTitle("Qtde de Notas Emitidas", '#ffffff', '12', '');
        $ind_qtde_notas_emitidas->setCriteria($criteria_ind_qtde_notas_emitidas);
        $ind_qtde_notas_emitidas->setIcon(new TImage('fas:circle #ffffff'));
        $ind_qtde_notas_emitidas->setValueSize("20");
        $ind_qtde_notas_emitidas->setValueColor("#ffffff", 'B');
        $ind_qtde_notas_emitidas->setSize('100%', 95);
        $ind_qtde_notas_emitidas->setLayout('horizontal', 'left');

        $ind_vlr_notas_emitidas->setDatabase('kraftsoft');
        $ind_vlr_notas_emitidas->setFieldValue("notafiscal.valor_total_nota");
        $ind_vlr_notas_emitidas->setModel('Notafiscal');
        $ind_vlr_notas_emitidas->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $ind_vlr_notas_emitidas->setTotal('sum');
        $ind_vlr_notas_emitidas->setColors('#27ae60', '#ffffff', '#2ecc71', '#ffffff');
        $ind_vlr_notas_emitidas->setTitle("Valor de Notas Emitidas", '#ffffff', '12', '');
        $ind_vlr_notas_emitidas->setCriteria($criteria_ind_vlr_notas_emitidas);
        $ind_vlr_notas_emitidas->setIcon(new TImage('fas:shopping-basket #ffffff'));
        $ind_vlr_notas_emitidas->setValueSize("20");
        $ind_vlr_notas_emitidas->setValueColor("#ffffff", 'B');
        $ind_vlr_notas_emitidas->setSize('100%', 95);
        $ind_vlr_notas_emitidas->setLayout('horizontal', 'left');

        $barra_total_por_filial->setDatabase('kraftsoft');
        $barra_total_por_filial->setFieldValue("notafiscal.valor_total_nota");
        $barra_total_por_filial->setFieldGroup(["system_unit.name", "notafiscal_mod.modelo"]);
        $barra_total_por_filial->setModel('Notafiscal');
        $barra_total_por_filial->setTitle("Totais de notas por Filial");
        $barra_total_por_filial->setTransformerValue(function($value, $row, $data)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $barra_total_por_filial->setLayout('vertical');
        $barra_total_por_filial->setJoins([
             'system_unit' => ['notafiscal.system_unit_id', 'system_unit.id'],
             'notafiscal_mod' => ['notafiscal.notafiscal_mod_id', 'notafiscal_mod.id']
        ]);
        $barra_total_por_filial->setTotal('sum');
        $barra_total_por_filial->showLegend(true);
        $barra_total_por_filial->enableOrderByValue('asc');
        $barra_total_por_filial->setCriteria($criteria_barra_total_por_filial);
        $barra_total_por_filial->setSize('100%', 280);
        $barra_total_por_filial->disableZoom();

        $row1 = $this->form->addContent([new TFormSeparator("Filtros", '#333', '18', '#eee')]);
        $row2 = $this->form->addFields([new TLabel("Data Inicial:", null, '14px', null, '100%'),$data_inicial],[new TLabel("Data Final:", null, '14px', null, '100%'),$data_final],[new TLabel("Filial:", null, '14px', null),$system_unit_id],[new TLabel(" ", null, '16px', null, '100%'),$button_buscar]);
        $row2->layout = ['col-sm-3','col-sm-3',' col-sm-4','col-sm-2'];

        $row3 = $this->form->addFields([$ind_qtde_notas_emitidas],[$ind_vlr_notas_emitidas],[$barra_total_por_filial]);
        $row3->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $searchData = $this->form->getData();
        $this->form->setData($searchData);

        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_ind_qtde_notas_emitidas->add(new TFilter('notafiscal.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_ind_qtde_notas_emitidas->add(new TFilter('notafiscal.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_ind_qtde_notas_emitidas->add(new TFilter('notafiscal.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_ind_vlr_notas_emitidas->add(new TFilter('notafiscal.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_ind_vlr_notas_emitidas->add(new TFilter('notafiscal.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_ind_vlr_notas_emitidas->add(new TFilter('notafiscal.data_emissao', '<=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_barra_total_por_filial->add(new TFilter('notafiscal.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->data_inicial;
        if($filterVar)
        {
            $criteria_barra_total_por_filial->add(new TFilter('notafiscal.data_emissao', '>=', $filterVar)); 
        }
        $filterVar = $searchData->data_final;
        if($filterVar)
        {
            $criteria_barra_total_por_filial->add(new TFilter('notafiscal.data_emissao', '<=', $filterVar)); 
        }

        BChart::generate($ind_qtde_notas_emitidas, $ind_vlr_notas_emitidas, $barra_total_por_filial);

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Dashboards","Dashboard Fiscal"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onShow($param = null)
    {               

    } 

}

