<?php

class DashboardVendas extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_DashboardVendas';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Dashboard de Vendas");

        $criteria_bind_total_vendas_hoje = new TCriteria();
        $criteria_bind_total_vendas_mes = new TCriteria();
        $criteria_bind_total_vendas_ano = new TCriteria();
        $criteria_bind_vendas_em_atendimento = new TCriteria();
        $criteria_bind_vendas_aguardando_faturamento = new TCriteria();
        $criteria_bind_vendas_aguardando_expedicao = new TCriteria();
        $criteria_bind_vendas_em_processo_entrega = new TCriteria();
        $criteria_bind_vendas_finalizadas = new TCriteria();
        $criteria_bind_vendas_canceladas = new TCriteria();
        $criteria_bbar_fluxo_vendas_mes = new TCriteria();
        $criteria_meta_geral_vendas = new TCriteria();

        $filterVar = date('d');
        $criteria_bind_total_vendas_hoje->add(new TFilter('DAY(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::Finalizada;
        $criteria_bind_total_vendas_hoje->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_total_vendas_hoje->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = date('Y');
        $criteria_bind_total_vendas_hoje->add(new TFilter('YEAR(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_total_vendas_mes->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::Finalizada;
        $criteria_bind_total_vendas_mes->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('Y');
        $criteria_bind_total_vendas_mes->add(new TFilter('YEAR(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = date('Y');
        $criteria_bind_total_vendas_ano->add(new TFilter('YEAR(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::Finalizada;
        $criteria_bind_total_vendas_ano->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_vendas_em_atendimento->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::EmAndamento;
        $criteria_bind_vendas_em_atendimento->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_vendas_aguardando_faturamento->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::AguardandoFaturamento;
        $criteria_bind_vendas_aguardando_faturamento->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_vendas_aguardando_expedicao->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::AguardandoExpedicao;
        $criteria_bind_vendas_aguardando_expedicao->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_vendas_em_processo_entrega->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::EmProcessoDeEntrega;
        $criteria_bind_vendas_em_processo_entrega->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_vendas_finalizadas->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::Finalizada;
        $criteria_bind_vendas_finalizadas->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('m');
        $criteria_bind_vendas_canceladas->add(new TFilter('MONTH(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaSituacao::Cancelada;
        $criteria_bind_vendas_canceladas->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = VendaSituacao::Finalizada;
        $criteria_bbar_fluxo_vendas_mes->add(new TFilter('venda.venda_situacao_id', '=', $filterVar)); 
        $filterVar = date('Y');
        $criteria_bbar_fluxo_vendas_mes->add(new TFilter('YEAR(venda.data_hora_venda)', '=', $filterVar)); 
        $filterVar = VendaMetaSituacao::Aberta;
        $criteria_meta_geral_vendas->add(new TFilter('venda_meta.venda_meta_situacao_id', '=', $filterVar)); 

        TTransaction::open('kraftsoft');
        $metavenda = VendaMeta::where('venda_meta_situacao_id', '=', VendaMetaSituacao::Aberta)->first();
        TTransaction::close(); 

        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $button_buscar = new TButton('button_buscar');
        $bind_total_vendas_hoje = new BIndicator('bind_total_vendas_hoje');
        $bind_total_vendas_mes = new BIndicator('bind_total_vendas_mes');
        $bind_total_vendas_ano = new BIndicator('bind_total_vendas_ano');
        $bind_vendas_em_atendimento = new BIndicator('bind_vendas_em_atendimento');
        $bind_vendas_aguardando_faturamento = new BIndicator('bind_vendas_aguardando_faturamento');
        $bind_vendas_aguardando_expedicao = new BIndicator('bind_vendas_aguardando_expedicao');
        $bind_vendas_em_processo_entrega = new BIndicator('bind_vendas_em_processo_entrega');
        $bind_vendas_finalizadas = new BIndicator('bind_vendas_finalizadas');
        $bind_vendas_canceladas = new BIndicator('bind_vendas_canceladas');
        $bbar_fluxo_vendas_mes = new BBarChart('bbar_fluxo_vendas_mes');
        $meta_geral_vendas = new BIndicator('meta_geral_vendas');
        $belement_metas_vendedor = new BElement('div');


        $system_unit_id->setDefaultOption(false);
        $system_unit_id->enableSearch();
        $button_buscar->setAction(new TAction(['DashboardVendas', 'onShow']), "Buscar");
        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search #FFFFFF');
        $system_unit_id->setSize('100%');
        $belement_metas_vendedor->setSize('100%', 80);

        $bind_total_vendas_hoje->setDatabase('kraftsoft');
        $bind_total_vendas_hoje->setFieldValue("venda.valor_total");
        $bind_total_vendas_hoje->setModel('Venda');
        $bind_total_vendas_hoje->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_total_vendas_hoje->setTotal('sum');
        $bind_total_vendas_hoje->setColors('#9B59B6', '#ffffff', '#8E44AD', '#ffffff');
        $bind_total_vendas_hoje->setTitle("HOJE", '#ffffff', '20', '');
        $bind_total_vendas_hoje->setCriteria($criteria_bind_total_vendas_hoje);
        $bind_total_vendas_hoje->setIcon(new TImage('fas:calendar-day #ffffff'));
        $bind_total_vendas_hoje->setValueSize("30");
        $bind_total_vendas_hoje->setValueColor("#ffffff", 'B');
        $bind_total_vendas_hoje->setSize('100%', 95);
        $bind_total_vendas_hoje->setLayout('horizontal', 'left');

        $bind_total_vendas_mes->setDatabase('kraftsoft');
        $bind_total_vendas_mes->setFieldValue("venda.valor_total");
        $bind_total_vendas_mes->setModel('Venda');
        $bind_total_vendas_mes->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_total_vendas_mes->setTotal('sum');
        $bind_total_vendas_mes->setColors('#3498DB', '#FFFFFF', '#2980B9', '#FFFFFF');
        $bind_total_vendas_mes->setTitle("mês", '#FFFFFF', '20', '');
        $bind_total_vendas_mes->setCriteria($criteria_bind_total_vendas_mes);
        $bind_total_vendas_mes->setIcon(new TImage('fas:calendar-week #FFFFFF'));
        $bind_total_vendas_mes->setValueSize("30");
        $bind_total_vendas_mes->setValueColor("#FFFFFF", 'B');
        $bind_total_vendas_mes->setSize('100%', 95);
        $bind_total_vendas_mes->setLayout('horizontal', 'left');

        $bind_total_vendas_ano->setDatabase('kraftsoft');
        $bind_total_vendas_ano->setFieldValue("venda.valor_total");
        $bind_total_vendas_ano->setModel('Venda');
        $bind_total_vendas_ano->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_total_vendas_ano->setTotal('sum');
        $bind_total_vendas_ano->setColors('#1ABC9C', '#FFFFFF', '#16A085', '#FFFFFF');
        $bind_total_vendas_ano->setTitle("ano", '#FFFFFF', '20', '');
        $bind_total_vendas_ano->setCriteria($criteria_bind_total_vendas_ano);
        $bind_total_vendas_ano->setIcon(new TImage('fas:calendar-alt #FFFFFF'));
        $bind_total_vendas_ano->setValueSize("30");
        $bind_total_vendas_ano->setValueColor("#FFFFFF", 'B');
        $bind_total_vendas_ano->setSize('100%', 95);
        $bind_total_vendas_ano->setLayout('horizontal', 'left');

        $bind_vendas_em_atendimento->setDatabase('kraftsoft');
        $bind_vendas_em_atendimento->setFieldValue("venda.id");
        $bind_vendas_em_atendimento->setModel('Venda');
        $bind_vendas_em_atendimento->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $bind_vendas_em_atendimento->setTotal('count');
        $bind_vendas_em_atendimento->setColors('#FF9800', '#ffffff', '#FF9800', '#ffffff');
        $bind_vendas_em_atendimento->setTitle("Em Andamento", '#ffffff', '20', '');
        $bind_vendas_em_atendimento->setCriteria($criteria_bind_vendas_em_atendimento);
        $bind_vendas_em_atendimento->setValueSize("30");
        $bind_vendas_em_atendimento->setValueColor("#ffffff", 'B');
        $bind_vendas_em_atendimento->setSize('100%', 95);
        $bind_vendas_em_atendimento->setLayout('horizontal', 'center');

        $bind_vendas_aguardando_faturamento->setDatabase('kraftsoft');
        $bind_vendas_aguardando_faturamento->setFieldValue("venda.id");
        $bind_vendas_aguardando_faturamento->setModel('Venda');
        $bind_vendas_aguardando_faturamento->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $bind_vendas_aguardando_faturamento->setTotal('count');
        $bind_vendas_aguardando_faturamento->setColors('#27AE60', '#FFFFFF', '#2ECC71', '#FFFFFF');
        $bind_vendas_aguardando_faturamento->setTitle("aguardando faturamento", '#FFFFFF', '17', '');
        $bind_vendas_aguardando_faturamento->setCriteria($criteria_bind_vendas_aguardando_faturamento);
        $bind_vendas_aguardando_faturamento->setValueSize("30");
        $bind_vendas_aguardando_faturamento->setValueColor("#FFFFFF", 'B');
        $bind_vendas_aguardando_faturamento->setSize('100%', 95);
        $bind_vendas_aguardando_faturamento->setLayout('horizontal', 'center');

        $bind_vendas_aguardando_expedicao->setDatabase('kraftsoft');
        $bind_vendas_aguardando_expedicao->setFieldValue("venda.id");
        $bind_vendas_aguardando_expedicao->setModel('Venda');
        $bind_vendas_aguardando_expedicao->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $bind_vendas_aguardando_expedicao->setTotal('count');
        $bind_vendas_aguardando_expedicao->setColors('#27AE60', '#FFFFFF', '#2ECC71', '#FFFFFF');
        $bind_vendas_aguardando_expedicao->setTitle("aguardando expedição", '#FFFFFF', '17', '');
        $bind_vendas_aguardando_expedicao->setCriteria($criteria_bind_vendas_aguardando_expedicao);
        $bind_vendas_aguardando_expedicao->setValueSize("30");
        $bind_vendas_aguardando_expedicao->setValueColor("#FFFFFF", 'B');
        $bind_vendas_aguardando_expedicao->setSize('100%', 95);
        $bind_vendas_aguardando_expedicao->setLayout('horizontal', 'center');

        $bind_vendas_em_processo_entrega->setDatabase('kraftsoft');
        $bind_vendas_em_processo_entrega->setFieldValue("venda.id");
        $bind_vendas_em_processo_entrega->setModel('Venda');
        $bind_vendas_em_processo_entrega->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $bind_vendas_em_processo_entrega->setTotal('count');
        $bind_vendas_em_processo_entrega->setColors('#27AE60', '#FFFFFF', '#2ECC71', '#FFFFFF');
        $bind_vendas_em_processo_entrega->setTitle("em processo de entrega", '#FFFFFF', '17', '');
        $bind_vendas_em_processo_entrega->setCriteria($criteria_bind_vendas_em_processo_entrega);
        $bind_vendas_em_processo_entrega->setValueSize("30");
        $bind_vendas_em_processo_entrega->setValueColor("#FFFFFF", 'B');
        $bind_vendas_em_processo_entrega->setSize('100%', 95);
        $bind_vendas_em_processo_entrega->setLayout('horizontal', 'center');

        $bind_vendas_finalizadas->setDatabase('kraftsoft');
        $bind_vendas_finalizadas->setFieldValue("venda.id");
        $bind_vendas_finalizadas->setModel('Venda');
        $bind_vendas_finalizadas->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $bind_vendas_finalizadas->setTotal('count');
        $bind_vendas_finalizadas->setColors('#27AE60', '#FFFFFF', '#2ECC71', '#FFFFFF');
        $bind_vendas_finalizadas->setTitle("finalizada", '#FFFFFF', '17', '');
        $bind_vendas_finalizadas->setCriteria($criteria_bind_vendas_finalizadas);
        $bind_vendas_finalizadas->setValueSize("30");
        $bind_vendas_finalizadas->setValueColor("#FFFFFF", 'B');
        $bind_vendas_finalizadas->setSize('100%', 95);
        $bind_vendas_finalizadas->setLayout('horizontal', 'center');

        $bind_vendas_canceladas->setDatabase('kraftsoft');
        $bind_vendas_canceladas->setFieldValue("venda.id");
        $bind_vendas_canceladas->setModel('Venda');
        $bind_vendas_canceladas->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value);
                    }
                    else
                    {
                        return $value;
                    }

        });
        $bind_vendas_canceladas->setTotal('count');
        $bind_vendas_canceladas->setColors('#27AE60', '#FFFFFF', '#2ECC71', '#FFFFFF');
        $bind_vendas_canceladas->setTitle("cancelada", '#FFFFFF', '17', '');
        $bind_vendas_canceladas->setCriteria($criteria_bind_vendas_canceladas);
        $bind_vendas_canceladas->setValueSize("30");
        $bind_vendas_canceladas->setValueColor("#FFFFFF", 'B');
        $bind_vendas_canceladas->setSize('100%', 95);
        $bind_vendas_canceladas->setLayout('horizontal', 'center');

        $bbar_fluxo_vendas_mes->setDatabase('kraftsoft');
        $bbar_fluxo_vendas_mes->setFieldValue("venda.valor_total");
        $bbar_fluxo_vendas_mes->setFieldGroup(["MONTH(venda.data_hora_venda)"]);
        $bbar_fluxo_vendas_mes->setModel('Venda');
        $bbar_fluxo_vendas_mes->setTitle("Fluxo de vendas no ano");
        $bbar_fluxo_vendas_mes->setTransformerLegend(function($value, $row, $data)
            {
                    $mes = Funcoes::meses();
                    return $mes[$value] ?? '';
            });
        $bbar_fluxo_vendas_mes->setTransformerValue(function($value, $row, $data)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bbar_fluxo_vendas_mes->setLayout('vertical');
        $bbar_fluxo_vendas_mes->setTotal('sum');
        $bbar_fluxo_vendas_mes->showLegend(true);
        $bbar_fluxo_vendas_mes->setCriteria($criteria_bbar_fluxo_vendas_mes);
        $bbar_fluxo_vendas_mes->setLabelValue("Valor");
        $bbar_fluxo_vendas_mes->setSize('100%', 280);
        $bbar_fluxo_vendas_mes->disableZoom();

        $meta_geral_vendas->setDatabase('kraftsoft');
        $meta_geral_vendas->setFieldValue("venda_meta.valor_meta_geral_realizada");
        $meta_geral_vendas->setModel('VendaMeta');
        $meta_geral_vendas->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });
        $meta_geral_vendas->setTotal('sum');
        $meta_geral_vendas->setTarget(100000, '#ffffff', function($percentage, $target){
            return "{$percentage}% de R$ 100.000,00";
        });
        $meta_geral_vendas->setColors('#3498DB', '#ffffff', '#2980B9', '#ffffff');
        $meta_geral_vendas->setTitle("Meta de Venda", '#ffffff', '20', '');
        $meta_geral_vendas->setCriteria($criteria_meta_geral_vendas);
        $meta_geral_vendas->setIcon(new TImage('fas:chart-line #ffffff'));
        $meta_geral_vendas->setValueSize("20");
        $meta_geral_vendas->setValueColor("#ffffff", 'B');
        $meta_geral_vendas->setSize('100%', 95);
        $meta_geral_vendas->setLayout('horizontal', 'left');

        $this->belement_metas_vendedor = $belement_metas_vendedor;

        TTransaction::open('kraftsoft');

        //carregando as cores de cada situação de venda...
        $lista_venda_situacao = VendaSituacao::where('id', '>', 0)->load();

        foreach ($lista_venda_situacao as $venda_situacao)
        {
            switch ($venda_situacao->id) 
            {
                case VendaSituacao::EmAndamento:
                    $bind_vendas_em_atendimento->setColors($venda_situacao->cor, '#ffffff', $venda_situacao->cor, '#ffffff');
                    break;

                case VendaSituacao::AguardandoFaturamento:
                    $bind_vendas_aguardando_faturamento->setColors($venda_situacao->cor, '#ffffff', $venda_situacao->cor, '#ffffff');
                    break;        

                case VendaSituacao::AguardandoExpedicao:
                    $bind_vendas_aguardando_expedicao->setColors($venda_situacao->cor, '#ffffff', $venda_situacao->cor, '#ffffff');
                    break;                            

                case VendaSituacao::Finalizada:
                    $bind_vendas_finalizadas->setColors($venda_situacao->cor, '#ffffff', $venda_situacao->cor, '#ffffff');
                    break;    

                case VendaSituacao::Cancelada:
                    $bind_vendas_canceladas->setColors($venda_situacao->cor, '#ffffff', $venda_situacao->cor, '#ffffff');
                    break;          

                case VendaSituacao::EmProcessoDeEntrega:
                    $bind_vendas_em_processo_entrega->setColors($venda_situacao->cor, '#ffffff', $venda_situacao->cor, '#ffffff');
                    break;                         
            }
        }

        //painel de metas por vendedor....
        $html = new THtmlRenderer('app/resources/dashboards/grafico_colunas.html');
        $data = array();
        echo  
        $lista_vendedores_meta = VendaMetaVendedor::where('venda_meta_id', '=', $metavenda->id)->load();

        if ($lista_vendedores_meta)
        {

            $data[] = [ 'Vendedor', 'Meta Prevista', 'Meta Realizada', 'teste' ];

            foreach ($lista_vendedores_meta as $meta_vendedor)
            {
                $data[] = [ $meta_vendedor->vendedor->nome, (double) $meta_vendedor->valor_meta_prevista, (double) $meta_vendedor->valor_meta_realizada, 0 ];
            }     

            //var_dump($data);

            $html->enableSection('main', array('data'   => json_encode($data),
                                               'width'  => '100%',
                                               'height' => '300px',
                                               'title'  => 'METAS PREVISTAS X REALIZADAS POR VENDEDOR',
                                               'ytitle' => 'Valor', 
                                               'xtitle' => 'Vendedor',
                                               'uniqid' => uniqid()));

            $belement_metas_vendedor->add($html);                    

        }

        TTransaction::close();

        $row1 = $this->form->addContent([new TFormSeparator("Filtros", '#333', '18', '#eee')]);
        $row2 = $this->form->addFields([new TLabel("Filial:", null, '14px', null),$system_unit_id]);
        $row2->layout = ['col-sm-12'];

        $row3 = $this->form->addFields([$button_buscar],[]);
        $row3->layout = ['col-sm-3','col-sm-6'];

        $row4 = $this->form->addContent([new TFormSeparator("Totais de Vendas", '#333', '18', '#eee')]);
        $row5 = $this->form->addFields([$bind_total_vendas_hoje],[$bind_total_vendas_mes],[$bind_total_vendas_ano]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addContent([new TFormSeparator("Resumo de Vendas - Mês", '#333', '18', '#eee')]);
        $row7 = $this->form->addFields([$bind_vendas_em_atendimento],[$bind_vendas_aguardando_faturamento],[$bind_vendas_aguardando_expedicao],[$bind_vendas_em_processo_entrega]);
        $row7->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row8 = $this->form->addFields([$bind_vendas_finalizadas],[$bind_vendas_canceladas]);
        $row8->layout = [' col-sm-6',' col-sm-6'];

        $row9 = $this->form->addFields([$bbar_fluxo_vendas_mes]);
        $row9->layout = [' col-sm-12'];

        $row10 = $this->form->addContent([new TFormSeparator("Meta Ativa", '#333', '18', '#eee')]);
        $row11 = $this->form->addFields([$meta_geral_vendas]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->form->addFields([$belement_metas_vendedor]);
        $row12->layout = [' col-sm-12'];

        $meta_geral_vendas->setTitle($metavenda->descricao, '#ffffff', '20', '');
        $meta_geral_vendas->setTarget($metavenda->valor_meta_geral_prevista, '#ffffff', function($percentage, $target){
            return "{$percentage}% de R$ ".number_format($target, 2, ',', '.');
        });

        $searchData = $this->form->getData();
        $this->form->setData($searchData);

        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_total_vendas_hoje->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_total_vendas_mes->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_total_vendas_ano->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_vendas_em_atendimento->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_vendas_aguardando_faturamento->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_vendas_aguardando_expedicao->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_vendas_em_processo_entrega->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_vendas_finalizadas->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bind_vendas_canceladas->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_bbar_fluxo_vendas_mes->add(new TFilter('venda.system_unit_id', '=', $filterVar)); 
        }
        $filterVar = $searchData->system_unit_id;
        if($filterVar)
        {
            $criteria_meta_geral_vendas->add(new TFilter('venda_meta.system_unit_id', '=', $filterVar)); 
        }

        BChart::generate($bind_total_vendas_hoje, $bind_total_vendas_mes, $bind_total_vendas_ano, $bind_vendas_em_atendimento, $bind_vendas_aguardando_faturamento, $bind_vendas_aguardando_expedicao, $bind_vendas_em_processo_entrega, $bind_vendas_finalizadas, $bind_vendas_canceladas, $bbar_fluxo_vendas_mes, $meta_geral_vendas);

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Dashboards","Dashboard de Vendas"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onShow($param = null)
    {               

    } 

    public  function ResumoVendasMes($param = null) 
    {
        try 
        {

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

