<?php

class PainelIndicadoresPersonalizados extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_PainelIndicadoresPersonalizados';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Painel de Indicadores Personalizados");

        $criteria_painel_id = new TCriteria();

        $filterVar = TSession::getValue("userid");
        $criteria_painel_id->add(new TFilter('id', 'in', "(SELECT painel_indicadores_id FROM painel_indicador_usuario WHERE system_users_id = '{$filterVar}')")); 

        $painel_id = new TDBCombo('painel_id', 'kraftsoft', 'PainelIndicadores', 'id', '{descricao}','descricao asc' , $criteria_painel_id );
        $button_carregar_painel = new TButton('button_carregar_painel');
        $html_painel = new BElement('div');


        $painel_id->enableSearch();
        $button_carregar_painel->setAction(new TAction([$this, 'onCarregarPainel']), "Carregar Painel");
        $button_carregar_painel->addStyleClass('btn-primary');
        $button_carregar_painel->setImage('far:chart-bar #FFFFFF');
        $painel_id->setSize('100%');
        $html_painel->setSize('100%', 80);

        $this->html_painel = $html_painel;

        $row1 = $this->form->addFields([new TLabel("Painel:", null, '14px', null),$painel_id],[new TLabel("  ", null, '14px', null, '100%'),$button_carregar_painel]);
        $row1->layout = [' col-sm-10',' col-sm-2'];

        $row2 = $this->form->addFields([$html_painel]);
        $row2->layout = [' col-sm-12'];

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Dashboards","Painel de Indicadores Personalizados"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onCarregarPainel($param = null) 
    {
        try 
        {
            TTransaction::open('kraftsoft'); 

            $lista_painel_indicador = PainelIndicadorUsuario::where('painel_indicadores_id', '=', $param['painel_id'])->load();

            if ($lista_painel_indicador)
            {
                foreach ($lista_painel_indicador as $indicador)
                {
                   $this->html_painel->add('<h2>'.$indicador->indicador_personalizado->descricao.'<h2>');
                   $this->html_painel->add('<br>');

                   $html = $indicador->indicador_personalizado->url_indicador;
                   $this->html_painel->add($html);
                }
            }
            else
            {
               new TMessage('info', 'Nenhum indicador encontrado!');   
            }

            TTransaction::close();

            //jogando para o componente na tela..
            // $html1 = '<iframe width="100%" height="450" src="https://datastudio.google.com/embed/reporting/faaa61b9-e552-43f0-aeca-67de4335344f/page/rJE4C" frameborder="0" style="border:0" allowfullscreen></iframe>';
            // $this->html_painel->add($html1);

            // $this->html_painel->add('<br>');

            // $html2 = '<iframe width="100%" height="450" src="https://datastudio.google.com/embed/reporting/faaa61b9-e552-43f0-aeca-67de4335344f/page/p_qyl10u6azc" frameborder="0" style="border:0" allowfullscreen></iframe>';
            // $this->html_painel->add($html2);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {               

    } 

}

