<?php

class EstoqueDepositoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'EstoqueDeposito';
    private static $primaryKey = 'id';
    private static $formName = 'form_EstoqueDepositoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Depósito de Estoque");


        $id = new TEntry('id');
        $descricao = new TEntry('descricao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $estoque_rua_estoque_deposito_descricao = new TEntry('estoque_rua_estoque_deposito_descricao');
        $estoque_rua_estoque_deposito_id = new THidden('estoque_rua_estoque_deposito_id');
        $button_adicionar_estoque_rua_estoque_deposito = new TButton('button_adicionar_estoque_rua_estoque_deposito');

        $descricao->addValidation("Descrição", new TRequiredValidator()); 

        $button_adicionar_estoque_rua_estoque_deposito->setAction(new TAction([$this, 'onAddDetailEstoqueRuaEstoqueDeposito'],['static' => 1]), "Adicionar");
        $button_adicionar_estoque_rua_estoque_deposito->addStyleClass('btn-default');
        $button_adicionar_estoque_rua_estoque_deposito->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $estoque_rua_estoque_deposito_id->setSize(200);
        $estoque_rua_estoque_deposito_descricao->setSize('100%');

        $button_adicionar_estoque_rua_estoque_deposito->id = '6328b14666dba';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id]);
        $row1->layout = ['col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $bcontainer_632874c6a2412 = new BContainer('bcontainer_632874c6a2412');
        $this->bcontainer_632874c6a2412 = $bcontainer_632874c6a2412;

        $bcontainer_632874c6a2412->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_632874c6a2412->setBorderColor('#c0c0c0');

        $row3 = $bcontainer_632874c6a2412->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row3->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row4 = $this->form->addFields([$bcontainer_632874c6a2412]);
        $row4->layout = [' col-sm-12'];

        $this->form->appendPage("Endereçamento");

        $this->detailFormEstoqueRuaEstoqueDeposito = new BootstrapFormBuilder('detailFormEstoqueRuaEstoqueDeposito');
        $this->detailFormEstoqueRuaEstoqueDeposito->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormEstoqueRuaEstoqueDeposito->setProperty('class', 'form-horizontal builder-detail-form');

        $row5 = $this->detailFormEstoqueRuaEstoqueDeposito->addFields([new TFormSeparator("Ruas", '#333', '18', '#eee')]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->detailFormEstoqueRuaEstoqueDeposito->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$estoque_rua_estoque_deposito_descricao,$estoque_rua_estoque_deposito_id],[]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->detailFormEstoqueRuaEstoqueDeposito->addFields([$button_adicionar_estoque_rua_estoque_deposito]);
        $row7->layout = [' col-sm-12'];

        $row8 = $this->detailFormEstoqueRuaEstoqueDeposito->addFields([new THidden('estoque_rua_estoque_deposito__row__id')]);
        $this->estoque_rua_estoque_deposito_criteria = new TCriteria();

        $this->estoque_rua_estoque_deposito_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->estoque_rua_estoque_deposito_list->disableHtmlConversion();;
        $this->estoque_rua_estoque_deposito_list->generateHiddenFields();
        $this->estoque_rua_estoque_deposito_list->setId('estoque_rua_estoque_deposito_list');

        $this->estoque_rua_estoque_deposito_list->style = 'width:100%';
        $this->estoque_rua_estoque_deposito_list->class .= ' table-bordered';

        $column_estoque_rua_estoque_deposito_id = new TDataGridColumn('id', "Id", 'center' , '70px');
        $column_estoque_rua_estoque_deposito_descricao = new TDataGridColumn('descricao', "Descrição", 'left');
        $column_estoque_rua_estoque_deposito_criado_em_transformed = new TDataGridColumn('criado_em', "Criado Em", 'left');
        $column_estoque_rua_estoque_deposito_criado_por = new TDataGridColumn('criado_por', "Criado Por", 'left');

        $column_estoque_rua_estoque_deposito__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_estoque_rua_estoque_deposito__row__data->setVisibility(false);

        $action_onEditDetailEstoqueRua = new TDataGridAction(array('EstoqueDepositoForm', 'onEditDetailEstoqueRua'));
        $action_onEditDetailEstoqueRua->setUseButton(true);
        $action_onEditDetailEstoqueRua->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailEstoqueRua->setLabel("Editar");
        $action_onEditDetailEstoqueRua->setImage('far:edit #478fca');
        $action_onEditDetailEstoqueRua->setFields(['__row__id', '__row__data']);

        $this->estoque_rua_estoque_deposito_list->addAction($action_onEditDetailEstoqueRua);
        $action_onDeleteDetailEstoqueRua = new TDataGridAction(array('EstoqueDepositoForm', 'onDeleteDetailEstoqueRua'));
        $action_onDeleteDetailEstoqueRua->setUseButton(true);
        $action_onDeleteDetailEstoqueRua->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailEstoqueRua->setLabel("Excluir");
        $action_onDeleteDetailEstoqueRua->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailEstoqueRua->setFields(['__row__id', '__row__data']);

        $this->estoque_rua_estoque_deposito_list->addAction($action_onDeleteDetailEstoqueRua);
        $action_onEstantes = new TDataGridAction(array('EstoqueDepositoForm', 'onEstantes'));
        $action_onEstantes->setUseButton(true);
        $action_onEstantes->setButtonClass('btn btn-default btn-sm');
        $action_onEstantes->setLabel("Estantes");
        $action_onEstantes->setImage('fas:box #9C27B0');
        $action_onEstantes->setFields(['__row__id', '__row__data']);
        $action_onEstantes->setDisplayCondition('EstoqueDepositoForm::onExibeEstantes');

        $this->estoque_rua_estoque_deposito_list->addAction($action_onEstantes);

        $this->estoque_rua_estoque_deposito_list->addColumn($column_estoque_rua_estoque_deposito_id);
        $this->estoque_rua_estoque_deposito_list->addColumn($column_estoque_rua_estoque_deposito_descricao);
        $this->estoque_rua_estoque_deposito_list->addColumn($column_estoque_rua_estoque_deposito_criado_em_transformed);
        $this->estoque_rua_estoque_deposito_list->addColumn($column_estoque_rua_estoque_deposito_criado_por);

        $this->estoque_rua_estoque_deposito_list->addColumn($column_estoque_rua_estoque_deposito__row__data);

        $this->estoque_rua_estoque_deposito_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->estoque_rua_estoque_deposito_list);
        $this->detailFormEstoqueRuaEstoqueDeposito->addContent([$tableResponsiveDiv]);

        $column_estoque_rua_estoque_deposito_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });        $row9 = $this->form->addFields([$this->detailFormEstoqueRuaEstoqueDeposito]);
        $row9->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['EstoqueDepositoHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Estoque","Cadastro de Depósito de Estoque"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailEstoqueRuaEstoqueDeposito($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Descrição", 'name'=>"estoque_rua_estoque_deposito_descricao", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->estoque_rua_estoque_deposito__row__id) ? $data->estoque_rua_estoque_deposito__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new EstoqueRua();
            $grid_data->__row__id = $__row__id;
            $grid_data->descricao = $data->estoque_rua_estoque_deposito_descricao;
            $grid_data->id = $data->estoque_rua_estoque_deposito_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['descricao'] =  $param['estoque_rua_estoque_deposito_descricao'] ?? null;
            $__row__data['__display__']['id'] =  $param['estoque_rua_estoque_deposito_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->estoque_rua_estoque_deposito_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('estoque_rua_estoque_deposito_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->estoque_rua_estoque_deposito_descricao = '';
            $data->estoque_rua_estoque_deposito_id = '';
            $data->estoque_rua_estoque_deposito__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6328b14666dba');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailEstoqueRua($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->estoque_rua_estoque_deposito_descricao = $__row__data->__display__->descricao ?? null;
            $data->estoque_rua_estoque_deposito_id = $__row__data->__display__->id ?? null;
            $data->estoque_rua_estoque_deposito__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6328b14666dba');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailEstoqueRua($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->estoque_rua_estoque_deposito_descricao = '';
            $data->estoque_rua_estoque_deposito_id = '';
            $data->estoque_rua_estoque_deposito__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('estoque_rua_estoque_deposito_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEstantes($param = null) 
    {
        try 
        {

            // echo 'rua id '.$param['id'];

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $pageParam = []; // ex.: = ['key' => 10]

            TSession::setValue('rua_id', $__row__data->__display__->id);

            TApplication::loadPage('EstoqueEstanteFormList', 'OnShow', $pageParam);

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onExibeEstantes($object)
    {
        try 
        {
            if(!$object->id==null)
            {
                return true;
            }

            return false;
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new EstoqueDeposito(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->system_unit_id = TSession::getValue('userunitid');

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $estoque_rua_estoque_deposito_items = $this->storeMasterDetailItems('EstoqueRua', 'estoque_deposito_id', 'estoque_rua_estoque_deposito', $object, $param['estoque_rua_estoque_deposito_list___row__data'] ?? [], $this->form, $this->estoque_rua_estoque_deposito_list, function($masterObject, $detailObject){ 

                //code here

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($detailObject);                

            }, $this->estoque_rua_estoque_deposito_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('EstoqueDepositoHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new EstoqueDeposito($key); // instantiates the Active Record 

                $estoque_rua_estoque_deposito_items = $this->loadMasterDetailItems('EstoqueRua', 'estoque_deposito_id', 'estoque_rua_estoque_deposito', $object, $this->form, $this->estoque_rua_estoque_deposito_list, $this->estoque_rua_estoque_deposito_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

