<?php

class ProdutoLoteForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ProdutoLote';
    private static $primaryKey = 'id';
    private static $formName = 'form_ProdutoLoteForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de lote de produto");


        $id = new TEntry('id');
        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc'  );
        $numero = new TEntry('numero');
        $validade = new TDate('validade');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $produto_id->addValidation("Produto", new TRequiredValidator()); 
        $numero->addValidation("Número", new TRequiredValidator()); 

        $produto_id->enableSearch();
        $validade->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $validade->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $numero->setSize('100%');
        $validade->setSize('100%');
        $criado_em->setSize('100%');
        $produto_id->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');

        // $idproduto = TSession::getValue('estoque_lancamento_form_produto_id');

        // if ($idproduto<>0)
        // {
        //     $produto_id->setEditable(false);
        // }

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$produto_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Número:", '#ff0000', '14px', null, '100%'),$numero],[new TLabel("Validade:", null, '14px', null, '100%'),$validade]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_632f60a57cd09 = new BContainer('bcontainer_632f60a57cd09');
        $this->bcontainer_632f60a57cd09 = $bcontainer_632f60a57cd09;

        $bcontainer_632f60a57cd09->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_632f60a57cd09->setBorderColor('#c0c0c0');

        $row3 = $bcontainer_632f60a57cd09->addFields([new TLabel("Criado em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null),$criado_por],[new TLabel("Alterado em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null),$alterado_por]);
        $row3->layout = ['col-sm-2','col-sm-4','col-sm-2','col-sm-4'];

        $row4 = $this->form->addFields([$bcontainer_632f60a57cd09]);
        $row4->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ProdutoLoteList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        // if ($idproduto<>0)
        // {
        //     TScript::create('document.getElementById("tbutton_btn_limpar_formulário").style.display = "none";');

        //     //$btn_onshow = $this->form->addAction("Voltar", new TAction([$this, 'closeCurtain.onclick()']), 'fas:arrow-left #000000');
        //     // $this->btn_onshow = $btn_onshow;            

        //     TScript::create('document.getElementById("tbutton_btn_voltar").style.display = "none";');            
        // }

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ProdutoLoteForm]');
        $style->width = '80% !important';   
        $style->show(true);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ProdutoLote(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ProdutoLoteList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ProdutoLote($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        // $idproduto = TSession::getValue('estoque_lancamento_form_produto_id');

        // if ($idproduto<>0)
        // {
        //     $object = new stdClass();
        //     $object->produto_id = $idproduto;
        //     TForm::sendData(self::$formName, $object);       

        //     //TDBCombo::disableField(self::$formName, 'produto_id');
        // }

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

