<?php

class CondicaoPagamentoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'CondicaoPagamento';
    private static $primaryKey = 'id';
    private static $formName = 'form_CondicaoPagamentoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de condição de pagamento");


        $id = new TEntry('id');
        $descricao = new TEntry('descricao');
        $numero_parcelas = new TEntry('numero_parcelas');
        $dias_primeira_parcelas = new TEntry('dias_primeira_parcelas');
        $dias_entre_parcelas = new TEntry('dias_entre_parcelas');
        $taxa = new TNumeric('taxa', '2', ',', '.' );
        $formapgto_condpgto_condicao_pagamento_forma_pagamento_id = new TDBCombo('formapgto_condpgto_condicao_pagamento_forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $formapgto_condpgto_condicao_pagamento_id = new THidden('formapgto_condpgto_condicao_pagamento_id');
        $button_adicionar_formapgto_condpgto_condicao_pagamento = new TButton('button_adicionar_formapgto_condpgto_condicao_pagamento');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $descricao->addValidation("Descrição", new TRequiredValidator()); 
        $numero_parcelas->addValidation("Número Parcelas", new TRequiredValidator()); 

        $formapgto_condpgto_condicao_pagamento_forma_pagamento_id->enableSearch();
        $button_adicionar_formapgto_condpgto_condicao_pagamento->setAction(new TAction([$this, 'onAddDetailFormapgtoCondpgtoCondicaoPagamento'],['static' => 1]), "Adicionar");
        $button_adicionar_formapgto_condpgto_condicao_pagamento->addStyleClass('btn-default');
        $button_adicionar_formapgto_condpgto_condicao_pagamento->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $taxa->setSize('100%');
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $numero_parcelas->setSize('100%');
        $dias_entre_parcelas->setSize('100%');
        $dias_primeira_parcelas->setSize('100%');
        $formapgto_condpgto_condicao_pagamento_id->setSize(200);
        $formapgto_condpgto_condicao_pagamento_forma_pagamento_id->setSize('100%');

        $button_adicionar_formapgto_condpgto_condicao_pagamento->id = '63fe020b58dd2';

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Número Parcelas:", '#ff0000', '14px', null, '100%'),$numero_parcelas],[new TLabel("Dias primeira parcela:", null, '14px', null, '100%'),$dias_primeira_parcelas]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Dias entre parcelas:", null, '14px', null, '100%'),$dias_entre_parcelas],[new TLabel("Taxa Financeira:", null, '14px', null, '100%'),$taxa]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $this->detailFormFormapgtoCondpgtoCondicaoPagamento = new BootstrapFormBuilder('detailFormFormapgtoCondpgtoCondicaoPagamento');
        $this->detailFormFormapgtoCondpgtoCondicaoPagamento->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormFormapgtoCondpgtoCondicaoPagamento->setProperty('class', 'form-horizontal builder-detail-form');

        $row4 = $this->detailFormFormapgtoCondpgtoCondicaoPagamento->addFields([new TFormSeparator("Forma de pagamento desta condição", '#333', '18', '#eee')]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->detailFormFormapgtoCondpgtoCondicaoPagamento->addFields([new TLabel("Forma pagamento:", '#ff0000', '14px', null, '100%'),$formapgto_condpgto_condicao_pagamento_forma_pagamento_id,$formapgto_condpgto_condicao_pagamento_id],[]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->detailFormFormapgtoCondpgtoCondicaoPagamento->addFields([$button_adicionar_formapgto_condpgto_condicao_pagamento]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->detailFormFormapgtoCondpgtoCondicaoPagamento->addFields([new THidden('formapgto_condpgto_condicao_pagamento__row__id')]);
        $this->formapgto_condpgto_condicao_pagamento_criteria = new TCriteria();

        $this->formapgto_condpgto_condicao_pagamento_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->formapgto_condpgto_condicao_pagamento_list->disableHtmlConversion();;
        $this->formapgto_condpgto_condicao_pagamento_list->generateHiddenFields();
        $this->formapgto_condpgto_condicao_pagamento_list->setId('formapgto_condpgto_condicao_pagamento_list');

        $this->formapgto_condpgto_condicao_pagamento_list->style = 'width:100%';
        $this->formapgto_condpgto_condicao_pagamento_list->class .= ' table-bordered';

        $column_formapgto_condpgto_condicao_pagamento_forma_pagamento_descricao = new TDataGridColumn('forma_pagamento->descricao', "Forma pagamento id", 'left');

        $column_formapgto_condpgto_condicao_pagamento__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_formapgto_condpgto_condicao_pagamento__row__data->setVisibility(false);

        $action_onEditDetailFormapgtoCondpgto = new TDataGridAction(array('CondicaoPagamentoForm', 'onEditDetailFormapgtoCondpgto'));
        $action_onEditDetailFormapgtoCondpgto->setUseButton(false);
        $action_onEditDetailFormapgtoCondpgto->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailFormapgtoCondpgto->setLabel("Editar");
        $action_onEditDetailFormapgtoCondpgto->setImage('far:edit #478fca');
        $action_onEditDetailFormapgtoCondpgto->setFields(['__row__id', '__row__data']);

        $this->formapgto_condpgto_condicao_pagamento_list->addAction($action_onEditDetailFormapgtoCondpgto);
        $action_onDeleteDetailFormapgtoCondpgto = new TDataGridAction(array('CondicaoPagamentoForm', 'onDeleteDetailFormapgtoCondpgto'));
        $action_onDeleteDetailFormapgtoCondpgto->setUseButton(false);
        $action_onDeleteDetailFormapgtoCondpgto->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailFormapgtoCondpgto->setLabel("Excluir");
        $action_onDeleteDetailFormapgtoCondpgto->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailFormapgtoCondpgto->setFields(['__row__id', '__row__data']);

        $this->formapgto_condpgto_condicao_pagamento_list->addAction($action_onDeleteDetailFormapgtoCondpgto);

        $this->formapgto_condpgto_condicao_pagamento_list->addColumn($column_formapgto_condpgto_condicao_pagamento_forma_pagamento_descricao);

        $this->formapgto_condpgto_condicao_pagamento_list->addColumn($column_formapgto_condpgto_condicao_pagamento__row__data);

        $this->formapgto_condpgto_condicao_pagamento_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->formapgto_condpgto_condicao_pagamento_list);
        $this->detailFormFormapgtoCondpgtoCondicaoPagamento->addContent([$tableResponsiveDiv]);
        $row8 = $this->form->addFields([$this->detailFormFormapgtoCondpgtoCondicaoPagamento]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row10->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['CondicaoPagamentoHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Financeiro","Cadastro de condição de pagamento"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailFormapgtoCondpgtoCondicaoPagamento($param = null) 
    {
        try
        {
            $data = $this->form->getData();

                $errors = [];
                $requiredFields = [];
                $requiredFields[] = ['label'=>"Forma pagamento id", 'name'=>"formapgto_condpgto_condicao_pagamento_forma_pagamento_id", 'class'=>'TRequiredValidator', 'value'=>[]];
                foreach($requiredFields as $requiredField)
                {
                    try
                    {
                        (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                    }
                    catch(Exception $e)
                    {
                        $errors[] = $e->getMessage() . '.';
                    }
                 }
                 if(count($errors) > 0)
                 {
                     throw new Exception(implode('<br>', $errors));
                 }

                $__row__id = !empty($data->formapgto_condpgto_condicao_pagamento__row__id) ? $data->formapgto_condpgto_condicao_pagamento__row__id : 'b'.uniqid();

                TTransaction::open(self::$database);

                $grid_data = new FormapgtoCondpgto();
                $grid_data->__row__id = $__row__id;
                $grid_data->forma_pagamento_id = $data->formapgto_condpgto_condicao_pagamento_forma_pagamento_id;
                $grid_data->id = $data->formapgto_condpgto_condicao_pagamento_id;

                $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
                $__row__data['__row__id'] = $__row__id;
                $__row__data['__display__']['forma_pagamento_id'] =  $param['formapgto_condpgto_condicao_pagamento_forma_pagamento_id'] ?? null;
                $__row__data['__display__']['id'] =  $param['formapgto_condpgto_condicao_pagamento_id'] ?? null;

                $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
                $row = $this->formapgto_condpgto_condicao_pagamento_list->addItem($grid_data);
                $row->id = $grid_data->__row__id;

                TDataGrid::replaceRowById('formapgto_condpgto_condicao_pagamento_list', $grid_data->__row__id, $row);

                TTransaction::close();

                $data = new stdClass;
                $data->formapgto_condpgto_condicao_pagamento_forma_pagamento_id = '';
                $data->formapgto_condpgto_condicao_pagamento_id = '';
                $data->formapgto_condpgto_condicao_pagamento__row__id = '';

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#63fe020b58dd2');
                   if(typeof element.attr('add') != 'undefined')
                   {
                       element.html(base64_decode(element.attr('add')));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailFormapgtoCondpgto($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));
                $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

                $data = new stdClass;
                $data->formapgto_condpgto_condicao_pagamento_forma_pagamento_id = $__row__data->__display__->forma_pagamento_id ?? null;
                $data->formapgto_condpgto_condicao_pagamento_id = $__row__data->__display__->id ?? null;
                $data->formapgto_condpgto_condicao_pagamento__row__id = $__row__data->__row__id;

                TForm::sendData(self::$formName, $data);
                TScript::create("
                   var element = $('#63fe020b58dd2');
                   if(!element.attr('add')){
                       element.attr('add', base64_encode(element.html()));
                   }
                   element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
                   if(!element.attr('edit')){
                       element.attr('edit', base64_encode(element.html()));
                   }
                ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onDeleteDetailFormapgtoCondpgto($param = null) 
    {
        try
        {

                $__row__data = unserialize(base64_decode($param['__row__data']));

                $data = new stdClass;
                $data->formapgto_condpgto_condicao_pagamento_forma_pagamento_id = '';
                $data->formapgto_condpgto_condicao_pagamento_id = '';
                $data->formapgto_condpgto_condicao_pagamento__row__id = '';

                TForm::sendData(self::$formName, $data);

                TDataGrid::removeRowById('formapgto_condpgto_condicao_pagamento_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new CondicaoPagamento(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $formapgto_condpgto_condicao_pagamento_items = $this->storeMasterDetailItems('FormapgtoCondpgto', 'condicao_pagamento_id', 'formapgto_condpgto_condicao_pagamento', $object, $param['formapgto_condpgto_condicao_pagamento_list___row__data'] ?? [], $this->form, $this->formapgto_condpgto_condicao_pagamento_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->formapgto_condpgto_condicao_pagamento_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('CondicaoPagamentoHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new CondicaoPagamento($key); // instantiates the Active Record 

                $formapgto_condpgto_condicao_pagamento_items = $this->loadMasterDetailItems('FormapgtoCondpgto', 'condicao_pagamento_id', 'formapgto_condpgto_condicao_pagamento', $object, $this->form, $this->formapgto_condpgto_condicao_pagamento_list, $this->formapgto_condpgto_condicao_pagamento_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

