<?php

class ContaCorrenteForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ContaCorrente';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContaCorrenteForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de conta corrente");


        $id = new TEntry('id');
        $banco_id = new TDBCombo('banco_id', 'kraftsoft', 'Banco', 'id', '{nome}','nome asc'  );
        $nome = new TEntry('nome');
        $agencia = new TEntry('agencia');
        $agencia_digito = new TEntry('agencia_digito');
        $conta = new TEntry('conta');
        $conta_digito = new TEntry('conta_digito');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $end_logradouro = new TEntry('end_logradouro');
        $end_numero = new TEntry('end_numero');
        $end_bairro = new TEntry('end_bairro');
        $end_cidade = new TEntry('end_cidade');
        $end_estado = new TEntry('end_estado');
        $end_cep = new TEntry('end_cep');
        $boleto_gerar = new TRadioGroup('boleto_gerar');
        $boleto_carteira = new TEntry('boleto_carteira');
        $boleto_convenio = new TEntry('boleto_convenio');
        $boleto_instrucoes = new TEntry('boleto_instrucoes');
        $boleto_codigo_cedente = new TEntry('boleto_codigo_cedente');
        $boleto_digito_cod_cedente = new TEntry('boleto_digito_cod_cedente');
        $boleto_multa = new TNumeric('boleto_multa', '2', ',', '.' );
        $boleto_juros_dia = new TNumeric('boleto_juros_dia', '2', ',', '.' );
        $boleto_digitos_nosso_numero = new TEntry('boleto_digitos_nosso_numero');
        $boleto_codigo_transmissao = new TEntry('boleto_codigo_transmissao');
        $boleto_local_pagamento = new TEntry('boleto_local_pagamento');

        $nome->addValidation("Nome", new TRequiredValidator()); 
        $boleto_gerar->addValidation("Gerar Boleto", new TRequiredValidator()); 

        $banco_id->enableSearch();
        $boleto_gerar->addItems(["1"=>"Sim","2"=>"Não"]);
        $boleto_gerar->setLayout('horizontal');
        $boleto_gerar->setBooleanMode();
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $nome->setSize('100%');
        $conta->setSize('100%');
        $agencia->setSize('100%');
        $end_cep->setSize('100%');
        $banco_id->setSize('100%');
        $boleto_gerar->setSize(80);
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $end_numero->setSize('100%');
        $end_bairro->setSize('100%');
        $end_cidade->setSize('100%');
        $end_estado->setSize('100%');
        $alterado_em->setSize('100%');
        $conta_digito->setSize('100%');
        $alterado_por->setSize('100%');
        $boleto_multa->setSize('100%');
        $agencia_digito->setSize('100%');
        $end_logradouro->setSize('100%');
        $boleto_carteira->setSize('100%');
        $boleto_convenio->setSize('100%');
        $boleto_juros_dia->setSize('100%');
        $boleto_instrucoes->setSize('100%');
        $boleto_codigo_cedente->setSize('100%');
        $boleto_local_pagamento->setSize('100%');
        $boleto_digito_cod_cedente->setSize('100%');
        $boleto_codigo_transmissao->setSize('100%');
        $boleto_digitos_nosso_numero->setSize('100%');


        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id]);
        $row1->layout = ['col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Banco:", null, '14px', null, '100%'),$banco_id],[new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Agência:", null, '14px', null, '100%'),$agencia],[new TLabel("Digito Agência:", null, '14px', null, '100%'),$agencia_digito]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Conta:", null, '14px', null, '100%'),$conta],[new TLabel("Digito Conta:", null, '14px', null, '100%'),$conta_digito]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_63420e4be6f53 = new BContainer('bcontainer_63420e4be6f53');
        $this->bcontainer_63420e4be6f53 = $bcontainer_63420e4be6f53;

        $bcontainer_63420e4be6f53->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_63420e4be6f53->setBorderColor('#c0c0c0');

        $row5 = $bcontainer_63420e4be6f53->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row5->layout = ['col-sm-2',' col-sm-4','col-sm-2',' col-sm-4'];

        $row6 = $this->form->addFields([$bcontainer_63420e4be6f53]);
        $row6->layout = [' col-sm-12'];

        $this->form->appendPage("Endereço");
        $row7 = $this->form->addFields([new TLabel("Logradouro:", null, '14px', null, '100%'),$end_logradouro],[new TLabel("Número:", null, '14px', null, '100%'),$end_numero]);
        $row7->layout = ['col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Bairro:", null, '14px', null, '100%'),$end_bairro],[new TLabel("Cidade:", null, '14px', null, '100%'),$end_cidade]);
        $row8->layout = ['col-sm-6','col-sm-6'];

        $row9 = $this->form->addFields([new TLabel("Estado:", null, '14px', null, '100%'),$end_estado],[new TLabel("CEP:", null, '14px', null, '100%'),$end_cep]);
        $row9->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("Boletos");
        $row10 = $this->form->addFields([new TLabel("Gerar Boleto:", '#ff0000', '14px', null, '100%'),$boleto_gerar],[new TLabel("Carteira:", null, '14px', null, '100%'),$boleto_carteira]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->form->addFields([new TLabel("Convenio:", null, '14px', null, '100%'),$boleto_convenio],[new TLabel("Instruções:", null, '14px', null, '100%'),$boleto_instrucoes]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->form->addFields([new TLabel("Código Cedente:", null, '14px', null, '100%'),$boleto_codigo_cedente],[new TLabel("Digito Codigo Cedente:", null, '14px', null, '100%'),$boleto_digito_cod_cedente]);
        $row12->layout = ['col-sm-6','col-sm-6'];

        $row13 = $this->form->addFields([new TLabel("Multa:", null, '14px', null, '100%'),$boleto_multa],[new TLabel("Juros ao dia:", null, '14px', null, '100%'),$boleto_juros_dia]);
        $row13->layout = ['col-sm-6','col-sm-6'];

        $row14 = $this->form->addFields([new TLabel("Qtd dígitos nosso número:", null, '14px', null, '100%'),$boleto_digitos_nosso_numero],[new TLabel("Código de transmissão:", null, '14px', null, '100%'),$boleto_codigo_transmissao]);
        $row14->layout = ['col-sm-6','col-sm-6'];

        $row15 = $this->form->addFields([new TLabel("Local de pagamento:", null, '14px', null, '100%'),$boleto_local_pagamento]);
        $row15->layout = ['col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ContaCorrenteHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Financeiro","Cadastro de conta corrente"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ContaCorrente(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->system_unit_id = TSession::getValue('userunitid');

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContaCorrenteHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ContaCorrente($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

