<?php

class ContaCorrenteLancamentosForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ContaCorrenteLancamentos';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContaCorrenteLancamentosForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Lançamento em conta corrente");

        $criteria_conta_corrente_id = new TCriteria();
        $criteria_plano_conta_id = new TCriteria();
        $criteria_centro_custo_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_conta_corrente_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_plano_conta_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_centro_custo_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $id = new TEntry('id');
        $conta_corrente_lanc_origem_id = new THidden('conta_corrente_lanc_origem_id');
        $documento = new TEntry('documento');
        $conta_corrente_id = new TDBCombo('conta_corrente_id', 'kraftsoft', 'ContaCorrente', 'id', '{nome}','nome asc' , $criteria_conta_corrente_id );
        $conta_corrente_lanc_tipo_id = new TDBCombo('conta_corrente_lanc_tipo_id', 'kraftsoft', 'ContaCorrenteLancTipo', 'id', '{descricao}','descricao asc'  );
        $data_lancamento = new TDate('data_lancamento');
        $valor = new TNumeric('valor', '2', ',', '.' );
        $plano_conta_id = new TDBCombo('plano_conta_id', 'kraftsoft', 'PlanoConta', 'id', '{numero}  - {descricao}','numero asc' , $criteria_plano_conta_id );
        $centro_custo_id = new TDBCombo('centro_custo_id', 'kraftsoft', 'CentroCusto', 'id', '{numero}  - {descricao}','numero asc' , $criteria_centro_custo_id );
        $historico = new TText('historico');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $conta_corrente_id->addValidation("Conta corrente id", new TRequiredValidator()); 
        $conta_corrente_lanc_tipo_id->addValidation("Conta corrente lanc tipo id", new TRequiredValidator()); 
        $data_lancamento->addValidation("Data Lançamento", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 
        $historico->addValidation("Histórico", new TRequiredValidator()); 

        $data_lancamento->setValue(date('d/m/Y'));
        $data_lancamento->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $data_lancamento->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $plano_conta_id->enableSearch();
        $centro_custo_id->enableSearch();
        $conta_corrente_id->enableSearch();
        $conta_corrente_lanc_tipo_id->enableSearch();

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $valor->setSize('100%');
        $documento->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $historico->setSize('100%', 70);
        $plano_conta_id->setSize('100%');
        $data_lancamento->setSize('100%');
        $centro_custo_id->setSize('100%');
        $conta_corrente_id->setSize('100%');
        $conta_corrente_lanc_origem_id->setSize(200);
        $conta_corrente_lanc_tipo_id->setSize('100%');

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id,$conta_corrente_lanc_origem_id],[new TLabel("Documento:", null, '14px', null, '100%'),$documento]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Conta corrente:", '#ff0000', '14px', null, '100%'),$conta_corrente_id],[new TLabel("Tipo Lançamento:", '#ff0000', '14px', null, '100%'),$conta_corrente_lanc_tipo_id]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Data Lançamento:", '#ff0000', '14px', null, '100%'),$data_lancamento],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Plano de conta:", null, '14px', null, '100%'),$plano_conta_id],[new TLabel("Centro de custo:", null, '14px', null, '100%'),$centro_custo_id]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Histórico:", '#FF0000', '14px', null, '100%'),$historico]);
        $row5->layout = [' col-sm-12'];

        $bcontainer_634942b8b4903 = new BContainer('bcontainer_634942b8b4903');
        $this->bcontainer_634942b8b4903 = $bcontainer_634942b8b4903;

        $bcontainer_634942b8b4903->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_634942b8b4903->setBorderColor('#c0c0c0');

        $row6 = $bcontainer_634942b8b4903->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row6->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row7 = $this->form->addFields([$bcontainer_634942b8b4903]);
        $row7->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ContaCorrenteLancamentosList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Financeiro","Cadastro de Lançamento em conta corrente"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ContaCorrenteLancamentos(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            if ($param['plano_conta_id'] != ''
            and $param['centro_custo_id'] == '')
            {
                throw new Exception('Informe o centro de custo!');  
            }

            if ($param['plano_conta_id'] == ''
            and $param['centro_custo_id'] != '')
            {
                throw new Exception('Informe o plano de contas!');  
            }       

            //validando o plano de conta caso esteja preenchido
            if ($param['plano_conta_id'] != ''
            and $param['centro_custo_id'] != '')
            {
                if ($param['conta_corrente_lanc_tipo_id'] == ContaCorrenteLancTipo::Debito)
                {
                   $plano_conta_origem_id = PlanoContaOrigem::Devedora; 
                }
                else
                {
                   $plano_conta_origem_id = PlanoContaOrigem::Credora; 
                }

                ContabilLancamentos::ValidaLancamentoContabil($param['plano_conta_id'],$param['centro_custo_id'],$plano_conta_origem_id);
            }            

            // ContaCorrenteLancamentosForm::ValidaContabil($param);    

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            if ($object->plano_conta_id != null
            and $object->centro_custo_id != null)
            {

                if ($object->conta_corrente_lanc_tipo_id == ContaCorrenteLancTipo::Debito)
                {
                   $contabil_lancamentos_id = ContabilLancamentosTipo::Debito; 
                }
                else
                {
                   $contabil_lancamentos_id = ContabilLancamentosTipo::Credito; 
                }                

                ContabilLancamentos::LancamentoContabil($object->plano_conta_id,
                                                        $object->centro_custo_id,
                                                        $contabil_lancamentos_id,
                                                        ContabilLancamentosSituacao::Liquidado,
                                                        ContabilLancamentosOrigem::ContaCorrente,
                                                        $object->id,
                                                        $object->data_lancamento,
                                                        $object->valor,
                                                        'Ref. Lançam. avulso em conta corrente');     
            }

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Lançamento efetuado com sucesso!", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContaCorrenteLancamentosList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ContaCorrenteLancamentos($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->conta_corrente_lanc_origem_id = ContaCorrenteLancOrigem::Avulso;
        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

    public static function ValidaContabil($param = null) 
    {
        try 
        {

            // if ($param['plano_conta_id'] != ''
            // and $param['centro_custo_id'] == '')
            // {
            //     throw new Exception('Informe o centro de custo!');  
            // }

            // if ($param['plano_conta_id'] == ''
            // and $param['centro_custo_id'] != '')
            // {
            //     throw new Exception('Informe o plano de contas!');  
            // }            

            // //validando o plano de conta caso esteja preenchido
            // if ($param['plano_conta_id'] != ''
            // and $param['centro_custo_id'] != '')
            // {
            //     if ($param['conta_corrente_lanc_tipo_id'] == ContaCorrenteLancTipo::Debito)
            //     {
            //       $plano_conta_origem_id = PlanoContaOrigem::Devedora; 
            //     }
            //     else
            //     {
            //       $plano_conta_origem_id = PlanoContaOrigem::Credora; 
            //     }

            //     ContabilLancamentos::ValidaLancamentoContabil($param['plano_conta_id'],$param['centro_custo_id'],$plano_conta_origem_id);
            // }
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

