<?php

class ContasRecBaixaBlocoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_ContasRecBaixaBlocoForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Baixar Contas a Receber em Bloco");

        $criteria_conta_corrente_id = new TCriteria();
        $criteria_tchecklist_titulos_baixa = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_conta_corrente_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue('ContasrecListbuilder_datagrid_check');
        $criteria_tchecklist_titulos_baixa->add(new TFilter('id', 'in', $filterVar)); 

        $conta_corrente_id = new TDBCombo('conta_corrente_id', 'kraftsoft', 'ContaCorrente', 'id', '{nome}','nome asc' , $criteria_conta_corrente_id );
        $data_pagamento = new TDate('data_pagamento');
        $tchecklist_titulos_baixa = new TCheckList('tchecklist_titulos_baixa');

        $conta_corrente_id->addValidation("Conta Corrente", new TRequiredValidator()); 

        $conta_corrente_id->enableSearch();
        $data_pagamento->setMask('dd/mm/yyyy');
        $data_pagamento->setDatabaseMask('yyyy-mm-dd');
        $data_pagamento->setSize('100%');
        $conta_corrente_id->setSize('100%');

        $data_pagamento->setValue(date('d/m/Y'));
        $tchecklist_titulos_baixa->setValue(TSession::getValue('ContasrecListbuilder_datagrid_check'));

        $tchecklist_titulos_baixa->setIdColumn('id');

        $column_tchecklist_titulos_baixa_id = $tchecklist_titulos_baixa->addColumn('id', "Id", 'left' , '14%');
        $column_tchecklist_titulos_baixa_cliente_nome = $tchecklist_titulos_baixa->addColumn('cliente->nome', "Cliente", 'left' , '30%');
        $column_tchecklist_titulos_baixa_forma_pagamento_descricao = $tchecklist_titulos_baixa->addColumn('forma_pagamento->descricao', "Forma pagamento", 'left' , '14%');
        $column_tchecklist_titulos_baixa_numero_documento = $tchecklist_titulos_baixa->addColumn('numero_documento', "Número Documento", 'left' , '14%');
        $column_tchecklist_titulos_baixa_parcela = $tchecklist_titulos_baixa->addColumn('parcela', "Parcela", 'left' , '14%');
        $column_tchecklist_titulos_baixa_valor_transformed = $tchecklist_titulos_baixa->addColumn('valor', "Valor Título", 'left' , '14%');
        $column_tchecklist_titulos_baixa_valor_aberto_transformed = $tchecklist_titulos_baixa->addColumn('valor_aberto', "Valor Aberto", 'left' , '14%');
        $column_tchecklist_titulos_baixa_data_vencimento_transformed = $tchecklist_titulos_baixa->addColumn('data_vencimento', "Data Vencimento", 'left' , '14%');

        $column_tchecklist_titulos_baixa_valor_transformed->setTransformer(function($value, $object, $row) 
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_tchecklist_titulos_baixa_valor_aberto_transformed->setTransformer(function($value, $object, $row) 
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_tchecklist_titulos_baixa_data_vencimento_transformed->setTransformer(function($value, $object, $row) 
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });        

        $tchecklist_titulos_baixa->setHeight(500);
        $tchecklist_titulos_baixa->makeScrollable();

        $tchecklist_titulos_baixa->fillWith('kraftsoft', 'Contasrec', 'id', 'id asc' , $criteria_tchecklist_titulos_baixa);


        $row1 = $this->form->addFields([new TLabel("Conta Corrente Baixa:", '#FF0000', '14px', null, '100%'),$conta_corrente_id],[new TLabel("Data Pagamento:", '#FF0000', '14px', null, '100%'),$data_pagamento]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([$tchecklist_titulos_baixa]);
        $row2->layout = [' col-sm-12'];

        // create the form actions
        $btn_onconfirmarbaixa = $this->form->addAction("Confirmar Baixa", new TAction([$this, 'onConfirmarBaixa']), 'fas:rocket #ffffff');
        $this->btn_onconfirmarbaixa = $btn_onconfirmarbaixa;
        $btn_onconfirmarbaixa->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ContasRecBaixaBlocoForm]');
        $style->width = '70% !important';   
        $style->show(true);

    }

    public function onConfirmarBaixa($param = null) 
    {
        try
        {

            $this->form->validate(); // validate form data
            $data = $this->form->getData();

            if ($data->tchecklist_titulos_baixa)
            {
               TTransaction::open('kraftsoft');

               foreach($data->tchecklist_titulos_baixa as $contasrec_id)
               {
                  $crec = new ContasRec($contasrec_id);

                  $crecbaixas = new ContasrecBaixas();
                  $crecbaixas->historico = 'Baixa do título Nº '.$crec->id
                                            .', Cliente: '.$crec->cliente->nome;

                  $crecbaixas->desconto = 0;
                  $crecbaixas->juros = 0;
                  $crecbaixas->multa = 0;
                  $crecbaixas->valor = $crec->valor_aberto;
                  $crecbaixas->data_pagamento = $data->data_pagamento;  
                  $crecbaixas->conta_corrente_id = $data->conta_corrente_id;
                  $crecbaixas->contasrec_id = $crec->id;

                  Funcoes::SalvarUsuarioCadastro($crecbaixas);                  
                  $crecbaixas->store();

                  Contasrec::BaixarTitulo($crecbaixas->historico,
                                          $crecbaixas->data_pagamento,
                                          $crecbaixas->desconto,
                                          $crecbaixas->valor,
                                          $crecbaixas->juros,
                                          $crecbaixas->multa,
                                          $crecbaixas->conta_corrente_id,
                                          $crecbaixas->contasrec_id,
                                          $crecbaixas->id);  

                  Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                                     Contasrec::Evento_ContasRecBaixado,
                                                     $crecbaixas,
                                                     'Contas a receber do cliente '.$crecbaixas->contasrec->cliente->nome.' , '.
                                                     'Valor da baixa: R$ '.number_format($crecbaixas->valor,2, ',', '.').' , '.
                                                     'Pagamento: '.TDate::date2br($crecbaixas->data_pagamento));                                           

               }

               TTransaction::close(); 

               TSession::setValue('ContasrecListbuilder_datagrid_check', NULL);
               new TMessage('info', 'Baixa de contas a receber em bloco realizada com sucesso!', new TAction(['ContasrecList', 'onShow']));
            }

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

    } 

}

