<?php

class ContaspagBaixasForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ContaspagBaixas';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContaspagBaixasForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Baixa de Contas a Pagar");

        $criteria_conta_corrente_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_conta_corrente_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $fornecedor = new TEntry('fornecedor');
        $cpag_id = new TEntry('cpag_id');
        $cpag_parcela = new TEntry('cpag_parcela');
        $cpag_numero_documento = new TEntry('cpag_numero_documento');
        $cpag_valor = new TNumeric('cpag_valor', '2', ',', '.' );
        $cpag_vencimento = new TDate('cpag_vencimento');
        $cpag_vencimento_original = new TDate('cpag_vencimento_original');
        $cpag_data_emissao = new TDate('cpag_data_emissao');
        $cpag_data_competencia = new TDate('cpag_data_competencia');
        $cpag_valor_pago = new TNumeric('cpag_valor_pago', '2', ',', '.' );
        $cpag_valor_aberto = new TNumeric('cpag_valor_aberto', '2', ',', '.' );
        $juros = new TNumeric('juros', '2', ',', '.' );
        $multa = new TNumeric('multa', '2', ',', '.' );
        $desconto = new TNumeric('desconto', '2', ',', '.' );
        $data_pagamento = new TDate('data_pagamento');
        $valor = new TNumeric('valor', '2', ',', '.' );
        $conta_corrente_id = new TDBCombo('conta_corrente_id', 'kraftsoft', 'ContaCorrente', 'id', '{nome}','nome asc' , $criteria_conta_corrente_id );
        $historico = new TText('historico');
        $id = new THidden('id');
        $contaspag_id = new THidden('contaspag_id');

        $data_pagamento->addValidation("Data Pagamento", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 
        $conta_corrente_id->addValidation("Conta Corrente", new TRequiredValidator()); 

        $conta_corrente_id->enableSearch();
        $data_pagamento->setValue(date('d/m/Y'));
        $cpag_data_emissao->setValue(date('d/m/Y'));

        $data_pagamento->setMask('dd/mm/yyyy');
        $cpag_vencimento->setMask('dd/mm/yyyy');
        $cpag_data_emissao->setMask('dd/mm/yyyy');
        $cpag_data_competencia->setMask('dd/mm/yyyy');
        $cpag_vencimento_original->setMask('dd/mm/yyyy');

        $data_pagamento->setDatabaseMask('yyyy-mm-dd');
        $cpag_vencimento->setDatabaseMask('yyyy-mm-dd');
        $cpag_data_emissao->setDatabaseMask('yyyy-mm-dd');
        $cpag_data_competencia->setDatabaseMask('yyyy-mm-dd');
        $cpag_vencimento_original->setDatabaseMask('yyyy-mm-dd');

        $cpag_id->setEditable(false);
        $fornecedor->setEditable(false);
        $cpag_valor->setEditable(false);
        $cpag_parcela->setEditable(false);
        $cpag_vencimento->setEditable(false);
        $cpag_valor_pago->setEditable(false);
        $cpag_data_emissao->setEditable(false);
        $cpag_valor_aberto->setEditable(false);
        $cpag_numero_documento->setEditable(false);
        $cpag_data_competencia->setEditable(false);
        $cpag_vencimento_original->setEditable(false);

        $id->setSize(200);
        $juros->setSize('100%');
        $multa->setSize('100%');
        $valor->setSize('100%');
        $cpag_id->setSize('100%');
        $desconto->setSize('100%');
        $contaspag_id->setSize(200);
        $fornecedor->setSize('100%');
        $cpag_valor->setSize('100%');
        $cpag_parcela->setSize('100%');
        $historico->setSize('100%', 70);
        $data_pagamento->setSize('100%');
        $cpag_vencimento->setSize('100%');
        $cpag_valor_pago->setSize('100%');
        $cpag_data_emissao->setSize('100%');
        $cpag_valor_aberto->setSize('100%');
        $conta_corrente_id->setSize('100%');
        $cpag_numero_documento->setSize('100%');
        $cpag_data_competencia->setSize('100%');
        $cpag_vencimento_original->setSize('100%');

        // $cpag_data_emissao->setValue(date("d/m/Y"));

        $bcontainer_634168c744dad = new BContainer('bcontainer_634168c744dad');
        $this->bcontainer_634168c744dad = $bcontainer_634168c744dad;

        $bcontainer_634168c744dad->setTitle("Resumo do Título", '#333', '18px', '', '#fff');
        $bcontainer_634168c744dad->setBorderColor('#c0c0c0');

        $row1 = $bcontainer_634168c744dad->addFields([new TLabel("Fornecedor:", null, '14px', null),$fornecedor]);
        $row1->layout = [' col-sm-12'];

        $row2 = $bcontainer_634168c744dad->addFields([new TLabel("Nº Título:", null, '14px', null),$cpag_id],[new TLabel("Parcela:", null, '14px', null),$cpag_parcela],[new TLabel("N º Documento:", null, '14px', null),$cpag_numero_documento],[new TLabel("Valor:", null, '14px', null),$cpag_valor]);
        $row2->layout = ['col-sm-3','col-sm-3','col-sm-3','col-sm-3'];

        $row3 = $bcontainer_634168c744dad->addFields([new TLabel("Vencimento:", null, '14px', null, '100%'),$cpag_vencimento],[new TLabel("Vencimento Original:", null, '14px', null),$cpag_vencimento_original],[new TLabel("Data Emissão:", null, '14px', null, '100%'),$cpag_data_emissao],[new TLabel("Data Competência:", null, '14px', null),$cpag_data_competencia]);
        $row3->layout = ['col-sm-3','col-sm-3','col-sm-3','col-sm-3'];

        $row4 = $bcontainer_634168c744dad->addFields([new TLabel("Valor Pago:", null, '14px', null),$cpag_valor_pago],[new TLabel("Valor Aberto:", null, '14px', null, '100%'),$cpag_valor_aberto]);
        $row4->layout = ['col-sm-3','col-sm-3'];

        $row5 = $this->form->addFields([$bcontainer_634168c744dad]);
        $row5->layout = ['col-sm-12'];

        $row6 = $this->form->addFields([new TLabel("Juros:", null, '14px', null, '100%'),$juros],[new TLabel("Multa:", null, '14px', null, '100%'),$multa],[new TLabel("Desconto:", null, '14px', null, '100%'),$desconto]);
        $row6->layout = ['col-sm-3','col-sm-3','col-sm-3'];

        $row7 = $this->form->addFields([new TLabel("Data Pagamento:", '#FF0000', '14px', null, '100%'),$data_pagamento],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Conta Corrente:", '#FF0000', '14px', null),$conta_corrente_id]);
        $row7->layout = ['col-sm-3','col-sm-3',' col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Histórico:", null, '14px', null, '100%'),$historico]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addFields([$id,$contaspag_id]);
        $row9->layout = ['col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ContaspagBaixasForm]');
        $style->width = '70% !important';   
        $style->show(true);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ContaspagBaixas(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            Contaspag::BaixarTitulo($object->historico,
                                    $object->data_pagamento,
                                    $object->desconto,
                                    $object->valor,
                                    $object->juros,
                                    $object->multa,
                                    $object->conta_corrente_id,
                                    $object->contaspag_id,
                                    $object->id);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               Contaspag::Evento_ContasPagBaixado,
                                               $object,
                                               'Contas a pagar do fornecedor '.$object->contaspag->fornecedor->nome.' , '.
                                               'Valor da baixa: R$ '.number_format($object->valor,2, ',', '.').' , '.
                                               'Pagamento: '.TDate::date2br($object->data_pagamento)); 

            TTransaction::close();                    

            TToast::show('success', "Baixa realizada com sucesso!", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContaspagList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();"); 

            // //atualizando a tela de consulta..
            // $pageParam = []; // ex.: = ['key' => 10]
            // TApplication::loadPage('ContaspagList', 'onShow', $pageParam);

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ContaspagBaixas($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        TTransaction::open(self::$database);
        $cpag = Contaspag::find($param['key']);

        if ($cpag)
        {

            $object = new stdClass();
            $object->fornecedor                 = $cpag->fornecedor->nome; 
            $object->cpag_id                    = $cpag->id;
            $object->cpag_valor_aberto          = number_format($cpag->valor_aberto, 2, ',', '.');
            $object->cpag_valor_pago            = number_format($cpag->valor_pago, 2, ',', '.');
            $object->cpag_data_competencia      = TDate::date2br($cpag->data_competencia);

            $object->cpag_data_emissao          = TDate::date2br($cpag->data_emissao);
            $object->cpag_vencimento_original   = TDate::date2br($cpag->data_venc_original);
            $object->cpag_vencimento            = TDate::date2br($cpag->data_vencimento);
            $object->cpag_valor                 = number_format($cpag->valor, 2, ',', '.');
            $object->cpag_numero_documento      = $cpag->numero_documento;
            $object->cpag_parcela               = $cpag->parcela;

            //campo THidden
            $object->contaspag_id               = $cpag->id;

            //campos da baixa
            $object->juros                      = '0,00';
            $object->multa                      = '0,00';
            $object->desconto                   = '0,00';
            $object->historico                  = 'Baixa individual do título Nº '.$cpag->id
                                                  .', Fornecedor: '.$cpag->fornecedor->nome;
            $object->valor                      = number_format($cpag->valor_aberto, 2, ',', '.');

            TForm::sendData(self::$formName, $object);
        }

        TTransaction::close();

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

