<?php

class ContaspagBlocoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ContaspagBloco';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContaspagBlocoForm';

    use BuilderMasterDetailTrait;
    use BuilderMasterDetailFieldListTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Geração de Títulos em Bloco");

        $criteria_contaspag_bloco_contabil_contaspag_bloco_plano_conta_id = new TCriteria();
        $criteria_contaspag_bloco_contabil_contaspag_bloco_centro_custo_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_contaspag_bloco_contabil_contaspag_bloco_plano_conta_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_contaspag_bloco_contabil_contaspag_bloco_centro_custo_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $id = new TEntry('id');
        $numero_documento = new TEntry('numero_documento');
        $fornecedor_id = new TDBCombo('fornecedor_id', 'kraftsoft', 'Fornecedor', 'id', '{nome}  - {cpf_cnpj}','nome asc'  );
        $forma_pagamento_id = new TDBCombo('forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $valor = new TNumeric('valor', '2', ',', '.' );
        $primeiro_vencimento = new TDate('primeiro_vencimento');
        $dia_fixo = new TCombo('dia_fixo');
        $tipo_geracao = new TCombo('tipo_geracao');
        $dias_entre_parcelas = new TSpinner('dias_entre_parcelas');
        $quantidade_parcelas = new TSpinner('quantidade_parcelas');
        $button_gerar_parcelas = new TButton('button_gerar_parcelas');
        $observacao = new TText('observacao');
        $contaspag_contaspag_bloco_id = new THidden('contaspag_contaspag_bloco_id[]');
        $contaspag_contaspag_bloco___row__id = new THidden('contaspag_contaspag_bloco___row__id[]');
        $contaspag_contaspag_bloco___row__data = new THidden('contaspag_contaspag_bloco___row__data[]');
        $contaspag_contaspag_bloco_forma_pagamento_id = new TDBCombo('contaspag_contaspag_bloco_forma_pagamento_id[]', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $contaspag_contaspag_bloco_numero_documento = new TEntry('contaspag_contaspag_bloco_numero_documento[]');
        $contaspag_contaspag_bloco_parcela = new TEntry('contaspag_contaspag_bloco_parcela[]');
        $contaspag_contaspag_bloco_data_competencia = new TDate('contaspag_contaspag_bloco_data_competencia[]');
        $contaspag_contaspag_bloco_data_vencimento = new TDate('contaspag_contaspag_bloco_data_vencimento[]');
        $contaspag_contaspag_bloco_valor = new TNumeric('contaspag_contaspag_bloco_valor[]', '2', ',', '.' );
        $this->FieldListParcelas = new TFieldList();
        $contaspag_bloco_contabil_contaspag_bloco_plano_conta_id = new TDBCombo('contaspag_bloco_contabil_contaspag_bloco_plano_conta_id', 'kraftsoft', 'PlanoConta', 'id', '{numero}  - {descricao}','numero asc' , $criteria_contaspag_bloco_contabil_contaspag_bloco_plano_conta_id );
        $contaspag_bloco_contabil_contaspag_bloco_id = new THidden('contaspag_bloco_contabil_contaspag_bloco_id');
        $contaspag_bloco_contabil_contaspag_bloco_centro_custo_id = new TDBCombo('contaspag_bloco_contabil_contaspag_bloco_centro_custo_id', 'kraftsoft', 'CentroCusto', 'id', '{numero}  - {descricao}','numero asc' , $criteria_contaspag_bloco_contabil_contaspag_bloco_centro_custo_id );
        $contaspag_bloco_contabil_contaspag_bloco_valor = new TNumeric('contaspag_bloco_contabil_contaspag_bloco_valor', '2', ',', '.' );
        $button_adicionar_contaspag_bloco_contabil_contaspag_bloco = new TButton('button_adicionar_contaspag_bloco_contabil_contaspag_bloco');

        $this->FieldListParcelas->addField(null, $contaspag_contaspag_bloco_id, []);
        $this->FieldListParcelas->addField(null, $contaspag_contaspag_bloco___row__id, ['uniqid' => true]);
        $this->FieldListParcelas->addField(null, $contaspag_contaspag_bloco___row__data, []);
        $this->FieldListParcelas->addField(new TLabel("Forma de pagamento", null, '14px', null), $contaspag_contaspag_bloco_forma_pagamento_id, ['width' => '30%']);
        $this->FieldListParcelas->addField(new TLabel("Número Documento", null, '14px', null), $contaspag_contaspag_bloco_numero_documento, ['width' => '15%']);
        $this->FieldListParcelas->addField(new TLabel("Parcela", null, '14px', null), $contaspag_contaspag_bloco_parcela, ['width' => '5%']);
        $this->FieldListParcelas->addField(new TLabel("Data Competencia", null, '14px', null), $contaspag_contaspag_bloco_data_competencia, ['width' => '15%']);
        $this->FieldListParcelas->addField(new TLabel("Vencimento", null, '14px', null), $contaspag_contaspag_bloco_data_vencimento, ['width' => '15%']);
        $this->FieldListParcelas->addField(new TLabel("Valor", null, '14px', null), $contaspag_contaspag_bloco_valor, ['width' => '30%']);

        $this->FieldListParcelas->width = '100%';
        $this->FieldListParcelas->setFieldPrefix('contaspag_contaspag_bloco');
        $this->FieldListParcelas->name = 'FieldListParcelas';

        $this->criteria_FieldListParcelas = new TCriteria();
        $this->default_item_FieldListParcelas = new stdClass();

        $this->form->addField($contaspag_contaspag_bloco_id);
        $this->form->addField($contaspag_contaspag_bloco___row__id);
        $this->form->addField($contaspag_contaspag_bloco___row__data);
        $this->form->addField($contaspag_contaspag_bloco_forma_pagamento_id);
        $this->form->addField($contaspag_contaspag_bloco_numero_documento);
        $this->form->addField($contaspag_contaspag_bloco_parcela);
        $this->form->addField($contaspag_contaspag_bloco_data_competencia);
        $this->form->addField($contaspag_contaspag_bloco_data_vencimento);
        $this->form->addField($contaspag_contaspag_bloco_valor);

        $this->FieldListParcelas->setRemoveAction(null, 'fas:times #dd5a43', "Excluír");

        $fornecedor_id->addValidation("Fornecedor id", new TRequiredValidator()); 
        $forma_pagamento_id->addValidation("Forma pagamento id", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 
        $primeiro_vencimento->addValidation("Primeiro Vencimento", new TRequiredValidator()); 
        $tipo_geracao->addValidation("Tipo de geração", new TRequiredValidator()); 
        $dias_entre_parcelas->addValidation("Dias entre parcelas", new TRequiredValidator()); 
        $quantidade_parcelas->addValidation("Quantidade de Parcelas", new TRequiredValidator()); 
        $contaspag_contaspag_bloco_forma_pagamento_id->addValidation("Forma pagamento id", new TRequiredListValidator()); 
        $contaspag_contaspag_bloco_numero_documento->addValidation("Número Documento", new TRequiredListValidator()); 
        $contaspag_contaspag_bloco_valor->addValidation("Valor", new TRequiredListValidator()); 

        $id->setEditable(false);
        $dia_fixo->addItems(["1"=>" Sim","0"=>" Não"]);
        $tipo_geracao->addItems(["valorparcela"=>" Valor da Parcela","valortotal"=>"Valor Total"]);

        $dias_entre_parcelas->setRange(1, 2000, 1);
        $quantidade_parcelas->setRange(1, 2000, 1);

        $button_gerar_parcelas->setAction(new TAction([$this, 'onGerarParcelas']), "Gerar Parcelas");
        $button_adicionar_contaspag_bloco_contabil_contaspag_bloco->setAction(new TAction([$this, 'onAddDetailContaspagBlocoContabilContaspagBloco'],['static' => 1]), "Adicionar");

        $button_gerar_parcelas->addStyleClass('btn-default');
        $button_adicionar_contaspag_bloco_contabil_contaspag_bloco->addStyleClass('btn-default');

        $button_gerar_parcelas->setImage('fas:calendar-alt #4CAF50');
        $button_adicionar_contaspag_bloco_contabil_contaspag_bloco->setImage('fas:plus #2ecc71');

        $primeiro_vencimento->setMask('dd/mm/yyyy');
        $contaspag_contaspag_bloco_data_vencimento->setMask('dd/mm/yyyy');
        $contaspag_contaspag_bloco_data_competencia->setMask('dd/mm/yyyy');

        $primeiro_vencimento->setDatabaseMask('yyyy-mm-dd');
        $contaspag_contaspag_bloco_data_vencimento->setDatabaseMask('yyyy-mm-dd');
        $contaspag_contaspag_bloco_data_competencia->setDatabaseMask('yyyy-mm-dd');

        $dia_fixo->setValue('0');
        $dias_entre_parcelas->setValue('30');
        $tipo_geracao->setValue('valorparcela');

        $dia_fixo->enableSearch();
        $tipo_geracao->enableSearch();
        $fornecedor_id->enableSearch();
        $forma_pagamento_id->enableSearch();
        $contaspag_contaspag_bloco_forma_pagamento_id->enableSearch();
        $contaspag_bloco_contabil_contaspag_bloco_plano_conta_id->enableSearch();
        $contaspag_bloco_contabil_contaspag_bloco_centro_custo_id->enableSearch();

        $id->setSize(100);
        $valor->setSize('100%');
        $dia_fixo->setSize('100%');
        $tipo_geracao->setSize('100%');
        $fornecedor_id->setSize('100%');
        $observacao->setSize('100%', 70);
        $numero_documento->setSize('100%');
        $forma_pagamento_id->setSize('100%');
        $primeiro_vencimento->setSize('100%');
        $dias_entre_parcelas->setSize('100%');
        $quantidade_parcelas->setSize('100%');
        $contaspag_contaspag_bloco_valor->setSize('100%');
        $contaspag_contaspag_bloco_parcela->setSize('100%');
        $contaspag_bloco_contabil_contaspag_bloco_id->setSize(200);
        $contaspag_contaspag_bloco_data_vencimento->setSize('100%');
        $contaspag_contaspag_bloco_numero_documento->setSize('100%');
        $contaspag_contaspag_bloco_data_competencia->setSize('100%');
        $contaspag_contaspag_bloco_forma_pagamento_id->setSize('100%');
        $contaspag_bloco_contabil_contaspag_bloco_valor->setSize('100%');
        $contaspag_bloco_contabil_contaspag_bloco_plano_conta_id->setSize('100%');
        $contaspag_bloco_contabil_contaspag_bloco_centro_custo_id->setSize('100%');

        $button_adicionar_contaspag_bloco_contabil_contaspag_bloco->id = '634499f3fb648';

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Número Documento:", '#FF0000', '14px', null),$numero_documento]);
        $row1->layout = ['col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Fornecedor:", '#ff0000', '14px', null, '100%'),$fornecedor_id],[new TLabel("Forma de pagamento:", '#ff0000', '14px', null, '100%'),$forma_pagamento_id]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Primeiro Vencimento:", '#FF0000', '14px', null, '100%'),$primeiro_vencimento],[new TLabel("Dia Fixo:", '#FF0000', '14px', null, '100%'),$dia_fixo]);
        $row3->layout = ['col-sm-3','col-sm-3','col-sm-2'];

        $row4 = $this->form->addFields([new TLabel("Tipo de Geração:", '#FF0000', '14px', null, '100%'),$tipo_geracao],[new TLabel("Dias entre parcelas:", '#FF0000', '14px', null, '100%'),$dias_entre_parcelas],[new TLabel("Quantidade de Parcelas:", '#ff0000', '14px', null, '100%'),$quantidade_parcelas],[new TLabel(" ", null, '14px', null, '100%'),$button_gerar_parcelas]);
        $row4->layout = ['col-sm-3','col-sm-3','col-sm-3','col-sm-3'];

        $row5 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$observacao]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->form->addContent([new TFormSeparator("Parcelas", '#333', '18', '#eee')]);
        $row7 = $this->form->addFields([$this->FieldListParcelas]);
        $row7->layout = ['col-sm-12'];

        $row8 = $this->form->addContent([new TFormSeparator("Plano de Conta", '#333', '18', '#eee')]);

        $this->detailFormContaspagBlocoContabilContaspagBloco = new BootstrapFormBuilder('detailFormContaspagBlocoContabilContaspagBloco');
        $this->detailFormContaspagBlocoContabilContaspagBloco->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormContaspagBlocoContabilContaspagBloco->setProperty('class', 'form-horizontal builder-detail-form');

        $row9 = $this->detailFormContaspagBlocoContabilContaspagBloco->addFields([new TLabel("Plano de conta:", '#ff0000', '14px', null, '100%'),$contaspag_bloco_contabil_contaspag_bloco_plano_conta_id,$contaspag_bloco_contabil_contaspag_bloco_id],[new TLabel("Centro de custo :", '#ff0000', '14px', null, '100%'),$contaspag_bloco_contabil_contaspag_bloco_centro_custo_id]);
        $row9->layout = ['col-sm-6','col-sm-6'];

        $row10 = $this->detailFormContaspagBlocoContabilContaspagBloco->addFields([new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$contaspag_bloco_contabil_contaspag_bloco_valor],[]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->detailFormContaspagBlocoContabilContaspagBloco->addFields([$button_adicionar_contaspag_bloco_contabil_contaspag_bloco]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->detailFormContaspagBlocoContabilContaspagBloco->addFields([new THidden('contaspag_bloco_contabil_contaspag_bloco__row__id')]);
        $this->contaspag_bloco_contabil_contaspag_bloco_criteria = new TCriteria();

        $this->contaspag_bloco_contabil_contaspag_bloco_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->contaspag_bloco_contabil_contaspag_bloco_list->disableHtmlConversion();;
        $this->contaspag_bloco_contabil_contaspag_bloco_list->generateHiddenFields();
        $this->contaspag_bloco_contabil_contaspag_bloco_list->setId('contaspag_bloco_contabil_contaspag_bloco_list');

        $this->contaspag_bloco_contabil_contaspag_bloco_list->style = 'width:100%';
        $this->contaspag_bloco_contabil_contaspag_bloco_list->class .= ' table-bordered';

        $column_contaspag_bloco_contabil_contaspag_bloco_plano_conta_descricao = new TDataGridColumn('plano_conta->descricao', "Plano de conta", 'left');
        $column_contaspag_bloco_contabil_contaspag_bloco_centro_custo_descricao = new TDataGridColumn('centro_custo->descricao', "Centro de custo", 'left');
        $column_contaspag_bloco_contabil_contaspag_bloco_valor_transformed = new TDataGridColumn('valor', "Valor", 'left');

        $column_contaspag_bloco_contabil_contaspag_bloco__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_contaspag_bloco_contabil_contaspag_bloco__row__data->setVisibility(false);

        $action_onEditDetailContaspagBlocoContabil = new TDataGridAction(array('ContaspagBlocoForm', 'onEditDetailContaspagBlocoContabil'));
        $action_onEditDetailContaspagBlocoContabil->setUseButton(false);
        $action_onEditDetailContaspagBlocoContabil->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailContaspagBlocoContabil->setLabel("Editar");
        $action_onEditDetailContaspagBlocoContabil->setImage('far:edit #478fca');
        $action_onEditDetailContaspagBlocoContabil->setFields(['__row__id', '__row__data']);

        $this->contaspag_bloco_contabil_contaspag_bloco_list->addAction($action_onEditDetailContaspagBlocoContabil);
        $action_onDeleteDetailContaspagBlocoContabil = new TDataGridAction(array('ContaspagBlocoForm', 'onDeleteDetailContaspagBlocoContabil'));
        $action_onDeleteDetailContaspagBlocoContabil->setUseButton(false);
        $action_onDeleteDetailContaspagBlocoContabil->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailContaspagBlocoContabil->setLabel("Excluir");
        $action_onDeleteDetailContaspagBlocoContabil->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailContaspagBlocoContabil->setFields(['__row__id', '__row__data']);

        $this->contaspag_bloco_contabil_contaspag_bloco_list->addAction($action_onDeleteDetailContaspagBlocoContabil);

        $this->contaspag_bloco_contabil_contaspag_bloco_list->addColumn($column_contaspag_bloco_contabil_contaspag_bloco_plano_conta_descricao);
        $this->contaspag_bloco_contabil_contaspag_bloco_list->addColumn($column_contaspag_bloco_contabil_contaspag_bloco_centro_custo_descricao);
        $this->contaspag_bloco_contabil_contaspag_bloco_list->addColumn($column_contaspag_bloco_contabil_contaspag_bloco_valor_transformed);

        $this->contaspag_bloco_contabil_contaspag_bloco_list->addColumn($column_contaspag_bloco_contabil_contaspag_bloco__row__data);

        $this->contaspag_bloco_contabil_contaspag_bloco_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->contaspag_bloco_contabil_contaspag_bloco_list);
        $this->detailFormContaspagBlocoContabilContaspagBloco->addContent([$tableResponsiveDiv]);

        $column_contaspag_bloco_contabil_contaspag_bloco_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row13 = $this->form->addFields([$this->detailFormContaspagBlocoContabilContaspagBloco]);
        $row13->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ContaspagBlocoForm]');
        $style->width = '90% !important';   
        $style->show(true);

    }

    public static function onGerarParcelas($param = null) 
    {
        try 
        {
            // como o método é estático não podemos utilizr o $this
            // temos que trabalhar apenas com o $param onde vem os dados que foram preenchidos pelo usuário
            // nesse caso vamos ter que converter o valor total para double e também a data para o formato americano
            // verificando se os campos foram preenchidos
            (new TRequiredValidator)->validate('Número Documento', $param['numero_documento'] );
            (new TRequiredValidator)->validate('Valor', $param['valor'] );
            (new TRequiredValidator)->validate('Quantidade de Parcelas', $param['quantidade_parcelas']);
            (new TRequiredValidator)->validate('Primeiro vencimento', $param['primeiro_vencimento']);
            (new TRequiredValidator)->validate('Fornecedor', $param['fornecedor_id']);
            (new TRequiredValidator)->validate('Forma de Pagamento', $param['forma_pagamento_id']);
            (new TRequiredValidator)->validate('Tipo de geração', $param['tipo_geracao']);
            (new TRequiredValidator)->validate('Dias entre parcelas', $param['dias_entre_parcelas']);

            // convertendo o valor que vem no formato brasileiro para formato americano
            $valor = (double) str_replace(',', '.', str_replace('.', '', $param['valor']));

            // convertendo a data para o farmato americano
            $primeiro_vencimento = TDate::date2us($param['primeiro_vencimento']);
            $parcelas = $param['quantidade_parcelas'];
            $tipo_geracao = $param['tipo_geracao'];
            $dias_entre_parcelas = $param['dias_entre_parcelas'];
            $dia_fixo = $param['dia_fixo'];

            // calcula o valor da parcela
            if ($tipo_geracao=='valortotal')
            {
                $valorParcela = $valor / $parcelas;
            }
            else
            {
                $valorParcela = $valor;
            }

            // transforma a data de vencimento em um objeto da classe DateTime
            $data_vencimento = new DateTime($primeiro_vencimento);

            // Extrai o dia do $primeiro_vencimento
            $dia_primeiro_vencimento = (int) date('d', strtotime($primeiro_vencimento));            

            $data = new stdClass();
            $data->contaspag_contaspag_bloco_forma_pagamento_id = [];
            $data->contaspag_contaspag_bloco_numero_documento = [];
            $data->contaspag_contaspag_bloco_parcela = [];
            $data->contaspag_contaspag_bloco_data_competencia = [];
            $data->contaspag_contaspag_bloco_data_vencimento = [];
            $data->contaspag_contaspag_bloco_valor = [];

            for($i = 0 ; $i < $parcelas; $i++)
            {
                // populando o array das propriedades do fieldlist

                // Define o dia da data de vencimento como o mínimo entre o dia do $primeiro_vencimento e o último dia do mês
                $ultimoDiaDoMes = $data_vencimento->format('t');
                $diaParaDefinir = min($dia_primeiro_vencimento, $ultimoDiaDoMes);                

                // Verifica se $dia_fixo é igual a 1
                if ($dia_fixo == 1) {
                    $data_vencimento->setDate(
                        $data_vencimento->format('Y'),
                        $data_vencimento->format('m'),
                        $diaParaDefinir
                    );
                }                

                $data->contaspag_contaspag_bloco_forma_pagamento_id[] = $param['forma_pagamento_id'];
                $data->contaspag_contaspag_bloco_numero_documento[] = $param['numero_documento'];
                $data->contaspag_contaspag_bloco_parcela[] = ($i+1).'/'.$parcelas;
                $data->contaspag_contaspag_bloco_data_competencia[] = $data_vencimento->format('d/m/Y');
                $data->contaspag_contaspag_bloco_data_vencimento[] = $data_vencimento->format('d/m/Y');
                $data->contaspag_contaspag_bloco_valor[] = number_format($valorParcela, 2, ',','.');                

                // acrescenta um mês a data de vencimento
                // $data_vencimento->modify( 'next month' );
                // $data_vencimento->modify( '+ '.$dias_entre_parcelas.' days' );

                // acrescenta um mês ou dias a data de vencimento
                if ($dia_fixo != 1) {
                    $data_vencimento->modify('next month');
                } else {
                    $data_vencimento->modify('+' . $dias_entre_parcelas . ' days');
                }                

            }

            // limpa o TFieldList
            // o primeiro parâmetro é o nome da variável definida para o TFieldList
            TFieldList::clearRows('FieldListParcelas');

            // adicionamos as linhas novas
            // primeiro parâmetro é o nome da variável definida para o TFieldList
            TFieldList::addRows('FieldListParcelas', $parcelas - 1, 1);

            // enviando os dados para o field list
            //TForm::sendData(self::$formName, $data);
            TForm::sendData(self::$formName, $data, false, true, 500);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailContaspagBlocoContabilContaspagBloco($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            //não deixar incluir plano de conta ou centro de custo SINTETICO, apenas ANALITICO...
            $plano_conta_id = $param['contaspag_bloco_contabil_contaspag_bloco_plano_conta_id'];
            $centro_custo_id = $param['contaspag_bloco_contabil_contaspag_bloco_centro_custo_id'];

            ContabilLancamentos::ValidaLancamentoContabil($plano_conta_id,$centro_custo_id,PlanoContaOrigem::Devedora);

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Plano conta id", 'name'=>"contaspag_bloco_contabil_contaspag_bloco_plano_conta_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Centro custo id", 'name'=>"contaspag_bloco_contabil_contaspag_bloco_centro_custo_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor", 'name'=>"contaspag_bloco_contabil_contaspag_bloco_valor", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->contaspag_bloco_contabil_contaspag_bloco__row__id) ? $data->contaspag_bloco_contabil_contaspag_bloco__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ContaspagBlocoContabil();
            $grid_data->__row__id = $__row__id;
            $grid_data->plano_conta_id = $data->contaspag_bloco_contabil_contaspag_bloco_plano_conta_id;
            $grid_data->id = $data->contaspag_bloco_contabil_contaspag_bloco_id;
            $grid_data->centro_custo_id = $data->contaspag_bloco_contabil_contaspag_bloco_centro_custo_id;
            $grid_data->valor = $data->contaspag_bloco_contabil_contaspag_bloco_valor;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['plano_conta_id'] =  $param['contaspag_bloco_contabil_contaspag_bloco_plano_conta_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['contaspag_bloco_contabil_contaspag_bloco_id'] ?? null;
            $__row__data['__display__']['centro_custo_id'] =  $param['contaspag_bloco_contabil_contaspag_bloco_centro_custo_id'] ?? null;
            $__row__data['__display__']['valor'] =  $param['contaspag_bloco_contabil_contaspag_bloco_valor'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->contaspag_bloco_contabil_contaspag_bloco_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('contaspag_bloco_contabil_contaspag_bloco_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->contaspag_bloco_contabil_contaspag_bloco_plano_conta_id = '';
            $data->contaspag_bloco_contabil_contaspag_bloco_id = '';
            $data->contaspag_bloco_contabil_contaspag_bloco_centro_custo_id = '';
            $data->contaspag_bloco_contabil_contaspag_bloco_valor = '';
            $data->contaspag_bloco_contabil_contaspag_bloco__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#634499f3fb648');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailContaspagBlocoContabil($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->contaspag_bloco_contabil_contaspag_bloco_plano_conta_id = $__row__data->__display__->plano_conta_id ?? null;
            $data->contaspag_bloco_contabil_contaspag_bloco_id = $__row__data->__display__->id ?? null;
            $data->contaspag_bloco_contabil_contaspag_bloco_centro_custo_id = $__row__data->__display__->centro_custo_id ?? null;
            $data->contaspag_bloco_contabil_contaspag_bloco_valor = $__row__data->__display__->valor ?? null;
            $data->contaspag_bloco_contabil_contaspag_bloco__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#634499f3fb648');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailContaspagBlocoContabil($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->contaspag_bloco_contabil_contaspag_bloco_plano_conta_id = '';
            $data->contaspag_bloco_contabil_contaspag_bloco_id = '';
            $data->contaspag_bloco_contabil_contaspag_bloco_centro_custo_id = '';
            $data->contaspag_bloco_contabil_contaspag_bloco_valor = '';
            $data->contaspag_bloco_contabil_contaspag_bloco__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('contaspag_bloco_contabil_contaspag_bloco_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ContaspagBloco(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->system_unit_id = TSession::getValue('userunitid');
            $object->contaspag_origem_id = ContaspagOrigem::Avulso;

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $contaspag_bloco_contabil_contaspag_bloco_items = $this->storeMasterDetailItems('ContaspagBlocoContabil', 'contaspag_bloco_id', 'contaspag_bloco_contabil_contaspag_bloco', $object, $param['contaspag_bloco_contabil_contaspag_bloco_list___row__data'] ?? [], $this->form, $this->contaspag_bloco_contabil_contaspag_bloco_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->contaspag_bloco_contabil_contaspag_bloco_criteria); 

            $contaspag_contaspag_bloco_items = $this->storeItems('Contaspag', 'contaspag_bloco_id', $object, $this->FieldListParcelas, function($masterObject, $detailObject){ 

                //complementando os campos dos contas a pagar

                //salvando o nome do usuario
                Funcoes::SalvarUsuarioCadastro($detailObject);                

                $detailObject->data_emissao = TDate::date2us(date('d/m/Y'));
                $detailObject->fornecedor_id = $masterObject->fornecedor_id;
                $detailObject->forma_pagamento_id = $masterObject->forma_pagamento_id;
                $detailObject->observacao = $masterObject->observacao;
                $detailObject->contaspag_origem_id = ContaspagOrigem::Avulso;
                $detailObject->contaspag_situacao_id = ContaspagSituacao::EmAberto;
                $detailObject->system_unit_id = TSession::getValue('userunitid');
                $detailObject->valor_aberto = $detailObject->valor;
                $detailObject->data_venc_original = $detailObject->data_vencimento;
                $detailObject->desconto = '0,00';
                $detailObject->valor_multa = '0,00';
                $detailObject->juros = '0,00';
                $detailObject->valor_pago = '0,00';      

            }, $this->criteria_FieldListParcelas); 

            //validar a soma dos titulos, tem que bater com o valor do bloco....
           /* $soma_parcelas = (double) Contaspag::where('contaspag_bloco_id', '=',  $object->id)
                                               ->sumby('valor');        

            $soma_parcelas = (double) number_format($soma_parcelas, 2, '.', '');            
            // $valor_total = (double) number_format($object->valor, 2, '.', '');            

            if ($soma_parcelas<>$object->valor) 
            {
                throw new Exception('Total das parcelas não é o mesmo do valor total! Verifique.');
            }
            RETIRADO ESSA VALIDAÇÃO DEPOIS QUE FOI INCLUIDO O TIPO DA GERAÇÃO*/

            //consultar os planos de conta deste bloco...
            $lista_pc_bloco = ContaspagBlocoContabil::where('contaspag_bloco_id', '=', $object->id)->load();            

            //consultar os contas a pagar gerados e incluir os planos de conta...
            $lista_contaspag = Contaspag::where('contaspag_bloco_id', '=', $object->id)->load();

            foreach ($lista_contaspag as $cpag) 
            {
                $idcpag = $cpag->id;

                //historico de vencimento...
                $cpag_hist_venc = new ContaspagHistoricoVenc;
                $cpag_hist_venc->contaspag_id = $idcpag;
                $cpag_hist_venc->vencimento_anterior = null;
                $cpag_hist_venc->vencimento_atual = $cpag->data_vencimento;

                Funcoes::SalvarUsuarioCadastro($cpag_hist_venc);

                $cpag_hist_venc->store();      

                 //incluindo os planos de conta se tiver..
                 if ($lista_pc_bloco)
                 {                    
                    foreach ($lista_pc_bloco as $pc_bloco)
                    {
                        $cpag_contabil = new ContaspagContabil();
                        $cpag_contabil->contaspag_id = $cpag->id;
                        $cpag_contabil->plano_conta_id = $pc_bloco->plano_conta_id;
                        $cpag_contabil->centro_custo_id = $pc_bloco->centro_custo_id;
                        $cpag_contabil->valor = $pc_bloco->valor;
                        $cpag_contabil->criado_por = TSession::getValue('username');
                        $cpag_contabil->store();

                        ContabilLancamentos::LancamentoContabil($pc_bloco->plano_conta_id,
                                                                $pc_bloco->centro_custo_id,
                                                                ContabilLancamentosTipo::Debito,
                                                                ContabilLancamentosSituacao::NaoLiquidado,
                                                                ContabilLancamentosOrigem::ContasPag,
                                                                $cpag_contabil->id,
                                                                $cpag->data_vencimento,
                                                                $pc_bloco->valor,
                                                                'Ref. Débito Forn: '.$cpag->fornecedor->nome);                        
                    }    

                 }
            }                                     

            //validando a soma do plano de contas...
            $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', TSession::getValue('userunitid'))->first();

            if ($config_filial->cpag_usa_plano_contas_id==Resposta::Sim)
            {
                $soma_contabil = (double) ContaspagContabil::where('contaspag_id', '=',  $idcpag)
                                            ->sumby('valor');        

                if ($soma_contabil<>$object->valor) 
                {
                    throw new Exception('Soma do plano de conta e centro de custo não está igual ao valor do título! Verifique.');
                }
            }             

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               Contaspag::Evento_ContasPagIncluidoOuAlterado,
                                               $object,
                                               'Contas a pagar em bloco do fornecedor '.$object->fornecedor->nome.' , '.
                                               'Valor do bloco: R$ '.number_format($object->valor,2, ',', '.').' , '.
                                               'Quantidade de Parcelas: '.$object->quantidade_parcelas); 

            TTransaction::close();                   

            TToast::show('success', "Títulos gerados com sucesso!", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContaspagList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();");
            TForm::sendData(self::$formName, (object)['id' => $object->id]);

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ContaspagBloco($key); // instantiates the Active Record 

                $contaspag_bloco_contabil_contaspag_bloco_items = $this->loadMasterDetailItems('ContaspagBlocoContabil', 'contaspag_bloco_id', 'contaspag_bloco_contabil_contaspag_bloco', $object, $this->form, $this->contaspag_bloco_contabil_contaspag_bloco_list, $this->contaspag_bloco_contabil_contaspag_bloco_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->FieldListParcelas_items = $this->loadItems('Contaspag', 'contaspag_bloco_id', $object, $this->FieldListParcelas, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }, $this->criteria_FieldListParcelas); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $this->FieldListParcelas->addHeader();
        $this->FieldListParcelas->addDetail($this->default_item_FieldListParcelas);

        $this->FieldListParcelas->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    }

    public function onShow($param = null)
    {
        $this->FieldListParcelas->addHeader();
        $this->FieldListParcelas->addDetail($this->default_item_FieldListParcelas);

        $this->FieldListParcelas->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

        # REMOVE O BOTÃO ADICIONAR DO TFieldList
        $this->FieldListParcelas->getFoot()->clearChildren();

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

