<?php

class ContaspagCalendarForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Contaspag';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContaspagCalendarForm';
    private static $startDateField = 'data_vencimento_calendario';
    private static $endDateField = 'data_vencimento_calendario';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::setSize(0.8, null);
        parent::setTitle("Calendário de pagamentos");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Calendário de pagamentos");

        $view = new THidden('view');



        $this->form->addFields([$view]);

        // create the form actions


        parent::add($this->form);

    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
              $key = $param['key'];  // get the parameter $key

              //fechando a janela de cadastro que abre obrigatoriamente..    
              TWindow::closeWindow();

              $pageParam = ['key' => $key]; // ex.: = ['key' => 10]
              TApplication::loadPage('ContaspagFormView', 'OnShow', $pageParam);                

               /*
                TTransaction::open(self::$database); // open a transaction

                $object = new Contaspag($key); // instantiates the Active Record 

                                $object->view = !empty($param['view']) ? $param['view'] : 'agendaWeek'; 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
                */
            }
            // else
            // {
            //     $this->form->clear();
            // }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public function onStartEdit($param)
    {

        $this->form->clear(true);

        $data = new stdClass;
        $data->view = $param['view'] ?? 'agendaWeek'; // calendar view
        $data->contaspag_situacao = new stdClass();
        $data->contaspag_situacao->cor = '#3a87ad';

        if (!empty($param['date']))
        {
            if(strlen($param['date']) == '10')
                $param['date'].= ' 09:00';

            $data->data_vencimento_calendario = str_replace('T', ' ', $param['date']);

            $data_vencimento_calendario = new DateTime($data->data_vencimento_calendario);
            $data_vencimento_calendario->add(new DateInterval('PT1H'));
            $data->data_vencimento_calendario = $data_vencimento_calendario->format('Y-m-d H:i:s');

        }

        $this->form->setData( $data );
    }

    public static function onUpdateEvent($param)
    {
        try
        {
            if (isset($param['id']))
            {
                TTransaction::open(self::$database);

                $class = self::$activeRecord;
                $object = new $class($param['id']);

                $object->data_vencimento_calendario = str_replace('T', ' ', $param['start_time']);
                $object->data_vencimento_calendario   = str_replace('T', ' ', $param['end_time']);

                $object->store();

                // close the transaction
                TTransaction::close();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', '<b>Error</b> ' . $e->getMessage());
            TTransaction::rollback();
        }
    }

    public static function getFormName()
    {
        return self::$formName;
    }

}

