<?php
/**
 * ContaspagCalendarForm Form
 * @author  <your name here>
 */
class ContaspagCalendarFormView extends TPage
{
    private $fc;

    /**
     * Page constructor
     */
    public function __construct($param = null)
    {
        parent::__construct();

        $this->fc = new TFullCalendar(date('Y-m-d'), 'month');
        $this->fc->enableDays([0,1,2,3,4,5,6]);
        $this->fc->setReloadAction(new TAction(array($this, 'getEvents'), $param));
        $this->fc->setEventClickAction(new TAction(array('ContaspagCalendarForm', 'onEdit')));
        $this->fc->setCurrentView('month');
        $this->fc->setTimeRange('00:00', '23:00');
        $this->fc->enablePopover('Título #{id}', "Fornecedor: {fornecedor->nome}  <br>
Documento: {numero_documento} <br>
Parcela: {parcela} <br>
Valor: {valor_br}  <br>   
------------------------------------<br>
Total a pagar no dia: {valor_dia}");
        $this->fc->setOption('slotTime', "00:30:00");
        $this->fc->setOption('slotDuration', "00:30:00");
        $this->fc->setOption('slotLabelInterval', 30);

        parent::add( $this->fc );
    }

    /**
     * Output events as an json
     */
    public static function getEvents($param=NULL)
    {
        $return = array();
        try
        {
            TTransaction::open('kraftsoft');

            $criteria = new TCriteria(); 

            $criteria->add(new TFilter('data_vencimento_calendario', '<=', substr($param['end'], 0, 10).' 23:59:59'));
            $criteria->add(new TFilter('data_vencimento_calendario', '>=', substr($param['start'], 0, 10).' 00:00:00'));

            $filterVar = ContaspagSituacao::EmAberto;
            $criteria->add(new TFilter('contaspag_situacao_id', '=', $filterVar)); 
            $filterVar = TSession::getValue("userunitid");
            $criteria->add(new TFilter('system_unit_id', '=', $filterVar)); 

            $events = Contaspag::getObjects($criteria);

            if ($events)
            {
                foreach ($events as $event)
                {
                    $event_array = $event->toArray();
                    $event_array['start'] = str_replace( ' ', 'T', $event_array['data_vencimento_calendario']);
                    $event_array['end'] = str_replace( ' ', 'T', $event_array['data_vencimento_calendario']);
                    $event_array['id'] = $event->id;
                    $event_array['color'] = $event->render("{contaspag_situacao->cor}");
                    $event_array['title'] = TFullCalendar::renderPopover($event->render("#{id} - {fornecedor->nome}  <br>
Valor: {valor_br}  <br> "), $event->render("Título #{id}"), $event->render("Fornecedor: {fornecedor->nome}  <br>
Documento: {numero_documento} <br>
Parcela: {parcela} <br>
Valor: {valor_br}  <br>   
------------------------------------<br>
Total a pagar no dia: {valor_dia}"));

                    $return[] = $event_array;
                }
            }
            TTransaction::close();
            echo json_encode($return);
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    /**
     * Reconfigure the callendar
     */
    public function onReload($param = null)
    {
        if (isset($param['view']))
        {
            $this->fc->setCurrentView($param['view']);
        }

        if (isset($param['date']))
        {
            $this->fc->setCurrentDate($param['date']);
        }
    }

}

