<?php

class ContaspagForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Contaspag';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContaspagForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de contas à pagar");

        $criteria_contaspag_contabil_contaspag_plano_conta_id = new TCriteria();
        $criteria_contaspag_contabil_contaspag_centro_custo_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_contaspag_contabil_contaspag_plano_conta_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_contaspag_contabil_contaspag_centro_custo_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $contaspag_situacao_id = new TDBArrowStep('contaspag_situacao_id', 'kraftsoft', 'ContaspagSituacao', 'id', '{descricao}','id asc'  );
        $id = new TEntry('id');
        $data_venc_original = new TDate('data_venc_original');
        $data_pagamento = new TDate('data_pagamento');
        $data_emissao = new TDate('data_emissao');
        $data_vencimento = new TDate('data_vencimento');
        $data_competencia = new TDate('data_competencia');
        $fornecedor_id = new TDBCombo('fornecedor_id', 'kraftsoft', 'Fornecedor', 'id', '{nome}','nome asc'  );
        $forma_pagamento_id = new TDBCombo('forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $contaspag_origem_id = new TDBCombo('contaspag_origem_id', 'kraftsoft', 'ContaspagOrigem', 'id', '{descricao}','descricao asc'  );
        $numero_documento = new TEntry('numero_documento');
        $parcela = new TEntry('parcela');
        $valor = new TNumeric('valor', '2', ',', '.' );
        $valor_pago = new TNumeric('valor_pago', '2', ',', '.' );
        $valor_aberto = new TNumeric('valor_aberto', '2', ',', '.' );
        $desconto = new TNumeric('desconto', '2', ',', '.' );
        $valor_multa = new TNumeric('valor_multa', '2', ',', '.' );
        $juros = new TNumeric('juros', '2', ',', '.' );
        $observacao = new TText('observacao');
        $system_unit_id = new THidden('system_unit_id');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $cheque_banco_id = new TDBCombo('cheque_banco_id', 'kraftsoft', 'Banco', 'id', '{nome}','nome asc'  );
        $cheque_agencia = new TEntry('cheque_agencia');
        $cheque_conta = new TNumeric('cheque_conta', '2', ',', '.' );
        $cheque_cpfcnpj = new TEntry('cheque_cpfcnpj');
        $cheque_emitente = new TEntry('cheque_emitente');
        $contaspag_contabil_contaspag_plano_conta_id = new TDBCombo('contaspag_contabil_contaspag_plano_conta_id', 'kraftsoft', 'PlanoConta', 'id', '{numero}  - {descricao}','numero asc' , $criteria_contaspag_contabil_contaspag_plano_conta_id );
        $contaspag_contabil_contaspag_id = new THidden('contaspag_contabil_contaspag_id');
        $contaspag_contabil_contaspag_centro_custo_id = new TDBCombo('contaspag_contabil_contaspag_centro_custo_id', 'kraftsoft', 'CentroCusto', 'id', '{numero}  - {descricao}','numero asc' , $criteria_contaspag_contabil_contaspag_centro_custo_id );
        $contaspag_contabil_contaspag_valor = new TNumeric('contaspag_contabil_contaspag_valor', '2', ',', '.' );
        $button_adicionar_contaspag_contabil_contaspag = new TButton('button_adicionar_contaspag_contabil_contaspag');

        $contaspag_situacao_id->addValidation("Contaspag situacao", new TRequiredValidator()); 
        $data_emissao->addValidation("Data Emissão", new TRequiredValidator()); 
        $data_vencimento->addValidation("Data Vencimento", new TRequiredValidator()); 
        $fornecedor_id->addValidation("Fornecedor", new TRequiredValidator()); 
        $forma_pagamento_id->addValidation("Forma de Pagamento", new TRequiredValidator()); 
        $contaspag_origem_id->addValidation("Contaspag origem id", new TRequiredValidator()); 
        $numero_documento->addValidation("Número Documento", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 

        $contaspag_situacao_id->setColorColumn('cor');
        $contaspag_situacao_id->setFilledColor('#fd9308');
        $contaspag_situacao_id->setFilledFontColor('#ffffff');
        $contaspag_situacao_id->setUnfilledColor('#d3d3d3');
        $contaspag_situacao_id->setUnfilledFontColor('#333333');
        $button_adicionar_contaspag_contabil_contaspag->setAction(new TAction([$this, 'onAddDetailContaspagContabilContaspag'],['static' => 1]), "Adicionar");
        $button_adicionar_contaspag_contabil_contaspag->addStyleClass('btn-default');
        $button_adicionar_contaspag_contabil_contaspag->setImage('fas:plus #2ecc71');
        $fornecedor_id->enableSearch();
        $cheque_banco_id->enableSearch();
        $forma_pagamento_id->enableSearch();
        $contaspag_origem_id->enableSearch();
        $contaspag_contabil_contaspag_plano_conta_id->enableSearch();
        $contaspag_contabil_contaspag_centro_custo_id->enableSearch();

        $data_emissao->setMask('dd/mm/yyyy');
        $data_pagamento->setMask('dd/mm/yyyy');
        $data_vencimento->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $data_competencia->setMask('dd/mm/yyyy');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_venc_original->setMask('dd/mm/yyyy');

        $data_emissao->setDatabaseMask('yyyy-mm-dd');
        $data_pagamento->setDatabaseMask('yyyy-mm-dd');
        $data_vencimento->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_competencia->setDatabaseMask('yyyy-mm-dd');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_venc_original->setDatabaseMask('yyyy-mm-dd');

        $id->setEditable(false);
        $juros->setEditable(false);
        $desconto->setEditable(false);
        $criado_em->setEditable(false);
        $valor_pago->setEditable(false);
        $criado_por->setEditable(false);
        $valor_multa->setEditable(false);
        $alterado_em->setEditable(false);
        $data_emissao->setEditable(false);
        $valor_aberto->setEditable(false);
        $alterado_por->setEditable(false);
        $data_pagamento->setEditable(false);
        $data_venc_original->setEditable(false);
        $contaspag_origem_id->setEditable(false);
        $contaspag_situacao_id->setEditable(false);

        $id->setSize('100%');
        $valor->setSize('100%');
        $juros->setSize('100%');
        $parcela->setSize('100%');
        $desconto->setSize('100%');
        $criado_em->setSize('100%');
        $valor_pago->setSize('100%');
        $criado_por->setSize('100%');
        $valor_multa->setSize('100%');
        $system_unit_id->setSize(200);
        $alterado_em->setSize('100%');
        $data_emissao->setSize('100%');
        $valor_aberto->setSize('100%');
        $alterado_por->setSize('100%');
        $cheque_conta->setSize('100%');
        $fornecedor_id->setSize('100%');
        $data_pagamento->setSize('100%');
        $observacao->setSize('100%', 70);
        $cheque_agencia->setSize('100%');
        $cheque_cpfcnpj->setSize('100%');
        $data_vencimento->setSize('100%');
        $cheque_banco_id->setSize('100%');
        $cheque_emitente->setSize('100%');
        $data_competencia->setSize('100%');
        $numero_documento->setSize('100%');
        $data_venc_original->setSize('100%');
        $forma_pagamento_id->setSize('100%');
        $contaspag_origem_id->setSize('100%');
        $contaspag_situacao_id->setSize('100%', 55);
        $contaspag_contabil_contaspag_id->setSize(200);
        $contaspag_contabil_contaspag_valor->setSize('100%');
        $contaspag_contabil_contaspag_plano_conta_id->setSize('100%');
        $contaspag_contabil_contaspag_centro_custo_id->setSize('100%');

        $button_adicionar_contaspag_contabil_contaspag->id = '633de20655a19';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$contaspag_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Data Vencimento Original:", null, '14px', null, '100%'),$data_venc_original],[new TLabel("Data Pagamento:", null, '14px', null, '100%'),$data_pagamento]);
        $row2->layout = [' col-sm-3','col-sm-3','col-sm-3'];

        $row3 = $this->form->addFields([new TLabel("Data Emissão:", '#ff0000', '14px', null, '100%'),$data_emissao],[new TLabel("Data Vencimento:", '#ff0000', '14px', null, '100%'),$data_vencimento],[new TLabel("Data Competência:", null, '14px', null, '100%'),$data_competencia]);
        $row3->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row4 = $this->form->addFields([new TLabel("Fornecedor:", '#ff0000', '14px', null, '100%'),$fornecedor_id]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->form->addFields([new TLabel("Forma pagamento:", '#ff0000', '14px', null, '100%'),$forma_pagamento_id],[new TLabel("Origem:", '#ff0000', '14px', null, '100%'),$contaspag_origem_id]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Número Documento:", '#ff0000', '14px', null, '100%'),$numero_documento],[new TLabel("Parcela:", null, '14px', null, '100%'),$parcela]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Valor Pago:", null, '14px', null, '100%'),$valor_pago]);
        $row7->layout = [' col-sm-6',' col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Valor Aberto:", null, '14px', null, '100%'),$valor_aberto],[new TLabel("Desconto:", null, '14px', null, '100%'),$desconto],[new TLabel("Valor Multa:", null, '14px', null, '100%'),$valor_multa],[new TLabel("Juros:", null, '14px', null, '100%'),$juros]);
        $row8->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row9 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$observacao]);
        $row9->layout = [' col-sm-12'];

        $row10 = $this->form->addFields([$system_unit_id]);
        $row10->layout = ['col-sm-6'];

        $bcontainer_633c93ebe6de1 = new BContainer('bcontainer_633c93ebe6de1');
        $this->bcontainer_633c93ebe6de1 = $bcontainer_633c93ebe6de1;

        $bcontainer_633c93ebe6de1->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_633c93ebe6de1->setBorderColor('#c0c0c0');

        $row11 = $bcontainer_633c93ebe6de1->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row11->layout = ['col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row12 = $this->form->addFields([$bcontainer_633c93ebe6de1]);
        $row12->layout = [' col-sm-12'];

        $this->form->appendPage("Dados de Cheque");
        $row13 = $this->form->addFields([new TLabel("Banco:", null, '14px', null, '100%'),$cheque_banco_id],[new TLabel("Agência:", null, '14px', null, '100%'),$cheque_agencia]);
        $row13->layout = ['col-sm-6','col-sm-6'];

        $row14 = $this->form->addFields([new TLabel("Conta:", null, '14px', null, '100%'),$cheque_conta],[new TLabel("CPF/CNPJ:", null, '14px', null, '100%'),$cheque_cpfcnpj]);
        $row14->layout = ['col-sm-6','col-sm-6'];

        $row15 = $this->form->addFields([new TLabel("Emitente:", null, '14px', null, '100%'),$cheque_emitente]);
        $row15->layout = [' col-sm-12'];

        $this->form->appendPage("Plano de Conta");

        $this->detailFormContaspagContabilContaspag = new BootstrapFormBuilder('detailFormContaspagContabilContaspag');
        $this->detailFormContaspagContabilContaspag->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormContaspagContabilContaspag->setProperty('class', 'form-horizontal builder-detail-form');

        $row16 = $this->detailFormContaspagContabilContaspag->addFields([new TLabel("Plano de conta:", '#ff0000', '14px', null, '100%'),$contaspag_contabil_contaspag_plano_conta_id,$contaspag_contabil_contaspag_id],[new TLabel("Centro de custo:", '#FF0000', '14px', null),$contaspag_contabil_contaspag_centro_custo_id],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$contaspag_contabil_contaspag_valor]);
        $row16->layout = ['col-sm-6','col-sm-6',' col-sm-6'];

        $row17 = $this->detailFormContaspagContabilContaspag->addFields([$button_adicionar_contaspag_contabil_contaspag]);
        $row17->layout = [' col-sm-12'];

        $row18 = $this->detailFormContaspagContabilContaspag->addFields([new THidden('contaspag_contabil_contaspag__row__id')]);
        $this->contaspag_contabil_contaspag_criteria = new TCriteria();

        $this->contaspag_contabil_contaspag_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->contaspag_contabil_contaspag_list->disableHtmlConversion();;
        $this->contaspag_contabil_contaspag_list->generateHiddenFields();
        $this->contaspag_contabil_contaspag_list->setId('contaspag_contabil_contaspag_list');

        $this->contaspag_contabil_contaspag_list->style = 'width:100%';
        $this->contaspag_contabil_contaspag_list->class .= ' table-bordered';

        $column_contaspag_contabil_contaspag_plano_conta_descricao = new TDataGridColumn('plano_conta->descricao', "Plano de conta ", 'left');
        $column_contaspag_contabil_contaspag_centro_custo_descricao = new TDataGridColumn('centro_custo->descricao', "Centro de custo", 'left');
        $column_contaspag_contabil_contaspag_valor_transformed = new TDataGridColumn('valor', "Valor", 'left');

        $column_contaspag_contabil_contaspag__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_contaspag_contabil_contaspag__row__data->setVisibility(false);

        $action_onEditDetailContaspagContabil = new TDataGridAction(array('ContaspagForm', 'onEditDetailContaspagContabil'));
        $action_onEditDetailContaspagContabil->setUseButton(false);
        $action_onEditDetailContaspagContabil->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailContaspagContabil->setLabel("Editar");
        $action_onEditDetailContaspagContabil->setImage('far:edit #478fca');
        $action_onEditDetailContaspagContabil->setFields(['__row__id', '__row__data']);

        $this->contaspag_contabil_contaspag_list->addAction($action_onEditDetailContaspagContabil);
        $action_onDeleteDetailContaspagContabil = new TDataGridAction(array('ContaspagForm', 'onDeleteDetailContaspagContabil'));
        $action_onDeleteDetailContaspagContabil->setUseButton(false);
        $action_onDeleteDetailContaspagContabil->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailContaspagContabil->setLabel("Excluir");
        $action_onDeleteDetailContaspagContabil->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailContaspagContabil->setFields(['__row__id', '__row__data']);

        $this->contaspag_contabil_contaspag_list->addAction($action_onDeleteDetailContaspagContabil);

        $this->contaspag_contabil_contaspag_list->addColumn($column_contaspag_contabil_contaspag_plano_conta_descricao);
        $this->contaspag_contabil_contaspag_list->addColumn($column_contaspag_contabil_contaspag_centro_custo_descricao);
        $this->contaspag_contabil_contaspag_list->addColumn($column_contaspag_contabil_contaspag_valor_transformed);

        $this->contaspag_contabil_contaspag_list->addColumn($column_contaspag_contabil_contaspag__row__data);

        $this->contaspag_contabil_contaspag_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->contaspag_contabil_contaspag_list);
        $this->detailFormContaspagContabilContaspag->addContent([$tableResponsiveDiv]);

        $column_contaspag_contabil_contaspag_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row19 = $this->form->addFields([$this->detailFormContaspagContabilContaspag]);
        $row19->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btnModoVisualizacao = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacao']), 'fas:bars #000000');
        $this->btnModoVisualizacao = $btnModoVisualizacao;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ContaspagList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Financeiro","Cadastro de contas à pagar"]));
        }
        $container->add($this->form);

        $btnModoVisualizacao->style = 'display:none';

        parent::add($container);

    }

    public  function onAddDetailContaspagContabilContaspag($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            //não deixar incluir plano de conta ou centro de custo SINTETICO, apenas ANALITICO...
            $plano_conta_id = $param['contaspag_contabil_contaspag_plano_conta_id'];
            $centro_custo_id = $param['contaspag_contabil_contaspag_centro_custo_id'];

            ContabilLancamentos::ValidaLancamentoContabil($plano_conta_id,$centro_custo_id,PlanoContaOrigem::Devedora);

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Plano de conta", 'name'=>"contaspag_contabil_contaspag_plano_conta_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Centro de custo", 'name'=>"contaspag_contabil_contaspag_centro_custo_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor", 'name'=>"contaspag_contabil_contaspag_valor", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->contaspag_contabil_contaspag__row__id) ? $data->contaspag_contabil_contaspag__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ContaspagContabil();
            $grid_data->__row__id = $__row__id;
            $grid_data->plano_conta_id = $data->contaspag_contabil_contaspag_plano_conta_id;
            $grid_data->id = $data->contaspag_contabil_contaspag_id;
            $grid_data->centro_custo_id = $data->contaspag_contabil_contaspag_centro_custo_id;
            $grid_data->valor = $data->contaspag_contabil_contaspag_valor;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['plano_conta_id'] =  $param['contaspag_contabil_contaspag_plano_conta_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['contaspag_contabil_contaspag_id'] ?? null;
            $__row__data['__display__']['centro_custo_id'] =  $param['contaspag_contabil_contaspag_centro_custo_id'] ?? null;
            $__row__data['__display__']['valor'] =  $param['contaspag_contabil_contaspag_valor'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->contaspag_contabil_contaspag_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('contaspag_contabil_contaspag_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->contaspag_contabil_contaspag_plano_conta_id = '';
            $data->contaspag_contabil_contaspag_id = '';
            $data->contaspag_contabil_contaspag_centro_custo_id = '';
            $data->contaspag_contabil_contaspag_valor = '';
            $data->contaspag_contabil_contaspag__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#633de20655a19');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailContaspagContabil($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->contaspag_contabil_contaspag_plano_conta_id = $__row__data->__display__->plano_conta_id ?? null;
            $data->contaspag_contabil_contaspag_id = $__row__data->__display__->id ?? null;
            $data->contaspag_contabil_contaspag_centro_custo_id = $__row__data->__display__->centro_custo_id ?? null;
            $data->contaspag_contabil_contaspag_valor = $__row__data->__display__->valor ?? null;
            $data->contaspag_contabil_contaspag__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#633de20655a19');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailContaspagContabil($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->contaspag_contabil_contaspag_plano_conta_id = '';
            $data->contaspag_contabil_contaspag_id = '';
            $data->contaspag_contabil_contaspag_centro_custo_id = '';
            $data->contaspag_contabil_contaspag_valor = '';
            $data->contaspag_contabil_contaspag__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('contaspag_contabil_contaspag_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Contaspag(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->valor_aberto = $object->valor - $object->valor_pago;

            if ($object->id=='')
            {
                $object->data_venc_original = $object->data_vencimento;
            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            //verificar se o vencimento foi alterado...
            $venc_inicial = TSession::getValue('cpag_vencimento_inicial');

            if ($venc_inicial<>$object->data_vencimento)
            {
                $cpag_hist_venc = new ContaspagHistoricoVenc;
                $cpag_hist_venc->contaspag_id = $object->id;
                $cpag_hist_venc->vencimento_anterior = $venc_inicial;
                $cpag_hist_venc->vencimento_atual = $object->data_vencimento;

                Funcoes::SalvarUsuarioCadastro($cpag_hist_venc);

                $cpag_hist_venc->store();
            }

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $contaspag_contabil_contaspag_items = $this->storeMasterDetailItems('ContaspagContabil', 'contaspag_id', 'contaspag_contabil_contaspag', $object, $param['contaspag_contabil_contaspag_list___row__data'] ?? [], $this->form, $this->contaspag_contabil_contaspag_list, function($masterObject, $detailObject){ 

                //code here
                Funcoes::SalvarUsuarioCadastro($detailObject);

            }, $this->contaspag_contabil_contaspag_criteria); 

            //validando a soma do plano de contas...
            $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', TSession::getValue('userunitid'))->first();

            if ($config_filial->cpag_usa_plano_contas_id==Resposta::Sim)
            {
                $soma_contabil = (double) ContaspagContabil::where('contaspag_id', '=',  $object->id)
                                                          ->sumby('valor'); 

                $object->valor = (double) $object->valor;

                //echo 'soma contabil '.$soma_contabil;
                //echo '  valor titulo'.$object->valor;

                $tolerancia = 0.001; // Defina uma tolerância aceitável para a comparação

                if (abs($soma_contabil - $object->valor) > $tolerancia)  
                {
                    throw new Exception('Soma do plano de conta e centro de custo não está igual ao valor do título! Verifique.');
                }
            }

            //atualizando a tabela de contabil lançamentos..
            ContaspagContabil::AtualizaLancamentoContabilContasPag(ContabilLancamentosTipo::Debito,
                                                                   ContabilLancamentosSituacao::NaoLiquidado,
                                                                   ContabilLancamentosOrigem::ContasPag,
                                                                   $object->id,
                                                                   $object->data_vencimento,
                                                                   'Ref. Débito Forn: '.$object->fornecedor->nome);            

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               Contaspag::Evento_ContasPagIncluidoOuAlterado,
                                               $object,
                                               'Contas a pagar do fornecedor '.$object->fornecedor->nome.' , '.
                                               'Valor do título: R$ '.number_format($object->valor,2, ',', '.').' , '.
                                               'Vencimento: '.TDate::date2br($object->data_vencimento)); 

            TTransaction::close();              

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContaspagList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacao($param = null) 
    {
        try 
        {
            $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve o título para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('ContaspagFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Contaspag($key); // instantiates the Active Record 

                TSession::setValue('cpag_vencimento_inicial', $object->data_vencimento);

                $contaspag_contabil_contaspag_items = $this->loadMasterDetailItems('ContaspagContabil', 'contaspag_id', 'contaspag_contabil_contaspag', $object, $this->form, $this->contaspag_contabil_contaspag_list, $this->contaspag_contabil_contaspag_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        TSession::setValue('cpag_vencimento_inicial', null);

        $object = new stdClass();
        $object->data_emissao = date('d/m/Y');
        $object->contaspag_situacao_id = ContaspagSituacao::EmAberto;
        $object->contaspag_origem_id = ContaspagOrigem::Avulso;
        $object->system_unit_id = TSession::getValue('userunitid');
        $object->desconto = '0,00';
        $object->valor_multa = '0,00';
        $object->juros = '0,00';
        $object->valor_pago = '0,00';

        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

