<?php

class ContaspagFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Contaspag';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Contaspag';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $contaspag = new Contaspag($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Contas a Pagar");

        TSession::setValue('contaspagformview_contaspag_id', $contaspag->id);

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'ContaspagSituacao', 'id', '{descricao}','id asc' );
        $lblid = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($contaspag->id, '', '15px', '');
        $lblvencoriginal = new TLabel("Data Vencimento Original:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(TDate::convertToMask($contaspag->data_venc_original, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbldatapagamento = new TLabel("Data Pagamento:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay(TDate::convertToMask($contaspag->data_pagamento, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbldataemissao = new TLabel("Data Emissão:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay(TDate::convertToMask($contaspag->data_emissao, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbldatavencimento = new TLabel("Data Vencimento:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay(TDate::convertToMask($contaspag->data_vencimento, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label2 = new TLabel("Data Competência:", '', '15px', 'B', '100%');
        $datetext6 = new TTextDisplay(TDate::convertToMask($contaspag->data_competencia, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lblfornecedor = new TLabel("Fornecedor:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($contaspag->fornecedor->nome, '', '15px', '');
        $lblformapgto = new TLabel("Forma de pagamento:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($contaspag->forma_pagamento->descricao, '', '15px', '');
        $lblorigem = new TLabel("Origem:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($contaspag->contaspag_origem->descricao, '', '15px', '');
        $lblnumdoc = new TLabel("Número Documento:", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay($contaspag->numero_documento, '', '15px', '');
        $lblparcela = new TLabel("Parcela:", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay($contaspag->parcela, '', '15px', '');
        $lblvalor = new TLabel("Valor:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(number_format((double)$contaspag->valor, '2', ',', '.'), '', '15px', '');
        $lblvalorpago = new TLabel("Valor Pago:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(number_format((double)$contaspag->valor_pago, '2', ',', '.'), '', '15px', '');
        $lblvaloraberto = new TLabel("Valor Aberto:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay(number_format((double)$contaspag->valor_aberto, '2', ',', '.'), '', '15px', '');
        $lbldesconto = new TLabel("Desconto:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay(number_format((double)$contaspag->desconto, '2', ',', '.'), '', '15px', '');
        $lblvalormulta = new TLabel("Valor Multa:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay(number_format((double)$contaspag->valor_multa, '2', ',', '.'), '', '15px', '');
        $lbljuros = new TLabel("Juros:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(number_format((double)$contaspag->juros, '2', ',', '.'), '', '15px', '');
        $lblobs = new TLabel("Observação:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay($contaspag->observacao, '', '15px', '');
        $lblcriadoem = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay(TDateTime::convertToMask($contaspag->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lblcriadopor = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay($contaspag->criado_por, '', '15px', '');
        $lblalteradoem = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay(TDateTime::convertToMask($contaspag->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lblalteradopor = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($contaspag->alterado_por, '', '15px', '');
        $label25 = new TLabel("Banco:", '', '15px', 'B');
        $text25 = new TTextDisplay($contaspag->cheque_banco->nome, '', '15px', '');
        $label26 = new TLabel("Agência:", '', '15px', 'B');
        $text26 = new TTextDisplay($contaspag->cheque_agencia, '', '15px', '');
        $label27 = new TLabel("Conta:", '', '15px', 'B');
        $txtchequeconta = new TTextDisplay($contaspag->cheque_conta, '', '15px', '');
        $label28 = new TLabel("Emitente:", '', '15px', 'B');
        $text28 = new TTextDisplay($contaspag->cheque_emitente, '', '15px', '');
        $label29 = new TLabel("CPF/CNPJ:", '', '15px', 'B');
        $text29 = new TTextDisplay($contaspag->cheque_cpfcnpj, '', '15px', '');
        $bpage_anexos = new BPageContainer();

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($contaspag->contaspag_situacao_id);
        $bpage_anexos->setSize('100%');
        $bpage_anexos->setAction(new TAction(['ContaspagAnexosHeaderList', 'onShow'], ['contapag_id' => $contaspag->id]));
        $bpage_anexos->setId('b63f28e112f148');

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpage_anexos->add($loadingContainer);


        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$lblid,$text1],[$lblvencoriginal,$text17],[$lbldatapagamento,$text19]);
        $row2->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([$lbldataemissao,$text14],[$lbldatavencimento,$text16],[$label2,$datetext6],[]);
        $row3->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row4 = $this->form->addFields([$lblfornecedor,$text4]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->form->addFields([$lblformapgto,$text3],[$lblorigem,$text5]);
        $row5->layout = [' col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([$lblnumdoc,$text7],[$lblparcela,$text8]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([$lblvalor,$text15],[$lblvalorpago,$text22]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([$lblvaloraberto,$text23],[$lbldesconto,$text20],[$lblvalormulta,$text24],[$lbljuros,$text21]);
        $row8->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row9 = $this->form->addFields([$lblobs,$text18]);
        $row9->layout = [' col-sm-12'];

        $row10 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row11 = $this->form->addFields([$lblcriadoem,$text9],[$lblcriadopor,$text12],[$lblalteradoem,$text13],[$lblalteradopor,$text11]);
        $row11->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Dados de Cheque");
        $row12 = $this->form->addFields([$label25],[$text25]);
        $row13 = $this->form->addFields([$label26],[$text26]);
        $row14 = $this->form->addFields([$label27],[$txtchequeconta]);
        $row15 = $this->form->addFields([$label28],[$text28]);
        $row16 = $this->form->addFields([$label29],[$text29]);

        $this->form->appendPage("Plano de Conta");

        $this->contaspag_contabil_contaspag_id_list = new TQuickGrid;
        $this->contaspag_contabil_contaspag_id_list->disableHtmlConversion();
        $this->contaspag_contabil_contaspag_id_list->style = 'width:100%';
        $this->contaspag_contabil_contaspag_id_list->disableDefaultClick();

        $column_plano_conta_numero_plano_conta_descricao = $this->contaspag_contabil_contaspag_id_list->addQuickColumn("Plano de conta", '{plano_conta->numero}  - {plano_conta->descricao}', 'left');
        $column_centro_custo_numero_centro_custo_descricao = $this->contaspag_contabil_contaspag_id_list->addQuickColumn("Centro de custo", '{centro_custo->numero}  - {centro_custo->descricao}', 'left');
        $column_valor_transformed = $this->contaspag_contabil_contaspag_id_list->addQuickColumn("Valor", 'valor', 'left');

        $column_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->contaspag_contabil_contaspag_id_list->createModel();

        $criteria_contaspag_contabil_contaspag_id = new TCriteria();
        $criteria_contaspag_contabil_contaspag_id->add(new TFilter('contaspag_id', '=', $contaspag->id));

        $criteria_contaspag_contabil_contaspag_id->setProperty('order', 'id desc');

        $contaspag_contabil_contaspag_id_items = ContaspagContabil::getObjects($criteria_contaspag_contabil_contaspag_id);

        $this->contaspag_contabil_contaspag_id_list->addItems($contaspag_contabil_contaspag_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->contaspag_contabil_contaspag_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Histórico de Vencimentos");

        $this->contaspag_historico_venc_contaspag_id_list = new TQuickGrid;
        $this->contaspag_historico_venc_contaspag_id_list->disableHtmlConversion();
        $this->contaspag_historico_venc_contaspag_id_list->style = 'width:100%';
        $this->contaspag_historico_venc_contaspag_id_list->disableDefaultClick();

        $column_criado_por = $this->contaspag_historico_venc_contaspag_id_list->addQuickColumn("Criado Por", 'criado_por', 'left');
        $column_criado_em_transformed = $this->contaspag_historico_venc_contaspag_id_list->addQuickColumn("Criado Em", 'criado_em', 'left');
        $column_vencimento_anterior_transformed = $this->contaspag_historico_venc_contaspag_id_list->addQuickColumn("Vencimento Anterior", 'vencimento_anterior', 'left');
        $column_vencimento_atual_transformed = $this->contaspag_historico_venc_contaspag_id_list->addQuickColumn("Vencimento Atual", 'vencimento_atual', 'left');

        $column_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_vencimento_anterior_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_vencimento_atual_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->contaspag_historico_venc_contaspag_id_list->createModel();

        $criteria_contaspag_historico_venc_contaspag_id = new TCriteria();
        $criteria_contaspag_historico_venc_contaspag_id->add(new TFilter('contaspag_id', '=', $contaspag->id));

        $criteria_contaspag_historico_venc_contaspag_id->setProperty('order', 'id desc');

        $contaspag_historico_venc_contaspag_id_items = ContaspagHistoricoVenc::getObjects($criteria_contaspag_historico_venc_contaspag_id);

        $this->contaspag_historico_venc_contaspag_id_list->addItems($contaspag_historico_venc_contaspag_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->contaspag_historico_venc_contaspag_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Anexos");
        $row17 = $this->form->addFields([$bpage_anexos]);
        $row17->layout = [' col-sm-12'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        $btnContaspagFormOnEditAction = new TAction(['ContaspagForm', 'onEdit'],['key'=>$contaspag->id]);
        $btnContaspagFormOnEditLabel = new TLabel("Editar");

        $btnContaspagFormOnEdit = $this->form->addHeaderAction($btnContaspagFormOnEditLabel, $btnContaspagFormOnEditAction, 'fas:edit #2196F3'); 
        $btnContaspagFormOnEditLabel->setFontSize('12px'); 
        $btnContaspagFormOnEditLabel->setFontColor('#333'); 

        $btnContaspagBaixasFormOnShowAction = new TAction(['ContaspagBaixasForm', 'onShow'],['key'=>$contaspag->id]);
        $btnContaspagBaixasFormOnShowLabel = new TLabel("Baixar Titulo");

        $btnContaspagBaixasFormOnShow = $this->form->addHeaderAction($btnContaspagBaixasFormOnShowLabel, $btnContaspagBaixasFormOnShowAction, 'fas:money-check-alt #009688'); 
        $btnContaspagBaixasFormOnShowLabel->setFontSize('12px'); 
        $btnContaspagBaixasFormOnShowLabel->setFontColor('#333'); 

        $btn_oncancelartituloAction = new TAction([$this, 'onCancelarTitulo'],['key'=>$contaspag->id]);
        $btn_oncancelartituloLabel = new TLabel("Cancelar Título");

        $btn_oncancelartitulo = $this->form->addHeaderAction($btn_oncancelartituloLabel, $btn_oncancelartituloAction, 'fas:trash-alt #E40606'); 
        $btn_oncancelartituloLabel->setFontSize('12px'); 
        $btn_oncancelartituloLabel->setFontColor('#333'); 

        $btnContaspagBaixasSimpleListOnShowAction = new TAction(['ContaspagBaixasSimpleList', 'onShow'],['key'=>$contaspag->id]);
        $btnContaspagBaixasSimpleListOnShowLabel = new TLabel("Visualizar Baixas");

        $btnContaspagBaixasSimpleListOnShow = $this->form->addHeaderAction($btnContaspagBaixasSimpleListOnShowLabel, $btnContaspagBaixasSimpleListOnShowAction, 'fas:search-plus #FF5722'); 
        $btnContaspagBaixasSimpleListOnShowLabel->setFontSize('12px'); 
        $btnContaspagBaixasSimpleListOnShowLabel->setFontColor('#333'); 

        $btn_onverorigemAction = new TAction([$this, 'onVerOrigem'],['key'=>$contaspag->id]);
        $btn_onverorigemLabel = new TLabel("Ver Origem");

        $btn_onverorigem = $this->form->addHeaderAction($btn_onverorigemLabel, $btn_onverorigemAction, 'fas:atom #4CAF50'); 
        $btn_onverorigemLabel->setFontSize('12px'); 
        $btn_onverorigemLabel->setFontColor('#000000'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        if($contaspag->contaspag_situacao_id==ContaspagSituacao::Cancelado
        or $contaspag->contaspag_situacao_id==ContaspagSituacao::Pago)
        {
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_baixar_titulo").style.display = "none";');
            TScript::create('document.getElementById("tbutton_cancelar_título").style.display = "none";');            
        } 

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ContaspagFormView]');
        $style->width = '90% !important';   
        $style->show(true);

    }

    public function onCancelarTitulo($param = null) 
    {
        try 
        {
            new TQuestion("Deseja cancelar o título?", new TAction([__CLASS__, 'onCancelarTituloYes'], $param), new TAction([__CLASS__, 'onCancelarTituloNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onVerOrigem($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);   
            $contaspag = Contaspag::find($param['key']);
            TTransaction::close();

            if ($contaspag->nota_fiscal_compra_id<>null)
            {
                 $pageParam = ['key' => $contaspag->nota_fiscal_compra_id]; // ex.: = ['key' => 10]

                 TApplication::loadPage('NotaFiscalCompraFormView', 'OnShow', $pageParam);                
            }
            else
            {
              new TMessage('info', 'Este título é de origem avulsa!');  
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onCancelarTituloYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $contaspag = Contaspag::find($param['key']);     

            if($contaspag) 
            {
                $contaspag->contaspag_situacao_id=ContaspagSituacao::Cancelado;
                $contaspag->store();

                ContaspagContabil::DeletaLancamentoContabilContasPag($contaspag->id);
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $contaspag->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarTituloNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

