<?php

class ContasrecBaixasForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ContasrecBaixas';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContasrecBaixasForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Baixa de Contas a Receber");

        $criteria_conta_corrente_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_conta_corrente_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $cliente = new TEntry('cliente');
        $crec_id = new TEntry('crec_id');
        $crec_parcela = new TEntry('crec_parcela');
        $crec_numero_documento = new TEntry('crec_numero_documento');
        $crec_valor = new TEntry('crec_valor');
        $crec_vencimento = new TDate('crec_vencimento');
        $crec_vencimento_original = new TDate('crec_vencimento_original');
        $crec_data_emissao = new TDate('crec_data_emissao');
        $crec_data_competencia = new TDate('crec_data_competencia');
        $crec_valor_pago = new TNumeric('crec_valor_pago', '2', ',', '.' );
        $crec_valor_aberto = new TNumeric('crec_valor_aberto', '2', ',', '.' );
        $juros = new TNumeric('juros', '2', ',', '.' );
        $multa = new TNumeric('multa', '2', ',', '.' );
        $desconto = new TNumeric('desconto', '2', ',', '.' );
        $data_pagamento = new TDate('data_pagamento');
        $valor = new TNumeric('valor', '2', ',', '.' );
        $conta_corrente_id = new TDBCombo('conta_corrente_id', 'kraftsoft', 'ContaCorrente', 'id', '{nome}','nome asc' , $criteria_conta_corrente_id );
        $historico = new TText('historico');
        $id = new THidden('id');
        $contasrec_id = new THidden('contasrec_id');

        $data_pagamento->addValidation("Data Pagamento", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 
        $conta_corrente_id->addValidation("Conta corrente id", new TRequiredValidator()); 

        $data_pagamento->setValue(date('d/m/Y'));
        $conta_corrente_id->enableSearch();
        $data_pagamento->setMask('dd/mm/yyyy');
        $crec_vencimento->setMask('dd/mm/yyyy');
        $crec_data_emissao->setMask('dd/mm/yyyy');
        $crec_data_competencia->setMask('dd/mm/yyyy');
        $crec_vencimento_original->setMask('dd/mm/yyyy');

        $data_pagamento->setDatabaseMask('yyyy-mm-dd');
        $crec_vencimento->setDatabaseMask('yyyy-mm-dd');
        $crec_data_emissao->setDatabaseMask('yyyy-mm-dd');
        $crec_data_competencia->setDatabaseMask('yyyy-mm-dd');
        $crec_vencimento_original->setDatabaseMask('yyyy-mm-dd');

        $cliente->setEditable(false);
        $crec_id->setEditable(false);
        $crec_valor->setEditable(false);
        $crec_parcela->setEditable(false);
        $crec_vencimento->setEditable(false);
        $crec_valor_pago->setEditable(false);
        $crec_data_emissao->setEditable(false);
        $crec_valor_aberto->setEditable(false);
        $crec_numero_documento->setEditable(false);
        $crec_data_competencia->setEditable(false);
        $crec_vencimento_original->setEditable(false);

        $id->setSize(200);
        $juros->setSize('100%');
        $multa->setSize('100%');
        $valor->setSize('100%');
        $cliente->setSize('100%');
        $crec_id->setSize('100%');
        $desconto->setSize('100%');
        $contasrec_id->setSize(200);
        $crec_valor->setSize('100%');
        $crec_parcela->setSize('100%');
        $historico->setSize('100%', 70);
        $data_pagamento->setSize('100%');
        $crec_vencimento->setSize('100%');
        $crec_valor_pago->setSize('100%');
        $crec_data_emissao->setSize('100%');
        $crec_valor_aberto->setSize('100%');
        $conta_corrente_id->setSize('100%');
        $crec_numero_documento->setSize('100%');
        $crec_data_competencia->setSize('100%');
        $crec_vencimento_original->setSize('100%');

        $bcontainer_634a957b4746e = new BContainer('bcontainer_634a957b4746e');
        $this->bcontainer_634a957b4746e = $bcontainer_634a957b4746e;

        $bcontainer_634a957b4746e->setTitle("Resumo do Título", '#333', '18px', '', '#fff');
        $bcontainer_634a957b4746e->setBorderColor('#c0c0c0');

        $row1 = $bcontainer_634a957b4746e->addFields([new TLabel("Cliente:", null, '14px', null),$cliente]);
        $row1->layout = [' col-sm-12'];

        $row2 = $bcontainer_634a957b4746e->addFields([new TLabel("Nº Título:", null, '14px', null),$crec_id],[new TLabel("Parcela:", null, '14px', null),$crec_parcela],[new TLabel("Nº Documento:", null, '14px', null),$crec_numero_documento],[new TLabel("Valor:", null, '14px', null),$crec_valor]);
        $row2->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row3 = $bcontainer_634a957b4746e->addFields([new TLabel("Vencimento:", null, '14px', null, '100%'),$crec_vencimento],[new TLabel("Vencimento Original:", null, '14px', null, '100%'),$crec_vencimento_original],[new TLabel("Data Emissão", null, '14px', null, '100%'),$crec_data_emissao],[new TLabel("Data Competência", null, '14px', null, '100%'),$crec_data_competencia]);
        $row3->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row4 = $bcontainer_634a957b4746e->addFields([new TLabel("Valor Pago:", null, '14px', null),$crec_valor_pago],[new TLabel("Valor Aberto:", null, '14px', null),$crec_valor_aberto]);
        $row4->layout = ['col-sm-3','col-sm-3'];

        $row5 = $this->form->addFields([$bcontainer_634a957b4746e]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->form->addFields([new TLabel("Juros:", null, '14px', null, '100%'),$juros],[new TLabel("Multa:", null, '14px', null, '100%'),$multa],[new TLabel("Desconto:", null, '14px', null, '100%'),$desconto]);
        $row6->layout = [' col-sm-3',' col-sm-3',' col-sm-3'];

        $row7 = $this->form->addFields([new TLabel("Data Pagamento:", '#FF0000', '14px', null, '100%'),$data_pagamento],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Conta Corrente:", '#ff0000', '14px', null, '100%'),$conta_corrente_id]);
        $row7->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Histórico:", null, '14px', null, '100%'),$historico]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addFields([$id,$contasrec_id]);
        $row9->layout = ['col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ContasrecBaixasForm]');
        $style->width = '70% !important';   
        $style->show(true);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ContasrecBaixas(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            Contasrec::BaixarTitulo($object->historico,
                                    $object->data_pagamento,
                                    $object->desconto,
                                    $object->valor,
                                    $object->juros,
                                    $object->multa,
                                    $object->conta_corrente_id,
                                    $object->contasrec_id,
                                    $object->id);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               Contasrec::Evento_ContasRecBaixado,
                                               $object,
                                               'Contas a receber do cliente '.$object->contasrec->cliente->nome.' , '.
                                               'Valor da baixa: R$ '.number_format($object->valor,2, ',', '.').' , '.
                                               'Pagamento: '.TDate::date2br($object->data_pagamento)); 

            TTransaction::close();                 

            TToast::show('success', "Baixa realizada com sucesso!", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContasrecList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ContasrecBaixas($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        TTransaction::open(self::$database);
        $crec = Contasrec::find($param['key']);

        if ($crec)
        {
            $object = new stdClass();
            $object->crec_id                    = $crec->id;
            $object->cliente                    = $crec->cliente->nome;
            $object->crec_valor_aberto          = number_format($crec->valor_aberto, 2, ',', '.');
            $object->crec_valor_pago            = number_format($crec->valor_pago, 2, ',', '.');
            $object->crec_data_competencia      = TDate::date2br($crec->data_competencia);

            $object->crec_data_emissao          = TDate::date2br($crec->data_emissao);
            $object->crec_vencimento_original   = TDate::date2br($crec->data_venc_original);
            $object->crec_vencimento            = TDate::date2br($crec->data_vencimento);
            $object->crec_valor                 = number_format($crec->valor, 2, ',', '.');
            $object->crec_numero_documento      = $crec->numero_documento;
            $object->crec_parcela               = $crec->parcela;

            //campo THidden
            $object->contasrec_id               = $crec->id;

            //campos da baixa
            $object->juros                      = '0,00';
            $object->multa                      = '0,00';
            $object->desconto                   = '0,00';
            $object->historico                  = 'Baixa individual do título Nº '.$crec->id
                                                  .', Cliente: '.$crec->cliente->nome;
            $object->valor                      = number_format($crec->valor_aberto, 2, ',', '.');

            TForm::sendData(self::$formName, $object);
        }

        TTransaction::close();

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

