<?php

class ContasrecBaixasReport extends TPage
{
    private $form; // form
    private $loaded;
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ContasrecBaixas';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContasrecBaixasReport';

    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);

        // define the form title
        $this->form->setFormTitle("Baixas de Contas a Receber");

        $contasrec_contasrec_origem_id = new TDBCombo('contasrec_contasrec_origem_id', 'kraftsoft', 'ContasrecOrigem', 'id', '{descricao}','id asc'  );
        $contasrec_contasrec_situacao_id = new TDBSelect('contasrec_contasrec_situacao_id', 'kraftsoft', 'ContasrecSituacao', 'id', '{descricao}','id asc'  );
        $conta_corrente_id = new TDBCombo('conta_corrente_id', 'kraftsoft', 'ContaCorrente', 'id', '{nome}','nome asc'  );
        $contasrec_cliente_id = new TDBCombo('contasrec_cliente_id', 'kraftsoft', 'Cliente', 'id', '{nome}','nome asc'  );
        $data_pagamento_inicial = new TDate('data_pagamento_inicial');
        $data_pagamento_final = new TDate('data_pagamento_final');

        $data_pagamento_final->setMask('dd/mm/yyyy');
        $data_pagamento_inicial->setMask('dd/mm/yyyy');

        $data_pagamento_final->setDatabaseMask('yyyy-mm-dd');
        $data_pagamento_inicial->setDatabaseMask('yyyy-mm-dd');

        $conta_corrente_id->enableSearch();
        $contasrec_cliente_id->enableSearch();
        $contasrec_contasrec_origem_id->enableSearch();
        $contasrec_contasrec_situacao_id->enableSearch();

        $conta_corrente_id->setSize('100%');
        $contasrec_cliente_id->setSize('100%');
        $data_pagamento_final->setSize('100%');
        $data_pagamento_inicial->setSize('100%');
        $contasrec_contasrec_origem_id->setSize('100%');
        $contasrec_contasrec_situacao_id->setSize('100%', 70);

        $row1 = $this->form->addFields([new TLabel("Origem:", null, '14px', null),$contasrec_contasrec_origem_id],[new TLabel("Situação:", null, '14px', null),$contasrec_contasrec_situacao_id]);
        $row1->layout = [' col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Conta Corrente:", null, '14px', null),$conta_corrente_id],[new TLabel("Cliente:", null, '14px', null),$contasrec_cliente_id]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Data Pagamento Inicial:", null, '14px', null, '100%'),$data_pagamento_inicial],[new TLabel("Data Pagamento Final:", null, '14px', null, '100%'),$data_pagamento_final]);
        $row3->layout = [' col-sm-3',' col-sm-3'];

        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue(__CLASS__.'_filter_data') );

        $btn_ongeneratehtml = $this->form->addAction("Gerar HTML", new TAction([$this, 'onGenerateHtml']), 'far:file-code #ffffff');
        $this->btn_ongeneratehtml = $btn_ongeneratehtml;
        $btn_ongeneratehtml->addStyleClass('btn-primary'); 

        $btn_ongeneratepdf = $this->form->addAction("Gerar PDF", new TAction([$this, 'onGeneratePdf']), 'far:file-pdf #d44734');
        $this->btn_ongeneratepdf = $btn_ongeneratepdf;

        $btn_ongeneratexls = $this->form->addAction("Gerar XLS", new TAction([$this, 'onGenerateXls']), 'far:file-excel #00a65a');
        $this->btn_ongeneratexls = $btn_ongeneratexls;

        $btn_ongeneratertf = $this->form->addAction("Gerar RTF", new TAction([$this, 'onGenerateRtf']), 'far:file-alt #324bcc');
        $this->btn_ongeneratertf = $btn_ongeneratertf;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        $container->add(TBreadCrumb::create(["Financeiro","Baixas de Contas a Receber"]));
        $container->add($this->form);

        parent::add($container);

    }

    public function onGenerateHtml($param = null) 
    {
        $this->onGenerate('html');
    }
    public function onGeneratePdf($param = null) 
    {
        $this->onGenerate('pdf');
    }
    public function onGenerateXls($param = null) 
    {
        $this->onGenerate('xls');
    }
    public function onGenerateRtf($param = null) 
    {
        $this->onGenerate('rtf');
    }

    /**
     * Register the filter in the session
     */
    public function getFilters()
    {
        // get the search form data
        $data = $this->form->getData();

        $filters = [];

        TSession::setValue(__CLASS__.'_filter_data', NULL);
        TSession::setValue(__CLASS__.'_filters', NULL);

        if (isset($data->contasrec_contasrec_origem_id) AND ( (is_scalar($data->contasrec_contasrec_origem_id) AND $data->contasrec_contasrec_origem_id !== '') OR (is_array($data->contasrec_contasrec_origem_id) AND (!empty($data->contasrec_contasrec_origem_id)) )) )
        {

            $filters[] = new TFilter('contasrec_id', 'in', "(SELECT id FROM contasrec WHERE contasrec_origem_id = '{$data->contasrec_contasrec_origem_id}')");// create the filter 
        }
        if (isset($data->contasrec_contasrec_situacao_id) AND ( (is_scalar($data->contasrec_contasrec_situacao_id) AND $data->contasrec_contasrec_situacao_id !== '') OR (is_array($data->contasrec_contasrec_situacao_id) AND (!empty($data->contasrec_contasrec_situacao_id)) )) )
        {
            $filterVar = is_array($data->contasrec_contasrec_situacao_id) ? "'".implode("','", $data->contasrec_contasrec_situacao_id)."'" : $data->contasrec_contasrec_situacao_id;
            $filters[] = new TFilter('contasrec_id', 'in', "(SELECT id FROM contasrec WHERE contasrec_situacao_id in ({$filterVar}))");// create the filter 
        }
        if (isset($data->conta_corrente_id) AND ( (is_scalar($data->conta_corrente_id) AND $data->conta_corrente_id !== '') OR (is_array($data->conta_corrente_id) AND (!empty($data->conta_corrente_id)) )) )
        {

            $filters[] = new TFilter('conta_corrente_id', '=', $data->conta_corrente_id);// create the filter 
        }
        if (isset($data->contasrec_cliente_id) AND ( (is_scalar($data->contasrec_cliente_id) AND $data->contasrec_cliente_id !== '') OR (is_array($data->contasrec_cliente_id) AND (!empty($data->contasrec_cliente_id)) )) )
        {

            $filters[] = new TFilter('contasrec_id', 'in', "(SELECT id FROM contasrec WHERE cliente_id = '{$data->contasrec_cliente_id}')");// create the filter 
        }
        if (isset($data->data_pagamento_inicial) AND ( (is_scalar($data->data_pagamento_inicial) AND $data->data_pagamento_inicial !== '') OR (is_array($data->data_pagamento_inicial) AND (!empty($data->data_pagamento_inicial)) )) )
        {

            $filters[] = new TFilter('data_pagamento', '>=', $data->data_pagamento_inicial);// create the filter 
        }
        if (isset($data->data_pagamento_final) AND ( (is_scalar($data->data_pagamento_final) AND $data->data_pagamento_final !== '') OR (is_array($data->data_pagamento_final) AND (!empty($data->data_pagamento_final)) )) )
        {

            $filters[] = new TFilter('data_pagamento', '<=', $data->data_pagamento_final);// create the filter 
        }

        // fill the form with data again
        $this->form->setData($data);

        // keep the search data in the session
        TSession::setValue(__CLASS__.'_filter_data', $data);

        return $filters;
    }

    public function onGenerate($format)
    {
        try
        {
            $filters = $this->getFilters();
            // open a transaction with database 'kraftsoft'
            TTransaction::open(self::$database);
            $param = [];
            // creates a repository for ContasrecBaixas
            $repository = new TRepository(self::$activeRecord);
            // creates a criteria
            $criteria = new TCriteria;

            $filterVar = TSession::getValue("userunitid");
            $criteria->add(new TFilter('contasrec_id', 'in', "(SELECT id FROM contasrec WHERE system_unit_id = '{$filterVar}')"));

            $param['order'] = 'contasrec_id,data_pagamento';
            $param['direction'] = 'asc';

            $criteria->setProperties($param);

            if ($filters)
            {
                foreach ($filters as $filter) 
                {
                    $criteria->add($filter);       
                }
            }

            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);

            if ($objects)
            {
                $widths = array(200,200,200,200,200,200,200,200);
                $reportExtension = 'pdf';
                switch ($format)
                {
                    case 'html':
                        $tr = new TTableWriterHTML($widths);
                        $reportExtension = 'html';
                        break;
                    case 'xls':
                        $tr = new TTableWriterXLS($widths);
                        $reportExtension = 'xls';
                        break;
                    case 'pdf':
                        $tr = new TTableWriterPDF($widths, 'L', 'A4');
                        $reportExtension = 'pdf';
                        break;
                    case 'htmlPdf':
                        $reportExtension = 'pdf';
                        $tr = new BTableWriterHtmlPDF($widths, 'L', 'A4');
                        break;
                    case 'rtf':
                        if (!class_exists('PHPRtfLite_Autoloader'))
                        {
                            PHPRtfLite::registerAutoloader();
                        }
                        $reportExtension = 'rtf';
                        $tr = new TTableWriterRTF($widths, 'L', 'A4');
                        break;
                }

                if (!empty($tr))
                {
                    // create the document styles
                    $tr->addStyle('title', 'Helvetica', '10', 'B',   '#ffffff', '#96c0e6');
                    $tr->addStyle('datap', 'Arial', '10', '',    '#000000', '#f0f0f0');
                    $tr->addStyle('datai', 'Arial', '10', '',    '#000000', '#ffffff');
                    $tr->addStyle('header', 'Helvetica', '16', 'B',   '#4589c5', '#494D90');
                    $tr->addStyle('footer', 'Helvetica', '10', 'B',  '#4589c5', '#B1B1EA');
                    $tr->addStyle('break', 'Helvetica', '10', 'B',  '#ffffff', '#8da4bc');
                    $tr->addStyle('total', 'Helvetica', '10', 'I',  '#000000', '#b2d1dc');
                    $tr->addStyle('breakTotal', 'Helvetica', '10', 'I',  '#000000', '#b3d5f3');

                    // Quando o relatório a ser gerado for PDF
                    if ($format == 'pdf')
                    {
                        // Adiciona o cabeçalho
                        $tr->setHeaderCallback(
                            function($tr)
                            {
                                $pdf = $tr->getNativeWriter();

                                // Define a fonte/ estilos
                                $pdf->SetFont('Arial','B',15); 

                                // Define o posicionamento do texto
                                $pdf->Cell(80); 

                                // Texto do cabeçalho
                                $pdf->Cell(100,10, utf8_decode('Relatório de Baixas de Contas a Receber') ,0,0,'C'); 
                                $pdf->Ln(10); 

                            }
                        );

                        // Adiciona o footer do relatório
                        $tr->setFooterCallback(
                            function($tr)
                            {
                                $pdf = $tr->getNativeWriter();

                                // Necessário para obter o número total de páginas
                                $pdf->AliasNbPages();

                                // Posiciona o footer no final da página
                                $pdf->SetY(-40);

                                // Define o estilho do footer
                                $pdf->SetFont('Arial'   ,'B',12); 
                                $pdf->Cell(110); 

                                // Obtém o número da página atual
                                $numero = $pdf->PageNo();

                                // Footer
                                $pdf->Cell(0,10, utf8_decode("Página: {$numero}/{nb}") ,0,0,'R');

                                // Line break 
                                $pdf->Ln(20); 
                            }
                        );
                    }
                    else // Para os demais formatos
                    {
                         $tr->setHeaderCallback(
                            function($tr)
                            {
                                $tr->addRow();
                                $tr->addCell('Relatório de Baixas de Contas a Receber', 'center', 'header', 100);
                            }
                        );

                        $tr->setFooterCallback(
                            function($tr)
                            {
                                $tr->addRow();
                                $tr->addCell(date('d/m/Y h:i:s'), 'center', 'footer', 100);
                            }
                        );
                    }

                    // add titles row
                    $tr->addRow();
                    $tr->addCell("Conta Corrente", 'left', 'title');
                    $tr->addCell("Data Pagamento", 'left', 'title');
                    $tr->addCell("Saldo Aberto", 'left', 'title');
                    $tr->addCell("Juros", 'left', 'title');
                    $tr->addCell("Multa", 'left', 'title');
                    $tr->addCell("Desconto", 'left', 'title');
                    $tr->addCell("Saldo a Pagar", 'left', 'title');
                    $tr->addCell("Valor", 'left', 'title');

                    $grandTotal = [];
                    $breakTotal = [];
                    $breakValue = null;
                    $firstRow = true;

                    // controls the background filling
                    $colour = false;                
                    foreach ($objects as $object)
                    {
                        $style = $colour ? 'datap' : 'datai';

                        if ($object->contasrec_id !== $breakValue)
                        {
                            if (!$firstRow)
                            {
                                $tr->addRow();

                                $breakTotal_juros = array_sum($breakTotal['juros']);
                                $breakTotal_multa = array_sum($breakTotal['multa']);
                                $breakTotal_desconto = array_sum($breakTotal['desconto']);
                                $breakTotal_saldo_apagar = array_sum($breakTotal['saldo_apagar']);
                                $breakTotal_valor = array_sum($breakTotal['valor']);

                                $breakTotal_juros = call_user_func(function($value)
                                {
                                    if(!$value)
                                    {
                                        $value = 0;
                                    }

                                    if(is_numeric($value))
                                    {
                                        return "R$ " . number_format($value, 2, ",", ".");
                                    }
                                    else
                                    {
                                        return $value;
                                    }
                                }, $breakTotal_juros); 

                                $breakTotal_multa = call_user_func(function($value)
                                {
                                    if(!$value)
                                    {
                                        $value = 0;
                                    }

                                    if(is_numeric($value))
                                    {
                                        return "R$ " . number_format($value, 2, ",", ".");
                                    }
                                    else
                                    {
                                        return $value;
                                    }
                                }, $breakTotal_multa); 

                                $breakTotal_desconto = call_user_func(function($value)
                                {
                                    if(!$value)
                                    {
                                        $value = 0;
                                    }

                                    if(is_numeric($value))
                                    {
                                        return "R$ " . number_format($value, 2, ",", ".");
                                    }
                                    else
                                    {
                                        return $value;
                                    }
                                }, $breakTotal_desconto); 

                                $breakTotal_saldo_apagar = call_user_func(function($value)
                                {
                                    if(!$value)
                                    {
                                        $value = 0;
                                    }

                                    if(is_numeric($value))
                                    {
                                        return "R$ " . number_format($value, 2, ",", ".");
                                    }
                                    else
                                    {
                                        return $value;
                                    }
                                }, $breakTotal_saldo_apagar); 

                                $breakTotal_valor = call_user_func(function($value)
                                {
                                    if(!$value)
                                    {
                                        $value = 0;
                                    }

                                    if(is_numeric($value))
                                    {
                                        return "R$ " . number_format($value, 2, ",", ".");
                                    }
                                    else
                                    {
                                        return $value;
                                    }
                                }, $breakTotal_valor); 

                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell($breakTotal_juros, 'right', 'breakTotal');
                                $tr->addCell($breakTotal_multa, 'right', 'breakTotal');
                                $tr->addCell($breakTotal_desconto, 'right', 'breakTotal');
                                $tr->addCell($breakTotal_saldo_apagar, 'right', 'breakTotal');
                                $tr->addCell($breakTotal_valor, 'right', 'breakTotal');
                            }
                            $tr->addRow();
                            $tr->addCell($object->render('Id: {contasrec->id}  / Nº Doc: {contasrec->numero_documento}  / Origem: {contasrec->contasrec_origem->descricao}  / Cliente: {contasrec->cliente->nome} /  CPF/CNPJ:  {contasrec->cliente->cpf_cnpj}  / Data Emissão: {contasrec->data_emissao_formatada}  / Forma Pgto: {contasrec->forma_pagamento->descricao}  / Vencimento: {contasrec->data_vencimento_formatada}'), 'left', 'break', 8);
                            $breakTotal = [];
                        }
                        $breakValue = $object->contasrec_id;

                        $grandTotal['juros'][] = $object->juros;
                        $breakTotal['juros'][] = $object->juros;
                        $grandTotal['multa'][] = $object->multa;
                        $breakTotal['multa'][] = $object->multa;
                        $grandTotal['desconto'][] = $object->desconto;
                        $breakTotal['desconto'][] = $object->desconto;
                        $grandTotal['saldo_apagar'][] = $object->saldo_apagar;
                        $breakTotal['saldo_apagar'][] = $object->saldo_apagar;
                        $grandTotal['valor'][] = $object->valor;
                        $breakTotal['valor'][] = $object->valor;

                        $firstRow = false;

                        $object->data_pagamento = call_user_func(function($value, $object, $row) 
                        {
                            if(!empty(trim($value)))
                            {
                                try
                                {
                                    $date = new DateTime($value);
                                    return $date->format('d/m/Y');
                                }
                                catch (Exception $e)
                                {
                                    return $value;
                                }
                            }
                        }, $object->data_pagamento, $object, null);

                        $object->saldo_aberto = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->saldo_aberto, $object, null);

                        $object->juros = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->juros, $object, null);

                        $object->multa = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->multa, $object, null);

                        $object->desconto = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->desconto, $object, null);

                        $object->saldo_apagar = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->saldo_apagar, $object, null);

                        $object->valor = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->valor, $object, null);

                        $tr->addRow();

                        $tr->addCell($object->conta_corrente->nome, 'left', $style);
                        $tr->addCell($object->data_pagamento, 'left', $style);
                        $tr->addCell($object->saldo_aberto, 'left', $style);
                        $tr->addCell($object->juros, 'right', $style);
                        $tr->addCell($object->multa, 'right', $style);
                        $tr->addCell($object->desconto, 'right', $style);
                        $tr->addCell($object->saldo_apagar, 'right', $style);
                        $tr->addCell($object->valor, 'right', $style);

                        $colour = !$colour;

                    }

                    $tr->addRow();

                    $breakTotal_juros = array_sum($breakTotal['juros']);
                    $breakTotal_multa = array_sum($breakTotal['multa']);
                    $breakTotal_desconto = array_sum($breakTotal['desconto']);
                    $breakTotal_saldo_apagar = array_sum($breakTotal['saldo_apagar']);
                    $breakTotal_valor = array_sum($breakTotal['valor']);

                    $breakTotal_juros = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $breakTotal_juros); 

                    $breakTotal_multa = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $breakTotal_multa); 

                    $breakTotal_desconto = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $breakTotal_desconto); 

                    $breakTotal_saldo_apagar = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $breakTotal_saldo_apagar); 

                    $breakTotal_valor = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $breakTotal_valor); 

                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell($breakTotal_juros, 'right', 'breakTotal');
                    $tr->addCell($breakTotal_multa, 'right', 'breakTotal');
                    $tr->addCell($breakTotal_desconto, 'right', 'breakTotal');
                    $tr->addCell($breakTotal_saldo_apagar, 'right', 'breakTotal');
                    $tr->addCell($breakTotal_valor, 'right', 'breakTotal');

                    $tr->addRow();

                    $grandTotal_juros = array_sum($grandTotal['juros']);
                    $grandTotal_multa = array_sum($grandTotal['multa']);
                    $grandTotal_desconto = array_sum($grandTotal['desconto']);
                    $grandTotal_saldo_apagar = array_sum($grandTotal['saldo_apagar']);
                    $grandTotal_valor = array_sum($grandTotal['valor']);

                    $grandTotal_juros = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $grandTotal_juros); 

                    $grandTotal_multa = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $grandTotal_multa); 

                    $grandTotal_desconto = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $grandTotal_desconto); 

                    $grandTotal_saldo_apagar = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $grandTotal_saldo_apagar); 

                    $grandTotal_valor = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $grandTotal_valor); 

                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell($grandTotal_juros, 'right', 'total');
                    $tr->addCell($grandTotal_multa, 'right', 'total');
                    $tr->addCell($grandTotal_desconto, 'right', 'total');
                    $tr->addCell($grandTotal_saldo_apagar, 'right', 'total');
                    $tr->addCell($grandTotal_valor, 'right', 'total');

                    $file = 'report_'.uniqid().".{$reportExtension}";
                    // stores the file
                    if (!file_exists("app/output/{$file}") || is_writable("app/output/{$file}"))
                    {
                        $tr->save("app/output/{$file}");
                    }
                    else
                    {
                        throw new Exception(_t('Permission denied') . ': ' . "app/output/{$file}");
                    }

                    parent::openFile("app/output/{$file}");

                    // shows the success message
                    new TMessage('info', _t('Report generated. Please, enable popups'));
                }
            }
            else
            {
                new TMessage('error', _t('No records found'));
            }

            // close the transaction
            TTransaction::close();
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }

    public function onShow($param = null)
    {

    }


}

