<?php

class ContasrecBlocoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ContasrecBloco';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContasrecBlocoForm';

    use BuilderMasterDetailFieldListTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Geração de Títulos em Bloco");

        $criteria_plano_conta_id = new TCriteria();
        $criteria_centro_custo_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_plano_conta_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_centro_custo_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $id = new TEntry('id');
        $numero_documento = new TEntry('numero_documento');
        $cliente_id = new TDBCombo('cliente_id', 'kraftsoft', 'Cliente', 'id', '{nome}  - {cpf_cnpj}','nome asc'  );
        $forma_pagamento_id = new TDBCombo('forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $valor = new TNumeric('valor', '2', ',', '.' );
        $primeiro_vencimento = new TDate('primeiro_vencimento');
        $dia_fixo = new TCombo('dia_fixo');
        $tipo_geracao = new TCombo('tipo_geracao');
        $dias_entre_parcelas = new TSpinner('dias_entre_parcelas');
        $quantidade_parcelas = new TSpinner('quantidade_parcelas');
        $button_gerar_parcelas = new TButton('button_gerar_parcelas');
        $plano_conta_id = new TDBCombo('plano_conta_id', 'kraftsoft', 'PlanoConta', 'id', '{numero}  - {descricao}','numero asc' , $criteria_plano_conta_id );
        $centro_custo_id = new TDBCombo('centro_custo_id', 'kraftsoft', 'CentroCusto', 'id', '{numero}  - {descricao}','numero asc' , $criteria_centro_custo_id );
        $observacao = new TText('observacao');
        $contasrec_contasrec_bloco_id = new THidden('contasrec_contasrec_bloco_id[]');
        $contasrec_contasrec_bloco___row__id = new THidden('contasrec_contasrec_bloco___row__id[]');
        $contasrec_contasrec_bloco___row__data = new THidden('contasrec_contasrec_bloco___row__data[]');
        $contasrec_contasrec_bloco_forma_pagamento_id = new TDBCombo('contasrec_contasrec_bloco_forma_pagamento_id[]', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $contasrec_contasrec_bloco_numero_documento = new TEntry('contasrec_contasrec_bloco_numero_documento[]');
        $contasrec_contasrec_bloco_parcela = new TEntry('contasrec_contasrec_bloco_parcela[]');
        $contasrec_contasrec_bloco_data_competencia = new TDate('contasrec_contasrec_bloco_data_competencia[]');
        $contasrec_contasrec_bloco_data_vencimento = new TDate('contasrec_contasrec_bloco_data_vencimento[]');
        $contasrec_contasrec_bloco_valor = new TNumeric('contasrec_contasrec_bloco_valor[]', '2', ',', '.' );
        $this->FieldListParcelas = new TFieldList();

        $this->FieldListParcelas->addField(null, $contasrec_contasrec_bloco_id, []);
        $this->FieldListParcelas->addField(null, $contasrec_contasrec_bloco___row__id, ['uniqid' => true]);
        $this->FieldListParcelas->addField(null, $contasrec_contasrec_bloco___row__data, []);
        $this->FieldListParcelas->addField(new TLabel("Forma de pagamento", null, '14px', null), $contasrec_contasrec_bloco_forma_pagamento_id, ['width' => '30%']);
        $this->FieldListParcelas->addField(new TLabel("Número Documento", null, '14px', null), $contasrec_contasrec_bloco_numero_documento, ['width' => '15%']);
        $this->FieldListParcelas->addField(new TLabel("Parcela", null, '14px', null), $contasrec_contasrec_bloco_parcela, ['width' => '5%']);
        $this->FieldListParcelas->addField(new TLabel("Data Competência", null, '14px', null), $contasrec_contasrec_bloco_data_competencia, ['width' => '15%']);
        $this->FieldListParcelas->addField(new TLabel("Data Vencimento", null, '14px', null), $contasrec_contasrec_bloco_data_vencimento, ['width' => '15%']);
        $this->FieldListParcelas->addField(new TLabel("Valor", null, '14px', null), $contasrec_contasrec_bloco_valor, ['width' => '30%']);

        $this->FieldListParcelas->width = '100%';
        $this->FieldListParcelas->setFieldPrefix('contasrec_contasrec_bloco');
        $this->FieldListParcelas->name = 'FieldListParcelas';

        $this->criteria_FieldListParcelas = new TCriteria();
        $this->default_item_FieldListParcelas = new stdClass();

        $this->form->addField($contasrec_contasrec_bloco_id);
        $this->form->addField($contasrec_contasrec_bloco___row__id);
        $this->form->addField($contasrec_contasrec_bloco___row__data);
        $this->form->addField($contasrec_contasrec_bloco_forma_pagamento_id);
        $this->form->addField($contasrec_contasrec_bloco_numero_documento);
        $this->form->addField($contasrec_contasrec_bloco_parcela);
        $this->form->addField($contasrec_contasrec_bloco_data_competencia);
        $this->form->addField($contasrec_contasrec_bloco_data_vencimento);
        $this->form->addField($contasrec_contasrec_bloco_valor);

        $this->FieldListParcelas->setRemoveAction(null, 'fas:times #dd5a43', "Excluír");

        $numero_documento->addValidation("Número Documento", new TRequiredValidator()); 
        $cliente_id->addValidation("Cliente id", new TRequiredValidator()); 
        $forma_pagamento_id->addValidation("Forma pagamento id", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 
        $primeiro_vencimento->addValidation("Primeiro Vencimento", new TRequiredValidator()); 
        $tipo_geracao->addValidation("Tipo geração", new TRequiredValidator()); 
        $quantidade_parcelas->addValidation("Quantidade Parcelas", new TRequiredValidator()); 
        $plano_conta_id->addValidation("Plano conta id", new TRequiredValidator()); 
        $centro_custo_id->addValidation("Centro custo id", new TRequiredValidator()); 
        $contasrec_contasrec_bloco_forma_pagamento_id->addValidation("Forma pagamento id", new TRequiredListValidator()); 
        $contasrec_contasrec_bloco_data_vencimento->addValidation("Data Vencimento", new TRequiredListValidator()); 
        $contasrec_contasrec_bloco_valor->addValidation("Valor", new TRequiredListValidator()); 

        $id->setEditable(false);
        $button_gerar_parcelas->setAction(new TAction([$this, 'onGerarParcelas']), "Gerar Parcelas");
        $button_gerar_parcelas->addStyleClass('btn-default');
        $button_gerar_parcelas->setImage('fas:calendar-alt #4CAF50');
        $dia_fixo->addItems(["1"=>" Sim","0"=>" Não"]);
        $tipo_geracao->addItems(["valorparcela"=>" Valor da Parcela","valortotal"=>"Valor Total"]);

        $dias_entre_parcelas->setRange(1, 2000, 1);
        $quantidade_parcelas->setRange(1, 2000, 1);

        $primeiro_vencimento->setMask('dd/mm/yyyy');
        $contasrec_contasrec_bloco_data_vencimento->setMask('dd/mm/yyyy');
        $contasrec_contasrec_bloco_data_competencia->setMask('dd/mm/yyyy');

        $primeiro_vencimento->setDatabaseMask('yyyy-mm-dd');
        $contasrec_contasrec_bloco_data_vencimento->setDatabaseMask('yyyy-mm-dd');
        $contasrec_contasrec_bloco_data_competencia->setDatabaseMask('yyyy-mm-dd');

        $dia_fixo->setValue('0');
        $dias_entre_parcelas->setValue('30');
        $tipo_geracao->setValue('valorparcela');

        $dia_fixo->enableSearch();
        $cliente_id->enableSearch();
        $tipo_geracao->enableSearch();
        $plano_conta_id->enableSearch();
        $centro_custo_id->enableSearch();
        $forma_pagamento_id->enableSearch();
        $contasrec_contasrec_bloco_forma_pagamento_id->enableSearch();

        $id->setSize(100);
        $valor->setSize('100%');
        $dia_fixo->setSize('100%');
        $cliente_id->setSize('100%');
        $tipo_geracao->setSize('100%');
        $plano_conta_id->setSize('100%');
        $observacao->setSize('100%', 70);
        $centro_custo_id->setSize('100%');
        $numero_documento->setSize('100%');
        $forma_pagamento_id->setSize('100%');
        $primeiro_vencimento->setSize('100%');
        $dias_entre_parcelas->setSize('100%');
        $quantidade_parcelas->setSize('100%');
        $contasrec_contasrec_bloco_valor->setSize('100%');
        $contasrec_contasrec_bloco_parcela->setSize('100%');
        $contasrec_contasrec_bloco_data_vencimento->setSize(110);
        $contasrec_contasrec_bloco_data_competencia->setSize(110);
        $contasrec_contasrec_bloco_numero_documento->setSize('100%');
        $contasrec_contasrec_bloco_forma_pagamento_id->setSize('100%');

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Número Documento:", '#FF0000', '14px', null, '100%'),$numero_documento]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Cliente:", '#ff0000', '14px', null, '100%'),$cliente_id],[new TLabel("Forma de pagamento:", '#ff0000', '14px', null, '100%'),$forma_pagamento_id]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Primeiro Vencimento:", '#FF0000', '14px', null, '100%'),$primeiro_vencimento],[new TLabel("Dia Fixo:", '#FF0000', '14px', null),$dia_fixo]);
        $row3->layout = ['col-sm-3','col-sm-3','col-sm-2'];

        $row4 = $this->form->addFields([new TLabel("Tipo de Geração:", '#FF0000', '14px', null, '100%'),$tipo_geracao],[new TLabel("Dias entre parcelas:", '#FF0000', '14px', null, '100%'),$dias_entre_parcelas],[new TLabel("Quantidade Parcelas:", '#ff0000', '14px', null, '100%'),$quantidade_parcelas],[new TLabel(" ", null, '14px', null, '100%'),$button_gerar_parcelas]);
        $row4->layout = [' col-sm-3',' col-sm-3','col-sm-3','col-sm-3'];

        $row5 = $this->form->addFields([new TLabel("Plano de conta:", '#ff0000', '14px', null, '100%'),$plano_conta_id],[new TLabel("Centro de custo:", '#ff0000', '14px', null, '100%'),$centro_custo_id]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$observacao]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->form->addContent([new TFormSeparator("Parcelas", '#333', '18', '#eee')]);
        $row8 = $this->form->addFields([$this->FieldListParcelas]);
        $row8->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ContasrecBlocoForm]');
        $style->width = '90% !important';   
        $style->show(true);

    }

    public static function onGerarParcelas($param = null) 
    {
        try 
        {
            // como o método é estático não podemos utilizr o $this
            // temos que trabalhar apenas com o $param onde vem os dados que foram preenchidos pelo usuário
            // nesse caso vamos ter que converter o valor total para double e também a data para o formato americano
            // verificando se os campos foram preenchidos
            (new TRequiredValidator)->validate('Número Documento', $param['numero_documento'] );
            (new TRequiredValidator)->validate('Valor', $param['valor'] );
            (new TRequiredValidator)->validate('Quantidade de Parcelas', $param['quantidade_parcelas']);
            (new TRequiredValidator)->validate('Primeiro vencimento', $param['primeiro_vencimento']);
            (new TRequiredValidator)->validate('Cliente', $param['cliente_id']);
            (new TRequiredValidator)->validate('Forma de Pagamento', $param['forma_pagamento_id']);
            (new TRequiredValidator)->validate('Plano de Conta', $param['plano_conta_id']);
            (new TRequiredValidator)->validate('Centro de Custo', $param['centro_custo_id']);
            (new TRequiredValidator)->validate('Tipo de geração', $param['tipo_geracao']);
            (new TRequiredValidator)->validate('Dias entre parcelas', $param['dias_entre_parcelas']);            

            //validando o plano de conta
            ContabilLancamentos::ValidaLancamentoContabil($param['plano_conta_id'],$param['centro_custo_id'],PlanoContaOrigem::Credora);            

            // convertendo o valor que vem no formato brasileiro para formato americano
            $valor = (double) str_replace(',', '.', str_replace('.', '', $param['valor']));

            // convertendo a data para o farmato americano
            $primeiro_vencimento = TDate::date2us($param['primeiro_vencimento']);
            $parcelas = $param['quantidade_parcelas'];
            $tipo_geracao = $param['tipo_geracao'];
            $dias_entre_parcelas = $param['dias_entre_parcelas'];    
            $dia_fixo = $param['dia_fixo'];

            // calcula o valor da parcela
            if ($tipo_geracao=='valortotal')
            {
                $valorParcela = $valor / $parcelas;
            }
            else
            {
                $valorParcela = $valor;
            }

            // transforma a data de vencimento em um objeto da classe DateTime
            $data_vencimento = new DateTime($primeiro_vencimento);

            // Extrai o dia do $primeiro_vencimento
            $dia_primeiro_vencimento = (int) date('d', strtotime($primeiro_vencimento));                 

            $data = new stdClass();
            $data->contasrec_contasrec_bloco_forma_pagamento_id = [];
            $data->contasrec_contasrec_bloco_numero_documento = [];
            $data->contasrec_contasrec_bloco_parcela = [];
            $data->contasrec_contasrec_bloco_data_competencia = [];
            $data->contasrec_contasrec_bloco_data_vencimento = [];
            $data->contasrec_contasrec_bloco_valor = [];

            for($i = 0 ; $i < $parcelas; $i++)
            {
                // populando o array das propriedades do fieldlist

                // Define o dia da data de vencimento como o mínimo entre o dia do $primeiro_vencimento e o último dia do mês
                $ultimoDiaDoMes = $data_vencimento->format('t');
                $diaParaDefinir = min($dia_primeiro_vencimento, $ultimoDiaDoMes);                

                // Verifica se $dia_fixo é igual a 1
                if ($dia_fixo == 1) {
                    $data_vencimento->setDate(
                        $data_vencimento->format('Y'),
                        $data_vencimento->format('m'),
                        $diaParaDefinir
                    );
                }                      

                $data->contasrec_contasrec_bloco_forma_pagamento_id[] = $param['forma_pagamento_id'];
                $data->contasrec_contasrec_bloco_numero_documento[] = $param['numero_documento'];
                $data->contasrec_contasrec_bloco_parcela[] = ($i+1).'/'.$parcelas;
                $data->contasrec_contasrec_bloco_data_competencia[] = $data_vencimento->format('d/m/Y');
                $data->contasrec_contasrec_bloco_data_vencimento[] = $data_vencimento->format('d/m/Y');
                $data->contasrec_contasrec_bloco_valor[] = number_format($valorParcela, 2, ',','.');;                

                // acrescenta um mês a data de vencimento
                // $data_vencimento->modify( 'next month' );
                //$data_vencimento->modify( '+ '.$dias_entre_parcelas.' days' );

                // acrescenta um mês ou dias a data de vencimento
                if ($dia_fixo != 1) {
                    $data_vencimento->modify('next month');
                } else {
                    $data_vencimento->modify('+' . $dias_entre_parcelas . ' days');
                }                      
            }

            // limpa o TFieldList
            // o primeiro parâmetro é o nome da variável definida para o TFieldList
            TFieldList::clearRows('FieldListParcelas');

            // adicionamos as linhas novas
            // primeiro parâmetro é o nome da variável definida para o TFieldList
            TFieldList::addRows('FieldListParcelas', $parcelas - 1, 1);

            // enviando os dados para o field list
            //TForm::sendData(self::$formName, $data);
            TForm::sendData(self::$formName, $data, false, true, 500);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ContasrecBloco(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->system_unit_id = TSession::getValue('userunitid');
            $object->contasrec_origem_id = ContasrecOrigem::Avulso;            

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $contasrec_contasrec_bloco_items = $this->storeItems('Contasrec', 'contasrec_bloco_id', $object, $this->FieldListParcelas, function($masterObject, $detailObject){ 

                //code here
                echo 'Aqui' . '</br>';
                //salvando o nome do usuario
                Funcoes::SalvarUsuarioCadastro($detailObject);                

                $detailObject->data_emissao = TDate::date2us(date('d/m/Y'));
                $detailObject->cliente_id = $masterObject->cliente_id;
                $detailObject->forma_pagamento_id = $masterObject->forma_pagamento_id;
                $detailObject->observacao = $masterObject->observacao;
                $detailObject->contasrec_origem_id = ContasrecOrigem::Avulso;
                $detailObject->contasrec_situacao_id = ContasrecSituacao::EmAberto;
                $detailObject->system_unit_id = TSession::getValue('userunitid');
                $detailObject->valor_aberto = $detailObject->valor;
                $detailObject->data_venc_original = $detailObject->data_vencimento;   
                $detailObject->plano_conta_id = $masterObject->plano_conta_id;
                $detailObject->centro_custo_id = $masterObject->centro_custo_id;
                $detailObject->desconto = '0,00';
                $detailObject->valor_multa = '0,00';
                $detailObject->juros = '0,00';
                $detailObject->valor_pago = '0,00';    
                $detailObject->ativo_id = Ativo::Ativo;

            }, $this->criteria_FieldListParcelas); 

            //validar a soma dos titulos, tem que bater com o valor do bloco....
           /* $soma_parcelas = (double) Contasrec::where('contasrec_bloco_id', '=',  $object->id)
                                               ->sumby('valor');    

            $soma_parcelas = (double) number_format($soma_parcelas, 2, '.', '');                                                   

            if ($soma_parcelas<>$object->valor) 
            {
                throw new Exception('Total das parcelas não é o mesmo do valor total! Verifique.');
            }

            //consultar os contas a receber gerados e incluir os lançamentos contabeis de cada
            $lista_contasrec = Contasrec::where('contasrec_bloco_id', '=', $object->id)->load(); 

            RETIRADO ESSA VALIDAÇÃO DEPOIS QUE FOI INCLUIDO O TIPO DA GERAÇÃO*/

            foreach ($lista_contasrec as $crec) 
            {            
                ContabilLancamentos::LancamentoContabil($crec->plano_conta_id,
                                                        $crec->centro_custo_id,
                                                        ContabilLancamentosTipo::Credito,
                                                        ContabilLancamentosSituacao::NaoLiquidado,
                                                        ContabilLancamentosOrigem::ContasRec,
                                                        $crec->id,
                                                        $crec->data_vencimento,
                                                        $crec->valor,
                                                        'Ref. Crédito Cliente: '.$crec->cliente->nome);                   
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               Contasrec::Evento_ContasRecIncluidoOuAlterado,
                                               $object,
                                               'Contas a receber em bloco do cliente '.$object->cliente->nome.' , '.
                                               'Valor do bloco: R$ '.number_format($object->valor,2, ',', '.').' , '.
                                               'Quantidade de Parcelas: '.$object->quantidade_parcelas); 

            TTransaction::close();                

            TToast::show('success', "Títulos gerados com sucesso!", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContasrecList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();");
            TForm::sendData(self::$formName, (object)['id' => $object->id]);

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ContasrecBloco($key); // instantiates the Active Record 

                $this->FieldListParcelas_items = $this->loadItems('Contasrec', 'contasrec_bloco_id', $object, $this->FieldListParcelas, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }, $this->criteria_FieldListParcelas); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $this->FieldListParcelas->addHeader();
        $this->FieldListParcelas->addDetail($this->default_item_FieldListParcelas);

        $this->FieldListParcelas->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    }

    public function onShow($param = null)
    {
        $this->FieldListParcelas->addHeader();
        $this->FieldListParcelas->addDetail($this->default_item_FieldListParcelas);

        $this->FieldListParcelas->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

        # REMOVE O BOTÃO ADICIONAR DO TFieldList
        $this->FieldListParcelas->getFoot()->clearChildren();

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

