<?php

class ContasrecClienteReport extends TPage
{
    private $form; // form
    private $loaded;
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Contasrec';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContasrecReport';

    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);

        // define the form title
        $this->form->setFormTitle("Relatório de Contas a Receber por Cliente");

        $id = new TEntry('id');
        $numero_documento = new TEntry('numero_documento');
        $contasrec_origem_id = new TDBCombo('contasrec_origem_id', 'kraftsoft', 'ContasrecOrigem', 'id', '{descricao}','descricao asc'  );
        $forma_pagamento_id = new TDBCombo('forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $contasrec_situacao_id = new TDBSelect('contasrec_situacao_id', 'kraftsoft', 'ContasrecSituacao', 'id', '{descricao}','id asc'  );
        $cliente_id = new TDBCombo('cliente_id', 'kraftsoft', 'Cliente', 'id', '{nome}','nome asc'  );
        $data_emissao_inicial = new TDate('data_emissao_inicial');
        $data_emissao_final = new TDate('data_emissao_final');
        $data_vencimento = new TDate('data_vencimento');
        $data_vencimento_final = new TDate('data_vencimento_final');
        $data_pagamento = new TDate('data_pagamento');
        $data_pagamento_final = new TDate('data_pagamento_final');
        $data_competencia_inicial = new TDate('data_competencia_inicial');
        $data_competencia_final = new TDate('data_competencia_final');

        $cliente_id->enableSearch();
        $forma_pagamento_id->enableSearch();
        $contasrec_origem_id->enableSearch();
        $contasrec_situacao_id->enableSearch();

        $data_pagamento->setMask('dd/mm/yyyy');
        $data_vencimento->setMask('dd/mm/yyyy');
        $data_emissao_final->setMask('dd/mm/yyyy');
        $data_emissao_inicial->setMask('dd/mm/yyyy');
        $data_pagamento_final->setMask('dd/mm/yyyy');
        $data_vencimento_final->setMask('dd/mm/yyyy');
        $data_competencia_final->setMask('dd/mm/yyyy');
        $data_competencia_inicial->setMask('dd/mm/yyyy');

        $data_pagamento->setDatabaseMask('yyyy-mm-dd');
        $data_vencimento->setDatabaseMask('yyyy-mm-dd');
        $data_emissao_final->setDatabaseMask('yyyy-mm-dd');
        $data_emissao_inicial->setDatabaseMask('yyyy-mm-dd');
        $data_pagamento_final->setDatabaseMask('yyyy-mm-dd');
        $data_vencimento_final->setDatabaseMask('yyyy-mm-dd');
        $data_competencia_final->setDatabaseMask('yyyy-mm-dd');
        $data_competencia_inicial->setDatabaseMask('yyyy-mm-dd');

        $id->setSize('100%');
        $cliente_id->setSize('100%');
        $data_pagamento->setSize('100%');
        $data_vencimento->setSize('100%');
        $numero_documento->setSize('100%');
        $forma_pagamento_id->setSize('100%');
        $data_emissao_final->setSize('100%');
        $contasrec_origem_id->setSize('100%');
        $data_emissao_inicial->setSize('100%');
        $data_pagamento_final->setSize('100%');
        $data_vencimento_final->setSize('100%');
        $data_competencia_final->setSize('100%');
        $data_competencia_inicial->setSize('100%');
        $contasrec_situacao_id->setSize('100%', 70);

        $row1 = $this->form->addFields([new TLabel("Nº Título (id):", null, '14px', null, '100%'),$id],[new TLabel("Número Documento:", null, '14px', null, '100%'),$numero_documento]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Origem:", null, '14px', null),$contasrec_origem_id],[new TLabel("Forma de Pagamento:", null, '14px', null),$forma_pagamento_id]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Situação:", null, '14px', null),$contasrec_situacao_id],[new TLabel("Cliente:", '#EC0606', '14px', null),$cliente_id]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Data Emissão Inicial:", null, '14px', null, '100%'),$data_emissao_inicial],[new TLabel("Data Emissão Final:", null, '14px', null, '100%'),$data_emissao_final],[new TLabel("Data Vencimento Inicial:", null, '14px', null, '100%'),$data_vencimento],[new TLabel("Data Vencimento Final:", null, '14px', null, '100%'),$data_vencimento_final]);
        $row4->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row5 = $this->form->addFields([new TLabel("Data Pagamento Inicial:", null, '14px', null, '100%'),$data_pagamento],[new TLabel("Data Pagamento Final:", null, '14px', null, '100%'),$data_pagamento_final],[new TLabel("Data Competência Inicial:", null, '14px', null, '100%'),$data_competencia_inicial],[new TLabel("Data Competência Final:", null, '14px', null, '100%'),$data_competencia_final]);
        $row5->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        // keep the form filled during navigation with session data
        $this->form->setData( TSession::getValue(__CLASS__.'_filter_data') );

        $btn_ongeneratehtml = $this->form->addAction("Gerar HTML", new TAction([$this, 'onGenerateHtml']), 'far:file-code #ffffff');
        $this->btn_ongeneratehtml = $btn_ongeneratehtml;
        $btn_ongeneratehtml->addStyleClass('btn-primary'); 

        $btn_ongeneratepdf = $this->form->addAction("Gerar PDF", new TAction([$this, 'onGeneratePdf']), 'far:file-pdf #d44734');
        $this->btn_ongeneratepdf = $btn_ongeneratepdf;

        $btn_ongeneratexls = $this->form->addAction("Gerar XLS", new TAction([$this, 'onGenerateXls']), 'far:file-excel #00a65a');
        $this->btn_ongeneratexls = $btn_ongeneratexls;

        $btn_ongeneratertf = $this->form->addAction("Gerar RTF", new TAction([$this, 'onGenerateRtf']), 'far:file-alt #324bcc');
        $this->btn_ongeneratertf = $btn_ongeneratertf;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        $container->add(TBreadCrumb::create(["Financeiro","Relatório de Contas a Receber por Cliente"]));
        $container->add($this->form);

        parent::add($container);

    }

    public function onGenerateHtml($param = null) 
    {
        $this->onGenerate('html');
    }
    public function onGeneratePdf($param = null) 
    {
        $this->onGenerate('pdf');
    }
    public function onGenerateXls($param = null) 
    {
        $this->onGenerate('xls');
    }
    public function onGenerateRtf($param = null) 
    {
        $this->onGenerate('rtf');
    }

    /**
     * Register the filter in the session
     */
    public function getFilters()
    {
        // get the search form data
        $data = $this->form->getData();

        $filters = [];

        TSession::setValue(__CLASS__.'_filter_data', NULL);
        TSession::setValue(__CLASS__.'_filters', NULL);

        if (isset($data->id) AND ( (is_scalar($data->id) AND $data->id !== '') OR (is_array($data->id) AND (!empty($data->id)) )) )
        {

            $filters[] = new TFilter('id', '=', $data->id);// create the filter 
        }
        if (isset($data->numero_documento) AND ( (is_scalar($data->numero_documento) AND $data->numero_documento !== '') OR (is_array($data->numero_documento) AND (!empty($data->numero_documento)) )) )
        {

            $filters[] = new TFilter('numero_documento', 'like', "%{$data->numero_documento}%");// create the filter 
        }
        if (isset($data->contasrec_origem_id) AND ( (is_scalar($data->contasrec_origem_id) AND $data->contasrec_origem_id !== '') OR (is_array($data->contasrec_origem_id) AND (!empty($data->contasrec_origem_id)) )) )
        {

            $filters[] = new TFilter('contasrec_origem_id', '=', $data->contasrec_origem_id);// create the filter 
        }
        if (isset($data->forma_pagamento_id) AND ( (is_scalar($data->forma_pagamento_id) AND $data->forma_pagamento_id !== '') OR (is_array($data->forma_pagamento_id) AND (!empty($data->forma_pagamento_id)) )) )
        {

            $filters[] = new TFilter('forma_pagamento_id', '=', $data->forma_pagamento_id);// create the filter 
        }
        if (isset($data->contasrec_situacao_id) AND ( (is_scalar($data->contasrec_situacao_id) AND $data->contasrec_situacao_id !== '') OR (is_array($data->contasrec_situacao_id) AND (!empty($data->contasrec_situacao_id)) )) )
        {

            $filters[] = new TFilter('contasrec_situacao_id', 'in', $data->contasrec_situacao_id);// create the filter 
        }
        if (isset($data->cliente_id) AND ( (is_scalar($data->cliente_id) AND $data->cliente_id !== '') OR (is_array($data->cliente_id) AND (!empty($data->cliente_id)) )) )
        {

            $filters[] = new TFilter('cliente_id', '=', $data->cliente_id);// create the filter 
        }
        if (isset($data->data_emissao_inicial) AND ( (is_scalar($data->data_emissao_inicial) AND $data->data_emissao_inicial !== '') OR (is_array($data->data_emissao_inicial) AND (!empty($data->data_emissao_inicial)) )) )
        {

            $filters[] = new TFilter('data_emissao', '>=', $data->data_emissao_inicial);// create the filter 
        }
        if (isset($data->data_emissao_final) AND ( (is_scalar($data->data_emissao_final) AND $data->data_emissao_final !== '') OR (is_array($data->data_emissao_final) AND (!empty($data->data_emissao_final)) )) )
        {

            $filters[] = new TFilter('data_emissao', '<=', $data->data_emissao_final);// create the filter 
        }
        if (isset($data->data_vencimento) AND ( (is_scalar($data->data_vencimento) AND $data->data_vencimento !== '') OR (is_array($data->data_vencimento) AND (!empty($data->data_vencimento)) )) )
        {

            $filters[] = new TFilter('data_vencimento', '>=', $data->data_vencimento);// create the filter 
        }
        if (isset($data->data_vencimento_final) AND ( (is_scalar($data->data_vencimento_final) AND $data->data_vencimento_final !== '') OR (is_array($data->data_vencimento_final) AND (!empty($data->data_vencimento_final)) )) )
        {

            $filters[] = new TFilter('data_vencimento', '<=', $data->data_vencimento_final);// create the filter 
        }
        if (isset($data->data_pagamento) AND ( (is_scalar($data->data_pagamento) AND $data->data_pagamento !== '') OR (is_array($data->data_pagamento) AND (!empty($data->data_pagamento)) )) )
        {

            $filters[] = new TFilter('data_pagamento', '>=', $data->data_pagamento);// create the filter 
        }
        if (isset($data->data_pagamento_final) AND ( (is_scalar($data->data_pagamento_final) AND $data->data_pagamento_final !== '') OR (is_array($data->data_pagamento_final) AND (!empty($data->data_pagamento_final)) )) )
        {

            $filters[] = new TFilter('data_pagamento', '<=', $data->data_pagamento_final);// create the filter 
        }
        if (isset($data->data_competencia_inicial) AND ( (is_scalar($data->data_competencia_inicial) AND $data->data_competencia_inicial !== '') OR (is_array($data->data_competencia_inicial) AND (!empty($data->data_competencia_inicial)) )) )
        {

            $filters[] = new TFilter('data_competencia', '>=', $data->data_competencia_inicial);// create the filter 
        }
        if (isset($data->data_competencia_final) AND ( (is_scalar($data->data_competencia_final) AND $data->data_competencia_final !== '') OR (is_array($data->data_competencia_final) AND (!empty($data->data_competencia_final)) )) )
        {

            $filters[] = new TFilter('data_competencia', '<=', $data->data_competencia_final);// create the filter 
        }

        // fill the form with data again
        $this->form->setData($data);

        // keep the search data in the session
        TSession::setValue(__CLASS__.'_filter_data', $data);

        return $filters;
    }

    public function onGenerate($format)
    {
        try
        {
            $filters = $this->getFilters();
            // open a transaction with database 'kraftsoft'
            TTransaction::open(self::$database);
            $param = [];
            // creates a repository for Contasrec
            $repository = new TRepository(self::$activeRecord);
            // creates a criteria
            $criteria = new TCriteria;

            $filterVar = TSession::getValue("userunitid");
            $criteria->add(new TFilter('system_unit_id', '=', $filterVar));

            $param['order'] = 'cliente_id,data_vencimento';
            $param['direction'] = 'asc';

            $criteria->setProperties($param);

            if ($filters)
            {
                foreach ($filters as $filter) 
                {
                    $criteria->add($filter);       
                }
            }

            $data = $this->form->getData();

            (new TRequiredValidator)->validate('Cliente', $data->cliente_id);

            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);

            if ($objects)
            {
                $widths = array(200,200,200,200,200,200,200,200,200,200,200);
                $reportExtension = 'pdf';
                switch ($format)
                {
                    case 'html':
                        $tr = new TTableWriterHTML($widths);
                        $reportExtension = 'html';
                        break;
                    case 'xls':
                        $tr = new TTableWriterXLS($widths);
                        $reportExtension = 'xls';
                        break;
                    case 'pdf':
                        $tr = new TTableWriterPDF($widths, 'L', 'A4');
                        $reportExtension = 'pdf';
                        break;
                    case 'htmlPdf':
                        $reportExtension = 'pdf';
                        $tr = new BTableWriterHtmlPDF($widths, 'L', 'A4');
                        break;
                    case 'rtf':
                        if (!class_exists('PHPRtfLite_Autoloader'))
                        {
                            PHPRtfLite::registerAutoloader();
                        }
                        $reportExtension = 'rtf';
                        $tr = new TTableWriterRTF($widths, 'L', 'A4');
                        break;
                }

                if (!empty($tr))
                {
                    // create the document styles
                    $tr->addStyle('title', 'Helvetica', '10', 'B',   '#ffffff', '#96c0e6');
                    $tr->addStyle('datap', 'Arial', '10', '',    '#000000', '#f0f0f0');
                    $tr->addStyle('datai', 'Arial', '10', '',    '#000000', '#ffffff');
                    $tr->addStyle('header', 'Helvetica', '16', 'B',   '#4589c5', '#494D90');
                    $tr->addStyle('footer', 'Helvetica', '10', 'B',  '#4589c5', '#B1B1EA');
                    $tr->addStyle('break', 'Helvetica', '10', 'B',  '#ffffff', '#8da4bc');
                    $tr->addStyle('total', 'Helvetica', '10', 'I',  '#000000', '#b2d1dc');
                    $tr->addStyle('breakTotal', 'Helvetica', '10', 'I',  '#000000', '#b3d5f3');

                    // Quando o relatório a ser gerado for PDF
                    if ($format == 'pdf')
                    {
                        // Adiciona o cabeçalho
                        $tr->setHeaderCallback(
                            function($tr)
                            {
                                $pdf = $tr->getNativeWriter();

                                // Define a fonte/ estilos
                                $pdf->SetFont('Arial','B',15); 

                                // Define o posicionamento do texto
                                $pdf->Cell(80); 

                                // Texto do cabeçalho
                                $pdf->Cell(100,10, utf8_decode('Relatório de Contas a Receber por Cliente') ,0,0,'C'); 
                                $pdf->Ln(10); 

                            }
                        );

                        // Adiciona o footer do relatório
                        $tr->setFooterCallback(
                            function($tr)
                            {
                                $pdf = $tr->getNativeWriter();

                                // Necessário para obter o número total de páginas
                                $pdf->AliasNbPages();

                                // Posiciona o footer no final da página
                                $pdf->SetY(-40);

                                // Define o estilho do footer
                                $pdf->SetFont('Arial'   ,'B',12); 
                                $pdf->Cell(110); 

                                // Obtém o número da página atual
                                $numero = $pdf->PageNo();

                                // Footer
                                $pdf->Cell(0,10, utf8_decode("Página: {$numero}/{nb}") ,0,0,'R');

                                // Line break 
                                $pdf->Ln(20); 
                            }
                        );
                    }
                    else // Para os demais formatos
                    {
                         $tr->setHeaderCallback(
                            function($tr)
                            {
                                $tr->addRow();
                                $tr->addCell('Relatório de Contas a Receber por Cliente', 'center', 'header', 100);
                            }
                        );

                        $tr->setFooterCallback(
                            function($tr)
                            {
                                $tr->addRow();
                                $tr->addCell(date('d/m/Y h:i:s'), 'center', 'footer', 100);
                            }
                        );
                    }

                    // add titles row
                    $tr->addRow();
                    $tr->addCell("Id", 'left', 'title');
                    $tr->addCell("Nº Documento", 'left', 'title');
                    $tr->addCell("Data Emissão", 'left', 'title');
                    $tr->addCell("Data Pgto", 'left', 'title');
                    $tr->addCell("Cliente", 'left', 'title');
                    $tr->addCell("Forma Pagamento", 'left', 'title');
                    $tr->addCell("Parcela", 'left', 'title');
                    $tr->addCell("Vencimento", 'left', 'title');
                    $tr->addCell("Valor", 'left', 'title');
                    $tr->addCell("Valor Pago", 'left', 'title');
                    $tr->addCell("Situação", 'left', 'title');

                    $grandTotal = [];
                    $breakTotal = [];
                    $breakValue = null;
                    $firstRow = true;

                    // controls the background filling
                    $colour = false;                
                    foreach ($objects as $object)
                    {
                        $style = $colour ? 'datap' : 'datai';

                        if ($object->cliente_id !== $breakValue)
                        {
                            if (!$firstRow)
                            {
                                $tr->addRow();

                                $breakTotal_id = count($breakTotal['id']);
                                $breakTotal_valor = array_sum($breakTotal['valor']);
                                $breakTotal_valor_pago = array_sum($breakTotal['valor_pago']);

                                $breakTotal_valor = call_user_func(function($value)
                                {
                                    if(!$value)
                                    {
                                        $value = 0;
                                    }

                                    if(is_numeric($value))
                                    {
                                        return "R$ " . number_format($value, 2, ",", ".");
                                    }
                                    else
                                    {
                                        return $value;
                                    }
                                }, $breakTotal_valor); 

                                $breakTotal_valor_pago = call_user_func(function($value)
                                {
                                    if(!$value)
                                    {
                                        $value = 0;
                                    }

                                    if(is_numeric($value))
                                    {
                                        return "R$ " . number_format($value, 2, ",", ".");
                                    }
                                    else
                                    {
                                        return $value;
                                    }
                                }, $breakTotal_valor_pago); 

                                $tr->addCell($breakTotal_id, 'left', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                                $tr->addCell($breakTotal_valor, 'right', 'breakTotal');
                                $tr->addCell($breakTotal_valor_pago, 'right', 'breakTotal');
                                $tr->addCell('', 'center', 'breakTotal');
                            }
                            $tr->addRow();
                            $tr->addCell($object->render('{cliente->nome}  - CPF/CNPJ: {cliente->cpf_cnpj}'), 'left', 'break', 11);
                            $breakTotal = [];
                        }
                        $breakValue = $object->cliente_id;

                        $grandTotal['id'][] = $object->id;
                        $breakTotal['id'][] = $object->id;
                        $grandTotal['valor'][] = $object->valor;
                        $breakTotal['valor'][] = $object->valor;
                        $grandTotal['valor_pago'][] = $object->valor_pago;
                        $breakTotal['valor_pago'][] = $object->valor_pago;

                        $firstRow = false;

                        $object->data_emissao = call_user_func(function($value, $object, $row) 
                        {
                            if(!empty(trim($value)))
                            {
                                try
                                {
                                    $date = new DateTime($value);
                                    return $date->format('d/m/Y');
                                }
                                catch (Exception $e)
                                {
                                    return $value;
                                }
                            }
                        }, $object->data_emissao, $object, null);

                        $object->data_pagamento = call_user_func(function($value, $object, $row) 
                        {
                            if(!empty(trim($value)))
                            {
                                try
                                {
                                    $date = new DateTime($value);
                                    return $date->format('d/m/Y');
                                }
                                catch (Exception $e)
                                {
                                    return $value;
                                }
                            }
                        }, $object->data_pagamento, $object, null);

                        $object->data_vencimento = call_user_func(function($value, $object, $row) 
                        {
                            if(!empty(trim($value)))
                            {
                                try
                                {
                                    $date = new DateTime($value);
                                    return $date->format('d/m/Y');
                                }
                                catch (Exception $e)
                                {
                                    return $value;
                                }
                            }
                        }, $object->data_vencimento, $object, null);

                        $object->valor = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->valor, $object, null);

                        $object->valor_pago = call_user_func(function($value, $object, $row) 
                        {
                            if(!$value)
                            {
                                $value = 0;
                            }

                            if(is_numeric($value))
                            {
                                return "R$ " . number_format($value, 2, ",", ".");
                            }
                            else
                            {
                                return $value;
                            }
                        }, $object->valor_pago, $object, null);

                        $tr->addRow();

                        $tr->addCell($object->id, 'left', $style);
                        $tr->addCell($object->numero_documento, 'left', $style);
                        $tr->addCell($object->data_emissao, 'left', $style);
                        $tr->addCell($object->data_pagamento, 'left', $style);
                        $tr->addCell($object->cliente->nome, 'left', $style);
                        $tr->addCell($object->forma_pagamento->descricao, 'left', $style);
                        $tr->addCell($object->parcela, 'left', $style);
                        $tr->addCell($object->data_vencimento, 'left', $style);
                        $tr->addCell($object->valor, 'right', $style);
                        $tr->addCell($object->valor_pago, 'right', $style);
                        $tr->addCell($object->contasrec_situacao->descricao, 'left', $style);

                        $colour = !$colour;

                    }

                    $tr->addRow();

                    $breakTotal_id = count($breakTotal['id']);
                    $breakTotal_valor = array_sum($breakTotal['valor']);
                    $breakTotal_valor_pago = array_sum($breakTotal['valor_pago']);

                    $breakTotal_valor = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $breakTotal_valor); 

                    $breakTotal_valor_pago = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $breakTotal_valor_pago); 

                    $tr->addCell($breakTotal_id, 'left', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');
                    $tr->addCell($breakTotal_valor, 'right', 'breakTotal');
                    $tr->addCell($breakTotal_valor_pago, 'right', 'breakTotal');
                    $tr->addCell('', 'center', 'breakTotal');

                    $tr->addRow();

                    $grandTotal_id = count($grandTotal['id']);
                    $grandTotal_valor = array_sum($grandTotal['valor']);
                    $grandTotal_valor_pago = array_sum($grandTotal['valor_pago']);

                    $grandTotal_valor = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $grandTotal_valor); 

                    $grandTotal_valor_pago = call_user_func(function($value)
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $grandTotal_valor_pago); 

                    $tr->addCell($grandTotal_id, 'left', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell('', 'center', 'total');
                    $tr->addCell($grandTotal_valor, 'right', 'total');
                    $tr->addCell($grandTotal_valor_pago, 'right', 'total');
                    $tr->addCell('', 'center', 'total');

                    $file = 'report_'.uniqid().".{$reportExtension}";
                    // stores the file
                    if (!file_exists("app/output/{$file}") || is_writable("app/output/{$file}"))
                    {
                        $tr->save("app/output/{$file}");
                    }
                    else
                    {
                        throw new Exception(_t('Permission denied') . ': ' . "app/output/{$file}");
                    }

                    parent::openFile("app/output/{$file}");

                    // shows the success message
                    new TMessage('info', _t('Report generated. Please, enable popups'));
                }
            }
            else
            {
                new TMessage('error', _t('No records found'));
            }

            // close the transaction
            TTransaction::close();
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }

    public function onShow($param = null)
    {

    }


}

