<?php

class ContasrecForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Contasrec';
    private static $primaryKey = 'id';
    private static $formName = 'form_ContasrecForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de contas a receber");

        $criteria_plano_conta_id = new TCriteria();
        $criteria_centro_custo_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_plano_conta_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_centro_custo_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $contasrec_situacao_id = new TDBArrowStep('contasrec_situacao_id', 'kraftsoft', 'ContasrecSituacao', 'id', '{descricao}','id asc'  );
        $id = new TEntry('id');
        $data_venc_original = new TDate('data_venc_original');
        $data_pagamento = new TDate('data_pagamento');
        $data_emissao = new TDate('data_emissao');
        $data_vencimento = new TDate('data_vencimento');
        $data_competencia = new TDate('data_competencia');
        $cliente_id = new TDBCombo('cliente_id', 'kraftsoft', 'Cliente', 'id', '{nome}','nome asc'  );
        $forma_pagamento_id = new TDBCombo('forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $contasrec_origem_id = new TDBCombo('contasrec_origem_id', 'kraftsoft', 'ContasrecOrigem', 'id', '{descricao}','descricao asc'  );
        $plano_conta_id = new TDBCombo('plano_conta_id', 'kraftsoft', 'PlanoConta', 'id', '{numero}  - {descricao}','numero asc' , $criteria_plano_conta_id );
        $centro_custo_id = new TDBCombo('centro_custo_id', 'kraftsoft', 'CentroCusto', 'id', '{numero}  - {descricao}','numero asc' , $criteria_centro_custo_id );
        $numero_documento = new TEntry('numero_documento');
        $parcela = new TEntry('parcela');
        $valor = new TNumeric('valor', '2', ',', '.' );
        $valor_pago = new TNumeric('valor_pago', '2', ',', '.' );
        $valor_aberto = new TNumeric('valor_aberto', '2', ',', '.' );
        $desconto = new TNumeric('desconto', '2', ',', '.' );
        $valor_multa = new TNumeric('valor_multa', '2', ',', '.' );
        $juros = new TNumeric('juros', '2', ',', '.' );
        $observacao = new TText('observacao');
        $system_unit_id = new THidden('system_unit_id');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $cheque_banco_id = new TDBCombo('cheque_banco_id', 'kraftsoft', 'Banco', 'id', '{nome}','nome asc'  );
        $cheque_agencia = new TEntry('cheque_agencia');
        $cheque_conta = new TEntry('cheque_conta');
        $cheque_cpfcnpj = new TEntry('cheque_cpfcnpj');
        $cheque_emitente = new TEntry('cheque_emitente');

        $data_emissao->addValidation("Data emissão", new TRequiredValidator()); 
        $data_vencimento->addValidation("Data Vencimento", new TRequiredValidator()); 
        $cliente_id->addValidation("Cliente", new TRequiredValidator()); 
        $forma_pagamento_id->addValidation("Forma pagamento id", new TRequiredValidator()); 
        $contasrec_origem_id->addValidation("Contasrec origem id", new TRequiredValidator()); 
        $plano_conta_id->addValidation("Plano de conta", new TRequiredValidator()); 
        $centro_custo_id->addValidation("Centro custo id", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 

        $contasrec_situacao_id->setColorColumn('cor');
        $contasrec_situacao_id->setFilledColor('#fd9308');
        $contasrec_situacao_id->setFilledFontColor('#ffffff');
        $contasrec_situacao_id->setUnfilledColor('#d3d3d3');
        $contasrec_situacao_id->setUnfilledFontColor('#333333');
        $cliente_id->enableSearch();
        $plano_conta_id->enableSearch();
        $centro_custo_id->enableSearch();
        $cheque_banco_id->enableSearch();
        $forma_pagamento_id->enableSearch();
        $contasrec_origem_id->enableSearch();

        $data_emissao->setMask('dd/mm/yyyy');
        $data_pagamento->setMask('dd/mm/yyyy');
        $data_vencimento->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $data_competencia->setMask('dd/mm/yyyy');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_venc_original->setMask('dd/mm/yyyy');

        $data_emissao->setDatabaseMask('yyyy-mm-dd');
        $data_pagamento->setDatabaseMask('yyyy-mm-dd');
        $data_vencimento->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_competencia->setDatabaseMask('yyyy-mm-dd');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_venc_original->setDatabaseMask('yyyy-mm-dd');

        $id->setEditable(false);
        $juros->setEditable(false);
        $desconto->setEditable(false);
        $criado_em->setEditable(false);
        $valor_pago->setEditable(false);
        $criado_por->setEditable(false);
        $valor_multa->setEditable(false);
        $alterado_em->setEditable(false);
        $valor_aberto->setEditable(false);
        $alterado_por->setEditable(false);
        $data_pagamento->setEditable(false);
        $data_venc_original->setEditable(false);
        $contasrec_origem_id->setEditable(false);
        $contasrec_situacao_id->setEditable(false);

        $id->setSize('100%');
        $valor->setSize('100%');
        $juros->setSize('100%');
        $parcela->setSize('100%');
        $desconto->setSize('100%');
        $criado_em->setSize('100%');
        $cliente_id->setSize('100%');
        $valor_pago->setSize('100%');
        $criado_por->setSize('100%');
        $valor_multa->setSize('100%');
        $system_unit_id->setSize(200);
        $alterado_em->setSize('100%');
        $data_emissao->setSize('100%');
        $valor_aberto->setSize('100%');
        $alterado_por->setSize('100%');
        $cheque_conta->setSize('100%');
        $data_pagamento->setSize('100%');
        $plano_conta_id->setSize('100%');
        $observacao->setSize('100%', 70);
        $cheque_agencia->setSize('100%');
        $cheque_cpfcnpj->setSize('100%');
        $data_vencimento->setSize('100%');
        $centro_custo_id->setSize('100%');
        $cheque_banco_id->setSize('100%');
        $cheque_emitente->setSize('100%');
        $data_competencia->setSize('100%');
        $numero_documento->setSize('100%');
        $data_venc_original->setSize('100%');
        $forma_pagamento_id->setSize('100%');
        $contasrec_origem_id->setSize('100%');
        $contasrec_situacao_id->setSize('100%', 55);

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$contasrec_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Vencimento Original:", null, '14px', null, '100%'),$data_venc_original],[new TLabel("Data Pagamento:", null, '14px', null, '100%'),$data_pagamento]);
        $row2->layout = [' col-sm-3',' col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([new TLabel("Data Emissão:", '#ff0000', '14px', null, '100%'),$data_emissao],[new TLabel("Data Vencimento:", '#ff0000', '14px', null, '100%'),$data_vencimento],[new TLabel("Data Competência:", null, '14px', null, '100%'),$data_competencia]);
        $row3->layout = [' col-sm-3',' col-sm-3',' col-sm-3'];

        $row4 = $this->form->addFields([new TLabel("Cliente:", '#ff0000', '14px', null, '100%'),$cliente_id]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->form->addFields([new TLabel("Forma de pagamento:", '#ff0000', '14px', null, '100%'),$forma_pagamento_id],[new TLabel("Origem:", '#ff0000', '14px', null, '100%'),$contasrec_origem_id]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Plano de conta:", '#ff0000', '14px', null, '100%'),$plano_conta_id],[new TLabel("Centro de custo:", '#ff0000', '14px', null, '100%'),$centro_custo_id]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([new TLabel("Número Documento:", null, '14px', null, '100%'),$numero_documento],[new TLabel("Parcela:", null, '14px', null, '100%'),$parcela]);
        $row7->layout = ['col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Valor Pago:", null, '14px', null, '100%'),$valor_pago]);
        $row8->layout = ['col-sm-6','col-sm-6'];

        $row9 = $this->form->addFields([new TLabel("Valor Aberto:", null, '14px', null, '100%'),$valor_aberto],[new TLabel("Desconto:", null, '14px', null, '100%'),$desconto],[new TLabel("Multa:", null, '14px', null, '100%'),$valor_multa],[new TLabel("Juros:", null, '14px', null, '100%'),$juros]);
        $row9->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row10 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$observacao]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->form->addFields([$system_unit_id]);
        $row11->layout = ['col-sm-3'];

        $bcontainer_6349de45fcf7f = new BContainer('bcontainer_6349de45fcf7f');
        $this->bcontainer_6349de45fcf7f = $bcontainer_6349de45fcf7f;

        $bcontainer_6349de45fcf7f->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_6349de45fcf7f->setBorderColor('#c0c0c0');

        $row12 = $bcontainer_6349de45fcf7f->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row12->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row13 = $this->form->addFields([$bcontainer_6349de45fcf7f]);
        $row13->layout = [' col-sm-12'];

        $this->form->appendPage("Dados de Cheque");
        $row14 = $this->form->addFields([new TLabel("Banco:", null, '14px', null, '100%'),$cheque_banco_id],[new TLabel("Agência:", null, '14px', null, '100%'),$cheque_agencia]);
        $row14->layout = ['col-sm-6','col-sm-6'];

        $row15 = $this->form->addFields([new TLabel("Conta:", null, '14px', null, '100%'),$cheque_conta],[new TLabel("CPF/CNPJ:", null, '14px', null, '100%'),$cheque_cpfcnpj]);
        $row15->layout = ['col-sm-6','col-sm-6'];

        $row16 = $this->form->addFields([new TLabel("Emitente:", null, '14px', null, '100%'),$cheque_emitente]);
        $row16->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btnModoVisualizacao = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacao']), 'fas:bars #000000');
        $this->btnModoVisualizacao = $btnModoVisualizacao;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ContasrecList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Financeiro","Cadastro de contas a receber"]));
        }
        $container->add($this->form);

        $btnModoVisualizacao->style = 'display:none';

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Contasrec(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            ContabilLancamentos::ValidaLancamentoContabil($object->plano_conta_id,$object->centro_custo_id,PlanoContaOrigem::Credora);

            $object->valor_aberto = $object->valor - $object->valor_pago;

            if ($object->id=='')
            {
                $object->data_venc_original = $object->data_vencimento;
                $object->ativo_id = Ativo::Ativo;
            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            //verificar se o vencimento foi alterado...
            $venc_inicial = TSession::getValue('crec_vencimento_inicial');

            if ($venc_inicial<>$object->data_vencimento)
            {
                $crec_hist_venc = new ContasrecHistoricoVenc;
                $crec_hist_venc->contasrec_id = $object->id;
                $crec_hist_venc->vencimento_anterior = $venc_inicial;
                $crec_hist_venc->vencimento_atual = $object->data_vencimento;

                Funcoes::SalvarUsuarioCadastro($crec_hist_venc);

                $crec_hist_venc->store();
            }

            //lançamento contabil...
            ContabilLancamentos::LancamentoContabil($object->plano_conta_id,
                                                    $object->centro_custo_id,
                                                    ContabilLancamentosTipo::Credito,
                                                    ContabilLancamentosSituacao::NaoLiquidado,
                                                    ContabilLancamentosOrigem::ContasRec,
                                                    $object->id,
                                                    $object->data_vencimento,
                                                    $object->valor,
                                                    'Ref. Crédito Cliente: '.$object->cliente->nome);   

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            //evento
            TTransaction::open(self::$database);

            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                               Contasrec::Evento_ContasRecIncluidoOuAlterado,
                                               $object,
                                               'Contas a receber do cliente '.$object->cliente->nome.' , '.
                                               'Valor do título: R$ '.number_format($object->valor,2, ',', '.').' , '.
                                               'Vencimento: '.TDate::date2br($object->data_vencimento)); 

            TTransaction::close();                

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ContasrecList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacao($param = null) 
    {
        try 
        {
            $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve o título para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('ContasrecFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Contasrec($key); // instantiates the Active Record 

                TSession::setValue('crec_vencimento_inicial', $object->data_vencimento);

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        TSession::setValue('crec_vencimento_inicial', null);

        $object = new stdClass();
        $object->data_emissao = date('d/m/Y');
        $object->contasrec_situacao_id = ContasrecSituacao::EmAberto;
        $object->contasrec_origem_id = ContasrecOrigem::Avulso;
        $object->system_unit_id = TSession::getValue('userunitid');
        $object->desconto = '0,00';
        $object->valor_multa = '0,00';
        $object->juros = '0,00';
        $object->valor_pago = '0,00';

        TForm::sendData(self::$formName, $object);
    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

