<?php

class ContasrecFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Contasrec';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Contasrec';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $contasrec = new Contasrec($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Contas a Receber");

        TSession::setValue('contasrecformview_contasrec_id', $contasrec->id);

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'ContasrecSituacao', 'id', '{descricao}','id asc' );
        $lbid = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($contasrec->id, '', '15px', '');
        $lbvencoriginal = new TLabel("Vencimento Original:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay(TDate::convertToMask($contasrec->data_venc_original, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbdatapgto = new TLabel("Data Pagamento:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(TDate::convertToMask($contasrec->data_pagamento, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbdataemissao = new TLabel("Data Emissão:", '', '15px', 'B', '100%');
        $datetext6 = new TTextDisplay(TDate::convertToMask($contasrec->data_emissao, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbdatavencimento = new TLabel("Data Vencimento:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(TDate::convertToMask($contasrec->data_vencimento, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbdatacompetencia = new TLabel("Data Competência:", '', '15px', 'B', '100%');
        $text32 = new TTextDisplay(TDate::convertToMask($contasrec->data_competencia, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbcliente = new TLabel("Cliente:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($contasrec->cliente->nome, '', '15px', '');
        $lbformapgto = new TLabel("Forma pagamento:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($contasrec->forma_pagamento->descricao, '', '15px', '');
        $lborigem = new TLabel("Origem:", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay($contasrec->contasrec_origem->descricao, '', '15px', '');
        $lbnumdoc = new TLabel("Número Documento:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($contasrec->numero_documento, '', '15px', '');
        $lbparcela = new TLabel("Parcela:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay($contasrec->parcela, '', '15px', '');
        $lbplanoconta = new TLabel("Plano de conta:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay($contasrec->plano_conta->descricao, '', '15px', '');
        $lbcentrocusto = new TLabel("Centro de custo:", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay($contasrec->centro_custo->descricao, '', '15px', '');
        $label41 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(number_format((double)$contasrec->valor, '2', ',', '.'), '', '15px', '');
        $label43 = new TLabel("Valor Pago:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay(number_format((double)$contasrec->valor_pago, '2', ',', '.'), '', '15px', '');
        $label47 = new TLabel("Valor Aberto:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay(number_format((double)$contasrec->valor_aberto, '2', ',', '.'), '', '15px', '');
        $label49 = new TLabel("Desconto:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(number_format((double)$contasrec->desconto, '2', ',', '.'), '', '15px', '');
        $label53 = new TLabel("Valor Multa:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay(number_format((double)$contasrec->valor_multa, '2', ',', '.'), '', '15px', '');
        $label51 = new TLabel("Juros:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay(number_format((double)$contasrec->juros, '2', ',', '.'), '', '15px', '');
        $label45 = new TLabel("Observação:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay($contasrec->observacao, '', '15px', '');
        $lbcriadoem = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay(TDateTime::convertToMask($contasrec->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbcriadopor = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay($contasrec->criado_por, '', '15px', '');
        $lbalteradoem = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay(TDateTime::convertToMask($contasrec->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbalteradopor = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($contasrec->alterado_por, '', '15px', '');
        $label27 = new TLabel("Banco:", '', '15px', 'B');
        $text27 = new TTextDisplay($contasrec->cheque_banco->nome, '', '15px', '');
        $label28 = new TLabel("Agência:", '', '15px', 'B');
        $text28 = new TTextDisplay($contasrec->cheque_agencia, '', '15px', '');
        $label29 = new TLabel("Conta:", '', '15px', 'B');
        $text29 = new TTextDisplay($contasrec->cheque_conta, '', '15px', '');
        $label30 = new TLabel("Emitente:", '', '15px', 'B');
        $text30 = new TTextDisplay($contasrec->cheque_emitente, '', '15px', '');
        $label31 = new TLabel("CPF/CNPJ:", '', '15px', 'B');
        $text31 = new TTextDisplay($contasrec->cheque_cpfcnpj, '', '15px', '');
        $label33 = new TLabel("Conta:", '', '15px', 'B');
        $text33 = new TTextDisplay($contasrec->conta_corrente_boleto->nome, '', '15px', '');
        $label35 = new TLabel("Nosso Número:", '', '15px', 'B');
        $text35 = new TTextDisplay($contasrec->boleto_nosso_numero, '', '15px', '');
        $label34 = new TLabel("Situação:", '', '15px', 'B');
        $text34 = new TTextDisplay($contasrec->boleto_situacao->descricao, '', '15px', '');
        $label37 = new TLabel("Vendedor:", '', '15px', 'B');
        $text37 = new TTextDisplay($contasrec->vendedor->nome, '', '15px', '');
        $label36 = new TLabel("Comissão Vendedor:", '', '15px', 'B');
        $text36 = new TTextDisplay(number_format((double)$contasrec->vendedor_comissao, '2', ',', '.'), '', '15px', '');
        $bpage_anexos = new BPageContainer();

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($contasrec->contasrec_situacao_id);
        $bpage_anexos->setSize('100%');
        $bpage_anexos->setAction(new TAction(['ContasrecAnexosHeaderList', 'onShow'], ['contarec_id' => $contasrec->id]));
        $bpage_anexos->setId('b63f29bf784c5a');

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpage_anexos->add($loadingContainer);


        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$lbid,$text1],[$lbvencoriginal,$text19],[$lbdatapgto,$text21]);
        $row2->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([$lbdataemissao,$datetext6],[$lbdatavencimento,$text18],[$lbdatacompetencia,$text32]);
        $row3->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row4 = $this->form->addFields([$lbcliente,$text3]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->form->addFields([$lbformapgto,$text4],[$lborigem,$text8]);
        $row5->layout = [' col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([$lbnumdoc,$text14],[$lbparcela,$text15]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([$lbplanoconta,$text6],[$lbcentrocusto,$text7]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([$label41,$text17],[$label43,$text24]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        $row9 = $this->form->addFields([$label47,$text25],[$label49,$text22],[$label53,$text26],[$label51,$text23]);
        $row9->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row10 = $this->form->addFields([$label45,$text20]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row12 = $this->form->addFields([$lbcriadoem,$text9],[$lbcriadopor,$text12],[$lbalteradoem,$text13],[$lbalteradopor,$text11]);
        $row12->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Dados de Cheque");
        $row13 = $this->form->addFields([$label27],[$text27]);
        $row14 = $this->form->addFields([$label28],[$text28]);
        $row15 = $this->form->addFields([$label29],[$text29]);
        $row16 = $this->form->addFields([$label30],[$text30]);
        $row17 = $this->form->addFields([$label31],[$text31]);

        $this->form->appendPage("Histórico de Vencimentos");

        $this->contasrec_historico_venc_contasrec_id_list = new TQuickGrid;
        $this->contasrec_historico_venc_contasrec_id_list->disableHtmlConversion();
        $this->contasrec_historico_venc_contasrec_id_list->style = 'width:100%';
        $this->contasrec_historico_venc_contasrec_id_list->disableDefaultClick();

        $column_criado_por = $this->contasrec_historico_venc_contasrec_id_list->addQuickColumn("Criado Por", 'criado_por', 'left');
        $column_criado_em_transformed = $this->contasrec_historico_venc_contasrec_id_list->addQuickColumn("Criado Em", 'criado_em', 'left');
        $column_vencimento_anterior_transformed = $this->contasrec_historico_venc_contasrec_id_list->addQuickColumn("Vencimento Anterior", 'vencimento_anterior', 'left');
        $column_vencimento_atual_transformed = $this->contasrec_historico_venc_contasrec_id_list->addQuickColumn("Vencimento Atual", 'vencimento_atual', 'left');

        $column_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_vencimento_anterior_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_vencimento_atual_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->contasrec_historico_venc_contasrec_id_list->createModel();

        $criteria_contasrec_historico_venc_contasrec_id = new TCriteria();
        $criteria_contasrec_historico_venc_contasrec_id->add(new TFilter('contasrec_id', '=', $contasrec->id));

        $criteria_contasrec_historico_venc_contasrec_id->setProperty('order', 'id desc');

        $contasrec_historico_venc_contasrec_id_items = ContasrecHistoricoVenc::getObjects($criteria_contasrec_historico_venc_contasrec_id);

        $this->contasrec_historico_venc_contasrec_id_list->addItems($contasrec_historico_venc_contasrec_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->contasrec_historico_venc_contasrec_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Dados de Boleto");
        $row18 = $this->form->addFields([$label33],[$text33]);
        $row19 = $this->form->addFields([$label35],[$text35]);
        $row20 = $this->form->addFields([$label34],[$text34]);

        $this->form->appendPage("Comissões");
        $row21 = $this->form->addFields([$label37],[$text37]);
        $row22 = $this->form->addFields([$label36],[$text36]);

        $this->form->appendPage("Anexos");
        $row23 = $this->form->addFields([$bpage_anexos]);
        $row23->layout = [' col-sm-12'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        $btnContasrecFormOnEditAction = new TAction(['ContasrecForm', 'onEdit'],['key'=>$contasrec->id]);
        $btnContasrecFormOnEditLabel = new TLabel("Editar");

        $btnContasrecFormOnEdit = $this->form->addHeaderAction($btnContasrecFormOnEditLabel, $btnContasrecFormOnEditAction, 'fas:edit #2196F3'); 
        $btnContasrecFormOnEditLabel->setFontSize('12px'); 
        $btnContasrecFormOnEditLabel->setFontColor('#333'); 

        $btnContasrecBaixasFormOnShowAction = new TAction(['ContasrecBaixasForm', 'onShow'],['key'=>$contasrec->id]);
        $btnContasrecBaixasFormOnShowLabel = new TLabel("Baixar Título");

        $btnContasrecBaixasFormOnShow = $this->form->addHeaderAction($btnContasrecBaixasFormOnShowLabel, $btnContasrecBaixasFormOnShowAction, 'fas:money-check-alt #009688'); 
        $btnContasrecBaixasFormOnShowLabel->setFontSize('12px'); 
        $btnContasrecBaixasFormOnShowLabel->setFontColor('#333'); 

        $btn_oncancelartituloAction = new TAction([$this, 'onCancelarTitulo'],['key'=>$contasrec->id]);
        $btn_oncancelartituloLabel = new TLabel("Cancelar Título");

        $btn_oncancelartitulo = $this->form->addHeaderAction($btn_oncancelartituloLabel, $btn_oncancelartituloAction, 'fas:trash-alt #E40606'); 
        $btn_oncancelartituloLabel->setFontSize('12px'); 
        $btn_oncancelartituloLabel->setFontColor('#333'); 

        $btn_onimprimirboletoAction = new TAction([$this, 'onImprimirBoleto'],['key'=>$contasrec->id]);
        $btn_onimprimirboletoLabel = new TLabel("Imprimir Boleto");

        $btn_onimprimirboleto = $this->form->addHeaderAction($btn_onimprimirboletoLabel, $btn_onimprimirboletoAction, 'fas:file-pdf #673AB7'); 
        $btn_onimprimirboletoLabel->setFontSize('12px'); 
        $btn_onimprimirboletoLabel->setFontColor('#333'); 

        $btnContasrecBaixasSimpleListOnShowAction = new TAction(['ContasrecBaixasSimpleList', 'onShow'],['key'=>$contasrec->id]);
        $btnContasrecBaixasSimpleListOnShowLabel = new TLabel("Visualizar Baixas");

        $btnContasrecBaixasSimpleListOnShow = $this->form->addHeaderAction($btnContasrecBaixasSimpleListOnShowLabel, $btnContasrecBaixasSimpleListOnShowAction, 'fas:search-plus #FF5722'); 
        $btnContasrecBaixasSimpleListOnShowLabel->setFontSize('12px'); 
        $btnContasrecBaixasSimpleListOnShowLabel->setFontColor('#333'); 

        $btn_onverorigemAction = new TAction([$this, 'onVerOrigem'],['key'=>$contasrec->id]);
        $btn_onverorigemLabel = new TLabel("Ver Origem");

        $btn_onverorigem = $this->form->addHeaderAction($btn_onverorigemLabel, $btn_onverorigemAction, 'fas:atom #4CAF50'); 
        $btn_onverorigemLabel->setFontSize('12px'); 
        $btn_onverorigemLabel->setFontColor('#333'); 

        $btn_onhistoricocobrancasAction = new TAction([$this, 'onHistoricoCobrancas'],['key'=>$contasrec->id]);
        $btn_onhistoricocobrancasLabel = new TLabel("Histórico de Cobranças");

        $btn_onhistoricocobrancas = $this->form->addHeaderAction($btn_onhistoricocobrancasLabel, $btn_onhistoricocobrancasAction, 'far:calendar-check #FF9800'); 
        $btn_onhistoricocobrancasLabel->setFontSize('12px'); 
        $btn_onhistoricocobrancasLabel->setFontColor('#333'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        if($contasrec->contasrec_situacao_id==ContasrecSituacao::Cancelado
        or $contasrec->contasrec_situacao_id==ContasrecSituacao::Pago)
        {
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_baixar_título").style.display = "none";');
            TScript::create('document.getElementById("tbutton_cancelar_título").style.display = "none";');            
        } 

        $tipodocumento = (isset($object->contasrec_forma_pagamento->tipo_documento_id)) ? $object->contasrec_forma_pagamento->tipo_documento_id  : 0;

        if($tipodocumento != TipoDocumento::Boleto)
        {
            TScript::create('document.getElementById("tbutton_imprimir_boleto").style.display = "none";');
        }         

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ContasrecFormView]');
        $style->width = '90% !important';   
        $style->show(true);

    }

    public function onCancelarTitulo($param = null) 
    {
        try 
        {
         new TQuestion("Deseja cancelar o título?", new TAction([__CLASS__, 'onCancelarTituloYes'], $param), new TAction([__CLASS__, 'onCancelarTituloNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onImprimirBoleto($param = null) 
    {
        try 
        {
            //code here

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onVerOrigem($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);   
            $contasrec = Contasrec::find($param['key']);

            if ($contasrec->contasrec_origem_id==ContasrecOrigem::Venda)
            {
                 $pageParam = ['key' => $contasrec->venda_formapgto->venda_id]; // ex.: = ['key' => 10]

                 TApplication::loadPage('VendaFormView', 'OnShow', $pageParam);                
            }
            else
            {
              new TMessage('info', 'Este título é de origem avulsa!');  
            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onHistoricoCobrancas($param = null) 
    {
        try 
        {
             $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]
             TSession::setValue('key_formhistoricocobranca', $param['key']);   

             TApplication::loadPage('ContasrecHistoricoCobrancaFormList', 'OnShow', $pageParam);      

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onCancelarTituloYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $contasrec = Contasrec::find($param['key']);     

            if($contasrec) 
            {
                $contasrec->contasrec_situacao_id=ContasrecSituacao::Cancelado;
                $contasrec->store();

                $lanc_contabil = ContabilLancamentos::where('contasrec_id','=',$contasrec->id)->first(); 

                if ($lanc_contabil)
                {
                    $lanc_contabil->delete();                
                }                
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $contasrec->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarTituloNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

