<?php

class CancelamentoMDFEForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_CancelamentoMDFEForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();
        parent::setSize(0.40, null);
        parent::setTitle("Cancelamento MDFE");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cancelamento MDFE");


        $justificativa = new TText('justificativa');

        $justificativa->addValidation("Justificativa", new TRequiredValidator()); 

        $justificativa->setSize('100%', 100);


        $row1 = $this->form->addFields([new TLabel("Justificativa:", null, '14px', null, '100%'),$justificativa]);
        $row1->layout = [' col-sm-12'];

        // create the form actions
        $btn_oncancelar = $this->form->addAction("Cancelar", new TAction([$this, 'onCancelar']), 'fas:ban #ffffff');
        $this->btn_oncancelar = $btn_oncancelar;
        $btn_oncancelar->addStyleClass('btn-danger'); 

        parent::add($this->form);

    }

    public function onCancelar($param = null) 
    {
        try
        {
            TTransaction::open('kraftsoft');

            $this->form->validate();

            $data = $this->form->getData();

            $mdfe = Mdfe::find(TSession::getValue('mdfe_id'));

            if($mdfe){
                $mdfe->justificativa_cancelamento = $data->justificativa;
                $mdfe->store();

                $retorno = NuvemFiscalMDFe::Cancelar($mdfe->id);

                new TMessage('info', $retorno);

            }else{
                throw new Exception('MDFe não encontrada.');
            }

            TTransaction::close();
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

    } 

}

