<?php

class CancelementoNotaForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_CancelementoNotaForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();
        parent::setSize(0.40, null);
        parent::setTitle("Cancelamento de Nota");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cancelamento de Nota");


        $justificativa = new TText('justificativa');
        $id = new THidden('id');

        $justificativa->addValidation("Justificativa", new TRequiredValidator()); 

        $id->setSize(200);
        $justificativa->setSize('100%', 150);

        $justificativa->autofocus = 'autofocus';


        $row1 = $this->form->addFields([new TLabel("Justificativa:", null, '14px', null, '100%'),$justificativa]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$id],[],[]);
        $row2->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        // create the form actions
        $btn_onconfirmarcancelamento = $this->form->addAction("Confirmar", new TAction([$this, 'onConfirmarCancelamento']), 'fas:ban #ffffff');
        $this->btn_onconfirmarcancelamento = $btn_onconfirmarcancelamento;
        $btn_onconfirmarcancelamento->addStyleClass('btn-danger'); 

        parent::add($this->form);

    }

    public function onConfirmarCancelamento($param = null) 
    {
        try
        {
            TTransaction::open('kraftsoft');

            $this->form->validate();

            $data = $this->form->getData();

            $nota = Notafiscal::find($data->id);

            if($nota)
            {
                $retorno = cloudDFE_NFE::cancelaNFE($nota->chave, $data->justificativa);

                if($retorno->codigo == 501)
                {
                    new TMessage('info', 'Retorno da SEFAZ: '."\n".cloudDFE_NFE::formataRetorno($retorno));                        
                    //  TSession::setValue('retorno_envio_nota', $retorno->erros);
                    //  TApplication::loadPage('RetornoCloudList', 'onShow');

                 }
                 else
                 {
                     TToast::show('success', "Nota fiscal cancelada com sucesso.", 'topRight', 'far:check-circle');
                     TApplication::loadPage('NotafiscalList', 'onReload');
                 }

            }

            TTransaction::close();

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

        $object = new stdClass();
        $object->id = $param['id'];

        TForm::sendData(self::$formName, $object);

    } 

}

