<?php

class InutilizarNumeroForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'InutilizarNumero';
    private static $primaryKey = 'id';
    private static $formName = 'form_InutilizarNumeroForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::setSize(0.45, null);
        parent::setTitle("Cadastro de inutilizar numero");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de inutilizar numero");


        $id = new TEntry('id');
        $created_at = new THidden('created_at');
        $system_unit_id = new THidden('system_unit_id');
        $system_users_id = new THidden('system_users_id');
        $serie = new TEntry('serie');
        $ninicio = new TEntry('ninicio');
        $nfinal = new TEntry('nfinal');
        $cstat = new TCheckButton('cstat');
        $xjust = new TText('xjust');

        $nfinal->addValidation("final", new TRequiredValidator()); 

        $cstat->setUseSwitch(true, 'blue');
        $cstat->setIndexValue("1");
        $id->setEditable(false);
        $serie->setEditable(false);
        $ninicio->setEditable(false);

        $serie->setMaxLength(20);
        $nfinal->setMaxLength(20);
        $ninicio->setMaxLength(20);

        $cstat->setValue('102');
        $created_at->setValue(date('Y-m-d H:i:s'));
        $system_users_id->setValue(TSession::getValue("userid"));
        $system_unit_id->setValue(TSession::getValue("userunitid"));
        $xjust->setValue('Erro de digitação dos números sequencias das notas');

        $id->setSize(100);
        $serie->setSize('100%');
        $nfinal->setSize('100%');
        $created_at->setSize(200);
        $ninicio->setSize('100%');
        $xjust->setSize('100%', 150);
        $system_unit_id->setSize(200);
        $system_users_id->setSize(200);

        $row1 = $this->form->addFields([new TLabel("Código:", null, '14px', null, '100%'),$id,$created_at,$system_unit_id,$system_users_id],[new TLabel("Serie:", null, '14px', null, '100%'),$serie],[new TLabel("Início: ", null, '14px', null, '100%'),$ninicio],[new TLabel("Final:", null, '14px', null, '100%'),$nfinal],[new TLabel("Ativar Controle:", null, '14px', null),$cstat]);
        $row1->layout = ['col-sm-2',' col-sm-3','col-sm-2','col-sm-2',' col-sm-3'];

        $row2 = $this->form->addFields([new TLabel("Justificativa: ", null, '14px', null),$xjust]);
        $row2->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['InutilizarNumeroList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        parent::add($this->form);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new InutilizarNumero(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('InutilizarNumeroList', 'onShow', $loadPageParam); 

                TWindow::closeWindow(parent::getId()); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new InutilizarNumero($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

       TTransaction::open(self::$database);
         $objeto = NotafiscalSeries::where('notafiscal_mod_id', '=', 1)->
                                    where('system_unit_id', '=',TSession::getValue('userunitid'))->first();

        TTransaction::close();

        $object = new stdClass();
        $object->serie = $objeto->serie;
        $object->ninicio = $objeto->sequencial + 1;
        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

