<?php

class MDFeCancelamentoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_MDFeCancelamentoForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cancelamento de MDF-e");


        $txt_justificativa = new TText('txt_justificativa');
        $id = new THidden('id');

        $txt_justificativa->addValidation("Justificativa", new TRequiredValidator()); 
        $txt_justificativa->addValidation("Quantidade de caracteres mínimo para justificativa: 15", new TMinValueValidator(), ["15"]); 

        $id->setSize(200);
        $txt_justificativa->setSize('100%', 100);


        $row1 = $this->form->addFields([new TLabel("Justificativa:", '#F44336', '14px', null, '100%'),$txt_justificativa]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$id],[],[]);
        $row2->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        // create the form actions
        $btn_oncancelar = $this->form->addAction("Confirmar", new TAction([$this, 'onCancelar']), 'fas:ban #ffffff');
        $this->btn_oncancelar = $btn_oncancelar;
        $btn_oncancelar->addStyleClass('btn-danger'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

    }

    public function onCancelar($param = null) 
    {
        try
        {
           // new TQuestion("Cancelar MDF-e?", new TAction([__CLASS__, 'onCancelarYes'], $param), new TAction([__CLASS__, 'onCancelarNo'], $param));

            TTransaction::open('kraftsoft');

            $this->form->validate();

            $data = $this->form->getData();

            $mdfe = Mdfe::find($data->id);

            if($mdfe)
            {
                $retorno = API_MDFe::Cancelar($mdfe, $data->txt_justificativa);

                //echo 'retorno '.var_dump($retorno);

                if($retorno->codigo == 5001)
                {
                    new TMessage('info', 'Retorno da SEFAZ: '."\n".API_MDFe::formataRetorno($retorno));   

                    //  $pageParam = ['titulo' => 'Retorno da SEFAZ'];
                    //  TSession::setValue('mens_personalizada', 'Retorno da SEFAZ: '."\n".API_MDFe::formataRetorno($retorno));
                    //  TApplication::loadPage('MensagemPersonalizada', 'OnShow', $pageParam);                    
                 }
                 else
                 {
                     TToast::show('success', "MDF-e cancelado com sucesso!", 'topRight', 'far:check-circle');

                     TApplication::loadPage('MdfeList', 'onReload');
                 }

            }

            TTransaction::close();                   
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

        $object = new stdClass();
        $object->id = $param['id'];

        TForm::sendData(self::$formName, $object);
    } 

    public function onCancelarYes($param = null)
    {
            // TTransaction::open('kraftsoft');

            // $this->form->validate();

            // $data = $this->form->getData();

            // $mdfe = Mdfe::find($data->id);

            // if($mdfe)
            // {
            //     $retorno = API_MDFe::Cancelar($mdfe, $data->txt_justificativa);

            //     if($retorno->codigo == 5001)
            //     {
            //          $pageParam = ['titulo' => 'Retorno da SEFAZ'];

            //          TSession::setValue('mens_personalizada', 'Retorno da SEFAZ: '."\n".API_MDFe::formataRetorno($retorno));
            //          TApplication::loadPage('MensagemPersonalizada', 'OnShow', $pageParam);                    
            //      }
            //      else
            //      {
            //          TToast::show('success', "MDF-e cancelado com sucesso!", 'topRight', 'far:check-circle');

            //          TApplication::loadPage('MdfeList', 'onReload');
            //      }

            // }

            // TTransaction::close();        
    }

    public function onCancelarNo($param = null)
    {

    }    

}

