<?php

class MdfeForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Mdfe';
    private static $primaryKey = 'id';
    private static $formName = 'form_MdfeForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de MDF-e");


        $mdfe_situacao_id = new TDBArrowStep('mdfe_situacao_id', 'kraftsoft', 'MdfeSituacao', 'id', '{descricao}','ordem asc'  );
        $id = new TEntry('id');
        $serie = new TCombo('serie');
        $nMDF = new TEntry('nMDF');
        $mdfe_tpamb_id = new TDBCombo('mdfe_tpamb_id', 'kraftsoft', 'MdfeTpamb', 'id', '{descricao}','descricao asc'  );
        $dhEmi = new TDateTime('dhEmi');
        $dhIniViagem = new TDateTime('dhIniViagem');
        $mdfe_tpemit_id = new TDBCombo('mdfe_tpemit_id', 'kraftsoft', 'MdfeTpemit', 'id', '{descricao}','descricao asc'  );
        $mdfe_tpprop_id = new TDBCombo('mdfe_tpprop_id', 'kraftsoft', 'MdfeTpprop', 'id', '{descricao}','descricao asc'  );
        $mdfe_tptransp_id = new TDBCombo('mdfe_tptransp_id', 'kraftsoft', 'MdfeTptransp', 'id', '{descricao}','descricao asc'  );
        $UFIni = new TDBCombo('UFIni', 'kraftsoft', 'Estado', 'id', '{nome}','nome asc'  );
        $UFFim = new TDBCombo('UFFim', 'kraftsoft', 'Estado', 'id', '{nome}','nome asc'  );
        $indCanalVerde = new TDBCombo('indCanalVerde', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $indCarregaPosterior = new TDBCombo('indCarregaPosterior', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $pgto_indAltoDesemp = new TEntry('pgto_indAltoDesemp');
        $mdfe_cunid_id = new TDBCombo('mdfe_cunid_id', 'kraftsoft', 'MdfeCunid', 'id', '{descricao}','descricao asc'  );
        $qCarga = new TNumeric('qCarga', '2', ',', '.' );
        $vCarga = new TNumeric('vCarga', '2', ',', '.' );
        $mdfe_tpcarga_id = new TDBCombo('mdfe_tpcarga_id', 'kraftsoft', 'MdfeTpcarga', 'id', '{descricao}','descricao asc'  );
        $prod_xProd = new TEntry('prod_xProd');
        $prod_cEAN = new TEntry('prod_cEAN');
        $prod_NCM = new TEntry('prod_NCM');
        $infAdFisco = new TText('infAdFisco');
        $infCpl = new TText('infCpl');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $veiculo_id = new TDBCombo('veiculo_id', 'kraftsoft', 'Veiculo', 'id', '{modelo_marca}','modelo_marca asc'  );
        $veic_placa = new TEntry('veic_placa');
        $veic_estado_id = new TDBCombo('veic_estado_id', 'kraftsoft', 'Estado', 'id', '{nome}','nome asc'  );
        $veic_rntrc = new TEntry('veic_rntrc');
        $veic_renavam = new TEntry('veic_renavam');
        $veic_cint = new TEntry('veic_cint');
        $mdfe_tpcar_id = new TDBCombo('mdfe_tpcar_id', 'kraftsoft', 'MdfeTpcar', 'id', '{descricao}','descricao asc'  );
        $mdfe_tpRod_id = new TDBCombo('mdfe_tpRod_id', 'kraftsoft', 'MdfeTprod', 'id', '{descricao}','descricao asc'  );
        $veic_tara = new TNumeric('veic_tara', '2', ',', '.' );
        $mdfe_condutor_mdfe_xnome = new TEntry('mdfe_condutor_mdfe_xnome');
        $mdfe_condutor_mdfe_id = new THidden('mdfe_condutor_mdfe_id');
        $mdfe_condutor_mdfe_cpf = new TEntry('mdfe_condutor_mdfe_cpf');
        $button_adicionar_mdfe_condutor_mdfe = new TButton('button_adicionar_mdfe_condutor_mdfe');
        $mdfe_infmuncarrega_mdfe_cidade_id = new TDBUniqueSearch('mdfe_infmuncarrega_mdfe_cidade_id', 'kraftsoft', 'Cidade', 'id', 'nome','nome asc'  );
        $mdfe_infmuncarrega_mdfe_id = new THidden('mdfe_infmuncarrega_mdfe_id');
        $button_adicionar_mdfe_infmuncarrega_mdfe = new TButton('button_adicionar_mdfe_infmuncarrega_mdfe');
        $mdfe_infpercurso_mdfe_UFPer = new TDBCombo('mdfe_infpercurso_mdfe_UFPer', 'kraftsoft', 'Estado', 'id', '{nome}  - ({sigla})','nome asc'  );
        $mdfe_infpercurso_mdfe_id = new THidden('mdfe_infpercurso_mdfe_id');
        $button_adicionar_mdfe_infpercurso_mdfe = new TButton('button_adicionar_mdfe_infpercurso_mdfe');
        $mdfe_infmundescarga_mdfe_cidade_id = new TDBUniqueSearch('mdfe_infmundescarga_mdfe_cidade_id', 'kraftsoft', 'Cidade', 'id', 'nome','nome asc'  );
        $mdfe_infmundescarga_mdfe_id = new THidden('mdfe_infmundescarga_mdfe_id');
        $button_adicionar_mdfe_infmundescarga_mdfe = new TButton('button_adicionar_mdfe_infmundescarga_mdfe');
        $mdfe_lacres_mdfe_nLacre = new TEntry('mdfe_lacres_mdfe_nLacre');
        $mdfe_lacres_mdfe_id = new THidden('mdfe_lacres_mdfe_id');
        $button_adicionar_mdfe_lacres_mdfe = new TButton('button_adicionar_mdfe_lacres_mdfe');
        $mdfe_respSeg_id = new TDBCombo('mdfe_respSeg_id', 'kraftsoft', 'MdfeRespseg', 'id', '{descricao}','descricao asc'  );
        $seguro_cpfcnpj = new TEntry('seguro_cpfcnpj');
        $seguradora_xSeg = new TEntry('seguradora_xSeg');
        $seguradora_cnpj = new TEntry('seguradora_cnpj');
        $mdfe_xmlaut_mdfe_cpfcnpj = new TEntry('mdfe_xmlaut_mdfe_cpfcnpj');
        $mdfe_xmlaut_mdfe_id = new THidden('mdfe_xmlaut_mdfe_id');
        $button_adicionar_mdfe_xmlaut_mdfe = new TButton('button_adicionar_mdfe_xmlaut_mdfe');
        $pgto_cpfcnpj = new TEntry('pgto_cpfcnpj');
        $pgto_xNome = new TEntry('pgto_xNome');
        $pgto_vContrato = new TNumeric('pgto_vContrato', '2', ',', '.' );
        $pgto_idEstrangeiro = new TEntry('pgto_idEstrangeiro');
        $mdfe_indpag_id = new TDBCombo('mdfe_indpag_id', 'kraftsoft', 'MdfeIndpag', 'id', '{descricao}','descricao asc'  );
        $indAntecipaAdiant = new TDBCombo('indAntecipaAdiant', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $pgto_vAdiant = new TNumeric('pgto_vAdiant', '2', ',', '.' );
        $pgto_codBanco = new TEntry('pgto_codBanco');
        $pgto_codAgencia = new TEntry('pgto_codAgencia');
        $pgto_CNPJIPEF = new TEntry('pgto_CNPJIPEF');
        $pgto_PIX = new TEntry('pgto_PIX');
        $mdfe_parcelas_mdfe_nParcela = new TEntry('mdfe_parcelas_mdfe_nParcela');
        $mdfe_parcelas_mdfe_id = new THidden('mdfe_parcelas_mdfe_id');
        $mdfe_parcelas_mdfe_dVenc = new TDate('mdfe_parcelas_mdfe_dVenc');
        $mdfe_parcelas_mdfe_vParcela = new TNumeric('mdfe_parcelas_mdfe_vParcela', '2', ',', '.' );
        $mdfe_parcelas_mdfe_mdfe_tpAntecip_id = new TDBCombo('mdfe_parcelas_mdfe_mdfe_tpAntecip_id', 'kraftsoft', 'MdfeTpantecip', 'id', '{descricao}','descricao asc'  );
        $button_adicionar_mdfe_parcelas_mdfe = new TButton('button_adicionar_mdfe_parcelas_mdfe');
        $mdfe_componentes_mdfe_mdfe_tpcomp_id = new TDBCombo('mdfe_componentes_mdfe_mdfe_tpcomp_id', 'kraftsoft', 'MdfeTpcomp', 'id', '{descricao}','descricao asc'  );
        $mdfe_componentes_mdfe_id = new THidden('mdfe_componentes_mdfe_id');
        $mdfe_componentes_mdfe_xComp = new TEntry('mdfe_componentes_mdfe_xComp');
        $mdfe_componentes_mdfe_vComp = new TNumeric('mdfe_componentes_mdfe_vComp', '2', ',', '.' );
        $button_adicionar_mdfe_componentes_mdfe = new TButton('button_adicionar_mdfe_componentes_mdfe');
        $status = new TEntry('status');
        $cStat = new TEntry('cStat');
        $mensagem_sefaz = new TText('mensagem_sefaz');
        $nProt = new TEntry('nProt');
        $chMDF = new TEntry('chMDF');
        $data_hora_envio = new TEntry('data_hora_envio');
        $protocolo_cancelamento = new TEntry('protocolo_cancelamento');
        $datahora_cancelamento = new TEntry('datahora_cancelamento');
        $justificativa_cancelamento = new TText('justificativa_cancelamento');

        $mdfe_tpamb_id->setChangeAction(new TAction([$this,'onExitTipoAmbiente']));
        $veiculo_id->setChangeAction(new TAction([$this,'onExitVeiculo']));

        $serie->addValidation("Série", new TRequiredValidator()); 
        $mdfe_tpamb_id->addValidation("Tipo Ambiente", new TRequiredValidator()); 
        $mdfe_tpemit_id->addValidation("Mdfe tpemit id", new TRequiredValidator()); 
        $mdfe_tpprop_id->addValidation("Mdfe tpprop id", new TRequiredValidator()); 
        $UFIni->addValidation("UF do Carregamento", new TRequiredValidator()); 
        $UFFim->addValidation("UF do Descarregamento", new TRequiredValidator()); 
        $indCanalVerde->addValidation("Indicador de participação do Canal Verde", new TRequiredValidator()); 
        $indCarregaPosterior->addValidation("Indicador de MDF-e com inclusão da Carga posterior a emissão por evento de inclusão de DF-e", new TRequiredValidator()); 
        $mdfe_cunid_id->addValidation("unidade de medida do Peso Bruto da Carga / Mercadorias transportadas", new TRequiredValidator()); 
        $veic_estado_id->addValidation("Estado do Veículo", new TRequiredValidator()); 
        $mdfe_tpcar_id->addValidation("Tipo de carroceria veículo", new TRequiredValidator()); 
        $mdfe_tpRod_id->addValidation("Tipo de rodado veículo", new TRequiredValidator()); 

        $mdfe_situacao_id->setColorColumn('cor');
        $mdfe_situacao_id->setFilledColor('#fd9308');
        $mdfe_situacao_id->setFilledFontColor('#ffffff');
        $mdfe_situacao_id->setUnfilledColor('#d3d3d3');
        $mdfe_situacao_id->setUnfilledFontColor('#333333');
        $mdfe_infmuncarrega_mdfe_cidade_id->setMinLength(2);
        $mdfe_infmundescarga_mdfe_cidade_id->setMinLength(2);

        $dhEmi->setDatabaseMask('yyyy-mm-dd hh:ii');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $dhIniViagem->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $mdfe_parcelas_mdfe_dVenc->setDatabaseMask('yyyy-mm-dd');

        $dhEmi->setMask('dd/mm/yyyy hh:ii');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $dhIniViagem->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $mdfe_parcelas_mdfe_dVenc->setMask('dd/mm/yyyy');
        $mdfe_infmuncarrega_mdfe_cidade_id->setMask('{nome} - {estado->sigla}');
        $mdfe_infmundescarga_mdfe_cidade_id->setMask('{nome}  - {estado->sigla}');

        $button_adicionar_mdfe_lacres_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeLacresMdfe'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_xmlaut_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeXmlautMdfe'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_condutor_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeCondutorMdfe'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_parcelas_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeParcelasMdfe'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_infpercurso_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeInfpercursoMdfe'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_componentes_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeComponentesMdfe'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_infmuncarrega_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeInfmuncarregaMdfe'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_infmundescarga_mdfe->setAction(new TAction([$this, 'onAddDetailMdfeInfmundescargaMdfe'],['static' => 1]), "Adicionar");

        $button_adicionar_mdfe_lacres_mdfe->addStyleClass('btn-default');
        $button_adicionar_mdfe_xmlaut_mdfe->addStyleClass('btn-default');
        $button_adicionar_mdfe_condutor_mdfe->addStyleClass('btn-default');
        $button_adicionar_mdfe_parcelas_mdfe->addStyleClass('btn-default');
        $button_adicionar_mdfe_infpercurso_mdfe->addStyleClass('btn-default');
        $button_adicionar_mdfe_componentes_mdfe->addStyleClass('btn-default');
        $button_adicionar_mdfe_infmuncarrega_mdfe->addStyleClass('btn-default');
        $button_adicionar_mdfe_infmundescarga_mdfe->addStyleClass('btn-default');

        $button_adicionar_mdfe_lacres_mdfe->setImage('fas:plus #2ecc71');
        $button_adicionar_mdfe_xmlaut_mdfe->setImage('fas:plus #2ecc71');
        $button_adicionar_mdfe_condutor_mdfe->setImage('fas:plus #2ecc71');
        $button_adicionar_mdfe_parcelas_mdfe->setImage('fas:plus #2ecc71');
        $button_adicionar_mdfe_infpercurso_mdfe->setImage('fas:plus #2ecc71');
        $button_adicionar_mdfe_componentes_mdfe->setImage('fas:plus #2ecc71');
        $button_adicionar_mdfe_infmuncarrega_mdfe->setImage('fas:plus #2ecc71');
        $button_adicionar_mdfe_infmundescarga_mdfe->setImage('fas:plus #2ecc71');

        $id->setEditable(false);
        $cStat->setEditable(false);
        $nProt->setEditable(false);
        $chMDF->setEditable(false);
        $status->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $mensagem_sefaz->setEditable(false);
        $data_hora_envio->setEditable(false);
        $mdfe_situacao_id->setEditable(false);
        $datahora_cancelamento->setEditable(false);
        $protocolo_cancelamento->setEditable(false);
        $justificativa_cancelamento->setEditable(false);

        $serie->enableSearch();
        $UFIni->enableSearch();
        $UFFim->enableSearch();
        $veiculo_id->enableSearch();
        $mdfe_tpamb_id->enableSearch();
        $indCanalVerde->enableSearch();
        $mdfe_cunid_id->enableSearch();
        $mdfe_tpcar_id->enableSearch();
        $mdfe_tpRod_id->enableSearch();
        $mdfe_tpemit_id->enableSearch();
        $mdfe_tpprop_id->enableSearch();
        $veic_estado_id->enableSearch();
        $mdfe_indpag_id->enableSearch();
        $mdfe_tpcarga_id->enableSearch();
        $mdfe_respSeg_id->enableSearch();
        $mdfe_tptransp_id->enableSearch();
        $indAntecipaAdiant->enableSearch();
        $indCarregaPosterior->enableSearch();
        $mdfe_infpercurso_mdfe_UFPer->enableSearch();
        $mdfe_parcelas_mdfe_mdfe_tpAntecip_id->enableSearch();
        $mdfe_componentes_mdfe_mdfe_tpcomp_id->enableSearch();

        $id->setSize('100%');
        $nMDF->setSize('100%');
        $serie->setSize('100%');
        $dhEmi->setSize('100%');
        $UFIni->setSize('100%');
        $UFFim->setSize('100%');
        $cStat->setSize('100%');
        $nProt->setSize('100%');
        $chMDF->setSize('100%');
        $qCarga->setSize('100%');
        $vCarga->setSize('100%');
        $status->setSize('100%');
        $prod_NCM->setSize('100%');
        $pgto_PIX->setSize('100%');
        $prod_cEAN->setSize('100%');
        $criado_em->setSize('100%');
        $veic_cint->setSize('100%');
        $veic_tara->setSize('100%');
        $prod_xProd->setSize('100%');
        $infCpl->setSize('100%', 70);
        $criado_por->setSize('100%');
        $veiculo_id->setSize('100%');
        $veic_placa->setSize('100%');
        $veic_rntrc->setSize('100%');
        $pgto_xNome->setSize('100%');
        $dhIniViagem->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $veic_renavam->setSize('100%');
        $pgto_cpfcnpj->setSize('100%');
        $pgto_vAdiant->setSize('100%');
        $mdfe_tpamb_id->setSize('100%');
        $indCanalVerde->setSize('100%');
        $mdfe_cunid_id->setSize('100%');
        $mdfe_tpcar_id->setSize('100%');
        $mdfe_tpRod_id->setSize('100%');
        $pgto_codBanco->setSize('100%');
        $pgto_CNPJIPEF->setSize('100%');
        $mdfe_tpemit_id->setSize('100%');
        $mdfe_tpprop_id->setSize('100%');
        $infAdFisco->setSize('100%', 70);
        $veic_estado_id->setSize('100%');
        $seguro_cpfcnpj->setSize('100%');
        $pgto_vContrato->setSize('100%');
        $mdfe_indpag_id->setSize('100%');
        $mdfe_tpcarga_id->setSize('100%');
        $mdfe_respSeg_id->setSize('100%');
        $seguradora_xSeg->setSize('100%');
        $seguradora_cnpj->setSize('100%');
        $pgto_codAgencia->setSize('100%');
        $data_hora_envio->setSize('100%');
        $mdfe_tptransp_id->setSize('100%');
        $mdfe_lacres_mdfe_id->setSize(200);
        $mdfe_xmlaut_mdfe_id->setSize(200);
        $indAntecipaAdiant->setSize('100%');
        $pgto_indAltoDesemp->setSize('100%');
        $mdfe_condutor_mdfe_id->setSize(200);
        $pgto_idEstrangeiro->setSize('100%');
        $mdfe_parcelas_mdfe_id->setSize(200);
        $mensagem_sefaz->setSize('100%', 70);
        $indCarregaPosterior->setSize('100%');
        $mdfe_situacao_id->setSize('100%', 55);
        $mdfe_infpercurso_mdfe_id->setSize(200);
        $mdfe_parcelas_mdfe_dVenc->setSize(110);
        $mdfe_componentes_mdfe_id->setSize(200);
        $datahora_cancelamento->setSize('100%');
        $mdfe_condutor_mdfe_cpf->setSize('100%');
        $protocolo_cancelamento->setSize('100%');
        $mdfe_infmuncarrega_mdfe_id->setSize(200);
        $mdfe_lacres_mdfe_nLacre->setSize('100%');
        $mdfe_condutor_mdfe_xnome->setSize('100%');
        $mdfe_infmundescarga_mdfe_id->setSize(200);
        $mdfe_xmlaut_mdfe_cpfcnpj->setSize('100%');
        $mdfe_infpercurso_mdfe_UFPer->setSize('100%');
        $mdfe_parcelas_mdfe_nParcela->setSize('100%');
        $mdfe_parcelas_mdfe_vParcela->setSize('100%');
        $mdfe_componentes_mdfe_xComp->setSize('100%');
        $mdfe_componentes_mdfe_vComp->setSize('100%');
        $justificativa_cancelamento->setSize('100%', 70);
        $mdfe_infmuncarrega_mdfe_cidade_id->setSize('100%');
        $mdfe_infmundescarga_mdfe_cidade_id->setSize('100%');
        $mdfe_parcelas_mdfe_mdfe_tpAntecip_id->setSize('100%');
        $mdfe_componentes_mdfe_mdfe_tpcomp_id->setSize('100%');

        $button_adicionar_mdfe_lacres_mdfe->id = '629f5a6112436';
        $button_adicionar_mdfe_xmlaut_mdfe->id = '629f5b9312451';
        $button_adicionar_mdfe_condutor_mdfe->id = '629f5aab1243f';
        $button_adicionar_mdfe_parcelas_mdfe->id = '629f5d0f12467';
        $button_adicionar_mdfe_infpercurso_mdfe->id = '629f5b2712448';
        $button_adicionar_mdfe_componentes_mdfe->id = '629f5bd71245a';
        $button_adicionar_mdfe_infmuncarrega_mdfe->id = '629f592b12424';
        $button_adicionar_mdfe_infmundescarga_mdfe->id = '629f59ad1242d';

        $this->form->appendPage("Geral");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$mdfe_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Série:", null, '14px', null, '100%'),$serie],[new TLabel("Número:", null, '14px', null, '100%'),$nMDF]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Tipo Ambiente:", '#FF0000', '14px', null),$mdfe_tpamb_id],[new TLabel("Data e hora emissão:", null, '14px', null, '100%'),$dhEmi],[new TLabel("Data e hora previstos de início da viagem:", null, '14px', null, '100%'),$dhIniViagem]);
        $row3->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Tipo Emitente:", '#ff0000', '14px', null, '100%'),$mdfe_tpemit_id],[new TLabel("Tipo de proprietário:", '#ff0000', '14px', null, '100%'),$mdfe_tpprop_id],[new TLabel("Tipo de Transporte:", null, '14px', null, '100%'),$mdfe_tptransp_id]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([new TLabel("UF do Carregamento:", '#ff0000', '14px', null, '100%'),$UFIni],[new TLabel("UF do Descarregamento:", '#ff0000', '14px', null, '100%'),$UFFim]);
        $row5->layout = ['col-sm-4','col-sm-4'];

        $row6 = $this->form->addFields([new TLabel("Indicador de participação do Canal Verde:", '#ff0000', '14px', null, '100%'),$indCanalVerde],[new TLabel("Por evento de inclusão de DF-e:", '#ff0000', '14px', null, '100%'),$indCarregaPosterior],[new TLabel("Transporte de alto desempenho:", null, '14px', null, '100%'),$pgto_indAltoDesemp]);
        $row6->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row7 = $this->form->addContent([new TFormSeparator("Valores", '#333', '18', '#eee')]);
        $row8 = $this->form->addFields([new TLabel("Unidade de medida:", '#ff0000', '14px', null, '100%'),$mdfe_cunid_id],[new TLabel("Peso bruto total da carga:", null, '14px', null, '100%'),$qCarga],[new TLabel("Valor total da carga:", null, '14px', null, '100%'),$vCarga]);
        $row8->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row9 = $this->form->addContent([new TFormSeparator("Carga/Mercadoria", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([new TLabel("Tipo da Carga:", null, '14px', null, '100%'),$mdfe_tpcarga_id],[new TLabel("Descrição do produto predominante:", null, '14px', null, '100%'),$prod_xProd]);
        $row10->layout = [' col-sm-6',' col-sm-6'];

        $row11 = $this->form->addFields([new TLabel("GTIN (código EAN ou código de barras):", null, '14px', null, '100%'),$prod_cEAN],[new TLabel("Código NCM do Produto:", null, '14px', null, '100%'),$prod_NCM]);
        $row11->layout = [' col-sm-6',' col-sm-6'];

        $row12 = $this->form->addFields([new TLabel("Informações adicionais de interesse do fisco:", null, '14px', null, '100%'),$infAdFisco],[new TLabel("Informações adicionais de interesse do contribuinte:", null, '14px', null, '100%'),$infCpl]);
        $row12->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_6364d37969372 = new BContainer('bcontainer_6364d37969372');
        $this->bcontainer_6364d37969372 = $bcontainer_6364d37969372;

        $bcontainer_6364d37969372->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_6364d37969372->setBorderColor('#c0c0c0');

        $row13 = $bcontainer_6364d37969372->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row13->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row14 = $this->form->addFields([$bcontainer_6364d37969372]);
        $row14->layout = [' col-sm-12'];

        $this->form->appendPage("Veículos e Condutores");
        $row15 = $this->form->addContent([new TFormSeparator("Veículo", '#333', '18', '#eee')]);
        $row16 = $this->form->addFields([new TLabel("Veículo:", '#F44336', '14px', null),$veiculo_id],[new TLabel("Placa:", null, '14px', null),$veic_placa],[new TLabel("Estado:", '#F44336', '14px', null),$veic_estado_id]);
        $row16->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row17 = $this->form->addFields([new TLabel("RNTRC:", null, '14px', null),$veic_rntrc],[new TLabel("Renavam:", null, '14px', null),$veic_renavam],[new TLabel("Código interno do veículo:", null, '14px', null),$veic_cint]);
        $row17->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row18 = $this->form->addFields([new TLabel("Tipo de carroceria:", '#F44336', '14px', null),$mdfe_tpcar_id],[new TLabel("Tipo de rodado:", '#F44336', '14px', null, '100%'),$mdfe_tpRod_id],[new TLabel("Tara:", null, '14px', null),$veic_tara]);
        $row18->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row19 = $this->form->addContent([new TFormSeparator("Condutores", '#333', '18', '#eee')]);

        $this->detailFormMdfeCondutorMdfe = new BootstrapFormBuilder('detailFormMdfeCondutorMdfe');
        $this->detailFormMdfeCondutorMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeCondutorMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row20 = $this->detailFormMdfeCondutorMdfe->addFields([new TLabel("Nome do Condutor :", '#ff0000', '14px', null, '100%'),$mdfe_condutor_mdfe_xnome,$mdfe_condutor_mdfe_id],[new TLabel("CPF:", '#ff0000', '14px', null, '100%'),$mdfe_condutor_mdfe_cpf]);
        $row20->layout = ['col-sm-6','col-sm-6'];

        $row21 = $this->detailFormMdfeCondutorMdfe->addFields([$button_adicionar_mdfe_condutor_mdfe]);
        $row21->layout = [' col-sm-12'];

        $row22 = $this->detailFormMdfeCondutorMdfe->addFields([new THidden('mdfe_condutor_mdfe__row__id')]);
        $this->mdfe_condutor_mdfe_criteria = new TCriteria();

        $this->mdfe_condutor_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_condutor_mdfe_list->disableHtmlConversion();;
        $this->mdfe_condutor_mdfe_list->generateHiddenFields();
        $this->mdfe_condutor_mdfe_list->setId('mdfe_condutor_mdfe_list');

        $this->mdfe_condutor_mdfe_list->style = 'width:100%';
        $this->mdfe_condutor_mdfe_list->class .= ' table-bordered';

        $column_mdfe_condutor_mdfe_xnome = new TDataGridColumn('xnome', "Nome do Condutor ", 'left');
        $column_mdfe_condutor_mdfe_cpf = new TDataGridColumn('cpf', "CPF", 'left');

        $column_mdfe_condutor_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_condutor_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeCondutor = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeCondutor'));
        $action_onEditDetailMdfeCondutor->setUseButton(true);
        $action_onEditDetailMdfeCondutor->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeCondutor->setLabel("Editar");
        $action_onEditDetailMdfeCondutor->setImage('far:edit #478fca');
        $action_onEditDetailMdfeCondutor->setFields(['__row__id', '__row__data']);

        $this->mdfe_condutor_mdfe_list->addAction($action_onEditDetailMdfeCondutor);
        $action_onDeleteDetailMdfeCondutor = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeCondutor'));
        $action_onDeleteDetailMdfeCondutor->setUseButton(true);
        $action_onDeleteDetailMdfeCondutor->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeCondutor->setLabel("Excluir");
        $action_onDeleteDetailMdfeCondutor->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeCondutor->setFields(['__row__id', '__row__data']);

        $this->mdfe_condutor_mdfe_list->addAction($action_onDeleteDetailMdfeCondutor);

        $this->mdfe_condutor_mdfe_list->addColumn($column_mdfe_condutor_mdfe_xnome);
        $this->mdfe_condutor_mdfe_list->addColumn($column_mdfe_condutor_mdfe_cpf);

        $this->mdfe_condutor_mdfe_list->addColumn($column_mdfe_condutor_mdfe__row__data);

        $this->mdfe_condutor_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_condutor_mdfe_list);
        $this->detailFormMdfeCondutorMdfe->addContent([$tableResponsiveDiv]);
        $row23 = $this->form->addFields([$this->detailFormMdfeCondutorMdfe]);
        $row23->layout = [' col-sm-12'];

        $this->form->appendPage("Carregamento");

        $this->detailFormMdfeInfmuncarregaMdfe = new BootstrapFormBuilder('detailFormMdfeInfmuncarregaMdfe');
        $this->detailFormMdfeInfmuncarregaMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeInfmuncarregaMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row24 = $this->detailFormMdfeInfmuncarregaMdfe->addFields([new TLabel("Cidade:", '#ff0000', '14px', null, '100%'),$mdfe_infmuncarrega_mdfe_cidade_id,$mdfe_infmuncarrega_mdfe_id]);
        $row24->layout = [' col-sm-12'];

        $row25 = $this->detailFormMdfeInfmuncarregaMdfe->addFields([$button_adicionar_mdfe_infmuncarrega_mdfe]);
        $row25->layout = [' col-sm-12'];

        $row26 = $this->detailFormMdfeInfmuncarregaMdfe->addFields([new THidden('mdfe_infmuncarrega_mdfe__row__id')]);
        $this->mdfe_infmuncarrega_mdfe_criteria = new TCriteria();

        $this->mdfe_infmuncarrega_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_infmuncarrega_mdfe_list->disableHtmlConversion();;
        $this->mdfe_infmuncarrega_mdfe_list->generateHiddenFields();
        $this->mdfe_infmuncarrega_mdfe_list->setId('mdfe_infmuncarrega_mdfe_list');

        $this->mdfe_infmuncarrega_mdfe_list->style = 'width:100%';
        $this->mdfe_infmuncarrega_mdfe_list->class .= ' table-bordered';

        $column_mdfe_infmuncarrega_mdfe_cMunCarrega = new TDataGridColumn('cMunCarrega', "Código do Município", 'left');
        $column_mdfe_infmuncarrega_mdfe_cidade_nome = new TDataGridColumn('cidade->nome', "Cidade", 'left');

        $column_mdfe_infmuncarrega_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_infmuncarrega_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeInfmuncarrega = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeInfmuncarrega'));
        $action_onEditDetailMdfeInfmuncarrega->setUseButton(true);
        $action_onEditDetailMdfeInfmuncarrega->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeInfmuncarrega->setLabel("Editar");
        $action_onEditDetailMdfeInfmuncarrega->setImage('far:edit #478fca');
        $action_onEditDetailMdfeInfmuncarrega->setFields(['__row__id', '__row__data']);

        $this->mdfe_infmuncarrega_mdfe_list->addAction($action_onEditDetailMdfeInfmuncarrega);
        $action_onDeleteDetailMdfeInfmuncarrega = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeInfmuncarrega'));
        $action_onDeleteDetailMdfeInfmuncarrega->setUseButton(true);
        $action_onDeleteDetailMdfeInfmuncarrega->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeInfmuncarrega->setLabel("Excluir");
        $action_onDeleteDetailMdfeInfmuncarrega->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeInfmuncarrega->setFields(['__row__id', '__row__data']);

        $this->mdfe_infmuncarrega_mdfe_list->addAction($action_onDeleteDetailMdfeInfmuncarrega);

        $this->mdfe_infmuncarrega_mdfe_list->addColumn($column_mdfe_infmuncarrega_mdfe_cMunCarrega);
        $this->mdfe_infmuncarrega_mdfe_list->addColumn($column_mdfe_infmuncarrega_mdfe_cidade_nome);

        $this->mdfe_infmuncarrega_mdfe_list->addColumn($column_mdfe_infmuncarrega_mdfe__row__data);

        $this->mdfe_infmuncarrega_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_infmuncarrega_mdfe_list);
        $this->detailFormMdfeInfmuncarregaMdfe->addContent([$tableResponsiveDiv]);
        $row27 = $this->form->addFields([$this->detailFormMdfeInfmuncarregaMdfe]);
        $row27->layout = [' col-sm-12'];

        $this->form->appendPage("Percurso");

        $this->detailFormMdfeInfpercursoMdfe = new BootstrapFormBuilder('detailFormMdfeInfpercursoMdfe');
        $this->detailFormMdfeInfpercursoMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeInfpercursoMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row28 = $this->detailFormMdfeInfpercursoMdfe->addFields([new TLabel("UF:", '#ff0000', '14px', null, '100%'),$mdfe_infpercurso_mdfe_UFPer,$mdfe_infpercurso_mdfe_id]);
        $row28->layout = ['col-sm-12'];

        $row29 = $this->detailFormMdfeInfpercursoMdfe->addFields([$button_adicionar_mdfe_infpercurso_mdfe]);
        $row29->layout = [' col-sm-12'];

        $row30 = $this->detailFormMdfeInfpercursoMdfe->addFields([new THidden('mdfe_infpercurso_mdfe__row__id')]);
        $this->mdfe_infpercurso_mdfe_criteria = new TCriteria();

        $this->mdfe_infpercurso_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_infpercurso_mdfe_list->disableHtmlConversion();;
        $this->mdfe_infpercurso_mdfe_list->generateHiddenFields();
        $this->mdfe_infpercurso_mdfe_list->setId('mdfe_infpercurso_mdfe_list');

        $this->mdfe_infpercurso_mdfe_list->style = 'width:100%';
        $this->mdfe_infpercurso_mdfe_list->class .= ' table-bordered';

        $column_mdfe_infpercurso_mdfe_fk_UFPer_nome = new TDataGridColumn('fk_UFPer->nome', "UF Percurso", 'left');

        $column_mdfe_infpercurso_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_infpercurso_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeInfpercurso = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeInfpercurso'));
        $action_onEditDetailMdfeInfpercurso->setUseButton(true);
        $action_onEditDetailMdfeInfpercurso->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeInfpercurso->setLabel("Editar");
        $action_onEditDetailMdfeInfpercurso->setImage('far:edit #478fca');
        $action_onEditDetailMdfeInfpercurso->setFields(['__row__id', '__row__data']);

        $this->mdfe_infpercurso_mdfe_list->addAction($action_onEditDetailMdfeInfpercurso);
        $action_onDeleteDetailMdfeInfpercurso = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeInfpercurso'));
        $action_onDeleteDetailMdfeInfpercurso->setUseButton(true);
        $action_onDeleteDetailMdfeInfpercurso->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeInfpercurso->setLabel("Excluir");
        $action_onDeleteDetailMdfeInfpercurso->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeInfpercurso->setFields(['__row__id', '__row__data']);

        $this->mdfe_infpercurso_mdfe_list->addAction($action_onDeleteDetailMdfeInfpercurso);

        $this->mdfe_infpercurso_mdfe_list->addColumn($column_mdfe_infpercurso_mdfe_fk_UFPer_nome);

        $this->mdfe_infpercurso_mdfe_list->addColumn($column_mdfe_infpercurso_mdfe__row__data);

        $this->mdfe_infpercurso_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_infpercurso_mdfe_list);
        $this->detailFormMdfeInfpercursoMdfe->addContent([$tableResponsiveDiv]);
        $row31 = $this->form->addFields([$this->detailFormMdfeInfpercursoMdfe]);
        $row31->layout = [' col-sm-12'];

        $this->form->appendPage("Descarga");

        $this->detailFormMdfeInfmundescargaMdfe = new BootstrapFormBuilder('detailFormMdfeInfmundescargaMdfe');
        $this->detailFormMdfeInfmundescargaMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeInfmundescargaMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row32 = $this->detailFormMdfeInfmundescargaMdfe->addFields([new TLabel("Cidade:", '#ff0000', '14px', null, '100%'),$mdfe_infmundescarga_mdfe_cidade_id,$mdfe_infmundescarga_mdfe_id]);
        $row32->layout = [' col-sm-12'];

        $row33 = $this->detailFormMdfeInfmundescargaMdfe->addFields([$button_adicionar_mdfe_infmundescarga_mdfe]);
        $row33->layout = [' col-sm-12'];

        $row34 = $this->detailFormMdfeInfmundescargaMdfe->addFields([new THidden('mdfe_infmundescarga_mdfe__row__id')]);
        $this->mdfe_infmundescarga_mdfe_criteria = new TCriteria();

        $this->mdfe_infmundescarga_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_infmundescarga_mdfe_list->disableHtmlConversion();;
        $this->mdfe_infmundescarga_mdfe_list->generateHiddenFields();
        $this->mdfe_infmundescarga_mdfe_list->setId('mdfe_infmundescarga_mdfe_list');

        $this->mdfe_infmundescarga_mdfe_list->style = 'width:100%';
        $this->mdfe_infmundescarga_mdfe_list->class .= ' table-bordered';

        $column_mdfe_infmundescarga_mdfe_cMunDescarga = new TDataGridColumn('cMunDescarga', "Código do Município", 'left');
        $column_mdfe_infmundescarga_mdfe_cidade_nome = new TDataGridColumn('cidade->nome', "Cidade", 'left');

        $column_mdfe_infmundescarga_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_infmundescarga_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeInfmundescarga = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeInfmundescarga'));
        $action_onEditDetailMdfeInfmundescarga->setUseButton(true);
        $action_onEditDetailMdfeInfmundescarga->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeInfmundescarga->setLabel("Editar");
        $action_onEditDetailMdfeInfmundescarga->setImage('far:edit #478fca');
        $action_onEditDetailMdfeInfmundescarga->setFields(['__row__id', '__row__data']);

        $this->mdfe_infmundescarga_mdfe_list->addAction($action_onEditDetailMdfeInfmundescarga);
        $action_onDeleteDetailMdfeInfmundescarga = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeInfmundescarga'));
        $action_onDeleteDetailMdfeInfmundescarga->setUseButton(true);
        $action_onDeleteDetailMdfeInfmundescarga->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeInfmundescarga->setLabel("Excluir");
        $action_onDeleteDetailMdfeInfmundescarga->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeInfmundescarga->setFields(['__row__id', '__row__data']);

        $this->mdfe_infmundescarga_mdfe_list->addAction($action_onDeleteDetailMdfeInfmundescarga);
        $action_onIncluirNFEDescarga = new TDataGridAction(array('MdfeForm', 'onIncluirNFEDescarga'));
        $action_onIncluirNFEDescarga->setUseButton(true);
        $action_onIncluirNFEDescarga->setButtonClass('btn btn-default btn-sm');
        $action_onIncluirNFEDescarga->setLabel("NF-e");
        $action_onIncluirNFEDescarga->setImage('fas:file #000000');
        $action_onIncluirNFEDescarga->setFields(['__row__id', '__row__data']);

        $this->mdfe_infmundescarga_mdfe_list->addAction($action_onIncluirNFEDescarga);
        $action_onIncluirCteDescarga = new TDataGridAction(array('MdfeForm', 'onIncluirCteDescarga'));
        $action_onIncluirCteDescarga->setUseButton(true);
        $action_onIncluirCteDescarga->setButtonClass('btn btn-default btn-sm');
        $action_onIncluirCteDescarga->setLabel("CT-e");
        $action_onIncluirCteDescarga->setImage('fas:file-alt #000000');
        $action_onIncluirCteDescarga->setFields(['__row__id', '__row__data']);

        $this->mdfe_infmundescarga_mdfe_list->addAction($action_onIncluirCteDescarga);
        $action_onIncluirMDFeDescarga = new TDataGridAction(array('MdfeForm', 'onIncluirMDFeDescarga'));
        $action_onIncluirMDFeDescarga->setUseButton(true);
        $action_onIncluirMDFeDescarga->setButtonClass('btn btn-default btn-sm');
        $action_onIncluirMDFeDescarga->setLabel("MDF-e");
        $action_onIncluirMDFeDescarga->setImage('fas:file-archive #000000');
        $action_onIncluirMDFeDescarga->setFields(['__row__id', '__row__data']);

        $this->mdfe_infmundescarga_mdfe_list->addAction($action_onIncluirMDFeDescarga);

        $this->mdfe_infmundescarga_mdfe_list->addColumn($column_mdfe_infmundescarga_mdfe_cMunDescarga);
        $this->mdfe_infmundescarga_mdfe_list->addColumn($column_mdfe_infmundescarga_mdfe_cidade_nome);

        $this->mdfe_infmundescarga_mdfe_list->addColumn($column_mdfe_infmundescarga_mdfe__row__data);

        $this->mdfe_infmundescarga_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_infmundescarga_mdfe_list);
        $this->detailFormMdfeInfmundescargaMdfe->addContent([$tableResponsiveDiv]);
        $row35 = $this->form->addFields([$this->detailFormMdfeInfmundescargaMdfe]);
        $row35->layout = [' col-sm-12'];

        $this->form->appendPage("Lacres");

        $this->detailFormMdfeLacresMdfe = new BootstrapFormBuilder('detailFormMdfeLacresMdfe');
        $this->detailFormMdfeLacresMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeLacresMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row36 = $this->detailFormMdfeLacresMdfe->addFields([new TLabel("Número do lacre:", '#ff0000', '14px', null, '100%'),$mdfe_lacres_mdfe_nLacre,$mdfe_lacres_mdfe_id]);
        $row36->layout = ['col-sm-12'];

        $row37 = $this->detailFormMdfeLacresMdfe->addFields([$button_adicionar_mdfe_lacres_mdfe]);
        $row37->layout = [' col-sm-12'];

        $row38 = $this->detailFormMdfeLacresMdfe->addFields([new THidden('mdfe_lacres_mdfe__row__id')]);
        $this->mdfe_lacres_mdfe_criteria = new TCriteria();

        $this->mdfe_lacres_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_lacres_mdfe_list->disableHtmlConversion();;
        $this->mdfe_lacres_mdfe_list->generateHiddenFields();
        $this->mdfe_lacres_mdfe_list->setId('mdfe_lacres_mdfe_list');

        $this->mdfe_lacres_mdfe_list->style = 'width:100%';
        $this->mdfe_lacres_mdfe_list->class .= ' table-bordered';

        $column_mdfe_lacres_mdfe_nLacre = new TDataGridColumn('nLacre', "Número do lacre", 'left');

        $column_mdfe_lacres_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_lacres_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeLacres = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeLacres'));
        $action_onEditDetailMdfeLacres->setUseButton(true);
        $action_onEditDetailMdfeLacres->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeLacres->setLabel("Editar");
        $action_onEditDetailMdfeLacres->setImage('far:edit #478fca');
        $action_onEditDetailMdfeLacres->setFields(['__row__id', '__row__data']);

        $this->mdfe_lacres_mdfe_list->addAction($action_onEditDetailMdfeLacres);
        $action_onDeleteDetailMdfeLacres = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeLacres'));
        $action_onDeleteDetailMdfeLacres->setUseButton(true);
        $action_onDeleteDetailMdfeLacres->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeLacres->setLabel("Excluir");
        $action_onDeleteDetailMdfeLacres->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeLacres->setFields(['__row__id', '__row__data']);

        $this->mdfe_lacres_mdfe_list->addAction($action_onDeleteDetailMdfeLacres);

        $this->mdfe_lacres_mdfe_list->addColumn($column_mdfe_lacres_mdfe_nLacre);

        $this->mdfe_lacres_mdfe_list->addColumn($column_mdfe_lacres_mdfe__row__data);

        $this->mdfe_lacres_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_lacres_mdfe_list);
        $this->detailFormMdfeLacresMdfe->addContent([$tableResponsiveDiv]);
        $row39 = $this->form->addFields([$this->detailFormMdfeLacresMdfe]);
        $row39->layout = [' col-sm-12'];

        $this->form->appendPage("Seguro");
        $row40 = $this->form->addFields([new TLabel("Responsável:", null, '14px', null, '100%'),$mdfe_respSeg_id],[new TLabel("CPF/CNPJ do responsável:", null, '14px', null, '100%'),$seguro_cpfcnpj]);
        $row40->layout = ['col-sm-6','col-sm-6'];

        $row41 = $this->form->addFields([new TLabel("Nome da Seguradora:", null, '14px', null, '100%'),$seguradora_xSeg],[new TLabel("CNPJ da seguradora:", null, '14px', null, '100%'),$seguradora_cnpj]);
        $row41->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("Autorizados");

        $this->detailFormMdfeXmlautMdfe = new BootstrapFormBuilder('detailFormMdfeXmlautMdfe');
        $this->detailFormMdfeXmlautMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeXmlautMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row42 = $this->detailFormMdfeXmlautMdfe->addFields([new TLabel("CPF/CNPJ Autorizado:", '#ff0000', '14px', null, '100%'),$mdfe_xmlaut_mdfe_cpfcnpj,$mdfe_xmlaut_mdfe_id]);
        $row42->layout = ['col-sm-12'];

        $row43 = $this->detailFormMdfeXmlautMdfe->addFields([$button_adicionar_mdfe_xmlaut_mdfe]);
        $row43->layout = [' col-sm-12'];

        $row44 = $this->detailFormMdfeXmlautMdfe->addFields([new THidden('mdfe_xmlaut_mdfe__row__id')]);
        $this->mdfe_xmlaut_mdfe_criteria = new TCriteria();

        $this->mdfe_xmlaut_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_xmlaut_mdfe_list->disableHtmlConversion();;
        $this->mdfe_xmlaut_mdfe_list->generateHiddenFields();
        $this->mdfe_xmlaut_mdfe_list->setId('mdfe_xmlaut_mdfe_list');

        $this->mdfe_xmlaut_mdfe_list->style = 'width:100%';
        $this->mdfe_xmlaut_mdfe_list->class .= ' table-bordered';

        $column_mdfe_xmlaut_mdfe_cpfcnpj = new TDataGridColumn('cpfcnpj', "CPF/CNPJ Autorizado", 'left');

        $column_mdfe_xmlaut_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_xmlaut_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeXmlaut = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeXmlaut'));
        $action_onEditDetailMdfeXmlaut->setUseButton(true);
        $action_onEditDetailMdfeXmlaut->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeXmlaut->setLabel("Editar");
        $action_onEditDetailMdfeXmlaut->setImage('far:edit #478fca');
        $action_onEditDetailMdfeXmlaut->setFields(['__row__id', '__row__data']);

        $this->mdfe_xmlaut_mdfe_list->addAction($action_onEditDetailMdfeXmlaut);
        $action_onDeleteDetailMdfeXmlaut = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeXmlaut'));
        $action_onDeleteDetailMdfeXmlaut->setUseButton(true);
        $action_onDeleteDetailMdfeXmlaut->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeXmlaut->setLabel("Excluir");
        $action_onDeleteDetailMdfeXmlaut->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeXmlaut->setFields(['__row__id', '__row__data']);

        $this->mdfe_xmlaut_mdfe_list->addAction($action_onDeleteDetailMdfeXmlaut);

        $this->mdfe_xmlaut_mdfe_list->addColumn($column_mdfe_xmlaut_mdfe_cpfcnpj);

        $this->mdfe_xmlaut_mdfe_list->addColumn($column_mdfe_xmlaut_mdfe__row__data);

        $this->mdfe_xmlaut_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_xmlaut_mdfe_list);
        $this->detailFormMdfeXmlautMdfe->addContent([$tableResponsiveDiv]);
        $row45 = $this->form->addFields([$this->detailFormMdfeXmlautMdfe]);
        $row45->layout = [' col-sm-12'];

        $this->form->appendPage("Pagamentos");
        $row46 = $this->form->addContent([new TFormSeparator("Pagamento", '#333', '18', '#eee')]);
        $row47 = $this->form->addFields([new TLabel("CPF/CNPJ:", null, '14px', null, '100%'),$pgto_cpfcnpj],[new TLabel("Nome:", null, '14px', null, '100%'),$pgto_xNome],[new TLabel("Valor total do contrato:", null, '14px', null, '100%'),$pgto_vContrato],[new TLabel("Identificação se Estrangeiro:", null, '14px', null, '100%'),$pgto_idEstrangeiro]);
        $row47->layout = ['col-sm-3','col-sm-3','col-sm-3','col-sm-3'];

        $row48 = $this->form->addFields([new TLabel("Indicador de Pagamento:", null, '14px', null, '100%'),$mdfe_indpag_id],[new TLabel("Adiantamento:", null, '14px', null, '100%'),$indAntecipaAdiant],[new TLabel("Valor do Adiantamento:", null, '14px', null, '100%'),$pgto_vAdiant]);
        $row48->layout = ['col-sm-3','col-sm-3','col-sm-3'];

        $row49 = $this->form->addFields([new TLabel("Número do banco:", null, '14px', null, '100%'),$pgto_codBanco],[new TLabel("Número da Agência:", null, '14px', null, '100%'),$pgto_codAgencia],[new TLabel("CNPJ da Instituição:", null, '14px', null, '100%'),$pgto_CNPJIPEF],[new TLabel("Chave PIX:", null, '14px', null, '100%'),$pgto_PIX]);
        $row49->layout = ['col-sm-3','col-sm-3','col-sm-3','col-sm-3'];

        $row50 = $this->form->addContent([new TFormSeparator("Parcelas", '#333', '18', '#eee')]);

        $this->detailFormMdfeParcelasMdfe = new BootstrapFormBuilder('detailFormMdfeParcelasMdfe');
        $this->detailFormMdfeParcelasMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeParcelasMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row51 = $this->detailFormMdfeParcelasMdfe->addFields([new TLabel("Número da parcela:", null, '14px', null, '100%'),$mdfe_parcelas_mdfe_nParcela,$mdfe_parcelas_mdfe_id],[new TLabel("Data de vencimento:", null, '14px', null, '100%'),$mdfe_parcelas_mdfe_dVenc]);
        $row51->layout = ['col-sm-6','col-sm-6'];

        $row52 = $this->detailFormMdfeParcelasMdfe->addFields([new TLabel("Valor da parcela:", null, '14px', null, '100%'),$mdfe_parcelas_mdfe_vParcela],[new TLabel("Tipo de Antecipação:", '#F44336', '14px', null, '100%'),$mdfe_parcelas_mdfe_mdfe_tpAntecip_id]);
        $row52->layout = ['col-sm-6','col-sm-6'];

        $row53 = $this->detailFormMdfeParcelasMdfe->addFields([$button_adicionar_mdfe_parcelas_mdfe]);
        $row53->layout = [' col-sm-12'];

        $row54 = $this->detailFormMdfeParcelasMdfe->addFields([new THidden('mdfe_parcelas_mdfe__row__id')]);
        $this->mdfe_parcelas_mdfe_criteria = new TCriteria();

        $this->mdfe_parcelas_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_parcelas_mdfe_list->disableHtmlConversion();;
        $this->mdfe_parcelas_mdfe_list->generateHiddenFields();
        $this->mdfe_parcelas_mdfe_list->setId('mdfe_parcelas_mdfe_list');

        $this->mdfe_parcelas_mdfe_list->style = 'width:100%';
        $this->mdfe_parcelas_mdfe_list->class .= ' table-bordered';

        $column_mdfe_parcelas_mdfe_nParcela = new TDataGridColumn('nParcela', "Número", 'left');
        $column_mdfe_parcelas_mdfe_dVenc_transformed = new TDataGridColumn('dVenc', "Vencimento", 'left');
        $column_mdfe_parcelas_mdfe_vParcela_transformed = new TDataGridColumn('vParcela', "Valor", 'left');
        $column_mdfe_parcelas_mdfe_mdfe_tpAntecip_descricao = new TDataGridColumn('mdfe_tpAntecip->descricao', "Tipo Antecipação", 'left');

        $column_mdfe_parcelas_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_parcelas_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeParcelas = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeParcelas'));
        $action_onEditDetailMdfeParcelas->setUseButton(true);
        $action_onEditDetailMdfeParcelas->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeParcelas->setLabel("Editar");
        $action_onEditDetailMdfeParcelas->setImage('far:edit #478fca');
        $action_onEditDetailMdfeParcelas->setFields(['__row__id', '__row__data']);

        $this->mdfe_parcelas_mdfe_list->addAction($action_onEditDetailMdfeParcelas);
        $action_onDeleteDetailMdfeParcelas = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeParcelas'));
        $action_onDeleteDetailMdfeParcelas->setUseButton(true);
        $action_onDeleteDetailMdfeParcelas->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeParcelas->setLabel("Excluir");
        $action_onDeleteDetailMdfeParcelas->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeParcelas->setFields(['__row__id', '__row__data']);

        $this->mdfe_parcelas_mdfe_list->addAction($action_onDeleteDetailMdfeParcelas);

        $this->mdfe_parcelas_mdfe_list->addColumn($column_mdfe_parcelas_mdfe_nParcela);
        $this->mdfe_parcelas_mdfe_list->addColumn($column_mdfe_parcelas_mdfe_dVenc_transformed);
        $this->mdfe_parcelas_mdfe_list->addColumn($column_mdfe_parcelas_mdfe_vParcela_transformed);
        $this->mdfe_parcelas_mdfe_list->addColumn($column_mdfe_parcelas_mdfe_mdfe_tpAntecip_descricao);

        $this->mdfe_parcelas_mdfe_list->addColumn($column_mdfe_parcelas_mdfe__row__data);

        $this->mdfe_parcelas_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_parcelas_mdfe_list);
        $this->detailFormMdfeParcelasMdfe->addContent([$tableResponsiveDiv]);

        $column_mdfe_parcelas_mdfe_dVenc_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $column_mdfe_parcelas_mdfe_vParcela_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row55 = $this->form->addFields([$this->detailFormMdfeParcelasMdfe]);
        $row55->layout = [' col-sm-12'];

        $row56 = $this->form->addContent([new TFormSeparator("Componentes", '#333', '18', '#eee')]);

        $this->detailFormMdfeComponentesMdfe = new BootstrapFormBuilder('detailFormMdfeComponentesMdfe');
        $this->detailFormMdfeComponentesMdfe->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeComponentesMdfe->setProperty('class', 'form-horizontal builder-detail-form');

        $row57 = $this->detailFormMdfeComponentesMdfe->addFields([new TLabel("Tipo:", null, '14px', null),$mdfe_componentes_mdfe_mdfe_tpcomp_id,$mdfe_componentes_mdfe_id],[new TLabel("Descrição:", null, '14px', null, '100%'),$mdfe_componentes_mdfe_xComp],[new TLabel("Valor:", null, '14px', null, '100%'),$mdfe_componentes_mdfe_vComp]);
        $row57->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row58 = $this->detailFormMdfeComponentesMdfe->addFields([$button_adicionar_mdfe_componentes_mdfe]);
        $row58->layout = [' col-sm-12'];

        $row59 = $this->detailFormMdfeComponentesMdfe->addFields([new THidden('mdfe_componentes_mdfe__row__id')]);
        $this->mdfe_componentes_mdfe_criteria = new TCriteria();

        $this->mdfe_componentes_mdfe_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_componentes_mdfe_list->disableHtmlConversion();;
        $this->mdfe_componentes_mdfe_list->generateHiddenFields();
        $this->mdfe_componentes_mdfe_list->setId('mdfe_componentes_mdfe_list');

        $this->mdfe_componentes_mdfe_list->style = 'width:100%';
        $this->mdfe_componentes_mdfe_list->class .= ' table-bordered';

        $column_mdfe_componentes_mdfe_mdfe_tpcomp_descricao = new TDataGridColumn('mdfe_tpcomp->descricao', "Tipo", 'left');
        $column_mdfe_componentes_mdfe_xComp = new TDataGridColumn('xComp', "Descrição", 'left');
        $column_mdfe_componentes_mdfe_vComp_transformed = new TDataGridColumn('vComp', "Valor", 'left');

        $column_mdfe_componentes_mdfe__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_componentes_mdfe__row__data->setVisibility(false);

        $action_onEditDetailMdfeComponentes = new TDataGridAction(array('MdfeForm', 'onEditDetailMdfeComponentes'));
        $action_onEditDetailMdfeComponentes->setUseButton(true);
        $action_onEditDetailMdfeComponentes->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeComponentes->setLabel("Editar");
        $action_onEditDetailMdfeComponentes->setImage('far:edit #478fca');
        $action_onEditDetailMdfeComponentes->setFields(['__row__id', '__row__data']);

        $this->mdfe_componentes_mdfe_list->addAction($action_onEditDetailMdfeComponentes);
        $action_onDeleteDetailMdfeComponentes = new TDataGridAction(array('MdfeForm', 'onDeleteDetailMdfeComponentes'));
        $action_onDeleteDetailMdfeComponentes->setUseButton(true);
        $action_onDeleteDetailMdfeComponentes->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeComponentes->setLabel("Excluir");
        $action_onDeleteDetailMdfeComponentes->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeComponentes->setFields(['__row__id', '__row__data']);

        $this->mdfe_componentes_mdfe_list->addAction($action_onDeleteDetailMdfeComponentes);

        $this->mdfe_componentes_mdfe_list->addColumn($column_mdfe_componentes_mdfe_mdfe_tpcomp_descricao);
        $this->mdfe_componentes_mdfe_list->addColumn($column_mdfe_componentes_mdfe_xComp);
        $this->mdfe_componentes_mdfe_list->addColumn($column_mdfe_componentes_mdfe_vComp_transformed);

        $this->mdfe_componentes_mdfe_list->addColumn($column_mdfe_componentes_mdfe__row__data);

        $this->mdfe_componentes_mdfe_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_componentes_mdfe_list);
        $this->detailFormMdfeComponentesMdfe->addContent([$tableResponsiveDiv]);

        $column_mdfe_componentes_mdfe_vComp_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row60 = $this->form->addFields([$this->detailFormMdfeComponentesMdfe]);
        $row60->layout = [' col-sm-12'];

        $this->form->appendPage("Eventos SEFAZ");
        $row61 = $this->form->addFields([new TLabel("Status SEFAZ:", null, '14px', null, '100%'),$status],[new TLabel("Código SEFAZ:", null, '14px', null, '100%'),$cStat],[new TLabel("Mensagem SEFAZ:", null, '14px', null, '100%'),$mensagem_sefaz]);
        $row61->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row62 = $this->form->addContent([new TFormSeparator("Envio", '#333', '18', '#eee')]);
        $row63 = $this->form->addFields([new TLabel("Protocolo:", null, '14px', null, '100%'),$nProt],[new TLabel("Chave:", null, '14px', null, '100%'),$chMDF],[new TLabel("Data e hora envio:", null, '14px', null, '100%'),$data_hora_envio]);
        $row63->layout = ['col-sm-4','col-sm-4',' col-sm-4'];

        $row64 = $this->form->addContent([new TFormSeparator("Cancelamento", '#333', '18', '#eee')]);
        $row65 = $this->form->addFields([new TLabel("Protocolo:", null, '14px', null),$protocolo_cancelamento],[new TLabel("Data e hora:", null, '14px', null),$datahora_cancelamento],[new TLabel("Justificativa de cancelamento:", null, '14px', null),$justificativa_cancelamento]);
        $row65->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacao = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacao']), 'fas:bars #000000');
        $this->btn_onvisualizacao = $btn_onvisualizacao;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['MdfeList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","Cadastro de MDF-e"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitTipoAmbiente($param = null) 
    {
        try 
        {
            if (isset($param['mdfe_tpamb_id']) && $param['mdfe_tpamb_id']&&isset($param['mdfe_tpamb_id']) && $param['mdfe_tpamb_id'])
            {
                $criteria = new TCriteria();
                $criteria->add(new TFilter('mdfe_tpamb_id', '=', $param['mdfe_tpamb_id']));         
                $criteria->add(new TFilter('system_unit_id', '=', TSession::getValue('userunitid')));  

                TDBCombo::reloadFromModel(self::$formName, 'serie', self::$database, 'MdfeSeries', 'serie', '{serie}', 'serie asc', $criteria, TRUE); 
            }
            else
            {
                TCombo::clearField(self::$formName, 'serie'); 
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitVeiculo($param = null) 
    {
        try 
        {
            if (isset($param['veiculo_id']) && $param['veiculo_id']&&isset($param['veiculo_id']) && $param['veiculo_id'])
            {
                TTransaction::open(self::$database);
                $veiculo = Veiculo::find($param['veiculo_id']);

                $object = new stdClass();

                if ($veiculo)
                {
                    $object->veic_rntrc = $veiculo->rntrc;
                    $object->veic_cint = $veiculo->id;
                    $object->veic_renavam = $veiculo->renavam;
                    $object->veic_estado_id = $veiculo->estado_id;
                    $object->veic_tara = $veiculo->tara;
                    $object->veic_placa = $veiculo->placa;
                    $object->mdfe_tpRod_id = $veiculo->mdfe_tpRod_id;
                    $object->mdfe_tpcar_id = $veiculo->mdfe_tpcar_id;

                    //adicionando condutor....
                    if ($veiculo->funcionario_motorista_id != null)
                    {
                        $object->mdfe_condutor_mdfe_xnome = $veiculo->funcionario_motorista->nome;
                        $object->mdfe_condutor_mdfe_cpf = $veiculo->funcionario_motorista->cpf;
                        $object->mdfe_condutor_mdfe_id = '';

                        $mdfeform = new MdfeForm([]);
                        $mdfeform->setIsWrapped(true);

                        $mdfeform->onAddDetailMdfeCondutorMdfe([   'customFormData' => $object,
                                                                    // simulando os dados enviados de forma bruta do formulário detalhe
                                                                    // ou seja, valores formatados
                                                                    'mdfe_condutor_mdfe_xnome' => $veiculo->funcionario_motorista->nome,
                                                                    'mdfe_condutor_mdfe_cpf' => $veiculo->funcionario_motorista->cpf
                                                                ]);

                        $object->mdfe_condutor_mdfe_xnome = '';
                        $object->mdfe_condutor_mdfe_cpf = '';
                    }

                }

                TTransaction::close();

                TForm::sendData(self::$formName, $object);                
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailMdfeCondutorMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if(!empty($param['customFormData']))
            {
                $data = $param['customFormData'];
            }                 

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Nome do Condutor ", 'name'=>"mdfe_condutor_mdfe_xnome", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"CPF", 'name'=>"mdfe_condutor_mdfe_cpf", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_condutor_mdfe__row__id) ? $data->mdfe_condutor_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeCondutor();
            $grid_data->__row__id = $__row__id;
            $grid_data->xnome = $data->mdfe_condutor_mdfe_xnome;
            $grid_data->id = $data->mdfe_condutor_mdfe_id;
            $grid_data->cpf = $data->mdfe_condutor_mdfe_cpf;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['xnome'] =  $param['mdfe_condutor_mdfe_xnome'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_condutor_mdfe_id'] ?? null;
            $__row__data['__display__']['cpf'] =  $param['mdfe_condutor_mdfe_cpf'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_condutor_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_condutor_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_condutor_mdfe_xnome = '';
            $data->mdfe_condutor_mdfe_id = '';
            $data->mdfe_condutor_mdfe_cpf = '';
            $data->mdfe_condutor_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5aab1243f');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailMdfeInfmuncarregaMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Código do Município de Carregamento", 'name'=>"mdfe_infmuncarrega_mdfe_cidade_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_infmuncarrega_mdfe__row__id) ? $data->mdfe_infmuncarrega_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeInfmuncarrega();
            $grid_data->__row__id = $__row__id;
            $grid_data->cidade_id = $data->mdfe_infmuncarrega_mdfe_cidade_id;
            $grid_data->id = $data->mdfe_infmuncarrega_mdfe_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['cidade_id'] =  $param['mdfe_infmuncarrega_mdfe_cidade_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_infmuncarrega_mdfe_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_infmuncarrega_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_infmuncarrega_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_infmuncarrega_mdfe_cidade_id = '';
            $data->mdfe_infmuncarrega_mdfe_id = '';
            $data->mdfe_infmuncarrega_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f592b12424');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailMdfeInfpercursoMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"UFPer", 'name'=>"mdfe_infpercurso_mdfe_UFPer", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_infpercurso_mdfe__row__id) ? $data->mdfe_infpercurso_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeInfpercurso();
            $grid_data->__row__id = $__row__id;
            $grid_data->UFPer = $data->mdfe_infpercurso_mdfe_UFPer;
            $grid_data->id = $data->mdfe_infpercurso_mdfe_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['UFPer'] =  $param['mdfe_infpercurso_mdfe_UFPer'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_infpercurso_mdfe_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_infpercurso_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_infpercurso_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_infpercurso_mdfe_UFPer = '';
            $data->mdfe_infpercurso_mdfe_id = '';
            $data->mdfe_infpercurso_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5b2712448');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailMdfeInfmundescargaMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Código do Município de Descarregamento", 'name'=>"mdfe_infmundescarga_mdfe_cidade_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_infmundescarga_mdfe__row__id) ? $data->mdfe_infmundescarga_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeInfmundescarga();
            $grid_data->__row__id = $__row__id;
            $grid_data->cidade_id = $data->mdfe_infmundescarga_mdfe_cidade_id;
            $grid_data->id = $data->mdfe_infmundescarga_mdfe_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['cidade_id'] =  $param['mdfe_infmundescarga_mdfe_cidade_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_infmundescarga_mdfe_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_infmundescarga_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_infmundescarga_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_infmundescarga_mdfe_cidade_id = '';
            $data->mdfe_infmundescarga_mdfe_id = '';
            $data->mdfe_infmundescarga_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f59ad1242d');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailMdfeLacresMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Número do lacre", 'name'=>"mdfe_lacres_mdfe_nLacre", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_lacres_mdfe__row__id) ? $data->mdfe_lacres_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeLacres();
            $grid_data->__row__id = $__row__id;
            $grid_data->nLacre = $data->mdfe_lacres_mdfe_nLacre;
            $grid_data->id = $data->mdfe_lacres_mdfe_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['nLacre'] =  $param['mdfe_lacres_mdfe_nLacre'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_lacres_mdfe_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_lacres_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_lacres_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_lacres_mdfe_nLacre = '';
            $data->mdfe_lacres_mdfe_id = '';
            $data->mdfe_lacres_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5a6112436');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailMdfeXmlautMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"CPF/CNPJ Autorizado", 'name'=>"mdfe_xmlaut_mdfe_cpfcnpj", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_xmlaut_mdfe__row__id) ? $data->mdfe_xmlaut_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeXmlaut();
            $grid_data->__row__id = $__row__id;
            $grid_data->cpfcnpj = $data->mdfe_xmlaut_mdfe_cpfcnpj;
            $grid_data->id = $data->mdfe_xmlaut_mdfe_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['cpfcnpj'] =  $param['mdfe_xmlaut_mdfe_cpfcnpj'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_xmlaut_mdfe_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_xmlaut_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_xmlaut_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_xmlaut_mdfe_cpfcnpj = '';
            $data->mdfe_xmlaut_mdfe_id = '';
            $data->mdfe_xmlaut_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5b9312451');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailMdfeParcelasMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Tipo Antecipação de Parcela", 'name'=>"mdfe_parcelas_mdfe_mdfe_tpAntecip_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_parcelas_mdfe__row__id) ? $data->mdfe_parcelas_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeParcelas();
            $grid_data->__row__id = $__row__id;
            $grid_data->nParcela = $data->mdfe_parcelas_mdfe_nParcela;
            $grid_data->id = $data->mdfe_parcelas_mdfe_id;
            $grid_data->dVenc = $data->mdfe_parcelas_mdfe_dVenc;
            $grid_data->vParcela = $data->mdfe_parcelas_mdfe_vParcela;
            $grid_data->mdfe_tpAntecip_id = $data->mdfe_parcelas_mdfe_mdfe_tpAntecip_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['nParcela'] =  $param['mdfe_parcelas_mdfe_nParcela'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_parcelas_mdfe_id'] ?? null;
            $__row__data['__display__']['dVenc'] =  $param['mdfe_parcelas_mdfe_dVenc'] ?? null;
            $__row__data['__display__']['vParcela'] =  $param['mdfe_parcelas_mdfe_vParcela'] ?? null;
            $__row__data['__display__']['mdfe_tpAntecip_id'] =  $param['mdfe_parcelas_mdfe_mdfe_tpAntecip_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_parcelas_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_parcelas_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_parcelas_mdfe_nParcela = '';
            $data->mdfe_parcelas_mdfe_id = '';
            $data->mdfe_parcelas_mdfe_dVenc = '';
            $data->mdfe_parcelas_mdfe_vParcela = '';
            $data->mdfe_parcelas_mdfe_mdfe_tpAntecip_id = '';
            $data->mdfe_parcelas_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5d0f12467');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailMdfeComponentesMdfe($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $__row__id = !empty($data->mdfe_componentes_mdfe__row__id) ? $data->mdfe_componentes_mdfe__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeComponentes();
            $grid_data->__row__id = $__row__id;
            $grid_data->mdfe_tpcomp_id = $data->mdfe_componentes_mdfe_mdfe_tpcomp_id;
            $grid_data->id = $data->mdfe_componentes_mdfe_id;
            $grid_data->xComp = $data->mdfe_componentes_mdfe_xComp;
            $grid_data->vComp = $data->mdfe_componentes_mdfe_vComp;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['mdfe_tpcomp_id'] =  $param['mdfe_componentes_mdfe_mdfe_tpcomp_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_componentes_mdfe_id'] ?? null;
            $__row__data['__display__']['xComp'] =  $param['mdfe_componentes_mdfe_xComp'] ?? null;
            $__row__data['__display__']['vComp'] =  $param['mdfe_componentes_mdfe_vComp'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_componentes_mdfe_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_componentes_mdfe_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_componentes_mdfe_mdfe_tpcomp_id = '';
            $data->mdfe_componentes_mdfe_id = '';
            $data->mdfe_componentes_mdfe_xComp = '';
            $data->mdfe_componentes_mdfe_vComp = '';
            $data->mdfe_componentes_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5bd71245a');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailMdfeCondutor($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_condutor_mdfe_xnome = $__row__data->__display__->xnome ?? null;
            $data->mdfe_condutor_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_condutor_mdfe_cpf = $__row__data->__display__->cpf ?? null;
            $data->mdfe_condutor_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5aab1243f');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeCondutor($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_condutor_mdfe_xnome = '';
            $data->mdfe_condutor_mdfe_id = '';
            $data->mdfe_condutor_mdfe_cpf = '';
            $data->mdfe_condutor_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_condutor_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailMdfeInfmuncarrega($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_infmuncarrega_mdfe_cidade_id = $__row__data->__display__->cidade_id ?? null;
            $data->mdfe_infmuncarrega_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_infmuncarrega_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f592b12424');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeInfmuncarrega($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_infmuncarrega_mdfe_cidade_id = '';
            $data->mdfe_infmuncarrega_mdfe_id = '';
            $data->mdfe_infmuncarrega_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_infmuncarrega_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailMdfeInfpercurso($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_infpercurso_mdfe_UFPer = $__row__data->__display__->UFPer ?? null;
            $data->mdfe_infpercurso_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_infpercurso_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5b2712448');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeInfpercurso($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_infpercurso_mdfe_UFPer = '';
            $data->mdfe_infpercurso_mdfe_id = '';
            $data->mdfe_infpercurso_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_infpercurso_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailMdfeInfmundescarga($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_infmundescarga_mdfe_cidade_id = $__row__data->__display__->cidade_id ?? null;
            $data->mdfe_infmundescarga_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_infmundescarga_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f59ad1242d');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeInfmundescarga($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_infmundescarga_mdfe_cidade_id = '';
            $data->mdfe_infmundescarga_mdfe_id = '';
            $data->mdfe_infmundescarga_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_infmundescarga_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onIncluirNFEDescarga($param = null) 
    {
        try 
        {
            $__row__data = unserialize(base64_decode($param['__row__data']));

            if($__row__data->id == null){
                throw new Exception('Favor salvar o MDF-e para poder incluir essa informação.');
            }

            $id = $__row__data->id;

            $pageParam = ['key' => $id]; 
            TApplication::loadPage('MdfeInfmundescargaForm', 'onEdit', $pageParam);

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onIncluirCteDescarga($param = null) 
    {
        try 
        {
            $__row__data = unserialize(base64_decode($param['__row__data']));

            if($__row__data->id == null){
                throw new Exception('Favor salvar o MDF-e para poder incluir essa informação.');
            }

            $id = $__row__data->id;

            $pageParam = ['key' => $id]; 
            TApplication::loadPage('MdfeInfmundescargaCteForm', 'onEdit', $pageParam);

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onIncluirMDFeDescarga($param = null) 
    {
        try 
        {
            $__row__data = unserialize(base64_decode($param['__row__data']));

            if($__row__data->id == null){
                throw new Exception('Favor salvar o MDF-e para poder incluir essa informação.');
            }

            $id = $__row__data->id;

            $pageParam = ['key' => $id]; 
            TApplication::loadPage('MdfeInfmundescargaMDFeForm', 'onEdit', $pageParam);

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onEditDetailMdfeLacres($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_lacres_mdfe_nLacre = $__row__data->__display__->nLacre ?? null;
            $data->mdfe_lacres_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_lacres_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5a6112436');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeLacres($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_lacres_mdfe_nLacre = '';
            $data->mdfe_lacres_mdfe_id = '';
            $data->mdfe_lacres_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_lacres_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailMdfeXmlaut($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_xmlaut_mdfe_cpfcnpj = $__row__data->__display__->cpfcnpj ?? null;
            $data->mdfe_xmlaut_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_xmlaut_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5b9312451');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeXmlaut($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_xmlaut_mdfe_cpfcnpj = '';
            $data->mdfe_xmlaut_mdfe_id = '';
            $data->mdfe_xmlaut_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_xmlaut_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailMdfeParcelas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_parcelas_mdfe_nParcela = $__row__data->__display__->nParcela ?? null;
            $data->mdfe_parcelas_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_parcelas_mdfe_dVenc = $__row__data->__display__->dVenc ?? null;
            $data->mdfe_parcelas_mdfe_vParcela = $__row__data->__display__->vParcela ?? null;
            $data->mdfe_parcelas_mdfe_mdfe_tpAntecip_id = $__row__data->__display__->mdfe_tpAntecip_id ?? null;
            $data->mdfe_parcelas_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5d0f12467');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeParcelas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_parcelas_mdfe_nParcela = '';
            $data->mdfe_parcelas_mdfe_id = '';
            $data->mdfe_parcelas_mdfe_dVenc = '';
            $data->mdfe_parcelas_mdfe_vParcela = '';
            $data->mdfe_parcelas_mdfe_mdfe_tpAntecip_id = '';
            $data->mdfe_parcelas_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_parcelas_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailMdfeComponentes($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_componentes_mdfe_mdfe_tpcomp_id = $__row__data->__display__->mdfe_tpcomp_id ?? null;
            $data->mdfe_componentes_mdfe_id = $__row__data->__display__->id ?? null;
            $data->mdfe_componentes_mdfe_xComp = $__row__data->__display__->xComp ?? null;
            $data->mdfe_componentes_mdfe_vComp = $__row__data->__display__->vComp ?? null;
            $data->mdfe_componentes_mdfe__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#629f5bd71245a');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeComponentes($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_componentes_mdfe_mdfe_tpcomp_id = '';
            $data->mdfe_componentes_mdfe_id = '';
            $data->mdfe_componentes_mdfe_xComp = '';
            $data->mdfe_componentes_mdfe_vComp = '';
            $data->mdfe_componentes_mdfe__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_componentes_mdfe_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Mdfe(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            Funcoes::SalvarUsuarioCadastro($object);

            if($data->id == "")
            {
                $object->system_unit_id = TSession::getValue('userunitid'); 
            }

            if(empty($object->nMDF))
            {
                $object->nMDF = funcaoMDFe::ObterProximoSequencialMdfeSerie($object->mdfe_tpamb_id,
                                                                            $object->serie,
                                                                            TSession::getValue('userunitid'));
            }             

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            TForm::sendData(self::$formName, (object)['nMDF' => $object->nMDF]);

            $mdfe_parcelas_mdfe_items = $this->storeMasterDetailItems('MdfeParcelas', 'mdfe_id', 'mdfe_parcelas_mdfe', $object, $param['mdfe_parcelas_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_parcelas_mdfe_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->mdfe_parcelas_mdfe_criteria); 

            $mdfe_componentes_mdfe_items = $this->storeMasterDetailItems('MdfeComponentes', 'mdfe_id', 'mdfe_componentes_mdfe', $object, $param['mdfe_componentes_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_componentes_mdfe_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->mdfe_componentes_mdfe_criteria); 

            $mdfe_xmlaut_mdfe_items = $this->storeMasterDetailItems('MdfeXmlaut', 'mdfe_id', 'mdfe_xmlaut_mdfe', $object, $param['mdfe_xmlaut_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_xmlaut_mdfe_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->mdfe_xmlaut_mdfe_criteria); 

            $mdfe_infpercurso_mdfe_items = $this->storeMasterDetailItems('MdfeInfpercurso', 'mdfe_id', 'mdfe_infpercurso_mdfe', $object, $param['mdfe_infpercurso_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_infpercurso_mdfe_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->mdfe_infpercurso_mdfe_criteria); 

            $mdfe_condutor_mdfe_items = $this->storeMasterDetailItems('MdfeCondutor', 'mdfe_id', 'mdfe_condutor_mdfe', $object, $param['mdfe_condutor_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_condutor_mdfe_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->mdfe_condutor_mdfe_criteria); 

            $mdfe_lacres_mdfe_items = $this->storeMasterDetailItems('MdfeLacres', 'mdfe_id', 'mdfe_lacres_mdfe', $object, $param['mdfe_lacres_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_lacres_mdfe_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->mdfe_lacres_mdfe_criteria); 

            $mdfe_infmundescarga_mdfe_items = $this->storeMasterDetailItems('MdfeInfmundescarga', 'mdfe_id', 'mdfe_infmundescarga_mdfe', $object, $param['mdfe_infmundescarga_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_infmundescarga_mdfe_list, function($masterObject, $detailObject){ 

                $cidade = Cidade::find($detailObject->cidade_id);
                if($cidade){
                    $detailObject->cMunDescarga = $cidade->codigo_ibge;
                    $detailObject->xMunDescarga = $cidade->nome;
                }

            }, $this->mdfe_infmundescarga_mdfe_criteria); 

            $mdfe_infmuncarrega_mdfe_items = $this->storeMasterDetailItems('MdfeInfmuncarrega', 'mdfe_id', 'mdfe_infmuncarrega_mdfe', $object, $param['mdfe_infmuncarrega_mdfe_list___row__data'] ?? [], $this->form, $this->mdfe_infmuncarrega_mdfe_list, function($masterObject, $detailObject){ 

                $cidade = Cidade::find($detailObject->cidade_id);
                if($cidade){
                    $detailObject->cMunCarrega = $cidade->codigo_ibge;
                    $detailObject->xMunCarrega = $cidade->nome;
                }

            }, $this->mdfe_infmuncarrega_mdfe_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacao($param = null) 
    {
        try 
        {
             $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve o MDF-e para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('MdfeFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Mdfe($key); // instantiates the Active Record 

                $mdfe_parcelas_mdfe_items = $this->loadMasterDetailItems('MdfeParcelas', 'mdfe_id', 'mdfe_parcelas_mdfe', $object, $this->form, $this->mdfe_parcelas_mdfe_list, $this->mdfe_parcelas_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $mdfe_componentes_mdfe_items = $this->loadMasterDetailItems('MdfeComponentes', 'mdfe_id', 'mdfe_componentes_mdfe', $object, $this->form, $this->mdfe_componentes_mdfe_list, $this->mdfe_componentes_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $mdfe_xmlaut_mdfe_items = $this->loadMasterDetailItems('MdfeXmlaut', 'mdfe_id', 'mdfe_xmlaut_mdfe', $object, $this->form, $this->mdfe_xmlaut_mdfe_list, $this->mdfe_xmlaut_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $mdfe_infpercurso_mdfe_items = $this->loadMasterDetailItems('MdfeInfpercurso', 'mdfe_id', 'mdfe_infpercurso_mdfe', $object, $this->form, $this->mdfe_infpercurso_mdfe_list, $this->mdfe_infpercurso_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $mdfe_condutor_mdfe_items = $this->loadMasterDetailItems('MdfeCondutor', 'mdfe_id', 'mdfe_condutor_mdfe', $object, $this->form, $this->mdfe_condutor_mdfe_list, $this->mdfe_condutor_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $mdfe_lacres_mdfe_items = $this->loadMasterDetailItems('MdfeLacres', 'mdfe_id', 'mdfe_lacres_mdfe', $object, $this->form, $this->mdfe_lacres_mdfe_list, $this->mdfe_lacres_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $mdfe_infmundescarga_mdfe_items = $this->loadMasterDetailItems('MdfeInfmundescarga', 'mdfe_id', 'mdfe_infmundescarga_mdfe', $object, $this->form, $this->mdfe_infmundescarga_mdfe_list, $this->mdfe_infmundescarga_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $mdfe_infmuncarrega_mdfe_items = $this->loadMasterDetailItems('MdfeInfmuncarrega', 'mdfe_id', 'mdfe_infmuncarrega_mdfe', $object, $this->form, $this->mdfe_infmuncarrega_mdfe_list, $this->mdfe_infmuncarrega_mdfe_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->mdfe_situacao_id     = MdfeSituacao::EmDigitacao;
        $object->dhEmi                = date('d/m/Y H:i');
        $object->dhIniViagem          = date('d/m/Y H:i');
        $object->mdfe_tpemit_id       = MdfeTpemit::PrestCargaProp;
        $object->mdfe_tpprop_id       = MdfeTpprop::TACIndependente;   
        //$object->mdfe_tptransp_id     = MdfeTptransp::ETC;
        $object->indCanalVerde        = Resposta::Nao;    
        $object->indCarregaPosterior  = Resposta::Nao;
        $object->mdfe_cunid_id        = MdfeCunid::KG;

        TTransaction::open(self::$database);

        $filial = SystemUnit::find(TSession::getValue('userunitid'));

        if($filial)
        {
            $object->mdfe_tpamb_id   = $filial->mdfe_tpamb_id;
            $object->UFIni           = $filial->mdfe_estadoini_id;
            //$object->mdfe_tpcarga_id = $filial->mdfe_tpcarga_id;
            $object->veiculo_id      = $filial->veiculo_id;

            $serie = MdfeSeries::where('mdfe_tpamb_id', '=', $object->mdfe_tpamb_id)
                                ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                ->first();
            if($serie){
                $numserie = $serie->serie;    
            }else{
                $numserie = null;
            }

            $object->serie = $numserie;
        }

        TTransaction::close();

        TForm::sendData(self::$formName, $object);

        // TSession::setValue('aba_items', false);
        //$this->fireEvents($object);

        // $object = new stdClass();
        // $object->serie = $numserie;

        // TForm::sendData(self::$formName, $object);

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->mdfe_tpamb_id))
            {
                $value = $object->mdfe_tpamb_id;

                $obj->mdfe_tpamb_id = $value;
            }
            if(isset($object->serie))
            {
                $value = $object->serie;

                $obj->serie = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->mdfe_tpamb_id))
            {
                $value = $object->mdfe_tpamb_id;

                $obj->mdfe_tpamb_id = $value;
            }
            if(isset($object->serie))
            {
                $value = $object->serie;

                $obj->serie = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

