<?php

class MdfeFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Mdfe';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Mdfe';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $mdfe = new Mdfe($param['key']);
        // define the form title
        $this->form->setFormTitle("MDFE - Visualizar");

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'MdfeSituacao', 'id', '{descricao}','ordem asc' );
        $label2 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($mdfe->id, '', '15px', '');
        $label240 = new TLabel("Série:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay($mdfe->serie, '', '15px', '');
        $label220 = new TLabel("Número:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay($mdfe->nMDF, '', '15px', '');
        $label3 = new TLabel("Tipo Ambiente:", '', '15px', 'B', '100%');
        $text71 = new TTextDisplay($mdfe->mdfe_tpamb->descricao, '', '15px', '');
        $label260 = new TLabel("Data e hora emissão:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(TDateTime::convertToMask($mdfe->dhEmi, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label320 = new TLabel("Data e hora previstos de início da viagem:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(TDateTime::convertToMask($mdfe->dhIniViagem, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label140 = new TLabel("Tipo Emitente:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay($mdfe->mdfe_tpemit->descricao, '', '15px', '');
        $label160 = new TLabel("Tipo de Proprietário", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay($mdfe->mdfe_tpprop->descricao, '', '15px', '');
        $label18 = new TLabel("Tipo de Transporte:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($mdfe->mdfe_tptransp->descricao, '', '15px', '');
        $label280 = new TLabel("UF do Carregamento:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay($mdfe->fk_UFIni->nome, '', '15px', '');
        $label300 = new TLabel("UF do Descarregamento:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay($mdfe->fk_UFFim->nome, '', '15px', '');
        $label90 = new TLabel("Indicador de participação do Canal Verde:", '', '15px', 'B');
        $text22 = new TTextDisplay($mdfe->fk_indCanalVerde->descricao, '', '15px', '');
        $label340 = new TLabel("Por evento de inclusão de DF-e:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay($mdfe->fk_indCarregaPosterior->descricao, '', '15px', '');
        $label70 = new TLabel("Transporte de alto desempenho:", '', '15px', 'B', '100%');
        $text41 = new TTextDisplay($mdfe->pgto_indAltoDesemp, '', '15px', '');
        $label54 = new TLabel("Tipo da Carga:", '', '15px', 'B', '100%');
        $text33 = new TTextDisplay($mdfe->mdfe_tpcarga->descricao, '', '15px', '');
        $label50 = new TLabel("Unidade de medida", '', '15px', 'B', '100%');
        $text31 = new TTextDisplay($mdfe->mdfe_cunid->descricao, '', '15px', '');
        $label52 = new TLabel("Peso Bruto Total:", '', '15px', 'B', '100%');
        $text32 = new TTextDisplay(number_format((double)$mdfe->qCarga, '2', ',', '.'), '', '15px', '');
        $label56 = new TLabel("Descrição do produto predominante:", '', '15px', 'B', '100%');
        $text34 = new TTextDisplay($mdfe->prod_xProd, '', '15px', '');
        $label58 = new TLabel("GTIN (código EAN ou código de barras)", '', '15px', 'B', '100%');
        $text35 = new TTextDisplay($mdfe->prod_cEAN, '', '15px', '');
        $label60 = new TLabel("Código NCM do Produto:", '', '15px', 'B', '100%');
        $text36 = new TTextDisplay($mdfe->prod_NCM, '', '15px', '');
        $label48 = new TLabel("Valor total da carga:", '', '15px', 'B', '100%');
        $text30 = new TTextDisplay(number_format((double)$mdfe->vCarga, '2', ',', '.'), '', '15px', '');
        $label360 = new TLabel("Informações adicionais de interesse do fisco:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay($mdfe->infAdFisco, '', '15px', '');
        $label380 = new TLabel("Informações adicionais de interesse do contribuinte:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay($mdfe->infCpl, '', '15px', '');
        $lbcriadoem = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $datetimetext6 = new TTextDisplay(TDateTime::convertToMask($mdfe->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbcriadopor = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $txtcriadopor = new TTextDisplay($mdfe->criado_por, '', '15px', '');
        $lbalteradoem = new TLabel("Alterado em:", '', '15px', 'B');
        $datetimetext8 = new TTextDisplay(TDateTime::convertToMask($mdfe->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbalteradopor = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $txtalteradopor = new TTextDisplay($mdfe->alterado_por, '', '15px', '');
        $label4 = new TLabel("Veículo:", '', '15px', 'B', '100%');
        $txtveiculo = new TTextDisplay($mdfe->veiculo->modelo_marca, '', '15px', '');
        $label6 = new TLabel("Placa:", '', '15px', 'B', '100%');
        $txtveicplaca = new TTextDisplay($mdfe->veic_placa, '', '12px', '');
        $lblveiestado = new TLabel("Estado:", '', '15px', 'B', '100%');
        $txtveicestado = new TTextDisplay($mdfe->veic_estado->nome, '', '15px', '');
        $label86 = new TLabel("RNTRC:", '', '15px', 'B', '100%');
        $text49 = new TTextDisplay($mdfe->veic_rntrc, '', '15px', '');
        $lbrenavam = new TLabel("Renavam:", '', '15px', 'B', '100%');
        $txtveicrenavam = new TTextDisplay($mdfe->veic_renavam, '', '15px', '');
        $lblveiccint = new TLabel("Código interno do veículo:", '', '15px', 'B', '100%');
        $txtveiccint = new TTextDisplay($mdfe->veic_cint, '', '15px', '');
        $label20 = new TLabel("Tipo de carroceria", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay($mdfe->mdfe_tpcar->descricao, '', '15px', '');
        $label88 = new TLabel("Tipo de rodado", '', '15px', 'B', '100%');
        $text50 = new TTextDisplay($mdfe->mdfe_tpRod->descricao, '', '15px', '');
        $lblveictara = new TLabel("Tara:", '', '15px', 'B', '100%');
        $txtveictara = new TTextDisplay($mdfe->veic_tara, '', '15px', '');
        $label400 = new TLabel("Responsável:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay($mdfe->mdfe_respSeg->descricao, '', '15px', '');
        $label42 = new TLabel("CPF/CNPJ do responsável pelo seguro:", '', '15px', 'B', '100%');
        $text27 = new TTextDisplay($mdfe->seguro_cpfcnpj, '', '15px', '');
        $label44 = new TLabel("Nome da Seguradora:", '', '15px', 'B', '100%');
        $text28 = new TTextDisplay($mdfe->seguradora_xSeg, '', '15px', '');
        $label46 = new TLabel("CNPJ da seguradora:", '', '15px', 'B', '100%');
        $text29 = new TTextDisplay($mdfe->seguradora_cnpj, '', '15px', '');
        $label62 = new TLabel("CPF/CNPJ:", '', '15px', 'B', '100%');
        $text37 = new TTextDisplay($mdfe->pgto_cpfcnpj, '', '15px', '');
        $label66 = new TLabel("Nome:", '', '15px', 'B', '100%');
        $text39 = new TTextDisplay($mdfe->pgto_xNome, '', '15px', '');
        $label68 = new TLabel("Valor total do contrato:", '', '15px', 'B', '100%');
        $text40 = new TTextDisplay(number_format((double)$mdfe->pgto_vContrato, '2', ',', '.'), '', '15px', '');
        $label64 = new TLabel("Identificação se estrangeiro:", '', '15px', 'B', '100%');
        $text38 = new TTextDisplay($mdfe->pgto_idEstrangeiro, '', '15px', '');
        $label72 = new TLabel("Indicador de Pagamento:", '', '15px', 'B', '100%');
        $text42 = new TTextDisplay($mdfe->mdfe_indpag_id, '', '15px', '');
        $label76 = new TLabel("Adiantamento:", '', '15px', 'B', '100%');
        $text44 = new TTextDisplay($mdfe->fk_indAntecipaAdiant->descricao, '', '15px', '');
        $label74 = new TLabel("Valor do Adiantamento:", '', '15px', 'B', '100%');
        $text43 = new TTextDisplay(number_format((double)$mdfe->pgto_vAdiant, '2', ',', '.'), '', '15px', '');
        $label78 = new TLabel("Número do banco:", '', '15px', 'B', '100%');
        $text45 = new TTextDisplay($mdfe->pgto_codBanco, '', '15px', '');
        $label80 = new TLabel("Número da Agência:", '', '15px', 'B', '100%');
        $text46 = new TTextDisplay($mdfe->pgto_codAgencia, '', '15px', '');
        $label82 = new TLabel("CNPJ da Instituição:", '', '15px', 'B', '100%');
        $text47 = new TTextDisplay($mdfe->pgto_CNPJIPEF, '', '15px', '');
        $label84 = new TLabel("Chave PIX:", '', '15px', 'B', '100%');
        $text48 = new TTextDisplay($mdfe->pgto_PIX, '', '15px', '');
        $lblstatussefaz = new TLabel("Status SEFAZ::", '', '15px', 'B', '100%');
        $txtstatussefaz = new TTextDisplay($mdfe->status, '', '15px', '');
        $label12 = new TLabel("Código SEFAZ:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($mdfe->cStat, '', '15px', '');
        $lblmensagemsefaz = new TLabel("Mensagem SEFAZ:", '', '15px', 'B', '100%');
        $txtmensagemsefaz = new TTextDisplay($mdfe->mensagem_sefaz, '', '15px', '');
        $label10 = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay($mdfe->nProt, '', '15px', '');
        $label8 = new TLabel("Chave:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($mdfe->chMDF, '', '15px', '');
        $lbdatahoraenvio = new TLabel("Date e hora envio:", '', '15px', 'B', '100%');
        $datetimetext3 = new TTextDisplay(TDateTime::convertToMask($mdfe->data_hora_envio, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbdataencerramento = new TLabel("Data Encerramento:", '', '15px', 'B', '100%');
        $datetext1 = new TTextDisplay(TDate::convertToMask($mdfe->data_encerramento, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbprotocoloencerramento = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $txtprotocoloencerramento = new TTextDisplay($mdfe->protocolo_encerramento, '', '15px', '');
        $lbmunencerramento = new TLabel("Cidade Encerramento:", '', '15px', 'B', '100%');
        $txtmunencerramento = new TTextDisplay($mdfe->cidade_encerramento->nome, '', '15px', '');
        $lblprotocolocancelamento = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $txtprotocolocancelamento = new TTextDisplay($mdfe->protocolo_cancelamento, '', '15px', '');
        $lbldatahoracancelamento = new TLabel("Data e hora:", '', '15px', 'B', '100%');
        $datetimetext5 = new TTextDisplay(TDateTime::convertToMask($mdfe->datahora_cancelamento, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label16 = new TLabel("Justificativa de cancelamento:", '', '15px', 'B', '100%');
        $txtjustificativacancelamento = new TTextDisplay($mdfe->justificativa_cancelamento, '', '15px', '');

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($mdfe->mdfe_situacao_id);

        $this->form->appendPage("Geral");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$label2,$text1],[$label240,$text17],[$label220,$text16]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([$label3,$text71],[$label260,$text18],[$label320,$text21]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([$label140,$text12],[$label160,$text13],[$label18,$text14]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$label280,$text19],[$label300,$text20],[]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addFields([$label90,$text22],[$label340,$text23],[$label70,$text41]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->form->addContent([new TFormSeparator("Carga/Mercadoria", '#333', '18', '#eee')]);
        $row8 = $this->form->addFields([$label54,$text33],[$label50,$text31],[$label52,$text32]);
        $row8->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row9 = $this->form->addFields([$label56,$text34],[$label58,$text35],[$label60,$text36]);
        $row9->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row10 = $this->form->addFields([$label48,$text30]);
        $row10->layout = [' col-sm-4'];

        $row11 = $this->form->addFields([$label360,$text24],[$label380,$text25]);
        $row11->layout = [' col-sm-6',' col-sm-6'];

        $row12 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row13 = $this->form->addFields([$lbcriadoem,$datetimetext6],[$lbcriadopor,$txtcriadopor],[$lbalteradoem,$datetimetext8],[$lbalteradopor,$txtalteradopor]);
        $row13->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Veículos e Condutores");
        $row14 = $this->form->addFields([$label4,$txtveiculo],[$label6,$txtveicplaca],[$lblveiestado,$txtveicestado]);
        $row14->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row15 = $this->form->addFields([$label86,$text49],[$lbrenavam,$txtveicrenavam],[$lblveiccint,$txtveiccint]);
        $row15->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row16 = $this->form->addFields([$label20,$text15],[$label88,$text50],[$lblveictara,$txtveictara]);
        $row16->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row17 = $this->form->addContent([new TFormSeparator("Condutores", '#333', '18', '#eee')]);

        $this->mdfe_condutor_mdfe_id_list = new TQuickGrid;
        $this->mdfe_condutor_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_condutor_mdfe_id_list->style = 'width:100%';
        $this->mdfe_condutor_mdfe_id_list->disableDefaultClick();

        $column_xnome = $this->mdfe_condutor_mdfe_id_list->addQuickColumn("Nome do Condutor ", 'xnome', 'left');
        $column_cpf = $this->mdfe_condutor_mdfe_id_list->addQuickColumn("CPF", 'cpf', 'left');

        $this->mdfe_condutor_mdfe_id_list->createModel();

        $criteria_mdfe_condutor_mdfe_id = new TCriteria();
        $criteria_mdfe_condutor_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_condutor_mdfe_id->setProperty('order', 'id desc');

        $mdfe_condutor_mdfe_id_items = MdfeCondutor::getObjects($criteria_mdfe_condutor_mdfe_id);

        $this->mdfe_condutor_mdfe_id_list->addItems($mdfe_condutor_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_condutor_mdfe_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Carregamento");

        $this->mdfe_infmuncarrega_mdfe_id_list = new TQuickGrid;
        $this->mdfe_infmuncarrega_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_infmuncarrega_mdfe_id_list->style = 'width:100%';
        $this->mdfe_infmuncarrega_mdfe_id_list->disableDefaultClick();

        $column_cMunCarrega = $this->mdfe_infmuncarrega_mdfe_id_list->addQuickColumn("Código do Município", 'cMunCarrega', 'left');
        $column_cidade_nome = $this->mdfe_infmuncarrega_mdfe_id_list->addQuickColumn("Cidade", 'cidade->nome', 'left');
        $column_cidade_estado_sigla = $this->mdfe_infmuncarrega_mdfe_id_list->addQuickColumn("UF", 'cidade->estado->sigla', 'left');

        $this->mdfe_infmuncarrega_mdfe_id_list->createModel();

        $criteria_mdfe_infmuncarrega_mdfe_id = new TCriteria();
        $criteria_mdfe_infmuncarrega_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_infmuncarrega_mdfe_id->setProperty('order', 'id desc');

        $mdfe_infmuncarrega_mdfe_id_items = MdfeInfmuncarrega::getObjects($criteria_mdfe_infmuncarrega_mdfe_id);

        $this->mdfe_infmuncarrega_mdfe_id_list->addItems($mdfe_infmuncarrega_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_infmuncarrega_mdfe_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Percurso");

        $this->mdfe_infpercurso_mdfe_id_list = new TQuickGrid;
        $this->mdfe_infpercurso_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_infpercurso_mdfe_id_list->style = 'width:100%';
        $this->mdfe_infpercurso_mdfe_id_list->disableDefaultClick();

        $column_fk_UFPer_nome = $this->mdfe_infpercurso_mdfe_id_list->addQuickColumn("UF Percurso", 'fk_UFPer->nome', 'left');

        $this->mdfe_infpercurso_mdfe_id_list->createModel();

        $criteria_mdfe_infpercurso_mdfe_id = new TCriteria();
        $criteria_mdfe_infpercurso_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_infpercurso_mdfe_id->setProperty('order', 'id desc');

        $mdfe_infpercurso_mdfe_id_items = MdfeInfpercurso::getObjects($criteria_mdfe_infpercurso_mdfe_id);

        $this->mdfe_infpercurso_mdfe_id_list->addItems($mdfe_infpercurso_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_infpercurso_mdfe_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Descarga");

        $this->mdfe_infmundescarga_mdfe_id_list = new TQuickGrid;
        $this->mdfe_infmundescarga_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_infmundescarga_mdfe_id_list->style = 'width:100%';
        $this->mdfe_infmundescarga_mdfe_id_list->disableDefaultClick();

        $action_onShow = new TDataGridAction(array('MdfeNfesSimpleList', 'onShow'));
        $action_onShow->setUseButton(true);
        $action_onShow->setButtonClass('btn btn-default btn-sm');
        $action_onShow->setLabel("Ver NF-e(s)");
        $action_onShow->setImage('fas:file #000000');
        $action_onShow->setField('id');

        $action_onShow->setParameter('key', '{id}');
        $this->mdfe_infmundescarga_mdfe_id_list->addAction($action_onShow);

        $action_MdfeCtesSimpleList_onShow = new TDataGridAction(array('MdfeCtesSimpleList', 'onShow'));
        $action_MdfeCtesSimpleList_onShow->setUseButton(true);
        $action_MdfeCtesSimpleList_onShow->setButtonClass('btn btn-default btn-sm');
        $action_MdfeCtesSimpleList_onShow->setLabel("Ver CT-e(s)");
        $action_MdfeCtesSimpleList_onShow->setImage('fas:file-alt #000000');
        $action_MdfeCtesSimpleList_onShow->setField('id');

        $action_MdfeCtesSimpleList_onShow->setParameter('key', '{id}');
        $this->mdfe_infmundescarga_mdfe_id_list->addAction($action_MdfeCtesSimpleList_onShow);

        $action_MdfeMdfesSimpleList_onShow = new TDataGridAction(array('MdfeMdfesSimpleList', 'onShow'));
        $action_MdfeMdfesSimpleList_onShow->setUseButton(true);
        $action_MdfeMdfesSimpleList_onShow->setButtonClass('btn btn-default btn-sm');
        $action_MdfeMdfesSimpleList_onShow->setLabel("Ver MDF-e(s)");
        $action_MdfeMdfesSimpleList_onShow->setImage('fas:file-archive #000000');
        $action_MdfeMdfesSimpleList_onShow->setField('id');

        $action_MdfeMdfesSimpleList_onShow->setParameter('key', '{id}');
        $this->mdfe_infmundescarga_mdfe_id_list->addAction($action_MdfeMdfesSimpleList_onShow);

        $column_cMunDescarga = $this->mdfe_infmundescarga_mdfe_id_list->addQuickColumn("Código do Município", 'cMunDescarga', 'left' , '30%');
        $column_cidade_nome1 = $this->mdfe_infmundescarga_mdfe_id_list->addQuickColumn("Cidade", 'cidade->nome', 'left' , '50%');
        $column_cidade_estado_sigla1 = $this->mdfe_infmundescarga_mdfe_id_list->addQuickColumn("UF", 'cidade->estado->sigla', 'left' , '20%');

        $this->mdfe_infmundescarga_mdfe_id_list->createModel();

        $criteria_mdfe_infmundescarga_mdfe_id = new TCriteria();
        $criteria_mdfe_infmundescarga_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_infmundescarga_mdfe_id->setProperty('order', 'id desc');

        $mdfe_infmundescarga_mdfe_id_items = MdfeInfmundescarga::getObjects($criteria_mdfe_infmundescarga_mdfe_id);

        $this->mdfe_infmundescarga_mdfe_id_list->addItems($mdfe_infmundescarga_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_infmundescarga_mdfe_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Lacres");

        $this->mdfe_lacres_mdfe_id_list = new TQuickGrid;
        $this->mdfe_lacres_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_lacres_mdfe_id_list->style = 'width:100%';
        $this->mdfe_lacres_mdfe_id_list->disableDefaultClick();

        $column_nLacre = $this->mdfe_lacres_mdfe_id_list->addQuickColumn("Número do lacre", 'nLacre', 'left');

        $this->mdfe_lacres_mdfe_id_list->createModel();

        $criteria_mdfe_lacres_mdfe_id = new TCriteria();
        $criteria_mdfe_lacres_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_lacres_mdfe_id->setProperty('order', 'id desc');

        $mdfe_lacres_mdfe_id_items = MdfeLacres::getObjects($criteria_mdfe_lacres_mdfe_id);

        $this->mdfe_lacres_mdfe_id_list->addItems($mdfe_lacres_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_lacres_mdfe_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Seguro");
        $row18 = $this->form->addFields([$label400,$text26],[$label42,$text27]);
        $row18->layout = [' col-sm-6','col-sm-6'];

        $row19 = $this->form->addFields([$label44,$text28],[$label46,$text29]);
        $row19->layout = [' col-sm-6',' col-sm-6'];

        $this->form->appendPage("Autorizados");

        $this->mdfe_xmlaut_mdfe_id_list = new TQuickGrid;
        $this->mdfe_xmlaut_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_xmlaut_mdfe_id_list->style = 'width:100%';
        $this->mdfe_xmlaut_mdfe_id_list->disableDefaultClick();

        $column_cpfcnpj = $this->mdfe_xmlaut_mdfe_id_list->addQuickColumn("CPF/CNPJ Autorizado", 'cpfcnpj', 'left');

        $this->mdfe_xmlaut_mdfe_id_list->createModel();

        $criteria_mdfe_xmlaut_mdfe_id = new TCriteria();
        $criteria_mdfe_xmlaut_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_xmlaut_mdfe_id->setProperty('order', 'id desc');

        $mdfe_xmlaut_mdfe_id_items = MdfeXmlaut::getObjects($criteria_mdfe_xmlaut_mdfe_id);

        $this->mdfe_xmlaut_mdfe_id_list->addItems($mdfe_xmlaut_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_xmlaut_mdfe_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Pagamentos");
        $row20 = $this->form->addContent([new TFormSeparator("Pagamento", '#333', '18', '#eee')]);
        $row21 = $this->form->addFields([$label62,$text37],[$label66,$text39],[$label68,$text40],[$label64,$text38]);
        $row21->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row22 = $this->form->addFields([$label72,$text42],[$label76,$text44],[$label74,$text43],[]);
        $row22->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row23 = $this->form->addFields([$label78,$text45],[$label80,$text46],[$label82,$text47],[$label84,$text48]);
        $row23->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row24 = $this->form->addContent([new TFormSeparator("Parcelas", '#333', '18', '#eee')]);

        $this->mdfe_parcelas_mdfe_id_list = new TQuickGrid;
        $this->mdfe_parcelas_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_parcelas_mdfe_id_list->style = 'width:100%';
        $this->mdfe_parcelas_mdfe_id_list->disableDefaultClick();

        $column_nParcela = $this->mdfe_parcelas_mdfe_id_list->addQuickColumn("Número da parcela", 'nParcela', 'left');
        $column_dVenc = $this->mdfe_parcelas_mdfe_id_list->addQuickColumn("Data de vencimento da Parcela", 'dVenc', 'left');
        $column_vParcela_transformed = $this->mdfe_parcelas_mdfe_id_list->addQuickColumn("Valor da parcela", 'vParcela', 'left');
        $column_mdfe_tpAntecip_descricao = $this->mdfe_parcelas_mdfe_id_list->addQuickColumn("Tipo Antecipação", 'mdfe_tpAntecip->descricao', 'left');

        $column_vParcela_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->mdfe_parcelas_mdfe_id_list->createModel();

        $criteria_mdfe_parcelas_mdfe_id = new TCriteria();
        $criteria_mdfe_parcelas_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_parcelas_mdfe_id->setProperty('order', 'id desc');

        $mdfe_parcelas_mdfe_id_items = MdfeParcelas::getObjects($criteria_mdfe_parcelas_mdfe_id);

        $this->mdfe_parcelas_mdfe_id_list->addItems($mdfe_parcelas_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_parcelas_mdfe_id_list));

        $this->form->addContent([$panel]);
        $row25 = $this->form->addContent([new TFormSeparator("Componentes", '#333', '18', '#eee')]);

        $this->mdfe_componentes_mdfe_id_list = new TQuickGrid;
        $this->mdfe_componentes_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_componentes_mdfe_id_list->style = 'width:100%';
        $this->mdfe_componentes_mdfe_id_list->disableDefaultClick();

        $column_mdfe_tpcomp_descricao = $this->mdfe_componentes_mdfe_id_list->addQuickColumn("Tipo do Componente", 'mdfe_tpcomp->descricao', 'left');
        $column_xComp = $this->mdfe_componentes_mdfe_id_list->addQuickColumn("Descrição", 'xComp', 'left');
        $column_vComp_transformed = $this->mdfe_componentes_mdfe_id_list->addQuickColumn("Valor do Componente", 'vComp', 'left');

        $column_vComp_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->mdfe_componentes_mdfe_id_list->createModel();

        $criteria_mdfe_componentes_mdfe_id = new TCriteria();
        $criteria_mdfe_componentes_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_componentes_mdfe_id->setProperty('order', 'id desc');

        $mdfe_componentes_mdfe_id_items = MdfeComponentes::getObjects($criteria_mdfe_componentes_mdfe_id);

        $this->mdfe_componentes_mdfe_id_list->addItems($mdfe_componentes_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_componentes_mdfe_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Eventos SEFAZ");
        $row26 = $this->form->addFields([$lblstatussefaz,$txtstatussefaz],[$label12,$text11],[$lblmensagemsefaz,$txtmensagemsefaz]);
        $row26->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row27 = $this->form->addContent([new TFormSeparator("Envio", '#333', '18', '#eee')]);
        $row28 = $this->form->addFields([$label10,$text10],[$label8,$text9],[$lbdatahoraenvio,$datetimetext3]);
        $row28->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row29 = $this->form->addContent([new TFormSeparator("Encerramento", '#333', '18', '#eee')]);
        $row30 = $this->form->addFields([$lbdataencerramento,$datetext1],[$lbprotocoloencerramento,$txtprotocoloencerramento],[$lbmunencerramento,$txtmunencerramento]);
        $row30->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row31 = $this->form->addContent([new TFormSeparator("Cancelamento", '#333', '18', '#eee')]);
        $row32 = $this->form->addFields([$lblprotocolocancelamento,$txtprotocolocancelamento],[$lbldatahoracancelamento,$datetimetext5],[$label16,$txtjustificativacancelamento]);
        $row32->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $this->form->appendPage("Logs");

        $this->mdfe_logs_mdfe_id_list = new TQuickGrid;
        $this->mdfe_logs_mdfe_id_list->disableHtmlConversion();
        $this->mdfe_logs_mdfe_id_list->style = 'width:100%';
        $this->mdfe_logs_mdfe_id_list->disableDefaultClick();

        $column_criado_em_transformed = $this->mdfe_logs_mdfe_id_list->addQuickColumn("Data/Hora", 'criado_em', 'left');
        $column_system_users_name = $this->mdfe_logs_mdfe_id_list->addQuickColumn("Usuário", 'system_users->name', 'left');
        $column_descricao = $this->mdfe_logs_mdfe_id_list->addQuickColumn("Descrição", 'descricao', 'left');

        $column_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->mdfe_logs_mdfe_id_list->createModel();

        $criteria_mdfe_logs_mdfe_id = new TCriteria();
        $criteria_mdfe_logs_mdfe_id->add(new TFilter('mdfe_id', '=', $mdfe->id));

        $criteria_mdfe_logs_mdfe_id->setProperty('order', 'id desc');

        $mdfe_logs_mdfe_id_items = MdfeLogs::getObjects($criteria_mdfe_logs_mdfe_id);

        $this->mdfe_logs_mdfe_id_list->addItems($mdfe_logs_mdfe_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->mdfe_logs_mdfe_id_list));

        $this->form->addContent([$panel]);

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        $btnMdfeFormOnEditAction = new TAction(['MdfeForm', 'onEdit'],['key'=>$mdfe->id]);
        $btnMdfeFormOnEditLabel = new TLabel("Editar");

        $btnMdfeFormOnEdit = $this->form->addHeaderAction($btnMdfeFormOnEditLabel, $btnMdfeFormOnEditAction, 'fas:edit #03A9F4'); 
        $btnMdfeFormOnEditLabel->setFontSize('12px'); 
        $btnMdfeFormOnEditLabel->setFontColor('#333'); 

        $btn_onenviarAction = new TAction([$this, 'onEnviar'],['key'=>$mdfe->id]);
        $btn_onenviarLabel = new TLabel("Enviar");

        $btn_onenviar = $this->form->addHeaderAction($btn_onenviarLabel, $btn_onenviarAction, 'fas:cloud-upload-alt #4CAF50'); 
        $btn_onenviarLabel->setFontSize('12px'); 
        $btn_onenviarLabel->setFontColor('#333'); 

        $btn_onpdfAction = new TAction([$this, 'onPDF'],['key'=>$mdfe->id]);
        $btn_onpdfLabel = new TLabel("PDF");

        $btn_onpdf = $this->form->addHeaderAction($btn_onpdfLabel, $btn_onpdfAction, 'far:file-pdf #F44336'); 
        $btn_onpdfLabel->setFontSize('12px'); 
        $btn_onpdfLabel->setFontColor('#333'); 

        $btn_onxmlAction = new TAction([$this, 'onXML'],['key'=>$mdfe->id]);
        $btn_onxmlLabel = new TLabel("XML");

        $btn_onxml = $this->form->addHeaderAction($btn_onxmlLabel, $btn_onxmlAction, 'far:file-code #FF9800'); 
        $btn_onxmlLabel->setFontSize('12px'); 
        $btn_onxmlLabel->setFontColor('#333'); 

        $btn_onencerrarAction = new TAction([$this, 'onEncerrar'],['key'=>$mdfe->id]);
        $btn_onencerrarLabel = new TLabel("Encerrar");

        $btn_onencerrar = $this->form->addHeaderAction($btn_onencerrarLabel, $btn_onencerrarAction, 'fas:flag-checkered #9C27B0'); 
        $btn_onencerrarLabel->setFontSize('12px'); 
        $btn_onencerrarLabel->setFontColor('#333'); 

        $btn_oncancelarAction = new TAction([$this, 'onCancelar'],['key'=>$mdfe->id]);
        $btn_oncancelarLabel = new TLabel("Cancelar");

        $btn_oncancelar = $this->form->addHeaderAction($btn_oncancelarLabel, $btn_oncancelarAction, 'fas:ban #E91E63'); 
        $btn_oncancelarLabel->setFontSize('12px'); 
        $btn_oncancelarLabel->setFontColor('#333'); 

        $btn_onconsultarAction = new TAction([$this, 'onConsultar'],['key'=>$mdfe->id]);
        $btn_onconsultarLabel = new TLabel("Consultar na SEFAZ");

        $btn_onconsultar = $this->form->addHeaderAction($btn_onconsultarLabel, $btn_onconsultarAction, 'fas:search #4CAF50'); 
        $btn_onconsultarLabel->setFontSize('12px'); 
        $btn_onconsultarLabel->setFontColor('#333'); 

        $btnMdfeListOnShowAction = new TAction(['MdfeList', 'onShow']);
        $btnMdfeListOnShowLabel = new TLabel("Voltar");

        $btnMdfeListOnShow = $this->form->addHeaderAction($btnMdfeListOnShowLabel, $btnMdfeListOnShowAction, 'fas:arrow-alt-circle-left #000000'); 
        $btnMdfeListOnShowLabel->setFontSize('12px'); 
        $btnMdfeListOnShowLabel->setFontColor('#333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","MDFE - Visualizar"]));
        }
        $container->add($this->form);

        if(is_null($mdfe->chMDF))
        {
           TScript::create('document.getElementById("tbutton_consultar").style.display = "none";');
        }

        if ($mdfe->cStat == 100)
        {
            TScript::create('document.getElementById("tbutton_enviar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
        }

        if($mdfe->mdfe_situacao_id == MdfeSituacao::Cancelado)
        {
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_encerrar").style.display = "none";');
        }  

        if($mdfe->mdfe_situacao_id == MdfeSituacao::EmDigitacao)
        {
            TScript::create('document.getElementById("tbutton_encerrar").style.display = "none";');
        }

        TTransaction::close();
        parent::add($container);

    }

    public function onEnviar($param = null) 
    {
        try 
        {
            new TQuestion("Enviar MDF-e?", new TAction([__CLASS__, 'onEnviarYes'], $param), new TAction([__CLASS__, 'onEnviarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onPDF($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $mdfe = Mdfe::find($param['key']);

            if($mdfe)
            {
                 $arquivo = API_MDFe::PDF($mdfe); 

                 if(file_exists($arquivo))
                 {
                    parent::openFile($arquivo);            
                 }
                 else
                 {
                     throw new Exception('PDF não encontrado!');
                 }

            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onXML($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $mdfe = Mdfe::find($param['key']);

            if($mdfe)
            {
                 $arquivo = API_MDFe::XML($mdfe); 

                 if(file_exists($arquivo)){
                        parent::openFile($arquivo);            
                 }else{
                     throw new Exception('Arquivo XML não encontrado!');
                 }
            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onEncerrar($param = null) 
    {
        try 
        {
            $pageParam = ['id' => $param['key']]; // ex.: = ['key' => 10]
            TApplication::loadPage('MDFeEncerrarForm', 'onShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onCancelar($param = null) 
    {
        try 
        {
            $pageParam = ['id' => $param['key']]; // ex.: = ['key' => 10]
            TApplication::loadPage('MDFeCancelamentoForm', 'onShow', $pageParam);

            // TSession::setValue('mdfe_id', $param['id']);
            // TApplication::loadPage('CancelamentoMDFEForm', 'onShow');

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onConsultar($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $mdfe = Mdfe::find($param['key']);

            $retorno = API_MDFe::Consulta($mdfe);

            $pageParam = ['titulo' => 'Retorno da SEFAZ'];

            TSession::setValue('mens_personalizada', 'Retorno da SEFAZ: '."\n".API_MDFe::formataRetorno($retorno));
            TApplication::loadPage('MensagemPersonalizada', 'OnShow', $pageParam);                     

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onEnviarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $mdfe = Mdfe::find($param['key']);

            if($mdfe)
            {
                $retorno =  API_MDFe::Enviar($mdfe); 

                 if ($retorno->codigo != 100)     
                 {
                    //  $pageParam = ['mensagem' => 'Retorno da SEFAZ: '."\n".API_MDFe::formataRetorno($retorno)]; 

                    $pageParam = ['titulo' => 'Retorno da SEFAZ'];

                     TSession::setValue('mens_personalizada', 'Retorno da SEFAZ: '."\n".API_MDFe::formataRetorno($retorno));
                     TApplication::loadPage('MensagemPersonalizada', 'OnShow', $pageParam);

                    // new TMessage('warning', 'Retorno da SEFAZ: '."\n".API_MDFe::formataRetorno($retorno));                     
                 }
                 else
                 {
                     TApplication::loadPage(__CLASS__, 'onShow', ['key' => $mdfe->id]);

                     TToast::show('success', "Documento enviado com sucesso!", 'topRight', 'far:check-circle');
                 }
            }            

            TTransaction::close();
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEnviarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

