<?php

class MdfeInclusaoDfeForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'MdfeInclusaoDfe';
    private static $primaryKey = 'id';
    private static $formName = 'form_MdfeInclusaoDfeForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("MDFE - Inclusão DFE");


        $id = new THidden('id');
        $mdfe_id = new THidden('mdfe_id');
        $notafiscal_id = new TDBCombo('notafiscal_id', 'kraftsoft', 'Notafiscal', 'id', '{id}','id asc'  );
        $chave = new TEntry('chave');
        $protocolo = new TEntry('protocolo');
        $cidade_carrega_id = new TDBCombo('cidade_carrega_id', 'kraftsoft', 'Cidade', 'id', '{nome}','nome asc'  );
        $cidade_descarga_id = new TDBCombo('cidade_descarga_id', 'kraftsoft', 'Cidade', 'id', '{nome}','nome asc'  );

        $notafiscal_id->addValidation("Nota", new TRequiredValidator()); 
        $chave->addValidation("Chave", new TRequiredValidator()); 
        $protocolo->addValidation("Protocolo", new TRequiredValidator()); 
        $cidade_carrega_id->addValidation("Cidade carrega id", new TRequiredValidator()); 
        $cidade_descarga_id->addValidation("Cidade descarga id", new TRequiredValidator()); 

        $notafiscal_id->enableSearch();
        $cidade_carrega_id->enableSearch();
        $cidade_descarga_id->enableSearch();

        $id->setSize(200);
        $mdfe_id->setSize(200);
        $chave->setSize('100%');
        $protocolo->setSize('100%');
        $notafiscal_id->setSize('100%');
        $cidade_carrega_id->setSize('100%');
        $cidade_descarga_id->setSize('100%');

        $row1 = $this->form->addFields([$id,$mdfe_id]);
        $row1->layout = ['col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Nota:", null, '14px', null, '100%'),$notafiscal_id],[new TLabel("Chave:", '#FF0000', '14px', null, '100%'),$chave],[new TLabel("Protocolo:", '#FF0000', '14px', null, '100%'),$protocolo]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Cidade Carrega:", '#ff0000', '14px', null, '100%'),$cidade_carrega_id],[new TLabel("Cidade Descarga:", '#ff0000', '14px', null, '100%'),$cidade_descarga_id]);
        $row3->layout = [' col-sm-6',' col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=MdfeInclusaoDfeForm]');
        $style->width = '50% !important';   
        $style->show(true);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new MdfeInclusaoDfe(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->store(); // save the object 

            NuvemFiscalMDFe::IncluirDfe($object->id);

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

                        TScript::create("Template.closeRightPanel();"); 
        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new MdfeInclusaoDfe($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->mdfe_id = $param['mdfe_id'];

        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

