<?php

class MdfeInfmundescargaForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'MdfeInfmundescarga';
    private static $primaryKey = 'id';
    private static $formName = 'form_MdfeInfmundescargaForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("NF-e Descarga");

        $criteria_mdfe_nfes_mdfe_infmundescarga_notafiscal_id = new TCriteria();

        $filterVar = NotafiscalSituacao::Autorizada;
        $criteria_mdfe_nfes_mdfe_infmundescarga_notafiscal_id->add(new TFilter('notafiscal_situacao_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_mdfe_nfes_mdfe_infmundescarga_notafiscal_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $mdfe_nfes_mdfe_infmundescarga_notafiscal_id = new TDBCombo('mdfe_nfes_mdfe_infmundescarga_notafiscal_id', 'kraftsoft', 'Notafiscal', 'id', 'Nº {numero}  - Data Emissão: {data_emissao}  - Cliente: {cliente_nome}','id asc' , $criteria_mdfe_nfes_mdfe_infmundescarga_notafiscal_id );
        $mdfe_nfes_mdfe_infmundescarga_chNFe = new TEntry('mdfe_nfes_mdfe_infmundescarga_chNFe');
        $mdfe_nfes_mdfe_infmundescarga_id = new THidden('mdfe_nfes_mdfe_infmundescarga_id');
        $mdfe_nfes_mdfe_infmundescarga_indReentrega = new TDBCombo('mdfe_nfes_mdfe_infmundescarga_indReentrega', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $mdfe_nfes_mdfe_infmundescarga_SegCodBarra = new TEntry('mdfe_nfes_mdfe_infmundescarga_SegCodBarra');
        $button_adicionar_mdfe_nfes_mdfe_infmundescarga = new TButton('button_adicionar_mdfe_nfes_mdfe_infmundescarga');
        $id = new THidden('id');

        $mdfe_nfes_mdfe_infmundescarga_notafiscal_id->setChangeAction(new TAction([$this,'onExitNotaSistema']));

        $mdfe_nfes_mdfe_infmundescarga_indReentrega->setValue(Resposta::Nao);
        $button_adicionar_mdfe_nfes_mdfe_infmundescarga->setAction(new TAction([$this, 'onAddDetailMdfeNfesMdfeInfmundescarga'],['static' => 1]), "Adicionar");
        $button_adicionar_mdfe_nfes_mdfe_infmundescarga->addStyleClass('btn-default');
        $button_adicionar_mdfe_nfes_mdfe_infmundescarga->setImage('fas:plus #2ecc71');
        $mdfe_nfes_mdfe_infmundescarga_indReentrega->enableSearch();
        $mdfe_nfes_mdfe_infmundescarga_notafiscal_id->enableSearch();

        $id->setSize(200);
        $mdfe_nfes_mdfe_infmundescarga_id->setSize(200);
        $mdfe_nfes_mdfe_infmundescarga_chNFe->setSize('100%');
        $mdfe_nfes_mdfe_infmundescarga_SegCodBarra->setSize('100%');
        $mdfe_nfes_mdfe_infmundescarga_indReentrega->setSize('100%');
        $mdfe_nfes_mdfe_infmundescarga_notafiscal_id->setSize('100%');

        $button_adicionar_mdfe_nfes_mdfe_infmundescarga->id = '62e6748fe19f6';

        $this->detailFormMdfeNfesMdfeInfmundescarga = new BootstrapFormBuilder('detailFormMdfeNfesMdfeInfmundescarga');
        $this->detailFormMdfeNfesMdfeInfmundescarga->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormMdfeNfesMdfeInfmundescarga->setProperty('class', 'form-horizontal builder-detail-form');

        $row1 = $this->detailFormMdfeNfesMdfeInfmundescarga->addFields([new TLabel("NF-e emitida pelo sistema:", null, '14px', null, '100%'),$mdfe_nfes_mdfe_infmundescarga_notafiscal_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->detailFormMdfeNfesMdfeInfmundescarga->addFields([new TLabel("Chave da Nota Fiscal Eletrônica:", null, '14px', null, '100%'),$mdfe_nfes_mdfe_infmundescarga_chNFe,$mdfe_nfes_mdfe_infmundescarga_id]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->detailFormMdfeNfesMdfeInfmundescarga->addFields([new TLabel("Indicador de Reentrega:", '#ff0000', '14px', null, '100%'),$mdfe_nfes_mdfe_infmundescarga_indReentrega],[new TLabel("Segundo código de barras:", null, '14px', null, '100%'),$mdfe_nfes_mdfe_infmundescarga_SegCodBarra]);
        $row3->layout = ['col-sm-6',' col-sm-6'];

        $row4 = $this->detailFormMdfeNfesMdfeInfmundescarga->addFields([$button_adicionar_mdfe_nfes_mdfe_infmundescarga]);
        $row4->layout = [' col-sm-12'];

        $row5 = $this->detailFormMdfeNfesMdfeInfmundescarga->addFields([new THidden('mdfe_nfes_mdfe_infmundescarga__row__id')]);
        $this->mdfe_nfes_mdfe_infmundescarga_criteria = new TCriteria();

        $this->mdfe_nfes_mdfe_infmundescarga_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->mdfe_nfes_mdfe_infmundescarga_list->disableHtmlConversion();;
        $this->mdfe_nfes_mdfe_infmundescarga_list->generateHiddenFields();
        $this->mdfe_nfes_mdfe_infmundescarga_list->setId('mdfe_nfes_mdfe_infmundescarga_list');

        $this->mdfe_nfes_mdfe_infmundescarga_list->style = 'width:100%';
        $this->mdfe_nfes_mdfe_infmundescarga_list->class .= ' table-bordered';

        $column_mdfe_nfes_mdfe_infmundescarga_chNFe = new TDataGridColumn('chNFe', "Chave", 'left');
        $column_mdfe_nfes_mdfe_infmundescarga_SegCodBarra = new TDataGridColumn('SegCodBarra', "Segundo código de barras", 'left');
        $column_mdfe_nfes_mdfe_infmundescarga_fk_indReentrega_descricao = new TDataGridColumn('fk_indReentrega->descricao', "Indicador de Reentrega", 'left');

        $column_mdfe_nfes_mdfe_infmundescarga__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_mdfe_nfes_mdfe_infmundescarga__row__data->setVisibility(false);

        $action_onEditDetailMdfeNfes = new TDataGridAction(array('MdfeInfmundescargaForm', 'onEditDetailMdfeNfes'));
        $action_onEditDetailMdfeNfes->setUseButton(true);
        $action_onEditDetailMdfeNfes->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailMdfeNfes->setLabel("Editar");
        $action_onEditDetailMdfeNfes->setImage('far:edit #478fca');
        $action_onEditDetailMdfeNfes->setFields(['__row__id', '__row__data']);

        $this->mdfe_nfes_mdfe_infmundescarga_list->addAction($action_onEditDetailMdfeNfes);
        $action_onDeleteDetailMdfeNfes = new TDataGridAction(array('MdfeInfmundescargaForm', 'onDeleteDetailMdfeNfes'));
        $action_onDeleteDetailMdfeNfes->setUseButton(true);
        $action_onDeleteDetailMdfeNfes->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailMdfeNfes->setLabel("Excluir");
        $action_onDeleteDetailMdfeNfes->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailMdfeNfes->setFields(['__row__id', '__row__data']);

        $this->mdfe_nfes_mdfe_infmundescarga_list->addAction($action_onDeleteDetailMdfeNfes);

        $this->mdfe_nfes_mdfe_infmundescarga_list->addColumn($column_mdfe_nfes_mdfe_infmundescarga_chNFe);
        $this->mdfe_nfes_mdfe_infmundescarga_list->addColumn($column_mdfe_nfes_mdfe_infmundescarga_SegCodBarra);
        $this->mdfe_nfes_mdfe_infmundescarga_list->addColumn($column_mdfe_nfes_mdfe_infmundescarga_fk_indReentrega_descricao);

        $this->mdfe_nfes_mdfe_infmundescarga_list->addColumn($column_mdfe_nfes_mdfe_infmundescarga__row__data);

        $this->mdfe_nfes_mdfe_infmundescarga_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->mdfe_nfes_mdfe_infmundescarga_list);
        $this->detailFormMdfeNfesMdfeInfmundescarga->addContent([$tableResponsiveDiv]);
        $row6 = $this->form->addFields([$this->detailFormMdfeNfesMdfeInfmundescarga]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->form->addFields([$id]);
        $row7->layout = ['col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=MdfeInfmundescargaForm]');
        $style->width = '70% !important';   
        $style->show(true);

    }

    public static function onExitNotaSistema($param = null) 
    {
        try 
        {
            if (isset($param['mdfe_nfes_mdfe_infmundescarga_notafiscal_id']) && $param['mdfe_nfes_mdfe_infmundescarga_notafiscal_id']
                &&isset($param['mdfe_nfes_mdfe_infmundescarga_notafiscal_id']) && $param['mdfe_nfes_mdfe_infmundescarga_notafiscal_id'])
            {
                TTransaction::open(self::$database);
                $notafiscal = Notafiscal::find($param['mdfe_nfes_mdfe_infmundescarga_notafiscal_id']);

                $object = new stdClass();

                if ($notafiscal)
                {
                    $object->mdfe_nfes_mdfe_infmundescarga_chNFe = $notafiscal->chave;
                }
                else
                {
                  $object->mdfe_nfes_mdfe_infmundescarga_chNFe = '';  
                }

                TTransaction::close();

                TForm::sendData(self::$formName, $object);                
            }            

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailMdfeNfesMdfeInfmundescarga($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Indicador de Reentrega", 'name'=>"mdfe_nfes_mdfe_infmundescarga_indReentrega", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->mdfe_nfes_mdfe_infmundescarga__row__id) ? $data->mdfe_nfes_mdfe_infmundescarga__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new MdfeNfes();
            $grid_data->__row__id = $__row__id;
            $grid_data->notafiscal_id = $data->mdfe_nfes_mdfe_infmundescarga_notafiscal_id;
            $grid_data->chNFe = $data->mdfe_nfes_mdfe_infmundescarga_chNFe;
            $grid_data->id = $data->mdfe_nfes_mdfe_infmundescarga_id;
            $grid_data->indReentrega = $data->mdfe_nfes_mdfe_infmundescarga_indReentrega;
            $grid_data->SegCodBarra = $data->mdfe_nfes_mdfe_infmundescarga_SegCodBarra;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['notafiscal_id'] =  $param['mdfe_nfes_mdfe_infmundescarga_notafiscal_id'] ?? null;
            $__row__data['__display__']['chNFe'] =  $param['mdfe_nfes_mdfe_infmundescarga_chNFe'] ?? null;
            $__row__data['__display__']['id'] =  $param['mdfe_nfes_mdfe_infmundescarga_id'] ?? null;
            $__row__data['__display__']['indReentrega'] =  $param['mdfe_nfes_mdfe_infmundescarga_indReentrega'] ?? null;
            $__row__data['__display__']['SegCodBarra'] =  $param['mdfe_nfes_mdfe_infmundescarga_SegCodBarra'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->mdfe_nfes_mdfe_infmundescarga_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('mdfe_nfes_mdfe_infmundescarga_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->mdfe_nfes_mdfe_infmundescarga_notafiscal_id = '';
            $data->mdfe_nfes_mdfe_infmundescarga_chNFe = '';
            $data->mdfe_nfes_mdfe_infmundescarga_id = '';
            $data->mdfe_nfes_mdfe_infmundescarga_indReentrega = Resposta::Nao;
            $data->mdfe_nfes_mdfe_infmundescarga_SegCodBarra = '';
            $data->mdfe_nfes_mdfe_infmundescarga__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#62e6748fe19f6');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailMdfeNfes($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->mdfe_nfes_mdfe_infmundescarga_notafiscal_id = $__row__data->__display__->notafiscal_id ?? null;
            $data->mdfe_nfes_mdfe_infmundescarga_chNFe = $__row__data->__display__->chNFe ?? null;
            $data->mdfe_nfes_mdfe_infmundescarga_id = $__row__data->__display__->id ?? null;
            $data->mdfe_nfes_mdfe_infmundescarga_indReentrega = $__row__data->__display__->indReentrega ?? null;
            $data->mdfe_nfes_mdfe_infmundescarga_SegCodBarra = $__row__data->__display__->SegCodBarra ?? null;
            $data->mdfe_nfes_mdfe_infmundescarga__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#62e6748fe19f6');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailMdfeNfes($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->mdfe_nfes_mdfe_infmundescarga_notafiscal_id = '';
            $data->mdfe_nfes_mdfe_infmundescarga_chNFe = '';
            $data->mdfe_nfes_mdfe_infmundescarga_id = '';
            $data->mdfe_nfes_mdfe_infmundescarga_indReentrega = '';
            $data->mdfe_nfes_mdfe_infmundescarga_SegCodBarra = '';
            $data->mdfe_nfes_mdfe_infmundescarga__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('mdfe_nfes_mdfe_infmundescarga_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new MdfeInfmundescarga(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            /*
            $object->store(); // save the object 
            */

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $mdfe_nfes_mdfe_infmundescarga_items = $this->storeMasterDetailItems('MdfeNfes', 'mdfe_infmundescarga_id', 'mdfe_nfes_mdfe_infmundescarga', $object, $param['mdfe_nfes_mdfe_infmundescarga_list___row__data'] ?? [], $this->form, $this->mdfe_nfes_mdfe_infmundescarga_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->mdfe_nfes_mdfe_infmundescarga_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new MdfeInfmundescarga($key); // instantiates the Active Record 

                $mdfe_nfes_mdfe_infmundescarga_items = $this->loadMasterDetailItems('MdfeNfes', 'mdfe_infmundescarga_id', 'mdfe_nfes_mdfe_infmundescarga', $object, $this->form, $this->mdfe_nfes_mdfe_infmundescarga_list, $this->mdfe_nfes_mdfe_infmundescarga_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

