<?php

class NaturezaOperacaoExcecaoICMSForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NaturezaOperacaoExcecao';
    private static $primaryKey = 'id';
    private static $formName = 'form_NaturezaOperacaoExcecaoICMSForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro Exceção de Natureza de Operação - ICMS");


        $id = new TEntry('id');
        $natop_excecao_tributo_id = new TDBCombo('natop_excecao_tributo_id', 'kraftsoft', 'NatopExcecaoTributo', 'id', '{descricao}','descricao asc'  );
        $natureza_operacao_id = new TDBCombo('natureza_operacao_id', 'kraftsoft', 'NaturezaOperacao', 'id', '{descricao}','descricao asc'  );
        $descricao = new TEntry('descricao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $natureza_operacao_estados_natureza_operacao_excecao_estado_id = new TDBCombo('natureza_operacao_estados_natureza_operacao_excecao_estado_id', 'kraftsoft', 'Estado', 'id', '{nome}','nome asc'  );
        $natureza_operacao_estados_natureza_operacao_excecao_id = new THidden('natureza_operacao_estados_natureza_operacao_excecao_id');
        $button_adicionar_natureza_operacao_estados_natureza_operacao_excecao = new TButton('button_adicionar_natureza_operacao_estados_natureza_operacao_excecao');
        $natureza_operacao_produtos_natureza_operacao_excecao_produto_id = new TDBCombo('natureza_operacao_produtos_natureza_operacao_excecao_produto_id', 'kraftsoft', 'Produto', 'id', '{id}  - {nome}','nome asc'  );
        $natureza_operacao_produtos_natureza_operacao_excecao_id = new THidden('natureza_operacao_produtos_natureza_operacao_excecao_id');
        $button_adicionar_natureza_operacao_produtos_natureza_operacao_excecao = new TButton('button_adicionar_natureza_operacao_produtos_natureza_operacao_excecao');
        $natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id = new TDBCombo('natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id', 'kraftsoft', 'NotafiscalItemOrig', 'id', '{id}','id asc'  );
        $natureza_operacao_origens_natureza_operacao_excecao_id = new THidden('natureza_operacao_origens_natureza_operacao_excecao_id');
        $button_adicionar_natureza_operacao_origens_natureza_operacao_excecao = new TButton('button_adicionar_natureza_operacao_origens_natureza_operacao_excecao');
        $natureza_operacao_ncm_natureza_operacao_excecao_ncm = new TEntry('natureza_operacao_ncm_natureza_operacao_excecao_ncm');
        $natureza_operacao_ncm_natureza_operacao_excecao_id = new THidden('natureza_operacao_ncm_natureza_operacao_excecao_id');
        $button_adicionar_natureza_operacao_ncm_natureza_operacao_excecao = new TButton('button_adicionar_natureza_operacao_ncm_natureza_operacao_excecao');
        $cst_icms_id = new TDBCombo('cst_icms_id', 'kraftsoft', 'CstIcms', 'id', '{descricao}','descricao asc'  );
        $cfop = new TEntry('cfop');
        $cfop_fora = new TEntry('cfop_fora');
        $icms_pcredsn = new TNumeric('icms_pcredsn', '2', ',', '.' );
        $icms_aliquota = new TNumeric('icms_aliquota', '2', ',', '.' );
        $icms_base = new TNumeric('icms_base', '2', ',', '.' );
        $notafiscal_item_modbc_id = new TDBCombo('notafiscal_item_modbc_id', 'kraftsoft', 'NotafiscalItemModbc', 'id', '{descricao}','id asc'  );
        $icms_picmsst = new TNumeric('icms_picmsst', '2', ',', '.' );
        $icms_basest = new TNumeric('icms_basest', '2', ',', '.' );
        $icms_pmvast = new TNumeric('icms_pmvast', '2', ',', '.' );
        $icms_pfcpst = new TNumeric('icms_pfcpst', '2', ',', '.' );
        $icms_pfcpstret = new TNumeric('icms_pfcpstret', '2', ',', '.' );
        $icms_predbcefet = new TNumeric('icms_predbcefet', '2', ',', '.' );

        $natop_excecao_tributo_id->addValidation("Natop excecao tributo id", new TRequiredValidator()); 
        $natureza_operacao_id->addValidation("Natureza operação", new TRequiredValidator()); 
        $cfop->addValidation("CFOP dentro do estado", new TRequiredValidator()); 
        $cfop_fora->addValidation("CFOP fora do estado", new TRequiredValidator()); 

        $natureza_operacao_id->setValue(TSession::getValue("natureza_operacao_id"));
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $cst_icms_id->enableSearch();
        $notafiscal_item_modbc_id->enableSearch();
        $natureza_operacao_produtos_natureza_operacao_excecao_produto_id->enableSearch();

        $button_adicionar_natureza_operacao_ncm_natureza_operacao_excecao->setAction(new TAction([$this, 'onAddDetailNaturezaOperacaoNcmNaturezaOperacaoExcecao'],['static' => 1]), "Adicionar");
        $button_adicionar_natureza_operacao_estados_natureza_operacao_excecao->setAction(new TAction([$this, 'onAddDetailNaturezaOperacaoEstadosNaturezaOperacaoExcecao'],['static' => 1]), "Adicionar");
        $button_adicionar_natureza_operacao_origens_natureza_operacao_excecao->setAction(new TAction([$this, 'onAddDetailNaturezaOperacaoOrigensNaturezaOperacaoExcecao'],['static' => 1]), "Adicionar");
        $button_adicionar_natureza_operacao_produtos_natureza_operacao_excecao->setAction(new TAction([$this, 'onAddDetailNaturezaOperacaoProdutosNaturezaOperacaoExcecao'],['static' => 1]), "Adicionar");

        $button_adicionar_natureza_operacao_ncm_natureza_operacao_excecao->addStyleClass('btn-default');
        $button_adicionar_natureza_operacao_estados_natureza_operacao_excecao->addStyleClass('btn-default');
        $button_adicionar_natureza_operacao_origens_natureza_operacao_excecao->addStyleClass('btn-default');
        $button_adicionar_natureza_operacao_produtos_natureza_operacao_excecao->addStyleClass('btn-default');

        $button_adicionar_natureza_operacao_ncm_natureza_operacao_excecao->setImage('fas:plus #2ecc71');
        $button_adicionar_natureza_operacao_estados_natureza_operacao_excecao->setImage('fas:plus #2ecc71');
        $button_adicionar_natureza_operacao_origens_natureza_operacao_excecao->setImage('fas:plus #2ecc71');
        $button_adicionar_natureza_operacao_produtos_natureza_operacao_excecao->setImage('fas:plus #2ecc71');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $natureza_operacao_id->setEditable(false);
        $natop_excecao_tributo_id->setEditable(false);

        $id->setSize(100);
        $cfop->setSize('100%');
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $cfop_fora->setSize('100%');
        $icms_base->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $cst_icms_id->setSize('100%');
        $icms_basest->setSize('100%');
        $icms_pmvast->setSize('100%');
        $icms_pfcpst->setSize('100%');
        $alterado_por->setSize('100%');
        $icms_pcredsn->setSize('100%');
        $icms_picmsst->setSize('100%');
        $icms_aliquota->setSize('100%');
        $icms_pfcpstret->setSize('100%');
        $icms_predbcefet->setSize('100%');
        $natureza_operacao_id->setSize('100%');
        $natop_excecao_tributo_id->setSize('100%');
        $notafiscal_item_modbc_id->setSize('100%');
        $natureza_operacao_ncm_natureza_operacao_excecao_id->setSize(200);
        $natureza_operacao_estados_natureza_operacao_excecao_id->setSize(200);
        $natureza_operacao_origens_natureza_operacao_excecao_id->setSize(200);
        $natureza_operacao_ncm_natureza_operacao_excecao_ncm->setSize('100%');
        $natureza_operacao_produtos_natureza_operacao_excecao_id->setSize(200);
        $natureza_operacao_estados_natureza_operacao_excecao_estado_id->setSize('100%');
        $natureza_operacao_produtos_natureza_operacao_excecao_produto_id->setSize('100%');
        $natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id->setSize('100%');

        $button_adicionar_natureza_operacao_ncm_natureza_operacao_excecao->id = '61d9fdc0a65f7';
        $button_adicionar_natureza_operacao_estados_natureza_operacao_excecao->id = '61d9fbeca65dc';
        $button_adicionar_natureza_operacao_origens_natureza_operacao_excecao->id = '61d9fd58a65ee';
        $button_adicionar_natureza_operacao_produtos_natureza_operacao_excecao->id = '61d9fcdba65e5';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Tributo:", '#ff0000', '14px', null, '100%'),$natop_excecao_tributo_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Natureza de operação:", '#ff0000', '14px', null, '100%'),$natureza_operacao_id],[new TLabel("Descrição:", null, '14px', null),$descricao]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_637799c55abcc = new BContainer('bcontainer_637799c55abcc');
        $this->bcontainer_637799c55abcc = $bcontainer_637799c55abcc;

        $bcontainer_637799c55abcc->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_637799c55abcc->setBorderColor('#c0c0c0');

        $row3 = $bcontainer_637799c55abcc->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row3->layout = ['col-sm-2','col-sm-4','col-sm-2','col-sm-4'];

        $row4 = $this->form->addFields([$bcontainer_637799c55abcc]);
        $row4->layout = [' col-sm-12'];

        $this->form->appendPage("Destinatário");

        $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao = new BootstrapFormBuilder('detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao');
        $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao->setProperty('class', 'form-horizontal builder-detail-form');

        $row5 = $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao->addFields([new TFormSeparator("Quando o destinatário for um destes estados", '#333', '18', '#eee')]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao->addFields([new TLabel("Estado:", '#ff0000', '14px', null, '100%'),$natureza_operacao_estados_natureza_operacao_excecao_estado_id,$natureza_operacao_estados_natureza_operacao_excecao_id],[]);
        $row6->layout = ['col-sm-6','col-sm-6'];

        $row7 = $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao->addFields([$button_adicionar_natureza_operacao_estados_natureza_operacao_excecao]);
        $row7->layout = [' col-sm-12'];

        $row8 = $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao->addFields([new THidden('natureza_operacao_estados_natureza_operacao_excecao__row__id')]);
        $this->natureza_operacao_estados_natureza_operacao_excecao_criteria = new TCriteria();

        $this->natureza_operacao_estados_natureza_operacao_excecao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->natureza_operacao_estados_natureza_operacao_excecao_list->disableHtmlConversion();;
        $this->natureza_operacao_estados_natureza_operacao_excecao_list->generateHiddenFields();
        $this->natureza_operacao_estados_natureza_operacao_excecao_list->setId('natureza_operacao_estados_natureza_operacao_excecao_list');

        $this->natureza_operacao_estados_natureza_operacao_excecao_list->style = 'width:100%';
        $this->natureza_operacao_estados_natureza_operacao_excecao_list->class .= ' table-bordered';

        $column_natureza_operacao_estados_natureza_operacao_excecao_estado_nome = new TDataGridColumn('estado->nome', "Estado", 'left');

        $column_natureza_operacao_estados_natureza_operacao_excecao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_natureza_operacao_estados_natureza_operacao_excecao__row__data->setVisibility(false);

        $action_onEditDetailNaturezaOperacaoEstados = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onEditDetailNaturezaOperacaoEstados'));
        $action_onEditDetailNaturezaOperacaoEstados->setUseButton(false);
        $action_onEditDetailNaturezaOperacaoEstados->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNaturezaOperacaoEstados->setLabel("Editar");
        $action_onEditDetailNaturezaOperacaoEstados->setImage('far:edit #478fca');
        $action_onEditDetailNaturezaOperacaoEstados->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_estados_natureza_operacao_excecao_list->addAction($action_onEditDetailNaturezaOperacaoEstados);
        $action_onDeleteDetailNaturezaOperacaoEstados = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onDeleteDetailNaturezaOperacaoEstados'));
        $action_onDeleteDetailNaturezaOperacaoEstados->setUseButton(false);
        $action_onDeleteDetailNaturezaOperacaoEstados->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNaturezaOperacaoEstados->setLabel("Excluir");
        $action_onDeleteDetailNaturezaOperacaoEstados->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNaturezaOperacaoEstados->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_estados_natureza_operacao_excecao_list->addAction($action_onDeleteDetailNaturezaOperacaoEstados);

        $this->natureza_operacao_estados_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_estados_natureza_operacao_excecao_estado_nome);

        $this->natureza_operacao_estados_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_estados_natureza_operacao_excecao__row__data);

        $this->natureza_operacao_estados_natureza_operacao_excecao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->natureza_operacao_estados_natureza_operacao_excecao_list);
        $this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao->addContent([$tableResponsiveDiv]);
        $row9 = $this->form->addFields([$this->detailFormNaturezaOperacaoEstadosNaturezaOperacaoExcecao]);
        $row9->layout = [' col-sm-12'];

        $this->form->appendPage("Produtos");

        $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao = new BootstrapFormBuilder('detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao');
        $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao->setProperty('class', 'form-horizontal builder-detail-form');

        $row10 = $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao->addFields([new TFormSeparator("Para os seguintes produtos", '#333', '18', '#eee')]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao->addFields([new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$natureza_operacao_produtos_natureza_operacao_excecao_produto_id,$natureza_operacao_produtos_natureza_operacao_excecao_id],[]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao->addFields([$button_adicionar_natureza_operacao_produtos_natureza_operacao_excecao]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao->addFields([new THidden('natureza_operacao_produtos_natureza_operacao_excecao__row__id')]);
        $this->natureza_operacao_produtos_natureza_operacao_excecao_criteria = new TCriteria();

        $this->natureza_operacao_produtos_natureza_operacao_excecao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->disableHtmlConversion();;
        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->generateHiddenFields();
        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->setId('natureza_operacao_produtos_natureza_operacao_excecao_list');

        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->style = 'width:100%';
        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->class .= ' table-bordered';

        $column_natureza_operacao_produtos_natureza_operacao_excecao_produto_nome = new TDataGridColumn('produto->nome', "Produto", 'left');

        $column_natureza_operacao_produtos_natureza_operacao_excecao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_natureza_operacao_produtos_natureza_operacao_excecao__row__data->setVisibility(false);

        $action_onEditDetailNaturezaOperacaoProdutos = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onEditDetailNaturezaOperacaoProdutos'));
        $action_onEditDetailNaturezaOperacaoProdutos->setUseButton(false);
        $action_onEditDetailNaturezaOperacaoProdutos->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNaturezaOperacaoProdutos->setLabel("Editar");
        $action_onEditDetailNaturezaOperacaoProdutos->setImage('far:edit #478fca');
        $action_onEditDetailNaturezaOperacaoProdutos->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->addAction($action_onEditDetailNaturezaOperacaoProdutos);
        $action_onDeleteDetailNaturezaOperacaoProdutos = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onDeleteDetailNaturezaOperacaoProdutos'));
        $action_onDeleteDetailNaturezaOperacaoProdutos->setUseButton(false);
        $action_onDeleteDetailNaturezaOperacaoProdutos->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNaturezaOperacaoProdutos->setLabel("Excluir");
        $action_onDeleteDetailNaturezaOperacaoProdutos->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNaturezaOperacaoProdutos->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->addAction($action_onDeleteDetailNaturezaOperacaoProdutos);

        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_produtos_natureza_operacao_excecao_produto_nome);

        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_produtos_natureza_operacao_excecao__row__data);

        $this->natureza_operacao_produtos_natureza_operacao_excecao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->natureza_operacao_produtos_natureza_operacao_excecao_list);
        $this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao->addContent([$tableResponsiveDiv]);
        $row14 = $this->form->addFields([$this->detailFormNaturezaOperacaoProdutosNaturezaOperacaoExcecao]);
        $row14->layout = [' col-sm-12'];

        $this->form->appendPage("Origem");

        $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao = new BootstrapFormBuilder('detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao');
        $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao->setProperty('class', 'form-horizontal builder-detail-form');

        $row15 = $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao->addFields([new TFormSeparator("Para as seguintes origens", '#333', '18', '#eee')]);
        $row15->layout = [' col-sm-12'];

        $row16 = $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao->addFields([new TLabel("Origem:", '#ff0000', '14px', null, '100%'),$natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id,$natureza_operacao_origens_natureza_operacao_excecao_id],[]);
        $row16->layout = ['col-sm-6','col-sm-6'];

        $row17 = $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao->addFields([$button_adicionar_natureza_operacao_origens_natureza_operacao_excecao]);
        $row17->layout = [' col-sm-12'];

        $row18 = $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao->addFields([new THidden('natureza_operacao_origens_natureza_operacao_excecao__row__id')]);
        $this->natureza_operacao_origens_natureza_operacao_excecao_criteria = new TCriteria();

        $this->natureza_operacao_origens_natureza_operacao_excecao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->natureza_operacao_origens_natureza_operacao_excecao_list->disableHtmlConversion();;
        $this->natureza_operacao_origens_natureza_operacao_excecao_list->generateHiddenFields();
        $this->natureza_operacao_origens_natureza_operacao_excecao_list->setId('natureza_operacao_origens_natureza_operacao_excecao_list');

        $this->natureza_operacao_origens_natureza_operacao_excecao_list->style = 'width:100%';
        $this->natureza_operacao_origens_natureza_operacao_excecao_list->class .= ' table-bordered';

        $column_natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id = new TDataGridColumn('notafiscal_item_orig_id', "Origem", 'left');

        $column_natureza_operacao_origens_natureza_operacao_excecao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_natureza_operacao_origens_natureza_operacao_excecao__row__data->setVisibility(false);

        $action_onEditDetailNaturezaOperacaoOrigens = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onEditDetailNaturezaOperacaoOrigens'));
        $action_onEditDetailNaturezaOperacaoOrigens->setUseButton(false);
        $action_onEditDetailNaturezaOperacaoOrigens->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNaturezaOperacaoOrigens->setLabel("Editar");
        $action_onEditDetailNaturezaOperacaoOrigens->setImage('far:edit #478fca');
        $action_onEditDetailNaturezaOperacaoOrigens->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_origens_natureza_operacao_excecao_list->addAction($action_onEditDetailNaturezaOperacaoOrigens);
        $action_onDeleteDetailNaturezaOperacaoOrigens = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onDeleteDetailNaturezaOperacaoOrigens'));
        $action_onDeleteDetailNaturezaOperacaoOrigens->setUseButton(false);
        $action_onDeleteDetailNaturezaOperacaoOrigens->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNaturezaOperacaoOrigens->setLabel("Excluir");
        $action_onDeleteDetailNaturezaOperacaoOrigens->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNaturezaOperacaoOrigens->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_origens_natureza_operacao_excecao_list->addAction($action_onDeleteDetailNaturezaOperacaoOrigens);

        $this->natureza_operacao_origens_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id);

        $this->natureza_operacao_origens_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_origens_natureza_operacao_excecao__row__data);

        $this->natureza_operacao_origens_natureza_operacao_excecao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->natureza_operacao_origens_natureza_operacao_excecao_list);
        $this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao->addContent([$tableResponsiveDiv]);
        $row19 = $this->form->addFields([$this->detailFormNaturezaOperacaoOrigensNaturezaOperacaoExcecao]);
        $row19->layout = [' col-sm-12'];

        $this->form->appendPage("NCM");

        $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao = new BootstrapFormBuilder('detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao');
        $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao->setProperty('class', 'form-horizontal builder-detail-form');

        $row20 = $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao->addFields([new TFormSeparator("Para as seguintes NCMs", '#333', '18', '#eee')]);
        $row20->layout = [' col-sm-12'];

        $row21 = $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao->addFields([new TLabel("NCM:", '#ff0000', '14px', null, '100%'),$natureza_operacao_ncm_natureza_operacao_excecao_ncm,$natureza_operacao_ncm_natureza_operacao_excecao_id],[]);
        $row21->layout = ['col-sm-6','col-sm-6'];

        $row22 = $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao->addFields([$button_adicionar_natureza_operacao_ncm_natureza_operacao_excecao]);
        $row22->layout = [' col-sm-12'];

        $row23 = $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao->addFields([new THidden('natureza_operacao_ncm_natureza_operacao_excecao__row__id')]);
        $this->natureza_operacao_ncm_natureza_operacao_excecao_criteria = new TCriteria();

        $this->natureza_operacao_ncm_natureza_operacao_excecao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->disableHtmlConversion();;
        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->generateHiddenFields();
        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->setId('natureza_operacao_ncm_natureza_operacao_excecao_list');

        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->style = 'width:100%';
        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->class .= ' table-bordered';

        $column_natureza_operacao_ncm_natureza_operacao_excecao_ncm = new TDataGridColumn('ncm', "NCM", 'left');

        $column_natureza_operacao_ncm_natureza_operacao_excecao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_natureza_operacao_ncm_natureza_operacao_excecao__row__data->setVisibility(false);

        $action_onEditDetailNaturezaOperacaoNcm = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onEditDetailNaturezaOperacaoNcm'));
        $action_onEditDetailNaturezaOperacaoNcm->setUseButton(false);
        $action_onEditDetailNaturezaOperacaoNcm->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNaturezaOperacaoNcm->setLabel("Editar");
        $action_onEditDetailNaturezaOperacaoNcm->setImage('far:edit #478fca');
        $action_onEditDetailNaturezaOperacaoNcm->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->addAction($action_onEditDetailNaturezaOperacaoNcm);
        $action_onDeleteDetailNaturezaOperacaoNcm = new TDataGridAction(array('NaturezaOperacaoExcecaoICMSForm', 'onDeleteDetailNaturezaOperacaoNcm'));
        $action_onDeleteDetailNaturezaOperacaoNcm->setUseButton(false);
        $action_onDeleteDetailNaturezaOperacaoNcm->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNaturezaOperacaoNcm->setLabel("Excluir");
        $action_onDeleteDetailNaturezaOperacaoNcm->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNaturezaOperacaoNcm->setFields(['__row__id', '__row__data']);

        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->addAction($action_onDeleteDetailNaturezaOperacaoNcm);

        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_ncm_natureza_operacao_excecao_ncm);

        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->addColumn($column_natureza_operacao_ncm_natureza_operacao_excecao__row__data);

        $this->natureza_operacao_ncm_natureza_operacao_excecao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->natureza_operacao_ncm_natureza_operacao_excecao_list);
        $this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao->addContent([$tableResponsiveDiv]);
        $row24 = $this->form->addFields([$this->detailFormNaturezaOperacaoNcmNaturezaOperacaoExcecao]);
        $row24->layout = [' col-sm-12'];

        $this->form->appendPage("ICMS");
        $row25 = $this->form->addFields([new TLabel("CST ICMS:", '#FF0000', '14px', null),$cst_icms_id]);
        $row25->layout = [' col-sm-12'];

        $row26 = $this->form->addFields([new TLabel("CFOP dentro do estado:", '#FF0000', '14px', null),$cfop],[new TLabel("CFOP fora do estado:", '#FF0000', '14px', null),$cfop_fora]);
        $row26->layout = [' col-sm-6',' col-sm-6'];

        $row27 = $this->form->addFields([new TLabel("Alíq. Aplic. de Cálculo do Crédito :", null, '14px', null),$icms_pcredsn],[new TLabel("Aliquota ICMS:", null, '14px', null),$icms_aliquota],[new TLabel("Base ICMS:", null, '14px', null),$icms_base]);
        $row27->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row28 = $this->form->addFields([new TLabel("Modalid. de Determ. da BC ICMS:", null, '14px', null),$notafiscal_item_modbc_id]);
        $row28->layout = [' col-sm-12'];

        $bcontainer_6378bdba9118e = new BContainer('bcontainer_6378bdba9118e');
        $this->bcontainer_6378bdba9118e = $bcontainer_6378bdba9118e;

        $bcontainer_6378bdba9118e->setTitle("Substituição Tributária", '#333', '18px', '', '#fff');
        $bcontainer_6378bdba9118e->setBorderColor('#c0c0c0');

        $row29 = $bcontainer_6378bdba9118e->addFields([new TLabel("Alíquota ICMS ST:", null, '14px', null),$icms_picmsst],[new TLabel("Base de Cálculo ICMS ST:", null, '14px', null),$icms_basest],[new TLabel("Margem Adic.ICMS:", null, '14px', null),$icms_pmvast]);
        $row29->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row30 = $this->form->addFields([$bcontainer_6378bdba9118e]);
        $row30->layout = [' col-sm-12'];

        $bcontainer_6378bf2e9119a = new BContainer('bcontainer_6378bf2e9119a');
        $this->bcontainer_6378bf2e9119a = $bcontainer_6378bf2e9119a;

        $bcontainer_6378bf2e9119a->setTitle("Substituição tributária retida anteriormente", '#333', '18px', '', '#fff');
        $bcontainer_6378bf2e9119a->setBorderColor('#c0c0c0');

        $row31 = $bcontainer_6378bf2e9119a->addFields([new TLabel("Alíquota FCP ICMS-ST :", null, '14px', null),$icms_pfcpst],[new TLabel("Alíquota ICMS Retido (CST 500):", null, '14px', null),$icms_pfcpstret],[new TLabel("Base de Cálculo ICMS Retido (CST 500):", null, '14px', null),$icms_predbcefet]);
        $row31->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row32 = $this->form->addFields([$bcontainer_6378bf2e9119a]);
        $row32->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=NaturezaOperacaoExcecaoICMSForm]');
        $style->width = '70% !important';   
        $style->show(true);

    }

    public  function onAddDetailNaturezaOperacaoEstadosNaturezaOperacaoExcecao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Estado id", 'name'=>"natureza_operacao_estados_natureza_operacao_excecao_estado_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->natureza_operacao_estados_natureza_operacao_excecao__row__id) ? $data->natureza_operacao_estados_natureza_operacao_excecao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NaturezaOperacaoEstados();
            $grid_data->__row__id = $__row__id;
            $grid_data->estado_id = $data->natureza_operacao_estados_natureza_operacao_excecao_estado_id;
            $grid_data->id = $data->natureza_operacao_estados_natureza_operacao_excecao_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['estado_id'] =  $param['natureza_operacao_estados_natureza_operacao_excecao_estado_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['natureza_operacao_estados_natureza_operacao_excecao_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->natureza_operacao_estados_natureza_operacao_excecao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('natureza_operacao_estados_natureza_operacao_excecao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->natureza_operacao_estados_natureza_operacao_excecao_estado_id = '';
            $data->natureza_operacao_estados_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_estados_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fbeca65dc');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNaturezaOperacaoProdutosNaturezaOperacaoExcecao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if(!empty($param['natureza_operacao_produtos_natureza_operacao_excecao_list___row__data']))
            {
                $rowId = $param['natureza_operacao_produtos_natureza_operacao_excecao__row__id'];
                foreach($param['natureza_operacao_produtos_natureza_operacao_excecao_list___row__data'] as $rowDataCoded)
                {
                    $rowDataDecoded = unserialize(base64_decode($rowDataCoded));    

                    $idprod_lista =  strval($rowDataDecoded->produto_id);
                    $idprod_add = strval($param['natureza_operacao_produtos_natureza_operacao_excecao_produto_id']);

                    if ($idprod_lista == $idprod_add)
                    {
                      throw new Exception('Produto já adicionado!');                                                 
                    }

                    // $rowDataDecoded->id;
                    // $rowDataDecoded->__row__id;
                }
            }

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Produto id", 'name'=>"natureza_operacao_produtos_natureza_operacao_excecao_produto_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->natureza_operacao_produtos_natureza_operacao_excecao__row__id) ? $data->natureza_operacao_produtos_natureza_operacao_excecao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NaturezaOperacaoProdutos();
            $grid_data->__row__id = $__row__id;
            $grid_data->produto_id = $data->natureza_operacao_produtos_natureza_operacao_excecao_produto_id;
            $grid_data->id = $data->natureza_operacao_produtos_natureza_operacao_excecao_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['produto_id'] =  $param['natureza_operacao_produtos_natureza_operacao_excecao_produto_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['natureza_operacao_produtos_natureza_operacao_excecao_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->natureza_operacao_produtos_natureza_operacao_excecao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('natureza_operacao_produtos_natureza_operacao_excecao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->natureza_operacao_produtos_natureza_operacao_excecao_produto_id = '';
            $data->natureza_operacao_produtos_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_produtos_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fcdba65e5');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNaturezaOperacaoOrigensNaturezaOperacaoExcecao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Notafiscal item orig id", 'name'=>"natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->natureza_operacao_origens_natureza_operacao_excecao__row__id) ? $data->natureza_operacao_origens_natureza_operacao_excecao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NaturezaOperacaoOrigens();
            $grid_data->__row__id = $__row__id;
            $grid_data->notafiscal_item_orig_id = $data->natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id;
            $grid_data->id = $data->natureza_operacao_origens_natureza_operacao_excecao_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['notafiscal_item_orig_id'] =  $param['natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['natureza_operacao_origens_natureza_operacao_excecao_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->natureza_operacao_origens_natureza_operacao_excecao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('natureza_operacao_origens_natureza_operacao_excecao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id = '';
            $data->natureza_operacao_origens_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_origens_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fd58a65ee');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNaturezaOperacaoNcmNaturezaOperacaoExcecao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"NCM", 'name'=>"natureza_operacao_ncm_natureza_operacao_excecao_ncm", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->natureza_operacao_ncm_natureza_operacao_excecao__row__id) ? $data->natureza_operacao_ncm_natureza_operacao_excecao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NaturezaOperacaoNcm();
            $grid_data->__row__id = $__row__id;
            $grid_data->ncm = $data->natureza_operacao_ncm_natureza_operacao_excecao_ncm;
            $grid_data->id = $data->natureza_operacao_ncm_natureza_operacao_excecao_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['ncm'] =  $param['natureza_operacao_ncm_natureza_operacao_excecao_ncm'] ?? null;
            $__row__data['__display__']['id'] =  $param['natureza_operacao_ncm_natureza_operacao_excecao_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->natureza_operacao_ncm_natureza_operacao_excecao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('natureza_operacao_ncm_natureza_operacao_excecao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->natureza_operacao_ncm_natureza_operacao_excecao_ncm = '';
            $data->natureza_operacao_ncm_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_ncm_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fdc0a65f7');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailNaturezaOperacaoEstados($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->natureza_operacao_estados_natureza_operacao_excecao_estado_id = $__row__data->__display__->estado_id ?? null;
            $data->natureza_operacao_estados_natureza_operacao_excecao_id = $__row__data->__display__->id ?? null;
            $data->natureza_operacao_estados_natureza_operacao_excecao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fbeca65dc');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNaturezaOperacaoEstados($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->natureza_operacao_estados_natureza_operacao_excecao_estado_id = '';
            $data->natureza_operacao_estados_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_estados_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('natureza_operacao_estados_natureza_operacao_excecao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNaturezaOperacaoProdutos($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->natureza_operacao_produtos_natureza_operacao_excecao_produto_id = $__row__data->__display__->produto_id ?? null;
            $data->natureza_operacao_produtos_natureza_operacao_excecao_id = $__row__data->__display__->id ?? null;
            $data->natureza_operacao_produtos_natureza_operacao_excecao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fcdba65e5');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNaturezaOperacaoProdutos($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->natureza_operacao_produtos_natureza_operacao_excecao_produto_id = '';
            $data->natureza_operacao_produtos_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_produtos_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('natureza_operacao_produtos_natureza_operacao_excecao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNaturezaOperacaoOrigens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id = $__row__data->__display__->notafiscal_item_orig_id ?? null;
            $data->natureza_operacao_origens_natureza_operacao_excecao_id = $__row__data->__display__->id ?? null;
            $data->natureza_operacao_origens_natureza_operacao_excecao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fd58a65ee');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNaturezaOperacaoOrigens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->natureza_operacao_origens_natureza_operacao_excecao_notafiscal_item_orig_id = '';
            $data->natureza_operacao_origens_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_origens_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('natureza_operacao_origens_natureza_operacao_excecao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNaturezaOperacaoNcm($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->natureza_operacao_ncm_natureza_operacao_excecao_ncm = $__row__data->__display__->ncm ?? null;
            $data->natureza_operacao_ncm_natureza_operacao_excecao_id = $__row__data->__display__->id ?? null;
            $data->natureza_operacao_ncm_natureza_operacao_excecao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61d9fdc0a65f7');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNaturezaOperacaoNcm($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->natureza_operacao_ncm_natureza_operacao_excecao_ncm = '';
            $data->natureza_operacao_ncm_natureza_operacao_excecao_id = '';
            $data->natureza_operacao_ncm_natureza_operacao_excecao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('natureza_operacao_ncm_natureza_operacao_excecao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new NaturezaOperacaoExcecao(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $natureza_operacao_ncm_natureza_operacao_excecao_items = $this->storeMasterDetailItems('NaturezaOperacaoNcm', 'natureza_operacao_excecao_id', 'natureza_operacao_ncm_natureza_operacao_excecao', $object, $param['natureza_operacao_ncm_natureza_operacao_excecao_list___row__data'] ?? [], $this->form, $this->natureza_operacao_ncm_natureza_operacao_excecao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->natureza_operacao_ncm_natureza_operacao_excecao_criteria); 

            $natureza_operacao_origens_natureza_operacao_excecao_items = $this->storeMasterDetailItems('NaturezaOperacaoOrigens', 'natureza_operacao_excecao_id', 'natureza_operacao_origens_natureza_operacao_excecao', $object, $param['natureza_operacao_origens_natureza_operacao_excecao_list___row__data'] ?? [], $this->form, $this->natureza_operacao_origens_natureza_operacao_excecao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->natureza_operacao_origens_natureza_operacao_excecao_criteria); 

            $natureza_operacao_produtos_natureza_operacao_excecao_items = $this->storeMasterDetailItems('NaturezaOperacaoProdutos', 'natureza_operacao_excecao_id', 'natureza_operacao_produtos_natureza_operacao_excecao', $object, $param['natureza_operacao_produtos_natureza_operacao_excecao_list___row__data'] ?? [], $this->form, $this->natureza_operacao_produtos_natureza_operacao_excecao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->natureza_operacao_produtos_natureza_operacao_excecao_criteria); 

            $natureza_operacao_estados_natureza_operacao_excecao_items = $this->storeMasterDetailItems('NaturezaOperacaoEstados', 'natureza_operacao_excecao_id', 'natureza_operacao_estados_natureza_operacao_excecao', $object, $param['natureza_operacao_estados_natureza_operacao_excecao_list___row__data'] ?? [], $this->form, $this->natureza_operacao_estados_natureza_operacao_excecao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->natureza_operacao_estados_natureza_operacao_excecao_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('NaturezaOperacaoExcecaoICMSList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();"); 
        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new NaturezaOperacaoExcecao($key); // instantiates the Active Record 

                $natureza_operacao_ncm_natureza_operacao_excecao_items = $this->loadMasterDetailItems('NaturezaOperacaoNcm', 'natureza_operacao_excecao_id', 'natureza_operacao_ncm_natureza_operacao_excecao', $object, $this->form, $this->natureza_operacao_ncm_natureza_operacao_excecao_list, $this->natureza_operacao_ncm_natureza_operacao_excecao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $natureza_operacao_origens_natureza_operacao_excecao_items = $this->loadMasterDetailItems('NaturezaOperacaoOrigens', 'natureza_operacao_excecao_id', 'natureza_operacao_origens_natureza_operacao_excecao', $object, $this->form, $this->natureza_operacao_origens_natureza_operacao_excecao_list, $this->natureza_operacao_origens_natureza_operacao_excecao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $natureza_operacao_produtos_natureza_operacao_excecao_items = $this->loadMasterDetailItems('NaturezaOperacaoProdutos', 'natureza_operacao_excecao_id', 'natureza_operacao_produtos_natureza_operacao_excecao', $object, $this->form, $this->natureza_operacao_produtos_natureza_operacao_excecao_list, $this->natureza_operacao_produtos_natureza_operacao_excecao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $natureza_operacao_estados_natureza_operacao_excecao_items = $this->loadMasterDetailItems('NaturezaOperacaoEstados', 'natureza_operacao_excecao_id', 'natureza_operacao_estados_natureza_operacao_excecao', $object, $this->form, $this->natureza_operacao_estados_natureza_operacao_excecao_list, $this->natureza_operacao_estados_natureza_operacao_excecao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->natop_excecao_tributo_id = NatopExcecaoTributo::ICMS;
        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

