<?php

class NaturezaOperacaoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NaturezaOperacao';
    private static $primaryKey = 'id';
    private static $formName = 'form_NaturezaOperacaoForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de natureza operação");

        // TTransaction::open(self::$database);

        // $filial = SystemUnit::find(TSession::getValue('userunitid'));

        // if($filial)
        // {
        //     $criteria_cst_icms_id->add(new TFilter('regime_tributario_id', '=', $filial->notafiscal_crt_id));
        // }

        // TTransaction::close();

        $id = new TEntry('id');
        $natureza_operacao_finalidade_id = new TDBCombo('natureza_operacao_finalidade_id', 'kraftsoft', 'NaturezaOperacaoFinalidade', 'id', '{nome}','nome asc'  );
        $descricao = new TEntry('descricao');
        $obs_padrao = new TText('obs_padrao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $cst_icms_id = new TDBCombo('cst_icms_id', 'kraftsoft', 'CstIcms', 'id', '{descricao}','cst_numero asc'  );
        $cst_icms_nao_contribuinte_id = new TDBCombo('cst_icms_nao_contribuinte_id', 'kraftsoft', 'CstIcms', 'id', '{descricao}','cst_numero asc'  );
        $cfop = new TEntry('cfop');
        $cfop_fora = new TEntry('cfop_fora');
        $bhelper_62064ec6b7189 = new BHelper();
        $icms_pCredSN = new TNumeric('icms_pCredSN', '2', ',', '.' );
        $bhelper_620651f246883 = new BHelper();
        $icms_aliquota = new TNumeric('icms_aliquota', '2', ',', '.' );
        $bhelper_6206523eb5525 = new BHelper();
        $icms_base = new TNumeric('icms_base', '2', ',', '.' );
        $bhelper_620655aadf402 = new BHelper();
        $notafiscal_item_modbc_id = new TDBCombo('notafiscal_item_modbc_id', 'kraftsoft', 'NotafiscalItemModbc', 'id', '{descricao}','id asc'  );
        $bhelper_6206543f29756 = new BHelper();
        $icms_pICMSST = new TNumeric('icms_pICMSST', '2', ',', '.' );
        $bhelper_62065472876b1 = new BHelper();
        $icms_baseST = new TNumeric('icms_baseST', '2', ',', '.' );
        $bhelper_620654fb52ca0 = new BHelper();
        $icms_pMVAST = new TNumeric('icms_pMVAST', '2', ',', '.' );
        $bhelper_6206560a096b8 = new BHelper();
        $icms_pFCPST = new TNumeric('icms_pFCPST', '2', ',', '.' );
        $icms_pFCPSTRet = new TNumeric('icms_pFCPSTRet', '2', ',', '.' );
        $icms_pRedBCEfet = new TNumeric('icms_pRedBCEfet', '2', ',', '.' );
        $cst_ipi_id = new TDBCombo('cst_ipi_id', 'kraftsoft', 'CstIpi', 'id', '{descricao}','descricao asc'  );
        $ipi_aliquota = new TNumeric('ipi_aliquota', '2', ',', '.' );
        $ipi_codigo_enquadramento = new TEntry('ipi_codigo_enquadramento');
        $cst_pis_id = new TDBCombo('cst_pis_id', 'kraftsoft', 'CstPis', 'id', '{descricao}','descricao asc'  );
        $pis_aliquota = new TNumeric('pis_aliquota', '2', ',', '.' );
        $pis_base = new TNumeric('pis_base', '2', ',', '.' );
        $cst_cofins_id = new TDBCombo('cst_cofins_id', 'kraftsoft', 'CstCofins', 'id', '{descricao}','descricao asc'  );
        $cofins_aliquota = new TNumeric('cofins_aliquota', '2', ',', '.' );
        $cofins_base = new TNumeric('cofins_base', '2', ',', '.' );

        $natureza_operacao_finalidade_id->addValidation("Natureza operacao finalidade id", new TRequiredValidator()); 
        $descricao->addValidation("Descrição", new TRequiredValidator()); 
        $cst_icms_id->addValidation("CST ICMS", new TRequiredValidator()); 
        $cst_icms_nao_contribuinte_id->addValidation("CST ICMS", new TRequiredValidator()); 
        $cfop->addValidation("CFOP dentro do estado", new TRequiredValidator()); 
        $cfop_fora->addValidation("CFOP fora do estado", new TRequiredValidator()); 
        $cst_ipi_id->addValidation("Cst ipi id", new TRequiredValidator()); 
        $cst_pis_id->addValidation("Cst pis id", new TRequiredValidator()); 
        $cst_cofins_id->addValidation("Cst cofins id", new TRequiredValidator()); 

        $cfop->setMaxLength(4);
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $cst_icms_id->enableSearch();
        $cst_icms_nao_contribuinte_id->enableSearch();

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $bhelper_62064ec6b7189->enableHover();
        $bhelper_620651f246883->enableHover();
        $bhelper_6206523eb5525->enableHover();
        $bhelper_620655aadf402->enableHover();
        $bhelper_6206543f29756->enableHover();
        $bhelper_62065472876b1->enableHover();
        $bhelper_620654fb52ca0->enableHover();
        $bhelper_6206560a096b8->enableHover();

        $bhelper_62064ec6b7189->setSide("top");
        $bhelper_620651f246883->setSide("top");
        $bhelper_6206523eb5525->setSide("top");
        $bhelper_620655aadf402->setSide("top");
        $bhelper_6206543f29756->setSide("top");
        $bhelper_62065472876b1->setSide("top");
        $bhelper_620654fb52ca0->setSide("top");
        $bhelper_6206560a096b8->setSide("top");

        $bhelper_62064ec6b7189->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620651f246883->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_6206523eb5525->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620655aadf402->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_6206543f29756->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_62065472876b1->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620654fb52ca0->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_6206560a096b8->setIcon(new TImage("fas:question #2196F3"));

        $bhelper_62064ec6b7189->setTitle("Utilização deste campo");
        $bhelper_620651f246883->setTitle("Utilização deste campo");
        $bhelper_6206523eb5525->setTitle("Utilização deste campo");
        $bhelper_620655aadf402->setTitle("Utilização deste campo");
        $bhelper_6206543f29756->setTitle("Utilização deste campo");
        $bhelper_62065472876b1->setTitle("Utilização deste campo");
        $bhelper_620654fb52ca0->setTitle("Utilização deste campo");
        $bhelper_6206560a096b8->setTitle("Utilização deste campo");

        $bhelper_620655aadf402->setContent("CST 00");
        $bhelper_62064ec6b7189->setContent("CST 101, 201, 900");
        $bhelper_6206543f29756->setContent("CST 201, 202, 203, 900");
        $bhelper_62065472876b1->setContent("CST 201, 202, 203, 900");
        $bhelper_620654fb52ca0->setContent("(CST 201, 202, 203, 900)");
        $bhelper_620651f246883->setContent("CST 201, 202, 203, 900, 00");
        $bhelper_6206523eb5525->setContent("CST 201, 202, 203, 900, 00");
        $bhelper_6206560a096b8->setContent("CST 201, 202, 203, 500, 900");

        $id->setSize(100);
        $cfop->setSize('100%');
        $pis_base->setSize('100%');
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $cfop_fora->setSize('100%');
        $icms_base->setSize('100%');
        $criado_por->setSize('100%');
        $cst_ipi_id->setSize('100%');
        $cst_pis_id->setSize('100%');
        $alterado_em->setSize('100%');
        $cst_icms_id->setSize('100%');
        $icms_baseST->setSize('100%');
        $icms_pMVAST->setSize('100%');
        $icms_pFCPST->setSize('100%');
        $cofins_base->setSize('100%');
        $alterado_por->setSize('100%');
        $icms_pCredSN->setSize('100%');
        $icms_pICMSST->setSize('100%');
        $ipi_aliquota->setSize('100%');
        $pis_aliquota->setSize('100%');
        $icms_aliquota->setSize('100%');
        $cst_cofins_id->setSize('100%');
        $icms_pFCPSTRet->setSize('100%');
        $obs_padrao->setSize('100%', 110);
        $icms_pRedBCEfet->setSize('100%');
        $cofins_aliquota->setSize('100%');
        $bhelper_62064ec6b7189->setSize('10');
        $bhelper_620651f246883->setSize('10');
        $bhelper_6206523eb5525->setSize('10');
        $bhelper_620655aadf402->setSize('10');
        $bhelper_6206543f29756->setSize('10');
        $bhelper_62065472876b1->setSize('10');
        $bhelper_620654fb52ca0->setSize('10');
        $bhelper_6206560a096b8->setSize('10');
        $notafiscal_item_modbc_id->setSize('100%');
        $ipi_codigo_enquadramento->setSize('100%');
        $cst_icms_nao_contribuinte_id->setSize('100%');
        $natureza_operacao_finalidade_id->setSize('100%');


        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Finalidade:", '#ff0000', '14px', null, '100%'),$natureza_operacao_finalidade_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Observações Padrão para notas desta operação:", null, '14px', null, '100%'),$obs_padrao]);
        $row3->layout = [' col-sm-12'];

        $bcontainer_63779aa55abd2 = new BContainer('bcontainer_63779aa55abd2');
        $this->bcontainer_63779aa55abd2 = $bcontainer_63779aa55abd2;

        $bcontainer_63779aa55abd2->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_63779aa55abd2->setBorderColor('#c0c0c0');

        $row4 = $bcontainer_63779aa55abd2->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row4->layout = ['col-sm-2','col-sm-4','col-sm-2','col-sm-4'];

        $row5 = $this->form->addFields([$bcontainer_63779aa55abd2]);
        $row5->layout = [' col-sm-12'];

        $this->form->appendPage("ICMS");
        $row6 = $this->form->addFields([new TLabel("CST ICMS (Contribuinte):", '#ff0000', '14px', null, '100%'),$cst_icms_id],[new TLabel("CST ICMS (Não-Contribuinte):", '#FF0000', '14px', null, '100%'),$cst_icms_nao_contribuinte_id]);
        $row6->layout = [' col-sm-6',' col-sm-6'];

        $row7 = $this->form->addFields([new TLabel("CFOP dentro do estado:", '#ff0000', '14px', null, '100%'),$cfop],[new TLabel("CFOP fora do estado:", '#FF0000', '14px', null, '100%'),$cfop_fora]);
        $row7->layout = [' col-sm-6',' col-sm-6'];

        $row8 = $this->form->addFields([new TLabel("Alíq. Aplic. de Cálculo do Crédito :", null, '14px', null),$bhelper_62064ec6b7189,$icms_pCredSN],[new TLabel("Aliquota ICMS:", null, '14px', null),$bhelper_620651f246883,$icms_aliquota],[new TLabel("Base ICMS:", null, '14px', null),$bhelper_6206523eb5525,$icms_base]);
        $row8->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row9 = $this->form->addFields([new TLabel("Modalid. de Determ. da BC ICMS:", null, '14px', null),$bhelper_620655aadf402,$notafiscal_item_modbc_id]);
        $row9->layout = [' col-sm-12'];

        $row10 = $this->form->addContent([new TFormSeparator("Substituição Tributária", '#333', '18', '#eee')]);
        $row11 = $this->form->addFields([new TLabel("Alíquota ICMS ST:", null, '14px', null),$bhelper_6206543f29756,$icms_pICMSST],[new TLabel("Base de Cálculo ICMS ST:", null, '14px', null),$bhelper_62065472876b1,$icms_baseST],[new TLabel("Margem Adic.ICMS:", null, '14px', null),$bhelper_620654fb52ca0,$icms_pMVAST]);
        $row11->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row12 = $this->form->addContent([new TFormSeparator("Substituição tributária retida anteriormente", '#333', '18', '#eee')]);
        $row13 = $this->form->addFields([new TLabel("Alíquota FCP ICMS-ST :", null, '14px', null),$bhelper_6206560a096b8,$icms_pFCPST],[new TLabel("Alíquota ICMS Retido (CST 500):", null, '14px', null),$icms_pFCPSTRet],[new TLabel("Base de Cálculo ICMS Retido (CST 500):", null, '14px', null),$icms_pRedBCEfet]);
        $row13->layout = ['col-sm-4',' col-sm-4',' col-sm-4'];

        $this->form->appendPage("IPI");
        $row14 = $this->form->addFields([new TLabel("CST IPI:", '#ff0000', '14px', null, '100%'),$cst_ipi_id]);
        $row14->layout = [' col-sm-12'];

        $row15 = $this->form->addFields([new TLabel("Aliquota IPI:", null, '14px', null, '100%'),$ipi_aliquota],[new TLabel("Código Enquadramento:", null, '14px', null, '100%'),$ipi_codigo_enquadramento]);
        $row15->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("PIS");
        $row16 = $this->form->addFields([new TLabel("CST PIS:", '#ff0000', '14px', null, '100%'),$cst_pis_id]);
        $row16->layout = [' col-sm-12'];

        $row17 = $this->form->addFields([new TLabel("Aliquota PIS:", null, '14px', null, '100%'),$pis_aliquota],[new TLabel("Base PIS:", null, '14px', null, '100%'),$pis_base]);
        $row17->layout = ['col-sm-6','col-sm-6'];

        $this->form->appendPage("COFINS");
        $row18 = $this->form->addFields([new TLabel("CST COFINS:", '#ff0000', '14px', null, '100%'),$cst_cofins_id]);
        $row18->layout = [' col-sm-12'];

        $row19 = $this->form->addFields([new TLabel("Aliquota Cofins:", null, '14px', null, '100%'),$cofins_aliquota],[new TLabel("Base Cofins:", null, '14px', null, '100%'),$cofins_base]);
        $row19->layout = ['col-sm-6','col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['NaturezaOperacaoHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","Cadastro de natureza operacao"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new NaturezaOperacao(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('NaturezaOperacaoHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new NaturezaOperacao($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

