<?php

class NotafiscalConsumidorFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Notafiscal';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Notafiscal';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $notafiscal = new Notafiscal($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Nota Fiscal");

        $transformed_notafiscal_data_hora_envio = call_user_func(function($value, $object, $row)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        }, $notafiscal->data_hora_envio, $notafiscal, null);

        $criteria_tdbarrowstep2 = new TCriteria();

        $filterVar = TRUE;
        $criteria_tdbarrowstep2->add(new TFilter('exibir', '=', $filterVar)); 

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'NotafiscalSituacao', 'id', '{descricao}','ordem asc' , $criteria_tdbarrowstep2);
        $lbid = new TLabel("Id:", '', '15px', 'B', '100%');
        $txid = new TTextDisplay($notafiscal->id, '', '15px', '');
        $lbnumero = new TLabel("Número:", '', '15px', 'B', '100%');
        $txnumero = new TTextDisplay($notafiscal->numero, '', '15px', '');
        $lbvendaid = new TLabel("Venda:", '', '15px', 'B', '100%');
        $txvendaid = new TTextDisplay($notafiscal->venda_id, '', '15px', '');
        $lbtipoambiente = new TLabel("Tipo Ambiente:", '', '15px', 'B', '100%');
        $txtipoambiente = new TTextDisplay($notafiscal->notafiscal_tpamb->descricao, '', '15px', '');
        $lbdataemissao = new TLabel("Data Emissão:", '', '15px', 'B', '100%');
        $txdataemissao = new TTextDisplay(TDateTime::convertToMask($notafiscal->data_emissao, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbdatasaida = new TLabel("Data Saída:", '', '15px', 'B', '100%');
        $txdatasaida = new TTextDisplay(TDateTime::convertToMask($notafiscal->data_saida, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbtipodocumento = new TLabel("Tipo de documento:", '', '15px', 'B', '100%');
        $txtipodocumento = new TTextDisplay($notafiscal->nf_tipodocumento->descricao, '', '15px', '');
        $lbmodelo = new TLabel("Modelo:", '', '15px', 'B', '100%');
        $txmodelo = new TTextDisplay($notafiscal->notafiscal_mod->modelo, '', '15px', '');
        $lbserie = new TLabel("Série:", '', '15px', 'B', '100%');
        $txserie = new TTextDisplay($notafiscal->serie, '', '15px', '');
        $lbnaturezaoperacao = new TLabel("Natureza de Operação:", '', '15px', 'B', '100%');
        $naturezaaa = new TTextDisplay($notafiscal->natureza_operacao->descricao, '', '12px', '');
        $label94 = new TLabel("CRT (Código de Regime Tributário):", '', '15px', 'B', '100%');
        $txtcrt = new TTextDisplay($notafiscal->notafiscal_crt->descricao, '', '15px', '');
        $label4545 = new TLabel("Destino da Operação:", '', '15px', 'B', '100%');
        $text3915 = new TTextDisplay($notafiscal->notafiscal_iddest_id, '', '15px', '');
        $lbfinalidade = new TLabel("Finalidade:", '', '15px', 'B', '100%');
        $txfinalidade = new TTextDisplay($notafiscal->notafiscal_finnfe->descricao, '', '15px', '');
        $lbconsumidorfinal = new TLabel("Consumidor final:", '', '15px', 'B', '100%');
        $txconsumidorfinal = new TTextDisplay($notafiscal->notafiscal_indfinal->descricao, '', '15px', '');
        $lbpresenca = new TLabel("Presença:", '', '15px', 'B', '100%');
        $txpresenca = new TTextDisplay($notafiscal->notafiscal_indpres->descricao, '', '15px', '');
        $lbtipoemissao = new TLabel("Tipo de Emissão:", '', '15px', 'B', '100%');
        $txtipoemissao = new TTextDisplay($notafiscal->notafiscal_tpemis->descricao, '', '15px', '');
        $label656 = new TLabel("Tipo de Impressão:", '', '15px', 'B', '100%');
        $txttpimp = new TTextDisplay($notafiscal->notafiscal_tpimp->descricao, '', '15px', '');
        $lbrodape = new TLabel("Informações Complementares:", '', '15px', 'B', '100%');
        $txinfcpl = new TTextDisplay($notafiscal->infcpl, '', '15px', '');
        $lbinformacoesadfisco = new TLabel("Informações adicionais do fisco:", '', '15px', 'B', '100%');
        $txinfoadfisco = new TTextDisplay($notafiscal->infadfisco, '', '15px', '');
        $label340 = new TLabel("Nome:", '', '15px', 'B', '100%');
        $text43 = new TTextDisplay($notafiscal->cliente_nome, '', '15px', '');
        $label36 = new TLabel("CPF/CNPJ:", '', '15px', 'B', '100%');
        $text44 = new TTextDisplay($notafiscal->cliente_cpfcnpj, '', '15px', '');
        $label38 = new TLabel("Inscrição Estadual:", '', '15px', 'B', '100%');
        $text45 = new TTextDisplay($notafiscal->cliente_inscest, '', '15px', '');
        $label40 = new TLabel("Inscrição Municipal:", '', '15px', 'B', '100%');
        $text46 = new TTextDisplay($notafiscal->cliente_inscmuni, '', '15px', '');
        $label42 = new TLabel("Telefone:", '', '15px', 'B', '100%');
        $text47 = new TTextDisplay($notafiscal->cliente_fone, '', '15px', '');
        $lbindicadordaiedodestinatario = new TLabel("Indicador da IE do Destinatário", '', '15px', 'B', '100%');
        $txindicadordaiedodestinatario = new TTextDisplay($notafiscal->notafiscal_indiedest->descricao, '', '15px', '');
        $label44 = new TLabel("Suframa:", '', '15px', 'B', '100%');
        $text49 = new TTextDisplay($notafiscal->cliente_suframa, '', '15px', '');
        $label320 = new TLabel("CEP:", '', '15px', 'B', '100%');
        $text41 = new TTextDisplay($notafiscal->cliente_cep, '', '15px', '');
        $label180 = new TLabel("Endereço:", '', '15px', 'B', '100%');
        $text36 = new TTextDisplay($notafiscal->cliente_endereco, '', '15px', '');
        $label2000 = new TLabel("Número:", '', '15px', 'B', '100%');
        $text38 = new TTextDisplay($notafiscal->cliente_numero, '', '15px', '');
        $label220 = new TLabel("Complemento:", '', '15px', 'B', '100%');
        $text37 = new TTextDisplay($notafiscal->cliente_complemento, '', '15px', '');
        $label240 = new TLabel("Bairro:", '', '15px', 'B', '100%');
        $text39 = new TTextDisplay($notafiscal->cliente_bairro, '', '15px', '');
        $label260 = new TLabel("Cidade:", '', '15px', 'B', '100%');
        $text40 = new TTextDisplay($notafiscal->cliente_cidade, '', '15px', '');
        $label300 = new TLabel("Código IBGE:", '', '15px', 'B', '100%');
        $text48 = new TTextDisplay($notafiscal->cliente_cidade_codibge, '', '15px', '');
        $label280 = new TLabel("Estado:", '', '15px', 'B', '100%');
        $text42 = new TTextDisplay($notafiscal->cliente_estado, '', '15px', '');
        $label1612 = new TLabel("Pagamento:", '', '12px', 'B', '100%');
        $txtindpag = new TTextDisplay($notafiscal->notafiscal_indpag->descricao, '', '12px', '');
        $label68 = new TLabel("Base de cálculo do ICMS:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(number_format((double)$notafiscal->icms_basecalc, '2', ',', '.'), '', '15px', '');
        $label70 = new TLabel("Total do ICMS:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay(number_format((double)$notafiscal->icms_valor, '2', ',', '.'), '', '15px', '');
        $label72 = new TLabel("Base de cálculo do ICMS ST:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($notafiscal->icms_subst_base_calc, '', '15px', '');
        $label74 = new TLabel("ICMS Subs Valor:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(number_format((double)$notafiscal->icms_subst_valor, '2', ',', '.'), '', '15px', '');
        $label76 = new TLabel("Total do Frete:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay(number_format((double)$notafiscal->frete_valor, '2', ',', '.'), '', '15px', '');
        $label78 = new TLabel("Total do Seguro:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(number_format((double)$notafiscal->seguro_valor, '2', ',', '.'), '', '15px', '');
        $label82 = new TLabel("Total IPI:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay(number_format((double)$notafiscal->ipi_valor, '2', ',', '.'), '', '15px', '');
        $label91 = new TLabel("Total Desconto:", '', '15px', 'B', '100%');
        $text121 = new TTextDisplay($notafiscal->desconto_valor, '', '15px', '');
        $label80 = new TLabel("Outras Despesas:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(number_format((double)$notafiscal->outras_despesas, '2', ',', '.'), '', '15px', '');
        $label111 = new TLabel("Total IPI Devolvido:", '', '15px', 'B', '100%');
        $text141 = new TTextDisplay($notafiscal->ipi_vipidevol, '', '15px', '');
        $label95 = new TLabel("COFINS:", '', '15px', 'B', '100%');
        $text125 = new TTextDisplay($notafiscal->cofins_valor, '', '15px', '');
        $label93 = new TLabel("PIS:", '', '15px', 'B', '100%');
        $text123 = new TTextDisplay($notafiscal->pis_valor, '', '15px', '');
        $label84 = new TLabel("Total Produtos:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(number_format((double)$notafiscal->valor_total_produtos, '2', ',', '.'), '', '15px', '');
        $label86 = new TLabel("Total Nota:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(number_format((double)$notafiscal->valor_total_nota, '2', ',', '.'), '', '15px', '');
        $label103 = new TLabel("Troco:", '', '15px', 'B', '100%');
        $text133 = new TTextDisplay($notafiscal->vtroco, '', '15px', '');
        $label105 = new TLabel("FCP:", '', '15px', 'B', '100%');
        $text135 = new TTextDisplay($notafiscal->icms_vfcp, '', '15px', '');
        $label107 = new TLabel("FCP ST:", '', '15px', 'B', '100%');
        $text137 = new TTextDisplay($notafiscal->icms_vfcpst, '', '15px', '');
        $label109 = new TLabel("FCP ST Retido:", '', '15px', 'B', '100%');
        $text139 = new TTextDisplay($notafiscal->icms_vfcpstret, '', '15px', '');
        $label101 = new TLabel("FCP Destino:", '', '15px', 'B', '100%');
        $text131 = new TTextDisplay($notafiscal->vfcpufdest, '', '15px', '');
        $label97 = new TLabel("ICMS Interestadual Destino:", '', '15px', 'B', '100%');
        $text127 = new TTextDisplay($notafiscal->vicmsufdest, '', '15px', '');
        $label99 = new TLabel("ICMS Inter Emitente:", '', '15px', 'B', '100%');
        $text129 = new TTextDisplay($notafiscal->vicmsufremet, '', '15px', '');
        $label113 = new TLabel("Total Serviço:", '', '15px', 'B', '100%');
        $text143 = new TTextDisplay($notafiscal->issqn_vserv, '', '15px', '');
        $label115 = new TLabel("Base:", '', '15px', 'B', '100%');
        $text145 = new TTextDisplay($notafiscal->issqn_vbc, '', '15px', '');
        $label117 = new TLabel("ISS:", '', '15px', 'B', '100%');
        $text147 = new TTextDisplay($notafiscal->issqn_viss, '', '15px', '');
        $label119 = new TLabel("Competência:", '', '15px', 'B', '100%');
        $datetext1 = new TTextDisplay(TDate::convertToMask($notafiscal->issqn_dcompet, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label121 = new TLabel("REF Trib:", '', '15px', 'B', '100%');
        $text151 = new TTextDisplay($notafiscal->issqn_reftrib, '', '15px', '');
        $lbstatus = new TLabel("Status SEFAZ:", '', '15px', 'B', '100%');
        $txstatus = new TTextDisplay($notafiscal->status, '', '15px', '');
        $lbcodigosefaz = new TLabel("Código SEFAZ:", '', '15px', 'B', '100%');
        $txcodigosefaz = new TTextDisplay($notafiscal->codigo_sefaz, '', '15px', '');
        $lbmensagem = new TLabel("Mensagem:", '', '15px', 'B', '100%');
        $txmensagem = new TTextDisplay($notafiscal->mensagem, '', '15px', '');
        $label71 = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $text103 = new TTextDisplay($notafiscal->protocolo_envio, '', '15px', '');
        $label2 = new TLabel("Data e hora envio:", '', '15px', 'B', '100%');
        $text33 = new TTextDisplay($transformed_notafiscal_data_hora_envio, '', '15px', '');
        $label73 = new TLabel("Chave:", '', '15px', 'B', '100%');
        $text105 = new TTextDisplay($notafiscal->chave, '', '15px', '');
        $label77 = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $text109 = new TTextDisplay($notafiscal->protocolo_cancelamento, '', '15px', '');
        $label79 = new TLabel("Data e hora:", '', '15px', 'B', '100%');
        $datetimetext4 = new TTextDisplay(TDateTime::convertToMask($notafiscal->datahora_cancelamento, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label81 = new TLabel("Justificativa:", '', '15px', 'B', '100%');
        $text111 = new TTextDisplay($notafiscal->justificativa_cancelamento, '', '15px', '');
        $label83 = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $text113 = new TTextDisplay($notafiscal->cce_protocolo, '', '15px', '');
        $label85 = new TLabel("Data e hora:", '', '15px', 'B', '100%');
        $datetimetext6 = new TTextDisplay(TDateTime::convertToMask($notafiscal->cce_datahora_evento, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label87 = new TLabel("Sequencial:", '', '15px', 'B', '100%');
        $text117 = new TTextDisplay($notafiscal->cce_sequencial, '', '15px', '');
        $label89 = new TLabel("Correção:", '', '15px', 'B', '100%');
        $text119 = new TTextDisplay($notafiscal->cce_correcao, '', '15px', '');

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($notafiscal->notafiscal_situacao_id);

        $this->form->appendPage("Geral");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$lbid,$txid],[$lbnumero,$txnumero],[$lbvendaid,$txvendaid]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([$lbtipoambiente,$txtipoambiente],[$lbdataemissao,$txdataemissao],[$lbdatasaida,$txdatasaida]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([$lbtipodocumento,$txtipodocumento],[$lbmodelo,$txmodelo],[$lbserie,$txserie]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$lbnaturezaoperacao,$naturezaaa],[$label94,$txtcrt],[$label4545,$text3915]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addFields([$lbfinalidade,$txfinalidade],[$lbconsumidorfinal,$txconsumidorfinal],[$lbpresenca,$txpresenca]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->form->addFields([$lbtipoemissao,$txtipoemissao],[$label656,$txttpimp]);
        $row7->layout = [' col-sm-4','col-sm-3'];

        $row8 = $this->form->addFields([$lbrodape,$txinfcpl],[$lbinformacoesadfisco,$txinfoadfisco]);
        $row8->layout = [' col-sm-6',' col-sm-6'];

        $this->form->appendPage("Cliente");
        $row9 = $this->form->addFields([$label340,$text43],[$label36,$text44]);
        $row9->layout = [' col-sm-8',' col-sm-4'];

        $row10 = $this->form->addFields([$label38,$text45],[$label40,$text46],[$label42,$text47]);
        $row10->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row11 = $this->form->addFields([$lbindicadordaiedodestinatario,$txindicadordaiedodestinatario],[$label44,$text49]);
        $row11->layout = [' col-sm-4',' col-sm-4'];

        $row12 = $this->form->addContent([new TFormSeparator("Endereço", '#333', '18', '#eee')]);
        $row13 = $this->form->addFields([$label320,$text41],[$label180,$text36],[$label2000,$text38],[$label220,$text37]);
        $row13->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row14 = $this->form->addFields([$label240,$text39],[$label260,$text40],[$label300,$text48],[$label280,$text42]);
        $row14->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $this->form->appendPage("Produtos");

        $this->notafiscal_itens_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_itens_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_itens_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_itens_notafiscal_id_list->disableDefaultClick();

        $action_onShow = new TDataGridAction(array('NotafiscalItensFormView', 'onShow'));
        $action_onShow->setUseButton(true);
        $action_onShow->setButtonClass('btn btn-default btn-sm');
        $action_onShow->setLabel("Detalhe");
        $action_onShow->setImage('fas:arrow-right #000000');
        $action_onShow->setField('id');

        $action_onShow->setParameter('key', '{id}');
        $this->notafiscal_itens_notafiscal_id_list->addAction($action_onShow);

        $column_cprod = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Código", 'cprod', 'left');
        $column_xprod = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Produto", 'xprod', 'left');
        $column_ucom = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Unidade", 'ucom', 'left');
        $column_qcom = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Quantidade", 'qcom', 'left');
        $column_vuncom_transformed = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Valor Unitário", 'vuncom', 'left');
        $column_vprod_transformed = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Valor Total", 'vprod', 'left');
        $column_cfop = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Cfop", 'cfop', 'left');
        $column_vdesc = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Desconto", 'vdesc', 'left');

        $column_vuncom_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_vprod_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->notafiscal_itens_notafiscal_id_list->createModel();

        $criteria_notafiscal_itens_notafiscal_id = new TCriteria();
        $criteria_notafiscal_itens_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_itens_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_itens_notafiscal_id_items = NotafiscalItens::getObjects($criteria_notafiscal_itens_notafiscal_id);

        $this->notafiscal_itens_notafiscal_id_list->addItems($notafiscal_itens_notafiscal_id_items);

        $icon = new TImage('fas:box #000000');
        $title = new TTextDisplay("{$icon} Itens da Nota", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add(new BootstrapDatagridWrapper($this->notafiscal_itens_notafiscal_id_list));
        $panel->add($tableResponsiveDiv);

        $this->form->addContent([$panel]);

        $this->form->appendPage("Pagamento");
        $row15 = $this->form->addFields([$label1612,$txtindpag]);
        $row15->layout = [' col-sm-12'];

        $this->notafiscal_pag_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_pag_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_pag_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_pag_notafiscal_id_list->disableDefaultClick();

        $column_notafiscal_tpag_descricao = $this->notafiscal_pag_notafiscal_id_list->addQuickColumn("Tipo", 'notafiscal_tpag->descricao', 'left');
        $column_vpag_transformed = $this->notafiscal_pag_notafiscal_id_list->addQuickColumn("Valor", 'vpag', 'left');
        $column_xpag = $this->notafiscal_pag_notafiscal_id_list->addQuickColumn("Descrição meio pgto (99-Outros)", 'xpag', 'left');

        $column_vpag_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->notafiscal_pag_notafiscal_id_list->createModel();

        $criteria_notafiscal_pag_notafiscal_id = new TCriteria();
        $criteria_notafiscal_pag_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_pag_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_pag_notafiscal_id_items = NotafiscalPag::getObjects($criteria_notafiscal_pag_notafiscal_id);

        $this->notafiscal_pag_notafiscal_id_list->addItems($notafiscal_pag_notafiscal_id_items);

        $icon = new TImage('fas:calculator #000000');
        $title = new TTextDisplay("{$icon} Pagamento", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add(new BootstrapDatagridWrapper($this->notafiscal_pag_notafiscal_id_list));
        $panel->add($tableResponsiveDiv);

        $this->form->addContent([$panel]);

        $this->form->appendPage("Pessoas autorizadas a acessar o XML da NF-e");

        $this->notafiscal_autxml_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_autxml_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_autxml_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_autxml_notafiscal_id_list->disableDefaultClick();

        $column_cpf_cnpj = $this->notafiscal_autxml_notafiscal_id_list->addQuickColumn("CPF/CNPJ", 'cpf_cnpj', 'left');

        $this->notafiscal_autxml_notafiscal_id_list->createModel();

        $criteria_notafiscal_autxml_notafiscal_id = new TCriteria();
        $criteria_notafiscal_autxml_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_autxml_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_autxml_notafiscal_id_items = NotafiscalAutxml::getObjects($criteria_notafiscal_autxml_notafiscal_id);

        $this->notafiscal_autxml_notafiscal_id_list->addItems($notafiscal_autxml_notafiscal_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->notafiscal_autxml_notafiscal_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Totais");
        $row16 = $this->form->addFields([$label68,$text12],[$label70,$text13],[$label72,$text14],[$label74,$text15]);
        $row16->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row17 = $this->form->addFields([$label76,$text16],[$label78,$text17],[$label82,$text19],[$label91,$text121]);
        $row17->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row18 = $this->form->addFields([$label80,$text18],[$label111,$text141],[$label95,$text125],[$label93,$text123]);
        $row18->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row19 = $this->form->addFields([$label84,$text21],[$label86,$text22],[$label103,$text133]);
        $row19->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row20 = $this->form->addFields([$label105,$text135],[$label107,$text137],[$label109,$text139],[$label101,$text131]);
        $row20->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row21 = $this->form->addFields([$label97,$text127],[$label99,$text129]);
        $row21->layout = [' col-sm-3',' col-sm-3'];

        $row22 = $this->form->addContent([new TFormSeparator("ISSQN", '#333', '18', '#eee')]);
        $row23 = $this->form->addFields([$label113,$text143],[$label115,$text145],[$label117,$text147],[$label119,$datetext1],[$label121,$text151]);
        $row23->layout = [' col-sm-2',' col-sm-2',' col-sm-2',' col-sm-3',' col-sm-3'];

        $this->form->appendPage("Eventos SEFAZ");
        $row24 = $this->form->addFields([$lbstatus,$txstatus],[$lbcodigosefaz,$txcodigosefaz],[$lbmensagem,$txmensagem]);
        $row24->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row25 = $this->form->addContent([new TFormSeparator("Envio", '#333', '18', '#eee')]);
        $row26 = $this->form->addFields([$label71,$text103],[$label2,$text33],[$label73,$text105]);
        $row26->layout = [' col-sm-3',' col-sm-3',' col-sm-6'];

        $row27 = $this->form->addContent([new TFormSeparator("Cancelamento", '#333', '18', '#eee')]);
        $row28 = $this->form->addFields([$label77,$text109],[$label79,$datetimetext4],[$label81,$text111]);
        $row28->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row29 = $this->form->addContent([new TFormSeparator("Carta de Correção", '#333', '18', '#eee')]);
        $row30 = $this->form->addFields([$label83,$text113],[$label85,$datetimetext6],[$label87,$text117]);
        $row30->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row31 = $this->form->addFields([$label89,$text119]);
        $row31->layout = [' col-sm-12'];

        $this->form->appendPage("Logs");

        $this->notafiscal_logs_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_logs_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_logs_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_logs_notafiscal_id_list->disableDefaultClick();

        $column_criado_em_transformed = $this->notafiscal_logs_notafiscal_id_list->addQuickColumn("Data/Hora", 'criado_em', 'left' , '20%');
        $column_system_users_name = $this->notafiscal_logs_notafiscal_id_list->addQuickColumn("Usuário", 'system_users->name', 'left' , '25%');
        $column_descricao = $this->notafiscal_logs_notafiscal_id_list->addQuickColumn("Descrição", 'descricao', 'left' , '65%');

        $column_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->notafiscal_logs_notafiscal_id_list->createModel();

        $criteria_notafiscal_logs_notafiscal_id = new TCriteria();
        $criteria_notafiscal_logs_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_logs_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_logs_notafiscal_id_items = NotafiscalLogs::getObjects($criteria_notafiscal_logs_notafiscal_id);

        $this->notafiscal_logs_notafiscal_id_list->addItems($notafiscal_logs_notafiscal_id_items);

        $icon = new TImage('far:circle #000000');
        $title = new TTextDisplay("{$icon} Logs", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->notafiscal_logs_notafiscal_id_list));

        $this->form->addContent([$panel]);

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        $btnNotafiscalConsumidorFormOnEditAction = new TAction(['NotafiscalConsumidorForm', 'onEdit'],['key'=>$notafiscal->id]);
        $btnNotafiscalConsumidorFormOnEditLabel = new TLabel("Editar ");

        $btnNotafiscalConsumidorFormOnEdit = $this->form->addHeaderAction($btnNotafiscalConsumidorFormOnEditLabel, $btnNotafiscalConsumidorFormOnEditAction, 'fas:edit #2196F3'); 
        $btnNotafiscalConsumidorFormOnEditLabel->setFontSize('12px'); 
        $btnNotafiscalConsumidorFormOnEditLabel->setFontColor('#333333'); 

        $btn_onenviarAction = new TAction([$this, 'onEnviar'],['key'=>$notafiscal->id]);
        $btn_onenviarLabel = new TLabel("Enviar");

        $btn_onenviar = $this->form->addHeaderAction($btn_onenviarLabel, $btn_onenviarAction, 'fas:check-circle #4CAF50'); 
        $btn_onenviarLabel->setFontSize('12px'); 
        $btn_onenviarLabel->setFontColor('#333333'); 

        $btn_onpdfAction = new TAction([$this, 'onPDF'],['key'=>$notafiscal->id]);
        $btn_onpdfLabel = new TLabel("PDF - DANFE");

        $btn_onpdf = $this->form->addHeaderAction($btn_onpdfLabel, $btn_onpdfAction, 'far:file-pdf #F44336'); 
        $btn_onpdfLabel->setFontSize('12px'); 
        $btn_onpdfLabel->setFontColor('#333333'); 

        $btn_onxmlAction = new TAction([$this, 'onXml'],['key'=>$notafiscal->id]);
        $btn_onxmlLabel = new TLabel("XML");

        $btn_onxml = $this->form->addHeaderAction($btn_onxmlLabel, $btn_onxmlAction, 'far:file-code #FF9800'); 
        $btn_onxmlLabel->setFontSize('12px'); 
        $btn_onxmlLabel->setFontColor('#333333'); 

        $btn_oncancelarAction = new TAction([$this, 'onCancelar'],['key'=>$notafiscal->id]);
        $btn_oncancelarLabel = new TLabel("Cancelar");

        $btn_oncancelar = $this->form->addHeaderAction($btn_oncancelarLabel, $btn_oncancelarAction, 'fas:ban #F44336'); 
        $btn_oncancelarLabel->setFontSize('12px'); 
        $btn_oncancelarLabel->setFontColor('#333333'); 

        $btn_onconsultasefazAction = new TAction([$this, 'onConsultaSefaz'],['key'=>$notafiscal->id]);
        $btn_onconsultasefazLabel = new TLabel("Consultar na SEFAZ");

        $btn_onconsultasefaz = $this->form->addHeaderAction($btn_onconsultasefazLabel, $btn_onconsultasefazAction, 'fas:search #00BCD4'); 
        $btn_onconsultasefazLabel->setFontSize('12px'); 
        $btn_onconsultasefazLabel->setFontColor('#333333'); 

        $btnNotafiscalListOnShowAction = new TAction(['NotafiscalList', 'onShow']);
        $btnNotafiscalListOnShowLabel = new TLabel("Voltar");

        $btnNotafiscalListOnShow = $this->form->addHeaderAction($btnNotafiscalListOnShowLabel, $btnNotafiscalListOnShowAction, 'fas:arrow-alt-circle-left #000000'); 
        $btnNotafiscalListOnShowLabel->setFontSize('12px'); 
        $btnNotafiscalListOnShowLabel->setFontColor('#333333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","Visualizar Nota Fiscal Consumidor"]));
        }
        $container->add($this->form);

        if(is_null($notafiscal->chave))
        {
           TScript::create('document.getElementById("tbutton_consultar_na_sefaz").style.display = "none";');
        }

        //100,103,104,105,110,302
        if (($notafiscal->codigo_sefaz == 100) or
            ($notafiscal->codigo_sefaz == 103) or
            ($notafiscal->codigo_sefaz == 104) or
            ($notafiscal->codigo_sefaz == 105) or
            ($notafiscal->codigo_sefaz == 110) or
            ($notafiscal->codigo_sefaz == 302))
        {
            TScript::create('document.getElementById("tbutton_enviar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_editar_").style.display = "none";');
        }

        if($notafiscal->codigo_sefaz != 100)
        {
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_carta_de_correção").style.display = "none";');
        }  

        if($notafiscal->sn_carta_correcao == 'N')
        {
            TScript::create('document.getElementById("tbutton_pdf_-_carta_de_correÇÃo").style.display = "none";');
        }

        TTransaction::close();
        parent::add($container);

    }

    public static function onEnviar($param = null) 
    {
        try 
        {
            new TQuestion("Enviar Nota Fiscal?", new TAction([__CLASS__, 'onEnviarYes'], $param), new TAction([__CLASS__, 'onEnviarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onPDF($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota)
            {
                 $arquivo = cloudDFE_NFE::pdfNFCe($nota->chave); 

                 if(file_exists($arquivo)){
                        parent::openFile($arquivo);            
                 }else{
                     throw new Exception('DANFE PDF não encontrado!');
                 }
            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onXml($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota)
            {

                if ($nota->movimentacao_origem_id==MovimentacaoOrigem::kraftweb)
                {
                  $arquivo = cloudDFE_NFE::xmlNFE($nota->chave); 
                }
                else
                {
                    $bin = base64_decode($nota->xml , true);

                    $document = 'tmp/'.$nota->chave.'.xml';

                    file_put_contents($document, $bin);                    

                    $arquivo = $document;
                }

                 if(file_exists($arquivo)){
                        parent::openFile($arquivo);            
                 }else{
                     throw new Exception('Arquivo XML não encontrado!');
                 }
            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onCancelar($param = null) 
    {
        try 
        {
            $pageParam = ['id' => $param['key']]; // ex.: = ['key' => 10]
            TApplication::loadPage('CancelementoNotaForm', 'onShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onConsultaSefaz($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota)
            {
                cloudDFE_NFE::consultaNFE($nota->chave); 
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $nota->id]);

            TToast::show('success', "Consulta realizada com sucesso!", 'topRight', 'far:check-circle');

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onEnviarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota)
            {

                    $retorno =  cloudDFE_NFE::criarNfce($nota);   

                     if ($retorno->codigo != 100)     
                     {
                         new TMessage('info', 'Retorno da SEFAZ: '."\n".cloudDFE_NFE::formataRetorno($retorno));                     
                     }
                     else
                     {
                         TApplication::loadPage(__CLASS__, 'onShow', ['key' => $nota->id]);

                         TToast::show('success', "Documento enviado com sucesso!", 'topRight', 'far:check-circle');
                     }

            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEnviarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

