<?php

class NotafiscalForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Notafiscal';
    private static $primaryKey = 'id';
    private static $formName = 'form_NotafiscalForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Nota Fiscal");

        $criteria_notafiscal_situacao_id = new TCriteria();

        $filterVar = TRUE;
        $criteria_notafiscal_situacao_id->add(new TFilter('exibir', '=', $filterVar)); 

        TSession::setValue('nota_fiscal_id', null);

        $notafiscal_situacao_id = new TDBArrowStep('notafiscal_situacao_id', 'kraftsoft', 'NotafiscalSituacao', 'id', '{descricao}','ordem asc' , $criteria_notafiscal_situacao_id );
        $id = new TEntry('id');
        $numero = new TEntry('numero');
        $venda_id = new TEntry('venda_id');
        $notafiscal_tpamb_id = new TDBCombo('notafiscal_tpamb_id', 'kraftsoft', 'NotafiscalTpamb', 'id', '{descricao}','descricao asc'  );
        $data_emissao = new TDateTime('data_emissao');
        $data_saida = new TDateTime('data_saida');
        $nf_tipodocumento_id = new TDBCombo('nf_tipodocumento_id', 'kraftsoft', 'NotafiscalTipodocumento', 'id', '{descricao}','descricao asc'  );
        $notafiscal_mod_id = new TDBCombo('notafiscal_mod_id', 'kraftsoft', 'NotafiscalMod', 'id', '{descricao}','descricao asc'  );
        $serie = new TCombo('serie');
        $natureza_operacao_id = new TDBCombo('natureza_operacao_id', 'kraftsoft', 'NaturezaOperacao', 'id', '{descricao}','descricao asc'  );
        $notafiscal_crt_id = new TDBCombo('notafiscal_crt_id', 'kraftsoft', 'NotafiscalCrt', 'id', '{descricao}','descricao asc'  );
        $notafiscal_iddest_id = new TDBCombo('notafiscal_iddest_id', 'kraftsoft', 'NotafiscalIddest', 'id', '{descricao}','descricao asc'  );
        $notafiscal_finnfe_id = new TDBCombo('notafiscal_finnfe_id', 'kraftsoft', 'NotafiscalFinnfe', 'id', '{descricao}','descricao asc'  );
        $notafiscal_indfinal_id = new TDBCombo('notafiscal_indfinal_id', 'kraftsoft', 'NotafiscalIndfinal', 'id', '{descricao}','descricao asc'  );
        $notafiscal_indpres_id = new TDBCombo('notafiscal_indpres_id', 'kraftsoft', 'NotafiscalIndpres', 'id', '{descricao}','descricao asc'  );
        $notafiscal_tpemis_id = new TDBCombo('notafiscal_tpemis_id', 'kraftsoft', 'NotafiscalTpemis', 'id', '{descricao}','descricao asc'  );
        $notafiscal_tpimp_id = new TDBCombo('notafiscal_tpimp_id', 'kraftsoft', 'NotafiscalTpimp', 'id', '{descricao}','descricao asc'  );
        $infcpl = new TText('infcpl');
        $infadfisco = new TText('infadfisco');
        $contingencia_data = new TDateTime('contingencia_data');
        $contingencia_motivo = new TEntry('contingencia_motivo');
        $movimentacao_origem_id = new THidden('movimentacao_origem_id');
        $cliente_id = new TSeekButton('cliente_id');
        $cliente_nome = new TEntry('cliente_nome');
        $cliente_cpfcnpj = new TEntry('cliente_cpfcnpj');
        $cliente_inscest = new TEntry('cliente_inscest');
        $cliente_inscmuni = new TEntry('cliente_inscmuni');
        $cliente_fone = new TEntry('cliente_fone');
        $notafiscal_indiedest_id = new TDBCombo('notafiscal_indiedest_id', 'kraftsoft', 'NotafiscalIndiedest', 'id', '{descricao}','descricao asc'  );
        $cliente_suframa = new TEntry('cliente_suframa');
        $cliente_cep = new TEntry('cliente_cep');
        $button_ = new TButton('button_');
        $cliente_endereco = new TEntry('cliente_endereco');
        $cliente_numero = new TEntry('cliente_numero');
        $cliente_bairro = new TEntry('cliente_bairro');
        $cliente_cidade = new TEntry('cliente_cidade');
        $cliente_cidade_codibge = new TEntry('cliente_cidade_codibge');
        $cliente_estado = new TEntry('cliente_estado');
        $cliente_complemento = new TEntry('cliente_complemento');
        $cliente_xpais = new TEntry('cliente_xpais');
        $cliente_cpais = new TEntry('cliente_cpais');
        $button_novo_item = new TButton('button_novo_item');
        $lista_items = new BPageContainer();
        $notafiscal_modfrete_id = new TDBCombo('notafiscal_modfrete_id', 'kraftsoft', 'NotafiscalModfrete', 'id', '{descricao}','descricao asc'  );
        $transp_nome = new TEntry('transp_nome');
        $transp_cnpj = new TEntry('transp_cnpj');
        $transp_inscest = new TEntry('transp_inscest');
        $transp_endereco = new TEntry('transp_endereco');
        $transp_cidade = new TEntry('transp_cidade');
        $transp_uf = new TEntry('transp_uf');
        $transp_placaveiculo = new TEntry('transp_placaveiculo');
        $transp_veiculouf = new TEntry('transp_veiculouf');
        $transp_veiculoRNTC = new TEntry('transp_veiculoRNTC');
        $notafiscal_frete_volumes_notafiscal_qVol = new TEntry('notafiscal_frete_volumes_notafiscal_qVol');
        $notafiscal_frete_volumes_notafiscal_id = new THidden('notafiscal_frete_volumes_notafiscal_id');
        $notafiscal_frete_volumes_notafiscal_nVol = new TEntry('notafiscal_frete_volumes_notafiscal_nVol');
        $notafiscal_frete_volumes_notafiscal_esp = new TEntry('notafiscal_frete_volumes_notafiscal_esp');
        $notafiscal_frete_volumes_notafiscal_marca = new TEntry('notafiscal_frete_volumes_notafiscal_marca');
        $notafiscal_frete_volumes_notafiscal_pesol = new TNumeric('notafiscal_frete_volumes_notafiscal_pesol', '2', ',', '.' );
        $notafiscal_frete_volumes_notafiscal_pesob = new TNumeric('notafiscal_frete_volumes_notafiscal_pesob', '2', ',', '.' );
        $button_adicionar_notafiscal_frete_volumes_notafiscal = new TButton('button_adicionar_notafiscal_frete_volumes_notafiscal');
        $entrega_marcado = new TEntry('entrega_marcado');
        $cep_entrega = new TEntry('cep_entrega');
        $entrega_cpfcnpj = new TEntry('entrega_cpfcnpj');
        $entrega_xnome = new TEntry('entrega_xnome');
        $entrega_xlgr = new TEntry('entrega_xlgr');
        $entrega_nro = new TEntry('entrega_nro');
        $entrega_xcpl = new TEntry('entrega_xcpl');
        $entrega_xbairro = new TEntry('entrega_xbairro');
        $entrega_cmun = new TEntry('entrega_cmun');
        $entrega_xmun = new TEntry('entrega_xmun');
        $entrega_uf = new TEntry('entrega_uf');
        $retirada_marcado = new TEntry('retirada_marcado');
        $retirada_cpfcnpj = new TEntry('retirada_cpfcnpj');
        $cep_retirada = new TEntry('cep_retirada');
        $retirada_xlgr = new TEntry('retirada_xlgr');
        $retirada_nro = new TEntry('retirada_nro');
        $retirada_xcpl = new TEntry('retirada_xcpl');
        $retirada_xbairro = new TEntry('retirada_xbairro');
        $retirada_cmun = new TEntry('retirada_cmun');
        $retirada_xmun = new TEntry('retirada_xmun');
        $retirada_uf = new TEntry('retirada_uf');
        $exporta_ufsaidapais = new TDBCombo('exporta_ufsaidapais', 'kraftsoft', 'Estado', 'sigla', '{nome} - {sigla}','nome asc'  );
        $exporta_xlocexporta = new TEntry('exporta_xlocexporta');
        $exporta_xlocdespacho = new TEntry('exporta_xlocdespacho');
        $fatura_numero = new TEntry('fatura_numero');
        $fatura_valor_original = new TNumeric('fatura_valor_original', '2', ',', '.' );
        $fatura_valor_desconto = new TNumeric('fatura_valor_desconto', '2', ',', '.' );
        $fatura_valor_liquido = new TNumeric('fatura_valor_liquido', '2', ',', '.' );
        $notafiscal_dup_notafiscal_ndup = new TEntry('notafiscal_dup_notafiscal_ndup');
        $notafiscal_dup_notafiscal_id = new THidden('notafiscal_dup_notafiscal_id');
        $notafiscal_dup_notafiscal_vdup = new TNumeric('notafiscal_dup_notafiscal_vdup', '2', ',', '.' );
        $notafiscal_dup_notafiscal_dvenc = new TDate('notafiscal_dup_notafiscal_dvenc');
        $button_adicionar_notafiscal_dup_notafiscal = new TButton('button_adicionar_notafiscal_dup_notafiscal');
        $notafiscal_indpag_id = new TDBCombo('notafiscal_indpag_id', 'kraftsoft', 'NotafiscalIndpag', 'id', '{descricao}','descricao asc'  );
        $notafiscal_pag_notafiscal_notafiscal_tpag_id = new TDBCombo('notafiscal_pag_notafiscal_notafiscal_tpag_id', 'kraftsoft', 'NotafiscalTpag', 'id', '{tpag}  - {descricao}','tpag asc'  );
        $notafiscal_pag_notafiscal_id = new THidden('notafiscal_pag_notafiscal_id');
        $notafiscal_pag_notafiscal_vpag = new TNumeric('notafiscal_pag_notafiscal_vpag', '2', ',', '.' );
        $notafiscal_pag_notafiscal_xpag = new TEntry('notafiscal_pag_notafiscal_xpag');
        $button_adicionar_notafiscal_pag_notafiscal = new TButton('button_adicionar_notafiscal_pag_notafiscal');
        $notafiscal_refecf_notafiscal_notafiscal_refecfmod_id = new TDBCombo('notafiscal_refecf_notafiscal_notafiscal_refecfmod_id', 'kraftsoft', 'NotafiscalRefecfmod', 'id', '{descricao}','descricao asc'  );
        $notafiscal_refecf_notafiscal_id = new THidden('notafiscal_refecf_notafiscal_id');
        $notafiscal_refecf_notafiscal_necf = new TEntry('notafiscal_refecf_notafiscal_necf');
        $notafiscal_refecf_notafiscal_ncoo = new TEntry('notafiscal_refecf_notafiscal_ncoo');
        $button_adicionar_notafiscal_refecf_notafiscal = new TButton('button_adicionar_notafiscal_refecf_notafiscal');
        $notafiscal_refnfe_notafiscal_refnfe = new TEntry('notafiscal_refnfe_notafiscal_refnfe');
        $notafiscal_refnfe_notafiscal_id = new THidden('notafiscal_refnfe_notafiscal_id');
        $button_adicionar_notafiscal_refnfe_notafiscal = new TButton('button_adicionar_notafiscal_refnfe_notafiscal');
        $notafiscal_autxml_notafiscal_cpf_cnpj = new TEntry('notafiscal_autxml_notafiscal_cpf_cnpj');
        $notafiscal_autxml_notafiscal_id = new THidden('notafiscal_autxml_notafiscal_id');
        $button_adicionar_notafiscal_autxml_notafiscal = new TButton('button_adicionar_notafiscal_autxml_notafiscal');
        $icms_basecalc = new TNumeric('icms_basecalc', '2', ',', '.' );
        $icms_valor = new TNumeric('icms_valor', '2', ',', '.' );
        $icms_subst_base_calc = new TNumeric('icms_subst_base_calc', '2', ',', '.' );
        $icms_subst_valor = new TNumeric('icms_subst_valor', '2', ',', '.' );
        $frete_valor = new TNumeric('frete_valor', '2', ',', '.' );
        $seguro_valor = new TNumeric('seguro_valor', '2', ',', '.' );
        $ipi_valor = new TNumeric('ipi_valor', '2', ',', '.' );
        $desconto_valor = new TNumeric('desconto_valor', '2', ',', '.' );
        $outras_despesas = new TNumeric('outras_despesas', '2', ',', '.' );
        $ipi_vipidevol = new TNumeric('ipi_vipidevol', '2', ',', '.' );
        $cofins_valor = new TNumeric('cofins_valor', '2', ',', '.' );
        $pis_valor = new TNumeric('pis_valor', '2', ',', '.' );
        $valor_total_produtos = new TNumeric('valor_total_produtos', '2', ',', '.' );
        $valor_total_nota = new TNumeric('valor_total_nota', '2', ',', '.' );
        $vtroco = new TNumeric('vtroco', '2', ',', '.' );
        $icms_vfcp = new TNumeric('icms_vfcp', '2', ',', '.' );
        $icms_vfcpst = new TNumeric('icms_vfcpst', '2', ',', '.' );
        $icms_vfcpstret = new TNumeric('icms_vfcpstret', '2', ',', '.' );
        $vfcpufdest = new TNumeric('vfcpufdest', '2', ',', '.' );
        $vicmsufdest = new TNumeric('vicmsufdest', '2', ',', '.' );
        $vicmsufremet = new TNumeric('vicmsufremet', '2', ',', '.' );
        $issqn_vserv = new TNumeric('issqn_vserv', '2', ',', '.' );
        $issqn_vbc = new TNumeric('issqn_vbc', '2', ',', '.' );
        $issqn_viss = new TNumeric('issqn_viss', '2', ',', '.' );
        $issqn_dcompet = new TDate('issqn_dcompet');
        $issqn_reftrib = new TEntry('issqn_reftrib');
        $status = new TEntry('status');
        $codigo_sefaz = new TEntry('codigo_sefaz');
        $mensagem = new TText('mensagem');
        $protocolo_envio = new TEntry('protocolo_envio');
        $data_hora_envio = new TEntry('data_hora_envio');
        $chave = new TEntry('chave');
        $protocolo_cancelamento = new TEntry('protocolo_cancelamento');
        $datahora_cancelamento = new TDateTime('datahora_cancelamento');
        $justificativa_cancelamento = new TText('justificativa_cancelamento');
        $cce_datahora_evento = new TDateTime('cce_datahora_evento');
        $cce_sequencial = new TEntry('cce_sequencial');
        $cce_protocolo = new TEntry('cce_protocolo');
        $cce_correcao = new TEntry('cce_correcao');

        $notafiscal_tpamb_id->setChangeAction(new TAction([$this,'onChangeAmbiente']));
        $nf_tipodocumento_id->setChangeAction(new TAction([$this,'onChangeTipoDocumento']));

        $cliente_id->setExitAction(new TAction([$this,'onExitCliente']));
        $cep_entrega->setExitAction(new TAction([$this,'OnBuscaCepEntrega']));
        $cep_retirada->setExitAction(new TAction([$this,'OnBuscaCepRetirada']));

        $notafiscal_tpamb_id->addValidation("Tipo de Ambiente", new TRequiredValidator()); 
        $nf_tipodocumento_id->addValidation("Tipo de documento", new TRequiredValidator()); 
        $notafiscal_mod_id->addValidation("Modelo", new TRequiredValidator()); 
        $serie->addValidation("Série", new TRequiredValidator()); 
        $notafiscal_crt_id->addValidation("CRT (Código de Regime Tributário)", new TRequiredValidator()); 
        $notafiscal_iddest_id->addValidation("Destino da Operação", new TRequiredValidator()); 
        $notafiscal_finnfe_id->addValidation("Finalidade de Emissão", new TRequiredValidator()); 
        $notafiscal_indfinal_id->addValidation("Consumidor Final", new TRequiredValidator()); 
        $notafiscal_indpres_id->addValidation("Indicador de Presença", new TRequiredValidator()); 
        $notafiscal_tpemis_id->addValidation("Tipo de Emissão", new TRequiredValidator()); 
        $notafiscal_tpimp_id->addValidation("Tipo de Impressão", new TRequiredValidator()); 
        $cliente_id->addValidation("Cliente", new TRequiredValidator()); 
        $notafiscal_indiedest_id->addValidation("Indicador da IE do Destinatário", new TRequiredValidator()); 
        $cliente_cep->addValidation("CEP do Cliente", new TRequiredValidator()); 
        $cliente_endereco->addValidation("Endereço do Cliente", new TRequiredValidator()); 
        $cliente_numero->addValidation("Número do Cliente", new TRequiredValidator()); 
        $cliente_bairro->addValidation("Bairro do Cliente", new TRequiredValidator()); 
        $cliente_cidade->addValidation("Cidade do Cliente", new TRequiredValidator()); 
        $cliente_cidade_codibge->addValidation("Código IBGE Cidade do Cliente", new TRequiredValidator()); 
        $cliente_estado->addValidation("Estado do Cliente", new TRequiredValidator()); 
        $notafiscal_modfrete_id->addValidation("Modalidade do frete", new TRequiredValidator()); 
        $notafiscal_indpag_id->addValidation("Indicador de Pagamento", new TRequiredValidator()); 

        $notafiscal_situacao_id->setColorColumn('cor');
        $notafiscal_situacao_id->setFilledColor('#fd9308');
        $notafiscal_situacao_id->setFilledFontColor('#ffffff');
        $notafiscal_situacao_id->setUnfilledColor('#d3d3d3');
        $notafiscal_situacao_id->setUnfilledFontColor('#333333');
        $movimentacao_origem_id->setValue(MovimentacaoOrigem::kraftweb);
        $lista_items->setId('b619949a3ecfa9');
        $notafiscal_tpamb_id->enableSearch();
        $exporta_ufsaidapais->enableSearch();
        $natureza_operacao_id->enableSearch();

        $issqn_dcompet->setDatabaseMask('yyyy-mm-dd');
        $data_saida->setDatabaseMask('yyyy-mm-dd hh:ii:ss');
        $data_emissao->setDatabaseMask('yyyy-mm-dd hh:ii:ss');
        $contingencia_data->setDatabaseMask('yyyy-mm-dd hh:ii');
        $cce_datahora_evento->setDatabaseMask('yyyy-mm-dd hh:ii');
        $datahora_cancelamento->setDatabaseMask('yyyy-mm-dd hh:ii');
        $notafiscal_dup_notafiscal_dvenc->setDatabaseMask('yyyy-mm-dd');

        $button_->addStyleClass('btn-default');
        $button_novo_item->addStyleClass('btn-default');
        $button_adicionar_notafiscal_dup_notafiscal->addStyleClass('btn-default');
        $button_adicionar_notafiscal_pag_notafiscal->addStyleClass('btn-default');
        $button_adicionar_notafiscal_refecf_notafiscal->addStyleClass('btn-default');
        $button_adicionar_notafiscal_refnfe_notafiscal->addStyleClass('btn-default');
        $button_adicionar_notafiscal_autxml_notafiscal->addStyleClass('btn-default');
        $button_adicionar_notafiscal_frete_volumes_notafiscal->addStyleClass('btn-default');

        $button_->setImage('fas:search #000000');
        $button_novo_item->setImage('fas:plus #000000');
        $button_adicionar_notafiscal_dup_notafiscal->setImage('fas:plus #2ecc71');
        $button_adicionar_notafiscal_pag_notafiscal->setImage('fas:plus #2ecc71');
        $button_adicionar_notafiscal_refecf_notafiscal->setImage('fas:plus #2ecc71');
        $button_adicionar_notafiscal_refnfe_notafiscal->setImage('fas:plus #2ecc71');
        $button_adicionar_notafiscal_autxml_notafiscal->setImage('fas:plus #2ecc71');
        $button_adicionar_notafiscal_frete_volumes_notafiscal->setImage('fas:plus #2ecc71');

        $issqn_dcompet->setMask('dd/mm/yyyy');
        $data_saida->setMask('dd/mm/yyyy hh:ii');
        $cliente_cep->setMask('99999-999', true);
        $data_emissao->setMask('dd/mm/yyyy hh:ii');
        $cliente_cidade_codibge->setMask('9999999');
        $contingencia_data->setMask('dd/mm/yyyy hh:ii');
        $cce_datahora_evento->setMask('dd/mm/yyyy hh:ii');
        $datahora_cancelamento->setMask('dd/mm/yyyy hh:ii');
        $notafiscal_dup_notafiscal_dvenc->setMask('dd/mm/yyyy');

        $button_->setAction(new TAction([$this, 'onConsultaCEP']), "");
        $button_novo_item->setAction(new TAction([$this, 'onNovoItem']), "Novo Item");
        $lista_items->setAction(new TAction(['NotafiscalItensSimpleList', 'onShow']));
        $button_adicionar_notafiscal_dup_notafiscal->setAction(new TAction([$this, 'onAddDetailNotafiscalDupNotafiscal'],['static' => 1]), "Adicionar");
        $button_adicionar_notafiscal_pag_notafiscal->setAction(new TAction([$this, 'onAddDetailNotafiscalPagNotafiscal'],['static' => 1]), "Adicionar");
        $button_adicionar_notafiscal_refecf_notafiscal->setAction(new TAction([$this, 'onAddDetailNotafiscalRefecfNotafiscal'],['static' => 1]), "Adicionar");
        $button_adicionar_notafiscal_refnfe_notafiscal->setAction(new TAction([$this, 'onAddDetailNotafiscalRefnfeNotafiscal'],['static' => 1]), "Adicionar");
        $button_adicionar_notafiscal_autxml_notafiscal->setAction(new TAction([$this, 'onAddDetailNotafiscalAutxmlNotafiscal'],['static' => 1]), "Adicionar");
        $button_adicionar_notafiscal_frete_volumes_notafiscal->setAction(new TAction([$this, 'onAddDetailNotafiscalFreteVolumesNotafiscal'],['static' => 1]), "Adicionar");

        $id->setEditable(false);
        $chave->setEditable(false);
        $vtroco->setEditable(false);
        $status->setEditable(false);
        $venda_id->setEditable(false);
        $mensagem->setEditable(false);
        $ipi_valor->setEditable(false);
        $pis_valor->setEditable(false);
        $icms_vfcp->setEditable(false);
        $issqn_vbc->setEditable(false);
        $icms_valor->setEditable(false);
        $vfcpufdest->setEditable(false);
        $issqn_viss->setEditable(false);
        $frete_valor->setEditable(false);
        $icms_vfcpst->setEditable(false);
        $vicmsufdest->setEditable(false);
        $issqn_vserv->setEditable(false);
        $cliente_nome->setEditable(false);
        $seguro_valor->setEditable(false);
        $cofins_valor->setEditable(false);
        $vicmsufremet->setEditable(false);
        $codigo_sefaz->setEditable(false);
        $cce_correcao->setEditable(false);
        $icms_basecalc->setEditable(false);
        $ipi_vipidevol->setEditable(false);
        $cce_protocolo->setEditable(false);
        $desconto_valor->setEditable(false);
        $icms_vfcpstret->setEditable(false);
        $cce_sequencial->setEditable(false);
        $cliente_cpfcnpj->setEditable(false);
        $outras_despesas->setEditable(false);
        $protocolo_envio->setEditable(false);
        $data_hora_envio->setEditable(false);
        $icms_subst_valor->setEditable(false);
        $valor_total_nota->setEditable(false);
        $notafiscal_mod_id->setEditable(false);
        $cce_datahora_evento->setEditable(false);
        $icms_subst_base_calc->setEditable(false);
        $valor_total_produtos->setEditable(false);
        $datahora_cancelamento->setEditable(false);
        $notafiscal_situacao_id->setEditable(false);
        $protocolo_cancelamento->setEditable(false);
        $justificativa_cancelamento->setEditable(false);

        $id->setSize('100%');
        $serie->setSize('100%');
        $chave->setSize('100%');
        $numero->setSize('100%');
        $vtroco->setSize('100%');
        $status->setSize('100%');
        $venda_id->setSize('100%');
        $transp_uf->setSize('100%');
        $ipi_valor->setSize('100%');
        $pis_valor->setSize('100%');
        $icms_vfcp->setSize('100%');
        $issqn_vbc->setSize('100%');
        $data_saida->setSize('100%');
        $infcpl->setSize('100%', 70);
        $cliente_id->setSize('100%');
        $cliente_cep->setSize('85%');
        $entrega_uf->setSize('100%');
        $icms_valor->setSize('100%');
        $vfcpufdest->setSize('100%');
        $issqn_viss->setSize('100%');
        $lista_items->setSize('100%');
        $transp_nome->setSize('100%');
        $transp_cnpj->setSize('100%');
        $cep_entrega->setSize('100%');
        $entrega_nro->setSize('100%');
        $retirada_uf->setSize('100%');
        $frete_valor->setSize('100%');
        $icms_vfcpst->setSize('100%');
        $vicmsufdest->setSize('100%');
        $issqn_vserv->setSize('100%');
        $data_emissao->setSize('100%');
        $cliente_nome->setSize('100%');
        $cliente_fone->setSize('100%');
        $entrega_xlgr->setSize('100%');
        $entrega_xcpl->setSize('100%');
        $entrega_cmun->setSize('100%');
        $entrega_xmun->setSize('100%');
        $cep_retirada->setSize('100%');
        $retirada_nro->setSize('100%');
        $seguro_valor->setSize('100%');
        $cofins_valor->setSize('100%');
        $vicmsufremet->setSize('100%');
        $codigo_sefaz->setSize('100%');
        $mensagem->setSize('100%', 70);
        $cce_correcao->setSize('100%');
        $cliente_xpais->setSize('100%');
        $cliente_cpais->setSize('100%');
        $transp_cidade->setSize('100%');
        $entrega_xnome->setSize('100%');
        $retirada_xlgr->setSize('100%');
        $retirada_xcpl->setSize('100%');
        $retirada_cmun->setSize('100%');
        $retirada_xmun->setSize('100%');
        $fatura_numero->setSize('100%');
        $icms_basecalc->setSize('100%');
        $ipi_vipidevol->setSize('100%');
        $issqn_dcompet->setSize('100%');
        $issqn_reftrib->setSize('100%');
        $cce_protocolo->setSize('100%');
        $infadfisco->setSize('100%', 70);
        $cliente_numero->setSize('100%');
        $cliente_bairro->setSize('100%');
        $cliente_cidade->setSize('100%');
        $cliente_estado->setSize('100%');
        $transp_inscest->setSize('100%');
        $desconto_valor->setSize('100%');
        $icms_vfcpstret->setSize('100%');
        $cce_sequencial->setSize('100%');
        $cliente_cpfcnpj->setSize('100%');
        $cliente_inscest->setSize('100%');
        $cliente_suframa->setSize('100%');
        $transp_endereco->setSize('100%');
        $entrega_marcado->setSize('100%');
        $entrega_cpfcnpj->setSize('100%');
        $entrega_xbairro->setSize('100%');
        $outras_despesas->setSize('100%');
        $protocolo_envio->setSize('100%');
        $data_hora_envio->setSize('100%');
        $cliente_inscmuni->setSize('100%');
        $cliente_endereco->setSize('100%');
        $transp_veiculouf->setSize('100%');
        $retirada_marcado->setSize('100%');
        $retirada_cpfcnpj->setSize('100%');
        $retirada_xbairro->setSize('100%');
        $icms_subst_valor->setSize('100%');
        $valor_total_nota->setSize('100%');
        $notafiscal_mod_id->setSize('100%');
        $notafiscal_crt_id->setSize('100%');
        $contingencia_data->setSize('100%');
        $transp_veiculoRNTC->setSize('100%');
        $notafiscal_tpamb_id->setSize('100%');
        $nf_tipodocumento_id->setSize('100%');
        $notafiscal_tpimp_id->setSize('100%');
        $contingencia_motivo->setSize('100%');
        $movimentacao_origem_id->setSize(200);
        $cliente_complemento->setSize('100%');
        $transp_placaveiculo->setSize('100%');
        $exporta_ufsaidapais->setSize('100%');
        $exporta_xlocexporta->setSize('100%');
        $cce_datahora_evento->setSize('100%');
        $natureza_operacao_id->setSize('100%');
        $notafiscal_iddest_id->setSize('100%');
        $notafiscal_finnfe_id->setSize('100%');
        $notafiscal_tpemis_id->setSize('100%');
        $exporta_xlocdespacho->setSize('100%');
        $fatura_valor_liquido->setSize('100%');
        $notafiscal_indpag_id->setSize('100%');
        $icms_subst_base_calc->setSize('100%');
        $valor_total_produtos->setSize('100%');
        $notafiscal_indpres_id->setSize('100%');
        $fatura_valor_original->setSize('100%');
        $fatura_valor_desconto->setSize('100%');
        $datahora_cancelamento->setSize('100%');
        $notafiscal_indfinal_id->setSize('100%');
        $cliente_cidade_codibge->setSize('100%');
        $notafiscal_modfrete_id->setSize('100%');
        $protocolo_cancelamento->setSize('100%');
        $notafiscal_indiedest_id->setSize('100%');
        $notafiscal_dup_notafiscal_id->setSize(200);
        $notafiscal_pag_notafiscal_id->setSize(200);
        $notafiscal_situacao_id->setSize('100%', 55);
        $notafiscal_refecf_notafiscal_id->setSize(200);
        $notafiscal_refnfe_notafiscal_id->setSize(200);
        $notafiscal_autxml_notafiscal_id->setSize(200);
        $notafiscal_dup_notafiscal_ndup->setSize('100%');
        $notafiscal_dup_notafiscal_vdup->setSize('100%');
        $notafiscal_pag_notafiscal_vpag->setSize('100%');
        $notafiscal_pag_notafiscal_xpag->setSize('100%');
        $justificativa_cancelamento->setSize('100%', 70);
        $notafiscal_dup_notafiscal_dvenc->setSize('100%');
        $notafiscal_refecf_notafiscal_necf->setSize('100%');
        $notafiscal_refecf_notafiscal_ncoo->setSize('100%');
        $notafiscal_frete_volumes_notafiscal_id->setSize(200);
        $notafiscal_refnfe_notafiscal_refnfe->setSize('100%');
        $notafiscal_autxml_notafiscal_cpf_cnpj->setSize('100%');
        $notafiscal_frete_volumes_notafiscal_esp->setSize('100%');
        $notafiscal_frete_volumes_notafiscal_qVol->setSize('100%');
        $notafiscal_frete_volumes_notafiscal_nVol->setSize('100%');
        $notafiscal_frete_volumes_notafiscal_marca->setSize('100%');
        $notafiscal_frete_volumes_notafiscal_pesol->setSize('100%');
        $notafiscal_frete_volumes_notafiscal_pesob->setSize('100%');
        $notafiscal_pag_notafiscal_notafiscal_tpag_id->setSize('100%');
        $notafiscal_refecf_notafiscal_notafiscal_refecfmod_id->setSize('100%');

        $button_adicionar_notafiscal_dup_notafiscal->id = '61a00abfeeb9e';
        $button_adicionar_notafiscal_pag_notafiscal->id = '619ed34a8f5fa';
        $button_adicionar_notafiscal_refecf_notafiscal->id = '61e2d3ecff51d';
        $button_adicionar_notafiscal_refnfe_notafiscal->id = '61e2d4beff521';
        $button_adicionar_notafiscal_autxml_notafiscal->id = '622268a80e1ef';
        $button_adicionar_notafiscal_frete_volumes_notafiscal->id = '61b26bcf71697';

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $lista_items->add($loadingContainer);

        $this->lista_items = $lista_items;

        $seed = AdiantiApplicationConfig::get()['general']['seed'];
        $cliente_id_seekAction = new TAction(['ClienteSeekWindow', 'onShow']);
        $seekFilters = [];
        $seekFields = base64_encode(serialize([
            ['name'=> 'cliente_id', 'column'=>'{id}']
        ]));

        $seekFilters = base64_encode(serialize($seekFilters));
        $cliente_id_seekAction->setParameter('_seek_fields', $seekFields);
        $cliente_id_seekAction->setParameter('_seek_filters', $seekFilters);
        $cliente_id_seekAction->setParameter('_seek_hash', md5($seed.$seekFields.$seekFilters));
        $cliente_id->setAction($cliente_id_seekAction);

        $this->form->appendPage("Geral");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$notafiscal_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Número:", null, '14px', null, '100%'),$numero],[new TLabel("Venda:", null, '14px', null, '100%'),$venda_id]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Tipo Ambiente:", '#FF0000', '14px', null, '100%'),$notafiscal_tpamb_id],[new TLabel("Data Emissão:", null, '14px', null, '100%'),$data_emissao],[new TLabel("Data Saída:", null, '14px', null, '100%'),$data_saida]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Tipo de documento:", '#ff0000', '14px', null, '100%'),$nf_tipodocumento_id],[new TLabel("Modelo:", '#FF0000', '14px', null, '100%'),$notafiscal_mod_id],[new TLabel("Série:", '#FF0000', '14px', null, '100%'),$serie]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([new TLabel("Natureza de Operação:", '#FF0000', '14px', null, '100%'),$natureza_operacao_id],[new TLabel("CRT (Código de Regime Tributário):", '#ff0000', '14px', null, '100%'),$notafiscal_crt_id],[new TLabel("Destino da Operação:", '#FF0000', '14px', null, '100%'),$notafiscal_iddest_id]);
        $row5->layout = [' col-sm-4','col-sm-4','col-sm-4'];

        $row6 = $this->form->addFields([new TLabel("Finalidade de Emissão:", '#FF0000', '14px', null, '100%'),$notafiscal_finnfe_id],[new TLabel("Consumidor Final:", '#FF0000', '14px', null, '100%'),$notafiscal_indfinal_id],[new TLabel("Indicador de Presença:", '#FF0000', '14px', null, '100%'),$notafiscal_indpres_id]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->form->addFields([new TLabel("Tipo de Emissão:", '#FF0000', '14px', null, '100%'),$notafiscal_tpemis_id],[new TLabel("Tipo de Impressão:", '#FF0000', '14px', null, '100%'),$notafiscal_tpimp_id]);
        $row7->layout = [' col-sm-4','col-sm-4'];

        $row8 = $this->form->addFields([new TLabel("Informações Complementares:", null, '14px', null, '100%'),$infcpl],[new TLabel("Informações adicionais do Fisco:", null, '14px', null, '100%'),$infadfisco]);
        $row8->layout = [' col-sm-6',' col-sm-6'];

        $row9 = $this->form->addContent([new TFormSeparator("Contingência", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([new TLabel("Data/Hora:", null, '14px', null, '100%'),$contingencia_data],[new TLabel("Motivo:", null, '14px', null, '100%'),$contingencia_motivo]);
        $row10->layout = [' col-sm-6','col-sm-6'];

        $row11 = $this->form->addFields([$movimentacao_origem_id],[]);
        $row11->layout = [' col-sm-6','col-sm-6'];

        $this->form->appendPage("Cliente");
        $row12 = $this->form->addFields([new TLabel("Cliente:", '#ff0000', '14px', null, '100%'),$cliente_id],[new TLabel("Nome/Razão Social:", null, '14px', null),$cliente_nome],[new TLabel("CPF/CNPJ:", null, '14px', null, '100%'),$cliente_cpfcnpj]);
        $row12->layout = [' col-sm-1',' col-sm-8',' col-sm-3'];

        $row13 = $this->form->addFields([new TLabel("Inscrição Estadual:", null, '14px', null, '100%'),$cliente_inscest],[new TLabel("Inscrição Municipal:", null, '14px', null, '100%'),$cliente_inscmuni],[new TLabel("Telefone:", null, '14px', null, '100%'),$cliente_fone]);
        $row13->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row14 = $this->form->addFields([new TLabel("Indicador da IE do Destinatário", '#FF0000', '14px', null, '100%'),$notafiscal_indiedest_id],[new TLabel("Suframa:", null, '14px', null),$cliente_suframa],[]);
        $row14->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row15 = $this->form->addContent([new TFormSeparator("Endereço", '#333', '18', '#eee')]);
        $row16 = $this->form->addFields([new TLabel("CEP:", '#FF0000', '14px', null, '100%'),$cliente_cep,$button_],[new TLabel("Endereço:", '#FF0000', '14px', null, '100%'),$cliente_endereco],[new TLabel("Número:", '#FF0000', '14px', null, '100%'),$cliente_numero]);
        $row16->layout = [' col-sm-4','col-sm-4',' col-sm-4'];

        $row17 = $this->form->addFields([new TLabel("Bairro:", '#FF0000', '14px', null, '100%'),$cliente_bairro],[new TLabel("Cidade:", '#FF0000', '14px', null, '100%'),$cliente_cidade],[new TLabel("Código IBGE Cidade:", '#FF0000', '14px', null, '100%'),$cliente_cidade_codibge]);
        $row17->layout = ['col-sm-4','col-sm-4',' col-sm-4'];

        $row18 = $this->form->addFields([new TLabel("Estado:", '#FF0000', '14px', null, '100%'),$cliente_estado],[new TLabel("Complemento:", null, '14px', null, '100%'),$cliente_complemento],[new TLabel("País:", null, '14px', null),$cliente_xpais],[new TLabel("Código País:", null, '14px', null),$cliente_cpais]);
        $row18->layout = [' col-sm-4',' col-sm-4',' col-sm-2',' col-sm-2'];

        $this->form->appendPage("Produtos");
        $row19 = $this->form->addFields([$button_novo_item],[],[]);
        $row19->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row20 = $this->form->addFields([$lista_items]);
        $row20->layout = [' col-sm-12'];

        $this->form->appendPage("Transporte");
        $row21 = $this->form->addContent([new TFormSeparator("Transportador", '#333', '18', '#eee')]);
        $row22 = $this->form->addFields([new TLabel("Modalidade do Frete:", '#FF0000', '14px', null, '100%'),$notafiscal_modfrete_id]);
        $row22->layout = [' col-sm-12'];

        $row23 = $this->form->addFields([new TLabel("Nome:", null, '14px', null, '100%'),$transp_nome],[new TLabel("CNPJ:", null, '14px', null, '100%'),$transp_cnpj],[new TLabel("Inscrição Estadual:", null, '14px', null, '100%'),$transp_inscest]);
        $row23->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row24 = $this->form->addFields([new TLabel("Endereço:", null, '14px', null, '100%'),$transp_endereco],[new TLabel("Cidade:", null, '14px', null, '100%'),$transp_cidade],[new TLabel("UF:", null, '14px', null, '100%'),$transp_uf]);
        $row24->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row25 = $this->form->addContent([new TFormSeparator("Veículo", '#333', '18', '#eee')]);
        $row26 = $this->form->addFields([new TLabel("Placa:", null, '14px', null, '100%'),$transp_placaveiculo],[new TLabel("UF do Veículo:", null, '14px', null, '100%'),$transp_veiculouf],[new TLabel("RNTC:", null, '14px', null, '100%'),$transp_veiculoRNTC]);
        $row26->layout = ['col-sm-3','col-sm-3','col-sm-3'];

        $this->detailFormNotafiscalFreteVolumesNotafiscal = new BootstrapFormBuilder('detailFormNotafiscalFreteVolumesNotafiscal');
        $this->detailFormNotafiscalFreteVolumesNotafiscal->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotafiscalFreteVolumesNotafiscal->setProperty('class', 'form-horizontal builder-detail-form');

        $row27 = $this->detailFormNotafiscalFreteVolumesNotafiscal->addFields([new TFormSeparator("Volumes", '#333', '18', '#eee')]);
        $row27->layout = [' col-sm-12'];

        $row28 = $this->detailFormNotafiscalFreteVolumesNotafiscal->addFields([new TLabel("Quantidade:", null, '14px', null, '100%'),$notafiscal_frete_volumes_notafiscal_qVol,$notafiscal_frete_volumes_notafiscal_id],[new TLabel("Número:", null, '14px', null, '100%'),$notafiscal_frete_volumes_notafiscal_nVol]);
        $row28->layout = ['col-sm-6','col-sm-6'];

        $row29 = $this->detailFormNotafiscalFreteVolumesNotafiscal->addFields([new TLabel("Espécie:", null, '14px', null, '100%'),$notafiscal_frete_volumes_notafiscal_esp],[new TLabel("Marca:", null, '14px', null, '100%'),$notafiscal_frete_volumes_notafiscal_marca]);
        $row29->layout = ['col-sm-6','col-sm-6'];

        $row30 = $this->detailFormNotafiscalFreteVolumesNotafiscal->addFields([new TLabel("Peso Líquido:", null, '14px', null, '100%'),$notafiscal_frete_volumes_notafiscal_pesol],[new TLabel("Peso Bruto:", null, '14px', null, '100%'),$notafiscal_frete_volumes_notafiscal_pesob]);
        $row30->layout = ['col-sm-6',' col-sm-6'];

        $row31 = $this->detailFormNotafiscalFreteVolumesNotafiscal->addFields([$button_adicionar_notafiscal_frete_volumes_notafiscal]);
        $row31->layout = [' col-sm-12'];

        $row32 = $this->detailFormNotafiscalFreteVolumesNotafiscal->addFields([new THidden('notafiscal_frete_volumes_notafiscal__row__id')]);
        $this->notafiscal_frete_volumes_notafiscal_criteria = new TCriteria();

        $this->notafiscal_frete_volumes_notafiscal_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->notafiscal_frete_volumes_notafiscal_list->disableHtmlConversion();;
        $this->notafiscal_frete_volumes_notafiscal_list->generateHiddenFields();
        $this->notafiscal_frete_volumes_notafiscal_list->setId('notafiscal_frete_volumes_notafiscal_list');

        $this->notafiscal_frete_volumes_notafiscal_list->disableDefaultClick();
        $this->notafiscal_frete_volumes_notafiscal_list->style = 'width:100%';
        $this->notafiscal_frete_volumes_notafiscal_list->class .= ' table-bordered';

        $column_notafiscal_frete_volumes_notafiscal_qVol = new TDataGridColumn('qVol', "Quantidade", 'left');
        $column_notafiscal_frete_volumes_notafiscal_nVol = new TDataGridColumn('nVol', "Número", 'left');
        $column_notafiscal_frete_volumes_notafiscal_esp = new TDataGridColumn('esp', "Espécie", 'left');
        $column_notafiscal_frete_volumes_notafiscal_marca = new TDataGridColumn('marca', "Marca", 'left');
        $column_notafiscal_frete_volumes_notafiscal_pesol = new TDataGridColumn('pesol', "Peso Líquido", 'left');
        $column_notafiscal_frete_volumes_notafiscal_pesob = new TDataGridColumn('pesob', "Peso Bruto", 'left');

        $column_notafiscal_frete_volumes_notafiscal__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_notafiscal_frete_volumes_notafiscal__row__data->setVisibility(false);

        $action_onEditDetailNotafiscalFreteVolumes = new TDataGridAction(array('NotafiscalForm', 'onEditDetailNotafiscalFreteVolumes'));
        $action_onEditDetailNotafiscalFreteVolumes->setUseButton(true);
        $action_onEditDetailNotafiscalFreteVolumes->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotafiscalFreteVolumes->setLabel("Editar");
        $action_onEditDetailNotafiscalFreteVolumes->setImage('far:edit #478fca');
        $action_onEditDetailNotafiscalFreteVolumes->setFields(['__row__id', '__row__data']);

        $this->notafiscal_frete_volumes_notafiscal_list->addAction($action_onEditDetailNotafiscalFreteVolumes);
        $action_onDeleteDetailNotafiscalFreteVolumes = new TDataGridAction(array('NotafiscalForm', 'onDeleteDetailNotafiscalFreteVolumes'));
        $action_onDeleteDetailNotafiscalFreteVolumes->setUseButton(true);
        $action_onDeleteDetailNotafiscalFreteVolumes->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotafiscalFreteVolumes->setLabel("Excluir");
        $action_onDeleteDetailNotafiscalFreteVolumes->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotafiscalFreteVolumes->setFields(['__row__id', '__row__data']);

        $this->notafiscal_frete_volumes_notafiscal_list->addAction($action_onDeleteDetailNotafiscalFreteVolumes);

        $this->notafiscal_frete_volumes_notafiscal_list->addColumn($column_notafiscal_frete_volumes_notafiscal_qVol);
        $this->notafiscal_frete_volumes_notafiscal_list->addColumn($column_notafiscal_frete_volumes_notafiscal_nVol);
        $this->notafiscal_frete_volumes_notafiscal_list->addColumn($column_notafiscal_frete_volumes_notafiscal_esp);
        $this->notafiscal_frete_volumes_notafiscal_list->addColumn($column_notafiscal_frete_volumes_notafiscal_marca);
        $this->notafiscal_frete_volumes_notafiscal_list->addColumn($column_notafiscal_frete_volumes_notafiscal_pesol);
        $this->notafiscal_frete_volumes_notafiscal_list->addColumn($column_notafiscal_frete_volumes_notafiscal_pesob);

        $this->notafiscal_frete_volumes_notafiscal_list->addColumn($column_notafiscal_frete_volumes_notafiscal__row__data);

        $this->notafiscal_frete_volumes_notafiscal_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->notafiscal_frete_volumes_notafiscal_list);
        $this->detailFormNotafiscalFreteVolumesNotafiscal->addContent([$tableResponsiveDiv]);
        $row33 = $this->form->addFields([$this->detailFormNotafiscalFreteVolumesNotafiscal]);
        $row33->layout = [' col-sm-12'];

        $this->form->appendPage("Entrega/Retirada");
        $row34 = $this->form->addContent([new TFormSeparator("Entrega", '#333', '18', '#eee')]);
        $row35 = $this->form->addFields([new TLabel("Marcado:", null, '14px', null, '100%'),$entrega_marcado],[new TLabel("CEP:", null, '14px', null),$cep_entrega],[new TLabel("CNPJ:", null, '14px', null, '100%'),$entrega_cpfcnpj],[new TLabel("Nome:", null, '14px', null),$entrega_xnome]);
        $row35->layout = ['col-sm-3','col-sm-2','col-sm-3',' col-sm-4'];

        $row36 = $this->form->addFields([new TLabel("Logradouro:", null, '14px', null, '100%'),$entrega_xlgr],[new TLabel("Número:", null, '14px', null, '100%'),$entrega_nro],[new TLabel("Complemento:", null, '14px', null, '100%'),$entrega_xcpl],[new TLabel("Bairro:", null, '14px', null, '100%'),$entrega_xbairro]);
        $row36->layout = ['col-sm-4',' col-sm-2','col-sm-4',' col-sm-2'];

        $row37 = $this->form->addFields([new TLabel("Código Município:", null, '14px', null),$entrega_cmun],[new TLabel("Município:", null, '14px', null, '100%'),$entrega_xmun],[new TLabel("UF:", null, '14px', null, '100%'),$entrega_uf]);
        $row37->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row38 = $this->form->addContent([new TFormSeparator("Retirada", '#333', '18', '#eee')]);
        $row39 = $this->form->addFields([new TLabel("Marcado:", null, '14px', null, '100%'),$retirada_marcado],[new TLabel("CNPJ:", null, '14px', null, '100%'),$retirada_cpfcnpj],[new TLabel("CEP:", null, '14px', null),$cep_retirada],[new TLabel("Logradouro:", null, '14px', null, '100%'),$retirada_xlgr]);
        $row39->layout = [' col-sm-3',' col-sm-3','col-sm-2','col-sm-4'];

        $row40 = $this->form->addFields([new TLabel("Número:", null, '14px', null, '100%'),$retirada_nro],[new TLabel("Complemento:", null, '14px', null, '100%'),$retirada_xcpl],[new TLabel("Bairro:", null, '14px', null, '100%'),$retirada_xbairro]);
        $row40->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row41 = $this->form->addFields([new TLabel("Código Município:", null, '14px', null, '100%'),$retirada_cmun],[new TLabel("Município:", null, '14px', null, '100%'),$retirada_xmun],[new TLabel("UF:", null, '14px', null, '100%'),$retirada_uf]);
        $row41->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $this->form->appendPage("Exportação");
        $row42 = $this->form->addFields([new TLabel("UF de embarque:", null, '14px', null),$exporta_ufsaidapais],[new TLabel("Local de embarque:", null, '14px', null),$exporta_xlocexporta],[new TLabel("Local de despacho:", null, '14px', null),$exporta_xlocdespacho]);
        $row42->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $this->form->appendPage("Cobrança");
        $row43 = $this->form->addContent([new TFormSeparator("Dados da Fatura", '#333', '18', '#eee')]);
        $row44 = $this->form->addFields([new TLabel("Número:", null, '14px', null, '100%'),$fatura_numero],[new TLabel("Valor Original:", null, '14px', null),$fatura_valor_original],[new TLabel("Valor Desconto:", null, '14px', null),$fatura_valor_desconto],[new TLabel("Valor Líquido:", null, '14px', null),$fatura_valor_liquido]);
        $row44->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row45 = $this->form->addContent([new TFormSeparator("Faturas", '#333', '18', '#eee')]);

        $this->detailFormNotafiscalDupNotafiscal = new BootstrapFormBuilder('detailFormNotafiscalDupNotafiscal');
        $this->detailFormNotafiscalDupNotafiscal->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotafiscalDupNotafiscal->setProperty('class', 'form-horizontal builder-detail-form');

        $row46 = $this->detailFormNotafiscalDupNotafiscal->addFields([new TLabel("Número:", null, '14px', null, '100%'),$notafiscal_dup_notafiscal_ndup,$notafiscal_dup_notafiscal_id],[new TLabel("Valor:", null, '14px', null, '100%'),$notafiscal_dup_notafiscal_vdup],[new TLabel("Data de Vencimento:", null, '14px', null, '100%'),$notafiscal_dup_notafiscal_dvenc],[new TLabel(" ", null, '14px', null, '100%'),$button_adicionar_notafiscal_dup_notafiscal]);
        $row46->layout = [' col-sm-3',' col-sm-3',' col-sm-3','col-sm-2'];

        $row47 = $this->detailFormNotafiscalDupNotafiscal->addFields([new THidden('notafiscal_dup_notafiscal__row__id')]);
        $this->notafiscal_dup_notafiscal_criteria = new TCriteria();

        $this->notafiscal_dup_notafiscal_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->notafiscal_dup_notafiscal_list->disableHtmlConversion();;
        $this->notafiscal_dup_notafiscal_list->generateHiddenFields();
        $this->notafiscal_dup_notafiscal_list->setId('notafiscal_dup_notafiscal_list');

        $this->notafiscal_dup_notafiscal_list->style = 'width:100%';
        $this->notafiscal_dup_notafiscal_list->class .= ' table-bordered';

        $column_notafiscal_dup_notafiscal_ndup = new TDataGridColumn('ndup', "Número", 'left');
        $column_notafiscal_dup_notafiscal_vdup_transformed = new TDataGridColumn('vdup', "Valor", 'left');
        $column_notafiscal_dup_notafiscal_dvenc_transformed = new TDataGridColumn('dvenc', "Vencimento", 'left');

        $column_notafiscal_dup_notafiscal__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_notafiscal_dup_notafiscal__row__data->setVisibility(false);

        $action_onEditDetailNotafiscalDup = new TDataGridAction(array('NotafiscalForm', 'onEditDetailNotafiscalDup'));
        $action_onEditDetailNotafiscalDup->setUseButton(false);
        $action_onEditDetailNotafiscalDup->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotafiscalDup->setLabel("Editar");
        $action_onEditDetailNotafiscalDup->setImage('far:edit #478fca');
        $action_onEditDetailNotafiscalDup->setFields(['__row__id', '__row__data']);

        $this->notafiscal_dup_notafiscal_list->addAction($action_onEditDetailNotafiscalDup);
        $action_onDeleteDetailNotafiscalDup = new TDataGridAction(array('NotafiscalForm', 'onDeleteDetailNotafiscalDup'));
        $action_onDeleteDetailNotafiscalDup->setUseButton(false);
        $action_onDeleteDetailNotafiscalDup->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotafiscalDup->setLabel("Excluir");
        $action_onDeleteDetailNotafiscalDup->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotafiscalDup->setFields(['__row__id', '__row__data']);

        $this->notafiscal_dup_notafiscal_list->addAction($action_onDeleteDetailNotafiscalDup);

        $this->notafiscal_dup_notafiscal_list->addColumn($column_notafiscal_dup_notafiscal_ndup);
        $this->notafiscal_dup_notafiscal_list->addColumn($column_notafiscal_dup_notafiscal_vdup_transformed);
        $this->notafiscal_dup_notafiscal_list->addColumn($column_notafiscal_dup_notafiscal_dvenc_transformed);

        $this->notafiscal_dup_notafiscal_list->addColumn($column_notafiscal_dup_notafiscal__row__data);

        $this->notafiscal_dup_notafiscal_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->notafiscal_dup_notafiscal_list);
        $this->detailFormNotafiscalDupNotafiscal->addContent([$tableResponsiveDiv]);

        $column_notafiscal_dup_notafiscal_vdup_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_notafiscal_dup_notafiscal_dvenc_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });        $row48 = $this->form->addFields([$this->detailFormNotafiscalDupNotafiscal]);
        $row48->layout = [' col-sm-12'];

        $this->form->appendPage("Pagamentos");
        $row49 = $this->form->addFields([new TLabel("Indicador de Pagamento:", '#FF0000', '14px', null, '100%'),$notafiscal_indpag_id]);
        $row49->layout = [' col-sm-12'];

        $row50 = $this->form->addContent([new TFormSeparator("Meios de Pagamento", '#333', '18', '#eee')]);

        $this->detailFormNotafiscalPagNotafiscal = new BootstrapFormBuilder('detailFormNotafiscalPagNotafiscal');
        $this->detailFormNotafiscalPagNotafiscal->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotafiscalPagNotafiscal->setProperty('class', 'form-horizontal builder-detail-form');

        $row51 = $this->detailFormNotafiscalPagNotafiscal->addFields([new TLabel("Tipo de pagamento:", '#ff0000', '14px', null, '100%'),$notafiscal_pag_notafiscal_notafiscal_tpag_id,$notafiscal_pag_notafiscal_id],[new TLabel("Valor:", null, '14px', null, '100%'),$notafiscal_pag_notafiscal_vpag]);
        $row51->layout = ['col-sm-6',' col-sm-6'];

        $row52 = $this->detailFormNotafiscalPagNotafiscal->addFields([new TLabel("Descrição meio de pagamento (p/ Outros)", null, '14px', null),$notafiscal_pag_notafiscal_xpag]);
        $row52->layout = [' col-sm-12'];

        $row53 = $this->detailFormNotafiscalPagNotafiscal->addFields([$button_adicionar_notafiscal_pag_notafiscal]);
        $row53->layout = [' col-sm-12'];

        $row54 = $this->detailFormNotafiscalPagNotafiscal->addFields([new THidden('notafiscal_pag_notafiscal__row__id')]);
        $this->notafiscal_pag_notafiscal_criteria = new TCriteria();

        $this->notafiscal_pag_notafiscal_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->notafiscal_pag_notafiscal_list->disableHtmlConversion();;
        $this->notafiscal_pag_notafiscal_list->generateHiddenFields();
        $this->notafiscal_pag_notafiscal_list->setId('notafiscal_pag_notafiscal_list');

        $this->notafiscal_pag_notafiscal_list->style = 'width:100%';
        $this->notafiscal_pag_notafiscal_list->class .= ' table-bordered';

        $column_notafiscal_pag_notafiscal_notafiscal_tpag_descricao = new TDataGridColumn('notafiscal_tpag->descricao', "Tipo de pagamento", 'left');
        $column_notafiscal_pag_notafiscal_vpag_transformed = new TDataGridColumn('vpag', "Valor", 'left');

        $column_notafiscal_pag_notafiscal__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_notafiscal_pag_notafiscal__row__data->setVisibility(false);

        $column_notafiscal_pag_notafiscal_vpag_transformed->enableTotal('sum', 'R$', 2, ',', '.');

        $action_onEditDetailNotafiscalPag = new TDataGridAction(array('NotafiscalForm', 'onEditDetailNotafiscalPag'));
        $action_onEditDetailNotafiscalPag->setUseButton(true);
        $action_onEditDetailNotafiscalPag->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotafiscalPag->setLabel("Editar");
        $action_onEditDetailNotafiscalPag->setImage('far:edit #478fca');
        $action_onEditDetailNotafiscalPag->setFields(['__row__id', '__row__data']);

        $this->notafiscal_pag_notafiscal_list->addAction($action_onEditDetailNotafiscalPag);
        $action_onDeleteDetailNotafiscalPag = new TDataGridAction(array('NotafiscalForm', 'onDeleteDetailNotafiscalPag'));
        $action_onDeleteDetailNotafiscalPag->setUseButton(true);
        $action_onDeleteDetailNotafiscalPag->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotafiscalPag->setLabel("Excluir");
        $action_onDeleteDetailNotafiscalPag->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotafiscalPag->setFields(['__row__id', '__row__data']);

        $this->notafiscal_pag_notafiscal_list->addAction($action_onDeleteDetailNotafiscalPag);

        $this->notafiscal_pag_notafiscal_list->addColumn($column_notafiscal_pag_notafiscal_notafiscal_tpag_descricao);
        $this->notafiscal_pag_notafiscal_list->addColumn($column_notafiscal_pag_notafiscal_vpag_transformed);

        $this->notafiscal_pag_notafiscal_list->addColumn($column_notafiscal_pag_notafiscal__row__data);

        $this->notafiscal_pag_notafiscal_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->notafiscal_pag_notafiscal_list);
        $this->detailFormNotafiscalPagNotafiscal->addContent([$tableResponsiveDiv]);

        $column_notafiscal_pag_notafiscal_vpag_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row55 = $this->form->addFields([$this->detailFormNotafiscalPagNotafiscal]);
        $row55->layout = [' col-sm-12'];

        $this->form->appendPage("Doc. Vinculados e Referênciados");

        $this->detailFormNotafiscalRefecfNotafiscal = new BootstrapFormBuilder('detailFormNotafiscalRefecfNotafiscal');
        $this->detailFormNotafiscalRefecfNotafiscal->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotafiscalRefecfNotafiscal->setProperty('class', 'form-horizontal builder-detail-form');

        $row56 = $this->detailFormNotafiscalRefecfNotafiscal->addFields([new TFormSeparator("Cupom Fiscal Vinculado a NF-e", '#333', '18', '#eee')]);
        $row56->layout = [' col-sm-12'];

        $row57 = $this->detailFormNotafiscalRefecfNotafiscal->addFields([new TLabel("Modelo:", '#ff0000', '14px', null, '100%'),$notafiscal_refecf_notafiscal_notafiscal_refecfmod_id,$notafiscal_refecf_notafiscal_id],[new TLabel("Número ECF:", null, '14px', null, '100%'),$notafiscal_refecf_notafiscal_necf],[new TLabel("Número COO:", null, '14px', null, '100%'),$notafiscal_refecf_notafiscal_ncoo]);
        $row57->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row58 = $this->detailFormNotafiscalRefecfNotafiscal->addFields([$button_adicionar_notafiscal_refecf_notafiscal]);
        $row58->layout = [' col-sm-12'];

        $row59 = $this->detailFormNotafiscalRefecfNotafiscal->addFields([new THidden('notafiscal_refecf_notafiscal__row__id')]);
        $this->notafiscal_refecf_notafiscal_criteria = new TCriteria();

        $this->notafiscal_refecf_notafiscal_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->notafiscal_refecf_notafiscal_list->disableHtmlConversion();;
        $this->notafiscal_refecf_notafiscal_list->generateHiddenFields();
        $this->notafiscal_refecf_notafiscal_list->setId('notafiscal_refecf_notafiscal_list');

        $this->notafiscal_refecf_notafiscal_list->style = 'width:100%';
        $this->notafiscal_refecf_notafiscal_list->class .= ' table-bordered';

        $column_notafiscal_refecf_notafiscal_notafiscal_refecfmod_descricao = new TDataGridColumn('notafiscal_refecfmod->descricao', "Modelo", 'left');
        $column_notafiscal_refecf_notafiscal_necf = new TDataGridColumn('necf', "Número ECF", 'left');
        $column_notafiscal_refecf_notafiscal_ncoo = new TDataGridColumn('ncoo', "Número COO", 'left');

        $column_notafiscal_refecf_notafiscal__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_notafiscal_refecf_notafiscal__row__data->setVisibility(false);

        $action_onEditDetailNotafiscalRefecf = new TDataGridAction(array('NotafiscalForm', 'onEditDetailNotafiscalRefecf'));
        $action_onEditDetailNotafiscalRefecf->setUseButton(false);
        $action_onEditDetailNotafiscalRefecf->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotafiscalRefecf->setLabel("Editar");
        $action_onEditDetailNotafiscalRefecf->setImage('far:edit #478fca');
        $action_onEditDetailNotafiscalRefecf->setFields(['__row__id', '__row__data']);

        $this->notafiscal_refecf_notafiscal_list->addAction($action_onEditDetailNotafiscalRefecf);
        $action_onDeleteDetailNotafiscalRefecf = new TDataGridAction(array('NotafiscalForm', 'onDeleteDetailNotafiscalRefecf'));
        $action_onDeleteDetailNotafiscalRefecf->setUseButton(false);
        $action_onDeleteDetailNotafiscalRefecf->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotafiscalRefecf->setLabel("Excluir");
        $action_onDeleteDetailNotafiscalRefecf->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotafiscalRefecf->setFields(['__row__id', '__row__data']);

        $this->notafiscal_refecf_notafiscal_list->addAction($action_onDeleteDetailNotafiscalRefecf);

        $this->notafiscal_refecf_notafiscal_list->addColumn($column_notafiscal_refecf_notafiscal_notafiscal_refecfmod_descricao);
        $this->notafiscal_refecf_notafiscal_list->addColumn($column_notafiscal_refecf_notafiscal_necf);
        $this->notafiscal_refecf_notafiscal_list->addColumn($column_notafiscal_refecf_notafiscal_ncoo);

        $this->notafiscal_refecf_notafiscal_list->addColumn($column_notafiscal_refecf_notafiscal__row__data);

        $this->notafiscal_refecf_notafiscal_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->notafiscal_refecf_notafiscal_list);
        $this->detailFormNotafiscalRefecfNotafiscal->addContent([$tableResponsiveDiv]);
        $row60 = $this->form->addFields([$this->detailFormNotafiscalRefecfNotafiscal]);
        $row60->layout = [' col-sm-12'];

        $this->detailFormNotafiscalRefnfeNotafiscal = new BootstrapFormBuilder('detailFormNotafiscalRefnfeNotafiscal');
        $this->detailFormNotafiscalRefnfeNotafiscal->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotafiscalRefnfeNotafiscal->setProperty('class', 'form-horizontal builder-detail-form');

        $row61 = $this->detailFormNotafiscalRefnfeNotafiscal->addFields([new TFormSeparator("Notas Referênciadas", '#333', '18', '#eee')]);
        $row61->layout = [' col-sm-12'];

        $row62 = $this->detailFormNotafiscalRefnfeNotafiscal->addFields([new TLabel("Chave Nfe/NFCe Refêrenciada:", '#ff0000', '14px', null, '100%'),$notafiscal_refnfe_notafiscal_refnfe,$notafiscal_refnfe_notafiscal_id],[]);
        $row62->layout = ['col-sm-6','col-sm-6'];

        $row63 = $this->detailFormNotafiscalRefnfeNotafiscal->addFields([$button_adicionar_notafiscal_refnfe_notafiscal]);
        $row63->layout = [' col-sm-12'];

        $row64 = $this->detailFormNotafiscalRefnfeNotafiscal->addFields([new THidden('notafiscal_refnfe_notafiscal__row__id')]);
        $this->notafiscal_refnfe_notafiscal_criteria = new TCriteria();

        $this->notafiscal_refnfe_notafiscal_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->notafiscal_refnfe_notafiscal_list->disableHtmlConversion();;
        $this->notafiscal_refnfe_notafiscal_list->generateHiddenFields();
        $this->notafiscal_refnfe_notafiscal_list->setId('notafiscal_refnfe_notafiscal_list');

        $this->notafiscal_refnfe_notafiscal_list->style = 'width:100%';
        $this->notafiscal_refnfe_notafiscal_list->class .= ' table-bordered';

        $column_notafiscal_refnfe_notafiscal_refnfe = new TDataGridColumn('refnfe', "Chave Nfe/NFCe Refêrenciada:", 'left');

        $column_notafiscal_refnfe_notafiscal__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_notafiscal_refnfe_notafiscal__row__data->setVisibility(false);

        $action_onEditDetailNotafiscalRefnfe = new TDataGridAction(array('NotafiscalForm', 'onEditDetailNotafiscalRefnfe'));
        $action_onEditDetailNotafiscalRefnfe->setUseButton(false);
        $action_onEditDetailNotafiscalRefnfe->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotafiscalRefnfe->setLabel("Editar");
        $action_onEditDetailNotafiscalRefnfe->setImage('far:edit #478fca');
        $action_onEditDetailNotafiscalRefnfe->setFields(['__row__id', '__row__data']);

        $this->notafiscal_refnfe_notafiscal_list->addAction($action_onEditDetailNotafiscalRefnfe);
        $action_onDeleteDetailNotafiscalRefnfe = new TDataGridAction(array('NotafiscalForm', 'onDeleteDetailNotafiscalRefnfe'));
        $action_onDeleteDetailNotafiscalRefnfe->setUseButton(false);
        $action_onDeleteDetailNotafiscalRefnfe->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotafiscalRefnfe->setLabel("Excluir");
        $action_onDeleteDetailNotafiscalRefnfe->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotafiscalRefnfe->setFields(['__row__id', '__row__data']);

        $this->notafiscal_refnfe_notafiscal_list->addAction($action_onDeleteDetailNotafiscalRefnfe);

        $this->notafiscal_refnfe_notafiscal_list->addColumn($column_notafiscal_refnfe_notafiscal_refnfe);

        $this->notafiscal_refnfe_notafiscal_list->addColumn($column_notafiscal_refnfe_notafiscal__row__data);

        $this->notafiscal_refnfe_notafiscal_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->notafiscal_refnfe_notafiscal_list);
        $this->detailFormNotafiscalRefnfeNotafiscal->addContent([$tableResponsiveDiv]);
        $row65 = $this->form->addFields([$this->detailFormNotafiscalRefnfeNotafiscal]);
        $row65->layout = [' col-sm-12'];

        $this->form->appendPage("Pessoas autorizadas a acessar o XML da NF-e");

        $this->detailFormNotafiscalAutxmlNotafiscal = new BootstrapFormBuilder('detailFormNotafiscalAutxmlNotafiscal');
        $this->detailFormNotafiscalAutxmlNotafiscal->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormNotafiscalAutxmlNotafiscal->setProperty('class', 'form-horizontal builder-detail-form');

        $row66 = $this->detailFormNotafiscalAutxmlNotafiscal->addFields([new TLabel("CPF/CNPJ:", '#ff0000', '14px', null, '100%'),$notafiscal_autxml_notafiscal_cpf_cnpj,$notafiscal_autxml_notafiscal_id],[]);
        $row66->layout = ['col-sm-6','col-sm-6'];

        $row67 = $this->detailFormNotafiscalAutxmlNotafiscal->addFields([$button_adicionar_notafiscal_autxml_notafiscal]);
        $row67->layout = [' col-sm-12'];

        $row68 = $this->detailFormNotafiscalAutxmlNotafiscal->addFields([new THidden('notafiscal_autxml_notafiscal__row__id')]);
        $this->notafiscal_autxml_notafiscal_criteria = new TCriteria();

        $this->notafiscal_autxml_notafiscal_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->notafiscal_autxml_notafiscal_list->disableHtmlConversion();;
        $this->notafiscal_autxml_notafiscal_list->generateHiddenFields();
        $this->notafiscal_autxml_notafiscal_list->setId('notafiscal_autxml_notafiscal_list');

        $this->notafiscal_autxml_notafiscal_list->style = 'width:100%';
        $this->notafiscal_autxml_notafiscal_list->class .= ' table-bordered';

        $column_notafiscal_autxml_notafiscal_cpf_cnpj = new TDataGridColumn('cpf_cnpj', "CPF/CNPJ", 'left');

        $column_notafiscal_autxml_notafiscal__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_notafiscal_autxml_notafiscal__row__data->setVisibility(false);

        $action_onEditDetailNotafiscalAutxml = new TDataGridAction(array('NotafiscalForm', 'onEditDetailNotafiscalAutxml'));
        $action_onEditDetailNotafiscalAutxml->setUseButton(true);
        $action_onEditDetailNotafiscalAutxml->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailNotafiscalAutxml->setLabel("Editar");
        $action_onEditDetailNotafiscalAutxml->setImage('far:edit #478fca');
        $action_onEditDetailNotafiscalAutxml->setFields(['__row__id', '__row__data']);

        $this->notafiscal_autxml_notafiscal_list->addAction($action_onEditDetailNotafiscalAutxml);
        $action_onDeleteDetailNotafiscalAutxml = new TDataGridAction(array('NotafiscalForm', 'onDeleteDetailNotafiscalAutxml'));
        $action_onDeleteDetailNotafiscalAutxml->setUseButton(true);
        $action_onDeleteDetailNotafiscalAutxml->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailNotafiscalAutxml->setLabel("Excluir");
        $action_onDeleteDetailNotafiscalAutxml->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailNotafiscalAutxml->setFields(['__row__id', '__row__data']);

        $this->notafiscal_autxml_notafiscal_list->addAction($action_onDeleteDetailNotafiscalAutxml);

        $this->notafiscal_autxml_notafiscal_list->addColumn($column_notafiscal_autxml_notafiscal_cpf_cnpj);

        $this->notafiscal_autxml_notafiscal_list->addColumn($column_notafiscal_autxml_notafiscal__row__data);

        $this->notafiscal_autxml_notafiscal_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->notafiscal_autxml_notafiscal_list);
        $this->detailFormNotafiscalAutxmlNotafiscal->addContent([$tableResponsiveDiv]);
        $row69 = $this->form->addFields([$this->detailFormNotafiscalAutxmlNotafiscal]);
        $row69->layout = [' col-sm-12'];

        $this->form->appendPage("Totais");
        $row70 = $this->form->addFields([new TLabel("Base de cálculo do ICMS:", null, '14px', null, '100%'),$icms_basecalc],[new TLabel("Total do ICMS:", null, '14px', null, '100%'),$icms_valor],[new TLabel("Base de cálculo do ICMS ST:", null, '14px', null, '100%'),$icms_subst_base_calc],[new TLabel("Total do ICMS ST:", null, '14px', null, '100%'),$icms_subst_valor]);
        $row70->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row71 = $this->form->addFields([new TLabel("Total do Frete:", null, '14px', null, '100%'),$frete_valor],[new TLabel("Total do Seguro:", null, '14px', null, '100%'),$seguro_valor],[new TLabel("Total IPI:", null, '14px', null, '100%'),$ipi_valor],[new TLabel("Total Desconto:", null, '14px', null, '100%'),$desconto_valor]);
        $row71->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row72 = $this->form->addFields([new TLabel("Outras Depesas:", null, '14px', null, '100%'),$outras_despesas],[new TLabel("Total IPI Devolvido:", null, '14px', null),$ipi_vipidevol],[new TLabel("COFINS:", null, '14px', null, '100%'),$cofins_valor],[new TLabel("PIS:", null, '14px', null, '100%'),$pis_valor]);
        $row72->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row73 = $this->form->addFields([new TLabel("Total Produtos:", null, '14px', null, '100%'),$valor_total_produtos],[new TLabel("Total Nota:", null, '14px', null, '100%'),$valor_total_nota],[new TLabel("Troco:", null, '14px', null),$vtroco]);
        $row73->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row74 = $this->form->addFields([new TLabel("FCP:", null, '14px', null, '100%'),$icms_vfcp],[new TLabel("FCP ST:", null, '14px', null),$icms_vfcpst],[new TLabel("FCP ST Retido:", null, '14px', null),$icms_vfcpstret],[new TLabel("FCP Destino:", null, '14px', null, '100%'),$vfcpufdest]);
        $row74->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row75 = $this->form->addFields([new TLabel("ICMS Interestadual Destino:", null, '14px', null, '100%'),$vicmsufdest],[new TLabel("ICMS Interestadual Emitente:", null, '14px', null, '100%'),$vicmsufremet]);
        $row75->layout = ['col-sm-3','col-sm-3'];

        $row76 = $this->form->addContent([new TFormSeparator("ISSQN", '#333', '18', '#eee')]);
        $row77 = $this->form->addFields([new TLabel("Total Serviço:", null, '14px', null, '100%'),$issqn_vserv],[new TLabel("Base:", null, '14px', null, '100%'),$issqn_vbc],[new TLabel("ISS:", null, '14px', null),$issqn_viss],[new TLabel("Competência:", null, '14px', null),$issqn_dcompet],[new TLabel("REF TRIB:", null, '14px', null, '100%'),$issqn_reftrib]);
        $row77->layout = [' col-sm-2',' col-sm-2',' col-sm-2','col-sm-2',' col-sm-4'];

        $this->form->appendPage("Eventos SEFAZ");
        $row78 = $this->form->addFields([new TLabel("Status SEFAZ:", null, '14px', null),$status],[new TLabel("Código SEFAZ:", null, '14px', null),$codigo_sefaz],[new TLabel("Mensagem SEFAZ:", null, '14px', null),$mensagem]);
        $row78->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row79 = $this->form->addContent([new TFormSeparator("Envio", '#333', '18', '#eee')]);
        $row80 = $this->form->addFields([new TLabel("Protocolo:", null, '14px', null),$protocolo_envio],[new TLabel("Data e hora envio:", null, '14px', null),$data_hora_envio],[new TLabel("Chave:", null, '14px', null),$chave]);
        $row80->layout = ['col-sm-4',' col-sm-4',' col-sm-4'];

        $row81 = $this->form->addContent([new TFormSeparator("Cancelamento", '#333', '18', '#eee')]);
        $row82 = $this->form->addFields([new TLabel("Protocolo:", null, '14px', null, '100%'),$protocolo_cancelamento],[new TLabel("Data e hora:", null, '14px', null, '100%'),$datahora_cancelamento],[]);
        $row82->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row83 = $this->form->addFields([new TLabel("Justificativa de cancelamento:", null, '14px', null, '100%'),$justificativa_cancelamento]);
        $row83->layout = [' col-sm-12'];

        $row84 = $this->form->addContent([new TFormSeparator("Carta de Correção", '#333', '18', '#eee')]);
        $row85 = $this->form->addFields([new TLabel("Data e hora:", null, '14px', null, '100%'),$cce_datahora_evento],[new TLabel("Sequencial:", null, '14px', null, '100%'),$cce_sequencial],[new TLabel("Protocolo:", null, '14px', null, '100%'),$cce_protocolo],[new TLabel("Correção:", null, '14px', null, '100%'),$cce_correcao]);
        $row85->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacaonfe = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacaoNfe']), 'fas:bars #000000');
        $this->btn_onvisualizacaonfe = $btn_onvisualizacaonfe;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['NotafiscalList', 'onShow']), 'fas:arrow-alt-circle-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","Cadastro de Nota Fiscal"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitCliente($param = null) 
    {
        try 
        {
            if (isset($param['cliente_id']) && $param['cliente_id'])
            {
                TTransaction::open(self::$database);

                $cliente = Cliente::find($param['cliente_id']);

                if($cliente)
                {
                    $object = new stdClass();

                    if ($cliente->pessoa_tipo_id==PessoaTipo::Fisica) 
                    {
                      $object->cliente_nome = $cliente->nome;
                    }
                    else
                    {
                      $object->cliente_nome = $cliente->razao_social;
                    }

                    if ($cliente->cliente_exterior=='N')
                    {
                        $object->cliente_cpfcnpj     = Funcoes::mascaraCpfCnpj($cliente->cpf_cnpj);
                    }

                    // echo 'cli indiedest '.$cliente->notafiscal_indiedest_id;

                    $object->cliente_inscest         = $cliente->insc_estadual;
                    $object->cliente_inscmuni        = $cliente->insc_municipal;
                    $object->cliente_fone            = $cliente->fone;
                    $object->notafiscal_indiedest_id = $cliente->notafiscal_indiedest_id;

                    if($cliente->notafiscal_indiedest_id == NotafiscalIndiedest::NaoContribuinte)
                    {
                        $object->notafiscal_indfinal_id = NotafiscalIndfinal::Sim;                        
                    }
                    else
                    {
                        $object->notafiscal_indfinal_id = NotafiscalIndfinal::Nao;
                    }

                    $cliente_endereco = ClienteEndereco::where('cliente_id', '=', $cliente->id)
                                                       ->where('principal', '=', 1)
                                                       ->first();

                    if($cliente_endereco)
                    {
                	    $object->cliente_endereco = $cliente_endereco->logradouro.' '.$cliente_endereco->complemento;
                        $object->cliente_complemento = $cliente_endereco->complemento;
                        $object->cliente_numero = $cliente_endereco->numero;
                        $object->cliente_bairro = $cliente_endereco->bairro;
                        $object->cliente_cep = $cliente_endereco->cep;
                        $object->cliente_cidade = $cliente_endereco->cidade->nome;
                        $object->cliente_cidade_codibge = $cliente_endereco->cidade->codigo_ibge;
                        $object->cliente_estado = $cliente_endereco->cidade->estado->sigla;

                        if (!isset($cliente_endereco->cidade->pais_id))
                        {
                            $object->cliente_cpais = '1058';
                            $object->cliente_xpais = 'BRASIL';
                        }
                        else
                        {
                            $object->cliente_cpais = $cliente_endereco->cidade->pais->codigo_pais;
                            $object->cliente_xpais = $cliente_endereco->cidade->pais->nome;
                        }
                    }

                    TForm::sendData(self::$formName, $object);

                }

                TTransaction::close();
            }
            else
            {
                 $object = new stdClass();

                 $object->cliente_nome            = '';
                 $object->cliente_cpfcnpj         = '';
                 $object->cliente_inscest         = '';
                 $object->cliente_inscmuni        = '';
                 $object->cliente_fone            = '';
                 $object->notafiscal_indiedest_id = '';

                 $object->cliente_endereco        = '';
                 $object->cliente_complemento     = '';
                 $object->cliente_numero          = '';
                 $object->cliente_bairro          = '';
                 $object->cliente_cep             = '';
                 $object->cliente_cidade          = '';
                 $object->cliente_cidade_codibge  = '';
                 $object->cliente_estado          = '';    
                 $object->cliente_cpais           = '';    
                 $object->cliente_xpais           = '';   

                 TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function OnBuscaCepEntrega($param = null) 
    {
        try 
        {

                if(isset($param['cep_entrega'])){
                $cep_entrega=consultarCEP::CEP($param['cep_entrega']);
                $object = new stdClass();
                $object->retirada_uf =$cep_entrega->state;
                $object->entrega_xlgr =$cep_entrega->address_name;
                $object->entrega_xbairro =$cep_entrega->district;
                $object->entrega_cmun =$cep_entrega->city_ibge;
                $object->entrega_xmun =$cep_entrega->city;
                $object->entrega_uf =$cep_entrega->state;
                TForm::sendData(self::$formName, $object);

}

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function OnBuscaCepRetirada($param = null) 
    {
        try 
        {

                if(isset($param['cep_retirada'])){
                $cep_eretirada=consultarCEP::CEP($param['cep_retirada']);
                $object = new stdClass();
                $object->retirada_uf =$cep_eretirada->state;
                $object->retirada_xlgr =$cep_eretirada->address_name;
                $object->retirada_xbairro =$cep_eretirada->district;
                $object->retirada_cmun =$cep_eretirada->city_ibge;
                $object->retirada_xmun =$cep_eretirada->city;
                $object->retirada_uf =$cep_eretirada->state;
                TForm::sendData(self::$formName, $object);

                }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onChangeAmbiente($param = null) 
    {
        try 
        {
            if (isset($param['notafiscal_tpamb_id']) && $param['notafiscal_tpamb_id']&&isset($param['notafiscal_tpamb_id']) && $param['notafiscal_tpamb_id'])
            {
                if (isset($param['notafiscal_mod_id']) && $param['notafiscal_mod_id']&&isset($param['notafiscal_mod_id']) && $param['notafiscal_mod_id']){
                    if (isset($param['nf_tipodocumento_id']) && $param['nf_tipodocumento_id']&&isset($param['nf_tipodocumento_id']) && $param['nf_tipodocumento_id'])
                    {
                        $criteria = new TCriteria();
                        $criteria->add(new TFilter('notafiscal_tpamb_id', '=', $param['notafiscal_tpamb_id']));         
                        $criteria->add(new TFilter('notafiscal_mod_id', '=', $param['notafiscal_mod_id']));  
                        $criteria->add(new TFilter('notafiscal_tipodocumento_id', '=', $param['nf_tipodocumento_id']));  
                        $criteria->add(new TFilter('system_unit_id', '=', TSession::getValue('userunitid')));  

                        TDBCombo::reloadFromModel(self::$formName, 'serie', self::$database, 'NotafiscalSeries', 'serie', '{serie}', 'serie asc', $criteria, TRUE); 
                    }
                    else
                    {
                        TCombo::clearField(self::$formName, 'serie'); 
                    }

                }
                else
                {
                    TCombo::clearField(self::$formName, 'serie'); 
                }

            }
            else 
            { 
                TCombo::clearField(self::$formName, 'serie'); 
            }  

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onChangeTipoDocumento($param = null) 
    {
        try 
        {
            if (isset($param['notafiscal_tpamb_id']) && $param['notafiscal_tpamb_id']&&isset($param['notafiscal_tpamb_id']) && $param['notafiscal_tpamb_id'])
            {
                if (isset($param['notafiscal_mod_id']) && $param['notafiscal_mod_id']&&isset($param['notafiscal_mod_id']) && $param['notafiscal_mod_id']){
                    if (isset($param['nf_tipodocumento_id']) && $param['nf_tipodocumento_id']&&isset($param['nf_tipodocumento_id']) && $param['nf_tipodocumento_id']){
                        $criteria = new TCriteria();
                        $criteria->add(new TFilter('notafiscal_tpamb_id', '=', $param['notafiscal_tpamb_id']));         
                        $criteria->add(new TFilter('notafiscal_mod_id', '=', $param['notafiscal_mod_id']));  
                        $criteria->add(new TFilter('notafiscal_tipodocumento_id', '=', $param['nf_tipodocumento_id']));  

                        TDBCombo::reloadFromModel(self::$formName, 'serie', self::$database, 'NotafiscalSeries', 'serie', '{serie}', 'serie asc', $criteria, TRUE); 
                    }else{
                        TCombo::clearField(self::$formName, 'serie'); 
                    }

                }else{
                    TCombo::clearField(self::$formName, 'serie'); 
                }

            }else 
            { 
                TCombo::clearField(self::$formName, 'serie'); 
            }  

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onConsultaCEP($param = null) 
    {
        try 
        {
            //code here
            if(!empty($param['cliente_cep']))
            {
                TTransaction::open(self::$database);
                $dadosCep = CEPService::get($param['cliente_cep']);
                TTransaction::close();

                if($dadosCep)
                {
                    $object = new stdClass();

            	    $object->cliente_endereco = $dadosCep->rua;
                    $object->cliente_bairro   = $dadosCep->bairro;
                    $object->cliente_cidade   = $dadosCep->cidade;
                    $object->cliente_cidade_codibge = $dadosCep->codigo_ibge;
                    $object->cliente_estado   = $dadosCep->uf;

                    if (!isset($dadosCep->cidade->pais_id))
                    {
                        $object->cliente_cpais = '1058';
                        $object->cliente_xpais = 'BRASIL';
                    }
                    else
                    {
                        $object->cliente_cpais = $cliente_endereco->cidade->pais->codigo_pais;
                        $object->cliente_xpais = $cliente_endereco->cidade->pais->nome;
                    }                    

                    TForm::sendData(self::$formName, $object);    
                }

            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onNovoItem($param = null) 
    {
        try 
        {
                if($param['id'] == '')
                {
                    throw new Exception('Favor salvar a nota antes de adicionar itens nela.');
                }

                TApplication::loadPage('NotafiscalItensForm', 'onShow', ['nota_fiscal_id' => $param['id']]);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailNotafiscalFreteVolumesNotafiscal($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $__row__id = !empty($data->notafiscal_frete_volumes_notafiscal__row__id) ? $data->notafiscal_frete_volumes_notafiscal__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotafiscalFreteVolumes();
            $grid_data->__row__id = $__row__id;
            $grid_data->qVol = $data->notafiscal_frete_volumes_notafiscal_qVol;
            $grid_data->id = $data->notafiscal_frete_volumes_notafiscal_id;
            $grid_data->nVol = $data->notafiscal_frete_volumes_notafiscal_nVol;
            $grid_data->esp = $data->notafiscal_frete_volumes_notafiscal_esp;
            $grid_data->marca = $data->notafiscal_frete_volumes_notafiscal_marca;
            $grid_data->pesol = $data->notafiscal_frete_volumes_notafiscal_pesol;
            $grid_data->pesob = $data->notafiscal_frete_volumes_notafiscal_pesob;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['qVol'] =  $param['notafiscal_frete_volumes_notafiscal_qVol'] ?? null;
            $__row__data['__display__']['id'] =  $param['notafiscal_frete_volumes_notafiscal_id'] ?? null;
            $__row__data['__display__']['nVol'] =  $param['notafiscal_frete_volumes_notafiscal_nVol'] ?? null;
            $__row__data['__display__']['esp'] =  $param['notafiscal_frete_volumes_notafiscal_esp'] ?? null;
            $__row__data['__display__']['marca'] =  $param['notafiscal_frete_volumes_notafiscal_marca'] ?? null;
            $__row__data['__display__']['pesol'] =  $param['notafiscal_frete_volumes_notafiscal_pesol'] ?? null;
            $__row__data['__display__']['pesob'] =  $param['notafiscal_frete_volumes_notafiscal_pesob'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->notafiscal_frete_volumes_notafiscal_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('notafiscal_frete_volumes_notafiscal_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->notafiscal_frete_volumes_notafiscal_qVol = '';
            $data->notafiscal_frete_volumes_notafiscal_id = '';
            $data->notafiscal_frete_volumes_notafiscal_nVol = '';
            $data->notafiscal_frete_volumes_notafiscal_esp = '';
            $data->notafiscal_frete_volumes_notafiscal_marca = '';
            $data->notafiscal_frete_volumes_notafiscal_pesol = '';
            $data->notafiscal_frete_volumes_notafiscal_pesob = '';
            $data->notafiscal_frete_volumes_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61b26bcf71697');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNotafiscalDupNotafiscal($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $__row__id = !empty($data->notafiscal_dup_notafiscal__row__id) ? $data->notafiscal_dup_notafiscal__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotafiscalDup();
            $grid_data->__row__id = $__row__id;
            $grid_data->ndup = $data->notafiscal_dup_notafiscal_ndup;
            $grid_data->id = $data->notafiscal_dup_notafiscal_id;
            $grid_data->vdup = $data->notafiscal_dup_notafiscal_vdup;
            $grid_data->dvenc = $data->notafiscal_dup_notafiscal_dvenc;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['ndup'] =  $param['notafiscal_dup_notafiscal_ndup'] ?? null;
            $__row__data['__display__']['id'] =  $param['notafiscal_dup_notafiscal_id'] ?? null;
            $__row__data['__display__']['vdup'] =  $param['notafiscal_dup_notafiscal_vdup'] ?? null;
            $__row__data['__display__']['dvenc'] =  $param['notafiscal_dup_notafiscal_dvenc'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->notafiscal_dup_notafiscal_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('notafiscal_dup_notafiscal_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->notafiscal_dup_notafiscal_ndup = '';
            $data->notafiscal_dup_notafiscal_id = '';
            $data->notafiscal_dup_notafiscal_vdup = '';
            $data->notafiscal_dup_notafiscal_dvenc = '';
            $data->notafiscal_dup_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61a00abfeeb9e');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNotafiscalPagNotafiscal($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Tipo de pagamento", 'name'=>"notafiscal_pag_notafiscal_notafiscal_tpag_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->notafiscal_pag_notafiscal__row__id) ? $data->notafiscal_pag_notafiscal__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotafiscalPag();
            $grid_data->__row__id = $__row__id;
            $grid_data->notafiscal_tpag_id = $data->notafiscal_pag_notafiscal_notafiscal_tpag_id;
            $grid_data->id = $data->notafiscal_pag_notafiscal_id;
            $grid_data->vpag = $data->notafiscal_pag_notafiscal_vpag;
            $grid_data->xpag = $data->notafiscal_pag_notafiscal_xpag;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['notafiscal_tpag_id'] =  $param['notafiscal_pag_notafiscal_notafiscal_tpag_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['notafiscal_pag_notafiscal_id'] ?? null;
            $__row__data['__display__']['vpag'] =  $param['notafiscal_pag_notafiscal_vpag'] ?? null;
            $__row__data['__display__']['xpag'] =  $param['notafiscal_pag_notafiscal_xpag'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->notafiscal_pag_notafiscal_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('notafiscal_pag_notafiscal_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->notafiscal_pag_notafiscal_notafiscal_tpag_id = '';
            $data->notafiscal_pag_notafiscal_id = '';
            $data->notafiscal_pag_notafiscal_vpag = '';
            $data->notafiscal_pag_notafiscal_xpag = '';
            $data->notafiscal_pag_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#619ed34a8f5fa');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNotafiscalRefecfNotafiscal($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Notafiscal refecfmod id", 'name'=>"notafiscal_refecf_notafiscal_notafiscal_refecfmod_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->notafiscal_refecf_notafiscal__row__id) ? $data->notafiscal_refecf_notafiscal__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotafiscalRefecf();
            $grid_data->__row__id = $__row__id;
            $grid_data->notafiscal_refecfmod_id = $data->notafiscal_refecf_notafiscal_notafiscal_refecfmod_id;
            $grid_data->id = $data->notafiscal_refecf_notafiscal_id;
            $grid_data->necf = $data->notafiscal_refecf_notafiscal_necf;
            $grid_data->ncoo = $data->notafiscal_refecf_notafiscal_ncoo;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['notafiscal_refecfmod_id'] =  $param['notafiscal_refecf_notafiscal_notafiscal_refecfmod_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['notafiscal_refecf_notafiscal_id'] ?? null;
            $__row__data['__display__']['necf'] =  $param['notafiscal_refecf_notafiscal_necf'] ?? null;
            $__row__data['__display__']['ncoo'] =  $param['notafiscal_refecf_notafiscal_ncoo'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->notafiscal_refecf_notafiscal_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('notafiscal_refecf_notafiscal_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->notafiscal_refecf_notafiscal_notafiscal_refecfmod_id = '';
            $data->notafiscal_refecf_notafiscal_id = '';
            $data->notafiscal_refecf_notafiscal_necf = '';
            $data->notafiscal_refecf_notafiscal_ncoo = '';
            $data->notafiscal_refecf_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61e2d3ecff51d');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNotafiscalRefnfeNotafiscal($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Chave Refêrenciada", 'name'=>"notafiscal_refnfe_notafiscal_refnfe", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->notafiscal_refnfe_notafiscal__row__id) ? $data->notafiscal_refnfe_notafiscal__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotafiscalRefnfe();
            $grid_data->__row__id = $__row__id;
            $grid_data->refnfe = $data->notafiscal_refnfe_notafiscal_refnfe;
            $grid_data->id = $data->notafiscal_refnfe_notafiscal_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['refnfe'] =  $param['notafiscal_refnfe_notafiscal_refnfe'] ?? null;
            $__row__data['__display__']['id'] =  $param['notafiscal_refnfe_notafiscal_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->notafiscal_refnfe_notafiscal_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('notafiscal_refnfe_notafiscal_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->notafiscal_refnfe_notafiscal_refnfe = '';
            $data->notafiscal_refnfe_notafiscal_id = '';
            $data->notafiscal_refnfe_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61e2d4beff521');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailNotafiscalAutxmlNotafiscal($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"CPF/CNPJ", 'name'=>"notafiscal_autxml_notafiscal_cpf_cnpj", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->notafiscal_autxml_notafiscal__row__id) ? $data->notafiscal_autxml_notafiscal__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new NotafiscalAutxml();
            $grid_data->__row__id = $__row__id;
            $grid_data->cpf_cnpj = $data->notafiscal_autxml_notafiscal_cpf_cnpj;
            $grid_data->id = $data->notafiscal_autxml_notafiscal_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['cpf_cnpj'] =  $param['notafiscal_autxml_notafiscal_cpf_cnpj'] ?? null;
            $__row__data['__display__']['id'] =  $param['notafiscal_autxml_notafiscal_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->notafiscal_autxml_notafiscal_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('notafiscal_autxml_notafiscal_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->notafiscal_autxml_notafiscal_cpf_cnpj = '';
            $data->notafiscal_autxml_notafiscal_id = '';
            $data->notafiscal_autxml_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#622268a80e1ef');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailNotafiscalFreteVolumes($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->notafiscal_frete_volumes_notafiscal_qVol = $__row__data->__display__->qVol ?? null;
            $data->notafiscal_frete_volumes_notafiscal_id = $__row__data->__display__->id ?? null;
            $data->notafiscal_frete_volumes_notafiscal_nVol = $__row__data->__display__->nVol ?? null;
            $data->notafiscal_frete_volumes_notafiscal_esp = $__row__data->__display__->esp ?? null;
            $data->notafiscal_frete_volumes_notafiscal_marca = $__row__data->__display__->marca ?? null;
            $data->notafiscal_frete_volumes_notafiscal_pesol = $__row__data->__display__->pesol ?? null;
            $data->notafiscal_frete_volumes_notafiscal_pesob = $__row__data->__display__->pesob ?? null;
            $data->notafiscal_frete_volumes_notafiscal__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61b26bcf71697');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotafiscalFreteVolumes($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->notafiscal_frete_volumes_notafiscal_qVol = '';
            $data->notafiscal_frete_volumes_notafiscal_id = '';
            $data->notafiscal_frete_volumes_notafiscal_nVol = '';
            $data->notafiscal_frete_volumes_notafiscal_esp = '';
            $data->notafiscal_frete_volumes_notafiscal_marca = '';
            $data->notafiscal_frete_volumes_notafiscal_pesol = '';
            $data->notafiscal_frete_volumes_notafiscal_pesob = '';
            $data->notafiscal_frete_volumes_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('notafiscal_frete_volumes_notafiscal_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNotafiscalDup($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->notafiscal_dup_notafiscal_ndup = $__row__data->__display__->ndup ?? null;
            $data->notafiscal_dup_notafiscal_id = $__row__data->__display__->id ?? null;
            $data->notafiscal_dup_notafiscal_vdup = $__row__data->__display__->vdup ?? null;
            $data->notafiscal_dup_notafiscal_dvenc = $__row__data->__display__->dvenc ?? null;
            $data->notafiscal_dup_notafiscal__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61a00abfeeb9e');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotafiscalDup($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->notafiscal_dup_notafiscal_ndup = '';
            $data->notafiscal_dup_notafiscal_id = '';
            $data->notafiscal_dup_notafiscal_vdup = '';
            $data->notafiscal_dup_notafiscal_dvenc = '';
            $data->notafiscal_dup_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('notafiscal_dup_notafiscal_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNotafiscalPag($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->notafiscal_pag_notafiscal_notafiscal_tpag_id = $__row__data->__display__->notafiscal_tpag_id ?? null;
            $data->notafiscal_pag_notafiscal_id = $__row__data->__display__->id ?? null;
            $data->notafiscal_pag_notafiscal_vpag = $__row__data->__display__->vpag ?? null;
            $data->notafiscal_pag_notafiscal_xpag = $__row__data->__display__->xpag ?? null;
            $data->notafiscal_pag_notafiscal__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#619ed34a8f5fa');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotafiscalPag($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->notafiscal_pag_notafiscal_notafiscal_tpag_id = '';
            $data->notafiscal_pag_notafiscal_id = '';
            $data->notafiscal_pag_notafiscal_vpag = '';
            $data->notafiscal_pag_notafiscal_xpag = '';
            $data->notafiscal_pag_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('notafiscal_pag_notafiscal_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNotafiscalRefecf($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->notafiscal_refecf_notafiscal_notafiscal_refecfmod_id = $__row__data->__display__->notafiscal_refecfmod_id ?? null;
            $data->notafiscal_refecf_notafiscal_id = $__row__data->__display__->id ?? null;
            $data->notafiscal_refecf_notafiscal_necf = $__row__data->__display__->necf ?? null;
            $data->notafiscal_refecf_notafiscal_ncoo = $__row__data->__display__->ncoo ?? null;
            $data->notafiscal_refecf_notafiscal__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61e2d3ecff51d');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotafiscalRefecf($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->notafiscal_refecf_notafiscal_notafiscal_refecfmod_id = '';
            $data->notafiscal_refecf_notafiscal_id = '';
            $data->notafiscal_refecf_notafiscal_necf = '';
            $data->notafiscal_refecf_notafiscal_ncoo = '';
            $data->notafiscal_refecf_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('notafiscal_refecf_notafiscal_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNotafiscalRefnfe($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->notafiscal_refnfe_notafiscal_refnfe = $__row__data->__display__->refnfe ?? null;
            $data->notafiscal_refnfe_notafiscal_id = $__row__data->__display__->id ?? null;
            $data->notafiscal_refnfe_notafiscal__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61e2d4beff521');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotafiscalRefnfe($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->notafiscal_refnfe_notafiscal_refnfe = '';
            $data->notafiscal_refnfe_notafiscal_id = '';
            $data->notafiscal_refnfe_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('notafiscal_refnfe_notafiscal_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailNotafiscalAutxml($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->notafiscal_autxml_notafiscal_cpf_cnpj = $__row__data->__display__->cpf_cnpj ?? null;
            $data->notafiscal_autxml_notafiscal_id = $__row__data->__display__->id ?? null;
            $data->notafiscal_autxml_notafiscal__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#622268a80e1ef');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailNotafiscalAutxml($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->notafiscal_autxml_notafiscal_cpf_cnpj = '';
            $data->notafiscal_autxml_notafiscal_id = '';
            $data->notafiscal_autxml_notafiscal__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('notafiscal_autxml_notafiscal_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Notafiscal(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            Funcoes::SalvarUsuarioCadastro($object);

            if($data->id == "")
            {
                $object->system_unit_id = TSession::getValue('userunitid'); 
            }

            if(empty($object->numero))
            {
                $object->numero = funcaoNFE::ObterProximoSequencialNotaSerie($object->notafiscal_tpamb_id,
                                                                             $object->notafiscal_mod_id,
                                                                             $object->nf_tipodocumento_id,
                                                                             $object->serie,
                                                                             TSession::getValue('userunitid'));
            } 

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            TForm::sendData(self::$formName, (object)['numero' => $object->numero]);

            $notafiscal_autxml_notafiscal_items = $this->storeMasterDetailItems('NotafiscalAutxml', 'notafiscal_id', 'notafiscal_autxml_notafiscal', $object, $param['notafiscal_autxml_notafiscal_list___row__data'] ?? [], $this->form, $this->notafiscal_autxml_notafiscal_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->notafiscal_autxml_notafiscal_criteria); 

            $notafiscal_refnfe_notafiscal_items = $this->storeMasterDetailItems('NotafiscalRefnfe', 'notafiscal_id', 'notafiscal_refnfe_notafiscal', $object, $param['notafiscal_refnfe_notafiscal_list___row__data'] ?? [], $this->form, $this->notafiscal_refnfe_notafiscal_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->notafiscal_refnfe_notafiscal_criteria); 

            $notafiscal_refecf_notafiscal_items = $this->storeMasterDetailItems('NotafiscalRefecf', 'notafiscal_id', 'notafiscal_refecf_notafiscal', $object, $param['notafiscal_refecf_notafiscal_list___row__data'] ?? [], $this->form, $this->notafiscal_refecf_notafiscal_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->notafiscal_refecf_notafiscal_criteria); 

            $notafiscal_frete_volumes_notafiscal_items = $this->storeMasterDetailItems('NotafiscalFreteVolumes', 'notafiscal_id', 'notafiscal_frete_volumes_notafiscal', $object, $param['notafiscal_frete_volumes_notafiscal_list___row__data'] ?? [], $this->form, $this->notafiscal_frete_volumes_notafiscal_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->notafiscal_frete_volumes_notafiscal_criteria); 

            $notafiscal_dup_notafiscal_items = $this->storeMasterDetailItems('NotafiscalDup', 'notafiscal_id', 'notafiscal_dup_notafiscal', $object, $param['notafiscal_dup_notafiscal_list___row__data'] ?? [], $this->form, $this->notafiscal_dup_notafiscal_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->notafiscal_dup_notafiscal_criteria); 

            $notafiscal_pag_notafiscal_items = $this->storeMasterDetailItems('NotafiscalPag', 'notafiscal_id', 'notafiscal_pag_notafiscal', $object, $param['notafiscal_pag_notafiscal_list___row__data'] ?? [], $this->form, $this->notafiscal_pag_notafiscal_list, function($masterObject, $detailObject){ 

                Funcoes::SalvarUsuarioCadastro($detailObject);

            }, $this->notafiscal_pag_notafiscal_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $data->numero = $object->numero;

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

           // TForm::sendData(self::$formName, $object);

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacaoNfe($param = null) 
    {
        try 
        {
             $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve a nota para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('NotafiscalFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Notafiscal($key); // instantiates the Active Record 

                TSession::setValue('nota_fiscal_id', $object->id);

                $notafiscal_autxml_notafiscal_items = $this->loadMasterDetailItems('NotafiscalAutxml', 'notafiscal_id', 'notafiscal_autxml_notafiscal', $object, $this->form, $this->notafiscal_autxml_notafiscal_list, $this->notafiscal_autxml_notafiscal_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $notafiscal_refnfe_notafiscal_items = $this->loadMasterDetailItems('NotafiscalRefnfe', 'notafiscal_id', 'notafiscal_refnfe_notafiscal', $object, $this->form, $this->notafiscal_refnfe_notafiscal_list, $this->notafiscal_refnfe_notafiscal_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $notafiscal_refecf_notafiscal_items = $this->loadMasterDetailItems('NotafiscalRefecf', 'notafiscal_id', 'notafiscal_refecf_notafiscal', $object, $this->form, $this->notafiscal_refecf_notafiscal_list, $this->notafiscal_refecf_notafiscal_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $notafiscal_frete_volumes_notafiscal_items = $this->loadMasterDetailItems('NotafiscalFreteVolumes', 'notafiscal_id', 'notafiscal_frete_volumes_notafiscal', $object, $this->form, $this->notafiscal_frete_volumes_notafiscal_list, $this->notafiscal_frete_volumes_notafiscal_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $notafiscal_dup_notafiscal_items = $this->loadMasterDetailItems('NotafiscalDup', 'notafiscal_id', 'notafiscal_dup_notafiscal', $object, $this->form, $this->notafiscal_dup_notafiscal_list, $this->notafiscal_dup_notafiscal_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $notafiscal_pag_notafiscal_items = $this->loadMasterDetailItems('NotafiscalPag', 'notafiscal_id', 'notafiscal_pag_notafiscal', $object, $this->form, $this->notafiscal_pag_notafiscal_list, $this->notafiscal_pag_notafiscal_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 

                if(TSession::getValue('aba_items') == true)
                {
                    $this->form->setCurrentPage(2);    
                }
                else
                {
                    $this->form->setCurrentPage(0);    
                }

            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->notafiscal_situacao_id  = NotafiscalSituacao::EmDigitacao;

        $object->notafiscal_iddest_id    = NotafiscalIddest::OperacaoInterna;
        $object->notafiscal_tpimp_id     = NotafiscalTpimp::Paisagem;
        $object->notafiscal_tpemis_id    = NotafiscalTpemis::Normal;
        $object->notafiscal_finnfe_id    = NotafiscalFinnfe::NfeNormal;
        $object->notafiscal_indfinal_id  = NotafiscalIndfinal::Nao;
        $object->notafiscal_indpres_id   = NotafiscalIndpres::NaoSeAplica;
        $object->notafiscal_indpag_id    = NotafiscalIndpag::PagamentoAVista;
        $object->notafiscal_mod_id       = NotafiscalMod::NFe;
        $object->notafiscal_modfrete_id  = NotafiscalModfrete::SemOcorrencia;
        $object->nf_tipodocumento_id     = NotafiscalTipodocumento::Saida;
        $object->data_emissao            = date('d/m/Y H:i');
        $object->data_saida              = date('d/m/Y H:i');

        TTransaction::open(self::$database);

        $filial = SystemUnit::find(TSession::getValue('userunitid'));

        if($filial)
        {
            $object->notafiscal_crt_id   = $filial->notafiscal_crt_id;
            $object->notafiscal_tpimp_id = $filial->nfe_tpimp_id;
            $object->notafiscal_tpamb_id = $filial->nfe_tpamb_id;  

         /*  VER COMO IMPLEMENTAR PARA TRAZER A SERIE AUTOMATICAMENTE..

            if($object->notafiscal_tpamb_id == NotafiscalTpamb::Producao)
            {
                $object->notafiscal_series_id = $filial->nfe_producao_series_id;                        
            }
            else
            {
                $object->notafiscal_series_id = $filial->nfe_homologacao_series_id;
            } */           

            $natureza = funcaoNFE::buscarDadosCFOP($filial->id, NotafiscalMod::NFe);

            if(!is_null($natureza))
            {
                $object->natureza_operacao_id = $natureza->id;
                $object->notafiscal_indfinal_id = $natureza->consumidor_final_id;
                $object->infcpl = $natureza->obs_padrao;
            }

            $serie = NotafiscalSeries::where('notafiscal_tpamb_id', '=', $object->notafiscal_tpamb_id)
                                     ->where('notafiscal_mod_id', '=', $object->notafiscal_mod_id)
                                     ->where('notafiscal_tipodocumento_id', '=', $object->nf_tipodocumento_id)
                                     ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                     ->first();
            if($serie){
                $idserie = $serie->serie;    
            }else{
                $idserie = null;
            }

        }

        TTransaction::close();

        TForm::sendData(self::$formName, $object);

        TSession::setValue('aba_items', false);

        $this->fireEvents($object);

        $object = new stdClass();
        $object->serie = $idserie;

        TForm::sendData(self::$formName, $object);

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->notafiscal_tpamb_id))
            {
                $value = $object->notafiscal_tpamb_id;

                $obj->notafiscal_tpamb_id = $value;
            }
            if(isset($object->serie))
            {
                $value = $object->serie;

                $obj->serie = $value;
            }
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->notafiscal_tpamb_id))
            {
                $value = $object->notafiscal_tpamb_id;

                $obj->notafiscal_tpamb_id = $value;
            }
            if(isset($object->serie))
            {
                $value = $object->serie;

                $obj->serie = $value;
            }
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

