<?php

class NotafiscalFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Notafiscal';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Notafiscal';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $notafiscal = new Notafiscal($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Nota Fiscal");

        $transformed_notafiscal_data_hora_envio = call_user_func(function($value, $object, $row)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        }, $notafiscal->data_hora_envio, $notafiscal, null);

        $criteria_tdbarrowstep2 = new TCriteria();

        $filterVar = TRUE;
        $criteria_tdbarrowstep2->add(new TFilter('exibir', '=', $filterVar)); 

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'NotafiscalSituacao', 'id', '{descricao}','ordem asc' , $criteria_tdbarrowstep2);
        $lbid = new TLabel("Id:", '', '15px', 'B', '100%');
        $txid = new TTextDisplay($notafiscal->id, '', '15px', '');
        $lbnumero = new TLabel("Número:", '', '15px', 'B', '100%');
        $txnumero = new TTextDisplay($notafiscal->numero, '', '15px', '');
        $lbvendaid = new TLabel("Venda:", '', '15px', 'B', '100%');
        $txvendaid = new TTextDisplay($notafiscal->venda_id, '', '15px', '');
        $lbtipoambiente = new TLabel("Tipo Ambiente:", '', '15px', 'B', '100%');
        $txtipoambiente = new TTextDisplay($notafiscal->notafiscal_tpamb->descricao, '', '15px', '');
        $lbdataemissao = new TLabel("Data Emissão:", '', '15px', 'B', '100%');
        $txdataemissao = new TTextDisplay(TDateTime::convertToMask($notafiscal->data_emissao, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbdatasaida = new TLabel("Data Saída:", '', '15px', 'B', '100%');
        $txdatasaida = new TTextDisplay(TDateTime::convertToMask($notafiscal->data_saida, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbtipodocumento = new TLabel("Tipo de documento:", '', '15px', 'B', '100%');
        $txtipodocumento = new TTextDisplay($notafiscal->nf_tipodocumento->descricao, '', '15px', '');
        $lbmodelo = new TLabel("Modelo:", '', '15px', 'B', '100%');
        $txmodelo = new TTextDisplay($notafiscal->notafiscal_mod->modelo, '', '15px', '');
        $lbserie = new TLabel("Série:", '', '15px', 'B', '100%');
        $txserie = new TTextDisplay($notafiscal->serie, '', '15px', '');
        $lbnaturezaoperacao = new TLabel("Natureza de Operação:", '', '15px', 'B', '100%');
        $naturezzaaa = new TTextDisplay($notafiscal->natureza_operacao->descricao, '', '15px', '');
        $label94 = new TLabel("CRT (Código de Regime Tributário):", '', '15px', 'B', '100%');
        $text35 = new TTextDisplay($notafiscal->notafiscal_crt->descricao, '', '15px', '');
        $label4545 = new TLabel("Destino da Operação:", '', '15px', 'B', '100%');
        $txt_notafiscal_iddest_id = new TTextDisplay($notafiscal->notafiscal_iddest_id, '', '15px', '');
        $lbfinalidade = new TLabel("Finalidade:", '', '15px', 'B', '100%');
        $txfinalidade = new TTextDisplay($notafiscal->notafiscal_finnfe->descricao, '', '15px', '');
        $lbconsumidorfinal = new TLabel("Consumidor final:", '', '15px', 'B', '100%');
        $txconsumidorfinal = new TTextDisplay($notafiscal->notafiscal_indfinal->descricao, '', '15px', '');
        $lbpresenca = new TLabel("Presença:", '', '15px', 'B', '100%');
        $txpresenca = new TTextDisplay($notafiscal->notafiscal_indpres->descricao, '', '15px', '');
        $lbtipoemissao = new TLabel("Tipo de Emissão:", '', '15px', 'B', '100%');
        $txtipoemissao = new TTextDisplay($notafiscal->notafiscal_tpemis->descricao, '', '15px', '');
        $label656 = new TLabel("Tipo de Impressão:", '', '15px', 'B', '100%');
        $text4123 = new TTextDisplay($notafiscal->notafiscal_tpimp->descricao, '', '15px', '');
        $lbrodape = new TLabel("Informações Complementares:", '', '15px', 'B', '100%');
        $txinfcpl = new TTextDisplay($notafiscal->infcpl, '', '15px', '');
        $lbinformacoesadfisco = new TLabel("Informações adicionais do fisco:", '', '15px', 'B', '100%');
        $txinfoadfisco = new TTextDisplay($notafiscal->infadfisco, '', '15px', '');
        $lblcontingenciadatahora = new TLabel("Data/Hora:", '', '15px', 'B', '100%');
        $datetimetext3 = new TTextDisplay(TDateTime::convertToMask($notafiscal->contingencia_data, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbcontingenciamotivo = new TLabel("Motivo:", '', '15px', 'B', '100%');
        $txtcontingenciamotivo = new TTextDisplay($notafiscal->contingencia_motivo, '', '15px', '');
        $label340 = new TLabel("Nome:", '', '15px', 'B', '100%');
        $text43 = new TTextDisplay($notafiscal->cliente_nome, '', '15px', '');
        $label36 = new TLabel("CPF/CNPJ:", '', '15px', 'B', '100%');
        $text44 = new TTextDisplay($notafiscal->cliente_cpfcnpj, '', '15px', '');
        $label38 = new TLabel("Inscrição Estadual:", '', '15px', 'B', '100%');
        $text45 = new TTextDisplay($notafiscal->cliente_inscest, '', '15px', '');
        $label40 = new TLabel("Inscrição Municipal:", '', '15px', 'B', '100%');
        $text46 = new TTextDisplay($notafiscal->cliente_inscmuni, '', '15px', '');
        $label42 = new TLabel("Telefone:", '', '15px', 'B', '100%');
        $text47 = new TTextDisplay($notafiscal->cliente_fone, '', '15px', '');
        $lbindicadordaiedodestinatario = new TLabel("Indicador da IE do Destinatário", '', '15px', 'B', '100%');
        $txindicadordaiedodestinatario = new TTextDisplay($notafiscal->notafiscal_indiedest->descricao, '', '15px', '');
        $label44 = new TLabel("Suframa:", '', '15px', 'B', '100%');
        $text49 = new TTextDisplay($notafiscal->cliente_suframa, '', '15px', '');
        $label320 = new TLabel("CEP:", '', '15px', 'B', '100%');
        $text41 = new TTextDisplay($notafiscal->cliente_cep, '', '15px', '');
        $label180 = new TLabel("Endereço:", '', '15px', 'B', '100%');
        $text36 = new TTextDisplay($notafiscal->cliente_endereco, '', '15px', '');
        $label2000 = new TLabel("Número:", '', '15px', 'B', '100%');
        $text38 = new TTextDisplay($notafiscal->cliente_numero, '', '15px', '');
        $label220 = new TLabel("Complemento:", '', '15px', 'B', '100%');
        $text37 = new TTextDisplay($notafiscal->cliente_complemento, '', '15px', '');
        $label240 = new TLabel("Bairro:", '', '15px', 'B', '100%');
        $text39 = new TTextDisplay($notafiscal->cliente_bairro, '', '15px', '');
        $label260 = new TLabel("Cidade:", '', '15px', 'B', '100%');
        $text40 = new TTextDisplay($notafiscal->cliente_cidade, '', '15px', '');
        $label300 = new TLabel("Código IBGE:", '', '15px', 'B', '100%');
        $text48 = new TTextDisplay($notafiscal->cliente_cidade_codibge, '', '15px', '');
        $label280 = new TLabel("Estado:", '', '15px', 'B', '100%');
        $text42 = new TTextDisplay($notafiscal->cliente_estado, '', '15px', '');
        $label1856 = new TLabel("Modalidade do frete:", '', '15px', 'B', '100%');
        $text5389 = new TTextDisplay($notafiscal->notafiscal_modfrete->descricao, '', '15px', '');
        $label48 = new TLabel("Transportadora:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay($notafiscal->transp_nome, '', '15px', '');
        $label500 = new TLabel("CPF/CNPJ:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay($notafiscal->transp_cnpj, '', '15px', '');
        $label52 = new TLabel("Inscrição Estadual:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay($notafiscal->transp_inscest, '', '15px', '');
        $label54 = new TLabel("Endereço:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay($notafiscal->transp_endereco, '', '15px', '');
        $label56 = new TLabel("Cidade:", '', '15px', 'B', '100%');
        $text27 = new TTextDisplay($notafiscal->transp_cidade, '', '15px', '');
        $label60 = new TLabel("UF:", '', '15px', 'B', '100%');
        $text29 = new TTextDisplay($notafiscal->transp_uf, '', '15px', '');
        $label58 = new TLabel("Placa:", '', '15px', 'B', '100%');
        $text28 = new TTextDisplay($notafiscal->transp_placaveiculo, '', '15px', '');
        $label62 = new TLabel("UF do Veículo:", '', '15px', 'B', '100%');
        $text30 = new TTextDisplay($notafiscal->transp_veiculouf, '', '15px', '');
        $label64 = new TLabel("RNTC Veículo:", '', '15px', 'B', '100%');
        $text31 = new TTextDisplay($notafiscal->transp_veiculoRNTC, '', '15px', '');
        $label66 = new TLabel("Númeração:", '', '15px', 'B', '100%');
        $text32 = new TTextDisplay($notafiscal->transp_numeracao, '', '15px', '');
        $label2552 = new TLabel("Marcado:", '', '15px', 'B', '100%');
        $text59 = new TTextDisplay($notafiscal->entrega_marcado, '', '15px', '');
        $label2752 = new TLabel("CNPJ:", '', '15px', 'B', '100%');
        $text61 = new TTextDisplay($notafiscal->entrega_cpfcnpj, '', '15px', '');
        $label2941 = new TLabel("Endereço:", '', '15px', 'B', '100%');
        $text63 = new TTextDisplay($notafiscal->entrega_xlgr, '', '15px', '');
        $label3145 = new TLabel("Número:", '', '15px', 'B', '100%');
        $text65 = new TTextDisplay($notafiscal->entrega_nro, '', '15px', '');
        $label33 = new TLabel("Complemento:", '', '15px', 'B', '100%');
        $text67 = new TTextDisplay($notafiscal->entrega_xcpl, '', '15px', '');
        $label35 = new TLabel("Bairro:", '', '15px', 'B', '100%');
        $text69 = new TTextDisplay($notafiscal->entrega_xbairro, '', '15px', '');
        $label37 = new TLabel("Município:", '', '15px', 'B', '100%');
        $text71 = new TTextDisplay($notafiscal->entrega_xmun, '', '15px', '');
        $label39 = new TLabel("Código Município:", '', '15px', 'B', '100%');
        $text73 = new TTextDisplay($notafiscal->entrega_cmun, '', '15px', '');
        $label41 = new TLabel("UF:", '', '15px', 'B', '100%');
        $text75 = new TTextDisplay($notafiscal->entrega_uf, '', '15px', '');
        $label43 = new TLabel("Marcado:", '', '15px', 'B', '100%');
        $text77 = new TTextDisplay($notafiscal->retirada_marcado, '', '15px', '');
        $label45 = new TLabel("CNPJ:", '', '15px', 'B', '100%');
        $text79 = new TTextDisplay($notafiscal->retirada_cpfcnpj, '', '15px', '');
        $label47 = new TLabel("Endereço:", '', '15px', 'B', '100%');
        $text81 = new TTextDisplay($notafiscal->retirada_xlgr, '', '15px', '');
        $label49 = new TLabel("Número:", '', '15px', 'B', '100%');
        $text83 = new TTextDisplay($notafiscal->retirada_nro, '', '15px', '');
        $label51 = new TLabel("Complemento:", '', '15px', 'B', '100%');
        $text85 = new TTextDisplay($notafiscal->retirada_xcpl, '', '15px', '');
        $label53 = new TLabel("Bairro:", '', '15px', 'B', '100%');
        $text87 = new TTextDisplay($notafiscal->retirada_xbairro, '', '15px', '');
        $label55 = new TLabel("Município:", '', '15px', 'B', '100%');
        $text89 = new TTextDisplay($notafiscal->retirada_xmun, '', '15px', '');
        $label57 = new TLabel("Código Município:", '', '15px', 'B', '100%');
        $text91 = new TTextDisplay($notafiscal->retirada_cmun, '', '15px', '');
        $label59 = new TLabel("UF:", '', '15px', 'B', '100%');
        $text93 = new TTextDisplay($notafiscal->retirada_uf, '', '15px', '');
        $label3 = new TLabel("UF de embarque:", '', '15px', 'B', '100%');
        $txtexp_ufembarque = new TTextDisplay($notafiscal->exporta_ufsaidapais, '', '15px', '');
        $label5 = new TLabel("Local de embarque:", '', '15px', 'B', '100%');
        $txtxlocexporta = new TTextDisplay($notafiscal->exporta_xlocexporta, '', '15px', '');
        $label7 = new TLabel("Loca de despacho:", '', '15px', 'B', '100%');
        $txtxlocdespacho = new TTextDisplay($notafiscal->exporta_xlocdespacho, '', '15px', '');
        $label6212 = new TLabel("Número:", '', '15px', 'B', '100%');
        $text95 = new TTextDisplay($notafiscal->fatura_numero, '', '15px', '');
        $label6412 = new TLabel("Valor original:", '', '15px', 'B', '100%');
        $text97 = new TTextDisplay($notafiscal->fatura_valor_original, '', '15px', '');
        $label6656 = new TLabel("Valor desconto:", '', '15px', 'B', '100%');
        $text99 = new TTextDisplay($notafiscal->fatura_valor_desconto, '', '15px', '');
        $label6889 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $text101 = new TTextDisplay($notafiscal->fatura_valor_liquido, '', '15px', '');
        $label1612 = new TLabel("Pagamento:", '', '12px', 'B', '100%');
        $text51 = new TTextDisplay($notafiscal->notafiscal_indpag->descricao, '', '12px', '');
        $label68 = new TLabel("Base de cálculo do ICMS:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(number_format((double)$notafiscal->icms_basecalc, '2', ',', '.'), '', '15px', '');
        $label70 = new TLabel("Total do ICMS:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay(number_format((double)$notafiscal->icms_valor, '2', ',', '.'), '', '15px', '');
        $label72 = new TLabel("Base de cálculo do ICMS ST:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($notafiscal->icms_subst_base_calc, '', '15px', '');
        $label74 = new TLabel("ICMS Subs Valor:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(number_format((double)$notafiscal->icms_subst_valor, '2', ',', '.'), '', '15px', '');
        $label76 = new TLabel("Total do Frete:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay(number_format((double)$notafiscal->frete_valor, '2', ',', '.'), '', '15px', '');
        $label78 = new TLabel("Total do Seguro:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(number_format((double)$notafiscal->seguro_valor, '2', ',', '.'), '', '15px', '');
        $label82 = new TLabel("Total IPI:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay(number_format((double)$notafiscal->ipi_valor, '2', ',', '.'), '', '15px', '');
        $label91 = new TLabel("Total Desconto:", '', '15px', 'B', '100%');
        $text121 = new TTextDisplay($notafiscal->desconto_valor, '', '15px', '');
        $label80 = new TLabel("Outras Despesas:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(number_format((double)$notafiscal->outras_despesas, '2', ',', '.'), '', '15px', '');
        $label111 = new TLabel("Total IPI Devolvido:", '', '15px', 'B', '100%');
        $text141 = new TTextDisplay($notafiscal->ipi_vipidevol, '', '15px', '');
        $label95 = new TLabel("COFINS:", '', '15px', 'B', '100%');
        $text125 = new TTextDisplay($notafiscal->cofins_valor, '', '15px', '');
        $label93 = new TLabel("PIS:", '', '15px', 'B', '100%');
        $text123 = new TTextDisplay($notafiscal->pis_valor, '', '15px', '');
        $label84 = new TLabel("Total Produtos:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(number_format((double)$notafiscal->valor_total_produtos, '2', ',', '.'), '', '15px', '');
        $label86 = new TLabel("Total Nota:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(number_format((double)$notafiscal->valor_total_nota, '2', ',', '.'), '', '15px', '');
        $label103 = new TLabel("Troco:", '', '15px', 'B', '100%');
        $text133 = new TTextDisplay($notafiscal->vtroco, '', '15px', '');
        $label105 = new TLabel("FCP:", '', '15px', 'B', '100%');
        $text135 = new TTextDisplay($notafiscal->icms_vfcp, '', '15px', '');
        $label107 = new TLabel("FCP ST:", '', '15px', 'B', '100%');
        $text137 = new TTextDisplay($notafiscal->icms_vfcpst, '', '15px', '');
        $label109 = new TLabel("FCP ST Retido:", '', '15px', 'B', '100%');
        $text139 = new TTextDisplay($notafiscal->icms_vfcpstret, '', '15px', '');
        $label101 = new TLabel("FCP Destino:", '', '15px', 'B', '100%');
        $text131 = new TTextDisplay($notafiscal->vfcpufdest, '', '15px', '');
        $label97 = new TLabel("ICMS Interestadual Destino:", '', '15px', 'B', '100%');
        $text127 = new TTextDisplay($notafiscal->vicmsufdest, '', '15px', '');
        $label99 = new TLabel("ICMS Inter Emitente:", '', '15px', 'B', '100%');
        $text129 = new TTextDisplay($notafiscal->vicmsufremet, '', '15px', '');
        $label113 = new TLabel("Total Serviço:", '', '15px', 'B', '100%');
        $text143 = new TTextDisplay($notafiscal->issqn_vserv, '', '15px', '');
        $label115 = new TLabel("Base:", '', '15px', 'B', '100%');
        $text145 = new TTextDisplay($notafiscal->issqn_vbc, '', '15px', '');
        $label117 = new TLabel("ISS:", '', '15px', 'B', '100%');
        $text147 = new TTextDisplay($notafiscal->issqn_viss, '', '15px', '');
        $label119 = new TLabel("Competência:", '', '15px', 'B', '100%');
        $datetext1 = new TTextDisplay(TDate::convertToMask($notafiscal->issqn_dcompet, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label121 = new TLabel("REF Trib:", '', '15px', 'B', '100%');
        $text151 = new TTextDisplay($notafiscal->issqn_reftrib, '', '15px', '');
        $lbstatus = new TLabel("Status SEFAZ:", '', '15px', 'B', '100%');
        $txstatus = new TTextDisplay($notafiscal->status, '', '15px', '');
        $lbcodigosefaz = new TLabel("Código SEFAZ:", '', '15px', 'B', '100%');
        $txcodigosefaz = new TTextDisplay($notafiscal->codigo_sefaz, '', '15px', '');
        $lbmensagem = new TLabel("Mensagem:", '', '15px', 'B', '100%');
        $txmensagem = new TTextDisplay($notafiscal->mensagem, '', '15px', '');
        $label71 = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $text103 = new TTextDisplay($notafiscal->protocolo_envio, '', '15px', '');
        $label2 = new TLabel("Data e hora envio:", '', '15px', 'B', '100%');
        $text33 = new TTextDisplay($transformed_notafiscal_data_hora_envio, '', '15px', '');
        $label73 = new TLabel("Chave:", '', '15px', 'B', '100%');
        $text105 = new TTextDisplay($notafiscal->chave, '', '15px', '');
        $label77 = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $text109 = new TTextDisplay($notafiscal->protocolo_cancelamento, '', '15px', '');
        $label79 = new TLabel("Data e hora:", '', '15px', 'B', '100%');
        $datetimetext4 = new TTextDisplay(TDateTime::convertToMask($notafiscal->datahora_cancelamento, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label81 = new TLabel("Justificativa:", '', '15px', 'B', '100%');
        $text111 = new TTextDisplay($notafiscal->justificativa_cancelamento, '', '15px', '');
        $label83 = new TLabel("Protocolo:", '', '15px', 'B', '100%');
        $text113 = new TTextDisplay($notafiscal->cce_protocolo, '', '15px', '');
        $label85 = new TLabel("Data e hora:", '', '15px', 'B', '100%');
        $datetimetext6 = new TTextDisplay(TDateTime::convertToMask($notafiscal->cce_datahora_evento, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label87 = new TLabel("Sequencial:", '', '15px', 'B', '100%');
        $text117 = new TTextDisplay($notafiscal->cce_sequencial, '', '15px', '');
        $label89 = new TLabel("Correção:", '', '15px', 'B', '100%');
        $text119 = new TTextDisplay($notafiscal->cce_correcao, '', '15px', '');

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($notafiscal->notafiscal_situacao_id);



        $notafiscal_iddest = new NotafiscalIddest($notafiscal->notafiscal_iddest_id);

        $txt_notafiscal_iddest_id = new TTextDisplay($notafiscal_iddest->descricao, '', '15px', '');

        $this->form->appendPage("Geral");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$lbid,$txid],[$lbnumero,$txnumero],[$lbvendaid,$txvendaid]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([$lbtipoambiente,$txtipoambiente],[$lbdataemissao,$txdataemissao],[$lbdatasaida,$txdatasaida]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([$lbtipodocumento,$txtipodocumento],[$lbmodelo,$txmodelo],[$lbserie,$txserie]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$lbnaturezaoperacao,$naturezzaaa],[$label94,$text35],[$label4545,$txt_notafiscal_iddest_id]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addFields([$lbfinalidade,$txfinalidade],[$lbconsumidorfinal,$txconsumidorfinal],[$lbpresenca,$txpresenca]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->form->addFields([$lbtipoemissao,$txtipoemissao],[$label656,$text4123]);
        $row7->layout = [' col-sm-4','col-sm-3'];

        $row8 = $this->form->addFields([$lbrodape,$txinfcpl],[$lbinformacoesadfisco,$txinfoadfisco]);
        $row8->layout = [' col-sm-6',' col-sm-6'];

        $row9 = $this->form->addContent([new TFormSeparator("Contingência", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([$lblcontingenciadatahora,$datetimetext3],[$lbcontingenciamotivo,$txtcontingenciamotivo]);
        $row10->layout = [' col-sm-6','col-sm-6'];

        $this->form->appendPage("Cliente");
        $row11 = $this->form->addFields([$label340,$text43],[$label36,$text44]);
        $row11->layout = [' col-sm-8',' col-sm-4'];

        $row12 = $this->form->addFields([$label38,$text45],[$label40,$text46],[$label42,$text47]);
        $row12->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row13 = $this->form->addFields([$lbindicadordaiedodestinatario,$txindicadordaiedodestinatario],[$label44,$text49]);
        $row13->layout = [' col-sm-4',' col-sm-4'];

        $row14 = $this->form->addContent([new TFormSeparator("Endereço", '#333', '18', '#eee')]);
        $row15 = $this->form->addFields([$label320,$text41],[$label180,$text36],[$label2000,$text38],[$label220,$text37]);
        $row15->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row16 = $this->form->addFields([$label240,$text39],[$label260,$text40],[$label300,$text48],[$label280,$text42]);
        $row16->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $this->form->appendPage("Produtos");

        $this->notafiscal_itens_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_itens_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_itens_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_itens_notafiscal_id_list->disableDefaultClick();

        $action_onShow = new TDataGridAction(array('NotafiscalItensFormView', 'onShow'));
        $action_onShow->setUseButton(true);
        $action_onShow->setButtonClass('btn btn-default btn-sm');
        $action_onShow->setLabel("Detalhe");
        $action_onShow->setImage('fas:arrow-right #000000');
        $action_onShow->setField('id');

        $action_onShow->setParameter('key', '{id}');
        $this->notafiscal_itens_notafiscal_id_list->addAction($action_onShow);

        $column_cprod = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Código", 'cprod', 'left');
        $column_xprod = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Produto", 'xprod', 'left');
        $column_ucom = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Unidade", 'ucom', 'left');
        $column_qcom = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Quantidade", 'qcom', 'left');
        $column_vuncom_transformed = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Valor Unitário", 'vuncom', 'left');
        $column_vprod_transformed = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Valor Total", 'vprod', 'left');
        $column_icms_basecalc_transformed = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Bc. ICMS", 'icms_basecalc', 'left');
        $column_icms_valor_transformed = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("V. ICMS", 'icms_valor', 'left');
        $column_cfop = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Cfop", 'cfop', 'left');
        $column_vdesc = $this->notafiscal_itens_notafiscal_id_list->addQuickColumn("Desconto", 'vdesc', 'left');

        $column_vuncom_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_vprod_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_icms_basecalc_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_icms_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->notafiscal_itens_notafiscal_id_list->createModel();

        $criteria_notafiscal_itens_notafiscal_id = new TCriteria();
        $criteria_notafiscal_itens_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_itens_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_itens_notafiscal_id_items = NotafiscalItens::getObjects($criteria_notafiscal_itens_notafiscal_id);

        $this->notafiscal_itens_notafiscal_id_list->addItems($notafiscal_itens_notafiscal_id_items);

        $icon = new TImage('fas:box #000000');
        $title = new TTextDisplay("{$icon} Itens da Nota", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add(new BootstrapDatagridWrapper($this->notafiscal_itens_notafiscal_id_list));
        $panel->add($tableResponsiveDiv);

        $this->form->addContent([$panel]);

        $this->form->appendPage("Transporte");
        $row17 = $this->form->addContent([new TFormSeparator("Transportador", '#333', '18', '#eee')]);
        $row18 = $this->form->addFields([$label1856,$text5389]);
        $row18->layout = [' col-sm-12'];

        $row19 = $this->form->addFields([$label48,$text23],[$label500,$text24],[$label52,$text25]);
        $row19->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row20 = $this->form->addFields([$label54,$text26],[$label56,$text27],[$label60,$text29]);
        $row20->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row21 = $this->form->addContent([new TFormSeparator("Veículo", '#333', '18', '#eee')]);
        $row22 = $this->form->addFields([$label58,$text28],[$label62,$text30],[$label64,$text31],[$label66,$text32]);
        $row22->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row23 = $this->form->addContent([new TFormSeparator("Volumes", '#333', '18', '#eee')]);

        $this->notafiscal_frete_volumes_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_frete_volumes_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_frete_volumes_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_frete_volumes_notafiscal_id_list->disableDefaultClick();

        $column_qVol = $this->notafiscal_frete_volumes_notafiscal_id_list->addQuickColumn("Quantidade", 'qVol', 'left');
        $column_nVol = $this->notafiscal_frete_volumes_notafiscal_id_list->addQuickColumn("Número", 'nVol', 'left');
        $column_esp = $this->notafiscal_frete_volumes_notafiscal_id_list->addQuickColumn("Espécie", 'esp', 'left');
        $column_marca = $this->notafiscal_frete_volumes_notafiscal_id_list->addQuickColumn("Marca", 'marca', 'left');
        $column_pesol = $this->notafiscal_frete_volumes_notafiscal_id_list->addQuickColumn("Peso Líquido", 'pesol', 'left');
        $column_pesob = $this->notafiscal_frete_volumes_notafiscal_id_list->addQuickColumn("Peso Bruto", 'pesob', 'left');

        $this->notafiscal_frete_volumes_notafiscal_id_list->createModel();

        $criteria_notafiscal_frete_volumes_notafiscal_id = new TCriteria();
        $criteria_notafiscal_frete_volumes_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_frete_volumes_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_frete_volumes_notafiscal_id_items = NotafiscalFreteVolumes::getObjects($criteria_notafiscal_frete_volumes_notafiscal_id);

        $this->notafiscal_frete_volumes_notafiscal_id_list->addItems($notafiscal_frete_volumes_notafiscal_id_items);

        $icon = new TImage('fas:boxes #000000');
        $title = new TTextDisplay("{$icon} Volumes", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add(new BootstrapDatagridWrapper($this->notafiscal_frete_volumes_notafiscal_id_list));
        $panel->add($tableResponsiveDiv);

        $this->form->addContent([$panel]);

        $this->form->appendPage("Entrega/Retirada");
        $row24 = $this->form->addContent([new TFormSeparator("Entrega", '#333', '18', '#eee')]);
        $row25 = $this->form->addFields([$label2552,$text59],[$label2752,$text61],[$label2941,$text63],[$label3145,$text65]);
        $row25->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row26 = $this->form->addFields([$label33,$text67],[$label35,$text69],[$label37,$text71],[$label39,$text73]);
        $row26->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row27 = $this->form->addFields([$label41,$text75],[],[]);
        $row27->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row28 = $this->form->addContent([new TFormSeparator("Retirada", '#333', '18', '#eee')]);
        $row29 = $this->form->addFields([$label43,$text77],[$label45,$text79],[$label47,$text81],[$label49,$text83]);
        $row29->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row30 = $this->form->addFields([$label51,$text85],[$label53,$text87],[$label55,$text89],[$label57,$text91]);
        $row30->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row31 = $this->form->addFields([$label59,$text93],[],[]);
        $row31->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $this->form->appendPage("Exportação");
        $row32 = $this->form->addFields([$label3,$txtexp_ufembarque],[$label5,$txtxlocexporta],[$label7,$txtxlocdespacho]);
        $row32->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $this->form->appendPage("Cobrança");
        $row33 = $this->form->addContent([new TFormSeparator("Dados da Fatura", '#333', '18', '#eee')]);
        $row34 = $this->form->addFields([$label6212,$text95],[$label6412,$text97],[$label6656,$text99],[$label6889,$text101]);
        $row34->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row35 = $this->form->addContent([new TFormSeparator("Faturas", '#333', '18', '#eee')]);

        $this->notafiscal_dup_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_dup_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_dup_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_dup_notafiscal_id_list->disableDefaultClick();

        $column_ndup = $this->notafiscal_dup_notafiscal_id_list->addQuickColumn("Número", 'ndup', 'left');
        $column_vdup_transformed = $this->notafiscal_dup_notafiscal_id_list->addQuickColumn("Valor", 'vdup', 'left');
        $column_dvenc_transformed = $this->notafiscal_dup_notafiscal_id_list->addQuickColumn("Vencimento", 'dvenc', 'left');

        $column_vdup_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_dvenc_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->notafiscal_dup_notafiscal_id_list->createModel();

        $criteria_notafiscal_dup_notafiscal_id = new TCriteria();
        $criteria_notafiscal_dup_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_dup_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_dup_notafiscal_id_items = NotafiscalDup::getObjects($criteria_notafiscal_dup_notafiscal_id);

        $this->notafiscal_dup_notafiscal_id_list->addItems($notafiscal_dup_notafiscal_id_items);

        $icon = new TImage('fas:calculator #000000');
        $title = new TTextDisplay("{$icon} Faturas", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add(new BootstrapDatagridWrapper($this->notafiscal_dup_notafiscal_id_list));
        $panel->add($tableResponsiveDiv);

        $this->form->addContent([$panel]);

        $this->form->appendPage("Pagamento");
        $row36 = $this->form->addFields([$label1612,$text51]);
        $row36->layout = [' col-sm-12'];

        $this->notafiscal_pag_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_pag_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_pag_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_pag_notafiscal_id_list->disableDefaultClick();

        $column_notafiscal_tpag_descricao = $this->notafiscal_pag_notafiscal_id_list->addQuickColumn("Tipo", 'notafiscal_tpag->descricao', 'left');
        $column_vpag_transformed = $this->notafiscal_pag_notafiscal_id_list->addQuickColumn("Valor", 'vpag', 'left');
        $column_xpag = $this->notafiscal_pag_notafiscal_id_list->addQuickColumn("Descrição meio pgto (99-Outros)", 'xpag', 'left');

        $column_vpag_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->notafiscal_pag_notafiscal_id_list->createModel();

        $criteria_notafiscal_pag_notafiscal_id = new TCriteria();
        $criteria_notafiscal_pag_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_pag_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_pag_notafiscal_id_items = NotafiscalPag::getObjects($criteria_notafiscal_pag_notafiscal_id);

        $this->notafiscal_pag_notafiscal_id_list->addItems($notafiscal_pag_notafiscal_id_items);

        $icon = new TImage('fas:calculator #000000');
        $title = new TTextDisplay("{$icon} Pagamento", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add(new BootstrapDatagridWrapper($this->notafiscal_pag_notafiscal_id_list));
        $panel->add($tableResponsiveDiv);

        $this->form->addContent([$panel]);

        $this->form->appendPage("Doc. Vinculados e Referênciados");
        $row37 = $this->form->addContent([new TFormSeparator("Cupom Fiscal Vinculado a NF-e", '#333', '18', '#eee')]);

        $this->notafiscal_refecf_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_refecf_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_refecf_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_refecf_notafiscal_id_list->disableDefaultClick();

        $column_notafiscal_refecfmod_descricao = $this->notafiscal_refecf_notafiscal_id_list->addQuickColumn("Modelo", 'notafiscal_refecfmod->descricao', 'left');
        $column_necf = $this->notafiscal_refecf_notafiscal_id_list->addQuickColumn("Número ECF", 'necf', 'left');
        $column_ncoo = $this->notafiscal_refecf_notafiscal_id_list->addQuickColumn("Número COO", 'ncoo', 'left');

        $this->notafiscal_refecf_notafiscal_id_list->createModel();

        $criteria_notafiscal_refecf_notafiscal_id = new TCriteria();
        $criteria_notafiscal_refecf_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_refecf_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_refecf_notafiscal_id_items = NotafiscalRefecf::getObjects($criteria_notafiscal_refecf_notafiscal_id);

        $this->notafiscal_refecf_notafiscal_id_list->addItems($notafiscal_refecf_notafiscal_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->notafiscal_refecf_notafiscal_id_list));

        $this->form->addContent([$panel]);
        $row38 = $this->form->addContent([new TFormSeparator("Notas Referênciadas", '#333', '18', '#eee')]);

        $this->notafiscal_refnfe_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_refnfe_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_refnfe_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_refnfe_notafiscal_id_list->disableDefaultClick();

        $column_refnfe = $this->notafiscal_refnfe_notafiscal_id_list->addQuickColumn("Chave NFe/NFCe Refêrenciada", 'refnfe', 'left');

        $this->notafiscal_refnfe_notafiscal_id_list->createModel();

        $criteria_notafiscal_refnfe_notafiscal_id = new TCriteria();
        $criteria_notafiscal_refnfe_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_refnfe_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_refnfe_notafiscal_id_items = NotafiscalRefnfe::getObjects($criteria_notafiscal_refnfe_notafiscal_id);

        $this->notafiscal_refnfe_notafiscal_id_list->addItems($notafiscal_refnfe_notafiscal_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->notafiscal_refnfe_notafiscal_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Pessoas autorizadas a acessar o XML da NF-e");

        $this->notafiscal_autxml_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_autxml_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_autxml_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_autxml_notafiscal_id_list->disableDefaultClick();

        $column_cpf_cnpj = $this->notafiscal_autxml_notafiscal_id_list->addQuickColumn("CPF/CNPJ", 'cpf_cnpj', 'left');

        $this->notafiscal_autxml_notafiscal_id_list->createModel();

        $criteria_notafiscal_autxml_notafiscal_id = new TCriteria();
        $criteria_notafiscal_autxml_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_autxml_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_autxml_notafiscal_id_items = NotafiscalAutxml::getObjects($criteria_notafiscal_autxml_notafiscal_id);

        $this->notafiscal_autxml_notafiscal_id_list->addItems($notafiscal_autxml_notafiscal_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->notafiscal_autxml_notafiscal_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Totais");
        $row39 = $this->form->addFields([$label68,$text12],[$label70,$text13],[$label72,$text14],[$label74,$text15]);
        $row39->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row40 = $this->form->addFields([$label76,$text16],[$label78,$text17],[$label82,$text19],[$label91,$text121]);
        $row40->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row41 = $this->form->addFields([$label80,$text18],[$label111,$text141],[$label95,$text125],[$label93,$text123]);
        $row41->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row42 = $this->form->addFields([$label84,$text21],[$label86,$text22],[$label103,$text133]);
        $row42->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row43 = $this->form->addFields([$label105,$text135],[$label107,$text137],[$label109,$text139],[$label101,$text131]);
        $row43->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row44 = $this->form->addFields([$label97,$text127],[$label99,$text129]);
        $row44->layout = [' col-sm-3',' col-sm-3'];

        $row45 = $this->form->addContent([new TFormSeparator("ISSQN", '#333', '18', '#eee')]);
        $row46 = $this->form->addFields([$label113,$text143],[$label115,$text145],[$label117,$text147],[$label119,$datetext1],[$label121,$text151]);
        $row46->layout = [' col-sm-2',' col-sm-2',' col-sm-2',' col-sm-3',' col-sm-3'];

        $this->form->appendPage("Eventos SEFAZ");
        $row47 = $this->form->addFields([$lbstatus,$txstatus],[$lbcodigosefaz,$txcodigosefaz],[$lbmensagem,$txmensagem]);
        $row47->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row48 = $this->form->addContent([new TFormSeparator("Envio", '#333', '18', '#eee')]);
        $row49 = $this->form->addFields([$label71,$text103],[$label2,$text33],[$label73,$text105]);
        $row49->layout = [' col-sm-3',' col-sm-3',' col-sm-6'];

        $row50 = $this->form->addContent([new TFormSeparator("Cancelamento", '#333', '18', '#eee')]);
        $row51 = $this->form->addFields([$label77,$text109],[$label79,$datetimetext4],[$label81,$text111]);
        $row51->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row52 = $this->form->addContent([new TFormSeparator("Carta de Correção", '#333', '18', '#eee')]);
        $row53 = $this->form->addFields([$label83,$text113],[$label85,$datetimetext6],[$label87,$text117]);
        $row53->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row54 = $this->form->addFields([$label89,$text119]);
        $row54->layout = [' col-sm-12'];

        $this->form->appendPage("Logs");

        $this->notafiscal_logs_notafiscal_id_list = new TQuickGrid;
        $this->notafiscal_logs_notafiscal_id_list->disableHtmlConversion();
        $this->notafiscal_logs_notafiscal_id_list->style = 'width:100%';
        $this->notafiscal_logs_notafiscal_id_list->disableDefaultClick();

        $column_criado_em_transformed = $this->notafiscal_logs_notafiscal_id_list->addQuickColumn("Data/Hora", 'criado_em', 'left' , '20%');
        $column_system_users_name = $this->notafiscal_logs_notafiscal_id_list->addQuickColumn("Usuário", 'system_users->name', 'left' , '25%');
        $column_descricao = $this->notafiscal_logs_notafiscal_id_list->addQuickColumn("Descrição", 'descricao', 'left' , '65%');

        $column_criado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->notafiscal_logs_notafiscal_id_list->createModel();

        $criteria_notafiscal_logs_notafiscal_id = new TCriteria();
        $criteria_notafiscal_logs_notafiscal_id->add(new TFilter('notafiscal_id', '=', $notafiscal->id));

        $criteria_notafiscal_logs_notafiscal_id->setProperty('order', 'id desc');

        $notafiscal_logs_notafiscal_id_items = NotafiscalLogs::getObjects($criteria_notafiscal_logs_notafiscal_id);

        $this->notafiscal_logs_notafiscal_id_list->addItems($notafiscal_logs_notafiscal_id_items);

        $icon = new TImage('far:circle #000000');
        $title = new TTextDisplay("{$icon} Logs", '#333', '12px', '{$fontStyle}');

        $panel = new TPanelGroup($title, '#f5f5f5');
        $panel->class = 'panel panel-default formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->notafiscal_logs_notafiscal_id_list));

        $this->form->addContent([$panel]);

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        $btnNotafiscalFormOnEditAction = new TAction(['NotafiscalForm', 'onEdit'],['key'=>$notafiscal->id]);
        $btnNotafiscalFormOnEditLabel = new TLabel("Editar ");

        $btnNotafiscalFormOnEdit = $this->form->addHeaderAction($btnNotafiscalFormOnEditLabel, $btnNotafiscalFormOnEditAction, 'fas:edit #2196F3'); 
        $btnNotafiscalFormOnEditLabel->setFontSize('12px'); 
        $btnNotafiscalFormOnEditLabel->setFontColor('#333333'); 

        $btn_onenviarAction = new TAction([$this, 'onEnviar'],['key'=>$notafiscal->id]);
        $btn_onenviarLabel = new TLabel("Enviar");

        $btn_onenviar = $this->form->addHeaderAction($btn_onenviarLabel, $btn_onenviarAction, 'fas:cloud-upload-alt #4CAF50'); 
        $btn_onenviarLabel->setFontSize('12px'); 
        $btn_onenviarLabel->setFontColor('#333333'); 

        $btn_onpdfAction = new TAction([$this, 'onPDF'],['key'=>$notafiscal->id]);
        $btn_onpdfLabel = new TLabel("PDF - DANFE");

        $btn_onpdf = $this->form->addHeaderAction($btn_onpdfLabel, $btn_onpdfAction, 'far:file-pdf #F44336'); 
        $btn_onpdfLabel->setFontSize('12px'); 
        $btn_onpdfLabel->setFontColor('#333333'); 

        $btn_onxmlAction = new TAction([$this, 'onXml'],['key'=>$notafiscal->id]);
        $btn_onxmlLabel = new TLabel("XML");

        $btn_onxml = $this->form->addHeaderAction($btn_onxmlLabel, $btn_onxmlAction, 'far:file-code #FF9800'); 
        $btn_onxmlLabel->setFontSize('12px'); 
        $btn_onxmlLabel->setFontColor('#333333'); 

        $btn_oncancelarAction = new TAction([$this, 'onCancelar'],['key'=>$notafiscal->id]);
        $btn_oncancelarLabel = new TLabel("Cancelar");

        $btn_oncancelar = $this->form->addHeaderAction($btn_oncancelarLabel, $btn_oncancelarAction, 'fas:ban #F44336'); 
        $btn_oncancelarLabel->setFontSize('12px'); 
        $btn_oncancelarLabel->setFontColor('#333333'); 

        $btn_oncorrecaoAction = new TAction([$this, 'onCorrecao'],['key'=>$notafiscal->id]);
        $btn_oncorrecaoLabel = new TLabel("Carta de Correção");

        $btn_oncorrecao = $this->form->addHeaderAction($btn_oncorrecaoLabel, $btn_oncorrecaoAction, 'far:file-alt #000000'); 
        $btn_oncorrecaoLabel->setFontSize('12px'); 
        $btn_oncorrecaoLabel->setFontColor('#333333'); 

        $btn_onpdfcceAction = new TAction([$this, 'onPDFCCe'],['key'=>$notafiscal->id]);
        $btn_onpdfcceLabel = new TLabel("PDF - CARTA DE CORREÇÃO");

        $btn_onpdfcce = $this->form->addHeaderAction($btn_onpdfcceLabel, $btn_onpdfcceAction, 'far:file-pdf #2196F3'); 
        $btn_onpdfcceLabel->setFontSize('12px'); 
        $btn_onpdfcceLabel->setFontColor('#333333'); 

        $btn_onconsultasefazAction = new TAction([$this, 'onConsultaSefaz'],['key'=>$notafiscal->id]);
        $btn_onconsultasefazLabel = new TLabel("Consultar na SEFAZ");

        $btn_onconsultasefaz = $this->form->addHeaderAction($btn_onconsultasefazLabel, $btn_onconsultasefazAction, 'fas:search #00BCD4'); 
        $btn_onconsultasefazLabel->setFontSize('12px'); 
        $btn_onconsultasefazLabel->setFontColor('#333333'); 

        $btnNotafiscalListOnShowAction = new TAction(['NotafiscalList', 'onShow']);
        $btnNotafiscalListOnShowLabel = new TLabel("Voltar");

        $btnNotafiscalListOnShow = $this->form->addHeaderAction($btnNotafiscalListOnShowLabel, $btnNotafiscalListOnShowAction, 'fas:arrow-alt-circle-left #000000'); 
        $btnNotafiscalListOnShowLabel->setFontSize('12px'); 
        $btnNotafiscalListOnShowLabel->setFontColor('#333333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","Visualizar Nota Fiscal"]));
        }
        $container->add($this->form);

        if(is_null($notafiscal->chave))
        {
           TScript::create('document.getElementById("tbutton_consultar_na_sefaz").style.display = "none";');
        }

        //100,103,104,105,110,302
        if (($notafiscal->codigo_sefaz == 100) or
            ($notafiscal->codigo_sefaz == 103) or
            ($notafiscal->codigo_sefaz == 104) or
            ($notafiscal->codigo_sefaz == 105) or
            ($notafiscal->codigo_sefaz == 110) or
            ($notafiscal->codigo_sefaz == 302))
        {
            TScript::create('document.getElementById("tbutton_enviar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_editar_").style.display = "none";');
        }

        if($notafiscal->codigo_sefaz != 100)
        {
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_carta_de_correção").style.display = "none";');
        }  

        if($notafiscal->sn_carta_correcao == 'N')
        {
            TScript::create('document.getElementById("tbutton_pdf_-_carta_de_correÇÃo").style.display = "none";');
        }

        TTransaction::close();
        parent::add($container);

    }

    public static function onEnviar($param = null) 
    {
        try 
        {
            new TQuestion("Enviar Nota Fiscal?", new TAction([__CLASS__, 'onEnviarYes'], $param), new TAction([__CLASS__, 'onEnviarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onPDF($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota){
                 $arquivo = cloudDFE_NFE::pdfNFE($nota->chave); 

                 if(file_exists($arquivo)){
                        parent::openFile($arquivo);            
                 }else{
                     throw new Exception('DANFE PDF não encontrado!');
                 }

            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onXml($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota)
            {
                 $arquivo = cloudDFE_NFE::xmlNFE($nota->chave); 

                 if(file_exists($arquivo)){
                        parent::openFile($arquivo);            
                 }else{
                     throw new Exception('Arquivo XML não encontrado.');
                 }
            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onCancelar($param = null) 
    {
        try 
        {
            $pageParam = ['id' => $param['key']]; // ex.: = ['key' => 10]
            TApplication::loadPage('CancelementoNotaForm', 'onShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onCorrecao($param = null) 
    {
        try 
        {
            $pageParam = ['id' => $param['key']]; // ex.: = ['key' => 10]
            TApplication::loadPage('CartaCorrecaoNotaForm', 'onShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onPDFCCe($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota){
                 $arquivo = cloudDFE_NFE::pdfCCe($nota->chave); 

                 if(file_exists($arquivo)){
                        parent::openFile($arquivo);            
                 }else{
                     throw new Exception('PDF carta de correção não encontrado.');
                 }
            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onConsultaSefaz($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota)
            {
                cloudDFE_NFE::consultaNFE($nota->chave); 
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $nota->id]);

            TToast::show('success', "Consulta realizada com sucesso!", 'topRight', 'far:check-circle');

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onEnviarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $nota = Notafiscal::find($param['key']);

            if($nota)
            {
                if($nota->notafiscal_mod_id == NotafiscalMod::NFe)
                {
                    $retorno =  cloudDFE_NFE::criarNFE($nota);   

                     if ($retorno->codigo != 100)     
                     {
                         new TMessage('info', 'Retorno da SEFAZ: '."\n".cloudDFE_NFE::formataRetorno($retorno));                     
                     }
                     else
                     {
                         TApplication::loadPage(__CLASS__, 'onShow', ['key' => $nota->id]);

                         TToast::show('success', "Documento enviado com sucesso!", 'topRight', 'far:check-circle');
                     }

                }
                else
                {

                    $retorno =  cloudDFE_NFE::criarNfce($nota);   

                     if ($retorno->codigo != 100)     
                     {
                         new TMessage('info', 'Retorno da SEFAZ: '."\n".cloudDFE_NFE::formataRetorno($retorno));                     
                     }
                     else
                     {
                         TApplication::loadPage(__CLASS__, 'onShow', ['key' => $nota->id]);

                         TToast::show('success', "Documento enviado com sucesso!", 'topRight', 'far:check-circle');
                     }

                }

            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEnviarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

