<?php

class NotafiscalItensForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NotafiscalItens';
    private static $primaryKey = 'id';
    private static $formName = 'form_NotafiscalItensForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::setSize(0.80, null);
        parent::setTitle("Itens da Nota Fiscal");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Itens da Nota Fiscal");

        $criteria_produto_id = new TCriteria();
        $criteria_icms_cst = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_produto_id->add(new TFilter('id', 'in', "(SELECT produto_id FROM produto_filial WHERE system_unit_id = '{$filterVar}')")); 
        $filterVar = Resposta::Sim;
        $criteria_produto_id->add(new TFilter('habilitado_id', '=', $filterVar)); 
        $filterVar = "0";
        $criteria_icms_cst->add(new TFilter('id', '>', $filterVar)); 

        TTransaction::open(self::$database);

        $filial = SystemUnit::find(TSession::getValue('userunitid'));

        if($filial)
        {
            $criteria_icms_cst->add(new TFilter('regime_tributario_id', '=', $filial->notafiscal_crt_id));
        }

        TTransaction::close();

        $cprod = new TEntry('cprod');
        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{id}  - {nome}','nome asc' , $criteria_produto_id );
        $cean = new TEntry('cean');
        $ncm = new TEntry('ncm');
        $cest = new TEntry('cest');
        $ucom = new TEntry('ucom');
        $qcom = new TNumeric('qcom', '2', ',', '.' );
        $vuncom = new TNumeric('vuncom', '2', ',', '.' );
        $vdesc = new TNumeric('vdesc', '2', ',', '.' );
        $voutro = new TNumeric('voutro', '2', ',', '.' );
        $vfrete = new TNumeric('vfrete', '2', ',', '.' );
        $vseg = new TNumeric('vseg', '2', ',', '.' );
        $vprod = new TNumeric('vprod', '2', ',', '.' );
        $nve = new TEntry('nve');
        $cfop = new TEntry('cfop');
        $xped = new TEntry('xped');
        $nitemped = new TEntry('nitemped');
        $notafiscal_item_indtot_id = new TDBCombo('notafiscal_item_indtot_id', 'kraftsoft', 'NotafiscalItemIndtot', 'id', '{descricao}','descricao asc'  );
        $notafiscal_id = new THidden('notafiscal_id');
        $id = new THidden('id');
        $notafiscal_mod_id = new THidden('notafiscal_mod_id');
        $cliente_estado = new THidden('cliente_estado');
        $empresa_estado = new THidden('empresa_estado');
        $icms_cst = new TDBCombo('icms_cst', 'kraftsoft', 'CstIcms', 'cst_numero', '{descricao}','descricao asc' , $criteria_icms_cst );
        $notafiscal_item_orig_id = new TDBCombo('notafiscal_item_orig_id', 'kraftsoft', 'NotafiscalItemOrig', 'id', '{descricao}','descricao asc'  );
        $bhelper_620c2538f2a09 = new BHelper();
        $icms_basecalc = new TNumeric('icms_basecalc', '2', ',', '.' );
        $bhelper_620c2688f227c = new BHelper();
        $icms_aliquota = new TNumeric('icms_aliquota', '2', ',', '.' );
        $icms_valor = new TNumeric('icms_valor', '2', ',', '.' );
        $bhelper_620c272e9ed31 = new BHelper();
        $icms_pcredsn = new TNumeric('icms_pcredsn', '2', ',', '.' );
        $bhelper_620c274a2d04a = new BHelper();
        $icms_predbc = new TNumeric('icms_predbc', '2', ',', '.' );
        $bhelper_620c278140a72 = new BHelper();
        $notafiscal_item_modbc_id = new TDBCombo('notafiscal_item_modbc_id', 'kraftsoft', 'NotafiscalItemModbc', 'id', '{descricao}','id asc'  );
        $bhelper_620c2790d7083 = new BHelper();
        $icms_pmvast = new TNumeric('icms_pmvast', '2', ',', '.' );
        $bhelper_620c281415da9 = new BHelper();
        $icms_vbcst = new TNumeric('icms_vbcst', '2', ',', '.' );
        $bhelper_620c2840538b0 = new BHelper();
        $icms_picmsst = new TNumeric('icms_picmsst', '2', ',', '.' );
        $icms_vicmsst = new TNumeric('icms_vicmsst', '2', ',', '.' );
        $bhelper_620c287142482 = new BHelper();
        $icms_predbcst = new TNumeric('icms_predbcst', '2', ',', '.' );
        $ipi_cst = new TDBCombo('ipi_cst', 'kraftsoft', 'CstIpi', 'cst_numero', '{descricao}','descricao asc'  );
        $ipi_valor_base = new TNumeric('ipi_valor_base', '2', ',', '.' );
        $ipi_aliquota = new TNumeric('ipi_aliquota', '2', ',', '.' );
        $ipi_valor = new TNumeric('ipi_valor', '2', ',', '.' );
        $extipi = new TEntry('extipi');
        $ipi_pdevol = new TNumeric('ipi_pdevol', '2', ',', '.' );
        $ipi_vipidevol = new TNumeric('ipi_vipidevol', '2', ',', '.' );
        $pis_cst = new TDBCombo('pis_cst', 'kraftsoft', 'CstPis', 'cst_numero', '{descricao}','descricao asc'  );
        $pis_valor_base = new TNumeric('pis_valor_base', '2', ',', '.' );
        $pis_aliquota = new TNumeric('pis_aliquota', '2', ',', '.' );
        $pis_valor = new TNumeric('pis_valor', '2', ',', '.' );
        $cofins_cst = new TDBCombo('cofins_cst', 'kraftsoft', 'CstCofins', 'cst_numero', '{descricao}','descricao asc'  );
        $cofins_valor_base = new TNumeric('cofins_valor_base', '2', ',', '.' );
        $cofins_aliquota = new TNumeric('cofins_aliquota', '2', ',', '.' );
        $cofins_valor = new TNumeric('cofins_valor', '2', ',', '.' );
        $fcp_vbcfcp = new TNumeric('fcp_vbcfcp', '2', ',', '.' );
        $fcp_pfcp = new TNumeric('fcp_pfcp', '2', ',', '.' );
        $fcp_vfcp = new TNumeric('fcp_vfcp', '2', ',', '.' );
        $fcp_vbcfcpst = new TNumeric('fcp_vbcfcpst', '2', ',', '.' );
        $fcp_pfcpst = new TNumeric('fcp_pfcpst', '2', ',', '.' );
        $fcp_vfcpst = new TNumeric('fcp_vfcpst', '2', ',', '.' );
        $fcp_vbcfcpstret = new TNumeric('fcp_vbcfcpstret', '2', ',', '.' );
        $fcp_pfcpstret = new TNumeric('fcp_pfcpstret', '2', ',', '.' );
        $fcp_vfcpstret = new TNumeric('fcp_vfcpstret', '2', ',', '.' );
        $icms_vbcufdest = new TNumeric('icms_vbcufdest', '2', ',', '.' );
        $icms_vbcfcpufdest = new TNumeric('icms_vbcfcpufdest', '2', ',', '.' );
        $icms_pfcpufdest = new TNumeric('icms_pfcpufdest', '2', ',', '.' );
        $icms_vfcpufdest = new TNumeric('icms_vfcpufdest', '2', ',', '.' );
        $icms_picmsufdest = new TNumeric('icms_picmsufdest', '2', ',', '.' );
        $icms_picmsinter = new TNumeric('icms_picmsinter', '2', ',', '.' );
        $icms_picmsinterpart = new TNumeric('icms_picmsinterpart', '2', ',', '.' );
        $icms_vicmsufdest = new TNumeric('icms_vicmsufdest', '2', ',', '.' );
        $icms_vicmsufremet = new TNumeric('icms_vicmsufremet', '2', ',', '.' );

        $produto_id->setChangeAction(new TAction([$this,'onChangeProduto']));

        $qcom->setExitAction(new TAction([$this,'onExitQuantidade']));
        $vuncom->setExitAction(new TAction([$this,'onExitValorUnitario']));

        $produto_id->addValidation("Produto id", new TRequiredValidator()); 
        $qcom->addValidation("quantidade", new TRequiredValidator()); 
        $vuncom->addValidation("valor", new TRequiredValidator()); 
        $icms_cst->addValidation("CST ICMS", new TRequiredValidator()); 
        $notafiscal_item_orig_id->addValidation("Origem", new TRequiredValidator()); 
        $ipi_cst->addValidation("CST IPI", new TRequiredValidator()); 
        $pis_cst->addValidation("CST PIS", new TRequiredValidator()); 
        $cofins_cst->addValidation("CST COFINS", new TRequiredValidator()); 

        $cean->setMaxLength(50);
        $vprod->setEditable(false);
        $notafiscal_item_indtot_id->setEditable(false);

        $pis_cst->enableSearch();
        $icms_cst->enableSearch();
        $produto_id->enableSearch();
        $cofins_cst->enableSearch();

        $bhelper_620c278140a72->setContent("CST 00");
        $bhelper_620c272e9ed31->setContent("CST 101, 201, 900");
        $bhelper_620c281415da9->setContent("CST 201, 202, 203, 900");
        $bhelper_620c2840538b0->setContent("CST 201, 202, 203, 900");
        $bhelper_620c2538f2a09->setContent("CST 201, 202, 203, 900, 00");
        $bhelper_620c2688f227c->setContent("CST 201, 202, 203, 900, 00");

        $bhelper_620c2538f2a09->enableHover();
        $bhelper_620c2688f227c->enableHover();
        $bhelper_620c272e9ed31->enableHover();
        $bhelper_620c274a2d04a->enableHover();
        $bhelper_620c278140a72->enableHover();
        $bhelper_620c2790d7083->enableHover();
        $bhelper_620c281415da9->enableHover();
        $bhelper_620c2840538b0->enableHover();
        $bhelper_620c287142482->enableHover();

        $bhelper_620c2538f2a09->setSide("top");
        $bhelper_620c2688f227c->setSide("top");
        $bhelper_620c272e9ed31->setSide("top");
        $bhelper_620c274a2d04a->setSide("top");
        $bhelper_620c278140a72->setSide("top");
        $bhelper_620c2790d7083->setSide("top");
        $bhelper_620c281415da9->setSide("top");
        $bhelper_620c2840538b0->setSide("top");
        $bhelper_620c287142482->setSide("left");

        $bhelper_620c2538f2a09->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c2688f227c->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c272e9ed31->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c274a2d04a->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c278140a72->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c2790d7083->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c281415da9->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c2840538b0->setIcon(new TImage("fas:question #2196F3"));
        $bhelper_620c287142482->setIcon(new TImage("fas:question #2196F3"));

        $bhelper_620c2538f2a09->setTitle("Utilização deste campo");
        $bhelper_620c2688f227c->setTitle("Utilização deste campo");
        $bhelper_620c272e9ed31->setTitle("Utilização deste campo");
        $bhelper_620c274a2d04a->setTitle("Utilização deste campo");
        $bhelper_620c278140a72->setTitle("Utilização deste campo");
        $bhelper_620c2790d7083->setTitle("Utilização deste campo");
        $bhelper_620c281415da9->setTitle("Utilização deste campo");
        $bhelper_620c2840538b0->setTitle("Utilização deste campo");
        $bhelper_620c287142482->setTitle("Utilização deste campo");

        $id->setSize(200);
        $ncm->setSize('100%');
        $nve->setSize('100%');
        $cean->setSize('100%');
        $cest->setSize('100%');
        $ucom->setSize('100%');
        $qcom->setSize('100%');
        $vseg->setSize('100%');
        $cfop->setSize('100%');
        $xped->setSize('100%');
        $cprod->setSize('100%');
        $vdesc->setSize('100%');
        $vprod->setSize('100%');
        $vuncom->setSize('100%');
        $voutro->setSize('100%');
        $vfrete->setSize('100%');
        $extipi->setSize('100%');
        $ipi_cst->setSize('100%');
        $pis_cst->setSize('100%');
        $nitemped->setSize('100%');
        $icms_cst->setSize('100%');
        $fcp_pfcp->setSize('100%');
        $fcp_vfcp->setSize('100%');
        $ipi_valor->setSize('100%');
        $pis_valor->setSize('100%');
        $produto_id->setSize('100%');
        $notafiscal_id->setSize(200);
        $icms_valor->setSize('100%');
        $icms_vbcst->setSize('100%');
        $ipi_pdevol->setSize('100%');
        $cofins_cst->setSize('100%');
        $fcp_vbcfcp->setSize('100%');
        $fcp_pfcpst->setSize('100%');
        $fcp_vfcpst->setSize('100%');
        $cliente_estado->setSize(200);
        $empresa_estado->setSize(200);
        $icms_predbc->setSize('100%');
        $icms_pmvast->setSize('100%');
        $icms_pcredsn->setSize('100%');
        $icms_picmsst->setSize('100%');
        $icms_vicmsst->setSize('100%');
        $ipi_aliquota->setSize('100%');
        $pis_aliquota->setSize('100%');
        $cofins_valor->setSize('100%');
        $fcp_vbcfcpst->setSize('100%');
        $icms_basecalc->setSize('100%');
        $icms_aliquota->setSize('100%');
        $icms_predbcst->setSize('100%');
        $ipi_vipidevol->setSize('100%');
        $fcp_pfcpstret->setSize('100%');
        $fcp_vfcpstret->setSize('100%');
        $notafiscal_mod_id->setSize(200);
        $ipi_valor_base->setSize('100%');
        $pis_valor_base->setSize('100%');
        $icms_vbcufdest->setSize('100%');
        $cofins_aliquota->setSize('100%');
        $fcp_vbcfcpstret->setSize('100%');
        $icms_pfcpufdest->setSize('100%');
        $icms_vfcpufdest->setSize('100%');
        $icms_picmsinter->setSize('100%');
        $icms_picmsufdest->setSize('100%');
        $icms_vicmsufdest->setSize('100%');
        $cofins_valor_base->setSize('100%');
        $icms_vbcfcpufdest->setSize('100%');
        $icms_vicmsufremet->setSize('100%');
        $bhelper_620c2538f2a09->setSize('10');
        $bhelper_620c2688f227c->setSize('10');
        $bhelper_620c272e9ed31->setSize('10');
        $bhelper_620c274a2d04a->setSize('10');
        $bhelper_620c278140a72->setSize('10');
        $bhelper_620c2790d7083->setSize('10');
        $bhelper_620c281415da9->setSize('10');
        $bhelper_620c2840538b0->setSize('10');
        $bhelper_620c287142482->setSize('10');
        $icms_picmsinterpart->setSize('100%');
        $notafiscal_item_orig_id->setSize('100%');
        $notafiscal_item_modbc_id->setSize('100%');
        $notafiscal_item_indtot_id->setSize('100%');


        $this->form->appendPage("Dados");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Código:", null, '14px', null),$cprod],[new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$produto_id]);
        $row1->layout = [' col-sm-4',' col-sm-8'];

        $row2 = $this->form->addFields([new TLabel("EAN:", null, '14px', null, '100%'),$cean],[new TLabel("NCM:", null, '14px', null, '100%'),$ncm],[new TLabel("CEST:", null, '14px', null, '100%'),$cest]);
        $row2->layout = ['col-sm-4','col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Unidade:", null, '14px', null, '100%'),$ucom],[new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$qcom],[new TLabel("Valor Unitário:", '#ff0000', '14px', null, '100%'),$vuncom]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Desconto:", null, '14px', null, '100%'),$vdesc],[new TLabel("Outras Despesas:", null, '14px', null),$voutro],[new TLabel("Frete:", null, '14px', null, '100%'),$vfrete]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([new TLabel("Seguro:", null, '14px', null, '100%'),$vseg],[new TLabel("Total:", null, '14px', null, '100%'),$vprod],[new TLabel("NVE (Nomenclatura de Valor Aduaneiro e Estatística):", null, '14px', null, '100%'),$nve]);
        $row5->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row6 = $this->form->addFields([new TLabel("CFOP:", null, '14px', null, '100%'),$cfop],[new TLabel("Nº pedido:", null, '14px', null, '100%'),$xped],[new TLabel("Item pedido:", null, '14px', null, '100%'),$nitemped]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->form->addFields([new TLabel("Indicador de Totalizador:", null, '14px', null, '100%'),$notafiscal_item_indtot_id],[$notafiscal_id,$id],[$notafiscal_mod_id],[$cliente_estado,$empresa_estado]);
        $row7->layout = ['col-sm-4','col-sm-2','col-sm-2','col-sm-2'];

        $this->form->appendPage("ICMS");
        $row8 = $this->form->addFields([new TLabel("CST:", '#FF0000', '14px', null, '100%'),$icms_cst],[new TLabel("Origem:", '#FF0000', '14px', null),$notafiscal_item_orig_id]);
        $row8->layout = [' col-sm-6',' col-sm-6'];

        $row9 = $this->form->addFields([new TLabel("Base de cálculo ICMS:", null, '14px', null),$bhelper_620c2538f2a09,$icms_basecalc],[new TLabel("Aliquota ICMS:", null, '14px', null),$bhelper_620c2688f227c,$icms_aliquota],[new TLabel("Valor ICMS:", null, '14px', null, '100%'),$icms_valor]);
        $row9->layout = [' col-sm-3',' col-sm-3',' col-sm-3'];

        $row10 = $this->form->addFields([new TLabel("Aliquota Crédito:", null, '14px', null),$bhelper_620c272e9ed31,$icms_pcredsn],[new TLabel("Perc. da Red. de Base do ICMS:", null, '14px', null),$bhelper_620c274a2d04a,$icms_predbc]);
        $row10->layout = [' col-sm-3',' col-sm-3'];

        $row11 = $this->form->addFields([new TLabel("Modalid. de Determ. da BC ICMS:", null, '14px', null),$bhelper_620c278140a72,$notafiscal_item_modbc_id],[new TLabel("Margem valor agregado:", null, '14px', null),$bhelper_620c2790d7083,$icms_pmvast]);
        $row11->layout = [' col-sm-6',' col-sm-3'];

        $row12 = $this->form->addContent([new TFormSeparator("Substituição Tributária", '#333', '18', '#eee')]);
        $row13 = $this->form->addFields([new TLabel("Base de cálculo ICMS ST:", null, '14px', null),$bhelper_620c281415da9,$icms_vbcst],[new TLabel("Aliquota ICMS ST:", null, '14px', null),$bhelper_620c2840538b0,$icms_picmsst],[new TLabel("Valor ICMS ST:", null, '14px', null),$icms_vicmsst],[new TLabel("Perc. da Red. Base do ICMS ST:", null, '14px', null),$bhelper_620c287142482,$icms_predbcst]);
        $row13->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $this->form->appendPage("IPI");
        $row14 = $this->form->addFields([new TLabel("CST:", '#FF0000', '14px', null),$ipi_cst]);
        $row14->layout = [' col-sm-12'];

        $row15 = $this->form->addFields([new TLabel("Valor Base:", null, '14px', null, '100%'),$ipi_valor_base],[new TLabel("Aliquota:", null, '14px', null),$ipi_aliquota],[new TLabel("Valor:", null, '14px', null, '100%'),$ipi_valor],[new TLabel("Exceção IPI:", null, '14px', null, '100%'),$extipi]);
        $row15->layout = [' col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row16 = $this->form->addContent([new TFormSeparator("IPI Devolvido", '#333', '18', '#eee')]);
        $row17 = $this->form->addFields([new TLabel("Percentual da mercadoria devolvida:", null, '14px', null),$ipi_pdevol],[new TLabel("Valor do IPI devolvido:", null, '14px', null),$ipi_vipidevol]);
        $row17->layout = ['col-sm-3','col-sm-3'];

        $this->form->appendPage("PIS");
        $row18 = $this->form->addFields([new TLabel("CST:", '#FF0000', '14px', null, '100%'),$pis_cst],[new TLabel("Valor base:", null, '14px', null, '100%'),$pis_valor_base],[new TLabel("Aliquota:", null, '14px', null, '100%'),$pis_aliquota],[new TLabel("Valor:", null, '14px', null, '100%'),$pis_valor]);
        $row18->layout = [' col-sm-6','col-sm-2','col-sm-2','col-sm-2'];

        $this->form->appendPage("COFINS");
        $row19 = $this->form->addFields([new TLabel("CST:", null, '14px', null, '100%'),$cofins_cst],[new TLabel("Valor base:", null, '14px', null, '100%'),$cofins_valor_base],[new TLabel("Aliquota:", null, '14px', null, '100%'),$cofins_aliquota],[new TLabel("Valor:", null, '14px', null, '100%'),$cofins_valor]);
        $row19->layout = [' col-sm-6',' col-sm-2',' col-sm-2','col-sm-2'];

        $this->form->appendPage("FCP (Fundo de combate a pobreza)");
        $row20 = $this->form->addFields([new TLabel("Valor da base de cálculo do FCP:", null, '14px', null),$fcp_vbcfcp],[new TLabel("Percentual do FCP:", null, '14px', null),$fcp_pfcp],[new TLabel("Valor do FCP:", null, '14px', null),$fcp_vfcp],[]);
        $row20->layout = [' col-sm-3','col-sm-3','col-sm-3',' col-sm-3'];

        $row21 = $this->form->addContent([new TFormSeparator("Substituição Tributária", '#333', '18', '#eee')]);
        $row22 = $this->form->addFields([new TLabel("Valor da base de cálculo do FCP por substituição", null, '14px', null),new TLabel("tributária:", null, '14px', null),$fcp_vbcfcpst],[new TLabel("Percentual do FCP por substituição tributária", null, '14px', null),$fcp_pfcpst],[new TLabel("Valor do FCP por substituição tributária", null, '14px', null),$fcp_vfcpst]);
        $row22->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row23 = $this->form->addFields([new TLabel("Valor da base de cálculo do FCP retido anteriormente", null, '14px', null),new TLabel("por ST", null, '14px', null),$fcp_vbcfcpstret],[new TLabel("Percentual do FCP retido anteriormente", null, '14px', null),new TLabel("por substituição tributária", null, '14px', null),$fcp_pfcpstret],[new TLabel("Valor do FCP retido por substituição tributária", null, '14px', null),$fcp_vfcpstret]);
        $row23->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $this->form->appendPage("ICMS Intesrestadual");
        $row24 = $this->form->addFields([new TLabel("Valor da BC do ICMS na UF de destino:", null, '14px', null),$icms_vbcufdest],[new TLabel("Valor da BC FCP na UF de destino:", null, '14px', null),$icms_vbcfcpufdest],[new TLabel("Percentual do ICMS relativo ao Fundo de Combate à Pobreza (FCP) na UF de destino:", null, '14px', null, '100%'),$icms_pfcpufdest],[new TLabel("Valor do ICMS relativo ao Fundo de Combate à Pobreza (FCP) da UF de destino:", null, '14px', null, '100%'),$icms_vfcpufdest]);
        $row24->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row25 = $this->form->addFields([new TLabel("Alíquota interna da UF de destino:", null, '14px', null),$icms_picmsufdest],[new TLabel("Alíquota interestadual das UF envolvidas:", null, '14px', null, '100%'),$icms_picmsinter],[new TLabel("Percentual provisório de partilha do ICMS Interestadual:", null, '14px', null, '100%'),$icms_picmsinterpart],[new TLabel("Valor do ICMS Interestadual para a UF de destino:", null, '14px', null, '100%'),$icms_vicmsufdest]);
        $row25->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row26 = $this->form->addFields([new TLabel("Valor do ICMS Interestadual para a UF do remetente:", null, '14px', null, '100%'),$icms_vicmsufremet],[],[]);
        $row26->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::add($this->form);

    }

    public static function onExitQuantidade($param = null) 
    {
        try 
        {

            $qcom = (double) str_replace(',', '.', str_replace('.', '', $param['qcom']));
            $vuncom = (double) str_replace(',', '.', str_replace('.', '', $param['vuncom']));

            $vprod = $qcom * $vuncom ;
            $object = new stdClass();
            $object->vprod = number_format($vprod, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitValorUnitario($param = null) 
    {
        try 
        {
            $qcom = (double) str_replace(',', '.', str_replace('.', '', $param['qcom']));
            $vuncom = (double) str_replace(',', '.', str_replace('.', '', $param['vuncom']));

            $vprod = $qcom * $vuncom ;
            $object = new stdClass();
            $object->vprod = number_format($vprod, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onChangeProduto($param = null) 
    {
        try 
        {
            if (isset($param['produto_id']) && $param['produto_id'])
            {
                TTransaction::open(self::$database);

                $produto = Produto::find($param['produto_id']);

                if($produto)
                {
                    $object = new stdClass();
                    $object->cean = $produto->codigo_EAN;

                    $object->cprod =  funcaoNFE::RetornaCProd(TSession::getValue('notafiscal_cprod_padrao_id'),
                                                             $produto->id,
                                                             $produto->codigo_EAN,
                                                             $produto->referencia,
                                                             $produto->codigo_sku);
                    $object->xprod = $produto->nome;
                    $object->ncm = $produto->ncm;
                    $object->cest = $produto->cest;
                    $object->ucom = $produto->unidade_medida->sigla;
                    $object->utrib = $produto->unidade_medida->sigla;

                    //trazer o preço da filial..
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $produto->id)
                                                  ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                  ->first();

                    if($produtofilial)
                    {
                        $object->vuncom = number_format($produtofilial->preco_venda, 2, ',', '.');    
                    }

                    //verificando a exceção da natureza...
                    $naturezaexcecaoICMS = funcaoNFE::VerificaExcecaoNatureza($param['notafiscal_id'],
                                                                              $produto->id,
                                                                              $param['notafiscal_item_orig_id'],
                                                                              $produto->ncm);

                    if ($naturezaexcecaoICMS)
                    {
                        $object->cfop = NaturezaOperacao::ObterCFOPItem($param['cliente_estado'],$param['empresa_estado'],$naturezaexcecaoICMS);
                        $object->icms_cst = $naturezaexcecaoICMS->cst_icms->cst_numero; 
                        $object->pis_cst = $naturezaexcecaoICMS->cst_pis->cst_numero;
                        $object->cofins_cst = $naturezaexcecaoICMS->cst_cofins->cst_numero;
                        $object->ipi_cst = $naturezaexcecaoICMS->cst_ipi->cst_numero;                
                        $object->ip_cst = $naturezaexcecaoICMS->cst_ipi->cst_numero;
                        $object->icms_aliquota = $naturezaexcecaoICMS->icms_aliquota;
                        $object->ipi_aliquota = $naturezaexcecaoICMS->ipi_aliquota;
                        $object->pis_aliquota = $naturezaexcecaoICMS->pis_aliquota;
                        $object->cofins_aliquota = $naturezaexcecaoICMS->cofins_aliquota;
                        $object->pis_valor_base = $naturezaexcecaoICMS->pis_base;
                        $object->cofins_valor_base = $naturezaexcecaoICMS->cofins_base;
                        $object->icms_predbc = $naturezaexcecaoICMS->icms_pRedBC;
                        $object->icms_basecalc = $naturezaexcecaoICMS->icms_base;
                        $object->icms_pst = $naturezaexcecaoICMS->icms_pST;
                        $object->icms_pcredsn = $naturezaexcecaoICMS->icms_pCredSN;
                        $object->icms_pmvast = $naturezaexcecaoICMS->icms_pMVAST;
                        $object->icms_picmsst = $naturezaexcecaoICMS->icms_pICMSST;
                        $object->icms_vbcst = $naturezaexcecaoICMS->icms_baseST;

                        $object->notafiscal_item_modbc_id = $naturezaexcecaoICMS->notafiscal_item_modbc_id;
                        $object->notafiscal_item_modbcst_id = $naturezaexcecaoICMS->notafiscal_item_modbcst_id;
                        $object->notafiscal_item_motDesICMS_id = $naturezaexcecaoICMS->notafiscal_item_motDesICMS_id;                        
                    }

                    //$unidade = UnidadeMedida::Find($produto->unidade_medida_id);

                    TForm::sendData(self::$formName, $object);

                }

                TTransaction::close();
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new NotafiscalItens(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $modelonota = $data->notafiscal_mod_id;

            $object->utrib    = $data->ucom;
            $object->qtrib    = $data->qcom;
            $object->vuntrib  = $data->vuncom;
            $object->ceantrib = $data->cean;

            $object->vprod = $data->qcom * $data->vuncom;

            $produto = Produto::find($data->produto_id);
            if($produto){
                $object->xprod = $produto->nome;    
            }

            $object->store(); // save the object 

            Notafiscal::atualiza_totais_nota($object->notafiscal_id);

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

            TSession::setValue('aba_items', true);

            $pageParam = ['key' => $object->notafiscal_id]; // ex.: = ['key' => 10]

            if ($modelonota==NotafiscalMod::NFe)
            {
                TApplication::loadPage('NotafiscalForm', 'onEdit', $pageParam);
            }
            else
            {
                TApplication::loadPage('NotafiscalConsumidorForm', 'onEdit', $pageParam);
            }            

                TWindow::closeWindow(parent::getId()); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new NotafiscalItens($key); // instantiates the Active Record 

                $filial = SystemUnit::find(TSession::getValue('userunitid'));
                TSession::setValue('notafiscal_cprod_padrao_id',$filial->notafiscal_cprod_padrao_id);

                $nota = Notafiscal::find($object->notafiscal_id);  
                $object->notafiscal_mod_id = $nota->notafiscal_mod_id;
                $object->cliente_estado = $nota->cliente_estado;
                $object->empresa_estado = $filial->end_uf;                

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->notafiscal_id = $param['nota_fiscal_id'];
        $object->qcom = '1,00';
        $object->vuncom = '0,00';
        $object->vprod = '0,00';
        $object->vdesc = '0,00';
        $object->vseg = '0,00';
        $object->vfrete = '0,00';
        $object->vuntrib = '0,00';
        $object->icms_aliquota = '0,00';
        $object->icms_valor = '0,00';
        $object->icms_basecalc = '0,00';
        $object->notafiscal_item_indtot_id = NotafiscalItemIndtot::Um;
        $object->notafiscal_item_orig_id = NotafiscalItemOrig::Zero;

        TTransaction::open(self::$database);

        $nota = Notafiscal::find($param['nota_fiscal_id']);   

        $filial = SystemUnit::find(TSession::getValue('userunitid'));
        TSession::setValue('notafiscal_cprod_padrao_id',$filial->notafiscal_cprod_padrao_id);

        //salvando o modelo da nota em campo hiddeen para fazer tratativas caso necessário..
        $object->notafiscal_mod_id = $nota->notafiscal_mod_id;
        $object->cliente_estado = $nota->cliente_estado;
        $object->empresa_estado = $filial->end_uf;

        if($nota)
        {
            // $natureza = funcaoNFE::buscarDadosCFOP($nota->system_unit_id, $nota->notafiscal_mod_id);
            $natureza = NaturezaOperacao::find($nota->natureza_operacao_id);

            if(!is_null($natureza))
            {
                $object->cfop = NaturezaOperacao::ObterCFOPItem($nota->cliente_estado,$filial->end_uf,$natureza);
                $object->icms_cst = NaturezaOperacao::ObterCSTItem($nota->notafiscal_indiedest_id,$natureza);//  $natureza->cst_icms->cst_numero; 
                $object->pis_cst = $natureza->cst_pis->cst_numero;
                $object->cofins_cst = $natureza->cst_cofins->cst_numero;
                $object->ipi_cst = $natureza->cst_ipi->cst_numero;                
                $object->icms_aliquota = $natureza->icms_aliquota;
                $object->ipi_aliquota = $natureza->ipi_aliquota;
                $object->pis_aliquota = $natureza->pis_aliquota;
                $object->cofins_aliquota = $natureza->cofins_aliquota;
                $object->pis_valor_base = $natureza->pis_base;
                $object->cofins_valor_base = $natureza->cofins_base;
                $object->icms_predbc = $natureza->icms_pRedBC;
                $object->icms_basecalc = $natureza->icms_base;
                $object->icms_pst = $natureza->icms_pST;
                $object->icms_pcredsn = $natureza->icms_pCredSN;
                $object->icms_pmvast = $natureza->icms_pMVAST;
                $object->icms_picmsst = $natureza->icms_pICMSST;
                $object->icms_vbcst = $natureza->icms_baseST;

                $object->notafiscal_item_modbc_id = $natureza->notafiscal_item_modbc_id;
                $object->notafiscal_item_modbcst_id = $natureza->notafiscal_item_modbcst_id;
                $object->notafiscal_item_motDesICMS_id = $natureza->notafiscal_item_motDesICMS_id;
            }
        }

        TTransaction::close();

        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

