<?php

class NotafiscalItensFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NotafiscalItens';
    private static $primaryKey = 'id';
    private static $formName = 'formView_NotafiscalItens';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $notafiscal_itens = new NotafiscalItens($param['key']);
        // define the form title
        $this->form->setFormTitle("Detalhe do Item");

        $lblcodigo = new TLabel("Código:", '', '15px', 'B', '100%');
        $txtcprod = new TTextDisplay($notafiscal_itens->cprod, '', '15px', '');
        $lblxprod = new TLabel("Produto:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay($notafiscal_itens->xprod, '', '15px', '');
        $label6 = new TLabel("EAN:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($notafiscal_itens->cean, '', '15px', '');
        $lblncm = new TLabel("NCM:", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay($notafiscal_itens->ncm, '', '15px', '');
        $lblnve = new TLabel("NVE (Nomeclatura de valor arduaneiro e estatistica)", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay($notafiscal_itens->nve, '', '15px', '');
        $lblucom = new TLabel("Unidade:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($notafiscal_itens->ucom, '', '15px', '');
        $lblqcom = new TLabel("Quantidade:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(number_format((double)$notafiscal_itens->qcom, '2', ',', '.'), '', '15px', '');
        $lblvuncom = new TLabel("valor:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay(number_format((double)$notafiscal_itens->vuncom, '2', ',', '.'), '', '15px', '');
        $lblvdesc = new TLabel("Desconto:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(number_format((double)$notafiscal_itens->vdesc, '2', ',', '.'), '', '15px', '');
        $lblvoutro = new TLabel("Outras Despesas:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(number_format((double)$notafiscal_itens->voutro, '2', ',', '.'), '', '15px', '');
        $lblfrete = new TLabel("Frete:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay(number_format((double)$notafiscal_itens->vfrete, '2', ',', '.'), '', '15px', '');
        $lblvseg = new TLabel("Seguro:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay(number_format((double)$notafiscal_itens->vseg, '2', ',', '.'), '', '15px', '');
        $lblvprod = new TLabel("Total:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay(number_format((double)$notafiscal_itens->vprod, '2', ',', '.'), '', '15px', '');
        $lblcfop = new TLabel("Cfop:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay($notafiscal_itens->cfop, '', '15px', '');
        $lblxped = new TLabel("Número do pedido:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay($notafiscal_itens->xped, '', '15px', '');
        $lblnitemped = new TLabel("Item pedido:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay($notafiscal_itens->nitemped, '', '15px', '');
        $lblindtot = new TLabel("Indicador de Totalizador:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay($notafiscal_itens->notafiscal_item_indtot_id, '', '15px', '');
        $label25 = new TLabel("CST:", '', '15px', 'B', '100%');
        $text29 = new TTextDisplay($notafiscal_itens->icms_cst, '', '15px', '');
        $label26 = new TLabel("Origem:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay($notafiscal_itens->notafiscal_item_orig->descricao, '', '15px', '');
        $label29 = new TLabel("Base de cálculo ICMS:", '', '15px', 'B', '100%');
        $text28 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_basecalc, '2', ',', '.'), '', '15px', '');
        $label31 = new TLabel("Aliquota ICMS:", '', '15px', 'B', '100%');
        $text31 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_aliquota, '2', ',', '.'), '', '15px', '');
        $label30 = new TLabel("Valor ICMS:", '', '15px', 'B', '100%');
        $text30 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_valor, '2', ',', '.'), '', '15px', '');
        $label35 = new TLabel("Aliquota Crédito:", '', '15px', 'B', '100%');
        $text32 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_pcredsn, '2', ',', '.'), '', '15px', '');
        $label34 = new TLabel("Perc. da Red. de Base do ICMS:", '', '15px', 'B', '100%');
        $text35 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_predbc, '2', ',', '.'), '', '15px', '');
        $label37 = new TLabel("Modalid. de Determ. da BC ICMS:", '', '15px', 'B', '100%');
        $text27 = new TTextDisplay($notafiscal_itens->notafiscal_item_modbc_id, '', '15px', '');
        $label43 = new TLabel("Margem valor agregado:", '', '15px', 'B', '100%');
        $text37 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_pmvast, '2', ',', '.'), '', '15px', '');
        $label41 = new TLabel("Base de cálculo ICMS ST:", '', '15px', 'B', '100%');
        $text39 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_vbcst, '2', ',', '.'), '', '15px', '');
        $label42 = new TLabel("Aliquota ICMS ST:", '', '15px', 'B', '100%');
        $text40 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_picmsst, '2', ',', '.'), '', '15px', '');
        $label32 = new TLabel("Valor ICMS ST:", '', '15px', 'B', '100%');
        $text41 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_vicmsst, '2', ',', '.'), '', '15px', '');
        $label27 = new TLabel("Perc. da Red. Base do ICMS ST:", '', '15px', 'B', '100%');
        $text38 = new TTextDisplay(number_format((double)$notafiscal_itens->icms_predbcst, '2', ',', '.'), '', '15px', '');
        $label55 = new TLabel("CST:", '', '15px', 'B', '100%');
        $text68 = new TTextDisplay($notafiscal_itens->ipi_cst, '', '15px', '');
        $label57 = new TLabel("Valor Base:", '', '15px', 'B', '100%');
        $monetarytext44 = new TTextDisplay(number_format((double)$notafiscal_itens->ipi_valor_base, '2', ',', '.'), '', '12px', '');
        $label59 = new TLabel("Aliquota:", '', '15px', 'B', '100%');
        $monetarytext45 = new TTextDisplay(number_format((double)$notafiscal_itens->ipi_aliquota, '2', ',', '.'), '', '15px', '');
        $label61 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $monetarytext46 = new TTextDisplay(number_format((double)$notafiscal_itens->ipi_valor, '2', ',', '.'), '', '15px', '');
        $label65 = new TLabel("Exceção IPI:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($notafiscal_itens->extipi, '', '15px', '');
        $label67 = new TLabel("Percentual da mercadoria devolvida:", '', '15px', 'B', '100%');
        $monetarytext47 = new TTextDisplay(number_format((double)$notafiscal_itens->ipi_pdevol, '2', ',', '.'), '', '15px', '');
        $label69 = new TLabel("Valor do IPI devolvido:", '', '15px', 'B', '100%');
        $monetarytext48 = new TTextDisplay(number_format((double)$notafiscal_itens->ipi_vipidevol, '2', ',', '.'), '', '15px', '');
        $label71 = new TLabel("CST:", '', '15px', 'B', '100%');
        $text45 = new TTextDisplay($notafiscal_itens->pis_cst, '', '15px', '');
        $label73 = new TLabel("Valor base:", '', '15px', 'B', '100%');
        $text48 = new TTextDisplay(number_format((double)$notafiscal_itens->pis_valor_base, '2', ',', '.'), '', '15px', '');
        $label75 = new TLabel("Aliquota:", '', '15px', 'B', '100%');
        $text47 = new TTextDisplay(number_format((double)$notafiscal_itens->pis_aliquota, '2', ',', '.'), '', '15px', '');
        $label77 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $text46 = new TTextDisplay(number_format((double)$notafiscal_itens->pis_valor, '2', ',', '.'), '', '15px', '');
        $label79 = new TLabel("CST:", '', '15px', 'B', '100%');
        $text49 = new TTextDisplay($notafiscal_itens->cofins_cst, '', '15px', '');
        $label81 = new TLabel("Valor base:", '', '15px', 'B', '100%');
        $text50 = new TTextDisplay(number_format((double)$notafiscal_itens->cofins_valor_base, '2', ',', '.'), '', '15px', '');
        $label83 = new TLabel("Aliquota:", '', '15px', 'B', '100%');
        $monetarytext50 = new TTextDisplay(number_format((double)$notafiscal_itens->cofins_aliquota, '2', ',', '.'), '', '15px', '');
        $label85 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $monetarytext52 = new TTextDisplay(number_format((double)$notafiscal_itens->cofins_valor, '2', ',', '.'), '', '15px', '');



        $this->form->appendPage("Dados");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$lblcodigo,$txtcprod],[$lblxprod,$text6]);
        $row1->layout = [' col-sm-4',' col-sm-8'];

        $row2 = $this->form->addFields([$label6,$text5],[$lblncm,$text7],[$lblnve,$text8]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([$lblucom,$text11],[$lblqcom,$text12],[$lblvuncom,$text13]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([$lblvdesc,$text21],[$lblvoutro,$text18],[$lblfrete,$text19]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$lblvseg,$text20],[$lblvprod,$text14],[]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addFields([$lblcfop,$text10],[$lblxped,$text23],[$lblnitemped,$text24]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->form->addFields([$lblindtot,$text25]);
        $row7->layout = [' col-sm-12'];

        $this->form->appendPage("ICMS");
        $row8 = $this->form->addFields([$label25,$text29],[$label26,$text26]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        $row9 = $this->form->addFields([$label29,$text28],[$label31,$text31],[$label30,$text30]);
        $row9->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row10 = $this->form->addFields([$label35,$text32],[$label34,$text35]);
        $row10->layout = ['col-sm-3','col-sm-3'];

        $row11 = $this->form->addFields([$label37,$text27],[$label43,$text37]);
        $row11->layout = [' col-sm-6',' col-sm-3'];

        $row12 = $this->form->addContent([new TFormSeparator("Substituição Tributária", '#333', '18', '#eee')]);
        $row13 = $this->form->addFields([$label41,$text39],[$label42,$text40],[$label32,$text41],[$label27,$text38]);
        $row13->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $this->form->appendPage("IPI");
        $row14 = $this->form->addFields([$label55,$text68]);
        $row14->layout = [' col-sm-12'];

        $row15 = $this->form->addFields([$label57,$monetarytext44],[$label59,$monetarytext45],[$label61,$monetarytext46],[$label65,$text9]);
        $row15->layout = ['col-sm-3','col-sm-3',' col-sm-3',' col-sm-3'];

        $row16 = $this->form->addContent([new TFormSeparator("IPI Devolvido", '#333', '18', '#eee')]);
        $row17 = $this->form->addFields([$label67,$monetarytext47],[$label69,$monetarytext48]);
        $row17->layout = ['col-sm-3','col-sm-3'];

        $this->form->appendPage("PIS");
        $row18 = $this->form->addFields([$label71,$text45],[$label73,$text48],[$label75,$text47],[$label77,$text46]);
        $row18->layout = [' col-sm-6',' col-sm-2',' col-sm-2','col-sm-2'];

        $this->form->appendPage("COFINS");
        $row19 = $this->form->addFields([$label79,$text49],[$label81,$text50],[$label83,$monetarytext50],[$label85,$monetarytext52]);
        $row19->layout = [' col-sm-6',' col-sm-2',' col-sm-2','col-sm-2'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=NotafiscalItensFormView]');
        $style->width = '70% !important';   
        $style->show(true);

    }

    public function onShow($param = null)
    {     

    }

}

