<?php

class NotafiscalItensSimpleList extends TPage
{

    private $datagrid; // listing
    private $pageNavigation;
    private $loaded;
    private static $database = 'kraftsoft';
    private static $activeRecord = 'NotafiscalItens';
    private static $primaryKey = 'id';
    private static $formName = 'formList_NotafiscalItens';
    private $limit = 20;

    public function __construct($param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        $this->limit = 0;

        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid->disableHtmlConversion();

        $this->datagrid_form = new TForm('datagrid_'.self::$formName);
        $this->datagrid_form->onsubmit = 'return false';

        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);

        $this->datagrid->style = 'width: 100%';
        $this->datagrid->setHeight(320);

        $column_cprod = new TDataGridColumn('cprod', "Cód. Produto", 'left');
        $column_xprod = new TDataGridColumn('xprod', "Descrição", 'left');
        $column_ucom = new TDataGridColumn('ucom', "Unid. Com.", 'left');
        $column_ncm = new TDataGridColumn('ncm', "NCM", 'left');
        $column_qcom_transformed = new TDataGridColumn('qcom', "Quantidade", 'right');
        $column_vuncom_transformed = new TDataGridColumn('vuncom', "Valor Unitário", 'right');
        $column_vprod_transformed = new TDataGridColumn('vprod', "Total", 'right');
        $column_icms_basecalc_transformed = new TDataGridColumn('icms_basecalc', "Bc. ICMS", 'left');
        $column_icms_valor_transformed = new TDataGridColumn('icms_valor', "V. ICMS", 'left');
        $column_icms_aliquota_transformed = new TDataGridColumn('icms_aliquota', "Aliq. ICMS", 'left');
        $column_cfop = new TDataGridColumn('cfop', "CFOP", 'left');
        $column_xped = new TDataGridColumn('xped', "Nº Pedido", 'left');
        $column_nitemped = new TDataGridColumn('nitemped', "Nº It. Pedido", 'left');
        $column_cprod1 = new TDataGridColumn('cprod', "Cód. Produto", 'left');

        $column_qcom_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_vuncom_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_vprod_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_icms_basecalc_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_icms_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_icms_aliquota_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });        

        $this->datagrid->addColumn($column_cprod);
        $this->datagrid->addColumn($column_xprod);
        $this->datagrid->addColumn($column_ucom);
        $this->datagrid->addColumn($column_ncm);
        $this->datagrid->addColumn($column_qcom_transformed);
        $this->datagrid->addColumn($column_vuncom_transformed);
        $this->datagrid->addColumn($column_vprod_transformed);
        $this->datagrid->addColumn($column_icms_basecalc_transformed);
        $this->datagrid->addColumn($column_icms_valor_transformed);
        $this->datagrid->addColumn($column_icms_aliquota_transformed);
        $this->datagrid->addColumn($column_cfop);
        $this->datagrid->addColumn($column_xped);
        $this->datagrid->addColumn($column_nitemped);
        $this->datagrid->addColumn($column_cprod1);

        $action_OnEditarItem = new TDataGridAction(array('NotafiscalItensSimpleList', 'OnEditarItem'));
        $action_OnEditarItem->setUseButton(true);
        $action_OnEditarItem->setButtonClass('btn btn-default btn-sm');
        $action_OnEditarItem->setLabel("Editar");
        $action_OnEditarItem->setImage('fas:edit #00BCD4');
        $action_OnEditarItem->setField(self::$primaryKey);

        $this->datagrid->addAction($action_OnEditarItem);

        $action_onExcluirItem = new TDataGridAction(array('NotafiscalItensSimpleList', 'onExcluirItem'));
        $action_onExcluirItem->setUseButton(true);
        $action_onExcluirItem->setButtonClass('btn btn-default btn-sm');
        $action_onExcluirItem->setLabel("Excluir");
        $action_onExcluirItem->setImage('fas:trash #F44336');
        $action_onExcluirItem->setField(self::$primaryKey);

        $this->datagrid->addAction($action_onExcluirItem);

        // create the datagrid model
        $this->datagrid->createModel();

        $panel = new TPanelGroup();
        $panel->datagrid = 'datagrid-container';
        $this->datagridPanel = $panel;
        $this->datagrid_form->add($this->datagrid);
        $panel->add($this->datagrid_form);

        $panel->getBody()->class .= ' table-responsive';

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","Lista Itens da Nota Fiscal"]));
        }
        $container->add($panel);

        parent::add($container);

    }

    public static function OnEditarItem($param = null) 
    {
        try 
        {
            $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            TApplication::loadPage('NotafiscalItensForm', 'onEdit', $pageParam);

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onExcluirItem($param = null) 
    {
        try 
        {

            new TQuestion("Excluir item?", new TAction([__CLASS__, 'onExcluirYes'], $param), new TAction([__CLASS__, 'onExcluirNo'], $param));

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'kraftsoft'
            TTransaction::open(self::$database);

            // creates a repository for NotafiscalItens
            $repository = new TRepository(self::$activeRecord);
            // creates a criteria
            $criteria = new TCriteria;

            if (empty($param['order']))
            {
                $param['order'] = 'id';    
            }
            if (empty($param['direction']))
            {
                $param['direction'] = 'desc';
            }

            $criteria->setProperties($param); // order, offset
            $criteria->setProperty('limit', $this->limit);

            if($filters = TSession::getValue(__CLASS__.'_filters'))
            {
                foreach ($filters as $filter) 
                {
                    $criteria->add($filter);       
                }
            }

            $criteria->add(new TFilter('notafiscal_id', '=', TSession::getValue('nota_fiscal_id') ));

            // load the objects according to criteria
            $objects = $repository->load($criteria, FALSE);

            $this->datagrid->clear();
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {

                    $row = $this->datagrid->addItem($object);
                    $row->id = "row_{$object->id}";

                }
            }

            // reset the criteria for record count
            $criteria->resetProperties();
            $count= $repository->count($criteria);

            // close the transaction
            TTransaction::close();
            $this->loaded = true;

            return $objects;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }

    public function onShow($param = null)
    {

    }

    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }

    public static function onExcluirYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $item = NotafiscalItens::find($param['id']);

            if($item)
            {
                $idnota = $item->notafiscal_id;

                $item->delete();

                Notafiscal::atualiza_totais_nota($idnota);

                TToast::show('success', "Exclusão realizada com sucesso.", 'topRight', 'far:check-circle');

                TSession::setValue('aba_items', true);

                $pageParam = ['key' => $idnota]; // ex.: = ['key' => 10]

                TApplication::loadPage('NotafiscalForm', 'onEdit', $pageParam);

            }
            else
            {
                new TMessage('info', 'Item não encontrado!');
            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExcluirNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

