<?php

class RetornoCloudList extends TWindow
{

    private $datagrid; // listing
    private $pageNavigation;
    private $loaded;
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Estado';
    private static $primaryKey = 'id';
    private static $formName = 'formList_Estado';
    private $limit = 20;

    public function __construct($param = null)
    {
        parent::__construct();
        parent::setSize(0.70, null);
        parent::setTitle("Retorno do Envio SEFAZ");
        parent::setProperty('class', 'window_modal');
        
        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        $this->limit = 20;

        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid->disableHtmlConversion();

        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);

        $this->datagrid->style = 'width: 100%';
        $this->datagrid->setHeight(320);

        $column_campo = new TDataGridColumn('campo', "Campo", 'left');
        $column_erro = new TDataGridColumn('erro', "Erro", 'left');
        $column_descricao = new TDataGridColumn('descricao', "Descrição", 'left');
        $column_detalhes = new TDataGridColumn('detalhes', "Detalhes", 'left');


        $this->datagrid->addColumn($column_campo);
        $this->datagrid->addColumn($column_erro);
        $this->datagrid->addColumn($column_descricao);
        $this->datagrid->addColumn($column_detalhes);

        // create the datagrid model
        $this->datagrid->createModel();

        // creates the page navigation
        $this->pageNavigation = new TPageNavigation;
        $this->pageNavigation->enableCounters();
        $this->pageNavigation->setAction(new TAction(array($this, 'onReload')));
        $this->pageNavigation->setWidth($this->datagrid->getWidth());

        $panel = new TPanelGroup;
        $panel->datagrid = 'datagrid-container';
        $this->datagridPanel = $panel;
        $panel->add($this->datagrid);
        $panel->getBody()->class .= ' table-responsive';

        $this->datagrid_form = new TForm('datagrid_'.self::$formName);

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%;padding:10px';
        $container->add($this->form);
        $container->add($panel);

        parent::add($container);

    }

    /**
     * Load the datagrid with data
     */
    public function onReload($param = NULL)
    {
        try
        {
            // open a transaction with database 'kraftsoft'
            TTransaction::open(self::$database);
            
            $objects = TSession::getValue('retorno_envio_nota');
            
            $this->datagrid->clear();
            
            if ($objects)
            {
                // iterate the collection of active records
                foreach ($objects as $object)
                {
                    $row = $this->datagrid->addItem($object);
                    $row->id = "row_{$object->id}";
                }
            }


            return $objects;
        }
        catch (Exception $e) // in case of exception
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());
            // undo all pending operations
            TTransaction::rollback();
        }
    }

    public function onShow($param = null)
    {

    }

    /**
     * method show()
     * Shows the page
     */
    public function show()
    {
        // check if the datagrid is already loaded
        if (!$this->loaded AND (!isset($_GET['method']) OR !(in_array($_GET['method'],  array('onReload', 'onSearch')))) )
        {
            if (func_num_args() > 0)
            {
                $this->onReload( func_get_arg(0) );
            }
            else
            {
                $this->onReload();
            }
        }
        parent::show();
    }

}

