<?php

class VeiculoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Veiculo';
    private static $primaryKey = 'id';
    private static $formName = 'form_VeiculoForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Veiculo");


        $id = new TEntry('id');
        $modelo_marca = new TEntry('modelo_marca');
        $ano = new TEntry('ano');
        $placa = new TEntry('placa');
        $estado_id = new TDBCombo('estado_id', 'kraftsoft', 'Estado', 'id', '{nome}','nome asc'  );
        $veiculo_tipo_id = new TDBCombo('veiculo_tipo_id', 'kraftsoft', 'VeiculoTipo', 'id', '{descricao}','descricao asc'  );
        $tara = new TNumeric('tara', '2', ',', '.' );
        $capacidade_kg = new TNumeric('capacidade_kg', '2', ',', '.' );
        $capacidade_m3 = new TNumeric('capacidade_m3', '2', ',', '.' );
        $renavam = new TEntry('renavam');
        $mdfe_tpRod_id = new TDBCombo('mdfe_tpRod_id', 'kraftsoft', 'MdfeTprod', 'id', '{descricao}','descricao asc'  );
        $mdfe_tpcar_id = new TDBCombo('mdfe_tpcar_id', 'kraftsoft', 'MdfeTpcar', 'id', '{descricao}','descricao asc'  );
        $funcionario_motorista_id = new TDBCombo('funcionario_motorista_id', 'kraftsoft', 'Funcionario', 'id', '{nome}','nome asc'  );
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $modelo_marca->addValidation("Modelo/Marca", new TRequiredValidator()); 
        $placa->addValidation("Placa", new TRequiredValidator()); 
        $estado_id->addValidation("UF Veículo", new TRequiredValidator()); 
        $veiculo_tipo_id->addValidation("Veiculo tipo id", new TRequiredValidator()); 
        $mdfe_tpRod_id->addValidation("Tipo de Rodado", new TRequiredValidator()); 

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $estado_id->enableSearch();
        $mdfe_tpRod_id->enableSearch();
        $mdfe_tpcar_id->enableSearch();
        $veiculo_tipo_id->enableSearch();
        $funcionario_motorista_id->enableSearch();

        $id->setSize(100);
        $ano->setSize('100%');
        $tara->setSize('100%');
        $placa->setSize('100%');
        $renavam->setSize('100%');
        $estado_id->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $modelo_marca->setSize('100%');
        $alterado_por->setSize('100%');
        $capacidade_kg->setSize('100%');
        $capacidade_m3->setSize('100%');
        $mdfe_tpRod_id->setSize('100%');
        $mdfe_tpcar_id->setSize('100%');
        $veiculo_tipo_id->setSize('100%');
        $funcionario_motorista_id->setSize('100%');

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id]);
        $row1->layout = ['col-sm-3'];

        $row2 = $this->form->addFields([new TLabel("Modelo/Marca:", '#F44336', '14px', null, '100%'),$modelo_marca],[new TLabel("Ano:", null, '14px', null, '100%'),$ano],[new TLabel("Placa:", '#F44336', '14px', null, '100%'),$placa]);
        $row2->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("UF:", '#F44336', '14px', null, '100%'),$estado_id],[new TLabel("Tipo de veículo:", '#F44336', '14px', null, '100%'),$veiculo_tipo_id]);
        $row3->layout = [' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Tara:", null, '14px', null, '100%'),$tara],[new TLabel("Capacidade KG:", null, '14px', null, '100%'),$capacidade_kg],[new TLabel("Capacidade M3:", null, '14px', null, '100%'),$capacidade_m3]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([new TLabel("RENAVAM:", null, '14px', null, '100%'),$renavam],[new TLabel("Tipo de Rodado:", '#F44336', '14px', null, '100%'),$mdfe_tpRod_id],[new TLabel("Tipo de Carroceria:", '#F44336', '14px', null, '100%'),$mdfe_tpcar_id]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row6 = $this->form->addFields([new TLabel("Motorista:", null, '14px', null),$funcionario_motorista_id]);
        $row6->layout = [' col-sm-12'];

        $bcontainer_6280048566daf = new BContainer('bcontainer_6280048566daf');
        $this->bcontainer_6280048566daf = $bcontainer_6280048566daf;

        $bcontainer_6280048566daf->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_6280048566daf->setBorderColor('#c0c0c0');

        $row7 = $bcontainer_6280048566daf->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row7->layout = ['col-sm-2',' col-sm-4','col-sm-2',' col-sm-4'];

        $row8 = $this->form->addFields([$bcontainer_6280048566daf]);
        $row8->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['VeiculoList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Fiscal","Cadastro de Veiculo"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Veiculo(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('VeiculoList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Veiculo($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

