<?php

class OrdemServicoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemServico';
    private static $primaryKey = 'id';
    private static $formName = 'form_OrdemServicoForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de ordem de serviço");


        $ordem_servico_situacao_id = new TDBArrowStep('ordem_servico_situacao_id', 'kraftsoft', 'OrdemServicoSituacao', 'id', '{descricao}','id asc'  );
        $id = new TEntry('id');
        $numero_os = new TEntry('numero_os');
        $data_emissao = new TDate('data_emissao');
        $prazo_entrega = new TDate('prazo_entrega');
        $data_abertura_os = new TDate('data_abertura_os');
        $prazo_garantia = new TDate('prazo_garantia');
        $cliente_id = new TSeekButton('cliente_id');
        $cliente_nome = new TEntry('cliente_nome');
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $cliente_contato_id = new TDBCombo('cliente_contato_id', 'kraftsoft', 'ClienteContato', 'id', '{nome}','nome asc'  );
        $cliente_endereco_id = new TDBCombo('cliente_endereco_id', 'kraftsoft', 'ClienteEndereco', 'id', '{logradouro}','logradouro asc'  );
        $informacoes_transporte = new TEntry('informacoes_transporte');
        $validade_dias = new TEntry('validade_dias');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $condicao_pagamento_id = new TDBCombo('condicao_pagamento_id', 'kraftsoft', 'CondicaoPagamento', 'id', '{descricao}','descricao asc'  );
        $observacoes = new TText('observacoes');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $button_novo_servico = new TButton('button_novo_servico');
        $lista_items = new BPageContainer();
        $valor = new TNumeric('valor', '2', ',', '.' );
        $desconto = new TNumeric('desconto', '2', ',', '.' );
        $valor_pago = new TNumeric('valor_pago', '2', ',', '.' );
        $valor_aprazo = new TNumeric('valor_aprazo', '2', ',', '.' );
        $valor_avista = new TNumeric('valor_avista', '2', ',', '.' );
        $valor_faturado_vendas = new TNumeric('valor_faturado_vendas', '2', ',', '.' );
        $vendedor_comissao = new TNumeric('vendedor_comissao', '2', ',', '.' );
        $vendedor_comissao_avista = new TNumeric('vendedor_comissao_avista', '2', ',', '.' );
        $vendedor_comissao_aprazo = new TNumeric('vendedor_comissao_aprazo', '2', ',', '.' );

        $cliente_id->setExitAction(new TAction([$this,'onExitCliente']));
        $desconto->setExitAction(new TAction([$this,'onExitDesconto']));

        $ordem_servico_situacao_id->addValidation("Ordem servico situacao id", new TRequiredValidator()); 
        $data_emissao->addValidation("Data Emissão", new TRequiredValidator()); 
        $system_unit_id->addValidation("System unit id", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 

        $ordem_servico_situacao_id->setColorColumn('cor');
        $ordem_servico_situacao_id->setFilledColor('#fa931f');
        $ordem_servico_situacao_id->setFilledFontColor('#ffffff');
        $ordem_servico_situacao_id->setUnfilledColor('#d3d3d3');
        $ordem_servico_situacao_id->setUnfilledFontColor('#333333');
        $button_novo_servico->addStyleClass('btn-default');
        $button_novo_servico->setImage('fas:plus #000000');
        $lista_items->setId('b652d890067cf4');
        $lista_items->setAction(new TAction(['OrdemServicoItemSimpleList', 'onShow']));
        $button_novo_servico->setAction(new TAction([$this, 'onNovoServico']), "Novo Serviço");

        $vendedor_id->enableSearch();
        $system_unit_id->enableSearch();
        $cliente_contato_id->enableSearch();
        $cliente_endereco_id->enableSearch();
        $condicao_pagamento_id->enableSearch();

        $data_emissao->setMask('dd/mm/yyyy');
        $prazo_entrega->setMask('dd/mm/yyyy');
        $prazo_garantia->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $data_abertura_os->setMask('dd/mm/yyyy');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $data_emissao->setDatabaseMask('yyyy-mm-dd');
        $prazo_entrega->setDatabaseMask('yyyy-mm-dd');
        $prazo_garantia->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_abertura_os->setDatabaseMask('yyyy-mm-dd');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $valor->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $cliente_nome->setEditable(false);
        $alterado_por->setEditable(false);
        $system_unit_id->setEditable(false);
        $ordem_servico_situacao_id->setEditable(false);

        $id->setSize('100%');
        $valor->setSize('100%');
        $cliente_id->setSize(110);
        $desconto->setSize('100%');
        $numero_os->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $valor_pago->setSize('100%');
        $cliente_nome->setSize('80%');
        $vendedor_id->setSize('100%');
        $alterado_em->setSize('100%');
        $lista_items->setSize('100%');
        $data_emissao->setSize('100%');
        $alterado_por->setSize('100%');
        $valor_aprazo->setSize('100%');
        $valor_avista->setSize('100%');
        $prazo_entrega->setSize('100%');
        $validade_dias->setSize('100%');
        $prazo_garantia->setSize('100%');
        $system_unit_id->setSize('100%');
        $observacoes->setSize('100%', 70);
        $data_abertura_os->setSize('100%');
        $vendedor_comissao->setSize('100%');
        $cliente_contato_id->setSize('100%');
        $cliente_endereco_id->setSize('100%');
        $condicao_pagamento_id->setSize('100%');
        $valor_faturado_vendas->setSize('100%');
        $informacoes_transporte->setSize('100%');
        $vendedor_comissao_avista->setSize('100%');
        $vendedor_comissao_aprazo->setSize('100%');
        $ordem_servico_situacao_id->setSize('100%', 55);

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $lista_items->add($loadingContainer);

        $this->lista_items = $lista_items;

        $seed = AdiantiApplicationConfig::get()['general']['seed'];
        $cliente_id_seekAction = new TAction(['ClienteSeekWindow', 'onShow']);
        $seekFilters = [];
        $seekFields = base64_encode(serialize([
            ['name'=> 'cliente_id', 'column'=>'{id}'],
            ['name'=> 'cliente_nome', 'column'=>'{nome}'],
            ['name'=> 'vendedor_id', 'column'=>'{vendedor_id}']
        ]));

        $seekFilters = base64_encode(serialize($seekFilters));
        $cliente_id_seekAction->setParameter('_seek_fields', $seekFields);
        $cliente_id_seekAction->setParameter('_seek_filters', $seekFilters);
        $cliente_id_seekAction->setParameter('_seek_hash', md5($seed.$seekFields.$seekFilters));
        $cliente_id->setAction($cliente_id_seekAction);

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$ordem_servico_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Número O.S.:", null, '14px', null, '100%'),$numero_os],[new TLabel("Data Emissão:", '#ff0000', '14px', null, '100%'),$data_emissao],[new TLabel("Prazo de Entrega:", null, '14px', null, '100%'),$prazo_entrega],[new TLabel("Data Abertura O.S.:", null, '14px', null, '100%'),$data_abertura_os],[new TLabel("Prazo de garantia:", null, '14px', null, '100%'),$prazo_garantia]);
        $row2->layout = [' col-sm-2',' col-sm-2',' col-sm-2',' col-sm-2',' col-sm-2','col-sm-2'];

        $row3 = $this->form->addFields([new TLabel("Cliente:", '#ff0000', '14px', null, '100%'),$cliente_id,$cliente_nome],[new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Contato do cliente:", null, '14px', null, '100%'),$cliente_contato_id],[new TLabel("Endereço de Entrega:", null, '14px', null, '100%'),$cliente_endereco_id]);
        $row4->layout = [' col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Informações de transporte:", null, '14px', null, '100%'),$informacoes_transporte],[new TLabel("Validade de dias da proposta:", null, '14px', null, '100%'),$validade_dias]);
        $row5->layout = [' col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Filial:", '#ff0000', '14px', null, '100%'),$system_unit_id],[new TLabel("Condição pagamento:", null, '14px', null, '100%'),$condicao_pagamento_id]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([new TLabel("Observações:", null, '14px', null, '100%'),$observacoes]);
        $row7->layout = [' col-sm-12'];

        $row8 = $this->form->addContent([new TFormSeparator("Histórico de Atualizações", '#333', '18', '#eee')]);
        $row9 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row9->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Serviço ");
        $row10 = $this->form->addFields([$button_novo_servico],[],[]);
        $row10->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $row11 = $this->form->addFields([$lista_items]);
        $row11->layout = [' col-sm-12'];

        $this->form->appendPage("Financeiro");
        $row12 = $this->form->addFields([new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Desconto:", null, '14px', null, '100%'),$desconto],[new TLabel("Valor Pago:", null, '14px', null, '100%'),$valor_pago]);
        $row12->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row13 = $this->form->addFields([new TLabel("Valor a prazo:", null, '14px', null, '100%'),$valor_aprazo],[new TLabel("Valor a vista:", null, '14px', null, '100%'),$valor_avista],[new TLabel("Valor faturado em vendas:", null, '14px', null, '100%'),$valor_faturado_vendas]);
        $row13->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row14 = $this->form->addContent([new TFormSeparator("Comissões", '#333', '18', '#eee')]);
        $row15 = $this->form->addFields([new TLabel("Comissão de Vendedor:", null, '14px', null, '100%'),$vendedor_comissao],[new TLabel("Comissão a vista vendedor:", null, '14px', null, '100%'),$vendedor_comissao_avista],[new TLabel("Comissão a prazo vendedor:", null, '14px', null, '100%'),$vendedor_comissao_aprazo]);
        $row15->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacaoordemservico = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacaoOrdemServico']), 'fas:bars #000000');
        $this->btn_onvisualizacaoordemservico = $btn_onvisualizacaoordemservico;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['OrdemServicoList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Ordem de Serviço","Cadastro de ordem de serviço"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitCliente($param = null) 
    {
        try 
        {
            //code here
            if(isset($param['cliente_id']) && $param['cliente_id'])
            {
                TTransaction::open(self::$database);

                $cliente = Cliente::find($param['cliente_id']);

                $object = new stdClass();
                //$object->cliente_contato_id = '';
                //$object->cliente_endereco_id = '';
                //$object->tabela_preco_id = $cliente->tabela_preco_id;

                $criteria = new TCriteria();
                $criteria->add(new TFilter('cliente_id', '=', $param['cliente_id']));

                TDBCombo::reloadFromModel(self::$formName, 'cliente_contato_id', self::$database, 'ClienteContato', 'id', '{nome}', 'nome asc', $criteria, true);
                TDBCombo::reloadFromModel(self::$formName, 'cliente_endereco_id', self::$database, 'ClienteEndereco', 'id', '{logradouro}  - {numero} -  {bairro} - {cidade->nome} ', 'logradouro asc', $criteria, TRUE);

                TTransaction::close();
            }
            else
            {
                TCombo::clearField(self::$formName, 'cliente_endereco_id');
                TCombo::clearField(self::$formName, 'cliente_contato_id'); 
            }

            $object->cliente_contato_id = $cliente->cliente_contato_id;
            $object->cliente_endereco_id = $cliente->cliente_endereco_id;
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitDesconto($param = null) 
    {
        try 
        {
            //code here
            $desconto = (double) str_replace(',', '.', str_replace('.', '', $param['desconto']));
            $valortotal = (double) str_replace(',', '.', str_replace('.', '', $param['valor']));

            $total = $valortotal - $desconto;

            $object = new stdClass();
            $object->valor = number_format($total, 2, ',', '.');

            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onNovoServico($param = null) 
    {
        try 
        {
            //code here
            if($param['id'] == '')
            {
                throw new Exception('Favor salvar a O.S antes de adicionar itens nela.');
            } else {
                TApplication::loadPage('OrdemServicoItemForm', 'onShow', ['ordem_servico_id' => $param['id']]);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new OrdemServico(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            if(empty($object->numero_os))
            {
                $object->numero_os = FuncoesOrdemServico::ObterProximoSequenciaOrdemServico(TSession::getValue('userunitid'));
            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $id = $object->id;

            //if($data->id == "")
            //{
                $object->system_unit_id = TSession::getValue('userunitid'); 
            //}

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['numero_os' => $object->numero_os]);

            if(isset($id))
            {
                OrdemServicoHistorico::LancarHistorico(OrdemServicoSituacao::OrcamentoAberto, $object->id, 'Mudança de Situação de O.S: Orcamento Aberto');
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $data->numero_os = $object->numero_os;

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacaoOrdemServico($param = null) 
    {
        try 
        {
            //code here
            $pageParam = ['key' => $param['id']];

            if($param['id'] == "")
            {
                throw new Exception("Salve a O.S para entrar no modo visualizaçãp!");
            } else
                TApplication::loadPage('OrdemServicoFormview', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new OrdemServico($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        //$object->data_abertura_os = date('d/m/Y H:i');
        $object->data_emissao = date('d/m/Y H:i');
        $object->prazo_entrega = date('d/m/Y H:i');
        $object->ordem_servico_situacao_id = OrdemServicoSituacao::OrcamentoAberto;
        $object->system_unit_id = TSession::getValue('userunitid');
        $object->criado_por = TSession::getValue('username');
        $object->usuario_aprovacao_id = TSession::getValue('username');
        $object->validade_dias = '1';
        $object->valor = '0';

        TForm::sendData(self::$formName, $object);

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

