<?php

class OrdemServicoFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemServico';
    private static $primaryKey = 'id';
    private static $formName = 'formView_OrdemServico';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $ordem_servico = new OrdemServico($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar ordem de serviço");

        $tdbarrowstep4 = new TDBArrowStep('tdbarrowstep4', 'kraftsoft', 'OrdemServicoSituacao', 'id', '{descricao}','id asc' );
        $label1 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($ordem_servico->id, '', '15px', '');
        $label15 = new TLabel("Número O.S.:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay($ordem_servico->numero_os, '', '15px', '');
        $label17 = new TLabel("Data Emissão:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(TDate::convertToMask($ordem_servico->data_emissao, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label20 = new TLabel("Prazo de Entrega:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay(TDate::convertToMask($ordem_servico->prazo_entrega, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label22 = new TLabel("Data Abertura O.S.:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(TDate::convertToMask($ordem_servico->data_abertura_os, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label3 = new TLabel("Cliente:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($ordem_servico->cliente->nome, '', '15px', '');
        $label5 = new TLabel("Vendedor:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($ordem_servico->vendedor->nome, '', '15px', '');
        $label2 = new TLabel("Filial:", '', '15px', 'B', '100%');
        $text2 = new TTextDisplay($ordem_servico->system_unit->name, '', '15px', '');
        $label21 = new TLabel("Validade de dias da proposta:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay($ordem_servico->validade_dias, '', '15px', '');
        $label = new TLabel("Contato do cliente:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($ordem_servico->cliente_contato->nome, '', '15px', '');
        $label8 = new TLabel("Condição pagamento:", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay($ordem_servico->condicao_pagamento->descricao, '', '15px', '');
        $label34 = new TLabel("Informações de transporte:", '', '15px', 'B', '100%');
        $text34 = new TTextDisplay($ordem_servico->informacoes_transporte, '', '15px', '');
        $label9 = new TLabel("Endereço de Entrega:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($ordem_servico->cliente_endereco->logradouro, '', '15px', '');
        $label27 = new TLabel("Prazo de garantia:", '', '15px', 'B', '100%');
        $text27 = new TTextDisplay(TDate::convertToMask($ordem_servico->prazo_garantia, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label33 = new TLabel("Usuário Aprovação:", '', '15px', 'B', '100%');
        $text33 = new TTextDisplay($ordem_servico->usuario_aprovacao->name, '', '15px', '');
        $label26 = new TLabel("Observações:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay($ordem_servico->observacoes, '', '15px', '');
        $label42 = new TLabel("Motivo de não aprovação do orçamento:", '', '15px', 'B', '100%');
        $text29 = new TTextDisplay($ordem_servico->motivo_nao_aprovacao_orcamento, '', '15px', '');
        $criado_em_label = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $datetimetext1 = new TTextDisplay(TDateTime::convertToMask($ordem_servico->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $criado_por = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $criado_por_text = new TTextDisplay($ordem_servico->criado_por, '', '15px', '');
        $alterado_em = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $alterado_em_datetime = new TTextDisplay(TDateTime::convertToMask($ordem_servico->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $alterado_por = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $alterado_por_text = new TTextDisplay($ordem_servico->alterado_por, '', '15px', '');
        $label18 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(number_format((double)$ordem_servico->valor, '2', ',', '.'), '', '15px', '');
        $label19 = new TLabel("Desconto:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay(number_format((double)$ordem_servico->desconto, '2', ',', '.'), '', '15px', '');
        $label28 = new TLabel("Valor Pago:", '', '15px', 'B', '100%');
        $text28 = new TTextDisplay(number_format((double)$ordem_servico->valor_pago, '2', ',', '.'), '', '15px', '');
        $label31 = new TLabel("Valor a prazo:", '', '15px', 'B', '100%');
        $text31 = new TTextDisplay(number_format((double)$ordem_servico->valor_aprazo, '2', ',', '.'), '', '15px', '');
        $label30 = new TLabel("Valor a vista:", '', '15px', 'B', '100%');
        $text30 = new TTextDisplay(number_format((double)$ordem_servico->valor_avista, '2', ',', '.'), '', '15px', '');
        $label32 = new TLabel("Valor faturado em vendas:", '', '15px', 'B', '100%');
        $text32 = new TTextDisplay(number_format((double)$ordem_servico->valor_faturado_vendas, '2', ',', '.'), '', '15px', '');
        $label23 = new TLabel("Comissão de Vendedor:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay(number_format((double)$ordem_servico->vendedor_comissao, '2', ',', '.'), '', '15px', '');
        $label24 = new TLabel("Comissão a vista vendedor:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay(number_format((double)$ordem_servico->vendedor_comissao_avista, '2', ',', '.'), '', '15px', '');
        $label25 = new TLabel("Comissão a prazo vendedor:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay(number_format((double)$ordem_servico->vendedor_comissao_aprazo, '2', ',', '.'), '', '15px', '');

        $tdbarrowstep4->setEditable(false);
        $tdbarrowstep4->setColorColumn('cor');
        $tdbarrowstep4->setFilledColor('#fd9308');
        $tdbarrowstep4->setFilledFontColor('#ffffff');
        $tdbarrowstep4->setUnfilledColor('#d3d3d3');
        $tdbarrowstep4->setUnfilledFontColor('#333333');
        $tdbarrowstep4->setWidth('100%');
        $tdbarrowstep4->setHeight('60');
        $tdbarrowstep4->setValue($ordem_servico->ordem_servico_situacao_id);


        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$tdbarrowstep4]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$label1,$text1],[$label15,$text15],[$label17,$text17],[$label20,$text20],[$label22,$text22]);
        $row2->layout = [' col-sm-2',' col-sm-2',' col-sm-2',' col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([$label3,$text3],[$label5,$text5]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([$label2,$text2],[$label21,$text21]);
        $row4->layout = [' col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([$label,$text4],[$label8,$text8]);
        $row5->layout = [' col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([$label34,$text34],[$label9,$text9]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([$label27,$text27],[$label33,$text33]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([$label26,$text26],[$label42,$text29]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        $row9 = $this->form->addContent([new TFormSeparator("Histórico de Atualizações", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([$criado_em_label,$datetimetext1],[$criado_por,$criado_por_text],[$alterado_em,$alterado_em_datetime],[$alterado_por,$alterado_por_text]);
        $row10->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Serviço");

        $this->ordem_servico_item_ordem_servico_id_list = new TQuickGrid;
        $this->ordem_servico_item_ordem_servico_id_list->disableHtmlConversion();
        $this->ordem_servico_item_ordem_servico_id_list->style = 'width:100%';
        $this->ordem_servico_item_ordem_servico_id_list->disableDefaultClick();

        $column_id = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Cód. Serviço", 'id', 'left');
        $column_produto_nome = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Serviço", 'produto->nome', 'left');
        $column_quantidade_transformed = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Quantidade", 'quantidade', 'right');
        $column_valor_unitario_transformed = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Valor unitário", 'valor_unitario', 'right');
        $column_desconto_transformed = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Desconto", 'desconto', 'left');
        $column_valor_total_transformed = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Valor total", 'valor_total', 'right');
        $column_quantidade_a_faturar = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Quantidade à faturar", 'quantidade_a_faturar', 'left');
        $column_quantidade_atendida = $this->ordem_servico_item_ordem_servico_id_list->addQuickColumn("Quantidade atendida", 'quantidade_atendida', 'left');

        $column_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_desconto_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->ordem_servico_item_ordem_servico_id_list->createModel();

        $criteria_ordem_servico_item_ordem_servico_id = new TCriteria();
        $criteria_ordem_servico_item_ordem_servico_id->add(new TFilter('ordem_servico_id', '=', $ordem_servico->id));

        $criteria_ordem_servico_item_ordem_servico_id->setProperty('order', 'id desc');

        $ordem_servico_item_ordem_servico_id_items = OrdemServicoItem::getObjects($criteria_ordem_servico_item_ordem_servico_id);

        $this->ordem_servico_item_ordem_servico_id_list->addItems($ordem_servico_item_ordem_servico_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->ordem_servico_item_ordem_servico_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Forma Pagamento");

        $this->servico_formapgto_ordem_servico_id_list = new TQuickGrid;
        $this->servico_formapgto_ordem_servico_id_list->disableHtmlConversion();
        $this->servico_formapgto_ordem_servico_id_list->style = 'width:100%';
        $this->servico_formapgto_ordem_servico_id_list->disableDefaultClick();

        $column_forma_pagamento_descricao = $this->servico_formapgto_ordem_servico_id_list->addQuickColumn("Forma pagamento", 'forma_pagamento->descricao', 'left');
        $column_valor = $this->servico_formapgto_ordem_servico_id_list->addQuickColumn("Valor", 'valor', 'left');

        $this->servico_formapgto_ordem_servico_id_list->createModel();

        $criteria_servico_formapgto_ordem_servico_id = new TCriteria();
        $criteria_servico_formapgto_ordem_servico_id->add(new TFilter('ordem_servico_id', '=', $ordem_servico->id));

        $criteria_servico_formapgto_ordem_servico_id->setProperty('order', 'id desc');

        $servico_formapgto_ordem_servico_id_items = ServicoFormapgto::getObjects($criteria_servico_formapgto_ordem_servico_id);

        $this->servico_formapgto_ordem_servico_id_list->addItems($servico_formapgto_ordem_servico_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->servico_formapgto_ordem_servico_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Financeiro");
        $row11 = $this->form->addFields([$label18,$text18],[$label19,$text19],[$label28,$text28]);
        $row11->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row12 = $this->form->addFields([$label31,$text31],[$label30,$text30],[$label32,$text32]);
        $row12->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row13 = $this->form->addContent([new TFormSeparator("Comissões", '#333', '18', '#eee')]);
        $row14 = $this->form->addFields([$label23,$text23],[$label24,$text24],[$label25,$text25]);
        $row14->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        $dropdownHeader = new TDropDown("Impressões", 'fa:print $FF5722');
        $dropdownHeader->setPullSide('right-panel');
        $dropdownHeader->setButtonSize('btn btn-sm btn-default dropdown-toggle');

        $btn_acao1 = $dropdownHeader->addPostAction("Espelho PDF", new TAction(['OrdemServicoDocument', 'onGenerate'], $param), self::$formName, 'far:file-pdf #DD0909');
        $this->btn_onacao1 = $btn_acao1;

        $btn_acao2 = $dropdownHeader->addPostAction("Imprimir Proposta", new TAction(['OrdemServicoPropostaDocument', 'onGenerate'], $param), self::$formName, 'fa:print #795548');
        $this->btn_onacao2 = $btn_acao2;

        $btn_acao3 = $dropdownHeader->addPostAction("Imprimir Recibo", new TAction(['OrdemServicoReciboDocument', 'onGenerate'], $param), self::$formName, 'fa:print #4CAF50');
        $this->btn_onacao3 = $btn_acao3;

        $this->form->addHeaderWidget( $dropdownHeader );

        $btnEditarAction = new TAction(['OrdemServicoForm', 'onEdit'],['key'=>$ordem_servico->id]);
        $btnEditarLabel = new TLabel("Editar");

        $btnEditar = $this->form->addHeaderAction($btnEditarLabel, $btnEditarAction, 'fas:edit #2196F3'); 
        $btnEditarLabel->setFontSize('12px'); 
        $btnEditarLabel->setFontColor('#333'); 

        $btnAceitarOrcamentoAction = new TAction([$this, 'onAceitarOrcamento'],['key'=>$ordem_servico->id]);
        $btnAceitarOrcamentoLabel = new TLabel("Aceitar Orçamento");

        $btnAceitarOrcamento = $this->form->addHeaderAction($btnAceitarOrcamentoLabel, $btnAceitarOrcamentoAction, 'fas:check #4CAF50'); 
        $btnAceitarOrcamentoLabel->setFontSize('12px'); 
        $btnAceitarOrcamentoLabel->setFontColor('#333'); 

        $btnRecusarOrcamentoAction = new TAction([$this, 'onRecusarOrcamento'],['key'=>$ordem_servico->id]);
        $btnRecusarOrcamentoLabel = new TLabel("Recusar Orçamento");

        $btnRecusarOrcamento = $this->form->addHeaderAction($btnRecusarOrcamentoLabel, $btnRecusarOrcamentoAction, 'fas:thumbs-down #F44336'); 
        $btnRecusarOrcamentoLabel->setFontSize('12px'); 
        $btnRecusarOrcamentoLabel->setFontColor('#333'); 

        $btn_onfaturamentoAction = new TAction([$this, 'onFaturamento'],['key'=>$ordem_servico->id]);
        $btn_onfaturamentoLabel = new TLabel("Faturamento");

        $btn_onfaturamento = $this->form->addHeaderAction($btn_onfaturamentoLabel, $btn_onfaturamentoAction, 'fas:money-check-alt #FF5722'); 
        $btn_onfaturamentoLabel->setFontSize('12px'); 
        $btn_onfaturamentoLabel->setFontColor('#333'); 

        $btnGerarVendaAction = new TAction([$this, 'onGerarVenda'],['key'=>$ordem_servico->id]);
        $btnGerarVendaLabel = new TLabel("Gerar Venda");

        $btnGerarVenda = $this->form->addHeaderAction($btnGerarVendaLabel, $btnGerarVendaAction, 'fas:dollar-sign #CDDC39'); 
        $btnGerarVendaLabel->setFontSize('12px'); 
        $btnGerarVendaLabel->setFontColor('#333'); 

        $btnOrdemServicoListOnShowAction = new TAction(['OrdemServicoList', 'onShow'],['key'=>$ordem_servico->id]);
        $btnOrdemServicoListOnShowLabel = new TLabel("Voltar");

        $btnOrdemServicoListOnShow = $this->form->addHeaderAction($btnOrdemServicoListOnShowLabel, $btnOrdemServicoListOnShowAction, 'fas:arrow-alt-circle-left #000000'); 
        $btnOrdemServicoListOnShowLabel->setFontSize('12px'); 
        $btnOrdemServicoListOnShowLabel->setFontColor('#333'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        if($ordem_servico->ordem_servico_situacao_id==OrdemServicoSituacao::OrcamentoAberto)
        {
            $btnGerarVenda->style = 'display:none';
        }

        if($ordem_servico->ordem_servico_situacao_id==OrdemServicoSituacao::OrcamentoAprovado
        or $ordem_servico->ordem_servico_situacao_id==OrdemServicoSituacao::OrcamentoRecusado)
        {
            $btnAceitarOrcamento->style = 'display:none';
            $btnRecusarOrcamento->style = 'display:none';
            $btnEditar->style = 'display:none';
        }

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=OrdemServicoFormView]');
        $style->width = '100% !important';   
        $style->show(true);

    }

    public function onAceitarOrcamento($param = null) 
    {
        try 
        {
            //code here
            new TQuestion("Deseja gerar a Ordem de Serviço?", new TAction([__CLASS__, 'onAceitarOrcamentoYes'], $param), new TAction([__CLASS__, 'onAceitarOrcamentoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onRecusarOrcamento($param = null) 
    {
        try 
        {
            //code here
            $pageParam = ['id' => $param['key']];
            TApplication::loadPage('RecusarOSForm', 'onshow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onFaturamento($param = null) 
    {
        try 
        {
            //code here
            $pageParam = ['ordem_servico_id' => $param['key']]; // ex.: = ['key' => 10]  
            TApplication::loadPage('ServicoFaturamentoSimpleList', 'onReload', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onGerarVenda($param = null) 
    {
        try 
        {
            //code here
            new TQuestion("Deseja aprovar a O.S e gerar a venda?", new TACtion([__CLASS__, 'onGerarVendaYes'], $param), new TAction([__CLASS__, 'onGerarVendaNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onAceitarOrcamentoYes($param = null) 
    {
        try 
        {
            //code here
            TTransaction::open(self::$database);

            $ordem_servico = OrdemServico::find($param['key']);

            if($ordem_servico)
            {
                $ordem_servico->data_abertura_os = date('Y-m-d H:i:s');
                $ordem_servico->ordem_servico_situacao_id = OrdemServicoSituacao::OrcamentoAprovado;

                OrdemServico::ObterProximoNumerOs($ordem_servico);

                $ordem_servico->store();

                OrdemServicoHistorico::LancarHistorico(OrdemServicoSituacao::OrcamentoAprovado, $ordem_servico->id, 'Mudança de Situação de O.S: Orcamento Aprovado');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $ordem_servico->id]);

            TToast::show('success', "O.S. Gerada com sucesso!", 'topRight', 'far:check-circle');
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onAceitarOrcamentoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarVendaYes($param = null) 
    {
        try 
        {
            //code here
            TTransaction::open(self::$database);

            $ordemservico = OrdemServico::find($param['key']);

            if($ordemservico)
            {
                OrdemServico::gerarVenda($ordemservico);
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $ordemservico->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarVendaNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

