<?php

class OrdemServicoItemForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemServicoItem';
    private static $primaryKey = 'id';
    private static $formName = 'form_OrdemServicoItemForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::setSize(0.90, null);
        parent::setTitle("Cadastro de Serviços");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Serviços");

        $criteria_produto_id = new TCriteria();

        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{id} - {nome}','nome asc' , $criteria_produto_id );
        $descricao_servico = new TEntry('descricao_servico');
        $quantidade = new TNumeric('quantidade', '2', ',', '.' );
        $valor_unitario = new TNumeric('valor_unitario', '2', ',', '.' );
        $valor_total = new TNumeric('valor_total', '2', ',', '.' );
        $largura = new TNumeric('largura', '2', ',', '.' );
        $altura = new TNumeric('altura', '2', ',', '.' );
        $id = new THidden('id');
        $ordem_servico_id = new THidden('ordem_servico_id');
        $ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id = new TDBCombo('ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id', 'kraftsoft', 'Funcionario', 'id', '{nome}','nome asc'  );
        $ordem_servico_item_mao_obra_ordem_servico_item_id = new THidden('ordem_servico_item_mao_obra_ordem_servico_item_id');
        $ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas = new TNumeric('ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas', '2', ',', '.' );
        $ordem_servico_item_mao_obra_ordem_servico_item_valor_hora = new TNumeric('ordem_servico_item_mao_obra_ordem_servico_item_valor_hora', '2', ',', '.' );
        $button_adicionar_ordem_servico_item_mao_obra_ordem_servico_item = new TButton('button_adicionar_ordem_servico_item_mao_obra_ordem_servico_item');
        $ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id = new TDBCombo('ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id', 'kraftsoft', 'DespesasServicos', 'id', '{descricao}','descricao asc'  );
        $ordem_servico_item_despesas_ordem_servico_item_id = new THidden('ordem_servico_item_despesas_ordem_servico_item_id');
        $ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id = new TDBRadioGroup('ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id', 'kraftsoft', 'DespesasServicosTipo', 'id', '{descricao}','descricao asc'  );
        $ordem_servico_item_despesas_ordem_servico_item_quantidade = new TNumeric('ordem_servico_item_despesas_ordem_servico_item_quantidade', '2', ',', '.' );
        $ordem_servico_item_despesas_ordem_servico_item_valor_unitario = new TNumeric('ordem_servico_item_despesas_ordem_servico_item_valor_unitario', '2', ',', '.' );
        $ordem_servico_item_despesas_ordem_servico_item_valor_total = new TNumeric('ordem_servico_item_despesas_ordem_servico_item_valor_total', '2', ',', '.' );
        $button_adicionar_ordem_servico_item_despesas_ordem_servico_item = new TButton('button_adicionar_ordem_servico_item_despesas_ordem_servico_item');

        $produto_id->setChangeAction(new TAction([$this,'onChangeServico']));
        $ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id->setChangeAction(new TAction([$this,'onChangeDespesa']));

        $quantidade->setExitAction(new TAction([$this,'onExitQuantidadeServico']));
        $valor_unitario->setExitAction(new TAction([$this,'onExitValorUnitServico']));
        $ordem_servico_item_despesas_ordem_servico_item_quantidade->setExitAction(new TAction([$this,'onExitQuantidadDespesas']));
        $ordem_servico_item_despesas_ordem_servico_item_valor_unitario->setExitAction(new TAction([$this,'onExitValorUnitDespesas']));

        $produto_id->addValidation("Produto id", new TRequiredValidator()); 
        $descricao_servico->addValidation("Descrição do serviço", new TRequiredValidator()); 
        $quantidade->addValidation("Quantidade", new TRequiredValidator()); 
        $valor_unitario->addValidation("Valor unitário", new TRequiredValidator()); 
        $valor_total->addValidation("Valor total", new TRequiredValidator()); 

        $ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id->setLayout('horizontal');
        $valor_total->setEditable(false);
        $ordem_servico_item_despesas_ordem_servico_item_valor_total->setEditable(false);

        $button_adicionar_ordem_servico_item_mao_obra_ordem_servico_item->setAction(new TAction([$this, 'onAddDetailOrdemServicoItemMaoObraOrdemServicoItem'],['static' => 1]), "Adicionar");
        $button_adicionar_ordem_servico_item_despesas_ordem_servico_item->setAction(new TAction([$this, 'onAddDetailOrdemServicoItemDespesasOrdemServicoItem'],['static' => 1]), "Adicionar");

        $button_adicionar_ordem_servico_item_mao_obra_ordem_servico_item->addStyleClass('btn-default');
        $button_adicionar_ordem_servico_item_despesas_ordem_servico_item->addStyleClass('btn-default');

        $button_adicionar_ordem_servico_item_mao_obra_ordem_servico_item->setImage('fas:plus #2ecc71');
        $button_adicionar_ordem_servico_item_despesas_ordem_servico_item->setImage('fas:plus #2ecc71');

        $produto_id->enableSearch();
        $ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id->enableSearch();
        $ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id->enableSearch();

        $id->setSize(200);
        $altura->setSize('100%');
        $largura->setSize('100%');
        $produto_id->setSize('100%');
        $quantidade->setSize('100%');
        $valor_total->setSize('100%');
        $ordem_servico_id->setSize(200);
        $valor_unitario->setSize('100%');
        $descricao_servico->setSize('100%');
        $ordem_servico_item_mao_obra_ordem_servico_item_id->setSize(200);
        $ordem_servico_item_despesas_ordem_servico_item_id->setSize(200);
        $ordem_servico_item_mao_obra_ordem_servico_item_valor_hora->setSize('100%');
        $ordem_servico_item_despesas_ordem_servico_item_quantidade->setSize('100%');
        $ordem_servico_item_despesas_ordem_servico_item_valor_total->setSize('100%');
        $ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id->setSize('100%');
        $ordem_servico_item_despesas_ordem_servico_item_valor_unitario->setSize('100%');
        $ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas->setSize('100%');
        $ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id->setSize('100%');
        $ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id->setSize('100%');

        $button_adicionar_ordem_servico_item_mao_obra_ordem_servico_item->id = '651b2eb44a029';
        $button_adicionar_ordem_servico_item_despesas_ordem_servico_item->id = '651b2fe54a032';

        $this->form->appendPage("Serviço");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Serviço:", '#FF0000', '14px', null, '100%'),$produto_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Descrição do serviço:", '#ff0000', '14px', null, '100%'),$descricao_servico]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$quantidade],[new TLabel("Valor unitário:", '#ff0000', '14px', null, '100%'),$valor_unitario],[new TLabel("Valor total:", '#ff0000', '14px', null, '100%'),$valor_total]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Largura:", null, '14px', null, '100%'),$largura],[new TLabel("Altura:", null, '14px', null, '100%'),$altura],[]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([$id],[$ordem_servico_id],[]);
        $row5->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        $this->form->appendPage("Mão de Obra");

        $this->detailFormOrdemServicoItemMaoObraOrdemServicoItem = new BootstrapFormBuilder('detailFormOrdemServicoItemMaoObraOrdemServicoItem');
        $this->detailFormOrdemServicoItemMaoObraOrdemServicoItem->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormOrdemServicoItemMaoObraOrdemServicoItem->setProperty('class', 'form-horizontal builder-detail-form');

        $row6 = $this->detailFormOrdemServicoItemMaoObraOrdemServicoItem->addFields([new TLabel("Funcionário:", '#ff0000', '14px', null, '100%'),$ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id,$ordem_servico_item_mao_obra_ordem_servico_item_id],[new TLabel("Quantidade Horas:", null, '14px', null, '100%'),$ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas],[new TLabel("Valor Hora:", null, '14px', null, '100%'),$ordem_servico_item_mao_obra_ordem_servico_item_valor_hora]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $this->detailFormOrdemServicoItemMaoObraOrdemServicoItem->addFields([$button_adicionar_ordem_servico_item_mao_obra_ordem_servico_item]);
        $row7->layout = [' col-sm-12'];

        $row8 = $this->detailFormOrdemServicoItemMaoObraOrdemServicoItem->addFields([new THidden('ordem_servico_item_mao_obra_ordem_servico_item__row__id')]);
        $this->ordem_servico_item_mao_obra_ordem_servico_item_criteria = new TCriteria();

        $this->ordem_servico_item_mao_obra_ordem_servico_item_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->disableHtmlConversion();;
        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->generateHiddenFields();
        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->setId('ordem_servico_item_mao_obra_ordem_servico_item_list');

        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->style = 'width:100%';
        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->class .= ' table-bordered';

        $column_ordem_servico_item_mao_obra_ordem_servico_item_funcionario_nome = new TDataGridColumn('funcionario->nome', "Funcionário", 'left');
        $column_ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas_transformed = new TDataGridColumn('quantidade_horas', "Quantidade Horas", 'left');
        $column_ordem_servico_item_mao_obra_ordem_servico_item_valor_hora_transformed = new TDataGridColumn('valor_hora', "Valor Hora", 'left');

        $column_ordem_servico_item_mao_obra_ordem_servico_item__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_ordem_servico_item_mao_obra_ordem_servico_item__row__data->setVisibility(false);

        $action_onEditDetailOrdemServicoItemMaoObra = new TDataGridAction(array('OrdemServicoItemForm', 'onEditDetailOrdemServicoItemMaoObra'));
        $action_onEditDetailOrdemServicoItemMaoObra->setUseButton(false);
        $action_onEditDetailOrdemServicoItemMaoObra->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailOrdemServicoItemMaoObra->setLabel("Editar");
        $action_onEditDetailOrdemServicoItemMaoObra->setImage('far:edit #478fca');
        $action_onEditDetailOrdemServicoItemMaoObra->setFields(['__row__id', '__row__data']);

        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->addAction($action_onEditDetailOrdemServicoItemMaoObra);
        $action_onDeleteDetailOrdemServicoItemMaoObra = new TDataGridAction(array('OrdemServicoItemForm', 'onDeleteDetailOrdemServicoItemMaoObra'));
        $action_onDeleteDetailOrdemServicoItemMaoObra->setUseButton(false);
        $action_onDeleteDetailOrdemServicoItemMaoObra->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailOrdemServicoItemMaoObra->setLabel("Excluir");
        $action_onDeleteDetailOrdemServicoItemMaoObra->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailOrdemServicoItemMaoObra->setFields(['__row__id', '__row__data']);

        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->addAction($action_onDeleteDetailOrdemServicoItemMaoObra);

        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->addColumn($column_ordem_servico_item_mao_obra_ordem_servico_item_funcionario_nome);
        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->addColumn($column_ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas_transformed);
        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->addColumn($column_ordem_servico_item_mao_obra_ordem_servico_item_valor_hora_transformed);

        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->addColumn($column_ordem_servico_item_mao_obra_ordem_servico_item__row__data);

        $this->ordem_servico_item_mao_obra_ordem_servico_item_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->ordem_servico_item_mao_obra_ordem_servico_item_list);
        $this->detailFormOrdemServicoItemMaoObraOrdemServicoItem->addContent([$tableResponsiveDiv]);

        $column_ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_ordem_servico_item_mao_obra_ordem_servico_item_valor_hora_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row9 = $this->form->addFields([$this->detailFormOrdemServicoItemMaoObraOrdemServicoItem]);
        $row9->layout = [' col-sm-12'];

        $this->form->appendPage("Despesas Diversas");

        $this->detailFormOrdemServicoItemDespesasOrdemServicoItem = new BootstrapFormBuilder('detailFormOrdemServicoItemDespesasOrdemServicoItem');
        $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->setProperty('class', 'form-horizontal builder-detail-form');

        $row10 = $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->addFields([new TLabel("Despesas: ", '#ff0000', '14px', null, '100%'),$ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id,$ordem_servico_item_despesas_ordem_servico_item_id],[new TLabel("Despesas tipo:", '#ff0000', '14px', null, '100%'),$ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$ordem_servico_item_despesas_ordem_servico_item_quantidade],[new TLabel("Valor Unitário:", '#ff0000', '14px', null, '100%'),$ordem_servico_item_despesas_ordem_servico_item_valor_unitario]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->addFields([new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$ordem_servico_item_despesas_ordem_servico_item_valor_total],[]);
        $row12->layout = ['col-sm-6','col-sm-6'];

        $row13 = $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->addFields([$button_adicionar_ordem_servico_item_despesas_ordem_servico_item]);
        $row13->layout = [' col-sm-12'];

        $row14 = $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->addFields([new THidden('ordem_servico_item_despesas_ordem_servico_item__row__id')]);
        $this->ordem_servico_item_despesas_ordem_servico_item_criteria = new TCriteria();

        $this->ordem_servico_item_despesas_ordem_servico_item_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->ordem_servico_item_despesas_ordem_servico_item_list->disableHtmlConversion();;
        $this->ordem_servico_item_despesas_ordem_servico_item_list->generateHiddenFields();
        $this->ordem_servico_item_despesas_ordem_servico_item_list->setId('ordem_servico_item_despesas_ordem_servico_item_list');

        $this->ordem_servico_item_despesas_ordem_servico_item_list->style = 'width:100%';
        $this->ordem_servico_item_despesas_ordem_servico_item_list->class .= ' table-bordered';

        $column_ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_descricao = new TDataGridColumn('despesas_servicos->descricao', "Despesas", 'left');
        $column_ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_descricao = new TDataGridColumn('despesas_servicos_tipo->descricao', "Despesas Tipo", 'left');
        $column_ordem_servico_item_despesas_ordem_servico_item_quantidade_transformed = new TDataGridColumn('quantidade', "Quantidade", 'left');
        $column_ordem_servico_item_despesas_ordem_servico_item_valor_unitario_transformed = new TDataGridColumn('valor_unitario', "Valor Unitário", 'left');
        $column_ordem_servico_item_despesas_ordem_servico_item_valor_total_transformed = new TDataGridColumn('valor_total', "Valor Total", 'left');

        $column_ordem_servico_item_despesas_ordem_servico_item__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_ordem_servico_item_despesas_ordem_servico_item__row__data->setVisibility(false);

        $action_onEditDetailOrdemServicoItemDespesas = new TDataGridAction(array('OrdemServicoItemForm', 'onEditDetailOrdemServicoItemDespesas'));
        $action_onEditDetailOrdemServicoItemDespesas->setUseButton(false);
        $action_onEditDetailOrdemServicoItemDespesas->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailOrdemServicoItemDespesas->setLabel("Editar");
        $action_onEditDetailOrdemServicoItemDespesas->setImage('far:edit #478fca');
        $action_onEditDetailOrdemServicoItemDespesas->setFields(['__row__id', '__row__data']);

        $this->ordem_servico_item_despesas_ordem_servico_item_list->addAction($action_onEditDetailOrdemServicoItemDespesas);
        $action_onDeleteDetailOrdemServicoItemDespesas = new TDataGridAction(array('OrdemServicoItemForm', 'onDeleteDetailOrdemServicoItemDespesas'));
        $action_onDeleteDetailOrdemServicoItemDespesas->setUseButton(false);
        $action_onDeleteDetailOrdemServicoItemDespesas->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailOrdemServicoItemDespesas->setLabel("Excluir");
        $action_onDeleteDetailOrdemServicoItemDespesas->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailOrdemServicoItemDespesas->setFields(['__row__id', '__row__data']);

        $this->ordem_servico_item_despesas_ordem_servico_item_list->addAction($action_onDeleteDetailOrdemServicoItemDespesas);

        $this->ordem_servico_item_despesas_ordem_servico_item_list->addColumn($column_ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_descricao);
        $this->ordem_servico_item_despesas_ordem_servico_item_list->addColumn($column_ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_descricao);
        $this->ordem_servico_item_despesas_ordem_servico_item_list->addColumn($column_ordem_servico_item_despesas_ordem_servico_item_quantidade_transformed);
        $this->ordem_servico_item_despesas_ordem_servico_item_list->addColumn($column_ordem_servico_item_despesas_ordem_servico_item_valor_unitario_transformed);
        $this->ordem_servico_item_despesas_ordem_servico_item_list->addColumn($column_ordem_servico_item_despesas_ordem_servico_item_valor_total_transformed);

        $this->ordem_servico_item_despesas_ordem_servico_item_list->addColumn($column_ordem_servico_item_despesas_ordem_servico_item__row__data);

        $this->ordem_servico_item_despesas_ordem_servico_item_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->ordem_servico_item_despesas_ordem_servico_item_list);
        $this->detailFormOrdemServicoItemDespesasOrdemServicoItem->addContent([$tableResponsiveDiv]);

        $column_ordem_servico_item_despesas_ordem_servico_item_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_ordem_servico_item_despesas_ordem_servico_item_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_ordem_servico_item_despesas_ordem_servico_item_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row15 = $this->form->addFields([$this->detailFormOrdemServicoItemDespesasOrdemServicoItem]);
        $row15->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::add($this->form);

    }

    public static function onExitQuantidadeServico($param = null) 
    {
        try 
        {
            //code here
            $qtde = (double) str_replace(',', '.', str_replace('.', '', $param['quantidade']));
            $valor_unit = (double) str_replace(',', '.', str_replace('.', '', $param['valor_unitario']));

            $valor_total = $qtde * $valor_unit;
            $object = new stdClass();
            $object->valor_total = number_format($valor_total, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitValorUnitServico($param = null) 
    {
        try 
        {
            //code here
            $qtde = (double) str_replace(',', '.', str_replace('.', '', $param['quantidade']));
            $valor_unit = (double) str_replace(',', '.', str_replace('.', '', $param['valor_unitario']));

            $valor_total = $qtde * $valor_unit;
            $object = new stdClass();
            $object->valor_total = number_format($valor_total, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitQuantidadDespesas($param = null) 
    {
        try 
        {
            //code here
            $qtde = (double) str_replace(',', '.', str_replace('.', '', $param['ordem_servico_item_despesas_ordem_servico_item_quantidade']));
            $valor_unit = (double) str_replace(',', '.', str_replace('.', '', $param['ordem_servico_item_despesas_ordem_servico_item_valor_unitario']));

            $valor_total = $qtde * $valor_unit;
            $object = new stdClass();
            $object->ordem_servico_item_despesas_ordem_servico_item_valor_total = number_format($valor_total, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitValorUnitDespesas($param = null) 
    {
        try 
        {
            //code here
            $qtde = (double) str_replace(',', '.', str_replace('.', '', $param['ordem_servico_item_despesas_ordem_servico_item_quantidade']));
            $valor_unit = (double) str_replace(',', '.', str_replace('.', '', $param['ordem_servico_item_despesas_ordem_servico_item_valor_unitario']));

            $valor_total = $qtde * $valor_unit;
            $object = new stdClass();
            $object->ordem_servico_item_despesas_ordem_servico_item_valor_total = number_format($valor_total, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onChangeServico($param = null) 
    {
        try 
        {
            //code here
            if (isset($param['produto_id']) && $param['produto_id'])
            {
                TTransaction::open(self::$database);

                $produto = Produto::find($param['produto_id']);

                if($produto)
                {
                    $object = new stdClass();

                    /*
                    $object->xprod = $produto->nome;
                    $object->ncm = $produto->ncm;
                    $object->cest = $produto->cest;
                    $object->ucom = $produto->unidade_medida->sigla;
                    $object->utrib = $produto->unidade_medida->sigla;
                    */

                    //trazer o preço da filial..
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $produto->id)
                                                  ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                  ->first();

                    if($produtofilial)
                    {
                        $object->valor_unitario = number_format($produtofilial->preco_venda, 2, ',', '.');
                        $object->quantidade = number_format(1, 2, ',', '.');
                    }

                    TForm::sendData(self::$formName, $object);

                }
                    TTransaction::close();
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onChangeDespesa($param = null) 
    {
        try 
        {
            //code here
            if (isset($param['ordem_servico_item_despesas_ordem_servico_item_id']) && $param['ordem_servico_item_despesas_ordem_servico_item_id'])
            {
                TTransaction::open(self::$database);

                $despesa = OrdemServicoItemDespesas::find($param['ordem_servico_item_despesas_ordem_servico_item_id']);

                if($despesa)
                {
                    $object = new stdClass();

                    $object->ordem_servico_item_despesas_ordem_servico_item_quantidade = '1,00';
                    $object->ordem_servico_item_despesas_ordem_servico_item_valor_unitario = $despesa->valor_unitario;

                    //trazer o preço da filial..
                    /*
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $produto->id)
                                                  ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                  ->first();
                    */

                    TForm::sendData(self::$formName, $object);

                }
                    TTransaction::close();
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailOrdemServicoItemMaoObraOrdemServicoItem($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Funcionario id", 'name'=>"ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->ordem_servico_item_mao_obra_ordem_servico_item__row__id) ? $data->ordem_servico_item_mao_obra_ordem_servico_item__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new OrdemServicoItemMaoObra();
            $grid_data->__row__id = $__row__id;
            $grid_data->funcionario_id = $data->ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id;
            $grid_data->id = $data->ordem_servico_item_mao_obra_ordem_servico_item_id;
            $grid_data->quantidade_horas = $data->ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas;
            $grid_data->valor_hora = $data->ordem_servico_item_mao_obra_ordem_servico_item_valor_hora;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['funcionario_id'] =  $param['ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['ordem_servico_item_mao_obra_ordem_servico_item_id'] ?? null;
            $__row__data['__display__']['quantidade_horas'] =  $param['ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas'] ?? null;
            $__row__data['__display__']['valor_hora'] =  $param['ordem_servico_item_mao_obra_ordem_servico_item_valor_hora'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->ordem_servico_item_mao_obra_ordem_servico_item_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('ordem_servico_item_mao_obra_ordem_servico_item_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item_id = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item_valor_hora = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#651b2eb44a029');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailOrdemServicoItemDespesasOrdemServicoItem($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Despesas servicos id", 'name'=>"ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Despesas servicos tipo id", 'name'=>"ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Quantidade", 'name'=>"ordem_servico_item_despesas_ordem_servico_item_quantidade", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Unitário", 'name'=>"ordem_servico_item_despesas_ordem_servico_item_valor_unitario", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Total", 'name'=>"ordem_servico_item_despesas_ordem_servico_item_valor_total", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->ordem_servico_item_despesas_ordem_servico_item__row__id) ? $data->ordem_servico_item_despesas_ordem_servico_item__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new OrdemServicoItemDespesas();
            $grid_data->__row__id = $__row__id;
            $grid_data->despesas_servicos_id = $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id;
            $grid_data->id = $data->ordem_servico_item_despesas_ordem_servico_item_id;
            $grid_data->despesas_servicos_tipo_id = $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id;
            $grid_data->quantidade = $data->ordem_servico_item_despesas_ordem_servico_item_quantidade;
            $grid_data->valor_unitario = $data->ordem_servico_item_despesas_ordem_servico_item_valor_unitario;
            $grid_data->valor_total = $data->ordem_servico_item_despesas_ordem_servico_item_valor_total;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['despesas_servicos_id'] =  $param['ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['ordem_servico_item_despesas_ordem_servico_item_id'] ?? null;
            $__row__data['__display__']['despesas_servicos_tipo_id'] =  $param['ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['ordem_servico_item_despesas_ordem_servico_item_quantidade'] ?? null;
            $__row__data['__display__']['valor_unitario'] =  $param['ordem_servico_item_despesas_ordem_servico_item_valor_unitario'] ?? null;
            $__row__data['__display__']['valor_total'] =  $param['ordem_servico_item_despesas_ordem_servico_item_valor_total'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->ordem_servico_item_despesas_ordem_servico_item_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('ordem_servico_item_despesas_ordem_servico_item_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_id = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_quantidade = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_valor_unitario = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_valor_total = '';
            $data->ordem_servico_item_despesas_ordem_servico_item__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#651b2fe54a032');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailOrdemServicoItemMaoObra($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id = $__row__data->__display__->funcionario_id ?? null;
            $data->ordem_servico_item_mao_obra_ordem_servico_item_id = $__row__data->__display__->id ?? null;
            $data->ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas = $__row__data->__display__->quantidade_horas ?? null;
            $data->ordem_servico_item_mao_obra_ordem_servico_item_valor_hora = $__row__data->__display__->valor_hora ?? null;
            $data->ordem_servico_item_mao_obra_ordem_servico_item__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#651b2eb44a029');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailOrdemServicoItemMaoObra($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->ordem_servico_item_mao_obra_ordem_servico_item_funcionario_id = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item_id = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item_valor_hora = '';
            $data->ordem_servico_item_mao_obra_ordem_servico_item__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('ordem_servico_item_mao_obra_ordem_servico_item_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailOrdemServicoItemDespesas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id = $__row__data->__display__->despesas_servicos_id ?? null;
            $data->ordem_servico_item_despesas_ordem_servico_item_id = $__row__data->__display__->id ?? null;
            $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id = $__row__data->__display__->despesas_servicos_tipo_id ?? null;
            $data->ordem_servico_item_despesas_ordem_servico_item_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->ordem_servico_item_despesas_ordem_servico_item_valor_unitario = $__row__data->__display__->valor_unitario ?? null;
            $data->ordem_servico_item_despesas_ordem_servico_item_valor_total = $__row__data->__display__->valor_total ?? null;
            $data->ordem_servico_item_despesas_ordem_servico_item__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#651b2fe54a032');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailOrdemServicoItemDespesas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_id = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_id = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_quantidade = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_valor_unitario = '';
            $data->ordem_servico_item_despesas_ordem_servico_item_valor_total = '';
            $data->ordem_servico_item_despesas_ordem_servico_item__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('ordem_servico_item_despesas_ordem_servico_item_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new OrdemServicoItem(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $ordem_servico_item_despesas_ordem_servico_item_items = $this->storeMasterDetailItems('OrdemServicoItemDespesas', 'ordem_servico_item_id', 'ordem_servico_item_despesas_ordem_servico_item', $object, $param['ordem_servico_item_despesas_ordem_servico_item_list___row__data'] ?? [], $this->form, $this->ordem_servico_item_despesas_ordem_servico_item_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->ordem_servico_item_despesas_ordem_servico_item_criteria); 

            $ordem_servico_item_mao_obra_ordem_servico_item_items = $this->storeMasterDetailItems('OrdemServicoItemMaoObra', 'ordem_servico_item_id', 'ordem_servico_item_mao_obra_ordem_servico_item', $object, $param['ordem_servico_item_mao_obra_ordem_servico_item_list___row__data'] ?? [], $this->form, $this->ordem_servico_item_mao_obra_ordem_servico_item_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->ordem_servico_item_mao_obra_ordem_servico_item_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            new TMessage('info', "Registro salvo", $messageAction); 

                TWindow::closeWindow(parent::getId()); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new OrdemServicoItem($key); // instantiates the Active Record 

                $ordem_servico_item_despesas_ordem_servico_item_items = $this->loadMasterDetailItems('OrdemServicoItemDespesas', 'ordem_servico_item_id', 'ordem_servico_item_despesas_ordem_servico_item', $object, $this->form, $this->ordem_servico_item_despesas_ordem_servico_item_list, $this->ordem_servico_item_despesas_ordem_servico_item_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $ordem_servico_item_mao_obra_ordem_servico_item_items = $this->loadMasterDetailItems('OrdemServicoItemMaoObra', 'ordem_servico_item_id', 'ordem_servico_item_mao_obra_ordem_servico_item', $object, $this->form, $this->ordem_servico_item_mao_obra_ordem_servico_item_list, $this->ordem_servico_item_mao_obra_ordem_servico_item_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        //$object->ordem_servico_id = $param['id'];
        $object->quantidade = '1,00';
        $object->ordem_servico_item_mao_obra_ordem_servico_item_quantidade_horas = '1,00';
        $object->ordem_servico_item_despesas_ordem_servico_item_despesas_servicos_tipo_id = '1';

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

