<?php

class OrdemServicoPropostaDocument extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemServico';
    private static $primaryKey = 'id';
    private static $htmlFile = 'app/documents/OrdemServicoPropostaDocumentTemplate.html';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {

    }

    public static function onGenerate($param)
    {
        try 
        {
            TTransaction::open(self::$database);

            $class = self::$activeRecord;
            $object = new $class($param['key']);

            $html = new AdiantiHTMLDocumentParser(self::$htmlFile);
            $html->setMaster($object);

            $criteria_OrdemServicoItem_ordem_servico_id = new TCriteria();
            $criteria_OrdemServicoItem_ordem_servico_id->add(new TFilter('ordem_servico_id', '=', $param['key']));

            $object->data_emissao = TDate::date2br($object->data_emissao);
            $object->data_abertura_os = TDate::date2br($object->data_abertura_os);
            $object->prazo_entrega = TDate::date2br($object->prazo_entrega);

            $objectsOrdemServicoItem_ordem_servico_id = OrdemServicoItem::getObjects($criteria_OrdemServicoItem_ordem_servico_id);
            $html->setDetail('OrdemServicoItem.ordem_servico_id', $objectsOrdemServicoItem_ordem_servico_id);

            $pageSize = 'A4';
            $document = 'tmp/'.uniqid().'.pdf'; 

            if(!$object->desconto)
            {
                $object->desconto = '0.00';
            }

            $html->process();

            $html->saveAsPDF($document, $pageSize, 'portrait');

            TTransaction::close();

            if(empty($param['returnFile']))
            {
                parent::openFile($document);

                new TMessage('info', _t('Document successfully generated'));    
            }
            else
            {
                return $document;
            }
        } 
        catch (Exception $e) 
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());

            // undo all pending operations
            TTransaction::rollback();
        }
    }

}

