<?php

class RecusarOSForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_RecusarOSForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();
        parent::setSize(0.40, null);
        parent::setTitle("Recusar O.S");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Recusar O.S");


        $motivo_nao_aprovacao_orcamento = new TText('motivo_nao_aprovacao_orcamento');
        $id = new THidden('id');


        $id->setSize(200);
        $motivo_nao_aprovacao_orcamento->setSize('100%', 150);


        $row1 = $this->form->addFields([new TLabel("Justificativa:", null, '14px', null, '100%'),$motivo_nao_aprovacao_orcamento]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$id],[],[]);
        $row2->layout = ['col-sm-3','col-sm-3', 'col-sm-6'];

        // create the form actions
        $btn_onconfirmarrecusar = $this->form->addAction("Confirmar", new TAction([$this, 'onConfirmarRecusar']), 'fas:ban #ffffff');
        $this->btn_onconfirmarrecusar = $btn_onconfirmarrecusar;
        $btn_onconfirmarrecusar->addStyleClass('btn-danger'); 

        parent::add($this->form);

    }

    public function onConfirmarRecusar($param = null) 
    {
        try
        {
            TTransaction::open('kraftsoft');

            $this->form->validate();

            $data = $this->form->getData();

            $OS = OrdemServico::find($data->id);

            if($OS)
            {
                $OS->motivo_nao_aprovacao_orcamento = $data->motivo_nao_aprovacao_orcamento;
                $OS->ordem_servico_situacao_id = OrdemServicoSituacao::OrcamentoRecusado;
                $OS->store();

                OrdemServicoHistorico::LancarHistorico(OrdemServicoSituacao::OrcamentoRecusado, $OS->id, 'Mudança de Situação de O.S: Orcamento Recusado');
            }

            TToast::show('success', "O.S recusada com sucesso.", 'topRight', 'far:check-circle');
            TApplication::loadPage('OrdemServicoList', 'onShow');

            TTransaction::close();
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

        $object = new stdClass();
        $object->id = $param['id'];

        TForm::sendData(self::$formName, $object);

    } 

}

