<?php

class ServicoGrupoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ProdutoGrupo';
    private static $primaryKey = 'id';
    private static $formName = 'form_ServicoGrupoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de grupo de serviço");


        $id = new TEntry('id');
        $tipo_recurso_id = new THidden('tipo_recurso_id');
        $descricao = new TEntry('descricao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $produtogrupo_subgrupo_produto_grupo_descricao = new TEntry('produtogrupo_subgrupo_produto_grupo_descricao');
        $produtogrupo_subgrupo_produto_grupo_id = new THidden('produtogrupo_subgrupo_produto_grupo_id');
        $button_adicionar_produtogrupo_subgrupo_produto_grupo = new TButton('button_adicionar_produtogrupo_subgrupo_produto_grupo');

        $descricao->addValidation("Descrição", new TRequiredValidator()); 

        $tipo_recurso_id->setValue(TipoRecurso::Servico);
        $button_adicionar_produtogrupo_subgrupo_produto_grupo->setAction(new TAction([$this, 'onAddDetailProdutogrupoSubgrupoProdutoGrupo'],['static' => 1]), "Adicionar");
        $button_adicionar_produtogrupo_subgrupo_produto_grupo->addStyleClass('btn-default');
        $button_adicionar_produtogrupo_subgrupo_produto_grupo->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $tipo_recurso_id->setSize(200);
        $alterado_por->setSize('100%');
        $produtogrupo_subgrupo_produto_grupo_id->setSize(200);
        $produtogrupo_subgrupo_produto_grupo_descricao->setSize('100%');

        $button_adicionar_produtogrupo_subgrupo_produto_grupo->id = '617ca83add16e';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[$tipo_recurso_id]);
        $row1->layout = ['col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $bcontainer_630b64150fffc = new BContainer('bcontainer_630b64150fffc');
        $this->bcontainer_630b64150fffc = $bcontainer_630b64150fffc;

        $bcontainer_630b64150fffc->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_630b64150fffc->setBorderColor('#c0c0c0');

        $row3 = $bcontainer_630b64150fffc->addFields([new TLabel("Criado em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null),$criado_por],[new TLabel("Alterado em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null),$alterado_por]);
        $row3->layout = ['col-sm-2','col-sm-4','col-sm-2','col-sm-4'];

        $row4 = $this->form->addFields([$bcontainer_630b64150fffc]);
        $row4->layout = [' col-sm-12'];

        $this->form->appendPage("Sub-Grupo");

        $this->detailFormProdutogrupoSubgrupoProdutoGrupo = new BootstrapFormBuilder('detailFormProdutogrupoSubgrupoProdutoGrupo');
        $this->detailFormProdutogrupoSubgrupoProdutoGrupo->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormProdutogrupoSubgrupoProdutoGrupo->setProperty('class', 'form-horizontal builder-detail-form');

        $row5 = $this->detailFormProdutogrupoSubgrupoProdutoGrupo->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$produtogrupo_subgrupo_produto_grupo_descricao,$produtogrupo_subgrupo_produto_grupo_id]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->detailFormProdutogrupoSubgrupoProdutoGrupo->addFields([$button_adicionar_produtogrupo_subgrupo_produto_grupo]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->detailFormProdutogrupoSubgrupoProdutoGrupo->addFields([new THidden('produtogrupo_subgrupo_produto_grupo__row__id')]);
        $this->produtogrupo_subgrupo_produto_grupo_criteria = new TCriteria();

        $this->produtogrupo_subgrupo_produto_grupo_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->produtogrupo_subgrupo_produto_grupo_list->disableHtmlConversion();;
        $this->produtogrupo_subgrupo_produto_grupo_list->generateHiddenFields();
        $this->produtogrupo_subgrupo_produto_grupo_list->setId('produtogrupo_subgrupo_produto_grupo_list');

        $this->produtogrupo_subgrupo_produto_grupo_list->disableDefaultClick();
        $this->produtogrupo_subgrupo_produto_grupo_list->style = 'width:100%';
        $this->produtogrupo_subgrupo_produto_grupo_list->class .= ' table-bordered';

        $column_produtogrupo_subgrupo_produto_grupo_descricao = new TDataGridColumn('descricao', "Descrição", 'left');

        $column_produtogrupo_subgrupo_produto_grupo__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_produtogrupo_subgrupo_produto_grupo__row__data->setVisibility(false);

        $action_onEditDetailProdutogrupoSubgrupo = new TDataGridAction(array('ServicoGrupoForm', 'onEditDetailProdutogrupoSubgrupo'));
        $action_onEditDetailProdutogrupoSubgrupo->setUseButton(false);
        $action_onEditDetailProdutogrupoSubgrupo->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailProdutogrupoSubgrupo->setLabel("Editar");
        $action_onEditDetailProdutogrupoSubgrupo->setImage('far:edit #478fca');
        $action_onEditDetailProdutogrupoSubgrupo->setFields(['__row__id', '__row__data']);

        $this->produtogrupo_subgrupo_produto_grupo_list->addAction($action_onEditDetailProdutogrupoSubgrupo);
        $action_onDeleteDetailProdutogrupoSubgrupo = new TDataGridAction(array('ServicoGrupoForm', 'onDeleteDetailProdutogrupoSubgrupo'));
        $action_onDeleteDetailProdutogrupoSubgrupo->setUseButton(false);
        $action_onDeleteDetailProdutogrupoSubgrupo->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailProdutogrupoSubgrupo->setLabel("Excluir");
        $action_onDeleteDetailProdutogrupoSubgrupo->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailProdutogrupoSubgrupo->setFields(['__row__id', '__row__data']);

        $this->produtogrupo_subgrupo_produto_grupo_list->addAction($action_onDeleteDetailProdutogrupoSubgrupo);

        $this->produtogrupo_subgrupo_produto_grupo_list->addColumn($column_produtogrupo_subgrupo_produto_grupo_descricao);

        $this->produtogrupo_subgrupo_produto_grupo_list->addColumn($column_produtogrupo_subgrupo_produto_grupo__row__data);

        $this->produtogrupo_subgrupo_produto_grupo_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->produtogrupo_subgrupo_produto_grupo_list);
        $this->detailFormProdutogrupoSubgrupoProdutoGrupo->addContent([$tableResponsiveDiv]);
        $row8 = $this->form->addFields([$this->detailFormProdutogrupoSubgrupoProdutoGrupo]);
        $row8->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ServicoGrupoHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Ordem de Serviço","Cadastro de grupo de serviço"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailProdutogrupoSubgrupoProdutoGrupo($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Descrição", 'name'=>"produtogrupo_subgrupo_produto_grupo_descricao", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->produtogrupo_subgrupo_produto_grupo__row__id) ? $data->produtogrupo_subgrupo_produto_grupo__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ProdutogrupoSubgrupo();
            $grid_data->__row__id = $__row__id;
            $grid_data->descricao = $data->produtogrupo_subgrupo_produto_grupo_descricao;
            $grid_data->id = $data->produtogrupo_subgrupo_produto_grupo_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['descricao'] =  $param['produtogrupo_subgrupo_produto_grupo_descricao'] ?? null;
            $__row__data['__display__']['id'] =  $param['produtogrupo_subgrupo_produto_grupo_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->produtogrupo_subgrupo_produto_grupo_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('produtogrupo_subgrupo_produto_grupo_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->produtogrupo_subgrupo_produto_grupo_descricao = '';
            $data->produtogrupo_subgrupo_produto_grupo_id = '';
            $data->produtogrupo_subgrupo_produto_grupo__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#617ca83add16e');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailProdutogrupoSubgrupo($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->produtogrupo_subgrupo_produto_grupo_descricao = $__row__data->__display__->descricao ?? null;
            $data->produtogrupo_subgrupo_produto_grupo_id = $__row__data->__display__->id ?? null;
            $data->produtogrupo_subgrupo_produto_grupo__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#617ca83add16e');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailProdutogrupoSubgrupo($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->produtogrupo_subgrupo_produto_grupo_descricao = '';
            $data->produtogrupo_subgrupo_produto_grupo_id = '';
            $data->produtogrupo_subgrupo_produto_grupo__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('produtogrupo_subgrupo_produto_grupo_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ProdutoGrupo(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $produtogrupo_subgrupo_produto_grupo_items = $this->storeMasterDetailItems('ProdutogrupoSubgrupo', 'produto_grupo_id', 'produtogrupo_subgrupo_produto_grupo', $object, $param['produtogrupo_subgrupo_produto_grupo_list___row__data'] ?? [], $this->form, $this->produtogrupo_subgrupo_produto_grupo_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->produtogrupo_subgrupo_produto_grupo_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ServicoGrupoHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ProdutoGrupo($key); // instantiates the Active Record 

                $produtogrupo_subgrupo_produto_grupo_items = $this->loadMasterDetailItems('ProdutogrupoSubgrupo', 'produto_grupo_id', 'produtogrupo_subgrupo_produto_grupo', $object, $this->form, $this->produtogrupo_subgrupo_produto_grupo_list, $this->produtogrupo_subgrupo_produto_grupo_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

