<?php

class OrdemProducaoDocument extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemProducao';
    private static $primaryKey = 'id';
    private static $htmlFile = 'app/documents/OrdemProducaoDocumentTemplate.html';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {

    }

    public static function onGenerate($param)
    {
        try 
        {
            TTransaction::open(self::$database);

            $class = self::$activeRecord;
            $object = new $class($param['key']);

            $html = new AdiantiHTMLDocumentParser(self::$htmlFile);
            $html->setMaster($object);

            $criteria_OrdemProducaoItens_ordem_producao_id = new TCriteria();
            $criteria_OrdemProducaoItens_ordem_producao_id->add(new TFilter('ordem_producao_id', '=', $param['key']));
            $criteria_OrdemProducaoEtapas_ordem_producao_id = new TCriteria();
            $criteria_OrdemProducaoEtapas_ordem_producao_id->add(new TFilter('ordem_producao_id', '=', $param['key']));

            $object->criado_em = TDate::date2br($object->criado_em);
            $object->data_producao = TDate::date2br($object->data_producao);

            $objectsOrdemProducaoItens_ordem_producao_id = OrdemProducaoItens::getObjects($criteria_OrdemProducaoItens_ordem_producao_id);
            $html->setDetail('OrdemProducaoItens.ordem_producao_id', $objectsOrdemProducaoItens_ordem_producao_id);
            $objectsOrdemProducaoEtapas_ordem_producao_id = OrdemProducaoEtapas::getObjects($criteria_OrdemProducaoEtapas_ordem_producao_id);
            $html->setDetail('OrdemProducaoEtapas.ordem_producao_id', $objectsOrdemProducaoEtapas_ordem_producao_id);

            $pageSize = 'A4';
            $document = 'tmp/'.uniqid().'.pdf'; 

            //$pageSize = array(229.76, 457.64);

            $html->process();

            $html->saveAsPDF($document, $pageSize, 'portrait');

            TTransaction::close();

            if(empty($param['returnFile']))
            {
                parent::openFile($document);

                new TMessage('info', _t('Document successfully generated'));    
            }
            else
            {
                return $document;
            }
        } 
        catch (Exception $e) 
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());

            // undo all pending operations
            TTransaction::rollback();
        }
    }

}

