<?php

class OrdemProducaoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemProducao';
    private static $primaryKey = 'id';
    private static $formName = 'form_OrdemProducaoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de ordem de produção");

        $criteria_produto_id = new TCriteria();
        $criteria_estoque_deposito_id = new TCriteria();
        $criteria_ordem_producao_itens_ordem_producao_produto_id = new TCriteria();
        $criteria_ordem_producao_itens_ordem_producao_estoque_deposito_id = new TCriteria();

        $filterVar = ProdutoTipo::Fabricado;
        $criteria_produto_id->add(new TFilter('produto_tipo_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_estoque_deposito_id->add(new TFilter('system_unit_id', '=', $filterVar)); 
        $filterVar = TipoRecurso::Produto;
        $criteria_ordem_producao_itens_ordem_producao_produto_id->add(new TFilter('tipo_recurso_id', '=', $filterVar)); 
        $filterVar = TSession::getValue("userunitid");
        $criteria_ordem_producao_itens_ordem_producao_estoque_deposito_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        $ordem_producao_situacao_id = new TDBArrowStep('ordem_producao_situacao_id', 'kraftsoft', 'OrdemProducaoSituacao', 'id', '{descricao}','id asc'  );
        $id = new TEntry('id');
        $data_producao = new TDate('data_producao');
        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc' , $criteria_produto_id );
        $produto_ficha_tecnica_id = new TCombo('produto_ficha_tecnica_id');
        $quantidade = new TSpinner('quantidade');
        $button_carregar_ficha_tecnica = new TButton('button_carregar_ficha_tecnica');
        $estoque_deposito_id = new TDBCombo('estoque_deposito_id', 'kraftsoft', 'EstoqueDeposito', 'id', '{descricao}','descricao asc' , $criteria_estoque_deposito_id );
        $ordem_producao_itens_ordem_producao_produto_id = new TDBCombo('ordem_producao_itens_ordem_producao_produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc' , $criteria_ordem_producao_itens_ordem_producao_produto_id );
        $ordem_producao_itens_ordem_producao_id = new THidden('ordem_producao_itens_ordem_producao_id');
        $ordem_producao_itens_ordem_producao_quantidade = new TNumeric('ordem_producao_itens_ordem_producao_quantidade', '2', ',', '.' );
        $ordem_producao_itens_ordem_producao_quantidade_total = new TNumeric('ordem_producao_itens_ordem_producao_quantidade_total', '2', ',', '.' );
        $ordem_producao_itens_ordem_producao_estoque_deposito_id = new TDBCombo('ordem_producao_itens_ordem_producao_estoque_deposito_id', 'kraftsoft', 'EstoqueDeposito', 'id', '{descricao}','descricao asc' , $criteria_ordem_producao_itens_ordem_producao_estoque_deposito_id );
        $button_adicionar_ordem_producao_itens_ordem_producao = new TButton('button_adicionar_ordem_producao_itens_ordem_producao');
        $ordem_producao_etapas_ordem_producao_descricao = new TEntry('ordem_producao_etapas_ordem_producao_descricao');
        $ordem_producao_etapas_ordem_producao_id = new THidden('ordem_producao_etapas_ordem_producao_id');
        $ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id = new TDBCombo('ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id', 'kraftsoft', 'OrdemProducaoEtapasSituacao', 'id', '{descricao}','descricao asc'  );
        $ordem_producao_etapas_ordem_producao_ordem = new TEntry('ordem_producao_etapas_ordem_producao_ordem');
        $button_adicionar_ordem_producao_etapas_ordem_producao = new TButton('button_adicionar_ordem_producao_etapas_ordem_producao');
        $observacoes = new TText('observacoes');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $system_unit_id = new THidden('system_unit_id');

        $produto_id->setChangeAction(new TAction([$this,'onExitProdutoFabricado']));
        $ordem_producao_itens_ordem_producao_produto_id->setChangeAction(new TAction([$this,'onExitProdutoMateriaPrima']));

        $ordem_producao_itens_ordem_producao_quantidade->setExitAction(new TAction([$this,'onExitQuantidadeMateriaPrima']));

        $data_producao->addValidation("Data Produção", new TRequiredValidator()); 
        $produto_id->addValidation("Produto id", new TRequiredValidator()); 
        $produto_ficha_tecnica_id->addValidation("Produto ficha tecnica id", new TRequiredValidator()); 
        $quantidade->addValidation("Quantidade", new TRequiredValidator()); 
        $estoque_deposito_id->addValidation("Depósito Fabricados", new TRequiredValidator()); 

        $ordem_producao_situacao_id->setColorColumn('cor');
        $ordem_producao_situacao_id->setFilledColor('#fd9308');
        $ordem_producao_situacao_id->setFilledFontColor('#ffffff');
        $ordem_producao_situacao_id->setUnfilledColor('#d3d3d3');
        $ordem_producao_situacao_id->setUnfilledFontColor('#333333');
        $data_producao->setValue(date('d/m/Y'));
        $quantidade->setRange(1, 2000, 1);
        $data_producao->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $data_producao->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $button_carregar_ficha_tecnica->setAction(new TAction([$this, 'onCarregarFichaTecnica']), "Carregar ficha técnica");
        $button_adicionar_ordem_producao_itens_ordem_producao->setAction(new TAction([$this, 'onAddDetailOrdemProducaoItensOrdemProducao'],['static' => 1]), "Adicionar");
        $button_adicionar_ordem_producao_etapas_ordem_producao->setAction(new TAction([$this, 'onAddDetailOrdemProducaoEtapasOrdemProducao'],['static' => 1]), "Adicionar");

        $button_carregar_ficha_tecnica->addStyleClass('btn-primary');
        $button_adicionar_ordem_producao_itens_ordem_producao->addStyleClass('btn-default');
        $button_adicionar_ordem_producao_etapas_ordem_producao->addStyleClass('btn-default');

        $button_carregar_ficha_tecnica->setImage('fas:calculator #FFFFFF');
        $button_adicionar_ordem_producao_itens_ordem_producao->setImage('fas:plus #2ecc71');
        $button_adicionar_ordem_producao_etapas_ordem_producao->setImage('fas:plus #2ecc71');

        $produto_id->enableSearch();
        $estoque_deposito_id->enableSearch();
        $produto_ficha_tecnica_id->enableSearch();
        $ordem_producao_itens_ordem_producao_produto_id->enableSearch();
        $ordem_producao_itens_ordem_producao_estoque_deposito_id->enableSearch();
        $ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id->enableSearch();

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $ordem_producao_situacao_id->setEditable(false);
        $ordem_producao_itens_ordem_producao_quantidade_total->setEditable(false);

        $id->setSize('100%');
        $quantidade->setSize('68%');
        $criado_em->setSize('100%');
        $produto_id->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $system_unit_id->setSize(200);
        $alterado_por->setSize('100%');
        $data_producao->setSize('100%');
        $observacoes->setSize('100%', 70);
        $estoque_deposito_id->setSize('100%');
        $produto_ficha_tecnica_id->setSize('100%');
        $ordem_producao_situacao_id->setSize('100%', 55);
        $ordem_producao_itens_ordem_producao_id->setSize(200);
        $ordem_producao_etapas_ordem_producao_id->setSize(200);
        $ordem_producao_etapas_ordem_producao_ordem->setSize('100%');
        $ordem_producao_itens_ordem_producao_produto_id->setSize('100%');
        $ordem_producao_itens_ordem_producao_quantidade->setSize('100%');
        $ordem_producao_etapas_ordem_producao_descricao->setSize('100%');
        $ordem_producao_itens_ordem_producao_quantidade_total->setSize('100%');
        $ordem_producao_itens_ordem_producao_estoque_deposito_id->setSize('100%');
        $ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id->setSize('100%');

        $button_adicionar_ordem_producao_itens_ordem_producao->id = '63d686979a224';
        $button_adicionar_ordem_producao_etapas_ordem_producao->id = '63d688809a22c';

        $row1 = $this->form->addFields([$ordem_producao_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Data Produção:", '#ff0000', '14px', null, '100%'),$data_producao]);
        $row2->layout = ['col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Produto Fabricado:", '#ff0000', '14px', null, '100%'),$produto_id],[new TLabel("Ficha Tecnica:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_id]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$quantidade,$button_carregar_ficha_tecnica],[new TLabel(" Depósito Fabricados", '#FF0000', '14px', null, '100%'),$estoque_deposito_id]);
        $row4->layout = ['col-sm-6',' col-sm-6'];

        $tab_63d67bbaf26bc = new BootstrapFormBuilder('tab_63d67bbaf26bc');
        $this->tab_63d67bbaf26bc = $tab_63d67bbaf26bc;
        $tab_63d67bbaf26bc->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63d67bbaf26bc->appendPage("Composição");

        $tab_63d67bbaf26bc->addFields([new THidden('current_tab_tab_63d67bbaf26bc')]);
        $tab_63d67bbaf26bc->setTabFunction("$('[name=current_tab_tab_63d67bbaf26bc]').val($(this).attr('data-current_page'));");

        $this->detailFormOrdemProducaoItensOrdemProducao = new BootstrapFormBuilder('detailFormOrdemProducaoItensOrdemProducao');
        $this->detailFormOrdemProducaoItensOrdemProducao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormOrdemProducaoItensOrdemProducao->setProperty('class', 'form-horizontal builder-detail-form');

        $row5 = $this->detailFormOrdemProducaoItensOrdemProducao->addFields([new TLabel("Produto matéria prima:", '#ff0000', '14px', null, '100%'),$ordem_producao_itens_ordem_producao_produto_id,$ordem_producao_itens_ordem_producao_id]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->detailFormOrdemProducaoItensOrdemProducao->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$ordem_producao_itens_ordem_producao_quantidade],[new TLabel("Quantidade Total:", '#FF0000', '14px', null, '100%'),$ordem_producao_itens_ordem_producao_quantidade_total],[new TLabel("Depósito:", '#FF0000', '14px', null, '100%'),$ordem_producao_itens_ordem_producao_estoque_deposito_id]);
        $row6->layout = [' col-sm-3',' col-sm-3','col-sm-6'];

        $row7 = $this->detailFormOrdemProducaoItensOrdemProducao->addFields([$button_adicionar_ordem_producao_itens_ordem_producao]);
        $row7->layout = [' col-sm-12'];

        $row8 = $this->detailFormOrdemProducaoItensOrdemProducao->addFields([new THidden('ordem_producao_itens_ordem_producao__row__id')]);
        $this->ordem_producao_itens_ordem_producao_criteria = new TCriteria();

        $this->ordem_producao_itens_ordem_producao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->ordem_producao_itens_ordem_producao_list->disableHtmlConversion();;
        $this->ordem_producao_itens_ordem_producao_list->generateHiddenFields();
        $this->ordem_producao_itens_ordem_producao_list->setId('ordem_producao_itens_ordem_producao_list');

        $this->ordem_producao_itens_ordem_producao_list->style = 'width:100%';
        $this->ordem_producao_itens_ordem_producao_list->class .= ' table-bordered';

        $column_ordem_producao_itens_ordem_producao_produto_nome = new TDataGridColumn('produto->nome', "Produto", 'left');
        $column_ordem_producao_itens_ordem_producao_quantidade_transformed = new TDataGridColumn('quantidade', "Quantidade", 'left');
        $column_ordem_producao_itens_ordem_producao_quantidade_total_transformed = new TDataGridColumn('quantidade_total', "Quantidade Total", 'left');
        $column_ordem_producao_itens_ordem_producao_estoque_deposito_descricao = new TDataGridColumn('estoque_deposito->descricao', "Depósito", 'left');

        $column_ordem_producao_itens_ordem_producao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_ordem_producao_itens_ordem_producao__row__data->setVisibility(false);

        $action_onEditDetailOrdemProducaoItens = new TDataGridAction(array('OrdemProducaoForm', 'onEditDetailOrdemProducaoItens'));
        $action_onEditDetailOrdemProducaoItens->setUseButton(false);
        $action_onEditDetailOrdemProducaoItens->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailOrdemProducaoItens->setLabel("Editar");
        $action_onEditDetailOrdemProducaoItens->setImage('far:edit #478fca');
        $action_onEditDetailOrdemProducaoItens->setFields(['__row__id', '__row__data']);

        $this->ordem_producao_itens_ordem_producao_list->addAction($action_onEditDetailOrdemProducaoItens);
        $action_onDeleteDetailOrdemProducaoItens = new TDataGridAction(array('OrdemProducaoForm', 'onDeleteDetailOrdemProducaoItens'));
        $action_onDeleteDetailOrdemProducaoItens->setUseButton(false);
        $action_onDeleteDetailOrdemProducaoItens->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailOrdemProducaoItens->setLabel("Excluir");
        $action_onDeleteDetailOrdemProducaoItens->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailOrdemProducaoItens->setFields(['__row__id', '__row__data']);

        $this->ordem_producao_itens_ordem_producao_list->addAction($action_onDeleteDetailOrdemProducaoItens);

        $this->ordem_producao_itens_ordem_producao_list->addColumn($column_ordem_producao_itens_ordem_producao_produto_nome);
        $this->ordem_producao_itens_ordem_producao_list->addColumn($column_ordem_producao_itens_ordem_producao_quantidade_transformed);
        $this->ordem_producao_itens_ordem_producao_list->addColumn($column_ordem_producao_itens_ordem_producao_quantidade_total_transformed);
        $this->ordem_producao_itens_ordem_producao_list->addColumn($column_ordem_producao_itens_ordem_producao_estoque_deposito_descricao);

        $this->ordem_producao_itens_ordem_producao_list->addColumn($column_ordem_producao_itens_ordem_producao__row__data);

        $this->ordem_producao_itens_ordem_producao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->ordem_producao_itens_ordem_producao_list);
        $this->detailFormOrdemProducaoItensOrdemProducao->addContent([$tableResponsiveDiv]);

        $column_ordem_producao_itens_ordem_producao_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_ordem_producao_itens_ordem_producao_quantidade_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });        $row9 = $tab_63d67bbaf26bc->addFields([$this->detailFormOrdemProducaoItensOrdemProducao]);
        $row9->layout = [' col-sm-12'];

        $tab_63d67bbaf26bc->appendPage("Etapas");

        $this->detailFormOrdemProducaoEtapasOrdemProducao = new BootstrapFormBuilder('detailFormOrdemProducaoEtapasOrdemProducao');
        $this->detailFormOrdemProducaoEtapasOrdemProducao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormOrdemProducaoEtapasOrdemProducao->setProperty('class', 'form-horizontal builder-detail-form');

        $row10 = $this->detailFormOrdemProducaoEtapasOrdemProducao->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$ordem_producao_etapas_ordem_producao_descricao,$ordem_producao_etapas_ordem_producao_id]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->detailFormOrdemProducaoEtapasOrdemProducao->addFields([new TLabel("Situação etapa:", '#ff0000', '14px', null, '100%'),$ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id],[new TLabel("Ordem:", null, '14px', null, '100%'),$ordem_producao_etapas_ordem_producao_ordem]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->detailFormOrdemProducaoEtapasOrdemProducao->addFields([$button_adicionar_ordem_producao_etapas_ordem_producao]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->detailFormOrdemProducaoEtapasOrdemProducao->addFields([new THidden('ordem_producao_etapas_ordem_producao__row__id')]);
        $this->ordem_producao_etapas_ordem_producao_criteria = new TCriteria();

        $this->ordem_producao_etapas_ordem_producao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->ordem_producao_etapas_ordem_producao_list->disableHtmlConversion();;
        $this->ordem_producao_etapas_ordem_producao_list->generateHiddenFields();
        $this->ordem_producao_etapas_ordem_producao_list->setId('ordem_producao_etapas_ordem_producao_list');

        $this->ordem_producao_etapas_ordem_producao_list->style = 'width:100%';
        $this->ordem_producao_etapas_ordem_producao_list->class .= ' table-bordered';

        $column_ordem_producao_etapas_ordem_producao_ordem = new TDataGridColumn('ordem', "Ordem", 'left');
        $column_ordem_producao_etapas_ordem_producao_descricao = new TDataGridColumn('descricao', "Descrição", 'left');
        $column_ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_descricao = new TDataGridColumn('ordem_producao_etapas_situacao->descricao', "Situação", 'left');

        $column_ordem_producao_etapas_ordem_producao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_ordem_producao_etapas_ordem_producao__row__data->setVisibility(false);

        $action_onEditDetailOrdemProducaoEtapas = new TDataGridAction(array('OrdemProducaoForm', 'onEditDetailOrdemProducaoEtapas'));
        $action_onEditDetailOrdemProducaoEtapas->setUseButton(false);
        $action_onEditDetailOrdemProducaoEtapas->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailOrdemProducaoEtapas->setLabel("Editar");
        $action_onEditDetailOrdemProducaoEtapas->setImage('far:edit #478fca');
        $action_onEditDetailOrdemProducaoEtapas->setFields(['__row__id', '__row__data']);

        $this->ordem_producao_etapas_ordem_producao_list->addAction($action_onEditDetailOrdemProducaoEtapas);
        $action_onDeleteDetailOrdemProducaoEtapas = new TDataGridAction(array('OrdemProducaoForm', 'onDeleteDetailOrdemProducaoEtapas'));
        $action_onDeleteDetailOrdemProducaoEtapas->setUseButton(false);
        $action_onDeleteDetailOrdemProducaoEtapas->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailOrdemProducaoEtapas->setLabel("Excluir");
        $action_onDeleteDetailOrdemProducaoEtapas->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailOrdemProducaoEtapas->setFields(['__row__id', '__row__data']);

        $this->ordem_producao_etapas_ordem_producao_list->addAction($action_onDeleteDetailOrdemProducaoEtapas);

        $this->ordem_producao_etapas_ordem_producao_list->addColumn($column_ordem_producao_etapas_ordem_producao_ordem);
        $this->ordem_producao_etapas_ordem_producao_list->addColumn($column_ordem_producao_etapas_ordem_producao_descricao);
        $this->ordem_producao_etapas_ordem_producao_list->addColumn($column_ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_descricao);

        $this->ordem_producao_etapas_ordem_producao_list->addColumn($column_ordem_producao_etapas_ordem_producao__row__data);

        $this->ordem_producao_etapas_ordem_producao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->ordem_producao_etapas_ordem_producao_list);
        $this->detailFormOrdemProducaoEtapasOrdemProducao->addContent([$tableResponsiveDiv]);
        $row14 = $tab_63d67bbaf26bc->addFields([$this->detailFormOrdemProducaoEtapasOrdemProducao]);
        $row14->layout = [' col-sm-12'];

        $row15 = $this->form->addFields([$tab_63d67bbaf26bc]);
        $row15->layout = [' col-sm-12'];

        $row16 = $this->form->addFields([new TLabel("Observações:", null, '14px', null, '100%'),$observacoes]);
        $row16->layout = [' col-sm-12'];

        $bcontainer_63d66a8ff26b1 = new BContainer('bcontainer_63d66a8ff26b1');
        $this->bcontainer_63d66a8ff26b1 = $bcontainer_63d66a8ff26b1;

        $bcontainer_63d66a8ff26b1->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_63d66a8ff26b1->setBorderColor('#c0c0c0');

        $row17 = $bcontainer_63d66a8ff26b1->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row17->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row18 = $this->form->addFields([$bcontainer_63d66a8ff26b1]);
        $row18->layout = [' col-sm-12'];

        $row19 = $this->form->addFields([$system_unit_id]);
        $row19->layout = ['col-sm-3'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacaoordemproducao = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacaoOrdemProducao']), 'fas:bars #000000');
        $this->btn_onvisualizacaoordemproducao = $btn_onvisualizacaoordemproducao;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['OrdemProducaoList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Ordens de Produção","Cadastro de ordem de produção"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitQuantidadeMateriaPrima($param = null) 
    {
        try 
        {
            $quant_mp = (double) str_replace(',', '.', str_replace('.', '', $param['ordem_producao_itens_ordem_producao_quantidade']));
            $quant_acabado = (double) str_replace(',', '.', str_replace('.', '', $param['quantidade']));

            $object = new stdClass();
            $object->ordem_producao_itens_ordem_producao_quantidade_total =  $quant_mp * $quant_acabado;
            TForm::sendData(self::$formName, $object); 

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitProdutoFabricado($param = null) 
    {
        try 
        {
            if (isset($param['produto_id']) && $param['produto_id'])
            {
                TTransaction::open(self::$database);

                $object = new stdClass();

                //trazer o deposito da filial..
                $produtofilial = ProdutoFilial::where('produto_id', '=', $param['produto_id'])
                                              ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                              ->first();

                if($produtofilial)
                {                        
                    $object->quantidade = 1;
                    $object->estoque_deposito_id = $produtofilial->estoque_deposito_padrao_id;
                }
                // else
                // {
                //     new TMessage('error', 'Este produto não tem vinculo configurado para esta filial');
                //     $object->produto_nome = '';
                //     $object->venda_item_venda_produto_id = '';
                // }

                TTransaction::close();       

                //carregando os lotes se houver..
                // $criteria = TCriteria::create(['produto_id' => $param['venda_item_venda_produto_id']]);
                // TDBCombo::reloadFromModel(self::$formName, 'venda_item_venda_produto_lote_id', 'kraftsoft', 'ProdutoLote', 'id', '{numero}', 'numero asc', $criteria, TRUE);                      

                TForm::sendData(self::$formName, $object); 
            }

            if (isset($param['produto_id']) && $param['produto_id'])
            { 
                $criteria = TCriteria::create(['produto_id' => $param['produto_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'produto_ficha_tecnica_id', 'kraftsoft', 'ProdutoFichaTecnica', 'id', '{descricao}', 'descricao asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'produto_ficha_tecnica_id'); 
            }  

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitProdutoMateriaPrima($param = null) 
    {
        try 
        {
            if (isset($param['ordem_producao_itens_ordem_producao_produto_id']) && $param['ordem_producao_itens_ordem_producao_produto_id'])
            {

                $entrar = TSession::getValue('op_edit_matprima');

                if ($entrar==0)
                {
                    TTransaction::open(self::$database);

                    $object = new stdClass();

                    //trazer o deposito da filial..
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $param['ordem_producao_itens_ordem_producao_produto_id'])
                                                  ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                  ->first();

                    if($produtofilial)
                    {                        
                        $object->ordem_producao_itens_ordem_producao_quantidade = 1;
                        $object->ordem_producao_itens_ordem_producao_estoque_deposito_id = $produtofilial->estoque_deposito_padrao_id;
                    }
                    // else
                    // {
                    //     new TMessage('error', 'Este produto não tem vinculo configurado para esta filial');
                    //     $object->produto_nome = '';
                    //     $object->venda_item_venda_produto_id = '';
                    // }

                    TTransaction::close();       

                    //carregando os lotes se houver..
                    // $criteria = TCriteria::create(['produto_id' => $param['venda_item_venda_produto_id']]);
                    // TDBCombo::reloadFromModel(self::$formName, 'venda_item_venda_produto_lote_id', 'kraftsoft', 'ProdutoLote', 'id', '{numero}', 'numero asc', $criteria, TRUE);                      

                    TForm::sendData(self::$formName, $object); 
                }
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCarregarFichaTecnica($param = null) 
    {
        try 
        {

            (new TRequiredValidator)->validate('Produto fabricado', $param['produto_id'] );
            (new TRequiredValidator)->validate('Ficha técnica', $param['produto_ficha_tecnica_id'] );
            (new TRequiredValidator)->validate('Quantidade', $param['quantidade']);

            TTransaction::open(self::$database);

            //carregando as materias primas...
            $lista_itens_ficha_tecnica = ProdutoFichaTecnicaItens::where('produto_ficha_tecnica_id', '=', $param['produto_ficha_tecnica_id'])->load();

            if ($lista_itens_ficha_tecnica)
            {

                //TFieldList::clearRows('FieldListParcelas');

                foreach ($lista_itens_ficha_tecnica as $item_ficha_tecnica)
                {
                    $object = new stdClass();
                    $object->ordem_producao_itens_ordem_producao_id = '';
                    $object->ordem_producao_itens_ordem_producao_produto_id = $item_ficha_tecnica->produto_id;
                    $object->ordem_producao_itens_ordem_producao_quantidade = $item_ficha_tecnica->quantidade;
                    $object->ordem_producao_itens_ordem_producao_quantidade_total = $item_ficha_tecnica->quantidade * $param['quantidade'];
                    $object->ordem_producao_itens_ordem_producao_estoque_deposito_id = '';

                    //trazer o deposito da filial..
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $item_ficha_tecnica->produto_id)
                                                  ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                  ->first();

                    if($produtofilial)
                    {                        
                        $object->ordem_producao_itens_ordem_producao_estoque_deposito_id = $produtofilial->estoque_deposito_padrao_id;
                    }                    

                    $opform = new OrdemProducaoForm([]);
                    $opform->setIsWrapped(true);

                    $opform->onAddDetailOrdemProducaoItensOrdemProducao([   'customFormData' => $object,
                                                  // simulando os dados enviados de forma bruta do formulário detalhe
                                                  // ou seja, valores formatados
                                                  'ordem_producao_itens_ordem_producao_id' => $object->ordem_producao_itens_ordem_producao_id = '',
                                                  'ordem_producao_itens_ordem_producao_produto_id' => $object->ordem_producao_itens_ordem_producao_produto_id,
                                                  'ordem_producao_itens_ordem_producao_quantidade' => $object->ordem_producao_itens_ordem_producao_quantidade,
                                                  'ordem_producao_itens_ordem_producao_estoque_deposito_id' => $object->ordem_producao_itens_ordem_producao_estoque_deposito_id
                                                ]);

                    $object->ordem_producao_itens_ordem_producao_id = '';
                    $object->ordem_producao_itens_ordem_producao_produto_id = '';
                    $object->ordem_producao_itens_ordem_producao_quantidade = '';   
                    $object->ordem_producao_itens_ordem_producao_quantidade_total = '';                       
                    $object->ordem_producao_itens_ordem_producao_estoque_deposito_id = '';

                    TForm::sendData(self::$formName, $object);   
                }

            }

            //adicionando as etapas....
            $lista_etapas_ficha_tecnica = ProdutoFichaTecnicaEtapasProducao::where('produto_ficha_tecnica_id', '=', $param['produto_ficha_tecnica_id'])->load();

            if ($lista_etapas_ficha_tecnica)
            {

                foreach ($lista_etapas_ficha_tecnica as $etapa_ficha_tecnica)
                {
                    $object = new stdClass();
                    $object->ordem_producao_etapas_ordem_producao_id = '';
                    $object->ordem_producao_etapas_ordem_producao_descricao = $etapa_ficha_tecnica->descricao;
                    $object->ordem_producao_etapas_ordem_producao_ordem = $etapa_ficha_tecnica->ordem;
                    $object->ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id = OrdemProducaoEtapasSituacao::Pendente;

                    $opform = new OrdemProducaoForm([]);
                    $opform->setIsWrapped(true);

                    $opform->onAddDetailOrdemProducaoEtapasOrdemProducao([   'customFormData' => $object,
                                                  // simulando os dados enviados de forma bruta do formulário detalhe
                                                  // ou seja, valores formatados
                                                  'ordem_producao_etapas_ordem_producao_id' => $object->ordem_producao_etapas_ordem_producao_id,
                                                  'ordem_producao_etapas_ordem_producao_descricao' => $object->ordem_producao_etapas_ordem_producao_descricao,
                                                  'ordem_producao_etapas_ordem_producao_ordem' => $object->ordem_producao_etapas_ordem_producao_ordem
                                                ]);

                    $object->ordem_producao_etapas_ordem_producao_id = '';
                    $object->ordem_producao_etapas_ordem_producao_descricao = '';
                    $object->ordem_producao_etapas_ordem_producao_ordem = '';   

                    TForm::sendData(self::$formName, $object);   
                }

            }

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailOrdemProducaoItensOrdemProducao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if(!empty($param['customFormData']))
            {
                $data = $param['customFormData'];
            }                   

            TSession::setValue('op_edit_matprima', false);

            $__row__id = !empty($data->ordem_producao_itens_ordem_producao__row__id) ? $data->ordem_producao_itens_ordem_producao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new OrdemProducaoItens();
            $grid_data->__row__id = $__row__id;
            $grid_data->produto_id = $data->ordem_producao_itens_ordem_producao_produto_id;
            $grid_data->id = $data->ordem_producao_itens_ordem_producao_id;
            $grid_data->quantidade = $data->ordem_producao_itens_ordem_producao_quantidade;
            $grid_data->quantidade_total = $data->ordem_producao_itens_ordem_producao_quantidade_total;
            $grid_data->estoque_deposito_id = $data->ordem_producao_itens_ordem_producao_estoque_deposito_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['produto_id'] =  $param['ordem_producao_itens_ordem_producao_produto_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['ordem_producao_itens_ordem_producao_id'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['ordem_producao_itens_ordem_producao_quantidade'] ?? null;
            $__row__data['__display__']['quantidade_total'] =  $param['ordem_producao_itens_ordem_producao_quantidade_total'] ?? null;
            $__row__data['__display__']['estoque_deposito_id'] =  $param['ordem_producao_itens_ordem_producao_estoque_deposito_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->ordem_producao_itens_ordem_producao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('ordem_producao_itens_ordem_producao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->ordem_producao_itens_ordem_producao_produto_id = '';
            $data->ordem_producao_itens_ordem_producao_id = '';
            $data->ordem_producao_itens_ordem_producao_quantidade = '';
            $data->ordem_producao_itens_ordem_producao_quantidade_total = '';
            $data->ordem_producao_itens_ordem_producao_estoque_deposito_id = '';
            $data->ordem_producao_itens_ordem_producao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63d686979a224');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailOrdemProducaoEtapasOrdemProducao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if(!empty($param['customFormData']))
            {
                $data = $param['customFormData'];
            }                  

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Descrição", 'name'=>"ordem_producao_etapas_ordem_producao_descricao", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Situacao Etapa", 'name'=>"ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->ordem_producao_etapas_ordem_producao__row__id) ? $data->ordem_producao_etapas_ordem_producao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new OrdemProducaoEtapas();
            $grid_data->__row__id = $__row__id;
            $grid_data->descricao = $data->ordem_producao_etapas_ordem_producao_descricao;
            $grid_data->id = $data->ordem_producao_etapas_ordem_producao_id;
            $grid_data->ordem_producao_etapas_situacao_id = $data->ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id;
            $grid_data->ordem = $data->ordem_producao_etapas_ordem_producao_ordem;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['descricao'] =  $param['ordem_producao_etapas_ordem_producao_descricao'] ?? null;
            $__row__data['__display__']['id'] =  $param['ordem_producao_etapas_ordem_producao_id'] ?? null;
            $__row__data['__display__']['ordem_producao_etapas_situacao_id'] =  $param['ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id'] ?? null;
            $__row__data['__display__']['ordem'] =  $param['ordem_producao_etapas_ordem_producao_ordem'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->ordem_producao_etapas_ordem_producao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('ordem_producao_etapas_ordem_producao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->ordem_producao_etapas_ordem_producao_descricao = '';
            $data->ordem_producao_etapas_ordem_producao_id = '';
            $data->ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id = '';
            $data->ordem_producao_etapas_ordem_producao_ordem = '';
            $data->ordem_producao_etapas_ordem_producao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63d688809a22c');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailOrdemProducaoItens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            TSession::setValue('op_edit_matprima', true);

            $data = new stdClass;
            $data->ordem_producao_itens_ordem_producao_produto_id = $__row__data->__display__->produto_id ?? null;
            $data->ordem_producao_itens_ordem_producao_id = $__row__data->__display__->id ?? null;
            $data->ordem_producao_itens_ordem_producao_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->ordem_producao_itens_ordem_producao_quantidade_total = $__row__data->__display__->quantidade_total ?? null;
            $data->ordem_producao_itens_ordem_producao_estoque_deposito_id = $__row__data->__display__->estoque_deposito_id ?? null;
            $data->ordem_producao_itens_ordem_producao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63d686979a224');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailOrdemProducaoItens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->ordem_producao_itens_ordem_producao_produto_id = '';
            $data->ordem_producao_itens_ordem_producao_id = '';
            $data->ordem_producao_itens_ordem_producao_quantidade = '';
            $data->ordem_producao_itens_ordem_producao_quantidade_total = '';
            $data->ordem_producao_itens_ordem_producao_estoque_deposito_id = '';
            $data->ordem_producao_itens_ordem_producao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('ordem_producao_itens_ordem_producao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailOrdemProducaoEtapas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->ordem_producao_etapas_ordem_producao_descricao = $__row__data->__display__->descricao ?? null;
            $data->ordem_producao_etapas_ordem_producao_id = $__row__data->__display__->id ?? null;
            $data->ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id = $__row__data->__display__->ordem_producao_etapas_situacao_id ?? null;
            $data->ordem_producao_etapas_ordem_producao_ordem = $__row__data->__display__->ordem ?? null;
            $data->ordem_producao_etapas_ordem_producao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63d688809a22c');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailOrdemProducaoEtapas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->ordem_producao_etapas_ordem_producao_descricao = '';
            $data->ordem_producao_etapas_ordem_producao_id = '';
            $data->ordem_producao_etapas_ordem_producao_ordem_producao_etapas_situacao_id = '';
            $data->ordem_producao_etapas_ordem_producao_ordem = '';
            $data->ordem_producao_etapas_ordem_producao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('ordem_producao_etapas_ordem_producao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new OrdemProducao(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $ordem_producao_etapas_ordem_producao_items = $this->storeMasterDetailItems('OrdemProducaoEtapas', 'ordem_producao_id', 'ordem_producao_etapas_ordem_producao', $object, $param['ordem_producao_etapas_ordem_producao_list___row__data'] ?? [], $this->form, $this->ordem_producao_etapas_ordem_producao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->ordem_producao_etapas_ordem_producao_criteria); 

            $ordem_producao_itens_ordem_producao_items = $this->storeMasterDetailItems('OrdemProducaoItens', 'ordem_producao_id', 'ordem_producao_itens_ordem_producao', $object, $param['ordem_producao_itens_ordem_producao_list___row__data'] ?? [], $this->form, $this->ordem_producao_itens_ordem_producao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->ordem_producao_itens_ordem_producao_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('OrdemProducaoList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacaoOrdemProducao($param = null) 
    {
        try 
        {
            //code here
             $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve a ordem de produção para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('OrdemProducaoFormView2', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new OrdemProducao($key); // instantiates the Active Record 

                TSession::setValue('op_edit_matprima', false);

                $ordem_producao_etapas_ordem_producao_items = $this->loadMasterDetailItems('OrdemProducaoEtapas', 'ordem_producao_id', 'ordem_producao_etapas_ordem_producao', $object, $this->form, $this->ordem_producao_etapas_ordem_producao_list, $this->ordem_producao_etapas_ordem_producao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $ordem_producao_itens_ordem_producao_items = $this->loadMasterDetailItems('OrdemProducaoItens', 'ordem_producao_id', 'ordem_producao_itens_ordem_producao', $object, $this->form, $this->ordem_producao_itens_ordem_producao_list, $this->ordem_producao_itens_ordem_producao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        TSession::setValue('op_edit_matprima', false);

        $object = new stdClass();
        $object->ordem_producao_situacao_id = VendaSituacao::EmAndamento;
        $object->system_unit_id = TSession::getValue('userunitid');

        TForm::sendData(self::$formName, $object);

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->produto_id))
            {
                $value = $object->produto_id;

                $obj->produto_id = $value;
            }
            if(isset($object->produto_ficha_tecnica_id))
            {
                $value = $object->produto_ficha_tecnica_id;

                $obj->produto_ficha_tecnica_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->produto_id))
            {
                $value = $object->produto_id;

                $obj->produto_id = $value;
            }
            if(isset($object->produto_ficha_tecnica_id))
            {
                $value = $object->produto_ficha_tecnica_id;

                $obj->produto_ficha_tecnica_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

