<?php

class OrdemProducaoFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemProducao';
    private static $primaryKey = 'id';
    private static $formName = 'formView_OrdemProducao';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $ordem_producao = new OrdemProducao($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Ordem de Produção");


        $btnOrdemProducaoFormOnEditAction = new TAction(['OrdemProducaoForm', 'onEdit'],['key'=>$ordem_producao->id]);
        $btnOrdemProducaoFormOnEditLabel = new TLabel("Editar");

        $btnOrdemProducaoFormOnEdit = $this->form->addHeaderAction($btnOrdemProducaoFormOnEditLabel, $btnOrdemProducaoFormOnEditAction, 'fas:edit #03A9F4'); 
        $btnOrdemProducaoFormOnEditLabel->setFontSize('12px'); 
        $btnOrdemProducaoFormOnEditLabel->setFontColor('#333'); 

        $btn_onpendenteAction = new TAction([$this, 'onPendente'],['key'=>$ordem_producao->id]);
        $btn_onpendenteLabel = new TLabel("Pendente");

        $btn_onpendente = $this->form->addHeaderAction($btn_onpendenteLabel, $btn_onpendenteAction, 'fas:clock #FFC107'); 
        $btn_onpendenteLabel->setFontSize('12px'); 
        $btn_onpendenteLabel->setFontColor('#333'); 

        $btn_onemandamentoAction = new TAction([$this, 'onEmAndamento'],['key'=>$ordem_producao->id]);
        $btn_onemandamentoLabel = new TLabel("Em Andamento");

        $btn_onemandamento = $this->form->addHeaderAction($btn_onemandamentoLabel, $btn_onemandamentoAction, 'fas:bacon #03A9F4'); 
        $btn_onemandamentoLabel->setFontSize('12px'); 
        $btn_onemandamentoLabel->setFontColor('#333'); 

        $btn_onfinalizadaAction = new TAction([$this, 'onFinalizada'],['key'=>$ordem_producao->id]);
        $btn_onfinalizadaLabel = new TLabel("Finalizada");

        $btn_onfinalizada = $this->form->addHeaderAction($btn_onfinalizadaLabel, $btn_onfinalizadaAction, 'fas:flag-checkered #009688'); 
        $btn_onfinalizadaLabel->setFontSize('12px'); 
        $btn_onfinalizadaLabel->setFontColor('#333'); 

        $btnOrdemProducaoDocumentOnGenerateAction = new TAction(['OrdemProducaoDocument', 'onGenerate'],['key'=>$ordem_producao->id]);
        $btnOrdemProducaoDocumentOnGenerateLabel = new TLabel("Imprimir");

        $btnOrdemProducaoDocumentOnGenerate = $this->form->addHeaderAction($btnOrdemProducaoDocumentOnGenerateLabel, $btnOrdemProducaoDocumentOnGenerateAction, 'fas:print #FF5722'); 
        $btnOrdemProducaoDocumentOnGenerateLabel->setFontSize('12px'); 
        $btnOrdemProducaoDocumentOnGenerateLabel->setFontColor('#333'); 

        $btn_oncancelarAction = new TAction([$this, 'onCancelar'],['key'=>$ordem_producao->id]);
        $btn_oncancelarLabel = new TLabel("Cancelar");

        $btn_oncancelar = $this->form->addHeaderAction($btn_oncancelarLabel, $btn_oncancelarAction, 'fas:window-close #F44336'); 
        $btn_oncancelarLabel->setFontSize('12px'); 
        $btn_oncancelarLabel->setFontColor('#333'); 

        $btnOrdemProducaoListOnShowAction = new TAction(['OrdemProducaoList', 'onShow'],['key'=>$ordem_producao->id]);
        $btnOrdemProducaoListOnShowLabel = new TLabel("Voltar");

        $btnOrdemProducaoListOnShow = $this->form->addHeaderAction($btnOrdemProducaoListOnShowLabel, $btnOrdemProducaoListOnShowAction, 'fas:arrow-left #000000'); 
        $btnOrdemProducaoListOnShowLabel->setFontSize('12px'); 
        $btnOrdemProducaoListOnShowLabel->setFontColor('#333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Ordens de Produção","Visualizar Ordem de Produção"]));
        }
        $container->add($this->form);

        if($ordem_producao->ordem_producao_situacao_id=OrdemProducaoSituacao::Finalizada
        or $ordem_producao->ordem_producao_situacao_id=OrdemProducaoSituacao::Cancelada)
        {
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_pendente").style.display = "none";');
            TScript::create('document.getElementById("tbutton_em_andamento").style.display = "none";');            
        } 

        TTransaction::close();
        parent::add($container);

    }

    public function onPendente($param = null) 
    {
        try 
        {
            new TQuestion("Confirma ordem de produção pendente?", new TAction([__CLASS__, 'onPendenteYes'], $param), new TAction([__CLASS__, 'onPendenteNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onEmAndamento($param = null) 
    {
        try 
        {
            new TQuestion("Confirma orem de produção em andamento?", new TAction([__CLASS__, 'onEmAndamentoYes'], $param), new TAction([__CLASS__, 'onEmAndamentoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onFinalizada($param = null) 
    {
        try 
        {
            new TQuestion("Deseja finalizar esta ordem de produção?", new TAction([__CLASS__, 'onFinalizadaYes'], $param), new TAction([__CLASS__, 'onFinalizadaNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onCancelar($param = null) 
    {
        try 
        {
             new TQuestion("Deseja cancelar esta ordem de produção?", new TAction([__CLASS__, 'onCancelarYes'], $param), new TAction([__CLASS__, 'onCancelarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public  function onPendenteYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::Pendente;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::Pendente,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Pendente');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onPendenteNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onEmAndamentoYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::EmAndamento;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::EmAndamento,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Em Andamento');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onEmAndamentoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onFinalizadaYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                //movimentando o estoque...
                OrdemProducao::LancaEstoqueOrdemProducao($op);

                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::Finalizada;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::Finalizada,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Finalizada');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onFinalizadaNo($param = null) 
    {
        try 
        {

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onCancelarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::Cancelada;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::Cancelada,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Cancelada');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onCancelarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

