<?php

class OrdemProducaoFormView2 extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'OrdemProducao';
    private static $primaryKey = 'id';
    private static $formName = 'formView_OrdemProducao';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $ordem_producao = new OrdemProducao($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Ordem de Produção");

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'OrdemProducaoSituacao', 'id', '{descricao}','id asc' );
        $label3 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($ordem_producao->id, '', '15px', '');
        $label15 = new TLabel("Data Produção:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay(TDate::convertToMask($ordem_producao->data_producao, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label16 = new TLabel("Produto:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($ordem_producao->produto->nome, '', '15px', '');
        $label17 = new TLabel("Ficha tecnica:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($ordem_producao->produto_ficha_tecnica->descricao, '', '15px', '');
        $label18 = new TLabel("Quantidade:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(number_format((double)$ordem_producao->quantidade, '2', ',', '.'), '', '15px', '');
        $label24 = new TLabel("Observações:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($ordem_producao->observacoes, '', '15px', '');
        $label20 = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay(TDateTime::convertToMask($ordem_producao->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label21 = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay($ordem_producao->criado_por, '', '15px', '');
        $label22 = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay(TDateTime::convertToMask($ordem_producao->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label23 = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($ordem_producao->alterado_por, '', '15px', '');

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($ordem_producao->ordem_producao_situacao_id);


        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$label3,$text1],[$label15,$text13]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([$label16,$text4],[$label17,$text5]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([$label18,$text12],[]);
        $row4->layout = [' col-sm-6','col-sm-6'];

        $row5 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);

        $tab_63e6a386390bd = new BootstrapFormBuilder('tab_63e6a386390bd');
        $this->tab_63e6a386390bd = $tab_63e6a386390bd;
        $tab_63e6a386390bd->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63e6a386390bd->appendPage("Composição");

        $tab_63e6a386390bd->addFields([new THidden('current_tab_tab_63e6a386390bd')]);
        $tab_63e6a386390bd->setTabFunction("$('[name=current_tab_tab_63e6a386390bd]').val($(this).attr('data-current_page'));");

        $this->ordem_producao_itens_ordem_producao_id_list = new TQuickGrid;
        $this->ordem_producao_itens_ordem_producao_id_list->disableHtmlConversion();
        $this->ordem_producao_itens_ordem_producao_id_list->style = 'width:100%';
        $this->ordem_producao_itens_ordem_producao_id_list->disableDefaultClick();

        $column_produto_nome = $this->ordem_producao_itens_ordem_producao_id_list->addQuickColumn("Produto", 'produto->nome', 'left');
        $column_quantidade_transformed = $this->ordem_producao_itens_ordem_producao_id_list->addQuickColumn("Quantidade", 'quantidade', 'left');
        $column_quantidade_total_transformed = $this->ordem_producao_itens_ordem_producao_id_list->addQuickColumn("Quantidade Total", 'quantidade_total', 'left');

        $column_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_quantidade_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $this->ordem_producao_itens_ordem_producao_id_list->createModel();

        $criteria_ordem_producao_itens_ordem_producao_id = new TCriteria();
        $criteria_ordem_producao_itens_ordem_producao_id->add(new TFilter('ordem_producao_id', '=', $ordem_producao->id));

        $criteria_ordem_producao_itens_ordem_producao_id->setProperty('order', 'id desc');

        $ordem_producao_itens_ordem_producao_id_items = OrdemProducaoItens::getObjects($criteria_ordem_producao_itens_ordem_producao_id);

        $this->ordem_producao_itens_ordem_producao_id_list->addItems($ordem_producao_itens_ordem_producao_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->ordem_producao_itens_ordem_producao_id_list));

        $tab_63e6a386390bd->addContent([$panel]);

        $tab_63e6a386390bd->appendPage("Etapas");

        $this->ordem_producao_etapas_ordem_producao_id_list = new TQuickGrid;
        $this->ordem_producao_etapas_ordem_producao_id_list->disableHtmlConversion();
        $this->ordem_producao_etapas_ordem_producao_id_list->style = 'width:100%';
        $this->ordem_producao_etapas_ordem_producao_id_list->disableDefaultClick();

        $column_ordem = $this->ordem_producao_etapas_ordem_producao_id_list->addQuickColumn("Ordem", 'ordem', 'left');
        $column_descricao = $this->ordem_producao_etapas_ordem_producao_id_list->addQuickColumn("Descrição", 'descricao', 'left');
        $column_ordem_producao_etapas_situacao_descricao = $this->ordem_producao_etapas_ordem_producao_id_list->addQuickColumn("Situação", 'ordem_producao_etapas_situacao->descricao', 'left');

        $this->ordem_producao_etapas_ordem_producao_id_list->createModel();

        $criteria_ordem_producao_etapas_ordem_producao_id = new TCriteria();
        $criteria_ordem_producao_etapas_ordem_producao_id->add(new TFilter('ordem_producao_id', '=', $ordem_producao->id));

        $criteria_ordem_producao_etapas_ordem_producao_id->setProperty('order', 'id desc');

        $ordem_producao_etapas_ordem_producao_id_items = OrdemProducaoEtapas::getObjects($criteria_ordem_producao_etapas_ordem_producao_id);

        $this->ordem_producao_etapas_ordem_producao_id_list->addItems($ordem_producao_etapas_ordem_producao_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->ordem_producao_etapas_ordem_producao_id_list));

        $tab_63e6a386390bd->addContent([$panel]);
        $row6 = $this->form->addFields([$tab_63e6a386390bd]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);
        $row8 = $this->form->addFields([$label24,$text14]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addContent([new TFormSeparator("Histórico de Atualizações", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([$label20,$text7],[$label21,$text10],[$label22,$text11],[$label23,$text9]);
        $row10->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        if(!empty($param['current_tab_tab_63e6a386390bd']))
        {
            $this->tab_63e6a386390bd->setCurrentPage($param['current_tab_tab_63e6a386390bd']);
        }

        $btnOrdemProducaoFormOnEditAction = new TAction(['OrdemProducaoForm', 'onEdit'],['key'=>$ordem_producao->id]);
        $btnOrdemProducaoFormOnEditLabel = new TLabel("Editar");

        $btnOrdemProducaoFormOnEdit = $this->form->addHeaderAction($btnOrdemProducaoFormOnEditLabel, $btnOrdemProducaoFormOnEditAction, 'fas:edit #03A9F4'); 
        $btnOrdemProducaoFormOnEditLabel->setFontSize('12px'); 
        $btnOrdemProducaoFormOnEditLabel->setFontColor('#333'); 

        $btn_onpendenteAction = new TAction([$this, 'onPendente'],['key'=>$ordem_producao->id]);
        $btn_onpendenteLabel = new TLabel("Pendente");

        $btn_onpendente = $this->form->addHeaderAction($btn_onpendenteLabel, $btn_onpendenteAction, 'fas:clock #FFC107'); 
        $btn_onpendenteLabel->setFontSize('12px'); 
        $btn_onpendenteLabel->setFontColor('#333'); 

        $btn_onemandamentoAction = new TAction([$this, 'onEmAndamento'],['key'=>$ordem_producao->id]);
        $btn_onemandamentoLabel = new TLabel("Em Andamento");

        $btn_onemandamento = $this->form->addHeaderAction($btn_onemandamentoLabel, $btn_onemandamentoAction, 'fas:bacon #03A9F4'); 
        $btn_onemandamentoLabel->setFontSize('12px'); 
        $btn_onemandamentoLabel->setFontColor('#333'); 

        $btn_onfinalizadaAction = new TAction([$this, 'onFinalizada'],['key'=>$ordem_producao->id]);
        $btn_onfinalizadaLabel = new TLabel("Finalizada");

        $btn_onfinalizada = $this->form->addHeaderAction($btn_onfinalizadaLabel, $btn_onfinalizadaAction, 'fas:flag-checkered #009688'); 
        $btn_onfinalizadaLabel->setFontSize('12px'); 
        $btn_onfinalizadaLabel->setFontColor('#333'); 

        $btnOrdemProducaoDocumentOnGenerateAction = new TAction(['OrdemProducaoDocument', 'onGenerate'],['key'=>$ordem_producao->id]);
        $btnOrdemProducaoDocumentOnGenerateLabel = new TLabel("Imprimir");

        $btnOrdemProducaoDocumentOnGenerate = $this->form->addHeaderAction($btnOrdemProducaoDocumentOnGenerateLabel, $btnOrdemProducaoDocumentOnGenerateAction, 'fas:print #FF5722'); 
        $btnOrdemProducaoDocumentOnGenerateLabel->setFontSize('12px'); 
        $btnOrdemProducaoDocumentOnGenerateLabel->setFontColor('#333'); 

        $btn_oncancelarAction = new TAction([$this, 'onCancelar'],['key'=>$ordem_producao->id]);
        $btn_oncancelarLabel = new TLabel("Cancelar");

        $btn_oncancelar = $this->form->addHeaderAction($btn_oncancelarLabel, $btn_oncancelarAction, 'fas:window-close #F44336'); 
        $btn_oncancelarLabel->setFontSize('12px'); 
        $btn_oncancelarLabel->setFontColor('#333'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        if($ordem_producao->ordem_producao_situacao_id==OrdemProducaoSituacao::Finalizada
        or $ordem_producao->ordem_producao_situacao_id==OrdemProducaoSituacao::Cancelada)
        {
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_pendente").style.display = "none";');
            TScript::create('document.getElementById("tbutton_em_andamento").style.display = "none";');            
            TScript::create('document.getElementById("tbutton_finalizada").style.display = "none";');            
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');            
        }

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=OrdemProducaoFormView2]');
        $style->width = '100% !important';   
        $style->show(true);

    }

    public function onPendente($param = null) 
    {
        try 
        {
            new TQuestion("Confirma ordem de produção pendente?", new TAction([__CLASS__, 'onPendenteYes'], $param), new TAction([__CLASS__, 'onPendenteNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }

    }
    public function onEmAndamento($param = null) 
    {
        try 
        {
            new TQuestion("Confirma orem de produção em andamento?", new TAction([__CLASS__, 'onEmAndamentoYes'], $param), new TAction([__CLASS__, 'onEmAndamentoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onFinalizada($param = null) 
    {
        try 
        {
            new TQuestion("Deseja finalizar esta ordem de produção?", new TAction([__CLASS__, 'onFinalizadaYes'], $param), new TAction([__CLASS__, 'onFinalizadaNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onCancelar($param = null) 
    {
        try 
        {
            new TQuestion("Deseja cancelar esta ordem de produção?", new TAction([__CLASS__, 'onCancelarYes'], $param), new TAction([__CLASS__, 'onCancelarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public  function onPendenteYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::Pendente;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::Pendente,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Pendente');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onPendenteNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onEmAndamentoYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::EmAndamento;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::EmAndamento,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Em Andamento');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onEmAndamentoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onFinalizadaYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                //movimentando o estoque...
                OrdemProducao::LancaEstoqueOrdemProducao($op);

                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::Finalizada;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::Finalizada,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Finalizada');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onFinalizadaNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onCancelarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $op = OrdemProducao::find($param['key']);     

            if($op) 
            {
                $op->ordem_producao_situacao_id=OrdemProducaoSituacao::Cancelada;
                $op->store();

                OrdemProducaoSituacaoHistorico::LancarHistorico(OrdemProducaoSituacao::Cancelada,
                                                                $op->id,
                                                                'Mudança de Situação de O.P.: Cancelada');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $op->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onCancelarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

