<?php

class ProdutoEmbalagemForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ProdutoEmbalagem';
    private static $primaryKey = 'id';
    private static $formName = 'form_ProdutoEmbalagemForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de embalagens");


        $id = new TEntry('id');
        $produto_tipo_embalagem_id = new TDBCombo('produto_tipo_embalagem_id', 'kraftsoft', 'ProdutoTipoEmbalagem', 'id', '{descricao}','descricao asc'  );
        $descricao = new TEntry('descricao');
        $dimensoes = new TEntry('dimensoes');
        $peso = new TNumeric('peso', '2', ',', '.' );
        $altura = new TNumeric('altura', '2', ',', '.' );
        $largura = new TNumeric('largura', '2', ',', '.' );
        $comprimento = new TNumeric('comprimento', '2', ',', '.' );
        $diametro = new TNumeric('diametro', '2', ',', '.' );
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $produto_tipo_embalagem_id->addValidation("Produto tipo embalagem id", new TRequiredValidator()); 
        $descricao->addValidation("Descrição", new TRequiredValidator()); 

        $produto_tipo_embalagem_id->enableSearch();
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $dimensoes->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $id->setSize(100);
        $peso->setSize('100%');
        $altura->setSize('100%');
        $largura->setSize('100%');
        $diametro->setSize('100%');
        $descricao->setSize('100%');
        $dimensoes->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $comprimento->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $produto_tipo_embalagem_id->setSize('100%');

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Tipo embalagem:", '#ff0000', '14px', null, '100%'),$produto_tipo_embalagem_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Dimensões:", '#ff0000', '14px', null, '100%'),$dimensoes],[new TLabel("Peso (Kg):", null, '14px', null, '100%'),$peso]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Altura:", null, '14px', null, '100%'),$altura],[new TLabel("Largura (cm):", null, '14px', null, '100%'),$largura]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Comprimento (cm):", null, '14px', null, '100%'),$comprimento],[new TLabel("Diâmetro:", null, '14px', null, '100%'),$diametro]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $bcontainer_63d9047b9de89 = new BContainer('bcontainer_63d9047b9de89');
        $this->bcontainer_63d9047b9de89 = $bcontainer_63d9047b9de89;

        $bcontainer_63d9047b9de89->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_63d9047b9de89->setBorderColor('#c0c0c0');

        $row6 = $bcontainer_63d9047b9de89->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row6->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row7 = $this->form->addFields([$bcontainer_63d9047b9de89]);
        $row7->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave']), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ProdutoEmbalagemHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Produto","Cadastro de embalagens"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ProdutoEmbalagem(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $object->dimensoes = ProdutoEmbalagem::RetornaDimensoes($object);

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ProdutoEmbalagemHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ProdutoEmbalagem($key); // instantiates the Active Record 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

