<?php

class ProdutoFichaTecnicaForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ProdutoFichaTecnica';
    private static $primaryKey = 'id';
    private static $formName = 'form_ProdutoFichaTecnicaForm';

    use BuilderMasterDetailTrait;
    use BuilderMasterDetailFieldListTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de ficha técnica de produto");

        $criteria_produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id = new TCriteria();

        $filterVar = TipoRecurso::Produto;
        $criteria_produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id->add(new TFilter('tipo_recurso_id', '=', $filterVar)); 

        $id = new TEntry('id');
        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc'  );
        $descricao = new TEntry('descricao');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $custo_total = new TNumeric('custo_total', '2', ',', '.' );
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id = new TDBCombo('produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc' , $criteria_produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id );
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_id = new THidden('produto_ficha_tecnica_itens_produto_ficha_tecnica_id');
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade = new TNumeric('produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade', '2', ',', '.' );
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo = new TNumeric('produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo', '2', ',', '.' );
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total = new TNumeric('produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total', '2', ',', '.' );
        $button_adicionar_produto_ficha_tecnica_itens_produto_ficha_tecnica = new TButton('button_adicionar_produto_ficha_tecnica_itens_produto_ficha_tecnica');
        $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_id = new THidden('produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_id[]');
        $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__id = new THidden('produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__id[]');
        $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__data = new THidden('produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__data[]');
        $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_descricao = new TEntry('produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_descricao[]');
        $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_ordem = new TEntry('produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_ordem[]');
        $this->fieldList_63c91a2f301bf = new TFieldList();
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $this->fieldList_63c91a2f301bf->addField(null, $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_id, []);
        $this->fieldList_63c91a2f301bf->addField(null, $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__id, ['uniqid' => true]);
        $this->fieldList_63c91a2f301bf->addField(null, $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__data, []);
        $this->fieldList_63c91a2f301bf->addField(new TLabel("Descrição", null, '14px', null), $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_descricao, ['width' => '80%']);
        $this->fieldList_63c91a2f301bf->addField(new TLabel("Ordem", null, '14px', null), $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_ordem, ['width' => '50%']);

        $this->fieldList_63c91a2f301bf->width = '100%';
        $this->fieldList_63c91a2f301bf->setFieldPrefix('produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica');
        $this->fieldList_63c91a2f301bf->name = 'fieldList_63c91a2f301bf';

        $this->criteria_fieldList_63c91a2f301bf = new TCriteria();
        $this->default_item_fieldList_63c91a2f301bf = new stdClass();

        $this->form->addField($produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_id);
        $this->form->addField($produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__id);
        $this->form->addField($produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica___row__data);
        $this->form->addField($produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_descricao);
        $this->form->addField($produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_ordem);

        $this->fieldList_63c91a2f301bf->setRemoveAction(null, 'fas:times #dd5a43', "Excluír");

        $produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id->setChangeAction(new TAction([$this,'onExitProduto']));

        $produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade->setExitAction(new TAction([$this,'onExitQuantidade']));

        $produto_id->addValidation("Produto id", new TRequiredValidator()); 
        $descricao->addValidation("Descrição", new TRequiredValidator()); 
        $system_unit_id->addValidation("Filial", new TRequiredValidator()); 

        $button_adicionar_produto_ficha_tecnica_itens_produto_ficha_tecnica->setAction(new TAction([$this, 'onAddDetailProdutoFichaTecnicaItensProdutoFichaTecnica'],['static' => 1]), "Adicionar");
        $button_adicionar_produto_ficha_tecnica_itens_produto_ficha_tecnica->addStyleClass('btn-default');
        $button_adicionar_produto_ficha_tecnica_itens_produto_ficha_tecnica->setImage('fas:plus #2ecc71');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $produto_id->enableSearch();
        $system_unit_id->enableSearch();
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id->enableSearch();

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $produto_id->setEditable(false);
        $criado_por->setEditable(false);
        $custo_total->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo->setEditable(false);
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total->setEditable(false);

        $id->setSize(100);
        $criado_em->setSize(150);
        $alterado_em->setSize(150);
        $descricao->setSize('100%');
        $produto_id->setSize('100%');
        $criado_por->setSize('100%');
        $custo_total->setSize('100%');
        $alterado_por->setSize('100%');
        $system_unit_id->setSize('100%');
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_id->setSize(200);
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id->setSize('100%');
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade->setSize('100%');
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo->setSize('100%');
        $produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total->setSize('100%');
        $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_ordem->setSize('100%');
        $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_descricao->setSize('100%');

        $button_adicionar_produto_ficha_tecnica_itens_produto_ficha_tecnica->id = '63c916e5301ae';

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$produto_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao],[new TLabel("Filial:", '#FF0000', '14px', null),$system_unit_id]);
        $row2->layout = ['col-sm-6',' col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Custo Total:", null, '14px', null, '100%'),$custo_total]);
        $row3->layout = ['col-sm-6'];

        $tab_63c916ba301a9 = new BootstrapFormBuilder('tab_63c916ba301a9');
        $this->tab_63c916ba301a9 = $tab_63c916ba301a9;
        $tab_63c916ba301a9->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63c916ba301a9->appendPage("Matérias primas");

        $tab_63c916ba301a9->addFields([new THidden('current_tab_tab_63c916ba301a9')]);
        $tab_63c916ba301a9->setTabFunction("$('[name=current_tab_tab_63c916ba301a9]').val($(this).attr('data-current_page'));");

        $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica = new BootstrapFormBuilder('detailFormProdutoFichaTecnicaItensProdutoFichaTecnica');
        $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica->setProperty('class', 'form-horizontal builder-detail-form');

        $row4 = $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica->addFields([new TLabel("Produto:", '#FF0000', '14px', null),$produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id,$produto_ficha_tecnica_itens_produto_ficha_tecnica_id],[new TLabel("Quantidade:", '#FF0000', '14px', null),$produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade]);
        $row4->layout = [' col-sm-6',' col-sm-6'];

        $row5 = $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica->addFields([new TLabel("Valor Custo:", null, '14px', null),$produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo],[new TLabel("Valor Total:", null, '14px', null),$produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total]);
        $row5->layout = [' col-sm-6',' col-sm-6'];

        $row6 = $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica->addFields([$button_adicionar_produto_ficha_tecnica_itens_produto_ficha_tecnica]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica->addFields([new THidden('produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id')]);
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_criteria = new TCriteria();

        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->disableHtmlConversion();;
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->generateHiddenFields();
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->setId('produto_ficha_tecnica_itens_produto_ficha_tecnica_list');

        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->style = 'width:100%';
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->class .= ' table-bordered';

        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_nome = new TDataGridColumn('produto->nome', "Produto", 'left');
        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade_transformed = new TDataGridColumn('quantidade', "Quantidade", 'left');
        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo_transformed = new TDataGridColumn('valor_custo', "Valor Custo", 'left');
        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total_transformed = new TDataGridColumn('valor_total', "Valor Total", 'left');

        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica__row__data->setVisibility(false);

        $action_onEditDetailProdutoFichaTecnicaItens = new TDataGridAction(array('ProdutoFichaTecnicaForm', 'onEditDetailProdutoFichaTecnicaItens'));
        $action_onEditDetailProdutoFichaTecnicaItens->setUseButton(false);
        $action_onEditDetailProdutoFichaTecnicaItens->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailProdutoFichaTecnicaItens->setLabel("Editar");
        $action_onEditDetailProdutoFichaTecnicaItens->setImage('far:edit #478fca');
        $action_onEditDetailProdutoFichaTecnicaItens->setFields(['__row__id', '__row__data']);

        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addAction($action_onEditDetailProdutoFichaTecnicaItens);
        $action_onDeleteDetailProdutoFichaTecnicaItens = new TDataGridAction(array('ProdutoFichaTecnicaForm', 'onDeleteDetailProdutoFichaTecnicaItens'));
        $action_onDeleteDetailProdutoFichaTecnicaItens->setUseButton(false);
        $action_onDeleteDetailProdutoFichaTecnicaItens->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailProdutoFichaTecnicaItens->setLabel("Excluir");
        $action_onDeleteDetailProdutoFichaTecnicaItens->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailProdutoFichaTecnicaItens->setFields(['__row__id', '__row__data']);

        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addAction($action_onDeleteDetailProdutoFichaTecnicaItens);

        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_nome);
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade_transformed);
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo_transformed);
        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total_transformed);

        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_itens_produto_ficha_tecnica__row__data);

        $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list);
        $this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica->addContent([$tableResponsiveDiv]);

        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row8 = $tab_63c916ba301a9->addFields([$this->detailFormProdutoFichaTecnicaItensProdutoFichaTecnica]);
        $row8->layout = [' col-sm-12'];

        $tab_63c916ba301a9->appendPage("Etapas de produção");
        $row9 = $tab_63c916ba301a9->addFields([$this->fieldList_63c91a2f301bf]);
        $row9->layout = [' col-sm-12'];

        $row10 = $this->form->addFields([$tab_63c916ba301a9]);
        $row10->layout = [' col-sm-12'];

        $bcontainer_63c808079baf5 = new BContainer('bcontainer_63c808079baf5');
        $this->bcontainer_63c808079baf5 = $bcontainer_63c808079baf5;

        $bcontainer_63c808079baf5->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_63c808079baf5->setBorderColor('#c0c0c0');

        $row11 = $bcontainer_63c808079baf5->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row11->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row12 = $this->form->addFields([$bcontainer_63c808079baf5]);
        $row12->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btnAtualizaCustoFichaTecnica = $this->form->addAction("Atualizar custo da ficha técnica", new TAction([$this, 'onAtualizarCustoFichaTecnica']), 'fas:calculator #FFFFFF');
        $this->btnAtualizaCustoFichaTecnica = $btnAtualizaCustoFichaTecnica;
        $btnAtualizaCustoFichaTecnica->addStyleClass('btn-success'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        //desabilitando o botao de calcular por não conseguir atualizar o grid em tela...
        TScript::create('document.getElementById("tbutton_btn_atualizar_custo_da_ficha_técnica").style.display = "none";');

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ProdutoFichaTecnicaForm]');
        $style->width = '80% !important';   
        $style->show(true);

    }

    public static function onExitQuantidade($param = null) 
    {
        try 
        {
            $qtd = (double) str_replace(',', '.', str_replace('.', '', $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade']));
            $vcusto = (double) str_replace(',', '.', str_replace('.', '', $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo']));

            $vtotal = $qtd * $vcusto;

            $object = new stdClass();
            $object->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total = number_format($vtotal, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitProduto($param = null) 
    {
        try 
        {
            if (isset($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id']) && $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id'])
            {
                TTransaction::open(self::$database);

                $object = new stdClass();

                $filialid = $param['system_unit_id'];

                //trazer o preço da filial..
                $produtofilial = ProdutoFilial::where('produto_id', '=', $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id'])
                                              ->where('system_unit_id', '=', $filialid)
                                              ->first();

                // $object->produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade = 1;
                $object->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo = '0,00';

                if($produtofilial)
                {                        
                    $object->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo = number_format($produtofilial->valor_custo, 2, ',', '.');
                    // $object->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total = number_format($produtofilial->valor_custo, 2, ',', '.');                    
                }

                TTransaction::close();       

                TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailProdutoFichaTecnicaItensProdutoFichaTecnica($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Produto id", 'name'=>"produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Quantidade", 'name'=>"produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id) ? $data->produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ProdutoFichaTecnicaItens();
            $grid_data->__row__id = $__row__id;
            $grid_data->produto_id = $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id;
            $grid_data->id = $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_id;
            $grid_data->quantidade = $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade;
            $grid_data->valor_custo = $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo;
            $grid_data->valor_total = $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['produto_id'] =  $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_id'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade'] ?? null;
            $__row__data['__display__']['valor_custo'] =  $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo'] ?? null;
            $__row__data['__display__']['valor_total'] =  $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('produto_ficha_tecnica_itens_produto_ficha_tecnica_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_id = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63c916e5301ae');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailProdutoFichaTecnicaItens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id = $__row__data->__display__->produto_id ?? null;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_id = $__row__data->__display__->id ?? null;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo = $__row__data->__display__->valor_custo ?? null;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total = $__row__data->__display__->valor_total ?? null;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63c916e5301ae');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailProdutoFichaTecnicaItens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_produto_id = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_id = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_quantidade = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_custo = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica_valor_total = '';
            $data->produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('produto_ficha_tecnica_itens_produto_ficha_tecnica_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ProdutoFichaTecnica(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $custototal = 0;

            if(!empty($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data']))
            {
                $rowId = $param['produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id'];
                foreach($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data'] as $rowDataCoded)
                {
                    $rowDataDecoded = unserialize(base64_decode($rowDataCoded));    

                    $custototal += $rowDataDecoded->valor_total;

                    $rowDataDecoded->__row__id;
                }
            }

            $object->custo_total = $custototal;

            //falta atualizar o custo do produto para esta filial..
            $produtoFilial = ProdutoFilial::where('produto_id', '=', $param['produto_id'])
                                            ->where('system_unit_id', '=', $param['system_unit_id'])->first();

            if($produtoFilial)
            {

               $produtoFilial->valor_custo = $custototal;
               $produtoFilial->store();

            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_items = $this->storeItems('ProdutoFichaTecnicaEtapasProducao', 'produto_ficha_tecnica_id', $object, $this->fieldList_63c91a2f301bf, function($masterObject, $detailObject){ 

                //code here

            }, $this->criteria_fieldList_63c91a2f301bf); 

            $produto_ficha_tecnica_itens_produto_ficha_tecnica_items = $this->storeMasterDetailItems('ProdutoFichaTecnicaItens', 'produto_ficha_tecnica_id', 'produto_ficha_tecnica_itens_produto_ficha_tecnica', $object, $param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data'] ?? [], $this->form, $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ProdutoFichaTecnicaHeaderList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();");
            TForm::sendData(self::$formName, (object)['id' => $object->id]);

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onAtualizarCustoFichaTecnica($param = null) 
    {
        try 
        {

            if(!empty($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data']))
            {
                TTransaction::open(self::$database);
                $custo_total = 0;
                $filialid = $param['system_unit_id'];

                $rowId = $param['produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id'];
                foreach($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data'] as $rowDataCoded)
                {
                    $rowDataDecoded = unserialize(base64_decode($rowDataCoded));    
                    $rowDataDecoded->produto_id;

                    //trazer o preço da filial..
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $rowDataDecoded->produto_id)
                                                  ->where('system_unit_id', '=', $filialid)
                                                  ->first();

                    if($produtofilial)
                    {                        
                        $rowDataDecoded->valor_custo = number_format($produtofilial->valor_custo, 2, ',', '.');
                    }

                    $rowDataDecoded->quantidade;
                    $rowDataDecoded->valor_total = $rowDataDecoded->quantidade * $rowDataDecoded->valor_custo;

                    $rowDataDecoded->__row__id;

                    TDataGrid::replaceRowById('produto_ficha_tecnica_itens_produto_ficha_tecnica_list', $rowDataDecoded->__row__id, $rowId);                    

                }

                TTransaction::close();

                // $object = new stdClass();

                // TForm::sendData(self::$formName, $object);        
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ProdutoFichaTecnica($key); // instantiates the Active Record 

                $this->fieldList_63c91a2f301bf_items = $this->loadItems('ProdutoFichaTecnicaEtapasProducao', 'produto_ficha_tecnica_id', $object, $this->fieldList_63c91a2f301bf, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }, $this->criteria_fieldList_63c91a2f301bf); 

                $produto_ficha_tecnica_itens_produto_ficha_tecnica_items = $this->loadMasterDetailItems('ProdutoFichaTecnicaItens', 'produto_ficha_tecnica_id', 'produto_ficha_tecnica_itens_produto_ficha_tecnica', $object, $this->form, $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_list, $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $this->fieldList_63c91a2f301bf->addHeader();
        $this->fieldList_63c91a2f301bf->addDetail($this->default_item_fieldList_63c91a2f301bf);

        $this->fieldList_63c91a2f301bf->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

       $obj = new Stdclass();
       $obj->produto_id = TSession::getValue('produtolist_id');
       $obj->system_unit_id = TSession::getValue('userunitid');
       TForm::sendData(self::$formName, $obj);

    }

    public function onShow($param = null)
    {
        $this->fieldList_63c91a2f301bf->addHeader();
        $this->fieldList_63c91a2f301bf->addDetail($this->default_item_fieldList_63c91a2f301bf);

        $this->fieldList_63c91a2f301bf->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

       $obj = new Stdclass();
       $obj->produto_id = TSession::getValue('produtolist_id');
       $obj->system_unit_id = TSession::getValue('userunitid');
       TForm::sendData(self::$formName, $obj);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

