<?php

class ProdutoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Produto';
    private static $primaryKey = 'id';
    private static $formName = 'form_ProdutoForm';

    use BuilderMasterDetailTrait;
    use Adianti\Base\AdiantiFileSaveTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de produto");

        $criteria_produto_grupo_id = new TCriteria();

        $filterVar = NULL;
        $criteria_produto_grupo_id->add(new TFilter('deletado_em', 'is', $filterVar)); 
        $filterVar = TipoRecurso::Produto;
        $criteria_produto_grupo_id->add(new TFilter('tipo_recurso_id', '=', $filterVar)); 

        $id = new TEntry('id');
        $tipo_recurso_id = new THidden('tipo_recurso_id');
        $referencia = new TEntry('referencia');
        $codigo_sku = new TEntry('codigo_sku');
        $nome = new TEntry('nome');
        $codigo_EAN = new TEntry('codigo_EAN');
        $produto_grupo_id = new TDBCombo('produto_grupo_id', 'kraftsoft', 'ProdutoGrupo', 'id', '{descricao}','descricao asc' , $criteria_produto_grupo_id );
        $produtogrupo_subgrupo_id = new TCombo('produtogrupo_subgrupo_id');
        $produto_fabricante_id = new TDBCombo('produto_fabricante_id', 'kraftsoft', 'ProdutoFabricante', 'id', '{nome}','nome asc'  );
        $unidade_medida_id = new TDBCombo('unidade_medida_id', 'kraftsoft', 'UnidadeMedida', 'id', '{nome} - ({sigla})','nome asc'  );
        $produto_tipo_id = new TDBCombo('produto_tipo_id', 'kraftsoft', 'ProdutoTipo', 'id', '{descricao}','descricao asc'  );
        $marca = new TEntry('marca');
        $nome_curto = new TEntry('nome_curto');
        $peso_liquido = new TNumeric('peso_liquido', '2', ',', '.' );
        $peso_bruto = new TNumeric('peso_bruto', '2', ',', '.' );
        $produto_embalagem_id = new TDBCombo('produto_embalagem_id', 'kraftsoft', 'ProdutoEmbalagem', 'id', '{descricao}','descricao asc'  );
        $largura = new TNumeric('largura', '2', ',', '.' );
        $altura = new TNumeric('altura', '2', ',', '.' );
        $comprimento = new TNumeric('comprimento', '2', ',', '.' );
        $diametro = new TNumeric('diametro', '2', ',', '.' );
        $dias_preparacao = new TNumeric('dias_preparacao', '0', ',', '.' );
        $unidade_caixa = new TEntry('unidade_caixa');
        $garantia = new TEntry('garantia');
        $obs = new TText('obs');
        $habilitado_id = new TRadioGroup('habilitado_id');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $ncm = new TEntry('ncm');
        $cest = new TEntry('cest');
        $notafiscal_item_orig_id = new TDBCombo('notafiscal_item_orig_id', 'kraftsoft', 'NotafiscalItemOrig', 'id', '{descricao}','codigo asc'  );
        $imagem = new TImageCropper('imagem');
        $especificacao = new THtmlEditor('especificacao');
        $link_site = new TEntry('link_site');
        $produto_filial_produto_system_unit_id = new TDBCombo('produto_filial_produto_system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $produto_filial_produto_id = new THidden('produto_filial_produto_id');
        $produto_filial_produto_margem = new TNumeric('produto_filial_produto_margem', '2', ',', '.' );
        $produto_filial_produto_valor_custo = new TNumeric('produto_filial_produto_valor_custo', '2', ',', '.' );
        $button_calc_preco_venda_produto_filial_produto = new TButton('button_calc_preco_venda_produto_filial_produto');
        $produto_filial_produto_preco_venda = new TNumeric('produto_filial_produto_preco_venda', '2', ',', '.' );
        $produto_filial_produto_estoque_minimo = new TNumeric('produto_filial_produto_estoque_minimo', '2', ',', '.' );
        $produto_filial_produto_estoque_maximo = new TNumeric('produto_filial_produto_estoque_maximo', '2', ',', '.' );
        $produto_filial_produto_codigo_balanca = new TEntry('produto_filial_produto_codigo_balanca');
        $produto_filial_produto_estoque_deposito_padrao_id = new TCombo('produto_filial_produto_estoque_deposito_padrao_id');
        $produto_filial_produto_sob_encomenda_id = new TDBCombo('produto_filial_produto_sob_encomenda_id', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $produto_filial_produto_gerar_op_venda_id = new TDBCombo('produto_filial_produto_gerar_op_venda_id', 'kraftsoft', 'Resposta', 'id', '{descricao}','descricao asc'  );
        $produto_filial_produto_preco_venda_anterior = new THidden('produto_filial_produto_preco_venda_anterior');
        $produto_filial_produto_valor_custo_anterior = new THidden('produto_filial_produto_valor_custo_anterior');
        $button_adicionar_produto_filial_produto = new TButton('button_adicionar_produto_filial_produto');
        $produto_fornecedor_produto_fornecedor_id = new TDBCombo('produto_fornecedor_produto_fornecedor_id', 'kraftsoft', 'Fornecedor', 'id', '{nome}','nome asc'  );
        $produto_fornecedor_produto_id = new THidden('produto_fornecedor_produto_id');
        $produto_fornecedor_produto_codigo_fornecedor = new TEntry('produto_fornecedor_produto_codigo_fornecedor');
        $produto_fornecedor_produto_descricao_produto_fornecedor = new TEntry('produto_fornecedor_produto_descricao_produto_fornecedor');
        $produto_fornecedor_produto_quantidade_minima_compra = new TNumeric('produto_fornecedor_produto_quantidade_minima_compra', '2', ',', '.' );
        $produto_fornecedor_produto_tempo_medio_fornecimento = new TNumeric('produto_fornecedor_produto_tempo_medio_fornecimento', '2', ',', '.' );
        $produto_fornecedor_produto_preco_venda = new TNumeric('produto_fornecedor_produto_preco_venda', '2', ',', '.' );
        $button_adicionar_produto_fornecedor_produto = new TButton('button_adicionar_produto_fornecedor_produto');

        $produto_grupo_id->setChangeAction(new TAction([$this,'onChangeproduto_grupo_id']));
        $produto_filial_produto_system_unit_id->setChangeAction(new TAction([$this,'onChangeproduto_filial_produto_system_unit_id']));

        $produto_filial_produto_margem->setExitAction(new TAction([$this,'onExitMargem']));
        $produto_filial_produto_valor_custo->setExitAction(new TAction([$this,'onExitPrecoCusto']));
        $produto_filial_produto_preco_venda->setExitAction(new TAction([$this,'onExitPrecoVenda']));

        $nome->addValidation("Nome", new TRequiredValidator()); 
        $produto_grupo_id->addValidation("Grupo", new TRequiredValidator()); 
        $unidade_medida_id->addValidation("Unidade medida id", new TRequiredValidator()); 
        $produto_tipo_id->addValidation("Tipo", new TRequiredValidator()); 
        $habilitado_id->addValidation("Habilitado", new TRequiredValidator()); 

        $habilitado_id->addItems(["1"=>"Sim","2"=>"Não"]);
        $habilitado_id->setLayout('horizontal');
        $habilitado_id->setUseButton();
        $imagem->enableFileHandling();
        $imagem->setAllowedExtensions(["jpg","jpeg","png","gif"]);
        $imagem->setImagePlaceholder(new TImage("fas:file-upload #dde5ec"));
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $button_calc_preco_venda_produto_filial_produto->setAction(new TAction([$this, 'onCalcularPrecoVenda']), "Calc. preço venda");
        $button_adicionar_produto_filial_produto->setAction(new TAction([$this, 'onAddDetailProdutoFilialProduto'],['static' => 1]), "Adicionar");
        $button_adicionar_produto_fornecedor_produto->setAction(new TAction([$this, 'onAddDetailProdutoFornecedorProduto'],['static' => 1]), "Adicionar");

        $button_adicionar_produto_filial_produto->addStyleClass('btn-default');
        $button_adicionar_produto_fornecedor_produto->addStyleClass('btn-default');
        $button_calc_preco_venda_produto_filial_produto->addStyleClass('btn-success');

        $button_adicionar_produto_filial_produto->setImage('fas:plus #2ecc71');
        $button_adicionar_produto_fornecedor_produto->setImage('fas:plus #2ecc71');
        $button_calc_preco_venda_produto_filial_produto->setImage('fas:calculator #FFFFFF');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);

        $produto_tipo_id->enableSearch();
        $produto_grupo_id->enableSearch();
        $unidade_medida_id->enableSearch();
        $produto_embalagem_id->enableSearch();
        $produto_fabricante_id->enableSearch();
        $notafiscal_item_orig_id->enableSearch();
        $produtogrupo_subgrupo_id->enableSearch();
        $produto_filial_produto_sob_encomenda_id->enableSearch();
        $produto_filial_produto_gerar_op_venda_id->enableSearch();
        $produto_fornecedor_produto_fornecedor_id->enableSearch();
        $produto_filial_produto_estoque_deposito_padrao_id->enableSearch();

        $id->setSize('100%');
        $ncm->setSize('100%');
        $nome->setSize('100%');
        $cest->setSize('100%');
        $marca->setSize('100%');
        $altura->setSize('100%');
        $largura->setSize('100%');
        $diametro->setSize('100%');
        $garantia->setSize('100%');
        $obs->setSize('100%', 110);
        $habilitado_id->setSize(80);
        $criado_em->setSize('100%');
        $link_site->setSize('100%');
        $referencia->setSize('100%');
        $codigo_sku->setSize('100%');
        $codigo_EAN->setSize('100%');
        $nome_curto->setSize('100%');
        $peso_bruto->setSize('100%');
        $criado_por->setSize('100%');
        $imagem->setSize('100%', 80);
        $comprimento->setSize('100%');
        $alterado_em->setSize('100%');
        $tipo_recurso_id->setSize(200);
        $peso_liquido->setSize('100%');
        $alterado_por->setSize('100%');
        $unidade_caixa->setSize('100%');
        $produto_tipo_id->setSize('100%');
        $dias_preparacao->setSize('100%');
        $produto_grupo_id->setSize('100%');
        $unidade_medida_id->setSize('100%');
        $especificacao->setSize('100%', 110);
        $produto_embalagem_id->setSize('100%');
        $produto_fabricante_id->setSize('100%');
        $produto_filial_produto_id->setSize(200);
        $notafiscal_item_orig_id->setSize('100%');
        $produtogrupo_subgrupo_id->setSize('100%');
        $produto_fornecedor_produto_id->setSize(200);
        $produto_filial_produto_margem->setSize('100%');
        $produto_filial_produto_valor_custo->setSize('70%');
        $produto_filial_produto_preco_venda->setSize('100%');
        $produto_filial_produto_system_unit_id->setSize('100%');
        $produto_filial_produto_estoque_minimo->setSize('100%');
        $produto_filial_produto_estoque_maximo->setSize('100%');
        $produto_filial_produto_codigo_balanca->setSize('100%');
        $produto_fornecedor_produto_preco_venda->setSize('100%');
        $produto_filial_produto_sob_encomenda_id->setSize('100%');
        $produto_filial_produto_gerar_op_venda_id->setSize('100%');
        $produto_filial_produto_preco_venda_anterior->setSize(200);
        $produto_filial_produto_valor_custo_anterior->setSize(200);
        $produto_fornecedor_produto_fornecedor_id->setSize('100%');
        $produto_fornecedor_produto_codigo_fornecedor->setSize('100%');
        $produto_filial_produto_estoque_deposito_padrao_id->setSize('100%');
        $produto_fornecedor_produto_quantidade_minima_compra->setSize('100%');
        $produto_fornecedor_produto_tempo_medio_fornecimento->setSize('100%');
        $produto_fornecedor_produto_descricao_produto_fornecedor->setSize('100%');

        $button_adicionar_produto_filial_produto->id = '61f9a7da2586a';
        $button_adicionar_produto_fornecedor_produto->id = '6387d56397b9e';

        $this->form->appendPage("Dados Gerais");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id,$tipo_recurso_id],[new TLabel("Referência:", null, '14px', null, '100%'),$referencia],[new TLabel("Código SKU:", null, '14px', null, '100%'),$codigo_sku]);
        $row1->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row2 = $this->form->addFields([new TLabel("Nome:", '#ff0000', '14px', null, '100%'),$nome],[new TLabel("Código EAN:", null, '14px', null, '100%'),$codigo_EAN]);
        $row2->layout = [' col-sm-8',' col-sm-4'];

        $row3 = $this->form->addFields([new TLabel("Grupo:", '#ff0000', '14px', null, '100%'),$produto_grupo_id],[new TLabel("Subgrupo:", null, '14px', null, '100%'),$produtogrupo_subgrupo_id],[new TLabel("Fabricante:", null, '14px', null, '100%'),$produto_fabricante_id]);
        $row3->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row4 = $this->form->addFields([new TLabel("Unidade medida:", '#ff0000', '14px', null, '100%'),$unidade_medida_id],[new TLabel("Tipo:", '#FF0000', '14px', null),$produto_tipo_id],[new TLabel("Marca:", null, '14px', null),$marca]);
        $row4->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row5 = $this->form->addFields([new TLabel("Nome Curto:", null, '14px', null),$nome_curto],[],[]);
        $row5->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $tab_63c74935ce196 = new BootstrapFormBuilder('tab_63c74935ce196');
        $this->tab_63c74935ce196 = $tab_63c74935ce196;
        $tab_63c74935ce196->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63c74935ce196->appendPage("Dimensões e peso");

        $tab_63c74935ce196->addFields([new THidden('current_tab_tab_63c74935ce196')]);
        $tab_63c74935ce196->setTabFunction("$('[name=current_tab_tab_63c74935ce196]').val($(this).attr('data-current_page'));");

        $row6 = $tab_63c74935ce196->addFields([new TLabel("Peso Líquido:", null, '14px', null),$peso_liquido],[new TLabel("Peso Bruto:", null, '14px', null),$peso_bruto],[]);
        $row6->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row7 = $tab_63c74935ce196->addFields([new TLabel("Embalagem:", null, '14px', null),$produto_embalagem_id],[new TLabel("Largura:", null, '14px', null),$largura],[new TLabel("Altura:", null, '14px', null),$altura]);
        $row7->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row8 = $tab_63c74935ce196->addFields([new TLabel("Comprimento:", null, '14px', null),$comprimento],[new TLabel("Diâmetro", null, '14px', null),$diametro],[]);
        $row8->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $tab_63c74935ce196->appendPage("Estoque");
        $row9 = $tab_63c74935ce196->addFields([new TLabel("Dias para preparação", null, '14px', null),$dias_preparacao],[new TLabel("Unidade por Caixa", null, '14px', null),$unidade_caixa],[]);
        $row9->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $tab_63c74935ce196->appendPage("Outros");
        $row10 = $tab_63c74935ce196->addFields([new TLabel("Garantia:", null, '14px', null),$garantia],[]);
        $row10->layout = [' col-sm-4',' col-sm-4'];

        $row11 = $this->form->addFields([$tab_63c74935ce196]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$obs]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->form->addFields([new TLabel("Habilitado:", '#FF0000', '14px', null, '100%'),$habilitado_id]);
        $row13->layout = ['col-sm-6'];

        $row14 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row15 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row15->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Fiscal");
        $row16 = $this->form->addFields([new TLabel("NCM:", null, '14px', null, '100%'),$ncm],[new TLabel("CEST:", null, '14px', null, '100%'),$cest]);
        $row16->layout = ['col-sm-6','col-sm-6'];

        $row17 = $this->form->addFields([new TLabel("Origem:", null, '14px', null, '100%'),$notafiscal_item_orig_id]);
        $row17->layout = [' col-sm-12'];

        $this->form->appendPage("Foto e Especificação");
        $row18 = $this->form->addFields([new TLabel("Imagem:", null, '14px', null, '100%'),$imagem]);
        $row18->layout = [' col-sm-6'];

        $row19 = $this->form->addFields([new TLabel("Especificação:", null, '14px', null, '100%'),$especificacao]);
        $row19->layout = [' col-sm-12'];

        $row20 = $this->form->addFields([new TLabel("Link Site:", null, '14px', null, '100%'),$link_site]);
        $row20->layout = [' col-sm-12'];

        $this->form->appendPage("Regras por Filial");

        $this->detailFormProdutoFilialProduto = new BootstrapFormBuilder('detailFormProdutoFilialProduto');
        $this->detailFormProdutoFilialProduto->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormProdutoFilialProduto->setProperty('class', 'form-horizontal builder-detail-form');

        $row21 = $this->detailFormProdutoFilialProduto->addFields([new TLabel("Filial:", '#ff0000', '14px', null, '100%'),$produto_filial_produto_system_unit_id,$produto_filial_produto_id],[new TLabel("Margem (%):", null, '14px', null, '100%'),$produto_filial_produto_margem]);
        $row21->layout = ['col-sm-6','col-sm-6'];

        $row22 = $this->detailFormProdutoFilialProduto->addFields([new TLabel("Valor Custo:", null, '14px', null, '100%'),$produto_filial_produto_valor_custo,$button_calc_preco_venda_produto_filial_produto],[new TLabel("Preço Venda:", '#ff0000', '14px', null, '100%'),$produto_filial_produto_preco_venda]);
        $row22->layout = ['col-sm-6','col-sm-6'];

        $row23 = $this->detailFormProdutoFilialProduto->addFields([new TLabel("Estoque Minimo:", null, '14px', null, '100%'),$produto_filial_produto_estoque_minimo],[new TLabel("Estoque Máximo:", null, '14px', null, '100%'),$produto_filial_produto_estoque_maximo]);
        $row23->layout = ['col-sm-6','col-sm-6'];

        $row24 = $this->detailFormProdutoFilialProduto->addFields([new TLabel("Código Balança:", null, '14px', null, '100%'),$produto_filial_produto_codigo_balanca],[new TLabel("Depósito Padrão", null, '14px', null),$produto_filial_produto_estoque_deposito_padrao_id]);
        $row24->layout = ['col-sm-6',' col-sm-6'];

        $row25 = $this->detailFormProdutoFilialProduto->addFields([new TLabel("Sob Encomenda", null, '14px', null),$produto_filial_produto_sob_encomenda_id],[new TLabel("Gerar O.P. após venda", null, '14px', null),$produto_filial_produto_gerar_op_venda_id]);
        $row25->layout = ['col-sm-6',' col-sm-6'];

        $row26 = $this->detailFormProdutoFilialProduto->addFields([$produto_filial_produto_preco_venda_anterior],[$produto_filial_produto_valor_custo_anterior]);
        $row26->layout = ['col-sm-6',' col-sm-6'];

        $row27 = $this->detailFormProdutoFilialProduto->addFields([$button_adicionar_produto_filial_produto]);
        $row27->layout = [' col-sm-12'];

        $row28 = $this->detailFormProdutoFilialProduto->addFields([new THidden('produto_filial_produto__row__id')]);
        $this->produto_filial_produto_criteria = new TCriteria();

        $this->produto_filial_produto_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->produto_filial_produto_list->disableHtmlConversion();;
        $this->produto_filial_produto_list->generateHiddenFields();
        $this->produto_filial_produto_list->setId('produto_filial_produto_list');

        $this->produto_filial_produto_list->style = 'width:100%';
        $this->produto_filial_produto_list->class .= ' table-bordered';

        $column_produto_filial_produto_system_unit_name = new TDataGridColumn('system_unit->name', "Filial", 'left');
        $column_produto_filial_produto_preco_venda_transformed = new TDataGridColumn('preco_venda', "Preço Venda", 'right');
        $column_produto_filial_produto_valor_custo_transformed = new TDataGridColumn('valor_custo', "Valor Custo", 'right');
        $column_produto_filial_produto_estoque_minimo_transformed = new TDataGridColumn('estoque_minimo', "Estoque Minimo", 'right');
        $column_produto_filial_produto_estoque_maximo_transformed = new TDataGridColumn('estoque_maximo', "Estoque Máximo", 'right');
        $column_produto_filial_produto_alterado_em_transformed = new TDataGridColumn('alterado_em', "Alterado Em", 'left');

        $column_produto_filial_produto__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_produto_filial_produto__row__data->setVisibility(false);

        $action_onEditDetailProdutoFilial = new TDataGridAction(array('ProdutoForm', 'onEditDetailProdutoFilial'));
        $action_onEditDetailProdutoFilial->setUseButton(true);
        $action_onEditDetailProdutoFilial->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailProdutoFilial->setLabel("Editar");
        $action_onEditDetailProdutoFilial->setImage('far:edit #478fca');
        $action_onEditDetailProdutoFilial->setFields(['__row__id', '__row__data']);

        $this->produto_filial_produto_list->addAction($action_onEditDetailProdutoFilial);
        $action_onDeleteDetailProdutoFilial = new TDataGridAction(array('ProdutoForm', 'onDeleteDetailProdutoFilial'));
        $action_onDeleteDetailProdutoFilial->setUseButton(true);
        $action_onDeleteDetailProdutoFilial->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailProdutoFilial->setLabel("Excluir");
        $action_onDeleteDetailProdutoFilial->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailProdutoFilial->setFields(['__row__id', '__row__data']);

        $this->produto_filial_produto_list->addAction($action_onDeleteDetailProdutoFilial);
        $action_onShow = new TDataGridAction(array('ProdutoEnderecamentoFormList', 'onShow'));
        $action_onShow->setUseButton(true);
        $action_onShow->setButtonClass('btn btn-default btn-sm');
        $action_onShow->setLabel("Endereçamento");
        $action_onShow->setImage('fas:sitemap #009688');
        $action_onShow->setFields(['__row__id', '__row__data']);
        $action_onShow->setDisplayCondition('ProdutoForm::onExibeEnderecamento');
        $action_onShow->setParameter('produto_form_produto_filial_id', '{id}');
        $this->produto_filial_produto_list->addAction($action_onShow);

        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_system_unit_name);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_preco_venda_transformed);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_valor_custo_transformed);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_estoque_minimo_transformed);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_estoque_maximo_transformed);
        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto_alterado_em_transformed);

        $this->produto_filial_produto_list->addColumn($column_produto_filial_produto__row__data);

        $this->produto_filial_produto_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->produto_filial_produto_list);
        $this->detailFormProdutoFilialProduto->addContent([$tableResponsiveDiv]);

        $column_produto_filial_produto_preco_venda_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_produto_filial_produto_valor_custo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_produto_filial_produto_estoque_minimo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_produto_filial_produto_estoque_maximo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_produto_filial_produto_alterado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });        $row29 = $this->form->addFields([$this->detailFormProdutoFilialProduto]);
        $row29->layout = [' col-sm-12'];

        $this->form->appendPage("Fornecedores");

        $this->detailFormProdutoFornecedorProduto = new BootstrapFormBuilder('detailFormProdutoFornecedorProduto');
        $this->detailFormProdutoFornecedorProduto->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormProdutoFornecedorProduto->setProperty('class', 'form-horizontal builder-detail-form');

        $row30 = $this->detailFormProdutoFornecedorProduto->addFields([new TLabel("Fornecedor:", '#ff0000', '14px', null, '100%'),$produto_fornecedor_produto_fornecedor_id,$produto_fornecedor_produto_id]);
        $row30->layout = [' col-sm-12'];

        $row31 = $this->detailFormProdutoFornecedorProduto->addFields([new TLabel("Código Fornecedor:", null, '14px', null, '100%'),$produto_fornecedor_produto_codigo_fornecedor],[new TLabel("Descrição do Produto no Fornecedor:", null, '14px', null, '100%'),$produto_fornecedor_produto_descricao_produto_fornecedor]);
        $row31->layout = ['col-sm-6','col-sm-6'];

        $row32 = $this->detailFormProdutoFornecedorProduto->addFields([new TLabel("Qtde. mínima para compra:", null, '14px', null, '100%'),$produto_fornecedor_produto_quantidade_minima_compra],[new TLabel("Tempo médio fornecimento:", null, '14px', null, '100%'),$produto_fornecedor_produto_tempo_medio_fornecimento]);
        $row32->layout = ['col-sm-6','col-sm-6'];

        $row33 = $this->detailFormProdutoFornecedorProduto->addFields([new TLabel("Preço de Venda Fornecedor:", null, '14px', null),$produto_fornecedor_produto_preco_venda]);
        $row33->layout = ['col-sm-6'];

        $row34 = $this->detailFormProdutoFornecedorProduto->addFields([$button_adicionar_produto_fornecedor_produto]);
        $row34->layout = [' col-sm-12'];

        $row35 = $this->detailFormProdutoFornecedorProduto->addFields([new THidden('produto_fornecedor_produto__row__id')]);
        $this->produto_fornecedor_produto_criteria = new TCriteria();

        $this->produto_fornecedor_produto_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->produto_fornecedor_produto_list->disableHtmlConversion();;
        $this->produto_fornecedor_produto_list->generateHiddenFields();
        $this->produto_fornecedor_produto_list->setId('produto_fornecedor_produto_list');

        $this->produto_fornecedor_produto_list->style = 'width:100%';
        $this->produto_fornecedor_produto_list->class .= ' table-bordered';

        $column_produto_fornecedor_produto_fornecedor_nome = new TDataGridColumn('fornecedor->nome', "Fornecedor", 'left');
        $column_produto_fornecedor_produto_codigo_fornecedor = new TDataGridColumn('codigo_fornecedor', "Cód. Fornecedor", 'left');
        $column_produto_fornecedor_produto_descricao_produto_fornecedor = new TDataGridColumn('descricao_produto_fornecedor', "Descrição do Produto no Fornecedor", 'left');
        $column_produto_fornecedor_produto_tempo_medio_fornecimento = new TDataGridColumn('tempo_medio_fornecimento', "Tempo médio fornecimento", 'left');
        $column_produto_fornecedor_produto_quantidade_minima_compra = new TDataGridColumn('quantidade_minima_compra', "Qtde. mínima para compra", 'left');
        $column_produto_fornecedor_produto_preco_venda_transformed = new TDataGridColumn('preco_venda', "Preço de Venda", 'left');

        $column_produto_fornecedor_produto__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_produto_fornecedor_produto__row__data->setVisibility(false);

        $action_onEditDetailProdutoFornecedor = new TDataGridAction(array('ProdutoForm', 'onEditDetailProdutoFornecedor'));
        $action_onEditDetailProdutoFornecedor->setUseButton(false);
        $action_onEditDetailProdutoFornecedor->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailProdutoFornecedor->setLabel("Editar");
        $action_onEditDetailProdutoFornecedor->setImage('far:edit #478fca');
        $action_onEditDetailProdutoFornecedor->setFields(['__row__id', '__row__data']);

        $this->produto_fornecedor_produto_list->addAction($action_onEditDetailProdutoFornecedor);
        $action_onDeleteDetailProdutoFornecedor = new TDataGridAction(array('ProdutoForm', 'onDeleteDetailProdutoFornecedor'));
        $action_onDeleteDetailProdutoFornecedor->setUseButton(false);
        $action_onDeleteDetailProdutoFornecedor->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailProdutoFornecedor->setLabel("Excluir");
        $action_onDeleteDetailProdutoFornecedor->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailProdutoFornecedor->setFields(['__row__id', '__row__data']);

        $this->produto_fornecedor_produto_list->addAction($action_onDeleteDetailProdutoFornecedor);

        $this->produto_fornecedor_produto_list->addColumn($column_produto_fornecedor_produto_fornecedor_nome);
        $this->produto_fornecedor_produto_list->addColumn($column_produto_fornecedor_produto_codigo_fornecedor);
        $this->produto_fornecedor_produto_list->addColumn($column_produto_fornecedor_produto_descricao_produto_fornecedor);
        $this->produto_fornecedor_produto_list->addColumn($column_produto_fornecedor_produto_tempo_medio_fornecimento);
        $this->produto_fornecedor_produto_list->addColumn($column_produto_fornecedor_produto_quantidade_minima_compra);
        $this->produto_fornecedor_produto_list->addColumn($column_produto_fornecedor_produto_preco_venda_transformed);

        $this->produto_fornecedor_produto_list->addColumn($column_produto_fornecedor_produto__row__data);

        $this->produto_fornecedor_produto_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->produto_fornecedor_produto_list);
        $this->detailFormProdutoFornecedorProduto->addContent([$tableResponsiveDiv]);

        $column_produto_fornecedor_produto_preco_venda_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row36 = $this->form->addFields([$this->detailFormProdutoFornecedorProduto]);
        $row36->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['ProdutoList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Produto","Cadastro de produto"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onChangeproduto_grupo_id($param)
    {
        try
        {

            if (isset($param['produto_grupo_id']) && $param['produto_grupo_id'])
            { 
                $criteria = TCriteria::create(['produto_grupo_id' => $param['produto_grupo_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'produtogrupo_subgrupo_id', 'kraftsoft', 'ProdutogrupoSubgrupo', 'id', '{descricao}', 'descricao asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'produtogrupo_subgrupo_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public static function onChangeproduto_filial_produto_system_unit_id($param)
    {
        try
        {

            if (isset($param['produto_filial_produto_system_unit_id']) && $param['produto_filial_produto_system_unit_id'])
            { 
                $criteria = TCriteria::create(['system_unit_id' => $param['produto_filial_produto_system_unit_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'produto_filial_produto_estoque_deposito_padrao_id', 'kraftsoft', 'EstoqueDeposito', 'id', '{descricao}', 'descricao asc', $criteria, TRUE); 
            } 
            else 
            { 
                TCombo::clearField(self::$formName, 'produto_filial_produto_estoque_deposito_padrao_id'); 
            }  

        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    } 

    public static function onExitMargem($param = null) 
    {
        try 
        {
        //   self::onExitPrecoCusto($param);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitPrecoCusto($param = null) 
    {
        try 
        {

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitPrecoVenda($param = null) 
    {
        try 
        {
        /*

        Por exemplo, se o preço de venda de um produto é R$ 100,00 e o custo total para produzi-lo é R$ 70,00, o lucro bruto é de R$ 30,00. 
        A margem de lucro seria calculada assim: (30 ÷ 100) x 100 = 30%. Portanto, a margem de lucro é de 30%.

        */

        // $produto_filial_produto_preco_venda = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_preco_venda']));
        // $produto_filial_produto_valor_custo = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_valor_custo']));

        // $produto_filial_produto_margem = (( $produto_filial_produto_preco_venda - $produto_filial_produto_valor_custo ) / 100) * 100;

        // $object = new stdClass();
        // $object->produto_filial_produto_margem = number_format($produto_filial_produto_margem, 2, ',', '.');
        // TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCalcularPrecoVenda($param = null) 
    {
        try 
        {
            //new TMessage('error', 'Ramon Viado' );
            $produto_filial_produto_margem = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_margem']));
            $produto_filial_produto_valor_custo = (double) str_replace(',', '.', str_replace('.', '', $param['produto_filial_produto_valor_custo']));

            $produto_filial_produto_preco_venda = $produto_filial_produto_valor_custo + (( $produto_filial_produto_margem * $produto_filial_produto_valor_custo ) / 100);

            $produto_filial_produto_preco_venda = number_format($produto_filial_produto_preco_venda, 2, ',', '.');

            $object = new stdClass();
            $object->produto_filial_produto_preco_venda = $produto_filial_produto_preco_venda; //number_format($produto_filial_produto_preco_venda, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailProdutoFilialProduto($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"System unit id", 'name'=>"produto_filial_produto_system_unit_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Preço Venda", 'name'=>"produto_filial_produto_preco_venda", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->produto_filial_produto__row__id) ? $data->produto_filial_produto__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ProdutoFilial();
            $grid_data->__row__id = $__row__id;
            $grid_data->system_unit_id = $data->produto_filial_produto_system_unit_id;
            $grid_data->id = $data->produto_filial_produto_id;
            $grid_data->margem = $data->produto_filial_produto_margem;
            $grid_data->valor_custo = $data->produto_filial_produto_valor_custo;
            $grid_data->preco_venda = $data->produto_filial_produto_preco_venda;
            $grid_data->estoque_minimo = $data->produto_filial_produto_estoque_minimo;
            $grid_data->estoque_maximo = $data->produto_filial_produto_estoque_maximo;
            $grid_data->codigo_balanca = $data->produto_filial_produto_codigo_balanca;
            $grid_data->estoque_deposito_padrao_id = $data->produto_filial_produto_estoque_deposito_padrao_id;
            $grid_data->sob_encomenda_id = $data->produto_filial_produto_sob_encomenda_id;
            $grid_data->gerar_op_venda_id = $data->produto_filial_produto_gerar_op_venda_id;
            $grid_data->preco_venda_anterior =  str_replace(',','.',str_replace('.','',$data->produto_filial_produto_preco_venda_anterior));
            $grid_data->valor_custo_anterior = str_replace(',','.',str_replace('.','',$data->produto_filial_produto_valor_custo_anterior));

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['system_unit_id'] =  $param['produto_filial_produto_system_unit_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['produto_filial_produto_id'] ?? null;
            $__row__data['__display__']['margem'] =  $param['produto_filial_produto_margem'] ?? null;
            $__row__data['__display__']['valor_custo'] =  $param['produto_filial_produto_valor_custo'] ?? null;
            $__row__data['__display__']['preco_venda'] =  $param['produto_filial_produto_preco_venda'] ?? null;
            $__row__data['__display__']['estoque_minimo'] =  $param['produto_filial_produto_estoque_minimo'] ?? null;
            $__row__data['__display__']['estoque_maximo'] =  $param['produto_filial_produto_estoque_maximo'] ?? null;
            $__row__data['__display__']['codigo_balanca'] =  $param['produto_filial_produto_codigo_balanca'] ?? null;
            $__row__data['__display__']['estoque_deposito_padrao_id'] =  $param['produto_filial_produto_estoque_deposito_padrao_id'] ?? null;
            $__row__data['__display__']['sob_encomenda_id'] =  $param['produto_filial_produto_sob_encomenda_id'] ?? null;
            $__row__data['__display__']['gerar_op_venda_id'] =  $param['produto_filial_produto_gerar_op_venda_id'] ?? null;
            $__row__data['__display__']['preco_venda_anterior'] =  $param['produto_filial_produto_preco_venda_anterior'] ?? null;
            $__row__data['__display__']['valor_custo_anterior'] =  $param['produto_filial_produto_valor_custo_anterior'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->produto_filial_produto_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('produto_filial_produto_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->produto_filial_produto_system_unit_id = '';
            $data->produto_filial_produto_id = '';
            $data->produto_filial_produto_margem = '';
            $data->produto_filial_produto_valor_custo = '';
            $data->produto_filial_produto_preco_venda = '';
            $data->produto_filial_produto_estoque_minimo = '';
            $data->produto_filial_produto_estoque_maximo = '';
            $data->produto_filial_produto_codigo_balanca = '';
            $data->produto_filial_produto_estoque_deposito_padrao_id = '';
            $data->produto_filial_produto_sob_encomenda_id = '';
            $data->produto_filial_produto_gerar_op_venda_id = '';
            $data->produto_filial_produto_preco_venda_anterior = '';
            $data->produto_filial_produto_valor_custo_anterior = '';
            $data->produto_filial_produto__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61f9a7da2586a');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailProdutoFornecedorProduto($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Fornecedor id", 'name'=>"produto_fornecedor_produto_fornecedor_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->produto_fornecedor_produto__row__id) ? $data->produto_fornecedor_produto__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ProdutoFornecedor();
            $grid_data->__row__id = $__row__id;
            $grid_data->fornecedor_id = $data->produto_fornecedor_produto_fornecedor_id;
            $grid_data->id = $data->produto_fornecedor_produto_id;
            $grid_data->codigo_fornecedor = $data->produto_fornecedor_produto_codigo_fornecedor;
            $grid_data->descricao_produto_fornecedor = $data->produto_fornecedor_produto_descricao_produto_fornecedor;
            $grid_data->quantidade_minima_compra = $data->produto_fornecedor_produto_quantidade_minima_compra;
            $grid_data->tempo_medio_fornecimento = $data->produto_fornecedor_produto_tempo_medio_fornecimento;
            $grid_data->preco_venda = $data->produto_fornecedor_produto_preco_venda;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['fornecedor_id'] =  $param['produto_fornecedor_produto_fornecedor_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['produto_fornecedor_produto_id'] ?? null;
            $__row__data['__display__']['codigo_fornecedor'] =  $param['produto_fornecedor_produto_codigo_fornecedor'] ?? null;
            $__row__data['__display__']['descricao_produto_fornecedor'] =  $param['produto_fornecedor_produto_descricao_produto_fornecedor'] ?? null;
            $__row__data['__display__']['quantidade_minima_compra'] =  $param['produto_fornecedor_produto_quantidade_minima_compra'] ?? null;
            $__row__data['__display__']['tempo_medio_fornecimento'] =  $param['produto_fornecedor_produto_tempo_medio_fornecimento'] ?? null;
            $__row__data['__display__']['preco_venda'] =  $param['produto_fornecedor_produto_preco_venda'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->produto_fornecedor_produto_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('produto_fornecedor_produto_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->produto_fornecedor_produto_fornecedor_id = '';
            $data->produto_fornecedor_produto_id = '';
            $data->produto_fornecedor_produto_codigo_fornecedor = '';
            $data->produto_fornecedor_produto_descricao_produto_fornecedor = '';
            $data->produto_fornecedor_produto_quantidade_minima_compra = '';
            $data->produto_fornecedor_produto_tempo_medio_fornecimento = '';
            $data->produto_fornecedor_produto_preco_venda = '';
            $data->produto_fornecedor_produto__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6387d56397b9e');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailProdutoFilial($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->produto_filial_produto_system_unit_id = $__row__data->__display__->system_unit_id ?? null;
            $data->produto_filial_produto_id = $__row__data->__display__->id ?? null;
            $data->produto_filial_produto_margem = $__row__data->__display__->margem ?? null;
            $data->produto_filial_produto_valor_custo = $__row__data->__display__->valor_custo ?? null;
            $data->produto_filial_produto_preco_venda = $__row__data->__display__->preco_venda ?? null;
            $data->produto_filial_produto_estoque_minimo = $__row__data->__display__->estoque_minimo ?? null;
            $data->produto_filial_produto_estoque_maximo = $__row__data->__display__->estoque_maximo ?? null;
            $data->produto_filial_produto_codigo_balanca = $__row__data->__display__->codigo_balanca ?? null;
            $data->produto_filial_produto_estoque_deposito_padrao_id = $__row__data->__display__->estoque_deposito_padrao_id ?? null;
            $data->produto_filial_produto_sob_encomenda_id = $__row__data->__display__->sob_encomenda_id ?? null;
            $data->produto_filial_produto_gerar_op_venda_id = $__row__data->__display__->gerar_op_venda_id ?? null;
            $data->produto_filial_produto_preco_venda_anterior = $__row__data->__display__->preco_venda_anterior ?? null;
            $data->produto_filial_produto_valor_custo_anterior = $__row__data->__display__->valor_custo_anterior ?? null;
            $data->produto_filial_produto__row__id = $__row__data->__row__id;

            $data->produto_filial_produto_preco_venda_anterior = $__row__data->__display__->preco_venda ?? null;
            $data->produto_filial_produto_valor_custo_anterior = $__row__data->__display__->valor_custo ?? null;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#61f9a7da2586a');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Salvar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailProdutoFilial($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->produto_filial_produto_system_unit_id = '';
            $data->produto_filial_produto_id = '';
            $data->produto_filial_produto_margem = '';
            $data->produto_filial_produto_valor_custo = '';
            $data->produto_filial_produto_preco_venda = '';
            $data->produto_filial_produto_estoque_minimo = '';
            $data->produto_filial_produto_estoque_maximo = '';
            $data->produto_filial_produto_codigo_balanca = '';
            $data->produto_filial_produto_estoque_deposito_padrao_id = '';
            $data->produto_filial_produto_sob_encomenda_id = '';
            $data->produto_filial_produto_gerar_op_venda_id = '';
            $data->produto_filial_produto_preco_venda_anterior = '';
            $data->produto_filial_produto_valor_custo_anterior = '';
            $data->produto_filial_produto__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('produto_filial_produto_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onExibeEnderecamento($object)
    {
        try 
        {
            if(!$object->id==null)
            {
                return true;
            }

            return false;
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public static function onEditDetailProdutoFornecedor($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->produto_fornecedor_produto_fornecedor_id = $__row__data->__display__->fornecedor_id ?? null;
            $data->produto_fornecedor_produto_id = $__row__data->__display__->id ?? null;
            $data->produto_fornecedor_produto_codigo_fornecedor = $__row__data->__display__->codigo_fornecedor ?? null;
            $data->produto_fornecedor_produto_descricao_produto_fornecedor = $__row__data->__display__->descricao_produto_fornecedor ?? null;
            $data->produto_fornecedor_produto_quantidade_minima_compra = $__row__data->__display__->quantidade_minima_compra ?? null;
            $data->produto_fornecedor_produto_tempo_medio_fornecimento = $__row__data->__display__->tempo_medio_fornecimento ?? null;
            $data->produto_fornecedor_produto_preco_venda = $__row__data->__display__->preco_venda ?? null;
            $data->produto_fornecedor_produto__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6387d56397b9e');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailProdutoFornecedor($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->produto_fornecedor_produto_fornecedor_id = '';
            $data->produto_fornecedor_produto_id = '';
            $data->produto_fornecedor_produto_codigo_fornecedor = '';
            $data->produto_fornecedor_produto_descricao_produto_fornecedor = '';
            $data->produto_fornecedor_produto_quantidade_minima_compra = '';
            $data->produto_fornecedor_produto_tempo_medio_fornecimento = '';
            $data->produto_fornecedor_produto_preco_venda = '';
            $data->produto_fornecedor_produto__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('produto_fornecedor_produto_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Produto(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $imagem_dir = 'app/files/kraft_arquivos/produtos';  

            if ($object->id==0)
            {
              $object->ativo_id = Ativo::Ativo;
            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $this->fireEvents($object);

            $this->saveFile($object, $data, 'imagem', $imagem_dir);
            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $produto_fornecedor_produto_items = $this->storeMasterDetailItems('ProdutoFornecedor', 'produto_id', 'produto_fornecedor_produto', $object, $param['produto_fornecedor_produto_list___row__data'] ?? [], $this->form, $this->produto_fornecedor_produto_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->produto_fornecedor_produto_criteria); 

            $produto_filial_produto_items = $this->storeMasterDetailItems('ProdutoFilial', 'produto_id', 'produto_filial_produto', $object, $param['produto_filial_produto_list___row__data'] ?? [], $this->form, $this->produto_filial_produto_list, function($masterObject, $detailObject)
            { 

                //code here
                //buscando tabelas de preço com este produto para recalcular os valores..
                $listatabelaprecoprod = TabelaPrecoProduto::where('produto_filial_id', '=', $detailObject->id)->load();

                if ($listatabelaprecoprod)
                {
                    foreach ($listatabelaprecoprod as $tabelaprecoprod)
                    {
                        $tabelaprecoprod->preco_venda = TabelaPreco::calcula_preco_tabela($tabelaprecoprod->tabela_preco->tabela_preco_tipo_alteracao_id,
                                                                                          $detailObject->preco_venda,
                                                                                          $tabelaprecoprod->valor_parametro);

                        $tabelaprecoprod->store();
                    }
                }

                //verificando se o valor ou custo foi alterado para gerar o historico..
                if (($detailObject->preco_venda != $detailObject->preco_venda_anterior) &&
                   ($detailObject->preco_venda_anterior != '') &&
                   ($detailObject->id != ''))
                {

                   //consultando a tabela de historico para ver se o ultimo registro também foi o mesmo valor, se for não registrar historico...
                   $prodfilhist = ProdutoFilialHistorico::where('produto_filial_id', '=', $detailObject->id)->last();
                   $repetido = false;

                   if ($prodfilhist)
                   {

                        if (($prodfilhist->preco_venda_antigo == $detailObject->preco_venda_anterior) &&
                           ($prodfilhist->preco_venda_novo == $detailObject->preco_venda))
                        {
                            $repetido = true;                               
                        }
                   }

                   if (!$repetido)
                   {            
                       $prod_filial_hist = new ProdutoFilialHistorico();
                       $prod_filial_hist->produto_id = $detailObject->produto_id;
                       $prod_filial_hist->produto_filial_id = $detailObject->id;
                       $prod_filial_hist->preco_venda_antigo = floatval($detailObject->preco_venda_anterior);
                       $prod_filial_hist->preco_venda_novo = floatval($detailObject->preco_venda);
                       $prod_filial_hist->valor_custo_antigo = floatval($detailObject->valor_custo_anterior);
                       $prod_filial_hist->valor_custo_novo = floatval($detailObject->valor_custo);
                       $prod_filial_hist->criado_por = TSession::getValue('username');

                       $prod_filial_hist->store();
                   }
                }

            }, $this->produto_filial_produto_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ProdutoList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Produto($key); // instantiates the Active Record 

                $produto_fornecedor_produto_items = $this->loadMasterDetailItems('ProdutoFornecedor', 'produto_id', 'produto_fornecedor_produto', $object, $this->form, $this->produto_fornecedor_produto_list, $this->produto_fornecedor_produto_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $produto_filial_produto_items = $this->loadMasterDetailItems('ProdutoFilial', 'produto_id', 'produto_filial_produto', $object, $this->form, $this->produto_filial_produto_list, $this->produto_filial_produto_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                    $objectItems->produto_filial_produto_system_unit_id = null;
                    if(isset($detailObject->system_unit_id) && $detailObject->system_unit_id)
                    {
                        $objectItems->__display__->system_unit_id = $detailObject->system_unit_id;
                    }

                    $objectItems->produto_filial_produto_estoque_deposito_padrao_id = null;
                    if(isset($detailObject->estoque_deposito_padrao_id) && $detailObject->estoque_deposito_padrao_id)
                    {
                        $objectItems->__display__->estoque_deposito_padrao_id = $detailObject->estoque_deposito_padrao_id;
                    }

                }); 

                $this->form->setData($object); // fill the form 

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $obj = new stdClass();

        if (empty($obj->id))
        {
          $obj->permite_desconto = Resposta::Nao;
          $obj->tipo_recurso_id = TipoRecurso::Produto;

          TForm::sendData(self::$formName, $obj); 
        }

    }

    public function onShow($param = null)
    {

        $obj = new stdClass();

        if (empty($obj->id))
        {
          $obj->permite_desconto = Resposta::Nao;
          $obj->tipo_recurso_id = TipoRecurso::Produto;
          $obj->notafiscal_item_orig_id = NotafiscalItemOrig::Zero;
          $obj->produto_tipo_id = ProdutoTipo::Simples;
          $obj->habilitado_id = Resposta::Sim;

          TForm::sendData(self::$formName, $obj); 
        }

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->produto_grupo_id))
            {
                $value = $object->produto_grupo_id;

                $obj->produto_grupo_id = $value;
            }
            if(isset($object->produtogrupo_subgrupo_id))
            {
                $value = $object->produtogrupo_subgrupo_id;

                $obj->produtogrupo_subgrupo_id = $value;
            }
            if(isset($object->produto_filial_produto_system_unit_id))
            {
                $value = $object->produto_filial_produto_system_unit_id;

                $obj->produto_filial_produto_system_unit_id = $value;
            }
            if(isset($object->produto_filial_produto_estoque_deposito_padrao_id))
            {
                $value = $object->produto_filial_produto_estoque_deposito_padrao_id;

                $obj->produto_filial_produto_estoque_deposito_padrao_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->produto_grupo_id))
            {
                $value = $object->produto_grupo_id;

                $obj->produto_grupo_id = $value;
            }
            if(isset($object->produtogrupo_subgrupo_id))
            {
                $value = $object->produtogrupo_subgrupo_id;

                $obj->produtogrupo_subgrupo_id = $value;
            }
            if(isset($object->produto_filial->produto->system_unit_id))
            {
                $value = $object->produto_filial->produto->system_unit_id;

                $obj->produto_filial_produto_system_unit_id = $value;
            }
            if(isset($object->produto_filial->produto->estoque_deposito_padrao_id))
            {
                $value = $object->produto_filial->produto->estoque_deposito_padrao_id;

                $obj->produto_filial_produto_estoque_deposito_padrao_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

