<?php

class ProdutoFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Produto';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Produto';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $produto = new Produto($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Produto");

        $txtnomeprodpainel = new TTextDisplay($produto->nome, '', '20px', 'B');
        $bpc_indicadores_prod = new BPageContainer();
        $bpc_ultimasvendas = new BPageContainer();
        $bpc_ultimascompras = new BPageContainer();
        $label1 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($produto->id, '', '15px', '');
        $label18 = new TLabel("Referência:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay($produto->referencia, '', '15px', '');
        $label26 = new TLabel("Código SKU:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay($produto->codigo_sku, '', '15px', '');
        $label8 = new TLabel("Nome:", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay($produto->nome, '', '15px', '');
        $label9 = new TLabel("Código EAN:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($produto->codigo_EAN, '', '15px', '');
        $label2 = new TLabel("Grupo:", '', '15px', 'B', '100%');
        $text2 = new TTextDisplay($produto->produto_grupo->descricao, '', '15px', '');
        $label6 = new TLabel("Subgrupo:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay($produto->produtogrupo_subgrupo->descricao, '', '15px', '');
        $label5 = new TLabel("Fabricante:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($produto->produto_fabricante->nome, '', '15px', '');
        $label3 = new TLabel("Unidade medida:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($produto->unidade_medida->nome, '', '15px', '');
        $label25 = new TLabel("Produto tipo id:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay($produto->produto_tipo->descricao, '', '15px', '');
        $label32 = new TLabel("Marca:", '', '15px', 'B', '100%');
        $text32 = new TTextDisplay($produto->marca, '', '15px', '');
        $label22 = new TLabel("Peso Liquido:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(number_format((double)$produto->peso_liquido, '2', ',', '.'), '', '15px', '');
        $label23 = new TLabel("Peso Bruto:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay(number_format((double)$produto->peso_bruto, '2', ',', '.'), '', '15px', '');
        $label35 = new TLabel("Embalagem:", '', '15px', 'B', '100%');
        $text35 = new TTextDisplay($produto->produto_embalagem->descricao, '', '15px', '');
        $label27 = new TLabel("Largura:", '', '15px', 'B', '100%');
        $text27 = new TTextDisplay(number_format((double)$produto->largura, '2', ',', '.'), '', '15px', '');
        $label28 = new TLabel("Altura:", '', '15px', 'B', '100%');
        $text28 = new TTextDisplay(number_format((double)$produto->altura, '2', ',', '.'), '', '15px', '');
        $label29 = new TLabel("Comprimento:", '', '15px', 'B', '100%');
        $text29 = new TTextDisplay(number_format((double)$produto->comprimento, '2', ',', '.'), '', '15px', '');
        $label30 = new TLabel("Diametro:", '', '15px', 'B', '100%');
        $text30 = new TTextDisplay(number_format((double)$produto->diametro, '2', ',', '.'), '', '15px', '');
        $label31 = new TLabel("Dias para preparação:", '', '15px', 'B', '100%');
        $text31 = new TTextDisplay(number_format((double)$produto->dias_preparacao, '2', ',', '.'), '', '15px', '');
        $label34 = new TLabel("Unidade por Caixa:", '', '15px', 'B', '100%');
        $text34 = new TTextDisplay(number_format((double)$produto->unidade_caixa, '2', ',', '.'), '', '15px', '');
        $label33 = new TLabel("Garantia:", '', '15px', 'B', '100%');
        $text33 = new TTextDisplay($produto->garantia, '', '15px', '');
        $label17 = new TLabel("Observação:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay($produto->obs, '', '15px', '');
        $label24 = new TLabel("Habilitado:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay($produto->habilitado->descricao, '', '15px', '');
        $label11 = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay(TDateTime::convertToMask($produto->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label15 = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay($produto->criado_por, '', '15px', '');
        $label12 = new TLabel("Alterado em:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(TDateTime::convertToMask($produto->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label16 = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay($produto->alterado_por, '', '15px', '');
        $label13 = new TLabel("NCM:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay($produto->ncm, '', '15px', '');
        $label14 = new TLabel("CEST:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay($produto->cest, '', '15px', '');
        $label7 = new TLabel("Origem:", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay($produto->notafiscal_item_orig->descricao, '', '15px', '');
        $label10 = new TLabel("Imagem:", '', '15px', 'B', '100%');
        $image1 = new TImage($produto->imagem);
        $label20 = new TLabel("Especificação:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay($produto->especificacao, '', '15px', '');
        $label21 = new TLabel("Link Site:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay($produto->link_site, '', '15px', '');

        $bpc_ultimasvendas->setSize('100%');
        $bpc_ultimascompras->setSize('100%');
        $bpc_indicadores_prod->setSize('100%');

        $bpc_indicadores_prod->setAction(new TAction(['ProdutoIndicadoresForm', 'onShow'], ['produto_id' => $produto->id]));
        $bpc_ultimasvendas->setAction(new TAction(['VendaItemProdutoSimpleList', 'onShow'], ['produto_id' => $produto->id]));
        $bpc_ultimascompras->setAction(new TAction(['NotaFiscalCompraItensProdutoSimpleList', 'onShow'], ['produto_id' => $produto->id]));

        $bpc_ultimasvendas->setId('b63f8c7872fb85');
        $bpc_ultimascompras->setId('b63f8cd03b74e7');
        $bpc_indicadores_prod->setId('b63f9d074ed1cf');

        $image1->width = '100%';
        $image1->height = '80px';

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_indicadores_prod->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_ultimasvendas->add($loadingContainer);
        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $bpc_ultimascompras->add($loadingContainer);


        $this->form->appendPage("Painel");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$txtnomeprodpainel]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$bpc_indicadores_prod]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addContent([new TFormSeparator("", '#333', '18', '#eee')]);

        $tab_63f8c76bd2388 = new BootstrapFormBuilder('tab_63f8c76bd2388');
        $this->tab_63f8c76bd2388 = $tab_63f8c76bd2388;
        $tab_63f8c76bd2388->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63f8c76bd2388->appendPage("Últimas Vendas");

        $tab_63f8c76bd2388->addFields([new THidden('current_tab_tab_63f8c76bd2388')]);
        $tab_63f8c76bd2388->setTabFunction("$('[name=current_tab_tab_63f8c76bd2388]').val($(this).attr('data-current_page'));");

        $row4 = $tab_63f8c76bd2388->addFields([$bpc_ultimasvendas]);
        $row4->layout = [' col-sm-12'];

        $tab_63f8c76bd2388->appendPage("Últimas Compras");
        $row5 = $tab_63f8c76bd2388->addFields([$bpc_ultimascompras]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->form->addFields([$tab_63f8c76bd2388]);
        $row6->layout = [' col-sm-12'];

        $this->form->appendPage("Dados Gerais");
        $row7 = $this->form->addFields([$label1,$text1],[$label18,$text18],[$label26,$text26]);
        $row7->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row8 = $this->form->addFields([$label8,$text8],[$label9,$text9]);
        $row8->layout = [' col-sm-8',' col-sm-4'];

        $row9 = $this->form->addFields([$label2,$text2],[$label6,$text6],[$label5,$text5]);
        $row9->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row10 = $this->form->addFields([$label3,$text3],[$label25,$text25],[$label32,$text32]);
        $row10->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $tab_63f8add6af43d = new BootstrapFormBuilder('tab_63f8add6af43d');
        $this->tab_63f8add6af43d = $tab_63f8add6af43d;
        $tab_63f8add6af43d->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63f8add6af43d->appendPage("Dimensões e peso");

        $tab_63f8add6af43d->addFields([new THidden('current_tab_tab_63f8add6af43d')]);
        $tab_63f8add6af43d->setTabFunction("$('[name=current_tab_tab_63f8add6af43d]').val($(this).attr('data-current_page'));");

        $row11 = $tab_63f8add6af43d->addFields([$label22,$text22],[$label23,$text23],[]);
        $row11->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row12 = $tab_63f8add6af43d->addFields([$label35,$text35],[$label27,$text27],[$label28,$text28]);
        $row12->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row13 = $tab_63f8add6af43d->addFields([$label29,$text29],[$label30,$text30],[]);
        $row13->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $tab_63f8add6af43d->appendPage("Estoque");
        $row14 = $tab_63f8add6af43d->addFields([$label31,$text31],[$label34,$text34],[]);
        $row14->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $tab_63f8add6af43d->appendPage("Outros");
        $row15 = $tab_63f8add6af43d->addFields([$label33,$text33],[]);
        $row15->layout = [' col-sm-4',' col-sm-4'];

        $row16 = $this->form->addFields([$tab_63f8add6af43d]);
        $row16->layout = [' col-sm-12'];

        $row17 = $this->form->addFields([$label17,$text17]);
        $row17->layout = [' col-sm-12'];

        $row18 = $this->form->addFields([$label24,$text24]);
        $row18->layout = ['col-sm-6'];

        $row19 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row20 = $this->form->addFields([$label11,$text11],[$label15,$text15],[$label12,$text12],[$label16,$text16]);
        $row20->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Fiscal");
        $row21 = $this->form->addFields([$label13,$text13],[$label14,$text14]);
        $row21->layout = [' col-sm-6','col-sm-6'];

        $row22 = $this->form->addFields([$label7,$text7]);
        $row22->layout = [' col-sm-12'];

        $this->form->appendPage("Foto e Especificação");
        $row23 = $this->form->addFields([$label10,$image1]);
        $row23->layout = [' col-sm-6'];

        $row24 = $this->form->addFields([$label20,$text20]);
        $row24->layout = [' col-sm-12'];

        $row25 = $this->form->addFields([$label21,$text21]);
        $row25->layout = [' col-sm-12'];

        $this->form->appendPage("Regras por Filial");

        $this->produto_filial_produto_id_list = new TQuickGrid;
        $this->produto_filial_produto_id_list->disableHtmlConversion();
        $this->produto_filial_produto_id_list->style = 'width:100%';
        $this->produto_filial_produto_id_list->disableDefaultClick();

        $column_system_unit_name = $this->produto_filial_produto_id_list->addQuickColumn("Filial", 'system_unit->name', 'left');
        $column_preco_venda_transformed = $this->produto_filial_produto_id_list->addQuickColumn("Preço Venda", 'preco_venda', 'left');
        $column_valor_custo_transformed = $this->produto_filial_produto_id_list->addQuickColumn("Valor Custo", 'valor_custo', 'left');
        $column_estoque_minimo_transformed = $this->produto_filial_produto_id_list->addQuickColumn("Estoque Minimo", 'estoque_minimo', 'left');
        $column_estoque_maximo_transformed = $this->produto_filial_produto_id_list->addQuickColumn("Estoque Máximo", 'estoque_maximo', 'left');
        $column_alterado_em_transformed = $this->produto_filial_produto_id_list->addQuickColumn("Alterado Em", 'alterado_em', 'left');

        $column_preco_venda_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_valor_custo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_estoque_minimo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_estoque_maximo_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_alterado_em_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!empty(trim($value)))
            {
                try
                {
                    $date = new DateTime($value);
                    return $date->format('d/m/Y H:i');
                }
                catch (Exception $e)
                {
                    return $value;
                }
            }
        });

        $this->produto_filial_produto_id_list->createModel();

        $criteria_produto_filial_produto_id = new TCriteria();
        $criteria_produto_filial_produto_id->add(new TFilter('produto_id', '=', $produto->id));

        $criteria_produto_filial_produto_id->setProperty('order', 'id desc');

        $produto_filial_produto_id_items = ProdutoFilial::getObjects($criteria_produto_filial_produto_id);

        $this->produto_filial_produto_id_list->addItems($produto_filial_produto_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->produto_filial_produto_id_list));

        $this->form->addContent([$panel]);

        $this->form->appendPage("Fornecedores");

        $this->produto_fornecedor_produto_id_list = new TQuickGrid;
        $this->produto_fornecedor_produto_id_list->disableHtmlConversion();
        $this->produto_fornecedor_produto_id_list->style = 'width:100%';
        $this->produto_fornecedor_produto_id_list->disableDefaultClick();

        $column_fornecedor_nome = $this->produto_fornecedor_produto_id_list->addQuickColumn("Fornecedor", 'fornecedor->nome', 'left');
        $column_codigo_fornecedor = $this->produto_fornecedor_produto_id_list->addQuickColumn("Cód. Fornecedor", 'codigo_fornecedor', 'left');
        $column_descricao_produto_fornecedor = $this->produto_fornecedor_produto_id_list->addQuickColumn("Descrição do Produto no Fornecedor", 'descricao_produto_fornecedor', 'left');
        $column_tempo_medio_fornecimento = $this->produto_fornecedor_produto_id_list->addQuickColumn("Tempo médio fornecimento", 'tempo_medio_fornecimento', 'left');
        $column_quantidade_minima_compra = $this->produto_fornecedor_produto_id_list->addQuickColumn("Qtde. mínima para compra", 'quantidade_minima_compra', 'left');
        $column_preco_venda_transformed1 = $this->produto_fornecedor_produto_id_list->addQuickColumn("Preço de Venda", 'preco_venda', 'left');

        $column_preco_venda_transformed1->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->produto_fornecedor_produto_id_list->createModel();

        $criteria_produto_fornecedor_produto_id = new TCriteria();
        $criteria_produto_fornecedor_produto_id->add(new TFilter('produto_id', '=', $produto->id));

        $criteria_produto_fornecedor_produto_id->setProperty('order', 'id desc');

        $produto_fornecedor_produto_id_items = ProdutoFornecedor::getObjects($criteria_produto_fornecedor_produto_id);

        $this->produto_fornecedor_produto_id_list->addItems($produto_fornecedor_produto_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->produto_fornecedor_produto_id_list));

        $this->form->addContent([$panel]);

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        if(!empty($param['current_tab_tab_63f8c76bd2388']))
        {
            $this->tab_63f8c76bd2388->setCurrentPage($param['current_tab_tab_63f8c76bd2388']);
        }
        if(!empty($param['current_tab_tab_63f8add6af43d']))
        {
            $this->tab_63f8add6af43d->setCurrentPage($param['current_tab_tab_63f8add6af43d']);
        }

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ProdutoFormView]');
        $style->width = '80% !important';   
        $style->show(true);

    }

    public function onShow($param = null)
    {     

    }

}

