<?php

class ProdutoIndicadoresForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_ProdutoIndicadoresForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("");

        $criteria_bind_qtd_total_vendas = new TCriteria();
        $criteria_bind_valor_total_vendido = new TCriteria();
        $criteria_bind_saldo_estoque = new TCriteria();

        if(!empty($param["produto_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_produto_id', $param["produto_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_produto_id');
        $criteria_bind_qtd_total_vendas->add(new TFilter('venda_item.produto_id', '=', $filterVar)); 
        if(!empty($param["produto_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_produto_id', $param["produto_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_produto_id');
        $criteria_bind_valor_total_vendido->add(new TFilter('venda_item.produto_id', '=', $filterVar)); 
        if(!empty($param["produto_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_produto_id', $param["produto_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_produto_id');
        $criteria_bind_saldo_estoque->add(new TFilter('estoque_saldos.produto_id', '=', $filterVar)); 

        $bind_qtd_total_vendas = new BIndicator('bind_qtd_total_vendas');
        $bind_valor_total_vendido = new BIndicator('bind_valor_total_vendido');
        $bind_saldo_estoque = new BIndicator('bind_saldo_estoque');


        $bind_qtd_total_vendas->setDatabase('kraftsoft');
        $bind_qtd_total_vendas->setFieldValue("venda_item.produto_id");
        $bind_qtd_total_vendas->setModel('VendaItem');
        $bind_qtd_total_vendas->setTotal('count');
        $bind_qtd_total_vendas->setColors('#1ABC9C', '#ffffff', '#16A085', '#ffffff');
        $bind_qtd_total_vendas->setTitle("quantidade vendida", '#ffffff', '20', '');
        $bind_qtd_total_vendas->setCriteria($criteria_bind_qtd_total_vendas);
        $bind_qtd_total_vendas->setIcon(new TImage('fas:shopping-basket #ffffff'));
        $bind_qtd_total_vendas->setValueSize("20");
        $bind_qtd_total_vendas->setValueColor("#ffffff", 'B');
        $bind_qtd_total_vendas->setSize('100%', 95);
        $bind_qtd_total_vendas->setLayout('horizontal', 'left');

        $bind_valor_total_vendido->setDatabase('kraftsoft');
        $bind_valor_total_vendido->setFieldValue("venda_item.valor_total");
        $bind_valor_total_vendido->setModel('VendaItem');
        $bind_valor_total_vendido->setTransformerValue(function($value)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });
        $bind_valor_total_vendido->setTotal('sum');
        $bind_valor_total_vendido->setColors('#3498DB', '#FFFFFF', '#2980B9', '#FFFFFF');
        $bind_valor_total_vendido->setTitle("valor total vendido", '#FFFFFF', '20', '');
        $bind_valor_total_vendido->setCriteria($criteria_bind_valor_total_vendido);
        $bind_valor_total_vendido->setIcon(new TImage('fas:dollar-sign #FFFFFF'));
        $bind_valor_total_vendido->setValueSize("20");
        $bind_valor_total_vendido->setValueColor("#FFFFFF", 'B');
        $bind_valor_total_vendido->setSize('100%', 95);
        $bind_valor_total_vendido->setLayout('horizontal', 'left');

        $bind_saldo_estoque->setDatabase('kraftsoft');
        $bind_saldo_estoque->setFieldValue("estoque_saldos.quant_disponivel");
        $bind_saldo_estoque->setModel('EstoqueSaldos');
        $bind_saldo_estoque->setTransformerValue(function($value)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });
        $bind_saldo_estoque->setTotal('sum');
        $bind_saldo_estoque->setColors('#9B59B6', '#FFFFFF', '#8E44AD', '#FFFFFF');
        $bind_saldo_estoque->setTitle("Saldo em estoque", '#FFFFFF', '20', '');
        $bind_saldo_estoque->setCriteria($criteria_bind_saldo_estoque);
        $bind_saldo_estoque->setIcon(new TImage('fas:boxes #FFFFFF'));
        $bind_saldo_estoque->setValueSize("20");
        $bind_saldo_estoque->setValueColor("#FFFFFF", 'B');
        $bind_saldo_estoque->setSize('100%', 95);
        $bind_saldo_estoque->setLayout('horizontal', 'left');


        TTransaction::open('kraftsoft');
        $repository = new TRepository('EstoqueSaldos');

        $criteria = new TCriteria();
        $criteria->add(new TFilter('produto_id', '=', $param['produto_id']));         
        $criteria->add(new TFilter('system_unit_id', '=', TSession::getValue('userunitid')));  

        $lista_estoquesaldo = $repository->load($criteria); 

        $quant_disponivel = 0;
        $quant_reservada = 0;
        $custo_medio = 0;
        $preco_medio = 0;
        $saldo_anterior = 0;

        foreach ($lista_estoquesaldo as $estoquesaldo)
        {
            $quant_disponivel += $estoquesaldo->quant_disponivel;
            $quant_reservada += $estoquesaldo->quant_reservada;   

            // $custo_medio += $estoquesaldo->preco_medio_custo;               

             if ($preco_medio==0)
             {
                $preco_medio += $estoquesaldo->preco_medio_venda;                           
             }
        }

        TTransaction::close();  

        $bind_saldo_estoque->setModel('EstoqueSaldos');
        $bind_saldo_estoque->setCriteria($criteria);
        $bind_saldo_estoque->setTotal('sum');

        //$this->belement_saldo_estoque->add("<span class='label' style='background-color:{#FFF}'>{$quant_disponivel}</span>");

        $row1 = $this->form->addFields([$bind_qtd_total_vendas],[$bind_valor_total_vendido]);
        $row1->layout = ['col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([$bind_saldo_estoque],[]);
        $row2->layout = ['col-sm-6',' col-sm-6'];

        $searchData = $this->form->getData();
        $this->form->setData($searchData);

        BChart::generate($bind_qtd_total_vendas, $bind_valor_total_vendido, $bind_saldo_estoque);

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Produto","Indicadores de Produto"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onShow($param = null)
    {               

    } 

}

