<?php

class ServicoFichaTecnicaForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'ProdutoFichaTecnica';
    private static $primaryKey = 'id';
    private static $formName = 'form_ServicoFichaTecnicaForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de ficha técnica de serviço");


        $id = new TEntry('id');
        $produto_id = new TDBCombo('produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc'  );
        $descricao = new TEntry('descricao');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $custo_total = new TNumeric('custo_total', '2', ',', '.' );
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id = new TDBCombo('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id', 'kraftsoft', 'Funcionario', 'id', '{nome}','nome asc'  );
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id = new THidden('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id');
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora = new TNumeric('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora', '2', ',', '.' );
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade = new TNumeric('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade', '2', ',', '.' );
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total = new TNumeric('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total', '2', ',', '.' );
        $button_adicionar_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica = new TButton('button_adicionar_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica');
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id = new TDBCombo('produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id', 'kraftsoft', 'DespesasServicos', 'id', '{descricao}','descricao asc'  );
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_id = new THidden('produto_ficha_tecnica_despesas_produto_ficha_tecnica_id');
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario = new TNumeric('produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario', '2', ',', '.' );
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade = new TNumeric('produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade', '2', ',', '.' );
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total = new TNumeric('produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total', '2', ',', '.' );
        $button_adicionar_produto_ficha_tecnica_despesas_produto_ficha_tecnica = new TButton('button_adicionar_produto_ficha_tecnica_despesas_produto_ficha_tecnica');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade->setExitAction(new TAction([$this,'onExitQuantidadeMaoDeObra']));
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade->setExitAction(new TAction([$this,'onExitQuantidadeDespesa']));

        $produto_id->addValidation("Servico id", new TRequiredValidator()); 
        $descricao->addValidation("Descrição", new TRequiredValidator()); 
        $system_unit_id->addValidation("Filial", new TRequiredValidator()); 

        $button_adicionar_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica->setAction(new TAction([$this, 'onAddDetailProdutoFichaTecnicaMaoObraProdutoFichaTecnica'],['static' => 1]), "Adicionar");
        $button_adicionar_produto_ficha_tecnica_despesas_produto_ficha_tecnica->setAction(new TAction([$this, 'onAddDetailProdutoFichaTecnicaDespesasProdutoFichaTecnica'],['static' => 1]), "Adicionar");

        $button_adicionar_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica->addStyleClass('btn-default');
        $button_adicionar_produto_ficha_tecnica_despesas_produto_ficha_tecnica->addStyleClass('btn-default');

        $button_adicionar_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica->setImage('fas:plus #2ecc71');
        $button_adicionar_produto_ficha_tecnica_despesas_produto_ficha_tecnica->setImage('fas:plus #2ecc71');

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $produto_id->enableSearch();
        $system_unit_id->enableSearch();
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id->enableSearch();
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id->enableSearch();

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $produto_id->setEditable(false);
        $criado_por->setEditable(false);
        $custo_total->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total->setEditable(false);
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total->setEditable(false);

        $id->setSize(100);
        $criado_em->setSize(150);
        $alterado_em->setSize(150);
        $descricao->setSize('100%');
        $produto_id->setSize('100%');
        $criado_por->setSize('100%');
        $custo_total->setSize('100%');
        $alterado_por->setSize('100%');
        $system_unit_id->setSize('100%');
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id->setSize(200);
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_id->setSize(200);
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora->setSize('100%');
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade->setSize('100%');
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade->setSize('100%');
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total->setSize('100%');
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total->setSize('100%');
        $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id->setSize('100%');
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario->setSize('100%');
        $produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id->setSize('100%');

        $button_adicionar_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica->id = '640107b5e3515';
        $button_adicionar_produto_ficha_tecnica_despesas_produto_ficha_tecnica->id = '64009240440d6';

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Serviço:", '#ff0000', '14px', null, '100%'),$produto_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao],[new TLabel("Filial:", '#FF0000', '14px', null),$system_unit_id]);
        $row2->layout = ['col-sm-6',' col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Custo Total:", null, '14px', null, '100%'),$custo_total]);
        $row3->layout = ['col-sm-6'];

        $tab_63c916ba301a9 = new BootstrapFormBuilder('tab_63c916ba301a9');
        $this->tab_63c916ba301a9 = $tab_63c916ba301a9;
        $tab_63c916ba301a9->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63c916ba301a9->appendPage("Mão de obra");

        $tab_63c916ba301a9->addFields([new THidden('current_tab_tab_63c916ba301a9')]);
        $tab_63c916ba301a9->setTabFunction("$('[name=current_tab_tab_63c916ba301a9]').val($(this).attr('data-current_page'));");

        $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica = new BootstrapFormBuilder('detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica');
        $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica->setProperty('class', 'form-horizontal builder-detail-form');

        $row4 = $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica->addFields([new TLabel("Funcionario:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id,$produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id],[new TLabel("Valor Hora:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade],[new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica->addFields([$button_adicionar_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica->addFields([new THidden('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__id')]);
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_criteria = new TCriteria();

        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->disableHtmlConversion();;
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->generateHiddenFields();
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->setId('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list');

        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->style = 'width:100%';
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->class .= ' table-bordered';

        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_nome = new TDataGridColumn('funcionario->nome', "Funcionario", 'left');
        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora_transformed = new TDataGridColumn('valor_hora', "Valor Hora", 'left');
        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade_transformed = new TDataGridColumn('quantidade', "Quantidade", 'left');
        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total_transformed = new TDataGridColumn('valor_total', "Valor Total", 'left');

        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__data->setVisibility(false);

        $action_onEditDetailProdutoFichaTecnicaMaoObra = new TDataGridAction(array('ServicoFichaTecnicaForm', 'onEditDetailProdutoFichaTecnicaMaoObra'));
        $action_onEditDetailProdutoFichaTecnicaMaoObra->setUseButton(false);
        $action_onEditDetailProdutoFichaTecnicaMaoObra->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailProdutoFichaTecnicaMaoObra->setLabel("Editar");
        $action_onEditDetailProdutoFichaTecnicaMaoObra->setImage('far:edit #478fca');
        $action_onEditDetailProdutoFichaTecnicaMaoObra->setFields(['__row__id', '__row__data']);

        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addAction($action_onEditDetailProdutoFichaTecnicaMaoObra);
        $action_onDeleteDetailProdutoFichaTecnicaMaoObra = new TDataGridAction(array('ServicoFichaTecnicaForm', 'onDeleteDetailProdutoFichaTecnicaMaoObra'));
        $action_onDeleteDetailProdutoFichaTecnicaMaoObra->setUseButton(false);
        $action_onDeleteDetailProdutoFichaTecnicaMaoObra->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailProdutoFichaTecnicaMaoObra->setLabel("Excluir");
        $action_onDeleteDetailProdutoFichaTecnicaMaoObra->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailProdutoFichaTecnicaMaoObra->setFields(['__row__id', '__row__data']);

        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addAction($action_onDeleteDetailProdutoFichaTecnicaMaoObra);

        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_nome);
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora_transformed);
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade_transformed);
        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total_transformed);

        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__data);

        $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list);
        $this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica->addContent([$tableResponsiveDiv]);

        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row8 = $tab_63c916ba301a9->addFields([$this->detailFormProdutoFichaTecnicaMaoObraProdutoFichaTecnica]);
        $row8->layout = [' col-sm-12'];

        $tab_63c916ba301a9->appendPage("Despesas");

        $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica = new BootstrapFormBuilder('detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica');
        $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica->setProperty('class', 'form-horizontal builder-detail-form');

        $row9 = $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica->addFields([new TLabel("Despesas serviços:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id,$produto_ficha_tecnica_despesas_produto_ficha_tecnica_id],[new TLabel("Valor Unitário:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario]);
        $row9->layout = ['col-sm-6','col-sm-6'];

        $row10 = $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade],[new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica->addFields([$button_adicionar_produto_ficha_tecnica_despesas_produto_ficha_tecnica]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica->addFields([new THidden('produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__id')]);
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_criteria = new TCriteria();

        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->disableHtmlConversion();;
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->generateHiddenFields();
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->setId('produto_ficha_tecnica_despesas_produto_ficha_tecnica_list');

        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->style = 'width:100%';
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->class .= ' table-bordered';

        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_descricao = new TDataGridColumn('despesas_servicos->descricao', "Despesas servicos", 'left');
        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario_transformed = new TDataGridColumn('valor_unitario', "Valor Unitário", 'left');
        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade_transformed = new TDataGridColumn('quantidade', "Quantidade", 'left');
        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total_transformed = new TDataGridColumn('valor_total', "Valor Total", 'left');

        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__data->setVisibility(false);

        $action_onEditDetailProdutoFichaTecnicaDespesas = new TDataGridAction(array('ServicoFichaTecnicaForm', 'onEditDetailProdutoFichaTecnicaDespesas'));
        $action_onEditDetailProdutoFichaTecnicaDespesas->setUseButton(false);
        $action_onEditDetailProdutoFichaTecnicaDespesas->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailProdutoFichaTecnicaDespesas->setLabel("Editar");
        $action_onEditDetailProdutoFichaTecnicaDespesas->setImage('far:edit #478fca');
        $action_onEditDetailProdutoFichaTecnicaDespesas->setFields(['__row__id', '__row__data']);

        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addAction($action_onEditDetailProdutoFichaTecnicaDespesas);
        $action_onDeleteDetailProdutoFichaTecnicaDespesas = new TDataGridAction(array('ServicoFichaTecnicaForm', 'onDeleteDetailProdutoFichaTecnicaDespesas'));
        $action_onDeleteDetailProdutoFichaTecnicaDespesas->setUseButton(false);
        $action_onDeleteDetailProdutoFichaTecnicaDespesas->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailProdutoFichaTecnicaDespesas->setLabel("Excluir");
        $action_onDeleteDetailProdutoFichaTecnicaDespesas->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailProdutoFichaTecnicaDespesas->setFields(['__row__id', '__row__data']);

        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addAction($action_onDeleteDetailProdutoFichaTecnicaDespesas);

        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_descricao);
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario_transformed);
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade_transformed);
        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total_transformed);

        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addColumn($column_produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__data);

        $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list);
        $this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica->addContent([$tableResponsiveDiv]);

        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row13 = $tab_63c916ba301a9->addFields([$this->detailFormProdutoFichaTecnicaDespesasProdutoFichaTecnica]);
        $row13->layout = [' col-sm-12'];

        $row14 = $this->form->addFields([$tab_63c916ba301a9]);
        $row14->layout = ['col-sm-12'];

        $bcontainer_63c808079baf5 = new BContainer('bcontainer_63c808079baf5');
        $this->bcontainer_63c808079baf5 = $bcontainer_63c808079baf5;

        $bcontainer_63c808079baf5->setTitle("Histórico de Atualizações", '#333', '18px', '', '#fff');
        $bcontainer_63c808079baf5->setBorderColor('#c0c0c0');

        $row15 = $bcontainer_63c808079baf5->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row15->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row16 = $this->form->addFields([$bcontainer_63c808079baf5]);
        $row16->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btnAtualizaCustoFichaTecnica = $this->form->addAction("Atualizar custo da ficha técnica", new TAction([$this, 'onAtualizarCustoFichaTecnica']), 'fas:calculator #FFFFFF');
        $this->btnAtualizaCustoFichaTecnica = $btnAtualizaCustoFichaTecnica;
        $btnAtualizaCustoFichaTecnica->addStyleClass('btn-success'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        //desabilitando o botao de calcular por não conseguir atualizar o grid em tela...
        TScript::create('document.getElementById("tbutton_btn_atualizar_custo_da_ficha_técnica").style.display = "none";');

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=ServicoFichaTecnicaForm]');
        $style->width = '80% !important';   
        $style->show(true);

    }

    public static function onExitQuantidadeMaoDeObra($param = null) 
    {
        try 
        {
            //code here
            $qtdmaodeobra = (double) str_replace(',','.', str_replace('.','', $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade']));
            $valorhoramaodeobra = (double) str_replace(',','.', str_replace('.','', $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora']));

            $valortotalmaodeobra = $qtdmaodeobra * $valorhoramaodeobra;

            $object = new stdClass();
            $object->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total = number_format($valortotalmaodeobra, 2,',','.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitQuantidadeDespesa($param = null) 
    {
        try 
        {
            //code here
            $qtddespesa = (double) str_replace(',','.',str_replace('.','',$param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade']));
            $valorunitdespesa = (double) str_replace(',','.',str_replace('.','',$param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario']));

            $valortotaldespesa = $qtddespesa * $valorunitdespesa;

            $object = new stdClass();
            $object->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total = number_format($valortotaldespesa, 2,',','.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailProdutoFichaTecnicaMaoObraProdutoFichaTecnica($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Funcionario id", 'name'=>"produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Hora", 'name'=>"produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Quantidade", 'name'=>"produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Total", 'name'=>"produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__id) ? $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ProdutoFichaTecnicaMaoObra();
            $grid_data->__row__id = $__row__id;
            $grid_data->funcionario_id = $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id;
            $grid_data->id = $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id;
            $grid_data->valor_hora = $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora;
            $grid_data->quantidade = $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade;
            $grid_data->valor_total = $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['funcionario_id'] =  $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id'] ?? null;
            $__row__data['__display__']['valor_hora'] =  $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade'] ?? null;
            $__row__data['__display__']['valor_total'] =  $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#640107b5e3515');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailProdutoFichaTecnicaDespesasProdutoFichaTecnica($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Despesas servicos id", 'name'=>"produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Unitário", 'name'=>"produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Quantidade", 'name'=>"produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Total", 'name'=>"produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__id) ? $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new ProdutoFichaTecnicaDespesas();
            $grid_data->__row__id = $__row__id;
            $grid_data->despesas_servicos_id = $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id;
            $grid_data->id = $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_id;
            $grid_data->valor_unitario = $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario;
            $grid_data->quantidade = $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade;
            $grid_data->valor_total = $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['despesas_servicos_id'] =  $param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_id'] ?? null;
            $__row__data['__display__']['valor_unitario'] =  $param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade'] ?? null;
            $__row__data['__display__']['valor_total'] =  $param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('produto_ficha_tecnica_despesas_produto_ficha_tecnica_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_id = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#64009240440d6');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailProdutoFichaTecnicaMaoObra($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id = $__row__data->__display__->funcionario_id ?? null;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id = $__row__data->__display__->id ?? null;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora = $__row__data->__display__->valor_hora ?? null;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total = $__row__data->__display__->valor_total ?? null;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#640107b5e3515');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailProdutoFichaTecnicaMaoObra($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_funcionario_id = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_id = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_hora = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_valor_total = '';
            $data->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailProdutoFichaTecnicaDespesas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id = $__row__data->__display__->despesas_servicos_id ?? null;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_id = $__row__data->__display__->id ?? null;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario = $__row__data->__display__->valor_unitario ?? null;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total = $__row__data->__display__->valor_total ?? null;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#64009240440d6');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailProdutoFichaTecnicaDespesas($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_despesas_servicos_id = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_id = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_unitario = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica_valor_total = '';
            $data->produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('produto_ficha_tecnica_despesas_produto_ficha_tecnica_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new ProdutoFichaTecnica(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            $custototal = 0;

            if(!empty($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data']))
            {
                $rowId = $param['produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id'];
                foreach($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data'] as $rowDataCoded)
                {
                    $rowDataDecoded = unserialize(base64_decode($rowDataCoded));    

                    $custototal += $rowDataDecoded->valor_total;

                    $rowDataDecoded->__row__id;
                }
            }

            $object->custo_total = $custototal;

            if(!empty($param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list___row__data']))
            {
                $rowId = $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica__row__id'];

                foreach($param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list___row__data'] as $rowDataCoded)
                {
                    $rowDataDecoded = unserialize(base64_decode($rowDataCoded));

                    $custototal += $rowDataDecoded->valor_total;

                    $rowDataDecoded->__row__id;
                }
            }

            $object->custo_total = $custototal;

            if(!empty($param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_list___row__data']))
            {
                $rowId = $param['produto_ficha_tecnica_despesas_produto_ficha_tecnica__row__id'];

                foreach($param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_list___row__data'] as $rowDataCoded)
                {
                    $rowDataDecoded = unserialize(base64_decode($rowDataCoded));

                    $custototal += $rowDataDecoded->valor_total;

                    $rowDataDecoded->__row__id;
                }
            }

            $object->custo_total = $custototal;

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_items = $this->storeMasterDetailItems('ProdutoFichaTecnicaMaoObra', 'produto_ficha_tecnica_id', 'produto_ficha_tecnica_mao_obra_produto_ficha_tecnica', $object, $param['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list___row__data'] ?? [], $this->form, $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_criteria); 

            $produto_ficha_tecnica_despesas_produto_ficha_tecnica_items = $this->storeMasterDetailItems('ProdutoFichaTecnicaDespesas', 'produto_ficha_tecnica_id', 'produto_ficha_tecnica_despesas_produto_ficha_tecnica', $object, $param['produto_ficha_tecnica_despesas_produto_ficha_tecnica_list___row__data'] ?? [], $this->form, $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('ServicoFichaTecnicaHeaderList', 'onShow', $loadPageParam); 

                        TScript::create("Template.closeRightPanel();"); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onAtualizarCustoFichaTecnica($param = null) 
    {
        try 
        {

            if(!empty($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data']))
            {
                TTransaction::open(self::$database);
                $custo_total = 0;
                $filialid = $param['system_unit_id'];

                $rowId = $param['produto_ficha_tecnica_itens_produto_ficha_tecnica__row__id'];
                foreach($param['produto_ficha_tecnica_itens_produto_ficha_tecnica_list___row__data'] as $rowDataCoded)
                {
                    $rowDataDecoded = unserialize(base64_decode($rowDataCoded));    
                    $rowDataDecoded->produto_id;

                    //trazer o preço da filial..
                    $produtofilial = ProdutoFilial::where('produto_id', '=', $rowDataDecoded->produto_id)
                                                  ->where('system_unit_id', '=', $filialid)
                                                  ->first();

                    if($produtofilial)
                    {                        
                        $rowDataDecoded->valor_custo = number_format($produtofilial->valor_custo, 2, ',', '.');
                    }

                    $rowDataDecoded->quantidade;
                    $rowDataDecoded->valor_total = $rowDataDecoded->quantidade * $rowDataDecoded->valor_custo;

                    $rowDataDecoded->__row__id;

                    TDataGrid::replaceRowById('produto_ficha_tecnica_itens_produto_ficha_tecnica_list', $rowDataDecoded->__row__id, $rowId);                    

                }

                TTransaction::close();

                // $object = new stdClass();

                // TForm::sendData(self::$formName, $object);        
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new ProdutoFichaTecnica($key); // instantiates the Active Record 

                $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_items = $this->loadMasterDetailItems('ProdutoFichaTecnicaMaoObra', 'produto_ficha_tecnica_id', 'produto_ficha_tecnica_mao_obra_produto_ficha_tecnica', $object, $this->form, $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_list, $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $produto_ficha_tecnica_despesas_produto_ficha_tecnica_items = $this->loadMasterDetailItems('ProdutoFichaTecnicaDespesas', 'produto_ficha_tecnica_id', 'produto_ficha_tecnica_despesas_produto_ficha_tecnica', $object, $this->form, $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_list, $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

       $obj = new Stdclass();
       $obj->produto_id = TSession::getValue('servicolist_id');
       $obj->system_unit_id = TSession::getValue('userunitid');
       TForm::sendData(self::$formName, $obj);

    }

    public function onShow($param = null)
    {

       $obj = new Stdclass();
       $obj->produto_id = TSession::getValue('servicolist_id');
       $obj->system_unit_id = TSession::getValue('userunitid');
       $obj->produto_ficha_tecnica_despesas_produto_ficha_tecnica_quantidade = 1;
       $obj->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_quantidade = 1;
       TForm::sendData(self::$formName, $obj);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

