<?php

class TabelaPrecoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'TabelaPreco';
    private static $primaryKey = 'id';
    private static $formName = 'form_TabelaPrecoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Tabela de Preço");

        $criteria_tabela_preco_produto_tabela_preco_produto_filial_id = new TCriteria();

        $filterVar = 'NULL';
        $criteria_tabela_preco_produto_tabela_preco_produto_filial_id->add(new TFilter('produto_id', 'in', "(SELECT id FROM produto WHERE deletado_em is {$filterVar})")); 

        $criteria_tabela_preco_produto_tabela_preco_produto_filial_id = new TCriteria();

        $criteria_tabela_preco_produto_tabela_preco_produto_filial_id->add(new TFilter('produto_id', 'in', "(SELECT id FROM produto WHERE deletado_em is NULL )")); 

        $id = new TEntry('id');
        $tabela_preco_tipo_id = new TDBCombo('tabela_preco_tipo_id', 'kraftsoft', 'TabelaPrecoTipo', 'id', '{descricao}','descricao asc'  );
        $tabela_preco_tipo_alteracao_id = new TDBCombo('tabela_preco_tipo_alteracao_id', 'kraftsoft', 'TabelaPrecoTipoAlteracao', 'id', '{descricao}','descricao asc'  );
        $descricao = new TEntry('descricao');
        $data_hora_promocao_inicial = new TDateTime('data_hora_promocao_inicial');
        $data_hora_promocao_final = new TDateTime('data_hora_promocao_final');
        $observacao = new TText('observacao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $tabela_preco_produto_tabela_preco_produto_filial_id = new TDBCombo('tabela_preco_produto_tabela_preco_produto_filial_id', 'kraftsoft', 'ProdutoFilial', 'id', '{produto_id}  - {produto->nome}  / Filial: {system_unit->name}','produto_id asc' , $criteria_tabela_preco_produto_tabela_preco_produto_filial_id );
        $tabela_preco_produto_tabela_preco_id = new THidden('tabela_preco_produto_tabela_preco_id');
        $preco_venda_prod = new TNumeric('preco_venda_prod', '2', ',', '.', true, true );
        $tabela_preco_produto_tabela_preco_valor_parametro = new TNumeric('tabela_preco_produto_tabela_preco_valor_parametro', '2', ',', '.' );
        $tabela_preco_produto_tabela_preco_preco_venda = new TNumeric('tabela_preco_produto_tabela_preco_preco_venda', '2', ',', '.' );
        $button_adicionar_tabela_preco_produto_tabela_preco = new TButton('button_adicionar_tabela_preco_produto_tabela_preco');
        $lista_clientes_tabela = new BPageContainer();

        $tabela_preco_produto_tabela_preco_produto_filial_id->setChangeAction(new TAction([$this,'onExitProdutoFilial']));

        $tabela_preco_produto_tabela_preco_valor_parametro->setExitAction(new TAction([$this,'onExitValorParametro']));

        $tabela_preco_tipo_id->addValidation("Tipo tabela", new TRequiredValidator()); 
        $descricao->addValidation("Descrição", new TRequiredValidator()); 

        $tabela_preco_tipo_id->setValue(TabelaPrecoTipo::Permanente);
        $button_adicionar_tabela_preco_produto_tabela_preco->addStyleClass('btn-default');
        $button_adicionar_tabela_preco_produto_tabela_preco->setImage('fas:plus #2ecc71');
        $lista_clientes_tabela->setId('b6324d80b0fff2');
        $lista_clientes_tabela->hide();
        $lista_clientes_tabela->setAction(new TAction(['TabelaPrecoClienteSimpleList', 'onShow']));
        $button_adicionar_tabela_preco_produto_tabela_preco->setAction(new TAction([$this, 'onAddDetailTabelaPrecoProdutoTabelaPreco'],['static' => 1]), "Adicionar");

        $tabela_preco_tipo_id->enableSearch();
        $tabela_preco_tipo_alteracao_id->enableSearch();
        $tabela_preco_produto_tabela_preco_produto_filial_id->enableSearch();

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_hora_promocao_final->setMask('dd/mm/yyyy hh:ii');
        $data_hora_promocao_inicial->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_hora_promocao_final->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_hora_promocao_inicial->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $preco_venda_prod->setEditable(false);
        $tabela_preco_produto_tabela_preco_preco_venda->setEditable(false);

        $id->setSize('100%');
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $observacao->setSize('100%', 70);
        $preco_venda_prod->setSize('100%');
        $tabela_preco_tipo_id->setSize('100%');
        $lista_clientes_tabela->setSize('100%');
        $data_hora_promocao_final->setSize('100%');
        $data_hora_promocao_inicial->setSize('100%');
        $tabela_preco_tipo_alteracao_id->setSize('100%');
        $tabela_preco_produto_tabela_preco_id->setSize(200);
        $tabela_preco_produto_tabela_preco_preco_venda->setSize('100%');
        $tabela_preco_produto_tabela_preco_valor_parametro->setSize('100%');
        $tabela_preco_produto_tabela_preco_produto_filial_id->setSize('100%');

        $button_adicionar_tabela_preco_produto_tabela_preco->id = '630b7ba31000a';

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $lista_clientes_tabela->add($loadingContainer);

        $this->lista_clientes_tabela = $lista_clientes_tabela;

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Tipo tabela:", '#FF0000', '14px', null, '100%'),$tabela_preco_tipo_id]);
        $row1->layout = [' col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Tipo de alteração:", '#FF0000', '14px', null),$tabela_preco_tipo_alteracao_id],[new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-6',' col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Data promoção inicial:", null, '14px', null, '100%'),$data_hora_promocao_inicial],[new TLabel("Data promoção final:", null, '14px', null, '100%'),$data_hora_promocao_final]);
        $row3->layout = [' col-sm-6',' col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Observações:", null, '14px', null, '100%'),$observacao]);
        $row4->layout = [' col-sm-12'];

        $bcontainer_630a78c9ee9e6 = new BContainer('bcontainer_630a78c9ee9e6');
        $this->bcontainer_630a78c9ee9e6 = $bcontainer_630a78c9ee9e6;

        $bcontainer_630a78c9ee9e6->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_630a78c9ee9e6->setBorderColor('#c0c0c0');

        $row5 = $bcontainer_630a78c9ee9e6->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row5->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row6 = $this->form->addFields([$bcontainer_630a78c9ee9e6]);
        $row6->layout = [' col-sm-12'];

        $this->form->appendPage("Produtos");

        $this->detailFormTabelaPrecoProdutoTabelaPreco = new BootstrapFormBuilder('detailFormTabelaPrecoProdutoTabelaPreco');
        $this->detailFormTabelaPrecoProdutoTabelaPreco->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormTabelaPrecoProdutoTabelaPreco->setProperty('class', 'form-horizontal builder-detail-form');

        $row7 = $this->detailFormTabelaPrecoProdutoTabelaPreco->addFields([new TLabel("Produto / Filial:", '#ff0000', '14px', null, '100%'),$tabela_preco_produto_tabela_preco_produto_filial_id,$tabela_preco_produto_tabela_preco_id],[new TLabel("Preço Venda Produto:", null, '14px', null),$preco_venda_prod]);
        $row7->layout = ['col-sm-6','col-sm-6'];

        $row8 = $this->detailFormTabelaPrecoProdutoTabelaPreco->addFields([new TLabel("Valor Parâmetro:", '#ff0000', '14px', null, '100%'),$tabela_preco_produto_tabela_preco_valor_parametro],[new TLabel("Preço Venda Tabela:", '#ff0000', '14px', null, '100%'),$tabela_preco_produto_tabela_preco_preco_venda]);
        $row8->layout = ['col-sm-6',' col-sm-6'];

        $row9 = $this->detailFormTabelaPrecoProdutoTabelaPreco->addFields([$button_adicionar_tabela_preco_produto_tabela_preco]);
        $row9->layout = [' col-sm-12'];

        $row10 = $this->detailFormTabelaPrecoProdutoTabelaPreco->addFields([new THidden('tabela_preco_produto_tabela_preco__row__id')]);
        $this->tabela_preco_produto_tabela_preco_criteria = new TCriteria();

        $this->tabela_preco_produto_tabela_preco_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->tabela_preco_produto_tabela_preco_list->disableHtmlConversion();;
        $this->tabela_preco_produto_tabela_preco_list->generateHiddenFields();
        $this->tabela_preco_produto_tabela_preco_list->setId('tabela_preco_produto_tabela_preco_list');

        $this->tabela_preco_produto_tabela_preco_list->style = 'width:100%';
        $this->tabela_preco_produto_tabela_preco_list->class .= ' table-bordered';

        $column_tabela_preco_produto_tabela_preco_produto_filial_produto_id = new TDataGridColumn('produto_filial->produto_id', "Id Produto", 'left');
        $column_tabela_preco_produto_tabela_preco_produto_filial_produto_nome = new TDataGridColumn('produto_filial->produto->nome', "Produto ", 'left');
        $column_tabela_preco_produto_tabela_preco_produto_filial_system_unit_name = new TDataGridColumn('produto_filial->system_unit->name', "Filial", 'left');
        $column_tabela_preco_produto_tabela_preco_produto_filial_preco_venda_transformed = new TDataGridColumn('produto_filial->preco_venda', "Preço Venda Produto", 'left');
        $column_tabela_preco_produto_tabela_preco_valor_parametro_transformed = new TDataGridColumn('valor_parametro', "Valor Parâmetro", 'left');
        $column_tabela_preco_produto_tabela_preco_preco_venda_transformed = new TDataGridColumn('preco_venda', "Preço Venda Tabela", 'left');

        $column_tabela_preco_produto_tabela_preco__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_tabela_preco_produto_tabela_preco__row__data->setVisibility(false);

        $action_onEditDetailTabelaPrecoProduto = new TDataGridAction(array('TabelaPrecoForm', 'onEditDetailTabelaPrecoProduto'));
        $action_onEditDetailTabelaPrecoProduto->setUseButton(false);
        $action_onEditDetailTabelaPrecoProduto->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailTabelaPrecoProduto->setLabel("Editar");
        $action_onEditDetailTabelaPrecoProduto->setImage('far:edit #478fca');
        $action_onEditDetailTabelaPrecoProduto->setFields(['__row__id', '__row__data']);

        $this->tabela_preco_produto_tabela_preco_list->addAction($action_onEditDetailTabelaPrecoProduto);
        $action_onDeleteDetailTabelaPrecoProduto = new TDataGridAction(array('TabelaPrecoForm', 'onDeleteDetailTabelaPrecoProduto'));
        $action_onDeleteDetailTabelaPrecoProduto->setUseButton(false);
        $action_onDeleteDetailTabelaPrecoProduto->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailTabelaPrecoProduto->setLabel("Excluir");
        $action_onDeleteDetailTabelaPrecoProduto->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailTabelaPrecoProduto->setFields(['__row__id', '__row__data']);

        $this->tabela_preco_produto_tabela_preco_list->addAction($action_onDeleteDetailTabelaPrecoProduto);

        $this->tabela_preco_produto_tabela_preco_list->addColumn($column_tabela_preco_produto_tabela_preco_produto_filial_produto_id);
        $this->tabela_preco_produto_tabela_preco_list->addColumn($column_tabela_preco_produto_tabela_preco_produto_filial_produto_nome);
        $this->tabela_preco_produto_tabela_preco_list->addColumn($column_tabela_preco_produto_tabela_preco_produto_filial_system_unit_name);
        $this->tabela_preco_produto_tabela_preco_list->addColumn($column_tabela_preco_produto_tabela_preco_produto_filial_preco_venda_transformed);
        $this->tabela_preco_produto_tabela_preco_list->addColumn($column_tabela_preco_produto_tabela_preco_valor_parametro_transformed);
        $this->tabela_preco_produto_tabela_preco_list->addColumn($column_tabela_preco_produto_tabela_preco_preco_venda_transformed);

        $this->tabela_preco_produto_tabela_preco_list->addColumn($column_tabela_preco_produto_tabela_preco__row__data);

        $this->tabela_preco_produto_tabela_preco_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->tabela_preco_produto_tabela_preco_list);
        $this->detailFormTabelaPrecoProdutoTabelaPreco->addContent([$tableResponsiveDiv]);

        $column_tabela_preco_produto_tabela_preco_produto_filial_preco_venda_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_tabela_preco_produto_tabela_preco_valor_parametro_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_tabela_preco_produto_tabela_preco_preco_venda_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row11 = $this->form->addFields([$this->detailFormTabelaPrecoProdutoTabelaPreco]);
        $row11->layout = [' col-sm-12'];

        $this->form->appendPage("Clientes");
        $row12 = $this->form->addFields([$lista_clientes_tabela]);
        $row12->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['TabelaPrecoHeaderList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Produto","Cadastro de Tabela de Preço"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitValorParametro($param = null) 
    {
        try 
        {
            if (isset($param['tabela_preco_produto_tabela_preco_produto_filial_id']) && $param['tabela_preco_produto_tabela_preco_produto_filial_id'])
            {
              $object = new stdClass();
              $preco_venda = TabelaPreco::calcula_preco_tabela($param['tabela_preco_tipo_alteracao_id'],
                                                               $param['preco_venda_prod'],
                                                               $param['tabela_preco_produto_tabela_preco_valor_parametro']);

              $object->tabela_preco_produto_tabela_preco_preco_venda = number_format($preco_venda , 2, ',', '.'); 
              TForm::sendData(self::$formName, $object); 
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitProdutoFilial($param = null) 
    {
        try 
        {
            if (isset($param['tabela_preco_produto_tabela_preco_produto_filial_id']) && $param['tabela_preco_produto_tabela_preco_produto_filial_id'])
            {
                TTransaction::open(self::$database);

                $object = new stdClass();

                //trazer o preço da filial..
                $produtofilial = ProdutoFilial::where('id', '=', $param['tabela_preco_produto_tabela_preco_produto_filial_id'])->first();

                if($produtofilial)
                {
                    $object->preco_venda_prod = number_format($produtofilial->preco_venda, 2, ',', '.');    
                }

                TTransaction::close();                

                TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailTabelaPrecoProdutoTabelaPreco($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Produto filial id", 'name'=>"tabela_preco_produto_tabela_preco_produto_filial_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Parâmetro", 'name'=>"tabela_preco_produto_tabela_preco_valor_parametro", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Preço Venda", 'name'=>"tabela_preco_produto_tabela_preco_preco_venda", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->tabela_preco_produto_tabela_preco__row__id) ? $data->tabela_preco_produto_tabela_preco__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new TabelaPrecoProduto();
            $grid_data->__row__id = $__row__id;
            $grid_data->produto_filial_id = $data->tabela_preco_produto_tabela_preco_produto_filial_id;
            $grid_data->id = $data->tabela_preco_produto_tabela_preco_id;
            $grid_data->preco_venda_prod = $data->preco_venda_prod;
            $grid_data->valor_parametro = $data->tabela_preco_produto_tabela_preco_valor_parametro;
            $grid_data->preco_venda = $data->tabela_preco_produto_tabela_preco_preco_venda;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['produto_filial_id'] =  $param['tabela_preco_produto_tabela_preco_produto_filial_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['tabela_preco_produto_tabela_preco_id'] ?? null;
            $__row__data['__display__']['preco_venda_prod'] =  $param['preco_venda_prod'] ?? null;
            $__row__data['__display__']['valor_parametro'] =  $param['tabela_preco_produto_tabela_preco_valor_parametro'] ?? null;
            $__row__data['__display__']['preco_venda'] =  $param['tabela_preco_produto_tabela_preco_preco_venda'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->tabela_preco_produto_tabela_preco_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('tabela_preco_produto_tabela_preco_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->tabela_preco_produto_tabela_preco_produto_filial_id = '';
            $data->tabela_preco_produto_tabela_preco_id = '';
            $data->preco_venda_prod = '';
            $data->tabela_preco_produto_tabela_preco_valor_parametro = '';
            $data->tabela_preco_produto_tabela_preco_preco_venda = '';
            $data->tabela_preco_produto_tabela_preco__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#630b7ba31000a');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailTabelaPrecoProduto($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->tabela_preco_produto_tabela_preco_produto_filial_id = $__row__data->__display__->produto_filial_id ?? null;
            $data->tabela_preco_produto_tabela_preco_id = $__row__data->__display__->id ?? null;
            $data->preco_venda_prod = $__row__data->__display__->preco_venda_prod ?? null;
            $data->tabela_preco_produto_tabela_preco_valor_parametro = $__row__data->__display__->valor_parametro ?? null;
            $data->tabela_preco_produto_tabela_preco_preco_venda = $__row__data->__display__->preco_venda ?? null;
            $data->tabela_preco_produto_tabela_preco__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#630b7ba31000a');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailTabelaPrecoProduto($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->tabela_preco_produto_tabela_preco_produto_filial_id = '';
            $data->tabela_preco_produto_tabela_preco_id = '';
            $data->preco_venda_prod = '';
            $data->tabela_preco_produto_tabela_preco_valor_parametro = '';
            $data->tabela_preco_produto_tabela_preco_preco_venda = '';
            $data->tabela_preco_produto_tabela_preco__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('tabela_preco_produto_tabela_preco_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new TabelaPreco(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $tabela_preco_produto_tabela_preco_items = $this->storeMasterDetailItems('TabelaPrecoProduto', 'tabela_preco_id', 'tabela_preco_produto_tabela_preco', $object, $param['tabela_preco_produto_tabela_preco_list___row__data'] ?? [], $this->form, $this->tabela_preco_produto_tabela_preco_list, function($masterObject, $detailObject){ 

                //code here

               $produtofilial = ProdutoFilial::where('id', '=', $detailObject->produto_filial_id)->first();

                // echo 'produto filial id '.$detailObject->produto_filial_id;
                // echo '<br>';
                // echo 'tabela_preco_tipo_alteracao_id '.$masterObject->tabela_preco_tipo_alteracao_id;
                // echo '<br>';
                // echo 'produtofilial->produto->preco_venda '.$produtofilial->preco_venda;   
                // echo '<br>';
                // echo 'detailObject->valor_parametro '.$detailObject->valor_parametro;
                // echo '<br>';                

               $preco_venda = TabelaPreco::calcula_preco_tabela($masterObject->tabela_preco_tipo_alteracao_id,
                                                                $produtofilial->preco_venda,
                                                                $detailObject->valor_parametro);

               $detailObject->preco_venda = $preco_venda;

            }, $this->tabela_preco_produto_tabela_preco_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('TabelaPrecoHeaderList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new TabelaPreco($key); // instantiates the Active Record 

                TSession::setValue('tabela_preco_id', $object->id);

                                $this->lista_clientes_tabela->unhide();

                $tabela_preco_produto_tabela_preco_items = $this->loadMasterDetailItems('TabelaPrecoProduto', 'tabela_preco_id', 'tabela_preco_produto_tabela_preco', $object, $this->form, $this->tabela_preco_produto_tabela_preco_list, $this->tabela_preco_produto_tabela_preco_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

