<?php

class UnidadeMedidaFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'UnidadeMedida';
    private static $primaryKey = 'id';
    private static $formName = 'formView_UnidadeMedida';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $unidade_medida = new UnidadeMedida($param['key']);
        // define the form title
        $this->form->setFormTitle("Unidades de Medida");

        $label1 = new TLabel("Id:", '', '12px', '');
        $text1 = new TTextDisplay($unidade_medida->id, '', '12px', '');
        $label2 = new TLabel("Nome:", '', '12px', '');
        $text2 = new TTextDisplay($unidade_medida->nome, '', '12px', '');
        $label3 = new TLabel("Sigla:", '', '12px', '');
        $text3 = new TTextDisplay($unidade_medida->sigla, '', '12px', '');
        $label4 = new TLabel("Criado em:", '', '12px', '');
        $text4 = new TTextDisplay(TDateTime::convertToMask($unidade_medida->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '12px', '');
        $label6 = new TLabel("Criado Por:", '', '12px', '');
        $text6 = new TTextDisplay($unidade_medida->criado_por, '', '12px', '');
        $label5 = new TLabel("Alterado em:", '', '12px', '');
        $text5 = new TTextDisplay(TDateTime::convertToMask($unidade_medida->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '12px', '');
        $label7 = new TLabel("Alterado Por:", '', '12px', '');
        $text7 = new TTextDisplay($unidade_medida->alterado_por, '', '12px', '');


        $row1 = $this->form->addFields([$label1],[$text1]);
        $row2 = $this->form->addFields([$label2],[$text2]);
        $row3 = $this->form->addFields([$label3],[$text3]);
        $row4 = $this->form->addFields([$label4],[$text4]);
        $row5 = $this->form->addFields([$label6],[$text6]);
        $row6 = $this->form->addFields([$label5],[$text5]);
        $row7 = $this->form->addFields([$label7],[$text7]);

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Produto","Unidades de Medida"]));
        }
        $container->add($this->form);

        TTransaction::close();
        parent::add($container);

    }

    public function onShow($param = null)
    {     

    }

}

