<?php

class HotFix extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_HotFix';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Hot Fix (Exclusivo Admin Kraft)");


        $button_recalcular_custos_das_fichas_tecnicas_do_produto = new TButton('button_recalcular_custos_das_fichas_tecnicas_do_produto');
        $button_remover_caracteres_cpf_e_cnpj_de_cliente = new TButton('button_remover_caracteres_cpf_e_cnpj_de_cliente');
        $button_incluir_id_do_funil_na_tabela_de_negocio = new TButton('button_incluir_id_do_funil_na_tabela_de_negocio');
        $button_habilitar_todos_os_produtos = new TButton('button_habilitar_todos_os_produtos');
        $button_setar_produtos_para_tipo_simples = new TButton('button_setar_produtos_para_tipo_simples');
        $button_setar_clientes_para_exterior_nao = new TButton('button_setar_clientes_para_exterior_nao');
        $button_preencher_data_vencimento_calendario_contas_pag = new TButton('button_preencher_data_vencimento_calendario_contas_pag');
        $system_unit_id_destino_pconta = new TEntry('system_unit_id_destino_pconta');
        $button_migrar_plano_de_contas_para_filial_destino = new TButton('button_migrar_plano_de_contas_para_filial_destino');
        $button_setar_grupos_de_produto_para_tipo_produto = new TButton('button_setar_grupos_de_produto_para_tipo_produto');
        $button_recalcula_saldos_de_estoque = new TButton('button_recalcula_saldos_de_estoque');
        $button_setar_todas_as_notas_para_origem_kraftweb = new TButton('button_setar_todas_as_notas_para_origem_kraftweb');
        $button_setar_todas_as_vendas_para_origem_kraftweb = new TButton('button_setar_todas_as_vendas_para_origem_kraftweb');
        $button_setar_todas_as_notas_para_origem_kraftpdv = new TButton('button_setar_todas_as_notas_para_origem_kraftpdv');
        $button_setar_todas_as_vendas_para_origem_kraftpdv = new TButton('button_setar_todas_as_vendas_para_origem_kraftpdv');
        $button_atualizar_custo_do_produto_nas_vendas = new TButton('button_atualizar_custo_do_produto_nas_vendas');


        $system_unit_id_destino_pconta->setSize('100%');
        $button_habilitar_todos_os_produtos->setAction(new TAction([$this, 'onHabilitarTodosProdutos']), "Habilitar todos os produtos");
        $button_recalcula_saldos_de_estoque->setAction(new TAction([$this, 'onRecalculaSaldosEstoque']), "Recalcula Saldos de Estoque");
        $button_setar_produtos_para_tipo_simples->setAction(new TAction([$this, 'onSetarProdutosTipoSimples']), "Setar produtos para tipo Simples");
        $button_setar_clientes_para_exterior_nao->setAction(new TAction([$this, 'onSetarClientesExterior']), "Setar clientes para exterior = Não");
        $button_setar_todas_as_notas_para_origem_kraftweb->setAction(new TAction([$this, 'onSetarNotasKraftWeb']), "Setar todas as notas para origem kraftweb");
        $button_setar_todas_as_notas_para_origem_kraftpdv->setAction(new TAction([$this, 'onSetarNotasKraftPdv']), "Setar todas as notas para origem kraftpdv");
        $button_atualizar_custo_do_produto_nas_vendas->setAction(new TAction([$this, 'onAtualizarCustoProdutoVendas']), "Atualizar custo do produto nas vendas");
        $button_setar_todas_as_vendas_para_origem_kraftweb->setAction(new TAction([$this, 'onSetarVendasKraftWeb']), "Setar todas as vendas para origem kraftweb");
        $button_setar_todas_as_vendas_para_origem_kraftpdv->setAction(new TAction([$this, 'onSetarVendasKraftPdv']), "Setar todas as vendas para origem kraftpdv");
        $button_incluir_id_do_funil_na_tabela_de_negocio->setAction(new TAction([$this, 'onIncluirIDFunilTabelaNegocio']), "Incluir id do funil na tabela de negócio");
        $button_migrar_plano_de_contas_para_filial_destino->setAction(new TAction([$this, 'onMigrarPlanoContasDestino']), "Migrar plano de contas para filial destino");
        $button_remover_caracteres_cpf_e_cnpj_de_cliente->setAction(new TAction([$this, 'onRemoverCaracteresCPFCNPJCliente']), "Remover caracteres CPF e CNPJ de cliente");
        $button_setar_grupos_de_produto_para_tipo_produto->setAction(new TAction([$this, 'onSetarGruposProdutoTipoProduto']), "Setar grupos de produto para tipo produto");
        $button_preencher_data_vencimento_calendario_contas_pag->setAction(new TAction([$this, 'onPreencherVencCalendarioCPag']), "Preencher data vencimento calendário Contas pag");
        $button_recalcular_custos_das_fichas_tecnicas_do_produto->setAction(new TAction([$this, 'onRecalculaFichasTecnicasProduto']), "Recalcular Custos das Fichas técnicas do produto");

        $button_habilitar_todos_os_produtos->addStyleClass('btn-primary');
        $button_recalcula_saldos_de_estoque->addStyleClass('btn-primary');
        $button_setar_produtos_para_tipo_simples->addStyleClass('btn-primary');
        $button_setar_clientes_para_exterior_nao->addStyleClass('btn-primary');
        $button_atualizar_custo_do_produto_nas_vendas->addStyleClass('btn-primary');
        $button_remover_caracteres_cpf_e_cnpj_de_cliente->addStyleClass('btn-primary');
        $button_incluir_id_do_funil_na_tabela_de_negocio->addStyleClass('btn-primary');
        $button_setar_grupos_de_produto_para_tipo_produto->addStyleClass('btn-primary');
        $button_setar_todas_as_notas_para_origem_kraftweb->addStyleClass('btn-primary');
        $button_setar_todas_as_notas_para_origem_kraftpdv->addStyleClass('btn-primary');
        $button_migrar_plano_de_contas_para_filial_destino->addStyleClass('btn-primary');
        $button_setar_todas_as_vendas_para_origem_kraftweb->addStyleClass('btn-primary');
        $button_setar_todas_as_vendas_para_origem_kraftpdv->addStyleClass('btn-primary');
        $button_preencher_data_vencimento_calendario_contas_pag->addStyleClass('btn-primary');
        $button_recalcular_custos_das_fichas_tecnicas_do_produto->addStyleClass('btn-primary');

        $button_recalcula_saldos_de_estoque->setImage('far:circle #FFFFFF');
        $button_habilitar_todos_os_produtos->setImage('fas:align-justify #FFFFFF');
        $button_atualizar_custo_do_produto_nas_vendas->setImage('far:circle #FFFFFF');
        $button_setar_produtos_para_tipo_simples->setImage('fas:align-justify #FFFFFF');
        $button_setar_clientes_para_exterior_nao->setImage('fas:align-justify #FFFFFF');
        $button_setar_grupos_de_produto_para_tipo_produto->setImage('far:circle #FFFFFF');
        $button_setar_todas_as_notas_para_origem_kraftweb->setImage('far:circle #FFFFFF');
        $button_setar_todas_as_notas_para_origem_kraftpdv->setImage('far:circle #FFFFFF');
        $button_migrar_plano_de_contas_para_filial_destino->setImage('far:circle #FFFFFF');
        $button_setar_todas_as_vendas_para_origem_kraftweb->setImage('far:circle #FFFFFF');
        $button_setar_todas_as_vendas_para_origem_kraftpdv->setImage('far:circle #FFFFFF');
        $button_remover_caracteres_cpf_e_cnpj_de_cliente->setImage('fas:align-justify #FFFFFF');
        $button_incluir_id_do_funil_na_tabela_de_negocio->setImage('fas:align-justify #FFFFFF');
        $button_preencher_data_vencimento_calendario_contas_pag->setImage('fas:align-justify #FFFFFF');
        $button_recalcular_custos_das_fichas_tecnicas_do_produto->setImage('fas:align-justify #FFFFFF');


        $row1 = $this->form->addFields([$button_recalcular_custos_das_fichas_tecnicas_do_produto],[$button_remover_caracteres_cpf_e_cnpj_de_cliente]);
        $row1->layout = [' col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([$button_incluir_id_do_funil_na_tabela_de_negocio],[$button_habilitar_todos_os_produtos]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([$button_setar_produtos_para_tipo_simples],[$button_setar_clientes_para_exterior_nao]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([$button_preencher_data_vencimento_calendario_contas_pag],[new TLabel("Id filial destino :", null, '14px', null),$system_unit_id_destino_pconta,$button_migrar_plano_de_contas_para_filial_destino]);
        $row4->layout = [' col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([$button_setar_grupos_de_produto_para_tipo_produto],[$button_recalcula_saldos_de_estoque]);
        $row5->layout = [' col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([$button_setar_todas_as_notas_para_origem_kraftweb],[$button_setar_todas_as_vendas_para_origem_kraftweb]);
        $row6->layout = [' col-sm-6','col-sm-6'];

        $row7 = $this->form->addFields([$button_setar_todas_as_notas_para_origem_kraftpdv],[$button_setar_todas_as_vendas_para_origem_kraftpdv]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $this->form->addFields([$button_atualizar_custo_do_produto_nas_vendas],[]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Tabelas de Sistema","Hot Fix (Exclusivo Admin Kraft)"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onRecalculaFichasTecnicasProduto($param = null) 
    {
        try 
        {

           TTransaction::open('kraftsoft');

           $ListaProdutos = Produto::where('id', '>', '0')->load();

           foreach ($ListaProdutos as $produto)
           {

                //carregando as fichas tecnicas
                $lista_ficha_tecnica = ProdutoFichaTecnica::where('produto_id', '=', $produto->id)->load();

                if ($lista_ficha_tecnica)
                {
                    foreach ($lista_ficha_tecnica as $ficha_tecnica)
                    {
                        //carregando as materias primas da ficha tecnica..
                        $lista_itens_ficha_tecnica = ProdutoFichaTecnicaItens::where('produto_ficha_tecnica_id', '=', $ficha_tecnica->id)->load();

                        if ($lista_itens_ficha_tecnica)
                        {
                            $custo_total = 0;

                            foreach ($lista_itens_ficha_tecnica as $item_ficha_tecnica)
                            {
                              $custo_total += $item_ficha_tecnica->valor_total;
                            }

                            $ficha_tecnica->custo_total = $custo_total;
                            $ficha_tecnica->store();
                        }
                    }
                }
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");
           // -----

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onRemoverCaracteresCPFCNPJCliente($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaClientes = Cliente::where('id', '>', '0')->load();

           foreach ($ListaClientes as $cliente)
           {

              $cliente->cpf_cnpj = Funcoes::limpaCPF_CNPJ($cliente->cpf_cnpj);   
              $cliente->store();

           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");           

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onIncluirIDFunilTabelaNegocio($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaNegocios = Negocio::where('id', '>', '0')->load();

           foreach ($ListaNegocios as $negocio)
           {
              $negocio->funil_id = $negocio->funil_etapas->funil_id;   
              $negocio->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");       

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onHabilitarTodosProdutos($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaProdutos = Produto::where('id', '>', '0')->load();

           foreach ($ListaProdutos as $produto)
           {
              $produto->habilitado_id = Resposta::Sim;
              $produto->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");               

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onSetarProdutosTipoSimples($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaProdutos = Produto::where('id', '>', '0')->load();

           foreach ($ListaProdutos as $produto)
           {
              $produto->produto_tipo_id = ProdutoTipo::Simples;
              $produto->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");             

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onSetarClientesExterior($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaClientes = Cliente::where('id', '>', '0')->load();

           foreach ($ListaClientes as $cliente)
           {
              $cliente->cliente_exterior = 'N';   
              $cliente->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");           

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onPreencherVencCalendarioCPag($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaCpag = Contaspag::where('id', '>', '0')->load();

           foreach ($ListaCpag as $cpag)
           {
              $cpag->data_vencimento_calendario = $cpag->data_vencimento;
              $cpag->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");    

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onMigrarPlanoContasDestino($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaPContas = PlanoConta::where('system_unit_id', '=', TSession::getValue('userunitid'))->load();

           foreach ($ListaPContas as $pconta)
           {
              $pconta->id = null;
              $pconta->system_unit_id = $param['system_unit_id_destino_pconta'];
              $pconta->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");         

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onSetarGruposProdutoTipoProduto($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaGrupoProduto = ProdutoGrupo::where('id', '>', '0')->load();

           foreach ($ListaGrupoProduto as $grupo)
           {
              $grupo->tipo_recurso_id = TipoRecurso::Produto;
              $grupo->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");                    

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onRecalculaSaldosEstoque($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaProdutos = Produto::where('id', '>', '0')->load();
           $lista_depositos = EstoqueDeposito::where('system_unit_id','=', TSession::getValue('userunitid'))->load();    

           foreach ($ListaProdutos as $produto)
           {
                // echo $produto->nome;

                // if ($produto->id==50) //temp
                // {
                    // echo $produto->nome;

                    $lista_lotes_produto = ProdutoLote::where('produto_id', '=', $produto->id)->load();
                    // $count_lotes = ProdutoLote::where('produto_id', '=', $produto->id)->count();

                    foreach ($lista_depositos as $deposito)
                    {
                        //  echo $deposito->descricao;
                        // echo 'count lotes '.$count_lotes;

                        //  if ($count_lotes = 0)
                        //  {
                            EstoqueLancamentos::AtualizaSaldosEstoque($produto->id,$deposito->id,null); 
                        //  }
                        //  else
                        //  {
                             foreach ($lista_lotes_produto as $produto_lote)
                             {    
                                EstoqueLancamentos::AtualizaSaldosEstoque($produto->id,$deposito->id,$produto_lote->id);     
                             }
                        //  }
                   }
                // }
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");    

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onSetarNotasKraftWeb($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaNotas = Notafiscal::all();

           foreach ($ListaNotas as $nota)
           {
              $nota->movimentacao_origem_id = MovimentacaoOrigem::kraftweb;   
              $nota->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");       

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onSetarVendasKraftWeb($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaVendas = Venda::all();

           foreach ($ListaVendas as $venda)
           {
              $venda->movimentacao_origem_id = MovimentacaoOrigem::kraftweb;   
              $venda->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");     

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onSetarNotasKraftPdv($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaNotas = Notafiscal::all();

           foreach ($ListaNotas as $nota)
           {
              $nota->movimentacao_origem_id = MovimentacaoOrigem::kraftpdv;   
              $nota->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");       

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onSetarVendasKraftPdv($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaVendas = Venda::all();

           foreach ($ListaVendas as $venda)
           {
              $venda->movimentacao_origem_id = MovimentacaoOrigem::kraftpdv;   
              $venda->store();
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");     

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAtualizarCustoProdutoVendas($param = null) 
    {
        try 
        {
           TTransaction::open('kraftsoft');

           $ListaVendaItem = VendaItem::all();

           foreach ($ListaVendaItem as $vendaItem)
           {
              //trazer o custo da filial..
              $produtofilial = ProdutoFilial::where('produto_id', '=', $vendaItem->produto_id)
                                              ->where('system_unit_id', '=', $vendaItem->venda->system_unit_id)
                                              ->first();               
              if ($produtofilial)
              {
                $vendaItem->valor_original = $produtofilial->preco_venda; 
                $vendaItem->valor_custo = $produtofilial->valor_custo;
                $vendaItem->store();
              }
           }

          TTransaction::close();

           // Código gerado pelo snippet: "Mensagem Toast"
          TToast::show("success", "Rotina realizada com sucesso!", "topRight", "");  

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {               

    } 

}

