<?php

class CupomNaoFiscalDocument extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Venda';
    private static $primaryKey = 'id';
    private static $htmlFile = 'app/documents/CupomNaoFiscalDocumentTemplate.html';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {

    }

    public static function onGenerate($param)
    {
        try 
        {
            TTransaction::open(self::$database);

            $class = self::$activeRecord;
            $object = new $class($param['key']);

            $html = new AdiantiHTMLDocumentParser(self::$htmlFile);
            $html->setMaster($object);

            $criteria_VendaItem_venda_id = new TCriteria();
            $criteria_VendaItem_venda_id->add(new TFilter('venda_id', '=', $param['key']));
            $criteria_VendaFormapgto_venda_id = new TCriteria();
            $criteria_VendaFormapgto_venda_id->add(new TFilter('venda_id', '=', $param['key']));

            $object->data_hora_venda = TDate::date2br($object->data_hora_venda);

            $objectsVendaItem_venda_id = VendaItem::getObjects($criteria_VendaItem_venda_id);
            $html->setDetail('VendaItem.venda_id', $objectsVendaItem_venda_id);
            $objectsVendaFormapgto_venda_id = VendaFormapgto::getObjects($criteria_VendaFormapgto_venda_id);
            $html->setDetail('VendaFormapgto.venda_id', $objectsVendaFormapgto_venda_id);

            $pageSize = 'A4';
            $document = 'tmp/'.uniqid().'.pdf'; 

            $pageSize = array(338, 453);

            if(!$object->desconto)
            {
                $object->desconto = '0.00';
            }

            if(!$object->valor_troco)
            {
                $object->valor_troco = '0.00';
            }

            $html->process();

            $html->saveAsPDF($document, $pageSize, 'portrait');

            TTransaction::close();

            if(empty($param['returnFile']))
            {
                parent::openFile($document);

                new TMessage('info', _t('Document successfully generated'));    
            }
            else
            {
                return $document;
            }
        } 
        catch (Exception $e) 
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());

            // undo all pending operations
            TTransaction::rollback();
        }
    }

}

