<?php

class DevolucaoMercadoriaDocument extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'VendaDevolucao';
    private static $primaryKey = 'id';
    private static $htmlFile = 'app/documents/DevolucaoMercadoriaDocumentTemplate.html';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {

    }

    public static function onGenerate($param)
    {
        try 
        {
            TTransaction::open(self::$database);

            $class = self::$activeRecord;
            $object = new $class($param['key']);

            $html = new AdiantiHTMLDocumentParser(self::$htmlFile);
            $html->setMaster($object);

            $criteria_VendaDevolucaoItens_venda_devolucao_id = new TCriteria();
            $criteria_VendaDevolucaoItens_venda_devolucao_id->add(new TFilter('venda_devolucao_id', '=', $param['key']));

            $objectsVendaDevolucaoItens_venda_devolucao_id = VendaDevolucaoItens::getObjects($criteria_VendaDevolucaoItens_venda_devolucao_id);
            $html->setDetail('VendaDevolucaoItens.venda_devolucao_id', $objectsVendaDevolucaoItens_venda_devolucao_id);

            $pageSize = 'A4';
            $document = 'tmp/'.uniqid().'.pdf'; 

            $object->data_devolucao = TDate::date2br($object->data_devolucao);

            $html->process();

            $html->saveAsPDF($document, $pageSize, 'portrait');

            TTransaction::close();

            if(empty($param['returnFile']))
            {
                parent::openFile($document);

                new TMessage('info', _t('Document successfully generated'));    
            }
            else
            {
                return $document;
            }
        } 
        catch (Exception $e) 
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());

            // undo all pending operations
            TTransaction::rollback();
        }
    }

}

