<?php

class EspelhosDaVenda extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_EspelhosDaVenda';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Espelhos Da Venda");


        $button_relatorio_de_separacao = new TButton('button_relatorio_de_separacao');


        $button_relatorio_de_separacao->setAction(new TAction([$this, 'onRelatorioSeparacao'],['key' => 'id']), "Relatório de separação");
        $button_relatorio_de_separacao->addStyleClass('btn-default');
        $button_relatorio_de_separacao->setImage('far:circle #000000');


        $row1 = $this->form->addFields([$button_relatorio_de_separacao]);
        $row1->layout = [' col-sm-3'];

        // create the form actions
        $btn_onaction = $this->form->addAction("Ação", new TAction([$this, 'onAction']), 'fas:rocket #ffffff');
        $this->btn_onaction = $btn_onaction;
        $btn_onaction->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=EspelhosDaVenda]');
        $style->width = '45% !important';   
        $style->show(true);

    }

    public  function onRelatorioSeparacao($param = null) 
    {
        try 
        {
            //code here
            TTransaction::open('kraftsoft');

            $venda = Venda::find($param['key']);

            RelatorioDeSeparacaoDocument::onGenerate($param->id);

            TTransaction::close();

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onAction($param = null) 
    {
        try
        {
            //
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

    } 

}

