<?php

class OrcamentoDocument extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Orcamento';
    private static $primaryKey = 'id';
    private static $htmlFile = 'app/documents/OrcamentoDocumentTemplate.html';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {

    }

    public static function onGenerate($param)
    {
        try 
        {
            TTransaction::open(self::$database);

            $class = self::$activeRecord;
            $object = new $class($param['key']);

            $html = new AdiantiHTMLDocumentParser(self::$htmlFile);
            $html->setMaster($object);

            $criteria_OrcamentoItem_orcamento_id = new TCriteria();
            $criteria_OrcamentoItem_orcamento_id->add(new TFilter('orcamento_id', '=', $param['key']));

            $object->data_orcamento = TDate::date2br($object->data_orcamento);

            $objectsOrcamentoItem_orcamento_id = OrcamentoItem::getObjects($criteria_OrcamentoItem_orcamento_id);
            $html->setDetail('OrcamentoItem.orcamento_id', $objectsOrcamentoItem_orcamento_id);

            $pageSize = 'A4';
            $document = 'tmp/'.uniqid().'.pdf'; 

            if(!$object->desconto)
            {
                $object->desconto = '0.00';
            }

            $html->process();

            $html->saveAsPDF($document, $pageSize, 'portrait');

            TTransaction::close();

            if(empty($param['returnFile']))
            {
                parent::openFile($document);

                new TMessage('info', _t('Document successfully generated'));    
            }
            else
            {
                return $document;
            }
        } 
        catch (Exception $e) 
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());

            // undo all pending operations
            TTransaction::rollback();
        }
    }

}

