<?php

class OrcamentoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Orcamento';
    private static $primaryKey = 'id';
    private static $formName = 'form_OrcamentoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de Orçamentos");

        TSession::setValue('orc_editou_prod', 'N');

        $orcamento_situacao_id = new TDBArrowStep('orcamento_situacao_id', 'kraftsoft', 'OrcamentoSituacao', 'id', '{descricao}','ordem asc'  );
        $id = new TEntry('id');
        $data_orcamento = new TDate('data_orcamento');
        $cliente_id = new TSeekButton('cliente_id');
        $cliente_nome = new TEntry('cliente_nome');
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $cliente_contato_id = new TDBCombo('cliente_contato_id', 'kraftsoft', 'ClienteContato', 'id', '{nome}','nome asc'  );
        $tabela_preco_id = new TDBCombo('tabela_preco_id', 'kraftsoft', 'TabelaPreco', 'id', '{descricao}','descricao asc'  );
        $observacao = new TText('observacao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $orcamento_item_orcamento_produto_id = new TSeekButton('orcamento_item_orcamento_produto_id');
        $produto_nome = new TEntry('produto_nome');
        $orcamento_item_orcamento_quantidade = new TNumeric('orcamento_item_orcamento_quantidade', '2', ',', '.' );
        $orcamento_item_orcamento_valor_unitario = new TNumeric('orcamento_item_orcamento_valor_unitario', '2', ',', '.' );
        $orcamento_item_orcamento_desconto = new TNumeric('orcamento_item_orcamento_desconto', '2', ',', '.' );
        $orcamento_item_orcamento_valor_frete = new TNumeric('orcamento_item_orcamento_valor_frete', '2', ',', '.' );
        $orcamento_item_orcamento_valor_total = new TNumeric('orcamento_item_orcamento_valor_total', '2', ',', '.' );
        $orcamento_item_orcamento_numero_pedido = new TEntry('orcamento_item_orcamento_numero_pedido');
        $orcamento_item_orcamento_numero_item_pedido = new TEntry('orcamento_item_orcamento_numero_item_pedido');
        $orcamento_item_orcamento_informacoes_adicionais = new TText('orcamento_item_orcamento_informacoes_adicionais');
        $orcamento_item_orcamento_id = new THidden('orcamento_item_orcamento_id');
        $button_adicionar_orcamento_item_orcamento = new TButton('button_adicionar_orcamento_item_orcamento');
        $valor_produtos = new TNumeric('valor_produtos', '2', ',', '.' );
        $frete_total = new TNumeric('frete_total', '2', ',', '.' );
        $valor_total = new TNumeric('valor_total', '2', ',', '.' );
        $peso_total = new TNumeric('peso_total', '2', ',', '.' );
        $desconto = new TNumeric('desconto', '2', ',', '.' );

        $cliente_id->setExitAction(new TAction([$this,'onExitCliente']));
        $orcamento_item_orcamento_produto_id->setExitAction(new TAction([$this,'onExitProduto']));
        $orcamento_item_orcamento_quantidade->setExitAction(new TAction([$this,'onExitQuantidade']));
        $orcamento_item_orcamento_valor_unitario->setExitAction(new TAction([$this,'onExitValorUnitario']));

        $data_orcamento->addValidation("Data", new TRequiredValidator()); 
        $criado_por->addValidation("Criado Por", new TRequiredValidator()); 
        $valor_produtos->addValidation("Total Produtos", new TRequiredValidator()); 
        $valor_total->addValidation("Valor Total", new TRequiredValidator()); 

        $orcamento_situacao_id->setColorColumn('cor');
        $orcamento_situacao_id->setFilledColor('#fd9308');
        $orcamento_situacao_id->setFilledFontColor('#ffffff');
        $orcamento_situacao_id->setUnfilledColor('#d3d3d3');
        $orcamento_situacao_id->setUnfilledFontColor('#333333');
        $data_orcamento->setValue('date("d/m/Y H:i")');
        $button_adicionar_orcamento_item_orcamento->setAction(new TAction([$this, 'onAddDetailOrcamentoItemOrcamento'],['static' => 1]), "Adicionar");
        $button_adicionar_orcamento_item_orcamento->addStyleClass('btn-default');
        $button_adicionar_orcamento_item_orcamento->setImage('fas:plus #2ecc71');
        $data_orcamento->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $data_orcamento->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $vendedor_id->enableSearch();
        $tabela_preco_id->enableSearch();
        $cliente_contato_id->enableSearch();

        $id->setEditable(false);
        $desconto->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $peso_total->setEditable(false);
        $alterado_em->setEditable(false);
        $frete_total->setEditable(false);
        $valor_total->setEditable(false);
        $cliente_nome->setEditable(false);
        $alterado_por->setEditable(false);
        $produto_nome->setEditable(false);
        $data_orcamento->setEditable(false);
        $valor_produtos->setEditable(false);
        $orcamento_situacao_id->setEditable(false);
        $orcamento_item_orcamento_valor_total->setEditable(false);

        $id->setSize('100%');
        $cliente_id->setSize(100);
        $desconto->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $peso_total->setSize('100%');
        $cliente_nome->setSize('80%');
        $vendedor_id->setSize('100%');
        $alterado_em->setSize('100%');
        $produto_nome->setSize('90%');
        $frete_total->setSize('100%');
        $valor_total->setSize('100%');
        $alterado_por->setSize('100%');
        $data_orcamento->setSize('100%');
        $observacao->setSize('100%', 70);
        $valor_produtos->setSize('100%');
        $tabela_preco_id->setSize('100%');
        $cliente_contato_id->setSize('100%');
        $orcamento_item_orcamento_id->setSize(200);
        $orcamento_situacao_id->setSize('100%', 55);
        $orcamento_item_orcamento_produto_id->setSize(100);
        $orcamento_item_orcamento_desconto->setSize('100%');
        $orcamento_item_orcamento_quantidade->setSize('100%');
        $orcamento_item_orcamento_valor_frete->setSize('100%');
        $orcamento_item_orcamento_valor_total->setSize('100%');
        $orcamento_item_orcamento_numero_pedido->setSize('100%');
        $orcamento_item_orcamento_valor_unitario->setSize('100%');
        $orcamento_item_orcamento_numero_item_pedido->setSize('100%');
        $orcamento_item_orcamento_informacoes_adicionais->setSize('100%', 70);

        $button_adicionar_orcamento_item_orcamento->id = '63eba3cace9e2';

        $seed = AdiantiApplicationConfig::get()['general']['seed'];
        $cliente_id_seekAction = new TAction(['ClienteSeekWindow', 'onShow']);
        $seekFilters = [];
        $seekFields = base64_encode(serialize([
            ['name'=> 'cliente_id', 'column'=>'{id}'],
            ['name'=> 'cliente_nome', 'column'=>'{nome}'],
            ['name'=> 'vendedor_id', 'column'=>'{vendedor_id}']
        ]));

        $seekFilters = base64_encode(serialize($seekFilters));
        $cliente_id_seekAction->setParameter('_seek_fields', $seekFields);
        $cliente_id_seekAction->setParameter('_seek_filters', $seekFilters);
        $cliente_id_seekAction->setParameter('_seek_hash', md5($seed.$seekFields.$seekFilters));
        $cliente_id->setAction($cliente_id_seekAction);

        $seed = AdiantiApplicationConfig::get()['general']['seed'];
        $orcamento_item_orcamento_produto_id_seekAction = new TAction(['ProdutoSeekWindow', 'onShow']);
        $seekFilters = [];
        $seekFields = base64_encode(serialize([
            ['name'=> 'orcamento_item_orcamento_produto_id', 'column'=>'{id}'],
            ['name'=> 'produto_nome', 'column'=>'{nome}']
        ]));

        $seekFilters = base64_encode(serialize($seekFilters));
        $orcamento_item_orcamento_produto_id_seekAction->setParameter('_seek_fields', $seekFields);
        $orcamento_item_orcamento_produto_id_seekAction->setParameter('_seek_filters', $seekFilters);
        $orcamento_item_orcamento_produto_id_seekAction->setParameter('_seek_hash', md5($seed.$seekFields.$seekFilters));
        $orcamento_item_orcamento_produto_id->setAction($orcamento_item_orcamento_produto_id_seekAction);

        TTransaction::open(self::$database);

        $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', TSession::getValue('userunitid'))->first();

        if ($config_filial)
        {
            TSession::setValue('informar_duplicidade_de_item_venda_id', $config_filial->informar_duplicidade_de_item_venda_id);
         }

        TTransaction::close();

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$orcamento_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Data:", '#ff0000', '14px', null, '100%'),$data_orcamento]);
        $row2->layout = ['col-sm-3','col-sm-3'];

        $row3 = $this->form->addFields([new TLabel("Cliente:", '#FF0000', '14px', null, '100%'),$cliente_id,$cliente_nome],[new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id]);
        $row3->layout = ['col-sm-6',' col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Cliente contato:", null, '14px', null, '100%'),$cliente_contato_id],[new TLabel("Tabela preço:", null, '14px', null, '100%'),$tabela_preco_id]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$observacao]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row7 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row7->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $this->form->appendPage("Produtos");

        $this->detailFormOrcamentoItemOrcamento = new BootstrapFormBuilder('detailFormOrcamentoItemOrcamento');
        $this->detailFormOrcamentoItemOrcamento->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormOrcamentoItemOrcamento->setProperty('class', 'form-horizontal builder-detail-form');

        $row8 = $this->detailFormOrcamentoItemOrcamento->addFields([new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$orcamento_item_orcamento_produto_id,$produto_nome]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->detailFormOrcamentoItemOrcamento->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$orcamento_item_orcamento_quantidade],[new TLabel("Valor Unitário:", '#ff0000', '14px', null, '100%'),$orcamento_item_orcamento_valor_unitario],[new TLabel("Desconto:", null, '14px', null, '100%'),$orcamento_item_orcamento_desconto]);
        $row9->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row10 = $this->detailFormOrcamentoItemOrcamento->addFields([new TLabel("Valor Frete:", null, '14px', null, '100%'),$orcamento_item_orcamento_valor_frete],[new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$orcamento_item_orcamento_valor_total]);
        $row10->layout = [' col-sm-4',' col-sm-4'];

        $row11 = $this->detailFormOrcamentoItemOrcamento->addFields([new TLabel("Número Pedido:", null, '14px', null, '100%'),$orcamento_item_orcamento_numero_pedido],[new TLabel("Número Item do Pedido:", null, '14px', null, '100%'),$orcamento_item_orcamento_numero_item_pedido]);
        $row11->layout = ['col-sm-6','col-sm-6'];

        $row12 = $this->detailFormOrcamentoItemOrcamento->addFields([new TLabel("Informações Adicionais:", null, '14px', null, '100%'),$orcamento_item_orcamento_informacoes_adicionais]);
        $row12->layout = [' col-sm-12'];

        $row13 = $this->detailFormOrcamentoItemOrcamento->addFields([$orcamento_item_orcamento_id]);
        $row13->layout = ['col-sm-6'];

        $row14 = $this->detailFormOrcamentoItemOrcamento->addFields([$button_adicionar_orcamento_item_orcamento]);
        $row14->layout = [' col-sm-12'];

        $row15 = $this->detailFormOrcamentoItemOrcamento->addFields([new THidden('orcamento_item_orcamento__row__id')]);
        $this->orcamento_item_orcamento_criteria = new TCriteria();

        $this->orcamento_item_orcamento_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->orcamento_item_orcamento_list->disableHtmlConversion();;
        $this->orcamento_item_orcamento_list->generateHiddenFields();
        $this->orcamento_item_orcamento_list->setId('orcamento_item_orcamento_list');
        $this->orcamento_item_orcamento_list->setMutationAction(new TAction([$this,'onCalculaTotal']));

        $this->orcamento_item_orcamento_list->style = 'width:100%';
        $this->orcamento_item_orcamento_list->class .= ' table-bordered';

        $column_orcamento_item_orcamento_produto_referencia = new TDataGridColumn('produto->referencia', "Referência", 'left');
        $column_orcamento_item_orcamento_produto_nome = new TDataGridColumn('produto->nome', "Produto", 'left');
        $column_orcamento_item_orcamento_quantidade_transformed = new TDataGridColumn('quantidade', "Quantidade", 'right');
        $column_orcamento_item_orcamento_valor_unitario_transformed = new TDataGridColumn('valor_unitario', "Valor Unitário", 'right');
        $column_orcamento_item_orcamento_desconto_transformed = new TDataGridColumn('desconto', "Desconto", 'right');
        $column_orcamento_item_orcamento_valor_total_transformed = new TDataGridColumn('valor_total', "Valor Total", 'right');
        $column_orcamento_item_orcamento_valor_frete_transformed = new TDataGridColumn('valor_frete', "Valor Frete", 'right');
        $column_orcamento_item_orcamento_peso_total_transformed = new TDataGridColumn('peso_total', "Peso Total", 'right');

        $column_orcamento_item_orcamento__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_orcamento_item_orcamento__row__data->setVisibility(false);

        $action_onEditDetailOrcamentoItem = new TDataGridAction(array('OrcamentoForm', 'onEditDetailOrcamentoItem'));
        $action_onEditDetailOrcamentoItem->setUseButton(true);
        $action_onEditDetailOrcamentoItem->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailOrcamentoItem->setLabel("Editar");
        $action_onEditDetailOrcamentoItem->setImage('far:edit #478fca');
        $action_onEditDetailOrcamentoItem->setFields(['__row__id', '__row__data']);

        $this->orcamento_item_orcamento_list->addAction($action_onEditDetailOrcamentoItem);
        $action_onDeleteDetailOrcamentoItem = new TDataGridAction(array('OrcamentoForm', 'onDeleteDetailOrcamentoItem'));
        $action_onDeleteDetailOrcamentoItem->setUseButton(true);
        $action_onDeleteDetailOrcamentoItem->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailOrcamentoItem->setLabel("Excluir");
        $action_onDeleteDetailOrcamentoItem->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailOrcamentoItem->setFields(['__row__id', '__row__data']);

        $this->orcamento_item_orcamento_list->addAction($action_onDeleteDetailOrcamentoItem);

        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_produto_referencia);
        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_produto_nome);
        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_quantidade_transformed);
        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_valor_unitario_transformed);
        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_desconto_transformed);
        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_valor_total_transformed);
        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_valor_frete_transformed);
        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento_peso_total_transformed);

        $this->orcamento_item_orcamento_list->addColumn($column_orcamento_item_orcamento__row__data);

        $this->orcamento_item_orcamento_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->orcamento_item_orcamento_list);
        $this->detailFormOrcamentoItemOrcamento->addContent([$tableResponsiveDiv]);

        $column_orcamento_item_orcamento_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_orcamento_item_orcamento_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_orcamento_item_orcamento_desconto_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_orcamento_item_orcamento_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_orcamento_item_orcamento_valor_frete_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_orcamento_item_orcamento_peso_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });        $row16 = $this->form->addFields([$this->detailFormOrcamentoItemOrcamento]);
        $row16->layout = [' col-sm-12'];

        $this->form->appendPage("Totais");
        $row17 = $this->form->addFields([new TLabel("Total Produtos:", '#ff0000', '14px', null, '100%'),$valor_produtos],[new TLabel("Total Frete:", null, '14px', null, '100%'),$frete_total]);
        $row17->layout = ['col-sm-6',' col-sm-6'];

        $row18 = $this->form->addFields([new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$valor_total],[new TLabel("Peso Total:", null, '14px', null, '100%'),$peso_total]);
        $row18->layout = [' col-sm-6',' col-sm-6'];

        $row19 = $this->form->addFields([new TLabel("Desconto:", null, '14px', null, '100%'),$desconto]);
        $row19->layout = [' col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacaoorcamento = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacaoOrcamento']), 'fas:bars #000000');
        $this->btn_onvisualizacaoorcamento = $btn_onvisualizacaoorcamento;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['OrcamentoList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Cadastro de Orçamentos"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitCliente($param = null) 
    {
        try 
        {
            //code here
            if(isset($param['cliente_id']) && $param['cliente_id'])
            {
                TTransaction::open(self::$database);

                $cliente = Cliente::find($param['cliente_id']);

                $object = new stdClass();
                $object->cliente_contato_id = '';
                $object->tabela_preco_id = $cliente->tabela_preco_id;
                $object->cliente_contato_id = $cliente->cliente_contato_id;
                TForm::sendData(self::$formName, $object);

                $criteria = new TCriteria();
                $criteria->add(new TFilter('cliente_id', '=', $param['cliente_id']));

                TDBCombo::reloadFromModel(self::$formName, 'cliente_contato_id', self::$database, 'ClienteContato', 'id', '{nome}', 'nome asc', $criteria, true);

                TTransaction::close();
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitProduto($param = null) 
    {
        try 
        {
            $edita_prod = TSession::getValue('orc_editou_prod');

            if(isset($param['orcamento_item_orcamento_produto_id']) && $param['orcamento_item_orcamento_produto_id'] && $edita_prod=='N')
            {
                TTransaction::open(self::$database);

                $object = new stdClass();

                $produtoFilial = ProdutoFilial::where('produto_id', '=', $param['orcamento_item_orcamento_produto_id'])
                                                ->where('system_unit_id', '=', TSession::getValue('userunitid'))->first();

                if($produtoFilial)
                {
                    //Parceiro possui tabela de preço vinculada
                    $tabelaPrecoProd = TabelaPrecoProduto::where('produto_filial_id', '=', $produtoFilial->id)
                                                         ->where('tabela_preco_id', '=', $param['tabela_preco_id'])->first();

                    if($tabelaPrecoProd)
                    {
                        $valorProduto = $tabelaPrecoProd->preco_venda;
                    }
                    else
                    {
                        $valorProduto = $produtoFilial->preco_venda;
                    }

                    $object->orcamento_item_orcamento_quantidade = 1;
                    $object->orcamento_item_orcamento_valor_unitario = number_format($valorProduto, 2,',','.');
                }
                else
                {
                    new TMessage('error', 'Este produto não tem vinculo configurado para esta filial!');
                    $object->produto_nome='';
                    $object->orcamento_item_orcamento_produto_id='';
                }

                TTransaction::close();

                TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitQuantidade($param = null) 
    {
        try 
        {
            //code here
            $qtd = (double) str_replace(',', '.', str_replace('.', '', $param['orcamento_item_orcamento_quantidade']));
            $valorUnit = (double) str_replace(',', '.', str_replace('.', '', $param['orcamento_item_orcamento_valor_unitario']));

            $valorTotal = $qtd * $valorUnit;

            $object = new stdClass();

            $object->orcamento_item_orcamento_valor_total = number_format($valorTotal, 2, ',', '.');

            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitValorUnitario($param = null) 
    {
        try 
        {
            //code here
            $qtd = (double) str_replace(',', '.', str_replace('.', '', $param['orcamento_item_orcamento_quantidade']));
            $valorUnit = (double) str_replace(',', '.', str_replace('.', '', $param['orcamento_item_orcamento_valor_unitario']));

            $valorTotal = $qtd * $valorUnit;

            $object = new stdClass();

            $object->orcamento_item_orcamento_valor_total = number_format($valorTotal, 2, ',', '.');

            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCalculaTotal($param = null) 
    {
        try 
        {
           // echo 'entrou calculo ';
            //code here
            $totalProdutos = 0;
            $totalFrete = 0;
            $totalVenda = 0;
            $totalDesconto = 0;
            $pesoTotal = 0;

            if(isset($param['list_data']))
            {
                foreach($param['list_data'] as $row)
                {
                    // echo 'total item '.number_format($row['valor_total'], 2,',','.');//str_replace(',', '.', str_replace('.', '', $row['valor_total']));

                    // $totalFrete += floatval(str_replace(',', '.', str_replace('.', '', $row['valor_frete'])));//floatval($row['valor_frete']);
                    // $totalDesconto += floatval(str_replace(',', '.', str_replace('.', '', $row['desconto'])));//floatval($row['desconto']);
                    // $pesoTotal += floatval(str_replace(',', '.', str_replace('.', '', $row['peso_total'])));//floatval($row['peso_total']);
                    // $totalProdutos += floatval(str_replace(',', '.', str_replace('.', '', $row['valor_total'])));//floatval($row['valor_total']);

                    // $vTotal = floatval(str_replace(',', '.', str_replace('.', '', $row['valor_total'])));//floatval($row['valor_total']);
                    // $vFrete = floatval(str_replace(',', '.', str_replace('.', '', $row['valor_frete'])));//floatval($row['valor_frete']);
                    // $vDesconto = floatval(str_replace(',', '.', str_replace('.', '', $row['desconto'])));//floatval($row['desconto']);

                    $vUnit = (double) $row['valor_unitario'];
                    $qtd = (double) $row['quantidade'];
                    $totalFrete += (double)  $row['valor_frete'];
                    $totalDesconto += (double) $row['desconto'];
                    $pesoTotal += (double) $row['peso_total'];
                    $totalProdutos += (double) ($vUnit * $qtd);//$row['valor_total'];                    

                    $vTotal = (double) $row['valor_total'];                    
                    $vFrete = (double)  $row['valor_frete'];                                        
                    $vDesconto = (double) $row['desconto'];                                                            

                    $totalVenda += floatval((($vUnit * $qtd) + $vFrete) - $vDesconto);
                }
            }

           // echo 'total item '.$totalProdutos;

            $totalFrete = number_format($totalFrete, 2,',','.');
            $totalDesconto = number_format($totalDesconto, 2,',','.');
            $totalVenda = number_format($totalVenda, 2,',','.');
            $totalProdutos = number_format($totalProdutos, 2,',','.');
            $pesoTotal = number_format($pesoTotal, 2,',','.');

            TScript::create("$('[name=desconto]').val('{$totalDesconto}')");
            TScript::create("$('[name=frete_total]').val('{$totalFrete}')");
            TScript::create("$('[name=valor_total]').val('{$totalVenda}')");
            TScript::create("$('[name=valor_produtos]').val('{$totalProdutos}')");
            TScript::create("$('[name=peso_total]').val('{$pesoTotal}')"); 

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailOrcamentoItemOrcamento($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if (TSession::getValue('informar_duplicidade_de_item_venda_id') == Resposta::Sim)
            {
                if(!empty($param['orcamento_item_orcamento_list___row__data']))
                {
                    $rowId = $param['orcamento_item_orcamento__row__id'];
                    foreach($param['orcamento_item_orcamento_list___row__data'] as $rowDataCoded)
                    {
                        $rowDataDecoded = unserialize(base64_decode($rowDataCoded));   

                        if ($rowDataDecoded->produto_id == $data->orcamento_item_orcamento_produto_id)
                        {
                          new TMessage('info', 'Este produto já se encontra na lista!');  
                        }
                        // $rowDataDecoded->id;
                        // $rowDataDecoded->__row__id;
                    }
                }
            }

            // $qtd = floatval(str_replace(',', '.', str_replace('.', '', $param['orcamento_item_orcamento_quantidade'])));
            // $valorUnit = floatval(str_replace(',', '.', str_replace('.', '', $param['orcamento_item_orcamento_valor_unitario'])));

            // $qtd = (double) str_replace(',', '.',$param['orcamento_item_orcamento_quantidade']);
            // $valorUnit = (double) str_replace(',', '.',$param['orcamento_item_orcamento_valor_unitario']);

            // $valorTotal = $qtd * $valorUnit;

            // echo 'valor total '.$valorTotal;

            // $data->orcamento_item_orcamento_valor_total = number_format($valorTotal, 2, ',', '.');

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Produto id", 'name'=>"orcamento_item_orcamento_produto_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Quantidade", 'name'=>"orcamento_item_orcamento_quantidade", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Unitário", 'name'=>"orcamento_item_orcamento_valor_unitario", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Total", 'name'=>"orcamento_item_orcamento_valor_total", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->orcamento_item_orcamento__row__id) ? $data->orcamento_item_orcamento__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new OrcamentoItem();
            $grid_data->__row__id = $__row__id;
            $grid_data->produto_id = $data->orcamento_item_orcamento_produto_id;
            $grid_data->produto_nome = $data->produto_nome;
            $grid_data->quantidade = $data->orcamento_item_orcamento_quantidade;
            $grid_data->valor_unitario = $data->orcamento_item_orcamento_valor_unitario;
            $grid_data->desconto = $data->orcamento_item_orcamento_desconto;
            $grid_data->valor_frete = $data->orcamento_item_orcamento_valor_frete;
            $grid_data->valor_total = $data->orcamento_item_orcamento_valor_total;
            $grid_data->numero_pedido = $data->orcamento_item_orcamento_numero_pedido;
            $grid_data->numero_item_pedido = $data->orcamento_item_orcamento_numero_item_pedido;
            $grid_data->informacoes_adicionais = $data->orcamento_item_orcamento_informacoes_adicionais;
            $grid_data->id = $data->orcamento_item_orcamento_id;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['produto_id'] =  $param['orcamento_item_orcamento_produto_id'] ?? null;
            $__row__data['__display__']['produto_nome'] =  $param['produto_nome'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['orcamento_item_orcamento_quantidade'] ?? null;
            $__row__data['__display__']['valor_unitario'] =  $param['orcamento_item_orcamento_valor_unitario'] ?? null;
            $__row__data['__display__']['desconto'] =  $param['orcamento_item_orcamento_desconto'] ?? null;
            $__row__data['__display__']['valor_frete'] =  $param['orcamento_item_orcamento_valor_frete'] ?? null;
            $__row__data['__display__']['valor_total'] =  $param['orcamento_item_orcamento_valor_total'] ?? null;
            $__row__data['__display__']['numero_pedido'] =  $param['orcamento_item_orcamento_numero_pedido'] ?? null;
            $__row__data['__display__']['numero_item_pedido'] =  $param['orcamento_item_orcamento_numero_item_pedido'] ?? null;
            $__row__data['__display__']['informacoes_adicionais'] =  $param['orcamento_item_orcamento_informacoes_adicionais'] ?? null;
            $__row__data['__display__']['id'] =  $param['orcamento_item_orcamento_id'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->orcamento_item_orcamento_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('orcamento_item_orcamento_list', $grid_data->__row__id, $row);

            TTransaction::close();

            TSession::setValue('orc_editou_prod', 'N');

            $data = new stdClass;
            $data->orcamento_item_orcamento_produto_id = '';
            $data->produto_nome = '';
            $data->orcamento_item_orcamento_quantidade = '';
            $data->orcamento_item_orcamento_valor_unitario = '';
            $data->orcamento_item_orcamento_desconto = '';
            $data->orcamento_item_orcamento_valor_frete = '';
            $data->orcamento_item_orcamento_valor_total = '';
            $data->orcamento_item_orcamento_numero_pedido = '';
            $data->orcamento_item_orcamento_numero_item_pedido = '';
            $data->orcamento_item_orcamento_informacoes_adicionais = '';
            $data->orcamento_item_orcamento_id = '';
            $data->orcamento_item_orcamento__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63eba3cace9e2');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailOrcamentoItem($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            TSession::setValue('orc_editou_prod', 'S');

            $data = new stdClass;
            $data->orcamento_item_orcamento_produto_id = $__row__data->__display__->produto_id ?? null;
            $data->produto_nome = $__row__data->__display__->produto_nome ?? null;
            $data->orcamento_item_orcamento_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->orcamento_item_orcamento_valor_unitario = $__row__data->__display__->valor_unitario ?? null;
            $data->orcamento_item_orcamento_desconto = $__row__data->__display__->desconto ?? null;
            $data->orcamento_item_orcamento_valor_frete = $__row__data->__display__->valor_frete ?? null;
            $data->orcamento_item_orcamento_valor_total = $__row__data->__display__->valor_total ?? null;
            $data->orcamento_item_orcamento_numero_pedido = $__row__data->__display__->numero_pedido ?? null;
            $data->orcamento_item_orcamento_numero_item_pedido = $__row__data->__display__->numero_item_pedido ?? null;
            $data->orcamento_item_orcamento_informacoes_adicionais = $__row__data->__display__->informacoes_adicionais ?? null;
            $data->orcamento_item_orcamento_id = $__row__data->__display__->id ?? null;
            $data->orcamento_item_orcamento__row__id = $__row__data->__row__id;

            TTransaction::open(self::$database);
            $data->produto_nome = Produto::find($data->orcamento_item_orcamento_produto_id)->nome;
            TTransaction::close();

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#63eba3cace9e2');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailOrcamentoItem($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->orcamento_item_orcamento_produto_id = '';
            $data->produto_nome = '';
            $data->orcamento_item_orcamento_quantidade = '';
            $data->orcamento_item_orcamento_valor_unitario = '';
            $data->orcamento_item_orcamento_desconto = '';
            $data->orcamento_item_orcamento_valor_frete = '';
            $data->orcamento_item_orcamento_valor_total = '';
            $data->orcamento_item_orcamento_numero_pedido = '';
            $data->orcamento_item_orcamento_numero_item_pedido = '';
            $data->orcamento_item_orcamento_informacoes_adicionais = '';
            $data->orcamento_item_orcamento_id = '';
            $data->orcamento_item_orcamento__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('orcamento_item_orcamento_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Orcamento(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //Funcoes::SalvarUsuarioCadastro($object);
            
            if ($object->id=='')
            {
               $object->criado_por = TSession::getValue('username');
               $object->criado_em = date("Y-m-d H:i:s"); 
            }
            else
            {
               $object->alterado_por = TSession::getValue('username');
               $object->alterado_em = date("Y-m-d H:i:s"); 
            }            

            $id = $object->id;

            $object->system_unit_id = TSession::getValue('userunitid');

            $object->store(); // save the object 

            if (isset($id))
            {
                OrcamentoSituacaoHistorico::LancarHistorico(OrcamentoSituacao::Aberto, $object->id, 'Situação do Orçamento: Aberto');
            }    

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $loadPageParam["key"] = "$object->id"; 

            $orcamento_item_orcamento_items = $this->storeMasterDetailItems('OrcamentoItem', 'orcamento_id', 'orcamento_item_orcamento', $object, $param['orcamento_item_orcamento_list___row__data'] ?? [], $this->form, $this->orcamento_item_orcamento_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->orcamento_item_orcamento_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            Orcamento::recalcula_itens_orcamento($object);

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Orçamento salvo!", 'topRight', 'far:check-circle');
            TApplication::loadPage('OrcamentoFormView', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacaoOrcamento($param = null) 
    {
        try 
        {
            //code here
            $pageParam = ['key' => $param['id']];

            if($param['id']=="")
            {
                throw new Exception("Salve o orçamento para entrar no modo visualização!");
            }
            else
                TApplication::loadPage('OrcamentoFormView', 'onShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Orcamento($key); // instantiates the Active Record 

                $orcamento_item_orcamento_items = $this->loadMasterDetailItems('OrcamentoItem', 'orcamento_id', 'orcamento_item_orcamento', $object, $this->form, $this->orcamento_item_orcamento_list, $this->orcamento_item_orcamento_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                    $objectItems->orcamento_item_orcamento_produto_id = null;
                    if(isset($detailObject->produto_id) && $detailObject->produto_id)
                    {
                        $objectItems->__display__->produto_id = $detailObject->produto_id;
                    }

                    $objectItems->orcamento_item_orcamento_produto_id = null;
                    if(isset($detailObject->produto_id) && $detailObject->produto_id)
                    {
                        $objectItems->__display__->produto_id = $detailObject->produto_id;
                    }

                }); 

                $this->form->setData($object); // fill the form 

                $dados = new stdClass();
                $dados->cliente_nome = $object->cliente->nome;
                TForm::sendData(self::$formName, $dados);

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->data_orcamento = date('d/m/Y H:i');
        $object->system_unit_id = TSession::getValue('userunitid');
        $object->criado_por = TSession::getValue('username');
        $object->criado_em = date("Y-m-d H:i:s");
        $object->orcamento_situacao_id = OrcamentoSituacao::Aberto;

        TForm::sendData(self::$formName, $object);

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
            if(isset($object->orcamento_item_orcamento_produto_id))
            {
                $value = $object->orcamento_item_orcamento_produto_id;

                $obj->orcamento_item_orcamento_produto_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
            if(isset($object->produto_id))
            {
                $value = $object->produto_id;

                $obj->orcamento_item_orcamento_produto_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

