<?php

class OrcamentoFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Orcamento';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Orcamento';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $orcamento = new Orcamento($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Orçamento");

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'OrcamentoSituacao', 'id', '{descricao}','ordem asc' );
        $label2 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($orcamento->id, '', '15px', '');
        $label4 = new TLabel("Data:", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay(TDate::convertToMask($orcamento->data_orcamento, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbsituacaocor = new TLabel("Situação:", '', '15px', 'B', '100%');
        $txtsituacaocor = new TTextDisplay($orcamento->situacao_cor, '', '15px', '');
        $label20 = new TLabel("Cliente:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay($orcamento->cliente->nome, '', '15px', '');
        $label21 = new TLabel("Vendedor:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($orcamento->vendedor->nome, '', '15px', '');
        $label22 = new TLabel("Cliente contato:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay($orcamento->cliente_contato->nome, '', '15px', '');
        $label23 = new TLabel("Tabela preco:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay($orcamento->tabela_preco->descricao, '', '15px', '');
        $label24 = new TLabel("Observação:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay($orcamento->observacao, '', '15px', '');
        $label30 = new TLabel("Justificativa de Reprovação:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay($orcamento->justificativa_reprovacao, '', '15px', '');
        $label29 = new TLabel("Total Produtos:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay(number_format((double)$orcamento->valor_produtos, '2', ',', '.'), '', '15px', '');
        $label31 = new TLabel("Total Frete:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(number_format((double)$orcamento->frete_total, '2', ',', '.'), '', '15px', '');
        $label33 = new TLabel("Valor Total:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(number_format((double)$orcamento->valor_total, '2', ',', '.'), '', '15px', '');
        $label35 = new TLabel("Peso Total:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay(number_format((double)$orcamento->peso_total, '2', ',', '.'), '', '15px', '');
        $label37 = new TLabel("Desconto:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(number_format((double)$orcamento->desconto, '2', ',', '.'), '', '15px', '');
        $label25 = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text8 = new TTextDisplay(TDateTime::convertToMask($orcamento->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label26 = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($orcamento->criado_por, '', '15px', '');
        $label27 = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text12 = new TTextDisplay(TDateTime::convertToMask($orcamento->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label28 = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay($orcamento->alterado_por, '', '15px', '');

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#ffffff');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($orcamento->orcamento_situacao_id);


        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$label2,$text1],[$label4,$text7],[$lbsituacaocor,$txtsituacaocor]);
        $row2->layout = ['col-sm-3','col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([$label20,$text5],[$label21,$text4]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([$label22,$text6],[$label23,$text19]);
        $row4->layout = [' col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([$label24,$text13]);
        $row5->layout = [' col-sm-12'];

        $row6 = $this->form->addFields([$label30,$text20]);
        $row6->layout = [' col-sm-12'];

        $tab_63fd03e449a9d = new BootstrapFormBuilder('tab_63fd03e449a9d');
        $this->tab_63fd03e449a9d = $tab_63fd03e449a9d;
        $tab_63fd03e449a9d->setProperty('style', 'border:none; box-shadow:none;');

        $tab_63fd03e449a9d->appendPage("Produtos");

        $tab_63fd03e449a9d->addFields([new THidden('current_tab_tab_63fd03e449a9d')]);
        $tab_63fd03e449a9d->setTabFunction("$('[name=current_tab_tab_63fd03e449a9d]').val($(this).attr('data-current_page'));");

        $this->orcamento_item_orcamento_id_list = new TQuickGrid;
        $this->orcamento_item_orcamento_id_list->disableHtmlConversion();
        $this->orcamento_item_orcamento_id_list->style = 'width:100%';
        $this->orcamento_item_orcamento_id_list->disableDefaultClick();

        $column_produto_id = $this->orcamento_item_orcamento_id_list->addQuickColumn("Cód. Prod.", 'produto_id', 'left');
        $column_produto_nome = $this->orcamento_item_orcamento_id_list->addQuickColumn("Produto", 'produto->nome', 'left');
        $column_quantidade_transformed = $this->orcamento_item_orcamento_id_list->addQuickColumn("Quantidade", 'quantidade', 'right');
        $column_valor_unitario_transformed = $this->orcamento_item_orcamento_id_list->addQuickColumn("Valor Unitário", 'valor_unitario', 'right');
        $column_desconto_transformed = $this->orcamento_item_orcamento_id_list->addQuickColumn("Desconto", 'desconto', 'left');
        $column_valor_frete_transformed = $this->orcamento_item_orcamento_id_list->addQuickColumn("Valor Frete", 'valor_frete', 'right');
        $column_valor_total_transformed = $this->orcamento_item_orcamento_id_list->addQuickColumn("Valor Total", 'valor_total', 'right');
        $column_numero_pedido = $this->orcamento_item_orcamento_id_list->addQuickColumn("Número Pedido", 'numero_pedido', 'left');
        $column_numero_item_pedido = $this->orcamento_item_orcamento_id_list->addQuickColumn("Número Item Pedido", 'numero_item_pedido', 'left');
        $column_informacoes_adicionais = $this->orcamento_item_orcamento_id_list->addQuickColumn("Informações Adicionais", 'informacoes_adicionais', 'left');

        $column_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_desconto_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_valor_frete_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->orcamento_item_orcamento_id_list->createModel();

        $criteria_orcamento_item_orcamento_id = new TCriteria();
        $criteria_orcamento_item_orcamento_id->add(new TFilter('orcamento_id', '=', $orcamento->id));

        $criteria_orcamento_item_orcamento_id->setProperty('order', 'id desc');

        $orcamento_item_orcamento_id_items = OrcamentoItem::getObjects($criteria_orcamento_item_orcamento_id);

        $this->orcamento_item_orcamento_id_list->addItems($orcamento_item_orcamento_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->orcamento_item_orcamento_id_list));

        $tab_63fd03e449a9d->addContent([$panel]);

        $tab_63fd03e449a9d->appendPage("Totais");
        $row7 = $tab_63fd03e449a9d->addFields([$label29,$text14],[$label31,$text17]);
        $row7->layout = [' col-sm-6','col-sm-6'];

        $row8 = $tab_63fd03e449a9d->addFields([$label33,$text18],[$label35,$text16]);
        $row8->layout = [' col-sm-6','col-sm-6'];

        $row9 = $tab_63fd03e449a9d->addFields([$label37,$text15],[]);
        $row9->layout = [' col-sm-6','col-sm-6'];

        $row10 = $this->form->addFields([$tab_63fd03e449a9d]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row12 = $this->form->addFields([$label25,$text8],[$label26,$text11],[$label27,$text12],[$label28,$text10]);
        $row12->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        if(!empty($param['current_tab_tab_63fd03e449a9d']))
        {
            $this->tab_63fd03e449a9d->setCurrentPage($param['current_tab_tab_63fd03e449a9d']);
        }

        $btnEditarAction = new TAction(['OrcamentoForm', 'onEdit'],['key'=>$orcamento->id]);
        $btnEditarLabel = new TLabel("Editar");

        $btnEditar = $this->form->addHeaderAction($btnEditarLabel, $btnEditarAction, 'fas:edit #2196F3'); 
        $btnEditarLabel->setFontSize('12px'); 
        $btnEditarLabel->setFontColor('#333'); 

        $btnOrcamentoDocumentOnGenerateAction = new TAction(['OrcamentoDocument', 'onGenerate'],['key'=>$orcamento->id]);
        $btnOrcamentoDocumentOnGenerateLabel = new TLabel("Imprimir");

        $btnOrcamentoDocumentOnGenerate = $this->form->addHeaderAction($btnOrcamentoDocumentOnGenerateLabel, $btnOrcamentoDocumentOnGenerateAction, 'fas:print #FF5722'); 
        $btnOrcamentoDocumentOnGenerateLabel->setFontSize('12px'); 
        $btnOrcamentoDocumentOnGenerateLabel->setFontColor('#333'); 

        $btnOrcamentoEmailFormOnShowAction = new TAction(['OrcamentoEmailForm', 'onShow'],['orcamento_id'=>$orcamento->id]);
        $btnOrcamentoEmailFormOnShowLabel = new TLabel("Enviar E-mail");

        $btnOrcamentoEmailFormOnShow = $this->form->addHeaderAction($btnOrcamentoEmailFormOnShowLabel, $btnOrcamentoEmailFormOnShowAction, 'fas:envelope #E91E63'); 
        $btnOrcamentoEmailFormOnShowLabel->setFontSize('12px'); 
        $btnOrcamentoEmailFormOnShowLabel->setFontColor('#333'); 

        $btnGerarVendaAction = new TAction([$this, 'onGerarVenda'],['key'=>$orcamento->id]);
        $btnGerarVendaLabel = new TLabel("Gerar Venda");

        $btnGerarVenda = $this->form->addHeaderAction($btnGerarVendaLabel, $btnGerarVendaAction, 'fas:thumbs-up #4CAF50'); 
        $btnGerarVendaLabel->setFontSize('12px'); 
        $btnGerarVendaLabel->setFontColor('#333'); 

        $btnReprovarAction = new TAction([$this, 'onReprovar'],['key'=>$orcamento->id]);
        $btnReprovarLabel = new TLabel("Reprovar");

        $btnReprovar = $this->form->addHeaderAction($btnReprovarLabel, $btnReprovarAction, 'fas:thumbs-down #FF5722'); 
        $btnReprovarLabel->setFontSize('12px'); 
        $btnReprovarLabel->setFontColor('#333'); 

        $btnOrcamentoSituacaoHistoricoTimeLineOnShowAction = new TAction(['OrcamentoSituacaoHistoricoTimeLine', 'onShow'],['key'=>$orcamento->id]);
        $btnOrcamentoSituacaoHistoricoTimeLineOnShowLabel = new TLabel("Linha do tempo das situações deste orçamento");

        $btnOrcamentoSituacaoHistoricoTimeLineOnShow = $this->form->addHeaderAction($btnOrcamentoSituacaoHistoricoTimeLineOnShowLabel, $btnOrcamentoSituacaoHistoricoTimeLineOnShowAction, 'fas:clock #FF9800'); 
        $btnOrcamentoSituacaoHistoricoTimeLineOnShowLabel->setFontSize('12px'); 
        $btnOrcamentoSituacaoHistoricoTimeLineOnShowLabel->setFontColor('#333'); 

        $btnCancelarAction = new TAction([$this, 'onCancelar'],['key'=>$orcamento->id]);
        $btnCancelarLabel = new TLabel("Cancelar");

        $btnCancelar = $this->form->addHeaderAction($btnCancelarLabel, $btnCancelarAction, 'fas:window-close #CE0D0D'); 
        $btnCancelarLabel->setFontSize('12px'); 
        $btnCancelarLabel->setFontColor('#333'); 

        $btnOrcamentoListOnShowAction = new TAction(['OrcamentoList', 'onShow']);
        $btnOrcamentoListOnShowLabel = new TLabel("Voltar");

        $btnOrcamentoListOnShow = $this->form->addHeaderAction($btnOrcamentoListOnShowLabel, $btnOrcamentoListOnShowAction, 'fas:arrow-alt-circle-left #000000'); 
        $btnOrcamentoListOnShowLabel->setFontSize('12px'); 
        $btnOrcamentoListOnShowLabel->setFontColor('#333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Visualizar Orçamento"]));
        }
        $container->add($this->form);

        if($orcamento->orcamento_situacao_id==OrcamentoSituacao::Aprovado
        or $orcamento->orcamento_situacao_id==OrcamentoSituacao::Cancelado
        or $orcamento->orcamento_situacao_id==OrcamentoSituacao::Reprovado)
        {
            $btnGerarVenda->style = 'display:none';
            $btnCancelar->style = 'display:none';
            $btnReprovar->style = 'display:none';
            $btnEditar->style = 'display:none';
        }

        TTransaction::close();
        parent::add($container);

    }

    public function onGerarVenda($param = null) 
    {
        try 
        {
            new TQuestion("Deseja aprovar o orçamento e gerar a venda?", new TAction([__CLASS__, 'onGerarVendaYes'], $param), new TAction([__CLASS__, 'onGerarVendaNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onReprovar($param = null) 
    {
        try 
        {
            //code here
            $pageParam = ['id' => $param['key']];
            TApplication::loadPage('ReprovarOrcamentoForm', 'onShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onCancelar($param = null) 
    {
        try 
        {
            //code here
            new TQuestion("Deseja cancelar o orçamento?", new TAction([__CLASS__, 'onCancelarYes'], $param), new TAction([__CLASS__, 'onCancelarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onGerarVendaYes($param = null) 
    {
        try 
        {
            //code here
            TTransaction::open(self::$database);

            $orcamento = Orcamento::find($param['key']);

            if($orcamento)
            {
                Orcamento::GerarVenda($orcamento);

                OrcamentoSituacaoHistorico::LancarHistorico(OrcamentoSituacao::Aprovado, $orcamento->id, 'Mudança de Situação do Orçamento: Aprovado');
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $orcamento->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarVendaNo($param = null) 
    {
        try 
        {
            //code here

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarYes($param = null) 
    {
        try 
        {
            //code here
            TTransaction::open(self::$database);

            $orcamento = Orcamento::find($param['key']);

            if($orcamento)
            {
                $orcamento->orcamento_situacao_id = OrcamentoSituacao::Cancelado;
                $orcamento->store();

                OrcamentoSituacaoHistorico::LancarHistorico(OrcamentoSituacao::Cancelado, $orcamento->id, 'Mudança de Situação do orçamento: Cancelado');
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $orcamento->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

