<?php

class RelatorioVendaPorProduto extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_RelatorioVendaPorProduto';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Relatório Venda Por Produto");


        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $data_venda_inicial = new TDate('data_venda_inicial');
        $data_venda_final = new TDate('data_venda_final');
        $produto_grupo = new TDBCombo('produto_grupo', 'kraftsoft', 'ProdutoGrupo', 'id', '{descricao}','descricao asc'  );
        $produto_subgrupo = new TDBCombo('produto_subgrupo', 'kraftsoft', 'ProdutogrupoSubgrupo', 'id', '{descricao}','descricao asc'  );


        $data_venda_final->setMask('dd/mm/yyyy');
        $data_venda_inicial->setMask('dd/mm/yyyy');

        $data_venda_final->setValue(date('d/m/Y'));
        $data_venda_inicial->setValue(date('d/m/Y'));

        $data_venda_final->setDatabaseMask('yyyy-mm-dd');
        $data_venda_inicial->setDatabaseMask('yyyy-mm-dd');

        $produto_grupo->enableSearch();
        $system_unit_id->enableSearch();
        $produto_subgrupo->enableSearch();

        $produto_grupo->setSize('100%');
        $system_unit_id->setSize('100%');
        $data_venda_final->setSize('100%');
        $produto_subgrupo->setSize('100%');
        $data_venda_inicial->setSize('100%');


        $row1 = $this->form->addFields([new TLabel("Filial:", null, '14px', null),$system_unit_id],[]);
        $row1->layout = [' col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Data Venda Inicial:", null, '14px', null, '100%'),$data_venda_inicial],[new TLabel("Data Venda Final:", null, '14px', null, '100%'),$data_venda_final]);
        $row2->layout = [' col-sm-6',' col-sm-6'];

        $row3 = $this->form->addFields([new TLabel("Grupo:", null, '14px', null, '100%'),$produto_grupo],[new TLabel("SubGrupo:", null, '14px', null, '100%'),$produto_subgrupo]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        // create the form actions
        $btn_ongerarplanilha = $this->form->addAction("Gerar Planilha", new TAction([$this, 'onGerarPlanilha']), 'fas:rocket #ffffff');
        $this->btn_ongerarplanilha = $btn_ongerarplanilha;
        $btn_ongerarplanilha->addStyleClass('btn-primary'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Relatório Venda Por Produto"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onGerarPlanilha($param = null) 
    {
        try
        {
            TTransaction::open('kraftsoft');

            $arquivo = 'app/output/'.uniqid().'.xls';

            $largura_colunas = [100,300,100,100,100,100,100,100];
            //$largura_colunas = [100];

            $planilha = new TTableWriterXLS($largura_colunas);

            $planilha->addRow();
            $planilha->addCell('CodProduto', 'left', 'title');
            $planilha->addCell('Produto', 'center', 'title');
            $planilha->addCell('Unidade', 'center', 'title');
            $planilha->addCell('Custo', 'center', 'title');
            $planilha->addCell('Qtde Total Vendido', 'center', 'title');
            $planilha->addCell('Valor Total Vendido', 'center', 'title');
            $planilha->addCell('Grupo Produto', 'center', 'title');
            // $planilha->addCell('SubGrupo Produto', 'center', 'title');
            //$planilha->addCell('Valor Margem', 'center', 'title');
            //$planilha->addCell('Distribuição Percentual', 'center', 'title');
            $planilha->addCell('Lucro', 'center', 'title');

            //$produtos = Produto::all();
            $conn = TTransaction::get();

            $sql = 'select p.id as CodigoProduto,
             p.nome as Produto,
             u.sigla as Unidade,
             g.descricao as Grupo_Produto,
             sum(i.quantidade) as QtdVendido,
             sum(i.valor_custo * i.quantidade) as Custo,
             sum(i.valor_total) as TotalVendido, 
             sum(i.valor_total-(i.valor_custo * i.quantidade)) as Lucro
             from venda_item i 
             inner join produto p on p.id = i.produto_id 
             inner join unidade_medida u on u.id = p.unidade_medida_id 
             inner join produto_grupo g on g.id = p.produto_grupo_id
             inner join venda v on v.id = i.venda_id '.
             'where v.data_hora_venda between "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'"'.
                                               ' and "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59"'.
             ' and v.system_unit_id='.$param['system_unit_id'].                                                        
             ' and v.venda_situacao_id = 4 and i.cancelado=2 group by 1,2,3,4';

	       // echo $sql;

            $listaprod = $conn->query($sql);

            foreach($listaprod as $prod)
            {
                $planilha->addRow();
                $planilha->addCell($prod['CodigoProduto'], 'left', 'data');
                $planilha->addCell($prod['Produto'], 'left', 'data');
                $planilha->addCell($prod['Unidade'], 'right', 'data');
                $planilha->addCell(number_format($prod['Custo'], 2, ',', '.'), 'right', 'data');
                $planilha->addCell(number_format($prod['QtdVendido'], 2, ',', '.'), 'right', 'data');
                $planilha->addCell(number_format($prod['TotalVendido'], 2, ',', '.'), 'right', 'data');
                $planilha->addCell($prod['Grupo_Produto'], 'right', 'data');
                $planilha->addCell(number_format($prod['Lucro'], 2, ',', '.'), 'right', 'data');
            }

            //echo $sql;

            $planilha->save($arquivo);

            TPage::openFile($arquivo);

            TTransaction::close();
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

    } 

}

