<?php

class RelatorioVendaSintetico extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_RelatorioVendaSintetico';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Relatório de vendas sintético ");


        $tipo_relatorio = new TCombo('tipo_relatorio');
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $data_venda_inicial = new TDate('data_venda_inicial');
        $data_venda_final = new TDate('data_venda_final');


        $tipo_relatorio->addItems(["1"=>"Dia","2"=>"Mês","3"=>"Ano"]);
        $tipo_relatorio->setDefaultOption(false);
        $system_unit_id->enableSearch();
        $data_venda_final->setMask('dd/mm/yyyy');
        $data_venda_inicial->setMask('dd/mm/yyyy');

        $data_venda_final->setDatabaseMask('yyyy-mm-dd');
        $data_venda_inicial->setDatabaseMask('yyyy-mm-dd');

        $tipo_relatorio->setValue('1');
        $data_venda_final->setValue(date('d/m/Y'));
        $data_venda_inicial->setValue(date('d/m/Y'));

        $tipo_relatorio->setSize('100%');
        $system_unit_id->setSize('100%');
        $data_venda_final->setSize('100%');
        $data_venda_inicial->setSize('100%');


        $row1 = $this->form->addFields([new TLabel("Período: ", null, '14px', null),$tipo_relatorio],[new TLabel("Filial:", null, '14px', null, '100%'),$system_unit_id]);
        $row1->layout = [' col-sm-6',' col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Data Venda Inicial:", null, '14px', null),$data_venda_inicial],[new TLabel("Data Venda Final:", null, '14px', null),$data_venda_final]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        // create the form actions
        $btn_ongerarplanilha = $this->form->addAction("Gerar Planilha ", new TAction([$this, 'onGerarPlanilha']), 'fas:rocket #ffffff');
        $this->btn_ongerarplanilha = $btn_ongerarplanilha;
        $btn_ongerarplanilha->addStyleClass('btn-primary'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Relatório de vendas sintético "]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onGerarPlanilha($param = null) 
    {
        try
        {
            TTransaction::open('kraftsoft');

            $arquivo = 'app/output/'.uniqid().'.xls';

            $largura_colunas = [100,400,100];

            $planilha = new TTableWriterXLS($largura_colunas);
            $planilha->addRow();
            $planilha->addCell('Período', 'center', 'title');
            $planilha->addCell('Total de Vendas', 'center', 'title');

            $conn = TTransaction::get();

            /*
            $sql_dia = '
                SELECT DATE_FORMAT(data_hora_venda, "%Y-%m-%d") as dia, SUM(valor_total) as total_vendas
                FROM venda
                WHERE data_hora_venda BETWEEN "' . date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))) . '"'
                . ' AND "' . date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59"' . ' and v.system_unit_id='.$param['system_unit_id'] .     
                'GROUP BY DATE(data_hora_venda)
            ';
            */

            /*
            $sql_dia = 'select v.data_hora_venda as Dia,
                    sum(v.valor_total) as totalVendido  
                    from venda v '.
                    'where v.data_hora_venda between "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'"'.
                                                      ' and "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59"'.
                    ' and v.system_unit_id='.$param['system_unit_id']';
            */

            if($param['tipo_relatorio'] == '1') //dia
            {
                if (!empty($param['system_unit_id']))
                {
                    $sql_dia = 'SELECT v.data_hora_venda as Dia,
                    SUM(v.valor_total) as totalVendido  
                    FROM venda v
                    WHERE v.data_hora_venda BETWEEN "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'" '.
                    ' AND "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59 "'.   
                    ' AND system_unit_id='.$param['system_unit_id']. 
                    ' and v.venda_situacao_id = 4
                    GROUP BY DATE(data_hora_venda)';
                }
                else
                {
                    $sql_dia = 'SELECT v.data_hora_venda as Dia,
                    SUM(v.valor_total) as totalVendido  
                    FROM venda v
                    WHERE v.data_hora_venda BETWEEN "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'" '.
                    ' AND "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59 "'.  
                    ' and v.venda_situacao_id = 4';
                }    

                //echo 'sql '.$sql_dia;

                $lista_dia = $conn->query($sql_dia);

                foreach($lista_dia as $venda)
                {
                    $data = $venda['Dia'];

                    $data_formatada = date("d/m/Y", strtotime($data));

                    $planilha->addRow();
                    $planilha->addCell($data_formatada, 'center', 'data');
                    $planilha->addCell(number_format($venda['totalVendido'], 2, ',', '.'), 'center', 'data');
                }
            }

            if($param['tipo_relatorio'] == '2') //mes
            {
                if(!empty($param['system_unit_id']))
                {
                    $sql_mes = ' SELECT DATE_FORMAT(data_hora_venda, "%Y-%m") AS mes, 
                                SUM(valor_total) AS total_vendas 
                                FROM venda v 
                                WHERE v.data_hora_venda BETWEEN "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'" '.
                                ' AND "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59 "'.
                                ' AND system_unit_id='.$param['system_unit_id'].
                                ' and v.venda_situacao_id = 4 '. 
                                'GROUP BY mes ';  
                }
                else
                {
                    $sql_mes = ' SELECT DATE_FORMAT(data_hora_venda, "%Y-%m") AS mes, 
                        SUM(valor_total) AS total_vendas 
                        FROM venda v 
                        WHERE v.data_hora_venda BETWEEN "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'" '.
                        ' AND "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59 "'.
                        ' and v.venda_situacao_id = 4 '. 
                        'GROUP BY mes ';
                }

                $lista_mes = $conn->query($sql_mes);

                foreach($lista_mes as $venda)
                {
                    setlocale(LC_TIME, 'pt_BR', 'pt_BR.utf-8', 'pt_BR.utf-8', 'portuguese');

                    $data = $venda['mes'];

                    $data_por_extenso = strftime('%B/%Y', strtotime($data));

                    $planilha->addRow();
                    $planilha->addCell($data_por_extenso, 'center', 'data');
                    $planilha->addCell(number_format($venda['total_vendas'], 2, ',', '.'), 'center', 'data');
                }
            }

            if($param['tipo_relatorio'] == '3') //ano
            {
                if(!empty($param['system_unit_id']))
                {
                    $sql_ano = 'SELECT DATE_FORMAT(data_hora_venda, "%Y") AS ano, 
                                SUM(valor_total) AS total_vendas 
                                FROM venda v
                                WHERE v.data_hora_venda BETWEEN "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'" '.
                                ' AND "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59 "'.
                                ' AND v.system_unit_id='.$param['system_unit_id'].
                                ' AND v.venda_situacao_id = 4 '.
                                'GROUP BY ano';
                }
                else 
                {
                    $sql_ano = 'SELECT DATE_FORMAT(data_hora_venda, "%Y") AS ano, 
                                SUM(valor_total) AS total_vendas 
                                FROM venda v
                                WHERE v.data_hora_venda BETWEEN "'.date(implode("-", array_reverse(explode("/", $param['data_venda_inicial'])))).'" '.
                                ' AND "'.date(implode("-", array_reverse(explode("/", $param['data_venda_final'])))).' 23:59:59 "'.
                                ' AND v.venda_situacao_id = 4 '.
                                'GROUP BY ano';
                }

                $lista_ano = $conn->query($sql_ano);

                foreach($lista_ano as $venda)
                {
                    $planilha->addRow();
                    $planilha->addCell($venda['ano'], 'center', 'data');
                    $planilha->addCell(number_format($venda['total_vendas'], 2, ',', '.'), 'center', 'data');
                }
            }

            $planilha->save($arquivo);

            TPage::openFile($arquivo);

            TTransaction::close();
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

    } 

}

