<?php

class ReprovarOrcamentoForm extends TWindow
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_ReprovarOrcamentoForm';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();
        parent::setSize(0.40, null);
        parent::setTitle("Reprovar Orçamento");
        parent::setProperty('class', 'window_modal');

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Reprovar Orçamento");


        $justificativa_reprovacao = new TText('justificativa_reprovacao');
        $id = new THidden('id');


        $id->setSize(200);
        $justificativa_reprovacao->setSize('100%', 150);


        $row1 = $this->form->addFields([new TLabel("Justificativa:", null, '14px', null, '100%'),$justificativa_reprovacao]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$id],[],[]);
        $row2->layout = ['col-sm-3','col-sm-3','col-sm-6'];

        // create the form actions
        $btn_onconfirmarreprovar = $this->form->addAction("Confirmar", new TAction([$this, 'onConfirmarReprovar']), 'fas:ban #ffffff');
        $this->btn_onconfirmarreprovar = $btn_onconfirmarreprovar;
        $btn_onconfirmarreprovar->addStyleClass('btn-danger'); 

        parent::add($this->form);

    }

    public function onConfirmarReprovar($param = null) 
    {
        try
        {
            TTransaction::open('kraftsoft');

            $this->form->validate();

            $data = $this->form->getData();

            $orcamento = Orcamento::find($data->id);

            if($orcamento)
            {
                $orcamento->justificativa_reprovacao = $data->justificativa_reprovacao;
                $orcamento->orcamento_situacao_id = OrcamentoSituacao::Reprovado;
                $orcamento->store();

                OrcamentoSituacaoHistorico::LancarHistorico(OrcamentoSituacao::Reprovado, $orcamento->id, 'Mudança de Situação do Orçamento: Reprovado');
            }

            TToast::show('success', "Orçamento reprovado com sucesso.", 'topRight', 'far:check-circle');
            TApplication::loadPage('OrcamentoList', 'onShow');

            TTransaction::close();
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {               

        $object = new stdClass();
        $object->id = $param['id'];

        TForm::sendData(self::$formName, $object);

    } 

}

