<?php

class VendaDevolucaoForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'VendaDevolucao';
    private static $primaryKey = 'id';
    private static $formName = 'form_VendaDevolucaoForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de devolução/troca de vendas");


        $id = new TEntry('id');
        $venda_id = new TEntry('venda_id');
        $venda_cliente_nome = new TDBCombo('venda_cliente_nome', 'kraftsoft', 'Cliente', 'id', '{nome}','nome asc'  );
        $data_devolucao = new TDate('data_devolucao');
        $valor = new TNumeric('valor', '2', ',', '.' );
        $system_unit_id = new TDBCombo('system_unit_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $venda_devolucao_itens_venda_devolucao_produto_id = new TDBCombo('venda_devolucao_itens_venda_devolucao_produto_id', 'kraftsoft', 'Produto', 'id', '{nome}','nome asc'  );
        $venda_devolucao_itens_venda_devolucao_id = new THidden('venda_devolucao_itens_venda_devolucao_id');
        $venda_devolucao_itens_venda_devolucao_quantidade = new TNumeric('venda_devolucao_itens_venda_devolucao_quantidade', '2', ',', '.' );
        $venda_devolucao_itens_venda_devolucao_valor_unitario = new TNumeric('venda_devolucao_itens_venda_devolucao_valor_unitario', '2', ',', '.' );
        $venda_devolucao_itens_venda_devolucao_valor_total = new TNumeric('venda_devolucao_itens_venda_devolucao_valor_total', '2', ',', '.' );
        $button_adicionar_venda_devolucao_itens_venda_devolucao = new TButton('button_adicionar_venda_devolucao_itens_venda_devolucao');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');

        $venda_devolucao_itens_venda_devolucao_quantidade->setExitAction(new TAction([$this,'onExitQuantidade']));

        $venda_id->addValidation("Venda id", new TRequiredValidator()); 
        $data_devolucao->addValidation("Data Devolução", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 

        $data_devolucao->setValue(date('d/m/Y'));
        $button_adicionar_venda_devolucao_itens_venda_devolucao->setAction(new TAction([$this, 'onAddDetailVendaDevolucaoItensVendaDevolucao'],['static' => 1]), "Adicionar");
        $button_adicionar_venda_devolucao_itens_venda_devolucao->addStyleClass('btn-default');
        $button_adicionar_venda_devolucao_itens_venda_devolucao->setImage('fas:plus #2ecc71');
        $system_unit_id->enableSearch();
        $venda_cliente_nome->enableSearch();
        $venda_devolucao_itens_venda_devolucao_produto_id->enableSearch();

        $data_devolucao->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');

        $data_devolucao->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $valor->setEditable(false);
        $venda_id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $system_unit_id->setEditable(false);
        $venda_devolucao_itens_venda_devolucao_produto_id->setEditable(false);
        $venda_devolucao_itens_venda_devolucao_valor_unitario->setEditable(false);

        $id->setSize('100%');
        $valor->setSize('100%');
        $venda_id->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $alterado_em->setSize('100%');
        $alterado_por->setSize('100%');
        $data_devolucao->setSize('100%');
        $system_unit_id->setSize('100%');
        $venda_cliente_nome->setSize('100%');
        $venda_devolucao_itens_venda_devolucao_id->setSize(200);
        $venda_devolucao_itens_venda_devolucao_produto_id->setSize('100%');
        $venda_devolucao_itens_venda_devolucao_quantidade->setSize('100%');
        $venda_devolucao_itens_venda_devolucao_valor_total->setSize('100%');
        $venda_devolucao_itens_venda_devolucao_valor_unitario->setSize('100%');

        $button_adicionar_venda_devolucao_itens_venda_devolucao->id = '6449207a7ffe6';

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Venda:", '#ff0000', '14px', null, '100%'),$venda_id],[new TLabel("Cliente:", null, '14px', null, '100%'),$venda_cliente_nome]);
        $row1->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row2 = $this->form->addFields([new TLabel("Data Devolução:", '#ff0000', '14px', null, '100%'),$data_devolucao],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor],[new TLabel("Filial: ", null, '14px', null, '100%'),$system_unit_id]);
        $row2->layout = ['col-sm-4','col-sm-4','col-sm-4'];

        $row3 = $this->form->addContent([new TFormSeparator("Itens que serão devolvidos ", '#333', '18', '#eee')]);

        $this->detailFormVendaDevolucaoItensVendaDevolucao = new BootstrapFormBuilder('detailFormVendaDevolucaoItensVendaDevolucao');
        $this->detailFormVendaDevolucaoItensVendaDevolucao->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormVendaDevolucaoItensVendaDevolucao->setProperty('class', 'form-horizontal builder-detail-form');

        $row4 = $this->detailFormVendaDevolucaoItensVendaDevolucao->addFields([new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$venda_devolucao_itens_venda_devolucao_produto_id,$venda_devolucao_itens_venda_devolucao_id],[new TLabel("Quant. à Devolver", '#ff0000', '14px', null, '100%'),$venda_devolucao_itens_venda_devolucao_quantidade]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->detailFormVendaDevolucaoItensVendaDevolucao->addFields([new TLabel("Valor Unitário:", null, '14px', null, '100%'),$venda_devolucao_itens_venda_devolucao_valor_unitario],[new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$venda_devolucao_itens_venda_devolucao_valor_total]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->detailFormVendaDevolucaoItensVendaDevolucao->addFields([$button_adicionar_venda_devolucao_itens_venda_devolucao]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->detailFormVendaDevolucaoItensVendaDevolucao->addFields([new THidden('venda_devolucao_itens_venda_devolucao__row__id')]);
        $this->venda_devolucao_itens_venda_devolucao_criteria = new TCriteria();

        $this->venda_devolucao_itens_venda_devolucao_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->venda_devolucao_itens_venda_devolucao_list->disableHtmlConversion();;
        $this->venda_devolucao_itens_venda_devolucao_list->generateHiddenFields();
        $this->venda_devolucao_itens_venda_devolucao_list->setId('venda_devolucao_itens_venda_devolucao_list');
        $this->venda_devolucao_itens_venda_devolucao_list->setMutationAction(new TAction([$this,'onCalcularTotal']));

        $this->venda_devolucao_itens_venda_devolucao_list->style = 'width:100%';
        $this->venda_devolucao_itens_venda_devolucao_list->class .= ' table-bordered';

        $column_venda_devolucao_itens_venda_devolucao_produto_nome = new TDataGridColumn('produto->nome', "Produto ", 'left');
        $column_venda_devolucao_itens_venda_devolucao_quantidade_transformed = new TDataGridColumn('quantidade', "Quant. à Devolver", 'left');
        $column_venda_devolucao_itens_venda_devolucao_valor_unitario_transformed = new TDataGridColumn('valor_unitario', "Valor Unitário", 'left');
        $column_venda_devolucao_itens_venda_devolucao_valor_total_transformed = new TDataGridColumn('valor_total', "Valor Total", 'left');

        $column_venda_devolucao_itens_venda_devolucao__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_venda_devolucao_itens_venda_devolucao__row__data->setVisibility(false);

        $action_onEditDetailVendaDevolucaoItens = new TDataGridAction(array('VendaDevolucaoForm', 'onEditDetailVendaDevolucaoItens'));
        $action_onEditDetailVendaDevolucaoItens->setUseButton(false);
        $action_onEditDetailVendaDevolucaoItens->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailVendaDevolucaoItens->setLabel("Editar");
        $action_onEditDetailVendaDevolucaoItens->setImage('far:edit #478fca');
        $action_onEditDetailVendaDevolucaoItens->setFields(['__row__id', '__row__data']);

        $this->venda_devolucao_itens_venda_devolucao_list->addAction($action_onEditDetailVendaDevolucaoItens);
        $action_onDeleteDetailVendaDevolucaoItens = new TDataGridAction(array('VendaDevolucaoForm', 'onDeleteDetailVendaDevolucaoItens'));
        $action_onDeleteDetailVendaDevolucaoItens->setUseButton(false);
        $action_onDeleteDetailVendaDevolucaoItens->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailVendaDevolucaoItens->setLabel("Excluir");
        $action_onDeleteDetailVendaDevolucaoItens->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailVendaDevolucaoItens->setFields(['__row__id', '__row__data']);

        $this->venda_devolucao_itens_venda_devolucao_list->addAction($action_onDeleteDetailVendaDevolucaoItens);

        $this->venda_devolucao_itens_venda_devolucao_list->addColumn($column_venda_devolucao_itens_venda_devolucao_produto_nome);
        $this->venda_devolucao_itens_venda_devolucao_list->addColumn($column_venda_devolucao_itens_venda_devolucao_quantidade_transformed);
        $this->venda_devolucao_itens_venda_devolucao_list->addColumn($column_venda_devolucao_itens_venda_devolucao_valor_unitario_transformed);
        $this->venda_devolucao_itens_venda_devolucao_list->addColumn($column_venda_devolucao_itens_venda_devolucao_valor_total_transformed);

        $this->venda_devolucao_itens_venda_devolucao_list->addColumn($column_venda_devolucao_itens_venda_devolucao__row__data);

        $this->venda_devolucao_itens_venda_devolucao_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->venda_devolucao_itens_venda_devolucao_list);
        $this->detailFormVendaDevolucaoItensVendaDevolucao->addContent([$tableResponsiveDiv]);

        $column_venda_devolucao_itens_venda_devolucao_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_venda_devolucao_itens_venda_devolucao_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_venda_devolucao_itens_venda_devolucao_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row8 = $this->form->addFields([$this->detailFormVendaDevolucaoItensVendaDevolucao]);
        $row8->layout = [' col-sm-12'];

        $row9 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row10 = $this->form->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row10->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacaodevolucao = $this->form->addAction("Modo visualização", new TAction([$this, 'onVisualizacaoDevolucao']), 'fas:align-justify #000000');
        $this->btn_onvisualizacaodevolucao = $btn_onvisualizacaodevolucao;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['VendaDevolucaoList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Cadastro de devolução/troca de vendas"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitQuantidade($param = null) 
    {
        try 
        {
            //code here

            $qtde = (double) str_replace(',', '.', str_replace('.', '', $param['venda_devolucao_itens_venda_devolucao_quantidade']));
            $valorUnit = (double) str_replace(',', '.', str_replace('.', '', $param['venda_devolucao_itens_venda_devolucao_valor_unitario']));

            $valorTotal = $qtde * $valorUnit;

            $object = new stdClass();
            $object->venda_devolucao_itens_venda_devolucao_valor_total = number_format($valorTotal, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCalcularTotal($param = null) 
    {
        try 
        {
            //code here
            $totalProdutos = 0;
            $totalVenda = 0;

            if(isset($param['list_data']))
            {
                foreach($param['list_data'] as $row)
                {
                    $valorUnit = (double) $row['valor_unitario'];
                    $qtde = (double) $row['quantidade'];
                    $totalProdutos += (double) ($valorUnit * $qtde);

                    $valorTotal = (double) $row['total'];

                    $totalVenda += floatval($valorUnit * $qtde);
                }
            }

            $totalProdutos = number_format($totalProdutos, 2, ',', '.');
            $totalVenda = number_format($totalVenda, 2, ',', '.');

            TScript::create("$('[name=valor]').val('{$totalVenda}')");

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailVendaDevolucaoItensVendaDevolucao($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if(!empty($param['customFormData']))
            {
                $data = $param['customFormData'];
            }

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Produto id", 'name'=>"venda_devolucao_itens_venda_devolucao_produto_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Quantidade", 'name'=>"venda_devolucao_itens_venda_devolucao_quantidade", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Total", 'name'=>"venda_devolucao_itens_venda_devolucao_valor_total", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->venda_devolucao_itens_venda_devolucao__row__id) ? $data->venda_devolucao_itens_venda_devolucao__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new VendaDevolucaoItens();
            $grid_data->__row__id = $__row__id;
            $grid_data->produto_id = $data->venda_devolucao_itens_venda_devolucao_produto_id;
            $grid_data->id = $data->venda_devolucao_itens_venda_devolucao_id;
            $grid_data->quantidade = $data->venda_devolucao_itens_venda_devolucao_quantidade;
            $grid_data->valor_unitario = $data->venda_devolucao_itens_venda_devolucao_valor_unitario;
            $grid_data->valor_total = $data->venda_devolucao_itens_venda_devolucao_valor_total;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['produto_id'] =  $param['venda_devolucao_itens_venda_devolucao_produto_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['venda_devolucao_itens_venda_devolucao_id'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['venda_devolucao_itens_venda_devolucao_quantidade'] ?? null;
            $__row__data['__display__']['valor_unitario'] =  $param['venda_devolucao_itens_venda_devolucao_valor_unitario'] ?? null;
            $__row__data['__display__']['valor_total'] =  $param['venda_devolucao_itens_venda_devolucao_valor_total'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->venda_devolucao_itens_venda_devolucao_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('venda_devolucao_itens_venda_devolucao_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->venda_devolucao_itens_venda_devolucao_produto_id = '';
            $data->venda_devolucao_itens_venda_devolucao_id = '';
            $data->venda_devolucao_itens_venda_devolucao_quantidade = '';
            $data->venda_devolucao_itens_venda_devolucao_valor_unitario = '';
            $data->venda_devolucao_itens_venda_devolucao_valor_total = '';
            $data->venda_devolucao_itens_venda_devolucao__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6449207a7ffe6');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailVendaDevolucaoItens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->venda_devolucao_itens_venda_devolucao_produto_id = $__row__data->__display__->produto_id ?? null;
            $data->venda_devolucao_itens_venda_devolucao_id = $__row__data->__display__->id ?? null;
            $data->venda_devolucao_itens_venda_devolucao_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->venda_devolucao_itens_venda_devolucao_valor_unitario = $__row__data->__display__->valor_unitario ?? null;
            $data->venda_devolucao_itens_venda_devolucao_valor_total = $__row__data->__display__->valor_total ?? null;
            $data->venda_devolucao_itens_venda_devolucao__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6449207a7ffe6');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailVendaDevolucaoItens($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->venda_devolucao_itens_venda_devolucao_produto_id = '';
            $data->venda_devolucao_itens_venda_devolucao_id = '';
            $data->venda_devolucao_itens_venda_devolucao_quantidade = '';
            $data->venda_devolucao_itens_venda_devolucao_valor_unitario = '';
            $data->venda_devolucao_itens_venda_devolucao_valor_total = '';
            $data->venda_devolucao_itens_venda_devolucao__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('venda_devolucao_itens_venda_devolucao_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new VendaDevolucao(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $loadPageParam["key"] = "$object->id"; 

            $venda_devolucao_itens_venda_devolucao_items = $this->storeMasterDetailItems('VendaDevolucaoItens', 'venda_devolucao_id', 'venda_devolucao_itens_venda_devolucao', $object, $param['venda_devolucao_itens_venda_devolucao_list___row__data'] ?? [], $this->form, $this->venda_devolucao_itens_venda_devolucao_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->venda_devolucao_itens_venda_devolucao_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('VendaDevolucaoFormView', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public function onVisualizacaoDevolucao($param = null) 
    {
        try 
        {
            //code here
            $pageParam = ['key' => $param['id']];

            if($param['id'] == "")
            {
                throw new Exception("Salve a devolução para entrar no modo visualização!");
            }
            else
                TApplication::loadPage('VendaDevolucaoFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new VendaDevolucao($key); // instantiates the Active Record 

                                $object->venda_cliente_nome = $object->venda->cliente->nome;

                $venda_devolucao_itens_venda_devolucao_items = $this->loadMasterDetailItems('VendaDevolucaoItens', 'venda_devolucao_id', 'venda_devolucao_itens_venda_devolucao', $object, $this->form, $this->venda_devolucao_itens_venda_devolucao_list, $this->venda_devolucao_itens_venda_devolucao_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->venda_id = $param['venda_id'];
        $object->system_unit_id = TSession::getValue('userunitid');
        //$object->venda_devolucao_itens_venda_devolucao_quantidade = 1;

        TForm::sendData(self::$formName, $object);

        //(new TRequiredValidator)->validate('venda_devolucao_itens_venda_devolucao_produto_id');
        //(new TRequiredValidator)->validate('venda_devolucao_itens_venda_devolucao_quantidade');
        //(new TRequiredValidator)->validate('venda_devolucao_itens_venda_devolucao_valor_unitario');
        //(new TRequiredValidator)->validate('venda_devolucao_itens_venda_devolucao_valor_total');

        TTransaction::open(self::$database);

        $lista_itens_venda = VendaItem::where('venda_id', '=', $param['venda_id'])->load();

        if($lista_itens_venda)
        {
            foreach($lista_itens_venda as $item_venda)
            {
                $object = new stdClass();
                $object->venda_devolucao_itens_venda_devolucao_id = '';
                $object->venda_devolucao_itens_venda_devolucao_produto_id = $item_venda->produto_id;
                $object->venda_devolucao_itens_venda_devolucao_quantidade = $item_venda->quantidade;
                $object->venda_devolucao_itens_venda_devolucao_valor_unitario = $item_venda->valor_unitario;
                $object->venda_devolucao_itens_venda_devolucao_valor_total = $item_venda->valor_total;

                $devolucao_form = new VendaDevolucaoForm([]);
                $devolucao_form->setIsWrapped(true);
                $devolucao_form->onAddDetailVendaDevolucaoItensVendaDevolucao([
                        'customFormData' => $object,
                        'venda_devolucao_itens_venda_devolucao_id' => $object->venda_devolucao_itens_venda_devolucao_id = '',
                        'venda_devolucao_itens_venda_devolucao_produto_id' => $object->venda_devolucao_itens_venda_devolucao_produto_id,
                        'venda_devolucao_itens_venda_devolucao_quantidade' => number_format($object->venda_devolucao_itens_venda_devolucao_quantidade, 2, ',', '.'),
                        'venda_devolucao_itens_venda_devolucao_valor_unitario' => number_format($object->venda_devolucao_itens_venda_devolucao_valor_unitario, 2, ',', '.'),
                        'venda_devolucao_itens_venda_devolucao_valor_total' => number_format($object->venda_devolucao_itens_venda_devolucao_valor_total, 2, ',', '.')
                    ]);

                $object->venda_devolucao_itens_venda_devolucao_id = '';
                $object->venda_devolucao_itens_venda_devolucao_produto_id = '';
                $object->venda_devolucao_itens_venda_devolucao_quantidade = '';
                $object->venda_devolucao_itens_venda_devolucao_valor_unitario = '';
                $object->venda_devolucao_itens_venda_devolucao_valor_total = '';

                //$object->valor = number_format($item_venda->valor_total, 2, ',', '.');

                TForm::sendData(self::$formName, $object);

            }
        }

        TTransaction::close();

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

