<?php

class VendaDevolucaoFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'VendaDevolucao';
    private static $primaryKey = 'id';
    private static $formName = 'formView_VendaDevolucao';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $venda_devolucao = new VendaDevolucao($param['key']);
        // define the form title
        $this->form->setFormTitle("Visualizar Devolução/troca");

        $label1 = new TLabel("Id:", '', '15px', 'B', '100%');
        $text1 = new TTextDisplay($venda_devolucao->id, '', '15px', '');
        $label3 = new TLabel("Venda:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($venda_devolucao->venda_id, '', '15px', '');
        $label2 = new TLabel("Filial:", '', '15px', 'B', '100%');
        $text2 = new TTextDisplay($venda_devolucao->system_unit->name, '', '15px', '');
        $label4 = new TLabel("Data Devolução:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay(TDate::convertToMask($venda_devolucao->data_devolucao, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $label5 = new TLabel("Valor:", '', '15px', 'B', '100%');
        $text5 = new TTextDisplay(number_format((double)$venda_devolucao->valor, '2', ',', '.'), '', '15px', '');
        $label6 = new TLabel("Criado Em:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay(TDateTime::convertToMask($venda_devolucao->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label9 = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($venda_devolucao->criado_por, '', '15px', '');
        $label8 = new TLabel("Alterado Em:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay(TDateTime::convertToMask($venda_devolucao->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $label21 = new TLabel("Alterado Por: ", '', '15px', 'B', '100%');
        $text7 = new TTextDisplay($venda_devolucao->alterado_por, '', '15px', '');

        $row1 = $this->form->addFields([$label1,$text1],[$label3,$text3],[$label2,$text2]);
        $row1->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row2 = $this->form->addFields([$label4,$text4],[$label5,$text5]);
        $row2->layout = [' col-sm-4',' col-sm-4'];

        $row3 = $this->form->addContent([new TFormSeparator("Itens Devolvidos", '#333', '18', '#eee')]);

        $this->venda_devolucao_itens_venda_devolucao_id_list = new TQuickGrid;
        $this->venda_devolucao_itens_venda_devolucao_id_list->disableHtmlConversion();
        $this->venda_devolucao_itens_venda_devolucao_id_list->style = 'width:100%';
        $this->venda_devolucao_itens_venda_devolucao_id_list->disableDefaultClick();

        $column_produto_nome = $this->venda_devolucao_itens_venda_devolucao_id_list->addQuickColumn("Produto", 'produto->nome', 'left');
        $column_quantidade_transformed = $this->venda_devolucao_itens_venda_devolucao_id_list->addQuickColumn("Quantidade Devolvida", 'quantidade', 'left');
        $column_valor_unitario_transformed = $this->venda_devolucao_itens_venda_devolucao_id_list->addQuickColumn("Valor Unitário", 'valor_unitario', 'left');
        $column_valor_total_transformed = $this->venda_devolucao_itens_venda_devolucao_id_list->addQuickColumn("Valor Total", 'valor_total', 'left');

        $column_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->venda_devolucao_itens_venda_devolucao_id_list->createModel();

        $criteria_venda_devolucao_itens_venda_devolucao_id = new TCriteria();
        $criteria_venda_devolucao_itens_venda_devolucao_id->add(new TFilter('venda_devolucao_id', '=', $venda_devolucao->id));

        $criteria_venda_devolucao_itens_venda_devolucao_id->setProperty('order', 'id desc');

        $venda_devolucao_itens_venda_devolucao_id_items = VendaDevolucaoItens::getObjects($criteria_venda_devolucao_itens_venda_devolucao_id);

        $this->venda_devolucao_itens_venda_devolucao_id_list->addItems($venda_devolucao_itens_venda_devolucao_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->venda_devolucao_itens_venda_devolucao_id_list));

        $this->form->addContent([$panel]);
        $row4 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row5 = $this->form->addFields([$label6,$text6],[$label9,$text9],[$label8,$text10],[$label21,$text7]);
        $row5->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $btnDevolucaoMercadoriaDocumentOnGenerateAction = new TAction(['DevolucaoMercadoriaDocument', 'onGenerate'],['key'=>$venda_devolucao->id]);
        $btnDevolucaoMercadoriaDocumentOnGenerateLabel = new TLabel("Imprimir");

        $btnDevolucaoMercadoriaDocumentOnGenerate = $this->form->addHeaderAction($btnDevolucaoMercadoriaDocumentOnGenerateLabel, $btnDevolucaoMercadoriaDocumentOnGenerateAction, 'fas:print #FF5722'); 
        $btnDevolucaoMercadoriaDocumentOnGenerateLabel->setFontSize('12px'); 
        $btnDevolucaoMercadoriaDocumentOnGenerateLabel->setFontColor('#333'); 

        $btnVendaDevolucaoListOnShowAction = new TAction(['VendaDevolucaoList', 'onShow']);
        $btnVendaDevolucaoListOnShowLabel = new TLabel("Voltar");

        $btnVendaDevolucaoListOnShow = $this->form->addHeaderAction($btnVendaDevolucaoListOnShowLabel, $btnVendaDevolucaoListOnShowAction, 'fas:arrow-alt-circle-left #000000'); 
        $btnVendaDevolucaoListOnShowLabel->setFontSize('12px'); 
        $btnVendaDevolucaoListOnShowLabel->setFontColor('#333'); 

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Visualizar Devolução/troca"]));
        }
        $container->add($this->form);

        TTransaction::close();
        parent::add($container);

    }

    public function onShow($param = null)
    {     

    }

}

