<?php

use fpdf\pdf;

class VendaEtiquetaDocument extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Venda';
    private static $primaryKey = 'id';
    private static $htmlFile = 'app/documents/VendaEtiquetaDocumentTemplate.html';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {

    }

    public static function onGenerate($param)
    {
        try 
        {
            TTransaction::open(self::$database);

            $class = self::$activeRecord;
            $object = new $class($param['key']);

            $html = new AdiantiHTMLDocumentParser(self::$htmlFile);
            $html->setMaster($object);

            $pageSize = 'A4';
            $document = 'tmp/'.uniqid().'.pdf'; 

            $pageSize = 'a6';

            $codigo_barras = new Picqer\Barcode\BarcodeGeneratorHTML();
            //$object->cliente_endereco->cep = $codigo_barras->getBarcode($object->cliente_endereco->cep, $codigo_barras::TYPE_CODE_128, $width = 1, $height = 30);
            $object->codigo_barras = $codigo_barras->getBarcode($object->cliente_endereco->cep, $codigo_barras::TYPE_CODE_128, $width = 3, $height = 75);

            if($object->venda_modalidade_id == VendaModalidade::EmpresaEntrega)
            { 
                if ($data->cliente_endereco_id==null)
                {
                   throw new Exception("Informe o endereço de entrega do cliente!");                    
                }
            }

            $html->process();

            $html->saveAsPDF($document, $pageSize, 'portrait');

            TTransaction::close();

            if(empty($param['returnFile']))
            {
                parent::openFile($document);

                new TMessage('info', _t('Document successfully generated'));    
            }
            else
            {
                return $document;
            }
        } 
        catch (Exception $e) 
        {
            // shows the exception error message
            new TMessage('error', $e->getMessage());

            // undo all pending operations
            TTransaction::rollback();
        }
    }

}

