<?php

class VendaForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Venda';
    private static $primaryKey = 'id';
    private static $formName = 'form_VendaForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de venda");

        $criteria_venda_item_venda_estoque_deposito_id = new TCriteria();

        $filterVar = TSession::getValue("userunitid");
        $criteria_venda_item_venda_estoque_deposito_id->add(new TFilter('system_unit_id', '=', $filterVar)); 

        TSession::setValue('venda_editou_prod', 'N');

        $venda_situacao_id = new TDBArrowStep('venda_situacao_id', 'kraftsoft', 'VendaSituacao', 'id', '{descricao}','ordem asc'  );
        $id = new TEntry('id');
        $data_hora_venda = new TDateTime('data_hora_venda');
        $orcamento_id = new TEntry('orcamento_id');
        $data_prev_entrega = new TDate('data_prev_entrega');
        $cliente_id = new TSeekButton('cliente_id');
        $cliente_nome = new TEntry('cliente_nome');
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $filial_saida_id = new TDBCombo('filial_saida_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $venda_tipo_pagamento_id = new TDBCombo('venda_tipo_pagamento_id', 'kraftsoft', 'VendaTipoPagamento', 'id', '{descricao}','descricao asc'  );
        $observacao = new TText('observacao');
        $observacao_nf = new TText('observacao_nf');
        $info_faturamento = new TText('info_faturamento');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $tabela_preco_id = new THidden('tabela_preco_id');
        $venda_item_venda_produto_id = new TSeekButton('venda_item_venda_produto_id');
        $produto_nome = new TEntry('produto_nome');
        $venda_item_venda_estoque_deposito_id = new TDBCombo('venda_item_venda_estoque_deposito_id', 'kraftsoft', 'EstoqueDeposito', 'id', '{descricao}','descricao asc' , $criteria_venda_item_venda_estoque_deposito_id );
        $venda_item_venda_produto_lote_id = new TDBCombo('venda_item_venda_produto_lote_id', 'kraftsoft', 'ProdutoLote', 'id', '{numero}','numero asc'  );
        $venda_item_venda_quantidade = new TNumeric('venda_item_venda_quantidade', '2', ',', '.' );
        $venda_item_venda_valor_unitario = new TNumeric('venda_item_venda_valor_unitario', '2', ',', '.' );
        $venda_item_venda_desconto = new TNumeric('venda_item_venda_desconto', '2', ',', '.' );
        $venda_item_venda_valor_frete = new TNumeric('venda_item_venda_valor_frete', '2', ',', '.' );
        $venda_item_venda_valor_total = new TNumeric('venda_item_venda_valor_total', '2', ',', '.' );
        $venda_item_venda_id = new THidden('venda_item_venda_id');
        $venda_item_venda_numero_pedido = new TEntry('venda_item_venda_numero_pedido');
        $venda_item_venda_numero_item_pedido = new TEntry('venda_item_venda_numero_item_pedido');
        $venda_item_venda_informacoes_adicionais = new TText('venda_item_venda_informacoes_adicionais');
        $button_adicionar_venda_item_venda = new TButton('button_adicionar_venda_item_venda');
        $venda_modalidade_id = new TDBCombo('venda_modalidade_id', 'kraftsoft', 'VendaModalidade', 'id', '{descricao}','descricao asc'  );
        $cliente_endereco_id = new TCombo('cliente_endereco_id');
        $venda_formapgto_venda_forma_pagamento_id = new TDBCombo('venda_formapgto_venda_forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $venda_formapgto_venda_id = new THidden('venda_formapgto_venda_id');
        $venda_formapgto_venda_valor = new TNumeric('venda_formapgto_venda_valor', '2', ',', '.' );
        $button_adicionar_venda_formapgto_venda = new TButton('button_adicionar_venda_formapgto_venda');
        $valor_produtos = new TNumeric('valor_produtos', '2', ',', '.' );
        $frete_total = new TNumeric('frete_total', '2', ',', '.' );
        $desconto = new TNumeric('desconto', '2', ',', '.' );
        $valor_total = new TNumeric('valor_total', '2', ',', '.' );
        $peso_total = new TNumeric('peso_total', '2', ',', '.' );
        $valor_troco = new TNumeric('valor_troco', '2', ',', '.' );
        $valor_avista = new TNumeric('valor_avista', '2', ',', '.' );
        $valor_aprazo = new TNumeric('valor_aprazo', '2', ',', '.' );
        $valor_comissao = new TEntry('valor_comissao');
        $comissao_avista = new TEntry('comissao_avista');
        $comissao_aprazo = new TEntry('comissao_aprazo');

        $venda_formapgto_venda_forma_pagamento_id->setChangeAction(new TAction([$this,'onExitFormaPgto']));

        $cliente_id->setExitAction(new TAction([$this,'onExitCliente']));
        $venda_item_venda_produto_id->setExitAction(new TAction([$this,'onExitProduto']));
        $venda_item_venda_quantidade->setExitAction(new TAction([$this,'onExitQuantidade']));
        $venda_item_venda_valor_unitario->setExitAction(new TAction([$this,'onExitValorUnitario']));

        $data_hora_venda->addValidation("Data Hora", new TRequiredValidator()); 
        $cliente_id->addValidation("Cliente", new TRequiredValidator()); 
        $filial_saida_id->addValidation("Filial de Saída", new TRequiredValidator()); 
        $venda_tipo_pagamento_id->addValidation("Venda tipo pagamento id", new TRequiredValidator()); 
        $venda_modalidade_id->addValidation("Venda modalidade id", new TRequiredValidator()); 
        $valor_produtos->addValidation("Valor Produtos", new TRequiredValidator()); 
        $valor_total->addValidation("Valor Total", new TRequiredValidator()); 

        $venda_situacao_id->setColorColumn('cor');
        $venda_situacao_id->setFilledColor('#fd9308');
        $venda_situacao_id->setFilledFontColor('#ffffff');
        $venda_situacao_id->setUnfilledColor('#d3d3d3');
        $venda_situacao_id->setUnfilledFontColor('#333333');
        $venda_item_venda_produto_lote_id->enableSearch();
        $venda_item_venda_estoque_deposito_id->enableSearch();

        $button_adicionar_venda_item_venda->setAction(new TAction([$this, 'onAddDetailVendaItemVenda'],['static' => 1]), "Adicionar");
        $button_adicionar_venda_formapgto_venda->setAction(new TAction([$this, 'onAddDetailVendaFormapgtoVenda'],['static' => 1]), "Adicionar");

        $button_adicionar_venda_item_venda->addStyleClass('btn-default');
        $button_adicionar_venda_formapgto_venda->addStyleClass('btn-default');

        $button_adicionar_venda_item_venda->setImage('fas:plus #2ecc71');
        $button_adicionar_venda_formapgto_venda->setImage('fas:plus #2ecc71');

        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $data_prev_entrega->setMask('dd/mm/yyyy');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_hora_venda->setMask('dd/mm/yyyy hh:ii');

        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_prev_entrega->setDatabaseMask('yyyy-mm-dd');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_hora_venda->setDatabaseMask('yyyy-mm-dd hh:ii');

        $venda_item_venda_desconto->setAllowNegative(false);
        $venda_item_venda_quantidade->setAllowNegative(false);
        $venda_item_venda_valor_frete->setAllowNegative(false);
        $venda_item_venda_valor_unitario->setAllowNegative(false);

        $id->setEditable(false);
        $desconto->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $peso_total->setEditable(false);
        $alterado_em->setEditable(false);
        $frete_total->setEditable(false);
        $valor_total->setEditable(false);
        $valor_troco->setEditable(false);
        $orcamento_id->setEditable(false);
        $cliente_nome->setEditable(false);
        $alterado_por->setEditable(false);
        $produto_nome->setEditable(false);
        $valor_avista->setEditable(false);
        $valor_aprazo->setEditable(false);
        $valor_produtos->setEditable(false);
        $valor_comissao->setEditable(false);
        $data_hora_venda->setEditable(false);
        $filial_saida_id->setEditable(false);
        $comissao_avista->setEditable(false);
        $comissao_aprazo->setEditable(false);
        $venda_situacao_id->setEditable(false);
        $venda_item_venda_valor_total->setEditable(false);

        $id->setSize('100%');
        $cliente_id->setSize(100);
        $desconto->setSize('100%');
        $criado_em->setSize('100%');
        $criado_por->setSize('100%');
        $peso_total->setSize('100%');
        $vendedor_id->setSize('100%');
        $alterado_em->setSize('100%');
        $frete_total->setSize('100%');
        $valor_total->setSize('100%');
        $valor_troco->setSize('100%');
        $orcamento_id->setSize('100%');
        $alterado_por->setSize('100%');
        $tabela_preco_id->setSize(200);
        $valor_avista->setSize('100%');
        $valor_aprazo->setSize('100%');
        $observacao->setSize('100%', 70);
        $valor_produtos->setSize('100%');
        $valor_comissao->setSize('100%');
        $data_hora_venda->setSize('100%');
        $filial_saida_id->setSize('100%');
        $comissao_avista->setSize('100%');
        $comissao_aprazo->setSize('100%');
        $venda_item_venda_id->setSize(200);
        $data_prev_entrega->setSize('100%');
        $observacao_nf->setSize('100%', 70);
        $venda_modalidade_id->setSize('100%');
        $cliente_endereco_id->setSize('100%');
        $info_faturamento->setSize('100%', 70);
        $venda_situacao_id->setSize('100%', 55);
        $venda_formapgto_venda_id->setSize(200);
        $venda_tipo_pagamento_id->setSize('100%');
        $venda_item_venda_produto_id->setSize(100);
        $venda_item_venda_desconto->setSize('100%');
        $cliente_nome->setSize('calc(100% - 130px)');
        $produto_nome->setSize('calc(100% - 120px)');
        $venda_item_venda_quantidade->setSize('100%');
        $venda_formapgto_venda_valor->setSize('100%');
        $venda_item_venda_valor_frete->setSize('100%');
        $venda_item_venda_valor_total->setSize('100%');
        $venda_item_venda_numero_pedido->setSize('100%');
        $venda_item_venda_valor_unitario->setSize('100%');
        $venda_item_venda_produto_lote_id->setSize('100%');
        $venda_item_venda_numero_item_pedido->setSize('100%');
        $venda_item_venda_estoque_deposito_id->setSize('100%');
        $venda_formapgto_venda_forma_pagamento_id->setSize('100%');
        $venda_item_venda_informacoes_adicionais->setSize('100%', 70);

        $button_adicionar_venda_item_venda->id = '62351a2667b83';
        $button_adicionar_venda_formapgto_venda->id = '624781ef21713';

        $seed = AdiantiApplicationConfig::get()['general']['seed'];
        $cliente_id_seekAction = new TAction(['ClienteSeekWindow', 'onShow']);
        $seekFilters = [];
        $seekFields = base64_encode(serialize([
            ['name'=> 'cliente_id', 'column'=>'{id}'],
            ['name'=> 'cliente_nome', 'column'=>'{nome}'],
            ['name'=> 'vendedor_id', 'column'=>'{vendedor_id}']
        ]));

        $seekFilters = base64_encode(serialize($seekFilters));
        $cliente_id_seekAction->setParameter('_seek_fields', $seekFields);
        $cliente_id_seekAction->setParameter('_seek_filters', $seekFilters);
        $cliente_id_seekAction->setParameter('_seek_hash', md5($seed.$seekFields.$seekFilters));
        $cliente_id->setAction($cliente_id_seekAction);

        $seed = AdiantiApplicationConfig::get()['general']['seed'];
        $venda_item_venda_produto_id_seekAction = new TAction(['ProdutoSeekWindow', 'onShow']);
        $seekFilters = [];
        $seekFields = base64_encode(serialize([
            ['name'=> 'venda_item_venda_produto_id', 'column'=>'{id}'],
            ['name'=> 'venda_item_venda_produto_id', 'column'=>'{id}'],
            ['name'=> 'produto_nome', 'column'=>'{nome}']
        ]));

        $seekFilters = base64_encode(serialize($seekFilters));
        $venda_item_venda_produto_id_seekAction->setParameter('_seek_fields', $seekFields);
        $venda_item_venda_produto_id_seekAction->setParameter('_seek_filters', $seekFilters);
        $venda_item_venda_produto_id_seekAction->setParameter('_seek_hash', md5($seed.$seekFields.$seekFilters));
        $venda_item_venda_produto_id->setAction($venda_item_venda_produto_id_seekAction);

        TTransaction::open(self::$database);

        $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', TSession::getValue('userunitid'))->first();

        if ($config_filial)
        {
            TSession::setValue('informar_duplicidade_de_item_venda_id', $config_filial->informar_duplicidade_de_item_venda_id);
         }

        TTransaction::close();

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([$venda_situacao_id]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id],[new TLabel("Data Hora:", '#ff0000', '14px', null, '100%'),$data_hora_venda],[new TLabel("Id Orcamento:", null, '14px', null, '100%'),$orcamento_id],[new TLabel("Data Previsão de Entrega:", null, '14px', null, '100%'),$data_prev_entrega]);
        $row2->layout = ['col-sm-3','col-sm-3','col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([new TLabel("Cliente:", '#FF0000', '14px', null, '100%'),$cliente_id,$cliente_nome],[new TLabel("Vendedor:", null, '14px', null, '100%'),$vendedor_id]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Filial de Saída:", '#ff0000', '14px', null, '100%'),$filial_saida_id],[new TLabel("Tipo de Pagamento:", '#ff0000', '14px', null, '100%'),$venda_tipo_pagamento_id]);
        $row4->layout = ['col-sm-6',' col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Observação:", null, '14px', null, '100%'),$observacao],[new TLabel("Observação para Nota Fiscal:", null, '14px', null, '100%'),$observacao_nf]);
        $row5->layout = ['col-sm-6','col-sm-6'];

        $row6 = $this->form->addFields([new TLabel("Informações para faturamento:", null, '14px', null),$info_faturamento]);
        $row6->layout = [' col-sm-12'];

        $row7 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row8 = $this->form->addFields([new TLabel("Criado em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null),$criado_por],[new TLabel("Alterado em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null),$alterado_por]);
        $row8->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row9 = $this->form->addFields([$tabela_preco_id]);
        $row9->layout = ['col-sm-3'];

        $this->form->appendPage("Produtos");

        $this->detailFormVendaItemVenda = new BootstrapFormBuilder('detailFormVendaItemVenda');
        $this->detailFormVendaItemVenda->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormVendaItemVenda->setProperty('class', 'form-horizontal builder-detail-form');

        $row10 = $this->detailFormVendaItemVenda->addFields([new TLabel("Produto:", '#ff0000', '14px', null, '100%'),$venda_item_venda_produto_id,$produto_nome]);
        $row10->layout = [' col-sm-12'];

        $row11 = $this->detailFormVendaItemVenda->addFields([new TLabel("Depósito:", '#FF0000', '14px', null),$venda_item_venda_estoque_deposito_id],[new TLabel("Lote:", null, '14px', null),$venda_item_venda_produto_lote_id]);
        $row11->layout = [' col-sm-6','col-sm-6'];

        $row12 = $this->detailFormVendaItemVenda->addFields([new TLabel("Quantidade:", '#ff0000', '14px', null, '100%'),$venda_item_venda_quantidade],[new TLabel("Valor Unitário:", '#ff0000', '14px', null, '100%'),$venda_item_venda_valor_unitario],[new TLabel("Desconto:", null, '14px', null, '100%'),$venda_item_venda_desconto]);
        $row12->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row13 = $this->detailFormVendaItemVenda->addFields([new TLabel("Frete:", null, '14px', null),$venda_item_venda_valor_frete],[new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$venda_item_venda_valor_total],[$venda_item_venda_id]);
        $row13->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row14 = $this->detailFormVendaItemVenda->addFields([new TLabel("Número Pedido:", null, '14px', null, '100%'),$venda_item_venda_numero_pedido],[new TLabel("Número Item Pedido:", null, '14px', null, '100%'),$venda_item_venda_numero_item_pedido]);
        $row14->layout = ['col-sm-6','col-sm-6'];

        $row15 = $this->detailFormVendaItemVenda->addFields([new TLabel("Informações Adicionais:", null, '14px', null, '100%'),$venda_item_venda_informacoes_adicionais]);
        $row15->layout = [' col-sm-12'];

        $row16 = $this->detailFormVendaItemVenda->addFields([$button_adicionar_venda_item_venda]);
        $row16->layout = [' col-sm-12'];

        $row17 = $this->detailFormVendaItemVenda->addFields([new THidden('venda_item_venda__row__id')]);
        $this->venda_item_venda_criteria = new TCriteria();

        $this->venda_item_venda_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->venda_item_venda_list->disableHtmlConversion();;
        $this->venda_item_venda_list->generateHiddenFields();
        $this->venda_item_venda_list->setId('venda_item_venda_list');
        $this->venda_item_venda_list->setMutationAction(new TAction([$this,'onCalculaTotal']));

        $this->venda_item_venda_list->style = 'width:100%';
        $this->venda_item_venda_list->class .= ' table-bordered';

        $column_venda_item_venda_produto_nome = new TDataGridColumn('produto->nome', "Produto", 'left');
        $column_venda_item_venda_quantidade_transformed = new TDataGridColumn('quantidade', "Quantidade", 'right');
        $column_venda_item_venda_valor_unitario_transformed = new TDataGridColumn('valor_unitario', "Valor Unitário", 'right');
        $column_venda_item_venda_desconto_transformed = new TDataGridColumn('desconto', "Desconto", 'right');
        $column_venda_item_venda_valor_total_transformed = new TDataGridColumn('valor_total', "Valor Total", 'right');
        $column_venda_item_venda_valor_frete_transformed = new TDataGridColumn('valor_frete', "Valor Frete", 'right');
        $column_venda_item_venda_peso_total_transformed = new TDataGridColumn('peso_total', "Peso Total", 'right');

        $column_venda_item_venda__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_venda_item_venda__row__data->setVisibility(false);

        $action_onEditDetailVendaItem = new TDataGridAction(array('VendaForm', 'onEditDetailVendaItem'));
        $action_onEditDetailVendaItem->setUseButton(true);
        $action_onEditDetailVendaItem->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailVendaItem->setLabel("Editar");
        $action_onEditDetailVendaItem->setImage('far:edit #478fca');
        $action_onEditDetailVendaItem->setFields(['__row__id', '__row__data']);

        $this->venda_item_venda_list->addAction($action_onEditDetailVendaItem);
        $action_onDeleteDetailVendaItem = new TDataGridAction(array('VendaForm', 'onDeleteDetailVendaItem'));
        $action_onDeleteDetailVendaItem->setUseButton(true);
        $action_onDeleteDetailVendaItem->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailVendaItem->setLabel("Excluir");
        $action_onDeleteDetailVendaItem->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailVendaItem->setFields(['__row__id', '__row__data']);

        $this->venda_item_venda_list->addAction($action_onDeleteDetailVendaItem);

        $this->venda_item_venda_list->addColumn($column_venda_item_venda_produto_nome);
        $this->venda_item_venda_list->addColumn($column_venda_item_venda_quantidade_transformed);
        $this->venda_item_venda_list->addColumn($column_venda_item_venda_valor_unitario_transformed);
        $this->venda_item_venda_list->addColumn($column_venda_item_venda_desconto_transformed);
        $this->venda_item_venda_list->addColumn($column_venda_item_venda_valor_total_transformed);
        $this->venda_item_venda_list->addColumn($column_venda_item_venda_valor_frete_transformed);
        $this->venda_item_venda_list->addColumn($column_venda_item_venda_peso_total_transformed);

        $this->venda_item_venda_list->addColumn($column_venda_item_venda__row__data);

        $this->venda_item_venda_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->venda_item_venda_list);
        $this->detailFormVendaItemVenda->addContent([$tableResponsiveDiv]);

        $column_venda_item_venda_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_venda_item_venda_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_venda_item_venda_desconto_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_venda_item_venda_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_venda_item_venda_valor_frete_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_venda_item_venda_peso_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });        $row18 = $this->form->addFields([$this->detailFormVendaItemVenda]);
        $row18->layout = [' col-sm-12'];

        $this->form->appendPage("Entrega");
        $row19 = $this->form->addFields([new TLabel("Modalidade:", '#ff0000', '14px', null, '100%'),$venda_modalidade_id]);
        $row19->layout = [' col-sm-12'];

        $row20 = $this->form->addFields([new TLabel("Endereço de Entrega:", null, '14px', null, '100%'),$cliente_endereco_id]);
        $row20->layout = [' col-sm-12'];

        $this->form->appendPage("Financeiro");

        $this->detailFormVendaFormapgtoVenda = new BootstrapFormBuilder('detailFormVendaFormapgtoVenda');
        $this->detailFormVendaFormapgtoVenda->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormVendaFormapgtoVenda->setProperty('class', 'form-horizontal builder-detail-form');

        $row21 = $this->detailFormVendaFormapgtoVenda->addFields([new TLabel("Forma de Pagamento:", '#ff0000', '14px', null, '100%'),$venda_formapgto_venda_forma_pagamento_id,$venda_formapgto_venda_id],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$venda_formapgto_venda_valor]);
        $row21->layout = ['col-sm-6','col-sm-6'];

        $row22 = $this->detailFormVendaFormapgtoVenda->addFields([$button_adicionar_venda_formapgto_venda]);
        $row22->layout = [' col-sm-12'];

        $row23 = $this->detailFormVendaFormapgtoVenda->addFields([new THidden('venda_formapgto_venda__row__id')]);
        $this->venda_formapgto_venda_criteria = new TCriteria();

        $this->venda_formapgto_venda_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->venda_formapgto_venda_list->disableHtmlConversion();;
        $this->venda_formapgto_venda_list->generateHiddenFields();
        $this->venda_formapgto_venda_list->setId('venda_formapgto_venda_list');

        $this->venda_formapgto_venda_list->style = 'width:100%';
        $this->venda_formapgto_venda_list->class .= ' table-bordered';

        $column_venda_formapgto_venda_forma_pagamento_descricao = new TDataGridColumn('forma_pagamento->descricao', "Forma de Pagamento", 'left');
        $column_venda_formapgto_venda_valor_transformed = new TDataGridColumn('valor', "Valor", 'left');

        $column_venda_formapgto_venda__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_venda_formapgto_venda__row__data->setVisibility(false);

        $column_venda_formapgto_venda_valor_transformed->enableTotal('sum', 'R$', 2, ',', '.');

        $action_onEditDetailVendaFormapgto = new TDataGridAction(array('VendaForm', 'onEditDetailVendaFormapgto'));
        $action_onEditDetailVendaFormapgto->setUseButton(true);
        $action_onEditDetailVendaFormapgto->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailVendaFormapgto->setLabel("Editar");
        $action_onEditDetailVendaFormapgto->setImage('far:edit #478fca');
        $action_onEditDetailVendaFormapgto->setFields(['__row__id', '__row__data']);

        $this->venda_formapgto_venda_list->addAction($action_onEditDetailVendaFormapgto);
        $action_onDeleteDetailVendaFormapgto = new TDataGridAction(array('VendaForm', 'onDeleteDetailVendaFormapgto'));
        $action_onDeleteDetailVendaFormapgto->setUseButton(true);
        $action_onDeleteDetailVendaFormapgto->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailVendaFormapgto->setLabel("Excluir");
        $action_onDeleteDetailVendaFormapgto->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailVendaFormapgto->setFields(['__row__id', '__row__data']);

        $this->venda_formapgto_venda_list->addAction($action_onDeleteDetailVendaFormapgto);
        $action_onVencimentos = new TDataGridAction(array('VendaForm', 'onVencimentos'));
        $action_onVencimentos->setUseButton(true);
        $action_onVencimentos->setButtonClass('btn btn-default btn-sm');
        $action_onVencimentos->setLabel("Vencimentos");
        $action_onVencimentos->setImage('fas:calendar-alt #00BCD4');
        $action_onVencimentos->setFields(['__row__id', '__row__data']);

        $this->venda_formapgto_venda_list->addAction($action_onVencimentos);

        $this->venda_formapgto_venda_list->addColumn($column_venda_formapgto_venda_forma_pagamento_descricao);
        $this->venda_formapgto_venda_list->addColumn($column_venda_formapgto_venda_valor_transformed);

        $this->venda_formapgto_venda_list->addColumn($column_venda_formapgto_venda__row__data);

        $this->venda_formapgto_venda_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->venda_formapgto_venda_list);
        $this->detailFormVendaFormapgtoVenda->addContent([$tableResponsiveDiv]);

        $column_venda_formapgto_venda_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });        $row24 = $this->form->addFields([$this->detailFormVendaFormapgtoVenda]);
        $row24->layout = [' col-sm-12'];

        $this->form->appendPage("Totais");
        $row25 = $this->form->addFields([new TLabel("Valor Produtos:", '#ff0000', '14px', null, '100%'),$valor_produtos],[new TLabel("Total Frete:", null, '14px', null, '100%'),$frete_total],[new TLabel("Desconto:", null, '14px', null, '100%'),$desconto]);
        $row25->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row26 = $this->form->addFields([new TLabel("Valor Total:", '#ff0000', '14px', null, '100%'),$valor_total],[new TLabel("Peso Total:", null, '14px', null, '100%'),$peso_total],[new TLabel("Troco:", null, '14px', null),$valor_troco]);
        $row26->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row27 = $this->form->addFields([new TLabel("Valor a vista:", null, '14px', null),$valor_avista],[new TLabel("Valor a prazo:", null, '14px', null),$valor_aprazo]);
        $row27->layout = [' col-sm-4',' col-sm-4'];

        $row28 = $this->form->addContent([new TFormSeparator("Comissões", '#333', '18', '#eee')]);
        $row29 = $this->form->addFields([new TLabel("Valor Comissão:", null, '14px', null),$valor_comissao],[new TLabel("Comissão a vista:", null, '14px', null),$comissao_avista],[new TLabel("Comissão a prazo:", null, '14px', null),$comissao_aprazo]);
        $row29->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onvisualizacaovenda = $this->form->addAction("Modo Visualização", new TAction([$this, 'onVisualizacaoVenda']), 'fas:bars #000000');
        $this->btn_onvisualizacaovenda = $btn_onvisualizacaovenda;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['VendaList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Cadastro de venda"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public static function onExitCliente($param = null) 
    {
        try 
        {
            if(isset($param['cliente_id']) && $param['cliente_id'])
            {
                TTransaction::open(self::$database);

                $cliente = Cliente::find($param['cliente_id']);

                $object = new stdClass();
                $object->cliente_contato_id = '';
                $object->cliente_endereco_id = '';
                $object->tabela_preco_id = $cliente->tabela_preco_id;
                $object->cliente_endereco_id = $cliente->cliente_endereco_id;
                TForm::sendData(self::$formName, $object);

                $criteria = new TCriteria();
                $criteria->add(new TFilter('cliente_id', '=', $param['cliente_id']));

                TDBCombo::reloadFromModel(self::$formName, 'cliente_endereco_id', self::$database, 'ClienteEndereco', 'id', '{logradouro}  - {numero} -  {bairro} - {cidade->nome} ', 'logradouro asc', $criteria, TRUE);

                TTransaction::close();
            }
            else
            {
                TCombo::clearField(self::$formName, 'cliente_endereco_id');
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitProduto($param = null) 
    {
        try 
        {
            $edita_prod = TSession::getValue('venda_editou_prod');
            // echo 'edita prod'.$edita_prod;

            if (isset($param['venda_item_venda_produto_id']) && $param['venda_item_venda_produto_id'] && $edita_prod=='N')
            {
                TTransaction::open(self::$database);

                $object = new stdClass();

                //trazer o preço da filial..
                $produtofilial = ProdutoFilial::where('produto_id', '=', $param['venda_item_venda_produto_id'])
                                              ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                              ->first();

                if($produtofilial)
                {                        
                    //veificando se o parceiro possui tabela de preço vinculada...
                    $tabelaprecoprod = TabelaPrecoProduto::where('produto_filial_id', '=', $produtofilial->id)
                                                         ->where('tabela_preco_id', '=', $param['tabela_preco_id'])
                                                         ->first();   

                    if ($tabelaprecoprod)
                    {
                       $valorproduto = $tabelaprecoprod->preco_venda;    
                    }
                    else
                    {
                       $valorproduto = $produtofilial->preco_venda;
                    }                                              

                    $object->venda_item_venda_quantidade = 1;
                    $object->venda_item_venda_valor_unitario = number_format($valorproduto, 2, ',', '.');  
                    $object->venda_item_venda_estoque_deposito_id = $produtofilial->estoque_deposito_padrao_id;
                }
                else
                {
                    new TMessage('error', 'Este produto não tem vinculo configurado para esta filial!');
                    $object->produto_nome = '';
                    $object->venda_item_venda_produto_id = '';
                }

                TTransaction::close();       

                //carregando os lotes se houver..
                $criteria = TCriteria::create(['produto_id' => $param['venda_item_venda_produto_id']]);
                TDBCombo::reloadFromModel(self::$formName, 'venda_item_venda_produto_lote_id', 'kraftsoft', 'ProdutoLote', 'id', '{numero}', 'numero asc', $criteria, TRUE);                      

                TForm::sendData(self::$formName, $object);
            }

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitQuantidade($param = null) 
    {
        try 
        {
            //code here
            $qtd = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_quantidade']));
            $vunitario = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_valor_unitario']));
            //$vfrete = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_valor_frete']));
            //$vdesconto = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_desconto']));

            $vtotal = $qtd * $vunitario;

            $object = new stdClass();
            $object->venda_item_venda_valor_total = number_format($vtotal, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitValorUnitario($param = null) 
    {
        try 
        {
            //code here
            $qtd = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_quantidade']));
            $vunitario = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_valor_unitario']));
            //$vfrete = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_valor_frete']));
            //$vdesconto = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_desconto']));

            $vtotal = $qtd * $vunitario;

            $object = new stdClass();
            $object->venda_item_venda_valor_total = number_format($vtotal, 2, ',', '.');
            TForm::sendData(self::$formName, $object);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onExitFormaPgto($param = null) 
    {
        try 
        {
            // Código gerado pelo snippet: "Enviar dados para campo"
            $object = new stdClass();
            $object->venda_formapgto_venda_valor = $param['valor_total'];
            TForm::sendData(self::$formName, $object);
            // -----

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCalculaTotal($param = null) 
    {
        try 
        {
            $totalprodutos = 0;
            $totalvenda = 0;
            $totalfrete = 0;
            $totaldesconto = 0;
            $pesototal = 0;

            if(isset($param['list_data']))
            {
                foreach($param['list_data'] as $row)
                {
                   /* $totalfrete += floatval($row['valor_frete']);
                    $totaldesconto += floatval($row['desconto']);  
                    $pesototal += floatval($row['peso_total']);  
                    $totalprodutos += floatval($row['valor_total']);

                    $vtotal = floatval($row['valor_total']);
                    $vfrete = floatval($row['valor_frete']);
                    $vdesconto = floatval($row['desconto']);

                    $totalvenda += floatval(($vtotal+$vfrete)-$vdesconto);  */

                    $vUnit = (double) $row['valor_unitario'];
                    $qtd = (double) $row['quantidade'];
                    $totalfrete += (double)  $row['valor_frete'];
                    $totaldesconto += (double) $row['desconto'];
                    $pesototal += (double) $row['peso_total'];
                    $totalprodutos += (double) ($vUnit * $qtd);//$row['valor_total'];                    

                    $vtotal = (double) $row['valor_total'];                    
                    $vfrete = (double)  $row['valor_frete'];                                        
                    $vdesconto = (double) $row['desconto'];                                                            

                    $totalvenda += floatval((($vUnit * $qtd) + $vfrete) - $vdesconto);                    
                }    
            }

            // $totalprodutos = (double) $totalprodutos;    
            // $totalvenda = (double) $totalvenda;
            // $totalfrete = (double) $totalfrete;
            // $totaldesconto = (double) $totaldesconto;
            // $pesototal = (double) $pesototal;

            $totalfrete   = number_format($totalfrete, 2, ',', '.');
            $totaldesconto   = number_format($totaldesconto, 2, ',', '.');
            $totalprodutos   = number_format($totalprodutos, 2, ',', '.');
            $totalvenda   = number_format($totalvenda, 2, ',', '.');
            $pesototal   = number_format($pesototal, 2, ',', '.');

            TScript::create("$('[name=desconto]').val('{$totaldesconto}')");
            TScript::create("$('[name=frete_total]').val('{$totalfrete}')");  
            TScript::create("$('[name=valor_produtos]').val('{$totalprodutos}')");
            TScript::create("$('[name=valor_total]').val('{$totalvenda}')");
            TScript::create("$('[name=peso_total]').val('{$pesototal}')");

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public  function onAddDetailVendaItemVenda($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            if (TSession::getValue('informar_duplicidade_de_item_venda_id') == Resposta::Sim)
            {
                if(!empty($param['venda_item_venda_list___row__data']))
                {
                    $rowId = $param['venda_item_venda__row__id'];
                    foreach($param['venda_item_venda_list___row__data'] as $rowDataCoded)
                    {
                        $rowDataDecoded = unserialize(base64_decode($rowDataCoded));    

                        if ($rowDataDecoded->produto_id == $data->venda_item_venda_produto_id)
                        {
                          new TMessage('info', 'Este produto já se encontra na lista!');  
                        }
                    }
                }
            }

            // $qtd = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_quantidade']));
            // $vunitario = (double) str_replace(',', '.', str_replace('.', '', $param['venda_item_venda_valor_unitario']));

            // $vtotal = $qtd * $vunitario;

            // $data->venda_item_venda_valor_total = number_format($vtotal, 2, ',', '.');            

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Produto", 'name'=>"venda_item_venda_produto_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Depósito", 'name'=>"venda_item_venda_estoque_deposito_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Quantidade", 'name'=>"venda_item_venda_quantidade", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Unitário", 'name'=>"venda_item_venda_valor_unitario", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor Total", 'name'=>"venda_item_venda_valor_total", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->venda_item_venda__row__id) ? $data->venda_item_venda__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new VendaItem();
            $grid_data->__row__id = $__row__id;
            $grid_data->produto_id = $data->venda_item_venda_produto_id;
            $grid_data->produto_nome = $data->produto_nome;
            $grid_data->estoque_deposito_id = $data->venda_item_venda_estoque_deposito_id;
            $grid_data->produto_lote_id = $data->venda_item_venda_produto_lote_id;
            $grid_data->quantidade = $data->venda_item_venda_quantidade;
            $grid_data->valor_unitario = $data->venda_item_venda_valor_unitario;
            $grid_data->desconto = $data->venda_item_venda_desconto;
            $grid_data->valor_frete = $data->venda_item_venda_valor_frete;
            $grid_data->valor_total = $data->venda_item_venda_valor_total;
            $grid_data->id = $data->venda_item_venda_id;
            $grid_data->numero_pedido = $data->venda_item_venda_numero_pedido;
            $grid_data->numero_item_pedido = $data->venda_item_venda_numero_item_pedido;
            $grid_data->informacoes_adicionais = $data->venda_item_venda_informacoes_adicionais;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['produto_id'] =  $param['venda_item_venda_produto_id'] ?? null;
            $__row__data['__display__']['produto_nome'] =  $param['produto_nome'] ?? null;
            $__row__data['__display__']['estoque_deposito_id'] =  $param['venda_item_venda_estoque_deposito_id'] ?? null;
            $__row__data['__display__']['produto_lote_id'] =  $param['venda_item_venda_produto_lote_id'] ?? null;
            $__row__data['__display__']['quantidade'] =  $param['venda_item_venda_quantidade'] ?? null;
            $__row__data['__display__']['valor_unitario'] =  $param['venda_item_venda_valor_unitario'] ?? null;
            $__row__data['__display__']['desconto'] =  $param['venda_item_venda_desconto'] ?? null;
            $__row__data['__display__']['valor_frete'] =  $param['venda_item_venda_valor_frete'] ?? null;
            $__row__data['__display__']['valor_total'] =  $param['venda_item_venda_valor_total'] ?? null;
            $__row__data['__display__']['id'] =  $param['venda_item_venda_id'] ?? null;
            $__row__data['__display__']['numero_pedido'] =  $param['venda_item_venda_numero_pedido'] ?? null;
            $__row__data['__display__']['numero_item_pedido'] =  $param['venda_item_venda_numero_item_pedido'] ?? null;
            $__row__data['__display__']['informacoes_adicionais'] =  $param['venda_item_venda_informacoes_adicionais'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->venda_item_venda_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('venda_item_venda_list', $grid_data->__row__id, $row);

            TTransaction::close();

            TSession::setValue('venda_editou_prod', 'N');

            $data = new stdClass;
            $data->venda_item_venda_produto_id = '';
            $data->produto_nome = '';
            $data->venda_item_venda_estoque_deposito_id = '';
            $data->venda_item_venda_produto_lote_id = '';
            $data->venda_item_venda_quantidade = '';
            $data->venda_item_venda_valor_unitario = '';
            $data->venda_item_venda_desconto = '';
            $data->venda_item_venda_valor_frete = '';
            $data->venda_item_venda_valor_total = '';
            $data->venda_item_venda_id = '';
            $data->venda_item_venda_numero_pedido = '';
            $data->venda_item_venda_numero_item_pedido = '';
            $data->venda_item_venda_informacoes_adicionais = '';
            $data->venda_item_venda__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#62351a2667b83');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public  function onAddDetailVendaFormapgtoVenda($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Forma pagamento id", 'name'=>"venda_formapgto_venda_forma_pagamento_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            $requiredFields[] = ['label'=>"Valor", 'name'=>"venda_formapgto_venda_valor", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->venda_formapgto_venda__row__id) ? $data->venda_formapgto_venda__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new VendaFormapgto();
            $grid_data->__row__id = $__row__id;
            $grid_data->forma_pagamento_id = $data->venda_formapgto_venda_forma_pagamento_id;
            $grid_data->id = $data->venda_formapgto_venda_id;
            $grid_data->valor = $data->venda_formapgto_venda_valor;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['forma_pagamento_id'] =  $param['venda_formapgto_venda_forma_pagamento_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['venda_formapgto_venda_id'] ?? null;
            $__row__data['__display__']['valor'] =  $param['venda_formapgto_venda_valor'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->venda_formapgto_venda_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('venda_formapgto_venda_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->venda_formapgto_venda_forma_pagamento_id = '';
            $data->venda_formapgto_venda_id = '';
            $data->venda_formapgto_venda_valor = '';
            $data->venda_formapgto_venda__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#624781ef21713');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailVendaItem($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            TSession::setValue('venda_editou_prod', 'S');

            $data = new stdClass;
            $data->venda_item_venda_produto_id = $__row__data->__display__->produto_id ?? null;
            $data->produto_nome = $__row__data->__display__->produto_nome ?? null;
            $data->venda_item_venda_estoque_deposito_id = $__row__data->__display__->estoque_deposito_id ?? null;
            $data->venda_item_venda_produto_lote_id = $__row__data->__display__->produto_lote_id ?? null;
            $data->venda_item_venda_quantidade = $__row__data->__display__->quantidade ?? null;
            $data->venda_item_venda_valor_unitario = $__row__data->__display__->valor_unitario ?? null;
            $data->venda_item_venda_desconto = $__row__data->__display__->desconto ?? null;
            $data->venda_item_venda_valor_frete = $__row__data->__display__->valor_frete ?? null;
            $data->venda_item_venda_valor_total = $__row__data->__display__->valor_total ?? null;
            $data->venda_item_venda_id = $__row__data->__display__->id ?? null;
            $data->venda_item_venda_numero_pedido = $__row__data->__display__->numero_pedido ?? null;
            $data->venda_item_venda_numero_item_pedido = $__row__data->__display__->numero_item_pedido ?? null;
            $data->venda_item_venda_informacoes_adicionais = $__row__data->__display__->informacoes_adicionais ?? null;
            $data->venda_item_venda__row__id = $__row__data->__row__id;

            TTransaction::open(self::$database);
            $data->produto_nome = Produto::find($data->venda_item_venda_produto_id)->nome;
            TTransaction::close();

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#62351a2667b83');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailVendaItem($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->venda_item_venda_produto_id = '';
            $data->produto_nome = '';
            $data->venda_item_venda_estoque_deposito_id = '';
            $data->venda_item_venda_produto_lote_id = '';
            $data->venda_item_venda_quantidade = '';
            $data->venda_item_venda_valor_unitario = '';
            $data->venda_item_venda_desconto = '';
            $data->venda_item_venda_valor_frete = '';
            $data->venda_item_venda_valor_total = '';
            $data->venda_item_venda_id = '';
            $data->venda_item_venda_numero_pedido = '';
            $data->venda_item_venda_numero_item_pedido = '';
            $data->venda_item_venda_informacoes_adicionais = '';
            $data->venda_item_venda__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('venda_item_venda_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onEditDetailVendaFormapgto($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->venda_formapgto_venda_forma_pagamento_id = $__row__data->__display__->forma_pagamento_id ?? null;
            $data->venda_formapgto_venda_id = $__row__data->__display__->id ?? null;
            $data->venda_formapgto_venda_valor = $__row__data->__display__->valor ?? null;
            $data->venda_formapgto_venda__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#624781ef21713');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailVendaFormapgto($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->venda_formapgto_venda_forma_pagamento_id = '';
            $data->venda_formapgto_venda_id = '';
            $data->venda_formapgto_venda_valor = '';
            $data->venda_formapgto_venda__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('venda_formapgto_venda_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onVencimentos($param = null) 
    {
        try 
        {
            $__row__data = unserialize(base64_decode($param['__row__data']));
            $id = $__row__data->id;

            $pageParam = ['key' => $id]; // ex.: = ['key' => 10]              

            if ($id == "")
            {
               throw new Exception("Salve a venda para poder informar o(s) vencimento(s) desta forma de pagamento!");  
            }
            else                  
              TApplication::loadPage('VendaFormapgtoTitulosForm', 'onEdit', $pageParam);  

            //</autoCode>
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new Venda(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            if($data->venda_modalidade_id == VendaModalidade::EmpresaEntrega)
            { 
                if ($data->cliente_endereco_id==null)
                {
                   throw new Exception("Informe o endereço de entrega do cliente!");                    
                }
            }
            else
                $data->cliente_endereco_id=null;

            if($data->venda_tipo_pagamento_id == VendaTipoPagamento::Entrega)
            {
                if ($data->venda_modalidade_id == VendaModalidade::ClienteRetira)
                {
                   throw new Exception("Quando a modalidade da venda é 'Cliente Retira', o tipo de pagamento deve ser 'Imediato'!");                    
                }                
            }

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $id = $object->id;

            //if ($data->id == "")
            //{
                //$object->data_hora_venda = date('d/m/Y H:i');
                $object->system_unit_id = TSession::getValue('userunitid');
            //}

            $object->store(); // save the object 

            $this->fireEvents($object);

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];
            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $loadPageParam["key"] = "$object->id";

            $venda_formapgto_venda_items = $this->storeMasterDetailItems('VendaFormapgto', 'venda_id', 'venda_formapgto_venda', $object, $param['venda_formapgto_venda_list___row__data'] ?? [], $this->form, $this->venda_formapgto_venda_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->venda_formapgto_venda_criteria); 

            //calculo do troco e formas de pagamento...
            $somaformapgto = 0; 
            $somaformasav = 0;
            $somaformasap = 0;

            // $venda_formapgto_venda_items = VendaFormapgto::where('venda_id', '=', $object->id)->load();

            foreach ($venda_formapgto_venda_items as $pagamento)
            {             
              $somaformapgto += $pagamento->valor;

              $formapgto = FormaPagamento::find($pagamento->forma_pagamento_id);

              if ($formapgto->tipo_documento_id==TipoDocumento::Dinheiro
              or $formapgto->tipo_documento_id==TipoDocumento::Cartao
              or $formapgto->tipo_documento_id==TipoDocumento::ContaCliente)
              {
                  $somaformasav += $pagamento->valor;
              }
              else
              {
                  $somaformasap += $pagamento->valor;
              }

            }

            // $valor_total = number_format($object->valor_total, 2, ',', '.');
            // $somaformapgto = (double) str_replace(',', '.', str_replace('.', '', $somaformapgto));
            // $somaformapgto = number_format($somaformapgto, 2, ',', '.');

            if ($somaformapgto<$object->valor_total)
            {
               throw new Exception("A soma da(s) forma(s) de pagamento deve ser igual ou maior que o valor da venda!");  
            }

            $object->valor_troco = number_format($somaformapgto-$object->valor_total, 2, ',', '.'); 
            $object->valor_avista = number_format($somaformasav, 2, ',', '.');
            $object->valor_aprazo = number_format($somaformasap, 2, ',', '.');             
            $object->store();

            $venda_item_venda_items = $this->storeMasterDetailItems('VendaItem', 'venda_id', 'venda_item_venda', $object, $param['venda_item_venda_list___row__data'] ?? [], $this->form, $this->venda_item_venda_list, function($masterObject, $detailObject){ 

                //code here

                if (isset($detailObject->id))
                {
                  $detailObject->cancelado = Resposta::Nao;
                }                

            }, $this->venda_item_venda_criteria); 

            if (isset($id))
            {
                VendaSituacaoHistorico::LancarHistorico(VendaSituacao::EmAndamento,
                                                        $object->id,
                                                        'Situação da venda: Em Andamento');      
            }         

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            Venda::recalcula_itens_venda($object);

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle'); 

            // TApplication::loadPage('VendaList', 'OnShow', $loadPageParam);
            // TApplication::loadPage('VendaFormView', 'OnShow', $loadPageParam);
            TApplication::loadPage('VendaForm', 'onEdit', $loadPageParam);   

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode>  

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    public static function onVisualizacaoVenda($param = null) 
    {
        try 
        {
            //code here
            $pageParam = ['key' => $param['id']]; // ex.: = ['key' => 10]

            if ($param['id'] == "")
            {
               throw new Exception("Salve a venda para entrar no modo visualização!");  
            }
            else
             TApplication::loadPage('VendaFormView', 'OnShow', $pageParam);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new Venda($key); // instantiates the Active Record 

                $criteria = new TCriteria();
                $criteria->add(new TFilter('cliente_id', '=', $object->cliente_id)); 
                // $criteria->add(new TFilter('ativo_id', '=', Ativo::Ativo)); 

                TDBCombo::reloadFromModel(self::$formName, 'cliente_endereco_id', self::$database, 'ClienteEndereco', 'id', '{logradouro}  - {numero} -  {bairro} - {cidade->nome} ', 'logradouro asc', $criteria, TRUE); 

                $venda_formapgto_venda_items = $this->loadMasterDetailItems('VendaFormapgto', 'venda_id', 'venda_formapgto_venda', $object, $this->form, $this->venda_formapgto_venda_list, $this->venda_formapgto_venda_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $venda_item_venda_items = $this->loadMasterDetailItems('VendaItem', 'venda_id', 'venda_item_venda', $object, $this->form, $this->venda_item_venda_list, $this->venda_item_venda_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                    $objectItems->venda_item_venda_produto_id = null;
                    if(isset($detailObject->produto_id) && $detailObject->produto_id)
                    {
                        $objectItems->__display__->produto_id = $detailObject->produto_id;
                    }

                    $objectItems->venda_item_venda_produto_id = null;
                    if(isset($detailObject->produto_id) && $detailObject->produto_id)
                    {
                        $objectItems->__display__->produto_id = $detailObject->produto_id;
                    }

                }); 

                $this->form->setData($object); // fill the form 

                $dados = new stdClass();
                $dados->cliente_nome = $object->cliente->nome;
                $dados->data_hora_venda = date('d/m/Y H:i');
                $dados->cliente_endereco_id = $object->cliente_endereco_id;
                TForm::sendData(self::$formName, $dados);

                $this->fireEvents($object);

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->data_hora_venda = date('d/m/Y H:i');
        $object->data_prev_entrega = date('d/m/Y H:i');
        $object->venda_situacao_id = VendaSituacao::EmAndamento;
        $object->filial_saida_id = TSession::getValue('userunitid');
        $object->venda_tipo_pagamento_id = VendaTipoPagamento::Imediato;
        $object->venda_modalidade_id = VendaModalidade::ClienteRetira;
        $object->criado_por = TSession::getValue('username'); 
        $object->data_hora_venda = date('d/m/Y H:i');
        $object->data_prev_entrega = date('d/m/Y H:i');        

        //$cliente Cliente::find()

        TForm::sendData(self::$formName, $object);

    } 

    public function fireEvents( $object )
    {
        $obj = new stdClass;
        if(is_object($object) && get_class($object) == 'stdClass')
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
            if(isset($object->venda_item_venda_produto_id))
            {
                $value = $object->venda_item_venda_produto_id;

                $obj->venda_item_venda_produto_id = $value;
            }
        }
        elseif(is_object($object))
        {
            if(isset($object->cliente_id))
            {
                $value = $object->cliente_id;

                $obj->cliente_id = $value;
            }
            if(isset($object->produto_id))
            {
                $value = $object->produto_id;

                $obj->venda_item_venda_produto_id = $value;
            }
        }
        TForm::sendData(self::$formName, $obj);
    }  

    public static function getFormName()
    {
        return self::$formName;
    }

}

