<?php

class VendaFormView extends TPage
{
    protected $form; // form
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Venda';
    private static $primaryKey = 'id';
    private static $formName = 'formView_Venda';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        TTransaction::open(self::$database);
        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        $this->form->setTagName('div');

        $venda = new Venda($param['key']);
        // define the form title
        $this->form->setFormTitle("Detalhes da Venda");

        $tdbarrowstep2 = new TDBArrowStep('tdbarrowstep2', 'kraftsoft', 'VendaSituacao', 'id', '{descricao}','ordem asc' );
        $lbid = new TLabel("Id:", '', '15px', 'B', '100%');
        $id = new TTextDisplay($venda->id, '', '15px', '');
        $lbdatahora = new TLabel("Data Hora:", '', '15px', 'B', '100%');
        $text13 = new TTextDisplay(TDateTime::convertToMask($venda->data_hora_venda, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbidorcamento = new TLabel("Orcamento:", '', '15px', 'B', '100%');
        $text3 = new TTextDisplay($venda->orcamento_id, '', '15px', '');
        $lbdatapreventrega = new TLabel("Data previsão entrega:", '', '15px', 'B', '100%');
        $text26 = new TTextDisplay(TDate::convertToMask($venda->data_prev_entrega, 'yyyy-mm-dd', 'dd/mm/yyyy'), '', '15px', '');
        $lbcliente = new TLabel("Cliente:", '', '15px', 'B', '100%');
        $text6 = new TTextDisplay($venda->cliente->nome, '', '15px', '');
        $lbvendedor = new TLabel("Vendedor:", '', '15px', 'B', '100%');
        $text4 = new TTextDisplay($venda->vendedor->nome, '', '15px', '');
        $lbfilialsaida = new TLabel("Filial de Saída:", '', '15px', 'B', '100%');
        $text9 = new TTextDisplay($venda->filial_saida->name, '', '15px', '');
        $lbtipopagamento = new TLabel("Tipo de pagamento:", '', '15px', 'B', '100%');
        $text11 = new TTextDisplay($venda->venda_tipo_pagamento->descricao, '', '15px', '');
        $lbmodalidade = new TLabel("Modalidade:", '', '15px', 'B', '100%');
        $text10 = new TTextDisplay($venda->venda_modalidade->descricao, '', '15px', '');
        $label35 = new TLabel("Cliente endereço:", '', '15px', 'B', '100%');
        $text24 = new TTextDisplay($venda->cliente_endereco->logradouro, '', '15px', '');
        $label2 = new TLabel("Valor Produtos:", '', '15px', 'B', '100%');
        $text14 = new TTextDisplay(number_format((double)$venda->valor_produtos, '2', ',', '.'), '', '15px', '');
        $label4 = new TLabel("Total Frete:", '', '15px', 'B', '100%');
        $text22 = new TTextDisplay(number_format((double)$venda->frete_total, '2', ',', '.'), '', '15px', '');
        $label6 = new TLabel("Desconto:", '', '15px', 'B', '100%');
        $text16 = new TTextDisplay(number_format((double)$venda->desconto, '2', ',', '.'), '', '15px', '');
        $label11 = new TLabel("Valor Total:", '', '15px', 'B', '100%');
        $text23 = new TTextDisplay(number_format((double)$venda->valor_total, '2', ',', '.'), '', '15px', '');
        $label13 = new TLabel("Peso Total:", '', '15px', 'B', '100%');
        $text21 = new TTextDisplay(number_format((double)$venda->peso_total, '2', ',', '.'), '', '15px', '');
        $label8 = new TLabel("Troco:", '', '15px', 'B', '100%');
        $text15 = new TTextDisplay(number_format((double)$venda->valor_troco, '2', ',', '.'), '', '15px', '');
        $label15 = new TLabel("Valor a vista:", '', '15px', 'B', '100%');
        $text32 = new TTextDisplay(number_format((double)$venda->valor_avista, '2', ',', '.'), '', '15px', '');
        $label17 = new TLabel("Valor a prazo:", '', '15px', 'B', '100%');
        $text33 = new TTextDisplay(number_format((double)$venda->valor_aprazo, '2', ',', '.'), '', '15px', '');
        $label19 = new TLabel("Valor Comissão:", '', '15px', 'B', '100%');
        $text29 = new TTextDisplay(number_format((double)$venda->valor_comissao, '2', ',', '.'), '', '15px', '');
        $label21 = new TLabel("Comissão a vista:", '', '15px', 'B', '100%');
        $text30 = new TTextDisplay(number_format((double)$venda->comissao_avista, '2', ',', '.'), '', '15px', '');
        $label23 = new TLabel("Comissão a prazo:", '', '15px', 'B', '100%');
        $text31 = new TTextDisplay($venda->comissao_aprazo, '', '15px', '');
        $lbobs = new TLabel("Observação:", '', '15px', 'B', '100%');
        $text19 = new TTextDisplay($venda->observacao, '', '15px', '');
        $lbobsnf = new TLabel("Observação da Nota Fiscal:", '', '15px', 'B', '100%');
        $text20 = new TTextDisplay($venda->observacao_nf, '', '15px', '');
        $lbinfofaturamento = new TLabel("Informações para faturamento:", '', '15px', 'B', '100%');
        $text25 = new TTextDisplay($venda->info_faturamento, '', '15px', '');
        $lbcriadoem = new TLabel("Criado em:", '', '15px', 'B', '100%');
        $text17 = new TTextDisplay(TDateTime::convertToMask($venda->criado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbcriadopor = new TLabel("Criado Por:", '', '15px', 'B', '100%');
        $text27 = new TTextDisplay($venda->criado_por, '', '15px', '');
        $lbalteradoem = new TLabel("Alterado em:", '', '15px', 'B', '100%');
        $text18 = new TTextDisplay(TDateTime::convertToMask($venda->alterado_em, 'yyyy-mm-dd hh:ii', 'dd/mm/yyyy hh:ii'), '', '15px', '');
        $lbalteradopor = new TLabel("Alterado Por:", '', '15px', 'B', '100%');
        $text28 = new TTextDisplay($venda->alterado_por, '', '15px', '');

        $tdbarrowstep2->setEditable(false);
        $tdbarrowstep2->setColorColumn('cor');
        $tdbarrowstep2->setFilledColor('#fd9308');
        $tdbarrowstep2->setFilledFontColor('#FFFFFF');
        $tdbarrowstep2->setUnfilledColor('#d3d3d3');
        $tdbarrowstep2->setUnfilledFontColor('#333333');
        $tdbarrowstep2->setWidth('100%');
        $tdbarrowstep2->setHeight('60');
        $tdbarrowstep2->setValue($venda->venda_situacao_id);

        $row1 = $this->form->addFields([$tdbarrowstep2]);
        $row1->layout = [' col-sm-12'];

        $row2 = $this->form->addFields([$lbid,$id],[$lbdatahora,$text13],[$lbidorcamento,$text3],[$lbdatapreventrega,$text26]);
        $row2->layout = ['col-sm-3',' col-sm-3',' col-sm-3',' col-sm-3'];

        $row3 = $this->form->addFields([$lbcliente,$text6],[$lbvendedor,$text4]);
        $row3->layout = [' col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([$lbfilialsaida,$text9],[$lbtipopagamento,$text11]);
        $row4->layout = [' col-sm-6','col-sm-6'];

        $tab_640b255a5d9b1 = new BootstrapFormBuilder('tab_640b255a5d9b1');
        $this->tab_640b255a5d9b1 = $tab_640b255a5d9b1;
        $tab_640b255a5d9b1->setProperty('style', 'border:none; box-shadow:none;');

        $tab_640b255a5d9b1->appendPage("Produtos");

        $tab_640b255a5d9b1->addFields([new THidden('current_tab_tab_640b255a5d9b1')]);
        $tab_640b255a5d9b1->setTabFunction("$('[name=current_tab_tab_640b255a5d9b1]').val($(this).attr('data-current_page'));");

        $this->venda_item_venda_id_list = new TQuickGrid;
        $this->venda_item_venda_id_list->disableHtmlConversion();
        $this->venda_item_venda_id_list->style = 'width:100%';
        $this->venda_item_venda_id_list->disableDefaultClick();

        $column_produto_id = $this->venda_item_venda_id_list->addQuickColumn("Cód. Prod.", 'produto_id', 'left');
        $column_produto_nome = $this->venda_item_venda_id_list->addQuickColumn("Produto", 'produto->nome', 'left');
        $column_quantidade_transformed = $this->venda_item_venda_id_list->addQuickColumn("Quantidade", 'quantidade', 'right');
        $column_valor_unitario_transformed = $this->venda_item_venda_id_list->addQuickColumn("Valor Unitário", 'valor_unitario', 'right');
        $column_desconto_transformed = $this->venda_item_venda_id_list->addQuickColumn("Desconto", 'desconto', 'left');
        $column_valor_frete_transformed = $this->venda_item_venda_id_list->addQuickColumn("Valor Frete", 'valor_frete', 'right');
        $column_valor_total_transformed = $this->venda_item_venda_id_list->addQuickColumn("Valor Total", 'valor_total', 'right');
        $column_numero_pedido = $this->venda_item_venda_id_list->addQuickColumn("Número Pedido", 'numero_pedido', 'left');
        $column_numero_item_pedido = $this->venda_item_venda_id_list->addQuickColumn("Número Item Pedido", 'numero_item_pedido', 'left');
        $column_informacoes_adicionais = $this->venda_item_venda_id_list->addQuickColumn("Informações Adicionais", 'informacoes_adicionais', 'left');
        $column_estoque_deposito_descricao = $this->venda_item_venda_id_list->addQuickColumn("Depósito", 'estoque_deposito->descricao', 'left');
        $column_produto_lote_numero = $this->venda_item_venda_id_list->addQuickColumn("Lote", 'produto_lote->numero', 'left');

        $column_quantidade_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_valor_unitario_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_desconto_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_valor_frete_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_valor_total_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->venda_item_venda_id_list->createModel();

        $criteria_venda_item_venda_id = new TCriteria();
        $criteria_venda_item_venda_id->add(new TFilter('venda_id', '=', $venda->id));

        $criteria_venda_item_venda_id->setProperty('order', 'id desc');

        $venda_item_venda_id_items = VendaItem::getObjects($criteria_venda_item_venda_id);

        $this->venda_item_venda_id_list->addItems($venda_item_venda_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->venda_item_venda_id_list));

        $tab_640b255a5d9b1->addContent([$panel]);

        $tab_640b255a5d9b1->appendPage("Entrega");
        $row5 = $tab_640b255a5d9b1->addFields([$lbmodalidade,$text10]);
        $row5->layout = [' col-sm-12'];

        $row6 = $tab_640b255a5d9b1->addFields([$label35,$text24]);
        $row6->layout = [' col-sm-12'];

        $tab_640b255a5d9b1->appendPage("Financeiro");

        $this->venda_formapgto_venda_id_list = new TQuickGrid;
        $this->venda_formapgto_venda_id_list->disableHtmlConversion();
        $this->venda_formapgto_venda_id_list->style = 'width:100%';
        $this->venda_formapgto_venda_id_list->disableDefaultClick();

        $column_forma_pagamento_descricao = $this->venda_formapgto_venda_id_list->addQuickColumn("Forma pagamento", 'forma_pagamento->descricao', 'left');
        $column_valor_transformed = $this->venda_formapgto_venda_id_list->addQuickColumn("Valor", 'valor', 'left');

        $column_valor_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $this->venda_formapgto_venda_id_list->createModel();

        $criteria_venda_formapgto_venda_id = new TCriteria();
        $criteria_venda_formapgto_venda_id->add(new TFilter('venda_id', '=', $venda->id));

        $criteria_venda_formapgto_venda_id->setProperty('order', 'id desc');

        $venda_formapgto_venda_id_items = VendaFormapgto::getObjects($criteria_venda_formapgto_venda_id);

        $this->venda_formapgto_venda_id_list->addItems($venda_formapgto_venda_id_items);

        $panel = new TElement('div');
        $panel->class = 'formView-detail';
        $panel->add(new BootstrapDatagridWrapper($this->venda_formapgto_venda_id_list));

        $tab_640b255a5d9b1->addContent([$panel]);

        $tab_640b255a5d9b1->appendPage("Totais");
        $row7 = $tab_640b255a5d9b1->addFields([$label2,$text14],[$label4,$text22],[$label6,$text16]);
        $row7->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row8 = $tab_640b255a5d9b1->addFields([$label11,$text23],[$label13,$text21],[$label8,$text15]);
        $row8->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row9 = $tab_640b255a5d9b1->addFields([$label15,$text32],[$label17,$text33],[]);
        $row9->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row10 = $tab_640b255a5d9b1->addFields([$label19,$text29],[$label21,$text30],[$label23,$text31]);
        $row10->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row11 = $this->form->addFields([$tab_640b255a5d9b1]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->form->addFields([$lbobs,$text19],[$lbobsnf,$text20]);
        $row12->layout = [' col-sm-6','col-sm-6'];

        $row13 = $this->form->addFields([$lbinfofaturamento,$text25]);
        $row13->layout = [' col-sm-12'];

        $row14 = $this->form->addContent([new TFormSeparator("Histórico de Alterações", '#333', '18', '#eee')]);
        $row15 = $this->form->addFields([$lbcriadoem,$text17],[$lbcriadopor,$text27],[$lbalteradoem,$text18],[$lbalteradopor,$text28]);
        $row15->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        if(!empty($param['current_tab']))
        {
            $this->form->setCurrentPage($param['current_tab']);
        }

        if(!empty($param['current_tab_tab_640b255a5d9b1']))
        {
            $this->tab_640b255a5d9b1->setCurrentPage($param['current_tab_tab_640b255a5d9b1']);
        }

        $dropdownHeader = new TDropDown("Impressões", 'fa:print #FF5722');
        $dropdownHeader->setPullSide('right-panel');
        $dropdownHeader->setButtonSize('btn btn-sm btn-default dropdown-toggle');

        $btn_acao1 = $dropdownHeader->addPostAction("Espelho PDF", new TAction(['VendaFormView', 'onEspelhoPDF'], $param), self::$formName, 'far:file-pdf #DD0909');
        $this->btn_onacao1 = $btn_acao1;

        $btn_acao2 = $dropdownHeader->addPostAction("Cupom não fiscal", new TAction(['CupomNaoFiscalDocument', 'onGenerate'], $param), self::$formName, 'fa:print #795548');
        $this->btn_onacao4 = $btn_acao2;

        $btn_acao3 = $dropdownHeader->addPostAction("Guia de separação", new TAction(['RelatorioDeSeparacaoDocument', 'onGenerate'], $param), self::$formName, 'fa:box-open #9E9E9E');
        $this->btn_onacao3 = $btn_acao3;

        $btn_acao4 = $dropdownHeader->addPostAction("Etiqueta de Envio", new TAction(['VendaEtiquetaDocument', 'onGenerate'], $param), self::$formName, 'fa:mail-bulk #4CAF50');
        $this->btn_onacao4 = $btn_acao4;

        $this->form->addHeaderWidget( $dropdownHeader );

        $btnVendaFormOnEditAction = new TAction(['VendaForm', 'onEdit'],['key'=>$venda->id]);
        $btnVendaFormOnEditLabel = new TLabel("Editar");

        $btnVendaFormOnEdit = $this->form->addHeaderAction($btnVendaFormOnEditLabel, $btnVendaFormOnEditAction, 'fas:edit #2196F3'); 
        $btnVendaFormOnEditLabel->setFontSize('12px'); 
        $btnVendaFormOnEditLabel->setFontColor('#333333'); 

        $btn_onenviarfaturamentoAction = new TAction([$this, 'onEnviarFaturamento'],['key'=>$venda->id]);
        $btn_onenviarfaturamentoLabel = new TLabel("Enviar p/ Faturamento");

        $btn_onenviarfaturamento = $this->form->addHeaderAction($btn_onenviarfaturamentoLabel, $btn_onenviarfaturamentoAction, 'fas:code-branch #9C27B0'); 
        $btn_onenviarfaturamentoLabel->setFontSize('12px'); 
        $btn_onenviarfaturamentoLabel->setFontColor('#333333'); 

        $btn_onfaturamentoAction = new TAction([$this, 'onFaturamento'],['key'=>$venda->id]);
        $btn_onfaturamentoLabel = new TLabel("Faturamento");

        $btn_onfaturamento = $this->form->addHeaderAction($btn_onfaturamentoLabel, $btn_onfaturamentoAction, 'fas:money-check-alt #FF5722'); 
        $btn_onfaturamentoLabel->setFontSize('12px'); 
        $btn_onfaturamentoLabel->setFontColor('#333333'); 

        $btn_ongerarnfeAction = new TAction([$this, 'onGerarNFe'],['key'=>$venda->id]);
        $btn_ongerarnfeLabel = new TLabel("Gerar NF-e");

        $btn_ongerarnfe = $this->form->addHeaderAction($btn_ongerarnfeLabel, $btn_ongerarnfeAction, 'fas:file-invoice-dollar #4CAF50'); 
        $btn_ongerarnfeLabel->setFontSize('12px'); 
        $btn_ongerarnfeLabel->setFontColor('#333333'); 

        $btn_ongerarnfceAction = new TAction([$this, 'onGerarNFCe'],['key'=>$venda->id]);
        $btn_ongerarnfceLabel = new TLabel("Gerar NFC-e");

        $btn_ongerarnfce = $this->form->addHeaderAction($btn_ongerarnfceLabel, $btn_ongerarnfceAction, 'fas:file-invoice-dollar #CDDC39'); 
        $btn_ongerarnfceLabel->setFontSize('12px'); 
        $btn_ongerarnfceLabel->setFontColor('#333333'); 

        $btn_oncancelarAction = new TAction([$this, 'onCancelar'],['key'=>$venda->id]);
        $btn_oncancelarLabel = new TLabel("Cancelar");

        $btn_oncancelar = $this->form->addHeaderAction($btn_oncancelarLabel, $btn_oncancelarAction, 'fas:window-close #CE0D0D'); 
        $btn_oncancelarLabel->setFontSize('12px'); 
        $btn_oncancelarLabel->setFontColor('#333333'); 

        $btn_onestornarvendaAction = new TAction([$this, 'onEstornarVenda'],['key'=>$venda->id]);
        $btn_onestornarvendaLabel = new TLabel("Estornar Venda");

        $btn_onestornarvenda = $this->form->addHeaderAction($btn_onestornarvendaLabel, $btn_onestornarvendaAction, 'fas:ban #E91E63'); 
        $btn_onestornarvendaLabel->setFontSize('12px'); 
        $btn_onestornarvendaLabel->setFontColor('#333'); 

        $btnVendaSituacaoHistoricoTimeLineOnShowAction = new TAction(['VendaSituacaoHistoricoTimeLine', 'onShow'],['key'=>$venda->id]);
        $btnVendaSituacaoHistoricoTimeLineOnShowLabel = new TLabel("Linha do tempo das situações desta venda");

        $btnVendaSituacaoHistoricoTimeLineOnShow = $this->form->addHeaderAction($btnVendaSituacaoHistoricoTimeLineOnShowLabel, $btnVendaSituacaoHistoricoTimeLineOnShowAction, 'fas:clock #FF9800'); 
        $btnVendaSituacaoHistoricoTimeLineOnShowLabel->setFontSize('12px'); 
        $btnVendaSituacaoHistoricoTimeLineOnShowLabel->setFontColor('#333'); 

        $btn_ondevolucaotrocaAction = new TAction([$this, 'onDevolucaoTroca'],['key'=>$venda->id]);
        $btn_ondevolucaotrocaLabel = new TLabel("Devolução / Troca");

        $btn_ondevolucaotroca = $this->form->addHeaderAction($btn_ondevolucaotrocaLabel, $btn_ondevolucaotrocaAction, 'fas:exchange-alt #00BCD4'); 
        $btn_ondevolucaotrocaLabel->setFontSize('12px'); 
        $btn_ondevolucaotrocaLabel->setFontColor('#333'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        if($venda->venda_situacao_id==VendaSituacao::EmAndamento
        or $venda->venda_situacao_id==VendaSituacao::AguardandoFaturamento)
        {
            TScript::create('document.getElementById("tbutton_gerar_nf-e").style.display = "none";');
            TScript::create('document.getElementById("tbutton_gerar_nfc-e").style.display = "none";');
            TScript::create('document.getElementById("tbutton_estornar_venda").style.display = "none";');            
        }

        if($venda->venda_situacao_id==VendaSituacao::AguardandoFaturamento)
        {
            TScript::create('document.getElementById("tbutton_gerar_nf-e").style.display = "none";');
            TScript::create('document.getElementById("tbutton_gerar_nfc-e").style.display = "none";');
            TScript::create('document.getElementById("tbutton_enviar_p/_faturamento").style.display = "none";');
            TScript::create('document.getElementById("tbutton_estornar_venda").style.display = "none";');                        
        }         

        if($venda->venda_situacao_id==VendaSituacao::Cancelada
        or $venda->venda_situacao_id==VendaSituacao::AguardandoExpedicao)
        {
            TScript::create('document.getElementById("tbutton_enviar_p/_faturamento").style.display = "none";');
            TScript::create('document.getElementById("tbutton_faturamento").style.display = "none";');
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_estornar_venda").style.display = "none";');                        
        }  

        if($venda->venda_situacao_id==VendaSituacao::Finalizada)
        {
            TScript::create('document.getElementById("tbutton_enviar_p/_faturamento").style.display = "none";');
            TScript::create('document.getElementById("tbutton_faturamento").style.display = "none";');
            TScript::create('document.getElementById("tbutton_editar").style.display = "none";');
            TScript::create('document.getElementById("tbutton_cancelar").style.display = "none";');
        }

        TTransaction::close();
        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=VendaFormView]');
        $style->width = '100% !important';   
        $style->show(true);

    }

    public function onEnviarFaturamento($param = null) 
    {
        try 
        {
            //code here
            new TQuestion("Deseja enviar venda para faturamento?", new TAction([__CLASS__, 'onEnviarFaturamentoYes'], $param), new TAction([__CLASS__, 'onEnviarFaturamentoNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onFaturamento($param = null) 
    {
        try 
        {
            //code here
           // new TQuestion("Deseja realizar o faturamento?", new TAction([__CLASS__, 'onFaturamentoYes'], $param), new TAction([__CLASS__, 'onFaturamentoNo'], $param));

          $pageParam = ['venda_id' => $param['key']]; // ex.: = ['key' => 10]  
          TApplication::loadPage('VendaFaturamentoSimpleList', 'onReload', $pageParam);  

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onGerarNFe($param = null) 
    {
        try 
        {
            //code here
            new TQuestion("Deseja gerar a NF-e?", new TAction([__CLASS__, 'onGerarNFeYes'], $param), new TAction([__CLASS__, 'onGerarNFeNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onGerarNFCe($param = null) 
    {
        try 
        {
            new TQuestion("Deseja gerar a NFC-e?", new TAction([__CLASS__, 'onGerarNFCeYes'], $param), new TAction([__CLASS__, 'onGerarNFCeNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onCancelar($param = null) 
    {
        try 
        {
            //code here
            new TQuestion("Deseja cancelar a venda?", new TAction([__CLASS__, 'onCancelarYes'], $param), new TAction([__CLASS__, 'onCancelarNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onEstornarVenda($param = null) 
    {
        try 
        {
            new TQuestion("Deseja estornar a venda?", new TAction([__CLASS__, 'onEstornarVendaYes'], $param), new TAction([__CLASS__, 'onEstornarVendaNo'], $param));

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }
    public function onDevolucaoTroca($param = null) 
    {
        try 
        {
            TTransaction::open('kraftsoft');    

            $venda = Venda::find($param['key']);    

            $pageParam = ['venda_id' => $venda->id]; 
            TApplication::loadPage('VendaDevolucaoForm', 'onShow', $pageParam);

            TTransaction::close();    

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onShow($param = null)
    {     

    }

    public static function onEnviarFaturamentoYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $venda = Venda::find($param['key']);     

            if($venda) 
            {
                //reservando o estoque...
                VendaItem::LancamentoEstoque(EstoqueTipoMovimentacao::EntradaReserva,
                                             EstoqueOrigem::ReservaSaldo, 
                                             $venda,
                                             'Reserva venda Id: '.$venda->id);

                $venda->venda_situacao_id=VendaSituacao::AguardandoFaturamento;
                $venda->store();

                VendaSituacaoHistorico::LancarHistorico(VendaSituacao::AguardandoFaturamento,
                                                        $venda->id,
                                                        'Mudança de Situação de venda: Aguardando Faturamento');

            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $venda->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEnviarFaturamentoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onFaturamentoYes($param = null) 
    {
        try 
        {

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onFaturamentoNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarNFeYes($param = null) 
    {
        try 
        {

            TTransaction::open('kraftsoft');    

            Venda::ValidaCamposNFe($param['key']);

            $nfe_id = funcaoNFE::geraNotaVenda($param['key'], NotafiscalMod::NFe);

            if(is_numeric($nfe_id))
            {
                $pageParam = ['key' => $nfe_id]; 
                TApplication::loadPage('NotafiscalFormView', 'onShow', $pageParam);

            }
            else
            {
                throw new Exception($nfe_id);
            }

            TTransaction::close();          

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarNFeNo($param = null) 
    {
        try 
        {
           new TQuestion("Deseja gerar a NFC-e?", new TAction([__CLASS__, 'onGerarNFCeYes'], $param), new TAction([__CLASS__, 'onGerarNFCeNo'], $param));
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarNFCeYes($param = null) 
    {
        try 
        {

            TTransaction::open('kraftsoft');    

            Venda::ValidaCamposNFe($param['key']);

            $nfe_id = funcaoNFE::geraNotaVenda($param['key'], NotafiscalMod::NFCe);

            if(is_numeric($nfe_id))
            {
                $pageParam = ['key' => $nfe_id]; 
                TApplication::loadPage('NotafiscalConsumidorFormView', 'onShow', $pageParam);

            }
            else
            {
                throw new Exception($nfe_id);
            }

            TTransaction::close();          

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onGerarNFCeNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $venda = Venda::find($param['key']);     

            if($venda) 
            {
                $venda->venda_situacao_id=VendaSituacao::Cancelada;
                $venda->store();

                //historico de situação de venda..
                VendaSituacaoHistorico::LancarHistorico(VendaSituacao::Cancelada,
                                                        $venda->id,
                                                        'Mudança de Situação de venda: Cancelada');                
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $venda->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onCancelarNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEstornarVendaYes($param = null) 
    {
        try 
        {
            TTransaction::open(self::$database);

            $venda = Venda::find($param['key']);     

            if($venda) 
            {
                Venda::EstornarVenda($venda);
            }

            TTransaction::close();

            TApplication::loadPage(__CLASS__, 'onShow', ['key' => $venda->id]);

            TToast::show('success', "Operação realizada com sucesso!", 'topRight', 'far:check-circle');  
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEstornarVendaNo($param = null) 
    {
        try 
        {
            //code here
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public static function onEspelhoPDF($param = null) 
    {
        try 
        {
            //code here
            $document = Venda::Espelho_Venda($param['key']);

            if(file_exists($document)) {
                parent::openFile($document);
            } else {
                new TMessage('error', "Arquivo não encontrado!");
            }
        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

}

