<?php

class VendaFormapgtoTitulosForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'VendaFormapgto';
    private static $primaryKey = 'id';
    private static $formName = 'form_VendaFormapgtoTitulosForm';

    use BuilderMasterDetailFieldListTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Vencimentos de Títulos da Venda");


        $forma_pagamento_id = new TDBCombo('forma_pagamento_id', 'kraftsoft', 'FormaPagamento', 'id', '{descricao}','descricao asc'  );
        $valor = new TNumeric('valor', '2', ',', '.' );
        $quantidade_parcelas = new TNumeric('quantidade_parcelas', '0', ',', '.' );
        $button_gerar_parcelas = new TButton('button_gerar_parcelas');
        $contasrec_venda_formapgto_id = new THidden('contasrec_venda_formapgto_id[]');
        $contasrec_venda_formapgto___row__id = new THidden('contasrec_venda_formapgto___row__id[]');
        $contasrec_venda_formapgto___row__data = new THidden('contasrec_venda_formapgto___row__data[]');
        $contasrec_venda_formapgto_parcela = new TEntry('contasrec_venda_formapgto_parcela[]');
        $contasrec_venda_formapgto_data_vencimento = new TDate('contasrec_venda_formapgto_data_vencimento[]');
        $contasrec_venda_formapgto_valor = new TNumeric('contasrec_venda_formapgto_valor[]', '2', ',', '.' );
        $this->FieldListParcelas = new TFieldList();
        $id = new THidden('id');
        $venda_id = new THidden('venda_id');

        $this->FieldListParcelas->addField(null, $contasrec_venda_formapgto_id, []);
        $this->FieldListParcelas->addField(null, $contasrec_venda_formapgto___row__id, ['uniqid' => true]);
        $this->FieldListParcelas->addField(null, $contasrec_venda_formapgto___row__data, []);
        $this->FieldListParcelas->addField(new TLabel("Parcela", null, '14px', null), $contasrec_venda_formapgto_parcela, ['width' => '33%']);
        $this->FieldListParcelas->addField(new TLabel("Data Vencimento", null, '14px', null), $contasrec_venda_formapgto_data_vencimento, ['width' => '33%']);
        $this->FieldListParcelas->addField(new TLabel("Valor", null, '14px', null), $contasrec_venda_formapgto_valor, ['width' => '33%']);

        $this->FieldListParcelas->width = '100%';
        $this->FieldListParcelas->setFieldPrefix('contasrec_venda_formapgto');
        $this->FieldListParcelas->name = 'FieldListParcelas';

        $this->criteria_FieldListParcelas = new TCriteria();
        $this->default_item_FieldListParcelas = new stdClass();

        $this->form->addField($contasrec_venda_formapgto_id);
        $this->form->addField($contasrec_venda_formapgto___row__id);
        $this->form->addField($contasrec_venda_formapgto___row__data);
        $this->form->addField($contasrec_venda_formapgto_parcela);
        $this->form->addField($contasrec_venda_formapgto_data_vencimento);
        $this->form->addField($contasrec_venda_formapgto_valor);

        $this->FieldListParcelas->setRemoveAction(null, 'fas:times #dd5a43', "Excluír");

        $forma_pagamento_id->addValidation("Forma pagamento id", new TRequiredValidator()); 
        $valor->addValidation("Valor", new TRequiredValidator()); 
        $contasrec_venda_formapgto_data_vencimento->addValidation("Data Vencimento", new TRequiredListValidator()); 
        $contasrec_venda_formapgto_valor->addValidation("Valor", new TRequiredListValidator()); 

        $forma_pagamento_id->enableSearch();
        $quantidade_parcelas->setValue('1');
        $button_gerar_parcelas->setAction(new TAction([$this, 'onGerarParcelas']), "Gerar Parcelas");
        $button_gerar_parcelas->addStyleClass('btn-default');
        $button_gerar_parcelas->setImage('fas:calendar-alt #4CAF50');
        $contasrec_venda_formapgto_data_vencimento->setMask('dd/mm/yyyy');
        $contasrec_venda_formapgto_data_vencimento->setDatabaseMask('yyyy-mm-dd');
        $valor->setEditable(false);
        $forma_pagamento_id->setEditable(false);

        $id->setSize(200);
        $valor->setSize('100%');
        $venda_id->setSize(200);
        $forma_pagamento_id->setSize('100%');
        $quantidade_parcelas->setSize('100%');
        $contasrec_venda_formapgto_valor->setSize('100%');
        $contasrec_venda_formapgto_parcela->setSize('100%');
        $contasrec_venda_formapgto_data_vencimento->setSize('100%');

        $row1 = $this->form->addFields([new TLabel("Forma de Pagamento:", '#ff0000', '14px', null, '100%'),$forma_pagamento_id],[new TLabel("Valor:", '#ff0000', '14px', null, '100%'),$valor]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Quantidade de Parcelas:", null, '14px', null),$quantidade_parcelas],[new TLabel(" ", null, '14px', null, '100%'),$button_gerar_parcelas]);
        $row2->layout = [' col-sm-6','col-sm-6'];

        $row3 = $this->form->addFields([$this->FieldListParcelas]);
        $row3->layout = [' col-sm-12'];

        $row4 = $this->form->addFields([$id,$venda_id]);
        $row4->layout = ['col-sm-6'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        parent::setTargetContainer('adianti_right_panel');

        $btnClose = new TButton('closeCurtain');
        $btnClose->class = 'btn btn-sm btn-default';
        $btnClose->style = 'margin-right:10px;';
        $btnClose->onClick = "Template.closeRightPanel();";
        $btnClose->setLabel("Fechar");
        $btnClose->setImage('fas:times');

        $this->form->addHeaderWidget($btnClose);

        parent::add($this->form);

        $style = new TStyle('right-panel > .container-part[page-name=VendaFormapgtoTitulosForm]');
        $style->width = '50% !important';   
        $style->show(true);

    }

    public static function onGerarParcelas($param = null) 
    {
        try 
        {
            // convertendo o valor que vem no formato brasileiro para formato americano
            $valor = (double) str_replace(',', '.', str_replace('.', '', $param['valor']));

            // convertendo a data para o farmato americano
            $primeiro_vencimento = new DateTime(date('d-m-Y'));
           // $primeiro_vencimento = $primeiro_vencimento->modify( 'next month' );

            // $primeiro_vencimento = TDate::date2us($primeiro_vencimento);
            $parcelas = $param['quantidade_parcelas'];

            // calcula o valor da parcela
            $valorParcela = $valor / $parcelas;

            // transforma a data de vencimento em um objeto da classe DateTime
            // $data_vencimento = new DateTime($primeiro_vencimento);

            $data_vencimento = $primeiro_vencimento->modify( 'next month' );;

            $data = new stdClass();
            $data->contasrec_venda_formapgto_parcela = [];
            $data->contasrec_venda_formapgto_data_vencimento = [];
            $data->contasrec_venda_formapgto_valor = [];

            for($i = 0 ; $i < $parcelas; $i++)
            {
                // populando o array das propriedades do fieldlist
                $data->contasrec_venda_formapgto_parcela[] = ($i+1).'/'.$parcelas;
                $data->contasrec_venda_formapgto_data_vencimento[] = $data_vencimento->format('d/m/Y');
                $data->contasrec_venda_formapgto_valor[] = number_format($valorParcela, 2, ',','.');;                

                // acrescenta um mês a data de vencimento
                $data_vencimento->modify( 'next month' );
            }

            // limpa o TFieldList
            // o primeiro parâmetro é o nome da variável definida para o TFieldList
            TFieldList::clearRows('FieldListParcelas');

            // adicionamos as linhas novas
            // primeiro parâmetro é o nome da variável definida para o TFieldList
            TFieldList::addRows('FieldListParcelas', $parcelas - 1);

            // enviando os dados para o field list
            //TForm::sendData(self::$formName, $data);
            TForm::sendData(self::$formName, $data, false, true, 500);

        }
        catch (Exception $e) 
        {
            new TMessage('error', $e->getMessage());    
        }
    }

    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new VendaFormapgto(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            $venda = Venda::find($object->venda_id);  
            $config_filial = ConfiguracoesFilial::where('system_unit_id', '=',  TSession::getValue('userunitid'))->first();

            if ($config_filial->plano_conta_crec_id==0 or
                $config_filial->centro_custo_crec_id==0)
            {
                throw new Exception('Plano de conta e centro de custo padrão para o contas a receber não foi configurado!<br>'.
                                    'Acesse a tela de configurações do sistema para realizar este ajuste.');
            } 

            $contasrec_venda_formapgto_items = $this->storeItems('Contasrec', 'venda_formapgto_id', $object, $this->FieldListParcelas, function($masterObject, $detailObject){ 

                //salvando o nome do usuario
                Funcoes::SalvarUsuarioCadastro($detailObject);   

                $config_filial = ConfiguracoesFilial::where('system_unit_id', '=',  TSession::getValue('userunitid'))->first();

                $detailObject->numero_documento = $masterObject->venda_id;
                $detailObject->data_competencia = $masterObject->venda->data_hora_venda;
                $detailObject->data_emissao = TDate::date2us(date('d/m/Y'));
                $detailObject->cliente_id = $masterObject->venda->cliente_id;
                $detailObject->forma_pagamento_id = $masterObject->forma_pagamento_id;
                $detailObject->observacao = 'Referente a recebimento de parcela '.$detailObject->parcela.' da venda número '.$masterObject->venda_id;
                $detailObject->contasrec_origem_id = ContasrecOrigem::Venda;
                $detailObject->contasrec_situacao_id = ContasrecSituacao::EmAberto;
                $detailObject->system_unit_id = TSession::getValue('userunitid');
                $detailObject->valor_aberto = $masterObject->valor;
                $detailObject->data_venc_original = $detailObject->data_vencimento;   
                $detailObject->plano_conta_id = $config_filial->plano_conta_crec_id;
                $detailObject->centro_custo_id = $config_filial->centro_custo_crec_id;
                $detailObject->desconto = '0,00';
                $detailObject->valor_multa = '0,00';
                $detailObject->juros = '0,00';
                $detailObject->valor_pago = '0,00';   
                $detailObject->venda_formapgto_id = $masterObject->id;
                $detailObject->ativo_id = Ativo::Inativo; //padrão inativo

            }, $this->criteria_FieldListParcelas); 

            $conn = TTransaction::get();
            $lista_contasrec = $conn->query('SELECT * from contasrec where venda_formapgto_id='.$object->id.' and deletado_em is null');            

            $soma_parcelas = 0;
            foreach ($lista_contasrec as $crec) 
            {
               $soma_parcelas += $crec['valor'];
            }

            //validar a soma dos titulos, tem que bater com o valor do bloco....
            // $soma_parcelas = (double) Contasrec::where('venda_formapgto_id', '=',  $object->id)
            //                                   ->sumby('valor');        

            if ($soma_parcelas<>$object->valor) 
            {
                throw new Exception('Total das parcelas não é o mesmo do valor total! Verifique.');
            }

            //consultar os contas a receber gerados e incluir os lançamentos contabeis de cada
            $lista_contasrec = Contasrec::where('venda_formapgto_id', '=', $object->id)->load();

            foreach ($lista_contasrec as $crec) 
            {            
                ContabilLancamentos::LancamentoContabil($crec->plano_conta_id,
                                                        $crec->centro_custo_id,
                                                        ContabilLancamentosTipo::Credito,
                                                        ContabilLancamentosSituacao::NaoLiquidado,
                                                        ContabilLancamentosOrigem::ContasRec,
                                                        $crec->id,
                                                        $crec->data_vencimento,
                                                        $crec->valor,
                                                        'Ref. Crédito de venda Cliente: '.$crec->cliente->nome);                   
            }            

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Informações Salvas", 'topRight', 'far:check-circle'); 

                        TScript::create("Template.closeRightPanel();");
            TForm::sendData(self::$formName, (object)['id' => $object->id]);

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new VendaFormapgto($key); // instantiates the Active Record 

                $this->FieldListParcelas_items = $this->loadItems('Contasrec', 'venda_formapgto_id', $object, $this->FieldListParcelas, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }, $this->criteria_FieldListParcelas); 

                # REMOVE O BOTÃO ADICIONAR DO TFieldList
                $this->FieldListParcelas->getFoot()->clearChildren();

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

        $this->FieldListParcelas->addHeader();
        $this->FieldListParcelas->addDetail($this->default_item_FieldListParcelas);

        $this->FieldListParcelas->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    }

    public function onShow($param = null)
    {
        $this->FieldListParcelas->addHeader();
        $this->FieldListParcelas->addDetail($this->default_item_FieldListParcelas);

        $this->FieldListParcelas->addCloneAction(null, 'fas:plus #69aa46', "Clonar");

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

