<?php

class VendaKanbanFormView extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = '';
    private static $activeRecord = '';
    private static $primaryKey = '';
    private static $formName = 'form_VendaKanbanFormView';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param = null)
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Kanban de Venda");


        $data_inicial = new TDate('data_inicial');
        $data_final = new TDate('data_final');
        $filial_saida_id = new TDBCombo('filial_saida_id', 'kraftsoft', 'SystemUnit', 'id', '{name}','name asc'  );
        $cliente_id = new TDBCombo('cliente_id', 'kraftsoft', 'Cliente', 'id', '{nome}','nome asc'  );
        $vendedor_id = new TDBCombo('vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $button_buscar = new TButton('button_buscar');
        $page_vendakanbanview = new BPageContainer();


        $button_buscar->addStyleClass('btn-primary');
        $button_buscar->setImage('fas:search-plus #FFFFFF');
        $page_vendakanbanview->setId('b63a81f1dd4aa0');
        $data_final->setMask('yyyy-mm-dd');
        $data_inicial->setMask('yyyy-mm-dd');

        $data_final->setDatabaseMask('yyyy-mm-dd');
        $data_inicial->setDatabaseMask('yyyy-mm-dd');

        $button_buscar->setAction(new TAction(['VendaKanbanFormView', 'onShow']), "Buscar");
        $page_vendakanbanview->setAction(new TAction(['VendaKanbanView', 'onShow'], $param));

        $cliente_id->enableSearch();
        $vendedor_id->enableSearch();
        $filial_saida_id->enableSearch();

        $data_final->setValue($param["data_final"] ?? null);
        $cliente_id->setValue($param["cliente_id"] ?? null);
        $vendedor_id->setValue($param["vendedor_id"] ?? null);
        $data_inicial->setValue($param["data_inicial"] ?? null);
        $filial_saida_id->setValue($param["filial_saida_id"] ?? null);

        $data_final->setSize('100%');
        $cliente_id->setSize('100%');
        $vendedor_id->setSize('100%');
        $data_inicial->setSize('100%');
        $filial_saida_id->setSize('100%');
        $page_vendakanbanview->setSize('100%');

        $loadingContainer = new TElement('div');
        $loadingContainer->style = 'text-align:center; padding:50px';

        $icon = new TElement('i');
        $icon->class = 'fas fa-spinner fa-spin fa-3x';

        $loadingContainer->add($icon);
        $loadingContainer->add('<br>Carregando');

        $page_vendakanbanview->add($loadingContainer);

        $this->page_vendakanbanview = $page_vendakanbanview;

        $row1 = $this->form->addFields([new TLabel("Data Inicial:", null, '14px', null, '100%'),$data_inicial],[new TLabel("Data Final:", null, '14px', null, '100%'),$data_final],[new TLabel("Filial de Saída:", null, '14px', null),$filial_saida_id]);
        $row1->layout = [' col-sm-4',' col-sm-4',' col-sm-4'];

        $row2 = $this->form->addFields([new TLabel("Cliente:", null, '14px', null),$cliente_id],[new TLabel("Vendedor:", null, '14px', null),$vendedor_id],[new TLabel(" ", null, '14px', null, '100%'),$button_buscar]);
        $row2->layout = ['col-sm-4','col-sm-4','col-sm-3'];

        $row3 = $this->form->addFields([$page_vendakanbanview]);
        $row3->layout = [' col-sm-12'];

        // create the form actions

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Kanban de Venda"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public function onShow($param = null)
    {               

    } 

}

