<?php

class VendaKanbanView extends TPage
{
    private static $database = 'kraftsoft';
    private static $activeRecord = 'Venda';
    private static $primaryKey = 'id';

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        try
        {
            parent::__construct();

            $kanban = new TKanban;
            $kanban->setItemDatabase(self::$database);

            // echo 'data inicial '.$param["data_inicial"] ?? "";
            // echo 'data final '.$param["data_final"] ?? "";

            $criteriaStage = new TCriteria();
            $criteriaItem = new TCriteria();

            $criteriaStage->setProperty('order', 'ordem asc');
            $criteriaItem->setProperty('order', 'data_hora_venda desc');

            TSession::setValue(__CLASS__.'load_filter_cliente_id', null);
            TSession::setValue(__CLASS__.'load_filter_vendedor_id', null);
            TSession::setValue(__CLASS__.'load_filter_filial_saida_id', null);
            TSession::setValue(__CLASS__.'load_filter_data_hora_venda', null);
            TSession::setValue(__CLASS__.'load_filter_data_hora_venda', null);

            if(!empty($param["cliente_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_cliente_id', $param["cliente_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_cliente_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('cliente_id', '=', $filterVar)); 
            }
            if(!empty($param["vendedor_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_vendedor_id', $param["vendedor_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_vendedor_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('vendedor_id', '=', $filterVar)); 
            }
            if(!empty($param["filial_saida_id"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_filial_saida_id', $param["filial_saida_id"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_filial_saida_id');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('filial_saida_id', '=', $filterVar)); 
            }
            if(!empty($param["data_inicial"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_data_hora_venda', $param["data_inicial"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_data_hora_venda');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('data_hora_venda', '>=', $filterVar)); 
            }
            if(!empty($param["data_final"] ?? ""))
        {
            TSession::setValue(__CLASS__.'load_filter_data_hora_venda', $param["data_final"] ?? "");
        }
        $filterVar = TSession::getValue(__CLASS__.'load_filter_data_hora_venda');
            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
                $criteriaItem->add(new TFilter('data_hora_venda', '<=', $filterVar)); 
            }

            $filterVar = TSession::getValue("userunitid");
            $criteriaItem->add(new TFilter('system_unit_id', '=', $filterVar)); 

         /*   TSession::setValue(__CLASS__.'load_filter_data_hora_venda_inicial', null);
            TSession::setValue(__CLASS__.'load_filter_data_hora_venda_final', null);

            if(!empty($param["data_inicial"] ?? ""))
            {
               $data = new DateTime($param["data_inicial"]);

            //   echo 'data inicial '.$data->format('Y-m-d');
               TSession::setValue(__CLASS__.'load_filter_data_hora_venda_inicial', $data->format('Y-m-d')); 
            }

            $filterVar = TSession::getValue(__CLASS__.'load_filter_data_hora_venda_inicial');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
               $criteriaItem->add(new TFilter('data_hora_venda', '>=', $filterVar));    
            }

            if(!empty($param["data_final"] ?? ""))
            {
                echo 'data final '.$param["data_final"];
            //   $data = new DateTime(trim($param["data_final"]));

            //   echo 'data final '.$data->format('Y-m-d');

               TSession::setValue(__CLASS__.'load_filter_data_hora_venda_final', $data->format('Y-m-d')); 
            }

            $filterVar = TSession::getValue(__CLASS__.'load_filter_data_hora_venda_final');

            if (isset($filterVar) AND ( (is_scalar($filterVar) AND $filterVar !== '') OR (is_array($filterVar) AND (!empty($filterVar)))))
            {
               $criteriaItem->add(new TFilter('data_hora_venda', '<=', $filterVar));    
            } */

            $criteriaItem->add(new TFilter('cliente_id', 'in', "(SELECT id FROM cliente WHERE deletado_em is NULL )")); 

            TTransaction::open(self::$database);
            $stages = VendaSituacao::getObjects($criteriaStage);
            $items  = Venda::getObjects($criteriaItem);

            if($stages)
            {
                foreach ($stages as $key => $stage)
                {

                    $kanban->addStage($stage->id, "{descricao}", $stage ,$stage->cor);

                }    
            }

            if($items)
            {
                foreach ($items as $key => $item)
                {

                    $item->data_hora_venda = call_user_func(function($value, $object, $row)
                    {
                        if(!empty(trim($value)))
                        {
                            try
                            {
                                $date = new DateTime($value);
                                return $date->format('d/m/Y H:i');
                            }
                            catch (Exception $e)
                            {
                                return $value;
                            }
                        }
                    }, $item->data_hora_venda, $item, null);

                    $item->valor_total = call_user_func(function($value, $object, $row) 
                    {
                        if(!$value)
                        {
                            $value = 0;
                        }

                        if(is_numeric($value))
                        {
                            return "R$ " . number_format($value, 2, ",", ".");
                        }
                        else
                        {
                            return $value;
                        }
                    }, $item->valor_total, $item, null);

                    $kanban->addItem($item->id, $item->venda_situacao_id, "Venda #{id}", "<b>Data:</b>  {data_hora_venda} <br>
<b>Cliente:</b>  {cliente->nome} <br>
<b>Vendedor:</b>  {vendedor->nome} <br>
<b>Valor total:</b> {valor_total} <br>", '', $item);

                }    
            }

            $kanbanItemAction_VendaFormView_onShow = new TAction(['VendaFormView', 'onShow']);

            $kanban->addItemAction("Visualizar Venda", $kanbanItemAction_VendaFormView_onShow, 'fas:search-plus #000000', null, true);

            //$kanban->setTemplatePath('app/resources/card.html');

            TTransaction::close();

            $container = new TVBox;

            $container->style = 'width: 100%';
            $container->class = 'form-container';
            if(empty($param['target_container']))
            {
                $container->add(TBreadCrumb::create(["Vendas","VendaKanbanView"]));
            }
            $container->add($kanban);

            parent::add($container);
        }
        catch(Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }

    public function onShow($param = null)
    {

    } 

}

