<?php

class VendaMetaForm extends TPage
{
    protected $form;
    private $formFields = [];
    private static $database = 'kraftsoft';
    private static $activeRecord = 'VendaMeta';
    private static $primaryKey = 'id';
    private static $formName = 'form_VendaMetaForm';

    use BuilderMasterDetailTrait;

    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();

        if(!empty($param['target_container']))
        {
            $this->adianti_target_container = $param['target_container'];
        }

        // creates the form
        $this->form = new BootstrapFormBuilder(self::$formName);
        // define the form title
        $this->form->setFormTitle("Cadastro de meta de venda");


        $id = new TEntry('id');
        $system_unit_id = new THidden('system_unit_id');
        $venda_meta_situacao_id = new TDBCombo('venda_meta_situacao_id', 'kraftsoft', 'VendaMetaSituacao', 'id', '{descricao}','descricao asc'  );
        $descricao = new TEntry('descricao');
        $data_inicial = new TDate('data_inicial');
        $data_final = new TDate('data_final');
        $valor_meta_geral_prevista = new TNumeric('valor_meta_geral_prevista', '2', ',', '.' );
        $valor_meta_geral_realizada = new TNumeric('valor_meta_geral_realizada', '2', ',', '.' );
        $data_ultimo_processamento = new TDateTime('data_ultimo_processamento');
        $criado_em = new TDateTime('criado_em');
        $criado_por = new TEntry('criado_por');
        $alterado_em = new TDateTime('alterado_em');
        $alterado_por = new TEntry('alterado_por');
        $venda_meta_vendedor_venda_meta_vendedor_id = new TDBCombo('venda_meta_vendedor_venda_meta_vendedor_id', 'kraftsoft', 'Vendedor', 'id', '{nome}','nome asc'  );
        $venda_meta_vendedor_venda_meta_id = new THidden('venda_meta_vendedor_venda_meta_id');
        $venda_meta_vendedor_venda_meta_valor_meta_prevista = new TNumeric('venda_meta_vendedor_venda_meta_valor_meta_prevista', '2', ',', '.' );
        $venda_meta_vendedor_venda_meta_valor_meta_realizada = new TNumeric('venda_meta_vendedor_venda_meta_valor_meta_realizada', '2', ',', '.' );
        $venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista = new TNumeric('venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista', '2', ',', '.' );
        $venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada = new TNumeric('venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada', '2', ',', '.' );
        $button_adicionar_venda_meta_vendedor_venda_meta = new TButton('button_adicionar_venda_meta_vendedor_venda_meta');

        $venda_meta_situacao_id->addValidation("Venda meta situacao id", new TRequiredValidator()); 
        $descricao->addValidation("Descrição", new TRequiredValidator()); 
        $data_inicial->addValidation("Data Inicial", new TRequiredValidator()); 
        $data_final->addValidation("Data Final", new TRequiredValidator()); 
        $valor_meta_geral_prevista->addValidation("Meta Geral Prevista (R$)", new TRequiredValidator()); 

        $button_adicionar_venda_meta_vendedor_venda_meta->setAction(new TAction([$this, 'onAddDetailVendaMetaVendedorVendaMeta'],['static' => 1]), "Adicionar");
        $button_adicionar_venda_meta_vendedor_venda_meta->addStyleClass('btn-default');
        $button_adicionar_venda_meta_vendedor_venda_meta->setImage('fas:plus #2ecc71');
        $venda_meta_situacao_id->enableSearch();
        $venda_meta_vendedor_venda_meta_vendedor_id->enableSearch();

        $data_final->setMask('dd/mm/yyyy');
        $data_inicial->setMask('dd/mm/yyyy');
        $criado_em->setMask('dd/mm/yyyy hh:ii');
        $alterado_em->setMask('dd/mm/yyyy hh:ii');
        $data_ultimo_processamento->setMask('dd/mm/yyyy hh:ii');

        $data_final->setDatabaseMask('yyyy-mm-dd');
        $data_inicial->setDatabaseMask('yyyy-mm-dd');
        $criado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $alterado_em->setDatabaseMask('yyyy-mm-dd hh:ii');
        $data_ultimo_processamento->setDatabaseMask('yyyy-mm-dd hh:ii');

        $id->setEditable(false);
        $criado_em->setEditable(false);
        $criado_por->setEditable(false);
        $alterado_em->setEditable(false);
        $alterado_por->setEditable(false);
        $data_ultimo_processamento->setEditable(false);
        $valor_meta_geral_realizada->setEditable(false);
        $venda_meta_vendedor_venda_meta_valor_meta_realizada->setEditable(false);
        $venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada->setEditable(false);

        $id->setSize(100);
        $descricao->setSize('100%');
        $criado_em->setSize('100%');
        $data_final->setSize('100%');
        $criado_por->setSize('100%');
        $system_unit_id->setSize(200);
        $alterado_em->setSize('100%');
        $data_inicial->setSize('100%');
        $alterado_por->setSize('100%');
        $venda_meta_situacao_id->setSize('100%');
        $valor_meta_geral_prevista->setSize('100%');
        $data_ultimo_processamento->setSize('100%');
        $valor_meta_geral_realizada->setSize('100%');
        $venda_meta_vendedor_venda_meta_id->setSize(200);
        $venda_meta_vendedor_venda_meta_vendedor_id->setSize('100%');
        $venda_meta_vendedor_venda_meta_valor_meta_prevista->setSize('100%');
        $venda_meta_vendedor_venda_meta_valor_meta_realizada->setSize('100%');
        $venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista->setSize('100%');
        $venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada->setSize('100%');

        $button_adicionar_venda_meta_vendedor_venda_meta->id = '6329f7fdeca86';

        $this->form->appendPage("Principal");

        $this->form->addFields([new THidden('current_tab')]);
        $this->form->setTabFunction("$('[name=current_tab]').val($(this).attr('data-current_page'));");

        $row1 = $this->form->addFields([new TLabel("Id:", null, '14px', null, '100%'),$id,$system_unit_id],[new TLabel("Situação:", '#ff0000', '14px', null, '100%'),$venda_meta_situacao_id]);
        $row1->layout = ['col-sm-6','col-sm-6'];

        $row2 = $this->form->addFields([new TLabel("Descrição:", '#ff0000', '14px', null, '100%'),$descricao]);
        $row2->layout = [' col-sm-12'];

        $row3 = $this->form->addFields([new TLabel("Data Inicial:", '#ff0000', '14px', null, '100%'),$data_inicial],[new TLabel("Data Final:", '#ff0000', '14px', null, '100%'),$data_final]);
        $row3->layout = ['col-sm-6','col-sm-6'];

        $row4 = $this->form->addFields([new TLabel("Meta Geral Prevista (R$):", '#ff0000', '14px', null, '100%'),$valor_meta_geral_prevista],[new TLabel("Meta Geral Realizada (R$):", null, '14px', null, '100%'),$valor_meta_geral_realizada]);
        $row4->layout = ['col-sm-6','col-sm-6'];

        $row5 = $this->form->addFields([new TLabel("Data/Hora Ultimo Processamento:", null, '14px', null, '100%'),$data_ultimo_processamento]);
        $row5->layout = ['col-sm-6'];

        $bcontainer_6329f6c2eca7b = new BContainer('bcontainer_6329f6c2eca7b');
        $this->bcontainer_6329f6c2eca7b = $bcontainer_6329f6c2eca7b;

        $bcontainer_6329f6c2eca7b->setTitle("Histórico de Alterações", '#333', '18px', '', '#fff');
        $bcontainer_6329f6c2eca7b->setBorderColor('#c0c0c0');

        $row6 = $bcontainer_6329f6c2eca7b->addFields([new TLabel("Criado Em:", null, '14px', null, '100%'),$criado_em],[new TLabel("Criado Por:", null, '14px', null, '100%'),$criado_por],[new TLabel("Alterado Em:", null, '14px', null, '100%'),$alterado_em],[new TLabel("Alterado Por:", null, '14px', null, '100%'),$alterado_por]);
        $row6->layout = [' col-sm-2',' col-sm-4',' col-sm-2',' col-sm-4'];

        $row7 = $this->form->addFields([$bcontainer_6329f6c2eca7b]);
        $row7->layout = [' col-sm-12'];

        $this->form->appendPage("Vendedores");

        $this->detailFormVendaMetaVendedorVendaMeta = new BootstrapFormBuilder('detailFormVendaMetaVendedorVendaMeta');
        $this->detailFormVendaMetaVendedorVendaMeta->setProperty('style', 'border:none; box-shadow:none; width:100%;');

        $this->detailFormVendaMetaVendedorVendaMeta->setProperty('class', 'form-horizontal builder-detail-form');

        $row8 = $this->detailFormVendaMetaVendedorVendaMeta->addFields([new TLabel("Vendedor:", '#ff0000', '14px', null, '100%'),$venda_meta_vendedor_venda_meta_vendedor_id,$venda_meta_vendedor_venda_meta_id],[]);
        $row8->layout = ['col-sm-6','col-sm-6'];

        $row9 = $this->detailFormVendaMetaVendedorVendaMeta->addFields([new TLabel("Meta Prevista (R$):", null, '14px', null, '100%'),$venda_meta_vendedor_venda_meta_valor_meta_prevista],[new TLabel("Meta Realizada (R$):", null, '14px', null, '100%'),$venda_meta_vendedor_venda_meta_valor_meta_realizada]);
        $row9->layout = [' col-sm-6','col-sm-6'];

        $row10 = $this->detailFormVendaMetaVendedorVendaMeta->addFields([new TLabel("Aproveitamento Carteira Prevista (%):", null, '14px', null, '100%'),$venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista],[new TLabel("Aproveitamento Carteira Realizada (%):", null, '14px', null, '100%'),$venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada]);
        $row10->layout = ['col-sm-6','col-sm-6'];

        $row11 = $this->detailFormVendaMetaVendedorVendaMeta->addFields([$button_adicionar_venda_meta_vendedor_venda_meta]);
        $row11->layout = [' col-sm-12'];

        $row12 = $this->detailFormVendaMetaVendedorVendaMeta->addFields([new THidden('venda_meta_vendedor_venda_meta__row__id')]);
        $this->venda_meta_vendedor_venda_meta_criteria = new TCriteria();

        $this->venda_meta_vendedor_venda_meta_list = new BootstrapDatagridWrapper(new TDataGrid);
        $this->venda_meta_vendedor_venda_meta_list->disableHtmlConversion();;
        $this->venda_meta_vendedor_venda_meta_list->generateHiddenFields();
        $this->venda_meta_vendedor_venda_meta_list->setId('venda_meta_vendedor_venda_meta_list');

        $this->venda_meta_vendedor_venda_meta_list->style = 'width:100%';
        $this->venda_meta_vendedor_venda_meta_list->class .= ' table-bordered';

        $column_venda_meta_vendedor_venda_meta_vendedor_nome = new TDataGridColumn('vendedor->nome', "Vendedor", 'left');
        $column_venda_meta_vendedor_venda_meta_valor_meta_prevista_transformed = new TDataGridColumn('valor_meta_prevista', "Meta Prevista (R$)", 'right');
        $column_venda_meta_vendedor_venda_meta_valor_meta_realizada_transformed = new TDataGridColumn('valor_meta_realizada', "Meta Realizada (R$)", 'right');
        $column_venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista_transformed = new TDataGridColumn('aproveiramento_carteira_prevista', "Aproveitamento Carteira Prevista (%)", 'right');
        $column_venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada_transformed = new TDataGridColumn('aproveitamento_carteira_realizada', "Aproveitamento Carteira Realizada (%)", 'right');

        $column_venda_meta_vendedor_venda_meta__row__data = new TDataGridColumn('__row__data', '', 'center');
        $column_venda_meta_vendedor_venda_meta__row__data->setVisibility(false);

        $action_onEditDetailVendaMetaVendedor = new TDataGridAction(array('VendaMetaForm', 'onEditDetailVendaMetaVendedor'));
        $action_onEditDetailVendaMetaVendedor->setUseButton(false);
        $action_onEditDetailVendaMetaVendedor->setButtonClass('btn btn-default btn-sm');
        $action_onEditDetailVendaMetaVendedor->setLabel("Editar");
        $action_onEditDetailVendaMetaVendedor->setImage('far:edit #478fca');
        $action_onEditDetailVendaMetaVendedor->setFields(['__row__id', '__row__data']);

        $this->venda_meta_vendedor_venda_meta_list->addAction($action_onEditDetailVendaMetaVendedor);
        $action_onDeleteDetailVendaMetaVendedor = new TDataGridAction(array('VendaMetaForm', 'onDeleteDetailVendaMetaVendedor'));
        $action_onDeleteDetailVendaMetaVendedor->setUseButton(false);
        $action_onDeleteDetailVendaMetaVendedor->setButtonClass('btn btn-default btn-sm');
        $action_onDeleteDetailVendaMetaVendedor->setLabel("Excluir");
        $action_onDeleteDetailVendaMetaVendedor->setImage('fas:trash-alt #dd5a43');
        $action_onDeleteDetailVendaMetaVendedor->setFields(['__row__id', '__row__data']);

        $this->venda_meta_vendedor_venda_meta_list->addAction($action_onDeleteDetailVendaMetaVendedor);

        $this->venda_meta_vendedor_venda_meta_list->addColumn($column_venda_meta_vendedor_venda_meta_vendedor_nome);
        $this->venda_meta_vendedor_venda_meta_list->addColumn($column_venda_meta_vendedor_venda_meta_valor_meta_prevista_transformed);
        $this->venda_meta_vendedor_venda_meta_list->addColumn($column_venda_meta_vendedor_venda_meta_valor_meta_realizada_transformed);
        $this->venda_meta_vendedor_venda_meta_list->addColumn($column_venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista_transformed);
        $this->venda_meta_vendedor_venda_meta_list->addColumn($column_venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada_transformed);

        $this->venda_meta_vendedor_venda_meta_list->addColumn($column_venda_meta_vendedor_venda_meta__row__data);

        $this->venda_meta_vendedor_venda_meta_list->createModel();
        $tableResponsiveDiv = new TElement('div');
        $tableResponsiveDiv->class = 'table-responsive';
        $tableResponsiveDiv->add($this->venda_meta_vendedor_venda_meta_list);
        $this->detailFormVendaMetaVendedorVendaMeta->addContent([$tableResponsiveDiv]);

        $column_venda_meta_vendedor_venda_meta_valor_meta_prevista_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_venda_meta_vendedor_venda_meta_valor_meta_realizada_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {
            if(!$value)
            {
                $value = 0;
            }

            if(is_numeric($value))
            {
                return "R$ " . number_format($value, 2, ",", ".");
            }
            else
            {
                return $value;
            }
        });

        $column_venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });

        $column_venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada_transformed->setTransformer(function($value, $object, $row, $cell = null, $last_row = null)
        {

                    if(!$value)
                    {
                        $value = 0;
                    }

                    if(is_numeric($value))
                    {
                        return number_format($value, 2, ",", ".");
                    }
                    else
                    {
                        return $value;
                    }

        });        $row13 = $this->form->addFields([$this->detailFormVendaMetaVendedorVendaMeta]);
        $row13->layout = [' col-sm-12'];

        // create the form actions
        $btn_onsave = $this->form->addAction("Salvar", new TAction([$this, 'onSave'],['static' => 1]), 'fas:save #ffffff');
        $this->btn_onsave = $btn_onsave;
        $btn_onsave->addStyleClass('btn-primary'); 

        $btn_onclear = $this->form->addAction("Limpar formulário", new TAction([$this, 'onClear']), 'fas:eraser #dd5a43');
        $this->btn_onclear = $btn_onclear;

        $btn_onshow = $this->form->addAction("Voltar", new TAction(['VendaMetaList', 'onShow']), 'fas:arrow-left #000000');
        $this->btn_onshow = $btn_onshow;

        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->class = 'form-container';
        if(empty($param['target_container']))
        {
            $container->add(TBreadCrumb::create(["Vendas","Cadastro de metas de venda"]));
        }
        $container->add($this->form);

        parent::add($container);

    }

    public  function onAddDetailVendaMetaVendedorVendaMeta($param = null) 
    {
        try
        {
            $data = $this->form->getData();

            $errors = [];
            $requiredFields = [];
            $requiredFields[] = ['label'=>"Vendedor id", 'name'=>"venda_meta_vendedor_venda_meta_vendedor_id", 'class'=>'TRequiredValidator', 'value'=>[]];
            foreach($requiredFields as $requiredField)
            {
                try
                {
                    (new $requiredField['class'])->validate($requiredField['label'], $data->{$requiredField['name']}, $requiredField['value']);
                }
                catch(Exception $e)
                {
                    $errors[] = $e->getMessage() . '.';
                }
             }
             if(count($errors) > 0)
             {
                 throw new Exception(implode('<br>', $errors));
             }

            $__row__id = !empty($data->venda_meta_vendedor_venda_meta__row__id) ? $data->venda_meta_vendedor_venda_meta__row__id : 'b'.uniqid();

            TTransaction::open(self::$database);

            $grid_data = new VendaMetaVendedor();
            $grid_data->__row__id = $__row__id;
            $grid_data->vendedor_id = $data->venda_meta_vendedor_venda_meta_vendedor_id;
            $grid_data->id = $data->venda_meta_vendedor_venda_meta_id;
            $grid_data->valor_meta_prevista = $data->venda_meta_vendedor_venda_meta_valor_meta_prevista;
            $grid_data->valor_meta_realizada = $data->venda_meta_vendedor_venda_meta_valor_meta_realizada;
            $grid_data->aproveiramento_carteira_prevista = $data->venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista;
            $grid_data->aproveitamento_carteira_realizada = $data->venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada;

            $__row__data = array_merge($grid_data->toArray(), (array)$grid_data->getVirtualData());
            $__row__data['__row__id'] = $__row__id;
            $__row__data['__display__']['vendedor_id'] =  $param['venda_meta_vendedor_venda_meta_vendedor_id'] ?? null;
            $__row__data['__display__']['id'] =  $param['venda_meta_vendedor_venda_meta_id'] ?? null;
            $__row__data['__display__']['valor_meta_prevista'] =  $param['venda_meta_vendedor_venda_meta_valor_meta_prevista'] ?? null;
            $__row__data['__display__']['valor_meta_realizada'] =  $param['venda_meta_vendedor_venda_meta_valor_meta_realizada'] ?? null;
            $__row__data['__display__']['aproveiramento_carteira_prevista'] =  $param['venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista'] ?? null;
            $__row__data['__display__']['aproveitamento_carteira_realizada'] =  $param['venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada'] ?? null;

            $grid_data->__row__data = base64_encode(serialize((object)$__row__data));
            $row = $this->venda_meta_vendedor_venda_meta_list->addItem($grid_data);
            $row->id = $grid_data->__row__id;

            TDataGrid::replaceRowById('venda_meta_vendedor_venda_meta_list', $grid_data->__row__id, $row);

            TTransaction::close();

            $data = new stdClass;
            $data->venda_meta_vendedor_venda_meta_vendedor_id = '';
            $data->venda_meta_vendedor_venda_meta_id = '';
            $data->venda_meta_vendedor_venda_meta_valor_meta_prevista = '';
            $data->venda_meta_vendedor_venda_meta_valor_meta_realizada = '';
            $data->venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista = '';
            $data->venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada = '';
            $data->venda_meta_vendedor_venda_meta__row__id = '';

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6329f7fdeca86');
               if(typeof element.attr('add') != 'undefined')
               {
                   element.html(base64_decode(element.attr('add')));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }

    public static function onEditDetailVendaMetaVendedor($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));
            $__row__data->__display__ = is_array($__row__data->__display__) ? (object) $__row__data->__display__ : $__row__data->__display__;

            $data = new stdClass;
            $data->venda_meta_vendedor_venda_meta_vendedor_id = $__row__data->__display__->vendedor_id ?? null;
            $data->venda_meta_vendedor_venda_meta_id = $__row__data->__display__->id ?? null;
            $data->venda_meta_vendedor_venda_meta_valor_meta_prevista = $__row__data->__display__->valor_meta_prevista ?? null;
            $data->venda_meta_vendedor_venda_meta_valor_meta_realizada = $__row__data->__display__->valor_meta_realizada ?? null;
            $data->venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista = $__row__data->__display__->aproveiramento_carteira_prevista ?? null;
            $data->venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada = $__row__data->__display__->aproveitamento_carteira_realizada ?? null;
            $data->venda_meta_vendedor_venda_meta__row__id = $__row__data->__row__id;

            TForm::sendData(self::$formName, $data);
            TScript::create("
               var element = $('#6329f7fdeca86');
               if(!element.attr('add')){
                   element.attr('add', base64_encode(element.html()));
               }
               element.html(\"<span><i class='far fa-edit' style='color:#478fca;padding-right:4px;'></i>Editar</span>\");
               if(!element.attr('edit')){
                   element.attr('edit', base64_encode(element.html()));
               }
            ");

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public static function onDeleteDetailVendaMetaVendedor($param = null) 
    {
        try
        {

            $__row__data = unserialize(base64_decode($param['__row__data']));

            $data = new stdClass;
            $data->venda_meta_vendedor_venda_meta_vendedor_id = '';
            $data->venda_meta_vendedor_venda_meta_id = '';
            $data->venda_meta_vendedor_venda_meta_valor_meta_prevista = '';
            $data->venda_meta_vendedor_venda_meta_valor_meta_realizada = '';
            $data->venda_meta_vendedor_venda_meta_aproveiramento_carteira_prevista = '';
            $data->venda_meta_vendedor_venda_meta_aproveitamento_carteira_realizada = '';
            $data->venda_meta_vendedor_venda_meta__row__id = '';

            TForm::sendData(self::$formName, $data);

            TDataGrid::removeRowById('venda_meta_vendedor_venda_meta_list', $__row__data->__row__id);

        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
        }
    }
    public function onSave($param = null) 
    {
        try
        {
            TTransaction::open(self::$database); // open a transaction

            $messageAction = null;

            $this->form->validate(); // validate form data

            $object = new VendaMeta(); // create an empty object 

            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data

            //salvando o nome do usuario
            Funcoes::SalvarUsuarioCadastro($object);

            $object->store(); // save the object 

            TForm::sendData(self::$formName, (object)['id' => $object->id]);

            $loadPageParam = [];

            if(!empty($param['target_container']))
            {
                $loadPageParam['target_container'] = $param['target_container'];
            }

            $venda_meta_vendedor_venda_meta_items = $this->storeMasterDetailItems('VendaMetaVendedor', 'venda_meta_id', 'venda_meta_vendedor_venda_meta', $object, $param['venda_meta_vendedor_venda_meta_list___row__data'] ?? [], $this->form, $this->venda_meta_vendedor_venda_meta_list, function($masterObject, $detailObject){ 

                //code here

            }, $this->venda_meta_vendedor_venda_meta_criteria); 

            // get the generated {PRIMARY_KEY}
            $data->id = $object->id; 

            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction

            TToast::show('success', "Registro salvo", 'topRight', 'far:check-circle');
            TApplication::loadPage('VendaMetaList', 'onShow', $loadPageParam); 

        }
        catch (Exception $e) // in case of exception
        {
            //</catchAutoCode> 

            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }

    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open(self::$database); // open a transaction

                $object = new VendaMeta($key); // instantiates the Active Record 

                $venda_meta_vendedor_venda_meta_items = $this->loadMasterDetailItems('VendaMetaVendedor', 'venda_meta_id', 'venda_meta_vendedor_venda_meta', $object, $this->form, $this->venda_meta_vendedor_venda_meta_list, $this->venda_meta_vendedor_venda_meta_criteria, function($masterObject, $detailObject, $objectItems){ 

                    //code here

                }); 

                $this->form->setData($object); // fill the form 

                TTransaction::close(); // close the transaction 
            }
            else
            {
                $this->form->clear();
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(true);

    }

    public function onShow($param = null)
    {

        $object = new stdClass();
        $object->system_unit_id = TSession::getValue('userunitid');
        TForm::sendData(self::$formName, $object);

    } 

    public static function getFormName()
    {
        return self::$formName;
    }

}

