PRAGMA foreign_keys=OFF; 

CREATE TABLE api_documentos( 
      id  INTEGER    NOT NULL  , 
      integradores_id int   NOT NULL  , 
      system_unit_id int   , 
      descricao text   NOT NULL  , 
      token_api text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      deletado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(integradores_id) REFERENCES integradores(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE apidocumentos_integradoresservicos( 
      id  INTEGER    NOT NULL  , 
      api_documentos_id int   NOT NULL  , 
      integradores_servicos_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(api_documentos_id) REFERENCES api_documentos(id),
FOREIGN KEY(integradores_servicos_id) REFERENCES integradores_servicos(id)) ; 

CREATE TABLE api_error( 
      id  INTEGER    NOT NULL  , 
      classe text   , 
      metodo text   , 
      url text   , 
      dados text   , 
      error_message text   , 
      inserted_at datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ativo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE banco( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      numero text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE boleto_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa( 
      id  INTEGER    NOT NULL  , 
      caixa_situacao_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      system_users_abertura_id int   NOT NULL  , 
      system_users_operador_id int   NOT NULL  , 
      system_users_fechamento_id int   , 
      data_hora_abertura datetime   , 
      data_hora_fechamento datetime   , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(caixa_situacao_id) REFERENCES caixa_situacao(id),
FOREIGN KEY(system_users_abertura_id) REFERENCES system_users(id),
FOREIGN KEY(system_users_operador_id) REFERENCES system_users(id),
FOREIGN KEY(system_users_fechamento_id) REFERENCES system_users(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE caixa_lancamentos( 
      id  INTEGER    NOT NULL  , 
      caixa_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      caixa_tipo_lancamento_id int   NOT NULL  , 
      valor double   NOT NULL  , 
      data_hora_lancamento datetime   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      observacao text   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      id_origem int   , 
 PRIMARY KEY (id),
FOREIGN KEY(caixa_id) REFERENCES caixa(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id),
FOREIGN KEY(caixa_tipo_lancamento_id) REFERENCES caixa_tipo_lancamento(id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id)) ; 

CREATE TABLE caixa_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_tipo_lancamento( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      centro_custo_tipo_id int   NOT NULL  , 
      centro_custo_pai_id int   , 
      numero text   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(centro_custo_tipo_id) REFERENCES centro_custo_tipo(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE centro_custo_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cep_cache( 
      id  INTEGER    NOT NULL  , 
      cep text   , 
      rua text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      cidade text   , 
      bairro text   , 
      codigo_ibge text   , 
      uf char  (2)   , 
      cidade_id int   , 
      estado_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agendamentos( 
      id  INTEGER    NOT NULL  , 
      certificado_venda_id int   NOT NULL  , 
      titulo text   NOT NULL  , 
      data_hora_inicial datetime   NOT NULL  , 
      data_hora_final datetime   NOT NULL  , 
      observacao text   , 
      cor text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(certificado_venda_id) REFERENCES certificado_venda(id)) ; 

CREATE TABLE certificado_agente_registro( 
      id  INTEGER    NOT NULL  , 
      parceiro_id int   , 
      nome text   NOT NULL  , 
      cpf text   , 
      fone text   , 
      email text   , 
      percentual_comissao double   , 
      deletado_em datetime   , 
      criado_em datetime   NOT NULL  , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(parceiro_id) REFERENCES parceiro(id)) ; 

CREATE TABLE certificado_cliente( 
      id  INTEGER    NOT NULL  , 
      cliente_id int   NOT NULL  , 
      parceiro_id int   , 
      produto_id int   NOT NULL  , 
      certificado_cliente_situacao_id int   NOT NULL  , 
      data_vencimento_certificado date   , 
      certificado_venda_id int   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(parceiro_id) REFERENCES parceiro(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(certificado_venda_id) REFERENCES certificado_venda(id),
FOREIGN KEY(certificado_cliente_situacao_id) REFERENCES certificado_cliente_situacao(id)) ; 

CREATE TABLE certificado_cliente_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_email_historico( 
      id  INTEGER    NOT NULL  , 
      certificado_cliente_id int   NOT NULL  , 
      email text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(certificado_cliente_id) REFERENCES certificado_cliente(id)) ; 

CREATE TABLE certificadora( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      texto_emissao text   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora_produtos( 
      id  INTEGER    NOT NULL  , 
      certificadora_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      qtde_dias_vencimento int   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      valor_custo double   , 
 PRIMARY KEY (id),
FOREIGN KEY(certificadora_id) REFERENCES certificadora(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE certificado_tipo_atendimento( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_repasse( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      parceiro_id int   , 
      certificado_agente_registro_id int   NOT NULL  , 
      certificado_venda_situacao_id int   NOT NULL  , 
      certificado_venda_modalidade_id int   , 
      certificado_venda_tipomodalidade_id int   , 
      certificado_tipo_repasse_id int   , 
      vendedor_id int   , 
      tabela_preco_id int   , 
      certificadora_id int   , 
      valor_custo double   , 
      data_hora_agendamento datetime   , 
      data_vencimento_certificado date   , 
      valor_externo double   , 
      custo_externo double   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      agente_comissao_percentual double   , 
      agente_comissao_valor double   , 
      vendedor_comissao_percentual double   , 
      vendedor_comissao_valor double   , 
      atendimento_externo text   , 
      parceiro_comissao_percentual double   , 
      parceiro_valor_repasse double   , 
      valor_total double   NOT NULL  , 
      comissao_total double   , 
      lucro_total double   , 
      valor_cliente double   , 
      valor_produto double   NOT NULL  , 
      protocolo_emissao text   , 
      data_emissao date   , 
      data_pagamento date   , 
      certificado_tipo_atendimento_id int   , 
      observacao text   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(parceiro_id) REFERENCES parceiro(id),
FOREIGN KEY(certificado_agente_registro_id) REFERENCES certificado_agente_registro(id),
FOREIGN KEY(certificado_venda_situacao_id) REFERENCES certificado_venda_situacao(id),
FOREIGN KEY(certificado_venda_modalidade_id) REFERENCES certificado_venda_modalidade(id),
FOREIGN KEY(certificado_venda_tipomodalidade_id) REFERENCES certificado_venda_tipomodalidade(id),
FOREIGN KEY(certificado_tipo_repasse_id) REFERENCES certificado_tipo_repasse(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(tabela_preco_id) REFERENCES tabela_preco(id),
FOREIGN KEY(certificado_tipo_atendimento_id) REFERENCES certificado_tipo_atendimento(id),
FOREIGN KEY(certificadora_id) REFERENCES certificadora(id)) ; 

CREATE TABLE certificado_venda_documentos( 
      id  INTEGER    NOT NULL  , 
      certificado_venda_id int   NOT NULL  , 
      descricao_arquivo text   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(certificado_venda_id) REFERENCES certificado_venda(id)) ; 

CREATE TABLE certificado_venda_formapgto( 
      id  INTEGER    NOT NULL  , 
      certificado_venda_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(certificado_venda_id) REFERENCES certificado_venda(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id)) ; 

CREATE TABLE certificado_venda_modalidade( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      certificado_tipo_repasse_id int   NOT NULL  , 
      certificado_venda_tipomodalidade_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(certificado_venda_tipomodalidade_id) REFERENCES certificado_venda_tipomodalidade(id),
FOREIGN KEY(certificado_tipo_repasse_id) REFERENCES certificado_tipo_repasse(id)) ; 

CREATE TABLE certificado_venda_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      ordem int   , 
      cor text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_tipomodalidade( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cfop( 
      id  INTEGER    NOT NULL  , 
      numero char  (4)   NOT NULL  , 
      descricao text   NOT NULL  , 
      aplicacao text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE chave_pix_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cidade( 
      id  INTEGER    NOT NULL  , 
      estado_id int   NOT NULL  , 
      pais_id int   , 
      nome text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      codigo_ibge text   , 
 PRIMARY KEY (id),
FOREIGN KEY(estado_id) REFERENCES estado(id),
FOREIGN KEY(pais_id) REFERENCES pais(id)) ; 

CREATE TABLE cliente( 
      id  INTEGER    NOT NULL  , 
      pessoa_tipo_id int   NOT NULL  , 
      cliente_classificacao_id int   NOT NULL  , 
      cliente_classificacao_subgrupo_id int   , 
      vendedor_id int   , 
      notafiscal_indiedest_id int   NOT NULL  , 
      notafiscal_crt_id int   , 
      nome text   NOT NULL  , 
      cpf_cnpj text   , 
      rg text   , 
      email text   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      insc_estadual text   , 
      insc_municipal text   , 
      razao_social text   , 
      fone text   , 
      observacoes text   , 
      data_nascimento date   , 
      conjuge text   , 
      conjuge_cpf text   , 
      nome_pai text   , 
      nome_mae text   , 
      local_trabalho text   , 
      renda double   , 
      tempo_trabalho text   , 
      residencia_propria int   , 
      utilizar_endereco_cobranca int   NOT NULL  , 
      cobranca_cnpj text   , 
      cobranca_nome text   , 
      cobranca_cep text   , 
      cobranca_endereco text   , 
      cobranca_bairro text   , 
      cobranca_uf text   , 
      cobranca_cidade text   , 
      cobranca_fones text   , 
      cliente_situacao_id int   NOT NULL  , 
      limite_credito double   , 
      limite_utilizado double   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
      system_unit_id int   , 
      deletado_em datetime   , 
      vendas_quantidade int   , 
      vendas_valortotal double   , 
      vendas_dataultima datetime   , 
      vendas_valormaior double   , 
      vendas_datamaior datetime   , 
      observacoes_financeiro text   , 
      tabela_preco_id int   , 
      percentual_comissao_vendedor double   , 
      cliente_exterior char  (1)   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(pessoa_tipo_id) REFERENCES pessoa_tipo(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(residencia_propria) REFERENCES resposta(id),
FOREIGN KEY(utilizar_endereco_cobranca) REFERENCES resposta(id),
FOREIGN KEY(cliente_situacao_id) REFERENCES cliente_situacao(id),
FOREIGN KEY(notafiscal_indiedest_id) REFERENCES notafiscal_indiedest(id),
FOREIGN KEY(notafiscal_crt_id) REFERENCES notafiscal_crt(id),
FOREIGN KEY(cliente_classificacao_id) REFERENCES cliente_classificacao(id),
FOREIGN KEY(cliente_classificacao_subgrupo_id) REFERENCES cliente_classificacao_subgrupo(id),
FOREIGN KEY(tabela_preco_id) REFERENCES tabela_preco(id)) ; 

CREATE TABLE cliente_classificacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
      ativo_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(ativo_id) REFERENCES ativo(id)) ; 

CREATE TABLE cliente_classificacao_subgrupo( 
      id  INTEGER    NOT NULL  , 
      cliente_classificacao_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_classificacao_id) REFERENCES cliente_classificacao(id)) ; 

CREATE TABLE cliente_contato( 
      id  INTEGER    NOT NULL  , 
      cliente_id int   , 
      tipo_contato text   , 
      nome text   NOT NULL  , 
      fone text   , 
      ativo_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id)) ; 

CREATE TABLE cliente_endereco( 
      id  INTEGER    NOT NULL  , 
      logradouro text   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      principal int   NOT NULL  , 
      cidade_id int   NOT NULL  , 
      bairro text   , 
      cep text   , 
      numero text   , 
      complemento text   , 
      ativo_id int   NOT NULL  , 
      codigo_ibge varchar  (20)   , 
      ibge_estado int  (2)   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(principal) REFERENCES resposta(id),
FOREIGN KEY(cidade_id) REFERENCES cidade(id)) ; 

CREATE TABLE cliente_historico_limite( 
      id  INTEGER    NOT NULL  , 
      cliente_id int   NOT NULL  , 
      valor double   NOT NULL  , 
      data_hora datetime   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id)) ; 

CREATE TABLE cliente_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE condicao_pagamento( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      numero_parcelas int   NOT NULL  , 
      dias_primeira_parcelas int   , 
      dias_entre_parcelas int   , 
      taxa double   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes( 
      id  INTEGER    NOT NULL  , 
      forma_pagamento_id_dinheiro_caixa int   , 
      forma_pagamento_id_titulos_cpag_nf int   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(forma_pagamento_id_dinheiro_caixa) REFERENCES forma_pagamento(id),
FOREIGN KEY(forma_pagamento_id_titulos_cpag_nf) REFERENCES forma_pagamento(id)) ; 

CREATE TABLE configuracoes_filial( 
      id  INTEGER    NOT NULL  , 
      configuracoes_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      produto_etiqueta_configuracoes_id int   , 
      plano_conta_mascara text   , 
      centro_custo_mascara text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      plano_conta_crec_id int   , 
      centro_custo_crec_id int   , 
      cpag_usa_plano_contas_id int   , 
      info_complementar_orcamento text   , 
      informar_duplicidade_de_item_venda_id int   , 
      venda_apenas_com_estoque_id int   , 
      notafiscal_cprod_padrao_orcamento_id int   , 
      notafiscal_cprod_padrao_venda_id int   , 
      produto_margem_padrao double   , 
 PRIMARY KEY (id),
FOREIGN KEY(configuracoes_id) REFERENCES configuracoes(id),
FOREIGN KEY(produto_etiqueta_configuracoes_id) REFERENCES produto_etiqueta_configuracoes(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(plano_conta_crec_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_crec_id) REFERENCES centro_custo(id),
FOREIGN KEY(cpag_usa_plano_contas_id) REFERENCES resposta(id),
FOREIGN KEY(notafiscal_cprod_padrao_orcamento_id) REFERENCES notafiscal_cprod_padrao(id),
FOREIGN KEY(informar_duplicidade_de_item_venda_id) REFERENCES resposta(id),
FOREIGN KEY(venda_apenas_com_estoque_id) REFERENCES resposta(id),
FOREIGN KEY(notafiscal_cprod_padrao_venda_id) REFERENCES notafiscal_cprod_padrao(id)) ; 

CREATE TABLE contabil_lancamentos( 
      id  INTEGER    NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      contabil_lancamentos_tipo_id int   NOT NULL  , 
      contabil_lancamentos_situacao_id int   NOT NULL  , 
      contabil_lancamentos_origem_id int   NOT NULL  , 
      data_lancamento date   NOT NULL  , 
      valor double   NOT NULL  , 
      contasrec_id int   , 
      contaspag_contabil_id int   , 
      conta_corrente_lancamentos_id int   , 
      historico text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(plano_conta_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_id) REFERENCES centro_custo(id),
FOREIGN KEY(contabil_lancamentos_tipo_id) REFERENCES contabil_lancamentos_tipo(id),
FOREIGN KEY(contasrec_id) REFERENCES contasrec(id),
FOREIGN KEY(contaspag_contabil_id) REFERENCES contaspag_contabil(id),
FOREIGN KEY(conta_corrente_lancamentos_id) REFERENCES conta_corrente_lancamentos(id),
FOREIGN KEY(contabil_lancamentos_situacao_id) REFERENCES contabil_lancamentos_situacao(id),
FOREIGN KEY(contabil_lancamentos_origem_id) REFERENCES contabil_lancamentos_origem(id)) ; 

CREATE TABLE contabil_lancamentos_origem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      banco_id int   , 
      nome text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      agencia text   , 
      conta text   , 
      agencia_digito text   , 
      conta_digito text   , 
      end_logradouro text   , 
      end_bairro text   , 
      end_cidade text   , 
      end_estado text   , 
      end_cep text   , 
      end_numero text   , 
      boleto_convenio text   , 
      boleto_carteira text   , 
      boleto_gerar text   NOT NULL  , 
      boleto_codigo_cedente text   , 
      boleto_digito_cod_cedente text   , 
      boleto_instrucoes text   , 
      boleto_multa double   , 
      boleto_juros_dia double   , 
      boleto_digitos_nosso_numero int   , 
      boleto_local_pagamento text   , 
      boleto_codigo_transmissao text   , 
 PRIMARY KEY (id),
FOREIGN KEY(banco_id) REFERENCES banco(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE conta_corrente_lancamentos( 
      id  INTEGER    NOT NULL  , 
      conta_corrente_id int   NOT NULL  , 
      conta_corrente_lanc_tipo_id int   NOT NULL  , 
      conta_corrente_lanc_origem_id int   NOT NULL  , 
      contaspag_baixas_id int   , 
      contasrec_baixas_id int   , 
      data_lancamento date   NOT NULL  , 
      valor double   NOT NULL  , 
      documento text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      historico text   , 
      plano_conta_id int   , 
      centro_custo_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(conta_corrente_id) REFERENCES conta_corrente(id),
FOREIGN KEY(conta_corrente_lanc_tipo_id) REFERENCES conta_corrente_lanc_tipo(id),
FOREIGN KEY(plano_conta_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_id) REFERENCES centro_custo(id),
FOREIGN KEY(contaspag_baixas_id) REFERENCES contaspag_baixas(id),
FOREIGN KEY(contasrec_baixas_id) REFERENCES contasrec_baixas(id),
FOREIGN KEY(conta_corrente_lanc_origem_id) REFERENCES conta_corrente_lanc_origem(id)) ; 

CREATE TABLE conta_corrente_lanc_origem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag( 
      id  INTEGER    NOT NULL  , 
      contaspag_situacao_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      contaspag_origem_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      numero_documento text   NOT NULL  , 
      parcela text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      data_emissao date   NOT NULL  , 
      valor double   NOT NULL  , 
      data_vencimento date   NOT NULL  , 
      data_venc_original date   , 
      observacao text   , 
      data_pagamento date   , 
      desconto double   , 
      juros double   , 
      valor_pago double   , 
      valor_aberto double   , 
      valor_multa double   , 
      cheque_banco_id int   , 
      cheque_agencia text   , 
      cheque_conta double   , 
      cheque_emitente text   , 
      cheque_cpfcnpj text   , 
      data_competencia date   , 
      contaspag_bloco_id int   , 
      nota_fiscal_compra_id int   , 
      data_vencimento_calendario datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(contaspag_situacao_id) REFERENCES contaspag_situacao(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id),
FOREIGN KEY(fornecedor_id) REFERENCES fornecedor(id),
FOREIGN KEY(contaspag_origem_id) REFERENCES contaspag_origem(id),
FOREIGN KEY(cheque_banco_id) REFERENCES banco(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(contaspag_bloco_id) REFERENCES contaspag_bloco(id),
FOREIGN KEY(nota_fiscal_compra_id) REFERENCES nota_fiscal_compra(id)) ; 

CREATE TABLE contaspag_anexos( 
      id  INTEGER    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      titulos_tipo_anexo_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(contaspag_id) REFERENCES contaspag(id),
FOREIGN KEY(titulos_tipo_anexo_id) REFERENCES titulos_tipo_anexo(id)) ; 

CREATE TABLE contaspag_baixas( 
      id  INTEGER    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      conta_corrente_id int   NOT NULL  , 
      data_pagamento date   NOT NULL  , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      juros double   , 
      desconto double   , 
      saldo_aberto double   , 
      saldo_apagar double   , 
      multa double   , 
      historico text   , 
 PRIMARY KEY (id),
FOREIGN KEY(contaspag_id) REFERENCES contaspag(id),
FOREIGN KEY(conta_corrente_id) REFERENCES conta_corrente(id)) ; 

CREATE TABLE contaspag_bloco( 
      id  INTEGER    NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      contaspag_origem_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      quantidade_parcelas int   NOT NULL  , 
      primeiro_vencimento date   , 
      valor double   NOT NULL  , 
      numero_documento text   , 
      observacao text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(fornecedor_id) REFERENCES fornecedor(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id),
FOREIGN KEY(contaspag_origem_id) REFERENCES contaspag_origem(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE contaspag_bloco_contabil( 
      id  INTEGER    NOT NULL  , 
      contaspag_bloco_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(plano_conta_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_id) REFERENCES centro_custo(id),
FOREIGN KEY(contaspag_bloco_id) REFERENCES contaspag_bloco(id)) ; 

CREATE TABLE contaspag_contabil( 
      id  INTEGER    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(contaspag_id) REFERENCES contaspag(id),
FOREIGN KEY(plano_conta_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_id) REFERENCES centro_custo(id)) ; 

CREATE TABLE contaspag_historico_venc( 
      id  INTEGER    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      vencimento_anterior date   , 
      vencimento_atual date   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(contaspag_id) REFERENCES contaspag(id)) ; 

CREATE TABLE contaspag_origem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      contasrec_situacao_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      contasrec_origem_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      numero_documento text   , 
      parcela text   , 
      valor double   NOT NULL  , 
      data_vencimento date   NOT NULL  , 
      data_venc_original date   , 
      observacao text   , 
      data_pagamento date   , 
      desconto double   , 
      juros double   , 
      valor_pago double   , 
      valor_aberto double   , 
      valor_multa double   , 
      cheque_banco_id int   , 
      cheque_agencia text   , 
      cheque_conta text   , 
      cheque_emitente text   , 
      cheque_cpfcnpj text   , 
      data_competencia date   , 
      conta_corrente_boleto_id int   , 
      boleto_situacao_id int   , 
      boleto_nosso_numero text   , 
      vendedor_comissao double   , 
      vendedor_id int   , 
      contasrec_bloco_id int   , 
      venda_formapgto_id int   , 
      data_emissao date   NOT NULL  , 
      ativo_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(contasrec_situacao_id) REFERENCES contasrec_situacao(id),
FOREIGN KEY(plano_conta_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_id) REFERENCES centro_custo(id),
FOREIGN KEY(contasrec_origem_id) REFERENCES contasrec_origem(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(cheque_banco_id) REFERENCES banco(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id),
FOREIGN KEY(conta_corrente_boleto_id) REFERENCES conta_corrente(id),
FOREIGN KEY(boleto_situacao_id) REFERENCES boleto_situacao(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(contasrec_bloco_id) REFERENCES contasrec_bloco(id),
FOREIGN KEY(venda_formapgto_id) REFERENCES venda_formapgto(id),
FOREIGN KEY(ativo_id) REFERENCES ativo(id)) ; 

CREATE TABLE contasrec_anexos( 
      id  INTEGER    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      titulos_tipo_anexo_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(contasrec_id) REFERENCES contasrec(id),
FOREIGN KEY(titulos_tipo_anexo_id) REFERENCES titulos_tipo_anexo(id)) ; 

CREATE TABLE contasrec_baixas( 
      id  INTEGER    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      conta_corrente_id int   NOT NULL  , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      juros double   , 
      desconto double   , 
      saldo_aberto double   NOT NULL  , 
      saldo_apagar double   , 
      multa double   , 
      historico text   , 
      data_pagamento date   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(contasrec_id) REFERENCES contasrec(id),
FOREIGN KEY(conta_corrente_id) REFERENCES conta_corrente(id)) ; 

CREATE TABLE contasrec_bloco( 
      id  INTEGER    NOT NULL  , 
      cliente_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      quantidade_parcelas int   NOT NULL  , 
      primeiro_vencimento date   , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      numero_documento text   , 
      observacao text   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(plano_conta_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_id) REFERENCES centro_custo(id)) ; 

CREATE TABLE contasrec_historico_cobranca( 
      id  INTEGER    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      historico text   NOT NULL  , 
      data_cobranca date   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(contasrec_id) REFERENCES contasrec(id)) ; 

CREATE TABLE contasrec_historico_venc( 
      id  INTEGER    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      vencimento_anterior date   , 
      vencimento_atual date   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(contasrec_id) REFERENCES contasrec(id)) ; 

CREATE TABLE contasrec_origem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_cofins( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_icms( 
      id  INTEGER    NOT NULL  , 
      regime_tributario_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(regime_tributario_id) REFERENCES notafiscal_crt(id)) ; 

CREATE TABLE cst_ipi( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_pis( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos( 
      id  INTEGER    NOT NULL  , 
      despesas_servicos_tipo_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(despesas_servicos_tipo_id) REFERENCES despesas_servicos_tipo(id)) ; 

CREATE TABLE despesas_servicos_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE dispositivos( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      token varchar  (100)   NOT NULL  , 
      serial_dispositivo text   , 
      criado_em datetime   NOT NULL  , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      alterado_por text   , 
      deletado_em datetime   , 
      data_hora_ultima_sincronizacao datetime   , 
      ip_sincronizacao text   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE email_template( 
      id  INTEGER    NOT NULL  , 
      titulo text   NOT NULL  , 
      mensagem text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estado( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      sigla char  (2)   NOT NULL  , 
      codigo_ibge text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_deposito( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE estoque_estante( 
      id  INTEGER    NOT NULL  , 
      estoque_rua_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(estoque_rua_id) REFERENCES estoque_rua(id)) ; 

CREATE TABLE estoque_lancamentos( 
      id  INTEGER    NOT NULL  , 
      produto_id int   NOT NULL  , 
      estoque_origem_id int   NOT NULL  , 
      estoque_tipo_movimentacao_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      produto_lote_id int   , 
      venda_id int   , 
      nota_fiscal_compra_id int   , 
      ordem_producao_id int   , 
      quantidade double   NOT NULL  , 
      observacao text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      preco_venda double   , 
      preco_custo double   , 
      data_lancamento date   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(estoque_origem_id) REFERENCES estoque_origem(id),
FOREIGN KEY(estoque_tipo_movimentacao_id) REFERENCES estoque_tipo_movimentacao(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(venda_id) REFERENCES venda(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(produto_lote_id) REFERENCES produto_lote(id),
FOREIGN KEY(estoque_deposito_id) REFERENCES estoque_deposito(id),
FOREIGN KEY(nota_fiscal_compra_id) REFERENCES nota_fiscal_compra(id),
FOREIGN KEY(ordem_producao_id) REFERENCES ordem_producao(id)) ; 

CREATE TABLE estoque_origem( 
      id  INTEGER    NOT NULL  , 
      estoque_tipo_movimentacao_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(estoque_tipo_movimentacao_id) REFERENCES estoque_tipo_movimentacao(id)) ; 

CREATE TABLE estoque_prateleira( 
      id  INTEGER    NOT NULL  , 
      estoque_estante_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(estoque_estante_id) REFERENCES estoque_estante(id)) ; 

CREATE TABLE estoque_rua( 
      id  INTEGER    NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(estoque_deposito_id) REFERENCES estoque_deposito(id)) ; 

CREATE TABLE estoque_saldos( 
      id  INTEGER    NOT NULL  , 
      produto_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      produto_lote_id int   , 
      quant_disponivel double   NOT NULL  , 
      quant_reservada double   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      preco_medio_venda double   , 
      preco_medio_custo double   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(produto_lote_id) REFERENCES produto_lote(id),
FOREIGN KEY(estoque_deposito_id) REFERENCES estoque_deposito(id)) ; 

CREATE TABLE estoque_tipo_movimentacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos( 
      id  INTEGER    NOT NULL  , 
      system_program_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      email_template_id int   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(email_template_id) REFERENCES email_template(id),
FOREIGN KEY(system_program_id) REFERENCES system_program(id)) ; 

CREATE TABLE eventos_documentos( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   , 
      system_users_id int   , 
      system_unit_id int   , 
      cstat int   , 
      xmotivo varchar  (255)   , 
      xevento varchar  (255)   , 
      tpevento varchar  (255)   , 
      nseqevento int   , 
      dhregevento datetime   , 
      nprot varchar  (255)   , 
      origem_event varchar  (255)   , 
      mensagem_manual text   , 
      tpamb int   , 
      veraplic varchar  (255)   , 
      chnfe varchar  (255)   , 
      dhrecbto datetime   , 
      digval varchar  (255)   , 
      xml text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_systemuser( 
      id  INTEGER    NOT NULL  , 
      eventos_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      enviar_email int   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id),
FOREIGN KEY(eventos_id) REFERENCES eventos(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE forma_pagamento( 
      id  INTEGER    NOT NULL  , 
      codigo_interno int  (11)   NOT NULL  , 
      tipo_documento_id int   NOT NULL  , 
      meio_pagamento_tef_id int   , 
      notafiscal_tpag_id int   , 
      descricao text   NOT NULL  , 
      prazo_pagamento int   , 
      taxa double   , 
      deletado_em datetime   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      criado_por text   , 
      alterado_por text   , 
      utiliza_pdv char  (1)   , 
      obriga_nf_pdv char  (1)   , 
 PRIMARY KEY (id),
FOREIGN KEY(tipo_documento_id) REFERENCES tipo_documento(id),
FOREIGN KEY(meio_pagamento_tef_id) REFERENCES meio_pagamento_tef(id),
FOREIGN KEY(notafiscal_tpag_id) REFERENCES notafiscal_tpag(id)) ; 

CREATE TABLE formapgto_condpgto( 
      id  INTEGER    NOT NULL  , 
      condicao_pagamento_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(condicao_pagamento_id) REFERENCES condicao_pagamento(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id)) ; 

CREATE TABLE fornecedor( 
      id  INTEGER    NOT NULL  , 
      pessoa_tipo_id int   NOT NULL  , 
      fornecedor_classificacao_id int   , 
      nome text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      insc_estadual text   , 
      insc_municipal text   , 
      cpf_cnpj text   , 
      razao_social text   , 
      logradouro text   , 
      cidade_id int   , 
      bairro text   , 
      cep text   , 
      numero text   , 
      complemento text   , 
      fone text   , 
      email text   , 
      site text   , 
      observacoes text   , 
      notafiscal_crt_id int   , 
      deletado_em datetime   , 
      notafiscal_indiedest_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(fornecedor_classificacao_id) REFERENCES fornecedor_classificacao(id),
FOREIGN KEY(pessoa_tipo_id) REFERENCES pessoa_tipo(id),
FOREIGN KEY(cidade_id) REFERENCES cidade(id),
FOREIGN KEY(notafiscal_crt_id) REFERENCES notafiscal_crt(id),
FOREIGN KEY(notafiscal_indiedest_id) REFERENCES notafiscal_indiedest(id)) ; 

CREATE TABLE fornecedor_classificacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      ativo_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(ativo_id) REFERENCES ativo(id)) ; 

CREATE TABLE fornecedor_contato( 
      id  INTEGER    NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      tipo_contato text   , 
      nome text   NOT NULL  , 
      fone text   , 
 PRIMARY KEY (id),
FOREIGN KEY(fornecedor_id) REFERENCES fornecedor(id)) ; 

CREATE TABLE funcionario( 
      id  INTEGER    NOT NULL  , 
      funcionario_cargo_id int   , 
      nome text   NOT NULL  , 
      cpf text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      valor_salario double   , 
      valor_hora double   , 
 PRIMARY KEY (id),
FOREIGN KEY(funcionario_cargo_id) REFERENCES funcionario_cargo(id)) ; 

CREATE TABLE funcionario_cargo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      deletado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil_etapas( 
      id  INTEGER    NOT NULL  , 
      funil_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      numero_etapa int   NOT NULL  , 
      cor_etapa text   , 
      cor_negocio text   , 
      ultima_etapa int   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      permite_edicao char  (1)   , 
      permite_exclusao char  (1)   , 
      kanban char  (1)   , 
      etapa_ganha char  (1)   , 
      etapa_perde char  (1)   , 
 PRIMARY KEY (id),
FOREIGN KEY(funil_id) REFERENCES funil(id),
FOREIGN KEY(ultima_etapa) REFERENCES resposta(id)) ; 

CREATE TABLE indicador_personalizado( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      url_indicador text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores_servicos( 
      id  INTEGER    NOT NULL  , 
      integradores_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(integradores_id) REFERENCES integradores(id)) ; 

CREATE TABLE inutilizar_numero( 
      id  INTEGER    NOT NULL  , 
      created_at datetime   , 
      system_user int   , 
      update_at datetime   , 
      deleted_at datetime   , 
      ninicio varchar  (20)   , 
      nfinal varchar  (20)   , 
      serie varchar  (20)   , 
      system_unit_id int   , 
      system_users_id int   , 
      xml_retorno text   , 
      protocolo varchar  (50)   , 
      xmotivo varchar  (200)   , 
      cstat int   , 
      notafiscal_id int   , 
      xjust varchar  (150)   , 
      tipo int  (1)   NOT NULL    DEFAULT 1, 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id)) ; 

CREATE TABLE mdfe( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      idmdfe varchar  (255)   , 
      chMDF text   , 
      nProt text   , 
      cStat text   , 
      mdfe_tpemit_id int   NOT NULL  , 
      mdfe_tpprop_id int   NOT NULL  , 
      mdfe_tptransp_id int   , 
      mdfe_tpcar_id int   NOT NULL  , 
      nMDF text   NOT NULL  , 
      serie text   , 
      dhEmi datetime   , 
      UFIni int   NOT NULL  , 
      UFFim int   NOT NULL  , 
      dhIniViagem datetime   , 
      indCanalVerde int   NOT NULL  , 
      indCarregaPosterior int   NOT NULL  , 
      infAdFisco text   , 
      infCpl text   , 
      mdfe_respSeg_id int   , 
      seguro_cpfcnpj text   , 
      seguradora_xSeg text   , 
      seguradora_cnpj text   , 
      vCarga double   , 
      mdfe_cunid_id int   NOT NULL  , 
      qCarga double   , 
      mdfe_tpcarga_id int   , 
      prod_xProd text   , 
      prod_cEAN text   , 
      prod_NCM text   , 
      pgto_cpfcnpj text   , 
      pgto_idEstrangeiro text   , 
      pgto_xNome text   , 
      pgto_vContrato double   , 
      pgto_indAltoDesemp text   , 
      mdfe_indpag_id int   , 
      pgto_vAdiant double   , 
      indAntecipaAdiant int   , 
      pgto_codBanco text   , 
      pgto_codAgencia text   , 
      pgto_CNPJIPEF text   , 
      pgto_PIX text   , 
      veic_rntrc text   , 
      mdfe_tpRod_id int   NOT NULL  , 
      veic_estado_id int   NOT NULL  , 
      veic_cint int   , 
      veic_placa text   , 
      veic_renavam text   , 
      veic_tara double   , 
      justificativa_cancelamento text   , 
      mensagem_sefaz text   , 
      status text   , 
      data_hora_envio datetime   , 
      protocolo_cancelamento text   , 
      datahora_cancelamento datetime   , 
      veiculo_id int   NOT NULL  , 
      mdfe_situacao_id int   NOT NULL  , 
      mdfe_tpamb_id int   NOT NULL  , 
      api_documentos_id int   , 
      xml_cancelamento text   , 
      xml text   , 
      cidade_encerramento_id int   , 
      cmunencerramento int   , 
      data_encerramento date   , 
      datahora_encerramento datetime   , 
      protocolo_encerramento text   , 
      xml_encerramento text   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_tpemit_id) REFERENCES mdfe_tpemit(id),
FOREIGN KEY(mdfe_tpprop_id) REFERENCES mdfe_tpprop(id),
FOREIGN KEY(mdfe_tptransp_id) REFERENCES mdfe_tptransp(id),
FOREIGN KEY(mdfe_tpcar_id) REFERENCES mdfe_tpcar(id),
FOREIGN KEY(UFIni) REFERENCES estado(id),
FOREIGN KEY(UFFim) REFERENCES estado(id),
FOREIGN KEY(indCanalVerde) REFERENCES resposta(id),
FOREIGN KEY(indCarregaPosterior) REFERENCES resposta(id),
FOREIGN KEY(mdfe_respSeg_id) REFERENCES mdfe_respSeg(id),
FOREIGN KEY(mdfe_cunid_id) REFERENCES mdfe_cunid(id),
FOREIGN KEY(mdfe_tpcarga_id) REFERENCES mdfe_tpcarga(id),
FOREIGN KEY(mdfe_indpag_id) REFERENCES mdfe_indpag(id),
FOREIGN KEY(indAntecipaAdiant) REFERENCES resposta(id),
FOREIGN KEY(mdfe_tpRod_id) REFERENCES mdfe_tpRod(id),
FOREIGN KEY(veic_estado_id) REFERENCES estado(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(veiculo_id) REFERENCES veiculo(id),
FOREIGN KEY(mdfe_situacao_id) REFERENCES mdfe_situacao(id),
FOREIGN KEY(mdfe_tpamb_id) REFERENCES mdfe_tpamb(id),
FOREIGN KEY(api_documentos_id) REFERENCES api_documentos(id),
FOREIGN KEY(cidade_encerramento_id) REFERENCES cidade(id)) ; 

CREATE TABLE mdfe_componentes( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      mdfe_tpcomp_id int   NOT NULL  , 
      vComp double   , 
      xComp text   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id),
FOREIGN KEY(mdfe_tpcomp_id) REFERENCES mdfe_tpcomp(id)) ; 

CREATE TABLE mdfe_condutor( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      xnome text   NOT NULL  , 
      cpf text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id)) ; 

CREATE TABLE mdfe_ctes( 
      id  INTEGER    NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      chCTe text   , 
      SegCodBarra text   , 
      indReentrega int   NOT NULL  , 
      mdfe_infmundescarga_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(indReentrega) REFERENCES resposta(id),
FOREIGN KEY(mdfe_infmundescarga_id) REFERENCES mdfe_infmundescarga(id)) ; 

CREATE TABLE mdfe_cunid( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_evento( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      status text   , 
      codigo_status text   , 
      motivo_status text   , 
      id_evento text   , 
      numero_sequencial text   , 
      chave text   , 
      protocolo text   , 
      tipo_evento text   , 
      data_recebimento text   , 
      data_evento text   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id)) ; 

CREATE TABLE mdfe_inclusao_dfe( 
      id  INTEGER    NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      mdfe_id int   NOT NULL  , 
      notafiscal_id int   , 
      cidade_carrega_id int   NOT NULL  , 
      cidade_descarga_id int   NOT NULL  , 
      chave text   NOT NULL  , 
      protocolo text   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id),
FOREIGN KEY(cidade_carrega_id) REFERENCES cidade(id),
FOREIGN KEY(cidade_descarga_id) REFERENCES cidade(id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE mdfe_indpag( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmuncarrega( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      cidade_id int   NOT NULL  , 
      cMunCarrega text   NOT NULL  , 
      xMunCarrega text   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id),
FOREIGN KEY(cidade_id) REFERENCES cidade(id)) ; 

CREATE TABLE mdfe_infmundescarga( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      cidade_id int   NOT NULL  , 
      cMunDescarga text   NOT NULL  , 
      xMunDescarga text   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id),
FOREIGN KEY(cidade_id) REFERENCES cidade(id)) ; 

CREATE TABLE mdfe_infpercurso( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      UFPer int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id),
FOREIGN KEY(UFPer) REFERENCES estado(id)) ; 

CREATE TABLE mdfe_lacres( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      nLacre text   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id)) ; 

CREATE TABLE mdfe_logs( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id)) ; 

CREATE TABLE mdfe_mdfes( 
      id  INTEGER    NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      chMDFe text   , 
      indReentrega int   NOT NULL  , 
      mdfe_infmundescarga_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_infmundescarga_id) REFERENCES mdfe_infmundescarga(id),
FOREIGN KEY(indReentrega) REFERENCES resposta(id)) ; 

CREATE TABLE mdfe_nfes( 
      id  INTEGER    NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      chNFe text   , 
      SegCodBarra text   , 
      indReentrega int   NOT NULL  , 
      mdfe_infmundescarga_id int   NOT NULL  , 
      notafiscal_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id),
FOREIGN KEY(mdfe_infmundescarga_id) REFERENCES mdfe_infmundescarga(id),
FOREIGN KEY(indReentrega) REFERENCES resposta(id)) ; 

CREATE TABLE mdfe_parcelas( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      nParcela text   , 
      dVenc date   , 
      vParcela double   , 
      mdfe_tpAntecip_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id),
FOREIGN KEY(mdfe_tpAntecip_id) REFERENCES mdfe_tpAntecip(id)) ; 

CREATE TABLE mdfe_respSeg( 
      id  INTEGER    NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_series( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      mdfe_tpamb_id int   NOT NULL  , 
      serie text   NOT NULL  , 
      sequencial int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(mdfe_tpamb_id) REFERENCES mdfe_tpamb(id)) ; 

CREATE TABLE mdfe_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      cor text   , 
      ordem int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpamb( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      valor text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpAntecip( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcar( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcarga( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcomp( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpemit( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpprop( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpRod( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tptransp( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_xmlaut( 
      id  INTEGER    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      cpfcnpj text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_id) REFERENCES mdfe(id)) ; 

CREATE TABLE meio_pagamento_tef( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE movimentacao_origem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natop_excecao_tributo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao( 
      id  INTEGER    NOT NULL  , 
      natureza_operacao_finalidade_id int   NOT NULL  , 
      cst_icms_id int   , 
      cst_icms_nao_contribuinte_id int   , 
      cst_ipi_id int   , 
      cst_pis_id int   , 
      cst_cofins_id int   , 
      cfop char  (4)   NOT NULL  , 
      descricao text   NOT NULL  , 
      obs_padrao text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      icms_aliquota double   , 
      ipi_aliquota double   , 
      ipi_codigo_enquadramento text   , 
      pis_aliquota double   , 
      pis_base double   , 
      cofins_aliquota double   , 
      consumidor_final_id int   , 
      cofins_base double   , 
      icms_pRedBC double   , 
      icms_pICMS double   , 
      icms_pDif double   , 
      icms_vICMSDeson double   , 
      icms_pMVAST double   , 
      icms_pICMSST double   , 
      icms_pFCP double   , 
      icms_pFCPST double   , 
      icms_pFCPSTRet double   , 
      icms_pST double   , 
      icms_pCredSN date   , 
      icms_pRedBCEfet double   , 
      icms_pICMSEfet double   , 
      notafiscal_item_modbc_id int   , 
      notafiscal_item_modbcst_id int   , 
      notafiscal_item_motDesICMS_id int   , 
      icms_pFCPUFDest double   , 
      icms_pICMSUFDest double   , 
      icms_baseST double   , 
      icms_base double   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_item_modbc_id) REFERENCES notafiscal_item_modbc(id),
FOREIGN KEY(notafiscal_item_modbcst_id) REFERENCES notafiscal_item_modbcst(id),
FOREIGN KEY(notafiscal_item_motDesICMS_id) REFERENCES notafiscal_item_motDesICMS(id),
FOREIGN KEY(natureza_operacao_finalidade_id) REFERENCES natureza_operacao_finalidade(id),
FOREIGN KEY(cst_icms_id) REFERENCES cst_icms(id),
FOREIGN KEY(cst_ipi_id) REFERENCES cst_ipi(id),
FOREIGN KEY(cst_pis_id) REFERENCES cst_pis(id),
FOREIGN KEY(cst_cofins_id) REFERENCES cst_cofins(id),
FOREIGN KEY(consumidor_final_id) REFERENCES resposta(id),
FOREIGN KEY(cst_icms_nao_contribuinte_id) REFERENCES cst_icms(id)) ; 

CREATE TABLE natureza_operacao_estados( 
      id  INTEGER    NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      estado_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(natureza_operacao_excecao_id) REFERENCES natureza_operacao_excecao(id),
FOREIGN KEY(estado_id) REFERENCES estado(id)) ; 

CREATE TABLE natureza_operacao_excecao( 
      id  INTEGER    NOT NULL  , 
      natureza_operacao_id int   NOT NULL  , 
      natop_excecao_tributo_id int   NOT NULL  , 
      cst_pis_id int   , 
      cst_ipi_id int   , 
      cst_icms_id int   , 
      cst_cofins_id int   , 
      cfop char  (4)   , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      icms_aliquota double   , 
      ipi_aliquota double   , 
      ipi_codigo_enquadramento text   , 
      pis_aliquota double   , 
      pis_base double   , 
      cofins_aliquota double   , 
      cofins_base double   , 
      icms_predbc double   , 
      icms_picms double   , 
      icms_pdif double   , 
      icms_vicmsdeson double   , 
      icms_pmvast double   , 
      icms_picmsst double   , 
      icms_pfcp double   , 
      icms_pfcpst double   , 
      icms_pfcpstret double   , 
      icms_pst double   , 
      icms_pcredsn double   , 
      icms_predbcefet double   , 
      icms_picmsefet double   , 
      icms_pfcpufdest double   , 
      icms_picmsufdest double   , 
      icms_base double   , 
      icms_basest double   , 
      notafiscal_item_modbc_id int   , 
      notafiscal_item_modbcst_id int   , 
      notafiscal_item_motDesICMS_id int   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id),
FOREIGN KEY(natop_excecao_tributo_id) REFERENCES natop_excecao_tributo(id),
FOREIGN KEY(natureza_operacao_id) REFERENCES natureza_operacao(id),
FOREIGN KEY(cst_pis_id) REFERENCES cst_pis(id),
FOREIGN KEY(cst_ipi_id) REFERENCES cst_ipi(id),
FOREIGN KEY(cst_icms_id) REFERENCES cst_icms(id),
FOREIGN KEY(cst_cofins_id) REFERENCES cst_cofins(id),
FOREIGN KEY(notafiscal_item_modbc_id) REFERENCES notafiscal_item_modbc(id),
FOREIGN KEY(notafiscal_item_modbcst_id) REFERENCES notafiscal_item_modbcst(id),
FOREIGN KEY(notafiscal_item_motDesICMS_id) REFERENCES notafiscal_item_motDesICMS(id)) ; 

CREATE TABLE natureza_operacao_finalidade( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_ncm( 
      id  INTEGER    NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      ncm text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(natureza_operacao_excecao_id) REFERENCES natureza_operacao_excecao(id)) ; 

CREATE TABLE natureza_operacao_origens( 
      id  INTEGER    NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      notafiscal_item_orig_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(natureza_operacao_excecao_id) REFERENCES natureza_operacao_excecao(id),
FOREIGN KEY(notafiscal_item_orig_id) REFERENCES notafiscal_item_orig(id)) ; 

CREATE TABLE natureza_operacao_produtos( 
      id  INTEGER    NOT NULL  , 
      produto_id int   NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(natureza_operacao_excecao_id) REFERENCES natureza_operacao_excecao(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE negocio( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      negocio_origem_id int   NOT NULL  , 
      funil_id int   , 
      funil_etapas_id int   NOT NULL  , 
      titulo text   NOT NULL  , 
      valor double   , 
      data_abertura date   NOT NULL  , 
      ordem int   NOT NULL  , 
      data_fechamento date   , 
      negocio_motivo_perda_id int   , 
      comentarios_motivo_perda text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      contato_nome text   , 
      contato_fone text   , 
      ativo_id int   NOT NULL  , 
      arquivado int   NOT NULL  , 
      data_fechamento_esperada date   , 
      vendedor_id int   , 
      mes int   , 
      ano int   , 
      orcamento_id int   , 
      cliente_id int   , 
      deletado_em datetime   , 
      contato_email text   , 
 PRIMARY KEY (id),
FOREIGN KEY(negocio_origem_id) REFERENCES negocio_origem(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(negocio_motivo_perda_id) REFERENCES negocio_motivo_perda(id),
FOREIGN KEY(funil_etapas_id) REFERENCES funil_etapas(id),
FOREIGN KEY(ativo_id) REFERENCES ativo(id),
FOREIGN KEY(arquivado) REFERENCES resposta(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(orcamento_id) REFERENCES orcamento(id),
FOREIGN KEY(funil_id) REFERENCES funil(id)) ; 

CREATE TABLE negocio_arquivos( 
      id  INTEGER    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      deletado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(negocio_id) REFERENCES negocio(id)) ; 

CREATE TABLE negocio_atividade( 
      id  INTEGER    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      negocio_tipo_atividade_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      horario_inicial datetime   , 
      horario_final datetime   , 
      observacao text   , 
 PRIMARY KEY (id),
FOREIGN KEY(negocio_id) REFERENCES negocio(id),
FOREIGN KEY(negocio_tipo_atividade_id) REFERENCES negocio_tipo_atividade(id)) ; 

CREATE TABLE negocio_etapas_historico( 
      id  INTEGER    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      funil_etapas_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(negocio_id) REFERENCES negocio(id),
FOREIGN KEY(funil_etapas_id) REFERENCES funil_etapas(id)) ; 

CREATE TABLE negocio_itens( 
      id  INTEGER    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      valor_unitario double   NOT NULL  , 
      quantidade double   NOT NULL  , 
      valor_total double   NOT NULL  , 
      desconto double   , 
 PRIMARY KEY (id),
FOREIGN KEY(negocio_id) REFERENCES negocio(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE negocio_motivo_perda( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      deletado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_notas( 
      id  INTEGER    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      nota text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      deletado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(negocio_id) REFERENCES negocio(id)) ; 

CREATE TABLE negocio_origem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      deletado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_tipo_atividade( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      icone text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   , 
      venda_id int   , 
      numero text   NOT NULL  , 
      data_emissao datetime   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      texto_rodape text   , 
      data_saida datetime   , 
      icms_basecalc double   , 
      icms_valor double   , 
      icms_subst_base_calc int   , 
      icms_subst_valor double   , 
      frete_valor double   , 
      seguro_valor double   , 
      outras_despesas double   , 
      ipi_valor double   , 
      serie text   , 
      valor_total_produtos double   , 
      valor_total_nota double   , 
      transp_nome text   , 
      transp_cnpj text   , 
      transp_inscest text   , 
      transp_endereco text   , 
      transp_cidade text   , 
      transp_placaveiculo text   , 
      transp_uf text   , 
      transp_veiculouf text   , 
      transp_veiculoRNTC text   , 
      transp_numeracao text   , 
      nf_tipodocumento_id int   NOT NULL  , 
      notafiscal_situacao_id int   NOT NULL  , 
      notafiscal_crt_id int   NOT NULL  , 
      cliente_endereco text   , 
      cliente_complemento text   , 
      cliente_numero text   , 
      cliente_bairro text   , 
      cliente_cidade text   , 
      cliente_cep text   , 
      cliente_estado text   , 
      cliente_nome text   , 
      cliente_cpfcnpj text   , 
      cliente_inscest text   , 
      cliente_inscmuni text   , 
      cliente_fone text   , 
      cliente_cidade_codibge int   , 
      cliente_suframa text   , 
      justificativa_cancelamento text   , 
      chave text   , 
      protocolo_envio text   , 
      notafiscal_indiedest_id int   NOT NULL  , 
      protocolo_cancelamento text   , 
      datahora_cancelamento datetime   , 
      cce_datahora_evento datetime   , 
      cce_sequencial int   , 
      cce_correcao text   , 
      cce_protocolo text   , 
      infadfisco text   , 
      desconto_valor double   , 
      pis_valor double   , 
      cofins_valor double   , 
      fatura_numero text   , 
      fatura_valor_original double   , 
      fatura_valor_desconto double   , 
      fatura_valor_liquido double   , 
      notafiscal_iddest_id int   NOT NULL  , 
      notafiscal_tpimp_id int   NOT NULL  , 
      notafiscal_tpemis_id int   NOT NULL  , 
      notafiscal_finnfe_id int   NOT NULL  , 
      notafiscal_indfinal_id int   NOT NULL  , 
      notafiscal_indpres_id int   NOT NULL  , 
      verproc text   , 
      notafiscal_indpag_id int   NOT NULL  , 
      retirada_marcado int   , 
      retirada_cpfcnpj text   , 
      retirada_xlgr text   , 
      retirada_nro text   , 
      retirada_xcpl text   , 
      retirada_xbairro text   , 
      retirada_cmun int   , 
      retirada_xmun text   , 
      retirada_uf text   , 
      entrega_marcado int   , 
      entrega_cpfcnpj text   , 
      entrega_xlgr text   , 
      entrega_nro text   , 
      entrega_xcpl text   , 
      entrega_xbairro text   , 
      entrega_cmun int   , 
      entrega_xmun text   , 
      entrega_uf text   , 
      vicmsufdest double   , 
      vicmsufremet double   , 
      vfcpufdest double   , 
      notafiscal_modelo_id int   NOT NULL  , 
      dispositivos_id int   , 
      xml text   , 
      data_hora_envio datetime   , 
      xml_cancelamento text   , 
      issqn_vserv double   , 
      issqn_vbc double   , 
      issqn_viss double   , 
      issqn_dcompet date   , 
      issqn_reftrib text   , 
      icms_vfcp double   , 
      icms_vfcpst double   , 
      icms_vfcpstret double   , 
      layout_versao text   , 
      ipi_vipidevol double   , 
      vtroco double   , 
      notafiscal_tpamb_id int   NOT NULL  , 
      notafiscal_mod_id int   NOT NULL  , 
      infcpl text   , 
      notafiscal_modfrete_id int   NOT NULL  , 
      status text   , 
      mensagem text   , 
      cce_xml text   , 
      cce_pdf text   , 
      codigo_sefaz int   , 
      sn_carta_correcao char  (1)   NOT NULL    DEFAULT 'N', 
      deletado_em datetime   , 
      contingencia_data datetime   , 
      contingencia_motivo text   , 
      exporta_ufsaidapais text   , 
      exporta_xlocexporta text   , 
      exporta_xlocdespacho text   , 
      cliente_cpais text   , 
      cliente_xpais text   , 
      natureza_operacao_id int   , 
      movimentacao_origem_id int   , 
      inutilizar int   , 
      xml_inicial text   , 
      entrega_cuf int  (2)   , 
      xml_assinado text   , 
      protolo_xml text   , 
      xml_autorizado text   , 
      cep_entrega varchar  (15)   , 
      cep_retirada varchar  (15)   , 
      entrega_xnome varchar  (200)   , 
      xml_carta text   , 
      protocolo_carta_resposta varchar  (200)   , 
      descricao text   , 
      xevento text   , 
      xmotivo text   , 
      cstat int   , 
      dhregevento varchar  (50)   , 
      nseqevento int  (11)   , 
      nprot varchar  (100)   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(notafiscal_tpamb_id) REFERENCES notafiscal_tpamb(id),
FOREIGN KEY(notafiscal_modfrete_id) REFERENCES notafiscal_modfrete(id),
FOREIGN KEY(notafiscal_mod_id) REFERENCES notafiscal_mod(id),
FOREIGN KEY(venda_id) REFERENCES venda(id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(nf_tipodocumento_id) REFERENCES notafiscal_tipodocumento(id),
FOREIGN KEY(notafiscal_situacao_id) REFERENCES notafiscal_situacao(id),
FOREIGN KEY(notafiscal_indiedest_id) REFERENCES notafiscal_indiedest(id),
FOREIGN KEY(notafiscal_iddest_id) REFERENCES notafiscal_iddest(id),
FOREIGN KEY(notafiscal_tpimp_id) REFERENCES notafiscal_tpimp(id),
FOREIGN KEY(notafiscal_tpemis_id) REFERENCES notafiscal_tpemis(id),
FOREIGN KEY(notafiscal_finnfe_id) REFERENCES notafiscal_finnfe(id),
FOREIGN KEY(notafiscal_indfinal_id) REFERENCES notafiscal_indfinal(id),
FOREIGN KEY(notafiscal_indpres_id) REFERENCES notafiscal_indpres(id),
FOREIGN KEY(notafiscal_indpag_id) REFERENCES notafiscal_indpag(id),
FOREIGN KEY(dispositivos_id) REFERENCES dispositivos(id),
FOREIGN KEY(notafiscal_crt_id) REFERENCES notafiscal_crt(id),
FOREIGN KEY(movimentacao_origem_id) REFERENCES movimentacao_origem(id),
FOREIGN KEY(natureza_operacao_id) REFERENCES natureza_operacao(id)) ; 

CREATE TABLE notafiscal_autxml( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      cpf_cnpj text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   NOT NULL  , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE nota_fiscal_compra( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      fornecedor_id int   , 
      numero text   NOT NULL  , 
      data_emissao datetime   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      natop text   , 
      data_saida datetime   , 
      infcpl text   , 
      infadfisco text   , 
      icms_basecalc double   , 
      icms_valor double   , 
      icms_subst_base_calc double   , 
      icms_subst_valor double   , 
      frete_valor double   , 
      seguro_valor double   , 
      outras_despesas double   , 
      ipi_valor double   , 
      serie text   , 
      valor_total_produtos double   , 
      valor_total_nota double   , 
      transp_nome text   , 
      transp_cnpj text   , 
      transp_inscest text   , 
      transp_endereco text   , 
      transp_cidade text   , 
      transp_placaveiculo text   , 
      transp_uf text   , 
      transp_veiculouf text   , 
      transp_veiculorntc text   , 
      transp_numeracao text   , 
      notafiscal_tipodocumento_id int   NOT NULL  , 
      nota_fiscal_compra_situacao_id int   NOT NULL  , 
      notafiscal_crt_id int   , 
      obs_importacao_xml text   , 
      cliente_endereco text   , 
      cliente_complemento text   , 
      cliente_numero text   , 
      cliente_bairro text   , 
      cliente_cidade text   , 
      cliente_cep text   , 
      cliente_estado text   , 
      cliente_nome text   , 
      cliente_cpfcnpj text   , 
      cliente_inscest text   , 
      cliente_fone text   , 
      cliente_cidade_codibge text   , 
      cliente_inscmuni text   , 
      cliente_suframa text   , 
      justificativa_cancelamento text   , 
      chave text   , 
      protocolo_envio text   , 
      notafiscal_indiedest_id int   , 
      protocolo_cancelamento text   , 
      datahora_cancelamento text   , 
      cce_datahora_evento text   , 
      cce_sequencial text   , 
      cce_correcao text   , 
      cce_protocolo text   , 
      desconto_valor double   , 
      pis_valor double   , 
      cofins_valor double   , 
      fatura_numero text   , 
      fatura_valor_original text   , 
      fatura_valor_desconto double   , 
      fatura_valor_liquido double   , 
      notafiscal_iddest_id int   NOT NULL  , 
      notafiscal_tpimp_id int   , 
      notafiscal_finnfe_id int   NOT NULL  , 
      notafiscal_indfinal_id int   NOT NULL  , 
      notafiscal_indpres_id int   NOT NULL  , 
      verproc text   , 
      notafiscal_indpag_id int   , 
      retirada_marcado int   , 
      retirada_cpfcnpj text   , 
      retirada_xlgr text   , 
      retirada_nro text   , 
      retirada_xcpl text   , 
      retirada_xbairro text   , 
      retirada_cmun int   , 
      retirada_xmun text   , 
      retirada_uf text   , 
      entrega_marcado int   , 
      entrega_cpfcnpj text   , 
      entrega_xlgr text   , 
      entrega_nro text   , 
      entrega_xcpl text   , 
      entrega_xbairro text   , 
      entrega_cmun text   , 
      entrega_xmun text   , 
      entrega_uf text   , 
      vicmsufdest double   , 
      vicmsufremet double   , 
      vfcpufdest text   , 
      notafiscal_mod_id int   NOT NULL  , 
      xml text   , 
      data_hora_envio datetime   , 
      xml_cancelamento text   , 
      issqn_vserv double   , 
      issqn_vbc double   , 
      issqn_viss double   , 
      issqn_dcompet date   , 
      issqn_reftrib text   , 
      icms_vfcp double   , 
      icms_vfcpst double   , 
      icms_vfcpstret double   , 
      layout_versao text   , 
      ipi_vipidevol double   , 
      vtroco date   , 
      notafiscal_modfrete_id int   , 
      cpag_lancada text   NOT NULL  , 
      dest_cnpj text   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(fornecedor_id) REFERENCES fornecedor(id),
FOREIGN KEY(notafiscal_tipodocumento_id) REFERENCES notafiscal_tipodocumento(id),
FOREIGN KEY(nota_fiscal_compra_situacao_id) REFERENCES nota_fiscal_compra_situacao(id),
FOREIGN KEY(notafiscal_crt_id) REFERENCES notafiscal_crt(id),
FOREIGN KEY(notafiscal_indiedest_id) REFERENCES notafiscal_indiedest(id),
FOREIGN KEY(notafiscal_iddest_id) REFERENCES notafiscal_iddest(id),
FOREIGN KEY(notafiscal_tpimp_id) REFERENCES notafiscal_tpimp(id),
FOREIGN KEY(notafiscal_finnfe_id) REFERENCES notafiscal_finnfe(id),
FOREIGN KEY(notafiscal_indfinal_id) REFERENCES notafiscal_indfinal(id),
FOREIGN KEY(notafiscal_indpres_id) REFERENCES notafiscal_indpres(id),
FOREIGN KEY(notafiscal_indpag_id) REFERENCES notafiscal_indpag(id),
FOREIGN KEY(notafiscal_mod_id) REFERENCES notafiscal_mod(id),
FOREIGN KEY(notafiscal_modfrete_id) REFERENCES notafiscal_modfrete(id)) ; 

CREATE TABLE nota_fiscal_compra_dup( 
      id  INTEGER    NOT NULL  , 
      nota_fiscal_compra_id int   NOT NULL  , 
      forma_pagamento_id int   , 
      plano_conta_id int   , 
      centro_custo_id int   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      ndup text   , 
      vdup double   , 
      dvenc date   , 
      parcela text   , 
 PRIMARY KEY (id),
FOREIGN KEY(nota_fiscal_compra_id) REFERENCES nota_fiscal_compra(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id),
FOREIGN KEY(plano_conta_id) REFERENCES plano_conta(id),
FOREIGN KEY(centro_custo_id) REFERENCES centro_custo(id)) ; 

CREATE TABLE nota_fiscal_compra_itens( 
      id  INTEGER    NOT NULL  , 
      nota_fiscal_compra_id int   NOT NULL  , 
      produto_id int   , 
      nota_fiscal_compra_itens_situacao_id int   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      nitem int   , 
      cean text   , 
      xprod text   , 
      ncm text   , 
      nve text   , 
      extipi text   , 
      cfop text   , 
      ucom text   , 
      qcom double   , 
      vuncom double   , 
      vprod double   , 
      ceantrib text   , 
      utrib text   , 
      qtrib double   , 
      vuntrib double   , 
      vfrete double   , 
      vseg double   , 
      vdesc double   , 
      vtottrib double   , 
      xped text   , 
      nitemped int   , 
      notafiscal_item_indtot_id int   , 
      notafiscal_item_orig_id int   NOT NULL  , 
      notafiscal_item_modbc_id int   , 
      icms_basecalc double   , 
      icms_cst text   , 
      icms_valor double   , 
      icms_aliquota double   , 
      icms_pcredsn double   , 
      icms_vcredicmssn double   , 
      icms_predbc double   , 
      icms_pst double   , 
      icms_pmvast double   , 
      icms_predbcst double   , 
      icms_vbcst double   , 
      icms_picmsst double   , 
      icms_vicmsst double   , 
      fcp_pfcp double   , 
      pis_cst text   , 
      pis_valor double   , 
      pis_aliquota double   , 
      pis_valor_base double   , 
      cofins_cst text   , 
      cofins_valor_base double   , 
      cofins_aliquota double   , 
      cofins_valor double   , 
      voutro double   , 
      infadprod text   , 
      notafiscal_item_motDesICMS_id int   , 
      cprod text   , 
      ipi_cst text   , 
      ipi_valor_base double   , 
      ipi_aliquota double   , 
      ipi_vipidevol double   , 
      ipi_valor double   , 
      ipi_pdevol double   , 
      estoque_deposito_id int   , 
      produto_lote_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(nota_fiscal_compra_itens_situacao_id) REFERENCES nota_fiscal_compra_itens_situacao(id),
FOREIGN KEY(nota_fiscal_compra_id) REFERENCES nota_fiscal_compra(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(notafiscal_item_indtot_id) REFERENCES notafiscal_item_indtot(id),
FOREIGN KEY(notafiscal_item_orig_id) REFERENCES notafiscal_item_orig(id),
FOREIGN KEY(notafiscal_item_modbc_id) REFERENCES notafiscal_item_modbc(id),
FOREIGN KEY(notafiscal_item_motDesICMS_id) REFERENCES notafiscal_item_motDesICMS(id),
FOREIGN KEY(estoque_deposito_id) REFERENCES estoque_deposito(id),
FOREIGN KEY(produto_lote_id) REFERENCES produto_lote(id)) ; 

CREATE TABLE nota_fiscal_compra_itens_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_pag( 
      id  INTEGER    NOT NULL  , 
      nota_fiscal_compra_id int   NOT NULL  , 
      notafiscal_tpag_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      tpag text   , 
      vpag double   , 
      xpag text   , 
 PRIMARY KEY (id),
FOREIGN KEY(nota_fiscal_compra_id) REFERENCES nota_fiscal_compra(id),
FOREIGN KEY(notafiscal_tpag_id) REFERENCES notafiscal_tpag(id)) ; 

CREATE TABLE nota_fiscal_compra_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      cor text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_cprod_padrao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_crt( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor int   , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_dup( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      ndup text   , 
      vdup double   , 
      dvenc date   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE notafiscal_finnfe( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_frete_volumes( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      qVol int   , 
      nVol text   , 
      esp text   , 
      marca text   , 
      pesol double   , 
      pesob double   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE notafiscal_iddest( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indfinal( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indiedest( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpag( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpres( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_indtot( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbc( 
      id  INTEGER    NOT NULL  , 
      codigo int   , 
      descricao text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbcst( 
      id  INTEGER    NOT NULL  , 
      codigo int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_motDesICMS( 
      id  INTEGER    NOT NULL  , 
      codigo text   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_orig( 
      id  INTEGER    NOT NULL  , 
      codigo int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_itens( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      nitem int   , 
      cean varchar  (50)   , 
      xprod text   NOT NULL  , 
      ncm text   , 
      nve text   , 
      extipi text   , 
      cfop text   , 
      ucom text   , 
      qcom double   NOT NULL  , 
      vuncom double  (13,2)   NOT NULL  , 
      vprod double   , 
      ceantrib text   , 
      utrib text   , 
      qtrib double  (13,2)   , 
      vuntrib double  (13,2)   , 
      vfrete double  (13,2)   , 
      vseg double  (13,2)   , 
      vdesc double  (13,2)   , 
      vtottrib double  (10,2)   , 
      xped text   , 
      nitemped int   , 
      notafiscal_item_indtot_id int   , 
      notafiscal_item_orig_id int   NOT NULL  , 
      notafiscal_item_modbc_id int   , 
      icms_basecalc double   , 
      icms_cst varchar  (20)   , 
      icms_valor double   , 
      icms_aliquota double   , 
      icms_pcredsn double  (10,2)   , 
      icms_vcredicmssn double   , 
      icms_predbc double   , 
      icms_pst double   , 
      icms_pmvast double   , 
      icms_predbcst double   , 
      icms_vbcst double   , 
      icms_picmsst double   , 
      icms_vicmsst double   , 
      alterado_em datetime   , 
      criado_em datetime   , 
      pis_cst varchar  (20)   , 
      pis_valor double   , 
      pis_aliquota double   , 
      pis_valor_base double   , 
      cofins_cst varchar  (20)   , 
      cofins_valor_base double   , 
      cofins_aliquota double   , 
      cofins_valor double   , 
      voutro double   , 
      infadprod text   , 
      notafiscal_item_motDesICMS_id int   , 
      cprod text   , 
      ipi_cst varchar  (255)   , 
      ipi_valor_base double   , 
      ipi_aliquota double   , 
      ipi_vipidevol double   , 
      ipi_valor double   , 
      ipi_pdevol double   , 
      cest text   , 
      fcp_pfcp double   , 
      fcp_vfcp double   , 
      fcp_vbcfcp double   , 
      fcp_vbcfcpst double   , 
      fcp_pfcpst double   , 
      fcp_vfcpst double   , 
      fcp_vbcfcpstret double   , 
      fcp_pfcpstret double   , 
      fcp_vfcpstret double   , 
      icms_vbcufdest double   , 
      icms_vbcfcpufdest double   , 
      icms_pfcpufdest double   , 
      icms_vfcpufdest double   , 
      icms_picmsinter double   , 
      icms_picmsinterpart double   , 
      icms_vicmsufdest double   , 
      icms_vicmsufremet double   , 
      icms_picmsufdest double   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_item_motDesICMS_id) REFERENCES notafiscal_item_motDesICMS(id),
FOREIGN KEY(notafiscal_item_orig_id) REFERENCES notafiscal_item_orig(id),
FOREIGN KEY(notafiscal_item_modbc_id) REFERENCES notafiscal_item_modbc(id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(notafiscal_item_indtot_id) REFERENCES notafiscal_item_indtot(id)) ; 

CREATE TABLE notafiscal_logs( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE notafiscal_mod( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      modelo text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_modfrete( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_pag( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      notafiscal_tpag_id int   NOT NULL  , 
      tpag text   , 
      vpag double   , 
      xpag text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id),
FOREIGN KEY(notafiscal_tpag_id) REFERENCES notafiscal_tpag(id)) ; 

CREATE TABLE notafiscal_refecf( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      notafiscal_refecfmod_id int   NOT NULL  , 
      necf text   , 
      ncoo text   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_refecfmod_id) REFERENCES notafiscal_refecfmod(id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE notafiscal_refecfmod( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refnfe( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      refnfe text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE notafiscal_series( 
      id  INTEGER    NOT NULL  , 
      serie text   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      notafiscal_tpamb_id int   NOT NULL  , 
      notafiscal_mod_id int   NOT NULL  , 
      sequencial int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      notafiscal_tipodocumento_id int   NOT NULL  , 
      deletado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_tipodocumento_id) REFERENCES notafiscal_tipodocumento(id),
FOREIGN KEY(notafiscal_tpamb_id) REFERENCES notafiscal_tpamb(id),
FOREIGN KEY(notafiscal_mod_id) REFERENCES notafiscal_mod(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE notafiscal_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      ordem int   , 
      exibir text   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao_sefaz( 
      id  INTEGER    NOT NULL  , 
      notafiscal_situacao_id int   NOT NULL  , 
      codigo_sefaz int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_situacao_id) REFERENCES notafiscal_situacao(id)) ; 

CREATE TABLE notafiscal_tipodoc_series( 
      id  INTEGER    NOT NULL  , 
      notafiscal_series_id int   NOT NULL  , 
      notafiscal_tipodocumento_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_series_id) REFERENCES notafiscal_series(id),
FOREIGN KEY(notafiscal_tipodocumento_id) REFERENCES notafiscal_tipodocumento(id)) ; 

CREATE TABLE notafiscal_tipodocumento( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpag( 
      id  INTEGER    NOT NULL  , 
      tpag text   NOT NULL  , 
      criado_em datetime   , 
      descricao text   NOT NULL  , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpamb( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpemis( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpimp( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      orcamento_situacao_id int   NOT NULL  , 
      vendedor_id int   , 
      cliente_id int   , 
      cliente_contato_id int   , 
      data_orcamento date   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      observacao text   , 
      valor_produtos double   NOT NULL  , 
      desconto double   , 
      peso_total double   , 
      frete_total double   , 
      valor_total double   NOT NULL  , 
      tabela_preco_id int   , 
      justificativa_reprovacao text   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(orcamento_situacao_id) REFERENCES orcamento_situacao(id),
FOREIGN KEY(cliente_contato_id) REFERENCES cliente_contato(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(tabela_preco_id) REFERENCES tabela_preco(id)) ; 

CREATE TABLE orcamento_interacoes( 
      id  INTEGER    NOT NULL  , 
      orcamento_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(orcamento_id) REFERENCES orcamento(id)) ; 

CREATE TABLE orcamento_item( 
      id  INTEGER    NOT NULL  , 
      orcamento_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade double   NOT NULL  , 
      valor_unitario double   NOT NULL  , 
      valor_total double   NOT NULL  , 
      valor_original double   NOT NULL  , 
      valor_custo double   , 
      desconto double   , 
      informacoes_adicionais text   , 
      numero_pedido text   , 
      numero_item_pedido text   , 
      valor_frete double   , 
      peso_unitario double   , 
      peso_total double   , 
 PRIMARY KEY (id),
FOREIGN KEY(orcamento_id) REFERENCES orcamento(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE orcamento_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      ordem int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao_historico( 
      id  INTEGER    NOT NULL  , 
      orcamento_situacao_id int   NOT NULL  , 
      orcamento_id int   NOT NULL  , 
      descricao text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(orcamento_situacao_id) REFERENCES orcamento_situacao(id),
FOREIGN KEY(orcamento_id) REFERENCES orcamento(id)) ; 

CREATE TABLE ordem_producao( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      ordem_producao_situacao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade double   NOT NULL  , 
      data_producao date   NOT NULL  , 
      observacoes text   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_producao_situacao_id) REFERENCES ordem_producao_situacao(id),
FOREIGN KEY(produto_ficha_tecnica_id) REFERENCES produto_ficha_tecnica(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(estoque_deposito_id) REFERENCES estoque_deposito(id)) ; 

CREATE TABLE ordem_producao_etapas( 
      id  INTEGER    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      ordem_producao_etapas_situacao_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      ordem int   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_producao_etapas_situacao_id) REFERENCES ordem_producao_etapas_situacao(id),
FOREIGN KEY(ordem_producao_id) REFERENCES ordem_producao(id)) ; 

CREATE TABLE ordem_producao_etapas_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_itens( 
      id  INTEGER    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade double   NOT NULL  , 
      quantidade_total double   NOT NULL  , 
      custo double   , 
      custo_total double   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(ordem_producao_id) REFERENCES ordem_producao(id),
FOREIGN KEY(estoque_deposito_id) REFERENCES estoque_deposito(id)) ; 

CREATE TABLE ordem_producao_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao_historico( 
      id  INTEGER    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      ordem_producao_situacao_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_producao_situacao_id) REFERENCES ordem_producao_situacao(id),
FOREIGN KEY(ordem_producao_id) REFERENCES ordem_producao(id)) ; 

CREATE TABLE ordem_producao_vendas( 
      id  INTEGER    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_producao_id) REFERENCES ordem_producao(id),
FOREIGN KEY(venda_id) REFERENCES venda(id)) ; 

CREATE TABLE ordem_servico( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      cliente_contato_id int   , 
      vendedor_id int   , 
      ordem_servico_situacao_id int   NOT NULL  , 
      ordem_servico_producao_etapa_id int   , 
      condicao_pagamento_id int   , 
      cliente_endereco_id int   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      numero_os int   , 
      numero_orcamento int   , 
      data_emissao date   NOT NULL  , 
      valor double   NOT NULL  , 
      desconto double   , 
      prazo_entrega date   , 
      validade_dias int   , 
      data_abertura_os date   , 
      vendedor_comissao double   , 
      vendedor_comissao_avista double   , 
      vendedor_comissao_aprazo double   , 
      observacoes text   , 
      prazo_garantia date   , 
      valor_pago double   , 
      motivo_nao_aprovacao_orcamento text   , 
      valor_avista double   , 
      valor_aprazo double   , 
      valor_faturado_vendas double   , 
      usuario_aprovacao_id int   , 
      informacoes_transporte text   , 
 PRIMARY KEY (id),
FOREIGN KEY(cliente_contato_id) REFERENCES cliente_contato(id),
FOREIGN KEY(ordem_servico_producao_etapa_id) REFERENCES ordem_servico_producao_etapa(id),
FOREIGN KEY(usuario_aprovacao_id) REFERENCES system_users(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(ordem_servico_situacao_id) REFERENCES ordem_servico_situacao(id),
FOREIGN KEY(condicao_pagamento_id) REFERENCES condicao_pagamento(id),
FOREIGN KEY(cliente_endereco_id) REFERENCES cliente_endereco(id)) ; 

CREATE TABLE ordem_servico_garantia_historico( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      observacoes text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_id) REFERENCES ordem_servico(id)) ; 

CREATE TABLE ordem_servico_historico( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_situacao_id int   NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_id) REFERENCES ordem_servico(id),
FOREIGN KEY(ordem_servico_situacao_id) REFERENCES ordem_servico_situacao(id)) ; 

CREATE TABLE ordem_servico_item( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      descricao_servico text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade double   NOT NULL  , 
      quantidade_atendida double   , 
      valor_unitario double   NOT NULL  , 
      valor_total double   NOT NULL  , 
      desconto double   , 
      arquivo text   , 
      largura double   , 
      altura double   , 
      quantidade_a_faturar double   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_id) REFERENCES ordem_servico(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE ordem_servico_item_despesas( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      despesas_servicos_id int   NOT NULL  , 
      despesas_servicos_tipo_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      valor_unitario double   NOT NULL  , 
      quantidade double   NOT NULL  , 
      valor_total double   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(despesas_servicos_id) REFERENCES despesas_servicos(id),
FOREIGN KEY(despesas_servicos_tipo_id) REFERENCES despesas_servicos_tipo(id),
FOREIGN KEY(ordem_servico_item_id) REFERENCES ordem_servico_item(id)) ; 

CREATE TABLE ordem_servico_item_ficha_tecnica( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      quantidade_fixa_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade double   NOT NULL  , 
      custo double   , 
      valor_unitario double   , 
      valor_total double   , 
      quantidade_original double   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_item_id) REFERENCES ordem_servico_item(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(quantidade_fixa_id) REFERENCES resposta(id)) ; 

CREATE TABLE ordem_servico_item_mao_obra( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      funcionario_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade_horas double   , 
      valor_hora double   , 
      valor_total double   , 
      quantidade_horas_original double   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_item_id) REFERENCES ordem_servico_item(id),
FOREIGN KEY(funcionario_id) REFERENCES funcionario(id)) ; 

CREATE TABLE ordem_servico_item_obs_etapas( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      ordem_servico_producao_etapa_id int   NOT NULL  , 
      observacao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_item_id) REFERENCES ordem_servico_item(id),
FOREIGN KEY(ordem_servico_producao_etapa_id) REFERENCES ordem_servico_producao_etapa(id)) ; 

CREATE TABLE ordem_servico_producao_etapa( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_venda( 
      id  INTEGER    NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_id) REFERENCES ordem_servico(id),
FOREIGN KEY(venda_id) REFERENCES venda(id)) ; 

CREATE TABLE painel_indicadores( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicador_usuario( 
      id  INTEGER    NOT NULL  , 
      painel_indicadores_id int   NOT NULL  , 
      indicador_personalizado_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(painel_indicadores_id) REFERENCES painel_indicadores(id),
FOREIGN KEY(indicador_personalizado_id) REFERENCES indicador_personalizado(id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id)) ; 

CREATE TABLE pais( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      codigo_pais text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE parceiro( 
      id  INTEGER    NOT NULL  , 
      certificado_venda_modalidade_id int   NOT NULL  , 
      tabela_preco_id int   , 
      vendedor_id int   , 
      cpf_cnpj text   NOT NULL  , 
      nome text   NOT NULL  , 
      razao_social text   , 
      cep text   , 
      logradouro text   , 
      bairro text   , 
      cidade text   , 
      estado text   , 
      fone text   , 
      email text   , 
      contato text   , 
      contato_fone text   , 
      comissao_percentual double   , 
      deletado_em datetime   , 
      criado_em datetime   NOT NULL  , 
      alterado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      banco_id int   , 
      banco_agencia text   , 
      banco_conta text   , 
      banco_chavepix text   , 
      banco_nome_titular text   , 
      banco_cpfcnpj text   , 
      chave_pix_tipo_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(tabela_preco_id) REFERENCES tabela_preco(id),
FOREIGN KEY(certificado_venda_modalidade_id) REFERENCES certificado_venda_modalidade(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(banco_id) REFERENCES banco(id),
FOREIGN KEY(chave_pix_tipo_id) REFERENCES chave_pix_tipo(id)) ; 

CREATE TABLE pdv_permissoes( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pedido_evento( 
      id  INTEGER    NOT NULL  , 
      notafiscal_id int   , 
      system_unit_id int   , 
      system_users_id int   , 
      chave varchar  (50)   , 
      descricao text   , 
      tipo varchar  (30)   , 
      numero varchar  (10)   , 
      serie int   , 
      nseqevento int   , 
      protocolo varchar  (20)   , 
      status int     DEFAULT 1, 
      protocolo_resposta varchar  (50)   , 
      xevento text   , 
      created_at datetime   , 
      update_at datetime   , 
      deleted_at datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(notafiscal_id) REFERENCES notafiscal(id)) ; 

CREATE TABLE pessoa_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      plano_conta_tipo_id int   NOT NULL  , 
      plano_conta_origem_id int   NOT NULL  , 
      plano_conta_pai_id int   , 
      numero text   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(plano_conta_tipo_id) REFERENCES plano_conta_tipo(id),
FOREIGN KEY(plano_conta_origem_id) REFERENCES plano_conta_origem(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE plano_conta_origem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto( 
      id  INTEGER    NOT NULL  , 
      produto_grupo_id int   NOT NULL  , 
      unidade_medida_id int   NOT NULL  , 
      tipo_recurso_id int   NOT NULL  , 
      produto_fabricante_id int   , 
      produtogrupo_subgrupo_id int   , 
      notafiscal_item_orig_id int   , 
      nome text   NOT NULL  , 
      nome_curto text   , 
      codigo_EAN text   , 
      imagem text   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      ncm text   , 
      cest text   , 
      criado_por text   , 
      alterado_por text   , 
      obs text   , 
      referencia text   , 
      deletado_em datetime   , 
      especificacao text   , 
      link_site text   , 
      peso_liquido double   , 
      peso_bruto double   , 
      habilitado_id int   , 
      produto_tipo_id int   , 
      codigo_sku text   , 
      largura double   , 
      altura double   , 
      comprimento double   , 
      diametro double   , 
      dias_preparacao double   , 
      marca text   , 
      garantia text   , 
      unidade_caixa double   , 
      produto_embalagem_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_grupo_id) REFERENCES produto_grupo(id),
FOREIGN KEY(unidade_medida_id) REFERENCES unidade_medida(id),
FOREIGN KEY(tipo_recurso_id) REFERENCES tipo_recurso(id),
FOREIGN KEY(produto_fabricante_id) REFERENCES produto_fabricante(id),
FOREIGN KEY(produtogrupo_subgrupo_id) REFERENCES produtogrupo_subgrupo(id),
FOREIGN KEY(notafiscal_item_orig_id) REFERENCES notafiscal_item_orig(id),
FOREIGN KEY(habilitado_id) REFERENCES resposta(id),
FOREIGN KEY(produto_tipo_id) REFERENCES produto_tipo(id),
FOREIGN KEY(produto_embalagem_id) REFERENCES produto_embalagem(id)) ; 

CREATE TABLE produto_embalagem( 
      id  INTEGER    NOT NULL  , 
      produto_tipo_embalagem_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      peso double   , 
      dimensoes text   NOT NULL  , 
      altura double   , 
      largura double   , 
      comprimento double   , 
      diametro double   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_tipo_embalagem_id) REFERENCES produto_tipo_embalagem(id)) ; 

CREATE TABLE produto_enderecamento( 
      id  INTEGER    NOT NULL  , 
      produto_filial_id int   NOT NULL  , 
      estoque_prateleira_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(estoque_prateleira_id) REFERENCES estoque_prateleira(id),
FOREIGN KEY(produto_filial_id) REFERENCES produto_filial(id)) ; 

CREATE TABLE produto_etiqueta_configuracoes( 
      id  INTEGER    NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fabricante( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      deletado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      custo_total double   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE produto_ficha_tecnica_despesas( 
      id  INTEGER    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      despesas_servicos_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      valor_unitario double   NOT NULL  , 
      quantidade double   NOT NULL  , 
      valor_total double   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_ficha_tecnica_id) REFERENCES produto_ficha_tecnica(id),
FOREIGN KEY(despesas_servicos_id) REFERENCES despesas_servicos(id)) ; 

CREATE TABLE produto_ficha_tecnica_etapas_producao( 
      id  INTEGER    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      ordem int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_ficha_tecnica_id) REFERENCES produto_ficha_tecnica(id)) ; 

CREATE TABLE produto_ficha_tecnica_itens( 
      id  INTEGER    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      quantidade double   NOT NULL  , 
      valor_custo double   , 
      valor_total double   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade_fixa_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_ficha_tecnica_id) REFERENCES produto_ficha_tecnica(id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(quantidade_fixa_id) REFERENCES resposta(id)) ; 

CREATE TABLE produto_ficha_tecnica_mao_obra( 
      id  INTEGER    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      funcionario_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      valor_hora double   NOT NULL  , 
      quantidade double   NOT NULL  , 
      valor_total double   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_ficha_tecnica_id) REFERENCES produto_ficha_tecnica(id),
FOREIGN KEY(funcionario_id) REFERENCES funcionario(id)) ; 

CREATE TABLE produto_filial( 
      id  INTEGER    NOT NULL  , 
      produto_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      margem double   , 
      preco_venda double   NOT NULL  , 
      preco_venda_anterior double   , 
      valor_custo double   , 
      valor_custo_anterior double   , 
      criado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
      estoque_minimo double   , 
      estoque_maximo double   , 
      local_estoque text   , 
      codigo_balanca text   , 
      deletado_em datetime   , 
      estoque_deposito_padrao_id int   , 
      sob_encomenda_id int   , 
      gerar_op_venda_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(estoque_deposito_padrao_id) REFERENCES estoque_deposito(id),
FOREIGN KEY(sob_encomenda_id) REFERENCES resposta(id),
FOREIGN KEY(gerar_op_venda_id) REFERENCES resposta(id)) ; 

CREATE TABLE produto_filial_historico( 
      id  INTEGER    NOT NULL  , 
      produto_id int   NOT NULL  , 
      produto_filial_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      preco_venda_antigo double   NOT NULL  , 
      preco_venda_novo double   NOT NULL  , 
      valor_custo_antigo double   , 
      valor_custo_novo double   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(produto_filial_id) REFERENCES produto_filial(id)) ; 

CREATE TABLE produto_fornecedor( 
      id  INTEGER    NOT NULL  , 
      produto_id int   NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      codigo_fornecedor text   , 
      descricao_produto_fornecedor text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      tempo_medio_fornecimento double   , 
      quantidade_minima_compra double   , 
      preco_venda double   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(fornecedor_id) REFERENCES fornecedor(id)) ; 

CREATE TABLE produto_grupo( 
      id  INTEGER    NOT NULL  , 
      tipo_recurso_id int   , 
      descricao text   NOT NULL  , 
      imagem text   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      criado_por text   , 
      alterado_por text   , 
      deletado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(tipo_recurso_id) REFERENCES tipo_recurso(id)) ; 

CREATE TABLE produtogrupo_subgrupo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      produto_grupo_id int   NOT NULL  , 
      subgrupo_id int  (11)   , 
      nivel int  (11)   , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_grupo_id) REFERENCES produto_grupo(id)) ; 

CREATE TABLE produto_lote( 
      id  INTEGER    NOT NULL  , 
      produto_id int   NOT NULL  , 
      numero text   NOT NULL  , 
      validade date   , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_em datetime   , 
      criado_por text   , 
      alterado_por text   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE produto_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo_embalagem( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE resposta( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE servico_formapgto( 
      id  INTEGER    NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      quantidade_parcelas int   , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(ordem_servico_id) REFERENCES ordem_servico(id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id)) ; 

CREATE TABLE system_document( 
      id int   NOT NULL  , 
      category_id int   NOT NULL  , 
      system_user_id int   , 
      title text   NOT NULL  , 
      description text   , 
      submission_date date   , 
      archive_date date   , 
      filename text   , 
 PRIMARY KEY (id),
FOREIGN KEY(category_id) REFERENCES system_document_category(id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id)) ; 

CREATE TABLE system_document_category( 
      id int   NOT NULL  , 
      name text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_group( 
      id int   NOT NULL  , 
      document_id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(document_id) REFERENCES system_document(id),
FOREIGN KEY(system_group_id) REFERENCES system_group(id)) ; 

CREATE TABLE system_document_user( 
      id int   NOT NULL  , 
      document_id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(document_id) REFERENCES system_document(id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id)) ; 

CREATE TABLE system_group( 
      id int   NOT NULL  , 
      name text   NOT NULL  , 
      uuid varchar  (36)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program( 
      id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
      system_program_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(system_program_id) REFERENCES system_program(id),
FOREIGN KEY(system_group_id) REFERENCES system_group(id)) ; 

CREATE TABLE system_group_program_permissoes( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      system_program_permissoes_id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_program_permissoes_id) REFERENCES system_program_permissoes(id),
FOREIGN KEY(system_group_id) REFERENCES system_group(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE system_message( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_user_to_id int   NOT NULL  , 
      subject text   NOT NULL  , 
      message text   , 
      dt_message datetime   , 
      checked char  (1)   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id),
FOREIGN KEY(system_user_to_id) REFERENCES system_users(id)) ; 

CREATE TABLE system_notification( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_user_to_id int   NOT NULL  , 
      subject text   , 
      message text   , 
      dt_message datetime   , 
      action_url text   , 
      action_label text   , 
      icon text   , 
      checked char  (1)   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id),
FOREIGN KEY(system_user_to_id) REFERENCES system_users(id)) ; 

CREATE TABLE system_preference( 
      id varchar  (255)   NOT NULL  , 
      preference text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program( 
      id int   NOT NULL  , 
      name text   NOT NULL  , 
      controller text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program_permissoes( 
      id  INTEGER    NOT NULL  , 
      system_program_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_program_id) REFERENCES system_program(id)) ; 

CREATE TABLE system_unit( 
      id int   NOT NULL  , 
      connection_name text   , 
      vendas_natureza_operacao_id int   , 
      nfce_natureza_operacao_id int   , 
      cnpj varchar  (14)   NOT NULL  , 
      name text   NOT NULL  , 
      razao_social varchar  (255)   NOT NULL  , 
      inscricao_estadual varchar  (255)   , 
      inscricao_municipal varchar  (255)   , 
      fone text   , 
      notafiscal_crt_id int   NOT NULL  , 
      pc_credito_sn double  (10,2)     DEFAULT 0, 
      aliquota_iss double  (10,2)   , 
      aliquota_irrf double  (10,2)   , 
      aliquota_csll double  (10,2)   , 
      sn_matriz char  (1)   NOT NULL    DEFAULT 'N', 
      nfce_tpamb_id int   , 
      nfe_tpamb_id int   , 
      nfe_tpimp_id int   , 
      nfce_tpimp_id int   , 
      certificadoA1 text   , 
      senha_certificado text   , 
      nfe_homologacao_series_id int   , 
      nfe_producao_series_id int   , 
      nfce_homologacao_series_id int   , 
      nfe_api_documentos_id int   , 
      nfce_api_documentos_id int   , 
      nfce_producao_series_id int   , 
      end_cep text   , 
      end_mun_codibge text   , 
      end_municipio text   , 
      end_uf char  (2)   , 
      end_logradouro text   , 
      end_bairro text   , 
      end_numero text   , 
      end_complemento text   , 
      nfce_csc_homologacao text   , 
      nfce_csc_producao text   , 
      notafiscal_cprod_padrao_id int   , 
      nfce_id_csc_homologacao text   , 
      nfce_id_csc_producao text   , 
      email varchar  (255)   , 
      token_api text   , 
      mdfe_tpamb_id int   , 
      mdfe_estadoini_id int   , 
      veiculo_id int   , 
      mdfe_api_documentos_id int   , 
      mdfe_homologacao_series_id int   , 
      mdfe_producao_series_id int   , 
      natureza_operacao_compra_id int   , 
      logo text   , 
      contador_nome text   , 
      contador_documento text   , 
      contador_email text   , 
      contador_celular text   , 
      config_host text   , 
      config_user text   , 
      config_password text   , 
      config_port varchar  (11)     DEFAULT '587', 
      config_from text   , 
      config_replyname text   , 
      config_replyto text   , 
      column_63 int   , 
      cnae text   , 
 PRIMARY KEY (id),
FOREIGN KEY(notafiscal_crt_id) REFERENCES notafiscal_crt(id),
FOREIGN KEY(nfe_tpamb_id) REFERENCES notafiscal_tpamb(id),
FOREIGN KEY(nfe_tpimp_id) REFERENCES notafiscal_tpimp(id),
FOREIGN KEY(nfe_api_documentos_id) REFERENCES api_documentos(id),
FOREIGN KEY(vendas_natureza_operacao_id) REFERENCES natureza_operacao(id),
FOREIGN KEY(nfce_natureza_operacao_id) REFERENCES natureza_operacao(id),
FOREIGN KEY(nfe_homologacao_series_id) REFERENCES notafiscal_series(id),
FOREIGN KEY(nfe_producao_series_id) REFERENCES notafiscal_series(id),
FOREIGN KEY(nfce_homologacao_series_id) REFERENCES notafiscal_series(id),
FOREIGN KEY(nfce_producao_series_id) REFERENCES notafiscal_series(id),
FOREIGN KEY(notafiscal_cprod_padrao_id) REFERENCES notafiscal_cprod_padrao(id),
FOREIGN KEY(nfce_tpimp_id) REFERENCES notafiscal_tpimp(id),
FOREIGN KEY(nfce_tpamb_id) REFERENCES notafiscal_tpamb(id),
FOREIGN KEY(nfce_api_documentos_id) REFERENCES api_documentos(id),
FOREIGN KEY(mdfe_tpamb_id) REFERENCES mdfe_tpamb(id),
FOREIGN KEY(mdfe_estadoini_id) REFERENCES estado(id),
FOREIGN KEY(veiculo_id) REFERENCES veiculo(id),
FOREIGN KEY(mdfe_api_documentos_id) REFERENCES api_documentos(id),
FOREIGN KEY(mdfe_homologacao_series_id) REFERENCES mdfe_series(id),
FOREIGN KEY(mdfe_producao_series_id) REFERENCES mdfe_series(id),
FOREIGN KEY(natureza_operacao_compra_id) REFERENCES natureza_operacao(id)) ; 

CREATE TABLE system_user_group( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(system_group_id) REFERENCES system_group(id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id)) ; 

CREATE TABLE system_user_pdv_permissoes( 
      id  INTEGER    NOT NULL  , 
      empresa_id int   NOT NULL  , 
      pdv_permissoes_id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(pdv_permissoes_id) REFERENCES pdv_permissoes(id)) ; 

CREATE TABLE system_user_program( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_program_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(system_program_id) REFERENCES system_program(id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id)) ; 

CREATE TABLE system_user_program_permissoes( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      system_program_permissoes_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_users_id) REFERENCES system_users(id),
FOREIGN KEY(system_program_permissoes_id) REFERENCES system_program_permissoes(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE system_users( 
      id int   NOT NULL  , 
      name text   NOT NULL  , 
      login text   NOT NULL  , 
      password text   NOT NULL  , 
      email text   , 
      frontpage_id int   , 
      system_unit_id int   , 
      active char  (1)   , 
      accepted_term_policy char  (1)   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(frontpage_id) REFERENCES system_program(id)) ; 

CREATE TABLE system_user_unit( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE tabela_preco( 
      id  INTEGER    NOT NULL  , 
      tabela_preco_tipo_alteracao_id int   NOT NULL  , 
      tabela_preco_tipo_id int   , 
      descricao text   NOT NULL  , 
      observacao text   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      data_hora_promocao_inicial datetime   , 
      data_hora_promocao_final datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(tabela_preco_tipo_alteracao_id) REFERENCES tabela_preco_tipo_alteracao(id),
FOREIGN KEY(tabela_preco_tipo_id) REFERENCES tabela_preco_tipo(id)) ; 

CREATE TABLE tabela_preco_produto( 
      id  INTEGER    NOT NULL  , 
      tabela_preco_id int   NOT NULL  , 
      produto_filial_id int   NOT NULL  , 
      preco_venda double   NOT NULL  , 
      valor_parametro double   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(tabela_preco_id) REFERENCES tabela_preco(id),
FOREIGN KEY(produto_filial_id) REFERENCES produto_filial(id)) ; 

CREATE TABLE tabela_preco_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo_alteracao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_documento( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_recurso( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE titulos_tipo_anexo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE unidade_medida( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      sigla text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo( 
      id  INTEGER    NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      modelo_marca text   NOT NULL  , 
      placa text   NOT NULL  , 
      ano int   , 
      tara double   , 
      capacidade_kg double   , 
      renavam text   , 
      capacidade_m3 double   , 
      mdfe_tpRod_id int   NOT NULL  , 
      estado_id int   NOT NULL  , 
      veiculo_tipo_id int   NOT NULL  , 
      mdfe_tpcar_id int   NOT NULL  , 
      funcionario_motorista_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(mdfe_tpRod_id) REFERENCES mdfe_tpRod(id),
FOREIGN KEY(estado_id) REFERENCES estado(id),
FOREIGN KEY(veiculo_tipo_id) REFERENCES veiculo_tipo(id),
FOREIGN KEY(mdfe_tpcar_id) REFERENCES mdfe_tpcar(id),
FOREIGN KEY(funcionario_motorista_id) REFERENCES funcionario(id)) ; 

CREATE TABLE veiculo_tipo( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda( 
      id  INTEGER    NOT NULL  , 
      venda_situacao_id int   NOT NULL  , 
      orcamento_id int   , 
      vendedor_id int   , 
      dispositivos_id int   , 
      cliente_id int   , 
      numero_celula_consumo text   , 
      system_unit_id int   NOT NULL  , 
      filial_saida_id int   NOT NULL  , 
      venda_modalidade_id int   NOT NULL  , 
      venda_tipo_pagamento_id int   NOT NULL  , 
      id_venda_local int   , 
      data_hora_venda datetime   NOT NULL  , 
      valor_produtos double   NOT NULL  , 
      valor_troco double   , 
      desconto double   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      observacao text   , 
      observacao_nf text   , 
      peso_total double   , 
      frete_total double   , 
      valor_total double   NOT NULL  , 
      cliente_endereco_id int   , 
      info_faturamento text   , 
      data_prev_entrega date   , 
      criado_por text   , 
      alterado_por text   , 
      valor_comissao double   , 
      comissao_avista double   , 
      comissao_aprazo int   , 
      valor_avista double   , 
      valor_aprazo double   , 
      tabela_preco_id int   , 
      movimentacao_origem_id int   , 
 PRIMARY KEY (id),
FOREIGN KEY(venda_situacao_id) REFERENCES venda_situacao(id),
FOREIGN KEY(cliente_id) REFERENCES cliente(id),
FOREIGN KEY(dispositivos_id) REFERENCES dispositivos(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(filial_saida_id) REFERENCES system_unit(id),
FOREIGN KEY(venda_modalidade_id) REFERENCES venda_modalidade(id),
FOREIGN KEY(venda_tipo_pagamento_id) REFERENCES venda_tipo_pagamento(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id),
FOREIGN KEY(orcamento_id) REFERENCES orcamento(id),
FOREIGN KEY(cliente_endereco_id) REFERENCES cliente_endereco(id),
FOREIGN KEY(tabela_preco_id) REFERENCES tabela_preco(id),
FOREIGN KEY(movimentacao_origem_id) REFERENCES movimentacao_origem(id)) ; 

CREATE TABLE venda_devolucao( 
      id  INTEGER    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      data_devolucao date   NOT NULL  , 
      valor double   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(venda_id) REFERENCES venda(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE venda_devolucao_itens( 
      id  INTEGER    NOT NULL  , 
      venda_devolucao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade double   NOT NULL  , 
      valor_unitario double   , 
      valor_total double   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(venda_devolucao_id) REFERENCES venda_devolucao(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE venda_devolucao_troca( 
      id  INTEGER    NOT NULL  , 
      venda_devolucao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      quantidade double   NOT NULL  , 
      valor_unitario double   NOT NULL  , 
      valor_total double   NOT NULL  , 
 PRIMARY KEY (id),
FOREIGN KEY(venda_devolucao_id) REFERENCES venda_devolucao(id),
FOREIGN KEY(produto_id) REFERENCES produto(id)) ; 

CREATE TABLE venda_formapgto( 
      id  INTEGER    NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      quantidade_parcelas int   , 
      valor double   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(forma_pagamento_id) REFERENCES forma_pagamento(id),
FOREIGN KEY(venda_id) REFERENCES venda(id)) ; 

CREATE TABLE venda_item( 
      id  INTEGER    NOT NULL  , 
      venda_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      quantidade double   NOT NULL  , 
      valor_unitario double   NOT NULL  , 
      valor_total double   NOT NULL  , 
      valor_original double   NOT NULL  , 
      valor_custo double   , 
      desconto double   , 
      informacoes_adicionais text   , 
      cancelado int   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
      numero_pedido text   , 
      numero_item_pedido text   , 
      valor_frete double   , 
      peso_unitario double   , 
      peso_total double   , 
      estoque_deposito_id int   , 
      produto_lote_id int   , 
      quantidade_devolvida double   , 
 PRIMARY KEY (id),
FOREIGN KEY(produto_id) REFERENCES produto(id),
FOREIGN KEY(cancelado) REFERENCES resposta(id),
FOREIGN KEY(venda_id) REFERENCES venda(id),
FOREIGN KEY(estoque_deposito_id) REFERENCES estoque_deposito(id),
FOREIGN KEY(produto_lote_id) REFERENCES produto_lote(id)) ; 

CREATE TABLE venda_meta( 
      id  INTEGER    NOT NULL  , 
      venda_meta_situacao_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      data_inicial date   NOT NULL  , 
      data_final date   NOT NULL  , 
      valor_meta_geral_prevista double   NOT NULL  , 
      valor_meta_geral_realizada double   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      data_ultimo_processamento datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(venda_meta_situacao_id) REFERENCES venda_meta_situacao(id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id)) ; 

CREATE TABLE venda_meta_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_vendedor( 
      id  INTEGER    NOT NULL  , 
      venda_meta_id int   NOT NULL  , 
      vendedor_id int   NOT NULL  , 
      valor_meta_prevista double   , 
      valor_meta_realizada double   , 
      criado_em datetime   NOT NULL  , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em datetime   , 
      aproveiramento_carteira_prevista double   , 
      aproveitamento_carteira_realizada double   , 
 PRIMARY KEY (id),
FOREIGN KEY(venda_meta_id) REFERENCES venda_meta(id),
FOREIGN KEY(vendedor_id) REFERENCES vendedor(id)) ; 

CREATE TABLE venda_modalidade( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      alterado_em datetime   , 
      situacaopdv_id int   , 
      ordem int   , 
      cor text   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao_historico( 
      id  INTEGER    NOT NULL  , 
      venda_situacao_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   NOT NULL  , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(venda_situacao_id) REFERENCES venda_situacao(id),
FOREIGN KEY(venda_id) REFERENCES venda(id)) ; 

CREATE TABLE venda_tipo_pagamento( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor( 
      id  INTEGER    NOT NULL  , 
      nome text   NOT NULL  , 
      cpf text   , 
      vendedor_tipo_comissao_id int   , 
      vendedor_tipo_pgto_comissao_id int   , 
      criado_em datetime   , 
      alterado_em datetime   , 
      percentual_comissao double   , 
      criado_por text   , 
      alterado_por text   , 
      deletado_em datetime   , 
 PRIMARY KEY (id),
FOREIGN KEY(vendedor_tipo_comissao_id) REFERENCES vendedor_tipo_comissao(id),
FOREIGN KEY(vendedor_tipo_pgto_comissao_id) REFERENCES vendedor_tipo_pgto_comissao(id)) ; 

CREATE TABLE vendedor_tipo_comissao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_pgto_comissao( 
      id  INTEGER    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em datetime   , 
      deletado_em datetime   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em datetime   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE xml_contador( 
      id  INTEGER    NOT NULL  , 
      data_inicio date   , 
      data_fim date   , 
      system_user_id int   , 
      system_unit_id int   , 
      data_solicitacao datetime   , 
      caminho_download varchar  (255)   , 
      updated_at datetime   , 
      created_at datetime   , 
      info_registros varchar  (255)   , 
      data_click datetime   , 
      status_id int     DEFAULT 0, 
      situacao int     DEFAULT 1, 
      caminho_pdf varchar  (255)   , 
      contador int     DEFAULT 0, 
      contador_email int     DEFAULT 0, 
      downloads int     DEFAULT 0, 
      rota text   , 
      chave varchar  (20)   , 
 PRIMARY KEY (id),
FOREIGN KEY(system_unit_id) REFERENCES system_unit(id),
FOREIGN KEY(system_user_id) REFERENCES system_users(id)) ; 

 
 CREATE UNIQUE INDEX unique_idx_dispositivos_token ON dispositivos(token);
 
 CREATE VIEW view_consulta_contabil_por_data AS select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento data_vencimento,
	   p.data_pagamento data_pagamento,
	   p.criado_em data_lancamento
from contaspag p,
	 contaspag_contabil cc,
	 contabil_lancamentos cl
where p.id = cc.contaspag_id 
and   cl.contaspag_contabil_id = cc.id
and   p.deletado_em is null
and   cc.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento  data_vencimento,
	   p.data_pagamento  data_pagamento,
	   p.criado_em  data_lancamento
from contasrec p,
	 contabil_lancamentos cl
where cl.contasrec_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_lancamento  data_vencimento,
	   p.data_lancamento  data_pagamento,
	   p.data_lancamento  data_lancamento
from conta_corrente_lancamentos p,
	 contabil_lancamentos cl
where cl.conta_corrente_lancamentos_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
; 

CREATE VIEW view_negocio_timeline AS SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'nota' as "tipo"
FROM negocio_notas

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'arquivo' as "tipo"
FROM negocio_arquivos

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'atividade' as "tipo"
FROM negocio_atividade

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'produto' as "tipo"
FROM negocio_itens

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'etapa' as "tipo"
FROM negocio_etapas_historico
; 

CREATE VIEW vw_caixa_resumo AS select c.caixa_id AS caixa_id,
		'Fundo de Caixa' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 3) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Entradas' AS tipo,
        coalesce(sum(c.valor), 0) AS valor 
        from caixa_lancamentos c where (c.caixa_tipo_lancamento_id = 2) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saidas' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 1) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saldo' AS tipo,sum((case when (c.caixa_tipo_lancamento_id = 1) then (c.valor * -(1)) else c.valor end)) AS valor 
        from caixa_lancamentos c 
        group by c.caixa_id
        ; 

CREATE VIEW vw_caixa_resumo_formas AS Select 
    c.caixa_id caixa_id,
    c.forma_pagamento_id forma_pagamento_id,
    f.descricao nome_forma_pagamento,
    sum(case when c.caixa_tipo_lancamento_id = 1 then c.valor * -1 else c.valor end) total
from caixa_lancamentos c,
     forma_pagamento f
where f.id = c.forma_pagamento_id
group by c.caixa_id, c.forma_pagamento_id; 

CREATE VIEW vw_funil_filial AS SELECT DISTINCT
f.id AS id,
f.descricao AS descricao,
n.system_unit_id AS system_unit_id
FROM funil f
INNER JOIN funil_etapas fe ON fe.funil_id = f.id
INNER JOIN negocio n ON n.funil_etapas_id = fe.id; 

CREATE VIEW vw_lotes_produto AS select l.id as id,
       l.produto_id as produto_id,
       l.numero as numero,
       l.validade as validade,
       sum(e.quant_disponivel) as Quantidade,
       sum(e.quant_reservada) as Reservado
       from produto_lote l
left join estoque_saldos e on e.produto_lote_id = l.id
; 

CREATE VIEW vw_produto_estoque AS SELECT     p.id as id,
           p.nome as nome,
           p.referencia as referencia,
           p.codigo_sku as SKU,
           p.obs as obs,
           f.margem as margem,
           f.valor_custo as valor_custo,
           f.preco_venda as preco_venda,
           p.peso_liquido as peso_liquido,
           p.peso_bruto as preso_bruto,
           g.descricao as grupo,
           sg.descricao as subgrupo,
           u.sigla as sigla,
           p.imagem as imagem,
           p.codigo_ean as ean,
           p.ncm as ncm,
           f.system_unit_id as system_unit_id,
           f.id as produto_filial_id,
           f.estoque_minimo as estoque_minimo,
           f.estoque_maximo as estoque_maximo,           
           (e.quant_disponivel) as Quantidade_Disponivel,
           (e.quant_reservada) as Quantidade_Reservada,
           d.descricao as deposito
           
           FROM produto p 
           INNER JOIN unidade_medida u ON p.unidade_medida_id = u.id 
           INNER JOIN produto_grupo g ON p.produto_grupo_id = g.id
           LEFT JOIN produtogrupo_subgrupo sg ON g.id = sg.produto_grupo_id
           LEFT JOIN produto_filial f ON f.produto_id = p.id 
           LEFT JOIN estoque_saldos e ON e.produto_id = p.id
           LEFT JOIN estoque_deposito d ON e.estoque_deposito_id = d.id
           group by 1,2           
           
           ; 
 
