<?php
class ClassMaster
{
    private static $database = 'kraftsoft';
    //ClassMaster::getXML
    public static function cleandoc($value)
    {

        return $value = preg_replace('/[^a-zA-Z0-9\s]/', '', $value);

    }

    public static function cleanPasta($value)
    {

        $dataHora = $value;
        $caractereSubstituto = '_';

// Remova espaços, dois pontos ':' e hífens '-' e substitua por um caractere específico
        $dataHoraFormatada = str_replace([' ', ':', '-'], $caractereSubstituto, $dataHora);

        return $dataHoraFormatada; // Resultado: "20231019235959"

    }

    /**
     * Limita o tamanho do texto ao valor especificado.
     *
     * @param string $texto O texto a ser limitado.
     * @param int $limite O limite máximo de caracteres.
     * @return string O texto limitado.
     */
    public static function limitarTexto($texto, $limite)
    {
        if (strlen($texto) > $limite) {
            $texto = substr($texto, 0, $limite);
        }
        return $texto;
    }

    public static function tipodoc($tipo)
    {

        if (strlen($tipo) === 11) {
            return $tipo_pessoa = "PESSOA_FISICA";
        } else {
            return $tipo_pessoa = "PESSOA_JURIDICA";
        }

    }

    /**
     * Converte uma data para o formato "d/m/Y".
     *
     * @param string $data A data a ser convertida.
     * @return string A data convertida.
     */
    public static function data_BR($data)
    {
        $dataConvertida = date("d/m/Y", strtotime($data));
        return $dataConvertida;
    }

    public static function calcularDataFutura($dias)
    {
        $dataAtual = date('Y-m-d'); // Data atual no formato "AAAA-MM-DD"
        $dataFutura = date('Y-m-d', strtotime("-$dias days", strtotime($dataAtual)));
        return $dataFutura;
    }

    /**
     * Converte um valor numérico para uma string formatada como moeda.
     *
     * @param float $value O valor numérico.
     * @return string O valor formatado como moeda. MillFunctionsClass::modeda_string
     */
    public static function modeda_string($value)
    {
        return 'R$ ' . number_format($value, 2, ',', '.');
    }

    public static function getXML($id, $file, $chave, $variavel_banco, $protocolo_envio = null)
    {
        TTransaction::open(self::$database);
        $objeto = Notafiscal::find($id);
        if ($objeto) {
            if ($variavel_banco != 'xml') {
                $objeto->$variavel_banco = $file;
            } else {

                $base64_encoded = base64_encode($file);
                $objeto->$variavel_banco = $base64_encoded;
            }

            $objeto->chave = $chave;
            $objeto->protocolo_envio = $protocolo_envio ?? null;

            if (isset($protocolo_envio)) {
                $objeto->status = 'Autorizada';
                $objeto->notafiscal_situacao_id = 2;
                $objeto->codigo_sefaz = 100;

            }

            $base64_encoded = base64_encode($xml_content);

            $objeto->store();
        }
        TTransaction::close();
        return true;
    }

    public static function interpretarCodigo($codigo)
    {
        switch ($codigo) {
            case '101':
                return '00';
            case '102':
                return '40';
            case '103':
                return '00';
            case '201':
                return '10';
            case '202':
                return '10';
            case '203':
                return '10';
            default:
                return '00';
        }
    }
    public static function formataPlacadeCarro($placa)
    {
        $tam = strlen($placa);
        $primeiraParte = substr($placa, 0, 3);
        $segundaParte = substr($placa, 3);

        $PLACA = $primeiraParte . "-" . $segundaParte;
        return $PLACA;
    }

    public static function CartaOFF($pedido)
    {
        TTransaction::open(self::$database);
        // Substitua 'campo_condicao' pelo campo que deseja verificar na tabela PedidoEvento
        $pedido = PedidoEvento::where('notafiscal_id', '=', $pedido)->first();

        TTransaction::close();
        if (isset($pedido->id)) {
            return true;
        }

        return false;
    }

}
