<?php
class CalculadoraAliquotaICMS
{
    public static function calcularAliquota($estadoOrigem, $estadoDestino)
    {
        $aliquotaInterestadual = self::obterAliquotaInterestadual($estadoOrigem);
        $aliquotaInterna = self::obterAliquotaInterna($estadoDestino);

        return [
            'interestadual' => $aliquotaInterestadual,
            'interna' => $aliquotaInterna,
        ];
    }

    private static function obterAliquotaInterestadual($estadoOrigem)
    {
        switch ($estadoOrigem) {
            case 'AC': return 7;
            case 'AL': return 12;
            case 'AP': return 9;
            case 'AM': return 8;
            case 'BA': return 7;
            case 'CE': return 11;
            case 'DF': return 5;
            case 'ES': return 6;
            case 'GO': return 8;
            case 'MA': return 12;
            case 'MT': return 7;
            case 'MS': return 6;
            case 'MG': return 12;
            case 'PA': return 9;
            case 'PB': return 11;
            case 'PR': return  9;
            case 'PE': return 10;
            case 'PI': return 8;
            case 'RJ': return 11;
            case 'RN': return 12;
            case 'RS': return 8;
            case 'RO': return 7;
            case 'RR': return 6;
            case 'SC': return 7;
            case 'SP': return 12;
            case 'SE': return 9;
            case 'TO': return 8;
            default: return 4; // Alíquota padrão para estados não listados
        }
    }

    private static function obterAliquotaInterna($estadoDestino)
    {
        switch ($estadoDestino) {
            case 'AC': return 12;
            case 'AL': return 18;
            case 'AP': return 15;
            case 'AM': return 17;
            case 'BA': return 19;
            case 'CE': return 18;
            case 'DF': return 12;
            case 'ES': return 17;
            case 'GO': return 15;
            case 'MA': return 18;
            case 'MT': return 16;
            case 'MS': return 15;
            case 'MG': return 18;
            case 'PA': return 16;
            case 'PB': return 17;
            case 'PR': return 18;
            case 'PE': return 18;
            case 'PI': return 16;
            case 'RJ': return 20;
            case 'RN': return 18;
            case 'RS': return 17;
            case 'RO': return 16;
            case 'RR': return 15;
            case 'SC': return 17;
            case 'SP': return 18;
            case 'SE': return 16;
            case 'TO': return 15;
            default: return 12; // Alíquota padrão para estados não listados
        }
    }
}
