<?php



use NFePHP\NFe\Tools;
use NFePHP\Common\Certificate;
use NFePHP\NFe\Common\Standardize;
use NFePHP\NFe\Complements;

/**
 * Classe Gera  carta de corerção obtenção do XML 
 *
 * Autor: Rubens dos Santos
 * Email: salvadorbba@gmail.com
 * Celular: (12) 99675-8056
 */
class CartaCorecaoNFe
{
    private $key;
    private $vendas;
    private $emitente;
    private $tools;
    private $nota;
    private $cliente;
    private $QTDEventos;
    private  $pedido;


    private $PedidoEvento;
    private static $database = 'kraftsoft';

    /**
     * Construtor da classe GeraNFe.
     *
     * @param string $key - A chave para buscar os parâmetros no banco de dados.
     */
    public function __construct($key)
    {
        $this->key = $key;
         
    }

    /**
     * Função para criar e obter um token de autenticação do Sicredi.
     *
     * @return string - O token de acesso obtido.  CartaCorecaoNFe  solicitar
     */
    public function solicitar()
    {

 
 
        try {
            // Abrir uma transação de banco de dados no contexto 'agendamentos'.
                   TTransaction::open(self::$database);
                  
                  
                    $this->pedido= PedidoEvento::find($this->key);
                
                    $this->vendas = Notafiscal::find($this->pedido->notafiscal_id);
             
                    $this->emitente = SystemUnit::find(TSession::getValue('userunitid'));
           
            
            TTransaction::close();

            $config = [
                'atualizacao' => date('Y-m-d H:i:s'),
                'tpAmb' => (int) $this->emitente->nfe_tpamb_id,
                'razaosocial' => $this->emitente->razao_social,
                'cnpj' => $this->emitente->cnpj, // PRECISA SER VÁLIDO
                'ie' => $this->emitente->inscricao_estadual, // PRECISA SER VÁLIDO
                'siglaUF' => $this->emitente->end_uf,
                'schemes' => 'PL_009_V4',
                'versao' => '4.00',
            ];

            $configJson = json_encode($config);
            $this->tools = new Tools(
                $configJson,
                Certificate::readPfx(file_get_contents($this->emitente->certificadoA1), $this->emitente->senha_certificado)

    
            );
            
            
             

            $this->tools->model('55');

            $chave =$this->pedido->chave;
            $xCorrecao =$this->pedido->descricao;
            $nSeqEvento = $this->pedido->nseqevento;
            
            $response =   $this->tools->sefazCCe($chave, $xCorrecao, $nSeqEvento);

           
            $stdCl = new Standardize($response);
            //nesse caso $std irá conter uma representação em stdClass do XML
            $std = $stdCl->toStd();
 
            $resposnse_cce = $std->retEvento->infEvento;
            
   
            //verifique se o evento foi processado
            if ($std->cStat != 128) {
                //houve alguma falha e o evento não foi processado
                //TRATAR
            } else {
                $cStat = $std->retEvento->infEvento->cStat;
                if ($cStat == '135' || $cStat == '136') {

                  //  $xmlAutorizado = file_get_contents($this->vendas->caminho_xml);

                    //SUCESSO PROTOCOLAR A SOLICITAÇÂO ANTES DE GUARDAR
                    $xml = Complements::toAuthorize($this->tools->lastRequest, $response);


                    TTransaction::open(self::$database);
                    $objeto_pedido = PedidoEvento::find($this->key);
                    if($objeto_pedido)
                    {
                        $objeto_pedido->protocolo_resposta = $resposnse_cce->nProt;
                        $objeto_pedido->xevento = $resposnse_cce->xMotivo ;
                        $objeto_pedido->status = 2;
                        $objeto_pedido->store();    
                    }

    // [tpAmb] => 2
    // [verAplic] => NFEPE_H_2.9.0
    // [cOrgao] => 26
    // [cStat] => 135
    // [xMotivo] => Evento registrado e vinculado a NF-e
    // [chNFe] => 26231214013224000142550070000007551777101089
    // [tpEvento] => 110110
    // [xEvento] => Carta de Correcao registrada
    // [nSeqEvento] => 2
    // [dhRegEvento] => 2023-12-17T21:36:45-03:00
    // [nProt] => 126230000365642
                    $objeto = Notafiscal::find($this->pedido->notafiscal_id);
                    if ($objeto) {
                        $objeto->xml_carta =  $xml;
                        $objeto->protocolo_carta_resposta = $resposnse_cce->nProt;
                        $objeto->xjust=$this->pedido->descricao;
                        $objeto->xevento=$resposnse_cce->xEvento;
                        $objeto->xmotivo=$resposnse_cce->xMotivo;
                        $objeto->cstat=$resposnse_cce->cStat;
                        $objeto->dhregevento= $resposnse_cce->dhRegEvento;
                        $objeto->nseqevento = $resposnse_cce->nSeqEvento;
                        $objeto->protocolo_resposta = $resposnse_cce->nProt;

                        $objeto->store();
                    }
 
                    $eventos = new EventosDocumentos();
                    $eventos->tpamb = $resposnse_cce->tpAmb;
                    $eventos->veraplic = $resposnse_cce->verAplic;
                    $eventos->cstat = $resposnse_cce->cStat;
                    $eventos->xmotivo = $resposnse_cce->xMotivo;
                    $eventos->chnfe = $resposnse_cce->chNFe;
                    $eventos->xevento = $resposnse_cce->xEvento;
                    $eventos->tpevento = $resposnse_cce->tpEvento;
                    $eventos->nseqevento = $resposnse_cce->nSeqEvento;
                    $eventos->dhregevento = $resposnse_cce->dhRegEvento;
                    $eventos->nprot = $resposnse_cce->nProt;
                     $eventos->xml = $xml ;
                      
                    
                    $eventos->system_users_id =  TSession::getValue('userunitid');
                    $eventos->system_unit_id =  TSession::getValue('userid');
                    $eventos->origem_event =  'cce';

                    $eventos->store();
 
 
   
                    TTransaction::close();
       
                    // Código gerado pelo snippet: "Exibir mensagem"
                    new TMessage('info', "Soliciação enviada com sucesso!<br>Protocolo: " . $resposnse_cce->nProt . '<br>Retorno:' . $resposnse_cce->xMotivo);
                    // -----


                } else {
                }
            }
        } catch (\Exception $e) {

            echo $e->getMessage();
        }
    }
}