<?php
/*
 * arquivo resposavel pela geração do XML da NF-e
 *
 * @version    7.4
 * @package    core
 * @author     Rubens do Santos
 * @license    http://www.adianti.com.br/framework-license
 *
 * saida do codigo   ->>>>  STATUsSEFAZ::Cosulta(TSession::getValue('userunitid')); id da nfe_temp
 */
use NFePHP\NFe\Tools;
use NFePHP\Common\Certificate;
use NFePHP\NFe\Common\Standardize;
class ConSusultaStatusSefaz
{

    private static $database = 'kraftsoft';
    private $tools;
    private   $key;
    private $emitente;
    /**
     * Class Constructor
     */
    public function __construct($key)
    {
        $this->key = $key;
    }

    public function Cosulta()
    {
 
        TTransaction::open(self::$database);

    $this->emitente = SystemUnit::find(TSession::getValue('userunitid'));

        ///// itens da nfe////////
        TTransaction::close();

        $antes = ['.', '-', '/', '(', ')'];
        $depos = ['', '', '', '', ''];
        $cpf_cnpj = str_replace($antes, $depos, $this->emitente->cnpj);

        $config = [
            'atualizacao' => date('Y-m-d H:i:s'),
            'tpAmb' => (int) $this->emitente->nfe_tpamb_id,
            'razaosocial' => $this->emitente->razao_social,
            'cnpj' => $cpf_cnpj, // PRECISA SER VÁLIDO
            'ie' => $this->emitente->inscricao_estadual, // PRECISA SER VÁLIDO
            'siglaUF' => $this->emitente->end_uf,
            'schemes' => 'PL_009_V4',
            'versao' => '4.00',
        ];

        $configJson = json_encode($config);
        $this->tools = new Tools(
            $configJson,
            Certificate::readPfx(file_get_contents($this->emitente->certificadoA1), $this->emitente->senha_certificado)

            //falta implementar do cloud nfe ****
        );
 
       
       
 
        try {
            
            
    
      $this->tools->model('55');
     $uf = $this->emitente->end_uf;
     $tpAmb =  (int) $this->emitente->nfe_tpamb_id;
    
    
    $response = $this->tools->sefazStatus($uf, $tpAmb);
    
 
            $stdCl = new Standardize($response);
            $std = $stdCl->toStd();
            $arr = $stdCl->toArray();
            $json = $stdCl->toJson();
            $std->xMotivo;

            if ( $tpAmb  == 1):
                $Ambiente = 'Produção';

            else:
                $Ambiente = 'Homologação';

            endif;

            new TMessage('info', 'Empresa:   <b>' . $this->emitente->razao_social . '</b> UF:<b>' . $uf . '</b><br>  Ambiente:<b>' . $Ambiente . '</b><hr>
Status:<b>' . $std->xMotivo . '</b>

            ');

        } catch (\Exception $e) {
            echo $e->getMessage();
        }
    }
} /// final
