<?php

use Adianti\Widget\Dialog\TMessage;
use NFePHP\Common\Certificate;
use NFePHP\NFe\Common\Standardize;
use NFePHP\NFe\Tools;

class ConsultarNFe
{
    private $tools;
    private $key;
    private static $database = 'kraftsoft';
    private $DocumentoFiscal;
    public function __construct($key)
    {
        $this->key = $key;
    }
    /**
     * Classe consulta NF-e para obtenção do Chave
     *
     * Autor: Rubens dos Santos
     * Email: salvadorbba@gmail.com
     * Celular: (12) 99675-8056
     *
     * nfephp-org/sped-da:dev-master
     * nfephp-org/sped-mail:^1.0
     * nfephp-org/sped-nfe:^5.0
     * https://github.com/nfephp-org
     */
    public function Seach()
    {

        try {

            TTransaction::open(self::$database);
            $this->emitente = SystemUnit::find(TSession::getValue('userunitid'));
            $this->DocumentoFiscal = Notafiscal::find($this->key);
            TTransaction::close();

            $config = [
                'atualizacao' => date('Y-m-d H:i:s'),
                'tpAmb' => (int) $this->emitente->nfe_tpamb_id,
                'razaosocial' => $this->emitente->razao_social,
                'cnpj' => $this->emitente->cnpj, // PRECISA SER VÁLIDO
                'ie' => $this->emitente->inscricao_estadual, // PRECISA SER VÁLIDO
                'siglaUF' => $this->emitente->end_uf,
                'schemes' => 'PL_009_V4',
                'versao' => '4.00',
            ];

            $configJson = json_encode($config);
            $this->tools = new Tools(
                $configJson,
                Certificate::readPfx(file_get_contents($this->emitente->certificadoA1), $this->emitente->senha_certificado)

            );
            $this->tools->model('55');

            $response = $this->tools->sefazConsultaChave($this->DocumentoFiscal->chave);
            
  
            $stdCl = new Standardize($response);
            $std = $stdCl->toStd();
      
            if(isset($std->infProt->cStat)){
                 if($std->infProt->cStat==656){
                // Código gerado pelo snippet: "Exibir mensagem"
           new TMessage('info', '<br>Atenção Erro<br>'.$std->infProt->xMotivo);
       return;
   }
                
            }
            if (!isset($std->procEventoNFe->evento->infEvento)) {
                $info_cosulta = $std->protNFe->infProt;

                new TMessage('info',
                    '

           <b>Chave: </b>' . $info_cosulta->chNFe . '<br>
           <b>Data Recibo: </b>' . $info_cosulta->dhRecbto . '<br>
           <b>Protocolo: </b>' . $info_cosulta->nProt . '<br>
           <b>Digval: </b>' . $info_cosulta->digVal . '<br>
           <b>Código de retorno: </b> ' . $info_cosulta->cStat . '<hr>
           <b>Retorno Sefaz:</b> ' . $info_cosulta->xMotivo . '


           ');

            } else {

                $info_cosulta = $std->procEventoNFe->evento->infEvento;

                new TMessage('info',
                    '

           <b>Chave: </b>' . $info_cosulta->chNFe . '<br>
           <b>Data Recibo: </b>' . $info_cosulta->dhRecbto . '<br>
           <b>Protocolo: </b>' . $info_cosulta->detEvento->nProt . '<br>
           <b>Digval: </b>' . $info_cosulta->digVal . '<br>
           <b>Código de retorno: </b> ' . $info_cosulta->cStat . '<hr>
           <b>Retorno Sefaz:</b> ' . $info_cosulta->descEvento->xMotivo . '


           ');

            }

        } catch (\Exception $e) {

            echo $e->getMessage();

        }

    }

}
