<?php

use NFePHP\Common\Certificate;
use NFePHP\NFe\Make;
use NFePHP\NFe\Tools;

class GeraDocumentoNFe
{

    private $key;
    private $vendas;
    private $emitente;
    private $tools;
    private $DocumentoFiscal;
    private $carrinho_itens;
    private $cliente;
    private $NaturezaOp;
    private $endereco;
    private $cidade;
    private $estado;
    private $duplicata;

    private $nota_itens;
    private static $database = 'kraftsoft';

    public function __construct($key)
    {
        $this->key = $key;
    }

    public function create()
    {

        try {

            TTransaction::open(self::$database);
            $this->emitente = SystemUnit::find(TSession::getValue('userunitid'));
            $this->DocumentoFiscal = Notafiscal::find($this->key);

            $this->nota_itens = cloudDFE_NFE::montaItensNota($this->DocumentoFiscal);
            TTransaction::close();

            $config = [
                'atualizacao' => date('Y-m-d H:i:s'),
                'tpAmb' => (int) $this->emitente->nfe_tpamb_id,
                'razaosocial' => $this->emitente->razao_social,
                'cnpj' => $this->emitente->cnpj, // PRECISA SER VÁLIDO
                'ie' => $this->emitente->inscricao_estadual, // PRECISA SER VÁLIDO
                'siglaUF' => $this->emitente->end_uf,
                'schemes' => 'PL_009_V4',
                'versao' => '4.00',
            ];

            $configJson = json_encode($config);
            $this->tools = new Tools(
                $configJson,
                Certificate::readPfx(file_get_contents($this->emitente->certificadoA1), $this->emitente->senha_certificado)

                //falta implementar do cloud nfe ****
            );

            $nfe = new Make();
            $std = new \stdClass();

            $std->versao = '4.00';
            $std->Id = null;
            $std->pk_nItem = '';
            $nfe->taginfNFe($std);

            $std = new \stdClass();
            $std->cUF = 35; //coloque um código real e válido
            $std->cNF = '80070008';
            $std->natOp = 'VENDA';
            $std->mod = 55;
            $std->serie = 1;
            $std->nNF = 10;
            $std->dhEmi = '2018-07-27T20:48:00-02:00';
            $std->dhSaiEnt = '2018-07-27T20:48:00-02:00';
            $std->tpNF = 1;
            $std->idDest = 1;
            $std->cMunFG = 3506003; //Código de município precisa ser válido
            $std->tpImp = 1;
            $std->tpEmis = 1;
            $std->cDV = 2;
            $std->tpAmb = 2; // Se deixar o tpAmb como 2 você emitirá a nota em ambiente de homologação(teste) e as notas fiscais aqui não tem valor fiscal
            $std->finNFe = 1;
            $std->indFinal = 0;
            $std->indPres = 0;
            $std->procEmi = '0';
            $std->verProc = 1;
            $nfe->tagide($std);

            $std = new \stdClass();
            $std->xNome = 'Razão social válida';
            $std->IE = 'IE válido';
            $std->CRT = 3;
            $std->CNPJ = 'CNPJ válido';
            $nfe->tagemit($std);

            $std = new \stdClass();
            $std->xLgr = "Rua Teste";
            $std->nro = '203';
            $std->xBairro = 'Centro';
            $std->cMun = 3506003; //Código de município precisa ser válido e igual o  cMunFG
            $std->xMun = 'Bauru';
            $std->UF = 'SP';
            $std->CEP = '80045190';
            $std->cPais = '1058';
            $std->xPais = 'BRASIL';
            $nfe->tagenderEmit($std);

            $std = new \stdClass();
            $std->xNome = 'Empresa destinatário teste';
            $std->indIEDest = 2;
            $std->IE = 'IE válido';
            $std->CNPJ = 'CNPJ válido';
            $nfe->tagdest($std);

            $std = new \stdClass();
            $std->xLgr = "Rua Teste";
            $std->nro = '203';
            $std->xBairro = 'Centro';
            $std->cMun = '3506003';
            $std->xMun = 'Bauru';
            $std->UF = 'SP';
            $std->CEP = '80045190';
            $std->cPais = '1058';
            $std->xPais = 'BRASIL';
            $nfe->tagenderDest($std);

            $item_ordem = 0;
            foreach ($this->nota_itens as $item_prod):
                // return$item_prod;
                $icms = $item_prod['imposto']['icms'];

                $stdProd = new stdClass();
                $stdProd->item = $item_prod['numero_item'];
                $stdProd->cEAN = $item_prod['codigo_barras_comercial'] ?? 'SEM GTIN';
                $stdProd->cEANTrib = $item_prod['codigo_barras_tributavel'] ?? 'SEM GTIN';
                $stdProd->cProd = $item_prod['codigo_produto'] ?? 1;
                $stdProd->xProd = $item_prod['descricao'];
                $stdProd->NCM = $item_prod['codigo_ncm'];
                $stdProd->CFOP = $item_prod['cfop'];
                $stdProd->uCom = $item_prod['unidade_comercial'];
                $stdProd->qCom = $item_prod['quantidade_comercial'];
                $stdProd->vUnCom = $item_prod['valor_unitario_comercial'];
                $stdProd->vProd = $item_prod['valor_bruto'];
                $stdProd->uTrib = $item_prod['unidade_tributavel'];
                $stdProd->qTrib = $item_prod['quantidade_tributavel'];
                $stdProd->vUnTrib = $item_prod['valor_unitario_tributavel'];
                $stdProd->indTot = 1;
                $nfe->tagprod($stdProd);

                $std = new stdClass();
                $std->item = $item_ordem;
                $std->vTotTrib = 10.99;
                $nfe->tagimposto($std);
                $stdICMS = new stdClass();
                $stdICMS->item = $item_ordem;
                $stdICMS->orig = $item_prod['origem'];
                $stdICMS->CST = $icms['situacao_tributaria'];
                if (isset($item_prod->fcp_pfcp)) {

                    $stdICMS->modBC = $icms['modalidade_base_calculo'];
                    $stdICMS->vBC = $icms['valor_base_calculo'];
                    $stdICMS->pICMS = $icms['aliquota'];
                    $stdICMS->vICMS = $icms['valor'];

                } else {

                    $stdICMS->pFCP = $icms['aliquota'];
                    $stdICMS->vFCP = $icms['valor'];
                    $stdICMS->vBCFCP = $icms['valor_base_calculo'];

                    $stdICMS->vBCFCPST = $icms['valor_base_calculo_st'];
                    $stdICMS->pFCPST = $icms['aliquota_st'];
                    $stdICMS->vFCPST = $icms['valor_st'];

                    $stdICMS->pFCPSTRet = $icms['aliquota_retido_st'];
                    $stdICMS->vFCPSTRet = $icms['valor_retido_st'];

                }
                $nfe->tagICMS($stdICMS);

                return $stdICMS;

                $std = new stdClass();
                $std->item = $item_ordem;
                $std->cEnq = '999';
                $std->CST = '50';
                $std->vIPI = 0;
                $std->vBC = 0;
                $std->pIPI = 0;
                $nfe->tagIPI($std);

                $std = new stdClass();
                $std->item = $item_ordem;
                $std->CST = '07';
                $std->vBC = 0;
                $std->pPIS = 0;
                $std->vPIS = 0;
                $nfe->tagPIS($std);

                $std = new stdClass();
                $std->item = $item_ordem;
                $std->vCOFINS = 0;
                $std->vBC = 0;
                $std->pCOFINS = 0;

                $nfe->tagCOFINSST($std);

                $std = new stdClass();
                $std->item = $item_ordem;
                $std->CST = '01';
                $std->vBC = 0;
                $std->pCOFINS = 0;
                $std->vCOFINS = 0;
                $std->qBCProd = 0;
                $std->vAliqProd = 0;
                $nfe->tagCOFINS($std);

            endforeach;

            $std = new stdClass();
            $std->vBC = '0.20';
            $std->vICMS = 0.04;
            $std->vICMSDeson = 0.00;
            $std->vBCST = 0.00;
            $std->vST = 0.00;
            $std->vProd = 10.99;
            $std->vFrete = 0.00;
            $std->vSeg = 0.00;
            $std->vDesc = 0.00;
            $std->vII = 0.00;
            $std->vIPI = 0.00;
            $std->vPIS = 0.00;
            $std->vCOFINS = 0.00;
            $std->vOutro = 0.00;
            $std->vNF = 11.03;
            $std->vTotTrib = 0.00;
            $nfe->tagICMSTot($std);

            $std = new \stdClass();
            $std->modFrete = 1;
            $nfe->tagtransp($std);

            $std = new \stdClass();
            $std->item = 1;
            $std->qVol = 2;
            $std->esp = 'caixa';
            $std->marca = 'OLX';
            $std->nVol = '11111';
            $std->pesoL = 10.00;
            $std->pesoB = 11.00;
            $nfe->tagvol($std);

            $std = new \stdClass();
            $std->nFat = '002';
            $std->vOrig = 100;
            $std->vLiq = 100;
            $nfe->tagfat($std);

            $std = new \stdClass();
            $std->nDup = '001';
            $std->dVenc = date('Y-m-d');
            $std->vDup = 11.03;
            $nfe->tagdup($std);

            $std = new \stdClass();
            $std->vTroco = 0;
            $nfe->tagpag($std);

            $std = new \stdClass();
            $std->indPag = 0;
            $std->tPag = "01";
            $std->vPag = 10.99;
            $std->indPag = 0;
            $nfe->tagdetPag($std);

        } catch (\Exception $e) {

            new TMessage('info', $e->getMessage());

        }

    }}
