<?php

//CorePrintNFCe::print($id,$serie,$nota);
use NFePHP\DA\NFe\Danfce;

class ImprimirNFCe
{

    private static $database = 'kraftsoft';
    private $tools;
     private $vendas;

    /**

     * Class Constructor ImprimirNFCe imprimir

     */

     public function __construct($key)
    {
        $this->key = $key;
    }
   public function imprimir() {

        #######conector e configuração da nfe##########
        TTransaction::open('kraftsoft');
        $this->vendas = Notafiscal::find($this->key );
        TTransaction::close();

        // Obter o XML da Nota Fiscal

        if (isset($this->vendas->xml_cancelamento)) {

            $xml = $this->vendas->xml_cancelamento;
        } else {
            $xml =  $this->vendas->xml;

            $xml = base64_decode($xml);
        }
        #######conector e configuração da nfe##########

        
        try {
            
        
                $logo = '';
 
            $danfce = new Danfce($xml);
            $danfce->debugMode(true); //seta modo debug, deve ser false em produção
            $danfce->setPaperWidth(80); //seta a largura do papel em mm max=80 e min=58
            $danfce->setMargins(2); //seta as margens
            $danfce->setDefaultFont('arial'); //altera o font pode ser 'times' ou 'arial'
            //$danfce->setOffLineDoublePrint(true); //ativa ou desativa a impressão conjunta das via do consumidor e da via do estabelecimento qnado a nfce for emitida em contingência OFFLINE
            // $danfce->setPrintResume(true); //ativa ou desativa a impressao apenas do resumo
            $danfce->setViaEstabelecimento(); //altera a via do consumidor para a via do estabelecimento, quando a NFCe for emitida em contingência OFFLINE
            //
            if ($this->vendas->status_id == 3) {
                $danfce->setAsCanceled(); //força marcar nfce como cancelada
            }
            $danfce->creditsIntegratorFooter('ARON Sistemas - http://www.aronsistemas.com.br');

            header('Content-Type: application/pdf');
            $logo = $danfce->render($logo);

            $path="app/output/NFCe/";
            if (is_dir($path)) {
            } else {mkdir($path, 0777, true);
            }

            $pdfnome =   $path .  $this->vendas->chave . ".pdf";
            file_put_contents($pdfnome, $logo);
            $pdfview = new HFileViewer();
            $pdfview->setFile($pdfnome);
            $pdfview->show();
        } catch (\Exception $e) {
            echo $e->getMessage();
        }

    }

}
