<?php

use NFePHP\DA\NFe\Danfe;

/**
 * Classe para geração e impressão de Danfe a partir de uma NFe.
 *
 * Autor: Rubens dos Santos
 * Email: salvadorbba@gmail.com
 * Celular: (12) 99675-8056
 */
class ImprimirNFe
{
    /**
     * Gera e imprime o DANFE a partir da chave de uma NFe.
     *
     * @param string $key Chave da Nota Fiscal Eletrônica (NFe).
     */
    public static function print($key)
    {
        // Abrir transação para obter informações da Nota Fiscal
        TTransaction::open('kraftsoft');
        $vendas = Notafiscal::find($key);
        TTransaction::close();

        // Obter o XML da Nota Fiscal

        if (isset($vendas->xml_cancelamento)) {

            $xml = $vendas->xml_cancelamento;
        } else {
            $xml = $vendas->xml;
            $xml = base64_decode($xml);
        }
        // Logo da empresa (pode ser vazio se não houver)
        $logo = '';
      if($vendas->notafiscal_mod_id==1){
        // Gerando o PDF do DANFE
        $danfe = new Danfe($xml);
        $danfe->debugMode(false);
        $danfe->creditsIntegratorFooter('Nota Fiscal 4.0 - http://kraftsoft.com.br');
        $danfe->obsContShow(false);
        $arq = $danfe->render($logo);
        
              }else{
        
              $xmlResult = new ImprimirNFCe(144);
               $response=  $xmlResult->imprimir();
               
               return;
              }
        

        // Salvar o PDF gerado
        $path = "app/output/pdf/NFe/";
        if (is_dir($path)) {
        } else {
            mkdir($path, 0777, true);
        }

        $pdfnome = $path . $vendas->chave . ".pdf";
        file_put_contents($pdfnome, $arq);

        // Exibir o PDF gerado
        $pdfview = new HFileViewer();
        $pdfview->setFile($pdfnome);
        $pdfview->show();
    }
}
