<?php

use NFePHP\Common\Certificate;
use NFePHP\NFe\Common\Standardize;
use NFePHP\NFe\Tools;

/**
 * Classe Gera  carata de corerção obtenção do XML
 *
 * Autor: Rubens dos Santos
 * Email: salvadorbba@gmail.com
 * Celular: (12) 99675-8056
 */
class InutilizaSpedNFeOne
{
    private $key;
    private $vendas;
    private $emitente;
    private $tools;
    private $nota;
    private $cliente;
    private $inutilizar;

    private $PedidoEvento;
    private static $database = 'kraftsoft';

    /**
     * Construtor da classe GeraNFe.
     *
     * @param string $key - A chave para buscar os parâmetros no banco de dados.
     */
    public function __construct($key)
    {
        $this->key = $key;
    }

    /**
     * Função para criar e obter um token de autenticação do Sicredi.
     *
     * @return string - O token de acesso obtido.
     */
    public function inutone()
    {

        try {
            // Abrir uma transação de banco de dados no contexto 'agendamentos'.
            TTransaction::open(self::$database);
            $this->inutilizar = Notafiscal::find($this->key);
            $this->emitente = SystemUnit::find(TSession::getValue('userunitid'));
            $nNFIni = $this->inutilizar->numero;
            $nNFFin = $this->inutilizar->numero;
            //  $numero='';
            // $objeto = Notafiscal::where('numero', '>=',$nNFIni )->
            // where('numero', '<=',$nNFFin )->get();

            TTransaction::close();

            $config = [
                'atualizacao' => date('Y-m-d H:i:s'),
                'tpAmb' => (int) $this->emitente->nfe_tpamb_id,
                'razaosocial' => $this->emitente->razao_social,
                'cnpj' => $this->emitente->cnpj, // PRECISA SER VÁLIDO
                'ie' => $this->emitente->inscricao_estadual, // PRECISA SER VÁLIDO
                'siglaUF' => $this->emitente->end_uf,
                'schemes' => 'PL_009_V4',
                'versao' => '4.00',
            ];
 
            $configJson = json_encode($config);
            $this->tools = new Tools(
                $configJson,
                Certificate::readPfx(file_get_contents($this->emitente->certificadoA1), $this->emitente->senha_certificado)
            );
 
            $nSerie = $this->inutilizar->serie;
            $nIni = $this->inutilizar->numero;
            $nFin = $this->inutilizar->numero;
            $xJust = 'Erro de digitação dos números sequencias das notas';




            ///// inutilizar junto a sefaz
            $response = $this->tools->sefazInutiliza($nSerie, $nIni, $nFin, $xJust);
            $stdCl = new Standardize($response);
            $std = $stdCl->toStd();
           
         TTransaction::open(self::$database);
            if ($std->infInut->cStat == 102) {
                $objeto = InutilizarNumero::find($this->key);
                if ($objeto) {
                    $objeto->cstat = $std->infInut->cStat;
                    $objeto->protocolo = $std->infInut->nProt;
                    $objeto->xml_retorno = $response;
                    $objeto->xmotivo = $std->infInut->xMotivo;
                    $objeto->tipo = 2;
                    $objeto->store();
                }

                $message = "Código: " . $std->infInut->cStat . "<br>" .
                "Motivo: " . $std->infInut->xMotivo . "<br>" .
                "UF: " . $std->infInut->cUF . "<br>" .
                "Ano: " . $std->infInut->ano . "<br>" .
                "CNPJ: " . $std->infInut->CNPJ . "<br>" .
                "Modelo: " . $std->infInut->mod . "<br>" .
                "Série: " . $std->infInut->serie . "<br>" .
                "Número Inicial: " . $std->infInut->nNFIni . "<br>" .
                "Número Final: " . $std->infInut->nNFFin . "<br>" .
                "Data de Recebimento: " . $std->infInut->dhRecbto . "<br>" .
                "Número de Protocolo: " . $std->infInut->nProt;
                //  TTransaction::open(self::$database);

                if ($std->infInut->cStat == 102) {

                    $objeto1 = Notafiscal::find($this->inutilizar->id);
                    if ($objeto1) {

                        $objeto1->status = 'Inutilizada';
                        $objeto1->inutilizar = 2;
                        $objeto1->notafiscal_situacao_id = 7;
                        $objeto1->mensagem = $std->infInut->xMotivo . ' - ' . $std->infInut->nProt;

                        $objeto1->store();
                    }


        sleep(1);
                
                $objeto_n = new InutilizarNumero();
                $objeto_n->cstat = $std->infInut->cStat;
                $objeto_n->protocolo = $std->infInut->nProt;
                $objeto_n->xml_retorno = $response;
                $objeto_n->xmotivo = $std->infInut->xMotivo;
                $objeto_n->created_at = date('Y-m-d H:i:s');
                $objeto_n->ninicio =  $std->infInut->nNFIni;
                $objeto_n->nfinal = $std->infInut->nNFFin;
                $objeto_n->serie = $this->inutilizar->serie;
                $objeto_n->system_unit_id =TSession::getValue('userunitid');   
                $objeto_n->system_users_id = TSession::getValue('userid');
                $objeto_n->xjust =  $xJust ;
                      $objeto_n->tipo =  2 ;     
                    $objeto_n->store();



 

 sleep(1);



                    //////alterar sequencia
                    $Numero_nota = NotafiscalSeries::where('notafiscal_mod_id', '=', 1)->
                        where('system_unit_id', '=', TSession::getValue('userunitid'))->first();

                    if ($Numero_nota) {
                        $Numero_nota->notafiscal_tpamb_id = $this->emitente->nfe_tpamb_id;
                        $Numero_nota->alterado_por = TSession::getValue('userid');
                        $Numero_nota->alterado_em = date('Y-m-d H:i:s');
                        $Numero_nota->sequencial = $std->infInut->nNFFin;
                        $Numero_nota->store();
                    }
                }

                TTransaction::close();
                sleep(3);

                $pageParam = []; // ex.: = ['key' => 10]

                TApplication::loadPage('NotafiscalList', 'onShow', $pageParam);

            } else {

                $message = "Código: " . $std->infInut->cStat . "<br>" .
                "Motivo: " . $std->infInut->xMotivo . "<br>" .
                "UF: " . $std->infInut->cUF . "<br>" .
                "Data de Recebimento: " . $std->infInut->dhRecbto . "<br>";

                // Display the message with line breaks

            }

            new TMessage('info', $message);
        } catch (\Exception $e) {

            return $e->getMessage();
        }
    }
}
