<?php

use Adianti\Database\TTransaction;
use Mpdf\Mpdf;
use Mpdf\QrCode\Output;

class ReciboCartaCorrecaoNFe
{
    private static $database = 'kraftsoft';

    private $key;
    private $vendas;
    private $emitente;
    
     private $cliente;
    /**

     * Class Constructor  ReciboCartaCorrecaoNFe ReciboCarta

     */

    public function __construct($key)
    {
        $this->key = $key;

    }

    public function ReciboCarta()
    {

        #######conector e configuração da nfe##########

        TTransaction::open(self::$database);

         $this->vendas = Notafiscal::find($this->key);
         $this->pedido = PedidoEvento::where('notafiscal_id', '=', $this->vendas->id)
                                    ->orderBy('id', 'desc') // Ordena pelos IDs em ordem decrescente
                                    ->first();

 
        $this->emitente = SystemUnit::find(TSession::getValue('userunitid'));
       $eventos = $this->pedido;
       
       
     $this->cliente = Cliente::find($this->vendas->cliente_id);
        TTransaction::close();
        #######conector e configuração da nfe##########
        // HTML
        function formataTelefone($numero)
        {
            if (strlen($numero) == 10) {
                $novo = substr_replace($numero, '(', 0, 0);
                $novo = substr_replace($novo, '9', 3, 0);
                $novo = substr_replace($novo, ')', 3, 0);
            } else {
                $novo = substr_replace($numero, '(', 0, 0);
                $novo = substr_replace($novo, ')', 3, 0);
            }
            return $novo;
        }
        $generatorHTML = new Picqer\Barcode\BarcodeGeneratorHTML();

 
        $generatorPNG = new Picqer\Barcode\BarcodeGeneratorPNG();
        $bar_code = $generatorPNG->getBarcode($this->pedido->chave, $generatorPNG::TYPE_CODE_128, 2, 50, [0, 0, 0]);
        $img_base64 = base64_encode($bar_code);
        $barra = '<img src="data:image/png;base64,' . $img_base64 . '">';
        $mpdf = new Mpdf();
        $html = '

 

		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%">
<tbody>
	<tr>
		<td>
			<h3 style="text-align: center;">
			<center>	<span style="font-size:16px;"><strong style="font-size: 16px;"><span style="font-family: arial, helvetica, sans-serif;">Representa&ccedil;&atilde;o Gr&aacute;fica de CC-e</span></strong></span></h3>
	<hr>

                        </center>

                        </td>
	</tr>
</tbody>

		</table>

		<table border="0" cellpadding="0" cellspacing="0" style="width: 100%">
<tbody>
	<tr>
		<td>
			<h3>
				<strong style="font-size: 12px;"><span style="font-family:arial,helvetica,sans-serif;">' . $this->emitente->razao_social . '</span></strong></h3>
			<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">CNPJ:' .   ( $this->emitente->cnpj) . '</span></span></div>
			<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Endereço: ' . $this->emitente->end_logradouro. '</span></span></div>
				<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Número:: ' .  $this->emitente->end_numero . '</span></span></div>
				<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Bairro: ' .  $this->emitente->end_bairro. '</span></span></div>
				<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">CEP: ' . $this->emitente->end_cep . '</span></span></div>
			<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Cidade: ' .  $this->emitente->end_municipio . '</span></span></div>
			<div>
			 


		</td>


		<td>
		<div>
		<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;"> Cóigo #: ' .  $this->pedido->id . '</span></span></div>
		<div>
	 
		<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;"> Nome evento: ' . $this->pedido->xevento . '</span></span></div>
				<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Sequencia: ' .  $this->pedido->nseqevento . '</span></span></div>
				<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Protocolo Original: ' .  $this->pedido->protocolo . '</span></span></div>
			<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;"></span></span></div>
			<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Criado em : ' .  $this->pedido->created_at . '</span></span></div>
			<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Prococolo resposta: ' . $this->pedido->protocolo_resposta . '</span></span></div>
			<div>
				<span style="font-size:12px;"><span style="font-family:arial,helvetica,sans-serif;">Registrado na SEFAZ em:  ' . $this->pedido->update_at . '</span></span></div>
				
				
				
		</td>


	</tr>
</tbody>



		</table>

        <hr>

		<table border="0" cellpadding="1" cellspacing="1" style="width: 100%">
<tbody>
	<tr>
		<td>
			<p>



        <br />
				<span style="font-size:12px;" style="font-family:arial,helvetica,sans-serif;">De acordo com as determina&ccedil;&otilde;es legais vigentes, vimos por meio desta comunicar-lhe que a Nota Fiscal, abaixo referenciada, cont&eacute;m irregularidades que est&atilde;o destacadas e suas respectivas corre&ccedil;&otilde;es, solicitamos que sejam aplicadas essas corre&ccedil;&otilde;es ao executar seus lan&ccedil;amentos fiscais</span></em></span><br />


			<table border="0" cellpadding="1" cellspacing="1" style="width: 100%">
				<tbody>
					<tr>
						<td><hr>
							<br />
							<strong>Nome do Destinat&aacute;rio:</strong>' . $this->cliente->nome . '<br />
							<strong>CNPJ do Destinat&aacute;rio:</strong>' . $this->cliente->cpf_cnpj . '<br />
							<strong>Nota Fiscal: </strong> ' .  $this->pedido->numero . ' - S&eacute;rie: ' . $this->pedido->serie . '<br />

						  <hr>



                                        </td>
					</tr>
					<tr>
						<td style="text-align: center;">
							' . $barra . '</td>
					</tr>
					<tr>
						<td style="text-align: center;">
							<b>' . $this->pedido->chave . '</b>


							</td>
					</tr>
				</tbody>
			</table>






			<table border="0" cellpadding="0" cellspacing="0" style="width: 100%">
				<tbody>
					<tr>
						<td>
							<br />
							<hr>
							<span style="font-size:12px;" style="font-family:arial,helvetica,sans-serif;"><em>A Carta de Correcao e disciplinada pelo paragrafo 1o-A do art. 7o do Convenio S/N, de 15 de dezembro de 1970 e pode ser utilizada para regularizacao de erro ocorrido na emissao de documento fiscal, desde que o erro nao esteja relacionado com: I - as variaveis que determinam o valor do imposto tais como: base de calculo, aliquota, diferenca de preco, quantidade, valor da operacao ou da prestacao; II - a correcao de dados cadastrais que implique mudanca do remetente ou do destinatario; III - a data de emissao ou de saida.</em></span><br />
							<br />

                                        <hr></td>
					</tr>
				</tbody>
			</table>
			<p>
				<strong>CORRE&Ccedil;&Otilde;ES A SEREM CONSIDERADAS</strong></p>
								
			<table border="0" cellpadding="0" cellspacing="0" style="width: 100%">
				<tbody>
					<tr>
						<td>
								'.$this->pedido->descricao.'<br />
							<br />
							<hr />
							<p>
								<br />
								<span style="font-size:12px;" style="font-family:arial,helvetica,sans-serif;">Este documento &eacute; uma representa&ccedil;&atilde;o gr&aacute;fica da CC-e e foi impresso apenas para sua informa&ccedil;&atilde;o e N&Atilde;O possui validade fiscal. A CC-e deve ser recebida e mantida em arquivo eletr&ocirc;nico XML e pode ser consultada atrav&eacute;s dos Portais das SEFAZ.</span><br />
								<hr></p>
						</td>
					</tr>
				</tbody>
			</table>
		</td>
	</tr>
</tbody>

		</table> <P>

 GERAÇÃO: ' . date('d/m/Y H:i:s') . '<br>PROTOCOLO: ' . $eventos->protocolo_resposta . ' <br><H3 style="color:RED;">ATENÇÃO:</H3>Documento não possui validade fiscal.<br>

 Selicite o Danfe corrrespondente a Nota fiscal nº ' .$this->pedido->numero. ' serie ' .  $this->pedido->serie. ' <br>

 Chave: ' .  $this->pedido->chave . '



        ';

        $path = "app/output/";
        $nome = mt_rand(1000000000, 1999999999) . ".pdf";
        $paths = "app/output/";
        $caminho = $path . $nome;
        $mpdf->SetHeader('COMPROVANTE DE CARTA DE CORREÇÃO ');
        $mpdf->WriteHTML($html);
        $mpdf->SetFooter('ARON SISTEMAS DE AUTOMAÇÃO V1.0.3');
//    $mpdf->SetProtection(array(), 'UserPassword',123);
        if ($empresa->ambiente == 2) {
            $mpdf->SetWatermarkText('Ambiente de ' . $Ambiente);} else {

        }
        $mpdf->showWatermarkText = true;
        $arquivo = $mpdf->Output($caminho, 'F');
        $pdfview = new HFileViewer();
        $pdfview->setFile($caminho);
        $pdfview->show();
        $pasta = $path; //NOME DA PASTA
        if (is_dir($pasta)) //VERIFICA SE REALMENTE É UM DIRETORIO
        {
            $resultado = '';
            $types = array('pdf');
            if ($handle = opendir($pasta)) {
                while ($entry = readdir($handle)) {
                    $ext = strtolower(pathinfo($entry, PATHINFO_EXTENSION));
                    if (in_array($ext, $types)) {
                        if ($entry == $nome) {
                        } else {
                            $resultado = unlink($pasta . $entry);
                        }
                    }
                }
            }

//            $resultado = unlink($pasta.$entry);
        }
        closedir($handle);

    }

}
