 
		   <?php

use Adianti\Database\TTransaction;
use Adianti\Widget\Dialog\TMessage;
use NFePHP\DA\NFe\Danfe;
use NFePHP\Mail\Mail;

class SendEmailNFE
{
    private $key;
    private $vendas;
    private $emitente;
    private $cliente;

    private static $database = 'kraftsoft';

    public function __construct($key)
    {
        $this->key = $key;
    }

    public function send()
    {
        try {
            TTransaction::open(self::$database);

            // Load relevant information based on the ID
           $this->vendas = Notafiscal::find($this->key);
 
         $this->emitente = SystemUnit::find(TSession::getValue('userunitid'));
          $this->cliente = Cliente::find($this->vendas->cliente_id);
            
            if(!isset($this->cliente->email)){
  
        $messageContent = 'Não é possível enviar email, pois o cliente não possui um endereço de email válido.<hr>';
        $messageContent .=  $this->cliente->nome;
        new TMessage('info', $messageContent);
        
    
    $pageParam = []; // ex.: = ['key' => 10]
    
    TApplication::loadPage('NotafiscalList', 'onShow', $pageParam);

        exit;

            }
            
                     $xmlBase64 = $this->vendas->xml;
                    
                    // Decodificar o XML base64
                    $xmlDecoded = base64_decode($xmlBase64);
                    
                    // Carregar o XML decodificado
                    $xml = simplexml_load_string($xmlDecoded);
                    
                    // Se desejar, você pode converter o objeto SimpleXMLElement em um formato mais legível
                    $xmlFormatted = $xml->asXML();
 
            // Configure email information
            $config = new stdClass();
            $config->host = $this->emitente->config_host;
            $config->user = $this->emitente->config_user;
            $config->password = $this->emitente->config_password;
            $config->secure = 'tls';
            $config->port = $this->emitente->config_port;
            $config->from = $this->emitente->config_user;
            $config->fantasy = $this->emitente->config_replyname;
            $config->replyTo = $this->emitente->config_user;
            $config->replyName = $this->emitente->config_replyname;
            $config->smtpdebug = 0;
            $config->smtpauth = true;
            $config->authtype = '';
            $config->smtpoptions = null;
            $config->timeout = 130;

            $mail = new Mail($config);

            $htmlTemplate = '';

            $path = "app/XML/NF-e";
            if (!is_dir($path)) {
                mkdir($path, 0777, true);
            }
            $xml = $path . '/' . $this->vendas->chave . '-nfe.xml';
            $response = file_put_contents($xml, $xmlFormatted);

            $logo = $this->emitente->logomarca ?? ''; // Use null coalescing operator for logo

            $xmls = file_get_contents($xml);

            $danfe = new Danfe($xmls);
            $danfe->debugMode(false);
            $danfe->creditsIntegratorFooter('Nota Fiscal 4.0 - http://developerapi.com.br');
            $danfe->obsContShow(false);
            $pdf = $danfe->render($logo);

            $mail->loadDocuments($xml, $pdf);

            // Email addresses of recipients
        $addresses = [$this->cliente->email];
       
            // Send the email
            $email = $mail->send($addresses, true);

            // Display success message
            TTransaction::close();

            new TMessage(
                'info',
                '<h3>E-mail enviado com Sucesso!</h3>' .
                "<b>Dados NFE: </b> " . $this->cliente->nome . '<br>' .
                "<b>E-mail: </b>" . $this->cliente->email . '<hr>' .
                "<b>Chave da NFe: </b>" . $this->vendas->chave . '<br>' . '<br>'
            );

        } catch (\Exception $e) {
            // Error handling
            new TMessage(
                'error',
                $e->getMessage() . '<hr>Provavelmente este problema é referente a problemas de configuração ou de conexão com servidor SMTP.'
            );
        }
    }
}

