<?php

class Caixa extends TRecord
{
    const TABLENAME  = 'caixa';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $caixa_situacao;
    private $system_users_abertura;
    private $system_users_operador;
    private $system_users_fechamento;
    private $system_unit;

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('caixa_situacao_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('system_users_abertura_id');
        parent::addAttribute('system_users_operador_id');
        parent::addAttribute('system_users_fechamento_id');
        parent::addAttribute('data_hora_abertura');
        parent::addAttribute('data_hora_fechamento');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_caixa_situacao
     * Sample of usage: $var->caixa_situacao = $object;
     * @param $object Instance of CaixaSituacao
     */
    public function set_caixa_situacao(CaixaSituacao $object)
    {
        $this->caixa_situacao = $object;
        $this->caixa_situacao_id = $object->id;
    }

    /**
     * Method get_caixa_situacao
     * Sample of usage: $var->caixa_situacao->attribute;
     * @returns CaixaSituacao instance
     */
    public function get_caixa_situacao()
    {
    
        // loads the associated object
        if (empty($this->caixa_situacao))
            $this->caixa_situacao = new CaixaSituacao($this->caixa_situacao_id);
    
        // returns the associated object
        return $this->caixa_situacao;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users_abertura(SystemUsers $object)
    {
        $this->system_users_abertura = $object;
        $this->system_users_abertura_id = $object->id;
    }

    /**
     * Method get_system_users_abertura
     * Sample of usage: $var->system_users_abertura->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users_abertura()
    {
    
        // loads the associated object
        if (empty($this->system_users_abertura))
            $this->system_users_abertura = new SystemUsers($this->system_users_abertura_id);
    
        // returns the associated object
        return $this->system_users_abertura;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users_operador(SystemUsers $object)
    {
        $this->system_users_operador = $object;
        $this->system_users_operador_id = $object->id;
    }

    /**
     * Method get_system_users_operador
     * Sample of usage: $var->system_users_operador->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users_operador()
    {
    
        // loads the associated object
        if (empty($this->system_users_operador))
            $this->system_users_operador = new SystemUsers($this->system_users_operador_id);
    
        // returns the associated object
        return $this->system_users_operador;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users_fechamento(SystemUsers $object)
    {
        $this->system_users_fechamento = $object;
        $this->system_users_fechamento_id = $object->id;
    }

    /**
     * Method get_system_users_fechamento
     * Sample of usage: $var->system_users_fechamento->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users_fechamento()
    {
    
        // loads the associated object
        if (empty($this->system_users_fechamento))
            $this->system_users_fechamento = new SystemUsers($this->system_users_fechamento_id);
    
        // returns the associated object
        return $this->system_users_fechamento;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getCaixaLancamentoss
     */
    public function getCaixaLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('caixa_id', '=', $this->id));
        return CaixaLancamentos::getObjects( $criteria );
    }

    public function set_caixa_lancamentos_caixa_to_string($caixa_lancamentos_caixa_to_string)
    {
        if(is_array($caixa_lancamentos_caixa_to_string))
        {
            $values = Caixa::where('id', 'in', $caixa_lancamentos_caixa_to_string)->getIndexedArray('id', 'id');
            $this->caixa_lancamentos_caixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_caixa_to_string = $caixa_lancamentos_caixa_to_string;
        }

        $this->vdata['caixa_lancamentos_caixa_to_string'] = $this->caixa_lancamentos_caixa_to_string;
    }

    public function get_caixa_lancamentos_caixa_to_string()
    {
        if(!empty($this->caixa_lancamentos_caixa_to_string))
        {
            return $this->caixa_lancamentos_caixa_to_string;
        }
    
        $values = CaixaLancamentos::where('caixa_id', '=', $this->id)->getIndexedArray('caixa_id','{caixa->id}');
        return implode(', ', $values);
    }

    public function set_caixa_lancamentos_forma_pagamento_to_string($caixa_lancamentos_forma_pagamento_to_string)
    {
        if(is_array($caixa_lancamentos_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $caixa_lancamentos_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->caixa_lancamentos_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_forma_pagamento_to_string = $caixa_lancamentos_forma_pagamento_to_string;
        }

        $this->vdata['caixa_lancamentos_forma_pagamento_to_string'] = $this->caixa_lancamentos_forma_pagamento_to_string;
    }

    public function get_caixa_lancamentos_forma_pagamento_to_string()
    {
        if(!empty($this->caixa_lancamentos_forma_pagamento_to_string))
        {
            return $this->caixa_lancamentos_forma_pagamento_to_string;
        }
    
        $values = CaixaLancamentos::where('caixa_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_caixa_lancamentos_caixa_tipo_lancamento_to_string($caixa_lancamentos_caixa_tipo_lancamento_to_string)
    {
        if(is_array($caixa_lancamentos_caixa_tipo_lancamento_to_string))
        {
            $values = CaixaTipoLancamento::where('id', 'in', $caixa_lancamentos_caixa_tipo_lancamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->caixa_lancamentos_caixa_tipo_lancamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_caixa_tipo_lancamento_to_string = $caixa_lancamentos_caixa_tipo_lancamento_to_string;
        }

        $this->vdata['caixa_lancamentos_caixa_tipo_lancamento_to_string'] = $this->caixa_lancamentos_caixa_tipo_lancamento_to_string;
    }

    public function get_caixa_lancamentos_caixa_tipo_lancamento_to_string()
    {
        if(!empty($this->caixa_lancamentos_caixa_tipo_lancamento_to_string))
        {
            return $this->caixa_lancamentos_caixa_tipo_lancamento_to_string;
        }
    
        $values = CaixaLancamentos::where('caixa_id', '=', $this->id)->getIndexedArray('caixa_tipo_lancamento_id','{caixa_tipo_lancamento->descricao}');
        return implode(', ', $values);
    }

    public function set_caixa_lancamentos_system_users_to_string($caixa_lancamentos_system_users_to_string)
    {
        if(is_array($caixa_lancamentos_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_lancamentos_system_users_to_string)->getIndexedArray('name', 'name');
            $this->caixa_lancamentos_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_system_users_to_string = $caixa_lancamentos_system_users_to_string;
        }

        $this->vdata['caixa_lancamentos_system_users_to_string'] = $this->caixa_lancamentos_system_users_to_string;
    }

    public function get_caixa_lancamentos_system_users_to_string()
    {
        if(!empty($this->caixa_lancamentos_system_users_to_string))
        {
            return $this->caixa_lancamentos_system_users_to_string;
        }
    
        $values = CaixaLancamentos::where('caixa_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

  public static function lanca_caixa($caixaId,$formapgtoId,$caixatipolancamentoID,$valor,$obs,$origemId,$systemuserID)
  {
    $cxlancamento = new CaixaLancamentos();
    $cxlancamento->caixa_id = $caixaId;
    $cxlancamento->caixa_tipo_lancamento_id = $caixatipolancamentoID;
    $cxlancamento->system_users_id = $systemuserID;
    $cxlancamento->forma_pagamento_id = $formapgtoId;
    $cxlancamento->valor = $valor;
    $cxlancamento->observacao = $obs;
    $cxlancamento->id_origem = $origemId;
    $cxlancamento->data_hora_lancamento = date('Y-m-d H:i:s');
    $cxlancamento->store();  
  }
    
}

