<?php

class CaixaLancamentos extends TRecord
{
    const TABLENAME  = 'caixa_lancamentos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';

    private $caixa;
    private $forma_pagamento;
    private $caixa_tipo_lancamento;
    private $system_users;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('caixa_id');
        parent::addAttribute('forma_pagamento_id');
        parent::addAttribute('caixa_tipo_lancamento_id');
        parent::addAttribute('valor');
        parent::addAttribute('data_hora_lancamento');
        parent::addAttribute('system_users_id');
        parent::addAttribute('observacao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('id_origem');
            
    }

    /**
     * Method set_caixa
     * Sample of usage: $var->caixa = $object;
     * @param $object Instance of Caixa
     */
    public function set_caixa(Caixa $object)
    {
        $this->caixa = $object;
        $this->caixa_id = $object->id;
    }

    /**
     * Method get_caixa
     * Sample of usage: $var->caixa->attribute;
     * @returns Caixa instance
     */
    public function get_caixa()
    {
    
        // loads the associated object
        if (empty($this->caixa))
            $this->caixa = new Caixa($this->caixa_id);
    
        // returns the associated object
        return $this->caixa;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento(FormaPagamento $object)
    {
        $this->forma_pagamento = $object;
        $this->forma_pagamento_id = $object->id;
    }

    /**
     * Method get_forma_pagamento
     * Sample of usage: $var->forma_pagamento->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento))
            $this->forma_pagamento = new FormaPagamento($this->forma_pagamento_id);
    
        // returns the associated object
        return $this->forma_pagamento;
    }
    /**
     * Method set_caixa_tipo_lancamento
     * Sample of usage: $var->caixa_tipo_lancamento = $object;
     * @param $object Instance of CaixaTipoLancamento
     */
    public function set_caixa_tipo_lancamento(CaixaTipoLancamento $object)
    {
        $this->caixa_tipo_lancamento = $object;
        $this->caixa_tipo_lancamento_id = $object->id;
    }

    /**
     * Method get_caixa_tipo_lancamento
     * Sample of usage: $var->caixa_tipo_lancamento->attribute;
     * @returns CaixaTipoLancamento instance
     */
    public function get_caixa_tipo_lancamento()
    {
    
        // loads the associated object
        if (empty($this->caixa_tipo_lancamento))
            $this->caixa_tipo_lancamento = new CaixaTipoLancamento($this->caixa_tipo_lancamento_id);
    
        // returns the associated object
        return $this->caixa_tipo_lancamento;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users(SystemUsers $object)
    {
        $this->system_users = $object;
        $this->system_users_id = $object->id;
    }

    /**
     * Method get_system_users
     * Sample of usage: $var->system_users->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users()
    {
    
        // loads the associated object
        if (empty($this->system_users))
            $this->system_users = new SystemUsers($this->system_users_id);
    
        // returns the associated object
        return $this->system_users;
    }

    
}

