<?php

class CaixaSituacao extends TRecord
{
    const TABLENAME  = 'caixa_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Aberto = '1';
    const Fechado = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getCaixas
     */
    public function getCaixas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('caixa_situacao_id', '=', $this->id));
        return Caixa::getObjects( $criteria );
    }

    public function set_caixa_caixa_situacao_to_string($caixa_caixa_situacao_to_string)
    {
        if(is_array($caixa_caixa_situacao_to_string))
        {
            $values = CaixaSituacao::where('id', 'in', $caixa_caixa_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->caixa_caixa_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_caixa_situacao_to_string = $caixa_caixa_situacao_to_string;
        }

        $this->vdata['caixa_caixa_situacao_to_string'] = $this->caixa_caixa_situacao_to_string;
    }

    public function get_caixa_caixa_situacao_to_string()
    {
        if(!empty($this->caixa_caixa_situacao_to_string))
        {
            return $this->caixa_caixa_situacao_to_string;
        }
    
        $values = Caixa::where('caixa_situacao_id', '=', $this->id)->getIndexedArray('caixa_situacao_id','{caixa_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_caixa_system_unit_to_string($caixa_system_unit_to_string)
    {
        if(is_array($caixa_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $caixa_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_unit_to_string = $caixa_system_unit_to_string;
        }

        $this->vdata['caixa_system_unit_to_string'] = $this->caixa_system_unit_to_string;
    }

    public function get_caixa_system_unit_to_string()
    {
        if(!empty($this->caixa_system_unit_to_string))
        {
            return $this->caixa_system_unit_to_string;
        }
    
        $values = Caixa::where('caixa_situacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_caixa_system_users_abertura_to_string($caixa_system_users_abertura_to_string)
    {
        if(is_array($caixa_system_users_abertura_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_system_users_abertura_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_users_abertura_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_users_abertura_to_string = $caixa_system_users_abertura_to_string;
        }

        $this->vdata['caixa_system_users_abertura_to_string'] = $this->caixa_system_users_abertura_to_string;
    }

    public function get_caixa_system_users_abertura_to_string()
    {
        if(!empty($this->caixa_system_users_abertura_to_string))
        {
            return $this->caixa_system_users_abertura_to_string;
        }
    
        $values = Caixa::where('caixa_situacao_id', '=', $this->id)->getIndexedArray('system_users_abertura_id','{system_users_abertura->name}');
        return implode(', ', $values);
    }

    public function set_caixa_system_users_operador_to_string($caixa_system_users_operador_to_string)
    {
        if(is_array($caixa_system_users_operador_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_system_users_operador_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_users_operador_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_users_operador_to_string = $caixa_system_users_operador_to_string;
        }

        $this->vdata['caixa_system_users_operador_to_string'] = $this->caixa_system_users_operador_to_string;
    }

    public function get_caixa_system_users_operador_to_string()
    {
        if(!empty($this->caixa_system_users_operador_to_string))
        {
            return $this->caixa_system_users_operador_to_string;
        }
    
        $values = Caixa::where('caixa_situacao_id', '=', $this->id)->getIndexedArray('system_users_operador_id','{system_users_operador->name}');
        return implode(', ', $values);
    }

    public function set_caixa_system_users_fechamento_to_string($caixa_system_users_fechamento_to_string)
    {
        if(is_array($caixa_system_users_fechamento_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_system_users_fechamento_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_users_fechamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_users_fechamento_to_string = $caixa_system_users_fechamento_to_string;
        }

        $this->vdata['caixa_system_users_fechamento_to_string'] = $this->caixa_system_users_fechamento_to_string;
    }

    public function get_caixa_system_users_fechamento_to_string()
    {
        if(!empty($this->caixa_system_users_fechamento_to_string))
        {
            return $this->caixa_system_users_fechamento_to_string;
        }
    
        $values = Caixa::where('caixa_situacao_id', '=', $this->id)->getIndexedArray('system_users_fechamento_id','{system_users_fechamento->name}');
        return implode(', ', $values);
    }

    
}

