<?php

class CentroCusto extends TRecord
{
    const TABLENAME  = 'centro_custo';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $centro_custo_tipo;
    private $system_unit;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('centro_custo_tipo_id');
        parent::addAttribute('centro_custo_pai_id');
        parent::addAttribute('numero');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_centro_custo_tipo
     * Sample of usage: $var->centro_custo_tipo = $object;
     * @param $object Instance of CentroCustoTipo
     */
    public function set_centro_custo_tipo(CentroCustoTipo $object)
    {
        $this->centro_custo_tipo = $object;
        $this->centro_custo_tipo_id = $object->id;
    }

    /**
     * Method get_centro_custo_tipo
     * Sample of usage: $var->centro_custo_tipo->attribute;
     * @returns CentroCustoTipo instance
     */
    public function get_centro_custo_tipo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo_tipo))
            $this->centro_custo_tipo = new CentroCustoTipo($this->centro_custo_tipo_id);
    
        // returns the associated object
        return $this->centro_custo_tipo;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getConfiguracoesFilials
     */
    public function getConfiguracoesFilials()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_crec_id', '=', $this->id));
        return ConfiguracoesFilial::getObjects( $criteria );
    }
    /**
     * Method getContabilLancamentoss
     */
    public function getContabilLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_id', '=', $this->id));
        return ContabilLancamentos::getObjects( $criteria );
    }
    /**
     * Method getContaCorrenteLancamentoss
     */
    public function getContaCorrenteLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_id', '=', $this->id));
        return ContaCorrenteLancamentos::getObjects( $criteria );
    }
    /**
     * Method getContaspagBlocoContabils
     */
    public function getContaspagBlocoContabils()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_id', '=', $this->id));
        return ContaspagBlocoContabil::getObjects( $criteria );
    }
    /**
     * Method getContaspagContabils
     */
    public function getContaspagContabils()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_id', '=', $this->id));
        return ContaspagContabil::getObjects( $criteria );
    }
    /**
     * Method getContasrecs
     */
    public function getContasrecs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_id', '=', $this->id));
        return Contasrec::getObjects( $criteria );
    }
    /**
     * Method getContasrecBlocos
     */
    public function getContasrecBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_id', '=', $this->id));
        return ContasrecBloco::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraDups
     */
    public function getNotaFiscalCompraDups()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_id', '=', $this->id));
        return NotaFiscalCompraDup::getObjects( $criteria );
    }

    public function set_configuracoes_filial_configuracoes_to_string($configuracoes_filial_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_configuracoes_to_string))
        {
            $values = Configuracoes::where('id', 'in', $configuracoes_filial_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_configuracoes_to_string = $configuracoes_filial_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_configuracoes_to_string'] = $this->configuracoes_filial_configuracoes_to_string;
    }

    public function get_configuracoes_filial_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_configuracoes_to_string))
        {
            return $this->configuracoes_filial_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('configuracoes_id','{configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_system_unit_to_string($configuracoes_filial_system_unit_to_string)
    {
        if(is_array($configuracoes_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $configuracoes_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->configuracoes_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_system_unit_to_string = $configuracoes_filial_system_unit_to_string;
        }

        $this->vdata['configuracoes_filial_system_unit_to_string'] = $this->configuracoes_filial_system_unit_to_string;
    }

    public function get_configuracoes_filial_system_unit_to_string()
    {
        if(!empty($this->configuracoes_filial_system_unit_to_string))
        {
            return $this->configuracoes_filial_system_unit_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_produto_etiqueta_configuracoes_to_string($configuracoes_filial_produto_etiqueta_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            $values = ProdutoEtiquetaConfiguracoes::where('id', 'in', $configuracoes_filial_produto_etiqueta_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = $configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_produto_etiqueta_configuracoes_to_string'] = $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
    }

    public function get_configuracoes_filial_produto_etiqueta_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            return $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('produto_etiqueta_configuracoes_id','{produto_etiqueta_configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_plano_conta_crec_to_string($configuracoes_filial_plano_conta_crec_to_string)
    {
        if(is_array($configuracoes_filial_plano_conta_crec_to_string))
        {
            $values = PlanoConta::where('id', 'in', $configuracoes_filial_plano_conta_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_plano_conta_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_plano_conta_crec_to_string = $configuracoes_filial_plano_conta_crec_to_string;
        }

        $this->vdata['configuracoes_filial_plano_conta_crec_to_string'] = $this->configuracoes_filial_plano_conta_crec_to_string;
    }

    public function get_configuracoes_filial_plano_conta_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_plano_conta_crec_to_string))
        {
            return $this->configuracoes_filial_plano_conta_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('plano_conta_crec_id','{plano_conta_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_centro_custo_crec_to_string($configuracoes_filial_centro_custo_crec_to_string)
    {
        if(is_array($configuracoes_filial_centro_custo_crec_to_string))
        {
            $values = CentroCusto::where('id', 'in', $configuracoes_filial_centro_custo_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_centro_custo_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_centro_custo_crec_to_string = $configuracoes_filial_centro_custo_crec_to_string;
        }

        $this->vdata['configuracoes_filial_centro_custo_crec_to_string'] = $this->configuracoes_filial_centro_custo_crec_to_string;
    }

    public function get_configuracoes_filial_centro_custo_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_centro_custo_crec_to_string))
        {
            return $this->configuracoes_filial_centro_custo_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('centro_custo_crec_id','{centro_custo_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_cpag_usa_plano_contas_to_string($configuracoes_filial_cpag_usa_plano_contas_to_string)
    {
        if(is_array($configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_cpag_usa_plano_contas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = $configuracoes_filial_cpag_usa_plano_contas_to_string;
        }

        $this->vdata['configuracoes_filial_cpag_usa_plano_contas_to_string'] = $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
    }

    public function get_configuracoes_filial_cpag_usa_plano_contas_to_string()
    {
        if(!empty($this->configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            return $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('cpag_usa_plano_contas_id','{cpag_usa_plano_contas->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_informar_duplicidade_de_item_venda_to_string($configuracoes_filial_informar_duplicidade_de_item_venda_to_string)
    {
        if(is_array($configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_informar_duplicidade_de_item_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = $configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }

        $this->vdata['configuracoes_filial_informar_duplicidade_de_item_venda_to_string'] = $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
    }

    public function get_configuracoes_filial_informar_duplicidade_de_item_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            return $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('informar_duplicidade_de_item_venda_id','{informar_duplicidade_de_item_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_venda_apenas_com_estoque_to_string($configuracoes_filial_venda_apenas_com_estoque_to_string)
    {
        if(is_array($configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_venda_apenas_com_estoque_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = $configuracoes_filial_venda_apenas_com_estoque_to_string;
        }

        $this->vdata['configuracoes_filial_venda_apenas_com_estoque_to_string'] = $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
    }

    public function get_configuracoes_filial_venda_apenas_com_estoque_to_string()
    {
        if(!empty($this->configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            return $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('venda_apenas_com_estoque_id','{venda_apenas_com_estoque->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_orcamento_id','{notafiscal_cprod_padrao_orcamento->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_venda_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('centro_custo_crec_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_venda_id','{notafiscal_cprod_padrao_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_plano_conta_to_string($contabil_lancamentos_plano_conta_to_string)
    {
        if(is_array($contabil_lancamentos_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contabil_lancamentos_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_plano_conta_to_string = $contabil_lancamentos_plano_conta_to_string;
        }

        $this->vdata['contabil_lancamentos_plano_conta_to_string'] = $this->contabil_lancamentos_plano_conta_to_string;
    }

    public function get_contabil_lancamentos_plano_conta_to_string()
    {
        if(!empty($this->contabil_lancamentos_plano_conta_to_string))
        {
            return $this->contabil_lancamentos_plano_conta_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_centro_custo_to_string($contabil_lancamentos_centro_custo_to_string)
    {
        if(is_array($contabil_lancamentos_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contabil_lancamentos_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_centro_custo_to_string = $contabil_lancamentos_centro_custo_to_string;
        }

        $this->vdata['contabil_lancamentos_centro_custo_to_string'] = $this->contabil_lancamentos_centro_custo_to_string;
    }

    public function get_contabil_lancamentos_centro_custo_to_string()
    {
        if(!empty($this->contabil_lancamentos_centro_custo_to_string))
        {
            return $this->contabil_lancamentos_centro_custo_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_tipo_to_string($contabil_lancamentos_contabil_lancamentos_tipo_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            $values = ContabilLancamentosTipo::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_tipo_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = $contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_tipo_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_tipo_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_tipo_id','{contabil_lancamentos_tipo->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_situacao_to_string($contabil_lancamentos_contabil_lancamentos_situacao_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            $values = ContabilLancamentosSituacao::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = $contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_situacao_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_situacao_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_situacao_id','{contabil_lancamentos_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_origem_to_string($contabil_lancamentos_contabil_lancamentos_origem_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            $values = ContabilLancamentosOrigem::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = $contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_origem_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_origem_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_origem_id','{contabil_lancamentos_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contasrec_to_string($contabil_lancamentos_contasrec_to_string)
    {
        if(is_array($contabil_lancamentos_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contabil_lancamentos_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contasrec_to_string = $contabil_lancamentos_contasrec_to_string;
        }

        $this->vdata['contabil_lancamentos_contasrec_to_string'] = $this->contabil_lancamentos_contasrec_to_string;
    }

    public function get_contabil_lancamentos_contasrec_to_string()
    {
        if(!empty($this->contabil_lancamentos_contasrec_to_string))
        {
            return $this->contabil_lancamentos_contasrec_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contaspag_contabil_to_string($contabil_lancamentos_contaspag_contabil_to_string)
    {
        if(is_array($contabil_lancamentos_contaspag_contabil_to_string))
        {
            $values = ContaspagContabil::where('id', 'in', $contabil_lancamentos_contaspag_contabil_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contaspag_contabil_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contaspag_contabil_to_string = $contabil_lancamentos_contaspag_contabil_to_string;
        }

        $this->vdata['contabil_lancamentos_contaspag_contabil_to_string'] = $this->contabil_lancamentos_contaspag_contabil_to_string;
    }

    public function get_contabil_lancamentos_contaspag_contabil_to_string()
    {
        if(!empty($this->contabil_lancamentos_contaspag_contabil_to_string))
        {
            return $this->contabil_lancamentos_contaspag_contabil_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('contaspag_contabil_id','{contaspag_contabil->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_conta_corrente_lancamentos_to_string($contabil_lancamentos_conta_corrente_lancamentos_to_string)
    {
        if(is_array($contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            $values = ContaCorrenteLancamentos::where('id', 'in', $contabil_lancamentos_conta_corrente_lancamentos_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = $contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }

        $this->vdata['contabil_lancamentos_conta_corrente_lancamentos_to_string'] = $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
    }

    public function get_contabil_lancamentos_conta_corrente_lancamentos_to_string()
    {
        if(!empty($this->contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            return $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }
    
        $values = ContabilLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('conta_corrente_lancamentos_id','{conta_corrente_lancamentos->id}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_conta_corrente_to_string($conta_corrente_lancamentos_conta_corrente_to_string)
    {
        if(is_array($conta_corrente_lancamentos_conta_corrente_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $conta_corrente_lancamentos_conta_corrente_to_string)->getIndexedArray('nome', 'nome');
            $this->conta_corrente_lancamentos_conta_corrente_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_conta_corrente_to_string = $conta_corrente_lancamentos_conta_corrente_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_conta_corrente_to_string'] = $this->conta_corrente_lancamentos_conta_corrente_to_string;
    }

    public function get_conta_corrente_lancamentos_conta_corrente_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_conta_corrente_to_string))
        {
            return $this->conta_corrente_lancamentos_conta_corrente_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('conta_corrente_id','{conta_corrente->nome}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string($conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string)
    {
        if(is_array($conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string))
        {
            $values = ContaCorrenteLancTipo::where('id', 'in', $conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string = $conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string'] = $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string;
    }

    public function get_conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string))
        {
            return $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('conta_corrente_lanc_tipo_id','{conta_corrente_lanc_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string($conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string)
    {
        if(is_array($conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string))
        {
            $values = ContaCorrenteLancOrigem::where('id', 'in', $conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string = $conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string'] = $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string;
    }

    public function get_conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string))
        {
            return $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('conta_corrente_lanc_origem_id','{conta_corrente_lanc_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_contaspag_baixas_to_string($conta_corrente_lancamentos_contaspag_baixas_to_string)
    {
        if(is_array($conta_corrente_lancamentos_contaspag_baixas_to_string))
        {
            $values = ContaspagBaixas::where('id', 'in', $conta_corrente_lancamentos_contaspag_baixas_to_string)->getIndexedArray('id', 'id');
            $this->conta_corrente_lancamentos_contaspag_baixas_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_contaspag_baixas_to_string = $conta_corrente_lancamentos_contaspag_baixas_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_contaspag_baixas_to_string'] = $this->conta_corrente_lancamentos_contaspag_baixas_to_string;
    }

    public function get_conta_corrente_lancamentos_contaspag_baixas_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_contaspag_baixas_to_string))
        {
            return $this->conta_corrente_lancamentos_contaspag_baixas_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('contaspag_baixas_id','{contaspag_baixas->id}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_contasrec_baixas_to_string($conta_corrente_lancamentos_contasrec_baixas_to_string)
    {
        if(is_array($conta_corrente_lancamentos_contasrec_baixas_to_string))
        {
            $values = ContasrecBaixas::where('id', 'in', $conta_corrente_lancamentos_contasrec_baixas_to_string)->getIndexedArray('id', 'id');
            $this->conta_corrente_lancamentos_contasrec_baixas_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_contasrec_baixas_to_string = $conta_corrente_lancamentos_contasrec_baixas_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_contasrec_baixas_to_string'] = $this->conta_corrente_lancamentos_contasrec_baixas_to_string;
    }

    public function get_conta_corrente_lancamentos_contasrec_baixas_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_contasrec_baixas_to_string))
        {
            return $this->conta_corrente_lancamentos_contasrec_baixas_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('contasrec_baixas_id','{contasrec_baixas->id}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_plano_conta_to_string($conta_corrente_lancamentos_plano_conta_to_string)
    {
        if(is_array($conta_corrente_lancamentos_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $conta_corrente_lancamentos_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_plano_conta_to_string = $conta_corrente_lancamentos_plano_conta_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_plano_conta_to_string'] = $this->conta_corrente_lancamentos_plano_conta_to_string;
    }

    public function get_conta_corrente_lancamentos_plano_conta_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_plano_conta_to_string))
        {
            return $this->conta_corrente_lancamentos_plano_conta_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_centro_custo_to_string($conta_corrente_lancamentos_centro_custo_to_string)
    {
        if(is_array($conta_corrente_lancamentos_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $conta_corrente_lancamentos_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_centro_custo_to_string = $conta_corrente_lancamentos_centro_custo_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_centro_custo_to_string'] = $this->conta_corrente_lancamentos_centro_custo_to_string;
    }

    public function get_conta_corrente_lancamentos_centro_custo_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_centro_custo_to_string))
        {
            return $this->conta_corrente_lancamentos_centro_custo_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('centro_custo_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contabil_contaspag_bloco_to_string($contaspag_bloco_contabil_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_bloco_contabil_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_bloco_contabil_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_bloco_contabil_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contabil_contaspag_bloco_to_string = $contaspag_bloco_contabil_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_bloco_contabil_contaspag_bloco_to_string'] = $this->contaspag_bloco_contabil_contaspag_bloco_to_string;
    }

    public function get_contaspag_bloco_contabil_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_bloco_contabil_contaspag_bloco_to_string))
        {
            return $this->contaspag_bloco_contabil_contaspag_bloco_to_string;
        }
    
        $values = ContaspagBlocoContabil::where('centro_custo_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contabil_plano_conta_to_string($contaspag_bloco_contabil_plano_conta_to_string)
    {
        if(is_array($contaspag_bloco_contabil_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contaspag_bloco_contabil_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contabil_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contabil_plano_conta_to_string = $contaspag_bloco_contabil_plano_conta_to_string;
        }

        $this->vdata['contaspag_bloco_contabil_plano_conta_to_string'] = $this->contaspag_bloco_contabil_plano_conta_to_string;
    }

    public function get_contaspag_bloco_contabil_plano_conta_to_string()
    {
        if(!empty($this->contaspag_bloco_contabil_plano_conta_to_string))
        {
            return $this->contaspag_bloco_contabil_plano_conta_to_string;
        }
    
        $values = ContaspagBlocoContabil::where('centro_custo_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contabil_centro_custo_to_string($contaspag_bloco_contabil_centro_custo_to_string)
    {
        if(is_array($contaspag_bloco_contabil_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contaspag_bloco_contabil_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contabil_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contabil_centro_custo_to_string = $contaspag_bloco_contabil_centro_custo_to_string;
        }

        $this->vdata['contaspag_bloco_contabil_centro_custo_to_string'] = $this->contaspag_bloco_contabil_centro_custo_to_string;
    }

    public function get_contaspag_bloco_contabil_centro_custo_to_string()
    {
        if(!empty($this->contaspag_bloco_contabil_centro_custo_to_string))
        {
            return $this->contaspag_bloco_contabil_centro_custo_to_string;
        }
    
        $values = ContaspagBlocoContabil::where('centro_custo_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_contabil_contaspag_to_string($contaspag_contabil_contaspag_to_string)
    {
        if(is_array($contaspag_contabil_contaspag_to_string))
        {
            $values = Contaspag::where('id', 'in', $contaspag_contabil_contaspag_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contabil_contaspag_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contabil_contaspag_to_string = $contaspag_contabil_contaspag_to_string;
        }

        $this->vdata['contaspag_contabil_contaspag_to_string'] = $this->contaspag_contabil_contaspag_to_string;
    }

    public function get_contaspag_contabil_contaspag_to_string()
    {
        if(!empty($this->contaspag_contabil_contaspag_to_string))
        {
            return $this->contaspag_contabil_contaspag_to_string;
        }
    
        $values = ContaspagContabil::where('centro_custo_id', '=', $this->id)->getIndexedArray('contaspag_id','{contaspag->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_contabil_plano_conta_to_string($contaspag_contabil_plano_conta_to_string)
    {
        if(is_array($contaspag_contabil_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contaspag_contabil_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contabil_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contabil_plano_conta_to_string = $contaspag_contabil_plano_conta_to_string;
        }

        $this->vdata['contaspag_contabil_plano_conta_to_string'] = $this->contaspag_contabil_plano_conta_to_string;
    }

    public function get_contaspag_contabil_plano_conta_to_string()
    {
        if(!empty($this->contaspag_contabil_plano_conta_to_string))
        {
            return $this->contaspag_contabil_plano_conta_to_string;
        }
    
        $values = ContaspagContabil::where('centro_custo_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_contabil_centro_custo_to_string($contaspag_contabil_centro_custo_to_string)
    {
        if(is_array($contaspag_contabil_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contaspag_contabil_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contabil_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contabil_centro_custo_to_string = $contaspag_contabil_centro_custo_to_string;
        }

        $this->vdata['contaspag_contabil_centro_custo_to_string'] = $this->contaspag_contabil_centro_custo_to_string;
    }

    public function get_contaspag_contabil_centro_custo_to_string()
    {
        if(!empty($this->contaspag_contabil_centro_custo_to_string))
        {
            return $this->contaspag_contabil_centro_custo_to_string;
        }
    
        $values = ContaspagContabil::where('centro_custo_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_system_unit_to_string($contasrec_system_unit_to_string)
    {
        if(is_array($contasrec_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_system_unit_to_string = $contasrec_system_unit_to_string;
        }

        $this->vdata['contasrec_system_unit_to_string'] = $this->contasrec_system_unit_to_string;
    }

    public function get_contasrec_system_unit_to_string()
    {
        if(!empty($this->contasrec_system_unit_to_string))
        {
            return $this->contasrec_system_unit_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_cliente_to_string($contasrec_cliente_to_string)
    {
        if(is_array($contasrec_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cliente_to_string = $contasrec_cliente_to_string;
        }

        $this->vdata['contasrec_cliente_to_string'] = $this->contasrec_cliente_to_string;
    }

    public function get_contasrec_cliente_to_string()
    {
        if(!empty($this->contasrec_cliente_to_string))
        {
            return $this->contasrec_cliente_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_forma_pagamento_to_string($contasrec_forma_pagamento_to_string)
    {
        if(is_array($contasrec_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_forma_pagamento_to_string = $contasrec_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_forma_pagamento_to_string'] = $this->contasrec_forma_pagamento_to_string;
    }

    public function get_contasrec_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_forma_pagamento_to_string))
        {
            return $this->contasrec_forma_pagamento_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_situacao_to_string($contasrec_contasrec_situacao_to_string)
    {
        if(is_array($contasrec_contasrec_situacao_to_string))
        {
            $values = ContasrecSituacao::where('id', 'in', $contasrec_contasrec_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_situacao_to_string = $contasrec_contasrec_situacao_to_string;
        }

        $this->vdata['contasrec_contasrec_situacao_to_string'] = $this->contasrec_contasrec_situacao_to_string;
    }

    public function get_contasrec_contasrec_situacao_to_string()
    {
        if(!empty($this->contasrec_contasrec_situacao_to_string))
        {
            return $this->contasrec_contasrec_situacao_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('contasrec_situacao_id','{contasrec_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_plano_conta_to_string($contasrec_plano_conta_to_string)
    {
        if(is_array($contasrec_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_plano_conta_to_string = $contasrec_plano_conta_to_string;
        }

        $this->vdata['contasrec_plano_conta_to_string'] = $this->contasrec_plano_conta_to_string;
    }

    public function get_contasrec_plano_conta_to_string()
    {
        if(!empty($this->contasrec_plano_conta_to_string))
        {
            return $this->contasrec_plano_conta_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_centro_custo_to_string($contasrec_centro_custo_to_string)
    {
        if(is_array($contasrec_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_centro_custo_to_string = $contasrec_centro_custo_to_string;
        }

        $this->vdata['contasrec_centro_custo_to_string'] = $this->contasrec_centro_custo_to_string;
    }

    public function get_contasrec_centro_custo_to_string()
    {
        if(!empty($this->contasrec_centro_custo_to_string))
        {
            return $this->contasrec_centro_custo_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_origem_to_string($contasrec_contasrec_origem_to_string)
    {
        if(is_array($contasrec_contasrec_origem_to_string))
        {
            $values = ContasrecOrigem::where('id', 'in', $contasrec_contasrec_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_origem_to_string = $contasrec_contasrec_origem_to_string;
        }

        $this->vdata['contasrec_contasrec_origem_to_string'] = $this->contasrec_contasrec_origem_to_string;
    }

    public function get_contasrec_contasrec_origem_to_string()
    {
        if(!empty($this->contasrec_contasrec_origem_to_string))
        {
            return $this->contasrec_contasrec_origem_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('contasrec_origem_id','{contasrec_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_cheque_banco_to_string($contasrec_cheque_banco_to_string)
    {
        if(is_array($contasrec_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contasrec_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cheque_banco_to_string = $contasrec_cheque_banco_to_string;
        }

        $this->vdata['contasrec_cheque_banco_to_string'] = $this->contasrec_cheque_banco_to_string;
    }

    public function get_contasrec_cheque_banco_to_string()
    {
        if(!empty($this->contasrec_cheque_banco_to_string))
        {
            return $this->contasrec_cheque_banco_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_conta_corrente_boleto_to_string($contasrec_conta_corrente_boleto_to_string)
    {
        if(is_array($contasrec_conta_corrente_boleto_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_conta_corrente_boleto_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_conta_corrente_boleto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_conta_corrente_boleto_to_string = $contasrec_conta_corrente_boleto_to_string;
        }

        $this->vdata['contasrec_conta_corrente_boleto_to_string'] = $this->contasrec_conta_corrente_boleto_to_string;
    }

    public function get_contasrec_conta_corrente_boleto_to_string()
    {
        if(!empty($this->contasrec_conta_corrente_boleto_to_string))
        {
            return $this->contasrec_conta_corrente_boleto_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('conta_corrente_boleto_id','{conta_corrente_boleto->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_boleto_situacao_to_string($contasrec_boleto_situacao_to_string)
    {
        if(is_array($contasrec_boleto_situacao_to_string))
        {
            $values = BoletoSituacao::where('id', 'in', $contasrec_boleto_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_boleto_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_boleto_situacao_to_string = $contasrec_boleto_situacao_to_string;
        }

        $this->vdata['contasrec_boleto_situacao_to_string'] = $this->contasrec_boleto_situacao_to_string;
    }

    public function get_contasrec_boleto_situacao_to_string()
    {
        if(!empty($this->contasrec_boleto_situacao_to_string))
        {
            return $this->contasrec_boleto_situacao_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('boleto_situacao_id','{boleto_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_vendedor_to_string($contasrec_vendedor_to_string)
    {
        if(is_array($contasrec_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $contasrec_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_vendedor_to_string = $contasrec_vendedor_to_string;
        }

        $this->vdata['contasrec_vendedor_to_string'] = $this->contasrec_vendedor_to_string;
    }

    public function get_contasrec_vendedor_to_string()
    {
        if(!empty($this->contasrec_vendedor_to_string))
        {
            return $this->contasrec_vendedor_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_bloco_to_string($contasrec_contasrec_bloco_to_string)
    {
        if(is_array($contasrec_contasrec_bloco_to_string))
        {
            $values = ContasrecBloco::where('id', 'in', $contasrec_contasrec_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_contasrec_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_bloco_to_string = $contasrec_contasrec_bloco_to_string;
        }

        $this->vdata['contasrec_contasrec_bloco_to_string'] = $this->contasrec_contasrec_bloco_to_string;
    }

    public function get_contasrec_contasrec_bloco_to_string()
    {
        if(!empty($this->contasrec_contasrec_bloco_to_string))
        {
            return $this->contasrec_contasrec_bloco_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('contasrec_bloco_id','{contasrec_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_venda_formapgto_to_string($contasrec_venda_formapgto_to_string)
    {
        if(is_array($contasrec_venda_formapgto_to_string))
        {
            $values = VendaFormapgto::where('id', 'in', $contasrec_venda_formapgto_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_venda_formapgto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_venda_formapgto_to_string = $contasrec_venda_formapgto_to_string;
        }

        $this->vdata['contasrec_venda_formapgto_to_string'] = $this->contasrec_venda_formapgto_to_string;
    }

    public function get_contasrec_venda_formapgto_to_string()
    {
        if(!empty($this->contasrec_venda_formapgto_to_string))
        {
            return $this->contasrec_venda_formapgto_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('venda_formapgto_id','{venda_formapgto->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_ativo_to_string($contasrec_ativo_to_string)
    {
        if(is_array($contasrec_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $contasrec_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_ativo_to_string = $contasrec_ativo_to_string;
        }

        $this->vdata['contasrec_ativo_to_string'] = $this->contasrec_ativo_to_string;
    }

    public function get_contasrec_ativo_to_string()
    {
        if(!empty($this->contasrec_ativo_to_string))
        {
            return $this->contasrec_ativo_to_string;
        }
    
        $values = Contasrec::where('centro_custo_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_cliente_to_string($contasrec_bloco_cliente_to_string)
    {
        if(is_array($contasrec_bloco_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_bloco_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_bloco_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_cliente_to_string = $contasrec_bloco_cliente_to_string;
        }

        $this->vdata['contasrec_bloco_cliente_to_string'] = $this->contasrec_bloco_cliente_to_string;
    }

    public function get_contasrec_bloco_cliente_to_string()
    {
        if(!empty($this->contasrec_bloco_cliente_to_string))
        {
            return $this->contasrec_bloco_cliente_to_string;
        }
    
        $values = ContasrecBloco::where('centro_custo_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_forma_pagamento_to_string($contasrec_bloco_forma_pagamento_to_string)
    {
        if(is_array($contasrec_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_forma_pagamento_to_string = $contasrec_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_bloco_forma_pagamento_to_string'] = $this->contasrec_bloco_forma_pagamento_to_string;
    }

    public function get_contasrec_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_bloco_forma_pagamento_to_string))
        {
            return $this->contasrec_bloco_forma_pagamento_to_string;
        }
    
        $values = ContasrecBloco::where('centro_custo_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_system_unit_to_string($contasrec_bloco_system_unit_to_string)
    {
        if(is_array($contasrec_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_system_unit_to_string = $contasrec_bloco_system_unit_to_string;
        }

        $this->vdata['contasrec_bloco_system_unit_to_string'] = $this->contasrec_bloco_system_unit_to_string;
    }

    public function get_contasrec_bloco_system_unit_to_string()
    {
        if(!empty($this->contasrec_bloco_system_unit_to_string))
        {
            return $this->contasrec_bloco_system_unit_to_string;
        }
    
        $values = ContasrecBloco::where('centro_custo_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_plano_conta_to_string($contasrec_bloco_plano_conta_to_string)
    {
        if(is_array($contasrec_bloco_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_bloco_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_plano_conta_to_string = $contasrec_bloco_plano_conta_to_string;
        }

        $this->vdata['contasrec_bloco_plano_conta_to_string'] = $this->contasrec_bloco_plano_conta_to_string;
    }

    public function get_contasrec_bloco_plano_conta_to_string()
    {
        if(!empty($this->contasrec_bloco_plano_conta_to_string))
        {
            return $this->contasrec_bloco_plano_conta_to_string;
        }
    
        $values = ContasrecBloco::where('centro_custo_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_centro_custo_to_string($contasrec_bloco_centro_custo_to_string)
    {
        if(is_array($contasrec_bloco_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_bloco_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_centro_custo_to_string = $contasrec_bloco_centro_custo_to_string;
        }

        $this->vdata['contasrec_bloco_centro_custo_to_string'] = $this->contasrec_bloco_centro_custo_to_string;
    }

    public function get_contasrec_bloco_centro_custo_to_string()
    {
        if(!empty($this->contasrec_bloco_centro_custo_to_string))
        {
            return $this->contasrec_bloco_centro_custo_to_string;
        }
    
        $values = ContasrecBloco::where('centro_custo_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_nota_fiscal_compra_to_string($nota_fiscal_compra_dup_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_dup_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string = $nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_dup_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('centro_custo_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_forma_pagamento_to_string($nota_fiscal_compra_dup_forma_pagamento_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $nota_fiscal_compra_dup_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_forma_pagamento_to_string = $nota_fiscal_compra_dup_forma_pagamento_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_forma_pagamento_to_string'] = $this->nota_fiscal_compra_dup_forma_pagamento_to_string;
    }

    public function get_nota_fiscal_compra_dup_forma_pagamento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_forma_pagamento_to_string))
        {
            return $this->nota_fiscal_compra_dup_forma_pagamento_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('centro_custo_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_plano_conta_to_string($nota_fiscal_compra_dup_plano_conta_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $nota_fiscal_compra_dup_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_plano_conta_to_string = $nota_fiscal_compra_dup_plano_conta_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_plano_conta_to_string'] = $this->nota_fiscal_compra_dup_plano_conta_to_string;
    }

    public function get_nota_fiscal_compra_dup_plano_conta_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_plano_conta_to_string))
        {
            return $this->nota_fiscal_compra_dup_plano_conta_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('centro_custo_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_centro_custo_to_string($nota_fiscal_compra_dup_centro_custo_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $nota_fiscal_compra_dup_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_centro_custo_to_string = $nota_fiscal_compra_dup_centro_custo_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_centro_custo_to_string'] = $this->nota_fiscal_compra_dup_centro_custo_to_string;
    }

    public function get_nota_fiscal_compra_dup_centro_custo_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_centro_custo_to_string))
        {
            return $this->nota_fiscal_compra_dup_centro_custo_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('centro_custo_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    
}

