<?php

class CentroCustoTipo extends TRecord
{
    const TABLENAME  = 'centro_custo_tipo';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Sintetico = '1';
    const Analitico = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getCentroCustos
     */
    public function getCentroCustos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('centro_custo_tipo_id', '=', $this->id));
        return CentroCusto::getObjects( $criteria );
    }

    public function set_centro_custo_system_unit_to_string($centro_custo_system_unit_to_string)
    {
        if(is_array($centro_custo_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $centro_custo_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->centro_custo_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->centro_custo_system_unit_to_string = $centro_custo_system_unit_to_string;
        }

        $this->vdata['centro_custo_system_unit_to_string'] = $this->centro_custo_system_unit_to_string;
    }

    public function get_centro_custo_system_unit_to_string()
    {
        if(!empty($this->centro_custo_system_unit_to_string))
        {
            return $this->centro_custo_system_unit_to_string;
        }
    
        $values = CentroCusto::where('centro_custo_tipo_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_centro_custo_centro_custo_tipo_to_string($centro_custo_centro_custo_tipo_to_string)
    {
        if(is_array($centro_custo_centro_custo_tipo_to_string))
        {
            $values = CentroCustoTipo::where('id', 'in', $centro_custo_centro_custo_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->centro_custo_centro_custo_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->centro_custo_centro_custo_tipo_to_string = $centro_custo_centro_custo_tipo_to_string;
        }

        $this->vdata['centro_custo_centro_custo_tipo_to_string'] = $this->centro_custo_centro_custo_tipo_to_string;
    }

    public function get_centro_custo_centro_custo_tipo_to_string()
    {
        if(!empty($this->centro_custo_centro_custo_tipo_to_string))
        {
            return $this->centro_custo_centro_custo_tipo_to_string;
        }
    
        $values = CentroCusto::where('centro_custo_tipo_id', '=', $this->id)->getIndexedArray('centro_custo_tipo_id','{centro_custo_tipo->descricao}');
        return implode(', ', $values);
    }

    
}

