<?php

class CertificadoAgenteRegistro extends TRecord
{
    const TABLENAME  = 'certificado_agente_registro';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $parceiro;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('parceiro_id');
        parent::addAttribute('nome');
        parent::addAttribute('cpf');
        parent::addAttribute('fone');
        parent::addAttribute('email');
        parent::addAttribute('percentual_comissao');
        parent::addAttribute('deletado_em');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_parceiro
     * Sample of usage: $var->parceiro = $object;
     * @param $object Instance of Parceiro
     */
    public function set_parceiro(Parceiro $object)
    {
        $this->parceiro = $object;
        $this->parceiro_id = $object->id;
    }

    /**
     * Method get_parceiro
     * Sample of usage: $var->parceiro->attribute;
     * @returns Parceiro instance
     */
    public function get_parceiro()
    {
    
        // loads the associated object
        if (empty($this->parceiro))
            $this->parceiro = new Parceiro($this->parceiro_id);
    
        // returns the associated object
        return $this->parceiro;
    }

    /**
     * Method getCertificadoVendas
     */
    public function getCertificadoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_agente_registro_id', '=', $this->id));
        return CertificadoVenda::getObjects( $criteria );
    }

    public function set_certificado_venda_system_unit_to_string($certificado_venda_system_unit_to_string)
    {
        if(is_array($certificado_venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $certificado_venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->certificado_venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_system_unit_to_string = $certificado_venda_system_unit_to_string;
        }

        $this->vdata['certificado_venda_system_unit_to_string'] = $this->certificado_venda_system_unit_to_string;
    }

    public function get_certificado_venda_system_unit_to_string()
    {
        if(!empty($this->certificado_venda_system_unit_to_string))
        {
            return $this->certificado_venda_system_unit_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_cliente_to_string($certificado_venda_cliente_to_string)
    {
        if(is_array($certificado_venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_cliente_to_string = $certificado_venda_cliente_to_string;
        }

        $this->vdata['certificado_venda_cliente_to_string'] = $this->certificado_venda_cliente_to_string;
    }

    public function get_certificado_venda_cliente_to_string()
    {
        if(!empty($this->certificado_venda_cliente_to_string))
        {
            return $this->certificado_venda_cliente_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_produto_to_string($certificado_venda_produto_to_string)
    {
        if(is_array($certificado_venda_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_venda_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_produto_to_string = $certificado_venda_produto_to_string;
        }

        $this->vdata['certificado_venda_produto_to_string'] = $this->certificado_venda_produto_to_string;
    }

    public function get_certificado_venda_produto_to_string()
    {
        if(!empty($this->certificado_venda_produto_to_string))
        {
            return $this->certificado_venda_produto_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_parceiro_to_string($certificado_venda_parceiro_to_string)
    {
        if(is_array($certificado_venda_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_venda_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_parceiro_to_string = $certificado_venda_parceiro_to_string;
        }

        $this->vdata['certificado_venda_parceiro_to_string'] = $this->certificado_venda_parceiro_to_string;
    }

    public function get_certificado_venda_parceiro_to_string()
    {
        if(!empty($this->certificado_venda_parceiro_to_string))
        {
            return $this->certificado_venda_parceiro_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_agente_registro_to_string($certificado_venda_certificado_agente_registro_to_string)
    {
        if(is_array($certificado_venda_certificado_agente_registro_to_string))
        {
            $values = CertificadoAgenteRegistro::where('id', 'in', $certificado_venda_certificado_agente_registro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificado_agente_registro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_agente_registro_to_string = $certificado_venda_certificado_agente_registro_to_string;
        }

        $this->vdata['certificado_venda_certificado_agente_registro_to_string'] = $this->certificado_venda_certificado_agente_registro_to_string;
    }

    public function get_certificado_venda_certificado_agente_registro_to_string()
    {
        if(!empty($this->certificado_venda_certificado_agente_registro_to_string))
        {
            return $this->certificado_venda_certificado_agente_registro_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('certificado_agente_registro_id','{certificado_agente_registro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_situacao_to_string($certificado_venda_certificado_venda_situacao_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_situacao_to_string))
        {
            $values = CertificadoVendaSituacao::where('id', 'in', $certificado_venda_certificado_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_situacao_to_string = $certificado_venda_certificado_venda_situacao_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_situacao_to_string'] = $this->certificado_venda_certificado_venda_situacao_to_string;
    }

    public function get_certificado_venda_certificado_venda_situacao_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_situacao_to_string))
        {
            return $this->certificado_venda_certificado_venda_situacao_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('certificado_venda_situacao_id','{certificado_venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_modalidade_to_string($certificado_venda_certificado_venda_modalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $certificado_venda_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_modalidade_to_string = $certificado_venda_certificado_venda_modalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_modalidade_to_string'] = $this->certificado_venda_certificado_venda_modalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_modalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_modalidade_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_tipomodalidade_to_string($certificado_venda_certificado_venda_tipomodalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            $values = CertificadoVendaTipomodalidade::where('id', 'in', $certificado_venda_certificado_venda_tipomodalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = $certificado_venda_certificado_venda_tipomodalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_tipomodalidade_to_string'] = $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_tipomodalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('certificado_venda_tipomodalidade_id','{certificado_venda_tipomodalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_repasse_to_string($certificado_venda_certificado_tipo_repasse_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_repasse_to_string))
        {
            $values = CertificadoTipoRepasse::where('id', 'in', $certificado_venda_certificado_tipo_repasse_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_repasse_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_repasse_to_string = $certificado_venda_certificado_tipo_repasse_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_repasse_to_string'] = $this->certificado_venda_certificado_tipo_repasse_to_string;
    }

    public function get_certificado_venda_certificado_tipo_repasse_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_repasse_to_string))
        {
            return $this->certificado_venda_certificado_tipo_repasse_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('certificado_tipo_repasse_id','{certificado_tipo_repasse->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_vendedor_to_string($certificado_venda_vendedor_to_string)
    {
        if(is_array($certificado_venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $certificado_venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_vendedor_to_string = $certificado_venda_vendedor_to_string;
        }

        $this->vdata['certificado_venda_vendedor_to_string'] = $this->certificado_venda_vendedor_to_string;
    }

    public function get_certificado_venda_vendedor_to_string()
    {
        if(!empty($this->certificado_venda_vendedor_to_string))
        {
            return $this->certificado_venda_vendedor_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_tabela_preco_to_string($certificado_venda_tabela_preco_to_string)
    {
        if(is_array($certificado_venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $certificado_venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_tabela_preco_to_string = $certificado_venda_tabela_preco_to_string;
        }

        $this->vdata['certificado_venda_tabela_preco_to_string'] = $this->certificado_venda_tabela_preco_to_string;
    }

    public function get_certificado_venda_tabela_preco_to_string()
    {
        if(!empty($this->certificado_venda_tabela_preco_to_string))
        {
            return $this->certificado_venda_tabela_preco_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificadora_to_string($certificado_venda_certificadora_to_string)
    {
        if(is_array($certificado_venda_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificado_venda_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificadora_to_string = $certificado_venda_certificadora_to_string;
        }

        $this->vdata['certificado_venda_certificadora_to_string'] = $this->certificado_venda_certificadora_to_string;
    }

    public function get_certificado_venda_certificadora_to_string()
    {
        if(!empty($this->certificado_venda_certificadora_to_string))
        {
            return $this->certificado_venda_certificadora_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_atendimento_to_string($certificado_venda_certificado_tipo_atendimento_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_atendimento_to_string))
        {
            $values = CertificadoTipoAtendimento::where('id', 'in', $certificado_venda_certificado_tipo_atendimento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_atendimento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_atendimento_to_string = $certificado_venda_certificado_tipo_atendimento_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_atendimento_to_string'] = $this->certificado_venda_certificado_tipo_atendimento_to_string;
    }

    public function get_certificado_venda_certificado_tipo_atendimento_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_atendimento_to_string))
        {
            return $this->certificado_venda_certificado_tipo_atendimento_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_agente_registro_id', '=', $this->id)->getIndexedArray('certificado_tipo_atendimento_id','{certificado_tipo_atendimento->descricao}');
        return implode(', ', $values);
    }

    
}

