<?php

class CertificadoCliente extends TRecord
{
    const TABLENAME  = 'certificado_cliente';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $cliente;
    private $parceiro;
    private $produto;
    private $certificado_venda;
    private $certificado_cliente_situacao;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cliente_id');
        parent::addAttribute('parceiro_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('certificado_cliente_situacao_id');
        parent::addAttribute('data_vencimento_certificado');
        parent::addAttribute('certificado_venda_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_parceiro
     * Sample of usage: $var->parceiro = $object;
     * @param $object Instance of Parceiro
     */
    public function set_parceiro(Parceiro $object)
    {
        $this->parceiro = $object;
        $this->parceiro_id = $object->id;
    }

    /**
     * Method get_parceiro
     * Sample of usage: $var->parceiro->attribute;
     * @returns Parceiro instance
     */
    public function get_parceiro()
    {
    
        // loads the associated object
        if (empty($this->parceiro))
            $this->parceiro = new Parceiro($this->parceiro_id);
    
        // returns the associated object
        return $this->parceiro;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_certificado_venda
     * Sample of usage: $var->certificado_venda = $object;
     * @param $object Instance of CertificadoVenda
     */
    public function set_certificado_venda(CertificadoVenda $object)
    {
        $this->certificado_venda = $object;
        $this->certificado_venda_id = $object->id;
    }

    /**
     * Method get_certificado_venda
     * Sample of usage: $var->certificado_venda->attribute;
     * @returns CertificadoVenda instance
     */
    public function get_certificado_venda()
    {
    
        // loads the associated object
        if (empty($this->certificado_venda))
            $this->certificado_venda = new CertificadoVenda($this->certificado_venda_id);
    
        // returns the associated object
        return $this->certificado_venda;
    }
    /**
     * Method set_certificado_cliente_situacao
     * Sample of usage: $var->certificado_cliente_situacao = $object;
     * @param $object Instance of CertificadoClienteSituacao
     */
    public function set_certificado_cliente_situacao(CertificadoClienteSituacao $object)
    {
        $this->certificado_cliente_situacao = $object;
        $this->certificado_cliente_situacao_id = $object->id;
    }

    /**
     * Method get_certificado_cliente_situacao
     * Sample of usage: $var->certificado_cliente_situacao->attribute;
     * @returns CertificadoClienteSituacao instance
     */
    public function get_certificado_cliente_situacao()
    {
    
        // loads the associated object
        if (empty($this->certificado_cliente_situacao))
            $this->certificado_cliente_situacao = new CertificadoClienteSituacao($this->certificado_cliente_situacao_id);
    
        // returns the associated object
        return $this->certificado_cliente_situacao;
    }

    /**
     * Method getCertificadoEmailHistoricos
     */
    public function getCertificadoEmailHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_cliente_id', '=', $this->id));
        return CertificadoEmailHistorico::getObjects( $criteria );
    }

    public function set_certificado_email_historico_certificado_cliente_to_string($certificado_email_historico_certificado_cliente_to_string)
    {
        if(is_array($certificado_email_historico_certificado_cliente_to_string))
        {
            $values = CertificadoCliente::where('id', 'in', $certificado_email_historico_certificado_cliente_to_string)->getIndexedArray('id', 'id');
            $this->certificado_email_historico_certificado_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_email_historico_certificado_cliente_to_string = $certificado_email_historico_certificado_cliente_to_string;
        }

        $this->vdata['certificado_email_historico_certificado_cliente_to_string'] = $this->certificado_email_historico_certificado_cliente_to_string;
    }

    public function get_certificado_email_historico_certificado_cliente_to_string()
    {
        if(!empty($this->certificado_email_historico_certificado_cliente_to_string))
        {
            return $this->certificado_email_historico_certificado_cliente_to_string;
        }
    
        $values = CertificadoEmailHistorico::where('certificado_cliente_id', '=', $this->id)->getIndexedArray('certificado_cliente_id','{certificado_cliente->id}');
        return implode(', ', $values);
    }

    
}

