<?php

class CertificadoClienteSituacao extends TRecord
{
    const TABLENAME  = 'certificado_cliente_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const AguardandoRenovacao = '1';
    const Renovado = '2';
    const NaoRenovado = '3';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getCertificadoClientes
     */
    public function getCertificadoClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_cliente_situacao_id', '=', $this->id));
        return CertificadoCliente::getObjects( $criteria );
    }

    public function set_certificado_cliente_cliente_to_string($certificado_cliente_cliente_to_string)
    {
        if(is_array($certificado_cliente_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_cliente_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_cliente_to_string = $certificado_cliente_cliente_to_string;
        }

        $this->vdata['certificado_cliente_cliente_to_string'] = $this->certificado_cliente_cliente_to_string;
    }

    public function get_certificado_cliente_cliente_to_string()
    {
        if(!empty($this->certificado_cliente_cliente_to_string))
        {
            return $this->certificado_cliente_cliente_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_cliente_situacao_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_parceiro_to_string($certificado_cliente_parceiro_to_string)
    {
        if(is_array($certificado_cliente_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_cliente_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_parceiro_to_string = $certificado_cliente_parceiro_to_string;
        }

        $this->vdata['certificado_cliente_parceiro_to_string'] = $this->certificado_cliente_parceiro_to_string;
    }

    public function get_certificado_cliente_parceiro_to_string()
    {
        if(!empty($this->certificado_cliente_parceiro_to_string))
        {
            return $this->certificado_cliente_parceiro_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_cliente_situacao_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_produto_to_string($certificado_cliente_produto_to_string)
    {
        if(is_array($certificado_cliente_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_cliente_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_produto_to_string = $certificado_cliente_produto_to_string;
        }

        $this->vdata['certificado_cliente_produto_to_string'] = $this->certificado_cliente_produto_to_string;
    }

    public function get_certificado_cliente_produto_to_string()
    {
        if(!empty($this->certificado_cliente_produto_to_string))
        {
            return $this->certificado_cliente_produto_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_cliente_situacao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_cliente_situacao_to_string($certificado_cliente_certificado_cliente_situacao_to_string)
    {
        if(is_array($certificado_cliente_certificado_cliente_situacao_to_string))
        {
            $values = CertificadoClienteSituacao::where('id', 'in', $certificado_cliente_certificado_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_cliente_certificado_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_cliente_situacao_to_string = $certificado_cliente_certificado_cliente_situacao_to_string;
        }

        $this->vdata['certificado_cliente_certificado_cliente_situacao_to_string'] = $this->certificado_cliente_certificado_cliente_situacao_to_string;
    }

    public function get_certificado_cliente_certificado_cliente_situacao_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_cliente_situacao_to_string))
        {
            return $this->certificado_cliente_certificado_cliente_situacao_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_cliente_situacao_id', '=', $this->id)->getIndexedArray('certificado_cliente_situacao_id','{certificado_cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_venda_to_string($certificado_cliente_certificado_venda_to_string)
    {
        if(is_array($certificado_cliente_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_cliente_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_cliente_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_venda_to_string = $certificado_cliente_certificado_venda_to_string;
        }

        $this->vdata['certificado_cliente_certificado_venda_to_string'] = $this->certificado_cliente_certificado_venda_to_string;
    }

    public function get_certificado_cliente_certificado_venda_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_venda_to_string))
        {
            return $this->certificado_cliente_certificado_venda_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_cliente_situacao_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    
}

