<?php

class CertificadoVenda extends TRecord
{
    const TABLENAME  = 'certificado_venda';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $cliente;
    private $produto;
    private $parceiro;
    private $certificado_agente_registro;
    private $certificado_venda_situacao;
    private $certificado_venda_modalidade;
    private $certificado_venda_tipomodalidade;
    private $certificado_tipo_repasse;
    private $vendedor;
    private $system_unit;
    private $tabela_preco;
    private $certificado_tipo_atendimento;
    private $certificadora;

    const Permissao_DesfazerAtendimento = 'Desfazer atendimento de venda de certificado';
    const Evento_VendaCertificadoIncluidaOuAlterada = 'Venda de certificado incluída ou alterada';
    const Evento_VendaCertificadoFinalizada = 'Venda de certificado finalizada';
    const Evento_VendaCertificadoDesfeita = 'Venda de certificado desfeita';
    const Evento_VendaCertificadoCancelada = 'Venda de certificado cancelada';
    const Evento_VendaCertificadoAgendada = 'Venda de certificado agendada';
            

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('cliente_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('parceiro_id');
        parent::addAttribute('certificado_agente_registro_id');
        parent::addAttribute('certificado_venda_situacao_id');
        parent::addAttribute('certificado_venda_modalidade_id');
        parent::addAttribute('certificado_venda_tipomodalidade_id');
        parent::addAttribute('certificado_tipo_repasse_id');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('tabela_preco_id');
        parent::addAttribute('certificadora_id');
        parent::addAttribute('valor_custo');
        parent::addAttribute('data_hora_agendamento');
        parent::addAttribute('data_vencimento_certificado');
        parent::addAttribute('valor_externo');
        parent::addAttribute('custo_externo');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('agente_comissao_percentual');
        parent::addAttribute('agente_comissao_valor');
        parent::addAttribute('vendedor_comissao_percentual');
        parent::addAttribute('vendedor_comissao_valor');
        parent::addAttribute('atendimento_externo');
        parent::addAttribute('parceiro_comissao_percentual');
        parent::addAttribute('parceiro_valor_repasse');
        parent::addAttribute('valor_total');
        parent::addAttribute('comissao_total');
        parent::addAttribute('lucro_total');
        parent::addAttribute('valor_cliente');
        parent::addAttribute('valor_produto');
        parent::addAttribute('protocolo_emissao');
        parent::addAttribute('data_emissao');
        parent::addAttribute('data_pagamento');
        parent::addAttribute('certificado_tipo_atendimento_id');
        parent::addAttribute('observacao');
    
    }

    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_parceiro
     * Sample of usage: $var->parceiro = $object;
     * @param $object Instance of Parceiro
     */
    public function set_parceiro(Parceiro $object)
    {
        $this->parceiro = $object;
        $this->parceiro_id = $object->id;
    }

    /**
     * Method get_parceiro
     * Sample of usage: $var->parceiro->attribute;
     * @returns Parceiro instance
     */
    public function get_parceiro()
    {
    
        // loads the associated object
        if (empty($this->parceiro))
            $this->parceiro = new Parceiro($this->parceiro_id);
    
        // returns the associated object
        return $this->parceiro;
    }
    /**
     * Method set_certificado_agente_registro
     * Sample of usage: $var->certificado_agente_registro = $object;
     * @param $object Instance of CertificadoAgenteRegistro
     */
    public function set_certificado_agente_registro(CertificadoAgenteRegistro $object)
    {
        $this->certificado_agente_registro = $object;
        $this->certificado_agente_registro_id = $object->id;
    }

    /**
     * Method get_certificado_agente_registro
     * Sample of usage: $var->certificado_agente_registro->attribute;
     * @returns CertificadoAgenteRegistro instance
     */
    public function get_certificado_agente_registro()
    {
    
        // loads the associated object
        if (empty($this->certificado_agente_registro))
            $this->certificado_agente_registro = new CertificadoAgenteRegistro($this->certificado_agente_registro_id);
    
        // returns the associated object
        return $this->certificado_agente_registro;
    }
    /**
     * Method set_certificado_venda_situacao
     * Sample of usage: $var->certificado_venda_situacao = $object;
     * @param $object Instance of CertificadoVendaSituacao
     */
    public function set_certificado_venda_situacao(CertificadoVendaSituacao $object)
    {
        $this->certificado_venda_situacao = $object;
        $this->certificado_venda_situacao_id = $object->id;
    }

    /**
     * Method get_certificado_venda_situacao
     * Sample of usage: $var->certificado_venda_situacao->attribute;
     * @returns CertificadoVendaSituacao instance
     */
    public function get_certificado_venda_situacao()
    {
    
        // loads the associated object
        if (empty($this->certificado_venda_situacao))
            $this->certificado_venda_situacao = new CertificadoVendaSituacao($this->certificado_venda_situacao_id);
    
        // returns the associated object
        return $this->certificado_venda_situacao;
    }
    /**
     * Method set_certificado_venda_modalidade
     * Sample of usage: $var->certificado_venda_modalidade = $object;
     * @param $object Instance of CertificadoVendaModalidade
     */
    public function set_certificado_venda_modalidade(CertificadoVendaModalidade $object)
    {
        $this->certificado_venda_modalidade = $object;
        $this->certificado_venda_modalidade_id = $object->id;
    }

    /**
     * Method get_certificado_venda_modalidade
     * Sample of usage: $var->certificado_venda_modalidade->attribute;
     * @returns CertificadoVendaModalidade instance
     */
    public function get_certificado_venda_modalidade()
    {
    
        // loads the associated object
        if (empty($this->certificado_venda_modalidade))
            $this->certificado_venda_modalidade = new CertificadoVendaModalidade($this->certificado_venda_modalidade_id);
    
        // returns the associated object
        return $this->certificado_venda_modalidade;
    }
    /**
     * Method set_certificado_venda_tipomodalidade
     * Sample of usage: $var->certificado_venda_tipomodalidade = $object;
     * @param $object Instance of CertificadoVendaTipomodalidade
     */
    public function set_certificado_venda_tipomodalidade(CertificadoVendaTipomodalidade $object)
    {
        $this->certificado_venda_tipomodalidade = $object;
        $this->certificado_venda_tipomodalidade_id = $object->id;
    }

    /**
     * Method get_certificado_venda_tipomodalidade
     * Sample of usage: $var->certificado_venda_tipomodalidade->attribute;
     * @returns CertificadoVendaTipomodalidade instance
     */
    public function get_certificado_venda_tipomodalidade()
    {
    
        // loads the associated object
        if (empty($this->certificado_venda_tipomodalidade))
            $this->certificado_venda_tipomodalidade = new CertificadoVendaTipomodalidade($this->certificado_venda_tipomodalidade_id);
    
        // returns the associated object
        return $this->certificado_venda_tipomodalidade;
    }
    /**
     * Method set_certificado_tipo_repasse
     * Sample of usage: $var->certificado_tipo_repasse = $object;
     * @param $object Instance of CertificadoTipoRepasse
     */
    public function set_certificado_tipo_repasse(CertificadoTipoRepasse $object)
    {
        $this->certificado_tipo_repasse = $object;
        $this->certificado_tipo_repasse_id = $object->id;
    }

    /**
     * Method get_certificado_tipo_repasse
     * Sample of usage: $var->certificado_tipo_repasse->attribute;
     * @returns CertificadoTipoRepasse instance
     */
    public function get_certificado_tipo_repasse()
    {
    
        // loads the associated object
        if (empty($this->certificado_tipo_repasse))
            $this->certificado_tipo_repasse = new CertificadoTipoRepasse($this->certificado_tipo_repasse_id);
    
        // returns the associated object
        return $this->certificado_tipo_repasse;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_tabela_preco
     * Sample of usage: $var->tabela_preco = $object;
     * @param $object Instance of TabelaPreco
     */
    public function set_tabela_preco(TabelaPreco $object)
    {
        $this->tabela_preco = $object;
        $this->tabela_preco_id = $object->id;
    }

    /**
     * Method get_tabela_preco
     * Sample of usage: $var->tabela_preco->attribute;
     * @returns TabelaPreco instance
     */
    public function get_tabela_preco()
    {
    
        // loads the associated object
        if (empty($this->tabela_preco))
            $this->tabela_preco = new TabelaPreco($this->tabela_preco_id);
    
        // returns the associated object
        return $this->tabela_preco;
    }
    /**
     * Method set_certificado_tipo_atendimento
     * Sample of usage: $var->certificado_tipo_atendimento = $object;
     * @param $object Instance of CertificadoTipoAtendimento
     */
    public function set_certificado_tipo_atendimento(CertificadoTipoAtendimento $object)
    {
        $this->certificado_tipo_atendimento = $object;
        $this->certificado_tipo_atendimento_id = $object->id;
    }

    /**
     * Method get_certificado_tipo_atendimento
     * Sample of usage: $var->certificado_tipo_atendimento->attribute;
     * @returns CertificadoTipoAtendimento instance
     */
    public function get_certificado_tipo_atendimento()
    {
    
        // loads the associated object
        if (empty($this->certificado_tipo_atendimento))
            $this->certificado_tipo_atendimento = new CertificadoTipoAtendimento($this->certificado_tipo_atendimento_id);
    
        // returns the associated object
        return $this->certificado_tipo_atendimento;
    }
    /**
     * Method set_certificadora
     * Sample of usage: $var->certificadora = $object;
     * @param $object Instance of Certificadora
     */
    public function set_certificadora(Certificadora $object)
    {
        $this->certificadora = $object;
        $this->certificadora_id = $object->id;
    }

    /**
     * Method get_certificadora
     * Sample of usage: $var->certificadora->attribute;
     * @returns Certificadora instance
     */
    public function get_certificadora()
    {
    
        // loads the associated object
        if (empty($this->certificadora))
            $this->certificadora = new Certificadora($this->certificadora_id);
    
        // returns the associated object
        return $this->certificadora;
    }

    /**
     * Method getCertificadoAgendamentoss
     */
    public function getCertificadoAgendamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_venda_id', '=', $this->id));
        return CertificadoAgendamentos::getObjects( $criteria );
    }
    /**
     * Method getCertificadoClientes
     */
    public function getCertificadoClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_venda_id', '=', $this->id));
        return CertificadoCliente::getObjects( $criteria );
    }
    /**
     * Method getCertificadoVendaDocumentoss
     */
    public function getCertificadoVendaDocumentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_venda_id', '=', $this->id));
        return CertificadoVendaDocumentos::getObjects( $criteria );
    }
    /**
     * Method getCertificadoVendaFormapgtos
     */
    public function getCertificadoVendaFormapgtos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_venda_id', '=', $this->id));
        return CertificadoVendaFormapgto::getObjects( $criteria );
    }

    public function set_certificado_agendamentos_certificado_venda_to_string($certificado_agendamentos_certificado_venda_to_string)
    {
        if(is_array($certificado_agendamentos_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_agendamentos_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_agendamentos_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_agendamentos_certificado_venda_to_string = $certificado_agendamentos_certificado_venda_to_string;
        }

        $this->vdata['certificado_agendamentos_certificado_venda_to_string'] = $this->certificado_agendamentos_certificado_venda_to_string;
    }

    public function get_certificado_agendamentos_certificado_venda_to_string()
    {
        if(!empty($this->certificado_agendamentos_certificado_venda_to_string))
        {
            return $this->certificado_agendamentos_certificado_venda_to_string;
        }
    
        $values = CertificadoAgendamentos::where('certificado_venda_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_cliente_to_string($certificado_cliente_cliente_to_string)
    {
        if(is_array($certificado_cliente_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_cliente_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_cliente_to_string = $certificado_cliente_cliente_to_string;
        }

        $this->vdata['certificado_cliente_cliente_to_string'] = $this->certificado_cliente_cliente_to_string;
    }

    public function get_certificado_cliente_cliente_to_string()
    {
        if(!empty($this->certificado_cliente_cliente_to_string))
        {
            return $this->certificado_cliente_cliente_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_venda_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_parceiro_to_string($certificado_cliente_parceiro_to_string)
    {
        if(is_array($certificado_cliente_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_cliente_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_parceiro_to_string = $certificado_cliente_parceiro_to_string;
        }

        $this->vdata['certificado_cliente_parceiro_to_string'] = $this->certificado_cliente_parceiro_to_string;
    }

    public function get_certificado_cliente_parceiro_to_string()
    {
        if(!empty($this->certificado_cliente_parceiro_to_string))
        {
            return $this->certificado_cliente_parceiro_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_venda_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_produto_to_string($certificado_cliente_produto_to_string)
    {
        if(is_array($certificado_cliente_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_cliente_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_produto_to_string = $certificado_cliente_produto_to_string;
        }

        $this->vdata['certificado_cliente_produto_to_string'] = $this->certificado_cliente_produto_to_string;
    }

    public function get_certificado_cliente_produto_to_string()
    {
        if(!empty($this->certificado_cliente_produto_to_string))
        {
            return $this->certificado_cliente_produto_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_venda_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_cliente_situacao_to_string($certificado_cliente_certificado_cliente_situacao_to_string)
    {
        if(is_array($certificado_cliente_certificado_cliente_situacao_to_string))
        {
            $values = CertificadoClienteSituacao::where('id', 'in', $certificado_cliente_certificado_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_cliente_certificado_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_cliente_situacao_to_string = $certificado_cliente_certificado_cliente_situacao_to_string;
        }

        $this->vdata['certificado_cliente_certificado_cliente_situacao_to_string'] = $this->certificado_cliente_certificado_cliente_situacao_to_string;
    }

    public function get_certificado_cliente_certificado_cliente_situacao_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_cliente_situacao_to_string))
        {
            return $this->certificado_cliente_certificado_cliente_situacao_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_venda_id', '=', $this->id)->getIndexedArray('certificado_cliente_situacao_id','{certificado_cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_venda_to_string($certificado_cliente_certificado_venda_to_string)
    {
        if(is_array($certificado_cliente_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_cliente_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_cliente_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_venda_to_string = $certificado_cliente_certificado_venda_to_string;
        }

        $this->vdata['certificado_cliente_certificado_venda_to_string'] = $this->certificado_cliente_certificado_venda_to_string;
    }

    public function get_certificado_cliente_certificado_venda_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_venda_to_string))
        {
            return $this->certificado_cliente_certificado_venda_to_string;
        }
    
        $values = CertificadoCliente::where('certificado_venda_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_documentos_certificado_venda_to_string($certificado_venda_documentos_certificado_venda_to_string)
    {
        if(is_array($certificado_venda_documentos_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_venda_documentos_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_venda_documentos_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_documentos_certificado_venda_to_string = $certificado_venda_documentos_certificado_venda_to_string;
        }

        $this->vdata['certificado_venda_documentos_certificado_venda_to_string'] = $this->certificado_venda_documentos_certificado_venda_to_string;
    }

    public function get_certificado_venda_documentos_certificado_venda_to_string()
    {
        if(!empty($this->certificado_venda_documentos_certificado_venda_to_string))
        {
            return $this->certificado_venda_documentos_certificado_venda_to_string;
        }
    
        $values = CertificadoVendaDocumentos::where('certificado_venda_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_formapgto_certificado_venda_to_string($certificado_venda_formapgto_certificado_venda_to_string)
    {
        if(is_array($certificado_venda_formapgto_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_venda_formapgto_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_venda_formapgto_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_formapgto_certificado_venda_to_string = $certificado_venda_formapgto_certificado_venda_to_string;
        }

        $this->vdata['certificado_venda_formapgto_certificado_venda_to_string'] = $this->certificado_venda_formapgto_certificado_venda_to_string;
    }

    public function get_certificado_venda_formapgto_certificado_venda_to_string()
    {
        if(!empty($this->certificado_venda_formapgto_certificado_venda_to_string))
        {
            return $this->certificado_venda_formapgto_certificado_venda_to_string;
        }
    
        $values = CertificadoVendaFormapgto::where('certificado_venda_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_formapgto_forma_pagamento_to_string($certificado_venda_formapgto_forma_pagamento_to_string)
    {
        if(is_array($certificado_venda_formapgto_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $certificado_venda_formapgto_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_formapgto_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_formapgto_forma_pagamento_to_string = $certificado_venda_formapgto_forma_pagamento_to_string;
        }

        $this->vdata['certificado_venda_formapgto_forma_pagamento_to_string'] = $this->certificado_venda_formapgto_forma_pagamento_to_string;
    }

    public function get_certificado_venda_formapgto_forma_pagamento_to_string()
    {
        if(!empty($this->certificado_venda_formapgto_forma_pagamento_to_string))
        {
            return $this->certificado_venda_formapgto_forma_pagamento_to_string;
        }
    
        $values = CertificadoVendaFormapgto::where('certificado_venda_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public static function SincronizaPermissoesEspeciais()
    {
        SystemProgramPermissoes::ProcessaPermissao('CertificadoVendaFormView',self::Permissao_DesfazerAtendimento);
        SystemProgramPermissoes::ProcessaPermissao('CertificadoVendaList',self::Permissao_DesfazerAtendimento);
  
    }

    public static function ConfigEvento_VendaCertificadoIncluidaOuAlterada($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Venda de certificado incluida ou alterada";
       $mensagem = "Id da venda: ".$id." OBS: ".$obs;
       $acao = new TAction(['CertificadoVendaFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function ConfigEvento_VendaCertificadoFinalizada($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Venda de certificado finalizada";
       $mensagem = "Id da venda: ".$id." OBS: ".$obs;
       $acao = new TAction(['CertificadoVendaFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }    

    public static function ConfigEvento_VendaCertificadoDesfeita($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Venda de certificado desfeita";
       $mensagem = "Id da venda: ".$id." OBS: ".$obs;
       $acao = new TAction(['CertificadoVendaFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    } 

    public static function ConfigEvento_VendaCertificadoCancelada($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Venda de certificado cancelada";
       $mensagem = "Id da venda: ".$id." OBS: ".$obs;
       $acao = new TAction(['CertificadoVendaFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function ConfigEvento_VendaCertificadoAgendada($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Venda de certificado agendada";
       $mensagem = "Id da venda: ".$id." OBS: ".$obs;
       $acao = new TAction(['CertificadoVendaFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }    
    

    public static function SincronizaEventos()
    {
       Eventos::ProcessaEventos('CertificadoVendaForm',self::Evento_VendaCertificadoIncluidaOuAlterada);
       Eventos::ProcessaEventos('CertificadoVendaForm',self::Evento_VendaCertificadoFinalizada);   
       Eventos::ProcessaEventos('CertificadoVendaForm',self::Evento_VendaCertificadoDesfeita);
       Eventos::ProcessaEventos('CertificadoVendaForm',self::Evento_VendaCertificadoCancelada);
       Eventos::ProcessaEventos('CertificadoVendaForm',self::Evento_VendaCertificadoAgendada);
    } 
  
            
}

