<?php

class CertificadoVendaFormapgto extends TRecord
{
    const TABLENAME  = 'certificado_venda_formapgto';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $certificado_venda;
    private $forma_pagamento;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('certificado_venda_id');
        parent::addAttribute('forma_pagamento_id');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_certificado_venda
     * Sample of usage: $var->certificado_venda = $object;
     * @param $object Instance of CertificadoVenda
     */
    public function set_certificado_venda(CertificadoVenda $object)
    {
        $this->certificado_venda = $object;
        $this->certificado_venda_id = $object->id;
    }

    /**
     * Method get_certificado_venda
     * Sample of usage: $var->certificado_venda->attribute;
     * @returns CertificadoVenda instance
     */
    public function get_certificado_venda()
    {
    
        // loads the associated object
        if (empty($this->certificado_venda))
            $this->certificado_venda = new CertificadoVenda($this->certificado_venda_id);
    
        // returns the associated object
        return $this->certificado_venda;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento(FormaPagamento $object)
    {
        $this->forma_pagamento = $object;
        $this->forma_pagamento_id = $object->id;
    }

    /**
     * Method get_forma_pagamento
     * Sample of usage: $var->forma_pagamento->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento))
            $this->forma_pagamento = new FormaPagamento($this->forma_pagamento_id);
    
        // returns the associated object
        return $this->forma_pagamento;
    }

    
}

