<?php

class CertificadoVendaModalidade extends TRecord
{
    const TABLENAME  = 'certificado_venda_modalidade';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $certificado_venda_tipomodalidade;
    private $certificado_tipo_repasse;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('certificado_tipo_repasse_id');
        parent::addAttribute('certificado_venda_tipomodalidade_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_certificado_venda_tipomodalidade
     * Sample of usage: $var->certificado_venda_tipomodalidade = $object;
     * @param $object Instance of CertificadoVendaTipomodalidade
     */
    public function set_certificado_venda_tipomodalidade(CertificadoVendaTipomodalidade $object)
    {
        $this->certificado_venda_tipomodalidade = $object;
        $this->certificado_venda_tipomodalidade_id = $object->id;
    }

    /**
     * Method get_certificado_venda_tipomodalidade
     * Sample of usage: $var->certificado_venda_tipomodalidade->attribute;
     * @returns CertificadoVendaTipomodalidade instance
     */
    public function get_certificado_venda_tipomodalidade()
    {
    
        // loads the associated object
        if (empty($this->certificado_venda_tipomodalidade))
            $this->certificado_venda_tipomodalidade = new CertificadoVendaTipomodalidade($this->certificado_venda_tipomodalidade_id);
    
        // returns the associated object
        return $this->certificado_venda_tipomodalidade;
    }
    /**
     * Method set_certificado_tipo_repasse
     * Sample of usage: $var->certificado_tipo_repasse = $object;
     * @param $object Instance of CertificadoTipoRepasse
     */
    public function set_certificado_tipo_repasse(CertificadoTipoRepasse $object)
    {
        $this->certificado_tipo_repasse = $object;
        $this->certificado_tipo_repasse_id = $object->id;
    }

    /**
     * Method get_certificado_tipo_repasse
     * Sample of usage: $var->certificado_tipo_repasse->attribute;
     * @returns CertificadoTipoRepasse instance
     */
    public function get_certificado_tipo_repasse()
    {
    
        // loads the associated object
        if (empty($this->certificado_tipo_repasse))
            $this->certificado_tipo_repasse = new CertificadoTipoRepasse($this->certificado_tipo_repasse_id);
    
        // returns the associated object
        return $this->certificado_tipo_repasse;
    }

    /**
     * Method getCertificadoVendas
     */
    public function getCertificadoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_venda_modalidade_id', '=', $this->id));
        return CertificadoVenda::getObjects( $criteria );
    }
    /**
     * Method getParceiros
     */
    public function getParceiros()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('certificado_venda_modalidade_id', '=', $this->id));
        return Parceiro::getObjects( $criteria );
    }

    public function set_certificado_venda_system_unit_to_string($certificado_venda_system_unit_to_string)
    {
        if(is_array($certificado_venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $certificado_venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->certificado_venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_system_unit_to_string = $certificado_venda_system_unit_to_string;
        }

        $this->vdata['certificado_venda_system_unit_to_string'] = $this->certificado_venda_system_unit_to_string;
    }

    public function get_certificado_venda_system_unit_to_string()
    {
        if(!empty($this->certificado_venda_system_unit_to_string))
        {
            return $this->certificado_venda_system_unit_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_cliente_to_string($certificado_venda_cliente_to_string)
    {
        if(is_array($certificado_venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_cliente_to_string = $certificado_venda_cliente_to_string;
        }

        $this->vdata['certificado_venda_cliente_to_string'] = $this->certificado_venda_cliente_to_string;
    }

    public function get_certificado_venda_cliente_to_string()
    {
        if(!empty($this->certificado_venda_cliente_to_string))
        {
            return $this->certificado_venda_cliente_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_produto_to_string($certificado_venda_produto_to_string)
    {
        if(is_array($certificado_venda_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_venda_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_produto_to_string = $certificado_venda_produto_to_string;
        }

        $this->vdata['certificado_venda_produto_to_string'] = $this->certificado_venda_produto_to_string;
    }

    public function get_certificado_venda_produto_to_string()
    {
        if(!empty($this->certificado_venda_produto_to_string))
        {
            return $this->certificado_venda_produto_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_parceiro_to_string($certificado_venda_parceiro_to_string)
    {
        if(is_array($certificado_venda_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_venda_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_parceiro_to_string = $certificado_venda_parceiro_to_string;
        }

        $this->vdata['certificado_venda_parceiro_to_string'] = $this->certificado_venda_parceiro_to_string;
    }

    public function get_certificado_venda_parceiro_to_string()
    {
        if(!empty($this->certificado_venda_parceiro_to_string))
        {
            return $this->certificado_venda_parceiro_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_agente_registro_to_string($certificado_venda_certificado_agente_registro_to_string)
    {
        if(is_array($certificado_venda_certificado_agente_registro_to_string))
        {
            $values = CertificadoAgenteRegistro::where('id', 'in', $certificado_venda_certificado_agente_registro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificado_agente_registro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_agente_registro_to_string = $certificado_venda_certificado_agente_registro_to_string;
        }

        $this->vdata['certificado_venda_certificado_agente_registro_to_string'] = $this->certificado_venda_certificado_agente_registro_to_string;
    }

    public function get_certificado_venda_certificado_agente_registro_to_string()
    {
        if(!empty($this->certificado_venda_certificado_agente_registro_to_string))
        {
            return $this->certificado_venda_certificado_agente_registro_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificado_agente_registro_id','{certificado_agente_registro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_situacao_to_string($certificado_venda_certificado_venda_situacao_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_situacao_to_string))
        {
            $values = CertificadoVendaSituacao::where('id', 'in', $certificado_venda_certificado_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_situacao_to_string = $certificado_venda_certificado_venda_situacao_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_situacao_to_string'] = $this->certificado_venda_certificado_venda_situacao_to_string;
    }

    public function get_certificado_venda_certificado_venda_situacao_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_situacao_to_string))
        {
            return $this->certificado_venda_certificado_venda_situacao_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificado_venda_situacao_id','{certificado_venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_modalidade_to_string($certificado_venda_certificado_venda_modalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $certificado_venda_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_modalidade_to_string = $certificado_venda_certificado_venda_modalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_modalidade_to_string'] = $this->certificado_venda_certificado_venda_modalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_modalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_modalidade_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_tipomodalidade_to_string($certificado_venda_certificado_venda_tipomodalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            $values = CertificadoVendaTipomodalidade::where('id', 'in', $certificado_venda_certificado_venda_tipomodalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = $certificado_venda_certificado_venda_tipomodalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_tipomodalidade_to_string'] = $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_tipomodalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificado_venda_tipomodalidade_id','{certificado_venda_tipomodalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_repasse_to_string($certificado_venda_certificado_tipo_repasse_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_repasse_to_string))
        {
            $values = CertificadoTipoRepasse::where('id', 'in', $certificado_venda_certificado_tipo_repasse_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_repasse_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_repasse_to_string = $certificado_venda_certificado_tipo_repasse_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_repasse_to_string'] = $this->certificado_venda_certificado_tipo_repasse_to_string;
    }

    public function get_certificado_venda_certificado_tipo_repasse_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_repasse_to_string))
        {
            return $this->certificado_venda_certificado_tipo_repasse_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificado_tipo_repasse_id','{certificado_tipo_repasse->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_vendedor_to_string($certificado_venda_vendedor_to_string)
    {
        if(is_array($certificado_venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $certificado_venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_vendedor_to_string = $certificado_venda_vendedor_to_string;
        }

        $this->vdata['certificado_venda_vendedor_to_string'] = $this->certificado_venda_vendedor_to_string;
    }

    public function get_certificado_venda_vendedor_to_string()
    {
        if(!empty($this->certificado_venda_vendedor_to_string))
        {
            return $this->certificado_venda_vendedor_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_tabela_preco_to_string($certificado_venda_tabela_preco_to_string)
    {
        if(is_array($certificado_venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $certificado_venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_tabela_preco_to_string = $certificado_venda_tabela_preco_to_string;
        }

        $this->vdata['certificado_venda_tabela_preco_to_string'] = $this->certificado_venda_tabela_preco_to_string;
    }

    public function get_certificado_venda_tabela_preco_to_string()
    {
        if(!empty($this->certificado_venda_tabela_preco_to_string))
        {
            return $this->certificado_venda_tabela_preco_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificadora_to_string($certificado_venda_certificadora_to_string)
    {
        if(is_array($certificado_venda_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificado_venda_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificadora_to_string = $certificado_venda_certificadora_to_string;
        }

        $this->vdata['certificado_venda_certificadora_to_string'] = $this->certificado_venda_certificadora_to_string;
    }

    public function get_certificado_venda_certificadora_to_string()
    {
        if(!empty($this->certificado_venda_certificadora_to_string))
        {
            return $this->certificado_venda_certificadora_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_atendimento_to_string($certificado_venda_certificado_tipo_atendimento_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_atendimento_to_string))
        {
            $values = CertificadoTipoAtendimento::where('id', 'in', $certificado_venda_certificado_tipo_atendimento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_atendimento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_atendimento_to_string = $certificado_venda_certificado_tipo_atendimento_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_atendimento_to_string'] = $this->certificado_venda_certificado_tipo_atendimento_to_string;
    }

    public function get_certificado_venda_certificado_tipo_atendimento_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_atendimento_to_string))
        {
            return $this->certificado_venda_certificado_tipo_atendimento_to_string;
        }
    
        $values = CertificadoVenda::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificado_tipo_atendimento_id','{certificado_tipo_atendimento->descricao}');
        return implode(', ', $values);
    }

    public function set_parceiro_certificado_venda_modalidade_to_string($parceiro_certificado_venda_modalidade_to_string)
    {
        if(is_array($parceiro_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $parceiro_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_certificado_venda_modalidade_to_string = $parceiro_certificado_venda_modalidade_to_string;
        }

        $this->vdata['parceiro_certificado_venda_modalidade_to_string'] = $this->parceiro_certificado_venda_modalidade_to_string;
    }

    public function get_parceiro_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->parceiro_certificado_venda_modalidade_to_string))
        {
            return $this->parceiro_certificado_venda_modalidade_to_string;
        }
    
        $values = Parceiro::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_parceiro_tabela_preco_to_string($parceiro_tabela_preco_to_string)
    {
        if(is_array($parceiro_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $parceiro_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_tabela_preco_to_string = $parceiro_tabela_preco_to_string;
        }

        $this->vdata['parceiro_tabela_preco_to_string'] = $this->parceiro_tabela_preco_to_string;
    }

    public function get_parceiro_tabela_preco_to_string()
    {
        if(!empty($this->parceiro_tabela_preco_to_string))
        {
            return $this->parceiro_tabela_preco_to_string;
        }
    
        $values = Parceiro::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_parceiro_vendedor_to_string($parceiro_vendedor_to_string)
    {
        if(is_array($parceiro_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $parceiro_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->parceiro_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_vendedor_to_string = $parceiro_vendedor_to_string;
        }

        $this->vdata['parceiro_vendedor_to_string'] = $this->parceiro_vendedor_to_string;
    }

    public function get_parceiro_vendedor_to_string()
    {
        if(!empty($this->parceiro_vendedor_to_string))
        {
            return $this->parceiro_vendedor_to_string;
        }
    
        $values = Parceiro::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_parceiro_banco_to_string($parceiro_banco_to_string)
    {
        if(is_array($parceiro_banco_to_string))
        {
            $values = Banco::where('id', 'in', $parceiro_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->parceiro_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_banco_to_string = $parceiro_banco_to_string;
        }

        $this->vdata['parceiro_banco_to_string'] = $this->parceiro_banco_to_string;
    }

    public function get_parceiro_banco_to_string()
    {
        if(!empty($this->parceiro_banco_to_string))
        {
            return $this->parceiro_banco_to_string;
        }
    
        $values = Parceiro::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('banco_id','{banco->nome}');
        return implode(', ', $values);
    }

    public function set_parceiro_chave_pix_tipo_to_string($parceiro_chave_pix_tipo_to_string)
    {
        if(is_array($parceiro_chave_pix_tipo_to_string))
        {
            $values = ChavePixTipo::where('id', 'in', $parceiro_chave_pix_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_chave_pix_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_chave_pix_tipo_to_string = $parceiro_chave_pix_tipo_to_string;
        }

        $this->vdata['parceiro_chave_pix_tipo_to_string'] = $this->parceiro_chave_pix_tipo_to_string;
    }

    public function get_parceiro_chave_pix_tipo_to_string()
    {
        if(!empty($this->parceiro_chave_pix_tipo_to_string))
        {
            return $this->parceiro_chave_pix_tipo_to_string;
        }
    
        $values = Parceiro::where('certificado_venda_modalidade_id', '=', $this->id)->getIndexedArray('chave_pix_tipo_id','{chave_pix_tipo->descricao}');
        return implode(', ', $values);
    }

    
}

