<?php

class CertificadoraProdutos extends TRecord
{
    const TABLENAME  = 'certificadora_produtos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $certificadora;
    private $produto;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('certificadora_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('qtde_dias_vencimento');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('valor_custo');
            
    }

    /**
     * Method set_certificadora
     * Sample of usage: $var->certificadora = $object;
     * @param $object Instance of Certificadora
     */
    public function set_certificadora(Certificadora $object)
    {
        $this->certificadora = $object;
        $this->certificadora_id = $object->id;
    }

    /**
     * Method get_certificadora
     * Sample of usage: $var->certificadora->attribute;
     * @returns Certificadora instance
     */
    public function get_certificadora()
    {
    
        // loads the associated object
        if (empty($this->certificadora))
            $this->certificadora = new Certificadora($this->certificadora_id);
    
        // returns the associated object
        return $this->certificadora;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }

    
}

