<?php

class ChavePixTipo extends TRecord
{
    const TABLENAME  = 'chave_pix_tipo';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const CPFCNPJ = '1';
    const Email = '2';
    const Telefone = '3';
    const ChaveAleatoria = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getParceiros
     */
    public function getParceiros()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('chave_pix_tipo_id', '=', $this->id));
        return Parceiro::getObjects( $criteria );
    }

    public function set_parceiro_certificado_venda_modalidade_to_string($parceiro_certificado_venda_modalidade_to_string)
    {
        if(is_array($parceiro_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $parceiro_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_certificado_venda_modalidade_to_string = $parceiro_certificado_venda_modalidade_to_string;
        }

        $this->vdata['parceiro_certificado_venda_modalidade_to_string'] = $this->parceiro_certificado_venda_modalidade_to_string;
    }

    public function get_parceiro_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->parceiro_certificado_venda_modalidade_to_string))
        {
            return $this->parceiro_certificado_venda_modalidade_to_string;
        }
    
        $values = Parceiro::where('chave_pix_tipo_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_parceiro_tabela_preco_to_string($parceiro_tabela_preco_to_string)
    {
        if(is_array($parceiro_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $parceiro_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_tabela_preco_to_string = $parceiro_tabela_preco_to_string;
        }

        $this->vdata['parceiro_tabela_preco_to_string'] = $this->parceiro_tabela_preco_to_string;
    }

    public function get_parceiro_tabela_preco_to_string()
    {
        if(!empty($this->parceiro_tabela_preco_to_string))
        {
            return $this->parceiro_tabela_preco_to_string;
        }
    
        $values = Parceiro::where('chave_pix_tipo_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_parceiro_vendedor_to_string($parceiro_vendedor_to_string)
    {
        if(is_array($parceiro_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $parceiro_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->parceiro_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_vendedor_to_string = $parceiro_vendedor_to_string;
        }

        $this->vdata['parceiro_vendedor_to_string'] = $this->parceiro_vendedor_to_string;
    }

    public function get_parceiro_vendedor_to_string()
    {
        if(!empty($this->parceiro_vendedor_to_string))
        {
            return $this->parceiro_vendedor_to_string;
        }
    
        $values = Parceiro::where('chave_pix_tipo_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_parceiro_banco_to_string($parceiro_banco_to_string)
    {
        if(is_array($parceiro_banco_to_string))
        {
            $values = Banco::where('id', 'in', $parceiro_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->parceiro_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_banco_to_string = $parceiro_banco_to_string;
        }

        $this->vdata['parceiro_banco_to_string'] = $this->parceiro_banco_to_string;
    }

    public function get_parceiro_banco_to_string()
    {
        if(!empty($this->parceiro_banco_to_string))
        {
            return $this->parceiro_banco_to_string;
        }
    
        $values = Parceiro::where('chave_pix_tipo_id', '=', $this->id)->getIndexedArray('banco_id','{banco->nome}');
        return implode(', ', $values);
    }

    public function set_parceiro_chave_pix_tipo_to_string($parceiro_chave_pix_tipo_to_string)
    {
        if(is_array($parceiro_chave_pix_tipo_to_string))
        {
            $values = ChavePixTipo::where('id', 'in', $parceiro_chave_pix_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_chave_pix_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_chave_pix_tipo_to_string = $parceiro_chave_pix_tipo_to_string;
        }

        $this->vdata['parceiro_chave_pix_tipo_to_string'] = $this->parceiro_chave_pix_tipo_to_string;
    }

    public function get_parceiro_chave_pix_tipo_to_string()
    {
        if(!empty($this->parceiro_chave_pix_tipo_to_string))
        {
            return $this->parceiro_chave_pix_tipo_to_string;
        }
    
        $values = Parceiro::where('chave_pix_tipo_id', '=', $this->id)->getIndexedArray('chave_pix_tipo_id','{chave_pix_tipo->descricao}');
        return implode(', ', $values);
    }

    
}

