<?php

class Cidade extends TRecord
{
    const TABLENAME  = 'cidade';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $estado;
    private $pais;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('estado_id');
        parent::addAttribute('pais_id');
        parent::addAttribute('nome');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('codigo_ibge');
            
    }

    /**
     * Method set_estado
     * Sample of usage: $var->estado = $object;
     * @param $object Instance of Estado
     */
    public function set_estado(Estado $object)
    {
        $this->estado = $object;
        $this->estado_id = $object->id;
    }

    /**
     * Method get_estado
     * Sample of usage: $var->estado->attribute;
     * @returns Estado instance
     */
    public function get_estado()
    {
    
        // loads the associated object
        if (empty($this->estado))
            $this->estado = new Estado($this->estado_id);
    
        // returns the associated object
        return $this->estado;
    }
    /**
     * Method set_pais
     * Sample of usage: $var->pais = $object;
     * @param $object Instance of Pais
     */
    public function set_pais(Pais $object)
    {
        $this->pais = $object;
        $this->pais_id = $object->id;
    }

    /**
     * Method get_pais
     * Sample of usage: $var->pais->attribute;
     * @returns Pais instance
     */
    public function get_pais()
    {
    
        // loads the associated object
        if (empty($this->pais))
            $this->pais = new Pais($this->pais_id);
    
        // returns the associated object
        return $this->pais;
    }

    /**
     * Method getClienteEnderecos
     */
    public function getClienteEnderecos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cidade_id', '=', $this->id));
        return ClienteEndereco::getObjects( $criteria );
    }
    /**
     * Method getFornecedors
     */
    public function getFornecedors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cidade_id', '=', $this->id));
        return Fornecedor::getObjects( $criteria );
    }
    /**
     * Method getMdfes
     */
    public function getMdfes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cidade_encerramento_id', '=', $this->id));
        return Mdfe::getObjects( $criteria );
    }
    /**
     * Method getMdfeInclusaoDfes
     */
    public function getMdfeInclusaoDfesByCidadeCarregas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cidade_carrega_id', '=', $this->id));
        return MdfeInclusaoDfe::getObjects( $criteria );
    }
    /**
     * Method getMdfeInclusaoDfes
     */
    public function getMdfeInclusaoDfesByCidadeDescargas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cidade_descarga_id', '=', $this->id));
        return MdfeInclusaoDfe::getObjects( $criteria );
    }
    /**
     * Method getMdfeInfmuncarregas
     */
    public function getMdfeInfmuncarregas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cidade_id', '=', $this->id));
        return MdfeInfmuncarrega::getObjects( $criteria );
    }
    /**
     * Method getMdfeInfmundescargas
     */
    public function getMdfeInfmundescargas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cidade_id', '=', $this->id));
        return MdfeInfmundescarga::getObjects( $criteria );
    }

    public function set_cliente_endereco_cliente_to_string($cliente_endereco_cliente_to_string)
    {
        if(is_array($cliente_endereco_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $cliente_endereco_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_endereco_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_cliente_to_string = $cliente_endereco_cliente_to_string;
        }

        $this->vdata['cliente_endereco_cliente_to_string'] = $this->cliente_endereco_cliente_to_string;
    }

    public function get_cliente_endereco_cliente_to_string()
    {
        if(!empty($this->cliente_endereco_cliente_to_string))
        {
            return $this->cliente_endereco_cliente_to_string;
        }
    
        $values = ClienteEndereco::where('cidade_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_fk_principal_to_string($cliente_endereco_fk_principal_to_string)
    {
        if(is_array($cliente_endereco_fk_principal_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_endereco_fk_principal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_endereco_fk_principal_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_fk_principal_to_string = $cliente_endereco_fk_principal_to_string;
        }

        $this->vdata['cliente_endereco_fk_principal_to_string'] = $this->cliente_endereco_fk_principal_to_string;
    }

    public function get_cliente_endereco_fk_principal_to_string()
    {
        if(!empty($this->cliente_endereco_fk_principal_to_string))
        {
            return $this->cliente_endereco_fk_principal_to_string;
        }
    
        $values = ClienteEndereco::where('cidade_id', '=', $this->id)->getIndexedArray('principal','{fk_principal->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_cidade_to_string($cliente_endereco_cidade_to_string)
    {
        if(is_array($cliente_endereco_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $cliente_endereco_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_endereco_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_cidade_to_string = $cliente_endereco_cidade_to_string;
        }

        $this->vdata['cliente_endereco_cidade_to_string'] = $this->cliente_endereco_cidade_to_string;
    }

    public function get_cliente_endereco_cidade_to_string()
    {
        if(!empty($this->cliente_endereco_cidade_to_string))
        {
            return $this->cliente_endereco_cidade_to_string;
        }
    
        $values = ClienteEndereco::where('cidade_id', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    public function set_fornecedor_pessoa_tipo_to_string($fornecedor_pessoa_tipo_to_string)
    {
        if(is_array($fornecedor_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $fornecedor_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_pessoa_tipo_to_string = $fornecedor_pessoa_tipo_to_string;
        }

        $this->vdata['fornecedor_pessoa_tipo_to_string'] = $this->fornecedor_pessoa_tipo_to_string;
    }

    public function get_fornecedor_pessoa_tipo_to_string()
    {
        if(!empty($this->fornecedor_pessoa_tipo_to_string))
        {
            return $this->fornecedor_pessoa_tipo_to_string;
        }
    
        $values = Fornecedor::where('cidade_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_fornecedor_classificacao_to_string($fornecedor_fornecedor_classificacao_to_string)
    {
        if(is_array($fornecedor_fornecedor_classificacao_to_string))
        {
            $values = FornecedorClassificacao::where('id', 'in', $fornecedor_fornecedor_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_fornecedor_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_fornecedor_classificacao_to_string = $fornecedor_fornecedor_classificacao_to_string;
        }

        $this->vdata['fornecedor_fornecedor_classificacao_to_string'] = $this->fornecedor_fornecedor_classificacao_to_string;
    }

    public function get_fornecedor_fornecedor_classificacao_to_string()
    {
        if(!empty($this->fornecedor_fornecedor_classificacao_to_string))
        {
            return $this->fornecedor_fornecedor_classificacao_to_string;
        }
    
        $values = Fornecedor::where('cidade_id', '=', $this->id)->getIndexedArray('fornecedor_classificacao_id','{fornecedor_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_cidade_to_string($fornecedor_cidade_to_string)
    {
        if(is_array($fornecedor_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $fornecedor_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->fornecedor_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_cidade_to_string = $fornecedor_cidade_to_string;
        }

        $this->vdata['fornecedor_cidade_to_string'] = $this->fornecedor_cidade_to_string;
    }

    public function get_fornecedor_cidade_to_string()
    {
        if(!empty($this->fornecedor_cidade_to_string))
        {
            return $this->fornecedor_cidade_to_string;
        }
    
        $values = Fornecedor::where('cidade_id', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    public function set_fornecedor_notafiscal_crt_to_string($fornecedor_notafiscal_crt_to_string)
    {
        if(is_array($fornecedor_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $fornecedor_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_notafiscal_crt_to_string = $fornecedor_notafiscal_crt_to_string;
        }

        $this->vdata['fornecedor_notafiscal_crt_to_string'] = $this->fornecedor_notafiscal_crt_to_string;
    }

    public function get_fornecedor_notafiscal_crt_to_string()
    {
        if(!empty($this->fornecedor_notafiscal_crt_to_string))
        {
            return $this->fornecedor_notafiscal_crt_to_string;
        }
    
        $values = Fornecedor::where('cidade_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_notafiscal_indiedest_to_string($fornecedor_notafiscal_indiedest_to_string)
    {
        if(is_array($fornecedor_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $fornecedor_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_notafiscal_indiedest_to_string = $fornecedor_notafiscal_indiedest_to_string;
        }

        $this->vdata['fornecedor_notafiscal_indiedest_to_string'] = $this->fornecedor_notafiscal_indiedest_to_string;
    }

    public function get_fornecedor_notafiscal_indiedest_to_string()
    {
        if(!empty($this->fornecedor_notafiscal_indiedest_to_string))
        {
            return $this->fornecedor_notafiscal_indiedest_to_string;
        }
    
        $values = Fornecedor::where('cidade_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_system_unit_to_string($mdfe_system_unit_to_string)
    {
        if(is_array($mdfe_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $mdfe_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->mdfe_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_system_unit_to_string = $mdfe_system_unit_to_string;
        }

        $this->vdata['mdfe_system_unit_to_string'] = $this->mdfe_system_unit_to_string;
    }

    public function get_mdfe_system_unit_to_string()
    {
        if(!empty($this->mdfe_system_unit_to_string))
        {
            return $this->mdfe_system_unit_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpemit_to_string($mdfe_mdfe_tpemit_to_string)
    {
        if(is_array($mdfe_mdfe_tpemit_to_string))
        {
            $values = MdfeTpemit::where('id', 'in', $mdfe_mdfe_tpemit_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpemit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpemit_to_string = $mdfe_mdfe_tpemit_to_string;
        }

        $this->vdata['mdfe_mdfe_tpemit_to_string'] = $this->mdfe_mdfe_tpemit_to_string;
    }

    public function get_mdfe_mdfe_tpemit_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpemit_to_string))
        {
            return $this->mdfe_mdfe_tpemit_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_tpemit_id','{mdfe_tpemit->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpprop_to_string($mdfe_mdfe_tpprop_to_string)
    {
        if(is_array($mdfe_mdfe_tpprop_to_string))
        {
            $values = MdfeTpprop::where('id', 'in', $mdfe_mdfe_tpprop_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpprop_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpprop_to_string = $mdfe_mdfe_tpprop_to_string;
        }

        $this->vdata['mdfe_mdfe_tpprop_to_string'] = $this->mdfe_mdfe_tpprop_to_string;
    }

    public function get_mdfe_mdfe_tpprop_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpprop_to_string))
        {
            return $this->mdfe_mdfe_tpprop_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_tpprop_id','{mdfe_tpprop->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tptransp_to_string($mdfe_mdfe_tptransp_to_string)
    {
        if(is_array($mdfe_mdfe_tptransp_to_string))
        {
            $values = MdfeTptransp::where('id', 'in', $mdfe_mdfe_tptransp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tptransp_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tptransp_to_string = $mdfe_mdfe_tptransp_to_string;
        }

        $this->vdata['mdfe_mdfe_tptransp_to_string'] = $this->mdfe_mdfe_tptransp_to_string;
    }

    public function get_mdfe_mdfe_tptransp_to_string()
    {
        if(!empty($this->mdfe_mdfe_tptransp_to_string))
        {
            return $this->mdfe_mdfe_tptransp_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_tptransp_id','{mdfe_tptransp->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcar_to_string($mdfe_mdfe_tpcar_to_string)
    {
        if(is_array($mdfe_mdfe_tpcar_to_string))
        {
            $values = MdfeTpcar::where('id', 'in', $mdfe_mdfe_tpcar_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcar_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcar_to_string = $mdfe_mdfe_tpcar_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcar_to_string'] = $this->mdfe_mdfe_tpcar_to_string;
    }

    public function get_mdfe_mdfe_tpcar_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcar_to_string))
        {
            return $this->mdfe_mdfe_tpcar_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_tpcar_id','{mdfe_tpcar->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFIni_to_string($mdfe_fk_UFIni_to_string)
    {
        if(is_array($mdfe_fk_UFIni_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFIni_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFIni_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFIni_to_string = $mdfe_fk_UFIni_to_string;
        }

        $this->vdata['mdfe_fk_UFIni_to_string'] = $this->mdfe_fk_UFIni_to_string;
    }

    public function get_mdfe_fk_UFIni_to_string()
    {
        if(!empty($this->mdfe_fk_UFIni_to_string))
        {
            return $this->mdfe_fk_UFIni_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('UFIni','{fk_UFIni->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFFim_to_string($mdfe_fk_UFFim_to_string)
    {
        if(is_array($mdfe_fk_UFFim_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFFim_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFFim_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFFim_to_string = $mdfe_fk_UFFim_to_string;
        }

        $this->vdata['mdfe_fk_UFFim_to_string'] = $this->mdfe_fk_UFFim_to_string;
    }

    public function get_mdfe_fk_UFFim_to_string()
    {
        if(!empty($this->mdfe_fk_UFFim_to_string))
        {
            return $this->mdfe_fk_UFFim_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('UFFim','{fk_UFFim->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCanalVerde_to_string($mdfe_fk_indCanalVerde_to_string)
    {
        if(is_array($mdfe_fk_indCanalVerde_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCanalVerde_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCanalVerde_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCanalVerde_to_string = $mdfe_fk_indCanalVerde_to_string;
        }

        $this->vdata['mdfe_fk_indCanalVerde_to_string'] = $this->mdfe_fk_indCanalVerde_to_string;
    }

    public function get_mdfe_fk_indCanalVerde_to_string()
    {
        if(!empty($this->mdfe_fk_indCanalVerde_to_string))
        {
            return $this->mdfe_fk_indCanalVerde_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('indCanalVerde','{fk_indCanalVerde->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCarregaPosterior_to_string($mdfe_fk_indCarregaPosterior_to_string)
    {
        if(is_array($mdfe_fk_indCarregaPosterior_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCarregaPosterior_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCarregaPosterior_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCarregaPosterior_to_string = $mdfe_fk_indCarregaPosterior_to_string;
        }

        $this->vdata['mdfe_fk_indCarregaPosterior_to_string'] = $this->mdfe_fk_indCarregaPosterior_to_string;
    }

    public function get_mdfe_fk_indCarregaPosterior_to_string()
    {
        if(!empty($this->mdfe_fk_indCarregaPosterior_to_string))
        {
            return $this->mdfe_fk_indCarregaPosterior_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('indCarregaPosterior','{fk_indCarregaPosterior->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_respSeg_to_string($mdfe_mdfe_respSeg_to_string)
    {
        if(is_array($mdfe_mdfe_respSeg_to_string))
        {
            $values = MdfeRespseg::where('id', 'in', $mdfe_mdfe_respSeg_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_respSeg_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_respSeg_to_string = $mdfe_mdfe_respSeg_to_string;
        }

        $this->vdata['mdfe_mdfe_respSeg_to_string'] = $this->mdfe_mdfe_respSeg_to_string;
    }

    public function get_mdfe_mdfe_respSeg_to_string()
    {
        if(!empty($this->mdfe_mdfe_respSeg_to_string))
        {
            return $this->mdfe_mdfe_respSeg_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_respSeg_id','{mdfe_respSeg->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_cunid_to_string($mdfe_mdfe_cunid_to_string)
    {
        if(is_array($mdfe_mdfe_cunid_to_string))
        {
            $values = MdfeCunid::where('id', 'in', $mdfe_mdfe_cunid_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_cunid_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_cunid_to_string = $mdfe_mdfe_cunid_to_string;
        }

        $this->vdata['mdfe_mdfe_cunid_to_string'] = $this->mdfe_mdfe_cunid_to_string;
    }

    public function get_mdfe_mdfe_cunid_to_string()
    {
        if(!empty($this->mdfe_mdfe_cunid_to_string))
        {
            return $this->mdfe_mdfe_cunid_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_cunid_id','{mdfe_cunid->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcarga_to_string($mdfe_mdfe_tpcarga_to_string)
    {
        if(is_array($mdfe_mdfe_tpcarga_to_string))
        {
            $values = MdfeTpcarga::where('id', 'in', $mdfe_mdfe_tpcarga_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcarga_to_string = $mdfe_mdfe_tpcarga_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcarga_to_string'] = $this->mdfe_mdfe_tpcarga_to_string;
    }

    public function get_mdfe_mdfe_tpcarga_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcarga_to_string))
        {
            return $this->mdfe_mdfe_tpcarga_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_tpcarga_id','{mdfe_tpcarga->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_indpag_to_string($mdfe_mdfe_indpag_to_string)
    {
        if(is_array($mdfe_mdfe_indpag_to_string))
        {
            $values = MdfeIndpag::where('id', 'in', $mdfe_mdfe_indpag_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_indpag_to_string = $mdfe_mdfe_indpag_to_string;
        }

        $this->vdata['mdfe_mdfe_indpag_to_string'] = $this->mdfe_mdfe_indpag_to_string;
    }

    public function get_mdfe_mdfe_indpag_to_string()
    {
        if(!empty($this->mdfe_mdfe_indpag_to_string))
        {
            return $this->mdfe_mdfe_indpag_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_indpag_id','{mdfe_indpag->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indAntecipaAdiant_to_string($mdfe_fk_indAntecipaAdiant_to_string)
    {
        if(is_array($mdfe_fk_indAntecipaAdiant_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indAntecipaAdiant_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indAntecipaAdiant_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indAntecipaAdiant_to_string = $mdfe_fk_indAntecipaAdiant_to_string;
        }

        $this->vdata['mdfe_fk_indAntecipaAdiant_to_string'] = $this->mdfe_fk_indAntecipaAdiant_to_string;
    }

    public function get_mdfe_fk_indAntecipaAdiant_to_string()
    {
        if(!empty($this->mdfe_fk_indAntecipaAdiant_to_string))
        {
            return $this->mdfe_fk_indAntecipaAdiant_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('indAntecipaAdiant','{fk_indAntecipaAdiant->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpRod_to_string($mdfe_mdfe_tpRod_to_string)
    {
        if(is_array($mdfe_mdfe_tpRod_to_string))
        {
            $values = MdfeTprod::where('id', 'in', $mdfe_mdfe_tpRod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpRod_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpRod_to_string = $mdfe_mdfe_tpRod_to_string;
        }

        $this->vdata['mdfe_mdfe_tpRod_to_string'] = $this->mdfe_mdfe_tpRod_to_string;
    }

    public function get_mdfe_mdfe_tpRod_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpRod_to_string))
        {
            return $this->mdfe_mdfe_tpRod_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_tpRod_id','{mdfe_tpRod->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_veic_estado_to_string($mdfe_veic_estado_to_string)
    {
        if(is_array($mdfe_veic_estado_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_veic_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_veic_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veic_estado_to_string = $mdfe_veic_estado_to_string;
        }

        $this->vdata['mdfe_veic_estado_to_string'] = $this->mdfe_veic_estado_to_string;
    }

    public function get_mdfe_veic_estado_to_string()
    {
        if(!empty($this->mdfe_veic_estado_to_string))
        {
            return $this->mdfe_veic_estado_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('veic_estado_id','{veic_estado->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_veiculo_to_string($mdfe_veiculo_to_string)
    {
        if(is_array($mdfe_veiculo_to_string))
        {
            $values = Veiculo::where('id', 'in', $mdfe_veiculo_to_string)->getIndexedArray('modelo_marca', 'modelo_marca');
            $this->mdfe_veiculo_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veiculo_to_string = $mdfe_veiculo_to_string;
        }

        $this->vdata['mdfe_veiculo_to_string'] = $this->mdfe_veiculo_to_string;
    }

    public function get_mdfe_veiculo_to_string()
    {
        if(!empty($this->mdfe_veiculo_to_string))
        {
            return $this->mdfe_veiculo_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('veiculo_id','{veiculo->modelo_marca}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_situacao_to_string($mdfe_mdfe_situacao_to_string)
    {
        if(is_array($mdfe_mdfe_situacao_to_string))
        {
            $values = MdfeSituacao::where('id', 'in', $mdfe_mdfe_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_situacao_to_string = $mdfe_mdfe_situacao_to_string;
        }

        $this->vdata['mdfe_mdfe_situacao_to_string'] = $this->mdfe_mdfe_situacao_to_string;
    }

    public function get_mdfe_mdfe_situacao_to_string()
    {
        if(!empty($this->mdfe_mdfe_situacao_to_string))
        {
            return $this->mdfe_mdfe_situacao_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_situacao_id','{mdfe_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpamb_to_string($mdfe_mdfe_tpamb_to_string)
    {
        if(is_array($mdfe_mdfe_tpamb_to_string))
        {
            $values = MdfeTpamb::where('id', 'in', $mdfe_mdfe_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpamb_to_string = $mdfe_mdfe_tpamb_to_string;
        }

        $this->vdata['mdfe_mdfe_tpamb_to_string'] = $this->mdfe_mdfe_tpamb_to_string;
    }

    public function get_mdfe_mdfe_tpamb_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpamb_to_string))
        {
            return $this->mdfe_mdfe_tpamb_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('mdfe_tpamb_id','{mdfe_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_api_documentos_to_string($mdfe_api_documentos_to_string)
    {
        if(is_array($mdfe_api_documentos_to_string))
        {
            $values = ApiDocumentos::where('id', 'in', $mdfe_api_documentos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_api_documentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_api_documentos_to_string = $mdfe_api_documentos_to_string;
        }

        $this->vdata['mdfe_api_documentos_to_string'] = $this->mdfe_api_documentos_to_string;
    }

    public function get_mdfe_api_documentos_to_string()
    {
        if(!empty($this->mdfe_api_documentos_to_string))
        {
            return $this->mdfe_api_documentos_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('api_documentos_id','{api_documentos->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_cidade_encerramento_to_string($mdfe_cidade_encerramento_to_string)
    {
        if(is_array($mdfe_cidade_encerramento_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_cidade_encerramento_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_cidade_encerramento_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_cidade_encerramento_to_string = $mdfe_cidade_encerramento_to_string;
        }

        $this->vdata['mdfe_cidade_encerramento_to_string'] = $this->mdfe_cidade_encerramento_to_string;
    }

    public function get_mdfe_cidade_encerramento_to_string()
    {
        if(!empty($this->mdfe_cidade_encerramento_to_string))
        {
            return $this->mdfe_cidade_encerramento_to_string;
        }
    
        $values = Mdfe::where('cidade_encerramento_id', '=', $this->id)->getIndexedArray('cidade_encerramento_id','{cidade_encerramento->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_inclusao_dfe_mdfe_to_string($mdfe_inclusao_dfe_mdfe_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_mdfe_to_string))
        {
            $values = Mdfe::where('id', 'in', $mdfe_inclusao_dfe_mdfe_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_inclusao_dfe_mdfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_mdfe_to_string = $mdfe_inclusao_dfe_mdfe_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_mdfe_to_string'] = $this->mdfe_inclusao_dfe_mdfe_to_string;
    }

    public function get_mdfe_inclusao_dfe_mdfe_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_mdfe_to_string))
        {
            return $this->mdfe_inclusao_dfe_mdfe_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('cidade_descarga_id', '=', $this->id)->getIndexedArray('mdfe_id','{mdfe->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_inclusao_dfe_notafiscal_to_string($mdfe_inclusao_dfe_notafiscal_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $mdfe_inclusao_dfe_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_inclusao_dfe_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_notafiscal_to_string = $mdfe_inclusao_dfe_notafiscal_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_notafiscal_to_string'] = $this->mdfe_inclusao_dfe_notafiscal_to_string;
    }

    public function get_mdfe_inclusao_dfe_notafiscal_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_notafiscal_to_string))
        {
            return $this->mdfe_inclusao_dfe_notafiscal_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('cidade_descarga_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_inclusao_dfe_cidade_carrega_to_string($mdfe_inclusao_dfe_cidade_carrega_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_cidade_carrega_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_inclusao_dfe_cidade_carrega_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_inclusao_dfe_cidade_carrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_cidade_carrega_to_string = $mdfe_inclusao_dfe_cidade_carrega_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_cidade_carrega_to_string'] = $this->mdfe_inclusao_dfe_cidade_carrega_to_string;
    }

    public function get_mdfe_inclusao_dfe_cidade_carrega_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_cidade_carrega_to_string))
        {
            return $this->mdfe_inclusao_dfe_cidade_carrega_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('cidade_descarga_id', '=', $this->id)->getIndexedArray('cidade_carrega_id','{cidade_carrega->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_inclusao_dfe_cidade_descarga_to_string($mdfe_inclusao_dfe_cidade_descarga_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_cidade_descarga_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_inclusao_dfe_cidade_descarga_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_inclusao_dfe_cidade_descarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_cidade_descarga_to_string = $mdfe_inclusao_dfe_cidade_descarga_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_cidade_descarga_to_string'] = $this->mdfe_inclusao_dfe_cidade_descarga_to_string;
    }

    public function get_mdfe_inclusao_dfe_cidade_descarga_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_cidade_descarga_to_string))
        {
            return $this->mdfe_inclusao_dfe_cidade_descarga_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('cidade_descarga_id', '=', $this->id)->getIndexedArray('cidade_descarga_id','{cidade_descarga->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_infmuncarrega_mdfe_to_string($mdfe_infmuncarrega_mdfe_to_string)
    {
        if(is_array($mdfe_infmuncarrega_mdfe_to_string))
        {
            $values = Mdfe::where('id', 'in', $mdfe_infmuncarrega_mdfe_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_infmuncarrega_mdfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_infmuncarrega_mdfe_to_string = $mdfe_infmuncarrega_mdfe_to_string;
        }

        $this->vdata['mdfe_infmuncarrega_mdfe_to_string'] = $this->mdfe_infmuncarrega_mdfe_to_string;
    }

    public function get_mdfe_infmuncarrega_mdfe_to_string()
    {
        if(!empty($this->mdfe_infmuncarrega_mdfe_to_string))
        {
            return $this->mdfe_infmuncarrega_mdfe_to_string;
        }
    
        $values = MdfeInfmuncarrega::where('cidade_id', '=', $this->id)->getIndexedArray('mdfe_id','{mdfe->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_infmuncarrega_cidade_to_string($mdfe_infmuncarrega_cidade_to_string)
    {
        if(is_array($mdfe_infmuncarrega_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_infmuncarrega_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_infmuncarrega_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_infmuncarrega_cidade_to_string = $mdfe_infmuncarrega_cidade_to_string;
        }

        $this->vdata['mdfe_infmuncarrega_cidade_to_string'] = $this->mdfe_infmuncarrega_cidade_to_string;
    }

    public function get_mdfe_infmuncarrega_cidade_to_string()
    {
        if(!empty($this->mdfe_infmuncarrega_cidade_to_string))
        {
            return $this->mdfe_infmuncarrega_cidade_to_string;
        }
    
        $values = MdfeInfmuncarrega::where('cidade_id', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_infmundescarga_mdfe_to_string($mdfe_infmundescarga_mdfe_to_string)
    {
        if(is_array($mdfe_infmundescarga_mdfe_to_string))
        {
            $values = Mdfe::where('id', 'in', $mdfe_infmundescarga_mdfe_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_infmundescarga_mdfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_infmundescarga_mdfe_to_string = $mdfe_infmundescarga_mdfe_to_string;
        }

        $this->vdata['mdfe_infmundescarga_mdfe_to_string'] = $this->mdfe_infmundescarga_mdfe_to_string;
    }

    public function get_mdfe_infmundescarga_mdfe_to_string()
    {
        if(!empty($this->mdfe_infmundescarga_mdfe_to_string))
        {
            return $this->mdfe_infmundescarga_mdfe_to_string;
        }
    
        $values = MdfeInfmundescarga::where('cidade_id', '=', $this->id)->getIndexedArray('mdfe_id','{mdfe->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_infmundescarga_cidade_to_string($mdfe_infmundescarga_cidade_to_string)
    {
        if(is_array($mdfe_infmundescarga_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_infmundescarga_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_infmundescarga_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_infmundescarga_cidade_to_string = $mdfe_infmundescarga_cidade_to_string;
        }

        $this->vdata['mdfe_infmundescarga_cidade_to_string'] = $this->mdfe_infmundescarga_cidade_to_string;
    }

    public function get_mdfe_infmundescarga_cidade_to_string()
    {
        if(!empty($this->mdfe_infmundescarga_cidade_to_string))
        {
            return $this->mdfe_infmundescarga_cidade_to_string;
        }
    
        $values = MdfeInfmundescarga::where('cidade_id', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    
}

