<?php

class Cliente extends TRecord
{
    const TABLENAME  = 'cliente';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_unit;
    private $pessoa_tipo;
    private $vendedor;
    private $fk_residencia_propria;
    private $fk_utilizar_endereco_cobranca;
    private $cliente_situacao;
    private $notafiscal_indiedest;
    private $notafiscal_crt;
    private $cliente_classificacao;
    private $cliente_classificacao_subgrupo;
    private $tabela_preco;

    // private $cpf_cnpj;

    const Permissao_ExcluirCliente = 'Excluir Cliente';

    

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('pessoa_tipo_id');
        parent::addAttribute('cliente_classificacao_id');
        parent::addAttribute('cliente_classificacao_subgrupo_id');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('notafiscal_indiedest_id');
        parent::addAttribute('notafiscal_crt_id');
        parent::addAttribute('nome');
        parent::addAttribute('cpf_cnpj');
        parent::addAttribute('rg');
        parent::addAttribute('email');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('insc_estadual');
        parent::addAttribute('insc_municipal');
        parent::addAttribute('razao_social');
        parent::addAttribute('fone');
        parent::addAttribute('observacoes');
        parent::addAttribute('data_nascimento');
        parent::addAttribute('conjuge');
        parent::addAttribute('conjuge_cpf');
        parent::addAttribute('nome_pai');
        parent::addAttribute('nome_mae');
        parent::addAttribute('local_trabalho');
        parent::addAttribute('renda');
        parent::addAttribute('tempo_trabalho');
        parent::addAttribute('residencia_propria');
        parent::addAttribute('utilizar_endereco_cobranca');
        parent::addAttribute('cobranca_cnpj');
        parent::addAttribute('cobranca_nome');
        parent::addAttribute('cobranca_cep');
        parent::addAttribute('cobranca_endereco');
        parent::addAttribute('cobranca_bairro');
        parent::addAttribute('cobranca_uf');
        parent::addAttribute('cobranca_cidade');
        parent::addAttribute('cobranca_fones');
        parent::addAttribute('cliente_situacao_id');
        parent::addAttribute('limite_credito');
        parent::addAttribute('limite_utilizado');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('deletado_em');
        parent::addAttribute('vendas_quantidade');
        parent::addAttribute('vendas_valortotal');
        parent::addAttribute('vendas_dataultima');
        parent::addAttribute('vendas_valormaior');
        parent::addAttribute('vendas_datamaior');
        parent::addAttribute('observacoes_financeiro');
        parent::addAttribute('tabela_preco_id');
        parent::addAttribute('percentual_comissao_vendedor');
        parent::addAttribute('cliente_exterior');
    
    }

    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_pessoa_tipo
     * Sample of usage: $var->pessoa_tipo = $object;
     * @param $object Instance of PessoaTipo
     */
    public function set_pessoa_tipo(PessoaTipo $object)
    {
        $this->pessoa_tipo = $object;
        $this->pessoa_tipo_id = $object->id;
    }

    /**
     * Method get_pessoa_tipo
     * Sample of usage: $var->pessoa_tipo->attribute;
     * @returns PessoaTipo instance
     */
    public function get_pessoa_tipo()
    {
    
        // loads the associated object
        if (empty($this->pessoa_tipo))
            $this->pessoa_tipo = new PessoaTipo($this->pessoa_tipo_id);
    
        // returns the associated object
        return $this->pessoa_tipo;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_fk_residencia_propria(Resposta $object)
    {
        $this->fk_residencia_propria = $object;
        $this->residencia_propria = $object->id;
    }

    /**
     * Method get_fk_residencia_propria
     * Sample of usage: $var->fk_residencia_propria->attribute;
     * @returns Resposta instance
     */
    public function get_fk_residencia_propria()
    {
    
        // loads the associated object
        if (empty($this->fk_residencia_propria))
            $this->fk_residencia_propria = new Resposta($this->residencia_propria);
    
        // returns the associated object
        return $this->fk_residencia_propria;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_fk_utilizar_endereco_cobranca(Resposta $object)
    {
        $this->fk_utilizar_endereco_cobranca = $object;
        $this->utilizar_endereco_cobranca = $object->id;
    }

    /**
     * Method get_fk_utilizar_endereco_cobranca
     * Sample of usage: $var->fk_utilizar_endereco_cobranca->attribute;
     * @returns Resposta instance
     */
    public function get_fk_utilizar_endereco_cobranca()
    {
    
        // loads the associated object
        if (empty($this->fk_utilizar_endereco_cobranca))
            $this->fk_utilizar_endereco_cobranca = new Resposta($this->utilizar_endereco_cobranca);
    
        // returns the associated object
        return $this->fk_utilizar_endereco_cobranca;
    }
    /**
     * Method set_cliente_situacao
     * Sample of usage: $var->cliente_situacao = $object;
     * @param $object Instance of ClienteSituacao
     */
    public function set_cliente_situacao(ClienteSituacao $object)
    {
        $this->cliente_situacao = $object;
        $this->cliente_situacao_id = $object->id;
    }

    /**
     * Method get_cliente_situacao
     * Sample of usage: $var->cliente_situacao->attribute;
     * @returns ClienteSituacao instance
     */
    public function get_cliente_situacao()
    {
    
        // loads the associated object
        if (empty($this->cliente_situacao))
            $this->cliente_situacao = new ClienteSituacao($this->cliente_situacao_id);
    
        // returns the associated object
        return $this->cliente_situacao;
    }
    /**
     * Method set_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest = $object;
     * @param $object Instance of NotafiscalIndiedest
     */
    public function set_notafiscal_indiedest(NotafiscalIndiedest $object)
    {
        $this->notafiscal_indiedest = $object;
        $this->notafiscal_indiedest_id = $object->id;
    }

    /**
     * Method get_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest->attribute;
     * @returns NotafiscalIndiedest instance
     */
    public function get_notafiscal_indiedest()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indiedest))
            $this->notafiscal_indiedest = new NotafiscalIndiedest($this->notafiscal_indiedest_id);
    
        // returns the associated object
        return $this->notafiscal_indiedest;
    }
    /**
     * Method set_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt = $object;
     * @param $object Instance of NotafiscalCrt
     */
    public function set_notafiscal_crt(NotafiscalCrt $object)
    {
        $this->notafiscal_crt = $object;
        $this->notafiscal_crt_id = $object->id;
    }

    /**
     * Method get_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt->attribute;
     * @returns NotafiscalCrt instance
     */
    public function get_notafiscal_crt()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_crt))
            $this->notafiscal_crt = new NotafiscalCrt($this->notafiscal_crt_id);
    
        // returns the associated object
        return $this->notafiscal_crt;
    }
    /**
     * Method set_cliente_classificacao
     * Sample of usage: $var->cliente_classificacao = $object;
     * @param $object Instance of ClienteClassificacao
     */
    public function set_cliente_classificacao(ClienteClassificacao $object)
    {
        $this->cliente_classificacao = $object;
        $this->cliente_classificacao_id = $object->id;
    }

    /**
     * Method get_cliente_classificacao
     * Sample of usage: $var->cliente_classificacao->attribute;
     * @returns ClienteClassificacao instance
     */
    public function get_cliente_classificacao()
    {
    
        // loads the associated object
        if (empty($this->cliente_classificacao))
            $this->cliente_classificacao = new ClienteClassificacao($this->cliente_classificacao_id);
    
        // returns the associated object
        return $this->cliente_classificacao;
    }
    /**
     * Method set_cliente_classificacao_subgrupo
     * Sample of usage: $var->cliente_classificacao_subgrupo = $object;
     * @param $object Instance of ClienteClassificacaoSubgrupo
     */
    public function set_cliente_classificacao_subgrupo(ClienteClassificacaoSubgrupo $object)
    {
        $this->cliente_classificacao_subgrupo = $object;
        $this->cliente_classificacao_subgrupo_id = $object->id;
    }

    /**
     * Method get_cliente_classificacao_subgrupo
     * Sample of usage: $var->cliente_classificacao_subgrupo->attribute;
     * @returns ClienteClassificacaoSubgrupo instance
     */
    public function get_cliente_classificacao_subgrupo()
    {
    
        // loads the associated object
        if (empty($this->cliente_classificacao_subgrupo))
            $this->cliente_classificacao_subgrupo = new ClienteClassificacaoSubgrupo($this->cliente_classificacao_subgrupo_id);
    
        // returns the associated object
        return $this->cliente_classificacao_subgrupo;
    }
    /**
     * Method set_tabela_preco
     * Sample of usage: $var->tabela_preco = $object;
     * @param $object Instance of TabelaPreco
     */
    public function set_tabela_preco(TabelaPreco $object)
    {
        $this->tabela_preco = $object;
        $this->tabela_preco_id = $object->id;
    }

    /**
     * Method get_tabela_preco
     * Sample of usage: $var->tabela_preco->attribute;
     * @returns TabelaPreco instance
     */
    public function get_tabela_preco()
    {
    
        // loads the associated object
        if (empty($this->tabela_preco))
            $this->tabela_preco = new TabelaPreco($this->tabela_preco_id);
    
        // returns the associated object
        return $this->tabela_preco;
    }

    /**
     * Method getCertificadoClientes
     */
    public function getCertificadoClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return CertificadoCliente::getObjects( $criteria );
    }
    /**
     * Method getCertificadoVendas
     */
    public function getCertificadoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return CertificadoVenda::getObjects( $criteria );
    }
    /**
     * Method getClienteContatos
     */
    public function getClienteContatos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return ClienteContato::getObjects( $criteria );
    }
    /**
     * Method getClienteEnderecos
     */
    public function getClienteEnderecos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return ClienteEndereco::getObjects( $criteria );
    }
    /**
     * Method getClienteHistoricoLimites
     */
    public function getClienteHistoricoLimites()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return ClienteHistoricoLimite::getObjects( $criteria );
    }
    /**
     * Method getContasrecs
     */
    public function getContasrecs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return Contasrec::getObjects( $criteria );
    }
    /**
     * Method getContasrecBlocos
     */
    public function getContasrecBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return ContasrecBloco::getObjects( $criteria );
    }
    /**
     * Method getNegocios
     */
    public function getNegocios()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return Negocio::getObjects( $criteria );
    }
    /**
     * Method getNotafiscals
     */
    public function getNotafiscals()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return Notafiscal::getObjects( $criteria );
    }
    /**
     * Method getOrcamentos
     */
    public function getOrcamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return Orcamento::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicos
     */
    public function getOrdemServicos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return OrdemServico::getObjects( $criteria );
    }
    /**
     * Method getVendas
     */
    public function getVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }

    public function set_certificado_cliente_cliente_to_string($certificado_cliente_cliente_to_string)
    {
        if(is_array($certificado_cliente_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_cliente_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_cliente_to_string = $certificado_cliente_cliente_to_string;
        }

        $this->vdata['certificado_cliente_cliente_to_string'] = $this->certificado_cliente_cliente_to_string;
    }

    public function get_certificado_cliente_cliente_to_string()
    {
        if(!empty($this->certificado_cliente_cliente_to_string))
        {
            return $this->certificado_cliente_cliente_to_string;
        }
    
        $values = CertificadoCliente::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_parceiro_to_string($certificado_cliente_parceiro_to_string)
    {
        if(is_array($certificado_cliente_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_cliente_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_parceiro_to_string = $certificado_cliente_parceiro_to_string;
        }

        $this->vdata['certificado_cliente_parceiro_to_string'] = $this->certificado_cliente_parceiro_to_string;
    }

    public function get_certificado_cliente_parceiro_to_string()
    {
        if(!empty($this->certificado_cliente_parceiro_to_string))
        {
            return $this->certificado_cliente_parceiro_to_string;
        }
    
        $values = CertificadoCliente::where('cliente_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_produto_to_string($certificado_cliente_produto_to_string)
    {
        if(is_array($certificado_cliente_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_cliente_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_produto_to_string = $certificado_cliente_produto_to_string;
        }

        $this->vdata['certificado_cliente_produto_to_string'] = $this->certificado_cliente_produto_to_string;
    }

    public function get_certificado_cliente_produto_to_string()
    {
        if(!empty($this->certificado_cliente_produto_to_string))
        {
            return $this->certificado_cliente_produto_to_string;
        }
    
        $values = CertificadoCliente::where('cliente_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_cliente_situacao_to_string($certificado_cliente_certificado_cliente_situacao_to_string)
    {
        if(is_array($certificado_cliente_certificado_cliente_situacao_to_string))
        {
            $values = CertificadoClienteSituacao::where('id', 'in', $certificado_cliente_certificado_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_cliente_certificado_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_cliente_situacao_to_string = $certificado_cliente_certificado_cliente_situacao_to_string;
        }

        $this->vdata['certificado_cliente_certificado_cliente_situacao_to_string'] = $this->certificado_cliente_certificado_cliente_situacao_to_string;
    }

    public function get_certificado_cliente_certificado_cliente_situacao_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_cliente_situacao_to_string))
        {
            return $this->certificado_cliente_certificado_cliente_situacao_to_string;
        }
    
        $values = CertificadoCliente::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_cliente_situacao_id','{certificado_cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_venda_to_string($certificado_cliente_certificado_venda_to_string)
    {
        if(is_array($certificado_cliente_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_cliente_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_cliente_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_venda_to_string = $certificado_cliente_certificado_venda_to_string;
        }

        $this->vdata['certificado_cliente_certificado_venda_to_string'] = $this->certificado_cliente_certificado_venda_to_string;
    }

    public function get_certificado_cliente_certificado_venda_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_venda_to_string))
        {
            return $this->certificado_cliente_certificado_venda_to_string;
        }
    
        $values = CertificadoCliente::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_system_unit_to_string($certificado_venda_system_unit_to_string)
    {
        if(is_array($certificado_venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $certificado_venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->certificado_venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_system_unit_to_string = $certificado_venda_system_unit_to_string;
        }

        $this->vdata['certificado_venda_system_unit_to_string'] = $this->certificado_venda_system_unit_to_string;
    }

    public function get_certificado_venda_system_unit_to_string()
    {
        if(!empty($this->certificado_venda_system_unit_to_string))
        {
            return $this->certificado_venda_system_unit_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_cliente_to_string($certificado_venda_cliente_to_string)
    {
        if(is_array($certificado_venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_cliente_to_string = $certificado_venda_cliente_to_string;
        }

        $this->vdata['certificado_venda_cliente_to_string'] = $this->certificado_venda_cliente_to_string;
    }

    public function get_certificado_venda_cliente_to_string()
    {
        if(!empty($this->certificado_venda_cliente_to_string))
        {
            return $this->certificado_venda_cliente_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_produto_to_string($certificado_venda_produto_to_string)
    {
        if(is_array($certificado_venda_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_venda_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_produto_to_string = $certificado_venda_produto_to_string;
        }

        $this->vdata['certificado_venda_produto_to_string'] = $this->certificado_venda_produto_to_string;
    }

    public function get_certificado_venda_produto_to_string()
    {
        if(!empty($this->certificado_venda_produto_to_string))
        {
            return $this->certificado_venda_produto_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_parceiro_to_string($certificado_venda_parceiro_to_string)
    {
        if(is_array($certificado_venda_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_venda_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_parceiro_to_string = $certificado_venda_parceiro_to_string;
        }

        $this->vdata['certificado_venda_parceiro_to_string'] = $this->certificado_venda_parceiro_to_string;
    }

    public function get_certificado_venda_parceiro_to_string()
    {
        if(!empty($this->certificado_venda_parceiro_to_string))
        {
            return $this->certificado_venda_parceiro_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_agente_registro_to_string($certificado_venda_certificado_agente_registro_to_string)
    {
        if(is_array($certificado_venda_certificado_agente_registro_to_string))
        {
            $values = CertificadoAgenteRegistro::where('id', 'in', $certificado_venda_certificado_agente_registro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificado_agente_registro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_agente_registro_to_string = $certificado_venda_certificado_agente_registro_to_string;
        }

        $this->vdata['certificado_venda_certificado_agente_registro_to_string'] = $this->certificado_venda_certificado_agente_registro_to_string;
    }

    public function get_certificado_venda_certificado_agente_registro_to_string()
    {
        if(!empty($this->certificado_venda_certificado_agente_registro_to_string))
        {
            return $this->certificado_venda_certificado_agente_registro_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_agente_registro_id','{certificado_agente_registro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_situacao_to_string($certificado_venda_certificado_venda_situacao_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_situacao_to_string))
        {
            $values = CertificadoVendaSituacao::where('id', 'in', $certificado_venda_certificado_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_situacao_to_string = $certificado_venda_certificado_venda_situacao_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_situacao_to_string'] = $this->certificado_venda_certificado_venda_situacao_to_string;
    }

    public function get_certificado_venda_certificado_venda_situacao_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_situacao_to_string))
        {
            return $this->certificado_venda_certificado_venda_situacao_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_venda_situacao_id','{certificado_venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_modalidade_to_string($certificado_venda_certificado_venda_modalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $certificado_venda_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_modalidade_to_string = $certificado_venda_certificado_venda_modalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_modalidade_to_string'] = $this->certificado_venda_certificado_venda_modalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_modalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_modalidade_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_tipomodalidade_to_string($certificado_venda_certificado_venda_tipomodalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            $values = CertificadoVendaTipomodalidade::where('id', 'in', $certificado_venda_certificado_venda_tipomodalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = $certificado_venda_certificado_venda_tipomodalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_tipomodalidade_to_string'] = $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_tipomodalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_venda_tipomodalidade_id','{certificado_venda_tipomodalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_repasse_to_string($certificado_venda_certificado_tipo_repasse_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_repasse_to_string))
        {
            $values = CertificadoTipoRepasse::where('id', 'in', $certificado_venda_certificado_tipo_repasse_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_repasse_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_repasse_to_string = $certificado_venda_certificado_tipo_repasse_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_repasse_to_string'] = $this->certificado_venda_certificado_tipo_repasse_to_string;
    }

    public function get_certificado_venda_certificado_tipo_repasse_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_repasse_to_string))
        {
            return $this->certificado_venda_certificado_tipo_repasse_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_tipo_repasse_id','{certificado_tipo_repasse->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_vendedor_to_string($certificado_venda_vendedor_to_string)
    {
        if(is_array($certificado_venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $certificado_venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_vendedor_to_string = $certificado_venda_vendedor_to_string;
        }

        $this->vdata['certificado_venda_vendedor_to_string'] = $this->certificado_venda_vendedor_to_string;
    }

    public function get_certificado_venda_vendedor_to_string()
    {
        if(!empty($this->certificado_venda_vendedor_to_string))
        {
            return $this->certificado_venda_vendedor_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_tabela_preco_to_string($certificado_venda_tabela_preco_to_string)
    {
        if(is_array($certificado_venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $certificado_venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_tabela_preco_to_string = $certificado_venda_tabela_preco_to_string;
        }

        $this->vdata['certificado_venda_tabela_preco_to_string'] = $this->certificado_venda_tabela_preco_to_string;
    }

    public function get_certificado_venda_tabela_preco_to_string()
    {
        if(!empty($this->certificado_venda_tabela_preco_to_string))
        {
            return $this->certificado_venda_tabela_preco_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificadora_to_string($certificado_venda_certificadora_to_string)
    {
        if(is_array($certificado_venda_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificado_venda_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificadora_to_string = $certificado_venda_certificadora_to_string;
        }

        $this->vdata['certificado_venda_certificadora_to_string'] = $this->certificado_venda_certificadora_to_string;
    }

    public function get_certificado_venda_certificadora_to_string()
    {
        if(!empty($this->certificado_venda_certificadora_to_string))
        {
            return $this->certificado_venda_certificadora_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_atendimento_to_string($certificado_venda_certificado_tipo_atendimento_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_atendimento_to_string))
        {
            $values = CertificadoTipoAtendimento::where('id', 'in', $certificado_venda_certificado_tipo_atendimento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_atendimento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_atendimento_to_string = $certificado_venda_certificado_tipo_atendimento_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_atendimento_to_string'] = $this->certificado_venda_certificado_tipo_atendimento_to_string;
    }

    public function get_certificado_venda_certificado_tipo_atendimento_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_atendimento_to_string))
        {
            return $this->certificado_venda_certificado_tipo_atendimento_to_string;
        }
    
        $values = CertificadoVenda::where('cliente_id', '=', $this->id)->getIndexedArray('certificado_tipo_atendimento_id','{certificado_tipo_atendimento->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_contato_cliente_to_string($cliente_contato_cliente_to_string)
    {
        if(is_array($cliente_contato_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $cliente_contato_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_contato_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_contato_cliente_to_string = $cliente_contato_cliente_to_string;
        }

        $this->vdata['cliente_contato_cliente_to_string'] = $this->cliente_contato_cliente_to_string;
    }

    public function get_cliente_contato_cliente_to_string()
    {
        if(!empty($this->cliente_contato_cliente_to_string))
        {
            return $this->cliente_contato_cliente_to_string;
        }
    
        $values = ClienteContato::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_cliente_to_string($cliente_endereco_cliente_to_string)
    {
        if(is_array($cliente_endereco_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $cliente_endereco_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_endereco_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_cliente_to_string = $cliente_endereco_cliente_to_string;
        }

        $this->vdata['cliente_endereco_cliente_to_string'] = $this->cliente_endereco_cliente_to_string;
    }

    public function get_cliente_endereco_cliente_to_string()
    {
        if(!empty($this->cliente_endereco_cliente_to_string))
        {
            return $this->cliente_endereco_cliente_to_string;
        }
    
        $values = ClienteEndereco::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_fk_principal_to_string($cliente_endereco_fk_principal_to_string)
    {
        if(is_array($cliente_endereco_fk_principal_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_endereco_fk_principal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_endereco_fk_principal_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_fk_principal_to_string = $cliente_endereco_fk_principal_to_string;
        }

        $this->vdata['cliente_endereco_fk_principal_to_string'] = $this->cliente_endereco_fk_principal_to_string;
    }

    public function get_cliente_endereco_fk_principal_to_string()
    {
        if(!empty($this->cliente_endereco_fk_principal_to_string))
        {
            return $this->cliente_endereco_fk_principal_to_string;
        }
    
        $values = ClienteEndereco::where('cliente_id', '=', $this->id)->getIndexedArray('principal','{fk_principal->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_cidade_to_string($cliente_endereco_cidade_to_string)
    {
        if(is_array($cliente_endereco_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $cliente_endereco_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_endereco_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_cidade_to_string = $cliente_endereco_cidade_to_string;
        }

        $this->vdata['cliente_endereco_cidade_to_string'] = $this->cliente_endereco_cidade_to_string;
    }

    public function get_cliente_endereco_cidade_to_string()
    {
        if(!empty($this->cliente_endereco_cidade_to_string))
        {
            return $this->cliente_endereco_cidade_to_string;
        }
    
        $values = ClienteEndereco::where('cliente_id', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_historico_limite_cliente_to_string($cliente_historico_limite_cliente_to_string)
    {
        if(is_array($cliente_historico_limite_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $cliente_historico_limite_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_historico_limite_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_historico_limite_cliente_to_string = $cliente_historico_limite_cliente_to_string;
        }

        $this->vdata['cliente_historico_limite_cliente_to_string'] = $this->cliente_historico_limite_cliente_to_string;
    }

    public function get_cliente_historico_limite_cliente_to_string()
    {
        if(!empty($this->cliente_historico_limite_cliente_to_string))
        {
            return $this->cliente_historico_limite_cliente_to_string;
        }
    
        $values = ClienteHistoricoLimite::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_system_unit_to_string($contasrec_system_unit_to_string)
    {
        if(is_array($contasrec_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_system_unit_to_string = $contasrec_system_unit_to_string;
        }

        $this->vdata['contasrec_system_unit_to_string'] = $this->contasrec_system_unit_to_string;
    }

    public function get_contasrec_system_unit_to_string()
    {
        if(!empty($this->contasrec_system_unit_to_string))
        {
            return $this->contasrec_system_unit_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_cliente_to_string($contasrec_cliente_to_string)
    {
        if(is_array($contasrec_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cliente_to_string = $contasrec_cliente_to_string;
        }

        $this->vdata['contasrec_cliente_to_string'] = $this->contasrec_cliente_to_string;
    }

    public function get_contasrec_cliente_to_string()
    {
        if(!empty($this->contasrec_cliente_to_string))
        {
            return $this->contasrec_cliente_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_forma_pagamento_to_string($contasrec_forma_pagamento_to_string)
    {
        if(is_array($contasrec_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_forma_pagamento_to_string = $contasrec_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_forma_pagamento_to_string'] = $this->contasrec_forma_pagamento_to_string;
    }

    public function get_contasrec_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_forma_pagamento_to_string))
        {
            return $this->contasrec_forma_pagamento_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_situacao_to_string($contasrec_contasrec_situacao_to_string)
    {
        if(is_array($contasrec_contasrec_situacao_to_string))
        {
            $values = ContasrecSituacao::where('id', 'in', $contasrec_contasrec_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_situacao_to_string = $contasrec_contasrec_situacao_to_string;
        }

        $this->vdata['contasrec_contasrec_situacao_to_string'] = $this->contasrec_contasrec_situacao_to_string;
    }

    public function get_contasrec_contasrec_situacao_to_string()
    {
        if(!empty($this->contasrec_contasrec_situacao_to_string))
        {
            return $this->contasrec_contasrec_situacao_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('contasrec_situacao_id','{contasrec_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_plano_conta_to_string($contasrec_plano_conta_to_string)
    {
        if(is_array($contasrec_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_plano_conta_to_string = $contasrec_plano_conta_to_string;
        }

        $this->vdata['contasrec_plano_conta_to_string'] = $this->contasrec_plano_conta_to_string;
    }

    public function get_contasrec_plano_conta_to_string()
    {
        if(!empty($this->contasrec_plano_conta_to_string))
        {
            return $this->contasrec_plano_conta_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_centro_custo_to_string($contasrec_centro_custo_to_string)
    {
        if(is_array($contasrec_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_centro_custo_to_string = $contasrec_centro_custo_to_string;
        }

        $this->vdata['contasrec_centro_custo_to_string'] = $this->contasrec_centro_custo_to_string;
    }

    public function get_contasrec_centro_custo_to_string()
    {
        if(!empty($this->contasrec_centro_custo_to_string))
        {
            return $this->contasrec_centro_custo_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_origem_to_string($contasrec_contasrec_origem_to_string)
    {
        if(is_array($contasrec_contasrec_origem_to_string))
        {
            $values = ContasrecOrigem::where('id', 'in', $contasrec_contasrec_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_origem_to_string = $contasrec_contasrec_origem_to_string;
        }

        $this->vdata['contasrec_contasrec_origem_to_string'] = $this->contasrec_contasrec_origem_to_string;
    }

    public function get_contasrec_contasrec_origem_to_string()
    {
        if(!empty($this->contasrec_contasrec_origem_to_string))
        {
            return $this->contasrec_contasrec_origem_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('contasrec_origem_id','{contasrec_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_cheque_banco_to_string($contasrec_cheque_banco_to_string)
    {
        if(is_array($contasrec_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contasrec_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cheque_banco_to_string = $contasrec_cheque_banco_to_string;
        }

        $this->vdata['contasrec_cheque_banco_to_string'] = $this->contasrec_cheque_banco_to_string;
    }

    public function get_contasrec_cheque_banco_to_string()
    {
        if(!empty($this->contasrec_cheque_banco_to_string))
        {
            return $this->contasrec_cheque_banco_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_conta_corrente_boleto_to_string($contasrec_conta_corrente_boleto_to_string)
    {
        if(is_array($contasrec_conta_corrente_boleto_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_conta_corrente_boleto_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_conta_corrente_boleto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_conta_corrente_boleto_to_string = $contasrec_conta_corrente_boleto_to_string;
        }

        $this->vdata['contasrec_conta_corrente_boleto_to_string'] = $this->contasrec_conta_corrente_boleto_to_string;
    }

    public function get_contasrec_conta_corrente_boleto_to_string()
    {
        if(!empty($this->contasrec_conta_corrente_boleto_to_string))
        {
            return $this->contasrec_conta_corrente_boleto_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('conta_corrente_boleto_id','{conta_corrente_boleto->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_boleto_situacao_to_string($contasrec_boleto_situacao_to_string)
    {
        if(is_array($contasrec_boleto_situacao_to_string))
        {
            $values = BoletoSituacao::where('id', 'in', $contasrec_boleto_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_boleto_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_boleto_situacao_to_string = $contasrec_boleto_situacao_to_string;
        }

        $this->vdata['contasrec_boleto_situacao_to_string'] = $this->contasrec_boleto_situacao_to_string;
    }

    public function get_contasrec_boleto_situacao_to_string()
    {
        if(!empty($this->contasrec_boleto_situacao_to_string))
        {
            return $this->contasrec_boleto_situacao_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('boleto_situacao_id','{boleto_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_vendedor_to_string($contasrec_vendedor_to_string)
    {
        if(is_array($contasrec_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $contasrec_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_vendedor_to_string = $contasrec_vendedor_to_string;
        }

        $this->vdata['contasrec_vendedor_to_string'] = $this->contasrec_vendedor_to_string;
    }

    public function get_contasrec_vendedor_to_string()
    {
        if(!empty($this->contasrec_vendedor_to_string))
        {
            return $this->contasrec_vendedor_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_bloco_to_string($contasrec_contasrec_bloco_to_string)
    {
        if(is_array($contasrec_contasrec_bloco_to_string))
        {
            $values = ContasrecBloco::where('id', 'in', $contasrec_contasrec_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_contasrec_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_bloco_to_string = $contasrec_contasrec_bloco_to_string;
        }

        $this->vdata['contasrec_contasrec_bloco_to_string'] = $this->contasrec_contasrec_bloco_to_string;
    }

    public function get_contasrec_contasrec_bloco_to_string()
    {
        if(!empty($this->contasrec_contasrec_bloco_to_string))
        {
            return $this->contasrec_contasrec_bloco_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('contasrec_bloco_id','{contasrec_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_venda_formapgto_to_string($contasrec_venda_formapgto_to_string)
    {
        if(is_array($contasrec_venda_formapgto_to_string))
        {
            $values = VendaFormapgto::where('id', 'in', $contasrec_venda_formapgto_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_venda_formapgto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_venda_formapgto_to_string = $contasrec_venda_formapgto_to_string;
        }

        $this->vdata['contasrec_venda_formapgto_to_string'] = $this->contasrec_venda_formapgto_to_string;
    }

    public function get_contasrec_venda_formapgto_to_string()
    {
        if(!empty($this->contasrec_venda_formapgto_to_string))
        {
            return $this->contasrec_venda_formapgto_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('venda_formapgto_id','{venda_formapgto->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_ativo_to_string($contasrec_ativo_to_string)
    {
        if(is_array($contasrec_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $contasrec_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_ativo_to_string = $contasrec_ativo_to_string;
        }

        $this->vdata['contasrec_ativo_to_string'] = $this->contasrec_ativo_to_string;
    }

    public function get_contasrec_ativo_to_string()
    {
        if(!empty($this->contasrec_ativo_to_string))
        {
            return $this->contasrec_ativo_to_string;
        }
    
        $values = Contasrec::where('cliente_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_cliente_to_string($contasrec_bloco_cliente_to_string)
    {
        if(is_array($contasrec_bloco_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_bloco_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_bloco_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_cliente_to_string = $contasrec_bloco_cliente_to_string;
        }

        $this->vdata['contasrec_bloco_cliente_to_string'] = $this->contasrec_bloco_cliente_to_string;
    }

    public function get_contasrec_bloco_cliente_to_string()
    {
        if(!empty($this->contasrec_bloco_cliente_to_string))
        {
            return $this->contasrec_bloco_cliente_to_string;
        }
    
        $values = ContasrecBloco::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_forma_pagamento_to_string($contasrec_bloco_forma_pagamento_to_string)
    {
        if(is_array($contasrec_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_forma_pagamento_to_string = $contasrec_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_bloco_forma_pagamento_to_string'] = $this->contasrec_bloco_forma_pagamento_to_string;
    }

    public function get_contasrec_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_bloco_forma_pagamento_to_string))
        {
            return $this->contasrec_bloco_forma_pagamento_to_string;
        }
    
        $values = ContasrecBloco::where('cliente_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_system_unit_to_string($contasrec_bloco_system_unit_to_string)
    {
        if(is_array($contasrec_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_system_unit_to_string = $contasrec_bloco_system_unit_to_string;
        }

        $this->vdata['contasrec_bloco_system_unit_to_string'] = $this->contasrec_bloco_system_unit_to_string;
    }

    public function get_contasrec_bloco_system_unit_to_string()
    {
        if(!empty($this->contasrec_bloco_system_unit_to_string))
        {
            return $this->contasrec_bloco_system_unit_to_string;
        }
    
        $values = ContasrecBloco::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_plano_conta_to_string($contasrec_bloco_plano_conta_to_string)
    {
        if(is_array($contasrec_bloco_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_bloco_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_plano_conta_to_string = $contasrec_bloco_plano_conta_to_string;
        }

        $this->vdata['contasrec_bloco_plano_conta_to_string'] = $this->contasrec_bloco_plano_conta_to_string;
    }

    public function get_contasrec_bloco_plano_conta_to_string()
    {
        if(!empty($this->contasrec_bloco_plano_conta_to_string))
        {
            return $this->contasrec_bloco_plano_conta_to_string;
        }
    
        $values = ContasrecBloco::where('cliente_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_centro_custo_to_string($contasrec_bloco_centro_custo_to_string)
    {
        if(is_array($contasrec_bloco_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_bloco_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_centro_custo_to_string = $contasrec_bloco_centro_custo_to_string;
        }

        $this->vdata['contasrec_bloco_centro_custo_to_string'] = $this->contasrec_bloco_centro_custo_to_string;
    }

    public function get_contasrec_bloco_centro_custo_to_string()
    {
        if(!empty($this->contasrec_bloco_centro_custo_to_string))
        {
            return $this->contasrec_bloco_centro_custo_to_string;
        }
    
        $values = ContasrecBloco::where('cliente_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_system_unit_to_string($negocio_system_unit_to_string)
    {
        if(is_array($negocio_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $negocio_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->negocio_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_system_unit_to_string = $negocio_system_unit_to_string;
        }

        $this->vdata['negocio_system_unit_to_string'] = $this->negocio_system_unit_to_string;
    }

    public function get_negocio_system_unit_to_string()
    {
        if(!empty($this->negocio_system_unit_to_string))
        {
            return $this->negocio_system_unit_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_origem_to_string($negocio_negocio_origem_to_string)
    {
        if(is_array($negocio_negocio_origem_to_string))
        {
            $values = NegocioOrigem::where('id', 'in', $negocio_negocio_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_origem_to_string = $negocio_negocio_origem_to_string;
        }

        $this->vdata['negocio_negocio_origem_to_string'] = $this->negocio_negocio_origem_to_string;
    }

    public function get_negocio_negocio_origem_to_string()
    {
        if(!empty($this->negocio_negocio_origem_to_string))
        {
            return $this->negocio_negocio_origem_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('negocio_origem_id','{negocio_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_to_string($negocio_funil_to_string)
    {
        if(is_array($negocio_funil_to_string))
        {
            $values = Funil::where('id', 'in', $negocio_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_to_string = $negocio_funil_to_string;
        }

        $this->vdata['negocio_funil_to_string'] = $this->negocio_funil_to_string;
    }

    public function get_negocio_funil_to_string()
    {
        if(!empty($this->negocio_funil_to_string))
        {
            return $this->negocio_funil_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_etapas_to_string($negocio_funil_etapas_to_string)
    {
        if(is_array($negocio_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_etapas_to_string = $negocio_funil_etapas_to_string;
        }

        $this->vdata['negocio_funil_etapas_to_string'] = $this->negocio_funil_etapas_to_string;
    }

    public function get_negocio_funil_etapas_to_string()
    {
        if(!empty($this->negocio_funil_etapas_to_string))
        {
            return $this->negocio_funil_etapas_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_motivo_perda_to_string($negocio_negocio_motivo_perda_to_string)
    {
        if(is_array($negocio_negocio_motivo_perda_to_string))
        {
            $values = NegocioMotivoPerda::where('id', 'in', $negocio_negocio_motivo_perda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_motivo_perda_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_motivo_perda_to_string = $negocio_negocio_motivo_perda_to_string;
        }

        $this->vdata['negocio_negocio_motivo_perda_to_string'] = $this->negocio_negocio_motivo_perda_to_string;
    }

    public function get_negocio_negocio_motivo_perda_to_string()
    {
        if(!empty($this->negocio_negocio_motivo_perda_to_string))
        {
            return $this->negocio_negocio_motivo_perda_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('negocio_motivo_perda_id','{negocio_motivo_perda->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_ativo_to_string($negocio_ativo_to_string)
    {
        if(is_array($negocio_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $negocio_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_ativo_to_string = $negocio_ativo_to_string;
        }

        $this->vdata['negocio_ativo_to_string'] = $this->negocio_ativo_to_string;
    }

    public function get_negocio_ativo_to_string()
    {
        if(!empty($this->negocio_ativo_to_string))
        {
            return $this->negocio_ativo_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_fk_arquivado_to_string($negocio_fk_arquivado_to_string)
    {
        if(is_array($negocio_fk_arquivado_to_string))
        {
            $values = Resposta::where('id', 'in', $negocio_fk_arquivado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_fk_arquivado_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_fk_arquivado_to_string = $negocio_fk_arquivado_to_string;
        }

        $this->vdata['negocio_fk_arquivado_to_string'] = $this->negocio_fk_arquivado_to_string;
    }

    public function get_negocio_fk_arquivado_to_string()
    {
        if(!empty($this->negocio_fk_arquivado_to_string))
        {
            return $this->negocio_fk_arquivado_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('arquivado','{fk_arquivado->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_vendedor_to_string($negocio_vendedor_to_string)
    {
        if(is_array($negocio_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $negocio_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_vendedor_to_string = $negocio_vendedor_to_string;
        }

        $this->vdata['negocio_vendedor_to_string'] = $this->negocio_vendedor_to_string;
    }

    public function get_negocio_vendedor_to_string()
    {
        if(!empty($this->negocio_vendedor_to_string))
        {
            return $this->negocio_vendedor_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_orcamento_to_string($negocio_orcamento_to_string)
    {
        if(is_array($negocio_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $negocio_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->negocio_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_orcamento_to_string = $negocio_orcamento_to_string;
        }

        $this->vdata['negocio_orcamento_to_string'] = $this->negocio_orcamento_to_string;
    }

    public function get_negocio_orcamento_to_string()
    {
        if(!empty($this->negocio_orcamento_to_string))
        {
            return $this->negocio_orcamento_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_negocio_cliente_to_string($negocio_cliente_to_string)
    {
        if(is_array($negocio_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $negocio_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_cliente_to_string = $negocio_cliente_to_string;
        }

        $this->vdata['negocio_cliente_to_string'] = $this->negocio_cliente_to_string;
    }

    public function get_negocio_cliente_to_string()
    {
        if(!empty($this->negocio_cliente_to_string))
        {
            return $this->negocio_cliente_to_string;
        }
    
        $values = Negocio::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_system_unit_to_string($notafiscal_system_unit_to_string)
    {
        if(is_array($notafiscal_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_system_unit_to_string = $notafiscal_system_unit_to_string;
        }

        $this->vdata['notafiscal_system_unit_to_string'] = $this->notafiscal_system_unit_to_string;
    }

    public function get_notafiscal_system_unit_to_string()
    {
        if(!empty($this->notafiscal_system_unit_to_string))
        {
            return $this->notafiscal_system_unit_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_cliente_to_string($notafiscal_cliente_to_string)
    {
        if(is_array($notafiscal_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $notafiscal_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_cliente_to_string = $notafiscal_cliente_to_string;
        }

        $this->vdata['notafiscal_cliente_to_string'] = $this->notafiscal_cliente_to_string;
    }

    public function get_notafiscal_cliente_to_string()
    {
        if(!empty($this->notafiscal_cliente_to_string))
        {
            return $this->notafiscal_cliente_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_venda_to_string($notafiscal_venda_to_string)
    {
        if(is_array($notafiscal_venda_to_string))
        {
            $values = Venda::where('id', 'in', $notafiscal_venda_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_venda_to_string = $notafiscal_venda_to_string;
        }

        $this->vdata['notafiscal_venda_to_string'] = $this->notafiscal_venda_to_string;
    }

    public function get_notafiscal_venda_to_string()
    {
        if(!empty($this->notafiscal_venda_to_string))
        {
            return $this->notafiscal_venda_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_nf_tipodocumento_to_string($notafiscal_nf_tipodocumento_to_string)
    {
        if(is_array($notafiscal_nf_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_nf_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_nf_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_nf_tipodocumento_to_string = $notafiscal_nf_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_nf_tipodocumento_to_string'] = $this->notafiscal_nf_tipodocumento_to_string;
    }

    public function get_notafiscal_nf_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_nf_tipodocumento_to_string))
        {
            return $this->notafiscal_nf_tipodocumento_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('nf_tipodocumento_id','{nf_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_situacao_to_string($notafiscal_notafiscal_situacao_to_string)
    {
        if(is_array($notafiscal_notafiscal_situacao_to_string))
        {
            $values = NotafiscalSituacao::where('id', 'in', $notafiscal_notafiscal_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_situacao_to_string = $notafiscal_notafiscal_situacao_to_string;
        }

        $this->vdata['notafiscal_notafiscal_situacao_to_string'] = $this->notafiscal_notafiscal_situacao_to_string;
    }

    public function get_notafiscal_notafiscal_situacao_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_situacao_to_string))
        {
            return $this->notafiscal_notafiscal_situacao_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_situacao_id','{notafiscal_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_crt_to_string($notafiscal_notafiscal_crt_to_string)
    {
        if(is_array($notafiscal_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $notafiscal_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_crt_to_string = $notafiscal_notafiscal_crt_to_string;
        }

        $this->vdata['notafiscal_notafiscal_crt_to_string'] = $this->notafiscal_notafiscal_crt_to_string;
    }

    public function get_notafiscal_notafiscal_crt_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_crt_to_string))
        {
            return $this->notafiscal_notafiscal_crt_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indiedest_to_string($notafiscal_notafiscal_indiedest_to_string)
    {
        if(is_array($notafiscal_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $notafiscal_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indiedest_to_string = $notafiscal_notafiscal_indiedest_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indiedest_to_string'] = $this->notafiscal_notafiscal_indiedest_to_string;
    }

    public function get_notafiscal_notafiscal_indiedest_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indiedest_to_string))
        {
            return $this->notafiscal_notafiscal_indiedest_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscaldest_to_string($notafiscal_notafiscaldest_to_string)
    {
        if(is_array($notafiscal_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $notafiscal_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscaldest_to_string = $notafiscal_notafiscaldest_to_string;
        }

        $this->vdata['notafiscal_notafiscaldest_to_string'] = $this->notafiscal_notafiscaldest_to_string;
    }

    public function get_notafiscal_notafiscaldest_to_string()
    {
        if(!empty($this->notafiscal_notafiscaldest_to_string))
        {
            return $this->notafiscal_notafiscaldest_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpimp_to_string($notafiscal_notafiscal_tpimp_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $notafiscal_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpimp_to_string = $notafiscal_notafiscal_tpimp_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpimp_to_string'] = $this->notafiscal_notafiscal_tpimp_to_string;
    }

    public function get_notafiscal_notafiscal_tpimp_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpimp_to_string))
        {
            return $this->notafiscal_notafiscal_tpimp_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpemis_to_string($notafiscal_notafiscal_tpemis_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpemis_to_string))
        {
            $values = NotafiscalTpemis::where('id', 'in', $notafiscal_notafiscal_tpemis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpemis_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpemis_to_string = $notafiscal_notafiscal_tpemis_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpemis_to_string'] = $this->notafiscal_notafiscal_tpemis_to_string;
    }

    public function get_notafiscal_notafiscal_tpemis_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpemis_to_string))
        {
            return $this->notafiscal_notafiscal_tpemis_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_tpemis_id','{notafiscal_tpemis->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_finnfe_to_string($notafiscal_notafiscal_finnfe_to_string)
    {
        if(is_array($notafiscal_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $notafiscal_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_finnfe_to_string = $notafiscal_notafiscal_finnfe_to_string;
        }

        $this->vdata['notafiscal_notafiscal_finnfe_to_string'] = $this->notafiscal_notafiscal_finnfe_to_string;
    }

    public function get_notafiscal_notafiscal_finnfe_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_finnfe_to_string))
        {
            return $this->notafiscal_notafiscal_finnfe_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indfinal_to_string($notafiscal_notafiscal_indfinal_to_string)
    {
        if(is_array($notafiscal_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $notafiscal_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indfinal_to_string = $notafiscal_notafiscal_indfinal_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indfinal_to_string'] = $this->notafiscal_notafiscal_indfinal_to_string;
    }

    public function get_notafiscal_notafiscal_indfinal_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indfinal_to_string))
        {
            return $this->notafiscal_notafiscal_indfinal_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpres_to_string($notafiscal_notafiscal_indpres_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $notafiscal_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpres_to_string = $notafiscal_notafiscal_indpres_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpres_to_string'] = $this->notafiscal_notafiscal_indpres_to_string;
    }

    public function get_notafiscal_notafiscal_indpres_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpres_to_string))
        {
            return $this->notafiscal_notafiscal_indpres_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpag_to_string($notafiscal_notafiscal_indpag_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $notafiscal_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpag_to_string = $notafiscal_notafiscal_indpag_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpag_to_string'] = $this->notafiscal_notafiscal_indpag_to_string;
    }

    public function get_notafiscal_notafiscal_indpag_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpag_to_string))
        {
            return $this->notafiscal_notafiscal_indpag_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dispositivos_to_string($notafiscal_dispositivos_to_string)
    {
        if(is_array($notafiscal_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $notafiscal_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dispositivos_to_string = $notafiscal_dispositivos_to_string;
        }

        $this->vdata['notafiscal_dispositivos_to_string'] = $this->notafiscal_dispositivos_to_string;
    }

    public function get_notafiscal_dispositivos_to_string()
    {
        if(!empty($this->notafiscal_dispositivos_to_string))
        {
            return $this->notafiscal_dispositivos_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpamb_to_string($notafiscal_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpamb_to_string = $notafiscal_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpamb_to_string'] = $this->notafiscal_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_notafiscal_tpamb_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_mod_to_string($notafiscal_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_mod_to_string = $notafiscal_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_notafiscal_mod_to_string'] = $this->notafiscal_notafiscal_mod_to_string;
    }

    public function get_notafiscal_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_mod_to_string))
        {
            return $this->notafiscal_notafiscal_mod_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_modfrete_to_string($notafiscal_notafiscal_modfrete_to_string)
    {
        if(is_array($notafiscal_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $notafiscal_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_modfrete_to_string = $notafiscal_notafiscal_modfrete_to_string;
        }

        $this->vdata['notafiscal_notafiscal_modfrete_to_string'] = $this->notafiscal_notafiscal_modfrete_to_string;
    }

    public function get_notafiscal_notafiscal_modfrete_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_modfrete_to_string))
        {
            return $this->notafiscal_notafiscal_modfrete_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_natureza_operacao_to_string($notafiscal_natureza_operacao_to_string)
    {
        if(is_array($notafiscal_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $notafiscal_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_natureza_operacao_to_string = $notafiscal_natureza_operacao_to_string;
        }

        $this->vdata['notafiscal_natureza_operacao_to_string'] = $this->notafiscal_natureza_operacao_to_string;
    }

    public function get_notafiscal_natureza_operacao_to_string()
    {
        if(!empty($this->notafiscal_natureza_operacao_to_string))
        {
            return $this->notafiscal_natureza_operacao_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_movimentacao_origem_to_string($notafiscal_movimentacao_origem_to_string)
    {
        if(is_array($notafiscal_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $notafiscal_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_movimentacao_origem_to_string = $notafiscal_movimentacao_origem_to_string;
        }

        $this->vdata['notafiscal_movimentacao_origem_to_string'] = $this->notafiscal_movimentacao_origem_to_string;
    }

    public function get_notafiscal_movimentacao_origem_to_string()
    {
        if(!empty($this->notafiscal_movimentacao_origem_to_string))
        {
            return $this->notafiscal_movimentacao_origem_to_string;
        }
    
        $values = Notafiscal::where('cliente_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_system_unit_to_string($orcamento_system_unit_to_string)
    {
        if(is_array($orcamento_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $orcamento_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->orcamento_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_system_unit_to_string = $orcamento_system_unit_to_string;
        }

        $this->vdata['orcamento_system_unit_to_string'] = $this->orcamento_system_unit_to_string;
    }

    public function get_orcamento_system_unit_to_string()
    {
        if(!empty($this->orcamento_system_unit_to_string))
        {
            return $this->orcamento_system_unit_to_string;
        }
    
        $values = Orcamento::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_orcamento_orcamento_situacao_to_string($orcamento_orcamento_situacao_to_string)
    {
        if(is_array($orcamento_orcamento_situacao_to_string))
        {
            $values = OrcamentoSituacao::where('id', 'in', $orcamento_orcamento_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_orcamento_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_orcamento_situacao_to_string = $orcamento_orcamento_situacao_to_string;
        }

        $this->vdata['orcamento_orcamento_situacao_to_string'] = $this->orcamento_orcamento_situacao_to_string;
    }

    public function get_orcamento_orcamento_situacao_to_string()
    {
        if(!empty($this->orcamento_orcamento_situacao_to_string))
        {
            return $this->orcamento_orcamento_situacao_to_string;
        }
    
        $values = Orcamento::where('cliente_id', '=', $this->id)->getIndexedArray('orcamento_situacao_id','{orcamento_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_vendedor_to_string($orcamento_vendedor_to_string)
    {
        if(is_array($orcamento_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $orcamento_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_vendedor_to_string = $orcamento_vendedor_to_string;
        }

        $this->vdata['orcamento_vendedor_to_string'] = $this->orcamento_vendedor_to_string;
    }

    public function get_orcamento_vendedor_to_string()
    {
        if(!empty($this->orcamento_vendedor_to_string))
        {
            return $this->orcamento_vendedor_to_string;
        }
    
        $values = Orcamento::where('cliente_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_to_string($orcamento_cliente_to_string)
    {
        if(is_array($orcamento_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $orcamento_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_to_string = $orcamento_cliente_to_string;
        }

        $this->vdata['orcamento_cliente_to_string'] = $this->orcamento_cliente_to_string;
    }

    public function get_orcamento_cliente_to_string()
    {
        if(!empty($this->orcamento_cliente_to_string))
        {
            return $this->orcamento_cliente_to_string;
        }
    
        $values = Orcamento::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_contato_to_string($orcamento_cliente_contato_to_string)
    {
        if(is_array($orcamento_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $orcamento_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_contato_to_string = $orcamento_cliente_contato_to_string;
        }

        $this->vdata['orcamento_cliente_contato_to_string'] = $this->orcamento_cliente_contato_to_string;
    }

    public function get_orcamento_cliente_contato_to_string()
    {
        if(!empty($this->orcamento_cliente_contato_to_string))
        {
            return $this->orcamento_cliente_contato_to_string;
        }
    
        $values = Orcamento::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_tabela_preco_to_string($orcamento_tabela_preco_to_string)
    {
        if(is_array($orcamento_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $orcamento_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_tabela_preco_to_string = $orcamento_tabela_preco_to_string;
        }

        $this->vdata['orcamento_tabela_preco_to_string'] = $this->orcamento_tabela_preco_to_string;
    }

    public function get_orcamento_tabela_preco_to_string()
    {
        if(!empty($this->orcamento_tabela_preco_to_string))
        {
            return $this->orcamento_tabela_preco_to_string;
        }
    
        $values = Orcamento::where('cliente_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_system_unit_to_string($ordem_servico_system_unit_to_string)
    {
        if(is_array($ordem_servico_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_servico_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_system_unit_to_string = $ordem_servico_system_unit_to_string;
        }

        $this->vdata['ordem_servico_system_unit_to_string'] = $this->ordem_servico_system_unit_to_string;
    }

    public function get_ordem_servico_system_unit_to_string()
    {
        if(!empty($this->ordem_servico_system_unit_to_string))
        {
            return $this->ordem_servico_system_unit_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_to_string($ordem_servico_cliente_to_string)
    {
        if(is_array($ordem_servico_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $ordem_servico_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_to_string = $ordem_servico_cliente_to_string;
        }

        $this->vdata['ordem_servico_cliente_to_string'] = $this->ordem_servico_cliente_to_string;
    }

    public function get_ordem_servico_cliente_to_string()
    {
        if(!empty($this->ordem_servico_cliente_to_string))
        {
            return $this->ordem_servico_cliente_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_contato_to_string($ordem_servico_cliente_contato_to_string)
    {
        if(is_array($ordem_servico_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $ordem_servico_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_contato_to_string = $ordem_servico_cliente_contato_to_string;
        }

        $this->vdata['ordem_servico_cliente_contato_to_string'] = $this->ordem_servico_cliente_contato_to_string;
    }

    public function get_ordem_servico_cliente_contato_to_string()
    {
        if(!empty($this->ordem_servico_cliente_contato_to_string))
        {
            return $this->ordem_servico_cliente_contato_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_vendedor_to_string($ordem_servico_vendedor_to_string)
    {
        if(is_array($ordem_servico_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $ordem_servico_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_vendedor_to_string = $ordem_servico_vendedor_to_string;
        }

        $this->vdata['ordem_servico_vendedor_to_string'] = $this->ordem_servico_vendedor_to_string;
    }

    public function get_ordem_servico_vendedor_to_string()
    {
        if(!empty($this->ordem_servico_vendedor_to_string))
        {
            return $this->ordem_servico_vendedor_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_situacao_to_string($ordem_servico_ordem_servico_situacao_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_situacao_to_string))
        {
            $values = OrdemServicoSituacao::where('id', 'in', $ordem_servico_ordem_servico_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_situacao_to_string = $ordem_servico_ordem_servico_situacao_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_situacao_to_string'] = $this->ordem_servico_ordem_servico_situacao_to_string;
    }

    public function get_ordem_servico_ordem_servico_situacao_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_situacao_to_string))
        {
            return $this->ordem_servico_ordem_servico_situacao_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('ordem_servico_situacao_id','{ordem_servico_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_producao_etapa_to_string($ordem_servico_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = $ordem_servico_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_condicao_pagamento_to_string($ordem_servico_condicao_pagamento_to_string)
    {
        if(is_array($ordem_servico_condicao_pagamento_to_string))
        {
            $values = CondicaoPagamento::where('id', 'in', $ordem_servico_condicao_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_condicao_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_condicao_pagamento_to_string = $ordem_servico_condicao_pagamento_to_string;
        }

        $this->vdata['ordem_servico_condicao_pagamento_to_string'] = $this->ordem_servico_condicao_pagamento_to_string;
    }

    public function get_ordem_servico_condicao_pagamento_to_string()
    {
        if(!empty($this->ordem_servico_condicao_pagamento_to_string))
        {
            return $this->ordem_servico_condicao_pagamento_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('condicao_pagamento_id','{condicao_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_endereco_to_string($ordem_servico_cliente_endereco_to_string)
    {
        if(is_array($ordem_servico_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $ordem_servico_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->ordem_servico_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_endereco_to_string = $ordem_servico_cliente_endereco_to_string;
        }

        $this->vdata['ordem_servico_cliente_endereco_to_string'] = $this->ordem_servico_cliente_endereco_to_string;
    }

    public function get_ordem_servico_cliente_endereco_to_string()
    {
        if(!empty($this->ordem_servico_cliente_endereco_to_string))
        {
            return $this->ordem_servico_cliente_endereco_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_usuario_aprovacao_to_string($ordem_servico_usuario_aprovacao_to_string)
    {
        if(is_array($ordem_servico_usuario_aprovacao_to_string))
        {
            $values = SystemUsers::where('id', 'in', $ordem_servico_usuario_aprovacao_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_usuario_aprovacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_usuario_aprovacao_to_string = $ordem_servico_usuario_aprovacao_to_string;
        }

        $this->vdata['ordem_servico_usuario_aprovacao_to_string'] = $this->ordem_servico_usuario_aprovacao_to_string;
    }

    public function get_ordem_servico_usuario_aprovacao_to_string()
    {
        if(!empty($this->ordem_servico_usuario_aprovacao_to_string))
        {
            return $this->ordem_servico_usuario_aprovacao_to_string;
        }
    
        $values = OrdemServico::where('cliente_id', '=', $this->id)->getIndexedArray('usuario_aprovacao_id','{usuario_aprovacao->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_situacao_to_string($venda_venda_situacao_to_string)
    {
        if(is_array($venda_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_situacao_to_string = $venda_venda_situacao_to_string;
        }

        $this->vdata['venda_venda_situacao_to_string'] = $this->venda_venda_situacao_to_string;
    }

    public function get_venda_venda_situacao_to_string()
    {
        if(!empty($this->venda_venda_situacao_to_string))
        {
            return $this->venda_venda_situacao_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_orcamento_to_string($venda_orcamento_to_string)
    {
        if(is_array($venda_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $venda_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->venda_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_orcamento_to_string = $venda_orcamento_to_string;
        }

        $this->vdata['venda_orcamento_to_string'] = $this->venda_orcamento_to_string;
    }

    public function get_venda_orcamento_to_string()
    {
        if(!empty($this->venda_orcamento_to_string))
        {
            return $this->venda_orcamento_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_vendedor_to_string($venda_vendedor_to_string)
    {
        if(is_array($venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_vendedor_to_string = $venda_vendedor_to_string;
        }

        $this->vdata['venda_vendedor_to_string'] = $this->venda_vendedor_to_string;
    }

    public function get_venda_vendedor_to_string()
    {
        if(!empty($this->venda_vendedor_to_string))
        {
            return $this->venda_vendedor_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_venda_dispositivos_to_string($venda_dispositivos_to_string)
    {
        if(is_array($venda_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $venda_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->venda_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_dispositivos_to_string = $venda_dispositivos_to_string;
        }

        $this->vdata['venda_dispositivos_to_string'] = $this->venda_dispositivos_to_string;
    }

    public function get_venda_dispositivos_to_string()
    {
        if(!empty($this->venda_dispositivos_to_string))
        {
            return $this->venda_dispositivos_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_to_string($venda_cliente_to_string)
    {
        if(is_array($venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_to_string = $venda_cliente_to_string;
        }

        $this->vdata['venda_cliente_to_string'] = $this->venda_cliente_to_string;
    }

    public function get_venda_cliente_to_string()
    {
        if(!empty($this->venda_cliente_to_string))
        {
            return $this->venda_cliente_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_venda_system_unit_to_string($venda_system_unit_to_string)
    {
        if(is_array($venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_system_unit_to_string = $venda_system_unit_to_string;
        }

        $this->vdata['venda_system_unit_to_string'] = $this->venda_system_unit_to_string;
    }

    public function get_venda_system_unit_to_string()
    {
        if(!empty($this->venda_system_unit_to_string))
        {
            return $this->venda_system_unit_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_filial_saida_to_string($venda_filial_saida_to_string)
    {
        if(is_array($venda_filial_saida_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_filial_saida_to_string)->getIndexedArray('name', 'name');
            $this->venda_filial_saida_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_filial_saida_to_string = $venda_filial_saida_to_string;
        }

        $this->vdata['venda_filial_saida_to_string'] = $this->venda_filial_saida_to_string;
    }

    public function get_venda_filial_saida_to_string()
    {
        if(!empty($this->venda_filial_saida_to_string))
        {
            return $this->venda_filial_saida_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('filial_saida_id','{filial_saida->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_modalidade_to_string($venda_venda_modalidade_to_string)
    {
        if(is_array($venda_venda_modalidade_to_string))
        {
            $values = VendaModalidade::where('id', 'in', $venda_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_modalidade_to_string = $venda_venda_modalidade_to_string;
        }

        $this->vdata['venda_venda_modalidade_to_string'] = $this->venda_venda_modalidade_to_string;
    }

    public function get_venda_venda_modalidade_to_string()
    {
        if(!empty($this->venda_venda_modalidade_to_string))
        {
            return $this->venda_venda_modalidade_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('venda_modalidade_id','{venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_tipo_pagamento_to_string($venda_venda_tipo_pagamento_to_string)
    {
        if(is_array($venda_venda_tipo_pagamento_to_string))
        {
            $values = VendaTipoPagamento::where('id', 'in', $venda_venda_tipo_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_tipo_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_tipo_pagamento_to_string = $venda_venda_tipo_pagamento_to_string;
        }

        $this->vdata['venda_venda_tipo_pagamento_to_string'] = $this->venda_venda_tipo_pagamento_to_string;
    }

    public function get_venda_venda_tipo_pagamento_to_string()
    {
        if(!empty($this->venda_venda_tipo_pagamento_to_string))
        {
            return $this->venda_venda_tipo_pagamento_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('venda_tipo_pagamento_id','{venda_tipo_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_endereco_to_string($venda_cliente_endereco_to_string)
    {
        if(is_array($venda_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $venda_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->venda_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_endereco_to_string = $venda_cliente_endereco_to_string;
        }

        $this->vdata['venda_cliente_endereco_to_string'] = $this->venda_cliente_endereco_to_string;
    }

    public function get_venda_cliente_endereco_to_string()
    {
        if(!empty($this->venda_cliente_endereco_to_string))
        {
            return $this->venda_cliente_endereco_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_venda_tabela_preco_to_string($venda_tabela_preco_to_string)
    {
        if(is_array($venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_tabela_preco_to_string = $venda_tabela_preco_to_string;
        }

        $this->vdata['venda_tabela_preco_to_string'] = $this->venda_tabela_preco_to_string;
    }

    public function get_venda_tabela_preco_to_string()
    {
        if(!empty($this->venda_tabela_preco_to_string))
        {
            return $this->venda_tabela_preco_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_movimentacao_origem_to_string($venda_movimentacao_origem_to_string)
    {
        if(is_array($venda_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $venda_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_movimentacao_origem_to_string = $venda_movimentacao_origem_to_string;
        }

        $this->vdata['venda_movimentacao_origem_to_string'] = $this->venda_movimentacao_origem_to_string;
    }

    public function get_venda_movimentacao_origem_to_string()
    {
        if(!empty($this->venda_movimentacao_origem_to_string))
        {
            return $this->venda_movimentacao_origem_to_string;
        }
    
        $values = Venda::where('cliente_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public static function SincronizaPermissoesEspeciais()
    {
      SystemProgramPermissoes::ProcessaPermissao('ClienteList',self::Permissao_ExcluirCliente);
    }  

    // public function get_cpf_cnpj()
    // {
    //   return Funcoes::mascaraCpfCnpj($this->cpf_cnpj); 
    // }  

    // public function set_cpf_cnpj()
    // {
    //   $this->cpf_cnpj = Funcoes::limpaCPF_CNPJ($this->cpf_cnpj); 
    // }  

        
}

