<?php

class ClienteClassificacao extends TRecord
{
    const TABLENAME  = 'cliente_classificacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ativo;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
        parent::addAttribute('ativo_id');
    
    }

    /**
     * Method set_ativo
     * Sample of usage: $var->ativo = $object;
     * @param $object Instance of Ativo
     */
    public function set_ativo(Ativo $object)
    {
        $this->ativo = $object;
        $this->ativo_id = $object->id;
    }

    /**
     * Method get_ativo
     * Sample of usage: $var->ativo->attribute;
     * @returns Ativo instance
     */
    public function get_ativo()
    {
    
        // loads the associated object
        if (empty($this->ativo))
            $this->ativo = new Ativo($this->ativo_id);
    
        // returns the associated object
        return $this->ativo;
    }

    /**
     * Method getClientes
     */
    public function getClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_classificacao_id', '=', $this->id));
        return Cliente::getObjects( $criteria );
    }
    /**
     * Method getClienteClassificacaoSubgrupos
     */
    public function getClienteClassificacaoSubgrupos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_classificacao_id', '=', $this->id));
        return ClienteClassificacaoSubgrupo::getObjects( $criteria );
    }

    public function set_cliente_pessoa_tipo_to_string($cliente_pessoa_tipo_to_string)
    {
        if(is_array($cliente_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $cliente_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_pessoa_tipo_to_string = $cliente_pessoa_tipo_to_string;
        }

        $this->vdata['cliente_pessoa_tipo_to_string'] = $this->cliente_pessoa_tipo_to_string;
    }

    public function get_cliente_pessoa_tipo_to_string()
    {
        if(!empty($this->cliente_pessoa_tipo_to_string))
        {
            return $this->cliente_pessoa_tipo_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_to_string($cliente_cliente_classificacao_to_string)
    {
        if(is_array($cliente_cliente_classificacao_to_string))
        {
            $values = ClienteClassificacao::where('id', 'in', $cliente_cliente_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_to_string = $cliente_cliente_classificacao_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_to_string'] = $this->cliente_cliente_classificacao_to_string;
    }

    public function get_cliente_cliente_classificacao_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_to_string))
        {
            return $this->cliente_cliente_classificacao_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('cliente_classificacao_id','{cliente_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_subgrupo_to_string($cliente_cliente_classificacao_subgrupo_to_string)
    {
        if(is_array($cliente_cliente_classificacao_subgrupo_to_string))
        {
            $values = ClienteClassificacaoSubgrupo::where('id', 'in', $cliente_cliente_classificacao_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_subgrupo_to_string = $cliente_cliente_classificacao_subgrupo_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_subgrupo_to_string'] = $this->cliente_cliente_classificacao_subgrupo_to_string;
    }

    public function get_cliente_cliente_classificacao_subgrupo_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_subgrupo_to_string))
        {
            return $this->cliente_cliente_classificacao_subgrupo_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('cliente_classificacao_subgrupo_id','{cliente_classificacao_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_vendedor_to_string($cliente_vendedor_to_string)
    {
        if(is_array($cliente_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $cliente_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_vendedor_to_string = $cliente_vendedor_to_string;
        }

        $this->vdata['cliente_vendedor_to_string'] = $this->cliente_vendedor_to_string;
    }

    public function get_cliente_vendedor_to_string()
    {
        if(!empty($this->cliente_vendedor_to_string))
        {
            return $this->cliente_vendedor_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_indiedest_to_string($cliente_notafiscal_indiedest_to_string)
    {
        if(is_array($cliente_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $cliente_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_indiedest_to_string = $cliente_notafiscal_indiedest_to_string;
        }

        $this->vdata['cliente_notafiscal_indiedest_to_string'] = $this->cliente_notafiscal_indiedest_to_string;
    }

    public function get_cliente_notafiscal_indiedest_to_string()
    {
        if(!empty($this->cliente_notafiscal_indiedest_to_string))
        {
            return $this->cliente_notafiscal_indiedest_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_crt_to_string($cliente_notafiscal_crt_to_string)
    {
        if(is_array($cliente_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $cliente_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_crt_to_string = $cliente_notafiscal_crt_to_string;
        }

        $this->vdata['cliente_notafiscal_crt_to_string'] = $this->cliente_notafiscal_crt_to_string;
    }

    public function get_cliente_notafiscal_crt_to_string()
    {
        if(!empty($this->cliente_notafiscal_crt_to_string))
        {
            return $this->cliente_notafiscal_crt_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_residencia_propria_to_string($cliente_fk_residencia_propria_to_string)
    {
        if(is_array($cliente_fk_residencia_propria_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_residencia_propria_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_residencia_propria_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_residencia_propria_to_string = $cliente_fk_residencia_propria_to_string;
        }

        $this->vdata['cliente_fk_residencia_propria_to_string'] = $this->cliente_fk_residencia_propria_to_string;
    }

    public function get_cliente_fk_residencia_propria_to_string()
    {
        if(!empty($this->cliente_fk_residencia_propria_to_string))
        {
            return $this->cliente_fk_residencia_propria_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('residencia_propria','{fk_residencia_propria->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_utilizar_endereco_cobranca_to_string($cliente_fk_utilizar_endereco_cobranca_to_string)
    {
        if(is_array($cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_utilizar_endereco_cobranca_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = $cliente_fk_utilizar_endereco_cobranca_to_string;
        }

        $this->vdata['cliente_fk_utilizar_endereco_cobranca_to_string'] = $this->cliente_fk_utilizar_endereco_cobranca_to_string;
    }

    public function get_cliente_fk_utilizar_endereco_cobranca_to_string()
    {
        if(!empty($this->cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            return $this->cliente_fk_utilizar_endereco_cobranca_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('utilizar_endereco_cobranca','{fk_utilizar_endereco_cobranca->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_situacao_to_string($cliente_cliente_situacao_to_string)
    {
        if(is_array($cliente_cliente_situacao_to_string))
        {
            $values = ClienteSituacao::where('id', 'in', $cliente_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_situacao_to_string = $cliente_cliente_situacao_to_string;
        }

        $this->vdata['cliente_cliente_situacao_to_string'] = $this->cliente_cliente_situacao_to_string;
    }

    public function get_cliente_cliente_situacao_to_string()
    {
        if(!empty($this->cliente_cliente_situacao_to_string))
        {
            return $this->cliente_cliente_situacao_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('cliente_situacao_id','{cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_system_unit_to_string($cliente_system_unit_to_string)
    {
        if(is_array($cliente_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $cliente_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->cliente_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_system_unit_to_string = $cliente_system_unit_to_string;
        }

        $this->vdata['cliente_system_unit_to_string'] = $this->cliente_system_unit_to_string;
    }

    public function get_cliente_system_unit_to_string()
    {
        if(!empty($this->cliente_system_unit_to_string))
        {
            return $this->cliente_system_unit_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_cliente_tabela_preco_to_string($cliente_tabela_preco_to_string)
    {
        if(is_array($cliente_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $cliente_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_tabela_preco_to_string = $cliente_tabela_preco_to_string;
        }

        $this->vdata['cliente_tabela_preco_to_string'] = $this->cliente_tabela_preco_to_string;
    }

    public function get_cliente_tabela_preco_to_string()
    {
        if(!empty($this->cliente_tabela_preco_to_string))
        {
            return $this->cliente_tabela_preco_to_string;
        }
    
        $values = Cliente::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_classificacao_subgrupo_cliente_classificacao_to_string($cliente_classificacao_subgrupo_cliente_classificacao_to_string)
    {
        if(is_array($cliente_classificacao_subgrupo_cliente_classificacao_to_string))
        {
            $values = ClienteClassificacao::where('id', 'in', $cliente_classificacao_subgrupo_cliente_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_classificacao_subgrupo_cliente_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_classificacao_subgrupo_cliente_classificacao_to_string = $cliente_classificacao_subgrupo_cliente_classificacao_to_string;
        }

        $this->vdata['cliente_classificacao_subgrupo_cliente_classificacao_to_string'] = $this->cliente_classificacao_subgrupo_cliente_classificacao_to_string;
    }

    public function get_cliente_classificacao_subgrupo_cliente_classificacao_to_string()
    {
        if(!empty($this->cliente_classificacao_subgrupo_cliente_classificacao_to_string))
        {
            return $this->cliente_classificacao_subgrupo_cliente_classificacao_to_string;
        }
    
        $values = ClienteClassificacaoSubgrupo::where('cliente_classificacao_id', '=', $this->id)->getIndexedArray('cliente_classificacao_id','{cliente_classificacao->descricao}');
        return implode(', ', $values);
    }

  public static function informacoes_ajuda()
  {
      $texto = '<b>Classificação de Clientes</b><br>'.
               'Cadastro de grupos e sub-grupos de clientes. Classifique seus clientes por segmentação.<br><br> '.
            //   '<b>Excemplo:</b>'.
            //   'Produto: Laranja. Pode-se criar um grupo com o nome de Frutas.<br><br>';
               '<b>Video explicativo:</b><br>'.
               '<iframe width="560" height="315" src="https://www.youtube.com/embed/9wXbZB4Iegg" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>';

      return $texto;
  }  
    
}

