<?php

class ClienteContato extends TRecord
{
    const TABLENAME  = 'cliente_contato';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    private $cliente;

    

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cliente_id');
        parent::addAttribute('tipo_contato');
        parent::addAttribute('nome');
        parent::addAttribute('fone');
        parent::addAttribute('ativo_id');
            
    }

    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }

    /**
     * Method getOrcamentos
     */
    public function getOrcamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_contato_id', '=', $this->id));
        return Orcamento::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicos
     */
    public function getOrdemServicos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_contato_id', '=', $this->id));
        return OrdemServico::getObjects( $criteria );
    }

    public function set_orcamento_system_unit_to_string($orcamento_system_unit_to_string)
    {
        if(is_array($orcamento_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $orcamento_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->orcamento_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_system_unit_to_string = $orcamento_system_unit_to_string;
        }

        $this->vdata['orcamento_system_unit_to_string'] = $this->orcamento_system_unit_to_string;
    }

    public function get_orcamento_system_unit_to_string()
    {
        if(!empty($this->orcamento_system_unit_to_string))
        {
            return $this->orcamento_system_unit_to_string;
        }
    
        $values = Orcamento::where('cliente_contato_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_orcamento_orcamento_situacao_to_string($orcamento_orcamento_situacao_to_string)
    {
        if(is_array($orcamento_orcamento_situacao_to_string))
        {
            $values = OrcamentoSituacao::where('id', 'in', $orcamento_orcamento_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_orcamento_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_orcamento_situacao_to_string = $orcamento_orcamento_situacao_to_string;
        }

        $this->vdata['orcamento_orcamento_situacao_to_string'] = $this->orcamento_orcamento_situacao_to_string;
    }

    public function get_orcamento_orcamento_situacao_to_string()
    {
        if(!empty($this->orcamento_orcamento_situacao_to_string))
        {
            return $this->orcamento_orcamento_situacao_to_string;
        }
    
        $values = Orcamento::where('cliente_contato_id', '=', $this->id)->getIndexedArray('orcamento_situacao_id','{orcamento_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_vendedor_to_string($orcamento_vendedor_to_string)
    {
        if(is_array($orcamento_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $orcamento_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_vendedor_to_string = $orcamento_vendedor_to_string;
        }

        $this->vdata['orcamento_vendedor_to_string'] = $this->orcamento_vendedor_to_string;
    }

    public function get_orcamento_vendedor_to_string()
    {
        if(!empty($this->orcamento_vendedor_to_string))
        {
            return $this->orcamento_vendedor_to_string;
        }
    
        $values = Orcamento::where('cliente_contato_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_to_string($orcamento_cliente_to_string)
    {
        if(is_array($orcamento_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $orcamento_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_to_string = $orcamento_cliente_to_string;
        }

        $this->vdata['orcamento_cliente_to_string'] = $this->orcamento_cliente_to_string;
    }

    public function get_orcamento_cliente_to_string()
    {
        if(!empty($this->orcamento_cliente_to_string))
        {
            return $this->orcamento_cliente_to_string;
        }
    
        $values = Orcamento::where('cliente_contato_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_contato_to_string($orcamento_cliente_contato_to_string)
    {
        if(is_array($orcamento_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $orcamento_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_contato_to_string = $orcamento_cliente_contato_to_string;
        }

        $this->vdata['orcamento_cliente_contato_to_string'] = $this->orcamento_cliente_contato_to_string;
    }

    public function get_orcamento_cliente_contato_to_string()
    {
        if(!empty($this->orcamento_cliente_contato_to_string))
        {
            return $this->orcamento_cliente_contato_to_string;
        }
    
        $values = Orcamento::where('cliente_contato_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_tabela_preco_to_string($orcamento_tabela_preco_to_string)
    {
        if(is_array($orcamento_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $orcamento_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_tabela_preco_to_string = $orcamento_tabela_preco_to_string;
        }

        $this->vdata['orcamento_tabela_preco_to_string'] = $this->orcamento_tabela_preco_to_string;
    }

    public function get_orcamento_tabela_preco_to_string()
    {
        if(!empty($this->orcamento_tabela_preco_to_string))
        {
            return $this->orcamento_tabela_preco_to_string;
        }
    
        $values = Orcamento::where('cliente_contato_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_system_unit_to_string($ordem_servico_system_unit_to_string)
    {
        if(is_array($ordem_servico_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_servico_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_system_unit_to_string = $ordem_servico_system_unit_to_string;
        }

        $this->vdata['ordem_servico_system_unit_to_string'] = $this->ordem_servico_system_unit_to_string;
    }

    public function get_ordem_servico_system_unit_to_string()
    {
        if(!empty($this->ordem_servico_system_unit_to_string))
        {
            return $this->ordem_servico_system_unit_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_to_string($ordem_servico_cliente_to_string)
    {
        if(is_array($ordem_servico_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $ordem_servico_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_to_string = $ordem_servico_cliente_to_string;
        }

        $this->vdata['ordem_servico_cliente_to_string'] = $this->ordem_servico_cliente_to_string;
    }

    public function get_ordem_servico_cliente_to_string()
    {
        if(!empty($this->ordem_servico_cliente_to_string))
        {
            return $this->ordem_servico_cliente_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_contato_to_string($ordem_servico_cliente_contato_to_string)
    {
        if(is_array($ordem_servico_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $ordem_servico_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_contato_to_string = $ordem_servico_cliente_contato_to_string;
        }

        $this->vdata['ordem_servico_cliente_contato_to_string'] = $this->ordem_servico_cliente_contato_to_string;
    }

    public function get_ordem_servico_cliente_contato_to_string()
    {
        if(!empty($this->ordem_servico_cliente_contato_to_string))
        {
            return $this->ordem_servico_cliente_contato_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_vendedor_to_string($ordem_servico_vendedor_to_string)
    {
        if(is_array($ordem_servico_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $ordem_servico_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_vendedor_to_string = $ordem_servico_vendedor_to_string;
        }

        $this->vdata['ordem_servico_vendedor_to_string'] = $this->ordem_servico_vendedor_to_string;
    }

    public function get_ordem_servico_vendedor_to_string()
    {
        if(!empty($this->ordem_servico_vendedor_to_string))
        {
            return $this->ordem_servico_vendedor_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_situacao_to_string($ordem_servico_ordem_servico_situacao_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_situacao_to_string))
        {
            $values = OrdemServicoSituacao::where('id', 'in', $ordem_servico_ordem_servico_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_situacao_to_string = $ordem_servico_ordem_servico_situacao_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_situacao_to_string'] = $this->ordem_servico_ordem_servico_situacao_to_string;
    }

    public function get_ordem_servico_ordem_servico_situacao_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_situacao_to_string))
        {
            return $this->ordem_servico_ordem_servico_situacao_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('ordem_servico_situacao_id','{ordem_servico_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_producao_etapa_to_string($ordem_servico_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = $ordem_servico_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_condicao_pagamento_to_string($ordem_servico_condicao_pagamento_to_string)
    {
        if(is_array($ordem_servico_condicao_pagamento_to_string))
        {
            $values = CondicaoPagamento::where('id', 'in', $ordem_servico_condicao_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_condicao_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_condicao_pagamento_to_string = $ordem_servico_condicao_pagamento_to_string;
        }

        $this->vdata['ordem_servico_condicao_pagamento_to_string'] = $this->ordem_servico_condicao_pagamento_to_string;
    }

    public function get_ordem_servico_condicao_pagamento_to_string()
    {
        if(!empty($this->ordem_servico_condicao_pagamento_to_string))
        {
            return $this->ordem_servico_condicao_pagamento_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('condicao_pagamento_id','{condicao_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_endereco_to_string($ordem_servico_cliente_endereco_to_string)
    {
        if(is_array($ordem_servico_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $ordem_servico_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->ordem_servico_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_endereco_to_string = $ordem_servico_cliente_endereco_to_string;
        }

        $this->vdata['ordem_servico_cliente_endereco_to_string'] = $this->ordem_servico_cliente_endereco_to_string;
    }

    public function get_ordem_servico_cliente_endereco_to_string()
    {
        if(!empty($this->ordem_servico_cliente_endereco_to_string))
        {
            return $this->ordem_servico_cliente_endereco_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_usuario_aprovacao_to_string($ordem_servico_usuario_aprovacao_to_string)
    {
        if(is_array($ordem_servico_usuario_aprovacao_to_string))
        {
            $values = SystemUsers::where('id', 'in', $ordem_servico_usuario_aprovacao_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_usuario_aprovacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_usuario_aprovacao_to_string = $ordem_servico_usuario_aprovacao_to_string;
        }

        $this->vdata['ordem_servico_usuario_aprovacao_to_string'] = $this->ordem_servico_usuario_aprovacao_to_string;
    }

    public function get_ordem_servico_usuario_aprovacao_to_string()
    {
        if(!empty($this->ordem_servico_usuario_aprovacao_to_string))
        {
            return $this->ordem_servico_usuario_aprovacao_to_string;
        }
    
        $values = OrdemServico::where('cliente_contato_id', '=', $this->id)->getIndexedArray('usuario_aprovacao_id','{usuario_aprovacao->name}');
        return implode(', ', $values);
    }

    
}

