<?php

class ClienteEndereco extends TRecord
{
    const TABLENAME  = 'cliente_endereco';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    private $cliente;
    private $fk_principal;
    private $cidade;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('logradouro');
        parent::addAttribute('cliente_id');
        parent::addAttribute('principal');
        parent::addAttribute('cidade_id');
        parent::addAttribute('bairro');
        parent::addAttribute('cep');
        parent::addAttribute('numero');
        parent::addAttribute('complemento');
        parent::addAttribute('ativo_id');
        parent::addAttribute('codigo_ibge');
        parent::addAttribute('ibge_estado');
            
    }

    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_fk_principal(Resposta $object)
    {
        $this->fk_principal = $object;
        $this->principal = $object->id;
    }

    /**
     * Method get_fk_principal
     * Sample of usage: $var->fk_principal->attribute;
     * @returns Resposta instance
     */
    public function get_fk_principal()
    {
    
        // loads the associated object
        if (empty($this->fk_principal))
            $this->fk_principal = new Resposta($this->principal);
    
        // returns the associated object
        return $this->fk_principal;
    }
    /**
     * Method set_cidade
     * Sample of usage: $var->cidade = $object;
     * @param $object Instance of Cidade
     */
    public function set_cidade(Cidade $object)
    {
        $this->cidade = $object;
        $this->cidade_id = $object->id;
    }

    /**
     * Method get_cidade
     * Sample of usage: $var->cidade->attribute;
     * @returns Cidade instance
     */
    public function get_cidade()
    {
    
        // loads the associated object
        if (empty($this->cidade))
            $this->cidade = new Cidade($this->cidade_id);
    
        // returns the associated object
        return $this->cidade;
    }

    /**
     * Method getOrdemServicos
     */
    public function getOrdemServicos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_endereco_id', '=', $this->id));
        return OrdemServico::getObjects( $criteria );
    }
    /**
     * Method getVendas
     */
    public function getVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_endereco_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }

    public function set_ordem_servico_system_unit_to_string($ordem_servico_system_unit_to_string)
    {
        if(is_array($ordem_servico_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_servico_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_system_unit_to_string = $ordem_servico_system_unit_to_string;
        }

        $this->vdata['ordem_servico_system_unit_to_string'] = $this->ordem_servico_system_unit_to_string;
    }

    public function get_ordem_servico_system_unit_to_string()
    {
        if(!empty($this->ordem_servico_system_unit_to_string))
        {
            return $this->ordem_servico_system_unit_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_to_string($ordem_servico_cliente_to_string)
    {
        if(is_array($ordem_servico_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $ordem_servico_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_to_string = $ordem_servico_cliente_to_string;
        }

        $this->vdata['ordem_servico_cliente_to_string'] = $this->ordem_servico_cliente_to_string;
    }

    public function get_ordem_servico_cliente_to_string()
    {
        if(!empty($this->ordem_servico_cliente_to_string))
        {
            return $this->ordem_servico_cliente_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_contato_to_string($ordem_servico_cliente_contato_to_string)
    {
        if(is_array($ordem_servico_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $ordem_servico_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_contato_to_string = $ordem_servico_cliente_contato_to_string;
        }

        $this->vdata['ordem_servico_cliente_contato_to_string'] = $this->ordem_servico_cliente_contato_to_string;
    }

    public function get_ordem_servico_cliente_contato_to_string()
    {
        if(!empty($this->ordem_servico_cliente_contato_to_string))
        {
            return $this->ordem_servico_cliente_contato_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_vendedor_to_string($ordem_servico_vendedor_to_string)
    {
        if(is_array($ordem_servico_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $ordem_servico_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_vendedor_to_string = $ordem_servico_vendedor_to_string;
        }

        $this->vdata['ordem_servico_vendedor_to_string'] = $this->ordem_servico_vendedor_to_string;
    }

    public function get_ordem_servico_vendedor_to_string()
    {
        if(!empty($this->ordem_servico_vendedor_to_string))
        {
            return $this->ordem_servico_vendedor_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_situacao_to_string($ordem_servico_ordem_servico_situacao_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_situacao_to_string))
        {
            $values = OrdemServicoSituacao::where('id', 'in', $ordem_servico_ordem_servico_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_situacao_to_string = $ordem_servico_ordem_servico_situacao_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_situacao_to_string'] = $this->ordem_servico_ordem_servico_situacao_to_string;
    }

    public function get_ordem_servico_ordem_servico_situacao_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_situacao_to_string))
        {
            return $this->ordem_servico_ordem_servico_situacao_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('ordem_servico_situacao_id','{ordem_servico_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_producao_etapa_to_string($ordem_servico_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = $ordem_servico_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_condicao_pagamento_to_string($ordem_servico_condicao_pagamento_to_string)
    {
        if(is_array($ordem_servico_condicao_pagamento_to_string))
        {
            $values = CondicaoPagamento::where('id', 'in', $ordem_servico_condicao_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_condicao_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_condicao_pagamento_to_string = $ordem_servico_condicao_pagamento_to_string;
        }

        $this->vdata['ordem_servico_condicao_pagamento_to_string'] = $this->ordem_servico_condicao_pagamento_to_string;
    }

    public function get_ordem_servico_condicao_pagamento_to_string()
    {
        if(!empty($this->ordem_servico_condicao_pagamento_to_string))
        {
            return $this->ordem_servico_condicao_pagamento_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('condicao_pagamento_id','{condicao_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_endereco_to_string($ordem_servico_cliente_endereco_to_string)
    {
        if(is_array($ordem_servico_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $ordem_servico_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->ordem_servico_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_endereco_to_string = $ordem_servico_cliente_endereco_to_string;
        }

        $this->vdata['ordem_servico_cliente_endereco_to_string'] = $this->ordem_servico_cliente_endereco_to_string;
    }

    public function get_ordem_servico_cliente_endereco_to_string()
    {
        if(!empty($this->ordem_servico_cliente_endereco_to_string))
        {
            return $this->ordem_servico_cliente_endereco_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_usuario_aprovacao_to_string($ordem_servico_usuario_aprovacao_to_string)
    {
        if(is_array($ordem_servico_usuario_aprovacao_to_string))
        {
            $values = SystemUsers::where('id', 'in', $ordem_servico_usuario_aprovacao_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_usuario_aprovacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_usuario_aprovacao_to_string = $ordem_servico_usuario_aprovacao_to_string;
        }

        $this->vdata['ordem_servico_usuario_aprovacao_to_string'] = $this->ordem_servico_usuario_aprovacao_to_string;
    }

    public function get_ordem_servico_usuario_aprovacao_to_string()
    {
        if(!empty($this->ordem_servico_usuario_aprovacao_to_string))
        {
            return $this->ordem_servico_usuario_aprovacao_to_string;
        }
    
        $values = OrdemServico::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('usuario_aprovacao_id','{usuario_aprovacao->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_situacao_to_string($venda_venda_situacao_to_string)
    {
        if(is_array($venda_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_situacao_to_string = $venda_venda_situacao_to_string;
        }

        $this->vdata['venda_venda_situacao_to_string'] = $this->venda_venda_situacao_to_string;
    }

    public function get_venda_venda_situacao_to_string()
    {
        if(!empty($this->venda_venda_situacao_to_string))
        {
            return $this->venda_venda_situacao_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_orcamento_to_string($venda_orcamento_to_string)
    {
        if(is_array($venda_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $venda_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->venda_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_orcamento_to_string = $venda_orcamento_to_string;
        }

        $this->vdata['venda_orcamento_to_string'] = $this->venda_orcamento_to_string;
    }

    public function get_venda_orcamento_to_string()
    {
        if(!empty($this->venda_orcamento_to_string))
        {
            return $this->venda_orcamento_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_vendedor_to_string($venda_vendedor_to_string)
    {
        if(is_array($venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_vendedor_to_string = $venda_vendedor_to_string;
        }

        $this->vdata['venda_vendedor_to_string'] = $this->venda_vendedor_to_string;
    }

    public function get_venda_vendedor_to_string()
    {
        if(!empty($this->venda_vendedor_to_string))
        {
            return $this->venda_vendedor_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_venda_dispositivos_to_string($venda_dispositivos_to_string)
    {
        if(is_array($venda_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $venda_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->venda_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_dispositivos_to_string = $venda_dispositivos_to_string;
        }

        $this->vdata['venda_dispositivos_to_string'] = $this->venda_dispositivos_to_string;
    }

    public function get_venda_dispositivos_to_string()
    {
        if(!empty($this->venda_dispositivos_to_string))
        {
            return $this->venda_dispositivos_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_to_string($venda_cliente_to_string)
    {
        if(is_array($venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_to_string = $venda_cliente_to_string;
        }

        $this->vdata['venda_cliente_to_string'] = $this->venda_cliente_to_string;
    }

    public function get_venda_cliente_to_string()
    {
        if(!empty($this->venda_cliente_to_string))
        {
            return $this->venda_cliente_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_venda_system_unit_to_string($venda_system_unit_to_string)
    {
        if(is_array($venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_system_unit_to_string = $venda_system_unit_to_string;
        }

        $this->vdata['venda_system_unit_to_string'] = $this->venda_system_unit_to_string;
    }

    public function get_venda_system_unit_to_string()
    {
        if(!empty($this->venda_system_unit_to_string))
        {
            return $this->venda_system_unit_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_filial_saida_to_string($venda_filial_saida_to_string)
    {
        if(is_array($venda_filial_saida_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_filial_saida_to_string)->getIndexedArray('name', 'name');
            $this->venda_filial_saida_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_filial_saida_to_string = $venda_filial_saida_to_string;
        }

        $this->vdata['venda_filial_saida_to_string'] = $this->venda_filial_saida_to_string;
    }

    public function get_venda_filial_saida_to_string()
    {
        if(!empty($this->venda_filial_saida_to_string))
        {
            return $this->venda_filial_saida_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('filial_saida_id','{filial_saida->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_modalidade_to_string($venda_venda_modalidade_to_string)
    {
        if(is_array($venda_venda_modalidade_to_string))
        {
            $values = VendaModalidade::where('id', 'in', $venda_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_modalidade_to_string = $venda_venda_modalidade_to_string;
        }

        $this->vdata['venda_venda_modalidade_to_string'] = $this->venda_venda_modalidade_to_string;
    }

    public function get_venda_venda_modalidade_to_string()
    {
        if(!empty($this->venda_venda_modalidade_to_string))
        {
            return $this->venda_venda_modalidade_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('venda_modalidade_id','{venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_tipo_pagamento_to_string($venda_venda_tipo_pagamento_to_string)
    {
        if(is_array($venda_venda_tipo_pagamento_to_string))
        {
            $values = VendaTipoPagamento::where('id', 'in', $venda_venda_tipo_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_tipo_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_tipo_pagamento_to_string = $venda_venda_tipo_pagamento_to_string;
        }

        $this->vdata['venda_venda_tipo_pagamento_to_string'] = $this->venda_venda_tipo_pagamento_to_string;
    }

    public function get_venda_venda_tipo_pagamento_to_string()
    {
        if(!empty($this->venda_venda_tipo_pagamento_to_string))
        {
            return $this->venda_venda_tipo_pagamento_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('venda_tipo_pagamento_id','{venda_tipo_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_endereco_to_string($venda_cliente_endereco_to_string)
    {
        if(is_array($venda_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $venda_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->venda_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_endereco_to_string = $venda_cliente_endereco_to_string;
        }

        $this->vdata['venda_cliente_endereco_to_string'] = $this->venda_cliente_endereco_to_string;
    }

    public function get_venda_cliente_endereco_to_string()
    {
        if(!empty($this->venda_cliente_endereco_to_string))
        {
            return $this->venda_cliente_endereco_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_venda_tabela_preco_to_string($venda_tabela_preco_to_string)
    {
        if(is_array($venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_tabela_preco_to_string = $venda_tabela_preco_to_string;
        }

        $this->vdata['venda_tabela_preco_to_string'] = $this->venda_tabela_preco_to_string;
    }

    public function get_venda_tabela_preco_to_string()
    {
        if(!empty($this->venda_tabela_preco_to_string))
        {
            return $this->venda_tabela_preco_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_movimentacao_origem_to_string($venda_movimentacao_origem_to_string)
    {
        if(is_array($venda_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $venda_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_movimentacao_origem_to_string = $venda_movimentacao_origem_to_string;
        }

        $this->vdata['venda_movimentacao_origem_to_string'] = $this->venda_movimentacao_origem_to_string;
    }

    public function get_venda_movimentacao_origem_to_string()
    {
        if(!empty($this->venda_movimentacao_origem_to_string))
        {
            return $this->venda_movimentacao_origem_to_string;
        }
    
        $values = Venda::where('cliente_endereco_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    
}

