<?php

class ClienteSituacao extends TRecord
{
    const TABLENAME  = 'cliente_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Ativo = '1';
    const Bloqueado = '2';
    const Desativado = '3';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getClientes
     */
    public function getClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cliente_situacao_id', '=', $this->id));
        return Cliente::getObjects( $criteria );
    }

    public function set_cliente_pessoa_tipo_to_string($cliente_pessoa_tipo_to_string)
    {
        if(is_array($cliente_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $cliente_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_pessoa_tipo_to_string = $cliente_pessoa_tipo_to_string;
        }

        $this->vdata['cliente_pessoa_tipo_to_string'] = $this->cliente_pessoa_tipo_to_string;
    }

    public function get_cliente_pessoa_tipo_to_string()
    {
        if(!empty($this->cliente_pessoa_tipo_to_string))
        {
            return $this->cliente_pessoa_tipo_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_to_string($cliente_cliente_classificacao_to_string)
    {
        if(is_array($cliente_cliente_classificacao_to_string))
        {
            $values = ClienteClassificacao::where('id', 'in', $cliente_cliente_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_to_string = $cliente_cliente_classificacao_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_to_string'] = $this->cliente_cliente_classificacao_to_string;
    }

    public function get_cliente_cliente_classificacao_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_to_string))
        {
            return $this->cliente_cliente_classificacao_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('cliente_classificacao_id','{cliente_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_subgrupo_to_string($cliente_cliente_classificacao_subgrupo_to_string)
    {
        if(is_array($cliente_cliente_classificacao_subgrupo_to_string))
        {
            $values = ClienteClassificacaoSubgrupo::where('id', 'in', $cliente_cliente_classificacao_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_subgrupo_to_string = $cliente_cliente_classificacao_subgrupo_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_subgrupo_to_string'] = $this->cliente_cliente_classificacao_subgrupo_to_string;
    }

    public function get_cliente_cliente_classificacao_subgrupo_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_subgrupo_to_string))
        {
            return $this->cliente_cliente_classificacao_subgrupo_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('cliente_classificacao_subgrupo_id','{cliente_classificacao_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_vendedor_to_string($cliente_vendedor_to_string)
    {
        if(is_array($cliente_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $cliente_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_vendedor_to_string = $cliente_vendedor_to_string;
        }

        $this->vdata['cliente_vendedor_to_string'] = $this->cliente_vendedor_to_string;
    }

    public function get_cliente_vendedor_to_string()
    {
        if(!empty($this->cliente_vendedor_to_string))
        {
            return $this->cliente_vendedor_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_indiedest_to_string($cliente_notafiscal_indiedest_to_string)
    {
        if(is_array($cliente_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $cliente_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_indiedest_to_string = $cliente_notafiscal_indiedest_to_string;
        }

        $this->vdata['cliente_notafiscal_indiedest_to_string'] = $this->cliente_notafiscal_indiedest_to_string;
    }

    public function get_cliente_notafiscal_indiedest_to_string()
    {
        if(!empty($this->cliente_notafiscal_indiedest_to_string))
        {
            return $this->cliente_notafiscal_indiedest_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_crt_to_string($cliente_notafiscal_crt_to_string)
    {
        if(is_array($cliente_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $cliente_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_crt_to_string = $cliente_notafiscal_crt_to_string;
        }

        $this->vdata['cliente_notafiscal_crt_to_string'] = $this->cliente_notafiscal_crt_to_string;
    }

    public function get_cliente_notafiscal_crt_to_string()
    {
        if(!empty($this->cliente_notafiscal_crt_to_string))
        {
            return $this->cliente_notafiscal_crt_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_residencia_propria_to_string($cliente_fk_residencia_propria_to_string)
    {
        if(is_array($cliente_fk_residencia_propria_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_residencia_propria_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_residencia_propria_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_residencia_propria_to_string = $cliente_fk_residencia_propria_to_string;
        }

        $this->vdata['cliente_fk_residencia_propria_to_string'] = $this->cliente_fk_residencia_propria_to_string;
    }

    public function get_cliente_fk_residencia_propria_to_string()
    {
        if(!empty($this->cliente_fk_residencia_propria_to_string))
        {
            return $this->cliente_fk_residencia_propria_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('residencia_propria','{fk_residencia_propria->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_utilizar_endereco_cobranca_to_string($cliente_fk_utilizar_endereco_cobranca_to_string)
    {
        if(is_array($cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_utilizar_endereco_cobranca_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = $cliente_fk_utilizar_endereco_cobranca_to_string;
        }

        $this->vdata['cliente_fk_utilizar_endereco_cobranca_to_string'] = $this->cliente_fk_utilizar_endereco_cobranca_to_string;
    }

    public function get_cliente_fk_utilizar_endereco_cobranca_to_string()
    {
        if(!empty($this->cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            return $this->cliente_fk_utilizar_endereco_cobranca_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('utilizar_endereco_cobranca','{fk_utilizar_endereco_cobranca->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_situacao_to_string($cliente_cliente_situacao_to_string)
    {
        if(is_array($cliente_cliente_situacao_to_string))
        {
            $values = ClienteSituacao::where('id', 'in', $cliente_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_situacao_to_string = $cliente_cliente_situacao_to_string;
        }

        $this->vdata['cliente_cliente_situacao_to_string'] = $this->cliente_cliente_situacao_to_string;
    }

    public function get_cliente_cliente_situacao_to_string()
    {
        if(!empty($this->cliente_cliente_situacao_to_string))
        {
            return $this->cliente_cliente_situacao_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('cliente_situacao_id','{cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_system_unit_to_string($cliente_system_unit_to_string)
    {
        if(is_array($cliente_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $cliente_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->cliente_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_system_unit_to_string = $cliente_system_unit_to_string;
        }

        $this->vdata['cliente_system_unit_to_string'] = $this->cliente_system_unit_to_string;
    }

    public function get_cliente_system_unit_to_string()
    {
        if(!empty($this->cliente_system_unit_to_string))
        {
            return $this->cliente_system_unit_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_cliente_tabela_preco_to_string($cliente_tabela_preco_to_string)
    {
        if(is_array($cliente_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $cliente_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_tabela_preco_to_string = $cliente_tabela_preco_to_string;
        }

        $this->vdata['cliente_tabela_preco_to_string'] = $this->cliente_tabela_preco_to_string;
    }

    public function get_cliente_tabela_preco_to_string()
    {
        if(!empty($this->cliente_tabela_preco_to_string))
        {
            return $this->cliente_tabela_preco_to_string;
        }
    
        $values = Cliente::where('cliente_situacao_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    
}

