<?php

class Configuracoes extends TRecord
{
    const TABLENAME  = 'configuracoes';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $forma_pagamento_dinheiro_caixa;
    private $forma_pagamento_titulos_cpag_nf;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('forma_pagamento_id_dinheiro_caixa');
        parent::addAttribute('forma_pagamento_id_titulos_cpag_nf');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento_dinheiro_caixa(FormaPagamento $object)
    {
        $this->forma_pagamento_dinheiro_caixa = $object;
        $this->forma_pagamento_id_dinheiro_caixa = $object->id;
    }

    /**
     * Method get_forma_pagamento_dinheiro_caixa
     * Sample of usage: $var->forma_pagamento_dinheiro_caixa->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento_dinheiro_caixa()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento_dinheiro_caixa))
            $this->forma_pagamento_dinheiro_caixa = new FormaPagamento($this->forma_pagamento_id_dinheiro_caixa);
    
        // returns the associated object
        return $this->forma_pagamento_dinheiro_caixa;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento_titulos_cpag_nf(FormaPagamento $object)
    {
        $this->forma_pagamento_titulos_cpag_nf = $object;
        $this->forma_pagamento_id_titulos_cpag_nf = $object->id;
    }

    /**
     * Method get_forma_pagamento_titulos_cpag_nf
     * Sample of usage: $var->forma_pagamento_titulos_cpag_nf->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento_titulos_cpag_nf()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento_titulos_cpag_nf))
            $this->forma_pagamento_titulos_cpag_nf = new FormaPagamento($this->forma_pagamento_id_titulos_cpag_nf);
    
        // returns the associated object
        return $this->forma_pagamento_titulos_cpag_nf;
    }

    /**
     * Method getConfiguracoesFilials
     */
    public function getConfiguracoesFilials()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('configuracoes_id', '=', $this->id));
        return ConfiguracoesFilial::getObjects( $criteria );
    }

    public function set_configuracoes_filial_configuracoes_to_string($configuracoes_filial_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_configuracoes_to_string))
        {
            $values = Configuracoes::where('id', 'in', $configuracoes_filial_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_configuracoes_to_string = $configuracoes_filial_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_configuracoes_to_string'] = $this->configuracoes_filial_configuracoes_to_string;
    }

    public function get_configuracoes_filial_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_configuracoes_to_string))
        {
            return $this->configuracoes_filial_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('configuracoes_id','{configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_system_unit_to_string($configuracoes_filial_system_unit_to_string)
    {
        if(is_array($configuracoes_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $configuracoes_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->configuracoes_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_system_unit_to_string = $configuracoes_filial_system_unit_to_string;
        }

        $this->vdata['configuracoes_filial_system_unit_to_string'] = $this->configuracoes_filial_system_unit_to_string;
    }

    public function get_configuracoes_filial_system_unit_to_string()
    {
        if(!empty($this->configuracoes_filial_system_unit_to_string))
        {
            return $this->configuracoes_filial_system_unit_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_produto_etiqueta_configuracoes_to_string($configuracoes_filial_produto_etiqueta_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            $values = ProdutoEtiquetaConfiguracoes::where('id', 'in', $configuracoes_filial_produto_etiqueta_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = $configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_produto_etiqueta_configuracoes_to_string'] = $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
    }

    public function get_configuracoes_filial_produto_etiqueta_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            return $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('produto_etiqueta_configuracoes_id','{produto_etiqueta_configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_plano_conta_crec_to_string($configuracoes_filial_plano_conta_crec_to_string)
    {
        if(is_array($configuracoes_filial_plano_conta_crec_to_string))
        {
            $values = PlanoConta::where('id', 'in', $configuracoes_filial_plano_conta_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_plano_conta_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_plano_conta_crec_to_string = $configuracoes_filial_plano_conta_crec_to_string;
        }

        $this->vdata['configuracoes_filial_plano_conta_crec_to_string'] = $this->configuracoes_filial_plano_conta_crec_to_string;
    }

    public function get_configuracoes_filial_plano_conta_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_plano_conta_crec_to_string))
        {
            return $this->configuracoes_filial_plano_conta_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('plano_conta_crec_id','{plano_conta_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_centro_custo_crec_to_string($configuracoes_filial_centro_custo_crec_to_string)
    {
        if(is_array($configuracoes_filial_centro_custo_crec_to_string))
        {
            $values = CentroCusto::where('id', 'in', $configuracoes_filial_centro_custo_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_centro_custo_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_centro_custo_crec_to_string = $configuracoes_filial_centro_custo_crec_to_string;
        }

        $this->vdata['configuracoes_filial_centro_custo_crec_to_string'] = $this->configuracoes_filial_centro_custo_crec_to_string;
    }

    public function get_configuracoes_filial_centro_custo_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_centro_custo_crec_to_string))
        {
            return $this->configuracoes_filial_centro_custo_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('centro_custo_crec_id','{centro_custo_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_cpag_usa_plano_contas_to_string($configuracoes_filial_cpag_usa_plano_contas_to_string)
    {
        if(is_array($configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_cpag_usa_plano_contas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = $configuracoes_filial_cpag_usa_plano_contas_to_string;
        }

        $this->vdata['configuracoes_filial_cpag_usa_plano_contas_to_string'] = $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
    }

    public function get_configuracoes_filial_cpag_usa_plano_contas_to_string()
    {
        if(!empty($this->configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            return $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('cpag_usa_plano_contas_id','{cpag_usa_plano_contas->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_informar_duplicidade_de_item_venda_to_string($configuracoes_filial_informar_duplicidade_de_item_venda_to_string)
    {
        if(is_array($configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_informar_duplicidade_de_item_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = $configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }

        $this->vdata['configuracoes_filial_informar_duplicidade_de_item_venda_to_string'] = $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
    }

    public function get_configuracoes_filial_informar_duplicidade_de_item_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            return $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('informar_duplicidade_de_item_venda_id','{informar_duplicidade_de_item_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_venda_apenas_com_estoque_to_string($configuracoes_filial_venda_apenas_com_estoque_to_string)
    {
        if(is_array($configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_venda_apenas_com_estoque_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = $configuracoes_filial_venda_apenas_com_estoque_to_string;
        }

        $this->vdata['configuracoes_filial_venda_apenas_com_estoque_to_string'] = $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
    }

    public function get_configuracoes_filial_venda_apenas_com_estoque_to_string()
    {
        if(!empty($this->configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            return $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('venda_apenas_com_estoque_id','{venda_apenas_com_estoque->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_orcamento_id','{notafiscal_cprod_padrao_orcamento->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_venda_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('configuracoes_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_venda_id','{notafiscal_cprod_padrao_venda->descricao}');
        return implode(', ', $values);
    }

    
}

