<?php

class ConfiguracoesFilial extends TRecord
{
    const TABLENAME  = 'configuracoes_filial';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $configuracoes;
    private $produto_etiqueta_configuracoes;
    private $system_unit;
    private $plano_conta_crec;
    private $centro_custo_crec;
    private $cpag_usa_plano_contas;
    private $notafiscal_cprod_padrao_orcamento;
    private $informar_duplicidade_de_item_venda;
    private $venda_apenas_com_estoque;
    private $notafiscal_cprod_padrao_venda;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('configuracoes_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('produto_etiqueta_configuracoes_id');
        parent::addAttribute('plano_conta_mascara');
        parent::addAttribute('centro_custo_mascara');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('plano_conta_crec_id');
        parent::addAttribute('centro_custo_crec_id');
        parent::addAttribute('cpag_usa_plano_contas_id');
        parent::addAttribute('info_complementar_orcamento');
        parent::addAttribute('informar_duplicidade_de_item_venda_id');
        parent::addAttribute('venda_apenas_com_estoque_id');
        parent::addAttribute('notafiscal_cprod_padrao_orcamento_id');
        parent::addAttribute('notafiscal_cprod_padrao_venda_id');
        parent::addAttribute('produto_margem_padrao');
            
    }

    /**
     * Method set_configuracoes
     * Sample of usage: $var->configuracoes = $object;
     * @param $object Instance of Configuracoes
     */
    public function set_configuracoes(Configuracoes $object)
    {
        $this->configuracoes = $object;
        $this->configuracoes_id = $object->id;
    }

    /**
     * Method get_configuracoes
     * Sample of usage: $var->configuracoes->attribute;
     * @returns Configuracoes instance
     */
    public function get_configuracoes()
    {
    
        // loads the associated object
        if (empty($this->configuracoes))
            $this->configuracoes = new Configuracoes($this->configuracoes_id);
    
        // returns the associated object
        return $this->configuracoes;
    }
    /**
     * Method set_produto_etiqueta_configuracoes
     * Sample of usage: $var->produto_etiqueta_configuracoes = $object;
     * @param $object Instance of ProdutoEtiquetaConfiguracoes
     */
    public function set_produto_etiqueta_configuracoes(ProdutoEtiquetaConfiguracoes $object)
    {
        $this->produto_etiqueta_configuracoes = $object;
        $this->produto_etiqueta_configuracoes_id = $object->id;
    }

    /**
     * Method get_produto_etiqueta_configuracoes
     * Sample of usage: $var->produto_etiqueta_configuracoes->attribute;
     * @returns ProdutoEtiquetaConfiguracoes instance
     */
    public function get_produto_etiqueta_configuracoes()
    {
    
        // loads the associated object
        if (empty($this->produto_etiqueta_configuracoes))
            $this->produto_etiqueta_configuracoes = new ProdutoEtiquetaConfiguracoes($this->produto_etiqueta_configuracoes_id);
    
        // returns the associated object
        return $this->produto_etiqueta_configuracoes;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta_crec(PlanoConta $object)
    {
        $this->plano_conta_crec = $object;
        $this->plano_conta_crec_id = $object->id;
    }

    /**
     * Method get_plano_conta_crec
     * Sample of usage: $var->plano_conta_crec->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta_crec()
    {
    
        // loads the associated object
        if (empty($this->plano_conta_crec))
            $this->plano_conta_crec = new PlanoConta($this->plano_conta_crec_id);
    
        // returns the associated object
        return $this->plano_conta_crec;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo_crec(CentroCusto $object)
    {
        $this->centro_custo_crec = $object;
        $this->centro_custo_crec_id = $object->id;
    }

    /**
     * Method get_centro_custo_crec
     * Sample of usage: $var->centro_custo_crec->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo_crec()
    {
    
        // loads the associated object
        if (empty($this->centro_custo_crec))
            $this->centro_custo_crec = new CentroCusto($this->centro_custo_crec_id);
    
        // returns the associated object
        return $this->centro_custo_crec;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_cpag_usa_plano_contas(Resposta $object)
    {
        $this->cpag_usa_plano_contas = $object;
        $this->cpag_usa_plano_contas_id = $object->id;
    }

    /**
     * Method get_cpag_usa_plano_contas
     * Sample of usage: $var->cpag_usa_plano_contas->attribute;
     * @returns Resposta instance
     */
    public function get_cpag_usa_plano_contas()
    {
    
        // loads the associated object
        if (empty($this->cpag_usa_plano_contas))
            $this->cpag_usa_plano_contas = new Resposta($this->cpag_usa_plano_contas_id);
    
        // returns the associated object
        return $this->cpag_usa_plano_contas;
    }
    /**
     * Method set_notafiscal_cprod_padrao
     * Sample of usage: $var->notafiscal_cprod_padrao = $object;
     * @param $object Instance of NotafiscalCprodPadrao
     */
    public function set_notafiscal_cprod_padrao_orcamento(NotafiscalCprodPadrao $object)
    {
        $this->notafiscal_cprod_padrao_orcamento = $object;
        $this->notafiscal_cprod_padrao_orcamento_id = $object->id;
    }

    /**
     * Method get_notafiscal_cprod_padrao_orcamento
     * Sample of usage: $var->notafiscal_cprod_padrao_orcamento->attribute;
     * @returns NotafiscalCprodPadrao instance
     */
    public function get_notafiscal_cprod_padrao_orcamento()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_cprod_padrao_orcamento))
            $this->notafiscal_cprod_padrao_orcamento = new NotafiscalCprodPadrao($this->notafiscal_cprod_padrao_orcamento_id);
    
        // returns the associated object
        return $this->notafiscal_cprod_padrao_orcamento;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_informar_duplicidade_de_item_venda(Resposta $object)
    {
        $this->informar_duplicidade_de_item_venda = $object;
        $this->informar_duplicidade_de_item_venda_id = $object->id;
    }

    /**
     * Method get_informar_duplicidade_de_item_venda
     * Sample of usage: $var->informar_duplicidade_de_item_venda->attribute;
     * @returns Resposta instance
     */
    public function get_informar_duplicidade_de_item_venda()
    {
    
        // loads the associated object
        if (empty($this->informar_duplicidade_de_item_venda))
            $this->informar_duplicidade_de_item_venda = new Resposta($this->informar_duplicidade_de_item_venda_id);
    
        // returns the associated object
        return $this->informar_duplicidade_de_item_venda;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_venda_apenas_com_estoque(Resposta $object)
    {
        $this->venda_apenas_com_estoque = $object;
        $this->venda_apenas_com_estoque_id = $object->id;
    }

    /**
     * Method get_venda_apenas_com_estoque
     * Sample of usage: $var->venda_apenas_com_estoque->attribute;
     * @returns Resposta instance
     */
    public function get_venda_apenas_com_estoque()
    {
    
        // loads the associated object
        if (empty($this->venda_apenas_com_estoque))
            $this->venda_apenas_com_estoque = new Resposta($this->venda_apenas_com_estoque_id);
    
        // returns the associated object
        return $this->venda_apenas_com_estoque;
    }
    /**
     * Method set_notafiscal_cprod_padrao
     * Sample of usage: $var->notafiscal_cprod_padrao = $object;
     * @param $object Instance of NotafiscalCprodPadrao
     */
    public function set_notafiscal_cprod_padrao_venda(NotafiscalCprodPadrao $object)
    {
        $this->notafiscal_cprod_padrao_venda = $object;
        $this->notafiscal_cprod_padrao_venda_id = $object->id;
    }

    /**
     * Method get_notafiscal_cprod_padrao_venda
     * Sample of usage: $var->notafiscal_cprod_padrao_venda->attribute;
     * @returns NotafiscalCprodPadrao instance
     */
    public function get_notafiscal_cprod_padrao_venda()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_cprod_padrao_venda))
            $this->notafiscal_cprod_padrao_venda = new NotafiscalCprodPadrao($this->notafiscal_cprod_padrao_venda_id);
    
        // returns the associated object
        return $this->notafiscal_cprod_padrao_venda;
    }

    
}

