<?php

class ContaCorrente extends TRecord
{
    const TABLENAME  = 'conta_corrente';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $banco;
    private $system_unit;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('banco_id');
        parent::addAttribute('nome');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('agencia');
        parent::addAttribute('conta');
        parent::addAttribute('agencia_digito');
        parent::addAttribute('conta_digito');
        parent::addAttribute('end_logradouro');
        parent::addAttribute('end_bairro');
        parent::addAttribute('end_cidade');
        parent::addAttribute('end_estado');
        parent::addAttribute('end_cep');
        parent::addAttribute('end_numero');
        parent::addAttribute('boleto_convenio');
        parent::addAttribute('boleto_carteira');
        parent::addAttribute('boleto_gerar');
        parent::addAttribute('boleto_codigo_cedente');
        parent::addAttribute('boleto_digito_cod_cedente');
        parent::addAttribute('boleto_instrucoes');
        parent::addAttribute('boleto_multa');
        parent::addAttribute('boleto_juros_dia');
        parent::addAttribute('boleto_digitos_nosso_numero');
        parent::addAttribute('boleto_local_pagamento');
        parent::addAttribute('boleto_codigo_transmissao');
            
    }

    /**
     * Method set_banco
     * Sample of usage: $var->banco = $object;
     * @param $object Instance of Banco
     */
    public function set_banco(Banco $object)
    {
        $this->banco = $object;
        $this->banco_id = $object->id;
    }

    /**
     * Method get_banco
     * Sample of usage: $var->banco->attribute;
     * @returns Banco instance
     */
    public function get_banco()
    {
    
        // loads the associated object
        if (empty($this->banco))
            $this->banco = new Banco($this->banco_id);
    
        // returns the associated object
        return $this->banco;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getContaCorrenteLancamentoss
     */
    public function getContaCorrenteLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('conta_corrente_id', '=', $this->id));
        return ContaCorrenteLancamentos::getObjects( $criteria );
    }
    /**
     * Method getContaspagBaixass
     */
    public function getContaspagBaixass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('conta_corrente_id', '=', $this->id));
        return ContaspagBaixas::getObjects( $criteria );
    }
    /**
     * Method getContasrecs
     */
    public function getContasrecs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('conta_corrente_boleto_id', '=', $this->id));
        return Contasrec::getObjects( $criteria );
    }
    /**
     * Method getContasrecBaixass
     */
    public function getContasrecBaixass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('conta_corrente_id', '=', $this->id));
        return ContasrecBaixas::getObjects( $criteria );
    }

    public function set_conta_corrente_lancamentos_conta_corrente_to_string($conta_corrente_lancamentos_conta_corrente_to_string)
    {
        if(is_array($conta_corrente_lancamentos_conta_corrente_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $conta_corrente_lancamentos_conta_corrente_to_string)->getIndexedArray('nome', 'nome');
            $this->conta_corrente_lancamentos_conta_corrente_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_conta_corrente_to_string = $conta_corrente_lancamentos_conta_corrente_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_conta_corrente_to_string'] = $this->conta_corrente_lancamentos_conta_corrente_to_string;
    }

    public function get_conta_corrente_lancamentos_conta_corrente_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_conta_corrente_to_string))
        {
            return $this->conta_corrente_lancamentos_conta_corrente_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $this->id)->getIndexedArray('conta_corrente_id','{conta_corrente->nome}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string($conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string)
    {
        if(is_array($conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string))
        {
            $values = ContaCorrenteLancTipo::where('id', 'in', $conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string = $conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string'] = $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string;
    }

    public function get_conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string))
        {
            return $this->conta_corrente_lancamentos_conta_corrente_lanc_tipo_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $this->id)->getIndexedArray('conta_corrente_lanc_tipo_id','{conta_corrente_lanc_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string($conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string)
    {
        if(is_array($conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string))
        {
            $values = ContaCorrenteLancOrigem::where('id', 'in', $conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string = $conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string'] = $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string;
    }

    public function get_conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string))
        {
            return $this->conta_corrente_lancamentos_conta_corrente_lanc_origem_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $this->id)->getIndexedArray('conta_corrente_lanc_origem_id','{conta_corrente_lanc_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_contaspag_baixas_to_string($conta_corrente_lancamentos_contaspag_baixas_to_string)
    {
        if(is_array($conta_corrente_lancamentos_contaspag_baixas_to_string))
        {
            $values = ContaspagBaixas::where('id', 'in', $conta_corrente_lancamentos_contaspag_baixas_to_string)->getIndexedArray('id', 'id');
            $this->conta_corrente_lancamentos_contaspag_baixas_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_contaspag_baixas_to_string = $conta_corrente_lancamentos_contaspag_baixas_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_contaspag_baixas_to_string'] = $this->conta_corrente_lancamentos_contaspag_baixas_to_string;
    }

    public function get_conta_corrente_lancamentos_contaspag_baixas_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_contaspag_baixas_to_string))
        {
            return $this->conta_corrente_lancamentos_contaspag_baixas_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $this->id)->getIndexedArray('contaspag_baixas_id','{contaspag_baixas->id}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_contasrec_baixas_to_string($conta_corrente_lancamentos_contasrec_baixas_to_string)
    {
        if(is_array($conta_corrente_lancamentos_contasrec_baixas_to_string))
        {
            $values = ContasrecBaixas::where('id', 'in', $conta_corrente_lancamentos_contasrec_baixas_to_string)->getIndexedArray('id', 'id');
            $this->conta_corrente_lancamentos_contasrec_baixas_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_contasrec_baixas_to_string = $conta_corrente_lancamentos_contasrec_baixas_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_contasrec_baixas_to_string'] = $this->conta_corrente_lancamentos_contasrec_baixas_to_string;
    }

    public function get_conta_corrente_lancamentos_contasrec_baixas_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_contasrec_baixas_to_string))
        {
            return $this->conta_corrente_lancamentos_contasrec_baixas_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $this->id)->getIndexedArray('contasrec_baixas_id','{contasrec_baixas->id}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_plano_conta_to_string($conta_corrente_lancamentos_plano_conta_to_string)
    {
        if(is_array($conta_corrente_lancamentos_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $conta_corrente_lancamentos_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_plano_conta_to_string = $conta_corrente_lancamentos_plano_conta_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_plano_conta_to_string'] = $this->conta_corrente_lancamentos_plano_conta_to_string;
    }

    public function get_conta_corrente_lancamentos_plano_conta_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_plano_conta_to_string))
        {
            return $this->conta_corrente_lancamentos_plano_conta_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_lancamentos_centro_custo_to_string($conta_corrente_lancamentos_centro_custo_to_string)
    {
        if(is_array($conta_corrente_lancamentos_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $conta_corrente_lancamentos_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->conta_corrente_lancamentos_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_lancamentos_centro_custo_to_string = $conta_corrente_lancamentos_centro_custo_to_string;
        }

        $this->vdata['conta_corrente_lancamentos_centro_custo_to_string'] = $this->conta_corrente_lancamentos_centro_custo_to_string;
    }

    public function get_conta_corrente_lancamentos_centro_custo_to_string()
    {
        if(!empty($this->conta_corrente_lancamentos_centro_custo_to_string))
        {
            return $this->conta_corrente_lancamentos_centro_custo_to_string;
        }
    
        $values = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_baixas_contaspag_to_string($contaspag_baixas_contaspag_to_string)
    {
        if(is_array($contaspag_baixas_contaspag_to_string))
        {
            $values = Contaspag::where('id', 'in', $contaspag_baixas_contaspag_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_baixas_contaspag_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_baixas_contaspag_to_string = $contaspag_baixas_contaspag_to_string;
        }

        $this->vdata['contaspag_baixas_contaspag_to_string'] = $this->contaspag_baixas_contaspag_to_string;
    }

    public function get_contaspag_baixas_contaspag_to_string()
    {
        if(!empty($this->contaspag_baixas_contaspag_to_string))
        {
            return $this->contaspag_baixas_contaspag_to_string;
        }
    
        $values = ContaspagBaixas::where('conta_corrente_id', '=', $this->id)->getIndexedArray('contaspag_id','{contaspag->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_baixas_conta_corrente_to_string($contaspag_baixas_conta_corrente_to_string)
    {
        if(is_array($contaspag_baixas_conta_corrente_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contaspag_baixas_conta_corrente_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_baixas_conta_corrente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_baixas_conta_corrente_to_string = $contaspag_baixas_conta_corrente_to_string;
        }

        $this->vdata['contaspag_baixas_conta_corrente_to_string'] = $this->contaspag_baixas_conta_corrente_to_string;
    }

    public function get_contaspag_baixas_conta_corrente_to_string()
    {
        if(!empty($this->contaspag_baixas_conta_corrente_to_string))
        {
            return $this->contaspag_baixas_conta_corrente_to_string;
        }
    
        $values = ContaspagBaixas::where('conta_corrente_id', '=', $this->id)->getIndexedArray('conta_corrente_id','{conta_corrente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_system_unit_to_string($contasrec_system_unit_to_string)
    {
        if(is_array($contasrec_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_system_unit_to_string = $contasrec_system_unit_to_string;
        }

        $this->vdata['contasrec_system_unit_to_string'] = $this->contasrec_system_unit_to_string;
    }

    public function get_contasrec_system_unit_to_string()
    {
        if(!empty($this->contasrec_system_unit_to_string))
        {
            return $this->contasrec_system_unit_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_cliente_to_string($contasrec_cliente_to_string)
    {
        if(is_array($contasrec_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cliente_to_string = $contasrec_cliente_to_string;
        }

        $this->vdata['contasrec_cliente_to_string'] = $this->contasrec_cliente_to_string;
    }

    public function get_contasrec_cliente_to_string()
    {
        if(!empty($this->contasrec_cliente_to_string))
        {
            return $this->contasrec_cliente_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_forma_pagamento_to_string($contasrec_forma_pagamento_to_string)
    {
        if(is_array($contasrec_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_forma_pagamento_to_string = $contasrec_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_forma_pagamento_to_string'] = $this->contasrec_forma_pagamento_to_string;
    }

    public function get_contasrec_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_forma_pagamento_to_string))
        {
            return $this->contasrec_forma_pagamento_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_situacao_to_string($contasrec_contasrec_situacao_to_string)
    {
        if(is_array($contasrec_contasrec_situacao_to_string))
        {
            $values = ContasrecSituacao::where('id', 'in', $contasrec_contasrec_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_situacao_to_string = $contasrec_contasrec_situacao_to_string;
        }

        $this->vdata['contasrec_contasrec_situacao_to_string'] = $this->contasrec_contasrec_situacao_to_string;
    }

    public function get_contasrec_contasrec_situacao_to_string()
    {
        if(!empty($this->contasrec_contasrec_situacao_to_string))
        {
            return $this->contasrec_contasrec_situacao_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('contasrec_situacao_id','{contasrec_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_plano_conta_to_string($contasrec_plano_conta_to_string)
    {
        if(is_array($contasrec_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_plano_conta_to_string = $contasrec_plano_conta_to_string;
        }

        $this->vdata['contasrec_plano_conta_to_string'] = $this->contasrec_plano_conta_to_string;
    }

    public function get_contasrec_plano_conta_to_string()
    {
        if(!empty($this->contasrec_plano_conta_to_string))
        {
            return $this->contasrec_plano_conta_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_centro_custo_to_string($contasrec_centro_custo_to_string)
    {
        if(is_array($contasrec_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_centro_custo_to_string = $contasrec_centro_custo_to_string;
        }

        $this->vdata['contasrec_centro_custo_to_string'] = $this->contasrec_centro_custo_to_string;
    }

    public function get_contasrec_centro_custo_to_string()
    {
        if(!empty($this->contasrec_centro_custo_to_string))
        {
            return $this->contasrec_centro_custo_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_origem_to_string($contasrec_contasrec_origem_to_string)
    {
        if(is_array($contasrec_contasrec_origem_to_string))
        {
            $values = ContasrecOrigem::where('id', 'in', $contasrec_contasrec_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_origem_to_string = $contasrec_contasrec_origem_to_string;
        }

        $this->vdata['contasrec_contasrec_origem_to_string'] = $this->contasrec_contasrec_origem_to_string;
    }

    public function get_contasrec_contasrec_origem_to_string()
    {
        if(!empty($this->contasrec_contasrec_origem_to_string))
        {
            return $this->contasrec_contasrec_origem_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('contasrec_origem_id','{contasrec_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_cheque_banco_to_string($contasrec_cheque_banco_to_string)
    {
        if(is_array($contasrec_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contasrec_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cheque_banco_to_string = $contasrec_cheque_banco_to_string;
        }

        $this->vdata['contasrec_cheque_banco_to_string'] = $this->contasrec_cheque_banco_to_string;
    }

    public function get_contasrec_cheque_banco_to_string()
    {
        if(!empty($this->contasrec_cheque_banco_to_string))
        {
            return $this->contasrec_cheque_banco_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_conta_corrente_boleto_to_string($contasrec_conta_corrente_boleto_to_string)
    {
        if(is_array($contasrec_conta_corrente_boleto_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_conta_corrente_boleto_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_conta_corrente_boleto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_conta_corrente_boleto_to_string = $contasrec_conta_corrente_boleto_to_string;
        }

        $this->vdata['contasrec_conta_corrente_boleto_to_string'] = $this->contasrec_conta_corrente_boleto_to_string;
    }

    public function get_contasrec_conta_corrente_boleto_to_string()
    {
        if(!empty($this->contasrec_conta_corrente_boleto_to_string))
        {
            return $this->contasrec_conta_corrente_boleto_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('conta_corrente_boleto_id','{conta_corrente_boleto->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_boleto_situacao_to_string($contasrec_boleto_situacao_to_string)
    {
        if(is_array($contasrec_boleto_situacao_to_string))
        {
            $values = BoletoSituacao::where('id', 'in', $contasrec_boleto_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_boleto_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_boleto_situacao_to_string = $contasrec_boleto_situacao_to_string;
        }

        $this->vdata['contasrec_boleto_situacao_to_string'] = $this->contasrec_boleto_situacao_to_string;
    }

    public function get_contasrec_boleto_situacao_to_string()
    {
        if(!empty($this->contasrec_boleto_situacao_to_string))
        {
            return $this->contasrec_boleto_situacao_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('boleto_situacao_id','{boleto_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_vendedor_to_string($contasrec_vendedor_to_string)
    {
        if(is_array($contasrec_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $contasrec_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_vendedor_to_string = $contasrec_vendedor_to_string;
        }

        $this->vdata['contasrec_vendedor_to_string'] = $this->contasrec_vendedor_to_string;
    }

    public function get_contasrec_vendedor_to_string()
    {
        if(!empty($this->contasrec_vendedor_to_string))
        {
            return $this->contasrec_vendedor_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_bloco_to_string($contasrec_contasrec_bloco_to_string)
    {
        if(is_array($contasrec_contasrec_bloco_to_string))
        {
            $values = ContasrecBloco::where('id', 'in', $contasrec_contasrec_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_contasrec_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_bloco_to_string = $contasrec_contasrec_bloco_to_string;
        }

        $this->vdata['contasrec_contasrec_bloco_to_string'] = $this->contasrec_contasrec_bloco_to_string;
    }

    public function get_contasrec_contasrec_bloco_to_string()
    {
        if(!empty($this->contasrec_contasrec_bloco_to_string))
        {
            return $this->contasrec_contasrec_bloco_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('contasrec_bloco_id','{contasrec_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_venda_formapgto_to_string($contasrec_venda_formapgto_to_string)
    {
        if(is_array($contasrec_venda_formapgto_to_string))
        {
            $values = VendaFormapgto::where('id', 'in', $contasrec_venda_formapgto_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_venda_formapgto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_venda_formapgto_to_string = $contasrec_venda_formapgto_to_string;
        }

        $this->vdata['contasrec_venda_formapgto_to_string'] = $this->contasrec_venda_formapgto_to_string;
    }

    public function get_contasrec_venda_formapgto_to_string()
    {
        if(!empty($this->contasrec_venda_formapgto_to_string))
        {
            return $this->contasrec_venda_formapgto_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('venda_formapgto_id','{venda_formapgto->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_ativo_to_string($contasrec_ativo_to_string)
    {
        if(is_array($contasrec_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $contasrec_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_ativo_to_string = $contasrec_ativo_to_string;
        }

        $this->vdata['contasrec_ativo_to_string'] = $this->contasrec_ativo_to_string;
    }

    public function get_contasrec_ativo_to_string()
    {
        if(!empty($this->contasrec_ativo_to_string))
        {
            return $this->contasrec_ativo_to_string;
        }
    
        $values = Contasrec::where('conta_corrente_boleto_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_baixas_contasrec_to_string($contasrec_baixas_contasrec_to_string)
    {
        if(is_array($contasrec_baixas_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contasrec_baixas_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_baixas_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_baixas_contasrec_to_string = $contasrec_baixas_contasrec_to_string;
        }

        $this->vdata['contasrec_baixas_contasrec_to_string'] = $this->contasrec_baixas_contasrec_to_string;
    }

    public function get_contasrec_baixas_contasrec_to_string()
    {
        if(!empty($this->contasrec_baixas_contasrec_to_string))
        {
            return $this->contasrec_baixas_contasrec_to_string;
        }
    
        $values = ContasrecBaixas::where('conta_corrente_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_baixas_conta_corrente_to_string($contasrec_baixas_conta_corrente_to_string)
    {
        if(is_array($contasrec_baixas_conta_corrente_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_baixas_conta_corrente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_baixas_conta_corrente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_baixas_conta_corrente_to_string = $contasrec_baixas_conta_corrente_to_string;
        }

        $this->vdata['contasrec_baixas_conta_corrente_to_string'] = $this->contasrec_baixas_conta_corrente_to_string;
    }

    public function get_contasrec_baixas_conta_corrente_to_string()
    {
        if(!empty($this->contasrec_baixas_conta_corrente_to_string))
        {
            return $this->contasrec_baixas_conta_corrente_to_string;
        }
    
        $values = ContasrecBaixas::where('conta_corrente_id', '=', $this->id)->getIndexedArray('conta_corrente_id','{conta_corrente->nome}');
        return implode(', ', $values);
    }

    
}

