<?php

class ContaCorrenteLancamentos extends TRecord
{
    const TABLENAME  = 'conta_corrente_lancamentos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $conta_corrente;
    private $conta_corrente_lanc_tipo;
    private $plano_conta;
    private $centro_custo;
    private $contaspag_baixas;
    private $contasrec_baixas;
    private $conta_corrente_lanc_origem;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('conta_corrente_id');
        parent::addAttribute('conta_corrente_lanc_tipo_id');
        parent::addAttribute('conta_corrente_lanc_origem_id');
        parent::addAttribute('contaspag_baixas_id');
        parent::addAttribute('contasrec_baixas_id');
        parent::addAttribute('data_lancamento');
        parent::addAttribute('valor');
        parent::addAttribute('documento');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('historico');
        parent::addAttribute('plano_conta_id');
        parent::addAttribute('centro_custo_id');
    
    }

    /**
     * Method set_conta_corrente
     * Sample of usage: $var->conta_corrente = $object;
     * @param $object Instance of ContaCorrente
     */
    public function set_conta_corrente(ContaCorrente $object)
    {
        $this->conta_corrente = $object;
        $this->conta_corrente_id = $object->id;
    }

    /**
     * Method get_conta_corrente
     * Sample of usage: $var->conta_corrente->attribute;
     * @returns ContaCorrente instance
     */
    public function get_conta_corrente()
    {
    
        // loads the associated object
        if (empty($this->conta_corrente))
            $this->conta_corrente = new ContaCorrente($this->conta_corrente_id);
    
        // returns the associated object
        return $this->conta_corrente;
    }
    /**
     * Method set_conta_corrente_lanc_tipo
     * Sample of usage: $var->conta_corrente_lanc_tipo = $object;
     * @param $object Instance of ContaCorrenteLancTipo
     */
    public function set_conta_corrente_lanc_tipo(ContaCorrenteLancTipo $object)
    {
        $this->conta_corrente_lanc_tipo = $object;
        $this->conta_corrente_lanc_tipo_id = $object->id;
    }

    /**
     * Method get_conta_corrente_lanc_tipo
     * Sample of usage: $var->conta_corrente_lanc_tipo->attribute;
     * @returns ContaCorrenteLancTipo instance
     */
    public function get_conta_corrente_lanc_tipo()
    {
    
        // loads the associated object
        if (empty($this->conta_corrente_lanc_tipo))
            $this->conta_corrente_lanc_tipo = new ContaCorrenteLancTipo($this->conta_corrente_lanc_tipo_id);
    
        // returns the associated object
        return $this->conta_corrente_lanc_tipo;
    }
    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta(PlanoConta $object)
    {
        $this->plano_conta = $object;
        $this->plano_conta_id = $object->id;
    }

    /**
     * Method get_plano_conta
     * Sample of usage: $var->plano_conta->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta()
    {
    
        // loads the associated object
        if (empty($this->plano_conta))
            $this->plano_conta = new PlanoConta($this->plano_conta_id);
    
        // returns the associated object
        return $this->plano_conta;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo(CentroCusto $object)
    {
        $this->centro_custo = $object;
        $this->centro_custo_id = $object->id;
    }

    /**
     * Method get_centro_custo
     * Sample of usage: $var->centro_custo->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo))
            $this->centro_custo = new CentroCusto($this->centro_custo_id);
    
        // returns the associated object
        return $this->centro_custo;
    }
    /**
     * Method set_contaspag_baixas
     * Sample of usage: $var->contaspag_baixas = $object;
     * @param $object Instance of ContaspagBaixas
     */
    public function set_contaspag_baixas(ContaspagBaixas $object)
    {
        $this->contaspag_baixas = $object;
        $this->contaspag_baixas_id = $object->id;
    }

    /**
     * Method get_contaspag_baixas
     * Sample of usage: $var->contaspag_baixas->attribute;
     * @returns ContaspagBaixas instance
     */
    public function get_contaspag_baixas()
    {
    
        // loads the associated object
        if (empty($this->contaspag_baixas))
            $this->contaspag_baixas = new ContaspagBaixas($this->contaspag_baixas_id);
    
        // returns the associated object
        return $this->contaspag_baixas;
    }
    /**
     * Method set_contasrec_baixas
     * Sample of usage: $var->contasrec_baixas = $object;
     * @param $object Instance of ContasrecBaixas
     */
    public function set_contasrec_baixas(ContasrecBaixas $object)
    {
        $this->contasrec_baixas = $object;
        $this->contasrec_baixas_id = $object->id;
    }

    /**
     * Method get_contasrec_baixas
     * Sample of usage: $var->contasrec_baixas->attribute;
     * @returns ContasrecBaixas instance
     */
    public function get_contasrec_baixas()
    {
    
        // loads the associated object
        if (empty($this->contasrec_baixas))
            $this->contasrec_baixas = new ContasrecBaixas($this->contasrec_baixas_id);
    
        // returns the associated object
        return $this->contasrec_baixas;
    }
    /**
     * Method set_conta_corrente_lanc_origem
     * Sample of usage: $var->conta_corrente_lanc_origem = $object;
     * @param $object Instance of ContaCorrenteLancOrigem
     */
    public function set_conta_corrente_lanc_origem(ContaCorrenteLancOrigem $object)
    {
        $this->conta_corrente_lanc_origem = $object;
        $this->conta_corrente_lanc_origem_id = $object->id;
    }

    /**
     * Method get_conta_corrente_lanc_origem
     * Sample of usage: $var->conta_corrente_lanc_origem->attribute;
     * @returns ContaCorrenteLancOrigem instance
     */
    public function get_conta_corrente_lanc_origem()
    {
    
        // loads the associated object
        if (empty($this->conta_corrente_lanc_origem))
            $this->conta_corrente_lanc_origem = new ContaCorrenteLancOrigem($this->conta_corrente_lanc_origem_id);
    
        // returns the associated object
        return $this->conta_corrente_lanc_origem;
    }

    /**
     * Method getContabilLancamentoss
     */
    public function getContabilLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('conta_corrente_lancamentos_id', '=', $this->id));
        return ContabilLancamentos::getObjects( $criteria );
    }

    public function set_contabil_lancamentos_plano_conta_to_string($contabil_lancamentos_plano_conta_to_string)
    {
        if(is_array($contabil_lancamentos_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contabil_lancamentos_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_plano_conta_to_string = $contabil_lancamentos_plano_conta_to_string;
        }

        $this->vdata['contabil_lancamentos_plano_conta_to_string'] = $this->contabil_lancamentos_plano_conta_to_string;
    }

    public function get_contabil_lancamentos_plano_conta_to_string()
    {
        if(!empty($this->contabil_lancamentos_plano_conta_to_string))
        {
            return $this->contabil_lancamentos_plano_conta_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_centro_custo_to_string($contabil_lancamentos_centro_custo_to_string)
    {
        if(is_array($contabil_lancamentos_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contabil_lancamentos_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_centro_custo_to_string = $contabil_lancamentos_centro_custo_to_string;
        }

        $this->vdata['contabil_lancamentos_centro_custo_to_string'] = $this->contabil_lancamentos_centro_custo_to_string;
    }

    public function get_contabil_lancamentos_centro_custo_to_string()
    {
        if(!empty($this->contabil_lancamentos_centro_custo_to_string))
        {
            return $this->contabil_lancamentos_centro_custo_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_tipo_to_string($contabil_lancamentos_contabil_lancamentos_tipo_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            $values = ContabilLancamentosTipo::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_tipo_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = $contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_tipo_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_tipo_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_tipo_id','{contabil_lancamentos_tipo->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_situacao_to_string($contabil_lancamentos_contabil_lancamentos_situacao_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            $values = ContabilLancamentosSituacao::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = $contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_situacao_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_situacao_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_situacao_id','{contabil_lancamentos_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_origem_to_string($contabil_lancamentos_contabil_lancamentos_origem_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            $values = ContabilLancamentosOrigem::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = $contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_origem_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_origem_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_origem_id','{contabil_lancamentos_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contasrec_to_string($contabil_lancamentos_contasrec_to_string)
    {
        if(is_array($contabil_lancamentos_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contabil_lancamentos_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contasrec_to_string = $contabil_lancamentos_contasrec_to_string;
        }

        $this->vdata['contabil_lancamentos_contasrec_to_string'] = $this->contabil_lancamentos_contasrec_to_string;
    }

    public function get_contabil_lancamentos_contasrec_to_string()
    {
        if(!empty($this->contabil_lancamentos_contasrec_to_string))
        {
            return $this->contabil_lancamentos_contasrec_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contaspag_contabil_to_string($contabil_lancamentos_contaspag_contabil_to_string)
    {
        if(is_array($contabil_lancamentos_contaspag_contabil_to_string))
        {
            $values = ContaspagContabil::where('id', 'in', $contabil_lancamentos_contaspag_contabil_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contaspag_contabil_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contaspag_contabil_to_string = $contabil_lancamentos_contaspag_contabil_to_string;
        }

        $this->vdata['contabil_lancamentos_contaspag_contabil_to_string'] = $this->contabil_lancamentos_contaspag_contabil_to_string;
    }

    public function get_contabil_lancamentos_contaspag_contabil_to_string()
    {
        if(!empty($this->contabil_lancamentos_contaspag_contabil_to_string))
        {
            return $this->contabil_lancamentos_contaspag_contabil_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('contaspag_contabil_id','{contaspag_contabil->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_conta_corrente_lancamentos_to_string($contabil_lancamentos_conta_corrente_lancamentos_to_string)
    {
        if(is_array($contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            $values = ContaCorrenteLancamentos::where('id', 'in', $contabil_lancamentos_conta_corrente_lancamentos_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = $contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }

        $this->vdata['contabil_lancamentos_conta_corrente_lancamentos_to_string'] = $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
    }

    public function get_contabil_lancamentos_conta_corrente_lancamentos_to_string()
    {
        if(!empty($this->contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            return $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }
    
        $values = ContabilLancamentos::where('conta_corrente_lancamentos_id', '=', $this->id)->getIndexedArray('conta_corrente_lancamentos_id','{conta_corrente_lancamentos->id}');
        return implode(', ', $values);
    }

   public static function ObterSaldoGeral($conta_corrente_id, &$entradas, &$saidas, $system_unit_id)
   {
       $total_debitos = 0;
       $total_creditos = 0;
   
       if ($conta_corrente_id == '')
       {
           $lista_lancamentos = ContaCorrenteLancamentos::where('id', '>', 0)
                                                        ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id} )")->load();
       
           foreach ($lista_lancamentos as $lancamento)
           {
               if ($lancamento->conta_corrente_lanc_tipo_id==ContaCorrenteLancTipo::Debito)
               {
                   $total_debitos += $lancamento->valor;
               }
               else
               {
                   $total_creditos += $lancamento->valor;
               }           
           }
       }
       else
       {
           $lista_lancamentos = ContaCorrenteLancamentos::where('conta_corrente_id', '=', $conta_corrente_id)->load();
       
           foreach ($lista_lancamentos as $lancamento)
           {
               if ($lancamento->conta_corrente_lanc_tipo_id==ContaCorrenteLancTipo::Debito)
               {
                   $total_debitos += $lancamento->valor;
               }
               else
               {
                   $total_creditos += $lancamento->valor;
               }           
           }       
       
       }
   
       $entradas = $total_creditos;
       $saidas = $total_debitos;
       return ($total_creditos-$total_debitos);
   }
   
   public static function ObterSaldoPeriodo($conta_corrente_id, $data_inicial, $data_final, &$entradas, &$saidas, $system_unit_id)
   {
   
        if ($conta_corrente_id !='')
        {
            $entradas = (double) ContaCorrenteLancamentos::where('data_lancamento', '>=', TDate::date2us($data_inicial))
                                                          ->where('data_lancamento', '<=', TDate::date2us($data_final))
                                                          ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                          ->where('conta_corrente_id', '=', $conta_corrente_id)
                                                          ->where('deletado_em', 'is', NULL)
                                                        //   ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id} )")
                                                          ->sumby('valor');  
                                                      
            echo 'entradas '.$entradas;
        
            $saidas = (double) ContaCorrenteLancamentos::where('data_lancamento', '>=', TDate::date2us($data_inicial))
                                                          ->where('data_lancamento', '<=', TDate::date2us($data_final))
                                                          ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                          ->where('conta_corrente_id', '=', $conta_corrente_id)
                                                          ->where('deletado_em', 'is', NULL)
                                                        //   ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id} )")
                                                          ->sumby('valor');   
                                                      
            echo 'saidas '.$saidas;                                                      
        }
        else
        {
            $entradas = (double) ContaCorrenteLancamentos::where('data_lancamento', '>=', TDate::date2us($data_inicial))
                                                          ->where('data_lancamento', '<=', TDate::date2us($data_final))
                                                          ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Credito)
                                                          ->where('deletado_em', 'is', NULL)
                                                          ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id} )")
                                                          ->sumby('valor');  

            $saidas = (double) ContaCorrenteLancamentos::where('data_lancamento', '>=', TDate::date2us($data_inicial))
                                                          ->where('data_lancamento', '<=', TDate::date2us($data_final))
                                                          ->where('conta_corrente_lanc_tipo_id', '=', ContaCorrenteLancTipo::Debito)
                                                          ->where('deletado_em', 'is', NULL)
                                                          ->where('conta_corrente_id', 'in', "(select id from conta_corrente where system_unit_id = {$system_unit_id} )")
                                                          ->sumby('valor');           
        }
                                                  
        return ($entradas - $saidas);                                          
   
   }
   
            
}

