<?php

class ContabilLancamentos extends TRecord
{
    const TABLENAME  = 'contabil_lancamentos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $plano_conta;
    private $centro_custo;
    private $contabil_lancamentos_tipo;
    private $contasrec;
    private $contaspag_contabil;
    private $conta_corrente_lancamentos;
    private $contabil_lancamentos_situacao;
    private $contabil_lancamentos_origem;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('plano_conta_id');
        parent::addAttribute('centro_custo_id');
        parent::addAttribute('contabil_lancamentos_tipo_id');
        parent::addAttribute('contabil_lancamentos_situacao_id');
        parent::addAttribute('contabil_lancamentos_origem_id');
        parent::addAttribute('data_lancamento');
        parent::addAttribute('valor');
        parent::addAttribute('contasrec_id');
        parent::addAttribute('contaspag_contabil_id');
        parent::addAttribute('conta_corrente_lancamentos_id');
        parent::addAttribute('historico');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta(PlanoConta $object)
    {
        $this->plano_conta = $object;
        $this->plano_conta_id = $object->id;
    }

    /**
     * Method get_plano_conta
     * Sample of usage: $var->plano_conta->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta()
    {
    
        // loads the associated object
        if (empty($this->plano_conta))
            $this->plano_conta = new PlanoConta($this->plano_conta_id);
    
        // returns the associated object
        return $this->plano_conta;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo(CentroCusto $object)
    {
        $this->centro_custo = $object;
        $this->centro_custo_id = $object->id;
    }

    /**
     * Method get_centro_custo
     * Sample of usage: $var->centro_custo->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo))
            $this->centro_custo = new CentroCusto($this->centro_custo_id);
    
        // returns the associated object
        return $this->centro_custo;
    }
    /**
     * Method set_contabil_lancamentos_tipo
     * Sample of usage: $var->contabil_lancamentos_tipo = $object;
     * @param $object Instance of ContabilLancamentosTipo
     */
    public function set_contabil_lancamentos_tipo(ContabilLancamentosTipo $object)
    {
        $this->contabil_lancamentos_tipo = $object;
        $this->contabil_lancamentos_tipo_id = $object->id;
    }

    /**
     * Method get_contabil_lancamentos_tipo
     * Sample of usage: $var->contabil_lancamentos_tipo->attribute;
     * @returns ContabilLancamentosTipo instance
     */
    public function get_contabil_lancamentos_tipo()
    {
    
        // loads the associated object
        if (empty($this->contabil_lancamentos_tipo))
            $this->contabil_lancamentos_tipo = new ContabilLancamentosTipo($this->contabil_lancamentos_tipo_id);
    
        // returns the associated object
        return $this->contabil_lancamentos_tipo;
    }
    /**
     * Method set_contasrec
     * Sample of usage: $var->contasrec = $object;
     * @param $object Instance of Contasrec
     */
    public function set_contasrec(Contasrec $object)
    {
        $this->contasrec = $object;
        $this->contasrec_id = $object->id;
    }

    /**
     * Method get_contasrec
     * Sample of usage: $var->contasrec->attribute;
     * @returns Contasrec instance
     */
    public function get_contasrec()
    {
    
        // loads the associated object
        if (empty($this->contasrec))
            $this->contasrec = new Contasrec($this->contasrec_id);
    
        // returns the associated object
        return $this->contasrec;
    }
    /**
     * Method set_contaspag_contabil
     * Sample of usage: $var->contaspag_contabil = $object;
     * @param $object Instance of ContaspagContabil
     */
    public function set_contaspag_contabil(ContaspagContabil $object)
    {
        $this->contaspag_contabil = $object;
        $this->contaspag_contabil_id = $object->id;
    }

    /**
     * Method get_contaspag_contabil
     * Sample of usage: $var->contaspag_contabil->attribute;
     * @returns ContaspagContabil instance
     */
    public function get_contaspag_contabil()
    {
    
        // loads the associated object
        if (empty($this->contaspag_contabil))
            $this->contaspag_contabil = new ContaspagContabil($this->contaspag_contabil_id);
    
        // returns the associated object
        return $this->contaspag_contabil;
    }
    /**
     * Method set_conta_corrente_lancamentos
     * Sample of usage: $var->conta_corrente_lancamentos = $object;
     * @param $object Instance of ContaCorrenteLancamentos
     */
    public function set_conta_corrente_lancamentos(ContaCorrenteLancamentos $object)
    {
        $this->conta_corrente_lancamentos = $object;
        $this->conta_corrente_lancamentos_id = $object->id;
    }

    /**
     * Method get_conta_corrente_lancamentos
     * Sample of usage: $var->conta_corrente_lancamentos->attribute;
     * @returns ContaCorrenteLancamentos instance
     */
    public function get_conta_corrente_lancamentos()
    {
    
        // loads the associated object
        if (empty($this->conta_corrente_lancamentos))
            $this->conta_corrente_lancamentos = new ContaCorrenteLancamentos($this->conta_corrente_lancamentos_id);
    
        // returns the associated object
        return $this->conta_corrente_lancamentos;
    }
    /**
     * Method set_contabil_lancamentos_situacao
     * Sample of usage: $var->contabil_lancamentos_situacao = $object;
     * @param $object Instance of ContabilLancamentosSituacao
     */
    public function set_contabil_lancamentos_situacao(ContabilLancamentosSituacao $object)
    {
        $this->contabil_lancamentos_situacao = $object;
        $this->contabil_lancamentos_situacao_id = $object->id;
    }

    /**
     * Method get_contabil_lancamentos_situacao
     * Sample of usage: $var->contabil_lancamentos_situacao->attribute;
     * @returns ContabilLancamentosSituacao instance
     */
    public function get_contabil_lancamentos_situacao()
    {
    
        // loads the associated object
        if (empty($this->contabil_lancamentos_situacao))
            $this->contabil_lancamentos_situacao = new ContabilLancamentosSituacao($this->contabil_lancamentos_situacao_id);
    
        // returns the associated object
        return $this->contabil_lancamentos_situacao;
    }
    /**
     * Method set_contabil_lancamentos_origem
     * Sample of usage: $var->contabil_lancamentos_origem = $object;
     * @param $object Instance of ContabilLancamentosOrigem
     */
    public function set_contabil_lancamentos_origem(ContabilLancamentosOrigem $object)
    {
        $this->contabil_lancamentos_origem = $object;
        $this->contabil_lancamentos_origem_id = $object->id;
    }

    /**
     * Method get_contabil_lancamentos_origem
     * Sample of usage: $var->contabil_lancamentos_origem->attribute;
     * @returns ContabilLancamentosOrigem instance
     */
    public function get_contabil_lancamentos_origem()
    {
    
        // loads the associated object
        if (empty($this->contabil_lancamentos_origem))
            $this->contabil_lancamentos_origem = new ContabilLancamentosOrigem($this->contabil_lancamentos_origem_id);
    
        // returns the associated object
        return $this->contabil_lancamentos_origem;
    }

    public static function LancamentoContabil($plano_conta_id,
                                       $centro_custo_id,
                                       $contabil_lancamentos_tipo_id,
                                       $contabil_lancamentos_situacao_id,
                                       $contabil_lancamentos_origem_id,
                                       $id_origem,
                                       $data_lancamento,
                                       $valor,
                                       $historico)
 {
 
     //verificando se o lancamento ja existe
     switch ($contabil_lancamentos_origem_id) 
     {
         case (ContabilLancamentosOrigem::ContasPag):
             {
                $lancamento = self::where('contaspag_contabil_id','=',$id_origem)->first();
            
                break;
             }
         case (ContabilLancamentosOrigem::ContasRec):
             {
                $lancamento = self::where('contasrec_id','=',$id_origem)->first();
            
                break;
             }
         case (ContabilLancamentosOrigem::ContaCorrente):
             {
                $lancamento = self::where('conta_corrente_lancamentos_id','=',$id_origem)->first();
            
                break;
             }

         default:
             // code...
             break;
     }
 
     if ($lancamento)
     {
         //atualizando o objeto..
         $lancamento->plano_conta_id = $plano_conta_id;
         $lancamento->centro_custo_id = $centro_custo_id;
         $lancamento->contabil_lancamentos_tipo_id = $contabil_lancamentos_tipo_id;
         $lancamento->contabil_lancamentos_situacao_id = $contabil_lancamentos_situacao_id;
         $lancamento->contabil_lancamentos_origem_id = $contabil_lancamentos_origem_id;
         $lancamento->data_lancamento = $data_lancamento;
         $lancamento->valor = $valor;
         $lancamento->historico = $historico;
         $lancamento->alterado_por = TSession::getValue('username');
         $lancamento->store();     
     }
     else
     {
         //preenchendo para incluir..
         $lancamento = new ContabilLancamentos();
         $lancamento->plano_conta_id = $plano_conta_id;
         $lancamento->centro_custo_id = $centro_custo_id;
         $lancamento->contabil_lancamentos_tipo_id = $contabil_lancamentos_tipo_id;
         $lancamento->contabil_lancamentos_situacao_id = $contabil_lancamentos_situacao_id;
         $lancamento->contabil_lancamentos_origem_id = $contabil_lancamentos_origem_id;
         $lancamento->data_lancamento = $data_lancamento;
         $lancamento->valor = $valor;
     
     
         //preenchendo o codigo origem corretamente...
         switch ($contabil_lancamentos_origem_id) 
         {
             case (ContabilLancamentosOrigem::ContasPag):
                 {
                    $lancamento->contaspag_contabil_id = $id_origem; 
                    break;
                 }
             case (ContabilLancamentosOrigem::ContasRec):
                 {
                    $lancamento->contasrec_id = $id_origem; 
                    break;
                 }
             case (ContabilLancamentosOrigem::ContaCorrente):
                 {
                    $lancamento->conta_corrente_lancamentos_id = $id_origem; 
                    break;
                 }
         }     

         $lancamento->historico = $historico;
         $lancamento->criado_por = TSession::getValue('username');
         $lancamento->store();
     }
 
 }  
 
 public static function ValidaLancamentoContabil($plano_conta_id, $centro_custo_id, $plano_conta_origem)
 {
    TTransaction::open('kraftsoft');

    $planoconta = PlanoConta::find($plano_conta_id);

    if ($planoconta)
    {
        if ($planoconta->plano_conta_tipo_id == PlanoContaTipo::Sintetico)
        {
           throw new Exception('Somente plano de contas analíticas podem ser vinculadas!'); 
        }
    
        if ($planoconta->plano_conta_origem_id <> PlanoContaOrigem::Ambos)
        {
            if ($planoconta->plano_conta_origem_id <> $plano_conta_origem)
            {
                throw new Exception('Você selecionou uma conta de origem '.$planoconta->plano_conta_origem->descricao.'!'); 
            }
        }
    }

    $centrocusto = CentroCusto::find($centro_custo_id);

    if ($centrocusto)
    {
        if ($centrocusto->centro_custo_tipo_id == CentroCustoTipo::Sintetico)
        {
           throw new Exception('Somente centros de custo analíticos podem ser vinculadas!'); 
        }
    }   

    TTransaction::close();  
 }
 

                                
}

