<?php

class ContabilLancamentosSituacao extends TRecord
{
    const TABLENAME  = 'contabil_lancamentos_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Liquidado = '1';
    const NaoLiquidado = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getContabilLancamentoss
     */
    public function getContabilLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contabil_lancamentos_situacao_id', '=', $this->id));
        return ContabilLancamentos::getObjects( $criteria );
    }

    public function set_contabil_lancamentos_plano_conta_to_string($contabil_lancamentos_plano_conta_to_string)
    {
        if(is_array($contabil_lancamentos_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contabil_lancamentos_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_plano_conta_to_string = $contabil_lancamentos_plano_conta_to_string;
        }

        $this->vdata['contabil_lancamentos_plano_conta_to_string'] = $this->contabil_lancamentos_plano_conta_to_string;
    }

    public function get_contabil_lancamentos_plano_conta_to_string()
    {
        if(!empty($this->contabil_lancamentos_plano_conta_to_string))
        {
            return $this->contabil_lancamentos_plano_conta_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_centro_custo_to_string($contabil_lancamentos_centro_custo_to_string)
    {
        if(is_array($contabil_lancamentos_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contabil_lancamentos_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_centro_custo_to_string = $contabil_lancamentos_centro_custo_to_string;
        }

        $this->vdata['contabil_lancamentos_centro_custo_to_string'] = $this->contabil_lancamentos_centro_custo_to_string;
    }

    public function get_contabil_lancamentos_centro_custo_to_string()
    {
        if(!empty($this->contabil_lancamentos_centro_custo_to_string))
        {
            return $this->contabil_lancamentos_centro_custo_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_tipo_to_string($contabil_lancamentos_contabil_lancamentos_tipo_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            $values = ContabilLancamentosTipo::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_tipo_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = $contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_tipo_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_tipo_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_tipo_id','{contabil_lancamentos_tipo->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_situacao_to_string($contabil_lancamentos_contabil_lancamentos_situacao_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            $values = ContabilLancamentosSituacao::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = $contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_situacao_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_situacao_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_situacao_id','{contabil_lancamentos_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_origem_to_string($contabil_lancamentos_contabil_lancamentos_origem_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            $values = ContabilLancamentosOrigem::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = $contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_origem_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_origem_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_origem_id','{contabil_lancamentos_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contasrec_to_string($contabil_lancamentos_contasrec_to_string)
    {
        if(is_array($contabil_lancamentos_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contabil_lancamentos_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contasrec_to_string = $contabil_lancamentos_contasrec_to_string;
        }

        $this->vdata['contabil_lancamentos_contasrec_to_string'] = $this->contabil_lancamentos_contasrec_to_string;
    }

    public function get_contabil_lancamentos_contasrec_to_string()
    {
        if(!empty($this->contabil_lancamentos_contasrec_to_string))
        {
            return $this->contabil_lancamentos_contasrec_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contaspag_contabil_to_string($contabil_lancamentos_contaspag_contabil_to_string)
    {
        if(is_array($contabil_lancamentos_contaspag_contabil_to_string))
        {
            $values = ContaspagContabil::where('id', 'in', $contabil_lancamentos_contaspag_contabil_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contaspag_contabil_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contaspag_contabil_to_string = $contabil_lancamentos_contaspag_contabil_to_string;
        }

        $this->vdata['contabil_lancamentos_contaspag_contabil_to_string'] = $this->contabil_lancamentos_contaspag_contabil_to_string;
    }

    public function get_contabil_lancamentos_contaspag_contabil_to_string()
    {
        if(!empty($this->contabil_lancamentos_contaspag_contabil_to_string))
        {
            return $this->contabil_lancamentos_contaspag_contabil_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('contaspag_contabil_id','{contaspag_contabil->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_conta_corrente_lancamentos_to_string($contabil_lancamentos_conta_corrente_lancamentos_to_string)
    {
        if(is_array($contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            $values = ContaCorrenteLancamentos::where('id', 'in', $contabil_lancamentos_conta_corrente_lancamentos_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = $contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }

        $this->vdata['contabil_lancamentos_conta_corrente_lancamentos_to_string'] = $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
    }

    public function get_contabil_lancamentos_conta_corrente_lancamentos_to_string()
    {
        if(!empty($this->contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            return $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }
    
        $values = ContabilLancamentos::where('contabil_lancamentos_situacao_id', '=', $this->id)->getIndexedArray('conta_corrente_lancamentos_id','{conta_corrente_lancamentos->id}');
        return implode(', ', $values);
    }

    
}

