<?php

class Contaspag extends TRecord
{
    const TABLENAME  = 'contaspag';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $contaspag_situacao;
    private $forma_pagamento;
    private $fornecedor;
    private $contaspag_origem;
    private $cheque_banco;
    private $system_unit;
    private $contaspag_bloco;
    private $nota_fiscal_compra;

    const Permissao_DesfazerBaixaContasPag = 'Desfazer baixa de contas a pagar';
    const Evento_ContasPagIncluidoOuAlterado = 'Contas a pagar incluído ou alterado';
    const Evento_ContasPagBaixado = 'Contas a pagar baixado';
                                                                        

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('contaspag_situacao_id');
        parent::addAttribute('forma_pagamento_id');
        parent::addAttribute('fornecedor_id');
        parent::addAttribute('contaspag_origem_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('numero_documento');
        parent::addAttribute('parcela');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('data_emissao');
        parent::addAttribute('valor');
        parent::addAttribute('data_vencimento');
        parent::addAttribute('data_venc_original');
        parent::addAttribute('observacao');
        parent::addAttribute('data_pagamento');
        parent::addAttribute('desconto');
        parent::addAttribute('juros');
        parent::addAttribute('valor_pago');
        parent::addAttribute('valor_aberto');
        parent::addAttribute('valor_multa');
        parent::addAttribute('cheque_banco_id');
        parent::addAttribute('cheque_agencia');
        parent::addAttribute('cheque_conta');
        parent::addAttribute('cheque_emitente');
        parent::addAttribute('cheque_cpfcnpj');
        parent::addAttribute('data_competencia');
        parent::addAttribute('contaspag_bloco_id');
        parent::addAttribute('nota_fiscal_compra_id');
        parent::addAttribute('data_vencimento_calendario');
    
    }

    /**
     * Method set_contaspag_situacao
     * Sample of usage: $var->contaspag_situacao = $object;
     * @param $object Instance of ContaspagSituacao
     */
    public function set_contaspag_situacao(ContaspagSituacao $object)
    {
        $this->contaspag_situacao = $object;
        $this->contaspag_situacao_id = $object->id;
    }

    /**
     * Method get_contaspag_situacao
     * Sample of usage: $var->contaspag_situacao->attribute;
     * @returns ContaspagSituacao instance
     */
    public function get_contaspag_situacao()
    {
    
        // loads the associated object
        if (empty($this->contaspag_situacao))
            $this->contaspag_situacao = new ContaspagSituacao($this->contaspag_situacao_id);
    
        // returns the associated object
        return $this->contaspag_situacao;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento(FormaPagamento $object)
    {
        $this->forma_pagamento = $object;
        $this->forma_pagamento_id = $object->id;
    }

    /**
     * Method get_forma_pagamento
     * Sample of usage: $var->forma_pagamento->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento))
            $this->forma_pagamento = new FormaPagamento($this->forma_pagamento_id);
    
        // returns the associated object
        return $this->forma_pagamento;
    }
    /**
     * Method set_fornecedor
     * Sample of usage: $var->fornecedor = $object;
     * @param $object Instance of Fornecedor
     */
    public function set_fornecedor(Fornecedor $object)
    {
        $this->fornecedor = $object;
        $this->fornecedor_id = $object->id;
    }

    /**
     * Method get_fornecedor
     * Sample of usage: $var->fornecedor->attribute;
     * @returns Fornecedor instance
     */
    public function get_fornecedor()
    {
    
        // loads the associated object
        if (empty($this->fornecedor))
            $this->fornecedor = new Fornecedor($this->fornecedor_id);
    
        // returns the associated object
        return $this->fornecedor;
    }
    /**
     * Method set_contaspag_origem
     * Sample of usage: $var->contaspag_origem = $object;
     * @param $object Instance of ContaspagOrigem
     */
    public function set_contaspag_origem(ContaspagOrigem $object)
    {
        $this->contaspag_origem = $object;
        $this->contaspag_origem_id = $object->id;
    }

    /**
     * Method get_contaspag_origem
     * Sample of usage: $var->contaspag_origem->attribute;
     * @returns ContaspagOrigem instance
     */
    public function get_contaspag_origem()
    {
    
        // loads the associated object
        if (empty($this->contaspag_origem))
            $this->contaspag_origem = new ContaspagOrigem($this->contaspag_origem_id);
    
        // returns the associated object
        return $this->contaspag_origem;
    }
    /**
     * Method set_banco
     * Sample of usage: $var->banco = $object;
     * @param $object Instance of Banco
     */
    public function set_cheque_banco(Banco $object)
    {
        $this->cheque_banco = $object;
        $this->cheque_banco_id = $object->id;
    }

    /**
     * Method get_cheque_banco
     * Sample of usage: $var->cheque_banco->attribute;
     * @returns Banco instance
     */
    public function get_cheque_banco()
    {
    
        // loads the associated object
        if (empty($this->cheque_banco))
            $this->cheque_banco = new Banco($this->cheque_banco_id);
    
        // returns the associated object
        return $this->cheque_banco;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_contaspag_bloco
     * Sample of usage: $var->contaspag_bloco = $object;
     * @param $object Instance of ContaspagBloco
     */
    public function set_contaspag_bloco(ContaspagBloco $object)
    {
        $this->contaspag_bloco = $object;
        $this->contaspag_bloco_id = $object->id;
    }

    /**
     * Method get_contaspag_bloco
     * Sample of usage: $var->contaspag_bloco->attribute;
     * @returns ContaspagBloco instance
     */
    public function get_contaspag_bloco()
    {
    
        // loads the associated object
        if (empty($this->contaspag_bloco))
            $this->contaspag_bloco = new ContaspagBloco($this->contaspag_bloco_id);
    
        // returns the associated object
        return $this->contaspag_bloco;
    }
    /**
     * Method set_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra = $object;
     * @param $object Instance of NotaFiscalCompra
     */
    public function set_nota_fiscal_compra(NotaFiscalCompra $object)
    {
        $this->nota_fiscal_compra = $object;
        $this->nota_fiscal_compra_id = $object->id;
    }

    /**
     * Method get_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra->attribute;
     * @returns NotaFiscalCompra instance
     */
    public function get_nota_fiscal_compra()
    {
    
        // loads the associated object
        if (empty($this->nota_fiscal_compra))
            $this->nota_fiscal_compra = new NotaFiscalCompra($this->nota_fiscal_compra_id);
    
        // returns the associated object
        return $this->nota_fiscal_compra;
    }

    /**
     * Method getContaspagAnexoss
     */
    public function getContaspagAnexoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_id', '=', $this->id));
        return ContaspagAnexos::getObjects( $criteria );
    }
    /**
     * Method getContaspagBaixass
     */
    public function getContaspagBaixass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_id', '=', $this->id));
        return ContaspagBaixas::getObjects( $criteria );
    }
    /**
     * Method getContaspagContabils
     */
    public function getContaspagContabils()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_id', '=', $this->id));
        return ContaspagContabil::getObjects( $criteria );
    }
    /**
     * Method getContaspagHistoricoVencs
     */
    public function getContaspagHistoricoVencs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_id', '=', $this->id));
        return ContaspagHistoricoVenc::getObjects( $criteria );
    }

    public function set_contaspag_anexos_contaspag_to_string($contaspag_anexos_contaspag_to_string)
    {
        if(is_array($contaspag_anexos_contaspag_to_string))
        {
            $values = Contaspag::where('id', 'in', $contaspag_anexos_contaspag_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_anexos_contaspag_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_anexos_contaspag_to_string = $contaspag_anexos_contaspag_to_string;
        }

        $this->vdata['contaspag_anexos_contaspag_to_string'] = $this->contaspag_anexos_contaspag_to_string;
    }

    public function get_contaspag_anexos_contaspag_to_string()
    {
        if(!empty($this->contaspag_anexos_contaspag_to_string))
        {
            return $this->contaspag_anexos_contaspag_to_string;
        }
    
        $values = ContaspagAnexos::where('contaspag_id', '=', $this->id)->getIndexedArray('contaspag_id','{contaspag->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_anexos_titulos_tipo_anexo_to_string($contaspag_anexos_titulos_tipo_anexo_to_string)
    {
        if(is_array($contaspag_anexos_titulos_tipo_anexo_to_string))
        {
            $values = TitulosTipoAnexo::where('id', 'in', $contaspag_anexos_titulos_tipo_anexo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_anexos_titulos_tipo_anexo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_anexos_titulos_tipo_anexo_to_string = $contaspag_anexos_titulos_tipo_anexo_to_string;
        }

        $this->vdata['contaspag_anexos_titulos_tipo_anexo_to_string'] = $this->contaspag_anexos_titulos_tipo_anexo_to_string;
    }

    public function get_contaspag_anexos_titulos_tipo_anexo_to_string()
    {
        if(!empty($this->contaspag_anexos_titulos_tipo_anexo_to_string))
        {
            return $this->contaspag_anexos_titulos_tipo_anexo_to_string;
        }
    
        $values = ContaspagAnexos::where('contaspag_id', '=', $this->id)->getIndexedArray('titulos_tipo_anexo_id','{titulos_tipo_anexo->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_baixas_contaspag_to_string($contaspag_baixas_contaspag_to_string)
    {
        if(is_array($contaspag_baixas_contaspag_to_string))
        {
            $values = Contaspag::where('id', 'in', $contaspag_baixas_contaspag_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_baixas_contaspag_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_baixas_contaspag_to_string = $contaspag_baixas_contaspag_to_string;
        }

        $this->vdata['contaspag_baixas_contaspag_to_string'] = $this->contaspag_baixas_contaspag_to_string;
    }

    public function get_contaspag_baixas_contaspag_to_string()
    {
        if(!empty($this->contaspag_baixas_contaspag_to_string))
        {
            return $this->contaspag_baixas_contaspag_to_string;
        }
    
        $values = ContaspagBaixas::where('contaspag_id', '=', $this->id)->getIndexedArray('contaspag_id','{contaspag->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_baixas_conta_corrente_to_string($contaspag_baixas_conta_corrente_to_string)
    {
        if(is_array($contaspag_baixas_conta_corrente_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contaspag_baixas_conta_corrente_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_baixas_conta_corrente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_baixas_conta_corrente_to_string = $contaspag_baixas_conta_corrente_to_string;
        }

        $this->vdata['contaspag_baixas_conta_corrente_to_string'] = $this->contaspag_baixas_conta_corrente_to_string;
    }

    public function get_contaspag_baixas_conta_corrente_to_string()
    {
        if(!empty($this->contaspag_baixas_conta_corrente_to_string))
        {
            return $this->contaspag_baixas_conta_corrente_to_string;
        }
    
        $values = ContaspagBaixas::where('contaspag_id', '=', $this->id)->getIndexedArray('conta_corrente_id','{conta_corrente->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contabil_contaspag_to_string($contaspag_contabil_contaspag_to_string)
    {
        if(is_array($contaspag_contabil_contaspag_to_string))
        {
            $values = Contaspag::where('id', 'in', $contaspag_contabil_contaspag_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contabil_contaspag_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contabil_contaspag_to_string = $contaspag_contabil_contaspag_to_string;
        }

        $this->vdata['contaspag_contabil_contaspag_to_string'] = $this->contaspag_contabil_contaspag_to_string;
    }

    public function get_contaspag_contabil_contaspag_to_string()
    {
        if(!empty($this->contaspag_contabil_contaspag_to_string))
        {
            return $this->contaspag_contabil_contaspag_to_string;
        }
    
        $values = ContaspagContabil::where('contaspag_id', '=', $this->id)->getIndexedArray('contaspag_id','{contaspag->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_contabil_plano_conta_to_string($contaspag_contabil_plano_conta_to_string)
    {
        if(is_array($contaspag_contabil_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contaspag_contabil_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contabil_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contabil_plano_conta_to_string = $contaspag_contabil_plano_conta_to_string;
        }

        $this->vdata['contaspag_contabil_plano_conta_to_string'] = $this->contaspag_contabil_plano_conta_to_string;
    }

    public function get_contaspag_contabil_plano_conta_to_string()
    {
        if(!empty($this->contaspag_contabil_plano_conta_to_string))
        {
            return $this->contaspag_contabil_plano_conta_to_string;
        }
    
        $values = ContaspagContabil::where('contaspag_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_contabil_centro_custo_to_string($contaspag_contabil_centro_custo_to_string)
    {
        if(is_array($contaspag_contabil_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contaspag_contabil_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contabil_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contabil_centro_custo_to_string = $contaspag_contabil_centro_custo_to_string;
        }

        $this->vdata['contaspag_contabil_centro_custo_to_string'] = $this->contaspag_contabil_centro_custo_to_string;
    }

    public function get_contaspag_contabil_centro_custo_to_string()
    {
        if(!empty($this->contaspag_contabil_centro_custo_to_string))
        {
            return $this->contaspag_contabil_centro_custo_to_string;
        }
    
        $values = ContaspagContabil::where('contaspag_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_historico_venc_contaspag_to_string($contaspag_historico_venc_contaspag_to_string)
    {
        if(is_array($contaspag_historico_venc_contaspag_to_string))
        {
            $values = Contaspag::where('id', 'in', $contaspag_historico_venc_contaspag_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_historico_venc_contaspag_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_historico_venc_contaspag_to_string = $contaspag_historico_venc_contaspag_to_string;
        }

        $this->vdata['contaspag_historico_venc_contaspag_to_string'] = $this->contaspag_historico_venc_contaspag_to_string;
    }

    public function get_contaspag_historico_venc_contaspag_to_string()
    {
        if(!empty($this->contaspag_historico_venc_contaspag_to_string))
        {
            return $this->contaspag_historico_venc_contaspag_to_string;
        }
    
        $values = ContaspagHistoricoVenc::where('contaspag_id', '=', $this->id)->getIndexedArray('contaspag_id','{contaspag->id}');
        return implode(', ', $values);
    }

  public function get_valor_dia()
  {
    $totaldia = (double) self::where('system_unit_id', '=', $this->system_unit_id)
                                ->where('data_vencimento', '=', $this->data_vencimento)
                                ->where('contaspag_situacao_id', '<>', ContaspagSituacao::Cancelado)
                                ->sumby('valor');     
  
    return 'R$ '.number_format($totaldia, 2, ',', '.'); 
  }

  public function get_valor_br()
  {
    return 'R$ '.number_format($this->valor, 2, ',', '.'); 
  }

  public function store()
  {
      $this->data_vencimento_calendario = $this->data_vencimento;
      parent::store();
  }
  
  public static function BaixarTitulo($historico, $data_pagamento, $desconto, $valor_pago, $juros, $multa, $conta_corrente_id, $contaspag_id, $baixa_id)
  {
  
    $contaspag = Contaspag::find($contaspag_id); 
 
    $valor_pago_total = $valor_pago + $contaspag->valor_pago;
    $desconto_total = $desconto + $contaspag->desconto;
    $juros_total = $juros + $contaspag->juros;
    $multa_total = $multa + $contaspag->multa;

    $valor_pago_baixa = ($valor_pago + $juros + $multa) - $desconto;
    $VlrAberto = $contaspag->valor - ($valor_pago_total) - ($desconto_total); 

    if ($VlrAberto<0)
    {
        $VlrAberto = 0;
    }

    //atualizando valores na baixa..
    $baixacpag = ContaspagBaixas::find($baixa_id);
    $baixacpag->saldo_aberto = $contaspag->saldo_aberto;
    $baixacpag->saldo_apagar = $VlrAberto;
    $baixacpag->store();
 
    //lançando na conta corrente...
    $lanc_conta = new ContaCorrenteLancamentos;
    $lanc_conta->conta_corrente_id = $conta_corrente_id; 
    $lanc_conta->conta_corrente_lanc_origem_id = ContaCorrenteLancOrigem::ContasPag; 
    $lanc_conta->conta_corrente_lanc_tipo_id = ContaCorrenteLancTipo::Debito; 
    $lanc_conta->contaspag_baixas_id = $baixa_id;
    $lanc_conta->data_lancamento = $data_pagamento;
    $lanc_conta->valor = $valor_pago_baixa;
    $lanc_conta->documento = $contaspag->numero_documento;
    $lanc_conta->criado_por = TSession::getValue('username');
    $lanc_conta->historico = $historico;
    $lanc_conta->store();

    //atualizando o contas a pagar
    if ($VlrAberto > 0)
    {
      $contaspag->contaspag_situacao_id = ContaspagSituacao::PagoParcialmente;  
    }
    else
    {
      $contaspag->contaspag_situacao_id = ContaspagSituacao::Pago;  
    }

    $contaspag->valor_aberto = $VlrAberto;
    $contaspag->valor_pago = $valor_pago_total;
    $contaspag->desconto = $desconto_total;
    $contaspag->juros = $juros_total;
    $contaspag->multa = $multa_total;
    $contaspag->data_pagamento = $data_pagamento;
    $contaspag->store();

    //verificando se está liquidado...
    if ($VlrAberto > 0)
    {
        $situacao_lanc_contabil = ContabilLancamentosSituacao::NaoLiquidado;  
    }
    else
    {
        $situacao_lanc_contabil = ContabilLancamentosSituacao::Liquidado;
    }   

    $fornecedor = Fornecedor::find($contaspag->fornecedor_id);

    ContaspagContabil::AtualizaLancamentoContabilContasPag(ContabilLancamentosTipo::Debito,
                                                           $situacao_lanc_contabil,
                                                           ContabilLancamentosOrigem::ContasPag,
                                                           $contaspag->id,
                                                           $contaspag->data_vencimento,
                                                           'Ref. Débito Forn: '.$fornecedor->nome);      

  }
  
  public static function DesfazerBaixa($contaspagbaixa)
  {
    //removendo o lançamento do extrato...
    $lanca_conta = ContaCorrenteLancamentos::where('contaspag_baixas_id', '=', $contaspagbaixa->id)->first();
    $lanca_conta->delete();

    ContaspagContabil::DesfazBaixaLancamentoContabilContasPag($contaspag->id);

    $contaspag = Contaspag::find($contaspagbaixa->contaspag_id);   
    $contaspag->valor_aberto = ($contaspag->valor_aberto + $contaspagbaixa->valor);
    $contaspag->valor_pago = ($contaspag->valor_pago - $contaspagbaixa->valor);
    $contaspag->desconto = ($contaspag->desconto - $contaspagbaixa->desconto);
    $contaspag->juros = ($contaspag->juros - $contaspagbaixa->juros);
    $contaspag->multa = ($contaspag->multa - $contaspagbaixa->multa);

    //atualizando o contas a pagar
    if ($contaspag->valor_aberto == $contaspag->valor)
    {
      $contaspag->contaspag_situacao_id = ContaspagSituacao::EmAberto;  
    }
    else
    {
      $contaspag->contaspag_situacao_id = ContaspagSituacao::PagoParcialmente;  
    }

    $contaspag->store();
  }
  
  public static function SincronizaPermissoesEspeciais()
  {
      SystemProgramPermissoes::ProcessaPermissao('ContaspagBaixasSimpleList',self::Permissao_DesfazerBaixaContasPag);
  }
  
  public function get_data_emissao_formatada()
  {
    return date('d/m/Y', strtotime($this->data_emissao));  
  }
  
  public function get_data_vencimento_formatada()
  {
    return date('d/m/Y', strtotime($this->data_vencimento));  
  }  
  
    public static function ConfigEvento_ContasPagIncluidoOuAlterado($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Contas a pagar incluído ou alterado no sistema";
       $mensagem = "Id do título: ".$id." OBS: ".$obs;
       $acao = new TAction(['ContaspagFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function ConfigEvento_ContasPagBaixado($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Contas a pagar baixado";
       $mensagem = "Id do título: ".$id." OBS: ".$obs;
       $acao = new TAction(['ContaspagFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function SincronizaEventos()
    {
       Eventos::ProcessaEventos('ContaspagForm',self::Evento_ContasPagIncluidoOuAlterado);
       Eventos::ProcessaEventos('ContaspagBaixasForm',self::Evento_ContasPagBaixado);   
    }
  
                                                                                
}

