<?php

class ContaspagBloco extends TRecord
{
    const TABLENAME  = 'contaspag_bloco';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $fornecedor;
    private $forma_pagamento;
    private $contaspag_origem;
    private $system_unit;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('fornecedor_id');
        parent::addAttribute('forma_pagamento_id');
        parent::addAttribute('contaspag_origem_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('quantidade_parcelas');
        parent::addAttribute('primeiro_vencimento');
        parent::addAttribute('valor');
        parent::addAttribute('numero_documento');
        parent::addAttribute('observacao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_fornecedor
     * Sample of usage: $var->fornecedor = $object;
     * @param $object Instance of Fornecedor
     */
    public function set_fornecedor(Fornecedor $object)
    {
        $this->fornecedor = $object;
        $this->fornecedor_id = $object->id;
    }

    /**
     * Method get_fornecedor
     * Sample of usage: $var->fornecedor->attribute;
     * @returns Fornecedor instance
     */
    public function get_fornecedor()
    {
    
        // loads the associated object
        if (empty($this->fornecedor))
            $this->fornecedor = new Fornecedor($this->fornecedor_id);
    
        // returns the associated object
        return $this->fornecedor;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento(FormaPagamento $object)
    {
        $this->forma_pagamento = $object;
        $this->forma_pagamento_id = $object->id;
    }

    /**
     * Method get_forma_pagamento
     * Sample of usage: $var->forma_pagamento->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento))
            $this->forma_pagamento = new FormaPagamento($this->forma_pagamento_id);
    
        // returns the associated object
        return $this->forma_pagamento;
    }
    /**
     * Method set_contaspag_origem
     * Sample of usage: $var->contaspag_origem = $object;
     * @param $object Instance of ContaspagOrigem
     */
    public function set_contaspag_origem(ContaspagOrigem $object)
    {
        $this->contaspag_origem = $object;
        $this->contaspag_origem_id = $object->id;
    }

    /**
     * Method get_contaspag_origem
     * Sample of usage: $var->contaspag_origem->attribute;
     * @returns ContaspagOrigem instance
     */
    public function get_contaspag_origem()
    {
    
        // loads the associated object
        if (empty($this->contaspag_origem))
            $this->contaspag_origem = new ContaspagOrigem($this->contaspag_origem_id);
    
        // returns the associated object
        return $this->contaspag_origem;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getContaspags
     */
    public function getContaspags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_bloco_id', '=', $this->id));
        return Contaspag::getObjects( $criteria );
    }
    /**
     * Method getContaspagBlocoContabils
     */
    public function getContaspagBlocoContabils()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_bloco_id', '=', $this->id));
        return ContaspagBlocoContabil::getObjects( $criteria );
    }

    public function set_contaspag_contaspag_situacao_to_string($contaspag_contaspag_situacao_to_string)
    {
        if(is_array($contaspag_contaspag_situacao_to_string))
        {
            $values = ContaspagSituacao::where('id', 'in', $contaspag_contaspag_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_situacao_to_string = $contaspag_contaspag_situacao_to_string;
        }

        $this->vdata['contaspag_contaspag_situacao_to_string'] = $this->contaspag_contaspag_situacao_to_string;
    }

    public function get_contaspag_contaspag_situacao_to_string()
    {
        if(!empty($this->contaspag_contaspag_situacao_to_string))
        {
            return $this->contaspag_contaspag_situacao_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('contaspag_situacao_id','{contaspag_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_forma_pagamento_to_string($contaspag_forma_pagamento_to_string)
    {
        if(is_array($contaspag_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_forma_pagamento_to_string = $contaspag_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_forma_pagamento_to_string'] = $this->contaspag_forma_pagamento_to_string;
    }

    public function get_contaspag_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_forma_pagamento_to_string))
        {
            return $this->contaspag_forma_pagamento_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_fornecedor_to_string($contaspag_fornecedor_to_string)
    {
        if(is_array($contaspag_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_fornecedor_to_string = $contaspag_fornecedor_to_string;
        }

        $this->vdata['contaspag_fornecedor_to_string'] = $this->contaspag_fornecedor_to_string;
    }

    public function get_contaspag_fornecedor_to_string()
    {
        if(!empty($this->contaspag_fornecedor_to_string))
        {
            return $this->contaspag_fornecedor_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_origem_to_string($contaspag_contaspag_origem_to_string)
    {
        if(is_array($contaspag_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_origem_to_string = $contaspag_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_contaspag_origem_to_string'] = $this->contaspag_contaspag_origem_to_string;
    }

    public function get_contaspag_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_contaspag_origem_to_string))
        {
            return $this->contaspag_contaspag_origem_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_system_unit_to_string($contaspag_system_unit_to_string)
    {
        if(is_array($contaspag_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_system_unit_to_string = $contaspag_system_unit_to_string;
        }

        $this->vdata['contaspag_system_unit_to_string'] = $this->contaspag_system_unit_to_string;
    }

    public function get_contaspag_system_unit_to_string()
    {
        if(!empty($this->contaspag_system_unit_to_string))
        {
            return $this->contaspag_system_unit_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contaspag_cheque_banco_to_string($contaspag_cheque_banco_to_string)
    {
        if(is_array($contaspag_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contaspag_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_cheque_banco_to_string = $contaspag_cheque_banco_to_string;
        }

        $this->vdata['contaspag_cheque_banco_to_string'] = $this->contaspag_cheque_banco_to_string;
    }

    public function get_contaspag_cheque_banco_to_string()
    {
        if(!empty($this->contaspag_cheque_banco_to_string))
        {
            return $this->contaspag_cheque_banco_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_bloco_to_string($contaspag_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_bloco_to_string = $contaspag_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_contaspag_bloco_to_string'] = $this->contaspag_contaspag_bloco_to_string;
    }

    public function get_contaspag_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_contaspag_bloco_to_string))
        {
            return $this->contaspag_contaspag_bloco_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_nota_fiscal_compra_to_string($contaspag_nota_fiscal_compra_to_string)
    {
        if(is_array($contaspag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $contaspag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_nota_fiscal_compra_to_string = $contaspag_nota_fiscal_compra_to_string;
        }

        $this->vdata['contaspag_nota_fiscal_compra_to_string'] = $this->contaspag_nota_fiscal_compra_to_string;
    }

    public function get_contaspag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->contaspag_nota_fiscal_compra_to_string))
        {
            return $this->contaspag_nota_fiscal_compra_to_string;
        }
    
        $values = Contaspag::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contabil_contaspag_bloco_to_string($contaspag_bloco_contabil_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_bloco_contabil_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_bloco_contabil_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_bloco_contabil_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contabil_contaspag_bloco_to_string = $contaspag_bloco_contabil_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_bloco_contabil_contaspag_bloco_to_string'] = $this->contaspag_bloco_contabil_contaspag_bloco_to_string;
    }

    public function get_contaspag_bloco_contabil_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_bloco_contabil_contaspag_bloco_to_string))
        {
            return $this->contaspag_bloco_contabil_contaspag_bloco_to_string;
        }
    
        $values = ContaspagBlocoContabil::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contabil_plano_conta_to_string($contaspag_bloco_contabil_plano_conta_to_string)
    {
        if(is_array($contaspag_bloco_contabil_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contaspag_bloco_contabil_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contabil_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contabil_plano_conta_to_string = $contaspag_bloco_contabil_plano_conta_to_string;
        }

        $this->vdata['contaspag_bloco_contabil_plano_conta_to_string'] = $this->contaspag_bloco_contabil_plano_conta_to_string;
    }

    public function get_contaspag_bloco_contabil_plano_conta_to_string()
    {
        if(!empty($this->contaspag_bloco_contabil_plano_conta_to_string))
        {
            return $this->contaspag_bloco_contabil_plano_conta_to_string;
        }
    
        $values = ContaspagBlocoContabil::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contabil_centro_custo_to_string($contaspag_bloco_contabil_centro_custo_to_string)
    {
        if(is_array($contaspag_bloco_contabil_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contaspag_bloco_contabil_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contabil_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contabil_centro_custo_to_string = $contaspag_bloco_contabil_centro_custo_to_string;
        }

        $this->vdata['contaspag_bloco_contabil_centro_custo_to_string'] = $this->contaspag_bloco_contabil_centro_custo_to_string;
    }

    public function get_contaspag_bloco_contabil_centro_custo_to_string()
    {
        if(!empty($this->contaspag_bloco_contabil_centro_custo_to_string))
        {
            return $this->contaspag_bloco_contabil_centro_custo_to_string;
        }
    
        $values = ContaspagBlocoContabil::where('contaspag_bloco_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    
}

