<?php

class ContaspagBlocoContabil extends TRecord
{
    const TABLENAME  = 'contaspag_bloco_contabil';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $plano_conta;
    private $centro_custo;
    private $contaspag_bloco;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('contaspag_bloco_id');
        parent::addAttribute('plano_conta_id');
        parent::addAttribute('centro_custo_id');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta(PlanoConta $object)
    {
        $this->plano_conta = $object;
        $this->plano_conta_id = $object->id;
    }

    /**
     * Method get_plano_conta
     * Sample of usage: $var->plano_conta->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta()
    {
    
        // loads the associated object
        if (empty($this->plano_conta))
            $this->plano_conta = new PlanoConta($this->plano_conta_id);
    
        // returns the associated object
        return $this->plano_conta;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo(CentroCusto $object)
    {
        $this->centro_custo = $object;
        $this->centro_custo_id = $object->id;
    }

    /**
     * Method get_centro_custo
     * Sample of usage: $var->centro_custo->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo))
            $this->centro_custo = new CentroCusto($this->centro_custo_id);
    
        // returns the associated object
        return $this->centro_custo;
    }
    /**
     * Method set_contaspag_bloco
     * Sample of usage: $var->contaspag_bloco = $object;
     * @param $object Instance of ContaspagBloco
     */
    public function set_contaspag_bloco(ContaspagBloco $object)
    {
        $this->contaspag_bloco = $object;
        $this->contaspag_bloco_id = $object->id;
    }

    /**
     * Method get_contaspag_bloco
     * Sample of usage: $var->contaspag_bloco->attribute;
     * @returns ContaspagBloco instance
     */
    public function get_contaspag_bloco()
    {
    
        // loads the associated object
        if (empty($this->contaspag_bloco))
            $this->contaspag_bloco = new ContaspagBloco($this->contaspag_bloco_id);
    
        // returns the associated object
        return $this->contaspag_bloco;
    }

    
}

