<?php

class ContaspagContabil extends TRecord
{
    const TABLENAME  = 'contaspag_contabil';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $contaspag;
    private $plano_conta;
    private $centro_custo;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('contaspag_id');
        parent::addAttribute('plano_conta_id');
        parent::addAttribute('centro_custo_id');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_contaspag
     * Sample of usage: $var->contaspag = $object;
     * @param $object Instance of Contaspag
     */
    public function set_contaspag(Contaspag $object)
    {
        $this->contaspag = $object;
        $this->contaspag_id = $object->id;
    }

    /**
     * Method get_contaspag
     * Sample of usage: $var->contaspag->attribute;
     * @returns Contaspag instance
     */
    public function get_contaspag()
    {
    
        // loads the associated object
        if (empty($this->contaspag))
            $this->contaspag = new Contaspag($this->contaspag_id);
    
        // returns the associated object
        return $this->contaspag;
    }
    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta(PlanoConta $object)
    {
        $this->plano_conta = $object;
        $this->plano_conta_id = $object->id;
    }

    /**
     * Method get_plano_conta
     * Sample of usage: $var->plano_conta->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta()
    {
    
        // loads the associated object
        if (empty($this->plano_conta))
            $this->plano_conta = new PlanoConta($this->plano_conta_id);
    
        // returns the associated object
        return $this->plano_conta;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo(CentroCusto $object)
    {
        $this->centro_custo = $object;
        $this->centro_custo_id = $object->id;
    }

    /**
     * Method get_centro_custo
     * Sample of usage: $var->centro_custo->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo))
            $this->centro_custo = new CentroCusto($this->centro_custo_id);
    
        // returns the associated object
        return $this->centro_custo;
    }

    /**
     * Method getContabilLancamentoss
     */
    public function getContabilLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_contabil_id', '=', $this->id));
        return ContabilLancamentos::getObjects( $criteria );
    }

    public function set_contabil_lancamentos_plano_conta_to_string($contabil_lancamentos_plano_conta_to_string)
    {
        if(is_array($contabil_lancamentos_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contabil_lancamentos_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_plano_conta_to_string = $contabil_lancamentos_plano_conta_to_string;
        }

        $this->vdata['contabil_lancamentos_plano_conta_to_string'] = $this->contabil_lancamentos_plano_conta_to_string;
    }

    public function get_contabil_lancamentos_plano_conta_to_string()
    {
        if(!empty($this->contabil_lancamentos_plano_conta_to_string))
        {
            return $this->contabil_lancamentos_plano_conta_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_centro_custo_to_string($contabil_lancamentos_centro_custo_to_string)
    {
        if(is_array($contabil_lancamentos_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contabil_lancamentos_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_centro_custo_to_string = $contabil_lancamentos_centro_custo_to_string;
        }

        $this->vdata['contabil_lancamentos_centro_custo_to_string'] = $this->contabil_lancamentos_centro_custo_to_string;
    }

    public function get_contabil_lancamentos_centro_custo_to_string()
    {
        if(!empty($this->contabil_lancamentos_centro_custo_to_string))
        {
            return $this->contabil_lancamentos_centro_custo_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_tipo_to_string($contabil_lancamentos_contabil_lancamentos_tipo_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            $values = ContabilLancamentosTipo::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_tipo_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = $contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_tipo_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_tipo_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_tipo_id','{contabil_lancamentos_tipo->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_situacao_to_string($contabil_lancamentos_contabil_lancamentos_situacao_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            $values = ContabilLancamentosSituacao::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = $contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_situacao_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_situacao_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_situacao_id','{contabil_lancamentos_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_origem_to_string($contabil_lancamentos_contabil_lancamentos_origem_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            $values = ContabilLancamentosOrigem::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = $contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_origem_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_origem_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_origem_id','{contabil_lancamentos_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contasrec_to_string($contabil_lancamentos_contasrec_to_string)
    {
        if(is_array($contabil_lancamentos_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contabil_lancamentos_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contasrec_to_string = $contabil_lancamentos_contasrec_to_string;
        }

        $this->vdata['contabil_lancamentos_contasrec_to_string'] = $this->contabil_lancamentos_contasrec_to_string;
    }

    public function get_contabil_lancamentos_contasrec_to_string()
    {
        if(!empty($this->contabil_lancamentos_contasrec_to_string))
        {
            return $this->contabil_lancamentos_contasrec_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contaspag_contabil_to_string($contabil_lancamentos_contaspag_contabil_to_string)
    {
        if(is_array($contabil_lancamentos_contaspag_contabil_to_string))
        {
            $values = ContaspagContabil::where('id', 'in', $contabil_lancamentos_contaspag_contabil_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contaspag_contabil_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contaspag_contabil_to_string = $contabil_lancamentos_contaspag_contabil_to_string;
        }

        $this->vdata['contabil_lancamentos_contaspag_contabil_to_string'] = $this->contabil_lancamentos_contaspag_contabil_to_string;
    }

    public function get_contabil_lancamentos_contaspag_contabil_to_string()
    {
        if(!empty($this->contabil_lancamentos_contaspag_contabil_to_string))
        {
            return $this->contabil_lancamentos_contaspag_contabil_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('contaspag_contabil_id','{contaspag_contabil->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_conta_corrente_lancamentos_to_string($contabil_lancamentos_conta_corrente_lancamentos_to_string)
    {
        if(is_array($contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            $values = ContaCorrenteLancamentos::where('id', 'in', $contabil_lancamentos_conta_corrente_lancamentos_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = $contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }

        $this->vdata['contabil_lancamentos_conta_corrente_lancamentos_to_string'] = $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
    }

    public function get_contabil_lancamentos_conta_corrente_lancamentos_to_string()
    {
        if(!empty($this->contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            return $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }
    
        $values = ContabilLancamentos::where('contaspag_contabil_id', '=', $this->id)->getIndexedArray('conta_corrente_lancamentos_id','{conta_corrente_lancamentos->id}');
        return implode(', ', $values);
    }

  public static function AtualizaLancamentoContabilContasPag($contabil_lancamentos_tipo_id,
                                                             $contabil_lancamentos_situacao_id,
                                                             $contabil_lancamentos_origem_id,
                                                             $contaspag_id,
                                                             $data_lancamento,
                                                             $historico)
  {
  
    //atualizando a tabela contabil de plano de contas...
    $lista_planoconta_cpag = ContaspagContabil::where('contaspag_id', '=', $contaspag_id)->load();

    if ($lista_planoconta_cpag)
    {
        foreach ($lista_planoconta_cpag as $planoconta_cpag)
        {
            ContabilLancamentos::LancamentoContabil($planoconta_cpag->plano_conta_id,
                                                    $planoconta_cpag->centro_custo_id,
                                                    $contabil_lancamentos_tipo_id,
                                                    $contabil_lancamentos_situacao_id,
                                                    $contabil_lancamentos_origem_id,
                                                    $planoconta_cpag->id,
                                                    $data_lancamento,
                                                    $planoconta_cpag->valor,
                                                    $historico);   
                                       
        }
    }      
  
  }
  
  public static function DeletaLancamentoContabilContasPag($contaspag_id)
  {
    //atualizando a tabela contabil de plano de contas...
    $lista_planoconta_cpag = ContaspagContabil::where('contaspag_id', '=', $contaspag_id)->load();

    if ($lista_planoconta_cpag)
    {
        foreach ($lista_planoconta_cpag as $planoconta_cpag)
        {
           $lanc_contabil = ContabilLancamentos::where('contaspag_contabil_id','=',$planoconta_cpag->id)->first(); 
       
           if ($lanc_contabil)
           {
               $lanc_contabil->delete();            
           }
        }
    }
  }
  
  public static function DesfazBaixaLancamentoContabilContasPag($contaspag_id)
  {
    //atualizando a tabela contabil de plano de contas...
    $lista_planoconta_cpag = ContaspagContabil::where('contaspag_id', '=', $contaspag_id)->load();

    if ($lista_planoconta_cpag)
    {
        foreach ($lista_planoconta_cpag as $planoconta_cpag)
        {
           $lanc_contabil = ContabilLancamentos::where('contaspag_contabil_id','=',$planoconta_cpag->id)->first(); 
       
           if ($lanc_contabil)
           {
               $lanc_contabil->contabil_lancamentos_situacao_id = ContabilLancamentosSituacao::NaoLiquidado;
               $lanc_contabil->store();
           }
        }
    }
  }  
  
            
}

