<?php

class ContaspagOrigem extends TRecord
{
    const TABLENAME  = 'contaspag_origem';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Avulso = '1';
    const Compras = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getContaspags
     */
    public function getContaspags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_origem_id', '=', $this->id));
        return Contaspag::getObjects( $criteria );
    }
    /**
     * Method getContaspagBlocos
     */
    public function getContaspagBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contaspag_origem_id', '=', $this->id));
        return ContaspagBloco::getObjects( $criteria );
    }

    public function set_contaspag_contaspag_situacao_to_string($contaspag_contaspag_situacao_to_string)
    {
        if(is_array($contaspag_contaspag_situacao_to_string))
        {
            $values = ContaspagSituacao::where('id', 'in', $contaspag_contaspag_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_situacao_to_string = $contaspag_contaspag_situacao_to_string;
        }

        $this->vdata['contaspag_contaspag_situacao_to_string'] = $this->contaspag_contaspag_situacao_to_string;
    }

    public function get_contaspag_contaspag_situacao_to_string()
    {
        if(!empty($this->contaspag_contaspag_situacao_to_string))
        {
            return $this->contaspag_contaspag_situacao_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('contaspag_situacao_id','{contaspag_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_forma_pagamento_to_string($contaspag_forma_pagamento_to_string)
    {
        if(is_array($contaspag_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_forma_pagamento_to_string = $contaspag_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_forma_pagamento_to_string'] = $this->contaspag_forma_pagamento_to_string;
    }

    public function get_contaspag_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_forma_pagamento_to_string))
        {
            return $this->contaspag_forma_pagamento_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_fornecedor_to_string($contaspag_fornecedor_to_string)
    {
        if(is_array($contaspag_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_fornecedor_to_string = $contaspag_fornecedor_to_string;
        }

        $this->vdata['contaspag_fornecedor_to_string'] = $this->contaspag_fornecedor_to_string;
    }

    public function get_contaspag_fornecedor_to_string()
    {
        if(!empty($this->contaspag_fornecedor_to_string))
        {
            return $this->contaspag_fornecedor_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_origem_to_string($contaspag_contaspag_origem_to_string)
    {
        if(is_array($contaspag_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_origem_to_string = $contaspag_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_contaspag_origem_to_string'] = $this->contaspag_contaspag_origem_to_string;
    }

    public function get_contaspag_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_contaspag_origem_to_string))
        {
            return $this->contaspag_contaspag_origem_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_system_unit_to_string($contaspag_system_unit_to_string)
    {
        if(is_array($contaspag_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_system_unit_to_string = $contaspag_system_unit_to_string;
        }

        $this->vdata['contaspag_system_unit_to_string'] = $this->contaspag_system_unit_to_string;
    }

    public function get_contaspag_system_unit_to_string()
    {
        if(!empty($this->contaspag_system_unit_to_string))
        {
            return $this->contaspag_system_unit_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contaspag_cheque_banco_to_string($contaspag_cheque_banco_to_string)
    {
        if(is_array($contaspag_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contaspag_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_cheque_banco_to_string = $contaspag_cheque_banco_to_string;
        }

        $this->vdata['contaspag_cheque_banco_to_string'] = $this->contaspag_cheque_banco_to_string;
    }

    public function get_contaspag_cheque_banco_to_string()
    {
        if(!empty($this->contaspag_cheque_banco_to_string))
        {
            return $this->contaspag_cheque_banco_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_bloco_to_string($contaspag_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_bloco_to_string = $contaspag_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_contaspag_bloco_to_string'] = $this->contaspag_contaspag_bloco_to_string;
    }

    public function get_contaspag_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_contaspag_bloco_to_string))
        {
            return $this->contaspag_contaspag_bloco_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_nota_fiscal_compra_to_string($contaspag_nota_fiscal_compra_to_string)
    {
        if(is_array($contaspag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $contaspag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_nota_fiscal_compra_to_string = $contaspag_nota_fiscal_compra_to_string;
        }

        $this->vdata['contaspag_nota_fiscal_compra_to_string'] = $this->contaspag_nota_fiscal_compra_to_string;
    }

    public function get_contaspag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->contaspag_nota_fiscal_compra_to_string))
        {
            return $this->contaspag_nota_fiscal_compra_to_string;
        }
    
        $values = Contaspag::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_fornecedor_to_string($contaspag_bloco_fornecedor_to_string)
    {
        if(is_array($contaspag_bloco_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_bloco_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_bloco_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_fornecedor_to_string = $contaspag_bloco_fornecedor_to_string;
        }

        $this->vdata['contaspag_bloco_fornecedor_to_string'] = $this->contaspag_bloco_fornecedor_to_string;
    }

    public function get_contaspag_bloco_fornecedor_to_string()
    {
        if(!empty($this->contaspag_bloco_fornecedor_to_string))
        {
            return $this->contaspag_bloco_fornecedor_to_string;
        }
    
        $values = ContaspagBloco::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_forma_pagamento_to_string($contaspag_bloco_forma_pagamento_to_string)
    {
        if(is_array($contaspag_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_forma_pagamento_to_string = $contaspag_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_bloco_forma_pagamento_to_string'] = $this->contaspag_bloco_forma_pagamento_to_string;
    }

    public function get_contaspag_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_bloco_forma_pagamento_to_string))
        {
            return $this->contaspag_bloco_forma_pagamento_to_string;
        }
    
        $values = ContaspagBloco::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contaspag_origem_to_string($contaspag_bloco_contaspag_origem_to_string)
    {
        if(is_array($contaspag_bloco_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_bloco_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contaspag_origem_to_string = $contaspag_bloco_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_bloco_contaspag_origem_to_string'] = $this->contaspag_bloco_contaspag_origem_to_string;
    }

    public function get_contaspag_bloco_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_bloco_contaspag_origem_to_string))
        {
            return $this->contaspag_bloco_contaspag_origem_to_string;
        }
    
        $values = ContaspagBloco::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_system_unit_to_string($contaspag_bloco_system_unit_to_string)
    {
        if(is_array($contaspag_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_system_unit_to_string = $contaspag_bloco_system_unit_to_string;
        }

        $this->vdata['contaspag_bloco_system_unit_to_string'] = $this->contaspag_bloco_system_unit_to_string;
    }

    public function get_contaspag_bloco_system_unit_to_string()
    {
        if(!empty($this->contaspag_bloco_system_unit_to_string))
        {
            return $this->contaspag_bloco_system_unit_to_string;
        }
    
        $values = ContaspagBloco::where('contaspag_origem_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    
}

