<?php

class Contasrec extends TRecord
{
    const TABLENAME  = 'contasrec';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $contasrec_situacao;
    private $plano_conta;
    private $centro_custo;
    private $contasrec_origem;
    private $system_unit;
    private $cliente;
    private $cheque_banco;
    private $forma_pagamento;
    private $conta_corrente_boleto;
    private $boleto_situacao;
    private $vendedor;
    private $contasrec_bloco;
    private $venda_formapgto;
    private $ativo;

    const Permissao_DesfazerBaixaContasRec = 'Desfazer baixa de contas a receber';
    const Evento_ContasRecIncluidoOuAlterado = 'Contas a receber incluído ou alterado';
    const Evento_ContasRecBaixado = 'Contas a receber baixado';
    const Evento_ContasRecHistoricoCobrancasIncluidoOuAlterado = 'Histórico de cobranças de contas a receber incluído ou alterado';
                                                

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('cliente_id');
        parent::addAttribute('forma_pagamento_id');
        parent::addAttribute('contasrec_situacao_id');
        parent::addAttribute('plano_conta_id');
        parent::addAttribute('centro_custo_id');
        parent::addAttribute('contasrec_origem_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('numero_documento');
        parent::addAttribute('parcela');
        parent::addAttribute('valor');
        parent::addAttribute('data_vencimento');
        parent::addAttribute('data_venc_original');
        parent::addAttribute('observacao');
        parent::addAttribute('data_pagamento');
        parent::addAttribute('desconto');
        parent::addAttribute('juros');
        parent::addAttribute('valor_pago');
        parent::addAttribute('valor_aberto');
        parent::addAttribute('valor_multa');
        parent::addAttribute('cheque_banco_id');
        parent::addAttribute('cheque_agencia');
        parent::addAttribute('cheque_conta');
        parent::addAttribute('cheque_emitente');
        parent::addAttribute('cheque_cpfcnpj');
        parent::addAttribute('data_competencia');
        parent::addAttribute('conta_corrente_boleto_id');
        parent::addAttribute('boleto_situacao_id');
        parent::addAttribute('boleto_nosso_numero');
        parent::addAttribute('vendedor_comissao');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('contasrec_bloco_id');
        parent::addAttribute('venda_formapgto_id');
        parent::addAttribute('data_emissao');
        parent::addAttribute('ativo_id');
    
    }

    /**
     * Method set_contasrec_situacao
     * Sample of usage: $var->contasrec_situacao = $object;
     * @param $object Instance of ContasrecSituacao
     */
    public function set_contasrec_situacao(ContasrecSituacao $object)
    {
        $this->contasrec_situacao = $object;
        $this->contasrec_situacao_id = $object->id;
    }

    /**
     * Method get_contasrec_situacao
     * Sample of usage: $var->contasrec_situacao->attribute;
     * @returns ContasrecSituacao instance
     */
    public function get_contasrec_situacao()
    {
    
        // loads the associated object
        if (empty($this->contasrec_situacao))
            $this->contasrec_situacao = new ContasrecSituacao($this->contasrec_situacao_id);
    
        // returns the associated object
        return $this->contasrec_situacao;
    }
    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta(PlanoConta $object)
    {
        $this->plano_conta = $object;
        $this->plano_conta_id = $object->id;
    }

    /**
     * Method get_plano_conta
     * Sample of usage: $var->plano_conta->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta()
    {
    
        // loads the associated object
        if (empty($this->plano_conta))
            $this->plano_conta = new PlanoConta($this->plano_conta_id);
    
        // returns the associated object
        return $this->plano_conta;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo(CentroCusto $object)
    {
        $this->centro_custo = $object;
        $this->centro_custo_id = $object->id;
    }

    /**
     * Method get_centro_custo
     * Sample of usage: $var->centro_custo->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo))
            $this->centro_custo = new CentroCusto($this->centro_custo_id);
    
        // returns the associated object
        return $this->centro_custo;
    }
    /**
     * Method set_contasrec_origem
     * Sample of usage: $var->contasrec_origem = $object;
     * @param $object Instance of ContasrecOrigem
     */
    public function set_contasrec_origem(ContasrecOrigem $object)
    {
        $this->contasrec_origem = $object;
        $this->contasrec_origem_id = $object->id;
    }

    /**
     * Method get_contasrec_origem
     * Sample of usage: $var->contasrec_origem->attribute;
     * @returns ContasrecOrigem instance
     */
    public function get_contasrec_origem()
    {
    
        // loads the associated object
        if (empty($this->contasrec_origem))
            $this->contasrec_origem = new ContasrecOrigem($this->contasrec_origem_id);
    
        // returns the associated object
        return $this->contasrec_origem;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_banco
     * Sample of usage: $var->banco = $object;
     * @param $object Instance of Banco
     */
    public function set_cheque_banco(Banco $object)
    {
        $this->cheque_banco = $object;
        $this->cheque_banco_id = $object->id;
    }

    /**
     * Method get_cheque_banco
     * Sample of usage: $var->cheque_banco->attribute;
     * @returns Banco instance
     */
    public function get_cheque_banco()
    {
    
        // loads the associated object
        if (empty($this->cheque_banco))
            $this->cheque_banco = new Banco($this->cheque_banco_id);
    
        // returns the associated object
        return $this->cheque_banco;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento(FormaPagamento $object)
    {
        $this->forma_pagamento = $object;
        $this->forma_pagamento_id = $object->id;
    }

    /**
     * Method get_forma_pagamento
     * Sample of usage: $var->forma_pagamento->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento))
            $this->forma_pagamento = new FormaPagamento($this->forma_pagamento_id);
    
        // returns the associated object
        return $this->forma_pagamento;
    }
    /**
     * Method set_conta_corrente
     * Sample of usage: $var->conta_corrente = $object;
     * @param $object Instance of ContaCorrente
     */
    public function set_conta_corrente_boleto(ContaCorrente $object)
    {
        $this->conta_corrente_boleto = $object;
        $this->conta_corrente_boleto_id = $object->id;
    }

    /**
     * Method get_conta_corrente_boleto
     * Sample of usage: $var->conta_corrente_boleto->attribute;
     * @returns ContaCorrente instance
     */
    public function get_conta_corrente_boleto()
    {
    
        // loads the associated object
        if (empty($this->conta_corrente_boleto))
            $this->conta_corrente_boleto = new ContaCorrente($this->conta_corrente_boleto_id);
    
        // returns the associated object
        return $this->conta_corrente_boleto;
    }
    /**
     * Method set_boleto_situacao
     * Sample of usage: $var->boleto_situacao = $object;
     * @param $object Instance of BoletoSituacao
     */
    public function set_boleto_situacao(BoletoSituacao $object)
    {
        $this->boleto_situacao = $object;
        $this->boleto_situacao_id = $object->id;
    }

    /**
     * Method get_boleto_situacao
     * Sample of usage: $var->boleto_situacao->attribute;
     * @returns BoletoSituacao instance
     */
    public function get_boleto_situacao()
    {
    
        // loads the associated object
        if (empty($this->boleto_situacao))
            $this->boleto_situacao = new BoletoSituacao($this->boleto_situacao_id);
    
        // returns the associated object
        return $this->boleto_situacao;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_contasrec_bloco
     * Sample of usage: $var->contasrec_bloco = $object;
     * @param $object Instance of ContasrecBloco
     */
    public function set_contasrec_bloco(ContasrecBloco $object)
    {
        $this->contasrec_bloco = $object;
        $this->contasrec_bloco_id = $object->id;
    }

    /**
     * Method get_contasrec_bloco
     * Sample of usage: $var->contasrec_bloco->attribute;
     * @returns ContasrecBloco instance
     */
    public function get_contasrec_bloco()
    {
    
        // loads the associated object
        if (empty($this->contasrec_bloco))
            $this->contasrec_bloco = new ContasrecBloco($this->contasrec_bloco_id);
    
        // returns the associated object
        return $this->contasrec_bloco;
    }
    /**
     * Method set_venda_formapgto
     * Sample of usage: $var->venda_formapgto = $object;
     * @param $object Instance of VendaFormapgto
     */
    public function set_venda_formapgto(VendaFormapgto $object)
    {
        $this->venda_formapgto = $object;
        $this->venda_formapgto_id = $object->id;
    }

    /**
     * Method get_venda_formapgto
     * Sample of usage: $var->venda_formapgto->attribute;
     * @returns VendaFormapgto instance
     */
    public function get_venda_formapgto()
    {
    
        // loads the associated object
        if (empty($this->venda_formapgto))
            $this->venda_formapgto = new VendaFormapgto($this->venda_formapgto_id);
    
        // returns the associated object
        return $this->venda_formapgto;
    }
    /**
     * Method set_ativo
     * Sample of usage: $var->ativo = $object;
     * @param $object Instance of Ativo
     */
    public function set_ativo(Ativo $object)
    {
        $this->ativo = $object;
        $this->ativo_id = $object->id;
    }

    /**
     * Method get_ativo
     * Sample of usage: $var->ativo->attribute;
     * @returns Ativo instance
     */
    public function get_ativo()
    {
    
        // loads the associated object
        if (empty($this->ativo))
            $this->ativo = new Ativo($this->ativo_id);
    
        // returns the associated object
        return $this->ativo;
    }

    /**
     * Method getContabilLancamentoss
     */
    public function getContabilLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contasrec_id', '=', $this->id));
        return ContabilLancamentos::getObjects( $criteria );
    }
    /**
     * Method getContasrecAnexoss
     */
    public function getContasrecAnexoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contasrec_id', '=', $this->id));
        return ContasrecAnexos::getObjects( $criteria );
    }
    /**
     * Method getContasrecBaixass
     */
    public function getContasrecBaixass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contasrec_id', '=', $this->id));
        return ContasrecBaixas::getObjects( $criteria );
    }
    /**
     * Method getContasrecHistoricoCobrancas
     */
    public function getContasrecHistoricoCobrancas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contasrec_id', '=', $this->id));
        return ContasrecHistoricoCobranca::getObjects( $criteria );
    }
    /**
     * Method getContasrecHistoricoVencs
     */
    public function getContasrecHistoricoVencs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contasrec_id', '=', $this->id));
        return ContasrecHistoricoVenc::getObjects( $criteria );
    }

    public function set_contabil_lancamentos_plano_conta_to_string($contabil_lancamentos_plano_conta_to_string)
    {
        if(is_array($contabil_lancamentos_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contabil_lancamentos_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_plano_conta_to_string = $contabil_lancamentos_plano_conta_to_string;
        }

        $this->vdata['contabil_lancamentos_plano_conta_to_string'] = $this->contabil_lancamentos_plano_conta_to_string;
    }

    public function get_contabil_lancamentos_plano_conta_to_string()
    {
        if(!empty($this->contabil_lancamentos_plano_conta_to_string))
        {
            return $this->contabil_lancamentos_plano_conta_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_centro_custo_to_string($contabil_lancamentos_centro_custo_to_string)
    {
        if(is_array($contabil_lancamentos_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contabil_lancamentos_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_centro_custo_to_string = $contabil_lancamentos_centro_custo_to_string;
        }

        $this->vdata['contabil_lancamentos_centro_custo_to_string'] = $this->contabil_lancamentos_centro_custo_to_string;
    }

    public function get_contabil_lancamentos_centro_custo_to_string()
    {
        if(!empty($this->contabil_lancamentos_centro_custo_to_string))
        {
            return $this->contabil_lancamentos_centro_custo_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_tipo_to_string($contabil_lancamentos_contabil_lancamentos_tipo_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            $values = ContabilLancamentosTipo::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_tipo_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string = $contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_tipo_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_tipo_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_tipo_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_tipo_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_tipo_id','{contabil_lancamentos_tipo->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_situacao_to_string($contabil_lancamentos_contabil_lancamentos_situacao_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            $values = ContabilLancamentosSituacao::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string = $contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_situacao_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_situacao_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_situacao_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_situacao_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_situacao_id','{contabil_lancamentos_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contabil_lancamentos_origem_to_string($contabil_lancamentos_contabil_lancamentos_origem_to_string)
    {
        if(is_array($contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            $values = ContabilLancamentosOrigem::where('id', 'in', $contabil_lancamentos_contabil_lancamentos_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contabil_lancamentos_origem_to_string = $contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }

        $this->vdata['contabil_lancamentos_contabil_lancamentos_origem_to_string'] = $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
    }

    public function get_contabil_lancamentos_contabil_lancamentos_origem_to_string()
    {
        if(!empty($this->contabil_lancamentos_contabil_lancamentos_origem_to_string))
        {
            return $this->contabil_lancamentos_contabil_lancamentos_origem_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('contabil_lancamentos_origem_id','{contabil_lancamentos_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contasrec_to_string($contabil_lancamentos_contasrec_to_string)
    {
        if(is_array($contabil_lancamentos_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contabil_lancamentos_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contasrec_to_string = $contabil_lancamentos_contasrec_to_string;
        }

        $this->vdata['contabil_lancamentos_contasrec_to_string'] = $this->contabil_lancamentos_contasrec_to_string;
    }

    public function get_contabil_lancamentos_contasrec_to_string()
    {
        if(!empty($this->contabil_lancamentos_contasrec_to_string))
        {
            return $this->contabil_lancamentos_contasrec_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_contaspag_contabil_to_string($contabil_lancamentos_contaspag_contabil_to_string)
    {
        if(is_array($contabil_lancamentos_contaspag_contabil_to_string))
        {
            $values = ContaspagContabil::where('id', 'in', $contabil_lancamentos_contaspag_contabil_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_contaspag_contabil_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_contaspag_contabil_to_string = $contabil_lancamentos_contaspag_contabil_to_string;
        }

        $this->vdata['contabil_lancamentos_contaspag_contabil_to_string'] = $this->contabil_lancamentos_contaspag_contabil_to_string;
    }

    public function get_contabil_lancamentos_contaspag_contabil_to_string()
    {
        if(!empty($this->contabil_lancamentos_contaspag_contabil_to_string))
        {
            return $this->contabil_lancamentos_contaspag_contabil_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('contaspag_contabil_id','{contaspag_contabil->id}');
        return implode(', ', $values);
    }

    public function set_contabil_lancamentos_conta_corrente_lancamentos_to_string($contabil_lancamentos_conta_corrente_lancamentos_to_string)
    {
        if(is_array($contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            $values = ContaCorrenteLancamentos::where('id', 'in', $contabil_lancamentos_conta_corrente_lancamentos_to_string)->getIndexedArray('id', 'id');
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->contabil_lancamentos_conta_corrente_lancamentos_to_string = $contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }

        $this->vdata['contabil_lancamentos_conta_corrente_lancamentos_to_string'] = $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
    }

    public function get_contabil_lancamentos_conta_corrente_lancamentos_to_string()
    {
        if(!empty($this->contabil_lancamentos_conta_corrente_lancamentos_to_string))
        {
            return $this->contabil_lancamentos_conta_corrente_lancamentos_to_string;
        }
    
        $values = ContabilLancamentos::where('contasrec_id', '=', $this->id)->getIndexedArray('conta_corrente_lancamentos_id','{conta_corrente_lancamentos->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_anexos_contasrec_to_string($contasrec_anexos_contasrec_to_string)
    {
        if(is_array($contasrec_anexos_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contasrec_anexos_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_anexos_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_anexos_contasrec_to_string = $contasrec_anexos_contasrec_to_string;
        }

        $this->vdata['contasrec_anexos_contasrec_to_string'] = $this->contasrec_anexos_contasrec_to_string;
    }

    public function get_contasrec_anexos_contasrec_to_string()
    {
        if(!empty($this->contasrec_anexos_contasrec_to_string))
        {
            return $this->contasrec_anexos_contasrec_to_string;
        }
    
        $values = ContasrecAnexos::where('contasrec_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_anexos_titulos_tipo_anexo_to_string($contasrec_anexos_titulos_tipo_anexo_to_string)
    {
        if(is_array($contasrec_anexos_titulos_tipo_anexo_to_string))
        {
            $values = TitulosTipoAnexo::where('id', 'in', $contasrec_anexos_titulos_tipo_anexo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_anexos_titulos_tipo_anexo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_anexos_titulos_tipo_anexo_to_string = $contasrec_anexos_titulos_tipo_anexo_to_string;
        }

        $this->vdata['contasrec_anexos_titulos_tipo_anexo_to_string'] = $this->contasrec_anexos_titulos_tipo_anexo_to_string;
    }

    public function get_contasrec_anexos_titulos_tipo_anexo_to_string()
    {
        if(!empty($this->contasrec_anexos_titulos_tipo_anexo_to_string))
        {
            return $this->contasrec_anexos_titulos_tipo_anexo_to_string;
        }
    
        $values = ContasrecAnexos::where('contasrec_id', '=', $this->id)->getIndexedArray('titulos_tipo_anexo_id','{titulos_tipo_anexo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_baixas_contasrec_to_string($contasrec_baixas_contasrec_to_string)
    {
        if(is_array($contasrec_baixas_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contasrec_baixas_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_baixas_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_baixas_contasrec_to_string = $contasrec_baixas_contasrec_to_string;
        }

        $this->vdata['contasrec_baixas_contasrec_to_string'] = $this->contasrec_baixas_contasrec_to_string;
    }

    public function get_contasrec_baixas_contasrec_to_string()
    {
        if(!empty($this->contasrec_baixas_contasrec_to_string))
        {
            return $this->contasrec_baixas_contasrec_to_string;
        }
    
        $values = ContasrecBaixas::where('contasrec_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_baixas_conta_corrente_to_string($contasrec_baixas_conta_corrente_to_string)
    {
        if(is_array($contasrec_baixas_conta_corrente_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_baixas_conta_corrente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_baixas_conta_corrente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_baixas_conta_corrente_to_string = $contasrec_baixas_conta_corrente_to_string;
        }

        $this->vdata['contasrec_baixas_conta_corrente_to_string'] = $this->contasrec_baixas_conta_corrente_to_string;
    }

    public function get_contasrec_baixas_conta_corrente_to_string()
    {
        if(!empty($this->contasrec_baixas_conta_corrente_to_string))
        {
            return $this->contasrec_baixas_conta_corrente_to_string;
        }
    
        $values = ContasrecBaixas::where('contasrec_id', '=', $this->id)->getIndexedArray('conta_corrente_id','{conta_corrente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_historico_cobranca_contasrec_to_string($contasrec_historico_cobranca_contasrec_to_string)
    {
        if(is_array($contasrec_historico_cobranca_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contasrec_historico_cobranca_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_historico_cobranca_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_historico_cobranca_contasrec_to_string = $contasrec_historico_cobranca_contasrec_to_string;
        }

        $this->vdata['contasrec_historico_cobranca_contasrec_to_string'] = $this->contasrec_historico_cobranca_contasrec_to_string;
    }

    public function get_contasrec_historico_cobranca_contasrec_to_string()
    {
        if(!empty($this->contasrec_historico_cobranca_contasrec_to_string))
        {
            return $this->contasrec_historico_cobranca_contasrec_to_string;
        }
    
        $values = ContasrecHistoricoCobranca::where('contasrec_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_historico_venc_contasrec_to_string($contasrec_historico_venc_contasrec_to_string)
    {
        if(is_array($contasrec_historico_venc_contasrec_to_string))
        {
            $values = Contasrec::where('id', 'in', $contasrec_historico_venc_contasrec_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_historico_venc_contasrec_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_historico_venc_contasrec_to_string = $contasrec_historico_venc_contasrec_to_string;
        }

        $this->vdata['contasrec_historico_venc_contasrec_to_string'] = $this->contasrec_historico_venc_contasrec_to_string;
    }

    public function get_contasrec_historico_venc_contasrec_to_string()
    {
        if(!empty($this->contasrec_historico_venc_contasrec_to_string))
        {
            return $this->contasrec_historico_venc_contasrec_to_string;
        }
    
        $values = ContasrecHistoricoVenc::where('contasrec_id', '=', $this->id)->getIndexedArray('contasrec_id','{contasrec->id}');
        return implode(', ', $values);
    }

  
  public static function BaixarTitulo($historico, $data_pagamento, $desconto, $valor_pago, $juros, $multa, $conta_corrente_id, $contasrec_id, $baixa_id)
  {
  
    $contasrec = Contasrec::find($contasrec_id); 
 
    $valor_pago_total = $valor_pago + $contasrec->valor_pago;
    $desconto_total = $desconto + $contasrec->desconto;
    $juros_total = $juros + $contasrec->juros;
    $multa_total = $multa + $contasrec->multa;

    $valor_pago_baixa = ($valor_pago + $juros + $multa) - $desconto;
    $VlrAberto = $contasrec->valor - ($valor_pago_total) - ($desconto_total); 

    if ($VlrAberto<0)
    {
        $VlrAberto = 0;
    }

    //atualizando valores na baixa..
    $baixacrec = ContasrecBaixas::find($baixa_id);
    $baixacrec->saldo_aberto = $baixacrec->saldo_aberto;
    $baixacrec->saldo_apagar = $VlrAberto;
    $baixacrec->store();
 
    //lançando na conta corrente...
    $lanc_conta = new ContaCorrenteLancamentos;
    $lanc_conta->conta_corrente_id = $conta_corrente_id; 
    $lanc_conta->conta_corrente_lanc_origem_id = ContaCorrenteLancOrigem::ContasRec; 
    $lanc_conta->conta_corrente_lanc_tipo_id = ContaCorrenteLancTipo::Credito; 
    $lanc_conta->contasrec_baixas_id = $baixa_id;
    $lanc_conta->data_lancamento = $data_pagamento;
    $lanc_conta->valor = $valor_pago_baixa;
    $lanc_conta->documento = $contasrec->numero_documento;
    $lanc_conta->criado_por = TSession::getValue('username');
    $lanc_conta->historico = $historico;
    $lanc_conta->store();

    //atualizando o contas a receber
    if ($VlrAberto > 0)
    {
      $contasrec->contasrec_situacao_id = ContasrecSituacao::PagoParcialmente;  
    }
    else
    {
      $contasrec->contasrec_situacao_id = ContasrecSituacao::Pago;  
    }

    $contasrec->valor_aberto = $VlrAberto;
    $contasrec->valor_pago = $valor_pago_total;
    $contasrec->desconto = $desconto_total;
    $contasrec->juros = $juros_total;
    $contasrec->multa = $multa_total;
    $contasrec->data_pagamento = $data_pagamento;
    $contasrec->store();

    //verificando se está liquidado...
    if ($VlrAberto > 0)
    {
        $situacao_lanc_contabil = ContabilLancamentosSituacao::NaoLiquidado;  
        $valor_contabil = $contasrec->valor;
    }
    else
    {
        $situacao_lanc_contabil = ContabilLancamentosSituacao::Liquidado;
        $valor_contabil = $contasrec->valor_pago;
    }

    $cliente = Cliente::find($contasrec->cliente_id);

    ContabilLancamentos::LancamentoContabil($contasrec->plano_conta_id,
                                            $contasrec->centro_custo_id,
                                            ContabilLancamentosTipo::Credito,
                                            $situacao_lanc_contabil,
                                            ContabilLancamentosOrigem::ContasRec,
                                            $contasrec->id,
                                            $contasrec->data_vencimento,
                                            $valor_contabil,
                                            'Ref. Crédito Cliente: '.$cliente->nome);                                           

  }
  
  public static function DesfazerBaixa($contasrecbaixa)
  {
    //removendo o lançamento do extrato...
    $lanca_conta = ContaCorrenteLancamentos::where('contasrec_baixas_id', '=', $contasrecbaixa->id)->first();
    $lanca_conta->delete();

    $lanc_contabil = ContabilLancamentos::where('contasrec_id','=',$contasrecbaixa->contasrec_id)->first(); 

    if ($lanc_contabil)
    {
       $lanc_contabil->contabil_lancamentos_situacao_id = ContabilLancamentosSituacao::NaoLiquidado;
       $lanc_contabil->store();        
    }  
 
    $contasrec = Contasrec::find($contasrecbaixa->contasrec_id);   
    $contasrec->valor_aberto = ($contasrec->valor_aberto + $contasrecbaixa->valor);
    $contasrec->valor_pago = ($contasrec->valor_pago - $contasrecbaixa->valor);
    $contasrec->desconto = ($contasrec->desconto - $contasrecbaixa->desconto);
    $contasrec->juros = ($contasrec->juros - $contasrecbaixa->juros);
    $contasrec->multa = ($contasrec->multa - $contasrecbaixa->multa);

    //atualizando o contas a receber
    if ($contasrec->valor_aberto == $contasrec->valor)
    {
      $contasrec->contasrec_situacao_id = ContasrecSituacao::EmAberto;  
    }
    else
    {
      $contasrec->contasrec_situacao_id = ContasrecSituacao::PagoParcialmente;  
    }

    $contasrec->store();
  }
  
  public static function SincronizaPermissoesEspeciais()
  {
      SystemProgramPermissoes::ProcessaPermissao('ContasrecBaixasSimpleList',self::Permissao_DesfazerBaixaContasRec);
  }
  
  public function get_data_emissao_formatada()
  {
    return date('d/m/Y', strtotime($this->data_emissao));  
  }
  
  public function get_data_vencimento_formatada()
  {
    return date('d/m/Y', strtotime($this->data_vencimento));  
  }   
  
  public function get_valor_formatado()
  {
    return  number_format($this->valor,2,",",".");
  } 
  
    public static function ConfigEvento_ContasRecIncluidoOuAlterado($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Contas a receber incluído ou alterado no sistema";
       $mensagem = "Id do título: ".$id." OBS: ".$obs;
       $acao = new TAction(['ContasrecFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function ConfigEvento_ContasRecBaixado($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Contas a receber baixado";
       $mensagem = "Id do título: ".$id." OBS: ".$obs;
       $acao = new TAction(['ContasrecFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function ConfigEvento_ContasRecHistoricoCobrancasIncluidoOuAlterado($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Histórico de contas a receber incluído ou alterado";
       $mensagem = "Id do título: ".$id." OBS: ".$obs;
       $acao = new TAction(['ContasrecHistoricoCobrancaFormList', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }  

    public static function SincronizaEventos()
    {
       Eventos::ProcessaEventos('ContasrecForm',self::Evento_ContasRecIncluidoOuAlterado);
       Eventos::ProcessaEventos('ContasrecBaixasForm',self::Evento_ContasRecBaixado);   
       Eventos::ProcessaEventos('ContasrecHistoricoCobrancaFormList',self::Evento_ContasRecHistoricoCobrancasIncluidoOuAlterado);          
   
    }  
  
                                                
}

