<?php

class ContasrecBloco extends TRecord
{
    const TABLENAME  = 'contasrec_bloco';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $cliente;
    private $forma_pagamento;
    private $system_unit;
    private $plano_conta;
    private $centro_custo;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cliente_id');
        parent::addAttribute('forma_pagamento_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('plano_conta_id');
        parent::addAttribute('centro_custo_id');
        parent::addAttribute('quantidade_parcelas');
        parent::addAttribute('primeiro_vencimento');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('numero_documento');
        parent::addAttribute('observacao');
            
    }

    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento(FormaPagamento $object)
    {
        $this->forma_pagamento = $object;
        $this->forma_pagamento_id = $object->id;
    }

    /**
     * Method get_forma_pagamento
     * Sample of usage: $var->forma_pagamento->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento))
            $this->forma_pagamento = new FormaPagamento($this->forma_pagamento_id);
    
        // returns the associated object
        return $this->forma_pagamento;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta(PlanoConta $object)
    {
        $this->plano_conta = $object;
        $this->plano_conta_id = $object->id;
    }

    /**
     * Method get_plano_conta
     * Sample of usage: $var->plano_conta->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta()
    {
    
        // loads the associated object
        if (empty($this->plano_conta))
            $this->plano_conta = new PlanoConta($this->plano_conta_id);
    
        // returns the associated object
        return $this->plano_conta;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo(CentroCusto $object)
    {
        $this->centro_custo = $object;
        $this->centro_custo_id = $object->id;
    }

    /**
     * Method get_centro_custo
     * Sample of usage: $var->centro_custo->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo))
            $this->centro_custo = new CentroCusto($this->centro_custo_id);
    
        // returns the associated object
        return $this->centro_custo;
    }

    /**
     * Method getContasrecs
     */
    public function getContasrecs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('contasrec_bloco_id', '=', $this->id));
        return Contasrec::getObjects( $criteria );
    }

    public function set_contasrec_system_unit_to_string($contasrec_system_unit_to_string)
    {
        if(is_array($contasrec_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_system_unit_to_string = $contasrec_system_unit_to_string;
        }

        $this->vdata['contasrec_system_unit_to_string'] = $this->contasrec_system_unit_to_string;
    }

    public function get_contasrec_system_unit_to_string()
    {
        if(!empty($this->contasrec_system_unit_to_string))
        {
            return $this->contasrec_system_unit_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_cliente_to_string($contasrec_cliente_to_string)
    {
        if(is_array($contasrec_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cliente_to_string = $contasrec_cliente_to_string;
        }

        $this->vdata['contasrec_cliente_to_string'] = $this->contasrec_cliente_to_string;
    }

    public function get_contasrec_cliente_to_string()
    {
        if(!empty($this->contasrec_cliente_to_string))
        {
            return $this->contasrec_cliente_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_forma_pagamento_to_string($contasrec_forma_pagamento_to_string)
    {
        if(is_array($contasrec_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_forma_pagamento_to_string = $contasrec_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_forma_pagamento_to_string'] = $this->contasrec_forma_pagamento_to_string;
    }

    public function get_contasrec_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_forma_pagamento_to_string))
        {
            return $this->contasrec_forma_pagamento_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_situacao_to_string($contasrec_contasrec_situacao_to_string)
    {
        if(is_array($contasrec_contasrec_situacao_to_string))
        {
            $values = ContasrecSituacao::where('id', 'in', $contasrec_contasrec_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_situacao_to_string = $contasrec_contasrec_situacao_to_string;
        }

        $this->vdata['contasrec_contasrec_situacao_to_string'] = $this->contasrec_contasrec_situacao_to_string;
    }

    public function get_contasrec_contasrec_situacao_to_string()
    {
        if(!empty($this->contasrec_contasrec_situacao_to_string))
        {
            return $this->contasrec_contasrec_situacao_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('contasrec_situacao_id','{contasrec_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_plano_conta_to_string($contasrec_plano_conta_to_string)
    {
        if(is_array($contasrec_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_plano_conta_to_string = $contasrec_plano_conta_to_string;
        }

        $this->vdata['contasrec_plano_conta_to_string'] = $this->contasrec_plano_conta_to_string;
    }

    public function get_contasrec_plano_conta_to_string()
    {
        if(!empty($this->contasrec_plano_conta_to_string))
        {
            return $this->contasrec_plano_conta_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_centro_custo_to_string($contasrec_centro_custo_to_string)
    {
        if(is_array($contasrec_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_centro_custo_to_string = $contasrec_centro_custo_to_string;
        }

        $this->vdata['contasrec_centro_custo_to_string'] = $this->contasrec_centro_custo_to_string;
    }

    public function get_contasrec_centro_custo_to_string()
    {
        if(!empty($this->contasrec_centro_custo_to_string))
        {
            return $this->contasrec_centro_custo_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_origem_to_string($contasrec_contasrec_origem_to_string)
    {
        if(is_array($contasrec_contasrec_origem_to_string))
        {
            $values = ContasrecOrigem::where('id', 'in', $contasrec_contasrec_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_origem_to_string = $contasrec_contasrec_origem_to_string;
        }

        $this->vdata['contasrec_contasrec_origem_to_string'] = $this->contasrec_contasrec_origem_to_string;
    }

    public function get_contasrec_contasrec_origem_to_string()
    {
        if(!empty($this->contasrec_contasrec_origem_to_string))
        {
            return $this->contasrec_contasrec_origem_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('contasrec_origem_id','{contasrec_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_cheque_banco_to_string($contasrec_cheque_banco_to_string)
    {
        if(is_array($contasrec_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contasrec_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cheque_banco_to_string = $contasrec_cheque_banco_to_string;
        }

        $this->vdata['contasrec_cheque_banco_to_string'] = $this->contasrec_cheque_banco_to_string;
    }

    public function get_contasrec_cheque_banco_to_string()
    {
        if(!empty($this->contasrec_cheque_banco_to_string))
        {
            return $this->contasrec_cheque_banco_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_conta_corrente_boleto_to_string($contasrec_conta_corrente_boleto_to_string)
    {
        if(is_array($contasrec_conta_corrente_boleto_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_conta_corrente_boleto_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_conta_corrente_boleto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_conta_corrente_boleto_to_string = $contasrec_conta_corrente_boleto_to_string;
        }

        $this->vdata['contasrec_conta_corrente_boleto_to_string'] = $this->contasrec_conta_corrente_boleto_to_string;
    }

    public function get_contasrec_conta_corrente_boleto_to_string()
    {
        if(!empty($this->contasrec_conta_corrente_boleto_to_string))
        {
            return $this->contasrec_conta_corrente_boleto_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('conta_corrente_boleto_id','{conta_corrente_boleto->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_boleto_situacao_to_string($contasrec_boleto_situacao_to_string)
    {
        if(is_array($contasrec_boleto_situacao_to_string))
        {
            $values = BoletoSituacao::where('id', 'in', $contasrec_boleto_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_boleto_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_boleto_situacao_to_string = $contasrec_boleto_situacao_to_string;
        }

        $this->vdata['contasrec_boleto_situacao_to_string'] = $this->contasrec_boleto_situacao_to_string;
    }

    public function get_contasrec_boleto_situacao_to_string()
    {
        if(!empty($this->contasrec_boleto_situacao_to_string))
        {
            return $this->contasrec_boleto_situacao_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('boleto_situacao_id','{boleto_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_vendedor_to_string($contasrec_vendedor_to_string)
    {
        if(is_array($contasrec_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $contasrec_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_vendedor_to_string = $contasrec_vendedor_to_string;
        }

        $this->vdata['contasrec_vendedor_to_string'] = $this->contasrec_vendedor_to_string;
    }

    public function get_contasrec_vendedor_to_string()
    {
        if(!empty($this->contasrec_vendedor_to_string))
        {
            return $this->contasrec_vendedor_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_bloco_to_string($contasrec_contasrec_bloco_to_string)
    {
        if(is_array($contasrec_contasrec_bloco_to_string))
        {
            $values = ContasrecBloco::where('id', 'in', $contasrec_contasrec_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_contasrec_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_bloco_to_string = $contasrec_contasrec_bloco_to_string;
        }

        $this->vdata['contasrec_contasrec_bloco_to_string'] = $this->contasrec_contasrec_bloco_to_string;
    }

    public function get_contasrec_contasrec_bloco_to_string()
    {
        if(!empty($this->contasrec_contasrec_bloco_to_string))
        {
            return $this->contasrec_contasrec_bloco_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('contasrec_bloco_id','{contasrec_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_venda_formapgto_to_string($contasrec_venda_formapgto_to_string)
    {
        if(is_array($contasrec_venda_formapgto_to_string))
        {
            $values = VendaFormapgto::where('id', 'in', $contasrec_venda_formapgto_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_venda_formapgto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_venda_formapgto_to_string = $contasrec_venda_formapgto_to_string;
        }

        $this->vdata['contasrec_venda_formapgto_to_string'] = $this->contasrec_venda_formapgto_to_string;
    }

    public function get_contasrec_venda_formapgto_to_string()
    {
        if(!empty($this->contasrec_venda_formapgto_to_string))
        {
            return $this->contasrec_venda_formapgto_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('venda_formapgto_id','{venda_formapgto->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_ativo_to_string($contasrec_ativo_to_string)
    {
        if(is_array($contasrec_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $contasrec_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_ativo_to_string = $contasrec_ativo_to_string;
        }

        $this->vdata['contasrec_ativo_to_string'] = $this->contasrec_ativo_to_string;
    }

    public function get_contasrec_ativo_to_string()
    {
        if(!empty($this->contasrec_ativo_to_string))
        {
            return $this->contasrec_ativo_to_string;
        }
    
        $values = Contasrec::where('contasrec_bloco_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    
}

