<?php

class CstIcms extends TRecord
{
    const TABLENAME  = 'cst_icms';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const ICMS_101 = '1';
    const ICMS_102 = '2';
    const ICMS_103 = '3';
    const ICMS_201 = '4';
    const ICMS_202 = '5';
    const ICMS_203 = '6';
    const ICMS_300 = '7';
    const ICMS_400 = '8';
    const ICMS_500 = '9';
    const ICMS_900 = '10';
    const ICMS_00 = '11';
    const ICMS_10_TribST = '12';
    const ICMS_10_TribStPartilha = '13';
    const ICMS_20 = '14';
    const ICMS_30 = '15';
    const ICMS_40 = '16';
    const ICMS_41_Trib = '17';
    const ICMS_41_NaoTrib = '18';
    const ICMS_50 = '19';
    const ICMS_51 = '20';
    const ICMS_60 = '21';
    const ICMS_70 = '22';
    const ICMS_90_Partilha = '23';
    const ICMS_90 = '24';

    private $regime_tributario;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('regime_tributario_id');
        parent::addAttribute('descricao');
        parent::addAttribute('cst_numero');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt = $object;
     * @param $object Instance of NotafiscalCrt
     */
    public function set_regime_tributario(NotafiscalCrt $object)
    {
        $this->regime_tributario = $object;
        $this->regime_tributario_id = $object->id;
    }

    /**
     * Method get_regime_tributario
     * Sample of usage: $var->regime_tributario->attribute;
     * @returns NotafiscalCrt instance
     */
    public function get_regime_tributario()
    {
    
        // loads the associated object
        if (empty($this->regime_tributario))
            $this->regime_tributario = new NotafiscalCrt($this->regime_tributario_id);
    
        // returns the associated object
        return $this->regime_tributario;
    }

    /**
     * Method getNaturezaOperacaos
     */
    public function getNaturezaOperacaosByCstIcmss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cst_icms_id', '=', $this->id));
        return NaturezaOperacao::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaos
     */
    public function getNaturezaOperacaosByCstIcmsNaoContribuintes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cst_icms_nao_contribuinte_id', '=', $this->id));
        return NaturezaOperacao::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaoExcecaos
     */
    public function getNaturezaOperacaoExcecaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cst_icms_id', '=', $this->id));
        return NaturezaOperacaoExcecao::getObjects( $criteria );
    }

    public function set_natureza_operacao_natureza_operacao_finalidade_to_string($natureza_operacao_natureza_operacao_finalidade_to_string)
    {
        if(is_array($natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            $values = NaturezaOperacaoFinalidade::where('id', 'in', $natureza_operacao_natureza_operacao_finalidade_to_string)->getIndexedArray('nome', 'nome');
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = $natureza_operacao_natureza_operacao_finalidade_to_string;
        }

        $this->vdata['natureza_operacao_natureza_operacao_finalidade_to_string'] = $this->natureza_operacao_natureza_operacao_finalidade_to_string;
    }

    public function get_natureza_operacao_natureza_operacao_finalidade_to_string()
    {
        if(!empty($this->natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            return $this->natureza_operacao_natureza_operacao_finalidade_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('natureza_operacao_finalidade_id','{natureza_operacao_finalidade->nome}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_to_string($natureza_operacao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_to_string = $natureza_operacao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_to_string'] = $this->natureza_operacao_cst_icms_to_string;
    }

    public function get_natureza_operacao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_to_string))
        {
            return $this->natureza_operacao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_nao_contribuinte_to_string($natureza_operacao_cst_icms_nao_contribuinte_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_nao_contribuinte_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = $natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_nao_contribuinte_to_string'] = $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
    }

    public function get_natureza_operacao_cst_icms_nao_contribuinte_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            return $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('cst_icms_nao_contribuinte_id','{cst_icms_nao_contribuinte->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_ipi_to_string($natureza_operacao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_ipi_to_string = $natureza_operacao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_cst_ipi_to_string'] = $this->natureza_operacao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_pis_to_string($natureza_operacao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_pis_to_string = $natureza_operacao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_cst_pis_to_string'] = $this->natureza_operacao_cst_pis_to_string;
    }

    public function get_natureza_operacao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_cst_pis_to_string))
        {
            return $this->natureza_operacao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_cofins_to_string($natureza_operacao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_cofins_to_string = $natureza_operacao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_cst_cofins_to_string'] = $this->natureza_operacao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_consumidor_final_to_string($natureza_operacao_consumidor_final_to_string)
    {
        if(is_array($natureza_operacao_consumidor_final_to_string))
        {
            $values = Resposta::where('id', 'in', $natureza_operacao_consumidor_final_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_consumidor_final_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_consumidor_final_to_string = $natureza_operacao_consumidor_final_to_string;
        }

        $this->vdata['natureza_operacao_consumidor_final_to_string'] = $this->natureza_operacao_consumidor_final_to_string;
    }

    public function get_natureza_operacao_consumidor_final_to_string()
    {
        if(!empty($this->natureza_operacao_consumidor_final_to_string))
        {
            return $this->natureza_operacao_consumidor_final_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('consumidor_final_id','{consumidor_final->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbc_to_string($natureza_operacao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbc_to_string = $natureza_operacao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbcst_to_string($natureza_operacao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = $natureza_operacao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_motDesICMS_to_string($natureza_operacao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacao::where('cst_icms_nao_contribuinte_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_natureza_operacao_to_string($natureza_operacao_excecao_natureza_operacao_to_string)
    {
        if(is_array($natureza_operacao_excecao_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $natureza_operacao_excecao_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natureza_operacao_to_string = $natureza_operacao_excecao_natureza_operacao_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natureza_operacao_to_string'] = $this->natureza_operacao_excecao_natureza_operacao_to_string;
    }

    public function get_natureza_operacao_excecao_natureza_operacao_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natureza_operacao_to_string))
        {
            return $this->natureza_operacao_excecao_natureza_operacao_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_natop_excecao_tributo_to_string($natureza_operacao_excecao_natop_excecao_tributo_to_string)
    {
        if(is_array($natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            $values = NatopExcecaoTributo::where('id', 'in', $natureza_operacao_excecao_natop_excecao_tributo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = $natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natop_excecao_tributo_to_string'] = $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
    }

    public function get_natureza_operacao_excecao_natop_excecao_tributo_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            return $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('natop_excecao_tributo_id','{natop_excecao_tributo->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_pis_to_string($natureza_operacao_excecao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_excecao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_pis_to_string = $natureza_operacao_excecao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_pis_to_string'] = $this->natureza_operacao_excecao_cst_pis_to_string;
    }

    public function get_natureza_operacao_excecao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_pis_to_string))
        {
            return $this->natureza_operacao_excecao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_ipi_to_string($natureza_operacao_excecao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_excecao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_ipi_to_string = $natureza_operacao_excecao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_ipi_to_string'] = $this->natureza_operacao_excecao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_excecao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_excecao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_icms_to_string($natureza_operacao_excecao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_excecao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_icms_to_string = $natureza_operacao_excecao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_icms_to_string'] = $this->natureza_operacao_excecao_cst_icms_to_string;
    }

    public function get_natureza_operacao_excecao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_icms_to_string))
        {
            return $this->natureza_operacao_excecao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_cofins_to_string($natureza_operacao_excecao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_excecao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_cofins_to_string = $natureza_operacao_excecao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_cofins_to_string'] = $this->natureza_operacao_excecao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_excecao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_excecao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbc_to_string($natureza_operacao_excecao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = $natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbcst_to_string($natureza_operacao_excecao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = $natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('cst_icms_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    
}

