<?php

class DespesasServicos extends TRecord
{
    const TABLENAME  = 'despesas_servicos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $despesas_servicos_tipo;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('despesas_servicos_tipo_id');
        parent::addAttribute('descricao');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_despesas_servicos_tipo
     * Sample of usage: $var->despesas_servicos_tipo = $object;
     * @param $object Instance of DespesasServicosTipo
     */
    public function set_despesas_servicos_tipo(DespesasServicosTipo $object)
    {
        $this->despesas_servicos_tipo = $object;
        $this->despesas_servicos_tipo_id = $object->id;
    }

    /**
     * Method get_despesas_servicos_tipo
     * Sample of usage: $var->despesas_servicos_tipo->attribute;
     * @returns DespesasServicosTipo instance
     */
    public function get_despesas_servicos_tipo()
    {
    
        // loads the associated object
        if (empty($this->despesas_servicos_tipo))
            $this->despesas_servicos_tipo = new DespesasServicosTipo($this->despesas_servicos_tipo_id);
    
        // returns the associated object
        return $this->despesas_servicos_tipo;
    }

    /**
     * Method getOrdemServicoItemDespesass
     */
    public function getOrdemServicoItemDespesass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('despesas_servicos_id', '=', $this->id));
        return OrdemServicoItemDespesas::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaDespesass
     */
    public function getProdutoFichaTecnicaDespesass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('despesas_servicos_id', '=', $this->id));
        return ProdutoFichaTecnicaDespesas::getObjects( $criteria );
    }

    public function set_ordem_servico_item_despesas_ordem_servico_item_to_string($ordem_servico_item_despesas_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_despesas_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_despesas_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_despesas_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_despesas_ordem_servico_item_to_string = $ordem_servico_item_despesas_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_despesas_ordem_servico_item_to_string'] = $this->ordem_servico_item_despesas_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_despesas_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_despesas_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_despesas_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemDespesas::where('despesas_servicos_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_despesas_despesas_servicos_to_string($ordem_servico_item_despesas_despesas_servicos_to_string)
    {
        if(is_array($ordem_servico_item_despesas_despesas_servicos_to_string))
        {
            $values = DespesasServicos::where('id', 'in', $ordem_servico_item_despesas_despesas_servicos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_despesas_despesas_servicos_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_despesas_despesas_servicos_to_string = $ordem_servico_item_despesas_despesas_servicos_to_string;
        }

        $this->vdata['ordem_servico_item_despesas_despesas_servicos_to_string'] = $this->ordem_servico_item_despesas_despesas_servicos_to_string;
    }

    public function get_ordem_servico_item_despesas_despesas_servicos_to_string()
    {
        if(!empty($this->ordem_servico_item_despesas_despesas_servicos_to_string))
        {
            return $this->ordem_servico_item_despesas_despesas_servicos_to_string;
        }
    
        $values = OrdemServicoItemDespesas::where('despesas_servicos_id', '=', $this->id)->getIndexedArray('despesas_servicos_id','{despesas_servicos->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_despesas_despesas_servicos_tipo_to_string($ordem_servico_item_despesas_despesas_servicos_tipo_to_string)
    {
        if(is_array($ordem_servico_item_despesas_despesas_servicos_tipo_to_string))
        {
            $values = DespesasServicosTipo::where('id', 'in', $ordem_servico_item_despesas_despesas_servicos_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string = $ordem_servico_item_despesas_despesas_servicos_tipo_to_string;
        }

        $this->vdata['ordem_servico_item_despesas_despesas_servicos_tipo_to_string'] = $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string;
    }

    public function get_ordem_servico_item_despesas_despesas_servicos_tipo_to_string()
    {
        if(!empty($this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string))
        {
            return $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string;
        }
    
        $values = OrdemServicoItemDespesas::where('despesas_servicos_id', '=', $this->id)->getIndexedArray('despesas_servicos_tipo_id','{despesas_servicos_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string($produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaDespesas::where('despesas_servicos_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_despesas_despesas_servicos_to_string($produto_ficha_tecnica_despesas_despesas_servicos_to_string)
    {
        if(is_array($produto_ficha_tecnica_despesas_despesas_servicos_to_string))
        {
            $values = DespesasServicos::where('id', 'in', $produto_ficha_tecnica_despesas_despesas_servicos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string = $produto_ficha_tecnica_despesas_despesas_servicos_to_string;
        }

        $this->vdata['produto_ficha_tecnica_despesas_despesas_servicos_to_string'] = $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string;
    }

    public function get_produto_ficha_tecnica_despesas_despesas_servicos_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_despesas_despesas_servicos_to_string))
        {
            return $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string;
        }
    
        $values = ProdutoFichaTecnicaDespesas::where('despesas_servicos_id', '=', $this->id)->getIndexedArray('despesas_servicos_id','{despesas_servicos->descricao}');
        return implode(', ', $values);
    }

    
}

