<?php

class EmailTemplate extends TRecord
{
    const TABLENAME  = 'email_template';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('titulo');
        parent::addAttribute('mensagem');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getEventoss
     */
    public function getEventoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('email_template_id', '=', $this->id));
        return Eventos::getObjects( $criteria );
    }

    public function set_eventos_system_program_to_string($eventos_system_program_to_string)
    {
        if(is_array($eventos_system_program_to_string))
        {
            $values = SystemProgram::where('id', 'in', $eventos_system_program_to_string)->getIndexedArray('name', 'name');
            $this->eventos_system_program_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_system_program_to_string = $eventos_system_program_to_string;
        }

        $this->vdata['eventos_system_program_to_string'] = $this->eventos_system_program_to_string;
    }

    public function get_eventos_system_program_to_string()
    {
        if(!empty($this->eventos_system_program_to_string))
        {
            return $this->eventos_system_program_to_string;
        }
    
        $values = Eventos::where('email_template_id', '=', $this->id)->getIndexedArray('system_program_id','{system_program->name}');
        return implode(', ', $values);
    }

    public function set_eventos_email_template_to_string($eventos_email_template_to_string)
    {
        if(is_array($eventos_email_template_to_string))
        {
            $values = EmailTemplate::where('id', 'in', $eventos_email_template_to_string)->getIndexedArray('titulo', 'titulo');
            $this->eventos_email_template_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_email_template_to_string = $eventos_email_template_to_string;
        }

        $this->vdata['eventos_email_template_to_string'] = $this->eventos_email_template_to_string;
    }

    public function get_eventos_email_template_to_string()
    {
        if(!empty($this->eventos_email_template_to_string))
        {
            return $this->eventos_email_template_to_string;
        }
    
        $values = Eventos::where('email_template_id', '=', $this->id)->getIndexedArray('email_template_id','{email_template->titulo}');
        return implode(', ', $values);
    }

    
}

