<?php

class EstoqueDeposito extends TRecord
{
    const TABLENAME  = 'estoque_deposito';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_unit;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }
    /**
     * Method getEstoqueRuas
     */
    public function getEstoqueRuas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_id', '=', $this->id));
        return EstoqueRua::getObjects( $criteria );
    }
    /**
     * Method getEstoqueSaldoss
     */
    public function getEstoqueSaldoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_id', '=', $this->id));
        return EstoqueSaldos::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraItenss
     */
    public function getNotaFiscalCompraItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_id', '=', $this->id));
        return NotaFiscalCompraItens::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaos
     */
    public function getOrdemProducaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_id', '=', $this->id));
        return OrdemProducao::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoItenss
     */
    public function getOrdemProducaoItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_id', '=', $this->id));
        return OrdemProducaoItens::getObjects( $criteria );
    }
    /**
     * Method getProdutoFilials
     */
    public function getProdutoFilials()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_padrao_id', '=', $this->id));
        return ProdutoFilial::getObjects( $criteria );
    }
    /**
     * Method getVendaItems
     */
    public function getVendaItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_deposito_id', '=', $this->id));
        return VendaItem::getObjects( $criteria );
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_estoque_rua_estoque_deposito_to_string($estoque_rua_estoque_deposito_to_string)
    {
        if(is_array($estoque_rua_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_rua_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_rua_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_rua_estoque_deposito_to_string = $estoque_rua_estoque_deposito_to_string;
        }

        $this->vdata['estoque_rua_estoque_deposito_to_string'] = $this->estoque_rua_estoque_deposito_to_string;
    }

    public function get_estoque_rua_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_rua_estoque_deposito_to_string))
        {
            return $this->estoque_rua_estoque_deposito_to_string;
        }
    
        $values = EstoqueRua::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_produto_to_string($estoque_saldos_produto_to_string)
    {
        if(is_array($estoque_saldos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_saldos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_saldos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_produto_to_string = $estoque_saldos_produto_to_string;
        }

        $this->vdata['estoque_saldos_produto_to_string'] = $this->estoque_saldos_produto_to_string;
    }

    public function get_estoque_saldos_produto_to_string()
    {
        if(!empty($this->estoque_saldos_produto_to_string))
        {
            return $this->estoque_saldos_produto_to_string;
        }
    
        $values = EstoqueSaldos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_system_unit_to_string($estoque_saldos_system_unit_to_string)
    {
        if(is_array($estoque_saldos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_saldos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_saldos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_system_unit_to_string = $estoque_saldos_system_unit_to_string;
        }

        $this->vdata['estoque_saldos_system_unit_to_string'] = $this->estoque_saldos_system_unit_to_string;
    }

    public function get_estoque_saldos_system_unit_to_string()
    {
        if(!empty($this->estoque_saldos_system_unit_to_string))
        {
            return $this->estoque_saldos_system_unit_to_string;
        }
    
        $values = EstoqueSaldos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_estoque_deposito_to_string($estoque_saldos_estoque_deposito_to_string)
    {
        if(is_array($estoque_saldos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_saldos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_saldos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_estoque_deposito_to_string = $estoque_saldos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_saldos_estoque_deposito_to_string'] = $this->estoque_saldos_estoque_deposito_to_string;
    }

    public function get_estoque_saldos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_saldos_estoque_deposito_to_string))
        {
            return $this->estoque_saldos_estoque_deposito_to_string;
        }
    
        $values = EstoqueSaldos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_produto_lote_to_string($estoque_saldos_produto_lote_to_string)
    {
        if(is_array($estoque_saldos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_saldos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_saldos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_produto_lote_to_string = $estoque_saldos_produto_lote_to_string;
        }

        $this->vdata['estoque_saldos_produto_lote_to_string'] = $this->estoque_saldos_produto_lote_to_string;
    }

    public function get_estoque_saldos_produto_lote_to_string()
    {
        if(!empty($this->estoque_saldos_produto_lote_to_string))
        {
            return $this->estoque_saldos_produto_lote_to_string;
        }
    
        $values = EstoqueSaldos::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_to_string($nota_fiscal_compra_itens_produto_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $nota_fiscal_compra_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_to_string = $nota_fiscal_compra_itens_produto_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_to_string'] = $this->nota_fiscal_compra_itens_produto_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            $values = NotaFiscalCompraItensSituacao::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_itens_situacao_id','{nota_fiscal_compra_itens_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            $values = NotafiscalItemIndtot::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_indtot_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('notafiscal_item_indtot_id','{notafiscal_item_indtot->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_orig_to_string($nota_fiscal_compra_itens_notafiscal_item_orig_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = $nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_orig_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_modbc_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_estoque_deposito_to_string($nota_fiscal_compra_itens_estoque_deposito_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $nota_fiscal_compra_itens_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = $nota_fiscal_compra_itens_estoque_deposito_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_estoque_deposito_to_string'] = $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
    }

    public function get_nota_fiscal_compra_itens_estoque_deposito_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            return $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_lote_to_string($nota_fiscal_compra_itens_produto_lote_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $nota_fiscal_compra_itens_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->nota_fiscal_compra_itens_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_lote_to_string = $nota_fiscal_compra_itens_produto_lote_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_lote_to_string'] = $this->nota_fiscal_compra_itens_produto_lote_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_lote_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_lote_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_lote_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_system_unit_to_string($ordem_producao_system_unit_to_string)
    {
        if(is_array($ordem_producao_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_producao_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_producao_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_system_unit_to_string = $ordem_producao_system_unit_to_string;
        }

        $this->vdata['ordem_producao_system_unit_to_string'] = $this->ordem_producao_system_unit_to_string;
    }

    public function get_ordem_producao_system_unit_to_string()
    {
        if(!empty($this->ordem_producao_system_unit_to_string))
        {
            return $this->ordem_producao_system_unit_to_string;
        }
    
        $values = OrdemProducao::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_ordem_producao_situacao_to_string($ordem_producao_ordem_producao_situacao_to_string)
    {
        if(is_array($ordem_producao_ordem_producao_situacao_to_string))
        {
            $values = OrdemProducaoSituacao::where('id', 'in', $ordem_producao_ordem_producao_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_ordem_producao_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_ordem_producao_situacao_to_string = $ordem_producao_ordem_producao_situacao_to_string;
        }

        $this->vdata['ordem_producao_ordem_producao_situacao_to_string'] = $this->ordem_producao_ordem_producao_situacao_to_string;
    }

    public function get_ordem_producao_ordem_producao_situacao_to_string()
    {
        if(!empty($this->ordem_producao_ordem_producao_situacao_to_string))
        {
            return $this->ordem_producao_ordem_producao_situacao_to_string;
        }
    
        $values = OrdemProducao::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('ordem_producao_situacao_id','{ordem_producao_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_to_string($ordem_producao_produto_to_string)
    {
        if(is_array($ordem_producao_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_to_string = $ordem_producao_produto_to_string;
        }

        $this->vdata['ordem_producao_produto_to_string'] = $this->ordem_producao_produto_to_string;
    }

    public function get_ordem_producao_produto_to_string()
    {
        if(!empty($this->ordem_producao_produto_to_string))
        {
            return $this->ordem_producao_produto_to_string;
        }
    
        $values = OrdemProducao::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_ficha_tecnica_to_string($ordem_producao_produto_ficha_tecnica_to_string)
    {
        if(is_array($ordem_producao_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $ordem_producao_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_ficha_tecnica_to_string = $ordem_producao_produto_ficha_tecnica_to_string;
        }

        $this->vdata['ordem_producao_produto_ficha_tecnica_to_string'] = $this->ordem_producao_produto_ficha_tecnica_to_string;
    }

    public function get_ordem_producao_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->ordem_producao_produto_ficha_tecnica_to_string))
        {
            return $this->ordem_producao_produto_ficha_tecnica_to_string;
        }
    
        $values = OrdemProducao::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_estoque_deposito_to_string($ordem_producao_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_estoque_deposito_to_string = $ordem_producao_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_estoque_deposito_to_string'] = $this->ordem_producao_estoque_deposito_to_string;
    }

    public function get_ordem_producao_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_estoque_deposito_to_string))
        {
            return $this->ordem_producao_estoque_deposito_to_string;
        }
    
        $values = OrdemProducao::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_ordem_producao_to_string($ordem_producao_itens_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_itens_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_itens_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_itens_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_ordem_producao_to_string = $ordem_producao_itens_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_itens_ordem_producao_to_string'] = $this->ordem_producao_itens_ordem_producao_to_string;
    }

    public function get_ordem_producao_itens_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_itens_ordem_producao_to_string))
        {
            return $this->ordem_producao_itens_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_produto_to_string($ordem_producao_itens_produto_to_string)
    {
        if(is_array($ordem_producao_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_produto_to_string = $ordem_producao_itens_produto_to_string;
        }

        $this->vdata['ordem_producao_itens_produto_to_string'] = $this->ordem_producao_itens_produto_to_string;
    }

    public function get_ordem_producao_itens_produto_to_string()
    {
        if(!empty($this->ordem_producao_itens_produto_to_string))
        {
            return $this->ordem_producao_itens_produto_to_string;
        }
    
        $values = OrdemProducaoItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_estoque_deposito_to_string($ordem_producao_itens_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_itens_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_itens_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_itens_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_estoque_deposito_to_string = $ordem_producao_itens_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_itens_estoque_deposito_to_string'] = $this->ordem_producao_itens_estoque_deposito_to_string;
    }

    public function get_ordem_producao_itens_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_itens_estoque_deposito_to_string))
        {
            return $this->ordem_producao_itens_estoque_deposito_to_string;
        }
    
        $values = OrdemProducaoItens::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_produto_to_string($produto_filial_produto_to_string)
    {
        if(is_array($produto_filial_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_filial_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_filial_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_produto_to_string = $produto_filial_produto_to_string;
        }

        $this->vdata['produto_filial_produto_to_string'] = $this->produto_filial_produto_to_string;
    }

    public function get_produto_filial_produto_to_string()
    {
        if(!empty($this->produto_filial_produto_to_string))
        {
            return $this->produto_filial_produto_to_string;
        }
    
        $values = ProdutoFilial::where('estoque_deposito_padrao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_filial_system_unit_to_string($produto_filial_system_unit_to_string)
    {
        if(is_array($produto_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $produto_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->produto_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_system_unit_to_string = $produto_filial_system_unit_to_string;
        }

        $this->vdata['produto_filial_system_unit_to_string'] = $this->produto_filial_system_unit_to_string;
    }

    public function get_produto_filial_system_unit_to_string()
    {
        if(!empty($this->produto_filial_system_unit_to_string))
        {
            return $this->produto_filial_system_unit_to_string;
        }
    
        $values = ProdutoFilial::where('estoque_deposito_padrao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_produto_filial_estoque_deposito_padrao_to_string($produto_filial_estoque_deposito_padrao_to_string)
    {
        if(is_array($produto_filial_estoque_deposito_padrao_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $produto_filial_estoque_deposito_padrao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_estoque_deposito_padrao_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_estoque_deposito_padrao_to_string = $produto_filial_estoque_deposito_padrao_to_string;
        }

        $this->vdata['produto_filial_estoque_deposito_padrao_to_string'] = $this->produto_filial_estoque_deposito_padrao_to_string;
    }

    public function get_produto_filial_estoque_deposito_padrao_to_string()
    {
        if(!empty($this->produto_filial_estoque_deposito_padrao_to_string))
        {
            return $this->produto_filial_estoque_deposito_padrao_to_string;
        }
    
        $values = ProdutoFilial::where('estoque_deposito_padrao_id', '=', $this->id)->getIndexedArray('estoque_deposito_padrao_id','{estoque_deposito_padrao->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_sob_encomenda_to_string($produto_filial_sob_encomenda_to_string)
    {
        if(is_array($produto_filial_sob_encomenda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_sob_encomenda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_sob_encomenda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_sob_encomenda_to_string = $produto_filial_sob_encomenda_to_string;
        }

        $this->vdata['produto_filial_sob_encomenda_to_string'] = $this->produto_filial_sob_encomenda_to_string;
    }

    public function get_produto_filial_sob_encomenda_to_string()
    {
        if(!empty($this->produto_filial_sob_encomenda_to_string))
        {
            return $this->produto_filial_sob_encomenda_to_string;
        }
    
        $values = ProdutoFilial::where('estoque_deposito_padrao_id', '=', $this->id)->getIndexedArray('sob_encomenda_id','{sob_encomenda->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_gerar_op_venda_to_string($produto_filial_gerar_op_venda_to_string)
    {
        if(is_array($produto_filial_gerar_op_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_gerar_op_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_gerar_op_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_gerar_op_venda_to_string = $produto_filial_gerar_op_venda_to_string;
        }

        $this->vdata['produto_filial_gerar_op_venda_to_string'] = $this->produto_filial_gerar_op_venda_to_string;
    }

    public function get_produto_filial_gerar_op_venda_to_string()
    {
        if(!empty($this->produto_filial_gerar_op_venda_to_string))
        {
            return $this->produto_filial_gerar_op_venda_to_string;
        }
    
        $values = ProdutoFilial::where('estoque_deposito_padrao_id', '=', $this->id)->getIndexedArray('gerar_op_venda_id','{gerar_op_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_venda_to_string($venda_item_venda_to_string)
    {
        if(is_array($venda_item_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_item_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_venda_to_string = $venda_item_venda_to_string;
        }

        $this->vdata['venda_item_venda_to_string'] = $this->venda_item_venda_to_string;
    }

    public function get_venda_item_venda_to_string()
    {
        if(!empty($this->venda_item_venda_to_string))
        {
            return $this->venda_item_venda_to_string;
        }
    
        $values = VendaItem::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_to_string($venda_item_produto_to_string)
    {
        if(is_array($venda_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_to_string = $venda_item_produto_to_string;
        }

        $this->vdata['venda_item_produto_to_string'] = $this->venda_item_produto_to_string;
    }

    public function get_venda_item_produto_to_string()
    {
        if(!empty($this->venda_item_produto_to_string))
        {
            return $this->venda_item_produto_to_string;
        }
    
        $values = VendaItem::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_item_fk_cancelado_to_string($venda_item_fk_cancelado_to_string)
    {
        if(is_array($venda_item_fk_cancelado_to_string))
        {
            $values = Resposta::where('id', 'in', $venda_item_fk_cancelado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_fk_cancelado_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_fk_cancelado_to_string = $venda_item_fk_cancelado_to_string;
        }

        $this->vdata['venda_item_fk_cancelado_to_string'] = $this->venda_item_fk_cancelado_to_string;
    }

    public function get_venda_item_fk_cancelado_to_string()
    {
        if(!empty($this->venda_item_fk_cancelado_to_string))
        {
            return $this->venda_item_fk_cancelado_to_string;
        }
    
        $values = VendaItem::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('cancelado','{fk_cancelado->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_estoque_deposito_to_string($venda_item_estoque_deposito_to_string)
    {
        if(is_array($venda_item_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $venda_item_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_estoque_deposito_to_string = $venda_item_estoque_deposito_to_string;
        }

        $this->vdata['venda_item_estoque_deposito_to_string'] = $this->venda_item_estoque_deposito_to_string;
    }

    public function get_venda_item_estoque_deposito_to_string()
    {
        if(!empty($this->venda_item_estoque_deposito_to_string))
        {
            return $this->venda_item_estoque_deposito_to_string;
        }
    
        $values = VendaItem::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_lote_to_string($venda_item_produto_lote_to_string)
    {
        if(is_array($venda_item_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $venda_item_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->venda_item_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_lote_to_string = $venda_item_produto_lote_to_string;
        }

        $this->vdata['venda_item_produto_lote_to_string'] = $this->venda_item_produto_lote_to_string;
    }

    public function get_venda_item_produto_lote_to_string()
    {
        if(!empty($this->venda_item_produto_lote_to_string))
        {
            return $this->venda_item_produto_lote_to_string;
        }
    
        $values = VendaItem::where('estoque_deposito_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    
}

