<?php

class EstoqueEstante extends TRecord
{
    const TABLENAME  = 'estoque_estante';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $estoque_rua;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('estoque_rua_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_estoque_rua
     * Sample of usage: $var->estoque_rua = $object;
     * @param $object Instance of EstoqueRua
     */
    public function set_estoque_rua(EstoqueRua $object)
    {
        $this->estoque_rua = $object;
        $this->estoque_rua_id = $object->id;
    }

    /**
     * Method get_estoque_rua
     * Sample of usage: $var->estoque_rua->attribute;
     * @returns EstoqueRua instance
     */
    public function get_estoque_rua()
    {
    
        // loads the associated object
        if (empty($this->estoque_rua))
            $this->estoque_rua = new EstoqueRua($this->estoque_rua_id);
    
        // returns the associated object
        return $this->estoque_rua;
    }

    /**
     * Method getEstoquePrateleiras
     */
    public function getEstoquePrateleiras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_estante_id', '=', $this->id));
        return EstoquePrateleira::getObjects( $criteria );
    }

    public function set_estoque_prateleira_estoque_estante_to_string($estoque_prateleira_estoque_estante_to_string)
    {
        if(is_array($estoque_prateleira_estoque_estante_to_string))
        {
            $values = EstoqueEstante::where('id', 'in', $estoque_prateleira_estoque_estante_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_prateleira_estoque_estante_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_prateleira_estoque_estante_to_string = $estoque_prateleira_estoque_estante_to_string;
        }

        $this->vdata['estoque_prateleira_estoque_estante_to_string'] = $this->estoque_prateleira_estoque_estante_to_string;
    }

    public function get_estoque_prateleira_estoque_estante_to_string()
    {
        if(!empty($this->estoque_prateleira_estoque_estante_to_string))
        {
            return $this->estoque_prateleira_estoque_estante_to_string;
        }
    
        $values = EstoquePrateleira::where('estoque_estante_id', '=', $this->id)->getIndexedArray('estoque_estante_id','{estoque_estante->descricao}');
        return implode(', ', $values);
    }

    
}

