<?php

class EstoqueLancamentos extends TRecord
{
    const TABLENAME  = 'estoque_lancamentos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $estoque_origem;
    private $estoque_tipo_movimentacao;
    private $system_unit;
    private $venda;
    private $produto;
    private $produto_lote;
    private $estoque_deposito;
    private $nota_fiscal_compra;
    private $ordem_producao;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_id');
        parent::addAttribute('estoque_origem_id');
        parent::addAttribute('estoque_tipo_movimentacao_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('estoque_deposito_id');
        parent::addAttribute('produto_lote_id');
        parent::addAttribute('venda_id');
        parent::addAttribute('nota_fiscal_compra_id');
        parent::addAttribute('ordem_producao_id');
        parent::addAttribute('quantidade');
        parent::addAttribute('observacao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('preco_venda');
        parent::addAttribute('preco_custo');
        parent::addAttribute('data_lancamento');
    
    }

    /**
     * Method set_estoque_origem
     * Sample of usage: $var->estoque_origem = $object;
     * @param $object Instance of EstoqueOrigem
     */
    public function set_estoque_origem(EstoqueOrigem $object)
    {
        $this->estoque_origem = $object;
        $this->estoque_origem_id = $object->id;
    }

    /**
     * Method get_estoque_origem
     * Sample of usage: $var->estoque_origem->attribute;
     * @returns EstoqueOrigem instance
     */
    public function get_estoque_origem()
    {
    
        // loads the associated object
        if (empty($this->estoque_origem))
            $this->estoque_origem = new EstoqueOrigem($this->estoque_origem_id);
    
        // returns the associated object
        return $this->estoque_origem;
    }
    /**
     * Method set_estoque_tipo_movimentacao
     * Sample of usage: $var->estoque_tipo_movimentacao = $object;
     * @param $object Instance of EstoqueTipoMovimentacao
     */
    public function set_estoque_tipo_movimentacao(EstoqueTipoMovimentacao $object)
    {
        $this->estoque_tipo_movimentacao = $object;
        $this->estoque_tipo_movimentacao_id = $object->id;
    }

    /**
     * Method get_estoque_tipo_movimentacao
     * Sample of usage: $var->estoque_tipo_movimentacao->attribute;
     * @returns EstoqueTipoMovimentacao instance
     */
    public function get_estoque_tipo_movimentacao()
    {
    
        // loads the associated object
        if (empty($this->estoque_tipo_movimentacao))
            $this->estoque_tipo_movimentacao = new EstoqueTipoMovimentacao($this->estoque_tipo_movimentacao_id);
    
        // returns the associated object
        return $this->estoque_tipo_movimentacao;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_venda
     * Sample of usage: $var->venda = $object;
     * @param $object Instance of Venda
     */
    public function set_venda(Venda $object)
    {
        $this->venda = $object;
        $this->venda_id = $object->id;
    }

    /**
     * Method get_venda
     * Sample of usage: $var->venda->attribute;
     * @returns Venda instance
     */
    public function get_venda()
    {
    
        // loads the associated object
        if (empty($this->venda))
            $this->venda = new Venda($this->venda_id);
    
        // returns the associated object
        return $this->venda;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_produto_lote
     * Sample of usage: $var->produto_lote = $object;
     * @param $object Instance of ProdutoLote
     */
    public function set_produto_lote(ProdutoLote $object)
    {
        $this->produto_lote = $object;
        $this->produto_lote_id = $object->id;
    }

    /**
     * Method get_produto_lote
     * Sample of usage: $var->produto_lote->attribute;
     * @returns ProdutoLote instance
     */
    public function get_produto_lote()
    {
    
        // loads the associated object
        if (empty($this->produto_lote))
            $this->produto_lote = new ProdutoLote($this->produto_lote_id);
    
        // returns the associated object
        return $this->produto_lote;
    }
    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito(EstoqueDeposito $object)
    {
        $this->estoque_deposito = $object;
        $this->estoque_deposito_id = $object->id;
    }

    /**
     * Method get_estoque_deposito
     * Sample of usage: $var->estoque_deposito->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito))
            $this->estoque_deposito = new EstoqueDeposito($this->estoque_deposito_id);
    
        // returns the associated object
        return $this->estoque_deposito;
    }
    /**
     * Method set_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra = $object;
     * @param $object Instance of NotaFiscalCompra
     */
    public function set_nota_fiscal_compra(NotaFiscalCompra $object)
    {
        $this->nota_fiscal_compra = $object;
        $this->nota_fiscal_compra_id = $object->id;
    }

    /**
     * Method get_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra->attribute;
     * @returns NotaFiscalCompra instance
     */
    public function get_nota_fiscal_compra()
    {
    
        // loads the associated object
        if (empty($this->nota_fiscal_compra))
            $this->nota_fiscal_compra = new NotaFiscalCompra($this->nota_fiscal_compra_id);
    
        // returns the associated object
        return $this->nota_fiscal_compra;
    }
    /**
     * Method set_ordem_producao
     * Sample of usage: $var->ordem_producao = $object;
     * @param $object Instance of OrdemProducao
     */
    public function set_ordem_producao(OrdemProducao $object)
    {
        $this->ordem_producao = $object;
        $this->ordem_producao_id = $object->id;
    }

    /**
     * Method get_ordem_producao
     * Sample of usage: $var->ordem_producao->attribute;
     * @returns OrdemProducao instance
     */
    public function get_ordem_producao()
    {
    
        // loads the associated object
        if (empty($this->ordem_producao))
            $this->ordem_producao = new OrdemProducao($this->ordem_producao_id);
    
        // returns the associated object
        return $this->ordem_producao;
    }

  public static function AtualizaSaldosEstoque($produto_id,$estoque_deposito_id, $produto_lote_id)
  {
  
    if ($produto_lote_id==null) 
    {
        $total_entradas = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                      ->where('produto_id', '=', $produto_id)
                                                      ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                      ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Entrada)
                                                      ->sumby('quantidade');
                                                  
        $total_saidas = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                    ->where('produto_id', '=', $produto_id)
                                                    ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                    ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Saida)
                                                    ->sumby('quantidade');   
                                                
        $total_entrada_reserva = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                      ->where('produto_id', '=', $produto_id)
                                                      ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                      ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::EntradaReserva)
                                                      ->sumby('quantidade');
                                                  
        $total_saida_reserva = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                    ->where('produto_id', '=', $produto_id)
                                                    ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                    ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::SaidaReserva)
                                                    ->sumby('quantidade');  
    } 
    else
    {
  
        $total_entradas = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                      ->where('produto_id', '=', $produto_id)
                                                      ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                      ->where('produto_lote_id', '=', $produto_lote_id)
                                                      ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Entrada)
                                                      ->sumby('quantidade');
                                                  
        $total_saidas = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                    ->where('produto_id', '=', $produto_id)
                                                    ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                    ->where('produto_lote_id', '=', $produto_lote_id)
                                                    ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Saida)
                                                    ->sumby('quantidade');   
                                                
        $total_entrada_reserva = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                      ->where('produto_id', '=', $produto_id)
                                                      ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                      ->where('produto_lote_id', '=', $produto_lote_id)
                                                      ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::EntradaReserva)
                                                      ->sumby('quantidade');
                                                  
        $total_saida_reserva = (double) EstoqueLancamentos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                    ->where('produto_id', '=', $produto_id)
                                                    ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                    ->where('produto_lote_id', '=', $produto_lote_id)
                                                    ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::SaidaReserva)
                                                    ->sumby('quantidade'); 
    }
                                            
    // echo '$total_entradas '.$total_entradas;
    // echo '$total_saidas '.$total_saidas;
    // echo '$total_entrada_reserva '.$total_entrada_reserva;
    // echo '$total_saida_reserva '.$total_saida_reserva;
                                            
    $quant_reservada = ($total_entrada_reserva-$total_saida_reserva);                                           
    $saldo_disponivel = (($total_entradas-$total_saidas) - $quant_reservada); 

    //consultando para atualizar...
    if ($produto_lote_id==null) 
    {
        $estoque_saldo = EstoqueSaldos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                      ->where('produto_id', '=', $produto_id)
                                      ->where('estoque_deposito_id', '=', $estoque_deposito_id)->first();
    }
    else
    {
        $estoque_saldo = EstoqueSaldos::where('system_unit_id', '=', TSession::getValue('userunitid'))
                                      ->where('produto_id', '=', $produto_id)
                                      ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                      ->where('produto_lote_id', '=', $produto_lote_id)->first();
    
    }
                              
                              
    if ($estoque_saldo)
    {
        $estoque_saldo->quant_disponivel = $saldo_disponivel;
        $estoque_saldo->quant_reservada = $quant_reservada;
        $estoque_saldo->store();
    }
  

    //   $lista_lancamentos_estoque = EstoqueLancamentos::where('produto_id', '=', $produto->id)->load();

    //   $entradas = 0;
    //   $saidas = 0;

    //   if ($lista_lancamentos_estoque)
    //   {
    //       foreach ($lista_lancamentos_estoque as $lancamento_estoque)
    //       {

    //           if ($lancamento_estoque->estoque_tipo_movimentacao_id = EstoqueTipoMovimentacao::Entrada)
    //           {
    //               $entradas += $lancamento_estoque->quantidade;
    //           }
    //           else
    //           {
    //               $saidas += $lancamento_estoque->quantidade;
    //           }

    //       }
    //   }
  
  
  }

  public static function ObterSaldoAnterior($system_unit_id, $produto_id, $estoque_deposito_id, $produto_lote_id, $data_inicial)
  {
  
       if ($estoque_deposito_id==0 and $produto_lote_id==0)
       {
            $total_entradas = (double) EstoqueLancamentos::where('system_unit_id', '=', $system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Entrada)
                                                          ->sumby('quantidade');  
                                                      
            $total_saidas = (double) EstoqueLancamentos::where('system_unit_id', '=', $system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Saida)
                                                          ->sumby('quantidade');               
       }
   
       if ($estoque_deposito_id==0 and $produto_lote_id !=0)
       {
            $total_entradas = (double) EstoqueLancamentos::where('system_unit_id', '=', $system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('produto_lote_id', '=', $produto_lote_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))   
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Entrada)
                                                          ->sumby('quantidade');  
                                                      
            $total_saidas = (double) EstoqueLancamentos::where('system_unit_id', '=',$system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('produto_lote_id', '=', $produto_lote_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))   
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Saida)
                                                          ->sumby('quantidade');               
       
       }   
   
       if ($estoque_deposito_id!=0 and $produto_lote_id==0)
       {
            $total_entradas = (double) EstoqueLancamentos::where('system_unit_id', '=', $system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))   
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Entrada)
                                                          ->sumby('quantidade');  
                                                      
            $total_saidas = (double) EstoqueLancamentos::where('system_unit_id', '=', $system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))   
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Saida)
                                                          ->sumby('quantidade');                                                    
       }   
   
       if ($estoque_deposito_id!=0 and $produto_lote_id!=0)
       {
            $total_entradas = (double) EstoqueLancamentos::where('system_unit_id', '=', $system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                          ->where('produto_lote_id', '=', $produto_lote_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))   
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Entrada)
                                                          ->sumby('quantidade');  
                                                      
            $total_saidas = (double) EstoqueLancamentos::where('system_unit_id', '=', $system_unit_id)
                                                          ->where('produto_id', '=', $produto_id)
                                                          ->where('estoque_deposito_id', '=', $estoque_deposito_id)
                                                          ->where('produto_lote_id', '=', $produto_lote_id)
                                                          ->where('data_lancamento', '>=', '2000-01-01')
                                                          ->where('data_lancamento', '<', TDate::date2us($data_inicial))   
                                                          ->where('estoque_tipo_movimentacao_id', '=', EstoqueTipoMovimentacao::Saida)
                                                          ->sumby('quantidade');           
       
       }   
   

        return ($total_entradas - $total_saidas);    
  }

  
        
}

