<?php

class EstoqueOrigem extends TRecord
{
    const TABLENAME  = 'estoque_origem';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const EntradaAvulsa = '1';
    const SaidaAvulsa = '2';
    const Compras = '3';
    const DevolucaoCompra = '4';
    const ProducaoAcabados = '5';
    const Vendas = '6';
    const DevolucaoVenda = '7';
    const EstornoVenda = '8';
    const ProducaoMateriasPrimas = '9';
    const InventarioEntrada = '10';
    const InventarioSaida = '11';
    const ReservaSaldo = '12';
    const RetornoReserva = '13';

    private $estoque_tipo_movimentacao;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('estoque_tipo_movimentacao_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_estoque_tipo_movimentacao
     * Sample of usage: $var->estoque_tipo_movimentacao = $object;
     * @param $object Instance of EstoqueTipoMovimentacao
     */
    public function set_estoque_tipo_movimentacao(EstoqueTipoMovimentacao $object)
    {
        $this->estoque_tipo_movimentacao = $object;
        $this->estoque_tipo_movimentacao_id = $object->id;
    }

    /**
     * Method get_estoque_tipo_movimentacao
     * Sample of usage: $var->estoque_tipo_movimentacao->attribute;
     * @returns EstoqueTipoMovimentacao instance
     */
    public function get_estoque_tipo_movimentacao()
    {
    
        // loads the associated object
        if (empty($this->estoque_tipo_movimentacao))
            $this->estoque_tipo_movimentacao = new EstoqueTipoMovimentacao($this->estoque_tipo_movimentacao_id);
    
        // returns the associated object
        return $this->estoque_tipo_movimentacao;
    }

    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_origem_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_origem_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    
}

