<?php

class EstoquePrateleira extends TRecord
{
    const TABLENAME  = 'estoque_prateleira';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $estoque_estante;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('estoque_estante_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_estoque_estante
     * Sample of usage: $var->estoque_estante = $object;
     * @param $object Instance of EstoqueEstante
     */
    public function set_estoque_estante(EstoqueEstante $object)
    {
        $this->estoque_estante = $object;
        $this->estoque_estante_id = $object->id;
    }

    /**
     * Method get_estoque_estante
     * Sample of usage: $var->estoque_estante->attribute;
     * @returns EstoqueEstante instance
     */
    public function get_estoque_estante()
    {
    
        // loads the associated object
        if (empty($this->estoque_estante))
            $this->estoque_estante = new EstoqueEstante($this->estoque_estante_id);
    
        // returns the associated object
        return $this->estoque_estante;
    }

    /**
     * Method getProdutoEnderecamentos
     */
    public function getProdutoEnderecamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_prateleira_id', '=', $this->id));
        return ProdutoEnderecamento::getObjects( $criteria );
    }

    public function set_produto_enderecamento_produto_filial_to_string($produto_enderecamento_produto_filial_to_string)
    {
        if(is_array($produto_enderecamento_produto_filial_to_string))
        {
            $values = ProdutoFilial::where('id', 'in', $produto_enderecamento_produto_filial_to_string)->getIndexedArray('preco_venda', 'preco_venda');
            $this->produto_enderecamento_produto_filial_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_enderecamento_produto_filial_to_string = $produto_enderecamento_produto_filial_to_string;
        }

        $this->vdata['produto_enderecamento_produto_filial_to_string'] = $this->produto_enderecamento_produto_filial_to_string;
    }

    public function get_produto_enderecamento_produto_filial_to_string()
    {
        if(!empty($this->produto_enderecamento_produto_filial_to_string))
        {
            return $this->produto_enderecamento_produto_filial_to_string;
        }
    
        $values = ProdutoEnderecamento::where('estoque_prateleira_id', '=', $this->id)->getIndexedArray('produto_filial_id','{produto_filial->preco_venda}');
        return implode(', ', $values);
    }

    public function set_produto_enderecamento_estoque_prateleira_to_string($produto_enderecamento_estoque_prateleira_to_string)
    {
        if(is_array($produto_enderecamento_estoque_prateleira_to_string))
        {
            $values = EstoquePrateleira::where('id', 'in', $produto_enderecamento_estoque_prateleira_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_enderecamento_estoque_prateleira_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_enderecamento_estoque_prateleira_to_string = $produto_enderecamento_estoque_prateleira_to_string;
        }

        $this->vdata['produto_enderecamento_estoque_prateleira_to_string'] = $this->produto_enderecamento_estoque_prateleira_to_string;
    }

    public function get_produto_enderecamento_estoque_prateleira_to_string()
    {
        if(!empty($this->produto_enderecamento_estoque_prateleira_to_string))
        {
            return $this->produto_enderecamento_estoque_prateleira_to_string;
        }
    
        $values = ProdutoEnderecamento::where('estoque_prateleira_id', '=', $this->id)->getIndexedArray('estoque_prateleira_id','{estoque_prateleira->descricao}');
        return implode(', ', $values);
    }

    
}

