<?php

class EstoqueRua extends TRecord
{
    const TABLENAME  = 'estoque_rua';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $estoque_deposito;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('estoque_deposito_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito(EstoqueDeposito $object)
    {
        $this->estoque_deposito = $object;
        $this->estoque_deposito_id = $object->id;
    }

    /**
     * Method get_estoque_deposito
     * Sample of usage: $var->estoque_deposito->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito))
            $this->estoque_deposito = new EstoqueDeposito($this->estoque_deposito_id);
    
        // returns the associated object
        return $this->estoque_deposito;
    }

    /**
     * Method getEstoqueEstantes
     */
    public function getEstoqueEstantes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_rua_id', '=', $this->id));
        return EstoqueEstante::getObjects( $criteria );
    }

    public function set_estoque_estante_estoque_rua_to_string($estoque_estante_estoque_rua_to_string)
    {
        if(is_array($estoque_estante_estoque_rua_to_string))
        {
            $values = EstoqueRua::where('id', 'in', $estoque_estante_estoque_rua_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_estante_estoque_rua_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_estante_estoque_rua_to_string = $estoque_estante_estoque_rua_to_string;
        }

        $this->vdata['estoque_estante_estoque_rua_to_string'] = $this->estoque_estante_estoque_rua_to_string;
    }

    public function get_estoque_estante_estoque_rua_to_string()
    {
        if(!empty($this->estoque_estante_estoque_rua_to_string))
        {
            return $this->estoque_estante_estoque_rua_to_string;
        }
    
        $values = EstoqueEstante::where('estoque_rua_id', '=', $this->id)->getIndexedArray('estoque_rua_id','{estoque_rua->descricao}');
        return implode(', ', $values);
    }

    
}

