<?php

class EstoqueSaldos extends TRecord
{
    const TABLENAME  = 'estoque_saldos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto;
    private $system_unit;
    private $produto_lote;
    private $estoque_deposito;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('estoque_deposito_id');
        parent::addAttribute('produto_lote_id');
        parent::addAttribute('quant_disponivel');
        parent::addAttribute('quant_reservada');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('preco_medio_venda');
        parent::addAttribute('preco_medio_custo');
    
    }

    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_produto_lote
     * Sample of usage: $var->produto_lote = $object;
     * @param $object Instance of ProdutoLote
     */
    public function set_produto_lote(ProdutoLote $object)
    {
        $this->produto_lote = $object;
        $this->produto_lote_id = $object->id;
    }

    /**
     * Method get_produto_lote
     * Sample of usage: $var->produto_lote->attribute;
     * @returns ProdutoLote instance
     */
    public function get_produto_lote()
    {
    
        // loads the associated object
        if (empty($this->produto_lote))
            $this->produto_lote = new ProdutoLote($this->produto_lote_id);
    
        // returns the associated object
        return $this->produto_lote;
    }
    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito(EstoqueDeposito $object)
    {
        $this->estoque_deposito = $object;
        $this->estoque_deposito_id = $object->id;
    }

    /**
     * Method get_estoque_deposito
     * Sample of usage: $var->estoque_deposito->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito))
            $this->estoque_deposito = new EstoqueDeposito($this->estoque_deposito_id);
    
        // returns the associated object
        return $this->estoque_deposito;
    }

  public static function RecalculaSaldos()
  {
  
  }

  public static function VerificaEventoProdutoAbaixoDoMinimo($produto_id, $system_unit_id)
  {
      $produtoEstoque = VwProdutoEstoque::find($system_unit_id);

      if ($produtoEstoque)
      {
        if ($produtoEstoque->Quantidade_Disponivel <= $produtoEstoque->estoque_minimo)
        {
            Funcoes::VerificaNotificacaoEvento(TSession::getValue('userid'),
                                              Produto::Evento_ProdutoAbaixoDoMinimo,
                                              $produtoEstoque,
                                              $produtoEstoque->nome.
                                              ' - Qtd Disponivel: '.$produtoEstoque->Quantidade_Disponivel.
                                              ' - Estoque Mínimo: '.$produtoEstoque->estoque_minimo);                            
        }
      }
  }
  
  
        
}

