<?php

class EstoqueTipoMovimentacao extends TRecord
{
    const TABLENAME  = 'estoque_tipo_movimentacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Entrada = '1';
    const Saida = '2';
    const EntradaReserva = '3';
    const SaidaReserva = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_tipo_movimentacao_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }
    /**
     * Method getEstoqueOrigems
     */
    public function getEstoqueOrigems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('estoque_tipo_movimentacao_id', '=', $this->id));
        return EstoqueOrigem::getObjects( $criteria );
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_estoque_origem_estoque_tipo_movimentacao_to_string($estoque_origem_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_origem_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_origem_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_origem_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_origem_estoque_tipo_movimentacao_to_string = $estoque_origem_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_origem_estoque_tipo_movimentacao_to_string'] = $this->estoque_origem_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_origem_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_origem_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_origem_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueOrigem::where('estoque_tipo_movimentacao_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    
}

