<?php

class Eventos extends TRecord
{
    const TABLENAME  = 'eventos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $email_template;
    private $system_program;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_program_id');
        parent::addAttribute('descricao');
        parent::addAttribute('email_template_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_email_template
     * Sample of usage: $var->email_template = $object;
     * @param $object Instance of EmailTemplate
     */
    public function set_email_template(EmailTemplate $object)
    {
        $this->email_template = $object;
        $this->email_template_id = $object->id;
    }

    /**
     * Method get_email_template
     * Sample of usage: $var->email_template->attribute;
     * @returns EmailTemplate instance
     */
    public function get_email_template()
    {
    
        // loads the associated object
        if (empty($this->email_template))
            $this->email_template = new EmailTemplate($this->email_template_id);
    
        // returns the associated object
        return $this->email_template;
    }
    /**
     * Method set_system_program
     * Sample of usage: $var->system_program = $object;
     * @param $object Instance of SystemProgram
     */
    public function set_system_program(SystemProgram $object)
    {
        $this->system_program = $object;
        $this->system_program_id = $object->id;
    }

    /**
     * Method get_system_program
     * Sample of usage: $var->system_program->attribute;
     * @returns SystemProgram instance
     */
    public function get_system_program()
    {
    
        // loads the associated object
        if (empty($this->system_program))
            $this->system_program = new SystemProgram($this->system_program_id);
    
        // returns the associated object
        return $this->system_program;
    }

    /**
     * Method getEventosSystemusers
     */
    public function getEventosSystemusers()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('eventos_id', '=', $this->id));
        return EventosSystemuser::getObjects( $criteria );
    }

    public function set_eventos_systemuser_eventos_to_string($eventos_systemuser_eventos_to_string)
    {
        if(is_array($eventos_systemuser_eventos_to_string))
        {
            $values = Eventos::where('id', 'in', $eventos_systemuser_eventos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->eventos_systemuser_eventos_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_systemuser_eventos_to_string = $eventos_systemuser_eventos_to_string;
        }

        $this->vdata['eventos_systemuser_eventos_to_string'] = $this->eventos_systemuser_eventos_to_string;
    }

    public function get_eventos_systemuser_eventos_to_string()
    {
        if(!empty($this->eventos_systemuser_eventos_to_string))
        {
            return $this->eventos_systemuser_eventos_to_string;
        }
    
        $values = EventosSystemuser::where('eventos_id', '=', $this->id)->getIndexedArray('eventos_id','{eventos->descricao}');
        return implode(', ', $values);
    }

    public function set_eventos_systemuser_system_users_to_string($eventos_systemuser_system_users_to_string)
    {
        if(is_array($eventos_systemuser_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $eventos_systemuser_system_users_to_string)->getIndexedArray('name', 'name');
            $this->eventos_systemuser_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_systemuser_system_users_to_string = $eventos_systemuser_system_users_to_string;
        }

        $this->vdata['eventos_systemuser_system_users_to_string'] = $this->eventos_systemuser_system_users_to_string;
    }

    public function get_eventos_systemuser_system_users_to_string()
    {
        if(!empty($this->eventos_systemuser_system_users_to_string))
        {
            return $this->eventos_systemuser_system_users_to_string;
        }
    
        $values = EventosSystemuser::where('eventos_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_eventos_systemuser_system_unit_to_string($eventos_systemuser_system_unit_to_string)
    {
        if(is_array($eventos_systemuser_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $eventos_systemuser_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->eventos_systemuser_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_systemuser_system_unit_to_string = $eventos_systemuser_system_unit_to_string;
        }

        $this->vdata['eventos_systemuser_system_unit_to_string'] = $this->eventos_systemuser_system_unit_to_string;
    }

    public function get_eventos_systemuser_system_unit_to_string()
    {
        if(!empty($this->eventos_systemuser_system_unit_to_string))
        {
            return $this->eventos_systemuser_system_unit_to_string;
        }
    
        $values = EventosSystemuser::where('eventos_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

  
  public static function CarregaEventos()
  {
      TTransaction::open('kraftsoft');
  
      UnidadeMedida::SincronizaEventos();
      NotaFiscalCompra::SincronizaEventos();
      Contaspag::SincronizaEventos();
      Contasrec::SincronizaEventos();
      CertificadoVenda::SincronizaEventos();
      Negocio::SincronizaEventos();   
      Produto::SincronizaEventos();   
  
      TTransaction::close(); 
  } 
 
  public static function ProcessaEventos($system_program, $descricao_evento)
  {
      //buscar se tem a tela no banco de dados...
      $system_program = SystemProgram::where('controller', '=', $system_program)->first();
  
      if ($system_program)
      {
        $eventos = Eventos::where('system_program_id', '=', $system_program->id)
                          ->where('descricao', '=', $descricao_evento)->first();
                                        
        if (!$eventos)                                
        {
            $novo_evento = new Eventos;
            $novo_evento->system_program_id = $system_program->id;
            $novo_evento->descricao = $descricao_evento;
            $novo_evento->criado_por = TSession::getValue('username');
            $novo_evento->store();
        }
      }      
  }  
  
  
                        
}

