<?php

class FormaPagamento extends TRecord
{
    const TABLENAME  = 'forma_pagamento';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $tipo_documento;
    private $meio_pagamento_tef;
    private $notafiscal_tpag;

    

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('codigo_interno');
        parent::addAttribute('tipo_documento_id');
        parent::addAttribute('meio_pagamento_tef_id');
        parent::addAttribute('notafiscal_tpag_id');
        parent::addAttribute('descricao');
        parent::addAttribute('prazo_pagamento');
        parent::addAttribute('taxa');
        parent::addAttribute('deletado_em');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
        parent::addAttribute('utiliza_pdv');
        parent::addAttribute('obriga_nf_pdv');
            
    }

    /**
     * Method set_tipo_documento
     * Sample of usage: $var->tipo_documento = $object;
     * @param $object Instance of TipoDocumento
     */
    public function set_tipo_documento(TipoDocumento $object)
    {
        $this->tipo_documento = $object;
        $this->tipo_documento_id = $object->id;
    }

    /**
     * Method get_tipo_documento
     * Sample of usage: $var->tipo_documento->attribute;
     * @returns TipoDocumento instance
     */
    public function get_tipo_documento()
    {
    
        // loads the associated object
        if (empty($this->tipo_documento))
            $this->tipo_documento = new TipoDocumento($this->tipo_documento_id);
    
        // returns the associated object
        return $this->tipo_documento;
    }
    /**
     * Method set_meio_pagamento_tef
     * Sample of usage: $var->meio_pagamento_tef = $object;
     * @param $object Instance of MeioPagamentoTef
     */
    public function set_meio_pagamento_tef(MeioPagamentoTef $object)
    {
        $this->meio_pagamento_tef = $object;
        $this->meio_pagamento_tef_id = $object->id;
    }

    /**
     * Method get_meio_pagamento_tef
     * Sample of usage: $var->meio_pagamento_tef->attribute;
     * @returns MeioPagamentoTef instance
     */
    public function get_meio_pagamento_tef()
    {
    
        // loads the associated object
        if (empty($this->meio_pagamento_tef))
            $this->meio_pagamento_tef = new MeioPagamentoTef($this->meio_pagamento_tef_id);
    
        // returns the associated object
        return $this->meio_pagamento_tef;
    }
    /**
     * Method set_notafiscal_tpag
     * Sample of usage: $var->notafiscal_tpag = $object;
     * @param $object Instance of NotafiscalTpag
     */
    public function set_notafiscal_tpag(NotafiscalTpag $object)
    {
        $this->notafiscal_tpag = $object;
        $this->notafiscal_tpag_id = $object->id;
    }

    /**
     * Method get_notafiscal_tpag
     * Sample of usage: $var->notafiscal_tpag->attribute;
     * @returns NotafiscalTpag instance
     */
    public function get_notafiscal_tpag()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tpag))
            $this->notafiscal_tpag = new NotafiscalTpag($this->notafiscal_tpag_id);
    
        // returns the associated object
        return $this->notafiscal_tpag;
    }

    /**
     * Method getCaixaLancamentoss
     */
    public function getCaixaLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return CaixaLancamentos::getObjects( $criteria );
    }
    /**
     * Method getCertificadoVendaFormapgtos
     */
    public function getCertificadoVendaFormapgtos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return CertificadoVendaFormapgto::getObjects( $criteria );
    }
    /**
     * Method getConfiguracoess
     */
    public function getConfiguracoessByFormaPagamentoDinheiroCaixas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id_dinheiro_caixa', '=', $this->id));
        return Configuracoes::getObjects( $criteria );
    }
    /**
     * Method getConfiguracoess
     */
    public function getConfiguracoessByFormaPagamentoTitulosCpagNfs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id_titulos_cpag_nf', '=', $this->id));
        return Configuracoes::getObjects( $criteria );
    }
    /**
     * Method getContaspags
     */
    public function getContaspags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return Contaspag::getObjects( $criteria );
    }
    /**
     * Method getContaspagBlocos
     */
    public function getContaspagBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return ContaspagBloco::getObjects( $criteria );
    }
    /**
     * Method getContasrecs
     */
    public function getContasrecs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return Contasrec::getObjects( $criteria );
    }
    /**
     * Method getContasrecBlocos
     */
    public function getContasrecBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return ContasrecBloco::getObjects( $criteria );
    }
    /**
     * Method getFormapgtoCondpgtos
     */
    public function getFormapgtoCondpgtos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return FormapgtoCondpgto::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraDups
     */
    public function getNotaFiscalCompraDups()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return NotaFiscalCompraDup::getObjects( $criteria );
    }
    /**
     * Method getServicoFormapgtos
     */
    public function getServicoFormapgtos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return ServicoFormapgto::getObjects( $criteria );
    }
    /**
     * Method getVendaFormapgtos
     */
    public function getVendaFormapgtos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('forma_pagamento_id', '=', $this->id));
        return VendaFormapgto::getObjects( $criteria );
    }

    public function set_caixa_lancamentos_caixa_to_string($caixa_lancamentos_caixa_to_string)
    {
        if(is_array($caixa_lancamentos_caixa_to_string))
        {
            $values = Caixa::where('id', 'in', $caixa_lancamentos_caixa_to_string)->getIndexedArray('id', 'id');
            $this->caixa_lancamentos_caixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_caixa_to_string = $caixa_lancamentos_caixa_to_string;
        }

        $this->vdata['caixa_lancamentos_caixa_to_string'] = $this->caixa_lancamentos_caixa_to_string;
    }

    public function get_caixa_lancamentos_caixa_to_string()
    {
        if(!empty($this->caixa_lancamentos_caixa_to_string))
        {
            return $this->caixa_lancamentos_caixa_to_string;
        }
    
        $values = CaixaLancamentos::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('caixa_id','{caixa->id}');
        return implode(', ', $values);
    }

    public function set_caixa_lancamentos_forma_pagamento_to_string($caixa_lancamentos_forma_pagamento_to_string)
    {
        if(is_array($caixa_lancamentos_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $caixa_lancamentos_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->caixa_lancamentos_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_forma_pagamento_to_string = $caixa_lancamentos_forma_pagamento_to_string;
        }

        $this->vdata['caixa_lancamentos_forma_pagamento_to_string'] = $this->caixa_lancamentos_forma_pagamento_to_string;
    }

    public function get_caixa_lancamentos_forma_pagamento_to_string()
    {
        if(!empty($this->caixa_lancamentos_forma_pagamento_to_string))
        {
            return $this->caixa_lancamentos_forma_pagamento_to_string;
        }
    
        $values = CaixaLancamentos::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_caixa_lancamentos_caixa_tipo_lancamento_to_string($caixa_lancamentos_caixa_tipo_lancamento_to_string)
    {
        if(is_array($caixa_lancamentos_caixa_tipo_lancamento_to_string))
        {
            $values = CaixaTipoLancamento::where('id', 'in', $caixa_lancamentos_caixa_tipo_lancamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->caixa_lancamentos_caixa_tipo_lancamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_caixa_tipo_lancamento_to_string = $caixa_lancamentos_caixa_tipo_lancamento_to_string;
        }

        $this->vdata['caixa_lancamentos_caixa_tipo_lancamento_to_string'] = $this->caixa_lancamentos_caixa_tipo_lancamento_to_string;
    }

    public function get_caixa_lancamentos_caixa_tipo_lancamento_to_string()
    {
        if(!empty($this->caixa_lancamentos_caixa_tipo_lancamento_to_string))
        {
            return $this->caixa_lancamentos_caixa_tipo_lancamento_to_string;
        }
    
        $values = CaixaLancamentos::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('caixa_tipo_lancamento_id','{caixa_tipo_lancamento->descricao}');
        return implode(', ', $values);
    }

    public function set_caixa_lancamentos_system_users_to_string($caixa_lancamentos_system_users_to_string)
    {
        if(is_array($caixa_lancamentos_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_lancamentos_system_users_to_string)->getIndexedArray('name', 'name');
            $this->caixa_lancamentos_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_lancamentos_system_users_to_string = $caixa_lancamentos_system_users_to_string;
        }

        $this->vdata['caixa_lancamentos_system_users_to_string'] = $this->caixa_lancamentos_system_users_to_string;
    }

    public function get_caixa_lancamentos_system_users_to_string()
    {
        if(!empty($this->caixa_lancamentos_system_users_to_string))
        {
            return $this->caixa_lancamentos_system_users_to_string;
        }
    
        $values = CaixaLancamentos::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_formapgto_certificado_venda_to_string($certificado_venda_formapgto_certificado_venda_to_string)
    {
        if(is_array($certificado_venda_formapgto_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_venda_formapgto_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_venda_formapgto_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_formapgto_certificado_venda_to_string = $certificado_venda_formapgto_certificado_venda_to_string;
        }

        $this->vdata['certificado_venda_formapgto_certificado_venda_to_string'] = $this->certificado_venda_formapgto_certificado_venda_to_string;
    }

    public function get_certificado_venda_formapgto_certificado_venda_to_string()
    {
        if(!empty($this->certificado_venda_formapgto_certificado_venda_to_string))
        {
            return $this->certificado_venda_formapgto_certificado_venda_to_string;
        }
    
        $values = CertificadoVendaFormapgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_formapgto_forma_pagamento_to_string($certificado_venda_formapgto_forma_pagamento_to_string)
    {
        if(is_array($certificado_venda_formapgto_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $certificado_venda_formapgto_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_formapgto_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_formapgto_forma_pagamento_to_string = $certificado_venda_formapgto_forma_pagamento_to_string;
        }

        $this->vdata['certificado_venda_formapgto_forma_pagamento_to_string'] = $this->certificado_venda_formapgto_forma_pagamento_to_string;
    }

    public function get_certificado_venda_formapgto_forma_pagamento_to_string()
    {
        if(!empty($this->certificado_venda_formapgto_forma_pagamento_to_string))
        {
            return $this->certificado_venda_formapgto_forma_pagamento_to_string;
        }
    
        $values = CertificadoVendaFormapgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_forma_pagamento_dinheiro_caixa_to_string($configuracoes_forma_pagamento_dinheiro_caixa_to_string)
    {
        if(is_array($configuracoes_forma_pagamento_dinheiro_caixa_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $configuracoes_forma_pagamento_dinheiro_caixa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_forma_pagamento_dinheiro_caixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_forma_pagamento_dinheiro_caixa_to_string = $configuracoes_forma_pagamento_dinheiro_caixa_to_string;
        }

        $this->vdata['configuracoes_forma_pagamento_dinheiro_caixa_to_string'] = $this->configuracoes_forma_pagamento_dinheiro_caixa_to_string;
    }

    public function get_configuracoes_forma_pagamento_dinheiro_caixa_to_string()
    {
        if(!empty($this->configuracoes_forma_pagamento_dinheiro_caixa_to_string))
        {
            return $this->configuracoes_forma_pagamento_dinheiro_caixa_to_string;
        }
    
        $values = Configuracoes::where('forma_pagamento_id_titulos_cpag_nf', '=', $this->id)->getIndexedArray('forma_pagamento_id_dinheiro_caixa','{forma_pagamento_dinheiro_caixa->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_forma_pagamento_titulos_cpag_nf_to_string($configuracoes_forma_pagamento_titulos_cpag_nf_to_string)
    {
        if(is_array($configuracoes_forma_pagamento_titulos_cpag_nf_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $configuracoes_forma_pagamento_titulos_cpag_nf_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_forma_pagamento_titulos_cpag_nf_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_forma_pagamento_titulos_cpag_nf_to_string = $configuracoes_forma_pagamento_titulos_cpag_nf_to_string;
        }

        $this->vdata['configuracoes_forma_pagamento_titulos_cpag_nf_to_string'] = $this->configuracoes_forma_pagamento_titulos_cpag_nf_to_string;
    }

    public function get_configuracoes_forma_pagamento_titulos_cpag_nf_to_string()
    {
        if(!empty($this->configuracoes_forma_pagamento_titulos_cpag_nf_to_string))
        {
            return $this->configuracoes_forma_pagamento_titulos_cpag_nf_to_string;
        }
    
        $values = Configuracoes::where('forma_pagamento_id_titulos_cpag_nf', '=', $this->id)->getIndexedArray('forma_pagamento_id_titulos_cpag_nf','{forma_pagamento_titulos_cpag_nf->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_situacao_to_string($contaspag_contaspag_situacao_to_string)
    {
        if(is_array($contaspag_contaspag_situacao_to_string))
        {
            $values = ContaspagSituacao::where('id', 'in', $contaspag_contaspag_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_situacao_to_string = $contaspag_contaspag_situacao_to_string;
        }

        $this->vdata['contaspag_contaspag_situacao_to_string'] = $this->contaspag_contaspag_situacao_to_string;
    }

    public function get_contaspag_contaspag_situacao_to_string()
    {
        if(!empty($this->contaspag_contaspag_situacao_to_string))
        {
            return $this->contaspag_contaspag_situacao_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('contaspag_situacao_id','{contaspag_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_forma_pagamento_to_string($contaspag_forma_pagamento_to_string)
    {
        if(is_array($contaspag_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_forma_pagamento_to_string = $contaspag_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_forma_pagamento_to_string'] = $this->contaspag_forma_pagamento_to_string;
    }

    public function get_contaspag_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_forma_pagamento_to_string))
        {
            return $this->contaspag_forma_pagamento_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_fornecedor_to_string($contaspag_fornecedor_to_string)
    {
        if(is_array($contaspag_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_fornecedor_to_string = $contaspag_fornecedor_to_string;
        }

        $this->vdata['contaspag_fornecedor_to_string'] = $this->contaspag_fornecedor_to_string;
    }

    public function get_contaspag_fornecedor_to_string()
    {
        if(!empty($this->contaspag_fornecedor_to_string))
        {
            return $this->contaspag_fornecedor_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_origem_to_string($contaspag_contaspag_origem_to_string)
    {
        if(is_array($contaspag_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_origem_to_string = $contaspag_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_contaspag_origem_to_string'] = $this->contaspag_contaspag_origem_to_string;
    }

    public function get_contaspag_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_contaspag_origem_to_string))
        {
            return $this->contaspag_contaspag_origem_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_system_unit_to_string($contaspag_system_unit_to_string)
    {
        if(is_array($contaspag_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_system_unit_to_string = $contaspag_system_unit_to_string;
        }

        $this->vdata['contaspag_system_unit_to_string'] = $this->contaspag_system_unit_to_string;
    }

    public function get_contaspag_system_unit_to_string()
    {
        if(!empty($this->contaspag_system_unit_to_string))
        {
            return $this->contaspag_system_unit_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contaspag_cheque_banco_to_string($contaspag_cheque_banco_to_string)
    {
        if(is_array($contaspag_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contaspag_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_cheque_banco_to_string = $contaspag_cheque_banco_to_string;
        }

        $this->vdata['contaspag_cheque_banco_to_string'] = $this->contaspag_cheque_banco_to_string;
    }

    public function get_contaspag_cheque_banco_to_string()
    {
        if(!empty($this->contaspag_cheque_banco_to_string))
        {
            return $this->contaspag_cheque_banco_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_bloco_to_string($contaspag_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_bloco_to_string = $contaspag_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_contaspag_bloco_to_string'] = $this->contaspag_contaspag_bloco_to_string;
    }

    public function get_contaspag_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_contaspag_bloco_to_string))
        {
            return $this->contaspag_contaspag_bloco_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_nota_fiscal_compra_to_string($contaspag_nota_fiscal_compra_to_string)
    {
        if(is_array($contaspag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $contaspag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_nota_fiscal_compra_to_string = $contaspag_nota_fiscal_compra_to_string;
        }

        $this->vdata['contaspag_nota_fiscal_compra_to_string'] = $this->contaspag_nota_fiscal_compra_to_string;
    }

    public function get_contaspag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->contaspag_nota_fiscal_compra_to_string))
        {
            return $this->contaspag_nota_fiscal_compra_to_string;
        }
    
        $values = Contaspag::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_fornecedor_to_string($contaspag_bloco_fornecedor_to_string)
    {
        if(is_array($contaspag_bloco_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_bloco_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_bloco_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_fornecedor_to_string = $contaspag_bloco_fornecedor_to_string;
        }

        $this->vdata['contaspag_bloco_fornecedor_to_string'] = $this->contaspag_bloco_fornecedor_to_string;
    }

    public function get_contaspag_bloco_fornecedor_to_string()
    {
        if(!empty($this->contaspag_bloco_fornecedor_to_string))
        {
            return $this->contaspag_bloco_fornecedor_to_string;
        }
    
        $values = ContaspagBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_forma_pagamento_to_string($contaspag_bloco_forma_pagamento_to_string)
    {
        if(is_array($contaspag_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_forma_pagamento_to_string = $contaspag_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_bloco_forma_pagamento_to_string'] = $this->contaspag_bloco_forma_pagamento_to_string;
    }

    public function get_contaspag_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_bloco_forma_pagamento_to_string))
        {
            return $this->contaspag_bloco_forma_pagamento_to_string;
        }
    
        $values = ContaspagBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contaspag_origem_to_string($contaspag_bloco_contaspag_origem_to_string)
    {
        if(is_array($contaspag_bloco_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_bloco_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contaspag_origem_to_string = $contaspag_bloco_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_bloco_contaspag_origem_to_string'] = $this->contaspag_bloco_contaspag_origem_to_string;
    }

    public function get_contaspag_bloco_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_bloco_contaspag_origem_to_string))
        {
            return $this->contaspag_bloco_contaspag_origem_to_string;
        }
    
        $values = ContaspagBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_system_unit_to_string($contaspag_bloco_system_unit_to_string)
    {
        if(is_array($contaspag_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_system_unit_to_string = $contaspag_bloco_system_unit_to_string;
        }

        $this->vdata['contaspag_bloco_system_unit_to_string'] = $this->contaspag_bloco_system_unit_to_string;
    }

    public function get_contaspag_bloco_system_unit_to_string()
    {
        if(!empty($this->contaspag_bloco_system_unit_to_string))
        {
            return $this->contaspag_bloco_system_unit_to_string;
        }
    
        $values = ContaspagBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_system_unit_to_string($contasrec_system_unit_to_string)
    {
        if(is_array($contasrec_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_system_unit_to_string = $contasrec_system_unit_to_string;
        }

        $this->vdata['contasrec_system_unit_to_string'] = $this->contasrec_system_unit_to_string;
    }

    public function get_contasrec_system_unit_to_string()
    {
        if(!empty($this->contasrec_system_unit_to_string))
        {
            return $this->contasrec_system_unit_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_cliente_to_string($contasrec_cliente_to_string)
    {
        if(is_array($contasrec_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cliente_to_string = $contasrec_cliente_to_string;
        }

        $this->vdata['contasrec_cliente_to_string'] = $this->contasrec_cliente_to_string;
    }

    public function get_contasrec_cliente_to_string()
    {
        if(!empty($this->contasrec_cliente_to_string))
        {
            return $this->contasrec_cliente_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_forma_pagamento_to_string($contasrec_forma_pagamento_to_string)
    {
        if(is_array($contasrec_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_forma_pagamento_to_string = $contasrec_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_forma_pagamento_to_string'] = $this->contasrec_forma_pagamento_to_string;
    }

    public function get_contasrec_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_forma_pagamento_to_string))
        {
            return $this->contasrec_forma_pagamento_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_situacao_to_string($contasrec_contasrec_situacao_to_string)
    {
        if(is_array($contasrec_contasrec_situacao_to_string))
        {
            $values = ContasrecSituacao::where('id', 'in', $contasrec_contasrec_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_situacao_to_string = $contasrec_contasrec_situacao_to_string;
        }

        $this->vdata['contasrec_contasrec_situacao_to_string'] = $this->contasrec_contasrec_situacao_to_string;
    }

    public function get_contasrec_contasrec_situacao_to_string()
    {
        if(!empty($this->contasrec_contasrec_situacao_to_string))
        {
            return $this->contasrec_contasrec_situacao_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('contasrec_situacao_id','{contasrec_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_plano_conta_to_string($contasrec_plano_conta_to_string)
    {
        if(is_array($contasrec_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_plano_conta_to_string = $contasrec_plano_conta_to_string;
        }

        $this->vdata['contasrec_plano_conta_to_string'] = $this->contasrec_plano_conta_to_string;
    }

    public function get_contasrec_plano_conta_to_string()
    {
        if(!empty($this->contasrec_plano_conta_to_string))
        {
            return $this->contasrec_plano_conta_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_centro_custo_to_string($contasrec_centro_custo_to_string)
    {
        if(is_array($contasrec_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_centro_custo_to_string = $contasrec_centro_custo_to_string;
        }

        $this->vdata['contasrec_centro_custo_to_string'] = $this->contasrec_centro_custo_to_string;
    }

    public function get_contasrec_centro_custo_to_string()
    {
        if(!empty($this->contasrec_centro_custo_to_string))
        {
            return $this->contasrec_centro_custo_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_origem_to_string($contasrec_contasrec_origem_to_string)
    {
        if(is_array($contasrec_contasrec_origem_to_string))
        {
            $values = ContasrecOrigem::where('id', 'in', $contasrec_contasrec_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_origem_to_string = $contasrec_contasrec_origem_to_string;
        }

        $this->vdata['contasrec_contasrec_origem_to_string'] = $this->contasrec_contasrec_origem_to_string;
    }

    public function get_contasrec_contasrec_origem_to_string()
    {
        if(!empty($this->contasrec_contasrec_origem_to_string))
        {
            return $this->contasrec_contasrec_origem_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('contasrec_origem_id','{contasrec_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_cheque_banco_to_string($contasrec_cheque_banco_to_string)
    {
        if(is_array($contasrec_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contasrec_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cheque_banco_to_string = $contasrec_cheque_banco_to_string;
        }

        $this->vdata['contasrec_cheque_banco_to_string'] = $this->contasrec_cheque_banco_to_string;
    }

    public function get_contasrec_cheque_banco_to_string()
    {
        if(!empty($this->contasrec_cheque_banco_to_string))
        {
            return $this->contasrec_cheque_banco_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_conta_corrente_boleto_to_string($contasrec_conta_corrente_boleto_to_string)
    {
        if(is_array($contasrec_conta_corrente_boleto_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_conta_corrente_boleto_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_conta_corrente_boleto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_conta_corrente_boleto_to_string = $contasrec_conta_corrente_boleto_to_string;
        }

        $this->vdata['contasrec_conta_corrente_boleto_to_string'] = $this->contasrec_conta_corrente_boleto_to_string;
    }

    public function get_contasrec_conta_corrente_boleto_to_string()
    {
        if(!empty($this->contasrec_conta_corrente_boleto_to_string))
        {
            return $this->contasrec_conta_corrente_boleto_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('conta_corrente_boleto_id','{conta_corrente_boleto->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_boleto_situacao_to_string($contasrec_boleto_situacao_to_string)
    {
        if(is_array($contasrec_boleto_situacao_to_string))
        {
            $values = BoletoSituacao::where('id', 'in', $contasrec_boleto_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_boleto_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_boleto_situacao_to_string = $contasrec_boleto_situacao_to_string;
        }

        $this->vdata['contasrec_boleto_situacao_to_string'] = $this->contasrec_boleto_situacao_to_string;
    }

    public function get_contasrec_boleto_situacao_to_string()
    {
        if(!empty($this->contasrec_boleto_situacao_to_string))
        {
            return $this->contasrec_boleto_situacao_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('boleto_situacao_id','{boleto_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_vendedor_to_string($contasrec_vendedor_to_string)
    {
        if(is_array($contasrec_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $contasrec_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_vendedor_to_string = $contasrec_vendedor_to_string;
        }

        $this->vdata['contasrec_vendedor_to_string'] = $this->contasrec_vendedor_to_string;
    }

    public function get_contasrec_vendedor_to_string()
    {
        if(!empty($this->contasrec_vendedor_to_string))
        {
            return $this->contasrec_vendedor_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_bloco_to_string($contasrec_contasrec_bloco_to_string)
    {
        if(is_array($contasrec_contasrec_bloco_to_string))
        {
            $values = ContasrecBloco::where('id', 'in', $contasrec_contasrec_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_contasrec_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_bloco_to_string = $contasrec_contasrec_bloco_to_string;
        }

        $this->vdata['contasrec_contasrec_bloco_to_string'] = $this->contasrec_contasrec_bloco_to_string;
    }

    public function get_contasrec_contasrec_bloco_to_string()
    {
        if(!empty($this->contasrec_contasrec_bloco_to_string))
        {
            return $this->contasrec_contasrec_bloco_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('contasrec_bloco_id','{contasrec_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_venda_formapgto_to_string($contasrec_venda_formapgto_to_string)
    {
        if(is_array($contasrec_venda_formapgto_to_string))
        {
            $values = VendaFormapgto::where('id', 'in', $contasrec_venda_formapgto_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_venda_formapgto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_venda_formapgto_to_string = $contasrec_venda_formapgto_to_string;
        }

        $this->vdata['contasrec_venda_formapgto_to_string'] = $this->contasrec_venda_formapgto_to_string;
    }

    public function get_contasrec_venda_formapgto_to_string()
    {
        if(!empty($this->contasrec_venda_formapgto_to_string))
        {
            return $this->contasrec_venda_formapgto_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('venda_formapgto_id','{venda_formapgto->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_ativo_to_string($contasrec_ativo_to_string)
    {
        if(is_array($contasrec_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $contasrec_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_ativo_to_string = $contasrec_ativo_to_string;
        }

        $this->vdata['contasrec_ativo_to_string'] = $this->contasrec_ativo_to_string;
    }

    public function get_contasrec_ativo_to_string()
    {
        if(!empty($this->contasrec_ativo_to_string))
        {
            return $this->contasrec_ativo_to_string;
        }
    
        $values = Contasrec::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_cliente_to_string($contasrec_bloco_cliente_to_string)
    {
        if(is_array($contasrec_bloco_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_bloco_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_bloco_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_cliente_to_string = $contasrec_bloco_cliente_to_string;
        }

        $this->vdata['contasrec_bloco_cliente_to_string'] = $this->contasrec_bloco_cliente_to_string;
    }

    public function get_contasrec_bloco_cliente_to_string()
    {
        if(!empty($this->contasrec_bloco_cliente_to_string))
        {
            return $this->contasrec_bloco_cliente_to_string;
        }
    
        $values = ContasrecBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_forma_pagamento_to_string($contasrec_bloco_forma_pagamento_to_string)
    {
        if(is_array($contasrec_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_forma_pagamento_to_string = $contasrec_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_bloco_forma_pagamento_to_string'] = $this->contasrec_bloco_forma_pagamento_to_string;
    }

    public function get_contasrec_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_bloco_forma_pagamento_to_string))
        {
            return $this->contasrec_bloco_forma_pagamento_to_string;
        }
    
        $values = ContasrecBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_system_unit_to_string($contasrec_bloco_system_unit_to_string)
    {
        if(is_array($contasrec_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_system_unit_to_string = $contasrec_bloco_system_unit_to_string;
        }

        $this->vdata['contasrec_bloco_system_unit_to_string'] = $this->contasrec_bloco_system_unit_to_string;
    }

    public function get_contasrec_bloco_system_unit_to_string()
    {
        if(!empty($this->contasrec_bloco_system_unit_to_string))
        {
            return $this->contasrec_bloco_system_unit_to_string;
        }
    
        $values = ContasrecBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_plano_conta_to_string($contasrec_bloco_plano_conta_to_string)
    {
        if(is_array($contasrec_bloco_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_bloco_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_plano_conta_to_string = $contasrec_bloco_plano_conta_to_string;
        }

        $this->vdata['contasrec_bloco_plano_conta_to_string'] = $this->contasrec_bloco_plano_conta_to_string;
    }

    public function get_contasrec_bloco_plano_conta_to_string()
    {
        if(!empty($this->contasrec_bloco_plano_conta_to_string))
        {
            return $this->contasrec_bloco_plano_conta_to_string;
        }
    
        $values = ContasrecBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_centro_custo_to_string($contasrec_bloco_centro_custo_to_string)
    {
        if(is_array($contasrec_bloco_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_bloco_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_centro_custo_to_string = $contasrec_bloco_centro_custo_to_string;
        }

        $this->vdata['contasrec_bloco_centro_custo_to_string'] = $this->contasrec_bloco_centro_custo_to_string;
    }

    public function get_contasrec_bloco_centro_custo_to_string()
    {
        if(!empty($this->contasrec_bloco_centro_custo_to_string))
        {
            return $this->contasrec_bloco_centro_custo_to_string;
        }
    
        $values = ContasrecBloco::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_formapgto_condpgto_condicao_pagamento_to_string($formapgto_condpgto_condicao_pagamento_to_string)
    {
        if(is_array($formapgto_condpgto_condicao_pagamento_to_string))
        {
            $values = CondicaoPagamento::where('id', 'in', $formapgto_condpgto_condicao_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->formapgto_condpgto_condicao_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->formapgto_condpgto_condicao_pagamento_to_string = $formapgto_condpgto_condicao_pagamento_to_string;
        }

        $this->vdata['formapgto_condpgto_condicao_pagamento_to_string'] = $this->formapgto_condpgto_condicao_pagamento_to_string;
    }

    public function get_formapgto_condpgto_condicao_pagamento_to_string()
    {
        if(!empty($this->formapgto_condpgto_condicao_pagamento_to_string))
        {
            return $this->formapgto_condpgto_condicao_pagamento_to_string;
        }
    
        $values = FormapgtoCondpgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('condicao_pagamento_id','{condicao_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_formapgto_condpgto_forma_pagamento_to_string($formapgto_condpgto_forma_pagamento_to_string)
    {
        if(is_array($formapgto_condpgto_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $formapgto_condpgto_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->formapgto_condpgto_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->formapgto_condpgto_forma_pagamento_to_string = $formapgto_condpgto_forma_pagamento_to_string;
        }

        $this->vdata['formapgto_condpgto_forma_pagamento_to_string'] = $this->formapgto_condpgto_forma_pagamento_to_string;
    }

    public function get_formapgto_condpgto_forma_pagamento_to_string()
    {
        if(!empty($this->formapgto_condpgto_forma_pagamento_to_string))
        {
            return $this->formapgto_condpgto_forma_pagamento_to_string;
        }
    
        $values = FormapgtoCondpgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_nota_fiscal_compra_to_string($nota_fiscal_compra_dup_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_dup_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string = $nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_dup_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_forma_pagamento_to_string($nota_fiscal_compra_dup_forma_pagamento_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $nota_fiscal_compra_dup_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_forma_pagamento_to_string = $nota_fiscal_compra_dup_forma_pagamento_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_forma_pagamento_to_string'] = $this->nota_fiscal_compra_dup_forma_pagamento_to_string;
    }

    public function get_nota_fiscal_compra_dup_forma_pagamento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_forma_pagamento_to_string))
        {
            return $this->nota_fiscal_compra_dup_forma_pagamento_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_plano_conta_to_string($nota_fiscal_compra_dup_plano_conta_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $nota_fiscal_compra_dup_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_plano_conta_to_string = $nota_fiscal_compra_dup_plano_conta_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_plano_conta_to_string'] = $this->nota_fiscal_compra_dup_plano_conta_to_string;
    }

    public function get_nota_fiscal_compra_dup_plano_conta_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_plano_conta_to_string))
        {
            return $this->nota_fiscal_compra_dup_plano_conta_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_centro_custo_to_string($nota_fiscal_compra_dup_centro_custo_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $nota_fiscal_compra_dup_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_centro_custo_to_string = $nota_fiscal_compra_dup_centro_custo_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_centro_custo_to_string'] = $this->nota_fiscal_compra_dup_centro_custo_to_string;
    }

    public function get_nota_fiscal_compra_dup_centro_custo_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_centro_custo_to_string))
        {
            return $this->nota_fiscal_compra_dup_centro_custo_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_servico_formapgto_forma_pagamento_to_string($servico_formapgto_forma_pagamento_to_string)
    {
        if(is_array($servico_formapgto_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $servico_formapgto_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->servico_formapgto_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->servico_formapgto_forma_pagamento_to_string = $servico_formapgto_forma_pagamento_to_string;
        }

        $this->vdata['servico_formapgto_forma_pagamento_to_string'] = $this->servico_formapgto_forma_pagamento_to_string;
    }

    public function get_servico_formapgto_forma_pagamento_to_string()
    {
        if(!empty($this->servico_formapgto_forma_pagamento_to_string))
        {
            return $this->servico_formapgto_forma_pagamento_to_string;
        }
    
        $values = ServicoFormapgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_servico_formapgto_ordem_servico_to_string($servico_formapgto_ordem_servico_to_string)
    {
        if(is_array($servico_formapgto_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $servico_formapgto_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->servico_formapgto_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->servico_formapgto_ordem_servico_to_string = $servico_formapgto_ordem_servico_to_string;
        }

        $this->vdata['servico_formapgto_ordem_servico_to_string'] = $this->servico_formapgto_ordem_servico_to_string;
    }

    public function get_servico_formapgto_ordem_servico_to_string()
    {
        if(!empty($this->servico_formapgto_ordem_servico_to_string))
        {
            return $this->servico_formapgto_ordem_servico_to_string;
        }
    
        $values = ServicoFormapgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function set_venda_formapgto_forma_pagamento_to_string($venda_formapgto_forma_pagamento_to_string)
    {
        if(is_array($venda_formapgto_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $venda_formapgto_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_formapgto_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_formapgto_forma_pagamento_to_string = $venda_formapgto_forma_pagamento_to_string;
        }

        $this->vdata['venda_formapgto_forma_pagamento_to_string'] = $this->venda_formapgto_forma_pagamento_to_string;
    }

    public function get_venda_formapgto_forma_pagamento_to_string()
    {
        if(!empty($this->venda_formapgto_forma_pagamento_to_string))
        {
            return $this->venda_formapgto_forma_pagamento_to_string;
        }
    
        $values = VendaFormapgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_formapgto_venda_to_string($venda_formapgto_venda_to_string)
    {
        if(is_array($venda_formapgto_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_formapgto_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_formapgto_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_formapgto_venda_to_string = $venda_formapgto_venda_to_string;
        }

        $this->vdata['venda_formapgto_venda_to_string'] = $this->venda_formapgto_venda_to_string;
    }

    public function get_venda_formapgto_venda_to_string()
    {
        if(!empty($this->venda_formapgto_venda_to_string))
        {
            return $this->venda_formapgto_venda_to_string;
        }
    
        $values = VendaFormapgto::where('forma_pagamento_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    
}

