<?php

class Fornecedor extends TRecord
{
    const TABLENAME  = 'fornecedor';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $fornecedor_classificacao;
    private $pessoa_tipo;
    private $cidade;
    private $notafiscal_crt;
    private $notafiscal_indiedest;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('pessoa_tipo_id');
        parent::addAttribute('fornecedor_classificacao_id');
        parent::addAttribute('nome');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('insc_estadual');
        parent::addAttribute('insc_municipal');
        parent::addAttribute('cpf_cnpj');
        parent::addAttribute('razao_social');
        parent::addAttribute('logradouro');
        parent::addAttribute('cidade_id');
        parent::addAttribute('bairro');
        parent::addAttribute('cep');
        parent::addAttribute('numero');
        parent::addAttribute('complemento');
        parent::addAttribute('fone');
        parent::addAttribute('email');
        parent::addAttribute('site');
        parent::addAttribute('observacoes');
        parent::addAttribute('notafiscal_crt_id');
        parent::addAttribute('deletado_em');
        parent::addAttribute('notafiscal_indiedest_id');
            
    }

    /**
     * Method set_fornecedor_classificacao
     * Sample of usage: $var->fornecedor_classificacao = $object;
     * @param $object Instance of FornecedorClassificacao
     */
    public function set_fornecedor_classificacao(FornecedorClassificacao $object)
    {
        $this->fornecedor_classificacao = $object;
        $this->fornecedor_classificacao_id = $object->id;
    }

    /**
     * Method get_fornecedor_classificacao
     * Sample of usage: $var->fornecedor_classificacao->attribute;
     * @returns FornecedorClassificacao instance
     */
    public function get_fornecedor_classificacao()
    {
    
        // loads the associated object
        if (empty($this->fornecedor_classificacao))
            $this->fornecedor_classificacao = new FornecedorClassificacao($this->fornecedor_classificacao_id);
    
        // returns the associated object
        return $this->fornecedor_classificacao;
    }
    /**
     * Method set_pessoa_tipo
     * Sample of usage: $var->pessoa_tipo = $object;
     * @param $object Instance of PessoaTipo
     */
    public function set_pessoa_tipo(PessoaTipo $object)
    {
        $this->pessoa_tipo = $object;
        $this->pessoa_tipo_id = $object->id;
    }

    /**
     * Method get_pessoa_tipo
     * Sample of usage: $var->pessoa_tipo->attribute;
     * @returns PessoaTipo instance
     */
    public function get_pessoa_tipo()
    {
    
        // loads the associated object
        if (empty($this->pessoa_tipo))
            $this->pessoa_tipo = new PessoaTipo($this->pessoa_tipo_id);
    
        // returns the associated object
        return $this->pessoa_tipo;
    }
    /**
     * Method set_cidade
     * Sample of usage: $var->cidade = $object;
     * @param $object Instance of Cidade
     */
    public function set_cidade(Cidade $object)
    {
        $this->cidade = $object;
        $this->cidade_id = $object->id;
    }

    /**
     * Method get_cidade
     * Sample of usage: $var->cidade->attribute;
     * @returns Cidade instance
     */
    public function get_cidade()
    {
    
        // loads the associated object
        if (empty($this->cidade))
            $this->cidade = new Cidade($this->cidade_id);
    
        // returns the associated object
        return $this->cidade;
    }
    /**
     * Method set_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt = $object;
     * @param $object Instance of NotafiscalCrt
     */
    public function set_notafiscal_crt(NotafiscalCrt $object)
    {
        $this->notafiscal_crt = $object;
        $this->notafiscal_crt_id = $object->id;
    }

    /**
     * Method get_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt->attribute;
     * @returns NotafiscalCrt instance
     */
    public function get_notafiscal_crt()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_crt))
            $this->notafiscal_crt = new NotafiscalCrt($this->notafiscal_crt_id);
    
        // returns the associated object
        return $this->notafiscal_crt;
    }
    /**
     * Method set_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest = $object;
     * @param $object Instance of NotafiscalIndiedest
     */
    public function set_notafiscal_indiedest(NotafiscalIndiedest $object)
    {
        $this->notafiscal_indiedest = $object;
        $this->notafiscal_indiedest_id = $object->id;
    }

    /**
     * Method get_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest->attribute;
     * @returns NotafiscalIndiedest instance
     */
    public function get_notafiscal_indiedest()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indiedest))
            $this->notafiscal_indiedest = new NotafiscalIndiedest($this->notafiscal_indiedest_id);
    
        // returns the associated object
        return $this->notafiscal_indiedest;
    }

    /**
     * Method getContaspags
     */
    public function getContaspags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('fornecedor_id', '=', $this->id));
        return Contaspag::getObjects( $criteria );
    }
    /**
     * Method getContaspagBlocos
     */
    public function getContaspagBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('fornecedor_id', '=', $this->id));
        return ContaspagBloco::getObjects( $criteria );
    }
    /**
     * Method getFornecedorContatos
     */
    public function getFornecedorContatos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('fornecedor_id', '=', $this->id));
        return FornecedorContato::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompras
     */
    public function getNotaFiscalCompras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('fornecedor_id', '=', $this->id));
        return NotaFiscalCompra::getObjects( $criteria );
    }
    /**
     * Method getProdutoFornecedors
     */
    public function getProdutoFornecedors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('fornecedor_id', '=', $this->id));
        return ProdutoFornecedor::getObjects( $criteria );
    }

    public function set_contaspag_contaspag_situacao_to_string($contaspag_contaspag_situacao_to_string)
    {
        if(is_array($contaspag_contaspag_situacao_to_string))
        {
            $values = ContaspagSituacao::where('id', 'in', $contaspag_contaspag_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_situacao_to_string = $contaspag_contaspag_situacao_to_string;
        }

        $this->vdata['contaspag_contaspag_situacao_to_string'] = $this->contaspag_contaspag_situacao_to_string;
    }

    public function get_contaspag_contaspag_situacao_to_string()
    {
        if(!empty($this->contaspag_contaspag_situacao_to_string))
        {
            return $this->contaspag_contaspag_situacao_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('contaspag_situacao_id','{contaspag_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_forma_pagamento_to_string($contaspag_forma_pagamento_to_string)
    {
        if(is_array($contaspag_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_forma_pagamento_to_string = $contaspag_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_forma_pagamento_to_string'] = $this->contaspag_forma_pagamento_to_string;
    }

    public function get_contaspag_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_forma_pagamento_to_string))
        {
            return $this->contaspag_forma_pagamento_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_fornecedor_to_string($contaspag_fornecedor_to_string)
    {
        if(is_array($contaspag_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_fornecedor_to_string = $contaspag_fornecedor_to_string;
        }

        $this->vdata['contaspag_fornecedor_to_string'] = $this->contaspag_fornecedor_to_string;
    }

    public function get_contaspag_fornecedor_to_string()
    {
        if(!empty($this->contaspag_fornecedor_to_string))
        {
            return $this->contaspag_fornecedor_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_origem_to_string($contaspag_contaspag_origem_to_string)
    {
        if(is_array($contaspag_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_origem_to_string = $contaspag_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_contaspag_origem_to_string'] = $this->contaspag_contaspag_origem_to_string;
    }

    public function get_contaspag_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_contaspag_origem_to_string))
        {
            return $this->contaspag_contaspag_origem_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_system_unit_to_string($contaspag_system_unit_to_string)
    {
        if(is_array($contaspag_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_system_unit_to_string = $contaspag_system_unit_to_string;
        }

        $this->vdata['contaspag_system_unit_to_string'] = $this->contaspag_system_unit_to_string;
    }

    public function get_contaspag_system_unit_to_string()
    {
        if(!empty($this->contaspag_system_unit_to_string))
        {
            return $this->contaspag_system_unit_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contaspag_cheque_banco_to_string($contaspag_cheque_banco_to_string)
    {
        if(is_array($contaspag_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contaspag_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_cheque_banco_to_string = $contaspag_cheque_banco_to_string;
        }

        $this->vdata['contaspag_cheque_banco_to_string'] = $this->contaspag_cheque_banco_to_string;
    }

    public function get_contaspag_cheque_banco_to_string()
    {
        if(!empty($this->contaspag_cheque_banco_to_string))
        {
            return $this->contaspag_cheque_banco_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_bloco_to_string($contaspag_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_bloco_to_string = $contaspag_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_contaspag_bloco_to_string'] = $this->contaspag_contaspag_bloco_to_string;
    }

    public function get_contaspag_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_contaspag_bloco_to_string))
        {
            return $this->contaspag_contaspag_bloco_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_nota_fiscal_compra_to_string($contaspag_nota_fiscal_compra_to_string)
    {
        if(is_array($contaspag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $contaspag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_nota_fiscal_compra_to_string = $contaspag_nota_fiscal_compra_to_string;
        }

        $this->vdata['contaspag_nota_fiscal_compra_to_string'] = $this->contaspag_nota_fiscal_compra_to_string;
    }

    public function get_contaspag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->contaspag_nota_fiscal_compra_to_string))
        {
            return $this->contaspag_nota_fiscal_compra_to_string;
        }
    
        $values = Contaspag::where('fornecedor_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_fornecedor_to_string($contaspag_bloco_fornecedor_to_string)
    {
        if(is_array($contaspag_bloco_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_bloco_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_bloco_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_fornecedor_to_string = $contaspag_bloco_fornecedor_to_string;
        }

        $this->vdata['contaspag_bloco_fornecedor_to_string'] = $this->contaspag_bloco_fornecedor_to_string;
    }

    public function get_contaspag_bloco_fornecedor_to_string()
    {
        if(!empty($this->contaspag_bloco_fornecedor_to_string))
        {
            return $this->contaspag_bloco_fornecedor_to_string;
        }
    
        $values = ContaspagBloco::where('fornecedor_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_forma_pagamento_to_string($contaspag_bloco_forma_pagamento_to_string)
    {
        if(is_array($contaspag_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_forma_pagamento_to_string = $contaspag_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_bloco_forma_pagamento_to_string'] = $this->contaspag_bloco_forma_pagamento_to_string;
    }

    public function get_contaspag_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_bloco_forma_pagamento_to_string))
        {
            return $this->contaspag_bloco_forma_pagamento_to_string;
        }
    
        $values = ContaspagBloco::where('fornecedor_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contaspag_origem_to_string($contaspag_bloco_contaspag_origem_to_string)
    {
        if(is_array($contaspag_bloco_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_bloco_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contaspag_origem_to_string = $contaspag_bloco_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_bloco_contaspag_origem_to_string'] = $this->contaspag_bloco_contaspag_origem_to_string;
    }

    public function get_contaspag_bloco_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_bloco_contaspag_origem_to_string))
        {
            return $this->contaspag_bloco_contaspag_origem_to_string;
        }
    
        $values = ContaspagBloco::where('fornecedor_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_system_unit_to_string($contaspag_bloco_system_unit_to_string)
    {
        if(is_array($contaspag_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_system_unit_to_string = $contaspag_bloco_system_unit_to_string;
        }

        $this->vdata['contaspag_bloco_system_unit_to_string'] = $this->contaspag_bloco_system_unit_to_string;
    }

    public function get_contaspag_bloco_system_unit_to_string()
    {
        if(!empty($this->contaspag_bloco_system_unit_to_string))
        {
            return $this->contaspag_bloco_system_unit_to_string;
        }
    
        $values = ContaspagBloco::where('fornecedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_fornecedor_contato_fornecedor_to_string($fornecedor_contato_fornecedor_to_string)
    {
        if(is_array($fornecedor_contato_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $fornecedor_contato_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->fornecedor_contato_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_contato_fornecedor_to_string = $fornecedor_contato_fornecedor_to_string;
        }

        $this->vdata['fornecedor_contato_fornecedor_to_string'] = $this->fornecedor_contato_fornecedor_to_string;
    }

    public function get_fornecedor_contato_fornecedor_to_string()
    {
        if(!empty($this->fornecedor_contato_fornecedor_to_string))
        {
            return $this->fornecedor_contato_fornecedor_to_string;
        }
    
        $values = FornecedorContato::where('fornecedor_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_system_unit_to_string($nota_fiscal_compra_system_unit_to_string)
    {
        if(is_array($nota_fiscal_compra_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $nota_fiscal_compra_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->nota_fiscal_compra_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_system_unit_to_string = $nota_fiscal_compra_system_unit_to_string;
        }

        $this->vdata['nota_fiscal_compra_system_unit_to_string'] = $this->nota_fiscal_compra_system_unit_to_string;
    }

    public function get_nota_fiscal_compra_system_unit_to_string()
    {
        if(!empty($this->nota_fiscal_compra_system_unit_to_string))
        {
            return $this->nota_fiscal_compra_system_unit_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_fornecedor_to_string($nota_fiscal_compra_fornecedor_to_string)
    {
        if(is_array($nota_fiscal_compra_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $nota_fiscal_compra_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_fornecedor_to_string = $nota_fiscal_compra_fornecedor_to_string;
        }

        $this->vdata['nota_fiscal_compra_fornecedor_to_string'] = $this->nota_fiscal_compra_fornecedor_to_string;
    }

    public function get_nota_fiscal_compra_fornecedor_to_string()
    {
        if(!empty($this->nota_fiscal_compra_fornecedor_to_string))
        {
            return $this->nota_fiscal_compra_fornecedor_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tipodocumento_to_string($nota_fiscal_compra_notafiscal_tipodocumento_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $nota_fiscal_compra_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = $nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tipodocumento_to_string'] = $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            $values = NotaFiscalCompraSituacao::where('id', 'in', $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_nota_fiscal_compra_situacao_to_string'] = $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
    }

    public function get_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            return $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_situacao_id','{nota_fiscal_compra_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_crt_to_string($nota_fiscal_compra_notafiscal_crt_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $nota_fiscal_compra_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_crt_to_string = $nota_fiscal_compra_notafiscal_crt_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_crt_to_string'] = $this->nota_fiscal_compra_notafiscal_crt_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_crt_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_crt_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_crt_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indiedest_to_string($nota_fiscal_compra_notafiscal_indiedest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $nota_fiscal_compra_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = $nota_fiscal_compra_notafiscal_indiedest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indiedest_to_string'] = $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indiedest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscaldest_to_string($nota_fiscal_compra_notafiscaldest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $nota_fiscal_compra_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscaldest_to_string = $nota_fiscal_compra_notafiscaldest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscaldest_to_string'] = $this->nota_fiscal_compra_notafiscaldest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscaldest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscaldest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscaldest_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tpimp_to_string($nota_fiscal_compra_notafiscal_tpimp_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $nota_fiscal_compra_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = $nota_fiscal_compra_notafiscal_tpimp_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tpimp_to_string'] = $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tpimp_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_finnfe_to_string($nota_fiscal_compra_notafiscal_finnfe_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $nota_fiscal_compra_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = $nota_fiscal_compra_notafiscal_finnfe_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_finnfe_to_string'] = $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_finnfe_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indfinal_to_string($nota_fiscal_compra_notafiscal_indfinal_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $nota_fiscal_compra_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = $nota_fiscal_compra_notafiscal_indfinal_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indfinal_to_string'] = $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indfinal_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpres_to_string($nota_fiscal_compra_notafiscal_indpres_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $nota_fiscal_compra_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = $nota_fiscal_compra_notafiscal_indpres_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpres_to_string'] = $this->nota_fiscal_compra_notafiscal_indpres_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpres_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpres_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpag_to_string($nota_fiscal_compra_notafiscal_indpag_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $nota_fiscal_compra_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = $nota_fiscal_compra_notafiscal_indpag_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpag_to_string'] = $this->nota_fiscal_compra_notafiscal_indpag_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpag_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpag_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_mod_to_string($nota_fiscal_compra_notafiscal_mod_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $nota_fiscal_compra_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_mod_to_string = $nota_fiscal_compra_notafiscal_mod_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_mod_to_string'] = $this->nota_fiscal_compra_notafiscal_mod_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_mod_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_mod_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_mod_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_modfrete_to_string($nota_fiscal_compra_notafiscal_modfrete_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $nota_fiscal_compra_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = $nota_fiscal_compra_notafiscal_modfrete_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_modfrete_to_string'] = $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_modfrete_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
        }
    
        $values = NotaFiscalCompra::where('fornecedor_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_fornecedor_produto_to_string($produto_fornecedor_produto_to_string)
    {
        if(is_array($produto_fornecedor_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_fornecedor_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_fornecedor_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_fornecedor_produto_to_string = $produto_fornecedor_produto_to_string;
        }

        $this->vdata['produto_fornecedor_produto_to_string'] = $this->produto_fornecedor_produto_to_string;
    }

    public function get_produto_fornecedor_produto_to_string()
    {
        if(!empty($this->produto_fornecedor_produto_to_string))
        {
            return $this->produto_fornecedor_produto_to_string;
        }
    
        $values = ProdutoFornecedor::where('fornecedor_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_fornecedor_fornecedor_to_string($produto_fornecedor_fornecedor_to_string)
    {
        if(is_array($produto_fornecedor_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $produto_fornecedor_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_fornecedor_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_fornecedor_fornecedor_to_string = $produto_fornecedor_fornecedor_to_string;
        }

        $this->vdata['produto_fornecedor_fornecedor_to_string'] = $this->produto_fornecedor_fornecedor_to_string;
    }

    public function get_produto_fornecedor_fornecedor_to_string()
    {
        if(!empty($this->produto_fornecedor_fornecedor_to_string))
        {
            return $this->produto_fornecedor_fornecedor_to_string;
        }
    
        $values = ProdutoFornecedor::where('fornecedor_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    
}

