<?php

class FornecedorClassificacao extends TRecord
{
    const TABLENAME  = 'fornecedor_classificacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ativo;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('ativo_id');
            
    }

    /**
     * Method set_ativo
     * Sample of usage: $var->ativo = $object;
     * @param $object Instance of Ativo
     */
    public function set_ativo(Ativo $object)
    {
        $this->ativo = $object;
        $this->ativo_id = $object->id;
    }

    /**
     * Method get_ativo
     * Sample of usage: $var->ativo->attribute;
     * @returns Ativo instance
     */
    public function get_ativo()
    {
    
        // loads the associated object
        if (empty($this->ativo))
            $this->ativo = new Ativo($this->ativo_id);
    
        // returns the associated object
        return $this->ativo;
    }

    /**
     * Method getFornecedors
     */
    public function getFornecedors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('fornecedor_classificacao_id', '=', $this->id));
        return Fornecedor::getObjects( $criteria );
    }

    public function set_fornecedor_pessoa_tipo_to_string($fornecedor_pessoa_tipo_to_string)
    {
        if(is_array($fornecedor_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $fornecedor_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_pessoa_tipo_to_string = $fornecedor_pessoa_tipo_to_string;
        }

        $this->vdata['fornecedor_pessoa_tipo_to_string'] = $this->fornecedor_pessoa_tipo_to_string;
    }

    public function get_fornecedor_pessoa_tipo_to_string()
    {
        if(!empty($this->fornecedor_pessoa_tipo_to_string))
        {
            return $this->fornecedor_pessoa_tipo_to_string;
        }
    
        $values = Fornecedor::where('fornecedor_classificacao_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_fornecedor_classificacao_to_string($fornecedor_fornecedor_classificacao_to_string)
    {
        if(is_array($fornecedor_fornecedor_classificacao_to_string))
        {
            $values = FornecedorClassificacao::where('id', 'in', $fornecedor_fornecedor_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_fornecedor_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_fornecedor_classificacao_to_string = $fornecedor_fornecedor_classificacao_to_string;
        }

        $this->vdata['fornecedor_fornecedor_classificacao_to_string'] = $this->fornecedor_fornecedor_classificacao_to_string;
    }

    public function get_fornecedor_fornecedor_classificacao_to_string()
    {
        if(!empty($this->fornecedor_fornecedor_classificacao_to_string))
        {
            return $this->fornecedor_fornecedor_classificacao_to_string;
        }
    
        $values = Fornecedor::where('fornecedor_classificacao_id', '=', $this->id)->getIndexedArray('fornecedor_classificacao_id','{fornecedor_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_cidade_to_string($fornecedor_cidade_to_string)
    {
        if(is_array($fornecedor_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $fornecedor_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->fornecedor_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_cidade_to_string = $fornecedor_cidade_to_string;
        }

        $this->vdata['fornecedor_cidade_to_string'] = $this->fornecedor_cidade_to_string;
    }

    public function get_fornecedor_cidade_to_string()
    {
        if(!empty($this->fornecedor_cidade_to_string))
        {
            return $this->fornecedor_cidade_to_string;
        }
    
        $values = Fornecedor::where('fornecedor_classificacao_id', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    public function set_fornecedor_notafiscal_crt_to_string($fornecedor_notafiscal_crt_to_string)
    {
        if(is_array($fornecedor_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $fornecedor_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_notafiscal_crt_to_string = $fornecedor_notafiscal_crt_to_string;
        }

        $this->vdata['fornecedor_notafiscal_crt_to_string'] = $this->fornecedor_notafiscal_crt_to_string;
    }

    public function get_fornecedor_notafiscal_crt_to_string()
    {
        if(!empty($this->fornecedor_notafiscal_crt_to_string))
        {
            return $this->fornecedor_notafiscal_crt_to_string;
        }
    
        $values = Fornecedor::where('fornecedor_classificacao_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_notafiscal_indiedest_to_string($fornecedor_notafiscal_indiedest_to_string)
    {
        if(is_array($fornecedor_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $fornecedor_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_notafiscal_indiedest_to_string = $fornecedor_notafiscal_indiedest_to_string;
        }

        $this->vdata['fornecedor_notafiscal_indiedest_to_string'] = $this->fornecedor_notafiscal_indiedest_to_string;
    }

    public function get_fornecedor_notafiscal_indiedest_to_string()
    {
        if(!empty($this->fornecedor_notafiscal_indiedest_to_string))
        {
            return $this->fornecedor_notafiscal_indiedest_to_string;
        }
    
        $values = Fornecedor::where('fornecedor_classificacao_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    
}

