<?php

class Funcionario extends TRecord
{
    const TABLENAME  = 'funcionario';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $funcionario_cargo;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('funcionario_cargo_id');
        parent::addAttribute('nome');
        parent::addAttribute('cpf');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('valor_salario');
        parent::addAttribute('valor_hora');
            
    }

    /**
     * Method set_funcionario_cargo
     * Sample of usage: $var->funcionario_cargo = $object;
     * @param $object Instance of FuncionarioCargo
     */
    public function set_funcionario_cargo(FuncionarioCargo $object)
    {
        $this->funcionario_cargo = $object;
        $this->funcionario_cargo_id = $object->id;
    }

    /**
     * Method get_funcionario_cargo
     * Sample of usage: $var->funcionario_cargo->attribute;
     * @returns FuncionarioCargo instance
     */
    public function get_funcionario_cargo()
    {
    
        // loads the associated object
        if (empty($this->funcionario_cargo))
            $this->funcionario_cargo = new FuncionarioCargo($this->funcionario_cargo_id);
    
        // returns the associated object
        return $this->funcionario_cargo;
    }

    /**
     * Method getOrdemServicoItemMaoObras
     */
    public function getOrdemServicoItemMaoObras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('funcionario_id', '=', $this->id));
        return OrdemServicoItemMaoObra::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaMaoObras
     */
    public function getProdutoFichaTecnicaMaoObras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('funcionario_id', '=', $this->id));
        return ProdutoFichaTecnicaMaoObra::getObjects( $criteria );
    }
    /**
     * Method getVeiculos
     */
    public function getVeiculos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('funcionario_motorista_id', '=', $this->id));
        return Veiculo::getObjects( $criteria );
    }

    public function set_ordem_servico_item_mao_obra_ordem_servico_item_to_string($ordem_servico_item_mao_obra_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_mao_obra_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_mao_obra_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string = $ordem_servico_item_mao_obra_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_mao_obra_ordem_servico_item_to_string'] = $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_mao_obra_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_mao_obra_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemMaoObra::where('funcionario_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_mao_obra_funcionario_to_string($ordem_servico_item_mao_obra_funcionario_to_string)
    {
        if(is_array($ordem_servico_item_mao_obra_funcionario_to_string))
        {
            $values = Funcionario::where('id', 'in', $ordem_servico_item_mao_obra_funcionario_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_item_mao_obra_funcionario_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_mao_obra_funcionario_to_string = $ordem_servico_item_mao_obra_funcionario_to_string;
        }

        $this->vdata['ordem_servico_item_mao_obra_funcionario_to_string'] = $this->ordem_servico_item_mao_obra_funcionario_to_string;
    }

    public function get_ordem_servico_item_mao_obra_funcionario_to_string()
    {
        if(!empty($this->ordem_servico_item_mao_obra_funcionario_to_string))
        {
            return $this->ordem_servico_item_mao_obra_funcionario_to_string;
        }
    
        $values = OrdemServicoItemMaoObra::where('funcionario_id', '=', $this->id)->getIndexedArray('funcionario_id','{funcionario->nome}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string($produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaMaoObra::where('funcionario_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_mao_obra_funcionario_to_string($produto_ficha_tecnica_mao_obra_funcionario_to_string)
    {
        if(is_array($produto_ficha_tecnica_mao_obra_funcionario_to_string))
        {
            $values = Funcionario::where('id', 'in', $produto_ficha_tecnica_mao_obra_funcionario_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_ficha_tecnica_mao_obra_funcionario_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_mao_obra_funcionario_to_string = $produto_ficha_tecnica_mao_obra_funcionario_to_string;
        }

        $this->vdata['produto_ficha_tecnica_mao_obra_funcionario_to_string'] = $this->produto_ficha_tecnica_mao_obra_funcionario_to_string;
    }

    public function get_produto_ficha_tecnica_mao_obra_funcionario_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_mao_obra_funcionario_to_string))
        {
            return $this->produto_ficha_tecnica_mao_obra_funcionario_to_string;
        }
    
        $values = ProdutoFichaTecnicaMaoObra::where('funcionario_id', '=', $this->id)->getIndexedArray('funcionario_id','{funcionario->nome}');
        return implode(', ', $values);
    }

    public function set_veiculo_mdfe_tpRod_to_string($veiculo_mdfe_tpRod_to_string)
    {
        if(is_array($veiculo_mdfe_tpRod_to_string))
        {
            $values = MdfeTprod::where('id', 'in', $veiculo_mdfe_tpRod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->veiculo_mdfe_tpRod_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_mdfe_tpRod_to_string = $veiculo_mdfe_tpRod_to_string;
        }

        $this->vdata['veiculo_mdfe_tpRod_to_string'] = $this->veiculo_mdfe_tpRod_to_string;
    }

    public function get_veiculo_mdfe_tpRod_to_string()
    {
        if(!empty($this->veiculo_mdfe_tpRod_to_string))
        {
            return $this->veiculo_mdfe_tpRod_to_string;
        }
    
        $values = Veiculo::where('funcionario_motorista_id', '=', $this->id)->getIndexedArray('mdfe_tpRod_id','{mdfe_tpRod->descricao}');
        return implode(', ', $values);
    }

    public function set_veiculo_estado_to_string($veiculo_estado_to_string)
    {
        if(is_array($veiculo_estado_to_string))
        {
            $values = Estado::where('id', 'in', $veiculo_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->veiculo_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_estado_to_string = $veiculo_estado_to_string;
        }

        $this->vdata['veiculo_estado_to_string'] = $this->veiculo_estado_to_string;
    }

    public function get_veiculo_estado_to_string()
    {
        if(!empty($this->veiculo_estado_to_string))
        {
            return $this->veiculo_estado_to_string;
        }
    
        $values = Veiculo::where('funcionario_motorista_id', '=', $this->id)->getIndexedArray('estado_id','{estado->nome}');
        return implode(', ', $values);
    }

    public function set_veiculo_veiculo_tipo_to_string($veiculo_veiculo_tipo_to_string)
    {
        if(is_array($veiculo_veiculo_tipo_to_string))
        {
            $values = VeiculoTipo::where('id', 'in', $veiculo_veiculo_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->veiculo_veiculo_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_veiculo_tipo_to_string = $veiculo_veiculo_tipo_to_string;
        }

        $this->vdata['veiculo_veiculo_tipo_to_string'] = $this->veiculo_veiculo_tipo_to_string;
    }

    public function get_veiculo_veiculo_tipo_to_string()
    {
        if(!empty($this->veiculo_veiculo_tipo_to_string))
        {
            return $this->veiculo_veiculo_tipo_to_string;
        }
    
        $values = Veiculo::where('funcionario_motorista_id', '=', $this->id)->getIndexedArray('veiculo_tipo_id','{veiculo_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_veiculo_mdfe_tpcar_to_string($veiculo_mdfe_tpcar_to_string)
    {
        if(is_array($veiculo_mdfe_tpcar_to_string))
        {
            $values = MdfeTpcar::where('id', 'in', $veiculo_mdfe_tpcar_to_string)->getIndexedArray('descricao', 'descricao');
            $this->veiculo_mdfe_tpcar_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_mdfe_tpcar_to_string = $veiculo_mdfe_tpcar_to_string;
        }

        $this->vdata['veiculo_mdfe_tpcar_to_string'] = $this->veiculo_mdfe_tpcar_to_string;
    }

    public function get_veiculo_mdfe_tpcar_to_string()
    {
        if(!empty($this->veiculo_mdfe_tpcar_to_string))
        {
            return $this->veiculo_mdfe_tpcar_to_string;
        }
    
        $values = Veiculo::where('funcionario_motorista_id', '=', $this->id)->getIndexedArray('mdfe_tpcar_id','{mdfe_tpcar->descricao}');
        return implode(', ', $values);
    }

    public function set_veiculo_funcionario_motorista_to_string($veiculo_funcionario_motorista_to_string)
    {
        if(is_array($veiculo_funcionario_motorista_to_string))
        {
            $values = Funcionario::where('id', 'in', $veiculo_funcionario_motorista_to_string)->getIndexedArray('nome', 'nome');
            $this->veiculo_funcionario_motorista_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_funcionario_motorista_to_string = $veiculo_funcionario_motorista_to_string;
        }

        $this->vdata['veiculo_funcionario_motorista_to_string'] = $this->veiculo_funcionario_motorista_to_string;
    }

    public function get_veiculo_funcionario_motorista_to_string()
    {
        if(!empty($this->veiculo_funcionario_motorista_to_string))
        {
            return $this->veiculo_funcionario_motorista_to_string;
        }
    
        $values = Veiculo::where('funcionario_motorista_id', '=', $this->id)->getIndexedArray('funcionario_motorista_id','{funcionario_motorista->nome}');
        return implode(', ', $values);
    }

    
}

