<?php

class Funil extends TRecord
{
    const TABLENAME  = 'funil';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

  const Permissao_ExcluirFunil = 'Excluir funil de CRM';
    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('deletado_em');
    
    }

    /**
     * Method getFunilEtapass
     */
    public function getFunilEtapass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('funil_id', '=', $this->id));
        return FunilEtapas::getObjects( $criteria );
    }
    /**
     * Method getNegocios
     */
    public function getNegocios()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('funil_id', '=', $this->id));
        return Negocio::getObjects( $criteria );
    }

    public function set_funil_etapas_funil_to_string($funil_etapas_funil_to_string)
    {
        if(is_array($funil_etapas_funil_to_string))
        {
            $values = Funil::where('id', 'in', $funil_etapas_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->funil_etapas_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->funil_etapas_funil_to_string = $funil_etapas_funil_to_string;
        }

        $this->vdata['funil_etapas_funil_to_string'] = $this->funil_etapas_funil_to_string;
    }

    public function get_funil_etapas_funil_to_string()
    {
        if(!empty($this->funil_etapas_funil_to_string))
        {
            return $this->funil_etapas_funil_to_string;
        }
    
        $values = FunilEtapas::where('funil_id', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_funil_etapas_fk_ultima_etapa_to_string($funil_etapas_fk_ultima_etapa_to_string)
    {
        if(is_array($funil_etapas_fk_ultima_etapa_to_string))
        {
            $values = Resposta::where('id', 'in', $funil_etapas_fk_ultima_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->funil_etapas_fk_ultima_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->funil_etapas_fk_ultima_etapa_to_string = $funil_etapas_fk_ultima_etapa_to_string;
        }

        $this->vdata['funil_etapas_fk_ultima_etapa_to_string'] = $this->funil_etapas_fk_ultima_etapa_to_string;
    }

    public function get_funil_etapas_fk_ultima_etapa_to_string()
    {
        if(!empty($this->funil_etapas_fk_ultima_etapa_to_string))
        {
            return $this->funil_etapas_fk_ultima_etapa_to_string;
        }
    
        $values = FunilEtapas::where('funil_id', '=', $this->id)->getIndexedArray('ultima_etapa','{fk_ultima_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_system_unit_to_string($negocio_system_unit_to_string)
    {
        if(is_array($negocio_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $negocio_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->negocio_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_system_unit_to_string = $negocio_system_unit_to_string;
        }

        $this->vdata['negocio_system_unit_to_string'] = $this->negocio_system_unit_to_string;
    }

    public function get_negocio_system_unit_to_string()
    {
        if(!empty($this->negocio_system_unit_to_string))
        {
            return $this->negocio_system_unit_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_origem_to_string($negocio_negocio_origem_to_string)
    {
        if(is_array($negocio_negocio_origem_to_string))
        {
            $values = NegocioOrigem::where('id', 'in', $negocio_negocio_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_origem_to_string = $negocio_negocio_origem_to_string;
        }

        $this->vdata['negocio_negocio_origem_to_string'] = $this->negocio_negocio_origem_to_string;
    }

    public function get_negocio_negocio_origem_to_string()
    {
        if(!empty($this->negocio_negocio_origem_to_string))
        {
            return $this->negocio_negocio_origem_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('negocio_origem_id','{negocio_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_to_string($negocio_funil_to_string)
    {
        if(is_array($negocio_funil_to_string))
        {
            $values = Funil::where('id', 'in', $negocio_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_to_string = $negocio_funil_to_string;
        }

        $this->vdata['negocio_funil_to_string'] = $this->negocio_funil_to_string;
    }

    public function get_negocio_funil_to_string()
    {
        if(!empty($this->negocio_funil_to_string))
        {
            return $this->negocio_funil_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_etapas_to_string($negocio_funil_etapas_to_string)
    {
        if(is_array($negocio_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_etapas_to_string = $negocio_funil_etapas_to_string;
        }

        $this->vdata['negocio_funil_etapas_to_string'] = $this->negocio_funil_etapas_to_string;
    }

    public function get_negocio_funil_etapas_to_string()
    {
        if(!empty($this->negocio_funil_etapas_to_string))
        {
            return $this->negocio_funil_etapas_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_motivo_perda_to_string($negocio_negocio_motivo_perda_to_string)
    {
        if(is_array($negocio_negocio_motivo_perda_to_string))
        {
            $values = NegocioMotivoPerda::where('id', 'in', $negocio_negocio_motivo_perda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_motivo_perda_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_motivo_perda_to_string = $negocio_negocio_motivo_perda_to_string;
        }

        $this->vdata['negocio_negocio_motivo_perda_to_string'] = $this->negocio_negocio_motivo_perda_to_string;
    }

    public function get_negocio_negocio_motivo_perda_to_string()
    {
        if(!empty($this->negocio_negocio_motivo_perda_to_string))
        {
            return $this->negocio_negocio_motivo_perda_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('negocio_motivo_perda_id','{negocio_motivo_perda->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_ativo_to_string($negocio_ativo_to_string)
    {
        if(is_array($negocio_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $negocio_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_ativo_to_string = $negocio_ativo_to_string;
        }

        $this->vdata['negocio_ativo_to_string'] = $this->negocio_ativo_to_string;
    }

    public function get_negocio_ativo_to_string()
    {
        if(!empty($this->negocio_ativo_to_string))
        {
            return $this->negocio_ativo_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_fk_arquivado_to_string($negocio_fk_arquivado_to_string)
    {
        if(is_array($negocio_fk_arquivado_to_string))
        {
            $values = Resposta::where('id', 'in', $negocio_fk_arquivado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_fk_arquivado_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_fk_arquivado_to_string = $negocio_fk_arquivado_to_string;
        }

        $this->vdata['negocio_fk_arquivado_to_string'] = $this->negocio_fk_arquivado_to_string;
    }

    public function get_negocio_fk_arquivado_to_string()
    {
        if(!empty($this->negocio_fk_arquivado_to_string))
        {
            return $this->negocio_fk_arquivado_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('arquivado','{fk_arquivado->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_vendedor_to_string($negocio_vendedor_to_string)
    {
        if(is_array($negocio_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $negocio_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_vendedor_to_string = $negocio_vendedor_to_string;
        }

        $this->vdata['negocio_vendedor_to_string'] = $this->negocio_vendedor_to_string;
    }

    public function get_negocio_vendedor_to_string()
    {
        if(!empty($this->negocio_vendedor_to_string))
        {
            return $this->negocio_vendedor_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_orcamento_to_string($negocio_orcamento_to_string)
    {
        if(is_array($negocio_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $negocio_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->negocio_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_orcamento_to_string = $negocio_orcamento_to_string;
        }

        $this->vdata['negocio_orcamento_to_string'] = $this->negocio_orcamento_to_string;
    }

    public function get_negocio_orcamento_to_string()
    {
        if(!empty($this->negocio_orcamento_to_string))
        {
            return $this->negocio_orcamento_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_negocio_cliente_to_string($negocio_cliente_to_string)
    {
        if(is_array($negocio_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $negocio_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_cliente_to_string = $negocio_cliente_to_string;
        }

        $this->vdata['negocio_cliente_to_string'] = $this->negocio_cliente_to_string;
    }

    public function get_negocio_cliente_to_string()
    {
        if(!empty($this->negocio_cliente_to_string))
        {
            return $this->negocio_cliente_to_string;
        }
    
        $values = Negocio::where('funil_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

  public static function SincronizaPermissoesEspeciais()
  {
      SystemProgramPermissoes::ProcessaPermissao('FunilHeaderList',self::Permissao_ExcluirFunil);
  }  
    
}

