<?php

class FunilEtapas extends TRecord
{
    const TABLENAME  = 'funil_etapas';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $funil;
    private $fk_ultima_etapa;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('funil_id');
        parent::addAttribute('descricao');
        parent::addAttribute('numero_etapa');
        parent::addAttribute('cor_etapa');
        parent::addAttribute('cor_negocio');
        parent::addAttribute('ultima_etapa');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('permite_edicao');
        parent::addAttribute('permite_exclusao');
        parent::addAttribute('kanban');
        parent::addAttribute('etapa_ganha');
        parent::addAttribute('etapa_perde');
            
    }

    /**
     * Method set_funil
     * Sample of usage: $var->funil = $object;
     * @param $object Instance of Funil
     */
    public function set_funil(Funil $object)
    {
        $this->funil = $object;
        $this->funil_id = $object->id;
    }

    /**
     * Method get_funil
     * Sample of usage: $var->funil->attribute;
     * @returns Funil instance
     */
    public function get_funil()
    {
    
        // loads the associated object
        if (empty($this->funil))
            $this->funil = new Funil($this->funil_id);
    
        // returns the associated object
        return $this->funil;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_fk_ultima_etapa(Resposta $object)
    {
        $this->fk_ultima_etapa = $object;
        $this->ultima_etapa = $object->id;
    }

    /**
     * Method get_fk_ultima_etapa
     * Sample of usage: $var->fk_ultima_etapa->attribute;
     * @returns Resposta instance
     */
    public function get_fk_ultima_etapa()
    {
    
        // loads the associated object
        if (empty($this->fk_ultima_etapa))
            $this->fk_ultima_etapa = new Resposta($this->ultima_etapa);
    
        // returns the associated object
        return $this->fk_ultima_etapa;
    }

    /**
     * Method getNegocios
     */
    public function getNegocios()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('funil_etapas_id', '=', $this->id));
        return Negocio::getObjects( $criteria );
    }
    /**
     * Method getNegocioEtapasHistoricos
     */
    public function getNegocioEtapasHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('funil_etapas_id', '=', $this->id));
        return NegocioEtapasHistorico::getObjects( $criteria );
    }

    public function set_negocio_system_unit_to_string($negocio_system_unit_to_string)
    {
        if(is_array($negocio_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $negocio_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->negocio_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_system_unit_to_string = $negocio_system_unit_to_string;
        }

        $this->vdata['negocio_system_unit_to_string'] = $this->negocio_system_unit_to_string;
    }

    public function get_negocio_system_unit_to_string()
    {
        if(!empty($this->negocio_system_unit_to_string))
        {
            return $this->negocio_system_unit_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_origem_to_string($negocio_negocio_origem_to_string)
    {
        if(is_array($negocio_negocio_origem_to_string))
        {
            $values = NegocioOrigem::where('id', 'in', $negocio_negocio_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_origem_to_string = $negocio_negocio_origem_to_string;
        }

        $this->vdata['negocio_negocio_origem_to_string'] = $this->negocio_negocio_origem_to_string;
    }

    public function get_negocio_negocio_origem_to_string()
    {
        if(!empty($this->negocio_negocio_origem_to_string))
        {
            return $this->negocio_negocio_origem_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('negocio_origem_id','{negocio_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_to_string($negocio_funil_to_string)
    {
        if(is_array($negocio_funil_to_string))
        {
            $values = Funil::where('id', 'in', $negocio_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_to_string = $negocio_funil_to_string;
        }

        $this->vdata['negocio_funil_to_string'] = $this->negocio_funil_to_string;
    }

    public function get_negocio_funil_to_string()
    {
        if(!empty($this->negocio_funil_to_string))
        {
            return $this->negocio_funil_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_etapas_to_string($negocio_funil_etapas_to_string)
    {
        if(is_array($negocio_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_etapas_to_string = $negocio_funil_etapas_to_string;
        }

        $this->vdata['negocio_funil_etapas_to_string'] = $this->negocio_funil_etapas_to_string;
    }

    public function get_negocio_funil_etapas_to_string()
    {
        if(!empty($this->negocio_funil_etapas_to_string))
        {
            return $this->negocio_funil_etapas_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_motivo_perda_to_string($negocio_negocio_motivo_perda_to_string)
    {
        if(is_array($negocio_negocio_motivo_perda_to_string))
        {
            $values = NegocioMotivoPerda::where('id', 'in', $negocio_negocio_motivo_perda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_motivo_perda_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_motivo_perda_to_string = $negocio_negocio_motivo_perda_to_string;
        }

        $this->vdata['negocio_negocio_motivo_perda_to_string'] = $this->negocio_negocio_motivo_perda_to_string;
    }

    public function get_negocio_negocio_motivo_perda_to_string()
    {
        if(!empty($this->negocio_negocio_motivo_perda_to_string))
        {
            return $this->negocio_negocio_motivo_perda_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('negocio_motivo_perda_id','{negocio_motivo_perda->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_ativo_to_string($negocio_ativo_to_string)
    {
        if(is_array($negocio_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $negocio_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_ativo_to_string = $negocio_ativo_to_string;
        }

        $this->vdata['negocio_ativo_to_string'] = $this->negocio_ativo_to_string;
    }

    public function get_negocio_ativo_to_string()
    {
        if(!empty($this->negocio_ativo_to_string))
        {
            return $this->negocio_ativo_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_fk_arquivado_to_string($negocio_fk_arquivado_to_string)
    {
        if(is_array($negocio_fk_arquivado_to_string))
        {
            $values = Resposta::where('id', 'in', $negocio_fk_arquivado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_fk_arquivado_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_fk_arquivado_to_string = $negocio_fk_arquivado_to_string;
        }

        $this->vdata['negocio_fk_arquivado_to_string'] = $this->negocio_fk_arquivado_to_string;
    }

    public function get_negocio_fk_arquivado_to_string()
    {
        if(!empty($this->negocio_fk_arquivado_to_string))
        {
            return $this->negocio_fk_arquivado_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('arquivado','{fk_arquivado->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_vendedor_to_string($negocio_vendedor_to_string)
    {
        if(is_array($negocio_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $negocio_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_vendedor_to_string = $negocio_vendedor_to_string;
        }

        $this->vdata['negocio_vendedor_to_string'] = $this->negocio_vendedor_to_string;
    }

    public function get_negocio_vendedor_to_string()
    {
        if(!empty($this->negocio_vendedor_to_string))
        {
            return $this->negocio_vendedor_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_orcamento_to_string($negocio_orcamento_to_string)
    {
        if(is_array($negocio_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $negocio_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->negocio_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_orcamento_to_string = $negocio_orcamento_to_string;
        }

        $this->vdata['negocio_orcamento_to_string'] = $this->negocio_orcamento_to_string;
    }

    public function get_negocio_orcamento_to_string()
    {
        if(!empty($this->negocio_orcamento_to_string))
        {
            return $this->negocio_orcamento_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_negocio_cliente_to_string($negocio_cliente_to_string)
    {
        if(is_array($negocio_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $negocio_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_cliente_to_string = $negocio_cliente_to_string;
        }

        $this->vdata['negocio_cliente_to_string'] = $this->negocio_cliente_to_string;
    }

    public function get_negocio_cliente_to_string()
    {
        if(!empty($this->negocio_cliente_to_string))
        {
            return $this->negocio_cliente_to_string;
        }
    
        $values = Negocio::where('funil_etapas_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_etapas_historico_negocio_to_string($negocio_etapas_historico_negocio_to_string)
    {
        if(is_array($negocio_etapas_historico_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_etapas_historico_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_etapas_historico_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_etapas_historico_negocio_to_string = $negocio_etapas_historico_negocio_to_string;
        }

        $this->vdata['negocio_etapas_historico_negocio_to_string'] = $this->negocio_etapas_historico_negocio_to_string;
    }

    public function get_negocio_etapas_historico_negocio_to_string()
    {
        if(!empty($this->negocio_etapas_historico_negocio_to_string))
        {
            return $this->negocio_etapas_historico_negocio_to_string;
        }
    
        $values = NegocioEtapasHistorico::where('funil_etapas_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

    public function set_negocio_etapas_historico_funil_etapas_to_string($negocio_etapas_historico_funil_etapas_to_string)
    {
        if(is_array($negocio_etapas_historico_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_etapas_historico_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_etapas_historico_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_etapas_historico_funil_etapas_to_string = $negocio_etapas_historico_funil_etapas_to_string;
        }

        $this->vdata['negocio_etapas_historico_funil_etapas_to_string'] = $this->negocio_etapas_historico_funil_etapas_to_string;
    }

    public function get_negocio_etapas_historico_funil_etapas_to_string()
    {
        if(!empty($this->negocio_etapas_historico_funil_etapas_to_string))
        {
            return $this->negocio_etapas_historico_funil_etapas_to_string;
        }
    
        $values = NegocioEtapasHistorico::where('funil_etapas_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    
}

