<?php

class Integradores extends TRecord
{
    const TABLENAME  = 'integradores';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const CloudDfe = '1';
    const NuvemFiscal = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nome');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getApiDocumentoss
     */
    public function getApiDocumentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('integradores_id', '=', $this->id));
        return ApiDocumentos::getObjects( $criteria );
    }
    /**
     * Method getIntegradoresServicoss
     */
    public function getIntegradoresServicoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('integradores_id', '=', $this->id));
        return IntegradoresServicos::getObjects( $criteria );
    }

    public function set_api_documentos_integradores_to_string($api_documentos_integradores_to_string)
    {
        if(is_array($api_documentos_integradores_to_string))
        {
            $values = Integradores::where('id', 'in', $api_documentos_integradores_to_string)->getIndexedArray('nome', 'nome');
            $this->api_documentos_integradores_to_string = implode(', ', $values);
        }
        else
        {
            $this->api_documentos_integradores_to_string = $api_documentos_integradores_to_string;
        }

        $this->vdata['api_documentos_integradores_to_string'] = $this->api_documentos_integradores_to_string;
    }

    public function get_api_documentos_integradores_to_string()
    {
        if(!empty($this->api_documentos_integradores_to_string))
        {
            return $this->api_documentos_integradores_to_string;
        }
    
        $values = ApiDocumentos::where('integradores_id', '=', $this->id)->getIndexedArray('integradores_id','{integradores->nome}');
        return implode(', ', $values);
    }

    public function set_api_documentos_system_unit_to_string($api_documentos_system_unit_to_string)
    {
        if(is_array($api_documentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $api_documentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->api_documentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->api_documentos_system_unit_to_string = $api_documentos_system_unit_to_string;
        }

        $this->vdata['api_documentos_system_unit_to_string'] = $this->api_documentos_system_unit_to_string;
    }

    public function get_api_documentos_system_unit_to_string()
    {
        if(!empty($this->api_documentos_system_unit_to_string))
        {
            return $this->api_documentos_system_unit_to_string;
        }
    
        $values = ApiDocumentos::where('integradores_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_integradores_servicos_integradores_to_string($integradores_servicos_integradores_to_string)
    {
        if(is_array($integradores_servicos_integradores_to_string))
        {
            $values = Integradores::where('id', 'in', $integradores_servicos_integradores_to_string)->getIndexedArray('nome', 'nome');
            $this->integradores_servicos_integradores_to_string = implode(', ', $values);
        }
        else
        {
            $this->integradores_servicos_integradores_to_string = $integradores_servicos_integradores_to_string;
        }

        $this->vdata['integradores_servicos_integradores_to_string'] = $this->integradores_servicos_integradores_to_string;
    }

    public function get_integradores_servicos_integradores_to_string()
    {
        if(!empty($this->integradores_servicos_integradores_to_string))
        {
            return $this->integradores_servicos_integradores_to_string;
        }
    
        $values = IntegradoresServicos::where('integradores_id', '=', $this->id)->getIndexedArray('integradores_id','{integradores->nome}');
        return implode(', ', $values);
    }

    
}

