<?php

class IntegradoresServicos extends TRecord
{
    const TABLENAME  = 'integradores_servicos';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const cloud_dfe_nfe = '1';
    const cloud_dfe_nfce = '2';
    const cloud_dfe_mdfe = '3';

    private $integradores;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('integradores_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_integradores
     * Sample of usage: $var->integradores = $object;
     * @param $object Instance of Integradores
     */
    public function set_integradores(Integradores $object)
    {
        $this->integradores = $object;
        $this->integradores_id = $object->id;
    }

    /**
     * Method get_integradores
     * Sample of usage: $var->integradores->attribute;
     * @returns Integradores instance
     */
    public function get_integradores()
    {
    
        // loads the associated object
        if (empty($this->integradores))
            $this->integradores = new Integradores($this->integradores_id);
    
        // returns the associated object
        return $this->integradores;
    }

    /**
     * Method getApidocumentosIntegradoresservicoss
     */
    public function getApidocumentosIntegradoresservicoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('integradores_servicos_id', '=', $this->id));
        return ApidocumentosIntegradoresservicos::getObjects( $criteria );
    }

    public function set_apidocumentos_integradoresservicos_api_documentos_to_string($apidocumentos_integradoresservicos_api_documentos_to_string)
    {
        if(is_array($apidocumentos_integradoresservicos_api_documentos_to_string))
        {
            $values = ApiDocumentos::where('id', 'in', $apidocumentos_integradoresservicos_api_documentos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->apidocumentos_integradoresservicos_api_documentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->apidocumentos_integradoresservicos_api_documentos_to_string = $apidocumentos_integradoresservicos_api_documentos_to_string;
        }

        $this->vdata['apidocumentos_integradoresservicos_api_documentos_to_string'] = $this->apidocumentos_integradoresservicos_api_documentos_to_string;
    }

    public function get_apidocumentos_integradoresservicos_api_documentos_to_string()
    {
        if(!empty($this->apidocumentos_integradoresservicos_api_documentos_to_string))
        {
            return $this->apidocumentos_integradoresservicos_api_documentos_to_string;
        }
    
        $values = ApidocumentosIntegradoresservicos::where('integradores_servicos_id', '=', $this->id)->getIndexedArray('api_documentos_id','{api_documentos->descricao}');
        return implode(', ', $values);
    }

    public function set_apidocumentos_integradoresservicos_integradores_servicos_to_string($apidocumentos_integradoresservicos_integradores_servicos_to_string)
    {
        if(is_array($apidocumentos_integradoresservicos_integradores_servicos_to_string))
        {
            $values = IntegradoresServicos::where('id', 'in', $apidocumentos_integradoresservicos_integradores_servicos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->apidocumentos_integradoresservicos_integradores_servicos_to_string = implode(', ', $values);
        }
        else
        {
            $this->apidocumentos_integradoresservicos_integradores_servicos_to_string = $apidocumentos_integradoresservicos_integradores_servicos_to_string;
        }

        $this->vdata['apidocumentos_integradoresservicos_integradores_servicos_to_string'] = $this->apidocumentos_integradoresservicos_integradores_servicos_to_string;
    }

    public function get_apidocumentos_integradoresservicos_integradores_servicos_to_string()
    {
        if(!empty($this->apidocumentos_integradoresservicos_integradores_servicos_to_string))
        {
            return $this->apidocumentos_integradoresservicos_integradores_servicos_to_string;
        }
    
        $values = ApidocumentosIntegradoresservicos::where('integradores_servicos_id', '=', $this->id)->getIndexedArray('integradores_servicos_id','{integradores_servicos->descricao}');
        return implode(', ', $values);
    }

    
}

