<?php

class InutilizarNumero extends TRecord
{
    const TABLENAME  = 'inutilizar_numero';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'created_at';
    const UPDATEDAT  = 'update_at';

    private $system_unit;
    private $system_users;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('created_at');
        parent::addAttribute('system_user');
        parent::addAttribute('update_at');
        parent::addAttribute('deleted_at');
        parent::addAttribute('ninicio');
        parent::addAttribute('nfinal');
        parent::addAttribute('serie');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('system_users_id');
        parent::addAttribute('xml_retorno');
        parent::addAttribute('protocolo');
        parent::addAttribute('xmotivo');
        parent::addAttribute('cstat');
        parent::addAttribute('notafiscal_id');
        parent::addAttribute('xjust');
        parent::addAttribute('tipo');
    
    }

    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users(SystemUsers $object)
    {
        $this->system_users = $object;
        $this->system_users_id = $object->id;
    }

    /**
     * Method get_system_users
     * Sample of usage: $var->system_users->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users()
    {
    
        // loads the associated object
        if (empty($this->system_users))
            $this->system_users = new SystemUsers($this->system_users_id);
    
        // returns the associated object
        return $this->system_users;
    }

  
    public function get_status_inut()
    {

        if ($this->cstat != 102) {
            return '🔵';
        } else {

            return '🟢' ;

        }

    }

    public function get_tipo_envio()
{
    if ($this->tipo == 1) {
        return "<label style='width:100px; font-size: 10px;' class='label label-primary'> <center> Via Ranger </center></label>";
    } else{
        return "<label style='width:100px; font-size: 10px;' class='label label-success'><center>Via Documento</center></label>";
    }  
}
    
}

