<?php

class MdfeInfmundescarga extends TRecord
{
    const TABLENAME  = 'mdfe_infmundescarga';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $mdfe;
    private $cidade;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('mdfe_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('cidade_id');
        parent::addAttribute('cMunDescarga');
        parent::addAttribute('xMunDescarga');
            
    }

    /**
     * Method set_mdfe
     * Sample of usage: $var->mdfe = $object;
     * @param $object Instance of Mdfe
     */
    public function set_mdfe(Mdfe $object)
    {
        $this->mdfe = $object;
        $this->mdfe_id = $object->id;
    }

    /**
     * Method get_mdfe
     * Sample of usage: $var->mdfe->attribute;
     * @returns Mdfe instance
     */
    public function get_mdfe()
    {
    
        // loads the associated object
        if (empty($this->mdfe))
            $this->mdfe = new Mdfe($this->mdfe_id);
    
        // returns the associated object
        return $this->mdfe;
    }
    /**
     * Method set_cidade
     * Sample of usage: $var->cidade = $object;
     * @param $object Instance of Cidade
     */
    public function set_cidade(Cidade $object)
    {
        $this->cidade = $object;
        $this->cidade_id = $object->id;
    }

    /**
     * Method get_cidade
     * Sample of usage: $var->cidade->attribute;
     * @returns Cidade instance
     */
    public function get_cidade()
    {
    
        // loads the associated object
        if (empty($this->cidade))
            $this->cidade = new Cidade($this->cidade_id);
    
        // returns the associated object
        return $this->cidade;
    }

    /**
     * Method getMdfeCtess
     */
    public function getMdfeCtess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('mdfe_infmundescarga_id', '=', $this->id));
        return MdfeCtes::getObjects( $criteria );
    }
    /**
     * Method getMdfeMdfess
     */
    public function getMdfeMdfess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('mdfe_infmundescarga_id', '=', $this->id));
        return MdfeMdfes::getObjects( $criteria );
    }
    /**
     * Method getMdfeNfess
     */
    public function getMdfeNfess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('mdfe_infmundescarga_id', '=', $this->id));
        return MdfeNfes::getObjects( $criteria );
    }

    public function set_mdfe_ctes_fk_indReentrega_to_string($mdfe_ctes_fk_indReentrega_to_string)
    {
        if(is_array($mdfe_ctes_fk_indReentrega_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_ctes_fk_indReentrega_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_ctes_fk_indReentrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_ctes_fk_indReentrega_to_string = $mdfe_ctes_fk_indReentrega_to_string;
        }

        $this->vdata['mdfe_ctes_fk_indReentrega_to_string'] = $this->mdfe_ctes_fk_indReentrega_to_string;
    }

    public function get_mdfe_ctes_fk_indReentrega_to_string()
    {
        if(!empty($this->mdfe_ctes_fk_indReentrega_to_string))
        {
            return $this->mdfe_ctes_fk_indReentrega_to_string;
        }
    
        $values = MdfeCtes::where('mdfe_infmundescarga_id', '=', $this->id)->getIndexedArray('indReentrega','{fk_indReentrega->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_ctes_mdfe_infmundescarga_to_string($mdfe_ctes_mdfe_infmundescarga_to_string)
    {
        if(is_array($mdfe_ctes_mdfe_infmundescarga_to_string))
        {
            $values = MdfeInfmundescarga::where('id', 'in', $mdfe_ctes_mdfe_infmundescarga_to_string)->getIndexedArray('xMunDescarga', 'xMunDescarga');
            $this->mdfe_ctes_mdfe_infmundescarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_ctes_mdfe_infmundescarga_to_string = $mdfe_ctes_mdfe_infmundescarga_to_string;
        }

        $this->vdata['mdfe_ctes_mdfe_infmundescarga_to_string'] = $this->mdfe_ctes_mdfe_infmundescarga_to_string;
    }

    public function get_mdfe_ctes_mdfe_infmundescarga_to_string()
    {
        if(!empty($this->mdfe_ctes_mdfe_infmundescarga_to_string))
        {
            return $this->mdfe_ctes_mdfe_infmundescarga_to_string;
        }
    
        $values = MdfeCtes::where('mdfe_infmundescarga_id', '=', $this->id)->getIndexedArray('mdfe_infmundescarga_id','{mdfe_infmundescarga->xMunDescarga}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfes_fk_indReentrega_to_string($mdfe_mdfes_fk_indReentrega_to_string)
    {
        if(is_array($mdfe_mdfes_fk_indReentrega_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_mdfes_fk_indReentrega_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfes_fk_indReentrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfes_fk_indReentrega_to_string = $mdfe_mdfes_fk_indReentrega_to_string;
        }

        $this->vdata['mdfe_mdfes_fk_indReentrega_to_string'] = $this->mdfe_mdfes_fk_indReentrega_to_string;
    }

    public function get_mdfe_mdfes_fk_indReentrega_to_string()
    {
        if(!empty($this->mdfe_mdfes_fk_indReentrega_to_string))
        {
            return $this->mdfe_mdfes_fk_indReentrega_to_string;
        }
    
        $values = MdfeMdfes::where('mdfe_infmundescarga_id', '=', $this->id)->getIndexedArray('indReentrega','{fk_indReentrega->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfes_mdfe_infmundescarga_to_string($mdfe_mdfes_mdfe_infmundescarga_to_string)
    {
        if(is_array($mdfe_mdfes_mdfe_infmundescarga_to_string))
        {
            $values = MdfeInfmundescarga::where('id', 'in', $mdfe_mdfes_mdfe_infmundescarga_to_string)->getIndexedArray('xMunDescarga', 'xMunDescarga');
            $this->mdfe_mdfes_mdfe_infmundescarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfes_mdfe_infmundescarga_to_string = $mdfe_mdfes_mdfe_infmundescarga_to_string;
        }

        $this->vdata['mdfe_mdfes_mdfe_infmundescarga_to_string'] = $this->mdfe_mdfes_mdfe_infmundescarga_to_string;
    }

    public function get_mdfe_mdfes_mdfe_infmundescarga_to_string()
    {
        if(!empty($this->mdfe_mdfes_mdfe_infmundescarga_to_string))
        {
            return $this->mdfe_mdfes_mdfe_infmundescarga_to_string;
        }
    
        $values = MdfeMdfes::where('mdfe_infmundescarga_id', '=', $this->id)->getIndexedArray('mdfe_infmundescarga_id','{mdfe_infmundescarga->xMunDescarga}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_fk_indReentrega_to_string($mdfe_nfes_fk_indReentrega_to_string)
    {
        if(is_array($mdfe_nfes_fk_indReentrega_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_nfes_fk_indReentrega_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_nfes_fk_indReentrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_fk_indReentrega_to_string = $mdfe_nfes_fk_indReentrega_to_string;
        }

        $this->vdata['mdfe_nfes_fk_indReentrega_to_string'] = $this->mdfe_nfes_fk_indReentrega_to_string;
    }

    public function get_mdfe_nfes_fk_indReentrega_to_string()
    {
        if(!empty($this->mdfe_nfes_fk_indReentrega_to_string))
        {
            return $this->mdfe_nfes_fk_indReentrega_to_string;
        }
    
        $values = MdfeNfes::where('mdfe_infmundescarga_id', '=', $this->id)->getIndexedArray('indReentrega','{fk_indReentrega->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_mdfe_infmundescarga_to_string($mdfe_nfes_mdfe_infmundescarga_to_string)
    {
        if(is_array($mdfe_nfes_mdfe_infmundescarga_to_string))
        {
            $values = MdfeInfmundescarga::where('id', 'in', $mdfe_nfes_mdfe_infmundescarga_to_string)->getIndexedArray('xMunDescarga', 'xMunDescarga');
            $this->mdfe_nfes_mdfe_infmundescarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_mdfe_infmundescarga_to_string = $mdfe_nfes_mdfe_infmundescarga_to_string;
        }

        $this->vdata['mdfe_nfes_mdfe_infmundescarga_to_string'] = $this->mdfe_nfes_mdfe_infmundescarga_to_string;
    }

    public function get_mdfe_nfes_mdfe_infmundescarga_to_string()
    {
        if(!empty($this->mdfe_nfes_mdfe_infmundescarga_to_string))
        {
            return $this->mdfe_nfes_mdfe_infmundescarga_to_string;
        }
    
        $values = MdfeNfes::where('mdfe_infmundescarga_id', '=', $this->id)->getIndexedArray('mdfe_infmundescarga_id','{mdfe_infmundescarga->xMunDescarga}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_notafiscal_to_string($mdfe_nfes_notafiscal_to_string)
    {
        if(is_array($mdfe_nfes_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $mdfe_nfes_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_nfes_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_notafiscal_to_string = $mdfe_nfes_notafiscal_to_string;
        }

        $this->vdata['mdfe_nfes_notafiscal_to_string'] = $this->mdfe_nfes_notafiscal_to_string;
    }

    public function get_mdfe_nfes_notafiscal_to_string()
    {
        if(!empty($this->mdfe_nfes_notafiscal_to_string))
        {
            return $this->mdfe_nfes_notafiscal_to_string;
        }
    
        $values = MdfeNfes::where('mdfe_infmundescarga_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    
}

