<?php

class MdfeLogs extends TRecord
{
    const TABLENAME  = 'mdfe_logs';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $mdfe;
    private $system_users;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('mdfe_id');
        parent::addAttribute('system_users_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_mdfe
     * Sample of usage: $var->mdfe = $object;
     * @param $object Instance of Mdfe
     */
    public function set_mdfe(Mdfe $object)
    {
        $this->mdfe = $object;
        $this->mdfe_id = $object->id;
    }

    /**
     * Method get_mdfe
     * Sample of usage: $var->mdfe->attribute;
     * @returns Mdfe instance
     */
    public function get_mdfe()
    {
    
        // loads the associated object
        if (empty($this->mdfe))
            $this->mdfe = new Mdfe($this->mdfe_id);
    
        // returns the associated object
        return $this->mdfe;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users(SystemUsers $object)
    {
        $this->system_users = $object;
        $this->system_users_id = $object->id;
    }

    /**
     * Method get_system_users
     * Sample of usage: $var->system_users->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users()
    {
    
        // loads the associated object
        if (empty($this->system_users))
            $this->system_users = new SystemUsers($this->system_users_id);
    
        // returns the associated object
        return $this->system_users;
    }

    
}

