<?php

class MdfeRespseg extends TRecord
{
    const TABLENAME  = 'mdfe_respSeg';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Emitente = '1';
    const Contratante = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('descricao');
        parent::addAttribute('valor');
            
    }

    /**
     * Method getMdfes
     */
    public function getMdfes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('mdfe_respSeg_id', '=', $this->id));
        return Mdfe::getObjects( $criteria );
    }

    public function set_mdfe_system_unit_to_string($mdfe_system_unit_to_string)
    {
        if(is_array($mdfe_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $mdfe_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->mdfe_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_system_unit_to_string = $mdfe_system_unit_to_string;
        }

        $this->vdata['mdfe_system_unit_to_string'] = $this->mdfe_system_unit_to_string;
    }

    public function get_mdfe_system_unit_to_string()
    {
        if(!empty($this->mdfe_system_unit_to_string))
        {
            return $this->mdfe_system_unit_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpemit_to_string($mdfe_mdfe_tpemit_to_string)
    {
        if(is_array($mdfe_mdfe_tpemit_to_string))
        {
            $values = MdfeTpemit::where('id', 'in', $mdfe_mdfe_tpemit_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpemit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpemit_to_string = $mdfe_mdfe_tpemit_to_string;
        }

        $this->vdata['mdfe_mdfe_tpemit_to_string'] = $this->mdfe_mdfe_tpemit_to_string;
    }

    public function get_mdfe_mdfe_tpemit_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpemit_to_string))
        {
            return $this->mdfe_mdfe_tpemit_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_tpemit_id','{mdfe_tpemit->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpprop_to_string($mdfe_mdfe_tpprop_to_string)
    {
        if(is_array($mdfe_mdfe_tpprop_to_string))
        {
            $values = MdfeTpprop::where('id', 'in', $mdfe_mdfe_tpprop_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpprop_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpprop_to_string = $mdfe_mdfe_tpprop_to_string;
        }

        $this->vdata['mdfe_mdfe_tpprop_to_string'] = $this->mdfe_mdfe_tpprop_to_string;
    }

    public function get_mdfe_mdfe_tpprop_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpprop_to_string))
        {
            return $this->mdfe_mdfe_tpprop_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_tpprop_id','{mdfe_tpprop->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tptransp_to_string($mdfe_mdfe_tptransp_to_string)
    {
        if(is_array($mdfe_mdfe_tptransp_to_string))
        {
            $values = MdfeTptransp::where('id', 'in', $mdfe_mdfe_tptransp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tptransp_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tptransp_to_string = $mdfe_mdfe_tptransp_to_string;
        }

        $this->vdata['mdfe_mdfe_tptransp_to_string'] = $this->mdfe_mdfe_tptransp_to_string;
    }

    public function get_mdfe_mdfe_tptransp_to_string()
    {
        if(!empty($this->mdfe_mdfe_tptransp_to_string))
        {
            return $this->mdfe_mdfe_tptransp_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_tptransp_id','{mdfe_tptransp->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcar_to_string($mdfe_mdfe_tpcar_to_string)
    {
        if(is_array($mdfe_mdfe_tpcar_to_string))
        {
            $values = MdfeTpcar::where('id', 'in', $mdfe_mdfe_tpcar_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcar_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcar_to_string = $mdfe_mdfe_tpcar_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcar_to_string'] = $this->mdfe_mdfe_tpcar_to_string;
    }

    public function get_mdfe_mdfe_tpcar_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcar_to_string))
        {
            return $this->mdfe_mdfe_tpcar_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_tpcar_id','{mdfe_tpcar->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFIni_to_string($mdfe_fk_UFIni_to_string)
    {
        if(is_array($mdfe_fk_UFIni_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFIni_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFIni_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFIni_to_string = $mdfe_fk_UFIni_to_string;
        }

        $this->vdata['mdfe_fk_UFIni_to_string'] = $this->mdfe_fk_UFIni_to_string;
    }

    public function get_mdfe_fk_UFIni_to_string()
    {
        if(!empty($this->mdfe_fk_UFIni_to_string))
        {
            return $this->mdfe_fk_UFIni_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('UFIni','{fk_UFIni->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFFim_to_string($mdfe_fk_UFFim_to_string)
    {
        if(is_array($mdfe_fk_UFFim_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFFim_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFFim_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFFim_to_string = $mdfe_fk_UFFim_to_string;
        }

        $this->vdata['mdfe_fk_UFFim_to_string'] = $this->mdfe_fk_UFFim_to_string;
    }

    public function get_mdfe_fk_UFFim_to_string()
    {
        if(!empty($this->mdfe_fk_UFFim_to_string))
        {
            return $this->mdfe_fk_UFFim_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('UFFim','{fk_UFFim->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCanalVerde_to_string($mdfe_fk_indCanalVerde_to_string)
    {
        if(is_array($mdfe_fk_indCanalVerde_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCanalVerde_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCanalVerde_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCanalVerde_to_string = $mdfe_fk_indCanalVerde_to_string;
        }

        $this->vdata['mdfe_fk_indCanalVerde_to_string'] = $this->mdfe_fk_indCanalVerde_to_string;
    }

    public function get_mdfe_fk_indCanalVerde_to_string()
    {
        if(!empty($this->mdfe_fk_indCanalVerde_to_string))
        {
            return $this->mdfe_fk_indCanalVerde_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('indCanalVerde','{fk_indCanalVerde->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCarregaPosterior_to_string($mdfe_fk_indCarregaPosterior_to_string)
    {
        if(is_array($mdfe_fk_indCarregaPosterior_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCarregaPosterior_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCarregaPosterior_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCarregaPosterior_to_string = $mdfe_fk_indCarregaPosterior_to_string;
        }

        $this->vdata['mdfe_fk_indCarregaPosterior_to_string'] = $this->mdfe_fk_indCarregaPosterior_to_string;
    }

    public function get_mdfe_fk_indCarregaPosterior_to_string()
    {
        if(!empty($this->mdfe_fk_indCarregaPosterior_to_string))
        {
            return $this->mdfe_fk_indCarregaPosterior_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('indCarregaPosterior','{fk_indCarregaPosterior->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_respSeg_to_string($mdfe_mdfe_respSeg_to_string)
    {
        if(is_array($mdfe_mdfe_respSeg_to_string))
        {
            $values = MdfeRespseg::where('id', 'in', $mdfe_mdfe_respSeg_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_respSeg_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_respSeg_to_string = $mdfe_mdfe_respSeg_to_string;
        }

        $this->vdata['mdfe_mdfe_respSeg_to_string'] = $this->mdfe_mdfe_respSeg_to_string;
    }

    public function get_mdfe_mdfe_respSeg_to_string()
    {
        if(!empty($this->mdfe_mdfe_respSeg_to_string))
        {
            return $this->mdfe_mdfe_respSeg_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_respSeg_id','{mdfe_respSeg->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_cunid_to_string($mdfe_mdfe_cunid_to_string)
    {
        if(is_array($mdfe_mdfe_cunid_to_string))
        {
            $values = MdfeCunid::where('id', 'in', $mdfe_mdfe_cunid_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_cunid_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_cunid_to_string = $mdfe_mdfe_cunid_to_string;
        }

        $this->vdata['mdfe_mdfe_cunid_to_string'] = $this->mdfe_mdfe_cunid_to_string;
    }

    public function get_mdfe_mdfe_cunid_to_string()
    {
        if(!empty($this->mdfe_mdfe_cunid_to_string))
        {
            return $this->mdfe_mdfe_cunid_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_cunid_id','{mdfe_cunid->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcarga_to_string($mdfe_mdfe_tpcarga_to_string)
    {
        if(is_array($mdfe_mdfe_tpcarga_to_string))
        {
            $values = MdfeTpcarga::where('id', 'in', $mdfe_mdfe_tpcarga_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcarga_to_string = $mdfe_mdfe_tpcarga_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcarga_to_string'] = $this->mdfe_mdfe_tpcarga_to_string;
    }

    public function get_mdfe_mdfe_tpcarga_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcarga_to_string))
        {
            return $this->mdfe_mdfe_tpcarga_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_tpcarga_id','{mdfe_tpcarga->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_indpag_to_string($mdfe_mdfe_indpag_to_string)
    {
        if(is_array($mdfe_mdfe_indpag_to_string))
        {
            $values = MdfeIndpag::where('id', 'in', $mdfe_mdfe_indpag_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_indpag_to_string = $mdfe_mdfe_indpag_to_string;
        }

        $this->vdata['mdfe_mdfe_indpag_to_string'] = $this->mdfe_mdfe_indpag_to_string;
    }

    public function get_mdfe_mdfe_indpag_to_string()
    {
        if(!empty($this->mdfe_mdfe_indpag_to_string))
        {
            return $this->mdfe_mdfe_indpag_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_indpag_id','{mdfe_indpag->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indAntecipaAdiant_to_string($mdfe_fk_indAntecipaAdiant_to_string)
    {
        if(is_array($mdfe_fk_indAntecipaAdiant_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indAntecipaAdiant_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indAntecipaAdiant_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indAntecipaAdiant_to_string = $mdfe_fk_indAntecipaAdiant_to_string;
        }

        $this->vdata['mdfe_fk_indAntecipaAdiant_to_string'] = $this->mdfe_fk_indAntecipaAdiant_to_string;
    }

    public function get_mdfe_fk_indAntecipaAdiant_to_string()
    {
        if(!empty($this->mdfe_fk_indAntecipaAdiant_to_string))
        {
            return $this->mdfe_fk_indAntecipaAdiant_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('indAntecipaAdiant','{fk_indAntecipaAdiant->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpRod_to_string($mdfe_mdfe_tpRod_to_string)
    {
        if(is_array($mdfe_mdfe_tpRod_to_string))
        {
            $values = MdfeTprod::where('id', 'in', $mdfe_mdfe_tpRod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpRod_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpRod_to_string = $mdfe_mdfe_tpRod_to_string;
        }

        $this->vdata['mdfe_mdfe_tpRod_to_string'] = $this->mdfe_mdfe_tpRod_to_string;
    }

    public function get_mdfe_mdfe_tpRod_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpRod_to_string))
        {
            return $this->mdfe_mdfe_tpRod_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_tpRod_id','{mdfe_tpRod->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_veic_estado_to_string($mdfe_veic_estado_to_string)
    {
        if(is_array($mdfe_veic_estado_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_veic_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_veic_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veic_estado_to_string = $mdfe_veic_estado_to_string;
        }

        $this->vdata['mdfe_veic_estado_to_string'] = $this->mdfe_veic_estado_to_string;
    }

    public function get_mdfe_veic_estado_to_string()
    {
        if(!empty($this->mdfe_veic_estado_to_string))
        {
            return $this->mdfe_veic_estado_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('veic_estado_id','{veic_estado->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_veiculo_to_string($mdfe_veiculo_to_string)
    {
        if(is_array($mdfe_veiculo_to_string))
        {
            $values = Veiculo::where('id', 'in', $mdfe_veiculo_to_string)->getIndexedArray('modelo_marca', 'modelo_marca');
            $this->mdfe_veiculo_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veiculo_to_string = $mdfe_veiculo_to_string;
        }

        $this->vdata['mdfe_veiculo_to_string'] = $this->mdfe_veiculo_to_string;
    }

    public function get_mdfe_veiculo_to_string()
    {
        if(!empty($this->mdfe_veiculo_to_string))
        {
            return $this->mdfe_veiculo_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('veiculo_id','{veiculo->modelo_marca}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_situacao_to_string($mdfe_mdfe_situacao_to_string)
    {
        if(is_array($mdfe_mdfe_situacao_to_string))
        {
            $values = MdfeSituacao::where('id', 'in', $mdfe_mdfe_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_situacao_to_string = $mdfe_mdfe_situacao_to_string;
        }

        $this->vdata['mdfe_mdfe_situacao_to_string'] = $this->mdfe_mdfe_situacao_to_string;
    }

    public function get_mdfe_mdfe_situacao_to_string()
    {
        if(!empty($this->mdfe_mdfe_situacao_to_string))
        {
            return $this->mdfe_mdfe_situacao_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_situacao_id','{mdfe_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpamb_to_string($mdfe_mdfe_tpamb_to_string)
    {
        if(is_array($mdfe_mdfe_tpamb_to_string))
        {
            $values = MdfeTpamb::where('id', 'in', $mdfe_mdfe_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpamb_to_string = $mdfe_mdfe_tpamb_to_string;
        }

        $this->vdata['mdfe_mdfe_tpamb_to_string'] = $this->mdfe_mdfe_tpamb_to_string;
    }

    public function get_mdfe_mdfe_tpamb_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpamb_to_string))
        {
            return $this->mdfe_mdfe_tpamb_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('mdfe_tpamb_id','{mdfe_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_api_documentos_to_string($mdfe_api_documentos_to_string)
    {
        if(is_array($mdfe_api_documentos_to_string))
        {
            $values = ApiDocumentos::where('id', 'in', $mdfe_api_documentos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_api_documentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_api_documentos_to_string = $mdfe_api_documentos_to_string;
        }

        $this->vdata['mdfe_api_documentos_to_string'] = $this->mdfe_api_documentos_to_string;
    }

    public function get_mdfe_api_documentos_to_string()
    {
        if(!empty($this->mdfe_api_documentos_to_string))
        {
            return $this->mdfe_api_documentos_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('api_documentos_id','{api_documentos->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_cidade_encerramento_to_string($mdfe_cidade_encerramento_to_string)
    {
        if(is_array($mdfe_cidade_encerramento_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_cidade_encerramento_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_cidade_encerramento_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_cidade_encerramento_to_string = $mdfe_cidade_encerramento_to_string;
        }

        $this->vdata['mdfe_cidade_encerramento_to_string'] = $this->mdfe_cidade_encerramento_to_string;
    }

    public function get_mdfe_cidade_encerramento_to_string()
    {
        if(!empty($this->mdfe_cidade_encerramento_to_string))
        {
            return $this->mdfe_cidade_encerramento_to_string;
        }
    
        $values = Mdfe::where('mdfe_respSeg_id', '=', $this->id)->getIndexedArray('cidade_encerramento_id','{cidade_encerramento->nome}');
        return implode(', ', $values);
    }

    
}

