<?php

class MdfeSeries extends TRecord
{
    const TABLENAME  = 'mdfe_series';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_unit;
    private $mdfe_tpamb;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('mdfe_tpamb_id');
        parent::addAttribute('serie');
        parent::addAttribute('sequencial');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_mdfe_tpamb
     * Sample of usage: $var->mdfe_tpamb = $object;
     * @param $object Instance of MdfeTpamb
     */
    public function set_mdfe_tpamb(MdfeTpamb $object)
    {
        $this->mdfe_tpamb = $object;
        $this->mdfe_tpamb_id = $object->id;
    }

    /**
     * Method get_mdfe_tpamb
     * Sample of usage: $var->mdfe_tpamb->attribute;
     * @returns MdfeTpamb instance
     */
    public function get_mdfe_tpamb()
    {
    
        // loads the associated object
        if (empty($this->mdfe_tpamb))
            $this->mdfe_tpamb = new MdfeTpamb($this->mdfe_tpamb_id);
    
        // returns the associated object
        return $this->mdfe_tpamb;
    }

    
}

