<?php

class MeioPagamentoTef extends TRecord
{
    const TABLENAME  = 'meio_pagamento_tef';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getFormaPagamentos
     */
    public function getFormaPagamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('meio_pagamento_tef_id', '=', $this->id));
        return FormaPagamento::getObjects( $criteria );
    }

    public function set_forma_pagamento_tipo_documento_to_string($forma_pagamento_tipo_documento_to_string)
    {
        if(is_array($forma_pagamento_tipo_documento_to_string))
        {
            $values = TipoDocumento::where('id', 'in', $forma_pagamento_tipo_documento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->forma_pagamento_tipo_documento_to_string = implode(', ', $values);
        }
        else
        {
            $this->forma_pagamento_tipo_documento_to_string = $forma_pagamento_tipo_documento_to_string;
        }

        $this->vdata['forma_pagamento_tipo_documento_to_string'] = $this->forma_pagamento_tipo_documento_to_string;
    }

    public function get_forma_pagamento_tipo_documento_to_string()
    {
        if(!empty($this->forma_pagamento_tipo_documento_to_string))
        {
            return $this->forma_pagamento_tipo_documento_to_string;
        }
    
        $values = FormaPagamento::where('meio_pagamento_tef_id', '=', $this->id)->getIndexedArray('tipo_documento_id','{tipo_documento->descricao}');
        return implode(', ', $values);
    }

    public function set_forma_pagamento_meio_pagamento_tef_to_string($forma_pagamento_meio_pagamento_tef_to_string)
    {
        if(is_array($forma_pagamento_meio_pagamento_tef_to_string))
        {
            $values = MeioPagamentoTef::where('id', 'in', $forma_pagamento_meio_pagamento_tef_to_string)->getIndexedArray('descricao', 'descricao');
            $this->forma_pagamento_meio_pagamento_tef_to_string = implode(', ', $values);
        }
        else
        {
            $this->forma_pagamento_meio_pagamento_tef_to_string = $forma_pagamento_meio_pagamento_tef_to_string;
        }

        $this->vdata['forma_pagamento_meio_pagamento_tef_to_string'] = $this->forma_pagamento_meio_pagamento_tef_to_string;
    }

    public function get_forma_pagamento_meio_pagamento_tef_to_string()
    {
        if(!empty($this->forma_pagamento_meio_pagamento_tef_to_string))
        {
            return $this->forma_pagamento_meio_pagamento_tef_to_string;
        }
    
        $values = FormaPagamento::where('meio_pagamento_tef_id', '=', $this->id)->getIndexedArray('meio_pagamento_tef_id','{meio_pagamento_tef->descricao}');
        return implode(', ', $values);
    }

    public function set_forma_pagamento_notafiscal_tpag_to_string($forma_pagamento_notafiscal_tpag_to_string)
    {
        if(is_array($forma_pagamento_notafiscal_tpag_to_string))
        {
            $values = NotafiscalTpag::where('id', 'in', $forma_pagamento_notafiscal_tpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->forma_pagamento_notafiscal_tpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->forma_pagamento_notafiscal_tpag_to_string = $forma_pagamento_notafiscal_tpag_to_string;
        }

        $this->vdata['forma_pagamento_notafiscal_tpag_to_string'] = $this->forma_pagamento_notafiscal_tpag_to_string;
    }

    public function get_forma_pagamento_notafiscal_tpag_to_string()
    {
        if(!empty($this->forma_pagamento_notafiscal_tpag_to_string))
        {
            return $this->forma_pagamento_notafiscal_tpag_to_string;
        }
    
        $values = FormaPagamento::where('meio_pagamento_tef_id', '=', $this->id)->getIndexedArray('notafiscal_tpag_id','{notafiscal_tpag->descricao}');
        return implode(', ', $values);
    }

    
}

