<?php

class MovimentacaoOrigem extends TRecord
{
    const TABLENAME  = 'movimentacao_origem';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const kraftweb = '1';
    const kraftpdv = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getNotafiscals
     */
    public function getNotafiscals()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movimentacao_origem_id', '=', $this->id));
        return Notafiscal::getObjects( $criteria );
    }
    /**
     * Method getVendas
     */
    public function getVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('movimentacao_origem_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }

    public function set_notafiscal_system_unit_to_string($notafiscal_system_unit_to_string)
    {
        if(is_array($notafiscal_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_system_unit_to_string = $notafiscal_system_unit_to_string;
        }

        $this->vdata['notafiscal_system_unit_to_string'] = $this->notafiscal_system_unit_to_string;
    }

    public function get_notafiscal_system_unit_to_string()
    {
        if(!empty($this->notafiscal_system_unit_to_string))
        {
            return $this->notafiscal_system_unit_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_cliente_to_string($notafiscal_cliente_to_string)
    {
        if(is_array($notafiscal_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $notafiscal_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_cliente_to_string = $notafiscal_cliente_to_string;
        }

        $this->vdata['notafiscal_cliente_to_string'] = $this->notafiscal_cliente_to_string;
    }

    public function get_notafiscal_cliente_to_string()
    {
        if(!empty($this->notafiscal_cliente_to_string))
        {
            return $this->notafiscal_cliente_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_venda_to_string($notafiscal_venda_to_string)
    {
        if(is_array($notafiscal_venda_to_string))
        {
            $values = Venda::where('id', 'in', $notafiscal_venda_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_venda_to_string = $notafiscal_venda_to_string;
        }

        $this->vdata['notafiscal_venda_to_string'] = $this->notafiscal_venda_to_string;
    }

    public function get_notafiscal_venda_to_string()
    {
        if(!empty($this->notafiscal_venda_to_string))
        {
            return $this->notafiscal_venda_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_nf_tipodocumento_to_string($notafiscal_nf_tipodocumento_to_string)
    {
        if(is_array($notafiscal_nf_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_nf_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_nf_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_nf_tipodocumento_to_string = $notafiscal_nf_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_nf_tipodocumento_to_string'] = $this->notafiscal_nf_tipodocumento_to_string;
    }

    public function get_notafiscal_nf_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_nf_tipodocumento_to_string))
        {
            return $this->notafiscal_nf_tipodocumento_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('nf_tipodocumento_id','{nf_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_situacao_to_string($notafiscal_notafiscal_situacao_to_string)
    {
        if(is_array($notafiscal_notafiscal_situacao_to_string))
        {
            $values = NotafiscalSituacao::where('id', 'in', $notafiscal_notafiscal_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_situacao_to_string = $notafiscal_notafiscal_situacao_to_string;
        }

        $this->vdata['notafiscal_notafiscal_situacao_to_string'] = $this->notafiscal_notafiscal_situacao_to_string;
    }

    public function get_notafiscal_notafiscal_situacao_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_situacao_to_string))
        {
            return $this->notafiscal_notafiscal_situacao_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_situacao_id','{notafiscal_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_crt_to_string($notafiscal_notafiscal_crt_to_string)
    {
        if(is_array($notafiscal_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $notafiscal_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_crt_to_string = $notafiscal_notafiscal_crt_to_string;
        }

        $this->vdata['notafiscal_notafiscal_crt_to_string'] = $this->notafiscal_notafiscal_crt_to_string;
    }

    public function get_notafiscal_notafiscal_crt_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_crt_to_string))
        {
            return $this->notafiscal_notafiscal_crt_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indiedest_to_string($notafiscal_notafiscal_indiedest_to_string)
    {
        if(is_array($notafiscal_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $notafiscal_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indiedest_to_string = $notafiscal_notafiscal_indiedest_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indiedest_to_string'] = $this->notafiscal_notafiscal_indiedest_to_string;
    }

    public function get_notafiscal_notafiscal_indiedest_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indiedest_to_string))
        {
            return $this->notafiscal_notafiscal_indiedest_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscaldest_to_string($notafiscal_notafiscaldest_to_string)
    {
        if(is_array($notafiscal_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $notafiscal_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscaldest_to_string = $notafiscal_notafiscaldest_to_string;
        }

        $this->vdata['notafiscal_notafiscaldest_to_string'] = $this->notafiscal_notafiscaldest_to_string;
    }

    public function get_notafiscal_notafiscaldest_to_string()
    {
        if(!empty($this->notafiscal_notafiscaldest_to_string))
        {
            return $this->notafiscal_notafiscaldest_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpimp_to_string($notafiscal_notafiscal_tpimp_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $notafiscal_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpimp_to_string = $notafiscal_notafiscal_tpimp_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpimp_to_string'] = $this->notafiscal_notafiscal_tpimp_to_string;
    }

    public function get_notafiscal_notafiscal_tpimp_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpimp_to_string))
        {
            return $this->notafiscal_notafiscal_tpimp_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpemis_to_string($notafiscal_notafiscal_tpemis_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpemis_to_string))
        {
            $values = NotafiscalTpemis::where('id', 'in', $notafiscal_notafiscal_tpemis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpemis_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpemis_to_string = $notafiscal_notafiscal_tpemis_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpemis_to_string'] = $this->notafiscal_notafiscal_tpemis_to_string;
    }

    public function get_notafiscal_notafiscal_tpemis_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpemis_to_string))
        {
            return $this->notafiscal_notafiscal_tpemis_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_tpemis_id','{notafiscal_tpemis->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_finnfe_to_string($notafiscal_notafiscal_finnfe_to_string)
    {
        if(is_array($notafiscal_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $notafiscal_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_finnfe_to_string = $notafiscal_notafiscal_finnfe_to_string;
        }

        $this->vdata['notafiscal_notafiscal_finnfe_to_string'] = $this->notafiscal_notafiscal_finnfe_to_string;
    }

    public function get_notafiscal_notafiscal_finnfe_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_finnfe_to_string))
        {
            return $this->notafiscal_notafiscal_finnfe_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indfinal_to_string($notafiscal_notafiscal_indfinal_to_string)
    {
        if(is_array($notafiscal_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $notafiscal_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indfinal_to_string = $notafiscal_notafiscal_indfinal_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indfinal_to_string'] = $this->notafiscal_notafiscal_indfinal_to_string;
    }

    public function get_notafiscal_notafiscal_indfinal_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indfinal_to_string))
        {
            return $this->notafiscal_notafiscal_indfinal_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpres_to_string($notafiscal_notafiscal_indpres_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $notafiscal_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpres_to_string = $notafiscal_notafiscal_indpres_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpres_to_string'] = $this->notafiscal_notafiscal_indpres_to_string;
    }

    public function get_notafiscal_notafiscal_indpres_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpres_to_string))
        {
            return $this->notafiscal_notafiscal_indpres_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpag_to_string($notafiscal_notafiscal_indpag_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $notafiscal_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpag_to_string = $notafiscal_notafiscal_indpag_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpag_to_string'] = $this->notafiscal_notafiscal_indpag_to_string;
    }

    public function get_notafiscal_notafiscal_indpag_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpag_to_string))
        {
            return $this->notafiscal_notafiscal_indpag_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dispositivos_to_string($notafiscal_dispositivos_to_string)
    {
        if(is_array($notafiscal_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $notafiscal_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dispositivos_to_string = $notafiscal_dispositivos_to_string;
        }

        $this->vdata['notafiscal_dispositivos_to_string'] = $this->notafiscal_dispositivos_to_string;
    }

    public function get_notafiscal_dispositivos_to_string()
    {
        if(!empty($this->notafiscal_dispositivos_to_string))
        {
            return $this->notafiscal_dispositivos_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpamb_to_string($notafiscal_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpamb_to_string = $notafiscal_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpamb_to_string'] = $this->notafiscal_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_notafiscal_tpamb_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_mod_to_string($notafiscal_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_mod_to_string = $notafiscal_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_notafiscal_mod_to_string'] = $this->notafiscal_notafiscal_mod_to_string;
    }

    public function get_notafiscal_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_mod_to_string))
        {
            return $this->notafiscal_notafiscal_mod_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_modfrete_to_string($notafiscal_notafiscal_modfrete_to_string)
    {
        if(is_array($notafiscal_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $notafiscal_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_modfrete_to_string = $notafiscal_notafiscal_modfrete_to_string;
        }

        $this->vdata['notafiscal_notafiscal_modfrete_to_string'] = $this->notafiscal_notafiscal_modfrete_to_string;
    }

    public function get_notafiscal_notafiscal_modfrete_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_modfrete_to_string))
        {
            return $this->notafiscal_notafiscal_modfrete_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_natureza_operacao_to_string($notafiscal_natureza_operacao_to_string)
    {
        if(is_array($notafiscal_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $notafiscal_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_natureza_operacao_to_string = $notafiscal_natureza_operacao_to_string;
        }

        $this->vdata['notafiscal_natureza_operacao_to_string'] = $this->notafiscal_natureza_operacao_to_string;
    }

    public function get_notafiscal_natureza_operacao_to_string()
    {
        if(!empty($this->notafiscal_natureza_operacao_to_string))
        {
            return $this->notafiscal_natureza_operacao_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_movimentacao_origem_to_string($notafiscal_movimentacao_origem_to_string)
    {
        if(is_array($notafiscal_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $notafiscal_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_movimentacao_origem_to_string = $notafiscal_movimentacao_origem_to_string;
        }

        $this->vdata['notafiscal_movimentacao_origem_to_string'] = $this->notafiscal_movimentacao_origem_to_string;
    }

    public function get_notafiscal_movimentacao_origem_to_string()
    {
        if(!empty($this->notafiscal_movimentacao_origem_to_string))
        {
            return $this->notafiscal_movimentacao_origem_to_string;
        }
    
        $values = Notafiscal::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_situacao_to_string($venda_venda_situacao_to_string)
    {
        if(is_array($venda_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_situacao_to_string = $venda_venda_situacao_to_string;
        }

        $this->vdata['venda_venda_situacao_to_string'] = $this->venda_venda_situacao_to_string;
    }

    public function get_venda_venda_situacao_to_string()
    {
        if(!empty($this->venda_venda_situacao_to_string))
        {
            return $this->venda_venda_situacao_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_orcamento_to_string($venda_orcamento_to_string)
    {
        if(is_array($venda_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $venda_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->venda_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_orcamento_to_string = $venda_orcamento_to_string;
        }

        $this->vdata['venda_orcamento_to_string'] = $this->venda_orcamento_to_string;
    }

    public function get_venda_orcamento_to_string()
    {
        if(!empty($this->venda_orcamento_to_string))
        {
            return $this->venda_orcamento_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_vendedor_to_string($venda_vendedor_to_string)
    {
        if(is_array($venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_vendedor_to_string = $venda_vendedor_to_string;
        }

        $this->vdata['venda_vendedor_to_string'] = $this->venda_vendedor_to_string;
    }

    public function get_venda_vendedor_to_string()
    {
        if(!empty($this->venda_vendedor_to_string))
        {
            return $this->venda_vendedor_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_venda_dispositivos_to_string($venda_dispositivos_to_string)
    {
        if(is_array($venda_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $venda_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->venda_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_dispositivos_to_string = $venda_dispositivos_to_string;
        }

        $this->vdata['venda_dispositivos_to_string'] = $this->venda_dispositivos_to_string;
    }

    public function get_venda_dispositivos_to_string()
    {
        if(!empty($this->venda_dispositivos_to_string))
        {
            return $this->venda_dispositivos_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_to_string($venda_cliente_to_string)
    {
        if(is_array($venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_to_string = $venda_cliente_to_string;
        }

        $this->vdata['venda_cliente_to_string'] = $this->venda_cliente_to_string;
    }

    public function get_venda_cliente_to_string()
    {
        if(!empty($this->venda_cliente_to_string))
        {
            return $this->venda_cliente_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_venda_system_unit_to_string($venda_system_unit_to_string)
    {
        if(is_array($venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_system_unit_to_string = $venda_system_unit_to_string;
        }

        $this->vdata['venda_system_unit_to_string'] = $this->venda_system_unit_to_string;
    }

    public function get_venda_system_unit_to_string()
    {
        if(!empty($this->venda_system_unit_to_string))
        {
            return $this->venda_system_unit_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_filial_saida_to_string($venda_filial_saida_to_string)
    {
        if(is_array($venda_filial_saida_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_filial_saida_to_string)->getIndexedArray('name', 'name');
            $this->venda_filial_saida_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_filial_saida_to_string = $venda_filial_saida_to_string;
        }

        $this->vdata['venda_filial_saida_to_string'] = $this->venda_filial_saida_to_string;
    }

    public function get_venda_filial_saida_to_string()
    {
        if(!empty($this->venda_filial_saida_to_string))
        {
            return $this->venda_filial_saida_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('filial_saida_id','{filial_saida->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_modalidade_to_string($venda_venda_modalidade_to_string)
    {
        if(is_array($venda_venda_modalidade_to_string))
        {
            $values = VendaModalidade::where('id', 'in', $venda_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_modalidade_to_string = $venda_venda_modalidade_to_string;
        }

        $this->vdata['venda_venda_modalidade_to_string'] = $this->venda_venda_modalidade_to_string;
    }

    public function get_venda_venda_modalidade_to_string()
    {
        if(!empty($this->venda_venda_modalidade_to_string))
        {
            return $this->venda_venda_modalidade_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('venda_modalidade_id','{venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_tipo_pagamento_to_string($venda_venda_tipo_pagamento_to_string)
    {
        if(is_array($venda_venda_tipo_pagamento_to_string))
        {
            $values = VendaTipoPagamento::where('id', 'in', $venda_venda_tipo_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_tipo_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_tipo_pagamento_to_string = $venda_venda_tipo_pagamento_to_string;
        }

        $this->vdata['venda_venda_tipo_pagamento_to_string'] = $this->venda_venda_tipo_pagamento_to_string;
    }

    public function get_venda_venda_tipo_pagamento_to_string()
    {
        if(!empty($this->venda_venda_tipo_pagamento_to_string))
        {
            return $this->venda_venda_tipo_pagamento_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('venda_tipo_pagamento_id','{venda_tipo_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_endereco_to_string($venda_cliente_endereco_to_string)
    {
        if(is_array($venda_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $venda_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->venda_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_endereco_to_string = $venda_cliente_endereco_to_string;
        }

        $this->vdata['venda_cliente_endereco_to_string'] = $this->venda_cliente_endereco_to_string;
    }

    public function get_venda_cliente_endereco_to_string()
    {
        if(!empty($this->venda_cliente_endereco_to_string))
        {
            return $this->venda_cliente_endereco_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_venda_tabela_preco_to_string($venda_tabela_preco_to_string)
    {
        if(is_array($venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_tabela_preco_to_string = $venda_tabela_preco_to_string;
        }

        $this->vdata['venda_tabela_preco_to_string'] = $this->venda_tabela_preco_to_string;
    }

    public function get_venda_tabela_preco_to_string()
    {
        if(!empty($this->venda_tabela_preco_to_string))
        {
            return $this->venda_tabela_preco_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_movimentacao_origem_to_string($venda_movimentacao_origem_to_string)
    {
        if(is_array($venda_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $venda_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_movimentacao_origem_to_string = $venda_movimentacao_origem_to_string;
        }

        $this->vdata['venda_movimentacao_origem_to_string'] = $this->venda_movimentacao_origem_to_string;
    }

    public function get_venda_movimentacao_origem_to_string()
    {
        if(!empty($this->venda_movimentacao_origem_to_string))
        {
            return $this->venda_movimentacao_origem_to_string;
        }
    
        $values = Venda::where('movimentacao_origem_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    
}

