<?php

class NatopExcecaoTributo extends TRecord
{
    const TABLENAME  = 'natop_excecao_tributo';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const ICMS = '1';
    const IPI = '2';
    const PIS = '3';
    const COFINS = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getNaturezaOperacaoExcecaos
     */
    public function getNaturezaOperacaoExcecaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natop_excecao_tributo_id', '=', $this->id));
        return NaturezaOperacaoExcecao::getObjects( $criteria );
    }

    public function set_natureza_operacao_excecao_natureza_operacao_to_string($natureza_operacao_excecao_natureza_operacao_to_string)
    {
        if(is_array($natureza_operacao_excecao_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $natureza_operacao_excecao_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natureza_operacao_to_string = $natureza_operacao_excecao_natureza_operacao_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natureza_operacao_to_string'] = $this->natureza_operacao_excecao_natureza_operacao_to_string;
    }

    public function get_natureza_operacao_excecao_natureza_operacao_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natureza_operacao_to_string))
        {
            return $this->natureza_operacao_excecao_natureza_operacao_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_natop_excecao_tributo_to_string($natureza_operacao_excecao_natop_excecao_tributo_to_string)
    {
        if(is_array($natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            $values = NatopExcecaoTributo::where('id', 'in', $natureza_operacao_excecao_natop_excecao_tributo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = $natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natop_excecao_tributo_to_string'] = $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
    }

    public function get_natureza_operacao_excecao_natop_excecao_tributo_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            return $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('natop_excecao_tributo_id','{natop_excecao_tributo->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_pis_to_string($natureza_operacao_excecao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_excecao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_pis_to_string = $natureza_operacao_excecao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_pis_to_string'] = $this->natureza_operacao_excecao_cst_pis_to_string;
    }

    public function get_natureza_operacao_excecao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_pis_to_string))
        {
            return $this->natureza_operacao_excecao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_ipi_to_string($natureza_operacao_excecao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_excecao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_ipi_to_string = $natureza_operacao_excecao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_ipi_to_string'] = $this->natureza_operacao_excecao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_excecao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_excecao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_icms_to_string($natureza_operacao_excecao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_excecao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_icms_to_string = $natureza_operacao_excecao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_icms_to_string'] = $this->natureza_operacao_excecao_cst_icms_to_string;
    }

    public function get_natureza_operacao_excecao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_icms_to_string))
        {
            return $this->natureza_operacao_excecao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_cofins_to_string($natureza_operacao_excecao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_excecao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_cofins_to_string = $natureza_operacao_excecao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_cofins_to_string'] = $this->natureza_operacao_excecao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_excecao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_excecao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbc_to_string($natureza_operacao_excecao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = $natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbcst_to_string($natureza_operacao_excecao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = $natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natop_excecao_tributo_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    
}

