<?php

class NaturezaOperacao extends TRecord
{
    const TABLENAME  = 'natureza_operacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $notafiscal_item_modbc;
    private $notafiscal_item_modbcst;
    private $notafiscal_item_motDesICMS;
    private $natureza_operacao_finalidade;
    private $cst_icms;
    private $cst_ipi;
    private $cst_pis;
    private $cst_cofins;
    private $consumidor_final;
    private $cst_icms_nao_contribuinte;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('natureza_operacao_finalidade_id');
        parent::addAttribute('cst_icms_id');
        parent::addAttribute('cst_icms_nao_contribuinte_id');
        parent::addAttribute('cst_ipi_id');
        parent::addAttribute('cst_pis_id');
        parent::addAttribute('cst_cofins_id');
        parent::addAttribute('cfop');
        parent::addAttribute('descricao');
        parent::addAttribute('obs_padrao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('icms_aliquota');
        parent::addAttribute('ipi_aliquota');
        parent::addAttribute('ipi_codigo_enquadramento');
        parent::addAttribute('pis_aliquota');
        parent::addAttribute('pis_base');
        parent::addAttribute('cofins_aliquota');
        parent::addAttribute('consumidor_final_id');
        parent::addAttribute('cofins_base');
        parent::addAttribute('icms_pRedBC');
        parent::addAttribute('icms_pICMS');
        parent::addAttribute('icms_pDif');
        parent::addAttribute('icms_vICMSDeson');
        parent::addAttribute('icms_pMVAST');
        parent::addAttribute('icms_pICMSST');
        parent::addAttribute('icms_pFCP');
        parent::addAttribute('icms_pFCPST');
        parent::addAttribute('icms_pFCPSTRet');
        parent::addAttribute('icms_pST');
        parent::addAttribute('icms_pCredSN');
        parent::addAttribute('icms_pRedBCEfet');
        parent::addAttribute('icms_pICMSEfet');
        parent::addAttribute('notafiscal_item_modbc_id');
        parent::addAttribute('notafiscal_item_modbcst_id');
        parent::addAttribute('notafiscal_item_motDesICMS_id');
        parent::addAttribute('icms_pFCPUFDest');
        parent::addAttribute('icms_pICMSUFDest');
        parent::addAttribute('icms_baseST');
        parent::addAttribute('icms_base');
        parent::addAttribute('cfop_fora');
    
    }

    /**
     * Method set_notafiscal_item_modbc
     * Sample of usage: $var->notafiscal_item_modbc = $object;
     * @param $object Instance of NotafiscalItemModbc
     */
    public function set_notafiscal_item_modbc(NotafiscalItemModbc $object)
    {
        $this->notafiscal_item_modbc = $object;
        $this->notafiscal_item_modbc_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_modbc
     * Sample of usage: $var->notafiscal_item_modbc->attribute;
     * @returns NotafiscalItemModbc instance
     */
    public function get_notafiscal_item_modbc()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_modbc))
            $this->notafiscal_item_modbc = new NotafiscalItemModbc($this->notafiscal_item_modbc_id);
    
        // returns the associated object
        return $this->notafiscal_item_modbc;
    }
    /**
     * Method set_notafiscal_item_modbcst
     * Sample of usage: $var->notafiscal_item_modbcst = $object;
     * @param $object Instance of NotafiscalItemModbcst
     */
    public function set_notafiscal_item_modbcst(NotafiscalItemModbcst $object)
    {
        $this->notafiscal_item_modbcst = $object;
        $this->notafiscal_item_modbcst_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_modbcst
     * Sample of usage: $var->notafiscal_item_modbcst->attribute;
     * @returns NotafiscalItemModbcst instance
     */
    public function get_notafiscal_item_modbcst()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_modbcst))
            $this->notafiscal_item_modbcst = new NotafiscalItemModbcst($this->notafiscal_item_modbcst_id);
    
        // returns the associated object
        return $this->notafiscal_item_modbcst;
    }
    /**
     * Method set_notafiscal_item_motDesICMS
     * Sample of usage: $var->notafiscal_item_motDesICMS = $object;
     * @param $object Instance of NotafiscalItemMotdesicms
     */
    public function set_notafiscal_item_motDesICMS(NotafiscalItemMotdesicms $object)
    {
        $this->notafiscal_item_motDesICMS = $object;
        $this->notafiscal_item_motDesICMS_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_motDesICMS
     * Sample of usage: $var->notafiscal_item_motDesICMS->attribute;
     * @returns NotafiscalItemMotdesicms instance
     */
    public function get_notafiscal_item_motDesICMS()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_motDesICMS))
            $this->notafiscal_item_motDesICMS = new NotafiscalItemMotdesicms($this->notafiscal_item_motDesICMS_id);
    
        // returns the associated object
        return $this->notafiscal_item_motDesICMS;
    }
    /**
     * Method set_natureza_operacao_finalidade
     * Sample of usage: $var->natureza_operacao_finalidade = $object;
     * @param $object Instance of NaturezaOperacaoFinalidade
     */
    public function set_natureza_operacao_finalidade(NaturezaOperacaoFinalidade $object)
    {
        $this->natureza_operacao_finalidade = $object;
        $this->natureza_operacao_finalidade_id = $object->id;
    }

    /**
     * Method get_natureza_operacao_finalidade
     * Sample of usage: $var->natureza_operacao_finalidade->attribute;
     * @returns NaturezaOperacaoFinalidade instance
     */
    public function get_natureza_operacao_finalidade()
    {
    
        // loads the associated object
        if (empty($this->natureza_operacao_finalidade))
            $this->natureza_operacao_finalidade = new NaturezaOperacaoFinalidade($this->natureza_operacao_finalidade_id);
    
        // returns the associated object
        return $this->natureza_operacao_finalidade;
    }
    /**
     * Method set_cst_icms
     * Sample of usage: $var->cst_icms = $object;
     * @param $object Instance of CstIcms
     */
    public function set_cst_icms(CstIcms $object)
    {
        $this->cst_icms = $object;
        $this->cst_icms_id = $object->id;
    }

    /**
     * Method get_cst_icms
     * Sample of usage: $var->cst_icms->attribute;
     * @returns CstIcms instance
     */
    public function get_cst_icms()
    {
    
        // loads the associated object
        if (empty($this->cst_icms))
            $this->cst_icms = new CstIcms($this->cst_icms_id);
    
        // returns the associated object
        return $this->cst_icms;
    }
    /**
     * Method set_cst_ipi
     * Sample of usage: $var->cst_ipi = $object;
     * @param $object Instance of CstIpi
     */
    public function set_cst_ipi(CstIpi $object)
    {
        $this->cst_ipi = $object;
        $this->cst_ipi_id = $object->id;
    }

    /**
     * Method get_cst_ipi
     * Sample of usage: $var->cst_ipi->attribute;
     * @returns CstIpi instance
     */
    public function get_cst_ipi()
    {
    
        // loads the associated object
        if (empty($this->cst_ipi))
            $this->cst_ipi = new CstIpi($this->cst_ipi_id);
    
        // returns the associated object
        return $this->cst_ipi;
    }
    /**
     * Method set_cst_pis
     * Sample of usage: $var->cst_pis = $object;
     * @param $object Instance of CstPis
     */
    public function set_cst_pis(CstPis $object)
    {
        $this->cst_pis = $object;
        $this->cst_pis_id = $object->id;
    }

    /**
     * Method get_cst_pis
     * Sample of usage: $var->cst_pis->attribute;
     * @returns CstPis instance
     */
    public function get_cst_pis()
    {
    
        // loads the associated object
        if (empty($this->cst_pis))
            $this->cst_pis = new CstPis($this->cst_pis_id);
    
        // returns the associated object
        return $this->cst_pis;
    }
    /**
     * Method set_cst_cofins
     * Sample of usage: $var->cst_cofins = $object;
     * @param $object Instance of CstCofins
     */
    public function set_cst_cofins(CstCofins $object)
    {
        $this->cst_cofins = $object;
        $this->cst_cofins_id = $object->id;
    }

    /**
     * Method get_cst_cofins
     * Sample of usage: $var->cst_cofins->attribute;
     * @returns CstCofins instance
     */
    public function get_cst_cofins()
    {
    
        // loads the associated object
        if (empty($this->cst_cofins))
            $this->cst_cofins = new CstCofins($this->cst_cofins_id);
    
        // returns the associated object
        return $this->cst_cofins;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_consumidor_final(Resposta $object)
    {
        $this->consumidor_final = $object;
        $this->consumidor_final_id = $object->id;
    }

    /**
     * Method get_consumidor_final
     * Sample of usage: $var->consumidor_final->attribute;
     * @returns Resposta instance
     */
    public function get_consumidor_final()
    {
    
        // loads the associated object
        if (empty($this->consumidor_final))
            $this->consumidor_final = new Resposta($this->consumidor_final_id);
    
        // returns the associated object
        return $this->consumidor_final;
    }
    /**
     * Method set_cst_icms
     * Sample of usage: $var->cst_icms = $object;
     * @param $object Instance of CstIcms
     */
    public function set_cst_icms_nao_contribuinte(CstIcms $object)
    {
        $this->cst_icms_nao_contribuinte = $object;
        $this->cst_icms_nao_contribuinte_id = $object->id;
    }

    /**
     * Method get_cst_icms_nao_contribuinte
     * Sample of usage: $var->cst_icms_nao_contribuinte->attribute;
     * @returns CstIcms instance
     */
    public function get_cst_icms_nao_contribuinte()
    {
    
        // loads the associated object
        if (empty($this->cst_icms_nao_contribuinte))
            $this->cst_icms_nao_contribuinte = new CstIcms($this->cst_icms_nao_contribuinte_id);
    
        // returns the associated object
        return $this->cst_icms_nao_contribuinte;
    }

    /**
     * Method getNaturezaOperacaoExcecaos
     */
    public function getNaturezaOperacaoExcecaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natureza_operacao_id', '=', $this->id));
        return NaturezaOperacaoExcecao::getObjects( $criteria );
    }
    /**
     * Method getNotafiscals
     */
    public function getNotafiscals()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natureza_operacao_id', '=', $this->id));
        return Notafiscal::getObjects( $criteria );
    }

    public function set_natureza_operacao_excecao_natureza_operacao_to_string($natureza_operacao_excecao_natureza_operacao_to_string)
    {
        if(is_array($natureza_operacao_excecao_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $natureza_operacao_excecao_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natureza_operacao_to_string = $natureza_operacao_excecao_natureza_operacao_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natureza_operacao_to_string'] = $this->natureza_operacao_excecao_natureza_operacao_to_string;
    }

    public function get_natureza_operacao_excecao_natureza_operacao_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natureza_operacao_to_string))
        {
            return $this->natureza_operacao_excecao_natureza_operacao_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_natop_excecao_tributo_to_string($natureza_operacao_excecao_natop_excecao_tributo_to_string)
    {
        if(is_array($natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            $values = NatopExcecaoTributo::where('id', 'in', $natureza_operacao_excecao_natop_excecao_tributo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = $natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natop_excecao_tributo_to_string'] = $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
    }

    public function get_natureza_operacao_excecao_natop_excecao_tributo_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            return $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('natop_excecao_tributo_id','{natop_excecao_tributo->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_pis_to_string($natureza_operacao_excecao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_excecao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_pis_to_string = $natureza_operacao_excecao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_pis_to_string'] = $this->natureza_operacao_excecao_cst_pis_to_string;
    }

    public function get_natureza_operacao_excecao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_pis_to_string))
        {
            return $this->natureza_operacao_excecao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_ipi_to_string($natureza_operacao_excecao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_excecao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_ipi_to_string = $natureza_operacao_excecao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_ipi_to_string'] = $this->natureza_operacao_excecao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_excecao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_excecao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_icms_to_string($natureza_operacao_excecao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_excecao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_icms_to_string = $natureza_operacao_excecao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_icms_to_string'] = $this->natureza_operacao_excecao_cst_icms_to_string;
    }

    public function get_natureza_operacao_excecao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_icms_to_string))
        {
            return $this->natureza_operacao_excecao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_cofins_to_string($natureza_operacao_excecao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_excecao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_cofins_to_string = $natureza_operacao_excecao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_cofins_to_string'] = $this->natureza_operacao_excecao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_excecao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_excecao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbc_to_string($natureza_operacao_excecao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = $natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbcst_to_string($natureza_operacao_excecao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = $natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_system_unit_to_string($notafiscal_system_unit_to_string)
    {
        if(is_array($notafiscal_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_system_unit_to_string = $notafiscal_system_unit_to_string;
        }

        $this->vdata['notafiscal_system_unit_to_string'] = $this->notafiscal_system_unit_to_string;
    }

    public function get_notafiscal_system_unit_to_string()
    {
        if(!empty($this->notafiscal_system_unit_to_string))
        {
            return $this->notafiscal_system_unit_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_cliente_to_string($notafiscal_cliente_to_string)
    {
        if(is_array($notafiscal_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $notafiscal_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_cliente_to_string = $notafiscal_cliente_to_string;
        }

        $this->vdata['notafiscal_cliente_to_string'] = $this->notafiscal_cliente_to_string;
    }

    public function get_notafiscal_cliente_to_string()
    {
        if(!empty($this->notafiscal_cliente_to_string))
        {
            return $this->notafiscal_cliente_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_venda_to_string($notafiscal_venda_to_string)
    {
        if(is_array($notafiscal_venda_to_string))
        {
            $values = Venda::where('id', 'in', $notafiscal_venda_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_venda_to_string = $notafiscal_venda_to_string;
        }

        $this->vdata['notafiscal_venda_to_string'] = $this->notafiscal_venda_to_string;
    }

    public function get_notafiscal_venda_to_string()
    {
        if(!empty($this->notafiscal_venda_to_string))
        {
            return $this->notafiscal_venda_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_nf_tipodocumento_to_string($notafiscal_nf_tipodocumento_to_string)
    {
        if(is_array($notafiscal_nf_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_nf_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_nf_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_nf_tipodocumento_to_string = $notafiscal_nf_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_nf_tipodocumento_to_string'] = $this->notafiscal_nf_tipodocumento_to_string;
    }

    public function get_notafiscal_nf_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_nf_tipodocumento_to_string))
        {
            return $this->notafiscal_nf_tipodocumento_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('nf_tipodocumento_id','{nf_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_situacao_to_string($notafiscal_notafiscal_situacao_to_string)
    {
        if(is_array($notafiscal_notafiscal_situacao_to_string))
        {
            $values = NotafiscalSituacao::where('id', 'in', $notafiscal_notafiscal_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_situacao_to_string = $notafiscal_notafiscal_situacao_to_string;
        }

        $this->vdata['notafiscal_notafiscal_situacao_to_string'] = $this->notafiscal_notafiscal_situacao_to_string;
    }

    public function get_notafiscal_notafiscal_situacao_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_situacao_to_string))
        {
            return $this->notafiscal_notafiscal_situacao_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_situacao_id','{notafiscal_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_crt_to_string($notafiscal_notafiscal_crt_to_string)
    {
        if(is_array($notafiscal_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $notafiscal_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_crt_to_string = $notafiscal_notafiscal_crt_to_string;
        }

        $this->vdata['notafiscal_notafiscal_crt_to_string'] = $this->notafiscal_notafiscal_crt_to_string;
    }

    public function get_notafiscal_notafiscal_crt_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_crt_to_string))
        {
            return $this->notafiscal_notafiscal_crt_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indiedest_to_string($notafiscal_notafiscal_indiedest_to_string)
    {
        if(is_array($notafiscal_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $notafiscal_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indiedest_to_string = $notafiscal_notafiscal_indiedest_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indiedest_to_string'] = $this->notafiscal_notafiscal_indiedest_to_string;
    }

    public function get_notafiscal_notafiscal_indiedest_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indiedest_to_string))
        {
            return $this->notafiscal_notafiscal_indiedest_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscaldest_to_string($notafiscal_notafiscaldest_to_string)
    {
        if(is_array($notafiscal_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $notafiscal_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscaldest_to_string = $notafiscal_notafiscaldest_to_string;
        }

        $this->vdata['notafiscal_notafiscaldest_to_string'] = $this->notafiscal_notafiscaldest_to_string;
    }

    public function get_notafiscal_notafiscaldest_to_string()
    {
        if(!empty($this->notafiscal_notafiscaldest_to_string))
        {
            return $this->notafiscal_notafiscaldest_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpimp_to_string($notafiscal_notafiscal_tpimp_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $notafiscal_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpimp_to_string = $notafiscal_notafiscal_tpimp_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpimp_to_string'] = $this->notafiscal_notafiscal_tpimp_to_string;
    }

    public function get_notafiscal_notafiscal_tpimp_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpimp_to_string))
        {
            return $this->notafiscal_notafiscal_tpimp_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpemis_to_string($notafiscal_notafiscal_tpemis_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpemis_to_string))
        {
            $values = NotafiscalTpemis::where('id', 'in', $notafiscal_notafiscal_tpemis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpemis_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpemis_to_string = $notafiscal_notafiscal_tpemis_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpemis_to_string'] = $this->notafiscal_notafiscal_tpemis_to_string;
    }

    public function get_notafiscal_notafiscal_tpemis_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpemis_to_string))
        {
            return $this->notafiscal_notafiscal_tpemis_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_tpemis_id','{notafiscal_tpemis->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_finnfe_to_string($notafiscal_notafiscal_finnfe_to_string)
    {
        if(is_array($notafiscal_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $notafiscal_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_finnfe_to_string = $notafiscal_notafiscal_finnfe_to_string;
        }

        $this->vdata['notafiscal_notafiscal_finnfe_to_string'] = $this->notafiscal_notafiscal_finnfe_to_string;
    }

    public function get_notafiscal_notafiscal_finnfe_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_finnfe_to_string))
        {
            return $this->notafiscal_notafiscal_finnfe_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indfinal_to_string($notafiscal_notafiscal_indfinal_to_string)
    {
        if(is_array($notafiscal_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $notafiscal_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indfinal_to_string = $notafiscal_notafiscal_indfinal_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indfinal_to_string'] = $this->notafiscal_notafiscal_indfinal_to_string;
    }

    public function get_notafiscal_notafiscal_indfinal_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indfinal_to_string))
        {
            return $this->notafiscal_notafiscal_indfinal_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpres_to_string($notafiscal_notafiscal_indpres_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $notafiscal_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpres_to_string = $notafiscal_notafiscal_indpres_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpres_to_string'] = $this->notafiscal_notafiscal_indpres_to_string;
    }

    public function get_notafiscal_notafiscal_indpres_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpres_to_string))
        {
            return $this->notafiscal_notafiscal_indpres_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpag_to_string($notafiscal_notafiscal_indpag_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $notafiscal_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpag_to_string = $notafiscal_notafiscal_indpag_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpag_to_string'] = $this->notafiscal_notafiscal_indpag_to_string;
    }

    public function get_notafiscal_notafiscal_indpag_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpag_to_string))
        {
            return $this->notafiscal_notafiscal_indpag_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dispositivos_to_string($notafiscal_dispositivos_to_string)
    {
        if(is_array($notafiscal_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $notafiscal_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dispositivos_to_string = $notafiscal_dispositivos_to_string;
        }

        $this->vdata['notafiscal_dispositivos_to_string'] = $this->notafiscal_dispositivos_to_string;
    }

    public function get_notafiscal_dispositivos_to_string()
    {
        if(!empty($this->notafiscal_dispositivos_to_string))
        {
            return $this->notafiscal_dispositivos_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpamb_to_string($notafiscal_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpamb_to_string = $notafiscal_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpamb_to_string'] = $this->notafiscal_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_notafiscal_tpamb_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_mod_to_string($notafiscal_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_mod_to_string = $notafiscal_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_notafiscal_mod_to_string'] = $this->notafiscal_notafiscal_mod_to_string;
    }

    public function get_notafiscal_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_mod_to_string))
        {
            return $this->notafiscal_notafiscal_mod_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_modfrete_to_string($notafiscal_notafiscal_modfrete_to_string)
    {
        if(is_array($notafiscal_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $notafiscal_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_modfrete_to_string = $notafiscal_notafiscal_modfrete_to_string;
        }

        $this->vdata['notafiscal_notafiscal_modfrete_to_string'] = $this->notafiscal_notafiscal_modfrete_to_string;
    }

    public function get_notafiscal_notafiscal_modfrete_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_modfrete_to_string))
        {
            return $this->notafiscal_notafiscal_modfrete_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_natureza_operacao_to_string($notafiscal_natureza_operacao_to_string)
    {
        if(is_array($notafiscal_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $notafiscal_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_natureza_operacao_to_string = $notafiscal_natureza_operacao_to_string;
        }

        $this->vdata['notafiscal_natureza_operacao_to_string'] = $this->notafiscal_natureza_operacao_to_string;
    }

    public function get_notafiscal_natureza_operacao_to_string()
    {
        if(!empty($this->notafiscal_natureza_operacao_to_string))
        {
            return $this->notafiscal_natureza_operacao_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_movimentacao_origem_to_string($notafiscal_movimentacao_origem_to_string)
    {
        if(is_array($notafiscal_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $notafiscal_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_movimentacao_origem_to_string = $notafiscal_movimentacao_origem_to_string;
        }

        $this->vdata['notafiscal_movimentacao_origem_to_string'] = $this->notafiscal_movimentacao_origem_to_string;
    }

    public function get_notafiscal_movimentacao_origem_to_string()
    {
        if(!empty($this->notafiscal_movimentacao_origem_to_string))
        {
            return $this->notafiscal_movimentacao_origem_to_string;
        }
    
        $values = Notafiscal::where('natureza_operacao_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

   public static function ObterCSTItem($notafiscal_indiedest_id, $natop)
   {
   
       if ($notafiscal_indiedest_id == NotafiscalIndiedest::ContribuinteICMS)
       {
           $cst_icms = CstIcms::find($natop->cst_icms_id);
        //   return $natop->cst_icms->cst_numero;
            return $cst_icms->cst_numero;
       }
       else
       {
           if (!$natop->cst_icms_nao_contribuinte_id)
           {
               $cst_icms = CstIcms::find($natop->cst_icms_id);
               return $cst_icms->cst_numero;       
           }
           else
           {
               $cst_icms = CstIcms::find($natop->cst_icms_nao_contribuinte_id);
               return $cst_icms->cst_numero;
           }
       }
   }
   
   public static function ObterCFOPItem($UF_cliente,$UF_empresa,$natureza)
   {
   
       if ($UF_cliente=='')
       {
        $UF_cliente = $UF_empresa;
       }
   
       if ($UF_cliente <> $UF_empresa)
       {
            return $natureza->cfop_fora;       
       }
       else
       {
           return $natureza->cfop;
       }
   }

                
}

