<?php

class NaturezaOperacaoExcecao extends TRecord
{
    const TABLENAME  = 'natureza_operacao_excecao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $natop_excecao_tributo;
    private $natureza_operacao;
    private $cst_pis;
    private $cst_ipi;
    private $cst_icms;
    private $cst_cofins;
    private $notafiscal_item_modbc;
    private $notafiscal_item_modbcst;
    private $notafiscal_item_motDesICMS;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('natureza_operacao_id');
        parent::addAttribute('natop_excecao_tributo_id');
        parent::addAttribute('cst_pis_id');
        parent::addAttribute('cst_ipi_id');
        parent::addAttribute('cst_icms_id');
        parent::addAttribute('cst_cofins_id');
        parent::addAttribute('cfop');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('icms_aliquota');
        parent::addAttribute('ipi_aliquota');
        parent::addAttribute('ipi_codigo_enquadramento');
        parent::addAttribute('pis_aliquota');
        parent::addAttribute('pis_base');
        parent::addAttribute('cofins_aliquota');
        parent::addAttribute('cofins_base');
        parent::addAttribute('icms_predbc');
        parent::addAttribute('icms_picms');
        parent::addAttribute('icms_pdif');
        parent::addAttribute('icms_vicmsdeson');
        parent::addAttribute('icms_pmvast');
        parent::addAttribute('icms_picmsst');
        parent::addAttribute('icms_pfcp');
        parent::addAttribute('icms_pfcpst');
        parent::addAttribute('icms_pfcpstret');
        parent::addAttribute('icms_pst');
        parent::addAttribute('icms_pcredsn');
        parent::addAttribute('icms_predbcefet');
        parent::addAttribute('icms_picmsefet');
        parent::addAttribute('icms_pfcpufdest');
        parent::addAttribute('icms_picmsufdest');
        parent::addAttribute('icms_base');
        parent::addAttribute('icms_basest');
        parent::addAttribute('notafiscal_item_modbc_id');
        parent::addAttribute('notafiscal_item_modbcst_id');
        parent::addAttribute('notafiscal_item_motDesICMS_id');
        parent::addAttribute('cfop_fora');
            
    }

    /**
     * Method set_natop_excecao_tributo
     * Sample of usage: $var->natop_excecao_tributo = $object;
     * @param $object Instance of NatopExcecaoTributo
     */
    public function set_natop_excecao_tributo(NatopExcecaoTributo $object)
    {
        $this->natop_excecao_tributo = $object;
        $this->natop_excecao_tributo_id = $object->id;
    }

    /**
     * Method get_natop_excecao_tributo
     * Sample of usage: $var->natop_excecao_tributo->attribute;
     * @returns NatopExcecaoTributo instance
     */
    public function get_natop_excecao_tributo()
    {
    
        // loads the associated object
        if (empty($this->natop_excecao_tributo))
            $this->natop_excecao_tributo = new NatopExcecaoTributo($this->natop_excecao_tributo_id);
    
        // returns the associated object
        return $this->natop_excecao_tributo;
    }
    /**
     * Method set_natureza_operacao
     * Sample of usage: $var->natureza_operacao = $object;
     * @param $object Instance of NaturezaOperacao
     */
    public function set_natureza_operacao(NaturezaOperacao $object)
    {
        $this->natureza_operacao = $object;
        $this->natureza_operacao_id = $object->id;
    }

    /**
     * Method get_natureza_operacao
     * Sample of usage: $var->natureza_operacao->attribute;
     * @returns NaturezaOperacao instance
     */
    public function get_natureza_operacao()
    {
    
        // loads the associated object
        if (empty($this->natureza_operacao))
            $this->natureza_operacao = new NaturezaOperacao($this->natureza_operacao_id);
    
        // returns the associated object
        return $this->natureza_operacao;
    }
    /**
     * Method set_cst_pis
     * Sample of usage: $var->cst_pis = $object;
     * @param $object Instance of CstPis
     */
    public function set_cst_pis(CstPis $object)
    {
        $this->cst_pis = $object;
        $this->cst_pis_id = $object->id;
    }

    /**
     * Method get_cst_pis
     * Sample of usage: $var->cst_pis->attribute;
     * @returns CstPis instance
     */
    public function get_cst_pis()
    {
    
        // loads the associated object
        if (empty($this->cst_pis))
            $this->cst_pis = new CstPis($this->cst_pis_id);
    
        // returns the associated object
        return $this->cst_pis;
    }
    /**
     * Method set_cst_ipi
     * Sample of usage: $var->cst_ipi = $object;
     * @param $object Instance of CstIpi
     */
    public function set_cst_ipi(CstIpi $object)
    {
        $this->cst_ipi = $object;
        $this->cst_ipi_id = $object->id;
    }

    /**
     * Method get_cst_ipi
     * Sample of usage: $var->cst_ipi->attribute;
     * @returns CstIpi instance
     */
    public function get_cst_ipi()
    {
    
        // loads the associated object
        if (empty($this->cst_ipi))
            $this->cst_ipi = new CstIpi($this->cst_ipi_id);
    
        // returns the associated object
        return $this->cst_ipi;
    }
    /**
     * Method set_cst_icms
     * Sample of usage: $var->cst_icms = $object;
     * @param $object Instance of CstIcms
     */
    public function set_cst_icms(CstIcms $object)
    {
        $this->cst_icms = $object;
        $this->cst_icms_id = $object->id;
    }

    /**
     * Method get_cst_icms
     * Sample of usage: $var->cst_icms->attribute;
     * @returns CstIcms instance
     */
    public function get_cst_icms()
    {
    
        // loads the associated object
        if (empty($this->cst_icms))
            $this->cst_icms = new CstIcms($this->cst_icms_id);
    
        // returns the associated object
        return $this->cst_icms;
    }
    /**
     * Method set_cst_cofins
     * Sample of usage: $var->cst_cofins = $object;
     * @param $object Instance of CstCofins
     */
    public function set_cst_cofins(CstCofins $object)
    {
        $this->cst_cofins = $object;
        $this->cst_cofins_id = $object->id;
    }

    /**
     * Method get_cst_cofins
     * Sample of usage: $var->cst_cofins->attribute;
     * @returns CstCofins instance
     */
    public function get_cst_cofins()
    {
    
        // loads the associated object
        if (empty($this->cst_cofins))
            $this->cst_cofins = new CstCofins($this->cst_cofins_id);
    
        // returns the associated object
        return $this->cst_cofins;
    }
    /**
     * Method set_notafiscal_item_modbc
     * Sample of usage: $var->notafiscal_item_modbc = $object;
     * @param $object Instance of NotafiscalItemModbc
     */
    public function set_notafiscal_item_modbc(NotafiscalItemModbc $object)
    {
        $this->notafiscal_item_modbc = $object;
        $this->notafiscal_item_modbc_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_modbc
     * Sample of usage: $var->notafiscal_item_modbc->attribute;
     * @returns NotafiscalItemModbc instance
     */
    public function get_notafiscal_item_modbc()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_modbc))
            $this->notafiscal_item_modbc = new NotafiscalItemModbc($this->notafiscal_item_modbc_id);
    
        // returns the associated object
        return $this->notafiscal_item_modbc;
    }
    /**
     * Method set_notafiscal_item_modbcst
     * Sample of usage: $var->notafiscal_item_modbcst = $object;
     * @param $object Instance of NotafiscalItemModbcst
     */
    public function set_notafiscal_item_modbcst(NotafiscalItemModbcst $object)
    {
        $this->notafiscal_item_modbcst = $object;
        $this->notafiscal_item_modbcst_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_modbcst
     * Sample of usage: $var->notafiscal_item_modbcst->attribute;
     * @returns NotafiscalItemModbcst instance
     */
    public function get_notafiscal_item_modbcst()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_modbcst))
            $this->notafiscal_item_modbcst = new NotafiscalItemModbcst($this->notafiscal_item_modbcst_id);
    
        // returns the associated object
        return $this->notafiscal_item_modbcst;
    }
    /**
     * Method set_notafiscal_item_motDesICMS
     * Sample of usage: $var->notafiscal_item_motDesICMS = $object;
     * @param $object Instance of NotafiscalItemMotdesicms
     */
    public function set_notafiscal_item_motDesICMS(NotafiscalItemMotdesicms $object)
    {
        $this->notafiscal_item_motDesICMS = $object;
        $this->notafiscal_item_motDesICMS_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_motDesICMS
     * Sample of usage: $var->notafiscal_item_motDesICMS->attribute;
     * @returns NotafiscalItemMotdesicms instance
     */
    public function get_notafiscal_item_motDesICMS()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_motDesICMS))
            $this->notafiscal_item_motDesICMS = new NotafiscalItemMotdesicms($this->notafiscal_item_motDesICMS_id);
    
        // returns the associated object
        return $this->notafiscal_item_motDesICMS;
    }

    /**
     * Method getNaturezaOperacaoEstadoss
     */
    public function getNaturezaOperacaoEstadoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natureza_operacao_excecao_id', '=', $this->id));
        return NaturezaOperacaoEstados::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaoNcms
     */
    public function getNaturezaOperacaoNcms()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natureza_operacao_excecao_id', '=', $this->id));
        return NaturezaOperacaoNcm::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaoOrigenss
     */
    public function getNaturezaOperacaoOrigenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natureza_operacao_excecao_id', '=', $this->id));
        return NaturezaOperacaoOrigens::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaoProdutoss
     */
    public function getNaturezaOperacaoProdutoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natureza_operacao_excecao_id', '=', $this->id));
        return NaturezaOperacaoProdutos::getObjects( $criteria );
    }

    public function set_natureza_operacao_estados_natureza_operacao_excecao_to_string($natureza_operacao_estados_natureza_operacao_excecao_to_string)
    {
        if(is_array($natureza_operacao_estados_natureza_operacao_excecao_to_string))
        {
            $values = NaturezaOperacaoExcecao::where('id', 'in', $natureza_operacao_estados_natureza_operacao_excecao_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_estados_natureza_operacao_excecao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_estados_natureza_operacao_excecao_to_string = $natureza_operacao_estados_natureza_operacao_excecao_to_string;
        }

        $this->vdata['natureza_operacao_estados_natureza_operacao_excecao_to_string'] = $this->natureza_operacao_estados_natureza_operacao_excecao_to_string;
    }

    public function get_natureza_operacao_estados_natureza_operacao_excecao_to_string()
    {
        if(!empty($this->natureza_operacao_estados_natureza_operacao_excecao_to_string))
        {
            return $this->natureza_operacao_estados_natureza_operacao_excecao_to_string;
        }
    
        $values = NaturezaOperacaoEstados::where('natureza_operacao_excecao_id', '=', $this->id)->getIndexedArray('natureza_operacao_excecao_id','{natureza_operacao_excecao->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_estados_estado_to_string($natureza_operacao_estados_estado_to_string)
    {
        if(is_array($natureza_operacao_estados_estado_to_string))
        {
            $values = Estado::where('id', 'in', $natureza_operacao_estados_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->natureza_operacao_estados_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_estados_estado_to_string = $natureza_operacao_estados_estado_to_string;
        }

        $this->vdata['natureza_operacao_estados_estado_to_string'] = $this->natureza_operacao_estados_estado_to_string;
    }

    public function get_natureza_operacao_estados_estado_to_string()
    {
        if(!empty($this->natureza_operacao_estados_estado_to_string))
        {
            return $this->natureza_operacao_estados_estado_to_string;
        }
    
        $values = NaturezaOperacaoEstados::where('natureza_operacao_excecao_id', '=', $this->id)->getIndexedArray('estado_id','{estado->nome}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_ncm_natureza_operacao_excecao_to_string($natureza_operacao_ncm_natureza_operacao_excecao_to_string)
    {
        if(is_array($natureza_operacao_ncm_natureza_operacao_excecao_to_string))
        {
            $values = NaturezaOperacaoExcecao::where('id', 'in', $natureza_operacao_ncm_natureza_operacao_excecao_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_ncm_natureza_operacao_excecao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_ncm_natureza_operacao_excecao_to_string = $natureza_operacao_ncm_natureza_operacao_excecao_to_string;
        }

        $this->vdata['natureza_operacao_ncm_natureza_operacao_excecao_to_string'] = $this->natureza_operacao_ncm_natureza_operacao_excecao_to_string;
    }

    public function get_natureza_operacao_ncm_natureza_operacao_excecao_to_string()
    {
        if(!empty($this->natureza_operacao_ncm_natureza_operacao_excecao_to_string))
        {
            return $this->natureza_operacao_ncm_natureza_operacao_excecao_to_string;
        }
    
        $values = NaturezaOperacaoNcm::where('natureza_operacao_excecao_id', '=', $this->id)->getIndexedArray('natureza_operacao_excecao_id','{natureza_operacao_excecao->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_origens_natureza_operacao_excecao_to_string($natureza_operacao_origens_natureza_operacao_excecao_to_string)
    {
        if(is_array($natureza_operacao_origens_natureza_operacao_excecao_to_string))
        {
            $values = NaturezaOperacaoExcecao::where('id', 'in', $natureza_operacao_origens_natureza_operacao_excecao_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_origens_natureza_operacao_excecao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_origens_natureza_operacao_excecao_to_string = $natureza_operacao_origens_natureza_operacao_excecao_to_string;
        }

        $this->vdata['natureza_operacao_origens_natureza_operacao_excecao_to_string'] = $this->natureza_operacao_origens_natureza_operacao_excecao_to_string;
    }

    public function get_natureza_operacao_origens_natureza_operacao_excecao_to_string()
    {
        if(!empty($this->natureza_operacao_origens_natureza_operacao_excecao_to_string))
        {
            return $this->natureza_operacao_origens_natureza_operacao_excecao_to_string;
        }
    
        $values = NaturezaOperacaoOrigens::where('natureza_operacao_excecao_id', '=', $this->id)->getIndexedArray('natureza_operacao_excecao_id','{natureza_operacao_excecao->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_origens_notafiscal_item_orig_to_string($natureza_operacao_origens_notafiscal_item_orig_to_string)
    {
        if(is_array($natureza_operacao_origens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $natureza_operacao_origens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_origens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_origens_notafiscal_item_orig_to_string = $natureza_operacao_origens_notafiscal_item_orig_to_string;
        }

        $this->vdata['natureza_operacao_origens_notafiscal_item_orig_to_string'] = $this->natureza_operacao_origens_notafiscal_item_orig_to_string;
    }

    public function get_natureza_operacao_origens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->natureza_operacao_origens_notafiscal_item_orig_to_string))
        {
            return $this->natureza_operacao_origens_notafiscal_item_orig_to_string;
        }
    
        $values = NaturezaOperacaoOrigens::where('natureza_operacao_excecao_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_produtos_produto_to_string($natureza_operacao_produtos_produto_to_string)
    {
        if(is_array($natureza_operacao_produtos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $natureza_operacao_produtos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->natureza_operacao_produtos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_produtos_produto_to_string = $natureza_operacao_produtos_produto_to_string;
        }

        $this->vdata['natureza_operacao_produtos_produto_to_string'] = $this->natureza_operacao_produtos_produto_to_string;
    }

    public function get_natureza_operacao_produtos_produto_to_string()
    {
        if(!empty($this->natureza_operacao_produtos_produto_to_string))
        {
            return $this->natureza_operacao_produtos_produto_to_string;
        }
    
        $values = NaturezaOperacaoProdutos::where('natureza_operacao_excecao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_produtos_natureza_operacao_excecao_to_string($natureza_operacao_produtos_natureza_operacao_excecao_to_string)
    {
        if(is_array($natureza_operacao_produtos_natureza_operacao_excecao_to_string))
        {
            $values = NaturezaOperacaoExcecao::where('id', 'in', $natureza_operacao_produtos_natureza_operacao_excecao_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string = $natureza_operacao_produtos_natureza_operacao_excecao_to_string;
        }

        $this->vdata['natureza_operacao_produtos_natureza_operacao_excecao_to_string'] = $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string;
    }

    public function get_natureza_operacao_produtos_natureza_operacao_excecao_to_string()
    {
        if(!empty($this->natureza_operacao_produtos_natureza_operacao_excecao_to_string))
        {
            return $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string;
        }
    
        $values = NaturezaOperacaoProdutos::where('natureza_operacao_excecao_id', '=', $this->id)->getIndexedArray('natureza_operacao_excecao_id','{natureza_operacao_excecao->id}');
        return implode(', ', $values);
    }

    
}

