<?php

class NaturezaOperacaoFinalidade extends TRecord
{
    const TABLENAME  = 'natureza_operacao_finalidade';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Normal = '1';
    const Devolucao = '2';
    const Bonificacao = '3';
    const Remessa = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nome');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getNaturezaOperacaos
     */
    public function getNaturezaOperacaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('natureza_operacao_finalidade_id', '=', $this->id));
        return NaturezaOperacao::getObjects( $criteria );
    }

    public function set_natureza_operacao_natureza_operacao_finalidade_to_string($natureza_operacao_natureza_operacao_finalidade_to_string)
    {
        if(is_array($natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            $values = NaturezaOperacaoFinalidade::where('id', 'in', $natureza_operacao_natureza_operacao_finalidade_to_string)->getIndexedArray('nome', 'nome');
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = $natureza_operacao_natureza_operacao_finalidade_to_string;
        }

        $this->vdata['natureza_operacao_natureza_operacao_finalidade_to_string'] = $this->natureza_operacao_natureza_operacao_finalidade_to_string;
    }

    public function get_natureza_operacao_natureza_operacao_finalidade_to_string()
    {
        if(!empty($this->natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            return $this->natureza_operacao_natureza_operacao_finalidade_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('natureza_operacao_finalidade_id','{natureza_operacao_finalidade->nome}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_to_string($natureza_operacao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_to_string = $natureza_operacao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_to_string'] = $this->natureza_operacao_cst_icms_to_string;
    }

    public function get_natureza_operacao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_to_string))
        {
            return $this->natureza_operacao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_nao_contribuinte_to_string($natureza_operacao_cst_icms_nao_contribuinte_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_nao_contribuinte_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = $natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_nao_contribuinte_to_string'] = $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
    }

    public function get_natureza_operacao_cst_icms_nao_contribuinte_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            return $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('cst_icms_nao_contribuinte_id','{cst_icms_nao_contribuinte->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_ipi_to_string($natureza_operacao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_ipi_to_string = $natureza_operacao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_cst_ipi_to_string'] = $this->natureza_operacao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_pis_to_string($natureza_operacao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_pis_to_string = $natureza_operacao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_cst_pis_to_string'] = $this->natureza_operacao_cst_pis_to_string;
    }

    public function get_natureza_operacao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_cst_pis_to_string))
        {
            return $this->natureza_operacao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_cofins_to_string($natureza_operacao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_cofins_to_string = $natureza_operacao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_cst_cofins_to_string'] = $this->natureza_operacao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_consumidor_final_to_string($natureza_operacao_consumidor_final_to_string)
    {
        if(is_array($natureza_operacao_consumidor_final_to_string))
        {
            $values = Resposta::where('id', 'in', $natureza_operacao_consumidor_final_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_consumidor_final_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_consumidor_final_to_string = $natureza_operacao_consumidor_final_to_string;
        }

        $this->vdata['natureza_operacao_consumidor_final_to_string'] = $this->natureza_operacao_consumidor_final_to_string;
    }

    public function get_natureza_operacao_consumidor_final_to_string()
    {
        if(!empty($this->natureza_operacao_consumidor_final_to_string))
        {
            return $this->natureza_operacao_consumidor_final_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('consumidor_final_id','{consumidor_final->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbc_to_string($natureza_operacao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbc_to_string = $natureza_operacao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbcst_to_string($natureza_operacao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = $natureza_operacao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_motDesICMS_to_string($natureza_operacao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacao::where('natureza_operacao_finalidade_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    
}

