<?php

class Negocio extends TRecord
{
    const TABLENAME  = 'negocio';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $negocio_origem;
    private $system_unit;
    private $negocio_motivo_perda;
    private $funil_etapas;
    private $ativo;
    private $fk_arquivado;
    private $vendedor;
    private $cliente;
    private $orcamento;
    private $funil;

    const Evento_NegocioIncluidoOuAlterado = 'Negócio incluído ou alterado';
                    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('negocio_origem_id');
        parent::addAttribute('funil_id');
        parent::addAttribute('funil_etapas_id');
        parent::addAttribute('titulo');
        parent::addAttribute('valor');
        parent::addAttribute('data_abertura');
        parent::addAttribute('ordem');
        parent::addAttribute('data_fechamento');
        parent::addAttribute('negocio_motivo_perda_id');
        parent::addAttribute('comentarios_motivo_perda');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('contato_nome');
        parent::addAttribute('contato_fone');
        parent::addAttribute('ativo_id');
        parent::addAttribute('arquivado');
        parent::addAttribute('data_fechamento_esperada');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('mes');
        parent::addAttribute('ano');
        parent::addAttribute('orcamento_id');
        parent::addAttribute('cliente_id');
        parent::addAttribute('deletado_em');
        parent::addAttribute('contato_email');
    
    }

    /**
     * Method set_negocio_origem
     * Sample of usage: $var->negocio_origem = $object;
     * @param $object Instance of NegocioOrigem
     */
    public function set_negocio_origem(NegocioOrigem $object)
    {
        $this->negocio_origem = $object;
        $this->negocio_origem_id = $object->id;
    }

    /**
     * Method get_negocio_origem
     * Sample of usage: $var->negocio_origem->attribute;
     * @returns NegocioOrigem instance
     */
    public function get_negocio_origem()
    {
    
        // loads the associated object
        if (empty($this->negocio_origem))
            $this->negocio_origem = new NegocioOrigem($this->negocio_origem_id);
    
        // returns the associated object
        return $this->negocio_origem;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_negocio_motivo_perda
     * Sample of usage: $var->negocio_motivo_perda = $object;
     * @param $object Instance of NegocioMotivoPerda
     */
    public function set_negocio_motivo_perda(NegocioMotivoPerda $object)
    {
        $this->negocio_motivo_perda = $object;
        $this->negocio_motivo_perda_id = $object->id;
    }

    /**
     * Method get_negocio_motivo_perda
     * Sample of usage: $var->negocio_motivo_perda->attribute;
     * @returns NegocioMotivoPerda instance
     */
    public function get_negocio_motivo_perda()
    {
    
        // loads the associated object
        if (empty($this->negocio_motivo_perda))
            $this->negocio_motivo_perda = new NegocioMotivoPerda($this->negocio_motivo_perda_id);
    
        // returns the associated object
        return $this->negocio_motivo_perda;
    }
    /**
     * Method set_funil_etapas
     * Sample of usage: $var->funil_etapas = $object;
     * @param $object Instance of FunilEtapas
     */
    public function set_funil_etapas(FunilEtapas $object)
    {
        $this->funil_etapas = $object;
        $this->funil_etapas_id = $object->id;
    }

    /**
     * Method get_funil_etapas
     * Sample of usage: $var->funil_etapas->attribute;
     * @returns FunilEtapas instance
     */
    public function get_funil_etapas()
    {
    
        // loads the associated object
        if (empty($this->funil_etapas))
            $this->funil_etapas = new FunilEtapas($this->funil_etapas_id);
    
        // returns the associated object
        return $this->funil_etapas;
    }
    /**
     * Method set_ativo
     * Sample of usage: $var->ativo = $object;
     * @param $object Instance of Ativo
     */
    public function set_ativo(Ativo $object)
    {
        $this->ativo = $object;
        $this->ativo_id = $object->id;
    }

    /**
     * Method get_ativo
     * Sample of usage: $var->ativo->attribute;
     * @returns Ativo instance
     */
    public function get_ativo()
    {
    
        // loads the associated object
        if (empty($this->ativo))
            $this->ativo = new Ativo($this->ativo_id);
    
        // returns the associated object
        return $this->ativo;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_fk_arquivado(Resposta $object)
    {
        $this->fk_arquivado = $object;
        $this->arquivado = $object->id;
    }

    /**
     * Method get_fk_arquivado
     * Sample of usage: $var->fk_arquivado->attribute;
     * @returns Resposta instance
     */
    public function get_fk_arquivado()
    {
    
        // loads the associated object
        if (empty($this->fk_arquivado))
            $this->fk_arquivado = new Resposta($this->arquivado);
    
        // returns the associated object
        return $this->fk_arquivado;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_orcamento
     * Sample of usage: $var->orcamento = $object;
     * @param $object Instance of Orcamento
     */
    public function set_orcamento(Orcamento $object)
    {
        $this->orcamento = $object;
        $this->orcamento_id = $object->id;
    }

    /**
     * Method get_orcamento
     * Sample of usage: $var->orcamento->attribute;
     * @returns Orcamento instance
     */
    public function get_orcamento()
    {
    
        // loads the associated object
        if (empty($this->orcamento))
            $this->orcamento = new Orcamento($this->orcamento_id);
    
        // returns the associated object
        return $this->orcamento;
    }
    /**
     * Method set_funil
     * Sample of usage: $var->funil = $object;
     * @param $object Instance of Funil
     */
    public function set_funil(Funil $object)
    {
        $this->funil = $object;
        $this->funil_id = $object->id;
    }

    /**
     * Method get_funil
     * Sample of usage: $var->funil->attribute;
     * @returns Funil instance
     */
    public function get_funil()
    {
    
        // loads the associated object
        if (empty($this->funil))
            $this->funil = new Funil($this->funil_id);
    
        // returns the associated object
        return $this->funil;
    }

    /**
     * Method getNegocioArquivoss
     */
    public function getNegocioArquivoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('negocio_id', '=', $this->id));
        return NegocioArquivos::getObjects( $criteria );
    }
    /**
     * Method getNegocioAtividades
     */
    public function getNegocioAtividades()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('negocio_id', '=', $this->id));
        return NegocioAtividade::getObjects( $criteria );
    }
    /**
     * Method getNegocioEtapasHistoricos
     */
    public function getNegocioEtapasHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('negocio_id', '=', $this->id));
        return NegocioEtapasHistorico::getObjects( $criteria );
    }
    /**
     * Method getNegocioItenss
     */
    public function getNegocioItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('negocio_id', '=', $this->id));
        return NegocioItens::getObjects( $criteria );
    }
    /**
     * Method getNegocioNotass
     */
    public function getNegocioNotass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('negocio_id', '=', $this->id));
        return NegocioNotas::getObjects( $criteria );
    }

    public function set_negocio_arquivos_negocio_to_string($negocio_arquivos_negocio_to_string)
    {
        if(is_array($negocio_arquivos_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_arquivos_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_arquivos_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_arquivos_negocio_to_string = $negocio_arquivos_negocio_to_string;
        }

        $this->vdata['negocio_arquivos_negocio_to_string'] = $this->negocio_arquivos_negocio_to_string;
    }

    public function get_negocio_arquivos_negocio_to_string()
    {
        if(!empty($this->negocio_arquivos_negocio_to_string))
        {
            return $this->negocio_arquivos_negocio_to_string;
        }
    
        $values = NegocioArquivos::where('negocio_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

    public function set_negocio_atividade_negocio_to_string($negocio_atividade_negocio_to_string)
    {
        if(is_array($negocio_atividade_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_atividade_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_atividade_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_atividade_negocio_to_string = $negocio_atividade_negocio_to_string;
        }

        $this->vdata['negocio_atividade_negocio_to_string'] = $this->negocio_atividade_negocio_to_string;
    }

    public function get_negocio_atividade_negocio_to_string()
    {
        if(!empty($this->negocio_atividade_negocio_to_string))
        {
            return $this->negocio_atividade_negocio_to_string;
        }
    
        $values = NegocioAtividade::where('negocio_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

    public function set_negocio_atividade_negocio_tipo_atividade_to_string($negocio_atividade_negocio_tipo_atividade_to_string)
    {
        if(is_array($negocio_atividade_negocio_tipo_atividade_to_string))
        {
            $values = NegocioTipoAtividade::where('id', 'in', $negocio_atividade_negocio_tipo_atividade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_atividade_negocio_tipo_atividade_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_atividade_negocio_tipo_atividade_to_string = $negocio_atividade_negocio_tipo_atividade_to_string;
        }

        $this->vdata['negocio_atividade_negocio_tipo_atividade_to_string'] = $this->negocio_atividade_negocio_tipo_atividade_to_string;
    }

    public function get_negocio_atividade_negocio_tipo_atividade_to_string()
    {
        if(!empty($this->negocio_atividade_negocio_tipo_atividade_to_string))
        {
            return $this->negocio_atividade_negocio_tipo_atividade_to_string;
        }
    
        $values = NegocioAtividade::where('negocio_id', '=', $this->id)->getIndexedArray('negocio_tipo_atividade_id','{negocio_tipo_atividade->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_etapas_historico_negocio_to_string($negocio_etapas_historico_negocio_to_string)
    {
        if(is_array($negocio_etapas_historico_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_etapas_historico_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_etapas_historico_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_etapas_historico_negocio_to_string = $negocio_etapas_historico_negocio_to_string;
        }

        $this->vdata['negocio_etapas_historico_negocio_to_string'] = $this->negocio_etapas_historico_negocio_to_string;
    }

    public function get_negocio_etapas_historico_negocio_to_string()
    {
        if(!empty($this->negocio_etapas_historico_negocio_to_string))
        {
            return $this->negocio_etapas_historico_negocio_to_string;
        }
    
        $values = NegocioEtapasHistorico::where('negocio_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

    public function set_negocio_etapas_historico_funil_etapas_to_string($negocio_etapas_historico_funil_etapas_to_string)
    {
        if(is_array($negocio_etapas_historico_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_etapas_historico_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_etapas_historico_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_etapas_historico_funil_etapas_to_string = $negocio_etapas_historico_funil_etapas_to_string;
        }

        $this->vdata['negocio_etapas_historico_funil_etapas_to_string'] = $this->negocio_etapas_historico_funil_etapas_to_string;
    }

    public function get_negocio_etapas_historico_funil_etapas_to_string()
    {
        if(!empty($this->negocio_etapas_historico_funil_etapas_to_string))
        {
            return $this->negocio_etapas_historico_funil_etapas_to_string;
        }
    
        $values = NegocioEtapasHistorico::where('negocio_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_itens_negocio_to_string($negocio_itens_negocio_to_string)
    {
        if(is_array($negocio_itens_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_itens_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_itens_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_itens_negocio_to_string = $negocio_itens_negocio_to_string;
        }

        $this->vdata['negocio_itens_negocio_to_string'] = $this->negocio_itens_negocio_to_string;
    }

    public function get_negocio_itens_negocio_to_string()
    {
        if(!empty($this->negocio_itens_negocio_to_string))
        {
            return $this->negocio_itens_negocio_to_string;
        }
    
        $values = NegocioItens::where('negocio_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

    public function set_negocio_itens_produto_to_string($negocio_itens_produto_to_string)
    {
        if(is_array($negocio_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $negocio_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_itens_produto_to_string = $negocio_itens_produto_to_string;
        }

        $this->vdata['negocio_itens_produto_to_string'] = $this->negocio_itens_produto_to_string;
    }

    public function get_negocio_itens_produto_to_string()
    {
        if(!empty($this->negocio_itens_produto_to_string))
        {
            return $this->negocio_itens_produto_to_string;
        }
    
        $values = NegocioItens::where('negocio_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_notas_negocio_to_string($negocio_notas_negocio_to_string)
    {
        if(is_array($negocio_notas_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_notas_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_notas_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_notas_negocio_to_string = $negocio_notas_negocio_to_string;
        }

        $this->vdata['negocio_notas_negocio_to_string'] = $this->negocio_notas_negocio_to_string;
    }

    public function get_negocio_notas_negocio_to_string()
    {
        if(!empty($this->negocio_notas_negocio_to_string))
        {
            return $this->negocio_notas_negocio_to_string;
        }
    
        $values = NegocioNotas::where('negocio_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

   public function get_etapa_cor()
   {
        $funil_etapa = FunilEtapas::find($this->funil_etapas_id);
    
        $cor = $funil_etapa->cor_etapa;
        $descricao = $funil_etapa->descricao;
    
        return "<span class='label' style='background-color:{$cor}'>{$descricao}</span>";
   }
   
   public function get_arquivado_cor()
   {
        $cor = '#F44336';
        $label = Resposta::find($this->arquivado)->descricao;

        if ($this->arquivado == Resposta::Sim)
        {
            $cor = '#4CAF50';
        }
    
        if ($this->arquivado == Resposta::Nao)
        {
            $cor = '#F44336';
        }
    
        return "<span class='label' style='background-color:{$cor}'>{$label}</span>";
   }   
   
   public static function TotalizaNegocio($negocio_id)
   {
       $negocio = self::find($negocio_id);
       $total = 0;

       $listaItens = NegocioItens::where('negocio_id','=', $negocio_id)->load();
   
       if ($listaItens)
       {
          foreach ($listaItens as $item)
          {
              $total += $item->valor_total;   
          } 
       }
  
       $negocio->valor = $total;
       $negocio->store();
   }
   
   public static function GerarOrcamento($negocio)
   {
    //   $negocio = self::find($negocio_id);
   
       //validando campos obrigatorios..
       if (!$negocio->cliente_id)
       {
           throw new exception('Cliente não informado no negócio!');
       }
   
       $orcamento = new Orcamento();
       $orcamento->system_unit_id = $negocio->system_unit_id;
       $orcamento->orcamento_situacao_id = OrcamentoSituacao::Aberto;
       $orcamento->vendedor_id = $negocio->vendedor_id;
       $orcamento->cliente_id = $negocio->cliente_id;
       $orcamento->cliente_contato_id = null;
       $orcamento->data_orcamento = date('Y-m-d');
       $orcamento->observacao = '';
       $orcamento->valor_produtos = $negocio->valor;
       $orcamento->desconto = 0;
       $orcamento->peso_total = 0;
       $orcamento->frete_total = 0;
       $orcamento->valor_total = $negocio->valor;
       $orcamento->tabela_preco_id = null;
   
       Funcoes::SalvarUsuarioCadastro($orcamento);
   
       $orcamento->store();
   
       //itens
       $listaItens = NegocioItens::where('negocio_id','=', $negocio->id)->load();
   
       if ($listaItens)
       {
          foreach ($listaItens as $item)
          {
              $orcamentoItem = new OrcamentoItem();

              $orcamentoItem->orcamento_id = $orcamento->id;
              $orcamentoItem->produto_id = $item->produto_id;
              $orcamentoItem->quantidade = $item->quantidade;
              $orcamentoItem->valor_unitario = $item->valor_unitario;
              $orcamentoItem->valor_total = $item->valor_total;
              $orcamentoItem->valor_original = $item->valor_unitario;
          
              $produtofilial = ProdutoFilial::where('produto_id', '=', $item->produto_id)
                                            ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                            ->first();

              if($produtofilial)
              {                    
                $orcamentoItem->valor_custo = number_format($produtofilial->valor_custo, 2, ',', '.');  
              }          

              $orcamentoItem->desconto = $item->desconto;
              $orcamentoItem->informacoes_adicionais = '';
              $orcamentoItem->numero_pedido = '';
              $orcamentoItem->numero_item_pedido = '';
              $orcamentoItem->valor_frete = 0;
              $orcamentoItem->peso_unitario = 0;
              $orcamentoItem->peso_total = 0;          
          
              Funcoes::SalvarUsuarioCadastro($orcamentoItem);
          
              $orcamentoItem->store();
          } 
       }
       else
       {
         throw new exception('Este negócio não possui produtos!');  
       }
   
       $negocio->orcamento_id = $orcamento->id;
       $negocio->store();
   }
   
   
    public static function ConfigEvento_NegocioIncluidoOuAlterado($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Negocio incluído ou alterado";
       $mensagem = "Id do negócio: ".$id." OBS: ".$obs;
       $acao = new TAction(['NegocioForm', 'onEdit'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function SincronizaEventos()
    {
       Eventos::ProcessaEventos('NegocioForm',self::Evento_NegocioIncluidoOuAlterado);
    } 
                    
}

