<?php

class NegocioAtividade extends TRecord
{
    const TABLENAME  = 'negocio_atividade';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $negocio;
    private $negocio_tipo_atividade;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('negocio_id');
        parent::addAttribute('negocio_tipo_atividade_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('horario_inicial');
        parent::addAttribute('horario_final');
        parent::addAttribute('observacao');
            
    }

    /**
     * Method set_negocio
     * Sample of usage: $var->negocio = $object;
     * @param $object Instance of Negocio
     */
    public function set_negocio(Negocio $object)
    {
        $this->negocio = $object;
        $this->negocio_id = $object->id;
    }

    /**
     * Method get_negocio
     * Sample of usage: $var->negocio->attribute;
     * @returns Negocio instance
     */
    public function get_negocio()
    {
    
        // loads the associated object
        if (empty($this->negocio))
            $this->negocio = new Negocio($this->negocio_id);
    
        // returns the associated object
        return $this->negocio;
    }
    /**
     * Method set_negocio_tipo_atividade
     * Sample of usage: $var->negocio_tipo_atividade = $object;
     * @param $object Instance of NegocioTipoAtividade
     */
    public function set_negocio_tipo_atividade(NegocioTipoAtividade $object)
    {
        $this->negocio_tipo_atividade = $object;
        $this->negocio_tipo_atividade_id = $object->id;
    }

    /**
     * Method get_negocio_tipo_atividade
     * Sample of usage: $var->negocio_tipo_atividade->attribute;
     * @returns NegocioTipoAtividade instance
     */
    public function get_negocio_tipo_atividade()
    {
    
        // loads the associated object
        if (empty($this->negocio_tipo_atividade))
            $this->negocio_tipo_atividade = new NegocioTipoAtividade($this->negocio_tipo_atividade_id);
    
        // returns the associated object
        return $this->negocio_tipo_atividade;
    }

    
}

