<?php

class NegocioEtapasHistorico extends TRecord
{
    const TABLENAME  = 'negocio_etapas_historico';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $negocio;
    private $funil_etapas;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('negocio_id');
        parent::addAttribute('funil_etapas_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_negocio
     * Sample of usage: $var->negocio = $object;
     * @param $object Instance of Negocio
     */
    public function set_negocio(Negocio $object)
    {
        $this->negocio = $object;
        $this->negocio_id = $object->id;
    }

    /**
     * Method get_negocio
     * Sample of usage: $var->negocio->attribute;
     * @returns Negocio instance
     */
    public function get_negocio()
    {
    
        // loads the associated object
        if (empty($this->negocio))
            $this->negocio = new Negocio($this->negocio_id);
    
        // returns the associated object
        return $this->negocio;
    }
    /**
     * Method set_funil_etapas
     * Sample of usage: $var->funil_etapas = $object;
     * @param $object Instance of FunilEtapas
     */
    public function set_funil_etapas(FunilEtapas $object)
    {
        $this->funil_etapas = $object;
        $this->funil_etapas_id = $object->id;
    }

    /**
     * Method get_funil_etapas
     * Sample of usage: $var->funil_etapas->attribute;
     * @returns FunilEtapas instance
     */
    public function get_funil_etapas()
    {
    
        // loads the associated object
        if (empty($this->funil_etapas))
            $this->funil_etapas = new FunilEtapas($this->funil_etapas_id);
    
        // returns the associated object
        return $this->funil_etapas;
    }

    
}

