<?php

class NegocioItens extends TRecord
{
    const TABLENAME  = 'negocio_itens';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $negocio;
    private $produto;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('negocio_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_total');
        parent::addAttribute('desconto');
            
    }

    /**
     * Method set_negocio
     * Sample of usage: $var->negocio = $object;
     * @param $object Instance of Negocio
     */
    public function set_negocio(Negocio $object)
    {
        $this->negocio = $object;
        $this->negocio_id = $object->id;
    }

    /**
     * Method get_negocio
     * Sample of usage: $var->negocio->attribute;
     * @returns Negocio instance
     */
    public function get_negocio()
    {
    
        // loads the associated object
        if (empty($this->negocio))
            $this->negocio = new Negocio($this->negocio_id);
    
        // returns the associated object
        return $this->negocio;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }

    
}

