<?php

class NegocioTipoAtividade extends TRecord
{
    const TABLENAME  = 'negocio_tipo_atividade';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('cor');
        parent::addAttribute('icone');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method getNegocioAtividades
     */
    public function getNegocioAtividades()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('negocio_tipo_atividade_id', '=', $this->id));
        return NegocioAtividade::getObjects( $criteria );
    }

    public function set_negocio_atividade_negocio_to_string($negocio_atividade_negocio_to_string)
    {
        if(is_array($negocio_atividade_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_atividade_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_atividade_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_atividade_negocio_to_string = $negocio_atividade_negocio_to_string;
        }

        $this->vdata['negocio_atividade_negocio_to_string'] = $this->negocio_atividade_negocio_to_string;
    }

    public function get_negocio_atividade_negocio_to_string()
    {
        if(!empty($this->negocio_atividade_negocio_to_string))
        {
            return $this->negocio_atividade_negocio_to_string;
        }
    
        $values = NegocioAtividade::where('negocio_tipo_atividade_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

    public function set_negocio_atividade_negocio_tipo_atividade_to_string($negocio_atividade_negocio_tipo_atividade_to_string)
    {
        if(is_array($negocio_atividade_negocio_tipo_atividade_to_string))
        {
            $values = NegocioTipoAtividade::where('id', 'in', $negocio_atividade_negocio_tipo_atividade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_atividade_negocio_tipo_atividade_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_atividade_negocio_tipo_atividade_to_string = $negocio_atividade_negocio_tipo_atividade_to_string;
        }

        $this->vdata['negocio_atividade_negocio_tipo_atividade_to_string'] = $this->negocio_atividade_negocio_tipo_atividade_to_string;
    }

    public function get_negocio_atividade_negocio_tipo_atividade_to_string()
    {
        if(!empty($this->negocio_atividade_negocio_tipo_atividade_to_string))
        {
            return $this->negocio_atividade_negocio_tipo_atividade_to_string;
        }
    
        $values = NegocioAtividade::where('negocio_tipo_atividade_id', '=', $this->id)->getIndexedArray('negocio_tipo_atividade_id','{negocio_tipo_atividade->descricao}');
        return implode(', ', $values);
    }

    public function get_icone_formatado()
    {
        if($this->icone)
        {
            return "<i class='{$this->icone}'> </i>";
        }
    }
  
  

}

