<?php

class NotaFiscalCompra extends TRecord
{
    const TABLENAME  = 'nota_fiscal_compra';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_unit;
    private $fornecedor;
    private $notafiscal_tipodocumento;
    private $nota_fiscal_compra_situacao;
    private $notafiscal_crt;
    private $notafiscal_indiedest;
    private $notafiscaldest;
    private $notafiscal_tpimp;
    private $notafiscal_finnfe;
    private $notafiscal_indfinal;
    private $notafiscal_indpres;
    private $notafiscal_indpag;
    private $notafiscal_mod;
    private $notafiscal_modfrete;

    const Evento_NotaEntradaIncluida = 'Nota fiscal de entrada incluída';
                                                            

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('fornecedor_id');
        parent::addAttribute('numero');
        parent::addAttribute('data_emissao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('natop');
        parent::addAttribute('data_saida');
        parent::addAttribute('infcpl');
        parent::addAttribute('infadfisco');
        parent::addAttribute('icms_basecalc');
        parent::addAttribute('icms_valor');
        parent::addAttribute('icms_subst_base_calc');
        parent::addAttribute('icms_subst_valor');
        parent::addAttribute('frete_valor');
        parent::addAttribute('seguro_valor');
        parent::addAttribute('outras_despesas');
        parent::addAttribute('ipi_valor');
        parent::addAttribute('serie');
        parent::addAttribute('valor_total_produtos');
        parent::addAttribute('valor_total_nota');
        parent::addAttribute('transp_nome');
        parent::addAttribute('transp_cnpj');
        parent::addAttribute('transp_inscest');
        parent::addAttribute('transp_endereco');
        parent::addAttribute('transp_cidade');
        parent::addAttribute('transp_placaveiculo');
        parent::addAttribute('transp_uf');
        parent::addAttribute('transp_veiculouf');
        parent::addAttribute('transp_veiculorntc');
        parent::addAttribute('transp_numeracao');
        parent::addAttribute('notafiscal_tipodocumento_id');
        parent::addAttribute('nota_fiscal_compra_situacao_id');
        parent::addAttribute('notafiscal_crt_id');
        parent::addAttribute('obs_importacao_xml');
        parent::addAttribute('cliente_endereco');
        parent::addAttribute('cliente_complemento');
        parent::addAttribute('cliente_numero');
        parent::addAttribute('cliente_bairro');
        parent::addAttribute('cliente_cidade');
        parent::addAttribute('cliente_cep');
        parent::addAttribute('cliente_estado');
        parent::addAttribute('cliente_nome');
        parent::addAttribute('cliente_cpfcnpj');
        parent::addAttribute('cliente_inscest');
        parent::addAttribute('cliente_fone');
        parent::addAttribute('cliente_cidade_codibge');
        parent::addAttribute('cliente_inscmuni');
        parent::addAttribute('cliente_suframa');
        parent::addAttribute('justificativa_cancelamento');
        parent::addAttribute('chave');
        parent::addAttribute('protocolo_envio');
        parent::addAttribute('notafiscal_indiedest_id');
        parent::addAttribute('protocolo_cancelamento');
        parent::addAttribute('datahora_cancelamento');
        parent::addAttribute('cce_datahora_evento');
        parent::addAttribute('cce_sequencial');
        parent::addAttribute('cce_correcao');
        parent::addAttribute('cce_protocolo');
        parent::addAttribute('desconto_valor');
        parent::addAttribute('pis_valor');
        parent::addAttribute('cofins_valor');
        parent::addAttribute('fatura_numero');
        parent::addAttribute('fatura_valor_original');
        parent::addAttribute('fatura_valor_desconto');
        parent::addAttribute('fatura_valor_liquido');
        parent::addAttribute('notafiscal_iddest_id');
        parent::addAttribute('notafiscal_tpimp_id');
        parent::addAttribute('notafiscal_finnfe_id');
        parent::addAttribute('notafiscal_indfinal_id');
        parent::addAttribute('notafiscal_indpres_id');
        parent::addAttribute('verproc');
        parent::addAttribute('notafiscal_indpag_id');
        parent::addAttribute('retirada_marcado');
        parent::addAttribute('retirada_cpfcnpj');
        parent::addAttribute('retirada_xlgr');
        parent::addAttribute('retirada_nro');
        parent::addAttribute('retirada_xcpl');
        parent::addAttribute('retirada_xbairro');
        parent::addAttribute('retirada_cmun');
        parent::addAttribute('retirada_xmun');
        parent::addAttribute('retirada_uf');
        parent::addAttribute('entrega_marcado');
        parent::addAttribute('entrega_cpfcnpj');
        parent::addAttribute('entrega_xlgr');
        parent::addAttribute('entrega_nro');
        parent::addAttribute('entrega_xcpl');
        parent::addAttribute('entrega_xbairro');
        parent::addAttribute('entrega_cmun');
        parent::addAttribute('entrega_xmun');
        parent::addAttribute('entrega_uf');
        parent::addAttribute('vicmsufdest');
        parent::addAttribute('vicmsufremet');
        parent::addAttribute('vfcpufdest');
        parent::addAttribute('notafiscal_mod_id');
        parent::addAttribute('xml');
        parent::addAttribute('data_hora_envio');
        parent::addAttribute('xml_cancelamento');
        parent::addAttribute('issqn_vserv');
        parent::addAttribute('issqn_vbc');
        parent::addAttribute('issqn_viss');
        parent::addAttribute('issqn_dcompet');
        parent::addAttribute('issqn_reftrib');
        parent::addAttribute('icms_vfcp');
        parent::addAttribute('icms_vfcpst');
        parent::addAttribute('icms_vfcpstret');
        parent::addAttribute('layout_versao');
        parent::addAttribute('ipi_vipidevol');
        parent::addAttribute('vtroco');
        parent::addAttribute('notafiscal_modfrete_id');
        parent::addAttribute('cpag_lancada');
        parent::addAttribute('dest_cnpj');
    
    }

    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_fornecedor
     * Sample of usage: $var->fornecedor = $object;
     * @param $object Instance of Fornecedor
     */
    public function set_fornecedor(Fornecedor $object)
    {
        $this->fornecedor = $object;
        $this->fornecedor_id = $object->id;
    }

    /**
     * Method get_fornecedor
     * Sample of usage: $var->fornecedor->attribute;
     * @returns Fornecedor instance
     */
    public function get_fornecedor()
    {
    
        // loads the associated object
        if (empty($this->fornecedor))
            $this->fornecedor = new Fornecedor($this->fornecedor_id);
    
        // returns the associated object
        return $this->fornecedor;
    }
    /**
     * Method set_notafiscal_tipodocumento
     * Sample of usage: $var->notafiscal_tipodocumento = $object;
     * @param $object Instance of NotafiscalTipodocumento
     */
    public function set_notafiscal_tipodocumento(NotafiscalTipodocumento $object)
    {
        $this->notafiscal_tipodocumento = $object;
        $this->notafiscal_tipodocumento_id = $object->id;
    }

    /**
     * Method get_notafiscal_tipodocumento
     * Sample of usage: $var->notafiscal_tipodocumento->attribute;
     * @returns NotafiscalTipodocumento instance
     */
    public function get_notafiscal_tipodocumento()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tipodocumento))
            $this->notafiscal_tipodocumento = new NotafiscalTipodocumento($this->notafiscal_tipodocumento_id);
    
        // returns the associated object
        return $this->notafiscal_tipodocumento;
    }
    /**
     * Method set_nota_fiscal_compra_situacao
     * Sample of usage: $var->nota_fiscal_compra_situacao = $object;
     * @param $object Instance of NotaFiscalCompraSituacao
     */
    public function set_nota_fiscal_compra_situacao(NotaFiscalCompraSituacao $object)
    {
        $this->nota_fiscal_compra_situacao = $object;
        $this->nota_fiscal_compra_situacao_id = $object->id;
    }

    /**
     * Method get_nota_fiscal_compra_situacao
     * Sample of usage: $var->nota_fiscal_compra_situacao->attribute;
     * @returns NotaFiscalCompraSituacao instance
     */
    public function get_nota_fiscal_compra_situacao()
    {
    
        // loads the associated object
        if (empty($this->nota_fiscal_compra_situacao))
            $this->nota_fiscal_compra_situacao = new NotaFiscalCompraSituacao($this->nota_fiscal_compra_situacao_id);
    
        // returns the associated object
        return $this->nota_fiscal_compra_situacao;
    }
    /**
     * Method set_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt = $object;
     * @param $object Instance of NotafiscalCrt
     */
    public function set_notafiscal_crt(NotafiscalCrt $object)
    {
        $this->notafiscal_crt = $object;
        $this->notafiscal_crt_id = $object->id;
    }

    /**
     * Method get_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt->attribute;
     * @returns NotafiscalCrt instance
     */
    public function get_notafiscal_crt()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_crt))
            $this->notafiscal_crt = new NotafiscalCrt($this->notafiscal_crt_id);
    
        // returns the associated object
        return $this->notafiscal_crt;
    }
    /**
     * Method set_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest = $object;
     * @param $object Instance of NotafiscalIndiedest
     */
    public function set_notafiscal_indiedest(NotafiscalIndiedest $object)
    {
        $this->notafiscal_indiedest = $object;
        $this->notafiscal_indiedest_id = $object->id;
    }

    /**
     * Method get_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest->attribute;
     * @returns NotafiscalIndiedest instance
     */
    public function get_notafiscal_indiedest()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indiedest))
            $this->notafiscal_indiedest = new NotafiscalIndiedest($this->notafiscal_indiedest_id);
    
        // returns the associated object
        return $this->notafiscal_indiedest;
    }
    /**
     * Method set_notafiscal_iddest
     * Sample of usage: $var->notafiscal_iddest = $object;
     * @param $object Instance of NotafiscalIddest
     */
    public function set_notafiscaldest(NotafiscalIddest $object)
    {
        $this->notafiscaldest = $object;
        $this->notafiscal_iddest_id = $object->id;
    }

    /**
     * Method get_notafiscaldest
     * Sample of usage: $var->notafiscaldest->attribute;
     * @returns NotafiscalIddest instance
     */
    public function get_notafiscaldest()
    {
    
        // loads the associated object
        if (empty($this->notafiscaldest))
            $this->notafiscaldest = new NotafiscalIddest($this->notafiscal_iddest_id);
    
        // returns the associated object
        return $this->notafiscaldest;
    }
    /**
     * Method set_notafiscal_tpimp
     * Sample of usage: $var->notafiscal_tpimp = $object;
     * @param $object Instance of NotafiscalTpimp
     */
    public function set_notafiscal_tpimp(NotafiscalTpimp $object)
    {
        $this->notafiscal_tpimp = $object;
        $this->notafiscal_tpimp_id = $object->id;
    }

    /**
     * Method get_notafiscal_tpimp
     * Sample of usage: $var->notafiscal_tpimp->attribute;
     * @returns NotafiscalTpimp instance
     */
    public function get_notafiscal_tpimp()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tpimp))
            $this->notafiscal_tpimp = new NotafiscalTpimp($this->notafiscal_tpimp_id);
    
        // returns the associated object
        return $this->notafiscal_tpimp;
    }
    /**
     * Method set_notafiscal_finnfe
     * Sample of usage: $var->notafiscal_finnfe = $object;
     * @param $object Instance of NotafiscalFinnfe
     */
    public function set_notafiscal_finnfe(NotafiscalFinnfe $object)
    {
        $this->notafiscal_finnfe = $object;
        $this->notafiscal_finnfe_id = $object->id;
    }

    /**
     * Method get_notafiscal_finnfe
     * Sample of usage: $var->notafiscal_finnfe->attribute;
     * @returns NotafiscalFinnfe instance
     */
    public function get_notafiscal_finnfe()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_finnfe))
            $this->notafiscal_finnfe = new NotafiscalFinnfe($this->notafiscal_finnfe_id);
    
        // returns the associated object
        return $this->notafiscal_finnfe;
    }
    /**
     * Method set_notafiscal_indfinal
     * Sample of usage: $var->notafiscal_indfinal = $object;
     * @param $object Instance of NotafiscalIndfinal
     */
    public function set_notafiscal_indfinal(NotafiscalIndfinal $object)
    {
        $this->notafiscal_indfinal = $object;
        $this->notafiscal_indfinal_id = $object->id;
    }

    /**
     * Method get_notafiscal_indfinal
     * Sample of usage: $var->notafiscal_indfinal->attribute;
     * @returns NotafiscalIndfinal instance
     */
    public function get_notafiscal_indfinal()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indfinal))
            $this->notafiscal_indfinal = new NotafiscalIndfinal($this->notafiscal_indfinal_id);
    
        // returns the associated object
        return $this->notafiscal_indfinal;
    }
    /**
     * Method set_notafiscal_indpres
     * Sample of usage: $var->notafiscal_indpres = $object;
     * @param $object Instance of NotafiscalIndpres
     */
    public function set_notafiscal_indpres(NotafiscalIndpres $object)
    {
        $this->notafiscal_indpres = $object;
        $this->notafiscal_indpres_id = $object->id;
    }

    /**
     * Method get_notafiscal_indpres
     * Sample of usage: $var->notafiscal_indpres->attribute;
     * @returns NotafiscalIndpres instance
     */
    public function get_notafiscal_indpres()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indpres))
            $this->notafiscal_indpres = new NotafiscalIndpres($this->notafiscal_indpres_id);
    
        // returns the associated object
        return $this->notafiscal_indpres;
    }
    /**
     * Method set_notafiscal_indpag
     * Sample of usage: $var->notafiscal_indpag = $object;
     * @param $object Instance of NotafiscalIndpag
     */
    public function set_notafiscal_indpag(NotafiscalIndpag $object)
    {
        $this->notafiscal_indpag = $object;
        $this->notafiscal_indpag_id = $object->id;
    }

    /**
     * Method get_notafiscal_indpag
     * Sample of usage: $var->notafiscal_indpag->attribute;
     * @returns NotafiscalIndpag instance
     */
    public function get_notafiscal_indpag()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indpag))
            $this->notafiscal_indpag = new NotafiscalIndpag($this->notafiscal_indpag_id);
    
        // returns the associated object
        return $this->notafiscal_indpag;
    }
    /**
     * Method set_notafiscal_mod
     * Sample of usage: $var->notafiscal_mod = $object;
     * @param $object Instance of NotafiscalMod
     */
    public function set_notafiscal_mod(NotafiscalMod $object)
    {
        $this->notafiscal_mod = $object;
        $this->notafiscal_mod_id = $object->id;
    }

    /**
     * Method get_notafiscal_mod
     * Sample of usage: $var->notafiscal_mod->attribute;
     * @returns NotafiscalMod instance
     */
    public function get_notafiscal_mod()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_mod))
            $this->notafiscal_mod = new NotafiscalMod($this->notafiscal_mod_id);
    
        // returns the associated object
        return $this->notafiscal_mod;
    }
    /**
     * Method set_notafiscal_modfrete
     * Sample of usage: $var->notafiscal_modfrete = $object;
     * @param $object Instance of NotafiscalModfrete
     */
    public function set_notafiscal_modfrete(NotafiscalModfrete $object)
    {
        $this->notafiscal_modfrete = $object;
        $this->notafiscal_modfrete_id = $object->id;
    }

    /**
     * Method get_notafiscal_modfrete
     * Sample of usage: $var->notafiscal_modfrete->attribute;
     * @returns NotafiscalModfrete instance
     */
    public function get_notafiscal_modfrete()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_modfrete))
            $this->notafiscal_modfrete = new NotafiscalModfrete($this->notafiscal_modfrete_id);
    
        // returns the associated object
        return $this->notafiscal_modfrete;
    }

    /**
     * Method getContaspags
     */
    public function getContaspags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('nota_fiscal_compra_id', '=', $this->id));
        return Contaspag::getObjects( $criteria );
    }
    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('nota_fiscal_compra_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraDups
     */
    public function getNotaFiscalCompraDups()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('nota_fiscal_compra_id', '=', $this->id));
        return NotaFiscalCompraDup::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraItenss
     */
    public function getNotaFiscalCompraItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('nota_fiscal_compra_id', '=', $this->id));
        return NotaFiscalCompraItens::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraPags
     */
    public function getNotaFiscalCompraPags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('nota_fiscal_compra_id', '=', $this->id));
        return NotaFiscalCompraPag::getObjects( $criteria );
    }

    public function set_contaspag_contaspag_situacao_to_string($contaspag_contaspag_situacao_to_string)
    {
        if(is_array($contaspag_contaspag_situacao_to_string))
        {
            $values = ContaspagSituacao::where('id', 'in', $contaspag_contaspag_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_situacao_to_string = $contaspag_contaspag_situacao_to_string;
        }

        $this->vdata['contaspag_contaspag_situacao_to_string'] = $this->contaspag_contaspag_situacao_to_string;
    }

    public function get_contaspag_contaspag_situacao_to_string()
    {
        if(!empty($this->contaspag_contaspag_situacao_to_string))
        {
            return $this->contaspag_contaspag_situacao_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('contaspag_situacao_id','{contaspag_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_forma_pagamento_to_string($contaspag_forma_pagamento_to_string)
    {
        if(is_array($contaspag_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_forma_pagamento_to_string = $contaspag_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_forma_pagamento_to_string'] = $this->contaspag_forma_pagamento_to_string;
    }

    public function get_contaspag_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_forma_pagamento_to_string))
        {
            return $this->contaspag_forma_pagamento_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_fornecedor_to_string($contaspag_fornecedor_to_string)
    {
        if(is_array($contaspag_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_fornecedor_to_string = $contaspag_fornecedor_to_string;
        }

        $this->vdata['contaspag_fornecedor_to_string'] = $this->contaspag_fornecedor_to_string;
    }

    public function get_contaspag_fornecedor_to_string()
    {
        if(!empty($this->contaspag_fornecedor_to_string))
        {
            return $this->contaspag_fornecedor_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_origem_to_string($contaspag_contaspag_origem_to_string)
    {
        if(is_array($contaspag_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_origem_to_string = $contaspag_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_contaspag_origem_to_string'] = $this->contaspag_contaspag_origem_to_string;
    }

    public function get_contaspag_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_contaspag_origem_to_string))
        {
            return $this->contaspag_contaspag_origem_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_system_unit_to_string($contaspag_system_unit_to_string)
    {
        if(is_array($contaspag_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_system_unit_to_string = $contaspag_system_unit_to_string;
        }

        $this->vdata['contaspag_system_unit_to_string'] = $this->contaspag_system_unit_to_string;
    }

    public function get_contaspag_system_unit_to_string()
    {
        if(!empty($this->contaspag_system_unit_to_string))
        {
            return $this->contaspag_system_unit_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contaspag_cheque_banco_to_string($contaspag_cheque_banco_to_string)
    {
        if(is_array($contaspag_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contaspag_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_cheque_banco_to_string = $contaspag_cheque_banco_to_string;
        }

        $this->vdata['contaspag_cheque_banco_to_string'] = $this->contaspag_cheque_banco_to_string;
    }

    public function get_contaspag_cheque_banco_to_string()
    {
        if(!empty($this->contaspag_cheque_banco_to_string))
        {
            return $this->contaspag_cheque_banco_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_bloco_to_string($contaspag_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_bloco_to_string = $contaspag_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_contaspag_bloco_to_string'] = $this->contaspag_contaspag_bloco_to_string;
    }

    public function get_contaspag_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_contaspag_bloco_to_string))
        {
            return $this->contaspag_contaspag_bloco_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_nota_fiscal_compra_to_string($contaspag_nota_fiscal_compra_to_string)
    {
        if(is_array($contaspag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $contaspag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_nota_fiscal_compra_to_string = $contaspag_nota_fiscal_compra_to_string;
        }

        $this->vdata['contaspag_nota_fiscal_compra_to_string'] = $this->contaspag_nota_fiscal_compra_to_string;
    }

    public function get_contaspag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->contaspag_nota_fiscal_compra_to_string))
        {
            return $this->contaspag_nota_fiscal_compra_to_string;
        }
    
        $values = Contaspag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_nota_fiscal_compra_to_string($nota_fiscal_compra_dup_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_dup_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string = $nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_dup_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_dup_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_forma_pagamento_to_string($nota_fiscal_compra_dup_forma_pagamento_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $nota_fiscal_compra_dup_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_forma_pagamento_to_string = $nota_fiscal_compra_dup_forma_pagamento_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_forma_pagamento_to_string'] = $this->nota_fiscal_compra_dup_forma_pagamento_to_string;
    }

    public function get_nota_fiscal_compra_dup_forma_pagamento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_forma_pagamento_to_string))
        {
            return $this->nota_fiscal_compra_dup_forma_pagamento_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_plano_conta_to_string($nota_fiscal_compra_dup_plano_conta_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $nota_fiscal_compra_dup_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_plano_conta_to_string = $nota_fiscal_compra_dup_plano_conta_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_plano_conta_to_string'] = $this->nota_fiscal_compra_dup_plano_conta_to_string;
    }

    public function get_nota_fiscal_compra_dup_plano_conta_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_plano_conta_to_string))
        {
            return $this->nota_fiscal_compra_dup_plano_conta_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_dup_centro_custo_to_string($nota_fiscal_compra_dup_centro_custo_to_string)
    {
        if(is_array($nota_fiscal_compra_dup_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $nota_fiscal_compra_dup_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_dup_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_dup_centro_custo_to_string = $nota_fiscal_compra_dup_centro_custo_to_string;
        }

        $this->vdata['nota_fiscal_compra_dup_centro_custo_to_string'] = $this->nota_fiscal_compra_dup_centro_custo_to_string;
    }

    public function get_nota_fiscal_compra_dup_centro_custo_to_string()
    {
        if(!empty($this->nota_fiscal_compra_dup_centro_custo_to_string))
        {
            return $this->nota_fiscal_compra_dup_centro_custo_to_string;
        }
    
        $values = NotaFiscalCompraDup::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_to_string($nota_fiscal_compra_itens_produto_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $nota_fiscal_compra_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_to_string = $nota_fiscal_compra_itens_produto_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_to_string'] = $this->nota_fiscal_compra_itens_produto_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            $values = NotaFiscalCompraItensSituacao::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_itens_situacao_id','{nota_fiscal_compra_itens_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            $values = NotafiscalItemIndtot::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_indtot_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('notafiscal_item_indtot_id','{notafiscal_item_indtot->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_orig_to_string($nota_fiscal_compra_itens_notafiscal_item_orig_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = $nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_orig_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_modbc_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_estoque_deposito_to_string($nota_fiscal_compra_itens_estoque_deposito_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $nota_fiscal_compra_itens_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = $nota_fiscal_compra_itens_estoque_deposito_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_estoque_deposito_to_string'] = $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
    }

    public function get_nota_fiscal_compra_itens_estoque_deposito_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            return $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_lote_to_string($nota_fiscal_compra_itens_produto_lote_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $nota_fiscal_compra_itens_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->nota_fiscal_compra_itens_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_lote_to_string = $nota_fiscal_compra_itens_produto_lote_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_lote_to_string'] = $this->nota_fiscal_compra_itens_produto_lote_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_lote_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_lote_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_lote_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_pag_nota_fiscal_compra_to_string($nota_fiscal_compra_pag_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_pag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_pag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string = $nota_fiscal_compra_pag_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_pag_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_pag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraPag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_pag_notafiscal_tpag_to_string($nota_fiscal_compra_pag_notafiscal_tpag_to_string)
    {
        if(is_array($nota_fiscal_compra_pag_notafiscal_tpag_to_string))
        {
            $values = NotafiscalTpag::where('id', 'in', $nota_fiscal_compra_pag_notafiscal_tpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string = $nota_fiscal_compra_pag_notafiscal_tpag_to_string;
        }

        $this->vdata['nota_fiscal_compra_pag_notafiscal_tpag_to_string'] = $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string;
    }

    public function get_nota_fiscal_compra_pag_notafiscal_tpag_to_string()
    {
        if(!empty($this->nota_fiscal_compra_pag_notafiscal_tpag_to_string))
        {
            return $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string;
        }
    
        $values = NotaFiscalCompraPag::where('nota_fiscal_compra_id', '=', $this->id)->getIndexedArray('notafiscal_tpag_id','{notafiscal_tpag->descricao}');
        return implode(', ', $values);
    }

  
   public static function EstornarNotaCompra($notacompra)
   {
       // verificando se tem saldo no estoque...
         foreach ($notacompra->getNotaFiscalCompraItenss() as $item) 
         {
              $prod_estoque = VwProdutoEstoque::where('id', '=', $item->produto_id)->first();
          
              if ($prod_estoque)
              {
                if ($prod_estoque->Quantidade_Disponivel < $item->quantidade)
                {
                    throw new exception('O produto '.$venda_item->produto->nome.' não tem saldo disponivel para venda!');
                }
              }
         }

        //retirando do estoque...
        self::LancamentoEstoque($notacompra,
                                'Estorno da entrada de nota fiscal de compra Id: '.$notacompra->id,
                                EstoqueTipoMovimentacao::Saida);                                 

        $notacompra->nota_fiscal_compra_situacao_id=NotaFiscalCompraSituacao::EmDigitacao;
        $notacompra->store();

        //cancelando o contas pag
        $lista_contaspag = Contaspag::where('nota_fiscal_compra_id', '=', $notacompra->id)->load();

        foreach ($lista_contaspag as $cpag) 
        {        
          //se tiver algum titulo baixado não será permitido o estorno..
          if ($cpag->contaspag_situacao_id != ContaspagSituacao::EmAberto)
          {
              throw new exception ('Existe títulos a pagar baixados, não será possivel estornar esta nota fiscal!');
          }

          $cpag->contaspag_situacao_id = ContaspagSituacao::Cancelado;
          $cpag->store();
        }                                        

   } 
 
 
 public function get_fornecedor_xml()
 {
     if ($this->fornecedor_id ==null)
     {
         return $this->cliente_nome.' (Não vinculado)';
     }
     else
     {
        if (empty($this->fornecedor))
            $this->fornecedor = new Fornecedor($this->fornecedor_id);     
        
         return $this->fornecedor->nome;
     }
 }

  
 public static function atualiza_totais_nota($idnota)
  {
     $nota = NotaFiscalCompra::find($idnota);
 
     if($nota)
     {
        $ICMS_BC                = 0;
        $ICMS_Valor             = 0;
        $ICMSST_BC              = 0;
        $ICMSST_Valor           = 0;
        $TotalProdutos          = 0;
        $TotalFrete             = 0;
        $TotalSeguro            = 0;
        $TotalDesconto          = 0;
        $IPI_Valor              = 0;
        $TotalNota              = 0;
        $PIS_Valor              = 0;
        $COFINS_Valor           = 0;
        $TotalOutrasDespesas    = 0;
        $TotalICMS_VICMSUFDEST  = 0;
        $TotalICMS_VICMSUFREMET = 0;
        $TotalICMS_VFCPUFDEST   = 0;
        $ISSQN_VBC              = 0;
        $ISSQN_VSERV            = 0;
        $ISSQN_VISS             = 0;
        $vFCP                   = 0;
        $vFCPST                 = 0;
        $vFCPSTRET              = 0;
        $vIPIDevol              = 0;    

         foreach ($nota->getNotaFiscalCompraItenss() as $item) 
         {
         
            $ICMS_BC                +=  $item->icms_basecalc;
            $ICMS_Valor             +=  $item->icms_valor;
            $ICMSST_BC              +=  $item->icms_vbcst;
            $ICMSST_Valor           +=  $item->icms_vicmsst;
            $TotalFrete             +=  $item->vfrete;
            $TotalSeguro            +=  $item->vseg;
            $TotalDesconto          +=  $item->vdesc;
            $IPI_Valor              +=  $item->ipi_valor;
            $PIS_Valor              +=  $item->pis_valor;
            $COFINS_Valor           +=  $item->cofins_valor;
            $TotalOutrasDespesas    +=  $item->voutro;
            $TotalProdutos          +=  $item->vprod;

            //totais de FCP (NFe 4.00)
            //$vFCP                   += $item->vfcp;
            //$vFCPST                 += $item->vfcpst;
            //$vFCPSTRET              += $item->vfcpstret;

           // $TotalICMS_VICMSUFDEST  += TotalICMS_VICMSUFDEST + ArredondaDecimal(2,CdsItNotaFiscalNI_ICMS_VICMSUFDEST.Value);
            //$TotalICMS_VICMSUFREMET += TotalICMS_VICMSUFREMET + ArredondaDecimal(2,CdsItNotaFiscalNI_ICMS_VICMSUFREMET.Value);
            //$TotalICMS_VFCPUFDEST   += TotalICMS_VFCPUFDEST + ArredondaDecimal(2,CdsItNotaFiscalNI_ICMS_VFCPUFDEST.Value);

            //parte de ISSQN FALTA
            //ISSQN_VBC              += CdsItNotaFiscalNI_ISSQN_VBC.Value;
            //if CdsItNotaFiscalNI_ISSQN_VBC.Value>0 then //só contabilizar valor se for de serviço...
            //ISSQN_VSERV          +=  CdsItNotaFiscalNI_TOTAL.Value;
            //ISSQN_VISS           += CdsItNotaFiscalNI_ISSQN_VISSQN.Value;

            $vIPIDevol              += $item->ipi_vipidevol;

         }
     
           $TotalNota = $TotalProdutos -
                        $TotalDesconto +
                        $ICMSST_Valor  +
                        $TotalFrete    +
                        $TotalSeguro   +
                        $IPI_Valor     +
                        $vIPIDevol     +
                        $TotalOutrasDespesas;   
                    

        $nota->icms_basecalc        = $ICMS_BC;
        $nota->icms_valor           = $ICMS_Valor;
        $nota->icms_subst_base_calc = $ICMSST_BC;
        $nota->icms_subst_valor     = $ICMSST_Valor;
        $nota->frete_valor          = $TotalFrete;
        $nota->seguro_valor         = $TotalSeguro;
        $nota->ipi_valor            = $IPI_Valor;
        $nota->desconto_valor       = $TotalDesconto;
        $nota->pis_valor            = $PIS_Valor;
        $nota->cofins_valor         = $COFINS_Valor;
        $nota->outras_despesas      = $TotalOutrasDespesas;
        $nota->icms_vfcp            = $vFCP;
        $nota->icms_vfcpst          = $vFCPST;
        $nota->icms_vfcpstret       = $vFCPSTRET;

        $nota->vicmsufdest          = $TotalICMS_VICMSUFDEST;
        $nota->vicmsufdestremet     = $TotalICMS_VICMSUFREMET;
        //$nota->vfcpufdest           = TotalICMS_VFCPUFDEST;  

        $nota->ipi_vipidevol        = $vIPIDevol;
    
        $nota->issqn_vserv          = $ISSQN_VSERV;
        $nota->issqn_vbc            = $ISSQN_VBC;
        $nota->issqn_viss           = $ISSQN_VISS;  
    
        if ($nota->issqn_vserv>0)
        {
            $nota->issqn_dcompet    = $nota->data_emissao;       
        }

        $nota->valor_total_produtos = $TotalProdutos; 
        $nota->valor_total_nota     = $TotalNota;
        $nota->store();
     }  

  }  
  
    public static function VinculaProdutosFornecedor($notacompra)
    {
        foreach ($notacompra->getNotaFiscalCompraItenss() as $item) 
        {
        
            //verificando se o produto existe vinculado ao fornecedor...
            $prod_forn = ProdutoFornecedor::where('fornecedor_id', '=', $notacompra->fornecedor_id)
                                          ->where('codigo_fornecedor', '=', $item->cprod)->first();
                                      
            if (!$prod_forn)
            {
                $prod_forn = new ProdutoFornecedor();
            }

            $prod_forn->produto_id = $item->produto_id;
            $prod_forn->fornecedor_id = $notacompra->fornecedor_id;
            $prod_forn->codigo_fornecedor = $item->cprod;
            $prod_forn->descricao_produto_fornecedor = $item->xprod;
            $prod_forn->preco_venda = $item->vuncom;
            Funcoes::SalvarUsuarioCadastro($prod_forn);
            $prod_forn->store();        
        
        }
    }
  
  
    public static function LancamentoEstoque($notacompra, $obs, $estoque_tipo_movimentacao_id)
    {
        foreach ($notacompra->getNotaFiscalCompraItenss() as $item) 
        {
            $lancamento = new EstoqueLancamentos();
            $lancamento->system_unit_id = $notacompra->system_unit_id;
            $lancamento->produto_id = $item->produto_id;
            $lancamento->estoque_tipo_movimentacao_id = $estoque_tipo_movimentacao_id;//EstoqueTipoMovimentacao::Entrada;
            $lancamento->estoque_origem_id = EstoqueOrigem::Compras;
            $lancamento->estoque_deposito_id = $item->estoque_deposito_id;
            $lancamento->produto_lote_id = $item->produto_lote_id;
            $lancamento->quantidade = $item->qcom;
            $lancamento->codigo_origem = $item->nota_fiscal_compra_id;
            $lancamento->preco_venda = 0;
            $lancamento->preco_custo = $item->vprod;   
            $lancamento->data_lancamento = date('Y-m-d');
            $lancamento->nota_fiscal_compra_id = $notacompra->id;
            $lancamento->criado_por = TSession::getValue('username');
            $lancamento->observacao = $obs;
            $lancamento->store();   
        }

    }

    public static function GerarContasAPagar($notacompra)
    {
        foreach ($notacompra->getNotaFiscalCompraDups() as $dup) 
        {
            $cpag = new Contaspag();
        
            $cpag->data_emissao = TDate::date2us(date('d/m/Y'));
            $cpag->numero_documento = $dup->ndup;
            $cpag->nota_fiscal_compra_id = $notacompra->id;
            $cpag->fornecedor_id = $notacompra->fornecedor_id;
            $cpag->forma_pagamento_id = $dup->forma_pagamento_id;
            $cpag->parcela = $dup->parcela;
            $cpag->observacao = 'Ref a nota fiscal de compra Nº '.$notacompra->numero;
            $cpag->contaspag_origem_id = ContaspagOrigem::Compras;
            $cpag->contaspag_situacao_id = ContaspagSituacao::EmAberto;
            $cpag->system_unit_id = TSession::getValue('userunitid');
            $cpag->valor_aberto = $dup->vdup;
            $cpag->valor = $dup->vdup;
            $cpag->data_venc_original = $dup->dvenc;
            $cpag->data_vencimento = $dup->dvenc;
            $cpag->desconto = '0,00';
            $cpag->valor_multa = '0,00';
            $cpag->juros = '0,00';
            $cpag->valor_pago = '0,00'; 
            $cpag->criado_por = TSession::getValue('username'); 
            $cpag->store();

            //gerando o plano de contas..
            if (($dup->plano_conta_id) and ($dup->centro_custo_id))
            {
                $cpag_contabil = new ContaspagContabil();
                $cpag_contabil->contaspag_id = $cpag->id;
                $cpag_contabil->plano_conta_id = $dup->plano_conta_id;
                $cpag_contabil->centro_custo_id = $dup->centro_custo_id;
                $cpag_contabil->valor = $dup->vdup;
                $cpag_contabil->criado_por = TSession::getValue('username');
                $cpag_contabil->store();

                ContabilLancamentos::LancamentoContabil($dup->plano_conta_id,
                                                        $dup->centro_custo_id,
                                                        ContabilLancamentosTipo::Debito,
                                                        ContabilLancamentosSituacao::NaoLiquidado,
                                                        ContabilLancamentosOrigem::ContasPag,
                                                        $cpag_contabil->id,
                                                        $dup->dvenc,
                                                        $dup->vdup,
                                                        'Ref. Débito Forn: '.$cpag->fornecedor->nome);            
            }
        }
    }

     public static function AnalisaVinculosNota($nota_fiscal_compra_id)
     {
         $nota = NotaFiscalCompra::find($nota_fiscal_compra_id);
     
         $resultado = '';
         $nota->nota_fiscal_compra_situacao_id = NotaFiscalCompraSituacao::EmDigitacao;
     
         $filial = SystemUnit::where('id', '=', TSession::getValue('userunitid'))
                             ->where('cnpj', '=', Funcoes::mascaraCpfCnpj($nota->dest_cnpj))->first();
    
        //verificando se a nota é para empresa logada
         if (!$filial)
         {
           $resultado = '-Esta nota fiscal não foi emitida para esta empresa!<br><br>';
         }
     
        //verificando se o fornecedor tem cadastro...
        if ($nota->fornecedor_id == null)
        {
            $forn = Fornecedor::where('cpf_cnpj', '=', Funcoes::mascaraCpfCnpj($nota->cliente_cpfcnpj))->first();
        
            if (!$forn)
            {
              $resultado = $resultado.'-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>';
              $nota->nota_fiscal_compra_situacao_id = NotaFiscalCompraSituacao::ImportadaFaltandoAjustes;
            }   
            else
            {
                $nota->fornecedor_id = $forn->id;
            }
        }
     
         foreach ($nota->getNotaFiscalCompraItenss() as $item) 
         {
         
            //verificando se o produto existe vinculado ao fornecedor...
            if ($item->produto_id == null)
            {        
                $prod_forn = ProdutoFornecedor::where('fornecedor_id', '=', $nota->fornecedor_id)
                                              ->where('codigo_fornecedor', '=', $item->cprod)->first();
                                          
                if ($prod_forn)
                {
                   $item->produto_id = $prod_forn->produto_id; 
               
                   //pegar o deposito padrão..
                   $produtofilial = ProdutoFilial::where('produto_id', '=', $item->produto_id)
                                                  ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                                  ->first();
                   if ($produtofilial)
                   {
                      $item->estoque_deposito_id = $produtofilial->estoque_deposito_id; 
                   }               
               
                   $item->store();
                }
                else
                {
                    $resultado = $resultado.'-O Produto '.$item->xprod.' desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>';
                    $nota->nota_fiscal_compra_situacao_id = NotaFiscalCompraSituacao::ImportadaFaltandoAjustes;         
                }         
            }        
         }
     
         //verificando se existem duplicatas (parcelas)
         $lista_dup = NotaFiscalCompraDup::where('nota_fiscal_compra_id', '=', $nota->id)->load();
     
         if ($lista_dup)
         {   
             $fp_semvinculo = false;
         
             foreach ($lista_dup as $dup)
             {
                if ($dup->forma_pagamento_id==null)
                {
                    $fp_semvinculo = true;
                }
             }

             if ($fp_semvinculo)             
             {
               $resultado = $resultado.'-Existe(m) parcela(s) para vincular a forma de pagamento do contas a pagar.<br><br>';
             }
         }

        $nota->obs_importacao_xml = $resultado;
        $nota->store();     
     }

     public static function ImportarArquivoXML($notacarregada, $arquivoxml)
     {
     
         $resultado = '';
     
         $nfcompra = new NotaFiscalCompra();
         $nfcompra->system_unit_id = TSession::getValue('userunitid');
         $nfcompra->xml = $arquivoxml;
         $nfcompra->chave = $notacarregada->getChave();
         $nfcompra->nota_fiscal_compra_situacao_id = NotaFiscalCompraSituacao::EmDigitacao;
     
         //verificando se a chave já existe no sistema...
         $nfcompra_chave = NotaFiscalCompra::where('chave', '=', $nfcompra->chave)->first();
     
         if ($nfcompra_chave)
         {
             throw new exception('Esta nota fiscal já existe no sistema! Realize uma consulta pela chave.');
         }

         //BLOCO IDE
        //  $ide = (string)$notacarregada->getIde();
         $ide = $notacarregada->getIde();
        //  $nfcompra-> $ide->versao;
         $nfcompra->natop        = $ide->ide_natOp;
     
         $nfmod = NotafiscalMod::where('modelo', '=', $ide->ide_mod)->first();
         $nfcompra->notafiscal_mod_id = $nfmod->id;
     
         $nfcompra->serie        = $ide->ide_serie;
         $nfcompra->numero       = $ide->ide_nNF;
         $nfcompra->data_emissao =  $ide->ide_dhEmi;
         $nfcompra->data_saida   =  $ide->ide_dhSaiEnt; 
     
         $tpdoc = NotafiscalTipodocumento::where('valor', '=', $ide->ide_tpNF)->first();
         $nfcompra->notafiscal_tipodocumento_id =  $tpdoc->id;

         $nfiddest = NotafiscalIddest::where('valor', '=', $ide->ide_idDEst)->first();
         $nfcompra->notafiscal_iddest_id = $nfiddest->id;

        //  $nfcompra->  $ide->ide_cMunFG; 
    
         $nftpimp = NotafiscalTpimp::where('valor', '=', $ide->ide_tp_Imp)->first();
         $nfcompra->notafiscal_tpimp_id = $nftpimp->id; 
     
         $nftpemis = NotafiscalTpemis::where('valor', '=', $ide->ide_tpEmis)->first();
         $nfcompra->notafiscal_tpemis_id = $nftpemis->id; 
     
         $nftpamb = NotafiscalTpamb::where('valor', '=', $ide->ide_tpAmb)->first();
         $nfcompra->notafiscal_tpamb_id =  $nftpamb->id; 
     
         $nffinnfe = NotafiscalFinnfe::where('valor', '=', $ide->ide_finNFe)->first();
         $nfcompra->notafiscal_finnfe_id = $nffinnfe->id; 
     
         $nfindfinal = NotafiscalIndfinal::where('valor', '=', $ide->ide_indFinal)->first();
         $nfcompra->notafiscal_indfinal_id =  $nfindfinal->id; 
     
         $nfindpres = NotafiscalIndpres::where('valor', '=', $ide->ide_indPres)->first();
         $nfcompra->notafiscal_indpres_id = $nfindpres->id;

         $nfcompra->verproc = $ide->ide_verProc;
     
        //  $nfcompra->  $ide->ide_procEmi;
        //  $nfcompra->  $ide->ide_dhCont; 
        //  $nfcompra->  $ide->ide_xJust; 
    
        // echo 'passou bloco ide - ';
    
        //BLOCO DESTINATARIO
        $destinatario = $notacarregada->getDestinatario();
        $nfcompra->dest_cnpj = $destinatario->dest_CNPJ;
    
        $filial = SystemUnit::where('id', '=', TSession::getValue('userunitid'))
                            ->where('cnpj', '=', Funcoes::mascaraCpfCnpj($destinatario->dest_CNPJ))->first();
    
        if (!$filial)
        {
          $resultado = '-Esta nota fiscal não foi emitida para esta empresa!<br><br>';
        }
    
        // echo 'passou bloco destinatario - ';

        //BLOCO EMITENTE
        $emitente = $notacarregada->getEmitente();

        if (empty($emitente->emit_cpf))
        {
            $nfcompra->cliente_cpfcnpj = $emitente->emit_cnpj;
        }
        else
        {
            $nfcompra->cliente_cpfcnpj = $emitente->emit_cpf;
        }
    
        //verificando se o fornecedor tem cadastro...
        $forn = Fornecedor::where('cpf_cnpj', '=', Funcoes::mascaraCpfCnpj($nfcompra->cliente_cpfcnpj))->first();
    
        if (!$forn)
        {
          $resultado = $resultado.'-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>';
          $nfcompra->nota_fiscal_compra_situacao_id = NotaFiscalCompraSituacao::ImportadaFaltandoAjustes;
        }
        else
        {
            $nfcompra->fornecedor_id = $forn->id;
        }
    
        $nfcompra->cliente_nome = $emitente->emit_xNome;
        // $nfcompra->cliente_xfant = $std->emit_xFant;
        $nfcompra->cliente_inscest = $emitente->emit_IE;
    
        $nfcrt = NotafiscalCrt::where('valor', '=', $emitente->emit_CRT)->first();
        $nfcompra->notafiscal_crt_id = $nfcrt->id;

        $nfcompra->cliente_endereco = $emitente->emit_xLgr; 
        $nfcompra->cliente_numero = $emitente->emit_nro;
        $nfcompra->cliente_complemento = $emitente->emit_xCpl; 
        $nfcompra->cliente_bairro = $emitente->emit_xBairro;
        $nfcompra->cliente_cidade_codibge = $emitente->emit_cMun;
        $nfcompra->cliente_cidade = $emitente->emit_xMun; 
        $nfcompra->cliente_estado = $emitente->emit_UF;
        $nfcompra->cliente_cep = $emitente->emit_CEP;
        // $nfcompra->cliente_ $std->emit_cPais;
        // $std->emit_xPais;
        $nfcompra->cliente_fone = $emitente->emit_fone;     
    
        // echo 'passou bloco emitente - ';
    
        //BLOCO PROTOCOLO
        $protocolo = $notacarregada->getProtocolo();    
    
        $nfcompra->protocolo_envio = $protocolo->protocolo_autorizacao;
        $nfcompra->data_hora_envio = $protocolo->dt_autorizacao;
        $nfcompra->status          = $protocolo->cd_status;
    
        // echo 'passou bloco protocolo - ';
    
        //BLOCO TRANSPORTE
        $transporte = $notacarregada->getTransporte();   
    
        if (empty($transporte->transp_CPF))
        {
            $nfcompra->transp_cpfcnpj = $transporte->transp_CNPJ;
        }
        else
        {
            $nfcompra->transp_cpfcnpj = $transporte->transp_CPF;
        }    
    
        $nfcompra->transp_nome = $transporte->transp_xNome;
        $nfcompra->transp_endereco = $transporte->transp_xEnder; 
        $nfcompra->transp_cidade = $transporte->transp_xMun;
        $nfcompra->transp_uf = $transporte->transp_UF;
        $nfcompra->transp_placaveiculo = $transporte->veic_placa;
        $nfcompra->transp_veiculouf = $transporte->veic_UF;
        $nfcompra->transp_veiculorntc = $transporte->veic_RNTC;
    
        // $nfcompra->transp_ $transporte->vol_qVol;
        // $nfcompra->transp_ $transporte->vol_nVol;
        // $nfcompra->transp_ $transporte->vol_esp;
        // $nfcompra->transp_ $transporte->vol_marca;
        // $nfcompra->transp_ $transporte->vol_pesoL;
        // $nfcompra->transp_ $transporte->vol_pesoB;
        //echo 'usuario '.TSession::getValue('username'). '</br>' ;
        Funcoes::SalvarUsuarioCadastro($nfcompra);
        $nfcompra->cpag_lancada = False;
        $nfcompra->store(); //salvando para ja ter o ID 
        // echo 'passou bloco transporte - ';
    
        //BLOCO ITENS
        // $lista_itens = [];
        foreach ($notacarregada->getProdutos() as $item) 
        {
            // code...
            $nfcompra_item = new NotaFiscalCompraItens();

            $nfcompra_item->cprod = $item->cProd;
            $nfcompra_item->cean = $item->cEAN;
            $nfcompra_item->xprod = $item->xProd;
        
            //verificando se o produto existe vinculado ao fornecedor...
            $prod_forn = ProdutoFornecedor::where('fornecedor_id', '=', $nfcompra->fornecedor_id)
                                          ->where('codigo_fornecedor', '=', $nfcompra_item->cprod)->first();
                                      
            if ($prod_forn)
            {
               $nfcompra_item->produto_id = $prod_forn->produto_id; 
           
               //pegar o deposito padrão..
               $produtofilial = ProdutoFilial::where('produto_id', '=', $nfcompra_item->produto_id)
                                              ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                              ->first();
               if ($produtofilial)
               {
                  $nfcompra_item->estoque_deposito_id = $produtofilial->estoque_deposito_id; 
               }
            }
            else
            {
                $resultado = $resultado.'-O Produto '.$item->xProd.' desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>';
                $nfcompra->nota_fiscal_compra_situacao_id = NotaFiscalCompraSituacao::ImportadaFaltandoAjustes;         
            }

            $nfcompra_item->ncm = $item->NCM;
            $nfcompra_item->nve = $item->nve;
            $nfcompra_item->cest = $item->cest;
            $nfcompra_item->cfop = $item->CFOP;
            $nfcompra_item->ucom = $item->uCom;
            $nfcompra_item->qcom = $item->qCom;
            $nfcompra_item->vuncom = $item->vUnCom;
            $nfcompra_item->vprod = $item->vProd;
            $nfcompra_item->ceantrib = $item->cEANTrib;
            $nfcompra_item->utrib = $item->uTrib;
            $nfcompra_item->qtrib = $item->qTrib;
            $nfcompra_item->vuntrib = $item->vUnTrib;
            $nfcompra_item->vfrete = $item->vFrete;
            $nfcompra_item->vseg = $item->vSeg;
            $nfcompra_item->vdesc = $item->vDesc;
            $nfcompra_item->voutro = $item->vOutro;
            $nfcompra_item->indTot = $item->indTot;
            $nfcompra_item->xped = $item->xPed;
            $nfcompra_item->nitemped = $item->nItemPed;
            // $nfcompra_item->nFCI = $item->nFCI;
        
            $nfitemorigem = NotafiscalItemOrig::where('codigo', '=', $item->orig)->first();
            $nfcompra_item->notafiscal_item_orig_id = $nfitemorigem->id;
        
            $nfcompra_item->icms_cst = $item->cst_icms;
        
            $nfitemmodbc = NotafiscalItemModbc::where('id', '=', $item->modBC)->first();
            $nfcompra_item->notafiscal_item_modbc_id = (isset($nfitemmodbc->id)) ? $nfitemmodbc->id : null;
        
            $nfcompra_item->icms_predbc = $item->pRedBC;
            $nfcompra_item->icms_basecalc = $item->vBC;
            $nfcompra_item->icms_aliquota = $item->pICMS;
            $nfcompra_item->icms_valor = $item->vICMS;
            // $nfcompra_item->vBCSTRet = $item->vBCSTRet;
            $nfcompra_item->icms_pst = $item->pST;
            // $nfcompra_item->vICMSSubstituto = $item->vICMSSubstituto;
            // $nfcompra_item->vICMSSTRet = $item->vICMSSTRet;
            // $nfcompra_item->vBCSTDest = $item->vBCSTDest;
            // $nfcompra_item->vICMSSTDest = $item->vICMSSTDest;
            // $nfcompra_item->modBCST = $item->modBCST;
            // $nfcompra_item->pMVAST = $item->pMVAST;
            $nfcompra_item->icms_vbcst = $item->vBCST;
            $nfcompra_item->icms_picmsst = $item->pICMSST;
            $nfcompra_item->icms_vicmsst = $item->vICMSST;
            $nfcompra_item->icms_pcredsn = $item->pCredSN;
            $nfcompra_item->icms_vcredicmssn = $item->vCredICMSSN;
            $nfcompra_item->icms_predbcst = $item->pRedBCST;
            // $nfcompra_item->vICMSDeson = $item->vICMSDeson;
            // $nfcompra_item->motDesICMS = $item->motDesICMS;
            // $nfcompra_item->vICMSOp = $item->vICMSOp;
            // $nfcompra_item->pDif = $item->pDif;
            // $nfcompra_item->vICMSDif = $item->vICMSDif;
            // $nfcompra_item->vBCFCP = $item->vBCFCP;
            // $nfcompra_item->pFCP = $item->pFCP;
            // $nfcompra_item->vFCP = $item->vFCP;
            // $nfcompra_item->vBCFCPST = $item->vBCFCPST;
            // $nfcompra_item->pFCPST = $item->pFCPST;
            // $nfcompra_item->vFCPST = $item->vFCPST;
            // $nfcompra_item->vBCFCPSTRet = $item->vBCFCPSTRet;
            // $nfcompra_item->pFCPSTRet = $item->pFCPSTRet;
            // $nfcompra_item->vFCPSTRet = $item->vFCPSTRet;
            // $nfcompra_item->pRedBCEfet = $item->pRedBCEfet;
            // $nfcompra_item->vBCEfet = $item->vBCEfet;
            // $nfcompra_item->pICMSEfet = $item->pICMSEfet;
            // $nfcompra_item->vICMSEfet = $item->vICMSEfet;
            // $nfcompra_item->enq_ipi = $item->enq_ipi;
        
            $nfcompra_item->ipi_cst = $item->cst_ipi;
            $nfcompra_item->ipi_valor_base = $item->vBCIPI;
            $nfcompra_item->ipi_aliquota = $item->pIPI;
            $nfcompra_item->ipi_valor = $item->vIPI;
            // $nfcompra_item->vBCII = $item->vBCII;
            // $nfcompra_item->vDespAdu = $item->vDespAdu;
            // $nfcompra_item->vII = $item->vII;
            // $nfcompra_item->vIOF = $item->vIOF;
            $nfcompra_item->pis_cst = $item->cst_pis;
            $nfcompra_item->pis_valor_base = $item->vBCPIS;
            $nfcompra_item->pis_aliquota = $item->pPIS;
            $nfcompra_item->pis_valor = $item->vPIS;
            $nfcompra_item->cofins_cst = $item->cst_cofins;
            $nfcompra_item->cofins_valor_base = $item->vBCCOFINS;
            $nfcompra_item->cofins_aliquota = $item->pCOFINS;
            $nfcompra_item->cofins_valor = $item->vCOFINS;
            // $nfcompra_item->nDI = $item->nDI;
            // $nfcompra_item->dDI = $item->dDI;
            // $nfcompra_item->xLocDesemb = $item->xLocDesemb;
            // $nfcompra_item->UFDesemb = $item->UFDesemb;
            // $nfcompra_item->dDesemb = $item->dDesemb;
            // $nfcompra_item->tpViaTransp = $item->tpViaTransp;
            // $nfcompra_item->vAFRMM = $item->vAFRMM;
            // $nfcompra_item->tpIntermedi = $item->tpIntermedio;
            // $nfcompra_item->cExportado = $item->cExportado;
            // $nfcompra_item->nAdicao = $item->nAdicao;
            // $nfcompra_item->nSeqAdic = $item->nSeqAdic;
            // $nfcompra_item->cFabricante = $item->cFabricante;
            // $nfcompra_item->qBCProd_pis = $item->qBCProd_pis;
            // $nfcompra_item->vAliqProd_pis = $item->vAliqProd_pis;
            // $nfcompra_item->qBCProd_cofins = $item->qBCProd_cofins;
            // $nfcompra_item->vAliqProd_cofins = $item->vAliqProd_cofins;

            $nfcompra_item->nota_fiscal_compra_id = $nfcompra->id;
            $nfcompra_item->store();
            // $lista_itens[] = $nfcompra_item;
        }
    
        // echo 'passou bloco itens - ';
    
        //BLOCO PAG (NÃO PRECISA)...
        //  $nfindpag = NotafiscalIndpag::where('valor', '=', $ide->indPag)->first(); 
        //  $nfcompra->notafiscal_indpag_id = $nfindpag->id;    
    
        //BLOCO PARCELAS
        // $lista_duplicatas = [];
        $config = Configuracoes::where('id', '>', 0)->first();
    
        $parcelas_a_vincular = false;
        foreach ($notacarregada->getParcelas() as $dup) 
        {
               $nf_dup = new NotaFiscalCompraDup();
               $nf_dup->parcela = $dup->parcela;
               $nf_dup->dvenc = $dup->dt_vencimento;
               $nf_dup->vdup =  $dup->vlr_parcela;         
               $nf_dup->ndup = $nfcompra->numero;
           
               if ($config)
               {
                    if ($config->forma_pagamento_id_titulos_cpag_nf != null)   
                    {
                        $nf_dup->forma_pagamento_id = $config->forma_pagamento_id_titulos_cpag_nf;      
                    }
               }

               $nf_dup->nota_fiscal_compra_id = $nfcompra->id;
               $nf_dup->store();
           
               if ($nf_dup->forma_pagamento_id == null)
               {
                   $parcelas_a_vincular = true;
               }
        
        //   $lista_duplicatas[] = $nf_dup;
        }
    
        if ($parcelas_a_vincular)
        {
           $resultado = $resultado.'-Existe(m) parcela(s) para vincular a forma de pagamento do contas a pagar.<br><br>';
           $nfcompra->nota_fiscal_compra_situacao_id = NotaFiscalCompraSituacao::ImportadaFaltandoAjustes;                
        }    

        // echo 'passou bloco parcelas - ';
    

        //BLOCO OBS
        $obs = $notacarregada->getObs(); 
    
        $nfcompra->infAdFisco =  $obs->infAdFisco;
        $nfcompra->infCpl = $obs->infCpl;
    
        // echo 'passou bloco obs - ';
    
        //BLOCO TOTAL
        $total = $notacarregada->getTotal(); 
    
        $nfcompra->fatura_valor_original = $total->fat_vOrig; 
        $nfcompra->fatura_valor_desconto = $total->fat_vDesc; 
        $nfcompra->fatura_valor_liquido  = $total->fat_vLiq;
        $nfcompra->icms_basecalc         = $total->vBC;
        $nfcompra->icms_valor            = $total->vICMS;
        $nfcompra->icms_subst_base_calc  = $total->vBCST;
        $nfcompra->icms_subst_valor      = $total->vST;
        $nfcompra->frete_valor           = $total->vFrete;
        $nfcompra->seguro_valor          = $total->vSeg;
        $nfcompra->outras_despesas       = $total->vOutro; 
        $nfcompra->ipi_valor             = $total->vIPI;
        $nfcompra->valor_total_produtos  = $total->vProd;
        $nfcompra->valor_total_nota      = $total->vNF;
        $nfcompra->desconto_valor        = $total->vDesc;
        $nfcompra->pis_valor             = $total->vPIS;
        $nfcompra->cofins_valor          = $total->vCOFINS;
    
        // echo 'passou bloco total';

        // $resultado = 'Análise da nota fiscal: <br>'.
        //              $resultado;
                     //.'<br>'.
                    //  'Atenção! Ao confirmar a importação, o sistema irá cadastrar automaticamente o(s) produto(s) e Fornecedor, '.
                    //  'caso não tenha encontrado no cadastro. Verifique antes se os cadastros já existem para não gerar duplicidade.'; 
                  
        $nfcompra->obs_importacao_xml = $resultado;
        $nfcompra->store();
    
        self::atualiza_totais_nota($nfcompra->id);
                    
        //salvar o objeto em sessão para salvar na tela...
        // TSession::setValue('notacompra_xml_importacao', $nfcompra);
        // TSession::setValue('nfcompra_itens_xml_importacao', $lista_itens);
        // TSession::setValue('nfcompra_dup_xml_importacao', $lista_duplicatas);

        return $nfcompra;

     }
 
    public static function AtualizaCustoProduto($notacompra)
    {
        foreach ($notacompra->getNotaFiscalCompraItenss() as $item) 
        {
            $produtofilial = ProdutoFilial::where('produto_id', '=', $item->produto_id)
                                            ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                            ->first();

            if($produtofilial)
            {                    
            
                $produtofilial->valor_custo = $item->vuntrib;  
            
                //atualizando o preço de venda --CRIAR CONFIGURAÇÃO FALTA
                $margem = (double) str_replace(',', '.', str_replace('.', '', $produtofilial->margem));
                $valor_custo = $produtofilial->valor_custo;//(double) str_replace(',', '.', str_replace('.', '', $produtofilial->valor_custo));

                $preco_venda = $valor_custo + (( $margem * $valor_custo ) / 100);

                $produtofilial->preco_venda = $preco_venda; //number_format($preco_venda, 2, ',', '.');            
                $produtofilial->store();
            }           
        }
    }
 
    public static function ConfigEvento_NotaEntradaIncluida($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Nota fiscal de entrada incluída no sistema";
       $mensagem = "Id da nota: ".$id." OBS: ".$obs;
       $acao = new TAction(['NotaFiscalCompraFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function SincronizaEventos()
    {
       Eventos::ProcessaEventos('NotaFiscalCompraForm',self::Evento_NotaEntradaIncluida);
    }     

                                                                                    
}

