<?php

class NotaFiscalCompraDup extends TRecord
{
    const TABLENAME  = 'nota_fiscal_compra_dup';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $nota_fiscal_compra;
    private $forma_pagamento;
    private $plano_conta;
    private $centro_custo;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nota_fiscal_compra_id');
        parent::addAttribute('forma_pagamento_id');
        parent::addAttribute('plano_conta_id');
        parent::addAttribute('centro_custo_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('ndup');
        parent::addAttribute('vdup');
        parent::addAttribute('dvenc');
        parent::addAttribute('parcela');
            
    }

    /**
     * Method set_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra = $object;
     * @param $object Instance of NotaFiscalCompra
     */
    public function set_nota_fiscal_compra(NotaFiscalCompra $object)
    {
        $this->nota_fiscal_compra = $object;
        $this->nota_fiscal_compra_id = $object->id;
    }

    /**
     * Method get_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra->attribute;
     * @returns NotaFiscalCompra instance
     */
    public function get_nota_fiscal_compra()
    {
    
        // loads the associated object
        if (empty($this->nota_fiscal_compra))
            $this->nota_fiscal_compra = new NotaFiscalCompra($this->nota_fiscal_compra_id);
    
        // returns the associated object
        return $this->nota_fiscal_compra;
    }
    /**
     * Method set_forma_pagamento
     * Sample of usage: $var->forma_pagamento = $object;
     * @param $object Instance of FormaPagamento
     */
    public function set_forma_pagamento(FormaPagamento $object)
    {
        $this->forma_pagamento = $object;
        $this->forma_pagamento_id = $object->id;
    }

    /**
     * Method get_forma_pagamento
     * Sample of usage: $var->forma_pagamento->attribute;
     * @returns FormaPagamento instance
     */
    public function get_forma_pagamento()
    {
    
        // loads the associated object
        if (empty($this->forma_pagamento))
            $this->forma_pagamento = new FormaPagamento($this->forma_pagamento_id);
    
        // returns the associated object
        return $this->forma_pagamento;
    }
    /**
     * Method set_plano_conta
     * Sample of usage: $var->plano_conta = $object;
     * @param $object Instance of PlanoConta
     */
    public function set_plano_conta(PlanoConta $object)
    {
        $this->plano_conta = $object;
        $this->plano_conta_id = $object->id;
    }

    /**
     * Method get_plano_conta
     * Sample of usage: $var->plano_conta->attribute;
     * @returns PlanoConta instance
     */
    public function get_plano_conta()
    {
    
        // loads the associated object
        if (empty($this->plano_conta))
            $this->plano_conta = new PlanoConta($this->plano_conta_id);
    
        // returns the associated object
        return $this->plano_conta;
    }
    /**
     * Method set_centro_custo
     * Sample of usage: $var->centro_custo = $object;
     * @param $object Instance of CentroCusto
     */
    public function set_centro_custo(CentroCusto $object)
    {
        $this->centro_custo = $object;
        $this->centro_custo_id = $object->id;
    }

    /**
     * Method get_centro_custo
     * Sample of usage: $var->centro_custo->attribute;
     * @returns CentroCusto instance
     */
    public function get_centro_custo()
    {
    
        // loads the associated object
        if (empty($this->centro_custo))
            $this->centro_custo = new CentroCusto($this->centro_custo_id);
    
        // returns the associated object
        return $this->centro_custo;
    }

    
}

