<?php

class NotaFiscalCompraItens extends TRecord
{
    const TABLENAME  = 'nota_fiscal_compra_itens';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $nota_fiscal_compra_itens_situacao;
    private $nota_fiscal_compra;
    private $produto;
    private $notafiscal_item_indtot;
    private $notafiscal_item_orig;
    private $notafiscal_item_modbc;
    private $notafiscal_item_motDesICMS;
    private $estoque_deposito;
    private $produto_lote;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nota_fiscal_compra_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('nota_fiscal_compra_itens_situacao_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('nitem');
        parent::addAttribute('cean');
        parent::addAttribute('xprod');
        parent::addAttribute('ncm');
        parent::addAttribute('nve');
        parent::addAttribute('extipi');
        parent::addAttribute('cfop');
        parent::addAttribute('ucom');
        parent::addAttribute('qcom');
        parent::addAttribute('vuncom');
        parent::addAttribute('vprod');
        parent::addAttribute('ceantrib');
        parent::addAttribute('utrib');
        parent::addAttribute('qtrib');
        parent::addAttribute('vuntrib');
        parent::addAttribute('vfrete');
        parent::addAttribute('vseg');
        parent::addAttribute('vdesc');
        parent::addAttribute('vtottrib');
        parent::addAttribute('xped');
        parent::addAttribute('nitemped');
        parent::addAttribute('notafiscal_item_indtot_id');
        parent::addAttribute('notafiscal_item_orig_id');
        parent::addAttribute('notafiscal_item_modbc_id');
        parent::addAttribute('icms_basecalc');
        parent::addAttribute('icms_cst');
        parent::addAttribute('icms_valor');
        parent::addAttribute('icms_aliquota');
        parent::addAttribute('icms_pcredsn');
        parent::addAttribute('icms_vcredicmssn');
        parent::addAttribute('icms_predbc');
        parent::addAttribute('icms_pst');
        parent::addAttribute('icms_pmvast');
        parent::addAttribute('icms_predbcst');
        parent::addAttribute('icms_vbcst');
        parent::addAttribute('icms_picmsst');
        parent::addAttribute('icms_vicmsst');
        parent::addAttribute('fcp_pfcp');
        parent::addAttribute('pis_cst');
        parent::addAttribute('pis_valor');
        parent::addAttribute('pis_aliquota');
        parent::addAttribute('pis_valor_base');
        parent::addAttribute('cofins_cst');
        parent::addAttribute('cofins_valor_base');
        parent::addAttribute('cofins_aliquota');
        parent::addAttribute('cofins_valor');
        parent::addAttribute('voutro');
        parent::addAttribute('infadprod');
        parent::addAttribute('notafiscal_item_motDesICMS_id');
        parent::addAttribute('cprod');
        parent::addAttribute('ipi_cst');
        parent::addAttribute('ipi_valor_base');
        parent::addAttribute('ipi_aliquota');
        parent::addAttribute('ipi_vipidevol');
        parent::addAttribute('ipi_valor');
        parent::addAttribute('ipi_pdevol');
        parent::addAttribute('estoque_deposito_id');
        parent::addAttribute('produto_lote_id');
    
    }

    /**
     * Method set_nota_fiscal_compra_itens_situacao
     * Sample of usage: $var->nota_fiscal_compra_itens_situacao = $object;
     * @param $object Instance of NotaFiscalCompraItensSituacao
     */
    public function set_nota_fiscal_compra_itens_situacao(NotaFiscalCompraItensSituacao $object)
    {
        $this->nota_fiscal_compra_itens_situacao = $object;
        $this->nota_fiscal_compra_itens_situacao_id = $object->id;
    }

    /**
     * Method get_nota_fiscal_compra_itens_situacao
     * Sample of usage: $var->nota_fiscal_compra_itens_situacao->attribute;
     * @returns NotaFiscalCompraItensSituacao instance
     */
    public function get_nota_fiscal_compra_itens_situacao()
    {
    
        // loads the associated object
        if (empty($this->nota_fiscal_compra_itens_situacao))
            $this->nota_fiscal_compra_itens_situacao = new NotaFiscalCompraItensSituacao($this->nota_fiscal_compra_itens_situacao_id);
    
        // returns the associated object
        return $this->nota_fiscal_compra_itens_situacao;
    }
    /**
     * Method set_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra = $object;
     * @param $object Instance of NotaFiscalCompra
     */
    public function set_nota_fiscal_compra(NotaFiscalCompra $object)
    {
        $this->nota_fiscal_compra = $object;
        $this->nota_fiscal_compra_id = $object->id;
    }

    /**
     * Method get_nota_fiscal_compra
     * Sample of usage: $var->nota_fiscal_compra->attribute;
     * @returns NotaFiscalCompra instance
     */
    public function get_nota_fiscal_compra()
    {
    
        // loads the associated object
        if (empty($this->nota_fiscal_compra))
            $this->nota_fiscal_compra = new NotaFiscalCompra($this->nota_fiscal_compra_id);
    
        // returns the associated object
        return $this->nota_fiscal_compra;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_notafiscal_item_indtot
     * Sample of usage: $var->notafiscal_item_indtot = $object;
     * @param $object Instance of NotafiscalItemIndtot
     */
    public function set_notafiscal_item_indtot(NotafiscalItemIndtot $object)
    {
        $this->notafiscal_item_indtot = $object;
        $this->notafiscal_item_indtot_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_indtot
     * Sample of usage: $var->notafiscal_item_indtot->attribute;
     * @returns NotafiscalItemIndtot instance
     */
    public function get_notafiscal_item_indtot()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_indtot))
            $this->notafiscal_item_indtot = new NotafiscalItemIndtot($this->notafiscal_item_indtot_id);
    
        // returns the associated object
        return $this->notafiscal_item_indtot;
    }
    /**
     * Method set_notafiscal_item_orig
     * Sample of usage: $var->notafiscal_item_orig = $object;
     * @param $object Instance of NotafiscalItemOrig
     */
    public function set_notafiscal_item_orig(NotafiscalItemOrig $object)
    {
        $this->notafiscal_item_orig = $object;
        $this->notafiscal_item_orig_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_orig
     * Sample of usage: $var->notafiscal_item_orig->attribute;
     * @returns NotafiscalItemOrig instance
     */
    public function get_notafiscal_item_orig()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_orig))
            $this->notafiscal_item_orig = new NotafiscalItemOrig($this->notafiscal_item_orig_id);
    
        // returns the associated object
        return $this->notafiscal_item_orig;
    }
    /**
     * Method set_notafiscal_item_modbc
     * Sample of usage: $var->notafiscal_item_modbc = $object;
     * @param $object Instance of NotafiscalItemModbc
     */
    public function set_notafiscal_item_modbc(NotafiscalItemModbc $object)
    {
        $this->notafiscal_item_modbc = $object;
        $this->notafiscal_item_modbc_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_modbc
     * Sample of usage: $var->notafiscal_item_modbc->attribute;
     * @returns NotafiscalItemModbc instance
     */
    public function get_notafiscal_item_modbc()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_modbc))
            $this->notafiscal_item_modbc = new NotafiscalItemModbc($this->notafiscal_item_modbc_id);
    
        // returns the associated object
        return $this->notafiscal_item_modbc;
    }
    /**
     * Method set_notafiscal_item_motDesICMS
     * Sample of usage: $var->notafiscal_item_motDesICMS = $object;
     * @param $object Instance of NotafiscalItemMotdesicms
     */
    public function set_notafiscal_item_motDesICMS(NotafiscalItemMotdesicms $object)
    {
        $this->notafiscal_item_motDesICMS = $object;
        $this->notafiscal_item_motDesICMS_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_motDesICMS
     * Sample of usage: $var->notafiscal_item_motDesICMS->attribute;
     * @returns NotafiscalItemMotdesicms instance
     */
    public function get_notafiscal_item_motDesICMS()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_motDesICMS))
            $this->notafiscal_item_motDesICMS = new NotafiscalItemMotdesicms($this->notafiscal_item_motDesICMS_id);
    
        // returns the associated object
        return $this->notafiscal_item_motDesICMS;
    }
    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito(EstoqueDeposito $object)
    {
        $this->estoque_deposito = $object;
        $this->estoque_deposito_id = $object->id;
    }

    /**
     * Method get_estoque_deposito
     * Sample of usage: $var->estoque_deposito->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito))
            $this->estoque_deposito = new EstoqueDeposito($this->estoque_deposito_id);
    
        // returns the associated object
        return $this->estoque_deposito;
    }
    /**
     * Method set_produto_lote
     * Sample of usage: $var->produto_lote = $object;
     * @param $object Instance of ProdutoLote
     */
    public function set_produto_lote(ProdutoLote $object)
    {
        $this->produto_lote = $object;
        $this->produto_lote_id = $object->id;
    }

    /**
     * Method get_produto_lote
     * Sample of usage: $var->produto_lote->attribute;
     * @returns ProdutoLote instance
     */
    public function get_produto_lote()
    {
    
        // loads the associated object
        if (empty($this->produto_lote))
            $this->produto_lote = new ProdutoLote($this->produto_lote_id);
    
        // returns the associated object
        return $this->produto_lote;
    }

 public function get_produto_xml()
 {
     if ($this->produto_id ==null)
     {
         return $this->xprod.' (Não vinculado)';
     }
     else
     {
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);     
        
         return $this->produto->nome;
     }
 }

}

