<?php

class NotaFiscalCompraSituacao extends TRecord
{
    const TABLENAME  = 'nota_fiscal_compra_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const EmDigitacao = '1';
    const ImportadaFaltandoAjustes = '2';
    const Finalizada = '3';
    const Cancelada = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('cor');
            
    }

    /**
     * Method getNotaFiscalCompras
     */
    public function getNotaFiscalCompras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('nota_fiscal_compra_situacao_id', '=', $this->id));
        return NotaFiscalCompra::getObjects( $criteria );
    }

    public function set_nota_fiscal_compra_system_unit_to_string($nota_fiscal_compra_system_unit_to_string)
    {
        if(is_array($nota_fiscal_compra_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $nota_fiscal_compra_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->nota_fiscal_compra_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_system_unit_to_string = $nota_fiscal_compra_system_unit_to_string;
        }

        $this->vdata['nota_fiscal_compra_system_unit_to_string'] = $this->nota_fiscal_compra_system_unit_to_string;
    }

    public function get_nota_fiscal_compra_system_unit_to_string()
    {
        if(!empty($this->nota_fiscal_compra_system_unit_to_string))
        {
            return $this->nota_fiscal_compra_system_unit_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_fornecedor_to_string($nota_fiscal_compra_fornecedor_to_string)
    {
        if(is_array($nota_fiscal_compra_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $nota_fiscal_compra_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_fornecedor_to_string = $nota_fiscal_compra_fornecedor_to_string;
        }

        $this->vdata['nota_fiscal_compra_fornecedor_to_string'] = $this->nota_fiscal_compra_fornecedor_to_string;
    }

    public function get_nota_fiscal_compra_fornecedor_to_string()
    {
        if(!empty($this->nota_fiscal_compra_fornecedor_to_string))
        {
            return $this->nota_fiscal_compra_fornecedor_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tipodocumento_to_string($nota_fiscal_compra_notafiscal_tipodocumento_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $nota_fiscal_compra_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = $nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tipodocumento_to_string'] = $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            $values = NotaFiscalCompraSituacao::where('id', 'in', $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_nota_fiscal_compra_situacao_to_string'] = $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
    }

    public function get_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            return $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_situacao_id','{nota_fiscal_compra_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_crt_to_string($nota_fiscal_compra_notafiscal_crt_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $nota_fiscal_compra_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_crt_to_string = $nota_fiscal_compra_notafiscal_crt_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_crt_to_string'] = $this->nota_fiscal_compra_notafiscal_crt_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_crt_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_crt_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_crt_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indiedest_to_string($nota_fiscal_compra_notafiscal_indiedest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $nota_fiscal_compra_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = $nota_fiscal_compra_notafiscal_indiedest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indiedest_to_string'] = $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indiedest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscaldest_to_string($nota_fiscal_compra_notafiscaldest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $nota_fiscal_compra_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscaldest_to_string = $nota_fiscal_compra_notafiscaldest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscaldest_to_string'] = $this->nota_fiscal_compra_notafiscaldest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscaldest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscaldest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscaldest_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tpimp_to_string($nota_fiscal_compra_notafiscal_tpimp_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $nota_fiscal_compra_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = $nota_fiscal_compra_notafiscal_tpimp_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tpimp_to_string'] = $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tpimp_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_finnfe_to_string($nota_fiscal_compra_notafiscal_finnfe_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $nota_fiscal_compra_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = $nota_fiscal_compra_notafiscal_finnfe_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_finnfe_to_string'] = $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_finnfe_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indfinal_to_string($nota_fiscal_compra_notafiscal_indfinal_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $nota_fiscal_compra_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = $nota_fiscal_compra_notafiscal_indfinal_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indfinal_to_string'] = $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indfinal_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpres_to_string($nota_fiscal_compra_notafiscal_indpres_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $nota_fiscal_compra_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = $nota_fiscal_compra_notafiscal_indpres_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpres_to_string'] = $this->nota_fiscal_compra_notafiscal_indpres_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpres_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpres_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpag_to_string($nota_fiscal_compra_notafiscal_indpag_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $nota_fiscal_compra_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = $nota_fiscal_compra_notafiscal_indpag_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpag_to_string'] = $this->nota_fiscal_compra_notafiscal_indpag_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpag_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpag_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_mod_to_string($nota_fiscal_compra_notafiscal_mod_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $nota_fiscal_compra_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_mod_to_string = $nota_fiscal_compra_notafiscal_mod_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_mod_to_string'] = $this->nota_fiscal_compra_notafiscal_mod_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_mod_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_mod_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_mod_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_modfrete_to_string($nota_fiscal_compra_notafiscal_modfrete_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $nota_fiscal_compra_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = $nota_fiscal_compra_notafiscal_modfrete_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_modfrete_to_string'] = $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_modfrete_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
        }
    
        $values = NotaFiscalCompra::where('nota_fiscal_compra_situacao_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    
}

