<?php

class Notafiscal extends TRecord
{
    const TABLENAME  = 'notafiscal';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_unit;
    private $notafiscal_tpamb;
    private $notafiscal_modfrete;
    private $notafiscal_mod;
    private $venda;
    private $cliente;
    private $nf_tipodocumento;
    private $notafiscal_situacao;
    private $notafiscal_indiedest;
    private $notafiscaldest;
    private $notafiscal_tpimp;
    private $notafiscal_tpemis;
    private $notafiscal_finnfe;
    private $notafiscal_indfinal;
    private $notafiscal_indpres;
    private $notafiscal_indpag;
    private $dispositivos;
    private $notafiscal_crt;
    private $movimentacao_origem;
    private $natureza_operacao;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('cliente_id');
        parent::addAttribute('venda_id');
        parent::addAttribute('numero');
        parent::addAttribute('data_emissao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('texto_rodape');
        parent::addAttribute('data_saida');
        parent::addAttribute('icms_basecalc');
        parent::addAttribute('icms_valor');
        parent::addAttribute('icms_subst_base_calc');
        parent::addAttribute('icms_subst_valor');
        parent::addAttribute('frete_valor');
        parent::addAttribute('seguro_valor');
        parent::addAttribute('outras_despesas');
        parent::addAttribute('ipi_valor');
        parent::addAttribute('serie');
        parent::addAttribute('valor_total_produtos');
        parent::addAttribute('valor_total_nota');
        parent::addAttribute('transp_nome');
        parent::addAttribute('transp_cnpj');
        parent::addAttribute('transp_inscest');
        parent::addAttribute('transp_endereco');
        parent::addAttribute('transp_cidade');
        parent::addAttribute('transp_placaveiculo');
        parent::addAttribute('transp_uf');
        parent::addAttribute('transp_veiculouf');
        parent::addAttribute('transp_veiculoRNTC');
        parent::addAttribute('transp_numeracao');
        parent::addAttribute('nf_tipodocumento_id');
        parent::addAttribute('notafiscal_situacao_id');
        parent::addAttribute('notafiscal_crt_id');
        parent::addAttribute('cliente_endereco');
        parent::addAttribute('cliente_complemento');
        parent::addAttribute('cliente_numero');
        parent::addAttribute('cliente_bairro');
        parent::addAttribute('cliente_cidade');
        parent::addAttribute('cliente_cep');
        parent::addAttribute('cliente_estado');
        parent::addAttribute('cliente_nome');
        parent::addAttribute('cliente_cpfcnpj');
        parent::addAttribute('cliente_inscest');
        parent::addAttribute('cliente_inscmuni');
        parent::addAttribute('cliente_fone');
        parent::addAttribute('cliente_cidade_codibge');
        parent::addAttribute('cliente_suframa');
        parent::addAttribute('justificativa_cancelamento');
        parent::addAttribute('chave');
        parent::addAttribute('protocolo_envio');
        parent::addAttribute('notafiscal_indiedest_id');
        parent::addAttribute('protocolo_cancelamento');
        parent::addAttribute('datahora_cancelamento');
        parent::addAttribute('cce_datahora_evento');
        parent::addAttribute('cce_sequencial');
        parent::addAttribute('cce_correcao');
        parent::addAttribute('cce_protocolo');
        parent::addAttribute('infadfisco');
        parent::addAttribute('desconto_valor');
        parent::addAttribute('pis_valor');
        parent::addAttribute('cofins_valor');
        parent::addAttribute('fatura_numero');
        parent::addAttribute('fatura_valor_original');
        parent::addAttribute('fatura_valor_desconto');
        parent::addAttribute('fatura_valor_liquido');
        parent::addAttribute('notafiscal_iddest_id');
        parent::addAttribute('notafiscal_tpimp_id');
        parent::addAttribute('notafiscal_tpemis_id');
        parent::addAttribute('notafiscal_finnfe_id');
        parent::addAttribute('notafiscal_indfinal_id');
        parent::addAttribute('notafiscal_indpres_id');
        parent::addAttribute('verproc');
        parent::addAttribute('notafiscal_indpag_id');
        parent::addAttribute('retirada_marcado');
        parent::addAttribute('retirada_cpfcnpj');
        parent::addAttribute('retirada_xlgr');
        parent::addAttribute('retirada_nro');
        parent::addAttribute('retirada_xcpl');
        parent::addAttribute('retirada_xbairro');
        parent::addAttribute('retirada_cmun');
        parent::addAttribute('retirada_xmun');
        parent::addAttribute('retirada_uf');
        parent::addAttribute('entrega_marcado');
        parent::addAttribute('entrega_cpfcnpj');
        parent::addAttribute('entrega_xlgr');
        parent::addAttribute('entrega_nro');
        parent::addAttribute('entrega_xcpl');
        parent::addAttribute('entrega_xbairro');
        parent::addAttribute('entrega_cmun');
        parent::addAttribute('entrega_xmun');
        parent::addAttribute('entrega_uf');
        parent::addAttribute('vicmsufdest');
        parent::addAttribute('vicmsufremet');
        parent::addAttribute('vfcpufdest');
        parent::addAttribute('notafiscal_modelo_id');
        parent::addAttribute('dispositivos_id');
        parent::addAttribute('xml');
        parent::addAttribute('data_hora_envio');
        parent::addAttribute('xml_cancelamento');
        parent::addAttribute('issqn_vserv');
        parent::addAttribute('issqn_vbc');
        parent::addAttribute('issqn_viss');
        parent::addAttribute('issqn_dcompet');
        parent::addAttribute('issqn_reftrib');
        parent::addAttribute('icms_vfcp');
        parent::addAttribute('icms_vfcpst');
        parent::addAttribute('icms_vfcpstret');
        parent::addAttribute('layout_versao');
        parent::addAttribute('ipi_vipidevol');
        parent::addAttribute('vtroco');
        parent::addAttribute('notafiscal_tpamb_id');
        parent::addAttribute('notafiscal_mod_id');
        parent::addAttribute('infcpl');
        parent::addAttribute('notafiscal_modfrete_id');
        parent::addAttribute('status');
        parent::addAttribute('mensagem');
        parent::addAttribute('cce_xml');
        parent::addAttribute('cce_pdf');
        parent::addAttribute('codigo_sefaz');
        parent::addAttribute('sn_carta_correcao');
        parent::addAttribute('deletado_em');
        parent::addAttribute('contingencia_data');
        parent::addAttribute('contingencia_motivo');
        parent::addAttribute('exporta_ufsaidapais');
        parent::addAttribute('exporta_xlocexporta');
        parent::addAttribute('exporta_xlocdespacho');
        parent::addAttribute('cliente_cpais');
        parent::addAttribute('cliente_xpais');
        parent::addAttribute('natureza_operacao_id');
        parent::addAttribute('movimentacao_origem_id');
        parent::addAttribute('inutilizar');
        parent::addAttribute('xml_inicial');
        parent::addAttribute('entrega_cuf');
        parent::addAttribute('xml_assinado');
        parent::addAttribute('protolo_xml');
        parent::addAttribute('xml_autorizado');
        parent::addAttribute('cep_entrega');
        parent::addAttribute('cep_retirada');
        parent::addAttribute('entrega_xnome');
        parent::addAttribute('xml_carta');
        parent::addAttribute('protocolo_carta_resposta');
        parent::addAttribute('descricao');
        parent::addAttribute('xevento');
        parent::addAttribute('xmotivo');
        parent::addAttribute('cstat');
        parent::addAttribute('dhregevento');
        parent::addAttribute('nseqevento');
        parent::addAttribute('nprot');
    
    }

    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_notafiscal_tpamb
     * Sample of usage: $var->notafiscal_tpamb = $object;
     * @param $object Instance of NotafiscalTpamb
     */
    public function set_notafiscal_tpamb(NotafiscalTpamb $object)
    {
        $this->notafiscal_tpamb = $object;
        $this->notafiscal_tpamb_id = $object->id;
    }

    /**
     * Method get_notafiscal_tpamb
     * Sample of usage: $var->notafiscal_tpamb->attribute;
     * @returns NotafiscalTpamb instance
     */
    public function get_notafiscal_tpamb()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tpamb))
            $this->notafiscal_tpamb = new NotafiscalTpamb($this->notafiscal_tpamb_id);
    
        // returns the associated object
        return $this->notafiscal_tpamb;
    }
    /**
     * Method set_notafiscal_modfrete
     * Sample of usage: $var->notafiscal_modfrete = $object;
     * @param $object Instance of NotafiscalModfrete
     */
    public function set_notafiscal_modfrete(NotafiscalModfrete $object)
    {
        $this->notafiscal_modfrete = $object;
        $this->notafiscal_modfrete_id = $object->id;
    }

    /**
     * Method get_notafiscal_modfrete
     * Sample of usage: $var->notafiscal_modfrete->attribute;
     * @returns NotafiscalModfrete instance
     */
    public function get_notafiscal_modfrete()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_modfrete))
            $this->notafiscal_modfrete = new NotafiscalModfrete($this->notafiscal_modfrete_id);
    
        // returns the associated object
        return $this->notafiscal_modfrete;
    }
    /**
     * Method set_notafiscal_mod
     * Sample of usage: $var->notafiscal_mod = $object;
     * @param $object Instance of NotafiscalMod
     */
    public function set_notafiscal_mod(NotafiscalMod $object)
    {
        $this->notafiscal_mod = $object;
        $this->notafiscal_mod_id = $object->id;
    }

    /**
     * Method get_notafiscal_mod
     * Sample of usage: $var->notafiscal_mod->attribute;
     * @returns NotafiscalMod instance
     */
    public function get_notafiscal_mod()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_mod))
            $this->notafiscal_mod = new NotafiscalMod($this->notafiscal_mod_id);
    
        // returns the associated object
        return $this->notafiscal_mod;
    }
    /**
     * Method set_venda
     * Sample of usage: $var->venda = $object;
     * @param $object Instance of Venda
     */
    public function set_venda(Venda $object)
    {
        $this->venda = $object;
        $this->venda_id = $object->id;
    }

    /**
     * Method get_venda
     * Sample of usage: $var->venda->attribute;
     * @returns Venda instance
     */
    public function get_venda()
    {
    
        // loads the associated object
        if (empty($this->venda))
            $this->venda = new Venda($this->venda_id);
    
        // returns the associated object
        return $this->venda;
    }
    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_notafiscal_tipodocumento
     * Sample of usage: $var->notafiscal_tipodocumento = $object;
     * @param $object Instance of NotafiscalTipodocumento
     */
    public function set_nf_tipodocumento(NotafiscalTipodocumento $object)
    {
        $this->nf_tipodocumento = $object;
        $this->nf_tipodocumento_id = $object->id;
    }

    /**
     * Method get_nf_tipodocumento
     * Sample of usage: $var->nf_tipodocumento->attribute;
     * @returns NotafiscalTipodocumento instance
     */
    public function get_nf_tipodocumento()
    {
    
        // loads the associated object
        if (empty($this->nf_tipodocumento))
            $this->nf_tipodocumento = new NotafiscalTipodocumento($this->nf_tipodocumento_id);
    
        // returns the associated object
        return $this->nf_tipodocumento;
    }
    /**
     * Method set_notafiscal_situacao
     * Sample of usage: $var->notafiscal_situacao = $object;
     * @param $object Instance of NotafiscalSituacao
     */
    public function set_notafiscal_situacao(NotafiscalSituacao $object)
    {
        $this->notafiscal_situacao = $object;
        $this->notafiscal_situacao_id = $object->id;
    }

    /**
     * Method get_notafiscal_situacao
     * Sample of usage: $var->notafiscal_situacao->attribute;
     * @returns NotafiscalSituacao instance
     */
    public function get_notafiscal_situacao()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_situacao))
            $this->notafiscal_situacao = new NotafiscalSituacao($this->notafiscal_situacao_id);
    
        // returns the associated object
        return $this->notafiscal_situacao;
    }
    /**
     * Method set_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest = $object;
     * @param $object Instance of NotafiscalIndiedest
     */
    public function set_notafiscal_indiedest(NotafiscalIndiedest $object)
    {
        $this->notafiscal_indiedest = $object;
        $this->notafiscal_indiedest_id = $object->id;
    }

    /**
     * Method get_notafiscal_indiedest
     * Sample of usage: $var->notafiscal_indiedest->attribute;
     * @returns NotafiscalIndiedest instance
     */
    public function get_notafiscal_indiedest()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indiedest))
            $this->notafiscal_indiedest = new NotafiscalIndiedest($this->notafiscal_indiedest_id);
    
        // returns the associated object
        return $this->notafiscal_indiedest;
    }
    /**
     * Method set_notafiscal_iddest
     * Sample of usage: $var->notafiscal_iddest = $object;
     * @param $object Instance of NotafiscalIddest
     */
    public function set_notafiscaldest(NotafiscalIddest $object)
    {
        $this->notafiscaldest = $object;
        $this->notafiscal_iddest_id = $object->id;
    }

    /**
     * Method get_notafiscaldest
     * Sample of usage: $var->notafiscaldest->attribute;
     * @returns NotafiscalIddest instance
     */
    public function get_notafiscaldest()
    {
    
        // loads the associated object
        if (empty($this->notafiscaldest))
            $this->notafiscaldest = new NotafiscalIddest($this->notafiscal_iddest_id);
    
        // returns the associated object
        return $this->notafiscaldest;
    }
    /**
     * Method set_notafiscal_tpimp
     * Sample of usage: $var->notafiscal_tpimp = $object;
     * @param $object Instance of NotafiscalTpimp
     */
    public function set_notafiscal_tpimp(NotafiscalTpimp $object)
    {
        $this->notafiscal_tpimp = $object;
        $this->notafiscal_tpimp_id = $object->id;
    }

    /**
     * Method get_notafiscal_tpimp
     * Sample of usage: $var->notafiscal_tpimp->attribute;
     * @returns NotafiscalTpimp instance
     */
    public function get_notafiscal_tpimp()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tpimp))
            $this->notafiscal_tpimp = new NotafiscalTpimp($this->notafiscal_tpimp_id);
    
        // returns the associated object
        return $this->notafiscal_tpimp;
    }
    /**
     * Method set_notafiscal_tpemis
     * Sample of usage: $var->notafiscal_tpemis = $object;
     * @param $object Instance of NotafiscalTpemis
     */
    public function set_notafiscal_tpemis(NotafiscalTpemis $object)
    {
        $this->notafiscal_tpemis = $object;
        $this->notafiscal_tpemis_id = $object->id;
    }

    /**
     * Method get_notafiscal_tpemis
     * Sample of usage: $var->notafiscal_tpemis->attribute;
     * @returns NotafiscalTpemis instance
     */
    public function get_notafiscal_tpemis()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tpemis))
            $this->notafiscal_tpemis = new NotafiscalTpemis($this->notafiscal_tpemis_id);
    
        // returns the associated object
        return $this->notafiscal_tpemis;
    }
    /**
     * Method set_notafiscal_finnfe
     * Sample of usage: $var->notafiscal_finnfe = $object;
     * @param $object Instance of NotafiscalFinnfe
     */
    public function set_notafiscal_finnfe(NotafiscalFinnfe $object)
    {
        $this->notafiscal_finnfe = $object;
        $this->notafiscal_finnfe_id = $object->id;
    }

    /**
     * Method get_notafiscal_finnfe
     * Sample of usage: $var->notafiscal_finnfe->attribute;
     * @returns NotafiscalFinnfe instance
     */
    public function get_notafiscal_finnfe()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_finnfe))
            $this->notafiscal_finnfe = new NotafiscalFinnfe($this->notafiscal_finnfe_id);
    
        // returns the associated object
        return $this->notafiscal_finnfe;
    }
    /**
     * Method set_notafiscal_indfinal
     * Sample of usage: $var->notafiscal_indfinal = $object;
     * @param $object Instance of NotafiscalIndfinal
     */
    public function set_notafiscal_indfinal(NotafiscalIndfinal $object)
    {
        $this->notafiscal_indfinal = $object;
        $this->notafiscal_indfinal_id = $object->id;
    }

    /**
     * Method get_notafiscal_indfinal
     * Sample of usage: $var->notafiscal_indfinal->attribute;
     * @returns NotafiscalIndfinal instance
     */
    public function get_notafiscal_indfinal()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indfinal))
            $this->notafiscal_indfinal = new NotafiscalIndfinal($this->notafiscal_indfinal_id);
    
        // returns the associated object
        return $this->notafiscal_indfinal;
    }
    /**
     * Method set_notafiscal_indpres
     * Sample of usage: $var->notafiscal_indpres = $object;
     * @param $object Instance of NotafiscalIndpres
     */
    public function set_notafiscal_indpres(NotafiscalIndpres $object)
    {
        $this->notafiscal_indpres = $object;
        $this->notafiscal_indpres_id = $object->id;
    }

    /**
     * Method get_notafiscal_indpres
     * Sample of usage: $var->notafiscal_indpres->attribute;
     * @returns NotafiscalIndpres instance
     */
    public function get_notafiscal_indpres()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indpres))
            $this->notafiscal_indpres = new NotafiscalIndpres($this->notafiscal_indpres_id);
    
        // returns the associated object
        return $this->notafiscal_indpres;
    }
    /**
     * Method set_notafiscal_indpag
     * Sample of usage: $var->notafiscal_indpag = $object;
     * @param $object Instance of NotafiscalIndpag
     */
    public function set_notafiscal_indpag(NotafiscalIndpag $object)
    {
        $this->notafiscal_indpag = $object;
        $this->notafiscal_indpag_id = $object->id;
    }

    /**
     * Method get_notafiscal_indpag
     * Sample of usage: $var->notafiscal_indpag->attribute;
     * @returns NotafiscalIndpag instance
     */
    public function get_notafiscal_indpag()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_indpag))
            $this->notafiscal_indpag = new NotafiscalIndpag($this->notafiscal_indpag_id);
    
        // returns the associated object
        return $this->notafiscal_indpag;
    }
    /**
     * Method set_dispositivos
     * Sample of usage: $var->dispositivos = $object;
     * @param $object Instance of Dispositivos
     */
    public function set_dispositivos(Dispositivos $object)
    {
        $this->dispositivos = $object;
        $this->dispositivos_id = $object->id;
    }

    /**
     * Method get_dispositivos
     * Sample of usage: $var->dispositivos->attribute;
     * @returns Dispositivos instance
     */
    public function get_dispositivos()
    {
    
        // loads the associated object
        if (empty($this->dispositivos))
            $this->dispositivos = new Dispositivos($this->dispositivos_id);
    
        // returns the associated object
        return $this->dispositivos;
    }
    /**
     * Method set_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt = $object;
     * @param $object Instance of NotafiscalCrt
     */
    public function set_notafiscal_crt(NotafiscalCrt $object)
    {
        $this->notafiscal_crt = $object;
        $this->notafiscal_crt_id = $object->id;
    }

    /**
     * Method get_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt->attribute;
     * @returns NotafiscalCrt instance
     */
    public function get_notafiscal_crt()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_crt))
            $this->notafiscal_crt = new NotafiscalCrt($this->notafiscal_crt_id);
    
        // returns the associated object
        return $this->notafiscal_crt;
    }
    /**
     * Method set_movimentacao_origem
     * Sample of usage: $var->movimentacao_origem = $object;
     * @param $object Instance of MovimentacaoOrigem
     */
    public function set_movimentacao_origem(MovimentacaoOrigem $object)
    {
        $this->movimentacao_origem = $object;
        $this->movimentacao_origem_id = $object->id;
    }

    /**
     * Method get_movimentacao_origem
     * Sample of usage: $var->movimentacao_origem->attribute;
     * @returns MovimentacaoOrigem instance
     */
    public function get_movimentacao_origem()
    {
    
        // loads the associated object
        if (empty($this->movimentacao_origem))
            $this->movimentacao_origem = new MovimentacaoOrigem($this->movimentacao_origem_id);
    
        // returns the associated object
        return $this->movimentacao_origem;
    }
    /**
     * Method set_natureza_operacao
     * Sample of usage: $var->natureza_operacao = $object;
     * @param $object Instance of NaturezaOperacao
     */
    public function set_natureza_operacao(NaturezaOperacao $object)
    {
        $this->natureza_operacao = $object;
        $this->natureza_operacao_id = $object->id;
    }

    /**
     * Method get_natureza_operacao
     * Sample of usage: $var->natureza_operacao->attribute;
     * @returns NaturezaOperacao instance
     */
    public function get_natureza_operacao()
    {
    
        // loads the associated object
        if (empty($this->natureza_operacao))
            $this->natureza_operacao = new NaturezaOperacao($this->natureza_operacao_id);
    
        // returns the associated object
        return $this->natureza_operacao;
    }

    /**
     * Method getMdfeInclusaoDfes
     */
    public function getMdfeInclusaoDfes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return MdfeInclusaoDfe::getObjects( $criteria );
    }
    /**
     * Method getMdfeNfess
     */
    public function getMdfeNfess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return MdfeNfes::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalAutxmls
     */
    public function getNotafiscalAutxmls()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalAutxml::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalDups
     */
    public function getNotafiscalDups()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalDup::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalFreteVolumess
     */
    public function getNotafiscalFreteVolumess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalFreteVolumes::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalItenss
     */
    public function getNotafiscalItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalItens::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalLogss
     */
    public function getNotafiscalLogss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalLogs::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalPags
     */
    public function getNotafiscalPags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalPag::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalRefecfs
     */
    public function getNotafiscalRefecfs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalRefecf::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalRefnfes
     */
    public function getNotafiscalRefnfes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return NotafiscalRefnfe::getObjects( $criteria );
    }
    /**
     * Method getPedidoEventos
     */
    public function getPedidoEventos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_id', '=', $this->id));
        return PedidoEvento::getObjects( $criteria );
    }

    public function set_mdfe_inclusao_dfe_mdfe_to_string($mdfe_inclusao_dfe_mdfe_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_mdfe_to_string))
        {
            $values = Mdfe::where('id', 'in', $mdfe_inclusao_dfe_mdfe_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_inclusao_dfe_mdfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_mdfe_to_string = $mdfe_inclusao_dfe_mdfe_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_mdfe_to_string'] = $this->mdfe_inclusao_dfe_mdfe_to_string;
    }

    public function get_mdfe_inclusao_dfe_mdfe_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_mdfe_to_string))
        {
            return $this->mdfe_inclusao_dfe_mdfe_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('notafiscal_id', '=', $this->id)->getIndexedArray('mdfe_id','{mdfe->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_inclusao_dfe_notafiscal_to_string($mdfe_inclusao_dfe_notafiscal_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $mdfe_inclusao_dfe_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_inclusao_dfe_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_notafiscal_to_string = $mdfe_inclusao_dfe_notafiscal_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_notafiscal_to_string'] = $this->mdfe_inclusao_dfe_notafiscal_to_string;
    }

    public function get_mdfe_inclusao_dfe_notafiscal_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_notafiscal_to_string))
        {
            return $this->mdfe_inclusao_dfe_notafiscal_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_inclusao_dfe_cidade_carrega_to_string($mdfe_inclusao_dfe_cidade_carrega_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_cidade_carrega_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_inclusao_dfe_cidade_carrega_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_inclusao_dfe_cidade_carrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_cidade_carrega_to_string = $mdfe_inclusao_dfe_cidade_carrega_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_cidade_carrega_to_string'] = $this->mdfe_inclusao_dfe_cidade_carrega_to_string;
    }

    public function get_mdfe_inclusao_dfe_cidade_carrega_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_cidade_carrega_to_string))
        {
            return $this->mdfe_inclusao_dfe_cidade_carrega_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('notafiscal_id', '=', $this->id)->getIndexedArray('cidade_carrega_id','{cidade_carrega->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_inclusao_dfe_cidade_descarga_to_string($mdfe_inclusao_dfe_cidade_descarga_to_string)
    {
        if(is_array($mdfe_inclusao_dfe_cidade_descarga_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_inclusao_dfe_cidade_descarga_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_inclusao_dfe_cidade_descarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_inclusao_dfe_cidade_descarga_to_string = $mdfe_inclusao_dfe_cidade_descarga_to_string;
        }

        $this->vdata['mdfe_inclusao_dfe_cidade_descarga_to_string'] = $this->mdfe_inclusao_dfe_cidade_descarga_to_string;
    }

    public function get_mdfe_inclusao_dfe_cidade_descarga_to_string()
    {
        if(!empty($this->mdfe_inclusao_dfe_cidade_descarga_to_string))
        {
            return $this->mdfe_inclusao_dfe_cidade_descarga_to_string;
        }
    
        $values = MdfeInclusaoDfe::where('notafiscal_id', '=', $this->id)->getIndexedArray('cidade_descarga_id','{cidade_descarga->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_fk_indReentrega_to_string($mdfe_nfes_fk_indReentrega_to_string)
    {
        if(is_array($mdfe_nfes_fk_indReentrega_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_nfes_fk_indReentrega_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_nfes_fk_indReentrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_fk_indReentrega_to_string = $mdfe_nfes_fk_indReentrega_to_string;
        }

        $this->vdata['mdfe_nfes_fk_indReentrega_to_string'] = $this->mdfe_nfes_fk_indReentrega_to_string;
    }

    public function get_mdfe_nfes_fk_indReentrega_to_string()
    {
        if(!empty($this->mdfe_nfes_fk_indReentrega_to_string))
        {
            return $this->mdfe_nfes_fk_indReentrega_to_string;
        }
    
        $values = MdfeNfes::where('notafiscal_id', '=', $this->id)->getIndexedArray('indReentrega','{fk_indReentrega->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_mdfe_infmundescarga_to_string($mdfe_nfes_mdfe_infmundescarga_to_string)
    {
        if(is_array($mdfe_nfes_mdfe_infmundescarga_to_string))
        {
            $values = MdfeInfmundescarga::where('id', 'in', $mdfe_nfes_mdfe_infmundescarga_to_string)->getIndexedArray('xMunDescarga', 'xMunDescarga');
            $this->mdfe_nfes_mdfe_infmundescarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_mdfe_infmundescarga_to_string = $mdfe_nfes_mdfe_infmundescarga_to_string;
        }

        $this->vdata['mdfe_nfes_mdfe_infmundescarga_to_string'] = $this->mdfe_nfes_mdfe_infmundescarga_to_string;
    }

    public function get_mdfe_nfes_mdfe_infmundescarga_to_string()
    {
        if(!empty($this->mdfe_nfes_mdfe_infmundescarga_to_string))
        {
            return $this->mdfe_nfes_mdfe_infmundescarga_to_string;
        }
    
        $values = MdfeNfes::where('notafiscal_id', '=', $this->id)->getIndexedArray('mdfe_infmundescarga_id','{mdfe_infmundescarga->xMunDescarga}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_notafiscal_to_string($mdfe_nfes_notafiscal_to_string)
    {
        if(is_array($mdfe_nfes_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $mdfe_nfes_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_nfes_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_notafiscal_to_string = $mdfe_nfes_notafiscal_to_string;
        }

        $this->vdata['mdfe_nfes_notafiscal_to_string'] = $this->mdfe_nfes_notafiscal_to_string;
    }

    public function get_mdfe_nfes_notafiscal_to_string()
    {
        if(!empty($this->mdfe_nfes_notafiscal_to_string))
        {
            return $this->mdfe_nfes_notafiscal_to_string;
        }
    
        $values = MdfeNfes::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_autxml_notafiscal_to_string($notafiscal_autxml_notafiscal_to_string)
    {
        if(is_array($notafiscal_autxml_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_autxml_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_autxml_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_autxml_notafiscal_to_string = $notafiscal_autxml_notafiscal_to_string;
        }

        $this->vdata['notafiscal_autxml_notafiscal_to_string'] = $this->notafiscal_autxml_notafiscal_to_string;
    }

    public function get_notafiscal_autxml_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_autxml_notafiscal_to_string))
        {
            return $this->notafiscal_autxml_notafiscal_to_string;
        }
    
        $values = NotafiscalAutxml::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dup_notafiscal_to_string($notafiscal_dup_notafiscal_to_string)
    {
        if(is_array($notafiscal_dup_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_dup_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dup_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dup_notafiscal_to_string = $notafiscal_dup_notafiscal_to_string;
        }

        $this->vdata['notafiscal_dup_notafiscal_to_string'] = $this->notafiscal_dup_notafiscal_to_string;
    }

    public function get_notafiscal_dup_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_dup_notafiscal_to_string))
        {
            return $this->notafiscal_dup_notafiscal_to_string;
        }
    
        $values = NotafiscalDup::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_frete_volumes_notafiscal_to_string($notafiscal_frete_volumes_notafiscal_to_string)
    {
        if(is_array($notafiscal_frete_volumes_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_frete_volumes_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_frete_volumes_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_frete_volumes_notafiscal_to_string = $notafiscal_frete_volumes_notafiscal_to_string;
        }

        $this->vdata['notafiscal_frete_volumes_notafiscal_to_string'] = $this->notafiscal_frete_volumes_notafiscal_to_string;
    }

    public function get_notafiscal_frete_volumes_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_frete_volumes_notafiscal_to_string))
        {
            return $this->notafiscal_frete_volumes_notafiscal_to_string;
        }
    
        $values = NotafiscalFreteVolumes::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_to_string($notafiscal_itens_notafiscal_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_itens_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_to_string = $notafiscal_itens_notafiscal_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_to_string'] = $this->notafiscal_itens_notafiscal_to_string;
    }

    public function get_notafiscal_itens_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_to_string))
        {
            return $this->notafiscal_itens_notafiscal_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_produto_to_string($notafiscal_itens_produto_to_string)
    {
        if(is_array($notafiscal_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $notafiscal_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_produto_to_string = $notafiscal_itens_produto_to_string;
        }

        $this->vdata['notafiscal_itens_produto_to_string'] = $this->notafiscal_itens_produto_to_string;
    }

    public function get_notafiscal_itens_produto_to_string()
    {
        if(!empty($this->notafiscal_itens_produto_to_string))
        {
            return $this->notafiscal_itens_produto_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_indtot_to_string($notafiscal_itens_notafiscal_item_indtot_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_indtot_to_string))
        {
            $values = NotafiscalItemIndtot::where('id', 'in', $notafiscal_itens_notafiscal_item_indtot_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_indtot_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_indtot_to_string = $notafiscal_itens_notafiscal_item_indtot_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_indtot_to_string'] = $this->notafiscal_itens_notafiscal_item_indtot_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_indtot_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_indtot_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_indtot_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_item_indtot_id','{notafiscal_item_indtot->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_orig_to_string($notafiscal_itens_notafiscal_item_orig_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $notafiscal_itens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_orig_to_string = $notafiscal_itens_notafiscal_item_orig_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_orig_to_string'] = $this->notafiscal_itens_notafiscal_item_orig_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_orig_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_orig_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_modbc_to_string($notafiscal_itens_notafiscal_item_modbc_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $notafiscal_itens_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_modbc_to_string = $notafiscal_itens_notafiscal_item_modbc_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_modbc_to_string'] = $this->notafiscal_itens_notafiscal_item_modbc_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_modbc_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_modbc_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_motDesICMS_to_string($notafiscal_itens_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $notafiscal_itens_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string = $notafiscal_itens_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_motDesICMS_to_string'] = $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_motDesICMS_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_logs_notafiscal_to_string($notafiscal_logs_notafiscal_to_string)
    {
        if(is_array($notafiscal_logs_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_logs_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_logs_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_logs_notafiscal_to_string = $notafiscal_logs_notafiscal_to_string;
        }

        $this->vdata['notafiscal_logs_notafiscal_to_string'] = $this->notafiscal_logs_notafiscal_to_string;
    }

    public function get_notafiscal_logs_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_logs_notafiscal_to_string))
        {
            return $this->notafiscal_logs_notafiscal_to_string;
        }
    
        $values = NotafiscalLogs::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_logs_system_users_to_string($notafiscal_logs_system_users_to_string)
    {
        if(is_array($notafiscal_logs_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $notafiscal_logs_system_users_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_logs_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_logs_system_users_to_string = $notafiscal_logs_system_users_to_string;
        }

        $this->vdata['notafiscal_logs_system_users_to_string'] = $this->notafiscal_logs_system_users_to_string;
    }

    public function get_notafiscal_logs_system_users_to_string()
    {
        if(!empty($this->notafiscal_logs_system_users_to_string))
        {
            return $this->notafiscal_logs_system_users_to_string;
        }
    
        $values = NotafiscalLogs::where('notafiscal_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_pag_notafiscal_to_string($notafiscal_pag_notafiscal_to_string)
    {
        if(is_array($notafiscal_pag_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_pag_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_pag_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_pag_notafiscal_to_string = $notafiscal_pag_notafiscal_to_string;
        }

        $this->vdata['notafiscal_pag_notafiscal_to_string'] = $this->notafiscal_pag_notafiscal_to_string;
    }

    public function get_notafiscal_pag_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_pag_notafiscal_to_string))
        {
            return $this->notafiscal_pag_notafiscal_to_string;
        }
    
        $values = NotafiscalPag::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_pag_notafiscal_tpag_to_string($notafiscal_pag_notafiscal_tpag_to_string)
    {
        if(is_array($notafiscal_pag_notafiscal_tpag_to_string))
        {
            $values = NotafiscalTpag::where('id', 'in', $notafiscal_pag_notafiscal_tpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_pag_notafiscal_tpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_pag_notafiscal_tpag_to_string = $notafiscal_pag_notafiscal_tpag_to_string;
        }

        $this->vdata['notafiscal_pag_notafiscal_tpag_to_string'] = $this->notafiscal_pag_notafiscal_tpag_to_string;
    }

    public function get_notafiscal_pag_notafiscal_tpag_to_string()
    {
        if(!empty($this->notafiscal_pag_notafiscal_tpag_to_string))
        {
            return $this->notafiscal_pag_notafiscal_tpag_to_string;
        }
    
        $values = NotafiscalPag::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_tpag_id','{notafiscal_tpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_refecf_notafiscal_to_string($notafiscal_refecf_notafiscal_to_string)
    {
        if(is_array($notafiscal_refecf_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_refecf_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_refecf_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_refecf_notafiscal_to_string = $notafiscal_refecf_notafiscal_to_string;
        }

        $this->vdata['notafiscal_refecf_notafiscal_to_string'] = $this->notafiscal_refecf_notafiscal_to_string;
    }

    public function get_notafiscal_refecf_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_refecf_notafiscal_to_string))
        {
            return $this->notafiscal_refecf_notafiscal_to_string;
        }
    
        $values = NotafiscalRefecf::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_refecf_notafiscal_refecfmod_to_string($notafiscal_refecf_notafiscal_refecfmod_to_string)
    {
        if(is_array($notafiscal_refecf_notafiscal_refecfmod_to_string))
        {
            $values = NotafiscalRefecfmod::where('id', 'in', $notafiscal_refecf_notafiscal_refecfmod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_refecf_notafiscal_refecfmod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_refecf_notafiscal_refecfmod_to_string = $notafiscal_refecf_notafiscal_refecfmod_to_string;
        }

        $this->vdata['notafiscal_refecf_notafiscal_refecfmod_to_string'] = $this->notafiscal_refecf_notafiscal_refecfmod_to_string;
    }

    public function get_notafiscal_refecf_notafiscal_refecfmod_to_string()
    {
        if(!empty($this->notafiscal_refecf_notafiscal_refecfmod_to_string))
        {
            return $this->notafiscal_refecf_notafiscal_refecfmod_to_string;
        }
    
        $values = NotafiscalRefecf::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_refecfmod_id','{notafiscal_refecfmod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_refnfe_notafiscal_to_string($notafiscal_refnfe_notafiscal_to_string)
    {
        if(is_array($notafiscal_refnfe_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_refnfe_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_refnfe_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_refnfe_notafiscal_to_string = $notafiscal_refnfe_notafiscal_to_string;
        }

        $this->vdata['notafiscal_refnfe_notafiscal_to_string'] = $this->notafiscal_refnfe_notafiscal_to_string;
    }

    public function get_notafiscal_refnfe_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_refnfe_notafiscal_to_string))
        {
            return $this->notafiscal_refnfe_notafiscal_to_string;
        }
    
        $values = NotafiscalRefnfe::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_pedido_evento_notafiscal_to_string($pedido_evento_notafiscal_to_string)
    {
        if(is_array($pedido_evento_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $pedido_evento_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->pedido_evento_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->pedido_evento_notafiscal_to_string = $pedido_evento_notafiscal_to_string;
        }

        $this->vdata['pedido_evento_notafiscal_to_string'] = $this->pedido_evento_notafiscal_to_string;
    }

    public function get_pedido_evento_notafiscal_to_string()
    {
        if(!empty($this->pedido_evento_notafiscal_to_string))
        {
            return $this->pedido_evento_notafiscal_to_string;
        }
    
        $values = PedidoEvento::where('notafiscal_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_pedido_evento_system_unit_to_string($pedido_evento_system_unit_to_string)
    {
        if(is_array($pedido_evento_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $pedido_evento_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->pedido_evento_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->pedido_evento_system_unit_to_string = $pedido_evento_system_unit_to_string;
        }

        $this->vdata['pedido_evento_system_unit_to_string'] = $this->pedido_evento_system_unit_to_string;
    }

    public function get_pedido_evento_system_unit_to_string()
    {
        if(!empty($this->pedido_evento_system_unit_to_string))
        {
            return $this->pedido_evento_system_unit_to_string;
        }
    
        $values = PedidoEvento::where('notafiscal_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_pedido_evento_system_users_to_string($pedido_evento_system_users_to_string)
    {
        if(is_array($pedido_evento_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $pedido_evento_system_users_to_string)->getIndexedArray('name', 'name');
            $this->pedido_evento_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->pedido_evento_system_users_to_string = $pedido_evento_system_users_to_string;
        }

        $this->vdata['pedido_evento_system_users_to_string'] = $this->pedido_evento_system_users_to_string;
    }

    public function get_pedido_evento_system_users_to_string()
    {
        if(!empty($this->pedido_evento_system_users_to_string))
        {
            return $this->pedido_evento_system_users_to_string;
        }
    
        $values = PedidoEvento::where('notafiscal_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

  public static function atualiza_totais_nota($idnota)
  {
     $nota = Notafiscal::find($idnota);
 
     if($nota)
     {
        $ICMS_BC                = 0;
        $ICMS_Valor             = 0;
        $ICMSST_BC              = 0;
        $ICMSST_Valor           = 0;
        $TotalProdutos          = 0;
        $TotalFrete             = 0;
        $TotalSeguro            = 0;
        $TotalDesconto          = 0;
        $IPI_Valor              = 0;
        $TotalNota              = 0;
        $PIS_Valor              = 0;
        $COFINS_Valor           = 0;
        $TotalOutrasDespesas    = 0;
        $TotalICMS_VICMSUFDEST  = 0;
        $TotalICMS_VICMSUFREMET = 0;
        $TotalICMS_VFCPUFDEST   = 0;
        $ISSQN_VBC              = 0;
        $ISSQN_VSERV            = 0;
        $ISSQN_VISS             = 0;
        $vFCP                   = 0;
        $vFCPST                 = 0;
        $vFCPSTRET              = 0;
        $vIPIDevol              = 0;    

         foreach ($nota->getNotafiscalItenss() as $item) 
         {
         
            $ICMS_BC                +=  $item->icms_basecalc;
            $ICMS_Valor             +=  $item->icms_valor;
            $ICMSST_BC              +=  $item->icms_vbcst;
            $ICMSST_Valor           +=  $item->icms_vicmsst;
            $TotalFrete             +=  $item->vfrete;
            $TotalSeguro            +=  $item->vseg;
            $TotalDesconto          +=  $item->vdesc;
            $IPI_Valor              +=  $item->ipi_valor;
            $PIS_Valor              +=  $item->pis_valor;
            $COFINS_Valor           +=  $item->cofins_valor;
            $TotalOutrasDespesas    +=  $item->voutro;
            $TotalProdutos          +=  $item->vprod;

            //totais de FCP (NFe 4.00)
            //$vFCP                   += $item->vfcp;
            //$vFCPST                 += $item->vfcpst;
            //$vFCPSTRET              += $item->vfcpstret;

            $TotalICMS_VICMSUFDEST  += $item->icms_vicmsufdest;
            $TotalICMS_VICMSUFREMET += $item->icms_vicmsufremet;
            //$TotalICMS_VFCPUFDEST   += TotalICMS_VFCPUFDEST + ArredondaDecimal(2,CdsItNotaFiscalNI_ICMS_VFCPUFDEST.Value);

            //parte de ISSQN FALTA
            //ISSQN_VBC              += CdsItNotaFiscalNI_ISSQN_VBC.Value;
            //if CdsItNotaFiscalNI_ISSQN_VBC.Value>0 then //só contabilizar valor se for de serviço...
            //ISSQN_VSERV          +=  CdsItNotaFiscalNI_TOTAL.Value;
            //ISSQN_VISS           += CdsItNotaFiscalNI_ISSQN_VISSQN.Value;

            $vIPIDevol              += $item->ipi_vipidevol;

         }
     
           $TotalNota = $TotalProdutos -
                        $TotalDesconto +
                        $ICMSST_Valor  +
                        $TotalFrete    +
                        $TotalSeguro   +
                        $IPI_Valor     +
                        $vIPIDevol     +
                        $TotalOutrasDespesas;   
                    

        $nota->icms_basecalc        = $ICMS_BC;
        $nota->icms_valor           = $ICMS_Valor;
        $nota->icms_subst_base_calc = $ICMSST_BC;
        $nota->icms_subst_valor     = $ICMSST_Valor;
        $nota->frete_valor          = $TotalFrete;
        $nota->seguro_valor         = $TotalSeguro;
        $nota->ipi_valor            = $IPI_Valor;
        $nota->desconto_valor       = $TotalDesconto;
        $nota->pis_valor            = $PIS_Valor;
        $nota->cofins_valor         = $COFINS_Valor;
        $nota->outras_despesas      = $TotalOutrasDespesas;
        $nota->icms_vfcp            = $vFCP;
        $nota->icms_vfcpst          = $vFCPST;
        $nota->icms_vfcpstret       = $vFCPSTRET;

        $nota->vicmsufdest          = $TotalICMS_VICMSUFDEST;
        $nota->vicmsufdestremet     = $TotalICMS_VICMSUFREMET;
        //$nota->vfcpufdest           = TotalICMS_VFCPUFDEST;  

        $nota->ipi_vipidevol        = $vIPIDevol;
    
        $nota->issqn_vserv          = $ISSQN_VSERV;
        $nota->issqn_vbc            = $ISSQN_VBC;
        $nota->issqn_viss           = $ISSQN_VISS;  
    
        if ($nota->issqn_vserv>0)
        {
            $nota->issqn_dcompet    = $nota->data_emissao;       
        }

        $nota->valor_total_produtos = $TotalProdutos; 
        $nota->valor_total_nota     = $TotalNota;
        $nota->store();
     }  

  }
                    
}

