<?php

class NotafiscalCrt extends TRecord
{
    const TABLENAME  = 'notafiscal_crt';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const SimplesNacional = '1';
    const SimplesNacionalExcessoSublimite = '2';
    const RegimeNormal = '3';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getClientes
     */
    public function getClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_crt_id', '=', $this->id));
        return Cliente::getObjects( $criteria );
    }
    /**
     * Method getCstIcmss
     */
    public function getCstIcmss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('regime_tributario_id', '=', $this->id));
        return CstIcms::getObjects( $criteria );
    }
    /**
     * Method getFornecedors
     */
    public function getFornecedors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_crt_id', '=', $this->id));
        return Fornecedor::getObjects( $criteria );
    }
    /**
     * Method getNotafiscals
     */
    public function getNotafiscals()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_crt_id', '=', $this->id));
        return Notafiscal::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompras
     */
    public function getNotaFiscalCompras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_crt_id', '=', $this->id));
        return NotaFiscalCompra::getObjects( $criteria );
    }

    public function set_cliente_pessoa_tipo_to_string($cliente_pessoa_tipo_to_string)
    {
        if(is_array($cliente_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $cliente_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_pessoa_tipo_to_string = $cliente_pessoa_tipo_to_string;
        }

        $this->vdata['cliente_pessoa_tipo_to_string'] = $this->cliente_pessoa_tipo_to_string;
    }

    public function get_cliente_pessoa_tipo_to_string()
    {
        if(!empty($this->cliente_pessoa_tipo_to_string))
        {
            return $this->cliente_pessoa_tipo_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_to_string($cliente_cliente_classificacao_to_string)
    {
        if(is_array($cliente_cliente_classificacao_to_string))
        {
            $values = ClienteClassificacao::where('id', 'in', $cliente_cliente_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_to_string = $cliente_cliente_classificacao_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_to_string'] = $this->cliente_cliente_classificacao_to_string;
    }

    public function get_cliente_cliente_classificacao_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_to_string))
        {
            return $this->cliente_cliente_classificacao_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('cliente_classificacao_id','{cliente_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_subgrupo_to_string($cliente_cliente_classificacao_subgrupo_to_string)
    {
        if(is_array($cliente_cliente_classificacao_subgrupo_to_string))
        {
            $values = ClienteClassificacaoSubgrupo::where('id', 'in', $cliente_cliente_classificacao_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_subgrupo_to_string = $cliente_cliente_classificacao_subgrupo_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_subgrupo_to_string'] = $this->cliente_cliente_classificacao_subgrupo_to_string;
    }

    public function get_cliente_cliente_classificacao_subgrupo_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_subgrupo_to_string))
        {
            return $this->cliente_cliente_classificacao_subgrupo_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('cliente_classificacao_subgrupo_id','{cliente_classificacao_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_vendedor_to_string($cliente_vendedor_to_string)
    {
        if(is_array($cliente_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $cliente_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_vendedor_to_string = $cliente_vendedor_to_string;
        }

        $this->vdata['cliente_vendedor_to_string'] = $this->cliente_vendedor_to_string;
    }

    public function get_cliente_vendedor_to_string()
    {
        if(!empty($this->cliente_vendedor_to_string))
        {
            return $this->cliente_vendedor_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_indiedest_to_string($cliente_notafiscal_indiedest_to_string)
    {
        if(is_array($cliente_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $cliente_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_indiedest_to_string = $cliente_notafiscal_indiedest_to_string;
        }

        $this->vdata['cliente_notafiscal_indiedest_to_string'] = $this->cliente_notafiscal_indiedest_to_string;
    }

    public function get_cliente_notafiscal_indiedest_to_string()
    {
        if(!empty($this->cliente_notafiscal_indiedest_to_string))
        {
            return $this->cliente_notafiscal_indiedest_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_crt_to_string($cliente_notafiscal_crt_to_string)
    {
        if(is_array($cliente_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $cliente_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_crt_to_string = $cliente_notafiscal_crt_to_string;
        }

        $this->vdata['cliente_notafiscal_crt_to_string'] = $this->cliente_notafiscal_crt_to_string;
    }

    public function get_cliente_notafiscal_crt_to_string()
    {
        if(!empty($this->cliente_notafiscal_crt_to_string))
        {
            return $this->cliente_notafiscal_crt_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_residencia_propria_to_string($cliente_fk_residencia_propria_to_string)
    {
        if(is_array($cliente_fk_residencia_propria_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_residencia_propria_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_residencia_propria_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_residencia_propria_to_string = $cliente_fk_residencia_propria_to_string;
        }

        $this->vdata['cliente_fk_residencia_propria_to_string'] = $this->cliente_fk_residencia_propria_to_string;
    }

    public function get_cliente_fk_residencia_propria_to_string()
    {
        if(!empty($this->cliente_fk_residencia_propria_to_string))
        {
            return $this->cliente_fk_residencia_propria_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('residencia_propria','{fk_residencia_propria->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_utilizar_endereco_cobranca_to_string($cliente_fk_utilizar_endereco_cobranca_to_string)
    {
        if(is_array($cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_utilizar_endereco_cobranca_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = $cliente_fk_utilizar_endereco_cobranca_to_string;
        }

        $this->vdata['cliente_fk_utilizar_endereco_cobranca_to_string'] = $this->cliente_fk_utilizar_endereco_cobranca_to_string;
    }

    public function get_cliente_fk_utilizar_endereco_cobranca_to_string()
    {
        if(!empty($this->cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            return $this->cliente_fk_utilizar_endereco_cobranca_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('utilizar_endereco_cobranca','{fk_utilizar_endereco_cobranca->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_situacao_to_string($cliente_cliente_situacao_to_string)
    {
        if(is_array($cliente_cliente_situacao_to_string))
        {
            $values = ClienteSituacao::where('id', 'in', $cliente_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_situacao_to_string = $cliente_cliente_situacao_to_string;
        }

        $this->vdata['cliente_cliente_situacao_to_string'] = $this->cliente_cliente_situacao_to_string;
    }

    public function get_cliente_cliente_situacao_to_string()
    {
        if(!empty($this->cliente_cliente_situacao_to_string))
        {
            return $this->cliente_cliente_situacao_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('cliente_situacao_id','{cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_system_unit_to_string($cliente_system_unit_to_string)
    {
        if(is_array($cliente_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $cliente_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->cliente_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_system_unit_to_string = $cliente_system_unit_to_string;
        }

        $this->vdata['cliente_system_unit_to_string'] = $this->cliente_system_unit_to_string;
    }

    public function get_cliente_system_unit_to_string()
    {
        if(!empty($this->cliente_system_unit_to_string))
        {
            return $this->cliente_system_unit_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_cliente_tabela_preco_to_string($cliente_tabela_preco_to_string)
    {
        if(is_array($cliente_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $cliente_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_tabela_preco_to_string = $cliente_tabela_preco_to_string;
        }

        $this->vdata['cliente_tabela_preco_to_string'] = $this->cliente_tabela_preco_to_string;
    }

    public function get_cliente_tabela_preco_to_string()
    {
        if(!empty($this->cliente_tabela_preco_to_string))
        {
            return $this->cliente_tabela_preco_to_string;
        }
    
        $values = Cliente::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_cst_icms_regime_tributario_to_string($cst_icms_regime_tributario_to_string)
    {
        if(is_array($cst_icms_regime_tributario_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $cst_icms_regime_tributario_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cst_icms_regime_tributario_to_string = implode(', ', $values);
        }
        else
        {
            $this->cst_icms_regime_tributario_to_string = $cst_icms_regime_tributario_to_string;
        }

        $this->vdata['cst_icms_regime_tributario_to_string'] = $this->cst_icms_regime_tributario_to_string;
    }

    public function get_cst_icms_regime_tributario_to_string()
    {
        if(!empty($this->cst_icms_regime_tributario_to_string))
        {
            return $this->cst_icms_regime_tributario_to_string;
        }
    
        $values = CstIcms::where('regime_tributario_id', '=', $this->id)->getIndexedArray('regime_tributario_id','{regime_tributario->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_pessoa_tipo_to_string($fornecedor_pessoa_tipo_to_string)
    {
        if(is_array($fornecedor_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $fornecedor_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_pessoa_tipo_to_string = $fornecedor_pessoa_tipo_to_string;
        }

        $this->vdata['fornecedor_pessoa_tipo_to_string'] = $this->fornecedor_pessoa_tipo_to_string;
    }

    public function get_fornecedor_pessoa_tipo_to_string()
    {
        if(!empty($this->fornecedor_pessoa_tipo_to_string))
        {
            return $this->fornecedor_pessoa_tipo_to_string;
        }
    
        $values = Fornecedor::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_fornecedor_classificacao_to_string($fornecedor_fornecedor_classificacao_to_string)
    {
        if(is_array($fornecedor_fornecedor_classificacao_to_string))
        {
            $values = FornecedorClassificacao::where('id', 'in', $fornecedor_fornecedor_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_fornecedor_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_fornecedor_classificacao_to_string = $fornecedor_fornecedor_classificacao_to_string;
        }

        $this->vdata['fornecedor_fornecedor_classificacao_to_string'] = $this->fornecedor_fornecedor_classificacao_to_string;
    }

    public function get_fornecedor_fornecedor_classificacao_to_string()
    {
        if(!empty($this->fornecedor_fornecedor_classificacao_to_string))
        {
            return $this->fornecedor_fornecedor_classificacao_to_string;
        }
    
        $values = Fornecedor::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('fornecedor_classificacao_id','{fornecedor_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_cidade_to_string($fornecedor_cidade_to_string)
    {
        if(is_array($fornecedor_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $fornecedor_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->fornecedor_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_cidade_to_string = $fornecedor_cidade_to_string;
        }

        $this->vdata['fornecedor_cidade_to_string'] = $this->fornecedor_cidade_to_string;
    }

    public function get_fornecedor_cidade_to_string()
    {
        if(!empty($this->fornecedor_cidade_to_string))
        {
            return $this->fornecedor_cidade_to_string;
        }
    
        $values = Fornecedor::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    public function set_fornecedor_notafiscal_crt_to_string($fornecedor_notafiscal_crt_to_string)
    {
        if(is_array($fornecedor_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $fornecedor_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_notafiscal_crt_to_string = $fornecedor_notafiscal_crt_to_string;
        }

        $this->vdata['fornecedor_notafiscal_crt_to_string'] = $this->fornecedor_notafiscal_crt_to_string;
    }

    public function get_fornecedor_notafiscal_crt_to_string()
    {
        if(!empty($this->fornecedor_notafiscal_crt_to_string))
        {
            return $this->fornecedor_notafiscal_crt_to_string;
        }
    
        $values = Fornecedor::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_fornecedor_notafiscal_indiedest_to_string($fornecedor_notafiscal_indiedest_to_string)
    {
        if(is_array($fornecedor_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $fornecedor_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->fornecedor_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->fornecedor_notafiscal_indiedest_to_string = $fornecedor_notafiscal_indiedest_to_string;
        }

        $this->vdata['fornecedor_notafiscal_indiedest_to_string'] = $this->fornecedor_notafiscal_indiedest_to_string;
    }

    public function get_fornecedor_notafiscal_indiedest_to_string()
    {
        if(!empty($this->fornecedor_notafiscal_indiedest_to_string))
        {
            return $this->fornecedor_notafiscal_indiedest_to_string;
        }
    
        $values = Fornecedor::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_system_unit_to_string($notafiscal_system_unit_to_string)
    {
        if(is_array($notafiscal_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_system_unit_to_string = $notafiscal_system_unit_to_string;
        }

        $this->vdata['notafiscal_system_unit_to_string'] = $this->notafiscal_system_unit_to_string;
    }

    public function get_notafiscal_system_unit_to_string()
    {
        if(!empty($this->notafiscal_system_unit_to_string))
        {
            return $this->notafiscal_system_unit_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_cliente_to_string($notafiscal_cliente_to_string)
    {
        if(is_array($notafiscal_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $notafiscal_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_cliente_to_string = $notafiscal_cliente_to_string;
        }

        $this->vdata['notafiscal_cliente_to_string'] = $this->notafiscal_cliente_to_string;
    }

    public function get_notafiscal_cliente_to_string()
    {
        if(!empty($this->notafiscal_cliente_to_string))
        {
            return $this->notafiscal_cliente_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_venda_to_string($notafiscal_venda_to_string)
    {
        if(is_array($notafiscal_venda_to_string))
        {
            $values = Venda::where('id', 'in', $notafiscal_venda_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_venda_to_string = $notafiscal_venda_to_string;
        }

        $this->vdata['notafiscal_venda_to_string'] = $this->notafiscal_venda_to_string;
    }

    public function get_notafiscal_venda_to_string()
    {
        if(!empty($this->notafiscal_venda_to_string))
        {
            return $this->notafiscal_venda_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_nf_tipodocumento_to_string($notafiscal_nf_tipodocumento_to_string)
    {
        if(is_array($notafiscal_nf_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_nf_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_nf_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_nf_tipodocumento_to_string = $notafiscal_nf_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_nf_tipodocumento_to_string'] = $this->notafiscal_nf_tipodocumento_to_string;
    }

    public function get_notafiscal_nf_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_nf_tipodocumento_to_string))
        {
            return $this->notafiscal_nf_tipodocumento_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('nf_tipodocumento_id','{nf_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_situacao_to_string($notafiscal_notafiscal_situacao_to_string)
    {
        if(is_array($notafiscal_notafiscal_situacao_to_string))
        {
            $values = NotafiscalSituacao::where('id', 'in', $notafiscal_notafiscal_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_situacao_to_string = $notafiscal_notafiscal_situacao_to_string;
        }

        $this->vdata['notafiscal_notafiscal_situacao_to_string'] = $this->notafiscal_notafiscal_situacao_to_string;
    }

    public function get_notafiscal_notafiscal_situacao_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_situacao_to_string))
        {
            return $this->notafiscal_notafiscal_situacao_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_situacao_id','{notafiscal_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_crt_to_string($notafiscal_notafiscal_crt_to_string)
    {
        if(is_array($notafiscal_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $notafiscal_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_crt_to_string = $notafiscal_notafiscal_crt_to_string;
        }

        $this->vdata['notafiscal_notafiscal_crt_to_string'] = $this->notafiscal_notafiscal_crt_to_string;
    }

    public function get_notafiscal_notafiscal_crt_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_crt_to_string))
        {
            return $this->notafiscal_notafiscal_crt_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indiedest_to_string($notafiscal_notafiscal_indiedest_to_string)
    {
        if(is_array($notafiscal_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $notafiscal_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indiedest_to_string = $notafiscal_notafiscal_indiedest_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indiedest_to_string'] = $this->notafiscal_notafiscal_indiedest_to_string;
    }

    public function get_notafiscal_notafiscal_indiedest_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indiedest_to_string))
        {
            return $this->notafiscal_notafiscal_indiedest_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscaldest_to_string($notafiscal_notafiscaldest_to_string)
    {
        if(is_array($notafiscal_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $notafiscal_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscaldest_to_string = $notafiscal_notafiscaldest_to_string;
        }

        $this->vdata['notafiscal_notafiscaldest_to_string'] = $this->notafiscal_notafiscaldest_to_string;
    }

    public function get_notafiscal_notafiscaldest_to_string()
    {
        if(!empty($this->notafiscal_notafiscaldest_to_string))
        {
            return $this->notafiscal_notafiscaldest_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpimp_to_string($notafiscal_notafiscal_tpimp_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $notafiscal_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpimp_to_string = $notafiscal_notafiscal_tpimp_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpimp_to_string'] = $this->notafiscal_notafiscal_tpimp_to_string;
    }

    public function get_notafiscal_notafiscal_tpimp_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpimp_to_string))
        {
            return $this->notafiscal_notafiscal_tpimp_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpemis_to_string($notafiscal_notafiscal_tpemis_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpemis_to_string))
        {
            $values = NotafiscalTpemis::where('id', 'in', $notafiscal_notafiscal_tpemis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpemis_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpemis_to_string = $notafiscal_notafiscal_tpemis_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpemis_to_string'] = $this->notafiscal_notafiscal_tpemis_to_string;
    }

    public function get_notafiscal_notafiscal_tpemis_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpemis_to_string))
        {
            return $this->notafiscal_notafiscal_tpemis_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_tpemis_id','{notafiscal_tpemis->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_finnfe_to_string($notafiscal_notafiscal_finnfe_to_string)
    {
        if(is_array($notafiscal_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $notafiscal_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_finnfe_to_string = $notafiscal_notafiscal_finnfe_to_string;
        }

        $this->vdata['notafiscal_notafiscal_finnfe_to_string'] = $this->notafiscal_notafiscal_finnfe_to_string;
    }

    public function get_notafiscal_notafiscal_finnfe_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_finnfe_to_string))
        {
            return $this->notafiscal_notafiscal_finnfe_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indfinal_to_string($notafiscal_notafiscal_indfinal_to_string)
    {
        if(is_array($notafiscal_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $notafiscal_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indfinal_to_string = $notafiscal_notafiscal_indfinal_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indfinal_to_string'] = $this->notafiscal_notafiscal_indfinal_to_string;
    }

    public function get_notafiscal_notafiscal_indfinal_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indfinal_to_string))
        {
            return $this->notafiscal_notafiscal_indfinal_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpres_to_string($notafiscal_notafiscal_indpres_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $notafiscal_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpres_to_string = $notafiscal_notafiscal_indpres_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpres_to_string'] = $this->notafiscal_notafiscal_indpres_to_string;
    }

    public function get_notafiscal_notafiscal_indpres_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpres_to_string))
        {
            return $this->notafiscal_notafiscal_indpres_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpag_to_string($notafiscal_notafiscal_indpag_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $notafiscal_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpag_to_string = $notafiscal_notafiscal_indpag_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpag_to_string'] = $this->notafiscal_notafiscal_indpag_to_string;
    }

    public function get_notafiscal_notafiscal_indpag_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpag_to_string))
        {
            return $this->notafiscal_notafiscal_indpag_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dispositivos_to_string($notafiscal_dispositivos_to_string)
    {
        if(is_array($notafiscal_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $notafiscal_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dispositivos_to_string = $notafiscal_dispositivos_to_string;
        }

        $this->vdata['notafiscal_dispositivos_to_string'] = $this->notafiscal_dispositivos_to_string;
    }

    public function get_notafiscal_dispositivos_to_string()
    {
        if(!empty($this->notafiscal_dispositivos_to_string))
        {
            return $this->notafiscal_dispositivos_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpamb_to_string($notafiscal_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpamb_to_string = $notafiscal_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpamb_to_string'] = $this->notafiscal_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_notafiscal_tpamb_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_mod_to_string($notafiscal_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_mod_to_string = $notafiscal_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_notafiscal_mod_to_string'] = $this->notafiscal_notafiscal_mod_to_string;
    }

    public function get_notafiscal_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_mod_to_string))
        {
            return $this->notafiscal_notafiscal_mod_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_modfrete_to_string($notafiscal_notafiscal_modfrete_to_string)
    {
        if(is_array($notafiscal_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $notafiscal_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_modfrete_to_string = $notafiscal_notafiscal_modfrete_to_string;
        }

        $this->vdata['notafiscal_notafiscal_modfrete_to_string'] = $this->notafiscal_notafiscal_modfrete_to_string;
    }

    public function get_notafiscal_notafiscal_modfrete_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_modfrete_to_string))
        {
            return $this->notafiscal_notafiscal_modfrete_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_natureza_operacao_to_string($notafiscal_natureza_operacao_to_string)
    {
        if(is_array($notafiscal_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $notafiscal_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_natureza_operacao_to_string = $notafiscal_natureza_operacao_to_string;
        }

        $this->vdata['notafiscal_natureza_operacao_to_string'] = $this->notafiscal_natureza_operacao_to_string;
    }

    public function get_notafiscal_natureza_operacao_to_string()
    {
        if(!empty($this->notafiscal_natureza_operacao_to_string))
        {
            return $this->notafiscal_natureza_operacao_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_movimentacao_origem_to_string($notafiscal_movimentacao_origem_to_string)
    {
        if(is_array($notafiscal_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $notafiscal_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_movimentacao_origem_to_string = $notafiscal_movimentacao_origem_to_string;
        }

        $this->vdata['notafiscal_movimentacao_origem_to_string'] = $this->notafiscal_movimentacao_origem_to_string;
    }

    public function get_notafiscal_movimentacao_origem_to_string()
    {
        if(!empty($this->notafiscal_movimentacao_origem_to_string))
        {
            return $this->notafiscal_movimentacao_origem_to_string;
        }
    
        $values = Notafiscal::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_system_unit_to_string($nota_fiscal_compra_system_unit_to_string)
    {
        if(is_array($nota_fiscal_compra_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $nota_fiscal_compra_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->nota_fiscal_compra_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_system_unit_to_string = $nota_fiscal_compra_system_unit_to_string;
        }

        $this->vdata['nota_fiscal_compra_system_unit_to_string'] = $this->nota_fiscal_compra_system_unit_to_string;
    }

    public function get_nota_fiscal_compra_system_unit_to_string()
    {
        if(!empty($this->nota_fiscal_compra_system_unit_to_string))
        {
            return $this->nota_fiscal_compra_system_unit_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_fornecedor_to_string($nota_fiscal_compra_fornecedor_to_string)
    {
        if(is_array($nota_fiscal_compra_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $nota_fiscal_compra_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_fornecedor_to_string = $nota_fiscal_compra_fornecedor_to_string;
        }

        $this->vdata['nota_fiscal_compra_fornecedor_to_string'] = $this->nota_fiscal_compra_fornecedor_to_string;
    }

    public function get_nota_fiscal_compra_fornecedor_to_string()
    {
        if(!empty($this->nota_fiscal_compra_fornecedor_to_string))
        {
            return $this->nota_fiscal_compra_fornecedor_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tipodocumento_to_string($nota_fiscal_compra_notafiscal_tipodocumento_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $nota_fiscal_compra_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = $nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tipodocumento_to_string'] = $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            $values = NotaFiscalCompraSituacao::where('id', 'in', $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_nota_fiscal_compra_situacao_to_string'] = $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
    }

    public function get_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            return $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_situacao_id','{nota_fiscal_compra_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_crt_to_string($nota_fiscal_compra_notafiscal_crt_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $nota_fiscal_compra_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_crt_to_string = $nota_fiscal_compra_notafiscal_crt_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_crt_to_string'] = $this->nota_fiscal_compra_notafiscal_crt_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_crt_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_crt_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_crt_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indiedest_to_string($nota_fiscal_compra_notafiscal_indiedest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $nota_fiscal_compra_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = $nota_fiscal_compra_notafiscal_indiedest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indiedest_to_string'] = $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indiedest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscaldest_to_string($nota_fiscal_compra_notafiscaldest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $nota_fiscal_compra_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscaldest_to_string = $nota_fiscal_compra_notafiscaldest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscaldest_to_string'] = $this->nota_fiscal_compra_notafiscaldest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscaldest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscaldest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscaldest_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tpimp_to_string($nota_fiscal_compra_notafiscal_tpimp_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $nota_fiscal_compra_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = $nota_fiscal_compra_notafiscal_tpimp_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tpimp_to_string'] = $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tpimp_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_finnfe_to_string($nota_fiscal_compra_notafiscal_finnfe_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $nota_fiscal_compra_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = $nota_fiscal_compra_notafiscal_finnfe_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_finnfe_to_string'] = $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_finnfe_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indfinal_to_string($nota_fiscal_compra_notafiscal_indfinal_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $nota_fiscal_compra_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = $nota_fiscal_compra_notafiscal_indfinal_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indfinal_to_string'] = $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indfinal_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpres_to_string($nota_fiscal_compra_notafiscal_indpres_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $nota_fiscal_compra_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = $nota_fiscal_compra_notafiscal_indpres_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpres_to_string'] = $this->nota_fiscal_compra_notafiscal_indpres_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpres_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpres_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpag_to_string($nota_fiscal_compra_notafiscal_indpag_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $nota_fiscal_compra_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = $nota_fiscal_compra_notafiscal_indpag_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpag_to_string'] = $this->nota_fiscal_compra_notafiscal_indpag_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpag_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpag_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_mod_to_string($nota_fiscal_compra_notafiscal_mod_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $nota_fiscal_compra_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_mod_to_string = $nota_fiscal_compra_notafiscal_mod_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_mod_to_string'] = $this->nota_fiscal_compra_notafiscal_mod_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_mod_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_mod_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_mod_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_modfrete_to_string($nota_fiscal_compra_notafiscal_modfrete_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $nota_fiscal_compra_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = $nota_fiscal_compra_notafiscal_modfrete_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_modfrete_to_string'] = $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_modfrete_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_crt_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    
}

