<?php

class NotafiscalItemMotdesicms extends TRecord
{
    const TABLENAME  = 'notafiscal_item_motDesICMS';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Taxi = '1';
    const ProdutorAgropecuario = '2';
    const FrotistaLocadora = '3';
    const DiplomaticoConsular = '4';
    const SUFRAMA = '5';
    const VendaAOrgaoPublico = '6';
    const Outros = '7';
    const DeficienteCondutor = '8';
    const DeficienteNaoCondutor = '9';
    const OrgaoDeFomentoEDesenvolvimentoAgropecuario = '10';
    const OlimpiadasRio2016 = '11';
    const SolicitadoPeloFisco = '12';
    const UtilitariosEMotocicletasDaAmazoniaOcidentalEAreasdeLivreComercio = '13';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('codigo');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getNaturezaOperacaos
     */
    public function getNaturezaOperacaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_item_motDesICMS_id', '=', $this->id));
        return NaturezaOperacao::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaoExcecaos
     */
    public function getNaturezaOperacaoExcecaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_item_motDesICMS_id', '=', $this->id));
        return NaturezaOperacaoExcecao::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraItenss
     */
    public function getNotaFiscalCompraItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_item_motDesICMS_id', '=', $this->id));
        return NotaFiscalCompraItens::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalItenss
     */
    public function getNotafiscalItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_item_motDesICMS_id', '=', $this->id));
        return NotafiscalItens::getObjects( $criteria );
    }

    public function set_natureza_operacao_natureza_operacao_finalidade_to_string($natureza_operacao_natureza_operacao_finalidade_to_string)
    {
        if(is_array($natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            $values = NaturezaOperacaoFinalidade::where('id', 'in', $natureza_operacao_natureza_operacao_finalidade_to_string)->getIndexedArray('nome', 'nome');
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = $natureza_operacao_natureza_operacao_finalidade_to_string;
        }

        $this->vdata['natureza_operacao_natureza_operacao_finalidade_to_string'] = $this->natureza_operacao_natureza_operacao_finalidade_to_string;
    }

    public function get_natureza_operacao_natureza_operacao_finalidade_to_string()
    {
        if(!empty($this->natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            return $this->natureza_operacao_natureza_operacao_finalidade_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('natureza_operacao_finalidade_id','{natureza_operacao_finalidade->nome}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_to_string($natureza_operacao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_to_string = $natureza_operacao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_to_string'] = $this->natureza_operacao_cst_icms_to_string;
    }

    public function get_natureza_operacao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_to_string))
        {
            return $this->natureza_operacao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_nao_contribuinte_to_string($natureza_operacao_cst_icms_nao_contribuinte_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_nao_contribuinte_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = $natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_nao_contribuinte_to_string'] = $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
    }

    public function get_natureza_operacao_cst_icms_nao_contribuinte_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            return $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_icms_nao_contribuinte_id','{cst_icms_nao_contribuinte->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_ipi_to_string($natureza_operacao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_ipi_to_string = $natureza_operacao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_cst_ipi_to_string'] = $this->natureza_operacao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_pis_to_string($natureza_operacao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_pis_to_string = $natureza_operacao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_cst_pis_to_string'] = $this->natureza_operacao_cst_pis_to_string;
    }

    public function get_natureza_operacao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_cst_pis_to_string))
        {
            return $this->natureza_operacao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_cofins_to_string($natureza_operacao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_cofins_to_string = $natureza_operacao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_cst_cofins_to_string'] = $this->natureza_operacao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_consumidor_final_to_string($natureza_operacao_consumidor_final_to_string)
    {
        if(is_array($natureza_operacao_consumidor_final_to_string))
        {
            $values = Resposta::where('id', 'in', $natureza_operacao_consumidor_final_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_consumidor_final_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_consumidor_final_to_string = $natureza_operacao_consumidor_final_to_string;
        }

        $this->vdata['natureza_operacao_consumidor_final_to_string'] = $this->natureza_operacao_consumidor_final_to_string;
    }

    public function get_natureza_operacao_consumidor_final_to_string()
    {
        if(!empty($this->natureza_operacao_consumidor_final_to_string))
        {
            return $this->natureza_operacao_consumidor_final_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('consumidor_final_id','{consumidor_final->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbc_to_string($natureza_operacao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbc_to_string = $natureza_operacao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbcst_to_string($natureza_operacao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = $natureza_operacao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_motDesICMS_to_string($natureza_operacao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_natureza_operacao_to_string($natureza_operacao_excecao_natureza_operacao_to_string)
    {
        if(is_array($natureza_operacao_excecao_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $natureza_operacao_excecao_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natureza_operacao_to_string = $natureza_operacao_excecao_natureza_operacao_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natureza_operacao_to_string'] = $this->natureza_operacao_excecao_natureza_operacao_to_string;
    }

    public function get_natureza_operacao_excecao_natureza_operacao_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natureza_operacao_to_string))
        {
            return $this->natureza_operacao_excecao_natureza_operacao_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_natop_excecao_tributo_to_string($natureza_operacao_excecao_natop_excecao_tributo_to_string)
    {
        if(is_array($natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            $values = NatopExcecaoTributo::where('id', 'in', $natureza_operacao_excecao_natop_excecao_tributo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_natop_excecao_tributo_to_string = $natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }

        $this->vdata['natureza_operacao_excecao_natop_excecao_tributo_to_string'] = $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
    }

    public function get_natureza_operacao_excecao_natop_excecao_tributo_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_natop_excecao_tributo_to_string))
        {
            return $this->natureza_operacao_excecao_natop_excecao_tributo_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('natop_excecao_tributo_id','{natop_excecao_tributo->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_pis_to_string($natureza_operacao_excecao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_excecao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_pis_to_string = $natureza_operacao_excecao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_pis_to_string'] = $this->natureza_operacao_excecao_cst_pis_to_string;
    }

    public function get_natureza_operacao_excecao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_pis_to_string))
        {
            return $this->natureza_operacao_excecao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_ipi_to_string($natureza_operacao_excecao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_excecao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_ipi_to_string = $natureza_operacao_excecao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_ipi_to_string'] = $this->natureza_operacao_excecao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_excecao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_excecao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_icms_to_string($natureza_operacao_excecao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_excecao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_icms_to_string = $natureza_operacao_excecao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_icms_to_string'] = $this->natureza_operacao_excecao_cst_icms_to_string;
    }

    public function get_natureza_operacao_excecao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_icms_to_string))
        {
            return $this->natureza_operacao_excecao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_cst_cofins_to_string($natureza_operacao_excecao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_excecao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_excecao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_cst_cofins_to_string = $natureza_operacao_excecao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_excecao_cst_cofins_to_string'] = $this->natureza_operacao_excecao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_excecao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_excecao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbc_to_string($natureza_operacao_excecao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string = $natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_modbcst_to_string($natureza_operacao_excecao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string = $natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_excecao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacaoExcecao::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_to_string($nota_fiscal_compra_itens_produto_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $nota_fiscal_compra_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_to_string = $nota_fiscal_compra_itens_produto_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_to_string'] = $this->nota_fiscal_compra_itens_produto_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            $values = NotaFiscalCompraItensSituacao::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_itens_situacao_id','{nota_fiscal_compra_itens_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            $values = NotafiscalItemIndtot::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_indtot_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_indtot_id','{notafiscal_item_indtot->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_orig_to_string($nota_fiscal_compra_itens_notafiscal_item_orig_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = $nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_orig_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_modbc_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_estoque_deposito_to_string($nota_fiscal_compra_itens_estoque_deposito_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $nota_fiscal_compra_itens_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = $nota_fiscal_compra_itens_estoque_deposito_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_estoque_deposito_to_string'] = $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
    }

    public function get_nota_fiscal_compra_itens_estoque_deposito_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            return $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_lote_to_string($nota_fiscal_compra_itens_produto_lote_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $nota_fiscal_compra_itens_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->nota_fiscal_compra_itens_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_lote_to_string = $nota_fiscal_compra_itens_produto_lote_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_lote_to_string'] = $this->nota_fiscal_compra_itens_produto_lote_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_lote_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_lote_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_lote_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_to_string($notafiscal_itens_notafiscal_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_itens_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_to_string = $notafiscal_itens_notafiscal_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_to_string'] = $this->notafiscal_itens_notafiscal_to_string;
    }

    public function get_notafiscal_itens_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_to_string))
        {
            return $this->notafiscal_itens_notafiscal_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_produto_to_string($notafiscal_itens_produto_to_string)
    {
        if(is_array($notafiscal_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $notafiscal_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_produto_to_string = $notafiscal_itens_produto_to_string;
        }

        $this->vdata['notafiscal_itens_produto_to_string'] = $this->notafiscal_itens_produto_to_string;
    }

    public function get_notafiscal_itens_produto_to_string()
    {
        if(!empty($this->notafiscal_itens_produto_to_string))
        {
            return $this->notafiscal_itens_produto_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_indtot_to_string($notafiscal_itens_notafiscal_item_indtot_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_indtot_to_string))
        {
            $values = NotafiscalItemIndtot::where('id', 'in', $notafiscal_itens_notafiscal_item_indtot_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_indtot_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_indtot_to_string = $notafiscal_itens_notafiscal_item_indtot_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_indtot_to_string'] = $this->notafiscal_itens_notafiscal_item_indtot_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_indtot_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_indtot_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_indtot_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_indtot_id','{notafiscal_item_indtot->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_orig_to_string($notafiscal_itens_notafiscal_item_orig_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $notafiscal_itens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_orig_to_string = $notafiscal_itens_notafiscal_item_orig_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_orig_to_string'] = $this->notafiscal_itens_notafiscal_item_orig_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_orig_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_orig_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_modbc_to_string($notafiscal_itens_notafiscal_item_modbc_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $notafiscal_itens_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_modbc_to_string = $notafiscal_itens_notafiscal_item_modbc_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_modbc_to_string'] = $this->notafiscal_itens_notafiscal_item_modbc_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_modbc_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_modbc_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_motDesICMS_to_string($notafiscal_itens_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $notafiscal_itens_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string = $notafiscal_itens_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_motDesICMS_to_string'] = $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_motDesICMS_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NotafiscalItens::where('notafiscal_item_motDesICMS_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    
}

