<?php

class NotafiscalPag extends TRecord
{
    const TABLENAME  = 'notafiscal_pag';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $notafiscal;
    private $notafiscal_tpag;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('notafiscal_id');
        parent::addAttribute('notafiscal_tpag_id');
        parent::addAttribute('tpag');
        parent::addAttribute('vpag');
        parent::addAttribute('xpag');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_notafiscal
     * Sample of usage: $var->notafiscal = $object;
     * @param $object Instance of Notafiscal
     */
    public function set_notafiscal(Notafiscal $object)
    {
        $this->notafiscal = $object;
        $this->notafiscal_id = $object->id;
    }

    /**
     * Method get_notafiscal
     * Sample of usage: $var->notafiscal->attribute;
     * @returns Notafiscal instance
     */
    public function get_notafiscal()
    {
    
        // loads the associated object
        if (empty($this->notafiscal))
            $this->notafiscal = new Notafiscal($this->notafiscal_id);
    
        // returns the associated object
        return $this->notafiscal;
    }
    /**
     * Method set_notafiscal_tpag
     * Sample of usage: $var->notafiscal_tpag = $object;
     * @param $object Instance of NotafiscalTpag
     */
    public function set_notafiscal_tpag(NotafiscalTpag $object)
    {
        $this->notafiscal_tpag = $object;
        $this->notafiscal_tpag_id = $object->id;
    }

    /**
     * Method get_notafiscal_tpag
     * Sample of usage: $var->notafiscal_tpag->attribute;
     * @returns NotafiscalTpag instance
     */
    public function get_notafiscal_tpag()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tpag))
            $this->notafiscal_tpag = new NotafiscalTpag($this->notafiscal_tpag_id);
    
        // returns the associated object
        return $this->notafiscal_tpag;
    }

    public function store(){
    
        $pagamento = NotafiscalTpag::find($this->notafiscal_tpag_id);
    
        if($pagamento){
            $this->tpag = $pagamento->tpag;        
        }
    
        parent::store();
    }

}

