<?php

class NotafiscalSeries extends TRecord
{
    const TABLENAME  = 'notafiscal_series';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $notafiscal_tipodocumento;
    private $notafiscal_tpamb;
    private $notafiscal_mod;
    private $system_unit;

    

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('serie');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('notafiscal_tpamb_id');
        parent::addAttribute('notafiscal_mod_id');
        parent::addAttribute('sequencial');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('notafiscal_tipodocumento_id');
        parent::addAttribute('deletado_em');
            
    }

    /**
     * Method set_notafiscal_tipodocumento
     * Sample of usage: $var->notafiscal_tipodocumento = $object;
     * @param $object Instance of NotafiscalTipodocumento
     */
    public function set_notafiscal_tipodocumento(NotafiscalTipodocumento $object)
    {
        $this->notafiscal_tipodocumento = $object;
        $this->notafiscal_tipodocumento_id = $object->id;
    }

    /**
     * Method get_notafiscal_tipodocumento
     * Sample of usage: $var->notafiscal_tipodocumento->attribute;
     * @returns NotafiscalTipodocumento instance
     */
    public function get_notafiscal_tipodocumento()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tipodocumento))
            $this->notafiscal_tipodocumento = new NotafiscalTipodocumento($this->notafiscal_tipodocumento_id);
    
        // returns the associated object
        return $this->notafiscal_tipodocumento;
    }
    /**
     * Method set_notafiscal_tpamb
     * Sample of usage: $var->notafiscal_tpamb = $object;
     * @param $object Instance of NotafiscalTpamb
     */
    public function set_notafiscal_tpamb(NotafiscalTpamb $object)
    {
        $this->notafiscal_tpamb = $object;
        $this->notafiscal_tpamb_id = $object->id;
    }

    /**
     * Method get_notafiscal_tpamb
     * Sample of usage: $var->notafiscal_tpamb->attribute;
     * @returns NotafiscalTpamb instance
     */
    public function get_notafiscal_tpamb()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_tpamb))
            $this->notafiscal_tpamb = new NotafiscalTpamb($this->notafiscal_tpamb_id);
    
        // returns the associated object
        return $this->notafiscal_tpamb;
    }
    /**
     * Method set_notafiscal_mod
     * Sample of usage: $var->notafiscal_mod = $object;
     * @param $object Instance of NotafiscalMod
     */
    public function set_notafiscal_mod(NotafiscalMod $object)
    {
        $this->notafiscal_mod = $object;
        $this->notafiscal_mod_id = $object->id;
    }

    /**
     * Method get_notafiscal_mod
     * Sample of usage: $var->notafiscal_mod->attribute;
     * @returns NotafiscalMod instance
     */
    public function get_notafiscal_mod()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_mod))
            $this->notafiscal_mod = new NotafiscalMod($this->notafiscal_mod_id);
    
        // returns the associated object
        return $this->notafiscal_mod;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getNotafiscalTipodocSeriess
     */
    public function getNotafiscalTipodocSeriess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_series_id', '=', $this->id));
        return NotafiscalTipodocSeries::getObjects( $criteria );
    }

    public function set_notafiscal_tipodoc_series_notafiscal_series_to_string($notafiscal_tipodoc_series_notafiscal_series_to_string)
    {
        if(is_array($notafiscal_tipodoc_series_notafiscal_series_to_string))
        {
            $values = NotafiscalSeries::where('id', 'in', $notafiscal_tipodoc_series_notafiscal_series_to_string)->getIndexedArray('serie', 'serie');
            $this->notafiscal_tipodoc_series_notafiscal_series_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_tipodoc_series_notafiscal_series_to_string = $notafiscal_tipodoc_series_notafiscal_series_to_string;
        }

        $this->vdata['notafiscal_tipodoc_series_notafiscal_series_to_string'] = $this->notafiscal_tipodoc_series_notafiscal_series_to_string;
    }

    public function get_notafiscal_tipodoc_series_notafiscal_series_to_string()
    {
        if(!empty($this->notafiscal_tipodoc_series_notafiscal_series_to_string))
        {
            return $this->notafiscal_tipodoc_series_notafiscal_series_to_string;
        }
    
        $values = NotafiscalTipodocSeries::where('notafiscal_series_id', '=', $this->id)->getIndexedArray('notafiscal_series_id','{notafiscal_series->serie}');
        return implode(', ', $values);
    }

    public function set_notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string($notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string)
    {
        if(is_array($notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string = $notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string'] = $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string;
    }

    public function get_notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string))
        {
            return $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotafiscalTipodocSeries::where('notafiscal_series_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    
}

