<?php

class NotafiscalTipodocumento extends TRecord
{
    const TABLENAME  = 'notafiscal_tipodocumento';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const Entrada = '1';
    const Saida = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getNotafiscals
     */
    public function getNotafiscals()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('nf_tipodocumento_id', '=', $this->id));
        return Notafiscal::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompras
     */
    public function getNotaFiscalCompras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_tipodocumento_id', '=', $this->id));
        return NotaFiscalCompra::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalSeriess
     */
    public function getNotafiscalSeriess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_tipodocumento_id', '=', $this->id));
        return NotafiscalSeries::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalTipodocSeriess
     */
    public function getNotafiscalTipodocSeriess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_tipodocumento_id', '=', $this->id));
        return NotafiscalTipodocSeries::getObjects( $criteria );
    }

    public function set_notafiscal_system_unit_to_string($notafiscal_system_unit_to_string)
    {
        if(is_array($notafiscal_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_system_unit_to_string = $notafiscal_system_unit_to_string;
        }

        $this->vdata['notafiscal_system_unit_to_string'] = $this->notafiscal_system_unit_to_string;
    }

    public function get_notafiscal_system_unit_to_string()
    {
        if(!empty($this->notafiscal_system_unit_to_string))
        {
            return $this->notafiscal_system_unit_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_cliente_to_string($notafiscal_cliente_to_string)
    {
        if(is_array($notafiscal_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $notafiscal_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_cliente_to_string = $notafiscal_cliente_to_string;
        }

        $this->vdata['notafiscal_cliente_to_string'] = $this->notafiscal_cliente_to_string;
    }

    public function get_notafiscal_cliente_to_string()
    {
        if(!empty($this->notafiscal_cliente_to_string))
        {
            return $this->notafiscal_cliente_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_venda_to_string($notafiscal_venda_to_string)
    {
        if(is_array($notafiscal_venda_to_string))
        {
            $values = Venda::where('id', 'in', $notafiscal_venda_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_venda_to_string = $notafiscal_venda_to_string;
        }

        $this->vdata['notafiscal_venda_to_string'] = $this->notafiscal_venda_to_string;
    }

    public function get_notafiscal_venda_to_string()
    {
        if(!empty($this->notafiscal_venda_to_string))
        {
            return $this->notafiscal_venda_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_nf_tipodocumento_to_string($notafiscal_nf_tipodocumento_to_string)
    {
        if(is_array($notafiscal_nf_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_nf_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_nf_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_nf_tipodocumento_to_string = $notafiscal_nf_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_nf_tipodocumento_to_string'] = $this->notafiscal_nf_tipodocumento_to_string;
    }

    public function get_notafiscal_nf_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_nf_tipodocumento_to_string))
        {
            return $this->notafiscal_nf_tipodocumento_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('nf_tipodocumento_id','{nf_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_situacao_to_string($notafiscal_notafiscal_situacao_to_string)
    {
        if(is_array($notafiscal_notafiscal_situacao_to_string))
        {
            $values = NotafiscalSituacao::where('id', 'in', $notafiscal_notafiscal_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_situacao_to_string = $notafiscal_notafiscal_situacao_to_string;
        }

        $this->vdata['notafiscal_notafiscal_situacao_to_string'] = $this->notafiscal_notafiscal_situacao_to_string;
    }

    public function get_notafiscal_notafiscal_situacao_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_situacao_to_string))
        {
            return $this->notafiscal_notafiscal_situacao_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_situacao_id','{notafiscal_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_crt_to_string($notafiscal_notafiscal_crt_to_string)
    {
        if(is_array($notafiscal_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $notafiscal_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_crt_to_string = $notafiscal_notafiscal_crt_to_string;
        }

        $this->vdata['notafiscal_notafiscal_crt_to_string'] = $this->notafiscal_notafiscal_crt_to_string;
    }

    public function get_notafiscal_notafiscal_crt_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_crt_to_string))
        {
            return $this->notafiscal_notafiscal_crt_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indiedest_to_string($notafiscal_notafiscal_indiedest_to_string)
    {
        if(is_array($notafiscal_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $notafiscal_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indiedest_to_string = $notafiscal_notafiscal_indiedest_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indiedest_to_string'] = $this->notafiscal_notafiscal_indiedest_to_string;
    }

    public function get_notafiscal_notafiscal_indiedest_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indiedest_to_string))
        {
            return $this->notafiscal_notafiscal_indiedest_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscaldest_to_string($notafiscal_notafiscaldest_to_string)
    {
        if(is_array($notafiscal_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $notafiscal_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscaldest_to_string = $notafiscal_notafiscaldest_to_string;
        }

        $this->vdata['notafiscal_notafiscaldest_to_string'] = $this->notafiscal_notafiscaldest_to_string;
    }

    public function get_notafiscal_notafiscaldest_to_string()
    {
        if(!empty($this->notafiscal_notafiscaldest_to_string))
        {
            return $this->notafiscal_notafiscaldest_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpimp_to_string($notafiscal_notafiscal_tpimp_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $notafiscal_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpimp_to_string = $notafiscal_notafiscal_tpimp_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpimp_to_string'] = $this->notafiscal_notafiscal_tpimp_to_string;
    }

    public function get_notafiscal_notafiscal_tpimp_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpimp_to_string))
        {
            return $this->notafiscal_notafiscal_tpimp_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpemis_to_string($notafiscal_notafiscal_tpemis_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpemis_to_string))
        {
            $values = NotafiscalTpemis::where('id', 'in', $notafiscal_notafiscal_tpemis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpemis_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpemis_to_string = $notafiscal_notafiscal_tpemis_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpemis_to_string'] = $this->notafiscal_notafiscal_tpemis_to_string;
    }

    public function get_notafiscal_notafiscal_tpemis_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpemis_to_string))
        {
            return $this->notafiscal_notafiscal_tpemis_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tpemis_id','{notafiscal_tpemis->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_finnfe_to_string($notafiscal_notafiscal_finnfe_to_string)
    {
        if(is_array($notafiscal_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $notafiscal_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_finnfe_to_string = $notafiscal_notafiscal_finnfe_to_string;
        }

        $this->vdata['notafiscal_notafiscal_finnfe_to_string'] = $this->notafiscal_notafiscal_finnfe_to_string;
    }

    public function get_notafiscal_notafiscal_finnfe_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_finnfe_to_string))
        {
            return $this->notafiscal_notafiscal_finnfe_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indfinal_to_string($notafiscal_notafiscal_indfinal_to_string)
    {
        if(is_array($notafiscal_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $notafiscal_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indfinal_to_string = $notafiscal_notafiscal_indfinal_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indfinal_to_string'] = $this->notafiscal_notafiscal_indfinal_to_string;
    }

    public function get_notafiscal_notafiscal_indfinal_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indfinal_to_string))
        {
            return $this->notafiscal_notafiscal_indfinal_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpres_to_string($notafiscal_notafiscal_indpres_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $notafiscal_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpres_to_string = $notafiscal_notafiscal_indpres_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpres_to_string'] = $this->notafiscal_notafiscal_indpres_to_string;
    }

    public function get_notafiscal_notafiscal_indpres_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpres_to_string))
        {
            return $this->notafiscal_notafiscal_indpres_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpag_to_string($notafiscal_notafiscal_indpag_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $notafiscal_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpag_to_string = $notafiscal_notafiscal_indpag_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpag_to_string'] = $this->notafiscal_notafiscal_indpag_to_string;
    }

    public function get_notafiscal_notafiscal_indpag_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpag_to_string))
        {
            return $this->notafiscal_notafiscal_indpag_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dispositivos_to_string($notafiscal_dispositivos_to_string)
    {
        if(is_array($notafiscal_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $notafiscal_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dispositivos_to_string = $notafiscal_dispositivos_to_string;
        }

        $this->vdata['notafiscal_dispositivos_to_string'] = $this->notafiscal_dispositivos_to_string;
    }

    public function get_notafiscal_dispositivos_to_string()
    {
        if(!empty($this->notafiscal_dispositivos_to_string))
        {
            return $this->notafiscal_dispositivos_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpamb_to_string($notafiscal_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpamb_to_string = $notafiscal_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpamb_to_string'] = $this->notafiscal_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_notafiscal_tpamb_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_mod_to_string($notafiscal_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_mod_to_string = $notafiscal_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_notafiscal_mod_to_string'] = $this->notafiscal_notafiscal_mod_to_string;
    }

    public function get_notafiscal_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_mod_to_string))
        {
            return $this->notafiscal_notafiscal_mod_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_modfrete_to_string($notafiscal_notafiscal_modfrete_to_string)
    {
        if(is_array($notafiscal_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $notafiscal_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_modfrete_to_string = $notafiscal_notafiscal_modfrete_to_string;
        }

        $this->vdata['notafiscal_notafiscal_modfrete_to_string'] = $this->notafiscal_notafiscal_modfrete_to_string;
    }

    public function get_notafiscal_notafiscal_modfrete_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_modfrete_to_string))
        {
            return $this->notafiscal_notafiscal_modfrete_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_natureza_operacao_to_string($notafiscal_natureza_operacao_to_string)
    {
        if(is_array($notafiscal_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $notafiscal_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_natureza_operacao_to_string = $notafiscal_natureza_operacao_to_string;
        }

        $this->vdata['notafiscal_natureza_operacao_to_string'] = $this->notafiscal_natureza_operacao_to_string;
    }

    public function get_notafiscal_natureza_operacao_to_string()
    {
        if(!empty($this->notafiscal_natureza_operacao_to_string))
        {
            return $this->notafiscal_natureza_operacao_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_movimentacao_origem_to_string($notafiscal_movimentacao_origem_to_string)
    {
        if(is_array($notafiscal_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $notafiscal_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_movimentacao_origem_to_string = $notafiscal_movimentacao_origem_to_string;
        }

        $this->vdata['notafiscal_movimentacao_origem_to_string'] = $this->notafiscal_movimentacao_origem_to_string;
    }

    public function get_notafiscal_movimentacao_origem_to_string()
    {
        if(!empty($this->notafiscal_movimentacao_origem_to_string))
        {
            return $this->notafiscal_movimentacao_origem_to_string;
        }
    
        $values = Notafiscal::where('nf_tipodocumento_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_system_unit_to_string($nota_fiscal_compra_system_unit_to_string)
    {
        if(is_array($nota_fiscal_compra_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $nota_fiscal_compra_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->nota_fiscal_compra_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_system_unit_to_string = $nota_fiscal_compra_system_unit_to_string;
        }

        $this->vdata['nota_fiscal_compra_system_unit_to_string'] = $this->nota_fiscal_compra_system_unit_to_string;
    }

    public function get_nota_fiscal_compra_system_unit_to_string()
    {
        if(!empty($this->nota_fiscal_compra_system_unit_to_string))
        {
            return $this->nota_fiscal_compra_system_unit_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_fornecedor_to_string($nota_fiscal_compra_fornecedor_to_string)
    {
        if(is_array($nota_fiscal_compra_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $nota_fiscal_compra_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_fornecedor_to_string = $nota_fiscal_compra_fornecedor_to_string;
        }

        $this->vdata['nota_fiscal_compra_fornecedor_to_string'] = $this->nota_fiscal_compra_fornecedor_to_string;
    }

    public function get_nota_fiscal_compra_fornecedor_to_string()
    {
        if(!empty($this->nota_fiscal_compra_fornecedor_to_string))
        {
            return $this->nota_fiscal_compra_fornecedor_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tipodocumento_to_string($nota_fiscal_compra_notafiscal_tipodocumento_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $nota_fiscal_compra_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = $nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tipodocumento_to_string'] = $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            $values = NotaFiscalCompraSituacao::where('id', 'in', $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_nota_fiscal_compra_situacao_to_string'] = $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
    }

    public function get_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            return $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_situacao_id','{nota_fiscal_compra_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_crt_to_string($nota_fiscal_compra_notafiscal_crt_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $nota_fiscal_compra_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_crt_to_string = $nota_fiscal_compra_notafiscal_crt_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_crt_to_string'] = $this->nota_fiscal_compra_notafiscal_crt_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_crt_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_crt_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_crt_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indiedest_to_string($nota_fiscal_compra_notafiscal_indiedest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $nota_fiscal_compra_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = $nota_fiscal_compra_notafiscal_indiedest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indiedest_to_string'] = $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indiedest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscaldest_to_string($nota_fiscal_compra_notafiscaldest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $nota_fiscal_compra_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscaldest_to_string = $nota_fiscal_compra_notafiscaldest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscaldest_to_string'] = $this->nota_fiscal_compra_notafiscaldest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscaldest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscaldest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscaldest_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tpimp_to_string($nota_fiscal_compra_notafiscal_tpimp_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $nota_fiscal_compra_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = $nota_fiscal_compra_notafiscal_tpimp_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tpimp_to_string'] = $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tpimp_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_finnfe_to_string($nota_fiscal_compra_notafiscal_finnfe_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $nota_fiscal_compra_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = $nota_fiscal_compra_notafiscal_finnfe_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_finnfe_to_string'] = $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_finnfe_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indfinal_to_string($nota_fiscal_compra_notafiscal_indfinal_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $nota_fiscal_compra_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = $nota_fiscal_compra_notafiscal_indfinal_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indfinal_to_string'] = $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indfinal_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpres_to_string($nota_fiscal_compra_notafiscal_indpres_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $nota_fiscal_compra_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = $nota_fiscal_compra_notafiscal_indpres_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpres_to_string'] = $this->nota_fiscal_compra_notafiscal_indpres_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpres_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpres_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpag_to_string($nota_fiscal_compra_notafiscal_indpag_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $nota_fiscal_compra_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = $nota_fiscal_compra_notafiscal_indpag_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpag_to_string'] = $this->nota_fiscal_compra_notafiscal_indpag_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpag_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpag_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_mod_to_string($nota_fiscal_compra_notafiscal_mod_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $nota_fiscal_compra_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_mod_to_string = $nota_fiscal_compra_notafiscal_mod_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_mod_to_string'] = $this->nota_fiscal_compra_notafiscal_mod_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_mod_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_mod_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_mod_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_modfrete_to_string($nota_fiscal_compra_notafiscal_modfrete_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $nota_fiscal_compra_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = $nota_fiscal_compra_notafiscal_modfrete_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_modfrete_to_string'] = $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_modfrete_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
        }
    
        $values = NotaFiscalCompra::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_system_unit_to_string($notafiscal_series_system_unit_to_string)
    {
        if(is_array($notafiscal_series_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_series_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_series_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_system_unit_to_string = $notafiscal_series_system_unit_to_string;
        }

        $this->vdata['notafiscal_series_system_unit_to_string'] = $this->notafiscal_series_system_unit_to_string;
    }

    public function get_notafiscal_series_system_unit_to_string()
    {
        if(!empty($this->notafiscal_series_system_unit_to_string))
        {
            return $this->notafiscal_series_system_unit_to_string;
        }
    
        $values = NotafiscalSeries::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_notafiscal_tpamb_to_string($notafiscal_series_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_series_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_series_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_series_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_notafiscal_tpamb_to_string = $notafiscal_series_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_series_notafiscal_tpamb_to_string'] = $this->notafiscal_series_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_series_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_series_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_series_notafiscal_tpamb_to_string;
        }
    
        $values = NotafiscalSeries::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_notafiscal_mod_to_string($notafiscal_series_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_series_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_series_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_series_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_notafiscal_mod_to_string = $notafiscal_series_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_series_notafiscal_mod_to_string'] = $this->notafiscal_series_notafiscal_mod_to_string;
    }

    public function get_notafiscal_series_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_series_notafiscal_mod_to_string))
        {
            return $this->notafiscal_series_notafiscal_mod_to_string;
        }
    
        $values = NotafiscalSeries::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_notafiscal_tipodocumento_to_string($notafiscal_series_notafiscal_tipodocumento_to_string)
    {
        if(is_array($notafiscal_series_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_series_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_series_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_notafiscal_tipodocumento_to_string = $notafiscal_series_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_series_notafiscal_tipodocumento_to_string'] = $this->notafiscal_series_notafiscal_tipodocumento_to_string;
    }

    public function get_notafiscal_series_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_series_notafiscal_tipodocumento_to_string))
        {
            return $this->notafiscal_series_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotafiscalSeries::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_tipodoc_series_notafiscal_series_to_string($notafiscal_tipodoc_series_notafiscal_series_to_string)
    {
        if(is_array($notafiscal_tipodoc_series_notafiscal_series_to_string))
        {
            $values = NotafiscalSeries::where('id', 'in', $notafiscal_tipodoc_series_notafiscal_series_to_string)->getIndexedArray('serie', 'serie');
            $this->notafiscal_tipodoc_series_notafiscal_series_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_tipodoc_series_notafiscal_series_to_string = $notafiscal_tipodoc_series_notafiscal_series_to_string;
        }

        $this->vdata['notafiscal_tipodoc_series_notafiscal_series_to_string'] = $this->notafiscal_tipodoc_series_notafiscal_series_to_string;
    }

    public function get_notafiscal_tipodoc_series_notafiscal_series_to_string()
    {
        if(!empty($this->notafiscal_tipodoc_series_notafiscal_series_to_string))
        {
            return $this->notafiscal_tipodoc_series_notafiscal_series_to_string;
        }
    
        $values = NotafiscalTipodocSeries::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_series_id','{notafiscal_series->serie}');
        return implode(', ', $values);
    }

    public function set_notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string($notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string)
    {
        if(is_array($notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string = $notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string'] = $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string;
    }

    public function get_notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string))
        {
            return $this->notafiscal_tipodoc_series_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotafiscalTipodocSeries::where('notafiscal_tipodocumento_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    
}

