<?php

class NotafiscalTpag extends TRecord
{
    const TABLENAME  = 'notafiscal_tpag';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Dinheiro = '1';
    const Cheque = '2';
    const CartaoDeCredito = '3';
    const CartaoDeDebito = '4';
    const CreditoLoja = '5';
    const ValeAlimentacao = '6';
    const ValeRefeicao = '7';
    const ValePresente = '8';
    const ValeCombustivel = '9';
    const BoletoBancario = '10';
    const SemPagamento = '11';
    const Outros = '12';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('tpag');
        parent::addAttribute('criado_em');
        parent::addAttribute('descricao');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getFormaPagamentos
     */
    public function getFormaPagamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_tpag_id', '=', $this->id));
        return FormaPagamento::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraPags
     */
    public function getNotaFiscalCompraPags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_tpag_id', '=', $this->id));
        return NotaFiscalCompraPag::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalPags
     */
    public function getNotafiscalPags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('notafiscal_tpag_id', '=', $this->id));
        return NotafiscalPag::getObjects( $criteria );
    }

    public function set_forma_pagamento_tipo_documento_to_string($forma_pagamento_tipo_documento_to_string)
    {
        if(is_array($forma_pagamento_tipo_documento_to_string))
        {
            $values = TipoDocumento::where('id', 'in', $forma_pagamento_tipo_documento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->forma_pagamento_tipo_documento_to_string = implode(', ', $values);
        }
        else
        {
            $this->forma_pagamento_tipo_documento_to_string = $forma_pagamento_tipo_documento_to_string;
        }

        $this->vdata['forma_pagamento_tipo_documento_to_string'] = $this->forma_pagamento_tipo_documento_to_string;
    }

    public function get_forma_pagamento_tipo_documento_to_string()
    {
        if(!empty($this->forma_pagamento_tipo_documento_to_string))
        {
            return $this->forma_pagamento_tipo_documento_to_string;
        }
    
        $values = FormaPagamento::where('notafiscal_tpag_id', '=', $this->id)->getIndexedArray('tipo_documento_id','{tipo_documento->descricao}');
        return implode(', ', $values);
    }

    public function set_forma_pagamento_meio_pagamento_tef_to_string($forma_pagamento_meio_pagamento_tef_to_string)
    {
        if(is_array($forma_pagamento_meio_pagamento_tef_to_string))
        {
            $values = MeioPagamentoTef::where('id', 'in', $forma_pagamento_meio_pagamento_tef_to_string)->getIndexedArray('descricao', 'descricao');
            $this->forma_pagamento_meio_pagamento_tef_to_string = implode(', ', $values);
        }
        else
        {
            $this->forma_pagamento_meio_pagamento_tef_to_string = $forma_pagamento_meio_pagamento_tef_to_string;
        }

        $this->vdata['forma_pagamento_meio_pagamento_tef_to_string'] = $this->forma_pagamento_meio_pagamento_tef_to_string;
    }

    public function get_forma_pagamento_meio_pagamento_tef_to_string()
    {
        if(!empty($this->forma_pagamento_meio_pagamento_tef_to_string))
        {
            return $this->forma_pagamento_meio_pagamento_tef_to_string;
        }
    
        $values = FormaPagamento::where('notafiscal_tpag_id', '=', $this->id)->getIndexedArray('meio_pagamento_tef_id','{meio_pagamento_tef->descricao}');
        return implode(', ', $values);
    }

    public function set_forma_pagamento_notafiscal_tpag_to_string($forma_pagamento_notafiscal_tpag_to_string)
    {
        if(is_array($forma_pagamento_notafiscal_tpag_to_string))
        {
            $values = NotafiscalTpag::where('id', 'in', $forma_pagamento_notafiscal_tpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->forma_pagamento_notafiscal_tpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->forma_pagamento_notafiscal_tpag_to_string = $forma_pagamento_notafiscal_tpag_to_string;
        }

        $this->vdata['forma_pagamento_notafiscal_tpag_to_string'] = $this->forma_pagamento_notafiscal_tpag_to_string;
    }

    public function get_forma_pagamento_notafiscal_tpag_to_string()
    {
        if(!empty($this->forma_pagamento_notafiscal_tpag_to_string))
        {
            return $this->forma_pagamento_notafiscal_tpag_to_string;
        }
    
        $values = FormaPagamento::where('notafiscal_tpag_id', '=', $this->id)->getIndexedArray('notafiscal_tpag_id','{notafiscal_tpag->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_pag_nota_fiscal_compra_to_string($nota_fiscal_compra_pag_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_pag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_pag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string = $nota_fiscal_compra_pag_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_pag_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_pag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_pag_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraPag::where('notafiscal_tpag_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_pag_notafiscal_tpag_to_string($nota_fiscal_compra_pag_notafiscal_tpag_to_string)
    {
        if(is_array($nota_fiscal_compra_pag_notafiscal_tpag_to_string))
        {
            $values = NotafiscalTpag::where('id', 'in', $nota_fiscal_compra_pag_notafiscal_tpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string = $nota_fiscal_compra_pag_notafiscal_tpag_to_string;
        }

        $this->vdata['nota_fiscal_compra_pag_notafiscal_tpag_to_string'] = $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string;
    }

    public function get_nota_fiscal_compra_pag_notafiscal_tpag_to_string()
    {
        if(!empty($this->nota_fiscal_compra_pag_notafiscal_tpag_to_string))
        {
            return $this->nota_fiscal_compra_pag_notafiscal_tpag_to_string;
        }
    
        $values = NotaFiscalCompraPag::where('notafiscal_tpag_id', '=', $this->id)->getIndexedArray('notafiscal_tpag_id','{notafiscal_tpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_pag_notafiscal_to_string($notafiscal_pag_notafiscal_to_string)
    {
        if(is_array($notafiscal_pag_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_pag_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_pag_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_pag_notafiscal_to_string = $notafiscal_pag_notafiscal_to_string;
        }

        $this->vdata['notafiscal_pag_notafiscal_to_string'] = $this->notafiscal_pag_notafiscal_to_string;
    }

    public function get_notafiscal_pag_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_pag_notafiscal_to_string))
        {
            return $this->notafiscal_pag_notafiscal_to_string;
        }
    
        $values = NotafiscalPag::where('notafiscal_tpag_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_pag_notafiscal_tpag_to_string($notafiscal_pag_notafiscal_tpag_to_string)
    {
        if(is_array($notafiscal_pag_notafiscal_tpag_to_string))
        {
            $values = NotafiscalTpag::where('id', 'in', $notafiscal_pag_notafiscal_tpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_pag_notafiscal_tpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_pag_notafiscal_tpag_to_string = $notafiscal_pag_notafiscal_tpag_to_string;
        }

        $this->vdata['notafiscal_pag_notafiscal_tpag_to_string'] = $this->notafiscal_pag_notafiscal_tpag_to_string;
    }

    public function get_notafiscal_pag_notafiscal_tpag_to_string()
    {
        if(!empty($this->notafiscal_pag_notafiscal_tpag_to_string))
        {
            return $this->notafiscal_pag_notafiscal_tpag_to_string;
        }
    
        $values = NotafiscalPag::where('notafiscal_tpag_id', '=', $this->id)->getIndexedArray('notafiscal_tpag_id','{notafiscal_tpag->descricao}');
        return implode(', ', $values);
    }

    
}

