<?php

class Orcamento extends TRecord
{
    const TABLENAME  = 'orcamento';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $cliente;
    private $vendedor;
    private $orcamento_situacao;
    private $cliente_contato;
    private $system_unit;
    private $tabela_preco;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('orcamento_situacao_id');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('cliente_id');
        parent::addAttribute('cliente_contato_id');
        parent::addAttribute('data_orcamento');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('observacao');
        parent::addAttribute('valor_produtos');
        parent::addAttribute('desconto');
        parent::addAttribute('peso_total');
        parent::addAttribute('frete_total');
        parent::addAttribute('valor_total');
        parent::addAttribute('tabela_preco_id');
        parent::addAttribute('justificativa_reprovacao');
    
    }

    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_orcamento_situacao
     * Sample of usage: $var->orcamento_situacao = $object;
     * @param $object Instance of OrcamentoSituacao
     */
    public function set_orcamento_situacao(OrcamentoSituacao $object)
    {
        $this->orcamento_situacao = $object;
        $this->orcamento_situacao_id = $object->id;
    }

    /**
     * Method get_orcamento_situacao
     * Sample of usage: $var->orcamento_situacao->attribute;
     * @returns OrcamentoSituacao instance
     */
    public function get_orcamento_situacao()
    {
    
        // loads the associated object
        if (empty($this->orcamento_situacao))
            $this->orcamento_situacao = new OrcamentoSituacao($this->orcamento_situacao_id);
    
        // returns the associated object
        return $this->orcamento_situacao;
    }
    /**
     * Method set_cliente_contato
     * Sample of usage: $var->cliente_contato = $object;
     * @param $object Instance of ClienteContato
     */
    public function set_cliente_contato(ClienteContato $object)
    {
        $this->cliente_contato = $object;
        $this->cliente_contato_id = $object->id;
    }

    /**
     * Method get_cliente_contato
     * Sample of usage: $var->cliente_contato->attribute;
     * @returns ClienteContato instance
     */
    public function get_cliente_contato()
    {
    
        // loads the associated object
        if (empty($this->cliente_contato))
            $this->cliente_contato = new ClienteContato($this->cliente_contato_id);
    
        // returns the associated object
        return $this->cliente_contato;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_tabela_preco
     * Sample of usage: $var->tabela_preco = $object;
     * @param $object Instance of TabelaPreco
     */
    public function set_tabela_preco(TabelaPreco $object)
    {
        $this->tabela_preco = $object;
        $this->tabela_preco_id = $object->id;
    }

    /**
     * Method get_tabela_preco
     * Sample of usage: $var->tabela_preco->attribute;
     * @returns TabelaPreco instance
     */
    public function get_tabela_preco()
    {
    
        // loads the associated object
        if (empty($this->tabela_preco))
            $this->tabela_preco = new TabelaPreco($this->tabela_preco_id);
    
        // returns the associated object
        return $this->tabela_preco;
    }

    /**
     * Method getNegocios
     */
    public function getNegocios()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('orcamento_id', '=', $this->id));
        return Negocio::getObjects( $criteria );
    }
    /**
     * Method getOrcamentoInteracoess
     */
    public function getOrcamentoInteracoess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('orcamento_id', '=', $this->id));
        return OrcamentoInteracoes::getObjects( $criteria );
    }
    /**
     * Method getOrcamentoItems
     */
    public function getOrcamentoItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('orcamento_id', '=', $this->id));
        return OrcamentoItem::getObjects( $criteria );
    }
    /**
     * Method getOrcamentoSituacaoHistoricos
     */
    public function getOrcamentoSituacaoHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('orcamento_id', '=', $this->id));
        return OrcamentoSituacaoHistorico::getObjects( $criteria );
    }
    /**
     * Method getVendas
     */
    public function getVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('orcamento_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }

    public function set_negocio_system_unit_to_string($negocio_system_unit_to_string)
    {
        if(is_array($negocio_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $negocio_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->negocio_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_system_unit_to_string = $negocio_system_unit_to_string;
        }

        $this->vdata['negocio_system_unit_to_string'] = $this->negocio_system_unit_to_string;
    }

    public function get_negocio_system_unit_to_string()
    {
        if(!empty($this->negocio_system_unit_to_string))
        {
            return $this->negocio_system_unit_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_origem_to_string($negocio_negocio_origem_to_string)
    {
        if(is_array($negocio_negocio_origem_to_string))
        {
            $values = NegocioOrigem::where('id', 'in', $negocio_negocio_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_origem_to_string = $negocio_negocio_origem_to_string;
        }

        $this->vdata['negocio_negocio_origem_to_string'] = $this->negocio_negocio_origem_to_string;
    }

    public function get_negocio_negocio_origem_to_string()
    {
        if(!empty($this->negocio_negocio_origem_to_string))
        {
            return $this->negocio_negocio_origem_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('negocio_origem_id','{negocio_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_to_string($negocio_funil_to_string)
    {
        if(is_array($negocio_funil_to_string))
        {
            $values = Funil::where('id', 'in', $negocio_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_to_string = $negocio_funil_to_string;
        }

        $this->vdata['negocio_funil_to_string'] = $this->negocio_funil_to_string;
    }

    public function get_negocio_funil_to_string()
    {
        if(!empty($this->negocio_funil_to_string))
        {
            return $this->negocio_funil_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_etapas_to_string($negocio_funil_etapas_to_string)
    {
        if(is_array($negocio_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_etapas_to_string = $negocio_funil_etapas_to_string;
        }

        $this->vdata['negocio_funil_etapas_to_string'] = $this->negocio_funil_etapas_to_string;
    }

    public function get_negocio_funil_etapas_to_string()
    {
        if(!empty($this->negocio_funil_etapas_to_string))
        {
            return $this->negocio_funil_etapas_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_motivo_perda_to_string($negocio_negocio_motivo_perda_to_string)
    {
        if(is_array($negocio_negocio_motivo_perda_to_string))
        {
            $values = NegocioMotivoPerda::where('id', 'in', $negocio_negocio_motivo_perda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_motivo_perda_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_motivo_perda_to_string = $negocio_negocio_motivo_perda_to_string;
        }

        $this->vdata['negocio_negocio_motivo_perda_to_string'] = $this->negocio_negocio_motivo_perda_to_string;
    }

    public function get_negocio_negocio_motivo_perda_to_string()
    {
        if(!empty($this->negocio_negocio_motivo_perda_to_string))
        {
            return $this->negocio_negocio_motivo_perda_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('negocio_motivo_perda_id','{negocio_motivo_perda->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_ativo_to_string($negocio_ativo_to_string)
    {
        if(is_array($negocio_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $negocio_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_ativo_to_string = $negocio_ativo_to_string;
        }

        $this->vdata['negocio_ativo_to_string'] = $this->negocio_ativo_to_string;
    }

    public function get_negocio_ativo_to_string()
    {
        if(!empty($this->negocio_ativo_to_string))
        {
            return $this->negocio_ativo_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_fk_arquivado_to_string($negocio_fk_arquivado_to_string)
    {
        if(is_array($negocio_fk_arquivado_to_string))
        {
            $values = Resposta::where('id', 'in', $negocio_fk_arquivado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_fk_arquivado_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_fk_arquivado_to_string = $negocio_fk_arquivado_to_string;
        }

        $this->vdata['negocio_fk_arquivado_to_string'] = $this->negocio_fk_arquivado_to_string;
    }

    public function get_negocio_fk_arquivado_to_string()
    {
        if(!empty($this->negocio_fk_arquivado_to_string))
        {
            return $this->negocio_fk_arquivado_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('arquivado','{fk_arquivado->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_vendedor_to_string($negocio_vendedor_to_string)
    {
        if(is_array($negocio_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $negocio_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_vendedor_to_string = $negocio_vendedor_to_string;
        }

        $this->vdata['negocio_vendedor_to_string'] = $this->negocio_vendedor_to_string;
    }

    public function get_negocio_vendedor_to_string()
    {
        if(!empty($this->negocio_vendedor_to_string))
        {
            return $this->negocio_vendedor_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_orcamento_to_string($negocio_orcamento_to_string)
    {
        if(is_array($negocio_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $negocio_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->negocio_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_orcamento_to_string = $negocio_orcamento_to_string;
        }

        $this->vdata['negocio_orcamento_to_string'] = $this->negocio_orcamento_to_string;
    }

    public function get_negocio_orcamento_to_string()
    {
        if(!empty($this->negocio_orcamento_to_string))
        {
            return $this->negocio_orcamento_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_negocio_cliente_to_string($negocio_cliente_to_string)
    {
        if(is_array($negocio_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $negocio_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_cliente_to_string = $negocio_cliente_to_string;
        }

        $this->vdata['negocio_cliente_to_string'] = $this->negocio_cliente_to_string;
    }

    public function get_negocio_cliente_to_string()
    {
        if(!empty($this->negocio_cliente_to_string))
        {
            return $this->negocio_cliente_to_string;
        }
    
        $values = Negocio::where('orcamento_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_interacoes_orcamento_to_string($orcamento_interacoes_orcamento_to_string)
    {
        if(is_array($orcamento_interacoes_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $orcamento_interacoes_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->orcamento_interacoes_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_interacoes_orcamento_to_string = $orcamento_interacoes_orcamento_to_string;
        }

        $this->vdata['orcamento_interacoes_orcamento_to_string'] = $this->orcamento_interacoes_orcamento_to_string;
    }

    public function get_orcamento_interacoes_orcamento_to_string()
    {
        if(!empty($this->orcamento_interacoes_orcamento_to_string))
        {
            return $this->orcamento_interacoes_orcamento_to_string;
        }
    
        $values = OrcamentoInteracoes::where('orcamento_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_orcamento_item_orcamento_to_string($orcamento_item_orcamento_to_string)
    {
        if(is_array($orcamento_item_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $orcamento_item_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->orcamento_item_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_item_orcamento_to_string = $orcamento_item_orcamento_to_string;
        }

        $this->vdata['orcamento_item_orcamento_to_string'] = $this->orcamento_item_orcamento_to_string;
    }

    public function get_orcamento_item_orcamento_to_string()
    {
        if(!empty($this->orcamento_item_orcamento_to_string))
        {
            return $this->orcamento_item_orcamento_to_string;
        }
    
        $values = OrcamentoItem::where('orcamento_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_orcamento_item_produto_to_string($orcamento_item_produto_to_string)
    {
        if(is_array($orcamento_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $orcamento_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_item_produto_to_string = $orcamento_item_produto_to_string;
        }

        $this->vdata['orcamento_item_produto_to_string'] = $this->orcamento_item_produto_to_string;
    }

    public function get_orcamento_item_produto_to_string()
    {
        if(!empty($this->orcamento_item_produto_to_string))
        {
            return $this->orcamento_item_produto_to_string;
        }
    
        $values = OrcamentoItem::where('orcamento_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_situacao_historico_orcamento_situacao_to_string($orcamento_situacao_historico_orcamento_situacao_to_string)
    {
        if(is_array($orcamento_situacao_historico_orcamento_situacao_to_string))
        {
            $values = OrcamentoSituacao::where('id', 'in', $orcamento_situacao_historico_orcamento_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_situacao_historico_orcamento_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_situacao_historico_orcamento_situacao_to_string = $orcamento_situacao_historico_orcamento_situacao_to_string;
        }

        $this->vdata['orcamento_situacao_historico_orcamento_situacao_to_string'] = $this->orcamento_situacao_historico_orcamento_situacao_to_string;
    }

    public function get_orcamento_situacao_historico_orcamento_situacao_to_string()
    {
        if(!empty($this->orcamento_situacao_historico_orcamento_situacao_to_string))
        {
            return $this->orcamento_situacao_historico_orcamento_situacao_to_string;
        }
    
        $values = OrcamentoSituacaoHistorico::where('orcamento_id', '=', $this->id)->getIndexedArray('orcamento_situacao_id','{orcamento_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_situacao_historico_orcamento_to_string($orcamento_situacao_historico_orcamento_to_string)
    {
        if(is_array($orcamento_situacao_historico_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $orcamento_situacao_historico_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->orcamento_situacao_historico_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_situacao_historico_orcamento_to_string = $orcamento_situacao_historico_orcamento_to_string;
        }

        $this->vdata['orcamento_situacao_historico_orcamento_to_string'] = $this->orcamento_situacao_historico_orcamento_to_string;
    }

    public function get_orcamento_situacao_historico_orcamento_to_string()
    {
        if(!empty($this->orcamento_situacao_historico_orcamento_to_string))
        {
            return $this->orcamento_situacao_historico_orcamento_to_string;
        }
    
        $values = OrcamentoSituacaoHistorico::where('orcamento_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_venda_situacao_to_string($venda_venda_situacao_to_string)
    {
        if(is_array($venda_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_situacao_to_string = $venda_venda_situacao_to_string;
        }

        $this->vdata['venda_venda_situacao_to_string'] = $this->venda_venda_situacao_to_string;
    }

    public function get_venda_venda_situacao_to_string()
    {
        if(!empty($this->venda_venda_situacao_to_string))
        {
            return $this->venda_venda_situacao_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_orcamento_to_string($venda_orcamento_to_string)
    {
        if(is_array($venda_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $venda_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->venda_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_orcamento_to_string = $venda_orcamento_to_string;
        }

        $this->vdata['venda_orcamento_to_string'] = $this->venda_orcamento_to_string;
    }

    public function get_venda_orcamento_to_string()
    {
        if(!empty($this->venda_orcamento_to_string))
        {
            return $this->venda_orcamento_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_vendedor_to_string($venda_vendedor_to_string)
    {
        if(is_array($venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_vendedor_to_string = $venda_vendedor_to_string;
        }

        $this->vdata['venda_vendedor_to_string'] = $this->venda_vendedor_to_string;
    }

    public function get_venda_vendedor_to_string()
    {
        if(!empty($this->venda_vendedor_to_string))
        {
            return $this->venda_vendedor_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_venda_dispositivos_to_string($venda_dispositivos_to_string)
    {
        if(is_array($venda_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $venda_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->venda_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_dispositivos_to_string = $venda_dispositivos_to_string;
        }

        $this->vdata['venda_dispositivos_to_string'] = $this->venda_dispositivos_to_string;
    }

    public function get_venda_dispositivos_to_string()
    {
        if(!empty($this->venda_dispositivos_to_string))
        {
            return $this->venda_dispositivos_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_to_string($venda_cliente_to_string)
    {
        if(is_array($venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_to_string = $venda_cliente_to_string;
        }

        $this->vdata['venda_cliente_to_string'] = $this->venda_cliente_to_string;
    }

    public function get_venda_cliente_to_string()
    {
        if(!empty($this->venda_cliente_to_string))
        {
            return $this->venda_cliente_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_venda_system_unit_to_string($venda_system_unit_to_string)
    {
        if(is_array($venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_system_unit_to_string = $venda_system_unit_to_string;
        }

        $this->vdata['venda_system_unit_to_string'] = $this->venda_system_unit_to_string;
    }

    public function get_venda_system_unit_to_string()
    {
        if(!empty($this->venda_system_unit_to_string))
        {
            return $this->venda_system_unit_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_filial_saida_to_string($venda_filial_saida_to_string)
    {
        if(is_array($venda_filial_saida_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_filial_saida_to_string)->getIndexedArray('name', 'name');
            $this->venda_filial_saida_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_filial_saida_to_string = $venda_filial_saida_to_string;
        }

        $this->vdata['venda_filial_saida_to_string'] = $this->venda_filial_saida_to_string;
    }

    public function get_venda_filial_saida_to_string()
    {
        if(!empty($this->venda_filial_saida_to_string))
        {
            return $this->venda_filial_saida_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('filial_saida_id','{filial_saida->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_modalidade_to_string($venda_venda_modalidade_to_string)
    {
        if(is_array($venda_venda_modalidade_to_string))
        {
            $values = VendaModalidade::where('id', 'in', $venda_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_modalidade_to_string = $venda_venda_modalidade_to_string;
        }

        $this->vdata['venda_venda_modalidade_to_string'] = $this->venda_venda_modalidade_to_string;
    }

    public function get_venda_venda_modalidade_to_string()
    {
        if(!empty($this->venda_venda_modalidade_to_string))
        {
            return $this->venda_venda_modalidade_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('venda_modalidade_id','{venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_tipo_pagamento_to_string($venda_venda_tipo_pagamento_to_string)
    {
        if(is_array($venda_venda_tipo_pagamento_to_string))
        {
            $values = VendaTipoPagamento::where('id', 'in', $venda_venda_tipo_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_tipo_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_tipo_pagamento_to_string = $venda_venda_tipo_pagamento_to_string;
        }

        $this->vdata['venda_venda_tipo_pagamento_to_string'] = $this->venda_venda_tipo_pagamento_to_string;
    }

    public function get_venda_venda_tipo_pagamento_to_string()
    {
        if(!empty($this->venda_venda_tipo_pagamento_to_string))
        {
            return $this->venda_venda_tipo_pagamento_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('venda_tipo_pagamento_id','{venda_tipo_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_endereco_to_string($venda_cliente_endereco_to_string)
    {
        if(is_array($venda_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $venda_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->venda_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_endereco_to_string = $venda_cliente_endereco_to_string;
        }

        $this->vdata['venda_cliente_endereco_to_string'] = $this->venda_cliente_endereco_to_string;
    }

    public function get_venda_cliente_endereco_to_string()
    {
        if(!empty($this->venda_cliente_endereco_to_string))
        {
            return $this->venda_cliente_endereco_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_venda_tabela_preco_to_string($venda_tabela_preco_to_string)
    {
        if(is_array($venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_tabela_preco_to_string = $venda_tabela_preco_to_string;
        }

        $this->vdata['venda_tabela_preco_to_string'] = $this->venda_tabela_preco_to_string;
    }

    public function get_venda_tabela_preco_to_string()
    {
        if(!empty($this->venda_tabela_preco_to_string))
        {
            return $this->venda_tabela_preco_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_movimentacao_origem_to_string($venda_movimentacao_origem_to_string)
    {
        if(is_array($venda_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $venda_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_movimentacao_origem_to_string = $venda_movimentacao_origem_to_string;
        }

        $this->vdata['venda_movimentacao_origem_to_string'] = $this->venda_movimentacao_origem_to_string;
    }

    public function get_venda_movimentacao_origem_to_string()
    {
        if(!empty($this->venda_movimentacao_origem_to_string))
        {
            return $this->venda_movimentacao_origem_to_string;
        }
    
        $values = Venda::where('orcamento_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

  public static function recalcula_itens_orcamento($orcamento)
  {
  
      foreach ($orcamento->getOrcamentoItems() as $item)
      {
         $item->valor_total = $item->quantidade * $item->valor_unitario;          
         $item->store();
      }
  }

   public function get_informacoes_complementares_impressao()
   {
   
      $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', $this->system_unit_id)->first(); 
  
      if ($config_filial)
      {
        return $config_filial->info_complementar_orcamento;        
      }
   }

   public function get_situacao_cor()
   {
        $orcamento_situacao = OrcamentoSituacao::find($this->orcamento_situacao_id);
    
        $cor = $orcamento_situacao->cor;
        $descricao = $orcamento_situacao->descricao;
    
        return "<span class='label' style='background-color:{$cor}'>{$descricao}</span>";
   }
  
  
   public static function GerarVenda($orcamento)
   {

       $venda = new Venda();
       $venda->system_unit_id = $orcamento->system_unit_id;
       $venda->filial_saida_id = $orcamento->system_unit_id;
       $venda->venda_situacao_id = VendaSituacao::EmAndamento;
       $venda->orcamento_id = $orcamento->id;
       $venda->vendedor_id = $orcamento->vendedor_id;
       $venda->cliente_id = $orcamento->cliente_id;
    //   $venda->cliente_contato_id = null;
       $venda->data_hora_venda = date('Y-m-d H:i:s');
       $venda->data_prev_entrega = date('Y-m-d H:i:s');
       $venda->observacao = $orcamento->observacao;
       $venda->valor_produtos = $orcamento->valor_produtos;
       $venda->desconto = $orcamento->desconto;
       $venda->peso_total = $orcamento->peso_total;
       $venda->frete_total = $orcamento->frete_total;
       $venda->valor_total = $orcamento->valor_total;
       $venda->tabela_preco_id = $orcamento->tabela_preco_id;
       $venda->venda_tipo_pagamento_id = VendaTipoPagamento::Imediato;
       $venda->venda_modalidade_id = VendaModalidade::ClienteRetira;   
       $venda->movimentacao_origem_id = MovimentacaoOrigem::kraftweb; 
   
       Funcoes::SalvarUsuarioCadastro($venda);
   
       $venda->store();
   
       //itens
       $listaItens = OrcamentoItem::where('orcamento_id','=', $orcamento->id)->load();
   
       if ($listaItens)
       {
          foreach ($listaItens as $item)
          {
              $vendaItem = new VendaItem();
          
              $vendaItem->venda_id = $venda->id;
              $vendaItem->produto_id = $item->produto_id;
              $vendaItem->quantidade = $item->quantidade;
              $vendaItem->valor_unitario = $item->valor_unitario;
              $vendaItem->valor_total = $item->valor_total;
              $vendaItem->valor_original = $item->valor_original;
              $vendaItem->informacoes_adicionais = $item->informacoes_adicionais;
              $vendaItem->numero_pedido = $item->numero_pedido;
              $vendaItem->numero_item_pedido = $item->numero_item_pedido;
              $vendaItem->cancelado = Resposta::Nao;
          
              $produtofilial = ProdutoFilial::where('produto_id', '=', $item->produto_id)
                                            ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                            ->first();

              if($produtofilial)
              {                    
                $vendaItem->valor_custo = number_format($produtofilial->valor_custo, 2, ',', '.');  
                $vendaItem->estoque_deposito_id = $produtofilial->estoque_deposito_id; 
              }          

              $vendaItem->desconto = $item->desconto;
              $vendaItem->valor_frete = $item->valor_frete;
              $vendaItem->peso_unitario = $item->peso_unitario;
              $vendaItem->peso_total = $item->peso_total;         

              Funcoes::SalvarUsuarioCadastro($vendaItem);
          
              $vendaItem->store();
          } 
       }

        $orcamento->orcamento_situacao_id = OrcamentoSituacao::Aprovado;
        $orcamento->store();
   }
  
   public static function ClonarOrcamento($orcamento_id)
   {
       $orcamento = Orcamento::find($orcamento_id);
   
       if($orcamento)
       {
           $id_orcamento_ant = $orcamento_id;
           $orcamento_novo = $orcamento;
       
           $orcamento_novo->id = null;
           $orcamento_novo->system_unit_id = TSession::getValue('userunitid');
           $orcamento_novo->criado_em = date('Y-m-d H:i:s');
           $orcamento_novo->criado_por = TSession::getValue('username');
           $orcamento_novo->alterado_em = null;
           $orcamento_novo->alterado_por = null;
           $orcamento_novo->cliente_id = $orcamento->cliente_id;
           $orcamento_novo->data_orcamento = date('Y-m-d');
           $orcamento_novo->observacao = $orcamento->observacao;
           $orcamento_novo->store();
       
       
       
           $itens_orcamento = OrcamentoItem::where('orcamento_id', '=', $id_orcamento_ant)->load();
           //Carregando os itens
           foreach($itens_orcamento as $item) {
               $novo_item = $item;
               $novo_item->orcamento_id = $orcamento_novo->id;
               $novo_item->criado_por = TSession::getValue('username');
               $novo_item->id = null;
               $novo_item->store();
           }
       
       }
   }

  
                                                            
}

