<?php

class OrcamentoItem extends TRecord
{
    const TABLENAME  = 'orcamento_item';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $orcamento;
    private $produto;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('orcamento_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('valor_total');
        parent::addAttribute('valor_original');
        parent::addAttribute('valor_custo');
        parent::addAttribute('desconto');
        parent::addAttribute('informacoes_adicionais');
        parent::addAttribute('numero_pedido');
        parent::addAttribute('numero_item_pedido');
        parent::addAttribute('valor_frete');
        parent::addAttribute('peso_unitario');
        parent::addAttribute('peso_total');
    
    }

    /**
     * Method set_orcamento
     * Sample of usage: $var->orcamento = $object;
     * @param $object Instance of Orcamento
     */
    public function set_orcamento(Orcamento $object)
    {
        $this->orcamento = $object;
        $this->orcamento_id = $object->id;
    }

    /**
     * Method get_orcamento
     * Sample of usage: $var->orcamento->attribute;
     * @returns Orcamento instance
     */
    public function get_orcamento()
    {
    
        // loads the associated object
        if (empty($this->orcamento))
            $this->orcamento = new Orcamento($this->orcamento_id);
    
        // returns the associated object
        return $this->orcamento;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }

   public function get_codigo_padrao_produto_impressao_orcamento()
    {
        $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', TSession::getValue('userunitid'))->first();
    
        if($config_filial)
        {
            $prod = Produto::find($this->produto_id);
            return funcaoNFE::RetornaCProd($config_filial->notafiscal_cprod_padrao_orcamento_id,
                                            $prod->id,
                                            $prod->codigo_EAN,
                                            $prod->referencia,
                                            $prod->codigo_sku);
                                                                 
        }
    }

    
}

