<?php

class OrcamentoSituacao extends TRecord
{
    const TABLENAME  = 'orcamento_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Aberto = '1';
    const Aprovado = '2';
    const Reprovado = '3';
    const Cancelado = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('cor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('ordem');
            
    }

    /**
     * Method getOrcamentos
     */
    public function getOrcamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('orcamento_situacao_id', '=', $this->id));
        return Orcamento::getObjects( $criteria );
    }
    /**
     * Method getOrcamentoSituacaoHistoricos
     */
    public function getOrcamentoSituacaoHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('orcamento_situacao_id', '=', $this->id));
        return OrcamentoSituacaoHistorico::getObjects( $criteria );
    }

    public function set_orcamento_system_unit_to_string($orcamento_system_unit_to_string)
    {
        if(is_array($orcamento_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $orcamento_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->orcamento_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_system_unit_to_string = $orcamento_system_unit_to_string;
        }

        $this->vdata['orcamento_system_unit_to_string'] = $this->orcamento_system_unit_to_string;
    }

    public function get_orcamento_system_unit_to_string()
    {
        if(!empty($this->orcamento_system_unit_to_string))
        {
            return $this->orcamento_system_unit_to_string;
        }
    
        $values = Orcamento::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_orcamento_orcamento_situacao_to_string($orcamento_orcamento_situacao_to_string)
    {
        if(is_array($orcamento_orcamento_situacao_to_string))
        {
            $values = OrcamentoSituacao::where('id', 'in', $orcamento_orcamento_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_orcamento_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_orcamento_situacao_to_string = $orcamento_orcamento_situacao_to_string;
        }

        $this->vdata['orcamento_orcamento_situacao_to_string'] = $this->orcamento_orcamento_situacao_to_string;
    }

    public function get_orcamento_orcamento_situacao_to_string()
    {
        if(!empty($this->orcamento_orcamento_situacao_to_string))
        {
            return $this->orcamento_orcamento_situacao_to_string;
        }
    
        $values = Orcamento::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('orcamento_situacao_id','{orcamento_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_vendedor_to_string($orcamento_vendedor_to_string)
    {
        if(is_array($orcamento_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $orcamento_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_vendedor_to_string = $orcamento_vendedor_to_string;
        }

        $this->vdata['orcamento_vendedor_to_string'] = $this->orcamento_vendedor_to_string;
    }

    public function get_orcamento_vendedor_to_string()
    {
        if(!empty($this->orcamento_vendedor_to_string))
        {
            return $this->orcamento_vendedor_to_string;
        }
    
        $values = Orcamento::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_to_string($orcamento_cliente_to_string)
    {
        if(is_array($orcamento_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $orcamento_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_to_string = $orcamento_cliente_to_string;
        }

        $this->vdata['orcamento_cliente_to_string'] = $this->orcamento_cliente_to_string;
    }

    public function get_orcamento_cliente_to_string()
    {
        if(!empty($this->orcamento_cliente_to_string))
        {
            return $this->orcamento_cliente_to_string;
        }
    
        $values = Orcamento::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_contato_to_string($orcamento_cliente_contato_to_string)
    {
        if(is_array($orcamento_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $orcamento_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_contato_to_string = $orcamento_cliente_contato_to_string;
        }

        $this->vdata['orcamento_cliente_contato_to_string'] = $this->orcamento_cliente_contato_to_string;
    }

    public function get_orcamento_cliente_contato_to_string()
    {
        if(!empty($this->orcamento_cliente_contato_to_string))
        {
            return $this->orcamento_cliente_contato_to_string;
        }
    
        $values = Orcamento::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_tabela_preco_to_string($orcamento_tabela_preco_to_string)
    {
        if(is_array($orcamento_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $orcamento_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_tabela_preco_to_string = $orcamento_tabela_preco_to_string;
        }

        $this->vdata['orcamento_tabela_preco_to_string'] = $this->orcamento_tabela_preco_to_string;
    }

    public function get_orcamento_tabela_preco_to_string()
    {
        if(!empty($this->orcamento_tabela_preco_to_string))
        {
            return $this->orcamento_tabela_preco_to_string;
        }
    
        $values = Orcamento::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_situacao_historico_orcamento_situacao_to_string($orcamento_situacao_historico_orcamento_situacao_to_string)
    {
        if(is_array($orcamento_situacao_historico_orcamento_situacao_to_string))
        {
            $values = OrcamentoSituacao::where('id', 'in', $orcamento_situacao_historico_orcamento_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_situacao_historico_orcamento_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_situacao_historico_orcamento_situacao_to_string = $orcamento_situacao_historico_orcamento_situacao_to_string;
        }

        $this->vdata['orcamento_situacao_historico_orcamento_situacao_to_string'] = $this->orcamento_situacao_historico_orcamento_situacao_to_string;
    }

    public function get_orcamento_situacao_historico_orcamento_situacao_to_string()
    {
        if(!empty($this->orcamento_situacao_historico_orcamento_situacao_to_string))
        {
            return $this->orcamento_situacao_historico_orcamento_situacao_to_string;
        }
    
        $values = OrcamentoSituacaoHistorico::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('orcamento_situacao_id','{orcamento_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_situacao_historico_orcamento_to_string($orcamento_situacao_historico_orcamento_to_string)
    {
        if(is_array($orcamento_situacao_historico_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $orcamento_situacao_historico_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->orcamento_situacao_historico_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_situacao_historico_orcamento_to_string = $orcamento_situacao_historico_orcamento_to_string;
        }

        $this->vdata['orcamento_situacao_historico_orcamento_to_string'] = $this->orcamento_situacao_historico_orcamento_to_string;
    }

    public function get_orcamento_situacao_historico_orcamento_to_string()
    {
        if(!empty($this->orcamento_situacao_historico_orcamento_to_string))
        {
            return $this->orcamento_situacao_historico_orcamento_to_string;
        }
    
        $values = OrcamentoSituacaoHistorico::where('orcamento_situacao_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    
}

