<?php

class OrcamentoSituacaoHistorico extends TRecord
{
    const TABLENAME  = 'orcamento_situacao_historico';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $orcamento_situacao;
    private $orcamento;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('orcamento_situacao_id');
        parent::addAttribute('orcamento_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_orcamento_situacao
     * Sample of usage: $var->orcamento_situacao = $object;
     * @param $object Instance of OrcamentoSituacao
     */
    public function set_orcamento_situacao(OrcamentoSituacao $object)
    {
        $this->orcamento_situacao = $object;
        $this->orcamento_situacao_id = $object->id;
    }

    /**
     * Method get_orcamento_situacao
     * Sample of usage: $var->orcamento_situacao->attribute;
     * @returns OrcamentoSituacao instance
     */
    public function get_orcamento_situacao()
    {
    
        // loads the associated object
        if (empty($this->orcamento_situacao))
            $this->orcamento_situacao = new OrcamentoSituacao($this->orcamento_situacao_id);
    
        // returns the associated object
        return $this->orcamento_situacao;
    }
    /**
     * Method set_orcamento
     * Sample of usage: $var->orcamento = $object;
     * @param $object Instance of Orcamento
     */
    public function set_orcamento(Orcamento $object)
    {
        $this->orcamento = $object;
        $this->orcamento_id = $object->id;
    }

    /**
     * Method get_orcamento
     * Sample of usage: $var->orcamento->attribute;
     * @returns Orcamento instance
     */
    public function get_orcamento()
    {
    
        // loads the associated object
        if (empty($this->orcamento))
            $this->orcamento = new Orcamento($this->orcamento_id);
    
        // returns the associated object
        return $this->orcamento;
    }

    public static function LancarHistorico($orcamento_situacao_id, $orcamento_id, $descricao)
    {
        $historicosit = new OrcamentoSituacaoHistorico;
        $historicosit->orcamento_situacao_id = $orcamento_situacao_id;
        $historicosit->orcamento_id = $orcamento_id;
        $historicosit->descricao = $descricao;
        $historicosit->criado_por = TSession::getValue('username');
        $historicosit->store();
    }
  
  

}

