<?php

class OrdemProducao extends TRecord
{
    const TABLENAME  = 'ordem_producao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ordem_producao_situacao;
    private $produto_ficha_tecnica;
    private $produto;
    private $system_unit;
    private $estoque_deposito;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('ordem_producao_situacao_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('produto_ficha_tecnica_id');
        parent::addAttribute('estoque_deposito_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade');
        parent::addAttribute('data_producao');
        parent::addAttribute('observacoes');
    
    }

    /**
     * Method set_ordem_producao_situacao
     * Sample of usage: $var->ordem_producao_situacao = $object;
     * @param $object Instance of OrdemProducaoSituacao
     */
    public function set_ordem_producao_situacao(OrdemProducaoSituacao $object)
    {
        $this->ordem_producao_situacao = $object;
        $this->ordem_producao_situacao_id = $object->id;
    }

    /**
     * Method get_ordem_producao_situacao
     * Sample of usage: $var->ordem_producao_situacao->attribute;
     * @returns OrdemProducaoSituacao instance
     */
    public function get_ordem_producao_situacao()
    {
    
        // loads the associated object
        if (empty($this->ordem_producao_situacao))
            $this->ordem_producao_situacao = new OrdemProducaoSituacao($this->ordem_producao_situacao_id);
    
        // returns the associated object
        return $this->ordem_producao_situacao;
    }
    /**
     * Method set_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica = $object;
     * @param $object Instance of ProdutoFichaTecnica
     */
    public function set_produto_ficha_tecnica(ProdutoFichaTecnica $object)
    {
        $this->produto_ficha_tecnica = $object;
        $this->produto_ficha_tecnica_id = $object->id;
    }

    /**
     * Method get_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica->attribute;
     * @returns ProdutoFichaTecnica instance
     */
    public function get_produto_ficha_tecnica()
    {
    
        // loads the associated object
        if (empty($this->produto_ficha_tecnica))
            $this->produto_ficha_tecnica = new ProdutoFichaTecnica($this->produto_ficha_tecnica_id);
    
        // returns the associated object
        return $this->produto_ficha_tecnica;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito(EstoqueDeposito $object)
    {
        $this->estoque_deposito = $object;
        $this->estoque_deposito_id = $object->id;
    }

    /**
     * Method get_estoque_deposito
     * Sample of usage: $var->estoque_deposito->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito))
            $this->estoque_deposito = new EstoqueDeposito($this->estoque_deposito_id);
    
        // returns the associated object
        return $this->estoque_deposito;
    }

    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_producao_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoEtapass
     */
    public function getOrdemProducaoEtapass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_producao_id', '=', $this->id));
        return OrdemProducaoEtapas::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoItenss
     */
    public function getOrdemProducaoItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_producao_id', '=', $this->id));
        return OrdemProducaoItens::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoSituacaoHistoricos
     */
    public function getOrdemProducaoSituacaoHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_producao_id', '=', $this->id));
        return OrdemProducaoSituacaoHistorico::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoVendass
     */
    public function getOrdemProducaoVendass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_producao_id', '=', $this->id));
        return OrdemProducaoVendas::getObjects( $criteria );
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('ordem_producao_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_etapas_ordem_producao_to_string($ordem_producao_etapas_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_etapas_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_etapas_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_etapas_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_etapas_ordem_producao_to_string = $ordem_producao_etapas_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_etapas_ordem_producao_to_string'] = $this->ordem_producao_etapas_ordem_producao_to_string;
    }

    public function get_ordem_producao_etapas_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_etapas_ordem_producao_to_string))
        {
            return $this->ordem_producao_etapas_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoEtapas::where('ordem_producao_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_etapas_ordem_producao_etapas_situacao_to_string($ordem_producao_etapas_ordem_producao_etapas_situacao_to_string)
    {
        if(is_array($ordem_producao_etapas_ordem_producao_etapas_situacao_to_string))
        {
            $values = OrdemProducaoEtapasSituacao::where('id', 'in', $ordem_producao_etapas_ordem_producao_etapas_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_etapas_ordem_producao_etapas_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_etapas_ordem_producao_etapas_situacao_to_string = $ordem_producao_etapas_ordem_producao_etapas_situacao_to_string;
        }

        $this->vdata['ordem_producao_etapas_ordem_producao_etapas_situacao_to_string'] = $this->ordem_producao_etapas_ordem_producao_etapas_situacao_to_string;
    }

    public function get_ordem_producao_etapas_ordem_producao_etapas_situacao_to_string()
    {
        if(!empty($this->ordem_producao_etapas_ordem_producao_etapas_situacao_to_string))
        {
            return $this->ordem_producao_etapas_ordem_producao_etapas_situacao_to_string;
        }
    
        $values = OrdemProducaoEtapas::where('ordem_producao_id', '=', $this->id)->getIndexedArray('ordem_producao_etapas_situacao_id','{ordem_producao_etapas_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_ordem_producao_to_string($ordem_producao_itens_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_itens_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_itens_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_itens_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_ordem_producao_to_string = $ordem_producao_itens_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_itens_ordem_producao_to_string'] = $this->ordem_producao_itens_ordem_producao_to_string;
    }

    public function get_ordem_producao_itens_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_itens_ordem_producao_to_string))
        {
            return $this->ordem_producao_itens_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoItens::where('ordem_producao_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_produto_to_string($ordem_producao_itens_produto_to_string)
    {
        if(is_array($ordem_producao_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_produto_to_string = $ordem_producao_itens_produto_to_string;
        }

        $this->vdata['ordem_producao_itens_produto_to_string'] = $this->ordem_producao_itens_produto_to_string;
    }

    public function get_ordem_producao_itens_produto_to_string()
    {
        if(!empty($this->ordem_producao_itens_produto_to_string))
        {
            return $this->ordem_producao_itens_produto_to_string;
        }
    
        $values = OrdemProducaoItens::where('ordem_producao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_estoque_deposito_to_string($ordem_producao_itens_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_itens_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_itens_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_itens_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_estoque_deposito_to_string = $ordem_producao_itens_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_itens_estoque_deposito_to_string'] = $this->ordem_producao_itens_estoque_deposito_to_string;
    }

    public function get_ordem_producao_itens_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_itens_estoque_deposito_to_string))
        {
            return $this->ordem_producao_itens_estoque_deposito_to_string;
        }
    
        $values = OrdemProducaoItens::where('ordem_producao_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_situacao_historico_ordem_producao_to_string($ordem_producao_situacao_historico_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_situacao_historico_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_situacao_historico_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_situacao_historico_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_situacao_historico_ordem_producao_to_string = $ordem_producao_situacao_historico_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_situacao_historico_ordem_producao_to_string'] = $this->ordem_producao_situacao_historico_ordem_producao_to_string;
    }

    public function get_ordem_producao_situacao_historico_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_situacao_historico_ordem_producao_to_string))
        {
            return $this->ordem_producao_situacao_historico_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoSituacaoHistorico::where('ordem_producao_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_situacao_historico_ordem_producao_situacao_to_string($ordem_producao_situacao_historico_ordem_producao_situacao_to_string)
    {
        if(is_array($ordem_producao_situacao_historico_ordem_producao_situacao_to_string))
        {
            $values = OrdemProducaoSituacao::where('id', 'in', $ordem_producao_situacao_historico_ordem_producao_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string = $ordem_producao_situacao_historico_ordem_producao_situacao_to_string;
        }

        $this->vdata['ordem_producao_situacao_historico_ordem_producao_situacao_to_string'] = $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string;
    }

    public function get_ordem_producao_situacao_historico_ordem_producao_situacao_to_string()
    {
        if(!empty($this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string))
        {
            return $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string;
        }
    
        $values = OrdemProducaoSituacaoHistorico::where('ordem_producao_id', '=', $this->id)->getIndexedArray('ordem_producao_situacao_id','{ordem_producao_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_vendas_ordem_producao_to_string($ordem_producao_vendas_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_vendas_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_vendas_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_vendas_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_vendas_ordem_producao_to_string = $ordem_producao_vendas_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_vendas_ordem_producao_to_string'] = $this->ordem_producao_vendas_ordem_producao_to_string;
    }

    public function get_ordem_producao_vendas_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_vendas_ordem_producao_to_string))
        {
            return $this->ordem_producao_vendas_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoVendas::where('ordem_producao_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_vendas_venda_to_string($ordem_producao_vendas_venda_to_string)
    {
        if(is_array($ordem_producao_vendas_venda_to_string))
        {
            $values = Venda::where('id', 'in', $ordem_producao_vendas_venda_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_vendas_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_vendas_venda_to_string = $ordem_producao_vendas_venda_to_string;
        }

        $this->vdata['ordem_producao_vendas_venda_to_string'] = $this->ordem_producao_vendas_venda_to_string;
    }

    public function get_ordem_producao_vendas_venda_to_string()
    {
        if(!empty($this->ordem_producao_vendas_venda_to_string))
        {
            return $this->ordem_producao_vendas_venda_to_string;
        }
    
        $values = OrdemProducaoVendas::where('ordem_producao_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

  public static function LancaEstoqueOrdemProducao($ordem_producao)
  {
        //lançando o produto acabado...
        $lancamento = new EstoqueLancamentos();
        $lancamento->system_unit_id = $ordem_producao->system_unit_id;
        $lancamento->produto_id = $ordem_producao->produto_id;
        $lancamento->estoque_tipo_movimentacao_id = EstoqueTipoMovimentacao::Entrada;
        $lancamento->estoque_origem_id = EstoqueOrigem::ProducaoAcabados;
        $lancamento->estoque_deposito_id = $ordem_producao->estoque_deposito_id;
        // $lancamento->produto_lote_id = $item->produto_lote_id;
        $lancamento->quantidade = $ordem_producao->quantidade;
        $lancamento->ordem_producao_id = $ordem_producao->id;
        $lancamento->preco_venda = 0;
        $lancamento->preco_custo = $ordem_producao->custo;   
        $lancamento->data_lancamento = date('Y-m-d');
        $lancamento->ordem_producao_id = $ordem_producao->id;
        $lancamento->criado_por = TSession::getValue('username');
        $lancamento->observacao = '';
        $lancamento->store();       

        //lançando as materias primas  
        foreach ($ordem_producao->getOrdemProducaoItenss() as $item) 
        {
            $lancamento = new EstoqueLancamentos();
            $lancamento->system_unit_id = $ordem_producao->system_unit_id;
            $lancamento->produto_id = $item->produto_id;
            $lancamento->estoque_tipo_movimentacao_id = EstoqueTipoMovimentacao::Saida;
            $lancamento->estoque_origem_id = EstoqueOrigem::ProducaoMateriasPrimas;
            $lancamento->estoque_deposito_id = $item->estoque_deposito_id;
            // $lancamento->produto_lote_id = $item->produto_lote_id;
            $lancamento->quantidade = $item->quantidade_total;
            $lancamento->ordem_producao_id = $item->ordem_producao_id;
            $lancamento->preco_venda = 0;
            $lancamento->preco_custo = $item->custo;   
            $lancamento->data_lancamento = date('Y-m-d');
            $lancamento->ordem_producao_id = $ordem_producao->id;
            $lancamento->criado_por = TSession::getValue('username');
            $lancamento->observacao = '';
            $lancamento->store();   
        }

  }
  
  
  
            
}

