<?php

class OrdemProducaoItens extends TRecord
{
    const TABLENAME  = 'ordem_producao_itens';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto;
    private $ordem_producao;
    private $estoque_deposito;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('ordem_producao_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('estoque_deposito_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade');
        parent::addAttribute('quantidade_total');
        parent::addAttribute('custo');
        parent::addAttribute('custo_total');
            
    }

    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_ordem_producao
     * Sample of usage: $var->ordem_producao = $object;
     * @param $object Instance of OrdemProducao
     */
    public function set_ordem_producao(OrdemProducao $object)
    {
        $this->ordem_producao = $object;
        $this->ordem_producao_id = $object->id;
    }

    /**
     * Method get_ordem_producao
     * Sample of usage: $var->ordem_producao->attribute;
     * @returns OrdemProducao instance
     */
    public function get_ordem_producao()
    {
    
        // loads the associated object
        if (empty($this->ordem_producao))
            $this->ordem_producao = new OrdemProducao($this->ordem_producao_id);
    
        // returns the associated object
        return $this->ordem_producao;
    }
    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito(EstoqueDeposito $object)
    {
        $this->estoque_deposito = $object;
        $this->estoque_deposito_id = $object->id;
    }

    /**
     * Method get_estoque_deposito
     * Sample of usage: $var->estoque_deposito->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito))
            $this->estoque_deposito = new EstoqueDeposito($this->estoque_deposito_id);
    
        // returns the associated object
        return $this->estoque_deposito;
    }

    
}

