<?php

class OrdemProducaoSituacao extends TRecord
{
    const TABLENAME  = 'ordem_producao_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Pendente = '1';
    const EmAndamento = '2';
    const Finalizada = '3';
    const Cancelada = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('cor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getOrdemProducaos
     */
    public function getOrdemProducaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_producao_situacao_id', '=', $this->id));
        return OrdemProducao::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoSituacaoHistoricos
     */
    public function getOrdemProducaoSituacaoHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_producao_situacao_id', '=', $this->id));
        return OrdemProducaoSituacaoHistorico::getObjects( $criteria );
    }

    public function set_ordem_producao_system_unit_to_string($ordem_producao_system_unit_to_string)
    {
        if(is_array($ordem_producao_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_producao_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_producao_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_system_unit_to_string = $ordem_producao_system_unit_to_string;
        }

        $this->vdata['ordem_producao_system_unit_to_string'] = $this->ordem_producao_system_unit_to_string;
    }

    public function get_ordem_producao_system_unit_to_string()
    {
        if(!empty($this->ordem_producao_system_unit_to_string))
        {
            return $this->ordem_producao_system_unit_to_string;
        }
    
        $values = OrdemProducao::where('ordem_producao_situacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_ordem_producao_situacao_to_string($ordem_producao_ordem_producao_situacao_to_string)
    {
        if(is_array($ordem_producao_ordem_producao_situacao_to_string))
        {
            $values = OrdemProducaoSituacao::where('id', 'in', $ordem_producao_ordem_producao_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_ordem_producao_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_ordem_producao_situacao_to_string = $ordem_producao_ordem_producao_situacao_to_string;
        }

        $this->vdata['ordem_producao_ordem_producao_situacao_to_string'] = $this->ordem_producao_ordem_producao_situacao_to_string;
    }

    public function get_ordem_producao_ordem_producao_situacao_to_string()
    {
        if(!empty($this->ordem_producao_ordem_producao_situacao_to_string))
        {
            return $this->ordem_producao_ordem_producao_situacao_to_string;
        }
    
        $values = OrdemProducao::where('ordem_producao_situacao_id', '=', $this->id)->getIndexedArray('ordem_producao_situacao_id','{ordem_producao_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_to_string($ordem_producao_produto_to_string)
    {
        if(is_array($ordem_producao_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_to_string = $ordem_producao_produto_to_string;
        }

        $this->vdata['ordem_producao_produto_to_string'] = $this->ordem_producao_produto_to_string;
    }

    public function get_ordem_producao_produto_to_string()
    {
        if(!empty($this->ordem_producao_produto_to_string))
        {
            return $this->ordem_producao_produto_to_string;
        }
    
        $values = OrdemProducao::where('ordem_producao_situacao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_ficha_tecnica_to_string($ordem_producao_produto_ficha_tecnica_to_string)
    {
        if(is_array($ordem_producao_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $ordem_producao_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_ficha_tecnica_to_string = $ordem_producao_produto_ficha_tecnica_to_string;
        }

        $this->vdata['ordem_producao_produto_ficha_tecnica_to_string'] = $this->ordem_producao_produto_ficha_tecnica_to_string;
    }

    public function get_ordem_producao_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->ordem_producao_produto_ficha_tecnica_to_string))
        {
            return $this->ordem_producao_produto_ficha_tecnica_to_string;
        }
    
        $values = OrdemProducao::where('ordem_producao_situacao_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_estoque_deposito_to_string($ordem_producao_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_estoque_deposito_to_string = $ordem_producao_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_estoque_deposito_to_string'] = $this->ordem_producao_estoque_deposito_to_string;
    }

    public function get_ordem_producao_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_estoque_deposito_to_string))
        {
            return $this->ordem_producao_estoque_deposito_to_string;
        }
    
        $values = OrdemProducao::where('ordem_producao_situacao_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_situacao_historico_ordem_producao_to_string($ordem_producao_situacao_historico_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_situacao_historico_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_situacao_historico_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_situacao_historico_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_situacao_historico_ordem_producao_to_string = $ordem_producao_situacao_historico_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_situacao_historico_ordem_producao_to_string'] = $this->ordem_producao_situacao_historico_ordem_producao_to_string;
    }

    public function get_ordem_producao_situacao_historico_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_situacao_historico_ordem_producao_to_string))
        {
            return $this->ordem_producao_situacao_historico_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoSituacaoHistorico::where('ordem_producao_situacao_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_situacao_historico_ordem_producao_situacao_to_string($ordem_producao_situacao_historico_ordem_producao_situacao_to_string)
    {
        if(is_array($ordem_producao_situacao_historico_ordem_producao_situacao_to_string))
        {
            $values = OrdemProducaoSituacao::where('id', 'in', $ordem_producao_situacao_historico_ordem_producao_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string = $ordem_producao_situacao_historico_ordem_producao_situacao_to_string;
        }

        $this->vdata['ordem_producao_situacao_historico_ordem_producao_situacao_to_string'] = $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string;
    }

    public function get_ordem_producao_situacao_historico_ordem_producao_situacao_to_string()
    {
        if(!empty($this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string))
        {
            return $this->ordem_producao_situacao_historico_ordem_producao_situacao_to_string;
        }
    
        $values = OrdemProducaoSituacaoHistorico::where('ordem_producao_situacao_id', '=', $this->id)->getIndexedArray('ordem_producao_situacao_id','{ordem_producao_situacao->descricao}');
        return implode(', ', $values);
    }

    
}

