<?php

class OrdemProducaoSituacaoHistorico extends TRecord
{
    const TABLENAME  = 'ordem_producao_situacao_historico';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ordem_producao_situacao;
    private $ordem_producao;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('ordem_producao_id');
        parent::addAttribute('ordem_producao_situacao_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_ordem_producao_situacao
     * Sample of usage: $var->ordem_producao_situacao = $object;
     * @param $object Instance of OrdemProducaoSituacao
     */
    public function set_ordem_producao_situacao(OrdemProducaoSituacao $object)
    {
        $this->ordem_producao_situacao = $object;
        $this->ordem_producao_situacao_id = $object->id;
    }

    /**
     * Method get_ordem_producao_situacao
     * Sample of usage: $var->ordem_producao_situacao->attribute;
     * @returns OrdemProducaoSituacao instance
     */
    public function get_ordem_producao_situacao()
    {
    
        // loads the associated object
        if (empty($this->ordem_producao_situacao))
            $this->ordem_producao_situacao = new OrdemProducaoSituacao($this->ordem_producao_situacao_id);
    
        // returns the associated object
        return $this->ordem_producao_situacao;
    }
    /**
     * Method set_ordem_producao
     * Sample of usage: $var->ordem_producao = $object;
     * @param $object Instance of OrdemProducao
     */
    public function set_ordem_producao(OrdemProducao $object)
    {
        $this->ordem_producao = $object;
        $this->ordem_producao_id = $object->id;
    }

    /**
     * Method get_ordem_producao
     * Sample of usage: $var->ordem_producao->attribute;
     * @returns OrdemProducao instance
     */
    public function get_ordem_producao()
    {
    
        // loads the associated object
        if (empty($this->ordem_producao))
            $this->ordem_producao = new OrdemProducao($this->ordem_producao_id);
    
        // returns the associated object
        return $this->ordem_producao;
    }

  
    public static function LancarHistorico($ordem_producao_situacao_id,$ordem_producao_id,$descricao)
    {
        $historicosit = new OrdemProducaoSituacaoHistorico;
        $historicosit->ordem_producao_situacao_id = $ordem_producao_situacao_id;
        $historicosit->ordem_producao_id = $ordem_producao_id;
        $historicosit->descricao = $descricao;
        $historicosit->criado_por =  TSession::getValue('username');
        $historicosit->store();    
    }  
  

}

