<?php

class OrdemServico extends TRecord
{
    const TABLENAME  = 'ordem_servico';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $cliente_contato;
    private $ordem_servico_producao_etapa;
    private $usuario_aprovacao;
    private $system_unit;
    private $cliente;
    private $vendedor;
    private $ordem_servico_situacao;
    private $condicao_pagamento;
    private $cliente_endereco;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('cliente_id');
        parent::addAttribute('cliente_contato_id');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('ordem_servico_situacao_id');
        parent::addAttribute('ordem_servico_producao_etapa_id');
        parent::addAttribute('condicao_pagamento_id');
        parent::addAttribute('cliente_endereco_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('numero_os');
        parent::addAttribute('numero_orcamento');
        parent::addAttribute('data_emissao');
        parent::addAttribute('valor');
        parent::addAttribute('desconto');
        parent::addAttribute('prazo_entrega');
        parent::addAttribute('validade_dias');
        parent::addAttribute('data_abertura_os');
        parent::addAttribute('vendedor_comissao');
        parent::addAttribute('vendedor_comissao_avista');
        parent::addAttribute('vendedor_comissao_aprazo');
        parent::addAttribute('observacoes');
        parent::addAttribute('prazo_garantia');
        parent::addAttribute('valor_pago');
        parent::addAttribute('motivo_nao_aprovacao_orcamento');
        parent::addAttribute('valor_avista');
        parent::addAttribute('valor_aprazo');
        parent::addAttribute('valor_faturado_vendas');
        parent::addAttribute('usuario_aprovacao_id');
        parent::addAttribute('informacoes_transporte');
    
    }

    /**
     * Method set_cliente_contato
     * Sample of usage: $var->cliente_contato = $object;
     * @param $object Instance of ClienteContato
     */
    public function set_cliente_contato(ClienteContato $object)
    {
        $this->cliente_contato = $object;
        $this->cliente_contato_id = $object->id;
    }

    /**
     * Method get_cliente_contato
     * Sample of usage: $var->cliente_contato->attribute;
     * @returns ClienteContato instance
     */
    public function get_cliente_contato()
    {
    
        // loads the associated object
        if (empty($this->cliente_contato))
            $this->cliente_contato = new ClienteContato($this->cliente_contato_id);
    
        // returns the associated object
        return $this->cliente_contato;
    }
    /**
     * Method set_ordem_servico_producao_etapa
     * Sample of usage: $var->ordem_servico_producao_etapa = $object;
     * @param $object Instance of OrdemServicoProducaoEtapa
     */
    public function set_ordem_servico_producao_etapa(OrdemServicoProducaoEtapa $object)
    {
        $this->ordem_servico_producao_etapa = $object;
        $this->ordem_servico_producao_etapa_id = $object->id;
    }

    /**
     * Method get_ordem_servico_producao_etapa
     * Sample of usage: $var->ordem_servico_producao_etapa->attribute;
     * @returns OrdemServicoProducaoEtapa instance
     */
    public function get_ordem_servico_producao_etapa()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico_producao_etapa))
            $this->ordem_servico_producao_etapa = new OrdemServicoProducaoEtapa($this->ordem_servico_producao_etapa_id);
    
        // returns the associated object
        return $this->ordem_servico_producao_etapa;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_usuario_aprovacao(SystemUsers $object)
    {
        $this->usuario_aprovacao = $object;
        $this->usuario_aprovacao_id = $object->id;
    }

    /**
     * Method get_usuario_aprovacao
     * Sample of usage: $var->usuario_aprovacao->attribute;
     * @returns SystemUsers instance
     */
    public function get_usuario_aprovacao()
    {
    
        // loads the associated object
        if (empty($this->usuario_aprovacao))
            $this->usuario_aprovacao = new SystemUsers($this->usuario_aprovacao_id);
    
        // returns the associated object
        return $this->usuario_aprovacao;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_ordem_servico_situacao
     * Sample of usage: $var->ordem_servico_situacao = $object;
     * @param $object Instance of OrdemServicoSituacao
     */
    public function set_ordem_servico_situacao(OrdemServicoSituacao $object)
    {
        $this->ordem_servico_situacao = $object;
        $this->ordem_servico_situacao_id = $object->id;
    }

    /**
     * Method get_ordem_servico_situacao
     * Sample of usage: $var->ordem_servico_situacao->attribute;
     * @returns OrdemServicoSituacao instance
     */
    public function get_ordem_servico_situacao()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico_situacao))
            $this->ordem_servico_situacao = new OrdemServicoSituacao($this->ordem_servico_situacao_id);
    
        // returns the associated object
        return $this->ordem_servico_situacao;
    }
    /**
     * Method set_condicao_pagamento
     * Sample of usage: $var->condicao_pagamento = $object;
     * @param $object Instance of CondicaoPagamento
     */
    public function set_condicao_pagamento(CondicaoPagamento $object)
    {
        $this->condicao_pagamento = $object;
        $this->condicao_pagamento_id = $object->id;
    }

    /**
     * Method get_condicao_pagamento
     * Sample of usage: $var->condicao_pagamento->attribute;
     * @returns CondicaoPagamento instance
     */
    public function get_condicao_pagamento()
    {
    
        // loads the associated object
        if (empty($this->condicao_pagamento))
            $this->condicao_pagamento = new CondicaoPagamento($this->condicao_pagamento_id);
    
        // returns the associated object
        return $this->condicao_pagamento;
    }
    /**
     * Method set_cliente_endereco
     * Sample of usage: $var->cliente_endereco = $object;
     * @param $object Instance of ClienteEndereco
     */
    public function set_cliente_endereco(ClienteEndereco $object)
    {
        $this->cliente_endereco = $object;
        $this->cliente_endereco_id = $object->id;
    }

    /**
     * Method get_cliente_endereco
     * Sample of usage: $var->cliente_endereco->attribute;
     * @returns ClienteEndereco instance
     */
    public function get_cliente_endereco()
    {
    
        // loads the associated object
        if (empty($this->cliente_endereco))
            $this->cliente_endereco = new ClienteEndereco($this->cliente_endereco_id);
    
        // returns the associated object
        return $this->cliente_endereco;
    }

    /**
     * Method getOrdemServicoGarantiaHistoricos
     */
    public function getOrdemServicoGarantiaHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_id', '=', $this->id));
        return OrdemServicoGarantiaHistorico::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoHistoricos
     */
    public function getOrdemServicoHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_id', '=', $this->id));
        return OrdemServicoHistorico::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItems
     */
    public function getOrdemServicoItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_id', '=', $this->id));
        return OrdemServicoItem::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoVendas
     */
    public function getOrdemServicoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_id', '=', $this->id));
        return OrdemServicoVenda::getObjects( $criteria );
    }
    /**
     * Method getServicoFormapgtos
     */
    public function getServicoFormapgtos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_id', '=', $this->id));
        return ServicoFormapgto::getObjects( $criteria );
    }

    public function set_ordem_servico_garantia_historico_ordem_servico_to_string($ordem_servico_garantia_historico_ordem_servico_to_string)
    {
        if(is_array($ordem_servico_garantia_historico_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $ordem_servico_garantia_historico_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->ordem_servico_garantia_historico_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_garantia_historico_ordem_servico_to_string = $ordem_servico_garantia_historico_ordem_servico_to_string;
        }

        $this->vdata['ordem_servico_garantia_historico_ordem_servico_to_string'] = $this->ordem_servico_garantia_historico_ordem_servico_to_string;
    }

    public function get_ordem_servico_garantia_historico_ordem_servico_to_string()
    {
        if(!empty($this->ordem_servico_garantia_historico_ordem_servico_to_string))
        {
            return $this->ordem_servico_garantia_historico_ordem_servico_to_string;
        }
    
        $values = OrdemServicoGarantiaHistorico::where('ordem_servico_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_historico_ordem_servico_situacao_to_string($ordem_servico_historico_ordem_servico_situacao_to_string)
    {
        if(is_array($ordem_servico_historico_ordem_servico_situacao_to_string))
        {
            $values = OrdemServicoSituacao::where('id', 'in', $ordem_servico_historico_ordem_servico_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_historico_ordem_servico_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_historico_ordem_servico_situacao_to_string = $ordem_servico_historico_ordem_servico_situacao_to_string;
        }

        $this->vdata['ordem_servico_historico_ordem_servico_situacao_to_string'] = $this->ordem_servico_historico_ordem_servico_situacao_to_string;
    }

    public function get_ordem_servico_historico_ordem_servico_situacao_to_string()
    {
        if(!empty($this->ordem_servico_historico_ordem_servico_situacao_to_string))
        {
            return $this->ordem_servico_historico_ordem_servico_situacao_to_string;
        }
    
        $values = OrdemServicoHistorico::where('ordem_servico_id', '=', $this->id)->getIndexedArray('ordem_servico_situacao_id','{ordem_servico_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_historico_ordem_servico_to_string($ordem_servico_historico_ordem_servico_to_string)
    {
        if(is_array($ordem_servico_historico_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $ordem_servico_historico_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->ordem_servico_historico_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_historico_ordem_servico_to_string = $ordem_servico_historico_ordem_servico_to_string;
        }

        $this->vdata['ordem_servico_historico_ordem_servico_to_string'] = $this->ordem_servico_historico_ordem_servico_to_string;
    }

    public function get_ordem_servico_historico_ordem_servico_to_string()
    {
        if(!empty($this->ordem_servico_historico_ordem_servico_to_string))
        {
            return $this->ordem_servico_historico_ordem_servico_to_string;
        }
    
        $values = OrdemServicoHistorico::where('ordem_servico_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ordem_servico_to_string($ordem_servico_item_ordem_servico_to_string)
    {
        if(is_array($ordem_servico_item_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $ordem_servico_item_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->ordem_servico_item_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ordem_servico_to_string = $ordem_servico_item_ordem_servico_to_string;
        }

        $this->vdata['ordem_servico_item_ordem_servico_to_string'] = $this->ordem_servico_item_ordem_servico_to_string;
    }

    public function get_ordem_servico_item_ordem_servico_to_string()
    {
        if(!empty($this->ordem_servico_item_ordem_servico_to_string))
        {
            return $this->ordem_servico_item_ordem_servico_to_string;
        }
    
        $values = OrdemServicoItem::where('ordem_servico_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_produto_to_string($ordem_servico_item_produto_to_string)
    {
        if(is_array($ordem_servico_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_servico_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_produto_to_string = $ordem_servico_item_produto_to_string;
        }

        $this->vdata['ordem_servico_item_produto_to_string'] = $this->ordem_servico_item_produto_to_string;
    }

    public function get_ordem_servico_item_produto_to_string()
    {
        if(!empty($this->ordem_servico_item_produto_to_string))
        {
            return $this->ordem_servico_item_produto_to_string;
        }
    
        $values = OrdemServicoItem::where('ordem_servico_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_venda_ordem_servico_to_string($ordem_servico_venda_ordem_servico_to_string)
    {
        if(is_array($ordem_servico_venda_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $ordem_servico_venda_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->ordem_servico_venda_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_venda_ordem_servico_to_string = $ordem_servico_venda_ordem_servico_to_string;
        }

        $this->vdata['ordem_servico_venda_ordem_servico_to_string'] = $this->ordem_servico_venda_ordem_servico_to_string;
    }

    public function get_ordem_servico_venda_ordem_servico_to_string()
    {
        if(!empty($this->ordem_servico_venda_ordem_servico_to_string))
        {
            return $this->ordem_servico_venda_ordem_servico_to_string;
        }
    
        $values = OrdemServicoVenda::where('ordem_servico_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_venda_venda_to_string($ordem_servico_venda_venda_to_string)
    {
        if(is_array($ordem_servico_venda_venda_to_string))
        {
            $values = Venda::where('id', 'in', $ordem_servico_venda_venda_to_string)->getIndexedArray('id', 'id');
            $this->ordem_servico_venda_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_venda_venda_to_string = $ordem_servico_venda_venda_to_string;
        }

        $this->vdata['ordem_servico_venda_venda_to_string'] = $this->ordem_servico_venda_venda_to_string;
    }

    public function get_ordem_servico_venda_venda_to_string()
    {
        if(!empty($this->ordem_servico_venda_venda_to_string))
        {
            return $this->ordem_servico_venda_venda_to_string;
        }
    
        $values = OrdemServicoVenda::where('ordem_servico_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_servico_formapgto_forma_pagamento_to_string($servico_formapgto_forma_pagamento_to_string)
    {
        if(is_array($servico_formapgto_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $servico_formapgto_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->servico_formapgto_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->servico_formapgto_forma_pagamento_to_string = $servico_formapgto_forma_pagamento_to_string;
        }

        $this->vdata['servico_formapgto_forma_pagamento_to_string'] = $this->servico_formapgto_forma_pagamento_to_string;
    }

    public function get_servico_formapgto_forma_pagamento_to_string()
    {
        if(!empty($this->servico_formapgto_forma_pagamento_to_string))
        {
            return $this->servico_formapgto_forma_pagamento_to_string;
        }
    
        $values = ServicoFormapgto::where('ordem_servico_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_servico_formapgto_ordem_servico_to_string($servico_formapgto_ordem_servico_to_string)
    {
        if(is_array($servico_formapgto_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $servico_formapgto_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->servico_formapgto_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->servico_formapgto_ordem_servico_to_string = $servico_formapgto_ordem_servico_to_string;
        }

        $this->vdata['servico_formapgto_ordem_servico_to_string'] = $this->servico_formapgto_ordem_servico_to_string;
    }

    public function get_servico_formapgto_ordem_servico_to_string()
    {
        if(!empty($this->servico_formapgto_ordem_servico_to_string))
        {
            return $this->servico_formapgto_ordem_servico_to_string;
        }
    
        $values = ServicoFormapgto::where('ordem_servico_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function get_valor_por_extenso()
    {
        $this->valor = Funcoes::retornaValorPorExtenso();
    }

    public static function GerarVenda($ordemservico)
    {
        $venda = new Venda();
        $venda->system_unit_id = $ordemservico->system_unit_id;
        $venda->filial_saida_id = $ordemservico->system_unit_id;
        $venda->venda_situacao_id = VendaSituacao::EmAndamento;
        $venda->orcamento_id = null;
        $venda->vendedor_id = $ordemservico->vendedor_id;
        $venda->cliente_id = $ordemservico->cliente_id;
        $venda->data_hora_venda = date('Y-m-d H:i:s');
        $venda->data_prev_entrega = date('Y-m-d H:i:s');
        $venda->observacao = $ordemservico->observacoes;
        //$venda->valor_produtos = $ordemservico->valor_produtos;
        $venda->desconto = $ordemservico->desconto;
        //$venda->peso_total = ...
        //$venda->frete_total = ...
        $venda->valor_total = $ordemservico->valor;
        //$venda->tabela_preco_id = ...
        $venda->venda_tipo_pagamento_id = VendaTipoPagamento::Imediato;
        $venda->venda_modalidade_id = VendaModalidade::ClienteRetira;
        $venda->movimentacao_origem_id = MovimentacaoOrigem::kraftweb;
    
        Funcoes::SalvarUsuarioCadastro($venda);
    
        $venda->store();
    
        //itens
        $lista_itens = OrdemServicoItem::where('ordem_servico_id', '=', $ordemservico->id)->load();
    
        if($lista_itens)
        {
            foreach($lista_itens as $item)
            {
                $vendaItem = new VendaItem();
            
                $vendaItem->venda_id = $venda->id;
                $vendaItem->produto_id = $item->produto_id;
                $vendaItem->quantidade = $item->quantidade;
                $vendaItem->valor_unitario = $item->valor_unitario;
                $vendaItem->valor_total = $item->valor_total;
                //$vendaItem->valor_original = ...
                $vendaItem->informacoes_adicionais = $item->observacoes;
                //$vendaItem->numero_pedido = ...
                //$vendaItem->numero_item_pedido = ...
                $vendaItem->cancelado = Resposta::Nao;
            
                $produto_filial = ProdutoFilial::where('produto_id', '=', $item->produto_id)
                                                ->where('system_unit_id', '=', TSession::getValue('userunitid'))->first();
                                            
                if($produto_filial)
                {
                    $vendaItem->valor_custo = number_format($produto_filial->valor_custo, 2, ',', '.');
                    $vendaItem->estoque_deposito_id = $produto_filial->estoque_deposito_id;
                }
            
                $vendaItem->desconto = $item->desconto;
                //$vendaItem->valor_frete = ...
                //$vendaItem->peso_unitario = ...
                //$vendaItem->peso_total = ...
            
                Funcoes::SalvarUsuarioCadastro($vendaItem);
            
                $vendaItem->store();
            }
        }
    
        $ordemservico->ordem_servico_situacao_id = OrdemServicoSituacao::OrcamentoAprovado;
        $ordemservico->store();
    
    }

    public static function ObterProximoNumerOs($ordemservico)
    {
        $OS = OrdemServicoItem::where('ordem_servico_id', '=', $ordemservico->id)->load();
    
        $current_value = $OS->numero_os;
    
        $next_value - $current_value + 1;
    
        return $current_value;
    
        $OS->store();
    }

                                                    
}

