<?php

class OrdemServicoHistorico extends TRecord
{
    const TABLENAME  = 'ordem_servico_historico';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ordem_servico;
    private $ordem_servico_situacao;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('ordem_servico_situacao_id');
        parent::addAttribute('ordem_servico_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_ordem_servico
     * Sample of usage: $var->ordem_servico = $object;
     * @param $object Instance of OrdemServico
     */
    public function set_ordem_servico(OrdemServico $object)
    {
        $this->ordem_servico = $object;
        $this->ordem_servico_id = $object->id;
    }

    /**
     * Method get_ordem_servico
     * Sample of usage: $var->ordem_servico->attribute;
     * @returns OrdemServico instance
     */
    public function get_ordem_servico()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico))
            $this->ordem_servico = new OrdemServico($this->ordem_servico_id);
    
        // returns the associated object
        return $this->ordem_servico;
    }
    /**
     * Method set_ordem_servico_situacao
     * Sample of usage: $var->ordem_servico_situacao = $object;
     * @param $object Instance of OrdemServicoSituacao
     */
    public function set_ordem_servico_situacao(OrdemServicoSituacao $object)
    {
        $this->ordem_servico_situacao = $object;
        $this->ordem_servico_situacao_id = $object->id;
    }

    /**
     * Method get_ordem_servico_situacao
     * Sample of usage: $var->ordem_servico_situacao->attribute;
     * @returns OrdemServicoSituacao instance
     */
    public function get_ordem_servico_situacao()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico_situacao))
            $this->ordem_servico_situacao = new OrdemServicoSituacao($this->ordem_servico_situacao_id);
    
        // returns the associated object
        return $this->ordem_servico_situacao;
    }

    public static function LancarHistorico($ordem_servico_situacao_id, $ordem_servico_id, $descricao)
    {
        $historicosit = new OrdemServicoHistorico;
        $historicosit->ordem_servico_situacao_id = $ordem_servico_situacao_id;
        $historicosit->ordem_servico_id = $ordem_servico_id;
        $historicosit->descricao = $descricao;
        $historicosit->criado_por = TSession::getValue('username');
        $historicosit->store();
    }

    
}

