<?php

class OrdemServicoItem extends TRecord
{
    const TABLENAME  = 'ordem_servico_item';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ordem_servico;
    private $produto;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('ordem_servico_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('descricao_servico');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade');
        parent::addAttribute('quantidade_atendida');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('valor_total');
        parent::addAttribute('desconto');
        parent::addAttribute('arquivo');
        parent::addAttribute('largura');
        parent::addAttribute('altura');
        parent::addAttribute('quantidade_a_faturar');
            
    }

    /**
     * Method set_ordem_servico
     * Sample of usage: $var->ordem_servico = $object;
     * @param $object Instance of OrdemServico
     */
    public function set_ordem_servico(OrdemServico $object)
    {
        $this->ordem_servico = $object;
        $this->ordem_servico_id = $object->id;
    }

    /**
     * Method get_ordem_servico
     * Sample of usage: $var->ordem_servico->attribute;
     * @returns OrdemServico instance
     */
    public function get_ordem_servico()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico))
            $this->ordem_servico = new OrdemServico($this->ordem_servico_id);
    
        // returns the associated object
        return $this->ordem_servico;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }

    /**
     * Method getOrdemServicoItemDespesass
     */
    public function getOrdemServicoItemDespesass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_item_id', '=', $this->id));
        return OrdemServicoItemDespesas::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItemFichaTecnicas
     */
    public function getOrdemServicoItemFichaTecnicas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_item_id', '=', $this->id));
        return OrdemServicoItemFichaTecnica::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItemMaoObras
     */
    public function getOrdemServicoItemMaoObras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_item_id', '=', $this->id));
        return OrdemServicoItemMaoObra::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItemObsEtapass
     */
    public function getOrdemServicoItemObsEtapass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_item_id', '=', $this->id));
        return OrdemServicoItemObsEtapas::getObjects( $criteria );
    }

    public function set_ordem_servico_item_despesas_ordem_servico_item_to_string($ordem_servico_item_despesas_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_despesas_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_despesas_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_despesas_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_despesas_ordem_servico_item_to_string = $ordem_servico_item_despesas_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_despesas_ordem_servico_item_to_string'] = $this->ordem_servico_item_despesas_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_despesas_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_despesas_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_despesas_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemDespesas::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_despesas_despesas_servicos_to_string($ordem_servico_item_despesas_despesas_servicos_to_string)
    {
        if(is_array($ordem_servico_item_despesas_despesas_servicos_to_string))
        {
            $values = DespesasServicos::where('id', 'in', $ordem_servico_item_despesas_despesas_servicos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_despesas_despesas_servicos_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_despesas_despesas_servicos_to_string = $ordem_servico_item_despesas_despesas_servicos_to_string;
        }

        $this->vdata['ordem_servico_item_despesas_despesas_servicos_to_string'] = $this->ordem_servico_item_despesas_despesas_servicos_to_string;
    }

    public function get_ordem_servico_item_despesas_despesas_servicos_to_string()
    {
        if(!empty($this->ordem_servico_item_despesas_despesas_servicos_to_string))
        {
            return $this->ordem_servico_item_despesas_despesas_servicos_to_string;
        }
    
        $values = OrdemServicoItemDespesas::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('despesas_servicos_id','{despesas_servicos->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_despesas_despesas_servicos_tipo_to_string($ordem_servico_item_despesas_despesas_servicos_tipo_to_string)
    {
        if(is_array($ordem_servico_item_despesas_despesas_servicos_tipo_to_string))
        {
            $values = DespesasServicosTipo::where('id', 'in', $ordem_servico_item_despesas_despesas_servicos_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string = $ordem_servico_item_despesas_despesas_servicos_tipo_to_string;
        }

        $this->vdata['ordem_servico_item_despesas_despesas_servicos_tipo_to_string'] = $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string;
    }

    public function get_ordem_servico_item_despesas_despesas_servicos_tipo_to_string()
    {
        if(!empty($this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string))
        {
            return $this->ordem_servico_item_despesas_despesas_servicos_tipo_to_string;
        }
    
        $values = OrdemServicoItemDespesas::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('despesas_servicos_tipo_id','{despesas_servicos_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string($ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string = $ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string'] = $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_produto_to_string($ordem_servico_item_ficha_tecnica_produto_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_servico_item_ficha_tecnica_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_item_ficha_tecnica_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_produto_to_string = $ordem_servico_item_ficha_tecnica_produto_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_produto_to_string'] = $this->ordem_servico_item_ficha_tecnica_produto_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_produto_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_produto_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_produto_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string($ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string))
        {
            $values = Resposta::where('id', 'in', $ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string = $ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string'] = $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('quantidade_fixa_id','{quantidade_fixa->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_mao_obra_ordem_servico_item_to_string($ordem_servico_item_mao_obra_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_mao_obra_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_mao_obra_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string = $ordem_servico_item_mao_obra_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_mao_obra_ordem_servico_item_to_string'] = $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_mao_obra_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_mao_obra_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_mao_obra_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemMaoObra::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_mao_obra_funcionario_to_string($ordem_servico_item_mao_obra_funcionario_to_string)
    {
        if(is_array($ordem_servico_item_mao_obra_funcionario_to_string))
        {
            $values = Funcionario::where('id', 'in', $ordem_servico_item_mao_obra_funcionario_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_item_mao_obra_funcionario_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_mao_obra_funcionario_to_string = $ordem_servico_item_mao_obra_funcionario_to_string;
        }

        $this->vdata['ordem_servico_item_mao_obra_funcionario_to_string'] = $this->ordem_servico_item_mao_obra_funcionario_to_string;
    }

    public function get_ordem_servico_item_mao_obra_funcionario_to_string()
    {
        if(!empty($this->ordem_servico_item_mao_obra_funcionario_to_string))
        {
            return $this->ordem_servico_item_mao_obra_funcionario_to_string;
        }
    
        $values = OrdemServicoItemMaoObra::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('funcionario_id','{funcionario->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_obs_etapas_ordem_servico_item_to_string($ordem_servico_item_obs_etapas_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_obs_etapas_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_obs_etapas_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string = $ordem_servico_item_obs_etapas_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_obs_etapas_ordem_servico_item_to_string'] = $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_obs_etapas_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemObsEtapas::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string($ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string = $ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServicoItemObsEtapas::where('ordem_servico_item_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    
}

