<?php

class OrdemServicoItemDespesas extends TRecord
{
    const TABLENAME  = 'ordem_servico_item_despesas';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $despesas_servicos;
    private $despesas_servicos_tipo;
    private $ordem_servico_item;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('ordem_servico_item_id');
        parent::addAttribute('despesas_servicos_id');
        parent::addAttribute('despesas_servicos_tipo_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_total');
            
    }

    /**
     * Method set_despesas_servicos
     * Sample of usage: $var->despesas_servicos = $object;
     * @param $object Instance of DespesasServicos
     */
    public function set_despesas_servicos(DespesasServicos $object)
    {
        $this->despesas_servicos = $object;
        $this->despesas_servicos_id = $object->id;
    }

    /**
     * Method get_despesas_servicos
     * Sample of usage: $var->despesas_servicos->attribute;
     * @returns DespesasServicos instance
     */
    public function get_despesas_servicos()
    {
    
        // loads the associated object
        if (empty($this->despesas_servicos))
            $this->despesas_servicos = new DespesasServicos($this->despesas_servicos_id);
    
        // returns the associated object
        return $this->despesas_servicos;
    }
    /**
     * Method set_despesas_servicos_tipo
     * Sample of usage: $var->despesas_servicos_tipo = $object;
     * @param $object Instance of DespesasServicosTipo
     */
    public function set_despesas_servicos_tipo(DespesasServicosTipo $object)
    {
        $this->despesas_servicos_tipo = $object;
        $this->despesas_servicos_tipo_id = $object->id;
    }

    /**
     * Method get_despesas_servicos_tipo
     * Sample of usage: $var->despesas_servicos_tipo->attribute;
     * @returns DespesasServicosTipo instance
     */
    public function get_despesas_servicos_tipo()
    {
    
        // loads the associated object
        if (empty($this->despesas_servicos_tipo))
            $this->despesas_servicos_tipo = new DespesasServicosTipo($this->despesas_servicos_tipo_id);
    
        // returns the associated object
        return $this->despesas_servicos_tipo;
    }
    /**
     * Method set_ordem_servico_item
     * Sample of usage: $var->ordem_servico_item = $object;
     * @param $object Instance of OrdemServicoItem
     */
    public function set_ordem_servico_item(OrdemServicoItem $object)
    {
        $this->ordem_servico_item = $object;
        $this->ordem_servico_item_id = $object->id;
    }

    /**
     * Method get_ordem_servico_item
     * Sample of usage: $var->ordem_servico_item->attribute;
     * @returns OrdemServicoItem instance
     */
    public function get_ordem_servico_item()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico_item))
            $this->ordem_servico_item = new OrdemServicoItem($this->ordem_servico_item_id);
    
        // returns the associated object
        return $this->ordem_servico_item;
    }

    
}

