<?php

class OrdemServicoItemFichaTecnica extends TRecord
{
    const TABLENAME  = 'ordem_servico_item_ficha_tecnica';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ordem_servico_item;
    private $produto;
    private $quantidade_fixa;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('ordem_servico_item_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('quantidade_fixa_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade');
        parent::addAttribute('custo');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('valor_total');
        parent::addAttribute('quantidade_original');
            
    }

    /**
     * Method set_ordem_servico_item
     * Sample of usage: $var->ordem_servico_item = $object;
     * @param $object Instance of OrdemServicoItem
     */
    public function set_ordem_servico_item(OrdemServicoItem $object)
    {
        $this->ordem_servico_item = $object;
        $this->ordem_servico_item_id = $object->id;
    }

    /**
     * Method get_ordem_servico_item
     * Sample of usage: $var->ordem_servico_item->attribute;
     * @returns OrdemServicoItem instance
     */
    public function get_ordem_servico_item()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico_item))
            $this->ordem_servico_item = new OrdemServicoItem($this->ordem_servico_item_id);
    
        // returns the associated object
        return $this->ordem_servico_item;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_quantidade_fixa(Resposta $object)
    {
        $this->quantidade_fixa = $object;
        $this->quantidade_fixa_id = $object->id;
    }

    /**
     * Method get_quantidade_fixa
     * Sample of usage: $var->quantidade_fixa->attribute;
     * @returns Resposta instance
     */
    public function get_quantidade_fixa()
    {
    
        // loads the associated object
        if (empty($this->quantidade_fixa))
            $this->quantidade_fixa = new Resposta($this->quantidade_fixa_id);
    
        // returns the associated object
        return $this->quantidade_fixa;
    }

    
}

