<?php

class OrdemServicoItemMaoObra extends TRecord
{
    const TABLENAME  = 'ordem_servico_item_mao_obra';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $ordem_servico_item;
    private $funcionario;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('ordem_servico_item_id');
        parent::addAttribute('funcionario_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade_horas');
        parent::addAttribute('valor_hora');
        parent::addAttribute('valor_total');
        parent::addAttribute('quantidade_horas_original');
            
    }

    /**
     * Method set_ordem_servico_item
     * Sample of usage: $var->ordem_servico_item = $object;
     * @param $object Instance of OrdemServicoItem
     */
    public function set_ordem_servico_item(OrdemServicoItem $object)
    {
        $this->ordem_servico_item = $object;
        $this->ordem_servico_item_id = $object->id;
    }

    /**
     * Method get_ordem_servico_item
     * Sample of usage: $var->ordem_servico_item->attribute;
     * @returns OrdemServicoItem instance
     */
    public function get_ordem_servico_item()
    {
    
        // loads the associated object
        if (empty($this->ordem_servico_item))
            $this->ordem_servico_item = new OrdemServicoItem($this->ordem_servico_item_id);
    
        // returns the associated object
        return $this->ordem_servico_item;
    }
    /**
     * Method set_funcionario
     * Sample of usage: $var->funcionario = $object;
     * @param $object Instance of Funcionario
     */
    public function set_funcionario(Funcionario $object)
    {
        $this->funcionario = $object;
        $this->funcionario_id = $object->id;
    }

    /**
     * Method get_funcionario
     * Sample of usage: $var->funcionario->attribute;
     * @returns Funcionario instance
     */
    public function get_funcionario()
    {
    
        // loads the associated object
        if (empty($this->funcionario))
            $this->funcionario = new Funcionario($this->funcionario_id);
    
        // returns the associated object
        return $this->funcionario;
    }

    
}

