<?php

class OrdemServicoProducaoEtapa extends TRecord
{
    const TABLENAME  = 'ordem_servico_producao_etapa';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('cor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getOrdemServicos
     */
    public function getOrdemServicos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_producao_etapa_id', '=', $this->id));
        return OrdemServico::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItemObsEtapass
     */
    public function getOrdemServicoItemObsEtapass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ordem_servico_producao_etapa_id', '=', $this->id));
        return OrdemServicoItemObsEtapas::getObjects( $criteria );
    }

    public function set_ordem_servico_system_unit_to_string($ordem_servico_system_unit_to_string)
    {
        if(is_array($ordem_servico_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_servico_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_system_unit_to_string = $ordem_servico_system_unit_to_string;
        }

        $this->vdata['ordem_servico_system_unit_to_string'] = $this->ordem_servico_system_unit_to_string;
    }

    public function get_ordem_servico_system_unit_to_string()
    {
        if(!empty($this->ordem_servico_system_unit_to_string))
        {
            return $this->ordem_servico_system_unit_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_to_string($ordem_servico_cliente_to_string)
    {
        if(is_array($ordem_servico_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $ordem_servico_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_to_string = $ordem_servico_cliente_to_string;
        }

        $this->vdata['ordem_servico_cliente_to_string'] = $this->ordem_servico_cliente_to_string;
    }

    public function get_ordem_servico_cliente_to_string()
    {
        if(!empty($this->ordem_servico_cliente_to_string))
        {
            return $this->ordem_servico_cliente_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_contato_to_string($ordem_servico_cliente_contato_to_string)
    {
        if(is_array($ordem_servico_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $ordem_servico_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_contato_to_string = $ordem_servico_cliente_contato_to_string;
        }

        $this->vdata['ordem_servico_cliente_contato_to_string'] = $this->ordem_servico_cliente_contato_to_string;
    }

    public function get_ordem_servico_cliente_contato_to_string()
    {
        if(!empty($this->ordem_servico_cliente_contato_to_string))
        {
            return $this->ordem_servico_cliente_contato_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_vendedor_to_string($ordem_servico_vendedor_to_string)
    {
        if(is_array($ordem_servico_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $ordem_servico_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_vendedor_to_string = $ordem_servico_vendedor_to_string;
        }

        $this->vdata['ordem_servico_vendedor_to_string'] = $this->ordem_servico_vendedor_to_string;
    }

    public function get_ordem_servico_vendedor_to_string()
    {
        if(!empty($this->ordem_servico_vendedor_to_string))
        {
            return $this->ordem_servico_vendedor_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_situacao_to_string($ordem_servico_ordem_servico_situacao_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_situacao_to_string))
        {
            $values = OrdemServicoSituacao::where('id', 'in', $ordem_servico_ordem_servico_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_situacao_to_string = $ordem_servico_ordem_servico_situacao_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_situacao_to_string'] = $this->ordem_servico_ordem_servico_situacao_to_string;
    }

    public function get_ordem_servico_ordem_servico_situacao_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_situacao_to_string))
        {
            return $this->ordem_servico_ordem_servico_situacao_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('ordem_servico_situacao_id','{ordem_servico_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_producao_etapa_to_string($ordem_servico_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = $ordem_servico_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_condicao_pagamento_to_string($ordem_servico_condicao_pagamento_to_string)
    {
        if(is_array($ordem_servico_condicao_pagamento_to_string))
        {
            $values = CondicaoPagamento::where('id', 'in', $ordem_servico_condicao_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_condicao_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_condicao_pagamento_to_string = $ordem_servico_condicao_pagamento_to_string;
        }

        $this->vdata['ordem_servico_condicao_pagamento_to_string'] = $this->ordem_servico_condicao_pagamento_to_string;
    }

    public function get_ordem_servico_condicao_pagamento_to_string()
    {
        if(!empty($this->ordem_servico_condicao_pagamento_to_string))
        {
            return $this->ordem_servico_condicao_pagamento_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('condicao_pagamento_id','{condicao_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_endereco_to_string($ordem_servico_cliente_endereco_to_string)
    {
        if(is_array($ordem_servico_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $ordem_servico_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->ordem_servico_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_endereco_to_string = $ordem_servico_cliente_endereco_to_string;
        }

        $this->vdata['ordem_servico_cliente_endereco_to_string'] = $this->ordem_servico_cliente_endereco_to_string;
    }

    public function get_ordem_servico_cliente_endereco_to_string()
    {
        if(!empty($this->ordem_servico_cliente_endereco_to_string))
        {
            return $this->ordem_servico_cliente_endereco_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_usuario_aprovacao_to_string($ordem_servico_usuario_aprovacao_to_string)
    {
        if(is_array($ordem_servico_usuario_aprovacao_to_string))
        {
            $values = SystemUsers::where('id', 'in', $ordem_servico_usuario_aprovacao_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_usuario_aprovacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_usuario_aprovacao_to_string = $ordem_servico_usuario_aprovacao_to_string;
        }

        $this->vdata['ordem_servico_usuario_aprovacao_to_string'] = $this->ordem_servico_usuario_aprovacao_to_string;
    }

    public function get_ordem_servico_usuario_aprovacao_to_string()
    {
        if(!empty($this->ordem_servico_usuario_aprovacao_to_string))
        {
            return $this->ordem_servico_usuario_aprovacao_to_string;
        }
    
        $values = OrdemServico::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('usuario_aprovacao_id','{usuario_aprovacao->name}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_obs_etapas_ordem_servico_item_to_string($ordem_servico_item_obs_etapas_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_obs_etapas_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_obs_etapas_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string = $ordem_servico_item_obs_etapas_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_obs_etapas_ordem_servico_item_to_string'] = $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_obs_etapas_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_obs_etapas_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemObsEtapas::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string($ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string = $ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_item_obs_etapas_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServicoItemObsEtapas::where('ordem_servico_producao_etapa_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    
}

