<?php

class PainelIndicadorUsuario extends TRecord
{
    const TABLENAME  = 'painel_indicador_usuario';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $painel_indicadores;
    private $indicador_personalizado;
    private $system_users;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('painel_indicadores_id');
        parent::addAttribute('indicador_personalizado_id');
        parent::addAttribute('system_users_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_painel_indicadores
     * Sample of usage: $var->painel_indicadores = $object;
     * @param $object Instance of PainelIndicadores
     */
    public function set_painel_indicadores(PainelIndicadores $object)
    {
        $this->painel_indicadores = $object;
        $this->painel_indicadores_id = $object->id;
    }

    /**
     * Method get_painel_indicadores
     * Sample of usage: $var->painel_indicadores->attribute;
     * @returns PainelIndicadores instance
     */
    public function get_painel_indicadores()
    {
    
        // loads the associated object
        if (empty($this->painel_indicadores))
            $this->painel_indicadores = new PainelIndicadores($this->painel_indicadores_id);
    
        // returns the associated object
        return $this->painel_indicadores;
    }
    /**
     * Method set_indicador_personalizado
     * Sample of usage: $var->indicador_personalizado = $object;
     * @param $object Instance of IndicadorPersonalizado
     */
    public function set_indicador_personalizado(IndicadorPersonalizado $object)
    {
        $this->indicador_personalizado = $object;
        $this->indicador_personalizado_id = $object->id;
    }

    /**
     * Method get_indicador_personalizado
     * Sample of usage: $var->indicador_personalizado->attribute;
     * @returns IndicadorPersonalizado instance
     */
    public function get_indicador_personalizado()
    {
    
        // loads the associated object
        if (empty($this->indicador_personalizado))
            $this->indicador_personalizado = new IndicadorPersonalizado($this->indicador_personalizado_id);
    
        // returns the associated object
        return $this->indicador_personalizado;
    }
    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users(SystemUsers $object)
    {
        $this->system_users = $object;
        $this->system_users_id = $object->id;
    }

    /**
     * Method get_system_users
     * Sample of usage: $var->system_users->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users()
    {
    
        // loads the associated object
        if (empty($this->system_users))
            $this->system_users = new SystemUsers($this->system_users_id);
    
        // returns the associated object
        return $this->system_users;
    }

    
}

