<?php

class Pais extends TRecord
{
    const TABLENAME  = 'pais';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nome');
        parent::addAttribute('codigo_pais');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getCidades
     */
    public function getCidades()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('pais_id', '=', $this->id));
        return Cidade::getObjects( $criteria );
    }

    public function set_cidade_estado_to_string($cidade_estado_to_string)
    {
        if(is_array($cidade_estado_to_string))
        {
            $values = Estado::where('id', 'in', $cidade_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->cidade_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->cidade_estado_to_string = $cidade_estado_to_string;
        }

        $this->vdata['cidade_estado_to_string'] = $this->cidade_estado_to_string;
    }

    public function get_cidade_estado_to_string()
    {
        if(!empty($this->cidade_estado_to_string))
        {
            return $this->cidade_estado_to_string;
        }
    
        $values = Cidade::where('pais_id', '=', $this->id)->getIndexedArray('estado_id','{estado->nome}');
        return implode(', ', $values);
    }

    public function set_cidade_pais_to_string($cidade_pais_to_string)
    {
        if(is_array($cidade_pais_to_string))
        {
            $values = Pais::where('id', 'in', $cidade_pais_to_string)->getIndexedArray('nome', 'nome');
            $this->cidade_pais_to_string = implode(', ', $values);
        }
        else
        {
            $this->cidade_pais_to_string = $cidade_pais_to_string;
        }

        $this->vdata['cidade_pais_to_string'] = $this->cidade_pais_to_string;
    }

    public function get_cidade_pais_to_string()
    {
        if(!empty($this->cidade_pais_to_string))
        {
            return $this->cidade_pais_to_string;
        }
    
        $values = Cidade::where('pais_id', '=', $this->id)->getIndexedArray('pais_id','{pais->nome}');
        return implode(', ', $values);
    }

    
}

