<?php

class Parceiro extends TRecord
{
    const TABLENAME  = 'parceiro';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $tabela_preco;
    private $certificado_venda_modalidade;
    private $vendedor;
    private $banco;
    private $chave_pix_tipo;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('certificado_venda_modalidade_id');
        parent::addAttribute('tabela_preco_id');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('cpf_cnpj');
        parent::addAttribute('nome');
        parent::addAttribute('razao_social');
        parent::addAttribute('cep');
        parent::addAttribute('logradouro');
        parent::addAttribute('bairro');
        parent::addAttribute('cidade');
        parent::addAttribute('estado');
        parent::addAttribute('fone');
        parent::addAttribute('email');
        parent::addAttribute('contato');
        parent::addAttribute('contato_fone');
        parent::addAttribute('comissao_percentual');
        parent::addAttribute('deletado_em');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('banco_id');
        parent::addAttribute('banco_agencia');
        parent::addAttribute('banco_conta');
        parent::addAttribute('banco_chavepix');
        parent::addAttribute('banco_nome_titular');
        parent::addAttribute('banco_cpfcnpj');
        parent::addAttribute('chave_pix_tipo_id');
            
    }

    /**
     * Method set_tabela_preco
     * Sample of usage: $var->tabela_preco = $object;
     * @param $object Instance of TabelaPreco
     */
    public function set_tabela_preco(TabelaPreco $object)
    {
        $this->tabela_preco = $object;
        $this->tabela_preco_id = $object->id;
    }

    /**
     * Method get_tabela_preco
     * Sample of usage: $var->tabela_preco->attribute;
     * @returns TabelaPreco instance
     */
    public function get_tabela_preco()
    {
    
        // loads the associated object
        if (empty($this->tabela_preco))
            $this->tabela_preco = new TabelaPreco($this->tabela_preco_id);
    
        // returns the associated object
        return $this->tabela_preco;
    }
    /**
     * Method set_certificado_venda_modalidade
     * Sample of usage: $var->certificado_venda_modalidade = $object;
     * @param $object Instance of CertificadoVendaModalidade
     */
    public function set_certificado_venda_modalidade(CertificadoVendaModalidade $object)
    {
        $this->certificado_venda_modalidade = $object;
        $this->certificado_venda_modalidade_id = $object->id;
    }

    /**
     * Method get_certificado_venda_modalidade
     * Sample of usage: $var->certificado_venda_modalidade->attribute;
     * @returns CertificadoVendaModalidade instance
     */
    public function get_certificado_venda_modalidade()
    {
    
        // loads the associated object
        if (empty($this->certificado_venda_modalidade))
            $this->certificado_venda_modalidade = new CertificadoVendaModalidade($this->certificado_venda_modalidade_id);
    
        // returns the associated object
        return $this->certificado_venda_modalidade;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_banco
     * Sample of usage: $var->banco = $object;
     * @param $object Instance of Banco
     */
    public function set_banco(Banco $object)
    {
        $this->banco = $object;
        $this->banco_id = $object->id;
    }

    /**
     * Method get_banco
     * Sample of usage: $var->banco->attribute;
     * @returns Banco instance
     */
    public function get_banco()
    {
    
        // loads the associated object
        if (empty($this->banco))
            $this->banco = new Banco($this->banco_id);
    
        // returns the associated object
        return $this->banco;
    }
    /**
     * Method set_chave_pix_tipo
     * Sample of usage: $var->chave_pix_tipo = $object;
     * @param $object Instance of ChavePixTipo
     */
    public function set_chave_pix_tipo(ChavePixTipo $object)
    {
        $this->chave_pix_tipo = $object;
        $this->chave_pix_tipo_id = $object->id;
    }

    /**
     * Method get_chave_pix_tipo
     * Sample of usage: $var->chave_pix_tipo->attribute;
     * @returns ChavePixTipo instance
     */
    public function get_chave_pix_tipo()
    {
    
        // loads the associated object
        if (empty($this->chave_pix_tipo))
            $this->chave_pix_tipo = new ChavePixTipo($this->chave_pix_tipo_id);
    
        // returns the associated object
        return $this->chave_pix_tipo;
    }

    /**
     * Method getCertificadoAgenteRegistros
     */
    public function getCertificadoAgenteRegistros()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('parceiro_id', '=', $this->id));
        return CertificadoAgenteRegistro::getObjects( $criteria );
    }
    /**
     * Method getCertificadoClientes
     */
    public function getCertificadoClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('parceiro_id', '=', $this->id));
        return CertificadoCliente::getObjects( $criteria );
    }
    /**
     * Method getCertificadoVendas
     */
    public function getCertificadoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('parceiro_id', '=', $this->id));
        return CertificadoVenda::getObjects( $criteria );
    }

    public function set_certificado_agente_registro_parceiro_to_string($certificado_agente_registro_parceiro_to_string)
    {
        if(is_array($certificado_agente_registro_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_agente_registro_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_agente_registro_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_agente_registro_parceiro_to_string = $certificado_agente_registro_parceiro_to_string;
        }

        $this->vdata['certificado_agente_registro_parceiro_to_string'] = $this->certificado_agente_registro_parceiro_to_string;
    }

    public function get_certificado_agente_registro_parceiro_to_string()
    {
        if(!empty($this->certificado_agente_registro_parceiro_to_string))
        {
            return $this->certificado_agente_registro_parceiro_to_string;
        }
    
        $values = CertificadoAgenteRegistro::where('parceiro_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_cliente_to_string($certificado_cliente_cliente_to_string)
    {
        if(is_array($certificado_cliente_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_cliente_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_cliente_to_string = $certificado_cliente_cliente_to_string;
        }

        $this->vdata['certificado_cliente_cliente_to_string'] = $this->certificado_cliente_cliente_to_string;
    }

    public function get_certificado_cliente_cliente_to_string()
    {
        if(!empty($this->certificado_cliente_cliente_to_string))
        {
            return $this->certificado_cliente_cliente_to_string;
        }
    
        $values = CertificadoCliente::where('parceiro_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_parceiro_to_string($certificado_cliente_parceiro_to_string)
    {
        if(is_array($certificado_cliente_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_cliente_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_parceiro_to_string = $certificado_cliente_parceiro_to_string;
        }

        $this->vdata['certificado_cliente_parceiro_to_string'] = $this->certificado_cliente_parceiro_to_string;
    }

    public function get_certificado_cliente_parceiro_to_string()
    {
        if(!empty($this->certificado_cliente_parceiro_to_string))
        {
            return $this->certificado_cliente_parceiro_to_string;
        }
    
        $values = CertificadoCliente::where('parceiro_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_produto_to_string($certificado_cliente_produto_to_string)
    {
        if(is_array($certificado_cliente_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_cliente_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_produto_to_string = $certificado_cliente_produto_to_string;
        }

        $this->vdata['certificado_cliente_produto_to_string'] = $this->certificado_cliente_produto_to_string;
    }

    public function get_certificado_cliente_produto_to_string()
    {
        if(!empty($this->certificado_cliente_produto_to_string))
        {
            return $this->certificado_cliente_produto_to_string;
        }
    
        $values = CertificadoCliente::where('parceiro_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_cliente_situacao_to_string($certificado_cliente_certificado_cliente_situacao_to_string)
    {
        if(is_array($certificado_cliente_certificado_cliente_situacao_to_string))
        {
            $values = CertificadoClienteSituacao::where('id', 'in', $certificado_cliente_certificado_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_cliente_certificado_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_cliente_situacao_to_string = $certificado_cliente_certificado_cliente_situacao_to_string;
        }

        $this->vdata['certificado_cliente_certificado_cliente_situacao_to_string'] = $this->certificado_cliente_certificado_cliente_situacao_to_string;
    }

    public function get_certificado_cliente_certificado_cliente_situacao_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_cliente_situacao_to_string))
        {
            return $this->certificado_cliente_certificado_cliente_situacao_to_string;
        }
    
        $values = CertificadoCliente::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_cliente_situacao_id','{certificado_cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_venda_to_string($certificado_cliente_certificado_venda_to_string)
    {
        if(is_array($certificado_cliente_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_cliente_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_cliente_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_venda_to_string = $certificado_cliente_certificado_venda_to_string;
        }

        $this->vdata['certificado_cliente_certificado_venda_to_string'] = $this->certificado_cliente_certificado_venda_to_string;
    }

    public function get_certificado_cliente_certificado_venda_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_venda_to_string))
        {
            return $this->certificado_cliente_certificado_venda_to_string;
        }
    
        $values = CertificadoCliente::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_system_unit_to_string($certificado_venda_system_unit_to_string)
    {
        if(is_array($certificado_venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $certificado_venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->certificado_venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_system_unit_to_string = $certificado_venda_system_unit_to_string;
        }

        $this->vdata['certificado_venda_system_unit_to_string'] = $this->certificado_venda_system_unit_to_string;
    }

    public function get_certificado_venda_system_unit_to_string()
    {
        if(!empty($this->certificado_venda_system_unit_to_string))
        {
            return $this->certificado_venda_system_unit_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_cliente_to_string($certificado_venda_cliente_to_string)
    {
        if(is_array($certificado_venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_cliente_to_string = $certificado_venda_cliente_to_string;
        }

        $this->vdata['certificado_venda_cliente_to_string'] = $this->certificado_venda_cliente_to_string;
    }

    public function get_certificado_venda_cliente_to_string()
    {
        if(!empty($this->certificado_venda_cliente_to_string))
        {
            return $this->certificado_venda_cliente_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_produto_to_string($certificado_venda_produto_to_string)
    {
        if(is_array($certificado_venda_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_venda_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_produto_to_string = $certificado_venda_produto_to_string;
        }

        $this->vdata['certificado_venda_produto_to_string'] = $this->certificado_venda_produto_to_string;
    }

    public function get_certificado_venda_produto_to_string()
    {
        if(!empty($this->certificado_venda_produto_to_string))
        {
            return $this->certificado_venda_produto_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_parceiro_to_string($certificado_venda_parceiro_to_string)
    {
        if(is_array($certificado_venda_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_venda_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_parceiro_to_string = $certificado_venda_parceiro_to_string;
        }

        $this->vdata['certificado_venda_parceiro_to_string'] = $this->certificado_venda_parceiro_to_string;
    }

    public function get_certificado_venda_parceiro_to_string()
    {
        if(!empty($this->certificado_venda_parceiro_to_string))
        {
            return $this->certificado_venda_parceiro_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_agente_registro_to_string($certificado_venda_certificado_agente_registro_to_string)
    {
        if(is_array($certificado_venda_certificado_agente_registro_to_string))
        {
            $values = CertificadoAgenteRegistro::where('id', 'in', $certificado_venda_certificado_agente_registro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificado_agente_registro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_agente_registro_to_string = $certificado_venda_certificado_agente_registro_to_string;
        }

        $this->vdata['certificado_venda_certificado_agente_registro_to_string'] = $this->certificado_venda_certificado_agente_registro_to_string;
    }

    public function get_certificado_venda_certificado_agente_registro_to_string()
    {
        if(!empty($this->certificado_venda_certificado_agente_registro_to_string))
        {
            return $this->certificado_venda_certificado_agente_registro_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_agente_registro_id','{certificado_agente_registro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_situacao_to_string($certificado_venda_certificado_venda_situacao_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_situacao_to_string))
        {
            $values = CertificadoVendaSituacao::where('id', 'in', $certificado_venda_certificado_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_situacao_to_string = $certificado_venda_certificado_venda_situacao_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_situacao_to_string'] = $this->certificado_venda_certificado_venda_situacao_to_string;
    }

    public function get_certificado_venda_certificado_venda_situacao_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_situacao_to_string))
        {
            return $this->certificado_venda_certificado_venda_situacao_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_venda_situacao_id','{certificado_venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_modalidade_to_string($certificado_venda_certificado_venda_modalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $certificado_venda_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_modalidade_to_string = $certificado_venda_certificado_venda_modalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_modalidade_to_string'] = $this->certificado_venda_certificado_venda_modalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_modalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_modalidade_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_tipomodalidade_to_string($certificado_venda_certificado_venda_tipomodalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            $values = CertificadoVendaTipomodalidade::where('id', 'in', $certificado_venda_certificado_venda_tipomodalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = $certificado_venda_certificado_venda_tipomodalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_tipomodalidade_to_string'] = $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_tipomodalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_venda_tipomodalidade_id','{certificado_venda_tipomodalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_repasse_to_string($certificado_venda_certificado_tipo_repasse_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_repasse_to_string))
        {
            $values = CertificadoTipoRepasse::where('id', 'in', $certificado_venda_certificado_tipo_repasse_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_repasse_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_repasse_to_string = $certificado_venda_certificado_tipo_repasse_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_repasse_to_string'] = $this->certificado_venda_certificado_tipo_repasse_to_string;
    }

    public function get_certificado_venda_certificado_tipo_repasse_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_repasse_to_string))
        {
            return $this->certificado_venda_certificado_tipo_repasse_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_tipo_repasse_id','{certificado_tipo_repasse->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_vendedor_to_string($certificado_venda_vendedor_to_string)
    {
        if(is_array($certificado_venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $certificado_venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_vendedor_to_string = $certificado_venda_vendedor_to_string;
        }

        $this->vdata['certificado_venda_vendedor_to_string'] = $this->certificado_venda_vendedor_to_string;
    }

    public function get_certificado_venda_vendedor_to_string()
    {
        if(!empty($this->certificado_venda_vendedor_to_string))
        {
            return $this->certificado_venda_vendedor_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_tabela_preco_to_string($certificado_venda_tabela_preco_to_string)
    {
        if(is_array($certificado_venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $certificado_venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_tabela_preco_to_string = $certificado_venda_tabela_preco_to_string;
        }

        $this->vdata['certificado_venda_tabela_preco_to_string'] = $this->certificado_venda_tabela_preco_to_string;
    }

    public function get_certificado_venda_tabela_preco_to_string()
    {
        if(!empty($this->certificado_venda_tabela_preco_to_string))
        {
            return $this->certificado_venda_tabela_preco_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificadora_to_string($certificado_venda_certificadora_to_string)
    {
        if(is_array($certificado_venda_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificado_venda_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificadora_to_string = $certificado_venda_certificadora_to_string;
        }

        $this->vdata['certificado_venda_certificadora_to_string'] = $this->certificado_venda_certificadora_to_string;
    }

    public function get_certificado_venda_certificadora_to_string()
    {
        if(!empty($this->certificado_venda_certificadora_to_string))
        {
            return $this->certificado_venda_certificadora_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_atendimento_to_string($certificado_venda_certificado_tipo_atendimento_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_atendimento_to_string))
        {
            $values = CertificadoTipoAtendimento::where('id', 'in', $certificado_venda_certificado_tipo_atendimento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_atendimento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_atendimento_to_string = $certificado_venda_certificado_tipo_atendimento_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_atendimento_to_string'] = $this->certificado_venda_certificado_tipo_atendimento_to_string;
    }

    public function get_certificado_venda_certificado_tipo_atendimento_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_atendimento_to_string))
        {
            return $this->certificado_venda_certificado_tipo_atendimento_to_string;
        }
    
        $values = CertificadoVenda::where('parceiro_id', '=', $this->id)->getIndexedArray('certificado_tipo_atendimento_id','{certificado_tipo_atendimento->descricao}');
        return implode(', ', $values);
    }

    
}

