<?php

class PedidoEvento extends TRecord
{
    const TABLENAME  = 'pedido_evento';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATED_BY_UNIT_ID  = 'system_unit_id';

    const UPDATED_BY_USER_ID  = 'system_users_id';

    const DELETEDAT  = 'deleted_at';
    const CREATEDAT  = 'created_at';
    const UPDATEDAT  = 'update_at';

    private $system_users;
    private $system_unit;
    private $notafiscal;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('notafiscal_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('system_users_id');
        parent::addAttribute('chave');
        parent::addAttribute('descricao');
        parent::addAttribute('tipo');
        parent::addAttribute('numero');
        parent::addAttribute('serie');
        parent::addAttribute('nseqevento');
        parent::addAttribute('protocolo');
        parent::addAttribute('status');
        parent::addAttribute('protocolo_resposta');
        parent::addAttribute('xevento');
        parent::addAttribute('created_at');
        parent::addAttribute('update_at');
        parent::addAttribute('deleted_at');
    
    }

    /**
     * Method set_system_users
     * Sample of usage: $var->system_users = $object;
     * @param $object Instance of SystemUsers
     */
    public function set_system_users(SystemUsers $object)
    {
        $this->system_users = $object;
        $this->system_users_id = $object->id;
    }

    /**
     * Method get_system_users
     * Sample of usage: $var->system_users->attribute;
     * @returns SystemUsers instance
     */
    public function get_system_users()
    {
    
        // loads the associated object
        if (empty($this->system_users))
            $this->system_users = new SystemUsers($this->system_users_id);
    
        // returns the associated object
        return $this->system_users;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_notafiscal
     * Sample of usage: $var->notafiscal = $object;
     * @param $object Instance of Notafiscal
     */
    public function set_notafiscal(Notafiscal $object)
    {
        $this->notafiscal = $object;
        $this->notafiscal_id = $object->id;
    }

    /**
     * Method get_notafiscal
     * Sample of usage: $var->notafiscal->attribute;
     * @returns Notafiscal instance
     */
    public function get_notafiscal()
    {
    
        // loads the associated object
        if (empty($this->notafiscal))
            $this->notafiscal = new Notafiscal($this->notafiscal_id);
    
        // returns the associated object
        return $this->notafiscal;
    }

public function get_situacao_evento() 
{
    if ($this->status == 2) {
        return '<span class="badge bg-success text-white">Sucesso! 🟢</span>';
    } elseif ( $this->status==4) {
        return '<span class="badge bg-warning text-dark">Rejeitada 🟠</span>';
    } else {
        return '<span class="badge bg-primary text-white">Aguardando 🔵</span>';
    }
}

            
         
public function get_status_tipo() 
{
    if ($this->tipo == 'cancelado') {
        return '<span class="badge bg-secondary text-white">Cancelamento</span>';  
    } else {
        return '<span class="badge bg-warning text-white">Carta de correção</span>';
    }
}

            
        
}

