<?php

class PlanoContaTipo extends TRecord
{
    const TABLENAME  = 'plano_conta_tipo';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Sintetico = '1';
    const Analitico = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getPlanoContas
     */
    public function getPlanoContas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('plano_conta_tipo_id', '=', $this->id));
        return PlanoConta::getObjects( $criteria );
    }

    public function set_plano_conta_system_unit_to_string($plano_conta_system_unit_to_string)
    {
        if(is_array($plano_conta_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $plano_conta_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->plano_conta_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->plano_conta_system_unit_to_string = $plano_conta_system_unit_to_string;
        }

        $this->vdata['plano_conta_system_unit_to_string'] = $this->plano_conta_system_unit_to_string;
    }

    public function get_plano_conta_system_unit_to_string()
    {
        if(!empty($this->plano_conta_system_unit_to_string))
        {
            return $this->plano_conta_system_unit_to_string;
        }
    
        $values = PlanoConta::where('plano_conta_tipo_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_plano_conta_plano_conta_tipo_to_string($plano_conta_plano_conta_tipo_to_string)
    {
        if(is_array($plano_conta_plano_conta_tipo_to_string))
        {
            $values = PlanoContaTipo::where('id', 'in', $plano_conta_plano_conta_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->plano_conta_plano_conta_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->plano_conta_plano_conta_tipo_to_string = $plano_conta_plano_conta_tipo_to_string;
        }

        $this->vdata['plano_conta_plano_conta_tipo_to_string'] = $this->plano_conta_plano_conta_tipo_to_string;
    }

    public function get_plano_conta_plano_conta_tipo_to_string()
    {
        if(!empty($this->plano_conta_plano_conta_tipo_to_string))
        {
            return $this->plano_conta_plano_conta_tipo_to_string;
        }
    
        $values = PlanoConta::where('plano_conta_tipo_id', '=', $this->id)->getIndexedArray('plano_conta_tipo_id','{plano_conta_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_plano_conta_plano_conta_origem_to_string($plano_conta_plano_conta_origem_to_string)
    {
        if(is_array($plano_conta_plano_conta_origem_to_string))
        {
            $values = PlanoContaOrigem::where('id', 'in', $plano_conta_plano_conta_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->plano_conta_plano_conta_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->plano_conta_plano_conta_origem_to_string = $plano_conta_plano_conta_origem_to_string;
        }

        $this->vdata['plano_conta_plano_conta_origem_to_string'] = $this->plano_conta_plano_conta_origem_to_string;
    }

    public function get_plano_conta_plano_conta_origem_to_string()
    {
        if(!empty($this->plano_conta_plano_conta_origem_to_string))
        {
            return $this->plano_conta_plano_conta_origem_to_string;
        }
    
        $values = PlanoConta::where('plano_conta_tipo_id', '=', $this->id)->getIndexedArray('plano_conta_origem_id','{plano_conta_origem->descricao}');
        return implode(', ', $values);
    }

    
}

