<?php

class Produto extends TRecord
{
    const TABLENAME  = 'produto';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto_grupo;
    private $unidade_medida;
    private $tipo_recurso;
    private $produto_fabricante;
    private $produtogrupo_subgrupo;
    private $notafiscal_item_orig;
    private $habilitado;
    private $produto_tipo;
    private $produto_embalagem;

    const Evento_ProdutoAbaixoDoMinimo = 'Produto abaixo do mínimo';

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_grupo_id');
        parent::addAttribute('unidade_medida_id');
        parent::addAttribute('tipo_recurso_id');
        parent::addAttribute('produto_fabricante_id');
        parent::addAttribute('produtogrupo_subgrupo_id');
        parent::addAttribute('notafiscal_item_orig_id');
        parent::addAttribute('nome');
        parent::addAttribute('nome_curto');
        parent::addAttribute('codigo_EAN');
        parent::addAttribute('imagem');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('ncm');
        parent::addAttribute('cest');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
        parent::addAttribute('obs');
        parent::addAttribute('referencia');
        parent::addAttribute('deletado_em');
        parent::addAttribute('especificacao');
        parent::addAttribute('link_site');
        parent::addAttribute('peso_liquido');
        parent::addAttribute('peso_bruto');
        parent::addAttribute('habilitado_id');
        parent::addAttribute('produto_tipo_id');
        parent::addAttribute('codigo_sku');
        parent::addAttribute('largura');
        parent::addAttribute('altura');
        parent::addAttribute('comprimento');
        parent::addAttribute('diametro');
        parent::addAttribute('dias_preparacao');
        parent::addAttribute('marca');
        parent::addAttribute('garantia');
        parent::addAttribute('unidade_caixa');
        parent::addAttribute('produto_embalagem_id');
    
    }

    /**
     * Method set_produto_grupo
     * Sample of usage: $var->produto_grupo = $object;
     * @param $object Instance of ProdutoGrupo
     */
    public function set_produto_grupo(ProdutoGrupo $object)
    {
        $this->produto_grupo = $object;
        $this->produto_grupo_id = $object->id;
    }

    /**
     * Method get_produto_grupo
     * Sample of usage: $var->produto_grupo->attribute;
     * @returns ProdutoGrupo instance
     */
    public function get_produto_grupo()
    {
    
        // loads the associated object
        if (empty($this->produto_grupo))
            $this->produto_grupo = new ProdutoGrupo($this->produto_grupo_id);
    
        // returns the associated object
        return $this->produto_grupo;
    }
    /**
     * Method set_unidade_medida
     * Sample of usage: $var->unidade_medida = $object;
     * @param $object Instance of UnidadeMedida
     */
    public function set_unidade_medida(UnidadeMedida $object)
    {
        $this->unidade_medida = $object;
        $this->unidade_medida_id = $object->id;
    }

    /**
     * Method get_unidade_medida
     * Sample of usage: $var->unidade_medida->attribute;
     * @returns UnidadeMedida instance
     */
    public function get_unidade_medida()
    {
    
        // loads the associated object
        if (empty($this->unidade_medida))
            $this->unidade_medida = new UnidadeMedida($this->unidade_medida_id);
    
        // returns the associated object
        return $this->unidade_medida;
    }
    /**
     * Method set_tipo_recurso
     * Sample of usage: $var->tipo_recurso = $object;
     * @param $object Instance of TipoRecurso
     */
    public function set_tipo_recurso(TipoRecurso $object)
    {
        $this->tipo_recurso = $object;
        $this->tipo_recurso_id = $object->id;
    }

    /**
     * Method get_tipo_recurso
     * Sample of usage: $var->tipo_recurso->attribute;
     * @returns TipoRecurso instance
     */
    public function get_tipo_recurso()
    {
    
        // loads the associated object
        if (empty($this->tipo_recurso))
            $this->tipo_recurso = new TipoRecurso($this->tipo_recurso_id);
    
        // returns the associated object
        return $this->tipo_recurso;
    }
    /**
     * Method set_produto_fabricante
     * Sample of usage: $var->produto_fabricante = $object;
     * @param $object Instance of ProdutoFabricante
     */
    public function set_produto_fabricante(ProdutoFabricante $object)
    {
        $this->produto_fabricante = $object;
        $this->produto_fabricante_id = $object->id;
    }

    /**
     * Method get_produto_fabricante
     * Sample of usage: $var->produto_fabricante->attribute;
     * @returns ProdutoFabricante instance
     */
    public function get_produto_fabricante()
    {
    
        // loads the associated object
        if (empty($this->produto_fabricante))
            $this->produto_fabricante = new ProdutoFabricante($this->produto_fabricante_id);
    
        // returns the associated object
        return $this->produto_fabricante;
    }
    /**
     * Method set_produtogrupo_subgrupo
     * Sample of usage: $var->produtogrupo_subgrupo = $object;
     * @param $object Instance of ProdutogrupoSubgrupo
     */
    public function set_produtogrupo_subgrupo(ProdutogrupoSubgrupo $object)
    {
        $this->produtogrupo_subgrupo = $object;
        $this->produtogrupo_subgrupo_id = $object->id;
    }

    /**
     * Method get_produtogrupo_subgrupo
     * Sample of usage: $var->produtogrupo_subgrupo->attribute;
     * @returns ProdutogrupoSubgrupo instance
     */
    public function get_produtogrupo_subgrupo()
    {
    
        // loads the associated object
        if (empty($this->produtogrupo_subgrupo))
            $this->produtogrupo_subgrupo = new ProdutogrupoSubgrupo($this->produtogrupo_subgrupo_id);
    
        // returns the associated object
        return $this->produtogrupo_subgrupo;
    }
    /**
     * Method set_notafiscal_item_orig
     * Sample of usage: $var->notafiscal_item_orig = $object;
     * @param $object Instance of NotafiscalItemOrig
     */
    public function set_notafiscal_item_orig(NotafiscalItemOrig $object)
    {
        $this->notafiscal_item_orig = $object;
        $this->notafiscal_item_orig_id = $object->id;
    }

    /**
     * Method get_notafiscal_item_orig
     * Sample of usage: $var->notafiscal_item_orig->attribute;
     * @returns NotafiscalItemOrig instance
     */
    public function get_notafiscal_item_orig()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_item_orig))
            $this->notafiscal_item_orig = new NotafiscalItemOrig($this->notafiscal_item_orig_id);
    
        // returns the associated object
        return $this->notafiscal_item_orig;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_habilitado(Resposta $object)
    {
        $this->habilitado = $object;
        $this->habilitado_id = $object->id;
    }

    /**
     * Method get_habilitado
     * Sample of usage: $var->habilitado->attribute;
     * @returns Resposta instance
     */
    public function get_habilitado()
    {
    
        // loads the associated object
        if (empty($this->habilitado))
            $this->habilitado = new Resposta($this->habilitado_id);
    
        // returns the associated object
        return $this->habilitado;
    }
    /**
     * Method set_produto_tipo
     * Sample of usage: $var->produto_tipo = $object;
     * @param $object Instance of ProdutoTipo
     */
    public function set_produto_tipo(ProdutoTipo $object)
    {
        $this->produto_tipo = $object;
        $this->produto_tipo_id = $object->id;
    }

    /**
     * Method get_produto_tipo
     * Sample of usage: $var->produto_tipo->attribute;
     * @returns ProdutoTipo instance
     */
    public function get_produto_tipo()
    {
    
        // loads the associated object
        if (empty($this->produto_tipo))
            $this->produto_tipo = new ProdutoTipo($this->produto_tipo_id);
    
        // returns the associated object
        return $this->produto_tipo;
    }
    /**
     * Method set_produto_embalagem
     * Sample of usage: $var->produto_embalagem = $object;
     * @param $object Instance of ProdutoEmbalagem
     */
    public function set_produto_embalagem(ProdutoEmbalagem $object)
    {
        $this->produto_embalagem = $object;
        $this->produto_embalagem_id = $object->id;
    }

    /**
     * Method get_produto_embalagem
     * Sample of usage: $var->produto_embalagem->attribute;
     * @returns ProdutoEmbalagem instance
     */
    public function get_produto_embalagem()
    {
    
        // loads the associated object
        if (empty($this->produto_embalagem))
            $this->produto_embalagem = new ProdutoEmbalagem($this->produto_embalagem_id);
    
        // returns the associated object
        return $this->produto_embalagem;
    }

    /**
     * Method getCertificadoClientes
     */
    public function getCertificadoClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return CertificadoCliente::getObjects( $criteria );
    }
    /**
     * Method getCertificadoraProdutoss
     */
    public function getCertificadoraProdutoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return CertificadoraProdutos::getObjects( $criteria );
    }
    /**
     * Method getCertificadoVendas
     */
    public function getCertificadoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return CertificadoVenda::getObjects( $criteria );
    }
    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }
    /**
     * Method getEstoqueSaldoss
     */
    public function getEstoqueSaldoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return EstoqueSaldos::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaoProdutoss
     */
    public function getNaturezaOperacaoProdutoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return NaturezaOperacaoProdutos::getObjects( $criteria );
    }
    /**
     * Method getNegocioItenss
     */
    public function getNegocioItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return NegocioItens::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompraItenss
     */
    public function getNotaFiscalCompraItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return NotaFiscalCompraItens::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalItenss
     */
    public function getNotafiscalItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return NotafiscalItens::getObjects( $criteria );
    }
    /**
     * Method getOrcamentoItems
     */
    public function getOrcamentoItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return OrcamentoItem::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaos
     */
    public function getOrdemProducaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return OrdemProducao::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoItenss
     */
    public function getOrdemProducaoItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return OrdemProducaoItens::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItems
     */
    public function getOrdemServicoItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return OrdemServicoItem::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItemFichaTecnicas
     */
    public function getOrdemServicoItemFichaTecnicas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return OrdemServicoItemFichaTecnica::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicas
     */
    public function getProdutoFichaTecnicas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return ProdutoFichaTecnica::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaItenss
     */
    public function getProdutoFichaTecnicaItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return ProdutoFichaTecnicaItens::getObjects( $criteria );
    }
    /**
     * Method getProdutoFilials
     */
    public function getProdutoFilials()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return ProdutoFilial::getObjects( $criteria );
    }
    /**
     * Method getProdutoFilialHistoricos
     */
    public function getProdutoFilialHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return ProdutoFilialHistorico::getObjects( $criteria );
    }
    /**
     * Method getProdutoFornecedors
     */
    public function getProdutoFornecedors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return ProdutoFornecedor::getObjects( $criteria );
    }
    /**
     * Method getProdutoLotes
     */
    public function getProdutoLotes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return ProdutoLote::getObjects( $criteria );
    }
    /**
     * Method getVendaDevolucaoItenss
     */
    public function getVendaDevolucaoItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return VendaDevolucaoItens::getObjects( $criteria );
    }
    /**
     * Method getVendaDevolucaoTrocas
     */
    public function getVendaDevolucaoTrocas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return VendaDevolucaoTroca::getObjects( $criteria );
    }
    /**
     * Method getVendaItems
     */
    public function getVendaItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_id', '=', $this->id));
        return VendaItem::getObjects( $criteria );
    }

    public function set_certificado_cliente_cliente_to_string($certificado_cliente_cliente_to_string)
    {
        if(is_array($certificado_cliente_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_cliente_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_cliente_to_string = $certificado_cliente_cliente_to_string;
        }

        $this->vdata['certificado_cliente_cliente_to_string'] = $this->certificado_cliente_cliente_to_string;
    }

    public function get_certificado_cliente_cliente_to_string()
    {
        if(!empty($this->certificado_cliente_cliente_to_string))
        {
            return $this->certificado_cliente_cliente_to_string;
        }
    
        $values = CertificadoCliente::where('produto_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_parceiro_to_string($certificado_cliente_parceiro_to_string)
    {
        if(is_array($certificado_cliente_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_cliente_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_parceiro_to_string = $certificado_cliente_parceiro_to_string;
        }

        $this->vdata['certificado_cliente_parceiro_to_string'] = $this->certificado_cliente_parceiro_to_string;
    }

    public function get_certificado_cliente_parceiro_to_string()
    {
        if(!empty($this->certificado_cliente_parceiro_to_string))
        {
            return $this->certificado_cliente_parceiro_to_string;
        }
    
        $values = CertificadoCliente::where('produto_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_produto_to_string($certificado_cliente_produto_to_string)
    {
        if(is_array($certificado_cliente_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_cliente_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_cliente_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_produto_to_string = $certificado_cliente_produto_to_string;
        }

        $this->vdata['certificado_cliente_produto_to_string'] = $this->certificado_cliente_produto_to_string;
    }

    public function get_certificado_cliente_produto_to_string()
    {
        if(!empty($this->certificado_cliente_produto_to_string))
        {
            return $this->certificado_cliente_produto_to_string;
        }
    
        $values = CertificadoCliente::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_cliente_situacao_to_string($certificado_cliente_certificado_cliente_situacao_to_string)
    {
        if(is_array($certificado_cliente_certificado_cliente_situacao_to_string))
        {
            $values = CertificadoClienteSituacao::where('id', 'in', $certificado_cliente_certificado_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_cliente_certificado_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_cliente_situacao_to_string = $certificado_cliente_certificado_cliente_situacao_to_string;
        }

        $this->vdata['certificado_cliente_certificado_cliente_situacao_to_string'] = $this->certificado_cliente_certificado_cliente_situacao_to_string;
    }

    public function get_certificado_cliente_certificado_cliente_situacao_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_cliente_situacao_to_string))
        {
            return $this->certificado_cliente_certificado_cliente_situacao_to_string;
        }
    
        $values = CertificadoCliente::where('produto_id', '=', $this->id)->getIndexedArray('certificado_cliente_situacao_id','{certificado_cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_cliente_certificado_venda_to_string($certificado_cliente_certificado_venda_to_string)
    {
        if(is_array($certificado_cliente_certificado_venda_to_string))
        {
            $values = CertificadoVenda::where('id', 'in', $certificado_cliente_certificado_venda_to_string)->getIndexedArray('id', 'id');
            $this->certificado_cliente_certificado_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_cliente_certificado_venda_to_string = $certificado_cliente_certificado_venda_to_string;
        }

        $this->vdata['certificado_cliente_certificado_venda_to_string'] = $this->certificado_cliente_certificado_venda_to_string;
    }

    public function get_certificado_cliente_certificado_venda_to_string()
    {
        if(!empty($this->certificado_cliente_certificado_venda_to_string))
        {
            return $this->certificado_cliente_certificado_venda_to_string;
        }
    
        $values = CertificadoCliente::where('produto_id', '=', $this->id)->getIndexedArray('certificado_venda_id','{certificado_venda->id}');
        return implode(', ', $values);
    }

    public function set_certificadora_produtos_certificadora_to_string($certificadora_produtos_certificadora_to_string)
    {
        if(is_array($certificadora_produtos_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificadora_produtos_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificadora_produtos_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificadora_produtos_certificadora_to_string = $certificadora_produtos_certificadora_to_string;
        }

        $this->vdata['certificadora_produtos_certificadora_to_string'] = $this->certificadora_produtos_certificadora_to_string;
    }

    public function get_certificadora_produtos_certificadora_to_string()
    {
        if(!empty($this->certificadora_produtos_certificadora_to_string))
        {
            return $this->certificadora_produtos_certificadora_to_string;
        }
    
        $values = CertificadoraProdutos::where('produto_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificadora_produtos_produto_to_string($certificadora_produtos_produto_to_string)
    {
        if(is_array($certificadora_produtos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificadora_produtos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificadora_produtos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificadora_produtos_produto_to_string = $certificadora_produtos_produto_to_string;
        }

        $this->vdata['certificadora_produtos_produto_to_string'] = $this->certificadora_produtos_produto_to_string;
    }

    public function get_certificadora_produtos_produto_to_string()
    {
        if(!empty($this->certificadora_produtos_produto_to_string))
        {
            return $this->certificadora_produtos_produto_to_string;
        }
    
        $values = CertificadoraProdutos::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_system_unit_to_string($certificado_venda_system_unit_to_string)
    {
        if(is_array($certificado_venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $certificado_venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->certificado_venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_system_unit_to_string = $certificado_venda_system_unit_to_string;
        }

        $this->vdata['certificado_venda_system_unit_to_string'] = $this->certificado_venda_system_unit_to_string;
    }

    public function get_certificado_venda_system_unit_to_string()
    {
        if(!empty($this->certificado_venda_system_unit_to_string))
        {
            return $this->certificado_venda_system_unit_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_cliente_to_string($certificado_venda_cliente_to_string)
    {
        if(is_array($certificado_venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_cliente_to_string = $certificado_venda_cliente_to_string;
        }

        $this->vdata['certificado_venda_cliente_to_string'] = $this->certificado_venda_cliente_to_string;
    }

    public function get_certificado_venda_cliente_to_string()
    {
        if(!empty($this->certificado_venda_cliente_to_string))
        {
            return $this->certificado_venda_cliente_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_produto_to_string($certificado_venda_produto_to_string)
    {
        if(is_array($certificado_venda_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_venda_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_produto_to_string = $certificado_venda_produto_to_string;
        }

        $this->vdata['certificado_venda_produto_to_string'] = $this->certificado_venda_produto_to_string;
    }

    public function get_certificado_venda_produto_to_string()
    {
        if(!empty($this->certificado_venda_produto_to_string))
        {
            return $this->certificado_venda_produto_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_parceiro_to_string($certificado_venda_parceiro_to_string)
    {
        if(is_array($certificado_venda_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_venda_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_parceiro_to_string = $certificado_venda_parceiro_to_string;
        }

        $this->vdata['certificado_venda_parceiro_to_string'] = $this->certificado_venda_parceiro_to_string;
    }

    public function get_certificado_venda_parceiro_to_string()
    {
        if(!empty($this->certificado_venda_parceiro_to_string))
        {
            return $this->certificado_venda_parceiro_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_agente_registro_to_string($certificado_venda_certificado_agente_registro_to_string)
    {
        if(is_array($certificado_venda_certificado_agente_registro_to_string))
        {
            $values = CertificadoAgenteRegistro::where('id', 'in', $certificado_venda_certificado_agente_registro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificado_agente_registro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_agente_registro_to_string = $certificado_venda_certificado_agente_registro_to_string;
        }

        $this->vdata['certificado_venda_certificado_agente_registro_to_string'] = $this->certificado_venda_certificado_agente_registro_to_string;
    }

    public function get_certificado_venda_certificado_agente_registro_to_string()
    {
        if(!empty($this->certificado_venda_certificado_agente_registro_to_string))
        {
            return $this->certificado_venda_certificado_agente_registro_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('certificado_agente_registro_id','{certificado_agente_registro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_situacao_to_string($certificado_venda_certificado_venda_situacao_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_situacao_to_string))
        {
            $values = CertificadoVendaSituacao::where('id', 'in', $certificado_venda_certificado_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_situacao_to_string = $certificado_venda_certificado_venda_situacao_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_situacao_to_string'] = $this->certificado_venda_certificado_venda_situacao_to_string;
    }

    public function get_certificado_venda_certificado_venda_situacao_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_situacao_to_string))
        {
            return $this->certificado_venda_certificado_venda_situacao_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('certificado_venda_situacao_id','{certificado_venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_modalidade_to_string($certificado_venda_certificado_venda_modalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $certificado_venda_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_modalidade_to_string = $certificado_venda_certificado_venda_modalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_modalidade_to_string'] = $this->certificado_venda_certificado_venda_modalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_modalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_modalidade_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_tipomodalidade_to_string($certificado_venda_certificado_venda_tipomodalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            $values = CertificadoVendaTipomodalidade::where('id', 'in', $certificado_venda_certificado_venda_tipomodalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = $certificado_venda_certificado_venda_tipomodalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_tipomodalidade_to_string'] = $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_tipomodalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('certificado_venda_tipomodalidade_id','{certificado_venda_tipomodalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_repasse_to_string($certificado_venda_certificado_tipo_repasse_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_repasse_to_string))
        {
            $values = CertificadoTipoRepasse::where('id', 'in', $certificado_venda_certificado_tipo_repasse_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_repasse_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_repasse_to_string = $certificado_venda_certificado_tipo_repasse_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_repasse_to_string'] = $this->certificado_venda_certificado_tipo_repasse_to_string;
    }

    public function get_certificado_venda_certificado_tipo_repasse_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_repasse_to_string))
        {
            return $this->certificado_venda_certificado_tipo_repasse_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('certificado_tipo_repasse_id','{certificado_tipo_repasse->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_vendedor_to_string($certificado_venda_vendedor_to_string)
    {
        if(is_array($certificado_venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $certificado_venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_vendedor_to_string = $certificado_venda_vendedor_to_string;
        }

        $this->vdata['certificado_venda_vendedor_to_string'] = $this->certificado_venda_vendedor_to_string;
    }

    public function get_certificado_venda_vendedor_to_string()
    {
        if(!empty($this->certificado_venda_vendedor_to_string))
        {
            return $this->certificado_venda_vendedor_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_tabela_preco_to_string($certificado_venda_tabela_preco_to_string)
    {
        if(is_array($certificado_venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $certificado_venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_tabela_preco_to_string = $certificado_venda_tabela_preco_to_string;
        }

        $this->vdata['certificado_venda_tabela_preco_to_string'] = $this->certificado_venda_tabela_preco_to_string;
    }

    public function get_certificado_venda_tabela_preco_to_string()
    {
        if(!empty($this->certificado_venda_tabela_preco_to_string))
        {
            return $this->certificado_venda_tabela_preco_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificadora_to_string($certificado_venda_certificadora_to_string)
    {
        if(is_array($certificado_venda_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificado_venda_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificadora_to_string = $certificado_venda_certificadora_to_string;
        }

        $this->vdata['certificado_venda_certificadora_to_string'] = $this->certificado_venda_certificadora_to_string;
    }

    public function get_certificado_venda_certificadora_to_string()
    {
        if(!empty($this->certificado_venda_certificadora_to_string))
        {
            return $this->certificado_venda_certificadora_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_atendimento_to_string($certificado_venda_certificado_tipo_atendimento_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_atendimento_to_string))
        {
            $values = CertificadoTipoAtendimento::where('id', 'in', $certificado_venda_certificado_tipo_atendimento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_atendimento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_atendimento_to_string = $certificado_venda_certificado_tipo_atendimento_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_atendimento_to_string'] = $this->certificado_venda_certificado_tipo_atendimento_to_string;
    }

    public function get_certificado_venda_certificado_tipo_atendimento_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_atendimento_to_string))
        {
            return $this->certificado_venda_certificado_tipo_atendimento_to_string;
        }
    
        $values = CertificadoVenda::where('produto_id', '=', $this->id)->getIndexedArray('certificado_tipo_atendimento_id','{certificado_tipo_atendimento->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('produto_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_produto_to_string($estoque_saldos_produto_to_string)
    {
        if(is_array($estoque_saldos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_saldos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_saldos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_produto_to_string = $estoque_saldos_produto_to_string;
        }

        $this->vdata['estoque_saldos_produto_to_string'] = $this->estoque_saldos_produto_to_string;
    }

    public function get_estoque_saldos_produto_to_string()
    {
        if(!empty($this->estoque_saldos_produto_to_string))
        {
            return $this->estoque_saldos_produto_to_string;
        }
    
        $values = EstoqueSaldos::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_system_unit_to_string($estoque_saldos_system_unit_to_string)
    {
        if(is_array($estoque_saldos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_saldos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_saldos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_system_unit_to_string = $estoque_saldos_system_unit_to_string;
        }

        $this->vdata['estoque_saldos_system_unit_to_string'] = $this->estoque_saldos_system_unit_to_string;
    }

    public function get_estoque_saldos_system_unit_to_string()
    {
        if(!empty($this->estoque_saldos_system_unit_to_string))
        {
            return $this->estoque_saldos_system_unit_to_string;
        }
    
        $values = EstoqueSaldos::where('produto_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_estoque_deposito_to_string($estoque_saldos_estoque_deposito_to_string)
    {
        if(is_array($estoque_saldos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_saldos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_saldos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_estoque_deposito_to_string = $estoque_saldos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_saldos_estoque_deposito_to_string'] = $this->estoque_saldos_estoque_deposito_to_string;
    }

    public function get_estoque_saldos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_saldos_estoque_deposito_to_string))
        {
            return $this->estoque_saldos_estoque_deposito_to_string;
        }
    
        $values = EstoqueSaldos::where('produto_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_produto_lote_to_string($estoque_saldos_produto_lote_to_string)
    {
        if(is_array($estoque_saldos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_saldos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_saldos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_produto_lote_to_string = $estoque_saldos_produto_lote_to_string;
        }

        $this->vdata['estoque_saldos_produto_lote_to_string'] = $this->estoque_saldos_produto_lote_to_string;
    }

    public function get_estoque_saldos_produto_lote_to_string()
    {
        if(!empty($this->estoque_saldos_produto_lote_to_string))
        {
            return $this->estoque_saldos_produto_lote_to_string;
        }
    
        $values = EstoqueSaldos::where('produto_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_produtos_produto_to_string($natureza_operacao_produtos_produto_to_string)
    {
        if(is_array($natureza_operacao_produtos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $natureza_operacao_produtos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->natureza_operacao_produtos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_produtos_produto_to_string = $natureza_operacao_produtos_produto_to_string;
        }

        $this->vdata['natureza_operacao_produtos_produto_to_string'] = $this->natureza_operacao_produtos_produto_to_string;
    }

    public function get_natureza_operacao_produtos_produto_to_string()
    {
        if(!empty($this->natureza_operacao_produtos_produto_to_string))
        {
            return $this->natureza_operacao_produtos_produto_to_string;
        }
    
        $values = NaturezaOperacaoProdutos::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_produtos_natureza_operacao_excecao_to_string($natureza_operacao_produtos_natureza_operacao_excecao_to_string)
    {
        if(is_array($natureza_operacao_produtos_natureza_operacao_excecao_to_string))
        {
            $values = NaturezaOperacaoExcecao::where('id', 'in', $natureza_operacao_produtos_natureza_operacao_excecao_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string = $natureza_operacao_produtos_natureza_operacao_excecao_to_string;
        }

        $this->vdata['natureza_operacao_produtos_natureza_operacao_excecao_to_string'] = $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string;
    }

    public function get_natureza_operacao_produtos_natureza_operacao_excecao_to_string()
    {
        if(!empty($this->natureza_operacao_produtos_natureza_operacao_excecao_to_string))
        {
            return $this->natureza_operacao_produtos_natureza_operacao_excecao_to_string;
        }
    
        $values = NaturezaOperacaoProdutos::where('produto_id', '=', $this->id)->getIndexedArray('natureza_operacao_excecao_id','{natureza_operacao_excecao->id}');
        return implode(', ', $values);
    }

    public function set_negocio_itens_negocio_to_string($negocio_itens_negocio_to_string)
    {
        if(is_array($negocio_itens_negocio_to_string))
        {
            $values = Negocio::where('id', 'in', $negocio_itens_negocio_to_string)->getIndexedArray('id', 'id');
            $this->negocio_itens_negocio_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_itens_negocio_to_string = $negocio_itens_negocio_to_string;
        }

        $this->vdata['negocio_itens_negocio_to_string'] = $this->negocio_itens_negocio_to_string;
    }

    public function get_negocio_itens_negocio_to_string()
    {
        if(!empty($this->negocio_itens_negocio_to_string))
        {
            return $this->negocio_itens_negocio_to_string;
        }
    
        $values = NegocioItens::where('produto_id', '=', $this->id)->getIndexedArray('negocio_id','{negocio->id}');
        return implode(', ', $values);
    }

    public function set_negocio_itens_produto_to_string($negocio_itens_produto_to_string)
    {
        if(is_array($negocio_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $negocio_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_itens_produto_to_string = $negocio_itens_produto_to_string;
        }

        $this->vdata['negocio_itens_produto_to_string'] = $this->negocio_itens_produto_to_string;
    }

    public function get_negocio_itens_produto_to_string()
    {
        if(!empty($this->negocio_itens_produto_to_string))
        {
            return $this->negocio_itens_produto_to_string;
        }
    
        $values = NegocioItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_to_string($nota_fiscal_compra_itens_produto_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $nota_fiscal_compra_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_to_string = $nota_fiscal_compra_itens_produto_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_to_string'] = $this->nota_fiscal_compra_itens_produto_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            $values = NotaFiscalCompraItensSituacao::where('id', 'in', $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string = $nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string'] = $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
    }

    public function get_nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string))
        {
            return $this->nota_fiscal_compra_itens_nota_fiscal_compra_itens_situacao_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_itens_situacao_id','{nota_fiscal_compra_itens_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            $values = NotafiscalItemIndtot::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string = $nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_indtot_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_indtot_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_indtot_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_indtot_id','{notafiscal_item_indtot->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_orig_to_string($nota_fiscal_compra_itens_notafiscal_item_orig_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string = $nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_orig_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_orig_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string = $nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_modbc_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_modbc_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string = $nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string'] = $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
    }

    public function get_nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string))
        {
            return $this->nota_fiscal_compra_itens_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_estoque_deposito_to_string($nota_fiscal_compra_itens_estoque_deposito_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $nota_fiscal_compra_itens_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_estoque_deposito_to_string = $nota_fiscal_compra_itens_estoque_deposito_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_estoque_deposito_to_string'] = $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
    }

    public function get_nota_fiscal_compra_itens_estoque_deposito_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_estoque_deposito_to_string))
        {
            return $this->nota_fiscal_compra_itens_estoque_deposito_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_itens_produto_lote_to_string($nota_fiscal_compra_itens_produto_lote_to_string)
    {
        if(is_array($nota_fiscal_compra_itens_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $nota_fiscal_compra_itens_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->nota_fiscal_compra_itens_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_itens_produto_lote_to_string = $nota_fiscal_compra_itens_produto_lote_to_string;
        }

        $this->vdata['nota_fiscal_compra_itens_produto_lote_to_string'] = $this->nota_fiscal_compra_itens_produto_lote_to_string;
    }

    public function get_nota_fiscal_compra_itens_produto_lote_to_string()
    {
        if(!empty($this->nota_fiscal_compra_itens_produto_lote_to_string))
        {
            return $this->nota_fiscal_compra_itens_produto_lote_to_string;
        }
    
        $values = NotaFiscalCompraItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_to_string($notafiscal_itens_notafiscal_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $notafiscal_itens_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_to_string = $notafiscal_itens_notafiscal_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_to_string'] = $this->notafiscal_itens_notafiscal_to_string;
    }

    public function get_notafiscal_itens_notafiscal_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_to_string))
        {
            return $this->notafiscal_itens_notafiscal_to_string;
        }
    
        $values = NotafiscalItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_produto_to_string($notafiscal_itens_produto_to_string)
    {
        if(is_array($notafiscal_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $notafiscal_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_produto_to_string = $notafiscal_itens_produto_to_string;
        }

        $this->vdata['notafiscal_itens_produto_to_string'] = $this->notafiscal_itens_produto_to_string;
    }

    public function get_notafiscal_itens_produto_to_string()
    {
        if(!empty($this->notafiscal_itens_produto_to_string))
        {
            return $this->notafiscal_itens_produto_to_string;
        }
    
        $values = NotafiscalItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_indtot_to_string($notafiscal_itens_notafiscal_item_indtot_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_indtot_to_string))
        {
            $values = NotafiscalItemIndtot::where('id', 'in', $notafiscal_itens_notafiscal_item_indtot_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_indtot_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_indtot_to_string = $notafiscal_itens_notafiscal_item_indtot_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_indtot_to_string'] = $this->notafiscal_itens_notafiscal_item_indtot_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_indtot_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_indtot_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_indtot_to_string;
        }
    
        $values = NotafiscalItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_indtot_id','{notafiscal_item_indtot->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_orig_to_string($notafiscal_itens_notafiscal_item_orig_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $notafiscal_itens_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_orig_to_string = $notafiscal_itens_notafiscal_item_orig_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_orig_to_string'] = $this->notafiscal_itens_notafiscal_item_orig_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_orig_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_orig_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_orig_to_string;
        }
    
        $values = NotafiscalItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_modbc_to_string($notafiscal_itens_notafiscal_item_modbc_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $notafiscal_itens_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_itens_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_modbc_to_string = $notafiscal_itens_notafiscal_item_modbc_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_modbc_to_string'] = $this->notafiscal_itens_notafiscal_item_modbc_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_modbc_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_modbc_to_string;
        }
    
        $values = NotafiscalItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_itens_notafiscal_item_motDesICMS_to_string($notafiscal_itens_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($notafiscal_itens_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $notafiscal_itens_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string = $notafiscal_itens_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['notafiscal_itens_notafiscal_item_motDesICMS_to_string'] = $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string;
    }

    public function get_notafiscal_itens_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->notafiscal_itens_notafiscal_item_motDesICMS_to_string))
        {
            return $this->notafiscal_itens_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NotafiscalItens::where('produto_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_item_orcamento_to_string($orcamento_item_orcamento_to_string)
    {
        if(is_array($orcamento_item_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $orcamento_item_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->orcamento_item_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_item_orcamento_to_string = $orcamento_item_orcamento_to_string;
        }

        $this->vdata['orcamento_item_orcamento_to_string'] = $this->orcamento_item_orcamento_to_string;
    }

    public function get_orcamento_item_orcamento_to_string()
    {
        if(!empty($this->orcamento_item_orcamento_to_string))
        {
            return $this->orcamento_item_orcamento_to_string;
        }
    
        $values = OrcamentoItem::where('produto_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_orcamento_item_produto_to_string($orcamento_item_produto_to_string)
    {
        if(is_array($orcamento_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $orcamento_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_item_produto_to_string = $orcamento_item_produto_to_string;
        }

        $this->vdata['orcamento_item_produto_to_string'] = $this->orcamento_item_produto_to_string;
    }

    public function get_orcamento_item_produto_to_string()
    {
        if(!empty($this->orcamento_item_produto_to_string))
        {
            return $this->orcamento_item_produto_to_string;
        }
    
        $values = OrcamentoItem::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_system_unit_to_string($ordem_producao_system_unit_to_string)
    {
        if(is_array($ordem_producao_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_producao_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_producao_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_system_unit_to_string = $ordem_producao_system_unit_to_string;
        }

        $this->vdata['ordem_producao_system_unit_to_string'] = $this->ordem_producao_system_unit_to_string;
    }

    public function get_ordem_producao_system_unit_to_string()
    {
        if(!empty($this->ordem_producao_system_unit_to_string))
        {
            return $this->ordem_producao_system_unit_to_string;
        }
    
        $values = OrdemProducao::where('produto_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_ordem_producao_situacao_to_string($ordem_producao_ordem_producao_situacao_to_string)
    {
        if(is_array($ordem_producao_ordem_producao_situacao_to_string))
        {
            $values = OrdemProducaoSituacao::where('id', 'in', $ordem_producao_ordem_producao_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_ordem_producao_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_ordem_producao_situacao_to_string = $ordem_producao_ordem_producao_situacao_to_string;
        }

        $this->vdata['ordem_producao_ordem_producao_situacao_to_string'] = $this->ordem_producao_ordem_producao_situacao_to_string;
    }

    public function get_ordem_producao_ordem_producao_situacao_to_string()
    {
        if(!empty($this->ordem_producao_ordem_producao_situacao_to_string))
        {
            return $this->ordem_producao_ordem_producao_situacao_to_string;
        }
    
        $values = OrdemProducao::where('produto_id', '=', $this->id)->getIndexedArray('ordem_producao_situacao_id','{ordem_producao_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_to_string($ordem_producao_produto_to_string)
    {
        if(is_array($ordem_producao_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_to_string = $ordem_producao_produto_to_string;
        }

        $this->vdata['ordem_producao_produto_to_string'] = $this->ordem_producao_produto_to_string;
    }

    public function get_ordem_producao_produto_to_string()
    {
        if(!empty($this->ordem_producao_produto_to_string))
        {
            return $this->ordem_producao_produto_to_string;
        }
    
        $values = OrdemProducao::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_ficha_tecnica_to_string($ordem_producao_produto_ficha_tecnica_to_string)
    {
        if(is_array($ordem_producao_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $ordem_producao_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_ficha_tecnica_to_string = $ordem_producao_produto_ficha_tecnica_to_string;
        }

        $this->vdata['ordem_producao_produto_ficha_tecnica_to_string'] = $this->ordem_producao_produto_ficha_tecnica_to_string;
    }

    public function get_ordem_producao_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->ordem_producao_produto_ficha_tecnica_to_string))
        {
            return $this->ordem_producao_produto_ficha_tecnica_to_string;
        }
    
        $values = OrdemProducao::where('produto_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_estoque_deposito_to_string($ordem_producao_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_estoque_deposito_to_string = $ordem_producao_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_estoque_deposito_to_string'] = $this->ordem_producao_estoque_deposito_to_string;
    }

    public function get_ordem_producao_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_estoque_deposito_to_string))
        {
            return $this->ordem_producao_estoque_deposito_to_string;
        }
    
        $values = OrdemProducao::where('produto_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_ordem_producao_to_string($ordem_producao_itens_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_itens_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_itens_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_itens_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_ordem_producao_to_string = $ordem_producao_itens_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_itens_ordem_producao_to_string'] = $this->ordem_producao_itens_ordem_producao_to_string;
    }

    public function get_ordem_producao_itens_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_itens_ordem_producao_to_string))
        {
            return $this->ordem_producao_itens_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoItens::where('produto_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_produto_to_string($ordem_producao_itens_produto_to_string)
    {
        if(is_array($ordem_producao_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_produto_to_string = $ordem_producao_itens_produto_to_string;
        }

        $this->vdata['ordem_producao_itens_produto_to_string'] = $this->ordem_producao_itens_produto_to_string;
    }

    public function get_ordem_producao_itens_produto_to_string()
    {
        if(!empty($this->ordem_producao_itens_produto_to_string))
        {
            return $this->ordem_producao_itens_produto_to_string;
        }
    
        $values = OrdemProducaoItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_itens_estoque_deposito_to_string($ordem_producao_itens_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_itens_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_itens_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_itens_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_itens_estoque_deposito_to_string = $ordem_producao_itens_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_itens_estoque_deposito_to_string'] = $this->ordem_producao_itens_estoque_deposito_to_string;
    }

    public function get_ordem_producao_itens_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_itens_estoque_deposito_to_string))
        {
            return $this->ordem_producao_itens_estoque_deposito_to_string;
        }
    
        $values = OrdemProducaoItens::where('produto_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ordem_servico_to_string($ordem_servico_item_ordem_servico_to_string)
    {
        if(is_array($ordem_servico_item_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $ordem_servico_item_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->ordem_servico_item_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ordem_servico_to_string = $ordem_servico_item_ordem_servico_to_string;
        }

        $this->vdata['ordem_servico_item_ordem_servico_to_string'] = $this->ordem_servico_item_ordem_servico_to_string;
    }

    public function get_ordem_servico_item_ordem_servico_to_string()
    {
        if(!empty($this->ordem_servico_item_ordem_servico_to_string))
        {
            return $this->ordem_servico_item_ordem_servico_to_string;
        }
    
        $values = OrdemServicoItem::where('produto_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_produto_to_string($ordem_servico_item_produto_to_string)
    {
        if(is_array($ordem_servico_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_servico_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_produto_to_string = $ordem_servico_item_produto_to_string;
        }

        $this->vdata['ordem_servico_item_produto_to_string'] = $this->ordem_servico_item_produto_to_string;
    }

    public function get_ordem_servico_item_produto_to_string()
    {
        if(!empty($this->ordem_servico_item_produto_to_string))
        {
            return $this->ordem_servico_item_produto_to_string;
        }
    
        $values = OrdemServicoItem::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string($ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string = $ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string'] = $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('produto_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_produto_to_string($ordem_servico_item_ficha_tecnica_produto_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_servico_item_ficha_tecnica_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_item_ficha_tecnica_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_produto_to_string = $ordem_servico_item_ficha_tecnica_produto_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_produto_to_string'] = $this->ordem_servico_item_ficha_tecnica_produto_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_produto_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_produto_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_produto_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string($ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string))
        {
            $values = Resposta::where('id', 'in', $ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string = $ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string'] = $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('produto_id', '=', $this->id)->getIndexedArray('quantidade_fixa_id','{quantidade_fixa->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_system_unit_to_string($produto_ficha_tecnica_system_unit_to_string)
    {
        if(is_array($produto_ficha_tecnica_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $produto_ficha_tecnica_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->produto_ficha_tecnica_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_system_unit_to_string = $produto_ficha_tecnica_system_unit_to_string;
        }

        $this->vdata['produto_ficha_tecnica_system_unit_to_string'] = $this->produto_ficha_tecnica_system_unit_to_string;
    }

    public function get_produto_ficha_tecnica_system_unit_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_system_unit_to_string))
        {
            return $this->produto_ficha_tecnica_system_unit_to_string;
        }
    
        $values = ProdutoFichaTecnica::where('produto_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_produto_to_string($produto_ficha_tecnica_produto_to_string)
    {
        if(is_array($produto_ficha_tecnica_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_ficha_tecnica_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_ficha_tecnica_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_produto_to_string = $produto_ficha_tecnica_produto_to_string;
        }

        $this->vdata['produto_ficha_tecnica_produto_to_string'] = $this->produto_ficha_tecnica_produto_to_string;
    }

    public function get_produto_ficha_tecnica_produto_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_produto_to_string))
        {
            return $this->produto_ficha_tecnica_produto_to_string;
        }
    
        $values = ProdutoFichaTecnica::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string($produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_produto_to_string($produto_ficha_tecnica_itens_produto_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_ficha_tecnica_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_ficha_tecnica_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_produto_to_string = $produto_ficha_tecnica_itens_produto_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_produto_to_string'] = $this->produto_ficha_tecnica_itens_produto_to_string;
    }

    public function get_produto_ficha_tecnica_itens_produto_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_produto_to_string))
        {
            return $this->produto_ficha_tecnica_itens_produto_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_quantidade_fixa_to_string($produto_ficha_tecnica_itens_quantidade_fixa_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_quantidade_fixa_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_ficha_tecnica_itens_quantidade_fixa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string = $produto_ficha_tecnica_itens_quantidade_fixa_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_quantidade_fixa_to_string'] = $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string;
    }

    public function get_produto_ficha_tecnica_itens_quantidade_fixa_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_quantidade_fixa_to_string))
        {
            return $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('produto_id', '=', $this->id)->getIndexedArray('quantidade_fixa_id','{quantidade_fixa->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_produto_to_string($produto_filial_produto_to_string)
    {
        if(is_array($produto_filial_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_filial_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_filial_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_produto_to_string = $produto_filial_produto_to_string;
        }

        $this->vdata['produto_filial_produto_to_string'] = $this->produto_filial_produto_to_string;
    }

    public function get_produto_filial_produto_to_string()
    {
        if(!empty($this->produto_filial_produto_to_string))
        {
            return $this->produto_filial_produto_to_string;
        }
    
        $values = ProdutoFilial::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_filial_system_unit_to_string($produto_filial_system_unit_to_string)
    {
        if(is_array($produto_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $produto_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->produto_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_system_unit_to_string = $produto_filial_system_unit_to_string;
        }

        $this->vdata['produto_filial_system_unit_to_string'] = $this->produto_filial_system_unit_to_string;
    }

    public function get_produto_filial_system_unit_to_string()
    {
        if(!empty($this->produto_filial_system_unit_to_string))
        {
            return $this->produto_filial_system_unit_to_string;
        }
    
        $values = ProdutoFilial::where('produto_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_produto_filial_estoque_deposito_padrao_to_string($produto_filial_estoque_deposito_padrao_to_string)
    {
        if(is_array($produto_filial_estoque_deposito_padrao_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $produto_filial_estoque_deposito_padrao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_estoque_deposito_padrao_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_estoque_deposito_padrao_to_string = $produto_filial_estoque_deposito_padrao_to_string;
        }

        $this->vdata['produto_filial_estoque_deposito_padrao_to_string'] = $this->produto_filial_estoque_deposito_padrao_to_string;
    }

    public function get_produto_filial_estoque_deposito_padrao_to_string()
    {
        if(!empty($this->produto_filial_estoque_deposito_padrao_to_string))
        {
            return $this->produto_filial_estoque_deposito_padrao_to_string;
        }
    
        $values = ProdutoFilial::where('produto_id', '=', $this->id)->getIndexedArray('estoque_deposito_padrao_id','{estoque_deposito_padrao->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_sob_encomenda_to_string($produto_filial_sob_encomenda_to_string)
    {
        if(is_array($produto_filial_sob_encomenda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_sob_encomenda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_sob_encomenda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_sob_encomenda_to_string = $produto_filial_sob_encomenda_to_string;
        }

        $this->vdata['produto_filial_sob_encomenda_to_string'] = $this->produto_filial_sob_encomenda_to_string;
    }

    public function get_produto_filial_sob_encomenda_to_string()
    {
        if(!empty($this->produto_filial_sob_encomenda_to_string))
        {
            return $this->produto_filial_sob_encomenda_to_string;
        }
    
        $values = ProdutoFilial::where('produto_id', '=', $this->id)->getIndexedArray('sob_encomenda_id','{sob_encomenda->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_gerar_op_venda_to_string($produto_filial_gerar_op_venda_to_string)
    {
        if(is_array($produto_filial_gerar_op_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_gerar_op_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_gerar_op_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_gerar_op_venda_to_string = $produto_filial_gerar_op_venda_to_string;
        }

        $this->vdata['produto_filial_gerar_op_venda_to_string'] = $this->produto_filial_gerar_op_venda_to_string;
    }

    public function get_produto_filial_gerar_op_venda_to_string()
    {
        if(!empty($this->produto_filial_gerar_op_venda_to_string))
        {
            return $this->produto_filial_gerar_op_venda_to_string;
        }
    
        $values = ProdutoFilial::where('produto_id', '=', $this->id)->getIndexedArray('gerar_op_venda_id','{gerar_op_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_historico_produto_to_string($produto_filial_historico_produto_to_string)
    {
        if(is_array($produto_filial_historico_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_filial_historico_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_filial_historico_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_historico_produto_to_string = $produto_filial_historico_produto_to_string;
        }

        $this->vdata['produto_filial_historico_produto_to_string'] = $this->produto_filial_historico_produto_to_string;
    }

    public function get_produto_filial_historico_produto_to_string()
    {
        if(!empty($this->produto_filial_historico_produto_to_string))
        {
            return $this->produto_filial_historico_produto_to_string;
        }
    
        $values = ProdutoFilialHistorico::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_filial_historico_produto_filial_to_string($produto_filial_historico_produto_filial_to_string)
    {
        if(is_array($produto_filial_historico_produto_filial_to_string))
        {
            $values = ProdutoFilial::where('id', 'in', $produto_filial_historico_produto_filial_to_string)->getIndexedArray('preco_venda', 'preco_venda');
            $this->produto_filial_historico_produto_filial_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_historico_produto_filial_to_string = $produto_filial_historico_produto_filial_to_string;
        }

        $this->vdata['produto_filial_historico_produto_filial_to_string'] = $this->produto_filial_historico_produto_filial_to_string;
    }

    public function get_produto_filial_historico_produto_filial_to_string()
    {
        if(!empty($this->produto_filial_historico_produto_filial_to_string))
        {
            return $this->produto_filial_historico_produto_filial_to_string;
        }
    
        $values = ProdutoFilialHistorico::where('produto_id', '=', $this->id)->getIndexedArray('produto_filial_id','{produto_filial->preco_venda}');
        return implode(', ', $values);
    }

    public function set_produto_fornecedor_produto_to_string($produto_fornecedor_produto_to_string)
    {
        if(is_array($produto_fornecedor_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_fornecedor_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_fornecedor_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_fornecedor_produto_to_string = $produto_fornecedor_produto_to_string;
        }

        $this->vdata['produto_fornecedor_produto_to_string'] = $this->produto_fornecedor_produto_to_string;
    }

    public function get_produto_fornecedor_produto_to_string()
    {
        if(!empty($this->produto_fornecedor_produto_to_string))
        {
            return $this->produto_fornecedor_produto_to_string;
        }
    
        $values = ProdutoFornecedor::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_fornecedor_fornecedor_to_string($produto_fornecedor_fornecedor_to_string)
    {
        if(is_array($produto_fornecedor_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $produto_fornecedor_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_fornecedor_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_fornecedor_fornecedor_to_string = $produto_fornecedor_fornecedor_to_string;
        }

        $this->vdata['produto_fornecedor_fornecedor_to_string'] = $this->produto_fornecedor_fornecedor_to_string;
    }

    public function get_produto_fornecedor_fornecedor_to_string()
    {
        if(!empty($this->produto_fornecedor_fornecedor_to_string))
        {
            return $this->produto_fornecedor_fornecedor_to_string;
        }
    
        $values = ProdutoFornecedor::where('produto_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_produto_lote_produto_to_string($produto_lote_produto_to_string)
    {
        if(is_array($produto_lote_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_lote_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_lote_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_lote_produto_to_string = $produto_lote_produto_to_string;
        }

        $this->vdata['produto_lote_produto_to_string'] = $this->produto_lote_produto_to_string;
    }

    public function get_produto_lote_produto_to_string()
    {
        if(!empty($this->produto_lote_produto_to_string))
        {
            return $this->produto_lote_produto_to_string;
        }
    
        $values = ProdutoLote::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_itens_venda_devolucao_to_string($venda_devolucao_itens_venda_devolucao_to_string)
    {
        if(is_array($venda_devolucao_itens_venda_devolucao_to_string))
        {
            $values = VendaDevolucao::where('id', 'in', $venda_devolucao_itens_venda_devolucao_to_string)->getIndexedArray('id', 'id');
            $this->venda_devolucao_itens_venda_devolucao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_itens_venda_devolucao_to_string = $venda_devolucao_itens_venda_devolucao_to_string;
        }

        $this->vdata['venda_devolucao_itens_venda_devolucao_to_string'] = $this->venda_devolucao_itens_venda_devolucao_to_string;
    }

    public function get_venda_devolucao_itens_venda_devolucao_to_string()
    {
        if(!empty($this->venda_devolucao_itens_venda_devolucao_to_string))
        {
            return $this->venda_devolucao_itens_venda_devolucao_to_string;
        }
    
        $values = VendaDevolucaoItens::where('produto_id', '=', $this->id)->getIndexedArray('venda_devolucao_id','{venda_devolucao->id}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_itens_produto_to_string($venda_devolucao_itens_produto_to_string)
    {
        if(is_array($venda_devolucao_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_devolucao_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_devolucao_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_itens_produto_to_string = $venda_devolucao_itens_produto_to_string;
        }

        $this->vdata['venda_devolucao_itens_produto_to_string'] = $this->venda_devolucao_itens_produto_to_string;
    }

    public function get_venda_devolucao_itens_produto_to_string()
    {
        if(!empty($this->venda_devolucao_itens_produto_to_string))
        {
            return $this->venda_devolucao_itens_produto_to_string;
        }
    
        $values = VendaDevolucaoItens::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_troca_venda_devolucao_to_string($venda_devolucao_troca_venda_devolucao_to_string)
    {
        if(is_array($venda_devolucao_troca_venda_devolucao_to_string))
        {
            $values = VendaDevolucao::where('id', 'in', $venda_devolucao_troca_venda_devolucao_to_string)->getIndexedArray('id', 'id');
            $this->venda_devolucao_troca_venda_devolucao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_troca_venda_devolucao_to_string = $venda_devolucao_troca_venda_devolucao_to_string;
        }

        $this->vdata['venda_devolucao_troca_venda_devolucao_to_string'] = $this->venda_devolucao_troca_venda_devolucao_to_string;
    }

    public function get_venda_devolucao_troca_venda_devolucao_to_string()
    {
        if(!empty($this->venda_devolucao_troca_venda_devolucao_to_string))
        {
            return $this->venda_devolucao_troca_venda_devolucao_to_string;
        }
    
        $values = VendaDevolucaoTroca::where('produto_id', '=', $this->id)->getIndexedArray('venda_devolucao_id','{venda_devolucao->id}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_troca_produto_to_string($venda_devolucao_troca_produto_to_string)
    {
        if(is_array($venda_devolucao_troca_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_devolucao_troca_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_devolucao_troca_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_troca_produto_to_string = $venda_devolucao_troca_produto_to_string;
        }

        $this->vdata['venda_devolucao_troca_produto_to_string'] = $this->venda_devolucao_troca_produto_to_string;
    }

    public function get_venda_devolucao_troca_produto_to_string()
    {
        if(!empty($this->venda_devolucao_troca_produto_to_string))
        {
            return $this->venda_devolucao_troca_produto_to_string;
        }
    
        $values = VendaDevolucaoTroca::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_item_venda_to_string($venda_item_venda_to_string)
    {
        if(is_array($venda_item_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_item_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_venda_to_string = $venda_item_venda_to_string;
        }

        $this->vdata['venda_item_venda_to_string'] = $this->venda_item_venda_to_string;
    }

    public function get_venda_item_venda_to_string()
    {
        if(!empty($this->venda_item_venda_to_string))
        {
            return $this->venda_item_venda_to_string;
        }
    
        $values = VendaItem::where('produto_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_to_string($venda_item_produto_to_string)
    {
        if(is_array($venda_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_to_string = $venda_item_produto_to_string;
        }

        $this->vdata['venda_item_produto_to_string'] = $this->venda_item_produto_to_string;
    }

    public function get_venda_item_produto_to_string()
    {
        if(!empty($this->venda_item_produto_to_string))
        {
            return $this->venda_item_produto_to_string;
        }
    
        $values = VendaItem::where('produto_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_item_fk_cancelado_to_string($venda_item_fk_cancelado_to_string)
    {
        if(is_array($venda_item_fk_cancelado_to_string))
        {
            $values = Resposta::where('id', 'in', $venda_item_fk_cancelado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_fk_cancelado_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_fk_cancelado_to_string = $venda_item_fk_cancelado_to_string;
        }

        $this->vdata['venda_item_fk_cancelado_to_string'] = $this->venda_item_fk_cancelado_to_string;
    }

    public function get_venda_item_fk_cancelado_to_string()
    {
        if(!empty($this->venda_item_fk_cancelado_to_string))
        {
            return $this->venda_item_fk_cancelado_to_string;
        }
    
        $values = VendaItem::where('produto_id', '=', $this->id)->getIndexedArray('cancelado','{fk_cancelado->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_estoque_deposito_to_string($venda_item_estoque_deposito_to_string)
    {
        if(is_array($venda_item_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $venda_item_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_estoque_deposito_to_string = $venda_item_estoque_deposito_to_string;
        }

        $this->vdata['venda_item_estoque_deposito_to_string'] = $this->venda_item_estoque_deposito_to_string;
    }

    public function get_venda_item_estoque_deposito_to_string()
    {
        if(!empty($this->venda_item_estoque_deposito_to_string))
        {
            return $this->venda_item_estoque_deposito_to_string;
        }
    
        $values = VendaItem::where('produto_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_lote_to_string($venda_item_produto_lote_to_string)
    {
        if(is_array($venda_item_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $venda_item_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->venda_item_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_lote_to_string = $venda_item_produto_lote_to_string;
        }

        $this->vdata['venda_item_produto_lote_to_string'] = $this->venda_item_produto_lote_to_string;
    }

    public function get_venda_item_produto_lote_to_string()
    {
        if(!empty($this->venda_item_produto_lote_to_string))
        {
            return $this->venda_item_produto_lote_to_string;
        }
    
        $values = VendaItem::where('produto_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public static function ClonarProduto($produto_id)
    {
        $produto = Produto::find($produto_id);
    
        if ($produto)
        {
            $id_prod_antigo = $produto_id;
            $produto_novo = $produto;
        
            $produto_novo->id = null;
            $produto_novo->nome = '(COPIA) '.$produto->nome;
            $produto_novo->criado_em = date('Y-m-d H:i:s');
            $produto_novo->criado_por = TSession::getValue('username');
            $produto_novo->alterado_em = null;
            $produto_novo->alterado_por = null;
            $produto_novo->store();
        
            //produto_filial
            $lista_prod_filial = ProdutoFilial::where('produto_id', '=', $id_prod_antigo)->load();
        
            if ($lista_prod_filial)
            {
                foreach ($lista_prod_filial as $prod_filial) 
                {
                    $prod_filial_novo = $prod_filial;
                    $prod_filial_novo->produto_id = $produto_novo->id;
                    $prod_filial_novo->id = null;
                    $prod_filial_novo->criado_em = date('Y-m-d H:i:s');
                    $prod_filial_novo->criado_por = TSession::getValue('username');
                    $prod_filial_novo->alterado_em = null;
                    $prod_filial_novo->alterado_por = null;                
                    $prod_filial_novo->store();
                }
            }
        
            //fornecedores
            $lista_fornecedores = ProdutoFornecedor::where('produto_id', '=', $id_prod_antigo)->load();
        
            if ($lista_fornecedores)
            {
                foreach ($lista_fornecedores as $prod_fornecedor) 
                {
                    $prod_fornecedor_novo = $prod_fornecedor;
                    $prod_fornecedor_novo->produto_id = $produto_novo->id;
                    $prod_fornecedor_novo->id = null;
                    $prod_fornecedor_novo->criado_em = date('Y-m-d H:i:s');
                    $prod_fornecedor_novo->criado_por = TSession::getValue('username');
                    $prod_fornecedor_novo->alterado_em = null;
                    $prod_fornecedor_novo->alterado_por = null;                
                    $prod_fornecedor_novo->store();
                }
            }

            //ficha tecnica
            $lista_ficha_tecnicas = ProdutoFichaTecnica::where('produto_id', '=', $id_prod_antigo)->load();
        
            if ($lista_ficha_tecnicas)
            {
                foreach ($lista_ficha_tecnicas as $ficha_tecnica) 
                {
                    $id_ficha_tecnica_antiga = $ficha_tecnica->id;
                
                    $ficha_tecnica_novo = $ficha_tecnica;
                    $ficha_tecnica_novo->produto_id = $produto_novo->id;
                    $ficha_tecnica_novo->id = null;
                    $ficha_tecnica_novo->descricao = '(COPIA) '.$ficha_tecnica->descricao;
                    $ficha_tecnica_novo->criado_em = date('Y-m-d H:i:s');
                    $ficha_tecnica_novo->criado_por = TSession::getValue('username');
                    $ficha_tecnica_novo->alterado_em = null;
                    $ficha_tecnica_novo->alterado_por = null;                
                    $ficha_tecnica_novo->store();

                    //itens
                    $lista_itens_ficha_tecnica = ProdutoFichaTecnicaItens::where('produto_ficha_tecnica_id', '=', $id_ficha_tecnica_antiga)->load();
                
                    if ($lista_itens_ficha_tecnica)
                    {
                        foreach ($lista_itens_ficha_tecnica as $item) 
                        {
                            $item_novo = $item;
                            $item_novo->id = null;
                            $item_novo->produto_ficha_tecnica_id = $ficha_tecnica_novo->id;
                            $item_novo->criado_em = date('Y-m-d H:i:s');
                            $item_novo->criado_por = TSession::getValue('username');
                            $item_novo->alterado_em = null;
                            $item_novo->alterado_por = null;                           
                            $item_novo->store();
                        }
                    }

                    //etapas
                    $lista_etapas_ficha_tecnica = ProdutoFichaTecnicaEtapasProducao::where('produto_ficha_tecnica_id', '=', $id_ficha_tecnica_antiga)->load();
                
                    if ($lista_etapas_ficha_tecnica)
                    {
                        foreach ($lista_etapas_ficha_tecnica as $etapa) 
                        {
                            $etapa_novo = $etapa;
                            $etapa_novo->produto_ficha_tecnica_id = $ficha_tecnica_novo->id;
                            $etapa_novo->id = null;
                            $etapa_novo->criado_em = date('Y-m-d H:i:s');
                            $etapa_novo->criado_por = TSession::getValue('username');
                            $etapa_novo->alterado_em = null;
                            $etapa_novo->alterado_por = null;                           
                            $etapa_novo->store();
                        }
                    }                
                
                }
            }        
        }
    }

    public static function ConfigEvento_ProdutoAbaixoDoMinimo($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Produto abaixo do mínimo";
       $mensagem = "Produto Id: ".$id." OBS: ".$obs;
       $acao = new TAction(['ProdutoFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    } 

    public static function SincronizaEventos()
    {
        Eventos::ProcessaEventos('ProdutoForm',self::Evento_ProdutoAbaixoDoMinimo);
    }
        
}

