<?php

class ProdutoEnderecamento extends TRecord
{
    const TABLENAME  = 'produto_enderecamento';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $estoque_prateleira;
    private $produto_filial;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_filial_id');
        parent::addAttribute('estoque_prateleira_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_estoque_prateleira
     * Sample of usage: $var->estoque_prateleira = $object;
     * @param $object Instance of EstoquePrateleira
     */
    public function set_estoque_prateleira(EstoquePrateleira $object)
    {
        $this->estoque_prateleira = $object;
        $this->estoque_prateleira_id = $object->id;
    }

    /**
     * Method get_estoque_prateleira
     * Sample of usage: $var->estoque_prateleira->attribute;
     * @returns EstoquePrateleira instance
     */
    public function get_estoque_prateleira()
    {
    
        // loads the associated object
        if (empty($this->estoque_prateleira))
            $this->estoque_prateleira = new EstoquePrateleira($this->estoque_prateleira_id);
    
        // returns the associated object
        return $this->estoque_prateleira;
    }
    /**
     * Method set_produto_filial
     * Sample of usage: $var->produto_filial = $object;
     * @param $object Instance of ProdutoFilial
     */
    public function set_produto_filial(ProdutoFilial $object)
    {
        $this->produto_filial = $object;
        $this->produto_filial_id = $object->id;
    }

    /**
     * Method get_produto_filial
     * Sample of usage: $var->produto_filial->attribute;
     * @returns ProdutoFilial instance
     */
    public function get_produto_filial()
    {
    
        // loads the associated object
        if (empty($this->produto_filial))
            $this->produto_filial = new ProdutoFilial($this->produto_filial_id);
    
        // returns the associated object
        return $this->produto_filial;
    }

    
}

