<?php

class ProdutoFabricante extends TRecord
{
    const TABLENAME  = 'produto_fabricante';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nome');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('deletado_em');
            
    }

    /**
     * Method getProdutos
     */
    public function getProdutos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_fabricante_id', '=', $this->id));
        return Produto::getObjects( $criteria );
    }

    public function set_produto_produto_grupo_to_string($produto_produto_grupo_to_string)
    {
        if(is_array($produto_produto_grupo_to_string))
        {
            $values = ProdutoGrupo::where('id', 'in', $produto_produto_grupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_grupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_grupo_to_string = $produto_produto_grupo_to_string;
        }

        $this->vdata['produto_produto_grupo_to_string'] = $this->produto_produto_grupo_to_string;
    }

    public function get_produto_produto_grupo_to_string()
    {
        if(!empty($this->produto_produto_grupo_to_string))
        {
            return $this->produto_produto_grupo_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('produto_grupo_id','{produto_grupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_unidade_medida_to_string($produto_unidade_medida_to_string)
    {
        if(is_array($produto_unidade_medida_to_string))
        {
            $values = UnidadeMedida::where('id', 'in', $produto_unidade_medida_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_unidade_medida_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_unidade_medida_to_string = $produto_unidade_medida_to_string;
        }

        $this->vdata['produto_unidade_medida_to_string'] = $this->produto_unidade_medida_to_string;
    }

    public function get_produto_unidade_medida_to_string()
    {
        if(!empty($this->produto_unidade_medida_to_string))
        {
            return $this->produto_unidade_medida_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('unidade_medida_id','{unidade_medida->nome}');
        return implode(', ', $values);
    }

    public function set_produto_tipo_recurso_to_string($produto_tipo_recurso_to_string)
    {
        if(is_array($produto_tipo_recurso_to_string))
        {
            $values = TipoRecurso::where('id', 'in', $produto_tipo_recurso_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_tipo_recurso_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_tipo_recurso_to_string = $produto_tipo_recurso_to_string;
        }

        $this->vdata['produto_tipo_recurso_to_string'] = $this->produto_tipo_recurso_to_string;
    }

    public function get_produto_tipo_recurso_to_string()
    {
        if(!empty($this->produto_tipo_recurso_to_string))
        {
            return $this->produto_tipo_recurso_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('tipo_recurso_id','{tipo_recurso->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produto_fabricante_to_string($produto_produto_fabricante_to_string)
    {
        if(is_array($produto_produto_fabricante_to_string))
        {
            $values = ProdutoFabricante::where('id', 'in', $produto_produto_fabricante_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_produto_fabricante_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_fabricante_to_string = $produto_produto_fabricante_to_string;
        }

        $this->vdata['produto_produto_fabricante_to_string'] = $this->produto_produto_fabricante_to_string;
    }

    public function get_produto_produto_fabricante_to_string()
    {
        if(!empty($this->produto_produto_fabricante_to_string))
        {
            return $this->produto_produto_fabricante_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('produto_fabricante_id','{produto_fabricante->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produtogrupo_subgrupo_to_string($produto_produtogrupo_subgrupo_to_string)
    {
        if(is_array($produto_produtogrupo_subgrupo_to_string))
        {
            $values = ProdutogrupoSubgrupo::where('id', 'in', $produto_produtogrupo_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produtogrupo_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produtogrupo_subgrupo_to_string = $produto_produtogrupo_subgrupo_to_string;
        }

        $this->vdata['produto_produtogrupo_subgrupo_to_string'] = $this->produto_produtogrupo_subgrupo_to_string;
    }

    public function get_produto_produtogrupo_subgrupo_to_string()
    {
        if(!empty($this->produto_produtogrupo_subgrupo_to_string))
        {
            return $this->produto_produtogrupo_subgrupo_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('produtogrupo_subgrupo_id','{produtogrupo_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_notafiscal_item_orig_to_string($produto_notafiscal_item_orig_to_string)
    {
        if(is_array($produto_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $produto_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->produto_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_notafiscal_item_orig_to_string = $produto_notafiscal_item_orig_to_string;
        }

        $this->vdata['produto_notafiscal_item_orig_to_string'] = $this->produto_notafiscal_item_orig_to_string;
    }

    public function get_produto_notafiscal_item_orig_to_string()
    {
        if(!empty($this->produto_notafiscal_item_orig_to_string))
        {
            return $this->produto_notafiscal_item_orig_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_produto_habilitado_to_string($produto_habilitado_to_string)
    {
        if(is_array($produto_habilitado_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_habilitado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_habilitado_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_habilitado_to_string = $produto_habilitado_to_string;
        }

        $this->vdata['produto_habilitado_to_string'] = $this->produto_habilitado_to_string;
    }

    public function get_produto_habilitado_to_string()
    {
        if(!empty($this->produto_habilitado_to_string))
        {
            return $this->produto_habilitado_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('habilitado_id','{habilitado->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_tipo_to_string($produto_produto_tipo_to_string)
    {
        if(is_array($produto_produto_tipo_to_string))
        {
            $values = ProdutoTipo::where('id', 'in', $produto_produto_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_tipo_to_string = $produto_produto_tipo_to_string;
        }

        $this->vdata['produto_produto_tipo_to_string'] = $this->produto_produto_tipo_to_string;
    }

    public function get_produto_produto_tipo_to_string()
    {
        if(!empty($this->produto_produto_tipo_to_string))
        {
            return $this->produto_produto_tipo_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('produto_tipo_id','{produto_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_embalagem_to_string($produto_produto_embalagem_to_string)
    {
        if(is_array($produto_produto_embalagem_to_string))
        {
            $values = ProdutoEmbalagem::where('id', 'in', $produto_produto_embalagem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_embalagem_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_embalagem_to_string = $produto_produto_embalagem_to_string;
        }

        $this->vdata['produto_produto_embalagem_to_string'] = $this->produto_produto_embalagem_to_string;
    }

    public function get_produto_produto_embalagem_to_string()
    {
        if(!empty($this->produto_produto_embalagem_to_string))
        {
            return $this->produto_produto_embalagem_to_string;
        }
    
        $values = Produto::where('produto_fabricante_id', '=', $this->id)->getIndexedArray('produto_embalagem_id','{produto_embalagem->descricao}');
        return implode(', ', $values);
    }

    
}

