<?php

class ProdutoFichaTecnica extends TRecord
{
    const TABLENAME  = 'produto_ficha_tecnica';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_unit;
    private $produto;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('descricao');
        parent::addAttribute('custo_total');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }

    /**
     * Method getOrdemProducaos
     */
    public function getOrdemProducaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_ficha_tecnica_id', '=', $this->id));
        return OrdemProducao::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaDespesass
     */
    public function getProdutoFichaTecnicaDespesass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_ficha_tecnica_id', '=', $this->id));
        return ProdutoFichaTecnicaDespesas::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaEtapasProducaos
     */
    public function getProdutoFichaTecnicaEtapasProducaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_ficha_tecnica_id', '=', $this->id));
        return ProdutoFichaTecnicaEtapasProducao::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaItenss
     */
    public function getProdutoFichaTecnicaItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_ficha_tecnica_id', '=', $this->id));
        return ProdutoFichaTecnicaItens::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaMaoObras
     */
    public function getProdutoFichaTecnicaMaoObras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_ficha_tecnica_id', '=', $this->id));
        return ProdutoFichaTecnicaMaoObra::getObjects( $criteria );
    }

    public function set_ordem_producao_system_unit_to_string($ordem_producao_system_unit_to_string)
    {
        if(is_array($ordem_producao_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_producao_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_producao_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_system_unit_to_string = $ordem_producao_system_unit_to_string;
        }

        $this->vdata['ordem_producao_system_unit_to_string'] = $this->ordem_producao_system_unit_to_string;
    }

    public function get_ordem_producao_system_unit_to_string()
    {
        if(!empty($this->ordem_producao_system_unit_to_string))
        {
            return $this->ordem_producao_system_unit_to_string;
        }
    
        $values = OrdemProducao::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_ordem_producao_situacao_to_string($ordem_producao_ordem_producao_situacao_to_string)
    {
        if(is_array($ordem_producao_ordem_producao_situacao_to_string))
        {
            $values = OrdemProducaoSituacao::where('id', 'in', $ordem_producao_ordem_producao_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_ordem_producao_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_ordem_producao_situacao_to_string = $ordem_producao_ordem_producao_situacao_to_string;
        }

        $this->vdata['ordem_producao_ordem_producao_situacao_to_string'] = $this->ordem_producao_ordem_producao_situacao_to_string;
    }

    public function get_ordem_producao_ordem_producao_situacao_to_string()
    {
        if(!empty($this->ordem_producao_ordem_producao_situacao_to_string))
        {
            return $this->ordem_producao_ordem_producao_situacao_to_string;
        }
    
        $values = OrdemProducao::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('ordem_producao_situacao_id','{ordem_producao_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_to_string($ordem_producao_produto_to_string)
    {
        if(is_array($ordem_producao_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_to_string = $ordem_producao_produto_to_string;
        }

        $this->vdata['ordem_producao_produto_to_string'] = $this->ordem_producao_produto_to_string;
    }

    public function get_ordem_producao_produto_to_string()
    {
        if(!empty($this->ordem_producao_produto_to_string))
        {
            return $this->ordem_producao_produto_to_string;
        }
    
        $values = OrdemProducao::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_ficha_tecnica_to_string($ordem_producao_produto_ficha_tecnica_to_string)
    {
        if(is_array($ordem_producao_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $ordem_producao_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_ficha_tecnica_to_string = $ordem_producao_produto_ficha_tecnica_to_string;
        }

        $this->vdata['ordem_producao_produto_ficha_tecnica_to_string'] = $this->ordem_producao_produto_ficha_tecnica_to_string;
    }

    public function get_ordem_producao_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->ordem_producao_produto_ficha_tecnica_to_string))
        {
            return $this->ordem_producao_produto_ficha_tecnica_to_string;
        }
    
        $values = OrdemProducao::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_estoque_deposito_to_string($ordem_producao_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_estoque_deposito_to_string = $ordem_producao_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_estoque_deposito_to_string'] = $this->ordem_producao_estoque_deposito_to_string;
    }

    public function get_ordem_producao_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_estoque_deposito_to_string))
        {
            return $this->ordem_producao_estoque_deposito_to_string;
        }
    
        $values = OrdemProducao::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string($produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_despesas_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaDespesas::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_despesas_despesas_servicos_to_string($produto_ficha_tecnica_despesas_despesas_servicos_to_string)
    {
        if(is_array($produto_ficha_tecnica_despesas_despesas_servicos_to_string))
        {
            $values = DespesasServicos::where('id', 'in', $produto_ficha_tecnica_despesas_despesas_servicos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string = $produto_ficha_tecnica_despesas_despesas_servicos_to_string;
        }

        $this->vdata['produto_ficha_tecnica_despesas_despesas_servicos_to_string'] = $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string;
    }

    public function get_produto_ficha_tecnica_despesas_despesas_servicos_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_despesas_despesas_servicos_to_string))
        {
            return $this->produto_ficha_tecnica_despesas_despesas_servicos_to_string;
        }
    
        $values = ProdutoFichaTecnicaDespesas::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('despesas_servicos_id','{despesas_servicos->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string($produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_etapas_producao_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaEtapasProducao::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string($produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_produto_to_string($produto_ficha_tecnica_itens_produto_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_ficha_tecnica_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_ficha_tecnica_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_produto_to_string = $produto_ficha_tecnica_itens_produto_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_produto_to_string'] = $this->produto_ficha_tecnica_itens_produto_to_string;
    }

    public function get_produto_ficha_tecnica_itens_produto_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_produto_to_string))
        {
            return $this->produto_ficha_tecnica_itens_produto_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_quantidade_fixa_to_string($produto_ficha_tecnica_itens_quantidade_fixa_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_quantidade_fixa_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_ficha_tecnica_itens_quantidade_fixa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string = $produto_ficha_tecnica_itens_quantidade_fixa_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_quantidade_fixa_to_string'] = $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string;
    }

    public function get_produto_ficha_tecnica_itens_quantidade_fixa_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_quantidade_fixa_to_string))
        {
            return $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('quantidade_fixa_id','{quantidade_fixa->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string($produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_mao_obra_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaMaoObra::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_mao_obra_funcionario_to_string($produto_ficha_tecnica_mao_obra_funcionario_to_string)
    {
        if(is_array($produto_ficha_tecnica_mao_obra_funcionario_to_string))
        {
            $values = Funcionario::where('id', 'in', $produto_ficha_tecnica_mao_obra_funcionario_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_ficha_tecnica_mao_obra_funcionario_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_mao_obra_funcionario_to_string = $produto_ficha_tecnica_mao_obra_funcionario_to_string;
        }

        $this->vdata['produto_ficha_tecnica_mao_obra_funcionario_to_string'] = $this->produto_ficha_tecnica_mao_obra_funcionario_to_string;
    }

    public function get_produto_ficha_tecnica_mao_obra_funcionario_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_mao_obra_funcionario_to_string))
        {
            return $this->produto_ficha_tecnica_mao_obra_funcionario_to_string;
        }
    
        $values = ProdutoFichaTecnicaMaoObra::where('produto_ficha_tecnica_id', '=', $this->id)->getIndexedArray('funcionario_id','{funcionario->nome}');
        return implode(', ', $values);
    }

    public static function ClonarFichaTecnica($ficha_tecnica_id)
    {
    
            $ficha_tecnica = ProdutoFichaTecnica::find($ficha_tecnica_id);
        
            if ($ficha_tecnica)
            {
                    $id_ficha_tecnica_antiga = $ficha_tecnica->id;
                
                    $ficha_tecnica_novo = $ficha_tecnica;
                    $ficha_tecnica_novo->id = null;
                    $ficha_tecnica_novo->descricao = '(COPIA) '.$ficha_tecnica->descricao;
                    $ficha_tecnica_novo->criado_em = date('Y-m-d H:i:s');
                    $ficha_tecnica_novo->criado_por = TSession::getValue('username');
                    $ficha_tecnica_novo->alterado_em = null;
                    $ficha_tecnica_novo->alterado_por = null;                
                    $ficha_tecnica_novo->store();

                    //itens
                    $lista_itens_ficha_tecnica = ProdutoFichaTecnicaItens::where('produto_ficha_tecnica_id', '=', $id_ficha_tecnica_antiga)->load();
                
                    if ($lista_itens_ficha_tecnica)
                    {
                        foreach ($lista_itens_ficha_tecnica as $item) 
                        {
                            $item_novo = $item;
                            $item_novo->id = null;
                            $item_novo->produto_ficha_tecnica_id = $ficha_tecnica_novo->id;
                            $item_novo->criado_em = date('Y-m-d H:i:s');
                            $item_novo->criado_por = TSession::getValue('username');
                            $item_novo->alterado_em = null;
                            $item_novo->alterado_por = null;                           
                            $item_novo->store();
                        }
                    }

                    //etapas
                    $lista_etapas_ficha_tecnica = ProdutoFichaTecnicaEtapasProducao::where('produto_ficha_tecnica_id', '=', $id_ficha_tecnica_antiga)->load();
                
                    if ($lista_etapas_ficha_tecnica)
                    {
                        foreach ($lista_etapas_ficha_tecnica as $etapa) 
                        {
                            $etapa_novo = $etapa;
                            $etapa_novo->produto_ficha_tecnica_id = $ficha_tecnica_novo->id;
                            $etapa_novo->id = null;
                            $etapa_novo->criado_em = date('Y-m-d H:i:s');
                            $etapa_novo->criado_por = TSession::getValue('username');
                            $etapa_novo->alterado_em = null;
                            $etapa_novo->alterado_por = null;                           
                            $etapa_novo->store();
                        }
                    }                
                
            }

    }

}

