<?php

class ProdutoFichaTecnicaDespesas extends TRecord
{
    const TABLENAME  = 'produto_ficha_tecnica_despesas';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto_ficha_tecnica;
    private $despesas_servicos;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_ficha_tecnica_id');
        parent::addAttribute('despesas_servicos_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_total');
            
    }

    /**
     * Method set_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica = $object;
     * @param $object Instance of ProdutoFichaTecnica
     */
    public function set_produto_ficha_tecnica(ProdutoFichaTecnica $object)
    {
        $this->produto_ficha_tecnica = $object;
        $this->produto_ficha_tecnica_id = $object->id;
    }

    /**
     * Method get_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica->attribute;
     * @returns ProdutoFichaTecnica instance
     */
    public function get_produto_ficha_tecnica()
    {
    
        // loads the associated object
        if (empty($this->produto_ficha_tecnica))
            $this->produto_ficha_tecnica = new ProdutoFichaTecnica($this->produto_ficha_tecnica_id);
    
        // returns the associated object
        return $this->produto_ficha_tecnica;
    }
    /**
     * Method set_despesas_servicos
     * Sample of usage: $var->despesas_servicos = $object;
     * @param $object Instance of DespesasServicos
     */
    public function set_despesas_servicos(DespesasServicos $object)
    {
        $this->despesas_servicos = $object;
        $this->despesas_servicos_id = $object->id;
    }

    /**
     * Method get_despesas_servicos
     * Sample of usage: $var->despesas_servicos->attribute;
     * @returns DespesasServicos instance
     */
    public function get_despesas_servicos()
    {
    
        // loads the associated object
        if (empty($this->despesas_servicos))
            $this->despesas_servicos = new DespesasServicos($this->despesas_servicos_id);
    
        // returns the associated object
        return $this->despesas_servicos;
    }

    
}

