<?php

class ProdutoFichaTecnicaItens extends TRecord
{
    const TABLENAME  = 'produto_ficha_tecnica_itens';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto_ficha_tecnica;
    private $produto;
    private $quantidade_fixa;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_ficha_tecnica_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_custo');
        parent::addAttribute('valor_total');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade_fixa_id');
            
    }

    /**
     * Method set_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica = $object;
     * @param $object Instance of ProdutoFichaTecnica
     */
    public function set_produto_ficha_tecnica(ProdutoFichaTecnica $object)
    {
        $this->produto_ficha_tecnica = $object;
        $this->produto_ficha_tecnica_id = $object->id;
    }

    /**
     * Method get_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica->attribute;
     * @returns ProdutoFichaTecnica instance
     */
    public function get_produto_ficha_tecnica()
    {
    
        // loads the associated object
        if (empty($this->produto_ficha_tecnica))
            $this->produto_ficha_tecnica = new ProdutoFichaTecnica($this->produto_ficha_tecnica_id);
    
        // returns the associated object
        return $this->produto_ficha_tecnica;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_quantidade_fixa(Resposta $object)
    {
        $this->quantidade_fixa = $object;
        $this->quantidade_fixa_id = $object->id;
    }

    /**
     * Method get_quantidade_fixa
     * Sample of usage: $var->quantidade_fixa->attribute;
     * @returns Resposta instance
     */
    public function get_quantidade_fixa()
    {
    
        // loads the associated object
        if (empty($this->quantidade_fixa))
            $this->quantidade_fixa = new Resposta($this->quantidade_fixa_id);
    
        // returns the associated object
        return $this->quantidade_fixa;
    }

    
}

