<?php

class ProdutoFichaTecnicaMaoObra extends TRecord
{
    const TABLENAME  = 'produto_ficha_tecnica_mao_obra';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto_ficha_tecnica;
    private $funcionario;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_ficha_tecnica_id');
        parent::addAttribute('funcionario_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('valor_hora');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_total');
            
    }

    /**
     * Method set_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica = $object;
     * @param $object Instance of ProdutoFichaTecnica
     */
    public function set_produto_ficha_tecnica(ProdutoFichaTecnica $object)
    {
        $this->produto_ficha_tecnica = $object;
        $this->produto_ficha_tecnica_id = $object->id;
    }

    /**
     * Method get_produto_ficha_tecnica
     * Sample of usage: $var->produto_ficha_tecnica->attribute;
     * @returns ProdutoFichaTecnica instance
     */
    public function get_produto_ficha_tecnica()
    {
    
        // loads the associated object
        if (empty($this->produto_ficha_tecnica))
            $this->produto_ficha_tecnica = new ProdutoFichaTecnica($this->produto_ficha_tecnica_id);
    
        // returns the associated object
        return $this->produto_ficha_tecnica;
    }
    /**
     * Method set_funcionario
     * Sample of usage: $var->funcionario = $object;
     * @param $object Instance of Funcionario
     */
    public function set_funcionario(Funcionario $object)
    {
        $this->funcionario = $object;
        $this->funcionario_id = $object->id;
    }

    /**
     * Method get_funcionario
     * Sample of usage: $var->funcionario->attribute;
     * @returns Funcionario instance
     */
    public function get_funcionario()
    {
    
        // loads the associated object
        if (empty($this->funcionario))
            $this->funcionario = new Funcionario($this->funcionario_id);
    
        // returns the associated object
        return $this->funcionario;
    }

    
}

