<?php

class ProdutoFilial extends TRecord
{
    const TABLENAME  = 'produto_filial';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto;
    private $system_unit;
    private $estoque_deposito_padrao;
    private $sob_encomenda;
    private $gerar_op_venda;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('margem');
        parent::addAttribute('preco_venda');
        parent::addAttribute('preco_venda_anterior');
        parent::addAttribute('valor_custo');
        parent::addAttribute('valor_custo_anterior');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('estoque_minimo');
        parent::addAttribute('estoque_maximo');
        parent::addAttribute('local_estoque');
        parent::addAttribute('codigo_balanca');
        parent::addAttribute('deletado_em');
        parent::addAttribute('estoque_deposito_padrao_id');
        parent::addAttribute('sob_encomenda_id');
        parent::addAttribute('gerar_op_venda_id');
    
    }

    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito_padrao(EstoqueDeposito $object)
    {
        $this->estoque_deposito_padrao = $object;
        $this->estoque_deposito_padrao_id = $object->id;
    }

    /**
     * Method get_estoque_deposito_padrao
     * Sample of usage: $var->estoque_deposito_padrao->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito_padrao()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito_padrao))
            $this->estoque_deposito_padrao = new EstoqueDeposito($this->estoque_deposito_padrao_id);
    
        // returns the associated object
        return $this->estoque_deposito_padrao;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_sob_encomenda(Resposta $object)
    {
        $this->sob_encomenda = $object;
        $this->sob_encomenda_id = $object->id;
    }

    /**
     * Method get_sob_encomenda
     * Sample of usage: $var->sob_encomenda->attribute;
     * @returns Resposta instance
     */
    public function get_sob_encomenda()
    {
    
        // loads the associated object
        if (empty($this->sob_encomenda))
            $this->sob_encomenda = new Resposta($this->sob_encomenda_id);
    
        // returns the associated object
        return $this->sob_encomenda;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_gerar_op_venda(Resposta $object)
    {
        $this->gerar_op_venda = $object;
        $this->gerar_op_venda_id = $object->id;
    }

    /**
     * Method get_gerar_op_venda
     * Sample of usage: $var->gerar_op_venda->attribute;
     * @returns Resposta instance
     */
    public function get_gerar_op_venda()
    {
    
        // loads the associated object
        if (empty($this->gerar_op_venda))
            $this->gerar_op_venda = new Resposta($this->gerar_op_venda_id);
    
        // returns the associated object
        return $this->gerar_op_venda;
    }

    /**
     * Method getProdutoEnderecamentos
     */
    public function getProdutoEnderecamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_filial_id', '=', $this->id));
        return ProdutoEnderecamento::getObjects( $criteria );
    }
    /**
     * Method getProdutoFilialHistoricos
     */
    public function getProdutoFilialHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_filial_id', '=', $this->id));
        return ProdutoFilialHistorico::getObjects( $criteria );
    }
    /**
     * Method getTabelaPrecoProdutos
     */
    public function getTabelaPrecoProdutos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_filial_id', '=', $this->id));
        return TabelaPrecoProduto::getObjects( $criteria );
    }

    public function set_produto_enderecamento_produto_filial_to_string($produto_enderecamento_produto_filial_to_string)
    {
        if(is_array($produto_enderecamento_produto_filial_to_string))
        {
            $values = ProdutoFilial::where('id', 'in', $produto_enderecamento_produto_filial_to_string)->getIndexedArray('preco_venda', 'preco_venda');
            $this->produto_enderecamento_produto_filial_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_enderecamento_produto_filial_to_string = $produto_enderecamento_produto_filial_to_string;
        }

        $this->vdata['produto_enderecamento_produto_filial_to_string'] = $this->produto_enderecamento_produto_filial_to_string;
    }

    public function get_produto_enderecamento_produto_filial_to_string()
    {
        if(!empty($this->produto_enderecamento_produto_filial_to_string))
        {
            return $this->produto_enderecamento_produto_filial_to_string;
        }
    
        $values = ProdutoEnderecamento::where('produto_filial_id', '=', $this->id)->getIndexedArray('produto_filial_id','{produto_filial->preco_venda}');
        return implode(', ', $values);
    }

    public function set_produto_enderecamento_estoque_prateleira_to_string($produto_enderecamento_estoque_prateleira_to_string)
    {
        if(is_array($produto_enderecamento_estoque_prateleira_to_string))
        {
            $values = EstoquePrateleira::where('id', 'in', $produto_enderecamento_estoque_prateleira_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_enderecamento_estoque_prateleira_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_enderecamento_estoque_prateleira_to_string = $produto_enderecamento_estoque_prateleira_to_string;
        }

        $this->vdata['produto_enderecamento_estoque_prateleira_to_string'] = $this->produto_enderecamento_estoque_prateleira_to_string;
    }

    public function get_produto_enderecamento_estoque_prateleira_to_string()
    {
        if(!empty($this->produto_enderecamento_estoque_prateleira_to_string))
        {
            return $this->produto_enderecamento_estoque_prateleira_to_string;
        }
    
        $values = ProdutoEnderecamento::where('produto_filial_id', '=', $this->id)->getIndexedArray('estoque_prateleira_id','{estoque_prateleira->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_historico_produto_to_string($produto_filial_historico_produto_to_string)
    {
        if(is_array($produto_filial_historico_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_filial_historico_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_filial_historico_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_historico_produto_to_string = $produto_filial_historico_produto_to_string;
        }

        $this->vdata['produto_filial_historico_produto_to_string'] = $this->produto_filial_historico_produto_to_string;
    }

    public function get_produto_filial_historico_produto_to_string()
    {
        if(!empty($this->produto_filial_historico_produto_to_string))
        {
            return $this->produto_filial_historico_produto_to_string;
        }
    
        $values = ProdutoFilialHistorico::where('produto_filial_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_filial_historico_produto_filial_to_string($produto_filial_historico_produto_filial_to_string)
    {
        if(is_array($produto_filial_historico_produto_filial_to_string))
        {
            $values = ProdutoFilial::where('id', 'in', $produto_filial_historico_produto_filial_to_string)->getIndexedArray('preco_venda', 'preco_venda');
            $this->produto_filial_historico_produto_filial_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_historico_produto_filial_to_string = $produto_filial_historico_produto_filial_to_string;
        }

        $this->vdata['produto_filial_historico_produto_filial_to_string'] = $this->produto_filial_historico_produto_filial_to_string;
    }

    public function get_produto_filial_historico_produto_filial_to_string()
    {
        if(!empty($this->produto_filial_historico_produto_filial_to_string))
        {
            return $this->produto_filial_historico_produto_filial_to_string;
        }
    
        $values = ProdutoFilialHistorico::where('produto_filial_id', '=', $this->id)->getIndexedArray('produto_filial_id','{produto_filial->preco_venda}');
        return implode(', ', $values);
    }

    public function set_tabela_preco_produto_tabela_preco_to_string($tabela_preco_produto_tabela_preco_to_string)
    {
        if(is_array($tabela_preco_produto_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $tabela_preco_produto_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->tabela_preco_produto_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->tabela_preco_produto_tabela_preco_to_string = $tabela_preco_produto_tabela_preco_to_string;
        }

        $this->vdata['tabela_preco_produto_tabela_preco_to_string'] = $this->tabela_preco_produto_tabela_preco_to_string;
    }

    public function get_tabela_preco_produto_tabela_preco_to_string()
    {
        if(!empty($this->tabela_preco_produto_tabela_preco_to_string))
        {
            return $this->tabela_preco_produto_tabela_preco_to_string;
        }
    
        $values = TabelaPrecoProduto::where('produto_filial_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_tabela_preco_produto_produto_filial_to_string($tabela_preco_produto_produto_filial_to_string)
    {
        if(is_array($tabela_preco_produto_produto_filial_to_string))
        {
            $values = ProdutoFilial::where('id', 'in', $tabela_preco_produto_produto_filial_to_string)->getIndexedArray('preco_venda', 'preco_venda');
            $this->tabela_preco_produto_produto_filial_to_string = implode(', ', $values);
        }
        else
        {
            $this->tabela_preco_produto_produto_filial_to_string = $tabela_preco_produto_produto_filial_to_string;
        }

        $this->vdata['tabela_preco_produto_produto_filial_to_string'] = $this->tabela_preco_produto_produto_filial_to_string;
    }

    public function get_tabela_preco_produto_produto_filial_to_string()
    {
        if(!empty($this->tabela_preco_produto_produto_filial_to_string))
        {
            return $this->tabela_preco_produto_produto_filial_to_string;
        }
    
        $values = TabelaPrecoProduto::where('produto_filial_id', '=', $this->id)->getIndexedArray('produto_filial_id','{produto_filial->preco_venda}');
        return implode(', ', $values);
    }

  
    public static function retornarEnderecamento()
    {
    
    }
  

}

