<?php

class ProdutoFilialHistorico extends TRecord
{
    const TABLENAME  = 'produto_filial_historico';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto;
    private $produto_filial;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto_id');
        parent::addAttribute('produto_filial_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('preco_venda_antigo');
        parent::addAttribute('preco_venda_novo');
        parent::addAttribute('valor_custo_antigo');
        parent::addAttribute('valor_custo_novo');
            
    }

    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_produto_filial
     * Sample of usage: $var->produto_filial = $object;
     * @param $object Instance of ProdutoFilial
     */
    public function set_produto_filial(ProdutoFilial $object)
    {
        $this->produto_filial = $object;
        $this->produto_filial_id = $object->id;
    }

    /**
     * Method get_produto_filial
     * Sample of usage: $var->produto_filial->attribute;
     * @returns ProdutoFilial instance
     */
    public function get_produto_filial()
    {
    
        // loads the associated object
        if (empty($this->produto_filial))
            $this->produto_filial = new ProdutoFilial($this->produto_filial_id);
    
        // returns the associated object
        return $this->produto_filial;
    }

    
}

