<?php

class ProdutoGrupo extends TRecord
{
    const TABLENAME  = 'produto_grupo';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $tipo_recurso;

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('tipo_recurso_id');
        parent::addAttribute('descricao');
        parent::addAttribute('imagem');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
        parent::addAttribute('deletado_em');
    
    }

    /**
     * Method set_tipo_recurso
     * Sample of usage: $var->tipo_recurso = $object;
     * @param $object Instance of TipoRecurso
     */
    public function set_tipo_recurso(TipoRecurso $object)
    {
        $this->tipo_recurso = $object;
        $this->tipo_recurso_id = $object->id;
    }

    /**
     * Method get_tipo_recurso
     * Sample of usage: $var->tipo_recurso->attribute;
     * @returns TipoRecurso instance
     */
    public function get_tipo_recurso()
    {
    
        // loads the associated object
        if (empty($this->tipo_recurso))
            $this->tipo_recurso = new TipoRecurso($this->tipo_recurso_id);
    
        // returns the associated object
        return $this->tipo_recurso;
    }

    /**
     * Method getProdutos
     */
    public function getProdutos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_grupo_id', '=', $this->id));
        return Produto::getObjects( $criteria );
    }
    /**
     * Method getProdutogrupoSubgrupos
     */
    public function getProdutogrupoSubgrupos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('produto_grupo_id', '=', $this->id));
        return ProdutogrupoSubgrupo::getObjects( $criteria );
    }

    public function set_produto_produto_grupo_to_string($produto_produto_grupo_to_string)
    {
        if(is_array($produto_produto_grupo_to_string))
        {
            $values = ProdutoGrupo::where('id', 'in', $produto_produto_grupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_grupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_grupo_to_string = $produto_produto_grupo_to_string;
        }

        $this->vdata['produto_produto_grupo_to_string'] = $this->produto_produto_grupo_to_string;
    }

    public function get_produto_produto_grupo_to_string()
    {
        if(!empty($this->produto_produto_grupo_to_string))
        {
            return $this->produto_produto_grupo_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('produto_grupo_id','{produto_grupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_unidade_medida_to_string($produto_unidade_medida_to_string)
    {
        if(is_array($produto_unidade_medida_to_string))
        {
            $values = UnidadeMedida::where('id', 'in', $produto_unidade_medida_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_unidade_medida_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_unidade_medida_to_string = $produto_unidade_medida_to_string;
        }

        $this->vdata['produto_unidade_medida_to_string'] = $this->produto_unidade_medida_to_string;
    }

    public function get_produto_unidade_medida_to_string()
    {
        if(!empty($this->produto_unidade_medida_to_string))
        {
            return $this->produto_unidade_medida_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('unidade_medida_id','{unidade_medida->nome}');
        return implode(', ', $values);
    }

    public function set_produto_tipo_recurso_to_string($produto_tipo_recurso_to_string)
    {
        if(is_array($produto_tipo_recurso_to_string))
        {
            $values = TipoRecurso::where('id', 'in', $produto_tipo_recurso_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_tipo_recurso_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_tipo_recurso_to_string = $produto_tipo_recurso_to_string;
        }

        $this->vdata['produto_tipo_recurso_to_string'] = $this->produto_tipo_recurso_to_string;
    }

    public function get_produto_tipo_recurso_to_string()
    {
        if(!empty($this->produto_tipo_recurso_to_string))
        {
            return $this->produto_tipo_recurso_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('tipo_recurso_id','{tipo_recurso->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produto_fabricante_to_string($produto_produto_fabricante_to_string)
    {
        if(is_array($produto_produto_fabricante_to_string))
        {
            $values = ProdutoFabricante::where('id', 'in', $produto_produto_fabricante_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_produto_fabricante_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_fabricante_to_string = $produto_produto_fabricante_to_string;
        }

        $this->vdata['produto_produto_fabricante_to_string'] = $this->produto_produto_fabricante_to_string;
    }

    public function get_produto_produto_fabricante_to_string()
    {
        if(!empty($this->produto_produto_fabricante_to_string))
        {
            return $this->produto_produto_fabricante_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('produto_fabricante_id','{produto_fabricante->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produtogrupo_subgrupo_to_string($produto_produtogrupo_subgrupo_to_string)
    {
        if(is_array($produto_produtogrupo_subgrupo_to_string))
        {
            $values = ProdutogrupoSubgrupo::where('id', 'in', $produto_produtogrupo_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produtogrupo_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produtogrupo_subgrupo_to_string = $produto_produtogrupo_subgrupo_to_string;
        }

        $this->vdata['produto_produtogrupo_subgrupo_to_string'] = $this->produto_produtogrupo_subgrupo_to_string;
    }

    public function get_produto_produtogrupo_subgrupo_to_string()
    {
        if(!empty($this->produto_produtogrupo_subgrupo_to_string))
        {
            return $this->produto_produtogrupo_subgrupo_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('produtogrupo_subgrupo_id','{produtogrupo_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_notafiscal_item_orig_to_string($produto_notafiscal_item_orig_to_string)
    {
        if(is_array($produto_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $produto_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->produto_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_notafiscal_item_orig_to_string = $produto_notafiscal_item_orig_to_string;
        }

        $this->vdata['produto_notafiscal_item_orig_to_string'] = $this->produto_notafiscal_item_orig_to_string;
    }

    public function get_produto_notafiscal_item_orig_to_string()
    {
        if(!empty($this->produto_notafiscal_item_orig_to_string))
        {
            return $this->produto_notafiscal_item_orig_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_produto_habilitado_to_string($produto_habilitado_to_string)
    {
        if(is_array($produto_habilitado_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_habilitado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_habilitado_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_habilitado_to_string = $produto_habilitado_to_string;
        }

        $this->vdata['produto_habilitado_to_string'] = $this->produto_habilitado_to_string;
    }

    public function get_produto_habilitado_to_string()
    {
        if(!empty($this->produto_habilitado_to_string))
        {
            return $this->produto_habilitado_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('habilitado_id','{habilitado->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_tipo_to_string($produto_produto_tipo_to_string)
    {
        if(is_array($produto_produto_tipo_to_string))
        {
            $values = ProdutoTipo::where('id', 'in', $produto_produto_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_tipo_to_string = $produto_produto_tipo_to_string;
        }

        $this->vdata['produto_produto_tipo_to_string'] = $this->produto_produto_tipo_to_string;
    }

    public function get_produto_produto_tipo_to_string()
    {
        if(!empty($this->produto_produto_tipo_to_string))
        {
            return $this->produto_produto_tipo_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('produto_tipo_id','{produto_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_embalagem_to_string($produto_produto_embalagem_to_string)
    {
        if(is_array($produto_produto_embalagem_to_string))
        {
            $values = ProdutoEmbalagem::where('id', 'in', $produto_produto_embalagem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_embalagem_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_embalagem_to_string = $produto_produto_embalagem_to_string;
        }

        $this->vdata['produto_produto_embalagem_to_string'] = $this->produto_produto_embalagem_to_string;
    }

    public function get_produto_produto_embalagem_to_string()
    {
        if(!empty($this->produto_produto_embalagem_to_string))
        {
            return $this->produto_produto_embalagem_to_string;
        }
    
        $values = Produto::where('produto_grupo_id', '=', $this->id)->getIndexedArray('produto_embalagem_id','{produto_embalagem->descricao}');
        return implode(', ', $values);
    }

    public function set_produtogrupo_subgrupo_produto_grupo_to_string($produtogrupo_subgrupo_produto_grupo_to_string)
    {
        if(is_array($produtogrupo_subgrupo_produto_grupo_to_string))
        {
            $values = ProdutoGrupo::where('id', 'in', $produtogrupo_subgrupo_produto_grupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produtogrupo_subgrupo_produto_grupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produtogrupo_subgrupo_produto_grupo_to_string = $produtogrupo_subgrupo_produto_grupo_to_string;
        }

        $this->vdata['produtogrupo_subgrupo_produto_grupo_to_string'] = $this->produtogrupo_subgrupo_produto_grupo_to_string;
    }

    public function get_produtogrupo_subgrupo_produto_grupo_to_string()
    {
        if(!empty($this->produtogrupo_subgrupo_produto_grupo_to_string))
        {
            return $this->produtogrupo_subgrupo_produto_grupo_to_string;
        }
    
        $values = ProdutogrupoSubgrupo::where('produto_grupo_id', '=', $this->id)->getIndexedArray('produto_grupo_id','{produto_grupo->descricao}');
        return implode(', ', $values);
    }

  public static function informacoes_ajuda()
  {
      $texto = '<b>Grupos de Produto</b><br>'.
               'Cadastro de grupos e sub-grupos de produtos. Classifique seus produtos por tipo.<br> '.
               '<b>Excemplo:</b>'.
               'Produto: Laranja. Pode-se criar um grupo com o nome de Frutas.<br><br>';
            //   '<b>Video explicativo:</b><br>'.
            //   '<iframe width="560" height="315" src="https://www.youtube.com/embed/oAi2mM4cIFg" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>';

      return $texto;
  }  
    
}

