<?php

class Resposta extends TRecord
{
    const TABLENAME  = 'resposta';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const Sim = '1';
    const Nao = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
            
    }

    /**
     * Method getClientes
     */
    public function getClientesByFkResidenciaProprias()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('residencia_propria', '=', $this->id));
        return Cliente::getObjects( $criteria );
    }
    /**
     * Method getClientes
     */
    public function getClientesByFkUtilizarEnderecoCobrancas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('utilizar_endereco_cobranca', '=', $this->id));
        return Cliente::getObjects( $criteria );
    }
    /**
     * Method getClienteEnderecos
     */
    public function getClienteEnderecos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('principal', '=', $this->id));
        return ClienteEndereco::getObjects( $criteria );
    }
    /**
     * Method getConfiguracoesFilials
     */
    public function getConfiguracoesFilialsByCpagUsaPlanoContass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cpag_usa_plano_contas_id', '=', $this->id));
        return ConfiguracoesFilial::getObjects( $criteria );
    }
    /**
     * Method getConfiguracoesFilials
     */
    public function getConfiguracoesFilialsByInformarDuplicidadeDeItemVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('informar_duplicidade_de_item_venda_id', '=', $this->id));
        return ConfiguracoesFilial::getObjects( $criteria );
    }
    /**
     * Method getConfiguracoesFilials
     */
    public function getConfiguracoesFilialsByVendaApenasComEstoques()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_apenas_com_estoque_id', '=', $this->id));
        return ConfiguracoesFilial::getObjects( $criteria );
    }
    /**
     * Method getFunilEtapass
     */
    public function getFunilEtapass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('ultima_etapa', '=', $this->id));
        return FunilEtapas::getObjects( $criteria );
    }
    /**
     * Method getMdfes
     */
    public function getMdfesByFkIndcanalverdes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('indCanalVerde', '=', $this->id));
        return Mdfe::getObjects( $criteria );
    }
    /**
     * Method getMdfes
     */
    public function getMdfesByFkIndcarregaposteriors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('indCarregaPosterior', '=', $this->id));
        return Mdfe::getObjects( $criteria );
    }
    /**
     * Method getMdfes
     */
    public function getMdfesByFkIndantecipaadiants()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('indAntecipaAdiant', '=', $this->id));
        return Mdfe::getObjects( $criteria );
    }
    /**
     * Method getMdfeCtess
     */
    public function getMdfeCtess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('indReentrega', '=', $this->id));
        return MdfeCtes::getObjects( $criteria );
    }
    /**
     * Method getMdfeMdfess
     */
    public function getMdfeMdfess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('indReentrega', '=', $this->id));
        return MdfeMdfes::getObjects( $criteria );
    }
    /**
     * Method getMdfeNfess
     */
    public function getMdfeNfess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('indReentrega', '=', $this->id));
        return MdfeNfes::getObjects( $criteria );
    }
    /**
     * Method getNaturezaOperacaos
     */
    public function getNaturezaOperacaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('consumidor_final_id', '=', $this->id));
        return NaturezaOperacao::getObjects( $criteria );
    }
    /**
     * Method getNegocios
     */
    public function getNegocios()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('arquivado', '=', $this->id));
        return Negocio::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoItemFichaTecnicas
     */
    public function getOrdemServicoItemFichaTecnicas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('quantidade_fixa_id', '=', $this->id));
        return OrdemServicoItemFichaTecnica::getObjects( $criteria );
    }
    /**
     * Method getProdutos
     */
    public function getProdutos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('habilitado_id', '=', $this->id));
        return Produto::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicaItenss
     */
    public function getProdutoFichaTecnicaItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('quantidade_fixa_id', '=', $this->id));
        return ProdutoFichaTecnicaItens::getObjects( $criteria );
    }
    /**
     * Method getProdutoFilials
     */
    public function getProdutoFilialsBySobEncomendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('sob_encomenda_id', '=', $this->id));
        return ProdutoFilial::getObjects( $criteria );
    }
    /**
     * Method getProdutoFilials
     */
    public function getProdutoFilialsByGerarOpVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('gerar_op_venda_id', '=', $this->id));
        return ProdutoFilial::getObjects( $criteria );
    }
    /**
     * Method getVendaItems
     */
    public function getVendaItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cancelado', '=', $this->id));
        return VendaItem::getObjects( $criteria );
    }

    public function set_cliente_pessoa_tipo_to_string($cliente_pessoa_tipo_to_string)
    {
        if(is_array($cliente_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $cliente_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_pessoa_tipo_to_string = $cliente_pessoa_tipo_to_string;
        }

        $this->vdata['cliente_pessoa_tipo_to_string'] = $this->cliente_pessoa_tipo_to_string;
    }

    public function get_cliente_pessoa_tipo_to_string()
    {
        if(!empty($this->cliente_pessoa_tipo_to_string))
        {
            return $this->cliente_pessoa_tipo_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_to_string($cliente_cliente_classificacao_to_string)
    {
        if(is_array($cliente_cliente_classificacao_to_string))
        {
            $values = ClienteClassificacao::where('id', 'in', $cliente_cliente_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_to_string = $cliente_cliente_classificacao_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_to_string'] = $this->cliente_cliente_classificacao_to_string;
    }

    public function get_cliente_cliente_classificacao_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_to_string))
        {
            return $this->cliente_cliente_classificacao_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('cliente_classificacao_id','{cliente_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_subgrupo_to_string($cliente_cliente_classificacao_subgrupo_to_string)
    {
        if(is_array($cliente_cliente_classificacao_subgrupo_to_string))
        {
            $values = ClienteClassificacaoSubgrupo::where('id', 'in', $cliente_cliente_classificacao_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_subgrupo_to_string = $cliente_cliente_classificacao_subgrupo_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_subgrupo_to_string'] = $this->cliente_cliente_classificacao_subgrupo_to_string;
    }

    public function get_cliente_cliente_classificacao_subgrupo_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_subgrupo_to_string))
        {
            return $this->cliente_cliente_classificacao_subgrupo_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('cliente_classificacao_subgrupo_id','{cliente_classificacao_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_vendedor_to_string($cliente_vendedor_to_string)
    {
        if(is_array($cliente_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $cliente_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_vendedor_to_string = $cliente_vendedor_to_string;
        }

        $this->vdata['cliente_vendedor_to_string'] = $this->cliente_vendedor_to_string;
    }

    public function get_cliente_vendedor_to_string()
    {
        if(!empty($this->cliente_vendedor_to_string))
        {
            return $this->cliente_vendedor_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_indiedest_to_string($cliente_notafiscal_indiedest_to_string)
    {
        if(is_array($cliente_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $cliente_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_indiedest_to_string = $cliente_notafiscal_indiedest_to_string;
        }

        $this->vdata['cliente_notafiscal_indiedest_to_string'] = $this->cliente_notafiscal_indiedest_to_string;
    }

    public function get_cliente_notafiscal_indiedest_to_string()
    {
        if(!empty($this->cliente_notafiscal_indiedest_to_string))
        {
            return $this->cliente_notafiscal_indiedest_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_crt_to_string($cliente_notafiscal_crt_to_string)
    {
        if(is_array($cliente_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $cliente_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_crt_to_string = $cliente_notafiscal_crt_to_string;
        }

        $this->vdata['cliente_notafiscal_crt_to_string'] = $this->cliente_notafiscal_crt_to_string;
    }

    public function get_cliente_notafiscal_crt_to_string()
    {
        if(!empty($this->cliente_notafiscal_crt_to_string))
        {
            return $this->cliente_notafiscal_crt_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_residencia_propria_to_string($cliente_fk_residencia_propria_to_string)
    {
        if(is_array($cliente_fk_residencia_propria_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_residencia_propria_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_residencia_propria_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_residencia_propria_to_string = $cliente_fk_residencia_propria_to_string;
        }

        $this->vdata['cliente_fk_residencia_propria_to_string'] = $this->cliente_fk_residencia_propria_to_string;
    }

    public function get_cliente_fk_residencia_propria_to_string()
    {
        if(!empty($this->cliente_fk_residencia_propria_to_string))
        {
            return $this->cliente_fk_residencia_propria_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('residencia_propria','{fk_residencia_propria->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_utilizar_endereco_cobranca_to_string($cliente_fk_utilizar_endereco_cobranca_to_string)
    {
        if(is_array($cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_utilizar_endereco_cobranca_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = $cliente_fk_utilizar_endereco_cobranca_to_string;
        }

        $this->vdata['cliente_fk_utilizar_endereco_cobranca_to_string'] = $this->cliente_fk_utilizar_endereco_cobranca_to_string;
    }

    public function get_cliente_fk_utilizar_endereco_cobranca_to_string()
    {
        if(!empty($this->cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            return $this->cliente_fk_utilizar_endereco_cobranca_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('utilizar_endereco_cobranca','{fk_utilizar_endereco_cobranca->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_situacao_to_string($cliente_cliente_situacao_to_string)
    {
        if(is_array($cliente_cliente_situacao_to_string))
        {
            $values = ClienteSituacao::where('id', 'in', $cliente_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_situacao_to_string = $cliente_cliente_situacao_to_string;
        }

        $this->vdata['cliente_cliente_situacao_to_string'] = $this->cliente_cliente_situacao_to_string;
    }

    public function get_cliente_cliente_situacao_to_string()
    {
        if(!empty($this->cliente_cliente_situacao_to_string))
        {
            return $this->cliente_cliente_situacao_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('cliente_situacao_id','{cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_system_unit_to_string($cliente_system_unit_to_string)
    {
        if(is_array($cliente_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $cliente_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->cliente_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_system_unit_to_string = $cliente_system_unit_to_string;
        }

        $this->vdata['cliente_system_unit_to_string'] = $this->cliente_system_unit_to_string;
    }

    public function get_cliente_system_unit_to_string()
    {
        if(!empty($this->cliente_system_unit_to_string))
        {
            return $this->cliente_system_unit_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_cliente_tabela_preco_to_string($cliente_tabela_preco_to_string)
    {
        if(is_array($cliente_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $cliente_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_tabela_preco_to_string = $cliente_tabela_preco_to_string;
        }

        $this->vdata['cliente_tabela_preco_to_string'] = $this->cliente_tabela_preco_to_string;
    }

    public function get_cliente_tabela_preco_to_string()
    {
        if(!empty($this->cliente_tabela_preco_to_string))
        {
            return $this->cliente_tabela_preco_to_string;
        }
    
        $values = Cliente::where('utilizar_endereco_cobranca', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_cliente_to_string($cliente_endereco_cliente_to_string)
    {
        if(is_array($cliente_endereco_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $cliente_endereco_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_endereco_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_cliente_to_string = $cliente_endereco_cliente_to_string;
        }

        $this->vdata['cliente_endereco_cliente_to_string'] = $this->cliente_endereco_cliente_to_string;
    }

    public function get_cliente_endereco_cliente_to_string()
    {
        if(!empty($this->cliente_endereco_cliente_to_string))
        {
            return $this->cliente_endereco_cliente_to_string;
        }
    
        $values = ClienteEndereco::where('principal', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_fk_principal_to_string($cliente_endereco_fk_principal_to_string)
    {
        if(is_array($cliente_endereco_fk_principal_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_endereco_fk_principal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_endereco_fk_principal_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_fk_principal_to_string = $cliente_endereco_fk_principal_to_string;
        }

        $this->vdata['cliente_endereco_fk_principal_to_string'] = $this->cliente_endereco_fk_principal_to_string;
    }

    public function get_cliente_endereco_fk_principal_to_string()
    {
        if(!empty($this->cliente_endereco_fk_principal_to_string))
        {
            return $this->cliente_endereco_fk_principal_to_string;
        }
    
        $values = ClienteEndereco::where('principal', '=', $this->id)->getIndexedArray('principal','{fk_principal->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_endereco_cidade_to_string($cliente_endereco_cidade_to_string)
    {
        if(is_array($cliente_endereco_cidade_to_string))
        {
            $values = Cidade::where('id', 'in', $cliente_endereco_cidade_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_endereco_cidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_endereco_cidade_to_string = $cliente_endereco_cidade_to_string;
        }

        $this->vdata['cliente_endereco_cidade_to_string'] = $this->cliente_endereco_cidade_to_string;
    }

    public function get_cliente_endereco_cidade_to_string()
    {
        if(!empty($this->cliente_endereco_cidade_to_string))
        {
            return $this->cliente_endereco_cidade_to_string;
        }
    
        $values = ClienteEndereco::where('principal', '=', $this->id)->getIndexedArray('cidade_id','{cidade->nome}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_configuracoes_to_string($configuracoes_filial_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_configuracoes_to_string))
        {
            $values = Configuracoes::where('id', 'in', $configuracoes_filial_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_configuracoes_to_string = $configuracoes_filial_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_configuracoes_to_string'] = $this->configuracoes_filial_configuracoes_to_string;
    }

    public function get_configuracoes_filial_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_configuracoes_to_string))
        {
            return $this->configuracoes_filial_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('configuracoes_id','{configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_system_unit_to_string($configuracoes_filial_system_unit_to_string)
    {
        if(is_array($configuracoes_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $configuracoes_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->configuracoes_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_system_unit_to_string = $configuracoes_filial_system_unit_to_string;
        }

        $this->vdata['configuracoes_filial_system_unit_to_string'] = $this->configuracoes_filial_system_unit_to_string;
    }

    public function get_configuracoes_filial_system_unit_to_string()
    {
        if(!empty($this->configuracoes_filial_system_unit_to_string))
        {
            return $this->configuracoes_filial_system_unit_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_produto_etiqueta_configuracoes_to_string($configuracoes_filial_produto_etiqueta_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            $values = ProdutoEtiquetaConfiguracoes::where('id', 'in', $configuracoes_filial_produto_etiqueta_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = $configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_produto_etiqueta_configuracoes_to_string'] = $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
    }

    public function get_configuracoes_filial_produto_etiqueta_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            return $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('produto_etiqueta_configuracoes_id','{produto_etiqueta_configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_plano_conta_crec_to_string($configuracoes_filial_plano_conta_crec_to_string)
    {
        if(is_array($configuracoes_filial_plano_conta_crec_to_string))
        {
            $values = PlanoConta::where('id', 'in', $configuracoes_filial_plano_conta_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_plano_conta_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_plano_conta_crec_to_string = $configuracoes_filial_plano_conta_crec_to_string;
        }

        $this->vdata['configuracoes_filial_plano_conta_crec_to_string'] = $this->configuracoes_filial_plano_conta_crec_to_string;
    }

    public function get_configuracoes_filial_plano_conta_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_plano_conta_crec_to_string))
        {
            return $this->configuracoes_filial_plano_conta_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('plano_conta_crec_id','{plano_conta_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_centro_custo_crec_to_string($configuracoes_filial_centro_custo_crec_to_string)
    {
        if(is_array($configuracoes_filial_centro_custo_crec_to_string))
        {
            $values = CentroCusto::where('id', 'in', $configuracoes_filial_centro_custo_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_centro_custo_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_centro_custo_crec_to_string = $configuracoes_filial_centro_custo_crec_to_string;
        }

        $this->vdata['configuracoes_filial_centro_custo_crec_to_string'] = $this->configuracoes_filial_centro_custo_crec_to_string;
    }

    public function get_configuracoes_filial_centro_custo_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_centro_custo_crec_to_string))
        {
            return $this->configuracoes_filial_centro_custo_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('centro_custo_crec_id','{centro_custo_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_cpag_usa_plano_contas_to_string($configuracoes_filial_cpag_usa_plano_contas_to_string)
    {
        if(is_array($configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_cpag_usa_plano_contas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = $configuracoes_filial_cpag_usa_plano_contas_to_string;
        }

        $this->vdata['configuracoes_filial_cpag_usa_plano_contas_to_string'] = $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
    }

    public function get_configuracoes_filial_cpag_usa_plano_contas_to_string()
    {
        if(!empty($this->configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            return $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('cpag_usa_plano_contas_id','{cpag_usa_plano_contas->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_informar_duplicidade_de_item_venda_to_string($configuracoes_filial_informar_duplicidade_de_item_venda_to_string)
    {
        if(is_array($configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_informar_duplicidade_de_item_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = $configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }

        $this->vdata['configuracoes_filial_informar_duplicidade_de_item_venda_to_string'] = $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
    }

    public function get_configuracoes_filial_informar_duplicidade_de_item_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            return $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('informar_duplicidade_de_item_venda_id','{informar_duplicidade_de_item_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_venda_apenas_com_estoque_to_string($configuracoes_filial_venda_apenas_com_estoque_to_string)
    {
        if(is_array($configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_venda_apenas_com_estoque_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = $configuracoes_filial_venda_apenas_com_estoque_to_string;
        }

        $this->vdata['configuracoes_filial_venda_apenas_com_estoque_to_string'] = $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
    }

    public function get_configuracoes_filial_venda_apenas_com_estoque_to_string()
    {
        if(!empty($this->configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            return $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('venda_apenas_com_estoque_id','{venda_apenas_com_estoque->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_orcamento_id','{notafiscal_cprod_padrao_orcamento->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_venda_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('venda_apenas_com_estoque_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_venda_id','{notafiscal_cprod_padrao_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_funil_etapas_funil_to_string($funil_etapas_funil_to_string)
    {
        if(is_array($funil_etapas_funil_to_string))
        {
            $values = Funil::where('id', 'in', $funil_etapas_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->funil_etapas_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->funil_etapas_funil_to_string = $funil_etapas_funil_to_string;
        }

        $this->vdata['funil_etapas_funil_to_string'] = $this->funil_etapas_funil_to_string;
    }

    public function get_funil_etapas_funil_to_string()
    {
        if(!empty($this->funil_etapas_funil_to_string))
        {
            return $this->funil_etapas_funil_to_string;
        }
    
        $values = FunilEtapas::where('ultima_etapa', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_funil_etapas_fk_ultima_etapa_to_string($funil_etapas_fk_ultima_etapa_to_string)
    {
        if(is_array($funil_etapas_fk_ultima_etapa_to_string))
        {
            $values = Resposta::where('id', 'in', $funil_etapas_fk_ultima_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->funil_etapas_fk_ultima_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->funil_etapas_fk_ultima_etapa_to_string = $funil_etapas_fk_ultima_etapa_to_string;
        }

        $this->vdata['funil_etapas_fk_ultima_etapa_to_string'] = $this->funil_etapas_fk_ultima_etapa_to_string;
    }

    public function get_funil_etapas_fk_ultima_etapa_to_string()
    {
        if(!empty($this->funil_etapas_fk_ultima_etapa_to_string))
        {
            return $this->funil_etapas_fk_ultima_etapa_to_string;
        }
    
        $values = FunilEtapas::where('ultima_etapa', '=', $this->id)->getIndexedArray('ultima_etapa','{fk_ultima_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_system_unit_to_string($mdfe_system_unit_to_string)
    {
        if(is_array($mdfe_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $mdfe_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->mdfe_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_system_unit_to_string = $mdfe_system_unit_to_string;
        }

        $this->vdata['mdfe_system_unit_to_string'] = $this->mdfe_system_unit_to_string;
    }

    public function get_mdfe_system_unit_to_string()
    {
        if(!empty($this->mdfe_system_unit_to_string))
        {
            return $this->mdfe_system_unit_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpemit_to_string($mdfe_mdfe_tpemit_to_string)
    {
        if(is_array($mdfe_mdfe_tpemit_to_string))
        {
            $values = MdfeTpemit::where('id', 'in', $mdfe_mdfe_tpemit_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpemit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpemit_to_string = $mdfe_mdfe_tpemit_to_string;
        }

        $this->vdata['mdfe_mdfe_tpemit_to_string'] = $this->mdfe_mdfe_tpemit_to_string;
    }

    public function get_mdfe_mdfe_tpemit_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpemit_to_string))
        {
            return $this->mdfe_mdfe_tpemit_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_tpemit_id','{mdfe_tpemit->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpprop_to_string($mdfe_mdfe_tpprop_to_string)
    {
        if(is_array($mdfe_mdfe_tpprop_to_string))
        {
            $values = MdfeTpprop::where('id', 'in', $mdfe_mdfe_tpprop_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpprop_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpprop_to_string = $mdfe_mdfe_tpprop_to_string;
        }

        $this->vdata['mdfe_mdfe_tpprop_to_string'] = $this->mdfe_mdfe_tpprop_to_string;
    }

    public function get_mdfe_mdfe_tpprop_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpprop_to_string))
        {
            return $this->mdfe_mdfe_tpprop_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_tpprop_id','{mdfe_tpprop->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tptransp_to_string($mdfe_mdfe_tptransp_to_string)
    {
        if(is_array($mdfe_mdfe_tptransp_to_string))
        {
            $values = MdfeTptransp::where('id', 'in', $mdfe_mdfe_tptransp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tptransp_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tptransp_to_string = $mdfe_mdfe_tptransp_to_string;
        }

        $this->vdata['mdfe_mdfe_tptransp_to_string'] = $this->mdfe_mdfe_tptransp_to_string;
    }

    public function get_mdfe_mdfe_tptransp_to_string()
    {
        if(!empty($this->mdfe_mdfe_tptransp_to_string))
        {
            return $this->mdfe_mdfe_tptransp_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_tptransp_id','{mdfe_tptransp->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcar_to_string($mdfe_mdfe_tpcar_to_string)
    {
        if(is_array($mdfe_mdfe_tpcar_to_string))
        {
            $values = MdfeTpcar::where('id', 'in', $mdfe_mdfe_tpcar_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcar_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcar_to_string = $mdfe_mdfe_tpcar_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcar_to_string'] = $this->mdfe_mdfe_tpcar_to_string;
    }

    public function get_mdfe_mdfe_tpcar_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcar_to_string))
        {
            return $this->mdfe_mdfe_tpcar_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_tpcar_id','{mdfe_tpcar->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFIni_to_string($mdfe_fk_UFIni_to_string)
    {
        if(is_array($mdfe_fk_UFIni_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFIni_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFIni_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFIni_to_string = $mdfe_fk_UFIni_to_string;
        }

        $this->vdata['mdfe_fk_UFIni_to_string'] = $this->mdfe_fk_UFIni_to_string;
    }

    public function get_mdfe_fk_UFIni_to_string()
    {
        if(!empty($this->mdfe_fk_UFIni_to_string))
        {
            return $this->mdfe_fk_UFIni_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('UFIni','{fk_UFIni->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFFim_to_string($mdfe_fk_UFFim_to_string)
    {
        if(is_array($mdfe_fk_UFFim_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFFim_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFFim_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFFim_to_string = $mdfe_fk_UFFim_to_string;
        }

        $this->vdata['mdfe_fk_UFFim_to_string'] = $this->mdfe_fk_UFFim_to_string;
    }

    public function get_mdfe_fk_UFFim_to_string()
    {
        if(!empty($this->mdfe_fk_UFFim_to_string))
        {
            return $this->mdfe_fk_UFFim_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('UFFim','{fk_UFFim->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCanalVerde_to_string($mdfe_fk_indCanalVerde_to_string)
    {
        if(is_array($mdfe_fk_indCanalVerde_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCanalVerde_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCanalVerde_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCanalVerde_to_string = $mdfe_fk_indCanalVerde_to_string;
        }

        $this->vdata['mdfe_fk_indCanalVerde_to_string'] = $this->mdfe_fk_indCanalVerde_to_string;
    }

    public function get_mdfe_fk_indCanalVerde_to_string()
    {
        if(!empty($this->mdfe_fk_indCanalVerde_to_string))
        {
            return $this->mdfe_fk_indCanalVerde_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('indCanalVerde','{fk_indCanalVerde->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCarregaPosterior_to_string($mdfe_fk_indCarregaPosterior_to_string)
    {
        if(is_array($mdfe_fk_indCarregaPosterior_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCarregaPosterior_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCarregaPosterior_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCarregaPosterior_to_string = $mdfe_fk_indCarregaPosterior_to_string;
        }

        $this->vdata['mdfe_fk_indCarregaPosterior_to_string'] = $this->mdfe_fk_indCarregaPosterior_to_string;
    }

    public function get_mdfe_fk_indCarregaPosterior_to_string()
    {
        if(!empty($this->mdfe_fk_indCarregaPosterior_to_string))
        {
            return $this->mdfe_fk_indCarregaPosterior_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('indCarregaPosterior','{fk_indCarregaPosterior->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_respSeg_to_string($mdfe_mdfe_respSeg_to_string)
    {
        if(is_array($mdfe_mdfe_respSeg_to_string))
        {
            $values = MdfeRespseg::where('id', 'in', $mdfe_mdfe_respSeg_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_respSeg_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_respSeg_to_string = $mdfe_mdfe_respSeg_to_string;
        }

        $this->vdata['mdfe_mdfe_respSeg_to_string'] = $this->mdfe_mdfe_respSeg_to_string;
    }

    public function get_mdfe_mdfe_respSeg_to_string()
    {
        if(!empty($this->mdfe_mdfe_respSeg_to_string))
        {
            return $this->mdfe_mdfe_respSeg_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_respSeg_id','{mdfe_respSeg->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_cunid_to_string($mdfe_mdfe_cunid_to_string)
    {
        if(is_array($mdfe_mdfe_cunid_to_string))
        {
            $values = MdfeCunid::where('id', 'in', $mdfe_mdfe_cunid_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_cunid_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_cunid_to_string = $mdfe_mdfe_cunid_to_string;
        }

        $this->vdata['mdfe_mdfe_cunid_to_string'] = $this->mdfe_mdfe_cunid_to_string;
    }

    public function get_mdfe_mdfe_cunid_to_string()
    {
        if(!empty($this->mdfe_mdfe_cunid_to_string))
        {
            return $this->mdfe_mdfe_cunid_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_cunid_id','{mdfe_cunid->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcarga_to_string($mdfe_mdfe_tpcarga_to_string)
    {
        if(is_array($mdfe_mdfe_tpcarga_to_string))
        {
            $values = MdfeTpcarga::where('id', 'in', $mdfe_mdfe_tpcarga_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcarga_to_string = $mdfe_mdfe_tpcarga_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcarga_to_string'] = $this->mdfe_mdfe_tpcarga_to_string;
    }

    public function get_mdfe_mdfe_tpcarga_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcarga_to_string))
        {
            return $this->mdfe_mdfe_tpcarga_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_tpcarga_id','{mdfe_tpcarga->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_indpag_to_string($mdfe_mdfe_indpag_to_string)
    {
        if(is_array($mdfe_mdfe_indpag_to_string))
        {
            $values = MdfeIndpag::where('id', 'in', $mdfe_mdfe_indpag_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_indpag_to_string = $mdfe_mdfe_indpag_to_string;
        }

        $this->vdata['mdfe_mdfe_indpag_to_string'] = $this->mdfe_mdfe_indpag_to_string;
    }

    public function get_mdfe_mdfe_indpag_to_string()
    {
        if(!empty($this->mdfe_mdfe_indpag_to_string))
        {
            return $this->mdfe_mdfe_indpag_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_indpag_id','{mdfe_indpag->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indAntecipaAdiant_to_string($mdfe_fk_indAntecipaAdiant_to_string)
    {
        if(is_array($mdfe_fk_indAntecipaAdiant_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indAntecipaAdiant_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indAntecipaAdiant_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indAntecipaAdiant_to_string = $mdfe_fk_indAntecipaAdiant_to_string;
        }

        $this->vdata['mdfe_fk_indAntecipaAdiant_to_string'] = $this->mdfe_fk_indAntecipaAdiant_to_string;
    }

    public function get_mdfe_fk_indAntecipaAdiant_to_string()
    {
        if(!empty($this->mdfe_fk_indAntecipaAdiant_to_string))
        {
            return $this->mdfe_fk_indAntecipaAdiant_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('indAntecipaAdiant','{fk_indAntecipaAdiant->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpRod_to_string($mdfe_mdfe_tpRod_to_string)
    {
        if(is_array($mdfe_mdfe_tpRod_to_string))
        {
            $values = MdfeTprod::where('id', 'in', $mdfe_mdfe_tpRod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpRod_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpRod_to_string = $mdfe_mdfe_tpRod_to_string;
        }

        $this->vdata['mdfe_mdfe_tpRod_to_string'] = $this->mdfe_mdfe_tpRod_to_string;
    }

    public function get_mdfe_mdfe_tpRod_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpRod_to_string))
        {
            return $this->mdfe_mdfe_tpRod_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_tpRod_id','{mdfe_tpRod->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_veic_estado_to_string($mdfe_veic_estado_to_string)
    {
        if(is_array($mdfe_veic_estado_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_veic_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_veic_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veic_estado_to_string = $mdfe_veic_estado_to_string;
        }

        $this->vdata['mdfe_veic_estado_to_string'] = $this->mdfe_veic_estado_to_string;
    }

    public function get_mdfe_veic_estado_to_string()
    {
        if(!empty($this->mdfe_veic_estado_to_string))
        {
            return $this->mdfe_veic_estado_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('veic_estado_id','{veic_estado->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_veiculo_to_string($mdfe_veiculo_to_string)
    {
        if(is_array($mdfe_veiculo_to_string))
        {
            $values = Veiculo::where('id', 'in', $mdfe_veiculo_to_string)->getIndexedArray('modelo_marca', 'modelo_marca');
            $this->mdfe_veiculo_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veiculo_to_string = $mdfe_veiculo_to_string;
        }

        $this->vdata['mdfe_veiculo_to_string'] = $this->mdfe_veiculo_to_string;
    }

    public function get_mdfe_veiculo_to_string()
    {
        if(!empty($this->mdfe_veiculo_to_string))
        {
            return $this->mdfe_veiculo_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('veiculo_id','{veiculo->modelo_marca}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_situacao_to_string($mdfe_mdfe_situacao_to_string)
    {
        if(is_array($mdfe_mdfe_situacao_to_string))
        {
            $values = MdfeSituacao::where('id', 'in', $mdfe_mdfe_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_situacao_to_string = $mdfe_mdfe_situacao_to_string;
        }

        $this->vdata['mdfe_mdfe_situacao_to_string'] = $this->mdfe_mdfe_situacao_to_string;
    }

    public function get_mdfe_mdfe_situacao_to_string()
    {
        if(!empty($this->mdfe_mdfe_situacao_to_string))
        {
            return $this->mdfe_mdfe_situacao_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_situacao_id','{mdfe_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpamb_to_string($mdfe_mdfe_tpamb_to_string)
    {
        if(is_array($mdfe_mdfe_tpamb_to_string))
        {
            $values = MdfeTpamb::where('id', 'in', $mdfe_mdfe_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpamb_to_string = $mdfe_mdfe_tpamb_to_string;
        }

        $this->vdata['mdfe_mdfe_tpamb_to_string'] = $this->mdfe_mdfe_tpamb_to_string;
    }

    public function get_mdfe_mdfe_tpamb_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpamb_to_string))
        {
            return $this->mdfe_mdfe_tpamb_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('mdfe_tpamb_id','{mdfe_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_api_documentos_to_string($mdfe_api_documentos_to_string)
    {
        if(is_array($mdfe_api_documentos_to_string))
        {
            $values = ApiDocumentos::where('id', 'in', $mdfe_api_documentos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_api_documentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_api_documentos_to_string = $mdfe_api_documentos_to_string;
        }

        $this->vdata['mdfe_api_documentos_to_string'] = $this->mdfe_api_documentos_to_string;
    }

    public function get_mdfe_api_documentos_to_string()
    {
        if(!empty($this->mdfe_api_documentos_to_string))
        {
            return $this->mdfe_api_documentos_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('api_documentos_id','{api_documentos->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_cidade_encerramento_to_string($mdfe_cidade_encerramento_to_string)
    {
        if(is_array($mdfe_cidade_encerramento_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_cidade_encerramento_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_cidade_encerramento_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_cidade_encerramento_to_string = $mdfe_cidade_encerramento_to_string;
        }

        $this->vdata['mdfe_cidade_encerramento_to_string'] = $this->mdfe_cidade_encerramento_to_string;
    }

    public function get_mdfe_cidade_encerramento_to_string()
    {
        if(!empty($this->mdfe_cidade_encerramento_to_string))
        {
            return $this->mdfe_cidade_encerramento_to_string;
        }
    
        $values = Mdfe::where('indAntecipaAdiant', '=', $this->id)->getIndexedArray('cidade_encerramento_id','{cidade_encerramento->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_ctes_fk_indReentrega_to_string($mdfe_ctes_fk_indReentrega_to_string)
    {
        if(is_array($mdfe_ctes_fk_indReentrega_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_ctes_fk_indReentrega_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_ctes_fk_indReentrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_ctes_fk_indReentrega_to_string = $mdfe_ctes_fk_indReentrega_to_string;
        }

        $this->vdata['mdfe_ctes_fk_indReentrega_to_string'] = $this->mdfe_ctes_fk_indReentrega_to_string;
    }

    public function get_mdfe_ctes_fk_indReentrega_to_string()
    {
        if(!empty($this->mdfe_ctes_fk_indReentrega_to_string))
        {
            return $this->mdfe_ctes_fk_indReentrega_to_string;
        }
    
        $values = MdfeCtes::where('indReentrega', '=', $this->id)->getIndexedArray('indReentrega','{fk_indReentrega->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_ctes_mdfe_infmundescarga_to_string($mdfe_ctes_mdfe_infmundescarga_to_string)
    {
        if(is_array($mdfe_ctes_mdfe_infmundescarga_to_string))
        {
            $values = MdfeInfmundescarga::where('id', 'in', $mdfe_ctes_mdfe_infmundescarga_to_string)->getIndexedArray('xMunDescarga', 'xMunDescarga');
            $this->mdfe_ctes_mdfe_infmundescarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_ctes_mdfe_infmundescarga_to_string = $mdfe_ctes_mdfe_infmundescarga_to_string;
        }

        $this->vdata['mdfe_ctes_mdfe_infmundescarga_to_string'] = $this->mdfe_ctes_mdfe_infmundescarga_to_string;
    }

    public function get_mdfe_ctes_mdfe_infmundescarga_to_string()
    {
        if(!empty($this->mdfe_ctes_mdfe_infmundescarga_to_string))
        {
            return $this->mdfe_ctes_mdfe_infmundescarga_to_string;
        }
    
        $values = MdfeCtes::where('indReentrega', '=', $this->id)->getIndexedArray('mdfe_infmundescarga_id','{mdfe_infmundescarga->xMunDescarga}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfes_fk_indReentrega_to_string($mdfe_mdfes_fk_indReentrega_to_string)
    {
        if(is_array($mdfe_mdfes_fk_indReentrega_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_mdfes_fk_indReentrega_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfes_fk_indReentrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfes_fk_indReentrega_to_string = $mdfe_mdfes_fk_indReentrega_to_string;
        }

        $this->vdata['mdfe_mdfes_fk_indReentrega_to_string'] = $this->mdfe_mdfes_fk_indReentrega_to_string;
    }

    public function get_mdfe_mdfes_fk_indReentrega_to_string()
    {
        if(!empty($this->mdfe_mdfes_fk_indReentrega_to_string))
        {
            return $this->mdfe_mdfes_fk_indReentrega_to_string;
        }
    
        $values = MdfeMdfes::where('indReentrega', '=', $this->id)->getIndexedArray('indReentrega','{fk_indReentrega->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfes_mdfe_infmundescarga_to_string($mdfe_mdfes_mdfe_infmundescarga_to_string)
    {
        if(is_array($mdfe_mdfes_mdfe_infmundescarga_to_string))
        {
            $values = MdfeInfmundescarga::where('id', 'in', $mdfe_mdfes_mdfe_infmundescarga_to_string)->getIndexedArray('xMunDescarga', 'xMunDescarga');
            $this->mdfe_mdfes_mdfe_infmundescarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfes_mdfe_infmundescarga_to_string = $mdfe_mdfes_mdfe_infmundescarga_to_string;
        }

        $this->vdata['mdfe_mdfes_mdfe_infmundescarga_to_string'] = $this->mdfe_mdfes_mdfe_infmundescarga_to_string;
    }

    public function get_mdfe_mdfes_mdfe_infmundescarga_to_string()
    {
        if(!empty($this->mdfe_mdfes_mdfe_infmundescarga_to_string))
        {
            return $this->mdfe_mdfes_mdfe_infmundescarga_to_string;
        }
    
        $values = MdfeMdfes::where('indReentrega', '=', $this->id)->getIndexedArray('mdfe_infmundescarga_id','{mdfe_infmundescarga->xMunDescarga}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_fk_indReentrega_to_string($mdfe_nfes_fk_indReentrega_to_string)
    {
        if(is_array($mdfe_nfes_fk_indReentrega_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_nfes_fk_indReentrega_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_nfes_fk_indReentrega_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_fk_indReentrega_to_string = $mdfe_nfes_fk_indReentrega_to_string;
        }

        $this->vdata['mdfe_nfes_fk_indReentrega_to_string'] = $this->mdfe_nfes_fk_indReentrega_to_string;
    }

    public function get_mdfe_nfes_fk_indReentrega_to_string()
    {
        if(!empty($this->mdfe_nfes_fk_indReentrega_to_string))
        {
            return $this->mdfe_nfes_fk_indReentrega_to_string;
        }
    
        $values = MdfeNfes::where('indReentrega', '=', $this->id)->getIndexedArray('indReentrega','{fk_indReentrega->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_mdfe_infmundescarga_to_string($mdfe_nfes_mdfe_infmundescarga_to_string)
    {
        if(is_array($mdfe_nfes_mdfe_infmundescarga_to_string))
        {
            $values = MdfeInfmundescarga::where('id', 'in', $mdfe_nfes_mdfe_infmundescarga_to_string)->getIndexedArray('xMunDescarga', 'xMunDescarga');
            $this->mdfe_nfes_mdfe_infmundescarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_mdfe_infmundescarga_to_string = $mdfe_nfes_mdfe_infmundescarga_to_string;
        }

        $this->vdata['mdfe_nfes_mdfe_infmundescarga_to_string'] = $this->mdfe_nfes_mdfe_infmundescarga_to_string;
    }

    public function get_mdfe_nfes_mdfe_infmundescarga_to_string()
    {
        if(!empty($this->mdfe_nfes_mdfe_infmundescarga_to_string))
        {
            return $this->mdfe_nfes_mdfe_infmundescarga_to_string;
        }
    
        $values = MdfeNfes::where('indReentrega', '=', $this->id)->getIndexedArray('mdfe_infmundescarga_id','{mdfe_infmundescarga->xMunDescarga}');
        return implode(', ', $values);
    }

    public function set_mdfe_nfes_notafiscal_to_string($mdfe_nfes_notafiscal_to_string)
    {
        if(is_array($mdfe_nfes_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $mdfe_nfes_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_nfes_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_nfes_notafiscal_to_string = $mdfe_nfes_notafiscal_to_string;
        }

        $this->vdata['mdfe_nfes_notafiscal_to_string'] = $this->mdfe_nfes_notafiscal_to_string;
    }

    public function get_mdfe_nfes_notafiscal_to_string()
    {
        if(!empty($this->mdfe_nfes_notafiscal_to_string))
        {
            return $this->mdfe_nfes_notafiscal_to_string;
        }
    
        $values = MdfeNfes::where('indReentrega', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_natureza_operacao_finalidade_to_string($natureza_operacao_natureza_operacao_finalidade_to_string)
    {
        if(is_array($natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            $values = NaturezaOperacaoFinalidade::where('id', 'in', $natureza_operacao_natureza_operacao_finalidade_to_string)->getIndexedArray('nome', 'nome');
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_natureza_operacao_finalidade_to_string = $natureza_operacao_natureza_operacao_finalidade_to_string;
        }

        $this->vdata['natureza_operacao_natureza_operacao_finalidade_to_string'] = $this->natureza_operacao_natureza_operacao_finalidade_to_string;
    }

    public function get_natureza_operacao_natureza_operacao_finalidade_to_string()
    {
        if(!empty($this->natureza_operacao_natureza_operacao_finalidade_to_string))
        {
            return $this->natureza_operacao_natureza_operacao_finalidade_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('natureza_operacao_finalidade_id','{natureza_operacao_finalidade->nome}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_to_string($natureza_operacao_cst_icms_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_to_string = $natureza_operacao_cst_icms_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_to_string'] = $this->natureza_operacao_cst_icms_to_string;
    }

    public function get_natureza_operacao_cst_icms_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_to_string))
        {
            return $this->natureza_operacao_cst_icms_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('cst_icms_id','{cst_icms->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_icms_nao_contribuinte_to_string($natureza_operacao_cst_icms_nao_contribuinte_to_string)
    {
        if(is_array($natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            $values = CstIcms::where('id', 'in', $natureza_operacao_cst_icms_nao_contribuinte_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_icms_nao_contribuinte_to_string = $natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }

        $this->vdata['natureza_operacao_cst_icms_nao_contribuinte_to_string'] = $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
    }

    public function get_natureza_operacao_cst_icms_nao_contribuinte_to_string()
    {
        if(!empty($this->natureza_operacao_cst_icms_nao_contribuinte_to_string))
        {
            return $this->natureza_operacao_cst_icms_nao_contribuinte_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('cst_icms_nao_contribuinte_id','{cst_icms_nao_contribuinte->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_ipi_to_string($natureza_operacao_cst_ipi_to_string)
    {
        if(is_array($natureza_operacao_cst_ipi_to_string))
        {
            $values = CstIpi::where('id', 'in', $natureza_operacao_cst_ipi_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_ipi_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_ipi_to_string = $natureza_operacao_cst_ipi_to_string;
        }

        $this->vdata['natureza_operacao_cst_ipi_to_string'] = $this->natureza_operacao_cst_ipi_to_string;
    }

    public function get_natureza_operacao_cst_ipi_to_string()
    {
        if(!empty($this->natureza_operacao_cst_ipi_to_string))
        {
            return $this->natureza_operacao_cst_ipi_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('cst_ipi_id','{cst_ipi->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_pis_to_string($natureza_operacao_cst_pis_to_string)
    {
        if(is_array($natureza_operacao_cst_pis_to_string))
        {
            $values = CstPis::where('id', 'in', $natureza_operacao_cst_pis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_pis_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_pis_to_string = $natureza_operacao_cst_pis_to_string;
        }

        $this->vdata['natureza_operacao_cst_pis_to_string'] = $this->natureza_operacao_cst_pis_to_string;
    }

    public function get_natureza_operacao_cst_pis_to_string()
    {
        if(!empty($this->natureza_operacao_cst_pis_to_string))
        {
            return $this->natureza_operacao_cst_pis_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('cst_pis_id','{cst_pis->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_cst_cofins_to_string($natureza_operacao_cst_cofins_to_string)
    {
        if(is_array($natureza_operacao_cst_cofins_to_string))
        {
            $values = CstCofins::where('id', 'in', $natureza_operacao_cst_cofins_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_cst_cofins_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_cst_cofins_to_string = $natureza_operacao_cst_cofins_to_string;
        }

        $this->vdata['natureza_operacao_cst_cofins_to_string'] = $this->natureza_operacao_cst_cofins_to_string;
    }

    public function get_natureza_operacao_cst_cofins_to_string()
    {
        if(!empty($this->natureza_operacao_cst_cofins_to_string))
        {
            return $this->natureza_operacao_cst_cofins_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('cst_cofins_id','{cst_cofins->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_consumidor_final_to_string($natureza_operacao_consumidor_final_to_string)
    {
        if(is_array($natureza_operacao_consumidor_final_to_string))
        {
            $values = Resposta::where('id', 'in', $natureza_operacao_consumidor_final_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_consumidor_final_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_consumidor_final_to_string = $natureza_operacao_consumidor_final_to_string;
        }

        $this->vdata['natureza_operacao_consumidor_final_to_string'] = $this->natureza_operacao_consumidor_final_to_string;
    }

    public function get_natureza_operacao_consumidor_final_to_string()
    {
        if(!empty($this->natureza_operacao_consumidor_final_to_string))
        {
            return $this->natureza_operacao_consumidor_final_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('consumidor_final_id','{consumidor_final->descricao}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbc_to_string($natureza_operacao_notafiscal_item_modbc_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbc_to_string))
        {
            $values = NotafiscalItemModbc::where('id', 'in', $natureza_operacao_notafiscal_item_modbc_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbc_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbc_to_string = $natureza_operacao_notafiscal_item_modbc_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbc_to_string'] = $this->natureza_operacao_notafiscal_item_modbc_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbc_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbc_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbc_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbc_id','{notafiscal_item_modbc->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_modbcst_to_string($natureza_operacao_notafiscal_item_modbcst_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            $values = NotafiscalItemModbcst::where('id', 'in', $natureza_operacao_notafiscal_item_modbcst_to_string)->getIndexedArray('id', 'id');
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_modbcst_to_string = $natureza_operacao_notafiscal_item_modbcst_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_modbcst_to_string'] = $this->natureza_operacao_notafiscal_item_modbcst_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_modbcst_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_modbcst_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_modbcst_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('notafiscal_item_modbcst_id','{notafiscal_item_modbcst->id}');
        return implode(', ', $values);
    }

    public function set_natureza_operacao_notafiscal_item_motDesICMS_to_string($natureza_operacao_notafiscal_item_motDesICMS_to_string)
    {
        if(is_array($natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            $values = NotafiscalItemMotdesicms::where('id', 'in', $natureza_operacao_notafiscal_item_motDesICMS_to_string)->getIndexedArray('descricao', 'descricao');
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = implode(', ', $values);
        }
        else
        {
            $this->natureza_operacao_notafiscal_item_motDesICMS_to_string = $natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }

        $this->vdata['natureza_operacao_notafiscal_item_motDesICMS_to_string'] = $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
    }

    public function get_natureza_operacao_notafiscal_item_motDesICMS_to_string()
    {
        if(!empty($this->natureza_operacao_notafiscal_item_motDesICMS_to_string))
        {
            return $this->natureza_operacao_notafiscal_item_motDesICMS_to_string;
        }
    
        $values = NaturezaOperacao::where('consumidor_final_id', '=', $this->id)->getIndexedArray('notafiscal_item_motDesICMS_id','{notafiscal_item_motDesICMS->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_system_unit_to_string($negocio_system_unit_to_string)
    {
        if(is_array($negocio_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $negocio_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->negocio_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_system_unit_to_string = $negocio_system_unit_to_string;
        }

        $this->vdata['negocio_system_unit_to_string'] = $this->negocio_system_unit_to_string;
    }

    public function get_negocio_system_unit_to_string()
    {
        if(!empty($this->negocio_system_unit_to_string))
        {
            return $this->negocio_system_unit_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_origem_to_string($negocio_negocio_origem_to_string)
    {
        if(is_array($negocio_negocio_origem_to_string))
        {
            $values = NegocioOrigem::where('id', 'in', $negocio_negocio_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_origem_to_string = $negocio_negocio_origem_to_string;
        }

        $this->vdata['negocio_negocio_origem_to_string'] = $this->negocio_negocio_origem_to_string;
    }

    public function get_negocio_negocio_origem_to_string()
    {
        if(!empty($this->negocio_negocio_origem_to_string))
        {
            return $this->negocio_negocio_origem_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('negocio_origem_id','{negocio_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_to_string($negocio_funil_to_string)
    {
        if(is_array($negocio_funil_to_string))
        {
            $values = Funil::where('id', 'in', $negocio_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_to_string = $negocio_funil_to_string;
        }

        $this->vdata['negocio_funil_to_string'] = $this->negocio_funil_to_string;
    }

    public function get_negocio_funil_to_string()
    {
        if(!empty($this->negocio_funil_to_string))
        {
            return $this->negocio_funil_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_etapas_to_string($negocio_funil_etapas_to_string)
    {
        if(is_array($negocio_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_etapas_to_string = $negocio_funil_etapas_to_string;
        }

        $this->vdata['negocio_funil_etapas_to_string'] = $this->negocio_funil_etapas_to_string;
    }

    public function get_negocio_funil_etapas_to_string()
    {
        if(!empty($this->negocio_funil_etapas_to_string))
        {
            return $this->negocio_funil_etapas_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_motivo_perda_to_string($negocio_negocio_motivo_perda_to_string)
    {
        if(is_array($negocio_negocio_motivo_perda_to_string))
        {
            $values = NegocioMotivoPerda::where('id', 'in', $negocio_negocio_motivo_perda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_motivo_perda_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_motivo_perda_to_string = $negocio_negocio_motivo_perda_to_string;
        }

        $this->vdata['negocio_negocio_motivo_perda_to_string'] = $this->negocio_negocio_motivo_perda_to_string;
    }

    public function get_negocio_negocio_motivo_perda_to_string()
    {
        if(!empty($this->negocio_negocio_motivo_perda_to_string))
        {
            return $this->negocio_negocio_motivo_perda_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('negocio_motivo_perda_id','{negocio_motivo_perda->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_ativo_to_string($negocio_ativo_to_string)
    {
        if(is_array($negocio_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $negocio_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_ativo_to_string = $negocio_ativo_to_string;
        }

        $this->vdata['negocio_ativo_to_string'] = $this->negocio_ativo_to_string;
    }

    public function get_negocio_ativo_to_string()
    {
        if(!empty($this->negocio_ativo_to_string))
        {
            return $this->negocio_ativo_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_fk_arquivado_to_string($negocio_fk_arquivado_to_string)
    {
        if(is_array($negocio_fk_arquivado_to_string))
        {
            $values = Resposta::where('id', 'in', $negocio_fk_arquivado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_fk_arquivado_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_fk_arquivado_to_string = $negocio_fk_arquivado_to_string;
        }

        $this->vdata['negocio_fk_arquivado_to_string'] = $this->negocio_fk_arquivado_to_string;
    }

    public function get_negocio_fk_arquivado_to_string()
    {
        if(!empty($this->negocio_fk_arquivado_to_string))
        {
            return $this->negocio_fk_arquivado_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('arquivado','{fk_arquivado->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_vendedor_to_string($negocio_vendedor_to_string)
    {
        if(is_array($negocio_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $negocio_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_vendedor_to_string = $negocio_vendedor_to_string;
        }

        $this->vdata['negocio_vendedor_to_string'] = $this->negocio_vendedor_to_string;
    }

    public function get_negocio_vendedor_to_string()
    {
        if(!empty($this->negocio_vendedor_to_string))
        {
            return $this->negocio_vendedor_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_orcamento_to_string($negocio_orcamento_to_string)
    {
        if(is_array($negocio_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $negocio_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->negocio_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_orcamento_to_string = $negocio_orcamento_to_string;
        }

        $this->vdata['negocio_orcamento_to_string'] = $this->negocio_orcamento_to_string;
    }

    public function get_negocio_orcamento_to_string()
    {
        if(!empty($this->negocio_orcamento_to_string))
        {
            return $this->negocio_orcamento_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_negocio_cliente_to_string($negocio_cliente_to_string)
    {
        if(is_array($negocio_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $negocio_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_cliente_to_string = $negocio_cliente_to_string;
        }

        $this->vdata['negocio_cliente_to_string'] = $this->negocio_cliente_to_string;
    }

    public function get_negocio_cliente_to_string()
    {
        if(!empty($this->negocio_cliente_to_string))
        {
            return $this->negocio_cliente_to_string;
        }
    
        $values = Negocio::where('arquivado', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string($ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string))
        {
            $values = OrdemServicoItem::where('id', 'in', $ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string)->getIndexedArray('descricao_servico', 'descricao_servico');
            $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string = $ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string'] = $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_ordem_servico_item_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('quantidade_fixa_id', '=', $this->id)->getIndexedArray('ordem_servico_item_id','{ordem_servico_item->descricao_servico}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_produto_to_string($ordem_servico_item_ficha_tecnica_produto_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_servico_item_ficha_tecnica_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_item_ficha_tecnica_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_produto_to_string = $ordem_servico_item_ficha_tecnica_produto_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_produto_to_string'] = $this->ordem_servico_item_ficha_tecnica_produto_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_produto_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_produto_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_produto_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('quantidade_fixa_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string($ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string)
    {
        if(is_array($ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string))
        {
            $values = Resposta::where('id', 'in', $ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string = $ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
        }

        $this->vdata['ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string'] = $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
    }

    public function get_ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string()
    {
        if(!empty($this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string))
        {
            return $this->ordem_servico_item_ficha_tecnica_quantidade_fixa_to_string;
        }
    
        $values = OrdemServicoItemFichaTecnica::where('quantidade_fixa_id', '=', $this->id)->getIndexedArray('quantidade_fixa_id','{quantidade_fixa->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_grupo_to_string($produto_produto_grupo_to_string)
    {
        if(is_array($produto_produto_grupo_to_string))
        {
            $values = ProdutoGrupo::where('id', 'in', $produto_produto_grupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_grupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_grupo_to_string = $produto_produto_grupo_to_string;
        }

        $this->vdata['produto_produto_grupo_to_string'] = $this->produto_produto_grupo_to_string;
    }

    public function get_produto_produto_grupo_to_string()
    {
        if(!empty($this->produto_produto_grupo_to_string))
        {
            return $this->produto_produto_grupo_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('produto_grupo_id','{produto_grupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_unidade_medida_to_string($produto_unidade_medida_to_string)
    {
        if(is_array($produto_unidade_medida_to_string))
        {
            $values = UnidadeMedida::where('id', 'in', $produto_unidade_medida_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_unidade_medida_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_unidade_medida_to_string = $produto_unidade_medida_to_string;
        }

        $this->vdata['produto_unidade_medida_to_string'] = $this->produto_unidade_medida_to_string;
    }

    public function get_produto_unidade_medida_to_string()
    {
        if(!empty($this->produto_unidade_medida_to_string))
        {
            return $this->produto_unidade_medida_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('unidade_medida_id','{unidade_medida->nome}');
        return implode(', ', $values);
    }

    public function set_produto_tipo_recurso_to_string($produto_tipo_recurso_to_string)
    {
        if(is_array($produto_tipo_recurso_to_string))
        {
            $values = TipoRecurso::where('id', 'in', $produto_tipo_recurso_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_tipo_recurso_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_tipo_recurso_to_string = $produto_tipo_recurso_to_string;
        }

        $this->vdata['produto_tipo_recurso_to_string'] = $this->produto_tipo_recurso_to_string;
    }

    public function get_produto_tipo_recurso_to_string()
    {
        if(!empty($this->produto_tipo_recurso_to_string))
        {
            return $this->produto_tipo_recurso_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('tipo_recurso_id','{tipo_recurso->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produto_fabricante_to_string($produto_produto_fabricante_to_string)
    {
        if(is_array($produto_produto_fabricante_to_string))
        {
            $values = ProdutoFabricante::where('id', 'in', $produto_produto_fabricante_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_produto_fabricante_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_fabricante_to_string = $produto_produto_fabricante_to_string;
        }

        $this->vdata['produto_produto_fabricante_to_string'] = $this->produto_produto_fabricante_to_string;
    }

    public function get_produto_produto_fabricante_to_string()
    {
        if(!empty($this->produto_produto_fabricante_to_string))
        {
            return $this->produto_produto_fabricante_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('produto_fabricante_id','{produto_fabricante->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produtogrupo_subgrupo_to_string($produto_produtogrupo_subgrupo_to_string)
    {
        if(is_array($produto_produtogrupo_subgrupo_to_string))
        {
            $values = ProdutogrupoSubgrupo::where('id', 'in', $produto_produtogrupo_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produtogrupo_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produtogrupo_subgrupo_to_string = $produto_produtogrupo_subgrupo_to_string;
        }

        $this->vdata['produto_produtogrupo_subgrupo_to_string'] = $this->produto_produtogrupo_subgrupo_to_string;
    }

    public function get_produto_produtogrupo_subgrupo_to_string()
    {
        if(!empty($this->produto_produtogrupo_subgrupo_to_string))
        {
            return $this->produto_produtogrupo_subgrupo_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('produtogrupo_subgrupo_id','{produtogrupo_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_notafiscal_item_orig_to_string($produto_notafiscal_item_orig_to_string)
    {
        if(is_array($produto_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $produto_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->produto_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_notafiscal_item_orig_to_string = $produto_notafiscal_item_orig_to_string;
        }

        $this->vdata['produto_notafiscal_item_orig_to_string'] = $this->produto_notafiscal_item_orig_to_string;
    }

    public function get_produto_notafiscal_item_orig_to_string()
    {
        if(!empty($this->produto_notafiscal_item_orig_to_string))
        {
            return $this->produto_notafiscal_item_orig_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_produto_habilitado_to_string($produto_habilitado_to_string)
    {
        if(is_array($produto_habilitado_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_habilitado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_habilitado_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_habilitado_to_string = $produto_habilitado_to_string;
        }

        $this->vdata['produto_habilitado_to_string'] = $this->produto_habilitado_to_string;
    }

    public function get_produto_habilitado_to_string()
    {
        if(!empty($this->produto_habilitado_to_string))
        {
            return $this->produto_habilitado_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('habilitado_id','{habilitado->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_tipo_to_string($produto_produto_tipo_to_string)
    {
        if(is_array($produto_produto_tipo_to_string))
        {
            $values = ProdutoTipo::where('id', 'in', $produto_produto_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_tipo_to_string = $produto_produto_tipo_to_string;
        }

        $this->vdata['produto_produto_tipo_to_string'] = $this->produto_produto_tipo_to_string;
    }

    public function get_produto_produto_tipo_to_string()
    {
        if(!empty($this->produto_produto_tipo_to_string))
        {
            return $this->produto_produto_tipo_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('produto_tipo_id','{produto_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_embalagem_to_string($produto_produto_embalagem_to_string)
    {
        if(is_array($produto_produto_embalagem_to_string))
        {
            $values = ProdutoEmbalagem::where('id', 'in', $produto_produto_embalagem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_embalagem_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_embalagem_to_string = $produto_produto_embalagem_to_string;
        }

        $this->vdata['produto_produto_embalagem_to_string'] = $this->produto_produto_embalagem_to_string;
    }

    public function get_produto_produto_embalagem_to_string()
    {
        if(!empty($this->produto_produto_embalagem_to_string))
        {
            return $this->produto_produto_embalagem_to_string;
        }
    
        $values = Produto::where('habilitado_id', '=', $this->id)->getIndexedArray('produto_embalagem_id','{produto_embalagem->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string($produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string = $produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string'] = $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
    }

    public function get_produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string))
        {
            return $this->produto_ficha_tecnica_itens_produto_ficha_tecnica_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('quantidade_fixa_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_produto_to_string($produto_ficha_tecnica_itens_produto_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_ficha_tecnica_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_ficha_tecnica_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_produto_to_string = $produto_ficha_tecnica_itens_produto_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_produto_to_string'] = $this->produto_ficha_tecnica_itens_produto_to_string;
    }

    public function get_produto_ficha_tecnica_itens_produto_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_produto_to_string))
        {
            return $this->produto_ficha_tecnica_itens_produto_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('quantidade_fixa_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_itens_quantidade_fixa_to_string($produto_ficha_tecnica_itens_quantidade_fixa_to_string)
    {
        if(is_array($produto_ficha_tecnica_itens_quantidade_fixa_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_ficha_tecnica_itens_quantidade_fixa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string = $produto_ficha_tecnica_itens_quantidade_fixa_to_string;
        }

        $this->vdata['produto_ficha_tecnica_itens_quantidade_fixa_to_string'] = $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string;
    }

    public function get_produto_ficha_tecnica_itens_quantidade_fixa_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_itens_quantidade_fixa_to_string))
        {
            return $this->produto_ficha_tecnica_itens_quantidade_fixa_to_string;
        }
    
        $values = ProdutoFichaTecnicaItens::where('quantidade_fixa_id', '=', $this->id)->getIndexedArray('quantidade_fixa_id','{quantidade_fixa->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_produto_to_string($produto_filial_produto_to_string)
    {
        if(is_array($produto_filial_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_filial_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_filial_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_produto_to_string = $produto_filial_produto_to_string;
        }

        $this->vdata['produto_filial_produto_to_string'] = $this->produto_filial_produto_to_string;
    }

    public function get_produto_filial_produto_to_string()
    {
        if(!empty($this->produto_filial_produto_to_string))
        {
            return $this->produto_filial_produto_to_string;
        }
    
        $values = ProdutoFilial::where('gerar_op_venda_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_filial_system_unit_to_string($produto_filial_system_unit_to_string)
    {
        if(is_array($produto_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $produto_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->produto_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_system_unit_to_string = $produto_filial_system_unit_to_string;
        }

        $this->vdata['produto_filial_system_unit_to_string'] = $this->produto_filial_system_unit_to_string;
    }

    public function get_produto_filial_system_unit_to_string()
    {
        if(!empty($this->produto_filial_system_unit_to_string))
        {
            return $this->produto_filial_system_unit_to_string;
        }
    
        $values = ProdutoFilial::where('gerar_op_venda_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_produto_filial_estoque_deposito_padrao_to_string($produto_filial_estoque_deposito_padrao_to_string)
    {
        if(is_array($produto_filial_estoque_deposito_padrao_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $produto_filial_estoque_deposito_padrao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_estoque_deposito_padrao_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_estoque_deposito_padrao_to_string = $produto_filial_estoque_deposito_padrao_to_string;
        }

        $this->vdata['produto_filial_estoque_deposito_padrao_to_string'] = $this->produto_filial_estoque_deposito_padrao_to_string;
    }

    public function get_produto_filial_estoque_deposito_padrao_to_string()
    {
        if(!empty($this->produto_filial_estoque_deposito_padrao_to_string))
        {
            return $this->produto_filial_estoque_deposito_padrao_to_string;
        }
    
        $values = ProdutoFilial::where('gerar_op_venda_id', '=', $this->id)->getIndexedArray('estoque_deposito_padrao_id','{estoque_deposito_padrao->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_sob_encomenda_to_string($produto_filial_sob_encomenda_to_string)
    {
        if(is_array($produto_filial_sob_encomenda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_sob_encomenda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_sob_encomenda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_sob_encomenda_to_string = $produto_filial_sob_encomenda_to_string;
        }

        $this->vdata['produto_filial_sob_encomenda_to_string'] = $this->produto_filial_sob_encomenda_to_string;
    }

    public function get_produto_filial_sob_encomenda_to_string()
    {
        if(!empty($this->produto_filial_sob_encomenda_to_string))
        {
            return $this->produto_filial_sob_encomenda_to_string;
        }
    
        $values = ProdutoFilial::where('gerar_op_venda_id', '=', $this->id)->getIndexedArray('sob_encomenda_id','{sob_encomenda->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_gerar_op_venda_to_string($produto_filial_gerar_op_venda_to_string)
    {
        if(is_array($produto_filial_gerar_op_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_gerar_op_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_gerar_op_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_gerar_op_venda_to_string = $produto_filial_gerar_op_venda_to_string;
        }

        $this->vdata['produto_filial_gerar_op_venda_to_string'] = $this->produto_filial_gerar_op_venda_to_string;
    }

    public function get_produto_filial_gerar_op_venda_to_string()
    {
        if(!empty($this->produto_filial_gerar_op_venda_to_string))
        {
            return $this->produto_filial_gerar_op_venda_to_string;
        }
    
        $values = ProdutoFilial::where('gerar_op_venda_id', '=', $this->id)->getIndexedArray('gerar_op_venda_id','{gerar_op_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_venda_to_string($venda_item_venda_to_string)
    {
        if(is_array($venda_item_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_item_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_venda_to_string = $venda_item_venda_to_string;
        }

        $this->vdata['venda_item_venda_to_string'] = $this->venda_item_venda_to_string;
    }

    public function get_venda_item_venda_to_string()
    {
        if(!empty($this->venda_item_venda_to_string))
        {
            return $this->venda_item_venda_to_string;
        }
    
        $values = VendaItem::where('cancelado', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_to_string($venda_item_produto_to_string)
    {
        if(is_array($venda_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_to_string = $venda_item_produto_to_string;
        }

        $this->vdata['venda_item_produto_to_string'] = $this->venda_item_produto_to_string;
    }

    public function get_venda_item_produto_to_string()
    {
        if(!empty($this->venda_item_produto_to_string))
        {
            return $this->venda_item_produto_to_string;
        }
    
        $values = VendaItem::where('cancelado', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_item_fk_cancelado_to_string($venda_item_fk_cancelado_to_string)
    {
        if(is_array($venda_item_fk_cancelado_to_string))
        {
            $values = Resposta::where('id', 'in', $venda_item_fk_cancelado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_fk_cancelado_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_fk_cancelado_to_string = $venda_item_fk_cancelado_to_string;
        }

        $this->vdata['venda_item_fk_cancelado_to_string'] = $this->venda_item_fk_cancelado_to_string;
    }

    public function get_venda_item_fk_cancelado_to_string()
    {
        if(!empty($this->venda_item_fk_cancelado_to_string))
        {
            return $this->venda_item_fk_cancelado_to_string;
        }
    
        $values = VendaItem::where('cancelado', '=', $this->id)->getIndexedArray('cancelado','{fk_cancelado->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_estoque_deposito_to_string($venda_item_estoque_deposito_to_string)
    {
        if(is_array($venda_item_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $venda_item_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_estoque_deposito_to_string = $venda_item_estoque_deposito_to_string;
        }

        $this->vdata['venda_item_estoque_deposito_to_string'] = $this->venda_item_estoque_deposito_to_string;
    }

    public function get_venda_item_estoque_deposito_to_string()
    {
        if(!empty($this->venda_item_estoque_deposito_to_string))
        {
            return $this->venda_item_estoque_deposito_to_string;
        }
    
        $values = VendaItem::where('cancelado', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_lote_to_string($venda_item_produto_lote_to_string)
    {
        if(is_array($venda_item_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $venda_item_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->venda_item_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_lote_to_string = $venda_item_produto_lote_to_string;
        }

        $this->vdata['venda_item_produto_lote_to_string'] = $this->venda_item_produto_lote_to_string;
    }

    public function get_venda_item_produto_lote_to_string()
    {
        if(!empty($this->venda_item_produto_lote_to_string))
        {
            return $this->venda_item_produto_lote_to_string;
        }
    
        $values = VendaItem::where('cancelado', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    
}

