<?php

class SystemGroupProgramPermissoes extends TRecord
{
    const TABLENAME  = 'system_group_program_permissoes';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_program_permissoes;
    private $system_group;
    private $system_unit;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('system_program_permissoes_id');
        parent::addAttribute('system_group_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_system_program_permissoes
     * Sample of usage: $var->system_program_permissoes = $object;
     * @param $object Instance of SystemProgramPermissoes
     */
    public function set_system_program_permissoes(SystemProgramPermissoes $object)
    {
        $this->system_program_permissoes = $object;
        $this->system_program_permissoes_id = $object->id;
    }

    /**
     * Method get_system_program_permissoes
     * Sample of usage: $var->system_program_permissoes->attribute;
     * @returns SystemProgramPermissoes instance
     */
    public function get_system_program_permissoes()
    {
    
        // loads the associated object
        if (empty($this->system_program_permissoes))
            $this->system_program_permissoes = new SystemProgramPermissoes($this->system_program_permissoes_id);
    
        // returns the associated object
        return $this->system_program_permissoes;
    }
    /**
     * Method set_system_group
     * Sample of usage: $var->system_group = $object;
     * @param $object Instance of SystemGroup
     */
    public function set_system_group(SystemGroup $object)
    {
        $this->system_group = $object;
        $this->system_group_id = $object->id;
    }

    /**
     * Method get_system_group
     * Sample of usage: $var->system_group->attribute;
     * @returns SystemGroup instance
     */
    public function get_system_group()
    {
    
        // loads the associated object
        if (empty($this->system_group))
            $this->system_group = new SystemGroup($this->system_group_id);
    
        // returns the associated object
        return $this->system_group;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    
}

