<?php

class SystemProgramPermissoes extends TRecord
{
    const TABLENAME  = 'system_program_permissoes';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $system_program;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_program_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_system_program
     * Sample of usage: $var->system_program = $object;
     * @param $object Instance of SystemProgram
     */
    public function set_system_program(SystemProgram $object)
    {
        $this->system_program = $object;
        $this->system_program_id = $object->id;
    }

    /**
     * Method get_system_program
     * Sample of usage: $var->system_program->attribute;
     * @returns SystemProgram instance
     */
    public function get_system_program()
    {
    
        // loads the associated object
        if (empty($this->system_program))
            $this->system_program = new SystemProgram($this->system_program_id);
    
        // returns the associated object
        return $this->system_program;
    }

    /**
     * Method getSystemGroupProgramPermissoess
     */
    public function getSystemGroupProgramPermissoess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_program_permissoes_id', '=', $this->id));
        return SystemGroupProgramPermissoes::getObjects( $criteria );
    }
    /**
     * Method getSystemUserProgramPermissoess
     */
    public function getSystemUserProgramPermissoess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_program_permissoes_id', '=', $this->id));
        return SystemUserProgramPermissoes::getObjects( $criteria );
    }

    public function set_system_group_program_permissoes_system_unit_to_string($system_group_program_permissoes_system_unit_to_string)
    {
        if(is_array($system_group_program_permissoes_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $system_group_program_permissoes_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->system_group_program_permissoes_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_unit_to_string = $system_group_program_permissoes_system_unit_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_unit_to_string'] = $this->system_group_program_permissoes_system_unit_to_string;
    }

    public function get_system_group_program_permissoes_system_unit_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_unit_to_string))
        {
            return $this->system_group_program_permissoes_system_unit_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_program_permissoes_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_system_group_program_permissoes_system_program_permissoes_to_string($system_group_program_permissoes_system_program_permissoes_to_string)
    {
        if(is_array($system_group_program_permissoes_system_program_permissoes_to_string))
        {
            $values = SystemProgramPermissoes::where('id', 'in', $system_group_program_permissoes_system_program_permissoes_to_string)->getIndexedArray('id', 'id');
            $this->system_group_program_permissoes_system_program_permissoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_program_permissoes_to_string = $system_group_program_permissoes_system_program_permissoes_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_program_permissoes_to_string'] = $this->system_group_program_permissoes_system_program_permissoes_to_string;
    }

    public function get_system_group_program_permissoes_system_program_permissoes_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_program_permissoes_to_string))
        {
            return $this->system_group_program_permissoes_system_program_permissoes_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_program_permissoes_id', '=', $this->id)->getIndexedArray('system_program_permissoes_id','{system_program_permissoes->id}');
        return implode(', ', $values);
    }

    public function set_system_group_program_permissoes_system_group_to_string($system_group_program_permissoes_system_group_to_string)
    {
        if(is_array($system_group_program_permissoes_system_group_to_string))
        {
            $values = SystemGroup::where('id', 'in', $system_group_program_permissoes_system_group_to_string)->getIndexedArray('name', 'name');
            $this->system_group_program_permissoes_system_group_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_group_to_string = $system_group_program_permissoes_system_group_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_group_to_string'] = $this->system_group_program_permissoes_system_group_to_string;
    }

    public function get_system_group_program_permissoes_system_group_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_group_to_string))
        {
            return $this->system_group_program_permissoes_system_group_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_program_permissoes_id', '=', $this->id)->getIndexedArray('system_group_id','{system_group->name}');
        return implode(', ', $values);
    }

    public function set_system_user_program_permissoes_system_unit_to_string($system_user_program_permissoes_system_unit_to_string)
    {
        if(is_array($system_user_program_permissoes_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $system_user_program_permissoes_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->system_user_program_permissoes_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_user_program_permissoes_system_unit_to_string = $system_user_program_permissoes_system_unit_to_string;
        }

        $this->vdata['system_user_program_permissoes_system_unit_to_string'] = $this->system_user_program_permissoes_system_unit_to_string;
    }

    public function get_system_user_program_permissoes_system_unit_to_string()
    {
        if(!empty($this->system_user_program_permissoes_system_unit_to_string))
        {
            return $this->system_user_program_permissoes_system_unit_to_string;
        }
    
        $values = SystemUserProgramPermissoes::where('system_program_permissoes_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_system_user_program_permissoes_system_users_to_string($system_user_program_permissoes_system_users_to_string)
    {
        if(is_array($system_user_program_permissoes_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $system_user_program_permissoes_system_users_to_string)->getIndexedArray('name', 'name');
            $this->system_user_program_permissoes_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_user_program_permissoes_system_users_to_string = $system_user_program_permissoes_system_users_to_string;
        }

        $this->vdata['system_user_program_permissoes_system_users_to_string'] = $this->system_user_program_permissoes_system_users_to_string;
    }

    public function get_system_user_program_permissoes_system_users_to_string()
    {
        if(!empty($this->system_user_program_permissoes_system_users_to_string))
        {
            return $this->system_user_program_permissoes_system_users_to_string;
        }
    
        $values = SystemUserProgramPermissoes::where('system_program_permissoes_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_system_user_program_permissoes_system_program_permissoes_to_string($system_user_program_permissoes_system_program_permissoes_to_string)
    {
        if(is_array($system_user_program_permissoes_system_program_permissoes_to_string))
        {
            $values = SystemProgramPermissoes::where('id', 'in', $system_user_program_permissoes_system_program_permissoes_to_string)->getIndexedArray('id', 'id');
            $this->system_user_program_permissoes_system_program_permissoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_user_program_permissoes_system_program_permissoes_to_string = $system_user_program_permissoes_system_program_permissoes_to_string;
        }

        $this->vdata['system_user_program_permissoes_system_program_permissoes_to_string'] = $this->system_user_program_permissoes_system_program_permissoes_to_string;
    }

    public function get_system_user_program_permissoes_system_program_permissoes_to_string()
    {
        if(!empty($this->system_user_program_permissoes_system_program_permissoes_to_string))
        {
            return $this->system_user_program_permissoes_system_program_permissoes_to_string;
        }
    
        $values = SystemUserProgramPermissoes::where('system_program_permissoes_id', '=', $this->id)->getIndexedArray('system_program_permissoes_id','{system_program_permissoes->id}');
        return implode(', ', $values);
    }

  public static function CarregaPermissoesEspeciais()
  {
      TTransaction::open('kraftsoft');
  
      Contaspag::SincronizaPermissoesEspeciais();
      Contasrec::SincronizaPermissoesEspeciais();
      CertificadoVenda::SincronizaPermissoesEspeciais();
      Funil::SincronizaPermissoesEspeciais();
      Cliente::SincronizaPermissoesEspeciais();
  
      TTransaction::close(); 
  }
  
  public static function ProcessaPermissao($system_program, $permissao)
  {
      //buscar se tem a tela no banco de dados...
      $system_program = SystemProgram::where('controller', '=', $system_program)->first();
  
      if ($system_program)
      {
        $system_program_permissoes = SystemProgramPermissoes::where('system_program_id', '=', $system_program->id)
                                                            ->where('descricao', '=', $permissao)->first();
                                        
        if (!$system_program_permissoes)                                
        {
            $nova_permissao = new SystemProgramPermissoes;
            $nova_permissao->system_program_id = $system_program->id;
            $nova_permissao->descricao = $permissao;
            $nova_permissao->criado_por = TSession::getValue('username');
            $nova_permissao->store();
        }
      }      
  }
  
  public static function ValidaPermissaoEspecial($system_program, $permissao, $usuario_id, $system_unit_id)
  {
      //buscar se tem a tela no banco de dados...
      TTransaction::open('kraftsoft');
  
      $system_program = SystemProgram::where('controller', '=', $system_program)->first();
  
      if ($system_program)
      {
        $system_program_permissoes = SystemProgramPermissoes::where('system_program_id', '=', $system_program->id)
                                                            ->where('descricao', '=', $permissao)->first();
                                        
        if ($system_program_permissoes)                                
        {
            //verificando se o usuário está vinculado nessa permissão
            $sp_user_permissoes = SystemUserProgramPermissoes::where('system_program_permissoes_id', '=', $system_program_permissoes->id)
                                                             ->where('system_users_id', '=', $usuario_id)
                                                             ->where('system_unit_id', '=', $system_unit_id)->first();
                                                         
            if (!$sp_user_permissoes)
            {
                //se não tiver vinculado ao usuário, verificar se nos grupos o usuário está vinculado...
                $lista_group_permissoes = SystemGroupProgramPermissoes::where('system_program_permissoes_id', '=', $system_program_permissoes->id)
                                                                       ->where('system_unit_id', '=', $system_unit_id)->load();
                          
                foreach ($lista_group_permissoes as $grupo_permissoes) 
                {
                    $usergroup = SystemUserGroup::where('system_user_id', '=', $usuario_id)
                                                ->where('system_group_id', '=', $grupo_permissoes->system_group_id)->first();
                  
                    if ($usergroup)
                    {
                        return true;                    
                    }
                }
            
                //se chegou aqui, não tem nenhuma permissão, gerar exceção...
                 throw new Exception("Você não tem permissão para executar esta ação!".'<br>'.
                                     'Permissão Especial: '.$permissao); 
            }
        }
        else
        {
                //se chegou aqui, não tem nenhuma permissão, gerar exceção...
                 throw new Exception("Você não tem permissão para executar esta ação!".'<br>'.
                                     'Permissão Especial: '.$permissao);       
        }    
      }
      else
      {
                //se chegou aqui, não tem nenhuma permissão, gerar exceção...
                 throw new Exception("Você não tem permissão para executar esta ação!".'<br>'.
                                     'Permissão Especial: '.$permissao);       
      }
  
      TTransaction::close(); 
  }
                                
}

