<?php

class SystemUserPdvPermissoes extends TRecord
{
    const TABLENAME  = 'system_user_pdv_permissoes';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $pdv_permissoes;

    

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('empresa_id');
        parent::addAttribute('pdv_permissoes_id');
        parent::addAttribute('system_user_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_pdv_permissoes
     * Sample of usage: $var->pdv_permissoes = $object;
     * @param $object Instance of PdvPermissoes
     */
    public function set_pdv_permissoes(PdvPermissoes $object)
    {
        $this->pdv_permissoes = $object;
        $this->pdv_permissoes_id = $object->id;
    }

    /**
     * Method get_pdv_permissoes
     * Sample of usage: $var->pdv_permissoes->attribute;
     * @returns PdvPermissoes instance
     */
    public function get_pdv_permissoes()
    {
    
        // loads the associated object
        if (empty($this->pdv_permissoes))
            $this->pdv_permissoes = new PdvPermissoes($this->pdv_permissoes_id);
    
        // returns the associated object
        return $this->pdv_permissoes;
    }

    
}

