<?php

class TabelaPrecoProduto extends TRecord
{
    const TABLENAME  = 'tabela_preco_produto';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $tabela_preco;
    private $produto_filial;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('tabela_preco_id');
        parent::addAttribute('produto_filial_id');
        parent::addAttribute('preco_venda');
        parent::addAttribute('valor_parametro');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method set_tabela_preco
     * Sample of usage: $var->tabela_preco = $object;
     * @param $object Instance of TabelaPreco
     */
    public function set_tabela_preco(TabelaPreco $object)
    {
        $this->tabela_preco = $object;
        $this->tabela_preco_id = $object->id;
    }

    /**
     * Method get_tabela_preco
     * Sample of usage: $var->tabela_preco->attribute;
     * @returns TabelaPreco instance
     */
    public function get_tabela_preco()
    {
    
        // loads the associated object
        if (empty($this->tabela_preco))
            $this->tabela_preco = new TabelaPreco($this->tabela_preco_id);
    
        // returns the associated object
        return $this->tabela_preco;
    }
    /**
     * Method set_produto_filial
     * Sample of usage: $var->produto_filial = $object;
     * @param $object Instance of ProdutoFilial
     */
    public function set_produto_filial(ProdutoFilial $object)
    {
        $this->produto_filial = $object;
        $this->produto_filial_id = $object->id;
    }

    /**
     * Method get_produto_filial
     * Sample of usage: $var->produto_filial->attribute;
     * @returns ProdutoFilial instance
     */
    public function get_produto_filial()
    {
    
        // loads the associated object
        if (empty($this->produto_filial))
            $this->produto_filial = new ProdutoFilial($this->produto_filial_id);
    
        // returns the associated object
        return $this->produto_filial;
    }

    
}

