<?php

class UnidadeMedida extends TRecord
{
    const TABLENAME  = 'unidade_medida';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const AMPOLA = '1';
    const BALDE = '2';
    const BANDEJA = '3';
    const BARRA = '4';
    const BISNAGA = '5';
    const BLOCO = '6';
    const BOBINA = '7';
    const BOMBONA = '8';
    const CAPSULA = '9';
    const CARTELA = '10';
    const CENTO = '11';
    const CONJUNTO = '12';
    const CENTIMETRO = '13';
    const CENTIMETRO_QUADRADO = '14';
    const CAIXA = '15';
    const EXIBICAO = '16';
    const DUZIA = '17';
    const EMBALAGEM = '18';
    const FARDO = '19';
    const FOLHA = '20';
    const FRASCO = '21';
    const GALAO = '22';
    const GARRAFA = '23';
    const GRAMAS = '24';
    const JOGO = '25';
    const QUILOGRAMA = '26';
    const KIT = '27';
    const LATA = '28';
    const LITRO = '29';
    const METRO = '30';
    const METRO_QUADRADO = '31';
    const METRO_CUBICO = '32';
    const MILHEIRO = '33';
    const MILILITRO = '34';
    const MEGAWATT_HORA = '35';
    const PACOTE = '36';
    const PALETE = '37';
    const PARES = '38';
    const PECA = '39';
    const QUILATE = '40';
    const RESMA = '41';
    const ROLO = '42';
    const SACO = '43';
    const SACOLA = '44';
    const TAMBOR = '45';
    const TANQUE = '46';
    const TONELADA = '47';
    const TUBO = '48';
    const UNIDADE = '49';
    const VASILHAME = '50';
    const VIDRO = '51';

    const Evento_UnidadeMedidaIncluidaOuAterada = 'Unidade de Medida Incluida ou Alterada';

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nome');
        parent::addAttribute('sigla');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
    
    }

    /**
     * Method getProdutos
     */
    public function getProdutos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('unidade_medida_id', '=', $this->id));
        return Produto::getObjects( $criteria );
    }

    public function set_produto_produto_grupo_to_string($produto_produto_grupo_to_string)
    {
        if(is_array($produto_produto_grupo_to_string))
        {
            $values = ProdutoGrupo::where('id', 'in', $produto_produto_grupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_grupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_grupo_to_string = $produto_produto_grupo_to_string;
        }

        $this->vdata['produto_produto_grupo_to_string'] = $this->produto_produto_grupo_to_string;
    }

    public function get_produto_produto_grupo_to_string()
    {
        if(!empty($this->produto_produto_grupo_to_string))
        {
            return $this->produto_produto_grupo_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('produto_grupo_id','{produto_grupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_unidade_medida_to_string($produto_unidade_medida_to_string)
    {
        if(is_array($produto_unidade_medida_to_string))
        {
            $values = UnidadeMedida::where('id', 'in', $produto_unidade_medida_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_unidade_medida_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_unidade_medida_to_string = $produto_unidade_medida_to_string;
        }

        $this->vdata['produto_unidade_medida_to_string'] = $this->produto_unidade_medida_to_string;
    }

    public function get_produto_unidade_medida_to_string()
    {
        if(!empty($this->produto_unidade_medida_to_string))
        {
            return $this->produto_unidade_medida_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('unidade_medida_id','{unidade_medida->nome}');
        return implode(', ', $values);
    }

    public function set_produto_tipo_recurso_to_string($produto_tipo_recurso_to_string)
    {
        if(is_array($produto_tipo_recurso_to_string))
        {
            $values = TipoRecurso::where('id', 'in', $produto_tipo_recurso_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_tipo_recurso_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_tipo_recurso_to_string = $produto_tipo_recurso_to_string;
        }

        $this->vdata['produto_tipo_recurso_to_string'] = $this->produto_tipo_recurso_to_string;
    }

    public function get_produto_tipo_recurso_to_string()
    {
        if(!empty($this->produto_tipo_recurso_to_string))
        {
            return $this->produto_tipo_recurso_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('tipo_recurso_id','{tipo_recurso->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produto_fabricante_to_string($produto_produto_fabricante_to_string)
    {
        if(is_array($produto_produto_fabricante_to_string))
        {
            $values = ProdutoFabricante::where('id', 'in', $produto_produto_fabricante_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_produto_fabricante_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_fabricante_to_string = $produto_produto_fabricante_to_string;
        }

        $this->vdata['produto_produto_fabricante_to_string'] = $this->produto_produto_fabricante_to_string;
    }

    public function get_produto_produto_fabricante_to_string()
    {
        if(!empty($this->produto_produto_fabricante_to_string))
        {
            return $this->produto_produto_fabricante_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('produto_fabricante_id','{produto_fabricante->nome}');
        return implode(', ', $values);
    }

    public function set_produto_produtogrupo_subgrupo_to_string($produto_produtogrupo_subgrupo_to_string)
    {
        if(is_array($produto_produtogrupo_subgrupo_to_string))
        {
            $values = ProdutogrupoSubgrupo::where('id', 'in', $produto_produtogrupo_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produtogrupo_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produtogrupo_subgrupo_to_string = $produto_produtogrupo_subgrupo_to_string;
        }

        $this->vdata['produto_produtogrupo_subgrupo_to_string'] = $this->produto_produtogrupo_subgrupo_to_string;
    }

    public function get_produto_produtogrupo_subgrupo_to_string()
    {
        if(!empty($this->produto_produtogrupo_subgrupo_to_string))
        {
            return $this->produto_produtogrupo_subgrupo_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('produtogrupo_subgrupo_id','{produtogrupo_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_notafiscal_item_orig_to_string($produto_notafiscal_item_orig_to_string)
    {
        if(is_array($produto_notafiscal_item_orig_to_string))
        {
            $values = NotafiscalItemOrig::where('id', 'in', $produto_notafiscal_item_orig_to_string)->getIndexedArray('id', 'id');
            $this->produto_notafiscal_item_orig_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_notafiscal_item_orig_to_string = $produto_notafiscal_item_orig_to_string;
        }

        $this->vdata['produto_notafiscal_item_orig_to_string'] = $this->produto_notafiscal_item_orig_to_string;
    }

    public function get_produto_notafiscal_item_orig_to_string()
    {
        if(!empty($this->produto_notafiscal_item_orig_to_string))
        {
            return $this->produto_notafiscal_item_orig_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('notafiscal_item_orig_id','{notafiscal_item_orig->id}');
        return implode(', ', $values);
    }

    public function set_produto_habilitado_to_string($produto_habilitado_to_string)
    {
        if(is_array($produto_habilitado_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_habilitado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_habilitado_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_habilitado_to_string = $produto_habilitado_to_string;
        }

        $this->vdata['produto_habilitado_to_string'] = $this->produto_habilitado_to_string;
    }

    public function get_produto_habilitado_to_string()
    {
        if(!empty($this->produto_habilitado_to_string))
        {
            return $this->produto_habilitado_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('habilitado_id','{habilitado->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_tipo_to_string($produto_produto_tipo_to_string)
    {
        if(is_array($produto_produto_tipo_to_string))
        {
            $values = ProdutoTipo::where('id', 'in', $produto_produto_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_tipo_to_string = $produto_produto_tipo_to_string;
        }

        $this->vdata['produto_produto_tipo_to_string'] = $this->produto_produto_tipo_to_string;
    }

    public function get_produto_produto_tipo_to_string()
    {
        if(!empty($this->produto_produto_tipo_to_string))
        {
            return $this->produto_produto_tipo_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('produto_tipo_id','{produto_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_produto_embalagem_to_string($produto_produto_embalagem_to_string)
    {
        if(is_array($produto_produto_embalagem_to_string))
        {
            $values = ProdutoEmbalagem::where('id', 'in', $produto_produto_embalagem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_produto_embalagem_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_produto_embalagem_to_string = $produto_produto_embalagem_to_string;
        }

        $this->vdata['produto_produto_embalagem_to_string'] = $this->produto_produto_embalagem_to_string;
    }

    public function get_produto_produto_embalagem_to_string()
    {
        if(!empty($this->produto_produto_embalagem_to_string))
        {
            return $this->produto_produto_embalagem_to_string;
        }
    
        $values = Produto::where('unidade_medida_id', '=', $this->id)->getIndexedArray('produto_embalagem_id','{produto_embalagem->descricao}');
        return implode(', ', $values);
    }

    public static function ConfigEvento_UnidadeMedidaIncluidaOuAlterada($id,$obs,$param,&$assunto,&$mensagem,&$acao,&$label,&$icone)
    {
       $assunto = "Unidade de Medida Incluida ou Alterada";
       $mensagem = "Id do módulo: ".$id." OBS: ".$obs;
       $acao = new TAction(['UnidadeMedidaFormView', 'onShow'], $param);
       $label = "Acessar";
       $icone = "fa fa-list-alt green";                   
    }

    public static function SincronizaEventos()
    {
       Eventos::ProcessaEventos('UnidadeMedidaForm',self::Evento_UnidadeMedidaIncluidaOuAterada);
    }
        
}

