<?php

class VeiculoTipo extends TRecord
{
    const TABLENAME  = 'veiculo_tipo';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Carro = '1';
    const Motocicleta = '2';
    const Caminhao = '3';
    const Outros = '4';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getVeiculos
     */
    public function getVeiculos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('veiculo_tipo_id', '=', $this->id));
        return Veiculo::getObjects( $criteria );
    }

    public function set_veiculo_mdfe_tpRod_to_string($veiculo_mdfe_tpRod_to_string)
    {
        if(is_array($veiculo_mdfe_tpRod_to_string))
        {
            $values = MdfeTprod::where('id', 'in', $veiculo_mdfe_tpRod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->veiculo_mdfe_tpRod_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_mdfe_tpRod_to_string = $veiculo_mdfe_tpRod_to_string;
        }

        $this->vdata['veiculo_mdfe_tpRod_to_string'] = $this->veiculo_mdfe_tpRod_to_string;
    }

    public function get_veiculo_mdfe_tpRod_to_string()
    {
        if(!empty($this->veiculo_mdfe_tpRod_to_string))
        {
            return $this->veiculo_mdfe_tpRod_to_string;
        }
    
        $values = Veiculo::where('veiculo_tipo_id', '=', $this->id)->getIndexedArray('mdfe_tpRod_id','{mdfe_tpRod->descricao}');
        return implode(', ', $values);
    }

    public function set_veiculo_estado_to_string($veiculo_estado_to_string)
    {
        if(is_array($veiculo_estado_to_string))
        {
            $values = Estado::where('id', 'in', $veiculo_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->veiculo_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_estado_to_string = $veiculo_estado_to_string;
        }

        $this->vdata['veiculo_estado_to_string'] = $this->veiculo_estado_to_string;
    }

    public function get_veiculo_estado_to_string()
    {
        if(!empty($this->veiculo_estado_to_string))
        {
            return $this->veiculo_estado_to_string;
        }
    
        $values = Veiculo::where('veiculo_tipo_id', '=', $this->id)->getIndexedArray('estado_id','{estado->nome}');
        return implode(', ', $values);
    }

    public function set_veiculo_veiculo_tipo_to_string($veiculo_veiculo_tipo_to_string)
    {
        if(is_array($veiculo_veiculo_tipo_to_string))
        {
            $values = VeiculoTipo::where('id', 'in', $veiculo_veiculo_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->veiculo_veiculo_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_veiculo_tipo_to_string = $veiculo_veiculo_tipo_to_string;
        }

        $this->vdata['veiculo_veiculo_tipo_to_string'] = $this->veiculo_veiculo_tipo_to_string;
    }

    public function get_veiculo_veiculo_tipo_to_string()
    {
        if(!empty($this->veiculo_veiculo_tipo_to_string))
        {
            return $this->veiculo_veiculo_tipo_to_string;
        }
    
        $values = Veiculo::where('veiculo_tipo_id', '=', $this->id)->getIndexedArray('veiculo_tipo_id','{veiculo_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_veiculo_mdfe_tpcar_to_string($veiculo_mdfe_tpcar_to_string)
    {
        if(is_array($veiculo_mdfe_tpcar_to_string))
        {
            $values = MdfeTpcar::where('id', 'in', $veiculo_mdfe_tpcar_to_string)->getIndexedArray('descricao', 'descricao');
            $this->veiculo_mdfe_tpcar_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_mdfe_tpcar_to_string = $veiculo_mdfe_tpcar_to_string;
        }

        $this->vdata['veiculo_mdfe_tpcar_to_string'] = $this->veiculo_mdfe_tpcar_to_string;
    }

    public function get_veiculo_mdfe_tpcar_to_string()
    {
        if(!empty($this->veiculo_mdfe_tpcar_to_string))
        {
            return $this->veiculo_mdfe_tpcar_to_string;
        }
    
        $values = Veiculo::where('veiculo_tipo_id', '=', $this->id)->getIndexedArray('mdfe_tpcar_id','{mdfe_tpcar->descricao}');
        return implode(', ', $values);
    }

    public function set_veiculo_funcionario_motorista_to_string($veiculo_funcionario_motorista_to_string)
    {
        if(is_array($veiculo_funcionario_motorista_to_string))
        {
            $values = Funcionario::where('id', 'in', $veiculo_funcionario_motorista_to_string)->getIndexedArray('nome', 'nome');
            $this->veiculo_funcionario_motorista_to_string = implode(', ', $values);
        }
        else
        {
            $this->veiculo_funcionario_motorista_to_string = $veiculo_funcionario_motorista_to_string;
        }

        $this->vdata['veiculo_funcionario_motorista_to_string'] = $this->veiculo_funcionario_motorista_to_string;
    }

    public function get_veiculo_funcionario_motorista_to_string()
    {
        if(!empty($this->veiculo_funcionario_motorista_to_string))
        {
            return $this->veiculo_funcionario_motorista_to_string;
        }
    
        $values = Veiculo::where('veiculo_tipo_id', '=', $this->id)->getIndexedArray('funcionario_motorista_id','{funcionario_motorista->nome}');
        return implode(', ', $values);
    }

    
}

