<?php

class Venda extends TRecord
{
    const TABLENAME  = 'venda';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $venda_situacao;
    private $cliente;
    private $dispositivos;
    private $system_unit;
    private $filial_saida;
    private $venda_modalidade;
    private $venda_tipo_pagamento;
    private $vendedor;
    private $orcamento;
    private $cliente_endereco;
    private $tabela_preco;
    private $movimentacao_origem;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('venda_situacao_id');
        parent::addAttribute('orcamento_id');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('dispositivos_id');
        parent::addAttribute('cliente_id');
        parent::addAttribute('numero_celula_consumo');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('filial_saida_id');
        parent::addAttribute('venda_modalidade_id');
        parent::addAttribute('venda_tipo_pagamento_id');
        parent::addAttribute('id_venda_local');
        parent::addAttribute('data_hora_venda');
        parent::addAttribute('valor_produtos');
        parent::addAttribute('valor_troco');
        parent::addAttribute('desconto');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('observacao');
        parent::addAttribute('observacao_nf');
        parent::addAttribute('peso_total');
        parent::addAttribute('frete_total');
        parent::addAttribute('valor_total');
        parent::addAttribute('cliente_endereco_id');
        parent::addAttribute('info_faturamento');
        parent::addAttribute('data_prev_entrega');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
        parent::addAttribute('valor_comissao');
        parent::addAttribute('comissao_avista');
        parent::addAttribute('comissao_aprazo');
        parent::addAttribute('valor_avista');
        parent::addAttribute('valor_aprazo');
        parent::addAttribute('tabela_preco_id');
        parent::addAttribute('movimentacao_origem_id');
    
    }

    /**
     * Method set_venda_situacao
     * Sample of usage: $var->venda_situacao = $object;
     * @param $object Instance of VendaSituacao
     */
    public function set_venda_situacao(VendaSituacao $object)
    {
        $this->venda_situacao = $object;
        $this->venda_situacao_id = $object->id;
    }

    /**
     * Method get_venda_situacao
     * Sample of usage: $var->venda_situacao->attribute;
     * @returns VendaSituacao instance
     */
    public function get_venda_situacao()
    {
    
        // loads the associated object
        if (empty($this->venda_situacao))
            $this->venda_situacao = new VendaSituacao($this->venda_situacao_id);
    
        // returns the associated object
        return $this->venda_situacao;
    }
    /**
     * Method set_cliente
     * Sample of usage: $var->cliente = $object;
     * @param $object Instance of Cliente
     */
    public function set_cliente(Cliente $object)
    {
        $this->cliente = $object;
        $this->cliente_id = $object->id;
    }

    /**
     * Method get_cliente
     * Sample of usage: $var->cliente->attribute;
     * @returns Cliente instance
     */
    public function get_cliente()
    {
    
        // loads the associated object
        if (empty($this->cliente))
            $this->cliente = new Cliente($this->cliente_id);
    
        // returns the associated object
        return $this->cliente;
    }
    /**
     * Method set_dispositivos
     * Sample of usage: $var->dispositivos = $object;
     * @param $object Instance of Dispositivos
     */
    public function set_dispositivos(Dispositivos $object)
    {
        $this->dispositivos = $object;
        $this->dispositivos_id = $object->id;
    }

    /**
     * Method get_dispositivos
     * Sample of usage: $var->dispositivos->attribute;
     * @returns Dispositivos instance
     */
    public function get_dispositivos()
    {
    
        // loads the associated object
        if (empty($this->dispositivos))
            $this->dispositivos = new Dispositivos($this->dispositivos_id);
    
        // returns the associated object
        return $this->dispositivos;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_filial_saida(SystemUnit $object)
    {
        $this->filial_saida = $object;
        $this->filial_saida_id = $object->id;
    }

    /**
     * Method get_filial_saida
     * Sample of usage: $var->filial_saida->attribute;
     * @returns SystemUnit instance
     */
    public function get_filial_saida()
    {
    
        // loads the associated object
        if (empty($this->filial_saida))
            $this->filial_saida = new SystemUnit($this->filial_saida_id);
    
        // returns the associated object
        return $this->filial_saida;
    }
    /**
     * Method set_venda_modalidade
     * Sample of usage: $var->venda_modalidade = $object;
     * @param $object Instance of VendaModalidade
     */
    public function set_venda_modalidade(VendaModalidade $object)
    {
        $this->venda_modalidade = $object;
        $this->venda_modalidade_id = $object->id;
    }

    /**
     * Method get_venda_modalidade
     * Sample of usage: $var->venda_modalidade->attribute;
     * @returns VendaModalidade instance
     */
    public function get_venda_modalidade()
    {
    
        // loads the associated object
        if (empty($this->venda_modalidade))
            $this->venda_modalidade = new VendaModalidade($this->venda_modalidade_id);
    
        // returns the associated object
        return $this->venda_modalidade;
    }
    /**
     * Method set_venda_tipo_pagamento
     * Sample of usage: $var->venda_tipo_pagamento = $object;
     * @param $object Instance of VendaTipoPagamento
     */
    public function set_venda_tipo_pagamento(VendaTipoPagamento $object)
    {
        $this->venda_tipo_pagamento = $object;
        $this->venda_tipo_pagamento_id = $object->id;
    }

    /**
     * Method get_venda_tipo_pagamento
     * Sample of usage: $var->venda_tipo_pagamento->attribute;
     * @returns VendaTipoPagamento instance
     */
    public function get_venda_tipo_pagamento()
    {
    
        // loads the associated object
        if (empty($this->venda_tipo_pagamento))
            $this->venda_tipo_pagamento = new VendaTipoPagamento($this->venda_tipo_pagamento_id);
    
        // returns the associated object
        return $this->venda_tipo_pagamento;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }
    /**
     * Method set_orcamento
     * Sample of usage: $var->orcamento = $object;
     * @param $object Instance of Orcamento
     */
    public function set_orcamento(Orcamento $object)
    {
        $this->orcamento = $object;
        $this->orcamento_id = $object->id;
    }

    /**
     * Method get_orcamento
     * Sample of usage: $var->orcamento->attribute;
     * @returns Orcamento instance
     */
    public function get_orcamento()
    {
    
        // loads the associated object
        if (empty($this->orcamento))
            $this->orcamento = new Orcamento($this->orcamento_id);
    
        // returns the associated object
        return $this->orcamento;
    }
    /**
     * Method set_cliente_endereco
     * Sample of usage: $var->cliente_endereco = $object;
     * @param $object Instance of ClienteEndereco
     */
    public function set_cliente_endereco(ClienteEndereco $object)
    {
        $this->cliente_endereco = $object;
        $this->cliente_endereco_id = $object->id;
    }

    /**
     * Method get_cliente_endereco
     * Sample of usage: $var->cliente_endereco->attribute;
     * @returns ClienteEndereco instance
     */
    public function get_cliente_endereco()
    {
    
        // loads the associated object
        if (empty($this->cliente_endereco))
            $this->cliente_endereco = new ClienteEndereco($this->cliente_endereco_id);
    
        // returns the associated object
        return $this->cliente_endereco;
    }
    /**
     * Method set_tabela_preco
     * Sample of usage: $var->tabela_preco = $object;
     * @param $object Instance of TabelaPreco
     */
    public function set_tabela_preco(TabelaPreco $object)
    {
        $this->tabela_preco = $object;
        $this->tabela_preco_id = $object->id;
    }

    /**
     * Method get_tabela_preco
     * Sample of usage: $var->tabela_preco->attribute;
     * @returns TabelaPreco instance
     */
    public function get_tabela_preco()
    {
    
        // loads the associated object
        if (empty($this->tabela_preco))
            $this->tabela_preco = new TabelaPreco($this->tabela_preco_id);
    
        // returns the associated object
        return $this->tabela_preco;
    }
    /**
     * Method set_movimentacao_origem
     * Sample of usage: $var->movimentacao_origem = $object;
     * @param $object Instance of MovimentacaoOrigem
     */
    public function set_movimentacao_origem(MovimentacaoOrigem $object)
    {
        $this->movimentacao_origem = $object;
        $this->movimentacao_origem_id = $object->id;
    }

    /**
     * Method get_movimentacao_origem
     * Sample of usage: $var->movimentacao_origem->attribute;
     * @returns MovimentacaoOrigem instance
     */
    public function get_movimentacao_origem()
    {
    
        // loads the associated object
        if (empty($this->movimentacao_origem))
            $this->movimentacao_origem = new MovimentacaoOrigem($this->movimentacao_origem_id);
    
        // returns the associated object
        return $this->movimentacao_origem;
    }

    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }
    /**
     * Method getNotafiscals
     */
    public function getNotafiscals()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return Notafiscal::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaoVendass
     */
    public function getOrdemProducaoVendass()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return OrdemProducaoVendas::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicoVendas
     */
    public function getOrdemServicoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return OrdemServicoVenda::getObjects( $criteria );
    }
    /**
     * Method getVendaDevolucaos
     */
    public function getVendaDevolucaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return VendaDevolucao::getObjects( $criteria );
    }
    /**
     * Method getVendaFormapgtos
     */
    public function getVendaFormapgtos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return VendaFormapgto::getObjects( $criteria );
    }
    /**
     * Method getVendaItems
     */
    public function getVendaItems()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return VendaItem::getObjects( $criteria );
    }
    /**
     * Method getVendaSituacaoHistoricos
     */
    public function getVendaSituacaoHistoricos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_id', '=', $this->id));
        return VendaSituacaoHistorico::getObjects( $criteria );
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('venda_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_system_unit_to_string($notafiscal_system_unit_to_string)
    {
        if(is_array($notafiscal_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_system_unit_to_string = $notafiscal_system_unit_to_string;
        }

        $this->vdata['notafiscal_system_unit_to_string'] = $this->notafiscal_system_unit_to_string;
    }

    public function get_notafiscal_system_unit_to_string()
    {
        if(!empty($this->notafiscal_system_unit_to_string))
        {
            return $this->notafiscal_system_unit_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_cliente_to_string($notafiscal_cliente_to_string)
    {
        if(is_array($notafiscal_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $notafiscal_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_cliente_to_string = $notafiscal_cliente_to_string;
        }

        $this->vdata['notafiscal_cliente_to_string'] = $this->notafiscal_cliente_to_string;
    }

    public function get_notafiscal_cliente_to_string()
    {
        if(!empty($this->notafiscal_cliente_to_string))
        {
            return $this->notafiscal_cliente_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_venda_to_string($notafiscal_venda_to_string)
    {
        if(is_array($notafiscal_venda_to_string))
        {
            $values = Venda::where('id', 'in', $notafiscal_venda_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_venda_to_string = $notafiscal_venda_to_string;
        }

        $this->vdata['notafiscal_venda_to_string'] = $this->notafiscal_venda_to_string;
    }

    public function get_notafiscal_venda_to_string()
    {
        if(!empty($this->notafiscal_venda_to_string))
        {
            return $this->notafiscal_venda_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_nf_tipodocumento_to_string($notafiscal_nf_tipodocumento_to_string)
    {
        if(is_array($notafiscal_nf_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_nf_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_nf_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_nf_tipodocumento_to_string = $notafiscal_nf_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_nf_tipodocumento_to_string'] = $this->notafiscal_nf_tipodocumento_to_string;
    }

    public function get_notafiscal_nf_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_nf_tipodocumento_to_string))
        {
            return $this->notafiscal_nf_tipodocumento_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('nf_tipodocumento_id','{nf_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_situacao_to_string($notafiscal_notafiscal_situacao_to_string)
    {
        if(is_array($notafiscal_notafiscal_situacao_to_string))
        {
            $values = NotafiscalSituacao::where('id', 'in', $notafiscal_notafiscal_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_situacao_to_string = $notafiscal_notafiscal_situacao_to_string;
        }

        $this->vdata['notafiscal_notafiscal_situacao_to_string'] = $this->notafiscal_notafiscal_situacao_to_string;
    }

    public function get_notafiscal_notafiscal_situacao_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_situacao_to_string))
        {
            return $this->notafiscal_notafiscal_situacao_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_situacao_id','{notafiscal_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_crt_to_string($notafiscal_notafiscal_crt_to_string)
    {
        if(is_array($notafiscal_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $notafiscal_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_crt_to_string = $notafiscal_notafiscal_crt_to_string;
        }

        $this->vdata['notafiscal_notafiscal_crt_to_string'] = $this->notafiscal_notafiscal_crt_to_string;
    }

    public function get_notafiscal_notafiscal_crt_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_crt_to_string))
        {
            return $this->notafiscal_notafiscal_crt_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indiedest_to_string($notafiscal_notafiscal_indiedest_to_string)
    {
        if(is_array($notafiscal_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $notafiscal_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indiedest_to_string = $notafiscal_notafiscal_indiedest_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indiedest_to_string'] = $this->notafiscal_notafiscal_indiedest_to_string;
    }

    public function get_notafiscal_notafiscal_indiedest_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indiedest_to_string))
        {
            return $this->notafiscal_notafiscal_indiedest_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscaldest_to_string($notafiscal_notafiscaldest_to_string)
    {
        if(is_array($notafiscal_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $notafiscal_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscaldest_to_string = $notafiscal_notafiscaldest_to_string;
        }

        $this->vdata['notafiscal_notafiscaldest_to_string'] = $this->notafiscal_notafiscaldest_to_string;
    }

    public function get_notafiscal_notafiscaldest_to_string()
    {
        if(!empty($this->notafiscal_notafiscaldest_to_string))
        {
            return $this->notafiscal_notafiscaldest_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpimp_to_string($notafiscal_notafiscal_tpimp_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $notafiscal_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpimp_to_string = $notafiscal_notafiscal_tpimp_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpimp_to_string'] = $this->notafiscal_notafiscal_tpimp_to_string;
    }

    public function get_notafiscal_notafiscal_tpimp_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpimp_to_string))
        {
            return $this->notafiscal_notafiscal_tpimp_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpemis_to_string($notafiscal_notafiscal_tpemis_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpemis_to_string))
        {
            $values = NotafiscalTpemis::where('id', 'in', $notafiscal_notafiscal_tpemis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpemis_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpemis_to_string = $notafiscal_notafiscal_tpemis_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpemis_to_string'] = $this->notafiscal_notafiscal_tpemis_to_string;
    }

    public function get_notafiscal_notafiscal_tpemis_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpemis_to_string))
        {
            return $this->notafiscal_notafiscal_tpemis_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_tpemis_id','{notafiscal_tpemis->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_finnfe_to_string($notafiscal_notafiscal_finnfe_to_string)
    {
        if(is_array($notafiscal_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $notafiscal_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_finnfe_to_string = $notafiscal_notafiscal_finnfe_to_string;
        }

        $this->vdata['notafiscal_notafiscal_finnfe_to_string'] = $this->notafiscal_notafiscal_finnfe_to_string;
    }

    public function get_notafiscal_notafiscal_finnfe_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_finnfe_to_string))
        {
            return $this->notafiscal_notafiscal_finnfe_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indfinal_to_string($notafiscal_notafiscal_indfinal_to_string)
    {
        if(is_array($notafiscal_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $notafiscal_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indfinal_to_string = $notafiscal_notafiscal_indfinal_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indfinal_to_string'] = $this->notafiscal_notafiscal_indfinal_to_string;
    }

    public function get_notafiscal_notafiscal_indfinal_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indfinal_to_string))
        {
            return $this->notafiscal_notafiscal_indfinal_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpres_to_string($notafiscal_notafiscal_indpres_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $notafiscal_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpres_to_string = $notafiscal_notafiscal_indpres_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpres_to_string'] = $this->notafiscal_notafiscal_indpres_to_string;
    }

    public function get_notafiscal_notafiscal_indpres_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpres_to_string))
        {
            return $this->notafiscal_notafiscal_indpres_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpag_to_string($notafiscal_notafiscal_indpag_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $notafiscal_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpag_to_string = $notafiscal_notafiscal_indpag_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpag_to_string'] = $this->notafiscal_notafiscal_indpag_to_string;
    }

    public function get_notafiscal_notafiscal_indpag_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpag_to_string))
        {
            return $this->notafiscal_notafiscal_indpag_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dispositivos_to_string($notafiscal_dispositivos_to_string)
    {
        if(is_array($notafiscal_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $notafiscal_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dispositivos_to_string = $notafiscal_dispositivos_to_string;
        }

        $this->vdata['notafiscal_dispositivos_to_string'] = $this->notafiscal_dispositivos_to_string;
    }

    public function get_notafiscal_dispositivos_to_string()
    {
        if(!empty($this->notafiscal_dispositivos_to_string))
        {
            return $this->notafiscal_dispositivos_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpamb_to_string($notafiscal_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpamb_to_string = $notafiscal_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpamb_to_string'] = $this->notafiscal_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_notafiscal_tpamb_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_mod_to_string($notafiscal_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_mod_to_string = $notafiscal_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_notafiscal_mod_to_string'] = $this->notafiscal_notafiscal_mod_to_string;
    }

    public function get_notafiscal_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_mod_to_string))
        {
            return $this->notafiscal_notafiscal_mod_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_modfrete_to_string($notafiscal_notafiscal_modfrete_to_string)
    {
        if(is_array($notafiscal_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $notafiscal_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_modfrete_to_string = $notafiscal_notafiscal_modfrete_to_string;
        }

        $this->vdata['notafiscal_notafiscal_modfrete_to_string'] = $this->notafiscal_notafiscal_modfrete_to_string;
    }

    public function get_notafiscal_notafiscal_modfrete_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_modfrete_to_string))
        {
            return $this->notafiscal_notafiscal_modfrete_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_natureza_operacao_to_string($notafiscal_natureza_operacao_to_string)
    {
        if(is_array($notafiscal_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $notafiscal_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_natureza_operacao_to_string = $notafiscal_natureza_operacao_to_string;
        }

        $this->vdata['notafiscal_natureza_operacao_to_string'] = $this->notafiscal_natureza_operacao_to_string;
    }

    public function get_notafiscal_natureza_operacao_to_string()
    {
        if(!empty($this->notafiscal_natureza_operacao_to_string))
        {
            return $this->notafiscal_natureza_operacao_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_movimentacao_origem_to_string($notafiscal_movimentacao_origem_to_string)
    {
        if(is_array($notafiscal_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $notafiscal_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_movimentacao_origem_to_string = $notafiscal_movimentacao_origem_to_string;
        }

        $this->vdata['notafiscal_movimentacao_origem_to_string'] = $this->notafiscal_movimentacao_origem_to_string;
    }

    public function get_notafiscal_movimentacao_origem_to_string()
    {
        if(!empty($this->notafiscal_movimentacao_origem_to_string))
        {
            return $this->notafiscal_movimentacao_origem_to_string;
        }
    
        $values = Notafiscal::where('venda_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_vendas_ordem_producao_to_string($ordem_producao_vendas_ordem_producao_to_string)
    {
        if(is_array($ordem_producao_vendas_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $ordem_producao_vendas_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_vendas_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_vendas_ordem_producao_to_string = $ordem_producao_vendas_ordem_producao_to_string;
        }

        $this->vdata['ordem_producao_vendas_ordem_producao_to_string'] = $this->ordem_producao_vendas_ordem_producao_to_string;
    }

    public function get_ordem_producao_vendas_ordem_producao_to_string()
    {
        if(!empty($this->ordem_producao_vendas_ordem_producao_to_string))
        {
            return $this->ordem_producao_vendas_ordem_producao_to_string;
        }
    
        $values = OrdemProducaoVendas::where('venda_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_vendas_venda_to_string($ordem_producao_vendas_venda_to_string)
    {
        if(is_array($ordem_producao_vendas_venda_to_string))
        {
            $values = Venda::where('id', 'in', $ordem_producao_vendas_venda_to_string)->getIndexedArray('id', 'id');
            $this->ordem_producao_vendas_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_vendas_venda_to_string = $ordem_producao_vendas_venda_to_string;
        }

        $this->vdata['ordem_producao_vendas_venda_to_string'] = $this->ordem_producao_vendas_venda_to_string;
    }

    public function get_ordem_producao_vendas_venda_to_string()
    {
        if(!empty($this->ordem_producao_vendas_venda_to_string))
        {
            return $this->ordem_producao_vendas_venda_to_string;
        }
    
        $values = OrdemProducaoVendas::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_venda_ordem_servico_to_string($ordem_servico_venda_ordem_servico_to_string)
    {
        if(is_array($ordem_servico_venda_ordem_servico_to_string))
        {
            $values = OrdemServico::where('id', 'in', $ordem_servico_venda_ordem_servico_to_string)->getIndexedArray('cliente_id', 'cliente_id');
            $this->ordem_servico_venda_ordem_servico_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_venda_ordem_servico_to_string = $ordem_servico_venda_ordem_servico_to_string;
        }

        $this->vdata['ordem_servico_venda_ordem_servico_to_string'] = $this->ordem_servico_venda_ordem_servico_to_string;
    }

    public function get_ordem_servico_venda_ordem_servico_to_string()
    {
        if(!empty($this->ordem_servico_venda_ordem_servico_to_string))
        {
            return $this->ordem_servico_venda_ordem_servico_to_string;
        }
    
        $values = OrdemServicoVenda::where('venda_id', '=', $this->id)->getIndexedArray('ordem_servico_id','{ordem_servico->cliente_id}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_venda_venda_to_string($ordem_servico_venda_venda_to_string)
    {
        if(is_array($ordem_servico_venda_venda_to_string))
        {
            $values = Venda::where('id', 'in', $ordem_servico_venda_venda_to_string)->getIndexedArray('id', 'id');
            $this->ordem_servico_venda_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_venda_venda_to_string = $ordem_servico_venda_venda_to_string;
        }

        $this->vdata['ordem_servico_venda_venda_to_string'] = $this->ordem_servico_venda_venda_to_string;
    }

    public function get_ordem_servico_venda_venda_to_string()
    {
        if(!empty($this->ordem_servico_venda_venda_to_string))
        {
            return $this->ordem_servico_venda_venda_to_string;
        }
    
        $values = OrdemServicoVenda::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_system_unit_to_string($venda_devolucao_system_unit_to_string)
    {
        if(is_array($venda_devolucao_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_devolucao_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_devolucao_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_system_unit_to_string = $venda_devolucao_system_unit_to_string;
        }

        $this->vdata['venda_devolucao_system_unit_to_string'] = $this->venda_devolucao_system_unit_to_string;
    }

    public function get_venda_devolucao_system_unit_to_string()
    {
        if(!empty($this->venda_devolucao_system_unit_to_string))
        {
            return $this->venda_devolucao_system_unit_to_string;
        }
    
        $values = VendaDevolucao::where('venda_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_venda_to_string($venda_devolucao_venda_to_string)
    {
        if(is_array($venda_devolucao_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_devolucao_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_devolucao_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_venda_to_string = $venda_devolucao_venda_to_string;
        }

        $this->vdata['venda_devolucao_venda_to_string'] = $this->venda_devolucao_venda_to_string;
    }

    public function get_venda_devolucao_venda_to_string()
    {
        if(!empty($this->venda_devolucao_venda_to_string))
        {
            return $this->venda_devolucao_venda_to_string;
        }
    
        $values = VendaDevolucao::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_formapgto_forma_pagamento_to_string($venda_formapgto_forma_pagamento_to_string)
    {
        if(is_array($venda_formapgto_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $venda_formapgto_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_formapgto_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_formapgto_forma_pagamento_to_string = $venda_formapgto_forma_pagamento_to_string;
        }

        $this->vdata['venda_formapgto_forma_pagamento_to_string'] = $this->venda_formapgto_forma_pagamento_to_string;
    }

    public function get_venda_formapgto_forma_pagamento_to_string()
    {
        if(!empty($this->venda_formapgto_forma_pagamento_to_string))
        {
            return $this->venda_formapgto_forma_pagamento_to_string;
        }
    
        $values = VendaFormapgto::where('venda_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_formapgto_venda_to_string($venda_formapgto_venda_to_string)
    {
        if(is_array($venda_formapgto_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_formapgto_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_formapgto_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_formapgto_venda_to_string = $venda_formapgto_venda_to_string;
        }

        $this->vdata['venda_formapgto_venda_to_string'] = $this->venda_formapgto_venda_to_string;
    }

    public function get_venda_formapgto_venda_to_string()
    {
        if(!empty($this->venda_formapgto_venda_to_string))
        {
            return $this->venda_formapgto_venda_to_string;
        }
    
        $values = VendaFormapgto::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_item_venda_to_string($venda_item_venda_to_string)
    {
        if(is_array($venda_item_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_item_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_venda_to_string = $venda_item_venda_to_string;
        }

        $this->vdata['venda_item_venda_to_string'] = $this->venda_item_venda_to_string;
    }

    public function get_venda_item_venda_to_string()
    {
        if(!empty($this->venda_item_venda_to_string))
        {
            return $this->venda_item_venda_to_string;
        }
    
        $values = VendaItem::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_to_string($venda_item_produto_to_string)
    {
        if(is_array($venda_item_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_item_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_item_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_to_string = $venda_item_produto_to_string;
        }

        $this->vdata['venda_item_produto_to_string'] = $this->venda_item_produto_to_string;
    }

    public function get_venda_item_produto_to_string()
    {
        if(!empty($this->venda_item_produto_to_string))
        {
            return $this->venda_item_produto_to_string;
        }
    
        $values = VendaItem::where('venda_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_item_fk_cancelado_to_string($venda_item_fk_cancelado_to_string)
    {
        if(is_array($venda_item_fk_cancelado_to_string))
        {
            $values = Resposta::where('id', 'in', $venda_item_fk_cancelado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_fk_cancelado_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_fk_cancelado_to_string = $venda_item_fk_cancelado_to_string;
        }

        $this->vdata['venda_item_fk_cancelado_to_string'] = $this->venda_item_fk_cancelado_to_string;
    }

    public function get_venda_item_fk_cancelado_to_string()
    {
        if(!empty($this->venda_item_fk_cancelado_to_string))
        {
            return $this->venda_item_fk_cancelado_to_string;
        }
    
        $values = VendaItem::where('venda_id', '=', $this->id)->getIndexedArray('cancelado','{fk_cancelado->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_estoque_deposito_to_string($venda_item_estoque_deposito_to_string)
    {
        if(is_array($venda_item_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $venda_item_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_item_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_estoque_deposito_to_string = $venda_item_estoque_deposito_to_string;
        }

        $this->vdata['venda_item_estoque_deposito_to_string'] = $this->venda_item_estoque_deposito_to_string;
    }

    public function get_venda_item_estoque_deposito_to_string()
    {
        if(!empty($this->venda_item_estoque_deposito_to_string))
        {
            return $this->venda_item_estoque_deposito_to_string;
        }
    
        $values = VendaItem::where('venda_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_item_produto_lote_to_string($venda_item_produto_lote_to_string)
    {
        if(is_array($venda_item_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $venda_item_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->venda_item_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_item_produto_lote_to_string = $venda_item_produto_lote_to_string;
        }

        $this->vdata['venda_item_produto_lote_to_string'] = $this->venda_item_produto_lote_to_string;
    }

    public function get_venda_item_produto_lote_to_string()
    {
        if(!empty($this->venda_item_produto_lote_to_string))
        {
            return $this->venda_item_produto_lote_to_string;
        }
    
        $values = VendaItem::where('venda_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_venda_situacao_historico_venda_situacao_to_string($venda_situacao_historico_venda_situacao_to_string)
    {
        if(is_array($venda_situacao_historico_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_situacao_historico_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_situacao_historico_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_situacao_historico_venda_situacao_to_string = $venda_situacao_historico_venda_situacao_to_string;
        }

        $this->vdata['venda_situacao_historico_venda_situacao_to_string'] = $this->venda_situacao_historico_venda_situacao_to_string;
    }

    public function get_venda_situacao_historico_venda_situacao_to_string()
    {
        if(!empty($this->venda_situacao_historico_venda_situacao_to_string))
        {
            return $this->venda_situacao_historico_venda_situacao_to_string;
        }
    
        $values = VendaSituacaoHistorico::where('venda_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_situacao_historico_venda_to_string($venda_situacao_historico_venda_to_string)
    {
        if(is_array($venda_situacao_historico_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_situacao_historico_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_situacao_historico_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_situacao_historico_venda_to_string = $venda_situacao_historico_venda_to_string;
        }

        $this->vdata['venda_situacao_historico_venda_to_string'] = $this->venda_situacao_historico_venda_to_string;
    }

    public function get_venda_situacao_historico_venda_to_string()
    {
        if(!empty($this->venda_situacao_historico_venda_to_string))
        {
            return $this->venda_situacao_historico_venda_to_string;
        }
    
        $values = VendaSituacaoHistorico::where('venda_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

  
  public function get_codigo_padrao_impressao_venda()
  {
      $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', $this->system_unit_id);
  
      if($config_filial)
      {
          return $config_filial->notafiscal_cprod_padrao_venda_id;
      }
  }
  
   public static function Espelho_Venda($idvenda)
   {
        try 
        {
            TTransaction::open('kraftsoft');
        
            $venda = Venda::find($idvenda);
        
            if(!$venda)
            {
                throw new Exception('Venda não encontrada!');
            }
        
            $html = new AdiantiHTMLDocumentParser('app/resources/espelho_venda.html', 'A4', 'portrait');
            $output = $html->getContents();
        
            $grid_produtos = null;
        
            $item_qtd = 0;
            $quantidade_produtos = 0;
            $total_produtos = 0;
            $venda_tipo_pagamento = ' ';
            $cliente_cpfcnpj = ' ';
            $cliente_nome = ' ';
        
        
            if (isset($venda->venda_tipo_pagamento->descricao))
            {
                $venda_tipo_pagamento = $venda->venda_tipo_pagamento->descricao;
            }

            if(isset($venda->cliente->cpf_cnpj))
            {
                $cliente_cpfcnpj = $venda->cliente->cpf_cnpj;
            }
        
            if(isset($venda->cliente->nome))
            {
                $cliente_nome = $venda->cliente->nome;
            }

            foreach($venda->getVendaItems() as $item)
            {
                $item_qtd ++;
                $quantidade_produtos += $item->quantidade;
                $total_produtos += $item->valor_total;
            
                $grid_produtos .= "
                    <tr>
                        <td>$item_qtd</td>
                        <td>".$item->codigo_padrao_produto_impressao_venda."</td>
                        <td>".$item->produto->nome."</td>
                        <td style='text-align: right;'>".number_format($item->quantidade, 2, ',', '.')."</td>
                        <td style='text-align: right;'>".number_format($item->valor_unitario, 2, ',', '.')."</td>
                        <td style='text-align: right;'>".number_format($item->desconto, 2, ',', '.')."</td>
                        <td style='text-align: right;'>".number_format($item->valor_total, 2, ',', '.')."</td>
                    </tr>
                ";
            }
        
            $output    = str_replace('{produtos}', $grid_produtos, $output);
        
            $output    = str_replace('{quantidade_produtos}', number_format($quantidade_produtos, 2, ',', '.') , $output);
            $output    = str_replace('{valor_icms}', "0,00", $output);
            $output    = str_replace('{total_produtos}', number_format($total_produtos, 2, ',', '.') , $output);
            $output    = str_replace('{valor_ipi}', "0,00", $output);
            $output    = str_replace('{valor_icms_st}', "0,00", $output);
            $output    = str_replace('{total_geral}', number_format($venda->valor_total, 2, ',', '.'), $output);
            $output    = str_replace('{observacao}', $venda->observacao, $output);
            $output    = str_replace('{logo}', $venda->observacao, $output);
            $output    = str_replace('{condicao_pagamento}', $venda_tipo_pagamento, $output);
        
            $filial    = SystemUnit::find($venda->system_unit_id);
        
            $endereco = $filial->end_logradouro.", ".
                        $filial->end_numero." ".
                        $filial->end_bairro." ".
                        $filial->end_municipio." ".
                        $filial->end_uf;
                        $filial->logo;
                    
            $output    = str_replace('{num_venda}', $venda->id, $output);
            $output    = str_replace('{data_venda}', TDate::date2br($venda->data_hora_venda), $output);
            $output    = str_replace('{nome_empresa}', $filial->name, $output);
            $output    = str_replace('{endereco_empresa}', $endereco , $output);
            $output    = str_replace('{telefone_empresa}', $filial->fone, $output);
            $output    = str_replace('{email_empresa}', "", $output);
            $output    = str_replace('{cnpj_empresa}', $filial->cnpj, $output);
            $output    = str_replace('{empresa_logo}', $filial->logo, $output);
        
            $endereco_cliente = ClienteEndereco::where('cliente_id', '=', $venda->cliente_id)->first();
        
            if($endereco_cliente)
            {
                $endereco = $endereco_cliente->logradouro.", ".
                            $endereco_cliente->numero." ".
                            $endereco_cliente->bairro." ".
                            $endereco_cliente->cidade->nome." ".
                            $endereco_cliente->cidade->estado->sigla;
            }
            else
            {
                $endereco = null;
            }
        
            $cliente_contato = ClienteContato::where('cliente_id', '=', $venda->cliente_id)->first();
        
            if($cliente_contato)
            {
                $contato = $cliente_contato->fone." ";
            }
            else
            {
                $contato = null;
            }
        
            $cliente = Cliente::find($venda->cliente_id);

            $output    = str_replace('{nome_cliente}', $cliente->nome, $output);
            $output    = str_replace('{endereco_cliente}', $endereco , $output);
            $output    = str_replace('{telefone_cliente}', $contato, $output);
            //$output    = str_replace('{email_cliente}', $filial->email, $output);
            $output    = str_replace('{cpf_cnpj_cliente}', $cliente->cpf_cnpj, $output);

            $document = 'tmp/' . uniqid() . '.pdf';

            $html = AdiantiHTMLDocumentParser::newFromString($output);

            $html->saveAsPDF($document);
        
            TTransaction::close();
        
            return $document;
        
        } catch (Exception $e) {
            new TMessage('error', $e->getMessage());
        
        }     
   }
   
   public static function ValidaCamposNFe($venda_id)
   {
       $lista_venda_item = VendaItem::where('venda_id','=',$venda_id)->load();
   
       if ($lista_venda_item)
       {
           foreach ($lista_venda_item as $venda_item)
           {
             //validando origem
             if ($venda_item->produto->notafiscal_item_orig_id==null)
             {
                 throw new Exception('O produto '.$venda_item->produto->nome.' está sem a origem informada! Ajuste o cadastro e volte para emitir a nota.'); 
             }
         
             //validando o NCM
             if ($venda_item->produto->ncm==null)
             {
                 throw new Exception('O produto '.$venda_item->produto->nome.' está sem o NCM informado! Ajuste o cadastro e volte para emitir a nota.'); 
             }         
           }
       }
   
   }
   
   public static function AtualizaResumoVendasCliente($cliente_id)
   {
       //quantidade de vendas 
       $qtdvendas = Venda::where('venda_situacao_id', '=', VendaSituacao::Finalizada)
                                  ->where('cliente_id', '=', $cliente_id)
                                  ->count();       
   
       //total de vendas
       $totalvendas = (double) Venda::where('venda_situacao_id', '=', VendaSituacao::Finalizada)
                                     ->where('cliente_id', '=', $cliente_id)
                                     ->sumby('valor_total');         
   
       //data ultima venda
       $dataultimavenda = Venda::where('venda_situacao_id', '=', VendaSituacao::Finalizada)
                                     ->where('cliente_id', '=', $cliente_id)
                                     ->maxby('data_hora_venda');        
   
       //maior venda
       $valormaiorvenda = (double)  Venda::where('venda_situacao_id', '=', VendaSituacao::Finalizada)
                                     ->where('cliente_id', '=', $cliente_id)
                                     ->maxby('valor_total');         
   
       //data maior venda
       $datamaiorvenda =  Venda::where('venda_situacao_id', '=', VendaSituacao::Finalizada)
                                     ->where('cliente_id', '=', $cliente_id)
                                     ->where('valor_total', '=', $valormaiorvenda)
                                     ->maxby('data_hora_venda');       
   
       $cliente = Cliente::find($cliente_id);
       $cliente->vendas_quantidade = $qtdvendas;
       $cliente->vendas_valortotal = $totalvendas;
       $cliente->vendas_dataultima = $dataultimavenda;
       $cliente->vendas_valormaior = $valormaiorvenda;
       $cliente->vendas_datamaior = $datamaiorvenda;
       $cliente->store();

   }
   
   public static function EstornarVenda($venda)
   {
   
       //verificando se existem notas ativas
       $lista_nf_venda = Notafiscal::where('venda_id', '=', $venda->id)->load();
   
       if ($lista_nf_venda)
       {
           foreach ($lista_nf_venda as $nota)
           {
                if ($nota->notafiscal_situacao_id != NotafiscalSituacao::Cancelada)
                {
                  throw new exception ('Existe(m) nota(s) fiscais vinculadas a esta venda, não será possivel estornar esta venda!');   
                }
           }
       }

        //devolvendo o estoque...
        VendaItem::LancamentoEstoque(EstoqueTipoMovimentacao::Entrada,
                                     EstoqueOrigem::EstornoVenda, 
                                     $venda,
                                     'Estorno da venda Id: '.$venda->id);                                     

        $venda->venda_situacao_id=VendaSituacao::EmAndamento;
        $venda->store();

        //historico de situação de venda..
        VendaSituacaoHistorico::LancarHistorico(VendaSituacao::EmAndamento,
                                $venda->id,
                                'Mudança de Situação de venda: Em Andamento (Venda estornada)');

        Venda::AtualizaResumoVendasCliente($venda->cliente_id);                    
    
        $lancamentos_caixa = CaixaLancamentos::where('id_origem', '=', $venda->id)->load();
    
        if ($lancamentos_caixa)
        {
            foreach ($lancamentos_caixa as $lancamento)
            {
                //$caixaId,$formapgtoId,$caixatipolancamentoID,$valor,$obs,$origemId,$systemuserID
                $obs = 'Estorno da Venda Id: '.$venda->id;

                Caixa::lanca_caixa($lancamento->caixa_id,
                                   $lancamento->forma_pagamento_id,
                                   CaixaTipoLancamento::Debito,
                                   $lancamento->valor,
                                   $obs,
                                   $venda->id,
                                   TSession::getValue('userid'));    
            }
        }

        $pagamentos = VendaFormapgto::where('venda_id', '=', $venda->id)->load();

        foreach($pagamentos as $pag)
        {
            //cancelando o contas a receber
            $lista_contasrec = Contasrec::where('venda_formapgto_id', '=', $pag->id)->load();

            foreach ($lista_contasrec as $crec) 
            {        
              //se tiver algum titulo baixado não será permitido o estorno..
              if ($crec->contasrec_situacao_id != ContasrecSituacao::EmAberto)
              {
                  throw new exception ('Existe títulos a receber baixados, não será possivel estornar esta venda!');
              }

              $crec->contasrec_situacao_id = ContasrecSituacao::Cancelado;
              $crec->store();
            }                                        
        }        

   }
   
  public static function recalcula_itens_venda($venda)
  {
  
      foreach ($venda->getVendaItems() as $item)
      {
         //trazer o custo da filial..
         $produtofilial = ProdutoFilial::where('produto_id', '=', $item->produto_id)
                                       ->where('system_unit_id', '=', $item->venda->system_unit_id)
                                       ->first();           
         if ($produtofilial)
         {
           $item->valor_original = $produtofilial->preco_venda; 
           $item->valor_custo = $produtofilial->valor_custo;
         }      

         $item->valor_total = $item->quantidade * $item->valor_unitario;          
         $item->store();
      }
  }   
   
   public static function Totaliza_Venda($venda_id)
   {
   
       $venda = Venda::find($venda_id);
   
       $totalprodutos = 0;
       $totalvenda = 0;
       $totalfrete = 0;
       $totaldesconto = 0;
       $pesototal = 0;   
  
       $lista_venda_item = VendaItem::where('venda_id','=',$venda_id)->load();
   
       if ($lista_venda_item)
       {
           foreach ($lista_venda_item as $venda_item)
           {   
             $totalfrete += $venda_item->valor_frete;
             $totaldesconto += $venda_item->desconto;  
             $pesototal += $venda_item->peso_total;  
             $totalprodutos += $venda_item->valor_total;
 
             $vtotal = $venda_item->valor_total;
             $vfrete = $venda_item->valor_frete;
             $vdesconto = $venda_item->desconto;

             $totalvenda += ($vtotal+$vfrete)-$vdesconto;  
           }
       }
   
       $totalprodutos = (double) $totalprodutos;
       $totalvenda = (double) $totalvenda;
       $totalfrete = (double) $totalfrete;
       $totaldesconto = (double) $totaldesconto;
       $pesototal = (double) $pesototal;

       $venda->frete_total   = number_format($totalfrete, 2, ',', '.');
       $venda->desconto   = number_format($totaldesconto, 2, ',', '.');
       $venda->valor_produtos   = number_format($totalprodutos, 2, ',', '.');
       $venda->valor_total   = number_format($totalvenda, 2, ',', '.');
       $venda->peso_total   = number_format($pesototal, 2, ',', '.');                  
       $venda->store();
   }
   
   public static function ValidaVendaSemEstoque($venda_id)
   {
       $lista_venda_item = VendaItem::where('venda_id','=',$venda_id)->load();
   
       if ($lista_venda_item)
       {
           foreach ($lista_venda_item as $venda_item)
           {  
              $prod_estoque = VwProdutoEstoque::where('id', '=', $venda_item->produto_id)->first();
          
              if ($prod_estoque)
              {
                if ($prod_estoque->Quantidade_Disponivel < $venda_item->quantidade)
                {
                    throw new exception('O produto '.$venda_item->produto->nome.' não tem saldo disponivel para venda!');
                }
              }
           }
       }
   }
   
   
   
   public static function ClonarVenda($venda_id)
   {
       $venda = Venda::find($venda_id);
   
       if($venda)
       {
           $id_venda_ant = $venda_id;
           $nova_venda = $venda;
       
           $nova_venda->id = null;
           $nova_venda->system_unit_id = TSession::getValue('userunitid');
           $nova_venda->criado_em = date('Y-m-d H:i:s');
           $nova_venda->alterado_em = null;
           $nova_venda->alterado_por = null;
           $nova_venda->cliente_id = $venda->cliente_id;
           $nova_venda->data_hora_venda = date('Y-m-d H:i:s');
           $nova_venda->observacao = $venda->observacao;
           $nova_venda->venda_situacao_id = VendaSituacao::EmAndamento;
       
           $nova_venda->store();
       
       
           $itens_vendas = VendaItem::where('venda_id', '=', $id_venda_ant)->load();
           //carregando os itens
           foreach($itens_vendas as $item) {
               $novo_item = $item;
               $novo_item->venda_id = $nova_venda->id;
               $novo_item->criado_por = TSession::getValue('userunitid');
               $novo_item->id = null;
           
               $novo_item->store();
           }
       
       
           $itens_vendas = VendaFormapgto::where('venda_id', '=', $id_venda_ant)->load();
       

               $novo_item = $item;
               $novo_item->venda_id = $nova_venda->id;
           
               $novo_item->id = null;
           
               $novo_item->store();
       
    
       }
   }

  
                                                                                                        
}

