<?php

class VendaDevolucao extends TRecord
{
    const TABLENAME  = 'venda_devolucao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $venda;
    private $system_unit;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_unit_id');
        parent::addAttribute('venda_id');
        parent::addAttribute('data_devolucao');
        parent::addAttribute('valor');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_venda
     * Sample of usage: $var->venda = $object;
     * @param $object Instance of Venda
     */
    public function set_venda(Venda $object)
    {
        $this->venda = $object;
        $this->venda_id = $object->id;
    }

    /**
     * Method get_venda
     * Sample of usage: $var->venda->attribute;
     * @returns Venda instance
     */
    public function get_venda()
    {
    
        // loads the associated object
        if (empty($this->venda))
            $this->venda = new Venda($this->venda_id);
    
        // returns the associated object
        return $this->venda;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getVendaDevolucaoItenss
     */
    public function getVendaDevolucaoItenss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_devolucao_id', '=', $this->id));
        return VendaDevolucaoItens::getObjects( $criteria );
    }
    /**
     * Method getVendaDevolucaoTrocas
     */
    public function getVendaDevolucaoTrocas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_devolucao_id', '=', $this->id));
        return VendaDevolucaoTroca::getObjects( $criteria );
    }

    public function set_venda_devolucao_itens_venda_devolucao_to_string($venda_devolucao_itens_venda_devolucao_to_string)
    {
        if(is_array($venda_devolucao_itens_venda_devolucao_to_string))
        {
            $values = VendaDevolucao::where('id', 'in', $venda_devolucao_itens_venda_devolucao_to_string)->getIndexedArray('id', 'id');
            $this->venda_devolucao_itens_venda_devolucao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_itens_venda_devolucao_to_string = $venda_devolucao_itens_venda_devolucao_to_string;
        }

        $this->vdata['venda_devolucao_itens_venda_devolucao_to_string'] = $this->venda_devolucao_itens_venda_devolucao_to_string;
    }

    public function get_venda_devolucao_itens_venda_devolucao_to_string()
    {
        if(!empty($this->venda_devolucao_itens_venda_devolucao_to_string))
        {
            return $this->venda_devolucao_itens_venda_devolucao_to_string;
        }
    
        $values = VendaDevolucaoItens::where('venda_devolucao_id', '=', $this->id)->getIndexedArray('venda_devolucao_id','{venda_devolucao->id}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_itens_produto_to_string($venda_devolucao_itens_produto_to_string)
    {
        if(is_array($venda_devolucao_itens_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_devolucao_itens_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_devolucao_itens_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_itens_produto_to_string = $venda_devolucao_itens_produto_to_string;
        }

        $this->vdata['venda_devolucao_itens_produto_to_string'] = $this->venda_devolucao_itens_produto_to_string;
    }

    public function get_venda_devolucao_itens_produto_to_string()
    {
        if(!empty($this->venda_devolucao_itens_produto_to_string))
        {
            return $this->venda_devolucao_itens_produto_to_string;
        }
    
        $values = VendaDevolucaoItens::where('venda_devolucao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_troca_venda_devolucao_to_string($venda_devolucao_troca_venda_devolucao_to_string)
    {
        if(is_array($venda_devolucao_troca_venda_devolucao_to_string))
        {
            $values = VendaDevolucao::where('id', 'in', $venda_devolucao_troca_venda_devolucao_to_string)->getIndexedArray('id', 'id');
            $this->venda_devolucao_troca_venda_devolucao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_troca_venda_devolucao_to_string = $venda_devolucao_troca_venda_devolucao_to_string;
        }

        $this->vdata['venda_devolucao_troca_venda_devolucao_to_string'] = $this->venda_devolucao_troca_venda_devolucao_to_string;
    }

    public function get_venda_devolucao_troca_venda_devolucao_to_string()
    {
        if(!empty($this->venda_devolucao_troca_venda_devolucao_to_string))
        {
            return $this->venda_devolucao_troca_venda_devolucao_to_string;
        }
    
        $values = VendaDevolucaoTroca::where('venda_devolucao_id', '=', $this->id)->getIndexedArray('venda_devolucao_id','{venda_devolucao->id}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_troca_produto_to_string($venda_devolucao_troca_produto_to_string)
    {
        if(is_array($venda_devolucao_troca_produto_to_string))
        {
            $values = Produto::where('id', 'in', $venda_devolucao_troca_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_devolucao_troca_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_troca_produto_to_string = $venda_devolucao_troca_produto_to_string;
        }

        $this->vdata['venda_devolucao_troca_produto_to_string'] = $this->venda_devolucao_troca_produto_to_string;
    }

    public function get_venda_devolucao_troca_produto_to_string()
    {
        if(!empty($this->venda_devolucao_troca_produto_to_string))
        {
            return $this->venda_devolucao_troca_produto_to_string;
        }
    
        $values = VendaDevolucaoTroca::where('venda_devolucao_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

}

