<?php

class VendaDevolucaoItens extends TRecord
{
    const TABLENAME  = 'venda_devolucao_itens';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $venda_devolucao;
    private $produto;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('venda_devolucao_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('valor_total');
    
    }

    /**
     * Method set_venda_devolucao
     * Sample of usage: $var->venda_devolucao = $object;
     * @param $object Instance of VendaDevolucao
     */
    public function set_venda_devolucao(VendaDevolucao $object)
    {
        $this->venda_devolucao = $object;
        $this->venda_devolucao_id = $object->id;
    }

    /**
     * Method get_venda_devolucao
     * Sample of usage: $var->venda_devolucao->attribute;
     * @returns VendaDevolucao instance
     */
    public function get_venda_devolucao()
    {
    
        // loads the associated object
        if (empty($this->venda_devolucao))
            $this->venda_devolucao = new VendaDevolucao($this->venda_devolucao_id);
    
        // returns the associated object
        return $this->venda_devolucao;
    }
    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }

    public static function processar_devolucao()
    {
    
    }

            
}

