<?php

class VendaItem extends TRecord
{
    const TABLENAME  = 'venda_item';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $produto;
    private $fk_cancelado;
    private $venda;
    private $estoque_deposito;
    private $produto_lote;

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('venda_id');
        parent::addAttribute('produto_id');
        parent::addAttribute('quantidade');
        parent::addAttribute('valor_unitario');
        parent::addAttribute('valor_total');
        parent::addAttribute('valor_original');
        parent::addAttribute('valor_custo');
        parent::addAttribute('desconto');
        parent::addAttribute('informacoes_adicionais');
        parent::addAttribute('cancelado');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('numero_pedido');
        parent::addAttribute('numero_item_pedido');
        parent::addAttribute('valor_frete');
        parent::addAttribute('peso_unitario');
        parent::addAttribute('peso_total');
        parent::addAttribute('estoque_deposito_id');
        parent::addAttribute('produto_lote_id');
        parent::addAttribute('quantidade_devolvida');
    
    }

    /**
     * Method set_produto
     * Sample of usage: $var->produto = $object;
     * @param $object Instance of Produto
     */
    public function set_produto(Produto $object)
    {
        $this->produto = $object;
        $this->produto_id = $object->id;
    }

    /**
     * Method get_produto
     * Sample of usage: $var->produto->attribute;
     * @returns Produto instance
     */
    public function get_produto()
    {
    
        // loads the associated object
        if (empty($this->produto))
            $this->produto = new Produto($this->produto_id);
    
        // returns the associated object
        return $this->produto;
    }
    /**
     * Method set_resposta
     * Sample of usage: $var->resposta = $object;
     * @param $object Instance of Resposta
     */
    public function set_fk_cancelado(Resposta $object)
    {
        $this->fk_cancelado = $object;
        $this->cancelado = $object->id;
    }

    /**
     * Method get_fk_cancelado
     * Sample of usage: $var->fk_cancelado->attribute;
     * @returns Resposta instance
     */
    public function get_fk_cancelado()
    {
    
        // loads the associated object
        if (empty($this->fk_cancelado))
            $this->fk_cancelado = new Resposta($this->cancelado);
    
        // returns the associated object
        return $this->fk_cancelado;
    }
    /**
     * Method set_venda
     * Sample of usage: $var->venda = $object;
     * @param $object Instance of Venda
     */
    public function set_venda(Venda $object)
    {
        $this->venda = $object;
        $this->venda_id = $object->id;
    }

    /**
     * Method get_venda
     * Sample of usage: $var->venda->attribute;
     * @returns Venda instance
     */
    public function get_venda()
    {
    
        // loads the associated object
        if (empty($this->venda))
            $this->venda = new Venda($this->venda_id);
    
        // returns the associated object
        return $this->venda;
    }
    /**
     * Method set_estoque_deposito
     * Sample of usage: $var->estoque_deposito = $object;
     * @param $object Instance of EstoqueDeposito
     */
    public function set_estoque_deposito(EstoqueDeposito $object)
    {
        $this->estoque_deposito = $object;
        $this->estoque_deposito_id = $object->id;
    }

    /**
     * Method get_estoque_deposito
     * Sample of usage: $var->estoque_deposito->attribute;
     * @returns EstoqueDeposito instance
     */
    public function get_estoque_deposito()
    {
    
        // loads the associated object
        if (empty($this->estoque_deposito))
            $this->estoque_deposito = new EstoqueDeposito($this->estoque_deposito_id);
    
        // returns the associated object
        return $this->estoque_deposito;
    }
    /**
     * Method set_produto_lote
     * Sample of usage: $var->produto_lote = $object;
     * @param $object Instance of ProdutoLote
     */
    public function set_produto_lote(ProdutoLote $object)
    {
        $this->produto_lote = $object;
        $this->produto_lote_id = $object->id;
    }

    /**
     * Method get_produto_lote
     * Sample of usage: $var->produto_lote->attribute;
     * @returns ProdutoLote instance
     */
    public function get_produto_lote()
    {
    
        // loads the associated object
        if (empty($this->produto_lote))
            $this->produto_lote = new ProdutoLote($this->produto_lote_id);
    
        // returns the associated object
        return $this->produto_lote;
    }

   
   public function get_enderecamento_produto_prateleira()
   {
       $prod_filial = ProdutoFilial::where('produto_id', '=', $this->produto_id)->first();
   
       if($prod_filial)
       {
            $prod_enderecamento = ProdutoEnderecamento::where('produto_filial_id', '=', $prod_filial->id)->first();
            
            return $prod_enderecamento->estoque_prateleira->descricao;
       }
   }
   
   public function get_enderecamento_produto_estante()
   {
       $prod_filial = ProdutoFilial::where('produto_id', '=', $this->produto_id)->first();
   
       if($prod_filial)
       {
           $prod_enderecamento = ProdutoEnderecamento::where('produto_filial_id', '=', $prod_filial->id)->first();
       
           return $prod_enderecamento->estoque_prateleira->estoque_estante->descricao;
       }
   }
   
   public function get_enderecamento_produto_rua()
   {
       $prod_filial = ProdutoFilial::where('produto_id', '=', $this->produto_id)->first();
   
       if($prod_filial)
       {
           $prod_enderecamento = ProdutoEnderecamento::where('produto_filial_id', '=', $prod_filial->id)->first();
       
           return $prod_enderecamento->estoque_prateleira->estoque_estante->estoque_rua->descricao;
       }
   }

   public function get_codigo_padrao_produto_impressao_venda()
    {
        $config_filial = ConfiguracoesFilial::where('system_unit_id', '=', TSession::getValue('userunitid'))->first();
    
        if($config_filial)
        {
            $prod = Produto::find($this->produto_id);
        
            return funcaoNFE::RetornaCProd($config_filial->notafiscal_cprod_padrao_venda_id,
                                            $prod->id,
                                            $prod->codigo_EAN,
                                            $prod->referencia,
                                            $prod->codigo_sku);
                                                                 
        }
    }

    public static function LancamentoEstoque($estoque_tipo_movimentacao, $estoque_origem_id, $venda, $obs)
    {
        $itens = VendaItem::where('venda_id', '=', $venda->id)->load();
    
        foreach ($itens as $item)
        {
            $lancamento = new EstoqueLancamentos();
            $lancamento->system_unit_id = $venda->system_unit_id;
            $lancamento->produto_id = $item->produto_id;
            $lancamento->estoque_tipo_movimentacao_id = $estoque_tipo_movimentacao;
            $lancamento->estoque_origem_id = $estoque_origem_id;
            $lancamento->estoque_deposito_id = $item->estoque_deposito_id;
            $lancamento->produto_lote_id = $item->produto_lote_id;
            $lancamento->quantidade = $item->quantidade;
            $lancamento->codigo_origem = $item->venda_id;
            $lancamento->preco_venda = $item->valor_unitario;
            $lancamento->preco_custo = $item->valor_custo;   
            $lancamento->data_lancamento = date('Y-m-d');
            $lancamento->venda_id = $venda->id;
            $lancamento->criado_por = TSession::getValue('username');
            $lancamento->observacao = $obs;
            $lancamento->store();   
        }
    }

    public static function VerificaProdutosAbaixoDoMinimo($venda)
    {
        $itens = VendaItem::where('venda_id', '=', $venda->id)->load();
    
        foreach ($itens as $item)
        {
            EstoqueSaldos::VerificaEventoProdutoAbaixoDoMinimo($item->produto_id,$venda->system_unit_id);
        }
    }
                                                            
}

