<?php

class VendaMeta extends TRecord
{
    const TABLENAME  = 'venda_meta';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $venda_meta_situacao;
    private $system_unit;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('venda_meta_situacao_id');
        parent::addAttribute('system_unit_id');
        parent::addAttribute('descricao');
        parent::addAttribute('data_inicial');
        parent::addAttribute('data_final');
        parent::addAttribute('valor_meta_geral_prevista');
        parent::addAttribute('valor_meta_geral_realizada');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('data_ultimo_processamento');
    
    }

    /**
     * Method set_venda_meta_situacao
     * Sample of usage: $var->venda_meta_situacao = $object;
     * @param $object Instance of VendaMetaSituacao
     */
    public function set_venda_meta_situacao(VendaMetaSituacao $object)
    {
        $this->venda_meta_situacao = $object;
        $this->venda_meta_situacao_id = $object->id;
    }

    /**
     * Method get_venda_meta_situacao
     * Sample of usage: $var->venda_meta_situacao->attribute;
     * @returns VendaMetaSituacao instance
     */
    public function get_venda_meta_situacao()
    {
    
        // loads the associated object
        if (empty($this->venda_meta_situacao))
            $this->venda_meta_situacao = new VendaMetaSituacao($this->venda_meta_situacao_id);
    
        // returns the associated object
        return $this->venda_meta_situacao;
    }
    /**
     * Method set_system_unit
     * Sample of usage: $var->system_unit = $object;
     * @param $object Instance of SystemUnit
     */
    public function set_system_unit(SystemUnit $object)
    {
        $this->system_unit = $object;
        $this->system_unit_id = $object->id;
    }

    /**
     * Method get_system_unit
     * Sample of usage: $var->system_unit->attribute;
     * @returns SystemUnit instance
     */
    public function get_system_unit()
    {
    
        // loads the associated object
        if (empty($this->system_unit))
            $this->system_unit = new SystemUnit($this->system_unit_id);
    
        // returns the associated object
        return $this->system_unit;
    }

    /**
     * Method getVendaMetaVendedors
     */
    public function getVendaMetaVendedors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_meta_id', '=', $this->id));
        return VendaMetaVendedor::getObjects( $criteria );
    }

    public function set_venda_meta_vendedor_venda_meta_to_string($venda_meta_vendedor_venda_meta_to_string)
    {
        if(is_array($venda_meta_vendedor_venda_meta_to_string))
        {
            $values = VendaMeta::where('id', 'in', $venda_meta_vendedor_venda_meta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_meta_vendedor_venda_meta_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_vendedor_venda_meta_to_string = $venda_meta_vendedor_venda_meta_to_string;
        }

        $this->vdata['venda_meta_vendedor_venda_meta_to_string'] = $this->venda_meta_vendedor_venda_meta_to_string;
    }

    public function get_venda_meta_vendedor_venda_meta_to_string()
    {
        if(!empty($this->venda_meta_vendedor_venda_meta_to_string))
        {
            return $this->venda_meta_vendedor_venda_meta_to_string;
        }
    
        $values = VendaMetaVendedor::where('venda_meta_id', '=', $this->id)->getIndexedArray('venda_meta_id','{venda_meta->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_meta_vendedor_vendedor_to_string($venda_meta_vendedor_vendedor_to_string)
    {
        if(is_array($venda_meta_vendedor_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_meta_vendedor_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_meta_vendedor_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_vendedor_vendedor_to_string = $venda_meta_vendedor_vendedor_to_string;
        }

        $this->vdata['venda_meta_vendedor_vendedor_to_string'] = $this->venda_meta_vendedor_vendedor_to_string;
    }

    public function get_venda_meta_vendedor_vendedor_to_string()
    {
        if(!empty($this->venda_meta_vendedor_vendedor_to_string))
        {
            return $this->venda_meta_vendedor_vendedor_to_string;
        }
    
        $values = VendaMetaVendedor::where('venda_meta_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

  public static function TotalizaMeta($idmeta)
  {
      TTransaction::open('kraftsoft');
      $conn = TTransaction::get();
  
      $vendameta = VendaMeta::find($idmeta);
  
      if ($vendameta)
      {
          //carregando as vendas finalizadas no periodo da meta
        //   $sql = 'SELECT SUM(v.valor_total) as total_vendas FROM venda v '
        //                               .'WHERE v.venda_situacao_id=4 '
        //                               .'AND v.data_hora_venda BETWEEN '.
        //                               '"'.$vendameta->data_inicial.' 00:00:00" AND '
        //                               .'"'.$vendameta->data_final.' 23:59:59"';
                                   
        //   $totalvendas  = $conn->query($sql);     
     
          $totalvendas = (double) Venda::where('venda_situacao_id', '=', VendaSituacao::Finalizada)
                                        ->where('data_hora_venda', '>=', $vendameta->data_inicial.' 00:00:00"')
                                        ->where('data_hora_venda', '<=', $vendameta->data_final.' 23:59:59"')                                    
                                        ->sumby('valor_total');     
      
          $vendameta->valor_meta_geral_realizada = $totalvendas;
          $vendameta->data_ultimo_processamento = date('Y-m-d H:i');
          $vendameta->store();        

          //metas dos vendedores
          $listametavendedores = VendaMetaVendedor::where('venda_meta_id', '=', $idmeta)->load();
      
          foreach ($listametavendedores as $metavendedor)
          {
              //vendas do vendedor...
            //   $sql = 'SELECT SUM(v.valor_total) as total_vendas FROM venda v '
            //                               .'WHERE v.venda_situacao_id=4 '
            //                               .'AND v.data_hora_venda BETWEEN '.
            //                               '"'.$vendameta->data_inicial.' 00:00:00" AND '
            //                               .'"'.$vendameta->data_final.' 23:59:59"'
            //                               .'AND v.vendedor_id='.$metavendedor->vendedor_id;
                                   
            //   $totalvendasvendedor  = $conn->query($sql);
        
              $totalvendasvendedor = (double) Venda::where('venda_situacao_id', '=', VendaSituacao::Finalizada)
                                                    ->where('data_hora_venda', '>=', $vendameta->data_inicial.' 00:00:00"')
                                                    ->where('data_hora_venda', '<=', $vendameta->data_final.' 23:59:59"')
                                                    ->where('vendedor_id', '=', $metavendedor->vendedor_id)
                                                    ->sumby('valor_total');             
                                          
              $metavendedor->valor_meta_realizada = $totalvendasvendedor;
              $metavendedor->store();
                                        
              //base de aproveitamento...FALTA                          
                                                        
                                       
                                       
          }
                  
      }
  
      TTransaction::close();
  }
                
}

