<?php

class VendaMetaSituacao extends TRecord
{
    const TABLENAME  = 'venda_meta_situacao';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const Aberta = '1';
    const Fechada = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getVendaMetas
     */
    public function getVendaMetas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_meta_situacao_id', '=', $this->id));
        return VendaMeta::getObjects( $criteria );
    }

    public function set_venda_meta_venda_meta_situacao_to_string($venda_meta_venda_meta_situacao_to_string)
    {
        if(is_array($venda_meta_venda_meta_situacao_to_string))
        {
            $values = VendaMetaSituacao::where('id', 'in', $venda_meta_venda_meta_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_meta_venda_meta_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_venda_meta_situacao_to_string = $venda_meta_venda_meta_situacao_to_string;
        }

        $this->vdata['venda_meta_venda_meta_situacao_to_string'] = $this->venda_meta_venda_meta_situacao_to_string;
    }

    public function get_venda_meta_venda_meta_situacao_to_string()
    {
        if(!empty($this->venda_meta_venda_meta_situacao_to_string))
        {
            return $this->venda_meta_venda_meta_situacao_to_string;
        }
    
        $values = VendaMeta::where('venda_meta_situacao_id', '=', $this->id)->getIndexedArray('venda_meta_situacao_id','{venda_meta_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_meta_system_unit_to_string($venda_meta_system_unit_to_string)
    {
        if(is_array($venda_meta_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_meta_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_meta_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_system_unit_to_string = $venda_meta_system_unit_to_string;
        }

        $this->vdata['venda_meta_system_unit_to_string'] = $this->venda_meta_system_unit_to_string;
    }

    public function get_venda_meta_system_unit_to_string()
    {
        if(!empty($this->venda_meta_system_unit_to_string))
        {
            return $this->venda_meta_system_unit_to_string;
        }
    
        $values = VendaMeta::where('venda_meta_situacao_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    
}

