<?php

class VendaMetaVendedor extends TRecord
{
    const TABLENAME  = 'venda_meta_vendedor';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $venda_meta;
    private $vendedor;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('venda_meta_id');
        parent::addAttribute('vendedor_id');
        parent::addAttribute('valor_meta_prevista');
        parent::addAttribute('valor_meta_realizada');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
        parent::addAttribute('aproveiramento_carteira_prevista');
        parent::addAttribute('aproveitamento_carteira_realizada');
            
    }

    /**
     * Method set_venda_meta
     * Sample of usage: $var->venda_meta = $object;
     * @param $object Instance of VendaMeta
     */
    public function set_venda_meta(VendaMeta $object)
    {
        $this->venda_meta = $object;
        $this->venda_meta_id = $object->id;
    }

    /**
     * Method get_venda_meta
     * Sample of usage: $var->venda_meta->attribute;
     * @returns VendaMeta instance
     */
    public function get_venda_meta()
    {
    
        // loads the associated object
        if (empty($this->venda_meta))
            $this->venda_meta = new VendaMeta($this->venda_meta_id);
    
        // returns the associated object
        return $this->venda_meta;
    }
    /**
     * Method set_vendedor
     * Sample of usage: $var->vendedor = $object;
     * @param $object Instance of Vendedor
     */
    public function set_vendedor(Vendedor $object)
    {
        $this->vendedor = $object;
        $this->vendedor_id = $object->id;
    }

    /**
     * Method get_vendedor
     * Sample of usage: $var->vendedor->attribute;
     * @returns Vendedor instance
     */
    public function get_vendedor()
    {
    
        // loads the associated object
        if (empty($this->vendedor))
            $this->vendedor = new Vendedor($this->vendedor_id);
    
        // returns the associated object
        return $this->vendedor;
    }

    
}

