<?php

class VendaModalidade extends TRecord
{
    const TABLENAME  = 'venda_modalidade';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}
    const CACHECONTROL  = 'TAPCache';

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    const ClienteRetira = '1';
    const EmpresaEntrega = '2';

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
            
    }

    /**
     * Method getVendas
     */
    public function getVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('venda_modalidade_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }

    public function set_venda_venda_situacao_to_string($venda_venda_situacao_to_string)
    {
        if(is_array($venda_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_situacao_to_string = $venda_venda_situacao_to_string;
        }

        $this->vdata['venda_venda_situacao_to_string'] = $this->venda_venda_situacao_to_string;
    }

    public function get_venda_venda_situacao_to_string()
    {
        if(!empty($this->venda_venda_situacao_to_string))
        {
            return $this->venda_venda_situacao_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_orcamento_to_string($venda_orcamento_to_string)
    {
        if(is_array($venda_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $venda_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->venda_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_orcamento_to_string = $venda_orcamento_to_string;
        }

        $this->vdata['venda_orcamento_to_string'] = $this->venda_orcamento_to_string;
    }

    public function get_venda_orcamento_to_string()
    {
        if(!empty($this->venda_orcamento_to_string))
        {
            return $this->venda_orcamento_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_vendedor_to_string($venda_vendedor_to_string)
    {
        if(is_array($venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_vendedor_to_string = $venda_vendedor_to_string;
        }

        $this->vdata['venda_vendedor_to_string'] = $this->venda_vendedor_to_string;
    }

    public function get_venda_vendedor_to_string()
    {
        if(!empty($this->venda_vendedor_to_string))
        {
            return $this->venda_vendedor_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_venda_dispositivos_to_string($venda_dispositivos_to_string)
    {
        if(is_array($venda_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $venda_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->venda_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_dispositivos_to_string = $venda_dispositivos_to_string;
        }

        $this->vdata['venda_dispositivos_to_string'] = $this->venda_dispositivos_to_string;
    }

    public function get_venda_dispositivos_to_string()
    {
        if(!empty($this->venda_dispositivos_to_string))
        {
            return $this->venda_dispositivos_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_to_string($venda_cliente_to_string)
    {
        if(is_array($venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_to_string = $venda_cliente_to_string;
        }

        $this->vdata['venda_cliente_to_string'] = $this->venda_cliente_to_string;
    }

    public function get_venda_cliente_to_string()
    {
        if(!empty($this->venda_cliente_to_string))
        {
            return $this->venda_cliente_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_venda_system_unit_to_string($venda_system_unit_to_string)
    {
        if(is_array($venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_system_unit_to_string = $venda_system_unit_to_string;
        }

        $this->vdata['venda_system_unit_to_string'] = $this->venda_system_unit_to_string;
    }

    public function get_venda_system_unit_to_string()
    {
        if(!empty($this->venda_system_unit_to_string))
        {
            return $this->venda_system_unit_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_filial_saida_to_string($venda_filial_saida_to_string)
    {
        if(is_array($venda_filial_saida_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_filial_saida_to_string)->getIndexedArray('name', 'name');
            $this->venda_filial_saida_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_filial_saida_to_string = $venda_filial_saida_to_string;
        }

        $this->vdata['venda_filial_saida_to_string'] = $this->venda_filial_saida_to_string;
    }

    public function get_venda_filial_saida_to_string()
    {
        if(!empty($this->venda_filial_saida_to_string))
        {
            return $this->venda_filial_saida_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('filial_saida_id','{filial_saida->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_modalidade_to_string($venda_venda_modalidade_to_string)
    {
        if(is_array($venda_venda_modalidade_to_string))
        {
            $values = VendaModalidade::where('id', 'in', $venda_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_modalidade_to_string = $venda_venda_modalidade_to_string;
        }

        $this->vdata['venda_venda_modalidade_to_string'] = $this->venda_venda_modalidade_to_string;
    }

    public function get_venda_venda_modalidade_to_string()
    {
        if(!empty($this->venda_venda_modalidade_to_string))
        {
            return $this->venda_venda_modalidade_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('venda_modalidade_id','{venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_tipo_pagamento_to_string($venda_venda_tipo_pagamento_to_string)
    {
        if(is_array($venda_venda_tipo_pagamento_to_string))
        {
            $values = VendaTipoPagamento::where('id', 'in', $venda_venda_tipo_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_tipo_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_tipo_pagamento_to_string = $venda_venda_tipo_pagamento_to_string;
        }

        $this->vdata['venda_venda_tipo_pagamento_to_string'] = $this->venda_venda_tipo_pagamento_to_string;
    }

    public function get_venda_venda_tipo_pagamento_to_string()
    {
        if(!empty($this->venda_venda_tipo_pagamento_to_string))
        {
            return $this->venda_venda_tipo_pagamento_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('venda_tipo_pagamento_id','{venda_tipo_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_endereco_to_string($venda_cliente_endereco_to_string)
    {
        if(is_array($venda_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $venda_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->venda_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_endereco_to_string = $venda_cliente_endereco_to_string;
        }

        $this->vdata['venda_cliente_endereco_to_string'] = $this->venda_cliente_endereco_to_string;
    }

    public function get_venda_cliente_endereco_to_string()
    {
        if(!empty($this->venda_cliente_endereco_to_string))
        {
            return $this->venda_cliente_endereco_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_venda_tabela_preco_to_string($venda_tabela_preco_to_string)
    {
        if(is_array($venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_tabela_preco_to_string = $venda_tabela_preco_to_string;
        }

        $this->vdata['venda_tabela_preco_to_string'] = $this->venda_tabela_preco_to_string;
    }

    public function get_venda_tabela_preco_to_string()
    {
        if(!empty($this->venda_tabela_preco_to_string))
        {
            return $this->venda_tabela_preco_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_movimentacao_origem_to_string($venda_movimentacao_origem_to_string)
    {
        if(is_array($venda_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $venda_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_movimentacao_origem_to_string = $venda_movimentacao_origem_to_string;
        }

        $this->vdata['venda_movimentacao_origem_to_string'] = $this->venda_movimentacao_origem_to_string;
    }

    public function get_venda_movimentacao_origem_to_string()
    {
        if(!empty($this->venda_movimentacao_origem_to_string))
        {
            return $this->venda_movimentacao_origem_to_string;
        }
    
        $values = Venda::where('venda_modalidade_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    
}

