<?php

class VendaSituacaoHistorico extends TRecord
{
    const TABLENAME  = 'venda_situacao_historico';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $venda_situacao;
    private $venda;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('venda_situacao_id');
        parent::addAttribute('venda_id');
        parent::addAttribute('descricao');
        parent::addAttribute('criado_em');
        parent::addAttribute('deletado_em');
        parent::addAttribute('alterado_por');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_em');
    
    }

    /**
     * Method set_venda_situacao
     * Sample of usage: $var->venda_situacao = $object;
     * @param $object Instance of VendaSituacao
     */
    public function set_venda_situacao(VendaSituacao $object)
    {
        $this->venda_situacao = $object;
        $this->venda_situacao_id = $object->id;
    }

    /**
     * Method get_venda_situacao
     * Sample of usage: $var->venda_situacao->attribute;
     * @returns VendaSituacao instance
     */
    public function get_venda_situacao()
    {
    
        // loads the associated object
        if (empty($this->venda_situacao))
            $this->venda_situacao = new VendaSituacao($this->venda_situacao_id);
    
        // returns the associated object
        return $this->venda_situacao;
    }
    /**
     * Method set_venda
     * Sample of usage: $var->venda = $object;
     * @param $object Instance of Venda
     */
    public function set_venda(Venda $object)
    {
        $this->venda = $object;
        $this->venda_id = $object->id;
    }

    /**
     * Method get_venda
     * Sample of usage: $var->venda->attribute;
     * @returns Venda instance
     */
    public function get_venda()
    {
    
        // loads the associated object
        if (empty($this->venda))
            $this->venda = new Venda($this->venda_id);
    
        // returns the associated object
        return $this->venda;
    }

    public static function LancarHistorico($venda_situacao_id,$venda_id,$descricao)
    {
        $historicosit = new VendaSituacaoHistorico;
        $historicosit->venda_situacao_id = $venda_situacao_id;
        $historicosit->venda_id = $venda_id;
        $historicosit->descricao = $descricao;
        $historicosit->criado_por =  TSession::getValue('username');
        $historicosit->store();    
    }
        
}

