<?php

class Vendedor extends TRecord
{
    const TABLENAME  = 'vendedor';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'serial'; // {max, serial}

    const DELETEDAT  = 'deletado_em';
    const CREATEDAT  = 'criado_em';
    const UPDATEDAT  = 'alterado_em';

    private $vendedor_tipo_comissao;
    private $vendedor_tipo_pgto_comissao;

    

    use SystemChangeLogTrait;
    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('nome');
        parent::addAttribute('cpf');
        parent::addAttribute('vendedor_tipo_comissao_id');
        parent::addAttribute('vendedor_tipo_pgto_comissao_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('alterado_em');
        parent::addAttribute('percentual_comissao');
        parent::addAttribute('criado_por');
        parent::addAttribute('alterado_por');
        parent::addAttribute('deletado_em');
            
    }

    /**
     * Method set_vendedor_tipo_comissao
     * Sample of usage: $var->vendedor_tipo_comissao = $object;
     * @param $object Instance of VendedorTipoComissao
     */
    public function set_vendedor_tipo_comissao(VendedorTipoComissao $object)
    {
        $this->vendedor_tipo_comissao = $object;
        $this->vendedor_tipo_comissao_id = $object->id;
    }

    /**
     * Method get_vendedor_tipo_comissao
     * Sample of usage: $var->vendedor_tipo_comissao->attribute;
     * @returns VendedorTipoComissao instance
     */
    public function get_vendedor_tipo_comissao()
    {
    
        // loads the associated object
        if (empty($this->vendedor_tipo_comissao))
            $this->vendedor_tipo_comissao = new VendedorTipoComissao($this->vendedor_tipo_comissao_id);
    
        // returns the associated object
        return $this->vendedor_tipo_comissao;
    }
    /**
     * Method set_vendedor_tipo_pgto_comissao
     * Sample of usage: $var->vendedor_tipo_pgto_comissao = $object;
     * @param $object Instance of VendedorTipoPgtoComissao
     */
    public function set_vendedor_tipo_pgto_comissao(VendedorTipoPgtoComissao $object)
    {
        $this->vendedor_tipo_pgto_comissao = $object;
        $this->vendedor_tipo_pgto_comissao_id = $object->id;
    }

    /**
     * Method get_vendedor_tipo_pgto_comissao
     * Sample of usage: $var->vendedor_tipo_pgto_comissao->attribute;
     * @returns VendedorTipoPgtoComissao instance
     */
    public function get_vendedor_tipo_pgto_comissao()
    {
    
        // loads the associated object
        if (empty($this->vendedor_tipo_pgto_comissao))
            $this->vendedor_tipo_pgto_comissao = new VendedorTipoPgtoComissao($this->vendedor_tipo_pgto_comissao_id);
    
        // returns the associated object
        return $this->vendedor_tipo_pgto_comissao;
    }

    /**
     * Method getCertificadoVendas
     */
    public function getCertificadoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return CertificadoVenda::getObjects( $criteria );
    }
    /**
     * Method getClientes
     */
    public function getClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return Cliente::getObjects( $criteria );
    }
    /**
     * Method getContasrecs
     */
    public function getContasrecs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return Contasrec::getObjects( $criteria );
    }
    /**
     * Method getNegocios
     */
    public function getNegocios()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return Negocio::getObjects( $criteria );
    }
    /**
     * Method getOrcamentos
     */
    public function getOrcamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return Orcamento::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicos
     */
    public function getOrdemServicos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return OrdemServico::getObjects( $criteria );
    }
    /**
     * Method getParceiros
     */
    public function getParceiros()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return Parceiro::getObjects( $criteria );
    }
    /**
     * Method getVendas
     */
    public function getVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }
    /**
     * Method getVendaMetaVendedors
     */
    public function getVendaMetaVendedors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('vendedor_id', '=', $this->id));
        return VendaMetaVendedor::getObjects( $criteria );
    }

    public function set_certificado_venda_system_unit_to_string($certificado_venda_system_unit_to_string)
    {
        if(is_array($certificado_venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $certificado_venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->certificado_venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_system_unit_to_string = $certificado_venda_system_unit_to_string;
        }

        $this->vdata['certificado_venda_system_unit_to_string'] = $this->certificado_venda_system_unit_to_string;
    }

    public function get_certificado_venda_system_unit_to_string()
    {
        if(!empty($this->certificado_venda_system_unit_to_string))
        {
            return $this->certificado_venda_system_unit_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_cliente_to_string($certificado_venda_cliente_to_string)
    {
        if(is_array($certificado_venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_cliente_to_string = $certificado_venda_cliente_to_string;
        }

        $this->vdata['certificado_venda_cliente_to_string'] = $this->certificado_venda_cliente_to_string;
    }

    public function get_certificado_venda_cliente_to_string()
    {
        if(!empty($this->certificado_venda_cliente_to_string))
        {
            return $this->certificado_venda_cliente_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_produto_to_string($certificado_venda_produto_to_string)
    {
        if(is_array($certificado_venda_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_venda_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_produto_to_string = $certificado_venda_produto_to_string;
        }

        $this->vdata['certificado_venda_produto_to_string'] = $this->certificado_venda_produto_to_string;
    }

    public function get_certificado_venda_produto_to_string()
    {
        if(!empty($this->certificado_venda_produto_to_string))
        {
            return $this->certificado_venda_produto_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_parceiro_to_string($certificado_venda_parceiro_to_string)
    {
        if(is_array($certificado_venda_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_venda_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_parceiro_to_string = $certificado_venda_parceiro_to_string;
        }

        $this->vdata['certificado_venda_parceiro_to_string'] = $this->certificado_venda_parceiro_to_string;
    }

    public function get_certificado_venda_parceiro_to_string()
    {
        if(!empty($this->certificado_venda_parceiro_to_string))
        {
            return $this->certificado_venda_parceiro_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_agente_registro_to_string($certificado_venda_certificado_agente_registro_to_string)
    {
        if(is_array($certificado_venda_certificado_agente_registro_to_string))
        {
            $values = CertificadoAgenteRegistro::where('id', 'in', $certificado_venda_certificado_agente_registro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificado_agente_registro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_agente_registro_to_string = $certificado_venda_certificado_agente_registro_to_string;
        }

        $this->vdata['certificado_venda_certificado_agente_registro_to_string'] = $this->certificado_venda_certificado_agente_registro_to_string;
    }

    public function get_certificado_venda_certificado_agente_registro_to_string()
    {
        if(!empty($this->certificado_venda_certificado_agente_registro_to_string))
        {
            return $this->certificado_venda_certificado_agente_registro_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('certificado_agente_registro_id','{certificado_agente_registro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_situacao_to_string($certificado_venda_certificado_venda_situacao_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_situacao_to_string))
        {
            $values = CertificadoVendaSituacao::where('id', 'in', $certificado_venda_certificado_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_situacao_to_string = $certificado_venda_certificado_venda_situacao_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_situacao_to_string'] = $this->certificado_venda_certificado_venda_situacao_to_string;
    }

    public function get_certificado_venda_certificado_venda_situacao_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_situacao_to_string))
        {
            return $this->certificado_venda_certificado_venda_situacao_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('certificado_venda_situacao_id','{certificado_venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_modalidade_to_string($certificado_venda_certificado_venda_modalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $certificado_venda_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_modalidade_to_string = $certificado_venda_certificado_venda_modalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_modalidade_to_string'] = $this->certificado_venda_certificado_venda_modalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_modalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_modalidade_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_tipomodalidade_to_string($certificado_venda_certificado_venda_tipomodalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            $values = CertificadoVendaTipomodalidade::where('id', 'in', $certificado_venda_certificado_venda_tipomodalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = $certificado_venda_certificado_venda_tipomodalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_tipomodalidade_to_string'] = $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_tipomodalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('certificado_venda_tipomodalidade_id','{certificado_venda_tipomodalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_repasse_to_string($certificado_venda_certificado_tipo_repasse_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_repasse_to_string))
        {
            $values = CertificadoTipoRepasse::where('id', 'in', $certificado_venda_certificado_tipo_repasse_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_repasse_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_repasse_to_string = $certificado_venda_certificado_tipo_repasse_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_repasse_to_string'] = $this->certificado_venda_certificado_tipo_repasse_to_string;
    }

    public function get_certificado_venda_certificado_tipo_repasse_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_repasse_to_string))
        {
            return $this->certificado_venda_certificado_tipo_repasse_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('certificado_tipo_repasse_id','{certificado_tipo_repasse->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_vendedor_to_string($certificado_venda_vendedor_to_string)
    {
        if(is_array($certificado_venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $certificado_venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_vendedor_to_string = $certificado_venda_vendedor_to_string;
        }

        $this->vdata['certificado_venda_vendedor_to_string'] = $this->certificado_venda_vendedor_to_string;
    }

    public function get_certificado_venda_vendedor_to_string()
    {
        if(!empty($this->certificado_venda_vendedor_to_string))
        {
            return $this->certificado_venda_vendedor_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_tabela_preco_to_string($certificado_venda_tabela_preco_to_string)
    {
        if(is_array($certificado_venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $certificado_venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_tabela_preco_to_string = $certificado_venda_tabela_preco_to_string;
        }

        $this->vdata['certificado_venda_tabela_preco_to_string'] = $this->certificado_venda_tabela_preco_to_string;
    }

    public function get_certificado_venda_tabela_preco_to_string()
    {
        if(!empty($this->certificado_venda_tabela_preco_to_string))
        {
            return $this->certificado_venda_tabela_preco_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificadora_to_string($certificado_venda_certificadora_to_string)
    {
        if(is_array($certificado_venda_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificado_venda_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificadora_to_string = $certificado_venda_certificadora_to_string;
        }

        $this->vdata['certificado_venda_certificadora_to_string'] = $this->certificado_venda_certificadora_to_string;
    }

    public function get_certificado_venda_certificadora_to_string()
    {
        if(!empty($this->certificado_venda_certificadora_to_string))
        {
            return $this->certificado_venda_certificadora_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_atendimento_to_string($certificado_venda_certificado_tipo_atendimento_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_atendimento_to_string))
        {
            $values = CertificadoTipoAtendimento::where('id', 'in', $certificado_venda_certificado_tipo_atendimento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_atendimento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_atendimento_to_string = $certificado_venda_certificado_tipo_atendimento_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_atendimento_to_string'] = $this->certificado_venda_certificado_tipo_atendimento_to_string;
    }

    public function get_certificado_venda_certificado_tipo_atendimento_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_atendimento_to_string))
        {
            return $this->certificado_venda_certificado_tipo_atendimento_to_string;
        }
    
        $values = CertificadoVenda::where('vendedor_id', '=', $this->id)->getIndexedArray('certificado_tipo_atendimento_id','{certificado_tipo_atendimento->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_pessoa_tipo_to_string($cliente_pessoa_tipo_to_string)
    {
        if(is_array($cliente_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $cliente_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_pessoa_tipo_to_string = $cliente_pessoa_tipo_to_string;
        }

        $this->vdata['cliente_pessoa_tipo_to_string'] = $this->cliente_pessoa_tipo_to_string;
    }

    public function get_cliente_pessoa_tipo_to_string()
    {
        if(!empty($this->cliente_pessoa_tipo_to_string))
        {
            return $this->cliente_pessoa_tipo_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_to_string($cliente_cliente_classificacao_to_string)
    {
        if(is_array($cliente_cliente_classificacao_to_string))
        {
            $values = ClienteClassificacao::where('id', 'in', $cliente_cliente_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_to_string = $cliente_cliente_classificacao_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_to_string'] = $this->cliente_cliente_classificacao_to_string;
    }

    public function get_cliente_cliente_classificacao_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_to_string))
        {
            return $this->cliente_cliente_classificacao_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_classificacao_id','{cliente_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_subgrupo_to_string($cliente_cliente_classificacao_subgrupo_to_string)
    {
        if(is_array($cliente_cliente_classificacao_subgrupo_to_string))
        {
            $values = ClienteClassificacaoSubgrupo::where('id', 'in', $cliente_cliente_classificacao_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_subgrupo_to_string = $cliente_cliente_classificacao_subgrupo_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_subgrupo_to_string'] = $this->cliente_cliente_classificacao_subgrupo_to_string;
    }

    public function get_cliente_cliente_classificacao_subgrupo_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_subgrupo_to_string))
        {
            return $this->cliente_cliente_classificacao_subgrupo_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_classificacao_subgrupo_id','{cliente_classificacao_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_vendedor_to_string($cliente_vendedor_to_string)
    {
        if(is_array($cliente_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $cliente_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_vendedor_to_string = $cliente_vendedor_to_string;
        }

        $this->vdata['cliente_vendedor_to_string'] = $this->cliente_vendedor_to_string;
    }

    public function get_cliente_vendedor_to_string()
    {
        if(!empty($this->cliente_vendedor_to_string))
        {
            return $this->cliente_vendedor_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_indiedest_to_string($cliente_notafiscal_indiedest_to_string)
    {
        if(is_array($cliente_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $cliente_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_indiedest_to_string = $cliente_notafiscal_indiedest_to_string;
        }

        $this->vdata['cliente_notafiscal_indiedest_to_string'] = $this->cliente_notafiscal_indiedest_to_string;
    }

    public function get_cliente_notafiscal_indiedest_to_string()
    {
        if(!empty($this->cliente_notafiscal_indiedest_to_string))
        {
            return $this->cliente_notafiscal_indiedest_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_crt_to_string($cliente_notafiscal_crt_to_string)
    {
        if(is_array($cliente_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $cliente_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_crt_to_string = $cliente_notafiscal_crt_to_string;
        }

        $this->vdata['cliente_notafiscal_crt_to_string'] = $this->cliente_notafiscal_crt_to_string;
    }

    public function get_cliente_notafiscal_crt_to_string()
    {
        if(!empty($this->cliente_notafiscal_crt_to_string))
        {
            return $this->cliente_notafiscal_crt_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_residencia_propria_to_string($cliente_fk_residencia_propria_to_string)
    {
        if(is_array($cliente_fk_residencia_propria_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_residencia_propria_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_residencia_propria_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_residencia_propria_to_string = $cliente_fk_residencia_propria_to_string;
        }

        $this->vdata['cliente_fk_residencia_propria_to_string'] = $this->cliente_fk_residencia_propria_to_string;
    }

    public function get_cliente_fk_residencia_propria_to_string()
    {
        if(!empty($this->cliente_fk_residencia_propria_to_string))
        {
            return $this->cliente_fk_residencia_propria_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('residencia_propria','{fk_residencia_propria->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_utilizar_endereco_cobranca_to_string($cliente_fk_utilizar_endereco_cobranca_to_string)
    {
        if(is_array($cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_utilizar_endereco_cobranca_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = $cliente_fk_utilizar_endereco_cobranca_to_string;
        }

        $this->vdata['cliente_fk_utilizar_endereco_cobranca_to_string'] = $this->cliente_fk_utilizar_endereco_cobranca_to_string;
    }

    public function get_cliente_fk_utilizar_endereco_cobranca_to_string()
    {
        if(!empty($this->cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            return $this->cliente_fk_utilizar_endereco_cobranca_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('utilizar_endereco_cobranca','{fk_utilizar_endereco_cobranca->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_situacao_to_string($cliente_cliente_situacao_to_string)
    {
        if(is_array($cliente_cliente_situacao_to_string))
        {
            $values = ClienteSituacao::where('id', 'in', $cliente_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_situacao_to_string = $cliente_cliente_situacao_to_string;
        }

        $this->vdata['cliente_cliente_situacao_to_string'] = $this->cliente_cliente_situacao_to_string;
    }

    public function get_cliente_cliente_situacao_to_string()
    {
        if(!empty($this->cliente_cliente_situacao_to_string))
        {
            return $this->cliente_cliente_situacao_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_situacao_id','{cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_system_unit_to_string($cliente_system_unit_to_string)
    {
        if(is_array($cliente_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $cliente_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->cliente_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_system_unit_to_string = $cliente_system_unit_to_string;
        }

        $this->vdata['cliente_system_unit_to_string'] = $this->cliente_system_unit_to_string;
    }

    public function get_cliente_system_unit_to_string()
    {
        if(!empty($this->cliente_system_unit_to_string))
        {
            return $this->cliente_system_unit_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_cliente_tabela_preco_to_string($cliente_tabela_preco_to_string)
    {
        if(is_array($cliente_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $cliente_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_tabela_preco_to_string = $cliente_tabela_preco_to_string;
        }

        $this->vdata['cliente_tabela_preco_to_string'] = $this->cliente_tabela_preco_to_string;
    }

    public function get_cliente_tabela_preco_to_string()
    {
        if(!empty($this->cliente_tabela_preco_to_string))
        {
            return $this->cliente_tabela_preco_to_string;
        }
    
        $values = Cliente::where('vendedor_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_system_unit_to_string($contasrec_system_unit_to_string)
    {
        if(is_array($contasrec_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_system_unit_to_string = $contasrec_system_unit_to_string;
        }

        $this->vdata['contasrec_system_unit_to_string'] = $this->contasrec_system_unit_to_string;
    }

    public function get_contasrec_system_unit_to_string()
    {
        if(!empty($this->contasrec_system_unit_to_string))
        {
            return $this->contasrec_system_unit_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_cliente_to_string($contasrec_cliente_to_string)
    {
        if(is_array($contasrec_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cliente_to_string = $contasrec_cliente_to_string;
        }

        $this->vdata['contasrec_cliente_to_string'] = $this->contasrec_cliente_to_string;
    }

    public function get_contasrec_cliente_to_string()
    {
        if(!empty($this->contasrec_cliente_to_string))
        {
            return $this->contasrec_cliente_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_forma_pagamento_to_string($contasrec_forma_pagamento_to_string)
    {
        if(is_array($contasrec_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_forma_pagamento_to_string = $contasrec_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_forma_pagamento_to_string'] = $this->contasrec_forma_pagamento_to_string;
    }

    public function get_contasrec_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_forma_pagamento_to_string))
        {
            return $this->contasrec_forma_pagamento_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_situacao_to_string($contasrec_contasrec_situacao_to_string)
    {
        if(is_array($contasrec_contasrec_situacao_to_string))
        {
            $values = ContasrecSituacao::where('id', 'in', $contasrec_contasrec_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_situacao_to_string = $contasrec_contasrec_situacao_to_string;
        }

        $this->vdata['contasrec_contasrec_situacao_to_string'] = $this->contasrec_contasrec_situacao_to_string;
    }

    public function get_contasrec_contasrec_situacao_to_string()
    {
        if(!empty($this->contasrec_contasrec_situacao_to_string))
        {
            return $this->contasrec_contasrec_situacao_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('contasrec_situacao_id','{contasrec_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_plano_conta_to_string($contasrec_plano_conta_to_string)
    {
        if(is_array($contasrec_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_plano_conta_to_string = $contasrec_plano_conta_to_string;
        }

        $this->vdata['contasrec_plano_conta_to_string'] = $this->contasrec_plano_conta_to_string;
    }

    public function get_contasrec_plano_conta_to_string()
    {
        if(!empty($this->contasrec_plano_conta_to_string))
        {
            return $this->contasrec_plano_conta_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_centro_custo_to_string($contasrec_centro_custo_to_string)
    {
        if(is_array($contasrec_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_centro_custo_to_string = $contasrec_centro_custo_to_string;
        }

        $this->vdata['contasrec_centro_custo_to_string'] = $this->contasrec_centro_custo_to_string;
    }

    public function get_contasrec_centro_custo_to_string()
    {
        if(!empty($this->contasrec_centro_custo_to_string))
        {
            return $this->contasrec_centro_custo_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_origem_to_string($contasrec_contasrec_origem_to_string)
    {
        if(is_array($contasrec_contasrec_origem_to_string))
        {
            $values = ContasrecOrigem::where('id', 'in', $contasrec_contasrec_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_origem_to_string = $contasrec_contasrec_origem_to_string;
        }

        $this->vdata['contasrec_contasrec_origem_to_string'] = $this->contasrec_contasrec_origem_to_string;
    }

    public function get_contasrec_contasrec_origem_to_string()
    {
        if(!empty($this->contasrec_contasrec_origem_to_string))
        {
            return $this->contasrec_contasrec_origem_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('contasrec_origem_id','{contasrec_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_cheque_banco_to_string($contasrec_cheque_banco_to_string)
    {
        if(is_array($contasrec_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contasrec_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cheque_banco_to_string = $contasrec_cheque_banco_to_string;
        }

        $this->vdata['contasrec_cheque_banco_to_string'] = $this->contasrec_cheque_banco_to_string;
    }

    public function get_contasrec_cheque_banco_to_string()
    {
        if(!empty($this->contasrec_cheque_banco_to_string))
        {
            return $this->contasrec_cheque_banco_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_conta_corrente_boleto_to_string($contasrec_conta_corrente_boleto_to_string)
    {
        if(is_array($contasrec_conta_corrente_boleto_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_conta_corrente_boleto_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_conta_corrente_boleto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_conta_corrente_boleto_to_string = $contasrec_conta_corrente_boleto_to_string;
        }

        $this->vdata['contasrec_conta_corrente_boleto_to_string'] = $this->contasrec_conta_corrente_boleto_to_string;
    }

    public function get_contasrec_conta_corrente_boleto_to_string()
    {
        if(!empty($this->contasrec_conta_corrente_boleto_to_string))
        {
            return $this->contasrec_conta_corrente_boleto_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('conta_corrente_boleto_id','{conta_corrente_boleto->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_boleto_situacao_to_string($contasrec_boleto_situacao_to_string)
    {
        if(is_array($contasrec_boleto_situacao_to_string))
        {
            $values = BoletoSituacao::where('id', 'in', $contasrec_boleto_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_boleto_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_boleto_situacao_to_string = $contasrec_boleto_situacao_to_string;
        }

        $this->vdata['contasrec_boleto_situacao_to_string'] = $this->contasrec_boleto_situacao_to_string;
    }

    public function get_contasrec_boleto_situacao_to_string()
    {
        if(!empty($this->contasrec_boleto_situacao_to_string))
        {
            return $this->contasrec_boleto_situacao_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('boleto_situacao_id','{boleto_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_vendedor_to_string($contasrec_vendedor_to_string)
    {
        if(is_array($contasrec_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $contasrec_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_vendedor_to_string = $contasrec_vendedor_to_string;
        }

        $this->vdata['contasrec_vendedor_to_string'] = $this->contasrec_vendedor_to_string;
    }

    public function get_contasrec_vendedor_to_string()
    {
        if(!empty($this->contasrec_vendedor_to_string))
        {
            return $this->contasrec_vendedor_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_bloco_to_string($contasrec_contasrec_bloco_to_string)
    {
        if(is_array($contasrec_contasrec_bloco_to_string))
        {
            $values = ContasrecBloco::where('id', 'in', $contasrec_contasrec_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_contasrec_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_bloco_to_string = $contasrec_contasrec_bloco_to_string;
        }

        $this->vdata['contasrec_contasrec_bloco_to_string'] = $this->contasrec_contasrec_bloco_to_string;
    }

    public function get_contasrec_contasrec_bloco_to_string()
    {
        if(!empty($this->contasrec_contasrec_bloco_to_string))
        {
            return $this->contasrec_contasrec_bloco_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('contasrec_bloco_id','{contasrec_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_venda_formapgto_to_string($contasrec_venda_formapgto_to_string)
    {
        if(is_array($contasrec_venda_formapgto_to_string))
        {
            $values = VendaFormapgto::where('id', 'in', $contasrec_venda_formapgto_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_venda_formapgto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_venda_formapgto_to_string = $contasrec_venda_formapgto_to_string;
        }

        $this->vdata['contasrec_venda_formapgto_to_string'] = $this->contasrec_venda_formapgto_to_string;
    }

    public function get_contasrec_venda_formapgto_to_string()
    {
        if(!empty($this->contasrec_venda_formapgto_to_string))
        {
            return $this->contasrec_venda_formapgto_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('venda_formapgto_id','{venda_formapgto->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_ativo_to_string($contasrec_ativo_to_string)
    {
        if(is_array($contasrec_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $contasrec_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_ativo_to_string = $contasrec_ativo_to_string;
        }

        $this->vdata['contasrec_ativo_to_string'] = $this->contasrec_ativo_to_string;
    }

    public function get_contasrec_ativo_to_string()
    {
        if(!empty($this->contasrec_ativo_to_string))
        {
            return $this->contasrec_ativo_to_string;
        }
    
        $values = Contasrec::where('vendedor_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_system_unit_to_string($negocio_system_unit_to_string)
    {
        if(is_array($negocio_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $negocio_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->negocio_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_system_unit_to_string = $negocio_system_unit_to_string;
        }

        $this->vdata['negocio_system_unit_to_string'] = $this->negocio_system_unit_to_string;
    }

    public function get_negocio_system_unit_to_string()
    {
        if(!empty($this->negocio_system_unit_to_string))
        {
            return $this->negocio_system_unit_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_origem_to_string($negocio_negocio_origem_to_string)
    {
        if(is_array($negocio_negocio_origem_to_string))
        {
            $values = NegocioOrigem::where('id', 'in', $negocio_negocio_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_origem_to_string = $negocio_negocio_origem_to_string;
        }

        $this->vdata['negocio_negocio_origem_to_string'] = $this->negocio_negocio_origem_to_string;
    }

    public function get_negocio_negocio_origem_to_string()
    {
        if(!empty($this->negocio_negocio_origem_to_string))
        {
            return $this->negocio_negocio_origem_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('negocio_origem_id','{negocio_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_to_string($negocio_funil_to_string)
    {
        if(is_array($negocio_funil_to_string))
        {
            $values = Funil::where('id', 'in', $negocio_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_to_string = $negocio_funil_to_string;
        }

        $this->vdata['negocio_funil_to_string'] = $this->negocio_funil_to_string;
    }

    public function get_negocio_funil_to_string()
    {
        if(!empty($this->negocio_funil_to_string))
        {
            return $this->negocio_funil_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_etapas_to_string($negocio_funil_etapas_to_string)
    {
        if(is_array($negocio_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_etapas_to_string = $negocio_funil_etapas_to_string;
        }

        $this->vdata['negocio_funil_etapas_to_string'] = $this->negocio_funil_etapas_to_string;
    }

    public function get_negocio_funil_etapas_to_string()
    {
        if(!empty($this->negocio_funil_etapas_to_string))
        {
            return $this->negocio_funil_etapas_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_motivo_perda_to_string($negocio_negocio_motivo_perda_to_string)
    {
        if(is_array($negocio_negocio_motivo_perda_to_string))
        {
            $values = NegocioMotivoPerda::where('id', 'in', $negocio_negocio_motivo_perda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_motivo_perda_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_motivo_perda_to_string = $negocio_negocio_motivo_perda_to_string;
        }

        $this->vdata['negocio_negocio_motivo_perda_to_string'] = $this->negocio_negocio_motivo_perda_to_string;
    }

    public function get_negocio_negocio_motivo_perda_to_string()
    {
        if(!empty($this->negocio_negocio_motivo_perda_to_string))
        {
            return $this->negocio_negocio_motivo_perda_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('negocio_motivo_perda_id','{negocio_motivo_perda->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_ativo_to_string($negocio_ativo_to_string)
    {
        if(is_array($negocio_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $negocio_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_ativo_to_string = $negocio_ativo_to_string;
        }

        $this->vdata['negocio_ativo_to_string'] = $this->negocio_ativo_to_string;
    }

    public function get_negocio_ativo_to_string()
    {
        if(!empty($this->negocio_ativo_to_string))
        {
            return $this->negocio_ativo_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_fk_arquivado_to_string($negocio_fk_arquivado_to_string)
    {
        if(is_array($negocio_fk_arquivado_to_string))
        {
            $values = Resposta::where('id', 'in', $negocio_fk_arquivado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_fk_arquivado_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_fk_arquivado_to_string = $negocio_fk_arquivado_to_string;
        }

        $this->vdata['negocio_fk_arquivado_to_string'] = $this->negocio_fk_arquivado_to_string;
    }

    public function get_negocio_fk_arquivado_to_string()
    {
        if(!empty($this->negocio_fk_arquivado_to_string))
        {
            return $this->negocio_fk_arquivado_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('arquivado','{fk_arquivado->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_vendedor_to_string($negocio_vendedor_to_string)
    {
        if(is_array($negocio_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $negocio_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_vendedor_to_string = $negocio_vendedor_to_string;
        }

        $this->vdata['negocio_vendedor_to_string'] = $this->negocio_vendedor_to_string;
    }

    public function get_negocio_vendedor_to_string()
    {
        if(!empty($this->negocio_vendedor_to_string))
        {
            return $this->negocio_vendedor_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_orcamento_to_string($negocio_orcamento_to_string)
    {
        if(is_array($negocio_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $negocio_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->negocio_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_orcamento_to_string = $negocio_orcamento_to_string;
        }

        $this->vdata['negocio_orcamento_to_string'] = $this->negocio_orcamento_to_string;
    }

    public function get_negocio_orcamento_to_string()
    {
        if(!empty($this->negocio_orcamento_to_string))
        {
            return $this->negocio_orcamento_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_negocio_cliente_to_string($negocio_cliente_to_string)
    {
        if(is_array($negocio_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $negocio_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_cliente_to_string = $negocio_cliente_to_string;
        }

        $this->vdata['negocio_cliente_to_string'] = $this->negocio_cliente_to_string;
    }

    public function get_negocio_cliente_to_string()
    {
        if(!empty($this->negocio_cliente_to_string))
        {
            return $this->negocio_cliente_to_string;
        }
    
        $values = Negocio::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_system_unit_to_string($orcamento_system_unit_to_string)
    {
        if(is_array($orcamento_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $orcamento_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->orcamento_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_system_unit_to_string = $orcamento_system_unit_to_string;
        }

        $this->vdata['orcamento_system_unit_to_string'] = $this->orcamento_system_unit_to_string;
    }

    public function get_orcamento_system_unit_to_string()
    {
        if(!empty($this->orcamento_system_unit_to_string))
        {
            return $this->orcamento_system_unit_to_string;
        }
    
        $values = Orcamento::where('vendedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_orcamento_orcamento_situacao_to_string($orcamento_orcamento_situacao_to_string)
    {
        if(is_array($orcamento_orcamento_situacao_to_string))
        {
            $values = OrcamentoSituacao::where('id', 'in', $orcamento_orcamento_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_orcamento_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_orcamento_situacao_to_string = $orcamento_orcamento_situacao_to_string;
        }

        $this->vdata['orcamento_orcamento_situacao_to_string'] = $this->orcamento_orcamento_situacao_to_string;
    }

    public function get_orcamento_orcamento_situacao_to_string()
    {
        if(!empty($this->orcamento_orcamento_situacao_to_string))
        {
            return $this->orcamento_orcamento_situacao_to_string;
        }
    
        $values = Orcamento::where('vendedor_id', '=', $this->id)->getIndexedArray('orcamento_situacao_id','{orcamento_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_vendedor_to_string($orcamento_vendedor_to_string)
    {
        if(is_array($orcamento_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $orcamento_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_vendedor_to_string = $orcamento_vendedor_to_string;
        }

        $this->vdata['orcamento_vendedor_to_string'] = $this->orcamento_vendedor_to_string;
    }

    public function get_orcamento_vendedor_to_string()
    {
        if(!empty($this->orcamento_vendedor_to_string))
        {
            return $this->orcamento_vendedor_to_string;
        }
    
        $values = Orcamento::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_to_string($orcamento_cliente_to_string)
    {
        if(is_array($orcamento_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $orcamento_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_to_string = $orcamento_cliente_to_string;
        }

        $this->vdata['orcamento_cliente_to_string'] = $this->orcamento_cliente_to_string;
    }

    public function get_orcamento_cliente_to_string()
    {
        if(!empty($this->orcamento_cliente_to_string))
        {
            return $this->orcamento_cliente_to_string;
        }
    
        $values = Orcamento::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_contato_to_string($orcamento_cliente_contato_to_string)
    {
        if(is_array($orcamento_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $orcamento_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_contato_to_string = $orcamento_cliente_contato_to_string;
        }

        $this->vdata['orcamento_cliente_contato_to_string'] = $this->orcamento_cliente_contato_to_string;
    }

    public function get_orcamento_cliente_contato_to_string()
    {
        if(!empty($this->orcamento_cliente_contato_to_string))
        {
            return $this->orcamento_cliente_contato_to_string;
        }
    
        $values = Orcamento::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_tabela_preco_to_string($orcamento_tabela_preco_to_string)
    {
        if(is_array($orcamento_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $orcamento_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_tabela_preco_to_string = $orcamento_tabela_preco_to_string;
        }

        $this->vdata['orcamento_tabela_preco_to_string'] = $this->orcamento_tabela_preco_to_string;
    }

    public function get_orcamento_tabela_preco_to_string()
    {
        if(!empty($this->orcamento_tabela_preco_to_string))
        {
            return $this->orcamento_tabela_preco_to_string;
        }
    
        $values = Orcamento::where('vendedor_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_system_unit_to_string($ordem_servico_system_unit_to_string)
    {
        if(is_array($ordem_servico_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_servico_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_system_unit_to_string = $ordem_servico_system_unit_to_string;
        }

        $this->vdata['ordem_servico_system_unit_to_string'] = $this->ordem_servico_system_unit_to_string;
    }

    public function get_ordem_servico_system_unit_to_string()
    {
        if(!empty($this->ordem_servico_system_unit_to_string))
        {
            return $this->ordem_servico_system_unit_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_to_string($ordem_servico_cliente_to_string)
    {
        if(is_array($ordem_servico_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $ordem_servico_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_to_string = $ordem_servico_cliente_to_string;
        }

        $this->vdata['ordem_servico_cliente_to_string'] = $this->ordem_servico_cliente_to_string;
    }

    public function get_ordem_servico_cliente_to_string()
    {
        if(!empty($this->ordem_servico_cliente_to_string))
        {
            return $this->ordem_servico_cliente_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_contato_to_string($ordem_servico_cliente_contato_to_string)
    {
        if(is_array($ordem_servico_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $ordem_servico_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_contato_to_string = $ordem_servico_cliente_contato_to_string;
        }

        $this->vdata['ordem_servico_cliente_contato_to_string'] = $this->ordem_servico_cliente_contato_to_string;
    }

    public function get_ordem_servico_cliente_contato_to_string()
    {
        if(!empty($this->ordem_servico_cliente_contato_to_string))
        {
            return $this->ordem_servico_cliente_contato_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_vendedor_to_string($ordem_servico_vendedor_to_string)
    {
        if(is_array($ordem_servico_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $ordem_servico_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_vendedor_to_string = $ordem_servico_vendedor_to_string;
        }

        $this->vdata['ordem_servico_vendedor_to_string'] = $this->ordem_servico_vendedor_to_string;
    }

    public function get_ordem_servico_vendedor_to_string()
    {
        if(!empty($this->ordem_servico_vendedor_to_string))
        {
            return $this->ordem_servico_vendedor_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_situacao_to_string($ordem_servico_ordem_servico_situacao_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_situacao_to_string))
        {
            $values = OrdemServicoSituacao::where('id', 'in', $ordem_servico_ordem_servico_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_situacao_to_string = $ordem_servico_ordem_servico_situacao_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_situacao_to_string'] = $this->ordem_servico_ordem_servico_situacao_to_string;
    }

    public function get_ordem_servico_ordem_servico_situacao_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_situacao_to_string))
        {
            return $this->ordem_servico_ordem_servico_situacao_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('ordem_servico_situacao_id','{ordem_servico_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_producao_etapa_to_string($ordem_servico_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = $ordem_servico_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_condicao_pagamento_to_string($ordem_servico_condicao_pagamento_to_string)
    {
        if(is_array($ordem_servico_condicao_pagamento_to_string))
        {
            $values = CondicaoPagamento::where('id', 'in', $ordem_servico_condicao_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_condicao_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_condicao_pagamento_to_string = $ordem_servico_condicao_pagamento_to_string;
        }

        $this->vdata['ordem_servico_condicao_pagamento_to_string'] = $this->ordem_servico_condicao_pagamento_to_string;
    }

    public function get_ordem_servico_condicao_pagamento_to_string()
    {
        if(!empty($this->ordem_servico_condicao_pagamento_to_string))
        {
            return $this->ordem_servico_condicao_pagamento_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('condicao_pagamento_id','{condicao_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_endereco_to_string($ordem_servico_cliente_endereco_to_string)
    {
        if(is_array($ordem_servico_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $ordem_servico_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->ordem_servico_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_endereco_to_string = $ordem_servico_cliente_endereco_to_string;
        }

        $this->vdata['ordem_servico_cliente_endereco_to_string'] = $this->ordem_servico_cliente_endereco_to_string;
    }

    public function get_ordem_servico_cliente_endereco_to_string()
    {
        if(!empty($this->ordem_servico_cliente_endereco_to_string))
        {
            return $this->ordem_servico_cliente_endereco_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_usuario_aprovacao_to_string($ordem_servico_usuario_aprovacao_to_string)
    {
        if(is_array($ordem_servico_usuario_aprovacao_to_string))
        {
            $values = SystemUsers::where('id', 'in', $ordem_servico_usuario_aprovacao_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_usuario_aprovacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_usuario_aprovacao_to_string = $ordem_servico_usuario_aprovacao_to_string;
        }

        $this->vdata['ordem_servico_usuario_aprovacao_to_string'] = $this->ordem_servico_usuario_aprovacao_to_string;
    }

    public function get_ordem_servico_usuario_aprovacao_to_string()
    {
        if(!empty($this->ordem_servico_usuario_aprovacao_to_string))
        {
            return $this->ordem_servico_usuario_aprovacao_to_string;
        }
    
        $values = OrdemServico::where('vendedor_id', '=', $this->id)->getIndexedArray('usuario_aprovacao_id','{usuario_aprovacao->name}');
        return implode(', ', $values);
    }

    public function set_parceiro_certificado_venda_modalidade_to_string($parceiro_certificado_venda_modalidade_to_string)
    {
        if(is_array($parceiro_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $parceiro_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_certificado_venda_modalidade_to_string = $parceiro_certificado_venda_modalidade_to_string;
        }

        $this->vdata['parceiro_certificado_venda_modalidade_to_string'] = $this->parceiro_certificado_venda_modalidade_to_string;
    }

    public function get_parceiro_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->parceiro_certificado_venda_modalidade_to_string))
        {
            return $this->parceiro_certificado_venda_modalidade_to_string;
        }
    
        $values = Parceiro::where('vendedor_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_parceiro_tabela_preco_to_string($parceiro_tabela_preco_to_string)
    {
        if(is_array($parceiro_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $parceiro_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_tabela_preco_to_string = $parceiro_tabela_preco_to_string;
        }

        $this->vdata['parceiro_tabela_preco_to_string'] = $this->parceiro_tabela_preco_to_string;
    }

    public function get_parceiro_tabela_preco_to_string()
    {
        if(!empty($this->parceiro_tabela_preco_to_string))
        {
            return $this->parceiro_tabela_preco_to_string;
        }
    
        $values = Parceiro::where('vendedor_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_parceiro_vendedor_to_string($parceiro_vendedor_to_string)
    {
        if(is_array($parceiro_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $parceiro_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->parceiro_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_vendedor_to_string = $parceiro_vendedor_to_string;
        }

        $this->vdata['parceiro_vendedor_to_string'] = $this->parceiro_vendedor_to_string;
    }

    public function get_parceiro_vendedor_to_string()
    {
        if(!empty($this->parceiro_vendedor_to_string))
        {
            return $this->parceiro_vendedor_to_string;
        }
    
        $values = Parceiro::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_parceiro_banco_to_string($parceiro_banco_to_string)
    {
        if(is_array($parceiro_banco_to_string))
        {
            $values = Banco::where('id', 'in', $parceiro_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->parceiro_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_banco_to_string = $parceiro_banco_to_string;
        }

        $this->vdata['parceiro_banco_to_string'] = $this->parceiro_banco_to_string;
    }

    public function get_parceiro_banco_to_string()
    {
        if(!empty($this->parceiro_banco_to_string))
        {
            return $this->parceiro_banco_to_string;
        }
    
        $values = Parceiro::where('vendedor_id', '=', $this->id)->getIndexedArray('banco_id','{banco->nome}');
        return implode(', ', $values);
    }

    public function set_parceiro_chave_pix_tipo_to_string($parceiro_chave_pix_tipo_to_string)
    {
        if(is_array($parceiro_chave_pix_tipo_to_string))
        {
            $values = ChavePixTipo::where('id', 'in', $parceiro_chave_pix_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->parceiro_chave_pix_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->parceiro_chave_pix_tipo_to_string = $parceiro_chave_pix_tipo_to_string;
        }

        $this->vdata['parceiro_chave_pix_tipo_to_string'] = $this->parceiro_chave_pix_tipo_to_string;
    }

    public function get_parceiro_chave_pix_tipo_to_string()
    {
        if(!empty($this->parceiro_chave_pix_tipo_to_string))
        {
            return $this->parceiro_chave_pix_tipo_to_string;
        }
    
        $values = Parceiro::where('vendedor_id', '=', $this->id)->getIndexedArray('chave_pix_tipo_id','{chave_pix_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_situacao_to_string($venda_venda_situacao_to_string)
    {
        if(is_array($venda_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_situacao_to_string = $venda_venda_situacao_to_string;
        }

        $this->vdata['venda_venda_situacao_to_string'] = $this->venda_venda_situacao_to_string;
    }

    public function get_venda_venda_situacao_to_string()
    {
        if(!empty($this->venda_venda_situacao_to_string))
        {
            return $this->venda_venda_situacao_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_orcamento_to_string($venda_orcamento_to_string)
    {
        if(is_array($venda_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $venda_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->venda_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_orcamento_to_string = $venda_orcamento_to_string;
        }

        $this->vdata['venda_orcamento_to_string'] = $this->venda_orcamento_to_string;
    }

    public function get_venda_orcamento_to_string()
    {
        if(!empty($this->venda_orcamento_to_string))
        {
            return $this->venda_orcamento_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_vendedor_to_string($venda_vendedor_to_string)
    {
        if(is_array($venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_vendedor_to_string = $venda_vendedor_to_string;
        }

        $this->vdata['venda_vendedor_to_string'] = $this->venda_vendedor_to_string;
    }

    public function get_venda_vendedor_to_string()
    {
        if(!empty($this->venda_vendedor_to_string))
        {
            return $this->venda_vendedor_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_venda_dispositivos_to_string($venda_dispositivos_to_string)
    {
        if(is_array($venda_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $venda_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->venda_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_dispositivos_to_string = $venda_dispositivos_to_string;
        }

        $this->vdata['venda_dispositivos_to_string'] = $this->venda_dispositivos_to_string;
    }

    public function get_venda_dispositivos_to_string()
    {
        if(!empty($this->venda_dispositivos_to_string))
        {
            return $this->venda_dispositivos_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_to_string($venda_cliente_to_string)
    {
        if(is_array($venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_to_string = $venda_cliente_to_string;
        }

        $this->vdata['venda_cliente_to_string'] = $this->venda_cliente_to_string;
    }

    public function get_venda_cliente_to_string()
    {
        if(!empty($this->venda_cliente_to_string))
        {
            return $this->venda_cliente_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_venda_system_unit_to_string($venda_system_unit_to_string)
    {
        if(is_array($venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_system_unit_to_string = $venda_system_unit_to_string;
        }

        $this->vdata['venda_system_unit_to_string'] = $this->venda_system_unit_to_string;
    }

    public function get_venda_system_unit_to_string()
    {
        if(!empty($this->venda_system_unit_to_string))
        {
            return $this->venda_system_unit_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_filial_saida_to_string($venda_filial_saida_to_string)
    {
        if(is_array($venda_filial_saida_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_filial_saida_to_string)->getIndexedArray('name', 'name');
            $this->venda_filial_saida_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_filial_saida_to_string = $venda_filial_saida_to_string;
        }

        $this->vdata['venda_filial_saida_to_string'] = $this->venda_filial_saida_to_string;
    }

    public function get_venda_filial_saida_to_string()
    {
        if(!empty($this->venda_filial_saida_to_string))
        {
            return $this->venda_filial_saida_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('filial_saida_id','{filial_saida->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_modalidade_to_string($venda_venda_modalidade_to_string)
    {
        if(is_array($venda_venda_modalidade_to_string))
        {
            $values = VendaModalidade::where('id', 'in', $venda_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_modalidade_to_string = $venda_venda_modalidade_to_string;
        }

        $this->vdata['venda_venda_modalidade_to_string'] = $this->venda_venda_modalidade_to_string;
    }

    public function get_venda_venda_modalidade_to_string()
    {
        if(!empty($this->venda_venda_modalidade_to_string))
        {
            return $this->venda_venda_modalidade_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('venda_modalidade_id','{venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_tipo_pagamento_to_string($venda_venda_tipo_pagamento_to_string)
    {
        if(is_array($venda_venda_tipo_pagamento_to_string))
        {
            $values = VendaTipoPagamento::where('id', 'in', $venda_venda_tipo_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_tipo_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_tipo_pagamento_to_string = $venda_venda_tipo_pagamento_to_string;
        }

        $this->vdata['venda_venda_tipo_pagamento_to_string'] = $this->venda_venda_tipo_pagamento_to_string;
    }

    public function get_venda_venda_tipo_pagamento_to_string()
    {
        if(!empty($this->venda_venda_tipo_pagamento_to_string))
        {
            return $this->venda_venda_tipo_pagamento_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('venda_tipo_pagamento_id','{venda_tipo_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_endereco_to_string($venda_cliente_endereco_to_string)
    {
        if(is_array($venda_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $venda_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->venda_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_endereco_to_string = $venda_cliente_endereco_to_string;
        }

        $this->vdata['venda_cliente_endereco_to_string'] = $this->venda_cliente_endereco_to_string;
    }

    public function get_venda_cliente_endereco_to_string()
    {
        if(!empty($this->venda_cliente_endereco_to_string))
        {
            return $this->venda_cliente_endereco_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_venda_tabela_preco_to_string($venda_tabela_preco_to_string)
    {
        if(is_array($venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_tabela_preco_to_string = $venda_tabela_preco_to_string;
        }

        $this->vdata['venda_tabela_preco_to_string'] = $this->venda_tabela_preco_to_string;
    }

    public function get_venda_tabela_preco_to_string()
    {
        if(!empty($this->venda_tabela_preco_to_string))
        {
            return $this->venda_tabela_preco_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_movimentacao_origem_to_string($venda_movimentacao_origem_to_string)
    {
        if(is_array($venda_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $venda_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_movimentacao_origem_to_string = $venda_movimentacao_origem_to_string;
        }

        $this->vdata['venda_movimentacao_origem_to_string'] = $this->venda_movimentacao_origem_to_string;
    }

    public function get_venda_movimentacao_origem_to_string()
    {
        if(!empty($this->venda_movimentacao_origem_to_string))
        {
            return $this->venda_movimentacao_origem_to_string;
        }
    
        $values = Venda::where('vendedor_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_meta_vendedor_venda_meta_to_string($venda_meta_vendedor_venda_meta_to_string)
    {
        if(is_array($venda_meta_vendedor_venda_meta_to_string))
        {
            $values = VendaMeta::where('id', 'in', $venda_meta_vendedor_venda_meta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_meta_vendedor_venda_meta_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_vendedor_venda_meta_to_string = $venda_meta_vendedor_venda_meta_to_string;
        }

        $this->vdata['venda_meta_vendedor_venda_meta_to_string'] = $this->venda_meta_vendedor_venda_meta_to_string;
    }

    public function get_venda_meta_vendedor_venda_meta_to_string()
    {
        if(!empty($this->venda_meta_vendedor_venda_meta_to_string))
        {
            return $this->venda_meta_vendedor_venda_meta_to_string;
        }
    
        $values = VendaMetaVendedor::where('vendedor_id', '=', $this->id)->getIndexedArray('venda_meta_id','{venda_meta->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_meta_vendedor_vendedor_to_string($venda_meta_vendedor_vendedor_to_string)
    {
        if(is_array($venda_meta_vendedor_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_meta_vendedor_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_meta_vendedor_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_vendedor_vendedor_to_string = $venda_meta_vendedor_vendedor_to_string;
        }

        $this->vdata['venda_meta_vendedor_vendedor_to_string'] = $this->venda_meta_vendedor_vendedor_to_string;
    }

    public function get_venda_meta_vendedor_vendedor_to_string()
    {
        if(!empty($this->venda_meta_vendedor_vendedor_to_string))
        {
            return $this->venda_meta_vendedor_vendedor_to_string;
        }
    
        $values = VendaMetaVendedor::where('vendedor_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    
}

