<?php

class ViewNegocioTimeline extends TRecord
{
    const TABLENAME  = 'view_negocio_timeline';
    const PRIMARYKEY = 'chave';
    const IDPOLICY   =  'max'; // {max, serial}

    private $negocio_etapa_historico;
    private $negocio_item;
    private $negocio_atividade;
    private $negocio_nota;
    private $negocio_arquivo;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('negocio_id');
        parent::addAttribute('criado_em');
        parent::addAttribute('tipo');
    
    }

  
  public function get_negocio_etapa_historico()
  {
      if (!$this->negocio_etapa_historico)
      {
          $this->negocio_etapa_historico = NegocioEtapasHistorico::find($this->chave);
      }
  
      return $this->negocio_etapa_historico;
  }
  
  public function get_negocio_item()
  {
      if (!$this->negocio_item)
      {
         $this->negocio_item = NegocioItens::find($this->chave);
      }
  
      return $this->negocio_item;
  }  
  
  public function get_negocio_atividade()
  {
      if (!$this->negocio_atividade)
      {
          $this->negocio_atividade = NegocioAtividade::find($this->chave);
      }
  
      return $this->negocio_atividade;
  }  
  
  public function get_negocio_nota()
  {
      if (!$this->negocio_nota)
      {
          $this->negocio_nota = NegocioNotas::find($this->chave);
      }
  
      return $this->negocio_nota;
  }  
  
  public function get_negocio_arquivo()
  {
      if (!$this->negocio_arquivo)
      {
          $this->negocio_arquivo = NegocioArquivos::find($this->chave);
      }
  
      return $this->negocio_arquivo;
  }  
  
  public function get_titulo()
  {
      if ($this->tipo == 'nota')
      {
          return "<i style='margin-right: 5px;' class='far fa-sticky-note'></i>Nota {$this->chave}";
      }
  
      if ($this->tipo == 'arquivo')
      {
          return "<i style='margin-right: 5px;' class='fas fa-file'></i>Arquivo {$this->chave}";
      }   
  
      if ($this->tipo == 'produto')
      {
        $negocio_item = $this->get_negocio_item();
    
        if (isset($negocio_item->produto->nome))
        {
          $produto_nome = $this->get_negocio_item()->produto->nome;
        }
        else
        {
          $produto_nome = '';
        }          
      
          return "<i style='margin-right: 5px;' class='fas fa-box'></i>{$produto_nome}";
      }  
  
      if ($this->tipo == 'etapa')
      {
            $etapahistorico = $this->get_negocio_etapa_historico();
      
            if (isset($etapahistorico->funil_etapas->cor_etapa))
            {
              $cor_etapa = $etapahistorico->funil_etapas->cor_etapa;
            }
            else
            {
              $cor_etapa = '';
            }
        
            if (isset($etapahistorico->funil_etapas->descricao))
            {
              $descricao_etapa = $etapahistorico->funil_etapas->descricao;
            }
            else
            {
              $descricao_etapa = '';
            }        
        
            return "<span style='margin-right: 5px; width: 30px; height: 15px; display: inline-block;
                   border-radius: 3px; border: 1px solid #555; background: {$cor_etapa}'></span>{$descricao_etapa}";
      }  
  
      if ($this->tipo == 'atividade')
      {
 
        if (isset($this->get_negocio_atividade()->negocio_tipo_atividade->icone))
        {
          $icone = $this->get_negocio_atividade()->negocio_tipo_atividade->icone;
        }
        else
        {
            $icone = '';
        }
    
        if (isset($this->get_negocio_atividade()->negocio_tipo_atividade->cor))
        {
          $cor = $this->get_negocio_atividade()->negocio_tipo_atividade->cor;
        }
        else
        {
          $cor = '';
        }  
    
        if (isset($this->get_negocio_atividade()->negocio_tipo_atividade->descricao))
        {
          $descricao = $this->get_negocio_atividade()->negocio_tipo_atividade->descricao;
        }
        else
        {
          $descricao = '';
        }       
    
        return "<i class='{$icone}' style='color: {$cor}; margin-right: 5px; '></i>{$descricao}";
      }  
  }
  
  public function get_descricao()
  {
  
      $div = "";
  
      if ($this->tipo == 'nota')
      {
          $negocio_nota = $this->get_negocio_nota();
      
          if (isset($negocio_nota->nota))
          {
              $nota = $negocio_nota->nota;
          }
          else
          {
              $nota = '';
          }      
      
          $div = "<b>Descrição: </b>{$nota}";
      }
      elseif ($this->tipo == 'arquivo')
      {
          $negocio_arquivo = $this->get_negocio_arquivo();
      
          if (isset($negocio_arquivo->arquivo))
          {
              $arquivo = $negocio_arquivo->arquivo;
          }
          else
          {
              $arquivo = '';
          }
      
          $div = "<b>Arquivo Adicionado: </b>{$arquivo}";
      
        //   $action = new TAction(['NegocioArquivosHeaderList', 'onShow'], ['key'=>$arquivo->id]);
      
        //   $a = new TElement('a');
        //   $a->class = 'btn btn-link';
        //   $a->generator = 'adianti';
        //   $a->href = $action->serialize();
        //   $a->add($arquivo->arquivo);
      
        //   $div = "{$a}";
      }
      elseif ($this->tipo == 'produto')
      {
         $item = $this->get_negocio_item();
     
         if (isset($item))
         {
             $qtde = number_format($item->quantidade, 2,',','.');
             $valor_unitario = number_format($item->valor_unitario, 2,',','.');
             $desconto = number_format($item->desconto, 2,',','.');
             $valor_total = number_format($item->valor_total, 2,',','.');
         }
         else
         {
             $qtde = number_format(0, 2,',','.');
             $valor_unitario = number_format(0, 2,',','.');
             $desconto = number_format(0, 2,',','.');
             $valor_total = number_format(0, 2,',','.');
         }

         $div = "<b>Quantidade: </b>{$qtde}<br/><b>Valor: </b>R$ {$valor_unitario}<br/><b>Desconto: </b>R$ {$desconto}<br/>
                 <b>Valor Total: </b>R$ {$valor_total}<br/>";
      }  
      elseif ($this->tipo == 'etapa')
      {
        //   $historico = $this->get_negocio_etapa_historico();
      
          $div = "Negócio movimentado";
      }
      elseif ($this->tipo == 'atividade')
      {
        $atividade = $this->get_negocio_atividade();
    
        if (isset($atividade->descricao))
        {
          $descricao = $atividade->descricao;
        }
        else
        {
          $descricao = '';
        }  
    
        if (isset($atividade->observacao))
        {
          $observacao = $atividade->observacao;
        }
        else
        {
          $observacao = '';
        } 
    
        if (isset($atividade->horario_inicial))
        {
          $ini = date('d/m/Y H:i', strtotime($atividade->horario_inicial));
        }
        else
        {
          $ini = '';
        }     
    
        if (isset($atividade->horario_final))
        {
          $fim = date('d/m/Y H:i', strtotime($atividade->horario_final));
        }
        else
        {
          $fim = '';
        }      
    
        // $descricao = $atividade->descricao;
        // $observacao = $atividade->observacao;
    
        // $ini = date('d/m/Y H:i', strtotime($atividade->horario_inicial));
        // $fim = date('d/m/Y H:i', strtotime($atividade->horario_final));
    
        $div = "<b>Descrição: </b>{$descricao}<br/><b>Inicio: </b>{$ini}<br/><b>Fim: </b>{$fim}<br/>{$observacao}<br/>";
      }  
  
      return $div;
  }
  
  
  
    
}

