<?php

class SystemGroup extends TRecord
{
    const TABLENAME  = 'system_group';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'max'; // {max, serial}

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('name');
        parent::addAttribute('uuid');
    
    }

    /**
     * Method getSystemGroupProgramPermissoess
     */
    public function getSystemGroupProgramPermissoess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_group_id', '=', $this->id));
        return SystemGroupProgramPermissoes::getObjects( $criteria );
    }

    public function set_system_group_program_permissoes_system_unit_to_string($system_group_program_permissoes_system_unit_to_string)
    {
        if(is_array($system_group_program_permissoes_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $system_group_program_permissoes_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->system_group_program_permissoes_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_unit_to_string = $system_group_program_permissoes_system_unit_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_unit_to_string'] = $this->system_group_program_permissoes_system_unit_to_string;
    }

    public function get_system_group_program_permissoes_system_unit_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_unit_to_string))
        {
            return $this->system_group_program_permissoes_system_unit_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_group_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_system_group_program_permissoes_system_program_permissoes_to_string($system_group_program_permissoes_system_program_permissoes_to_string)
    {
        if(is_array($system_group_program_permissoes_system_program_permissoes_to_string))
        {
            $values = SystemProgramPermissoes::where('id', 'in', $system_group_program_permissoes_system_program_permissoes_to_string)->getIndexedArray('id', 'id');
            $this->system_group_program_permissoes_system_program_permissoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_program_permissoes_to_string = $system_group_program_permissoes_system_program_permissoes_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_program_permissoes_to_string'] = $this->system_group_program_permissoes_system_program_permissoes_to_string;
    }

    public function get_system_group_program_permissoes_system_program_permissoes_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_program_permissoes_to_string))
        {
            return $this->system_group_program_permissoes_system_program_permissoes_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_group_id', '=', $this->id)->getIndexedArray('system_program_permissoes_id','{system_program_permissoes->id}');
        return implode(', ', $values);
    }

    public function set_system_group_program_permissoes_system_group_to_string($system_group_program_permissoes_system_group_to_string)
    {
        if(is_array($system_group_program_permissoes_system_group_to_string))
        {
            $values = SystemGroup::where('id', 'in', $system_group_program_permissoes_system_group_to_string)->getIndexedArray('name', 'name');
            $this->system_group_program_permissoes_system_group_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_group_to_string = $system_group_program_permissoes_system_group_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_group_to_string'] = $this->system_group_program_permissoes_system_group_to_string;
    }

    public function get_system_group_program_permissoes_system_group_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_group_to_string))
        {
            return $this->system_group_program_permissoes_system_group_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_group_id', '=', $this->id)->getIndexedArray('system_group_id','{system_group->name}');
        return implode(', ', $values);
    }

    /**
     * Add a SystemProgram to the SystemGroup
     * @param $object Instance of SystemProgram
     */
    public function addSystemProgram(SystemProgram $systemprogram)
    {
        if (SystemGroupProgram::where('system_program_id','=',$systemprogram->id)->where('system_group_id','=',$this->id)->count() == 0)
        {
            $object = new SystemGroupProgram;
            $object->system_program_id = $systemprogram->id;
            $object->system_group_id = $this->id;
            $object->store();
        }
    }

    /**
     * Return the SystemProgram's
     * @return Collection of SystemProgram
     */
    public function getSystemPrograms()
    {
        $system_programs = array();
    
        // load the related System_program objects
        $repository = new TRepository('SystemGroupProgram');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_group_id', '=', $this->id));
        $system_group_system_programs = $repository->load($criteria);
        if ($system_group_system_programs)
        {
            foreach ($system_group_system_programs as $system_group_system_program)
            {
                $system_programs[] = new SystemProgram( $system_group_system_program->system_program_id );
            }
        }
    
        return $system_programs;
    }

    /**
     * Reset aggregates
     */
    public function clearParts()
    {
        // delete the related objects
        SystemGroupProgram::where('system_group_id', '=', $this->id)->delete();
        SystemUserGroup::where('system_group_id', '=', $this->id)->delete();
    }

    /**
     * Delete the object and its aggregates
     * @param $id object ID
     */
    public function delete($id = NULL)
    {
        // delete the related System_groupSystem_program objects
        $id = isset($id) ? $id : $this->id;
    
        SystemGroupProgram::where('system_group_id', '=', $id)->delete();
        SystemUserGroup::where('system_group_id', '=', $id)->delete();
    
        // delete the object itself
        parent::delete($id);
    }

    /**
     * Clone the entire object and related ones
     */
    public function cloneGroup()
    {
        $programs = $this->getSystemPrograms();
        $users    = $this->getSystemUsers();
        unset($this->id);
        $this->name .= ' (clone)';
        $this->store();
        if ($programs)
        {
            foreach ($programs as $program)
            {
                $this->addSystemProgram( $program );
            }
        }
        if ($users)
        {
            foreach ($users as $user)
            {
                $this->addSystemUser( $user );
            }
        }
    }
    /**
     * Add a SystemUser to the SystemGroup
     * @param $object Instance of SystemUser
     */
    public function addSystemUser(SystemUsers $systemuser)
    {
        if (SystemUserGroup::where('system_user_id','=',$systemuser->id)->where('system_group_id','=',$this->id)->count() == 0)
        {
            $object = new SystemUserGroup;
            $object->system_user_id  = $systemuser->id;
            $object->system_group_id = $this->id;
            $object->store();
        }
    }
    /**
     * Return the SystemUser's
     * @return Collection of SystemUser
     */
    public function getSystemUsers()
    {
        $system_users = array();
        // load the related System_user objects
        $repository = new TRepository('SystemUserGroup');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_group_id', '=', $this->id));
        $system_group_system_users = $repository->load($criteria);
        if ($system_group_system_users)
        {
            foreach ($system_group_system_users as $system_group_system_user)
            {
                $system_users[] = new SystemUsers( $system_group_system_user->system_user_id );
            }
        }
        return $system_users;
    }

    
}

