<?php

class SystemProgram extends TRecord
{
    const TABLENAME  = 'system_program';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'max'; // {max, serial}

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('name');
        parent::addAttribute('controller');
    
    }

    /**
     * Method getEventoss
     */
    public function getEventoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_program_id', '=', $this->id));
        return Eventos::getObjects( $criteria );
    }
    /**
     * Method getSystemProgramPermissoess
     */
    public function getSystemProgramPermissoess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_program_id', '=', $this->id));
        return SystemProgramPermissoes::getObjects( $criteria );
    }

    public function set_eventos_system_program_to_string($eventos_system_program_to_string)
    {
        if(is_array($eventos_system_program_to_string))
        {
            $values = SystemProgram::where('id', 'in', $eventos_system_program_to_string)->getIndexedArray('name', 'name');
            $this->eventos_system_program_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_system_program_to_string = $eventos_system_program_to_string;
        }

        $this->vdata['eventos_system_program_to_string'] = $this->eventos_system_program_to_string;
    }

    public function get_eventos_system_program_to_string()
    {
        if(!empty($this->eventos_system_program_to_string))
        {
            return $this->eventos_system_program_to_string;
        }
    
        $values = Eventos::where('system_program_id', '=', $this->id)->getIndexedArray('system_program_id','{system_program->name}');
        return implode(', ', $values);
    }

    public function set_eventos_email_template_to_string($eventos_email_template_to_string)
    {
        if(is_array($eventos_email_template_to_string))
        {
            $values = EmailTemplate::where('id', 'in', $eventos_email_template_to_string)->getIndexedArray('titulo', 'titulo');
            $this->eventos_email_template_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_email_template_to_string = $eventos_email_template_to_string;
        }

        $this->vdata['eventos_email_template_to_string'] = $this->eventos_email_template_to_string;
    }

    public function get_eventos_email_template_to_string()
    {
        if(!empty($this->eventos_email_template_to_string))
        {
            return $this->eventos_email_template_to_string;
        }
    
        $values = Eventos::where('system_program_id', '=', $this->id)->getIndexedArray('email_template_id','{email_template->titulo}');
        return implode(', ', $values);
    }

    public function set_system_program_permissoes_system_program_to_string($system_program_permissoes_system_program_to_string)
    {
        if(is_array($system_program_permissoes_system_program_to_string))
        {
            $values = SystemProgram::where('id', 'in', $system_program_permissoes_system_program_to_string)->getIndexedArray('name', 'name');
            $this->system_program_permissoes_system_program_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_program_permissoes_system_program_to_string = $system_program_permissoes_system_program_to_string;
        }

        $this->vdata['system_program_permissoes_system_program_to_string'] = $this->system_program_permissoes_system_program_to_string;
    }

    public function get_system_program_permissoes_system_program_to_string()
    {
        if(!empty($this->system_program_permissoes_system_program_to_string))
        {
            return $this->system_program_permissoes_system_program_to_string;
        }
    
        $values = SystemProgramPermissoes::where('system_program_id', '=', $this->id)->getIndexedArray('system_program_id','{system_program->name}');
        return implode(', ', $values);
    }

    /**
     * Find program by controller
     */
    public static function findByController($controller)
    {
        $objects = SystemProgram::where('controller', '=', $controller)->load();
        if (count($objects)>0)
        {
            return $objects[0];
        }
    }

    /**
     * Add a SystemGroup to the SystemProgram
     * @param $object Instance of SystemGroup
     */
    public function addSystemGroup(SystemGroup $systemgroup)
    {
        $object = new SystemGroupProgram;
        $object->system_program_id = $this->id;
        $object->system_group_id = $systemgroup->id;
        $object->store();
    }

    /**
     * Return the SystemGroup's
     * @return Collection of SystemGroup
     */
    public function getSystemGroups()
    {
        $system_groups = array();
    
        // load the related System_program objects
        $system_group_system_programs = SystemGroupProgram::where('system_program_id', '=', $this->id)->load();
    
        if ($system_group_system_programs)
        {
            foreach ($system_group_system_programs as $system_group_system_program)
            {
                $system_groups[] = new SystemGroup( $system_group_system_program->system_group_id );
            }
        }
    
        return $system_groups;
    }

    /**
     * Reset aggregates
     */
    public function clearParts()
    {
        // delete the related objects
        SystemGroupProgram::where('system_program_id', '=', $this->id)->delete();
    }

    /**
     * Delete the object and its aggregates
     * @param $id object ID
     */
    public function delete($id = NULL)
    {
        // delete the related System_groupSystem_program objects
        $id = isset($id) ? $id : $this->id;
    
        SystemGroupProgram::where('system_program_id', '=', $id)->delete();
        SystemUserProgram::where('system_program_id', '=', $id)->delete();
    
        // delete the object itself
        parent::delete($id);
    }

}

