<?php

class NuvemFiscal
{
    
    public static function MontaApresentacaoRetorno($retorno){
        
        if(isset($retorno->error->code)){
            $mensagem  = "<b>Erro: </b>".$retorno->error->message."<br>";
        }else{
            $mensagem  = "<b>ID: </b>".$retorno->id."<br>";
            $mensagem .= "<b>Ambiente: </b>".$retorno->ambiente."<br>";
            $mensagem .= "<b>Data emissão: </b>".$retorno->data_emissao."<br>";
            $mensagem .= "<b>Modelo: </b>".$retorno->modelo."<br>";
            $mensagem .= "<b>Número: </b>".$retorno->numero."<br>";
            $mensagem .= "<b>Série: </b>".$retorno->serie."<br>";
            $mensagem .= "<b>Chave: </b>".$retorno->chave."<br>";
            $mensagem .= "<b>Protocolo: </b>".$retorno->protocolo."<br>";
            $mensagem .= "<b>Status: </b>".$retorno->status."<br>";
            $mensagem .= "<b>Status Autorização: </b>".$retorno->autorizacao->status."<br>";
            $mensagem .= "<b>Código: </b>".$retorno->autorizacao->codigo_status."<br>";
            $mensagem .= "<b>Motivo: </b>".$retorno->autorizacao->motivo_status."<br>";
            $mensagem .= "<b>ID: </b>".$retorno->autorizacao->id."<br>";
            $mensagem .= "<b>Nº Sequencial: </b>".$retorno->autorizacao->numero_sequencial."<br>";
            $mensagem .= "<b>Chave: </b>".$retorno->autorizacao->chave_acesso."<br>";
            $mensagem .= "<b>Tipo de evento: </b>".$retorno->autorizacao->tipo_evento."<br>";
            $mensagem .= "<b>Data recebimento: </b>".$retorno->autorizacao->data_recebimento."<br>";
            $mensagem .= "<b>Data evento: </b>".$retorno->autorizacao->data_evento."<br>";
        }
        
        return $mensagem;
        
    }
    
    public static function ValidaCampoNulo($valor){
        return !is_null($valor) ? $valor : "";    
    }   
    
    public static function RetornaURL(){
        return "https://api.sandbox.nuvemfiscal.com.br"; 
        
        // return "https://api.nuvemfiscal.com.br"; 
    }
    
    public function RetornaToken()
    {
        $url = "https://auth.nuvemfiscal.com.br/oauth/token";
       
        $curl = curl_init();
        
        // $dados = json_encode($dados);
        
        $client_id = "PeycanUQY77BG8gXy715";
        $client_secret = "aXx4ZhxwWpS2VB8y73mFtXkNAslfkitY6qnhUBPA";
        
       // https://auth.nuvemfiscal.com.br/oauth/token/grant_type=client_credentials&client_id=PeycanUQY77BG8gXy715&client_secret=aXx4ZhxwWpS2VB8y73mFtXkNAslfkitY6qnhUBPA&scope=cep%20cnpj%20nfse%20mdfe

        $post = "grant_type=client_credentials&client_id=$client_id&client_secret=$client_secret&scope=mdfe%20nfe";
        
        curl_setopt_array($curl, array(
          CURLOPT_URL => $url,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLINFO_HEADER_OUT => true,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'POST',
          CURLOPT_POSTFIELDS => $post,
          CURLOPT_HTTPHEADER => array(
            'Host: auth.nuvemfiscal.com.br',
            'Content-Type: application/x-www-form-urlencoded'
          ),
        ));
        
        $response = curl_exec($curl);
        
        // echo "<pre>";
        // var_dump(curl_getinfo($curl));
        // echo "</pre>";
        
        // echo "<pre>";
        // var_dump($response);
        // echo "</pre>";
        
        curl_close($curl);
        
        $response = json_decode($response);
        
        return $response->access_token;
        
    
    }    

    // public static function RetornaToken(){
        
    //     return "aXx4ZhxwWpS2VB8y73mFtXkNAslfkitY6qnhUBPA";
    //     // return "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJpYXQiOjE1ODU0NTIzMzMsInRlbmFudF9pZCI6IkFudG9uaW8gQ2FybG9zIzQ3ODYifQ.c_P-Ed6PW_qSlEZUYCRukCQi9LbDTNRPtVuZsuHcbRI";    
    // }
    
    public function ConsultaCnpj($cnpj)
    {
        $url = self::RetornaURL();
        $token = self::RetornaToken();
        
        var_dump($token);
        
        $curl = curl_init();
        
        curl_setopt_array($curl, array(
          CURLOPT_URL => $url.'/cnpj/'.$cnpj,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'GET',
          CURLOPT_HTTPHEADER => array(
            'Authorization: Bearer '.$token
          ),
        ));
        
        $response = curl_exec($curl);
        
        curl_close($curl);
        
        return json_decode($response);
        
    }

    public function ExecutarGet($get)
    {
        $url = self::RetornaURL();
        $token = self::RetornaToken();
        
        $curl = curl_init();
        
        curl_setopt_array($curl, array(
          CURLOPT_URL => $url.$get,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'GET',
          CURLOPT_HTTPHEADER => array(
            'Authorization: Bearer '.$token
          ),
        ));
        
        $response = curl_exec($curl);
        
        curl_close($curl);
        
        return json_decode($response);
        
    }

    public function ExecutarPost($post, $dados)
    {
        $url = self::RetornaURL();
        $token = self::RetornaToken();
        
        $curl = curl_init();
        
        $dados = json_encode($dados);
        
        curl_setopt_array($curl, array(
          CURLOPT_URL => $url.$post,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'POST',
          CURLOPT_POSTFIELDS => $dados,
          CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json',
            'Accept: application/json',
            'Authorization: Bearer '.$token
          ),
        ));
        
        $response = curl_exec($curl);
        
        echo "<pre>";
        var_dump($response);
        echo "</pre>";
        
        curl_close($curl);
        
        return json_decode($response);
    }
    
    public static function CadastrarAtualizarEmpresa($id){
        
        $filial = SystemUnit::find($id);
        
        $data_atual = date("Y-m-d\TH:s:sP", strtotime(date('Y-m-d')));
        
        $dados = [    "cpf_cnpj" => $filial->cnpj,
                      "created_at" => $data_atual,
                      "updated_at" => $data_atual,
                      "inscricao_estadual" => $filial->inscricao_estadual,
                      "inscricao_municipal" => $filial->inscricao_municipal,
                      "nome_razao_social" => $filial->razao_social,
                      "nome_fantasia" => $filial->name,
                      "fone" => $filial->fone,
                      "email" => $filial->email,
                      "endereco" => [
                        "logradouro" => $filial->end_logradouro,
                        "numero" => $filial->end_numero,
                        "complemento" => $filial->end_complemento,
                        "bairro" => $filial->end_bairro,
                        "codigo_municipio" => trim($filial->end_mun_codibge),
                        "cidade" => $filial->end_municipio,
                        "uf" => $filial->end_uf,
                        "codigo_pais" => "1052",
                        "pais" => "Brasil",
                        "cep" => $filial->end_cep
                      ],
                      "optante_simples_nacional" => $filial->notafiscal_crt->valor == '1' ? true : false,
                      "regime_tributacao" => 0,
                      "regime_especial_tributacao" => 0,
                      "incentivo_fiscal" => true,
                      "incentivador_cultural" => true,
                      "nfe" => [
                        "ambiente" => "homologacao"
                      ],
                    //   "nfce" => [
                    //     "sefaz" => [
                    //       "id_csc" => 0,
                    //       "csc" => "string"
                    //     ],
                    //     "ambiente" => "homologacao"
                    //   ],
                      "mdfe" => [
                        "ambiente" => "homologacao"
                      ],
                    //   "cte" => [
                    //     "ambiente" => "homologacao"
                    //   ],
                    //   "cte_os" => [
                    //     "ambiente" => "homologacao"
                    //   ],
                    //   "nfse" => [
                    //     "rps" => [
                    //       "lote" => 0,
                    //       "serie" => "string",
                    //       "numero" => 0
                    //     ],
                    //     "prefeitura" => [
                    //       "login" => "string",
                    //       "senha" => "string",
                    //       "token" => "string"
                    //     ],
                    //     "ambiente" => "homologacao"
                    //   ]    
        ];
        
        var_dump($dados);
        
        $retorno = NuvemFiscal::ExecutarPost("/empresas", $dados);
        

    }
    
    public static function VincularCertificado($id){
        try {
            $filial = SystemUnit::find($id);
            
            if(!file_exists($filial->certificadoA1)){
                throw new Exception("Certificado não encontrado.");
            }
            
            $dados = [    "certificado" => base64_encode(file_get_contents($filial->certificadoA1)),
                          "password" => $filial->senha_certificado,
            ];
            
            $cnpj = Funcoes::sonumeros($filial->cnpj); 
            
            $retorno = NuvemFiscal::ExecutarPost("/empresas/$cnpj/certificado", $dados);
            
            echo "<pre>";
            var_dump($retorno);
            echo "</pre>";
            
        } catch (Exception $e) {
            new TMessage('error', $e->getMessage());
        }
        
    }
    
}
