<?php

class TabelaPrecoProdutoRestService extends AdiantiRecordService
{
    const DATABASE      = 'kraftsoft';
    const ACTIVE_RECORD = 'TabelaPrecoProduto';
    const ATTRIBUTES    = ['alterado_em','alterado_por','criado_em','criado_por','deletado_em','id','preco_venda','produto_filial_id','tabela_preco_id','valor_parametro'];
    
    
    public static function ObterTabelaPrecoProdutosFilial($param)
    {
        TTransaction::open('kraftsoft');
        $conn = TTransaction::get();
        
        $lista_tabpreco_produtos = $conn->query('SELECT * from tabela_preco_produto order by id');
        
        $itens = array();

        foreach ($lista_tabpreco_produtos as $tabpreco_produto) 
        {
            
            $produtofilial = ProdutoFilial::find($tabpreco_produto['produto_filial_id']);
            
            if ($produtofilial)
            {
                //só incluir se for da filial solicitada
                if ($produtofilial->system_unit_id == $param['system_unit_id']) 
                {
                    array_push($itens, ['id' => $tabpreco_produto['id'],
                                        'tabela_preco_id' => $tabpreco_produto['tabela_preco_id'],
                                        'produto_id' => $produtofilial->produto_id,
                                        'preco_venda' => (isset($tabpreco_produto['preco_venda'])) ? $tabpreco_produto['preco_venda'] : 0,
                                        'valor_parametro' => $tabpreco_produto['valor_parametro']]);
                }
            }
        }

        TTransaction::close();
        
        return $itens;
    }       
    
    
    
    
    
    /**
     * load($param)
     *
     * Load an Active Records by its ID
     * 
     * @return The Active Record as associative array
     * @param $param['id'] Object ID
     */
    
    
    /**
     * delete($param)
     *
     * Delete an Active Records by its ID
     * 
     * @return The Operation result
     * @param $param['id'] Object ID
     */
    
    
    /**
     * store($param)
     *
     * Save an Active Records
     * 
     * @return The Operation result
     * @param $param['data'] Associative array with object data
     */
    
    
    /**
     * loadAll($param)
     *
     * List the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['offset']    Query offset
     *        $param['limit']     Query limit
     *        $param['order']     Query order by
     *        $param['direction'] Query order direction (asc, desc)
     *        $param['filters']   Query filters (array with field,operator,field)
     */
    
    
    /**
     * deleteAll($param)
     *
     * Delete the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['filters']   Query filters (array with field,operator,field)
     */
}
