<?php

class API_MDFe
{
    public static function RetornaAPIPadrao()
    {
       $filial = SystemUnit::find(TSession::getValue('userunitid'));    
       
       if ($filial->mdfe_api_documentos_id==0)
       {
          throw new exception('API de MDF-e não configurada para esta filial!');           
       }
       else
       {
          return $filial->mdfe_api_documentos;
       }

    }
    
    
    public static function Consulta($mdfe)
    {
        $mdfe_api_documentos = self::RetornaAPIPadrao();
        
        switch ($mdfe_api_documentos->integradores_id) 
        {
            case  Integradores::CloudDfe :
            {    
                return cloudDFe_MDFe::Consulta($mdfe);
                
                break;
            }
            case  Integradores::NuvemFiscal :
            {    
                return NuvemFiscal_MDFe::Consulta($mdfe);
                
                break;
            }            
        }                   
    }
    
    public static function Cancelar($mdfe, $justificativa)
    {
        $mdfe_api_documentos = self::RetornaAPIPadrao();
        
        switch ($mdfe_api_documentos->integradores_id) 
        {
            case  Integradores::CloudDfe :
            {    
                return cloudDFe_MDFe::Cancelar($mdfe, $justificativa);
                
                break;
            }
            case  Integradores::NuvemFiscal :
            {    
                return NuvemFiscal_MDFe::Cancelar($mdfe, $justificativa);
                
                break;
            }            
        }        
    }
    
    public static function IncluirDfe($id)
    {
        
    }
    
    public static function Encerra($mdfe)
    {
        // if (!isset($mdfe->api_documentos->integradores_id))
        // {
        //   throw new Exception('API de integração não encontrada!');             
        // }

        switch ($mdfe->api_documentos->integradores_id) 
        {
            case  Integradores::CloudDfe :
            {    
                return cloudDFe_MDFe::Encerra($mdfe);
                
                break;
            }
            case  Integradores::NuvemFiscal :
            {    
                return NuvemFiscal_MDFe::Encerra($mdfe);
                
                break;
            }            
        }             
    }    
    
    public static function XML($mdfe)
    {
        switch ($mdfe->api_documentos->integradores_id) 
        {
            case  Integradores::CloudDfe :
            {    
                return cloudDFe_MDFe::XML($mdfe);
                
                break;
            }
            case  Integradores::NuvemFiscal :
            {    
                return NuvemFiscal_MDFe::XML($mdfe);
                
                break;
            }            
        }              
    }   
    
    public static function PDF($mdfe)
    {
        switch ($mdfe->api_documentos->integradores_id) 
        {
            case  Integradores::CloudDfe :
            {    
                return cloudDFe_MDFe::PDF($mdfe);
                
                break;
            }
            case  Integradores::NuvemFiscal :
            {    
                return NuvemFiscal_MDFe::PDF($mdfe);
                
                break;
            }            
        }              
    }       
    
    public static function Enviar($mdfe)
    {
        $mdfe_api_documentos = self::RetornaAPIPadrao();
        
        switch ($mdfe_api_documentos->integradores_id) 
        {
            case  Integradores::CloudDfe :
            {    
                return cloudDFe_MDFe::Enviar($mdfe, $mdfe_api_documentos);
                
                break;
            }
            case  Integradores::NuvemFiscal :
            {    
                return NuvemFiscal_MDFe::Enviar($mdfe, $mdfe_api_documentos);
                
                break;
            }      
            
//            case  Integradores::SpedNFE :
  //          {    
    //            return SpedNFe::Enviar($mdfe, $mdfe_api_documentos);
                
      //          break;
        //    }      
            
            
        }
    }
    
    public static function formataRetorno($resp)
    {
        $mdfe_api_documentos = self::RetornaAPIPadrao();
        
        switch ($mdfe_api_documentos->integradores_id) 
        {
            case  Integradores::CloudDfe :
            {    
                return cloudDFe_MDFe::formataRetorno($resp);
                
                break;
            }
            case  Integradores::NuvemFiscal :
            {    
                return NuvemFiscal_MDFe::formataRetorno($resp);
                
                break;
            }            
        }        
    }
    
  
    
}
