<?php

class funcaoNFE
{
    public static function DuplicarNota($id)
    {
        
        $nota = Notafiscal::find($id);
        
        if($nota)
        {
            
            $id_nota = $nota->id;
            
            $nova_nota = $nota;

            $serie = NotafiscalSeries::where('notafiscal_tpamb_id', '=', $nota->notafiscal_tpamb_id)
                                     ->where('notafiscal_mod_id', '=', $nota->notafiscal_mod_id)
                                     ->where('notafiscal_tipodocumento_id', '=', $nota->nf_tipodocumento_id)
                                     ->where('serie', '=', $nota->serie)
                                     ->where('system_unit_id', '=', $nota->system_unit_id)
                                     ->first();
            if($serie)
            {
                $numero = $serie->sequencial + 1;

                $nova_nota->numero = $numero;

                if($serie){
                    $serie->sequencial =  $numero;
                    $serie->store();
                }

            }else{
                throw new Exception('Série da nota não configurada para a filial!');
            }
            
            
            $nova_nota->id = null;
            $nova_nota->criado_em = date('Y-m-d H:i:s');
            $nova_nota->data_emissao = date('Y-m-d H:i:s');
            $nova_nota->data_saida = date('Y-m-d H:i:s');
            $nova_nota->alterado_em = null;
            $nova_nota->notafiscal_situacao_id = NotafiscalSituacao::EmDigitacao;
            $nova_nota->justificativa_cancelamento = null;
            $nova_nota->chave = null;
            $nova_nota->protocolo_envio = null;
            $nova_nota->protocolo_cancelamento = null;
            $nova_nota->datahora_cancelamento = null;
            $nova_nota->xml = null;
            $nova_nota->data_hora_envio = null;
            $nova_nota->xml_cancelamento = null;
            $nova_nota->status = null;
            $nova_nota->mensagem = null;
            $nova_nota->cce_xml = null;
            $nova_nota->cce_pdf = null;
            $nova_nota->codigo_sefaz = null;
            $nova_nota->sn_carta_correcao = 'N';            
            
            $nova_nota->store();   
            
            $itens_nota = NotafiscalDup::where('notafiscal_id', '=', $id_nota)->load();
            //carrega os dados de duplicatas
            foreach($itens_nota as $item){
                $novo_item = $item;
                $novo_item->notafiscal_id = $nova_nota->id;
                
                $novo_item->id = null;
                
                $novo_item->store();    
            }
        
            $itens_nota = NotafiscalPag::where('notafiscal_id', '=', $id_nota)->load();
            //carrega os dados de pagamento
            foreach($itens_nota as $item){
                $novo_item = $item;
                $novo_item->notafiscal_id = $nova_nota->id;
                
                $novo_item->id = null;
                
                $novo_item->store();    
            }

            $itens_nota = NotafiscalRefecf::where('notafiscal_id', '=', $id_nota)->load();
            //carrega os dados de ecfs
            foreach($itens_nota as $item){
                $novo_item = $item;
                $novo_item->notafiscal_id = $nova_nota->id;
                
                $novo_item->id = null;
                
                $novo_item->store();    
            }
        
            $itens_nota = NotafiscalRefnfe::where('notafiscal_id', '=', $id_nota)->load();
            //carrega os dados de nfe
            foreach($itens_nota as $item){
                $novo_item = $item;
                $novo_item->notafiscal_id = $nova_nota->id;
                
                $novo_item->id = null;
                
                $novo_item->store();    
            }

            $itens_nota = NotafiscalFreteVolumes::where('notafiscal_id', '=', $id_nota)->load();
            
            //carrega os dados de volumes
            foreach($itens_nota as $item){
                $novo_item = $item;
                $novo_item->notafiscal_id = $nova_nota->id;
                
                $novo_item->id = null;
                
                $novo_item->store();    
            }
            
            $itens_nota = NotafiscalItens::where('notafiscal_id', '=', $id_nota)->load();
            //carrega os dados de items
            foreach($itens_nota as $item){
                $novo_item = $item;
                $novo_item->notafiscal_id = $nova_nota->id;
                
                $novo_item->id = null;
                
                $novo_item->store();  
                
            }
        
        }        
    }
    
    public static function salvarLog($idnfe, $descricao)
    {
        $log = new NotafiscalLogs();
        $log->notafiscal_id = $idnfe;
        $log->descricao = $descricao;
        $log->system_users_id = TSession::getValue('userid');
        
        Funcoes::SalvarUsuarioCadastro($log);

        $log->store();
    }
    

    public static function buscarDadosCFOP($filial_id, $tipooperacao)
    {
        try 
        {

            $unidade = SystemUnit::find($filial_id);
            
            if($unidade)
            {
                if($tipooperacao == NotafiscalMod::NFe){
                    $cfop_id = $unidade->vendas_natureza_operacao_id;    
                }else{
                    $cfop_id = $unidade->nfce_natureza_operacao_id;
                }
                
                $natureza = NaturezaOperacao::find($cfop_id);
            }

            if($natureza)
            {
                return $natureza;
            }
            
            return null;
            
            
        }catch (Exception $e) {
            
        }    
    }
    
    public static function VerificaExcecaoNatureza($notafiscal_id, $produto_id, $origem_id, $ncm, $modulo = 'vendas')
    {
        try 
        {
            if ($modulo == 'vendas')
            {
                $notafiscal = Notafiscal::find($notafiscal_id);
                
                //pegar a natureza da nota
                // $natureza = self::buscarDadosCFOP($notafiscal->system_unit_id,
                                                //   $notafiscal->notafiscal_mod_id);
                                                
                  $natureza = NaturezaOperacao::find($notafiscal->natureza_operacao_id);
            }
            else
            {
                $notafiscal = NotaFiscalCompra::find($notafiscal_id);
                $filial = SystemUnit::find(TSession::getValue('userunitid'));
                $natureza = NaturezaOperacao::find($filial->natureza_operacao_compra_id);
            }
            
            //ver se existe exceção de ICMS...
            $natopexcecaoICMS = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $natureza->id)
                                                        ->where('natop_excecao_tributo_id','=', NatopExcecaoTributo::ICMS)->first();
                                                        
            if ($natopexcecaoICMS)
            {
                //ver se o estado do cliente está na lista
                
                //obtendo o id do estado pela sigla
                $estado = Estado::where('sigla', '=', $notafiscal->cliente_estado)->first();
                $temestado = false;
                
                if ($estado)
                {
                    $natopestados = NaturezaOperacaoEstados::where('natureza_operacao_excecao_id', '=', $natopexcecaoICMS->id)
                                                           ->where('estado_id', '=', $estado->id)->first();
                    if ($natopestados)
                    {
                        $temestado = true;
                    }
                    else
                    {
                        $temestado = false;
                    }
                }
            
                //ver se o produto está na lista
                $natopproduto = NaturezaOperacaoProdutos::where('natureza_operacao_excecao_id', '=', $natopexcecaoICMS->id)
                                                        ->where('produto_id', '=', $produto_id)->first();
                if ($natopproduto)
                {
                    $temproduto = true;
                }
                else
                {
                    $temproduto = false;
                }                
            
                // ver se a oritem está na lista
                $natoporigem = NaturezaOperacaoOrigens::where('natureza_operacao_excecao_id', '=', $natopexcecaoICMS->id)
                                                      ->where('notafiscal_item_orig_id', '=', $origem_id)->first();
                if ($natoporigem)
                {
                    $temorigem = true;
                }
                else
                {
                    $temorigem = false;
                }
             
                //ver se o ncm está na lista
                $natopNCM = NaturezaOperacaoNcm::where('natureza_operacao_excecao_id', '=', $natopexcecaoICMS->id)
                                                ->where('ncm', '=', $ncm)->first();
                if ($natopNCM)
                {
                    $temNCM = true;
                }
                else
                {
                    $temNCM = false;
                }          
                
                //REALIZANDO A APURAÇÃO....
                if ($temestado==true or $temproduto==true or $temorigem==true or $temNCM==true)
                {
                    return $natopexcecaoICMS;
                }
            }
            
            
            
        }catch (Exception $e) {
            
        }    
    }
    
    public static function geraNotaVenda($venda_id, $tiponota) 
    {
        
        try 
        {

            $objeto = Notafiscal::where('venda_id',  '=', $venda_id)->first();
            
            if($objeto)
            {
                if ($objeto->notafiscal_situacao_id!=NotafiscalSituacao::Cancelada)
                {
                  throw new Exception("Já existe uma nota fiscal desta venda! Nota Número: ".$objeto->numero);   
                }
            }

            $venda = Venda::find($venda_id);
            
            if(!$venda){
                throw new Exception("Venda não encontrada!");    
            }
            
            $filial = SystemUnit::find($venda->system_unit_id);
            
            if($tiponota == NotafiscalMod::NFe)
            {

                if($filial->nfe_tpamb_id == NotafiscalTpamb::Producao)
                {
                    $serie = $filial->nfe_producao_series->serie;
                }
                else
                {
                    $serie = $filial->nfe_homologacao_series->serie;
                }
            }
            else
            {
                if($filial->nfce_tpamb_id == NotafiscalTpamb::Producao)
                {
                    $serie = $filial->nfce_producao_series->serie;
                }
                else
                {
                    $serie = $filial->nfce_homologacao_series->serie;
                }
            }
            
            $natureza = funcaoNFE::buscarDadosCFOP($venda->system_unit_id, $tiponota);

            if(!is_null($natureza))
            {
                // $natureza_descricao = $natureza->descricao;
                
                $cliente_endereco = ClienteEndereco::where('cliente_id', '=', $venda->cliente_id)
                                                    ->where('principal', '=', '1')->first();
                
                if ($cliente_endereco)
                {
                    $cliente_estado = $cliente_endereco->cidade->estado->sigla;
                }
                else
                {
                  throw new Exception("Endereço do cliente não encontrado! Revise o cadastro dele para gerar a nota.");  
                }
                
                $cfop = NaturezaOperacao::ObterCFOPItem($cliente_estado,$filial->end_uf,$natureza);
                
                $icms_cst = NaturezaOperacao::ObterCSTItem($venda->cliente->notafiscal_indiedest_id,$natureza);//  $natureza->cst_icms->cst_numero; 
                $pis_cst = $natureza->cst_pis->cst_numero;
                $cofins_cst = $natureza->cst_cofins->cst_numero;
                $ipi_cst = $natureza->cst_ipi->cst_numero;                
                $icms_aliquota = $natureza->icms_aliquota;
                $ipi_aliquota = $natureza->ipi_aliquota;
                $pis_aliquota = $natureza->pis_aliquota;
                $cofins_aliquota = $natureza->cofins_aliquota;
                $pis_valor_base = $natureza->pis_base;
                $cofins_valor_base = $natureza->cofins_base;
                $icms_predbc = $natureza->icms_pRedBC;
                $icms_basecalc = $natureza->icms_base;
                $icms_pst = $natureza->icms_pST;
                $icms_pcredsn = $natureza->icms_pCredSN;
                $icms_pmvast = $natureza->icms_pMVAST;
                $icms_picmsst = $natureza->icms_pICMSST;
                $icms_vbcst = $natureza->icms_baseST;

                $notafiscal_item_modbc_id = $natureza->notafiscal_item_modbc_id;
                $notafiscal_item_modbcst_id = $natureza->notafiscal_item_modbcst_id;
                $notafiscal_item_motDesICMS_id = $natureza->notafiscal_item_motDesICMS_id;
            }            

            $numero_nota = self::ObterProximoSequencialNotaSerie($filial->nfe_tpamb_id,
                                                                 $tiponota,
                                                                 NotafiscalTipodocumento::Saida,
                                                                 $serie,
                                                                 TSession::getValue('userunitid'));
            
            $nfe = new Notafiscal();
            $nfe->system_unit_id = $venda->system_unit_id;
            $nfe->movimentacao_origem_id = MovimentacaoOrigem::kraftweb;
            $nfe->cliente_id = $venda->cliente_id;
            $nfe->venda_id = $venda->id;
            $nfe->numero = $numero_nota;
            $nfe->data_emissao = date('Y-m-d H:i');
            $nfe->data_saida = date('Y-m-d H:i');
            $nfe->natureza_operacao_id = $natureza->id; 
            $nfe->serie = $serie; 
            // $nfe->icms_basecalc = 0;
            // $nfe->icms_valor = 0;
            // $nfe->icms_subst_base_calc = 0;
            // $nfe->icms_subst_valor = 0;
            // $nfe->frete_valor = $venda->frete_total;
            // $nfe->seguro_valor = 0;
            // $nfe->outras_despesas = 0;
            // $nfe->ipi_valor = 0;
            // $nfe->valor_total_produtos = $venda->valor_produtos;
            // $nfe->valor_total_nota = $venda->valor_total;
    
            // $nfe->transp_nome = '1';
            // $nfe->transp_cnpj = '1';
            // $nfe->transp_inscest = '1';
            // $nfe->transp_endereco = '1';
            // $nfe->transp_cidade = '1';
            // $nfe->transp_placaveiculo = '1';
            // $nfe->transp_uf = '1';
            // $nfe->transp_veiculouf = '1';
            // $nfe->transp_veiculoRNTC = '1';
            // $nfe->transp_numeracao = '1';
    
            $nfe->nf_tipodocumento_id = NotafiscalTipodocumento::Saida;
            $nfe->notafiscal_situacao_id = NotafiscalSituacao::EmDigitacao;
            $nfe->notafiscal_crt_id = $venda->system_unit->notafiscal_crt_id;
            $nfe->notafiscal_indiedest_id = $venda->cliente->notafiscal_indiedest_id;
            
            if ($cliente_estado<>$filial->end_uf)
            {
                $nfe->notafiscal_iddest_id = NotafiscalIddest::OperacaoInterestadual;
            }
            else
            {
                $nfe->notafiscal_iddest_id = NotafiscalIddest::OperacaoInterna;
            }
            
            $nfe->notafiscal_tpimp_id = $tiponota; 
            $nfe->notafiscal_tpemis_id = NotafiscalTpemis::Normal;
            $nfe->notafiscal_finnfe_id = NotafiscalFinnfe::NfeNormal;
            $nfe->notafiscal_indfinal_id = NotafiscalIndfinal::Sim;
            $nfe->notafiscal_indpres_id = NotafiscalIndpres::NaoSeAplica;
            $nfe->verproc = '1';
            $nfe->notafiscal_indpag_id = NotafiscalIndpag::PagamentoAVista;
            
            
            //preencher com os dados do cliente...
            $nfe->cliente_cpfcnpj = $venda->cliente->cpf_cnpj;
            $nfe->cliente_nome = $venda->cliente->nome;
            $nfe->cliente_fone = $venda->cliente->fone;
            $nfe->cliente_inscest = $venda->cliente->insc_estadual;
            $nfe->cliente_inscmuni = $venda->cliente->insc_municipal;
            // $nfe->cliente_suframa = '1';
    
            $clienteEndereco = ClienteEndereco::where('cliente_id', '=', $venda->cliente_id)
                                              ->where('principal', '=', Resposta::Sim) 
                                              ->first();
                                              
            if($clienteEndereco)
            {
                $nfe->cliente_endereco = $clienteEndereco->logradouro.' '.$clienteEndereco->complemento;
                $nfe->cliente_complemento = $clienteEndereco->complemento;
                $nfe->cliente_numero = $clienteEndereco->numero;
                $nfe->cliente_bairro = $clienteEndereco->bairro;
                $nfe->cliente_cidade = $clienteEndereco->cidade->nome;
                $nfe->cliente_cidade_codibge = $clienteEndereco->cidade->codigo_ibge;
                $nfe->cliente_cep = $clienteEndereco->cep;
                $nfe->cliente_estado = $clienteEndereco->cidade->estado->sigla;
            }

            $nfe->infadfisco = '';
            $nfe->desconto_valor = $venda->desconto;
            $nfe->pis_valor = 0;
            $nfe->cofins_valor = 0;
            // $nfe->fatura_numero = 0;
    
            // $nfe->retirada_marcado = '1';
            // $nfe->retirada_cpfcnpj = '1';
            // $nfe->retirada_xlgr = '1';
            // $nfe->retirada_nro = '1';
            // $nfe->retirada_xcpl = '1';
            // $nfe->retirada_xbairro = '1';
            // $nfe->retirada_cmun = '1';
            // $nfe->retirada_xmun = '1';
            // $nfe->retirada_uf = '1';
            // $nfe->entrega_marcado = '1';
            // $nfe->entrega_cpfcnpj = '1';
            // $nfe->entrega_xlgr = '1';
            // $nfe->entrega_nro = '1';
            // $nfe->entrega_xcpl = '1';
            // $nfe->entrega_xbairro = '1';
            // $nfe->entrega_cmun = '1';
            // $nfe->entrega_xmun = '1';
            // $nfe->entrega_uf = '1';
            $nfe->vicmsufdest = 0;
            $nfe->vicmsufremet = 0;
            $nfe->vfcpufdest = 0;
            
            $nfe->dispositivos_id = $venda->dispositivos_id;
            $nfe->issqn_vserv = 0;
            $nfe->issqn_vbc = 0;
            $nfe->issqn_viss = 0;
            $nfe->issqn_dcompet = 0;
            $nfe->issqn_reftrib = 0;
            $nfe->icms_vfcp = 0;
            $nfe->icms_vfcpst = 0;
            $nfe->icms_vfcpstret = 0;
            $nfe->layout_versao = '1';
            $nfe->ipi_vipidevol = 0;
            $nfe->vtroco = $venda->valor_troco;
            $nfe->notafiscal_tpamb_id = $filial->nfe_tpamb_id; 
            $nfe->notafiscal_mod_id = $tiponota;
            $nfe->infcpl = $venda->observacao_nf;
            $nfe->notafiscal_modfrete_id = NotafiscalModfrete::SemOcorrencia;
            $nfe->sn_carta_correcao = 'N';
            $nfe->store();
            
            //add itens da venda na nota.
            $i = 0;
            
            foreach($venda->getVendaItems() as $item)
            {
                    $i ++;
                    
                    $notafiscalitem = new NotafiscalItens();
                    $notafiscalitem->notafiscal_id  = $nfe->id;
                    $notafiscalitem->produto_id  = $item->produto_id;
                    
                    $notafiscalitem->cprod = funcaoNFE::RetornaCProd($filial->notafiscal_cprod_padrao_id,
                                                                     $item->produto->id,
                                                                     $item->produto->codigo_EAN,
                                                                     $item->produto->referencia,
                                                                     $item->produto->codigo_sku);
                                                                     
                    //verificando a exceção da natureza...
                    $naturezaexcecaoICMS = funcaoNFE::VerificaExcecaoNatureza($nfe->id,
                                                                              $item->produto_id,
                                                                              $item->produto->notafiscal_item_orig_id,
                                                                              $item->produto->ncm);

                    if ($naturezaexcecaoICMS)
                    {
                        $cfop = NaturezaOperacao::ObterCFOPItem($cliente_estado,$filial->end_uf,$naturezaexcecaoICMS);
                        
                        $icms_cst = $naturezaexcecaoICMS->cst_icms->cst_numero; 
                        $pis_cst = $naturezaexcecaoICMS->cst_pis->cst_numero;
                        $cofins_cst = $naturezaexcecaoICMS->cst_cofins->cst_numero;
                        $ipi_cst = $naturezaexcecaoICMS->cst_ipi->cst_numero;                
                        $ip_cst = $naturezaexcecaoICMS->cst_ipi->cst_numero;
                        $icms_aliquota = $naturezaexcecaoICMS->icms_aliquota;
                        $ipi_aliquota = $naturezaexcecaoICMS->ipi_aliquota;
                        $pis_aliquota = $naturezaexcecaoICMS->pis_aliquota;
                        $cofins_aliquota = $naturezaexcecaoICMS->cofins_aliquota;
                        $pis_valor_base = $naturezaexcecaoICMS->pis_base;
                        $cofins_valor_base = $naturezaexcecaoICMS->cofins_base;
                        $icms_predbc = $naturezaexcecaoICMS->icms_pRedBC;
                        $icms_basecalc = $naturezaexcecaoICMS->icms_base;
                        $icms_pst = $naturezaexcecaoICMS->icms_pST;
                        $icms_pcredsn = $naturezaexcecaoICMS->icms_pCredSN;
                        $icms_pmvast = $naturezaexcecaoICMS->icms_pMVAST;
                        $icms_picmsst = $naturezaexcecaoICMS->icms_pICMSST;
                        $icms_vbcst = $naturezaexcecaoICMS->icms_baseST;

                        $notafiscal_item_modbc_id = $naturezaexcecaoICMS->notafiscal_item_modbc_id;
                        $notafiscal_item_modbcst_id = $naturezaexcecaoICMS->notafiscal_item_modbcst_id;
                        $notafiscal_item_motDesICMS_id = $naturezaexcecaoICMS->notafiscal_item_motDesICMS_id;                        
                    }                                                                      
                                                                     

                    $notafiscalitem->nitem  = $i;
                    $notafiscalitem->criado_em  = date('Y-m-d H:i:s');
                    $notafiscalitem->cean  = $item->produto->codigo_EAN;
                    $notafiscalitem->xprod  = $item->produto->nome;
                    $notafiscalitem->ncm  = $item->produto->ncm;
                    $notafiscalitem->cest  = $item->produto->cest;
                    $notafiscalitem->nve  = "";
                    $notafiscalitem->extipi  = 0;
                    
                    $notafiscalitem->ucom  = $item->produto->unidade_medida->sigla;
                    $notafiscalitem->qcom  = $item->quantidade;
                    $notafiscalitem->vuncom  = $item->valor_unitario;
                    $notafiscalitem->vprod  = $item->valor_total;
                    $notafiscalitem->ceantrib  = $item->produto->codigo_EAN;
                    $notafiscalitem->utrib  = $item->produto->unidade_medida->sigla;
                    $notafiscalitem->qtrib  = $item->quantidade;
                    $notafiscalitem->vuntrib  = $item->valor_unitario;
                    $notafiscalitem->vfrete  = $item->valor_frete;
                    $notafiscalitem->vseg  = 0;
                    $notafiscalitem->vdesc  = $item->desconto;
                    // $notafiscalitem->vtottrib  = $item->valor_total;
                    $notafiscalitem->xped  = $item->numero_pedido;
                    $notafiscalitem->nitemped  = $item->numero_item_pedido;
                    $notafiscalitem->notafiscal_item_indtot_id  = NotafiscalItemIndtot::Zero;
                    $notafiscalitem->notafiscal_item_orig_id  = $item->produto->notafiscal_item_orig_id;// NotafiscalItemOrig::Zero;

                    $notafiscalitem->cfop = $cfop;
                    $notafiscalitem->icms_cst = $icms_cst;
                    $notafiscalitem->pis_cst = $pis_cst;
                    $notafiscalitem->cofins_cst = $cofins_cst;
                    $notafiscalitem->ipi_cst = $ipi_cst;                
                    $notafiscalitem->icms_aliquota = $icms_aliquota;
                    $notafiscalitem->ipi_aliquota = $ipi_aliquota;
                    $notafiscalitem->pis_aliquota = $pis_aliquota;
                    $notafiscalitem->cofins_aliquota = $cofins_aliquota;
                    $notafiscalitem->pis_valor_base = $pis_valor_base;
                    $notafiscalitem->cofins_valor_base = $cofins_valor_base;
                    $notafiscalitem->icms_predbc = $icms_predbc;
                    $notafiscalitem->icms_basecalc = $icms_basecalc;
                    $notafiscalitem->icms_pst = $icms_pst;
                    $notafiscalitem->icms_pcredsn = $icms_pcredsn;
                    $notafiscalitem->icms_pmvast = $icms_pmvast;
                    $notafiscalitem->icms_picmsst = $icms_picmsst;
                    $notafiscalitem->icms_vbcst = $icms_vbcst;
    
                    $notafiscalitem->notafiscal_item_modbc_id = $notafiscal_item_modbc_id;
                    $notafiscalitem->notafiscal_item_modbcst_id = $notafiscal_item_modbcst_id;
                    $notafiscalitem->notafiscal_item_motDesICMS_id = $notafiscal_item_motDesICMS_id;                    
                    
                    $notafiscalitem->voutro  = 0;
                    $notafiscalitem->infadprod  = $item->informacoes_adicionais;

                    $notafiscalitem->ipi_valor_base  = 0;
                    $notafiscalitem->ipi_valor  = 0;
                    $notafiscalitem->ipi_vipidevol  = 0;
                    $notafiscalitem->ipi_pdevol  = 0; 
                    $notafiscalitem->store();
                    
            }
            
            foreach($venda->getVendaFormapgtos() as $pagamento)
            {
                $notapag = new NotafiscalPag();
                $notapag->notafiscal_id      = $nfe->id;
                $notapag->notafiscal_tpag_id = $pagamento->forma_pagamento->notafiscal_tpag_id;
                $notapag->vpag = $pagamento->valor;
                $notapag->tpag = $pagamento->forma_pagamento->notafiscal_tpag->tpag;
                
                if ($pagamento->forma_pagamento->notafiscal_tpag->tpag==NotafiscalTpag::Outros)
                {
                    $notapag->xpag = $pagamento->forma_pagamento->descricao;    
                }

                $notapag->store();
            }
            
            //cobranças...
            $temFatura = false;
            $somaFatura = 0;
            foreach($venda->getVendaFormapgtos() as $pagamento)
            {            
                $lista_contasrec = Contasrec::where('venda_formapgto_id', '=', $pagamento->id)->load();

                foreach ($lista_contasrec as $crec) 
                {    
                    $temFatura = true;
                    $somaFatura += $crec->valor;
                    
                    $notadup = new NotafiscalDup();
                    $notadup->notafiscal_id = $nfe->id; 
                    $notadup->ndup = $crec->numero_documento;
                    $notadup->vdup = $crec->valor;
                    $notadup->dvenc = $crec->data_vencimento;
                    $notadup->store();
                }
            }
            
            if ($temFatura)
            {
               $nfe->fatura_numero = $venda->id; 
               $nfe->fatura_valor_original = $somaFatura; 
               $nfe->fatura_valor_desconto = 0;
               $nfe->fatura_valor_liquido = $somaFatura;
               $nfe->store();
            }            
            
            Notafiscal::atualiza_totais_nota($nfe->id);
            
            return $nfe->id;
            
        } catch (Exception $e) {
            
            return $e->getMessage();
            
        }

    }
    
    // public static function RetornaNumeroNota($tpamb, $mod, $tipodoc, $serienota) --antigo, desativado
    // {

    //     $serie = NotafiscalSeries::where('notafiscal_tpamb_id', '=', $tpamb)
    //                              ->where('notafiscal_mod_id', '=', $mod)
    //                              ->where('notafiscal_tipodocumento_id', '=', $tipodoc)
    //                              ->where('serie', '=', $serienota)
    //                              ->first();
    //     ;
        
    //     if($serie)
    //     {

    //         $numero = $serie->sequencial + 1;

    //         if($serie)
    //         {
    //             $serie->sequencial =  $numero;
    //             $serie->store();
    //         }
            
    //         return $numero;
    //     }
    //     else
    //     {
    //         throw new Exception("Série da nota não configurada para a filial. <br><b>Ambiente: </b>$tpamb<br><b>Modelo: </b>$mod<br><b>Documento: </b>$tipodoc<br><b>Serie: </b>$serienota");
    //     }

    // }
    
   public static function RetornaCProd($cprodpadraoid, $idprod, $eanprod, $referenciaprod, $sku)
   {
       
     if ($cprodpadraoid == NotafiscalCprodPadrao::CodigoProduto)
     {
        return $idprod;    
     }
     elseif ($cprodpadraoid == NotafiscalCprodPadrao::Referencia)
     {
        return $referenciaprod; 
     }
     elseif ($cprodpadraoid == NotafiscalCprodPadrao::CodigoBarras)
     {
        return $eanprod;
     }
     elseif ($cprodpadraoid == NotafiscalCprodPadrao::CodigoSKU)
     {
        return $sku;
     }
     else
     {
        return $idprod;    
     }
   }
   
   public static function ObterProximoSequencialNotaSerie($notafiscal_tpamb_id, $notafiscal_mod_id, $notafiscal_tipodocumento_id, $serie, $system_unit_id)
   {
        $nfserie = NotafiscalSeries::where('notafiscal_tpamb_id', '=', $notafiscal_tpamb_id)
                                   ->where('notafiscal_mod_id', '=', $notafiscal_mod_id)
                                   ->where('notafiscal_tipodocumento_id', '=', $notafiscal_tipodocumento_id)
                                   ->where('serie', '=', $serie)
                                   ->where('system_unit_id', '=', $system_unit_id)
                                   ->first();

        if($nfserie)
        {
            $numero = $nfserie->sequencial + 1;

            $nfserie->sequencial =  $numero;
            $nfserie->store();

            return $numero;
        }
        else
        {
            throw new Exception("Série da nota não configurada para esta filial!'
                                .'<br><b>Ambiente: </b> $notafiscal_tpamb_id<br><b>'
                                .'Modelo: </b> $notafiscal_mod_id<br><b>'
                                .'Documento: </b> $notafiscal_tipodocumento_id<br>'.
                                .'<b>Serie: </b> $serie");
                                
            // throw new Exception('Série da nota não configurada para esta filial!');
        }       
   }

}
