<?php

class Funcoes
{

    public static function sonumeros($val)
    {
        return preg_replace("/[^0-9]/", "", $val);
    }

    public static function SalvarUsuarioCadastro(&$object)
    {         
       if ($object->id=='')
       {
          $object->criado_por = TSession::getValue('username');
          $object->criado_em = date("Y-m-d H:i:s"); 
       }
       else
       {
          $object->alterado_por = TSession::getValue('username');
          $object->alterado_em = date("Y-m-d H:i:s"); 
       }

       //verificando se tem id mas não tem criado por...               
       if (($object->id !='') and ($object->criado_por == ''))
       {
          $object->criado_por = TSession::getValue('username'); 
          $object->alterado_por = '';
          $object->criado_em = date("Y-m-d H:i:s");
       }

    }
    
    public static function VerificaNotificacaoEvento($system_user_id, $descricao_evento, $objeto, $obs)
    {
        
        //consultar para ver se usuário está na lista deste evento...
        $lista_eventoUser = EventosSystemuser::where('eventos_id',  'in', "(select id from eventos where descricao = '{$descricao_evento}')")
                                       //->where('system_users_id', '=', $system_user_id)
                                       ->where('system_unit_id', '=', TSession::getValue('userunitid'))
                                       ->load();

        if($lista_eventoUser)
        {
            foreach ($lista_eventoUser as $eventoUser)
            {
                   $assunto = "";
                   $mensagem = "";
                   $acao = "";
                   $label = "";
                   $icone = "";
                   
                   $param = ['id' => $objeto->id, 'key' => $objeto->id];
        
                   switch ($descricao_evento)
                   {
                      case UnidadeMedida::Evento_UnidadeMedidaIncluidaOuAterada:
                           UnidadeMedida::ConfigEvento_UnidadeMedidaIncluidaOuAlterada($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;
                          
                      case NotaFiscalCompra::Evento_NotaEntradaIncluida:
                           NotaFiscalCompra::ConfigEvento_NotaEntradaIncluida($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;
                           
                      case Contaspag::Evento_ContasPagIncluidoOuAlterado:
                           Contaspag::ConfigEvento_ContasPagIncluidoOuAlterado($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;
                           
                      case Contaspag::Evento_ContasPagBaixado:
                          {
                           $param = ['id' => $objeto->contaspag_id, 'key' => $objeto->contaspag_id];
                           Contaspag::ConfigEvento_ContasPagBaixado($objeto->contaspag_id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                          }
                          break;     
                          
                      case Contasrec::Evento_ContasRecIncluidoOuAlterado:
                           Contasrec::ConfigEvento_ContasRecIncluidoOuAlterado($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;
                           
                      case Contasrec::Evento_ContasRecBaixado:
                          {
                           $param = ['id' => $objeto->contasrec_id, 'key' => $objeto->contasrec_id];
                           Contasrec::ConfigEvento_ContasRecBaixado($objeto->contasrec_id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                          }
                          break;  
                          
                      case Contasrec::Evento_ContasRecHistoricoCobrancasIncluidoOuAlterado:
                          {
                           $param = ['id' => $objeto->contasrec_id, 'key' => $objeto->contasrec_id];
                           Contasrec::ConfigEvento_ContasRecHistoricoCobrancasIncluidoOuAlterado($objeto->contasrec_id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                          }
                          break;                            
                          
                      case CertificadoVenda::Evento_VendaCertificadoIncluidaOuAlterada:
                           CertificadoVenda::ConfigEvento_VendaCertificadoIncluidaOuAlterada($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;           
                           
                      case CertificadoVenda::Evento_VendaCertificadoFinalizada:
                           CertificadoVenda::ConfigEvento_VendaCertificadoFinalizada($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;                       
                           
                      case CertificadoVenda::Evento_VendaCertificadoDesfeita:
                           CertificadoVenda::ConfigEvento_VendaCertificadoDesfeita($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;   
                           
                      case CertificadoVenda::Evento_VendaCertificadoCancelada:
                           CertificadoVenda::ConfigEvento_VendaCertificadoCancelada($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;           
                           
                      case CertificadoVenda::Evento_VendaCertificadoAgendada:
                           CertificadoVenda::ConfigEvento_VendaCertificadoAgendada($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;                               
                           
                      case Negocio::Evento_NegocioIncluidoOuAlterado:
                           Negocio::ConfigEvento_NegocioIncluidoOuAlterado($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;            
                           
                      case Produto::Evento_ProdutoAbaixoDoMinimo:
                           Produto::ConfigEvento_ProdutoAbaixoDoMinimo($objeto->id,$obs,$param,$assunto,$mensagem,$acao,$label,$icone);
                           break;                               
                   }         
                   
                   if (!empty($assunto))
                   {
                       //colocando o nome da empresa na frente do assunto...
                       $assunto = '['.SystemUnit::find(TSession::getValue('userunitid'))->name.'] '.$assunto;
                       $mensagem = $mensagem. ' Usuário: '.TSession::getValue('username'); 
                       
                       SystemNotification::register( $eventoUser->system_users_id, // usuario destino
                                                     $assunto, // assunto
                                                     $mensagem, // mensagem
                                                     $acao, // acao do botão
                                                     $label, // label do botão
                                                     $icone); // ícone do botão       
                       
                       if ($eventoUser->enviar_email)                              
                       {
                           if ($eventoUser->eventos->email_template_id)
                           {
                                $assunto  = $eventoUser->eventos->email_template->titulo;
                                $mensagem = $eventoUser->eventos->email_template->mensagem;
                                
                                $assunto = $objeto->render($assunto);
                                $mensagem = $objeto->render($mensagem);
                                
                                $assunto = '['.SystemUnit::find(TSession::getValue('userunitid'))->name.'] '.$assunto;
                           }
            
                           MailService::send($eventoUser->system_users->email, $assunto, $mensagem, 'html');
                          // SendGridMailService::enviar($eventoUser->system_users->email, $assunto, $mensagem);               
                       }
                   }
                   else
                   {
                       throw new Exception('Mensagem não configurada para este evento!');
                   }

                
            } //foreach lista eventouser
        }
        
    }
    
    public static function mascaraCpfCnpj($val)
    {
        $val = preg_replace("/[^0-9]/", "", $val);

        $mask = '';

        if(strlen($val) == 11)
        {
            $mask = '###.###.###-##';
        }else
        {
            $mask = '##.###.###/####-##';   
        }

        $maskared = '';
        $k = 0;
        for($i = 0; $i<=strlen($mask)-1; $i++)
        {
            if($mask[$i] == '#')
            {
                if(isset($val[$k]))
                $maskared .= $val[$k++];
            }
            else
            {
                if(isset($mask[$i]))
                $maskared .= $mask[$i];
            }
        }
        if($val == '')
        {
            $maskared = '';
        }
        return $maskared;
    }
    
    public static function retornaCSSCamposDesabilitados()
    {
        return  "background-color:white; box-shadow: 0 0 0 0; border: 0 none; outline: 0; font-weight: bold;";
    }
    
   public static function limpaCPF_CNPJ($valor)
   {
     $valor = trim($valor);
     $valor = str_replace(".", "", $valor);
     $valor = str_replace(",", "", $valor);
     $valor = str_replace("-", "", $valor);
     $valor = str_replace("/", "", $valor);
     return $valor;
   }   
   
    public static function retornaFormaPagamentoPadraoDinheiroCaixa()
    {
      //  TTransaction::open('kraftsoft');
        
        $config = Configuracoes::where('id','>',0)->first();
                     
        if($config){
            return $config->forma_pagamento_id_dinheiro_caixa;
        }else{
            return 0;
        }

       // TTransaction::close();
    }   
    
    public static function geraToken($tamanho = 8, $maiusculas = true, $numeros = true, $simbolos = false)
    {
        $lmin = 'abcdefghijklmnopqrstuvwxyz';
        $lmai = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $num = '1234567890';
        $simb = '!@#$%*-';
        $retorno = '';
        $caracteres = '';

        $caracteres .= $lmin;
        if ($maiusculas) $caracteres .= $lmai;
        if ($numeros) $caracteres .= $num;
        if ($simbolos) $caracteres .= $simb;

        $len = strlen($caracteres);
        for ($n = 1; $n <= $tamanho; $n++) {
        $rand = mt_rand(1, $len);
        $retorno .= $caracteres[$rand-1];
        }
        return $retorno;
    }    
    
    
    function mask($val, $mask)
    {
        $maskared = '';
        $k = 0;
        for ($i = 0; $i <= strlen($mask) - 1; ++$i) {
            if ($mask[$i] == '#') {
                if (isset($val[$k])) {
                    $maskared .= $val[$k++];
                }
            } else {
                if (isset($mask[$i])) {
                    $maskared .= $mask[$i];
                }
            }
        }
    
        return $maskared;
        
        /*
            $cnpj = '11222333000199';
            $cpf = '00100200300';
            $cep = '08665110';
            $data = '10102010';
            $hora = '021050';
            
            echo mask($cnpj, '##.###.###/####-##').'<br>';
            echo mask($cpf, '###.###.###-##').'<br>';
            echo mask($cep, '#####-###').'<br>';
            echo mask($data, '##/##/####').'<br>';
            echo mask($data, '##/##/####').'<br>';
            echo mask($data, '[##][##][####]').'<br>';
            echo mask($data, '(##)(##)(####)').'<br>';
            echo mask($hora, 'Agora são ## horas ## minutos e ## segundos').'<br>';
            echo mask($hora, '##:##:##');        
        
        */
    }  
    
    public static function meses()
    {
        return [
            '1' => 'JANEIRO', 
            '2' => 'FEVEREIRO', 
            '3' => 'MARÇO', 
            '4' => 'ABRIL', 
            '5' => 'MAIO', 
            '6' => 'JUNHO', 
            '7' => 'JULHO', 
            '8' => 'AGOSTO', 
            '9' => 'SETEMBRO', 
            '10' => 'OUTUBRO', 
            '11' => 'NOVEMBRO', 
            '12' => 'DEZEMBRO'];
    }   
    
    public static function primeiroNome($nome_completo)
    {
        $resultado = explode(" ", $nome_completo);
        $nome      = $resultado[0];        
        return $nome;
    } 

    public static function anos()
    {
        $ano_atual = date('Y');
        $ano_atual -= 10;
        $anos     = [];
        
        for($ano_atual; $ano_atual <= date('Y'); $ano_atual++)
        {
            $anos[$ano_atual] = $ano_atual;
        }
        
        for($ano_atual; $ano_atual <= date('Y'); $ano_atual++)
        {
            $anos[$ano_atual] = $ano_atual;
        }
        
        return $anos;
    }
    
    public static function retornaDataPorExtenso()
    {
        date_default_timezone_set('America/Sao_Paulo');
        $data = new DateTime();
        $formatter = new IntlDateFormatter('pt_BR', IntlDateFormatter::FULL, IntlDateFormatter::NONE, 'America/Sao_Paulo', IntlDateFormatter::GREGORIAN);
        
        $dataFormatada = $formatter->format($data);
        
        return $dataFormatada;
    }
    
    public static function retornaMesPorExtenso($data)
    {
        $meses = [
            1 => 'Janeiro',
            2 => 'Fevereiro',
            3 => 'Março',
            4 => 'Abril',
            5 => 'Maio',
            6 => 'Junho',
            7 => 'Julho',
            8 => 'Agosto',
            9 => 'Setembro',
            10 => 'Outubro',
            11 => 'Novembro',
            12 => 'Dezembro'
        ];
        
        // Divide a data em partes
        $partesData = explode('-', $data);
        
        if (count($partesData) === 3) {
        
        $mes = intval($partesData[1]); // Pega o mês da data
    
            if (isset($meses[$mes])) {
                return $meses[$mes];
            } else {
                return 'Mês inválido';
            }
        }
        else 
        {
        return 'Data inválida';
        }
    }
}
