<?php

class NuvemFiscal_MDFe
{
    
    
    public static function Consulta($id)
    {
        
        try 
        {
            $mdfe = Mdfe::find($id);
            
            if(is_null($mdfe->idmdfe)){
                throw new Exception('MDF-e não possui ID para consulta.');    
            }
            
            $id = $mdfe->idmdfe;
            
            $retorno = NuvemFiscal::ExecutarGet("/mdfe/$id");
            
            $mensagem = NuvemFiscal::MontaApresentacaoRetorno($retorno);
            
            new TMessage('info', $mensagem);
            
            // echo "<pre>";
            // var_dump($retorno);
            // echo "</pre>";
            
        } catch (Exception $e) {
            new TMessage('error', $e->getMessage());
        }
    }
    
    public static function Cancelar($id)
    {
        try 
        {
            $mdfe = Mdfe::find($id);
            
            // $id = "3a0532a7-7802-45b1-85ea-ce1d190b3e9e";
            // $id = "26220714013224000142580010000000031732318196";
            
            $id = $mdfe->idmdfe;
            
            $dados = [
                    "justificativa" => $mdfe->justificativa_cancelamento  
            ];    
            
            $retorno = NuvemFiscal::ExecutarPost("/mdfe/$id/cancelamento", $dados);
            
            $mensagem = NuvemFiscal::MontaApresentacaoRetorno($retorno);
            
            return $mensagem;
    
            // echo "<pre>";
            // var_dump($retorno);
            // echo "</pre>";
            
            // return true;
                
        } catch (Exception $e) {
             new TMessage('error', $e->getMessage());
        }
        
    }
    
    public static function IncluirDfe($id)
    {
        try 
        {
            
            $item = MdfeInclusaoDfe::find($id); 
            
            $dados = [
                    "codigo_municipio_carrega" => $item->cidade_carrega->codigo_ibge,
                    "municipio_carrega" => $item->cidade_carrega->nome,
                    "documentos" => [
                        "codigo_municipio_descarga" => $item->cidade_descarga->codigo_ibge,
                        "codigo_municipio_descarga" => $item->cidade_descarga->nome,
                        "codigo_municipio_descarga" => $item->chave
                    ],
                    "protocolo_autorizacao" => $item->protocolo,
            ];  
            
            $retorno = NuvemFiscal::ExecutarPost("/mdfe/$item->id/inclusao-dfe", $dados);
            
            $mensagem = NuvemFiscal::MontaApresentacaoRetorno($retorno);
            
            return $mensagem;
    
            echo "<pre>";
            var_dump($retorno);
            echo "</pre>";
            
            // return true;
                
        } catch (Exception $e) {
             new TMessage('error', $e->getMessage());
        }
    }
    
    public static function Enviar($id)
    {
        
        $mdfe = Mdfe::find($id);
        
        $dhemi = date("Y-m-d\TH:s:sP", strtotime($mdfe->dhEmi));
        $dhIniViagem = date("Y-m-d\TH:s:sP", strtotime($mdfe->dhIniViagem));
        
        $qcte =  MdfeCtes::where('mdfe_infmundescarga_id' , 'in', "(select id from mdfe_infmundescarga where mdfe_id = $mdfe->id)" )->count();
        $qnfe =  MdfeNfes::where('mdfe_infmundescarga_id' , 'in', "(select id from mdfe_infmundescarga where mdfe_id = $mdfe->id)" )->count();
        $qmdfe =  MdfeMdfes::where('mdfe_infmundescarga_id' , 'in', "(select id from mdfe_infmundescarga where mdfe_id = $mdfe->id)" )->count();
        
        if(strlen(Funcoes::sonumeros($mdfe->seguro_cpfcnpj)) == 11){
            $nome_cpf_cnpj_seguro = 'CPF';
            $cpfnpj_seguro = Funcoes::sonumeros($mdfe->seguro_cpfcnpj); 
        }else{
            $nome_cpf_cnpj_seguro = 'CNPJ';
            $cpfnpj_seguro = Funcoes::sonumeros($mdfe->seguro_cpfcnpj); 
        }
        
        $dados = ["infMDFe"=> [
                    
                    "emit"=> [
                      "CNPJ"=> $mdfe->system_unit->cnpj,
                    // //   "CPF"=> "et nulla ull",
                      "IE"=> $mdfe->system_unit->inscricao_estadual,
                      "xNome"=> $mdfe->system_unit->razao_social,
                      "xFant"=> $mdfe->system_unit->name,
                      "enderEmit"=> [
                        "xLgr"=> $mdfe->system_unit->end_logradouro,
                        "nro"=> $mdfe->system_unit->end_numero,
                        "xCpl"=> $mdfe->system_unit->end_complemento,
                        "xBairro"=> $mdfe->system_unit->end_bairro,
                        "cMun"=> intval($mdfe->system_unit->end_mun_codibge),
                        "xMun"=> $mdfe->system_unit->end_municipio,
                        "CEP"=> intval($mdfe->system_unit->end_cep),
                        "UF"=> $mdfe->system_unit->end_uf,
                        "fone"=> $mdfe->system_unit->fone,
                        "email"=> $mdfe->system_unit->email
                      ]
                    ],
                    
                    "ide"=> [
                      "infMunCarrega"=> self::MontaInfCarrega($mdfe),
                      "UFIni"=> NuvemFiscal::ValidaCampoNulo($mdfe->fk_UFIni->sigla),
                      "UFFim"=> NuvemFiscal::ValidaCampoNulo($mdfe->fk_UFFim->sigla),
                      "verProc"=> "1",
                      "procEmi"=> "0",
                      "tpEmis"=> 1,
                      "dhEmi"=> $dhemi,
                      "modal"=> 1, 
                      "cDV"=> -26387741, //verificar
                      "cMDF"=> 73231820, //verificar
                      "nMDF"=> intval($mdfe->nMDF),
                      "serie"=> intval($mdfe->serie),
                      "tpEmit"=> intval($mdfe->mdfe_tpemit->valor),
                      "cUF"=> 26,
                      "tpAmb"=> 2,
                    //   "tpTransp"=> intval($mdfe->mdfe_tptransp->valor),
                      "mod"=> 58,
                      //verificar como informar esses dados
                      "infPercurso"=> self::MontaInfPercurso($mdfe),
                      "dhIniViagem"=> $dhIniViagem,
                      "indCanalVerde"=> 1, //intval($mdfe->indCanalVerde),
                    //   "indCarregaPosterior"=> 0,//intval($mdfe->indCarregaPosterior)
                    ],
                    
                    "tot"=> [
                      "qCarga"=> floatval($mdfe->qCarga),
                      "cUnid"=> $mdfe->mdfe_cunid->valor,
                      "vCarga"=> floatval($mdfe->vCarga),
                      "qCTe"=> intval($qcte),
                      "qNFe"=> intval($qnfe),
                      "qMDFe"=> intval($qmdfe)
                    ],
                    
                    "infDoc"=> [
                      "infMunDescarga"=> self::MontaInfDescarga($mdfe)
                    ],
                    
                    "infModal"=> [
                          "versaoModal"=> "0", //verificar
                          "rodo"=> [
                                "veicTracao"=> [
                                      "tpCar"=> str_pad($mdfe->mdfe_tpcar->valor, 2, "0", STR_PAD_LEFT),
                                      "tpRod"=> NuvemFiscal::ValidaCampoNulo($mdfe->mdfe_tpRod->valor),
                                      "condutor"=> self::MontaCondutor($mdfe),
                                      "tara" => intval(NuvemFiscal::ValidaCampoNulo($mdfe->veic_tara)),
                                      "placa"=> NuvemFiscal::ValidaCampoNulo($mdfe->veic_placa),
                                      "cInt"=> NuvemFiscal::ValidaCampoNulo($mdfe->veic_cint),
                                      "RENAVAM"=> str_pad($mdfe->veic_renavam, 9, "0", STR_PAD_LEFT),
                                      "capKG"=> 0, //verificar
                                      "capM3"=> 0, //verificar
                                    //   "prop"=> NuvemFiscal::ValidaCampoNulo($mdfe->mdfe_tpprop->valor),
                                      "UF"=> NuvemFiscal::ValidaCampoNulo($mdfe->veic_estado->sigla)
                                 ],//fim veicTracao
                                 
                                "infANTT"=> self::MontaInformacaoANT($mdfe),
                                 
                          ]//fim rodo
                          
                    ],//fim infomodal

                    "versao"=> "", //verificar
                    "Id"=> "", //verificar
                    
                    "seg"=> [
                      [
                        "infResp"=> [
                          "respSeg"=> intval($mdfe->mdfe_respSeg->valor),
                          $nome_cpf_cnpj_seguro =>  $cpfnpj_seguro,
                        ],
                        "infSeg"=> [
                          "CNPJ"=> $mdfe->seguradora_cnpj,
                          "xSeg"=> $mdfe->seguradora_xSeg
                        ],
                        "nApol" => "123456",
                        "nAver" =>  [
                                        "123456"
                                    ]                        
                      ]
                    ],
                    
                    "prodPred"=> [
                      "xProd"=> $mdfe->prod_xProd,
                      "tpCarga"=> $mdfe->mdfe_tpcarga->valor, 
                      "cEAN"=> $mdfe->prod_cEAN,
                      "NCM"=> $mdfe->prod_NCM,
                      
                    ],

                    "lacres"=> self::MontaLacres($mdfe),

                    "autXML"=> self::MontaXmlAuth($mdfe),

                    "infAdic"=> [
                      "infAdFisco"=> $mdfe->infAdFisco,
                      "infCpl"=> $mdfe->infCpl
                    ], 
                    
                    "infRespTec"=> [ //verificar bloco de dados
                      "fone"=> "81981762527",
                      "email"=> "fernando@fdtecnologia.com.br",
                      "xContato"=> "Fernando Duarte",
                      "CNPJ"=> "14013224000142",
                    ],
                    
                    
                ],
                
                // "infMDFeSupl"=> [
                //     "qrCodMDFe" => ""
                // ],                
                
                "ambiente"=> "homologacao"
                //   "referencia"=> "consequat commodo nulla culpa"                              
        ];  
                
        
        // echo "<pre>";
        // var_dump($dados);
        // echo "</pre>";

        $retorno = NuvemFiscal::ExecutarPost("/mdfe", $dados);
        
        echo "<pre>";
        // var_dump($retorno->status);
        var_dump($retorno);
        echo "</pre>";
        
        exit;
        
        $mdfe->idmdfe = $retorno->id;
        $mdfe->chMDF  = $retorno->chave;
        $mdfe->nProt  = $retorno->protocolo;
        $mdfe->cStat  = $retorno->status;
        $mdfe->store();
        
        $evento = new MdfeEvento();
        $evento->mdfe_id = $mdfe->id;
        $evento->status = $retorno->autorizacao->status;
        $evento->codigo_status = $retorno->autorizacao->codigo_status;
        $evento->motivo_status = $retorno->autorizacao->motivo_status;
        $evento->id_evento = $retorno->autorizacao->id;
        $evento->numero_sequencial = $retorno->autorizacao->numero_sequencial;
        $evento->chave = $retorno->autorizacao->chave_acesso;
        // $evento->protocolo = $retorno->autorizacao->campo;
        $evento->tipo_evento = $retorno->autorizacao->tipo_evento;
        $evento->data_recebimento = $retorno->autorizacao->data_recebimento;
        $evento->data_evento = $retorno->autorizacao->data_evento;        
        $evento->store();
        
        echo "<pre>";
        // var_dump($retorno->status);
        var_dump($retorno);
        echo "</pre>";
        
        
    }
    
    public static function MontaInformacaoANT($mdfe)
    {

            $array = array();
            
            if(NuvemFiscal::ValidaCampoNulo($mdfe->veic_rntrc) <> ""){
                $array["RNTRC"] = $mdfe->veic_rntrc;     
            }
            
            if(count($array) > 0){
                return $array;    
            }else{
                return null;
            }
            
                                    //   "RNTRC" => NuvemFiscal::ValidaCampoNulo($mdfe->veic_rntrc),
                                    //   "infCIOT"=> array(
                                    //         [
                                            
                                    //         ]   
                                    //   ), //verificar
                                    //   "valePed"=> array(
                                    //         [
                                            
                                    //         ]   
                                    //   ),//verificar
                                    //   "infContratante"=> array(
                                    //         [
                                            
                                    //         ]   
                                    //   ), //verificar
                                    //   "infPag"=> array(
                                    //         [
                                            
                                    //         ]   
                                    //   ) //verificar
                                // ]//fim infANTT            
    }
    
    public static function MontaCondutor($mdfe)
    {
        
        $array = array();
        
        foreach ($mdfe->getMdfeCondutors() as $item) {
            $array[] = [
                "xNome" => $item->xnome, 
                "CPF" => $item->cpf,
            ];    
        }
        
        return $array;
        
    }

    public static function MontaInfPercurso($mdfe)
    {
        
        $array = array();
        
        foreach ($mdfe->getMdfeInfpercursos() as $item) {
            $array[] = [
                "UFPer" => $item->fk_UFPer->sigla,    
            ];    
        }
        
        return $array;
        
    }
    
    public static function MontaLacres($mdfe)
    {
        
        $array = array();
        
        foreach ($mdfe->getMdfeLacress() as $item) {
            $array[] = [
                "nLacre" => $item->nLacre,    
            ];    
        }
        
        return $array;
        
    }
    
    public static function MontaInfDescarga($mdfe)
    {
        
        $array = array();
        
        foreach ($mdfe->getMdfeInfmundescargas() as $item) {
            $array[] = [
                "xMunDescarga" => $item->xMunDescarga,    
                "cMunDescarga" => intval($item->cMunDescarga),
                "infCTe" => self::MontaCtes($item->id),
                "infNFe" => self::MontaNfes($item->id),
                "infMDFeTransp" => self::MontaMDFes($item->id),
            ];    
        }
        
        return $array;
        
    }
    
    public static function MontaMDFes($id)
    {
        
        $array = array(); 
        
        $descarga = MdfeInfmundescarga::find($id);
        
        foreach($descarga->getMdfeMdfess() as $item){
            $array[] = [
                "chMDFe" => $item->chMDFe,    
                // "indReentrega" => intval($item->indReentrega)
                "indReentrega" => intval(1)
            ];    
        }
       
        return $array;
        
    }
    
    public static function MontaCtes($id)
    {
        
        $array = array(); 
        
        $descarga = MdfeInfmundescarga::find($id);
        
        foreach($descarga->getMdfeCtess() as $item){
            $array[] = [
                "chCTe" => $item->chCTe,    
                "SegCodBarra" => $item->SegCodBarra,
                // "indReentrega" => intval($item->indReentrega)
                "indReentrega" => intval(1)
            ];    
        }
       
        return $array;
        
    }

    public static function MontaNfes($id)
    {
        
        $array = array(); 
        
        $descarga = MdfeInfmundescarga::find($id);
        
        foreach($descarga->getMdfeNfess() as $item){
            $array[] = [
                "chNFe" => $item->chNFe,    
                "SegCodBarra" => $item->SegCodBarra,
                // "indReentrega" => intval($item->indReentrega)
                "indReentrega" => intval(1)
            ];    
        }
       
        return $array;
        
    }

    public static function MontaXmlAuth($mdfe)
    {
        
        $array = array();
        
        foreach ($mdfe->getMdfeXmlauts() as $item) {

            $documento = Funcoes::sonumeros($item->cpfcnpj);
            $cpfcnpj = strlen($documento) == 11 ? "CPF" : "CNPJ";
            
            $array[] = [
                $cpfcnpj => $documento    
            ];    
        }
        
        return $array;
        
    }
    
    public static function MontaInfCarrega($mdfe)
    {
        
        $array = array();
        
        foreach ($mdfe->getMdfeInfmuncarregas() as $item) {
            
            $array[] = [
                "xMunCarrega" => $item->xMunCarrega,    
                "cMunCarrega" => intval($item->cMunCarrega),
            ];    
        }
        
        return $array;
        
    }
    
}

