<?php

class ClienteEnderecoRestService extends AdiantiRecordService
{
    const DATABASE      = 'kraftsoft';
    const ACTIVE_RECORD = 'ClienteEndereco';
    const ATTRIBUTES    = ['ativo_id','bairro','cep','cidade_id','cliente_id','complemento','id','logradouro','numero','principal'];
    
    
    public static function ObterEnderecosClientes($param)
    {
        TTransaction::open('kraftsoft');

        $listaenderecos = ClienteEndereco::where('id', '>', 0)->load();

        $itens = array();

        foreach ($listaenderecos as $endereco) 
        {
            
            array_push($itens, ['id' => $endereco->id,
                                'logradouro' => $endereco->logradouro,
                                'cliente_id' => $endereco->cliente_id,
                                'principal' => $endereco->principal,
                                'cidade_id' => $endereco->cidade_id,
                                'cidade' => $endereco->cidade->nome,
                                'cidade_codigo_ibge' => $endereco->cidade->codigo_ibge,
                                'estado' => $endereco->cidade->estado->sigla,
                                'estado_codigo_ibge' =>$endereco->cidade->estado->codigo_ibge,
                                'bairro' => $endereco->bairro,
                                'cep' => $endereco->cep,
                                'numero' => $endereco->numero,
                                'complemento' => $endereco->complemento,
                                'ativo_id' => $endereco->ativo_id
                                ]);
        }

        TTransaction::close();
        
        return $itens;
    }      
    
    
    
    /**
     * load($param)
     *
     * Load an Active Records by its ID
     * 
     * @return The Active Record as associative array
     * @param $param['id'] Object ID
     */
    
    
    /**
     * delete($param)
     *
     * Delete an Active Records by its ID
     * 
     * @return The Operation result
     * @param $param['id'] Object ID
     */
    
    
    /**
     * store($param)
     *
     * Save an Active Records
     * 
     * @return The Operation result
     * @param $param['data'] Associative array with object data
     */
    
    
    /**
     * loadAll($param)
     *
     * List the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['offset']    Query offset
     *        $param['limit']     Query limit
     *        $param['order']     Query order by
     *        $param['direction'] Query order direction (asc, desc)
     *        $param['filters']   Query filters (array with field,operator,field)
     */
    
    
    /**
     * deleteAll($param)
     *
     * Delete the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['filters']   Query filters (array with field,operator,field)
     */
}
