<?php

class NaturezaOperacaoExcecaoRestService extends AdiantiRecordService
{
    const DATABASE      = 'kraftsoft';
    const ACTIVE_RECORD = 'NaturezaOperacaoExcecao';
    const ATTRIBUTES    = ['alterado_em','alterado_por','cfop','cfop_fora','cofins_aliquota','cofins_base','criado_em','criado_por','cst_cofins_id','cst_icms_id','cst_ipi_id','cst_pis_id','descricao','icms_aliquota','icms_base','icms_basest','icms_pcredsn','icms_pdif','icms_pfcp','icms_pfcpst','icms_pfcpstret','icms_pfcpufdest','icms_picms','icms_picmsefet','icms_picmsst','icms_picmsufdest','icms_pmvast','icms_predbc','icms_predbcefet','icms_pst','icms_vicmsdeson','id','ipi_aliquota','ipi_codigo_enquadramento','natop_excecao_tributo_id','natureza_operacao_id','notafiscal_item_modbc_id','notafiscal_item_modbcst_id','notafiscal_item_motDesICMS_id','pis_aliquota','pis_base'];
    
    public static function ObterNaturezaOperacaoExcecaoNFCe($param)
    {
        TTransaction::open('kraftsoft');
        
        $lista_natop = NaturezaOperacaoExcecao::where('natureza_operacao_id', '=', $param['natureza_operacao_id'])->load();

        $itens = array();
        
        foreach ($lista_natop as $natop) 
        {        
            array_push($itens, ['id' => $natop->id,
                                'natureza_operacao_finalidade_id' => $natop->natureza_operacao_finalidade_id,
                                'natureza_operacao_id' => $natop->natureza_operacao_id,                                
                                'cst_icms_id' => $natop->cst_icms->cst_numero,
                                'cst_ipi_id' => $natop->cst_ipi->cst_numero,
                                'cst_pis_id' => $natop->cst_pis->cst_numero,
                                'cst_cofins_id' => $natop->cst_cofins->cst_numero,
                                'cfop' => $natop->cfop,
                                'descricao' => $natop->descricao,
                                'obs_padrao' => $natop->obs_padrao,
                                'criado_em' => $natop->criado_em,
                                'alterado_por' => $natop->alterado_por,
                                'criado_por' => $natop->criado_por,
                                'alterado_em' => $natop->alterado_em,
                                'icms_aliquota' => $natop->icms_aliquota,
                                'ipi_aliquota' => $natop->ipi_aliquota,
                                'ipi_codigo_enquadramento' => $natop->ipi_codigo_enquadramento,
                                'pis_aliquota' => $natop->pis_aliquota,
                                'pis_base' => $natop->pis_base,
                                'cofins_aliquota' => $natop->cofins_aliquota,
                                'consumidor_final_id' => $natop->consumidor_final_id,
                                'cofins_base' => $natop->cofins_base,
                                'icms_predbc' => $natop->icms_predbc,
                                'icms_picms' => $natop->icms_picms,
                                'icms_pdif' => $natop->icms_pdif,
                                'icms_vicmsdeson' => $natop->icms_vicmsdeson,
                                'icms_pmvast' => $natop->icms_pmvast,
                                'icms_picmsst' => $natop->icms_picmsst,
                                'icms_pfcp' => $natop->icms_pfcp,
                                'icms_pfcpst' => $natop->icms_pfcpst,
                                'icms_pfcpstret' => $natop->icms_pfcpstret,
                                'icms_pst' => $natop->icms_pst,
                                'icms_pcredsn' => $natop->icms_pcredsn,
                                'icms_predbcefet' => $natop->icms_predbcefet,
                                'icms_picmsefet' => $natop->icms_picmsefet,
                                'notafiscal_item_modbc_id' => $natop->notafiscal_item_modbc->codigo,
                                'notafiscal_item_modbcst_id' => $natop->notafiscal_item_modbcst->codigo,
                                'notafiscal_item_motdesicms_id' => $natop->notafiscal_item_motdesicms->codigo,
                                'icms_pfcpufdest' => $natop->icms_pfcpufdest,
                                'icms_picmsufdest' => $natop->icms_picmsufdest,
                                'icms_base' => $natop->icms_base,
                                'icms_basest' => $natop->icms_basest
                                ]);     
                                
        }
            
        TTransaction::close();
        
        return $itens;
    }              
   
   
   
   
    /**
     * load($param)
     *
     * Load an Active Records by its ID
     * 
     * @return The Active Record as associative array
     * @param $param['id'] Object ID
     */
    
    
    /**
     * delete($param)
     *
     * Delete an Active Records by its ID
     * 
     * @return The Operation result
     * @param $param['id'] Object ID
     */
    
    
    /**
     * store($param)
     *
     * Save an Active Records
     * 
     * @return The Operation result
     * @param $param['data'] Associative array with object data
     */
    
    
    /**
     * loadAll($param)
     *
     * List the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['offset']    Query offset
     *        $param['limit']     Query limit
     *        $param['order']     Query order by
     *        $param['direction'] Query order direction (asc, desc)
     *        $param['filters']   Query filters (array with field,operator,field)
     */
    
    
    /**
     * deleteAll($param)
     *
     * Delete the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['filters']   Query filters (array with field,operator,field)
     */
}
