<?php

class NaturezaOperacaoRestService extends AdiantiRecordService
{
    const DATABASE      = 'kraftsoft';
    const ACTIVE_RECORD = 'NaturezaOperacao';
    const ATTRIBUTES    = ['alterado_em','alterado_por','cfop','cofins_aliquota','cofins_base','consumidor_final_id','criado_em','criado_por','cst_cofins_id','cst_icms_id','cst_ipi_id','cst_pis_id','descricao','icms_aliquota','icms_base','icms_baseST','icms_pCredSN','icms_pDif','icms_pFCP','icms_pFCPST','icms_pFCPSTRet','icms_pFCPUFDest','icms_pICMS','icms_pICMSEfet','icms_pICMSST','icms_pICMSUFDest','icms_pMVAST','icms_pRedBC','icms_pRedBCEfet','icms_pST','icms_vICMSDeson','id','ipi_aliquota','ipi_codigo_enquadramento','natureza_operacao_finalidade_id','notafiscal_item_modbc_id','notafiscal_item_modbcst_id','notafiscal_item_motDesICMS_id','obs_padrao','pis_aliquota','pis_base'];
    
    public static function ObterNaturezaOperacaoNFCe($param)
    {
        TTransaction::open('kraftsoft');
        
        $filial = SystemUnit::find($param['filial_id']);

        $natop = NaturezaOperacao::where('id', '=', $filial->nfce_natureza_operacao_id)->first();

        $itens = array();
        

            array_push($itens, ['id' => $natop->id,
                                'natureza_operacao_finalidade_id' => $natop->natureza_operacao_finalidade_id,
                                'cst_icms_id' => $natop->cst_icms->cst_numero,
                                'cst_ipi_id' => $natop->cst_ipi->cst_numero,
                                'cst_pis_id' => $natop->cst_pis->cst_numero,
                                'cst_cofins_id' => $natop->cst_cofins->cst_numero,
                                'cfop' => $natop->cfop,
                                'descricao' => $natop->descricao,
                                'obs_padrao' => $natop->obs_padrao,
                                'criado_em' => $natop->criado_em,
                                'alterado_por' => $natop->alterado_por,
                                'criado_por' => $natop->criado_por,
                                'alterado_em' => $natop->alterado_em,
                                'icms_aliquota' => $natop->icms_aliquota,
                                'ipi_aliquota' => $natop->ipi_aliquota,
                                'ipi_codigo_enquadramento' => $natop->ipi_codigo_enquadramento,
                                'pis_aliquota' => $natop->pis_aliquota,
                                'pis_base' => $natop->pis_base,
                                'cofins_aliquota' => $natop->cofins_aliquota,
                                'consumidor_final_id' => $natop->consumidor_final_id,
                                'cofins_base' => $natop->cofins_base,
                                'icms_predbc' => $natop->icms_predbc,
                                'icms_picms' => $natop->icms_picms,
                                'icms_pdif' => $natop->icms_pdif,
                                'icms_vicmsdeson' => $natop->icms_vicmsdeson,
                                'icms_pmvast' => $natop->icms_pmvast,
                                'icms_picmsst' => $natop->icms_picmsst,
                                'icms_pfcp' => $natop->icms_pfcp,
                                'icms_pfcpst' => $natop->icms_pfcpst,
                                'icms_pfcpstret' => $natop->icms_pfcpstret,
                                'icms_pst' => $natop->icms_pst,
                                'icms_pcredsn' => $natop->icms_pcredsn,
                                'icms_predbcefet' => $natop->icms_predbcefet,
                                'icms_picmsefet' => $natop->icms_picmsefet,
                                'notafiscal_item_modbc_id' => $natop->notafiscal_item_modbc->codigo,
                                'notafiscal_item_modbcst_id' => $natop->notafiscal_item_modbcst->codigo,
                                'notafiscal_item_motdesicms_id' => $natop->notafiscal_item_motdesicms->codigo,
                                'icms_pfcpufdest' => $natop->icms_pfcpufdest,
                                'icms_picmsufdest' => $natop->icms_picmsufdest,
                                'icms_base' => $natop->icms_base,
                                'icms_basest' => $natop->icms_basest
                                ]);            
            
        TTransaction::close();
        
        return $itens;
    }           
    
    
    /**
     * load($param)
     *
     * Load an Active Records by its ID
     * 
     * @return The Active Record as associative array
     * @param $param['id'] Object ID
     */
    
    
    /**
     * delete($param)
     *
     * Delete an Active Records by its ID
     * 
     * @return The Operation result
     * @param $param['id'] Object ID
     */
    
    
    /**
     * store($param)
     *
     * Save an Active Records
     * 
     * @return The Operation result
     * @param $param['data'] Associative array with object data
     */
    
    
    /**
     * loadAll($param)
     *
     * List the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['offset']    Query offset
     *        $param['limit']     Query limit
     *        $param['order']     Query order by
     *        $param['direction'] Query order direction (asc, desc)
     *        $param['filters']   Query filters (array with field,operator,field)
     */
    
    
    /**
     * deleteAll($param)
     *
     * Delete the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['filters']   Query filters (array with field,operator,field)
     */
}
