<?php

class ProdutoRestService extends AdiantiRecordService
{
    const DATABASE      = 'kraftsoft';
    const ACTIVE_RECORD = 'Produto';
    const ATTRIBUTES    = ['alterado_em','alterado_por','cest','codigo_EAN','criado_em','criado_por','deletado_em','especificacao','id','imagem','link_site','ncm','nome','notafiscal_item_orig_id','obs','peso_bruto','peso_liquido','produto_fabricante_id','produto_grupo_id','produtogrupo_subgrupo_id','referencia','tipo_recurso_id','unidade_medida_id'];
    
   
   
    public static function ObterProdutosFilial($param)
    {
        TTransaction::open('kraftsoft');
        $conn = TTransaction::get();
        
        $listaprodutos = $conn->query('SELECT * from produto order by id');
        
        //$listaprodutos = (object)$listaprodutos; //transforma o array em objeto --não utilizei mas fica como exemplo de possibilidade
        
        //$listaprodutos = Produto::where('id', '>', 0)->load(); --esta forma não traz os produtos excluidos.

        $itens = array();

        foreach ($listaprodutos as $produto) 
        {
            //buscando os preços da filial...
            $produtofilial = ProdutoFilial::where('produto_id', '=', $produto['id'])->where('system_unit_id', '=', $param['filialid'])->first(); 
            
            array_push($itens, ['id' => $produto['id'],
                                'produto_grupo_id' => $produto['produto_grupo_id'],
                                'unidade_medida_id' => $produto['unidade_medida_id'],
                                'tipo_recurso_id' => $produto['tipo_recurso_id'],
                                'produto_fabricante_id' => $produto['produto_fabricante_id'],
                                'produtogrupo_subgrupo_id' => $produto['produtogrupo_subgrupo_id'],
                                'notafiscal_item_orig_id' => (isset(NotafiscalItemOrig::find($produto['notafiscal_item_orig_id'])->codigo)) ?
                                                              NotafiscalItemOrig::find($produto['notafiscal_item_orig_id'])->codigo : 0 ,
                                'nome' => $produto['nome'],
                                'codigo_EAN' => $produto['codigo_EAN'],
                                'imagem' => $produto['imagem'],
                                'criado_em' => $produto['criado_em'],
                                'alterado_em' => $produto['alterado_em'],
                                'ncm' => $produto['ncm'],
                                'cest' => $produto['cest'],
                                'criado_por' => $produto['criado_por'],
                                'alterado_por' => $produto['alterado_por'],
                                'obs' => $produto['obs'],
                                'referencia' => $produto['referencia'],
                                'deletado_em' => $produto['deletado_em'],
                                'especificacao' => $produto['especificacao'],
                                'link_site' => $produto['link_site'],
                                'peso_liquido' => $produto['peso_liquido'],
                                'peso_bruto' => $produto['peso_bruto'],
                                'habilitado_id' => $produto['habilitado_id'],
                                
                                'margem' => (isset($produtofilial->margem)) ? $produtofilial->margem : 0,
                                'preco_venda' => (isset($produtofilial->preco_venda)) ? $produtofilial->preco_venda : 0,
                                'valor_custo' => (isset($produtofilial->valor_custo)) ? $produtofilial->valor_custo : 0,
                                'estoque_minimo' => (isset($produtofilial->estoque_minimo)) ? $produtofilial->estoque_minimo : 0,
                                'estoque_maximo' => (isset($produtofilial->estoque_maximo)) ? $produtofilial->estoque_maximo : 0,
                                'local_estoque' => (isset($produtofilial->local_estoque)) ? $produtofilial->local_estoque : '',
                                'codigo_balanca' => (isset($produtofilial->codigo_balanca)) ? $produtofilial->codigo_balanca : '']);
        }

        TTransaction::close();
        
        return $itens;
    }   
   
   
   
   
    /**
     * load($param)
     *
     * Load an Active Records by its ID
     * 
     * @return The Active Record as associative array
     * @param $param['id'] Object ID
     */
    
    
    /**
     * delete($param)
     *
     * Delete an Active Records by its ID
     * 
     * @return The Operation result
     * @param $param['id'] Object ID
     */
    
    
    /**
     * store($param)
     *
     * Save an Active Records
     * 
     * @return The Operation result
     * @param $param['data'] Associative array with object data
     */
    
    
    /**
     * loadAll($param)
     *
     * List the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['offset']    Query offset
     *        $param['limit']     Query limit
     *        $param['order']     Query order by
     *        $param['direction'] Query order direction (asc, desc)
     *        $param['filters']   Query filters (array with field,operator,field)
     */
    
    
    /**
     * deleteAll($param)
     *
     * Delete the Active Records by the filter
     * 
     * @return Array of records
     * @param $param['filters']   Query filters (array with field,operator,field)
     */
}
