CREATE TABLE api_documentos( 
      id  integer generated by default as identity     NOT NULL , 
      integradores_id integer    NOT NULL , 
      system_unit_id integer   , 
      descricao blob sub_type 1    NOT NULL , 
      token_api blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE apidocumentos_integradoresservicos( 
      id  integer generated by default as identity     NOT NULL , 
      api_documentos_id integer    NOT NULL , 
      integradores_servicos_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE api_error( 
      id  integer generated by default as identity     NOT NULL , 
      classe blob sub_type 1   , 
      metodo blob sub_type 1   , 
      url blob sub_type 1   , 
      dados blob sub_type 1   , 
      error_message blob sub_type 1   , 
      inserted_at timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ativo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE banco( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      numero blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE boleto_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa( 
      id  integer generated by default as identity     NOT NULL , 
      caixa_situacao_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      system_users_abertura_id integer    NOT NULL , 
      system_users_operador_id integer    NOT NULL , 
      system_users_fechamento_id integer   , 
      data_hora_abertura timestamp   , 
      data_hora_fechamento timestamp   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_lancamentos( 
      id  integer generated by default as identity     NOT NULL , 
      caixa_id integer    NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      caixa_tipo_lancamento_id integer    NOT NULL , 
      valor float    NOT NULL , 
      data_hora_lancamento timestamp    NOT NULL , 
      system_users_id integer    NOT NULL , 
      observacao blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      id_origem integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_tipo_lancamento( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      centro_custo_tipo_id integer    NOT NULL , 
      centro_custo_pai_id integer   , 
      numero blob sub_type 1    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cep_cache( 
      id  integer generated by default as identity     NOT NULL , 
      cep blob sub_type 1   , 
      rua blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      cidade blob sub_type 1   , 
      bairro blob sub_type 1   , 
      codigo_ibge blob sub_type 1   , 
      uf char  (2)   , 
      cidade_id integer   , 
      estado_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agendamentos( 
      id  integer generated by default as identity     NOT NULL , 
      certificado_venda_id integer    NOT NULL , 
      titulo blob sub_type 1    NOT NULL , 
      data_hora_inicial timestamp    NOT NULL , 
      data_hora_final timestamp    NOT NULL , 
      observacao blob sub_type 1   , 
      cor blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agente_registro( 
      id  integer generated by default as identity     NOT NULL , 
      parceiro_id integer   , 
      nome blob sub_type 1    NOT NULL , 
      cpf blob sub_type 1   , 
      fone blob sub_type 1   , 
      email blob sub_type 1   , 
      percentual_comissao float   , 
      deletado_em timestamp   , 
      criado_em timestamp    NOT NULL , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente( 
      id  integer generated by default as identity     NOT NULL , 
      cliente_id integer    NOT NULL , 
      parceiro_id integer   , 
      produto_id integer    NOT NULL , 
      certificado_cliente_situacao_id integer    NOT NULL , 
      data_vencimento_certificado date   , 
      certificado_venda_id integer   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_email_historico( 
      id  integer generated by default as identity     NOT NULL , 
      certificado_cliente_id integer    NOT NULL , 
      email blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      texto_emissao blob sub_type 1   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora_produtos( 
      id  integer generated by default as identity     NOT NULL , 
      certificadora_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      qtde_dias_vencimento integer   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      valor_custo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_atendimento( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_repasse( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      cliente_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      parceiro_id integer   , 
      certificado_agente_registro_id integer    NOT NULL , 
      certificado_venda_situacao_id integer    NOT NULL , 
      certificado_venda_modalidade_id integer   , 
      certificado_venda_tipomodalidade_id integer   , 
      certificado_tipo_repasse_id integer   , 
      vendedor_id integer   , 
      tabela_preco_id integer   , 
      certificadora_id integer   , 
      valor_custo float   , 
      data_hora_agendamento timestamp   , 
      data_vencimento_certificado date   , 
      valor_externo float   , 
      custo_externo float   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      agente_comissao_percentual float   , 
      agente_comissao_valor float   , 
      vendedor_comissao_percentual float   , 
      vendedor_comissao_valor float   , 
      atendimento_externo char(1)   , 
      parceiro_comissao_percentual float   , 
      parceiro_valor_repasse float   , 
      valor_total float    NOT NULL , 
      comissao_total float   , 
      lucro_total float   , 
      valor_cliente float   , 
      valor_produto float    NOT NULL , 
      protocolo_emissao blob sub_type 1   , 
      data_emissao date   , 
      data_pagamento date   , 
      certificado_tipo_atendimento_id integer   , 
      observacao blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_documentos( 
      id  integer generated by default as identity     NOT NULL , 
      certificado_venda_id integer    NOT NULL , 
      descricao_arquivo blob sub_type 1    NOT NULL , 
      arquivo blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_formapgto( 
      id  integer generated by default as identity     NOT NULL , 
      certificado_venda_id integer    NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_modalidade( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      certificado_tipo_repasse_id integer    NOT NULL , 
      certificado_venda_tipomodalidade_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      ordem integer   , 
      cor blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_tipomodalidade( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cfop( 
      id  integer generated by default as identity     NOT NULL , 
      numero char  (4)    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      aplicacao blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE chave_pix_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cidade( 
      id  integer generated by default as identity     NOT NULL , 
      estado_id integer    NOT NULL , 
      pais_id integer   , 
      nome blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      codigo_ibge blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente( 
      id  integer generated by default as identity     NOT NULL , 
      pessoa_tipo_id integer    NOT NULL , 
      cliente_classificacao_id integer    NOT NULL , 
      cliente_classificacao_subgrupo_id integer   , 
      vendedor_id integer   , 
      notafiscal_indiedest_id integer    NOT NULL , 
      notafiscal_crt_id integer   , 
      nome blob sub_type 1    NOT NULL , 
      cpf_cnpj blob sub_type 1   , 
      rg blob sub_type 1   , 
      email blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      insc_estadual blob sub_type 1   , 
      insc_municipal blob sub_type 1   , 
      razao_social blob sub_type 1   , 
      fone blob sub_type 1   , 
      observacoes blob sub_type 1   , 
      data_nascimento date   , 
      conjuge blob sub_type 1   , 
      conjuge_cpf blob sub_type 1   , 
      nome_pai blob sub_type 1   , 
      nome_mae blob sub_type 1   , 
      local_trabalho blob sub_type 1   , 
      renda float   , 
      tempo_trabalho blob sub_type 1   , 
      residencia_propria integer   , 
      utilizar_endereco_cobranca integer    NOT NULL , 
      cobranca_cnpj blob sub_type 1   , 
      cobranca_nome blob sub_type 1   , 
      cobranca_cep blob sub_type 1   , 
      cobranca_endereco blob sub_type 1   , 
      cobranca_bairro blob sub_type 1   , 
      cobranca_uf blob sub_type 1   , 
      cobranca_cidade blob sub_type 1   , 
      cobranca_fones blob sub_type 1   , 
      cliente_situacao_id integer    NOT NULL , 
      limite_credito float   , 
      limite_utilizado float   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_por blob sub_type 1   , 
      system_unit_id integer   , 
      deletado_em timestamp   , 
      vendas_quantidade integer   , 
      vendas_valortotal float   , 
      vendas_dataultima timestamp   , 
      vendas_valormaior float   , 
      vendas_datamaior timestamp   , 
      observacoes_financeiro blob sub_type 1   , 
      tabela_preco_id integer   , 
      percentual_comissao_vendedor float   , 
      cliente_exterior char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_por blob sub_type 1   , 
      ativo_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao_subgrupo( 
      id  integer generated by default as identity     NOT NULL , 
      cliente_classificacao_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_contato( 
      id  integer generated by default as identity     NOT NULL , 
      cliente_id integer   , 
      tipo_contato blob sub_type 1   , 
      nome blob sub_type 1    NOT NULL , 
      fone blob sub_type 1   , 
      ativo_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_endereco( 
      id  integer generated by default as identity     NOT NULL , 
      logradouro blob sub_type 1    NOT NULL , 
      cliente_id integer    NOT NULL , 
      principal integer    NOT NULL , 
      cidade_id integer    NOT NULL , 
      bairro blob sub_type 1   , 
      cep blob sub_type 1   , 
      numero blob sub_type 1   , 
      complemento blob sub_type 1   , 
      ativo_id integer    NOT NULL , 
      codigo_ibge varchar  (20)   , 
      ibge_estado integer  (2)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_historico_limite( 
      id  integer generated by default as identity     NOT NULL , 
      cliente_id integer    NOT NULL , 
      valor float    NOT NULL , 
      data_hora timestamp    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_por blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE condicao_pagamento( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      numero_parcelas integer    NOT NULL , 
      dias_primeira_parcelas integer   , 
      dias_entre_parcelas integer   , 
      taxa float   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes( 
      id  integer generated by default as identity     NOT NULL , 
      forma_pagamento_id_dinheiro_caixa integer   , 
      forma_pagamento_id_titulos_cpag_nf integer   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes_filial( 
      id  integer generated by default as identity     NOT NULL , 
      configuracoes_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      produto_etiqueta_configuracoes_id integer   , 
      plano_conta_mascara blob sub_type 1   , 
      centro_custo_mascara blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      plano_conta_crec_id integer   , 
      centro_custo_crec_id integer   , 
      cpag_usa_plano_contas_id integer   , 
      info_complementar_orcamento blob sub_type 1   , 
      informar_duplicidade_de_item_venda_id integer   , 
      venda_apenas_com_estoque_id integer   , 
      notafiscal_cprod_padrao_orcamento_id integer   , 
      notafiscal_cprod_padrao_venda_id integer   , 
      produto_margem_padrao float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos( 
      id  integer generated by default as identity     NOT NULL , 
      plano_conta_id integer    NOT NULL , 
      centro_custo_id integer    NOT NULL , 
      contabil_lancamentos_tipo_id integer    NOT NULL , 
      contabil_lancamentos_situacao_id integer    NOT NULL , 
      contabil_lancamentos_origem_id integer    NOT NULL , 
      data_lancamento date    NOT NULL , 
      valor float    NOT NULL , 
      contasrec_id integer   , 
      contaspag_contabil_id integer   , 
      conta_corrente_lancamentos_id integer   , 
      historico blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_origem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      banco_id integer   , 
      nome blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      agencia blob sub_type 1   , 
      conta blob sub_type 1   , 
      agencia_digito blob sub_type 1   , 
      conta_digito blob sub_type 1   , 
      end_logradouro blob sub_type 1   , 
      end_bairro blob sub_type 1   , 
      end_cidade blob sub_type 1   , 
      end_estado blob sub_type 1   , 
      end_cep blob sub_type 1   , 
      end_numero blob sub_type 1   , 
      boleto_convenio blob sub_type 1   , 
      boleto_carteira blob sub_type 1   , 
      boleto_gerar char(1)    NOT NULL , 
      boleto_codigo_cedente blob sub_type 1   , 
      boleto_digito_cod_cedente blob sub_type 1   , 
      boleto_instrucoes blob sub_type 1   , 
      boleto_multa float   , 
      boleto_juros_dia float   , 
      boleto_digitos_nosso_numero integer   , 
      boleto_local_pagamento blob sub_type 1   , 
      boleto_codigo_transmissao blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lancamentos( 
      id  integer generated by default as identity     NOT NULL , 
      conta_corrente_id integer    NOT NULL , 
      conta_corrente_lanc_tipo_id integer    NOT NULL , 
      conta_corrente_lanc_origem_id integer    NOT NULL , 
      contaspag_baixas_id integer   , 
      contasrec_baixas_id integer   , 
      data_lancamento date    NOT NULL , 
      valor float    NOT NULL , 
      documento blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      historico blob sub_type 1   , 
      plano_conta_id integer   , 
      centro_custo_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_origem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag( 
      id  integer generated by default as identity     NOT NULL , 
      contaspag_situacao_id integer    NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      fornecedor_id integer    NOT NULL , 
      contaspag_origem_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      numero_documento blob sub_type 1    NOT NULL , 
      parcela blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      data_emissao date    NOT NULL , 
      valor float    NOT NULL , 
      data_vencimento date    NOT NULL , 
      data_venc_original date   , 
      observacao blob sub_type 1   , 
      data_pagamento date   , 
      desconto float   , 
      juros float   , 
      valor_pago float   , 
      valor_aberto float   , 
      valor_multa float   , 
      cheque_banco_id integer   , 
      cheque_agencia blob sub_type 1   , 
      cheque_conta float   , 
      cheque_emitente blob sub_type 1   , 
      cheque_cpfcnpj blob sub_type 1   , 
      data_competencia date   , 
      contaspag_bloco_id integer   , 
      nota_fiscal_compra_id integer   , 
      data_vencimento_calendario timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_anexos( 
      id  integer generated by default as identity     NOT NULL , 
      contaspag_id integer    NOT NULL , 
      titulos_tipo_anexo_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      arquivo blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_baixas( 
      id  integer generated by default as identity     NOT NULL , 
      contaspag_id integer    NOT NULL , 
      conta_corrente_id integer    NOT NULL , 
      data_pagamento date    NOT NULL , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      juros float   , 
      desconto float   , 
      saldo_aberto float   , 
      saldo_apagar float   , 
      multa float   , 
      historico blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco( 
      id  integer generated by default as identity     NOT NULL , 
      fornecedor_id integer    NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      contaspag_origem_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      quantidade_parcelas integer    NOT NULL , 
      primeiro_vencimento date   , 
      valor float    NOT NULL , 
      numero_documento blob sub_type 1   , 
      observacao blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco_contabil( 
      id  integer generated by default as identity     NOT NULL , 
      contaspag_bloco_id integer    NOT NULL , 
      plano_conta_id integer    NOT NULL , 
      centro_custo_id integer    NOT NULL , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_contabil( 
      id  integer generated by default as identity     NOT NULL , 
      contaspag_id integer    NOT NULL , 
      plano_conta_id integer    NOT NULL , 
      centro_custo_id integer    NOT NULL , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_historico_venc( 
      id  integer generated by default as identity     NOT NULL , 
      contaspag_id integer    NOT NULL , 
      vencimento_anterior date   , 
      vencimento_atual date    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_origem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      cliente_id integer    NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      contasrec_situacao_id integer    NOT NULL , 
      plano_conta_id integer    NOT NULL , 
      centro_custo_id integer    NOT NULL , 
      contasrec_origem_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      numero_documento blob sub_type 1   , 
      parcela blob sub_type 1   , 
      valor float    NOT NULL , 
      data_vencimento date    NOT NULL , 
      data_venc_original date   , 
      observacao blob sub_type 1   , 
      data_pagamento date   , 
      desconto float   , 
      juros float   , 
      valor_pago float   , 
      valor_aberto float   , 
      valor_multa float   , 
      cheque_banco_id integer   , 
      cheque_agencia blob sub_type 1   , 
      cheque_conta blob sub_type 1   , 
      cheque_emitente blob sub_type 1   , 
      cheque_cpfcnpj blob sub_type 1   , 
      data_competencia date   , 
      conta_corrente_boleto_id integer   , 
      boleto_situacao_id integer   , 
      boleto_nosso_numero blob sub_type 1   , 
      vendedor_comissao float   , 
      vendedor_id integer   , 
      contasrec_bloco_id integer   , 
      venda_formapgto_id integer   , 
      data_emissao date    NOT NULL , 
      ativo_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_anexos( 
      id  integer generated by default as identity     NOT NULL , 
      contasrec_id integer    NOT NULL , 
      titulos_tipo_anexo_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      arquivo blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_baixas( 
      id  integer generated by default as identity     NOT NULL , 
      contasrec_id integer    NOT NULL , 
      conta_corrente_id integer    NOT NULL , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      juros float   , 
      desconto float   , 
      saldo_aberto float    NOT NULL , 
      saldo_apagar float   , 
      multa float   , 
      historico blob sub_type 1   , 
      data_pagamento date    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_bloco( 
      id  integer generated by default as identity     NOT NULL , 
      cliente_id integer    NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      plano_conta_id integer    NOT NULL , 
      centro_custo_id integer    NOT NULL , 
      quantidade_parcelas integer    NOT NULL , 
      primeiro_vencimento date   , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      numero_documento blob sub_type 1   , 
      observacao blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_cobranca( 
      id  integer generated by default as identity     NOT NULL , 
      contasrec_id integer    NOT NULL , 
      historico blob sub_type 1    NOT NULL , 
      data_cobranca date    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_venc( 
      id  integer generated by default as identity     NOT NULL , 
      contasrec_id integer    NOT NULL , 
      vencimento_anterior date   , 
      vencimento_atual date    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_origem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_cofins( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cst_numero blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_icms( 
      id  integer generated by default as identity     NOT NULL , 
      regime_tributario_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cst_numero blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_ipi( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cst_numero blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_pis( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cst_numero blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos( 
      id  integer generated by default as identity     NOT NULL , 
      despesas_servicos_tipo_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE dispositivos( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      token varchar  (100)    NOT NULL , 
      serial_dispositivo blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      deletado_em timestamp   , 
      data_hora_ultima_sincronizacao timestamp   , 
      ip_sincronizacao blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE email_template( 
      id  integer generated by default as identity     NOT NULL , 
      titulo blob sub_type 1    NOT NULL , 
      mensagem blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estado( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      sigla char  (2)    NOT NULL , 
      codigo_ibge blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_deposito( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_estante( 
      id  integer generated by default as identity     NOT NULL , 
      estoque_rua_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_lancamentos( 
      id  integer generated by default as identity     NOT NULL , 
      produto_id integer    NOT NULL , 
      estoque_origem_id integer    NOT NULL , 
      estoque_tipo_movimentacao_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      estoque_deposito_id integer    NOT NULL , 
      produto_lote_id integer   , 
      venda_id integer   , 
      nota_fiscal_compra_id integer   , 
      ordem_producao_id integer   , 
      quantidade float    NOT NULL , 
      observacao blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      preco_venda float   , 
      preco_custo float   , 
      data_lancamento date    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_origem( 
      id  integer generated by default as identity     NOT NULL , 
      estoque_tipo_movimentacao_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_prateleira( 
      id  integer generated by default as identity     NOT NULL , 
      estoque_estante_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_rua( 
      id  integer generated by default as identity     NOT NULL , 
      estoque_deposito_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_saldos( 
      id  integer generated by default as identity     NOT NULL , 
      produto_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      estoque_deposito_id integer    NOT NULL , 
      produto_lote_id integer   , 
      quant_disponivel float    NOT NULL , 
      quant_reservada float   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      preco_medio_venda float   , 
      preco_medio_custo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_tipo_movimentacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos( 
      id  integer generated by default as identity     NOT NULL , 
      system_program_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      email_template_id integer   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_documentos( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer   , 
      system_users_id integer   , 
      system_unit_id integer   , 
      cstat integer   , 
      xmotivo varchar  (255)   , 
      xevento varchar  (255)   , 
      tpevento varchar  (255)   , 
      nseqevento integer   , 
      dhregevento timestamp   , 
      nprot varchar  (255)   , 
      origem_event varchar  (255)   , 
      mensagem_manual blob sub_type 1   , 
      tpamb integer   , 
      veraplic varchar  (255)   , 
      chnfe varchar  (255)   , 
      dhrecbto timestamp   , 
      digval varchar  (255)   , 
      xml blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_systemuser( 
      id  integer generated by default as identity     NOT NULL , 
      eventos_id integer    NOT NULL , 
      system_users_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      enviar_email integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE forma_pagamento( 
      id  integer generated by default as identity     NOT NULL , 
      codigo_interno integer  (11)    NOT NULL , 
      tipo_documento_id integer    NOT NULL , 
      meio_pagamento_tef_id integer   , 
      notafiscal_tpag_id integer   , 
      descricao blob sub_type 1    NOT NULL , 
      prazo_pagamento integer   , 
      taxa float   , 
      deletado_em timestamp   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por blob sub_type 1   , 
      alterado_por blob sub_type 1   , 
      utiliza_pdv char  (1)   , 
      obriga_nf_pdv char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE formapgto_condpgto( 
      id  integer generated by default as identity     NOT NULL , 
      condicao_pagamento_id integer    NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor( 
      id  integer generated by default as identity     NOT NULL , 
      pessoa_tipo_id integer    NOT NULL , 
      fornecedor_classificacao_id integer   , 
      nome blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      insc_estadual blob sub_type 1   , 
      insc_municipal blob sub_type 1   , 
      cpf_cnpj blob sub_type 1   , 
      razao_social blob sub_type 1   , 
      logradouro blob sub_type 1   , 
      cidade_id integer   , 
      bairro blob sub_type 1   , 
      cep blob sub_type 1   , 
      numero blob sub_type 1   , 
      complemento blob sub_type 1   , 
      fone blob sub_type 1   , 
      email blob sub_type 1   , 
      site blob sub_type 1   , 
      observacoes blob sub_type 1   , 
      notafiscal_crt_id integer   , 
      deletado_em timestamp   , 
      notafiscal_indiedest_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_classificacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      ativo_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_contato( 
      id  integer generated by default as identity     NOT NULL , 
      fornecedor_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      tipo_contato blob sub_type 1   , 
      nome blob sub_type 1    NOT NULL , 
      fone blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario( 
      id  integer generated by default as identity     NOT NULL , 
      funcionario_cargo_id integer   , 
      nome blob sub_type 1    NOT NULL , 
      cpf blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      valor_salario float   , 
      valor_hora float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario_cargo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil_etapas( 
      id  integer generated by default as identity     NOT NULL , 
      funil_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      numero_etapa integer    NOT NULL , 
      cor_etapa blob sub_type 1   , 
      cor_negocio blob sub_type 1   , 
      ultima_etapa integer   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      permite_edicao char  (1)   , 
      permite_exclusao char  (1)   , 
      kanban char  (1)   , 
      etapa_ganha char  (1)   , 
      etapa_perde char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE indicador_personalizado( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      url_indicador blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores_servicos( 
      id  integer generated by default as identity     NOT NULL , 
      integradores_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE inutilizar_numero( 
      id  integer generated by default as identity     NOT NULL , 
      created_at timestamp   , 
      system_user integer   , 
      update_at timestamp   , 
      deleted_at timestamp   , 
      ninicio varchar  (20)   , 
      nfinal varchar  (20)   , 
      serie varchar  (20)   , 
      system_unit_id integer   , 
      system_users_id integer   , 
      xml_retorno blob sub_type 1   , 
      protocolo varchar  (50)   , 
      xmotivo varchar  (200)   , 
      cstat integer   , 
      notafiscal_id integer   , 
      xjust varchar  (150)   , 
      tipo integer  (1)    DEFAULT 1  NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      idmdfe varchar  (255)   , 
      chMDF blob sub_type 1   , 
      nProt blob sub_type 1   , 
      cStat blob sub_type 1   , 
      mdfe_tpemit_id integer    NOT NULL , 
      mdfe_tpprop_id integer    NOT NULL , 
      mdfe_tptransp_id integer   , 
      mdfe_tpcar_id integer    NOT NULL , 
      nMDF blob sub_type 1    NOT NULL , 
      serie blob sub_type 1   , 
      dhEmi timestamp   , 
      UFIni integer    NOT NULL , 
      UFFim integer    NOT NULL , 
      dhIniViagem timestamp   , 
      indCanalVerde integer    NOT NULL , 
      indCarregaPosterior integer    NOT NULL , 
      infAdFisco blob sub_type 1   , 
      infCpl blob sub_type 1   , 
      mdfe_respSeg_id integer   , 
      seguro_cpfcnpj blob sub_type 1   , 
      seguradora_xSeg blob sub_type 1   , 
      seguradora_cnpj blob sub_type 1   , 
      vCarga float   , 
      mdfe_cunid_id integer    NOT NULL , 
      qCarga float   , 
      mdfe_tpcarga_id integer   , 
      prod_xProd blob sub_type 1   , 
      prod_cEAN blob sub_type 1   , 
      prod_NCM blob sub_type 1   , 
      pgto_cpfcnpj blob sub_type 1   , 
      pgto_idEstrangeiro blob sub_type 1   , 
      pgto_xNome blob sub_type 1   , 
      pgto_vContrato float   , 
      pgto_indAltoDesemp blob sub_type 1   , 
      mdfe_indpag_id integer   , 
      pgto_vAdiant float   , 
      indAntecipaAdiant integer   , 
      pgto_codBanco blob sub_type 1   , 
      pgto_codAgencia blob sub_type 1   , 
      pgto_CNPJIPEF blob sub_type 1   , 
      pgto_PIX blob sub_type 1   , 
      veic_rntrc blob sub_type 1   , 
      mdfe_tpRod_id integer    NOT NULL , 
      veic_estado_id integer    NOT NULL , 
      veic_cint integer   , 
      veic_placa blob sub_type 1   , 
      veic_renavam blob sub_type 1   , 
      veic_tara float   , 
      justificativa_cancelamento blob sub_type 1   , 
      mensagem_sefaz blob sub_type 1   , 
      status blob sub_type 1   , 
      data_hora_envio timestamp   , 
      protocolo_cancelamento blob sub_type 1   , 
      datahora_cancelamento timestamp   , 
      veiculo_id integer    NOT NULL , 
      mdfe_situacao_id integer    NOT NULL , 
      mdfe_tpamb_id integer    NOT NULL , 
      api_documentos_id integer   , 
      xml_cancelamento blob sub_type 1   , 
      xml blob sub_type 1   , 
      cidade_encerramento_id integer   , 
      cmunencerramento integer   , 
      data_encerramento date   , 
      datahora_encerramento timestamp   , 
      protocolo_encerramento blob sub_type 1   , 
      xml_encerramento blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_componentes( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      mdfe_tpcomp_id integer    NOT NULL , 
      vComp float   , 
      xComp blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_condutor( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      xnome blob sub_type 1    NOT NULL , 
      cpf blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_ctes( 
      id  integer generated by default as identity     NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      chCTe blob sub_type 1   , 
      SegCodBarra blob sub_type 1   , 
      indReentrega integer    NOT NULL , 
      mdfe_infmundescarga_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_cunid( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_evento( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      status blob sub_type 1   , 
      codigo_status blob sub_type 1   , 
      motivo_status blob sub_type 1   , 
      id_evento blob sub_type 1   , 
      numero_sequencial blob sub_type 1   , 
      chave blob sub_type 1   , 
      protocolo blob sub_type 1   , 
      tipo_evento blob sub_type 1   , 
      data_recebimento blob sub_type 1   , 
      data_evento blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_inclusao_dfe( 
      id  integer generated by default as identity     NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      mdfe_id integer    NOT NULL , 
      notafiscal_id integer   , 
      cidade_carrega_id integer    NOT NULL , 
      cidade_descarga_id integer    NOT NULL , 
      chave blob sub_type 1    NOT NULL , 
      protocolo blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_indpag( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmuncarrega( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      cidade_id integer    NOT NULL , 
      cMunCarrega blob sub_type 1    NOT NULL , 
      xMunCarrega blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmundescarga( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      cidade_id integer    NOT NULL , 
      cMunDescarga blob sub_type 1    NOT NULL , 
      xMunDescarga blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infpercurso( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      UFPer integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_lacres( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      nLacre blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_logs( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      system_users_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_mdfes( 
      id  integer generated by default as identity     NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      chMDFe blob sub_type 1   , 
      indReentrega integer    NOT NULL , 
      mdfe_infmundescarga_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_nfes( 
      id  integer generated by default as identity     NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      chNFe blob sub_type 1   , 
      SegCodBarra blob sub_type 1   , 
      indReentrega integer    NOT NULL , 
      mdfe_infmundescarga_id integer    NOT NULL , 
      notafiscal_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_parcelas( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      nParcela blob sub_type 1   , 
      dVenc date   , 
      vParcela float   , 
      mdfe_tpAntecip_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_respSeg( 
      id  integer generated by default as identity     NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_series( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      mdfe_tpamb_id integer    NOT NULL , 
      serie blob sub_type 1    NOT NULL , 
      sequencial integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      cor blob sub_type 1   , 
      ordem integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpamb( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      valor blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpAntecip( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcar( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcarga( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcomp( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpemit( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpprop( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpRod( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tptransp( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_xmlaut( 
      id  integer generated by default as identity     NOT NULL , 
      mdfe_id integer    NOT NULL , 
      cpfcnpj blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE meio_pagamento_tef( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE movimentacao_origem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natop_excecao_tributo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao( 
      id  integer generated by default as identity     NOT NULL , 
      natureza_operacao_finalidade_id integer    NOT NULL , 
      cst_icms_id integer   , 
      cst_icms_nao_contribuinte_id integer   , 
      cst_ipi_id integer   , 
      cst_pis_id integer   , 
      cst_cofins_id integer   , 
      cfop char  (4)    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      obs_padrao blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      icms_aliquota float   , 
      ipi_aliquota float   , 
      ipi_codigo_enquadramento blob sub_type 1   , 
      pis_aliquota float   , 
      pis_base float   , 
      cofins_aliquota float   , 
      consumidor_final_id integer   , 
      cofins_base float   , 
      icms_pRedBC float   , 
      icms_pICMS float   , 
      icms_pDif float   , 
      icms_vICMSDeson float   , 
      icms_pMVAST float   , 
      icms_pICMSST float   , 
      icms_pFCP float   , 
      icms_pFCPST float   , 
      icms_pFCPSTRet float   , 
      icms_pST float   , 
      icms_pCredSN date   , 
      icms_pRedBCEfet float   , 
      icms_pICMSEfet float   , 
      notafiscal_item_modbc_id integer   , 
      notafiscal_item_modbcst_id integer   , 
      notafiscal_item_motDesICMS_id integer   , 
      icms_pFCPUFDest float   , 
      icms_pICMSUFDest float   , 
      icms_baseST float   , 
      icms_base float   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_estados( 
      id  integer generated by default as identity     NOT NULL , 
      natureza_operacao_excecao_id integer    NOT NULL , 
      estado_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_excecao( 
      id  integer generated by default as identity     NOT NULL , 
      natureza_operacao_id integer    NOT NULL , 
      natop_excecao_tributo_id integer    NOT NULL , 
      cst_pis_id integer   , 
      cst_ipi_id integer   , 
      cst_icms_id integer   , 
      cst_cofins_id integer   , 
      cfop char  (4)   , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      icms_aliquota float   , 
      ipi_aliquota float   , 
      ipi_codigo_enquadramento blob sub_type 1   , 
      pis_aliquota float   , 
      pis_base float   , 
      cofins_aliquota float   , 
      cofins_base float   , 
      icms_predbc float   , 
      icms_picms float   , 
      icms_pdif float   , 
      icms_vicmsdeson float   , 
      icms_pmvast float   , 
      icms_picmsst float   , 
      icms_pfcp float   , 
      icms_pfcpst float   , 
      icms_pfcpstret float   , 
      icms_pst float   , 
      icms_pcredsn float   , 
      icms_predbcefet float   , 
      icms_picmsefet float   , 
      icms_pfcpufdest float   , 
      icms_picmsufdest float   , 
      icms_base float   , 
      icms_basest float   , 
      notafiscal_item_modbc_id integer   , 
      notafiscal_item_modbcst_id integer   , 
      notafiscal_item_motDesICMS_id integer   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_finalidade( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_ncm( 
      id  integer generated by default as identity     NOT NULL , 
      natureza_operacao_excecao_id integer    NOT NULL , 
      ncm blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_origens( 
      id  integer generated by default as identity     NOT NULL , 
      natureza_operacao_excecao_id integer    NOT NULL , 
      notafiscal_item_orig_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_produtos( 
      id  integer generated by default as identity     NOT NULL , 
      produto_id integer    NOT NULL , 
      natureza_operacao_excecao_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      negocio_origem_id integer    NOT NULL , 
      funil_id integer   , 
      funil_etapas_id integer    NOT NULL , 
      titulo blob sub_type 1    NOT NULL , 
      valor float   , 
      data_abertura date    NOT NULL , 
      ordem integer    NOT NULL , 
      data_fechamento date   , 
      negocio_motivo_perda_id integer   , 
      comentarios_motivo_perda blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      contato_nome blob sub_type 1   , 
      contato_fone blob sub_type 1   , 
      ativo_id integer    NOT NULL , 
      arquivado integer    NOT NULL , 
      data_fechamento_esperada date   , 
      vendedor_id integer   , 
      mes integer   , 
      ano integer   , 
      orcamento_id integer   , 
      cliente_id integer   , 
      deletado_em timestamp   , 
      contato_email blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_arquivos( 
      id  integer generated by default as identity     NOT NULL , 
      negocio_id integer    NOT NULL , 
      arquivo blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_atividade( 
      id  integer generated by default as identity     NOT NULL , 
      negocio_id integer    NOT NULL , 
      negocio_tipo_atividade_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      horario_inicial timestamp   , 
      horario_final timestamp   , 
      observacao blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_etapas_historico( 
      id  integer generated by default as identity     NOT NULL , 
      negocio_id integer    NOT NULL , 
      funil_etapas_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_itens( 
      id  integer generated by default as identity     NOT NULL , 
      negocio_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      valor_unitario float    NOT NULL , 
      quantidade float    NOT NULL , 
      valor_total float    NOT NULL , 
      desconto float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_motivo_perda( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_notas( 
      id  integer generated by default as identity     NOT NULL , 
      negocio_id integer    NOT NULL , 
      nota blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_origem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_tipo_atividade( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      icone blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      cliente_id integer   , 
      venda_id integer   , 
      numero blob sub_type 1    NOT NULL , 
      data_emissao timestamp   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      texto_rodape blob sub_type 1   , 
      data_saida timestamp   , 
      icms_basecalc float   , 
      icms_valor float   , 
      icms_subst_base_calc integer   , 
      icms_subst_valor float   , 
      frete_valor float   , 
      seguro_valor float   , 
      outras_despesas float   , 
      ipi_valor float   , 
      serie blob sub_type 1   , 
      valor_total_produtos float   , 
      valor_total_nota float   , 
      transp_nome blob sub_type 1   , 
      transp_cnpj blob sub_type 1   , 
      transp_inscest blob sub_type 1   , 
      transp_endereco blob sub_type 1   , 
      transp_cidade blob sub_type 1   , 
      transp_placaveiculo blob sub_type 1   , 
      transp_uf blob sub_type 1   , 
      transp_veiculouf blob sub_type 1   , 
      transp_veiculoRNTC blob sub_type 1   , 
      transp_numeracao blob sub_type 1   , 
      nf_tipodocumento_id integer    NOT NULL , 
      notafiscal_situacao_id integer    NOT NULL , 
      notafiscal_crt_id integer    NOT NULL , 
      cliente_endereco blob sub_type 1   , 
      cliente_complemento blob sub_type 1   , 
      cliente_numero blob sub_type 1   , 
      cliente_bairro blob sub_type 1   , 
      cliente_cidade blob sub_type 1   , 
      cliente_cep blob sub_type 1   , 
      cliente_estado blob sub_type 1   , 
      cliente_nome blob sub_type 1   , 
      cliente_cpfcnpj blob sub_type 1   , 
      cliente_inscest blob sub_type 1   , 
      cliente_inscmuni blob sub_type 1   , 
      cliente_fone blob sub_type 1   , 
      cliente_cidade_codibge integer   , 
      cliente_suframa blob sub_type 1   , 
      justificativa_cancelamento blob sub_type 1   , 
      chave blob sub_type 1   , 
      protocolo_envio blob sub_type 1   , 
      notafiscal_indiedest_id integer    NOT NULL , 
      protocolo_cancelamento blob sub_type 1   , 
      datahora_cancelamento timestamp   , 
      cce_datahora_evento timestamp   , 
      cce_sequencial integer   , 
      cce_correcao blob sub_type 1   , 
      cce_protocolo blob sub_type 1   , 
      infadfisco blob sub_type 1   , 
      desconto_valor float   , 
      pis_valor float   , 
      cofins_valor float   , 
      fatura_numero blob sub_type 1   , 
      fatura_valor_original float   , 
      fatura_valor_desconto float   , 
      fatura_valor_liquido float   , 
      notafiscal_iddest_id integer    NOT NULL , 
      notafiscal_tpimp_id integer    NOT NULL , 
      notafiscal_tpemis_id integer    NOT NULL , 
      notafiscal_finnfe_id integer    NOT NULL , 
      notafiscal_indfinal_id integer    NOT NULL , 
      notafiscal_indpres_id integer    NOT NULL , 
      verproc blob sub_type 1   , 
      notafiscal_indpag_id integer    NOT NULL , 
      retirada_marcado integer   , 
      retirada_cpfcnpj blob sub_type 1   , 
      retirada_xlgr blob sub_type 1   , 
      retirada_nro blob sub_type 1   , 
      retirada_xcpl blob sub_type 1   , 
      retirada_xbairro blob sub_type 1   , 
      retirada_cmun integer   , 
      retirada_xmun blob sub_type 1   , 
      retirada_uf blob sub_type 1   , 
      entrega_marcado integer   , 
      entrega_cpfcnpj blob sub_type 1   , 
      entrega_xlgr blob sub_type 1   , 
      entrega_nro blob sub_type 1   , 
      entrega_xcpl blob sub_type 1   , 
      entrega_xbairro blob sub_type 1   , 
      entrega_cmun integer   , 
      entrega_xmun blob sub_type 1   , 
      entrega_uf blob sub_type 1   , 
      vicmsufdest float   , 
      vicmsufremet float   , 
      vfcpufdest float   , 
      notafiscal_modelo_id integer    NOT NULL , 
      dispositivos_id integer   , 
      xml blob sub_type 1   , 
      data_hora_envio timestamp   , 
      xml_cancelamento blob sub_type 1   , 
      issqn_vserv float   , 
      issqn_vbc float   , 
      issqn_viss float   , 
      issqn_dcompet date   , 
      issqn_reftrib blob sub_type 1   , 
      icms_vfcp float   , 
      icms_vfcpst float   , 
      icms_vfcpstret float   , 
      layout_versao blob sub_type 1   , 
      ipi_vipidevol float   , 
      vtroco float   , 
      notafiscal_tpamb_id integer    NOT NULL , 
      notafiscal_mod_id integer    NOT NULL , 
      infcpl blob sub_type 1   , 
      notafiscal_modfrete_id integer    NOT NULL , 
      status blob sub_type 1   , 
      mensagem blob sub_type 1   , 
      cce_xml blob sub_type 1   , 
      cce_pdf blob sub_type 1   , 
      codigo_sefaz integer   , 
      sn_carta_correcao char  (1)    DEFAULT 'N'  NOT NULL , 
      deletado_em timestamp   , 
      contingencia_data timestamp   , 
      contingencia_motivo blob sub_type 1   , 
      exporta_ufsaidapais blob sub_type 1   , 
      exporta_xlocexporta blob sub_type 1   , 
      exporta_xlocdespacho blob sub_type 1   , 
      cliente_cpais blob sub_type 1   , 
      cliente_xpais blob sub_type 1   , 
      natureza_operacao_id integer   , 
      movimentacao_origem_id integer   , 
      inutilizar integer   , 
      xml_inicial blob sub_type 1   , 
      entrega_cuf integer  (2)   , 
      xml_assinado blob sub_type 1   , 
      protolo_xml blob sub_type 1   , 
      xml_autorizado blob sub_type 1   , 
      cep_entrega varchar  (15)   , 
      cep_retirada varchar  (15)   , 
      entrega_xnome varchar  (200)   , 
      xml_carta blob sub_type 1   , 
      protocolo_carta_resposta varchar  (200)   , 
      descricao blob sub_type 1   , 
      xevento blob sub_type 1   , 
      xmotivo blob sub_type 1   , 
      cstat integer   , 
      dhregevento varchar  (50)   , 
      nseqevento integer  (11)   , 
      nprot varchar  (100)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_autxml( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      cpf_cnpj blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp    NOT NULL , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      fornecedor_id integer   , 
      numero blob sub_type 1    NOT NULL , 
      data_emissao timestamp   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      natop blob sub_type 1   , 
      data_saida timestamp   , 
      infcpl blob sub_type 1   , 
      infadfisco blob sub_type 1   , 
      icms_basecalc float   , 
      icms_valor float   , 
      icms_subst_base_calc float   , 
      icms_subst_valor float   , 
      frete_valor float   , 
      seguro_valor float   , 
      outras_despesas float   , 
      ipi_valor float   , 
      serie blob sub_type 1   , 
      valor_total_produtos float   , 
      valor_total_nota float   , 
      transp_nome blob sub_type 1   , 
      transp_cnpj blob sub_type 1   , 
      transp_inscest blob sub_type 1   , 
      transp_endereco blob sub_type 1   , 
      transp_cidade blob sub_type 1   , 
      transp_placaveiculo blob sub_type 1   , 
      transp_uf blob sub_type 1   , 
      transp_veiculouf blob sub_type 1   , 
      transp_veiculorntc blob sub_type 1   , 
      transp_numeracao blob sub_type 1   , 
      notafiscal_tipodocumento_id integer    NOT NULL , 
      nota_fiscal_compra_situacao_id integer    NOT NULL , 
      notafiscal_crt_id integer   , 
      obs_importacao_xml blob sub_type 1   , 
      cliente_endereco blob sub_type 1   , 
      cliente_complemento blob sub_type 1   , 
      cliente_numero blob sub_type 1   , 
      cliente_bairro blob sub_type 1   , 
      cliente_cidade blob sub_type 1   , 
      cliente_cep blob sub_type 1   , 
      cliente_estado blob sub_type 1   , 
      cliente_nome blob sub_type 1   , 
      cliente_cpfcnpj blob sub_type 1   , 
      cliente_inscest blob sub_type 1   , 
      cliente_fone blob sub_type 1   , 
      cliente_cidade_codibge blob sub_type 1   , 
      cliente_inscmuni blob sub_type 1   , 
      cliente_suframa blob sub_type 1   , 
      justificativa_cancelamento blob sub_type 1   , 
      chave blob sub_type 1   , 
      protocolo_envio blob sub_type 1   , 
      notafiscal_indiedest_id integer   , 
      protocolo_cancelamento blob sub_type 1   , 
      datahora_cancelamento blob sub_type 1   , 
      cce_datahora_evento blob sub_type 1   , 
      cce_sequencial blob sub_type 1   , 
      cce_correcao blob sub_type 1   , 
      cce_protocolo blob sub_type 1   , 
      desconto_valor float   , 
      pis_valor float   , 
      cofins_valor float   , 
      fatura_numero blob sub_type 1   , 
      fatura_valor_original blob sub_type 1   , 
      fatura_valor_desconto float   , 
      fatura_valor_liquido float   , 
      notafiscal_iddest_id integer    NOT NULL , 
      notafiscal_tpimp_id integer   , 
      notafiscal_finnfe_id integer    NOT NULL , 
      notafiscal_indfinal_id integer    NOT NULL , 
      notafiscal_indpres_id integer    NOT NULL , 
      verproc blob sub_type 1   , 
      notafiscal_indpag_id integer   , 
      retirada_marcado integer   , 
      retirada_cpfcnpj blob sub_type 1   , 
      retirada_xlgr blob sub_type 1   , 
      retirada_nro blob sub_type 1   , 
      retirada_xcpl blob sub_type 1   , 
      retirada_xbairro blob sub_type 1   , 
      retirada_cmun integer   , 
      retirada_xmun blob sub_type 1   , 
      retirada_uf blob sub_type 1   , 
      entrega_marcado integer   , 
      entrega_cpfcnpj blob sub_type 1   , 
      entrega_xlgr blob sub_type 1   , 
      entrega_nro blob sub_type 1   , 
      entrega_xcpl blob sub_type 1   , 
      entrega_xbairro blob sub_type 1   , 
      entrega_cmun blob sub_type 1   , 
      entrega_xmun blob sub_type 1   , 
      entrega_uf blob sub_type 1   , 
      vicmsufdest float   , 
      vicmsufremet float   , 
      vfcpufdest blob sub_type 1   , 
      notafiscal_mod_id integer    NOT NULL , 
      xml blob sub_type 1   , 
      data_hora_envio timestamp   , 
      xml_cancelamento blob sub_type 1   , 
      issqn_vserv float   , 
      issqn_vbc float   , 
      issqn_viss float   , 
      issqn_dcompet date   , 
      issqn_reftrib blob sub_type 1   , 
      icms_vfcp float   , 
      icms_vfcpst float   , 
      icms_vfcpstret float   , 
      layout_versao blob sub_type 1   , 
      ipi_vipidevol float   , 
      vtroco date   , 
      notafiscal_modfrete_id integer   , 
      cpag_lancada char(1)    NOT NULL , 
      dest_cnpj blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_dup( 
      id  integer generated by default as identity     NOT NULL , 
      nota_fiscal_compra_id integer    NOT NULL , 
      forma_pagamento_id integer   , 
      plano_conta_id integer   , 
      centro_custo_id integer   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      ndup blob sub_type 1   , 
      vdup float   , 
      dvenc date   , 
      parcela blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens( 
      id  integer generated by default as identity     NOT NULL , 
      nota_fiscal_compra_id integer    NOT NULL , 
      produto_id integer   , 
      nota_fiscal_compra_itens_situacao_id integer   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      nitem integer   , 
      cean blob sub_type 1   , 
      xprod blob sub_type 1   , 
      ncm blob sub_type 1   , 
      nve blob sub_type 1   , 
      extipi blob sub_type 1   , 
      cfop blob sub_type 1   , 
      ucom blob sub_type 1   , 
      qcom float   , 
      vuncom float   , 
      vprod float   , 
      ceantrib blob sub_type 1   , 
      utrib blob sub_type 1   , 
      qtrib float   , 
      vuntrib float   , 
      vfrete float   , 
      vseg float   , 
      vdesc float   , 
      vtottrib float   , 
      xped blob sub_type 1   , 
      nitemped integer   , 
      notafiscal_item_indtot_id integer   , 
      notafiscal_item_orig_id integer    NOT NULL , 
      notafiscal_item_modbc_id integer   , 
      icms_basecalc float   , 
      icms_cst blob sub_type 1   , 
      icms_valor float   , 
      icms_aliquota float   , 
      icms_pcredsn float   , 
      icms_vcredicmssn float   , 
      icms_predbc float   , 
      icms_pst float   , 
      icms_pmvast float   , 
      icms_predbcst float   , 
      icms_vbcst float   , 
      icms_picmsst float   , 
      icms_vicmsst float   , 
      fcp_pfcp float   , 
      pis_cst blob sub_type 1   , 
      pis_valor float   , 
      pis_aliquota float   , 
      pis_valor_base float   , 
      cofins_cst blob sub_type 1   , 
      cofins_valor_base float   , 
      cofins_aliquota float   , 
      cofins_valor float   , 
      voutro float   , 
      infadprod blob sub_type 1   , 
      notafiscal_item_motDesICMS_id integer   , 
      cprod blob sub_type 1   , 
      ipi_cst blob sub_type 1   , 
      ipi_valor_base float   , 
      ipi_aliquota float   , 
      ipi_vipidevol float   , 
      ipi_valor float   , 
      ipi_pdevol float   , 
      estoque_deposito_id integer   , 
      produto_lote_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_pag( 
      id  integer generated by default as identity     NOT NULL , 
      nota_fiscal_compra_id integer    NOT NULL , 
      notafiscal_tpag_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      tpag blob sub_type 1   , 
      vpag float   , 
      xpag blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      cor blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_cprod_padrao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_crt( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor integer   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_dup( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      ndup blob sub_type 1   , 
      vdup float   , 
      dvenc date   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_finnfe( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_frete_volumes( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      qVol integer   , 
      nVol blob sub_type 1   , 
      esp blob sub_type 1   , 
      marca blob sub_type 1   , 
      pesol float   , 
      pesob float   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_iddest( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indfinal( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indiedest( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpag( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpres( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_indtot( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbc( 
      id  integer generated by default as identity     NOT NULL , 
      codigo integer   , 
      descricao blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbcst( 
      id  integer generated by default as identity     NOT NULL , 
      codigo integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_motDesICMS( 
      id  integer generated by default as identity     NOT NULL , 
      codigo blob sub_type 1    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_orig( 
      id  integer generated by default as identity     NOT NULL , 
      codigo integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_itens( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      nitem integer   , 
      cean varchar  (50)   , 
      xprod blob sub_type 1    NOT NULL , 
      ncm blob sub_type 1   , 
      nve blob sub_type 1   , 
      extipi blob sub_type 1   , 
      cfop blob sub_type 1   , 
      ucom blob sub_type 1   , 
      qcom float    NOT NULL , 
      vuncom float  (13,2)    NOT NULL , 
      vprod float   , 
      ceantrib blob sub_type 1   , 
      utrib blob sub_type 1   , 
      qtrib float  (13,2)   , 
      vuntrib float  (13,2)   , 
      vfrete float  (13,2)   , 
      vseg float  (13,2)   , 
      vdesc float  (13,2)   , 
      vtottrib float  (10,2)   , 
      xped blob sub_type 1   , 
      nitemped integer   , 
      notafiscal_item_indtot_id integer   , 
      notafiscal_item_orig_id integer    NOT NULL , 
      notafiscal_item_modbc_id integer   , 
      icms_basecalc float   , 
      icms_cst varchar  (20)   , 
      icms_valor float   , 
      icms_aliquota float   , 
      icms_pcredsn float  (10,2)   , 
      icms_vcredicmssn float   , 
      icms_predbc float   , 
      icms_pst float   , 
      icms_pmvast float   , 
      icms_predbcst float   , 
      icms_vbcst float   , 
      icms_picmsst float   , 
      icms_vicmsst float   , 
      alterado_em timestamp   , 
      criado_em timestamp   , 
      pis_cst varchar  (20)   , 
      pis_valor float   , 
      pis_aliquota float   , 
      pis_valor_base float   , 
      cofins_cst varchar  (20)   , 
      cofins_valor_base float   , 
      cofins_aliquota float   , 
      cofins_valor float   , 
      voutro float   , 
      infadprod blob sub_type 1   , 
      notafiscal_item_motDesICMS_id integer   , 
      cprod blob sub_type 1   , 
      ipi_cst varchar  (255)   , 
      ipi_valor_base float   , 
      ipi_aliquota float   , 
      ipi_vipidevol float   , 
      ipi_valor float   , 
      ipi_pdevol float   , 
      cest blob sub_type 1   , 
      fcp_pfcp float   , 
      fcp_vfcp float   , 
      fcp_vbcfcp float   , 
      fcp_vbcfcpst float   , 
      fcp_pfcpst float   , 
      fcp_vfcpst float   , 
      fcp_vbcfcpstret float   , 
      fcp_pfcpstret float   , 
      fcp_vfcpstret float   , 
      icms_vbcufdest float   , 
      icms_vbcfcpufdest float   , 
      icms_pfcpufdest float   , 
      icms_vfcpufdest float   , 
      icms_picmsinter float   , 
      icms_picmsinterpart float   , 
      icms_vicmsufdest float   , 
      icms_vicmsufremet float   , 
      icms_picmsufdest float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_logs( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      system_users_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_mod( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      modelo blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_modfrete( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_pag( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      notafiscal_tpag_id integer    NOT NULL , 
      tpag blob sub_type 1   , 
      vpag float   , 
      xpag blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecf( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      notafiscal_refecfmod_id integer    NOT NULL , 
      necf blob sub_type 1   , 
      ncoo blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecfmod( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refnfe( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer    NOT NULL , 
      refnfe blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_series( 
      id  integer generated by default as identity     NOT NULL , 
      serie blob sub_type 1    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      notafiscal_tpamb_id integer    NOT NULL , 
      notafiscal_mod_id integer    NOT NULL , 
      sequencial integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      notafiscal_tipodocumento_id integer    NOT NULL , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      ordem integer   , 
      exibir char(1)   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_por blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao_sefaz( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_situacao_id integer    NOT NULL , 
      codigo_sefaz integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodoc_series( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_series_id integer    NOT NULL , 
      notafiscal_tipodocumento_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodocumento( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpag( 
      id  integer generated by default as identity     NOT NULL , 
      tpag blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      descricao blob sub_type 1    NOT NULL , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpamb( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpemis( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpimp( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      valor blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      orcamento_situacao_id integer    NOT NULL , 
      vendedor_id integer   , 
      cliente_id integer   , 
      cliente_contato_id integer   , 
      data_orcamento date    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      observacao blob sub_type 1   , 
      valor_produtos float    NOT NULL , 
      desconto float   , 
      peso_total float   , 
      frete_total float   , 
      valor_total float    NOT NULL , 
      tabela_preco_id integer   , 
      justificativa_reprovacao blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_interacoes( 
      id  integer generated by default as identity     NOT NULL , 
      orcamento_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_item( 
      id  integer generated by default as identity     NOT NULL , 
      orcamento_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade float    NOT NULL , 
      valor_unitario float    NOT NULL , 
      valor_total float    NOT NULL , 
      valor_original float    NOT NULL , 
      valor_custo float   , 
      desconto float   , 
      informacoes_adicionais blob sub_type 1   , 
      numero_pedido blob sub_type 1   , 
      numero_item_pedido blob sub_type 1   , 
      valor_frete float   , 
      peso_unitario float   , 
      peso_total float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      ordem integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao_historico( 
      id  integer generated by default as identity     NOT NULL , 
      orcamento_situacao_id integer    NOT NULL , 
      orcamento_id integer    NOT NULL , 
      descricao blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      ordem_producao_situacao_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      produto_ficha_tecnica_id integer    NOT NULL , 
      estoque_deposito_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade float    NOT NULL , 
      data_producao date    NOT NULL , 
      observacoes blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_producao_id integer    NOT NULL , 
      ordem_producao_etapas_situacao_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      ordem integer   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_itens( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_producao_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      estoque_deposito_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade float    NOT NULL , 
      quantidade_total float    NOT NULL , 
      custo float   , 
      custo_total float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao_historico( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_producao_id integer    NOT NULL , 
      ordem_producao_situacao_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_vendas( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_producao_id integer    NOT NULL , 
      venda_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      cliente_id integer    NOT NULL , 
      cliente_contato_id integer   , 
      vendedor_id integer   , 
      ordem_servico_situacao_id integer    NOT NULL , 
      ordem_servico_producao_etapa_id integer   , 
      condicao_pagamento_id integer   , 
      cliente_endereco_id integer   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      numero_os integer   , 
      numero_orcamento integer   , 
      data_emissao date    NOT NULL , 
      valor float    NOT NULL , 
      desconto float   , 
      prazo_entrega date   , 
      validade_dias integer   , 
      data_abertura_os date   , 
      vendedor_comissao float   , 
      vendedor_comissao_avista float   , 
      vendedor_comissao_aprazo float   , 
      observacoes blob sub_type 1   , 
      prazo_garantia date   , 
      valor_pago float   , 
      motivo_nao_aprovacao_orcamento blob sub_type 1   , 
      valor_avista float   , 
      valor_aprazo float   , 
      valor_faturado_vendas float   , 
      usuario_aprovacao_id integer   , 
      informacoes_transporte blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_garantia_historico( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_id integer    NOT NULL , 
      observacoes blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_historico( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_situacao_id integer    NOT NULL , 
      ordem_servico_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      descricao_servico blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade float    NOT NULL , 
      quantidade_atendida float   , 
      valor_unitario float    NOT NULL , 
      valor_total float    NOT NULL , 
      desconto float   , 
      arquivo blob sub_type 1   , 
      largura float   , 
      altura float   , 
      quantidade_a_faturar float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_despesas( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_item_id integer    NOT NULL , 
      despesas_servicos_id integer    NOT NULL , 
      despesas_servicos_tipo_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      valor_unitario float    NOT NULL , 
      quantidade float    NOT NULL , 
      valor_total float    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_ficha_tecnica( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_item_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      quantidade_fixa_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade float    NOT NULL , 
      custo float   , 
      valor_unitario float   , 
      valor_total float   , 
      quantidade_original float    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_mao_obra( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_item_id integer    NOT NULL , 
      funcionario_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade_horas float   , 
      valor_hora float   , 
      valor_total float   , 
      quantidade_horas_original float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_obs_etapas( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_item_id integer    NOT NULL , 
      ordem_servico_producao_etapa_id integer    NOT NULL , 
      observacao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_producao_etapa( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      cor blob sub_type 1   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_venda( 
      id  integer generated by default as identity     NOT NULL , 
      ordem_servico_id integer    NOT NULL , 
      venda_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicadores( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicador_usuario( 
      id  integer generated by default as identity     NOT NULL , 
      painel_indicadores_id integer    NOT NULL , 
      indicador_personalizado_id integer    NOT NULL , 
      system_users_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pais( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      codigo_pais blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE parceiro( 
      id  integer generated by default as identity     NOT NULL , 
      certificado_venda_modalidade_id integer    NOT NULL , 
      tabela_preco_id integer   , 
      vendedor_id integer   , 
      cpf_cnpj blob sub_type 1    NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      razao_social blob sub_type 1   , 
      cep blob sub_type 1   , 
      logradouro blob sub_type 1   , 
      bairro blob sub_type 1   , 
      cidade blob sub_type 1   , 
      estado blob sub_type 1   , 
      fone blob sub_type 1   , 
      email blob sub_type 1   , 
      contato blob sub_type 1   , 
      contato_fone blob sub_type 1   , 
      comissao_percentual float   , 
      deletado_em timestamp   , 
      criado_em timestamp    NOT NULL , 
      alterado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      banco_id integer   , 
      banco_agencia blob sub_type 1   , 
      banco_conta blob sub_type 1   , 
      banco_chavepix blob sub_type 1   , 
      banco_nome_titular blob sub_type 1   , 
      banco_cpfcnpj blob sub_type 1   , 
      chave_pix_tipo_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pdv_permissoes( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pedido_evento( 
      id  integer generated by default as identity     NOT NULL , 
      notafiscal_id integer   , 
      system_unit_id integer   , 
      system_users_id integer   , 
      chave varchar  (50)   , 
      descricao blob sub_type 1   , 
      tipo varchar  (30)   , 
      numero varchar  (10)   , 
      serie integer   , 
      nseqevento integer   , 
      protocolo varchar  (20)   , 
      status integer    DEFAULT 1 , 
      protocolo_resposta varchar  (50)   , 
      xevento blob sub_type 1   , 
      created_at timestamp   , 
      update_at timestamp   , 
      deleted_at timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pessoa_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      plano_conta_tipo_id integer    NOT NULL , 
      plano_conta_origem_id integer    NOT NULL , 
      plano_conta_pai_id integer   , 
      numero blob sub_type 1    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_origem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto( 
      id  integer generated by default as identity     NOT NULL , 
      produto_grupo_id integer    NOT NULL , 
      unidade_medida_id integer    NOT NULL , 
      tipo_recurso_id integer    NOT NULL , 
      produto_fabricante_id integer   , 
      produtogrupo_subgrupo_id integer   , 
      notafiscal_item_orig_id integer   , 
      nome blob sub_type 1    NOT NULL , 
      nome_curto blob sub_type 1   , 
      codigo_EAN blob sub_type 1   , 
      imagem blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      ncm blob sub_type 1   , 
      cest blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_por blob sub_type 1   , 
      obs blob sub_type 1   , 
      referencia blob sub_type 1   , 
      deletado_em timestamp   , 
      especificacao blob sub_type 1   , 
      link_site blob sub_type 1   , 
      peso_liquido float   , 
      peso_bruto float   , 
      habilitado_id integer   , 
      produto_tipo_id integer   , 
      codigo_sku blob sub_type 1   , 
      largura float   , 
      altura float   , 
      comprimento float   , 
      diametro float   , 
      dias_preparacao float   , 
      marca blob sub_type 1   , 
      garantia blob sub_type 1   , 
      unidade_caixa float   , 
      produto_embalagem_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_embalagem( 
      id  integer generated by default as identity     NOT NULL , 
      produto_tipo_embalagem_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      peso float   , 
      dimensoes blob sub_type 1    NOT NULL , 
      altura float   , 
      largura float   , 
      comprimento float   , 
      diametro float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_enderecamento( 
      id  integer generated by default as identity     NOT NULL , 
      produto_filial_id integer    NOT NULL , 
      estoque_prateleira_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_etiqueta_configuracoes( 
      id  integer generated by default as identity     NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fabricante( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      custo_total float   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_despesas( 
      id  integer generated by default as identity     NOT NULL , 
      produto_ficha_tecnica_id integer    NOT NULL , 
      despesas_servicos_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      valor_unitario float    NOT NULL , 
      quantidade float    NOT NULL , 
      valor_total float    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_etapas_producao( 
      id  integer generated by default as identity     NOT NULL , 
      produto_ficha_tecnica_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      ordem integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_itens( 
      id  integer generated by default as identity     NOT NULL , 
      produto_ficha_tecnica_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      quantidade float    NOT NULL , 
      valor_custo float   , 
      valor_total float   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade_fixa_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_mao_obra( 
      id  integer generated by default as identity     NOT NULL , 
      produto_ficha_tecnica_id integer    NOT NULL , 
      funcionario_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      valor_hora float    NOT NULL , 
      quantidade float    NOT NULL , 
      valor_total float    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial( 
      id  integer generated by default as identity     NOT NULL , 
      produto_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      margem float   , 
      preco_venda float    NOT NULL , 
      preco_venda_anterior float   , 
      valor_custo float   , 
      valor_custo_anterior float   , 
      criado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
      estoque_minimo float   , 
      estoque_maximo float   , 
      local_estoque blob sub_type 1   , 
      codigo_balanca blob sub_type 1   , 
      deletado_em timestamp   , 
      estoque_deposito_padrao_id integer   , 
      sob_encomenda_id integer   , 
      gerar_op_venda_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial_historico( 
      id  integer generated by default as identity     NOT NULL , 
      produto_id integer    NOT NULL , 
      produto_filial_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      preco_venda_antigo float    NOT NULL , 
      preco_venda_novo float    NOT NULL , 
      valor_custo_antigo float   , 
      valor_custo_novo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fornecedor( 
      id  integer generated by default as identity     NOT NULL , 
      produto_id integer    NOT NULL , 
      fornecedor_id integer    NOT NULL , 
      codigo_fornecedor blob sub_type 1   , 
      descricao_produto_fornecedor blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      tempo_medio_fornecimento float   , 
      quantidade_minima_compra float   , 
      preco_venda float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_grupo( 
      id  integer generated by default as identity     NOT NULL , 
      tipo_recurso_id integer   , 
      descricao blob sub_type 1    NOT NULL , 
      imagem blob sub_type 1   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por blob sub_type 1   , 
      alterado_por blob sub_type 1   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produtogrupo_subgrupo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      produto_grupo_id integer    NOT NULL , 
      subgrupo_id integer  (11)   , 
      nivel integer  (11)   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_lote( 
      id  integer generated by default as identity     NOT NULL , 
      produto_id integer    NOT NULL , 
      numero blob sub_type 1    NOT NULL , 
      validade date   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por blob sub_type 1   , 
      alterado_por blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo_embalagem( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE resposta( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE servico_formapgto( 
      id  integer generated by default as identity     NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      ordem_servico_id integer    NOT NULL , 
      quantidade_parcelas integer   , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document( 
      id integer    NOT NULL , 
      category_id integer    NOT NULL , 
      system_user_id integer   , 
      title blob sub_type 1    NOT NULL , 
      description blob sub_type 1   , 
      submission_date date   , 
      archive_date date   , 
      filename blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_category( 
      id integer    NOT NULL , 
      name blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_group( 
      id integer    NOT NULL , 
      document_id integer    NOT NULL , 
      system_group_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_user( 
      id integer    NOT NULL , 
      document_id integer    NOT NULL , 
      system_user_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group( 
      id integer    NOT NULL , 
      name blob sub_type 1    NOT NULL , 
      uuid varchar  (36)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program( 
      id integer    NOT NULL , 
      system_group_id integer    NOT NULL , 
      system_program_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program_permissoes( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      system_program_permissoes_id integer    NOT NULL , 
      system_group_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_message( 
      id integer    NOT NULL , 
      system_user_id integer    NOT NULL , 
      system_user_to_id integer    NOT NULL , 
      subject blob sub_type 1    NOT NULL , 
      message blob sub_type 1   , 
      dt_message timestamp   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_notification( 
      id integer    NOT NULL , 
      system_user_id integer    NOT NULL , 
      system_user_to_id integer    NOT NULL , 
      subject blob sub_type 1   , 
      message blob sub_type 1   , 
      dt_message timestamp   , 
      action_url blob sub_type 1   , 
      action_label blob sub_type 1   , 
      icon blob sub_type 1   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_preference( 
      id varchar  (255)    NOT NULL , 
      preference blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program( 
      id integer    NOT NULL , 
      name blob sub_type 1    NOT NULL , 
      controller blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program_permissoes( 
      id  integer generated by default as identity     NOT NULL , 
      system_program_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_unit( 
      id integer    NOT NULL , 
      connection_name blob sub_type 1   , 
      vendas_natureza_operacao_id integer   , 
      nfce_natureza_operacao_id integer   , 
      cnpj varchar  (14)    NOT NULL , 
      name blob sub_type 1    NOT NULL , 
      razao_social varchar  (255)    NOT NULL , 
      inscricao_estadual varchar  (255)   , 
      inscricao_municipal varchar  (255)   , 
      fone blob sub_type 1   , 
      notafiscal_crt_id integer    NOT NULL , 
      pc_credito_sn float  (10,2)    DEFAULT 0 , 
      aliquota_iss float  (10,2)   , 
      aliquota_irrf float  (10,2)   , 
      aliquota_csll float  (10,2)   , 
      sn_matriz char  (1)    DEFAULT 'N'  NOT NULL , 
      nfce_tpamb_id integer   , 
      nfe_tpamb_id integer   , 
      nfe_tpimp_id integer   , 
      nfce_tpimp_id integer   , 
      certificadoA1 blob sub_type 1   , 
      senha_certificado blob sub_type 1   , 
      nfe_homologacao_series_id integer   , 
      nfe_producao_series_id integer   , 
      nfce_homologacao_series_id integer   , 
      nfe_api_documentos_id integer   , 
      nfce_api_documentos_id integer   , 
      nfce_producao_series_id integer   , 
      end_cep blob sub_type 1   , 
      end_mun_codibge blob sub_type 1   , 
      end_municipio blob sub_type 1   , 
      end_uf char  (2)   , 
      end_logradouro blob sub_type 1   , 
      end_bairro blob sub_type 1   , 
      end_numero blob sub_type 1   , 
      end_complemento blob sub_type 1   , 
      nfce_csc_homologacao blob sub_type 1   , 
      nfce_csc_producao blob sub_type 1   , 
      notafiscal_cprod_padrao_id integer   , 
      nfce_id_csc_homologacao blob sub_type 1   , 
      nfce_id_csc_producao blob sub_type 1   , 
      email varchar  (255)   , 
      token_api blob sub_type 1   , 
      mdfe_tpamb_id integer   , 
      mdfe_estadoini_id integer   , 
      veiculo_id integer   , 
      mdfe_api_documentos_id integer   , 
      mdfe_homologacao_series_id integer   , 
      mdfe_producao_series_id integer   , 
      natureza_operacao_compra_id integer   , 
      logo blob sub_type 1   , 
      contador_nome blob sub_type 1   , 
      contador_documento blob sub_type 1   , 
      contador_email blob sub_type 1   , 
      contador_celular blob sub_type 1   , 
      config_host blob sub_type 1   , 
      config_user blob sub_type 1   , 
      config_password blob sub_type 1   , 
      config_port varchar  (11)    DEFAULT '587' , 
      config_from blob sub_type 1   , 
      config_replyname blob sub_type 1   , 
      config_replyto blob sub_type 1   , 
      column_63 integer   , 
      cnae blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_group( 
      id integer    NOT NULL , 
      system_user_id integer    NOT NULL , 
      system_group_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_pdv_permissoes( 
      id  integer generated by default as identity     NOT NULL , 
      empresa_id integer    NOT NULL , 
      pdv_permissoes_id integer    NOT NULL , 
      system_user_id integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program( 
      id integer    NOT NULL , 
      system_user_id integer    NOT NULL , 
      system_program_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program_permissoes( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      system_users_id integer    NOT NULL , 
      system_program_permissoes_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_users( 
      id integer    NOT NULL , 
      name blob sub_type 1    NOT NULL , 
      login blob sub_type 1    NOT NULL , 
      password blob sub_type 1    NOT NULL , 
      email blob sub_type 1   , 
      frontpage_id integer   , 
      system_unit_id integer   , 
      active char  (1)   , 
      accepted_term_policy char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_unit( 
      id integer    NOT NULL , 
      system_user_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco( 
      id  integer generated by default as identity     NOT NULL , 
      tabela_preco_tipo_alteracao_id integer    NOT NULL , 
      tabela_preco_tipo_id integer   , 
      descricao blob sub_type 1    NOT NULL , 
      observacao blob sub_type 1   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      data_hora_promocao_inicial timestamp   , 
      data_hora_promocao_final timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_produto( 
      id  integer generated by default as identity     NOT NULL , 
      tabela_preco_id integer    NOT NULL , 
      produto_filial_id integer    NOT NULL , 
      preco_venda float    NOT NULL , 
      valor_parametro float    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo_alteracao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_documento( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_recurso( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE titulos_tipo_anexo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE unidade_medida( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      sigla blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_por blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo( 
      id  integer generated by default as identity     NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      modelo_marca blob sub_type 1    NOT NULL , 
      placa blob sub_type 1    NOT NULL , 
      ano integer   , 
      tara float   , 
      capacidade_kg float   , 
      renavam blob sub_type 1   , 
      capacidade_m3 float   , 
      mdfe_tpRod_id integer    NOT NULL , 
      estado_id integer    NOT NULL , 
      veiculo_tipo_id integer    NOT NULL , 
      mdfe_tpcar_id integer    NOT NULL , 
      funcionario_motorista_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo_tipo( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda( 
      id  integer generated by default as identity     NOT NULL , 
      venda_situacao_id integer    NOT NULL , 
      orcamento_id integer   , 
      vendedor_id integer   , 
      dispositivos_id integer   , 
      cliente_id integer   , 
      numero_celula_consumo blob sub_type 1   , 
      system_unit_id integer    NOT NULL , 
      filial_saida_id integer    NOT NULL , 
      venda_modalidade_id integer    NOT NULL , 
      venda_tipo_pagamento_id integer    NOT NULL , 
      id_venda_local integer   , 
      data_hora_venda timestamp    NOT NULL , 
      valor_produtos float    NOT NULL , 
      valor_troco float   , 
      desconto float   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      observacao blob sub_type 1   , 
      observacao_nf blob sub_type 1   , 
      peso_total float   , 
      frete_total float   , 
      valor_total float    NOT NULL , 
      cliente_endereco_id integer   , 
      info_faturamento blob sub_type 1   , 
      data_prev_entrega date   , 
      criado_por blob sub_type 1   , 
      alterado_por blob sub_type 1   , 
      valor_comissao float   , 
      comissao_avista float   , 
      comissao_aprazo integer   , 
      valor_avista float   , 
      valor_aprazo float   , 
      tabela_preco_id integer   , 
      movimentacao_origem_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao( 
      id  integer generated by default as identity     NOT NULL , 
      system_unit_id integer    NOT NULL , 
      venda_id integer    NOT NULL , 
      data_devolucao date    NOT NULL , 
      valor float    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_itens( 
      id  integer generated by default as identity     NOT NULL , 
      venda_devolucao_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade float    NOT NULL , 
      valor_unitario float   , 
      valor_total float    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_troca( 
      id  integer generated by default as identity     NOT NULL , 
      venda_devolucao_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      quantidade float    NOT NULL , 
      valor_unitario float    NOT NULL , 
      valor_total float    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_formapgto( 
      id  integer generated by default as identity     NOT NULL , 
      forma_pagamento_id integer    NOT NULL , 
      venda_id integer    NOT NULL , 
      quantidade_parcelas integer   , 
      valor float    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_item( 
      id  integer generated by default as identity     NOT NULL , 
      venda_id integer    NOT NULL , 
      produto_id integer    NOT NULL , 
      quantidade float    NOT NULL , 
      valor_unitario float    NOT NULL , 
      valor_total float    NOT NULL , 
      valor_original float    NOT NULL , 
      valor_custo float   , 
      desconto float   , 
      informacoes_adicionais blob sub_type 1   , 
      cancelado integer    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      numero_pedido blob sub_type 1   , 
      numero_item_pedido blob sub_type 1   , 
      valor_frete float   , 
      peso_unitario float   , 
      peso_total float   , 
      estoque_deposito_id integer   , 
      produto_lote_id integer   , 
      quantidade_devolvida float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta( 
      id  integer generated by default as identity     NOT NULL , 
      venda_meta_situacao_id integer    NOT NULL , 
      system_unit_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      data_inicial date    NOT NULL , 
      data_final date    NOT NULL , 
      valor_meta_geral_prevista float    NOT NULL , 
      valor_meta_geral_realizada float   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      data_ultimo_processamento timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_vendedor( 
      id  integer generated by default as identity     NOT NULL , 
      venda_meta_id integer    NOT NULL , 
      vendedor_id integer    NOT NULL , 
      valor_meta_prevista float   , 
      valor_meta_realizada float   , 
      criado_em timestamp    NOT NULL , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_em timestamp   , 
      aproveiramento_carteira_prevista float   , 
      aproveitamento_carteira_realizada float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_modalidade( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      situacaopdv_id integer   , 
      ordem integer   , 
      cor blob sub_type 1   , 
      criado_por blob sub_type 1    NOT NULL , 
      alterado_por blob sub_type 1   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao_historico( 
      id  integer generated by default as identity     NOT NULL , 
      venda_situacao_id integer    NOT NULL , 
      venda_id integer    NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp    NOT NULL , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_tipo_pagamento( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor( 
      id  integer generated by default as identity     NOT NULL , 
      nome blob sub_type 1    NOT NULL , 
      cpf blob sub_type 1   , 
      vendedor_tipo_comissao_id integer   , 
      vendedor_tipo_pgto_comissao_id integer   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      percentual_comissao float   , 
      criado_por blob sub_type 1   , 
      alterado_por blob sub_type 1   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_comissao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_pgto_comissao( 
      id  integer generated by default as identity     NOT NULL , 
      descricao blob sub_type 1    NOT NULL , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por blob sub_type 1   , 
      criado_por blob sub_type 1   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE xml_contador( 
      id  integer generated by default as identity     NOT NULL , 
      data_inicio date   , 
      data_fim date   , 
      system_user_id integer   , 
      system_unit_id integer   , 
      data_solicitacao timestamp   , 
      caminho_download varchar  (255)   , 
      updated_at timestamp   , 
      created_at timestamp   , 
      info_registros varchar  (255)   , 
      data_click timestamp   , 
      status_id integer    DEFAULT 0 , 
      situacao integer    DEFAULT 1 , 
      caminho_pdf varchar  (255)   , 
      contador integer    DEFAULT 0 , 
      contador_email integer    DEFAULT 0 , 
      downloads integer    DEFAULT 0 , 
      rota blob sub_type 1   , 
      chave varchar  (20)   , 
 PRIMARY KEY (id)) ; 

 
 CREATE UNIQUE INDEX unique_idx_dispositivos_token ON dispositivos COMPUTED BY (token);
  
 ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT apidocumentos_integradoresservicos_65dce47a645da FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT apidocumentos_integradoresservicos_65dce47a6469a FOREIGN KEY (integradores_servicos_id) references integradores_servicos(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_2 FOREIGN KEY (caixa_situacao_id) references caixa_situacao(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_3 FOREIGN KEY (system_users_abertura_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_4 FOREIGN KEY (system_users_operador_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_5 FOREIGN KEY (system_users_fechamento_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_1 FOREIGN KEY (caixa_id) references caixa(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_3 FOREIGN KEY (caixa_tipo_lancamento_id) references caixa_tipo_lancamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_4 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_1 FOREIGN KEY (centro_custo_tipo_id) references centro_custo_tipo(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_agendamentos ADD CONSTRAINT fk_certificado_agendamentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_agente_registro ADD CONSTRAINT certificado_agente_registro_65dce47a68ac5 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_2 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_4 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_5 FOREIGN KEY (certificado_cliente_situacao_id) references certificado_cliente_situacao(id); 
ALTER TABLE certificado_email_historico ADD CONSTRAINT certificado_email_historico_65dce47a6a069 FOREIGN KEY (certificado_cliente_id) references certificado_cliente(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_1 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_4 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_agente_registro_id) references certificado_agente_registro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_5 FOREIGN KEY (certificado_venda_situacao_id) references certificado_venda_situacao(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_7 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_8 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_9 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_12 FOREIGN KEY (certificado_tipo_atendimento_id) references certificado_tipo_atendimento(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_13 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificado_venda_documentos ADD CONSTRAINT certificado_venda_documentos_65dce47a6caea FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT certificado_venda_formapgto_65dce47a6d081 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT certificado_venda_formapgto_65dce47a6d137 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT certificado_venda_modalidade_65dce47a6d77c FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT certificado_venda_modalidade_65dce47a6d837 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_2 FOREIGN KEY (pais_id) references pais(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_3 FOREIGN KEY (residencia_propria) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_4 FOREIGN KEY (utilizar_endereco_cobranca) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_5 FOREIGN KEY (cliente_situacao_id) references cliente_situacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_7 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_8 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_9 FOREIGN KEY (cliente_classificacao_subgrupo_id) references cliente_classificacao_subgrupo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE cliente_classificacao ADD CONSTRAINT fk_cliente_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE cliente_classificacao_subgrupo ADD CONSTRAINT cliente_classificacao_subgrupo_65dce47a70886 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente_contato ADD CONSTRAINT fk_cliente_contato_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_2 FOREIGN KEY (principal) references resposta(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE cliente_historico_limite ADD CONSTRAINT fk_cliente_historico_limite_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_1 FOREIGN KEY (forma_pagamento_id_dinheiro_caixa) references forma_pagamento(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_2 FOREIGN KEY (forma_pagamento_id_titulos_cpag_nf) references forma_pagamento(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_1 FOREIGN KEY (configuracoes_id) references configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_2 FOREIGN KEY (produto_etiqueta_configuracoes_id) references produto_etiqueta_configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_4 FOREIGN KEY (plano_conta_crec_id) references plano_conta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_5 FOREIGN KEY (centro_custo_crec_id) references centro_custo(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_6 FOREIGN KEY (cpag_usa_plano_contas_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_9 FOREIGN KEY (notafiscal_cprod_padrao_orcamento_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_7 FOREIGN KEY (informar_duplicidade_de_item_venda_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_8 FOREIGN KEY (venda_apenas_com_estoque_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_10 FOREIGN KEY (notafiscal_cprod_padrao_venda_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_1 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_2 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_3 FOREIGN KEY (contabil_lancamentos_tipo_id) references contabil_lancamentos_tipo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_4 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_5 FOREIGN KEY (contaspag_contabil_id) references contaspag_contabil(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_6 FOREIGN KEY (conta_corrente_lancamentos_id) references conta_corrente_lancamentos(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_7 FOREIGN KEY (contabil_lancamentos_situacao_id) references contabil_lancamentos_situacao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_8 FOREIGN KEY (contabil_lancamentos_origem_id) references contabil_lancamentos_origem(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_1 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT conta_corrente_lancamentos_65dce47a7856f FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT conta_corrente_lancamentos_65dce47a785fe FOREIGN KEY (conta_corrente_lanc_tipo_id) references conta_corrente_lanc_tipo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT conta_corrente_lancamentos_65dce47a78697 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT conta_corrente_lancamentos_65dce47a787b2 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT conta_corrente_lancamentos_65dce47a78b31 FOREIGN KEY (contaspag_baixas_id) references contaspag_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT conta_corrente_lancamentos_65dce47a78bb8 FOREIGN KEY (contasrec_baixas_id) references contasrec_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT conta_corrente_lancamentos_65dce47a78c2a FOREIGN KEY (conta_corrente_lanc_origem_id) references conta_corrente_lanc_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_1 FOREIGN KEY (contaspag_situacao_id) references contaspag_situacao(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_3 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_4 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_5 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_7 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_3 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_bloco_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT contaspag_bloco_contabil_65dce47a7cba7 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT contaspag_bloco_contabil_65dce47a7cc36 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT contaspag_bloco_contabil_65dce47a7ccb7 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_historico_venc ADD CONSTRAINT fk_contaspag_historico_venc_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_1 FOREIGN KEY (contasrec_situacao_id) references contasrec_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_4 FOREIGN KEY (contasrec_origem_id) references contasrec_origem(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_6 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_7 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_8 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_9 FOREIGN KEY (conta_corrente_boleto_id) references conta_corrente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_10 FOREIGN KEY (boleto_situacao_id) references boleto_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_11 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_12 FOREIGN KEY (contasrec_bloco_id) references contasrec_bloco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_13 FOREIGN KEY (venda_formapgto_id) references venda_formapgto(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_14 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_4 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_5 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec_historico_cobranca ADD CONSTRAINT contasrec_historico_cobranca_65dce47a8133b FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_historico_venc ADD CONSTRAINT fk_contasrec_historico_venc_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE cst_icms ADD CONSTRAINT fk_cst_icms_1 FOREIGN KEY (regime_tributario_id) references notafiscal_crt(id); 
ALTER TABLE despesas_servicos ADD CONSTRAINT fk_despesas_servicos_1 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE dispositivos ADD CONSTRAINT fk_dispositivos_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_deposito ADD CONSTRAINT fk_estoque_deposito_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_estante ADD CONSTRAINT fk_estoque_estante_1 FOREIGN KEY (estoque_rua_id) references estoque_rua(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_1 FOREIGN KEY (estoque_origem_id) references estoque_origem(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_2 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_4 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_5 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_6 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_9 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE estoque_origem ADD CONSTRAINT fk_estoque_origem_1 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_prateleira ADD CONSTRAINT fk_estoque_prateleira_1 FOREIGN KEY (estoque_estante_id) references estoque_estante(id); 
ALTER TABLE estoque_rua ADD CONSTRAINT fk_estoque_rua_1 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_3 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_1 FOREIGN KEY (email_template_id) references email_template(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_2 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_1 FOREIGN KEY (eventos_id) references eventos(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_1 FOREIGN KEY (tipo_documento_id) references tipo_documento(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_3 FOREIGN KEY (meio_pagamento_tef_id) references meio_pagamento_tef(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_4 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_1 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_4 FOREIGN KEY (fornecedor_classificacao_id) references fornecedor_classificacao(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE fornecedor_classificacao ADD CONSTRAINT fk_fornecedor_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE fornecedor_contato ADD CONSTRAINT fk_fornecedor_contato_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE funcionario ADD CONSTRAINT fk_funcionario_1 FOREIGN KEY (funcionario_cargo_id) references funcionario_cargo(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_1 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_2 FOREIGN KEY (ultima_etapa) references resposta(id); 
ALTER TABLE integradores_servicos ADD CONSTRAINT fk_integradores_servicos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_1 FOREIGN KEY (mdfe_tpemit_id) references mdfe_tpemit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_2 FOREIGN KEY (mdfe_tpprop_id) references mdfe_tpprop(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_4 FOREIGN KEY (mdfe_tptransp_id) references mdfe_tptransp(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_6 FOREIGN KEY (UFIni) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_7 FOREIGN KEY (UFFim) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_8 FOREIGN KEY (indCanalVerde) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_9 FOREIGN KEY (indCarregaPosterior) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_10 FOREIGN KEY (mdfe_respSeg_id) references mdfe_respSeg(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_11 FOREIGN KEY (mdfe_cunid_id) references mdfe_cunid(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_12 FOREIGN KEY (mdfe_tpcarga_id) references mdfe_tpcarga(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_13 FOREIGN KEY (mdfe_indpag_id) references mdfe_indpag(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_14 FOREIGN KEY (indAntecipaAdiant) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_15 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veic_estado_id) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_16 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_18 FOREIGN KEY (mdfe_situacao_id) references mdfe_situacao(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_19 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_20 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_21 FOREIGN KEY (cidade_encerramento_id) references cidade(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_2 FOREIGN KEY (mdfe_tpcomp_id) references mdfe_tpcomp(id); 
ALTER TABLE mdfe_condutor ADD CONSTRAINT fk_mdfe_condutor_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_evento ADD CONSTRAINT fk_mdfe_evento_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_2 FOREIGN KEY (cidade_carrega_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_3 FOREIGN KEY (cidade_descarga_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_4 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_2 FOREIGN KEY (UFPer) references estado(id); 
ALTER TABLE mdfe_lacres ADD CONSTRAINT fk_mdfe_lacres_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_2 FOREIGN KEY (mdfe_tpAntecip_id) references mdfe_tpAntecip(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_2 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe_xmlaut ADD CONSTRAINT fk_mdfe_xmlaut_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_1 FOREIGN KEY (natureza_operacao_finalidade_id) references natureza_operacao_finalidade(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_2 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_3 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_4 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_5 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_6 FOREIGN KEY (consumidor_final_id) references resposta(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_10 FOREIGN KEY (cst_icms_nao_contribuinte_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_2 FOREIGN KEY (natop_excecao_tributo_id) references natop_excecao_tributo(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_1 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_3 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_4 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_5 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_6 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao_ncm ADD CONSTRAINT fk_natureza_operacao_ncm_1 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_1 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT natureza_operacao_produtos_65dce47a9dac3 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT natureza_operacao_produtos_65dce47a9db92 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_1 FOREIGN KEY (negocio_origem_id) references negocio_origem(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_3 FOREIGN KEY (negocio_motivo_perda_id) references negocio_motivo_perda(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_4 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_5 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_6 FOREIGN KEY (arquivado) references resposta(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_7 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_9 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_8 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_10 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE negocio_arquivos ADD CONSTRAINT fk_negocio_arquivos_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_2 FOREIGN KEY (negocio_tipo_atividade_id) references negocio_tipo_atividade(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_2 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio_notas ADD CONSTRAINT fk_negocio_notas_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_17 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_18 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_3 FOREIGN KEY (nf_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_4 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_6 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_7 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_8 FOREIGN KEY (notafiscal_tpemis_id) references notafiscal_tpemis(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_16 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_21 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE notafiscal_autxml ADD CONSTRAINT fk_notafiscal_autxml_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_3 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_4 FOREIGN KEY (nota_fiscal_compra_situacao_id) references nota_fiscal_compra_situacao(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_7 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_8 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_13 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_14 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_3 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_4 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_9 FOREIGN KEY (nota_fiscal_compra_itens_situacao_id) references nota_fiscal_compra_itens_situacao(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_8 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_dup ADD CONSTRAINT fk_notafiscal_dup_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_frete_volumes ADD CONSTRAINT fk_notafiscal_frete_volumes_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_1 FOREIGN KEY (notafiscal_refecfmod_id) references notafiscal_refecfmod(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_refnfe ADD CONSTRAINT fk_notafiscal_refnfe_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_4 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_1 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_2 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal_situacao_sefaz ADD CONSTRAINT fk_notafiscal_situacao_sefaz_1 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_1 FOREIGN KEY (notafiscal_series_id) references notafiscal_series(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_2 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_3 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_4 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_6 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE orcamento_interacoes ADD CONSTRAINT fk_orcamento_interacoes_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT orcamento_situacao_historico_65dce47aba1e2 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT orcamento_situacao_historico_65dce47aba2b2 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_2 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_5 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_2 FOREIGN KEY (ordem_producao_etapas_situacao_id) references ordem_producao_etapas_situacao(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_3 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT ordem_producao_situacao_historico_65dce47abd093 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT ordem_producao_situacao_historico_65dce47abd13f FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_8 FOREIGN KEY (usuario_aprovacao_id) references system_users(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_9 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_3 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_4 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_5 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE ordem_servico_garantia_historico ADD CONSTRAINT ordem_servico_garantia_historico_65dce47abecee FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_2 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT ordem_servico_item_despesas_65dce47ac0310 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT ordem_servico_item_despesas_65dce47ac03c4 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT ordem_servico_item_despesas_65dce47ac044e FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT ordem_servico_item_ficha_tecnica_65dce47ac0b76 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT ordem_servico_item_ficha_tecnica_65dce47ac0c46 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT ordem_servico_item_ficha_tecnica_65dce47ac0cee FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT ordem_servico_item_mao_obra_65dce47ac13f9 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT ordem_servico_item_mao_obra_65dce47ac14ab FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT ordem_servico_item_obs_etapas_65dce47ac1ddf FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT ordem_servico_item_obs_etapas_65dce47ac1e6c FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_1 FOREIGN KEY (painel_indicadores_id) references painel_indicadores(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_2 FOREIGN KEY (indicador_personalizado_id) references indicador_personalizado(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_3 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_2 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_3 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_4 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_5 FOREIGN KEY (chave_pix_tipo_id) references chave_pix_tipo(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_1 FOREIGN KEY (plano_conta_tipo_id) references plano_conta_tipo(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_2 FOREIGN KEY (plano_conta_origem_id) references plano_conta_origem(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_2 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_3 FOREIGN KEY (unidade_medida_id) references unidade_medida(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_fabricante_id) references produto_fabricante(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_9 FOREIGN KEY (produtogrupo_subgrupo_id) references produtogrupo_subgrupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_6 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (habilitado_id) references resposta(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_tipo_id) references produto_tipo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_11 FOREIGN KEY (produto_embalagem_id) references produto_embalagem(id); 
ALTER TABLE produto_embalagem ADD CONSTRAINT fk_produto_embalagem_1 FOREIGN KEY (produto_tipo_embalagem_id) references produto_tipo_embalagem(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (estoque_prateleira_id) references estoque_prateleira(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT produto_ficha_tecnica_despesas_65dce47ac94ae FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT produto_ficha_tecnica_despesas_65dce47ac953f FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE produto_ficha_tecnica_etapas_producao ADD CONSTRAINT produto_ficha_tecnica_etapas_producao_65dce47ac9ac2 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT produto_ficha_tecnica_itens_65dce47aca36d FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT produto_ficha_tecnica_itens_65dce47aca431 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT produto_ficha_tecnica_itens_65dce47aca4ac FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT produto_ficha_tecnica_mao_obra_65dce47acab0c FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT produto_ficha_tecnica_mao_obra_65dce47acabd6 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_3 FOREIGN KEY (estoque_deposito_padrao_id) references estoque_deposito(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_4 FOREIGN KEY (sob_encomenda_id) references resposta(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_5 FOREIGN KEY (gerar_op_venda_id) references resposta(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_preco_historico_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_filial_historico_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE produto_grupo ADD CONSTRAINT fk_produto_grupo_1 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produtogrupo_subgrupo ADD CONSTRAINT fk_produtogrupo_subgrupo_1 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto_lote ADD CONSTRAINT fk_produto_lote_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_2 FOREIGN KEY (category_id) references system_document_category(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT system_group_program_permissoes_65dce47ad1f0d FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT system_group_program_permissoes_65dce47ad2062 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT system_group_program_permissoes_65dce47ad2116 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_program_permissoes ADD CONSTRAINT fk_system_program_permissoes_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_2 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_4 FOREIGN KEY (nfe_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_5 FOREIGN KEY (nfe_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_13 FOREIGN KEY (nfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_6 FOREIGN KEY (vendas_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_7 FOREIGN KEY (nfce_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_9 FOREIGN KEY (nfe_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_10 FOREIGN KEY (nfe_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_11 FOREIGN KEY (nfce_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_12 FOREIGN KEY (nfce_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_14 FOREIGN KEY (notafiscal_cprod_padrao_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (nfce_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_3 FOREIGN KEY (nfce_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_1 FOREIGN KEY (nfce_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_16 FOREIGN KEY (mdfe_estadoini_id) references estado(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_18 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_19 FOREIGN KEY (mdfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_20 FOREIGN KEY (mdfe_homologacao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (mdfe_producao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (natureza_operacao_compra_id) references natureza_operacao(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_pdv_permissoes ADD CONSTRAINT system_user_pdv_permissoes_65dce47ad59bd FOREIGN KEY (pdv_permissoes_id) references pdv_permissoes(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT system_user_program_permissoes_65dce47ad63a9 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT system_user_program_permissoes_65dce47ad6450 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT system_user_program_permissoes_65dce47ad64ca FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_2 FOREIGN KEY (frontpage_id) references system_program(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_1 FOREIGN KEY (tabela_preco_tipo_alteracao_id) references tabela_preco_tipo_alteracao(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_2 FOREIGN KEY (tabela_preco_tipo_id) references tabela_preco_tipo(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_1 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_3 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_4 FOREIGN KEY (veiculo_tipo_id) references veiculo_tipo(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (funcionario_motorista_id) references funcionario(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_2 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_3 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_5 FOREIGN KEY (filial_saida_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_6 FOREIGN KEY (venda_modalidade_id) references venda_modalidade(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_7 FOREIGN KEY (venda_tipo_pagamento_id) references venda_tipo_pagamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_8 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_9 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_10 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_12 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_3 FOREIGN KEY (cancelado) references resposta(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_5 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_1 FOREIGN KEY (venda_meta_situacao_id) references venda_meta_situacao(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_1 FOREIGN KEY (venda_meta_id) references venda_meta(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_1 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_1 FOREIGN KEY (vendedor_tipo_comissao_id) references vendedor_tipo_comissao(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_2 FOREIGN KEY (vendedor_tipo_pgto_comissao_id) references vendedor_tipo_pgto_comissao(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_2 FOREIGN KEY (system_user_id) references system_users(id); 

 CREATE VIEW view_consulta_contabil_por_data AS select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento data_vencimento,
	   p.data_pagamento data_pagamento,
	   p.criado_em data_lancamento
from contaspag p,
	 contaspag_contabil cc,
	 contabil_lancamentos cl
where p.id = cc.contaspag_id 
and   cl.contaspag_contabil_id = cc.id
and   p.deletado_em is null
and   cc.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento  data_vencimento,
	   p.data_pagamento  data_pagamento,
	   p.criado_em  data_lancamento
from contasrec p,
	 contabil_lancamentos cl
where cl.contasrec_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_lancamento  data_vencimento,
	   p.data_lancamento  data_pagamento,
	   p.data_lancamento  data_lancamento
from conta_corrente_lancamentos p,
	 contabil_lancamentos cl
where cl.conta_corrente_lancamentos_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
; 

CREATE VIEW view_negocio_timeline AS SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'nota' as "tipo"
FROM negocio_notas

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'arquivo' as "tipo"
FROM negocio_arquivos

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'atividade' as "tipo"
FROM negocio_atividade

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'produto' as "tipo"
FROM negocio_itens

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'etapa' as "tipo"
FROM negocio_etapas_historico
; 

CREATE VIEW vw_caixa_resumo AS select c.caixa_id AS caixa_id,
		'Fundo de Caixa' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 3) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Entradas' AS tipo,
        coalesce(sum(c.valor), 0) AS valor 
        from caixa_lancamentos c where (c.caixa_tipo_lancamento_id = 2) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saidas' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 1) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saldo' AS tipo,sum((case when (c.caixa_tipo_lancamento_id = 1) then (c.valor * -(1)) else c.valor end)) AS valor 
        from caixa_lancamentos c 
        group by c.caixa_id
        ; 

CREATE VIEW vw_caixa_resumo_formas AS Select 
    c.caixa_id caixa_id,
    c.forma_pagamento_id forma_pagamento_id,
    f.descricao nome_forma_pagamento,
    sum(case when c.caixa_tipo_lancamento_id = 1 then c.valor * -1 else c.valor end) total
from caixa_lancamentos c,
     forma_pagamento f
where f.id = c.forma_pagamento_id
group by c.caixa_id, c.forma_pagamento_id; 

CREATE VIEW vw_funil_filial AS SELECT DISTINCT
f.id AS id,
f.descricao AS descricao,
n.system_unit_id AS system_unit_id
FROM funil f
INNER JOIN funil_etapas fe ON fe.funil_id = f.id
INNER JOIN negocio n ON n.funil_etapas_id = fe.id; 

CREATE VIEW vw_lotes_produto AS select l.id as id,
       l.produto_id as produto_id,
       l.numero as numero,
       l.validade as validade,
       sum(e.quant_disponivel) as Quantidade,
       sum(e.quant_reservada) as Reservado
       from produto_lote l
left join estoque_saldos e on e.produto_lote_id = l.id
; 

CREATE VIEW vw_produto_estoque AS SELECT     p.id as id,
           p.nome as nome,
           p.referencia as referencia,
           p.codigo_sku as SKU,
           p.obs as obs,
           f.margem as margem,
           f.valor_custo as valor_custo,
           f.preco_venda as preco_venda,
           p.peso_liquido as peso_liquido,
           p.peso_bruto as preso_bruto,
           g.descricao as grupo,
           sg.descricao as subgrupo,
           u.sigla as sigla,
           p.imagem as imagem,
           p.codigo_ean as ean,
           p.ncm as ncm,
           f.system_unit_id as system_unit_id,
           f.id as produto_filial_id,
           f.estoque_minimo as estoque_minimo,
           f.estoque_maximo as estoque_maximo,           
           (e.quant_disponivel) as Quantidade_Disponivel,
           (e.quant_reservada) as Quantidade_Reservada,
           d.descricao as deposito
           
           FROM produto p 
           INNER JOIN unidade_medida u ON p.unidade_medida_id = u.id 
           INNER JOIN produto_grupo g ON p.produto_grupo_id = g.id
           LEFT JOIN produtogrupo_subgrupo sg ON g.id = sg.produto_grupo_id
           LEFT JOIN produto_filial f ON f.produto_id = p.id 
           LEFT JOIN estoque_saldos e ON e.produto_id = p.id
           LEFT JOIN estoque_deposito d ON e.estoque_deposito_id = d.id
           group by 1,2           
           
           ; 
 
