CREATE TABLE api_documentos( 
      id  INT IDENTITY    NOT NULL  , 
      integradores_id int   NOT NULL  , 
      system_unit_id int   , 
      descricao nvarchar(max)   NOT NULL  , 
      token_api nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE apidocumentos_integradoresservicos( 
      id  INT IDENTITY    NOT NULL  , 
      api_documentos_id int   NOT NULL  , 
      integradores_servicos_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE api_error( 
      id  INT IDENTITY    NOT NULL  , 
      classe nvarchar(max)   , 
      metodo nvarchar(max)   , 
      url nvarchar(max)   , 
      dados nvarchar(max)   , 
      error_message nvarchar(max)   , 
      inserted_at datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ativo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE banco( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      numero nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE boleto_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa( 
      id  INT IDENTITY    NOT NULL  , 
      caixa_situacao_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      system_users_abertura_id int   NOT NULL  , 
      system_users_operador_id int   NOT NULL  , 
      system_users_fechamento_id int   , 
      data_hora_abertura datetime2   , 
      data_hora_fechamento datetime2   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_lancamentos( 
      id  INT IDENTITY    NOT NULL  , 
      caixa_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      caixa_tipo_lancamento_id int   NOT NULL  , 
      valor float   NOT NULL  , 
      data_hora_lancamento datetime2   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      observacao nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      id_origem int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_tipo_lancamento( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      centro_custo_tipo_id int   NOT NULL  , 
      centro_custo_pai_id int   , 
      numero nvarchar(max)   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cep_cache( 
      id  INT IDENTITY    NOT NULL  , 
      cep nvarchar(max)   , 
      rua nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      cidade nvarchar(max)   , 
      bairro nvarchar(max)   , 
      codigo_ibge nvarchar(max)   , 
      uf char  (2)   , 
      cidade_id int   , 
      estado_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agendamentos( 
      id  INT IDENTITY    NOT NULL  , 
      certificado_venda_id int   NOT NULL  , 
      titulo nvarchar(max)   NOT NULL  , 
      data_hora_inicial datetime2   NOT NULL  , 
      data_hora_final datetime2   NOT NULL  , 
      observacao nvarchar(max)   , 
      cor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agente_registro( 
      id  INT IDENTITY    NOT NULL  , 
      parceiro_id int   , 
      nome nvarchar(max)   NOT NULL  , 
      cpf nvarchar(max)   , 
      fone nvarchar(max)   , 
      email nvarchar(max)   , 
      percentual_comissao float   , 
      deletado_em datetime2   , 
      criado_em datetime2   NOT NULL  , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente( 
      id  INT IDENTITY    NOT NULL  , 
      cliente_id int   NOT NULL  , 
      parceiro_id int   , 
      produto_id int   NOT NULL  , 
      certificado_cliente_situacao_id int   NOT NULL  , 
      data_vencimento_certificado date   , 
      certificado_venda_id int   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_email_historico( 
      id  INT IDENTITY    NOT NULL  , 
      certificado_cliente_id int   NOT NULL  , 
      email nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      texto_emissao nvarchar(max)   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora_produtos( 
      id  INT IDENTITY    NOT NULL  , 
      certificadora_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      qtde_dias_vencimento int   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      valor_custo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_atendimento( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_repasse( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      parceiro_id int   , 
      certificado_agente_registro_id int   NOT NULL  , 
      certificado_venda_situacao_id int   NOT NULL  , 
      certificado_venda_modalidade_id int   , 
      certificado_venda_tipomodalidade_id int   , 
      certificado_tipo_repasse_id int   , 
      vendedor_id int   , 
      tabela_preco_id int   , 
      certificadora_id int   , 
      valor_custo float   , 
      data_hora_agendamento datetime2   , 
      data_vencimento_certificado date   , 
      valor_externo float   , 
      custo_externo float   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      agente_comissao_percentual float   , 
      agente_comissao_valor float   , 
      vendedor_comissao_percentual float   , 
      vendedor_comissao_valor float   , 
      atendimento_externo bit   , 
      parceiro_comissao_percentual float   , 
      parceiro_valor_repasse float   , 
      valor_total float   NOT NULL  , 
      comissao_total float   , 
      lucro_total float   , 
      valor_cliente float   , 
      valor_produto float   NOT NULL  , 
      protocolo_emissao nvarchar(max)   , 
      data_emissao date   , 
      data_pagamento date   , 
      certificado_tipo_atendimento_id int   , 
      observacao nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_documentos( 
      id  INT IDENTITY    NOT NULL  , 
      certificado_venda_id int   NOT NULL  , 
      descricao_arquivo nvarchar(max)   NOT NULL  , 
      arquivo nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_formapgto( 
      id  INT IDENTITY    NOT NULL  , 
      certificado_venda_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_modalidade( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      certificado_tipo_repasse_id int   NOT NULL  , 
      certificado_venda_tipomodalidade_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      ordem int   , 
      cor nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_tipomodalidade( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cfop( 
      id  INT IDENTITY    NOT NULL  , 
      numero char  (4)   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      aplicacao nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE chave_pix_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cidade( 
      id  INT IDENTITY    NOT NULL  , 
      estado_id int   NOT NULL  , 
      pais_id int   , 
      nome nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      codigo_ibge nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente( 
      id  INT IDENTITY    NOT NULL  , 
      pessoa_tipo_id int   NOT NULL  , 
      cliente_classificacao_id int   NOT NULL  , 
      cliente_classificacao_subgrupo_id int   , 
      vendedor_id int   , 
      notafiscal_indiedest_id int   NOT NULL  , 
      notafiscal_crt_id int   , 
      nome nvarchar(max)   NOT NULL  , 
      cpf_cnpj nvarchar(max)   , 
      rg nvarchar(max)   , 
      email nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      insc_estadual nvarchar(max)   , 
      insc_municipal nvarchar(max)   , 
      razao_social nvarchar(max)   , 
      fone nvarchar(max)   , 
      observacoes nvarchar(max)   , 
      data_nascimento date   , 
      conjuge nvarchar(max)   , 
      conjuge_cpf nvarchar(max)   , 
      nome_pai nvarchar(max)   , 
      nome_mae nvarchar(max)   , 
      local_trabalho nvarchar(max)   , 
      renda float   , 
      tempo_trabalho nvarchar(max)   , 
      residencia_propria int   , 
      utilizar_endereco_cobranca int   NOT NULL  , 
      cobranca_cnpj nvarchar(max)   , 
      cobranca_nome nvarchar(max)   , 
      cobranca_cep nvarchar(max)   , 
      cobranca_endereco nvarchar(max)   , 
      cobranca_bairro nvarchar(max)   , 
      cobranca_uf nvarchar(max)   , 
      cobranca_cidade nvarchar(max)   , 
      cobranca_fones nvarchar(max)   , 
      cliente_situacao_id int   NOT NULL  , 
      limite_credito float   , 
      limite_utilizado float   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_por nvarchar(max)   , 
      system_unit_id int   , 
      deletado_em datetime2   , 
      vendas_quantidade int   , 
      vendas_valortotal float   , 
      vendas_dataultima datetime2   , 
      vendas_valormaior float   , 
      vendas_datamaior datetime2   , 
      observacoes_financeiro nvarchar(max)   , 
      tabela_preco_id int   , 
      percentual_comissao_vendedor float   , 
      cliente_exterior char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_por nvarchar(max)   , 
      ativo_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao_subgrupo( 
      id  INT IDENTITY    NOT NULL  , 
      cliente_classificacao_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_contato( 
      id  INT IDENTITY    NOT NULL  , 
      cliente_id int   , 
      tipo_contato nvarchar(max)   , 
      nome nvarchar(max)   NOT NULL  , 
      fone nvarchar(max)   , 
      ativo_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_endereco( 
      id  INT IDENTITY    NOT NULL  , 
      logradouro nvarchar(max)   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      principal int   NOT NULL  , 
      cidade_id int   NOT NULL  , 
      bairro nvarchar(max)   , 
      cep nvarchar(max)   , 
      numero nvarchar(max)   , 
      complemento nvarchar(max)   , 
      ativo_id int   NOT NULL  , 
      codigo_ibge varchar  (20)   , 
      ibge_estado int  (2)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_historico_limite( 
      id  INT IDENTITY    NOT NULL  , 
      cliente_id int   NOT NULL  , 
      valor float   NOT NULL  , 
      data_hora datetime2   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_por nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE condicao_pagamento( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      numero_parcelas int   NOT NULL  , 
      dias_primeira_parcelas int   , 
      dias_entre_parcelas int   , 
      taxa float   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes( 
      id  INT IDENTITY    NOT NULL  , 
      forma_pagamento_id_dinheiro_caixa int   , 
      forma_pagamento_id_titulos_cpag_nf int   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes_filial( 
      id  INT IDENTITY    NOT NULL  , 
      configuracoes_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      produto_etiqueta_configuracoes_id int   , 
      plano_conta_mascara nvarchar(max)   , 
      centro_custo_mascara nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      plano_conta_crec_id int   , 
      centro_custo_crec_id int   , 
      cpag_usa_plano_contas_id int   , 
      info_complementar_orcamento nvarchar(max)   , 
      informar_duplicidade_de_item_venda_id int   , 
      venda_apenas_com_estoque_id int   , 
      notafiscal_cprod_padrao_orcamento_id int   , 
      notafiscal_cprod_padrao_venda_id int   , 
      produto_margem_padrao float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos( 
      id  INT IDENTITY    NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      contabil_lancamentos_tipo_id int   NOT NULL  , 
      contabil_lancamentos_situacao_id int   NOT NULL  , 
      contabil_lancamentos_origem_id int   NOT NULL  , 
      data_lancamento date   NOT NULL  , 
      valor float   NOT NULL  , 
      contasrec_id int   , 
      contaspag_contabil_id int   , 
      conta_corrente_lancamentos_id int   , 
      historico nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_origem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      banco_id int   , 
      nome nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      agencia nvarchar(max)   , 
      conta nvarchar(max)   , 
      agencia_digito nvarchar(max)   , 
      conta_digito nvarchar(max)   , 
      end_logradouro nvarchar(max)   , 
      end_bairro nvarchar(max)   , 
      end_cidade nvarchar(max)   , 
      end_estado nvarchar(max)   , 
      end_cep nvarchar(max)   , 
      end_numero nvarchar(max)   , 
      boleto_convenio nvarchar(max)   , 
      boleto_carteira nvarchar(max)   , 
      boleto_gerar bit   NOT NULL  , 
      boleto_codigo_cedente nvarchar(max)   , 
      boleto_digito_cod_cedente nvarchar(max)   , 
      boleto_instrucoes nvarchar(max)   , 
      boleto_multa float   , 
      boleto_juros_dia float   , 
      boleto_digitos_nosso_numero int   , 
      boleto_local_pagamento nvarchar(max)   , 
      boleto_codigo_transmissao nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lancamentos( 
      id  INT IDENTITY    NOT NULL  , 
      conta_corrente_id int   NOT NULL  , 
      conta_corrente_lanc_tipo_id int   NOT NULL  , 
      conta_corrente_lanc_origem_id int   NOT NULL  , 
      contaspag_baixas_id int   , 
      contasrec_baixas_id int   , 
      data_lancamento date   NOT NULL  , 
      valor float   NOT NULL  , 
      documento nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      historico nvarchar(max)   , 
      plano_conta_id int   , 
      centro_custo_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_origem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag( 
      id  INT IDENTITY    NOT NULL  , 
      contaspag_situacao_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      contaspag_origem_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      numero_documento nvarchar(max)   NOT NULL  , 
      parcela nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      data_emissao date   NOT NULL  , 
      valor float   NOT NULL  , 
      data_vencimento date   NOT NULL  , 
      data_venc_original date   , 
      observacao nvarchar(max)   , 
      data_pagamento date   , 
      desconto float   , 
      juros float   , 
      valor_pago float   , 
      valor_aberto float   , 
      valor_multa float   , 
      cheque_banco_id int   , 
      cheque_agencia nvarchar(max)   , 
      cheque_conta float   , 
      cheque_emitente nvarchar(max)   , 
      cheque_cpfcnpj nvarchar(max)   , 
      data_competencia date   , 
      contaspag_bloco_id int   , 
      nota_fiscal_compra_id int   , 
      data_vencimento_calendario datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_anexos( 
      id  INT IDENTITY    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      titulos_tipo_anexo_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      arquivo nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_baixas( 
      id  INT IDENTITY    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      conta_corrente_id int   NOT NULL  , 
      data_pagamento date   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      juros float   , 
      desconto float   , 
      saldo_aberto float   , 
      saldo_apagar float   , 
      multa float   , 
      historico nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco( 
      id  INT IDENTITY    NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      contaspag_origem_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      quantidade_parcelas int   NOT NULL  , 
      primeiro_vencimento date   , 
      valor float   NOT NULL  , 
      numero_documento nvarchar(max)   , 
      observacao nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco_contabil( 
      id  INT IDENTITY    NOT NULL  , 
      contaspag_bloco_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_contabil( 
      id  INT IDENTITY    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_historico_venc( 
      id  INT IDENTITY    NOT NULL  , 
      contaspag_id int   NOT NULL  , 
      vencimento_anterior date   , 
      vencimento_atual date   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_origem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      contasrec_situacao_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      contasrec_origem_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      numero_documento nvarchar(max)   , 
      parcela nvarchar(max)   , 
      valor float   NOT NULL  , 
      data_vencimento date   NOT NULL  , 
      data_venc_original date   , 
      observacao nvarchar(max)   , 
      data_pagamento date   , 
      desconto float   , 
      juros float   , 
      valor_pago float   , 
      valor_aberto float   , 
      valor_multa float   , 
      cheque_banco_id int   , 
      cheque_agencia nvarchar(max)   , 
      cheque_conta nvarchar(max)   , 
      cheque_emitente nvarchar(max)   , 
      cheque_cpfcnpj nvarchar(max)   , 
      data_competencia date   , 
      conta_corrente_boleto_id int   , 
      boleto_situacao_id int   , 
      boleto_nosso_numero nvarchar(max)   , 
      vendedor_comissao float   , 
      vendedor_id int   , 
      contasrec_bloco_id int   , 
      venda_formapgto_id int   , 
      data_emissao date   NOT NULL  , 
      ativo_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_anexos( 
      id  INT IDENTITY    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      titulos_tipo_anexo_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      arquivo nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_baixas( 
      id  INT IDENTITY    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      conta_corrente_id int   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      juros float   , 
      desconto float   , 
      saldo_aberto float   NOT NULL  , 
      saldo_apagar float   , 
      multa float   , 
      historico nvarchar(max)   , 
      data_pagamento date   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_bloco( 
      id  INT IDENTITY    NOT NULL  , 
      cliente_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      plano_conta_id int   NOT NULL  , 
      centro_custo_id int   NOT NULL  , 
      quantidade_parcelas int   NOT NULL  , 
      primeiro_vencimento date   , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      numero_documento nvarchar(max)   , 
      observacao nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_cobranca( 
      id  INT IDENTITY    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      historico nvarchar(max)   NOT NULL  , 
      data_cobranca date   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_venc( 
      id  INT IDENTITY    NOT NULL  , 
      contasrec_id int   NOT NULL  , 
      vencimento_anterior date   , 
      vencimento_atual date   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_origem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_cofins( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cst_numero nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_icms( 
      id  INT IDENTITY    NOT NULL  , 
      regime_tributario_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cst_numero nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_ipi( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cst_numero nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_pis( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cst_numero nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos( 
      id  INT IDENTITY    NOT NULL  , 
      despesas_servicos_tipo_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE dispositivos( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      token varchar  (100)   NOT NULL  , 
      serial_dispositivo nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      deletado_em datetime2   , 
      data_hora_ultima_sincronizacao datetime2   , 
      ip_sincronizacao nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE email_template( 
      id  INT IDENTITY    NOT NULL  , 
      titulo nvarchar(max)   NOT NULL  , 
      mensagem nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estado( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      sigla char  (2)   NOT NULL  , 
      codigo_ibge nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_deposito( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_estante( 
      id  INT IDENTITY    NOT NULL  , 
      estoque_rua_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_lancamentos( 
      id  INT IDENTITY    NOT NULL  , 
      produto_id int   NOT NULL  , 
      estoque_origem_id int   NOT NULL  , 
      estoque_tipo_movimentacao_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      produto_lote_id int   , 
      venda_id int   , 
      nota_fiscal_compra_id int   , 
      ordem_producao_id int   , 
      quantidade float   NOT NULL  , 
      observacao nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      preco_venda float   , 
      preco_custo float   , 
      data_lancamento date   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_origem( 
      id  INT IDENTITY    NOT NULL  , 
      estoque_tipo_movimentacao_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_prateleira( 
      id  INT IDENTITY    NOT NULL  , 
      estoque_estante_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_rua( 
      id  INT IDENTITY    NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_saldos( 
      id  INT IDENTITY    NOT NULL  , 
      produto_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      produto_lote_id int   , 
      quant_disponivel float   NOT NULL  , 
      quant_reservada float   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      preco_medio_venda float   , 
      preco_medio_custo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_tipo_movimentacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos( 
      id  INT IDENTITY    NOT NULL  , 
      system_program_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      email_template_id int   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_documentos( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   , 
      system_users_id int   , 
      system_unit_id int   , 
      cstat int   , 
      xmotivo varchar  (255)   , 
      xevento varchar  (255)   , 
      tpevento varchar  (255)   , 
      nseqevento int   , 
      dhregevento datetime2   , 
      nprot varchar  (255)   , 
      origem_event varchar  (255)   , 
      mensagem_manual nvarchar(max)   , 
      tpamb int   , 
      veraplic varchar  (255)   , 
      chnfe varchar  (255)   , 
      dhrecbto datetime2   , 
      digval varchar  (255)   , 
      xml nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_systemuser( 
      id  INT IDENTITY    NOT NULL  , 
      eventos_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      enviar_email int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE forma_pagamento( 
      id  INT IDENTITY    NOT NULL  , 
      codigo_interno int  (11)   NOT NULL  , 
      tipo_documento_id int   NOT NULL  , 
      meio_pagamento_tef_id int   , 
      notafiscal_tpag_id int   , 
      descricao nvarchar(max)   NOT NULL  , 
      prazo_pagamento int   , 
      taxa float   , 
      deletado_em datetime2   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      criado_por nvarchar(max)   , 
      alterado_por nvarchar(max)   , 
      utiliza_pdv char  (1)   , 
      obriga_nf_pdv char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE formapgto_condpgto( 
      id  INT IDENTITY    NOT NULL  , 
      condicao_pagamento_id int   NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor( 
      id  INT IDENTITY    NOT NULL  , 
      pessoa_tipo_id int   NOT NULL  , 
      fornecedor_classificacao_id int   , 
      nome nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      insc_estadual nvarchar(max)   , 
      insc_municipal nvarchar(max)   , 
      cpf_cnpj nvarchar(max)   , 
      razao_social nvarchar(max)   , 
      logradouro nvarchar(max)   , 
      cidade_id int   , 
      bairro nvarchar(max)   , 
      cep nvarchar(max)   , 
      numero nvarchar(max)   , 
      complemento nvarchar(max)   , 
      fone nvarchar(max)   , 
      email nvarchar(max)   , 
      site nvarchar(max)   , 
      observacoes nvarchar(max)   , 
      notafiscal_crt_id int   , 
      deletado_em datetime2   , 
      notafiscal_indiedest_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_classificacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      ativo_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_contato( 
      id  INT IDENTITY    NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      tipo_contato nvarchar(max)   , 
      nome nvarchar(max)   NOT NULL  , 
      fone nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario( 
      id  INT IDENTITY    NOT NULL  , 
      funcionario_cargo_id int   , 
      nome nvarchar(max)   NOT NULL  , 
      cpf nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      valor_salario float   , 
      valor_hora float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario_cargo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil_etapas( 
      id  INT IDENTITY    NOT NULL  , 
      funil_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      numero_etapa int   NOT NULL  , 
      cor_etapa nvarchar(max)   , 
      cor_negocio nvarchar(max)   , 
      ultima_etapa int   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      permite_edicao char  (1)   , 
      permite_exclusao char  (1)   , 
      kanban char  (1)   , 
      etapa_ganha char  (1)   , 
      etapa_perde char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE indicador_personalizado( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      url_indicador nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores_servicos( 
      id  INT IDENTITY    NOT NULL  , 
      integradores_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE inutilizar_numero( 
      id  INT IDENTITY    NOT NULL  , 
      created_at datetime2   , 
      system_user int   , 
      update_at datetime2   , 
      deleted_at datetime2   , 
      ninicio varchar  (20)   , 
      nfinal varchar  (20)   , 
      serie varchar  (20)   , 
      system_unit_id int   , 
      system_users_id int   , 
      xml_retorno nvarchar(max)   , 
      protocolo varchar  (50)   , 
      xmotivo varchar  (200)   , 
      cstat int   , 
      notafiscal_id int   , 
      xjust varchar  (150)   , 
      tipo int  (1)   NOT NULL    DEFAULT 1, 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      idmdfe varchar  (255)   , 
      chMDF nvarchar(max)   , 
      nProt nvarchar(max)   , 
      cStat nvarchar(max)   , 
      mdfe_tpemit_id int   NOT NULL  , 
      mdfe_tpprop_id int   NOT NULL  , 
      mdfe_tptransp_id int   , 
      mdfe_tpcar_id int   NOT NULL  , 
      nMDF nvarchar(max)   NOT NULL  , 
      serie nvarchar(max)   , 
      dhEmi datetime2   , 
      UFIni int   NOT NULL  , 
      UFFim int   NOT NULL  , 
      dhIniViagem datetime2   , 
      indCanalVerde int   NOT NULL  , 
      indCarregaPosterior int   NOT NULL  , 
      infAdFisco nvarchar(max)   , 
      infCpl nvarchar(max)   , 
      mdfe_respSeg_id int   , 
      seguro_cpfcnpj nvarchar(max)   , 
      seguradora_xSeg nvarchar(max)   , 
      seguradora_cnpj nvarchar(max)   , 
      vCarga float   , 
      mdfe_cunid_id int   NOT NULL  , 
      qCarga float   , 
      mdfe_tpcarga_id int   , 
      prod_xProd nvarchar(max)   , 
      prod_cEAN nvarchar(max)   , 
      prod_NCM nvarchar(max)   , 
      pgto_cpfcnpj nvarchar(max)   , 
      pgto_idEstrangeiro nvarchar(max)   , 
      pgto_xNome nvarchar(max)   , 
      pgto_vContrato float   , 
      pgto_indAltoDesemp nvarchar(max)   , 
      mdfe_indpag_id int   , 
      pgto_vAdiant float   , 
      indAntecipaAdiant int   , 
      pgto_codBanco nvarchar(max)   , 
      pgto_codAgencia nvarchar(max)   , 
      pgto_CNPJIPEF nvarchar(max)   , 
      pgto_PIX nvarchar(max)   , 
      veic_rntrc nvarchar(max)   , 
      mdfe_tpRod_id int   NOT NULL  , 
      veic_estado_id int   NOT NULL  , 
      veic_cint int   , 
      veic_placa nvarchar(max)   , 
      veic_renavam nvarchar(max)   , 
      veic_tara float   , 
      justificativa_cancelamento nvarchar(max)   , 
      mensagem_sefaz nvarchar(max)   , 
      status nvarchar(max)   , 
      data_hora_envio datetime2   , 
      protocolo_cancelamento nvarchar(max)   , 
      datahora_cancelamento datetime2   , 
      veiculo_id int   NOT NULL  , 
      mdfe_situacao_id int   NOT NULL  , 
      mdfe_tpamb_id int   NOT NULL  , 
      api_documentos_id int   , 
      xml_cancelamento nvarchar(max)   , 
      xml nvarchar(max)   , 
      cidade_encerramento_id int   , 
      cmunencerramento int   , 
      data_encerramento date   , 
      datahora_encerramento datetime2   , 
      protocolo_encerramento nvarchar(max)   , 
      xml_encerramento nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_componentes( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      mdfe_tpcomp_id int   NOT NULL  , 
      vComp float   , 
      xComp nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_condutor( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      xnome nvarchar(max)   NOT NULL  , 
      cpf nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_ctes( 
      id  INT IDENTITY    NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      chCTe nvarchar(max)   , 
      SegCodBarra nvarchar(max)   , 
      indReentrega int   NOT NULL  , 
      mdfe_infmundescarga_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_cunid( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_evento( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      status nvarchar(max)   , 
      codigo_status nvarchar(max)   , 
      motivo_status nvarchar(max)   , 
      id_evento nvarchar(max)   , 
      numero_sequencial nvarchar(max)   , 
      chave nvarchar(max)   , 
      protocolo nvarchar(max)   , 
      tipo_evento nvarchar(max)   , 
      data_recebimento nvarchar(max)   , 
      data_evento nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_inclusao_dfe( 
      id  INT IDENTITY    NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      mdfe_id int   NOT NULL  , 
      notafiscal_id int   , 
      cidade_carrega_id int   NOT NULL  , 
      cidade_descarga_id int   NOT NULL  , 
      chave nvarchar(max)   NOT NULL  , 
      protocolo nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_indpag( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmuncarrega( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      cidade_id int   NOT NULL  , 
      cMunCarrega nvarchar(max)   NOT NULL  , 
      xMunCarrega nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmundescarga( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      cidade_id int   NOT NULL  , 
      cMunDescarga nvarchar(max)   NOT NULL  , 
      xMunDescarga nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infpercurso( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      UFPer int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_lacres( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      nLacre nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_logs( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_mdfes( 
      id  INT IDENTITY    NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      chMDFe nvarchar(max)   , 
      indReentrega int   NOT NULL  , 
      mdfe_infmundescarga_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_nfes( 
      id  INT IDENTITY    NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      chNFe nvarchar(max)   , 
      SegCodBarra nvarchar(max)   , 
      indReentrega int   NOT NULL  , 
      mdfe_infmundescarga_id int   NOT NULL  , 
      notafiscal_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_parcelas( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      nParcela nvarchar(max)   , 
      dVenc date   , 
      vParcela float   , 
      mdfe_tpAntecip_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_respSeg( 
      id  INT IDENTITY    NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_series( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      mdfe_tpamb_id int   NOT NULL  , 
      serie nvarchar(max)   NOT NULL  , 
      sequencial int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      cor nvarchar(max)   , 
      ordem int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpamb( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      valor nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpAntecip( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcar( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcarga( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcomp( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpemit( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpprop( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpRod( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tptransp( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_xmlaut( 
      id  INT IDENTITY    NOT NULL  , 
      mdfe_id int   NOT NULL  , 
      cpfcnpj nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE meio_pagamento_tef( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE movimentacao_origem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natop_excecao_tributo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao( 
      id  INT IDENTITY    NOT NULL  , 
      natureza_operacao_finalidade_id int   NOT NULL  , 
      cst_icms_id int   , 
      cst_icms_nao_contribuinte_id int   , 
      cst_ipi_id int   , 
      cst_pis_id int   , 
      cst_cofins_id int   , 
      cfop char  (4)   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      obs_padrao nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      icms_aliquota float   , 
      ipi_aliquota float   , 
      ipi_codigo_enquadramento nvarchar(max)   , 
      pis_aliquota float   , 
      pis_base float   , 
      cofins_aliquota float   , 
      consumidor_final_id int   , 
      cofins_base float   , 
      icms_pRedBC float   , 
      icms_pICMS float   , 
      icms_pDif float   , 
      icms_vICMSDeson float   , 
      icms_pMVAST float   , 
      icms_pICMSST float   , 
      icms_pFCP float   , 
      icms_pFCPST float   , 
      icms_pFCPSTRet float   , 
      icms_pST float   , 
      icms_pCredSN date   , 
      icms_pRedBCEfet float   , 
      icms_pICMSEfet float   , 
      notafiscal_item_modbc_id int   , 
      notafiscal_item_modbcst_id int   , 
      notafiscal_item_motDesICMS_id int   , 
      icms_pFCPUFDest float   , 
      icms_pICMSUFDest float   , 
      icms_baseST float   , 
      icms_base float   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_estados( 
      id  INT IDENTITY    NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      estado_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_excecao( 
      id  INT IDENTITY    NOT NULL  , 
      natureza_operacao_id int   NOT NULL  , 
      natop_excecao_tributo_id int   NOT NULL  , 
      cst_pis_id int   , 
      cst_ipi_id int   , 
      cst_icms_id int   , 
      cst_cofins_id int   , 
      cfop char  (4)   , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      icms_aliquota float   , 
      ipi_aliquota float   , 
      ipi_codigo_enquadramento nvarchar(max)   , 
      pis_aliquota float   , 
      pis_base float   , 
      cofins_aliquota float   , 
      cofins_base float   , 
      icms_predbc float   , 
      icms_picms float   , 
      icms_pdif float   , 
      icms_vicmsdeson float   , 
      icms_pmvast float   , 
      icms_picmsst float   , 
      icms_pfcp float   , 
      icms_pfcpst float   , 
      icms_pfcpstret float   , 
      icms_pst float   , 
      icms_pcredsn float   , 
      icms_predbcefet float   , 
      icms_picmsefet float   , 
      icms_pfcpufdest float   , 
      icms_picmsufdest float   , 
      icms_base float   , 
      icms_basest float   , 
      notafiscal_item_modbc_id int   , 
      notafiscal_item_modbcst_id int   , 
      notafiscal_item_motDesICMS_id int   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_finalidade( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_ncm( 
      id  INT IDENTITY    NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      ncm nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_origens( 
      id  INT IDENTITY    NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      notafiscal_item_orig_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_produtos( 
      id  INT IDENTITY    NOT NULL  , 
      produto_id int   NOT NULL  , 
      natureza_operacao_excecao_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      negocio_origem_id int   NOT NULL  , 
      funil_id int   , 
      funil_etapas_id int   NOT NULL  , 
      titulo nvarchar(max)   NOT NULL  , 
      valor float   , 
      data_abertura date   NOT NULL  , 
      ordem int   NOT NULL  , 
      data_fechamento date   , 
      negocio_motivo_perda_id int   , 
      comentarios_motivo_perda nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      contato_nome nvarchar(max)   , 
      contato_fone nvarchar(max)   , 
      ativo_id int   NOT NULL  , 
      arquivado int   NOT NULL  , 
      data_fechamento_esperada date   , 
      vendedor_id int   , 
      mes int   , 
      ano int   , 
      orcamento_id int   , 
      cliente_id int   , 
      deletado_em datetime2   , 
      contato_email nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_arquivos( 
      id  INT IDENTITY    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      arquivo nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_atividade( 
      id  INT IDENTITY    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      negocio_tipo_atividade_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      horario_inicial datetime2   , 
      horario_final datetime2   , 
      observacao nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_etapas_historico( 
      id  INT IDENTITY    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      funil_etapas_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_itens( 
      id  INT IDENTITY    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      valor_unitario float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      desconto float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_motivo_perda( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_notas( 
      id  INT IDENTITY    NOT NULL  , 
      negocio_id int   NOT NULL  , 
      nota nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_origem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_tipo_atividade( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      icone nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   , 
      venda_id int   , 
      numero nvarchar(max)   NOT NULL  , 
      data_emissao datetime2   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      texto_rodape nvarchar(max)   , 
      data_saida datetime2   , 
      icms_basecalc float   , 
      icms_valor float   , 
      icms_subst_base_calc int   , 
      icms_subst_valor float   , 
      frete_valor float   , 
      seguro_valor float   , 
      outras_despesas float   , 
      ipi_valor float   , 
      serie nvarchar(max)   , 
      valor_total_produtos float   , 
      valor_total_nota float   , 
      transp_nome nvarchar(max)   , 
      transp_cnpj nvarchar(max)   , 
      transp_inscest nvarchar(max)   , 
      transp_endereco nvarchar(max)   , 
      transp_cidade nvarchar(max)   , 
      transp_placaveiculo nvarchar(max)   , 
      transp_uf nvarchar(max)   , 
      transp_veiculouf nvarchar(max)   , 
      transp_veiculoRNTC nvarchar(max)   , 
      transp_numeracao nvarchar(max)   , 
      nf_tipodocumento_id int   NOT NULL  , 
      notafiscal_situacao_id int   NOT NULL  , 
      notafiscal_crt_id int   NOT NULL  , 
      cliente_endereco nvarchar(max)   , 
      cliente_complemento nvarchar(max)   , 
      cliente_numero nvarchar(max)   , 
      cliente_bairro nvarchar(max)   , 
      cliente_cidade nvarchar(max)   , 
      cliente_cep nvarchar(max)   , 
      cliente_estado nvarchar(max)   , 
      cliente_nome nvarchar(max)   , 
      cliente_cpfcnpj nvarchar(max)   , 
      cliente_inscest nvarchar(max)   , 
      cliente_inscmuni nvarchar(max)   , 
      cliente_fone nvarchar(max)   , 
      cliente_cidade_codibge int   , 
      cliente_suframa nvarchar(max)   , 
      justificativa_cancelamento nvarchar(max)   , 
      chave nvarchar(max)   , 
      protocolo_envio nvarchar(max)   , 
      notafiscal_indiedest_id int   NOT NULL  , 
      protocolo_cancelamento nvarchar(max)   , 
      datahora_cancelamento datetime2   , 
      cce_datahora_evento datetime2   , 
      cce_sequencial int   , 
      cce_correcao nvarchar(max)   , 
      cce_protocolo nvarchar(max)   , 
      infadfisco nvarchar(max)   , 
      desconto_valor float   , 
      pis_valor float   , 
      cofins_valor float   , 
      fatura_numero nvarchar(max)   , 
      fatura_valor_original float   , 
      fatura_valor_desconto float   , 
      fatura_valor_liquido float   , 
      notafiscal_iddest_id int   NOT NULL  , 
      notafiscal_tpimp_id int   NOT NULL  , 
      notafiscal_tpemis_id int   NOT NULL  , 
      notafiscal_finnfe_id int   NOT NULL  , 
      notafiscal_indfinal_id int   NOT NULL  , 
      notafiscal_indpres_id int   NOT NULL  , 
      verproc nvarchar(max)   , 
      notafiscal_indpag_id int   NOT NULL  , 
      retirada_marcado int   , 
      retirada_cpfcnpj nvarchar(max)   , 
      retirada_xlgr nvarchar(max)   , 
      retirada_nro nvarchar(max)   , 
      retirada_xcpl nvarchar(max)   , 
      retirada_xbairro nvarchar(max)   , 
      retirada_cmun int   , 
      retirada_xmun nvarchar(max)   , 
      retirada_uf nvarchar(max)   , 
      entrega_marcado int   , 
      entrega_cpfcnpj nvarchar(max)   , 
      entrega_xlgr nvarchar(max)   , 
      entrega_nro nvarchar(max)   , 
      entrega_xcpl nvarchar(max)   , 
      entrega_xbairro nvarchar(max)   , 
      entrega_cmun int   , 
      entrega_xmun nvarchar(max)   , 
      entrega_uf nvarchar(max)   , 
      vicmsufdest float   , 
      vicmsufremet float   , 
      vfcpufdest float   , 
      notafiscal_modelo_id int   NOT NULL  , 
      dispositivos_id int   , 
      xml nvarchar(max)   , 
      data_hora_envio datetime2   , 
      xml_cancelamento nvarchar(max)   , 
      issqn_vserv float   , 
      issqn_vbc float   , 
      issqn_viss float   , 
      issqn_dcompet date   , 
      issqn_reftrib nvarchar(max)   , 
      icms_vfcp float   , 
      icms_vfcpst float   , 
      icms_vfcpstret float   , 
      layout_versao nvarchar(max)   , 
      ipi_vipidevol float   , 
      vtroco float   , 
      notafiscal_tpamb_id int   NOT NULL  , 
      notafiscal_mod_id int   NOT NULL  , 
      infcpl nvarchar(max)   , 
      notafiscal_modfrete_id int   NOT NULL  , 
      status nvarchar(max)   , 
      mensagem nvarchar(max)   , 
      cce_xml nvarchar(max)   , 
      cce_pdf nvarchar(max)   , 
      codigo_sefaz int   , 
      sn_carta_correcao char  (1)   NOT NULL    DEFAULT 'N', 
      deletado_em datetime2   , 
      contingencia_data datetime2   , 
      contingencia_motivo nvarchar(max)   , 
      exporta_ufsaidapais nvarchar(max)   , 
      exporta_xlocexporta nvarchar(max)   , 
      exporta_xlocdespacho nvarchar(max)   , 
      cliente_cpais nvarchar(max)   , 
      cliente_xpais nvarchar(max)   , 
      natureza_operacao_id int   , 
      movimentacao_origem_id int   , 
      inutilizar int   , 
      xml_inicial nvarchar(max)   , 
      entrega_cuf int  (2)   , 
      xml_assinado nvarchar(max)   , 
      protolo_xml nvarchar(max)   , 
      xml_autorizado nvarchar(max)   , 
      cep_entrega varchar  (15)   , 
      cep_retirada varchar  (15)   , 
      entrega_xnome varchar  (200)   , 
      xml_carta nvarchar(max)   , 
      protocolo_carta_resposta varchar  (200)   , 
      descricao nvarchar(max)   , 
      xevento nvarchar(max)   , 
      xmotivo nvarchar(max)   , 
      cstat int   , 
      dhregevento varchar  (50)   , 
      nseqevento int  (11)   , 
      nprot varchar  (100)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_autxml( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      cpf_cnpj nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   NOT NULL  , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      fornecedor_id int   , 
      numero nvarchar(max)   NOT NULL  , 
      data_emissao datetime2   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      natop nvarchar(max)   , 
      data_saida datetime2   , 
      infcpl nvarchar(max)   , 
      infadfisco nvarchar(max)   , 
      icms_basecalc float   , 
      icms_valor float   , 
      icms_subst_base_calc float   , 
      icms_subst_valor float   , 
      frete_valor float   , 
      seguro_valor float   , 
      outras_despesas float   , 
      ipi_valor float   , 
      serie nvarchar(max)   , 
      valor_total_produtos float   , 
      valor_total_nota float   , 
      transp_nome nvarchar(max)   , 
      transp_cnpj nvarchar(max)   , 
      transp_inscest nvarchar(max)   , 
      transp_endereco nvarchar(max)   , 
      transp_cidade nvarchar(max)   , 
      transp_placaveiculo nvarchar(max)   , 
      transp_uf nvarchar(max)   , 
      transp_veiculouf nvarchar(max)   , 
      transp_veiculorntc nvarchar(max)   , 
      transp_numeracao nvarchar(max)   , 
      notafiscal_tipodocumento_id int   NOT NULL  , 
      nota_fiscal_compra_situacao_id int   NOT NULL  , 
      notafiscal_crt_id int   , 
      obs_importacao_xml nvarchar(max)   , 
      cliente_endereco nvarchar(max)   , 
      cliente_complemento nvarchar(max)   , 
      cliente_numero nvarchar(max)   , 
      cliente_bairro nvarchar(max)   , 
      cliente_cidade nvarchar(max)   , 
      cliente_cep nvarchar(max)   , 
      cliente_estado nvarchar(max)   , 
      cliente_nome nvarchar(max)   , 
      cliente_cpfcnpj nvarchar(max)   , 
      cliente_inscest nvarchar(max)   , 
      cliente_fone nvarchar(max)   , 
      cliente_cidade_codibge nvarchar(max)   , 
      cliente_inscmuni nvarchar(max)   , 
      cliente_suframa nvarchar(max)   , 
      justificativa_cancelamento nvarchar(max)   , 
      chave nvarchar(max)   , 
      protocolo_envio nvarchar(max)   , 
      notafiscal_indiedest_id int   , 
      protocolo_cancelamento nvarchar(max)   , 
      datahora_cancelamento nvarchar(max)   , 
      cce_datahora_evento nvarchar(max)   , 
      cce_sequencial nvarchar(max)   , 
      cce_correcao nvarchar(max)   , 
      cce_protocolo nvarchar(max)   , 
      desconto_valor float   , 
      pis_valor float   , 
      cofins_valor float   , 
      fatura_numero nvarchar(max)   , 
      fatura_valor_original nvarchar(max)   , 
      fatura_valor_desconto float   , 
      fatura_valor_liquido float   , 
      notafiscal_iddest_id int   NOT NULL  , 
      notafiscal_tpimp_id int   , 
      notafiscal_finnfe_id int   NOT NULL  , 
      notafiscal_indfinal_id int   NOT NULL  , 
      notafiscal_indpres_id int   NOT NULL  , 
      verproc nvarchar(max)   , 
      notafiscal_indpag_id int   , 
      retirada_marcado int   , 
      retirada_cpfcnpj nvarchar(max)   , 
      retirada_xlgr nvarchar(max)   , 
      retirada_nro nvarchar(max)   , 
      retirada_xcpl nvarchar(max)   , 
      retirada_xbairro nvarchar(max)   , 
      retirada_cmun int   , 
      retirada_xmun nvarchar(max)   , 
      retirada_uf nvarchar(max)   , 
      entrega_marcado int   , 
      entrega_cpfcnpj nvarchar(max)   , 
      entrega_xlgr nvarchar(max)   , 
      entrega_nro nvarchar(max)   , 
      entrega_xcpl nvarchar(max)   , 
      entrega_xbairro nvarchar(max)   , 
      entrega_cmun nvarchar(max)   , 
      entrega_xmun nvarchar(max)   , 
      entrega_uf nvarchar(max)   , 
      vicmsufdest float   , 
      vicmsufremet float   , 
      vfcpufdest nvarchar(max)   , 
      notafiscal_mod_id int   NOT NULL  , 
      xml nvarchar(max)   , 
      data_hora_envio datetime2   , 
      xml_cancelamento nvarchar(max)   , 
      issqn_vserv float   , 
      issqn_vbc float   , 
      issqn_viss float   , 
      issqn_dcompet date   , 
      issqn_reftrib nvarchar(max)   , 
      icms_vfcp float   , 
      icms_vfcpst float   , 
      icms_vfcpstret float   , 
      layout_versao nvarchar(max)   , 
      ipi_vipidevol float   , 
      vtroco date   , 
      notafiscal_modfrete_id int   , 
      cpag_lancada bit   NOT NULL  , 
      dest_cnpj nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_dup( 
      id  INT IDENTITY    NOT NULL  , 
      nota_fiscal_compra_id int   NOT NULL  , 
      forma_pagamento_id int   , 
      plano_conta_id int   , 
      centro_custo_id int   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      ndup nvarchar(max)   , 
      vdup float   , 
      dvenc date   , 
      parcela nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens( 
      id  INT IDENTITY    NOT NULL  , 
      nota_fiscal_compra_id int   NOT NULL  , 
      produto_id int   , 
      nota_fiscal_compra_itens_situacao_id int   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      nitem int   , 
      cean nvarchar(max)   , 
      xprod nvarchar(max)   , 
      ncm nvarchar(max)   , 
      nve nvarchar(max)   , 
      extipi nvarchar(max)   , 
      cfop nvarchar(max)   , 
      ucom nvarchar(max)   , 
      qcom float   , 
      vuncom float   , 
      vprod float   , 
      ceantrib nvarchar(max)   , 
      utrib nvarchar(max)   , 
      qtrib float   , 
      vuntrib float   , 
      vfrete float   , 
      vseg float   , 
      vdesc float   , 
      vtottrib float   , 
      xped nvarchar(max)   , 
      nitemped int   , 
      notafiscal_item_indtot_id int   , 
      notafiscal_item_orig_id int   NOT NULL  , 
      notafiscal_item_modbc_id int   , 
      icms_basecalc float   , 
      icms_cst nvarchar(max)   , 
      icms_valor float   , 
      icms_aliquota float   , 
      icms_pcredsn float   , 
      icms_vcredicmssn float   , 
      icms_predbc float   , 
      icms_pst float   , 
      icms_pmvast float   , 
      icms_predbcst float   , 
      icms_vbcst float   , 
      icms_picmsst float   , 
      icms_vicmsst float   , 
      fcp_pfcp float   , 
      pis_cst nvarchar(max)   , 
      pis_valor float   , 
      pis_aliquota float   , 
      pis_valor_base float   , 
      cofins_cst nvarchar(max)   , 
      cofins_valor_base float   , 
      cofins_aliquota float   , 
      cofins_valor float   , 
      voutro float   , 
      infadprod nvarchar(max)   , 
      notafiscal_item_motDesICMS_id int   , 
      cprod nvarchar(max)   , 
      ipi_cst nvarchar(max)   , 
      ipi_valor_base float   , 
      ipi_aliquota float   , 
      ipi_vipidevol float   , 
      ipi_valor float   , 
      ipi_pdevol float   , 
      estoque_deposito_id int   , 
      produto_lote_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_pag( 
      id  INT IDENTITY    NOT NULL  , 
      nota_fiscal_compra_id int   NOT NULL  , 
      notafiscal_tpag_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      tpag nvarchar(max)   , 
      vpag float   , 
      xpag nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      cor nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_cprod_padrao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_crt( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor int   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_dup( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      ndup nvarchar(max)   , 
      vdup float   , 
      dvenc date   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_finnfe( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_frete_volumes( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      qVol int   , 
      nVol nvarchar(max)   , 
      esp nvarchar(max)   , 
      marca nvarchar(max)   , 
      pesol float   , 
      pesob float   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_iddest( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indfinal( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indiedest( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpag( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpres( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_indtot( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbc( 
      id  INT IDENTITY    NOT NULL  , 
      codigo int   , 
      descricao nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbcst( 
      id  INT IDENTITY    NOT NULL  , 
      codigo int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_motDesICMS( 
      id  INT IDENTITY    NOT NULL  , 
      codigo nvarchar(max)   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_orig( 
      id  INT IDENTITY    NOT NULL  , 
      codigo int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_itens( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      nitem int   , 
      cean varchar  (50)   , 
      xprod nvarchar(max)   NOT NULL  , 
      ncm nvarchar(max)   , 
      nve nvarchar(max)   , 
      extipi nvarchar(max)   , 
      cfop nvarchar(max)   , 
      ucom nvarchar(max)   , 
      qcom float   NOT NULL  , 
      vuncom float  (13,2)   NOT NULL  , 
      vprod float   , 
      ceantrib nvarchar(max)   , 
      utrib nvarchar(max)   , 
      qtrib float  (13,2)   , 
      vuntrib float  (13,2)   , 
      vfrete float  (13,2)   , 
      vseg float  (13,2)   , 
      vdesc float  (13,2)   , 
      vtottrib float  (10,2)   , 
      xped nvarchar(max)   , 
      nitemped int   , 
      notafiscal_item_indtot_id int   , 
      notafiscal_item_orig_id int   NOT NULL  , 
      notafiscal_item_modbc_id int   , 
      icms_basecalc float   , 
      icms_cst varchar  (20)   , 
      icms_valor float   , 
      icms_aliquota float   , 
      icms_pcredsn float  (10,2)   , 
      icms_vcredicmssn float   , 
      icms_predbc float   , 
      icms_pst float   , 
      icms_pmvast float   , 
      icms_predbcst float   , 
      icms_vbcst float   , 
      icms_picmsst float   , 
      icms_vicmsst float   , 
      alterado_em datetime2   , 
      criado_em datetime2   , 
      pis_cst varchar  (20)   , 
      pis_valor float   , 
      pis_aliquota float   , 
      pis_valor_base float   , 
      cofins_cst varchar  (20)   , 
      cofins_valor_base float   , 
      cofins_aliquota float   , 
      cofins_valor float   , 
      voutro float   , 
      infadprod nvarchar(max)   , 
      notafiscal_item_motDesICMS_id int   , 
      cprod nvarchar(max)   , 
      ipi_cst varchar  (255)   , 
      ipi_valor_base float   , 
      ipi_aliquota float   , 
      ipi_vipidevol float   , 
      ipi_valor float   , 
      ipi_pdevol float   , 
      cest nvarchar(max)   , 
      fcp_pfcp float   , 
      fcp_vfcp float   , 
      fcp_vbcfcp float   , 
      fcp_vbcfcpst float   , 
      fcp_pfcpst float   , 
      fcp_vfcpst float   , 
      fcp_vbcfcpstret float   , 
      fcp_pfcpstret float   , 
      fcp_vfcpstret float   , 
      icms_vbcufdest float   , 
      icms_vbcfcpufdest float   , 
      icms_pfcpufdest float   , 
      icms_vfcpufdest float   , 
      icms_picmsinter float   , 
      icms_picmsinterpart float   , 
      icms_vicmsufdest float   , 
      icms_vicmsufremet float   , 
      icms_picmsufdest float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_logs( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_mod( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      modelo nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_modfrete( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_pag( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      notafiscal_tpag_id int   NOT NULL  , 
      tpag nvarchar(max)   , 
      vpag float   , 
      xpag nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecf( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      notafiscal_refecfmod_id int   NOT NULL  , 
      necf nvarchar(max)   , 
      ncoo nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecfmod( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refnfe( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   NOT NULL  , 
      refnfe nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_series( 
      id  INT IDENTITY    NOT NULL  , 
      serie nvarchar(max)   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      notafiscal_tpamb_id int   NOT NULL  , 
      notafiscal_mod_id int   NOT NULL  , 
      sequencial int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      notafiscal_tipodocumento_id int   NOT NULL  , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      ordem int   , 
      exibir bit   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_por nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao_sefaz( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_situacao_id int   NOT NULL  , 
      codigo_sefaz int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodoc_series( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_series_id int   NOT NULL  , 
      notafiscal_tipodocumento_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodocumento( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpag( 
      id  INT IDENTITY    NOT NULL  , 
      tpag nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      descricao nvarchar(max)   NOT NULL  , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpamb( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpemis( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpimp( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      valor nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      orcamento_situacao_id int   NOT NULL  , 
      vendedor_id int   , 
      cliente_id int   , 
      cliente_contato_id int   , 
      data_orcamento date   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      observacao nvarchar(max)   , 
      valor_produtos float   NOT NULL  , 
      desconto float   , 
      peso_total float   , 
      frete_total float   , 
      valor_total float   NOT NULL  , 
      tabela_preco_id int   , 
      justificativa_reprovacao nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_interacoes( 
      id  INT IDENTITY    NOT NULL  , 
      orcamento_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_item( 
      id  INT IDENTITY    NOT NULL  , 
      orcamento_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade float   NOT NULL  , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      valor_original float   NOT NULL  , 
      valor_custo float   , 
      desconto float   , 
      informacoes_adicionais nvarchar(max)   , 
      numero_pedido nvarchar(max)   , 
      numero_item_pedido nvarchar(max)   , 
      valor_frete float   , 
      peso_unitario float   , 
      peso_total float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      ordem int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao_historico( 
      id  INT IDENTITY    NOT NULL  , 
      orcamento_situacao_id int   NOT NULL  , 
      orcamento_id int   NOT NULL  , 
      descricao nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      ordem_producao_situacao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade float   NOT NULL  , 
      data_producao date   NOT NULL  , 
      observacoes nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      ordem_producao_etapas_situacao_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      ordem int   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_itens( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      estoque_deposito_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade float   NOT NULL  , 
      quantidade_total float   NOT NULL  , 
      custo float   , 
      custo_total float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao_historico( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      ordem_producao_situacao_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_vendas( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_producao_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      cliente_id int   NOT NULL  , 
      cliente_contato_id int   , 
      vendedor_id int   , 
      ordem_servico_situacao_id int   NOT NULL  , 
      ordem_servico_producao_etapa_id int   , 
      condicao_pagamento_id int   , 
      cliente_endereco_id int   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      numero_os int   , 
      numero_orcamento int   , 
      data_emissao date   NOT NULL  , 
      valor float   NOT NULL  , 
      desconto float   , 
      prazo_entrega date   , 
      validade_dias int   , 
      data_abertura_os date   , 
      vendedor_comissao float   , 
      vendedor_comissao_avista float   , 
      vendedor_comissao_aprazo float   , 
      observacoes nvarchar(max)   , 
      prazo_garantia date   , 
      valor_pago float   , 
      motivo_nao_aprovacao_orcamento nvarchar(max)   , 
      valor_avista float   , 
      valor_aprazo float   , 
      valor_faturado_vendas float   , 
      usuario_aprovacao_id int   , 
      informacoes_transporte nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_garantia_historico( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      observacoes nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_historico( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_situacao_id int   NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      descricao_servico nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade float   NOT NULL  , 
      quantidade_atendida float   , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      desconto float   , 
      arquivo nvarchar(max)   , 
      largura float   , 
      altura float   , 
      quantidade_a_faturar float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_despesas( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      despesas_servicos_id int   NOT NULL  , 
      despesas_servicos_tipo_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      valor_unitario float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_ficha_tecnica( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      quantidade_fixa_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade float   NOT NULL  , 
      custo float   , 
      valor_unitario float   , 
      valor_total float   , 
      quantidade_original float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_mao_obra( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      funcionario_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade_horas float   , 
      valor_hora float   , 
      valor_total float   , 
      quantidade_horas_original float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_obs_etapas( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_item_id int   NOT NULL  , 
      ordem_servico_producao_etapa_id int   NOT NULL  , 
      observacao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_producao_etapa( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      cor nvarchar(max)   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_venda( 
      id  INT IDENTITY    NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicadores( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicador_usuario( 
      id  INT IDENTITY    NOT NULL  , 
      painel_indicadores_id int   NOT NULL  , 
      indicador_personalizado_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pais( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      codigo_pais nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE parceiro( 
      id  INT IDENTITY    NOT NULL  , 
      certificado_venda_modalidade_id int   NOT NULL  , 
      tabela_preco_id int   , 
      vendedor_id int   , 
      cpf_cnpj nvarchar(max)   NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      razao_social nvarchar(max)   , 
      cep nvarchar(max)   , 
      logradouro nvarchar(max)   , 
      bairro nvarchar(max)   , 
      cidade nvarchar(max)   , 
      estado nvarchar(max)   , 
      fone nvarchar(max)   , 
      email nvarchar(max)   , 
      contato nvarchar(max)   , 
      contato_fone nvarchar(max)   , 
      comissao_percentual float   , 
      deletado_em datetime2   , 
      criado_em datetime2   NOT NULL  , 
      alterado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      banco_id int   , 
      banco_agencia nvarchar(max)   , 
      banco_conta nvarchar(max)   , 
      banco_chavepix nvarchar(max)   , 
      banco_nome_titular nvarchar(max)   , 
      banco_cpfcnpj nvarchar(max)   , 
      chave_pix_tipo_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pdv_permissoes( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pedido_evento( 
      id  INT IDENTITY    NOT NULL  , 
      notafiscal_id int   , 
      system_unit_id int   , 
      system_users_id int   , 
      chave varchar  (50)   , 
      descricao nvarchar(max)   , 
      tipo varchar  (30)   , 
      numero varchar  (10)   , 
      serie int   , 
      nseqevento int   , 
      protocolo varchar  (20)   , 
      status int     DEFAULT 1, 
      protocolo_resposta varchar  (50)   , 
      xevento nvarchar(max)   , 
      created_at datetime2   , 
      update_at datetime2   , 
      deleted_at datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pessoa_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      plano_conta_tipo_id int   NOT NULL  , 
      plano_conta_origem_id int   NOT NULL  , 
      plano_conta_pai_id int   , 
      numero nvarchar(max)   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_origem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto( 
      id  INT IDENTITY    NOT NULL  , 
      produto_grupo_id int   NOT NULL  , 
      unidade_medida_id int   NOT NULL  , 
      tipo_recurso_id int   NOT NULL  , 
      produto_fabricante_id int   , 
      produtogrupo_subgrupo_id int   , 
      notafiscal_item_orig_id int   , 
      nome nvarchar(max)   NOT NULL  , 
      nome_curto nvarchar(max)   , 
      codigo_EAN nvarchar(max)   , 
      imagem nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      ncm nvarchar(max)   , 
      cest nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_por nvarchar(max)   , 
      obs nvarchar(max)   , 
      referencia nvarchar(max)   , 
      deletado_em datetime2   , 
      especificacao nvarchar(max)   , 
      link_site nvarchar(max)   , 
      peso_liquido float   , 
      peso_bruto float   , 
      habilitado_id int   , 
      produto_tipo_id int   , 
      codigo_sku nvarchar(max)   , 
      largura float   , 
      altura float   , 
      comprimento float   , 
      diametro float   , 
      dias_preparacao float   , 
      marca nvarchar(max)   , 
      garantia nvarchar(max)   , 
      unidade_caixa float   , 
      produto_embalagem_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_embalagem( 
      id  INT IDENTITY    NOT NULL  , 
      produto_tipo_embalagem_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      peso float   , 
      dimensoes nvarchar(max)   NOT NULL  , 
      altura float   , 
      largura float   , 
      comprimento float   , 
      diametro float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_enderecamento( 
      id  INT IDENTITY    NOT NULL  , 
      produto_filial_id int   NOT NULL  , 
      estoque_prateleira_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_etiqueta_configuracoes( 
      id  INT IDENTITY    NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fabricante( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      custo_total float   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_despesas( 
      id  INT IDENTITY    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      despesas_servicos_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      valor_unitario float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_etapas_producao( 
      id  INT IDENTITY    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      ordem int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_itens( 
      id  INT IDENTITY    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_custo float   , 
      valor_total float   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade_fixa_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_mao_obra( 
      id  INT IDENTITY    NOT NULL  , 
      produto_ficha_tecnica_id int   NOT NULL  , 
      funcionario_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      valor_hora float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial( 
      id  INT IDENTITY    NOT NULL  , 
      produto_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      margem float   , 
      preco_venda float   NOT NULL  , 
      preco_venda_anterior float   , 
      valor_custo float   , 
      valor_custo_anterior float   , 
      criado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
      estoque_minimo float   , 
      estoque_maximo float   , 
      local_estoque nvarchar(max)   , 
      codigo_balanca nvarchar(max)   , 
      deletado_em datetime2   , 
      estoque_deposito_padrao_id int   , 
      sob_encomenda_id int   , 
      gerar_op_venda_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial_historico( 
      id  INT IDENTITY    NOT NULL  , 
      produto_id int   NOT NULL  , 
      produto_filial_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      preco_venda_antigo float   NOT NULL  , 
      preco_venda_novo float   NOT NULL  , 
      valor_custo_antigo float   , 
      valor_custo_novo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fornecedor( 
      id  INT IDENTITY    NOT NULL  , 
      produto_id int   NOT NULL  , 
      fornecedor_id int   NOT NULL  , 
      codigo_fornecedor nvarchar(max)   , 
      descricao_produto_fornecedor nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      tempo_medio_fornecimento float   , 
      quantidade_minima_compra float   , 
      preco_venda float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_grupo( 
      id  INT IDENTITY    NOT NULL  , 
      tipo_recurso_id int   , 
      descricao nvarchar(max)   NOT NULL  , 
      imagem nvarchar(max)   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      criado_por nvarchar(max)   , 
      alterado_por nvarchar(max)   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produtogrupo_subgrupo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      produto_grupo_id int   NOT NULL  , 
      subgrupo_id int  (11)   , 
      nivel int  (11)   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_lote( 
      id  INT IDENTITY    NOT NULL  , 
      produto_id int   NOT NULL  , 
      numero nvarchar(max)   NOT NULL  , 
      validade date   , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_em datetime2   , 
      criado_por nvarchar(max)   , 
      alterado_por nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo_embalagem( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE resposta( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE servico_formapgto( 
      id  INT IDENTITY    NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      ordem_servico_id int   NOT NULL  , 
      quantidade_parcelas int   , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document( 
      id int   NOT NULL  , 
      category_id int   NOT NULL  , 
      system_user_id int   , 
      title nvarchar(max)   NOT NULL  , 
      description nvarchar(max)   , 
      submission_date date   , 
      archive_date date   , 
      filename nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_category( 
      id int   NOT NULL  , 
      name nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_group( 
      id int   NOT NULL  , 
      document_id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_user( 
      id int   NOT NULL  , 
      document_id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group( 
      id int   NOT NULL  , 
      name nvarchar(max)   NOT NULL  , 
      uuid varchar  (36)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program( 
      id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
      system_program_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program_permissoes( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      system_program_permissoes_id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_message( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_user_to_id int   NOT NULL  , 
      subject nvarchar(max)   NOT NULL  , 
      message nvarchar(max)   , 
      dt_message datetime2   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_notification( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_user_to_id int   NOT NULL  , 
      subject nvarchar(max)   , 
      message nvarchar(max)   , 
      dt_message datetime2   , 
      action_url nvarchar(max)   , 
      action_label nvarchar(max)   , 
      icon nvarchar(max)   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_preference( 
      id varchar  (255)   NOT NULL  , 
      preference nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program( 
      id int   NOT NULL  , 
      name nvarchar(max)   NOT NULL  , 
      controller nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program_permissoes( 
      id  INT IDENTITY    NOT NULL  , 
      system_program_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_unit( 
      id int   NOT NULL  , 
      connection_name nvarchar(max)   , 
      vendas_natureza_operacao_id int   , 
      nfce_natureza_operacao_id int   , 
      cnpj varchar  (14)   NOT NULL  , 
      name nvarchar(max)   NOT NULL  , 
      razao_social varchar  (255)   NOT NULL  , 
      inscricao_estadual varchar  (255)   , 
      inscricao_municipal varchar  (255)   , 
      fone nvarchar(max)   , 
      notafiscal_crt_id int   NOT NULL  , 
      pc_credito_sn float  (10,2)     DEFAULT 0, 
      aliquota_iss float  (10,2)   , 
      aliquota_irrf float  (10,2)   , 
      aliquota_csll float  (10,2)   , 
      sn_matriz char  (1)   NOT NULL    DEFAULT 'N', 
      nfce_tpamb_id int   , 
      nfe_tpamb_id int   , 
      nfe_tpimp_id int   , 
      nfce_tpimp_id int   , 
      certificadoA1 nvarchar(max)   , 
      senha_certificado nvarchar(max)   , 
      nfe_homologacao_series_id int   , 
      nfe_producao_series_id int   , 
      nfce_homologacao_series_id int   , 
      nfe_api_documentos_id int   , 
      nfce_api_documentos_id int   , 
      nfce_producao_series_id int   , 
      end_cep nvarchar(max)   , 
      end_mun_codibge nvarchar(max)   , 
      end_municipio nvarchar(max)   , 
      end_uf char  (2)   , 
      end_logradouro nvarchar(max)   , 
      end_bairro nvarchar(max)   , 
      end_numero nvarchar(max)   , 
      end_complemento nvarchar(max)   , 
      nfce_csc_homologacao nvarchar(max)   , 
      nfce_csc_producao nvarchar(max)   , 
      notafiscal_cprod_padrao_id int   , 
      nfce_id_csc_homologacao nvarchar(max)   , 
      nfce_id_csc_producao nvarchar(max)   , 
      email varchar  (255)   , 
      token_api nvarchar(max)   , 
      mdfe_tpamb_id int   , 
      mdfe_estadoini_id int   , 
      veiculo_id int   , 
      mdfe_api_documentos_id int   , 
      mdfe_homologacao_series_id int   , 
      mdfe_producao_series_id int   , 
      natureza_operacao_compra_id int   , 
      logo nvarchar(max)   , 
      contador_nome nvarchar(max)   , 
      contador_documento nvarchar(max)   , 
      contador_email nvarchar(max)   , 
      contador_celular nvarchar(max)   , 
      config_host nvarchar(max)   , 
      config_user nvarchar(max)   , 
      config_password nvarchar(max)   , 
      config_port varchar  (11)     DEFAULT '587', 
      config_from nvarchar(max)   , 
      config_replyname nvarchar(max)   , 
      config_replyto nvarchar(max)   , 
      column_63 int   , 
      cnae nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_group( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_group_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_pdv_permissoes( 
      id  INT IDENTITY    NOT NULL  , 
      empresa_id int   NOT NULL  , 
      pdv_permissoes_id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_program_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program_permissoes( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      system_users_id int   NOT NULL  , 
      system_program_permissoes_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_users( 
      id int   NOT NULL  , 
      name nvarchar(max)   NOT NULL  , 
      login nvarchar(max)   NOT NULL  , 
      password nvarchar(max)   NOT NULL  , 
      email nvarchar(max)   , 
      frontpage_id int   , 
      system_unit_id int   , 
      active char  (1)   , 
      accepted_term_policy char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_unit( 
      id int   NOT NULL  , 
      system_user_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco( 
      id  INT IDENTITY    NOT NULL  , 
      tabela_preco_tipo_alteracao_id int   NOT NULL  , 
      tabela_preco_tipo_id int   , 
      descricao nvarchar(max)   NOT NULL  , 
      observacao nvarchar(max)   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      data_hora_promocao_inicial datetime2   , 
      data_hora_promocao_final datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_produto( 
      id  INT IDENTITY    NOT NULL  , 
      tabela_preco_id int   NOT NULL  , 
      produto_filial_id int   NOT NULL  , 
      preco_venda float   NOT NULL  , 
      valor_parametro float   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo_alteracao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_documento( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_recurso( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE titulos_tipo_anexo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE unidade_medida( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      sigla nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_por nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo( 
      id  INT IDENTITY    NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      modelo_marca nvarchar(max)   NOT NULL  , 
      placa nvarchar(max)   NOT NULL  , 
      ano int   , 
      tara float   , 
      capacidade_kg float   , 
      renavam nvarchar(max)   , 
      capacidade_m3 float   , 
      mdfe_tpRod_id int   NOT NULL  , 
      estado_id int   NOT NULL  , 
      veiculo_tipo_id int   NOT NULL  , 
      mdfe_tpcar_id int   NOT NULL  , 
      funcionario_motorista_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo_tipo( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda( 
      id  INT IDENTITY    NOT NULL  , 
      venda_situacao_id int   NOT NULL  , 
      orcamento_id int   , 
      vendedor_id int   , 
      dispositivos_id int   , 
      cliente_id int   , 
      numero_celula_consumo nvarchar(max)   , 
      system_unit_id int   NOT NULL  , 
      filial_saida_id int   NOT NULL  , 
      venda_modalidade_id int   NOT NULL  , 
      venda_tipo_pagamento_id int   NOT NULL  , 
      id_venda_local int   , 
      data_hora_venda datetime2   NOT NULL  , 
      valor_produtos float   NOT NULL  , 
      valor_troco float   , 
      desconto float   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      observacao nvarchar(max)   , 
      observacao_nf nvarchar(max)   , 
      peso_total float   , 
      frete_total float   , 
      valor_total float   NOT NULL  , 
      cliente_endereco_id int   , 
      info_faturamento nvarchar(max)   , 
      data_prev_entrega date   , 
      criado_por nvarchar(max)   , 
      alterado_por nvarchar(max)   , 
      valor_comissao float   , 
      comissao_avista float   , 
      comissao_aprazo int   , 
      valor_avista float   , 
      valor_aprazo float   , 
      tabela_preco_id int   , 
      movimentacao_origem_id int   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao( 
      id  INT IDENTITY    NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      data_devolucao date   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_itens( 
      id  INT IDENTITY    NOT NULL  , 
      venda_devolucao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade float   NOT NULL  , 
      valor_unitario float   , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_troca( 
      id  INT IDENTITY    NOT NULL  , 
      venda_devolucao_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      quantidade float   NOT NULL  , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_formapgto( 
      id  INT IDENTITY    NOT NULL  , 
      forma_pagamento_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      quantidade_parcelas int   , 
      valor float   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_item( 
      id  INT IDENTITY    NOT NULL  , 
      venda_id int   NOT NULL  , 
      produto_id int   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      valor_original float   NOT NULL  , 
      valor_custo float   , 
      desconto float   , 
      informacoes_adicionais nvarchar(max)   , 
      cancelado int   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      numero_pedido nvarchar(max)   , 
      numero_item_pedido nvarchar(max)   , 
      valor_frete float   , 
      peso_unitario float   , 
      peso_total float   , 
      estoque_deposito_id int   , 
      produto_lote_id int   , 
      quantidade_devolvida float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta( 
      id  INT IDENTITY    NOT NULL  , 
      venda_meta_situacao_id int   NOT NULL  , 
      system_unit_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      data_inicial date   NOT NULL  , 
      data_final date   NOT NULL  , 
      valor_meta_geral_prevista float   NOT NULL  , 
      valor_meta_geral_realizada float   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      data_ultimo_processamento datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_vendedor( 
      id  INT IDENTITY    NOT NULL  , 
      venda_meta_id int   NOT NULL  , 
      vendedor_id int   NOT NULL  , 
      valor_meta_prevista float   , 
      valor_meta_realizada float   , 
      criado_em datetime2   NOT NULL  , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_em datetime2   , 
      aproveiramento_carteira_prevista float   , 
      aproveitamento_carteira_realizada float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_modalidade( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      situacaopdv_id int   , 
      ordem int   , 
      cor nvarchar(max)   , 
      criado_por nvarchar(max)   NOT NULL  , 
      alterado_por nvarchar(max)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao_historico( 
      id  INT IDENTITY    NOT NULL  , 
      venda_situacao_id int   NOT NULL  , 
      venda_id int   NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   NOT NULL  , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_tipo_pagamento( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor( 
      id  INT IDENTITY    NOT NULL  , 
      nome nvarchar(max)   NOT NULL  , 
      cpf nvarchar(max)   , 
      vendedor_tipo_comissao_id int   , 
      vendedor_tipo_pgto_comissao_id int   , 
      criado_em datetime2   , 
      alterado_em datetime2   , 
      percentual_comissao float   , 
      criado_por nvarchar(max)   , 
      alterado_por nvarchar(max)   , 
      deletado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_comissao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_pgto_comissao( 
      id  INT IDENTITY    NOT NULL  , 
      descricao nvarchar(max)   NOT NULL  , 
      criado_em datetime2   , 
      deletado_em datetime2   , 
      alterado_por nvarchar(max)   , 
      criado_por nvarchar(max)   , 
      alterado_em datetime2   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE xml_contador( 
      id  INT IDENTITY    NOT NULL  , 
      data_inicio date   , 
      data_fim date   , 
      system_user_id int   , 
      system_unit_id int   , 
      data_solicitacao datetime2   , 
      caminho_download varchar  (255)   , 
      updated_at datetime2   , 
      created_at datetime2   , 
      info_registros varchar  (255)   , 
      data_click datetime2   , 
      status_id int     DEFAULT 0, 
      situacao int     DEFAULT 1, 
      caminho_pdf varchar  (255)   , 
      contador int     DEFAULT 0, 
      contador_email int     DEFAULT 0, 
      downloads int     DEFAULT 0, 
      rota nvarchar(max)   , 
      chave varchar  (20)   , 
 PRIMARY KEY (id)) ; 

 
 ALTER TABLE dispositivos ADD UNIQUE (token);
  
 ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_1 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_2 FOREIGN KEY (integradores_servicos_id) references integradores_servicos(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_2 FOREIGN KEY (caixa_situacao_id) references caixa_situacao(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_3 FOREIGN KEY (system_users_abertura_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_4 FOREIGN KEY (system_users_operador_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_5 FOREIGN KEY (system_users_fechamento_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_1 FOREIGN KEY (caixa_id) references caixa(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_3 FOREIGN KEY (caixa_tipo_lancamento_id) references caixa_tipo_lancamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_4 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_1 FOREIGN KEY (centro_custo_tipo_id) references centro_custo_tipo(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_agendamentos ADD CONSTRAINT fk_certificado_agendamentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_agente_registro ADD CONSTRAINT fk_certificado_agente_registro_1 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_2 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_4 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_5 FOREIGN KEY (certificado_cliente_situacao_id) references certificado_cliente_situacao(id); 
ALTER TABLE certificado_email_historico ADD CONSTRAINT fk_certificado_email_historico_1 FOREIGN KEY (certificado_cliente_id) references certificado_cliente(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_1 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_4 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_agente_registro_id) references certificado_agente_registro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_5 FOREIGN KEY (certificado_venda_situacao_id) references certificado_venda_situacao(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_7 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_8 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_9 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_12 FOREIGN KEY (certificado_tipo_atendimento_id) references certificado_tipo_atendimento(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_13 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificado_venda_documentos ADD CONSTRAINT fk_certificado_venda_documentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_1 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_2 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_2 FOREIGN KEY (pais_id) references pais(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_3 FOREIGN KEY (residencia_propria) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_4 FOREIGN KEY (utilizar_endereco_cobranca) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_5 FOREIGN KEY (cliente_situacao_id) references cliente_situacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_7 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_8 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_9 FOREIGN KEY (cliente_classificacao_subgrupo_id) references cliente_classificacao_subgrupo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE cliente_classificacao ADD CONSTRAINT fk_cliente_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE cliente_classificacao_subgrupo ADD CONSTRAINT fk_cliente_classificacao_subgrupo_1 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente_contato ADD CONSTRAINT fk_cliente_contato_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_2 FOREIGN KEY (principal) references resposta(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE cliente_historico_limite ADD CONSTRAINT fk_cliente_historico_limite_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_1 FOREIGN KEY (forma_pagamento_id_dinheiro_caixa) references forma_pagamento(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_2 FOREIGN KEY (forma_pagamento_id_titulos_cpag_nf) references forma_pagamento(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_1 FOREIGN KEY (configuracoes_id) references configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_2 FOREIGN KEY (produto_etiqueta_configuracoes_id) references produto_etiqueta_configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_4 FOREIGN KEY (plano_conta_crec_id) references plano_conta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_5 FOREIGN KEY (centro_custo_crec_id) references centro_custo(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_6 FOREIGN KEY (cpag_usa_plano_contas_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_9 FOREIGN KEY (notafiscal_cprod_padrao_orcamento_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_7 FOREIGN KEY (informar_duplicidade_de_item_venda_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_8 FOREIGN KEY (venda_apenas_com_estoque_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_10 FOREIGN KEY (notafiscal_cprod_padrao_venda_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_1 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_2 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_3 FOREIGN KEY (contabil_lancamentos_tipo_id) references contabil_lancamentos_tipo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_4 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_5 FOREIGN KEY (contaspag_contabil_id) references contaspag_contabil(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_6 FOREIGN KEY (conta_corrente_lancamentos_id) references conta_corrente_lancamentos(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_7 FOREIGN KEY (contabil_lancamentos_situacao_id) references contabil_lancamentos_situacao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_8 FOREIGN KEY (contabil_lancamentos_origem_id) references contabil_lancamentos_origem(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_1 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_1 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_2 FOREIGN KEY (conta_corrente_lanc_tipo_id) references conta_corrente_lanc_tipo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (contaspag_baixas_id) references contaspag_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (contasrec_baixas_id) references contasrec_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_7 FOREIGN KEY (conta_corrente_lanc_origem_id) references conta_corrente_lanc_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_1 FOREIGN KEY (contaspag_situacao_id) references contaspag_situacao(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_3 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_4 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_5 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_7 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_3 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_bloco_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_historico_venc ADD CONSTRAINT fk_contaspag_historico_venc_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_1 FOREIGN KEY (contasrec_situacao_id) references contasrec_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_4 FOREIGN KEY (contasrec_origem_id) references contasrec_origem(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_6 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_7 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_8 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_9 FOREIGN KEY (conta_corrente_boleto_id) references conta_corrente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_10 FOREIGN KEY (boleto_situacao_id) references boleto_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_11 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_12 FOREIGN KEY (contasrec_bloco_id) references contasrec_bloco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_13 FOREIGN KEY (venda_formapgto_id) references venda_formapgto(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_14 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_4 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_5 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec_historico_cobranca ADD CONSTRAINT fk_contasrec_historico_cobranca_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_historico_venc ADD CONSTRAINT fk_contasrec_historico_venc_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE cst_icms ADD CONSTRAINT fk_cst_icms_1 FOREIGN KEY (regime_tributario_id) references notafiscal_crt(id); 
ALTER TABLE despesas_servicos ADD CONSTRAINT fk_despesas_servicos_1 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE dispositivos ADD CONSTRAINT fk_dispositivos_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_deposito ADD CONSTRAINT fk_estoque_deposito_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_estante ADD CONSTRAINT fk_estoque_estante_1 FOREIGN KEY (estoque_rua_id) references estoque_rua(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_1 FOREIGN KEY (estoque_origem_id) references estoque_origem(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_2 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_4 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_5 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_6 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_9 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE estoque_origem ADD CONSTRAINT fk_estoque_origem_1 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_prateleira ADD CONSTRAINT fk_estoque_prateleira_1 FOREIGN KEY (estoque_estante_id) references estoque_estante(id); 
ALTER TABLE estoque_rua ADD CONSTRAINT fk_estoque_rua_1 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_3 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_1 FOREIGN KEY (email_template_id) references email_template(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_2 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_1 FOREIGN KEY (eventos_id) references eventos(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_1 FOREIGN KEY (tipo_documento_id) references tipo_documento(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_3 FOREIGN KEY (meio_pagamento_tef_id) references meio_pagamento_tef(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_4 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_1 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_4 FOREIGN KEY (fornecedor_classificacao_id) references fornecedor_classificacao(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE fornecedor_classificacao ADD CONSTRAINT fk_fornecedor_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE fornecedor_contato ADD CONSTRAINT fk_fornecedor_contato_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE funcionario ADD CONSTRAINT fk_funcionario_1 FOREIGN KEY (funcionario_cargo_id) references funcionario_cargo(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_1 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_2 FOREIGN KEY (ultima_etapa) references resposta(id); 
ALTER TABLE integradores_servicos ADD CONSTRAINT fk_integradores_servicos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_1 FOREIGN KEY (mdfe_tpemit_id) references mdfe_tpemit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_2 FOREIGN KEY (mdfe_tpprop_id) references mdfe_tpprop(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_4 FOREIGN KEY (mdfe_tptransp_id) references mdfe_tptransp(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_6 FOREIGN KEY (UFIni) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_7 FOREIGN KEY (UFFim) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_8 FOREIGN KEY (indCanalVerde) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_9 FOREIGN KEY (indCarregaPosterior) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_10 FOREIGN KEY (mdfe_respSeg_id) references mdfe_respSeg(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_11 FOREIGN KEY (mdfe_cunid_id) references mdfe_cunid(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_12 FOREIGN KEY (mdfe_tpcarga_id) references mdfe_tpcarga(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_13 FOREIGN KEY (mdfe_indpag_id) references mdfe_indpag(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_14 FOREIGN KEY (indAntecipaAdiant) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_15 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veic_estado_id) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_16 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_18 FOREIGN KEY (mdfe_situacao_id) references mdfe_situacao(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_19 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_20 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_21 FOREIGN KEY (cidade_encerramento_id) references cidade(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_2 FOREIGN KEY (mdfe_tpcomp_id) references mdfe_tpcomp(id); 
ALTER TABLE mdfe_condutor ADD CONSTRAINT fk_mdfe_condutor_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_evento ADD CONSTRAINT fk_mdfe_evento_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_2 FOREIGN KEY (cidade_carrega_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_3 FOREIGN KEY (cidade_descarga_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_4 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_2 FOREIGN KEY (UFPer) references estado(id); 
ALTER TABLE mdfe_lacres ADD CONSTRAINT fk_mdfe_lacres_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_2 FOREIGN KEY (mdfe_tpAntecip_id) references mdfe_tpAntecip(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_2 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe_xmlaut ADD CONSTRAINT fk_mdfe_xmlaut_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_1 FOREIGN KEY (natureza_operacao_finalidade_id) references natureza_operacao_finalidade(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_2 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_3 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_4 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_5 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_6 FOREIGN KEY (consumidor_final_id) references resposta(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_10 FOREIGN KEY (cst_icms_nao_contribuinte_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_2 FOREIGN KEY (natop_excecao_tributo_id) references natop_excecao_tributo(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_1 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_3 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_4 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_5 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_6 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao_ncm ADD CONSTRAINT fk_natureza_operacao_ncm_1 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_1 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_1 FOREIGN KEY (negocio_origem_id) references negocio_origem(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_3 FOREIGN KEY (negocio_motivo_perda_id) references negocio_motivo_perda(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_4 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_5 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_6 FOREIGN KEY (arquivado) references resposta(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_7 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_9 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_8 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_10 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE negocio_arquivos ADD CONSTRAINT fk_negocio_arquivos_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_2 FOREIGN KEY (negocio_tipo_atividade_id) references negocio_tipo_atividade(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_2 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio_notas ADD CONSTRAINT fk_negocio_notas_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_17 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_18 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_3 FOREIGN KEY (nf_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_4 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_6 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_7 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_8 FOREIGN KEY (notafiscal_tpemis_id) references notafiscal_tpemis(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_16 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_21 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE notafiscal_autxml ADD CONSTRAINT fk_notafiscal_autxml_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_3 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_4 FOREIGN KEY (nota_fiscal_compra_situacao_id) references nota_fiscal_compra_situacao(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_7 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_8 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_13 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_14 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_3 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_4 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_9 FOREIGN KEY (nota_fiscal_compra_itens_situacao_id) references nota_fiscal_compra_itens_situacao(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_8 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_dup ADD CONSTRAINT fk_notafiscal_dup_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_frete_volumes ADD CONSTRAINT fk_notafiscal_frete_volumes_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_1 FOREIGN KEY (notafiscal_refecfmod_id) references notafiscal_refecfmod(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_refnfe ADD CONSTRAINT fk_notafiscal_refnfe_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_4 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_1 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_2 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal_situacao_sefaz ADD CONSTRAINT fk_notafiscal_situacao_sefaz_1 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_1 FOREIGN KEY (notafiscal_series_id) references notafiscal_series(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_2 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_3 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_4 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_6 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE orcamento_interacoes ADD CONSTRAINT fk_orcamento_interacoes_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_1 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_2 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_2 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_5 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_2 FOREIGN KEY (ordem_producao_etapas_situacao_id) references ordem_producao_etapas_situacao(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_3 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_2 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_8 FOREIGN KEY (usuario_aprovacao_id) references system_users(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_9 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_3 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_4 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_5 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE ordem_servico_garantia_historico ADD CONSTRAINT fk_ordem_servico_garantia_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_2 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_3 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_4 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_2 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_1 FOREIGN KEY (painel_indicadores_id) references painel_indicadores(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_2 FOREIGN KEY (indicador_personalizado_id) references indicador_personalizado(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_3 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_2 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_3 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_4 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_5 FOREIGN KEY (chave_pix_tipo_id) references chave_pix_tipo(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_1 FOREIGN KEY (plano_conta_tipo_id) references plano_conta_tipo(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_2 FOREIGN KEY (plano_conta_origem_id) references plano_conta_origem(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_2 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_3 FOREIGN KEY (unidade_medida_id) references unidade_medida(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_fabricante_id) references produto_fabricante(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_9 FOREIGN KEY (produtogrupo_subgrupo_id) references produtogrupo_subgrupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_6 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (habilitado_id) references resposta(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_tipo_id) references produto_tipo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_11 FOREIGN KEY (produto_embalagem_id) references produto_embalagem(id); 
ALTER TABLE produto_embalagem ADD CONSTRAINT fk_produto_embalagem_1 FOREIGN KEY (produto_tipo_embalagem_id) references produto_tipo_embalagem(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (estoque_prateleira_id) references estoque_prateleira(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE produto_ficha_tecnica_etapas_producao ADD CONSTRAINT fk_produto_ficha_tecnica_etapas_producao_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_3 FOREIGN KEY (estoque_deposito_padrao_id) references estoque_deposito(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_4 FOREIGN KEY (sob_encomenda_id) references resposta(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_5 FOREIGN KEY (gerar_op_venda_id) references resposta(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_preco_historico_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_filial_historico_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE produto_grupo ADD CONSTRAINT fk_produto_grupo_1 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produtogrupo_subgrupo ADD CONSTRAINT fk_produtogrupo_subgrupo_1 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto_lote ADD CONSTRAINT fk_produto_lote_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_2 FOREIGN KEY (category_id) references system_document_category(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_1 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_program_permissoes ADD CONSTRAINT fk_system_program_permissoes_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_2 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_4 FOREIGN KEY (nfe_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_5 FOREIGN KEY (nfe_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_13 FOREIGN KEY (nfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_6 FOREIGN KEY (vendas_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_7 FOREIGN KEY (nfce_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_9 FOREIGN KEY (nfe_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_10 FOREIGN KEY (nfe_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_11 FOREIGN KEY (nfce_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_12 FOREIGN KEY (nfce_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_14 FOREIGN KEY (notafiscal_cprod_padrao_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (nfce_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_3 FOREIGN KEY (nfce_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_1 FOREIGN KEY (nfce_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_16 FOREIGN KEY (mdfe_estadoini_id) references estado(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_18 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_19 FOREIGN KEY (mdfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_20 FOREIGN KEY (mdfe_homologacao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (mdfe_producao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (natureza_operacao_compra_id) references natureza_operacao(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_pdv_permissoes ADD CONSTRAINT fk_system_user_permissoes_pdv_2 FOREIGN KEY (pdv_permissoes_id) references pdv_permissoes(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_2 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_2 FOREIGN KEY (frontpage_id) references system_program(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_1 FOREIGN KEY (tabela_preco_tipo_alteracao_id) references tabela_preco_tipo_alteracao(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_2 FOREIGN KEY (tabela_preco_tipo_id) references tabela_preco_tipo(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_1 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_3 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_4 FOREIGN KEY (veiculo_tipo_id) references veiculo_tipo(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (funcionario_motorista_id) references funcionario(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_2 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_3 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_5 FOREIGN KEY (filial_saida_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_6 FOREIGN KEY (venda_modalidade_id) references venda_modalidade(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_7 FOREIGN KEY (venda_tipo_pagamento_id) references venda_tipo_pagamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_8 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_9 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_10 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_12 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_3 FOREIGN KEY (cancelado) references resposta(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_5 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_1 FOREIGN KEY (venda_meta_situacao_id) references venda_meta_situacao(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_1 FOREIGN KEY (venda_meta_id) references venda_meta(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_1 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_1 FOREIGN KEY (vendedor_tipo_comissao_id) references vendedor_tipo_comissao(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_2 FOREIGN KEY (vendedor_tipo_pgto_comissao_id) references vendedor_tipo_pgto_comissao(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_2 FOREIGN KEY (system_user_id) references system_users(id); 

 CREATE VIEW view_consulta_contabil_por_data AS select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento data_vencimento,
	   p.data_pagamento data_pagamento,
	   p.criado_em data_lancamento
from contaspag p,
	 contaspag_contabil cc,
	 contabil_lancamentos cl
where p.id = cc.contaspag_id 
and   cl.contaspag_contabil_id = cc.id
and   p.deletado_em is null
and   cc.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento  data_vencimento,
	   p.data_pagamento  data_pagamento,
	   p.criado_em  data_lancamento
from contasrec p,
	 contabil_lancamentos cl
where cl.contasrec_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_lancamento  data_vencimento,
	   p.data_lancamento  data_pagamento,
	   p.data_lancamento  data_lancamento
from conta_corrente_lancamentos p,
	 contabil_lancamentos cl
where cl.conta_corrente_lancamentos_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
; 

CREATE VIEW view_negocio_timeline AS SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'nota' as "tipo"
FROM negocio_notas

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'arquivo' as "tipo"
FROM negocio_arquivos

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'atividade' as "tipo"
FROM negocio_atividade

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'produto' as "tipo"
FROM negocio_itens

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'etapa' as "tipo"
FROM negocio_etapas_historico
; 

CREATE VIEW vw_caixa_resumo AS select c.caixa_id AS caixa_id,
		'Fundo de Caixa' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 3) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Entradas' AS tipo,
        coalesce(sum(c.valor), 0) AS valor 
        from caixa_lancamentos c where (c.caixa_tipo_lancamento_id = 2) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saidas' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 1) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saldo' AS tipo,sum((case when (c.caixa_tipo_lancamento_id = 1) then (c.valor * -(1)) else c.valor end)) AS valor 
        from caixa_lancamentos c 
        group by c.caixa_id
        ; 

CREATE VIEW vw_caixa_resumo_formas AS Select 
    c.caixa_id caixa_id,
    c.forma_pagamento_id forma_pagamento_id,
    f.descricao nome_forma_pagamento,
    sum(case when c.caixa_tipo_lancamento_id = 1 then c.valor * -1 else c.valor end) total
from caixa_lancamentos c,
     forma_pagamento f
where f.id = c.forma_pagamento_id
group by c.caixa_id, c.forma_pagamento_id; 

CREATE VIEW vw_funil_filial AS SELECT DISTINCT
f.id AS id,
f.descricao AS descricao,
n.system_unit_id AS system_unit_id
FROM funil f
INNER JOIN funil_etapas fe ON fe.funil_id = f.id
INNER JOIN negocio n ON n.funil_etapas_id = fe.id; 

CREATE VIEW vw_lotes_produto AS select l.id as id,
       l.produto_id as produto_id,
       l.numero as numero,
       l.validade as validade,
       sum(e.quant_disponivel) as Quantidade,
       sum(e.quant_reservada) as Reservado
       from produto_lote l
left join estoque_saldos e on e.produto_lote_id = l.id
; 

CREATE VIEW vw_produto_estoque AS SELECT     p.id as id,
           p.nome as nome,
           p.referencia as referencia,
           p.codigo_sku as SKU,
           p.obs as obs,
           f.margem as margem,
           f.valor_custo as valor_custo,
           f.preco_venda as preco_venda,
           p.peso_liquido as peso_liquido,
           p.peso_bruto as preso_bruto,
           g.descricao as grupo,
           sg.descricao as subgrupo,
           u.sigla as sigla,
           p.imagem as imagem,
           p.codigo_ean as ean,
           p.ncm as ncm,
           f.system_unit_id as system_unit_id,
           f.id as produto_filial_id,
           f.estoque_minimo as estoque_minimo,
           f.estoque_maximo as estoque_maximo,           
           (e.quant_disponivel) as Quantidade_Disponivel,
           (e.quant_reservada) as Quantidade_Reservada,
           d.descricao as deposito
           
           FROM produto p 
           INNER JOIN unidade_medida u ON p.unidade_medida_id = u.id 
           INNER JOIN produto_grupo g ON p.produto_grupo_id = g.id
           LEFT JOIN produtogrupo_subgrupo sg ON g.id = sg.produto_grupo_id
           LEFT JOIN produto_filial f ON f.produto_id = p.id 
           LEFT JOIN estoque_saldos e ON e.produto_id = p.id
           LEFT JOIN estoque_deposito d ON e.estoque_deposito_id = d.id
           group by 1,2           
           
           ; 
 
