CREATE TABLE api_documentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `integradores_id` int   NOT NULL  , 
      `system_unit_id` int   , 
      `descricao` text   NOT NULL  , 
      `token_api` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE apidocumentos_integradoresservicos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `api_documentos_id` int   NOT NULL  , 
      `integradores_servicos_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE api_error( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `classe` text   , 
      `metodo` text   , 
      `url` text   , 
      `dados` text   , 
      `error_message` text   , 
      `inserted_at` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ativo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE banco( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `numero` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE boleto_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE caixa( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `caixa_situacao_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `system_users_abertura_id` int   NOT NULL  , 
      `system_users_operador_id` int   NOT NULL  , 
      `system_users_fechamento_id` int   , 
      `data_hora_abertura` datetime   , 
      `data_hora_fechamento` datetime   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE caixa_lancamentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `caixa_id` int   NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `caixa_tipo_lancamento_id` int   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `data_hora_lancamento` datetime   NOT NULL  , 
      `system_users_id` int   NOT NULL  , 
      `observacao` text   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `id_origem` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE caixa_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE caixa_tipo_lancamento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE centro_custo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `centro_custo_tipo_id` int   NOT NULL  , 
      `centro_custo_pai_id` int   , 
      `numero` text   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE centro_custo_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cep_cache( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `cep` text   , 
      `rua` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `cidade` text   , 
      `bairro` text   , 
      `codigo_ibge` text   , 
      `uf` char  (2)   , 
      `cidade_id` int   , 
      `estado_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_agendamentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `certificado_venda_id` int   NOT NULL  , 
      `titulo` text   NOT NULL  , 
      `data_hora_inicial` datetime   NOT NULL  , 
      `data_hora_final` datetime   NOT NULL  , 
      `observacao` text   , 
      `cor` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_agente_registro( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `parceiro_id` int   , 
      `nome` text   NOT NULL  , 
      `cpf` text   , 
      `fone` text   , 
      `email` text   , 
      `percentual_comissao` double   , 
      `deletado_em` datetime   , 
      `criado_em` datetime   NOT NULL  , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_cliente( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `cliente_id` int   NOT NULL  , 
      `parceiro_id` int   , 
      `produto_id` int   NOT NULL  , 
      `certificado_cliente_situacao_id` int   NOT NULL  , 
      `data_vencimento_certificado` date   , 
      `certificado_venda_id` int   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_cliente_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_email_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `certificado_cliente_id` int   NOT NULL  , 
      `email` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificadora( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `texto_emissao` text   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificadora_produtos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `certificadora_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `qtde_dias_vencimento` int   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `valor_custo` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_tipo_atendimento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_tipo_repasse( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_venda( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `cliente_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `parceiro_id` int   , 
      `certificado_agente_registro_id` int   NOT NULL  , 
      `certificado_venda_situacao_id` int   NOT NULL  , 
      `certificado_venda_modalidade_id` int   , 
      `certificado_venda_tipomodalidade_id` int   , 
      `certificado_tipo_repasse_id` int   , 
      `vendedor_id` int   , 
      `tabela_preco_id` int   , 
      `certificadora_id` int   , 
      `valor_custo` double   , 
      `data_hora_agendamento` datetime   , 
      `data_vencimento_certificado` date   , 
      `valor_externo` double   , 
      `custo_externo` double   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `agente_comissao_percentual` double   , 
      `agente_comissao_valor` double   , 
      `vendedor_comissao_percentual` double   , 
      `vendedor_comissao_valor` double   , 
      `atendimento_externo` boolean   , 
      `parceiro_comissao_percentual` double   , 
      `parceiro_valor_repasse` double   , 
      `valor_total` double   NOT NULL  , 
      `comissao_total` double   , 
      `lucro_total` double   , 
      `valor_cliente` double   , 
      `valor_produto` double   NOT NULL  , 
      `protocolo_emissao` text   , 
      `data_emissao` date   , 
      `data_pagamento` date   , 
      `certificado_tipo_atendimento_id` int   , 
      `observacao` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_venda_documentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `certificado_venda_id` int   NOT NULL  , 
      `descricao_arquivo` text   NOT NULL  , 
      `arquivo` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_venda_formapgto( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `certificado_venda_id` int   NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_venda_modalidade( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `certificado_tipo_repasse_id` int   NOT NULL  , 
      `certificado_venda_tipomodalidade_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_venda_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `ordem` int   , 
      `cor` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE certificado_venda_tipomodalidade( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cfop( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `numero` char  (4)   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `aplicacao` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE chave_pix_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cidade( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `estado_id` int   NOT NULL  , 
      `pais_id` int   , 
      `nome` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `codigo_ibge` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cliente( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `pessoa_tipo_id` int   NOT NULL  , 
      `cliente_classificacao_id` int   NOT NULL  , 
      `cliente_classificacao_subgrupo_id` int   , 
      `vendedor_id` int   , 
      `notafiscal_indiedest_id` int   NOT NULL  , 
      `notafiscal_crt_id` int   , 
      `nome` text   NOT NULL  , 
      `cpf_cnpj` text   , 
      `rg` text   , 
      `email` text   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `insc_estadual` text   , 
      `insc_municipal` text   , 
      `razao_social` text   , 
      `fone` text   , 
      `observacoes` text   , 
      `data_nascimento` date   , 
      `conjuge` text   , 
      `conjuge_cpf` text   , 
      `nome_pai` text   , 
      `nome_mae` text   , 
      `local_trabalho` text   , 
      `renda` double   , 
      `tempo_trabalho` text   , 
      `residencia_propria` int   , 
      `utilizar_endereco_cobranca` int   NOT NULL  , 
      `cobranca_cnpj` text   , 
      `cobranca_nome` text   , 
      `cobranca_cep` text   , 
      `cobranca_endereco` text   , 
      `cobranca_bairro` text   , 
      `cobranca_uf` text   , 
      `cobranca_cidade` text   , 
      `cobranca_fones` text   , 
      `cliente_situacao_id` int   NOT NULL  , 
      `limite_credito` double   , 
      `limite_utilizado` double   , 
      `criado_por` text   NOT NULL  , 
      `alterado_por` text   , 
      `system_unit_id` int   , 
      `deletado_em` datetime   , 
      `vendas_quantidade` int   , 
      `vendas_valortotal` double   , 
      `vendas_dataultima` datetime   , 
      `vendas_valormaior` double   , 
      `vendas_datamaior` datetime   , 
      `observacoes_financeiro` text   , 
      `tabela_preco_id` int   , 
      `percentual_comissao_vendedor` double   , 
      `cliente_exterior` char  (1)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cliente_classificacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `criado_por` text   NOT NULL  , 
      `alterado_por` text   , 
      `ativo_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cliente_classificacao_subgrupo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `cliente_classificacao_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cliente_contato( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `cliente_id` int   , 
      `tipo_contato` text   , 
      `nome` text   NOT NULL  , 
      `fone` text   , 
      `ativo_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cliente_endereco( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `logradouro` text   NOT NULL  , 
      `cliente_id` int   NOT NULL  , 
      `principal` int   NOT NULL  , 
      `cidade_id` int   NOT NULL  , 
      `bairro` text   , 
      `cep` text   , 
      `numero` text   , 
      `complemento` text   , 
      `ativo_id` int   NOT NULL  , 
      `codigo_ibge` varchar  (20)   , 
      `ibge_estado` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cliente_historico_limite( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `cliente_id` int   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `data_hora` datetime   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `criado_por` text   NOT NULL  , 
      `alterado_por` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cliente_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE condicao_pagamento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `numero_parcelas` int   NOT NULL  , 
      `dias_primeira_parcelas` int   , 
      `dias_entre_parcelas` int   , 
      `taxa` double   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE configuracoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `forma_pagamento_id_dinheiro_caixa` int   , 
      `forma_pagamento_id_titulos_cpag_nf` int   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE configuracoes_filial( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `configuracoes_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `produto_etiqueta_configuracoes_id` int   , 
      `plano_conta_mascara` text   , 
      `centro_custo_mascara` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `plano_conta_crec_id` int   , 
      `centro_custo_crec_id` int   , 
      `cpag_usa_plano_contas_id` int   , 
      `info_complementar_orcamento` text   , 
      `informar_duplicidade_de_item_venda_id` int   , 
      `venda_apenas_com_estoque_id` int   , 
      `notafiscal_cprod_padrao_orcamento_id` int   , 
      `notafiscal_cprod_padrao_venda_id` int   , 
      `produto_margem_padrao` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contabil_lancamentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `plano_conta_id` int   NOT NULL  , 
      `centro_custo_id` int   NOT NULL  , 
      `contabil_lancamentos_tipo_id` int   NOT NULL  , 
      `contabil_lancamentos_situacao_id` int   NOT NULL  , 
      `contabil_lancamentos_origem_id` int   NOT NULL  , 
      `data_lancamento` date   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `contasrec_id` int   , 
      `contaspag_contabil_id` int   , 
      `conta_corrente_lancamentos_id` int   , 
      `historico` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contabil_lancamentos_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contabil_lancamentos_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contabil_lancamentos_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE conta_corrente( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `banco_id` int   , 
      `nome` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `agencia` text   , 
      `conta` text   , 
      `agencia_digito` text   , 
      `conta_digito` text   , 
      `end_logradouro` text   , 
      `end_bairro` text   , 
      `end_cidade` text   , 
      `end_estado` text   , 
      `end_cep` text   , 
      `end_numero` text   , 
      `boleto_convenio` text   , 
      `boleto_carteira` text   , 
      `boleto_gerar` boolean   NOT NULL  , 
      `boleto_codigo_cedente` text   , 
      `boleto_digito_cod_cedente` text   , 
      `boleto_instrucoes` text   , 
      `boleto_multa` double   , 
      `boleto_juros_dia` double   , 
      `boleto_digitos_nosso_numero` int   , 
      `boleto_local_pagamento` text   , 
      `boleto_codigo_transmissao` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE conta_corrente_lancamentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `conta_corrente_id` int   NOT NULL  , 
      `conta_corrente_lanc_tipo_id` int   NOT NULL  , 
      `conta_corrente_lanc_origem_id` int   NOT NULL  , 
      `contaspag_baixas_id` int   , 
      `contasrec_baixas_id` int   , 
      `data_lancamento` date   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `documento` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `historico` text   , 
      `plano_conta_id` int   , 
      `centro_custo_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE conta_corrente_lanc_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE conta_corrente_lanc_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contaspag_situacao_id` int   NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `fornecedor_id` int   NOT NULL  , 
      `contaspag_origem_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `numero_documento` text   NOT NULL  , 
      `parcela` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `data_emissao` date   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `data_vencimento` date   NOT NULL  , 
      `data_venc_original` date   , 
      `observacao` text   , 
      `data_pagamento` date   , 
      `desconto` double   , 
      `juros` double   , 
      `valor_pago` double   , 
      `valor_aberto` double   , 
      `valor_multa` double   , 
      `cheque_banco_id` int   , 
      `cheque_agencia` text   , 
      `cheque_conta` double   , 
      `cheque_emitente` text   , 
      `cheque_cpfcnpj` text   , 
      `data_competencia` date   , 
      `contaspag_bloco_id` int   , 
      `nota_fiscal_compra_id` int   , 
      `data_vencimento_calendario` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_anexos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contaspag_id` int   NOT NULL  , 
      `titulos_tipo_anexo_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `arquivo` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_baixas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contaspag_id` int   NOT NULL  , 
      `conta_corrente_id` int   NOT NULL  , 
      `data_pagamento` date   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `juros` double   , 
      `desconto` double   , 
      `saldo_aberto` double   , 
      `saldo_apagar` double   , 
      `multa` double   , 
      `historico` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_bloco( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `fornecedor_id` int   NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `contaspag_origem_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `quantidade_parcelas` int   NOT NULL  , 
      `primeiro_vencimento` date   , 
      `valor` double   NOT NULL  , 
      `numero_documento` text   , 
      `observacao` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_bloco_contabil( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contaspag_bloco_id` int   NOT NULL  , 
      `plano_conta_id` int   NOT NULL  , 
      `centro_custo_id` int   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_contabil( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contaspag_id` int   NOT NULL  , 
      `plano_conta_id` int   NOT NULL  , 
      `centro_custo_id` int   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_historico_venc( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contaspag_id` int   NOT NULL  , 
      `vencimento_anterior` date   , 
      `vencimento_atual` date   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contaspag_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `cliente_id` int   NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `contasrec_situacao_id` int   NOT NULL  , 
      `plano_conta_id` int   NOT NULL  , 
      `centro_custo_id` int   NOT NULL  , 
      `contasrec_origem_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `numero_documento` text   , 
      `parcela` text   , 
      `valor` double   NOT NULL  , 
      `data_vencimento` date   NOT NULL  , 
      `data_venc_original` date   , 
      `observacao` text   , 
      `data_pagamento` date   , 
      `desconto` double   , 
      `juros` double   , 
      `valor_pago` double   , 
      `valor_aberto` double   , 
      `valor_multa` double   , 
      `cheque_banco_id` int   , 
      `cheque_agencia` text   , 
      `cheque_conta` text   , 
      `cheque_emitente` text   , 
      `cheque_cpfcnpj` text   , 
      `data_competencia` date   , 
      `conta_corrente_boleto_id` int   , 
      `boleto_situacao_id` int   , 
      `boleto_nosso_numero` text   , 
      `vendedor_comissao` double   , 
      `vendedor_id` int   , 
      `contasrec_bloco_id` int   , 
      `venda_formapgto_id` int   , 
      `data_emissao` date   NOT NULL  , 
      `ativo_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec_anexos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contasrec_id` int   NOT NULL  , 
      `titulos_tipo_anexo_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `arquivo` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec_baixas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contasrec_id` int   NOT NULL  , 
      `conta_corrente_id` int   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `juros` double   , 
      `desconto` double   , 
      `saldo_aberto` double   NOT NULL  , 
      `saldo_apagar` double   , 
      `multa` double   , 
      `historico` text   , 
      `data_pagamento` date   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec_bloco( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `cliente_id` int   NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `plano_conta_id` int   NOT NULL  , 
      `centro_custo_id` int   NOT NULL  , 
      `quantidade_parcelas` int   NOT NULL  , 
      `primeiro_vencimento` date   , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `numero_documento` text   , 
      `observacao` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec_historico_cobranca( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contasrec_id` int   NOT NULL  , 
      `historico` text   NOT NULL  , 
      `data_cobranca` date   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec_historico_venc( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `contasrec_id` int   NOT NULL  , 
      `vencimento_anterior` date   , 
      `vencimento_atual` date   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE contasrec_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cst_cofins( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cst_numero` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cst_icms( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `regime_tributario_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cst_numero` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cst_ipi( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cst_numero` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE cst_pis( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cst_numero` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE despesas_servicos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `despesas_servicos_tipo_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE despesas_servicos_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE dispositivos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `token` varchar  (100)   NOT NULL  , 
      `serial_dispositivo` text   , 
      `criado_em` datetime   NOT NULL  , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `alterado_por` text   , 
      `deletado_em` datetime   , 
      `data_hora_ultima_sincronizacao` datetime   , 
      `ip_sincronizacao` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE email_template( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `titulo` text   NOT NULL  , 
      `mensagem` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estado( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `sigla` char  (2)   NOT NULL  , 
      `codigo_ibge` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_deposito( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_estante( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `estoque_rua_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_lancamentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `estoque_origem_id` int   NOT NULL  , 
      `estoque_tipo_movimentacao_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `estoque_deposito_id` int   NOT NULL  , 
      `produto_lote_id` int   , 
      `venda_id` int   , 
      `nota_fiscal_compra_id` int   , 
      `ordem_producao_id` int   , 
      `quantidade` double   NOT NULL  , 
      `observacao` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `preco_venda` double   , 
      `preco_custo` double   , 
      `data_lancamento` date   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `estoque_tipo_movimentacao_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_prateleira( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `estoque_estante_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_rua( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `estoque_deposito_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_saldos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `estoque_deposito_id` int   NOT NULL  , 
      `produto_lote_id` int   , 
      `quant_disponivel` double   NOT NULL  , 
      `quant_reservada` double   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `preco_medio_venda` double   , 
      `preco_medio_custo` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE estoque_tipo_movimentacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE eventos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_program_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `email_template_id` int   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE eventos_documentos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   , 
      `system_users_id` int   , 
      `system_unit_id` int   , 
      `cstat` int   , 
      `xmotivo` varchar  (255)   , 
      `xevento` varchar  (255)   , 
      `tpevento` varchar  (255)   , 
      `nseqevento` int   , 
      `dhregevento` datetime   , 
      `nprot` varchar  (255)   , 
      `origem_event` varchar  (255)   , 
      `mensagem_manual` text   , 
      `tpamb` int   , 
      `veraplic` varchar  (255)   , 
      `chnfe` varchar  (255)   , 
      `dhrecbto` datetime   , 
      `digval` varchar  (255)   , 
      `xml` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE eventos_systemuser( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `eventos_id` int   NOT NULL  , 
      `system_users_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `enviar_email` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE forma_pagamento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `codigo_interno` int   NOT NULL  , 
      `tipo_documento_id` int   NOT NULL  , 
      `meio_pagamento_tef_id` int   , 
      `notafiscal_tpag_id` int   , 
      `descricao` text   NOT NULL  , 
      `prazo_pagamento` int   , 
      `taxa` double   , 
      `deletado_em` datetime   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `criado_por` text   , 
      `alterado_por` text   , 
      `utiliza_pdv` char  (1)   , 
      `obriga_nf_pdv` char  (1)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE formapgto_condpgto( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `condicao_pagamento_id` int   NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE fornecedor( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `pessoa_tipo_id` int   NOT NULL  , 
      `fornecedor_classificacao_id` int   , 
      `nome` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `insc_estadual` text   , 
      `insc_municipal` text   , 
      `cpf_cnpj` text   , 
      `razao_social` text   , 
      `logradouro` text   , 
      `cidade_id` int   , 
      `bairro` text   , 
      `cep` text   , 
      `numero` text   , 
      `complemento` text   , 
      `fone` text   , 
      `email` text   , 
      `site` text   , 
      `observacoes` text   , 
      `notafiscal_crt_id` int   , 
      `deletado_em` datetime   , 
      `notafiscal_indiedest_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE fornecedor_classificacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `ativo_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE fornecedor_contato( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `fornecedor_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `tipo_contato` text   , 
      `nome` text   NOT NULL  , 
      `fone` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE funcionario( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `funcionario_cargo_id` int   , 
      `nome` text   NOT NULL  , 
      `cpf` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `valor_salario` double   , 
      `valor_hora` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE funcionario_cargo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE funil( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE funil_etapas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `funil_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `numero_etapa` int   NOT NULL  , 
      `cor_etapa` text   , 
      `cor_negocio` text   , 
      `ultima_etapa` int   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `permite_edicao` char  (1)   , 
      `permite_exclusao` char  (1)   , 
      `kanban` char  (1)   , 
      `etapa_ganha` char  (1)   , 
      `etapa_perde` char  (1)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE indicador_personalizado( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `url_indicador` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE integradores( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE integradores_servicos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `integradores_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE inutilizar_numero( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `created_at` datetime   , 
      `system_user` int   , 
      `update_at` datetime   , 
      `deleted_at` datetime   , 
      `ninicio` varchar  (20)   , 
      `nfinal` varchar  (20)   , 
      `serie` varchar  (20)   , 
      `system_unit_id` int   , 
      `system_users_id` int   , 
      `xml_retorno` text   , 
      `protocolo` varchar  (50)   , 
      `xmotivo` varchar  (200)   , 
      `cstat` int   , 
      `notafiscal_id` int   , 
      `xjust` varchar  (150)   , 
      `tipo` int   NOT NULL    DEFAULT 1, 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `idmdfe` varchar  (255)   , 
      `chMDF` text   , 
      `nProt` text   , 
      `cStat` text   , 
      `mdfe_tpemit_id` int   NOT NULL  , 
      `mdfe_tpprop_id` int   NOT NULL  , 
      `mdfe_tptransp_id` int   , 
      `mdfe_tpcar_id` int   NOT NULL  , 
      `nMDF` text   NOT NULL  , 
      `serie` text   , 
      `dhEmi` datetime   , 
      `UFIni` int   NOT NULL  , 
      `UFFim` int   NOT NULL  , 
      `dhIniViagem` datetime   , 
      `indCanalVerde` int   NOT NULL  , 
      `indCarregaPosterior` int   NOT NULL  , 
      `infAdFisco` text   , 
      `infCpl` text   , 
      `mdfe_respSeg_id` int   , 
      `seguro_cpfcnpj` text   , 
      `seguradora_xSeg` text   , 
      `seguradora_cnpj` text   , 
      `vCarga` double   , 
      `mdfe_cunid_id` int   NOT NULL  , 
      `qCarga` double   , 
      `mdfe_tpcarga_id` int   , 
      `prod_xProd` text   , 
      `prod_cEAN` text   , 
      `prod_NCM` text   , 
      `pgto_cpfcnpj` text   , 
      `pgto_idEstrangeiro` text   , 
      `pgto_xNome` text   , 
      `pgto_vContrato` double   , 
      `pgto_indAltoDesemp` text   , 
      `mdfe_indpag_id` int   , 
      `pgto_vAdiant` double   , 
      `indAntecipaAdiant` int   , 
      `pgto_codBanco` text   , 
      `pgto_codAgencia` text   , 
      `pgto_CNPJIPEF` text   , 
      `pgto_PIX` text   , 
      `veic_rntrc` text   , 
      `mdfe_tpRod_id` int   NOT NULL  , 
      `veic_estado_id` int   NOT NULL  , 
      `veic_cint` int   , 
      `veic_placa` text   , 
      `veic_renavam` text   , 
      `veic_tara` double   , 
      `justificativa_cancelamento` text   , 
      `mensagem_sefaz` text   , 
      `status` text   , 
      `data_hora_envio` datetime   , 
      `protocolo_cancelamento` text   , 
      `datahora_cancelamento` datetime   , 
      `veiculo_id` int   NOT NULL  , 
      `mdfe_situacao_id` int   NOT NULL  , 
      `mdfe_tpamb_id` int   NOT NULL  , 
      `api_documentos_id` int   , 
      `xml_cancelamento` text   , 
      `xml` text   , 
      `cidade_encerramento_id` int   , 
      `cmunencerramento` int   , 
      `data_encerramento` date   , 
      `datahora_encerramento` datetime   , 
      `protocolo_encerramento` text   , 
      `xml_encerramento` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_componentes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `mdfe_tpcomp_id` int   NOT NULL  , 
      `vComp` double   , 
      `xComp` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_condutor( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `xnome` text   NOT NULL  , 
      `cpf` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_ctes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `chCTe` text   , 
      `SegCodBarra` text   , 
      `indReentrega` int   NOT NULL  , 
      `mdfe_infmundescarga_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_cunid( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_evento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `status` text   , 
      `codigo_status` text   , 
      `motivo_status` text   , 
      `id_evento` text   , 
      `numero_sequencial` text   , 
      `chave` text   , 
      `protocolo` text   , 
      `tipo_evento` text   , 
      `data_recebimento` text   , 
      `data_evento` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_inclusao_dfe( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `mdfe_id` int   NOT NULL  , 
      `notafiscal_id` int   , 
      `cidade_carrega_id` int   NOT NULL  , 
      `cidade_descarga_id` int   NOT NULL  , 
      `chave` text   NOT NULL  , 
      `protocolo` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_indpag( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_infmuncarrega( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `cidade_id` int   NOT NULL  , 
      `cMunCarrega` text   NOT NULL  , 
      `xMunCarrega` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_infmundescarga( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `cidade_id` int   NOT NULL  , 
      `cMunDescarga` text   NOT NULL  , 
      `xMunDescarga` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_infpercurso( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `UFPer` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_lacres( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `nLacre` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_logs( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `system_users_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_mdfes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `chMDFe` text   , 
      `indReentrega` int   NOT NULL  , 
      `mdfe_infmundescarga_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_nfes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `chNFe` text   , 
      `SegCodBarra` text   , 
      `indReentrega` int   NOT NULL  , 
      `mdfe_infmundescarga_id` int   NOT NULL  , 
      `notafiscal_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_parcelas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `nParcela` text   , 
      `dVenc` date   , 
      `vParcela` double   , 
      `mdfe_tpAntecip_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_respSeg( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_series( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `mdfe_tpamb_id` int   NOT NULL  , 
      `serie` text   NOT NULL  , 
      `sequencial` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `cor` text   , 
      `ordem` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpamb( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `valor` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpAntecip( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpcar( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpcarga( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpcomp( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpemit( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpprop( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tpRod( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_tptransp( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE mdfe_xmlaut( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `mdfe_id` int   NOT NULL  , 
      `cpfcnpj` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE meio_pagamento_tef( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE movimentacao_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natop_excecao_tributo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natureza_operacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `natureza_operacao_finalidade_id` int   NOT NULL  , 
      `cst_icms_id` int   , 
      `cst_icms_nao_contribuinte_id` int   , 
      `cst_ipi_id` int   , 
      `cst_pis_id` int   , 
      `cst_cofins_id` int   , 
      `cfop` char  (4)   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `obs_padrao` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `icms_aliquota` double   , 
      `ipi_aliquota` double   , 
      `ipi_codigo_enquadramento` text   , 
      `pis_aliquota` double   , 
      `pis_base` double   , 
      `cofins_aliquota` double   , 
      `consumidor_final_id` int   , 
      `cofins_base` double   , 
      `icms_pRedBC` double   , 
      `icms_pICMS` double   , 
      `icms_pDif` double   , 
      `icms_vICMSDeson` double   , 
      `icms_pMVAST` double   , 
      `icms_pICMSST` double   , 
      `icms_pFCP` double   , 
      `icms_pFCPST` double   , 
      `icms_pFCPSTRet` double   , 
      `icms_pST` double   , 
      `icms_pCredSN` date   , 
      `icms_pRedBCEfet` double   , 
      `icms_pICMSEfet` double   , 
      `notafiscal_item_modbc_id` int   , 
      `notafiscal_item_modbcst_id` int   , 
      `notafiscal_item_motDesICMS_id` int   , 
      `icms_pFCPUFDest` double   , 
      `icms_pICMSUFDest` double   , 
      `icms_baseST` double   , 
      `icms_base` double   , 
      `cfop_fora` char  (4)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natureza_operacao_estados( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `natureza_operacao_excecao_id` int   NOT NULL  , 
      `estado_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natureza_operacao_excecao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `natureza_operacao_id` int   NOT NULL  , 
      `natop_excecao_tributo_id` int   NOT NULL  , 
      `cst_pis_id` int   , 
      `cst_ipi_id` int   , 
      `cst_icms_id` int   , 
      `cst_cofins_id` int   , 
      `cfop` char  (4)   , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `icms_aliquota` double   , 
      `ipi_aliquota` double   , 
      `ipi_codigo_enquadramento` text   , 
      `pis_aliquota` double   , 
      `pis_base` double   , 
      `cofins_aliquota` double   , 
      `cofins_base` double   , 
      `icms_predbc` double   , 
      `icms_picms` double   , 
      `icms_pdif` double   , 
      `icms_vicmsdeson` double   , 
      `icms_pmvast` double   , 
      `icms_picmsst` double   , 
      `icms_pfcp` double   , 
      `icms_pfcpst` double   , 
      `icms_pfcpstret` double   , 
      `icms_pst` double   , 
      `icms_pcredsn` double   , 
      `icms_predbcefet` double   , 
      `icms_picmsefet` double   , 
      `icms_pfcpufdest` double   , 
      `icms_picmsufdest` double   , 
      `icms_base` double   , 
      `icms_basest` double   , 
      `notafiscal_item_modbc_id` int   , 
      `notafiscal_item_modbcst_id` int   , 
      `notafiscal_item_motDesICMS_id` int   , 
      `cfop_fora` char  (4)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natureza_operacao_finalidade( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natureza_operacao_ncm( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `natureza_operacao_excecao_id` int   NOT NULL  , 
      `ncm` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natureza_operacao_origens( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `natureza_operacao_excecao_id` int   NOT NULL  , 
      `notafiscal_item_orig_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE natureza_operacao_produtos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `natureza_operacao_excecao_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `negocio_origem_id` int   NOT NULL  , 
      `funil_id` int   , 
      `funil_etapas_id` int   NOT NULL  , 
      `titulo` text   NOT NULL  , 
      `valor` double   , 
      `data_abertura` date   NOT NULL  , 
      `ordem` int   NOT NULL  , 
      `data_fechamento` date   , 
      `negocio_motivo_perda_id` int   , 
      `comentarios_motivo_perda` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `contato_nome` text   , 
      `contato_fone` text   , 
      `ativo_id` int   NOT NULL  , 
      `arquivado` int   NOT NULL  , 
      `data_fechamento_esperada` date   , 
      `vendedor_id` int   , 
      `mes` int   , 
      `ano` int   , 
      `orcamento_id` int   , 
      `cliente_id` int   , 
      `deletado_em` datetime   , 
      `contato_email` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_arquivos( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `negocio_id` int   NOT NULL  , 
      `arquivo` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_atividade( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `negocio_id` int   NOT NULL  , 
      `negocio_tipo_atividade_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `horario_inicial` datetime   , 
      `horario_final` datetime   , 
      `observacao` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_etapas_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `negocio_id` int   NOT NULL  , 
      `funil_etapas_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_itens( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `negocio_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `valor_unitario` double   NOT NULL  , 
      `quantidade` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
      `desconto` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_motivo_perda( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_notas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `negocio_id` int   NOT NULL  , 
      `nota` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE negocio_tipo_atividade( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `icone` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `cliente_id` int   , 
      `venda_id` int   , 
      `numero` text   NOT NULL  , 
      `data_emissao` datetime   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `texto_rodape` text   , 
      `data_saida` datetime   , 
      `icms_basecalc` double   , 
      `icms_valor` double   , 
      `icms_subst_base_calc` int   , 
      `icms_subst_valor` double   , 
      `frete_valor` double   , 
      `seguro_valor` double   , 
      `outras_despesas` double   , 
      `ipi_valor` double   , 
      `serie` text   , 
      `valor_total_produtos` double   , 
      `valor_total_nota` double   , 
      `transp_nome` text   , 
      `transp_cnpj` text   , 
      `transp_inscest` text   , 
      `transp_endereco` text   , 
      `transp_cidade` text   , 
      `transp_placaveiculo` text   , 
      `transp_uf` text   , 
      `transp_veiculouf` text   , 
      `transp_veiculoRNTC` text   , 
      `transp_numeracao` text   , 
      `nf_tipodocumento_id` int   NOT NULL  , 
      `notafiscal_situacao_id` int   NOT NULL  , 
      `notafiscal_crt_id` int   NOT NULL  , 
      `cliente_endereco` text   , 
      `cliente_complemento` text   , 
      `cliente_numero` text   , 
      `cliente_bairro` text   , 
      `cliente_cidade` text   , 
      `cliente_cep` text   , 
      `cliente_estado` text   , 
      `cliente_nome` text   , 
      `cliente_cpfcnpj` text   , 
      `cliente_inscest` text   , 
      `cliente_inscmuni` text   , 
      `cliente_fone` text   , 
      `cliente_cidade_codibge` int   , 
      `cliente_suframa` text   , 
      `justificativa_cancelamento` text   , 
      `chave` text   , 
      `protocolo_envio` text   , 
      `notafiscal_indiedest_id` int   NOT NULL  , 
      `protocolo_cancelamento` text   , 
      `datahora_cancelamento` datetime   , 
      `cce_datahora_evento` datetime   , 
      `cce_sequencial` int   , 
      `cce_correcao` text   , 
      `cce_protocolo` text   , 
      `infadfisco` text   , 
      `desconto_valor` double   , 
      `pis_valor` double   , 
      `cofins_valor` double   , 
      `fatura_numero` text   , 
      `fatura_valor_original` double   , 
      `fatura_valor_desconto` double   , 
      `fatura_valor_liquido` double   , 
      `notafiscal_iddest_id` int   NOT NULL  , 
      `notafiscal_tpimp_id` int   NOT NULL  , 
      `notafiscal_tpemis_id` int   NOT NULL  , 
      `notafiscal_finnfe_id` int   NOT NULL  , 
      `notafiscal_indfinal_id` int   NOT NULL  , 
      `notafiscal_indpres_id` int   NOT NULL  , 
      `verproc` text   , 
      `notafiscal_indpag_id` int   NOT NULL  , 
      `retirada_marcado` int   , 
      `retirada_cpfcnpj` text   , 
      `retirada_xlgr` text   , 
      `retirada_nro` text   , 
      `retirada_xcpl` text   , 
      `retirada_xbairro` text   , 
      `retirada_cmun` int   , 
      `retirada_xmun` text   , 
      `retirada_uf` text   , 
      `entrega_marcado` int   , 
      `entrega_cpfcnpj` text   , 
      `entrega_xlgr` text   , 
      `entrega_nro` text   , 
      `entrega_xcpl` text   , 
      `entrega_xbairro` text   , 
      `entrega_cmun` int   , 
      `entrega_xmun` text   , 
      `entrega_uf` text   , 
      `vicmsufdest` double   , 
      `vicmsufremet` double   , 
      `vfcpufdest` double   , 
      `notafiscal_modelo_id` int   NOT NULL  , 
      `dispositivos_id` int   , 
      `xml` text   , 
      `data_hora_envio` datetime   , 
      `xml_cancelamento` text   , 
      `issqn_vserv` double   , 
      `issqn_vbc` double   , 
      `issqn_viss` double   , 
      `issqn_dcompet` date   , 
      `issqn_reftrib` text   , 
      `icms_vfcp` double   , 
      `icms_vfcpst` double   , 
      `icms_vfcpstret` double   , 
      `layout_versao` text   , 
      `ipi_vipidevol` double   , 
      `vtroco` double   , 
      `notafiscal_tpamb_id` int   NOT NULL  , 
      `notafiscal_mod_id` int   NOT NULL  , 
      `infcpl` text   , 
      `notafiscal_modfrete_id` int   NOT NULL  , 
      `status` text   , 
      `mensagem` text   , 
      `cce_xml` text   , 
      `cce_pdf` text   , 
      `codigo_sefaz` int   , 
      `sn_carta_correcao` char  (1)   NOT NULL    DEFAULT 'N', 
      `deletado_em` datetime   , 
      `contingencia_data` datetime   , 
      `contingencia_motivo` text   , 
      `exporta_ufsaidapais` text   , 
      `exporta_xlocexporta` text   , 
      `exporta_xlocdespacho` text   , 
      `cliente_cpais` text   , 
      `cliente_xpais` text   , 
      `natureza_operacao_id` int   , 
      `movimentacao_origem_id` int   , 
      `inutilizar` int   , 
      `xml_inicial` text   , 
      `entrega_cuf` int   , 
      `xml_assinado` text   , 
      `protolo_xml` text   , 
      `xml_autorizado` text   , 
      `cep_entrega` varchar  (15)   , 
      `cep_retirada` varchar  (15)   , 
      `entrega_xnome` varchar  (200)   , 
      `xml_carta` text   , 
      `protocolo_carta_resposta` varchar  (200)   , 
      `descricao` text   , 
      `xevento` text   , 
      `xmotivo` text   , 
      `cstat` int   , 
      `dhregevento` varchar  (50)   , 
      `nseqevento` int   , 
      `nprot` varchar  (100)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_autxml( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `cpf_cnpj` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   NOT NULL  , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE nota_fiscal_compra( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `fornecedor_id` int   , 
      `numero` text   NOT NULL  , 
      `data_emissao` datetime   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `natop` text   , 
      `data_saida` datetime   , 
      `infcpl` text   , 
      `infadfisco` text   , 
      `icms_basecalc` double   , 
      `icms_valor` double   , 
      `icms_subst_base_calc` double   , 
      `icms_subst_valor` double   , 
      `frete_valor` double   , 
      `seguro_valor` double   , 
      `outras_despesas` double   , 
      `ipi_valor` double   , 
      `serie` text   , 
      `valor_total_produtos` double   , 
      `valor_total_nota` double   , 
      `transp_nome` text   , 
      `transp_cnpj` text   , 
      `transp_inscest` text   , 
      `transp_endereco` text   , 
      `transp_cidade` text   , 
      `transp_placaveiculo` text   , 
      `transp_uf` text   , 
      `transp_veiculouf` text   , 
      `transp_veiculorntc` text   , 
      `transp_numeracao` text   , 
      `notafiscal_tipodocumento_id` int   NOT NULL  , 
      `nota_fiscal_compra_situacao_id` int   NOT NULL  , 
      `notafiscal_crt_id` int   , 
      `obs_importacao_xml` text   , 
      `cliente_endereco` text   , 
      `cliente_complemento` text   , 
      `cliente_numero` text   , 
      `cliente_bairro` text   , 
      `cliente_cidade` text   , 
      `cliente_cep` text   , 
      `cliente_estado` text   , 
      `cliente_nome` text   , 
      `cliente_cpfcnpj` text   , 
      `cliente_inscest` text   , 
      `cliente_fone` text   , 
      `cliente_cidade_codibge` text   , 
      `cliente_inscmuni` text   , 
      `cliente_suframa` text   , 
      `justificativa_cancelamento` text   , 
      `chave` text   , 
      `protocolo_envio` text   , 
      `notafiscal_indiedest_id` int   , 
      `protocolo_cancelamento` text   , 
      `datahora_cancelamento` text   , 
      `cce_datahora_evento` text   , 
      `cce_sequencial` text   , 
      `cce_correcao` text   , 
      `cce_protocolo` text   , 
      `desconto_valor` double   , 
      `pis_valor` double   , 
      `cofins_valor` double   , 
      `fatura_numero` text   , 
      `fatura_valor_original` text   , 
      `fatura_valor_desconto` double   , 
      `fatura_valor_liquido` double   , 
      `notafiscal_iddest_id` int   NOT NULL  , 
      `notafiscal_tpimp_id` int   , 
      `notafiscal_finnfe_id` int   NOT NULL  , 
      `notafiscal_indfinal_id` int   NOT NULL  , 
      `notafiscal_indpres_id` int   NOT NULL  , 
      `verproc` text   , 
      `notafiscal_indpag_id` int   , 
      `retirada_marcado` int   , 
      `retirada_cpfcnpj` text   , 
      `retirada_xlgr` text   , 
      `retirada_nro` text   , 
      `retirada_xcpl` text   , 
      `retirada_xbairro` text   , 
      `retirada_cmun` int   , 
      `retirada_xmun` text   , 
      `retirada_uf` text   , 
      `entrega_marcado` int   , 
      `entrega_cpfcnpj` text   , 
      `entrega_xlgr` text   , 
      `entrega_nro` text   , 
      `entrega_xcpl` text   , 
      `entrega_xbairro` text   , 
      `entrega_cmun` text   , 
      `entrega_xmun` text   , 
      `entrega_uf` text   , 
      `vicmsufdest` double   , 
      `vicmsufremet` double   , 
      `vfcpufdest` text   , 
      `notafiscal_mod_id` int   NOT NULL  , 
      `xml` text   , 
      `data_hora_envio` datetime   , 
      `xml_cancelamento` text   , 
      `issqn_vserv` double   , 
      `issqn_vbc` double   , 
      `issqn_viss` double   , 
      `issqn_dcompet` date   , 
      `issqn_reftrib` text   , 
      `icms_vfcp` double   , 
      `icms_vfcpst` double   , 
      `icms_vfcpstret` double   , 
      `layout_versao` text   , 
      `ipi_vipidevol` double   , 
      `vtroco` date   , 
      `notafiscal_modfrete_id` int   , 
      `cpag_lancada` boolean   NOT NULL  , 
      `dest_cnpj` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE nota_fiscal_compra_dup( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nota_fiscal_compra_id` int   NOT NULL  , 
      `forma_pagamento_id` int   , 
      `plano_conta_id` int   , 
      `centro_custo_id` int   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `ndup` text   , 
      `vdup` double   , 
      `dvenc` date   , 
      `parcela` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE nota_fiscal_compra_itens( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nota_fiscal_compra_id` int   NOT NULL  , 
      `produto_id` int   , 
      `nota_fiscal_compra_itens_situacao_id` int   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `nitem` int   , 
      `cean` text   , 
      `xprod` text   , 
      `ncm` text   , 
      `nve` text   , 
      `extipi` text   , 
      `cfop` text   , 
      `ucom` text   , 
      `qcom` double   , 
      `vuncom` double   , 
      `vprod` double   , 
      `ceantrib` text   , 
      `utrib` text   , 
      `qtrib` double   , 
      `vuntrib` double   , 
      `vfrete` double   , 
      `vseg` double   , 
      `vdesc` double   , 
      `vtottrib` double   , 
      `xped` text   , 
      `nitemped` int   , 
      `notafiscal_item_indtot_id` int   , 
      `notafiscal_item_orig_id` int   NOT NULL  , 
      `notafiscal_item_modbc_id` int   , 
      `icms_basecalc` double   , 
      `icms_cst` text   , 
      `icms_valor` double   , 
      `icms_aliquota` double   , 
      `icms_pcredsn` double   , 
      `icms_vcredicmssn` double   , 
      `icms_predbc` double   , 
      `icms_pst` double   , 
      `icms_pmvast` double   , 
      `icms_predbcst` double   , 
      `icms_vbcst` double   , 
      `icms_picmsst` double   , 
      `icms_vicmsst` double   , 
      `fcp_pfcp` double   , 
      `pis_cst` text   , 
      `pis_valor` double   , 
      `pis_aliquota` double   , 
      `pis_valor_base` double   , 
      `cofins_cst` text   , 
      `cofins_valor_base` double   , 
      `cofins_aliquota` double   , 
      `cofins_valor` double   , 
      `voutro` double   , 
      `infadprod` text   , 
      `notafiscal_item_motDesICMS_id` int   , 
      `cprod` text   , 
      `ipi_cst` text   , 
      `ipi_valor_base` double   , 
      `ipi_aliquota` double   , 
      `ipi_vipidevol` double   , 
      `ipi_valor` double   , 
      `ipi_pdevol` double   , 
      `estoque_deposito_id` int   , 
      `produto_lote_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE nota_fiscal_compra_itens_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE nota_fiscal_compra_pag( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nota_fiscal_compra_id` int   NOT NULL  , 
      `notafiscal_tpag_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `tpag` text   , 
      `vpag` double   , 
      `xpag` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE nota_fiscal_compra_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `cor` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_cprod_padrao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_crt( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` int   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_dup( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `ndup` text   , 
      `vdup` double   , 
      `dvenc` date   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_finnfe( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_frete_volumes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `qVol` int   , 
      `nVol` text   , 
      `esp` text   , 
      `marca` text   , 
      `pesol` double   , 
      `pesob` double   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_iddest( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_indfinal( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_indiedest( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_indpag( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_indpres( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_item_indtot( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_item_modbc( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `codigo` int   , 
      `descricao` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_item_modbcst( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `codigo` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_item_motDesICMS( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `codigo` text   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_item_orig( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `codigo` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_itens( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `nitem` int   , 
      `cean` varchar  (50)   , 
      `xprod` text   NOT NULL  , 
      `ncm` text   , 
      `nve` text   , 
      `extipi` text   , 
      `cfop` text   , 
      `ucom` text   , 
      `qcom` double   NOT NULL  , 
      `vuncom` double   NOT NULL  , 
      `vprod` double   , 
      `ceantrib` text   , 
      `utrib` text   , 
      `qtrib` double   , 
      `vuntrib` double   , 
      `vfrete` double   , 
      `vseg` double   , 
      `vdesc` double   , 
      `vtottrib` double   , 
      `xped` text   , 
      `nitemped` int   , 
      `notafiscal_item_indtot_id` int   , 
      `notafiscal_item_orig_id` int   NOT NULL  , 
      `notafiscal_item_modbc_id` int   , 
      `icms_basecalc` double   , 
      `icms_cst` varchar  (20)   , 
      `icms_valor` double   , 
      `icms_aliquota` double   , 
      `icms_pcredsn` double   , 
      `icms_vcredicmssn` double   , 
      `icms_predbc` double   , 
      `icms_pst` double   , 
      `icms_pmvast` double   , 
      `icms_predbcst` double   , 
      `icms_vbcst` double   , 
      `icms_picmsst` double   , 
      `icms_vicmsst` double   , 
      `alterado_em` datetime   , 
      `criado_em` datetime   , 
      `pis_cst` varchar  (20)   , 
      `pis_valor` double   , 
      `pis_aliquota` double   , 
      `pis_valor_base` double   , 
      `cofins_cst` varchar  (20)   , 
      `cofins_valor_base` double   , 
      `cofins_aliquota` double   , 
      `cofins_valor` double   , 
      `voutro` double   , 
      `infadprod` text   , 
      `notafiscal_item_motDesICMS_id` int   , 
      `cprod` text   , 
      `ipi_cst` varchar  (255)   , 
      `ipi_valor_base` double   , 
      `ipi_aliquota` double   , 
      `ipi_vipidevol` double   , 
      `ipi_valor` double   , 
      `ipi_pdevol` double   , 
      `cest` text   , 
      `fcp_pfcp` double   , 
      `fcp_vfcp` double   , 
      `fcp_vbcfcp` double   , 
      `fcp_vbcfcpst` double   , 
      `fcp_pfcpst` double   , 
      `fcp_vfcpst` double   , 
      `fcp_vbcfcpstret` double   , 
      `fcp_pfcpstret` double   , 
      `fcp_vfcpstret` double   , 
      `icms_vbcufdest` double   , 
      `icms_vbcfcpufdest` double   , 
      `icms_pfcpufdest` double   , 
      `icms_vfcpufdest` double   , 
      `icms_picmsinter` double   , 
      `icms_picmsinterpart` double   , 
      `icms_vicmsufdest` double   , 
      `icms_vicmsufremet` double   , 
      `icms_picmsufdest` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_logs( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `system_users_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_mod( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `modelo` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_modfrete( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_pag( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `notafiscal_tpag_id` int   NOT NULL  , 
      `tpag` text   , 
      `vpag` double   , 
      `xpag` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_refecf( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `notafiscal_refecfmod_id` int   NOT NULL  , 
      `necf` text   , 
      `ncoo` text   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_refecfmod( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_refnfe( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   NOT NULL  , 
      `refnfe` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_series( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `serie` text   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `notafiscal_tpamb_id` int   NOT NULL  , 
      `notafiscal_mod_id` int   NOT NULL  , 
      `sequencial` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `notafiscal_tipodocumento_id` int   NOT NULL  , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `ordem` int   , 
      `exibir` boolean   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `criado_por` text   NOT NULL  , 
      `alterado_por` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_situacao_sefaz( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_situacao_id` int   NOT NULL  , 
      `codigo_sefaz` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_tipodoc_series( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_series_id` int   NOT NULL  , 
      `notafiscal_tipodocumento_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_tipodocumento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_tpag( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `tpag` text   NOT NULL  , 
      `criado_em` datetime   , 
      `descricao` text   NOT NULL  , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_tpamb( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_tpemis( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE notafiscal_tpimp( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `valor` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE orcamento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `orcamento_situacao_id` int   NOT NULL  , 
      `vendedor_id` int   , 
      `cliente_id` int   , 
      `cliente_contato_id` int   , 
      `data_orcamento` date   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `observacao` text   , 
      `valor_produtos` double   NOT NULL  , 
      `desconto` double   , 
      `peso_total` double   , 
      `frete_total` double   , 
      `valor_total` double   NOT NULL  , 
      `tabela_preco_id` int   , 
      `justificativa_reprovacao` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE orcamento_interacoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `orcamento_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE orcamento_item( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `orcamento_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade` double   NOT NULL  , 
      `valor_unitario` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
      `valor_original` double   NOT NULL  , 
      `valor_custo` double   , 
      `desconto` double   , 
      `informacoes_adicionais` text   , 
      `numero_pedido` text   , 
      `numero_item_pedido` text   , 
      `valor_frete` double   , 
      `peso_unitario` double   , 
      `peso_total` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE orcamento_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `ordem` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE orcamento_situacao_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `orcamento_situacao_id` int   NOT NULL  , 
      `orcamento_id` int   NOT NULL  , 
      `descricao` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_producao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `ordem_producao_situacao_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `produto_ficha_tecnica_id` int   NOT NULL  , 
      `estoque_deposito_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade` double   NOT NULL  , 
      `data_producao` date   NOT NULL  , 
      `observacoes` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_producao_etapas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_producao_id` int   NOT NULL  , 
      `ordem_producao_etapas_situacao_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `ordem` int   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_producao_etapas_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_producao_itens( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_producao_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `estoque_deposito_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade` double   NOT NULL  , 
      `quantidade_total` double   NOT NULL  , 
      `custo` double   , 
      `custo_total` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_producao_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_producao_situacao_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_producao_id` int   NOT NULL  , 
      `ordem_producao_situacao_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_producao_vendas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_producao_id` int   NOT NULL  , 
      `venda_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `cliente_id` int   NOT NULL  , 
      `cliente_contato_id` int   , 
      `vendedor_id` int   , 
      `ordem_servico_situacao_id` int   NOT NULL  , 
      `ordem_servico_producao_etapa_id` int   , 
      `condicao_pagamento_id` int   , 
      `cliente_endereco_id` int   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `numero_os` int   , 
      `numero_orcamento` int   , 
      `data_emissao` date   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `desconto` double   , 
      `prazo_entrega` date   , 
      `validade_dias` int   , 
      `data_abertura_os` date   , 
      `vendedor_comissao` double   , 
      `vendedor_comissao_avista` double   , 
      `vendedor_comissao_aprazo` double   , 
      `observacoes` text   , 
      `prazo_garantia` date   , 
      `valor_pago` double   , 
      `motivo_nao_aprovacao_orcamento` text   , 
      `valor_avista` double   , 
      `valor_aprazo` double   , 
      `valor_faturado_vendas` double   , 
      `usuario_aprovacao_id` int   , 
      `informacoes_transporte` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_garantia_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_id` int   NOT NULL  , 
      `observacoes` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_situacao_id` int   NOT NULL  , 
      `ordem_servico_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_item( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `descricao_servico` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade` double   NOT NULL  , 
      `quantidade_atendida` double   , 
      `valor_unitario` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
      `desconto` double   , 
      `arquivo` text   , 
      `largura` double   , 
      `altura` double   , 
      `quantidade_a_faturar` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_item_despesas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_item_id` int   NOT NULL  , 
      `despesas_servicos_id` int   NOT NULL  , 
      `despesas_servicos_tipo_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `valor_unitario` double   NOT NULL  , 
      `quantidade` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_item_ficha_tecnica( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_item_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `quantidade_fixa_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade` double   NOT NULL  , 
      `custo` double   , 
      `valor_unitario` double   , 
      `valor_total` double   , 
      `quantidade_original` double   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_item_mao_obra( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_item_id` int   NOT NULL  , 
      `funcionario_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade_horas` double   , 
      `valor_hora` double   , 
      `valor_total` double   , 
      `quantidade_horas_original` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_item_obs_etapas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_item_id` int   NOT NULL  , 
      `ordem_servico_producao_etapa_id` int   NOT NULL  , 
      `observacao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_producao_etapa( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `cor` text   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE ordem_servico_venda( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `ordem_servico_id` int   NOT NULL  , 
      `venda_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE painel_indicadores( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE painel_indicador_usuario( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `painel_indicadores_id` int   NOT NULL  , 
      `indicador_personalizado_id` int   NOT NULL  , 
      `system_users_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE pais( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `codigo_pais` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE parceiro( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `certificado_venda_modalidade_id` int   NOT NULL  , 
      `tabela_preco_id` int   , 
      `vendedor_id` int   , 
      `cpf_cnpj` text   NOT NULL  , 
      `nome` text   NOT NULL  , 
      `razao_social` text   , 
      `cep` text   , 
      `logradouro` text   , 
      `bairro` text   , 
      `cidade` text   , 
      `estado` text   , 
      `fone` text   , 
      `email` text   , 
      `contato` text   , 
      `contato_fone` text   , 
      `comissao_percentual` double   , 
      `deletado_em` datetime   , 
      `criado_em` datetime   NOT NULL  , 
      `alterado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `banco_id` int   , 
      `banco_agencia` text   , 
      `banco_conta` text   , 
      `banco_chavepix` text   , 
      `banco_nome_titular` text   , 
      `banco_cpfcnpj` text   , 
      `chave_pix_tipo_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE pdv_permissoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE pedido_evento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `notafiscal_id` int   , 
      `system_unit_id` int   , 
      `system_users_id` int   , 
      `chave` varchar  (50)   , 
      `descricao` text   , 
      `tipo` varchar  (30)   , 
      `numero` varchar  (10)   , 
      `serie` int   , 
      `nseqevento` int   , 
      `protocolo` varchar  (20)   , 
      `status` int     DEFAULT 1, 
      `protocolo_resposta` varchar  (50)   , 
      `xevento` text   , 
      `created_at` datetime   , 
      `update_at` datetime   , 
      `deleted_at` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE pessoa_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE plano_conta( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `plano_conta_tipo_id` int   NOT NULL  , 
      `plano_conta_origem_id` int   NOT NULL  , 
      `plano_conta_pai_id` int   , 
      `numero` text   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE plano_conta_origem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE plano_conta_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_grupo_id` int   NOT NULL  , 
      `unidade_medida_id` int   NOT NULL  , 
      `tipo_recurso_id` int   NOT NULL  , 
      `produto_fabricante_id` int   , 
      `produtogrupo_subgrupo_id` int   , 
      `notafiscal_item_orig_id` int   , 
      `nome` text   NOT NULL  , 
      `nome_curto` text   , 
      `codigo_EAN` text   , 
      `imagem` text   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `ncm` text   , 
      `cest` text   , 
      `criado_por` text   , 
      `alterado_por` text   , 
      `obs` text   , 
      `referencia` text   , 
      `deletado_em` datetime   , 
      `especificacao` text   , 
      `link_site` text   , 
      `peso_liquido` double   , 
      `peso_bruto` double   , 
      `habilitado_id` int   , 
      `produto_tipo_id` int   , 
      `codigo_sku` text   , 
      `largura` double   , 
      `altura` double   , 
      `comprimento` double   , 
      `diametro` double   , 
      `dias_preparacao` double   , 
      `marca` text   , 
      `garantia` text   , 
      `unidade_caixa` double   , 
      `produto_embalagem_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_embalagem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_tipo_embalagem_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `peso` double   , 
      `dimensoes` text   NOT NULL  , 
      `altura` double   , 
      `largura` double   , 
      `comprimento` double   , 
      `diametro` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_enderecamento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_filial_id` int   NOT NULL  , 
      `estoque_prateleira_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_etiqueta_configuracoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_fabricante( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_ficha_tecnica( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `custo_total` double   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_ficha_tecnica_despesas( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_ficha_tecnica_id` int   NOT NULL  , 
      `despesas_servicos_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `valor_unitario` double   NOT NULL  , 
      `quantidade` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_ficha_tecnica_etapas_producao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_ficha_tecnica_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `ordem` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_ficha_tecnica_itens( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_ficha_tecnica_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `quantidade` double   NOT NULL  , 
      `valor_custo` double   , 
      `valor_total` double   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade_fixa_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_ficha_tecnica_mao_obra( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_ficha_tecnica_id` int   NOT NULL  , 
      `funcionario_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `valor_hora` double   NOT NULL  , 
      `quantidade` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_filial( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `margem` double   , 
      `preco_venda` double   NOT NULL  , 
      `preco_venda_anterior` double   , 
      `valor_custo` double   , 
      `valor_custo_anterior` double   , 
      `criado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
      `estoque_minimo` double   , 
      `estoque_maximo` double   , 
      `local_estoque` text   , 
      `codigo_balanca` text   , 
      `deletado_em` datetime   , 
      `estoque_deposito_padrao_id` int   , 
      `sob_encomenda_id` int   , 
      `gerar_op_venda_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_filial_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `produto_filial_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `preco_venda_antigo` double   NOT NULL  , 
      `preco_venda_novo` double   NOT NULL  , 
      `valor_custo_antigo` double   , 
      `valor_custo_novo` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_fornecedor( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `fornecedor_id` int   NOT NULL  , 
      `codigo_fornecedor` text   , 
      `descricao_produto_fornecedor` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `tempo_medio_fornecimento` double   , 
      `quantidade_minima_compra` double   , 
      `preco_venda` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_grupo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `tipo_recurso_id` int   , 
      `descricao` text   NOT NULL  , 
      `imagem` text   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `criado_por` text   , 
      `alterado_por` text   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produtogrupo_subgrupo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `produto_grupo_id` int   NOT NULL  , 
      `subgrupo_id` int   , 
      `nivel` int   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_lote( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `numero` text   NOT NULL  , 
      `validade` date   , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_em` datetime   , 
      `criado_por` text   , 
      `alterado_por` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE produto_tipo_embalagem( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE resposta( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE servico_formapgto( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `ordem_servico_id` int   NOT NULL  , 
      `quantidade_parcelas` int   , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_document( 
      `id` int   NOT NULL  , 
      `category_id` int   NOT NULL  , 
      `system_user_id` int   , 
      `title` text   NOT NULL  , 
      `description` text   , 
      `submission_date` date   , 
      `archive_date` date   , 
      `filename` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_document_category( 
      `id` int   NOT NULL  , 
      `name` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_document_group( 
      `id` int   NOT NULL  , 
      `document_id` int   NOT NULL  , 
      `system_group_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_document_user( 
      `id` int   NOT NULL  , 
      `document_id` int   NOT NULL  , 
      `system_user_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_group( 
      `id` int   NOT NULL  , 
      `name` text   NOT NULL  , 
      `uuid` varchar  (36)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_group_program( 
      `id` int   NOT NULL  , 
      `system_group_id` int   NOT NULL  , 
      `system_program_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_group_program_permissoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `system_program_permissoes_id` int   NOT NULL  , 
      `system_group_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_message( 
      `id` int   NOT NULL  , 
      `system_user_id` int   NOT NULL  , 
      `system_user_to_id` int   NOT NULL  , 
      `subject` text   NOT NULL  , 
      `message` text   , 
      `dt_message` datetime   , 
      `checked` char  (1)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_notification( 
      `id` int   NOT NULL  , 
      `system_user_id` int   NOT NULL  , 
      `system_user_to_id` int   NOT NULL  , 
      `subject` text   , 
      `message` text   , 
      `dt_message` datetime   , 
      `action_url` text   , 
      `action_label` text   , 
      `icon` text   , 
      `checked` char  (1)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_preference( 
      `id` varchar  (255)   NOT NULL  , 
      `preference` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_program( 
      `id` int   NOT NULL  , 
      `name` text   NOT NULL  , 
      `controller` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_program_permissoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_program_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_unit( 
      `id` int   NOT NULL  , 
      `connection_name` text   , 
      `vendas_natureza_operacao_id` int   , 
      `nfce_natureza_operacao_id` int   , 
      `cnpj` varchar  (14)   NOT NULL  , 
      `name` text   NOT NULL  , 
      `razao_social` varchar  (255)   NOT NULL  , 
      `inscricao_estadual` varchar  (255)   , 
      `inscricao_municipal` varchar  (255)   , 
      `fone` text   , 
      `notafiscal_crt_id` int   NOT NULL  , 
      `pc_credito_sn` double     DEFAULT 0, 
      `aliquota_iss` double   , 
      `aliquota_irrf` double   , 
      `aliquota_csll` double   , 
      `sn_matriz` char  (1)   NOT NULL    DEFAULT 'N', 
      `nfce_tpamb_id` int   , 
      `nfe_tpamb_id` int   , 
      `nfe_tpimp_id` int   , 
      `nfce_tpimp_id` int   , 
      `certificadoA1` text   , 
      `senha_certificado` text   , 
      `nfe_homologacao_series_id` int   , 
      `nfe_producao_series_id` int   , 
      `nfce_homologacao_series_id` int   , 
      `nfe_api_documentos_id` int   , 
      `nfce_api_documentos_id` int   , 
      `nfce_producao_series_id` int   , 
      `end_cep` text   , 
      `end_mun_codibge` text   , 
      `end_municipio` text   , 
      `end_uf` char  (2)   , 
      `end_logradouro` text   , 
      `end_bairro` text   , 
      `end_numero` text   , 
      `end_complemento` text   , 
      `nfce_csc_homologacao` text   , 
      `nfce_csc_producao` text   , 
      `notafiscal_cprod_padrao_id` int   , 
      `nfce_id_csc_homologacao` text   , 
      `nfce_id_csc_producao` text   , 
      `email` varchar  (255)   , 
      `token_api` text   , 
      `mdfe_tpamb_id` int   , 
      `mdfe_estadoini_id` int   , 
      `veiculo_id` int   , 
      `mdfe_api_documentos_id` int   , 
      `mdfe_homologacao_series_id` int   , 
      `mdfe_producao_series_id` int   , 
      `natureza_operacao_compra_id` int   , 
      `logo` text   , 
      `contador_nome` text   , 
      `contador_documento` text   , 
      `contador_email` text   , 
      `contador_celular` text   , 
      `config_host` text   , 
      `config_user` text   , 
      `config_password` text   , 
      `config_port` varchar  (11)     DEFAULT '587', 
      `config_from` text   , 
      `config_replyname` text   , 
      `config_replyto` text   , 
      `column_63` int   , 
      `cnae` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_user_group( 
      `id` int   NOT NULL  , 
      `system_user_id` int   NOT NULL  , 
      `system_group_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_user_pdv_permissoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `empresa_id` int   NOT NULL  , 
      `pdv_permissoes_id` int   NOT NULL  , 
      `system_user_id` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_user_program( 
      `id` int   NOT NULL  , 
      `system_user_id` int   NOT NULL  , 
      `system_program_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_user_program_permissoes( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `system_users_id` int   NOT NULL  , 
      `system_program_permissoes_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_users( 
      `id` int   NOT NULL  , 
      `name` text   NOT NULL  , 
      `login` text   NOT NULL  , 
      `password` text   NOT NULL  , 
      `email` text   , 
      `frontpage_id` int   , 
      `system_unit_id` int   , 
      `active` char  (1)   , 
      `accepted_term_policy` char  (1)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE system_user_unit( 
      `id` int   NOT NULL  , 
      `system_user_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE tabela_preco( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `tabela_preco_tipo_alteracao_id` int   NOT NULL  , 
      `tabela_preco_tipo_id` int   , 
      `descricao` text   NOT NULL  , 
      `observacao` text   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `data_hora_promocao_inicial` datetime   , 
      `data_hora_promocao_final` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE tabela_preco_produto( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `tabela_preco_id` int   NOT NULL  , 
      `produto_filial_id` int   NOT NULL  , 
      `preco_venda` double   NOT NULL  , 
      `valor_parametro` double   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE tabela_preco_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE tabela_preco_tipo_alteracao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE tipo_documento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE tipo_recurso( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE titulos_tipo_anexo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE unidade_medida( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `sigla` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `criado_por` text   NOT NULL  , 
      `alterado_por` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE veiculo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `modelo_marca` text   NOT NULL  , 
      `placa` text   NOT NULL  , 
      `ano` int   , 
      `tara` double   , 
      `capacidade_kg` double   , 
      `renavam` text   , 
      `capacidade_m3` double   , 
      `mdfe_tpRod_id` int   NOT NULL  , 
      `estado_id` int   NOT NULL  , 
      `veiculo_tipo_id` int   NOT NULL  , 
      `mdfe_tpcar_id` int   NOT NULL  , 
      `funcionario_motorista_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE veiculo_tipo( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `venda_situacao_id` int   NOT NULL  , 
      `orcamento_id` int   , 
      `vendedor_id` int   , 
      `dispositivos_id` int   , 
      `cliente_id` int   , 
      `numero_celula_consumo` text   , 
      `system_unit_id` int   NOT NULL  , 
      `filial_saida_id` int   NOT NULL  , 
      `venda_modalidade_id` int   NOT NULL  , 
      `venda_tipo_pagamento_id` int   NOT NULL  , 
      `id_venda_local` int   , 
      `data_hora_venda` datetime   NOT NULL  , 
      `valor_produtos` double   NOT NULL  , 
      `valor_troco` double   , 
      `desconto` double   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `observacao` text   , 
      `observacao_nf` text   , 
      `peso_total` double   , 
      `frete_total` double   , 
      `valor_total` double   NOT NULL  , 
      `cliente_endereco_id` int   , 
      `info_faturamento` text   , 
      `data_prev_entrega` date   , 
      `criado_por` text   , 
      `alterado_por` text   , 
      `valor_comissao` double   , 
      `comissao_avista` double   , 
      `comissao_aprazo` int   , 
      `valor_avista` double   , 
      `valor_aprazo` double   , 
      `tabela_preco_id` int   , 
      `movimentacao_origem_id` int   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_devolucao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `venda_id` int   NOT NULL  , 
      `data_devolucao` date   NOT NULL  , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_devolucao_itens( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `venda_devolucao_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade` double   NOT NULL  , 
      `valor_unitario` double   , 
      `valor_total` double   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_devolucao_troca( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `venda_devolucao_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `quantidade` double   NOT NULL  , 
      `valor_unitario` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_formapgto( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `forma_pagamento_id` int   NOT NULL  , 
      `venda_id` int   NOT NULL  , 
      `quantidade_parcelas` int   , 
      `valor` double   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_item( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `venda_id` int   NOT NULL  , 
      `produto_id` int   NOT NULL  , 
      `quantidade` double   NOT NULL  , 
      `valor_unitario` double   NOT NULL  , 
      `valor_total` double   NOT NULL  , 
      `valor_original` double   NOT NULL  , 
      `valor_custo` double   , 
      `desconto` double   , 
      `informacoes_adicionais` text   , 
      `cancelado` int   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `numero_pedido` text   , 
      `numero_item_pedido` text   , 
      `valor_frete` double   , 
      `peso_unitario` double   , 
      `peso_total` double   , 
      `estoque_deposito_id` int   , 
      `produto_lote_id` int   , 
      `quantidade_devolvida` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_meta( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `venda_meta_situacao_id` int   NOT NULL  , 
      `system_unit_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `data_inicial` date   NOT NULL  , 
      `data_final` date   NOT NULL  , 
      `valor_meta_geral_prevista` double   NOT NULL  , 
      `valor_meta_geral_realizada` double   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `data_ultimo_processamento` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_meta_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_meta_vendedor( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `venda_meta_id` int   NOT NULL  , 
      `vendedor_id` int   NOT NULL  , 
      `valor_meta_prevista` double   , 
      `valor_meta_realizada` double   , 
      `criado_em` datetime   NOT NULL  , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_em` datetime   , 
      `aproveiramento_carteira_prevista` double   , 
      `aproveitamento_carteira_realizada` double   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_modalidade( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_situacao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `situacaopdv_id` int   , 
      `ordem` int   , 
      `cor` text   , 
      `criado_por` text   NOT NULL  , 
      `alterado_por` text   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_situacao_historico( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `venda_situacao_id` int   NOT NULL  , 
      `venda_id` int   NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   NOT NULL  , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE venda_tipo_pagamento( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE vendedor( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `nome` text   NOT NULL  , 
      `cpf` text   , 
      `vendedor_tipo_comissao_id` int   , 
      `vendedor_tipo_pgto_comissao_id` int   , 
      `criado_em` datetime   , 
      `alterado_em` datetime   , 
      `percentual_comissao` double   , 
      `criado_por` text   , 
      `alterado_por` text   , 
      `deletado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE vendedor_tipo_comissao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE vendedor_tipo_pgto_comissao( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `descricao` text   NOT NULL  , 
      `criado_em` datetime   , 
      `deletado_em` datetime   , 
      `alterado_por` text   , 
      `criado_por` text   , 
      `alterado_em` datetime   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

CREATE TABLE xml_contador( 
      `id`  INT  AUTO_INCREMENT    NOT NULL  , 
      `data_inicio` date   , 
      `data_fim` date   , 
      `system_user_id` int   , 
      `system_unit_id` int   , 
      `data_solicitacao` datetime   , 
      `caminho_download` varchar  (255)   , 
      `updated_at` datetime   , 
      `created_at` datetime   , 
      `info_registros` varchar  (255)   , 
      `data_click` datetime   , 
      `status_id` int     DEFAULT 0, 
      `situacao` int     DEFAULT 1, 
      `caminho_pdf` varchar  (255)   , 
      `contador` int     DEFAULT 0, 
      `contador_email` int     DEFAULT 0, 
      `downloads` int     DEFAULT 0, 
      `rota` text   , 
      `chave` varchar  (20)   , 
 PRIMARY KEY (id)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci; 

 
 ALTER TABLE dispositivos ADD UNIQUE (token);
  
 ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_1 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_2 FOREIGN KEY (integradores_servicos_id) references integradores_servicos(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_2 FOREIGN KEY (caixa_situacao_id) references caixa_situacao(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_3 FOREIGN KEY (system_users_abertura_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_4 FOREIGN KEY (system_users_operador_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_5 FOREIGN KEY (system_users_fechamento_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_1 FOREIGN KEY (caixa_id) references caixa(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_3 FOREIGN KEY (caixa_tipo_lancamento_id) references caixa_tipo_lancamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_4 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_1 FOREIGN KEY (centro_custo_tipo_id) references centro_custo_tipo(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_agendamentos ADD CONSTRAINT fk_certificado_agendamentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_agente_registro ADD CONSTRAINT fk_certificado_agente_registro_1 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_2 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_4 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_5 FOREIGN KEY (certificado_cliente_situacao_id) references certificado_cliente_situacao(id); 
ALTER TABLE certificado_email_historico ADD CONSTRAINT fk_certificado_email_historico_1 FOREIGN KEY (certificado_cliente_id) references certificado_cliente(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_1 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_4 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_agente_registro_id) references certificado_agente_registro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_5 FOREIGN KEY (certificado_venda_situacao_id) references certificado_venda_situacao(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_7 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_8 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_9 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_12 FOREIGN KEY (certificado_tipo_atendimento_id) references certificado_tipo_atendimento(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_13 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificado_venda_documentos ADD CONSTRAINT fk_certificado_venda_documentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_1 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_2 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_2 FOREIGN KEY (pais_id) references pais(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_3 FOREIGN KEY (residencia_propria) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_4 FOREIGN KEY (utilizar_endereco_cobranca) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_5 FOREIGN KEY (cliente_situacao_id) references cliente_situacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_7 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_8 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_9 FOREIGN KEY (cliente_classificacao_subgrupo_id) references cliente_classificacao_subgrupo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE cliente_classificacao ADD CONSTRAINT fk_cliente_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE cliente_classificacao_subgrupo ADD CONSTRAINT fk_cliente_classificacao_subgrupo_1 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente_contato ADD CONSTRAINT fk_cliente_contato_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_2 FOREIGN KEY (principal) references resposta(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE cliente_historico_limite ADD CONSTRAINT fk_cliente_historico_limite_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_1 FOREIGN KEY (forma_pagamento_id_dinheiro_caixa) references forma_pagamento(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_2 FOREIGN KEY (forma_pagamento_id_titulos_cpag_nf) references forma_pagamento(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_1 FOREIGN KEY (configuracoes_id) references configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_2 FOREIGN KEY (produto_etiqueta_configuracoes_id) references produto_etiqueta_configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_4 FOREIGN KEY (plano_conta_crec_id) references plano_conta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_5 FOREIGN KEY (centro_custo_crec_id) references centro_custo(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_6 FOREIGN KEY (cpag_usa_plano_contas_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_9 FOREIGN KEY (notafiscal_cprod_padrao_orcamento_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_7 FOREIGN KEY (informar_duplicidade_de_item_venda_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_8 FOREIGN KEY (venda_apenas_com_estoque_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_10 FOREIGN KEY (notafiscal_cprod_padrao_venda_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_1 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_2 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_3 FOREIGN KEY (contabil_lancamentos_tipo_id) references contabil_lancamentos_tipo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_4 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_5 FOREIGN KEY (contaspag_contabil_id) references contaspag_contabil(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_6 FOREIGN KEY (conta_corrente_lancamentos_id) references conta_corrente_lancamentos(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_7 FOREIGN KEY (contabil_lancamentos_situacao_id) references contabil_lancamentos_situacao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_8 FOREIGN KEY (contabil_lancamentos_origem_id) references contabil_lancamentos_origem(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_1 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_1 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_2 FOREIGN KEY (conta_corrente_lanc_tipo_id) references conta_corrente_lanc_tipo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (contaspag_baixas_id) references contaspag_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (contasrec_baixas_id) references contasrec_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_7 FOREIGN KEY (conta_corrente_lanc_origem_id) references conta_corrente_lanc_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_1 FOREIGN KEY (contaspag_situacao_id) references contaspag_situacao(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_3 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_4 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_5 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_7 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_3 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_bloco_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_historico_venc ADD CONSTRAINT fk_contaspag_historico_venc_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_1 FOREIGN KEY (contasrec_situacao_id) references contasrec_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_4 FOREIGN KEY (contasrec_origem_id) references contasrec_origem(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_6 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_7 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_8 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_9 FOREIGN KEY (conta_corrente_boleto_id) references conta_corrente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_10 FOREIGN KEY (boleto_situacao_id) references boleto_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_11 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_12 FOREIGN KEY (contasrec_bloco_id) references contasrec_bloco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_13 FOREIGN KEY (venda_formapgto_id) references venda_formapgto(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_14 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_4 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_5 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec_historico_cobranca ADD CONSTRAINT fk_contasrec_historico_cobranca_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_historico_venc ADD CONSTRAINT fk_contasrec_historico_venc_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE cst_icms ADD CONSTRAINT fk_cst_icms_1 FOREIGN KEY (regime_tributario_id) references notafiscal_crt(id); 
ALTER TABLE despesas_servicos ADD CONSTRAINT fk_despesas_servicos_1 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE dispositivos ADD CONSTRAINT fk_dispositivos_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_deposito ADD CONSTRAINT fk_estoque_deposito_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_estante ADD CONSTRAINT fk_estoque_estante_1 FOREIGN KEY (estoque_rua_id) references estoque_rua(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_1 FOREIGN KEY (estoque_origem_id) references estoque_origem(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_2 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_4 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_5 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_6 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_9 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE estoque_origem ADD CONSTRAINT fk_estoque_origem_1 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_prateleira ADD CONSTRAINT fk_estoque_prateleira_1 FOREIGN KEY (estoque_estante_id) references estoque_estante(id); 
ALTER TABLE estoque_rua ADD CONSTRAINT fk_estoque_rua_1 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_3 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_1 FOREIGN KEY (email_template_id) references email_template(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_2 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_1 FOREIGN KEY (eventos_id) references eventos(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_1 FOREIGN KEY (tipo_documento_id) references tipo_documento(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_3 FOREIGN KEY (meio_pagamento_tef_id) references meio_pagamento_tef(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_4 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_1 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_4 FOREIGN KEY (fornecedor_classificacao_id) references fornecedor_classificacao(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE fornecedor_classificacao ADD CONSTRAINT fk_fornecedor_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE fornecedor_contato ADD CONSTRAINT fk_fornecedor_contato_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE funcionario ADD CONSTRAINT fk_funcionario_1 FOREIGN KEY (funcionario_cargo_id) references funcionario_cargo(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_1 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_2 FOREIGN KEY (ultima_etapa) references resposta(id); 
ALTER TABLE integradores_servicos ADD CONSTRAINT fk_integradores_servicos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_1 FOREIGN KEY (mdfe_tpemit_id) references mdfe_tpemit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_2 FOREIGN KEY (mdfe_tpprop_id) references mdfe_tpprop(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_4 FOREIGN KEY (mdfe_tptransp_id) references mdfe_tptransp(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_6 FOREIGN KEY (UFIni) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_7 FOREIGN KEY (UFFim) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_8 FOREIGN KEY (indCanalVerde) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_9 FOREIGN KEY (indCarregaPosterior) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_10 FOREIGN KEY (mdfe_respSeg_id) references mdfe_respSeg(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_11 FOREIGN KEY (mdfe_cunid_id) references mdfe_cunid(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_12 FOREIGN KEY (mdfe_tpcarga_id) references mdfe_tpcarga(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_13 FOREIGN KEY (mdfe_indpag_id) references mdfe_indpag(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_14 FOREIGN KEY (indAntecipaAdiant) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_15 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veic_estado_id) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_16 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_18 FOREIGN KEY (mdfe_situacao_id) references mdfe_situacao(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_19 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_20 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_21 FOREIGN KEY (cidade_encerramento_id) references cidade(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_2 FOREIGN KEY (mdfe_tpcomp_id) references mdfe_tpcomp(id); 
ALTER TABLE mdfe_condutor ADD CONSTRAINT fk_mdfe_condutor_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_evento ADD CONSTRAINT fk_mdfe_evento_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_2 FOREIGN KEY (cidade_carrega_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_3 FOREIGN KEY (cidade_descarga_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_4 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_2 FOREIGN KEY (UFPer) references estado(id); 
ALTER TABLE mdfe_lacres ADD CONSTRAINT fk_mdfe_lacres_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_2 FOREIGN KEY (mdfe_tpAntecip_id) references mdfe_tpAntecip(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_2 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe_xmlaut ADD CONSTRAINT fk_mdfe_xmlaut_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_1 FOREIGN KEY (natureza_operacao_finalidade_id) references natureza_operacao_finalidade(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_2 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_3 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_4 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_5 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_6 FOREIGN KEY (consumidor_final_id) references resposta(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_10 FOREIGN KEY (cst_icms_nao_contribuinte_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_2 FOREIGN KEY (natop_excecao_tributo_id) references natop_excecao_tributo(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_1 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_3 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_4 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_5 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_6 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao_ncm ADD CONSTRAINT fk_natureza_operacao_ncm_1 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_1 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_1 FOREIGN KEY (negocio_origem_id) references negocio_origem(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_3 FOREIGN KEY (negocio_motivo_perda_id) references negocio_motivo_perda(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_4 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_5 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_6 FOREIGN KEY (arquivado) references resposta(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_7 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_9 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_8 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_10 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE negocio_arquivos ADD CONSTRAINT fk_negocio_arquivos_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_2 FOREIGN KEY (negocio_tipo_atividade_id) references negocio_tipo_atividade(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_2 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio_notas ADD CONSTRAINT fk_negocio_notas_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_17 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_18 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_3 FOREIGN KEY (nf_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_4 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_6 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_7 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_8 FOREIGN KEY (notafiscal_tpemis_id) references notafiscal_tpemis(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_16 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_21 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE notafiscal_autxml ADD CONSTRAINT fk_notafiscal_autxml_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_3 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_4 FOREIGN KEY (nota_fiscal_compra_situacao_id) references nota_fiscal_compra_situacao(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_7 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_8 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_13 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_14 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_3 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_4 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_9 FOREIGN KEY (nota_fiscal_compra_itens_situacao_id) references nota_fiscal_compra_itens_situacao(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_8 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_dup ADD CONSTRAINT fk_notafiscal_dup_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_frete_volumes ADD CONSTRAINT fk_notafiscal_frete_volumes_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_1 FOREIGN KEY (notafiscal_refecfmod_id) references notafiscal_refecfmod(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_refnfe ADD CONSTRAINT fk_notafiscal_refnfe_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_4 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_1 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_2 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal_situacao_sefaz ADD CONSTRAINT fk_notafiscal_situacao_sefaz_1 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_1 FOREIGN KEY (notafiscal_series_id) references notafiscal_series(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_2 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_3 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_4 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_6 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE orcamento_interacoes ADD CONSTRAINT fk_orcamento_interacoes_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_1 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_2 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_2 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_5 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_2 FOREIGN KEY (ordem_producao_etapas_situacao_id) references ordem_producao_etapas_situacao(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_3 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_2 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_8 FOREIGN KEY (usuario_aprovacao_id) references system_users(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_9 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_3 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_4 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_5 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE ordem_servico_garantia_historico ADD CONSTRAINT fk_ordem_servico_garantia_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_2 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_3 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_4 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_2 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_1 FOREIGN KEY (painel_indicadores_id) references painel_indicadores(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_2 FOREIGN KEY (indicador_personalizado_id) references indicador_personalizado(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_3 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_2 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_3 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_4 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_5 FOREIGN KEY (chave_pix_tipo_id) references chave_pix_tipo(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_1 FOREIGN KEY (plano_conta_tipo_id) references plano_conta_tipo(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_2 FOREIGN KEY (plano_conta_origem_id) references plano_conta_origem(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_2 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_3 FOREIGN KEY (unidade_medida_id) references unidade_medida(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_fabricante_id) references produto_fabricante(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_9 FOREIGN KEY (produtogrupo_subgrupo_id) references produtogrupo_subgrupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_6 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (habilitado_id) references resposta(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_tipo_id) references produto_tipo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_11 FOREIGN KEY (produto_embalagem_id) references produto_embalagem(id); 
ALTER TABLE produto_embalagem ADD CONSTRAINT fk_produto_embalagem_1 FOREIGN KEY (produto_tipo_embalagem_id) references produto_tipo_embalagem(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (estoque_prateleira_id) references estoque_prateleira(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE produto_ficha_tecnica_etapas_producao ADD CONSTRAINT fk_produto_ficha_tecnica_etapas_producao_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_3 FOREIGN KEY (estoque_deposito_padrao_id) references estoque_deposito(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_4 FOREIGN KEY (sob_encomenda_id) references resposta(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_5 FOREIGN KEY (gerar_op_venda_id) references resposta(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_preco_historico_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_filial_historico_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE produto_grupo ADD CONSTRAINT fk_produto_grupo_1 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produtogrupo_subgrupo ADD CONSTRAINT fk_produtogrupo_subgrupo_1 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto_lote ADD CONSTRAINT fk_produto_lote_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_2 FOREIGN KEY (category_id) references system_document_category(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_1 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_program_permissoes ADD CONSTRAINT fk_system_program_permissoes_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_2 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_4 FOREIGN KEY (nfe_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_5 FOREIGN KEY (nfe_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_13 FOREIGN KEY (nfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_6 FOREIGN KEY (vendas_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_7 FOREIGN KEY (nfce_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_9 FOREIGN KEY (nfe_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_10 FOREIGN KEY (nfe_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_11 FOREIGN KEY (nfce_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_12 FOREIGN KEY (nfce_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_14 FOREIGN KEY (notafiscal_cprod_padrao_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (nfce_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_3 FOREIGN KEY (nfce_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_1 FOREIGN KEY (nfce_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_16 FOREIGN KEY (mdfe_estadoini_id) references estado(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_18 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_19 FOREIGN KEY (mdfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_20 FOREIGN KEY (mdfe_homologacao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (mdfe_producao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (natureza_operacao_compra_id) references natureza_operacao(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_pdv_permissoes ADD CONSTRAINT fk_system_user_permissoes_pdv_2 FOREIGN KEY (pdv_permissoes_id) references pdv_permissoes(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_2 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_2 FOREIGN KEY (frontpage_id) references system_program(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_1 FOREIGN KEY (tabela_preco_tipo_alteracao_id) references tabela_preco_tipo_alteracao(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_2 FOREIGN KEY (tabela_preco_tipo_id) references tabela_preco_tipo(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_1 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_3 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_4 FOREIGN KEY (veiculo_tipo_id) references veiculo_tipo(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (funcionario_motorista_id) references funcionario(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_2 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_3 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_5 FOREIGN KEY (filial_saida_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_6 FOREIGN KEY (venda_modalidade_id) references venda_modalidade(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_7 FOREIGN KEY (venda_tipo_pagamento_id) references venda_tipo_pagamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_8 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_9 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_10 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_12 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_3 FOREIGN KEY (cancelado) references resposta(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_5 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_1 FOREIGN KEY (venda_meta_situacao_id) references venda_meta_situacao(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_1 FOREIGN KEY (venda_meta_id) references venda_meta(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_1 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_1 FOREIGN KEY (vendedor_tipo_comissao_id) references vendedor_tipo_comissao(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_2 FOREIGN KEY (vendedor_tipo_pgto_comissao_id) references vendedor_tipo_pgto_comissao(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_2 FOREIGN KEY (system_user_id) references system_users(id); 

 CREATE VIEW view_consulta_contabil_por_data AS select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento data_vencimento,
	   p.data_pagamento data_pagamento,
	   p.criado_em data_lancamento
from contaspag p,
	 contaspag_contabil cc,
	 contabil_lancamentos cl
where p.id = cc.contaspag_id 
and   cl.contaspag_contabil_id = cc.id
and   p.deletado_em is null
and   cc.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento  data_vencimento,
	   p.data_pagamento  data_pagamento,
	   p.criado_em  data_lancamento
from contasrec p,
	 contabil_lancamentos cl
where cl.contasrec_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_lancamento  data_vencimento,
	   p.data_lancamento  data_pagamento,
	   p.data_lancamento  data_lancamento
from conta_corrente_lancamentos p,
	 contabil_lancamentos cl
where cl.conta_corrente_lancamentos_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
; 

CREATE VIEW view_negocio_timeline AS SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'nota' as "tipo"
FROM negocio_notas

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'arquivo' as "tipo"
FROM negocio_arquivos

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'atividade' as "tipo"
FROM negocio_atividade

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'produto' as "tipo"
FROM negocio_itens

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'etapa' as "tipo"
FROM negocio_etapas_historico
; 

CREATE VIEW vw_caixa_resumo AS select c.caixa_id AS caixa_id,
		'Fundo de Caixa' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 3) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Entradas' AS tipo,
        coalesce(sum(c.valor), 0) AS valor 
        from caixa_lancamentos c where (c.caixa_tipo_lancamento_id = 2) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saidas' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 1) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saldo' AS tipo,sum((case when (c.caixa_tipo_lancamento_id = 1) then (c.valor * -(1)) else c.valor end)) AS valor 
        from caixa_lancamentos c 
        group by c.caixa_id
        ; 

CREATE VIEW vw_caixa_resumo_formas AS Select 
    c.caixa_id caixa_id,
    c.forma_pagamento_id forma_pagamento_id,
    f.descricao nome_forma_pagamento,
    sum(case when c.caixa_tipo_lancamento_id = 1 then c.valor * -1 else c.valor end) total
from caixa_lancamentos c,
     forma_pagamento f
where f.id = c.forma_pagamento_id
group by c.caixa_id, c.forma_pagamento_id; 

CREATE VIEW vw_funil_filial AS SELECT DISTINCT
f.id AS id,
f.descricao AS descricao,
n.system_unit_id AS system_unit_id
FROM funil f
INNER JOIN funil_etapas fe ON fe.funil_id = f.id
INNER JOIN negocio n ON n.funil_etapas_id = fe.id; 

CREATE VIEW vw_lotes_produto AS select l.id as id,
       l.produto_id as produto_id,
       l.numero as numero,
       l.validade as validade,
       sum(e.quant_disponivel) as Quantidade,
       sum(e.quant_reservada) as Reservado
       from produto_lote l
left join estoque_saldos e on e.produto_lote_id = l.id
; 

CREATE VIEW vw_produto_estoque AS SELECT     p.id as id,
           p.nome as nome,
           p.referencia as referencia,
           p.codigo_sku as SKU,
           p.obs as obs,
           f.margem as margem,
           f.valor_custo as valor_custo,
           f.preco_venda as preco_venda,
           p.peso_liquido as peso_liquido,
           p.peso_bruto as preso_bruto,
           g.descricao as grupo,
           sg.descricao as subgrupo,
           u.sigla as sigla,
           p.imagem as imagem,
           p.codigo_ean as ean,
           p.ncm as ncm,
           f.system_unit_id as system_unit_id,
           f.id as produto_filial_id,
           f.estoque_minimo as estoque_minimo,
           f.estoque_maximo as estoque_maximo,           
           (e.quant_disponivel) as Quantidade_Disponivel,
           (e.quant_reservada) as Quantidade_Reservada,
           d.descricao as deposito
           
           FROM produto p 
           INNER JOIN unidade_medida u ON p.unidade_medida_id = u.id 
           INNER JOIN produto_grupo g ON p.produto_grupo_id = g.id
           LEFT JOIN produtogrupo_subgrupo sg ON g.id = sg.produto_grupo_id
           LEFT JOIN produto_filial f ON f.produto_id = p.id 
           LEFT JOIN estoque_saldos e ON e.produto_id = p.id
           LEFT JOIN estoque_deposito d ON e.estoque_deposito_id = d.id
           group by 1,2           
           
           ; 
 
