CREATE TABLE api_documentos( 
      id number(10)    NOT NULL , 
      integradores_id number(10)    NOT NULL , 
      system_unit_id number(10)   , 
      descricao varchar(3000)    NOT NULL , 
      token_api varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE apidocumentos_integradoresservicos( 
      id number(10)    NOT NULL , 
      api_documentos_id number(10)    NOT NULL , 
      integradores_servicos_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE api_error( 
      id number(10)    NOT NULL , 
      classe varchar(3000)   , 
      metodo varchar(3000)   , 
      url varchar(3000)   , 
      dados varchar(3000)   , 
      error_message varchar(3000)   , 
      inserted_at timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ativo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE banco( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      numero varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE boleto_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa( 
      id number(10)    NOT NULL , 
      caixa_situacao_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      system_users_abertura_id number(10)    NOT NULL , 
      system_users_operador_id number(10)    NOT NULL , 
      system_users_fechamento_id number(10)   , 
      data_hora_abertura timestamp(0)   , 
      data_hora_fechamento timestamp(0)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_lancamentos( 
      id number(10)    NOT NULL , 
      caixa_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      caixa_tipo_lancamento_id number(10)    NOT NULL , 
      valor binary_double    NOT NULL , 
      data_hora_lancamento timestamp(0)    NOT NULL , 
      system_users_id number(10)    NOT NULL , 
      observacao varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      id_origem number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_tipo_lancamento( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      centro_custo_tipo_id number(10)    NOT NULL , 
      centro_custo_pai_id number(10)   , 
      numero varchar(3000)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cep_cache( 
      id number(10)    NOT NULL , 
      cep varchar(3000)   , 
      rua varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      cidade varchar(3000)   , 
      bairro varchar(3000)   , 
      codigo_ibge varchar(3000)   , 
      uf char  (2)   , 
      cidade_id number(10)   , 
      estado_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agendamentos( 
      id number(10)    NOT NULL , 
      certificado_venda_id number(10)    NOT NULL , 
      titulo varchar(3000)    NOT NULL , 
      data_hora_inicial timestamp(0)    NOT NULL , 
      data_hora_final timestamp(0)    NOT NULL , 
      observacao varchar(3000)   , 
      cor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agente_registro( 
      id number(10)    NOT NULL , 
      parceiro_id number(10)   , 
      nome varchar(3000)    NOT NULL , 
      cpf varchar(3000)   , 
      fone varchar(3000)   , 
      email varchar(3000)   , 
      percentual_comissao binary_double   , 
      deletado_em timestamp(0)   , 
      criado_em timestamp(0)    NOT NULL , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente( 
      id number(10)    NOT NULL , 
      cliente_id number(10)    NOT NULL , 
      parceiro_id number(10)   , 
      produto_id number(10)    NOT NULL , 
      certificado_cliente_situacao_id number(10)    NOT NULL , 
      data_vencimento_certificado date   , 
      certificado_venda_id number(10)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_email_historico( 
      id number(10)    NOT NULL , 
      certificado_cliente_id number(10)    NOT NULL , 
      email varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      texto_emissao varchar(3000)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora_produtos( 
      id number(10)    NOT NULL , 
      certificadora_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      qtde_dias_vencimento number(10)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      valor_custo binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_atendimento( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_repasse( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      cliente_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      parceiro_id number(10)   , 
      certificado_agente_registro_id number(10)    NOT NULL , 
      certificado_venda_situacao_id number(10)    NOT NULL , 
      certificado_venda_modalidade_id number(10)   , 
      certificado_venda_tipomodalidade_id number(10)   , 
      certificado_tipo_repasse_id number(10)   , 
      vendedor_id number(10)   , 
      tabela_preco_id number(10)   , 
      certificadora_id number(10)   , 
      valor_custo binary_double   , 
      data_hora_agendamento timestamp(0)   , 
      data_vencimento_certificado date   , 
      valor_externo binary_double   , 
      custo_externo binary_double   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      agente_comissao_percentual binary_double   , 
      agente_comissao_valor binary_double   , 
      vendedor_comissao_percentual binary_double   , 
      vendedor_comissao_valor binary_double   , 
      atendimento_externo char(1)   , 
      parceiro_comissao_percentual binary_double   , 
      parceiro_valor_repasse binary_double   , 
      valor_total binary_double    NOT NULL , 
      comissao_total binary_double   , 
      lucro_total binary_double   , 
      valor_cliente binary_double   , 
      valor_produto binary_double    NOT NULL , 
      protocolo_emissao varchar(3000)   , 
      data_emissao date   , 
      data_pagamento date   , 
      certificado_tipo_atendimento_id number(10)   , 
      observacao varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_documentos( 
      id number(10)    NOT NULL , 
      certificado_venda_id number(10)    NOT NULL , 
      descricao_arquivo varchar(3000)    NOT NULL , 
      arquivo varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_formapgto( 
      id number(10)    NOT NULL , 
      certificado_venda_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_modalidade( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      certificado_tipo_repasse_id number(10)    NOT NULL , 
      certificado_venda_tipomodalidade_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      ordem number(10)   , 
      cor varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_tipomodalidade( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cfop( 
      id number(10)    NOT NULL , 
      numero char  (4)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      aplicacao varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE chave_pix_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cidade( 
      id number(10)    NOT NULL , 
      estado_id number(10)    NOT NULL , 
      pais_id number(10)   , 
      nome varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      codigo_ibge varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente( 
      id number(10)    NOT NULL , 
      pessoa_tipo_id number(10)    NOT NULL , 
      cliente_classificacao_id number(10)    NOT NULL , 
      cliente_classificacao_subgrupo_id number(10)   , 
      vendedor_id number(10)   , 
      notafiscal_indiedest_id number(10)    NOT NULL , 
      notafiscal_crt_id number(10)   , 
      nome varchar(3000)    NOT NULL , 
      cpf_cnpj varchar(3000)   , 
      rg varchar(3000)   , 
      email varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      insc_estadual varchar(3000)   , 
      insc_municipal varchar(3000)   , 
      razao_social varchar(3000)   , 
      fone varchar(3000)   , 
      observacoes varchar(3000)   , 
      data_nascimento date   , 
      conjuge varchar(3000)   , 
      conjuge_cpf varchar(3000)   , 
      nome_pai varchar(3000)   , 
      nome_mae varchar(3000)   , 
      local_trabalho varchar(3000)   , 
      renda binary_double   , 
      tempo_trabalho varchar(3000)   , 
      residencia_propria number(10)   , 
      utilizar_endereco_cobranca number(10)    NOT NULL , 
      cobranca_cnpj varchar(3000)   , 
      cobranca_nome varchar(3000)   , 
      cobranca_cep varchar(3000)   , 
      cobranca_endereco varchar(3000)   , 
      cobranca_bairro varchar(3000)   , 
      cobranca_uf varchar(3000)   , 
      cobranca_cidade varchar(3000)   , 
      cobranca_fones varchar(3000)   , 
      cliente_situacao_id number(10)    NOT NULL , 
      limite_credito binary_double   , 
      limite_utilizado binary_double   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_por varchar(3000)   , 
      system_unit_id number(10)   , 
      deletado_em timestamp(0)   , 
      vendas_quantidade number(10)   , 
      vendas_valortotal binary_double   , 
      vendas_dataultima timestamp(0)   , 
      vendas_valormaior binary_double   , 
      vendas_datamaior timestamp(0)   , 
      observacoes_financeiro varchar(3000)   , 
      tabela_preco_id number(10)   , 
      percentual_comissao_vendedor binary_double   , 
      cliente_exterior char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_por varchar(3000)   , 
      ativo_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao_subgrupo( 
      id number(10)    NOT NULL , 
      cliente_classificacao_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_contato( 
      id number(10)    NOT NULL , 
      cliente_id number(10)   , 
      tipo_contato varchar(3000)   , 
      nome varchar(3000)    NOT NULL , 
      fone varchar(3000)   , 
      ativo_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_endereco( 
      id number(10)    NOT NULL , 
      logradouro varchar(3000)    NOT NULL , 
      cliente_id number(10)    NOT NULL , 
      principal number(10)    NOT NULL , 
      cidade_id number(10)    NOT NULL , 
      bairro varchar(3000)   , 
      cep varchar(3000)   , 
      numero varchar(3000)   , 
      complemento varchar(3000)   , 
      ativo_id number(10)    NOT NULL , 
      codigo_ibge varchar  (20)   , 
      ibge_estado number(10)  (2)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_historico_limite( 
      id number(10)    NOT NULL , 
      cliente_id number(10)    NOT NULL , 
      valor binary_double    NOT NULL , 
      data_hora timestamp(0)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_por varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE condicao_pagamento( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      numero_parcelas number(10)    NOT NULL , 
      dias_primeira_parcelas number(10)   , 
      dias_entre_parcelas number(10)   , 
      taxa binary_double   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes( 
      id number(10)    NOT NULL , 
      forma_pagamento_id_dinheiro_caixa number(10)   , 
      forma_pagamento_id_titulos_cpag_nf number(10)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes_filial( 
      id number(10)    NOT NULL , 
      configuracoes_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      produto_etiqueta_configuracoes_id number(10)   , 
      plano_conta_mascara varchar(3000)   , 
      centro_custo_mascara varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      plano_conta_crec_id number(10)   , 
      centro_custo_crec_id number(10)   , 
      cpag_usa_plano_contas_id number(10)   , 
      info_complementar_orcamento varchar(3000)   , 
      informar_duplicidade_de_item_venda_id number(10)   , 
      venda_apenas_com_estoque_id number(10)   , 
      notafiscal_cprod_padrao_orcamento_id number(10)   , 
      notafiscal_cprod_padrao_venda_id number(10)   , 
      produto_margem_padrao binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos( 
      id number(10)    NOT NULL , 
      plano_conta_id number(10)    NOT NULL , 
      centro_custo_id number(10)    NOT NULL , 
      contabil_lancamentos_tipo_id number(10)    NOT NULL , 
      contabil_lancamentos_situacao_id number(10)    NOT NULL , 
      contabil_lancamentos_origem_id number(10)    NOT NULL , 
      data_lancamento date    NOT NULL , 
      valor binary_double    NOT NULL , 
      contasrec_id number(10)   , 
      contaspag_contabil_id number(10)   , 
      conta_corrente_lancamentos_id number(10)   , 
      historico varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_origem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      banco_id number(10)   , 
      nome varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      agencia varchar(3000)   , 
      conta varchar(3000)   , 
      agencia_digito varchar(3000)   , 
      conta_digito varchar(3000)   , 
      end_logradouro varchar(3000)   , 
      end_bairro varchar(3000)   , 
      end_cidade varchar(3000)   , 
      end_estado varchar(3000)   , 
      end_cep varchar(3000)   , 
      end_numero varchar(3000)   , 
      boleto_convenio varchar(3000)   , 
      boleto_carteira varchar(3000)   , 
      boleto_gerar char(1)    NOT NULL , 
      boleto_codigo_cedente varchar(3000)   , 
      boleto_digito_cod_cedente varchar(3000)   , 
      boleto_instrucoes varchar(3000)   , 
      boleto_multa binary_double   , 
      boleto_juros_dia binary_double   , 
      boleto_digitos_nosso_numero number(10)   , 
      boleto_local_pagamento varchar(3000)   , 
      boleto_codigo_transmissao varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lancamentos( 
      id number(10)    NOT NULL , 
      conta_corrente_id number(10)    NOT NULL , 
      conta_corrente_lanc_tipo_id number(10)    NOT NULL , 
      conta_corrente_lanc_origem_id number(10)    NOT NULL , 
      contaspag_baixas_id number(10)   , 
      contasrec_baixas_id number(10)   , 
      data_lancamento date    NOT NULL , 
      valor binary_double    NOT NULL , 
      documento varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      historico varchar(3000)   , 
      plano_conta_id number(10)   , 
      centro_custo_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_origem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag( 
      id number(10)    NOT NULL , 
      contaspag_situacao_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      fornecedor_id number(10)    NOT NULL , 
      contaspag_origem_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      numero_documento varchar(3000)    NOT NULL , 
      parcela varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      data_emissao date    NOT NULL , 
      valor binary_double    NOT NULL , 
      data_vencimento date    NOT NULL , 
      data_venc_original date   , 
      observacao varchar(3000)   , 
      data_pagamento date   , 
      desconto binary_double   , 
      juros binary_double   , 
      valor_pago binary_double   , 
      valor_aberto binary_double   , 
      valor_multa binary_double   , 
      cheque_banco_id number(10)   , 
      cheque_agencia varchar(3000)   , 
      cheque_conta binary_double   , 
      cheque_emitente varchar(3000)   , 
      cheque_cpfcnpj varchar(3000)   , 
      data_competencia date   , 
      contaspag_bloco_id number(10)   , 
      nota_fiscal_compra_id number(10)   , 
      data_vencimento_calendario timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_anexos( 
      id number(10)    NOT NULL , 
      contaspag_id number(10)    NOT NULL , 
      titulos_tipo_anexo_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      arquivo varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_baixas( 
      id number(10)    NOT NULL , 
      contaspag_id number(10)    NOT NULL , 
      conta_corrente_id number(10)    NOT NULL , 
      data_pagamento date    NOT NULL , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      juros binary_double   , 
      desconto binary_double   , 
      saldo_aberto binary_double   , 
      saldo_apagar binary_double   , 
      multa binary_double   , 
      historico varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco( 
      id number(10)    NOT NULL , 
      fornecedor_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      contaspag_origem_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      quantidade_parcelas number(10)    NOT NULL , 
      primeiro_vencimento date   , 
      valor binary_double    NOT NULL , 
      numero_documento varchar(3000)   , 
      observacao varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco_contabil( 
      id number(10)    NOT NULL , 
      contaspag_bloco_id number(10)    NOT NULL , 
      plano_conta_id number(10)    NOT NULL , 
      centro_custo_id number(10)    NOT NULL , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_contabil( 
      id number(10)    NOT NULL , 
      contaspag_id number(10)    NOT NULL , 
      plano_conta_id number(10)    NOT NULL , 
      centro_custo_id number(10)    NOT NULL , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_historico_venc( 
      id number(10)    NOT NULL , 
      contaspag_id number(10)    NOT NULL , 
      vencimento_anterior date   , 
      vencimento_atual date    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_origem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      cliente_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      contasrec_situacao_id number(10)    NOT NULL , 
      plano_conta_id number(10)    NOT NULL , 
      centro_custo_id number(10)    NOT NULL , 
      contasrec_origem_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      numero_documento varchar(3000)   , 
      parcela varchar(3000)   , 
      valor binary_double    NOT NULL , 
      data_vencimento date    NOT NULL , 
      data_venc_original date   , 
      observacao varchar(3000)   , 
      data_pagamento date   , 
      desconto binary_double   , 
      juros binary_double   , 
      valor_pago binary_double   , 
      valor_aberto binary_double   , 
      valor_multa binary_double   , 
      cheque_banco_id number(10)   , 
      cheque_agencia varchar(3000)   , 
      cheque_conta varchar(3000)   , 
      cheque_emitente varchar(3000)   , 
      cheque_cpfcnpj varchar(3000)   , 
      data_competencia date   , 
      conta_corrente_boleto_id number(10)   , 
      boleto_situacao_id number(10)   , 
      boleto_nosso_numero varchar(3000)   , 
      vendedor_comissao binary_double   , 
      vendedor_id number(10)   , 
      contasrec_bloco_id number(10)   , 
      venda_formapgto_id number(10)   , 
      data_emissao date    NOT NULL , 
      ativo_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_anexos( 
      id number(10)    NOT NULL , 
      contasrec_id number(10)    NOT NULL , 
      titulos_tipo_anexo_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      arquivo varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_baixas( 
      id number(10)    NOT NULL , 
      contasrec_id number(10)    NOT NULL , 
      conta_corrente_id number(10)    NOT NULL , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      juros binary_double   , 
      desconto binary_double   , 
      saldo_aberto binary_double    NOT NULL , 
      saldo_apagar binary_double   , 
      multa binary_double   , 
      historico varchar(3000)   , 
      data_pagamento date    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_bloco( 
      id number(10)    NOT NULL , 
      cliente_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      plano_conta_id number(10)    NOT NULL , 
      centro_custo_id number(10)    NOT NULL , 
      quantidade_parcelas number(10)    NOT NULL , 
      primeiro_vencimento date   , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      numero_documento varchar(3000)   , 
      observacao varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_cobranca( 
      id number(10)    NOT NULL , 
      contasrec_id number(10)    NOT NULL , 
      historico varchar(3000)    NOT NULL , 
      data_cobranca date    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_venc( 
      id number(10)    NOT NULL , 
      contasrec_id number(10)    NOT NULL , 
      vencimento_anterior date   , 
      vencimento_atual date    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_origem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_cofins( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cst_numero varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_icms( 
      id number(10)    NOT NULL , 
      regime_tributario_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cst_numero varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_ipi( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cst_numero varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_pis( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cst_numero varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos( 
      id number(10)    NOT NULL , 
      despesas_servicos_tipo_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE dispositivos( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      token varchar  (100)    NOT NULL , 
      serial_dispositivo varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      deletado_em timestamp(0)   , 
      data_hora_ultima_sincronizacao timestamp(0)   , 
      ip_sincronizacao varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE email_template( 
      id number(10)    NOT NULL , 
      titulo varchar(3000)    NOT NULL , 
      mensagem varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estado( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      sigla char  (2)    NOT NULL , 
      codigo_ibge varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_deposito( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_estante( 
      id number(10)    NOT NULL , 
      estoque_rua_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_lancamentos( 
      id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      estoque_origem_id number(10)    NOT NULL , 
      estoque_tipo_movimentacao_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      estoque_deposito_id number(10)    NOT NULL , 
      produto_lote_id number(10)   , 
      venda_id number(10)   , 
      nota_fiscal_compra_id number(10)   , 
      ordem_producao_id number(10)   , 
      quantidade binary_double    NOT NULL , 
      observacao varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      preco_venda binary_double   , 
      preco_custo binary_double   , 
      data_lancamento date    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_origem( 
      id number(10)    NOT NULL , 
      estoque_tipo_movimentacao_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_prateleira( 
      id number(10)    NOT NULL , 
      estoque_estante_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_rua( 
      id number(10)    NOT NULL , 
      estoque_deposito_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_saldos( 
      id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      estoque_deposito_id number(10)    NOT NULL , 
      produto_lote_id number(10)   , 
      quant_disponivel binary_double    NOT NULL , 
      quant_reservada binary_double   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      preco_medio_venda binary_double   , 
      preco_medio_custo binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_tipo_movimentacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos( 
      id number(10)    NOT NULL , 
      system_program_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      email_template_id number(10)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_documentos( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)   , 
      system_users_id number(10)   , 
      system_unit_id number(10)   , 
      cstat number(10)   , 
      xmotivo varchar  (255)   , 
      xevento varchar  (255)   , 
      tpevento varchar  (255)   , 
      nseqevento number(10)   , 
      dhregevento timestamp(0)   , 
      nprot varchar  (255)   , 
      origem_event varchar  (255)   , 
      mensagem_manual varchar(3000)   , 
      tpamb number(10)   , 
      veraplic varchar  (255)   , 
      chnfe varchar  (255)   , 
      dhrecbto timestamp(0)   , 
      digval varchar  (255)   , 
      xml varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_systemuser( 
      id number(10)    NOT NULL , 
      eventos_id number(10)    NOT NULL , 
      system_users_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      enviar_email number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE forma_pagamento( 
      id number(10)    NOT NULL , 
      codigo_interno number(10)  (11)    NOT NULL , 
      tipo_documento_id number(10)    NOT NULL , 
      meio_pagamento_tef_id number(10)   , 
      notafiscal_tpag_id number(10)   , 
      descricao varchar(3000)    NOT NULL , 
      prazo_pagamento number(10)   , 
      taxa binary_double   , 
      deletado_em timestamp(0)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      criado_por varchar(3000)   , 
      alterado_por varchar(3000)   , 
      utiliza_pdv char  (1)   , 
      obriga_nf_pdv char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE formapgto_condpgto( 
      id number(10)    NOT NULL , 
      condicao_pagamento_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor( 
      id number(10)    NOT NULL , 
      pessoa_tipo_id number(10)    NOT NULL , 
      fornecedor_classificacao_id number(10)   , 
      nome varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      insc_estadual varchar(3000)   , 
      insc_municipal varchar(3000)   , 
      cpf_cnpj varchar(3000)   , 
      razao_social varchar(3000)   , 
      logradouro varchar(3000)   , 
      cidade_id number(10)   , 
      bairro varchar(3000)   , 
      cep varchar(3000)   , 
      numero varchar(3000)   , 
      complemento varchar(3000)   , 
      fone varchar(3000)   , 
      email varchar(3000)   , 
      site varchar(3000)   , 
      observacoes varchar(3000)   , 
      notafiscal_crt_id number(10)   , 
      deletado_em timestamp(0)   , 
      notafiscal_indiedest_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_classificacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      ativo_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_contato( 
      id number(10)    NOT NULL , 
      fornecedor_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      tipo_contato varchar(3000)   , 
      nome varchar(3000)    NOT NULL , 
      fone varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario( 
      id number(10)    NOT NULL , 
      funcionario_cargo_id number(10)   , 
      nome varchar(3000)    NOT NULL , 
      cpf varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      valor_salario binary_double   , 
      valor_hora binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario_cargo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil_etapas( 
      id number(10)    NOT NULL , 
      funil_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      numero_etapa number(10)    NOT NULL , 
      cor_etapa varchar(3000)   , 
      cor_negocio varchar(3000)   , 
      ultima_etapa number(10)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      permite_edicao char  (1)   , 
      permite_exclusao char  (1)   , 
      kanban char  (1)   , 
      etapa_ganha char  (1)   , 
      etapa_perde char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE indicador_personalizado( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      url_indicador varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores_servicos( 
      id number(10)    NOT NULL , 
      integradores_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE inutilizar_numero( 
      id number(10)    NOT NULL , 
      created_at timestamp(0)   , 
      system_user number(10)   , 
      update_at timestamp(0)   , 
      deleted_at timestamp(0)   , 
      ninicio varchar  (20)   , 
      nfinal varchar  (20)   , 
      serie varchar  (20)   , 
      system_unit_id number(10)   , 
      system_users_id number(10)   , 
      xml_retorno varchar(3000)   , 
      protocolo varchar  (50)   , 
      xmotivo varchar  (200)   , 
      cstat number(10)   , 
      notafiscal_id number(10)   , 
      xjust varchar  (150)   , 
      tipo number(10)  (1)    DEFAULT 1  NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      idmdfe varchar  (255)   , 
      chMDF varchar(3000)   , 
      nProt varchar(3000)   , 
      cStat varchar(3000)   , 
      mdfe_tpemit_id number(10)    NOT NULL , 
      mdfe_tpprop_id number(10)    NOT NULL , 
      mdfe_tptransp_id number(10)   , 
      mdfe_tpcar_id number(10)    NOT NULL , 
      nMDF varchar(3000)    NOT NULL , 
      serie varchar(3000)   , 
      dhEmi timestamp(0)   , 
      UFIni number(10)    NOT NULL , 
      UFFim number(10)    NOT NULL , 
      dhIniViagem timestamp(0)   , 
      indCanalVerde number(10)    NOT NULL , 
      indCarregaPosterior number(10)    NOT NULL , 
      infAdFisco varchar(3000)   , 
      infCpl varchar(3000)   , 
      mdfe_respSeg_id number(10)   , 
      seguro_cpfcnpj varchar(3000)   , 
      seguradora_xSeg varchar(3000)   , 
      seguradora_cnpj varchar(3000)   , 
      vCarga binary_double   , 
      mdfe_cunid_id number(10)    NOT NULL , 
      qCarga binary_double   , 
      mdfe_tpcarga_id number(10)   , 
      prod_xProd varchar(3000)   , 
      prod_cEAN varchar(3000)   , 
      prod_NCM varchar(3000)   , 
      pgto_cpfcnpj varchar(3000)   , 
      pgto_idEstrangeiro varchar(3000)   , 
      pgto_xNome varchar(3000)   , 
      pgto_vContrato binary_double   , 
      pgto_indAltoDesemp varchar(3000)   , 
      mdfe_indpag_id number(10)   , 
      pgto_vAdiant binary_double   , 
      indAntecipaAdiant number(10)   , 
      pgto_codBanco varchar(3000)   , 
      pgto_codAgencia varchar(3000)   , 
      pgto_CNPJIPEF varchar(3000)   , 
      pgto_PIX varchar(3000)   , 
      veic_rntrc varchar(3000)   , 
      mdfe_tpRod_id number(10)    NOT NULL , 
      veic_estado_id number(10)    NOT NULL , 
      veic_cint number(10)   , 
      veic_placa varchar(3000)   , 
      veic_renavam varchar(3000)   , 
      veic_tara binary_double   , 
      justificativa_cancelamento varchar(3000)   , 
      mensagem_sefaz varchar(3000)   , 
      status varchar(3000)   , 
      data_hora_envio timestamp(0)   , 
      protocolo_cancelamento varchar(3000)   , 
      datahora_cancelamento timestamp(0)   , 
      veiculo_id number(10)    NOT NULL , 
      mdfe_situacao_id number(10)    NOT NULL , 
      mdfe_tpamb_id number(10)    NOT NULL , 
      api_documentos_id number(10)   , 
      xml_cancelamento varchar(3000)   , 
      xml varchar(3000)   , 
      cidade_encerramento_id number(10)   , 
      cmunencerramento number(10)   , 
      data_encerramento date   , 
      datahora_encerramento timestamp(0)   , 
      protocolo_encerramento varchar(3000)   , 
      xml_encerramento varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_componentes( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      mdfe_tpcomp_id number(10)    NOT NULL , 
      vComp binary_double   , 
      xComp varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_condutor( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      xnome varchar(3000)    NOT NULL , 
      cpf varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_ctes( 
      id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      chCTe varchar(3000)   , 
      SegCodBarra varchar(3000)   , 
      indReentrega number(10)    NOT NULL , 
      mdfe_infmundescarga_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_cunid( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_evento( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      status varchar(3000)   , 
      codigo_status varchar(3000)   , 
      motivo_status varchar(3000)   , 
      id_evento varchar(3000)   , 
      numero_sequencial varchar(3000)   , 
      chave varchar(3000)   , 
      protocolo varchar(3000)   , 
      tipo_evento varchar(3000)   , 
      data_recebimento varchar(3000)   , 
      data_evento varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_inclusao_dfe( 
      id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      mdfe_id number(10)    NOT NULL , 
      notafiscal_id number(10)   , 
      cidade_carrega_id number(10)    NOT NULL , 
      cidade_descarga_id number(10)    NOT NULL , 
      chave varchar(3000)    NOT NULL , 
      protocolo varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_indpag( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmuncarrega( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      cidade_id number(10)    NOT NULL , 
      cMunCarrega varchar(3000)    NOT NULL , 
      xMunCarrega varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmundescarga( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      cidade_id number(10)    NOT NULL , 
      cMunDescarga varchar(3000)    NOT NULL , 
      xMunDescarga varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infpercurso( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      UFPer number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_lacres( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      nLacre varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_logs( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      system_users_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_mdfes( 
      id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      chMDFe varchar(3000)   , 
      indReentrega number(10)    NOT NULL , 
      mdfe_infmundescarga_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_nfes( 
      id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      chNFe varchar(3000)   , 
      SegCodBarra varchar(3000)   , 
      indReentrega number(10)    NOT NULL , 
      mdfe_infmundescarga_id number(10)    NOT NULL , 
      notafiscal_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_parcelas( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      nParcela varchar(3000)   , 
      dVenc date   , 
      vParcela binary_double   , 
      mdfe_tpAntecip_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_respSeg( 
      id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_series( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      mdfe_tpamb_id number(10)    NOT NULL , 
      serie varchar(3000)    NOT NULL , 
      sequencial number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      cor varchar(3000)   , 
      ordem number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpamb( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      valor varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpAntecip( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcar( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcarga( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcomp( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpemit( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpprop( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpRod( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tptransp( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_xmlaut( 
      id number(10)    NOT NULL , 
      mdfe_id number(10)    NOT NULL , 
      cpfcnpj varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE meio_pagamento_tef( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE movimentacao_origem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natop_excecao_tributo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao( 
      id number(10)    NOT NULL , 
      natureza_operacao_finalidade_id number(10)    NOT NULL , 
      cst_icms_id number(10)   , 
      cst_icms_nao_contribuinte_id number(10)   , 
      cst_ipi_id number(10)   , 
      cst_pis_id number(10)   , 
      cst_cofins_id number(10)   , 
      cfop char  (4)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      obs_padrao varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      icms_aliquota binary_double   , 
      ipi_aliquota binary_double   , 
      ipi_codigo_enquadramento varchar(3000)   , 
      pis_aliquota binary_double   , 
      pis_base binary_double   , 
      cofins_aliquota binary_double   , 
      consumidor_final_id number(10)   , 
      cofins_base binary_double   , 
      icms_pRedBC binary_double   , 
      icms_pICMS binary_double   , 
      icms_pDif binary_double   , 
      icms_vICMSDeson binary_double   , 
      icms_pMVAST binary_double   , 
      icms_pICMSST binary_double   , 
      icms_pFCP binary_double   , 
      icms_pFCPST binary_double   , 
      icms_pFCPSTRet binary_double   , 
      icms_pST binary_double   , 
      icms_pCredSN date   , 
      icms_pRedBCEfet binary_double   , 
      icms_pICMSEfet binary_double   , 
      notafiscal_item_modbc_id number(10)   , 
      notafiscal_item_modbcst_id number(10)   , 
      notafiscal_item_motDesICMS_id number(10)   , 
      icms_pFCPUFDest binary_double   , 
      icms_pICMSUFDest binary_double   , 
      icms_baseST binary_double   , 
      icms_base binary_double   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_estados( 
      id number(10)    NOT NULL , 
      natureza_operacao_excecao_id number(10)    NOT NULL , 
      estado_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_excecao( 
      id number(10)    NOT NULL , 
      natureza_operacao_id number(10)    NOT NULL , 
      natop_excecao_tributo_id number(10)    NOT NULL , 
      cst_pis_id number(10)   , 
      cst_ipi_id number(10)   , 
      cst_icms_id number(10)   , 
      cst_cofins_id number(10)   , 
      cfop char  (4)   , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      icms_aliquota binary_double   , 
      ipi_aliquota binary_double   , 
      ipi_codigo_enquadramento varchar(3000)   , 
      pis_aliquota binary_double   , 
      pis_base binary_double   , 
      cofins_aliquota binary_double   , 
      cofins_base binary_double   , 
      icms_predbc binary_double   , 
      icms_picms binary_double   , 
      icms_pdif binary_double   , 
      icms_vicmsdeson binary_double   , 
      icms_pmvast binary_double   , 
      icms_picmsst binary_double   , 
      icms_pfcp binary_double   , 
      icms_pfcpst binary_double   , 
      icms_pfcpstret binary_double   , 
      icms_pst binary_double   , 
      icms_pcredsn binary_double   , 
      icms_predbcefet binary_double   , 
      icms_picmsefet binary_double   , 
      icms_pfcpufdest binary_double   , 
      icms_picmsufdest binary_double   , 
      icms_base binary_double   , 
      icms_basest binary_double   , 
      notafiscal_item_modbc_id number(10)   , 
      notafiscal_item_modbcst_id number(10)   , 
      notafiscal_item_motDesICMS_id number(10)   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_finalidade( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_ncm( 
      id number(10)    NOT NULL , 
      natureza_operacao_excecao_id number(10)    NOT NULL , 
      ncm varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_origens( 
      id number(10)    NOT NULL , 
      natureza_operacao_excecao_id number(10)    NOT NULL , 
      notafiscal_item_orig_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_produtos( 
      id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      natureza_operacao_excecao_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      negocio_origem_id number(10)    NOT NULL , 
      funil_id number(10)   , 
      funil_etapas_id number(10)    NOT NULL , 
      titulo varchar(3000)    NOT NULL , 
      valor binary_double   , 
      data_abertura date    NOT NULL , 
      ordem number(10)    NOT NULL , 
      data_fechamento date   , 
      negocio_motivo_perda_id number(10)   , 
      comentarios_motivo_perda varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      contato_nome varchar(3000)   , 
      contato_fone varchar(3000)   , 
      ativo_id number(10)    NOT NULL , 
      arquivado number(10)    NOT NULL , 
      data_fechamento_esperada date   , 
      vendedor_id number(10)   , 
      mes number(10)   , 
      ano number(10)   , 
      orcamento_id number(10)   , 
      cliente_id number(10)   , 
      deletado_em timestamp(0)   , 
      contato_email varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_arquivos( 
      id number(10)    NOT NULL , 
      negocio_id number(10)    NOT NULL , 
      arquivo varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_atividade( 
      id number(10)    NOT NULL , 
      negocio_id number(10)    NOT NULL , 
      negocio_tipo_atividade_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      horario_inicial timestamp(0)   , 
      horario_final timestamp(0)   , 
      observacao varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_etapas_historico( 
      id number(10)    NOT NULL , 
      negocio_id number(10)    NOT NULL , 
      funil_etapas_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_itens( 
      id number(10)    NOT NULL , 
      negocio_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      valor_unitario binary_double    NOT NULL , 
      quantidade binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
      desconto binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_motivo_perda( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_notas( 
      id number(10)    NOT NULL , 
      negocio_id number(10)    NOT NULL , 
      nota varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_origem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_tipo_atividade( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      icone varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      cliente_id number(10)   , 
      venda_id number(10)   , 
      numero varchar(3000)    NOT NULL , 
      data_emissao timestamp(0)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      texto_rodape varchar(3000)   , 
      data_saida timestamp(0)   , 
      icms_basecalc binary_double   , 
      icms_valor binary_double   , 
      icms_subst_base_calc number(10)   , 
      icms_subst_valor binary_double   , 
      frete_valor binary_double   , 
      seguro_valor binary_double   , 
      outras_despesas binary_double   , 
      ipi_valor binary_double   , 
      serie varchar(3000)   , 
      valor_total_produtos binary_double   , 
      valor_total_nota binary_double   , 
      transp_nome varchar(3000)   , 
      transp_cnpj varchar(3000)   , 
      transp_inscest varchar(3000)   , 
      transp_endereco varchar(3000)   , 
      transp_cidade varchar(3000)   , 
      transp_placaveiculo varchar(3000)   , 
      transp_uf varchar(3000)   , 
      transp_veiculouf varchar(3000)   , 
      transp_veiculoRNTC varchar(3000)   , 
      transp_numeracao varchar(3000)   , 
      nf_tipodocumento_id number(10)    NOT NULL , 
      notafiscal_situacao_id number(10)    NOT NULL , 
      notafiscal_crt_id number(10)    NOT NULL , 
      cliente_endereco varchar(3000)   , 
      cliente_complemento varchar(3000)   , 
      cliente_numero varchar(3000)   , 
      cliente_bairro varchar(3000)   , 
      cliente_cidade varchar(3000)   , 
      cliente_cep varchar(3000)   , 
      cliente_estado varchar(3000)   , 
      cliente_nome varchar(3000)   , 
      cliente_cpfcnpj varchar(3000)   , 
      cliente_inscest varchar(3000)   , 
      cliente_inscmuni varchar(3000)   , 
      cliente_fone varchar(3000)   , 
      cliente_cidade_codibge number(10)   , 
      cliente_suframa varchar(3000)   , 
      justificativa_cancelamento varchar(3000)   , 
      chave varchar(3000)   , 
      protocolo_envio varchar(3000)   , 
      notafiscal_indiedest_id number(10)    NOT NULL , 
      protocolo_cancelamento varchar(3000)   , 
      datahora_cancelamento timestamp(0)   , 
      cce_datahora_evento timestamp(0)   , 
      cce_sequencial number(10)   , 
      cce_correcao varchar(3000)   , 
      cce_protocolo varchar(3000)   , 
      infadfisco varchar(3000)   , 
      desconto_valor binary_double   , 
      pis_valor binary_double   , 
      cofins_valor binary_double   , 
      fatura_numero varchar(3000)   , 
      fatura_valor_original binary_double   , 
      fatura_valor_desconto binary_double   , 
      fatura_valor_liquido binary_double   , 
      notafiscal_iddest_id number(10)    NOT NULL , 
      notafiscal_tpimp_id number(10)    NOT NULL , 
      notafiscal_tpemis_id number(10)    NOT NULL , 
      notafiscal_finnfe_id number(10)    NOT NULL , 
      notafiscal_indfinal_id number(10)    NOT NULL , 
      notafiscal_indpres_id number(10)    NOT NULL , 
      verproc varchar(3000)   , 
      notafiscal_indpag_id number(10)    NOT NULL , 
      retirada_marcado number(10)   , 
      retirada_cpfcnpj varchar(3000)   , 
      retirada_xlgr varchar(3000)   , 
      retirada_nro varchar(3000)   , 
      retirada_xcpl varchar(3000)   , 
      retirada_xbairro varchar(3000)   , 
      retirada_cmun number(10)   , 
      retirada_xmun varchar(3000)   , 
      retirada_uf varchar(3000)   , 
      entrega_marcado number(10)   , 
      entrega_cpfcnpj varchar(3000)   , 
      entrega_xlgr varchar(3000)   , 
      entrega_nro varchar(3000)   , 
      entrega_xcpl varchar(3000)   , 
      entrega_xbairro varchar(3000)   , 
      entrega_cmun number(10)   , 
      entrega_xmun varchar(3000)   , 
      entrega_uf varchar(3000)   , 
      vicmsufdest binary_double   , 
      vicmsufremet binary_double   , 
      vfcpufdest binary_double   , 
      notafiscal_modelo_id number(10)    NOT NULL , 
      dispositivos_id number(10)   , 
      xml varchar(3000)   , 
      data_hora_envio timestamp(0)   , 
      xml_cancelamento varchar(3000)   , 
      issqn_vserv binary_double   , 
      issqn_vbc binary_double   , 
      issqn_viss binary_double   , 
      issqn_dcompet date   , 
      issqn_reftrib varchar(3000)   , 
      icms_vfcp binary_double   , 
      icms_vfcpst binary_double   , 
      icms_vfcpstret binary_double   , 
      layout_versao varchar(3000)   , 
      ipi_vipidevol binary_double   , 
      vtroco binary_double   , 
      notafiscal_tpamb_id number(10)    NOT NULL , 
      notafiscal_mod_id number(10)    NOT NULL , 
      infcpl varchar(3000)   , 
      notafiscal_modfrete_id number(10)    NOT NULL , 
      status varchar(3000)   , 
      mensagem varchar(3000)   , 
      cce_xml varchar(3000)   , 
      cce_pdf varchar(3000)   , 
      codigo_sefaz number(10)   , 
      sn_carta_correcao char  (1)    DEFAULT 'N'  NOT NULL , 
      deletado_em timestamp(0)   , 
      contingencia_data timestamp(0)   , 
      contingencia_motivo varchar(3000)   , 
      exporta_ufsaidapais varchar(3000)   , 
      exporta_xlocexporta varchar(3000)   , 
      exporta_xlocdespacho varchar(3000)   , 
      cliente_cpais varchar(3000)   , 
      cliente_xpais varchar(3000)   , 
      natureza_operacao_id number(10)   , 
      movimentacao_origem_id number(10)   , 
      inutilizar number(10)   , 
      xml_inicial varchar(3000)   , 
      entrega_cuf number(10)  (2)   , 
      xml_assinado varchar(3000)   , 
      protolo_xml varchar(3000)   , 
      xml_autorizado varchar(3000)   , 
      cep_entrega varchar  (15)   , 
      cep_retirada varchar  (15)   , 
      entrega_xnome varchar  (200)   , 
      xml_carta varchar(3000)   , 
      protocolo_carta_resposta varchar  (200)   , 
      descricao varchar(3000)   , 
      xevento varchar(3000)   , 
      xmotivo varchar(3000)   , 
      cstat number(10)   , 
      dhregevento varchar  (50)   , 
      nseqevento number(10)  (11)   , 
      nprot varchar  (100)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_autxml( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      cpf_cnpj varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)    NOT NULL , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      fornecedor_id number(10)   , 
      numero varchar(3000)    NOT NULL , 
      data_emissao timestamp(0)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      natop varchar(3000)   , 
      data_saida timestamp(0)   , 
      infcpl varchar(3000)   , 
      infadfisco varchar(3000)   , 
      icms_basecalc binary_double   , 
      icms_valor binary_double   , 
      icms_subst_base_calc binary_double   , 
      icms_subst_valor binary_double   , 
      frete_valor binary_double   , 
      seguro_valor binary_double   , 
      outras_despesas binary_double   , 
      ipi_valor binary_double   , 
      serie varchar(3000)   , 
      valor_total_produtos binary_double   , 
      valor_total_nota binary_double   , 
      transp_nome varchar(3000)   , 
      transp_cnpj varchar(3000)   , 
      transp_inscest varchar(3000)   , 
      transp_endereco varchar(3000)   , 
      transp_cidade varchar(3000)   , 
      transp_placaveiculo varchar(3000)   , 
      transp_uf varchar(3000)   , 
      transp_veiculouf varchar(3000)   , 
      transp_veiculorntc varchar(3000)   , 
      transp_numeracao varchar(3000)   , 
      notafiscal_tipodocumento_id number(10)    NOT NULL , 
      nota_fiscal_compra_situacao_id number(10)    NOT NULL , 
      notafiscal_crt_id number(10)   , 
      obs_importacao_xml varchar(3000)   , 
      cliente_endereco varchar(3000)   , 
      cliente_complemento varchar(3000)   , 
      cliente_numero varchar(3000)   , 
      cliente_bairro varchar(3000)   , 
      cliente_cidade varchar(3000)   , 
      cliente_cep varchar(3000)   , 
      cliente_estado varchar(3000)   , 
      cliente_nome varchar(3000)   , 
      cliente_cpfcnpj varchar(3000)   , 
      cliente_inscest varchar(3000)   , 
      cliente_fone varchar(3000)   , 
      cliente_cidade_codibge varchar(3000)   , 
      cliente_inscmuni varchar(3000)   , 
      cliente_suframa varchar(3000)   , 
      justificativa_cancelamento varchar(3000)   , 
      chave varchar(3000)   , 
      protocolo_envio varchar(3000)   , 
      notafiscal_indiedest_id number(10)   , 
      protocolo_cancelamento varchar(3000)   , 
      datahora_cancelamento varchar(3000)   , 
      cce_datahora_evento varchar(3000)   , 
      cce_sequencial varchar(3000)   , 
      cce_correcao varchar(3000)   , 
      cce_protocolo varchar(3000)   , 
      desconto_valor binary_double   , 
      pis_valor binary_double   , 
      cofins_valor binary_double   , 
      fatura_numero varchar(3000)   , 
      fatura_valor_original varchar(3000)   , 
      fatura_valor_desconto binary_double   , 
      fatura_valor_liquido binary_double   , 
      notafiscal_iddest_id number(10)    NOT NULL , 
      notafiscal_tpimp_id number(10)   , 
      notafiscal_finnfe_id number(10)    NOT NULL , 
      notafiscal_indfinal_id number(10)    NOT NULL , 
      notafiscal_indpres_id number(10)    NOT NULL , 
      verproc varchar(3000)   , 
      notafiscal_indpag_id number(10)   , 
      retirada_marcado number(10)   , 
      retirada_cpfcnpj varchar(3000)   , 
      retirada_xlgr varchar(3000)   , 
      retirada_nro varchar(3000)   , 
      retirada_xcpl varchar(3000)   , 
      retirada_xbairro varchar(3000)   , 
      retirada_cmun number(10)   , 
      retirada_xmun varchar(3000)   , 
      retirada_uf varchar(3000)   , 
      entrega_marcado number(10)   , 
      entrega_cpfcnpj varchar(3000)   , 
      entrega_xlgr varchar(3000)   , 
      entrega_nro varchar(3000)   , 
      entrega_xcpl varchar(3000)   , 
      entrega_xbairro varchar(3000)   , 
      entrega_cmun varchar(3000)   , 
      entrega_xmun varchar(3000)   , 
      entrega_uf varchar(3000)   , 
      vicmsufdest binary_double   , 
      vicmsufremet binary_double   , 
      vfcpufdest varchar(3000)   , 
      notafiscal_mod_id number(10)    NOT NULL , 
      xml varchar(3000)   , 
      data_hora_envio timestamp(0)   , 
      xml_cancelamento varchar(3000)   , 
      issqn_vserv binary_double   , 
      issqn_vbc binary_double   , 
      issqn_viss binary_double   , 
      issqn_dcompet date   , 
      issqn_reftrib varchar(3000)   , 
      icms_vfcp binary_double   , 
      icms_vfcpst binary_double   , 
      icms_vfcpstret binary_double   , 
      layout_versao varchar(3000)   , 
      ipi_vipidevol binary_double   , 
      vtroco date   , 
      notafiscal_modfrete_id number(10)   , 
      cpag_lancada char(1)    NOT NULL , 
      dest_cnpj varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_dup( 
      id number(10)    NOT NULL , 
      nota_fiscal_compra_id number(10)    NOT NULL , 
      forma_pagamento_id number(10)   , 
      plano_conta_id number(10)   , 
      centro_custo_id number(10)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      ndup varchar(3000)   , 
      vdup binary_double   , 
      dvenc date   , 
      parcela varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens( 
      id number(10)    NOT NULL , 
      nota_fiscal_compra_id number(10)    NOT NULL , 
      produto_id number(10)   , 
      nota_fiscal_compra_itens_situacao_id number(10)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      nitem number(10)   , 
      cean varchar(3000)   , 
      xprod varchar(3000)   , 
      ncm varchar(3000)   , 
      nve varchar(3000)   , 
      extipi varchar(3000)   , 
      cfop varchar(3000)   , 
      ucom varchar(3000)   , 
      qcom binary_double   , 
      vuncom binary_double   , 
      vprod binary_double   , 
      ceantrib varchar(3000)   , 
      utrib varchar(3000)   , 
      qtrib binary_double   , 
      vuntrib binary_double   , 
      vfrete binary_double   , 
      vseg binary_double   , 
      vdesc binary_double   , 
      vtottrib binary_double   , 
      xped varchar(3000)   , 
      nitemped number(10)   , 
      notafiscal_item_indtot_id number(10)   , 
      notafiscal_item_orig_id number(10)    NOT NULL , 
      notafiscal_item_modbc_id number(10)   , 
      icms_basecalc binary_double   , 
      icms_cst varchar(3000)   , 
      icms_valor binary_double   , 
      icms_aliquota binary_double   , 
      icms_pcredsn binary_double   , 
      icms_vcredicmssn binary_double   , 
      icms_predbc binary_double   , 
      icms_pst binary_double   , 
      icms_pmvast binary_double   , 
      icms_predbcst binary_double   , 
      icms_vbcst binary_double   , 
      icms_picmsst binary_double   , 
      icms_vicmsst binary_double   , 
      fcp_pfcp binary_double   , 
      pis_cst varchar(3000)   , 
      pis_valor binary_double   , 
      pis_aliquota binary_double   , 
      pis_valor_base binary_double   , 
      cofins_cst varchar(3000)   , 
      cofins_valor_base binary_double   , 
      cofins_aliquota binary_double   , 
      cofins_valor binary_double   , 
      voutro binary_double   , 
      infadprod varchar(3000)   , 
      notafiscal_item_motDesICMS_id number(10)   , 
      cprod varchar(3000)   , 
      ipi_cst varchar(3000)   , 
      ipi_valor_base binary_double   , 
      ipi_aliquota binary_double   , 
      ipi_vipidevol binary_double   , 
      ipi_valor binary_double   , 
      ipi_pdevol binary_double   , 
      estoque_deposito_id number(10)   , 
      produto_lote_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_pag( 
      id number(10)    NOT NULL , 
      nota_fiscal_compra_id number(10)    NOT NULL , 
      notafiscal_tpag_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      tpag varchar(3000)   , 
      vpag binary_double   , 
      xpag varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      cor varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_cprod_padrao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_crt( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor number(10)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_dup( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      ndup varchar(3000)   , 
      vdup binary_double   , 
      dvenc date   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_finnfe( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_frete_volumes( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      qVol number(10)   , 
      nVol varchar(3000)   , 
      esp varchar(3000)   , 
      marca varchar(3000)   , 
      pesol binary_double   , 
      pesob binary_double   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_iddest( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indfinal( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indiedest( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpag( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpres( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_indtot( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbc( 
      id number(10)    NOT NULL , 
      codigo number(10)   , 
      descricao varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbcst( 
      id number(10)    NOT NULL , 
      codigo number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_motDesICMS( 
      id number(10)    NOT NULL , 
      codigo varchar(3000)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_orig( 
      id number(10)    NOT NULL , 
      codigo number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_itens( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      nitem number(10)   , 
      cean varchar  (50)   , 
      xprod varchar(3000)    NOT NULL , 
      ncm varchar(3000)   , 
      nve varchar(3000)   , 
      extipi varchar(3000)   , 
      cfop varchar(3000)   , 
      ucom varchar(3000)   , 
      qcom binary_double    NOT NULL , 
      vuncom binary_double  (13,2)    NOT NULL , 
      vprod binary_double   , 
      ceantrib varchar(3000)   , 
      utrib varchar(3000)   , 
      qtrib binary_double  (13,2)   , 
      vuntrib binary_double  (13,2)   , 
      vfrete binary_double  (13,2)   , 
      vseg binary_double  (13,2)   , 
      vdesc binary_double  (13,2)   , 
      vtottrib binary_double  (10,2)   , 
      xped varchar(3000)   , 
      nitemped number(10)   , 
      notafiscal_item_indtot_id number(10)   , 
      notafiscal_item_orig_id number(10)    NOT NULL , 
      notafiscal_item_modbc_id number(10)   , 
      icms_basecalc binary_double   , 
      icms_cst varchar  (20)   , 
      icms_valor binary_double   , 
      icms_aliquota binary_double   , 
      icms_pcredsn binary_double  (10,2)   , 
      icms_vcredicmssn binary_double   , 
      icms_predbc binary_double   , 
      icms_pst binary_double   , 
      icms_pmvast binary_double   , 
      icms_predbcst binary_double   , 
      icms_vbcst binary_double   , 
      icms_picmsst binary_double   , 
      icms_vicmsst binary_double   , 
      alterado_em timestamp(0)   , 
      criado_em timestamp(0)   , 
      pis_cst varchar  (20)   , 
      pis_valor binary_double   , 
      pis_aliquota binary_double   , 
      pis_valor_base binary_double   , 
      cofins_cst varchar  (20)   , 
      cofins_valor_base binary_double   , 
      cofins_aliquota binary_double   , 
      cofins_valor binary_double   , 
      voutro binary_double   , 
      infadprod varchar(3000)   , 
      notafiscal_item_motDesICMS_id number(10)   , 
      cprod varchar(3000)   , 
      ipi_cst varchar  (255)   , 
      ipi_valor_base binary_double   , 
      ipi_aliquota binary_double   , 
      ipi_vipidevol binary_double   , 
      ipi_valor binary_double   , 
      ipi_pdevol binary_double   , 
      cest varchar(3000)   , 
      fcp_pfcp binary_double   , 
      fcp_vfcp binary_double   , 
      fcp_vbcfcp binary_double   , 
      fcp_vbcfcpst binary_double   , 
      fcp_pfcpst binary_double   , 
      fcp_vfcpst binary_double   , 
      fcp_vbcfcpstret binary_double   , 
      fcp_pfcpstret binary_double   , 
      fcp_vfcpstret binary_double   , 
      icms_vbcufdest binary_double   , 
      icms_vbcfcpufdest binary_double   , 
      icms_pfcpufdest binary_double   , 
      icms_vfcpufdest binary_double   , 
      icms_picmsinter binary_double   , 
      icms_picmsinterpart binary_double   , 
      icms_vicmsufdest binary_double   , 
      icms_vicmsufremet binary_double   , 
      icms_picmsufdest binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_logs( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      system_users_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_mod( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      modelo varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_modfrete( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_pag( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      notafiscal_tpag_id number(10)    NOT NULL , 
      tpag varchar(3000)   , 
      vpag binary_double   , 
      xpag varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecf( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      notafiscal_refecfmod_id number(10)    NOT NULL , 
      necf varchar(3000)   , 
      ncoo varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecfmod( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refnfe( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)    NOT NULL , 
      refnfe varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_series( 
      id number(10)    NOT NULL , 
      serie varchar(3000)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      notafiscal_tpamb_id number(10)    NOT NULL , 
      notafiscal_mod_id number(10)    NOT NULL , 
      sequencial number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      notafiscal_tipodocumento_id number(10)    NOT NULL , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      ordem number(10)   , 
      exibir char(1)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_por varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao_sefaz( 
      id number(10)    NOT NULL , 
      notafiscal_situacao_id number(10)    NOT NULL , 
      codigo_sefaz number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodoc_series( 
      id number(10)    NOT NULL , 
      notafiscal_series_id number(10)    NOT NULL , 
      notafiscal_tipodocumento_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodocumento( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpag( 
      id number(10)    NOT NULL , 
      tpag varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      descricao varchar(3000)    NOT NULL , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpamb( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpemis( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpimp( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      valor varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      orcamento_situacao_id number(10)    NOT NULL , 
      vendedor_id number(10)   , 
      cliente_id number(10)   , 
      cliente_contato_id number(10)   , 
      data_orcamento date    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      observacao varchar(3000)   , 
      valor_produtos binary_double    NOT NULL , 
      desconto binary_double   , 
      peso_total binary_double   , 
      frete_total binary_double   , 
      valor_total binary_double    NOT NULL , 
      tabela_preco_id number(10)   , 
      justificativa_reprovacao varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_interacoes( 
      id number(10)    NOT NULL , 
      orcamento_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_item( 
      id number(10)    NOT NULL , 
      orcamento_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade binary_double    NOT NULL , 
      valor_unitario binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
      valor_original binary_double    NOT NULL , 
      valor_custo binary_double   , 
      desconto binary_double   , 
      informacoes_adicionais varchar(3000)   , 
      numero_pedido varchar(3000)   , 
      numero_item_pedido varchar(3000)   , 
      valor_frete binary_double   , 
      peso_unitario binary_double   , 
      peso_total binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      ordem number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao_historico( 
      id number(10)    NOT NULL , 
      orcamento_situacao_id number(10)    NOT NULL , 
      orcamento_id number(10)    NOT NULL , 
      descricao varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      ordem_producao_situacao_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      produto_ficha_tecnica_id number(10)    NOT NULL , 
      estoque_deposito_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade binary_double    NOT NULL , 
      data_producao date    NOT NULL , 
      observacoes varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas( 
      id number(10)    NOT NULL , 
      ordem_producao_id number(10)    NOT NULL , 
      ordem_producao_etapas_situacao_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      ordem number(10)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_itens( 
      id number(10)    NOT NULL , 
      ordem_producao_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      estoque_deposito_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade binary_double    NOT NULL , 
      quantidade_total binary_double    NOT NULL , 
      custo binary_double   , 
      custo_total binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao_historico( 
      id number(10)    NOT NULL , 
      ordem_producao_id number(10)    NOT NULL , 
      ordem_producao_situacao_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_vendas( 
      id number(10)    NOT NULL , 
      ordem_producao_id number(10)    NOT NULL , 
      venda_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      cliente_id number(10)    NOT NULL , 
      cliente_contato_id number(10)   , 
      vendedor_id number(10)   , 
      ordem_servico_situacao_id number(10)    NOT NULL , 
      ordem_servico_producao_etapa_id number(10)   , 
      condicao_pagamento_id number(10)   , 
      cliente_endereco_id number(10)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      numero_os number(10)   , 
      numero_orcamento number(10)   , 
      data_emissao date    NOT NULL , 
      valor binary_double    NOT NULL , 
      desconto binary_double   , 
      prazo_entrega date   , 
      validade_dias number(10)   , 
      data_abertura_os date   , 
      vendedor_comissao binary_double   , 
      vendedor_comissao_avista binary_double   , 
      vendedor_comissao_aprazo binary_double   , 
      observacoes varchar(3000)   , 
      prazo_garantia date   , 
      valor_pago binary_double   , 
      motivo_nao_aprovacao_orcamento varchar(3000)   , 
      valor_avista binary_double   , 
      valor_aprazo binary_double   , 
      valor_faturado_vendas binary_double   , 
      usuario_aprovacao_id number(10)   , 
      informacoes_transporte varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_garantia_historico( 
      id number(10)    NOT NULL , 
      ordem_servico_id number(10)    NOT NULL , 
      observacoes varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_historico( 
      id number(10)    NOT NULL , 
      ordem_servico_situacao_id number(10)    NOT NULL , 
      ordem_servico_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item( 
      id number(10)    NOT NULL , 
      ordem_servico_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      descricao_servico varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade binary_double    NOT NULL , 
      quantidade_atendida binary_double   , 
      valor_unitario binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
      desconto binary_double   , 
      arquivo varchar(3000)   , 
      largura binary_double   , 
      altura binary_double   , 
      quantidade_a_faturar binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_despesas( 
      id number(10)    NOT NULL , 
      ordem_servico_item_id number(10)    NOT NULL , 
      despesas_servicos_id number(10)    NOT NULL , 
      despesas_servicos_tipo_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      valor_unitario binary_double    NOT NULL , 
      quantidade binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_ficha_tecnica( 
      id number(10)    NOT NULL , 
      ordem_servico_item_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      quantidade_fixa_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade binary_double    NOT NULL , 
      custo binary_double   , 
      valor_unitario binary_double   , 
      valor_total binary_double   , 
      quantidade_original binary_double    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_mao_obra( 
      id number(10)    NOT NULL , 
      ordem_servico_item_id number(10)    NOT NULL , 
      funcionario_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade_horas binary_double   , 
      valor_hora binary_double   , 
      valor_total binary_double   , 
      quantidade_horas_original binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_obs_etapas( 
      id number(10)    NOT NULL , 
      ordem_servico_item_id number(10)    NOT NULL , 
      ordem_servico_producao_etapa_id number(10)    NOT NULL , 
      observacao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_producao_etapa( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      cor varchar(3000)   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_venda( 
      id number(10)    NOT NULL , 
      ordem_servico_id number(10)    NOT NULL , 
      venda_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicadores( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicador_usuario( 
      id number(10)    NOT NULL , 
      painel_indicadores_id number(10)    NOT NULL , 
      indicador_personalizado_id number(10)    NOT NULL , 
      system_users_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pais( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      codigo_pais varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE parceiro( 
      id number(10)    NOT NULL , 
      certificado_venda_modalidade_id number(10)    NOT NULL , 
      tabela_preco_id number(10)   , 
      vendedor_id number(10)   , 
      cpf_cnpj varchar(3000)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      razao_social varchar(3000)   , 
      cep varchar(3000)   , 
      logradouro varchar(3000)   , 
      bairro varchar(3000)   , 
      cidade varchar(3000)   , 
      estado varchar(3000)   , 
      fone varchar(3000)   , 
      email varchar(3000)   , 
      contato varchar(3000)   , 
      contato_fone varchar(3000)   , 
      comissao_percentual binary_double   , 
      deletado_em timestamp(0)   , 
      criado_em timestamp(0)    NOT NULL , 
      alterado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      banco_id number(10)   , 
      banco_agencia varchar(3000)   , 
      banco_conta varchar(3000)   , 
      banco_chavepix varchar(3000)   , 
      banco_nome_titular varchar(3000)   , 
      banco_cpfcnpj varchar(3000)   , 
      chave_pix_tipo_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pdv_permissoes( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pedido_evento( 
      id number(10)    NOT NULL , 
      notafiscal_id number(10)   , 
      system_unit_id number(10)   , 
      system_users_id number(10)   , 
      chave varchar  (50)   , 
      descricao varchar(3000)   , 
      tipo varchar  (30)   , 
      numero varchar  (10)   , 
      serie number(10)   , 
      nseqevento number(10)   , 
      protocolo varchar  (20)   , 
      status number(10)    DEFAULT 1 , 
      protocolo_resposta varchar  (50)   , 
      xevento varchar(3000)   , 
      created_at timestamp(0)   , 
      update_at timestamp(0)   , 
      deleted_at timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pessoa_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      plano_conta_tipo_id number(10)    NOT NULL , 
      plano_conta_origem_id number(10)    NOT NULL , 
      plano_conta_pai_id number(10)   , 
      numero varchar(3000)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_origem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto( 
      id number(10)    NOT NULL , 
      produto_grupo_id number(10)    NOT NULL , 
      unidade_medida_id number(10)    NOT NULL , 
      tipo_recurso_id number(10)    NOT NULL , 
      produto_fabricante_id number(10)   , 
      produtogrupo_subgrupo_id number(10)   , 
      notafiscal_item_orig_id number(10)   , 
      nome varchar(3000)    NOT NULL , 
      nome_curto varchar(3000)   , 
      codigo_EAN varchar(3000)   , 
      imagem varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      ncm varchar(3000)   , 
      cest varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_por varchar(3000)   , 
      obs varchar(3000)   , 
      referencia varchar(3000)   , 
      deletado_em timestamp(0)   , 
      especificacao varchar(3000)   , 
      link_site varchar(3000)   , 
      peso_liquido binary_double   , 
      peso_bruto binary_double   , 
      habilitado_id number(10)   , 
      produto_tipo_id number(10)   , 
      codigo_sku varchar(3000)   , 
      largura binary_double   , 
      altura binary_double   , 
      comprimento binary_double   , 
      diametro binary_double   , 
      dias_preparacao binary_double   , 
      marca varchar(3000)   , 
      garantia varchar(3000)   , 
      unidade_caixa binary_double   , 
      produto_embalagem_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_embalagem( 
      id number(10)    NOT NULL , 
      produto_tipo_embalagem_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      peso binary_double   , 
      dimensoes varchar(3000)    NOT NULL , 
      altura binary_double   , 
      largura binary_double   , 
      comprimento binary_double   , 
      diametro binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_enderecamento( 
      id number(10)    NOT NULL , 
      produto_filial_id number(10)    NOT NULL , 
      estoque_prateleira_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_etiqueta_configuracoes( 
      id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fabricante( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      custo_total binary_double   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_despesas( 
      id number(10)    NOT NULL , 
      produto_ficha_tecnica_id number(10)    NOT NULL , 
      despesas_servicos_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      valor_unitario binary_double    NOT NULL , 
      quantidade binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_etapas_producao( 
      id number(10)    NOT NULL , 
      produto_ficha_tecnica_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      ordem number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_itens( 
      id number(10)    NOT NULL , 
      produto_ficha_tecnica_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      quantidade binary_double    NOT NULL , 
      valor_custo binary_double   , 
      valor_total binary_double   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade_fixa_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_mao_obra( 
      id number(10)    NOT NULL , 
      produto_ficha_tecnica_id number(10)    NOT NULL , 
      funcionario_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      valor_hora binary_double    NOT NULL , 
      quantidade binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial( 
      id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      margem binary_double   , 
      preco_venda binary_double    NOT NULL , 
      preco_venda_anterior binary_double   , 
      valor_custo binary_double   , 
      valor_custo_anterior binary_double   , 
      criado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
      estoque_minimo binary_double   , 
      estoque_maximo binary_double   , 
      local_estoque varchar(3000)   , 
      codigo_balanca varchar(3000)   , 
      deletado_em timestamp(0)   , 
      estoque_deposito_padrao_id number(10)   , 
      sob_encomenda_id number(10)   , 
      gerar_op_venda_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial_historico( 
      id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      produto_filial_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      preco_venda_antigo binary_double    NOT NULL , 
      preco_venda_novo binary_double    NOT NULL , 
      valor_custo_antigo binary_double   , 
      valor_custo_novo binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fornecedor( 
      id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      fornecedor_id number(10)    NOT NULL , 
      codigo_fornecedor varchar(3000)   , 
      descricao_produto_fornecedor varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      tempo_medio_fornecimento binary_double   , 
      quantidade_minima_compra binary_double   , 
      preco_venda binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_grupo( 
      id number(10)    NOT NULL , 
      tipo_recurso_id number(10)   , 
      descricao varchar(3000)    NOT NULL , 
      imagem varchar(3000)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      criado_por varchar(3000)   , 
      alterado_por varchar(3000)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produtogrupo_subgrupo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      produto_grupo_id number(10)    NOT NULL , 
      subgrupo_id number(10)  (11)   , 
      nivel number(10)  (11)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_lote( 
      id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      numero varchar(3000)    NOT NULL , 
      validade date   , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      criado_por varchar(3000)   , 
      alterado_por varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo_embalagem( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE resposta( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE servico_formapgto( 
      id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      ordem_servico_id number(10)    NOT NULL , 
      quantidade_parcelas number(10)   , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document( 
      id number(10)    NOT NULL , 
      category_id number(10)    NOT NULL , 
      system_user_id number(10)   , 
      title varchar(3000)    NOT NULL , 
      description varchar(3000)   , 
      submission_date date   , 
      archive_date date   , 
      filename varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_category( 
      id number(10)    NOT NULL , 
      name varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_group( 
      id number(10)    NOT NULL , 
      document_id number(10)    NOT NULL , 
      system_group_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_user( 
      id number(10)    NOT NULL , 
      document_id number(10)    NOT NULL , 
      system_user_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group( 
      id number(10)    NOT NULL , 
      name varchar(3000)    NOT NULL , 
      uuid varchar  (36)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program( 
      id number(10)    NOT NULL , 
      system_group_id number(10)    NOT NULL , 
      system_program_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program_permissoes( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      system_program_permissoes_id number(10)    NOT NULL , 
      system_group_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_message( 
      id number(10)    NOT NULL , 
      system_user_id number(10)    NOT NULL , 
      system_user_to_id number(10)    NOT NULL , 
      subject varchar(3000)    NOT NULL , 
      message varchar(3000)   , 
      dt_message timestamp(0)   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_notification( 
      id number(10)    NOT NULL , 
      system_user_id number(10)    NOT NULL , 
      system_user_to_id number(10)    NOT NULL , 
      subject varchar(3000)   , 
      message varchar(3000)   , 
      dt_message timestamp(0)   , 
      action_url varchar(3000)   , 
      action_label varchar(3000)   , 
      icon varchar(3000)   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_preference( 
      id varchar  (255)    NOT NULL , 
      preference varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program( 
      id number(10)    NOT NULL , 
      name varchar(3000)    NOT NULL , 
      controller varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program_permissoes( 
      id number(10)    NOT NULL , 
      system_program_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_unit( 
      id number(10)    NOT NULL , 
      connection_name varchar(3000)   , 
      vendas_natureza_operacao_id number(10)   , 
      nfce_natureza_operacao_id number(10)   , 
      cnpj varchar  (14)    NOT NULL , 
      name varchar(3000)    NOT NULL , 
      razao_social varchar  (255)    NOT NULL , 
      inscricao_estadual varchar  (255)   , 
      inscricao_municipal varchar  (255)   , 
      fone varchar(3000)   , 
      notafiscal_crt_id number(10)    NOT NULL , 
      pc_credito_sn binary_double  (10,2)    DEFAULT 0 , 
      aliquota_iss binary_double  (10,2)   , 
      aliquota_irrf binary_double  (10,2)   , 
      aliquota_csll binary_double  (10,2)   , 
      sn_matriz char  (1)    DEFAULT 'N'  NOT NULL , 
      nfce_tpamb_id number(10)   , 
      nfe_tpamb_id number(10)   , 
      nfe_tpimp_id number(10)   , 
      nfce_tpimp_id number(10)   , 
      certificadoA1 varchar(3000)   , 
      senha_certificado varchar(3000)   , 
      nfe_homologacao_series_id number(10)   , 
      nfe_producao_series_id number(10)   , 
      nfce_homologacao_series_id number(10)   , 
      nfe_api_documentos_id number(10)   , 
      nfce_api_documentos_id number(10)   , 
      nfce_producao_series_id number(10)   , 
      end_cep varchar(3000)   , 
      end_mun_codibge varchar(3000)   , 
      end_municipio varchar(3000)   , 
      end_uf char  (2)   , 
      end_logradouro varchar(3000)   , 
      end_bairro varchar(3000)   , 
      end_numero varchar(3000)   , 
      end_complemento varchar(3000)   , 
      nfce_csc_homologacao varchar(3000)   , 
      nfce_csc_producao varchar(3000)   , 
      notafiscal_cprod_padrao_id number(10)   , 
      nfce_id_csc_homologacao varchar(3000)   , 
      nfce_id_csc_producao varchar(3000)   , 
      email varchar  (255)   , 
      token_api varchar(3000)   , 
      mdfe_tpamb_id number(10)   , 
      mdfe_estadoini_id number(10)   , 
      veiculo_id number(10)   , 
      mdfe_api_documentos_id number(10)   , 
      mdfe_homologacao_series_id number(10)   , 
      mdfe_producao_series_id number(10)   , 
      natureza_operacao_compra_id number(10)   , 
      logo varchar(3000)   , 
      contador_nome varchar(3000)   , 
      contador_documento varchar(3000)   , 
      contador_email varchar(3000)   , 
      contador_celular varchar(3000)   , 
      config_host varchar(3000)   , 
      config_user varchar(3000)   , 
      config_password varchar(3000)   , 
      config_port varchar  (11)    DEFAULT '587' , 
      config_from varchar(3000)   , 
      config_replyname varchar(3000)   , 
      config_replyto varchar(3000)   , 
      column_63 number(10)   , 
      cnae varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_group( 
      id number(10)    NOT NULL , 
      system_user_id number(10)    NOT NULL , 
      system_group_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_pdv_permissoes( 
      id number(10)    NOT NULL , 
      empresa_id number(10)    NOT NULL , 
      pdv_permissoes_id number(10)    NOT NULL , 
      system_user_id number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program( 
      id number(10)    NOT NULL , 
      system_user_id number(10)    NOT NULL , 
      system_program_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program_permissoes( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      system_users_id number(10)    NOT NULL , 
      system_program_permissoes_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_users( 
      id number(10)    NOT NULL , 
      name varchar(3000)    NOT NULL , 
      login varchar(3000)    NOT NULL , 
      password varchar(3000)    NOT NULL , 
      email varchar(3000)   , 
      frontpage_id number(10)   , 
      system_unit_id number(10)   , 
      active char  (1)   , 
      accepted_term_policy char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_unit( 
      id number(10)    NOT NULL , 
      system_user_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco( 
      id number(10)    NOT NULL , 
      tabela_preco_tipo_alteracao_id number(10)    NOT NULL , 
      tabela_preco_tipo_id number(10)   , 
      descricao varchar(3000)    NOT NULL , 
      observacao varchar(3000)   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      data_hora_promocao_inicial timestamp(0)   , 
      data_hora_promocao_final timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_produto( 
      id number(10)    NOT NULL , 
      tabela_preco_id number(10)    NOT NULL , 
      produto_filial_id number(10)    NOT NULL , 
      preco_venda binary_double    NOT NULL , 
      valor_parametro binary_double    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo_alteracao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_documento( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_recurso( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE titulos_tipo_anexo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE unidade_medida( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      sigla varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_por varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo( 
      id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      modelo_marca varchar(3000)    NOT NULL , 
      placa varchar(3000)    NOT NULL , 
      ano number(10)   , 
      tara binary_double   , 
      capacidade_kg binary_double   , 
      renavam varchar(3000)   , 
      capacidade_m3 binary_double   , 
      mdfe_tpRod_id number(10)    NOT NULL , 
      estado_id number(10)    NOT NULL , 
      veiculo_tipo_id number(10)    NOT NULL , 
      mdfe_tpcar_id number(10)    NOT NULL , 
      funcionario_motorista_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo_tipo( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda( 
      id number(10)    NOT NULL , 
      venda_situacao_id number(10)    NOT NULL , 
      orcamento_id number(10)   , 
      vendedor_id number(10)   , 
      dispositivos_id number(10)   , 
      cliente_id number(10)   , 
      numero_celula_consumo varchar(3000)   , 
      system_unit_id number(10)    NOT NULL , 
      filial_saida_id number(10)    NOT NULL , 
      venda_modalidade_id number(10)    NOT NULL , 
      venda_tipo_pagamento_id number(10)    NOT NULL , 
      id_venda_local number(10)   , 
      data_hora_venda timestamp(0)    NOT NULL , 
      valor_produtos binary_double    NOT NULL , 
      valor_troco binary_double   , 
      desconto binary_double   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      observacao varchar(3000)   , 
      observacao_nf varchar(3000)   , 
      peso_total binary_double   , 
      frete_total binary_double   , 
      valor_total binary_double    NOT NULL , 
      cliente_endereco_id number(10)   , 
      info_faturamento varchar(3000)   , 
      data_prev_entrega date   , 
      criado_por varchar(3000)   , 
      alterado_por varchar(3000)   , 
      valor_comissao binary_double   , 
      comissao_avista binary_double   , 
      comissao_aprazo number(10)   , 
      valor_avista binary_double   , 
      valor_aprazo binary_double   , 
      tabela_preco_id number(10)   , 
      movimentacao_origem_id number(10)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao( 
      id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      venda_id number(10)    NOT NULL , 
      data_devolucao date    NOT NULL , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_itens( 
      id number(10)    NOT NULL , 
      venda_devolucao_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade binary_double    NOT NULL , 
      valor_unitario binary_double   , 
      valor_total binary_double    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_troca( 
      id number(10)    NOT NULL , 
      venda_devolucao_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      quantidade binary_double    NOT NULL , 
      valor_unitario binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_formapgto( 
      id number(10)    NOT NULL , 
      forma_pagamento_id number(10)    NOT NULL , 
      venda_id number(10)    NOT NULL , 
      quantidade_parcelas number(10)   , 
      valor binary_double    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_item( 
      id number(10)    NOT NULL , 
      venda_id number(10)    NOT NULL , 
      produto_id number(10)    NOT NULL , 
      quantidade binary_double    NOT NULL , 
      valor_unitario binary_double    NOT NULL , 
      valor_total binary_double    NOT NULL , 
      valor_original binary_double    NOT NULL , 
      valor_custo binary_double   , 
      desconto binary_double   , 
      informacoes_adicionais varchar(3000)   , 
      cancelado number(10)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      numero_pedido varchar(3000)   , 
      numero_item_pedido varchar(3000)   , 
      valor_frete binary_double   , 
      peso_unitario binary_double   , 
      peso_total binary_double   , 
      estoque_deposito_id number(10)   , 
      produto_lote_id number(10)   , 
      quantidade_devolvida binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta( 
      id number(10)    NOT NULL , 
      venda_meta_situacao_id number(10)    NOT NULL , 
      system_unit_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      data_inicial date    NOT NULL , 
      data_final date    NOT NULL , 
      valor_meta_geral_prevista binary_double    NOT NULL , 
      valor_meta_geral_realizada binary_double   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      data_ultimo_processamento timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_vendedor( 
      id number(10)    NOT NULL , 
      venda_meta_id number(10)    NOT NULL , 
      vendedor_id number(10)    NOT NULL , 
      valor_meta_prevista binary_double   , 
      valor_meta_realizada binary_double   , 
      criado_em timestamp(0)    NOT NULL , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_em timestamp(0)   , 
      aproveiramento_carteira_prevista binary_double   , 
      aproveitamento_carteira_realizada binary_double   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_modalidade( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      situacaopdv_id number(10)   , 
      ordem number(10)   , 
      cor varchar(3000)   , 
      criado_por varchar(3000)    NOT NULL , 
      alterado_por varchar(3000)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao_historico( 
      id number(10)    NOT NULL , 
      venda_situacao_id number(10)    NOT NULL , 
      venda_id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)    NOT NULL , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_tipo_pagamento( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor( 
      id number(10)    NOT NULL , 
      nome varchar(3000)    NOT NULL , 
      cpf varchar(3000)   , 
      vendedor_tipo_comissao_id number(10)   , 
      vendedor_tipo_pgto_comissao_id number(10)   , 
      criado_em timestamp(0)   , 
      alterado_em timestamp(0)   , 
      percentual_comissao binary_double   , 
      criado_por varchar(3000)   , 
      alterado_por varchar(3000)   , 
      deletado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_comissao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_pgto_comissao( 
      id number(10)    NOT NULL , 
      descricao varchar(3000)    NOT NULL , 
      criado_em timestamp(0)   , 
      deletado_em timestamp(0)   , 
      alterado_por varchar(3000)   , 
      criado_por varchar(3000)   , 
      alterado_em timestamp(0)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE xml_contador( 
      id number(10)    NOT NULL , 
      data_inicio date   , 
      data_fim date   , 
      system_user_id number(10)   , 
      system_unit_id number(10)   , 
      data_solicitacao timestamp(0)   , 
      caminho_download varchar  (255)   , 
      updated_at timestamp(0)   , 
      created_at timestamp(0)   , 
      info_registros varchar  (255)   , 
      data_click timestamp(0)   , 
      status_id number(10)    DEFAULT 0 , 
      situacao number(10)    DEFAULT 1 , 
      caminho_pdf varchar  (255)   , 
      contador number(10)    DEFAULT 0 , 
      contador_email number(10)    DEFAULT 0 , 
      downloads number(10)    DEFAULT 0 , 
      rota varchar(3000)   , 
      chave varchar  (20)   , 
 PRIMARY KEY (id)) ; 

 
 ALTER TABLE dispositivos ADD UNIQUE (token);
  
 ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_1 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_2 FOREIGN KEY (integradores_servicos_id) references integradores_servicos(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_2 FOREIGN KEY (caixa_situacao_id) references caixa_situacao(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_3 FOREIGN KEY (system_users_abertura_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_4 FOREIGN KEY (system_users_operador_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_5 FOREIGN KEY (system_users_fechamento_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_1 FOREIGN KEY (caixa_id) references caixa(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_3 FOREIGN KEY (caixa_tipo_lancamento_id) references caixa_tipo_lancamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_4 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_1 FOREIGN KEY (centro_custo_tipo_id) references centro_custo_tipo(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_agendamentos ADD CONSTRAINT fk_certificado_agendamentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_agente_registro ADD CONSTRAINT fk_certificado_agente_registro_1 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_2 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_4 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_5 FOREIGN KEY (certificado_cliente_situacao_id) references certificado_cliente_situacao(id); 
ALTER TABLE certificado_email_historico ADD CONSTRAINT fk_certificado_email_historico_1 FOREIGN KEY (certificado_cliente_id) references certificado_cliente(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_1 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_4 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_agente_registro_id) references certificado_agente_registro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_5 FOREIGN KEY (certificado_venda_situacao_id) references certificado_venda_situacao(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_7 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_8 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_9 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_12 FOREIGN KEY (certificado_tipo_atendimento_id) references certificado_tipo_atendimento(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_13 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificado_venda_documentos ADD CONSTRAINT fk_certificado_venda_documentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_1 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_2 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_2 FOREIGN KEY (pais_id) references pais(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_3 FOREIGN KEY (residencia_propria) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_4 FOREIGN KEY (utilizar_endereco_cobranca) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_5 FOREIGN KEY (cliente_situacao_id) references cliente_situacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_7 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_8 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_9 FOREIGN KEY (cliente_classificacao_subgrupo_id) references cliente_classificacao_subgrupo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE cliente_classificacao ADD CONSTRAINT fk_cliente_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE cliente_classificacao_subgrupo ADD CONSTRAINT fk_cliente_classificacao_subgrupo_1 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente_contato ADD CONSTRAINT fk_cliente_contato_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_2 FOREIGN KEY (principal) references resposta(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE cliente_historico_limite ADD CONSTRAINT fk_cliente_historico_limite_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_1 FOREIGN KEY (forma_pagamento_id_dinheiro_caixa) references forma_pagamento(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_2 FOREIGN KEY (forma_pagamento_id_titulos_cpag_nf) references forma_pagamento(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_1 FOREIGN KEY (configuracoes_id) references configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_2 FOREIGN KEY (produto_etiqueta_configuracoes_id) references produto_etiqueta_configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_4 FOREIGN KEY (plano_conta_crec_id) references plano_conta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_5 FOREIGN KEY (centro_custo_crec_id) references centro_custo(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_6 FOREIGN KEY (cpag_usa_plano_contas_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_9 FOREIGN KEY (notafiscal_cprod_padrao_orcamento_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_7 FOREIGN KEY (informar_duplicidade_de_item_venda_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_8 FOREIGN KEY (venda_apenas_com_estoque_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_10 FOREIGN KEY (notafiscal_cprod_padrao_venda_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_1 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_2 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_3 FOREIGN KEY (contabil_lancamentos_tipo_id) references contabil_lancamentos_tipo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_4 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_5 FOREIGN KEY (contaspag_contabil_id) references contaspag_contabil(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_6 FOREIGN KEY (conta_corrente_lancamentos_id) references conta_corrente_lancamentos(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_7 FOREIGN KEY (contabil_lancamentos_situacao_id) references contabil_lancamentos_situacao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_8 FOREIGN KEY (contabil_lancamentos_origem_id) references contabil_lancamentos_origem(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_1 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_1 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_2 FOREIGN KEY (conta_corrente_lanc_tipo_id) references conta_corrente_lanc_tipo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (contaspag_baixas_id) references contaspag_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (contasrec_baixas_id) references contasrec_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_7 FOREIGN KEY (conta_corrente_lanc_origem_id) references conta_corrente_lanc_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_1 FOREIGN KEY (contaspag_situacao_id) references contaspag_situacao(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_3 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_4 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_5 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_7 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_3 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_bloco_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_historico_venc ADD CONSTRAINT fk_contaspag_historico_venc_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_1 FOREIGN KEY (contasrec_situacao_id) references contasrec_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_4 FOREIGN KEY (contasrec_origem_id) references contasrec_origem(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_6 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_7 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_8 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_9 FOREIGN KEY (conta_corrente_boleto_id) references conta_corrente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_10 FOREIGN KEY (boleto_situacao_id) references boleto_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_11 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_12 FOREIGN KEY (contasrec_bloco_id) references contasrec_bloco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_13 FOREIGN KEY (venda_formapgto_id) references venda_formapgto(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_14 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_4 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_5 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec_historico_cobranca ADD CONSTRAINT fk_contasrec_historico_cobranca_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_historico_venc ADD CONSTRAINT fk_contasrec_historico_venc_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE cst_icms ADD CONSTRAINT fk_cst_icms_1 FOREIGN KEY (regime_tributario_id) references notafiscal_crt(id); 
ALTER TABLE despesas_servicos ADD CONSTRAINT fk_despesas_servicos_1 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE dispositivos ADD CONSTRAINT fk_dispositivos_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_deposito ADD CONSTRAINT fk_estoque_deposito_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_estante ADD CONSTRAINT fk_estoque_estante_1 FOREIGN KEY (estoque_rua_id) references estoque_rua(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_1 FOREIGN KEY (estoque_origem_id) references estoque_origem(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_2 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_4 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_5 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_6 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_9 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE estoque_origem ADD CONSTRAINT fk_estoque_origem_1 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_prateleira ADD CONSTRAINT fk_estoque_prateleira_1 FOREIGN KEY (estoque_estante_id) references estoque_estante(id); 
ALTER TABLE estoque_rua ADD CONSTRAINT fk_estoque_rua_1 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_3 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_1 FOREIGN KEY (email_template_id) references email_template(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_2 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_1 FOREIGN KEY (eventos_id) references eventos(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_1 FOREIGN KEY (tipo_documento_id) references tipo_documento(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_3 FOREIGN KEY (meio_pagamento_tef_id) references meio_pagamento_tef(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_4 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_1 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_4 FOREIGN KEY (fornecedor_classificacao_id) references fornecedor_classificacao(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE fornecedor_classificacao ADD CONSTRAINT fk_fornecedor_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE fornecedor_contato ADD CONSTRAINT fk_fornecedor_contato_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE funcionario ADD CONSTRAINT fk_funcionario_1 FOREIGN KEY (funcionario_cargo_id) references funcionario_cargo(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_1 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_2 FOREIGN KEY (ultima_etapa) references resposta(id); 
ALTER TABLE integradores_servicos ADD CONSTRAINT fk_integradores_servicos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_1 FOREIGN KEY (mdfe_tpemit_id) references mdfe_tpemit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_2 FOREIGN KEY (mdfe_tpprop_id) references mdfe_tpprop(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_4 FOREIGN KEY (mdfe_tptransp_id) references mdfe_tptransp(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_6 FOREIGN KEY (UFIni) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_7 FOREIGN KEY (UFFim) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_8 FOREIGN KEY (indCanalVerde) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_9 FOREIGN KEY (indCarregaPosterior) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_10 FOREIGN KEY (mdfe_respSeg_id) references mdfe_respSeg(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_11 FOREIGN KEY (mdfe_cunid_id) references mdfe_cunid(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_12 FOREIGN KEY (mdfe_tpcarga_id) references mdfe_tpcarga(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_13 FOREIGN KEY (mdfe_indpag_id) references mdfe_indpag(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_14 FOREIGN KEY (indAntecipaAdiant) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_15 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veic_estado_id) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_16 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_18 FOREIGN KEY (mdfe_situacao_id) references mdfe_situacao(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_19 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_20 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_21 FOREIGN KEY (cidade_encerramento_id) references cidade(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_2 FOREIGN KEY (mdfe_tpcomp_id) references mdfe_tpcomp(id); 
ALTER TABLE mdfe_condutor ADD CONSTRAINT fk_mdfe_condutor_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_evento ADD CONSTRAINT fk_mdfe_evento_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_2 FOREIGN KEY (cidade_carrega_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_3 FOREIGN KEY (cidade_descarga_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_4 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_2 FOREIGN KEY (UFPer) references estado(id); 
ALTER TABLE mdfe_lacres ADD CONSTRAINT fk_mdfe_lacres_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_2 FOREIGN KEY (mdfe_tpAntecip_id) references mdfe_tpAntecip(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_2 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe_xmlaut ADD CONSTRAINT fk_mdfe_xmlaut_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_1 FOREIGN KEY (natureza_operacao_finalidade_id) references natureza_operacao_finalidade(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_2 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_3 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_4 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_5 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_6 FOREIGN KEY (consumidor_final_id) references resposta(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_10 FOREIGN KEY (cst_icms_nao_contribuinte_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_2 FOREIGN KEY (natop_excecao_tributo_id) references natop_excecao_tributo(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_1 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_3 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_4 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_5 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_6 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao_ncm ADD CONSTRAINT fk_natureza_operacao_ncm_1 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_1 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_1 FOREIGN KEY (negocio_origem_id) references negocio_origem(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_3 FOREIGN KEY (negocio_motivo_perda_id) references negocio_motivo_perda(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_4 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_5 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_6 FOREIGN KEY (arquivado) references resposta(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_7 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_9 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_8 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_10 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE negocio_arquivos ADD CONSTRAINT fk_negocio_arquivos_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_2 FOREIGN KEY (negocio_tipo_atividade_id) references negocio_tipo_atividade(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_2 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio_notas ADD CONSTRAINT fk_negocio_notas_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_17 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_18 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_3 FOREIGN KEY (nf_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_4 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_6 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_7 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_8 FOREIGN KEY (notafiscal_tpemis_id) references notafiscal_tpemis(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_16 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_21 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE notafiscal_autxml ADD CONSTRAINT fk_notafiscal_autxml_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_3 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_4 FOREIGN KEY (nota_fiscal_compra_situacao_id) references nota_fiscal_compra_situacao(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_7 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_8 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_13 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_14 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_3 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_4 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_9 FOREIGN KEY (nota_fiscal_compra_itens_situacao_id) references nota_fiscal_compra_itens_situacao(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_8 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_dup ADD CONSTRAINT fk_notafiscal_dup_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_frete_volumes ADD CONSTRAINT fk_notafiscal_frete_volumes_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_1 FOREIGN KEY (notafiscal_refecfmod_id) references notafiscal_refecfmod(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_refnfe ADD CONSTRAINT fk_notafiscal_refnfe_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_4 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_1 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_2 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal_situacao_sefaz ADD CONSTRAINT fk_notafiscal_situacao_sefaz_1 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_1 FOREIGN KEY (notafiscal_series_id) references notafiscal_series(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_2 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_3 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_4 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_6 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE orcamento_interacoes ADD CONSTRAINT fk_orcamento_interacoes_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_1 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_2 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_2 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_5 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_2 FOREIGN KEY (ordem_producao_etapas_situacao_id) references ordem_producao_etapas_situacao(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_3 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_2 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_8 FOREIGN KEY (usuario_aprovacao_id) references system_users(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_9 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_3 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_4 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_5 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE ordem_servico_garantia_historico ADD CONSTRAINT fk_ordem_servico_garantia_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_2 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_3 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_4 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_2 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_1 FOREIGN KEY (painel_indicadores_id) references painel_indicadores(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_2 FOREIGN KEY (indicador_personalizado_id) references indicador_personalizado(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_3 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_2 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_3 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_4 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_5 FOREIGN KEY (chave_pix_tipo_id) references chave_pix_tipo(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_1 FOREIGN KEY (plano_conta_tipo_id) references plano_conta_tipo(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_2 FOREIGN KEY (plano_conta_origem_id) references plano_conta_origem(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_2 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_3 FOREIGN KEY (unidade_medida_id) references unidade_medida(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_fabricante_id) references produto_fabricante(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_9 FOREIGN KEY (produtogrupo_subgrupo_id) references produtogrupo_subgrupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_6 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (habilitado_id) references resposta(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_tipo_id) references produto_tipo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_11 FOREIGN KEY (produto_embalagem_id) references produto_embalagem(id); 
ALTER TABLE produto_embalagem ADD CONSTRAINT fk_produto_embalagem_1 FOREIGN KEY (produto_tipo_embalagem_id) references produto_tipo_embalagem(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (estoque_prateleira_id) references estoque_prateleira(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE produto_ficha_tecnica_etapas_producao ADD CONSTRAINT fk_produto_ficha_tecnica_etapas_producao_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_3 FOREIGN KEY (estoque_deposito_padrao_id) references estoque_deposito(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_4 FOREIGN KEY (sob_encomenda_id) references resposta(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_5 FOREIGN KEY (gerar_op_venda_id) references resposta(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_preco_historico_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_filial_historico_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE produto_grupo ADD CONSTRAINT fk_produto_grupo_1 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produtogrupo_subgrupo ADD CONSTRAINT fk_produtogrupo_subgrupo_1 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto_lote ADD CONSTRAINT fk_produto_lote_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_2 FOREIGN KEY (category_id) references system_document_category(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_1 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_program_permissoes ADD CONSTRAINT fk_system_program_permissoes_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_2 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_4 FOREIGN KEY (nfe_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_5 FOREIGN KEY (nfe_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_13 FOREIGN KEY (nfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_6 FOREIGN KEY (vendas_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_7 FOREIGN KEY (nfce_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_9 FOREIGN KEY (nfe_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_10 FOREIGN KEY (nfe_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_11 FOREIGN KEY (nfce_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_12 FOREIGN KEY (nfce_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_14 FOREIGN KEY (notafiscal_cprod_padrao_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (nfce_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_3 FOREIGN KEY (nfce_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_1 FOREIGN KEY (nfce_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_16 FOREIGN KEY (mdfe_estadoini_id) references estado(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_18 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_19 FOREIGN KEY (mdfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_20 FOREIGN KEY (mdfe_homologacao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (mdfe_producao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (natureza_operacao_compra_id) references natureza_operacao(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_pdv_permissoes ADD CONSTRAINT fk_system_user_permissoes_pdv_2 FOREIGN KEY (pdv_permissoes_id) references pdv_permissoes(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_2 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_2 FOREIGN KEY (frontpage_id) references system_program(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_1 FOREIGN KEY (tabela_preco_tipo_alteracao_id) references tabela_preco_tipo_alteracao(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_2 FOREIGN KEY (tabela_preco_tipo_id) references tabela_preco_tipo(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_1 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_3 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_4 FOREIGN KEY (veiculo_tipo_id) references veiculo_tipo(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (funcionario_motorista_id) references funcionario(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_2 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_3 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_5 FOREIGN KEY (filial_saida_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_6 FOREIGN KEY (venda_modalidade_id) references venda_modalidade(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_7 FOREIGN KEY (venda_tipo_pagamento_id) references venda_tipo_pagamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_8 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_9 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_10 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_12 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_3 FOREIGN KEY (cancelado) references resposta(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_5 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_1 FOREIGN KEY (venda_meta_situacao_id) references venda_meta_situacao(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_1 FOREIGN KEY (venda_meta_id) references venda_meta(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_1 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_1 FOREIGN KEY (vendedor_tipo_comissao_id) references vendedor_tipo_comissao(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_2 FOREIGN KEY (vendedor_tipo_pgto_comissao_id) references vendedor_tipo_pgto_comissao(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_2 FOREIGN KEY (system_user_id) references system_users(id); 
 CREATE SEQUENCE api_documentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER api_documentos_id_seq_tr 

BEFORE INSERT ON api_documentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT api_documentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE apidocumentos_integradoresservicos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER apidocumentos_integradoresservicos_id_seq_tr 

BEFORE INSERT ON apidocumentos_integradoresservicos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT apidocumentos_integradoresservicos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE api_error_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER api_error_id_seq_tr 

BEFORE INSERT ON api_error FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT api_error_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ativo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ativo_id_seq_tr 

BEFORE INSERT ON ativo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ativo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE banco_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER banco_id_seq_tr 

BEFORE INSERT ON banco FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT banco_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE boleto_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER boleto_situacao_id_seq_tr 

BEFORE INSERT ON boleto_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT boleto_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE caixa_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER caixa_id_seq_tr 

BEFORE INSERT ON caixa FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT caixa_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE caixa_lancamentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER caixa_lancamentos_id_seq_tr 

BEFORE INSERT ON caixa_lancamentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT caixa_lancamentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE caixa_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER caixa_situacao_id_seq_tr 

BEFORE INSERT ON caixa_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT caixa_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE caixa_tipo_lancamento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER caixa_tipo_lancamento_id_seq_tr 

BEFORE INSERT ON caixa_tipo_lancamento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT caixa_tipo_lancamento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE centro_custo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER centro_custo_id_seq_tr 

BEFORE INSERT ON centro_custo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT centro_custo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE centro_custo_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER centro_custo_tipo_id_seq_tr 

BEFORE INSERT ON centro_custo_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT centro_custo_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cep_cache_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cep_cache_id_seq_tr 

BEFORE INSERT ON cep_cache FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cep_cache_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_agendamentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_agendamentos_id_seq_tr 

BEFORE INSERT ON certificado_agendamentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_agendamentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_agente_registro_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_agente_registro_id_seq_tr 

BEFORE INSERT ON certificado_agente_registro FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_agente_registro_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_cliente_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_cliente_id_seq_tr 

BEFORE INSERT ON certificado_cliente FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_cliente_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_cliente_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_cliente_situacao_id_seq_tr 

BEFORE INSERT ON certificado_cliente_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_cliente_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_email_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_email_historico_id_seq_tr 

BEFORE INSERT ON certificado_email_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_email_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificadora_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificadora_id_seq_tr 

BEFORE INSERT ON certificadora FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificadora_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificadora_produtos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificadora_produtos_id_seq_tr 

BEFORE INSERT ON certificadora_produtos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificadora_produtos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_tipo_atendimento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_tipo_atendimento_id_seq_tr 

BEFORE INSERT ON certificado_tipo_atendimento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_tipo_atendimento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_tipo_repasse_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_tipo_repasse_id_seq_tr 

BEFORE INSERT ON certificado_tipo_repasse FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_tipo_repasse_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_venda_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_venda_id_seq_tr 

BEFORE INSERT ON certificado_venda FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_venda_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_venda_documentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_venda_documentos_id_seq_tr 

BEFORE INSERT ON certificado_venda_documentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_venda_documentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_venda_formapgto_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_venda_formapgto_id_seq_tr 

BEFORE INSERT ON certificado_venda_formapgto FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_venda_formapgto_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_venda_modalidade_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_venda_modalidade_id_seq_tr 

BEFORE INSERT ON certificado_venda_modalidade FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_venda_modalidade_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_venda_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_venda_situacao_id_seq_tr 

BEFORE INSERT ON certificado_venda_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_venda_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE certificado_venda_tipomodalidade_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER certificado_venda_tipomodalidade_id_seq_tr 

BEFORE INSERT ON certificado_venda_tipomodalidade FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT certificado_venda_tipomodalidade_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cfop_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cfop_id_seq_tr 

BEFORE INSERT ON cfop FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cfop_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE chave_pix_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER chave_pix_tipo_id_seq_tr 

BEFORE INSERT ON chave_pix_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT chave_pix_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cidade_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cidade_id_seq_tr 

BEFORE INSERT ON cidade FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cidade_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cliente_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cliente_id_seq_tr 

BEFORE INSERT ON cliente FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cliente_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cliente_classificacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cliente_classificacao_id_seq_tr 

BEFORE INSERT ON cliente_classificacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cliente_classificacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cliente_classificacao_subgrupo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cliente_classificacao_subgrupo_id_seq_tr 

BEFORE INSERT ON cliente_classificacao_subgrupo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cliente_classificacao_subgrupo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cliente_contato_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cliente_contato_id_seq_tr 

BEFORE INSERT ON cliente_contato FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cliente_contato_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cliente_endereco_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cliente_endereco_id_seq_tr 

BEFORE INSERT ON cliente_endereco FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cliente_endereco_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cliente_historico_limite_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cliente_historico_limite_id_seq_tr 

BEFORE INSERT ON cliente_historico_limite FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cliente_historico_limite_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cliente_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cliente_situacao_id_seq_tr 

BEFORE INSERT ON cliente_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cliente_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE condicao_pagamento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER condicao_pagamento_id_seq_tr 

BEFORE INSERT ON condicao_pagamento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT condicao_pagamento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE configuracoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER configuracoes_id_seq_tr 

BEFORE INSERT ON configuracoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT configuracoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE configuracoes_filial_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER configuracoes_filial_id_seq_tr 

BEFORE INSERT ON configuracoes_filial FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT configuracoes_filial_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contabil_lancamentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contabil_lancamentos_id_seq_tr 

BEFORE INSERT ON contabil_lancamentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contabil_lancamentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contabil_lancamentos_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contabil_lancamentos_origem_id_seq_tr 

BEFORE INSERT ON contabil_lancamentos_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contabil_lancamentos_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contabil_lancamentos_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contabil_lancamentos_situacao_id_seq_tr 

BEFORE INSERT ON contabil_lancamentos_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contabil_lancamentos_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contabil_lancamentos_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contabil_lancamentos_tipo_id_seq_tr 

BEFORE INSERT ON contabil_lancamentos_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contabil_lancamentos_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE conta_corrente_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER conta_corrente_id_seq_tr 

BEFORE INSERT ON conta_corrente FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT conta_corrente_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE conta_corrente_lancamentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER conta_corrente_lancamentos_id_seq_tr 

BEFORE INSERT ON conta_corrente_lancamentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT conta_corrente_lancamentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE conta_corrente_lanc_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER conta_corrente_lanc_origem_id_seq_tr 

BEFORE INSERT ON conta_corrente_lanc_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT conta_corrente_lanc_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE conta_corrente_lanc_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER conta_corrente_lanc_tipo_id_seq_tr 

BEFORE INSERT ON conta_corrente_lanc_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT conta_corrente_lanc_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_id_seq_tr 

BEFORE INSERT ON contaspag FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_anexos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_anexos_id_seq_tr 

BEFORE INSERT ON contaspag_anexos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_anexos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_baixas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_baixas_id_seq_tr 

BEFORE INSERT ON contaspag_baixas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_baixas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_bloco_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_bloco_id_seq_tr 

BEFORE INSERT ON contaspag_bloco FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_bloco_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_bloco_contabil_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_bloco_contabil_id_seq_tr 

BEFORE INSERT ON contaspag_bloco_contabil FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_bloco_contabil_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_contabil_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_contabil_id_seq_tr 

BEFORE INSERT ON contaspag_contabil FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_contabil_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_historico_venc_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_historico_venc_id_seq_tr 

BEFORE INSERT ON contaspag_historico_venc FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_historico_venc_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_origem_id_seq_tr 

BEFORE INSERT ON contaspag_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contaspag_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contaspag_situacao_id_seq_tr 

BEFORE INSERT ON contaspag_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contaspag_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_id_seq_tr 

BEFORE INSERT ON contasrec FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_anexos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_anexos_id_seq_tr 

BEFORE INSERT ON contasrec_anexos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_anexos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_baixas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_baixas_id_seq_tr 

BEFORE INSERT ON contasrec_baixas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_baixas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_bloco_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_bloco_id_seq_tr 

BEFORE INSERT ON contasrec_bloco FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_bloco_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_historico_cobranca_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_historico_cobranca_id_seq_tr 

BEFORE INSERT ON contasrec_historico_cobranca FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_historico_cobranca_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_historico_venc_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_historico_venc_id_seq_tr 

BEFORE INSERT ON contasrec_historico_venc FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_historico_venc_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_origem_id_seq_tr 

BEFORE INSERT ON contasrec_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE contasrec_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER contasrec_situacao_id_seq_tr 

BEFORE INSERT ON contasrec_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT contasrec_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cst_cofins_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cst_cofins_id_seq_tr 

BEFORE INSERT ON cst_cofins FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cst_cofins_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cst_icms_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cst_icms_id_seq_tr 

BEFORE INSERT ON cst_icms FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cst_icms_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cst_ipi_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cst_ipi_id_seq_tr 

BEFORE INSERT ON cst_ipi FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cst_ipi_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE cst_pis_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER cst_pis_id_seq_tr 

BEFORE INSERT ON cst_pis FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT cst_pis_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE despesas_servicos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER despesas_servicos_id_seq_tr 

BEFORE INSERT ON despesas_servicos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT despesas_servicos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE despesas_servicos_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER despesas_servicos_tipo_id_seq_tr 

BEFORE INSERT ON despesas_servicos_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT despesas_servicos_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE dispositivos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER dispositivos_id_seq_tr 

BEFORE INSERT ON dispositivos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT dispositivos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE email_template_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER email_template_id_seq_tr 

BEFORE INSERT ON email_template FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT email_template_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estado_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estado_id_seq_tr 

BEFORE INSERT ON estado FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estado_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_deposito_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_deposito_id_seq_tr 

BEFORE INSERT ON estoque_deposito FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_deposito_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_estante_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_estante_id_seq_tr 

BEFORE INSERT ON estoque_estante FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_estante_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_lancamentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_lancamentos_id_seq_tr 

BEFORE INSERT ON estoque_lancamentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_lancamentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_origem_id_seq_tr 

BEFORE INSERT ON estoque_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_prateleira_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_prateleira_id_seq_tr 

BEFORE INSERT ON estoque_prateleira FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_prateleira_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_rua_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_rua_id_seq_tr 

BEFORE INSERT ON estoque_rua FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_rua_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_saldos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_saldos_id_seq_tr 

BEFORE INSERT ON estoque_saldos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_saldos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE estoque_tipo_movimentacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER estoque_tipo_movimentacao_id_seq_tr 

BEFORE INSERT ON estoque_tipo_movimentacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT estoque_tipo_movimentacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE eventos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER eventos_id_seq_tr 

BEFORE INSERT ON eventos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT eventos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE eventos_documentos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER eventos_documentos_id_seq_tr 

BEFORE INSERT ON eventos_documentos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT eventos_documentos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE eventos_systemuser_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER eventos_systemuser_id_seq_tr 

BEFORE INSERT ON eventos_systemuser FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT eventos_systemuser_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE forma_pagamento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER forma_pagamento_id_seq_tr 

BEFORE INSERT ON forma_pagamento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT forma_pagamento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE formapgto_condpgto_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER formapgto_condpgto_id_seq_tr 

BEFORE INSERT ON formapgto_condpgto FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT formapgto_condpgto_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE fornecedor_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER fornecedor_id_seq_tr 

BEFORE INSERT ON fornecedor FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT fornecedor_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE fornecedor_classificacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER fornecedor_classificacao_id_seq_tr 

BEFORE INSERT ON fornecedor_classificacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT fornecedor_classificacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE fornecedor_contato_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER fornecedor_contato_id_seq_tr 

BEFORE INSERT ON fornecedor_contato FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT fornecedor_contato_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE funcionario_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER funcionario_id_seq_tr 

BEFORE INSERT ON funcionario FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT funcionario_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE funcionario_cargo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER funcionario_cargo_id_seq_tr 

BEFORE INSERT ON funcionario_cargo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT funcionario_cargo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE funil_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER funil_id_seq_tr 

BEFORE INSERT ON funil FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT funil_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE funil_etapas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER funil_etapas_id_seq_tr 

BEFORE INSERT ON funil_etapas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT funil_etapas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE indicador_personalizado_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER indicador_personalizado_id_seq_tr 

BEFORE INSERT ON indicador_personalizado FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT indicador_personalizado_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE integradores_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER integradores_id_seq_tr 

BEFORE INSERT ON integradores FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT integradores_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE integradores_servicos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER integradores_servicos_id_seq_tr 

BEFORE INSERT ON integradores_servicos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT integradores_servicos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE inutilizar_numero_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER inutilizar_numero_id_seq_tr 

BEFORE INSERT ON inutilizar_numero FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT inutilizar_numero_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_id_seq_tr 

BEFORE INSERT ON mdfe FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_componentes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_componentes_id_seq_tr 

BEFORE INSERT ON mdfe_componentes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_componentes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_condutor_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_condutor_id_seq_tr 

BEFORE INSERT ON mdfe_condutor FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_condutor_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_ctes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_ctes_id_seq_tr 

BEFORE INSERT ON mdfe_ctes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_ctes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_cunid_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_cunid_id_seq_tr 

BEFORE INSERT ON mdfe_cunid FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_cunid_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_evento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_evento_id_seq_tr 

BEFORE INSERT ON mdfe_evento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_evento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_inclusao_dfe_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_inclusao_dfe_id_seq_tr 

BEFORE INSERT ON mdfe_inclusao_dfe FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_inclusao_dfe_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_indpag_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_indpag_id_seq_tr 

BEFORE INSERT ON mdfe_indpag FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_indpag_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_infmuncarrega_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_infmuncarrega_id_seq_tr 

BEFORE INSERT ON mdfe_infmuncarrega FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_infmuncarrega_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_infmundescarga_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_infmundescarga_id_seq_tr 

BEFORE INSERT ON mdfe_infmundescarga FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_infmundescarga_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_infpercurso_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_infpercurso_id_seq_tr 

BEFORE INSERT ON mdfe_infpercurso FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_infpercurso_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_lacres_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_lacres_id_seq_tr 

BEFORE INSERT ON mdfe_lacres FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_lacres_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_logs_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_logs_id_seq_tr 

BEFORE INSERT ON mdfe_logs FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_logs_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_mdfes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_mdfes_id_seq_tr 

BEFORE INSERT ON mdfe_mdfes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_mdfes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_nfes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_nfes_id_seq_tr 

BEFORE INSERT ON mdfe_nfes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_nfes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_parcelas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_parcelas_id_seq_tr 

BEFORE INSERT ON mdfe_parcelas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_parcelas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_respSeg_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_respSeg_id_seq_tr 

BEFORE INSERT ON mdfe_respSeg FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_respSeg_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_series_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_series_id_seq_tr 

BEFORE INSERT ON mdfe_series FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_series_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_situacao_id_seq_tr 

BEFORE INSERT ON mdfe_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpamb_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpamb_id_seq_tr 

BEFORE INSERT ON mdfe_tpamb FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpamb_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpAntecip_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpAntecip_id_seq_tr 

BEFORE INSERT ON mdfe_tpAntecip FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpAntecip_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpcar_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpcar_id_seq_tr 

BEFORE INSERT ON mdfe_tpcar FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpcar_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpcarga_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpcarga_id_seq_tr 

BEFORE INSERT ON mdfe_tpcarga FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpcarga_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpcomp_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpcomp_id_seq_tr 

BEFORE INSERT ON mdfe_tpcomp FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpcomp_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpemit_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpemit_id_seq_tr 

BEFORE INSERT ON mdfe_tpemit FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpemit_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpprop_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpprop_id_seq_tr 

BEFORE INSERT ON mdfe_tpprop FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpprop_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tpRod_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tpRod_id_seq_tr 

BEFORE INSERT ON mdfe_tpRod FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tpRod_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_tptransp_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_tptransp_id_seq_tr 

BEFORE INSERT ON mdfe_tptransp FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_tptransp_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE mdfe_xmlaut_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER mdfe_xmlaut_id_seq_tr 

BEFORE INSERT ON mdfe_xmlaut FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT mdfe_xmlaut_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE meio_pagamento_tef_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER meio_pagamento_tef_id_seq_tr 

BEFORE INSERT ON meio_pagamento_tef FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT meio_pagamento_tef_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE movimentacao_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER movimentacao_origem_id_seq_tr 

BEFORE INSERT ON movimentacao_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT movimentacao_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natop_excecao_tributo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natop_excecao_tributo_id_seq_tr 

BEFORE INSERT ON natop_excecao_tributo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natop_excecao_tributo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natureza_operacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natureza_operacao_id_seq_tr 

BEFORE INSERT ON natureza_operacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natureza_operacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natureza_operacao_estados_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natureza_operacao_estados_id_seq_tr 

BEFORE INSERT ON natureza_operacao_estados FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natureza_operacao_estados_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natureza_operacao_excecao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natureza_operacao_excecao_id_seq_tr 

BEFORE INSERT ON natureza_operacao_excecao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natureza_operacao_excecao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natureza_operacao_finalidade_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natureza_operacao_finalidade_id_seq_tr 

BEFORE INSERT ON natureza_operacao_finalidade FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natureza_operacao_finalidade_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natureza_operacao_ncm_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natureza_operacao_ncm_id_seq_tr 

BEFORE INSERT ON natureza_operacao_ncm FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natureza_operacao_ncm_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natureza_operacao_origens_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natureza_operacao_origens_id_seq_tr 

BEFORE INSERT ON natureza_operacao_origens FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natureza_operacao_origens_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE natureza_operacao_produtos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER natureza_operacao_produtos_id_seq_tr 

BEFORE INSERT ON natureza_operacao_produtos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT natureza_operacao_produtos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_id_seq_tr 

BEFORE INSERT ON negocio FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_arquivos_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_arquivos_id_seq_tr 

BEFORE INSERT ON negocio_arquivos FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_arquivos_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_atividade_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_atividade_id_seq_tr 

BEFORE INSERT ON negocio_atividade FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_atividade_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_etapas_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_etapas_historico_id_seq_tr 

BEFORE INSERT ON negocio_etapas_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_etapas_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_itens_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_itens_id_seq_tr 

BEFORE INSERT ON negocio_itens FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_itens_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_motivo_perda_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_motivo_perda_id_seq_tr 

BEFORE INSERT ON negocio_motivo_perda FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_motivo_perda_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_notas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_notas_id_seq_tr 

BEFORE INSERT ON negocio_notas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_notas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_origem_id_seq_tr 

BEFORE INSERT ON negocio_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE negocio_tipo_atividade_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER negocio_tipo_atividade_id_seq_tr 

BEFORE INSERT ON negocio_tipo_atividade FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT negocio_tipo_atividade_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_id_seq_tr 

BEFORE INSERT ON notafiscal FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_autxml_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_autxml_id_seq_tr 

BEFORE INSERT ON notafiscal_autxml FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_autxml_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE nota_fiscal_compra_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER nota_fiscal_compra_id_seq_tr 

BEFORE INSERT ON nota_fiscal_compra FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT nota_fiscal_compra_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE nota_fiscal_compra_dup_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER nota_fiscal_compra_dup_id_seq_tr 

BEFORE INSERT ON nota_fiscal_compra_dup FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT nota_fiscal_compra_dup_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE nota_fiscal_compra_itens_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER nota_fiscal_compra_itens_id_seq_tr 

BEFORE INSERT ON nota_fiscal_compra_itens FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT nota_fiscal_compra_itens_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE nota_fiscal_compra_itens_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER nota_fiscal_compra_itens_situacao_id_seq_tr 

BEFORE INSERT ON nota_fiscal_compra_itens_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT nota_fiscal_compra_itens_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE nota_fiscal_compra_pag_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER nota_fiscal_compra_pag_id_seq_tr 

BEFORE INSERT ON nota_fiscal_compra_pag FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT nota_fiscal_compra_pag_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE nota_fiscal_compra_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER nota_fiscal_compra_situacao_id_seq_tr 

BEFORE INSERT ON nota_fiscal_compra_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT nota_fiscal_compra_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_cprod_padrao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_cprod_padrao_id_seq_tr 

BEFORE INSERT ON notafiscal_cprod_padrao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_cprod_padrao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_crt_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_crt_id_seq_tr 

BEFORE INSERT ON notafiscal_crt FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_crt_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_dup_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_dup_id_seq_tr 

BEFORE INSERT ON notafiscal_dup FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_dup_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_finnfe_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_finnfe_id_seq_tr 

BEFORE INSERT ON notafiscal_finnfe FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_finnfe_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_frete_volumes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_frete_volumes_id_seq_tr 

BEFORE INSERT ON notafiscal_frete_volumes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_frete_volumes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_iddest_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_iddest_id_seq_tr 

BEFORE INSERT ON notafiscal_iddest FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_iddest_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_indfinal_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_indfinal_id_seq_tr 

BEFORE INSERT ON notafiscal_indfinal FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_indfinal_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_indiedest_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_indiedest_id_seq_tr 

BEFORE INSERT ON notafiscal_indiedest FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_indiedest_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_indpag_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_indpag_id_seq_tr 

BEFORE INSERT ON notafiscal_indpag FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_indpag_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_indpres_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_indpres_id_seq_tr 

BEFORE INSERT ON notafiscal_indpres FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_indpres_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_item_indtot_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_item_indtot_id_seq_tr 

BEFORE INSERT ON notafiscal_item_indtot FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_item_indtot_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_item_modbc_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_item_modbc_id_seq_tr 

BEFORE INSERT ON notafiscal_item_modbc FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_item_modbc_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_item_modbcst_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_item_modbcst_id_seq_tr 

BEFORE INSERT ON notafiscal_item_modbcst FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_item_modbcst_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_item_motDesICMS_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_item_motDesICMS_id_seq_tr 

BEFORE INSERT ON notafiscal_item_motDesICMS FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_item_motDesICMS_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_item_orig_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_item_orig_id_seq_tr 

BEFORE INSERT ON notafiscal_item_orig FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_item_orig_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_itens_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_itens_id_seq_tr 

BEFORE INSERT ON notafiscal_itens FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_itens_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_logs_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_logs_id_seq_tr 

BEFORE INSERT ON notafiscal_logs FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_logs_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_mod_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_mod_id_seq_tr 

BEFORE INSERT ON notafiscal_mod FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_mod_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_modfrete_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_modfrete_id_seq_tr 

BEFORE INSERT ON notafiscal_modfrete FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_modfrete_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_pag_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_pag_id_seq_tr 

BEFORE INSERT ON notafiscal_pag FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_pag_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_refecf_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_refecf_id_seq_tr 

BEFORE INSERT ON notafiscal_refecf FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_refecf_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_refecfmod_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_refecfmod_id_seq_tr 

BEFORE INSERT ON notafiscal_refecfmod FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_refecfmod_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_refnfe_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_refnfe_id_seq_tr 

BEFORE INSERT ON notafiscal_refnfe FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_refnfe_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_series_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_series_id_seq_tr 

BEFORE INSERT ON notafiscal_series FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_series_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_situacao_id_seq_tr 

BEFORE INSERT ON notafiscal_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_situacao_sefaz_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_situacao_sefaz_id_seq_tr 

BEFORE INSERT ON notafiscal_situacao_sefaz FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_situacao_sefaz_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_tipodoc_series_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_tipodoc_series_id_seq_tr 

BEFORE INSERT ON notafiscal_tipodoc_series FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_tipodoc_series_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_tipodocumento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_tipodocumento_id_seq_tr 

BEFORE INSERT ON notafiscal_tipodocumento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_tipodocumento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_tpag_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_tpag_id_seq_tr 

BEFORE INSERT ON notafiscal_tpag FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_tpag_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_tpamb_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_tpamb_id_seq_tr 

BEFORE INSERT ON notafiscal_tpamb FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_tpamb_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_tpemis_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_tpemis_id_seq_tr 

BEFORE INSERT ON notafiscal_tpemis FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_tpemis_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE notafiscal_tpimp_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER notafiscal_tpimp_id_seq_tr 

BEFORE INSERT ON notafiscal_tpimp FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT notafiscal_tpimp_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE orcamento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER orcamento_id_seq_tr 

BEFORE INSERT ON orcamento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT orcamento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE orcamento_interacoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER orcamento_interacoes_id_seq_tr 

BEFORE INSERT ON orcamento_interacoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT orcamento_interacoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE orcamento_item_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER orcamento_item_id_seq_tr 

BEFORE INSERT ON orcamento_item FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT orcamento_item_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE orcamento_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER orcamento_situacao_id_seq_tr 

BEFORE INSERT ON orcamento_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT orcamento_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE orcamento_situacao_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER orcamento_situacao_historico_id_seq_tr 

BEFORE INSERT ON orcamento_situacao_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT orcamento_situacao_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_producao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_producao_id_seq_tr 

BEFORE INSERT ON ordem_producao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_producao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_producao_etapas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_producao_etapas_id_seq_tr 

BEFORE INSERT ON ordem_producao_etapas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_producao_etapas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_producao_etapas_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_producao_etapas_situacao_id_seq_tr 

BEFORE INSERT ON ordem_producao_etapas_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_producao_etapas_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_producao_itens_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_producao_itens_id_seq_tr 

BEFORE INSERT ON ordem_producao_itens FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_producao_itens_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_producao_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_producao_situacao_id_seq_tr 

BEFORE INSERT ON ordem_producao_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_producao_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_producao_situacao_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_producao_situacao_historico_id_seq_tr 

BEFORE INSERT ON ordem_producao_situacao_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_producao_situacao_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_producao_vendas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_producao_vendas_id_seq_tr 

BEFORE INSERT ON ordem_producao_vendas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_producao_vendas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_id_seq_tr 

BEFORE INSERT ON ordem_servico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_garantia_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_garantia_historico_id_seq_tr 

BEFORE INSERT ON ordem_servico_garantia_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_garantia_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_historico_id_seq_tr 

BEFORE INSERT ON ordem_servico_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_item_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_item_id_seq_tr 

BEFORE INSERT ON ordem_servico_item FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_item_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_item_despesas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_item_despesas_id_seq_tr 

BEFORE INSERT ON ordem_servico_item_despesas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_item_despesas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_item_ficha_tecnica_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_item_ficha_tecnica_id_seq_tr 

BEFORE INSERT ON ordem_servico_item_ficha_tecnica FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_item_ficha_tecnica_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_item_mao_obra_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_item_mao_obra_id_seq_tr 

BEFORE INSERT ON ordem_servico_item_mao_obra FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_item_mao_obra_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_item_obs_etapas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_item_obs_etapas_id_seq_tr 

BEFORE INSERT ON ordem_servico_item_obs_etapas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_item_obs_etapas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_producao_etapa_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_producao_etapa_id_seq_tr 

BEFORE INSERT ON ordem_servico_producao_etapa FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_producao_etapa_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_situacao_id_seq_tr 

BEFORE INSERT ON ordem_servico_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE ordem_servico_venda_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER ordem_servico_venda_id_seq_tr 

BEFORE INSERT ON ordem_servico_venda FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT ordem_servico_venda_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE painel_indicadores_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER painel_indicadores_id_seq_tr 

BEFORE INSERT ON painel_indicadores FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT painel_indicadores_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE painel_indicador_usuario_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER painel_indicador_usuario_id_seq_tr 

BEFORE INSERT ON painel_indicador_usuario FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT painel_indicador_usuario_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE pais_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER pais_id_seq_tr 

BEFORE INSERT ON pais FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT pais_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE parceiro_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER parceiro_id_seq_tr 

BEFORE INSERT ON parceiro FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT parceiro_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE pdv_permissoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER pdv_permissoes_id_seq_tr 

BEFORE INSERT ON pdv_permissoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT pdv_permissoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE pedido_evento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER pedido_evento_id_seq_tr 

BEFORE INSERT ON pedido_evento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT pedido_evento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE pessoa_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER pessoa_tipo_id_seq_tr 

BEFORE INSERT ON pessoa_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT pessoa_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE plano_conta_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER plano_conta_id_seq_tr 

BEFORE INSERT ON plano_conta FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT plano_conta_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE plano_conta_origem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER plano_conta_origem_id_seq_tr 

BEFORE INSERT ON plano_conta_origem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT plano_conta_origem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE plano_conta_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER plano_conta_tipo_id_seq_tr 

BEFORE INSERT ON plano_conta_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT plano_conta_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_id_seq_tr 

BEFORE INSERT ON produto FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_embalagem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_embalagem_id_seq_tr 

BEFORE INSERT ON produto_embalagem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_embalagem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_enderecamento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_enderecamento_id_seq_tr 

BEFORE INSERT ON produto_enderecamento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_enderecamento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_etiqueta_configuracoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_etiqueta_configuracoes_id_seq_tr 

BEFORE INSERT ON produto_etiqueta_configuracoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_etiqueta_configuracoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_fabricante_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_fabricante_id_seq_tr 

BEFORE INSERT ON produto_fabricante FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_fabricante_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_ficha_tecnica_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_ficha_tecnica_id_seq_tr 

BEFORE INSERT ON produto_ficha_tecnica FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_ficha_tecnica_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_ficha_tecnica_despesas_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_ficha_tecnica_despesas_id_seq_tr 

BEFORE INSERT ON produto_ficha_tecnica_despesas FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_ficha_tecnica_despesas_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_ficha_tecnica_etapas_producao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_ficha_tecnica_etapas_producao_id_seq_tr 

BEFORE INSERT ON produto_ficha_tecnica_etapas_producao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_ficha_tecnica_etapas_producao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_ficha_tecnica_itens_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_ficha_tecnica_itens_id_seq_tr 

BEFORE INSERT ON produto_ficha_tecnica_itens FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_ficha_tecnica_itens_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_ficha_tecnica_mao_obra_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_ficha_tecnica_mao_obra_id_seq_tr 

BEFORE INSERT ON produto_ficha_tecnica_mao_obra FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_ficha_tecnica_mao_obra_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_filial_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_filial_id_seq_tr 

BEFORE INSERT ON produto_filial FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_filial_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_filial_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_filial_historico_id_seq_tr 

BEFORE INSERT ON produto_filial_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_filial_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_fornecedor_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_fornecedor_id_seq_tr 

BEFORE INSERT ON produto_fornecedor FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_fornecedor_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_grupo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_grupo_id_seq_tr 

BEFORE INSERT ON produto_grupo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_grupo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produtogrupo_subgrupo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produtogrupo_subgrupo_id_seq_tr 

BEFORE INSERT ON produtogrupo_subgrupo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produtogrupo_subgrupo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_lote_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_lote_id_seq_tr 

BEFORE INSERT ON produto_lote FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_lote_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_tipo_id_seq_tr 

BEFORE INSERT ON produto_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE produto_tipo_embalagem_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER produto_tipo_embalagem_id_seq_tr 

BEFORE INSERT ON produto_tipo_embalagem FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT produto_tipo_embalagem_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE resposta_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER resposta_id_seq_tr 

BEFORE INSERT ON resposta FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT resposta_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE servico_formapgto_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER servico_formapgto_id_seq_tr 

BEFORE INSERT ON servico_formapgto FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT servico_formapgto_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE system_group_program_permissoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER system_group_program_permissoes_id_seq_tr 

BEFORE INSERT ON system_group_program_permissoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT system_group_program_permissoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE system_program_permissoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER system_program_permissoes_id_seq_tr 

BEFORE INSERT ON system_program_permissoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT system_program_permissoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE system_user_pdv_permissoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER system_user_pdv_permissoes_id_seq_tr 

BEFORE INSERT ON system_user_pdv_permissoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT system_user_pdv_permissoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE system_user_program_permissoes_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER system_user_program_permissoes_id_seq_tr 

BEFORE INSERT ON system_user_program_permissoes FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT system_user_program_permissoes_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE tabela_preco_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER tabela_preco_id_seq_tr 

BEFORE INSERT ON tabela_preco FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT tabela_preco_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE tabela_preco_produto_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER tabela_preco_produto_id_seq_tr 

BEFORE INSERT ON tabela_preco_produto FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT tabela_preco_produto_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE tabela_preco_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER tabela_preco_tipo_id_seq_tr 

BEFORE INSERT ON tabela_preco_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT tabela_preco_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE tabela_preco_tipo_alteracao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER tabela_preco_tipo_alteracao_id_seq_tr 

BEFORE INSERT ON tabela_preco_tipo_alteracao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT tabela_preco_tipo_alteracao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE tipo_documento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER tipo_documento_id_seq_tr 

BEFORE INSERT ON tipo_documento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT tipo_documento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE tipo_recurso_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER tipo_recurso_id_seq_tr 

BEFORE INSERT ON tipo_recurso FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT tipo_recurso_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE titulos_tipo_anexo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER titulos_tipo_anexo_id_seq_tr 

BEFORE INSERT ON titulos_tipo_anexo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT titulos_tipo_anexo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE unidade_medida_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER unidade_medida_id_seq_tr 

BEFORE INSERT ON unidade_medida FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT unidade_medida_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE veiculo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER veiculo_id_seq_tr 

BEFORE INSERT ON veiculo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT veiculo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE veiculo_tipo_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER veiculo_tipo_id_seq_tr 

BEFORE INSERT ON veiculo_tipo FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT veiculo_tipo_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_id_seq_tr 

BEFORE INSERT ON venda FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_devolucao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_devolucao_id_seq_tr 

BEFORE INSERT ON venda_devolucao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_devolucao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_devolucao_itens_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_devolucao_itens_id_seq_tr 

BEFORE INSERT ON venda_devolucao_itens FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_devolucao_itens_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_devolucao_troca_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_devolucao_troca_id_seq_tr 

BEFORE INSERT ON venda_devolucao_troca FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_devolucao_troca_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_formapgto_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_formapgto_id_seq_tr 

BEFORE INSERT ON venda_formapgto FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_formapgto_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_item_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_item_id_seq_tr 

BEFORE INSERT ON venda_item FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_item_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_meta_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_meta_id_seq_tr 

BEFORE INSERT ON venda_meta FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_meta_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_meta_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_meta_situacao_id_seq_tr 

BEFORE INSERT ON venda_meta_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_meta_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_meta_vendedor_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_meta_vendedor_id_seq_tr 

BEFORE INSERT ON venda_meta_vendedor FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_meta_vendedor_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_modalidade_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_modalidade_id_seq_tr 

BEFORE INSERT ON venda_modalidade FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_modalidade_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_situacao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_situacao_id_seq_tr 

BEFORE INSERT ON venda_situacao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_situacao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_situacao_historico_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_situacao_historico_id_seq_tr 

BEFORE INSERT ON venda_situacao_historico FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_situacao_historico_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE venda_tipo_pagamento_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER venda_tipo_pagamento_id_seq_tr 

BEFORE INSERT ON venda_tipo_pagamento FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT venda_tipo_pagamento_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE vendedor_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER vendedor_id_seq_tr 

BEFORE INSERT ON vendedor FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT vendedor_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE vendedor_tipo_comissao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER vendedor_tipo_comissao_id_seq_tr 

BEFORE INSERT ON vendedor_tipo_comissao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT vendedor_tipo_comissao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE vendedor_tipo_pgto_comissao_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER vendedor_tipo_pgto_comissao_id_seq_tr 

BEFORE INSERT ON vendedor_tipo_pgto_comissao FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT vendedor_tipo_pgto_comissao_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
CREATE SEQUENCE xml_contador_id_seq START WITH 1 INCREMENT BY 1; 

CREATE OR REPLACE TRIGGER xml_contador_id_seq_tr 

BEFORE INSERT ON xml_contador FOR EACH ROW 

    WHEN 

        (NEW.id IS NULL) 

    BEGIN 

        SELECT xml_contador_id_seq.NEXTVAL INTO :NEW.id FROM DUAL; 

END;
 
 CREATE VIEW view_consulta_contabil_por_data AS select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento data_vencimento,
	   p.data_pagamento data_pagamento,
	   p.criado_em data_lancamento
from contaspag p,
	 contaspag_contabil cc,
	 contabil_lancamentos cl
where p.id = cc.contaspag_id 
and   cl.contaspag_contabil_id = cc.id
and   p.deletado_em is null
and   cc.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento  data_vencimento,
	   p.data_pagamento  data_pagamento,
	   p.criado_em  data_lancamento
from contasrec p,
	 contabil_lancamentos cl
where cl.contasrec_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_lancamento  data_vencimento,
	   p.data_lancamento  data_pagamento,
	   p.data_lancamento  data_lancamento
from conta_corrente_lancamentos p,
	 contabil_lancamentos cl
where cl.conta_corrente_lancamentos_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
; 

CREATE VIEW view_negocio_timeline AS SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'nota' as "tipo"
FROM negocio_notas

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'arquivo' as "tipo"
FROM negocio_arquivos

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'atividade' as "tipo"
FROM negocio_atividade

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'produto' as "tipo"
FROM negocio_itens

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'etapa' as "tipo"
FROM negocio_etapas_historico
; 

CREATE VIEW vw_caixa_resumo AS select c.caixa_id AS caixa_id,
		'Fundo de Caixa' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 3) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Entradas' AS tipo,
        coalesce(sum(c.valor), 0) AS valor 
        from caixa_lancamentos c where (c.caixa_tipo_lancamento_id = 2) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saidas' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 1) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saldo' AS tipo,sum((case when (c.caixa_tipo_lancamento_id = 1) then (c.valor * -(1)) else c.valor end)) AS valor 
        from caixa_lancamentos c 
        group by c.caixa_id
        ; 

CREATE VIEW vw_caixa_resumo_formas AS Select 
    c.caixa_id caixa_id,
    c.forma_pagamento_id forma_pagamento_id,
    f.descricao nome_forma_pagamento,
    sum(case when c.caixa_tipo_lancamento_id = 1 then c.valor * -1 else c.valor end) total
from caixa_lancamentos c,
     forma_pagamento f
where f.id = c.forma_pagamento_id
group by c.caixa_id, c.forma_pagamento_id; 

CREATE VIEW vw_funil_filial AS SELECT DISTINCT
f.id AS id,
f.descricao AS descricao,
n.system_unit_id AS system_unit_id
FROM funil f
INNER JOIN funil_etapas fe ON fe.funil_id = f.id
INNER JOIN negocio n ON n.funil_etapas_id = fe.id; 

CREATE VIEW vw_lotes_produto AS select l.id as id,
       l.produto_id as produto_id,
       l.numero as numero,
       l.validade as validade,
       sum(e.quant_disponivel) as Quantidade,
       sum(e.quant_reservada) as Reservado
       from produto_lote l
left join estoque_saldos e on e.produto_lote_id = l.id
; 

CREATE VIEW vw_produto_estoque AS SELECT     p.id as id,
           p.nome as nome,
           p.referencia as referencia,
           p.codigo_sku as SKU,
           p.obs as obs,
           f.margem as margem,
           f.valor_custo as valor_custo,
           f.preco_venda as preco_venda,
           p.peso_liquido as peso_liquido,
           p.peso_bruto as preso_bruto,
           g.descricao as grupo,
           sg.descricao as subgrupo,
           u.sigla as sigla,
           p.imagem as imagem,
           p.codigo_ean as ean,
           p.ncm as ncm,
           f.system_unit_id as system_unit_id,
           f.id as produto_filial_id,
           f.estoque_minimo as estoque_minimo,
           f.estoque_maximo as estoque_maximo,           
           (e.quant_disponivel) as Quantidade_Disponivel,
           (e.quant_reservada) as Quantidade_Reservada,
           d.descricao as deposito
           
           FROM produto p 
           INNER JOIN unidade_medida u ON p.unidade_medida_id = u.id 
           INNER JOIN produto_grupo g ON p.produto_grupo_id = g.id
           LEFT JOIN produtogrupo_subgrupo sg ON g.id = sg.produto_grupo_id
           LEFT JOIN produto_filial f ON f.produto_id = p.id 
           LEFT JOIN estoque_saldos e ON e.produto_id = p.id
           LEFT JOIN estoque_deposito d ON e.estoque_deposito_id = d.id
           group by 1,2           
           
           ; 
 
