CREATE TABLE api_documentos( 
      id  SERIAL    NOT NULL  , 
      integradores_id integer   NOT NULL  , 
      system_unit_id integer   , 
      descricao text   NOT NULL  , 
      token_api text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE apidocumentos_integradoresservicos( 
      id  SERIAL    NOT NULL  , 
      api_documentos_id integer   NOT NULL  , 
      integradores_servicos_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE api_error( 
      id  SERIAL    NOT NULL  , 
      classe text   , 
      metodo text   , 
      url text   , 
      dados text   , 
      error_message text   , 
      inserted_at timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ativo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE banco( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      numero text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE boleto_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa( 
      id  SERIAL    NOT NULL  , 
      caixa_situacao_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      system_users_abertura_id integer   NOT NULL  , 
      system_users_operador_id integer   NOT NULL  , 
      system_users_fechamento_id integer   , 
      data_hora_abertura timestamp   , 
      data_hora_fechamento timestamp   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_lancamentos( 
      id  SERIAL    NOT NULL  , 
      caixa_id integer   NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      caixa_tipo_lancamento_id integer   NOT NULL  , 
      valor float   NOT NULL  , 
      data_hora_lancamento timestamp   NOT NULL  , 
      system_users_id integer   NOT NULL  , 
      observacao text   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      id_origem integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE caixa_tipo_lancamento( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      centro_custo_tipo_id integer   NOT NULL  , 
      centro_custo_pai_id integer   , 
      numero text   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE centro_custo_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cep_cache( 
      id  SERIAL    NOT NULL  , 
      cep text   , 
      rua text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      cidade text   , 
      bairro text   , 
      codigo_ibge text   , 
      uf char  (2)   , 
      cidade_id integer   , 
      estado_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agendamentos( 
      id  SERIAL    NOT NULL  , 
      certificado_venda_id integer   NOT NULL  , 
      titulo text   NOT NULL  , 
      data_hora_inicial timestamp   NOT NULL  , 
      data_hora_final timestamp   NOT NULL  , 
      observacao text   , 
      cor text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_agente_registro( 
      id  SERIAL    NOT NULL  , 
      parceiro_id integer   , 
      nome text   NOT NULL  , 
      cpf text   , 
      fone text   , 
      email text   , 
      percentual_comissao float   , 
      deletado_em timestamp   , 
      criado_em timestamp   NOT NULL  , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente( 
      id  SERIAL    NOT NULL  , 
      cliente_id integer   NOT NULL  , 
      parceiro_id integer   , 
      produto_id integer   NOT NULL  , 
      certificado_cliente_situacao_id integer   NOT NULL  , 
      data_vencimento_certificado date   , 
      certificado_venda_id integer   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_cliente_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_email_historico( 
      id  SERIAL    NOT NULL  , 
      certificado_cliente_id integer   NOT NULL  , 
      email text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      texto_emissao text   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificadora_produtos( 
      id  SERIAL    NOT NULL  , 
      certificadora_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      qtde_dias_vencimento integer   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      valor_custo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_atendimento( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_tipo_repasse( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      cliente_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      parceiro_id integer   , 
      certificado_agente_registro_id integer   NOT NULL  , 
      certificado_venda_situacao_id integer   NOT NULL  , 
      certificado_venda_modalidade_id integer   , 
      certificado_venda_tipomodalidade_id integer   , 
      certificado_tipo_repasse_id integer   , 
      vendedor_id integer   , 
      tabela_preco_id integer   , 
      certificadora_id integer   , 
      valor_custo float   , 
      data_hora_agendamento timestamp   , 
      data_vencimento_certificado date   , 
      valor_externo float   , 
      custo_externo float   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      agente_comissao_percentual float   , 
      agente_comissao_valor float   , 
      vendedor_comissao_percentual float   , 
      vendedor_comissao_valor float   , 
      atendimento_externo boolean   , 
      parceiro_comissao_percentual float   , 
      parceiro_valor_repasse float   , 
      valor_total float   NOT NULL  , 
      comissao_total float   , 
      lucro_total float   , 
      valor_cliente float   , 
      valor_produto float   NOT NULL  , 
      protocolo_emissao text   , 
      data_emissao date   , 
      data_pagamento date   , 
      certificado_tipo_atendimento_id integer   , 
      observacao text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_documentos( 
      id  SERIAL    NOT NULL  , 
      certificado_venda_id integer   NOT NULL  , 
      descricao_arquivo text   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_formapgto( 
      id  SERIAL    NOT NULL  , 
      certificado_venda_id integer   NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_modalidade( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      certificado_tipo_repasse_id integer   NOT NULL  , 
      certificado_venda_tipomodalidade_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      ordem integer   , 
      cor text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE certificado_venda_tipomodalidade( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cfop( 
      id  SERIAL    NOT NULL  , 
      numero char  (4)   NOT NULL  , 
      descricao text   NOT NULL  , 
      aplicacao text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE chave_pix_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cidade( 
      id  SERIAL    NOT NULL  , 
      estado_id integer   NOT NULL  , 
      pais_id integer   , 
      nome text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      codigo_ibge text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente( 
      id  SERIAL    NOT NULL  , 
      pessoa_tipo_id integer   NOT NULL  , 
      cliente_classificacao_id integer   NOT NULL  , 
      cliente_classificacao_subgrupo_id integer   , 
      vendedor_id integer   , 
      notafiscal_indiedest_id integer   NOT NULL  , 
      notafiscal_crt_id integer   , 
      nome text   NOT NULL  , 
      cpf_cnpj text   , 
      rg text   , 
      email text   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      insc_estadual text   , 
      insc_municipal text   , 
      razao_social text   , 
      fone text   , 
      observacoes text   , 
      data_nascimento date   , 
      conjuge text   , 
      conjuge_cpf text   , 
      nome_pai text   , 
      nome_mae text   , 
      local_trabalho text   , 
      renda float   , 
      tempo_trabalho text   , 
      residencia_propria integer   , 
      utilizar_endereco_cobranca integer   NOT NULL  , 
      cobranca_cnpj text   , 
      cobranca_nome text   , 
      cobranca_cep text   , 
      cobranca_endereco text   , 
      cobranca_bairro text   , 
      cobranca_uf text   , 
      cobranca_cidade text   , 
      cobranca_fones text   , 
      cliente_situacao_id integer   NOT NULL  , 
      limite_credito float   , 
      limite_utilizado float   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
      system_unit_id integer   , 
      deletado_em timestamp   , 
      vendas_quantidade integer   , 
      vendas_valortotal float   , 
      vendas_dataultima timestamp   , 
      vendas_valormaior float   , 
      vendas_datamaior timestamp   , 
      observacoes_financeiro text   , 
      tabela_preco_id integer   , 
      percentual_comissao_vendedor float   , 
      cliente_exterior char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
      ativo_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_classificacao_subgrupo( 
      id  SERIAL    NOT NULL  , 
      cliente_classificacao_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_contato( 
      id  SERIAL    NOT NULL  , 
      cliente_id integer   , 
      tipo_contato text   , 
      nome text   NOT NULL  , 
      fone text   , 
      ativo_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_endereco( 
      id  SERIAL    NOT NULL  , 
      logradouro text   NOT NULL  , 
      cliente_id integer   NOT NULL  , 
      principal integer   NOT NULL  , 
      cidade_id integer   NOT NULL  , 
      bairro text   , 
      cep text   , 
      numero text   , 
      complemento text   , 
      ativo_id integer   NOT NULL  , 
      codigo_ibge varchar  (20)   , 
      ibge_estado integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_historico_limite( 
      id  SERIAL    NOT NULL  , 
      cliente_id integer   NOT NULL  , 
      valor float   NOT NULL  , 
      data_hora timestamp   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cliente_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE condicao_pagamento( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      numero_parcelas integer   NOT NULL  , 
      dias_primeira_parcelas integer   , 
      dias_entre_parcelas integer   , 
      taxa float   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes( 
      id  SERIAL    NOT NULL  , 
      forma_pagamento_id_dinheiro_caixa integer   , 
      forma_pagamento_id_titulos_cpag_nf integer   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE configuracoes_filial( 
      id  SERIAL    NOT NULL  , 
      configuracoes_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      produto_etiqueta_configuracoes_id integer   , 
      plano_conta_mascara text   , 
      centro_custo_mascara text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      plano_conta_crec_id integer   , 
      centro_custo_crec_id integer   , 
      cpag_usa_plano_contas_id integer   , 
      info_complementar_orcamento text   , 
      informar_duplicidade_de_item_venda_id integer   , 
      venda_apenas_com_estoque_id integer   , 
      notafiscal_cprod_padrao_orcamento_id integer   , 
      notafiscal_cprod_padrao_venda_id integer   , 
      produto_margem_padrao float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos( 
      id  SERIAL    NOT NULL  , 
      plano_conta_id integer   NOT NULL  , 
      centro_custo_id integer   NOT NULL  , 
      contabil_lancamentos_tipo_id integer   NOT NULL  , 
      contabil_lancamentos_situacao_id integer   NOT NULL  , 
      contabil_lancamentos_origem_id integer   NOT NULL  , 
      data_lancamento date   NOT NULL  , 
      valor float   NOT NULL  , 
      contasrec_id integer   , 
      contaspag_contabil_id integer   , 
      conta_corrente_lancamentos_id integer   , 
      historico text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_origem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contabil_lancamentos_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      banco_id integer   , 
      nome text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      agencia text   , 
      conta text   , 
      agencia_digito text   , 
      conta_digito text   , 
      end_logradouro text   , 
      end_bairro text   , 
      end_cidade text   , 
      end_estado text   , 
      end_cep text   , 
      end_numero text   , 
      boleto_convenio text   , 
      boleto_carteira text   , 
      boleto_gerar boolean   NOT NULL  , 
      boleto_codigo_cedente text   , 
      boleto_digito_cod_cedente text   , 
      boleto_instrucoes text   , 
      boleto_multa float   , 
      boleto_juros_dia float   , 
      boleto_digitos_nosso_numero integer   , 
      boleto_local_pagamento text   , 
      boleto_codigo_transmissao text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lancamentos( 
      id  SERIAL    NOT NULL  , 
      conta_corrente_id integer   NOT NULL  , 
      conta_corrente_lanc_tipo_id integer   NOT NULL  , 
      conta_corrente_lanc_origem_id integer   NOT NULL  , 
      contaspag_baixas_id integer   , 
      contasrec_baixas_id integer   , 
      data_lancamento date   NOT NULL  , 
      valor float   NOT NULL  , 
      documento text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      historico text   , 
      plano_conta_id integer   , 
      centro_custo_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_origem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE conta_corrente_lanc_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag( 
      id  SERIAL    NOT NULL  , 
      contaspag_situacao_id integer   NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      fornecedor_id integer   NOT NULL  , 
      contaspag_origem_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      numero_documento text   NOT NULL  , 
      parcela text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      data_emissao date   NOT NULL  , 
      valor float   NOT NULL  , 
      data_vencimento date   NOT NULL  , 
      data_venc_original date   , 
      observacao text   , 
      data_pagamento date   , 
      desconto float   , 
      juros float   , 
      valor_pago float   , 
      valor_aberto float   , 
      valor_multa float   , 
      cheque_banco_id integer   , 
      cheque_agencia text   , 
      cheque_conta float   , 
      cheque_emitente text   , 
      cheque_cpfcnpj text   , 
      data_competencia date   , 
      contaspag_bloco_id integer   , 
      nota_fiscal_compra_id integer   , 
      data_vencimento_calendario timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_anexos( 
      id  SERIAL    NOT NULL  , 
      contaspag_id integer   NOT NULL  , 
      titulos_tipo_anexo_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_baixas( 
      id  SERIAL    NOT NULL  , 
      contaspag_id integer   NOT NULL  , 
      conta_corrente_id integer   NOT NULL  , 
      data_pagamento date   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      juros float   , 
      desconto float   , 
      saldo_aberto float   , 
      saldo_apagar float   , 
      multa float   , 
      historico text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco( 
      id  SERIAL    NOT NULL  , 
      fornecedor_id integer   NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      contaspag_origem_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      quantidade_parcelas integer   NOT NULL  , 
      primeiro_vencimento date   , 
      valor float   NOT NULL  , 
      numero_documento text   , 
      observacao text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_bloco_contabil( 
      id  SERIAL    NOT NULL  , 
      contaspag_bloco_id integer   NOT NULL  , 
      plano_conta_id integer   NOT NULL  , 
      centro_custo_id integer   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_contabil( 
      id  SERIAL    NOT NULL  , 
      contaspag_id integer   NOT NULL  , 
      plano_conta_id integer   NOT NULL  , 
      centro_custo_id integer   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_historico_venc( 
      id  SERIAL    NOT NULL  , 
      contaspag_id integer   NOT NULL  , 
      vencimento_anterior date   , 
      vencimento_atual date   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_origem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contaspag_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      cliente_id integer   NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      contasrec_situacao_id integer   NOT NULL  , 
      plano_conta_id integer   NOT NULL  , 
      centro_custo_id integer   NOT NULL  , 
      contasrec_origem_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      numero_documento text   , 
      parcela text   , 
      valor float   NOT NULL  , 
      data_vencimento date   NOT NULL  , 
      data_venc_original date   , 
      observacao text   , 
      data_pagamento date   , 
      desconto float   , 
      juros float   , 
      valor_pago float   , 
      valor_aberto float   , 
      valor_multa float   , 
      cheque_banco_id integer   , 
      cheque_agencia text   , 
      cheque_conta text   , 
      cheque_emitente text   , 
      cheque_cpfcnpj text   , 
      data_competencia date   , 
      conta_corrente_boleto_id integer   , 
      boleto_situacao_id integer   , 
      boleto_nosso_numero text   , 
      vendedor_comissao float   , 
      vendedor_id integer   , 
      contasrec_bloco_id integer   , 
      venda_formapgto_id integer   , 
      data_emissao date   NOT NULL  , 
      ativo_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_anexos( 
      id  SERIAL    NOT NULL  , 
      contasrec_id integer   NOT NULL  , 
      titulos_tipo_anexo_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_baixas( 
      id  SERIAL    NOT NULL  , 
      contasrec_id integer   NOT NULL  , 
      conta_corrente_id integer   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      juros float   , 
      desconto float   , 
      saldo_aberto float   NOT NULL  , 
      saldo_apagar float   , 
      multa float   , 
      historico text   , 
      data_pagamento date   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_bloco( 
      id  SERIAL    NOT NULL  , 
      cliente_id integer   NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      plano_conta_id integer   NOT NULL  , 
      centro_custo_id integer   NOT NULL  , 
      quantidade_parcelas integer   NOT NULL  , 
      primeiro_vencimento date   , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      numero_documento text   , 
      observacao text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_cobranca( 
      id  SERIAL    NOT NULL  , 
      contasrec_id integer   NOT NULL  , 
      historico text   NOT NULL  , 
      data_cobranca date   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_historico_venc( 
      id  SERIAL    NOT NULL  , 
      contasrec_id integer   NOT NULL  , 
      vencimento_anterior date   , 
      vencimento_atual date   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_origem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE contasrec_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_cofins( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_icms( 
      id  SERIAL    NOT NULL  , 
      regime_tributario_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_ipi( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE cst_pis( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cst_numero text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos( 
      id  SERIAL    NOT NULL  , 
      despesas_servicos_tipo_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE despesas_servicos_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE dispositivos( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      token varchar  (100)   NOT NULL  , 
      serial_dispositivo text   , 
      criado_em timestamp   NOT NULL  , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      alterado_por text   , 
      deletado_em timestamp   , 
      data_hora_ultima_sincronizacao timestamp   , 
      ip_sincronizacao text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE email_template( 
      id  SERIAL    NOT NULL  , 
      titulo text   NOT NULL  , 
      mensagem text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estado( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      sigla char  (2)   NOT NULL  , 
      codigo_ibge text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_deposito( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_estante( 
      id  SERIAL    NOT NULL  , 
      estoque_rua_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_lancamentos( 
      id  SERIAL    NOT NULL  , 
      produto_id integer   NOT NULL  , 
      estoque_origem_id integer   NOT NULL  , 
      estoque_tipo_movimentacao_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      estoque_deposito_id integer   NOT NULL  , 
      produto_lote_id integer   , 
      venda_id integer   , 
      nota_fiscal_compra_id integer   , 
      ordem_producao_id integer   , 
      quantidade float   NOT NULL  , 
      observacao text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      preco_venda float   , 
      preco_custo float   , 
      data_lancamento date   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_origem( 
      id  SERIAL    NOT NULL  , 
      estoque_tipo_movimentacao_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_prateleira( 
      id  SERIAL    NOT NULL  , 
      estoque_estante_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_rua( 
      id  SERIAL    NOT NULL  , 
      estoque_deposito_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_saldos( 
      id  SERIAL    NOT NULL  , 
      produto_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      estoque_deposito_id integer   NOT NULL  , 
      produto_lote_id integer   , 
      quant_disponivel float   NOT NULL  , 
      quant_reservada float   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      preco_medio_venda float   , 
      preco_medio_custo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE estoque_tipo_movimentacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos( 
      id  SERIAL    NOT NULL  , 
      system_program_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      email_template_id integer   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_documentos( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   , 
      system_users_id integer   , 
      system_unit_id integer   , 
      cstat integer   , 
      xmotivo varchar  (255)   , 
      xevento varchar  (255)   , 
      tpevento varchar  (255)   , 
      nseqevento integer   , 
      dhregevento timestamp   , 
      nprot varchar  (255)   , 
      origem_event varchar  (255)   , 
      mensagem_manual text   , 
      tpamb integer   , 
      veraplic varchar  (255)   , 
      chnfe varchar  (255)   , 
      dhrecbto timestamp   , 
      digval varchar  (255)   , 
      xml text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE eventos_systemuser( 
      id  SERIAL    NOT NULL  , 
      eventos_id integer   NOT NULL  , 
      system_users_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      enviar_email integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE forma_pagamento( 
      id  SERIAL    NOT NULL  , 
      codigo_interno integer   NOT NULL  , 
      tipo_documento_id integer   NOT NULL  , 
      meio_pagamento_tef_id integer   , 
      notafiscal_tpag_id integer   , 
      descricao text   NOT NULL  , 
      prazo_pagamento integer   , 
      taxa float   , 
      deletado_em timestamp   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por text   , 
      alterado_por text   , 
      utiliza_pdv char  (1)   , 
      obriga_nf_pdv char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE formapgto_condpgto( 
      id  SERIAL    NOT NULL  , 
      condicao_pagamento_id integer   NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor( 
      id  SERIAL    NOT NULL  , 
      pessoa_tipo_id integer   NOT NULL  , 
      fornecedor_classificacao_id integer   , 
      nome text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      insc_estadual text   , 
      insc_municipal text   , 
      cpf_cnpj text   , 
      razao_social text   , 
      logradouro text   , 
      cidade_id integer   , 
      bairro text   , 
      cep text   , 
      numero text   , 
      complemento text   , 
      fone text   , 
      email text   , 
      site text   , 
      observacoes text   , 
      notafiscal_crt_id integer   , 
      deletado_em timestamp   , 
      notafiscal_indiedest_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_classificacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      ativo_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE fornecedor_contato( 
      id  SERIAL    NOT NULL  , 
      fornecedor_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      tipo_contato text   , 
      nome text   NOT NULL  , 
      fone text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario( 
      id  SERIAL    NOT NULL  , 
      funcionario_cargo_id integer   , 
      nome text   NOT NULL  , 
      cpf text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      valor_salario float   , 
      valor_hora float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funcionario_cargo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE funil_etapas( 
      id  SERIAL    NOT NULL  , 
      funil_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      numero_etapa integer   NOT NULL  , 
      cor_etapa text   , 
      cor_negocio text   , 
      ultima_etapa integer   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      permite_edicao char  (1)   , 
      permite_exclusao char  (1)   , 
      kanban char  (1)   , 
      etapa_ganha char  (1)   , 
      etapa_perde char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE indicador_personalizado( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      url_indicador text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE integradores_servicos( 
      id  SERIAL    NOT NULL  , 
      integradores_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE inutilizar_numero( 
      id  SERIAL    NOT NULL  , 
      created_at timestamp   , 
      system_user integer   , 
      update_at timestamp   , 
      deleted_at timestamp   , 
      ninicio varchar  (20)   , 
      nfinal varchar  (20)   , 
      serie varchar  (20)   , 
      system_unit_id integer   , 
      system_users_id integer   , 
      xml_retorno text   , 
      protocolo varchar  (50)   , 
      xmotivo varchar  (200)   , 
      cstat integer   , 
      notafiscal_id integer   , 
      xjust varchar  (150)   , 
      tipo integer   NOT NULL    DEFAULT 1, 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      idmdfe varchar  (255)   , 
      chMDF text   , 
      nProt text   , 
      cStat text   , 
      mdfe_tpemit_id integer   NOT NULL  , 
      mdfe_tpprop_id integer   NOT NULL  , 
      mdfe_tptransp_id integer   , 
      mdfe_tpcar_id integer   NOT NULL  , 
      nMDF text   NOT NULL  , 
      serie text   , 
      dhEmi timestamp   , 
      UFIni integer   NOT NULL  , 
      UFFim integer   NOT NULL  , 
      dhIniViagem timestamp   , 
      indCanalVerde integer   NOT NULL  , 
      indCarregaPosterior integer   NOT NULL  , 
      infAdFisco text   , 
      infCpl text   , 
      mdfe_respSeg_id integer   , 
      seguro_cpfcnpj text   , 
      seguradora_xSeg text   , 
      seguradora_cnpj text   , 
      vCarga float   , 
      mdfe_cunid_id integer   NOT NULL  , 
      qCarga float   , 
      mdfe_tpcarga_id integer   , 
      prod_xProd text   , 
      prod_cEAN text   , 
      prod_NCM text   , 
      pgto_cpfcnpj text   , 
      pgto_idEstrangeiro text   , 
      pgto_xNome text   , 
      pgto_vContrato float   , 
      pgto_indAltoDesemp text   , 
      mdfe_indpag_id integer   , 
      pgto_vAdiant float   , 
      indAntecipaAdiant integer   , 
      pgto_codBanco text   , 
      pgto_codAgencia text   , 
      pgto_CNPJIPEF text   , 
      pgto_PIX text   , 
      veic_rntrc text   , 
      mdfe_tpRod_id integer   NOT NULL  , 
      veic_estado_id integer   NOT NULL  , 
      veic_cint integer   , 
      veic_placa text   , 
      veic_renavam text   , 
      veic_tara float   , 
      justificativa_cancelamento text   , 
      mensagem_sefaz text   , 
      status text   , 
      data_hora_envio timestamp   , 
      protocolo_cancelamento text   , 
      datahora_cancelamento timestamp   , 
      veiculo_id integer   NOT NULL  , 
      mdfe_situacao_id integer   NOT NULL  , 
      mdfe_tpamb_id integer   NOT NULL  , 
      api_documentos_id integer   , 
      xml_cancelamento text   , 
      xml text   , 
      cidade_encerramento_id integer   , 
      cmunencerramento integer   , 
      data_encerramento date   , 
      datahora_encerramento timestamp   , 
      protocolo_encerramento text   , 
      xml_encerramento text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_componentes( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      mdfe_tpcomp_id integer   NOT NULL  , 
      vComp float   , 
      xComp text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_condutor( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      xnome text   NOT NULL  , 
      cpf text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_ctes( 
      id  SERIAL    NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      chCTe text   , 
      SegCodBarra text   , 
      indReentrega integer   NOT NULL  , 
      mdfe_infmundescarga_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_cunid( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_evento( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      status text   , 
      codigo_status text   , 
      motivo_status text   , 
      id_evento text   , 
      numero_sequencial text   , 
      chave text   , 
      protocolo text   , 
      tipo_evento text   , 
      data_recebimento text   , 
      data_evento text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_inclusao_dfe( 
      id  SERIAL    NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      mdfe_id integer   NOT NULL  , 
      notafiscal_id integer   , 
      cidade_carrega_id integer   NOT NULL  , 
      cidade_descarga_id integer   NOT NULL  , 
      chave text   NOT NULL  , 
      protocolo text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_indpag( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmuncarrega( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      cidade_id integer   NOT NULL  , 
      cMunCarrega text   NOT NULL  , 
      xMunCarrega text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infmundescarga( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      cidade_id integer   NOT NULL  , 
      cMunDescarga text   NOT NULL  , 
      xMunDescarga text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_infpercurso( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      UFPer integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_lacres( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      nLacre text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_logs( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      system_users_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_mdfes( 
      id  SERIAL    NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      chMDFe text   , 
      indReentrega integer   NOT NULL  , 
      mdfe_infmundescarga_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_nfes( 
      id  SERIAL    NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      chNFe text   , 
      SegCodBarra text   , 
      indReentrega integer   NOT NULL  , 
      mdfe_infmundescarga_id integer   NOT NULL  , 
      notafiscal_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_parcelas( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      nParcela text   , 
      dVenc date   , 
      vParcela float   , 
      mdfe_tpAntecip_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_respSeg( 
      id  SERIAL    NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_series( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      mdfe_tpamb_id integer   NOT NULL  , 
      serie text   NOT NULL  , 
      sequencial integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      cor text   , 
      ordem integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpamb( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      valor text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpAntecip( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcar( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcarga( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpcomp( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpemit( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpprop( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tpRod( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_tptransp( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE mdfe_xmlaut( 
      id  SERIAL    NOT NULL  , 
      mdfe_id integer   NOT NULL  , 
      cpfcnpj text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE meio_pagamento_tef( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE movimentacao_origem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natop_excecao_tributo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao( 
      id  SERIAL    NOT NULL  , 
      natureza_operacao_finalidade_id integer   NOT NULL  , 
      cst_icms_id integer   , 
      cst_icms_nao_contribuinte_id integer   , 
      cst_ipi_id integer   , 
      cst_pis_id integer   , 
      cst_cofins_id integer   , 
      cfop char  (4)   NOT NULL  , 
      descricao text   NOT NULL  , 
      obs_padrao text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      icms_aliquota float   , 
      ipi_aliquota float   , 
      ipi_codigo_enquadramento text   , 
      pis_aliquota float   , 
      pis_base float   , 
      cofins_aliquota float   , 
      consumidor_final_id integer   , 
      cofins_base float   , 
      icms_pRedBC float   , 
      icms_pICMS float   , 
      icms_pDif float   , 
      icms_vICMSDeson float   , 
      icms_pMVAST float   , 
      icms_pICMSST float   , 
      icms_pFCP float   , 
      icms_pFCPST float   , 
      icms_pFCPSTRet float   , 
      icms_pST float   , 
      icms_pCredSN date   , 
      icms_pRedBCEfet float   , 
      icms_pICMSEfet float   , 
      notafiscal_item_modbc_id integer   , 
      notafiscal_item_modbcst_id integer   , 
      notafiscal_item_motDesICMS_id integer   , 
      icms_pFCPUFDest float   , 
      icms_pICMSUFDest float   , 
      icms_baseST float   , 
      icms_base float   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_estados( 
      id  SERIAL    NOT NULL  , 
      natureza_operacao_excecao_id integer   NOT NULL  , 
      estado_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_excecao( 
      id  SERIAL    NOT NULL  , 
      natureza_operacao_id integer   NOT NULL  , 
      natop_excecao_tributo_id integer   NOT NULL  , 
      cst_pis_id integer   , 
      cst_ipi_id integer   , 
      cst_icms_id integer   , 
      cst_cofins_id integer   , 
      cfop char  (4)   , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      icms_aliquota float   , 
      ipi_aliquota float   , 
      ipi_codigo_enquadramento text   , 
      pis_aliquota float   , 
      pis_base float   , 
      cofins_aliquota float   , 
      cofins_base float   , 
      icms_predbc float   , 
      icms_picms float   , 
      icms_pdif float   , 
      icms_vicmsdeson float   , 
      icms_pmvast float   , 
      icms_picmsst float   , 
      icms_pfcp float   , 
      icms_pfcpst float   , 
      icms_pfcpstret float   , 
      icms_pst float   , 
      icms_pcredsn float   , 
      icms_predbcefet float   , 
      icms_picmsefet float   , 
      icms_pfcpufdest float   , 
      icms_picmsufdest float   , 
      icms_base float   , 
      icms_basest float   , 
      notafiscal_item_modbc_id integer   , 
      notafiscal_item_modbcst_id integer   , 
      notafiscal_item_motDesICMS_id integer   , 
      cfop_fora char  (4)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_finalidade( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_ncm( 
      id  SERIAL    NOT NULL  , 
      natureza_operacao_excecao_id integer   NOT NULL  , 
      ncm text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_origens( 
      id  SERIAL    NOT NULL  , 
      natureza_operacao_excecao_id integer   NOT NULL  , 
      notafiscal_item_orig_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE natureza_operacao_produtos( 
      id  SERIAL    NOT NULL  , 
      produto_id integer   NOT NULL  , 
      natureza_operacao_excecao_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      negocio_origem_id integer   NOT NULL  , 
      funil_id integer   , 
      funil_etapas_id integer   NOT NULL  , 
      titulo text   NOT NULL  , 
      valor float   , 
      data_abertura date   NOT NULL  , 
      ordem integer   NOT NULL  , 
      data_fechamento date   , 
      negocio_motivo_perda_id integer   , 
      comentarios_motivo_perda text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      contato_nome text   , 
      contato_fone text   , 
      ativo_id integer   NOT NULL  , 
      arquivado integer   NOT NULL  , 
      data_fechamento_esperada date   , 
      vendedor_id integer   , 
      mes integer   , 
      ano integer   , 
      orcamento_id integer   , 
      cliente_id integer   , 
      deletado_em timestamp   , 
      contato_email text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_arquivos( 
      id  SERIAL    NOT NULL  , 
      negocio_id integer   NOT NULL  , 
      arquivo text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_atividade( 
      id  SERIAL    NOT NULL  , 
      negocio_id integer   NOT NULL  , 
      negocio_tipo_atividade_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      horario_inicial timestamp   , 
      horario_final timestamp   , 
      observacao text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_etapas_historico( 
      id  SERIAL    NOT NULL  , 
      negocio_id integer   NOT NULL  , 
      funil_etapas_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_itens( 
      id  SERIAL    NOT NULL  , 
      negocio_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      valor_unitario float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      desconto float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_motivo_perda( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_notas( 
      id  SERIAL    NOT NULL  , 
      negocio_id integer   NOT NULL  , 
      nota text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_origem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE negocio_tipo_atividade( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      icone text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      cliente_id integer   , 
      venda_id integer   , 
      numero text   NOT NULL  , 
      data_emissao timestamp   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      texto_rodape text   , 
      data_saida timestamp   , 
      icms_basecalc float   , 
      icms_valor float   , 
      icms_subst_base_calc integer   , 
      icms_subst_valor float   , 
      frete_valor float   , 
      seguro_valor float   , 
      outras_despesas float   , 
      ipi_valor float   , 
      serie text   , 
      valor_total_produtos float   , 
      valor_total_nota float   , 
      transp_nome text   , 
      transp_cnpj text   , 
      transp_inscest text   , 
      transp_endereco text   , 
      transp_cidade text   , 
      transp_placaveiculo text   , 
      transp_uf text   , 
      transp_veiculouf text   , 
      transp_veiculoRNTC text   , 
      transp_numeracao text   , 
      nf_tipodocumento_id integer   NOT NULL  , 
      notafiscal_situacao_id integer   NOT NULL  , 
      notafiscal_crt_id integer   NOT NULL  , 
      cliente_endereco text   , 
      cliente_complemento text   , 
      cliente_numero text   , 
      cliente_bairro text   , 
      cliente_cidade text   , 
      cliente_cep text   , 
      cliente_estado text   , 
      cliente_nome text   , 
      cliente_cpfcnpj text   , 
      cliente_inscest text   , 
      cliente_inscmuni text   , 
      cliente_fone text   , 
      cliente_cidade_codibge integer   , 
      cliente_suframa text   , 
      justificativa_cancelamento text   , 
      chave text   , 
      protocolo_envio text   , 
      notafiscal_indiedest_id integer   NOT NULL  , 
      protocolo_cancelamento text   , 
      datahora_cancelamento timestamp   , 
      cce_datahora_evento timestamp   , 
      cce_sequencial integer   , 
      cce_correcao text   , 
      cce_protocolo text   , 
      infadfisco text   , 
      desconto_valor float   , 
      pis_valor float   , 
      cofins_valor float   , 
      fatura_numero text   , 
      fatura_valor_original float   , 
      fatura_valor_desconto float   , 
      fatura_valor_liquido float   , 
      notafiscal_iddest_id integer   NOT NULL  , 
      notafiscal_tpimp_id integer   NOT NULL  , 
      notafiscal_tpemis_id integer   NOT NULL  , 
      notafiscal_finnfe_id integer   NOT NULL  , 
      notafiscal_indfinal_id integer   NOT NULL  , 
      notafiscal_indpres_id integer   NOT NULL  , 
      verproc text   , 
      notafiscal_indpag_id integer   NOT NULL  , 
      retirada_marcado integer   , 
      retirada_cpfcnpj text   , 
      retirada_xlgr text   , 
      retirada_nro text   , 
      retirada_xcpl text   , 
      retirada_xbairro text   , 
      retirada_cmun integer   , 
      retirada_xmun text   , 
      retirada_uf text   , 
      entrega_marcado integer   , 
      entrega_cpfcnpj text   , 
      entrega_xlgr text   , 
      entrega_nro text   , 
      entrega_xcpl text   , 
      entrega_xbairro text   , 
      entrega_cmun integer   , 
      entrega_xmun text   , 
      entrega_uf text   , 
      vicmsufdest float   , 
      vicmsufremet float   , 
      vfcpufdest float   , 
      notafiscal_modelo_id integer   NOT NULL  , 
      dispositivos_id integer   , 
      xml text   , 
      data_hora_envio timestamp   , 
      xml_cancelamento text   , 
      issqn_vserv float   , 
      issqn_vbc float   , 
      issqn_viss float   , 
      issqn_dcompet date   , 
      issqn_reftrib text   , 
      icms_vfcp float   , 
      icms_vfcpst float   , 
      icms_vfcpstret float   , 
      layout_versao text   , 
      ipi_vipidevol float   , 
      vtroco float   , 
      notafiscal_tpamb_id integer   NOT NULL  , 
      notafiscal_mod_id integer   NOT NULL  , 
      infcpl text   , 
      notafiscal_modfrete_id integer   NOT NULL  , 
      status text   , 
      mensagem text   , 
      cce_xml text   , 
      cce_pdf text   , 
      codigo_sefaz integer   , 
      sn_carta_correcao char  (1)   NOT NULL    DEFAULT 'N', 
      deletado_em timestamp   , 
      contingencia_data timestamp   , 
      contingencia_motivo text   , 
      exporta_ufsaidapais text   , 
      exporta_xlocexporta text   , 
      exporta_xlocdespacho text   , 
      cliente_cpais text   , 
      cliente_xpais text   , 
      natureza_operacao_id integer   , 
      movimentacao_origem_id integer   , 
      inutilizar integer   , 
      xml_inicial text   , 
      entrega_cuf integer   , 
      xml_assinado text   , 
      protolo_xml text   , 
      xml_autorizado text   , 
      cep_entrega varchar  (15)   , 
      cep_retirada varchar  (15)   , 
      entrega_xnome varchar  (200)   , 
      xml_carta text   , 
      protocolo_carta_resposta varchar  (200)   , 
      descricao text   , 
      xevento text   , 
      xmotivo text   , 
      cstat integer   , 
      dhregevento varchar  (50)   , 
      nseqevento integer   , 
      nprot varchar  (100)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_autxml( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      cpf_cnpj text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   NOT NULL  , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      fornecedor_id integer   , 
      numero text   NOT NULL  , 
      data_emissao timestamp   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      natop text   , 
      data_saida timestamp   , 
      infcpl text   , 
      infadfisco text   , 
      icms_basecalc float   , 
      icms_valor float   , 
      icms_subst_base_calc float   , 
      icms_subst_valor float   , 
      frete_valor float   , 
      seguro_valor float   , 
      outras_despesas float   , 
      ipi_valor float   , 
      serie text   , 
      valor_total_produtos float   , 
      valor_total_nota float   , 
      transp_nome text   , 
      transp_cnpj text   , 
      transp_inscest text   , 
      transp_endereco text   , 
      transp_cidade text   , 
      transp_placaveiculo text   , 
      transp_uf text   , 
      transp_veiculouf text   , 
      transp_veiculorntc text   , 
      transp_numeracao text   , 
      notafiscal_tipodocumento_id integer   NOT NULL  , 
      nota_fiscal_compra_situacao_id integer   NOT NULL  , 
      notafiscal_crt_id integer   , 
      obs_importacao_xml text   , 
      cliente_endereco text   , 
      cliente_complemento text   , 
      cliente_numero text   , 
      cliente_bairro text   , 
      cliente_cidade text   , 
      cliente_cep text   , 
      cliente_estado text   , 
      cliente_nome text   , 
      cliente_cpfcnpj text   , 
      cliente_inscest text   , 
      cliente_fone text   , 
      cliente_cidade_codibge text   , 
      cliente_inscmuni text   , 
      cliente_suframa text   , 
      justificativa_cancelamento text   , 
      chave text   , 
      protocolo_envio text   , 
      notafiscal_indiedest_id integer   , 
      protocolo_cancelamento text   , 
      datahora_cancelamento text   , 
      cce_datahora_evento text   , 
      cce_sequencial text   , 
      cce_correcao text   , 
      cce_protocolo text   , 
      desconto_valor float   , 
      pis_valor float   , 
      cofins_valor float   , 
      fatura_numero text   , 
      fatura_valor_original text   , 
      fatura_valor_desconto float   , 
      fatura_valor_liquido float   , 
      notafiscal_iddest_id integer   NOT NULL  , 
      notafiscal_tpimp_id integer   , 
      notafiscal_finnfe_id integer   NOT NULL  , 
      notafiscal_indfinal_id integer   NOT NULL  , 
      notafiscal_indpres_id integer   NOT NULL  , 
      verproc text   , 
      notafiscal_indpag_id integer   , 
      retirada_marcado integer   , 
      retirada_cpfcnpj text   , 
      retirada_xlgr text   , 
      retirada_nro text   , 
      retirada_xcpl text   , 
      retirada_xbairro text   , 
      retirada_cmun integer   , 
      retirada_xmun text   , 
      retirada_uf text   , 
      entrega_marcado integer   , 
      entrega_cpfcnpj text   , 
      entrega_xlgr text   , 
      entrega_nro text   , 
      entrega_xcpl text   , 
      entrega_xbairro text   , 
      entrega_cmun text   , 
      entrega_xmun text   , 
      entrega_uf text   , 
      vicmsufdest float   , 
      vicmsufremet float   , 
      vfcpufdest text   , 
      notafiscal_mod_id integer   NOT NULL  , 
      xml text   , 
      data_hora_envio timestamp   , 
      xml_cancelamento text   , 
      issqn_vserv float   , 
      issqn_vbc float   , 
      issqn_viss float   , 
      issqn_dcompet date   , 
      issqn_reftrib text   , 
      icms_vfcp float   , 
      icms_vfcpst float   , 
      icms_vfcpstret float   , 
      layout_versao text   , 
      ipi_vipidevol float   , 
      vtroco date   , 
      notafiscal_modfrete_id integer   , 
      cpag_lancada boolean   NOT NULL  , 
      dest_cnpj text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_dup( 
      id  SERIAL    NOT NULL  , 
      nota_fiscal_compra_id integer   NOT NULL  , 
      forma_pagamento_id integer   , 
      plano_conta_id integer   , 
      centro_custo_id integer   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      ndup text   , 
      vdup float   , 
      dvenc date   , 
      parcela text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens( 
      id  SERIAL    NOT NULL  , 
      nota_fiscal_compra_id integer   NOT NULL  , 
      produto_id integer   , 
      nota_fiscal_compra_itens_situacao_id integer   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      nitem integer   , 
      cean text   , 
      xprod text   , 
      ncm text   , 
      nve text   , 
      extipi text   , 
      cfop text   , 
      ucom text   , 
      qcom float   , 
      vuncom float   , 
      vprod float   , 
      ceantrib text   , 
      utrib text   , 
      qtrib float   , 
      vuntrib float   , 
      vfrete float   , 
      vseg float   , 
      vdesc float   , 
      vtottrib float   , 
      xped text   , 
      nitemped integer   , 
      notafiscal_item_indtot_id integer   , 
      notafiscal_item_orig_id integer   NOT NULL  , 
      notafiscal_item_modbc_id integer   , 
      icms_basecalc float   , 
      icms_cst text   , 
      icms_valor float   , 
      icms_aliquota float   , 
      icms_pcredsn float   , 
      icms_vcredicmssn float   , 
      icms_predbc float   , 
      icms_pst float   , 
      icms_pmvast float   , 
      icms_predbcst float   , 
      icms_vbcst float   , 
      icms_picmsst float   , 
      icms_vicmsst float   , 
      fcp_pfcp float   , 
      pis_cst text   , 
      pis_valor float   , 
      pis_aliquota float   , 
      pis_valor_base float   , 
      cofins_cst text   , 
      cofins_valor_base float   , 
      cofins_aliquota float   , 
      cofins_valor float   , 
      voutro float   , 
      infadprod text   , 
      notafiscal_item_motDesICMS_id integer   , 
      cprod text   , 
      ipi_cst text   , 
      ipi_valor_base float   , 
      ipi_aliquota float   , 
      ipi_vipidevol float   , 
      ipi_valor float   , 
      ipi_pdevol float   , 
      estoque_deposito_id integer   , 
      produto_lote_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_itens_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_pag( 
      id  SERIAL    NOT NULL  , 
      nota_fiscal_compra_id integer   NOT NULL  , 
      notafiscal_tpag_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      tpag text   , 
      vpag float   , 
      xpag text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE nota_fiscal_compra_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      cor text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_cprod_padrao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_crt( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor integer   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_dup( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      ndup text   , 
      vdup float   , 
      dvenc date   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_finnfe( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_frete_volumes( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      qVol integer   , 
      nVol text   , 
      esp text   , 
      marca text   , 
      pesol float   , 
      pesob float   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_iddest( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indfinal( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indiedest( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpag( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_indpres( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_indtot( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbc( 
      id  SERIAL    NOT NULL  , 
      codigo integer   , 
      descricao text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_modbcst( 
      id  SERIAL    NOT NULL  , 
      codigo integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_motDesICMS( 
      id  SERIAL    NOT NULL  , 
      codigo text   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_item_orig( 
      id  SERIAL    NOT NULL  , 
      codigo integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_itens( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      nitem integer   , 
      cean varchar  (50)   , 
      xprod text   NOT NULL  , 
      ncm text   , 
      nve text   , 
      extipi text   , 
      cfop text   , 
      ucom text   , 
      qcom float   NOT NULL  , 
      vuncom float   NOT NULL  , 
      vprod float   , 
      ceantrib text   , 
      utrib text   , 
      qtrib float   , 
      vuntrib float   , 
      vfrete float   , 
      vseg float   , 
      vdesc float   , 
      vtottrib float   , 
      xped text   , 
      nitemped integer   , 
      notafiscal_item_indtot_id integer   , 
      notafiscal_item_orig_id integer   NOT NULL  , 
      notafiscal_item_modbc_id integer   , 
      icms_basecalc float   , 
      icms_cst varchar  (20)   , 
      icms_valor float   , 
      icms_aliquota float   , 
      icms_pcredsn float   , 
      icms_vcredicmssn float   , 
      icms_predbc float   , 
      icms_pst float   , 
      icms_pmvast float   , 
      icms_predbcst float   , 
      icms_vbcst float   , 
      icms_picmsst float   , 
      icms_vicmsst float   , 
      alterado_em timestamp   , 
      criado_em timestamp   , 
      pis_cst varchar  (20)   , 
      pis_valor float   , 
      pis_aliquota float   , 
      pis_valor_base float   , 
      cofins_cst varchar  (20)   , 
      cofins_valor_base float   , 
      cofins_aliquota float   , 
      cofins_valor float   , 
      voutro float   , 
      infadprod text   , 
      notafiscal_item_motDesICMS_id integer   , 
      cprod text   , 
      ipi_cst varchar  (255)   , 
      ipi_valor_base float   , 
      ipi_aliquota float   , 
      ipi_vipidevol float   , 
      ipi_valor float   , 
      ipi_pdevol float   , 
      cest text   , 
      fcp_pfcp float   , 
      fcp_vfcp float   , 
      fcp_vbcfcp float   , 
      fcp_vbcfcpst float   , 
      fcp_pfcpst float   , 
      fcp_vfcpst float   , 
      fcp_vbcfcpstret float   , 
      fcp_pfcpstret float   , 
      fcp_vfcpstret float   , 
      icms_vbcufdest float   , 
      icms_vbcfcpufdest float   , 
      icms_pfcpufdest float   , 
      icms_vfcpufdest float   , 
      icms_picmsinter float   , 
      icms_picmsinterpart float   , 
      icms_vicmsufdest float   , 
      icms_vicmsufremet float   , 
      icms_picmsufdest float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_logs( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      system_users_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_mod( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      modelo text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_modfrete( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_pag( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      notafiscal_tpag_id integer   NOT NULL  , 
      tpag text   , 
      vpag float   , 
      xpag text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecf( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      notafiscal_refecfmod_id integer   NOT NULL  , 
      necf text   , 
      ncoo text   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refecfmod( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_refnfe( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   NOT NULL  , 
      refnfe text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_series( 
      id  SERIAL    NOT NULL  , 
      serie text   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      notafiscal_tpamb_id integer   NOT NULL  , 
      notafiscal_mod_id integer   NOT NULL  , 
      sequencial integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      notafiscal_tipodocumento_id integer   NOT NULL  , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      ordem integer   , 
      exibir boolean   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_situacao_sefaz( 
      id  SERIAL    NOT NULL  , 
      notafiscal_situacao_id integer   NOT NULL  , 
      codigo_sefaz integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodoc_series( 
      id  SERIAL    NOT NULL  , 
      notafiscal_series_id integer   NOT NULL  , 
      notafiscal_tipodocumento_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tipodocumento( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpag( 
      id  SERIAL    NOT NULL  , 
      tpag text   NOT NULL  , 
      criado_em timestamp   , 
      descricao text   NOT NULL  , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpamb( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpemis( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE notafiscal_tpimp( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      valor text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      orcamento_situacao_id integer   NOT NULL  , 
      vendedor_id integer   , 
      cliente_id integer   , 
      cliente_contato_id integer   , 
      data_orcamento date   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      observacao text   , 
      valor_produtos float   NOT NULL  , 
      desconto float   , 
      peso_total float   , 
      frete_total float   , 
      valor_total float   NOT NULL  , 
      tabela_preco_id integer   , 
      justificativa_reprovacao text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_interacoes( 
      id  SERIAL    NOT NULL  , 
      orcamento_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_item( 
      id  SERIAL    NOT NULL  , 
      orcamento_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade float   NOT NULL  , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      valor_original float   NOT NULL  , 
      valor_custo float   , 
      desconto float   , 
      informacoes_adicionais text   , 
      numero_pedido text   , 
      numero_item_pedido text   , 
      valor_frete float   , 
      peso_unitario float   , 
      peso_total float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      ordem integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE orcamento_situacao_historico( 
      id  SERIAL    NOT NULL  , 
      orcamento_situacao_id integer   NOT NULL  , 
      orcamento_id integer   NOT NULL  , 
      descricao text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      ordem_producao_situacao_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      produto_ficha_tecnica_id integer   NOT NULL  , 
      estoque_deposito_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade float   NOT NULL  , 
      data_producao date   NOT NULL  , 
      observacoes text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas( 
      id  SERIAL    NOT NULL  , 
      ordem_producao_id integer   NOT NULL  , 
      ordem_producao_etapas_situacao_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      ordem integer   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_etapas_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_itens( 
      id  SERIAL    NOT NULL  , 
      ordem_producao_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      estoque_deposito_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade float   NOT NULL  , 
      quantidade_total float   NOT NULL  , 
      custo float   , 
      custo_total float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_situacao_historico( 
      id  SERIAL    NOT NULL  , 
      ordem_producao_id integer   NOT NULL  , 
      ordem_producao_situacao_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_producao_vendas( 
      id  SERIAL    NOT NULL  , 
      ordem_producao_id integer   NOT NULL  , 
      venda_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      cliente_id integer   NOT NULL  , 
      cliente_contato_id integer   , 
      vendedor_id integer   , 
      ordem_servico_situacao_id integer   NOT NULL  , 
      ordem_servico_producao_etapa_id integer   , 
      condicao_pagamento_id integer   , 
      cliente_endereco_id integer   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      numero_os integer   , 
      numero_orcamento integer   , 
      data_emissao date   NOT NULL  , 
      valor float   NOT NULL  , 
      desconto float   , 
      prazo_entrega date   , 
      validade_dias integer   , 
      data_abertura_os date   , 
      vendedor_comissao float   , 
      vendedor_comissao_avista float   , 
      vendedor_comissao_aprazo float   , 
      observacoes text   , 
      prazo_garantia date   , 
      valor_pago float   , 
      motivo_nao_aprovacao_orcamento text   , 
      valor_avista float   , 
      valor_aprazo float   , 
      valor_faturado_vendas float   , 
      usuario_aprovacao_id integer   , 
      informacoes_transporte text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_garantia_historico( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_id integer   NOT NULL  , 
      observacoes text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_historico( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_situacao_id integer   NOT NULL  , 
      ordem_servico_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      descricao_servico text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade float   NOT NULL  , 
      quantidade_atendida float   , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      desconto float   , 
      arquivo text   , 
      largura float   , 
      altura float   , 
      quantidade_a_faturar float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_despesas( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_item_id integer   NOT NULL  , 
      despesas_servicos_id integer   NOT NULL  , 
      despesas_servicos_tipo_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      valor_unitario float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_ficha_tecnica( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_item_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      quantidade_fixa_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade float   NOT NULL  , 
      custo float   , 
      valor_unitario float   , 
      valor_total float   , 
      quantidade_original float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_mao_obra( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_item_id integer   NOT NULL  , 
      funcionario_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade_horas float   , 
      valor_hora float   , 
      valor_total float   , 
      quantidade_horas_original float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_item_obs_etapas( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_item_id integer   NOT NULL  , 
      ordem_servico_producao_etapa_id integer   NOT NULL  , 
      observacao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_producao_etapa( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      cor text   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE ordem_servico_venda( 
      id  SERIAL    NOT NULL  , 
      ordem_servico_id integer   NOT NULL  , 
      venda_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicadores( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE painel_indicador_usuario( 
      id  SERIAL    NOT NULL  , 
      painel_indicadores_id integer   NOT NULL  , 
      indicador_personalizado_id integer   NOT NULL  , 
      system_users_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pais( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      codigo_pais text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE parceiro( 
      id  SERIAL    NOT NULL  , 
      certificado_venda_modalidade_id integer   NOT NULL  , 
      tabela_preco_id integer   , 
      vendedor_id integer   , 
      cpf_cnpj text   NOT NULL  , 
      nome text   NOT NULL  , 
      razao_social text   , 
      cep text   , 
      logradouro text   , 
      bairro text   , 
      cidade text   , 
      estado text   , 
      fone text   , 
      email text   , 
      contato text   , 
      contato_fone text   , 
      comissao_percentual float   , 
      deletado_em timestamp   , 
      criado_em timestamp   NOT NULL  , 
      alterado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      banco_id integer   , 
      banco_agencia text   , 
      banco_conta text   , 
      banco_chavepix text   , 
      banco_nome_titular text   , 
      banco_cpfcnpj text   , 
      chave_pix_tipo_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pdv_permissoes( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pedido_evento( 
      id  SERIAL    NOT NULL  , 
      notafiscal_id integer   , 
      system_unit_id integer   , 
      system_users_id integer   , 
      chave varchar  (50)   , 
      descricao text   , 
      tipo varchar  (30)   , 
      numero varchar  (10)   , 
      serie integer   , 
      nseqevento integer   , 
      protocolo varchar  (20)   , 
      status integer     DEFAULT 1, 
      protocolo_resposta varchar  (50)   , 
      xevento text   , 
      created_at timestamp   , 
      update_at timestamp   , 
      deleted_at timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE pessoa_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      plano_conta_tipo_id integer   NOT NULL  , 
      plano_conta_origem_id integer   NOT NULL  , 
      plano_conta_pai_id integer   , 
      numero text   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_origem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE plano_conta_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto( 
      id  SERIAL    NOT NULL  , 
      produto_grupo_id integer   NOT NULL  , 
      unidade_medida_id integer   NOT NULL  , 
      tipo_recurso_id integer   NOT NULL  , 
      produto_fabricante_id integer   , 
      produtogrupo_subgrupo_id integer   , 
      notafiscal_item_orig_id integer   , 
      nome text   NOT NULL  , 
      nome_curto text   , 
      codigo_EAN text   , 
      imagem text   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      ncm text   , 
      cest text   , 
      criado_por text   , 
      alterado_por text   , 
      obs text   , 
      referencia text   , 
      deletado_em timestamp   , 
      especificacao text   , 
      link_site text   , 
      peso_liquido float   , 
      peso_bruto float   , 
      habilitado_id integer   , 
      produto_tipo_id integer   , 
      codigo_sku text   , 
      largura float   , 
      altura float   , 
      comprimento float   , 
      diametro float   , 
      dias_preparacao float   , 
      marca text   , 
      garantia text   , 
      unidade_caixa float   , 
      produto_embalagem_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_embalagem( 
      id  SERIAL    NOT NULL  , 
      produto_tipo_embalagem_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      peso float   , 
      dimensoes text   NOT NULL  , 
      altura float   , 
      largura float   , 
      comprimento float   , 
      diametro float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_enderecamento( 
      id  SERIAL    NOT NULL  , 
      produto_filial_id integer   NOT NULL  , 
      estoque_prateleira_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_etiqueta_configuracoes( 
      id  SERIAL    NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fabricante( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      custo_total float   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_despesas( 
      id  SERIAL    NOT NULL  , 
      produto_ficha_tecnica_id integer   NOT NULL  , 
      despesas_servicos_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      valor_unitario float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_etapas_producao( 
      id  SERIAL    NOT NULL  , 
      produto_ficha_tecnica_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      ordem integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_itens( 
      id  SERIAL    NOT NULL  , 
      produto_ficha_tecnica_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_custo float   , 
      valor_total float   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade_fixa_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_ficha_tecnica_mao_obra( 
      id  SERIAL    NOT NULL  , 
      produto_ficha_tecnica_id integer   NOT NULL  , 
      funcionario_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      valor_hora float   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial( 
      id  SERIAL    NOT NULL  , 
      produto_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      margem float   , 
      preco_venda float   NOT NULL  , 
      preco_venda_anterior float   , 
      valor_custo float   , 
      valor_custo_anterior float   , 
      criado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
      estoque_minimo float   , 
      estoque_maximo float   , 
      local_estoque text   , 
      codigo_balanca text   , 
      deletado_em timestamp   , 
      estoque_deposito_padrao_id integer   , 
      sob_encomenda_id integer   , 
      gerar_op_venda_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_filial_historico( 
      id  SERIAL    NOT NULL  , 
      produto_id integer   NOT NULL  , 
      produto_filial_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      preco_venda_antigo float   NOT NULL  , 
      preco_venda_novo float   NOT NULL  , 
      valor_custo_antigo float   , 
      valor_custo_novo float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_fornecedor( 
      id  SERIAL    NOT NULL  , 
      produto_id integer   NOT NULL  , 
      fornecedor_id integer   NOT NULL  , 
      codigo_fornecedor text   , 
      descricao_produto_fornecedor text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      tempo_medio_fornecimento float   , 
      quantidade_minima_compra float   , 
      preco_venda float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_grupo( 
      id  SERIAL    NOT NULL  , 
      tipo_recurso_id integer   , 
      descricao text   NOT NULL  , 
      imagem text   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por text   , 
      alterado_por text   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produtogrupo_subgrupo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      produto_grupo_id integer   NOT NULL  , 
      subgrupo_id integer   , 
      nivel integer   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_lote( 
      id  SERIAL    NOT NULL  , 
      produto_id integer   NOT NULL  , 
      numero text   NOT NULL  , 
      validade date   , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por text   , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE produto_tipo_embalagem( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE resposta( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE servico_formapgto( 
      id  SERIAL    NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      ordem_servico_id integer   NOT NULL  , 
      quantidade_parcelas integer   , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document( 
      id integer   NOT NULL  , 
      category_id integer   NOT NULL  , 
      system_user_id integer   , 
      title text   NOT NULL  , 
      description text   , 
      submission_date date   , 
      archive_date date   , 
      filename text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_category( 
      id integer   NOT NULL  , 
      name text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_group( 
      id integer   NOT NULL  , 
      document_id integer   NOT NULL  , 
      system_group_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_document_user( 
      id integer   NOT NULL  , 
      document_id integer   NOT NULL  , 
      system_user_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group( 
      id integer   NOT NULL  , 
      name text   NOT NULL  , 
      uuid varchar  (36)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program( 
      id integer   NOT NULL  , 
      system_group_id integer   NOT NULL  , 
      system_program_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_group_program_permissoes( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      system_program_permissoes_id integer   NOT NULL  , 
      system_group_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_message( 
      id integer   NOT NULL  , 
      system_user_id integer   NOT NULL  , 
      system_user_to_id integer   NOT NULL  , 
      subject text   NOT NULL  , 
      message text   , 
      dt_message timestamp   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_notification( 
      id integer   NOT NULL  , 
      system_user_id integer   NOT NULL  , 
      system_user_to_id integer   NOT NULL  , 
      subject text   , 
      message text   , 
      dt_message timestamp   , 
      action_url text   , 
      action_label text   , 
      icon text   , 
      checked char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_preference( 
      id varchar  (255)   NOT NULL  , 
      preference text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program( 
      id integer   NOT NULL  , 
      name text   NOT NULL  , 
      controller text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_program_permissoes( 
      id  SERIAL    NOT NULL  , 
      system_program_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_unit( 
      id integer   NOT NULL  , 
      connection_name text   , 
      vendas_natureza_operacao_id integer   , 
      nfce_natureza_operacao_id integer   , 
      cnpj varchar  (14)   NOT NULL  , 
      name text   NOT NULL  , 
      razao_social varchar  (255)   NOT NULL  , 
      inscricao_estadual varchar  (255)   , 
      inscricao_municipal varchar  (255)   , 
      fone text   , 
      notafiscal_crt_id integer   NOT NULL  , 
      pc_credito_sn float     DEFAULT 0, 
      aliquota_iss float   , 
      aliquota_irrf float   , 
      aliquota_csll float   , 
      sn_matriz char  (1)   NOT NULL    DEFAULT 'N', 
      nfce_tpamb_id integer   , 
      nfe_tpamb_id integer   , 
      nfe_tpimp_id integer   , 
      nfce_tpimp_id integer   , 
      certificadoA1 text   , 
      senha_certificado text   , 
      nfe_homologacao_series_id integer   , 
      nfe_producao_series_id integer   , 
      nfce_homologacao_series_id integer   , 
      nfe_api_documentos_id integer   , 
      nfce_api_documentos_id integer   , 
      nfce_producao_series_id integer   , 
      end_cep text   , 
      end_mun_codibge text   , 
      end_municipio text   , 
      end_uf char  (2)   , 
      end_logradouro text   , 
      end_bairro text   , 
      end_numero text   , 
      end_complemento text   , 
      nfce_csc_homologacao text   , 
      nfce_csc_producao text   , 
      notafiscal_cprod_padrao_id integer   , 
      nfce_id_csc_homologacao text   , 
      nfce_id_csc_producao text   , 
      email varchar  (255)   , 
      token_api text   , 
      mdfe_tpamb_id integer   , 
      mdfe_estadoini_id integer   , 
      veiculo_id integer   , 
      mdfe_api_documentos_id integer   , 
      mdfe_homologacao_series_id integer   , 
      mdfe_producao_series_id integer   , 
      natureza_operacao_compra_id integer   , 
      logo text   , 
      contador_nome text   , 
      contador_documento text   , 
      contador_email text   , 
      contador_celular text   , 
      config_host text   , 
      config_user text   , 
      config_password text   , 
      config_port varchar  (11)     DEFAULT '587', 
      config_from text   , 
      config_replyname text   , 
      config_replyto text   , 
      column_63 integer   , 
      cnae text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_group( 
      id integer   NOT NULL  , 
      system_user_id integer   NOT NULL  , 
      system_group_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_pdv_permissoes( 
      id  SERIAL    NOT NULL  , 
      empresa_id integer   NOT NULL  , 
      pdv_permissoes_id integer   NOT NULL  , 
      system_user_id integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program( 
      id integer   NOT NULL  , 
      system_user_id integer   NOT NULL  , 
      system_program_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_program_permissoes( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      system_users_id integer   NOT NULL  , 
      system_program_permissoes_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_users( 
      id integer   NOT NULL  , 
      name text   NOT NULL  , 
      login text   NOT NULL  , 
      password text   NOT NULL  , 
      email text   , 
      frontpage_id integer   , 
      system_unit_id integer   , 
      active char  (1)   , 
      accepted_term_policy char  (1)   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE system_user_unit( 
      id integer   NOT NULL  , 
      system_user_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco( 
      id  SERIAL    NOT NULL  , 
      tabela_preco_tipo_alteracao_id integer   NOT NULL  , 
      tabela_preco_tipo_id integer   , 
      descricao text   NOT NULL  , 
      observacao text   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      data_hora_promocao_inicial timestamp   , 
      data_hora_promocao_final timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_produto( 
      id  SERIAL    NOT NULL  , 
      tabela_preco_id integer   NOT NULL  , 
      produto_filial_id integer   NOT NULL  , 
      preco_venda float   NOT NULL  , 
      valor_parametro float   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tabela_preco_tipo_alteracao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_documento( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE tipo_recurso( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE titulos_tipo_anexo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE unidade_medida( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      sigla text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo( 
      id  SERIAL    NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      modelo_marca text   NOT NULL  , 
      placa text   NOT NULL  , 
      ano integer   , 
      tara float   , 
      capacidade_kg float   , 
      renavam text   , 
      capacidade_m3 float   , 
      mdfe_tpRod_id integer   NOT NULL  , 
      estado_id integer   NOT NULL  , 
      veiculo_tipo_id integer   NOT NULL  , 
      mdfe_tpcar_id integer   NOT NULL  , 
      funcionario_motorista_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE veiculo_tipo( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda( 
      id  SERIAL    NOT NULL  , 
      venda_situacao_id integer   NOT NULL  , 
      orcamento_id integer   , 
      vendedor_id integer   , 
      dispositivos_id integer   , 
      cliente_id integer   , 
      numero_celula_consumo text   , 
      system_unit_id integer   NOT NULL  , 
      filial_saida_id integer   NOT NULL  , 
      venda_modalidade_id integer   NOT NULL  , 
      venda_tipo_pagamento_id integer   NOT NULL  , 
      id_venda_local integer   , 
      data_hora_venda timestamp   NOT NULL  , 
      valor_produtos float   NOT NULL  , 
      valor_troco float   , 
      desconto float   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      observacao text   , 
      observacao_nf text   , 
      peso_total float   , 
      frete_total float   , 
      valor_total float   NOT NULL  , 
      cliente_endereco_id integer   , 
      info_faturamento text   , 
      data_prev_entrega date   , 
      criado_por text   , 
      alterado_por text   , 
      valor_comissao float   , 
      comissao_avista float   , 
      comissao_aprazo integer   , 
      valor_avista float   , 
      valor_aprazo float   , 
      tabela_preco_id integer   , 
      movimentacao_origem_id integer   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao( 
      id  SERIAL    NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      venda_id integer   NOT NULL  , 
      data_devolucao date   NOT NULL  , 
      valor float   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_itens( 
      id  SERIAL    NOT NULL  , 
      venda_devolucao_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade float   NOT NULL  , 
      valor_unitario float   , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_devolucao_troca( 
      id  SERIAL    NOT NULL  , 
      venda_devolucao_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      quantidade float   NOT NULL  , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_formapgto( 
      id  SERIAL    NOT NULL  , 
      forma_pagamento_id integer   NOT NULL  , 
      venda_id integer   NOT NULL  , 
      quantidade_parcelas integer   , 
      valor float   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_item( 
      id  SERIAL    NOT NULL  , 
      venda_id integer   NOT NULL  , 
      produto_id integer   NOT NULL  , 
      quantidade float   NOT NULL  , 
      valor_unitario float   NOT NULL  , 
      valor_total float   NOT NULL  , 
      valor_original float   NOT NULL  , 
      valor_custo float   , 
      desconto float   , 
      informacoes_adicionais text   , 
      cancelado integer   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      numero_pedido text   , 
      numero_item_pedido text   , 
      valor_frete float   , 
      peso_unitario float   , 
      peso_total float   , 
      estoque_deposito_id integer   , 
      produto_lote_id integer   , 
      quantidade_devolvida float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta( 
      id  SERIAL    NOT NULL  , 
      venda_meta_situacao_id integer   NOT NULL  , 
      system_unit_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      data_inicial date   NOT NULL  , 
      data_final date   NOT NULL  , 
      valor_meta_geral_prevista float   NOT NULL  , 
      valor_meta_geral_realizada float   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      data_ultimo_processamento timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_meta_vendedor( 
      id  SERIAL    NOT NULL  , 
      venda_meta_id integer   NOT NULL  , 
      vendedor_id integer   NOT NULL  , 
      valor_meta_prevista float   , 
      valor_meta_realizada float   , 
      criado_em timestamp   NOT NULL  , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   NOT NULL  , 
      alterado_em timestamp   , 
      aproveiramento_carteira_prevista float   , 
      aproveitamento_carteira_realizada float   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_modalidade( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      situacaopdv_id integer   , 
      ordem integer   , 
      cor text   , 
      criado_por text   NOT NULL  , 
      alterado_por text   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_situacao_historico( 
      id  SERIAL    NOT NULL  , 
      venda_situacao_id integer   NOT NULL  , 
      venda_id integer   NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   NOT NULL  , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE venda_tipo_pagamento( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor( 
      id  SERIAL    NOT NULL  , 
      nome text   NOT NULL  , 
      cpf text   , 
      vendedor_tipo_comissao_id integer   , 
      vendedor_tipo_pgto_comissao_id integer   , 
      criado_em timestamp   , 
      alterado_em timestamp   , 
      percentual_comissao float   , 
      criado_por text   , 
      alterado_por text   , 
      deletado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_comissao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE vendedor_tipo_pgto_comissao( 
      id  SERIAL    NOT NULL  , 
      descricao text   NOT NULL  , 
      criado_em timestamp   , 
      deletado_em timestamp   , 
      alterado_por text   , 
      criado_por text   , 
      alterado_em timestamp   , 
 PRIMARY KEY (id)) ; 

CREATE TABLE xml_contador( 
      id  SERIAL    NOT NULL  , 
      data_inicio date   , 
      data_fim date   , 
      system_user_id integer   , 
      system_unit_id integer   , 
      data_solicitacao timestamp   , 
      caminho_download varchar  (255)   , 
      updated_at timestamp   , 
      created_at timestamp   , 
      info_registros varchar  (255)   , 
      data_click timestamp   , 
      status_id integer     DEFAULT 0, 
      situacao integer     DEFAULT 1, 
      caminho_pdf varchar  (255)   , 
      contador integer     DEFAULT 0, 
      contador_email integer     DEFAULT 0, 
      downloads integer     DEFAULT 0, 
      rota text   , 
      chave varchar  (20)   , 
 PRIMARY KEY (id)) ; 

 
 ALTER TABLE dispositivos ADD UNIQUE (token);
  
 ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE api_documentos ADD CONSTRAINT fk_api_documentos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_1 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE apidocumentos_integradoresservicos ADD CONSTRAINT fk_apidocumentos_integradoresservicos_2 FOREIGN KEY (integradores_servicos_id) references integradores_servicos(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_2 FOREIGN KEY (caixa_situacao_id) references caixa_situacao(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_3 FOREIGN KEY (system_users_abertura_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_4 FOREIGN KEY (system_users_operador_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_5 FOREIGN KEY (system_users_fechamento_id) references system_users(id); 
ALTER TABLE caixa ADD CONSTRAINT fk_caixa_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_1 FOREIGN KEY (caixa_id) references caixa(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_3 FOREIGN KEY (caixa_tipo_lancamento_id) references caixa_tipo_lancamento(id); 
ALTER TABLE caixa_lancamentos ADD CONSTRAINT fk_caixa_lancamentos_4 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_1 FOREIGN KEY (centro_custo_tipo_id) references centro_custo_tipo(id); 
ALTER TABLE centro_custo ADD CONSTRAINT fk_centro_custo_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_agendamentos ADD CONSTRAINT fk_certificado_agendamentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_agente_registro ADD CONSTRAINT fk_certificado_agente_registro_1 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_2 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_4 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_cliente ADD CONSTRAINT fk_certificado_cliente_5 FOREIGN KEY (certificado_cliente_situacao_id) references certificado_cliente_situacao(id); 
ALTER TABLE certificado_email_historico ADD CONSTRAINT fk_certificado_email_historico_1 FOREIGN KEY (certificado_cliente_id) references certificado_cliente(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_1 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificadora_produtos ADD CONSTRAINT fk_certificadora_produtos_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_venda_certificado_4 FOREIGN KEY (parceiro_id) references parceiro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_agente_registro_id) references certificado_agente_registro(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_5 FOREIGN KEY (certificado_venda_situacao_id) references certificado_venda_situacao(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_6 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_7 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_8 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_9 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_12 FOREIGN KEY (certificado_tipo_atendimento_id) references certificado_tipo_atendimento(id); 
ALTER TABLE certificado_venda ADD CONSTRAINT fk_certificado_venda_13 FOREIGN KEY (certificadora_id) references certificadora(id); 
ALTER TABLE certificado_venda_documentos ADD CONSTRAINT fk_certificado_venda_documentos_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_1 FOREIGN KEY (certificado_venda_id) references certificado_venda(id); 
ALTER TABLE certificado_venda_formapgto ADD CONSTRAINT fk_certificado_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_1 FOREIGN KEY (certificado_venda_tipomodalidade_id) references certificado_venda_tipomodalidade(id); 
ALTER TABLE certificado_venda_modalidade ADD CONSTRAINT fk_certificado_venda_modalidade_2 FOREIGN KEY (certificado_tipo_repasse_id) references certificado_tipo_repasse(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE cidade ADD CONSTRAINT fk_cidade_2 FOREIGN KEY (pais_id) references pais(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_10 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_3 FOREIGN KEY (residencia_propria) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_4 FOREIGN KEY (utilizar_endereco_cobranca) references resposta(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_5 FOREIGN KEY (cliente_situacao_id) references cliente_situacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_7 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_8 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_9 FOREIGN KEY (cliente_classificacao_subgrupo_id) references cliente_classificacao_subgrupo(id); 
ALTER TABLE cliente ADD CONSTRAINT fk_cliente_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE cliente_classificacao ADD CONSTRAINT fk_cliente_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE cliente_classificacao_subgrupo ADD CONSTRAINT fk_cliente_classificacao_subgrupo_1 FOREIGN KEY (cliente_classificacao_id) references cliente_classificacao(id); 
ALTER TABLE cliente_contato ADD CONSTRAINT fk_cliente_contato_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_2 FOREIGN KEY (principal) references resposta(id); 
ALTER TABLE cliente_endereco ADD CONSTRAINT fk_cliente_endereco_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE cliente_historico_limite ADD CONSTRAINT fk_cliente_historico_limite_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_1 FOREIGN KEY (forma_pagamento_id_dinheiro_caixa) references forma_pagamento(id); 
ALTER TABLE configuracoes ADD CONSTRAINT fk_configuracoes_2 FOREIGN KEY (forma_pagamento_id_titulos_cpag_nf) references forma_pagamento(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_1 FOREIGN KEY (configuracoes_id) references configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_2 FOREIGN KEY (produto_etiqueta_configuracoes_id) references produto_etiqueta_configuracoes(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_4 FOREIGN KEY (plano_conta_crec_id) references plano_conta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_5 FOREIGN KEY (centro_custo_crec_id) references centro_custo(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_6 FOREIGN KEY (cpag_usa_plano_contas_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_9 FOREIGN KEY (notafiscal_cprod_padrao_orcamento_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_7 FOREIGN KEY (informar_duplicidade_de_item_venda_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_8 FOREIGN KEY (venda_apenas_com_estoque_id) references resposta(id); 
ALTER TABLE configuracoes_filial ADD CONSTRAINT fk_configuracoes_filial_10 FOREIGN KEY (notafiscal_cprod_padrao_venda_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_1 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_2 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_3 FOREIGN KEY (contabil_lancamentos_tipo_id) references contabil_lancamentos_tipo(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_4 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_5 FOREIGN KEY (contaspag_contabil_id) references contaspag_contabil(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_6 FOREIGN KEY (conta_corrente_lancamentos_id) references conta_corrente_lancamentos(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_7 FOREIGN KEY (contabil_lancamentos_situacao_id) references contabil_lancamentos_situacao(id); 
ALTER TABLE contabil_lancamentos ADD CONSTRAINT fk_contabil_lancamentos_8 FOREIGN KEY (contabil_lancamentos_origem_id) references contabil_lancamentos_origem(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_1 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE conta_corrente ADD CONSTRAINT fk_conta_corrente_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_1 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_2 FOREIGN KEY (conta_corrente_lanc_tipo_id) references conta_corrente_lanc_tipo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_5 FOREIGN KEY (contaspag_baixas_id) references contaspag_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_6 FOREIGN KEY (contasrec_baixas_id) references contasrec_baixas(id); 
ALTER TABLE conta_corrente_lancamentos ADD CONSTRAINT fk_conta_corrente_lancamentos_7 FOREIGN KEY (conta_corrente_lanc_origem_id) references conta_corrente_lanc_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_1 FOREIGN KEY (contaspag_situacao_id) references contaspag_situacao(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_3 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_4 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_5 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_6 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_7 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag ADD CONSTRAINT fk_contaspag_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_anexos ADD CONSTRAINT fk_contaspag_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_baixas ADD CONSTRAINT fk_contaspag_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_agrupamento_3 FOREIGN KEY (contaspag_origem_id) references contaspag_origem(id); 
ALTER TABLE contaspag_bloco ADD CONSTRAINT fk_contaspag_bloco_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_bloco_contabil ADD CONSTRAINT fk_contaspag_agrupamento_contabil_3 FOREIGN KEY (contaspag_bloco_id) references contaspag_bloco(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contaspag_contabil ADD CONSTRAINT fk_contaspag_contabil_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contaspag_historico_venc ADD CONSTRAINT fk_contaspag_historico_venc_1 FOREIGN KEY (contaspag_id) references contaspag(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_1 FOREIGN KEY (contasrec_situacao_id) references contasrec_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_2 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_3 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_4 FOREIGN KEY (contasrec_origem_id) references contasrec_origem(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_6 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_7 FOREIGN KEY (cheque_banco_id) references banco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_8 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_9 FOREIGN KEY (conta_corrente_boleto_id) references conta_corrente(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_10 FOREIGN KEY (boleto_situacao_id) references boleto_situacao(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_11 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_12 FOREIGN KEY (contasrec_bloco_id) references contasrec_bloco(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_13 FOREIGN KEY (venda_formapgto_id) references venda_formapgto(id); 
ALTER TABLE contasrec ADD CONSTRAINT fk_contasrec_14 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_anexos ADD CONSTRAINT fk_contasrec_anexos_2 FOREIGN KEY (titulos_tipo_anexo_id) references titulos_tipo_anexo(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_baixas ADD CONSTRAINT fk_contasrec_baixas_2 FOREIGN KEY (conta_corrente_id) references conta_corrente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_4 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE contasrec_bloco ADD CONSTRAINT fk_contasrec_bloco_5 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE contasrec_historico_cobranca ADD CONSTRAINT fk_contasrec_historico_cobranca_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE contasrec_historico_venc ADD CONSTRAINT fk_contasrec_historico_venc_1 FOREIGN KEY (contasrec_id) references contasrec(id); 
ALTER TABLE cst_icms ADD CONSTRAINT fk_cst_icms_1 FOREIGN KEY (regime_tributario_id) references notafiscal_crt(id); 
ALTER TABLE despesas_servicos ADD CONSTRAINT fk_despesas_servicos_1 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE dispositivos ADD CONSTRAINT fk_dispositivos_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_deposito ADD CONSTRAINT fk_estoque_deposito_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_estante ADD CONSTRAINT fk_estoque_estante_1 FOREIGN KEY (estoque_rua_id) references estoque_rua(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_1 FOREIGN KEY (estoque_origem_id) references estoque_origem(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_2 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_4 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_5 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_6 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_8 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE estoque_lancamentos ADD CONSTRAINT fk_estoque_lancamentos_9 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE estoque_origem ADD CONSTRAINT fk_estoque_origem_1 FOREIGN KEY (estoque_tipo_movimentacao_id) references estoque_tipo_movimentacao(id); 
ALTER TABLE estoque_prateleira ADD CONSTRAINT fk_estoque_prateleira_1 FOREIGN KEY (estoque_estante_id) references estoque_estante(id); 
ALTER TABLE estoque_rua ADD CONSTRAINT fk_estoque_rua_1 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_3 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE estoque_saldos ADD CONSTRAINT fk_estoque_saldos_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_1 FOREIGN KEY (email_template_id) references email_template(id); 
ALTER TABLE eventos ADD CONSTRAINT fk_eventos_2 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_1 FOREIGN KEY (eventos_id) references eventos(id); 
ALTER TABLE eventos_systemuser ADD CONSTRAINT fk_eventos_systemuser_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_1 FOREIGN KEY (tipo_documento_id) references tipo_documento(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_3 FOREIGN KEY (meio_pagamento_tef_id) references meio_pagamento_tef(id); 
ALTER TABLE forma_pagamento ADD CONSTRAINT fk_forma_pagamento_4 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_1 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE formapgto_condpgto ADD CONSTRAINT fk_formapgto_condpgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_4 FOREIGN KEY (fornecedor_classificacao_id) references fornecedor_classificacao(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_1 FOREIGN KEY (pessoa_tipo_id) references pessoa_tipo(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_3 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE fornecedor ADD CONSTRAINT fk_fornecedor_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE fornecedor_classificacao ADD CONSTRAINT fk_fornecedor_classificacao_1 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE fornecedor_contato ADD CONSTRAINT fk_fornecedor_contato_1 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE funcionario ADD CONSTRAINT fk_funcionario_1 FOREIGN KEY (funcionario_cargo_id) references funcionario_cargo(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_1 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE funil_etapas ADD CONSTRAINT fk_funil_etapas_2 FOREIGN KEY (ultima_etapa) references resposta(id); 
ALTER TABLE integradores_servicos ADD CONSTRAINT fk_integradores_servicos_1 FOREIGN KEY (integradores_id) references integradores(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE inutilizar_numero ADD CONSTRAINT fk_inutilizar_numero_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_1 FOREIGN KEY (mdfe_tpemit_id) references mdfe_tpemit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_2 FOREIGN KEY (mdfe_tpprop_id) references mdfe_tpprop(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_4 FOREIGN KEY (mdfe_tptransp_id) references mdfe_tptransp(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_6 FOREIGN KEY (UFIni) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_7 FOREIGN KEY (UFFim) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_8 FOREIGN KEY (indCanalVerde) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_9 FOREIGN KEY (indCarregaPosterior) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_10 FOREIGN KEY (mdfe_respSeg_id) references mdfe_respSeg(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_11 FOREIGN KEY (mdfe_cunid_id) references mdfe_cunid(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_12 FOREIGN KEY (mdfe_tpcarga_id) references mdfe_tpcarga(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_13 FOREIGN KEY (mdfe_indpag_id) references mdfe_indpag(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_14 FOREIGN KEY (indAntecipaAdiant) references resposta(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_15 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veic_estado_id) references estado(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_16 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_17 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_18 FOREIGN KEY (mdfe_situacao_id) references mdfe_situacao(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_19 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_20 FOREIGN KEY (api_documentos_id) references api_documentos(id); 
ALTER TABLE mdfe ADD CONSTRAINT fk_mdfe_21 FOREIGN KEY (cidade_encerramento_id) references cidade(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_componentes ADD CONSTRAINT fk_mdfe_componentes_2 FOREIGN KEY (mdfe_tpcomp_id) references mdfe_tpcomp(id); 
ALTER TABLE mdfe_condutor ADD CONSTRAINT fk_mdfe_condutor_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_ctes ADD CONSTRAINT fk_mdfe_ctes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_evento ADD CONSTRAINT fk_mdfe_evento_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_2 FOREIGN KEY (cidade_carrega_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_3 FOREIGN KEY (cidade_descarga_id) references cidade(id); 
ALTER TABLE mdfe_inclusao_dfe ADD CONSTRAINT fk_mdf_inclusao_dfe_4 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmuncarrega ADD CONSTRAINT fk_mdfe_infmuncarrega_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infmundescarga ADD CONSTRAINT fk_mdfe_infmundescarga_2 FOREIGN KEY (cidade_id) references cidade(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_infpercurso ADD CONSTRAINT fk_mdfe_infpercurso_2 FOREIGN KEY (UFPer) references estado(id); 
ALTER TABLE mdfe_lacres ADD CONSTRAINT fk_mdfe_lacres_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_logs ADD CONSTRAINT fk_mdfe_logs_2 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_mdfes ADD CONSTRAINT fk_mdfe_mdfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_2 FOREIGN KEY (mdfe_infmundescarga_id) references mdfe_infmundescarga(id); 
ALTER TABLE mdfe_nfes ADD CONSTRAINT fk_mdfe_nfes_1 FOREIGN KEY (indReentrega) references resposta(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE mdfe_parcelas ADD CONSTRAINT fk_mdfe_parcelas_2 FOREIGN KEY (mdfe_tpAntecip_id) references mdfe_tpAntecip(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE mdfe_series ADD CONSTRAINT fk_mdfe_series_2 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE mdfe_xmlaut ADD CONSTRAINT fk_mdfe_xmlaut_1 FOREIGN KEY (mdfe_id) references mdfe(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_1 FOREIGN KEY (natureza_operacao_finalidade_id) references natureza_operacao_finalidade(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_2 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_3 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_4 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_5 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_6 FOREIGN KEY (consumidor_final_id) references resposta(id); 
ALTER TABLE natureza_operacao ADD CONSTRAINT fk_natureza_operacao_10 FOREIGN KEY (cst_icms_nao_contribuinte_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_estados ADD CONSTRAINT fk_natureza_operacao_estados_1 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_2 FOREIGN KEY (natop_excecao_tributo_id) references natop_excecao_tributo(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_1 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_3 FOREIGN KEY (cst_pis_id) references cst_pis(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_4 FOREIGN KEY (cst_ipi_id) references cst_ipi(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_5 FOREIGN KEY (cst_icms_id) references cst_icms(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_6 FOREIGN KEY (cst_cofins_id) references cst_cofins(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_7 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_8 FOREIGN KEY (notafiscal_item_modbcst_id) references notafiscal_item_modbcst(id); 
ALTER TABLE natureza_operacao_excecao ADD CONSTRAINT fk_natureza_operacao_excecao_9 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE natureza_operacao_ncm ADD CONSTRAINT fk_natureza_operacao_ncm_1 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_origens ADD CONSTRAINT fk_natureza_operacao_origens_1 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_2 FOREIGN KEY (natureza_operacao_excecao_id) references natureza_operacao_excecao(id); 
ALTER TABLE natureza_operacao_produtos ADD CONSTRAINT fk_natureza_operacao_produtos_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_1 FOREIGN KEY (negocio_origem_id) references negocio_origem(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_3 FOREIGN KEY (negocio_motivo_perda_id) references negocio_motivo_perda(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_4 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_5 FOREIGN KEY (ativo_id) references ativo(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_6 FOREIGN KEY (arquivado) references resposta(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_7 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_9 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_8 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE negocio ADD CONSTRAINT fk_negocio_10 FOREIGN KEY (funil_id) references funil(id); 
ALTER TABLE negocio_arquivos ADD CONSTRAINT fk_negocio_arquivos_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_atividade ADD CONSTRAINT fk_negocio_atividade_2 FOREIGN KEY (negocio_tipo_atividade_id) references negocio_tipo_atividade(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_etapas_historico ADD CONSTRAINT fk_negocio_etapas_historico_2 FOREIGN KEY (funil_etapas_id) references funil_etapas(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE negocio_itens ADD CONSTRAINT fk_negocio_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE negocio_notas ADD CONSTRAINT fk_negocio_notas_1 FOREIGN KEY (negocio_id) references negocio(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_17 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_18 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_2 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_3 FOREIGN KEY (nf_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_4 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_5 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_6 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_7 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_8 FOREIGN KEY (notafiscal_tpemis_id) references notafiscal_tpemis(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_16 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_21 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_20 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE notafiscal ADD CONSTRAINT fk_notafiscal_19 FOREIGN KEY (natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE notafiscal_autxml ADD CONSTRAINT fk_notafiscal_autxml_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_3 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_4 FOREIGN KEY (nota_fiscal_compra_situacao_id) references nota_fiscal_compra_situacao(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_5 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_6 FOREIGN KEY (notafiscal_indiedest_id) references notafiscal_indiedest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_7 FOREIGN KEY (notafiscal_iddest_id) references notafiscal_iddest(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_8 FOREIGN KEY (notafiscal_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_9 FOREIGN KEY (notafiscal_finnfe_id) references notafiscal_finnfe(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_10 FOREIGN KEY (notafiscal_indfinal_id) references notafiscal_indfinal(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_11 FOREIGN KEY (notafiscal_indpres_id) references notafiscal_indpres(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_12 FOREIGN KEY (notafiscal_indpag_id) references notafiscal_indpag(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_13 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE nota_fiscal_compra ADD CONSTRAINT fk_nota_fiscal_compra_14 FOREIGN KEY (notafiscal_modfrete_id) references notafiscal_modfrete(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_3 FOREIGN KEY (plano_conta_id) references plano_conta(id); 
ALTER TABLE nota_fiscal_compra_dup ADD CONSTRAINT fk_nota_fiscal_compra_dup_4 FOREIGN KEY (centro_custo_id) references centro_custo(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_9 FOREIGN KEY (nota_fiscal_compra_itens_situacao_id) references nota_fiscal_compra_itens_situacao(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_7 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE nota_fiscal_compra_itens ADD CONSTRAINT fk_nota_fiscal_compra_itens_8 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_1 FOREIGN KEY (nota_fiscal_compra_id) references nota_fiscal_compra(id); 
ALTER TABLE nota_fiscal_compra_pag ADD CONSTRAINT fk_nota_fiscal_compra_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_dup ADD CONSTRAINT fk_notafiscal_dup_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_frete_volumes ADD CONSTRAINT fk_notafiscal_frete_volumes_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_6 FOREIGN KEY (notafiscal_item_motDesICMS_id) references notafiscal_item_motDesICMS(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_4 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_5 FOREIGN KEY (notafiscal_item_modbc_id) references notafiscal_item_modbc(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE notafiscal_itens ADD CONSTRAINT fk_notafiscal_itens_3 FOREIGN KEY (notafiscal_item_indtot_id) references notafiscal_item_indtot(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE notafiscal_logs ADD CONSTRAINT fk_notafiscal_logs_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_pag ADD CONSTRAINT fk_notafiscal_pag_2 FOREIGN KEY (notafiscal_tpag_id) references notafiscal_tpag(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_1 FOREIGN KEY (notafiscal_refecfmod_id) references notafiscal_refecfmod(id); 
ALTER TABLE notafiscal_refecf ADD CONSTRAINT fk_notafiscal_refecf_2 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_refnfe ADD CONSTRAINT fk_notafiscal_refnfe_1 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_4 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_1 FOREIGN KEY (notafiscal_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_2 FOREIGN KEY (notafiscal_mod_id) references notafiscal_mod(id); 
ALTER TABLE notafiscal_series ADD CONSTRAINT fk_notafiscal_series_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE notafiscal_situacao_sefaz ADD CONSTRAINT fk_notafiscal_situacao_sefaz_1 FOREIGN KEY (notafiscal_situacao_id) references notafiscal_situacao(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_1 FOREIGN KEY (notafiscal_series_id) references notafiscal_series(id); 
ALTER TABLE notafiscal_tipodoc_series ADD CONSTRAINT fk_notafiscal_tipodoc_series_2 FOREIGN KEY (notafiscal_tipodocumento_id) references notafiscal_tipodocumento(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_3 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_4 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_5 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE orcamento ADD CONSTRAINT fk_orcamento_6 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE orcamento_interacoes ADD CONSTRAINT fk_orcamento_interacoes_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_1 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE orcamento_item ADD CONSTRAINT fk_orcamento_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_1 FOREIGN KEY (orcamento_situacao_id) references orcamento_situacao(id); 
ALTER TABLE orcamento_situacao_historico ADD CONSTRAINT fk_orcamento_situacao_historico_2 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_2 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_3 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_producao ADD CONSTRAINT fk_ordem_producao_5 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_2 FOREIGN KEY (ordem_producao_etapas_situacao_id) references ordem_producao_etapas_situacao(id); 
ALTER TABLE ordem_producao_etapas ADD CONSTRAINT fk_ordem_producao_etapas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_itens ADD CONSTRAINT fk_ordem_producao_itens_3 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_1 FOREIGN KEY (ordem_producao_situacao_id) references ordem_producao_situacao(id); 
ALTER TABLE ordem_producao_situacao_historico ADD CONSTRAINT fk_ordem_producao_situacao_historico_2 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_1 FOREIGN KEY (ordem_producao_id) references ordem_producao(id); 
ALTER TABLE ordem_producao_vendas ADD CONSTRAINT fk_ordem_producao_vendas_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (cliente_contato_id) references cliente_contato(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_7 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_8 FOREIGN KEY (usuario_aprovacao_id) references system_users(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_9 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_3 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_4 FOREIGN KEY (condicao_pagamento_id) references condicao_pagamento(id); 
ALTER TABLE ordem_servico ADD CONSTRAINT fk_ordem_servico_5 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE ordem_servico_garantia_historico ADD CONSTRAINT fk_ordem_servico_garantia_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_historico ADD CONSTRAINT fk_ordem_servico_historico_2 FOREIGN KEY (ordem_servico_situacao_id) references ordem_servico_situacao(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_item ADD CONSTRAINT fk_ordem_servico_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_3 FOREIGN KEY (despesas_servicos_tipo_id) references despesas_servicos_tipo(id); 
ALTER TABLE ordem_servico_item_despesas ADD CONSTRAINT fk_ordem_servico_item_despesas_4 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE ordem_servico_item_ficha_tecnica ADD CONSTRAINT fk_ordem_servico_item_ficha_tecnica_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_mao_obra ADD CONSTRAINT fk_ordem_servico_item_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_1 FOREIGN KEY (ordem_servico_item_id) references ordem_servico_item(id); 
ALTER TABLE ordem_servico_item_obs_etapas ADD CONSTRAINT fk_ordem_servico_item_obs_etapas_2 FOREIGN KEY (ordem_servico_producao_etapa_id) references ordem_servico_producao_etapa(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE ordem_servico_venda ADD CONSTRAINT fk_ordem_servico_venda_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_1 FOREIGN KEY (painel_indicadores_id) references painel_indicadores(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_2 FOREIGN KEY (indicador_personalizado_id) references indicador_personalizado(id); 
ALTER TABLE painel_indicador_usuario ADD CONSTRAINT fk_painel_indicador_usuario_3 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_2 FOREIGN KEY (certificado_venda_modalidade_id) references certificado_venda_modalidade(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_3 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_4 FOREIGN KEY (banco_id) references banco(id); 
ALTER TABLE parceiro ADD CONSTRAINT fk_parceiro_5 FOREIGN KEY (chave_pix_tipo_id) references chave_pix_tipo(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE pedido_evento ADD CONSTRAINT fk_pedido_evento_3 FOREIGN KEY (notafiscal_id) references notafiscal(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_1 FOREIGN KEY (plano_conta_tipo_id) references plano_conta_tipo(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_2 FOREIGN KEY (plano_conta_origem_id) references plano_conta_origem(id); 
ALTER TABLE plano_conta ADD CONSTRAINT fk_plano_conta_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_2 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_3 FOREIGN KEY (unidade_medida_id) references unidade_medida(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_fabricante_id) references produto_fabricante(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_9 FOREIGN KEY (produtogrupo_subgrupo_id) references produtogrupo_subgrupo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_6 FOREIGN KEY (notafiscal_item_orig_id) references notafiscal_item_orig(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_7 FOREIGN KEY (habilitado_id) references resposta(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_8 FOREIGN KEY (produto_tipo_id) references produto_tipo(id); 
ALTER TABLE produto ADD CONSTRAINT fk_produto_11 FOREIGN KEY (produto_embalagem_id) references produto_embalagem(id); 
ALTER TABLE produto_embalagem ADD CONSTRAINT fk_produto_embalagem_1 FOREIGN KEY (produto_tipo_embalagem_id) references produto_tipo_embalagem(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (estoque_prateleira_id) references estoque_prateleira(id); 
ALTER TABLE produto_enderecamento ADD CONSTRAINT fk_produto_enderecamento_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_ficha_tecnica ADD CONSTRAINT fk_produto_ficha_tecnica_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_despesas ADD CONSTRAINT fk_produto_ficha_tecnica_despesas_2 FOREIGN KEY (despesas_servicos_id) references despesas_servicos(id); 
ALTER TABLE produto_ficha_tecnica_etapas_producao ADD CONSTRAINT fk_produto_ficha_tecnica_etapas_producao_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_ficha_tecnica_itens ADD CONSTRAINT fk_produto_ficha_tecnica_itens_3 FOREIGN KEY (quantidade_fixa_id) references resposta(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_1 FOREIGN KEY (produto_ficha_tecnica_id) references produto_ficha_tecnica(id); 
ALTER TABLE produto_ficha_tecnica_mao_obra ADD CONSTRAINT fk_produto_ficha_tecnica_mao_obra_2 FOREIGN KEY (funcionario_id) references funcionario(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_3 FOREIGN KEY (estoque_deposito_padrao_id) references estoque_deposito(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_4 FOREIGN KEY (sob_encomenda_id) references resposta(id); 
ALTER TABLE produto_filial ADD CONSTRAINT fk_produto_filial_5 FOREIGN KEY (gerar_op_venda_id) references resposta(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_preco_historico_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_filial_historico ADD CONSTRAINT fk_produto_filial_historico_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE produto_fornecedor ADD CONSTRAINT fk_produto_fornecedor_2 FOREIGN KEY (fornecedor_id) references fornecedor(id); 
ALTER TABLE produto_grupo ADD CONSTRAINT fk_produto_grupo_1 FOREIGN KEY (tipo_recurso_id) references tipo_recurso(id); 
ALTER TABLE produtogrupo_subgrupo ADD CONSTRAINT fk_produtogrupo_subgrupo_1 FOREIGN KEY (produto_grupo_id) references produto_grupo(id); 
ALTER TABLE produto_lote ADD CONSTRAINT fk_produto_lote_1 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_1 FOREIGN KEY (ordem_servico_id) references ordem_servico(id); 
ALTER TABLE servico_formapgto ADD CONSTRAINT fk_servico_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_2 FOREIGN KEY (category_id) references system_document_category(id); 
ALTER TABLE system_document ADD CONSTRAINT fk_system_document_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_group ADD CONSTRAINT fk_system_document_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_2 FOREIGN KEY (document_id) references system_document(id); 
ALTER TABLE system_document_user ADD CONSTRAINT fk_system_document_user_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_group_program ADD CONSTRAINT fk_system_group_program_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_1 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_2 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_group_program_permissoes ADD CONSTRAINT fk_system_group_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_message ADD CONSTRAINT fk_system_message_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_notification ADD CONSTRAINT fk_system_notification_2 FOREIGN KEY (system_user_to_id) references system_users(id); 
ALTER TABLE system_program_permissoes ADD CONSTRAINT fk_system_program_permissoes_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_2 FOREIGN KEY (notafiscal_crt_id) references notafiscal_crt(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_4 FOREIGN KEY (nfe_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_5 FOREIGN KEY (nfe_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_13 FOREIGN KEY (nfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_6 FOREIGN KEY (vendas_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_7 FOREIGN KEY (nfce_natureza_operacao_id) references natureza_operacao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_9 FOREIGN KEY (nfe_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_10 FOREIGN KEY (nfe_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_11 FOREIGN KEY (nfce_homologacao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_12 FOREIGN KEY (nfce_producao_series_id) references notafiscal_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_14 FOREIGN KEY (notafiscal_cprod_padrao_id) references notafiscal_cprod_padrao(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (nfce_tpimp_id) references notafiscal_tpimp(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_3 FOREIGN KEY (nfce_tpamb_id) references notafiscal_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_1 FOREIGN KEY (nfce_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_15 FOREIGN KEY (mdfe_tpamb_id) references mdfe_tpamb(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_16 FOREIGN KEY (mdfe_estadoini_id) references estado(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_18 FOREIGN KEY (veiculo_id) references veiculo(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_19 FOREIGN KEY (mdfe_api_documentos_id) references api_documentos(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_20 FOREIGN KEY (mdfe_homologacao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (mdfe_producao_series_id) references mdfe_series(id); 
ALTER TABLE system_unit ADD CONSTRAINT fk_system_unit_21 FOREIGN KEY (natureza_operacao_compra_id) references natureza_operacao(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_1 FOREIGN KEY (system_group_id) references system_group(id); 
ALTER TABLE system_user_group ADD CONSTRAINT fk_system_user_group_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_pdv_permissoes ADD CONSTRAINT fk_system_user_permissoes_pdv_2 FOREIGN KEY (pdv_permissoes_id) references pdv_permissoes(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_1 FOREIGN KEY (system_program_id) references system_program(id); 
ALTER TABLE system_user_program ADD CONSTRAINT fk_system_user_program_2 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_1 FOREIGN KEY (system_users_id) references system_users(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_2 FOREIGN KEY (system_program_permissoes_id) references system_program_permissoes(id); 
ALTER TABLE system_user_program_permissoes ADD CONSTRAINT fk_system_user_program_permissoes_3 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE system_users ADD CONSTRAINT fk_system_user_2 FOREIGN KEY (frontpage_id) references system_program(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_1 FOREIGN KEY (system_user_id) references system_users(id); 
ALTER TABLE system_user_unit ADD CONSTRAINT fk_system_user_unit_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_1 FOREIGN KEY (tabela_preco_tipo_alteracao_id) references tabela_preco_tipo_alteracao(id); 
ALTER TABLE tabela_preco ADD CONSTRAINT fk_tabela_preco_2 FOREIGN KEY (tabela_preco_tipo_id) references tabela_preco_tipo(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_1 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE tabela_preco_produto ADD CONSTRAINT fk_tabela_preco_produto_2 FOREIGN KEY (produto_filial_id) references produto_filial(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_1 FOREIGN KEY (mdfe_tpRod_id) references mdfe_tpRod(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_3 FOREIGN KEY (estado_id) references estado(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_4 FOREIGN KEY (veiculo_tipo_id) references veiculo_tipo(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (mdfe_tpcar_id) references mdfe_tpcar(id); 
ALTER TABLE veiculo ADD CONSTRAINT fk_veiculo_5 FOREIGN KEY (funcionario_motorista_id) references funcionario(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_2 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_1 FOREIGN KEY (cliente_id) references cliente(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_3 FOREIGN KEY (dispositivos_id) references dispositivos(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_4 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_5 FOREIGN KEY (filial_saida_id) references system_unit(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_6 FOREIGN KEY (venda_modalidade_id) references venda_modalidade(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_7 FOREIGN KEY (venda_tipo_pagamento_id) references venda_tipo_pagamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_8 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_9 FOREIGN KEY (orcamento_id) references orcamento(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_10 FOREIGN KEY (cliente_endereco_id) references cliente_endereco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_11 FOREIGN KEY (tabela_preco_id) references tabela_preco(id); 
ALTER TABLE venda ADD CONSTRAINT fk_venda_12 FOREIGN KEY (movimentacao_origem_id) references movimentacao_origem(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_devolucao ADD CONSTRAINT fk_venda_devolucao_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_itens ADD CONSTRAINT fk_venda_devolucao_itens_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_1 FOREIGN KEY (venda_devolucao_id) references venda_devolucao(id); 
ALTER TABLE venda_devolucao_troca ADD CONSTRAINT fk_venda_devolucao_troca_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_2 FOREIGN KEY (forma_pagamento_id) references forma_pagamento(id); 
ALTER TABLE venda_formapgto ADD CONSTRAINT fk_venda_formapgto_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_2 FOREIGN KEY (produto_id) references produto(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_3 FOREIGN KEY (cancelado) references resposta(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_1 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_4 FOREIGN KEY (estoque_deposito_id) references estoque_deposito(id); 
ALTER TABLE venda_item ADD CONSTRAINT fk_venda_item_5 FOREIGN KEY (produto_lote_id) references produto_lote(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_1 FOREIGN KEY (venda_meta_situacao_id) references venda_meta_situacao(id); 
ALTER TABLE venda_meta ADD CONSTRAINT fk_venda_meta_2 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_1 FOREIGN KEY (venda_meta_id) references venda_meta(id); 
ALTER TABLE venda_meta_vendedor ADD CONSTRAINT fk_venda_meta_vendedor_2 FOREIGN KEY (vendedor_id) references vendedor(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_1 FOREIGN KEY (venda_situacao_id) references venda_situacao(id); 
ALTER TABLE venda_situacao_historico ADD CONSTRAINT fk_venda_situacao_historico_2 FOREIGN KEY (venda_id) references venda(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_1 FOREIGN KEY (vendedor_tipo_comissao_id) references vendedor_tipo_comissao(id); 
ALTER TABLE vendedor ADD CONSTRAINT fk_vendedor_2 FOREIGN KEY (vendedor_tipo_pgto_comissao_id) references vendedor_tipo_pgto_comissao(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_1 FOREIGN KEY (system_unit_id) references system_unit(id); 
ALTER TABLE xml_contador ADD CONSTRAINT fk_xml_contador_2 FOREIGN KEY (system_user_id) references system_users(id); 

 CREATE VIEW view_consulta_contabil_por_data AS select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento data_vencimento,
	   p.data_pagamento data_pagamento,
	   p.criado_em data_lancamento
from contaspag p,
	 contaspag_contabil cc,
	 contabil_lancamentos cl
where p.id = cc.contaspag_id 
and   cl.contaspag_contabil_id = cc.id
and   p.deletado_em is null
and   cc.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_vencimento  data_vencimento,
	   p.data_pagamento  data_pagamento,
	   p.criado_em  data_lancamento
from contasrec p,
	 contabil_lancamentos cl
where cl.contasrec_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
union all
select 
	   cl.id contabil_lancamento_id,	
	   p.data_lancamento  data_vencimento,
	   p.data_lancamento  data_pagamento,
	   p.data_lancamento  data_lancamento
from conta_corrente_lancamentos p,
	 contabil_lancamentos cl
where cl.conta_corrente_lancamentos_id = p.id
and   p.deletado_em is null
and   cl.deletado_em is null
; 

CREATE VIEW view_negocio_timeline AS SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'nota' as "tipo"
FROM negocio_notas

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'arquivo' as "tipo"
FROM negocio_arquivos

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'atividade' as "tipo"
FROM negocio_atividade

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'produto' as "tipo"
FROM negocio_itens

UNION ALL

SELECT
    id as "chave",
    negocio_id as "negocio_id",
    criado_em as "criado_em",
    'etapa' as "tipo"
FROM negocio_etapas_historico
; 

CREATE VIEW vw_caixa_resumo AS select c.caixa_id AS caixa_id,
		'Fundo de Caixa' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 3) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Entradas' AS tipo,
        coalesce(sum(c.valor), 0) AS valor 
        from caixa_lancamentos c where (c.caixa_tipo_lancamento_id = 2) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saidas' AS tipo,
        sum(c.valor) AS valor 
        from caixa_lancamentos c 
        where (c.caixa_tipo_lancamento_id = 1) 
        group by c.caixa_id
        union all 
        select c.caixa_id AS caixa_id,
        'Saldo' AS tipo,sum((case when (c.caixa_tipo_lancamento_id = 1) then (c.valor * -(1)) else c.valor end)) AS valor 
        from caixa_lancamentos c 
        group by c.caixa_id
        ; 

CREATE VIEW vw_caixa_resumo_formas AS Select 
    c.caixa_id caixa_id,
    c.forma_pagamento_id forma_pagamento_id,
    f.descricao nome_forma_pagamento,
    sum(case when c.caixa_tipo_lancamento_id = 1 then c.valor * -1 else c.valor end) total
from caixa_lancamentos c,
     forma_pagamento f
where f.id = c.forma_pagamento_id
group by c.caixa_id, c.forma_pagamento_id; 

CREATE VIEW vw_funil_filial AS SELECT DISTINCT
f.id AS id,
f.descricao AS descricao,
n.system_unit_id AS system_unit_id
FROM funil f
INNER JOIN funil_etapas fe ON fe.funil_id = f.id
INNER JOIN negocio n ON n.funil_etapas_id = fe.id; 

CREATE VIEW vw_lotes_produto AS select l.id as id,
       l.produto_id as produto_id,
       l.numero as numero,
       l.validade as validade,
       sum(e.quant_disponivel) as Quantidade,
       sum(e.quant_reservada) as Reservado
       from produto_lote l
left join estoque_saldos e on e.produto_lote_id = l.id
; 

CREATE VIEW vw_produto_estoque AS SELECT     p.id as id,
           p.nome as nome,
           p.referencia as referencia,
           p.codigo_sku as SKU,
           p.obs as obs,
           f.margem as margem,
           f.valor_custo as valor_custo,
           f.preco_venda as preco_venda,
           p.peso_liquido as peso_liquido,
           p.peso_bruto as preso_bruto,
           g.descricao as grupo,
           sg.descricao as subgrupo,
           u.sigla as sigla,
           p.imagem as imagem,
           p.codigo_ean as ean,
           p.ncm as ncm,
           f.system_unit_id as system_unit_id,
           f.id as produto_filial_id,
           f.estoque_minimo as estoque_minimo,
           f.estoque_maximo as estoque_maximo,           
           (e.quant_disponivel) as Quantidade_Disponivel,
           (e.quant_reservada) as Quantidade_Reservada,
           d.descricao as deposito
           
           FROM produto p 
           INNER JOIN unidade_medida u ON p.unidade_medida_id = u.id 
           INNER JOIN produto_grupo g ON p.produto_grupo_id = g.id
           LEFT JOIN produtogrupo_subgrupo sg ON g.id = sg.produto_grupo_id
           LEFT JOIN produto_filial f ON f.produto_id = p.id 
           LEFT JOIN estoque_saldos e ON e.produto_id = p.id
           LEFT JOIN estoque_deposito d ON e.estoque_deposito_id = d.id
           group by 1,2           
           
           ; 
 
