<?php

class SystemUnit extends TRecord
{
    const TABLENAME  = 'system_unit';
    const PRIMARYKEY = 'id';
    const IDPOLICY   =  'max'; // {max, serial}

    private $notafiscal_crt;
    private $nfe_tpamb;
    private $nfe_tpimp;
    private $nfe_api_documentos;
    private $vendas_natureza_operacao;
    private $nfce_natureza_operacao;
    private $nfe_homologacao_series;
    private $nfe_producao_series;
    private $nfce_homologacao_series;
    private $nfce_producao_series;
    private $notafiscal_cprod_padrao;
    private $nfce_tpimp;
    private $nfce_tpamb;
    private $nfce_api_documentos;
    private $mdfe_tpamb;
    private $mdfe_estadoini;
    private $veiculo;
    private $mdfe_api_documentos;
    private $mdfe_homologacao_series;
    private $mdfe_producao_series;
    private $natureza_operacao_compra;

    

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('connection_name');
        parent::addAttribute('vendas_natureza_operacao_id');
        parent::addAttribute('nfce_natureza_operacao_id');
        parent::addAttribute('cnpj');
        parent::addAttribute('name');
        parent::addAttribute('razao_social');
        parent::addAttribute('inscricao_estadual');
        parent::addAttribute('inscricao_municipal');
        parent::addAttribute('fone');
        parent::addAttribute('notafiscal_crt_id');
        parent::addAttribute('pc_credito_sn');
        parent::addAttribute('aliquota_iss');
        parent::addAttribute('aliquota_irrf');
        parent::addAttribute('aliquota_csll');
        parent::addAttribute('sn_matriz');
        parent::addAttribute('nfce_tpamb_id');
        parent::addAttribute('nfe_tpamb_id');
        parent::addAttribute('nfe_tpimp_id');
        parent::addAttribute('nfce_tpimp_id');
        parent::addAttribute('certificadoA1');
        parent::addAttribute('senha_certificado');
        parent::addAttribute('nfe_homologacao_series_id');
        parent::addAttribute('nfe_producao_series_id');
        parent::addAttribute('nfce_homologacao_series_id');
        parent::addAttribute('nfe_api_documentos_id');
        parent::addAttribute('nfce_api_documentos_id');
        parent::addAttribute('nfce_producao_series_id');
        parent::addAttribute('end_cep');
        parent::addAttribute('end_mun_codibge');
        parent::addAttribute('end_municipio');
        parent::addAttribute('end_uf');
        parent::addAttribute('end_logradouro');
        parent::addAttribute('end_bairro');
        parent::addAttribute('end_numero');
        parent::addAttribute('end_complemento');
        parent::addAttribute('nfce_csc_homologacao');
        parent::addAttribute('nfce_csc_producao');
        parent::addAttribute('notafiscal_cprod_padrao_id');
        parent::addAttribute('nfce_id_csc_homologacao');
        parent::addAttribute('nfce_id_csc_producao');
        parent::addAttribute('email');
        parent::addAttribute('token_api');
        parent::addAttribute('mdfe_tpamb_id');
        parent::addAttribute('mdfe_estadoini_id');
        parent::addAttribute('veiculo_id');
        parent::addAttribute('mdfe_api_documentos_id');
        parent::addAttribute('mdfe_homologacao_series_id');
        parent::addAttribute('mdfe_producao_series_id');
        parent::addAttribute('natureza_operacao_compra_id');
        parent::addAttribute('logo');
        parent::addAttribute('contador_nome');
        parent::addAttribute('contador_documento');
        parent::addAttribute('contador_email');
        parent::addAttribute('contador_celular');
        parent::addAttribute('config_host');
        parent::addAttribute('config_user');
        parent::addAttribute('config_password');
        parent::addAttribute('config_port');
        parent::addAttribute('config_from');
        parent::addAttribute('config_replyname');
        parent::addAttribute('config_replyto');
        parent::addAttribute('column_63');
        parent::addAttribute('cnae');
            
    }

    /**
     * Method set_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt = $object;
     * @param $object Instance of NotafiscalCrt
     */
    public function set_notafiscal_crt(NotafiscalCrt $object)
    {
        $this->notafiscal_crt = $object;
        $this->notafiscal_crt_id = $object->id;
    }

    /**
     * Method get_notafiscal_crt
     * Sample of usage: $var->notafiscal_crt->attribute;
     * @returns NotafiscalCrt instance
     */
    public function get_notafiscal_crt()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_crt))
            $this->notafiscal_crt = new NotafiscalCrt($this->notafiscal_crt_id);
    
        // returns the associated object
        return $this->notafiscal_crt;
    }
    /**
     * Method set_notafiscal_tpamb
     * Sample of usage: $var->notafiscal_tpamb = $object;
     * @param $object Instance of NotafiscalTpamb
     */
    public function set_nfe_tpamb(NotafiscalTpamb $object)
    {
        $this->nfe_tpamb = $object;
        $this->nfe_tpamb_id = $object->id;
    }

    /**
     * Method get_nfe_tpamb
     * Sample of usage: $var->nfe_tpamb->attribute;
     * @returns NotafiscalTpamb instance
     */
    public function get_nfe_tpamb()
    {
    
        // loads the associated object
        if (empty($this->nfe_tpamb))
            $this->nfe_tpamb = new NotafiscalTpamb($this->nfe_tpamb_id);
    
        // returns the associated object
        return $this->nfe_tpamb;
    }
    /**
     * Method set_notafiscal_tpimp
     * Sample of usage: $var->notafiscal_tpimp = $object;
     * @param $object Instance of NotafiscalTpimp
     */
    public function set_nfe_tpimp(NotafiscalTpimp $object)
    {
        $this->nfe_tpimp = $object;
        $this->nfe_tpimp_id = $object->id;
    }

    /**
     * Method get_nfe_tpimp
     * Sample of usage: $var->nfe_tpimp->attribute;
     * @returns NotafiscalTpimp instance
     */
    public function get_nfe_tpimp()
    {
    
        // loads the associated object
        if (empty($this->nfe_tpimp))
            $this->nfe_tpimp = new NotafiscalTpimp($this->nfe_tpimp_id);
    
        // returns the associated object
        return $this->nfe_tpimp;
    }
    /**
     * Method set_api_documentos
     * Sample of usage: $var->api_documentos = $object;
     * @param $object Instance of ApiDocumentos
     */
    public function set_nfe_api_documentos(ApiDocumentos $object)
    {
        $this->nfe_api_documentos = $object;
        $this->nfe_api_documentos_id = $object->id;
    }

    /**
     * Method get_nfe_api_documentos
     * Sample of usage: $var->nfe_api_documentos->attribute;
     * @returns ApiDocumentos instance
     */
    public function get_nfe_api_documentos()
    {
    
        // loads the associated object
        if (empty($this->nfe_api_documentos))
            $this->nfe_api_documentos = new ApiDocumentos($this->nfe_api_documentos_id);
    
        // returns the associated object
        return $this->nfe_api_documentos;
    }
    /**
     * Method set_natureza_operacao
     * Sample of usage: $var->natureza_operacao = $object;
     * @param $object Instance of NaturezaOperacao
     */
    public function set_vendas_natureza_operacao(NaturezaOperacao $object)
    {
        $this->vendas_natureza_operacao = $object;
        $this->vendas_natureza_operacao_id = $object->id;
    }

    /**
     * Method get_vendas_natureza_operacao
     * Sample of usage: $var->vendas_natureza_operacao->attribute;
     * @returns NaturezaOperacao instance
     */
    public function get_vendas_natureza_operacao()
    {
    
        // loads the associated object
        if (empty($this->vendas_natureza_operacao))
            $this->vendas_natureza_operacao = new NaturezaOperacao($this->vendas_natureza_operacao_id);
    
        // returns the associated object
        return $this->vendas_natureza_operacao;
    }
    /**
     * Method set_natureza_operacao
     * Sample of usage: $var->natureza_operacao = $object;
     * @param $object Instance of NaturezaOperacao
     */
    public function set_nfce_natureza_operacao(NaturezaOperacao $object)
    {
        $this->nfce_natureza_operacao = $object;
        $this->nfce_natureza_operacao_id = $object->id;
    }

    /**
     * Method get_nfce_natureza_operacao
     * Sample of usage: $var->nfce_natureza_operacao->attribute;
     * @returns NaturezaOperacao instance
     */
    public function get_nfce_natureza_operacao()
    {
    
        // loads the associated object
        if (empty($this->nfce_natureza_operacao))
            $this->nfce_natureza_operacao = new NaturezaOperacao($this->nfce_natureza_operacao_id);
    
        // returns the associated object
        return $this->nfce_natureza_operacao;
    }
    /**
     * Method set_notafiscal_series
     * Sample of usage: $var->notafiscal_series = $object;
     * @param $object Instance of NotafiscalSeries
     */
    public function set_nfe_homologacao_series(NotafiscalSeries $object)
    {
        $this->nfe_homologacao_series = $object;
        $this->nfe_homologacao_series_id = $object->id;
    }

    /**
     * Method get_nfe_homologacao_series
     * Sample of usage: $var->nfe_homologacao_series->attribute;
     * @returns NotafiscalSeries instance
     */
    public function get_nfe_homologacao_series()
    {
    
        // loads the associated object
        if (empty($this->nfe_homologacao_series))
            $this->nfe_homologacao_series = new NotafiscalSeries($this->nfe_homologacao_series_id);
    
        // returns the associated object
        return $this->nfe_homologacao_series;
    }
    /**
     * Method set_notafiscal_series
     * Sample of usage: $var->notafiscal_series = $object;
     * @param $object Instance of NotafiscalSeries
     */
    public function set_nfe_producao_series(NotafiscalSeries $object)
    {
        $this->nfe_producao_series = $object;
        $this->nfe_producao_series_id = $object->id;
    }

    /**
     * Method get_nfe_producao_series
     * Sample of usage: $var->nfe_producao_series->attribute;
     * @returns NotafiscalSeries instance
     */
    public function get_nfe_producao_series()
    {
    
        // loads the associated object
        if (empty($this->nfe_producao_series))
            $this->nfe_producao_series = new NotafiscalSeries($this->nfe_producao_series_id);
    
        // returns the associated object
        return $this->nfe_producao_series;
    }
    /**
     * Method set_notafiscal_series
     * Sample of usage: $var->notafiscal_series = $object;
     * @param $object Instance of NotafiscalSeries
     */
    public function set_nfce_homologacao_series(NotafiscalSeries $object)
    {
        $this->nfce_homologacao_series = $object;
        $this->nfce_homologacao_series_id = $object->id;
    }

    /**
     * Method get_nfce_homologacao_series
     * Sample of usage: $var->nfce_homologacao_series->attribute;
     * @returns NotafiscalSeries instance
     */
    public function get_nfce_homologacao_series()
    {
    
        // loads the associated object
        if (empty($this->nfce_homologacao_series))
            $this->nfce_homologacao_series = new NotafiscalSeries($this->nfce_homologacao_series_id);
    
        // returns the associated object
        return $this->nfce_homologacao_series;
    }
    /**
     * Method set_notafiscal_series
     * Sample of usage: $var->notafiscal_series = $object;
     * @param $object Instance of NotafiscalSeries
     */
    public function set_nfce_producao_series(NotafiscalSeries $object)
    {
        $this->nfce_producao_series = $object;
        $this->nfce_producao_series_id = $object->id;
    }

    /**
     * Method get_nfce_producao_series
     * Sample of usage: $var->nfce_producao_series->attribute;
     * @returns NotafiscalSeries instance
     */
    public function get_nfce_producao_series()
    {
    
        // loads the associated object
        if (empty($this->nfce_producao_series))
            $this->nfce_producao_series = new NotafiscalSeries($this->nfce_producao_series_id);
    
        // returns the associated object
        return $this->nfce_producao_series;
    }
    /**
     * Method set_notafiscal_cprod_padrao
     * Sample of usage: $var->notafiscal_cprod_padrao = $object;
     * @param $object Instance of NotafiscalCprodPadrao
     */
    public function set_notafiscal_cprod_padrao(NotafiscalCprodPadrao $object)
    {
        $this->notafiscal_cprod_padrao = $object;
        $this->notafiscal_cprod_padrao_id = $object->id;
    }

    /**
     * Method get_notafiscal_cprod_padrao
     * Sample of usage: $var->notafiscal_cprod_padrao->attribute;
     * @returns NotafiscalCprodPadrao instance
     */
    public function get_notafiscal_cprod_padrao()
    {
    
        // loads the associated object
        if (empty($this->notafiscal_cprod_padrao))
            $this->notafiscal_cprod_padrao = new NotafiscalCprodPadrao($this->notafiscal_cprod_padrao_id);
    
        // returns the associated object
        return $this->notafiscal_cprod_padrao;
    }
    /**
     * Method set_notafiscal_tpimp
     * Sample of usage: $var->notafiscal_tpimp = $object;
     * @param $object Instance of NotafiscalTpimp
     */
    public function set_nfce_tpimp(NotafiscalTpimp $object)
    {
        $this->nfce_tpimp = $object;
        $this->nfce_tpimp_id = $object->id;
    }

    /**
     * Method get_nfce_tpimp
     * Sample of usage: $var->nfce_tpimp->attribute;
     * @returns NotafiscalTpimp instance
     */
    public function get_nfce_tpimp()
    {
    
        // loads the associated object
        if (empty($this->nfce_tpimp))
            $this->nfce_tpimp = new NotafiscalTpimp($this->nfce_tpimp_id);
    
        // returns the associated object
        return $this->nfce_tpimp;
    }
    /**
     * Method set_notafiscal_tpamb
     * Sample of usage: $var->notafiscal_tpamb = $object;
     * @param $object Instance of NotafiscalTpamb
     */
    public function set_nfce_tpamb(NotafiscalTpamb $object)
    {
        $this->nfce_tpamb = $object;
        $this->nfce_tpamb_id = $object->id;
    }

    /**
     * Method get_nfce_tpamb
     * Sample of usage: $var->nfce_tpamb->attribute;
     * @returns NotafiscalTpamb instance
     */
    public function get_nfce_tpamb()
    {
    
        // loads the associated object
        if (empty($this->nfce_tpamb))
            $this->nfce_tpamb = new NotafiscalTpamb($this->nfce_tpamb_id);
    
        // returns the associated object
        return $this->nfce_tpamb;
    }
    /**
     * Method set_api_documentos
     * Sample of usage: $var->api_documentos = $object;
     * @param $object Instance of ApiDocumentos
     */
    public function set_nfce_api_documentos(ApiDocumentos $object)
    {
        $this->nfce_api_documentos = $object;
        $this->nfce_api_documentos_id = $object->id;
    }

    /**
     * Method get_nfce_api_documentos
     * Sample of usage: $var->nfce_api_documentos->attribute;
     * @returns ApiDocumentos instance
     */
    public function get_nfce_api_documentos()
    {
    
        // loads the associated object
        if (empty($this->nfce_api_documentos))
            $this->nfce_api_documentos = new ApiDocumentos($this->nfce_api_documentos_id);
    
        // returns the associated object
        return $this->nfce_api_documentos;
    }
    /**
     * Method set_mdfe_tpamb
     * Sample of usage: $var->mdfe_tpamb = $object;
     * @param $object Instance of MdfeTpamb
     */
    public function set_mdfe_tpamb(MdfeTpamb $object)
    {
        $this->mdfe_tpamb = $object;
        $this->mdfe_tpamb_id = $object->id;
    }

    /**
     * Method get_mdfe_tpamb
     * Sample of usage: $var->mdfe_tpamb->attribute;
     * @returns MdfeTpamb instance
     */
    public function get_mdfe_tpamb()
    {
    
        // loads the associated object
        if (empty($this->mdfe_tpamb))
            $this->mdfe_tpamb = new MdfeTpamb($this->mdfe_tpamb_id);
    
        // returns the associated object
        return $this->mdfe_tpamb;
    }
    /**
     * Method set_estado
     * Sample of usage: $var->estado = $object;
     * @param $object Instance of Estado
     */
    public function set_mdfe_estadoini(Estado $object)
    {
        $this->mdfe_estadoini = $object;
        $this->mdfe_estadoini_id = $object->id;
    }

    /**
     * Method get_mdfe_estadoini
     * Sample of usage: $var->mdfe_estadoini->attribute;
     * @returns Estado instance
     */
    public function get_mdfe_estadoini()
    {
    
        // loads the associated object
        if (empty($this->mdfe_estadoini))
            $this->mdfe_estadoini = new Estado($this->mdfe_estadoini_id);
    
        // returns the associated object
        return $this->mdfe_estadoini;
    }
    /**
     * Method set_veiculo
     * Sample of usage: $var->veiculo = $object;
     * @param $object Instance of Veiculo
     */
    public function set_veiculo(Veiculo $object)
    {
        $this->veiculo = $object;
        $this->veiculo_id = $object->id;
    }

    /**
     * Method get_veiculo
     * Sample of usage: $var->veiculo->attribute;
     * @returns Veiculo instance
     */
    public function get_veiculo()
    {
    
        // loads the associated object
        if (empty($this->veiculo))
            $this->veiculo = new Veiculo($this->veiculo_id);
    
        // returns the associated object
        return $this->veiculo;
    }
    /**
     * Method set_api_documentos
     * Sample of usage: $var->api_documentos = $object;
     * @param $object Instance of ApiDocumentos
     */
    public function set_mdfe_api_documentos(ApiDocumentos $object)
    {
        $this->mdfe_api_documentos = $object;
        $this->mdfe_api_documentos_id = $object->id;
    }

    /**
     * Method get_mdfe_api_documentos
     * Sample of usage: $var->mdfe_api_documentos->attribute;
     * @returns ApiDocumentos instance
     */
    public function get_mdfe_api_documentos()
    {
    
        // loads the associated object
        if (empty($this->mdfe_api_documentos))
            $this->mdfe_api_documentos = new ApiDocumentos($this->mdfe_api_documentos_id);
    
        // returns the associated object
        return $this->mdfe_api_documentos;
    }
    /**
     * Method set_mdfe_series
     * Sample of usage: $var->mdfe_series = $object;
     * @param $object Instance of MdfeSeries
     */
    public function set_mdfe_homologacao_series(MdfeSeries $object)
    {
        $this->mdfe_homologacao_series = $object;
        $this->mdfe_homologacao_series_id = $object->id;
    }

    /**
     * Method get_mdfe_homologacao_series
     * Sample of usage: $var->mdfe_homologacao_series->attribute;
     * @returns MdfeSeries instance
     */
    public function get_mdfe_homologacao_series()
    {
    
        // loads the associated object
        if (empty($this->mdfe_homologacao_series))
            $this->mdfe_homologacao_series = new MdfeSeries($this->mdfe_homologacao_series_id);
    
        // returns the associated object
        return $this->mdfe_homologacao_series;
    }
    /**
     * Method set_mdfe_series
     * Sample of usage: $var->mdfe_series = $object;
     * @param $object Instance of MdfeSeries
     */
    public function set_mdfe_producao_series(MdfeSeries $object)
    {
        $this->mdfe_producao_series = $object;
        $this->mdfe_producao_series_id = $object->id;
    }

    /**
     * Method get_mdfe_producao_series
     * Sample of usage: $var->mdfe_producao_series->attribute;
     * @returns MdfeSeries instance
     */
    public function get_mdfe_producao_series()
    {
    
        // loads the associated object
        if (empty($this->mdfe_producao_series))
            $this->mdfe_producao_series = new MdfeSeries($this->mdfe_producao_series_id);
    
        // returns the associated object
        return $this->mdfe_producao_series;
    }
    /**
     * Method set_natureza_operacao
     * Sample of usage: $var->natureza_operacao = $object;
     * @param $object Instance of NaturezaOperacao
     */
    public function set_natureza_operacao_compra(NaturezaOperacao $object)
    {
        $this->natureza_operacao_compra = $object;
        $this->natureza_operacao_compra_id = $object->id;
    }

    /**
     * Method get_natureza_operacao_compra
     * Sample of usage: $var->natureza_operacao_compra->attribute;
     * @returns NaturezaOperacao instance
     */
    public function get_natureza_operacao_compra()
    {
    
        // loads the associated object
        if (empty($this->natureza_operacao_compra))
            $this->natureza_operacao_compra = new NaturezaOperacao($this->natureza_operacao_compra_id);
    
        // returns the associated object
        return $this->natureza_operacao_compra;
    }

    /**
     * Method getApiDocumentoss
     */
    public function getApiDocumentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return ApiDocumentos::getObjects( $criteria );
    }
    /**
     * Method getCaixas
     */
    public function getCaixas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Caixa::getObjects( $criteria );
    }
    /**
     * Method getCentroCustos
     */
    public function getCentroCustos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return CentroCusto::getObjects( $criteria );
    }
    /**
     * Method getCertificadoVendas
     */
    public function getCertificadoVendas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return CertificadoVenda::getObjects( $criteria );
    }
    /**
     * Method getClientes
     */
    public function getClientes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Cliente::getObjects( $criteria );
    }
    /**
     * Method getConfiguracoesFilials
     */
    public function getConfiguracoesFilials()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return ConfiguracoesFilial::getObjects( $criteria );
    }
    /**
     * Method getContaCorrentes
     */
    public function getContaCorrentes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return ContaCorrente::getObjects( $criteria );
    }
    /**
     * Method getContaspags
     */
    public function getContaspags()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Contaspag::getObjects( $criteria );
    }
    /**
     * Method getContaspagBlocos
     */
    public function getContaspagBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return ContaspagBloco::getObjects( $criteria );
    }
    /**
     * Method getContasrecs
     */
    public function getContasrecs()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Contasrec::getObjects( $criteria );
    }
    /**
     * Method getContasrecBlocos
     */
    public function getContasrecBlocos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return ContasrecBloco::getObjects( $criteria );
    }
    /**
     * Method getDispositivoss
     */
    public function getDispositivoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Dispositivos::getObjects( $criteria );
    }
    /**
     * Method getEstoqueDepositos
     */
    public function getEstoqueDepositos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return EstoqueDeposito::getObjects( $criteria );
    }
    /**
     * Method getEstoqueLancamentoss
     */
    public function getEstoqueLancamentoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return EstoqueLancamentos::getObjects( $criteria );
    }
    /**
     * Method getEstoqueSaldoss
     */
    public function getEstoqueSaldoss()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return EstoqueSaldos::getObjects( $criteria );
    }
    /**
     * Method getEventosSystemusers
     */
    public function getEventosSystemusers()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return EventosSystemuser::getObjects( $criteria );
    }
    /**
     * Method getInutilizarNumeros
     */
    public function getInutilizarNumeros()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return InutilizarNumero::getObjects( $criteria );
    }
    /**
     * Method getMdfes
     */
    public function getMdfes()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Mdfe::getObjects( $criteria );
    }
    /**
     * Method getMdfeSeriess
     */
    public function getMdfeSeriess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return MdfeSeries::getObjects( $criteria );
    }
    /**
     * Method getNegocios
     */
    public function getNegocios()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Negocio::getObjects( $criteria );
    }
    /**
     * Method getNotafiscals
     */
    public function getNotafiscals()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Notafiscal::getObjects( $criteria );
    }
    /**
     * Method getNotaFiscalCompras
     */
    public function getNotaFiscalCompras()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return NotaFiscalCompra::getObjects( $criteria );
    }
    /**
     * Method getNotafiscalSeriess
     */
    public function getNotafiscalSeriess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return NotafiscalSeries::getObjects( $criteria );
    }
    /**
     * Method getOrcamentos
     */
    public function getOrcamentos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Orcamento::getObjects( $criteria );
    }
    /**
     * Method getOrdemProducaos
     */
    public function getOrdemProducaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return OrdemProducao::getObjects( $criteria );
    }
    /**
     * Method getOrdemServicos
     */
    public function getOrdemServicos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return OrdemServico::getObjects( $criteria );
    }
    /**
     * Method getPedidoEventos
     */
    public function getPedidoEventos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return PedidoEvento::getObjects( $criteria );
    }
    /**
     * Method getPlanoContas
     */
    public function getPlanoContas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return PlanoConta::getObjects( $criteria );
    }
    /**
     * Method getProdutoFichaTecnicas
     */
    public function getProdutoFichaTecnicas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return ProdutoFichaTecnica::getObjects( $criteria );
    }
    /**
     * Method getProdutoFilials
     */
    public function getProdutoFilials()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return ProdutoFilial::getObjects( $criteria );
    }
    /**
     * Method getSystemGroupProgramPermissoess
     */
    public function getSystemGroupProgramPermissoess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return SystemGroupProgramPermissoes::getObjects( $criteria );
    }
    /**
     * Method getSystemUserProgramPermissoess
     */
    public function getSystemUserProgramPermissoess()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return SystemUserProgramPermissoes::getObjects( $criteria );
    }
    /**
     * Method getVendas
     */
    public function getVendasBySystemUnits()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }
    /**
     * Method getVendas
     */
    public function getVendasByFilialSaidas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('filial_saida_id', '=', $this->id));
        return Venda::getObjects( $criteria );
    }
    /**
     * Method getVendaDevolucaos
     */
    public function getVendaDevolucaos()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return VendaDevolucao::getObjects( $criteria );
    }
    /**
     * Method getVendaMetas
     */
    public function getVendaMetas()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return VendaMeta::getObjects( $criteria );
    }
    /**
     * Method getXmlContadors
     */
    public function getXmlContadors()
    {
        $criteria = new TCriteria;
        $criteria->add(new TFilter('system_unit_id', '=', $this->id));
        return XmlContador::getObjects( $criteria );
    }

    public function set_api_documentos_integradores_to_string($api_documentos_integradores_to_string)
    {
        if(is_array($api_documentos_integradores_to_string))
        {
            $values = Integradores::where('id', 'in', $api_documentos_integradores_to_string)->getIndexedArray('nome', 'nome');
            $this->api_documentos_integradores_to_string = implode(', ', $values);
        }
        else
        {
            $this->api_documentos_integradores_to_string = $api_documentos_integradores_to_string;
        }

        $this->vdata['api_documentos_integradores_to_string'] = $this->api_documentos_integradores_to_string;
    }

    public function get_api_documentos_integradores_to_string()
    {
        if(!empty($this->api_documentos_integradores_to_string))
        {
            return $this->api_documentos_integradores_to_string;
        }
    
        $values = ApiDocumentos::where('system_unit_id', '=', $this->id)->getIndexedArray('integradores_id','{integradores->nome}');
        return implode(', ', $values);
    }

    public function set_api_documentos_system_unit_to_string($api_documentos_system_unit_to_string)
    {
        if(is_array($api_documentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $api_documentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->api_documentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->api_documentos_system_unit_to_string = $api_documentos_system_unit_to_string;
        }

        $this->vdata['api_documentos_system_unit_to_string'] = $this->api_documentos_system_unit_to_string;
    }

    public function get_api_documentos_system_unit_to_string()
    {
        if(!empty($this->api_documentos_system_unit_to_string))
        {
            return $this->api_documentos_system_unit_to_string;
        }
    
        $values = ApiDocumentos::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_caixa_caixa_situacao_to_string($caixa_caixa_situacao_to_string)
    {
        if(is_array($caixa_caixa_situacao_to_string))
        {
            $values = CaixaSituacao::where('id', 'in', $caixa_caixa_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->caixa_caixa_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_caixa_situacao_to_string = $caixa_caixa_situacao_to_string;
        }

        $this->vdata['caixa_caixa_situacao_to_string'] = $this->caixa_caixa_situacao_to_string;
    }

    public function get_caixa_caixa_situacao_to_string()
    {
        if(!empty($this->caixa_caixa_situacao_to_string))
        {
            return $this->caixa_caixa_situacao_to_string;
        }
    
        $values = Caixa::where('system_unit_id', '=', $this->id)->getIndexedArray('caixa_situacao_id','{caixa_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_caixa_system_unit_to_string($caixa_system_unit_to_string)
    {
        if(is_array($caixa_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $caixa_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_unit_to_string = $caixa_system_unit_to_string;
        }

        $this->vdata['caixa_system_unit_to_string'] = $this->caixa_system_unit_to_string;
    }

    public function get_caixa_system_unit_to_string()
    {
        if(!empty($this->caixa_system_unit_to_string))
        {
            return $this->caixa_system_unit_to_string;
        }
    
        $values = Caixa::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_caixa_system_users_abertura_to_string($caixa_system_users_abertura_to_string)
    {
        if(is_array($caixa_system_users_abertura_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_system_users_abertura_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_users_abertura_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_users_abertura_to_string = $caixa_system_users_abertura_to_string;
        }

        $this->vdata['caixa_system_users_abertura_to_string'] = $this->caixa_system_users_abertura_to_string;
    }

    public function get_caixa_system_users_abertura_to_string()
    {
        if(!empty($this->caixa_system_users_abertura_to_string))
        {
            return $this->caixa_system_users_abertura_to_string;
        }
    
        $values = Caixa::where('system_unit_id', '=', $this->id)->getIndexedArray('system_users_abertura_id','{system_users_abertura->name}');
        return implode(', ', $values);
    }

    public function set_caixa_system_users_operador_to_string($caixa_system_users_operador_to_string)
    {
        if(is_array($caixa_system_users_operador_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_system_users_operador_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_users_operador_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_users_operador_to_string = $caixa_system_users_operador_to_string;
        }

        $this->vdata['caixa_system_users_operador_to_string'] = $this->caixa_system_users_operador_to_string;
    }

    public function get_caixa_system_users_operador_to_string()
    {
        if(!empty($this->caixa_system_users_operador_to_string))
        {
            return $this->caixa_system_users_operador_to_string;
        }
    
        $values = Caixa::where('system_unit_id', '=', $this->id)->getIndexedArray('system_users_operador_id','{system_users_operador->name}');
        return implode(', ', $values);
    }

    public function set_caixa_system_users_fechamento_to_string($caixa_system_users_fechamento_to_string)
    {
        if(is_array($caixa_system_users_fechamento_to_string))
        {
            $values = SystemUsers::where('id', 'in', $caixa_system_users_fechamento_to_string)->getIndexedArray('name', 'name');
            $this->caixa_system_users_fechamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->caixa_system_users_fechamento_to_string = $caixa_system_users_fechamento_to_string;
        }

        $this->vdata['caixa_system_users_fechamento_to_string'] = $this->caixa_system_users_fechamento_to_string;
    }

    public function get_caixa_system_users_fechamento_to_string()
    {
        if(!empty($this->caixa_system_users_fechamento_to_string))
        {
            return $this->caixa_system_users_fechamento_to_string;
        }
    
        $values = Caixa::where('system_unit_id', '=', $this->id)->getIndexedArray('system_users_fechamento_id','{system_users_fechamento->name}');
        return implode(', ', $values);
    }

    public function set_centro_custo_system_unit_to_string($centro_custo_system_unit_to_string)
    {
        if(is_array($centro_custo_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $centro_custo_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->centro_custo_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->centro_custo_system_unit_to_string = $centro_custo_system_unit_to_string;
        }

        $this->vdata['centro_custo_system_unit_to_string'] = $this->centro_custo_system_unit_to_string;
    }

    public function get_centro_custo_system_unit_to_string()
    {
        if(!empty($this->centro_custo_system_unit_to_string))
        {
            return $this->centro_custo_system_unit_to_string;
        }
    
        $values = CentroCusto::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_centro_custo_centro_custo_tipo_to_string($centro_custo_centro_custo_tipo_to_string)
    {
        if(is_array($centro_custo_centro_custo_tipo_to_string))
        {
            $values = CentroCustoTipo::where('id', 'in', $centro_custo_centro_custo_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->centro_custo_centro_custo_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->centro_custo_centro_custo_tipo_to_string = $centro_custo_centro_custo_tipo_to_string;
        }

        $this->vdata['centro_custo_centro_custo_tipo_to_string'] = $this->centro_custo_centro_custo_tipo_to_string;
    }

    public function get_centro_custo_centro_custo_tipo_to_string()
    {
        if(!empty($this->centro_custo_centro_custo_tipo_to_string))
        {
            return $this->centro_custo_centro_custo_tipo_to_string;
        }
    
        $values = CentroCusto::where('system_unit_id', '=', $this->id)->getIndexedArray('centro_custo_tipo_id','{centro_custo_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_system_unit_to_string($certificado_venda_system_unit_to_string)
    {
        if(is_array($certificado_venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $certificado_venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->certificado_venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_system_unit_to_string = $certificado_venda_system_unit_to_string;
        }

        $this->vdata['certificado_venda_system_unit_to_string'] = $this->certificado_venda_system_unit_to_string;
    }

    public function get_certificado_venda_system_unit_to_string()
    {
        if(!empty($this->certificado_venda_system_unit_to_string))
        {
            return $this->certificado_venda_system_unit_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_cliente_to_string($certificado_venda_cliente_to_string)
    {
        if(is_array($certificado_venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $certificado_venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_cliente_to_string = $certificado_venda_cliente_to_string;
        }

        $this->vdata['certificado_venda_cliente_to_string'] = $this->certificado_venda_cliente_to_string;
    }

    public function get_certificado_venda_cliente_to_string()
    {
        if(!empty($this->certificado_venda_cliente_to_string))
        {
            return $this->certificado_venda_cliente_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_produto_to_string($certificado_venda_produto_to_string)
    {
        if(is_array($certificado_venda_produto_to_string))
        {
            $values = Produto::where('id', 'in', $certificado_venda_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_produto_to_string = $certificado_venda_produto_to_string;
        }

        $this->vdata['certificado_venda_produto_to_string'] = $this->certificado_venda_produto_to_string;
    }

    public function get_certificado_venda_produto_to_string()
    {
        if(!empty($this->certificado_venda_produto_to_string))
        {
            return $this->certificado_venda_produto_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_parceiro_to_string($certificado_venda_parceiro_to_string)
    {
        if(is_array($certificado_venda_parceiro_to_string))
        {
            $values = Parceiro::where('id', 'in', $certificado_venda_parceiro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_parceiro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_parceiro_to_string = $certificado_venda_parceiro_to_string;
        }

        $this->vdata['certificado_venda_parceiro_to_string'] = $this->certificado_venda_parceiro_to_string;
    }

    public function get_certificado_venda_parceiro_to_string()
    {
        if(!empty($this->certificado_venda_parceiro_to_string))
        {
            return $this->certificado_venda_parceiro_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('parceiro_id','{parceiro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_agente_registro_to_string($certificado_venda_certificado_agente_registro_to_string)
    {
        if(is_array($certificado_venda_certificado_agente_registro_to_string))
        {
            $values = CertificadoAgenteRegistro::where('id', 'in', $certificado_venda_certificado_agente_registro_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificado_agente_registro_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_agente_registro_to_string = $certificado_venda_certificado_agente_registro_to_string;
        }

        $this->vdata['certificado_venda_certificado_agente_registro_to_string'] = $this->certificado_venda_certificado_agente_registro_to_string;
    }

    public function get_certificado_venda_certificado_agente_registro_to_string()
    {
        if(!empty($this->certificado_venda_certificado_agente_registro_to_string))
        {
            return $this->certificado_venda_certificado_agente_registro_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('certificado_agente_registro_id','{certificado_agente_registro->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_situacao_to_string($certificado_venda_certificado_venda_situacao_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_situacao_to_string))
        {
            $values = CertificadoVendaSituacao::where('id', 'in', $certificado_venda_certificado_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_situacao_to_string = $certificado_venda_certificado_venda_situacao_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_situacao_to_string'] = $this->certificado_venda_certificado_venda_situacao_to_string;
    }

    public function get_certificado_venda_certificado_venda_situacao_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_situacao_to_string))
        {
            return $this->certificado_venda_certificado_venda_situacao_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('certificado_venda_situacao_id','{certificado_venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_modalidade_to_string($certificado_venda_certificado_venda_modalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_modalidade_to_string))
        {
            $values = CertificadoVendaModalidade::where('id', 'in', $certificado_venda_certificado_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_modalidade_to_string = $certificado_venda_certificado_venda_modalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_modalidade_to_string'] = $this->certificado_venda_certificado_venda_modalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_modalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_modalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_modalidade_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('certificado_venda_modalidade_id','{certificado_venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_venda_tipomodalidade_to_string($certificado_venda_certificado_venda_tipomodalidade_to_string)
    {
        if(is_array($certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            $values = CertificadoVendaTipomodalidade::where('id', 'in', $certificado_venda_certificado_venda_tipomodalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_venda_tipomodalidade_to_string = $certificado_venda_certificado_venda_tipomodalidade_to_string;
        }

        $this->vdata['certificado_venda_certificado_venda_tipomodalidade_to_string'] = $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
    }

    public function get_certificado_venda_certificado_venda_tipomodalidade_to_string()
    {
        if(!empty($this->certificado_venda_certificado_venda_tipomodalidade_to_string))
        {
            return $this->certificado_venda_certificado_venda_tipomodalidade_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('certificado_venda_tipomodalidade_id','{certificado_venda_tipomodalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_repasse_to_string($certificado_venda_certificado_tipo_repasse_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_repasse_to_string))
        {
            $values = CertificadoTipoRepasse::where('id', 'in', $certificado_venda_certificado_tipo_repasse_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_repasse_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_repasse_to_string = $certificado_venda_certificado_tipo_repasse_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_repasse_to_string'] = $this->certificado_venda_certificado_tipo_repasse_to_string;
    }

    public function get_certificado_venda_certificado_tipo_repasse_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_repasse_to_string))
        {
            return $this->certificado_venda_certificado_tipo_repasse_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('certificado_tipo_repasse_id','{certificado_tipo_repasse->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_vendedor_to_string($certificado_venda_vendedor_to_string)
    {
        if(is_array($certificado_venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $certificado_venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_vendedor_to_string = $certificado_venda_vendedor_to_string;
        }

        $this->vdata['certificado_venda_vendedor_to_string'] = $this->certificado_venda_vendedor_to_string;
    }

    public function get_certificado_venda_vendedor_to_string()
    {
        if(!empty($this->certificado_venda_vendedor_to_string))
        {
            return $this->certificado_venda_vendedor_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_tabela_preco_to_string($certificado_venda_tabela_preco_to_string)
    {
        if(is_array($certificado_venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $certificado_venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_tabela_preco_to_string = $certificado_venda_tabela_preco_to_string;
        }

        $this->vdata['certificado_venda_tabela_preco_to_string'] = $this->certificado_venda_tabela_preco_to_string;
    }

    public function get_certificado_venda_tabela_preco_to_string()
    {
        if(!empty($this->certificado_venda_tabela_preco_to_string))
        {
            return $this->certificado_venda_tabela_preco_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificadora_to_string($certificado_venda_certificadora_to_string)
    {
        if(is_array($certificado_venda_certificadora_to_string))
        {
            $values = Certificadora::where('id', 'in', $certificado_venda_certificadora_to_string)->getIndexedArray('nome', 'nome');
            $this->certificado_venda_certificadora_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificadora_to_string = $certificado_venda_certificadora_to_string;
        }

        $this->vdata['certificado_venda_certificadora_to_string'] = $this->certificado_venda_certificadora_to_string;
    }

    public function get_certificado_venda_certificadora_to_string()
    {
        if(!empty($this->certificado_venda_certificadora_to_string))
        {
            return $this->certificado_venda_certificadora_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('certificadora_id','{certificadora->nome}');
        return implode(', ', $values);
    }

    public function set_certificado_venda_certificado_tipo_atendimento_to_string($certificado_venda_certificado_tipo_atendimento_to_string)
    {
        if(is_array($certificado_venda_certificado_tipo_atendimento_to_string))
        {
            $values = CertificadoTipoAtendimento::where('id', 'in', $certificado_venda_certificado_tipo_atendimento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->certificado_venda_certificado_tipo_atendimento_to_string = implode(', ', $values);
        }
        else
        {
            $this->certificado_venda_certificado_tipo_atendimento_to_string = $certificado_venda_certificado_tipo_atendimento_to_string;
        }

        $this->vdata['certificado_venda_certificado_tipo_atendimento_to_string'] = $this->certificado_venda_certificado_tipo_atendimento_to_string;
    }

    public function get_certificado_venda_certificado_tipo_atendimento_to_string()
    {
        if(!empty($this->certificado_venda_certificado_tipo_atendimento_to_string))
        {
            return $this->certificado_venda_certificado_tipo_atendimento_to_string;
        }
    
        $values = CertificadoVenda::where('system_unit_id', '=', $this->id)->getIndexedArray('certificado_tipo_atendimento_id','{certificado_tipo_atendimento->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_pessoa_tipo_to_string($cliente_pessoa_tipo_to_string)
    {
        if(is_array($cliente_pessoa_tipo_to_string))
        {
            $values = PessoaTipo::where('id', 'in', $cliente_pessoa_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_pessoa_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_pessoa_tipo_to_string = $cliente_pessoa_tipo_to_string;
        }

        $this->vdata['cliente_pessoa_tipo_to_string'] = $this->cliente_pessoa_tipo_to_string;
    }

    public function get_cliente_pessoa_tipo_to_string()
    {
        if(!empty($this->cliente_pessoa_tipo_to_string))
        {
            return $this->cliente_pessoa_tipo_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('pessoa_tipo_id','{pessoa_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_to_string($cliente_cliente_classificacao_to_string)
    {
        if(is_array($cliente_cliente_classificacao_to_string))
        {
            $values = ClienteClassificacao::where('id', 'in', $cliente_cliente_classificacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_to_string = $cliente_cliente_classificacao_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_to_string'] = $this->cliente_cliente_classificacao_to_string;
    }

    public function get_cliente_cliente_classificacao_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_to_string))
        {
            return $this->cliente_cliente_classificacao_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_classificacao_id','{cliente_classificacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_classificacao_subgrupo_to_string($cliente_cliente_classificacao_subgrupo_to_string)
    {
        if(is_array($cliente_cliente_classificacao_subgrupo_to_string))
        {
            $values = ClienteClassificacaoSubgrupo::where('id', 'in', $cliente_cliente_classificacao_subgrupo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_classificacao_subgrupo_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_classificacao_subgrupo_to_string = $cliente_cliente_classificacao_subgrupo_to_string;
        }

        $this->vdata['cliente_cliente_classificacao_subgrupo_to_string'] = $this->cliente_cliente_classificacao_subgrupo_to_string;
    }

    public function get_cliente_cliente_classificacao_subgrupo_to_string()
    {
        if(!empty($this->cliente_cliente_classificacao_subgrupo_to_string))
        {
            return $this->cliente_cliente_classificacao_subgrupo_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_classificacao_subgrupo_id','{cliente_classificacao_subgrupo->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_vendedor_to_string($cliente_vendedor_to_string)
    {
        if(is_array($cliente_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $cliente_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->cliente_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_vendedor_to_string = $cliente_vendedor_to_string;
        }

        $this->vdata['cliente_vendedor_to_string'] = $this->cliente_vendedor_to_string;
    }

    public function get_cliente_vendedor_to_string()
    {
        if(!empty($this->cliente_vendedor_to_string))
        {
            return $this->cliente_vendedor_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_indiedest_to_string($cliente_notafiscal_indiedest_to_string)
    {
        if(is_array($cliente_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $cliente_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_indiedest_to_string = $cliente_notafiscal_indiedest_to_string;
        }

        $this->vdata['cliente_notafiscal_indiedest_to_string'] = $this->cliente_notafiscal_indiedest_to_string;
    }

    public function get_cliente_notafiscal_indiedest_to_string()
    {
        if(!empty($this->cliente_notafiscal_indiedest_to_string))
        {
            return $this->cliente_notafiscal_indiedest_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_notafiscal_crt_to_string($cliente_notafiscal_crt_to_string)
    {
        if(is_array($cliente_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $cliente_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_notafiscal_crt_to_string = $cliente_notafiscal_crt_to_string;
        }

        $this->vdata['cliente_notafiscal_crt_to_string'] = $this->cliente_notafiscal_crt_to_string;
    }

    public function get_cliente_notafiscal_crt_to_string()
    {
        if(!empty($this->cliente_notafiscal_crt_to_string))
        {
            return $this->cliente_notafiscal_crt_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_residencia_propria_to_string($cliente_fk_residencia_propria_to_string)
    {
        if(is_array($cliente_fk_residencia_propria_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_residencia_propria_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_residencia_propria_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_residencia_propria_to_string = $cliente_fk_residencia_propria_to_string;
        }

        $this->vdata['cliente_fk_residencia_propria_to_string'] = $this->cliente_fk_residencia_propria_to_string;
    }

    public function get_cliente_fk_residencia_propria_to_string()
    {
        if(!empty($this->cliente_fk_residencia_propria_to_string))
        {
            return $this->cliente_fk_residencia_propria_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('residencia_propria','{fk_residencia_propria->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_fk_utilizar_endereco_cobranca_to_string($cliente_fk_utilizar_endereco_cobranca_to_string)
    {
        if(is_array($cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            $values = Resposta::where('id', 'in', $cliente_fk_utilizar_endereco_cobranca_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_fk_utilizar_endereco_cobranca_to_string = $cliente_fk_utilizar_endereco_cobranca_to_string;
        }

        $this->vdata['cliente_fk_utilizar_endereco_cobranca_to_string'] = $this->cliente_fk_utilizar_endereco_cobranca_to_string;
    }

    public function get_cliente_fk_utilizar_endereco_cobranca_to_string()
    {
        if(!empty($this->cliente_fk_utilizar_endereco_cobranca_to_string))
        {
            return $this->cliente_fk_utilizar_endereco_cobranca_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('utilizar_endereco_cobranca','{fk_utilizar_endereco_cobranca->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_cliente_situacao_to_string($cliente_cliente_situacao_to_string)
    {
        if(is_array($cliente_cliente_situacao_to_string))
        {
            $values = ClienteSituacao::where('id', 'in', $cliente_cliente_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_cliente_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_cliente_situacao_to_string = $cliente_cliente_situacao_to_string;
        }

        $this->vdata['cliente_cliente_situacao_to_string'] = $this->cliente_cliente_situacao_to_string;
    }

    public function get_cliente_cliente_situacao_to_string()
    {
        if(!empty($this->cliente_cliente_situacao_to_string))
        {
            return $this->cliente_cliente_situacao_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_situacao_id','{cliente_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_cliente_system_unit_to_string($cliente_system_unit_to_string)
    {
        if(is_array($cliente_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $cliente_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->cliente_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_system_unit_to_string = $cliente_system_unit_to_string;
        }

        $this->vdata['cliente_system_unit_to_string'] = $this->cliente_system_unit_to_string;
    }

    public function get_cliente_system_unit_to_string()
    {
        if(!empty($this->cliente_system_unit_to_string))
        {
            return $this->cliente_system_unit_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_cliente_tabela_preco_to_string($cliente_tabela_preco_to_string)
    {
        if(is_array($cliente_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $cliente_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->cliente_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->cliente_tabela_preco_to_string = $cliente_tabela_preco_to_string;
        }

        $this->vdata['cliente_tabela_preco_to_string'] = $this->cliente_tabela_preco_to_string;
    }

    public function get_cliente_tabela_preco_to_string()
    {
        if(!empty($this->cliente_tabela_preco_to_string))
        {
            return $this->cliente_tabela_preco_to_string;
        }
    
        $values = Cliente::where('system_unit_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_configuracoes_to_string($configuracoes_filial_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_configuracoes_to_string))
        {
            $values = Configuracoes::where('id', 'in', $configuracoes_filial_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_configuracoes_to_string = $configuracoes_filial_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_configuracoes_to_string'] = $this->configuracoes_filial_configuracoes_to_string;
    }

    public function get_configuracoes_filial_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_configuracoes_to_string))
        {
            return $this->configuracoes_filial_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('configuracoes_id','{configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_system_unit_to_string($configuracoes_filial_system_unit_to_string)
    {
        if(is_array($configuracoes_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $configuracoes_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->configuracoes_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_system_unit_to_string = $configuracoes_filial_system_unit_to_string;
        }

        $this->vdata['configuracoes_filial_system_unit_to_string'] = $this->configuracoes_filial_system_unit_to_string;
    }

    public function get_configuracoes_filial_system_unit_to_string()
    {
        if(!empty($this->configuracoes_filial_system_unit_to_string))
        {
            return $this->configuracoes_filial_system_unit_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_produto_etiqueta_configuracoes_to_string($configuracoes_filial_produto_etiqueta_configuracoes_to_string)
    {
        if(is_array($configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            $values = ProdutoEtiquetaConfiguracoes::where('id', 'in', $configuracoes_filial_produto_etiqueta_configuracoes_to_string)->getIndexedArray('id', 'id');
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string = $configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }

        $this->vdata['configuracoes_filial_produto_etiqueta_configuracoes_to_string'] = $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
    }

    public function get_configuracoes_filial_produto_etiqueta_configuracoes_to_string()
    {
        if(!empty($this->configuracoes_filial_produto_etiqueta_configuracoes_to_string))
        {
            return $this->configuracoes_filial_produto_etiqueta_configuracoes_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_etiqueta_configuracoes_id','{produto_etiqueta_configuracoes->id}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_plano_conta_crec_to_string($configuracoes_filial_plano_conta_crec_to_string)
    {
        if(is_array($configuracoes_filial_plano_conta_crec_to_string))
        {
            $values = PlanoConta::where('id', 'in', $configuracoes_filial_plano_conta_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_plano_conta_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_plano_conta_crec_to_string = $configuracoes_filial_plano_conta_crec_to_string;
        }

        $this->vdata['configuracoes_filial_plano_conta_crec_to_string'] = $this->configuracoes_filial_plano_conta_crec_to_string;
    }

    public function get_configuracoes_filial_plano_conta_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_plano_conta_crec_to_string))
        {
            return $this->configuracoes_filial_plano_conta_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('plano_conta_crec_id','{plano_conta_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_centro_custo_crec_to_string($configuracoes_filial_centro_custo_crec_to_string)
    {
        if(is_array($configuracoes_filial_centro_custo_crec_to_string))
        {
            $values = CentroCusto::where('id', 'in', $configuracoes_filial_centro_custo_crec_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_centro_custo_crec_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_centro_custo_crec_to_string = $configuracoes_filial_centro_custo_crec_to_string;
        }

        $this->vdata['configuracoes_filial_centro_custo_crec_to_string'] = $this->configuracoes_filial_centro_custo_crec_to_string;
    }

    public function get_configuracoes_filial_centro_custo_crec_to_string()
    {
        if(!empty($this->configuracoes_filial_centro_custo_crec_to_string))
        {
            return $this->configuracoes_filial_centro_custo_crec_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('centro_custo_crec_id','{centro_custo_crec->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_cpag_usa_plano_contas_to_string($configuracoes_filial_cpag_usa_plano_contas_to_string)
    {
        if(is_array($configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_cpag_usa_plano_contas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_cpag_usa_plano_contas_to_string = $configuracoes_filial_cpag_usa_plano_contas_to_string;
        }

        $this->vdata['configuracoes_filial_cpag_usa_plano_contas_to_string'] = $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
    }

    public function get_configuracoes_filial_cpag_usa_plano_contas_to_string()
    {
        if(!empty($this->configuracoes_filial_cpag_usa_plano_contas_to_string))
        {
            return $this->configuracoes_filial_cpag_usa_plano_contas_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('cpag_usa_plano_contas_id','{cpag_usa_plano_contas->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_informar_duplicidade_de_item_venda_to_string($configuracoes_filial_informar_duplicidade_de_item_venda_to_string)
    {
        if(is_array($configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_informar_duplicidade_de_item_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string = $configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }

        $this->vdata['configuracoes_filial_informar_duplicidade_de_item_venda_to_string'] = $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
    }

    public function get_configuracoes_filial_informar_duplicidade_de_item_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string))
        {
            return $this->configuracoes_filial_informar_duplicidade_de_item_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('informar_duplicidade_de_item_venda_id','{informar_duplicidade_de_item_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_venda_apenas_com_estoque_to_string($configuracoes_filial_venda_apenas_com_estoque_to_string)
    {
        if(is_array($configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            $values = Resposta::where('id', 'in', $configuracoes_filial_venda_apenas_com_estoque_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_venda_apenas_com_estoque_to_string = $configuracoes_filial_venda_apenas_com_estoque_to_string;
        }

        $this->vdata['configuracoes_filial_venda_apenas_com_estoque_to_string'] = $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
    }

    public function get_configuracoes_filial_venda_apenas_com_estoque_to_string()
    {
        if(!empty($this->configuracoes_filial_venda_apenas_com_estoque_to_string))
        {
            return $this->configuracoes_filial_venda_apenas_com_estoque_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('venda_apenas_com_estoque_id','{venda_apenas_com_estoque->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string = $configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_orcamento_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_orcamento_id','{notafiscal_cprod_padrao_orcamento->descricao}');
        return implode(', ', $values);
    }

    public function set_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)
    {
        if(is_array($configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            $values = NotafiscalCprodPadrao::where('id', 'in', $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string = $configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }

        $this->vdata['configuracoes_filial_notafiscal_cprod_padrao_venda_to_string'] = $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
    }

    public function get_configuracoes_filial_notafiscal_cprod_padrao_venda_to_string()
    {
        if(!empty($this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string))
        {
            return $this->configuracoes_filial_notafiscal_cprod_padrao_venda_to_string;
        }
    
        $values = ConfiguracoesFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_cprod_padrao_venda_id','{notafiscal_cprod_padrao_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_system_unit_to_string($conta_corrente_system_unit_to_string)
    {
        if(is_array($conta_corrente_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $conta_corrente_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->conta_corrente_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_system_unit_to_string = $conta_corrente_system_unit_to_string;
        }

        $this->vdata['conta_corrente_system_unit_to_string'] = $this->conta_corrente_system_unit_to_string;
    }

    public function get_conta_corrente_system_unit_to_string()
    {
        if(!empty($this->conta_corrente_system_unit_to_string))
        {
            return $this->conta_corrente_system_unit_to_string;
        }
    
        $values = ContaCorrente::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_conta_corrente_banco_to_string($conta_corrente_banco_to_string)
    {
        if(is_array($conta_corrente_banco_to_string))
        {
            $values = Banco::where('id', 'in', $conta_corrente_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->conta_corrente_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->conta_corrente_banco_to_string = $conta_corrente_banco_to_string;
        }

        $this->vdata['conta_corrente_banco_to_string'] = $this->conta_corrente_banco_to_string;
    }

    public function get_conta_corrente_banco_to_string()
    {
        if(!empty($this->conta_corrente_banco_to_string))
        {
            return $this->conta_corrente_banco_to_string;
        }
    
        $values = ContaCorrente::where('system_unit_id', '=', $this->id)->getIndexedArray('banco_id','{banco->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_situacao_to_string($contaspag_contaspag_situacao_to_string)
    {
        if(is_array($contaspag_contaspag_situacao_to_string))
        {
            $values = ContaspagSituacao::where('id', 'in', $contaspag_contaspag_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_situacao_to_string = $contaspag_contaspag_situacao_to_string;
        }

        $this->vdata['contaspag_contaspag_situacao_to_string'] = $this->contaspag_contaspag_situacao_to_string;
    }

    public function get_contaspag_contaspag_situacao_to_string()
    {
        if(!empty($this->contaspag_contaspag_situacao_to_string))
        {
            return $this->contaspag_contaspag_situacao_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('contaspag_situacao_id','{contaspag_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_forma_pagamento_to_string($contaspag_forma_pagamento_to_string)
    {
        if(is_array($contaspag_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_forma_pagamento_to_string = $contaspag_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_forma_pagamento_to_string'] = $this->contaspag_forma_pagamento_to_string;
    }

    public function get_contaspag_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_forma_pagamento_to_string))
        {
            return $this->contaspag_forma_pagamento_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_fornecedor_to_string($contaspag_fornecedor_to_string)
    {
        if(is_array($contaspag_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_fornecedor_to_string = $contaspag_fornecedor_to_string;
        }

        $this->vdata['contaspag_fornecedor_to_string'] = $this->contaspag_fornecedor_to_string;
    }

    public function get_contaspag_fornecedor_to_string()
    {
        if(!empty($this->contaspag_fornecedor_to_string))
        {
            return $this->contaspag_fornecedor_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_origem_to_string($contaspag_contaspag_origem_to_string)
    {
        if(is_array($contaspag_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_origem_to_string = $contaspag_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_contaspag_origem_to_string'] = $this->contaspag_contaspag_origem_to_string;
    }

    public function get_contaspag_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_contaspag_origem_to_string))
        {
            return $this->contaspag_contaspag_origem_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_system_unit_to_string($contaspag_system_unit_to_string)
    {
        if(is_array($contaspag_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_system_unit_to_string = $contaspag_system_unit_to_string;
        }

        $this->vdata['contaspag_system_unit_to_string'] = $this->contaspag_system_unit_to_string;
    }

    public function get_contaspag_system_unit_to_string()
    {
        if(!empty($this->contaspag_system_unit_to_string))
        {
            return $this->contaspag_system_unit_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contaspag_cheque_banco_to_string($contaspag_cheque_banco_to_string)
    {
        if(is_array($contaspag_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contaspag_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_cheque_banco_to_string = $contaspag_cheque_banco_to_string;
        }

        $this->vdata['contaspag_cheque_banco_to_string'] = $this->contaspag_cheque_banco_to_string;
    }

    public function get_contaspag_cheque_banco_to_string()
    {
        if(!empty($this->contaspag_cheque_banco_to_string))
        {
            return $this->contaspag_cheque_banco_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_contaspag_bloco_to_string($contaspag_contaspag_bloco_to_string)
    {
        if(is_array($contaspag_contaspag_bloco_to_string))
        {
            $values = ContaspagBloco::where('id', 'in', $contaspag_contaspag_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_contaspag_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_contaspag_bloco_to_string = $contaspag_contaspag_bloco_to_string;
        }

        $this->vdata['contaspag_contaspag_bloco_to_string'] = $this->contaspag_contaspag_bloco_to_string;
    }

    public function get_contaspag_contaspag_bloco_to_string()
    {
        if(!empty($this->contaspag_contaspag_bloco_to_string))
        {
            return $this->contaspag_contaspag_bloco_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('contaspag_bloco_id','{contaspag_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_nota_fiscal_compra_to_string($contaspag_nota_fiscal_compra_to_string)
    {
        if(is_array($contaspag_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $contaspag_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->contaspag_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_nota_fiscal_compra_to_string = $contaspag_nota_fiscal_compra_to_string;
        }

        $this->vdata['contaspag_nota_fiscal_compra_to_string'] = $this->contaspag_nota_fiscal_compra_to_string;
    }

    public function get_contaspag_nota_fiscal_compra_to_string()
    {
        if(!empty($this->contaspag_nota_fiscal_compra_to_string))
        {
            return $this->contaspag_nota_fiscal_compra_to_string;
        }
    
        $values = Contaspag::where('system_unit_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_fornecedor_to_string($contaspag_bloco_fornecedor_to_string)
    {
        if(is_array($contaspag_bloco_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $contaspag_bloco_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contaspag_bloco_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_fornecedor_to_string = $contaspag_bloco_fornecedor_to_string;
        }

        $this->vdata['contaspag_bloco_fornecedor_to_string'] = $this->contaspag_bloco_fornecedor_to_string;
    }

    public function get_contaspag_bloco_fornecedor_to_string()
    {
        if(!empty($this->contaspag_bloco_fornecedor_to_string))
        {
            return $this->contaspag_bloco_fornecedor_to_string;
        }
    
        $values = ContaspagBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_forma_pagamento_to_string($contaspag_bloco_forma_pagamento_to_string)
    {
        if(is_array($contaspag_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contaspag_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_forma_pagamento_to_string = $contaspag_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contaspag_bloco_forma_pagamento_to_string'] = $this->contaspag_bloco_forma_pagamento_to_string;
    }

    public function get_contaspag_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contaspag_bloco_forma_pagamento_to_string))
        {
            return $this->contaspag_bloco_forma_pagamento_to_string;
        }
    
        $values = ContaspagBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_contaspag_origem_to_string($contaspag_bloco_contaspag_origem_to_string)
    {
        if(is_array($contaspag_bloco_contaspag_origem_to_string))
        {
            $values = ContaspagOrigem::where('id', 'in', $contaspag_bloco_contaspag_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contaspag_bloco_contaspag_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_contaspag_origem_to_string = $contaspag_bloco_contaspag_origem_to_string;
        }

        $this->vdata['contaspag_bloco_contaspag_origem_to_string'] = $this->contaspag_bloco_contaspag_origem_to_string;
    }

    public function get_contaspag_bloco_contaspag_origem_to_string()
    {
        if(!empty($this->contaspag_bloco_contaspag_origem_to_string))
        {
            return $this->contaspag_bloco_contaspag_origem_to_string;
        }
    
        $values = ContaspagBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('contaspag_origem_id','{contaspag_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contaspag_bloco_system_unit_to_string($contaspag_bloco_system_unit_to_string)
    {
        if(is_array($contaspag_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contaspag_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contaspag_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contaspag_bloco_system_unit_to_string = $contaspag_bloco_system_unit_to_string;
        }

        $this->vdata['contaspag_bloco_system_unit_to_string'] = $this->contaspag_bloco_system_unit_to_string;
    }

    public function get_contaspag_bloco_system_unit_to_string()
    {
        if(!empty($this->contaspag_bloco_system_unit_to_string))
        {
            return $this->contaspag_bloco_system_unit_to_string;
        }
    
        $values = ContaspagBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_system_unit_to_string($contasrec_system_unit_to_string)
    {
        if(is_array($contasrec_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_system_unit_to_string = $contasrec_system_unit_to_string;
        }

        $this->vdata['contasrec_system_unit_to_string'] = $this->contasrec_system_unit_to_string;
    }

    public function get_contasrec_system_unit_to_string()
    {
        if(!empty($this->contasrec_system_unit_to_string))
        {
            return $this->contasrec_system_unit_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_cliente_to_string($contasrec_cliente_to_string)
    {
        if(is_array($contasrec_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cliente_to_string = $contasrec_cliente_to_string;
        }

        $this->vdata['contasrec_cliente_to_string'] = $this->contasrec_cliente_to_string;
    }

    public function get_contasrec_cliente_to_string()
    {
        if(!empty($this->contasrec_cliente_to_string))
        {
            return $this->contasrec_cliente_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_forma_pagamento_to_string($contasrec_forma_pagamento_to_string)
    {
        if(is_array($contasrec_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_forma_pagamento_to_string = $contasrec_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_forma_pagamento_to_string'] = $this->contasrec_forma_pagamento_to_string;
    }

    public function get_contasrec_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_forma_pagamento_to_string))
        {
            return $this->contasrec_forma_pagamento_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_situacao_to_string($contasrec_contasrec_situacao_to_string)
    {
        if(is_array($contasrec_contasrec_situacao_to_string))
        {
            $values = ContasrecSituacao::where('id', 'in', $contasrec_contasrec_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_situacao_to_string = $contasrec_contasrec_situacao_to_string;
        }

        $this->vdata['contasrec_contasrec_situacao_to_string'] = $this->contasrec_contasrec_situacao_to_string;
    }

    public function get_contasrec_contasrec_situacao_to_string()
    {
        if(!empty($this->contasrec_contasrec_situacao_to_string))
        {
            return $this->contasrec_contasrec_situacao_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('contasrec_situacao_id','{contasrec_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_plano_conta_to_string($contasrec_plano_conta_to_string)
    {
        if(is_array($contasrec_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_plano_conta_to_string = $contasrec_plano_conta_to_string;
        }

        $this->vdata['contasrec_plano_conta_to_string'] = $this->contasrec_plano_conta_to_string;
    }

    public function get_contasrec_plano_conta_to_string()
    {
        if(!empty($this->contasrec_plano_conta_to_string))
        {
            return $this->contasrec_plano_conta_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_centro_custo_to_string($contasrec_centro_custo_to_string)
    {
        if(is_array($contasrec_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_centro_custo_to_string = $contasrec_centro_custo_to_string;
        }

        $this->vdata['contasrec_centro_custo_to_string'] = $this->contasrec_centro_custo_to_string;
    }

    public function get_contasrec_centro_custo_to_string()
    {
        if(!empty($this->contasrec_centro_custo_to_string))
        {
            return $this->contasrec_centro_custo_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_origem_to_string($contasrec_contasrec_origem_to_string)
    {
        if(is_array($contasrec_contasrec_origem_to_string))
        {
            $values = ContasrecOrigem::where('id', 'in', $contasrec_contasrec_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_contasrec_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_origem_to_string = $contasrec_contasrec_origem_to_string;
        }

        $this->vdata['contasrec_contasrec_origem_to_string'] = $this->contasrec_contasrec_origem_to_string;
    }

    public function get_contasrec_contasrec_origem_to_string()
    {
        if(!empty($this->contasrec_contasrec_origem_to_string))
        {
            return $this->contasrec_contasrec_origem_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('contasrec_origem_id','{contasrec_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_cheque_banco_to_string($contasrec_cheque_banco_to_string)
    {
        if(is_array($contasrec_cheque_banco_to_string))
        {
            $values = Banco::where('id', 'in', $contasrec_cheque_banco_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_cheque_banco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_cheque_banco_to_string = $contasrec_cheque_banco_to_string;
        }

        $this->vdata['contasrec_cheque_banco_to_string'] = $this->contasrec_cheque_banco_to_string;
    }

    public function get_contasrec_cheque_banco_to_string()
    {
        if(!empty($this->contasrec_cheque_banco_to_string))
        {
            return $this->contasrec_cheque_banco_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('cheque_banco_id','{cheque_banco->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_conta_corrente_boleto_to_string($contasrec_conta_corrente_boleto_to_string)
    {
        if(is_array($contasrec_conta_corrente_boleto_to_string))
        {
            $values = ContaCorrente::where('id', 'in', $contasrec_conta_corrente_boleto_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_conta_corrente_boleto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_conta_corrente_boleto_to_string = $contasrec_conta_corrente_boleto_to_string;
        }

        $this->vdata['contasrec_conta_corrente_boleto_to_string'] = $this->contasrec_conta_corrente_boleto_to_string;
    }

    public function get_contasrec_conta_corrente_boleto_to_string()
    {
        if(!empty($this->contasrec_conta_corrente_boleto_to_string))
        {
            return $this->contasrec_conta_corrente_boleto_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('conta_corrente_boleto_id','{conta_corrente_boleto->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_boleto_situacao_to_string($contasrec_boleto_situacao_to_string)
    {
        if(is_array($contasrec_boleto_situacao_to_string))
        {
            $values = BoletoSituacao::where('id', 'in', $contasrec_boleto_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_boleto_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_boleto_situacao_to_string = $contasrec_boleto_situacao_to_string;
        }

        $this->vdata['contasrec_boleto_situacao_to_string'] = $this->contasrec_boleto_situacao_to_string;
    }

    public function get_contasrec_boleto_situacao_to_string()
    {
        if(!empty($this->contasrec_boleto_situacao_to_string))
        {
            return $this->contasrec_boleto_situacao_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('boleto_situacao_id','{boleto_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_vendedor_to_string($contasrec_vendedor_to_string)
    {
        if(is_array($contasrec_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $contasrec_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_vendedor_to_string = $contasrec_vendedor_to_string;
        }

        $this->vdata['contasrec_vendedor_to_string'] = $this->contasrec_vendedor_to_string;
    }

    public function get_contasrec_vendedor_to_string()
    {
        if(!empty($this->contasrec_vendedor_to_string))
        {
            return $this->contasrec_vendedor_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_contasrec_bloco_to_string($contasrec_contasrec_bloco_to_string)
    {
        if(is_array($contasrec_contasrec_bloco_to_string))
        {
            $values = ContasrecBloco::where('id', 'in', $contasrec_contasrec_bloco_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_contasrec_bloco_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_contasrec_bloco_to_string = $contasrec_contasrec_bloco_to_string;
        }

        $this->vdata['contasrec_contasrec_bloco_to_string'] = $this->contasrec_contasrec_bloco_to_string;
    }

    public function get_contasrec_contasrec_bloco_to_string()
    {
        if(!empty($this->contasrec_contasrec_bloco_to_string))
        {
            return $this->contasrec_contasrec_bloco_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('contasrec_bloco_id','{contasrec_bloco->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_venda_formapgto_to_string($contasrec_venda_formapgto_to_string)
    {
        if(is_array($contasrec_venda_formapgto_to_string))
        {
            $values = VendaFormapgto::where('id', 'in', $contasrec_venda_formapgto_to_string)->getIndexedArray('id', 'id');
            $this->contasrec_venda_formapgto_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_venda_formapgto_to_string = $contasrec_venda_formapgto_to_string;
        }

        $this->vdata['contasrec_venda_formapgto_to_string'] = $this->contasrec_venda_formapgto_to_string;
    }

    public function get_contasrec_venda_formapgto_to_string()
    {
        if(!empty($this->contasrec_venda_formapgto_to_string))
        {
            return $this->contasrec_venda_formapgto_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('venda_formapgto_id','{venda_formapgto->id}');
        return implode(', ', $values);
    }

    public function set_contasrec_ativo_to_string($contasrec_ativo_to_string)
    {
        if(is_array($contasrec_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $contasrec_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_ativo_to_string = $contasrec_ativo_to_string;
        }

        $this->vdata['contasrec_ativo_to_string'] = $this->contasrec_ativo_to_string;
    }

    public function get_contasrec_ativo_to_string()
    {
        if(!empty($this->contasrec_ativo_to_string))
        {
            return $this->contasrec_ativo_to_string;
        }
    
        $values = Contasrec::where('system_unit_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_cliente_to_string($contasrec_bloco_cliente_to_string)
    {
        if(is_array($contasrec_bloco_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $contasrec_bloco_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->contasrec_bloco_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_cliente_to_string = $contasrec_bloco_cliente_to_string;
        }

        $this->vdata['contasrec_bloco_cliente_to_string'] = $this->contasrec_bloco_cliente_to_string;
    }

    public function get_contasrec_bloco_cliente_to_string()
    {
        if(!empty($this->contasrec_bloco_cliente_to_string))
        {
            return $this->contasrec_bloco_cliente_to_string;
        }
    
        $values = ContasrecBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_forma_pagamento_to_string($contasrec_bloco_forma_pagamento_to_string)
    {
        if(is_array($contasrec_bloco_forma_pagamento_to_string))
        {
            $values = FormaPagamento::where('id', 'in', $contasrec_bloco_forma_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_forma_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_forma_pagamento_to_string = $contasrec_bloco_forma_pagamento_to_string;
        }

        $this->vdata['contasrec_bloco_forma_pagamento_to_string'] = $this->contasrec_bloco_forma_pagamento_to_string;
    }

    public function get_contasrec_bloco_forma_pagamento_to_string()
    {
        if(!empty($this->contasrec_bloco_forma_pagamento_to_string))
        {
            return $this->contasrec_bloco_forma_pagamento_to_string;
        }
    
        $values = ContasrecBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('forma_pagamento_id','{forma_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_system_unit_to_string($contasrec_bloco_system_unit_to_string)
    {
        if(is_array($contasrec_bloco_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $contasrec_bloco_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->contasrec_bloco_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_system_unit_to_string = $contasrec_bloco_system_unit_to_string;
        }

        $this->vdata['contasrec_bloco_system_unit_to_string'] = $this->contasrec_bloco_system_unit_to_string;
    }

    public function get_contasrec_bloco_system_unit_to_string()
    {
        if(!empty($this->contasrec_bloco_system_unit_to_string))
        {
            return $this->contasrec_bloco_system_unit_to_string;
        }
    
        $values = ContasrecBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_plano_conta_to_string($contasrec_bloco_plano_conta_to_string)
    {
        if(is_array($contasrec_bloco_plano_conta_to_string))
        {
            $values = PlanoConta::where('id', 'in', $contasrec_bloco_plano_conta_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_plano_conta_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_plano_conta_to_string = $contasrec_bloco_plano_conta_to_string;
        }

        $this->vdata['contasrec_bloco_plano_conta_to_string'] = $this->contasrec_bloco_plano_conta_to_string;
    }

    public function get_contasrec_bloco_plano_conta_to_string()
    {
        if(!empty($this->contasrec_bloco_plano_conta_to_string))
        {
            return $this->contasrec_bloco_plano_conta_to_string;
        }
    
        $values = ContasrecBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('plano_conta_id','{plano_conta->descricao}');
        return implode(', ', $values);
    }

    public function set_contasrec_bloco_centro_custo_to_string($contasrec_bloco_centro_custo_to_string)
    {
        if(is_array($contasrec_bloco_centro_custo_to_string))
        {
            $values = CentroCusto::where('id', 'in', $contasrec_bloco_centro_custo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->contasrec_bloco_centro_custo_to_string = implode(', ', $values);
        }
        else
        {
            $this->contasrec_bloco_centro_custo_to_string = $contasrec_bloco_centro_custo_to_string;
        }

        $this->vdata['contasrec_bloco_centro_custo_to_string'] = $this->contasrec_bloco_centro_custo_to_string;
    }

    public function get_contasrec_bloco_centro_custo_to_string()
    {
        if(!empty($this->contasrec_bloco_centro_custo_to_string))
        {
            return $this->contasrec_bloco_centro_custo_to_string;
        }
    
        $values = ContasrecBloco::where('system_unit_id', '=', $this->id)->getIndexedArray('centro_custo_id','{centro_custo->descricao}');
        return implode(', ', $values);
    }

    public function set_dispositivos_system_unit_to_string($dispositivos_system_unit_to_string)
    {
        if(is_array($dispositivos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $dispositivos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->dispositivos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->dispositivos_system_unit_to_string = $dispositivos_system_unit_to_string;
        }

        $this->vdata['dispositivos_system_unit_to_string'] = $this->dispositivos_system_unit_to_string;
    }

    public function get_dispositivos_system_unit_to_string()
    {
        if(!empty($this->dispositivos_system_unit_to_string))
        {
            return $this->dispositivos_system_unit_to_string;
        }
    
        $values = Dispositivos::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_deposito_system_unit_to_string($estoque_deposito_system_unit_to_string)
    {
        if(is_array($estoque_deposito_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_deposito_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_deposito_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_deposito_system_unit_to_string = $estoque_deposito_system_unit_to_string;
        }

        $this->vdata['estoque_deposito_system_unit_to_string'] = $this->estoque_deposito_system_unit_to_string;
    }

    public function get_estoque_deposito_system_unit_to_string()
    {
        if(!empty($this->estoque_deposito_system_unit_to_string))
        {
            return $this->estoque_deposito_system_unit_to_string;
        }
    
        $values = EstoqueDeposito::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_to_string($estoque_lancamentos_produto_to_string)
    {
        if(is_array($estoque_lancamentos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_lancamentos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_lancamentos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_to_string = $estoque_lancamentos_produto_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_to_string'] = $this->estoque_lancamentos_produto_to_string;
    }

    public function get_estoque_lancamentos_produto_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_to_string))
        {
            return $this->estoque_lancamentos_produto_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_origem_to_string($estoque_lancamentos_estoque_origem_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_origem_to_string))
        {
            $values = EstoqueOrigem::where('id', 'in', $estoque_lancamentos_estoque_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_origem_to_string = $estoque_lancamentos_estoque_origem_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_origem_to_string'] = $this->estoque_lancamentos_estoque_origem_to_string;
    }

    public function get_estoque_lancamentos_estoque_origem_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_origem_to_string))
        {
            return $this->estoque_lancamentos_estoque_origem_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('estoque_origem_id','{estoque_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_tipo_movimentacao_to_string($estoque_lancamentos_estoque_tipo_movimentacao_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            $values = EstoqueTipoMovimentacao::where('id', 'in', $estoque_lancamentos_estoque_tipo_movimentacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string = $estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_tipo_movimentacao_to_string'] = $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
    }

    public function get_estoque_lancamentos_estoque_tipo_movimentacao_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_tipo_movimentacao_to_string))
        {
            return $this->estoque_lancamentos_estoque_tipo_movimentacao_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('estoque_tipo_movimentacao_id','{estoque_tipo_movimentacao->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_system_unit_to_string($estoque_lancamentos_system_unit_to_string)
    {
        if(is_array($estoque_lancamentos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_lancamentos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_lancamentos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_system_unit_to_string = $estoque_lancamentos_system_unit_to_string;
        }

        $this->vdata['estoque_lancamentos_system_unit_to_string'] = $this->estoque_lancamentos_system_unit_to_string;
    }

    public function get_estoque_lancamentos_system_unit_to_string()
    {
        if(!empty($this->estoque_lancamentos_system_unit_to_string))
        {
            return $this->estoque_lancamentos_system_unit_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_estoque_deposito_to_string($estoque_lancamentos_estoque_deposito_to_string)
    {
        if(is_array($estoque_lancamentos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_lancamentos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_lancamentos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_estoque_deposito_to_string = $estoque_lancamentos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_lancamentos_estoque_deposito_to_string'] = $this->estoque_lancamentos_estoque_deposito_to_string;
    }

    public function get_estoque_lancamentos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_lancamentos_estoque_deposito_to_string))
        {
            return $this->estoque_lancamentos_estoque_deposito_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_produto_lote_to_string($estoque_lancamentos_produto_lote_to_string)
    {
        if(is_array($estoque_lancamentos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_lancamentos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_lancamentos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_produto_lote_to_string = $estoque_lancamentos_produto_lote_to_string;
        }

        $this->vdata['estoque_lancamentos_produto_lote_to_string'] = $this->estoque_lancamentos_produto_lote_to_string;
    }

    public function get_estoque_lancamentos_produto_lote_to_string()
    {
        if(!empty($this->estoque_lancamentos_produto_lote_to_string))
        {
            return $this->estoque_lancamentos_produto_lote_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_venda_to_string($estoque_lancamentos_venda_to_string)
    {
        if(is_array($estoque_lancamentos_venda_to_string))
        {
            $values = Venda::where('id', 'in', $estoque_lancamentos_venda_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_venda_to_string = $estoque_lancamentos_venda_to_string;
        }

        $this->vdata['estoque_lancamentos_venda_to_string'] = $this->estoque_lancamentos_venda_to_string;
    }

    public function get_estoque_lancamentos_venda_to_string()
    {
        if(!empty($this->estoque_lancamentos_venda_to_string))
        {
            return $this->estoque_lancamentos_venda_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_nota_fiscal_compra_to_string($estoque_lancamentos_nota_fiscal_compra_to_string)
    {
        if(is_array($estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            $values = NotaFiscalCompra::where('id', 'in', $estoque_lancamentos_nota_fiscal_compra_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_nota_fiscal_compra_to_string = $estoque_lancamentos_nota_fiscal_compra_to_string;
        }

        $this->vdata['estoque_lancamentos_nota_fiscal_compra_to_string'] = $this->estoque_lancamentos_nota_fiscal_compra_to_string;
    }

    public function get_estoque_lancamentos_nota_fiscal_compra_to_string()
    {
        if(!empty($this->estoque_lancamentos_nota_fiscal_compra_to_string))
        {
            return $this->estoque_lancamentos_nota_fiscal_compra_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_id','{nota_fiscal_compra->id}');
        return implode(', ', $values);
    }

    public function set_estoque_lancamentos_ordem_producao_to_string($estoque_lancamentos_ordem_producao_to_string)
    {
        if(is_array($estoque_lancamentos_ordem_producao_to_string))
        {
            $values = OrdemProducao::where('id', 'in', $estoque_lancamentos_ordem_producao_to_string)->getIndexedArray('id', 'id');
            $this->estoque_lancamentos_ordem_producao_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_lancamentos_ordem_producao_to_string = $estoque_lancamentos_ordem_producao_to_string;
        }

        $this->vdata['estoque_lancamentos_ordem_producao_to_string'] = $this->estoque_lancamentos_ordem_producao_to_string;
    }

    public function get_estoque_lancamentos_ordem_producao_to_string()
    {
        if(!empty($this->estoque_lancamentos_ordem_producao_to_string))
        {
            return $this->estoque_lancamentos_ordem_producao_to_string;
        }
    
        $values = EstoqueLancamentos::where('system_unit_id', '=', $this->id)->getIndexedArray('ordem_producao_id','{ordem_producao->id}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_produto_to_string($estoque_saldos_produto_to_string)
    {
        if(is_array($estoque_saldos_produto_to_string))
        {
            $values = Produto::where('id', 'in', $estoque_saldos_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->estoque_saldos_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_produto_to_string = $estoque_saldos_produto_to_string;
        }

        $this->vdata['estoque_saldos_produto_to_string'] = $this->estoque_saldos_produto_to_string;
    }

    public function get_estoque_saldos_produto_to_string()
    {
        if(!empty($this->estoque_saldos_produto_to_string))
        {
            return $this->estoque_saldos_produto_to_string;
        }
    
        $values = EstoqueSaldos::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_system_unit_to_string($estoque_saldos_system_unit_to_string)
    {
        if(is_array($estoque_saldos_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $estoque_saldos_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->estoque_saldos_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_system_unit_to_string = $estoque_saldos_system_unit_to_string;
        }

        $this->vdata['estoque_saldos_system_unit_to_string'] = $this->estoque_saldos_system_unit_to_string;
    }

    public function get_estoque_saldos_system_unit_to_string()
    {
        if(!empty($this->estoque_saldos_system_unit_to_string))
        {
            return $this->estoque_saldos_system_unit_to_string;
        }
    
        $values = EstoqueSaldos::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_estoque_deposito_to_string($estoque_saldos_estoque_deposito_to_string)
    {
        if(is_array($estoque_saldos_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $estoque_saldos_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->estoque_saldos_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_estoque_deposito_to_string = $estoque_saldos_estoque_deposito_to_string;
        }

        $this->vdata['estoque_saldos_estoque_deposito_to_string'] = $this->estoque_saldos_estoque_deposito_to_string;
    }

    public function get_estoque_saldos_estoque_deposito_to_string()
    {
        if(!empty($this->estoque_saldos_estoque_deposito_to_string))
        {
            return $this->estoque_saldos_estoque_deposito_to_string;
        }
    
        $values = EstoqueSaldos::where('system_unit_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_estoque_saldos_produto_lote_to_string($estoque_saldos_produto_lote_to_string)
    {
        if(is_array($estoque_saldos_produto_lote_to_string))
        {
            $values = ProdutoLote::where('id', 'in', $estoque_saldos_produto_lote_to_string)->getIndexedArray('numero', 'numero');
            $this->estoque_saldos_produto_lote_to_string = implode(', ', $values);
        }
        else
        {
            $this->estoque_saldos_produto_lote_to_string = $estoque_saldos_produto_lote_to_string;
        }

        $this->vdata['estoque_saldos_produto_lote_to_string'] = $this->estoque_saldos_produto_lote_to_string;
    }

    public function get_estoque_saldos_produto_lote_to_string()
    {
        if(!empty($this->estoque_saldos_produto_lote_to_string))
        {
            return $this->estoque_saldos_produto_lote_to_string;
        }
    
        $values = EstoqueSaldos::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_lote_id','{produto_lote->numero}');
        return implode(', ', $values);
    }

    public function set_eventos_systemuser_eventos_to_string($eventos_systemuser_eventos_to_string)
    {
        if(is_array($eventos_systemuser_eventos_to_string))
        {
            $values = Eventos::where('id', 'in', $eventos_systemuser_eventos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->eventos_systemuser_eventos_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_systemuser_eventos_to_string = $eventos_systemuser_eventos_to_string;
        }

        $this->vdata['eventos_systemuser_eventos_to_string'] = $this->eventos_systemuser_eventos_to_string;
    }

    public function get_eventos_systemuser_eventos_to_string()
    {
        if(!empty($this->eventos_systemuser_eventos_to_string))
        {
            return $this->eventos_systemuser_eventos_to_string;
        }
    
        $values = EventosSystemuser::where('system_unit_id', '=', $this->id)->getIndexedArray('eventos_id','{eventos->descricao}');
        return implode(', ', $values);
    }

    public function set_eventos_systemuser_system_users_to_string($eventos_systemuser_system_users_to_string)
    {
        if(is_array($eventos_systemuser_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $eventos_systemuser_system_users_to_string)->getIndexedArray('name', 'name');
            $this->eventos_systemuser_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_systemuser_system_users_to_string = $eventos_systemuser_system_users_to_string;
        }

        $this->vdata['eventos_systemuser_system_users_to_string'] = $this->eventos_systemuser_system_users_to_string;
    }

    public function get_eventos_systemuser_system_users_to_string()
    {
        if(!empty($this->eventos_systemuser_system_users_to_string))
        {
            return $this->eventos_systemuser_system_users_to_string;
        }
    
        $values = EventosSystemuser::where('system_unit_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_eventos_systemuser_system_unit_to_string($eventos_systemuser_system_unit_to_string)
    {
        if(is_array($eventos_systemuser_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $eventos_systemuser_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->eventos_systemuser_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->eventos_systemuser_system_unit_to_string = $eventos_systemuser_system_unit_to_string;
        }

        $this->vdata['eventos_systemuser_system_unit_to_string'] = $this->eventos_systemuser_system_unit_to_string;
    }

    public function get_eventos_systemuser_system_unit_to_string()
    {
        if(!empty($this->eventos_systemuser_system_unit_to_string))
        {
            return $this->eventos_systemuser_system_unit_to_string;
        }
    
        $values = EventosSystemuser::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_inutilizar_numero_system_unit_to_string($inutilizar_numero_system_unit_to_string)
    {
        if(is_array($inutilizar_numero_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $inutilizar_numero_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->inutilizar_numero_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->inutilizar_numero_system_unit_to_string = $inutilizar_numero_system_unit_to_string;
        }

        $this->vdata['inutilizar_numero_system_unit_to_string'] = $this->inutilizar_numero_system_unit_to_string;
    }

    public function get_inutilizar_numero_system_unit_to_string()
    {
        if(!empty($this->inutilizar_numero_system_unit_to_string))
        {
            return $this->inutilizar_numero_system_unit_to_string;
        }
    
        $values = InutilizarNumero::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_inutilizar_numero_system_users_to_string($inutilizar_numero_system_users_to_string)
    {
        if(is_array($inutilizar_numero_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $inutilizar_numero_system_users_to_string)->getIndexedArray('name', 'name');
            $this->inutilizar_numero_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->inutilizar_numero_system_users_to_string = $inutilizar_numero_system_users_to_string;
        }

        $this->vdata['inutilizar_numero_system_users_to_string'] = $this->inutilizar_numero_system_users_to_string;
    }

    public function get_inutilizar_numero_system_users_to_string()
    {
        if(!empty($this->inutilizar_numero_system_users_to_string))
        {
            return $this->inutilizar_numero_system_users_to_string;
        }
    
        $values = InutilizarNumero::where('system_unit_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_mdfe_system_unit_to_string($mdfe_system_unit_to_string)
    {
        if(is_array($mdfe_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $mdfe_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->mdfe_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_system_unit_to_string = $mdfe_system_unit_to_string;
        }

        $this->vdata['mdfe_system_unit_to_string'] = $this->mdfe_system_unit_to_string;
    }

    public function get_mdfe_system_unit_to_string()
    {
        if(!empty($this->mdfe_system_unit_to_string))
        {
            return $this->mdfe_system_unit_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpemit_to_string($mdfe_mdfe_tpemit_to_string)
    {
        if(is_array($mdfe_mdfe_tpemit_to_string))
        {
            $values = MdfeTpemit::where('id', 'in', $mdfe_mdfe_tpemit_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpemit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpemit_to_string = $mdfe_mdfe_tpemit_to_string;
        }

        $this->vdata['mdfe_mdfe_tpemit_to_string'] = $this->mdfe_mdfe_tpemit_to_string;
    }

    public function get_mdfe_mdfe_tpemit_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpemit_to_string))
        {
            return $this->mdfe_mdfe_tpemit_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tpemit_id','{mdfe_tpemit->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpprop_to_string($mdfe_mdfe_tpprop_to_string)
    {
        if(is_array($mdfe_mdfe_tpprop_to_string))
        {
            $values = MdfeTpprop::where('id', 'in', $mdfe_mdfe_tpprop_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpprop_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpprop_to_string = $mdfe_mdfe_tpprop_to_string;
        }

        $this->vdata['mdfe_mdfe_tpprop_to_string'] = $this->mdfe_mdfe_tpprop_to_string;
    }

    public function get_mdfe_mdfe_tpprop_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpprop_to_string))
        {
            return $this->mdfe_mdfe_tpprop_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tpprop_id','{mdfe_tpprop->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tptransp_to_string($mdfe_mdfe_tptransp_to_string)
    {
        if(is_array($mdfe_mdfe_tptransp_to_string))
        {
            $values = MdfeTptransp::where('id', 'in', $mdfe_mdfe_tptransp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tptransp_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tptransp_to_string = $mdfe_mdfe_tptransp_to_string;
        }

        $this->vdata['mdfe_mdfe_tptransp_to_string'] = $this->mdfe_mdfe_tptransp_to_string;
    }

    public function get_mdfe_mdfe_tptransp_to_string()
    {
        if(!empty($this->mdfe_mdfe_tptransp_to_string))
        {
            return $this->mdfe_mdfe_tptransp_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tptransp_id','{mdfe_tptransp->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcar_to_string($mdfe_mdfe_tpcar_to_string)
    {
        if(is_array($mdfe_mdfe_tpcar_to_string))
        {
            $values = MdfeTpcar::where('id', 'in', $mdfe_mdfe_tpcar_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcar_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcar_to_string = $mdfe_mdfe_tpcar_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcar_to_string'] = $this->mdfe_mdfe_tpcar_to_string;
    }

    public function get_mdfe_mdfe_tpcar_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcar_to_string))
        {
            return $this->mdfe_mdfe_tpcar_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tpcar_id','{mdfe_tpcar->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFIni_to_string($mdfe_fk_UFIni_to_string)
    {
        if(is_array($mdfe_fk_UFIni_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFIni_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFIni_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFIni_to_string = $mdfe_fk_UFIni_to_string;
        }

        $this->vdata['mdfe_fk_UFIni_to_string'] = $this->mdfe_fk_UFIni_to_string;
    }

    public function get_mdfe_fk_UFIni_to_string()
    {
        if(!empty($this->mdfe_fk_UFIni_to_string))
        {
            return $this->mdfe_fk_UFIni_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('UFIni','{fk_UFIni->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_UFFim_to_string($mdfe_fk_UFFim_to_string)
    {
        if(is_array($mdfe_fk_UFFim_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_fk_UFFim_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_fk_UFFim_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_UFFim_to_string = $mdfe_fk_UFFim_to_string;
        }

        $this->vdata['mdfe_fk_UFFim_to_string'] = $this->mdfe_fk_UFFim_to_string;
    }

    public function get_mdfe_fk_UFFim_to_string()
    {
        if(!empty($this->mdfe_fk_UFFim_to_string))
        {
            return $this->mdfe_fk_UFFim_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('UFFim','{fk_UFFim->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCanalVerde_to_string($mdfe_fk_indCanalVerde_to_string)
    {
        if(is_array($mdfe_fk_indCanalVerde_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCanalVerde_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCanalVerde_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCanalVerde_to_string = $mdfe_fk_indCanalVerde_to_string;
        }

        $this->vdata['mdfe_fk_indCanalVerde_to_string'] = $this->mdfe_fk_indCanalVerde_to_string;
    }

    public function get_mdfe_fk_indCanalVerde_to_string()
    {
        if(!empty($this->mdfe_fk_indCanalVerde_to_string))
        {
            return $this->mdfe_fk_indCanalVerde_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('indCanalVerde','{fk_indCanalVerde->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indCarregaPosterior_to_string($mdfe_fk_indCarregaPosterior_to_string)
    {
        if(is_array($mdfe_fk_indCarregaPosterior_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indCarregaPosterior_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indCarregaPosterior_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indCarregaPosterior_to_string = $mdfe_fk_indCarregaPosterior_to_string;
        }

        $this->vdata['mdfe_fk_indCarregaPosterior_to_string'] = $this->mdfe_fk_indCarregaPosterior_to_string;
    }

    public function get_mdfe_fk_indCarregaPosterior_to_string()
    {
        if(!empty($this->mdfe_fk_indCarregaPosterior_to_string))
        {
            return $this->mdfe_fk_indCarregaPosterior_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('indCarregaPosterior','{fk_indCarregaPosterior->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_respSeg_to_string($mdfe_mdfe_respSeg_to_string)
    {
        if(is_array($mdfe_mdfe_respSeg_to_string))
        {
            $values = MdfeRespseg::where('id', 'in', $mdfe_mdfe_respSeg_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_respSeg_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_respSeg_to_string = $mdfe_mdfe_respSeg_to_string;
        }

        $this->vdata['mdfe_mdfe_respSeg_to_string'] = $this->mdfe_mdfe_respSeg_to_string;
    }

    public function get_mdfe_mdfe_respSeg_to_string()
    {
        if(!empty($this->mdfe_mdfe_respSeg_to_string))
        {
            return $this->mdfe_mdfe_respSeg_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_respSeg_id','{mdfe_respSeg->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_cunid_to_string($mdfe_mdfe_cunid_to_string)
    {
        if(is_array($mdfe_mdfe_cunid_to_string))
        {
            $values = MdfeCunid::where('id', 'in', $mdfe_mdfe_cunid_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_cunid_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_cunid_to_string = $mdfe_mdfe_cunid_to_string;
        }

        $this->vdata['mdfe_mdfe_cunid_to_string'] = $this->mdfe_mdfe_cunid_to_string;
    }

    public function get_mdfe_mdfe_cunid_to_string()
    {
        if(!empty($this->mdfe_mdfe_cunid_to_string))
        {
            return $this->mdfe_mdfe_cunid_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_cunid_id','{mdfe_cunid->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpcarga_to_string($mdfe_mdfe_tpcarga_to_string)
    {
        if(is_array($mdfe_mdfe_tpcarga_to_string))
        {
            $values = MdfeTpcarga::where('id', 'in', $mdfe_mdfe_tpcarga_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpcarga_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpcarga_to_string = $mdfe_mdfe_tpcarga_to_string;
        }

        $this->vdata['mdfe_mdfe_tpcarga_to_string'] = $this->mdfe_mdfe_tpcarga_to_string;
    }

    public function get_mdfe_mdfe_tpcarga_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpcarga_to_string))
        {
            return $this->mdfe_mdfe_tpcarga_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tpcarga_id','{mdfe_tpcarga->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_indpag_to_string($mdfe_mdfe_indpag_to_string)
    {
        if(is_array($mdfe_mdfe_indpag_to_string))
        {
            $values = MdfeIndpag::where('id', 'in', $mdfe_mdfe_indpag_to_string)->getIndexedArray('id', 'id');
            $this->mdfe_mdfe_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_indpag_to_string = $mdfe_mdfe_indpag_to_string;
        }

        $this->vdata['mdfe_mdfe_indpag_to_string'] = $this->mdfe_mdfe_indpag_to_string;
    }

    public function get_mdfe_mdfe_indpag_to_string()
    {
        if(!empty($this->mdfe_mdfe_indpag_to_string))
        {
            return $this->mdfe_mdfe_indpag_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_indpag_id','{mdfe_indpag->id}');
        return implode(', ', $values);
    }

    public function set_mdfe_fk_indAntecipaAdiant_to_string($mdfe_fk_indAntecipaAdiant_to_string)
    {
        if(is_array($mdfe_fk_indAntecipaAdiant_to_string))
        {
            $values = Resposta::where('id', 'in', $mdfe_fk_indAntecipaAdiant_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_fk_indAntecipaAdiant_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_fk_indAntecipaAdiant_to_string = $mdfe_fk_indAntecipaAdiant_to_string;
        }

        $this->vdata['mdfe_fk_indAntecipaAdiant_to_string'] = $this->mdfe_fk_indAntecipaAdiant_to_string;
    }

    public function get_mdfe_fk_indAntecipaAdiant_to_string()
    {
        if(!empty($this->mdfe_fk_indAntecipaAdiant_to_string))
        {
            return $this->mdfe_fk_indAntecipaAdiant_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('indAntecipaAdiant','{fk_indAntecipaAdiant->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpRod_to_string($mdfe_mdfe_tpRod_to_string)
    {
        if(is_array($mdfe_mdfe_tpRod_to_string))
        {
            $values = MdfeTprod::where('id', 'in', $mdfe_mdfe_tpRod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpRod_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpRod_to_string = $mdfe_mdfe_tpRod_to_string;
        }

        $this->vdata['mdfe_mdfe_tpRod_to_string'] = $this->mdfe_mdfe_tpRod_to_string;
    }

    public function get_mdfe_mdfe_tpRod_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpRod_to_string))
        {
            return $this->mdfe_mdfe_tpRod_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tpRod_id','{mdfe_tpRod->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_veic_estado_to_string($mdfe_veic_estado_to_string)
    {
        if(is_array($mdfe_veic_estado_to_string))
        {
            $values = Estado::where('id', 'in', $mdfe_veic_estado_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_veic_estado_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veic_estado_to_string = $mdfe_veic_estado_to_string;
        }

        $this->vdata['mdfe_veic_estado_to_string'] = $this->mdfe_veic_estado_to_string;
    }

    public function get_mdfe_veic_estado_to_string()
    {
        if(!empty($this->mdfe_veic_estado_to_string))
        {
            return $this->mdfe_veic_estado_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('veic_estado_id','{veic_estado->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_veiculo_to_string($mdfe_veiculo_to_string)
    {
        if(is_array($mdfe_veiculo_to_string))
        {
            $values = Veiculo::where('id', 'in', $mdfe_veiculo_to_string)->getIndexedArray('modelo_marca', 'modelo_marca');
            $this->mdfe_veiculo_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_veiculo_to_string = $mdfe_veiculo_to_string;
        }

        $this->vdata['mdfe_veiculo_to_string'] = $this->mdfe_veiculo_to_string;
    }

    public function get_mdfe_veiculo_to_string()
    {
        if(!empty($this->mdfe_veiculo_to_string))
        {
            return $this->mdfe_veiculo_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('veiculo_id','{veiculo->modelo_marca}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_situacao_to_string($mdfe_mdfe_situacao_to_string)
    {
        if(is_array($mdfe_mdfe_situacao_to_string))
        {
            $values = MdfeSituacao::where('id', 'in', $mdfe_mdfe_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_situacao_to_string = $mdfe_mdfe_situacao_to_string;
        }

        $this->vdata['mdfe_mdfe_situacao_to_string'] = $this->mdfe_mdfe_situacao_to_string;
    }

    public function get_mdfe_mdfe_situacao_to_string()
    {
        if(!empty($this->mdfe_mdfe_situacao_to_string))
        {
            return $this->mdfe_mdfe_situacao_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_situacao_id','{mdfe_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_mdfe_tpamb_to_string($mdfe_mdfe_tpamb_to_string)
    {
        if(is_array($mdfe_mdfe_tpamb_to_string))
        {
            $values = MdfeTpamb::where('id', 'in', $mdfe_mdfe_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_mdfe_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_mdfe_tpamb_to_string = $mdfe_mdfe_tpamb_to_string;
        }

        $this->vdata['mdfe_mdfe_tpamb_to_string'] = $this->mdfe_mdfe_tpamb_to_string;
    }

    public function get_mdfe_mdfe_tpamb_to_string()
    {
        if(!empty($this->mdfe_mdfe_tpamb_to_string))
        {
            return $this->mdfe_mdfe_tpamb_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tpamb_id','{mdfe_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_api_documentos_to_string($mdfe_api_documentos_to_string)
    {
        if(is_array($mdfe_api_documentos_to_string))
        {
            $values = ApiDocumentos::where('id', 'in', $mdfe_api_documentos_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_api_documentos_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_api_documentos_to_string = $mdfe_api_documentos_to_string;
        }

        $this->vdata['mdfe_api_documentos_to_string'] = $this->mdfe_api_documentos_to_string;
    }

    public function get_mdfe_api_documentos_to_string()
    {
        if(!empty($this->mdfe_api_documentos_to_string))
        {
            return $this->mdfe_api_documentos_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('api_documentos_id','{api_documentos->descricao}');
        return implode(', ', $values);
    }

    public function set_mdfe_cidade_encerramento_to_string($mdfe_cidade_encerramento_to_string)
    {
        if(is_array($mdfe_cidade_encerramento_to_string))
        {
            $values = Cidade::where('id', 'in', $mdfe_cidade_encerramento_to_string)->getIndexedArray('nome', 'nome');
            $this->mdfe_cidade_encerramento_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_cidade_encerramento_to_string = $mdfe_cidade_encerramento_to_string;
        }

        $this->vdata['mdfe_cidade_encerramento_to_string'] = $this->mdfe_cidade_encerramento_to_string;
    }

    public function get_mdfe_cidade_encerramento_to_string()
    {
        if(!empty($this->mdfe_cidade_encerramento_to_string))
        {
            return $this->mdfe_cidade_encerramento_to_string;
        }
    
        $values = Mdfe::where('system_unit_id', '=', $this->id)->getIndexedArray('cidade_encerramento_id','{cidade_encerramento->nome}');
        return implode(', ', $values);
    }

    public function set_mdfe_series_system_unit_to_string($mdfe_series_system_unit_to_string)
    {
        if(is_array($mdfe_series_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $mdfe_series_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->mdfe_series_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_series_system_unit_to_string = $mdfe_series_system_unit_to_string;
        }

        $this->vdata['mdfe_series_system_unit_to_string'] = $this->mdfe_series_system_unit_to_string;
    }

    public function get_mdfe_series_system_unit_to_string()
    {
        if(!empty($this->mdfe_series_system_unit_to_string))
        {
            return $this->mdfe_series_system_unit_to_string;
        }
    
        $values = MdfeSeries::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_mdfe_series_mdfe_tpamb_to_string($mdfe_series_mdfe_tpamb_to_string)
    {
        if(is_array($mdfe_series_mdfe_tpamb_to_string))
        {
            $values = MdfeTpamb::where('id', 'in', $mdfe_series_mdfe_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->mdfe_series_mdfe_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->mdfe_series_mdfe_tpamb_to_string = $mdfe_series_mdfe_tpamb_to_string;
        }

        $this->vdata['mdfe_series_mdfe_tpamb_to_string'] = $this->mdfe_series_mdfe_tpamb_to_string;
    }

    public function get_mdfe_series_mdfe_tpamb_to_string()
    {
        if(!empty($this->mdfe_series_mdfe_tpamb_to_string))
        {
            return $this->mdfe_series_mdfe_tpamb_to_string;
        }
    
        $values = MdfeSeries::where('system_unit_id', '=', $this->id)->getIndexedArray('mdfe_tpamb_id','{mdfe_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_system_unit_to_string($negocio_system_unit_to_string)
    {
        if(is_array($negocio_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $negocio_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->negocio_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_system_unit_to_string = $negocio_system_unit_to_string;
        }

        $this->vdata['negocio_system_unit_to_string'] = $this->negocio_system_unit_to_string;
    }

    public function get_negocio_system_unit_to_string()
    {
        if(!empty($this->negocio_system_unit_to_string))
        {
            return $this->negocio_system_unit_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_origem_to_string($negocio_negocio_origem_to_string)
    {
        if(is_array($negocio_negocio_origem_to_string))
        {
            $values = NegocioOrigem::where('id', 'in', $negocio_negocio_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_origem_to_string = $negocio_negocio_origem_to_string;
        }

        $this->vdata['negocio_negocio_origem_to_string'] = $this->negocio_negocio_origem_to_string;
    }

    public function get_negocio_negocio_origem_to_string()
    {
        if(!empty($this->negocio_negocio_origem_to_string))
        {
            return $this->negocio_negocio_origem_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('negocio_origem_id','{negocio_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_to_string($negocio_funil_to_string)
    {
        if(is_array($negocio_funil_to_string))
        {
            $values = Funil::where('id', 'in', $negocio_funil_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_to_string = $negocio_funil_to_string;
        }

        $this->vdata['negocio_funil_to_string'] = $this->negocio_funil_to_string;
    }

    public function get_negocio_funil_to_string()
    {
        if(!empty($this->negocio_funil_to_string))
        {
            return $this->negocio_funil_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('funil_id','{funil->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_funil_etapas_to_string($negocio_funil_etapas_to_string)
    {
        if(is_array($negocio_funil_etapas_to_string))
        {
            $values = FunilEtapas::where('id', 'in', $negocio_funil_etapas_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_funil_etapas_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_funil_etapas_to_string = $negocio_funil_etapas_to_string;
        }

        $this->vdata['negocio_funil_etapas_to_string'] = $this->negocio_funil_etapas_to_string;
    }

    public function get_negocio_funil_etapas_to_string()
    {
        if(!empty($this->negocio_funil_etapas_to_string))
        {
            return $this->negocio_funil_etapas_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('funil_etapas_id','{funil_etapas->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_negocio_motivo_perda_to_string($negocio_negocio_motivo_perda_to_string)
    {
        if(is_array($negocio_negocio_motivo_perda_to_string))
        {
            $values = NegocioMotivoPerda::where('id', 'in', $negocio_negocio_motivo_perda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_negocio_motivo_perda_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_negocio_motivo_perda_to_string = $negocio_negocio_motivo_perda_to_string;
        }

        $this->vdata['negocio_negocio_motivo_perda_to_string'] = $this->negocio_negocio_motivo_perda_to_string;
    }

    public function get_negocio_negocio_motivo_perda_to_string()
    {
        if(!empty($this->negocio_negocio_motivo_perda_to_string))
        {
            return $this->negocio_negocio_motivo_perda_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('negocio_motivo_perda_id','{negocio_motivo_perda->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_ativo_to_string($negocio_ativo_to_string)
    {
        if(is_array($negocio_ativo_to_string))
        {
            $values = Ativo::where('id', 'in', $negocio_ativo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_ativo_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_ativo_to_string = $negocio_ativo_to_string;
        }

        $this->vdata['negocio_ativo_to_string'] = $this->negocio_ativo_to_string;
    }

    public function get_negocio_ativo_to_string()
    {
        if(!empty($this->negocio_ativo_to_string))
        {
            return $this->negocio_ativo_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('ativo_id','{ativo->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_fk_arquivado_to_string($negocio_fk_arquivado_to_string)
    {
        if(is_array($negocio_fk_arquivado_to_string))
        {
            $values = Resposta::where('id', 'in', $negocio_fk_arquivado_to_string)->getIndexedArray('descricao', 'descricao');
            $this->negocio_fk_arquivado_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_fk_arquivado_to_string = $negocio_fk_arquivado_to_string;
        }

        $this->vdata['negocio_fk_arquivado_to_string'] = $this->negocio_fk_arquivado_to_string;
    }

    public function get_negocio_fk_arquivado_to_string()
    {
        if(!empty($this->negocio_fk_arquivado_to_string))
        {
            return $this->negocio_fk_arquivado_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('arquivado','{fk_arquivado->descricao}');
        return implode(', ', $values);
    }

    public function set_negocio_vendedor_to_string($negocio_vendedor_to_string)
    {
        if(is_array($negocio_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $negocio_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_vendedor_to_string = $negocio_vendedor_to_string;
        }

        $this->vdata['negocio_vendedor_to_string'] = $this->negocio_vendedor_to_string;
    }

    public function get_negocio_vendedor_to_string()
    {
        if(!empty($this->negocio_vendedor_to_string))
        {
            return $this->negocio_vendedor_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_negocio_orcamento_to_string($negocio_orcamento_to_string)
    {
        if(is_array($negocio_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $negocio_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->negocio_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_orcamento_to_string = $negocio_orcamento_to_string;
        }

        $this->vdata['negocio_orcamento_to_string'] = $this->negocio_orcamento_to_string;
    }

    public function get_negocio_orcamento_to_string()
    {
        if(!empty($this->negocio_orcamento_to_string))
        {
            return $this->negocio_orcamento_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_negocio_cliente_to_string($negocio_cliente_to_string)
    {
        if(is_array($negocio_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $negocio_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->negocio_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->negocio_cliente_to_string = $negocio_cliente_to_string;
        }

        $this->vdata['negocio_cliente_to_string'] = $this->negocio_cliente_to_string;
    }

    public function get_negocio_cliente_to_string()
    {
        if(!empty($this->negocio_cliente_to_string))
        {
            return $this->negocio_cliente_to_string;
        }
    
        $values = Negocio::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_system_unit_to_string($notafiscal_system_unit_to_string)
    {
        if(is_array($notafiscal_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_system_unit_to_string = $notafiscal_system_unit_to_string;
        }

        $this->vdata['notafiscal_system_unit_to_string'] = $this->notafiscal_system_unit_to_string;
    }

    public function get_notafiscal_system_unit_to_string()
    {
        if(!empty($this->notafiscal_system_unit_to_string))
        {
            return $this->notafiscal_system_unit_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_cliente_to_string($notafiscal_cliente_to_string)
    {
        if(is_array($notafiscal_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $notafiscal_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->notafiscal_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_cliente_to_string = $notafiscal_cliente_to_string;
        }

        $this->vdata['notafiscal_cliente_to_string'] = $this->notafiscal_cliente_to_string;
    }

    public function get_notafiscal_cliente_to_string()
    {
        if(!empty($this->notafiscal_cliente_to_string))
        {
            return $this->notafiscal_cliente_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_notafiscal_venda_to_string($notafiscal_venda_to_string)
    {
        if(is_array($notafiscal_venda_to_string))
        {
            $values = Venda::where('id', 'in', $notafiscal_venda_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_venda_to_string = $notafiscal_venda_to_string;
        }

        $this->vdata['notafiscal_venda_to_string'] = $this->notafiscal_venda_to_string;
    }

    public function get_notafiscal_venda_to_string()
    {
        if(!empty($this->notafiscal_venda_to_string))
        {
            return $this->notafiscal_venda_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_nf_tipodocumento_to_string($notafiscal_nf_tipodocumento_to_string)
    {
        if(is_array($notafiscal_nf_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_nf_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_nf_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_nf_tipodocumento_to_string = $notafiscal_nf_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_nf_tipodocumento_to_string'] = $this->notafiscal_nf_tipodocumento_to_string;
    }

    public function get_notafiscal_nf_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_nf_tipodocumento_to_string))
        {
            return $this->notafiscal_nf_tipodocumento_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('nf_tipodocumento_id','{nf_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_situacao_to_string($notafiscal_notafiscal_situacao_to_string)
    {
        if(is_array($notafiscal_notafiscal_situacao_to_string))
        {
            $values = NotafiscalSituacao::where('id', 'in', $notafiscal_notafiscal_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_situacao_to_string = $notafiscal_notafiscal_situacao_to_string;
        }

        $this->vdata['notafiscal_notafiscal_situacao_to_string'] = $this->notafiscal_notafiscal_situacao_to_string;
    }

    public function get_notafiscal_notafiscal_situacao_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_situacao_to_string))
        {
            return $this->notafiscal_notafiscal_situacao_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_situacao_id','{notafiscal_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_crt_to_string($notafiscal_notafiscal_crt_to_string)
    {
        if(is_array($notafiscal_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $notafiscal_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_crt_to_string = $notafiscal_notafiscal_crt_to_string;
        }

        $this->vdata['notafiscal_notafiscal_crt_to_string'] = $this->notafiscal_notafiscal_crt_to_string;
    }

    public function get_notafiscal_notafiscal_crt_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_crt_to_string))
        {
            return $this->notafiscal_notafiscal_crt_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indiedest_to_string($notafiscal_notafiscal_indiedest_to_string)
    {
        if(is_array($notafiscal_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $notafiscal_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indiedest_to_string = $notafiscal_notafiscal_indiedest_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indiedest_to_string'] = $this->notafiscal_notafiscal_indiedest_to_string;
    }

    public function get_notafiscal_notafiscal_indiedest_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indiedest_to_string))
        {
            return $this->notafiscal_notafiscal_indiedest_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscaldest_to_string($notafiscal_notafiscaldest_to_string)
    {
        if(is_array($notafiscal_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $notafiscal_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscaldest_to_string = $notafiscal_notafiscaldest_to_string;
        }

        $this->vdata['notafiscal_notafiscaldest_to_string'] = $this->notafiscal_notafiscaldest_to_string;
    }

    public function get_notafiscal_notafiscaldest_to_string()
    {
        if(!empty($this->notafiscal_notafiscaldest_to_string))
        {
            return $this->notafiscal_notafiscaldest_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpimp_to_string($notafiscal_notafiscal_tpimp_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $notafiscal_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpimp_to_string = $notafiscal_notafiscal_tpimp_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpimp_to_string'] = $this->notafiscal_notafiscal_tpimp_to_string;
    }

    public function get_notafiscal_notafiscal_tpimp_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpimp_to_string))
        {
            return $this->notafiscal_notafiscal_tpimp_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpemis_to_string($notafiscal_notafiscal_tpemis_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpemis_to_string))
        {
            $values = NotafiscalTpemis::where('id', 'in', $notafiscal_notafiscal_tpemis_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpemis_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpemis_to_string = $notafiscal_notafiscal_tpemis_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpemis_to_string'] = $this->notafiscal_notafiscal_tpemis_to_string;
    }

    public function get_notafiscal_notafiscal_tpemis_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpemis_to_string))
        {
            return $this->notafiscal_notafiscal_tpemis_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_tpemis_id','{notafiscal_tpemis->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_finnfe_to_string($notafiscal_notafiscal_finnfe_to_string)
    {
        if(is_array($notafiscal_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $notafiscal_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_finnfe_to_string = $notafiscal_notafiscal_finnfe_to_string;
        }

        $this->vdata['notafiscal_notafiscal_finnfe_to_string'] = $this->notafiscal_notafiscal_finnfe_to_string;
    }

    public function get_notafiscal_notafiscal_finnfe_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_finnfe_to_string))
        {
            return $this->notafiscal_notafiscal_finnfe_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indfinal_to_string($notafiscal_notafiscal_indfinal_to_string)
    {
        if(is_array($notafiscal_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $notafiscal_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indfinal_to_string = $notafiscal_notafiscal_indfinal_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indfinal_to_string'] = $this->notafiscal_notafiscal_indfinal_to_string;
    }

    public function get_notafiscal_notafiscal_indfinal_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indfinal_to_string))
        {
            return $this->notafiscal_notafiscal_indfinal_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpres_to_string($notafiscal_notafiscal_indpres_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $notafiscal_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpres_to_string = $notafiscal_notafiscal_indpres_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpres_to_string'] = $this->notafiscal_notafiscal_indpres_to_string;
    }

    public function get_notafiscal_notafiscal_indpres_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpres_to_string))
        {
            return $this->notafiscal_notafiscal_indpres_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_indpag_to_string($notafiscal_notafiscal_indpag_to_string)
    {
        if(is_array($notafiscal_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $notafiscal_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_indpag_to_string = $notafiscal_notafiscal_indpag_to_string;
        }

        $this->vdata['notafiscal_notafiscal_indpag_to_string'] = $this->notafiscal_notafiscal_indpag_to_string;
    }

    public function get_notafiscal_notafiscal_indpag_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_indpag_to_string))
        {
            return $this->notafiscal_notafiscal_indpag_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_dispositivos_to_string($notafiscal_dispositivos_to_string)
    {
        if(is_array($notafiscal_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $notafiscal_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->notafiscal_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_dispositivos_to_string = $notafiscal_dispositivos_to_string;
        }

        $this->vdata['notafiscal_dispositivos_to_string'] = $this->notafiscal_dispositivos_to_string;
    }

    public function get_notafiscal_dispositivos_to_string()
    {
        if(!empty($this->notafiscal_dispositivos_to_string))
        {
            return $this->notafiscal_dispositivos_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_tpamb_to_string($notafiscal_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_tpamb_to_string = $notafiscal_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_notafiscal_tpamb_to_string'] = $this->notafiscal_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_notafiscal_tpamb_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_mod_to_string($notafiscal_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_mod_to_string = $notafiscal_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_notafiscal_mod_to_string'] = $this->notafiscal_notafiscal_mod_to_string;
    }

    public function get_notafiscal_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_mod_to_string))
        {
            return $this->notafiscal_notafiscal_mod_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_notafiscal_modfrete_to_string($notafiscal_notafiscal_modfrete_to_string)
    {
        if(is_array($notafiscal_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $notafiscal_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_notafiscal_modfrete_to_string = $notafiscal_notafiscal_modfrete_to_string;
        }

        $this->vdata['notafiscal_notafiscal_modfrete_to_string'] = $this->notafiscal_notafiscal_modfrete_to_string;
    }

    public function get_notafiscal_notafiscal_modfrete_to_string()
    {
        if(!empty($this->notafiscal_notafiscal_modfrete_to_string))
        {
            return $this->notafiscal_notafiscal_modfrete_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_natureza_operacao_to_string($notafiscal_natureza_operacao_to_string)
    {
        if(is_array($notafiscal_natureza_operacao_to_string))
        {
            $values = NaturezaOperacao::where('id', 'in', $notafiscal_natureza_operacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_natureza_operacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_natureza_operacao_to_string = $notafiscal_natureza_operacao_to_string;
        }

        $this->vdata['notafiscal_natureza_operacao_to_string'] = $this->notafiscal_natureza_operacao_to_string;
    }

    public function get_notafiscal_natureza_operacao_to_string()
    {
        if(!empty($this->notafiscal_natureza_operacao_to_string))
        {
            return $this->notafiscal_natureza_operacao_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('natureza_operacao_id','{natureza_operacao->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_movimentacao_origem_to_string($notafiscal_movimentacao_origem_to_string)
    {
        if(is_array($notafiscal_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $notafiscal_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_movimentacao_origem_to_string = $notafiscal_movimentacao_origem_to_string;
        }

        $this->vdata['notafiscal_movimentacao_origem_to_string'] = $this->notafiscal_movimentacao_origem_to_string;
    }

    public function get_notafiscal_movimentacao_origem_to_string()
    {
        if(!empty($this->notafiscal_movimentacao_origem_to_string))
        {
            return $this->notafiscal_movimentacao_origem_to_string;
        }
    
        $values = Notafiscal::where('system_unit_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_system_unit_to_string($nota_fiscal_compra_system_unit_to_string)
    {
        if(is_array($nota_fiscal_compra_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $nota_fiscal_compra_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->nota_fiscal_compra_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_system_unit_to_string = $nota_fiscal_compra_system_unit_to_string;
        }

        $this->vdata['nota_fiscal_compra_system_unit_to_string'] = $this->nota_fiscal_compra_system_unit_to_string;
    }

    public function get_nota_fiscal_compra_system_unit_to_string()
    {
        if(!empty($this->nota_fiscal_compra_system_unit_to_string))
        {
            return $this->nota_fiscal_compra_system_unit_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_fornecedor_to_string($nota_fiscal_compra_fornecedor_to_string)
    {
        if(is_array($nota_fiscal_compra_fornecedor_to_string))
        {
            $values = Fornecedor::where('id', 'in', $nota_fiscal_compra_fornecedor_to_string)->getIndexedArray('nome', 'nome');
            $this->nota_fiscal_compra_fornecedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_fornecedor_to_string = $nota_fiscal_compra_fornecedor_to_string;
        }

        $this->vdata['nota_fiscal_compra_fornecedor_to_string'] = $this->nota_fiscal_compra_fornecedor_to_string;
    }

    public function get_nota_fiscal_compra_fornecedor_to_string()
    {
        if(!empty($this->nota_fiscal_compra_fornecedor_to_string))
        {
            return $this->nota_fiscal_compra_fornecedor_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('fornecedor_id','{fornecedor->nome}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tipodocumento_to_string($nota_fiscal_compra_notafiscal_tipodocumento_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $nota_fiscal_compra_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string = $nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tipodocumento_to_string'] = $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tipodocumento_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)
    {
        if(is_array($nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            $values = NotaFiscalCompraSituacao::where('id', 'in', $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string = $nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }

        $this->vdata['nota_fiscal_compra_nota_fiscal_compra_situacao_to_string'] = $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
    }

    public function get_nota_fiscal_compra_nota_fiscal_compra_situacao_to_string()
    {
        if(!empty($this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string))
        {
            return $this->nota_fiscal_compra_nota_fiscal_compra_situacao_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('nota_fiscal_compra_situacao_id','{nota_fiscal_compra_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_crt_to_string($nota_fiscal_compra_notafiscal_crt_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_crt_to_string))
        {
            $values = NotafiscalCrt::where('id', 'in', $nota_fiscal_compra_notafiscal_crt_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_crt_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_crt_to_string = $nota_fiscal_compra_notafiscal_crt_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_crt_to_string'] = $this->nota_fiscal_compra_notafiscal_crt_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_crt_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_crt_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_crt_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_crt_id','{notafiscal_crt->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indiedest_to_string($nota_fiscal_compra_notafiscal_indiedest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            $values = NotafiscalIndiedest::where('id', 'in', $nota_fiscal_compra_notafiscal_indiedest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indiedest_to_string = $nota_fiscal_compra_notafiscal_indiedest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indiedest_to_string'] = $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indiedest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indiedest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indiedest_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indiedest_id','{notafiscal_indiedest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscaldest_to_string($nota_fiscal_compra_notafiscaldest_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscaldest_to_string))
        {
            $values = NotafiscalIddest::where('id', 'in', $nota_fiscal_compra_notafiscaldest_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscaldest_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscaldest_to_string = $nota_fiscal_compra_notafiscaldest_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscaldest_to_string'] = $this->nota_fiscal_compra_notafiscaldest_to_string;
    }

    public function get_nota_fiscal_compra_notafiscaldest_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscaldest_to_string))
        {
            return $this->nota_fiscal_compra_notafiscaldest_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_iddest_id','{notafiscaldest->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_tpimp_to_string($nota_fiscal_compra_notafiscal_tpimp_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            $values = NotafiscalTpimp::where('id', 'in', $nota_fiscal_compra_notafiscal_tpimp_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_tpimp_to_string = $nota_fiscal_compra_notafiscal_tpimp_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_tpimp_to_string'] = $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_tpimp_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_tpimp_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_tpimp_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_tpimp_id','{notafiscal_tpimp->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_finnfe_to_string($nota_fiscal_compra_notafiscal_finnfe_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            $values = NotafiscalFinnfe::where('id', 'in', $nota_fiscal_compra_notafiscal_finnfe_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_finnfe_to_string = $nota_fiscal_compra_notafiscal_finnfe_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_finnfe_to_string'] = $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_finnfe_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_finnfe_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_finnfe_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_finnfe_id','{notafiscal_finnfe->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indfinal_to_string($nota_fiscal_compra_notafiscal_indfinal_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            $values = NotafiscalIndfinal::where('id', 'in', $nota_fiscal_compra_notafiscal_indfinal_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indfinal_to_string = $nota_fiscal_compra_notafiscal_indfinal_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indfinal_to_string'] = $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indfinal_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indfinal_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indfinal_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indfinal_id','{notafiscal_indfinal->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpres_to_string($nota_fiscal_compra_notafiscal_indpres_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            $values = NotafiscalIndpres::where('id', 'in', $nota_fiscal_compra_notafiscal_indpres_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpres_to_string = $nota_fiscal_compra_notafiscal_indpres_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpres_to_string'] = $this->nota_fiscal_compra_notafiscal_indpres_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpres_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpres_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpres_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indpres_id','{notafiscal_indpres->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_indpag_to_string($nota_fiscal_compra_notafiscal_indpag_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            $values = NotafiscalIndpag::where('id', 'in', $nota_fiscal_compra_notafiscal_indpag_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_indpag_to_string = $nota_fiscal_compra_notafiscal_indpag_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_indpag_to_string'] = $this->nota_fiscal_compra_notafiscal_indpag_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_indpag_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_indpag_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_indpag_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_indpag_id','{notafiscal_indpag->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_mod_to_string($nota_fiscal_compra_notafiscal_mod_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $nota_fiscal_compra_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_mod_to_string = $nota_fiscal_compra_notafiscal_mod_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_mod_to_string'] = $this->nota_fiscal_compra_notafiscal_mod_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_mod_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_mod_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_mod_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_nota_fiscal_compra_notafiscal_modfrete_to_string($nota_fiscal_compra_notafiscal_modfrete_to_string)
    {
        if(is_array($nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            $values = NotafiscalModfrete::where('id', 'in', $nota_fiscal_compra_notafiscal_modfrete_to_string)->getIndexedArray('descricao', 'descricao');
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = implode(', ', $values);
        }
        else
        {
            $this->nota_fiscal_compra_notafiscal_modfrete_to_string = $nota_fiscal_compra_notafiscal_modfrete_to_string;
        }

        $this->vdata['nota_fiscal_compra_notafiscal_modfrete_to_string'] = $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
    }

    public function get_nota_fiscal_compra_notafiscal_modfrete_to_string()
    {
        if(!empty($this->nota_fiscal_compra_notafiscal_modfrete_to_string))
        {
            return $this->nota_fiscal_compra_notafiscal_modfrete_to_string;
        }
    
        $values = NotaFiscalCompra::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_modfrete_id','{notafiscal_modfrete->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_system_unit_to_string($notafiscal_series_system_unit_to_string)
    {
        if(is_array($notafiscal_series_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $notafiscal_series_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->notafiscal_series_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_system_unit_to_string = $notafiscal_series_system_unit_to_string;
        }

        $this->vdata['notafiscal_series_system_unit_to_string'] = $this->notafiscal_series_system_unit_to_string;
    }

    public function get_notafiscal_series_system_unit_to_string()
    {
        if(!empty($this->notafiscal_series_system_unit_to_string))
        {
            return $this->notafiscal_series_system_unit_to_string;
        }
    
        $values = NotafiscalSeries::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_notafiscal_tpamb_to_string($notafiscal_series_notafiscal_tpamb_to_string)
    {
        if(is_array($notafiscal_series_notafiscal_tpamb_to_string))
        {
            $values = NotafiscalTpamb::where('id', 'in', $notafiscal_series_notafiscal_tpamb_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_series_notafiscal_tpamb_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_notafiscal_tpamb_to_string = $notafiscal_series_notafiscal_tpamb_to_string;
        }

        $this->vdata['notafiscal_series_notafiscal_tpamb_to_string'] = $this->notafiscal_series_notafiscal_tpamb_to_string;
    }

    public function get_notafiscal_series_notafiscal_tpamb_to_string()
    {
        if(!empty($this->notafiscal_series_notafiscal_tpamb_to_string))
        {
            return $this->notafiscal_series_notafiscal_tpamb_to_string;
        }
    
        $values = NotafiscalSeries::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_tpamb_id','{notafiscal_tpamb->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_notafiscal_mod_to_string($notafiscal_series_notafiscal_mod_to_string)
    {
        if(is_array($notafiscal_series_notafiscal_mod_to_string))
        {
            $values = NotafiscalMod::where('id', 'in', $notafiscal_series_notafiscal_mod_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_series_notafiscal_mod_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_notafiscal_mod_to_string = $notafiscal_series_notafiscal_mod_to_string;
        }

        $this->vdata['notafiscal_series_notafiscal_mod_to_string'] = $this->notafiscal_series_notafiscal_mod_to_string;
    }

    public function get_notafiscal_series_notafiscal_mod_to_string()
    {
        if(!empty($this->notafiscal_series_notafiscal_mod_to_string))
        {
            return $this->notafiscal_series_notafiscal_mod_to_string;
        }
    
        $values = NotafiscalSeries::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_mod_id','{notafiscal_mod->descricao}');
        return implode(', ', $values);
    }

    public function set_notafiscal_series_notafiscal_tipodocumento_to_string($notafiscal_series_notafiscal_tipodocumento_to_string)
    {
        if(is_array($notafiscal_series_notafiscal_tipodocumento_to_string))
        {
            $values = NotafiscalTipodocumento::where('id', 'in', $notafiscal_series_notafiscal_tipodocumento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->notafiscal_series_notafiscal_tipodocumento_to_string = implode(', ', $values);
        }
        else
        {
            $this->notafiscal_series_notafiscal_tipodocumento_to_string = $notafiscal_series_notafiscal_tipodocumento_to_string;
        }

        $this->vdata['notafiscal_series_notafiscal_tipodocumento_to_string'] = $this->notafiscal_series_notafiscal_tipodocumento_to_string;
    }

    public function get_notafiscal_series_notafiscal_tipodocumento_to_string()
    {
        if(!empty($this->notafiscal_series_notafiscal_tipodocumento_to_string))
        {
            return $this->notafiscal_series_notafiscal_tipodocumento_to_string;
        }
    
        $values = NotafiscalSeries::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_tipodocumento_id','{notafiscal_tipodocumento->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_system_unit_to_string($orcamento_system_unit_to_string)
    {
        if(is_array($orcamento_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $orcamento_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->orcamento_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_system_unit_to_string = $orcamento_system_unit_to_string;
        }

        $this->vdata['orcamento_system_unit_to_string'] = $this->orcamento_system_unit_to_string;
    }

    public function get_orcamento_system_unit_to_string()
    {
        if(!empty($this->orcamento_system_unit_to_string))
        {
            return $this->orcamento_system_unit_to_string;
        }
    
        $values = Orcamento::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_orcamento_orcamento_situacao_to_string($orcamento_orcamento_situacao_to_string)
    {
        if(is_array($orcamento_orcamento_situacao_to_string))
        {
            $values = OrcamentoSituacao::where('id', 'in', $orcamento_orcamento_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_orcamento_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_orcamento_situacao_to_string = $orcamento_orcamento_situacao_to_string;
        }

        $this->vdata['orcamento_orcamento_situacao_to_string'] = $this->orcamento_orcamento_situacao_to_string;
    }

    public function get_orcamento_orcamento_situacao_to_string()
    {
        if(!empty($this->orcamento_orcamento_situacao_to_string))
        {
            return $this->orcamento_orcamento_situacao_to_string;
        }
    
        $values = Orcamento::where('system_unit_id', '=', $this->id)->getIndexedArray('orcamento_situacao_id','{orcamento_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_orcamento_vendedor_to_string($orcamento_vendedor_to_string)
    {
        if(is_array($orcamento_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $orcamento_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_vendedor_to_string = $orcamento_vendedor_to_string;
        }

        $this->vdata['orcamento_vendedor_to_string'] = $this->orcamento_vendedor_to_string;
    }

    public function get_orcamento_vendedor_to_string()
    {
        if(!empty($this->orcamento_vendedor_to_string))
        {
            return $this->orcamento_vendedor_to_string;
        }
    
        $values = Orcamento::where('system_unit_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_to_string($orcamento_cliente_to_string)
    {
        if(is_array($orcamento_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $orcamento_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_to_string = $orcamento_cliente_to_string;
        }

        $this->vdata['orcamento_cliente_to_string'] = $this->orcamento_cliente_to_string;
    }

    public function get_orcamento_cliente_to_string()
    {
        if(!empty($this->orcamento_cliente_to_string))
        {
            return $this->orcamento_cliente_to_string;
        }
    
        $values = Orcamento::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_cliente_contato_to_string($orcamento_cliente_contato_to_string)
    {
        if(is_array($orcamento_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $orcamento_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->orcamento_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_cliente_contato_to_string = $orcamento_cliente_contato_to_string;
        }

        $this->vdata['orcamento_cliente_contato_to_string'] = $this->orcamento_cliente_contato_to_string;
    }

    public function get_orcamento_cliente_contato_to_string()
    {
        if(!empty($this->orcamento_cliente_contato_to_string))
        {
            return $this->orcamento_cliente_contato_to_string;
        }
    
        $values = Orcamento::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_orcamento_tabela_preco_to_string($orcamento_tabela_preco_to_string)
    {
        if(is_array($orcamento_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $orcamento_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->orcamento_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->orcamento_tabela_preco_to_string = $orcamento_tabela_preco_to_string;
        }

        $this->vdata['orcamento_tabela_preco_to_string'] = $this->orcamento_tabela_preco_to_string;
    }

    public function get_orcamento_tabela_preco_to_string()
    {
        if(!empty($this->orcamento_tabela_preco_to_string))
        {
            return $this->orcamento_tabela_preco_to_string;
        }
    
        $values = Orcamento::where('system_unit_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_system_unit_to_string($ordem_producao_system_unit_to_string)
    {
        if(is_array($ordem_producao_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_producao_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_producao_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_system_unit_to_string = $ordem_producao_system_unit_to_string;
        }

        $this->vdata['ordem_producao_system_unit_to_string'] = $this->ordem_producao_system_unit_to_string;
    }

    public function get_ordem_producao_system_unit_to_string()
    {
        if(!empty($this->ordem_producao_system_unit_to_string))
        {
            return $this->ordem_producao_system_unit_to_string;
        }
    
        $values = OrdemProducao::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_ordem_producao_situacao_to_string($ordem_producao_ordem_producao_situacao_to_string)
    {
        if(is_array($ordem_producao_ordem_producao_situacao_to_string))
        {
            $values = OrdemProducaoSituacao::where('id', 'in', $ordem_producao_ordem_producao_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_ordem_producao_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_ordem_producao_situacao_to_string = $ordem_producao_ordem_producao_situacao_to_string;
        }

        $this->vdata['ordem_producao_ordem_producao_situacao_to_string'] = $this->ordem_producao_ordem_producao_situacao_to_string;
    }

    public function get_ordem_producao_ordem_producao_situacao_to_string()
    {
        if(!empty($this->ordem_producao_ordem_producao_situacao_to_string))
        {
            return $this->ordem_producao_ordem_producao_situacao_to_string;
        }
    
        $values = OrdemProducao::where('system_unit_id', '=', $this->id)->getIndexedArray('ordem_producao_situacao_id','{ordem_producao_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_to_string($ordem_producao_produto_to_string)
    {
        if(is_array($ordem_producao_produto_to_string))
        {
            $values = Produto::where('id', 'in', $ordem_producao_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_producao_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_to_string = $ordem_producao_produto_to_string;
        }

        $this->vdata['ordem_producao_produto_to_string'] = $this->ordem_producao_produto_to_string;
    }

    public function get_ordem_producao_produto_to_string()
    {
        if(!empty($this->ordem_producao_produto_to_string))
        {
            return $this->ordem_producao_produto_to_string;
        }
    
        $values = OrdemProducao::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_produto_ficha_tecnica_to_string($ordem_producao_produto_ficha_tecnica_to_string)
    {
        if(is_array($ordem_producao_produto_ficha_tecnica_to_string))
        {
            $values = ProdutoFichaTecnica::where('id', 'in', $ordem_producao_produto_ficha_tecnica_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_produto_ficha_tecnica_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_produto_ficha_tecnica_to_string = $ordem_producao_produto_ficha_tecnica_to_string;
        }

        $this->vdata['ordem_producao_produto_ficha_tecnica_to_string'] = $this->ordem_producao_produto_ficha_tecnica_to_string;
    }

    public function get_ordem_producao_produto_ficha_tecnica_to_string()
    {
        if(!empty($this->ordem_producao_produto_ficha_tecnica_to_string))
        {
            return $this->ordem_producao_produto_ficha_tecnica_to_string;
        }
    
        $values = OrdemProducao::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_ficha_tecnica_id','{produto_ficha_tecnica->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_producao_estoque_deposito_to_string($ordem_producao_estoque_deposito_to_string)
    {
        if(is_array($ordem_producao_estoque_deposito_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $ordem_producao_estoque_deposito_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_producao_estoque_deposito_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_producao_estoque_deposito_to_string = $ordem_producao_estoque_deposito_to_string;
        }

        $this->vdata['ordem_producao_estoque_deposito_to_string'] = $this->ordem_producao_estoque_deposito_to_string;
    }

    public function get_ordem_producao_estoque_deposito_to_string()
    {
        if(!empty($this->ordem_producao_estoque_deposito_to_string))
        {
            return $this->ordem_producao_estoque_deposito_to_string;
        }
    
        $values = OrdemProducao::where('system_unit_id', '=', $this->id)->getIndexedArray('estoque_deposito_id','{estoque_deposito->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_system_unit_to_string($ordem_servico_system_unit_to_string)
    {
        if(is_array($ordem_servico_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $ordem_servico_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_system_unit_to_string = $ordem_servico_system_unit_to_string;
        }

        $this->vdata['ordem_servico_system_unit_to_string'] = $this->ordem_servico_system_unit_to_string;
    }

    public function get_ordem_servico_system_unit_to_string()
    {
        if(!empty($this->ordem_servico_system_unit_to_string))
        {
            return $this->ordem_servico_system_unit_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_to_string($ordem_servico_cliente_to_string)
    {
        if(is_array($ordem_servico_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $ordem_servico_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_to_string = $ordem_servico_cliente_to_string;
        }

        $this->vdata['ordem_servico_cliente_to_string'] = $this->ordem_servico_cliente_to_string;
    }

    public function get_ordem_servico_cliente_to_string()
    {
        if(!empty($this->ordem_servico_cliente_to_string))
        {
            return $this->ordem_servico_cliente_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_contato_to_string($ordem_servico_cliente_contato_to_string)
    {
        if(is_array($ordem_servico_cliente_contato_to_string))
        {
            $values = ClienteContato::where('id', 'in', $ordem_servico_cliente_contato_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_cliente_contato_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_contato_to_string = $ordem_servico_cliente_contato_to_string;
        }

        $this->vdata['ordem_servico_cliente_contato_to_string'] = $this->ordem_servico_cliente_contato_to_string;
    }

    public function get_ordem_servico_cliente_contato_to_string()
    {
        if(!empty($this->ordem_servico_cliente_contato_to_string))
        {
            return $this->ordem_servico_cliente_contato_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_contato_id','{cliente_contato->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_vendedor_to_string($ordem_servico_vendedor_to_string)
    {
        if(is_array($ordem_servico_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $ordem_servico_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->ordem_servico_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_vendedor_to_string = $ordem_servico_vendedor_to_string;
        }

        $this->vdata['ordem_servico_vendedor_to_string'] = $this->ordem_servico_vendedor_to_string;
    }

    public function get_ordem_servico_vendedor_to_string()
    {
        if(!empty($this->ordem_servico_vendedor_to_string))
        {
            return $this->ordem_servico_vendedor_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_situacao_to_string($ordem_servico_ordem_servico_situacao_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_situacao_to_string))
        {
            $values = OrdemServicoSituacao::where('id', 'in', $ordem_servico_ordem_servico_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_situacao_to_string = $ordem_servico_ordem_servico_situacao_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_situacao_to_string'] = $this->ordem_servico_ordem_servico_situacao_to_string;
    }

    public function get_ordem_servico_ordem_servico_situacao_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_situacao_to_string))
        {
            return $this->ordem_servico_ordem_servico_situacao_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('ordem_servico_situacao_id','{ordem_servico_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_ordem_servico_producao_etapa_to_string($ordem_servico_ordem_servico_producao_etapa_to_string)
    {
        if(is_array($ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            $values = OrdemServicoProducaoEtapa::where('id', 'in', $ordem_servico_ordem_servico_producao_etapa_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_ordem_servico_producao_etapa_to_string = $ordem_servico_ordem_servico_producao_etapa_to_string;
        }

        $this->vdata['ordem_servico_ordem_servico_producao_etapa_to_string'] = $this->ordem_servico_ordem_servico_producao_etapa_to_string;
    }

    public function get_ordem_servico_ordem_servico_producao_etapa_to_string()
    {
        if(!empty($this->ordem_servico_ordem_servico_producao_etapa_to_string))
        {
            return $this->ordem_servico_ordem_servico_producao_etapa_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('ordem_servico_producao_etapa_id','{ordem_servico_producao_etapa->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_condicao_pagamento_to_string($ordem_servico_condicao_pagamento_to_string)
    {
        if(is_array($ordem_servico_condicao_pagamento_to_string))
        {
            $values = CondicaoPagamento::where('id', 'in', $ordem_servico_condicao_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->ordem_servico_condicao_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_condicao_pagamento_to_string = $ordem_servico_condicao_pagamento_to_string;
        }

        $this->vdata['ordem_servico_condicao_pagamento_to_string'] = $this->ordem_servico_condicao_pagamento_to_string;
    }

    public function get_ordem_servico_condicao_pagamento_to_string()
    {
        if(!empty($this->ordem_servico_condicao_pagamento_to_string))
        {
            return $this->ordem_servico_condicao_pagamento_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('condicao_pagamento_id','{condicao_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_cliente_endereco_to_string($ordem_servico_cliente_endereco_to_string)
    {
        if(is_array($ordem_servico_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $ordem_servico_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->ordem_servico_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_cliente_endereco_to_string = $ordem_servico_cliente_endereco_to_string;
        }

        $this->vdata['ordem_servico_cliente_endereco_to_string'] = $this->ordem_servico_cliente_endereco_to_string;
    }

    public function get_ordem_servico_cliente_endereco_to_string()
    {
        if(!empty($this->ordem_servico_cliente_endereco_to_string))
        {
            return $this->ordem_servico_cliente_endereco_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_ordem_servico_usuario_aprovacao_to_string($ordem_servico_usuario_aprovacao_to_string)
    {
        if(is_array($ordem_servico_usuario_aprovacao_to_string))
        {
            $values = SystemUsers::where('id', 'in', $ordem_servico_usuario_aprovacao_to_string)->getIndexedArray('name', 'name');
            $this->ordem_servico_usuario_aprovacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->ordem_servico_usuario_aprovacao_to_string = $ordem_servico_usuario_aprovacao_to_string;
        }

        $this->vdata['ordem_servico_usuario_aprovacao_to_string'] = $this->ordem_servico_usuario_aprovacao_to_string;
    }

    public function get_ordem_servico_usuario_aprovacao_to_string()
    {
        if(!empty($this->ordem_servico_usuario_aprovacao_to_string))
        {
            return $this->ordem_servico_usuario_aprovacao_to_string;
        }
    
        $values = OrdemServico::where('system_unit_id', '=', $this->id)->getIndexedArray('usuario_aprovacao_id','{usuario_aprovacao->name}');
        return implode(', ', $values);
    }

    public function set_pedido_evento_notafiscal_to_string($pedido_evento_notafiscal_to_string)
    {
        if(is_array($pedido_evento_notafiscal_to_string))
        {
            $values = Notafiscal::where('id', 'in', $pedido_evento_notafiscal_to_string)->getIndexedArray('id', 'id');
            $this->pedido_evento_notafiscal_to_string = implode(', ', $values);
        }
        else
        {
            $this->pedido_evento_notafiscal_to_string = $pedido_evento_notafiscal_to_string;
        }

        $this->vdata['pedido_evento_notafiscal_to_string'] = $this->pedido_evento_notafiscal_to_string;
    }

    public function get_pedido_evento_notafiscal_to_string()
    {
        if(!empty($this->pedido_evento_notafiscal_to_string))
        {
            return $this->pedido_evento_notafiscal_to_string;
        }
    
        $values = PedidoEvento::where('system_unit_id', '=', $this->id)->getIndexedArray('notafiscal_id','{notafiscal->id}');
        return implode(', ', $values);
    }

    public function set_pedido_evento_system_unit_to_string($pedido_evento_system_unit_to_string)
    {
        if(is_array($pedido_evento_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $pedido_evento_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->pedido_evento_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->pedido_evento_system_unit_to_string = $pedido_evento_system_unit_to_string;
        }

        $this->vdata['pedido_evento_system_unit_to_string'] = $this->pedido_evento_system_unit_to_string;
    }

    public function get_pedido_evento_system_unit_to_string()
    {
        if(!empty($this->pedido_evento_system_unit_to_string))
        {
            return $this->pedido_evento_system_unit_to_string;
        }
    
        $values = PedidoEvento::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_pedido_evento_system_users_to_string($pedido_evento_system_users_to_string)
    {
        if(is_array($pedido_evento_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $pedido_evento_system_users_to_string)->getIndexedArray('name', 'name');
            $this->pedido_evento_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->pedido_evento_system_users_to_string = $pedido_evento_system_users_to_string;
        }

        $this->vdata['pedido_evento_system_users_to_string'] = $this->pedido_evento_system_users_to_string;
    }

    public function get_pedido_evento_system_users_to_string()
    {
        if(!empty($this->pedido_evento_system_users_to_string))
        {
            return $this->pedido_evento_system_users_to_string;
        }
    
        $values = PedidoEvento::where('system_unit_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_plano_conta_system_unit_to_string($plano_conta_system_unit_to_string)
    {
        if(is_array($plano_conta_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $plano_conta_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->plano_conta_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->plano_conta_system_unit_to_string = $plano_conta_system_unit_to_string;
        }

        $this->vdata['plano_conta_system_unit_to_string'] = $this->plano_conta_system_unit_to_string;
    }

    public function get_plano_conta_system_unit_to_string()
    {
        if(!empty($this->plano_conta_system_unit_to_string))
        {
            return $this->plano_conta_system_unit_to_string;
        }
    
        $values = PlanoConta::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_plano_conta_plano_conta_tipo_to_string($plano_conta_plano_conta_tipo_to_string)
    {
        if(is_array($plano_conta_plano_conta_tipo_to_string))
        {
            $values = PlanoContaTipo::where('id', 'in', $plano_conta_plano_conta_tipo_to_string)->getIndexedArray('descricao', 'descricao');
            $this->plano_conta_plano_conta_tipo_to_string = implode(', ', $values);
        }
        else
        {
            $this->plano_conta_plano_conta_tipo_to_string = $plano_conta_plano_conta_tipo_to_string;
        }

        $this->vdata['plano_conta_plano_conta_tipo_to_string'] = $this->plano_conta_plano_conta_tipo_to_string;
    }

    public function get_plano_conta_plano_conta_tipo_to_string()
    {
        if(!empty($this->plano_conta_plano_conta_tipo_to_string))
        {
            return $this->plano_conta_plano_conta_tipo_to_string;
        }
    
        $values = PlanoConta::where('system_unit_id', '=', $this->id)->getIndexedArray('plano_conta_tipo_id','{plano_conta_tipo->descricao}');
        return implode(', ', $values);
    }

    public function set_plano_conta_plano_conta_origem_to_string($plano_conta_plano_conta_origem_to_string)
    {
        if(is_array($plano_conta_plano_conta_origem_to_string))
        {
            $values = PlanoContaOrigem::where('id', 'in', $plano_conta_plano_conta_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->plano_conta_plano_conta_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->plano_conta_plano_conta_origem_to_string = $plano_conta_plano_conta_origem_to_string;
        }

        $this->vdata['plano_conta_plano_conta_origem_to_string'] = $this->plano_conta_plano_conta_origem_to_string;
    }

    public function get_plano_conta_plano_conta_origem_to_string()
    {
        if(!empty($this->plano_conta_plano_conta_origem_to_string))
        {
            return $this->plano_conta_plano_conta_origem_to_string;
        }
    
        $values = PlanoConta::where('system_unit_id', '=', $this->id)->getIndexedArray('plano_conta_origem_id','{plano_conta_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_system_unit_to_string($produto_ficha_tecnica_system_unit_to_string)
    {
        if(is_array($produto_ficha_tecnica_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $produto_ficha_tecnica_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->produto_ficha_tecnica_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_system_unit_to_string = $produto_ficha_tecnica_system_unit_to_string;
        }

        $this->vdata['produto_ficha_tecnica_system_unit_to_string'] = $this->produto_ficha_tecnica_system_unit_to_string;
    }

    public function get_produto_ficha_tecnica_system_unit_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_system_unit_to_string))
        {
            return $this->produto_ficha_tecnica_system_unit_to_string;
        }
    
        $values = ProdutoFichaTecnica::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_produto_ficha_tecnica_produto_to_string($produto_ficha_tecnica_produto_to_string)
    {
        if(is_array($produto_ficha_tecnica_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_ficha_tecnica_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_ficha_tecnica_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_ficha_tecnica_produto_to_string = $produto_ficha_tecnica_produto_to_string;
        }

        $this->vdata['produto_ficha_tecnica_produto_to_string'] = $this->produto_ficha_tecnica_produto_to_string;
    }

    public function get_produto_ficha_tecnica_produto_to_string()
    {
        if(!empty($this->produto_ficha_tecnica_produto_to_string))
        {
            return $this->produto_ficha_tecnica_produto_to_string;
        }
    
        $values = ProdutoFichaTecnica::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_filial_produto_to_string($produto_filial_produto_to_string)
    {
        if(is_array($produto_filial_produto_to_string))
        {
            $values = Produto::where('id', 'in', $produto_filial_produto_to_string)->getIndexedArray('nome', 'nome');
            $this->produto_filial_produto_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_produto_to_string = $produto_filial_produto_to_string;
        }

        $this->vdata['produto_filial_produto_to_string'] = $this->produto_filial_produto_to_string;
    }

    public function get_produto_filial_produto_to_string()
    {
        if(!empty($this->produto_filial_produto_to_string))
        {
            return $this->produto_filial_produto_to_string;
        }
    
        $values = ProdutoFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('produto_id','{produto->nome}');
        return implode(', ', $values);
    }

    public function set_produto_filial_system_unit_to_string($produto_filial_system_unit_to_string)
    {
        if(is_array($produto_filial_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $produto_filial_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->produto_filial_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_system_unit_to_string = $produto_filial_system_unit_to_string;
        }

        $this->vdata['produto_filial_system_unit_to_string'] = $this->produto_filial_system_unit_to_string;
    }

    public function get_produto_filial_system_unit_to_string()
    {
        if(!empty($this->produto_filial_system_unit_to_string))
        {
            return $this->produto_filial_system_unit_to_string;
        }
    
        $values = ProdutoFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_produto_filial_estoque_deposito_padrao_to_string($produto_filial_estoque_deposito_padrao_to_string)
    {
        if(is_array($produto_filial_estoque_deposito_padrao_to_string))
        {
            $values = EstoqueDeposito::where('id', 'in', $produto_filial_estoque_deposito_padrao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_estoque_deposito_padrao_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_estoque_deposito_padrao_to_string = $produto_filial_estoque_deposito_padrao_to_string;
        }

        $this->vdata['produto_filial_estoque_deposito_padrao_to_string'] = $this->produto_filial_estoque_deposito_padrao_to_string;
    }

    public function get_produto_filial_estoque_deposito_padrao_to_string()
    {
        if(!empty($this->produto_filial_estoque_deposito_padrao_to_string))
        {
            return $this->produto_filial_estoque_deposito_padrao_to_string;
        }
    
        $values = ProdutoFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('estoque_deposito_padrao_id','{estoque_deposito_padrao->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_sob_encomenda_to_string($produto_filial_sob_encomenda_to_string)
    {
        if(is_array($produto_filial_sob_encomenda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_sob_encomenda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_sob_encomenda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_sob_encomenda_to_string = $produto_filial_sob_encomenda_to_string;
        }

        $this->vdata['produto_filial_sob_encomenda_to_string'] = $this->produto_filial_sob_encomenda_to_string;
    }

    public function get_produto_filial_sob_encomenda_to_string()
    {
        if(!empty($this->produto_filial_sob_encomenda_to_string))
        {
            return $this->produto_filial_sob_encomenda_to_string;
        }
    
        $values = ProdutoFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('sob_encomenda_id','{sob_encomenda->descricao}');
        return implode(', ', $values);
    }

    public function set_produto_filial_gerar_op_venda_to_string($produto_filial_gerar_op_venda_to_string)
    {
        if(is_array($produto_filial_gerar_op_venda_to_string))
        {
            $values = Resposta::where('id', 'in', $produto_filial_gerar_op_venda_to_string)->getIndexedArray('descricao', 'descricao');
            $this->produto_filial_gerar_op_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->produto_filial_gerar_op_venda_to_string = $produto_filial_gerar_op_venda_to_string;
        }

        $this->vdata['produto_filial_gerar_op_venda_to_string'] = $this->produto_filial_gerar_op_venda_to_string;
    }

    public function get_produto_filial_gerar_op_venda_to_string()
    {
        if(!empty($this->produto_filial_gerar_op_venda_to_string))
        {
            return $this->produto_filial_gerar_op_venda_to_string;
        }
    
        $values = ProdutoFilial::where('system_unit_id', '=', $this->id)->getIndexedArray('gerar_op_venda_id','{gerar_op_venda->descricao}');
        return implode(', ', $values);
    }

    public function set_system_group_program_permissoes_system_unit_to_string($system_group_program_permissoes_system_unit_to_string)
    {
        if(is_array($system_group_program_permissoes_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $system_group_program_permissoes_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->system_group_program_permissoes_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_unit_to_string = $system_group_program_permissoes_system_unit_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_unit_to_string'] = $this->system_group_program_permissoes_system_unit_to_string;
    }

    public function get_system_group_program_permissoes_system_unit_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_unit_to_string))
        {
            return $this->system_group_program_permissoes_system_unit_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_system_group_program_permissoes_system_program_permissoes_to_string($system_group_program_permissoes_system_program_permissoes_to_string)
    {
        if(is_array($system_group_program_permissoes_system_program_permissoes_to_string))
        {
            $values = SystemProgramPermissoes::where('id', 'in', $system_group_program_permissoes_system_program_permissoes_to_string)->getIndexedArray('id', 'id');
            $this->system_group_program_permissoes_system_program_permissoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_program_permissoes_to_string = $system_group_program_permissoes_system_program_permissoes_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_program_permissoes_to_string'] = $this->system_group_program_permissoes_system_program_permissoes_to_string;
    }

    public function get_system_group_program_permissoes_system_program_permissoes_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_program_permissoes_to_string))
        {
            return $this->system_group_program_permissoes_system_program_permissoes_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_unit_id', '=', $this->id)->getIndexedArray('system_program_permissoes_id','{system_program_permissoes->id}');
        return implode(', ', $values);
    }

    public function set_system_group_program_permissoes_system_group_to_string($system_group_program_permissoes_system_group_to_string)
    {
        if(is_array($system_group_program_permissoes_system_group_to_string))
        {
            $values = SystemGroup::where('id', 'in', $system_group_program_permissoes_system_group_to_string)->getIndexedArray('name', 'name');
            $this->system_group_program_permissoes_system_group_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_group_program_permissoes_system_group_to_string = $system_group_program_permissoes_system_group_to_string;
        }

        $this->vdata['system_group_program_permissoes_system_group_to_string'] = $this->system_group_program_permissoes_system_group_to_string;
    }

    public function get_system_group_program_permissoes_system_group_to_string()
    {
        if(!empty($this->system_group_program_permissoes_system_group_to_string))
        {
            return $this->system_group_program_permissoes_system_group_to_string;
        }
    
        $values = SystemGroupProgramPermissoes::where('system_unit_id', '=', $this->id)->getIndexedArray('system_group_id','{system_group->name}');
        return implode(', ', $values);
    }

    public function set_system_user_program_permissoes_system_unit_to_string($system_user_program_permissoes_system_unit_to_string)
    {
        if(is_array($system_user_program_permissoes_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $system_user_program_permissoes_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->system_user_program_permissoes_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_user_program_permissoes_system_unit_to_string = $system_user_program_permissoes_system_unit_to_string;
        }

        $this->vdata['system_user_program_permissoes_system_unit_to_string'] = $this->system_user_program_permissoes_system_unit_to_string;
    }

    public function get_system_user_program_permissoes_system_unit_to_string()
    {
        if(!empty($this->system_user_program_permissoes_system_unit_to_string))
        {
            return $this->system_user_program_permissoes_system_unit_to_string;
        }
    
        $values = SystemUserProgramPermissoes::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_system_user_program_permissoes_system_users_to_string($system_user_program_permissoes_system_users_to_string)
    {
        if(is_array($system_user_program_permissoes_system_users_to_string))
        {
            $values = SystemUsers::where('id', 'in', $system_user_program_permissoes_system_users_to_string)->getIndexedArray('name', 'name');
            $this->system_user_program_permissoes_system_users_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_user_program_permissoes_system_users_to_string = $system_user_program_permissoes_system_users_to_string;
        }

        $this->vdata['system_user_program_permissoes_system_users_to_string'] = $this->system_user_program_permissoes_system_users_to_string;
    }

    public function get_system_user_program_permissoes_system_users_to_string()
    {
        if(!empty($this->system_user_program_permissoes_system_users_to_string))
        {
            return $this->system_user_program_permissoes_system_users_to_string;
        }
    
        $values = SystemUserProgramPermissoes::where('system_unit_id', '=', $this->id)->getIndexedArray('system_users_id','{system_users->name}');
        return implode(', ', $values);
    }

    public function set_system_user_program_permissoes_system_program_permissoes_to_string($system_user_program_permissoes_system_program_permissoes_to_string)
    {
        if(is_array($system_user_program_permissoes_system_program_permissoes_to_string))
        {
            $values = SystemProgramPermissoes::where('id', 'in', $system_user_program_permissoes_system_program_permissoes_to_string)->getIndexedArray('id', 'id');
            $this->system_user_program_permissoes_system_program_permissoes_to_string = implode(', ', $values);
        }
        else
        {
            $this->system_user_program_permissoes_system_program_permissoes_to_string = $system_user_program_permissoes_system_program_permissoes_to_string;
        }

        $this->vdata['system_user_program_permissoes_system_program_permissoes_to_string'] = $this->system_user_program_permissoes_system_program_permissoes_to_string;
    }

    public function get_system_user_program_permissoes_system_program_permissoes_to_string()
    {
        if(!empty($this->system_user_program_permissoes_system_program_permissoes_to_string))
        {
            return $this->system_user_program_permissoes_system_program_permissoes_to_string;
        }
    
        $values = SystemUserProgramPermissoes::where('system_unit_id', '=', $this->id)->getIndexedArray('system_program_permissoes_id','{system_program_permissoes->id}');
        return implode(', ', $values);
    }

    public function set_venda_venda_situacao_to_string($venda_venda_situacao_to_string)
    {
        if(is_array($venda_venda_situacao_to_string))
        {
            $values = VendaSituacao::where('id', 'in', $venda_venda_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_situacao_to_string = $venda_venda_situacao_to_string;
        }

        $this->vdata['venda_venda_situacao_to_string'] = $this->venda_venda_situacao_to_string;
    }

    public function get_venda_venda_situacao_to_string()
    {
        if(!empty($this->venda_venda_situacao_to_string))
        {
            return $this->venda_venda_situacao_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('venda_situacao_id','{venda_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_orcamento_to_string($venda_orcamento_to_string)
    {
        if(is_array($venda_orcamento_to_string))
        {
            $values = Orcamento::where('id', 'in', $venda_orcamento_to_string)->getIndexedArray('id', 'id');
            $this->venda_orcamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_orcamento_to_string = $venda_orcamento_to_string;
        }

        $this->vdata['venda_orcamento_to_string'] = $this->venda_orcamento_to_string;
    }

    public function get_venda_orcamento_to_string()
    {
        if(!empty($this->venda_orcamento_to_string))
        {
            return $this->venda_orcamento_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('orcamento_id','{orcamento->id}');
        return implode(', ', $values);
    }

    public function set_venda_vendedor_to_string($venda_vendedor_to_string)
    {
        if(is_array($venda_vendedor_to_string))
        {
            $values = Vendedor::where('id', 'in', $venda_vendedor_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_vendedor_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_vendedor_to_string = $venda_vendedor_to_string;
        }

        $this->vdata['venda_vendedor_to_string'] = $this->venda_vendedor_to_string;
    }

    public function get_venda_vendedor_to_string()
    {
        if(!empty($this->venda_vendedor_to_string))
        {
            return $this->venda_vendedor_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('vendedor_id','{vendedor->nome}');
        return implode(', ', $values);
    }

    public function set_venda_dispositivos_to_string($venda_dispositivos_to_string)
    {
        if(is_array($venda_dispositivos_to_string))
        {
            $values = Dispositivos::where('id', 'in', $venda_dispositivos_to_string)->getIndexedArray('id', 'id');
            $this->venda_dispositivos_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_dispositivos_to_string = $venda_dispositivos_to_string;
        }

        $this->vdata['venda_dispositivos_to_string'] = $this->venda_dispositivos_to_string;
    }

    public function get_venda_dispositivos_to_string()
    {
        if(!empty($this->venda_dispositivos_to_string))
        {
            return $this->venda_dispositivos_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('dispositivos_id','{dispositivos->id}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_to_string($venda_cliente_to_string)
    {
        if(is_array($venda_cliente_to_string))
        {
            $values = Cliente::where('id', 'in', $venda_cliente_to_string)->getIndexedArray('nome', 'nome');
            $this->venda_cliente_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_to_string = $venda_cliente_to_string;
        }

        $this->vdata['venda_cliente_to_string'] = $this->venda_cliente_to_string;
    }

    public function get_venda_cliente_to_string()
    {
        if(!empty($this->venda_cliente_to_string))
        {
            return $this->venda_cliente_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('cliente_id','{cliente->nome}');
        return implode(', ', $values);
    }

    public function set_venda_system_unit_to_string($venda_system_unit_to_string)
    {
        if(is_array($venda_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_system_unit_to_string = $venda_system_unit_to_string;
        }

        $this->vdata['venda_system_unit_to_string'] = $this->venda_system_unit_to_string;
    }

    public function get_venda_system_unit_to_string()
    {
        if(!empty($this->venda_system_unit_to_string))
        {
            return $this->venda_system_unit_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_filial_saida_to_string($venda_filial_saida_to_string)
    {
        if(is_array($venda_filial_saida_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_filial_saida_to_string)->getIndexedArray('name', 'name');
            $this->venda_filial_saida_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_filial_saida_to_string = $venda_filial_saida_to_string;
        }

        $this->vdata['venda_filial_saida_to_string'] = $this->venda_filial_saida_to_string;
    }

    public function get_venda_filial_saida_to_string()
    {
        if(!empty($this->venda_filial_saida_to_string))
        {
            return $this->venda_filial_saida_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('filial_saida_id','{filial_saida->name}');
        return implode(', ', $values);
    }

    public function set_venda_venda_modalidade_to_string($venda_venda_modalidade_to_string)
    {
        if(is_array($venda_venda_modalidade_to_string))
        {
            $values = VendaModalidade::where('id', 'in', $venda_venda_modalidade_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_modalidade_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_modalidade_to_string = $venda_venda_modalidade_to_string;
        }

        $this->vdata['venda_venda_modalidade_to_string'] = $this->venda_venda_modalidade_to_string;
    }

    public function get_venda_venda_modalidade_to_string()
    {
        if(!empty($this->venda_venda_modalidade_to_string))
        {
            return $this->venda_venda_modalidade_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('venda_modalidade_id','{venda_modalidade->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_venda_tipo_pagamento_to_string($venda_venda_tipo_pagamento_to_string)
    {
        if(is_array($venda_venda_tipo_pagamento_to_string))
        {
            $values = VendaTipoPagamento::where('id', 'in', $venda_venda_tipo_pagamento_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_venda_tipo_pagamento_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_venda_tipo_pagamento_to_string = $venda_venda_tipo_pagamento_to_string;
        }

        $this->vdata['venda_venda_tipo_pagamento_to_string'] = $this->venda_venda_tipo_pagamento_to_string;
    }

    public function get_venda_venda_tipo_pagamento_to_string()
    {
        if(!empty($this->venda_venda_tipo_pagamento_to_string))
        {
            return $this->venda_venda_tipo_pagamento_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('venda_tipo_pagamento_id','{venda_tipo_pagamento->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_cliente_endereco_to_string($venda_cliente_endereco_to_string)
    {
        if(is_array($venda_cliente_endereco_to_string))
        {
            $values = ClienteEndereco::where('id', 'in', $venda_cliente_endereco_to_string)->getIndexedArray('logradouro', 'logradouro');
            $this->venda_cliente_endereco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_cliente_endereco_to_string = $venda_cliente_endereco_to_string;
        }

        $this->vdata['venda_cliente_endereco_to_string'] = $this->venda_cliente_endereco_to_string;
    }

    public function get_venda_cliente_endereco_to_string()
    {
        if(!empty($this->venda_cliente_endereco_to_string))
        {
            return $this->venda_cliente_endereco_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('cliente_endereco_id','{cliente_endereco->logradouro}');
        return implode(', ', $values);
    }

    public function set_venda_tabela_preco_to_string($venda_tabela_preco_to_string)
    {
        if(is_array($venda_tabela_preco_to_string))
        {
            $values = TabelaPreco::where('id', 'in', $venda_tabela_preco_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_tabela_preco_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_tabela_preco_to_string = $venda_tabela_preco_to_string;
        }

        $this->vdata['venda_tabela_preco_to_string'] = $this->venda_tabela_preco_to_string;
    }

    public function get_venda_tabela_preco_to_string()
    {
        if(!empty($this->venda_tabela_preco_to_string))
        {
            return $this->venda_tabela_preco_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('tabela_preco_id','{tabela_preco->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_movimentacao_origem_to_string($venda_movimentacao_origem_to_string)
    {
        if(is_array($venda_movimentacao_origem_to_string))
        {
            $values = MovimentacaoOrigem::where('id', 'in', $venda_movimentacao_origem_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_movimentacao_origem_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_movimentacao_origem_to_string = $venda_movimentacao_origem_to_string;
        }

        $this->vdata['venda_movimentacao_origem_to_string'] = $this->venda_movimentacao_origem_to_string;
    }

    public function get_venda_movimentacao_origem_to_string()
    {
        if(!empty($this->venda_movimentacao_origem_to_string))
        {
            return $this->venda_movimentacao_origem_to_string;
        }
    
        $values = Venda::where('filial_saida_id', '=', $this->id)->getIndexedArray('movimentacao_origem_id','{movimentacao_origem->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_system_unit_to_string($venda_devolucao_system_unit_to_string)
    {
        if(is_array($venda_devolucao_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_devolucao_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_devolucao_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_system_unit_to_string = $venda_devolucao_system_unit_to_string;
        }

        $this->vdata['venda_devolucao_system_unit_to_string'] = $this->venda_devolucao_system_unit_to_string;
    }

    public function get_venda_devolucao_system_unit_to_string()
    {
        if(!empty($this->venda_devolucao_system_unit_to_string))
        {
            return $this->venda_devolucao_system_unit_to_string;
        }
    
        $values = VendaDevolucao::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_venda_devolucao_venda_to_string($venda_devolucao_venda_to_string)
    {
        if(is_array($venda_devolucao_venda_to_string))
        {
            $values = Venda::where('id', 'in', $venda_devolucao_venda_to_string)->getIndexedArray('id', 'id');
            $this->venda_devolucao_venda_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_devolucao_venda_to_string = $venda_devolucao_venda_to_string;
        }

        $this->vdata['venda_devolucao_venda_to_string'] = $this->venda_devolucao_venda_to_string;
    }

    public function get_venda_devolucao_venda_to_string()
    {
        if(!empty($this->venda_devolucao_venda_to_string))
        {
            return $this->venda_devolucao_venda_to_string;
        }
    
        $values = VendaDevolucao::where('system_unit_id', '=', $this->id)->getIndexedArray('venda_id','{venda->id}');
        return implode(', ', $values);
    }

    public function set_venda_meta_venda_meta_situacao_to_string($venda_meta_venda_meta_situacao_to_string)
    {
        if(is_array($venda_meta_venda_meta_situacao_to_string))
        {
            $values = VendaMetaSituacao::where('id', 'in', $venda_meta_venda_meta_situacao_to_string)->getIndexedArray('descricao', 'descricao');
            $this->venda_meta_venda_meta_situacao_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_venda_meta_situacao_to_string = $venda_meta_venda_meta_situacao_to_string;
        }

        $this->vdata['venda_meta_venda_meta_situacao_to_string'] = $this->venda_meta_venda_meta_situacao_to_string;
    }

    public function get_venda_meta_venda_meta_situacao_to_string()
    {
        if(!empty($this->venda_meta_venda_meta_situacao_to_string))
        {
            return $this->venda_meta_venda_meta_situacao_to_string;
        }
    
        $values = VendaMeta::where('system_unit_id', '=', $this->id)->getIndexedArray('venda_meta_situacao_id','{venda_meta_situacao->descricao}');
        return implode(', ', $values);
    }

    public function set_venda_meta_system_unit_to_string($venda_meta_system_unit_to_string)
    {
        if(is_array($venda_meta_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $venda_meta_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->venda_meta_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->venda_meta_system_unit_to_string = $venda_meta_system_unit_to_string;
        }

        $this->vdata['venda_meta_system_unit_to_string'] = $this->venda_meta_system_unit_to_string;
    }

    public function get_venda_meta_system_unit_to_string()
    {
        if(!empty($this->venda_meta_system_unit_to_string))
        {
            return $this->venda_meta_system_unit_to_string;
        }
    
        $values = VendaMeta::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    public function set_xml_contador_system_user_to_string($xml_contador_system_user_to_string)
    {
        if(is_array($xml_contador_system_user_to_string))
        {
            $values = SystemUsers::where('id', 'in', $xml_contador_system_user_to_string)->getIndexedArray('name', 'name');
            $this->xml_contador_system_user_to_string = implode(', ', $values);
        }
        else
        {
            $this->xml_contador_system_user_to_string = $xml_contador_system_user_to_string;
        }

        $this->vdata['xml_contador_system_user_to_string'] = $this->xml_contador_system_user_to_string;
    }

    public function get_xml_contador_system_user_to_string()
    {
        if(!empty($this->xml_contador_system_user_to_string))
        {
            return $this->xml_contador_system_user_to_string;
        }
    
        $values = XmlContador::where('system_unit_id', '=', $this->id)->getIndexedArray('system_user_id','{system_user->name}');
        return implode(', ', $values);
    }

    public function set_xml_contador_system_unit_to_string($xml_contador_system_unit_to_string)
    {
        if(is_array($xml_contador_system_unit_to_string))
        {
            $values = SystemUnit::where('id', 'in', $xml_contador_system_unit_to_string)->getIndexedArray('name', 'name');
            $this->xml_contador_system_unit_to_string = implode(', ', $values);
        }
        else
        {
            $this->xml_contador_system_unit_to_string = $xml_contador_system_unit_to_string;
        }

        $this->vdata['xml_contador_system_unit_to_string'] = $this->xml_contador_system_unit_to_string;
    }

    public function get_xml_contador_system_unit_to_string()
    {
        if(!empty($this->xml_contador_system_unit_to_string))
        {
            return $this->xml_contador_system_unit_to_string;
        }
    
        $values = XmlContador::where('system_unit_id', '=', $this->id)->getIndexedArray('system_unit_id','{system_unit->name}');
        return implode(', ', $values);
    }

    
}

