-- --------------------------------------------------------
-- Servidor:                     127.0.0.1
-- Versão do servidor:           8.0.30 - MySQL Community Server - GPL
-- OS do Servidor:               Win64
-- HeidiSQL Versão:              12.1.0.6537
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- Copiando estrutura do banco de dados para erp_nuvem
DROP DATABASE IF EXISTS `erp_nuvem`;
CREATE DATABASE IF NOT EXISTS `erp_nuvem` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;
USE `erp_nuvem`;

-- Copiando estrutura para tabela erp_nuvem.apidocumentos_integradoresservicos
DROP TABLE IF EXISTS `apidocumentos_integradoresservicos`;
CREATE TABLE IF NOT EXISTS `apidocumentos_integradoresservicos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `api_documentos_id` int NOT NULL,
  `integradores_servicos_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_apidocumentos_integradoresservicos_1` (`api_documentos_id`),
  KEY `fk_apidocumentos_integradoresservicos_2` (`integradores_servicos_id`),
  CONSTRAINT `fk_apidocumentos_integradoresservicos_1` FOREIGN KEY (`api_documentos_id`) REFERENCES `api_documentos` (`id`),
  CONSTRAINT `fk_apidocumentos_integradoresservicos_2` FOREIGN KEY (`integradores_servicos_id`) REFERENCES `integradores_servicos` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.apidocumentos_integradoresservicos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.api_documentos
DROP TABLE IF EXISTS `api_documentos`;
CREATE TABLE IF NOT EXISTS `api_documentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `integradores_id` int NOT NULL,
  `system_unit_id` int DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `token_api` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_api_documentos_1` (`integradores_id`),
  KEY `fk_api_documentos_2` (`system_unit_id`),
  CONSTRAINT `fk_api_documentos_1` FOREIGN KEY (`integradores_id`) REFERENCES `integradores` (`id`),
  CONSTRAINT `fk_api_documentos_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.api_documentos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.api_error
DROP TABLE IF EXISTS `api_error`;
CREATE TABLE IF NOT EXISTS `api_error` (
  `id` int NOT NULL AUTO_INCREMENT,
  `classe` text COLLATE utf8mb3_unicode_ci,
  `metodo` text COLLATE utf8mb3_unicode_ci,
  `url` text COLLATE utf8mb3_unicode_ci,
  `dados` text COLLATE utf8mb3_unicode_ci,
  `error_message` text COLLATE utf8mb3_unicode_ci,
  `inserted_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.api_error: ~2 rows (aproximadamente)
INSERT INTO `api_error` (`id`, `classe`, `metodo`, `url`, `dados`, `error_message`, `inserted_at`) VALUES
	(1, NULL, NULL, '/cep/api/v1/68473000', NULL, NULL, NULL),
	(4, NULL, NULL, '/cep/api/v1/39390000', NULL, NULL, NULL),
	(5, NULL, NULL, '/cep/api/v1/78250000', NULL, NULL, NULL),
	(6, NULL, NULL, '/cep/api/v1/78250000', NULL, NULL, NULL),
	(7, NULL, NULL, '/cep/api/v1/78250000', NULL, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.ativo
DROP TABLE IF EXISTS `ativo`;
CREATE TABLE IF NOT EXISTS `ativo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ativo: ~2 rows (aproximadamente)
INSERT INTO `ativo` (`id`, `descricao`) VALUES
	(1, 'Ativo'),
	(2, 'Inativo');

-- Copiando estrutura para tabela erp_nuvem.banco
DROP TABLE IF EXISTS `banco`;
CREATE TABLE IF NOT EXISTS `banco` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.banco: ~0 rows (aproximadamente)
INSERT INTO `banco` (`id`, `nome`, `numero`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'BANCO DO BRASIL', '001', '2024-06-03 23:30:34', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.boleto_situacao
DROP TABLE IF EXISTS `boleto_situacao`;
CREATE TABLE IF NOT EXISTS `boleto_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.boleto_situacao: ~4 rows (aproximadamente)
INSERT INTO `boleto_situacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Não Enviado', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Enviado', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Rejeitado', NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'Pendente de Baixa no Banco', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.caixa
DROP TABLE IF EXISTS `caixa`;
CREATE TABLE IF NOT EXISTS `caixa` (
  `id` int NOT NULL AUTO_INCREMENT,
  `caixa_situacao_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `system_users_abertura_id` int NOT NULL,
  `system_users_operador_id` int NOT NULL,
  `system_users_fechamento_id` int DEFAULT NULL,
  `data_hora_abertura` datetime DEFAULT NULL,
  `data_hora_fechamento` datetime DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_caixa_2` (`caixa_situacao_id`),
  KEY `fk_caixa_3` (`system_users_abertura_id`),
  KEY `fk_caixa_4` (`system_users_operador_id`),
  KEY `fk_caixa_5` (`system_users_fechamento_id`),
  KEY `fk_caixa_6` (`system_unit_id`),
  CONSTRAINT `fk_caixa_2` FOREIGN KEY (`caixa_situacao_id`) REFERENCES `caixa_situacao` (`id`),
  CONSTRAINT `fk_caixa_3` FOREIGN KEY (`system_users_abertura_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_caixa_4` FOREIGN KEY (`system_users_operador_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_caixa_5` FOREIGN KEY (`system_users_fechamento_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_caixa_6` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.caixa: ~0 rows (aproximadamente)
INSERT INTO `caixa` (`id`, `caixa_situacao_id`, `system_unit_id`, `system_users_abertura_id`, `system_users_operador_id`, `system_users_fechamento_id`, `data_hora_abertura`, `data_hora_fechamento`, `criado_em`, `alterado_em`) VALUES
	(1, 1, 1, 1, 1, NULL, '2024-04-03 20:53:10', NULL, '2024-04-03 20:53:10', NULL);

-- Copiando estrutura para tabela erp_nuvem.caixa_lancamentos
DROP TABLE IF EXISTS `caixa_lancamentos`;
CREATE TABLE IF NOT EXISTS `caixa_lancamentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `caixa_id` int NOT NULL,
  `forma_pagamento_id` int NOT NULL,
  `caixa_tipo_lancamento_id` int NOT NULL,
  `valor` double NOT NULL,
  `data_hora_lancamento` datetime NOT NULL,
  `system_users_id` int NOT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `id_origem` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_caixa_lancamentos_1` (`caixa_id`),
  KEY `fk_caixa_lancamentos_2` (`forma_pagamento_id`),
  KEY `fk_caixa_lancamentos_3` (`caixa_tipo_lancamento_id`),
  KEY `fk_caixa_lancamentos_4` (`system_users_id`),
  CONSTRAINT `fk_caixa_lancamentos_1` FOREIGN KEY (`caixa_id`) REFERENCES `caixa` (`id`),
  CONSTRAINT `fk_caixa_lancamentos_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`),
  CONSTRAINT `fk_caixa_lancamentos_3` FOREIGN KEY (`caixa_tipo_lancamento_id`) REFERENCES `caixa_tipo_lancamento` (`id`),
  CONSTRAINT `fk_caixa_lancamentos_4` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.caixa_lancamentos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.caixa_situacao
DROP TABLE IF EXISTS `caixa_situacao`;
CREATE TABLE IF NOT EXISTS `caixa_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.caixa_situacao: ~2 rows (aproximadamente)
INSERT INTO `caixa_situacao` (`id`, `descricao`, `criado_em`, `alterado_em`) VALUES
	(1, 'Aberto', NULL, NULL),
	(2, 'Fechado', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.caixa_tipo_lancamento
DROP TABLE IF EXISTS `caixa_tipo_lancamento`;
CREATE TABLE IF NOT EXISTS `caixa_tipo_lancamento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.caixa_tipo_lancamento: ~3 rows (aproximadamente)
INSERT INTO `caixa_tipo_lancamento` (`id`, `descricao`, `criado_em`, `alterado_em`) VALUES
	(1, 'Débito', NULL, NULL),
	(2, 'Crédito', NULL, NULL),
	(3, 'Fundo de Caixa', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.centro_custo
DROP TABLE IF EXISTS `centro_custo`;
CREATE TABLE IF NOT EXISTS `centro_custo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `centro_custo_tipo_id` int NOT NULL,
  `centro_custo_pai_id` int DEFAULT NULL,
  `numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_centro_custo_1` (`centro_custo_tipo_id`),
  KEY `fk_centro_custo_2` (`system_unit_id`),
  CONSTRAINT `fk_centro_custo_1` FOREIGN KEY (`centro_custo_tipo_id`) REFERENCES `centro_custo_tipo` (`id`),
  CONSTRAINT `fk_centro_custo_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.centro_custo: ~4 rows (aproximadamente)
INSERT INTO `centro_custo` (`id`, `system_unit_id`, `centro_custo_tipo_id`, `centro_custo_pai_id`, `numero`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 1, 2, NULL, '1', 'CONTAS A RECEBER', '2024-06-02 22:14:06', '2024-06-02 22:15:30', NULL, 'Administrador', NULL),
	(2, 1, 2, NULL, '1.2', 'VENDAS', '2024-06-02 22:15:19', '2024-06-02 22:15:27', NULL, 'Administrador', NULL),
	(3, 1, 1, NULL, '1', 'RECEITAS', '2024-06-02 22:15:49', NULL, NULL, 'Administrador', NULL),
	(4, 1, 2, 3, '1.2', 'VENDAS', '2024-06-02 22:16:06', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.centro_custo_tipo
DROP TABLE IF EXISTS `centro_custo_tipo`;
CREATE TABLE IF NOT EXISTS `centro_custo_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.centro_custo_tipo: ~2 rows (aproximadamente)
INSERT INTO `centro_custo_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Sintético', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Analítico', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.cep_cache
DROP TABLE IF EXISTS `cep_cache`;
CREATE TABLE IF NOT EXISTS `cep_cache` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cep` text COLLATE utf8mb3_unicode_ci,
  `rua` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `cidade` text COLLATE utf8mb3_unicode_ci,
  `bairro` text COLLATE utf8mb3_unicode_ci,
  `codigo_ibge` text COLLATE utf8mb3_unicode_ci,
  `uf` char(2) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `cidade_id` int DEFAULT NULL,
  `estado_id` int DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cep_cache: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificadora
DROP TABLE IF EXISTS `certificadora`;
CREATE TABLE IF NOT EXISTS `certificadora` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `texto_emissao` text COLLATE utf8mb3_unicode_ci,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificadora: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificadora_produtos
DROP TABLE IF EXISTS `certificadora_produtos`;
CREATE TABLE IF NOT EXISTS `certificadora_produtos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `certificadora_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `qtde_dias_vencimento` int DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `valor_custo` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificadora_produtos_1` (`certificadora_id`),
  KEY `fk_certificadora_produtos_2` (`produto_id`),
  CONSTRAINT `fk_certificadora_produtos_1` FOREIGN KEY (`certificadora_id`) REFERENCES `certificadora` (`id`),
  CONSTRAINT `fk_certificadora_produtos_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificadora_produtos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_agendamentos
DROP TABLE IF EXISTS `certificado_agendamentos`;
CREATE TABLE IF NOT EXISTS `certificado_agendamentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `certificado_venda_id` int NOT NULL,
  `titulo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `data_hora_inicial` datetime NOT NULL,
  `data_hora_final` datetime NOT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `cor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificado_agendamentos_1` (`certificado_venda_id`),
  CONSTRAINT `fk_certificado_agendamentos_1` FOREIGN KEY (`certificado_venda_id`) REFERENCES `certificado_venda` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_agendamentos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_agente_registro
DROP TABLE IF EXISTS `certificado_agente_registro`;
CREATE TABLE IF NOT EXISTS `certificado_agente_registro` (
  `id` int NOT NULL AUTO_INCREMENT,
  `parceiro_id` int DEFAULT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cpf` text COLLATE utf8mb3_unicode_ci,
  `fone` text COLLATE utf8mb3_unicode_ci,
  `email` text COLLATE utf8mb3_unicode_ci,
  `percentual_comissao` double DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificado_agente_registro_1` (`parceiro_id`),
  CONSTRAINT `fk_certificado_agente_registro_1` FOREIGN KEY (`parceiro_id`) REFERENCES `parceiro` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_agente_registro: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_cliente
DROP TABLE IF EXISTS `certificado_cliente`;
CREATE TABLE IF NOT EXISTS `certificado_cliente` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cliente_id` int NOT NULL,
  `parceiro_id` int DEFAULT NULL,
  `produto_id` int NOT NULL,
  `certificado_cliente_situacao_id` int NOT NULL,
  `data_vencimento_certificado` date DEFAULT NULL,
  `certificado_venda_id` int DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificado_cliente_1` (`cliente_id`),
  KEY `fk_certificado_cliente_2` (`parceiro_id`),
  KEY `fk_certificado_cliente_3` (`produto_id`),
  KEY `fk_certificado_cliente_4` (`certificado_venda_id`),
  KEY `fk_certificado_cliente_5` (`certificado_cliente_situacao_id`),
  CONSTRAINT `fk_certificado_cliente_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_certificado_cliente_2` FOREIGN KEY (`parceiro_id`) REFERENCES `parceiro` (`id`),
  CONSTRAINT `fk_certificado_cliente_3` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_certificado_cliente_4` FOREIGN KEY (`certificado_venda_id`) REFERENCES `certificado_venda` (`id`),
  CONSTRAINT `fk_certificado_cliente_5` FOREIGN KEY (`certificado_cliente_situacao_id`) REFERENCES `certificado_cliente_situacao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_cliente: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_cliente_situacao
DROP TABLE IF EXISTS `certificado_cliente_situacao`;
CREATE TABLE IF NOT EXISTS `certificado_cliente_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_cliente_situacao: ~3 rows (aproximadamente)
INSERT INTO `certificado_cliente_situacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Aguardando Renovação', NULL, NULL, '', '', NULL),
	(2, 'Renovado', NULL, NULL, '', '', NULL),
	(3, 'Não Renovado', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.certificado_email_historico
DROP TABLE IF EXISTS `certificado_email_historico`;
CREATE TABLE IF NOT EXISTS `certificado_email_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `certificado_cliente_id` int NOT NULL,
  `email` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificado_email_historico_1` (`certificado_cliente_id`),
  CONSTRAINT `fk_certificado_email_historico_1` FOREIGN KEY (`certificado_cliente_id`) REFERENCES `certificado_cliente` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_email_historico: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_tipo_atendimento
DROP TABLE IF EXISTS `certificado_tipo_atendimento`;
CREATE TABLE IF NOT EXISTS `certificado_tipo_atendimento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_tipo_atendimento: ~3 rows (aproximadamente)
INSERT INTO `certificado_tipo_atendimento` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Presencial Interno', NULL, NULL, '', '', NULL),
	(2, 'Presencial Externo', NULL, NULL, '', '', NULL),
	(3, 'Remoto', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.certificado_tipo_repasse
DROP TABLE IF EXISTS `certificado_tipo_repasse`;
CREATE TABLE IF NOT EXISTS `certificado_tipo_repasse` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_tipo_repasse: ~2 rows (aproximadamente)
INSERT INTO `certificado_tipo_repasse` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Pré-Pago', NULL, NULL, '', '', NULL),
	(2, 'Pós-Pago', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.certificado_venda
DROP TABLE IF EXISTS `certificado_venda`;
CREATE TABLE IF NOT EXISTS `certificado_venda` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `cliente_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `parceiro_id` int DEFAULT NULL,
  `certificado_agente_registro_id` int NOT NULL,
  `certificado_venda_situacao_id` int NOT NULL,
  `certificado_venda_modalidade_id` int DEFAULT NULL,
  `certificado_venda_tipomodalidade_id` int DEFAULT NULL,
  `certificado_tipo_repasse_id` int DEFAULT NULL,
  `vendedor_id` int DEFAULT NULL,
  `tabela_preco_id` int DEFAULT NULL,
  `certificadora_id` int DEFAULT NULL,
  `valor_custo` double DEFAULT NULL,
  `data_hora_agendamento` datetime DEFAULT NULL,
  `data_vencimento_certificado` date DEFAULT NULL,
  `valor_externo` double DEFAULT NULL,
  `custo_externo` double DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `agente_comissao_percentual` double DEFAULT NULL,
  `agente_comissao_valor` double DEFAULT NULL,
  `vendedor_comissao_percentual` double DEFAULT NULL,
  `vendedor_comissao_valor` double DEFAULT NULL,
  `atendimento_externo` tinyint(1) DEFAULT NULL,
  `parceiro_comissao_percentual` double DEFAULT NULL,
  `parceiro_valor_repasse` double DEFAULT NULL,
  `valor_total` double NOT NULL,
  `comissao_total` double DEFAULT NULL,
  `lucro_total` double DEFAULT NULL,
  `valor_cliente` double DEFAULT NULL,
  `valor_produto` double NOT NULL,
  `protocolo_emissao` text COLLATE utf8mb3_unicode_ci,
  `data_emissao` date DEFAULT NULL,
  `data_pagamento` date DEFAULT NULL,
  `certificado_tipo_atendimento_id` int DEFAULT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_venda_certificado_2` (`cliente_id`),
  KEY `fk_venda_certificado_3` (`produto_id`),
  KEY `fk_venda_certificado_4` (`parceiro_id`),
  KEY `fk_certificado_venda_6` (`certificado_venda_modalidade_id`),
  KEY `fk_certificado_venda_5` (`certificado_venda_situacao_id`),
  KEY `fk_certificado_venda_7` (`certificado_venda_tipomodalidade_id`),
  KEY `fk_certificado_venda_8` (`certificado_tipo_repasse_id`),
  KEY `fk_certificado_venda_9` (`vendedor_id`),
  KEY `fk_certificado_venda_10` (`system_unit_id`),
  KEY `fk_certificado_venda_11` (`tabela_preco_id`),
  KEY `fk_certificado_venda_12` (`certificado_tipo_atendimento_id`),
  KEY `fk_certificado_venda_13` (`certificadora_id`),
  CONSTRAINT `fk_certificado_venda_10` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_certificado_venda_11` FOREIGN KEY (`tabela_preco_id`) REFERENCES `tabela_preco` (`id`),
  CONSTRAINT `fk_certificado_venda_12` FOREIGN KEY (`certificado_tipo_atendimento_id`) REFERENCES `certificado_tipo_atendimento` (`id`),
  CONSTRAINT `fk_certificado_venda_13` FOREIGN KEY (`certificadora_id`) REFERENCES `certificadora` (`id`),
  CONSTRAINT `fk_certificado_venda_5` FOREIGN KEY (`certificado_venda_situacao_id`) REFERENCES `certificado_venda_situacao` (`id`),
  CONSTRAINT `fk_certificado_venda_6` FOREIGN KEY (`certificado_venda_modalidade_id`) REFERENCES `certificado_venda_modalidade` (`id`),
  CONSTRAINT `fk_certificado_venda_7` FOREIGN KEY (`certificado_venda_tipomodalidade_id`) REFERENCES `certificado_venda_tipomodalidade` (`id`),
  CONSTRAINT `fk_certificado_venda_8` FOREIGN KEY (`certificado_tipo_repasse_id`) REFERENCES `certificado_tipo_repasse` (`id`),
  CONSTRAINT `fk_certificado_venda_9` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_venda_certificado_2` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_venda_certificado_3` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_venda_certificado_4` FOREIGN KEY (`parceiro_id`) REFERENCES `parceiro` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_venda: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_venda_documentos
DROP TABLE IF EXISTS `certificado_venda_documentos`;
CREATE TABLE IF NOT EXISTS `certificado_venda_documentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `certificado_venda_id` int NOT NULL,
  `descricao_arquivo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `arquivo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificado_venda_documentos_1` (`certificado_venda_id`),
  CONSTRAINT `fk_certificado_venda_documentos_1` FOREIGN KEY (`certificado_venda_id`) REFERENCES `certificado_venda` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_venda_documentos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_venda_formapgto
DROP TABLE IF EXISTS `certificado_venda_formapgto`;
CREATE TABLE IF NOT EXISTS `certificado_venda_formapgto` (
  `id` int NOT NULL AUTO_INCREMENT,
  `certificado_venda_id` int NOT NULL,
  `forma_pagamento_id` int NOT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificado_venda_formapgto_1` (`certificado_venda_id`),
  KEY `fk_certificado_venda_formapgto_2` (`forma_pagamento_id`),
  CONSTRAINT `fk_certificado_venda_formapgto_1` FOREIGN KEY (`certificado_venda_id`) REFERENCES `certificado_venda` (`id`),
  CONSTRAINT `fk_certificado_venda_formapgto_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_venda_formapgto: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_venda_modalidade
DROP TABLE IF EXISTS `certificado_venda_modalidade`;
CREATE TABLE IF NOT EXISTS `certificado_venda_modalidade` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `certificado_tipo_repasse_id` int NOT NULL,
  `certificado_venda_tipomodalidade_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_certificado_venda_modalidade_1` (`certificado_venda_tipomodalidade_id`),
  KEY `fk_certificado_venda_modalidade_2` (`certificado_tipo_repasse_id`),
  CONSTRAINT `fk_certificado_venda_modalidade_1` FOREIGN KEY (`certificado_venda_tipomodalidade_id`) REFERENCES `certificado_venda_tipomodalidade` (`id`),
  CONSTRAINT `fk_certificado_venda_modalidade_2` FOREIGN KEY (`certificado_tipo_repasse_id`) REFERENCES `certificado_tipo_repasse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_venda_modalidade: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.certificado_venda_situacao
DROP TABLE IF EXISTS `certificado_venda_situacao`;
CREATE TABLE IF NOT EXISTS `certificado_venda_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `ordem` int DEFAULT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_venda_situacao: ~4 rows (aproximadamente)
INSERT INTO `certificado_venda_situacao` (`id`, `descricao`, `ordem`, `cor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Aguardando Atendimento', 1, '', NULL, NULL, '', '', NULL),
	(2, 'Atendido', 3, '', NULL, NULL, '', '', NULL),
	(3, 'Cancelado', 4, '', NULL, NULL, '', '', NULL),
	(4, 'Aguardando Aprovação', 2, '', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.certificado_venda_tipomodalidade
DROP TABLE IF EXISTS `certificado_venda_tipomodalidade`;
CREATE TABLE IF NOT EXISTS `certificado_venda_tipomodalidade` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.certificado_venda_tipomodalidade: ~2 rows (aproximadamente)
INSERT INTO `certificado_venda_tipomodalidade` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Percentual sobre venda', NULL, NULL, '', '', NULL),
	(2, 'Valor de tabela', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.cfop
DROP TABLE IF EXISTS `cfop`;
CREATE TABLE IF NOT EXISTS `cfop` (
  `id` int NOT NULL AUTO_INCREMENT,
  `numero` char(4) COLLATE utf8mb3_unicode_ci NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `aplicacao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cfop: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.chave_pix_tipo
DROP TABLE IF EXISTS `chave_pix_tipo`;
CREATE TABLE IF NOT EXISTS `chave_pix_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.chave_pix_tipo: ~4 rows (aproximadamente)
INSERT INTO `chave_pix_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'CPF/CNPJ', NULL, NULL, '', '', NULL),
	(2, 'E-Mail', NULL, NULL, '', '', NULL),
	(3, 'Telefone', NULL, NULL, '', '', NULL),
	(4, 'Chave Aleatória', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.cidade
DROP TABLE IF EXISTS `cidade`;
CREATE TABLE IF NOT EXISTS `cidade` (
  `id` int NOT NULL AUTO_INCREMENT,
  `estado_id` int NOT NULL,
  `pais_id` int DEFAULT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `codigo_ibge` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_cidade_1` (`estado_id`),
  KEY `fk_cidade_2` (`pais_id`),
  CONSTRAINT `fk_cidade_1` FOREIGN KEY (`estado_id`) REFERENCES `estado` (`id`),
  CONSTRAINT `fk_cidade_2` FOREIGN KEY (`pais_id`) REFERENCES `pais` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cidade: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.cliente
DROP TABLE IF EXISTS `cliente`;
CREATE TABLE IF NOT EXISTS `cliente` (
  `id` int NOT NULL AUTO_INCREMENT,
  `pessoa_tipo_id` int NOT NULL,
  `cliente_classificacao_id` int NOT NULL,
  `cliente_classificacao_subgrupo_id` int DEFAULT NULL,
  `vendedor_id` int DEFAULT NULL,
  `notafiscal_indiedest_id` int NOT NULL,
  `notafiscal_crt_id` int DEFAULT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cpf_cnpj` text COLLATE utf8mb3_unicode_ci,
  `rg` text COLLATE utf8mb3_unicode_ci,
  `email` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `insc_estadual` text COLLATE utf8mb3_unicode_ci,
  `insc_municipal` text COLLATE utf8mb3_unicode_ci,
  `razao_social` text COLLATE utf8mb3_unicode_ci,
  `fone` text COLLATE utf8mb3_unicode_ci,
  `observacoes` text COLLATE utf8mb3_unicode_ci,
  `data_nascimento` date DEFAULT NULL,
  `conjuge` text COLLATE utf8mb3_unicode_ci,
  `conjuge_cpf` text COLLATE utf8mb3_unicode_ci,
  `nome_pai` text COLLATE utf8mb3_unicode_ci,
  `nome_mae` text COLLATE utf8mb3_unicode_ci,
  `local_trabalho` text COLLATE utf8mb3_unicode_ci,
  `renda` double DEFAULT NULL,
  `tempo_trabalho` text COLLATE utf8mb3_unicode_ci,
  `residencia_propria` int DEFAULT NULL,
  `utilizar_endereco_cobranca` int NOT NULL,
  `cobranca_cnpj` text COLLATE utf8mb3_unicode_ci,
  `cobranca_nome` text COLLATE utf8mb3_unicode_ci,
  `cobranca_cep` text COLLATE utf8mb3_unicode_ci,
  `cobranca_endereco` text COLLATE utf8mb3_unicode_ci,
  `cobranca_bairro` text COLLATE utf8mb3_unicode_ci,
  `cobranca_uf` text COLLATE utf8mb3_unicode_ci,
  `cobranca_cidade` text COLLATE utf8mb3_unicode_ci,
  `cobranca_fones` text COLLATE utf8mb3_unicode_ci,
  `cliente_situacao_id` int NOT NULL,
  `limite_credito` double DEFAULT NULL,
  `limite_utilizado` double DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `system_unit_id` int DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `vendas_quantidade` int DEFAULT NULL,
  `vendas_valortotal` double DEFAULT NULL,
  `vendas_dataultima` datetime DEFAULT NULL,
  `vendas_valormaior` double DEFAULT NULL,
  `vendas_datamaior` datetime DEFAULT NULL,
  `observacoes_financeiro` text COLLATE utf8mb3_unicode_ci,
  `tabela_preco_id` int DEFAULT NULL,
  `percentual_comissao_vendedor` double DEFAULT NULL,
  `cliente_exterior` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cliente_10` (`system_unit_id`),
  KEY `fk_cliente_1` (`pessoa_tipo_id`),
  KEY `fk_cliente_2` (`vendedor_id`),
  KEY `fk_cliente_3` (`residencia_propria`),
  KEY `fk_cliente_4` (`utilizar_endereco_cobranca`),
  KEY `fk_cliente_5` (`cliente_situacao_id`),
  KEY `fk_cliente_6` (`notafiscal_indiedest_id`),
  KEY `fk_cliente_7` (`notafiscal_crt_id`),
  KEY `fk_cliente_8` (`cliente_classificacao_id`),
  KEY `fk_cliente_9` (`cliente_classificacao_subgrupo_id`),
  KEY `fk_cliente_11` (`tabela_preco_id`),
  CONSTRAINT `fk_cliente_1` FOREIGN KEY (`pessoa_tipo_id`) REFERENCES `pessoa_tipo` (`id`),
  CONSTRAINT `fk_cliente_10` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_cliente_11` FOREIGN KEY (`tabela_preco_id`) REFERENCES `tabela_preco` (`id`),
  CONSTRAINT `fk_cliente_2` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_cliente_3` FOREIGN KEY (`residencia_propria`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_cliente_4` FOREIGN KEY (`utilizar_endereco_cobranca`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_cliente_5` FOREIGN KEY (`cliente_situacao_id`) REFERENCES `cliente_situacao` (`id`),
  CONSTRAINT `fk_cliente_6` FOREIGN KEY (`notafiscal_indiedest_id`) REFERENCES `notafiscal_indiedest` (`id`),
  CONSTRAINT `fk_cliente_7` FOREIGN KEY (`notafiscal_crt_id`) REFERENCES `notafiscal_crt` (`id`),
  CONSTRAINT `fk_cliente_8` FOREIGN KEY (`cliente_classificacao_id`) REFERENCES `cliente_classificacao` (`id`),
  CONSTRAINT `fk_cliente_9` FOREIGN KEY (`cliente_classificacao_subgrupo_id`) REFERENCES `cliente_classificacao_subgrupo` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cliente: ~0 rows (aproximadamente)
INSERT INTO `cliente` (`id`, `pessoa_tipo_id`, `cliente_classificacao_id`, `cliente_classificacao_subgrupo_id`, `vendedor_id`, `notafiscal_indiedest_id`, `notafiscal_crt_id`, `nome`, `cpf_cnpj`, `rg`, `email`, `criado_em`, `alterado_em`, `insc_estadual`, `insc_municipal`, `razao_social`, `fone`, `observacoes`, `data_nascimento`, `conjuge`, `conjuge_cpf`, `nome_pai`, `nome_mae`, `local_trabalho`, `renda`, `tempo_trabalho`, `residencia_propria`, `utilizar_endereco_cobranca`, `cobranca_cnpj`, `cobranca_nome`, `cobranca_cep`, `cobranca_endereco`, `cobranca_bairro`, `cobranca_uf`, `cobranca_cidade`, `cobranca_fones`, `cliente_situacao_id`, `limite_credito`, `limite_utilizado`, `criado_por`, `alterado_por`, `system_unit_id`, `deletado_em`, `vendas_quantidade`, `vendas_valortotal`, `vendas_dataultima`, `vendas_valormaior`, `vendas_datamaior`, `observacoes_financeiro`, `tabela_preco_id`, `percentual_comissao_vendedor`, `cliente_exterior`) VALUES
	(1, 1, 1, NULL, NULL, 3, NULL, 'Fernando Ferreira Gomes Nascimento', '96947055172', '96947055172', 'fpasqueto@gmail.com', '2024-03-30 10:53:08', '2024-05-30 18:42:31', '96947055172', '96947055172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'Administrador', 'Administrador', 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'N');

-- Copiando estrutura para tabela erp_nuvem.cliente_classificacao
DROP TABLE IF EXISTS `cliente_classificacao`;
CREATE TABLE IF NOT EXISTS `cliente_classificacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `ativo_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cliente_classificacao_1` (`ativo_id`),
  CONSTRAINT `fk_cliente_classificacao_1` FOREIGN KEY (`ativo_id`) REFERENCES `ativo` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cliente_classificacao: ~0 rows (aproximadamente)
INSERT INTO `cliente_classificacao` (`id`, `descricao`, `criado_em`, `alterado_em`, `criado_por`, `alterado_por`, `ativo_id`) VALUES
	(1, 'GERAL', '2024-03-30 10:52:31', NULL, 'Administrador', NULL, 1),
	(2, 'LOJA', '2024-05-30 18:47:45', '2024-05-30 18:47:58', 'Administrador', 'Administrador', 1);

-- Copiando estrutura para tabela erp_nuvem.cliente_classificacao_subgrupo
DROP TABLE IF EXISTS `cliente_classificacao_subgrupo`;
CREATE TABLE IF NOT EXISTS `cliente_classificacao_subgrupo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cliente_classificacao_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cliente_classificacao_subgrupo_1` (`cliente_classificacao_id`),
  CONSTRAINT `fk_cliente_classificacao_subgrupo_1` FOREIGN KEY (`cliente_classificacao_id`) REFERENCES `cliente_classificacao` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cliente_classificacao_subgrupo: ~0 rows (aproximadamente)
INSERT INTO `cliente_classificacao_subgrupo` (`id`, `cliente_classificacao_id`, `descricao`, `criado_em`, `alterado_em`) VALUES
	(1, 2, 'LOJA', '2024-05-30 18:47:58', NULL);

-- Copiando estrutura para tabela erp_nuvem.cliente_contato
DROP TABLE IF EXISTS `cliente_contato`;
CREATE TABLE IF NOT EXISTS `cliente_contato` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cliente_id` int DEFAULT NULL,
  `tipo_contato` text COLLATE utf8mb3_unicode_ci,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `fone` text COLLATE utf8mb3_unicode_ci,
  `ativo_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cliente_contato_1` (`cliente_id`),
  CONSTRAINT `fk_cliente_contato_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cliente_contato: ~0 rows (aproximadamente)
INSERT INTO `cliente_contato` (`id`, `cliente_id`, `tipo_contato`, `nome`, `fone`, `ativo_id`) VALUES
	(1, 1, 'GERAL', 'GERAL', NULL, 1);

-- Copiando estrutura para tabela erp_nuvem.cliente_endereco
DROP TABLE IF EXISTS `cliente_endereco`;
CREATE TABLE IF NOT EXISTS `cliente_endereco` (
  `id` int NOT NULL AUTO_INCREMENT,
  `logradouro` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cliente_id` int NOT NULL,
  `principal` int NOT NULL,
  `cidade_id` int NOT NULL,
  `bairro` text COLLATE utf8mb3_unicode_ci,
  `cep` text COLLATE utf8mb3_unicode_ci,
  `numero` text COLLATE utf8mb3_unicode_ci,
  `complemento` text COLLATE utf8mb3_unicode_ci,
  `ativo_id` int NOT NULL,
  `codigo_ibge` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `ibge_estado` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cliente_endereco_1` (`cliente_id`),
  KEY `fk_cliente_endereco_2` (`principal`),
  KEY `fk_cliente_endereco_3` (`cidade_id`),
  CONSTRAINT `fk_cliente_endereco_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_cliente_endereco_2` FOREIGN KEY (`principal`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_cliente_endereco_3` FOREIGN KEY (`cidade_id`) REFERENCES `cidade` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cliente_endereco: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.cliente_historico_limite
DROP TABLE IF EXISTS `cliente_historico_limite`;
CREATE TABLE IF NOT EXISTS `cliente_historico_limite` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cliente_id` int NOT NULL,
  `valor` double NOT NULL,
  `data_hora` datetime NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_cliente_historico_limite_1` (`cliente_id`),
  CONSTRAINT `fk_cliente_historico_limite_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cliente_historico_limite: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.cliente_situacao
DROP TABLE IF EXISTS `cliente_situacao`;
CREATE TABLE IF NOT EXISTS `cliente_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cliente_situacao: ~3 rows (aproximadamente)
INSERT INTO `cliente_situacao` (`id`, `descricao`, `criado_em`, `alterado_em`) VALUES
	(1, 'Ativo', NULL, NULL),
	(2, 'Bloqueado', NULL, NULL),
	(3, 'Desativado', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.condicao_pagamento
DROP TABLE IF EXISTS `condicao_pagamento`;
CREATE TABLE IF NOT EXISTS `condicao_pagamento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `numero_parcelas` int NOT NULL,
  `dias_primeira_parcelas` int DEFAULT NULL,
  `dias_entre_parcelas` int DEFAULT NULL,
  `taxa` double DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.condicao_pagamento: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.configuracoes
DROP TABLE IF EXISTS `configuracoes`;
CREATE TABLE IF NOT EXISTS `configuracoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `forma_pagamento_id_dinheiro_caixa` int DEFAULT NULL,
  `forma_pagamento_id_titulos_cpag_nf` int DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_configuracoes_1` (`forma_pagamento_id_dinheiro_caixa`),
  KEY `fk_configuracoes_2` (`forma_pagamento_id_titulos_cpag_nf`),
  CONSTRAINT `fk_configuracoes_1` FOREIGN KEY (`forma_pagamento_id_dinheiro_caixa`) REFERENCES `forma_pagamento` (`id`),
  CONSTRAINT `fk_configuracoes_2` FOREIGN KEY (`forma_pagamento_id_titulos_cpag_nf`) REFERENCES `forma_pagamento` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.configuracoes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.configuracoes_filial
DROP TABLE IF EXISTS `configuracoes_filial`;
CREATE TABLE IF NOT EXISTS `configuracoes_filial` (
  `id` int NOT NULL AUTO_INCREMENT,
  `configuracoes_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `produto_etiqueta_configuracoes_id` int DEFAULT NULL,
  `plano_conta_mascara` text COLLATE utf8mb3_unicode_ci,
  `centro_custo_mascara` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `plano_conta_crec_id` int DEFAULT NULL,
  `centro_custo_crec_id` int DEFAULT NULL,
  `cpag_usa_plano_contas_id` int DEFAULT NULL,
  `info_complementar_orcamento` text COLLATE utf8mb3_unicode_ci,
  `informar_duplicidade_de_item_venda_id` int DEFAULT NULL,
  `venda_apenas_com_estoque_id` int DEFAULT NULL,
  `notafiscal_cprod_padrao_orcamento_id` int DEFAULT NULL,
  `notafiscal_cprod_padrao_venda_id` int DEFAULT NULL,
  `produto_margem_padrao` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_configuracoes_filial_1` (`configuracoes_id`),
  KEY `fk_configuracoes_filial_2` (`produto_etiqueta_configuracoes_id`),
  KEY `fk_configuracoes_filial_3` (`system_unit_id`),
  KEY `fk_configuracoes_filial_4` (`plano_conta_crec_id`),
  KEY `fk_configuracoes_filial_5` (`centro_custo_crec_id`),
  KEY `fk_configuracoes_filial_6` (`cpag_usa_plano_contas_id`),
  KEY `fk_configuracoes_filial_9` (`notafiscal_cprod_padrao_orcamento_id`),
  KEY `fk_configuracoes_filial_7` (`informar_duplicidade_de_item_venda_id`),
  KEY `fk_configuracoes_filial_8` (`venda_apenas_com_estoque_id`),
  KEY `fk_configuracoes_filial_10` (`notafiscal_cprod_padrao_venda_id`),
  CONSTRAINT `fk_configuracoes_filial_1` FOREIGN KEY (`configuracoes_id`) REFERENCES `configuracoes` (`id`),
  CONSTRAINT `fk_configuracoes_filial_10` FOREIGN KEY (`notafiscal_cprod_padrao_venda_id`) REFERENCES `notafiscal_cprod_padrao` (`id`),
  CONSTRAINT `fk_configuracoes_filial_2` FOREIGN KEY (`produto_etiqueta_configuracoes_id`) REFERENCES `produto_etiqueta_configuracoes` (`id`),
  CONSTRAINT `fk_configuracoes_filial_3` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_configuracoes_filial_4` FOREIGN KEY (`plano_conta_crec_id`) REFERENCES `plano_conta` (`id`),
  CONSTRAINT `fk_configuracoes_filial_5` FOREIGN KEY (`centro_custo_crec_id`) REFERENCES `centro_custo` (`id`),
  CONSTRAINT `fk_configuracoes_filial_6` FOREIGN KEY (`cpag_usa_plano_contas_id`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_configuracoes_filial_7` FOREIGN KEY (`informar_duplicidade_de_item_venda_id`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_configuracoes_filial_8` FOREIGN KEY (`venda_apenas_com_estoque_id`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_configuracoes_filial_9` FOREIGN KEY (`notafiscal_cprod_padrao_orcamento_id`) REFERENCES `notafiscal_cprod_padrao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.configuracoes_filial: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contabil_lancamentos
DROP TABLE IF EXISTS `contabil_lancamentos`;
CREATE TABLE IF NOT EXISTS `contabil_lancamentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `plano_conta_id` int NOT NULL,
  `centro_custo_id` int NOT NULL,
  `contabil_lancamentos_tipo_id` int NOT NULL,
  `contabil_lancamentos_situacao_id` int NOT NULL,
  `contabil_lancamentos_origem_id` int NOT NULL,
  `data_lancamento` date NOT NULL,
  `valor` double NOT NULL,
  `contasrec_id` int DEFAULT NULL,
  `contaspag_contabil_id` int DEFAULT NULL,
  `conta_corrente_lancamentos_id` int DEFAULT NULL,
  `historico` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contabil_1` (`plano_conta_id`),
  KEY `fk_contabil_2` (`centro_custo_id`),
  KEY `fk_contabil_lancamentos_3` (`contabil_lancamentos_tipo_id`),
  KEY `fk_contabil_lancamentos_4` (`contasrec_id`),
  KEY `fk_contabil_lancamentos_5` (`contaspag_contabil_id`),
  KEY `fk_contabil_lancamentos_6` (`conta_corrente_lancamentos_id`),
  KEY `fk_contabil_lancamentos_7` (`contabil_lancamentos_situacao_id`),
  KEY `fk_contabil_lancamentos_8` (`contabil_lancamentos_origem_id`),
  CONSTRAINT `fk_contabil_1` FOREIGN KEY (`plano_conta_id`) REFERENCES `plano_conta` (`id`),
  CONSTRAINT `fk_contabil_2` FOREIGN KEY (`centro_custo_id`) REFERENCES `centro_custo` (`id`),
  CONSTRAINT `fk_contabil_lancamentos_3` FOREIGN KEY (`contabil_lancamentos_tipo_id`) REFERENCES `contabil_lancamentos_tipo` (`id`),
  CONSTRAINT `fk_contabil_lancamentos_4` FOREIGN KEY (`contasrec_id`) REFERENCES `contasrec` (`id`),
  CONSTRAINT `fk_contabil_lancamentos_5` FOREIGN KEY (`contaspag_contabil_id`) REFERENCES `contaspag_contabil` (`id`),
  CONSTRAINT `fk_contabil_lancamentos_6` FOREIGN KEY (`conta_corrente_lancamentos_id`) REFERENCES `conta_corrente_lancamentos` (`id`),
  CONSTRAINT `fk_contabil_lancamentos_7` FOREIGN KEY (`contabil_lancamentos_situacao_id`) REFERENCES `contabil_lancamentos_situacao` (`id`),
  CONSTRAINT `fk_contabil_lancamentos_8` FOREIGN KEY (`contabil_lancamentos_origem_id`) REFERENCES `contabil_lancamentos_origem` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contabil_lancamentos: ~0 rows (aproximadamente)
INSERT INTO `contabil_lancamentos` (`id`, `plano_conta_id`, `centro_custo_id`, `contabil_lancamentos_tipo_id`, `contabil_lancamentos_situacao_id`, `contabil_lancamentos_origem_id`, `data_lancamento`, `valor`, `contasrec_id`, `contaspag_contabil_id`, `conta_corrente_lancamentos_id`, `historico`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 2, 4, 2, 2, 2, '2024-06-03', 500, 1, NULL, NULL, 'Ref. Crédito Cliente: Fernando Ferreira Gomes Nascimento', '2024-06-02 22:31:28', NULL, NULL, 'Administrador', NULL),
	(2, 2, 4, 2, 1, 3, '2024-06-03', 500, NULL, NULL, 1, 'Ref. Lançam. avulso em conta corrente', '2024-06-03 23:32:02', NULL, NULL, 'Administrador', NULL),
	(3, 2, 4, 2, 2, 2, '2024-07-31', 500, 2, NULL, NULL, 'Ref. Crédito Cliente: Fernando Ferreira Gomes Nascimento', '2024-07-30 14:46:01', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.contabil_lancamentos_origem
DROP TABLE IF EXISTS `contabil_lancamentos_origem`;
CREATE TABLE IF NOT EXISTS `contabil_lancamentos_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contabil_lancamentos_origem: ~3 rows (aproximadamente)
INSERT INTO `contabil_lancamentos_origem` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Contas a Pagar', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Contas a Receber', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Conta Corrente', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.contabil_lancamentos_situacao
DROP TABLE IF EXISTS `contabil_lancamentos_situacao`;
CREATE TABLE IF NOT EXISTS `contabil_lancamentos_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contabil_lancamentos_situacao: ~2 rows (aproximadamente)
INSERT INTO `contabil_lancamentos_situacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Liquidado', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Não Liquidado', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.contabil_lancamentos_tipo
DROP TABLE IF EXISTS `contabil_lancamentos_tipo`;
CREATE TABLE IF NOT EXISTS `contabil_lancamentos_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contabil_lancamentos_tipo: ~2 rows (aproximadamente)
INSERT INTO `contabil_lancamentos_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Débito', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Crédito', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.contaspag
DROP TABLE IF EXISTS `contaspag`;
CREATE TABLE IF NOT EXISTS `contaspag` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contaspag_situacao_id` int NOT NULL,
  `forma_pagamento_id` int NOT NULL,
  `fornecedor_id` int NOT NULL,
  `contaspag_origem_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `numero_documento` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `parcela` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `data_emissao` date NOT NULL,
  `valor` double NOT NULL,
  `data_vencimento` date NOT NULL,
  `data_venc_original` date DEFAULT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `data_pagamento` date DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  `juros` double DEFAULT NULL,
  `valor_pago` double DEFAULT NULL,
  `valor_aberto` double DEFAULT NULL,
  `valor_multa` double DEFAULT NULL,
  `cheque_banco_id` int DEFAULT NULL,
  `cheque_agencia` text COLLATE utf8mb3_unicode_ci,
  `cheque_conta` double DEFAULT NULL,
  `cheque_emitente` text COLLATE utf8mb3_unicode_ci,
  `cheque_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `data_competencia` date DEFAULT NULL,
  `contaspag_bloco_id` int DEFAULT NULL,
  `nota_fiscal_compra_id` int DEFAULT NULL,
  `data_vencimento_calendario` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contaspag_1` (`contaspag_situacao_id`),
  KEY `fk_contaspag_2` (`forma_pagamento_id`),
  KEY `fk_contaspag_3` (`fornecedor_id`),
  KEY `fk_contaspag_4` (`contaspag_origem_id`),
  KEY `fk_contaspag_5` (`cheque_banco_id`),
  KEY `fk_contaspag_6` (`system_unit_id`),
  KEY `fk_contaspag_7` (`contaspag_bloco_id`),
  KEY `fk_contaspag_8` (`nota_fiscal_compra_id`),
  CONSTRAINT `fk_contaspag_1` FOREIGN KEY (`contaspag_situacao_id`) REFERENCES `contaspag_situacao` (`id`),
  CONSTRAINT `fk_contaspag_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`),
  CONSTRAINT `fk_contaspag_3` FOREIGN KEY (`fornecedor_id`) REFERENCES `fornecedor` (`id`),
  CONSTRAINT `fk_contaspag_4` FOREIGN KEY (`contaspag_origem_id`) REFERENCES `contaspag_origem` (`id`),
  CONSTRAINT `fk_contaspag_5` FOREIGN KEY (`cheque_banco_id`) REFERENCES `banco` (`id`),
  CONSTRAINT `fk_contaspag_6` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_contaspag_7` FOREIGN KEY (`contaspag_bloco_id`) REFERENCES `contaspag_bloco` (`id`),
  CONSTRAINT `fk_contaspag_8` FOREIGN KEY (`nota_fiscal_compra_id`) REFERENCES `nota_fiscal_compra` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag: ~0 rows (aproximadamente)
INSERT INTO `contaspag` (`id`, `contaspag_situacao_id`, `forma_pagamento_id`, `fornecedor_id`, `contaspag_origem_id`, `system_unit_id`, `numero_documento`, `parcela`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `data_emissao`, `valor`, `data_vencimento`, `data_venc_original`, `observacao`, `data_pagamento`, `desconto`, `juros`, `valor_pago`, `valor_aberto`, `valor_multa`, `cheque_banco_id`, `cheque_agencia`, `cheque_conta`, `cheque_emitente`, `cheque_cpfcnpj`, `data_competencia`, `contaspag_bloco_id`, `nota_fiscal_compra_id`, `data_vencimento_calendario`) VALUES
	(1, 1, 2, 1, 1, 1, '111', NULL, '2024-06-06 10:52:00', NULL, NULL, 'Administrador', NULL, '2024-06-06', 1000, '2024-06-20', '2024-06-20', NULL, NULL, 0, 0, 0, 1000, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-06-20 00:00:00');

-- Copiando estrutura para tabela erp_nuvem.contaspag_anexos
DROP TABLE IF EXISTS `contaspag_anexos`;
CREATE TABLE IF NOT EXISTS `contaspag_anexos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contaspag_id` int NOT NULL,
  `titulos_tipo_anexo_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `arquivo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contaspag_anexos_1` (`contaspag_id`),
  KEY `fk_contaspag_anexos_2` (`titulos_tipo_anexo_id`),
  CONSTRAINT `fk_contaspag_anexos_1` FOREIGN KEY (`contaspag_id`) REFERENCES `contaspag` (`id`),
  CONSTRAINT `fk_contaspag_anexos_2` FOREIGN KEY (`titulos_tipo_anexo_id`) REFERENCES `titulos_tipo_anexo` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_anexos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contaspag_baixas
DROP TABLE IF EXISTS `contaspag_baixas`;
CREATE TABLE IF NOT EXISTS `contaspag_baixas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contaspag_id` int NOT NULL,
  `conta_corrente_id` int NOT NULL,
  `data_pagamento` date NOT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `juros` double DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  `saldo_aberto` double DEFAULT NULL,
  `saldo_apagar` double DEFAULT NULL,
  `multa` double DEFAULT NULL,
  `historico` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_contaspag_baixas_1` (`contaspag_id`),
  KEY `fk_contaspag_baixas_2` (`conta_corrente_id`),
  CONSTRAINT `fk_contaspag_baixas_1` FOREIGN KEY (`contaspag_id`) REFERENCES `contaspag` (`id`),
  CONSTRAINT `fk_contaspag_baixas_2` FOREIGN KEY (`conta_corrente_id`) REFERENCES `conta_corrente` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_baixas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contaspag_bloco
DROP TABLE IF EXISTS `contaspag_bloco`;
CREATE TABLE IF NOT EXISTS `contaspag_bloco` (
  `id` int NOT NULL AUTO_INCREMENT,
  `fornecedor_id` int NOT NULL,
  `forma_pagamento_id` int NOT NULL,
  `contaspag_origem_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `quantidade_parcelas` int NOT NULL,
  `primeiro_vencimento` date DEFAULT NULL,
  `valor` double DEFAULT NULL,
  `numero_documento` text COLLATE utf8mb3_unicode_ci,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contaspag_agrupamento_1` (`fornecedor_id`),
  KEY `fk_contaspag_agrupamento_2` (`forma_pagamento_id`),
  KEY `fk_contaspag_agrupamento_3` (`contaspag_origem_id`),
  KEY `fk_contaspag_bloco_4` (`system_unit_id`),
  CONSTRAINT `fk_contaspag_agrupamento_1` FOREIGN KEY (`fornecedor_id`) REFERENCES `fornecedor` (`id`),
  CONSTRAINT `fk_contaspag_agrupamento_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`),
  CONSTRAINT `fk_contaspag_agrupamento_3` FOREIGN KEY (`contaspag_origem_id`) REFERENCES `contaspag_origem` (`id`),
  CONSTRAINT `fk_contaspag_bloco_4` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_bloco: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contaspag_bloco_contabil
DROP TABLE IF EXISTS `contaspag_bloco_contabil`;
CREATE TABLE IF NOT EXISTS `contaspag_bloco_contabil` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contaspag_bloco_id` int NOT NULL,
  `plano_conta_id` int NOT NULL,
  `centro_custo_id` int NOT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contaspag_agrupamento_contabil_2` (`plano_conta_id`),
  KEY `fk_contaspag_agrupamento_contabil_3` (`contaspag_bloco_id`),
  CONSTRAINT `fk_contaspag_agrupamento_contabil_2` FOREIGN KEY (`plano_conta_id`) REFERENCES `plano_conta` (`id`),
  CONSTRAINT `fk_contaspag_agrupamento_contabil_3` FOREIGN KEY (`contaspag_bloco_id`) REFERENCES `contaspag_bloco` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_bloco_contabil: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contaspag_contabil
DROP TABLE IF EXISTS `contaspag_contabil`;
CREATE TABLE IF NOT EXISTS `contaspag_contabil` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contaspag_id` int NOT NULL,
  `plano_conta_id` int NOT NULL,
  `centro_custo_id` int NOT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contaspag_contabil_1` (`contaspag_id`),
  KEY `fk_contaspag_contabil_2` (`plano_conta_id`),
  KEY `fk_contaspag_contabil_3` (`centro_custo_id`),
  CONSTRAINT `fk_contaspag_contabil_1` FOREIGN KEY (`contaspag_id`) REFERENCES `contaspag` (`id`),
  CONSTRAINT `fk_contaspag_contabil_2` FOREIGN KEY (`plano_conta_id`) REFERENCES `plano_conta` (`id`),
  CONSTRAINT `fk_contaspag_contabil_3` FOREIGN KEY (`centro_custo_id`) REFERENCES `centro_custo` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_contabil: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contaspag_historico_venc
DROP TABLE IF EXISTS `contaspag_historico_venc`;
CREATE TABLE IF NOT EXISTS `contaspag_historico_venc` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contaspag_id` int NOT NULL,
  `vencimento_anterior` date DEFAULT NULL,
  `vencimento_atual` date NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contaspag_historico_venc_1` (`contaspag_id`),
  CONSTRAINT `fk_contaspag_historico_venc_1` FOREIGN KEY (`contaspag_id`) REFERENCES `contaspag` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_historico_venc: ~0 rows (aproximadamente)
INSERT INTO `contaspag_historico_venc` (`id`, `contaspag_id`, `vencimento_anterior`, `vencimento_atual`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 1, NULL, '2024-06-20', '2024-06-06 10:52:00', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.contaspag_origem
DROP TABLE IF EXISTS `contaspag_origem`;
CREATE TABLE IF NOT EXISTS `contaspag_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_origem: ~2 rows (aproximadamente)
INSERT INTO `contaspag_origem` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Avulso', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Compras', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.contaspag_situacao
DROP TABLE IF EXISTS `contaspag_situacao`;
CREATE TABLE IF NOT EXISTS `contaspag_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contaspag_situacao: ~4 rows (aproximadamente)
INSERT INTO `contaspag_situacao` (`id`, `descricao`, `cor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Em Aberto', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Pago Parcialmente', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Pago', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'Cancelado', NULL, NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.contasrec
DROP TABLE IF EXISTS `contasrec`;
CREATE TABLE IF NOT EXISTS `contasrec` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `cliente_id` int NOT NULL,
  `forma_pagamento_id` int NOT NULL,
  `contasrec_situacao_id` int NOT NULL,
  `plano_conta_id` int NOT NULL,
  `centro_custo_id` int NOT NULL,
  `contasrec_origem_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `numero_documento` text COLLATE utf8mb3_unicode_ci,
  `parcela` text COLLATE utf8mb3_unicode_ci,
  `valor` double DEFAULT NULL,
  `data_vencimento` date DEFAULT NULL,
  `data_venc_original` date DEFAULT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `data_pagamento` date DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  `juros` double DEFAULT NULL,
  `valor_pago` double DEFAULT NULL,
  `valor_aberto` double DEFAULT NULL,
  `valor_multa` double DEFAULT NULL,
  `cheque_banco_id` int DEFAULT NULL,
  `cheque_agencia` text COLLATE utf8mb3_unicode_ci,
  `cheque_conta` text COLLATE utf8mb3_unicode_ci,
  `cheque_emitente` text COLLATE utf8mb3_unicode_ci,
  `cheque_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `data_competencia` date DEFAULT NULL,
  `conta_corrente_boleto_id` int DEFAULT NULL,
  `boleto_situacao_id` int DEFAULT NULL,
  `boleto_nosso_numero` text COLLATE utf8mb3_unicode_ci,
  `vendedor_comissao` double DEFAULT NULL,
  `vendedor_id` int DEFAULT NULL,
  `contasrec_bloco_id` int DEFAULT NULL,
  `venda_formapgto_id` int DEFAULT NULL,
  `data_emissao` date DEFAULT NULL,
  `ativo_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contasrec_1` (`contasrec_situacao_id`),
  KEY `fk_contasrec_2` (`plano_conta_id`),
  KEY `fk_contasrec_3` (`centro_custo_id`),
  KEY `fk_contasrec_4` (`contasrec_origem_id`),
  KEY `fk_contasrec_5` (`system_unit_id`),
  KEY `fk_contasrec_6` (`cliente_id`),
  KEY `fk_contasrec_7` (`cheque_banco_id`),
  KEY `fk_contasrec_8` (`forma_pagamento_id`),
  KEY `fk_contasrec_9` (`conta_corrente_boleto_id`),
  KEY `fk_contasrec_10` (`boleto_situacao_id`),
  KEY `fk_contasrec_11` (`vendedor_id`),
  KEY `fk_contasrec_12` (`contasrec_bloco_id`),
  KEY `fk_contasrec_13` (`venda_formapgto_id`),
  KEY `fk_contasrec_14` (`ativo_id`),
  CONSTRAINT `fk_contasrec_1` FOREIGN KEY (`contasrec_situacao_id`) REFERENCES `contasrec_situacao` (`id`),
  CONSTRAINT `fk_contasrec_10` FOREIGN KEY (`boleto_situacao_id`) REFERENCES `boleto_situacao` (`id`),
  CONSTRAINT `fk_contasrec_11` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_contasrec_12` FOREIGN KEY (`contasrec_bloco_id`) REFERENCES `contasrec_bloco` (`id`),
  CONSTRAINT `fk_contasrec_13` FOREIGN KEY (`venda_formapgto_id`) REFERENCES `venda_formapgto` (`id`),
  CONSTRAINT `fk_contasrec_14` FOREIGN KEY (`ativo_id`) REFERENCES `ativo` (`id`),
  CONSTRAINT `fk_contasrec_2` FOREIGN KEY (`plano_conta_id`) REFERENCES `plano_conta` (`id`),
  CONSTRAINT `fk_contasrec_3` FOREIGN KEY (`centro_custo_id`) REFERENCES `centro_custo` (`id`),
  CONSTRAINT `fk_contasrec_4` FOREIGN KEY (`contasrec_origem_id`) REFERENCES `contasrec_origem` (`id`),
  CONSTRAINT `fk_contasrec_5` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_contasrec_6` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_contasrec_7` FOREIGN KEY (`cheque_banco_id`) REFERENCES `banco` (`id`),
  CONSTRAINT `fk_contasrec_8` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`),
  CONSTRAINT `fk_contasrec_9` FOREIGN KEY (`conta_corrente_boleto_id`) REFERENCES `conta_corrente` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec: ~0 rows (aproximadamente)
INSERT INTO `contasrec` (`id`, `system_unit_id`, `cliente_id`, `forma_pagamento_id`, `contasrec_situacao_id`, `plano_conta_id`, `centro_custo_id`, `contasrec_origem_id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `numero_documento`, `parcela`, `valor`, `data_vencimento`, `data_venc_original`, `observacao`, `data_pagamento`, `desconto`, `juros`, `valor_pago`, `valor_aberto`, `valor_multa`, `cheque_banco_id`, `cheque_agencia`, `cheque_conta`, `cheque_emitente`, `cheque_cpfcnpj`, `data_competencia`, `conta_corrente_boleto_id`, `boleto_situacao_id`, `boleto_nosso_numero`, `vendedor_comissao`, `vendedor_id`, `contasrec_bloco_id`, `venda_formapgto_id`, `data_emissao`, `ativo_id`) VALUES
	(1, 1, 1, 2, 1, 2, 4, 1, '2024-06-02 22:31:28', NULL, NULL, 'Administrador', NULL, '1245234', '1', 500, '2024-06-03', '2024-06-03', NULL, NULL, 0, 0, 0, 500, 0, NULL, NULL, NULL, NULL, NULL, '2024-06-03', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-06-02', 1),
	(2, 1, 1, 2, 1, 2, 4, 1, '2024-07-30 14:46:01', NULL, NULL, 'Administrador', NULL, '11121254', '1', 500, '2024-07-31', '2024-07-31', NULL, NULL, 0, 0, 0, 500, 0, NULL, NULL, NULL, NULL, NULL, '2024-07-31', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2024-07-30', 1);

-- Copiando estrutura para tabela erp_nuvem.contasrec_anexos
DROP TABLE IF EXISTS `contasrec_anexos`;
CREATE TABLE IF NOT EXISTS `contasrec_anexos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contasrec_id` int NOT NULL,
  `titulos_tipo_anexo_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `arquivo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contasrec_anexos_1` (`contasrec_id`),
  KEY `fk_contasrec_anexos_2` (`titulos_tipo_anexo_id`),
  CONSTRAINT `fk_contasrec_anexos_1` FOREIGN KEY (`contasrec_id`) REFERENCES `contasrec` (`id`),
  CONSTRAINT `fk_contasrec_anexos_2` FOREIGN KEY (`titulos_tipo_anexo_id`) REFERENCES `titulos_tipo_anexo` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec_anexos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contasrec_baixas
DROP TABLE IF EXISTS `contasrec_baixas`;
CREATE TABLE IF NOT EXISTS `contasrec_baixas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contasrec_id` int NOT NULL,
  `conta_corrente_id` int NOT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `juros` double DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  `saldo_aberto` double NOT NULL,
  `saldo_apagar` double DEFAULT NULL,
  `multa` double DEFAULT NULL,
  `historico` text COLLATE utf8mb3_unicode_ci,
  `data_pagamento` date NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contasrec_baixas_1` (`contasrec_id`),
  KEY `fk_contasrec_baixas_2` (`conta_corrente_id`),
  CONSTRAINT `fk_contasrec_baixas_1` FOREIGN KEY (`contasrec_id`) REFERENCES `contasrec` (`id`),
  CONSTRAINT `fk_contasrec_baixas_2` FOREIGN KEY (`conta_corrente_id`) REFERENCES `conta_corrente` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec_baixas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contasrec_bloco
DROP TABLE IF EXISTS `contasrec_bloco`;
CREATE TABLE IF NOT EXISTS `contasrec_bloco` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cliente_id` int NOT NULL,
  `forma_pagamento_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `plano_conta_id` int NOT NULL,
  `centro_custo_id` int NOT NULL,
  `quantidade_parcelas` int NOT NULL,
  `primeiro_vencimento` date DEFAULT NULL,
  `valor` double DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `numero_documento` text COLLATE utf8mb3_unicode_ci,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_contasrec_bloco_1` (`cliente_id`),
  KEY `fk_contasrec_bloco_2` (`forma_pagamento_id`),
  KEY `fk_contasrec_bloco_3` (`system_unit_id`),
  KEY `fk_contasrec_bloco_4` (`plano_conta_id`),
  KEY `fk_contasrec_bloco_5` (`centro_custo_id`),
  CONSTRAINT `fk_contasrec_bloco_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_contasrec_bloco_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`),
  CONSTRAINT `fk_contasrec_bloco_3` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_contasrec_bloco_4` FOREIGN KEY (`plano_conta_id`) REFERENCES `plano_conta` (`id`),
  CONSTRAINT `fk_contasrec_bloco_5` FOREIGN KEY (`centro_custo_id`) REFERENCES `centro_custo` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec_bloco: ~1 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contasrec_historico_cobranca
DROP TABLE IF EXISTS `contasrec_historico_cobranca`;
CREATE TABLE IF NOT EXISTS `contasrec_historico_cobranca` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contasrec_id` int NOT NULL,
  `historico` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `data_cobranca` date NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contasrec_historico_cobranca_1` (`contasrec_id`),
  CONSTRAINT `fk_contasrec_historico_cobranca_1` FOREIGN KEY (`contasrec_id`) REFERENCES `contasrec` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec_historico_cobranca: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.contasrec_historico_venc
DROP TABLE IF EXISTS `contasrec_historico_venc`;
CREATE TABLE IF NOT EXISTS `contasrec_historico_venc` (
  `id` int NOT NULL AUTO_INCREMENT,
  `contasrec_id` int NOT NULL,
  `vencimento_anterior` date DEFAULT NULL,
  `vencimento_atual` date NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_contasrec_historico_venc_1` (`contasrec_id`),
  CONSTRAINT `fk_contasrec_historico_venc_1` FOREIGN KEY (`contasrec_id`) REFERENCES `contasrec` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec_historico_venc: ~0 rows (aproximadamente)
INSERT INTO `contasrec_historico_venc` (`id`, `contasrec_id`, `vencimento_anterior`, `vencimento_atual`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 1, NULL, '2024-06-03', '2024-06-02 22:31:28', NULL, NULL, 'Administrador', NULL),
	(2, 2, NULL, '2024-07-31', '2024-07-30 14:46:01', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.contasrec_origem
DROP TABLE IF EXISTS `contasrec_origem`;
CREATE TABLE IF NOT EXISTS `contasrec_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec_origem: ~2 rows (aproximadamente)
INSERT INTO `contasrec_origem` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Avulso', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Venda', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.contasrec_situacao
DROP TABLE IF EXISTS `contasrec_situacao`;
CREATE TABLE IF NOT EXISTS `contasrec_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.contasrec_situacao: ~4 rows (aproximadamente)
INSERT INTO `contasrec_situacao` (`id`, `descricao`, `cor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Em Aberto', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Pago Parcialmente', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Pago', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'Cancelado', NULL, NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.conta_corrente
DROP TABLE IF EXISTS `conta_corrente`;
CREATE TABLE IF NOT EXISTS `conta_corrente` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `banco_id` int DEFAULT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `agencia` text COLLATE utf8mb3_unicode_ci,
  `conta` text COLLATE utf8mb3_unicode_ci,
  `agencia_digito` text COLLATE utf8mb3_unicode_ci,
  `conta_digito` text COLLATE utf8mb3_unicode_ci,
  `end_logradouro` text COLLATE utf8mb3_unicode_ci,
  `end_bairro` text COLLATE utf8mb3_unicode_ci,
  `end_cidade` text COLLATE utf8mb3_unicode_ci,
  `end_estado` text COLLATE utf8mb3_unicode_ci,
  `end_cep` text COLLATE utf8mb3_unicode_ci,
  `end_numero` text COLLATE utf8mb3_unicode_ci,
  `boleto_convenio` text COLLATE utf8mb3_unicode_ci,
  `boleto_carteira` text COLLATE utf8mb3_unicode_ci,
  `boleto_gerar` tinyint(1) NOT NULL,
  `boleto_codigo_cedente` text COLLATE utf8mb3_unicode_ci,
  `boleto_digito_cod_cedente` text COLLATE utf8mb3_unicode_ci,
  `boleto_instrucoes` text COLLATE utf8mb3_unicode_ci,
  `boleto_multa` double DEFAULT NULL,
  `boleto_juros_dia` double DEFAULT NULL,
  `boleto_digitos_nosso_numero` int DEFAULT NULL,
  `boleto_local_pagamento` text COLLATE utf8mb3_unicode_ci,
  `boleto_codigo_transmissao` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_conta_corrente_1` (`banco_id`),
  KEY `fk_conta_corrente_2` (`system_unit_id`),
  CONSTRAINT `fk_conta_corrente_1` FOREIGN KEY (`banco_id`) REFERENCES `banco` (`id`),
  CONSTRAINT `fk_conta_corrente_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.conta_corrente: ~2 rows (aproximadamente)
INSERT INTO `conta_corrente` (`id`, `system_unit_id`, `banco_id`, `nome`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `agencia`, `conta`, `agencia_digito`, `conta_digito`, `end_logradouro`, `end_bairro`, `end_cidade`, `end_estado`, `end_cep`, `end_numero`, `boleto_convenio`, `boleto_carteira`, `boleto_gerar`, `boleto_codigo_cedente`, `boleto_digito_cod_cedente`, `boleto_instrucoes`, `boleto_multa`, `boleto_juros_dia`, `boleto_digitos_nosso_numero`, `boleto_local_pagamento`, `boleto_codigo_transmissao`) VALUES
	(1, 1, 1, 'Fernando Ferreira Gomes Nascimento', '2024-06-03 23:30:49', NULL, NULL, 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(2, 1, 1, 'CAIXA GERAL', '2024-06-03 23:31:11', NULL, NULL, 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.conta_corrente_lancamentos
DROP TABLE IF EXISTS `conta_corrente_lancamentos`;
CREATE TABLE IF NOT EXISTS `conta_corrente_lancamentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `conta_corrente_id` int NOT NULL,
  `conta_corrente_lanc_tipo_id` int NOT NULL,
  `conta_corrente_lanc_origem_id` int NOT NULL,
  `contaspag_baixas_id` int DEFAULT NULL,
  `contasrec_baixas_id` int DEFAULT NULL,
  `data_lancamento` date NOT NULL,
  `valor` double NOT NULL,
  `documento` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `historico` text COLLATE utf8mb3_unicode_ci,
  `plano_conta_id` int DEFAULT NULL,
  `centro_custo_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_conta_corrente_lancamentos_1` (`conta_corrente_id`),
  KEY `fk_conta_corrente_lancamentos_2` (`conta_corrente_lanc_tipo_id`),
  KEY `fk_conta_corrente_lancamentos_5` (`contaspag_baixas_id`),
  KEY `fk_conta_corrente_lancamentos_6` (`contasrec_baixas_id`),
  KEY `fk_conta_corrente_lancamentos_7` (`conta_corrente_lanc_origem_id`),
  CONSTRAINT `fk_conta_corrente_lancamentos_1` FOREIGN KEY (`conta_corrente_id`) REFERENCES `conta_corrente` (`id`),
  CONSTRAINT `fk_conta_corrente_lancamentos_2` FOREIGN KEY (`conta_corrente_lanc_tipo_id`) REFERENCES `conta_corrente_lanc_tipo` (`id`),
  CONSTRAINT `fk_conta_corrente_lancamentos_5` FOREIGN KEY (`contaspag_baixas_id`) REFERENCES `contaspag_baixas` (`id`),
  CONSTRAINT `fk_conta_corrente_lancamentos_6` FOREIGN KEY (`contasrec_baixas_id`) REFERENCES `contasrec_baixas` (`id`),
  CONSTRAINT `fk_conta_corrente_lancamentos_7` FOREIGN KEY (`conta_corrente_lanc_origem_id`) REFERENCES `conta_corrente_lanc_origem` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.conta_corrente_lancamentos: ~0 rows (aproximadamente)
INSERT INTO `conta_corrente_lancamentos` (`id`, `conta_corrente_id`, `conta_corrente_lanc_tipo_id`, `conta_corrente_lanc_origem_id`, `contaspag_baixas_id`, `contasrec_baixas_id`, `data_lancamento`, `valor`, `documento`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `historico`, `plano_conta_id`, `centro_custo_id`) VALUES
	(1, 2, 2, 1, NULL, NULL, '2024-06-03', 500, NULL, '2024-06-03 23:32:02', NULL, NULL, 'Administrador', NULL, 'DFDSFSDFSDF', 2, 4);

-- Copiando estrutura para tabela erp_nuvem.conta_corrente_lanc_origem
DROP TABLE IF EXISTS `conta_corrente_lanc_origem`;
CREATE TABLE IF NOT EXISTS `conta_corrente_lanc_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.conta_corrente_lanc_origem: ~4 rows (aproximadamente)
INSERT INTO `conta_corrente_lanc_origem` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Avulso', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Contas a Pagar', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Contas a Receber', NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'Caixa', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.conta_corrente_lanc_tipo
DROP TABLE IF EXISTS `conta_corrente_lanc_tipo`;
CREATE TABLE IF NOT EXISTS `conta_corrente_lanc_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.conta_corrente_lanc_tipo: ~2 rows (aproximadamente)
INSERT INTO `conta_corrente_lanc_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Débito', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Crédito', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.cst_cofins
DROP TABLE IF EXISTS `cst_cofins`;
CREATE TABLE IF NOT EXISTS `cst_cofins` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cst_numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cst_cofins: ~33 rows (aproximadamente)
INSERT INTO `cst_cofins` (`id`, `descricao`, `cst_numero`, `criado_em`, `alterado_em`) VALUES
	(1, 'COFINS 01 - Operação Tributável - Base de Cálculo = Valor da Operação Aliquota Normal (Cumulativo/Não Cumulativo)', '01', NULL, NULL),
	(2, 'COFINS 02 - Operação Tributável - Base de Cálculo = Valor da Operação (Aliquota Diferenciada)', '02', NULL, NULL),
	(3, 'COFINS 03 - Operação Tributável - Base de Cálculo = Quantidade Vendida x Aliquota por Unidade de Produto', '03', NULL, NULL),
	(4, 'COFINS 04 - Operação Tributável - Tributação Monofásica - (Aliquota Zero)', '04', NULL, NULL),
	(5, 'COFINS 05 - Operação Tributável (ST)', '05', NULL, NULL),
	(6, 'COFINS 06 - Operação Tributável - Aliquota Zero', '06', NULL, NULL),
	(7, 'COFINS 07 - Operação Isenta da Contribuição', '07', NULL, NULL),
	(8, 'COFINS 08 - Operação sem Incidência da Contribuição', '08', NULL, NULL),
	(9, 'COFINS 09 - Operação com Suspensão da Contribuição', '09', NULL, NULL),
	(10, 'COFINS 49 - Outras Operações de Saída', '49', NULL, NULL),
	(11, 'COFINS 50 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita Tributada no Mercado Interno', '50', NULL, NULL),
	(12, 'COFINS 51 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita e Não Tributada no Mercado Interno', '51', NULL, NULL),
	(13, 'COFINS 52 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita de Exportação', '52', NULL, NULL),
	(14, 'COFINS 53 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno', '53', NULL, NULL),
	(15, 'COFINS 54 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas no Mercado Interno e de Exportação', '54', NULL, NULL),
	(16, 'COFINS 55 - Operação com Direito a Crédito - Vinculada a Receitas Não-Tributadas no Mercado Interno e de Exportação', '55', NULL, NULL),
	(17, 'COFINS 56 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno, e de Exportação', '56', NULL, NULL),
	(18, 'COFINS 60 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receitas Tributada no Mercado Interno', '60', NULL, NULL),
	(19, 'COFINS 61 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receita Não-Tributada no Mercado Interno', '61', NULL, NULL),
	(20, 'COFINS 62 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receita de Exportação', '62', NULL, NULL),
	(21, 'COFINS 63 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno', '63', NULL, NULL),
	(22, 'COFINS 64 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas no Mercado Interno de Exportação', '64', NULL, NULL),
	(23, 'COFINS 65 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Não-Tributadas no Mercado Interno e de Exportação', '65', NULL, NULL),
	(24, 'COFINS 66 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno , e de Exportação', '66', NULL, NULL),
	(25, 'COFINS 67 - Crédito Presumido - Outras Operações', '67', NULL, NULL),
	(26, 'COFINS 70 - Operação de Aquisição sem Direito a Crédito', '70', NULL, NULL),
	(27, 'COFINS 71 - Operação de Aquisição com Isenção', '71', NULL, NULL),
	(28, 'COFINS 72 - Operação de Aquisição com Suspensão', '72', NULL, NULL),
	(29, 'COFINS 73 - Operação de Aquisição a Aliquota Zero', '73', NULL, NULL),
	(30, 'COFINS 74 - Operação de Aquisição sem Incidência da Contribuição', '74', NULL, NULL),
	(31, 'COFINS 75 - Operação de Aquisição por Substituição Tributária', '75', NULL, NULL),
	(32, 'COFINS 98 - Outras Operações de Entrada', '98', NULL, NULL),
	(33, 'COFINS 99 - Outras Operações', '99', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.cst_icms
DROP TABLE IF EXISTS `cst_icms`;
CREATE TABLE IF NOT EXISTS `cst_icms` (
  `id` int NOT NULL AUTO_INCREMENT,
  `regime_tributario_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cst_numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cst_icms_1` (`regime_tributario_id`),
  CONSTRAINT `fk_cst_icms_1` FOREIGN KEY (`regime_tributario_id`) REFERENCES `notafiscal_crt` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cst_icms: ~24 rows (aproximadamente)
INSERT INTO `cst_icms` (`id`, `regime_tributario_id`, `descricao`, `cst_numero`, `criado_em`, `alterado_em`) VALUES
	(1, 1, '101 - Tributada com permissão de crédito', '101', NULL, NULL),
	(2, 1, '102 - Tributada sem permissão de crédito', '102', NULL, NULL),
	(3, 1, '103 - Isenção do ICMS para faixa de receita bruta', '103', NULL, NULL),
	(4, 1, '201 - Tributada com permissão de crédito e cobrança do ICMS por ST', '201', NULL, NULL),
	(5, 1, '202 - Triburada sem permissão de crédito e cobrança do ICMS por ST', '202', NULL, NULL),
	(6, 1, '203 - Isenção do ICMS para faixa de receita bruta e com cobrança do ICMS por ST', '203', NULL, NULL),
	(7, 1, '300 - Imune', '300', NULL, NULL),
	(8, 1, '400 - Não tributada', '400', NULL, NULL),
	(9, 1, '500 - ICMS cobrado anteriormente por ST ou por antecipação', '500', NULL, NULL),
	(10, 1, '900 - Outros', '900', NULL, NULL),
	(11, 3, '00 - Tributada integralmente', '00', NULL, NULL),
	(12, 3, '10 - Tributada com cobrança do ICMS por ST', '10', NULL, NULL),
	(13, 3, '10 - Tributada com cobrança do ICMS por ST (com partilha do ICMS entre a UF de origem e a UF  de destino ou a UF definida na legislação', '10', NULL, NULL),
	(14, 3, '20 - Com redução da base de cálculo', '20', NULL, NULL),
	(15, 3, '30 - Isenta ou não trivutada e com cobrança do ICMS por ST', '30', NULL, NULL),
	(16, 3, '40 - Isenta', '40', NULL, NULL),
	(17, 3, '41 - Não tributada', '41', NULL, NULL),
	(18, 3, '41 - Não tributada (ICMSST devido para a UF de destino, nas operações interestaduais de produtos que tiveram retenção antecipada de ICMS por ST na UF do remetente)', '41', NULL, NULL),
	(19, 3, '50 - Suspensão', '50', NULL, NULL),
	(20, 3, '51 - Diferimento', '51', NULL, NULL),
	(21, 3, '60 - Cobrado anteriormente por ST', '60', NULL, NULL),
	(22, 3, '70 - Com redução de base de cálculo e cobrança do ICMS por ST', '70', NULL, NULL),
	(23, 3, '90 - Outras (com partilha do ICMS entre a UF de origem e a UF de  destino ou a UF definida na legislação', '90', NULL, NULL),
	(24, 3, '90 - Outras', '90', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.cst_ipi
DROP TABLE IF EXISTS `cst_ipi`;
CREATE TABLE IF NOT EXISTS `cst_ipi` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cst_numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cst_ipi: ~13 rows (aproximadamente)
INSERT INTO `cst_ipi` (`id`, `descricao`, `cst_numero`, `criado_em`, `alterado_em`) VALUES
	(1, 'IPI 00 - Entrada com recuperação de crédito', '00', NULL, NULL),
	(2, 'IPI 01 - Entrada tributada com aliquota zero', '01', NULL, NULL),
	(3, 'IPI 02 - Entrada isenta', '02', NULL, NULL),
	(4, 'IPI 03 - Entrada não-tributada', '03', NULL, NULL),
	(5, 'IPI 04 - Entrada imune', '04', NULL, NULL),
	(6, 'IPI 49 - Outras entradas', '49', NULL, NULL),
	(7, 'IPI 50 - Saída tributada', '50', NULL, NULL),
	(8, 'IPI 51 - Saída tributada com aliquota zero', '51', NULL, NULL),
	(9, 'IPI 52 - Saída isenta', '52', NULL, NULL),
	(10, 'IPI 53 - Saída não-tributada', '53', NULL, NULL),
	(11, 'IPI 54 - Saída imune', '54', NULL, NULL),
	(12, 'IPI 55 - Saída com suspensão', '55', NULL, NULL),
	(13, 'IPI 99 - Outras saídas', '99', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.cst_pis
DROP TABLE IF EXISTS `cst_pis`;
CREATE TABLE IF NOT EXISTS `cst_pis` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cst_numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.cst_pis: ~33 rows (aproximadamente)
INSERT INTO `cst_pis` (`id`, `descricao`, `cst_numero`, `criado_em`, `alterado_em`) VALUES
	(1, 'PIS 01 - Operação Tributável - Base de Cálculo = Valor da Operação Aliquota Normal (Cumulativo/Não Cumulativo)', '01', NULL, NULL),
	(2, 'PIS 02 - Operação Tributável - Base de Cálculo = Valor da Operação (Aliquota Diferenciada)', '02', NULL, NULL),
	(3, 'PIS 03 - Operação Tributável - Base de Cálculo = Quantidade Vendida x Aliquota por Unidade de Produto', '03', NULL, NULL),
	(4, 'PIS 04 - Operação Tributável - Tributação Monofásica - (Aliquota Zero)', '04', NULL, NULL),
	(5, 'PIS 05 - Operação Tributável (ST)', '05', NULL, NULL),
	(6, 'PIS 06 - Operação Tributável - Aliquota Zero', '06', NULL, NULL),
	(7, 'PIS 07 - Operação Isenta da Contribuição', '07', NULL, NULL),
	(8, 'PIS 08 - Operação sem Incidência da Contribuição', '08', NULL, NULL),
	(9, 'PIS 09 - Operação com Suspensão da Contribuição', '09', NULL, NULL),
	(10, 'PIS 49 - Outras Operações de Saída', '49', NULL, NULL),
	(11, 'PIS 50 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita Tributada no Mercado Interno', '50', NULL, NULL),
	(12, 'PIS 51 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita e Não Tributada no Mercado Interno', '51', NULL, NULL),
	(13, 'PIS 52 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita de Exportação', '52', NULL, NULL),
	(14, 'PIS 53 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno', '53', NULL, NULL),
	(15, 'PIS 54 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas no Mercado Interno e de Exportação', '54', NULL, NULL),
	(16, 'PIS 55 - Operação com Direito a Crédito - Vinculada a Receitas Não-Tributadas no Mercado Interno e de Exportação', '55', NULL, NULL),
	(17, 'PIS 56 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno, e de Exportação', '56', NULL, NULL),
	(18, 'PIS 60 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receitas Tributada no Mercado Interno', '60', NULL, NULL),
	(19, 'PIS 61 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receita Não-Tributada no Mercado Interno', '61', NULL, NULL),
	(20, 'PIS 62 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receita de Exportação', '62', NULL, NULL),
	(21, 'PIS 63 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno', '63', NULL, NULL),
	(22, 'PIS 64 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas no Mercado Interno de Exportação', '64', NULL, NULL),
	(23, 'PIS 65 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Não-Tributadas no Mercado Interno e de Exportação', '65', NULL, NULL),
	(24, 'PIS 66 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno , e de Exportação', '66', NULL, NULL),
	(25, 'PIS 67 - Crédito Presumido - Outras Operações', '67', NULL, NULL),
	(26, 'PIS 70 - Operação de Aquisição sem Direito a Crédito', '70', NULL, NULL),
	(27, 'PIS 71 - Operação de Aquisição com Isenção', '71', NULL, NULL),
	(28, 'PIS 72 - Operação de Aquisição com Suspensão', '72', NULL, NULL),
	(29, 'PIS 73 - Operação de Aquisição a Aliquota Zero', '73', NULL, NULL),
	(30, 'PIS 74 - Operação de Aquisição sem Incidência da Contribuição', '74', NULL, NULL),
	(31, 'PIS 75 - Operação de Aquisição por Substituição Tributária', '75', NULL, NULL),
	(32, 'PIS 98 - Outras Operações de Entrada', '98', NULL, NULL),
	(33, 'PIS 99 - Outras Operações', '99', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.despesas_servicos
DROP TABLE IF EXISTS `despesas_servicos`;
CREATE TABLE IF NOT EXISTS `despesas_servicos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `despesas_servicos_tipo_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_despesas_servicos_1` (`despesas_servicos_tipo_id`),
  CONSTRAINT `fk_despesas_servicos_1` FOREIGN KEY (`despesas_servicos_tipo_id`) REFERENCES `despesas_servicos_tipo` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.despesas_servicos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.despesas_servicos_tipo
DROP TABLE IF EXISTS `despesas_servicos_tipo`;
CREATE TABLE IF NOT EXISTS `despesas_servicos_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.despesas_servicos_tipo: ~2 rows (aproximadamente)
INSERT INTO `despesas_servicos_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Valor Definido', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Percentual sobre valor do serviço', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.dispositivos
DROP TABLE IF EXISTS `dispositivos`;
CREATE TABLE IF NOT EXISTS `dispositivos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `token` varchar(100) COLLATE utf8mb3_unicode_ci NOT NULL,
  `serial_dispositivo` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `deletado_em` datetime DEFAULT NULL,
  `data_hora_ultima_sincronizacao` datetime DEFAULT NULL,
  `ip_sincronizacao` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  UNIQUE KEY `token` (`token`),
  KEY `fk_dispositivos_1` (`system_unit_id`),
  CONSTRAINT `fk_dispositivos_1` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.dispositivos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.email_template
DROP TABLE IF EXISTS `email_template`;
CREATE TABLE IF NOT EXISTS `email_template` (
  `id` int NOT NULL AUTO_INCREMENT,
  `titulo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `mensagem` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.email_template: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.estado
DROP TABLE IF EXISTS `estado`;
CREATE TABLE IF NOT EXISTS `estado` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `sigla` char(2) COLLATE utf8mb3_unicode_ci NOT NULL,
  `codigo_ibge` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estado: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.estoque_deposito
DROP TABLE IF EXISTS `estoque_deposito`;
CREATE TABLE IF NOT EXISTS `estoque_deposito` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_estoque_deposito_1` (`system_unit_id`),
  CONSTRAINT `fk_estoque_deposito_1` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_deposito: ~0 rows (aproximadamente)
INSERT INTO `estoque_deposito` (`id`, `system_unit_id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 1, 'LOJA', NULL, NULL, 'Administrador', 'Sistema Kraft', '2024-03-31 09:48:49'),
	(2, 1, 'DEPOSITO', '2024-03-31 09:48:38', NULL, 'Administrador', 'Administrador', '2024-03-31 09:49:00');

-- Copiando estrutura para tabela erp_nuvem.estoque_estante
DROP TABLE IF EXISTS `estoque_estante`;
CREATE TABLE IF NOT EXISTS `estoque_estante` (
  `id` int NOT NULL AUTO_INCREMENT,
  `estoque_rua_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_estoque_estante_1` (`estoque_rua_id`),
  CONSTRAINT `fk_estoque_estante_1` FOREIGN KEY (`estoque_rua_id`) REFERENCES `estoque_rua` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_estante: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.estoque_lancamentos
DROP TABLE IF EXISTS `estoque_lancamentos`;
CREATE TABLE IF NOT EXISTS `estoque_lancamentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_id` int NOT NULL,
  `estoque_origem_id` int NOT NULL,
  `estoque_tipo_movimentacao_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `estoque_deposito_id` int NOT NULL,
  `produto_lote_id` int DEFAULT NULL,
  `venda_id` int DEFAULT NULL,
  `nota_fiscal_compra_id` int DEFAULT NULL,
  `ordem_producao_id` int DEFAULT NULL,
  `quantidade` double NOT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `preco_venda` double DEFAULT NULL,
  `preco_custo` double DEFAULT NULL,
  `data_lancamento` date NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_estoque_lancamentos_1` (`estoque_origem_id`),
  KEY `fk_estoque_lancamentos_2` (`estoque_tipo_movimentacao_id`),
  KEY `fk_estoque_lancamentos_3` (`system_unit_id`),
  KEY `fk_estoque_lancamentos_4` (`venda_id`),
  KEY `fk_estoque_lancamentos_5` (`produto_id`),
  KEY `fk_estoque_lancamentos_6` (`produto_lote_id`),
  KEY `fk_estoque_lancamentos_7` (`estoque_deposito_id`),
  KEY `fk_estoque_lancamentos_8` (`nota_fiscal_compra_id`),
  KEY `fk_estoque_lancamentos_9` (`ordem_producao_id`),
  CONSTRAINT `fk_estoque_lancamentos_1` FOREIGN KEY (`estoque_origem_id`) REFERENCES `estoque_origem` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_2` FOREIGN KEY (`estoque_tipo_movimentacao_id`) REFERENCES `estoque_tipo_movimentacao` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_3` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_4` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_5` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_6` FOREIGN KEY (`produto_lote_id`) REFERENCES `produto_lote` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_7` FOREIGN KEY (`estoque_deposito_id`) REFERENCES `estoque_deposito` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_8` FOREIGN KEY (`nota_fiscal_compra_id`) REFERENCES `nota_fiscal_compra` (`id`),
  CONSTRAINT `fk_estoque_lancamentos_9` FOREIGN KEY (`ordem_producao_id`) REFERENCES `ordem_producao` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_lancamentos: ~2 rows (aproximadamente)
INSERT INTO `estoque_lancamentos` (`id`, `produto_id`, `estoque_origem_id`, `estoque_tipo_movimentacao_id`, `system_unit_id`, `estoque_deposito_id`, `produto_lote_id`, `venda_id`, `nota_fiscal_compra_id`, `ordem_producao_id`, `quantidade`, `observacao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `preco_venda`, `preco_custo`, `data_lancamento`) VALUES
	(7, 5, 3, 1, 1, 1, NULL, NULL, 5, NULL, 1, 'Entrada de nota fiscal de compra Id: 5', '2024-03-30 22:57:57', NULL, NULL, 'Administrador', NULL, 0, 950, '2024-03-30'),
	(8, 5, 1, 1, 1, 2, NULL, NULL, NULL, NULL, 5, 'CONTAGEM DE ESTOQUE', '2024-03-31 09:50:47', NULL, NULL, 'Administrador', NULL, 950, NULL, '2024-03-31'),
	(9, 8, 1, 1, 1, 2, NULL, NULL, NULL, NULL, 50, 'hfhfghfghfghfg', '2024-04-19 15:38:55', NULL, NULL, 'Administrador', NULL, 0, NULL, '2024-04-19');

-- Copiando estrutura para tabela erp_nuvem.estoque_origem
DROP TABLE IF EXISTS `estoque_origem`;
CREATE TABLE IF NOT EXISTS `estoque_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `estoque_tipo_movimentacao_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_estoque_origem_1` (`estoque_tipo_movimentacao_id`),
  CONSTRAINT `fk_estoque_origem_1` FOREIGN KEY (`estoque_tipo_movimentacao_id`) REFERENCES `estoque_tipo_movimentacao` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_origem: ~13 rows (aproximadamente)
INSERT INTO `estoque_origem` (`id`, `estoque_tipo_movimentacao_id`, `descricao`, `criado_em`, `alterado_em`) VALUES
	(1, 1, 'Entrada Avulsa', NULL, NULL),
	(2, 2, 'Saída Avulsa', NULL, NULL),
	(3, 1, 'Compras', NULL, NULL),
	(4, 2, 'Devolução de Compra', NULL, NULL),
	(5, 1, 'Produção Acabados', NULL, NULL),
	(6, 2, 'Vendas', NULL, NULL),
	(7, 1, 'Devolução de Venda', NULL, NULL),
	(8, 1, 'Estorno de Venda', NULL, NULL),
	(9, 2, 'Produção Matérias Primas', NULL, NULL),
	(10, 1, 'Inventario Entrada', NULL, NULL),
	(11, 2, 'Inventario Saida', NULL, NULL),
	(12, 4, 'Retorno de Reserva', NULL, NULL),
	(13, 3, 'Reserva de Saldo', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.estoque_prateleira
DROP TABLE IF EXISTS `estoque_prateleira`;
CREATE TABLE IF NOT EXISTS `estoque_prateleira` (
  `id` int NOT NULL AUTO_INCREMENT,
  `estoque_estante_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_estoque_prateleira_1` (`estoque_estante_id`),
  CONSTRAINT `fk_estoque_prateleira_1` FOREIGN KEY (`estoque_estante_id`) REFERENCES `estoque_estante` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_prateleira: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.estoque_rua
DROP TABLE IF EXISTS `estoque_rua`;
CREATE TABLE IF NOT EXISTS `estoque_rua` (
  `id` int NOT NULL AUTO_INCREMENT,
  `estoque_deposito_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_estoque_rua_1` (`estoque_deposito_id`),
  CONSTRAINT `fk_estoque_rua_1` FOREIGN KEY (`estoque_deposito_id`) REFERENCES `estoque_deposito` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_rua: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.estoque_saldos
DROP TABLE IF EXISTS `estoque_saldos`;
CREATE TABLE IF NOT EXISTS `estoque_saldos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `estoque_deposito_id` int NOT NULL,
  `produto_lote_id` int DEFAULT NULL,
  `quant_disponivel` double NOT NULL,
  `quant_reservada` double DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `preco_medio_venda` double DEFAULT NULL,
  `preco_medio_custo` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_estoque_saldos_1` (`produto_id`),
  KEY `fk_estoque_saldos_2` (`system_unit_id`),
  KEY `fk_estoque_saldos_3` (`produto_lote_id`),
  KEY `fk_estoque_saldos_4` (`estoque_deposito_id`),
  CONSTRAINT `fk_estoque_saldos_1` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_estoque_saldos_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_estoque_saldos_3` FOREIGN KEY (`produto_lote_id`) REFERENCES `produto_lote` (`id`),
  CONSTRAINT `fk_estoque_saldos_4` FOREIGN KEY (`estoque_deposito_id`) REFERENCES `estoque_deposito` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_saldos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.estoque_tipo_movimentacao
DROP TABLE IF EXISTS `estoque_tipo_movimentacao`;
CREATE TABLE IF NOT EXISTS `estoque_tipo_movimentacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.estoque_tipo_movimentacao: ~4 rows (aproximadamente)
INSERT INTO `estoque_tipo_movimentacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Entrada', NULL, NULL, '', '', NULL),
	(2, 'Saída', NULL, NULL, '', '', NULL),
	(3, 'Entrada Reserva', NULL, NULL, '', '', NULL),
	(4, 'Saída Reserva', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.eventos
DROP TABLE IF EXISTS `eventos`;
CREATE TABLE IF NOT EXISTS `eventos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_program_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `email_template_id` int DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_eventos_1` (`email_template_id`),
  KEY `fk_eventos_2` (`system_program_id`),
  CONSTRAINT `fk_eventos_1` FOREIGN KEY (`email_template_id`) REFERENCES `email_template` (`id`),
  CONSTRAINT `fk_eventos_2` FOREIGN KEY (`system_program_id`) REFERENCES `system_program` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.eventos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.eventos_documentos
DROP TABLE IF EXISTS `eventos_documentos`;
CREATE TABLE IF NOT EXISTS `eventos_documentos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int DEFAULT NULL,
  `system_users_id` int DEFAULT NULL,
  `system_unit_id` int DEFAULT NULL,
  `cstat` int DEFAULT NULL,
  `xmotivo` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `xevento` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `tpevento` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `nseqevento` int DEFAULT NULL,
  `dhregevento` datetime DEFAULT NULL,
  `nprot` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `origem_event` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `mensagem_manual` text COLLATE utf8mb3_unicode_ci,
  `tpamb` int DEFAULT NULL,
  `veraplic` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `chnfe` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `dhrecbto` datetime DEFAULT NULL,
  `digval` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `xml` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.eventos_documentos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.eventos_systemuser
DROP TABLE IF EXISTS `eventos_systemuser`;
CREATE TABLE IF NOT EXISTS `eventos_systemuser` (
  `id` int NOT NULL AUTO_INCREMENT,
  `eventos_id` int NOT NULL,
  `system_users_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `enviar_email` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_eventos_systemuser_2` (`system_users_id`),
  KEY `fk_eventos_systemuser_1` (`eventos_id`),
  KEY `fk_eventos_systemuser_3` (`system_unit_id`),
  CONSTRAINT `fk_eventos_systemuser_1` FOREIGN KEY (`eventos_id`) REFERENCES `eventos` (`id`),
  CONSTRAINT `fk_eventos_systemuser_2` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_eventos_systemuser_3` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.eventos_systemuser: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.formapgto_condpgto
DROP TABLE IF EXISTS `formapgto_condpgto`;
CREATE TABLE IF NOT EXISTS `formapgto_condpgto` (
  `id` int NOT NULL AUTO_INCREMENT,
  `condicao_pagamento_id` int NOT NULL,
  `forma_pagamento_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_formapgto_condpgto_1` (`condicao_pagamento_id`),
  KEY `fk_formapgto_condpgto_2` (`forma_pagamento_id`),
  CONSTRAINT `fk_formapgto_condpgto_1` FOREIGN KEY (`condicao_pagamento_id`) REFERENCES `condicao_pagamento` (`id`),
  CONSTRAINT `fk_formapgto_condpgto_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.formapgto_condpgto: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.forma_pagamento
DROP TABLE IF EXISTS `forma_pagamento`;
CREATE TABLE IF NOT EXISTS `forma_pagamento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `codigo_interno` int NOT NULL,
  `tipo_documento_id` int NOT NULL,
  `meio_pagamento_tef_id` int DEFAULT NULL,
  `notafiscal_tpag_id` int DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `prazo_pagamento` int DEFAULT NULL,
  `taxa` double DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `utiliza_pdv` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `obriga_nf_pdv` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_forma_pagamento_1` (`tipo_documento_id`),
  KEY `fk_forma_pagamento_3` (`meio_pagamento_tef_id`),
  KEY `fk_forma_pagamento_4` (`notafiscal_tpag_id`),
  CONSTRAINT `fk_forma_pagamento_1` FOREIGN KEY (`tipo_documento_id`) REFERENCES `tipo_documento` (`id`),
  CONSTRAINT `fk_forma_pagamento_3` FOREIGN KEY (`meio_pagamento_tef_id`) REFERENCES `meio_pagamento_tef` (`id`),
  CONSTRAINT `fk_forma_pagamento_4` FOREIGN KEY (`notafiscal_tpag_id`) REFERENCES `notafiscal_tpag` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.forma_pagamento: ~2 rows (aproximadamente)
INSERT INTO `forma_pagamento` (`id`, `codigo_interno`, `tipo_documento_id`, `meio_pagamento_tef_id`, `notafiscal_tpag_id`, `descricao`, `prazo_pagamento`, `taxa`, `deletado_em`, `criado_em`, `alterado_em`, `criado_por`, `alterado_por`, `utiliza_pdv`, `obriga_nf_pdv`) VALUES
	(1, 1, 4, NULL, 1, 'DINHEIRO', NULL, NULL, NULL, '2024-03-30 23:17:25', NULL, 'Administrador', NULL, 'S', NULL),
	(2, 2, 4, NULL, 10, 'BOLETO', 30, NULL, NULL, '2024-03-31 09:36:54', NULL, 'Administrador', NULL, 'S', 'N');

-- Copiando estrutura para tabela erp_nuvem.fornecedor
DROP TABLE IF EXISTS `fornecedor`;
CREATE TABLE IF NOT EXISTS `fornecedor` (
  `id` int NOT NULL AUTO_INCREMENT,
  `pessoa_tipo_id` int NOT NULL,
  `fornecedor_classificacao_id` int DEFAULT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `insc_estadual` text COLLATE utf8mb3_unicode_ci,
  `insc_municipal` text COLLATE utf8mb3_unicode_ci,
  `cpf_cnpj` text COLLATE utf8mb3_unicode_ci,
  `razao_social` text COLLATE utf8mb3_unicode_ci,
  `logradouro` text COLLATE utf8mb3_unicode_ci,
  `cidade_id` int DEFAULT NULL,
  `bairro` text COLLATE utf8mb3_unicode_ci,
  `cep` text COLLATE utf8mb3_unicode_ci,
  `numero` text COLLATE utf8mb3_unicode_ci,
  `complemento` text COLLATE utf8mb3_unicode_ci,
  `fone` text COLLATE utf8mb3_unicode_ci,
  `email` text COLLATE utf8mb3_unicode_ci,
  `site` text COLLATE utf8mb3_unicode_ci,
  `observacoes` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_crt_id` int DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `notafiscal_indiedest_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_fornecedor_4` (`fornecedor_classificacao_id`),
  KEY `fk_fornecedor_1` (`pessoa_tipo_id`),
  KEY `fk_fornecedor_3` (`cidade_id`),
  KEY `fk_fornecedor_5` (`notafiscal_indiedest_id`),
  CONSTRAINT `fk_fornecedor_1` FOREIGN KEY (`pessoa_tipo_id`) REFERENCES `pessoa_tipo` (`id`),
  CONSTRAINT `fk_fornecedor_3` FOREIGN KEY (`cidade_id`) REFERENCES `cidade` (`id`),
  CONSTRAINT `fk_fornecedor_4` FOREIGN KEY (`fornecedor_classificacao_id`) REFERENCES `fornecedor_classificacao` (`id`),
  CONSTRAINT `fk_fornecedor_5` FOREIGN KEY (`notafiscal_indiedest_id`) REFERENCES `notafiscal_indiedest` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.fornecedor: ~0 rows (aproximadamente)
INSERT INTO `fornecedor` (`id`, `pessoa_tipo_id`, `fornecedor_classificacao_id`, `nome`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`, `insc_estadual`, `insc_municipal`, `cpf_cnpj`, `razao_social`, `logradouro`, `cidade_id`, `bairro`, `cep`, `numero`, `complemento`, `fone`, `email`, `site`, `observacoes`, `notafiscal_crt_id`, `deletado_em`, `notafiscal_indiedest_id`) VALUES
	(1, 2, NULL, 'SH PECAS E SERVICOS MECANICOS LTDA', '2024-03-30 15:00:09', NULL, 'Administrador', NULL, '158478622', NULL, '37.961.074/0001-02', 'SH PECAS E SERVICOS MECANICOS LTDA', 'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B', NULL, 'PARQUE MARAJO', '68473000', 'S/N', NULL, '96984206564', NULL, NULL, NULL, NULL, NULL, NULL),
	(2, 2, NULL, 'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A', '2024-04-19 15:35:45', NULL, 'Administrador', NULL, '0020488295661', NULL, '04.641.376/0159-15', 'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A', 'AV UM LOTE 10 QUAD 8', NULL, 'LOTEAMENTO RESIDENCIAL PARK SUL', '39390000', '48', NULL, '3131172600', NULL, NULL, NULL, NULL, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.fornecedor_classificacao
DROP TABLE IF EXISTS `fornecedor_classificacao`;
CREATE TABLE IF NOT EXISTS `fornecedor_classificacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `ativo_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_fornecedor_classificacao_1` (`ativo_id`),
  CONSTRAINT `fk_fornecedor_classificacao_1` FOREIGN KEY (`ativo_id`) REFERENCES `ativo` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.fornecedor_classificacao: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.fornecedor_contato
DROP TABLE IF EXISTS `fornecedor_contato`;
CREATE TABLE IF NOT EXISTS `fornecedor_contato` (
  `id` int NOT NULL AUTO_INCREMENT,
  `fornecedor_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `tipo_contato` text COLLATE utf8mb3_unicode_ci,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `fone` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_fornecedor_contato_1` (`fornecedor_id`),
  CONSTRAINT `fk_fornecedor_contato_1` FOREIGN KEY (`fornecedor_id`) REFERENCES `fornecedor` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.fornecedor_contato: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.funcionario
DROP TABLE IF EXISTS `funcionario`;
CREATE TABLE IF NOT EXISTS `funcionario` (
  `id` int NOT NULL AUTO_INCREMENT,
  `funcionario_cargo_id` int DEFAULT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cpf` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `valor_salario` double DEFAULT NULL,
  `valor_hora` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_funcionario_1` (`funcionario_cargo_id`),
  CONSTRAINT `fk_funcionario_1` FOREIGN KEY (`funcionario_cargo_id`) REFERENCES `funcionario_cargo` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.funcionario: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.funcionario_cargo
DROP TABLE IF EXISTS `funcionario_cargo`;
CREATE TABLE IF NOT EXISTS `funcionario_cargo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.funcionario_cargo: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.funil
DROP TABLE IF EXISTS `funil`;
CREATE TABLE IF NOT EXISTS `funil` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.funil: ~0 rows (aproximadamente)
INSERT INTO `funil` (`id`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`, `deletado_em`) VALUES
	(1, 'LOJA', '2024-06-04 01:25:12', NULL, 'Administrador', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.funil_etapas
DROP TABLE IF EXISTS `funil_etapas`;
CREATE TABLE IF NOT EXISTS `funil_etapas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `funil_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `numero_etapa` int NOT NULL,
  `cor_etapa` text COLLATE utf8mb3_unicode_ci,
  `cor_negocio` text COLLATE utf8mb3_unicode_ci,
  `ultima_etapa` int DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `permite_edicao` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `permite_exclusao` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `kanban` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `etapa_ganha` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `etapa_perde` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_funil_etapas_1` (`funil_id`),
  KEY `fk_funil_etapas_2` (`ultima_etapa`),
  CONSTRAINT `fk_funil_etapas_1` FOREIGN KEY (`funil_id`) REFERENCES `funil` (`id`),
  CONSTRAINT `fk_funil_etapas_2` FOREIGN KEY (`ultima_etapa`) REFERENCES `resposta` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.funil_etapas: ~0 rows (aproximadamente)
INSERT INTO `funil_etapas` (`id`, `funil_id`, `descricao`, `numero_etapa`, `cor_etapa`, `cor_negocio`, `ultima_etapa`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`, `permite_edicao`, `permite_exclusao`, `kanban`, `etapa_ganha`, `etapa_perde`) VALUES
	(1, 1, 'GERAL', 1, '#9C27B0', '#2196F3', NULL, '2024-06-04 01:25:12', NULL, NULL, NULL, 'S', 'S', 'S', 'S', 'S');

-- Copiando estrutura para tabela erp_nuvem.indicador_personalizado
DROP TABLE IF EXISTS `indicador_personalizado`;
CREATE TABLE IF NOT EXISTS `indicador_personalizado` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `url_indicador` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.indicador_personalizado: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.integradores
DROP TABLE IF EXISTS `integradores`;
CREATE TABLE IF NOT EXISTS `integradores` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.integradores: ~2 rows (aproximadamente)
INSERT INTO `integradores` (`id`, `nome`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Cloud-DFe', NULL, '', '', NULL),
	(2, 'Nuvem Fiscal', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.integradores_servicos
DROP TABLE IF EXISTS `integradores_servicos`;
CREATE TABLE IF NOT EXISTS `integradores_servicos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `integradores_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_integradores_servicos_1` (`integradores_id`),
  CONSTRAINT `fk_integradores_servicos_1` FOREIGN KEY (`integradores_id`) REFERENCES `integradores` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.integradores_servicos: ~3 rows (aproximadamente)
INSERT INTO `integradores_servicos` (`id`, `integradores_id`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 1, 'NF-e', NULL, '', '', NULL),
	(2, 1, 'NFC-e', NULL, '', '', NULL),
	(3, 1, 'MDF-e', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.inutilizar_numero
DROP TABLE IF EXISTS `inutilizar_numero`;
CREATE TABLE IF NOT EXISTS `inutilizar_numero` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created_at` datetime DEFAULT NULL,
  `system_user` int DEFAULT NULL,
  `update_at` datetime DEFAULT NULL,
  `deleted_at` datetime DEFAULT NULL,
  `ninicio` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `nfinal` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `serie` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `system_unit_id` int DEFAULT NULL,
  `system_users_id` int DEFAULT NULL,
  `xml_retorno` text COLLATE utf8mb3_unicode_ci,
  `protocolo` varchar(50) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `xmotivo` varchar(200) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `cstat` int DEFAULT NULL,
  `notafiscal_id` int DEFAULT NULL,
  `xjust` varchar(150) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `tipo` int NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `fk_inutilizar_numero_1` (`system_unit_id`),
  KEY `fk_inutilizar_numero_2` (`system_users_id`),
  CONSTRAINT `fk_inutilizar_numero_1` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_inutilizar_numero_2` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.inutilizar_numero: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe
DROP TABLE IF EXISTS `mdfe`;
CREATE TABLE IF NOT EXISTS `mdfe` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `idmdfe` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `chMDF` text COLLATE utf8mb3_unicode_ci,
  `nProt` text COLLATE utf8mb3_unicode_ci,
  `cStat` text COLLATE utf8mb3_unicode_ci,
  `mdfe_tpemit_id` int NOT NULL,
  `mdfe_tpprop_id` int NOT NULL,
  `mdfe_tptransp_id` int DEFAULT NULL,
  `mdfe_tpcar_id` int NOT NULL,
  `nMDF` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `serie` text COLLATE utf8mb3_unicode_ci,
  `dhEmi` datetime DEFAULT NULL,
  `UFIni` int NOT NULL,
  `UFFim` int NOT NULL,
  `dhIniViagem` datetime DEFAULT NULL,
  `indCanalVerde` int NOT NULL,
  `indCarregaPosterior` int NOT NULL,
  `infAdFisco` text COLLATE utf8mb3_unicode_ci,
  `infCpl` text COLLATE utf8mb3_unicode_ci,
  `mdfe_respSeg_id` int DEFAULT NULL,
  `seguro_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `seguradora_xSeg` text COLLATE utf8mb3_unicode_ci,
  `seguradora_cnpj` text COLLATE utf8mb3_unicode_ci,
  `vCarga` double DEFAULT NULL,
  `mdfe_cunid_id` int NOT NULL,
  `qCarga` double DEFAULT NULL,
  `mdfe_tpcarga_id` int DEFAULT NULL,
  `prod_xProd` text COLLATE utf8mb3_unicode_ci,
  `prod_cEAN` text COLLATE utf8mb3_unicode_ci,
  `prod_NCM` text COLLATE utf8mb3_unicode_ci,
  `pgto_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `pgto_idEstrangeiro` text COLLATE utf8mb3_unicode_ci,
  `pgto_xNome` text COLLATE utf8mb3_unicode_ci,
  `pgto_vContrato` double DEFAULT NULL,
  `pgto_indAltoDesemp` text COLLATE utf8mb3_unicode_ci,
  `mdfe_indpag_id` int DEFAULT NULL,
  `pgto_vAdiant` double DEFAULT NULL,
  `indAntecipaAdiant` int DEFAULT NULL,
  `pgto_codBanco` text COLLATE utf8mb3_unicode_ci,
  `pgto_codAgencia` text COLLATE utf8mb3_unicode_ci,
  `pgto_CNPJIPEF` text COLLATE utf8mb3_unicode_ci,
  `pgto_PIX` text COLLATE utf8mb3_unicode_ci,
  `veic_rntrc` text COLLATE utf8mb3_unicode_ci,
  `mdfe_tpRod_id` int NOT NULL,
  `veic_estado_id` int NOT NULL,
  `veic_cint` int DEFAULT NULL,
  `veic_placa` text COLLATE utf8mb3_unicode_ci,
  `veic_renavam` text COLLATE utf8mb3_unicode_ci,
  `veic_tara` double DEFAULT NULL,
  `justificativa_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `mensagem_sefaz` text COLLATE utf8mb3_unicode_ci,
  `status` text COLLATE utf8mb3_unicode_ci,
  `data_hora_envio` datetime DEFAULT NULL,
  `protocolo_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `datahora_cancelamento` datetime DEFAULT NULL,
  `veiculo_id` int NOT NULL,
  `mdfe_situacao_id` int NOT NULL,
  `mdfe_tpamb_id` int NOT NULL,
  `api_documentos_id` int DEFAULT NULL,
  `xml_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `xml` text COLLATE utf8mb3_unicode_ci,
  `cidade_encerramento_id` int DEFAULT NULL,
  `cmunencerramento` int DEFAULT NULL,
  `data_encerramento` date DEFAULT NULL,
  `datahora_encerramento` datetime DEFAULT NULL,
  `protocolo_encerramento` text COLLATE utf8mb3_unicode_ci,
  `xml_encerramento` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_1` (`mdfe_tpemit_id`),
  KEY `fk_mdfe_2` (`mdfe_tpprop_id`),
  KEY `fk_mdfe_4` (`mdfe_tptransp_id`),
  KEY `fk_mdfe_5` (`mdfe_tpcar_id`),
  KEY `fk_mdfe_6` (`UFIni`),
  KEY `fk_mdfe_7` (`UFFim`),
  KEY `fk_mdfe_8` (`indCanalVerde`),
  KEY `fk_mdfe_9` (`indCarregaPosterior`),
  KEY `fk_mdfe_10` (`mdfe_respSeg_id`),
  KEY `fk_mdfe_11` (`mdfe_cunid_id`),
  KEY `fk_mdfe_12` (`mdfe_tpcarga_id`),
  KEY `fk_mdfe_13` (`mdfe_indpag_id`),
  KEY `fk_mdfe_14` (`indAntecipaAdiant`),
  KEY `fk_mdfe_15` (`mdfe_tpRod_id`),
  KEY `fk_mdfe_17` (`veiculo_id`),
  KEY `fk_mdfe_16` (`system_unit_id`),
  KEY `fk_mdfe_18` (`mdfe_situacao_id`),
  KEY `fk_mdfe_19` (`mdfe_tpamb_id`),
  KEY `fk_mdfe_20` (`api_documentos_id`),
  KEY `fk_mdfe_21` (`cidade_encerramento_id`),
  CONSTRAINT `fk_mdfe_1` FOREIGN KEY (`mdfe_tpemit_id`) REFERENCES `mdfe_tpemit` (`id`),
  CONSTRAINT `fk_mdfe_10` FOREIGN KEY (`mdfe_respSeg_id`) REFERENCES `mdfe_respseg` (`id`),
  CONSTRAINT `fk_mdfe_11` FOREIGN KEY (`mdfe_cunid_id`) REFERENCES `mdfe_cunid` (`id`),
  CONSTRAINT `fk_mdfe_12` FOREIGN KEY (`mdfe_tpcarga_id`) REFERENCES `mdfe_tpcarga` (`id`),
  CONSTRAINT `fk_mdfe_13` FOREIGN KEY (`mdfe_indpag_id`) REFERENCES `mdfe_indpag` (`id`),
  CONSTRAINT `fk_mdfe_14` FOREIGN KEY (`indAntecipaAdiant`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_mdfe_15` FOREIGN KEY (`mdfe_tpRod_id`) REFERENCES `mdfe_tprod` (`id`),
  CONSTRAINT `fk_mdfe_16` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_mdfe_17` FOREIGN KEY (`veiculo_id`) REFERENCES `veiculo` (`id`),
  CONSTRAINT `fk_mdfe_18` FOREIGN KEY (`mdfe_situacao_id`) REFERENCES `mdfe_situacao` (`id`),
  CONSTRAINT `fk_mdfe_19` FOREIGN KEY (`mdfe_tpamb_id`) REFERENCES `mdfe_tpamb` (`id`),
  CONSTRAINT `fk_mdfe_2` FOREIGN KEY (`mdfe_tpprop_id`) REFERENCES `mdfe_tpprop` (`id`),
  CONSTRAINT `fk_mdfe_20` FOREIGN KEY (`api_documentos_id`) REFERENCES `api_documentos` (`id`),
  CONSTRAINT `fk_mdfe_21` FOREIGN KEY (`cidade_encerramento_id`) REFERENCES `cidade` (`id`),
  CONSTRAINT `fk_mdfe_4` FOREIGN KEY (`mdfe_tptransp_id`) REFERENCES `mdfe_tptransp` (`id`),
  CONSTRAINT `fk_mdfe_5` FOREIGN KEY (`mdfe_tpcar_id`) REFERENCES `mdfe_tpcar` (`id`),
  CONSTRAINT `fk_mdfe_6` FOREIGN KEY (`UFIni`) REFERENCES `estado` (`id`),
  CONSTRAINT `fk_mdfe_7` FOREIGN KEY (`UFFim`) REFERENCES `estado` (`id`),
  CONSTRAINT `fk_mdfe_8` FOREIGN KEY (`indCanalVerde`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_mdfe_9` FOREIGN KEY (`indCarregaPosterior`) REFERENCES `resposta` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_componentes
DROP TABLE IF EXISTS `mdfe_componentes`;
CREATE TABLE IF NOT EXISTS `mdfe_componentes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `mdfe_tpcomp_id` int NOT NULL,
  `vComp` double DEFAULT NULL,
  `xComp` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_componentes_1` (`mdfe_id`),
  KEY `fk_mdfe_componentes_2` (`mdfe_tpcomp_id`),
  CONSTRAINT `fk_mdfe_componentes_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`),
  CONSTRAINT `fk_mdfe_componentes_2` FOREIGN KEY (`mdfe_tpcomp_id`) REFERENCES `mdfe_tpcomp` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_componentes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_condutor
DROP TABLE IF EXISTS `mdfe_condutor`;
CREATE TABLE IF NOT EXISTS `mdfe_condutor` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `xnome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cpf` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_condutor_1` (`mdfe_id`),
  CONSTRAINT `fk_mdfe_condutor_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_condutor: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_ctes
DROP TABLE IF EXISTS `mdfe_ctes`;
CREATE TABLE IF NOT EXISTS `mdfe_ctes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `chCTe` text COLLATE utf8mb3_unicode_ci,
  `SegCodBarra` text COLLATE utf8mb3_unicode_ci,
  `indReentrega` int NOT NULL,
  `mdfe_infmundescarga_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_ctes_1` (`indReentrega`),
  KEY `fk_mdfe_ctes_2` (`mdfe_infmundescarga_id`),
  CONSTRAINT `fk_mdfe_ctes_1` FOREIGN KEY (`indReentrega`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_mdfe_ctes_2` FOREIGN KEY (`mdfe_infmundescarga_id`) REFERENCES `mdfe_infmundescarga` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_ctes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_cunid
DROP TABLE IF EXISTS `mdfe_cunid`;
CREATE TABLE IF NOT EXISTS `mdfe_cunid` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_cunid: ~2 rows (aproximadamente)
INSERT INTO `mdfe_cunid` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'KG', '01', NULL, NULL, '', '', NULL),
	(2, 'TON', '02', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_evento
DROP TABLE IF EXISTS `mdfe_evento`;
CREATE TABLE IF NOT EXISTS `mdfe_evento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `status` text COLLATE utf8mb3_unicode_ci,
  `codigo_status` text COLLATE utf8mb3_unicode_ci,
  `motivo_status` text COLLATE utf8mb3_unicode_ci,
  `id_evento` text COLLATE utf8mb3_unicode_ci,
  `numero_sequencial` text COLLATE utf8mb3_unicode_ci,
  `chave` text COLLATE utf8mb3_unicode_ci,
  `protocolo` text COLLATE utf8mb3_unicode_ci,
  `tipo_evento` text COLLATE utf8mb3_unicode_ci,
  `data_recebimento` text COLLATE utf8mb3_unicode_ci,
  `data_evento` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_evento_1` (`mdfe_id`),
  CONSTRAINT `fk_mdfe_evento_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_evento: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_inclusao_dfe
DROP TABLE IF EXISTS `mdfe_inclusao_dfe`;
CREATE TABLE IF NOT EXISTS `mdfe_inclusao_dfe` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `mdfe_id` int NOT NULL,
  `notafiscal_id` int DEFAULT NULL,
  `cidade_carrega_id` int NOT NULL,
  `cidade_descarga_id` int NOT NULL,
  `chave` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `protocolo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdf_inclusao_dfe_1` (`mdfe_id`),
  KEY `fk_mdf_inclusao_dfe_2` (`cidade_carrega_id`),
  KEY `fk_mdf_inclusao_dfe_3` (`cidade_descarga_id`),
  KEY `fk_mdf_inclusao_dfe_4` (`notafiscal_id`),
  CONSTRAINT `fk_mdf_inclusao_dfe_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`),
  CONSTRAINT `fk_mdf_inclusao_dfe_2` FOREIGN KEY (`cidade_carrega_id`) REFERENCES `cidade` (`id`),
  CONSTRAINT `fk_mdf_inclusao_dfe_3` FOREIGN KEY (`cidade_descarga_id`) REFERENCES `cidade` (`id`),
  CONSTRAINT `fk_mdf_inclusao_dfe_4` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_inclusao_dfe: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_indpag
DROP TABLE IF EXISTS `mdfe_indpag`;
CREATE TABLE IF NOT EXISTS `mdfe_indpag` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_indpag: ~2 rows (aproximadamente)
INSERT INTO `mdfe_indpag` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Pagamento à Vista', '0', NULL, NULL, '', '', NULL),
	(2, 'Pagamento à Prazo', '1', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_infmuncarrega
DROP TABLE IF EXISTS `mdfe_infmuncarrega`;
CREATE TABLE IF NOT EXISTS `mdfe_infmuncarrega` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `cidade_id` int NOT NULL,
  `cMunCarrega` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `xMunCarrega` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_infmuncarrega_1` (`mdfe_id`),
  KEY `fk_mdfe_infmuncarrega_2` (`cidade_id`),
  CONSTRAINT `fk_mdfe_infmuncarrega_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`),
  CONSTRAINT `fk_mdfe_infmuncarrega_2` FOREIGN KEY (`cidade_id`) REFERENCES `cidade` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_infmuncarrega: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_infmundescarga
DROP TABLE IF EXISTS `mdfe_infmundescarga`;
CREATE TABLE IF NOT EXISTS `mdfe_infmundescarga` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `cidade_id` int NOT NULL,
  `cMunDescarga` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `xMunDescarga` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_infmundescarga_1` (`mdfe_id`),
  KEY `fk_mdfe_infmundescarga_2` (`cidade_id`),
  CONSTRAINT `fk_mdfe_infmundescarga_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`),
  CONSTRAINT `fk_mdfe_infmundescarga_2` FOREIGN KEY (`cidade_id`) REFERENCES `cidade` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_infmundescarga: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_infpercurso
DROP TABLE IF EXISTS `mdfe_infpercurso`;
CREATE TABLE IF NOT EXISTS `mdfe_infpercurso` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `UFPer` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_infpercurso_1` (`mdfe_id`),
  KEY `fk_mdfe_infpercurso_2` (`UFPer`),
  CONSTRAINT `fk_mdfe_infpercurso_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`),
  CONSTRAINT `fk_mdfe_infpercurso_2` FOREIGN KEY (`UFPer`) REFERENCES `estado` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_infpercurso: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_lacres
DROP TABLE IF EXISTS `mdfe_lacres`;
CREATE TABLE IF NOT EXISTS `mdfe_lacres` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `nLacre` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_lacres_1` (`mdfe_id`),
  CONSTRAINT `fk_mdfe_lacres_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_lacres: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_logs
DROP TABLE IF EXISTS `mdfe_logs`;
CREATE TABLE IF NOT EXISTS `mdfe_logs` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `system_users_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_logs_1` (`mdfe_id`),
  KEY `fk_mdfe_logs_2` (`system_users_id`),
  CONSTRAINT `fk_mdfe_logs_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`),
  CONSTRAINT `fk_mdfe_logs_2` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_logs: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_mdfes
DROP TABLE IF EXISTS `mdfe_mdfes`;
CREATE TABLE IF NOT EXISTS `mdfe_mdfes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `chMDFe` text COLLATE utf8mb3_unicode_ci,
  `indReentrega` int NOT NULL,
  `mdfe_infmundescarga_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_mdfes_2` (`mdfe_infmundescarga_id`),
  KEY `fk_mdfe_mdfes_1` (`indReentrega`),
  CONSTRAINT `fk_mdfe_mdfes_1` FOREIGN KEY (`indReentrega`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_mdfe_mdfes_2` FOREIGN KEY (`mdfe_infmundescarga_id`) REFERENCES `mdfe_infmundescarga` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_mdfes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_nfes
DROP TABLE IF EXISTS `mdfe_nfes`;
CREATE TABLE IF NOT EXISTS `mdfe_nfes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `chNFe` text COLLATE utf8mb3_unicode_ci,
  `SegCodBarra` text COLLATE utf8mb3_unicode_ci,
  `indReentrega` int NOT NULL,
  `mdfe_infmundescarga_id` int NOT NULL,
  `notafiscal_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_nfes_3` (`notafiscal_id`),
  KEY `fk_mdfe_nfes_2` (`mdfe_infmundescarga_id`),
  KEY `fk_mdfe_nfes_1` (`indReentrega`),
  CONSTRAINT `fk_mdfe_nfes_1` FOREIGN KEY (`indReentrega`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_mdfe_nfes_2` FOREIGN KEY (`mdfe_infmundescarga_id`) REFERENCES `mdfe_infmundescarga` (`id`),
  CONSTRAINT `fk_mdfe_nfes_3` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_nfes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_parcelas
DROP TABLE IF EXISTS `mdfe_parcelas`;
CREATE TABLE IF NOT EXISTS `mdfe_parcelas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `nParcela` text COLLATE utf8mb3_unicode_ci,
  `dVenc` date DEFAULT NULL,
  `vParcela` double DEFAULT NULL,
  `mdfe_tpAntecip_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_parcelas_1` (`mdfe_id`),
  KEY `fk_mdfe_parcelas_2` (`mdfe_tpAntecip_id`),
  CONSTRAINT `fk_mdfe_parcelas_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`),
  CONSTRAINT `fk_mdfe_parcelas_2` FOREIGN KEY (`mdfe_tpAntecip_id`) REFERENCES `mdfe_tpantecip` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_parcelas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_respseg
DROP TABLE IF EXISTS `mdfe_respseg`;
CREATE TABLE IF NOT EXISTS `mdfe_respseg` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_respseg: ~2 rows (aproximadamente)
INSERT INTO `mdfe_respseg` (`id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `descricao`, `valor`) VALUES
	(1, NULL, NULL, '', '', NULL, 'Emitente do MDF-e', '1'),
	(2, NULL, NULL, '', '', NULL, 'Responsável pela contratação do serviço de transporte (contratante)', '2');

-- Copiando estrutura para tabela erp_nuvem.mdfe_series
DROP TABLE IF EXISTS `mdfe_series`;
CREATE TABLE IF NOT EXISTS `mdfe_series` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `mdfe_tpamb_id` int NOT NULL,
  `serie` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `sequencial` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_series_1` (`system_unit_id`),
  KEY `fk_mdfe_series_2` (`mdfe_tpamb_id`),
  CONSTRAINT `fk_mdfe_series_1` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_mdfe_series_2` FOREIGN KEY (`mdfe_tpamb_id`) REFERENCES `mdfe_tpamb` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_series: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.mdfe_situacao
DROP TABLE IF EXISTS `mdfe_situacao`;
CREATE TABLE IF NOT EXISTS `mdfe_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `ordem` int DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_situacao: ~4 rows (aproximadamente)
INSERT INTO `mdfe_situacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `cor`, `ordem`) VALUES
	(1, 'Em Digitação', NULL, NULL, '', 'Sistema Kraft', NULL, '', 1),
	(2, 'Transmitido', NULL, NULL, '', 'Sistema Kraft', NULL, '', 2),
	(3, 'Encerrado', NULL, NULL, '', 'Sistema Kraft', NULL, '', 3),
	(4, 'Cancelado', NULL, NULL, '', 'Sistema Kraft', NULL, '', 4);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tpamb
DROP TABLE IF EXISTS `mdfe_tpamb`;
CREATE TABLE IF NOT EXISTS `mdfe_tpamb` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tpamb: ~2 rows (aproximadamente)
INSERT INTO `mdfe_tpamb` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `valor`) VALUES
	(1, 'Produção', NULL, NULL, '', 'Sistema Kraft', NULL, '1'),
	(2, 'Homologação', NULL, NULL, '', 'Sistema Kraft', NULL, '2');

-- Copiando estrutura para tabela erp_nuvem.mdfe_tpantecip
DROP TABLE IF EXISTS `mdfe_tpantecip`;
CREATE TABLE IF NOT EXISTS `mdfe_tpantecip` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tpantecip: ~3 rows (aproximadamente)
INSERT INTO `mdfe_tpantecip` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Não permite antecipar', '0', NULL, NULL, '', '', NULL),
	(2, 'Permite antecipar as parcelas', '1', NULL, NULL, '', '', NULL),
	(3, 'Permite antecipar as parcelas mediante confirmação', '2', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tpcar
DROP TABLE IF EXISTS `mdfe_tpcar`;
CREATE TABLE IF NOT EXISTS `mdfe_tpcar` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tpcar: ~6 rows (aproximadamente)
INSERT INTO `mdfe_tpcar` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'não aplicável', '00', NULL, NULL, '', '', NULL),
	(2, 'Aberta', '01', NULL, NULL, '', '', NULL),
	(3, 'Fechada/Baú', '02', NULL, NULL, '', '', NULL),
	(4, 'Granelera', '03', NULL, NULL, '', '', NULL),
	(5, 'Porta Container', '04', NULL, NULL, '', '', NULL),
	(6, 'Sider', '05', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tpcarga
DROP TABLE IF EXISTS `mdfe_tpcarga`;
CREATE TABLE IF NOT EXISTS `mdfe_tpcarga` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tpcarga: ~11 rows (aproximadamente)
INSERT INTO `mdfe_tpcarga` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Granel sólido', '01', NULL, NULL, '', '', NULL),
	(2, 'Granel líquido', '02', NULL, NULL, '', '', NULL),
	(3, 'Frigorificada', '03', NULL, NULL, '', '', NULL),
	(4, 'Conteinerizada', '04', NULL, NULL, '', '', NULL),
	(5, 'Carga Geral', '05', NULL, NULL, '', '', NULL),
	(6, 'Neogranel', '06', NULL, NULL, '', '', NULL),
	(7, 'Perigosa (granel sólido)', '07', NULL, NULL, '', '', NULL),
	(8, 'Perigosa (granel líquido)', '08', NULL, NULL, '', '', NULL),
	(9, 'Perigosa (carga frigorificada)', '09', NULL, NULL, '', '', NULL),
	(10, 'Perigosa (conteinerizada)', '10', NULL, NULL, '', '', NULL),
	(11, 'Perigosa (carga geral)', '11', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tpcomp
DROP TABLE IF EXISTS `mdfe_tpcomp`;
CREATE TABLE IF NOT EXISTS `mdfe_tpcomp` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tpcomp: ~4 rows (aproximadamente)
INSERT INTO `mdfe_tpcomp` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Vale Pedágio', '01', NULL, NULL, '', '', NULL),
	(2, 'Impostos, taxas e contribuições', '02', NULL, NULL, '', '', NULL),
	(3, 'Despesas (bancárias, meios de pagamento, outras)', '03', NULL, NULL, '', '', NULL),
	(4, 'Outros', '99', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tpemit
DROP TABLE IF EXISTS `mdfe_tpemit`;
CREATE TABLE IF NOT EXISTS `mdfe_tpemit` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tpemit: ~3 rows (aproximadamente)
INSERT INTO `mdfe_tpemit` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Prestador de serviço de transporte', '1', NULL, NULL, '', '', NULL),
	(2, 'Transportador de Carga Própria', '2', NULL, NULL, '', '', NULL),
	(3, 'Prestador de serviço de transporte que emitirá CT-e Globalizado', '3', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tpprop
DROP TABLE IF EXISTS `mdfe_tpprop`;
CREATE TABLE IF NOT EXISTS `mdfe_tpprop` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tpprop: ~3 rows (aproximadamente)
INSERT INTO `mdfe_tpprop` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'TAC – Agregado', '0', NULL, NULL, '', '', NULL),
	(2, 'TAC Independente', '1', NULL, NULL, '', '', NULL),
	(3, 'Outros', '2', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tprod
DROP TABLE IF EXISTS `mdfe_tprod`;
CREATE TABLE IF NOT EXISTS `mdfe_tprod` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tprod: ~6 rows (aproximadamente)
INSERT INTO `mdfe_tprod` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Truck', '01', NULL, NULL, '', '', NULL),
	(2, 'Toco', '02', NULL, NULL, '', '', NULL),
	(3, 'Cavalo Mecânico', '03', NULL, NULL, '', '', NULL),
	(4, 'VAN', '04', NULL, NULL, '', '', NULL),
	(5, 'Utilitário', '05', NULL, NULL, '', '', NULL),
	(6, 'Outros', '06', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_tptransp
DROP TABLE IF EXISTS `mdfe_tptransp`;
CREATE TABLE IF NOT EXISTS `mdfe_tptransp` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_tptransp: ~3 rows (aproximadamente)
INSERT INTO `mdfe_tptransp` (`id`, `descricao`, `valor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'ETC (Empresa de tranposte rodoviário de cargas)', '1', NULL, NULL, '', '', NULL),
	(2, 'TAC (Transportador autônomo de cargas)', '2', NULL, NULL, '', '', NULL),
	(3, 'CTC (Cooperativa de tranporte rodoviário de cargas)', '3', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.mdfe_xmlaut
DROP TABLE IF EXISTS `mdfe_xmlaut`;
CREATE TABLE IF NOT EXISTS `mdfe_xmlaut` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mdfe_id` int NOT NULL,
  `cpfcnpj` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_mdfe_xmlaut_1` (`mdfe_id`),
  CONSTRAINT `fk_mdfe_xmlaut_1` FOREIGN KEY (`mdfe_id`) REFERENCES `mdfe` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.mdfe_xmlaut: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.meio_pagamento_tef
DROP TABLE IF EXISTS `meio_pagamento_tef`;
CREATE TABLE IF NOT EXISTS `meio_pagamento_tef` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.meio_pagamento_tef: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.movimentacao_origem
DROP TABLE IF EXISTS `movimentacao_origem`;
CREATE TABLE IF NOT EXISTS `movimentacao_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.movimentacao_origem: ~2 rows (aproximadamente)
INSERT INTO `movimentacao_origem` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Kraft WEB', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Kraft PDV', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.natop_excecao_tributo
DROP TABLE IF EXISTS `natop_excecao_tributo`;
CREATE TABLE IF NOT EXISTS `natop_excecao_tributo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natop_excecao_tributo: ~4 rows (aproximadamente)
INSERT INTO `natop_excecao_tributo` (`id`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'ICMS', NULL, '', '', NULL),
	(2, 'IPI', NULL, '', '', NULL),
	(3, 'PIS', NULL, '', '', NULL),
	(4, 'COFINS', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.natureza_operacao
DROP TABLE IF EXISTS `natureza_operacao`;
CREATE TABLE IF NOT EXISTS `natureza_operacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `natureza_operacao_finalidade_id` int NOT NULL,
  `cst_icms_id` int DEFAULT NULL,
  `cst_icms_nao_contribuinte_id` int DEFAULT NULL,
  `cst_ipi_id` int DEFAULT NULL,
  `cst_pis_id` int DEFAULT NULL,
  `cst_cofins_id` int DEFAULT NULL,
  `cfop` char(4) COLLATE utf8mb3_unicode_ci NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `obs_padrao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `icms_aliquota` double DEFAULT NULL,
  `ipi_aliquota` double DEFAULT NULL,
  `ipi_codigo_enquadramento` text COLLATE utf8mb3_unicode_ci,
  `pis_aliquota` double DEFAULT NULL,
  `pis_base` double DEFAULT NULL,
  `cofins_aliquota` double DEFAULT NULL,
  `consumidor_final_id` int DEFAULT NULL,
  `cofins_base` double DEFAULT NULL,
  `icms_pRedBC` double DEFAULT NULL,
  `icms_pICMS` double DEFAULT NULL,
  `icms_pDif` double DEFAULT NULL,
  `icms_vICMSDeson` double DEFAULT NULL,
  `icms_pMVAST` double DEFAULT NULL,
  `icms_pICMSST` double DEFAULT NULL,
  `icms_pFCP` double DEFAULT NULL,
  `icms_pFCPST` double DEFAULT NULL,
  `icms_pFCPSTRet` double DEFAULT NULL,
  `icms_pST` double DEFAULT NULL,
  `icms_pCredSN` date DEFAULT NULL,
  `icms_pRedBCEfet` double DEFAULT NULL,
  `icms_pICMSEfet` double DEFAULT NULL,
  `notafiscal_item_modbc_id` int DEFAULT NULL,
  `notafiscal_item_modbcst_id` int DEFAULT NULL,
  `notafiscal_item_motDesICMS_id` int DEFAULT NULL,
  `icms_pFCPUFDest` double DEFAULT NULL,
  `icms_pICMSUFDest` double DEFAULT NULL,
  `icms_baseST` double DEFAULT NULL,
  `icms_base` double DEFAULT NULL,
  `cfop_fora` char(4) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_natureza_operacao_7` (`notafiscal_item_modbc_id`),
  KEY `fk_natureza_operacao_8` (`notafiscal_item_modbcst_id`),
  KEY `fk_natureza_operacao_9` (`notafiscal_item_motDesICMS_id`),
  KEY `fk_natureza_operacao_1` (`natureza_operacao_finalidade_id`),
  KEY `fk_natureza_operacao_2` (`cst_icms_id`),
  KEY `fk_natureza_operacao_3` (`cst_ipi_id`),
  KEY `fk_natureza_operacao_4` (`cst_pis_id`),
  KEY `fk_natureza_operacao_5` (`cst_cofins_id`),
  KEY `fk_natureza_operacao_6` (`consumidor_final_id`),
  KEY `fk_natureza_operacao_10` (`cst_icms_nao_contribuinte_id`),
  CONSTRAINT `fk_natureza_operacao_1` FOREIGN KEY (`natureza_operacao_finalidade_id`) REFERENCES `natureza_operacao_finalidade` (`id`),
  CONSTRAINT `fk_natureza_operacao_10` FOREIGN KEY (`cst_icms_nao_contribuinte_id`) REFERENCES `cst_icms` (`id`),
  CONSTRAINT `fk_natureza_operacao_2` FOREIGN KEY (`cst_icms_id`) REFERENCES `cst_icms` (`id`),
  CONSTRAINT `fk_natureza_operacao_3` FOREIGN KEY (`cst_ipi_id`) REFERENCES `cst_ipi` (`id`),
  CONSTRAINT `fk_natureza_operacao_4` FOREIGN KEY (`cst_pis_id`) REFERENCES `cst_pis` (`id`),
  CONSTRAINT `fk_natureza_operacao_5` FOREIGN KEY (`cst_cofins_id`) REFERENCES `cst_cofins` (`id`),
  CONSTRAINT `fk_natureza_operacao_6` FOREIGN KEY (`consumidor_final_id`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_natureza_operacao_7` FOREIGN KEY (`notafiscal_item_modbc_id`) REFERENCES `notafiscal_item_modbc` (`id`),
  CONSTRAINT `fk_natureza_operacao_8` FOREIGN KEY (`notafiscal_item_modbcst_id`) REFERENCES `notafiscal_item_modbcst` (`id`),
  CONSTRAINT `fk_natureza_operacao_9` FOREIGN KEY (`notafiscal_item_motDesICMS_id`) REFERENCES `notafiscal_item_motdesicms` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natureza_operacao: ~0 rows (aproximadamente)
INSERT INTO `natureza_operacao` (`id`, `natureza_operacao_finalidade_id`, `cst_icms_id`, `cst_icms_nao_contribuinte_id`, `cst_ipi_id`, `cst_pis_id`, `cst_cofins_id`, `cfop`, `descricao`, `obs_padrao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`, `icms_aliquota`, `ipi_aliquota`, `ipi_codigo_enquadramento`, `pis_aliquota`, `pis_base`, `cofins_aliquota`, `consumidor_final_id`, `cofins_base`, `icms_pRedBC`, `icms_pICMS`, `icms_pDif`, `icms_vICMSDeson`, `icms_pMVAST`, `icms_pICMSST`, `icms_pFCP`, `icms_pFCPST`, `icms_pFCPSTRet`, `icms_pST`, `icms_pCredSN`, `icms_pRedBCEfet`, `icms_pICMSEfet`, `notafiscal_item_modbc_id`, `notafiscal_item_modbcst_id`, `notafiscal_item_motDesICMS_id`, `icms_pFCPUFDest`, `icms_pICMSUFDest`, `icms_baseST`, `icms_base`, `cfop_fora`) VALUES
	(1, 1, NULL, NULL, NULL, NULL, NULL, '5102', 'Venda de mercadorias', '', NULL, '', '', NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '6102'),
	(2, 1, 11, 2, 10, 8, 8, '5102', 'VENDA DE MERCADORIAS', NULL, '2024-03-31 09:54:09', NULL, 'Administrador', NULL, 17, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL, NULL, NULL, 100, '6102');

-- Copiando estrutura para tabela erp_nuvem.natureza_operacao_estados
DROP TABLE IF EXISTS `natureza_operacao_estados`;
CREATE TABLE IF NOT EXISTS `natureza_operacao_estados` (
  `id` int NOT NULL AUTO_INCREMENT,
  `natureza_operacao_excecao_id` int NOT NULL,
  `estado_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_natureza_operacao_estados_2` (`natureza_operacao_excecao_id`),
  KEY `fk_natureza_operacao_estados_1` (`estado_id`),
  CONSTRAINT `fk_natureza_operacao_estados_1` FOREIGN KEY (`estado_id`) REFERENCES `estado` (`id`),
  CONSTRAINT `fk_natureza_operacao_estados_2` FOREIGN KEY (`natureza_operacao_excecao_id`) REFERENCES `natureza_operacao_excecao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natureza_operacao_estados: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.natureza_operacao_excecao
DROP TABLE IF EXISTS `natureza_operacao_excecao`;
CREATE TABLE IF NOT EXISTS `natureza_operacao_excecao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `natureza_operacao_id` int NOT NULL,
  `natop_excecao_tributo_id` int NOT NULL,
  `cst_pis_id` int DEFAULT NULL,
  `cst_ipi_id` int DEFAULT NULL,
  `cst_icms_id` int DEFAULT NULL,
  `cst_cofins_id` int DEFAULT NULL,
  `cfop` char(4) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `icms_aliquota` double DEFAULT NULL,
  `ipi_aliquota` double DEFAULT NULL,
  `ipi_codigo_enquadramento` text COLLATE utf8mb3_unicode_ci,
  `pis_aliquota` double DEFAULT NULL,
  `pis_base` double DEFAULT NULL,
  `cofins_aliquota` double DEFAULT NULL,
  `cofins_base` double DEFAULT NULL,
  `icms_predbc` double DEFAULT NULL,
  `icms_picms` double DEFAULT NULL,
  `icms_pdif` double DEFAULT NULL,
  `icms_vicmsdeson` double DEFAULT NULL,
  `icms_pmvast` double DEFAULT NULL,
  `icms_picmsst` double DEFAULT NULL,
  `icms_pfcp` double DEFAULT NULL,
  `icms_pfcpst` double DEFAULT NULL,
  `icms_pfcpstret` double DEFAULT NULL,
  `icms_pst` double DEFAULT NULL,
  `icms_pcredsn` double DEFAULT NULL,
  `icms_predbcefet` double DEFAULT NULL,
  `icms_picmsefet` double DEFAULT NULL,
  `icms_pfcpufdest` double DEFAULT NULL,
  `icms_picmsufdest` double DEFAULT NULL,
  `icms_base` double DEFAULT NULL,
  `icms_basest` double DEFAULT NULL,
  `notafiscal_item_modbc_id` int DEFAULT NULL,
  `notafiscal_item_modbcst_id` int DEFAULT NULL,
  `notafiscal_item_motDesICMS_id` int DEFAULT NULL,
  `cfop_fora` char(4) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_natureza_operacao_excecao_2` (`natop_excecao_tributo_id`),
  KEY `fk_natureza_operacao_excecao_1` (`natureza_operacao_id`),
  KEY `fk_natureza_operacao_excecao_3` (`cst_pis_id`),
  KEY `fk_natureza_operacao_excecao_4` (`cst_ipi_id`),
  KEY `fk_natureza_operacao_excecao_5` (`cst_icms_id`),
  KEY `fk_natureza_operacao_excecao_6` (`cst_cofins_id`),
  KEY `fk_natureza_operacao_excecao_7` (`notafiscal_item_modbc_id`),
  KEY `fk_natureza_operacao_excecao_8` (`notafiscal_item_modbcst_id`),
  KEY `fk_natureza_operacao_excecao_9` (`notafiscal_item_motDesICMS_id`),
  CONSTRAINT `fk_natureza_operacao_excecao_1` FOREIGN KEY (`natureza_operacao_id`) REFERENCES `natureza_operacao` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_2` FOREIGN KEY (`natop_excecao_tributo_id`) REFERENCES `natop_excecao_tributo` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_3` FOREIGN KEY (`cst_pis_id`) REFERENCES `cst_pis` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_4` FOREIGN KEY (`cst_ipi_id`) REFERENCES `cst_ipi` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_5` FOREIGN KEY (`cst_icms_id`) REFERENCES `cst_icms` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_6` FOREIGN KEY (`cst_cofins_id`) REFERENCES `cst_cofins` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_7` FOREIGN KEY (`notafiscal_item_modbc_id`) REFERENCES `notafiscal_item_modbc` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_8` FOREIGN KEY (`notafiscal_item_modbcst_id`) REFERENCES `notafiscal_item_modbcst` (`id`),
  CONSTRAINT `fk_natureza_operacao_excecao_9` FOREIGN KEY (`notafiscal_item_motDesICMS_id`) REFERENCES `notafiscal_item_motdesicms` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natureza_operacao_excecao: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.natureza_operacao_finalidade
DROP TABLE IF EXISTS `natureza_operacao_finalidade`;
CREATE TABLE IF NOT EXISTS `natureza_operacao_finalidade` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natureza_operacao_finalidade: ~4 rows (aproximadamente)
INSERT INTO `natureza_operacao_finalidade` (`id`, `nome`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Normal', NULL, '', '', NULL),
	(2, 'Devolução', NULL, '', '', NULL),
	(3, 'Bonificação', NULL, '', '', NULL),
	(4, 'Remessa', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.natureza_operacao_ncm
DROP TABLE IF EXISTS `natureza_operacao_ncm`;
CREATE TABLE IF NOT EXISTS `natureza_operacao_ncm` (
  `id` int NOT NULL AUTO_INCREMENT,
  `natureza_operacao_excecao_id` int NOT NULL,
  `ncm` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_natureza_operacao_ncm_1` (`natureza_operacao_excecao_id`),
  CONSTRAINT `fk_natureza_operacao_ncm_1` FOREIGN KEY (`natureza_operacao_excecao_id`) REFERENCES `natureza_operacao_excecao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natureza_operacao_ncm: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.natureza_operacao_origens
DROP TABLE IF EXISTS `natureza_operacao_origens`;
CREATE TABLE IF NOT EXISTS `natureza_operacao_origens` (
  `id` int NOT NULL AUTO_INCREMENT,
  `natureza_operacao_excecao_id` int NOT NULL,
  `notafiscal_item_orig_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_natureza_operacao_origens_2` (`natureza_operacao_excecao_id`),
  KEY `fk_natureza_operacao_origens_1` (`notafiscal_item_orig_id`),
  CONSTRAINT `fk_natureza_operacao_origens_1` FOREIGN KEY (`notafiscal_item_orig_id`) REFERENCES `notafiscal_item_orig` (`id`),
  CONSTRAINT `fk_natureza_operacao_origens_2` FOREIGN KEY (`natureza_operacao_excecao_id`) REFERENCES `natureza_operacao_excecao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natureza_operacao_origens: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.natureza_operacao_produtos
DROP TABLE IF EXISTS `natureza_operacao_produtos`;
CREATE TABLE IF NOT EXISTS `natureza_operacao_produtos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_id` int NOT NULL,
  `natureza_operacao_excecao_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_natureza_operacao_produtos_2` (`natureza_operacao_excecao_id`),
  KEY `fk_natureza_operacao_produtos_1` (`produto_id`),
  CONSTRAINT `fk_natureza_operacao_produtos_1` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_natureza_operacao_produtos_2` FOREIGN KEY (`natureza_operacao_excecao_id`) REFERENCES `natureza_operacao_excecao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.natureza_operacao_produtos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.negocio
DROP TABLE IF EXISTS `negocio`;
CREATE TABLE IF NOT EXISTS `negocio` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `negocio_origem_id` int NOT NULL,
  `funil_id` int DEFAULT NULL,
  `funil_etapas_id` int NOT NULL,
  `titulo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` double DEFAULT NULL,
  `data_abertura` date NOT NULL,
  `ordem` int NOT NULL,
  `data_fechamento` date DEFAULT NULL,
  `negocio_motivo_perda_id` int DEFAULT NULL,
  `comentarios_motivo_perda` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `contato_nome` text COLLATE utf8mb3_unicode_ci,
  `contato_fone` text COLLATE utf8mb3_unicode_ci,
  `ativo_id` int NOT NULL,
  `arquivado` int NOT NULL,
  `data_fechamento_esperada` date DEFAULT NULL,
  `vendedor_id` int DEFAULT NULL,
  `mes` int DEFAULT NULL,
  `ano` int DEFAULT NULL,
  `orcamento_id` int DEFAULT NULL,
  `cliente_id` int DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `contato_email` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_negocio_1` (`negocio_origem_id`),
  KEY `fk_negocio_2` (`system_unit_id`),
  KEY `fk_negocio_3` (`negocio_motivo_perda_id`),
  KEY `fk_negocio_4` (`funil_etapas_id`),
  KEY `fk_negocio_5` (`ativo_id`),
  KEY `fk_negocio_6` (`arquivado`),
  KEY `fk_negocio_7` (`vendedor_id`),
  KEY `fk_negocio_9` (`cliente_id`),
  KEY `fk_negocio_8` (`orcamento_id`),
  KEY `fk_negocio_10` (`funil_id`),
  CONSTRAINT `fk_negocio_1` FOREIGN KEY (`negocio_origem_id`) REFERENCES `negocio_origem` (`id`),
  CONSTRAINT `fk_negocio_10` FOREIGN KEY (`funil_id`) REFERENCES `funil` (`id`),
  CONSTRAINT `fk_negocio_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_negocio_3` FOREIGN KEY (`negocio_motivo_perda_id`) REFERENCES `negocio_motivo_perda` (`id`),
  CONSTRAINT `fk_negocio_4` FOREIGN KEY (`funil_etapas_id`) REFERENCES `funil_etapas` (`id`),
  CONSTRAINT `fk_negocio_5` FOREIGN KEY (`ativo_id`) REFERENCES `ativo` (`id`),
  CONSTRAINT `fk_negocio_6` FOREIGN KEY (`arquivado`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_negocio_7` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_negocio_8` FOREIGN KEY (`orcamento_id`) REFERENCES `orcamento` (`id`),
  CONSTRAINT `fk_negocio_9` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio: ~0 rows (aproximadamente)
INSERT INTO `negocio` (`id`, `system_unit_id`, `negocio_origem_id`, `funil_id`, `funil_etapas_id`, `titulo`, `valor`, `data_abertura`, `ordem`, `data_fechamento`, `negocio_motivo_perda_id`, `comentarios_motivo_perda`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`, `contato_nome`, `contato_fone`, `ativo_id`, `arquivado`, `data_fechamento_esperada`, `vendedor_id`, `mes`, `ano`, `orcamento_id`, `cliente_id`, `deletado_em`, `contato_email`) VALUES
	(1, 1, 1, 1, 1, 'TESTE', NULL, '2024-06-04', 1, NULL, NULL, NULL, '2024-06-04 01:26:12', NULL, 'Administrador', NULL, 'FERNANDO', '65996728882', 1, 2, '2024-06-04', 1, NULL, NULL, NULL, 1, NULL, 'fpasqueto@gmail.com');

-- Copiando estrutura para tabela erp_nuvem.negocio_arquivos
DROP TABLE IF EXISTS `negocio_arquivos`;
CREATE TABLE IF NOT EXISTS `negocio_arquivos` (
  `id` int NOT NULL AUTO_INCREMENT,
  `negocio_id` int NOT NULL,
  `arquivo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_negocio_arquivos_1` (`negocio_id`),
  CONSTRAINT `fk_negocio_arquivos_1` FOREIGN KEY (`negocio_id`) REFERENCES `negocio` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_arquivos: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.negocio_atividade
DROP TABLE IF EXISTS `negocio_atividade`;
CREATE TABLE IF NOT EXISTS `negocio_atividade` (
  `id` int NOT NULL AUTO_INCREMENT,
  `negocio_id` int NOT NULL,
  `negocio_tipo_atividade_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `horario_inicial` datetime DEFAULT NULL,
  `horario_final` datetime DEFAULT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_negocio_atividade_1` (`negocio_id`),
  KEY `fk_negocio_atividade_2` (`negocio_tipo_atividade_id`),
  CONSTRAINT `fk_negocio_atividade_1` FOREIGN KEY (`negocio_id`) REFERENCES `negocio` (`id`),
  CONSTRAINT `fk_negocio_atividade_2` FOREIGN KEY (`negocio_tipo_atividade_id`) REFERENCES `negocio_tipo_atividade` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_atividade: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.negocio_etapas_historico
DROP TABLE IF EXISTS `negocio_etapas_historico`;
CREATE TABLE IF NOT EXISTS `negocio_etapas_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `negocio_id` int NOT NULL,
  `funil_etapas_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_negocio_etapas_historico_1` (`negocio_id`),
  KEY `fk_negocio_etapas_historico_2` (`funil_etapas_id`),
  CONSTRAINT `fk_negocio_etapas_historico_1` FOREIGN KEY (`negocio_id`) REFERENCES `negocio` (`id`),
  CONSTRAINT `fk_negocio_etapas_historico_2` FOREIGN KEY (`funil_etapas_id`) REFERENCES `funil_etapas` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_etapas_historico: ~0 rows (aproximadamente)
INSERT INTO `negocio_etapas_historico` (`id`, `negocio_id`, `funil_etapas_id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 1, 1, '2024-06-04 01:26:12', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.negocio_itens
DROP TABLE IF EXISTS `negocio_itens`;
CREATE TABLE IF NOT EXISTS `negocio_itens` (
  `id` int NOT NULL AUTO_INCREMENT,
  `negocio_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `valor_unitario` double NOT NULL,
  `quantidade` double NOT NULL,
  `valor_total` double NOT NULL,
  `desconto` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_negocio_itens_1` (`negocio_id`),
  KEY `fk_negocio_itens_2` (`produto_id`),
  CONSTRAINT `fk_negocio_itens_1` FOREIGN KEY (`negocio_id`) REFERENCES `negocio` (`id`),
  CONSTRAINT `fk_negocio_itens_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_itens: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.negocio_motivo_perda
DROP TABLE IF EXISTS `negocio_motivo_perda`;
CREATE TABLE IF NOT EXISTS `negocio_motivo_perda` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_motivo_perda: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.negocio_notas
DROP TABLE IF EXISTS `negocio_notas`;
CREATE TABLE IF NOT EXISTS `negocio_notas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `negocio_id` int NOT NULL,
  `nota` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_negocio_notas_1` (`negocio_id`),
  CONSTRAINT `fk_negocio_notas_1` FOREIGN KEY (`negocio_id`) REFERENCES `negocio` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_notas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.negocio_origem
DROP TABLE IF EXISTS `negocio_origem`;
CREATE TABLE IF NOT EXISTS `negocio_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_origem: ~0 rows (aproximadamente)
INSERT INTO `negocio_origem` (`id`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`, `deletado_em`) VALUES
	(1, 'LOJA', '2024-06-04 01:24:19', NULL, 'Administrador', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.negocio_tipo_atividade
DROP TABLE IF EXISTS `negocio_tipo_atividade`;
CREATE TABLE IF NOT EXISTS `negocio_tipo_atividade` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `icone` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.negocio_tipo_atividade: ~4 rows (aproximadamente)
INSERT INTO `negocio_tipo_atividade` (`id`, `descricao`, `cor`, `icone`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Ligar', '', 'fas fa-phone', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Reunião', '', 'fas fa-users', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Tarefa', '', 'fas fa-tasks', NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'E-Mail', '', 'fas fa-envelope', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal
DROP TABLE IF EXISTS `notafiscal`;
CREATE TABLE IF NOT EXISTS `notafiscal` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `cliente_id` int DEFAULT NULL,
  `venda_id` int DEFAULT NULL,
  `numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `data_emissao` datetime DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `texto_rodape` text COLLATE utf8mb3_unicode_ci,
  `data_saida` datetime DEFAULT NULL,
  `icms_basecalc` double DEFAULT NULL,
  `icms_valor` double DEFAULT NULL,
  `icms_subst_base_calc` int DEFAULT NULL,
  `icms_subst_valor` double DEFAULT NULL,
  `frete_valor` double DEFAULT NULL,
  `seguro_valor` double DEFAULT NULL,
  `outras_despesas` double DEFAULT NULL,
  `ipi_valor` double DEFAULT NULL,
  `serie` text COLLATE utf8mb3_unicode_ci,
  `valor_total_produtos` double DEFAULT NULL,
  `valor_total_nota` double DEFAULT NULL,
  `transp_nome` text COLLATE utf8mb3_unicode_ci,
  `transp_cnpj` text COLLATE utf8mb3_unicode_ci,
  `transp_inscest` text COLLATE utf8mb3_unicode_ci,
  `transp_endereco` text COLLATE utf8mb3_unicode_ci,
  `transp_cidade` text COLLATE utf8mb3_unicode_ci,
  `transp_placaveiculo` text COLLATE utf8mb3_unicode_ci,
  `transp_uf` text COLLATE utf8mb3_unicode_ci,
  `transp_veiculouf` text COLLATE utf8mb3_unicode_ci,
  `transp_veiculoRNTC` text COLLATE utf8mb3_unicode_ci,
  `transp_numeracao` text COLLATE utf8mb3_unicode_ci,
  `nf_tipodocumento_id` int NOT NULL,
  `notafiscal_situacao_id` int NOT NULL,
  `notafiscal_crt_id` int NOT NULL,
  `cliente_endereco` text COLLATE utf8mb3_unicode_ci,
  `cliente_complemento` text COLLATE utf8mb3_unicode_ci,
  `cliente_numero` text COLLATE utf8mb3_unicode_ci,
  `cliente_bairro` text COLLATE utf8mb3_unicode_ci,
  `cliente_cidade` text COLLATE utf8mb3_unicode_ci,
  `cliente_cep` text COLLATE utf8mb3_unicode_ci,
  `cliente_estado` text COLLATE utf8mb3_unicode_ci,
  `cliente_nome` text COLLATE utf8mb3_unicode_ci,
  `cliente_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `cliente_inscest` text COLLATE utf8mb3_unicode_ci,
  `cliente_inscmuni` text COLLATE utf8mb3_unicode_ci,
  `cliente_fone` text COLLATE utf8mb3_unicode_ci,
  `cliente_cidade_codibge` int DEFAULT NULL,
  `cliente_suframa` text COLLATE utf8mb3_unicode_ci,
  `justificativa_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `chave` text COLLATE utf8mb3_unicode_ci,
  `protocolo_envio` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_indiedest_id` int NOT NULL,
  `protocolo_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `datahora_cancelamento` datetime DEFAULT NULL,
  `cce_datahora_evento` datetime DEFAULT NULL,
  `cce_sequencial` int DEFAULT NULL,
  `cce_correcao` text COLLATE utf8mb3_unicode_ci,
  `cce_protocolo` text COLLATE utf8mb3_unicode_ci,
  `infadfisco` text COLLATE utf8mb3_unicode_ci,
  `desconto_valor` double DEFAULT NULL,
  `pis_valor` double DEFAULT NULL,
  `cofins_valor` double DEFAULT NULL,
  `fatura_numero` text COLLATE utf8mb3_unicode_ci,
  `fatura_valor_original` double DEFAULT NULL,
  `fatura_valor_desconto` double DEFAULT NULL,
  `fatura_valor_liquido` double DEFAULT NULL,
  `notafiscal_iddest_id` int NOT NULL,
  `notafiscal_tpimp_id` int NOT NULL,
  `notafiscal_tpemis_id` int NOT NULL,
  `notafiscal_finnfe_id` int NOT NULL,
  `notafiscal_indfinal_id` int NOT NULL,
  `notafiscal_indpres_id` int NOT NULL,
  `verproc` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_indpag_id` int NOT NULL,
  `retirada_marcado` int DEFAULT NULL,
  `retirada_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `retirada_xlgr` text COLLATE utf8mb3_unicode_ci,
  `retirada_nro` text COLLATE utf8mb3_unicode_ci,
  `retirada_xcpl` text COLLATE utf8mb3_unicode_ci,
  `retirada_xbairro` text COLLATE utf8mb3_unicode_ci,
  `retirada_cmun` int DEFAULT NULL,
  `retirada_xmun` text COLLATE utf8mb3_unicode_ci,
  `retirada_uf` text COLLATE utf8mb3_unicode_ci,
  `entrega_marcado` int DEFAULT NULL,
  `entrega_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `entrega_xlgr` text COLLATE utf8mb3_unicode_ci,
  `entrega_nro` text COLLATE utf8mb3_unicode_ci,
  `entrega_xcpl` text COLLATE utf8mb3_unicode_ci,
  `entrega_xbairro` text COLLATE utf8mb3_unicode_ci,
  `entrega_cmun` int DEFAULT NULL,
  `entrega_xmun` text COLLATE utf8mb3_unicode_ci,
  `entrega_uf` text COLLATE utf8mb3_unicode_ci,
  `vicmsufdest` double DEFAULT NULL,
  `vicmsufremet` double DEFAULT NULL,
  `vfcpufdest` double DEFAULT NULL,
  `notafiscal_modelo_id` int NOT NULL,
  `dispositivos_id` int DEFAULT NULL,
  `xml` text COLLATE utf8mb3_unicode_ci,
  `data_hora_envio` datetime DEFAULT NULL,
  `xml_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `issqn_vserv` double DEFAULT NULL,
  `issqn_vbc` double DEFAULT NULL,
  `issqn_viss` double DEFAULT NULL,
  `issqn_dcompet` date DEFAULT NULL,
  `issqn_reftrib` text COLLATE utf8mb3_unicode_ci,
  `icms_vfcp` double DEFAULT NULL,
  `icms_vfcpst` double DEFAULT NULL,
  `icms_vfcpstret` double DEFAULT NULL,
  `layout_versao` text COLLATE utf8mb3_unicode_ci,
  `ipi_vipidevol` double DEFAULT NULL,
  `vtroco` double DEFAULT NULL,
  `notafiscal_tpamb_id` int NOT NULL,
  `notafiscal_mod_id` int NOT NULL,
  `infcpl` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_modfrete_id` int NOT NULL,
  `status` text COLLATE utf8mb3_unicode_ci,
  `mensagem` text COLLATE utf8mb3_unicode_ci,
  `cce_xml` text COLLATE utf8mb3_unicode_ci,
  `cce_pdf` text COLLATE utf8mb3_unicode_ci,
  `codigo_sefaz` int DEFAULT NULL,
  `sn_carta_correcao` char(1) COLLATE utf8mb3_unicode_ci NOT NULL DEFAULT 'N',
  `deletado_em` datetime DEFAULT NULL,
  `contingencia_data` datetime DEFAULT NULL,
  `contingencia_motivo` text COLLATE utf8mb3_unicode_ci,
  `exporta_ufsaidapais` text COLLATE utf8mb3_unicode_ci,
  `exporta_xlocexporta` text COLLATE utf8mb3_unicode_ci,
  `exporta_xlocdespacho` text COLLATE utf8mb3_unicode_ci,
  `cliente_cpais` text COLLATE utf8mb3_unicode_ci,
  `cliente_xpais` text COLLATE utf8mb3_unicode_ci,
  `natureza_operacao_id` int DEFAULT NULL,
  `movimentacao_origem_id` int DEFAULT NULL,
  `inutilizar` int DEFAULT NULL,
  `xml_inicial` text COLLATE utf8mb3_unicode_ci,
  `entrega_cuf` int DEFAULT NULL,
  `xml_assinado` text COLLATE utf8mb3_unicode_ci,
  `protolo_xml` text COLLATE utf8mb3_unicode_ci,
  `xml_autorizado` text COLLATE utf8mb3_unicode_ci,
  `cep_entrega` varchar(15) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `cep_retirada` varchar(15) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `entrega_xnome` varchar(200) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `xml_carta` text COLLATE utf8mb3_unicode_ci,
  `protocolo_carta_resposta` varchar(200) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci,
  `xevento` text COLLATE utf8mb3_unicode_ci,
  `xmotivo` text COLLATE utf8mb3_unicode_ci,
  `cstat` int DEFAULT NULL,
  `dhregevento` varchar(50) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `nseqevento` int DEFAULT NULL,
  `nprot` varchar(100) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_19` (`natureza_operacao_id`),
  KEY `fk_notafiscal_17` (`notafiscal_tpamb_id`),
  KEY `fk_notafiscal_20` (`movimentacao_origem_id`),
  KEY `fk_notafiscal_18` (`notafiscal_mod_id`),
  KEY `fk_notafiscal_1` (`venda_id`),
  KEY `fk_notafiscal_2` (`cliente_id`),
  KEY `fk_notafiscal_3` (`nf_tipodocumento_id`),
  KEY `fk_notafiscal_4` (`notafiscal_situacao_id`),
  KEY `fk_notafiscal_5` (`notafiscal_indiedest_id`),
  KEY `fk_notafiscal_6` (`notafiscal_iddest_id`),
  KEY `fk_notafiscal_7` (`notafiscal_tpimp_id`),
  KEY `fk_notafiscal_8` (`notafiscal_tpemis_id`),
  KEY `fk_notafiscal_9` (`notafiscal_finnfe_id`),
  KEY `fk_notafiscal_10` (`notafiscal_indfinal_id`),
  KEY `fk_notafiscal_11` (`notafiscal_indpres_id`),
  KEY `fk_notafiscal_12` (`notafiscal_indpag_id`),
  KEY `fk_notafiscal_16` (`dispositivos_id`),
  KEY `fk_notafiscal_21` (`notafiscal_crt_id`),
  CONSTRAINT `fk_notafiscal_1` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`),
  CONSTRAINT `fk_notafiscal_10` FOREIGN KEY (`notafiscal_indfinal_id`) REFERENCES `notafiscal_indfinal` (`id`),
  CONSTRAINT `fk_notafiscal_11` FOREIGN KEY (`notafiscal_indpres_id`) REFERENCES `notafiscal_indpres` (`id`),
  CONSTRAINT `fk_notafiscal_12` FOREIGN KEY (`notafiscal_indpag_id`) REFERENCES `notafiscal_indpag` (`id`),
  CONSTRAINT `fk_notafiscal_16` FOREIGN KEY (`dispositivos_id`) REFERENCES `dispositivos` (`id`),
  CONSTRAINT `fk_notafiscal_17` FOREIGN KEY (`notafiscal_tpamb_id`) REFERENCES `notafiscal_tpamb` (`id`),
  CONSTRAINT `fk_notafiscal_18` FOREIGN KEY (`notafiscal_mod_id`) REFERENCES `notafiscal_mod` (`id`),
  CONSTRAINT `fk_notafiscal_19` FOREIGN KEY (`natureza_operacao_id`) REFERENCES `natureza_operacao` (`id`),
  CONSTRAINT `fk_notafiscal_2` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_notafiscal_20` FOREIGN KEY (`movimentacao_origem_id`) REFERENCES `movimentacao_origem` (`id`),
  CONSTRAINT `fk_notafiscal_21` FOREIGN KEY (`notafiscal_crt_id`) REFERENCES `notafiscal_crt` (`id`),
  CONSTRAINT `fk_notafiscal_3` FOREIGN KEY (`nf_tipodocumento_id`) REFERENCES `notafiscal_tipodocumento` (`id`),
  CONSTRAINT `fk_notafiscal_4` FOREIGN KEY (`notafiscal_situacao_id`) REFERENCES `notafiscal_situacao` (`id`),
  CONSTRAINT `fk_notafiscal_5` FOREIGN KEY (`notafiscal_indiedest_id`) REFERENCES `notafiscal_indiedest` (`id`),
  CONSTRAINT `fk_notafiscal_6` FOREIGN KEY (`notafiscal_iddest_id`) REFERENCES `notafiscal_iddest` (`id`),
  CONSTRAINT `fk_notafiscal_7` FOREIGN KEY (`notafiscal_tpimp_id`) REFERENCES `notafiscal_tpimp` (`id`),
  CONSTRAINT `fk_notafiscal_8` FOREIGN KEY (`notafiscal_tpemis_id`) REFERENCES `notafiscal_tpemis` (`id`),
  CONSTRAINT `fk_notafiscal_9` FOREIGN KEY (`notafiscal_finnfe_id`) REFERENCES `notafiscal_finnfe` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_autxml
DROP TABLE IF EXISTS `notafiscal_autxml`;
CREATE TABLE IF NOT EXISTS `notafiscal_autxml` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `cpf_cnpj` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_autxml_1` (`notafiscal_id`),
  CONSTRAINT `fk_notafiscal_autxml_1` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_autxml: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_cprod_padrao
DROP TABLE IF EXISTS `notafiscal_cprod_padrao`;
CREATE TABLE IF NOT EXISTS `notafiscal_cprod_padrao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_cprod_padrao: ~4 rows (aproximadamente)
INSERT INTO `notafiscal_cprod_padrao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Código do Produto', NULL, NULL, '', '', NULL),
	(2, 'Referência', NULL, NULL, '', '', NULL),
	(3, 'Código de Barras', NULL, NULL, '', '', NULL),
	(4, 'Código SKU', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_crt
DROP TABLE IF EXISTS `notafiscal_crt`;
CREATE TABLE IF NOT EXISTS `notafiscal_crt` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` int DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_crt: ~3 rows (aproximadamente)
INSERT INTO `notafiscal_crt` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, 'Simples Nacional', 1, NULL, NULL),
	(2, 'Simples Nacional, Excesso sublimite de receita bruta', 2, NULL, NULL),
	(3, 'Regime Normal', 3, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_dup
DROP TABLE IF EXISTS `notafiscal_dup`;
CREATE TABLE IF NOT EXISTS `notafiscal_dup` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `ndup` text COLLATE utf8mb3_unicode_ci,
  `vdup` double DEFAULT NULL,
  `dvenc` date DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_dup_1` (`notafiscal_id`),
  CONSTRAINT `fk_notafiscal_dup_1` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_dup: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_finnfe
DROP TABLE IF EXISTS `notafiscal_finnfe`;
CREATE TABLE IF NOT EXISTS `notafiscal_finnfe` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_finnfe: ~4 rows (aproximadamente)
INSERT INTO `notafiscal_finnfe` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '1 - Nf-e normal', '1', NULL, NULL),
	(2, '2 - Nf-e complementar', '2', NULL, NULL),
	(3, '3 - Nf-e de ajuste', '3', NULL, NULL),
	(4, '4 - Devolução de mercadoria', '4', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_frete_volumes
DROP TABLE IF EXISTS `notafiscal_frete_volumes`;
CREATE TABLE IF NOT EXISTS `notafiscal_frete_volumes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `qVol` int DEFAULT NULL,
  `nVol` text COLLATE utf8mb3_unicode_ci,
  `esp` text COLLATE utf8mb3_unicode_ci,
  `marca` text COLLATE utf8mb3_unicode_ci,
  `pesol` double DEFAULT NULL,
  `pesob` double DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_frete_volumes_1` (`notafiscal_id`),
  CONSTRAINT `fk_notafiscal_frete_volumes_1` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_frete_volumes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_iddest
DROP TABLE IF EXISTS `notafiscal_iddest`;
CREATE TABLE IF NOT EXISTS `notafiscal_iddest` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_iddest: ~3 rows (aproximadamente)
INSERT INTO `notafiscal_iddest` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '1 - Operação Interna', '1', NULL, NULL),
	(2, '2 - Operação Interestadual', '2', NULL, NULL),
	(3, '3 - Operação com Exterior', '3', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_indfinal
DROP TABLE IF EXISTS `notafiscal_indfinal`;
CREATE TABLE IF NOT EXISTS `notafiscal_indfinal` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_indfinal: ~2 rows (aproximadamente)
INSERT INTO `notafiscal_indfinal` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '0 - Não', '0', NULL, NULL),
	(2, '1 - Sim', '1', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_indiedest
DROP TABLE IF EXISTS `notafiscal_indiedest`;
CREATE TABLE IF NOT EXISTS `notafiscal_indiedest` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_indiedest: ~3 rows (aproximadamente)
INSERT INTO `notafiscal_indiedest` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '1 - Contribuinte ICMS', '1', NULL, NULL),
	(2, '2 - Contribuinte ISENTO', '2', NULL, NULL),
	(3, '9 - Não Contribuinte', '9', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_indpag
DROP TABLE IF EXISTS `notafiscal_indpag`;
CREATE TABLE IF NOT EXISTS `notafiscal_indpag` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_indpag: ~3 rows (aproximadamente)
INSERT INTO `notafiscal_indpag` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '0 - Pagamento a vista', '0', NULL, NULL),
	(2, '1 - Pagamento a prazo', '1', NULL, NULL),
	(3, '2 - Outros', '2', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_indpres
DROP TABLE IF EXISTS `notafiscal_indpres`;
CREATE TABLE IF NOT EXISTS `notafiscal_indpres` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_indpres: ~6 rows (aproximadamente)
INSERT INTO `notafiscal_indpres` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '0 - Não se aplica', '0', NULL, NULL),
	(2, '1 - Operação Presencial', '1', NULL, NULL),
	(3, '2 - Operação NÃO presencial , pela INTERNET', '2', NULL, NULL),
	(4, '3 - Operação NÃO presencial , pela TELEATENDIMENTO', '3', NULL, NULL),
	(5, '5 - Operação presencial, fora do estabelecimento', '5', NULL, NULL),
	(6, '9 - Operação NÃO presencial ,OUTROS', '9', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_item_indtot
DROP TABLE IF EXISTS `notafiscal_item_indtot`;
CREATE TABLE IF NOT EXISTS `notafiscal_item_indtot` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_item_indtot: ~2 rows (aproximadamente)
INSERT INTO `notafiscal_item_indtot` (`id`, `descricao`, `valor`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, '0=Valor do item (vProd) não compõe o valor total da NF-e', 0, NULL, '', '', NULL),
	(2, '1=Valor do item (vProd) compõe o valor total da NF-e (vProd) (v2.0)', 1, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_item_modbc
DROP TABLE IF EXISTS `notafiscal_item_modbc`;
CREATE TABLE IF NOT EXISTS `notafiscal_item_modbc` (
  `id` int NOT NULL AUTO_INCREMENT,
  `codigo` int DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_item_modbc: ~4 rows (aproximadamente)
INSERT INTO `notafiscal_item_modbc` (`id`, `codigo`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 0, '0=Margem Valor Agregado (%);', NULL, '', '', NULL),
	(2, 1, '1=Pauta (Valor);', NULL, '', '', NULL),
	(3, 2, '2=Preço Tabelado Máx. (valor);', NULL, '', '', NULL),
	(4, 3, '3=Valor da operação', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_item_modbcst
DROP TABLE IF EXISTS `notafiscal_item_modbcst`;
CREATE TABLE IF NOT EXISTS `notafiscal_item_modbcst` (
  `id` int NOT NULL AUTO_INCREMENT,
  `codigo` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_item_modbcst: ~6 rows (aproximadamente)
INSERT INTO `notafiscal_item_modbcst` (`id`, `codigo`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 0, '0=Preço tabelado ou máximo sugerido;', NULL, '', '', NULL),
	(2, 1, '1=Lista Negativa (valor);', NULL, '', '', NULL),
	(3, 2, '2=Lista Positiva (valor);', NULL, '', '', NULL),
	(4, 3, '3=Lista Neutra (valor);', NULL, '', '', NULL),
	(5, 4, '4=Margem Valor Agregado (%);', NULL, '', '', NULL),
	(6, 5, '5=Pauta (valor);', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_item_motdesicms
DROP TABLE IF EXISTS `notafiscal_item_motdesicms`;
CREATE TABLE IF NOT EXISTS `notafiscal_item_motdesicms` (
  `id` int NOT NULL AUTO_INCREMENT,
  `codigo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_item_motdesicms: ~13 rows (aproximadamente)
INSERT INTO `notafiscal_item_motdesicms` (`id`, `codigo`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, '1', 'Táxi', NULL, '', '', NULL),
	(2, '3', 'Produtor Agropecuário', NULL, '', '', NULL),
	(3, '4', 'Frotista/Locadora', NULL, '', '', NULL),
	(4, '5', 'Diplomático/Consular', NULL, '', '', NULL),
	(5, '7', 'SUFRAMA', NULL, '', '', NULL),
	(6, '8', 'Venda a Órgão Público', NULL, '', '', NULL),
	(7, '9', 'Outros', NULL, '', '', NULL),
	(8, '10', 'Deficiente Condutor (Convênio ICMS 38/12)', NULL, '', '', NULL),
	(9, '11', 'Deficiente Não Condutor (Convênio ICMS 38/12)', NULL, '', '', NULL),
	(10, '12', 'Órgão de fomento e desenvolvimento agropecuário', NULL, '', '', NULL),
	(11, '16', 'Olimpíadas Rio 2016', NULL, '', '', NULL),
	(12, '90', 'Solicitado pelo Fisco', NULL, '', '', NULL),
	(13, '6', 'Utilitários e Motocicletas da Amazônia Ocidental e Áreas de Livre Comércio', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_item_orig
DROP TABLE IF EXISTS `notafiscal_item_orig`;
CREATE TABLE IF NOT EXISTS `notafiscal_item_orig` (
  `id` int NOT NULL AUTO_INCREMENT,
  `codigo` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_item_orig: ~9 rows (aproximadamente)
INSERT INTO `notafiscal_item_orig` (`id`, `codigo`, `descricao`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 0, '0 - Nacional, exceto as indicadas nos códigos 3, 4, 5 e 8;', NULL, '', '', NULL),
	(2, 1, '1 - Estrangeira - Importação direta, exceto a indicada no código 6;', NULL, '', '', NULL),
	(3, 2, '2 - Estrangeira - Adquirida no mercado interno, exceto a indicada no código 7;', NULL, '', '', NULL),
	(4, 3, '3 - Nacional, mercadoria ou bem com Conteúdo de Importação superior a 40% e inferior ou igual a 70%;', NULL, '', '', NULL),
	(5, 4, '4 - Nacional, cuja produção tenha sido feita em conformidade com os processos produtivos básicos de que tratam as legislações citadas nos Ajustes;', NULL, '', '', NULL),
	(6, 5, '5 - Nacional, mercadoria ou bem com Conteúdo de Importação inferior ou igual a 40%;', NULL, '', '', NULL),
	(7, 6, '6 - Estrangeira - Importação direta, sem similar nacional, constante em lista da CAMEX e gás natural;', NULL, '', '', NULL),
	(8, 7, '7 - Estrangeira - Adquirida no mercado interno, sem similar nacional, constante lista CAMEX e gás natural.', NULL, '', '', NULL),
	(9, 8, '8 - Nacional, mercadoria ou bem com Conteúdo de Importação superior a 70%;', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_itens
DROP TABLE IF EXISTS `notafiscal_itens`;
CREATE TABLE IF NOT EXISTS `notafiscal_itens` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `nitem` int DEFAULT NULL,
  `cean` varchar(50) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `xprod` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `ncm` text COLLATE utf8mb3_unicode_ci,
  `nve` text COLLATE utf8mb3_unicode_ci,
  `extipi` text COLLATE utf8mb3_unicode_ci,
  `cfop` text COLLATE utf8mb3_unicode_ci,
  `ucom` text COLLATE utf8mb3_unicode_ci,
  `qcom` double NOT NULL,
  `vuncom` double NOT NULL,
  `vprod` double DEFAULT NULL,
  `ceantrib` text COLLATE utf8mb3_unicode_ci,
  `utrib` text COLLATE utf8mb3_unicode_ci,
  `qtrib` double DEFAULT NULL,
  `vuntrib` double DEFAULT NULL,
  `vfrete` double DEFAULT NULL,
  `vseg` double DEFAULT NULL,
  `vdesc` double DEFAULT NULL,
  `vtottrib` double DEFAULT NULL,
  `xped` text COLLATE utf8mb3_unicode_ci,
  `nitemped` int DEFAULT NULL,
  `notafiscal_item_indtot_id` int DEFAULT NULL,
  `notafiscal_item_orig_id` int NOT NULL,
  `notafiscal_item_modbc_id` int DEFAULT NULL,
  `icms_basecalc` double DEFAULT NULL,
  `icms_cst` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `icms_valor` double DEFAULT NULL,
  `icms_aliquota` double DEFAULT NULL,
  `icms_pcredsn` double DEFAULT NULL,
  `icms_vcredicmssn` double DEFAULT NULL,
  `icms_predbc` double DEFAULT NULL,
  `icms_pst` double DEFAULT NULL,
  `icms_pmvast` double DEFAULT NULL,
  `icms_predbcst` double DEFAULT NULL,
  `icms_vbcst` double DEFAULT NULL,
  `icms_picmsst` double DEFAULT NULL,
  `icms_vicmsst` double DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `pis_cst` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `pis_valor` double DEFAULT NULL,
  `pis_aliquota` double DEFAULT NULL,
  `pis_valor_base` double DEFAULT NULL,
  `cofins_cst` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `cofins_valor_base` double DEFAULT NULL,
  `cofins_aliquota` double DEFAULT NULL,
  `cofins_valor` double DEFAULT NULL,
  `voutro` double DEFAULT NULL,
  `infadprod` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_item_motDesICMS_id` int DEFAULT NULL,
  `cprod` text COLLATE utf8mb3_unicode_ci,
  `ipi_cst` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `ipi_valor_base` double DEFAULT NULL,
  `ipi_aliquota` double DEFAULT NULL,
  `ipi_vipidevol` double DEFAULT NULL,
  `ipi_valor` double DEFAULT NULL,
  `ipi_pdevol` double DEFAULT NULL,
  `cest` text COLLATE utf8mb3_unicode_ci,
  `fcp_pfcp` double DEFAULT NULL,
  `fcp_vfcp` double DEFAULT NULL,
  `fcp_vbcfcp` double DEFAULT NULL,
  `fcp_vbcfcpst` double DEFAULT NULL,
  `fcp_pfcpst` double DEFAULT NULL,
  `fcp_vfcpst` double DEFAULT NULL,
  `fcp_vbcfcpstret` double DEFAULT NULL,
  `fcp_pfcpstret` double DEFAULT NULL,
  `fcp_vfcpstret` double DEFAULT NULL,
  `icms_vbcufdest` double DEFAULT NULL,
  `icms_vbcfcpufdest` double DEFAULT NULL,
  `icms_pfcpufdest` double DEFAULT NULL,
  `icms_vfcpufdest` double DEFAULT NULL,
  `icms_picmsinter` double DEFAULT NULL,
  `icms_picmsinterpart` double DEFAULT NULL,
  `icms_vicmsufdest` double DEFAULT NULL,
  `icms_vicmsufremet` double DEFAULT NULL,
  `icms_picmsufdest` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_itens_6` (`notafiscal_item_motDesICMS_id`),
  KEY `fk_notafiscal_itens_4` (`notafiscal_item_orig_id`),
  KEY `fk_notafiscal_itens_5` (`notafiscal_item_modbc_id`),
  KEY `fk_notafiscal_itens_1` (`notafiscal_id`),
  KEY `fk_notafiscal_itens_2` (`produto_id`),
  KEY `fk_notafiscal_itens_3` (`notafiscal_item_indtot_id`),
  CONSTRAINT `fk_notafiscal_itens_1` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`),
  CONSTRAINT `fk_notafiscal_itens_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_notafiscal_itens_3` FOREIGN KEY (`notafiscal_item_indtot_id`) REFERENCES `notafiscal_item_indtot` (`id`),
  CONSTRAINT `fk_notafiscal_itens_4` FOREIGN KEY (`notafiscal_item_orig_id`) REFERENCES `notafiscal_item_orig` (`id`),
  CONSTRAINT `fk_notafiscal_itens_5` FOREIGN KEY (`notafiscal_item_modbc_id`) REFERENCES `notafiscal_item_modbc` (`id`),
  CONSTRAINT `fk_notafiscal_itens_6` FOREIGN KEY (`notafiscal_item_motDesICMS_id`) REFERENCES `notafiscal_item_motdesicms` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_itens: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_logs
DROP TABLE IF EXISTS `notafiscal_logs`;
CREATE TABLE IF NOT EXISTS `notafiscal_logs` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `system_users_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_logs_1` (`system_users_id`),
  KEY `fk_notafiscal_logs_2` (`notafiscal_id`),
  CONSTRAINT `fk_notafiscal_logs_1` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_notafiscal_logs_2` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_logs: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_mod
DROP TABLE IF EXISTS `notafiscal_mod`;
CREATE TABLE IF NOT EXISTS `notafiscal_mod` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `modelo` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_mod: ~2 rows (aproximadamente)
INSERT INTO `notafiscal_mod` (`id`, `descricao`, `modelo`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'NF-e', '55', NULL, '', '', NULL),
	(2, 'NFC-e', '65', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_modfrete
DROP TABLE IF EXISTS `notafiscal_modfrete`;
CREATE TABLE IF NOT EXISTS `notafiscal_modfrete` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_modfrete: ~6 rows (aproximadamente)
INSERT INTO `notafiscal_modfrete` (`id`, `descricao`, `valor`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Contratação do Frete por conta do Remetente (CIF)', '0', NULL, '', '', NULL),
	(2, 'Contratação do Frete por conta do Destinatário (FOB)', '1', NULL, '', '', NULL),
	(3, 'Contratação do Frete por conta de Terceiros', '2', NULL, '', '', NULL),
	(4, 'Transporte Próprio por conta do Remetente', '3', NULL, '', '', NULL),
	(5, 'Transporte Próprio por conta do Destinatário', '4', NULL, '', '', NULL),
	(6, 'Sem Ocorrência de Transporte', '9', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_pag
DROP TABLE IF EXISTS `notafiscal_pag`;
CREATE TABLE IF NOT EXISTS `notafiscal_pag` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `notafiscal_tpag_id` int NOT NULL,
  `tpag` text COLLATE utf8mb3_unicode_ci,
  `vpag` double DEFAULT NULL,
  `xpag` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_pag_1` (`notafiscal_id`),
  KEY `fk_notafiscal_pag_2` (`notafiscal_tpag_id`),
  CONSTRAINT `fk_notafiscal_pag_1` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`),
  CONSTRAINT `fk_notafiscal_pag_2` FOREIGN KEY (`notafiscal_tpag_id`) REFERENCES `notafiscal_tpag` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_pag: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_refecf
DROP TABLE IF EXISTS `notafiscal_refecf`;
CREATE TABLE IF NOT EXISTS `notafiscal_refecf` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `notafiscal_refecfmod_id` int NOT NULL,
  `necf` text COLLATE utf8mb3_unicode_ci,
  `ncoo` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_refecf_1` (`notafiscal_refecfmod_id`),
  KEY `fk_notafiscal_refecf_2` (`notafiscal_id`),
  CONSTRAINT `fk_notafiscal_refecf_1` FOREIGN KEY (`notafiscal_refecfmod_id`) REFERENCES `notafiscal_refecfmod` (`id`),
  CONSTRAINT `fk_notafiscal_refecf_2` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_refecf: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_refecfmod
DROP TABLE IF EXISTS `notafiscal_refecfmod`;
CREATE TABLE IF NOT EXISTS `notafiscal_refecfmod` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_refecfmod: ~3 rows (aproximadamente)
INSERT INTO `notafiscal_refecfmod` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '2B', '2B', NULL, NULL),
	(2, '2C', '2C', NULL, NULL),
	(3, '2D', '2D', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_refnfe
DROP TABLE IF EXISTS `notafiscal_refnfe`;
CREATE TABLE IF NOT EXISTS `notafiscal_refnfe` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int NOT NULL,
  `refnfe` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_refnfe_1` (`notafiscal_id`),
  CONSTRAINT `fk_notafiscal_refnfe_1` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_refnfe: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_series
DROP TABLE IF EXISTS `notafiscal_series`;
CREATE TABLE IF NOT EXISTS `notafiscal_series` (
  `id` int NOT NULL AUTO_INCREMENT,
  `serie` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `system_unit_id` int NOT NULL,
  `notafiscal_tpamb_id` int NOT NULL,
  `notafiscal_mod_id` int NOT NULL,
  `sequencial` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `notafiscal_tipodocumento_id` int NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_series_4` (`notafiscal_tipodocumento_id`),
  KEY `fk_notafiscal_series_1` (`notafiscal_tpamb_id`),
  KEY `fk_notafiscal_series_2` (`notafiscal_mod_id`),
  KEY `fk_notafiscal_series_5` (`system_unit_id`),
  CONSTRAINT `fk_notafiscal_series_1` FOREIGN KEY (`notafiscal_tpamb_id`) REFERENCES `notafiscal_tpamb` (`id`),
  CONSTRAINT `fk_notafiscal_series_2` FOREIGN KEY (`notafiscal_mod_id`) REFERENCES `notafiscal_mod` (`id`),
  CONSTRAINT `fk_notafiscal_series_4` FOREIGN KEY (`notafiscal_tipodocumento_id`) REFERENCES `notafiscal_tipodocumento` (`id`),
  CONSTRAINT `fk_notafiscal_series_5` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_series: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_situacao
DROP TABLE IF EXISTS `notafiscal_situacao`;
CREATE TABLE IF NOT EXISTS `notafiscal_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `ordem` int DEFAULT NULL,
  `exibir` tinyint(1) DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_situacao: ~6 rows (aproximadamente)
INSERT INTO `notafiscal_situacao` (`id`, `descricao`, `cor`, `ordem`, `exibir`, `criado_em`, `alterado_em`, `criado_por`, `alterado_por`) VALUES
	(1, 'Em Digitação', '#FF9800', 1, 1, NULL, NULL, 'Sistema Kraft', ''),
	(2, 'Autorizada', '#4CAF50', 2, 1, NULL, NULL, 'Sistema Kraft', ''),
	(3, 'Cancelada', '#F44336', 3, 1, NULL, NULL, 'Sistema Kraft', ''),
	(4, 'Denegada', '', NULL, 0, NULL, NULL, 'Sistema Kraft', ''),
	(5, 'Rejeitada', '', NULL, 0, NULL, NULL, 'Sistema Kraft', ''),
	(6, 'Processada Offline', '', NULL, 0, NULL, NULL, 'Sistema Kraft', '');

-- Copiando estrutura para tabela erp_nuvem.notafiscal_situacao_sefaz
DROP TABLE IF EXISTS `notafiscal_situacao_sefaz`;
CREATE TABLE IF NOT EXISTS `notafiscal_situacao_sefaz` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_situacao_id` int NOT NULL,
  `codigo_sefaz` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_situacao_sefaz_1` (`notafiscal_situacao_id`),
  CONSTRAINT `fk_notafiscal_situacao_sefaz_1` FOREIGN KEY (`notafiscal_situacao_id`) REFERENCES `notafiscal_situacao` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_situacao_sefaz: ~2 rows (aproximadamente)
INSERT INTO `notafiscal_situacao_sefaz` (`id`, `notafiscal_situacao_id`, `codigo_sefaz`) VALUES
	(1, 2, 100),
	(2, 3, 101);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_tipodocumento
DROP TABLE IF EXISTS `notafiscal_tipodocumento`;
CREATE TABLE IF NOT EXISTS `notafiscal_tipodocumento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_tipodocumento: ~2 rows (aproximadamente)
INSERT INTO `notafiscal_tipodocumento` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, '0 - Entrada', '0', NULL, NULL),
	(2, '1 - Saída', '1', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_tipodoc_series
DROP TABLE IF EXISTS `notafiscal_tipodoc_series`;
CREATE TABLE IF NOT EXISTS `notafiscal_tipodoc_series` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_series_id` int NOT NULL,
  `notafiscal_tipodocumento_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_notafiscal_tipodoc_series_1` (`notafiscal_series_id`),
  KEY `fk_notafiscal_tipodoc_series_2` (`notafiscal_tipodocumento_id`),
  CONSTRAINT `fk_notafiscal_tipodoc_series_1` FOREIGN KEY (`notafiscal_series_id`) REFERENCES `notafiscal_series` (`id`),
  CONSTRAINT `fk_notafiscal_tipodoc_series_2` FOREIGN KEY (`notafiscal_tipodocumento_id`) REFERENCES `notafiscal_tipodocumento` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_tipodoc_series: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.notafiscal_tpag
DROP TABLE IF EXISTS `notafiscal_tpag`;
CREATE TABLE IF NOT EXISTS `notafiscal_tpag` (
  `id` int NOT NULL AUTO_INCREMENT,
  `tpag` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_tpag: ~12 rows (aproximadamente)
INSERT INTO `notafiscal_tpag` (`id`, `tpag`, `criado_em`, `descricao`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, '01 ', NULL, 'Dinheiro ', '', '', NULL),
	(2, '02', NULL, 'Cheque', '', '', NULL),
	(3, '03', NULL, 'Cartão de Crédito', '', '', NULL),
	(4, '04', NULL, 'Cartão de Débito', '', '', NULL),
	(5, '05', NULL, 'Crédito Loja', '', '', NULL),
	(6, '10', NULL, 'Vale Alimentação', '', '', NULL),
	(7, '11', NULL, 'Vale Refeição', '', '', NULL),
	(8, '12', NULL, 'Vale Presente', '', '', NULL),
	(9, '13', NULL, 'Vale Combustivel', '', '', NULL),
	(10, '15', NULL, 'Boleto Bancário', '', '', NULL),
	(11, '90', NULL, 'Sem Pagamento', '', '', NULL),
	(12, '99', NULL, 'Outros', '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_tpamb
DROP TABLE IF EXISTS `notafiscal_tpamb`;
CREATE TABLE IF NOT EXISTS `notafiscal_tpamb` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_tpamb: ~2 rows (aproximadamente)
INSERT INTO `notafiscal_tpamb` (`id`, `descricao`, `valor`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Produção', '1', NULL, '', '', NULL),
	(2, 'Homologação', '2', NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_tpemis
DROP TABLE IF EXISTS `notafiscal_tpemis`;
CREATE TABLE IF NOT EXISTS `notafiscal_tpemis` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_tpemis: ~9 rows (aproximadamente)
INSERT INTO `notafiscal_tpemis` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, 'Normal', '1', NULL, NULL),
	(2, 'Contingência', '2', NULL, NULL),
	(3, 'SCAN', '3', NULL, NULL),
	(4, 'DPEC', '4', NULL, NULL),
	(5, 'FS-DA', '5', NULL, NULL),
	(6, 'SVC-AN', '6', NULL, NULL),
	(7, 'SVC-RS', '7', NULL, NULL),
	(8, 'SVC-SP', '8', NULL, NULL),
	(9, 'OffLine', '9', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.notafiscal_tpimp
DROP TABLE IF EXISTS `notafiscal_tpimp`;
CREATE TABLE IF NOT EXISTS `notafiscal_tpimp` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `valor` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.notafiscal_tpimp: ~6 rows (aproximadamente)
INSERT INTO `notafiscal_tpimp` (`id`, `descricao`, `valor`, `criado_em`, `alterado_em`) VALUES
	(1, 'Sem geração de DANFE', '0', NULL, NULL),
	(2, 'DANFE normal, Retrato', '1', NULL, NULL),
	(3, 'DANFE normal, Paisagem', '2', NULL, NULL),
	(4, 'DANFE Simplificado', '3', NULL, NULL),
	(5, 'DANFE NFC-e', '4', NULL, NULL),
	(6, 'DANFE NFC-e em mensagem eletronica', '5', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.nota_fiscal_compra
DROP TABLE IF EXISTS `nota_fiscal_compra`;
CREATE TABLE IF NOT EXISTS `nota_fiscal_compra` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `fornecedor_id` int DEFAULT NULL,
  `numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `data_emissao` datetime DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `natop` text COLLATE utf8mb3_unicode_ci,
  `data_saida` datetime DEFAULT NULL,
  `infcpl` text COLLATE utf8mb3_unicode_ci,
  `infadfisco` text COLLATE utf8mb3_unicode_ci,
  `icms_basecalc` double DEFAULT NULL,
  `icms_valor` double DEFAULT NULL,
  `icms_subst_base_calc` double DEFAULT NULL,
  `icms_subst_valor` double DEFAULT NULL,
  `frete_valor` double DEFAULT NULL,
  `seguro_valor` double DEFAULT NULL,
  `outras_despesas` double DEFAULT NULL,
  `ipi_valor` double DEFAULT NULL,
  `serie` text COLLATE utf8mb3_unicode_ci,
  `valor_total_produtos` double DEFAULT NULL,
  `valor_total_nota` double DEFAULT NULL,
  `transp_nome` text COLLATE utf8mb3_unicode_ci,
  `transp_cnpj` text COLLATE utf8mb3_unicode_ci,
  `transp_inscest` text COLLATE utf8mb3_unicode_ci,
  `transp_endereco` text COLLATE utf8mb3_unicode_ci,
  `transp_cidade` text COLLATE utf8mb3_unicode_ci,
  `transp_placaveiculo` text COLLATE utf8mb3_unicode_ci,
  `transp_uf` text COLLATE utf8mb3_unicode_ci,
  `transp_veiculouf` text COLLATE utf8mb3_unicode_ci,
  `transp_veiculorntc` text COLLATE utf8mb3_unicode_ci,
  `transp_numeracao` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_tipodocumento_id` int NOT NULL,
  `nota_fiscal_compra_situacao_id` int NOT NULL,
  `notafiscal_crt_id` int DEFAULT NULL,
  `obs_importacao_xml` text COLLATE utf8mb3_unicode_ci,
  `cliente_endereco` text COLLATE utf8mb3_unicode_ci,
  `cliente_complemento` text COLLATE utf8mb3_unicode_ci,
  `cliente_numero` text COLLATE utf8mb3_unicode_ci,
  `cliente_bairro` text COLLATE utf8mb3_unicode_ci,
  `cliente_cidade` text COLLATE utf8mb3_unicode_ci,
  `cliente_cep` text COLLATE utf8mb3_unicode_ci,
  `cliente_estado` text COLLATE utf8mb3_unicode_ci,
  `cliente_nome` text COLLATE utf8mb3_unicode_ci,
  `cliente_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `cliente_inscest` text COLLATE utf8mb3_unicode_ci,
  `cliente_fone` text COLLATE utf8mb3_unicode_ci,
  `cliente_cidade_codibge` text COLLATE utf8mb3_unicode_ci,
  `cliente_inscmuni` text COLLATE utf8mb3_unicode_ci,
  `cliente_suframa` text COLLATE utf8mb3_unicode_ci,
  `justificativa_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `chave` text COLLATE utf8mb3_unicode_ci,
  `protocolo_envio` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_indiedest_id` int DEFAULT NULL,
  `protocolo_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `datahora_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `cce_datahora_evento` text COLLATE utf8mb3_unicode_ci,
  `cce_sequencial` text COLLATE utf8mb3_unicode_ci,
  `cce_correcao` text COLLATE utf8mb3_unicode_ci,
  `cce_protocolo` text COLLATE utf8mb3_unicode_ci,
  `desconto_valor` double DEFAULT NULL,
  `pis_valor` double DEFAULT NULL,
  `cofins_valor` double DEFAULT NULL,
  `fatura_numero` text COLLATE utf8mb3_unicode_ci,
  `fatura_valor_original` text COLLATE utf8mb3_unicode_ci,
  `fatura_valor_desconto` double DEFAULT NULL,
  `fatura_valor_liquido` double DEFAULT NULL,
  `notafiscal_iddest_id` int NOT NULL,
  `notafiscal_tpimp_id` int DEFAULT NULL,
  `notafiscal_finnfe_id` int NOT NULL,
  `notafiscal_indfinal_id` int NOT NULL,
  `notafiscal_indpres_id` int NOT NULL,
  `verproc` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_indpag_id` int DEFAULT NULL,
  `retirada_marcado` int DEFAULT NULL,
  `retirada_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `retirada_xlgr` text COLLATE utf8mb3_unicode_ci,
  `retirada_nro` text COLLATE utf8mb3_unicode_ci,
  `retirada_xcpl` text COLLATE utf8mb3_unicode_ci,
  `retirada_xbairro` text COLLATE utf8mb3_unicode_ci,
  `retirada_cmun` int DEFAULT NULL,
  `retirada_xmun` text COLLATE utf8mb3_unicode_ci,
  `retirada_uf` text COLLATE utf8mb3_unicode_ci,
  `entrega_marcado` int DEFAULT NULL,
  `entrega_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `entrega_xlgr` text COLLATE utf8mb3_unicode_ci,
  `entrega_nro` text COLLATE utf8mb3_unicode_ci,
  `entrega_xcpl` text COLLATE utf8mb3_unicode_ci,
  `entrega_xbairro` text COLLATE utf8mb3_unicode_ci,
  `entrega_cmun` text COLLATE utf8mb3_unicode_ci,
  `entrega_xmun` text COLLATE utf8mb3_unicode_ci,
  `entrega_uf` text COLLATE utf8mb3_unicode_ci,
  `vicmsufdest` double DEFAULT NULL,
  `vicmsufremet` double DEFAULT NULL,
  `vfcpufdest` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_mod_id` int NOT NULL,
  `xml` text COLLATE utf8mb3_unicode_ci,
  `data_hora_envio` datetime DEFAULT NULL,
  `xml_cancelamento` text COLLATE utf8mb3_unicode_ci,
  `issqn_vserv` double DEFAULT NULL,
  `issqn_vbc` double DEFAULT NULL,
  `issqn_viss` double DEFAULT NULL,
  `issqn_dcompet` date DEFAULT NULL,
  `issqn_reftrib` text COLLATE utf8mb3_unicode_ci,
  `icms_vfcp` double DEFAULT NULL,
  `icms_vfcpst` double DEFAULT NULL,
  `icms_vfcpstret` double DEFAULT NULL,
  `layout_versao` text COLLATE utf8mb3_unicode_ci,
  `ipi_vipidevol` double DEFAULT NULL,
  `vtroco` date DEFAULT NULL,
  `notafiscal_modfrete_id` int DEFAULT NULL,
  `cpag_lancada` tinyint(1) DEFAULT NULL,
  `dest_cnpj` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_nota_fiscal_compra_1` (`system_unit_id`),
  KEY `fk_nota_fiscal_compra_2` (`fornecedor_id`),
  KEY `fk_nota_fiscal_compra_3` (`notafiscal_tipodocumento_id`),
  KEY `fk_nota_fiscal_compra_4` (`nota_fiscal_compra_situacao_id`),
  KEY `fk_nota_fiscal_compra_5` (`notafiscal_crt_id`),
  KEY `fk_nota_fiscal_compra_6` (`notafiscal_indiedest_id`),
  KEY `fk_nota_fiscal_compra_7` (`notafiscal_iddest_id`),
  KEY `fk_nota_fiscal_compra_8` (`notafiscal_tpimp_id`),
  KEY `fk_nota_fiscal_compra_9` (`notafiscal_finnfe_id`),
  KEY `fk_nota_fiscal_compra_10` (`notafiscal_indfinal_id`),
  KEY `fk_nota_fiscal_compra_11` (`notafiscal_indpres_id`),
  KEY `fk_nota_fiscal_compra_12` (`notafiscal_indpag_id`),
  KEY `fk_nota_fiscal_compra_13` (`notafiscal_mod_id`),
  KEY `fk_nota_fiscal_compra_14` (`notafiscal_modfrete_id`),
  CONSTRAINT `fk_nota_fiscal_compra_1` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_10` FOREIGN KEY (`notafiscal_indfinal_id`) REFERENCES `notafiscal_indfinal` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_11` FOREIGN KEY (`notafiscal_indpres_id`) REFERENCES `notafiscal_indpres` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_12` FOREIGN KEY (`notafiscal_indpag_id`) REFERENCES `notafiscal_indpag` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_13` FOREIGN KEY (`notafiscal_mod_id`) REFERENCES `notafiscal_mod` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_14` FOREIGN KEY (`notafiscal_modfrete_id`) REFERENCES `notafiscal_modfrete` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_2` FOREIGN KEY (`fornecedor_id`) REFERENCES `fornecedor` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_3` FOREIGN KEY (`notafiscal_tipodocumento_id`) REFERENCES `notafiscal_tipodocumento` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_4` FOREIGN KEY (`nota_fiscal_compra_situacao_id`) REFERENCES `nota_fiscal_compra_situacao` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_5` FOREIGN KEY (`notafiscal_crt_id`) REFERENCES `notafiscal_crt` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_6` FOREIGN KEY (`notafiscal_indiedest_id`) REFERENCES `notafiscal_indiedest` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_7` FOREIGN KEY (`notafiscal_iddest_id`) REFERENCES `notafiscal_iddest` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_8` FOREIGN KEY (`notafiscal_tpimp_id`) REFERENCES `notafiscal_tpimp` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_9` FOREIGN KEY (`notafiscal_finnfe_id`) REFERENCES `notafiscal_finnfe` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.nota_fiscal_compra: ~3 rows (aproximadamente)
INSERT INTO `nota_fiscal_compra` (`id`, `system_unit_id`, `fornecedor_id`, `numero`, `data_emissao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `natop`, `data_saida`, `infcpl`, `infadfisco`, `icms_basecalc`, `icms_valor`, `icms_subst_base_calc`, `icms_subst_valor`, `frete_valor`, `seguro_valor`, `outras_despesas`, `ipi_valor`, `serie`, `valor_total_produtos`, `valor_total_nota`, `transp_nome`, `transp_cnpj`, `transp_inscest`, `transp_endereco`, `transp_cidade`, `transp_placaveiculo`, `transp_uf`, `transp_veiculouf`, `transp_veiculorntc`, `transp_numeracao`, `notafiscal_tipodocumento_id`, `nota_fiscal_compra_situacao_id`, `notafiscal_crt_id`, `obs_importacao_xml`, `cliente_endereco`, `cliente_complemento`, `cliente_numero`, `cliente_bairro`, `cliente_cidade`, `cliente_cep`, `cliente_estado`, `cliente_nome`, `cliente_cpfcnpj`, `cliente_inscest`, `cliente_fone`, `cliente_cidade_codibge`, `cliente_inscmuni`, `cliente_suframa`, `justificativa_cancelamento`, `chave`, `protocolo_envio`, `notafiscal_indiedest_id`, `protocolo_cancelamento`, `datahora_cancelamento`, `cce_datahora_evento`, `cce_sequencial`, `cce_correcao`, `cce_protocolo`, `desconto_valor`, `pis_valor`, `cofins_valor`, `fatura_numero`, `fatura_valor_original`, `fatura_valor_desconto`, `fatura_valor_liquido`, `notafiscal_iddest_id`, `notafiscal_tpimp_id`, `notafiscal_finnfe_id`, `notafiscal_indfinal_id`, `notafiscal_indpres_id`, `verproc`, `notafiscal_indpag_id`, `retirada_marcado`, `retirada_cpfcnpj`, `retirada_xlgr`, `retirada_nro`, `retirada_xcpl`, `retirada_xbairro`, `retirada_cmun`, `retirada_xmun`, `retirada_uf`, `entrega_marcado`, `entrega_cpfcnpj`, `entrega_xlgr`, `entrega_nro`, `entrega_xcpl`, `entrega_xbairro`, `entrega_cmun`, `entrega_xmun`, `entrega_uf`, `vicmsufdest`, `vicmsufremet`, `vfcpufdest`, `notafiscal_mod_id`, `xml`, `data_hora_envio`, `xml_cancelamento`, `issqn_vserv`, `issqn_vbc`, `issqn_viss`, `issqn_dcompet`, `issqn_reftrib`, `icms_vfcp`, `icms_vfcpst`, `icms_vfcpstret`, `layout_versao`, `ipi_vipidevol`, `vtroco`, `notafiscal_modfrete_id`, `cpag_lancada`, `dest_cnpj`) VALUES
	(5, 1, 1, '33', '2023-12-30 00:00:00', '2024-03-30 14:59:12', NULL, NULL, 'Administrador', '2024-03-30 22:57:57', 'VENDA DE MERCADORIA ADQUIRIDA', '2023-12-30 19:06:18', NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0, '1', 950, 950, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, 3, 1, '-Esta nota fiscal não foi emitida para esta empresa!<br><br>', 'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B', NULL, 'S/N', 'PARQUE MARAJO', 'NOVO REPARTIMENTO', '68473000', 'PA', 'SH PECAS E SERVICOS MECANICOS LTDA', '37961074000102', '158478622', '96984206564', '1505064', NULL, NULL, NULL, '15231237961074000102550010000000331406166746', '315230000073309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, NULL, NULL, 1, 2, 1, 1, 2, '1.0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 'tmp/15231237961074000102550010000000331406166746-nfe.xml', '2023-12-30 20:06:30', NULL, 0, 0, 0, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, '05641124000170'),
	(6, 1, NULL, '989436', '2023-06-14 22:34:26', '2024-04-19 15:33:42', '2024-04-19 15:35:15', NULL, 'Administrador', '2024-04-19 15:33:42', 'Venda Mercadoria', '2023-06-15 07:30:00', NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0, '2', 574.38, 574.38, NULL, NULL, NULL, NULL, 'MONTES CLAROS', NULL, NULL, NULL, NULL, NULL, 2, 2, 3, '-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA CRYSTAL C/GAS 500ML 12X500ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA CRYSTAL S/GAS 500ML C/12 12X500ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COCA COLA KS 290ML C/24 24X290ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COCA COLA PET 600ML C/6 06X600ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto DV FRUT LARANJA PET 450ML C/6 06X450ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto DV FRUT UVA PET 450ML C/6 06X450ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto EISENBAHN 600ML C/24 RET 24X600ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FANTA LARANJA LATA 350ML C/12 12X350ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FANTA UVA LT 350ML L+P- C/06 06X350ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto THEREZOPOLIS GOLD LN 355ML 06X355ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>', 'AV. DAS INDUSTRIAS', NULL, '173', 'DIST. INDUST', 'MONTES CLAROS', '39404621', 'MG', 'BEBIDAS NOVA GERACAO LTDA', '00328924000545', '0030773180010', '08006012355', '3143302', NULL, NULL, NULL, '31230600328924000545550020009894361403898914', '131235440033029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 7.46, 34.42, NULL, NULL, NULL, NULL, 1, 2, 1, 1, 2, 'IND V.2019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 'tmp/31230600328924000545550020009894361403898914-nfe.xml', '2023-06-14 22:35:18', NULL, 0, 0, 0, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, '48169520000159'),
	(7, 1, 2, '18045', '2023-06-03 00:00:00', '2024-04-19 15:35:22', NULL, 'Administrador', 'Administrador', '2024-04-19 15:46:15', NULL, NULL, NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0, '1', 880.58, 871.36, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, 2, 3, '-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>', 'AV UM LOTE 10 QUAD 8', NULL, '48', 'LOTEAMENTO RESIDENCIAL PARK SUL', 'BOCAIUVA', '39390000', 'MG', 'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A', '04641376015915', '0020488295661', '3131172600', '3107307', NULL, NULL, NULL, '31230604641376015915550010000180451000180469', '131235419061517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 9.22, 0, 0, NULL, NULL, NULL, NULL, 1, 2, 1, 1, 1, '1.0.0.0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, 'tmp/31230604641376015915550010000180451000180469-nfe.xml', '2023-06-03 16:46:12', NULL, 0, 0, 0, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, '48169520000159'),
	(8, 1, 1, '12541', '2024-05-31 02:22:00', '2024-05-31 02:25:25', NULL, NULL, 'Administrador', '2024-05-31 02:26:07', NULL, '2024-05-31 02:22:00', NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0, '1', 50, 45, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, 1, 3, NULL, 'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B', NULL, 'S/N', 'PARQUE MARAJO', NULL, '68473000', NULL, 'SH PECAS E SERVICOS MECANICOS LTDA', '37.961.074/0001-02', '158478622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 5, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 1, 1, 1, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, 1, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, 0, 0, 0, NULL, 0, NULL, 6, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.nota_fiscal_compra_dup
DROP TABLE IF EXISTS `nota_fiscal_compra_dup`;
CREATE TABLE IF NOT EXISTS `nota_fiscal_compra_dup` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nota_fiscal_compra_id` int NOT NULL,
  `forma_pagamento_id` int DEFAULT NULL,
  `plano_conta_id` int DEFAULT NULL,
  `centro_custo_id` int DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `ndup` text COLLATE utf8mb3_unicode_ci,
  `vdup` double DEFAULT NULL,
  `dvenc` date DEFAULT NULL,
  `parcela` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_nota_fiscal_compra_dup_1` (`nota_fiscal_compra_id`),
  KEY `fk_nota_fiscal_compra_dup_2` (`forma_pagamento_id`),
  KEY `fk_nota_fiscal_compra_dup_3` (`plano_conta_id`),
  KEY `fk_nota_fiscal_compra_dup_4` (`centro_custo_id`),
  CONSTRAINT `fk_nota_fiscal_compra_dup_1` FOREIGN KEY (`nota_fiscal_compra_id`) REFERENCES `nota_fiscal_compra` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_dup_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_dup_3` FOREIGN KEY (`plano_conta_id`) REFERENCES `plano_conta` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_dup_4` FOREIGN KEY (`centro_custo_id`) REFERENCES `centro_custo` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.nota_fiscal_compra_dup: ~0 rows (aproximadamente)
INSERT INTO `nota_fiscal_compra_dup` (`id`, `nota_fiscal_compra_id`, `forma_pagamento_id`, `plano_conta_id`, `centro_custo_id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `ndup`, `vdup`, `dvenc`, `parcela`) VALUES
	(1, 8, 2, NULL, NULL, '2024-05-31 02:25:25', NULL, NULL, 'Administrador', NULL, '32156465', 100, '2024-05-31', NULL);

-- Copiando estrutura para tabela erp_nuvem.nota_fiscal_compra_itens
DROP TABLE IF EXISTS `nota_fiscal_compra_itens`;
CREATE TABLE IF NOT EXISTS `nota_fiscal_compra_itens` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nota_fiscal_compra_id` int NOT NULL,
  `produto_id` int DEFAULT NULL,
  `nota_fiscal_compra_itens_situacao_id` int DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `nitem` int DEFAULT NULL,
  `cean` text COLLATE utf8mb3_unicode_ci,
  `xprod` text COLLATE utf8mb3_unicode_ci,
  `ncm` text COLLATE utf8mb3_unicode_ci,
  `nve` text COLLATE utf8mb3_unicode_ci,
  `extipi` text COLLATE utf8mb3_unicode_ci,
  `cfop` text COLLATE utf8mb3_unicode_ci,
  `ucom` text COLLATE utf8mb3_unicode_ci,
  `qcom` double DEFAULT NULL,
  `vuncom` double DEFAULT NULL,
  `vprod` double DEFAULT NULL,
  `ceantrib` text COLLATE utf8mb3_unicode_ci,
  `utrib` text COLLATE utf8mb3_unicode_ci,
  `qtrib` double DEFAULT NULL,
  `vuntrib` double DEFAULT NULL,
  `vfrete` double DEFAULT NULL,
  `vseg` double DEFAULT NULL,
  `vdesc` double DEFAULT NULL,
  `vtottrib` double DEFAULT NULL,
  `xped` text COLLATE utf8mb3_unicode_ci,
  `nitemped` int DEFAULT NULL,
  `notafiscal_item_indtot_id` int DEFAULT NULL,
  `notafiscal_item_orig_id` int NOT NULL,
  `notafiscal_item_modbc_id` int DEFAULT NULL,
  `icms_basecalc` double DEFAULT NULL,
  `icms_cst` text COLLATE utf8mb3_unicode_ci,
  `icms_valor` double DEFAULT NULL,
  `icms_aliquota` double DEFAULT NULL,
  `icms_pcredsn` double DEFAULT NULL,
  `icms_vcredicmssn` double DEFAULT NULL,
  `icms_predbc` double DEFAULT NULL,
  `icms_pst` double DEFAULT NULL,
  `icms_pmvast` double DEFAULT NULL,
  `icms_predbcst` double DEFAULT NULL,
  `icms_vbcst` double DEFAULT NULL,
  `icms_picmsst` double DEFAULT NULL,
  `icms_vicmsst` double DEFAULT NULL,
  `fcp_pfcp` double DEFAULT NULL,
  `pis_cst` text COLLATE utf8mb3_unicode_ci,
  `pis_valor` double DEFAULT NULL,
  `pis_aliquota` double DEFAULT NULL,
  `pis_valor_base` double DEFAULT NULL,
  `cofins_cst` text COLLATE utf8mb3_unicode_ci,
  `cofins_valor_base` double DEFAULT NULL,
  `cofins_aliquota` double DEFAULT NULL,
  `cofins_valor` double DEFAULT NULL,
  `voutro` double DEFAULT NULL,
  `infadprod` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_item_motDesICMS_id` int DEFAULT NULL,
  `cprod` text COLLATE utf8mb3_unicode_ci,
  `ipi_cst` text COLLATE utf8mb3_unicode_ci,
  `ipi_valor_base` double DEFAULT NULL,
  `ipi_aliquota` double DEFAULT NULL,
  `ipi_vipidevol` double DEFAULT NULL,
  `ipi_valor` double DEFAULT NULL,
  `ipi_pdevol` double DEFAULT NULL,
  `estoque_deposito_id` int DEFAULT NULL,
  `produto_lote_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_nota_fiscal_compra_itens_9` (`nota_fiscal_compra_itens_situacao_id`),
  KEY `fk_nota_fiscal_compra_itens_1` (`nota_fiscal_compra_id`),
  KEY `fk_nota_fiscal_compra_itens_2` (`produto_id`),
  KEY `fk_nota_fiscal_compra_itens_3` (`notafiscal_item_indtot_id`),
  KEY `fk_nota_fiscal_compra_itens_4` (`notafiscal_item_orig_id`),
  KEY `fk_nota_fiscal_compra_itens_5` (`notafiscal_item_modbc_id`),
  KEY `fk_nota_fiscal_compra_itens_6` (`notafiscal_item_motDesICMS_id`),
  KEY `fk_nota_fiscal_compra_itens_7` (`estoque_deposito_id`),
  KEY `fk_nota_fiscal_compra_itens_8` (`produto_lote_id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_1` FOREIGN KEY (`nota_fiscal_compra_id`) REFERENCES `nota_fiscal_compra` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_3` FOREIGN KEY (`notafiscal_item_indtot_id`) REFERENCES `notafiscal_item_indtot` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_4` FOREIGN KEY (`notafiscal_item_orig_id`) REFERENCES `notafiscal_item_orig` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_5` FOREIGN KEY (`notafiscal_item_modbc_id`) REFERENCES `notafiscal_item_modbc` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_6` FOREIGN KEY (`notafiscal_item_motDesICMS_id`) REFERENCES `notafiscal_item_motdesicms` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_7` FOREIGN KEY (`estoque_deposito_id`) REFERENCES `estoque_deposito` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_8` FOREIGN KEY (`produto_lote_id`) REFERENCES `produto_lote` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_itens_9` FOREIGN KEY (`nota_fiscal_compra_itens_situacao_id`) REFERENCES `nota_fiscal_compra_itens_situacao` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=46 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.nota_fiscal_compra_itens: ~44 rows (aproximadamente)
INSERT INTO `nota_fiscal_compra_itens` (`id`, `nota_fiscal_compra_id`, `produto_id`, `nota_fiscal_compra_itens_situacao_id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `nitem`, `cean`, `xprod`, `ncm`, `nve`, `extipi`, `cfop`, `ucom`, `qcom`, `vuncom`, `vprod`, `ceantrib`, `utrib`, `qtrib`, `vuntrib`, `vfrete`, `vseg`, `vdesc`, `vtottrib`, `xped`, `nitemped`, `notafiscal_item_indtot_id`, `notafiscal_item_orig_id`, `notafiscal_item_modbc_id`, `icms_basecalc`, `icms_cst`, `icms_valor`, `icms_aliquota`, `icms_pcredsn`, `icms_vcredicmssn`, `icms_predbc`, `icms_pst`, `icms_pmvast`, `icms_predbcst`, `icms_vbcst`, `icms_picmsst`, `icms_vicmsst`, `fcp_pfcp`, `pis_cst`, `pis_valor`, `pis_aliquota`, `pis_valor_base`, `cofins_cst`, `cofins_valor_base`, `cofins_aliquota`, `cofins_valor`, `voutro`, `infadprod`, `notafiscal_item_motDesICMS_id`, `cprod`, `ipi_cst`, `ipi_valor_base`, `ipi_aliquota`, `ipi_vipidevol`, `ipi_valor`, `ipi_pdevol`, `estoque_deposito_id`, `produto_lote_id`) VALUES
	(1, 5, 5, NULL, '2024-03-30 14:59:12', NULL, NULL, NULL, '2024-03-30 21:47:48', NULL, 'SEM GTIN', 'BATERIA 150 AMPERES MOURA', '85071090', NULL, NULL, '5102', 'UN', 1, 950, 950, 'SEM GTIN', 'UN', 1, 950, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '500', 0, 0, 0, 0, 0, NULL, NULL, 0, 0, 0, 0, NULL, '07', 0, 0, 0, '07', 0, 0, 0, 0, NULL, NULL, '28', '53', 0, 0, NULL, 0, NULL, 1, NULL),
	(2, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900531008', 'AGUA CRYSTAL C/GAS 500ML 12X500ML', '22011000', NULL, NULL, '5405', 'DZ', 1, 17.28, 17.28, '7894900531008', 'UN', 12, 1.44, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 18, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '201106', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(3, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900530001', 'AGUA CRYSTAL S/GAS 500ML C/12 12X500ML', '22011000', NULL, NULL, '5405', 'DZ', 10, 15.36, 153.6, '7894900530001', 'UN', 120, 1.28, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 18, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '201107', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(4, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900015034', 'COCA COLA KS 290ML C/24 24X290ML', '22021000', NULL, NULL, '5405', 'CX', 1, 45.36, 45.36, '7894900015034', 'UN', 24, 1.89, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 20, NULL, 0, 0, 0, 0, NULL, '02', 0.84, 1.86, 45.36, '02', 45.36, 8.54, 3.87, 0, NULL, NULL, '055399', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(5, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900011609', 'COCA COLA PET 600ML C/6 06X600ML', '22021000', NULL, NULL, '5405', 'FD', 3, 24, 72, '7894900011609', 'UN', 18, 4, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 20, NULL, 0, 0, 0, 0, NULL, '02', 1.33, 1.86, 72, '02', 72, 8.54, 6.14, 0, NULL, NULL, '100415', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(6, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900556056', 'DV FRUT LARANJA PET 450ML C/6 06X450ML', '22021000', NULL, NULL, '5405', 'FD', 1, 17.1, 17.1, '7894900556056', 'UN', 6, 2.85, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 18, NULL, 0, 0, 0, 0, NULL, '02', 0.31, 1.86, 17.1, '02', 17.1, 8.54, 1.46, 0, NULL, NULL, '118955', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(7, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900550054', 'DV FRUT UVA PET 450ML C/6 06X450ML', '22021000', NULL, NULL, '5405', 'FD', 1, 17.1, 17.1, '7894900550054', 'UN', 6, 2.85, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 18, NULL, 0, 0, 0, 0, NULL, '02', 0.31, 1.86, 17.1, '02', 17.1, 8.54, 1.46, 0, NULL, NULL, '118798', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(8, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7898367983615', 'EISENBAHN 600ML C/24 RET 24X600ML', '22030000', NULL, NULL, '5405', 'CX', 1, 152.16, 152.16, '7898367983615', 'UN', 24, 6.34, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 25, NULL, 0, 0, 0, 0, NULL, '02', 2.83, 1.86, 152.16, '02', 152.16, 8.54, 12.99, 0, NULL, NULL, '139468', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(9, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900030013', 'FANTA LARANJA LATA 350ML C/12 12X350ML', '22021000', NULL, NULL, '5405', 'DZ', 1, 31.8, 31.8, '7894900030013', 'UN', 12, 2.65, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 20, NULL, 0, 0, 0, 0, NULL, '02', 0.59, 1.86, 31.8, '02', 31.8, 8.54, 2.71, 0, NULL, NULL, '155441', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(10, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7894900050226', 'FANTA UVA LT 350ML L+P- C/06 06X350ML', '22021000', NULL, NULL, '5405', 'FD', 1, 15.9, 15.9, '7894900050226', 'UN', 6, 2.65, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 20, NULL, 0, 0, 0, 0, NULL, '02', 0.29, 1.86, 15.9, '02', 15.9, 8.54, 1.35, 0, NULL, NULL, '155761', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(11, 6, NULL, NULL, '2024-04-19 15:33:42', NULL, NULL, NULL, NULL, NULL, '7896371000175', 'THEREZOPOLIS GOLD LN 355ML 06X355ML', '22030000', NULL, NULL, '5405', 'CX', 2, 26.04, 52.08, '7896371000175', 'UN', 12, 4.34, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '60', 0, 0, 0, 0, 0, 23, NULL, 0, 0, 0, 0, NULL, '02', 0.96, 1.86, 52.08, '02', 52.08, 8.54, 4.44, 0, NULL, NULL, '139649', NULL, 0, 0, NULL, 0, NULL, NULL, NULL),
	(12, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7893595535100', 'FEIJAO CARIOCA TIA GRAM 1KG', '07133399', NULL, NULL, '5929', 'PT', 3, 6.99, 20.97, '7893595535100', 'PT', 3, 6.99, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '270054', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(13, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7898507968748', 'LARANJA PERA RIO 10KG PT', '08051000', NULL, NULL, '5929', 'PT', 1, 25.9, 25.9, '7898507968748', 'PT', 1, 25.9, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '188471', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(14, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896029046296', 'RACAO GATOS WHISKAS SALMAO 85G SH', '23091000', NULL, NULL, '5929', 'SH', 1, 3.29, 3.29, '7896029046296', 'SH', 1, 3.29, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '89506', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(15, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7898949747765', 'COUVE FLOR NECTAR 300G BJ', '07041000', NULL, NULL, '5929', 'BJ', 2, 13.98, 27.96, '7898949747765', 'BJ', 2, 13.98, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '232210', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(16, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7898949747284', 'PIMENTA BIQUINHO NECTAR VITA 200G BJ', '07096000', NULL, NULL, '5929', 'BJ', 2, 5.99, 11.98, '7898949747284', 'BJ', 2, 5.99, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '87250', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(17, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896029046623', 'RACAO GATOS WHISKAS CASTR.CARNE 85G', '23099010', NULL, NULL, '5929', 'SH', 1, 3.29, 3.29, '7896029046623', 'SH', 1, 3.29, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '257183', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(18, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '0000000067454', 'CENOURA VERMELHA KG', '07061000', NULL, NULL, '5929', 'KG', 1.61, 4.98, 8.02, '0000000067454', 'KG', 1.61, 4.98, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '6745', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(19, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896417204239', 'MAC.VILMA OVOS LINGUINE 500G PT', '19021100', NULL, NULL, '5929', 'PT', 5, 4.78, 23.9, '7896417204239', 'PT', 5, 4.78, 0, 0, 1.4, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '10808', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(20, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896104999905', 'GUARD.MILI 21X22CM PT', '48183000', NULL, NULL, '5929', 'PT', 7, 1.65, 11.55, '7896104999905', 'PT', 7, 1.65, 0, 0, 0.49, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '9684', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(21, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896051111023', 'LEITE L.V.BH INTEG.1L TP', '04012010', NULL, NULL, '5929', 'TP', 2, 4.28, 8.56, '7896051111023', 'TP', 2, 4.28, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '103186', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(22, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896029046197', 'RACAO GATOS WHISKAS CORDEIRO 85G SH', '23091000', NULL, NULL, '5929', 'SH', 1, 3.29, 3.29, '7896029046197', 'SH', 1, 3.29, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '73200', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(23, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7891132009367', 'SAL CHURRASCO AJI SAL 2KG PT', '21039029', NULL, NULL, '5929', 'PT', 1, 26.7, 26.7, '7891132009367', 'PT', 1, 26.7, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '263859', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(24, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7891050000101', 'WHISKY PASSPORT 1L GF', '22083020', NULL, NULL, '5929', 'GF', 1, 64.9, 64.9, '7891050000101', 'GF', 1, 64.9, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '10717', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(25, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896029046555', 'RACAO GATOS WHISKAS CASTR.PEIXE 85G SH', '23091000', NULL, NULL, '5929', 'SH', 1, 3.29, 3.29, '7896029046555', 'SH', 1, 3.29, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '266165', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(26, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '0000000067164', 'BACON SADIA MANTA VACUO KG BAKN', '02101900', NULL, NULL, '5929', 'KG', 3.026, 26.98, 81.64, '0000000067164', 'KG', 3.026, 26.98, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '6716', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(27, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896417204437', 'MAC.VILMA OVOS ESPAG.N9 500G PT', '19021100', NULL, NULL, '5929', 'PT', 1, 4.78, 4.78, '7896417204437', 'PT', 1, 4.78, 0, 0, 0.28, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '12091', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(28, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896716311669', 'LINGUICA PAMPLONA CALAB.1KG PT', '16010000', NULL, NULL, '5929', 'PT', 4, 18.98, 75.92, '7896716311669', 'PT', 4, 18.98, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '147363', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(29, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '0000000199933', 'PIMENTAO AMARELO/VERMELHO KG', '07096000', NULL, NULL, '5929', 'KG', 2.47, 17.68, 43.67, '0000000199933', 'KG', 2.47, 17.68, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '88994', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(30, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '0000000064248', 'TOMATE LONGA VIDA KG', '07020000', NULL, NULL, '5929', 'KG', 3.435, 7.89, 27.1, '0000000064248', 'KG', 3.435, 7.89, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '6424', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(31, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7898921567411', 'BATATA CONG.UAI 2KG PT', '20041000', NULL, NULL, '5929', 'PT', 5, 23.98, 119.9, '7898921567411', 'PT', 5, 23.98, 0, 0, 6, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '132120', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(32, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896035210001', 'SAL REFINADO CISNE 1KG PT', '25010020', NULL, NULL, '5929', 'PT', 2, 3.98, 7.96, '7896035210001', 'PT', 2, 3.98, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '49651', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(33, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '0000000067416', 'CEBOLA AMARELA KG', '07031019', NULL, NULL, '5929', 'KG', 2.225, 4.98, 11.08, '0000000067416', 'KG', 2.225, 4.98, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '6741', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(34, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896029047279', 'RACAO GATOS WHISKAS FILHOTE FRANGO 85G', '23099010', NULL, NULL, '5929', 'SH', 1, 3.29, 3.29, '7896029047279', 'SH', 1, 3.29, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '88147', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(35, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7898904964077', 'OVOS BCOS.SOMAI JUMBO C/40 CX', '04071100', NULL, NULL, '5929', 'CX', 1, 39.9, 39.9, '7898904964077', 'CX', 1, 39.9, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '258498', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(36, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896389905110', 'FARINHA MAND.XAP CRUA 1KG PT', '11062000', NULL, NULL, '5929', 'PT', 2, 5.78, 11.56, '7896389905110', 'PT', 2, 5.78, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '2261', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(37, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896029077641', 'RACAO GATOS WHISKAS ATUM 85G SH', '23099010', NULL, NULL, '5929', 'SH', 1, 3.29, 3.29, '7896029077641', 'SH', 1, 3.29, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '73197', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(38, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7898915457063', 'AGUA SANIT.BH 5L FR', '28289011', NULL, NULL, '5929', 'FR', 1, 8.95, 8.95, '7898915457063', 'FR', 1, 8.95, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '141518', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(39, 7, NULL, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, NULL, NULL, '7896104992487', 'TOALHA PAP.MILI GRAN CHEF C/200 PT', '48189090', NULL, NULL, '5929', 'PT', 3, 6.9, 20.7, '7896104992487', 'PT', 3, 6.9, 0, 0, 1.05, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '278525', '99', 0, 0, NULL, 0, NULL, NULL, NULL),
	(40, 7, 10, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, '2024-04-19 15:46:15', NULL, '7898949747611', 'BROCOLIS NINJA NECTAR VITA 200G BJ', '07041000', NULL, NULL, '5929', 'BJ', 2, 11.98, 23.96, '7898949747611', 'BJ', 2, 11.98, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '160427', '99', 0, 0, NULL, 0, NULL, 2, NULL),
	(41, 7, 9, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, '2024-04-19 15:45:48', NULL, '7897121000766', 'ALHO FRITO ALHO ROXO 400G PT', '20059900', NULL, NULL, '5929', 'PT', 1, 23.99, 23.99, '7897121000766', 'PT', 1, 23.99, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '180578', '99', 0, 0, NULL, 0, NULL, 2, NULL),
	(42, 7, 8, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, '2024-04-19 15:37:04', NULL, '7896242200048', 'OLEO SOJA ABC 900ML FR', '15079011', NULL, NULL, '5929', 'FR', 20, 4.99, 99.8, '7896242200048', 'FR', 20, 4.99, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '6580', '99', 0, 0, NULL, 0, NULL, 2, NULL),
	(43, 7, 7, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, '2024-04-19 15:36:32', NULL, '0000000071314', 'TOMATE ITALIANO ANDREA KG', '07020000', NULL, NULL, '5929', 'KG', 1.215, 7.89, 9.59, '0000000071314', 'KG', 1.215, 7.89, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '06', 0, 0, 0, '06', 0, 0, 0, 0, NULL, NULL, '7131', '99', 0, 0, NULL, 0, NULL, 2, NULL),
	(44, 7, 6, NULL, '2024-04-19 15:35:23', NULL, NULL, NULL, '2024-04-19 15:36:19', NULL, '7899306041724', 'RACAO GATOS BAW WAW MIX 900G PT', '23099010', NULL, NULL, '5929', 'PT', 1, 19.9, 19.9, '7899306041724', 'PT', 1, 19.9, 0, 0, 0, NULL, NULL, NULL, NULL, 1, NULL, 0, '40', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0, NULL, '01', 0, 0, 0, '01', 0, 0, 0, 0, NULL, NULL, '271852', '99', 0, 0, NULL, 0, NULL, 2, NULL),
	(45, 8, 9, NULL, '2024-05-31 02:26:07', NULL, NULL, NULL, NULL, NULL, NULL, 'ALHO FRITO ALHO ROXO 400G PT', '20059900', NULL, NULL, NULL, 'UNID', 1, 50, 50, NULL, 'UNID', 1, 50, 0, 0, 5, NULL, NULL, NULL, NULL, 1, NULL, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '9', NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL);

-- Copiando estrutura para tabela erp_nuvem.nota_fiscal_compra_itens_situacao
DROP TABLE IF EXISTS `nota_fiscal_compra_itens_situacao`;
CREATE TABLE IF NOT EXISTS `nota_fiscal_compra_itens_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.nota_fiscal_compra_itens_situacao: ~2 rows (aproximadamente)
INSERT INTO `nota_fiscal_compra_itens_situacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Produto vinculado', NULL, NULL, '', '', NULL),
	(2, 'Produto sem vinculo', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.nota_fiscal_compra_pag
DROP TABLE IF EXISTS `nota_fiscal_compra_pag`;
CREATE TABLE IF NOT EXISTS `nota_fiscal_compra_pag` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nota_fiscal_compra_id` int NOT NULL,
  `notafiscal_tpag_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `tpag` text COLLATE utf8mb3_unicode_ci,
  `vpag` double DEFAULT NULL,
  `xpag` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_nota_fiscal_compra_pag_1` (`nota_fiscal_compra_id`),
  KEY `fk_nota_fiscal_compra_pag_2` (`notafiscal_tpag_id`),
  CONSTRAINT `fk_nota_fiscal_compra_pag_1` FOREIGN KEY (`nota_fiscal_compra_id`) REFERENCES `nota_fiscal_compra` (`id`),
  CONSTRAINT `fk_nota_fiscal_compra_pag_2` FOREIGN KEY (`notafiscal_tpag_id`) REFERENCES `notafiscal_tpag` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.nota_fiscal_compra_pag: ~0 rows (aproximadamente)
INSERT INTO `nota_fiscal_compra_pag` (`id`, `nota_fiscal_compra_id`, `notafiscal_tpag_id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `tpag`, `vpag`, `xpag`) VALUES
	(1, 8, 1, '2024-05-31 02:25:25', NULL, NULL, 'Administrador', NULL, NULL, 100, NULL);

-- Copiando estrutura para tabela erp_nuvem.nota_fiscal_compra_situacao
DROP TABLE IF EXISTS `nota_fiscal_compra_situacao`;
CREATE TABLE IF NOT EXISTS `nota_fiscal_compra_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.nota_fiscal_compra_situacao: ~4 rows (aproximadamente)
INSERT INTO `nota_fiscal_compra_situacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `cor`) VALUES
	(1, 'Em Digitação', NULL, NULL, '', 'Sistema Kraft', NULL, ''),
	(2, 'Importada faltando ajustes', NULL, NULL, '', 'Sistema Kraft', NULL, ''),
	(3, 'Finalizada', NULL, NULL, '', 'Sistema Kraft', NULL, ''),
	(4, 'Cancelada', NULL, NULL, '', 'Sistema Kraft', NULL, '');

-- Copiando estrutura para tabela erp_nuvem.orcamento
DROP TABLE IF EXISTS `orcamento`;
CREATE TABLE IF NOT EXISTS `orcamento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `orcamento_situacao_id` int NOT NULL,
  `vendedor_id` int DEFAULT NULL,
  `cliente_id` int DEFAULT NULL,
  `cliente_contato_id` int DEFAULT NULL,
  `data_orcamento` date NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `valor_produtos` double NOT NULL,
  `desconto` double DEFAULT NULL,
  `peso_total` double DEFAULT NULL,
  `frete_total` double DEFAULT NULL,
  `valor_total` double NOT NULL,
  `tabela_preco_id` int DEFAULT NULL,
  `justificativa_reprovacao` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_orcamento_1` (`cliente_id`),
  KEY `fk_orcamento_2` (`vendedor_id`),
  KEY `fk_orcamento_3` (`orcamento_situacao_id`),
  KEY `fk_orcamento_4` (`cliente_contato_id`),
  KEY `fk_orcamento_5` (`system_unit_id`),
  KEY `fk_orcamento_6` (`tabela_preco_id`),
  CONSTRAINT `fk_orcamento_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_orcamento_2` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_orcamento_3` FOREIGN KEY (`orcamento_situacao_id`) REFERENCES `orcamento_situacao` (`id`),
  CONSTRAINT `fk_orcamento_4` FOREIGN KEY (`cliente_contato_id`) REFERENCES `cliente_contato` (`id`),
  CONSTRAINT `fk_orcamento_5` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_orcamento_6` FOREIGN KEY (`tabela_preco_id`) REFERENCES `tabela_preco` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.orcamento: ~1 rows (aproximadamente)
INSERT INTO `orcamento` (`id`, `system_unit_id`, `orcamento_situacao_id`, `vendedor_id`, `cliente_id`, `cliente_contato_id`, `data_orcamento`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `observacao`, `valor_produtos`, `desconto`, `peso_total`, `frete_total`, `valor_total`, `tabela_preco_id`, `justificativa_reprovacao`) VALUES
	(5, 1, 1, 1, 1, 1, '2024-05-30', '2024-05-30 19:11:12', NULL, 'Administrador', 'Administrador', '2024-06-04 01:27:11', NULL, 1250, 0, 0, 0, 1250, NULL, NULL),
	(6, 1, 1, NULL, 1, NULL, '2024-06-06', '2024-06-06 10:48:19', NULL, NULL, 'Administrador', NULL, NULL, 1235, 0, 0, 0, 1235, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.orcamento_interacoes
DROP TABLE IF EXISTS `orcamento_interacoes`;
CREATE TABLE IF NOT EXISTS `orcamento_interacoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `orcamento_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_orcamento_interacoes_1` (`orcamento_id`),
  CONSTRAINT `fk_orcamento_interacoes_1` FOREIGN KEY (`orcamento_id`) REFERENCES `orcamento` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.orcamento_interacoes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.orcamento_item
DROP TABLE IF EXISTS `orcamento_item`;
CREATE TABLE IF NOT EXISTS `orcamento_item` (
  `id` int NOT NULL AUTO_INCREMENT,
  `orcamento_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade` double DEFAULT NULL,
  `valor_unitario` double DEFAULT NULL,
  `valor_total` double DEFAULT NULL,
  `valor_original` double DEFAULT NULL,
  `valor_custo` double DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  `informacoes_adicionais` text COLLATE utf8mb3_unicode_ci,
  `numero_pedido` text COLLATE utf8mb3_unicode_ci,
  `numero_item_pedido` text COLLATE utf8mb3_unicode_ci,
  `valor_frete` double DEFAULT NULL,
  `peso_unitario` double DEFAULT NULL,
  `peso_total` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_orcamento_item_1` (`orcamento_id`),
  KEY `fk_orcamento_item_2` (`produto_id`),
  CONSTRAINT `fk_orcamento_item_1` FOREIGN KEY (`orcamento_id`) REFERENCES `orcamento` (`id`),
  CONSTRAINT `fk_orcamento_item_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.orcamento_item: ~0 rows (aproximadamente)
INSERT INTO `orcamento_item` (`id`, `orcamento_id`, `produto_id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `quantidade`, `valor_unitario`, `valor_total`, `valor_original`, `valor_custo`, `desconto`, `informacoes_adicionais`, `numero_pedido`, `numero_item_pedido`, `valor_frete`, `peso_unitario`, `peso_total`) VALUES
	(1, 5, 5, '2024-05-30 19:11:12', NULL, NULL, NULL, '2024-06-04 01:27:11', 1, 950, 950, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(2, 5, 6, '2024-06-04 00:12:45', NULL, NULL, NULL, '2024-06-04 01:27:11', 3, 100, 300, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(3, 6, 5, '2024-06-06 10:48:19', NULL, NULL, NULL, '2024-06-06 10:48:19', 1, 1235, 1235, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.orcamento_situacao
DROP TABLE IF EXISTS `orcamento_situacao`;
CREATE TABLE IF NOT EXISTS `orcamento_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `ordem` int DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.orcamento_situacao: ~4 rows (aproximadamente)
INSERT INTO `orcamento_situacao` (`id`, `descricao`, `cor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `ordem`) VALUES
	(1, 'Aberto', '', NULL, NULL, '', 'Sistema Kraft', NULL, 1),
	(2, 'Aprovado', '', NULL, NULL, '', 'Sistema Kraft', NULL, 2),
	(3, 'Reprovado', '', NULL, NULL, '', 'Sistema Kraft', NULL, 3),
	(4, 'Cancelado', '', NULL, NULL, '', 'Sistema Kraft', NULL, 4);

-- Copiando estrutura para tabela erp_nuvem.orcamento_situacao_historico
DROP TABLE IF EXISTS `orcamento_situacao_historico`;
CREATE TABLE IF NOT EXISTS `orcamento_situacao_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `orcamento_situacao_id` int NOT NULL,
  `orcamento_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_orcamento_situacao_historico_1` (`orcamento_situacao_id`),
  KEY `fk_orcamento_situacao_historico_2` (`orcamento_id`),
  CONSTRAINT `fk_orcamento_situacao_historico_1` FOREIGN KEY (`orcamento_situacao_id`) REFERENCES `orcamento_situacao` (`id`),
  CONSTRAINT `fk_orcamento_situacao_historico_2` FOREIGN KEY (`orcamento_id`) REFERENCES `orcamento` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.orcamento_situacao_historico: ~1 rows (aproximadamente)
INSERT INTO `orcamento_situacao_historico` (`id`, `orcamento_situacao_id`, `orcamento_id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(11, 1, 5, 'Situação do Orçamento: Aberto', '2024-05-30 19:11:12', NULL, NULL, 'Administrador', NULL),
	(12, 1, 5, 'Situação do Orçamento: Aberto', '2024-06-04 00:12:45', NULL, NULL, 'Administrador', NULL),
	(13, 1, 5, 'Situação do Orçamento: Aberto', '2024-06-04 01:27:11', NULL, NULL, 'Administrador', NULL),
	(14, 1, 6, 'Situação do Orçamento: Aberto', '2024-06-06 10:48:19', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.ordem_producao
DROP TABLE IF EXISTS `ordem_producao`;
CREATE TABLE IF NOT EXISTS `ordem_producao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `ordem_producao_situacao_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `produto_ficha_tecnica_id` int NOT NULL,
  `estoque_deposito_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade` double NOT NULL,
  `data_producao` date NOT NULL,
  `observacoes` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_producao_1` (`ordem_producao_situacao_id`),
  KEY `fk_ordem_producao_2` (`produto_ficha_tecnica_id`),
  KEY `fk_ordem_producao_3` (`produto_id`),
  KEY `fk_ordem_producao_4` (`system_unit_id`),
  KEY `fk_ordem_producao_5` (`estoque_deposito_id`),
  CONSTRAINT `fk_ordem_producao_1` FOREIGN KEY (`ordem_producao_situacao_id`) REFERENCES `ordem_producao_situacao` (`id`),
  CONSTRAINT `fk_ordem_producao_2` FOREIGN KEY (`produto_ficha_tecnica_id`) REFERENCES `produto_ficha_tecnica` (`id`),
  CONSTRAINT `fk_ordem_producao_3` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_ordem_producao_4` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_ordem_producao_5` FOREIGN KEY (`estoque_deposito_id`) REFERENCES `estoque_deposito` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_producao: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_producao_etapas
DROP TABLE IF EXISTS `ordem_producao_etapas`;
CREATE TABLE IF NOT EXISTS `ordem_producao_etapas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_producao_id` int NOT NULL,
  `ordem_producao_etapas_situacao_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `ordem` int DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_producao_etapas_2` (`ordem_producao_etapas_situacao_id`),
  KEY `fk_ordem_producao_etapas_1` (`ordem_producao_id`),
  CONSTRAINT `fk_ordem_producao_etapas_1` FOREIGN KEY (`ordem_producao_id`) REFERENCES `ordem_producao` (`id`),
  CONSTRAINT `fk_ordem_producao_etapas_2` FOREIGN KEY (`ordem_producao_etapas_situacao_id`) REFERENCES `ordem_producao_etapas_situacao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_producao_etapas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_producao_etapas_situacao
DROP TABLE IF EXISTS `ordem_producao_etapas_situacao`;
CREATE TABLE IF NOT EXISTS `ordem_producao_etapas_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_producao_etapas_situacao: ~3 rows (aproximadamente)
INSERT INTO `ordem_producao_etapas_situacao` (`id`, `descricao`, `cor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Pendente', '', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Em Andamento', '', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Finalizada', '', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.ordem_producao_itens
DROP TABLE IF EXISTS `ordem_producao_itens`;
CREATE TABLE IF NOT EXISTS `ordem_producao_itens` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_producao_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `estoque_deposito_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade` double NOT NULL,
  `quantidade_total` double NOT NULL,
  `custo` double DEFAULT NULL,
  `custo_total` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_producao_itens_2` (`produto_id`),
  KEY `fk_ordem_producao_itens_1` (`ordem_producao_id`),
  KEY `fk_ordem_producao_itens_3` (`estoque_deposito_id`),
  CONSTRAINT `fk_ordem_producao_itens_1` FOREIGN KEY (`ordem_producao_id`) REFERENCES `ordem_producao` (`id`),
  CONSTRAINT `fk_ordem_producao_itens_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_ordem_producao_itens_3` FOREIGN KEY (`estoque_deposito_id`) REFERENCES `estoque_deposito` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_producao_itens: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_producao_situacao
DROP TABLE IF EXISTS `ordem_producao_situacao`;
CREATE TABLE IF NOT EXISTS `ordem_producao_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_producao_situacao: ~4 rows (aproximadamente)
INSERT INTO `ordem_producao_situacao` (`id`, `descricao`, `cor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Pendente', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Em Andamento', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Finalizada', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'Cancelada', NULL, NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.ordem_producao_situacao_historico
DROP TABLE IF EXISTS `ordem_producao_situacao_historico`;
CREATE TABLE IF NOT EXISTS `ordem_producao_situacao_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_producao_id` int NOT NULL,
  `ordem_producao_situacao_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_producao_situacao_historico_1` (`ordem_producao_situacao_id`),
  KEY `fk_ordem_producao_situacao_historico_2` (`ordem_producao_id`),
  CONSTRAINT `fk_ordem_producao_situacao_historico_1` FOREIGN KEY (`ordem_producao_situacao_id`) REFERENCES `ordem_producao_situacao` (`id`),
  CONSTRAINT `fk_ordem_producao_situacao_historico_2` FOREIGN KEY (`ordem_producao_id`) REFERENCES `ordem_producao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_producao_situacao_historico: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_producao_vendas
DROP TABLE IF EXISTS `ordem_producao_vendas`;
CREATE TABLE IF NOT EXISTS `ordem_producao_vendas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_producao_id` int NOT NULL,
  `venda_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_producao_vendas_1` (`ordem_producao_id`),
  KEY `fk_ordem_producao_vendas_2` (`venda_id`),
  CONSTRAINT `fk_ordem_producao_vendas_1` FOREIGN KEY (`ordem_producao_id`) REFERENCES `ordem_producao` (`id`),
  CONSTRAINT `fk_ordem_producao_vendas_2` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_producao_vendas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico
DROP TABLE IF EXISTS `ordem_servico`;
CREATE TABLE IF NOT EXISTS `ordem_servico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `cliente_id` int NOT NULL,
  `cliente_contato_id` int DEFAULT NULL,
  `vendedor_id` int DEFAULT NULL,
  `ordem_servico_situacao_id` int NOT NULL,
  `ordem_servico_producao_etapa_id` int DEFAULT NULL,
  `condicao_pagamento_id` int DEFAULT NULL,
  `cliente_endereco_id` int DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `numero_os` int DEFAULT NULL,
  `numero_orcamento` int DEFAULT NULL,
  `data_emissao` date NOT NULL,
  `valor` double NOT NULL,
  `desconto` double DEFAULT NULL,
  `prazo_entrega` date DEFAULT NULL,
  `validade_dias` int DEFAULT NULL,
  `data_abertura_os` date DEFAULT NULL,
  `vendedor_comissao` double DEFAULT NULL,
  `vendedor_comissao_avista` double DEFAULT NULL,
  `vendedor_comissao_aprazo` double DEFAULT NULL,
  `observacoes` text COLLATE utf8mb3_unicode_ci,
  `prazo_garantia` date DEFAULT NULL,
  `valor_pago` double DEFAULT NULL,
  `motivo_nao_aprovacao_orcamento` text COLLATE utf8mb3_unicode_ci,
  `valor_avista` double DEFAULT NULL,
  `valor_aprazo` double DEFAULT NULL,
  `valor_faturado_vendas` double DEFAULT NULL,
  `usuario_aprovacao_id` int DEFAULT NULL,
  `informacoes_transporte` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_7` (`ordem_servico_producao_etapa_id`),
  KEY `fk_ordem_servico_8` (`usuario_aprovacao_id`),
  KEY `fk_ordem_servico_9` (`system_unit_id`),
  KEY `fk_ordem_servico_1` (`cliente_id`),
  KEY `fk_ordem_servico_2` (`vendedor_id`),
  KEY `fk_ordem_servico_3` (`ordem_servico_situacao_id`),
  KEY `fk_ordem_servico_4` (`condicao_pagamento_id`),
  KEY `fk_ordem_servico_5` (`cliente_endereco_id`),
  CONSTRAINT `fk_ordem_servico_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_ordem_servico_2` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_ordem_servico_3` FOREIGN KEY (`ordem_servico_situacao_id`) REFERENCES `ordem_servico_situacao` (`id`),
  CONSTRAINT `fk_ordem_servico_4` FOREIGN KEY (`condicao_pagamento_id`) REFERENCES `condicao_pagamento` (`id`),
  CONSTRAINT `fk_ordem_servico_5` FOREIGN KEY (`cliente_endereco_id`) REFERENCES `cliente_endereco` (`id`),
  CONSTRAINT `fk_ordem_servico_7` FOREIGN KEY (`ordem_servico_producao_etapa_id`) REFERENCES `ordem_servico_producao_etapa` (`id`),
  CONSTRAINT `fk_ordem_servico_8` FOREIGN KEY (`usuario_aprovacao_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_ordem_servico_9` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_garantia_historico
DROP TABLE IF EXISTS `ordem_servico_garantia_historico`;
CREATE TABLE IF NOT EXISTS `ordem_servico_garantia_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_id` int NOT NULL,
  `observacoes` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_garantia_historico_1` (`ordem_servico_id`),
  CONSTRAINT `fk_ordem_servico_garantia_historico_1` FOREIGN KEY (`ordem_servico_id`) REFERENCES `ordem_servico` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_garantia_historico: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_historico
DROP TABLE IF EXISTS `ordem_servico_historico`;
CREATE TABLE IF NOT EXISTS `ordem_servico_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_situacao_id` int NOT NULL,
  `ordem_servico_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_historico_1` (`ordem_servico_id`),
  KEY `fk_ordem_servico_historico_2` (`ordem_servico_situacao_id`),
  CONSTRAINT `fk_ordem_servico_historico_1` FOREIGN KEY (`ordem_servico_id`) REFERENCES `ordem_servico` (`id`),
  CONSTRAINT `fk_ordem_servico_historico_2` FOREIGN KEY (`ordem_servico_situacao_id`) REFERENCES `ordem_servico_situacao` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_historico: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_item
DROP TABLE IF EXISTS `ordem_servico_item`;
CREATE TABLE IF NOT EXISTS `ordem_servico_item` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `descricao_servico` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade` double NOT NULL,
  `quantidade_atendida` double DEFAULT NULL,
  `valor_unitario` double NOT NULL,
  `valor_total` double NOT NULL,
  `desconto` double DEFAULT NULL,
  `arquivo` text COLLATE utf8mb3_unicode_ci,
  `largura` double DEFAULT NULL,
  `altura` double DEFAULT NULL,
  `quantidade_a_faturar` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_item_1` (`ordem_servico_id`),
  KEY `fk_ordem_servico_item_2` (`produto_id`),
  CONSTRAINT `fk_ordem_servico_item_1` FOREIGN KEY (`ordem_servico_id`) REFERENCES `ordem_servico` (`id`),
  CONSTRAINT `fk_ordem_servico_item_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_item: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_item_despesas
DROP TABLE IF EXISTS `ordem_servico_item_despesas`;
CREATE TABLE IF NOT EXISTS `ordem_servico_item_despesas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_item_id` int NOT NULL,
  `despesas_servicos_id` int NOT NULL,
  `despesas_servicos_tipo_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `valor_unitario` double NOT NULL,
  `quantidade` double NOT NULL,
  `valor_total` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_item_despesas_2` (`despesas_servicos_id`),
  KEY `fk_ordem_servico_item_despesas_3` (`despesas_servicos_tipo_id`),
  KEY `fk_ordem_servico_item_despesas_4` (`ordem_servico_item_id`),
  CONSTRAINT `fk_ordem_servico_item_despesas_2` FOREIGN KEY (`despesas_servicos_id`) REFERENCES `despesas_servicos` (`id`),
  CONSTRAINT `fk_ordem_servico_item_despesas_3` FOREIGN KEY (`despesas_servicos_tipo_id`) REFERENCES `despesas_servicos_tipo` (`id`),
  CONSTRAINT `fk_ordem_servico_item_despesas_4` FOREIGN KEY (`ordem_servico_item_id`) REFERENCES `ordem_servico_item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_item_despesas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_item_ficha_tecnica
DROP TABLE IF EXISTS `ordem_servico_item_ficha_tecnica`;
CREATE TABLE IF NOT EXISTS `ordem_servico_item_ficha_tecnica` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_item_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `quantidade_fixa_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade` double NOT NULL,
  `custo` double DEFAULT NULL,
  `valor_unitario` double DEFAULT NULL,
  `valor_total` double DEFAULT NULL,
  `quantidade_original` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_item_ficha_tecnica_1` (`ordem_servico_item_id`),
  KEY `fk_ordem_servico_item_ficha_tecnica_2` (`produto_id`),
  KEY `fk_ordem_servico_item_ficha_tecnica_3` (`quantidade_fixa_id`),
  CONSTRAINT `fk_ordem_servico_item_ficha_tecnica_1` FOREIGN KEY (`ordem_servico_item_id`) REFERENCES `ordem_servico_item` (`id`),
  CONSTRAINT `fk_ordem_servico_item_ficha_tecnica_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_ordem_servico_item_ficha_tecnica_3` FOREIGN KEY (`quantidade_fixa_id`) REFERENCES `resposta` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_item_ficha_tecnica: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_item_mao_obra
DROP TABLE IF EXISTS `ordem_servico_item_mao_obra`;
CREATE TABLE IF NOT EXISTS `ordem_servico_item_mao_obra` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_item_id` int NOT NULL,
  `funcionario_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade_horas` double DEFAULT NULL,
  `valor_hora` double DEFAULT NULL,
  `valor_total` double DEFAULT NULL,
  `quantidade_horas_original` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_item_mao_obra_1` (`ordem_servico_item_id`),
  KEY `fk_ordem_servico_item_mao_obra_2` (`funcionario_id`),
  CONSTRAINT `fk_ordem_servico_item_mao_obra_1` FOREIGN KEY (`ordem_servico_item_id`) REFERENCES `ordem_servico_item` (`id`),
  CONSTRAINT `fk_ordem_servico_item_mao_obra_2` FOREIGN KEY (`funcionario_id`) REFERENCES `funcionario` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_item_mao_obra: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_item_obs_etapas
DROP TABLE IF EXISTS `ordem_servico_item_obs_etapas`;
CREATE TABLE IF NOT EXISTS `ordem_servico_item_obs_etapas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_item_id` int NOT NULL,
  `ordem_servico_producao_etapa_id` int NOT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_item_obs_etapas_1` (`ordem_servico_item_id`),
  KEY `fk_ordem_servico_item_obs_etapas_2` (`ordem_servico_producao_etapa_id`),
  CONSTRAINT `fk_ordem_servico_item_obs_etapas_1` FOREIGN KEY (`ordem_servico_item_id`) REFERENCES `ordem_servico_item` (`id`),
  CONSTRAINT `fk_ordem_servico_item_obs_etapas_2` FOREIGN KEY (`ordem_servico_producao_etapa_id`) REFERENCES `ordem_servico_producao_etapa` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_item_obs_etapas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_producao_etapa
DROP TABLE IF EXISTS `ordem_servico_producao_etapa`;
CREATE TABLE IF NOT EXISTS `ordem_servico_producao_etapa` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_producao_etapa: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_situacao
DROP TABLE IF EXISTS `ordem_servico_situacao`;
CREATE TABLE IF NOT EXISTS `ordem_servico_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_situacao: ~5 rows (aproximadamente)
INSERT INTO `ordem_servico_situacao` (`id`, `descricao`, `cor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Orçamento Aberto', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Orçamento Aprovado', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Orçamento Recusado', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'O.S. Paga Parcialmente', NULL, NULL, NULL, '', 'Sistema Kraft', NULL),
	(5, 'O.S. Faturada', NULL, NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.ordem_servico_venda
DROP TABLE IF EXISTS `ordem_servico_venda`;
CREATE TABLE IF NOT EXISTS `ordem_servico_venda` (
  `id` int NOT NULL AUTO_INCREMENT,
  `ordem_servico_id` int NOT NULL,
  `venda_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_ordem_servico_venda_1` (`ordem_servico_id`),
  KEY `fk_ordem_servico_venda_2` (`venda_id`),
  CONSTRAINT `fk_ordem_servico_venda_1` FOREIGN KEY (`ordem_servico_id`) REFERENCES `ordem_servico` (`id`),
  CONSTRAINT `fk_ordem_servico_venda_2` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.ordem_servico_venda: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.painel_indicadores
DROP TABLE IF EXISTS `painel_indicadores`;
CREATE TABLE IF NOT EXISTS `painel_indicadores` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.painel_indicadores: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.painel_indicador_usuario
DROP TABLE IF EXISTS `painel_indicador_usuario`;
CREATE TABLE IF NOT EXISTS `painel_indicador_usuario` (
  `id` int NOT NULL AUTO_INCREMENT,
  `painel_indicadores_id` int NOT NULL,
  `indicador_personalizado_id` int NOT NULL,
  `system_users_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_painel_indicador_usuario_1` (`painel_indicadores_id`),
  KEY `fk_painel_indicador_usuario_2` (`indicador_personalizado_id`),
  KEY `fk_painel_indicador_usuario_3` (`system_users_id`),
  CONSTRAINT `fk_painel_indicador_usuario_1` FOREIGN KEY (`painel_indicadores_id`) REFERENCES `painel_indicadores` (`id`),
  CONSTRAINT `fk_painel_indicador_usuario_2` FOREIGN KEY (`indicador_personalizado_id`) REFERENCES `indicador_personalizado` (`id`),
  CONSTRAINT `fk_painel_indicador_usuario_3` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.painel_indicador_usuario: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.pais
DROP TABLE IF EXISTS `pais`;
CREATE TABLE IF NOT EXISTS `pais` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `codigo_pais` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.pais: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.parceiro
DROP TABLE IF EXISTS `parceiro`;
CREATE TABLE IF NOT EXISTS `parceiro` (
  `id` int NOT NULL AUTO_INCREMENT,
  `certificado_venda_modalidade_id` int NOT NULL,
  `tabela_preco_id` int DEFAULT NULL,
  `vendedor_id` int DEFAULT NULL,
  `cpf_cnpj` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `razao_social` text COLLATE utf8mb3_unicode_ci,
  `cep` text COLLATE utf8mb3_unicode_ci,
  `logradouro` text COLLATE utf8mb3_unicode_ci,
  `bairro` text COLLATE utf8mb3_unicode_ci,
  `cidade` text COLLATE utf8mb3_unicode_ci,
  `estado` text COLLATE utf8mb3_unicode_ci,
  `fone` text COLLATE utf8mb3_unicode_ci,
  `email` text COLLATE utf8mb3_unicode_ci,
  `contato` text COLLATE utf8mb3_unicode_ci,
  `contato_fone` text COLLATE utf8mb3_unicode_ci,
  `comissao_percentual` double DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `banco_id` int DEFAULT NULL,
  `banco_agencia` text COLLATE utf8mb3_unicode_ci,
  `banco_conta` text COLLATE utf8mb3_unicode_ci,
  `banco_chavepix` text COLLATE utf8mb3_unicode_ci,
  `banco_nome_titular` text COLLATE utf8mb3_unicode_ci,
  `banco_cpfcnpj` text COLLATE utf8mb3_unicode_ci,
  `chave_pix_tipo_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_parceiro_1` (`tabela_preco_id`),
  KEY `fk_parceiro_2` (`certificado_venda_modalidade_id`),
  KEY `fk_parceiro_3` (`vendedor_id`),
  KEY `fk_parceiro_4` (`banco_id`),
  KEY `fk_parceiro_5` (`chave_pix_tipo_id`),
  CONSTRAINT `fk_parceiro_1` FOREIGN KEY (`tabela_preco_id`) REFERENCES `tabela_preco` (`id`),
  CONSTRAINT `fk_parceiro_2` FOREIGN KEY (`certificado_venda_modalidade_id`) REFERENCES `certificado_venda_modalidade` (`id`),
  CONSTRAINT `fk_parceiro_3` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_parceiro_4` FOREIGN KEY (`banco_id`) REFERENCES `banco` (`id`),
  CONSTRAINT `fk_parceiro_5` FOREIGN KEY (`chave_pix_tipo_id`) REFERENCES `chave_pix_tipo` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.parceiro: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.pdv_permissoes
DROP TABLE IF EXISTS `pdv_permissoes`;
CREATE TABLE IF NOT EXISTS `pdv_permissoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.pdv_permissoes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.pedido_evento
DROP TABLE IF EXISTS `pedido_evento`;
CREATE TABLE IF NOT EXISTS `pedido_evento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `notafiscal_id` int DEFAULT NULL,
  `system_unit_id` int DEFAULT NULL,
  `system_users_id` int DEFAULT NULL,
  `chave` varchar(50) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci,
  `tipo` varchar(30) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `numero` varchar(10) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `serie` int DEFAULT NULL,
  `nseqevento` int DEFAULT NULL,
  `protocolo` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `status` int DEFAULT '1',
  `protocolo_resposta` varchar(50) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `xevento` text COLLATE utf8mb3_unicode_ci,
  `created_at` datetime DEFAULT NULL,
  `update_at` datetime DEFAULT NULL,
  `deleted_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_pedido_evento_1` (`system_users_id`),
  KEY `fk_pedido_evento_2` (`system_unit_id`),
  KEY `fk_pedido_evento_3` (`notafiscal_id`),
  CONSTRAINT `fk_pedido_evento_1` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_pedido_evento_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_pedido_evento_3` FOREIGN KEY (`notafiscal_id`) REFERENCES `notafiscal` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.pedido_evento: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.pessoa_tipo
DROP TABLE IF EXISTS `pessoa_tipo`;
CREATE TABLE IF NOT EXISTS `pessoa_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.pessoa_tipo: ~2 rows (aproximadamente)
INSERT INTO `pessoa_tipo` (`id`, `descricao`) VALUES
	(1, 'Fisica'),
	(2, 'Juridica');

-- Copiando estrutura para tabela erp_nuvem.plano_conta
DROP TABLE IF EXISTS `plano_conta`;
CREATE TABLE IF NOT EXISTS `plano_conta` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `plano_conta_tipo_id` int NOT NULL,
  `plano_conta_origem_id` int NOT NULL,
  `plano_conta_pai_id` int DEFAULT NULL,
  `numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_plano_conta_1` (`plano_conta_tipo_id`),
  KEY `fk_plano_conta_2` (`plano_conta_origem_id`),
  KEY `fk_plano_conta_3` (`system_unit_id`),
  CONSTRAINT `fk_plano_conta_1` FOREIGN KEY (`plano_conta_tipo_id`) REFERENCES `plano_conta_tipo` (`id`),
  CONSTRAINT `fk_plano_conta_2` FOREIGN KEY (`plano_conta_origem_id`) REFERENCES `plano_conta_origem` (`id`),
  CONSTRAINT `fk_plano_conta_3` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.plano_conta: ~2 rows (aproximadamente)
INSERT INTO `plano_conta` (`id`, `system_unit_id`, `plano_conta_tipo_id`, `plano_conta_origem_id`, `plano_conta_pai_id`, `numero`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 1, 1, 1, NULL, '1', 'RECEITAS', '2024-06-02 22:17:29', NULL, NULL, 'Administrador', NULL),
	(2, 1, 2, 1, 1, '1.2', 'RECEBIMENTOS', '2024-06-02 22:18:01', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.plano_conta_origem
DROP TABLE IF EXISTS `plano_conta_origem`;
CREATE TABLE IF NOT EXISTS `plano_conta_origem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.plano_conta_origem: ~3 rows (aproximadamente)
INSERT INTO `plano_conta_origem` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Credora', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Devedora', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Ambos', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.plano_conta_tipo
DROP TABLE IF EXISTS `plano_conta_tipo`;
CREATE TABLE IF NOT EXISTS `plano_conta_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.plano_conta_tipo: ~2 rows (aproximadamente)
INSERT INTO `plano_conta_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Sintético', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Analítico', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.produto
DROP TABLE IF EXISTS `produto`;
CREATE TABLE IF NOT EXISTS `produto` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_grupo_id` int NOT NULL,
  `unidade_medida_id` int NOT NULL,
  `tipo_recurso_id` int NOT NULL,
  `produto_fabricante_id` int DEFAULT NULL,
  `produtogrupo_subgrupo_id` int DEFAULT NULL,
  `notafiscal_item_orig_id` int DEFAULT NULL,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `nome_curto` text COLLATE utf8mb3_unicode_ci,
  `codigo_EAN` text COLLATE utf8mb3_unicode_ci,
  `imagem` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `ncm` text COLLATE utf8mb3_unicode_ci,
  `cest` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `obs` text COLLATE utf8mb3_unicode_ci,
  `referencia` text COLLATE utf8mb3_unicode_ci,
  `deletado_em` datetime DEFAULT NULL,
  `especificacao` text COLLATE utf8mb3_unicode_ci,
  `link_site` text COLLATE utf8mb3_unicode_ci,
  `peso_liquido` double DEFAULT NULL,
  `peso_bruto` double DEFAULT NULL,
  `habilitado_id` int DEFAULT NULL,
  `produto_tipo_id` int DEFAULT NULL,
  `codigo_sku` text COLLATE utf8mb3_unicode_ci,
  `largura` double DEFAULT NULL,
  `altura` double DEFAULT NULL,
  `comprimento` double DEFAULT NULL,
  `diametro` double DEFAULT NULL,
  `dias_preparacao` double DEFAULT NULL,
  `marca` text COLLATE utf8mb3_unicode_ci,
  `garantia` text COLLATE utf8mb3_unicode_ci,
  `unidade_caixa` double DEFAULT NULL,
  `produto_embalagem_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_2` (`produto_grupo_id`),
  KEY `fk_produto_3` (`unidade_medida_id`),
  KEY `fk_produto_7` (`habilitado_id`),
  KEY `fk_produto_8` (`produto_tipo_id`),
  KEY `fk_produto_9` (`produtogrupo_subgrupo_id`),
  KEY `fk_produto_6` (`notafiscal_item_orig_id`),
  KEY `fk_produto_11` (`produto_embalagem_id`),
  CONSTRAINT `fk_produto_11` FOREIGN KEY (`produto_embalagem_id`) REFERENCES `produto_embalagem` (`id`),
  CONSTRAINT `fk_produto_2` FOREIGN KEY (`produto_grupo_id`) REFERENCES `produto_grupo` (`id`),
  CONSTRAINT `fk_produto_3` FOREIGN KEY (`unidade_medida_id`) REFERENCES `unidade_medida` (`id`),
  CONSTRAINT `fk_produto_6` FOREIGN KEY (`notafiscal_item_orig_id`) REFERENCES `notafiscal_item_orig` (`id`),
  CONSTRAINT `fk_produto_7` FOREIGN KEY (`habilitado_id`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_produto_8` FOREIGN KEY (`produto_tipo_id`) REFERENCES `produto_tipo` (`id`),
  CONSTRAINT `fk_produto_9` FOREIGN KEY (`produtogrupo_subgrupo_id`) REFERENCES `produtogrupo_subgrupo` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto: ~6 rows (aproximadamente)
INSERT INTO `produto` (`id`, `produto_grupo_id`, `unidade_medida_id`, `tipo_recurso_id`, `produto_fabricante_id`, `produtogrupo_subgrupo_id`, `notafiscal_item_orig_id`, `nome`, `nome_curto`, `codigo_EAN`, `imagem`, `criado_em`, `alterado_em`, `ncm`, `cest`, `criado_por`, `alterado_por`, `obs`, `referencia`, `deletado_em`, `especificacao`, `link_site`, `peso_liquido`, `peso_bruto`, `habilitado_id`, `produto_tipo_id`, `codigo_sku`, `largura`, `altura`, `comprimento`, `diametro`, `dias_preparacao`, `marca`, `garantia`, `unidade_caixa`, `produto_embalagem_id`) VALUES
	(1, 1, 49, 1, NULL, 1, 1, 'TESTE', NULL, NULL, NULL, '2024-03-30 10:41:03', '2024-03-30 10:41:32', NULL, NULL, 'Administrador', 'Administrador', NULL, '12454655', NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(5, 1, 49, 1, NULL, NULL, 1, 'BATERIA 150 AMPERES MOURA', NULL, NULL, NULL, '2024-03-30 21:47:48', '2024-06-04 00:52:34', '85071090', NULL, 'Administrador', 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(6, 1, 49, 1, NULL, NULL, 1, 'RACAO GATOS BAW WAW MIX 900G PT', NULL, NULL, 'app/files/kraft_arquivos/produtos/6/travas_john.jpg', '2024-04-19 15:36:18', '2024-06-04 01:16:23', '23099010', NULL, 'Administrador', 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(7, 1, 26, 1, NULL, NULL, 1, 'TOMATE ITALIANO ANDREA KG', NULL, NULL, NULL, '2024-04-19 15:36:32', NULL, '07020000', NULL, 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(8, 1, 49, 1, NULL, NULL, 1, 'OLEO SOJA ABC 900ML FR', NULL, NULL, NULL, '2024-04-19 15:37:04', NULL, '15079011', NULL, 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(9, 1, 49, 1, NULL, NULL, 1, 'ALHO FRITO ALHO ROXO 400G PT', NULL, NULL, NULL, '2024-04-19 15:45:48', NULL, '20059900', NULL, 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(10, 1, 49, 1, NULL, NULL, 1, 'BROCOLIS NINJA NECTAR VITA 200G BJ', NULL, NULL, NULL, '2024-04-19 15:46:15', NULL, '07041000', NULL, 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
	(11, 1, 7, 1, NULL, NULL, 1, 'ETIQUETA 120X120', NULL, NULL, NULL, '2024-06-06 10:55:07', NULL, NULL, NULL, 'Administrador', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.produtogrupo_subgrupo
DROP TABLE IF EXISTS `produtogrupo_subgrupo`;
CREATE TABLE IF NOT EXISTS `produtogrupo_subgrupo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `produto_grupo_id` int NOT NULL,
  `subgrupo_id` int DEFAULT NULL,
  `nivel` int DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produtogrupo_subgrupo_1` (`produto_grupo_id`),
  CONSTRAINT `fk_produtogrupo_subgrupo_1` FOREIGN KEY (`produto_grupo_id`) REFERENCES `produto_grupo` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produtogrupo_subgrupo: ~0 rows (aproximadamente)
INSERT INTO `produtogrupo_subgrupo` (`id`, `descricao`, `produto_grupo_id`, `subgrupo_id`, `nivel`, `criado_em`, `alterado_em`) VALUES
	(1, 'GERAL', 1, NULL, NULL, '2024-03-30 10:39:59', NULL);

-- Copiando estrutura para tabela erp_nuvem.produto_embalagem
DROP TABLE IF EXISTS `produto_embalagem`;
CREATE TABLE IF NOT EXISTS `produto_embalagem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_tipo_embalagem_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `peso` double DEFAULT NULL,
  `dimensoes` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `altura` double DEFAULT NULL,
  `largura` double DEFAULT NULL,
  `comprimento` double DEFAULT NULL,
  `diametro` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_embalagem_1` (`produto_tipo_embalagem_id`),
  CONSTRAINT `fk_produto_embalagem_1` FOREIGN KEY (`produto_tipo_embalagem_id`) REFERENCES `produto_tipo_embalagem` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_embalagem: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_enderecamento
DROP TABLE IF EXISTS `produto_enderecamento`;
CREATE TABLE IF NOT EXISTS `produto_enderecamento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_filial_id` int NOT NULL,
  `estoque_prateleira_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_enderecamento_2` (`produto_filial_id`),
  CONSTRAINT `fk_produto_enderecamento_2` FOREIGN KEY (`produto_filial_id`) REFERENCES `produto_filial` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_enderecamento: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_etiqueta_configuracoes
DROP TABLE IF EXISTS `produto_etiqueta_configuracoes`;
CREATE TABLE IF NOT EXISTS `produto_etiqueta_configuracoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_etiqueta_configuracoes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_fabricante
DROP TABLE IF EXISTS `produto_fabricante`;
CREATE TABLE IF NOT EXISTS `produto_fabricante` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_fabricante: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_ficha_tecnica
DROP TABLE IF EXISTS `produto_ficha_tecnica`;
CREATE TABLE IF NOT EXISTS `produto_ficha_tecnica` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `custo_total` double DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_ficha_tecnica_2` (`system_unit_id`),
  KEY `fk_produto_ficha_tecnica_1` (`produto_id`),
  CONSTRAINT `fk_produto_ficha_tecnica_1` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_produto_ficha_tecnica_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_ficha_tecnica: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_ficha_tecnica_despesas
DROP TABLE IF EXISTS `produto_ficha_tecnica_despesas`;
CREATE TABLE IF NOT EXISTS `produto_ficha_tecnica_despesas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_ficha_tecnica_id` int NOT NULL,
  `despesas_servicos_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `valor_unitario` double NOT NULL,
  `quantidade` double NOT NULL,
  `valor_total` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_ficha_tecnica_despesas_1` (`produto_ficha_tecnica_id`),
  KEY `fk_produto_ficha_tecnica_despesas_2` (`despesas_servicos_id`),
  CONSTRAINT `fk_produto_ficha_tecnica_despesas_1` FOREIGN KEY (`produto_ficha_tecnica_id`) REFERENCES `produto_ficha_tecnica` (`id`),
  CONSTRAINT `fk_produto_ficha_tecnica_despesas_2` FOREIGN KEY (`despesas_servicos_id`) REFERENCES `despesas_servicos` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_ficha_tecnica_despesas: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_ficha_tecnica_etapas_producao
DROP TABLE IF EXISTS `produto_ficha_tecnica_etapas_producao`;
CREATE TABLE IF NOT EXISTS `produto_ficha_tecnica_etapas_producao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_ficha_tecnica_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `ordem` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_ficha_tecnica_etapas_producao_1` (`produto_ficha_tecnica_id`),
  CONSTRAINT `fk_produto_ficha_tecnica_etapas_producao_1` FOREIGN KEY (`produto_ficha_tecnica_id`) REFERENCES `produto_ficha_tecnica` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_ficha_tecnica_etapas_producao: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_ficha_tecnica_itens
DROP TABLE IF EXISTS `produto_ficha_tecnica_itens`;
CREATE TABLE IF NOT EXISTS `produto_ficha_tecnica_itens` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_ficha_tecnica_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `quantidade` double NOT NULL,
  `valor_custo` double DEFAULT NULL,
  `valor_total` double DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade_fixa_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_ficha_tecnica_itens_1` (`produto_ficha_tecnica_id`),
  KEY `fk_produto_ficha_tecnica_itens_2` (`produto_id`),
  KEY `fk_produto_ficha_tecnica_itens_3` (`quantidade_fixa_id`),
  CONSTRAINT `fk_produto_ficha_tecnica_itens_1` FOREIGN KEY (`produto_ficha_tecnica_id`) REFERENCES `produto_ficha_tecnica` (`id`),
  CONSTRAINT `fk_produto_ficha_tecnica_itens_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_produto_ficha_tecnica_itens_3` FOREIGN KEY (`quantidade_fixa_id`) REFERENCES `resposta` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_ficha_tecnica_itens: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_ficha_tecnica_mao_obra
DROP TABLE IF EXISTS `produto_ficha_tecnica_mao_obra`;
CREATE TABLE IF NOT EXISTS `produto_ficha_tecnica_mao_obra` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_ficha_tecnica_id` int NOT NULL,
  `funcionario_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `valor_hora` double NOT NULL,
  `quantidade` double NOT NULL,
  `valor_total` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_ficha_tecnica_mao_obra_1` (`produto_ficha_tecnica_id`),
  KEY `fk_produto_ficha_tecnica_mao_obra_2` (`funcionario_id`),
  CONSTRAINT `fk_produto_ficha_tecnica_mao_obra_1` FOREIGN KEY (`produto_ficha_tecnica_id`) REFERENCES `produto_ficha_tecnica` (`id`),
  CONSTRAINT `fk_produto_ficha_tecnica_mao_obra_2` FOREIGN KEY (`funcionario_id`) REFERENCES `funcionario` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_ficha_tecnica_mao_obra: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_filial
DROP TABLE IF EXISTS `produto_filial`;
CREATE TABLE IF NOT EXISTS `produto_filial` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `margem` double DEFAULT NULL,
  `preco_venda` double DEFAULT NULL,
  `preco_venda_anterior` double DEFAULT NULL,
  `valor_custo` double DEFAULT NULL,
  `valor_custo_anterior` double DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `estoque_minimo` double DEFAULT NULL,
  `estoque_maximo` double DEFAULT NULL,
  `local_estoque` text COLLATE utf8mb3_unicode_ci,
  `codigo_balanca` text COLLATE utf8mb3_unicode_ci,
  `deletado_em` datetime DEFAULT NULL,
  `estoque_deposito_padrao_id` int DEFAULT NULL,
  `sob_encomenda_id` int DEFAULT NULL,
  `gerar_op_venda_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_filial_1` (`produto_id`),
  KEY `fk_produto_filial_2` (`system_unit_id`),
  KEY `fk_produto_filial_3` (`estoque_deposito_padrao_id`),
  KEY `fk_produto_filial_4` (`sob_encomenda_id`),
  KEY `fk_produto_filial_5` (`gerar_op_venda_id`),
  CONSTRAINT `fk_produto_filial_1` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_produto_filial_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_produto_filial_3` FOREIGN KEY (`estoque_deposito_padrao_id`) REFERENCES `estoque_deposito` (`id`),
  CONSTRAINT `fk_produto_filial_4` FOREIGN KEY (`sob_encomenda_id`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_produto_filial_5` FOREIGN KEY (`gerar_op_venda_id`) REFERENCES `resposta` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_filial: ~6 rows (aproximadamente)
INSERT INTO `produto_filial` (`id`, `produto_id`, `system_unit_id`, `margem`, `preco_venda`, `preco_venda_anterior`, `valor_custo`, `valor_custo_anterior`, `criado_em`, `alterado_por`, `criado_por`, `alterado_em`, `estoque_minimo`, `estoque_maximo`, `local_estoque`, `codigo_balanca`, `deletado_em`, `estoque_deposito_padrao_id`, `sob_encomenda_id`, `gerar_op_venda_id`) VALUES
	(1, 5, 1, 30, 1235, 950, 950, 950, '2024-03-30 21:47:48', NULL, NULL, '2024-06-04 00:54:37', NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL),
	(2, 6, 1, 30, 338, 325, 260, 250, '2024-04-19 15:36:19', NULL, NULL, '2024-06-04 01:16:23', NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL),
	(3, 7, 1, 0, 0, NULL, NULL, NULL, '2024-04-19 15:36:32', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL),
	(4, 8, 1, 0, 0, NULL, NULL, NULL, '2024-04-19 15:37:04', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL),
	(5, 9, 1, 0, 0, NULL, NULL, NULL, '2024-04-19 15:45:48', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL),
	(6, 10, 1, 0, 0, NULL, NULL, NULL, '2024-04-19 15:46:15', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.produto_filial_historico
DROP TABLE IF EXISTS `produto_filial_historico`;
CREATE TABLE IF NOT EXISTS `produto_filial_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_id` int NOT NULL,
  `produto_filial_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text CHARACTER SET utf8mb3 COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  `preco_venda_antigo` double DEFAULT NULL,
  `preco_venda_novo` double DEFAULT NULL,
  `valor_custo_antigo` double DEFAULT NULL,
  `valor_custo_novo` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_preco_historico_1` (`produto_id`),
  KEY `fk_produto_filial_historico_2` (`produto_filial_id`),
  CONSTRAINT `fk_produto_filial_historico_2` FOREIGN KEY (`produto_filial_id`) REFERENCES `produto_filial` (`id`),
  CONSTRAINT `fk_produto_preco_historico_1` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_filial_historico: ~3 rows (aproximadamente)
INSERT INTO `produto_filial_historico` (`id`, `produto_id`, `produto_filial_id`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `preco_venda_antigo`, `preco_venda_novo`, `valor_custo_antigo`, `valor_custo_novo`) VALUES
	(12, 5, 1, '2024-06-04 00:54:37', NULL, NULL, 'Administrador', NULL, 950, 1235, 950, 950),
	(13, 6, 2, '2024-06-04 01:14:31', NULL, NULL, 'Administrador', NULL, 0, 325, 0, 250),
	(14, 6, 2, '2024-06-04 01:15:33', NULL, NULL, 'Administrador', NULL, 325, 338, 250, 260);

-- Copiando estrutura para tabela erp_nuvem.produto_fornecedor
DROP TABLE IF EXISTS `produto_fornecedor`;
CREATE TABLE IF NOT EXISTS `produto_fornecedor` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_id` int NOT NULL,
  `fornecedor_id` int NOT NULL,
  `codigo_fornecedor` text COLLATE utf8mb3_unicode_ci,
  `descricao_produto_fornecedor` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `tempo_medio_fornecimento` double DEFAULT NULL,
  `quantidade_minima_compra` double DEFAULT NULL,
  `preco_venda` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_fornecedor_1` (`produto_id`),
  KEY `fk_produto_fornecedor_2` (`fornecedor_id`),
  CONSTRAINT `fk_produto_fornecedor_1` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_produto_fornecedor_2` FOREIGN KEY (`fornecedor_id`) REFERENCES `fornecedor` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_fornecedor: ~0 rows (aproximadamente)
INSERT INTO `produto_fornecedor` (`id`, `produto_id`, `fornecedor_id`, `codigo_fornecedor`, `descricao_produto_fornecedor`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `tempo_medio_fornecimento`, `quantidade_minima_compra`, `preco_venda`) VALUES
	(1, 5, 1, '28', 'BATERIA 150 AMPERES MOURA', '2024-03-30 22:57:57', NULL, NULL, 'Administrador', '2024-04-03 11:42:16', NULL, NULL, 950);

-- Copiando estrutura para tabela erp_nuvem.produto_grupo
DROP TABLE IF EXISTS `produto_grupo`;
CREATE TABLE IF NOT EXISTS `produto_grupo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `tipo_recurso_id` int DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `imagem` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_produto_grupo_1` (`tipo_recurso_id`),
  CONSTRAINT `fk_produto_grupo_1` FOREIGN KEY (`tipo_recurso_id`) REFERENCES `tipo_recurso` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_grupo: ~0 rows (aproximadamente)
INSERT INTO `produto_grupo` (`id`, `tipo_recurso_id`, `descricao`, `imagem`, `criado_em`, `alterado_em`, `criado_por`, `alterado_por`, `deletado_em`) VALUES
	(1, 1, 'GERAL', NULL, '2024-03-30 10:39:49', '2024-03-30 10:39:59', 'Administrador', 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.produto_lote
DROP TABLE IF EXISTS `produto_lote`;
CREATE TABLE IF NOT EXISTS `produto_lote` (
  `id` int NOT NULL AUTO_INCREMENT,
  `produto_id` int NOT NULL,
  `numero` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `validade` date DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_produto_lote_1` (`produto_id`),
  CONSTRAINT `fk_produto_lote_1` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_lote: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.produto_tipo
DROP TABLE IF EXISTS `produto_tipo`;
CREATE TABLE IF NOT EXISTS `produto_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_tipo: ~5 rows (aproximadamente)
INSERT INTO `produto_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Simples', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Fabricado', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Kit', NULL, NULL, '', 'Sistema Kraft', NULL),
	(4, 'Com Variações', NULL, NULL, '', 'Sistema Kraft', NULL),
	(5, 'Materia-Prima', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.produto_tipo_embalagem
DROP TABLE IF EXISTS `produto_tipo_embalagem`;
CREATE TABLE IF NOT EXISTS `produto_tipo_embalagem` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.produto_tipo_embalagem: ~3 rows (aproximadamente)
INSERT INTO `produto_tipo_embalagem` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Envelope', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Pacote/Caixa', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Rolo/Cilindro', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.resposta
DROP TABLE IF EXISTS `resposta`;
CREATE TABLE IF NOT EXISTS `resposta` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.resposta: ~2 rows (aproximadamente)
INSERT INTO `resposta` (`id`, `descricao`) VALUES
	(1, 'Sim'),
	(2, 'Não');

-- Copiando estrutura para tabela erp_nuvem.servico_formapgto
DROP TABLE IF EXISTS `servico_formapgto`;
CREATE TABLE IF NOT EXISTS `servico_formapgto` (
  `id` int NOT NULL AUTO_INCREMENT,
  `forma_pagamento_id` int NOT NULL,
  `ordem_servico_id` int NOT NULL,
  `quantidade_parcelas` int DEFAULT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_servico_formapgto_1` (`ordem_servico_id`),
  KEY `fk_servico_formapgto_2` (`forma_pagamento_id`),
  CONSTRAINT `fk_servico_formapgto_1` FOREIGN KEY (`ordem_servico_id`) REFERENCES `ordem_servico` (`id`),
  CONSTRAINT `fk_servico_formapgto_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.servico_formapgto: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_document
DROP TABLE IF EXISTS `system_document`;
CREATE TABLE IF NOT EXISTS `system_document` (
  `id` int NOT NULL,
  `category_id` int NOT NULL,
  `system_user_id` int DEFAULT NULL,
  `title` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `description` text COLLATE utf8mb3_unicode_ci,
  `submission_date` date DEFAULT NULL,
  `archive_date` date DEFAULT NULL,
  `filename` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_system_document_2` (`category_id`),
  KEY `fk_system_document_1` (`system_user_id`),
  CONSTRAINT `fk_system_document_1` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_system_document_2` FOREIGN KEY (`category_id`) REFERENCES `system_document_category` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_document: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_document_category
DROP TABLE IF EXISTS `system_document_category`;
CREATE TABLE IF NOT EXISTS `system_document_category` (
  `id` int NOT NULL,
  `name` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_document_category: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_document_group
DROP TABLE IF EXISTS `system_document_group`;
CREATE TABLE IF NOT EXISTS `system_document_group` (
  `id` int NOT NULL,
  `document_id` int NOT NULL,
  `system_group_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_document_group_2` (`document_id`),
  KEY `fk_system_document_group_1` (`system_group_id`),
  CONSTRAINT `fk_system_document_group_1` FOREIGN KEY (`system_group_id`) REFERENCES `system_group` (`id`),
  CONSTRAINT `fk_system_document_group_2` FOREIGN KEY (`document_id`) REFERENCES `system_document` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_document_group: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_document_user
DROP TABLE IF EXISTS `system_document_user`;
CREATE TABLE IF NOT EXISTS `system_document_user` (
  `id` int NOT NULL,
  `document_id` int NOT NULL,
  `system_user_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_document_user_2` (`document_id`),
  KEY `fk_system_document_user_1` (`system_user_id`),
  CONSTRAINT `fk_system_document_user_1` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_system_document_user_2` FOREIGN KEY (`document_id`) REFERENCES `system_document` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_document_user: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_group
DROP TABLE IF EXISTS `system_group`;
CREATE TABLE IF NOT EXISTS `system_group` (
  `id` int NOT NULL,
  `name` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `uuid` varchar(36) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_group: ~18 rows (aproximadamente)
INSERT INTO `system_group` (`id`, `name`, `uuid`) VALUES
	(1, 'Admin', NULL),
	(2, 'Standard', NULL),
	(3, 'CRM', '858dbe88-6c7a-4896-a398-0cb8f0a8a542'),
	(4, 'Cadastros Diversos', '5b082ae2-e439-462c-9202-809c3b580d21'),
	(5, 'Certificação Digital', '5d62149b-8ce4-4094-8c91-edbb86b78113'),
	(6, 'Cliente', 'b7f651be-e61c-453c-8f59-85fc61110455'),
	(7, 'Compras', '290f2d3b-e756-40ce-a45e-3ec21fdf5062'),
	(8, 'Configurações', '65cf7042-4db2-4522-92c9-c2f4bc3c3f54'),
	(9, 'Contabilidade', 'c4b83438-8ad8-4dea-a61b-a51b6a8300c1'),
	(10, 'Dashboards', 'd44c46a8-a977-4dc6-862d-073f75f8f792'),
	(11, 'Estoque', 'a11a9a45-51ac-4ade-b349-c39ea146b568'),
	(12, 'Financeiro', '8343eebe-edd1-419f-8ef4-1aba535ac0b6'),
	(13, 'Fiscal', '6f7eb492-ee91-4bcb-ba25-52963971998e'),
	(14, 'Ordem de Serviço', '454c14ad-b9d6-4665-82b2-74240322a2df'),
	(15, 'Ordens de Produção', '6871dcc5-9181-4f3d-8bed-1c89ccc9ce98'),
	(16, 'Produto', 'ec9faac1-06ec-448f-b965-ef537f946a7d'),
	(17, 'Tabelas de Sistema', '6b49a400-42ff-41a8-8508-53e5424142cd'),
	(18, 'Vendas', 'e7afa479-b461-4535-a595-7b682d8d0106');

-- Copiando estrutura para tabela erp_nuvem.system_group_program
DROP TABLE IF EXISTS `system_group_program`;
CREATE TABLE IF NOT EXISTS `system_group_program` (
  `id` int NOT NULL,
  `system_group_id` int NOT NULL,
  `system_program_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_group_program_1` (`system_program_id`),
  KEY `fk_system_group_program_2` (`system_group_id`),
  CONSTRAINT `fk_system_group_program_1` FOREIGN KEY (`system_program_id`) REFERENCES `system_program` (`id`),
  CONSTRAINT `fk_system_group_program_2` FOREIGN KEY (`system_group_id`) REFERENCES `system_group` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_group_program: ~365 rows (aproximadamente)
INSERT INTO `system_group_program` (`id`, `system_group_id`, `system_program_id`) VALUES
	(1, 1, 1),
	(2, 1, 2),
	(3, 1, 3),
	(4, 1, 4),
	(5, 1, 5),
	(6, 1, 6),
	(7, 1, 8),
	(8, 1, 9),
	(9, 1, 11),
	(10, 1, 14),
	(11, 1, 15),
	(12, 2, 10),
	(13, 2, 12),
	(14, 2, 13),
	(15, 2, 16),
	(16, 2, 17),
	(17, 2, 18),
	(18, 2, 19),
	(19, 2, 20),
	(20, 1, 21),
	(21, 2, 22),
	(22, 2, 23),
	(23, 2, 24),
	(24, 2, 25),
	(25, 1, 26),
	(26, 1, 27),
	(27, 1, 28),
	(28, 1, 29),
	(29, 2, 30),
	(30, 1, 31),
	(31, 1, 32),
	(32, 1, 33),
	(33, 1, 34),
	(34, 1, 35),
	(35, 1, 36),
	(36, 1, 37),
	(37, 1, 38),
	(38, 1, 39),
	(39, 1, 40),
	(40, 3, 41),
	(41, 3, 42),
	(42, 3, 43),
	(43, 3, 44),
	(44, 3, 45),
	(45, 3, 46),
	(46, 3, 47),
	(47, 3, 48),
	(48, 3, 49),
	(49, 3, 50),
	(50, 3, 51),
	(51, 3, 52),
	(52, 3, 53),
	(53, 3, 54),
	(54, 3, 55),
	(55, 3, 56),
	(56, 3, 57),
	(57, 3, 58),
	(58, 3, 59),
	(59, 3, 60),
	(60, 3, 61),
	(61, 3, 62),
	(62, 3, 63),
	(63, 3, 64),
	(64, 3, 65),
	(65, 3, 66),
	(66, 3, 67),
	(67, 4, 68),
	(68, 4, 69),
	(69, 4, 70),
	(70, 4, 71),
	(71, 4, 72),
	(72, 4, 73),
	(73, 4, 74),
	(74, 4, 75),
	(75, 4, 76),
	(76, 4, 77),
	(77, 4, 78),
	(78, 4, 79),
	(79, 4, 80),
	(80, 4, 81),
	(81, 5, 82),
	(82, 5, 83),
	(83, 5, 84),
	(84, 5, 85),
	(85, 5, 86),
	(86, 5, 87),
	(87, 5, 88),
	(88, 5, 89),
	(89, 5, 90),
	(90, 5, 91),
	(91, 5, 92),
	(92, 5, 93),
	(93, 5, 94),
	(94, 5, 95),
	(95, 5, 96),
	(96, 5, 97),
	(97, 5, 98),
	(98, 5, 99),
	(99, 5, 100),
	(100, 5, 101),
	(101, 5, 102),
	(102, 6, 103),
	(103, 6, 104),
	(104, 6, 105),
	(105, 6, 106),
	(106, 6, 107),
	(107, 6, 108),
	(108, 6, 109),
	(109, 6, 110),
	(110, 7, 111),
	(111, 7, 112),
	(112, 7, 113),
	(113, 7, 114),
	(114, 7, 115),
	(115, 7, 116),
	(116, 7, 117),
	(117, 7, 118),
	(118, 7, 119),
	(119, 7, 120),
	(120, 8, 121),
	(121, 8, 122),
	(122, 8, 123),
	(123, 8, 124),
	(124, 8, 125),
	(125, 8, 126),
	(126, 8, 127),
	(127, 8, 128),
	(128, 8, 129),
	(129, 8, 130),
	(130, 8, 131),
	(131, 8, 132),
	(132, 8, 133),
	(133, 8, 134),
	(134, 8, 135),
	(135, 8, 136),
	(136, 8, 137),
	(137, 8, 138),
	(138, 8, 139),
	(139, 8, 140),
	(140, 8, 141),
	(141, 8, 142),
	(142, 8, 143),
	(143, 8, 144),
	(144, 8, 145),
	(145, 8, 146),
	(146, 8, 147),
	(147, 8, 148),
	(148, 8, 149),
	(149, 8, 150),
	(150, 8, 151),
	(151, 8, 152),
	(152, 8, 153),
	(153, 9, 154),
	(154, 9, 155),
	(155, 10, 156),
	(156, 10, 157),
	(157, 10, 158),
	(158, 10, 159),
	(159, 10, 160),
	(160, 10, 161),
	(161, 11, 162),
	(162, 11, 163),
	(163, 11, 164),
	(164, 11, 165),
	(165, 11, 166),
	(166, 11, 167),
	(167, 11, 168),
	(168, 11, 169),
	(169, 11, 170),
	(170, 11, 171),
	(171, 11, 172),
	(172, 12, 173),
	(173, 12, 174),
	(174, 12, 175),
	(175, 12, 176),
	(176, 12, 177),
	(177, 12, 178),
	(178, 12, 179),
	(179, 12, 180),
	(180, 12, 181),
	(181, 12, 182),
	(182, 12, 183),
	(183, 12, 184),
	(184, 12, 185),
	(185, 12, 186),
	(186, 12, 187),
	(187, 12, 188),
	(188, 12, 189),
	(189, 12, 190),
	(190, 12, 191),
	(191, 12, 192),
	(192, 12, 193),
	(193, 12, 194),
	(194, 12, 195),
	(195, 12, 196),
	(196, 12, 197),
	(197, 12, 198),
	(198, 12, 199),
	(199, 12, 200),
	(200, 12, 201),
	(201, 12, 202),
	(202, 12, 203),
	(203, 12, 204),
	(204, 12, 205),
	(205, 12, 206),
	(206, 12, 207),
	(207, 12, 208),
	(208, 12, 209),
	(209, 12, 210),
	(210, 12, 211),
	(211, 12, 212),
	(212, 12, 213),
	(213, 12, 214),
	(214, 12, 215),
	(215, 12, 216),
	(216, 12, 217),
	(217, 12, 218),
	(218, 12, 219),
	(219, 12, 220),
	(220, 12, 221),
	(221, 12, 222),
	(222, 12, 223),
	(223, 13, 224),
	(224, 13, 225),
	(225, 13, 226),
	(226, 13, 227),
	(227, 13, 228),
	(228, 13, 229),
	(229, 13, 230),
	(230, 13, 231),
	(231, 13, 232),
	(232, 13, 233),
	(233, 13, 234),
	(234, 13, 235),
	(235, 13, 236),
	(236, 13, 237),
	(237, 13, 238),
	(238, 13, 239),
	(239, 13, 240),
	(240, 13, 241),
	(241, 13, 242),
	(242, 13, 243),
	(243, 13, 244),
	(244, 13, 245),
	(245, 13, 246),
	(246, 13, 247),
	(247, 13, 248),
	(248, 13, 249),
	(249, 13, 250),
	(250, 13, 251),
	(251, 13, 252),
	(252, 13, 253),
	(253, 13, 254),
	(254, 13, 255),
	(255, 13, 256),
	(256, 13, 257),
	(257, 13, 258),
	(258, 13, 259),
	(259, 13, 260),
	(260, 13, 261),
	(261, 13, 262),
	(262, 13, 263),
	(263, 14, 264),
	(264, 14, 265),
	(265, 14, 266),
	(266, 14, 267),
	(267, 14, 268),
	(268, 14, 269),
	(269, 14, 270),
	(270, 14, 271),
	(271, 14, 272),
	(272, 14, 273),
	(273, 14, 274),
	(274, 14, 275),
	(275, 14, 276),
	(276, 14, 277),
	(277, 14, 278),
	(278, 14, 279),
	(279, 15, 280),
	(280, 15, 281),
	(281, 15, 282),
	(282, 15, 283),
	(283, 15, 284),
	(284, 16, 285),
	(285, 16, 286),
	(286, 16, 287),
	(287, 16, 288),
	(288, 16, 289),
	(289, 16, 290),
	(290, 16, 291),
	(291, 16, 292),
	(292, 16, 293),
	(293, 16, 294),
	(294, 16, 295),
	(295, 16, 296),
	(296, 16, 297),
	(297, 16, 298),
	(298, 16, 299),
	(299, 16, 300),
	(300, 16, 301),
	(301, 16, 302),
	(302, 16, 303),
	(303, 16, 304),
	(304, 16, 305),
	(305, 16, 306),
	(306, 16, 307),
	(307, 16, 308),
	(308, 16, 309),
	(309, 17, 310),
	(310, 17, 311),
	(311, 17, 312),
	(312, 17, 313),
	(313, 17, 314),
	(314, 17, 315),
	(315, 17, 316),
	(316, 17, 317),
	(317, 17, 318),
	(318, 17, 319),
	(319, 17, 320),
	(320, 17, 321),
	(321, 17, 322),
	(322, 17, 323),
	(323, 17, 324),
	(324, 17, 325),
	(325, 17, 326),
	(326, 17, 327),
	(327, 17, 328),
	(328, 17, 329),
	(329, 17, 330),
	(330, 17, 331),
	(331, 17, 332),
	(332, 18, 333),
	(333, 18, 334),
	(334, 18, 335),
	(335, 18, 336),
	(336, 18, 337),
	(337, 18, 338),
	(338, 18, 339),
	(339, 18, 340),
	(340, 18, 341),
	(341, 18, 342),
	(342, 18, 343),
	(343, 18, 344),
	(344, 18, 345),
	(345, 18, 346),
	(346, 18, 347),
	(347, 18, 348),
	(348, 18, 349),
	(349, 18, 350),
	(350, 18, 351),
	(351, 18, 352),
	(352, 18, 353),
	(353, 18, 354),
	(354, 18, 355),
	(355, 18, 356),
	(356, 18, 357),
	(357, 18, 358),
	(358, 18, 359),
	(359, 18, 360),
	(360, 18, 361),
	(361, 18, 362),
	(362, 18, 363),
	(363, 18, 364),
	(364, 18, 365),
	(365, 18, 366);

-- Copiando estrutura para tabela erp_nuvem.system_group_program_permissoes
DROP TABLE IF EXISTS `system_group_program_permissoes`;
CREATE TABLE IF NOT EXISTS `system_group_program_permissoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `system_program_permissoes_id` int NOT NULL,
  `system_group_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_group_program_permissoes_1` (`system_program_permissoes_id`),
  KEY `fk_system_group_program_permissoes_2` (`system_group_id`),
  KEY `fk_system_group_program_permissoes_3` (`system_unit_id`),
  CONSTRAINT `fk_system_group_program_permissoes_1` FOREIGN KEY (`system_program_permissoes_id`) REFERENCES `system_program_permissoes` (`id`),
  CONSTRAINT `fk_system_group_program_permissoes_2` FOREIGN KEY (`system_group_id`) REFERENCES `system_group` (`id`),
  CONSTRAINT `fk_system_group_program_permissoes_3` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_group_program_permissoes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_message
DROP TABLE IF EXISTS `system_message`;
CREATE TABLE IF NOT EXISTS `system_message` (
  `id` int NOT NULL,
  `system_user_id` int NOT NULL,
  `system_user_to_id` int NOT NULL,
  `subject` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `message` text COLLATE utf8mb3_unicode_ci,
  `dt_message` datetime DEFAULT NULL,
  `checked` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_message_1` (`system_user_id`),
  KEY `fk_system_message_2` (`system_user_to_id`),
  CONSTRAINT `fk_system_message_1` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_system_message_2` FOREIGN KEY (`system_user_to_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_message: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_notification
DROP TABLE IF EXISTS `system_notification`;
CREATE TABLE IF NOT EXISTS `system_notification` (
  `id` int NOT NULL,
  `system_user_id` int NOT NULL,
  `system_user_to_id` int NOT NULL,
  `subject` text COLLATE utf8mb3_unicode_ci,
  `message` text COLLATE utf8mb3_unicode_ci,
  `dt_message` datetime DEFAULT NULL,
  `action_url` text COLLATE utf8mb3_unicode_ci,
  `action_label` text COLLATE utf8mb3_unicode_ci,
  `icon` text COLLATE utf8mb3_unicode_ci,
  `checked` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_notification_1` (`system_user_id`),
  KEY `fk_system_notification_2` (`system_user_to_id`),
  CONSTRAINT `fk_system_notification_1` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_system_notification_2` FOREIGN KEY (`system_user_to_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_notification: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_preference
DROP TABLE IF EXISTS `system_preference`;
CREATE TABLE IF NOT EXISTS `system_preference` (
  `id` varchar(255) COLLATE utf8mb3_unicode_ci NOT NULL,
  `preference` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_preference: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_program
DROP TABLE IF EXISTS `system_program`;
CREATE TABLE IF NOT EXISTS `system_program` (
  `id` int NOT NULL,
  `name` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `controller` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_program: ~366 rows (aproximadamente)
INSERT INTO `system_program` (`id`, `name`, `controller`) VALUES
	(1, 'System Group Form', 'SystemGroupForm'),
	(2, 'System Group List', 'SystemGroupList'),
	(3, 'System Program Form', 'SystemProgramForm'),
	(4, 'System Program List', 'SystemProgramList'),
	(5, 'System User Form', 'SystemUserForm'),
	(6, 'System User List', 'SystemUserList'),
	(7, 'Common Page', 'CommonPage'),
	(8, 'System PHP Info', 'SystemPHPInfoView'),
	(9, 'System ChangeLog View', 'SystemChangeLogView'),
	(10, 'Welcome View', 'WelcomeView'),
	(11, 'System Sql Log', 'SystemSqlLogList'),
	(12, 'System Profile View', 'SystemProfileView'),
	(13, 'System Profile Form', 'SystemProfileForm'),
	(14, 'System SQL Panel', 'SystemSQLPanel'),
	(15, 'System Access Log', 'SystemAccessLogList'),
	(16, 'System Message Form', 'SystemMessageForm'),
	(17, 'System Message List', 'SystemMessageList'),
	(18, 'System Message Form View', 'SystemMessageFormView'),
	(19, 'System Notification List', 'SystemNotificationList'),
	(20, 'System Notification Form View', 'SystemNotificationFormView'),
	(21, 'System Document Category List', 'SystemDocumentCategoryFormList'),
	(22, 'System Document Form', 'SystemDocumentForm'),
	(23, 'System Document Upload Form', 'SystemDocumentUploadForm'),
	(24, 'System Document List', 'SystemDocumentList'),
	(25, 'System Shared Document List', 'SystemSharedDocumentList'),
	(26, 'System Unit Form', 'SystemUnitForm'),
	(27, 'System Unit List', 'SystemUnitList'),
	(28, 'System Access stats', 'SystemAccessLogStats'),
	(29, 'System Preference form', 'SystemPreferenceForm'),
	(30, 'System Support form', 'SystemSupportForm'),
	(31, 'System PHP Error', 'SystemPHPErrorLogView'),
	(32, 'System Database Browser', 'SystemDatabaseExplorer'),
	(33, 'System Table List', 'SystemTableList'),
	(34, 'System Data Browser', 'SystemDataBrowser'),
	(35, 'System Menu Editor', 'SystemMenuEditor'),
	(36, 'System Request Log', 'SystemRequestLogList'),
	(37, 'System Request Log View', 'SystemRequestLogView'),
	(38, 'System Administration Dashboard', 'SystemAdministrationDashboard'),
	(39, 'System Log Dashboard', 'SystemLogDashboard'),
	(40, 'System Session dump', 'SystemSessionDumpView'),
	(41, 'Consultar Negócios', 'NegocioList'),
	(42, 'Agenda Global', 'BuscaAgendaGlobalAtividadeForm'),
	(43, 'Kanban', 'BuscaKanbanNegocioForm'),
	(44, 'Origens de Negócio', 'NegocioOrigemHeaderList'),
	(45, 'Tipos de atividade de negócio', 'NegocioTipoAtividadeHeaderList'),
	(46, 'Funis', 'FunilHeaderList'),
	(47, 'Motivos de perdas de Negócio', 'NegocioMotivoPerdaHeaderList'),
	(48, 'Cadastro de funil', 'FunilForm'),
	(49, 'Cadastro de itens de negócio', 'NegocioItensForm'),
	(50, 'Itens de negócio', 'NegocioItensHeaderList'),
	(51, 'Cadastro de motivo de perda de negócio', 'NegocioMotivoPerdaForm'),
	(52, 'Cadastro de origem de negocio', 'NegocioOrigemForm'),
	(53, 'Cadastro de notas de negócio', 'NegocioNotasForm'),
	(54, 'Notas de negócio', 'NegocioNotasHeaderList'),
	(55, 'Cadastro de arquivos de negócio', 'NegocioArquivosForm'),
	(56, 'Arquivos de negócio', 'NegocioArquivosHeaderList'),
	(57, 'Atividades do Negócio(Form)', 'NegocioAtividadeCalendarForm'),
	(58, 'Atividades do Negócio(View)', 'NegocioAtividadeCalendarFormView'),
	(59, 'Agenda Global(Form)', 'NegocioAtividadeGlobalCalendarForm'),
	(60, 'Agenda Global(View)', 'NegocioAtividadeGlobalCalendarFormView'),
	(61, 'Cadastro de tipos de atividade de negócio', 'NegocioTipoAtividadeForm'),
	(62, 'Negócio', 'NegocioForm'),
	(63, 'Timeline de negociação', 'NegocioTimeline'),
	(64, 'Enviar e-mail de negócio', 'NegocioEmailForm'),
	(65, 'Negócios Arquivados', 'NegociosArquivadosList'),
	(66, 'Negócios', 'NegocioKanbanView'),
	(67, 'Visualizar Negócio', 'NegocioFormView'),
	(68, 'Classificação de Fornecedor', 'FornecedorClassificacaoHeaderList'),
	(69, 'Fornecedores', 'FornecedorList'),
	(70, 'Vendedores', 'VendedorHeaderList'),
	(71, 'Funcionários', 'FuncionarioList'),
	(72, 'Veículos', 'VeiculoList'),
	(73, 'Cargos de funcionário', 'FuncionarioCargoList'),
	(74, 'Cadastro de classificação de fornecedor', 'FornecedorClassificacaoForm'),
	(75, 'Cadastro de fornecedor', 'FornecedorForm'),
	(76, 'Cadastro de vendedor', 'VendedorForm'),
	(77, 'Cadastro de pedido evento', 'PedidoEventoForm'),
	(78, 'Cadastro de cargos de funcionário', 'FuncionarioCargoForm'),
	(79, 'Cadastro de funcionário', 'FuncionarioForm'),
	(80, 'Cadastro de serviço', 'ServicoForm'),
	(81, 'Mensagem', 'MensagemPersonalizada'),
	(82, 'Vendas de Certificado', 'CertificadoVendaList'),
	(83, 'Agendamentos de Certificado(Form)', 'CertificadoAgendamentosCalendarForm'),
	(84, 'Agendamentos de Certificado(View)', 'CertificadoAgendamentosCalendarFormView'),
	(85, 'Modalidade de Certificação', 'CertificadoVendaModalidadeHeaderList'),
	(86, 'Parceiros', 'ParceiroList'),
	(87, 'Agente de Registros', 'CertificadoAgenteRegistroList'),
	(88, 'Certificadoras', 'CertificadoraHeaderList'),
	(89, 'Relatório de Parceiro', 'CertificadoVendaParceiroReport'),
	(90, 'Relatório de Vendas de Certificados', 'CertificadoVendaReport'),
	(91, 'Relatório de Agente de Registro', 'CertificadoVendaAGRReport'),
	(92, 'Relatório de Vendedor', 'CertificadoVendaVendedorReport'),
	(93, 'Vencimentos de Certificados ', 'CertificadoClienteReport'),
	(94, 'Relatório de Lucratividade', 'CertificadoVendaLucratividadeReport'),
	(95, 'Cadastro de Modalidade de Certificação', 'CertificadoVendaModalidadeForm'),
	(96, 'Cadastro de Agente de Registro', 'CertificadoAgenteRegistroForm'),
	(97, 'Cadastro de Parceiro', 'ParceiroForm'),
	(98, 'Cadastro de certificadora', 'CertificadoraForm'),
	(99, 'Certificados Digitais de Cliente', 'CertificadoClienteFormList'),
	(100, 'Cadastro de venda de certificado Digital', 'CertificadoVendaForm'),
	(101, 'Agendamentos de Certificados', 'CertificadoAgendamentosSimpleList'),
	(102, 'Venda de Certificado Digital', 'CertificadoVendaFormView'),
	(103, 'Classificação de Cliente', 'ClienteClassificacaoHeaderList'),
	(104, 'Clientes', 'ClienteList'),
	(105, 'Relatório de clientes', 'ClienteReport'),
	(106, 'Cadastro de cliente', 'ClienteForm'),
	(107, 'Cadastro limite de crédito de cliente ', 'ClienteHistoricoLimiteForm'),
	(108, 'Espelho Financeiro de Cliente', 'ClienteEspelhoFinanceiro'),
	(109, 'Histórico de limite de crédito de cliente', 'ClienteHistoricoLimiteHeaderList'),
	(110, 'Cadastro de classificação de cliente ', 'ClienteClassificacaoForm'),
	(111, 'Nota fiscal de compras', 'NotaFiscalCompraList'),
	(112, 'Relatório de Notas Fiscais de Compra', 'NotaFiscalCompraReport'),
	(113, 'Importar XML de nota fiscal compra', 'NotaFiscalCompraImportarXML'),
	(114, 'Vincular Produto', 'NotaFiscalCompraVincularProduto'),
	(115, 'Lista de Itens da nota fiscal de compra', 'NotaFiscalCompraItensSimpleList'),
	(116, 'Visualizar Nota Fiscal de Compra', 'NotaFiscalCompraFormView'),
	(117, 'Item de nota fiscal de compra', 'NotaFiscalCompraItensForm'),
	(118, 'Cadastro de nota fiscal de compra', 'NotaFiscalCompraForm'),
	(119, 'Compras de produto', 'NotaFiscalCompraItensProdutoSimpleList'),
	(120, 'Vincular Fornecedor a nota fiscal de compra', 'NotaFiscalCompraVincularFornecedor'),
	(121, 'Tipos de Pagamento de NF-e', 'NotafiscalTpagList'),
	(122, 'Cep caches', 'CepCacheHeaderList'),
	(123, 'Cidades', 'CidadeHeaderList'),
	(124, 'Estados', 'EstadoHeaderList'),
	(125, 'Países', 'PaisHeaderList'),
	(126, 'Filial', 'FilialList'),
	(127, 'Alertas para eventos', 'EventosHeaderList'),
	(128, 'Permissões especiais', 'PermissoesEspeciaisList'),
	(129, 'Templates de e-mail ', 'EmailTemplateHeaderList'),
	(130, 'Dispositivos', 'DispositivosList'),
	(131, 'API de documentos', 'ApiDocumentosHeaderList'),
	(132, 'API Errors', 'ApiErrorHeaderList'),
	(133, 'Configurações', 'ConfiguracoesForm'),
	(134, 'Histórico de Atualizações do sistema', 'HistoricoAtualizacoesSistema'),
	(135, 'Indicadores personalizados', 'IndicadorPersonalizadoHeaderList'),
	(136, 'Painel de indicadores', 'PainelIndicadoresHeaderList'),
	(137, 'Integradoress', 'IntegradoresList'),
	(138, 'Cadastro de API de documentos', 'ApiDocumentosForm'),
	(139, 'Cadastro de cep cache', 'CepCacheForm'),
	(140, 'Cadastro de estado', 'EstadoForm'),
	(141, 'Cadastro de cidade', 'CidadeForm'),
	(142, 'Cadastro de Tipo Pagamento NF-e', 'NotafiscalTpagForm'),
	(143, 'Cadastro de dispositivos', 'DispositivosForm'),
	(144, 'Cadastro de Filial', 'FilialForm'),
	(145, 'Alertas para eventos', 'EventosForm'),
	(146, 'Cadastro de template de e-mail', 'EmailTemplateForm'),
	(147, 'Cadastro de painel de indicadores', 'PainelIndicadoresForm'),
	(148, 'Cadastro de indicador personalizado', 'IndicadorPersonalizadoForm'),
	(149, 'Cadastro de permissões especiais', 'PermissoesEspeciaisForm'),
	(150, 'Cadastro de integradores', 'IntegradoresForm'),
	(151, 'Ajuda', 'AjudaForm'),
	(152, 'Cadastro de país', 'PaisForm'),
	(153, 'TesteControlle', 'TesteControlle'),
	(154, 'XML Contabilidade', 'XmlContadorList'),
	(155, 'Cadastro de XML Contabilidade', 'XmlContadorForm'),
	(156, 'Dashboard Fiscal', 'DashboardFiscal'),
	(157, 'Dashboard CRM', 'DashboardCRM'),
	(158, 'Dashboard de Vendas', 'DashboardVendas'),
	(159, 'Dashboard Certificação Digital', 'DashboardCertificacaoDigital'),
	(160, 'Painel de Indicadores Personalizados', 'PainelIndicadoresPersonalizados'),
	(161, 'Dashborad Financeiro', 'DashboardFinanceiro'),
	(162, 'Depósitos de Estoque ', 'EstoqueDepositoHeaderList'),
	(163, 'Lotes de Produto', 'ProdutoLoteList'),
	(164, 'Lançamentos de Estoque ', 'EstoqueLancamentosList'),
	(165, 'Estoque de produtos', 'VwProdutoEstoqueReport'),
	(166, 'Cadastro de lançamentos de estoque', 'EstoqueLancamentosForm'),
	(167, 'Cadastro de Depósito de Estoque', 'EstoqueDepositoForm'),
	(168, 'Estantes de rua de depósito', 'EstoqueEstanteFormList'),
	(169, 'Prateleiras de Estante no Depósito', 'EstoquePrateleiraFormList'),
	(170, 'Cadastro de lote de produto', 'ProdutoLoteForm'),
	(171, 'Lote de Produto', 'ProdutoLoteFormAvulso'),
	(172, 'Busca de Produtos com estoque', 'VwProdutoEstoqueSeekWindow'),
	(173, 'Contas a receber de Cliente', 'ClienteContasrecList'),
	(174, 'Contas à pagar', 'ContaspagList'),
	(175, 'Calendário de pagamentos(Form)', 'ContaspagCalendarForm'),
	(176, 'Calendário de pagamentos(View)', 'ContaspagCalendarFormView'),
	(177, 'Relatório de Contas a Pagar', 'ContaspagReport'),
	(178, 'Relatório de Contas a Pagar por Fornecedor', 'ContaspagFornecedorReport'),
	(179, 'Baixas de Contas a Pagar', 'ContaspagBaixasReport'),
	(180, 'Contas a receber', 'ContasrecList'),
	(181, 'Relatório de Contas a Receber', 'ContasrecReport'),
	(182, 'Relatório de Contas a Receber por Cliente', 'ContasrecClienteReport'),
	(183, 'Baixas de Contas a Receber', 'ContasrecBaixasReport'),
	(184, 'Histórico de Cobranças', 'ContasrecHistoricoCobrancaReport'),
	(185, 'Caixa Monitor', 'CaixaList'),
	(186, 'Lançamentos de conta corrente', 'ContaCorrenteLancamentosList'),
	(187, 'Condição de pagamentos', 'CondicaoPagamentoHeaderList'),
	(188, 'Formas de pagamento', 'FormaPagamentoHeaderList'),
	(189, 'Conta corrente', 'ContaCorrenteHeaderList'),
	(190, 'Bancos', 'BancoList'),
	(191, 'Plano de contas', 'PlanoContaList'),
	(192, 'Centro de custos', 'CentroCustoList'),
	(193, 'Tipos de anexo', 'TitulosTipoAnexoHeaderList'),
	(194, 'Relatório Plano de Contas', 'ContabilLancamentosReport'),
	(195, 'Lançamentos de Caixa', 'CaixaLancamentosSimpleList'),
	(196, 'Abertura de Caixa', 'AberturaCaixaForm'),
	(197, 'Cadastro de forma de pagamento', 'FormaPagamentoForm'),
	(198, 'Sangria/Suprimento de Caixa', 'SangriaSuprimentoForm'),
	(199, 'Cadastro de tipos de anexo', 'TitulosTipoAnexoForm'),
	(200, 'Histórico de cobranças', 'ContasrecHistoricoCobrancaFormList'),
	(201, 'Visualizar Contas a Pagar', 'ContaspagFormView'),
	(202, 'Cadastro de contas a receber', 'ContasrecForm'),
	(203, 'Baixa de Contas a Receber', 'ContasrecBaixasForm'),
	(204, 'Cadastro de Lançamento em conta corrente', 'ContaCorrenteLancamentosForm'),
	(205, 'Cadastro de centro de custo', 'CentroCustoForm'),
	(206, 'Cadastro de condição de pagamento', 'CondicaoPagamentoForm'),
	(207, 'Resumo de Formas Caixa', 'CaixaResumoFormasSimpleList'),
	(208, 'Cadastro de Bancos', 'BancoForm'),
	(209, 'Cadastro de conta corrente', 'ContaCorrenteForm'),
	(210, 'Cadastro de contas à pagar', 'ContaspagForm'),
	(211, 'Cadastro de plano de conta', 'PlanoContaForm'),
	(212, 'Baixa de Contas a Pagar', 'ContaspagBaixasForm'),
	(213, 'Consulta de Baixas - Contas a Pagar', 'ContaspagBaixasSimpleList'),
	(214, 'Visualizar Contas a Receber', 'ContasrecFormView'),
	(215, 'Geração de Títulos em Bloco', 'ContaspagBlocoForm'),
	(216, 'Geração de Títulos em Bloco', 'ContasrecBlocoForm'),
	(217, 'Consultas de Baixas - Contas a Receber', 'ContasrecBaixasSimpleList'),
	(218, 'Baixar Contas a Pagar em Bloco', 'ContasPagBaixaBlocoForm'),
	(219, 'Baixar Contas a Receber em Bloco', 'ContasRecBaixaBlocoForm'),
	(220, 'Cadastro de anexos de contas a pagar', 'ContaspagAnexosForm'),
	(221, 'Cadastro de anexos de contas a receber', 'ContasrecAnexosForm'),
	(222, 'Anexos de contas a receber', 'ContasrecAnexosHeaderList'),
	(223, 'Anexos de contas a pagar', 'ContaspagAnexosHeaderList'),
	(224, 'Exceção de Natureza de Operação - ICMS', 'NaturezaOperacaoExcecaoICMSList'),
	(225, 'Nota Fiscal', 'NotafiscalList'),
	(226, 'Séries de nota fiscal', 'NotafiscalSeriesHeaderList'),
	(227, 'Naturezas de Operação', 'NaturezaOperacaoHeaderList'),
	(228, 'Relatório de Notas Fiscais', 'NotafiscalReport'),
	(229, 'Notas fiscais por CFOP', 'NotasFiscaisCFOP'),
	(230, 'Inutilizar numeros', 'InutilizarNumeroList'),
	(231, 'MDF-e', 'MdfeList'),
	(232, 'Séries de MDF-e', 'MdfeSeriesHeaderList'),
	(233, 'Pedido eventos', 'PedidoEventoList'),
	(234, 'LogsNotafiscal', 'NotafiscalLogsTimeLine'),
	(235, 'Cancelamento de MDF-e', 'MDFeCancelamentoForm'),
	(236, 'Carta de Correção', 'CartaCorrecaoNotaForm'),
	(237, 'Eventos da MDFE', 'MdfeEventoSimpleList'),
	(238, 'MDF-e Descarga', 'MdfeInfmundescargaMDFeForm'),
	(239, 'NFe Descarga', 'MdfeInfmundescargaForm'),
	(240, 'CT-e Descarga', 'MdfeInfmundescargaCteForm'),
	(241, 'MDFE - Visualizar', 'MdfeFormView'),
	(242, 'MDFE - Inclusão DFE', 'MdfeInclusaoDfeForm'),
	(243, 'Cadastro de Veiculo', 'VeiculoForm'),
	(244, 'Retorno Envio de Nota', 'RetornoCloudList'),
	(245, 'Cadastro de séries de nota fiscal', 'NotafiscalSeriesForm'),
	(246, 'Cadastro de MDF-e', 'MdfeForm'),
	(247, 'Cadastro de Nota Fiscal de Consumidor', 'NotafiscalConsumidorForm'),
	(248, 'Lista de CT-e', 'MdfeCtesSimpleList'),
	(249, 'Detalhe do Item', 'NotafiscalItensFormView'),
	(250, 'Lista de Notas Fiscais', 'MdfeNfesSimpleList'),
	(251, 'Cancelamento MDFE', 'CancelamentoMDFEForm'),
	(252, 'Visualizar Nota Fiscal Consumidor', 'NotafiscalConsumidorFormView'),
	(253, 'Itens da Nota Fiscal', 'NotafiscalItensForm'),
	(254, 'Cadastro Exceção de Natureza de Operação - ICMS', 'NaturezaOperacaoExcecaoICMSForm'),
	(255, 'Cadastro de séries de MDF-e', 'MdfeSeriesForm'),
	(256, 'Lista de MDF-e', 'MdfeMdfesSimpleList'),
	(257, 'Visualizar Nota Fiscal', 'NotafiscalFormView'),
	(258, 'Cadastro de inutilizar numero', 'InutilizarNumeroForm'),
	(259, 'Encerrar MDF-e', 'MDFeEncerrarForm'),
	(260, 'Cadastro de natureza operacao', 'NaturezaOperacaoForm'),
	(261, 'Lista Itens da Nota Fiscal', 'NotafiscalItensSimpleList'),
	(262, 'Cadastro de Nota Fiscal', 'NotafiscalForm'),
	(263, 'Cancelamento de Nota', 'CancelementoNotaForm'),
	(264, 'Ordem de serviço', 'OrdemServicoList'),
	(265, 'Grupos de serviço', 'ServicoGrupoHeaderList'),
	(266, 'Serviços', 'ServicoList'),
	(267, 'Despesas de serviços', 'DespesasServicosHeaderList'),
	(268, 'Cadastro de Serviços', 'OrdemServicoItemForm'),
	(269, 'Visualizar ordem de serviço', 'OrdemServicoFormView'),
	(270, 'OrdemServicoReciboDocument', 'OrdemServicoReciboDocument'),
	(271, 'RecusarOSForm', 'RecusarOSForm'),
	(272, 'Cadastro de despesas de serviços', 'DespesasServicosForm'),
	(273, 'OrdemServicoDocument', 'OrdemServicoDocument'),
	(274, 'Cadastro de ordem de serviço', 'OrdemServicoForm'),
	(275, 'Serviço Faturamento', 'ServicoFaturamentoSimpleList'),
	(276, 'Ordem Serviço item listagem', 'OrdemServicoItemSimpleList'),
	(277, 'OrdemServicoPropostaDocument', 'OrdemServicoPropostaDocument'),
	(278, 'Busca de Serviços', 'ServicoSeekWindow'),
	(279, 'Cadastro de grupo de serviço', 'ServicoGrupoForm'),
	(280, 'Ordens de produção', 'OrdemProducaoList'),
	(281, 'Ordem de produção documento', 'OrdemProducaoDocument'),
	(282, 'Visualizar Ordem de Produção', 'OrdemProducaoFormView'),
	(283, 'Cadastro de ordem de produção', 'OrdemProducaoForm'),
	(284, 'Visualizar Ordem de Produção', 'OrdemProducaoFormView2'),
	(285, 'Grupos de produto ', 'ProdutoGrupoHeaderList'),
	(286, 'Produtos', 'ProdutoList'),
	(287, 'Produtos (Consulta por Cards)', 'ProdutoCardList'),
	(288, 'Tabela de Preços', 'TabelaPrecoHeaderList'),
	(289, 'Unidades de medida', 'UnidadeMedidaHeaderList'),
	(290, 'Fabricantes', 'ProdutoFabricanteHeaderList'),
	(291, 'Embalagens', 'ProdutoEmbalagemHeaderList'),
	(292, 'Relatório de histórico de preços por produto', 'ProdutoFilialHistoricoReport'),
	(293, 'Etiqueta de código de barra de produto - Modelo 1', 'ProdutoBarCode'),
	(294, 'Etiqueta de código de barra de produto - Modelo 2', 'ProdutoBarCode2'),
	(295, 'Cadastro de grupo de produto', 'ProdutoGrupoForm'),
	(296, 'Fichas técnicas de serviço', 'ServicoFichaTecnicaHeaderList'),
	(297, 'Indicadores de Produto', 'ProdutoIndicadoresForm'),
	(298, 'Unidades de Medida', 'UnidadeMedidaFormView'),
	(299, 'Cadastro de ficha técnica de produto', 'ProdutoFichaTecnicaForm'),
	(300, 'Fichas técnicas de produto', 'ProdutoFichaTecnicaHeaderList'),
	(301, 'Visualizar Produto', 'ProdutoFormView'),
	(302, 'Cadastro de ficha técnica de serviço', 'ServicoFichaTecnicaForm'),
	(303, 'Cadastro de unidade de medida', 'UnidadeMedidaForm'),
	(304, 'Clientes da Tabela de Preço', 'TabelaPrecoClienteSimpleList'),
	(305, 'Cadastro de Tabela de Preço', 'TabelaPrecoForm'),
	(306, 'Endereçamento de Produto', 'ProdutoEnderecamentoFormList'),
	(307, 'Cadastro de Fabricante', 'ProdutoFabricanteForm'),
	(308, 'Cadastro de embalagens', 'ProdutoEmbalagemForm'),
	(309, 'Cadastro de produto', 'ProdutoForm'),
	(310, 'Situação de Venda', 'VendaSituacaoHeaderList'),
	(311, 'Situação de venda de certificados', 'CertificadoVendaSituacaoHeaderList'),
	(312, 'Situação de Nota Fiscal', 'NotafiscalSituacaoHeaderList'),
	(313, 'Situação de contas a pagar', 'ContaspagSituacaoHeaderList'),
	(314, 'Situação de contas a receber', 'ContasrecSituacaoHeaderList'),
	(315, 'Situação de MDF-e', 'MdfeSituacaoHeaderList'),
	(316, 'Situação de nota fiscal de compra', 'NotaFiscalCompraSituacaoHeaderList'),
	(317, 'Situação de ordem de produção', 'OrdemProducaoSituacaoHeaderList'),
	(318, 'Situação de etapas de ordem de produção ', 'OrdemProducaoEtapasSituacaoHeaderList'),
	(319, 'Situação de Orçamento', 'OrcamentoSituacaoHeaderList'),
	(320, 'Situação de ordem de serviço', 'OrdemServicoSituacaoHeaderList'),
	(321, 'Hot Fix (Exclusivo Admin Kraft)', 'HotFix'),
	(322, 'Cadastro de venda situacao', 'VendaSituacaoForm'),
	(323, 'Cadastro de situacao de ordem serviço', 'OrdemServicoSituacaoForm'),
	(324, 'Cadastro de situação de ordem de produção ', 'OrdemProducaoSituacaoForm'),
	(325, 'Cadastro de Situação de Nota Fiscal', 'NotafiscalSituacaoForm'),
	(326, 'Cadastro de situação de nota fiscal de compra', 'NotaFiscalCompraSituacaoForm'),
	(327, 'Cadastro de Situação de Orçamento', 'OrcamentoSituacaoForm'),
	(328, 'Cadastro de situação de contas a pagar', 'ContaspagSituacaoForm'),
	(329, 'Cadastro de situação de contas a receber', 'ContasrecSituacaoForm'),
	(330, 'Cadastro de Situação de MDF-e', 'MdfeSituacaoForm'),
	(331, 'Cadastro de Situação Ordem de produção estapas', 'OrdemProducaoEtapasSituacaoForm'),
	(332, 'Cadastro de situação de venda de certificados', 'CertificadoVendaSituacaoForm'),
	(333, 'Vendas Cliente', 'ClienteVendaList'),
	(334, 'Orçamentos', 'OrcamentoList'),
	(335, 'Vendas', 'VendaList'),
	(336, 'Kanban de Venda', 'VendaKanbanFormView'),
	(337, 'Metas de Venda', 'VendaMetaList'),
	(338, 'Relatório de Vendas', 'VendaReport'),
	(339, 'Relatório de comissão vendedor por venda', 'ComissaoVendedorPorVendaReport'),
	(340, 'Relatório Venda Por Produto', 'RelatorioVendaPorProduto'),
	(341, 'Relatório De Lucratividade', 'VendaItemReport'),
	(342, 'Relatório de vendas sintético ', 'RelatorioVendaSintetico'),
	(343, 'Devolução/Troca de Vendas', 'VendaDevolucaoList'),
	(344, 'Busca de Clientes', 'ClienteSeekWindow'),
	(345, 'Linha do tempo do orçamento', 'OrcamentoSituacaoHistoricoTimeLine'),
	(346, 'Linha do tempo da venda', 'VendaSituacaoHistoricoTimeLine'),
	(347, 'Documento do orcamento', 'OrcamentoDocument'),
	(348, 'CupomNaoFiscalDocument', 'CupomNaoFiscalDocument'),
	(349, 'Venda Etiqueta Documento', 'VendaEtiquetaDocument'),
	(350, 'Visualizar Devolução/troca', 'VendaDevolucaoFormView'),
	(351, 'Cadastro de Orçamentos', 'OrcamentoForm'),
	(352, 'Visualizar Orçamento', 'OrcamentoFormView'),
	(353, 'Enviar e-mail de orçamento', 'OrcamentoEmailForm'),
	(354, 'Vendas de produto', 'VendaItemProdutoSimpleList'),
	(355, 'Vencimentos de Títulos da Venda', 'VendaFormapgtoTitulosForm'),
	(356, 'Cadastro de metas de venda', 'VendaMetaForm'),
	(357, 'ReprovarOrcamentoForm', 'ReprovarOrcamentoForm'),
	(358, 'Faturamento de Venda', 'VendaFaturamentoSimpleList'),
	(359, 'VendaKanbanView', 'VendaKanbanView'),
	(360, 'DevolucaoMercadoriaDocument', 'DevolucaoMercadoriaDocument'),
	(361, 'EspelhosDaVenda', 'EspelhosDaVenda'),
	(362, 'Relatório de Separação', 'RelatorioDeSeparacaoDocument'),
	(363, 'Detalhes da Venda', 'VendaFormView'),
	(364, 'Busca de Produtos', 'ProdutoSeekWindow'),
	(365, 'Cadastro de devolução/troca de vendas', 'VendaDevolucaoForm'),
	(366, 'Cadastro de venda', 'VendaForm');

-- Copiando estrutura para tabela erp_nuvem.system_program_permissoes
DROP TABLE IF EXISTS `system_program_permissoes`;
CREATE TABLE IF NOT EXISTS `system_program_permissoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_program_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_program_permissoes_1` (`system_program_id`),
  CONSTRAINT `fk_system_program_permissoes_1` FOREIGN KEY (`system_program_id`) REFERENCES `system_program` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_program_permissoes: ~6 rows (aproximadamente)
INSERT INTO `system_program_permissoes` (`id`, `system_program_id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 213, 'Desfazer baixa de contas a pagar', '2024-06-05 21:48:56', NULL, NULL, 'Administrador', NULL),
	(2, 217, 'Desfazer baixa de contas a receber', '2024-06-05 21:48:56', NULL, NULL, 'Administrador', NULL),
	(3, 102, 'Desfazer atendimento de venda de certificado', '2024-06-05 21:48:56', NULL, NULL, 'Administrador', NULL),
	(4, 82, 'Desfazer atendimento de venda de certificado', '2024-06-05 21:48:56', NULL, NULL, 'Administrador', NULL),
	(5, 46, 'Excluir funil de CRM', '2024-06-05 21:48:56', NULL, NULL, 'Administrador', NULL),
	(6, 104, 'Excluir Cliente', '2024-06-05 21:48:56', NULL, NULL, 'Administrador', NULL);

-- Copiando estrutura para tabela erp_nuvem.system_unit
DROP TABLE IF EXISTS `system_unit`;
CREATE TABLE IF NOT EXISTS `system_unit` (
  `id` int NOT NULL,
  `connection_name` text COLLATE utf8mb3_unicode_ci,
  `vendas_natureza_operacao_id` int DEFAULT NULL,
  `nfce_natureza_operacao_id` int DEFAULT NULL,
  `cnpj` varchar(14) COLLATE utf8mb3_unicode_ci NOT NULL,
  `name` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `razao_social` varchar(255) COLLATE utf8mb3_unicode_ci NOT NULL,
  `inscricao_estadual` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `inscricao_municipal` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `fone` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_crt_id` int NOT NULL,
  `pc_credito_sn` double DEFAULT '0',
  `aliquota_iss` double DEFAULT NULL,
  `aliquota_irrf` double DEFAULT NULL,
  `aliquota_csll` double DEFAULT NULL,
  `sn_matriz` char(1) COLLATE utf8mb3_unicode_ci NOT NULL DEFAULT 'N',
  `nfce_tpamb_id` int DEFAULT NULL,
  `nfe_tpamb_id` int DEFAULT NULL,
  `nfe_tpimp_id` int DEFAULT NULL,
  `nfce_tpimp_id` int DEFAULT NULL,
  `certificadoA1` text COLLATE utf8mb3_unicode_ci,
  `senha_certificado` text COLLATE utf8mb3_unicode_ci,
  `nfe_homologacao_series_id` int DEFAULT NULL,
  `nfe_producao_series_id` int DEFAULT NULL,
  `nfce_homologacao_series_id` int DEFAULT NULL,
  `nfe_api_documentos_id` int DEFAULT NULL,
  `nfce_api_documentos_id` int DEFAULT NULL,
  `nfce_producao_series_id` int DEFAULT NULL,
  `end_cep` text COLLATE utf8mb3_unicode_ci,
  `end_mun_codibge` text COLLATE utf8mb3_unicode_ci,
  `end_municipio` text COLLATE utf8mb3_unicode_ci,
  `end_uf` char(2) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `end_logradouro` text COLLATE utf8mb3_unicode_ci,
  `end_bairro` text COLLATE utf8mb3_unicode_ci,
  `end_numero` text COLLATE utf8mb3_unicode_ci,
  `end_complemento` text COLLATE utf8mb3_unicode_ci,
  `nfce_csc_homologacao` text COLLATE utf8mb3_unicode_ci,
  `nfce_csc_producao` text COLLATE utf8mb3_unicode_ci,
  `notafiscal_cprod_padrao_id` int DEFAULT NULL,
  `nfce_id_csc_homologacao` text COLLATE utf8mb3_unicode_ci,
  `nfce_id_csc_producao` text COLLATE utf8mb3_unicode_ci,
  `email` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `token_api` text COLLATE utf8mb3_unicode_ci,
  `mdfe_tpamb_id` int DEFAULT NULL,
  `mdfe_estadoini_id` int DEFAULT NULL,
  `veiculo_id` int DEFAULT NULL,
  `mdfe_api_documentos_id` int DEFAULT NULL,
  `mdfe_homologacao_series_id` int DEFAULT NULL,
  `mdfe_producao_series_id` int DEFAULT NULL,
  `natureza_operacao_compra_id` int DEFAULT NULL,
  `logo` text COLLATE utf8mb3_unicode_ci,
  `contador_nome` text COLLATE utf8mb3_unicode_ci,
  `contador_documento` text COLLATE utf8mb3_unicode_ci,
  `contador_email` text COLLATE utf8mb3_unicode_ci,
  `contador_celular` text COLLATE utf8mb3_unicode_ci,
  `config_host` text COLLATE utf8mb3_unicode_ci,
  `config_user` text COLLATE utf8mb3_unicode_ci,
  `config_password` text COLLATE utf8mb3_unicode_ci,
  `config_port` varchar(11) COLLATE utf8mb3_unicode_ci DEFAULT '587',
  `config_from` text COLLATE utf8mb3_unicode_ci,
  `config_replyname` text COLLATE utf8mb3_unicode_ci,
  `config_replyto` text COLLATE utf8mb3_unicode_ci,
  `column_63` int DEFAULT NULL,
  `cnae` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`),
  KEY `fk_system_unit_2` (`notafiscal_crt_id`),
  KEY `fk_system_unit_4` (`nfe_tpamb_id`),
  KEY `fk_system_unit_5` (`nfe_tpimp_id`),
  KEY `fk_system_unit_13` (`nfe_api_documentos_id`),
  KEY `fk_system_unit_6` (`vendas_natureza_operacao_id`),
  KEY `fk_system_unit_7` (`nfce_natureza_operacao_id`),
  KEY `fk_system_unit_9` (`nfe_homologacao_series_id`),
  KEY `fk_system_unit_10` (`nfe_producao_series_id`),
  KEY `fk_system_unit_11` (`nfce_homologacao_series_id`),
  KEY `fk_system_unit_12` (`nfce_producao_series_id`),
  KEY `fk_system_unit_14` (`notafiscal_cprod_padrao_id`),
  KEY `fk_system_unit_15` (`mdfe_tpamb_id`),
  KEY `fk_system_unit_3` (`nfce_tpamb_id`),
  KEY `fk_system_unit_1` (`nfce_api_documentos_id`),
  KEY `fk_system_unit_16` (`mdfe_estadoini_id`),
  KEY `fk_system_unit_18` (`veiculo_id`),
  KEY `fk_system_unit_19` (`mdfe_api_documentos_id`),
  KEY `fk_system_unit_20` (`mdfe_homologacao_series_id`),
  KEY `fk_system_unit_21` (`natureza_operacao_compra_id`),
  CONSTRAINT `fk_system_unit_1` FOREIGN KEY (`nfce_api_documentos_id`) REFERENCES `api_documentos` (`id`),
  CONSTRAINT `fk_system_unit_10` FOREIGN KEY (`nfe_producao_series_id`) REFERENCES `notafiscal_series` (`id`),
  CONSTRAINT `fk_system_unit_11` FOREIGN KEY (`nfce_homologacao_series_id`) REFERENCES `notafiscal_series` (`id`),
  CONSTRAINT `fk_system_unit_12` FOREIGN KEY (`nfce_producao_series_id`) REFERENCES `notafiscal_series` (`id`),
  CONSTRAINT `fk_system_unit_13` FOREIGN KEY (`nfe_api_documentos_id`) REFERENCES `api_documentos` (`id`),
  CONSTRAINT `fk_system_unit_14` FOREIGN KEY (`notafiscal_cprod_padrao_id`) REFERENCES `notafiscal_cprod_padrao` (`id`),
  CONSTRAINT `fk_system_unit_15` FOREIGN KEY (`mdfe_tpamb_id`) REFERENCES `mdfe_tpamb` (`id`),
  CONSTRAINT `fk_system_unit_16` FOREIGN KEY (`mdfe_estadoini_id`) REFERENCES `estado` (`id`),
  CONSTRAINT `fk_system_unit_18` FOREIGN KEY (`veiculo_id`) REFERENCES `veiculo` (`id`),
  CONSTRAINT `fk_system_unit_19` FOREIGN KEY (`mdfe_api_documentos_id`) REFERENCES `api_documentos` (`id`),
  CONSTRAINT `fk_system_unit_2` FOREIGN KEY (`notafiscal_crt_id`) REFERENCES `notafiscal_crt` (`id`),
  CONSTRAINT `fk_system_unit_20` FOREIGN KEY (`mdfe_homologacao_series_id`) REFERENCES `mdfe_series` (`id`),
  CONSTRAINT `fk_system_unit_21` FOREIGN KEY (`natureza_operacao_compra_id`) REFERENCES `natureza_operacao` (`id`),
  CONSTRAINT `fk_system_unit_3` FOREIGN KEY (`nfce_tpamb_id`) REFERENCES `notafiscal_tpamb` (`id`),
  CONSTRAINT `fk_system_unit_4` FOREIGN KEY (`nfe_tpamb_id`) REFERENCES `notafiscal_tpamb` (`id`),
  CONSTRAINT `fk_system_unit_5` FOREIGN KEY (`nfe_tpimp_id`) REFERENCES `notafiscal_tpimp` (`id`),
  CONSTRAINT `fk_system_unit_6` FOREIGN KEY (`vendas_natureza_operacao_id`) REFERENCES `natureza_operacao` (`id`),
  CONSTRAINT `fk_system_unit_7` FOREIGN KEY (`nfce_natureza_operacao_id`) REFERENCES `natureza_operacao` (`id`),
  CONSTRAINT `fk_system_unit_9` FOREIGN KEY (`nfe_homologacao_series_id`) REFERENCES `notafiscal_series` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_unit: ~0 rows (aproximadamente)
INSERT INTO `system_unit` (`id`, `connection_name`, `vendas_natureza_operacao_id`, `nfce_natureza_operacao_id`, `cnpj`, `name`, `razao_social`, `inscricao_estadual`, `inscricao_municipal`, `fone`, `notafiscal_crt_id`, `pc_credito_sn`, `aliquota_iss`, `aliquota_irrf`, `aliquota_csll`, `sn_matriz`, `nfce_tpamb_id`, `nfe_tpamb_id`, `nfe_tpimp_id`, `nfce_tpimp_id`, `certificadoA1`, `senha_certificado`, `nfe_homologacao_series_id`, `nfe_producao_series_id`, `nfce_homologacao_series_id`, `nfe_api_documentos_id`, `nfce_api_documentos_id`, `nfce_producao_series_id`, `end_cep`, `end_mun_codibge`, `end_municipio`, `end_uf`, `end_logradouro`, `end_bairro`, `end_numero`, `end_complemento`, `nfce_csc_homologacao`, `nfce_csc_producao`, `notafiscal_cprod_padrao_id`, `nfce_id_csc_homologacao`, `nfce_id_csc_producao`, `email`, `token_api`, `mdfe_tpamb_id`, `mdfe_estadoini_id`, `veiculo_id`, `mdfe_api_documentos_id`, `mdfe_homologacao_series_id`, `mdfe_producao_series_id`, `natureza_operacao_compra_id`, `logo`, `contador_nome`, `contador_documento`, `contador_email`, `contador_celular`, `config_host`, `config_user`, `config_password`, `config_port`, `config_from`, `config_replyname`, `config_replyto`, `column_63`, `cnae`) VALUES
	(1, 'matriz', 1, 1, '14013224000142', 'Matriz', 'Matriz', NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, 'S', 2, 2, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'admin', NULL, NULL, NULL, NULL, NULL, 'admin');

-- Copiando estrutura para tabela erp_nuvem.system_users
DROP TABLE IF EXISTS `system_users`;
CREATE TABLE IF NOT EXISTS `system_users` (
  `id` int NOT NULL,
  `name` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `login` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `password` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `email` text COLLATE utf8mb3_unicode_ci,
  `frontpage_id` int DEFAULT NULL,
  `system_unit_id` int DEFAULT NULL,
  `active` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `accepted_term_policy` char(1) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_user_1` (`system_unit_id`),
  KEY `fk_system_user_2` (`frontpage_id`),
  CONSTRAINT `fk_system_user_1` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_system_user_2` FOREIGN KEY (`frontpage_id`) REFERENCES `system_program` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_users: ~0 rows (aproximadamente)
INSERT INTO `system_users` (`id`, `name`, `login`, `password`, `email`, `frontpage_id`, `system_unit_id`, `active`, `accepted_term_policy`) VALUES
	(1, 'Administrador', 'admin', '45dec722904764c8dcc8ba514e52d77b', 'kraftsoft@fdtec.com.br', NULL, 1, 'Y', 'Y');

-- Copiando estrutura para tabela erp_nuvem.system_user_group
DROP TABLE IF EXISTS `system_user_group`;
CREATE TABLE IF NOT EXISTS `system_user_group` (
  `id` int NOT NULL,
  `system_user_id` int NOT NULL,
  `system_group_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_user_group_1` (`system_group_id`),
  KEY `fk_system_user_group_2` (`system_user_id`),
  CONSTRAINT `fk_system_user_group_1` FOREIGN KEY (`system_group_id`) REFERENCES `system_group` (`id`),
  CONSTRAINT `fk_system_user_group_2` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_user_group: ~19 rows (aproximadamente)
INSERT INTO `system_user_group` (`id`, `system_user_id`, `system_group_id`) VALUES
	(1, 1, 1),
	(2, 2, 2),
	(3, 1, 2),
	(4, 1, 3),
	(5, 1, 4),
	(6, 1, 5),
	(7, 1, 6),
	(8, 1, 7),
	(9, 1, 8),
	(10, 1, 9),
	(11, 1, 10),
	(12, 1, 11),
	(13, 1, 12),
	(14, 1, 13),
	(15, 1, 14),
	(16, 1, 15),
	(17, 1, 16),
	(18, 1, 17),
	(19, 1, 18);

-- Copiando estrutura para tabela erp_nuvem.system_user_pdv_permissoes
DROP TABLE IF EXISTS `system_user_pdv_permissoes`;
CREATE TABLE IF NOT EXISTS `system_user_pdv_permissoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `empresa_id` int NOT NULL,
  `pdv_permissoes_id` int NOT NULL,
  `system_user_id` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_user_permissoes_pdv_2` (`pdv_permissoes_id`),
  CONSTRAINT `fk_system_user_permissoes_pdv_2` FOREIGN KEY (`pdv_permissoes_id`) REFERENCES `pdv_permissoes` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_user_pdv_permissoes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_user_program
DROP TABLE IF EXISTS `system_user_program`;
CREATE TABLE IF NOT EXISTS `system_user_program` (
  `id` int NOT NULL,
  `system_user_id` int NOT NULL,
  `system_program_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_user_program_1` (`system_program_id`),
  KEY `fk_system_user_program_2` (`system_user_id`),
  CONSTRAINT `fk_system_user_program_1` FOREIGN KEY (`system_program_id`) REFERENCES `system_program` (`id`),
  CONSTRAINT `fk_system_user_program_2` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_user_program: ~0 rows (aproximadamente)
INSERT INTO `system_user_program` (`id`, `system_user_id`, `system_program_id`) VALUES
	(1, 2, 7);

-- Copiando estrutura para tabela erp_nuvem.system_user_program_permissoes
DROP TABLE IF EXISTS `system_user_program_permissoes`;
CREATE TABLE IF NOT EXISTS `system_user_program_permissoes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `system_users_id` int NOT NULL,
  `system_program_permissoes_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_user_program_permissoes_1` (`system_users_id`),
  KEY `fk_system_user_program_permissoes_2` (`system_program_permissoes_id`),
  KEY `fk_system_user_program_permissoes_3` (`system_unit_id`),
  CONSTRAINT `fk_system_user_program_permissoes_1` FOREIGN KEY (`system_users_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_system_user_program_permissoes_2` FOREIGN KEY (`system_program_permissoes_id`) REFERENCES `system_program_permissoes` (`id`),
  CONSTRAINT `fk_system_user_program_permissoes_3` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_user_program_permissoes: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.system_user_unit
DROP TABLE IF EXISTS `system_user_unit`;
CREATE TABLE IF NOT EXISTS `system_user_unit` (
  `id` int NOT NULL,
  `system_user_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_system_user_unit_1` (`system_user_id`),
  KEY `fk_system_user_unit_2` (`system_unit_id`),
  CONSTRAINT `fk_system_user_unit_1` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`),
  CONSTRAINT `fk_system_user_unit_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.system_user_unit: ~0 rows (aproximadamente)
INSERT INTO `system_user_unit` (`id`, `system_user_id`, `system_unit_id`) VALUES
	(1, 1, 1);

-- Copiando estrutura para tabela erp_nuvem.tabela_preco
DROP TABLE IF EXISTS `tabela_preco`;
CREATE TABLE IF NOT EXISTS `tabela_preco` (
  `id` int NOT NULL AUTO_INCREMENT,
  `tabela_preco_tipo_alteracao_id` int NOT NULL,
  `tabela_preco_tipo_id` int DEFAULT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `data_hora_promocao_inicial` datetime DEFAULT NULL,
  `data_hora_promocao_final` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_tabela_preco_1` (`tabela_preco_tipo_alteracao_id`),
  KEY `fk_tabela_preco_2` (`tabela_preco_tipo_id`),
  CONSTRAINT `fk_tabela_preco_1` FOREIGN KEY (`tabela_preco_tipo_alteracao_id`) REFERENCES `tabela_preco_tipo_alteracao` (`id`),
  CONSTRAINT `fk_tabela_preco_2` FOREIGN KEY (`tabela_preco_tipo_id`) REFERENCES `tabela_preco_tipo` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.tabela_preco: ~0 rows (aproximadamente)
INSERT INTO `tabela_preco` (`id`, `tabela_preco_tipo_alteracao_id`, `tabela_preco_tipo_id`, `descricao`, `observacao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `data_hora_promocao_inicial`, `data_hora_promocao_final`) VALUES
	(1, 1, 1, 'A VISTA', NULL, '2024-04-01 13:53:35', NULL, NULL, 'Administrador', NULL, NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.tabela_preco_produto
DROP TABLE IF EXISTS `tabela_preco_produto`;
CREATE TABLE IF NOT EXISTS `tabela_preco_produto` (
  `id` int NOT NULL AUTO_INCREMENT,
  `tabela_preco_id` int NOT NULL,
  `produto_filial_id` int NOT NULL,
  `preco_venda` double NOT NULL,
  `valor_parametro` double NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_tabela_preco_produto_1` (`tabela_preco_id`),
  KEY `fk_tabela_preco_produto_2` (`produto_filial_id`),
  CONSTRAINT `fk_tabela_preco_produto_1` FOREIGN KEY (`tabela_preco_id`) REFERENCES `tabela_preco` (`id`),
  CONSTRAINT `fk_tabela_preco_produto_2` FOREIGN KEY (`produto_filial_id`) REFERENCES `produto_filial` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.tabela_preco_produto: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.tabela_preco_tipo
DROP TABLE IF EXISTS `tabela_preco_tipo`;
CREATE TABLE IF NOT EXISTS `tabela_preco_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.tabela_preco_tipo: ~2 rows (aproximadamente)
INSERT INTO `tabela_preco_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Permanente', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Promocional Temporária', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.tabela_preco_tipo_alteracao
DROP TABLE IF EXISTS `tabela_preco_tipo_alteracao`;
CREATE TABLE IF NOT EXISTS `tabela_preco_tipo_alteracao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.tabela_preco_tipo_alteracao: ~5 rows (aproximadamente)
INSERT INTO `tabela_preco_tipo_alteracao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Acréscimo percentual sobre o valor do produto', NULL, NULL, '', '', NULL),
	(2, 'Decréscimo percentual sobre o valor do produto', NULL, NULL, '', '', NULL),
	(3, 'Acréscimo com valor fixo sobre o valor do produto', NULL, NULL, '', '', NULL),
	(4, 'Decréscimo com valor fixo sobre o valor do produto', NULL, NULL, '', '', NULL),
	(5, 'Valor fixo', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.tipo_documento
DROP TABLE IF EXISTS `tipo_documento`;
CREATE TABLE IF NOT EXISTS `tipo_documento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.tipo_documento: ~6 rows (aproximadamente)
INSERT INTO `tipo_documento` (`id`, `descricao`, `criado_em`, `alterado_em`) VALUES
	(1, 'Dinheiro', NULL, NULL),
	(2, 'Cheque', NULL, NULL),
	(3, 'Cartão', NULL, NULL),
	(4, 'Boleto', NULL, NULL),
	(5, 'Títulos Diversos', NULL, NULL),
	(6, 'Conta Corrente Cliente', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.tipo_recurso
DROP TABLE IF EXISTS `tipo_recurso`;
CREATE TABLE IF NOT EXISTS `tipo_recurso` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.tipo_recurso: ~2 rows (aproximadamente)
INSERT INTO `tipo_recurso` (`id`, `nome`) VALUES
	(1, 'Produto'),
	(2, 'Serviço');

-- Copiando estrutura para tabela erp_nuvem.titulos_tipo_anexo
DROP TABLE IF EXISTS `titulos_tipo_anexo`;
CREATE TABLE IF NOT EXISTS `titulos_tipo_anexo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.titulos_tipo_anexo: ~3 rows (aproximadamente)
INSERT INTO `titulos_tipo_anexo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Recibo', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Boleto', NULL, NULL, '', 'Sistema Kraft', NULL),
	(3, 'Comprovante de Pagamento', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.unidade_medida
DROP TABLE IF EXISTS `unidade_medida`;
CREATE TABLE IF NOT EXISTS `unidade_medida` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `sigla` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=52 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.unidade_medida: ~51 rows (aproximadamente)
INSERT INTO `unidade_medida` (`id`, `nome`, `sigla`, `criado_em`, `alterado_em`, `criado_por`, `alterado_por`) VALUES
	(1, 'AMPOLA', 'AMPOLA', NULL, NULL, 'Sistema Kraft', ''),
	(2, 'BALDE', 'BALDE', NULL, NULL, 'Sistema Kraft', ''),
	(3, 'BANDEJA', 'BANDEJ', NULL, NULL, 'Sistema Kraft', ''),
	(4, 'BARRA', 'BARRA', NULL, NULL, 'Sistema Kraft', ''),
	(5, 'BISNAGA', 'BISNAG', NULL, NULL, 'Sistema Kraft', ''),
	(6, 'BLOCO', 'BLOCO', NULL, NULL, 'Sistema Kraft', ''),
	(7, 'BOBINA', 'BOBINA', NULL, NULL, 'Sistema Kraft', ''),
	(8, 'BOMBONA', 'BOMBEAR', NULL, NULL, 'Sistema Kraft', ''),
	(9, 'CÁPSULA', 'CÁPSULAS', NULL, NULL, 'Sistema Kraft', ''),
	(10, 'CARTELA', 'CARRINHO', NULL, NULL, 'Sistema Kraft', ''),
	(11, 'CENTO', 'CENTO', NULL, NULL, 'Sistema Kraft', ''),
	(12, 'CONJUNTO', 'CJ', NULL, NULL, 'Sistema Kraft', ''),
	(13, 'CENTÍMETRO', 'CM', NULL, NULL, 'Sistema Kraft', ''),
	(14, 'CENTIMETRO QUADRADO', 'CM2', NULL, NULL, 'Sistema Kraft', ''),
	(15, 'CAIXA', 'CX', NULL, NULL, 'Sistema Kraft', ''),
	(16, 'EXIBIÇÃO', 'DISP', NULL, NULL, 'Sistema Kraft', ''),
	(17, 'DUZIA', 'DUZIA', NULL, NULL, 'Sistema Kraft', ''),
	(18, 'EMBALAGEM', 'EMBAL', NULL, NULL, 'Sistema Kraft', ''),
	(19, 'FARDO', 'FARDO', NULL, NULL, 'Sistema Kraft', ''),
	(20, 'FOLHA', 'FOLHA', NULL, NULL, 'Sistema Kraft', ''),
	(21, 'FRASCO', 'FRASCO', NULL, NULL, 'Sistema Kraft', ''),
	(22, 'GALÃO', 'GALAO', NULL, NULL, 'Sistema Kraft', ''),
	(23, 'GARRAFA', 'GF', NULL, NULL, 'Sistema Kraft', ''),
	(24, 'GRAMAS', 'GRAMAS', NULL, NULL, 'Sistema Kraft', ''),
	(25, 'JOGO', 'JOGO', NULL, NULL, 'Sistema Kraft', ''),
	(26, 'QUILOGRAMA', 'KG', NULL, NULL, 'Sistema Kraft', ''),
	(27, 'KIT', 'KIT', NULL, NULL, 'Sistema Kraft', ''),
	(28, 'LATA', 'LATA', NULL, NULL, 'Sistema Kraft', ''),
	(29, 'LITRO', 'LITRO', NULL, NULL, 'Sistema Kraft', ''),
	(30, 'METRO', 'M', NULL, NULL, 'Sistema Kraft', ''),
	(31, 'METRO QUADRADO', 'M2', NULL, NULL, 'Sistema Kraft', ''),
	(32, 'METRO CÚBICO', 'M3', NULL, NULL, 'Sistema Kraft', ''),
	(33, 'MILHEIRO', 'MILHEI', NULL, NULL, 'Sistema Kraft', ''),
	(34, 'MILILITRO', 'ML', NULL, NULL, 'Sistema Kraft', ''),
	(35, 'MEGAWATT HORA', 'MWH', NULL, NULL, 'Sistema Kraft', ''),
	(36, 'PACOTE', 'PACOTE', NULL, NULL, 'Sistema Kraft', ''),
	(37, 'PALETE', 'PALETE', NULL, NULL, 'Sistema Kraft', ''),
	(38, 'PARES', 'PARES', NULL, NULL, 'Sistema Kraft', ''),
	(39, 'PEÇA', 'PC', NULL, NULL, 'Sistema Kraft', ''),
	(40, 'QUILATE', 'K', NULL, NULL, 'Sistema Kraft', ''),
	(41, 'RESMA', 'RESMA', NULL, NULL, 'Sistema Kraft', ''),
	(42, 'ROLO', 'ROLO', NULL, NULL, 'Sistema Kraft', ''),
	(43, 'SACO', 'SACO', NULL, NULL, 'Sistema Kraft', ''),
	(44, 'SACOLA', 'SACOLA', NULL, NULL, 'Sistema Kraft', ''),
	(45, 'TAMBOR', 'TAMBOR', NULL, NULL, 'Sistema Kraft', ''),
	(46, 'TANQUE', 'TANQUE', NULL, NULL, 'Sistema Kraft', ''),
	(47, 'TONELADA', 'TON', NULL, NULL, 'Sistema Kraft', ''),
	(48, 'TUBO', 'TUBO', NULL, NULL, 'Sistema Kraft', ''),
	(49, 'UNIDADE', 'UNID', NULL, NULL, 'Sistema Kraft', ''),
	(50, 'VASILHAME', 'VASIL', NULL, NULL, 'Sistema Kraft', ''),
	(51, 'VIDRO', 'VIDRO', NULL, NULL, 'Sistema Kraft', '');

-- Copiando estrutura para tabela erp_nuvem.veiculo
DROP TABLE IF EXISTS `veiculo`;
CREATE TABLE IF NOT EXISTS `veiculo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `modelo_marca` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `placa` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `ano` int DEFAULT NULL,
  `tara` double DEFAULT NULL,
  `capacidade_kg` double DEFAULT NULL,
  `renavam` text COLLATE utf8mb3_unicode_ci,
  `capacidade_m3` double DEFAULT NULL,
  `mdfe_tpRod_id` int NOT NULL,
  `estado_id` int NOT NULL,
  `veiculo_tipo_id` int NOT NULL,
  `mdfe_tpcar_id` int NOT NULL,
  `funcionario_motorista_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_veiculo_1` (`mdfe_tpRod_id`),
  KEY `fk_veiculo_3` (`estado_id`),
  KEY `fk_veiculo_4` (`veiculo_tipo_id`),
  KEY `fk_veiculo_5` (`funcionario_motorista_id`),
  CONSTRAINT `fk_veiculo_1` FOREIGN KEY (`mdfe_tpRod_id`) REFERENCES `mdfe_tprod` (`id`),
  CONSTRAINT `fk_veiculo_3` FOREIGN KEY (`estado_id`) REFERENCES `estado` (`id`),
  CONSTRAINT `fk_veiculo_4` FOREIGN KEY (`veiculo_tipo_id`) REFERENCES `veiculo_tipo` (`id`),
  CONSTRAINT `fk_veiculo_5` FOREIGN KEY (`funcionario_motorista_id`) REFERENCES `funcionario` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.veiculo: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.veiculo_tipo
DROP TABLE IF EXISTS `veiculo_tipo`;
CREATE TABLE IF NOT EXISTS `veiculo_tipo` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.veiculo_tipo: ~4 rows (aproximadamente)
INSERT INTO `veiculo_tipo` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Carro', NULL, NULL, '', '', NULL),
	(2, 'Motocicleta', NULL, NULL, '', '', NULL),
	(3, 'Caminhão', NULL, NULL, '', '', NULL),
	(4, 'Outros', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.venda
DROP TABLE IF EXISTS `venda`;
CREATE TABLE IF NOT EXISTS `venda` (
  `id` int NOT NULL AUTO_INCREMENT,
  `venda_situacao_id` int NOT NULL,
  `orcamento_id` int DEFAULT NULL,
  `vendedor_id` int DEFAULT NULL,
  `dispositivos_id` int DEFAULT NULL,
  `cliente_id` int DEFAULT NULL,
  `numero_celula_consumo` text COLLATE utf8mb3_unicode_ci,
  `system_unit_id` int NOT NULL,
  `filial_saida_id` int NOT NULL,
  `venda_modalidade_id` int NOT NULL,
  `venda_tipo_pagamento_id` int NOT NULL,
  `id_venda_local` int DEFAULT NULL,
  `data_hora_venda` datetime NOT NULL,
  `valor_produtos` double NOT NULL,
  `valor_troco` double DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `observacao` text COLLATE utf8mb3_unicode_ci,
  `observacao_nf` text COLLATE utf8mb3_unicode_ci,
  `peso_total` double DEFAULT NULL,
  `frete_total` double DEFAULT NULL,
  `valor_total` double NOT NULL,
  `cliente_endereco_id` int DEFAULT NULL,
  `info_faturamento` text COLLATE utf8mb3_unicode_ci,
  `data_prev_entrega` date DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `valor_comissao` double DEFAULT NULL,
  `comissao_avista` double DEFAULT NULL,
  `comissao_aprazo` int DEFAULT NULL,
  `valor_avista` double DEFAULT NULL,
  `valor_aprazo` double DEFAULT NULL,
  `tabela_preco_id` int DEFAULT NULL,
  `movimentacao_origem_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_2` (`venda_situacao_id`),
  KEY `fk_venda_1` (`cliente_id`),
  KEY `fk_venda_3` (`dispositivos_id`),
  KEY `fk_venda_4` (`system_unit_id`),
  KEY `fk_venda_5` (`filial_saida_id`),
  KEY `fk_venda_6` (`venda_modalidade_id`),
  KEY `fk_venda_7` (`venda_tipo_pagamento_id`),
  KEY `fk_venda_8` (`vendedor_id`),
  KEY `fk_venda_9` (`orcamento_id`),
  KEY `fk_venda_10` (`cliente_endereco_id`),
  KEY `fk_venda_11` (`tabela_preco_id`),
  KEY `fk_venda_12` (`movimentacao_origem_id`),
  CONSTRAINT `fk_venda_1` FOREIGN KEY (`cliente_id`) REFERENCES `cliente` (`id`),
  CONSTRAINT `fk_venda_10` FOREIGN KEY (`cliente_endereco_id`) REFERENCES `cliente_endereco` (`id`),
  CONSTRAINT `fk_venda_11` FOREIGN KEY (`tabela_preco_id`) REFERENCES `tabela_preco` (`id`),
  CONSTRAINT `fk_venda_12` FOREIGN KEY (`movimentacao_origem_id`) REFERENCES `movimentacao_origem` (`id`),
  CONSTRAINT `fk_venda_2` FOREIGN KEY (`venda_situacao_id`) REFERENCES `venda_situacao` (`id`),
  CONSTRAINT `fk_venda_3` FOREIGN KEY (`dispositivos_id`) REFERENCES `dispositivos` (`id`),
  CONSTRAINT `fk_venda_4` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_venda_5` FOREIGN KEY (`filial_saida_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_venda_6` FOREIGN KEY (`venda_modalidade_id`) REFERENCES `venda_modalidade` (`id`),
  CONSTRAINT `fk_venda_7` FOREIGN KEY (`venda_tipo_pagamento_id`) REFERENCES `venda_tipo_pagamento` (`id`),
  CONSTRAINT `fk_venda_8` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`),
  CONSTRAINT `fk_venda_9` FOREIGN KEY (`orcamento_id`) REFERENCES `orcamento` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda: ~1 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_devolucao
DROP TABLE IF EXISTS `venda_devolucao`;
CREATE TABLE IF NOT EXISTS `venda_devolucao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `system_unit_id` int NOT NULL,
  `venda_id` int NOT NULL,
  `data_devolucao` date NOT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_devolucao_1` (`venda_id`),
  KEY `fk_venda_devolucao_2` (`system_unit_id`),
  CONSTRAINT `fk_venda_devolucao_1` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`),
  CONSTRAINT `fk_venda_devolucao_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_devolucao: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_devolucao_itens
DROP TABLE IF EXISTS `venda_devolucao_itens`;
CREATE TABLE IF NOT EXISTS `venda_devolucao_itens` (
  `id` int NOT NULL AUTO_INCREMENT,
  `venda_devolucao_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade` double NOT NULL,
  `valor_unitario` double DEFAULT NULL,
  `valor_total` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_devolucao_itens_1` (`venda_devolucao_id`),
  KEY `fk_venda_devolucao_itens_2` (`produto_id`),
  CONSTRAINT `fk_venda_devolucao_itens_1` FOREIGN KEY (`venda_devolucao_id`) REFERENCES `venda_devolucao` (`id`),
  CONSTRAINT `fk_venda_devolucao_itens_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_devolucao_itens: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_devolucao_troca
DROP TABLE IF EXISTS `venda_devolucao_troca`;
CREATE TABLE IF NOT EXISTS `venda_devolucao_troca` (
  `id` int NOT NULL AUTO_INCREMENT,
  `venda_devolucao_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `quantidade` double NOT NULL,
  `valor_unitario` double NOT NULL,
  `valor_total` double NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_devolucao_troca_1` (`venda_devolucao_id`),
  KEY `fk_venda_devolucao_troca_2` (`produto_id`),
  CONSTRAINT `fk_venda_devolucao_troca_1` FOREIGN KEY (`venda_devolucao_id`) REFERENCES `venda_devolucao` (`id`),
  CONSTRAINT `fk_venda_devolucao_troca_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_devolucao_troca: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_formapgto
DROP TABLE IF EXISTS `venda_formapgto`;
CREATE TABLE IF NOT EXISTS `venda_formapgto` (
  `id` int NOT NULL AUTO_INCREMENT,
  `forma_pagamento_id` int NOT NULL,
  `venda_id` int NOT NULL,
  `quantidade_parcelas` int DEFAULT NULL,
  `valor` double NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_formapgto_2` (`forma_pagamento_id`),
  KEY `fk_venda_formapgto_1` (`venda_id`),
  CONSTRAINT `fk_venda_formapgto_1` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`),
  CONSTRAINT `fk_venda_formapgto_2` FOREIGN KEY (`forma_pagamento_id`) REFERENCES `forma_pagamento` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_formapgto: ~2 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_item
DROP TABLE IF EXISTS `venda_item`;
CREATE TABLE IF NOT EXISTS `venda_item` (
  `id` int NOT NULL AUTO_INCREMENT,
  `venda_id` int NOT NULL,
  `produto_id` int NOT NULL,
  `quantidade` double NOT NULL,
  `valor_unitario` double NOT NULL,
  `valor_total` double NOT NULL,
  `valor_original` double NOT NULL,
  `valor_custo` double DEFAULT NULL,
  `desconto` double DEFAULT NULL,
  `informacoes_adicionais` text COLLATE utf8mb3_unicode_ci,
  `cancelado` int NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `numero_pedido` text COLLATE utf8mb3_unicode_ci,
  `numero_item_pedido` text COLLATE utf8mb3_unicode_ci,
  `valor_frete` double DEFAULT NULL,
  `peso_unitario` double DEFAULT NULL,
  `peso_total` double DEFAULT NULL,
  `estoque_deposito_id` int DEFAULT NULL,
  `produto_lote_id` int DEFAULT NULL,
  `quantidade_devolvida` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_item_2` (`produto_id`),
  KEY `fk_venda_item_3` (`cancelado`),
  KEY `fk_venda_item_1` (`venda_id`),
  KEY `fk_venda_item_4` (`estoque_deposito_id`),
  KEY `fk_venda_item_5` (`produto_lote_id`),
  CONSTRAINT `fk_venda_item_1` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`),
  CONSTRAINT `fk_venda_item_2` FOREIGN KEY (`produto_id`) REFERENCES `produto` (`id`),
  CONSTRAINT `fk_venda_item_3` FOREIGN KEY (`cancelado`) REFERENCES `resposta` (`id`),
  CONSTRAINT `fk_venda_item_4` FOREIGN KEY (`estoque_deposito_id`) REFERENCES `estoque_deposito` (`id`),
  CONSTRAINT `fk_venda_item_5` FOREIGN KEY (`produto_lote_id`) REFERENCES `produto_lote` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_item: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_meta
DROP TABLE IF EXISTS `venda_meta`;
CREATE TABLE IF NOT EXISTS `venda_meta` (
  `id` int NOT NULL AUTO_INCREMENT,
  `venda_meta_situacao_id` int NOT NULL,
  `system_unit_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `data_inicial` date NOT NULL,
  `data_final` date NOT NULL,
  `valor_meta_geral_prevista` double NOT NULL,
  `valor_meta_geral_realizada` double DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `data_ultimo_processamento` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_meta_1` (`venda_meta_situacao_id`),
  KEY `fk_venda_meta_2` (`system_unit_id`),
  CONSTRAINT `fk_venda_meta_1` FOREIGN KEY (`venda_meta_situacao_id`) REFERENCES `venda_meta_situacao` (`id`),
  CONSTRAINT `fk_venda_meta_2` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_meta: ~0 rows (aproximadamente)
INSERT INTO `venda_meta` (`id`, `venda_meta_situacao_id`, `system_unit_id`, `descricao`, `data_inicial`, `data_final`, `valor_meta_geral_prevista`, `valor_meta_geral_realizada`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`, `data_ultimo_processamento`) VALUES
	(1, 1, 1, 'Marco', '2024-03-01', '2024-03-31', 50000, NULL, '2024-03-30 14:41:24', NULL, NULL, 'Administrador', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.venda_meta_situacao
DROP TABLE IF EXISTS `venda_meta_situacao`;
CREATE TABLE IF NOT EXISTS `venda_meta_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_meta_situacao: ~2 rows (aproximadamente)
INSERT INTO `venda_meta_situacao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Aberta', NULL, NULL, '', 'Sistema Kraft', NULL),
	(2, 'Fechada', NULL, NULL, '', 'Sistema Kraft', NULL);

-- Copiando estrutura para tabela erp_nuvem.venda_meta_vendedor
DROP TABLE IF EXISTS `venda_meta_vendedor`;
CREATE TABLE IF NOT EXISTS `venda_meta_vendedor` (
  `id` int NOT NULL AUTO_INCREMENT,
  `venda_meta_id` int NOT NULL,
  `vendedor_id` int NOT NULL,
  `valor_meta_prevista` double DEFAULT NULL,
  `valor_meta_realizada` double DEFAULT NULL,
  `criado_em` datetime NOT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `aproveiramento_carteira_prevista` double DEFAULT NULL,
  `aproveitamento_carteira_realizada` double DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_meta_vendedor_1` (`venda_meta_id`),
  KEY `fk_venda_meta_vendedor_2` (`vendedor_id`),
  CONSTRAINT `fk_venda_meta_vendedor_1` FOREIGN KEY (`venda_meta_id`) REFERENCES `venda_meta` (`id`),
  CONSTRAINT `fk_venda_meta_vendedor_2` FOREIGN KEY (`vendedor_id`) REFERENCES `vendedor` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_meta_vendedor: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_modalidade
DROP TABLE IF EXISTS `venda_modalidade`;
CREATE TABLE IF NOT EXISTS `venda_modalidade` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_modalidade: ~2 rows (aproximadamente)
INSERT INTO `venda_modalidade` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Cliente Retira', NULL, NULL, '', '', NULL),
	(2, 'Empresa Entrega', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.venda_situacao
DROP TABLE IF EXISTS `venda_situacao`;
CREATE TABLE IF NOT EXISTS `venda_situacao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `situacaopdv_id` int DEFAULT NULL,
  `ordem` int DEFAULT NULL,
  `cor` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_situacao: ~6 rows (aproximadamente)
INSERT INTO `venda_situacao` (`id`, `descricao`, `criado_em`, `alterado_em`, `situacaopdv_id`, `ordem`, `cor`, `criado_por`, `alterado_por`) VALUES
	(1, 'Em Andamento', NULL, NULL, 1, 1, '', 'Sistema Kraft', ''),
	(2, 'Aguardando Faturamento', NULL, NULL, 2, 2, '', 'Sistema Kraft', ''),
	(3, 'Aguardando Expedição', NULL, NULL, 3, 3, '', 'Sistema Kraft', ''),
	(4, 'Finalizada', NULL, NULL, 4, 5, '', 'Sistema Kraft', ''),
	(5, 'Cancelada', NULL, NULL, 5, 6, '', 'Sistema Kraft', ''),
	(6, 'Em Processo de Entrega', NULL, NULL, NULL, 4, '', 'Sistema Kraft', '');

-- Copiando estrutura para tabela erp_nuvem.venda_situacao_historico
DROP TABLE IF EXISTS `venda_situacao_historico`;
CREATE TABLE IF NOT EXISTS `venda_situacao_historico` (
  `id` int NOT NULL AUTO_INCREMENT,
  `venda_situacao_id` int NOT NULL,
  `venda_id` int NOT NULL,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime NOT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_venda_situacao_historico_1` (`venda_situacao_id`),
  KEY `fk_venda_situacao_historico_2` (`venda_id`),
  CONSTRAINT `fk_venda_situacao_historico_1` FOREIGN KEY (`venda_situacao_id`) REFERENCES `venda_situacao` (`id`),
  CONSTRAINT `fk_venda_situacao_historico_2` FOREIGN KEY (`venda_id`) REFERENCES `venda` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_situacao_historico: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem.venda_tipo_pagamento
DROP TABLE IF EXISTS `venda_tipo_pagamento`;
CREATE TABLE IF NOT EXISTS `venda_tipo_pagamento` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.venda_tipo_pagamento: ~2 rows (aproximadamente)
INSERT INTO `venda_tipo_pagamento` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Imediato', NULL, NULL, '', '', NULL),
	(2, 'Entrega', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.vendedor
DROP TABLE IF EXISTS `vendedor`;
CREATE TABLE IF NOT EXISTS `vendedor` (
  `id` int NOT NULL AUTO_INCREMENT,
  `nome` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `cpf` text COLLATE utf8mb3_unicode_ci,
  `vendedor_tipo_comissao_id` int DEFAULT NULL,
  `vendedor_tipo_pgto_comissao_id` int DEFAULT NULL,
  `criado_em` datetime DEFAULT NULL,
  `alterado_em` datetime DEFAULT NULL,
  `percentual_comissao` double DEFAULT NULL,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `deletado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_vendedor_1` (`vendedor_tipo_comissao_id`),
  KEY `fk_vendedor_2` (`vendedor_tipo_pgto_comissao_id`),
  CONSTRAINT `fk_vendedor_1` FOREIGN KEY (`vendedor_tipo_comissao_id`) REFERENCES `vendedor_tipo_comissao` (`id`),
  CONSTRAINT `fk_vendedor_2` FOREIGN KEY (`vendedor_tipo_pgto_comissao_id`) REFERENCES `vendedor_tipo_pgto_comissao` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.vendedor: ~0 rows (aproximadamente)
INSERT INTO `vendedor` (`id`, `nome`, `cpf`, `vendedor_tipo_comissao_id`, `vendedor_tipo_pgto_comissao_id`, `criado_em`, `alterado_em`, `percentual_comissao`, `criado_por`, `alterado_por`, `deletado_em`) VALUES
	(1, 'LOJA', NULL, NULL, 1, '2024-04-01 13:52:40', NULL, NULL, 'Administrador', NULL, NULL);

-- Copiando estrutura para tabela erp_nuvem.vendedor_tipo_comissao
DROP TABLE IF EXISTS `vendedor_tipo_comissao`;
CREATE TABLE IF NOT EXISTS `vendedor_tipo_comissao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.vendedor_tipo_comissao: ~3 rows (aproximadamente)
INSERT INTO `vendedor_tipo_comissao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Padrão', NULL, NULL, '', '', NULL),
	(2, 'Por Produto', NULL, NULL, '', '', NULL),
	(3, 'Por Cliente', NULL, NULL, '', '', NULL);

-- Copiando estrutura para tabela erp_nuvem.vendedor_tipo_pgto_comissao
DROP TABLE IF EXISTS `vendedor_tipo_pgto_comissao`;
CREATE TABLE IF NOT EXISTS `vendedor_tipo_pgto_comissao` (
  `id` int NOT NULL AUTO_INCREMENT,
  `descricao` text COLLATE utf8mb3_unicode_ci NOT NULL,
  `criado_em` datetime DEFAULT NULL,
  `deletado_em` datetime DEFAULT NULL,
  `alterado_por` text COLLATE utf8mb3_unicode_ci,
  `criado_por` text COLLATE utf8mb3_unicode_ci,
  `alterado_em` datetime DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.vendedor_tipo_pgto_comissao: ~2 rows (aproximadamente)
INSERT INTO `vendedor_tipo_pgto_comissao` (`id`, `descricao`, `criado_em`, `deletado_em`, `alterado_por`, `criado_por`, `alterado_em`) VALUES
	(1, 'Faturamento', NULL, NULL, '', '', NULL),
	(2, 'Liquidez', NULL, NULL, '', '', NULL);

-- Copiando estrutura para view erp_nuvem.view_consulta_contabil_por_data
DROP VIEW IF EXISTS `view_consulta_contabil_por_data`;
-- Criando tabela temporária para evitar erros de dependência de VIEW
CREATE TABLE `view_consulta_contabil_por_data` (
	`contabil_lancamento_id` INT(10) NOT NULL,
	`data_vencimento` DATE NULL,
	`data_pagamento` DATE NULL,
	`data_lancamento` DATETIME NULL
) ENGINE=MyISAM;

-- Copiando estrutura para view erp_nuvem.view_negocio_timeline
DROP VIEW IF EXISTS `view_negocio_timeline`;
-- Criando tabela temporária para evitar erros de dependência de VIEW
CREATE TABLE `view_negocio_timeline` (
	`chave` INT(10) NOT NULL,
	`negocio_id` INT(10) NOT NULL,
	`criado_em` DATETIME NULL,
	`tipo` VARCHAR(9) NOT NULL COLLATE 'utf8mb3_general_ci'
) ENGINE=MyISAM;

-- Copiando estrutura para view erp_nuvem.vw_caixa_resumo
DROP VIEW IF EXISTS `vw_caixa_resumo`;
-- Criando tabela temporária para evitar erros de dependência de VIEW
CREATE TABLE `vw_caixa_resumo` (
	`caixa_id` INT(10) NOT NULL,
	`tipo` VARCHAR(14) NOT NULL COLLATE 'utf8mb3_general_ci',
	`valor` DOUBLE NULL
) ENGINE=MyISAM;

-- Copiando estrutura para view erp_nuvem.vw_caixa_resumo_formas
DROP VIEW IF EXISTS `vw_caixa_resumo_formas`;
-- Criando tabela temporária para evitar erros de dependência de VIEW
CREATE TABLE `vw_caixa_resumo_formas` (
	`caixa_id` INT(10) NOT NULL,
	`forma_pagamento_id` INT(10) NOT NULL,
	`nome_forma_pagamento` TEXT NOT NULL COLLATE 'utf8mb3_unicode_ci',
	`total` DOUBLE NULL
) ENGINE=MyISAM;

-- Copiando estrutura para view erp_nuvem.vw_funil_filial
DROP VIEW IF EXISTS `vw_funil_filial`;
-- Criando tabela temporária para evitar erros de dependência de VIEW
CREATE TABLE `vw_funil_filial` (
	`id` INT(10) NOT NULL,
	`descricao` TEXT NOT NULL COLLATE 'utf8mb3_unicode_ci',
	`system_unit_id` INT(10) NOT NULL
) ENGINE=MyISAM;

-- Copiando estrutura para view erp_nuvem.vw_lotes_produto
DROP VIEW IF EXISTS `vw_lotes_produto`;
-- Criando tabela temporária para evitar erros de dependência de VIEW
CREATE TABLE `vw_lotes_produto` (
	`id` INT(10) NULL,
	`produto_id` INT(10) NULL,
	`numero` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`validade` DATE NULL,
	`Quantidade` DOUBLE NULL,
	`Reservado` DOUBLE NULL
) ENGINE=MyISAM;

-- Copiando estrutura para view erp_nuvem.vw_produto_estoque
DROP VIEW IF EXISTS `vw_produto_estoque`;
-- Criando tabela temporária para evitar erros de dependência de VIEW
CREATE TABLE `vw_produto_estoque` (
	`id` INT(10) NOT NULL,
	`nome` TEXT NOT NULL COLLATE 'utf8mb3_unicode_ci',
	`referencia` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`SKU` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`obs` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`margem` DOUBLE NULL,
	`valor_custo` DOUBLE NULL,
	`preco_venda` DOUBLE NULL,
	`peso_liquido` DOUBLE NULL,
	`preso_bruto` DOUBLE NULL,
	`grupo` TEXT NOT NULL COLLATE 'utf8mb3_unicode_ci',
	`subgrupo` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`sigla` TEXT NOT NULL COLLATE 'utf8mb3_unicode_ci',
	`imagem` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`ean` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`ncm` TEXT NULL COLLATE 'utf8mb3_unicode_ci',
	`system_unit_id` INT(10) NULL,
	`produto_filial_id` INT(10) NULL,
	`estoque_minimo` DOUBLE NULL,
	`estoque_maximo` DOUBLE NULL,
	`Quantidade_Disponivel` DOUBLE NULL,
	`Quantidade_Reservada` DOUBLE NULL,
	`deposito` TEXT NULL COLLATE 'utf8mb3_unicode_ci'
) ENGINE=MyISAM;

-- Copiando estrutura para tabela erp_nuvem.xml_contador
DROP TABLE IF EXISTS `xml_contador`;
CREATE TABLE IF NOT EXISTS `xml_contador` (
  `id` int NOT NULL AUTO_INCREMENT,
  `data_inicio` date DEFAULT NULL,
  `data_fim` date DEFAULT NULL,
  `system_user_id` int DEFAULT NULL,
  `system_unit_id` int DEFAULT NULL,
  `data_solicitacao` datetime DEFAULT NULL,
  `caminho_download` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `updated_at` datetime DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `info_registros` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `data_click` datetime DEFAULT NULL,
  `status_id` int DEFAULT '0',
  `situacao` int DEFAULT '1',
  `caminho_pdf` varchar(255) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  `contador` int DEFAULT '0',
  `contador_email` int DEFAULT '0',
  `downloads` int DEFAULT '0',
  `rota` text COLLATE utf8mb3_unicode_ci,
  `chave` varchar(20) COLLATE utf8mb3_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_xml_contador_1` (`system_unit_id`),
  KEY `fk_xml_contador_2` (`system_user_id`),
  CONSTRAINT `fk_xml_contador_1` FOREIGN KEY (`system_unit_id`) REFERENCES `system_unit` (`id`),
  CONSTRAINT `fk_xml_contador_2` FOREIGN KEY (`system_user_id`) REFERENCES `system_users` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COLLATE=utf8mb3_unicode_ci;

-- Copiando dados para a tabela erp_nuvem.xml_contador: ~0 rows (aproximadamente)

-- Copiando estrutura para view erp_nuvem.view_consulta_contabil_por_data
DROP VIEW IF EXISTS `view_consulta_contabil_por_data`;
-- Removendo tabela temporária e criando a estrutura VIEW final
DROP TABLE IF EXISTS `view_consulta_contabil_por_data`;
CREATE ALGORITHM=UNDEFINED SQL SECURITY DEFINER VIEW `erp_nuvem`.`view_consulta_contabil_por_data` AS select `cl`.`id` AS `contabil_lancamento_id`,`p`.`data_vencimento` AS `data_vencimento`,`p`.`data_pagamento` AS `data_pagamento`,`p`.`criado_em` AS `data_lancamento` from ((`erp_nuvem`.`contaspag` `p` join `erp_nuvem`.`contaspag_contabil` `cc`) join `erp_nuvem`.`contabil_lancamentos` `cl`) where ((`p`.`id` = `cc`.`contaspag_id`) and (`cl`.`contaspag_contabil_id` = `cc`.`id`) and (`p`.`deletado_em` is null) and (`cc`.`deletado_em` is null) and (`cl`.`deletado_em` is null)) union all select `cl`.`id` AS `contabil_lancamento_id`,`p`.`data_vencimento` AS `data_vencimento`,`p`.`data_pagamento` AS `data_pagamento`,`p`.`criado_em` AS `data_lancamento` from (`erp_nuvem`.`contasrec` `p` join `erp_nuvem`.`contabil_lancamentos` `cl`) where ((`cl`.`contasrec_id` = `p`.`id`) and (`p`.`deletado_em` is null) and (`cl`.`deletado_em` is null)) union all select `cl`.`id` AS `contabil_lancamento_id`,`p`.`data_lancamento` AS `data_vencimento`,`p`.`data_lancamento` AS `data_pagamento`,`p`.`data_lancamento` AS `data_lancamento` from (`erp_nuvem`.`conta_corrente_lancamentos` `p` join `erp_nuvem`.`contabil_lancamentos` `cl`) where ((`cl`.`conta_corrente_lancamentos_id` = `p`.`id`) and (`p`.`deletado_em` is null) and (`cl`.`deletado_em` is null));

-- Copiando estrutura para view erp_nuvem.view_negocio_timeline
DROP VIEW IF EXISTS `view_negocio_timeline`;
-- Removendo tabela temporária e criando a estrutura VIEW final
DROP TABLE IF EXISTS `view_negocio_timeline`;
CREATE ALGORITHM=UNDEFINED SQL SECURITY DEFINER VIEW `erp_nuvem`.`view_negocio_timeline` AS select `erp_nuvem`.`negocio_notas`.`id` AS `chave`,`erp_nuvem`.`negocio_notas`.`negocio_id` AS `negocio_id`,`erp_nuvem`.`negocio_notas`.`criado_em` AS `criado_em`,'nota' AS `tipo` from `erp_nuvem`.`negocio_notas` union all select `erp_nuvem`.`negocio_arquivos`.`id` AS `chave`,`erp_nuvem`.`negocio_arquivos`.`negocio_id` AS `negocio_id`,`erp_nuvem`.`negocio_arquivos`.`criado_em` AS `criado_em`,'arquivo' AS `tipo` from `erp_nuvem`.`negocio_arquivos` union all select `erp_nuvem`.`negocio_atividade`.`id` AS `chave`,`erp_nuvem`.`negocio_atividade`.`negocio_id` AS `negocio_id`,`erp_nuvem`.`negocio_atividade`.`criado_em` AS `criado_em`,'atividade' AS `tipo` from `erp_nuvem`.`negocio_atividade` union all select `erp_nuvem`.`negocio_itens`.`id` AS `chave`,`erp_nuvem`.`negocio_itens`.`negocio_id` AS `negocio_id`,`erp_nuvem`.`negocio_itens`.`criado_em` AS `criado_em`,'produto' AS `tipo` from `erp_nuvem`.`negocio_itens` union all select `erp_nuvem`.`negocio_etapas_historico`.`id` AS `chave`,`erp_nuvem`.`negocio_etapas_historico`.`negocio_id` AS `negocio_id`,`erp_nuvem`.`negocio_etapas_historico`.`criado_em` AS `criado_em`,'etapa' AS `tipo` from `erp_nuvem`.`negocio_etapas_historico`;

-- Copiando estrutura para view erp_nuvem.vw_caixa_resumo
DROP VIEW IF EXISTS `vw_caixa_resumo`;
-- Removendo tabela temporária e criando a estrutura VIEW final
DROP TABLE IF EXISTS `vw_caixa_resumo`;
CREATE ALGORITHM=UNDEFINED SQL SECURITY DEFINER VIEW `erp_nuvem`.`vw_caixa_resumo` AS select `c`.`caixa_id` AS `caixa_id`,'Fundo de Caixa' AS `tipo`,sum(`c`.`valor`) AS `valor` from `erp_nuvem`.`caixa_lancamentos` `c` where (`c`.`caixa_tipo_lancamento_id` = 3) group by `c`.`caixa_id` union all select `c`.`caixa_id` AS `caixa_id`,'Entradas' AS `tipo`,coalesce(sum(`c`.`valor`),0) AS `valor` from `erp_nuvem`.`caixa_lancamentos` `c` where (`c`.`caixa_tipo_lancamento_id` = 2) group by `c`.`caixa_id` union all select `c`.`caixa_id` AS `caixa_id`,'Saidas' AS `tipo`,sum(`c`.`valor`) AS `valor` from `erp_nuvem`.`caixa_lancamentos` `c` where (`c`.`caixa_tipo_lancamento_id` = 1) group by `c`.`caixa_id` union all select `c`.`caixa_id` AS `caixa_id`,'Saldo' AS `tipo`,sum((case when (`c`.`caixa_tipo_lancamento_id` = 1) then (`c`.`valor` * -(1)) else `c`.`valor` end)) AS `valor` from `erp_nuvem`.`caixa_lancamentos` `c` group by `c`.`caixa_id`;

-- Copiando estrutura para view erp_nuvem.vw_caixa_resumo_formas
DROP VIEW IF EXISTS `vw_caixa_resumo_formas`;
-- Removendo tabela temporária e criando a estrutura VIEW final
DROP TABLE IF EXISTS `vw_caixa_resumo_formas`;
CREATE ALGORITHM=UNDEFINED SQL SECURITY DEFINER VIEW `erp_nuvem`.`vw_caixa_resumo_formas` AS select `c`.`caixa_id` AS `caixa_id`,`c`.`forma_pagamento_id` AS `forma_pagamento_id`,`f`.`descricao` AS `nome_forma_pagamento`,sum((case when (`c`.`caixa_tipo_lancamento_id` = 1) then (`c`.`valor` * -(1)) else `c`.`valor` end)) AS `total` from (`erp_nuvem`.`caixa_lancamentos` `c` join `erp_nuvem`.`forma_pagamento` `f`) where (`f`.`id` = `c`.`forma_pagamento_id`) group by `c`.`caixa_id`,`c`.`forma_pagamento_id`;

-- Copiando estrutura para view erp_nuvem.vw_funil_filial
DROP VIEW IF EXISTS `vw_funil_filial`;
-- Removendo tabela temporária e criando a estrutura VIEW final
DROP TABLE IF EXISTS `vw_funil_filial`;
CREATE ALGORITHM=UNDEFINED SQL SECURITY DEFINER VIEW `erp_nuvem`.`vw_funil_filial` AS select distinct `f`.`id` AS `id`,`f`.`descricao` AS `descricao`,`n`.`system_unit_id` AS `system_unit_id` from ((`erp_nuvem`.`funil` `f` join `erp_nuvem`.`funil_etapas` `fe` on((`fe`.`funil_id` = `f`.`id`))) join `erp_nuvem`.`negocio` `n` on((`n`.`funil_etapas_id` = `fe`.`id`)));

-- Copiando estrutura para view erp_nuvem.vw_lotes_produto
DROP VIEW IF EXISTS `vw_lotes_produto`;
-- Removendo tabela temporária e criando a estrutura VIEW final
DROP TABLE IF EXISTS `vw_lotes_produto`;
CREATE ALGORITHM=UNDEFINED SQL SECURITY DEFINER VIEW `erp_nuvem`.`vw_lotes_produto` AS select `l`.`id` AS `id`,`l`.`produto_id` AS `produto_id`,`l`.`numero` AS `numero`,`l`.`validade` AS `validade`,sum(`e`.`quant_disponivel`) AS `Quantidade`,sum(`e`.`quant_reservada`) AS `Reservado` from (`erp_nuvem`.`produto_lote` `l` left join `erp_nuvem`.`estoque_saldos` `e` on((`e`.`produto_lote_id` = `l`.`id`)));

-- Copiando estrutura para view erp_nuvem.vw_produto_estoque
DROP VIEW IF EXISTS `vw_produto_estoque`;
-- Removendo tabela temporária e criando a estrutura VIEW final
DROP TABLE IF EXISTS `vw_produto_estoque`;
CREATE ALGORITHM=UNDEFINED SQL SECURITY DEFINER VIEW `erp_nuvem`.`vw_produto_estoque` AS select `p`.`id` AS `id`,`p`.`nome` AS `nome`,`p`.`referencia` AS `referencia`,`p`.`codigo_sku` AS `SKU`,`p`.`obs` AS `obs`,`f`.`margem` AS `margem`,`f`.`valor_custo` AS `valor_custo`,`f`.`preco_venda` AS `preco_venda`,`p`.`peso_liquido` AS `peso_liquido`,`p`.`peso_bruto` AS `preso_bruto`,`g`.`descricao` AS `grupo`,`sg`.`descricao` AS `subgrupo`,`u`.`sigla` AS `sigla`,`p`.`imagem` AS `imagem`,`p`.`codigo_EAN` AS `ean`,`p`.`ncm` AS `ncm`,`f`.`system_unit_id` AS `system_unit_id`,`f`.`id` AS `produto_filial_id`,`f`.`estoque_minimo` AS `estoque_minimo`,`f`.`estoque_maximo` AS `estoque_maximo`,`e`.`quant_disponivel` AS `Quantidade_Disponivel`,`e`.`quant_reservada` AS `Quantidade_Reservada`,`d`.`descricao` AS `deposito` from ((((((`erp_nuvem`.`produto` `p` join `erp_nuvem`.`unidade_medida` `u` on((`p`.`unidade_medida_id` = `u`.`id`))) join `erp_nuvem`.`produto_grupo` `g` on((`p`.`produto_grupo_id` = `g`.`id`))) left join `erp_nuvem`.`produtogrupo_subgrupo` `sg` on((`g`.`id` = `sg`.`produto_grupo_id`))) left join `erp_nuvem`.`produto_filial` `f` on((`f`.`produto_id` = `p`.`id`))) left join `erp_nuvem`.`estoque_saldos` `e` on((`e`.`produto_id` = `p`.`id`))) left join `erp_nuvem`.`estoque_deposito` `d` on((`e`.`estoque_deposito_id` = `d`.`id`))) group by `p`.`id`,`p`.`nome`;

/*!40103 SET TIME_ZONE=IFNULL(@OLD_TIME_ZONE, 'system') */;
/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
