-- --------------------------------------------------------
-- Servidor:                     127.0.0.1
-- Versão do servidor:           8.0.30 - MySQL Community Server - GPL
-- OS do Servidor:               Win64
-- HeidiSQL Versão:              12.1.0.6537
-- --------------------------------------------------------

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET NAMES utf8 */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


-- Copiando estrutura do banco de dados para erp_nuvem_log
DROP DATABASE IF EXISTS `erp_nuvem_log`;
CREATE DATABASE IF NOT EXISTS `erp_nuvem_log` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;
USE `erp_nuvem_log`;

-- Copiando estrutura para tabela erp_nuvem_log.system_access_log
DROP TABLE IF EXISTS `system_access_log`;
CREATE TABLE IF NOT EXISTS `system_access_log` (
  `id` int NOT NULL,
  `sessionid` text,
  `login` text,
  `login_time` datetime DEFAULT NULL,
  `login_year` varchar(4) DEFAULT NULL,
  `login_month` varchar(2) DEFAULT NULL,
  `login_day` varchar(2) DEFAULT NULL,
  `logout_time` datetime DEFAULT NULL,
  `impersonated` char(1) DEFAULT NULL,
  `access_ip` varchar(45) DEFAULT NULL,
  `impersonated_by` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

-- Copiando dados para a tabela erp_nuvem_log.system_access_log: ~1 rows (aproximadamente)
INSERT INTO `system_access_log` (`id`, `sessionid`, `login`, `login_time`, `login_year`, `login_month`, `login_day`, `logout_time`, `impersonated`, `access_ip`, `impersonated_by`) VALUES
	(1, 'bmr7hnb051fgsdjk46m621tlpm', 'admin', '2024-03-30 10:21:01', '2024', '03', '30', NULL, 'N', '127.0.0.1', NULL),
	(2, 'umas14pat3lib5roqevptplopl', 'admin', '2024-04-01 13:50:43', '2024', '04', '01', NULL, 'N', '127.0.0.1', NULL),
	(3, 'b8bk7b59fljc860mtvr5cb2ee3', 'admin', '2024-04-19 15:28:22', '2024', '04', '19', NULL, 'N', '127.0.0.1', NULL),
	(4, 'nn3ubr66bae04jm80oasdeh9ns', 'admin', '2024-05-30 18:36:42', '2024', '05', '30', NULL, 'N', '127.0.0.1', NULL),
	(5, 'uiii886mjue4h5d4cnlh7hhugu', 'admin', '2024-06-04 12:14:09', '2024', '06', '04', NULL, 'N', '127.0.0.1', NULL),
	(6, 'tg61ol9faabbai3f96evjkn37u', 'admin', '2024-06-06 10:44:54', '2024', '06', '06', NULL, 'N', '127.0.0.1', NULL),
	(7, 'lll8hh6e4vbqnntar9ghtfhso2', 'admin', '2024-06-22 20:46:52', '2024', '06', '22', NULL, 'N', '127.0.0.1', NULL),
	(8, 'm3tshokm0mirsecobhiouvae8l', 'admin', '2024-07-09 22:12:06', '2024', '07', '09', NULL, 'N', '127.0.0.1', NULL),
	(9, 'e1ajobajboca0f7asl2ev2n7k6', 'admin', '2024-07-19 16:06:33', '2024', '07', '19', NULL, 'N', '127.0.0.1', NULL),
	(10, 'esc9k2gnugptiajh2nc8k4gdhn', 'admin', '2024-07-28 09:45:26', '2024', '07', '28', NULL, 'N', '127.0.0.1', NULL),
	(11, '34t9q80ekelhn5c4vnho4t6ld1', 'admin', '2024-07-30 14:22:17', '2024', '07', '30', NULL, 'N', '127.0.0.1', NULL),
	(12, 'pqm93ipute4dubcpqvso13vqpv', 'admin', '2024-08-07 21:06:29', '2024', '08', '07', NULL, 'N', '127.0.0.1', NULL),
	(13, 'vovv3erb82ggs1uaijruf0l7f6', 'admin', '2024-10-02 22:42:32', '2024', '10', '02', NULL, 'N', '127.0.0.1', NULL),
	(14, 'o7l8kkq57hokeb2sfe6drg2gat', 'admin', '2025-03-12 11:13:41', '2025', '03', '12', NULL, 'N', '127.0.0.1', NULL);

-- Copiando estrutura para tabela erp_nuvem_log.system_access_notification_log
DROP TABLE IF EXISTS `system_access_notification_log`;
CREATE TABLE IF NOT EXISTS `system_access_notification_log` (
  `id` int NOT NULL,
  `login` text,
  `email` text,
  `ip_address` text,
  `login_time` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

-- Copiando dados para a tabela erp_nuvem_log.system_access_notification_log: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem_log.system_change_log
DROP TABLE IF EXISTS `system_change_log`;
CREATE TABLE IF NOT EXISTS `system_change_log` (
  `id` int NOT NULL,
  `logdate` timestamp NULL DEFAULT NULL,
  `login` text,
  `tablename` text,
  `primarykey` text,
  `pkvalue` text,
  `operation` text,
  `columnname` text,
  `oldvalue` text,
  `newvalue` text,
  `access_ip` text,
  `transaction_id` text,
  `log_trace` text,
  `session_id` text,
  `class_name` text,
  `php_sapi` text,
  `log_year` varchar(4) DEFAULT NULL,
  `log_month` varchar(2) DEFAULT NULL,
  `log_day` varchar(2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

-- Copiando dados para a tabela erp_nuvem_log.system_change_log: ~141 rows (aproximadamente)
INSERT INTO `system_change_log` (`id`, `logdate`, `login`, `tablename`, `primarykey`, `pkvalue`, `operation`, `columnname`, `oldvalue`, `newvalue`, `access_ip`, `transaction_id`, `log_trace`, `session_id`, `class_name`, `php_sapi`, `log_year`, `log_month`, `log_day`) VALUES
	(1, '2024-03-30 13:39:49', 'admin', 'produto_grupo', 'id', '1', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6608162520ed2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(ProdutoGrupo), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): ProdutoGrupo->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(331): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoGrupoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '2024', '03', '30'),
	(2, '2024-03-30 13:39:49', 'admin', 'produto_grupo', 'id', '1', 'created', 'descricao', NULL, 'GERAL', '127.0.0.1', '6608162520ed2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(ProdutoGrupo), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): ProdutoGrupo->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(331): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoGrupoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '2024', '03', '30'),
	(3, '2024-03-30 13:39:49', 'admin', 'produto_grupo', 'id', '1', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6608162520ed2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(ProdutoGrupo), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): ProdutoGrupo->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(331): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoGrupoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '2024', '03', '30'),
	(4, '2024-03-30 13:39:49', 'admin', 'produto_grupo', 'id', '1', 'created', 'id', NULL, '1', '127.0.0.1', '6608162520ed2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(ProdutoGrupo), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): ProdutoGrupo->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(331): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoGrupoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '2024', '03', '30'),
	(5, '2024-03-30 13:39:59', 'admin', 'produto_grupo', 'id', '1', 'created', 'alterado_por', NULL, 'Administrador', '127.0.0.1', '6608162ee1786', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(ProdutoGrupo), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): ProdutoGrupo->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(331): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoGrupoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '2024', '03', '30'),
	(6, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(7, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'referencia', NULL, '12454655', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(8, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'nome', NULL, 'TESTE', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(9, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(10, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'produtogrupo_subgrupo_id', NULL, '1', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(11, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(12, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(13, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(14, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(15, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(16, '2024-03-30 13:41:03', 'admin', 'produto', 'id', '1', 'created', 'id', NULL, '1', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(17, '2024-03-30 13:41:32', 'admin', 'produto', 'id', '1', 'created', 'alterado_por', NULL, 'Administrador', '127.0.0.1', '6608168cabb57', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '30'),
	(18, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'system_unit_id', NULL, '1', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(19, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'cliente_classificacao_id', NULL, '1', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(20, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'nome', NULL, 'Fernando Ferreira Gomes Nascimento', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(21, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'pessoa_tipo_id', NULL, '1', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(22, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'cpf_cnpj', NULL, '96947055172', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(23, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'cliente_exterior', NULL, 'N', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(24, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'email', NULL, 'fpasqueto@gmail.com', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(25, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'notafiscal_indiedest_id', NULL, '3', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(26, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(27, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'utilizar_endereco_cobranca', NULL, '2', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(28, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'cliente_situacao_id', NULL, '1', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(29, '2024-03-30 13:53:09', 'admin', 'cliente', 'id', '1', 'created', 'id', NULL, '1', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '2024', '03', '30'),
	(30, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(31, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(32, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(33, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(34, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'nome', NULL, 'BATERIA 150 AMPERES MOURA', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(35, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'ncm', NULL, '85071090', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(36, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(37, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(38, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(39, '2024-03-30 18:00:47', 'admin', 'produto', 'id', '2', 'created', 'id', NULL, '2', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(40, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(41, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(42, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(43, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(44, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'nome', NULL, 'BATERIA 150 AMPERES MOURA', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(45, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'ncm', NULL, '85071090', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(46, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(47, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(48, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(49, '2024-03-30 18:01:11', 'admin', 'produto', 'id', '3', 'created', 'id', NULL, '3', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(50, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(51, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(52, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(53, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(54, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'nome', NULL, 'BATERIA 150 AMPERES MOURA', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(55, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'ncm', NULL, '85071090', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(56, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(57, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(58, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(59, '2024-03-30 23:00:48', 'admin', 'produto', 'id', '4', 'created', 'id', NULL, '4', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(60, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(61, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(62, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(63, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(64, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'nome', NULL, 'BATERIA 150 AMPERES MOURA', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(65, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'ncm', NULL, '85071090', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(66, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(67, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(68, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(69, '2024-03-31 00:47:48', 'admin', 'produto', 'id', '5', 'created', 'id', NULL, '5', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '03', '30'),
	(70, '2024-03-31 02:17:25', 'admin', 'forma_pagamento', 'id', '1', 'created', 'codigo_interno', NULL, '1', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '30'),
	(71, '2024-03-31 02:17:25', 'admin', 'forma_pagamento', 'id', '1', 'created', 'tipo_documento_id', NULL, '4', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '30'),
	(72, '2024-03-31 02:17:25', 'admin', 'forma_pagamento', 'id', '1', 'created', 'descricao', NULL, 'DINHEIRO', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '30'),
	(73, '2024-03-31 02:17:25', 'admin', 'forma_pagamento', 'id', '1', 'created', 'notafiscal_tpag_id', NULL, '1', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '30'),
	(74, '2024-03-31 02:17:25', 'admin', 'forma_pagamento', 'id', '1', 'created', 'utiliza_pdv', NULL, 'S', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '30'),
	(75, '2024-03-31 02:17:25', 'admin', 'forma_pagamento', 'id', '1', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '30'),
	(76, '2024-03-31 02:17:25', 'admin', 'forma_pagamento', 'id', '1', 'created', 'id', NULL, '1', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '30'),
	(77, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'codigo_interno', NULL, '2', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(78, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'tipo_documento_id', NULL, '4', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(79, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'descricao', NULL, 'BOLETO', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(80, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'notafiscal_tpag_id', NULL, '10', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(81, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'prazo_pagamento', NULL, '30', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(82, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'utiliza_pdv', NULL, 'S', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(83, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'obriga_nf_pdv', NULL, 'N', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(84, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(85, '2024-03-31 12:36:54', 'admin', 'forma_pagamento', 'id', '2', 'created', 'id', NULL, '2', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(FormaPagamento), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): FormaPagamento->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '2024', '03', '31'),
	(86, '2024-03-31 12:57:12', 'admin', 'produto', 'id', '5', 'created', 'alterado_por', NULL, 'Administrador', '127.0.0.1', '66095da89fd10', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '2024', '03', '31'),
	(87, '2024-04-01 16:52:41', 'admin', 'vendedor', 'id', '1', 'created', 'nome', NULL, 'LOJA', '127.0.0.1', '660ae658ca258', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Vendedor), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Vendedor->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cadastros_diversos\\VendedorForm.php(126): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendedorForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'VendedorForm', 'apache2handler', '2024', '04', '01'),
	(88, '2024-04-01 16:52:41', 'admin', 'vendedor', 'id', '1', 'created', 'vendedor_tipo_pgto_comissao_id', NULL, '1', '127.0.0.1', '660ae658ca258', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Vendedor), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Vendedor->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cadastros_diversos\\VendedorForm.php(126): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendedorForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'VendedorForm', 'apache2handler', '2024', '04', '01'),
	(89, '2024-04-01 16:52:41', 'admin', 'vendedor', 'id', '1', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '660ae658ca258', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Vendedor), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Vendedor->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cadastros_diversos\\VendedorForm.php(126): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendedorForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'VendedorForm', 'apache2handler', '2024', '04', '01'),
	(90, '2024-04-01 16:52:41', 'admin', 'vendedor', 'id', '1', 'created', 'id', NULL, '1', '127.0.0.1', '660ae658ca258', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Vendedor), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Vendedor->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cadastros_diversos\\VendedorForm.php(126): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendedorForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'VendedorForm', 'apache2handler', '2024', '04', '01'),
	(91, '2024-04-03 23:53:10', 'admin', 'caixa', 'id', '1', 'created', 'system_users_abertura_id', NULL, '1', '127.0.0.1', '660debe6cf32c', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Caixa), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Caixa->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\AberturaCaixaForm.php(108): Adianti\\Database\\TRecord->store()\n#3 [internal function]: AberturaCaixaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'AberturaCaixaForm', 'apache2handler', '2024', '04', '03'),
	(92, '2024-04-03 23:53:10', 'admin', 'caixa', 'id', '1', 'created', 'data_hora_abertura', NULL, '2024-04-03 20:53:10', '127.0.0.1', '660debe6cf32c', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Caixa), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Caixa->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\AberturaCaixaForm.php(108): Adianti\\Database\\TRecord->store()\n#3 [internal function]: AberturaCaixaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'AberturaCaixaForm', 'apache2handler', '2024', '04', '03'),
	(93, '2024-04-03 23:53:10', 'admin', 'caixa', 'id', '1', 'created', 'system_users_operador_id', NULL, '1', '127.0.0.1', '660debe6cf32c', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Caixa), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Caixa->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\AberturaCaixaForm.php(108): Adianti\\Database\\TRecord->store()\n#3 [internal function]: AberturaCaixaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'AberturaCaixaForm', 'apache2handler', '2024', '04', '03'),
	(94, '2024-04-03 23:53:10', 'admin', 'caixa', 'id', '1', 'created', 'caixa_situacao_id', NULL, '1', '127.0.0.1', '660debe6cf32c', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Caixa), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Caixa->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\AberturaCaixaForm.php(108): Adianti\\Database\\TRecord->store()\n#3 [internal function]: AberturaCaixaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'AberturaCaixaForm', 'apache2handler', '2024', '04', '03'),
	(95, '2024-04-03 23:53:10', 'admin', 'caixa', 'id', '1', 'created', 'system_unit_id', NULL, '1', '127.0.0.1', '660debe6cf32c', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Caixa), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Caixa->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\AberturaCaixaForm.php(108): Adianti\\Database\\TRecord->store()\n#3 [internal function]: AberturaCaixaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'AberturaCaixaForm', 'apache2handler', '2024', '04', '03'),
	(96, '2024-04-03 23:53:10', 'admin', 'caixa', 'id', '1', 'created', 'id', NULL, '1', '127.0.0.1', '660debe6cf32c', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Caixa), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Caixa->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\AberturaCaixaForm.php(108): Adianti\\Database\\TRecord->store()\n#3 [internal function]: AberturaCaixaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'AberturaCaixaForm', 'apache2handler', '2024', '04', '03'),
	(97, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(98, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(99, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(100, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(101, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'nome', NULL, 'RACAO GATOS BAW WAW MIX 900G PT', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(102, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'ncm', NULL, '23099010', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(103, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(104, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(105, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(106, '2024-04-19 18:36:19', 'admin', 'produto', 'id', '6', 'created', 'id', NULL, '6', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(107, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(108, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(109, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(110, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(111, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'nome', NULL, 'TOMATE ITALIANO ANDREA KG', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(112, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'ncm', NULL, '07020000', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(113, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'unidade_medida_id', NULL, '26', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(114, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(115, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(116, '2024-04-19 18:36:32', 'admin', 'produto', 'id', '7', 'created', 'id', NULL, '7', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(117, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(118, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(119, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(120, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(121, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'nome', NULL, 'OLEO SOJA ABC 900ML FR', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(122, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'ncm', NULL, '15079011', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(123, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(124, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(125, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(126, '2024-04-19 18:37:04', 'admin', 'produto', 'id', '8', 'created', 'id', NULL, '8', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(127, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(128, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(129, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(130, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(131, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'nome', NULL, 'ALHO FRITO ALHO ROXO 400G PT', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(132, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'ncm', NULL, '20059900', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(133, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(134, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(135, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(136, '2024-04-19 18:45:48', 'admin', 'produto', 'id', '9', 'created', 'id', NULL, '9', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(137, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(138, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(139, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'produto_tipo_id', NULL, '1', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(140, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(141, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'nome', NULL, 'BROCOLIS NINJA NECTAR VITA 200G BJ', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(142, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'ncm', NULL, '07041000', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(143, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'unidade_medida_id', NULL, '49', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(144, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(145, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(146, '2024-04-19 18:46:15', 'admin', 'produto', 'id', '10', 'created', 'id', NULL, '10', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '2024', '04', '19'),
	(147, '2024-05-30 21:42:31', 'admin', 'cliente', 'id', '1', 'deleted', 'cliente_situacao_id', '1', NULL, '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '2024', '05', '30'),
	(148, '2024-05-30 21:42:31', 'admin', 'cliente', 'id', '1', 'created', 'rg', NULL, '96947055172', '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '2024', '05', '30'),
	(149, '2024-05-30 21:42:31', 'admin', 'cliente', 'id', '1', 'created', 'insc_municipal', NULL, '96947055172', '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '2024', '05', '30'),
	(150, '2024-05-30 21:42:31', 'admin', 'cliente', 'id', '1', 'created', 'insc_estadual', NULL, '96947055172', '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '2024', '05', '30'),
	(151, '2024-05-30 21:42:31', 'admin', 'cliente', 'id', '1', 'created', 'alterado_por', NULL, 'Administrador', '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Cliente), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Cliente->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '2024', '05', '30'),
	(152, '2024-06-04 04:14:31', 'admin', 'produto', 'id', '6', 'created', 'alterado_por', NULL, 'Administrador', '127.0.0.1', '665e94a77d92c', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(153, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'created', 'imagem', NULL, '%7B%22newFile%22%3A%22tmp%2Ftravas_john.jpg%22%2C%22fileName%22%3A%22tmp%2Ftravas_john.jpg%22%7D', '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(154, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'produto_grupo_id', '1', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(155, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'unidade_medida_id', '49', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(156, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'tipo_recurso_id', '1', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(157, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'notafiscal_item_orig_id', '1', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(158, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'nome', 'RACAO GATOS BAW WAW MIX 900G PT', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(159, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'ncm', '23099010', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(160, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'criado_por', 'Administrador', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(161, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'alterado_por', 'Administrador', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(162, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'habilitado_id', '1', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(163, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'deleted', 'produto_tipo_id', '1', NULL, '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(164, '2024-06-04 04:16:23', 'admin', 'produto', 'id', '6', 'changed', 'imagem', '%7B%22newFile%22%3A%22tmp%2Ftravas_john.jpg%22%2C%22fileName%22%3A%22tmp%2Ftravas_john.jpg%22%7D', 'app/files/kraft_arquivos/produtos/6/travas_john.jpg', '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '2024', '06', '04'),
	(165, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'tipo_recurso_id', NULL, '1', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(166, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'nome', NULL, 'ETIQUETA 120X120', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(167, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'produto_grupo_id', NULL, '1', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(168, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'unidade_medida_id', NULL, '7', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(169, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'produto_tipo_id', NULL, '2', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(170, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'habilitado_id', NULL, '1', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(171, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'criado_por', NULL, 'Administrador', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(172, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'notafiscal_item_orig_id', NULL, '1', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06'),
	(173, '2024-06-06 13:55:07', 'admin', 'produto', 'id', '11', 'created', 'id', NULL, '11', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\app\\model\\log\\SystemChangeLogTrait.php(48): SystemChangeLogService::register(Object(Produto), Array, Array)\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(904): Produto->onAfterStore(Object(stdClass))\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '2024', '06', '06');

-- Copiando estrutura para tabela erp_nuvem_log.system_request_log
DROP TABLE IF EXISTS `system_request_log`;
CREATE TABLE IF NOT EXISTS `system_request_log` (
  `id` int NOT NULL,
  `endpoint` text,
  `logdate` text,
  `log_year` varchar(4) DEFAULT NULL,
  `log_month` varchar(2) DEFAULT NULL,
  `log_day` varchar(2) DEFAULT NULL,
  `session_id` text,
  `login` text,
  `access_ip` text,
  `class_name` text,
  `http_host` text,
  `server_port` text,
  `request_uri` text,
  `request_method` text,
  `query_string` text,
  `request_headers` text,
  `request_body` longtext,
  `request_duration` int DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

-- Copiando dados para a tabela erp_nuvem_log.system_request_log: ~0 rows (aproximadamente)

-- Copiando estrutura para tabela erp_nuvem_log.system_sql_log
DROP TABLE IF EXISTS `system_sql_log`;
CREATE TABLE IF NOT EXISTS `system_sql_log` (
  `id` int NOT NULL,
  `logdate` timestamp NULL DEFAULT NULL,
  `login` text,
  `database_name` text,
  `sql_command` longtext,
  `statement_type` text,
  `access_ip` varchar(45) DEFAULT NULL,
  `transaction_id` text,
  `log_trace` text,
  `session_id` text,
  `class_name` text,
  `php_sapi` text,
  `request_id` text,
  `log_year` varchar(4) DEFAULT NULL,
  `log_month` varchar(2) DEFAULT NULL,
  `log_day` varchar(2) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

-- Copiando dados para a tabela erp_nuvem_log.system_sql_log: ~347 rows (aproximadamente)
INSERT INTO `system_sql_log` (`id`, `logdate`, `login`, `database_name`, `sql_command`, `statement_type`, `access_ip`, `transaction_id`, `log_trace`, `session_id`, `class_name`, `php_sapi`, `request_id`, `log_year`, `log_month`, `log_day`) VALUES
	(1, '2024-03-30 13:39:49', 'admin', 'kraftsoft', 'INSERT INTO produto_grupo (tipo_recurso_id, descricao, imagem, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'1\', \'GERAL\', NULL, \'2024-03-30 10:39:49\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '6608162520ed2', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(331): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoGrupoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '66081625068c9', '2024', '03', '30'),
	(2, '2024-03-30 13:39:49', 'admin', 'kraftsoft', 'DELETE FROM produtogrupo_subgrupo WHERE (produto_grupo_id = \'1\')', 'DELETE', '127.0.0.1', '6608162520ed2', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(347): ProdutoGrupoForm->storeMasterDetailItems(\'ProdutogrupoSub...\', \'produto_grupo_i...\', \'produtogrupo_su...\', Object(ProdutoGrupo), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoGrupoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '66081625068c9', '2024', '03', '30'),
	(3, '2024-03-30 13:39:59', 'admin', 'kraftsoft', 'UPDATE produto_grupo SET tipo_recurso_id = \'1\', descricao = \'GERAL\', imagem = NULL, criado_por = \'Administrador\', alterado_em = \'2024-03-30 10:39:59\', alterado_por = \'Administrador\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '6608162ee1786', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(331): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoGrupoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '6608162ec48c3', '2024', '03', '30'),
	(4, '2024-03-30 13:39:59', 'admin', 'kraftsoft', 'INSERT INTO produtogrupo_subgrupo (descricao, produto_grupo_id, criado_em) VALUES (\'GERAL\', \'1\', \'2024-03-30 10:39:59\')', 'INSERT', '127.0.0.1', '6608162ee1786', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(347): ProdutoGrupoForm->storeMasterDetailItems(\'ProdutogrupoSub...\', \'produto_grupo_i...\', \'produtogrupo_su...\', Object(ProdutoGrupo), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoGrupoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '6608162ec48c3', '2024', '03', '30'),
	(5, '2024-03-30 13:39:59', 'admin', 'kraftsoft', 'DELETE FROM produtogrupo_subgrupo WHERE (produto_grupo_id = \'1\' AND id not in (1))', 'DELETE', '127.0.0.1', '6608162ee1786', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoGrupoForm.php(347): ProdutoGrupoForm->storeMasterDetailItems(\'ProdutogrupoSub...\', \'produto_grupo_i...\', \'produtogrupo_su...\', Object(ProdutoGrupo), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoGrupoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoGrupoForm', 'apache2handler', '6608162ec48c3', '2024', '03', '30'),
	(6, '2024-03-30 13:41:03', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, referencia, codigo_sku, nome, codigo_EAN, produto_grupo_id, produtogrupo_subgrupo_id, produto_fabricante_id, unidade_medida_id, produto_tipo_id, marca, nome_curto, peso_liquido, peso_bruto, produto_embalagem_id, largura, altura, comprimento, diametro, dias_preparacao, unidade_caixa, garantia, obs, habilitado_id, criado_em, criado_por, alterado_em, alterado_por, ncm, cest, notafiscal_item_orig_id, imagem, especificacao, link_site) VALUES (\'1\', \'12454655\', NULL, \'TESTE\', NULL, \'1\', \'1\', NULL, \'49\', \'1\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\', \'2024-03-30 10:41:03\', \'Administrador\', NULL, NULL, NULL, NULL, \'1\', NULL, NULL, NULL)', 'INSERT', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '6608166eb747b', '2024', '03', '30'),
	(7, '2024-03-30 13:41:03', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-03-30 10:41:03\' WHERE (produto_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1089): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '6608166eb747b', '2024', '03', '30'),
	(8, '2024-03-30 13:41:03', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-03-30 10:41:03\' WHERE (produto_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6608166ef0aaf', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '6608166eb747b', '2024', '03', '30'),
	(9, '2024-03-30 13:41:32', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = \'12454655\', codigo_sku = NULL, nome = \'TESTE\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = \'1\', produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-03-30 10:41:32\', alterado_por = \'Administrador\', ncm = NULL, cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '6608168cabb57', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1071): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '6608168c6c723', '2024', '03', '30'),
	(10, '2024-03-30 13:41:32', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-03-30 10:41:32\' WHERE (produto_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6608168cabb57', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1089): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '6608168c6c723', '2024', '03', '30'),
	(11, '2024-03-30 13:41:32', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-03-30 10:41:32\' WHERE (produto_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6608168cabb57', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '6608168c6c723', '2024', '03', '30'),
	(12, '2024-03-30 13:52:31', 'admin', 'kraftsoft', 'INSERT INTO cliente_classificacao (descricao, criado_em, criado_por, alterado_em, alterado_por, ativo_id) VALUES (\'GERAL\', \'2024-03-30 10:52:31\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '6608191f88903', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteClassificacaoForm.php(339): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteClassificacaoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteClassificacaoForm', 'apache2handler', '6608191f7a6b9', '2024', '03', '30'),
	(13, '2024-03-30 13:52:31', 'admin', 'kraftsoft', 'DELETE FROM cliente_classificacao_subgrupo WHERE (cliente_classificacao_id = \'1\')', 'DELETE', '127.0.0.1', '6608191f88903', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteClassificacaoForm.php(354): ClienteClassificacaoForm->storeMasterDetailItems(\'ClienteClassifi...\', \'cliente_classif...\', \'cliente_classif...\', Object(ClienteClassificacao), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteClassificacaoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteClassificacaoForm', 'apache2handler', '6608191f7a6b9', '2024', '03', '30'),
	(14, '2024-03-30 13:53:08', 'admin', 'kraftsoft', 'INSERT INTO cliente (system_unit_id, cliente_classificacao_id, cliente_classificacao_subgrupo_id, nome, razao_social, pessoa_tipo_id, cpf_cnpj, rg, cliente_exterior, insc_municipal, insc_estadual, vendedor_id, data_nascimento, fone, email, notafiscal_crt_id, notafiscal_indiedest_id, observacoes, criado_em, criado_por, alterado_em, alterado_por, utilizar_endereco_cobranca, cobranca_cnpj, cobranca_nome, cobranca_cep, cobranca_endereco, cobranca_bairro, cobranca_uf, cobranca_cidade, cobranca_fones, conjuge, conjuge_cpf, nome_pai, nome_mae, local_trabalho, renda, tempo_trabalho, residencia_propria, tabela_preco_id, cliente_situacao_id) VALUES (\'1\', \'1\', NULL, \'Fernando Ferreira Gomes Nascimento\', NULL, \'1\', \'96947055172\', NULL, \'N\', NULL, NULL, NULL, NULL, NULL, \'fpasqueto@gmail.com\', NULL, \'3\', NULL, \'2024-03-30 10:53:08\', \'Administrador\', NULL, NULL, \'2\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '660819449f1e8', '2024', '03', '30'),
	(15, '2024-03-30 13:53:09', 'admin', 'kraftsoft', 'DELETE FROM cliente_contato WHERE (cliente_id = \'1\')', 'DELETE', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1068): ClienteForm->storeMasterDetailItems(\'ClienteContato\', \'cliente_id\', \'cliente_contato...\', Object(Cliente), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '660819449f1e8', '2024', '03', '30'),
	(16, '2024-03-30 13:53:09', 'admin', 'kraftsoft', 'DELETE FROM cliente_endereco WHERE (cliente_id = \'1\')', 'DELETE', '127.0.0.1', '66081944d8a60', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1080): ClienteForm->storeMasterDetailItems(\'ClienteEndereco\', \'cliente_id\', \'cliente_enderec...\', Object(Cliente), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ClienteForm', 'apache2handler', '660819449f1e8', '2024', '03', '30'),
	(17, '2024-03-30 17:41:24', 'admin', 'kraftsoft', 'INSERT INTO venda_meta (system_unit_id, venda_meta_situacao_id, descricao, data_inicial, data_final, valor_meta_geral_prevista, valor_meta_geral_realizada, data_ultimo_processamento, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'1\', \'1\', \'Marco\', \'2024-03-01\', \'2024-03-31\', \'50000.00\', NULL, NULL, \'2024-03-30 14:41:24\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '66084ec4023c8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaMetaForm.php(469): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendaMetaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'VendaMetaForm', 'apache2handler', '66084ec349e8d', '2024', '03', '30'),
	(18, '2024-03-30 17:41:24', 'admin', 'kraftsoft', 'UPDATE venda_meta_vendedor SET deletado_em = \'2024-03-30 14:41:24\' WHERE (venda_meta_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66084ec4023c8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE venda_me...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE venda_me...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaMetaForm.php(484): VendaMetaForm->storeMasterDetailItems(\'VendaMetaVended...\', \'venda_meta_id\', \'venda_meta_vend...\', Object(VendaMeta), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: VendaMetaForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'VendaMetaForm', 'apache2handler', '66084ec349e8d', '2024', '03', '30'),
	(19, '2024-03-30 17:43:25', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, criado_em) VALUES (\'1\', \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', \'15231237961074000102550010000000331406166746\', \'2\', \'VENDA DE MERCADORIA ADQUIRIDA\', 1, \'1\', \'33\', \'2023-12-30 00:00:00\', \'2023-12-30 19:06:18\', 2, 1, 2, 1, 1, 2, \'1.0\', \'05641124000170\', \'37961074000102\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'158478622\', 1, \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', \'1505064\', \'NOVO REPARTIMENTO\', \'PA\', \'68473000\', \'96984206564\', \'315230000073309\', \'2023-12-30 20:06:30\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', \'2024-03-30 14:43:25\')', 'INSERT', '127.0.0.1', '66084f3cba86b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1922): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '66084f3c95aef', '2024', '03', '30'),
	(20, '2024-03-30 17:43:56', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, criado_em) VALUES (\'1\', \'tmp/15231237961074000102550010000000231497796121-nfe.xml\', \'15231237961074000102550010000000231497796121\', \'2\', \'VENDA DE MERCADORIA ADQUIRIDA\', 1, \'1\', \'23\', \'2023-12-02 00:00:00\', \'2023-12-02 13:45:09\', 2, 1, 2, 1, 1, 2, \'1.0\', \'45707058000299\', \'37961074000102\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'158478622\', 1, \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', \'1505064\', \'NOVO REPARTIMENTO\', \'PA\', \'68473000\', \'96984206564\', \'315230000070067\', \'2023-12-02 14:45:09\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', \'2024-03-30 14:43:56\')', 'INSERT', '127.0.0.1', '66084f5c32fd1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1922): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '66084f5c01d2a', '2024', '03', '30'),
	(21, '2024-03-30 17:54:58', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, cpag_lancada, criado_em) VALUES (\'1\', \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', \'15231237961074000102550010000000331406166746\', \'2\', \'VENDA DE MERCADORIA ADQUIRIDA\', 1, \'1\', \'33\', \'2023-12-30 00:00:00\', \'2023-12-30 19:06:18\', 2, 1, 2, 1, 1, 2, \'1.0\', \'05641124000170\', \'37961074000102\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'158478622\', 1, \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', \'1505064\', \'NOVO REPARTIMENTO\', \'PA\', \'68473000\', \'96984206564\', \'315230000073309\', \'2023-12-30 20:06:30\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', FALSE, \'2024-03-30 14:54:58\')', 'INSERT', '127.0.0.1', '660851f23f3f1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1923): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660851f217d93', '2024', '03', '30'),
	(22, '2024-03-30 17:54:58', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'28\', \'SEM GTIN\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', NULL, \'5102\', \'UN\', \'1.0000\', \'950.0000000000\', \'950.00\', \'SEM GTIN\', \'UN\', \'1.0000\', \'950.0000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'500\', NULL, 0, 0, 0, 0, NULL, 0, 0, 0, 0, 0, 0, \'53\', 0, 0, 0, \'07\', 0, 0, 0, \'07\', 0, 0, 0, \'1\', \'2024-03-30 14:54:58\')', 'INSERT', '127.0.0.1', '660851f23f3f1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2061): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660851f217d93', '2024', '03', '30'),
	(23, '2024-03-30 17:56:18', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, cpag_lancada, criado_em) VALUES (\'1\', \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', \'15231237961074000102550010000000331406166746\', \'2\', \'VENDA DE MERCADORIA ADQUIRIDA\', 1, \'1\', \'33\', \'2023-12-30 00:00:00\', \'2023-12-30 19:06:18\', 2, 1, 2, 1, 1, 2, \'1.0\', \'05641124000170\', \'37961074000102\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'158478622\', 1, \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', \'1505064\', \'NOVO REPARTIMENTO\', \'PA\', \'68473000\', \'96984206564\', \'315230000073309\', \'2023-12-30 20:06:30\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', FALSE, \'2024-03-30 14:56:18\')', 'INSERT', '127.0.0.1', '6608524270598', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1923): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852424a82f', '2024', '03', '30'),
	(24, '2024-03-30 17:56:18', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'28\', \'SEM GTIN\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', NULL, \'5102\', \'UN\', \'1.0000\', \'950.0000000000\', \'950.00\', \'SEM GTIN\', \'UN\', \'1.0000\', \'950.0000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'500\', NULL, 0, 0, 0, 0, NULL, 0, 0, 0, 0, 0, 0, \'53\', 0, 0, 0, \'07\', 0, 0, 0, \'07\', 0, 0, 0, \'2\', \'2024-03-30 14:56:18\')', 'INSERT', '127.0.0.1', '6608524270598', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2061): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852424a82f', '2024', '03', '30'),
	(25, '2024-03-30 17:57:30', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, cpag_lancada, criado_em) VALUES (\'1\', \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', \'15231237961074000102550010000000331406166746\', \'2\', \'VENDA DE MERCADORIA ADQUIRIDA\', 1, \'1\', \'33\', \'2023-12-30 00:00:00\', \'2023-12-30 19:06:18\', 2, 1, 2, 1, 1, 2, \'1.0\', \'05641124000170\', \'37961074000102\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'158478622\', 1, \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', \'1505064\', \'NOVO REPARTIMENTO\', \'PA\', \'68473000\', \'96984206564\', \'315230000073309\', \'2023-12-30 20:06:30\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', FALSE, \'2024-03-30 14:57:30\')', 'INSERT', '127.0.0.1', '66085289d933f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1923): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '66085289b34fe', '2024', '03', '30'),
	(26, '2024-03-30 17:57:30', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'28\', \'SEM GTIN\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', NULL, \'5102\', \'UN\', \'1.0000\', \'950.0000000000\', \'950.00\', \'SEM GTIN\', \'UN\', \'1.0000\', \'950.0000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'500\', NULL, 0, 0, 0, 0, NULL, 0, 0, 0, 0, 0, 0, \'53\', 0, 0, 0, \'07\', 0, 0, 0, \'07\', 0, 0, 0, \'3\', \'2024-03-30 14:57:30\')', 'INSERT', '127.0.0.1', '66085289d933f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2061): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '66085289b34fe', '2024', '03', '30'),
	(27, '2024-03-30 17:58:19', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, cpag_lancada, criado_em) VALUES (\'1\', \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', \'15231237961074000102550010000000331406166746\', \'2\', \'VENDA DE MERCADORIA ADQUIRIDA\', 1, \'1\', \'33\', \'2023-12-30 00:00:00\', \'2023-12-30 19:06:18\', 2, 1, 2, 1, 1, 2, \'1.0\', \'05641124000170\', \'37961074000102\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'158478622\', 1, \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', \'1505064\', \'NOVO REPARTIMENTO\', \'PA\', \'68473000\', \'96984206564\', \'315230000073309\', \'2023-12-30 20:06:30\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', FALSE, \'2024-03-30 14:58:19\')', 'INSERT', '127.0.0.1', '660852bad676c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1923): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852bab0999', '2024', '03', '30'),
	(28, '2024-03-30 17:58:19', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'28\', \'SEM GTIN\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', NULL, \'5102\', \'UN\', \'1.0000\', \'950.0000000000\', \'950.00\', \'SEM GTIN\', \'UN\', \'1.0000\', \'950.0000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'500\', NULL, 0, 0, 0, 0, NULL, 0, 0, 0, 0, 0, 0, \'53\', 0, 0, 0, \'07\', 0, 0, 0, \'07\', 0, 0, 0, \'4\', \'2024-03-30 14:58:19\')', 'INSERT', '127.0.0.1', '660852bad676c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2061): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852bab0999', '2024', '03', '30'),
	(29, '2024-03-30 17:59:12', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, cpag_lancada, criado_em) VALUES (\'1\', \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', \'15231237961074000102550010000000331406166746\', \'2\', \'VENDA DE MERCADORIA ADQUIRIDA\', 1, \'1\', \'33\', \'2023-12-30 00:00:00\', \'2023-12-30 19:06:18\', 2, 1, 2, 1, 1, 2, \'1.0\', \'05641124000170\', \'37961074000102\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'158478622\', 1, \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', \'1505064\', \'NOVO REPARTIMENTO\', \'PA\', \'68473000\', \'96984206564\', \'315230000073309\', \'2023-12-30 20:06:30\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', FALSE, \'2024-03-30 14:59:12\')', 'INSERT', '127.0.0.1', '660852f01aac5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1923): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852efe3ee1', '2024', '03', '30'),
	(30, '2024-03-30 17:59:12', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'28\', \'SEM GTIN\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', NULL, \'5102\', \'UN\', \'1.0000\', \'950.0000000000\', \'950.00\', \'SEM GTIN\', \'UN\', \'1.0000\', \'950.0000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'500\', NULL, 0, 0, 0, 0, NULL, 0, 0, 0, 0, 0, 0, \'53\', 0, 0, 0, \'07\', 0, 0, 0, \'07\', 0, 0, 0, \'5\', \'2024-03-30 14:59:12\')', 'INSERT', '127.0.0.1', '660852f01aac5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2061): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852efe3ee1', '2024', '03', '30'),
	(31, '2024-03-30 17:59:12', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = \'1\', xml = \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', chave = \'15231237961074000102550010000000331406166746\', nota_fiscal_compra_situacao_id = \'2\', natop = \'VENDA DE MERCADORIA ADQUIRIDA\', notafiscal_mod_id = 1, serie = \'1\', numero = \'33\', data_emissao = \'2023-12-30 00:00:00\', data_saida = \'2023-12-30 19:06:18\', notafiscal_tipodocumento_id = 2, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'1.0\', dest_cnpj = \'05641124000170\', cliente_cpfcnpj = \'37961074000102\', cliente_nome = \'SH PECAS E SERVICOS MECANICOS LTDA\', cliente_inscest = \'158478622\', notafiscal_crt_id = 1, cliente_endereco = \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', cliente_numero = \'S/N\', cliente_complemento = NULL, cliente_bairro = \'PARQUE MARAJO\', cliente_cidade_codibge = \'1505064\', cliente_cidade = \'NOVO REPARTIMENTO\', cliente_estado = \'PA\', cliente_cep = \'68473000\', cliente_fone = \'96984206564\', protocolo_envio = \'315230000073309\', data_hora_envio = \'2023-12-30 20:06:30\', transp_nome = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_uf = NULL, transp_placaveiculo = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, criado_por = \'Administrador\', cpag_lancada = FALSE, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATERIA 150 AMPERES MOURA desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', alterado_em = \'2024-03-30 14:59:12\' WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '660852f01aac5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2149): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852efe3ee1', '2024', '03', '30'),
	(32, '2024-03-30 17:59:12', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = NULL, numero = \'33\', data_emissao = \'2023-12-30 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-03-30 14:59:12\', natop = \'VENDA DE MERCADORIA ADQUIRIDA\', data_saida = \'2023-12-30 19:06:18\', infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 950, valor_total_nota = 950, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = 2, notafiscal_crt_id = 1, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATERIA 150 AMPERES MOURA desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', cliente_complemento = NULL, cliente_numero = \'S/N\', cliente_bairro = \'PARQUE MARAJO\', cliente_cidade = \'NOVO REPARTIMENTO\', cliente_cep = \'68473000\', cliente_estado = \'PA\', cliente_nome = \'SH PECAS E SERVICOS MECANICOS LTDA\', cliente_cpfcnpj = \'37961074000102\', cliente_inscest = \'158478622\', cliente_fone = \'96984206564\', cliente_cidade_codibge = \'1505064\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'15231237961074000102550010000000331406166746\', protocolo_envio = \'315230000073309\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 0, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'1.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', data_hora_envio = \'2023-12-30 20:06:30\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'05641124000170\' WHERE (id = 5)', 'UPDATE', '127.0.0.1', '660852f01aac5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1564): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2151): NotaFiscalCompra::atualiza_totais_nota(\'5\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/15231237961...\')\n#5 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraImportarXML', 'apache2handler', '660852efe3ee1', '2024', '03', '30'),
	(33, '2024-03-30 18:00:09', 'admin', 'kraftsoft', 'INSERT INTO api_error (url, error_message) VALUES (\'/cep/api/v1/68473000\', NULL)', 'INSERT', '127.0.0.1', '66085328e46d7', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO api...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO api...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\service\\php_services\\CEPService.php(25): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(161): CEPService::get(\'68473000\')\n#4 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '66085328b75bb', '2024', '03', '30'),
	(34, '2024-03-30 18:00:09', 'admin', 'kraftsoft', 'INSERT INTO fornecedor (nome, razao_social, cpf_cnpj, pessoa_tipo_id, insc_estadual, insc_municipal, fone, logradouro, cep, numero, bairro, complemento, criado_por, criado_em) VALUES (\'SH PECAS E SERVICOS MECANICOS LTDA\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'37.961.074/0001-02\', \'2\', \'158478622\', NULL, \'96984206564\', \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'68473000\', \'S/N\', \'PARQUE MARAJO\', NULL, \'Administrador\', \'2024-03-30 15:00:09\')', 'INSERT', '127.0.0.1', '66085328e46d7', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO for...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO for...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(175): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '66085328b75bb', '2024', '03', '30'),
	(35, '2024-03-30 18:00:09', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = \'1\', numero = \'33\', data_emissao = \'2023-12-30 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-03-30 15:00:09\', natop = \'VENDA DE MERCADORIA ADQUIRIDA\', data_saida = \'2023-12-30 19:06:18\', infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 950, valor_total_nota = 950, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = 2, notafiscal_crt_id = 1, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATERIA 150 AMPERES MOURA desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', cliente_complemento = NULL, cliente_numero = \'S/N\', cliente_bairro = \'PARQUE MARAJO\', cliente_cidade = \'NOVO REPARTIMENTO\', cliente_cep = \'68473000\', cliente_estado = \'PA\', cliente_nome = \'SH PECAS E SERVICOS MECANICOS LTDA\', cliente_cpfcnpj = \'37961074000102\', cliente_inscest = \'158478622\', cliente_fone = \'96984206564\', cliente_cidade_codibge = \'1505064\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'15231237961074000102550010000000331406166746\', protocolo_envio = \'315230000073309\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 0, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'1.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', data_hora_envio = \'2023-12-30 20:06:30\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'05641124000170\' WHERE (id = 5)', 'UPDATE', '127.0.0.1', '66085328e46d7', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(180): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '66085328b75bb', '2024', '03', '30'),
	(36, '2024-03-30 18:00:09', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 1, numero = \'33\', data_emissao = \'2023-12-30 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-03-30 15:00:09\', natop = \'VENDA DE MERCADORIA ADQUIRIDA\', data_saida = \'2023-12-30 19:06:18\', infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 950, valor_total_nota = 950, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'2\', notafiscal_crt_id = 1, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto BATERIA 150 AMPERES MOURA desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', cliente_complemento = NULL, cliente_numero = \'S/N\', cliente_bairro = \'PARQUE MARAJO\', cliente_cidade = \'NOVO REPARTIMENTO\', cliente_cep = \'68473000\', cliente_estado = \'PA\', cliente_nome = \'SH PECAS E SERVICOS MECANICOS LTDA\', cliente_cpfcnpj = \'37961074000102\', cliente_inscest = \'158478622\', cliente_fone = \'96984206564\', cliente_cidade_codibge = \'1505064\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'15231237961074000102550010000000331406166746\', protocolo_envio = \'315230000073309\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 0, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'1.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', data_hora_envio = \'2023-12-30 20:06:30\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'05641124000170\' WHERE (id = 5)', 'UPDATE', '127.0.0.1', '66085328e46d7', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1755): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(183): NotaFiscalCompra::AnalisaVinculosNota(5)\n#4 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '66085328b75bb', '2024', '03', '30'),
	(37, '2024-03-30 18:00:47', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', \'49\', \'1\', \'Administrador\', \'2024-03-30 15:00:47\')', 'INSERT', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608534f6f6b5', '2024', '03', '30'),
	(38, '2024-03-30 18:00:47', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, criado_em) VALUES (\'1\', \'2\', \'1\', 0, \'2024-03-30 15:00:47\')', 'INSERT', '127.0.0.1', '6608534f9ce58', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608534f6f6b5', '2024', '03', '30'),
	(39, '2024-03-30 18:01:11', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', \'49\', \'1\', \'Administrador\', \'2024-03-30 15:01:11\')', 'INSERT', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608536752de0', '2024', '03', '30'),
	(40, '2024-03-30 18:01:11', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, criado_em) VALUES (\'1\', \'3\', \'1\', 0, \'2024-03-30 15:01:11\')', 'INSERT', '127.0.0.1', '660853678a7cb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608536752de0', '2024', '03', '30'),
	(41, '2024-03-30 23:00:48', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', \'49\', \'1\', \'Administrador\', \'2024-03-30 20:00:48\')', 'INSERT', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(144): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '660899a01e939', '2024', '03', '30'),
	(42, '2024-03-30 23:00:48', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, criado_em) VALUES (\'1\', \'4\', \'1\', 0, \'2024-03-30 20:00:48\')', 'INSERT', '127.0.0.1', '660899a064daa', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '660899a01e939', '2024', '03', '30'),
	(43, '2024-03-31 00:47:48', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'BATERIA 150 AMPERES MOURA\', \'85071090\', \'49\', \'1\', \'Administrador\', \'2024-03-30 21:47:48\')', 'INSERT', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608b2b455420', '2024', '03', '30'),
	(44, '2024-03-31 00:47:48', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, preco_venda, criado_em) VALUES (\'1\', \'5\', \'1\', 0, 0, \'2024-03-30 21:47:48\')', 'INSERT', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608b2b455420', '2024', '03', '30'),
	(45, '2024-03-31 00:47:48', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_itens SET nota_fiscal_compra_id = 5, produto_id = \'5\', nota_fiscal_compra_itens_situacao_id = NULL, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 21:47:48\', nitem = NULL, cean = \'SEM GTIN\', xprod = \'BATERIA 150 AMPERES MOURA\', ncm = \'85071090\', nve = NULL, extipi = NULL, cfop = \'5102\', ucom = \'UN\', qcom = 1, vuncom = 950, vprod = 950, ceantrib = \'SEM GTIN\', utrib = \'UN\', qtrib = 1, vuntrib = 950, vfrete = 0, vseg = 0, vdesc = 0, vtottrib = NULL, xped = NULL, nitemped = NULL, notafiscal_item_indtot_id = NULL, notafiscal_item_orig_id = 1, notafiscal_item_modbc_id = NULL, icms_basecalc = 0, icms_cst = \'500\', icms_valor = 0, icms_aliquota = 0, icms_pcredsn = 0, icms_vcredicmssn = 0, icms_predbc = 0, icms_pst = NULL, icms_pmvast = NULL, icms_predbcst = 0, icms_vbcst = 0, icms_picmsst = 0, icms_vicmsst = 0, fcp_pfcp = NULL, pis_cst = \'07\', pis_valor = 0, pis_aliquota = 0, pis_valor_base = 0, cofins_cst = \'07\', cofins_valor_base = 0, cofins_aliquota = 0, cofins_valor = 0, voutro = 0, infadprod = NULL, notafiscal_item_motDesICMS_id = NULL, cprod = \'28\', ipi_cst = \'53\', ipi_valor_base = 0, ipi_aliquota = 0, ipi_vipidevol = NULL, ipi_valor = 0, ipi_pdevol = NULL, estoque_deposito_id = \'1\', produto_lote_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(167): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608b2b455420', '2024', '03', '30'),
	(46, '2024-03-31 00:47:48', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 1, numero = \'33\', data_emissao = \'2023-12-30 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-03-30 21:47:48\', natop = \'VENDA DE MERCADORIA ADQUIRIDA\', data_saida = \'2023-12-30 19:06:18\', infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 950, valor_total_nota = 950, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'1\', notafiscal_crt_id = 1, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>\', cliente_endereco = \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', cliente_complemento = NULL, cliente_numero = \'S/N\', cliente_bairro = \'PARQUE MARAJO\', cliente_cidade = \'NOVO REPARTIMENTO\', cliente_cep = \'68473000\', cliente_estado = \'PA\', cliente_nome = \'SH PECAS E SERVICOS MECANICOS LTDA\', cliente_cpfcnpj = \'37961074000102\', cliente_inscest = \'158478622\', cliente_fone = \'96984206564\', cliente_cidade_codibge = \'1505064\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'15231237961074000102550010000000331406166746\', protocolo_envio = \'315230000073309\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 0, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'1.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', data_hora_envio = \'2023-12-30 20:06:30\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'05641124000170\' WHERE (id = 5)', 'UPDATE', '127.0.0.1', '6608b2b4932fe', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1755): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(170): NotaFiscalCompra::AnalisaVinculosNota(5)\n#4 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6608b2b455420', '2024', '03', '30'),
	(47, '2024-03-31 00:50:09', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (system_unit_id, produto_id, estoque_tipo_movimentacao_id, estoque_origem_id, estoque_deposito_id, produto_lote_id, quantidade, preco_venda, preco_custo, data_lancamento, nota_fiscal_compra_id, criado_por, observacao, criado_em) VALUES (1, 5, \'1\', \'3\', 1, NULL, 1, 0, 950, \'2024-03-30\', 5, \'Administrador\', \'Entrada de nota fiscal de compra Id: 5\', \'2024-03-30 21:50:09\')', 'INSERT', '127.0.0.1', '6608b341c07ad', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1613): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(600): NotaFiscalCompra::LancamentoEstoque(Object(NotaFiscalCompra), \'Entrada de nota...\', \'1\')\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608b341b81a5', '2024', '03', '30'),
	(48, '2024-03-31 00:50:09', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = 5, system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 21:50:09\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608b341c07ad', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2182): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(605): NotaFiscalCompra::AtualizaCustoProduto(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608b341b81a5', '2024', '03', '30'),
	(49, '2024-03-31 00:50:09', 'admin', 'kraftsoft', 'INSERT INTO produto_fornecedor (produto_id, fornecedor_id, codigo_fornecedor, descricao_produto_fornecedor, preco_venda, criado_em) VALUES (5, 1, \'28\', \'BATERIA 150 AMPERES MOURA\', 950, \'2024-03-30 21:50:09\')', 'INSERT', '127.0.0.1', '6608b341c07ad', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1588): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(607): NotaFiscalCompra::VinculaProdutosFornecedor(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608b341b81a5', '2024', '03', '30'),
	(50, '2024-03-31 00:52:24', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (system_unit_id, produto_id, estoque_tipo_movimentacao_id, estoque_origem_id, estoque_deposito_id, produto_lote_id, quantidade, preco_venda, preco_custo, data_lancamento, nota_fiscal_compra_id, criado_por, observacao, criado_em) VALUES (1, 5, \'1\', \'3\', 1, NULL, 1, 0, 950, \'2024-03-30\', 5, \'Administrador\', \'Entrada de nota fiscal de compra Id: 5\', \'2024-03-30 21:52:24\')', 'INSERT', '127.0.0.1', '6608b3c82334b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1613): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(600): NotaFiscalCompra::LancamentoEstoque(Object(NotaFiscalCompra), \'Entrada de nota...\', \'1\')\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608b3c81b015', '2024', '03', '30'),
	(51, '2024-03-31 00:52:24', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = 5, system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 21:52:24\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608b3c82334b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2182): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(605): NotaFiscalCompra::AtualizaCustoProduto(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608b3c81b015', '2024', '03', '30'),
	(52, '2024-03-31 00:52:24', 'admin', 'kraftsoft', 'INSERT INTO produto_fornecedor (produto_id, fornecedor_id, codigo_fornecedor, descricao_produto_fornecedor, preco_venda, criado_em) VALUES (5, 1, \'28\', \'BATERIA 150 AMPERES MOURA\', 950, \'2024-03-30 21:52:24\')', 'INSERT', '127.0.0.1', '6608b3c82334b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1588): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(607): NotaFiscalCompra::VinculaProdutosFornecedor(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608b3c81b015', '2024', '03', '30'),
	(53, '2024-03-31 01:22:40', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (system_unit_id, produto_id, estoque_tipo_movimentacao_id, estoque_origem_id, estoque_deposito_id, produto_lote_id, quantidade, preco_venda, preco_custo, data_lancamento, nota_fiscal_compra_id, criado_por, observacao, criado_em) VALUES (1, 5, \'1\', \'3\', 1, NULL, 1, 0, 950, \'2024-03-30\', 5, \'Administrador\', \'Entrada de nota fiscal de compra Id: 5\', \'2024-03-30 22:22:40\')', 'INSERT', '127.0.0.1', '6608bae0a0fea', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1613): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(601): NotaFiscalCompra::LancamentoEstoque(Object(NotaFiscalCompra), \'Entrada de nota...\', \'1\')\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608bae09906d', '2024', '03', '30'),
	(54, '2024-03-31 01:22:40', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = 5, system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 22:22:40\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608bae0a0fea', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2182): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(606): NotaFiscalCompra::AtualizaCustoProduto(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608bae09906d', '2024', '03', '30'),
	(55, '2024-03-31 01:22:40', 'admin', 'kraftsoft', 'INSERT INTO produto_fornecedor (produto_id, fornecedor_id, codigo_fornecedor, descricao_produto_fornecedor, preco_venda, criado_em) VALUES (5, 1, \'28\', \'BATERIA 150 AMPERES MOURA\', 950, \'2024-03-30 22:22:40\')', 'INSERT', '127.0.0.1', '6608bae0a0fea', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1588): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(608): NotaFiscalCompra::VinculaProdutosFornecedor(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608bae09906d', '2024', '03', '30'),
	(56, '2024-03-31 01:44:37', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (system_unit_id, produto_id, estoque_tipo_movimentacao_id, estoque_origem_id, estoque_deposito_id, produto_lote_id, quantidade, preco_venda, preco_custo, data_lancamento, nota_fiscal_compra_id, criado_por, observacao, criado_em) VALUES (1, 5, \'1\', \'3\', 1, NULL, 1, 0, 950, \'2024-03-30\', 5, \'Administrador\', \'Entrada de nota fiscal de compra Id: 5\', \'2024-03-30 22:44:37\')', 'INSERT', '127.0.0.1', '6608c004e7111', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1613): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(601): NotaFiscalCompra::LancamentoEstoque(Object(NotaFiscalCompra), \'Entrada de nota...\', \'1\')\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c004d70a1', '2024', '03', '30'),
	(57, '2024-03-31 01:44:37', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = 5, system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 22:44:37\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608c004e7111', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2182): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(606): NotaFiscalCompra::AtualizaCustoProduto(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c004d70a1', '2024', '03', '30'),
	(58, '2024-03-31 01:44:37', 'admin', 'kraftsoft', 'INSERT INTO produto_fornecedor (produto_id, fornecedor_id, codigo_fornecedor, descricao_produto_fornecedor, preco_venda, criado_em) VALUES (5, 1, \'28\', \'BATERIA 150 AMPERES MOURA\', 950, \'2024-03-30 22:44:37\')', 'INSERT', '127.0.0.1', '6608c004e7111', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1588): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(608): NotaFiscalCompra::VinculaProdutosFornecedor(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c004d70a1', '2024', '03', '30'),
	(59, '2024-03-31 01:46:02', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (system_unit_id, produto_id, estoque_tipo_movimentacao_id, estoque_origem_id, estoque_deposito_id, produto_lote_id, quantidade, preco_venda, preco_custo, data_lancamento, nota_fiscal_compra_id, criado_por, observacao, criado_em) VALUES (1, 5, \'1\', \'3\', 1, NULL, 1, 0, 950, \'2024-03-30\', 5, \'Administrador\', \'Entrada de nota fiscal de compra Id: 5\', \'2024-03-30 22:46:02\')', 'INSERT', '127.0.0.1', '6608c05a63ce8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1613): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(601): NotaFiscalCompra::LancamentoEstoque(Object(NotaFiscalCompra), \'Entrada de nota...\', \'1\')\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c05a59b8e', '2024', '03', '30'),
	(60, '2024-03-31 01:46:02', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = 5, system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 22:46:02\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608c05a63ce8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2182): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(606): NotaFiscalCompra::AtualizaCustoProduto(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c05a59b8e', '2024', '03', '30'),
	(61, '2024-03-31 01:46:02', 'admin', 'kraftsoft', 'INSERT INTO produto_fornecedor (produto_id, fornecedor_id, codigo_fornecedor, descricao_produto_fornecedor, preco_venda, criado_em) VALUES (5, 1, \'28\', \'BATERIA 150 AMPERES MOURA\', 950, \'2024-03-30 22:46:02\')', 'INSERT', '127.0.0.1', '6608c05a63ce8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1588): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(608): NotaFiscalCompra::VinculaProdutosFornecedor(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c05a59b8e', '2024', '03', '30'),
	(62, '2024-03-31 01:46:58', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (system_unit_id, produto_id, estoque_tipo_movimentacao_id, estoque_origem_id, estoque_deposito_id, produto_lote_id, quantidade, preco_venda, preco_custo, data_lancamento, nota_fiscal_compra_id, criado_por, observacao, criado_em) VALUES (1, 5, \'1\', \'3\', 1, NULL, 1, 0, 950, \'2024-03-30\', 5, \'Administrador\', \'Entrada de nota fiscal de compra Id: 5\', \'2024-03-30 22:46:58\')', 'INSERT', '127.0.0.1', '6608c092359e9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1613): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(601): NotaFiscalCompra::LancamentoEstoque(Object(NotaFiscalCompra), \'Entrada de nota...\', \'1\')\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c0922d7cb', '2024', '03', '30'),
	(63, '2024-03-31 01:46:58', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = 5, system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 22:46:58\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608c092359e9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2182): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(606): NotaFiscalCompra::AtualizaCustoProduto(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c0922d7cb', '2024', '03', '30'),
	(64, '2024-03-31 01:46:58', 'admin', 'kraftsoft', 'INSERT INTO produto_fornecedor (produto_id, fornecedor_id, codigo_fornecedor, descricao_produto_fornecedor, preco_venda, criado_em) VALUES (5, 1, \'28\', \'BATERIA 150 AMPERES MOURA\', 950, \'2024-03-30 22:46:58\')', 'INSERT', '127.0.0.1', '6608c092359e9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1588): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(608): NotaFiscalCompra::VinculaProdutosFornecedor(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c0922d7cb', '2024', '03', '30'),
	(65, '2024-03-31 01:57:57', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (system_unit_id, produto_id, estoque_tipo_movimentacao_id, estoque_origem_id, estoque_deposito_id, produto_lote_id, quantidade, preco_venda, preco_custo, data_lancamento, nota_fiscal_compra_id, criado_por, observacao, criado_em) VALUES (1, 5, \'1\', \'3\', 1, NULL, 1, 0, 950, \'2024-03-30\', 5, \'Administrador\', \'Entrada de nota fiscal de compra Id: 5\', \'2024-03-30 22:57:57\')', 'INSERT', '127.0.0.1', '6608c3257cb43', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1614): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(601): NotaFiscalCompra::LancamentoEstoque(Object(NotaFiscalCompra), \'Entrada de nota...\', \'1\')\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c32572aaa', '2024', '03', '30'),
	(66, '2024-03-31 01:57:57', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = 5, system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-30 22:57:57\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6608c3257cb43', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2183): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(606): NotaFiscalCompra::AtualizaCustoProduto(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c32572aaa', '2024', '03', '30'),
	(67, '2024-03-31 01:57:57', 'admin', 'kraftsoft', 'INSERT INTO produto_fornecedor (produto_id, fornecedor_id, codigo_fornecedor, descricao_produto_fornecedor, preco_venda, criado_por, criado_em) VALUES (5, 1, \'28\', \'BATERIA 150 AMPERES MOURA\', 950, \'Administrador\', \'2024-03-30 22:57:57\')', 'INSERT', '127.0.0.1', '6608c3257cb43', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1589): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(608): NotaFiscalCompra::VinculaProdutosFornecedor(Object(NotaFiscalCompra))\n#4 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c32572aaa', '2024', '03', '30'),
	(68, '2024-03-31 01:57:57', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 1, numero = \'33\', data_emissao = \'2023-12-30 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-03-30 22:57:57\', natop = \'VENDA DE MERCADORIA ADQUIRIDA\', data_saida = \'2023-12-30 19:06:18\', infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 950, valor_total_nota = 950, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'3\', notafiscal_crt_id = 1, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>\', cliente_endereco = \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', cliente_complemento = NULL, cliente_numero = \'S/N\', cliente_bairro = \'PARQUE MARAJO\', cliente_cidade = \'NOVO REPARTIMENTO\', cliente_cep = \'68473000\', cliente_estado = \'PA\', cliente_nome = \'SH PECAS E SERVICOS MECANICOS LTDA\', cliente_cpfcnpj = \'37961074000102\', cliente_inscest = \'158478622\', cliente_fone = \'96984206564\', cliente_cidade_codibge = \'1505064\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'15231237961074000102550010000000331406166746\', protocolo_envio = \'315230000073309\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 0, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'1.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/15231237961074000102550010000000331406166746-nfe.xml\', data_hora_envio = \'2023-12-30 20:06:30\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'05641124000170\' WHERE (id = 5)', 'UPDATE', '127.0.0.1', '6608c3257cb43', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraFormView.php(612): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraFormView::onFinalizarYes(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NotaFiscalCompraFormView', 'apache2handler', '6608c32572aaa', '2024', '03', '30'),
	(69, '2024-03-31 02:17:25', 'admin', 'kraftsoft', 'INSERT INTO forma_pagamento (codigo_interno, tipo_documento_id, meio_pagamento_tef_id, descricao, notafiscal_tpag_id, taxa, prazo_pagamento, utiliza_pdv, obriga_nf_pdv, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'1\', \'4\', NULL, \'DINHEIRO\', \'1\', NULL, NULL, \'S\', NULL, \'2024-03-30 23:17:25\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '6608c7b5a79a1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO for...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO for...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '6608c7b572efb', '2024', '03', '30'),
	(70, '2024-03-31 12:36:54', 'admin', 'kraftsoft', 'INSERT INTO forma_pagamento (codigo_interno, tipo_documento_id, meio_pagamento_tef_id, descricao, notafiscal_tpag_id, taxa, prazo_pagamento, utiliza_pdv, obriga_nf_pdv, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'2\', \'4\', NULL, \'BOLETO\', \'10\', NULL, \'30\', \'S\', \'N\', \'2024-03-31 09:36:54\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '660958e6a2042', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO for...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO for...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\FormaPagamentoForm.php(149): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FormaPagamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'FormaPagamentoForm', 'apache2handler', '660958e6594c5', '2024', '03', '31'),
	(71, '2024-03-31 12:48:38', 'admin', 'kraftsoft', 'INSERT INTO estoque_deposito (descricao, criado_em, criado_por, alterado_em, alterado_por, system_unit_id) VALUES (\'LOJA\', \'2024-03-31 09:48:38\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66095ba65e1ac', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueDepositoForm.php(389): Adianti\\Database\\TRecord->store()\n#3 [internal function]: EstoqueDepositoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'EstoqueDepositoForm', 'apache2handler', '66095ba620086', '2024', '03', '31'),
	(72, '2024-03-31 12:48:38', 'admin', 'kraftsoft', 'UPDATE estoque_rua SET deletado_em = \'2024-03-31 09:48:38\' WHERE (estoque_deposito_id = \'2\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66095ba65e1ac', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE estoque_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE estoque_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueDepositoForm.php(407): EstoqueDepositoForm->storeMasterDetailItems(\'EstoqueRua\', \'estoque_deposit...\', \'estoque_rua_est...\', Object(EstoqueDeposito), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: EstoqueDepositoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'EstoqueDepositoForm', 'apache2handler', '66095ba620086', '2024', '03', '31'),
	(73, '2024-03-31 12:48:49', 'admin', 'kraftsoft', 'UPDATE estoque_deposito SET descricao = \'LOJA\', criado_por = \'Sistema Kraft\', alterado_em = \'2024-03-31 09:48:49\', alterado_por = \'Administrador\', system_unit_id = \'1\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '66095bb19df83', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE estoque_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE estoque_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueDepositoForm.php(389): Adianti\\Database\\TRecord->store()\n#3 [internal function]: EstoqueDepositoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'EstoqueDepositoForm', 'apache2handler', '66095bb154e18', '2024', '03', '31'),
	(74, '2024-03-31 12:48:49', 'admin', 'kraftsoft', 'UPDATE estoque_rua SET deletado_em = \'2024-03-31 09:48:49\' WHERE (estoque_deposito_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66095bb19df83', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE estoque_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE estoque_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueDepositoForm.php(407): EstoqueDepositoForm->storeMasterDetailItems(\'EstoqueRua\', \'estoque_deposit...\', \'estoque_rua_est...\', Object(EstoqueDeposito), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: EstoqueDepositoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'EstoqueDepositoForm', 'apache2handler', '66095bb154e18', '2024', '03', '31'),
	(75, '2024-03-31 12:49:00', 'admin', 'kraftsoft', 'UPDATE estoque_deposito SET descricao = \'DEPOSITO\', criado_por = \'Administrador\', alterado_em = \'2024-03-31 09:49:00\', alterado_por = \'Administrador\', system_unit_id = \'1\' WHERE (id = \'2\')', 'UPDATE', '127.0.0.1', '66095bbc2c651', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE estoque_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE estoque_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueDepositoForm.php(389): Adianti\\Database\\TRecord->store()\n#3 [internal function]: EstoqueDepositoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'EstoqueDepositoForm', 'apache2handler', '66095bbbd7dcc', '2024', '03', '31'),
	(76, '2024-03-31 12:49:00', 'admin', 'kraftsoft', 'UPDATE estoque_rua SET deletado_em = \'2024-03-31 09:49:00\' WHERE (estoque_deposito_id = \'2\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66095bbc2c651', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE estoque_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE estoque_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueDepositoForm.php(407): EstoqueDepositoForm->storeMasterDetailItems(\'EstoqueRua\', \'estoque_deposit...\', \'estoque_rua_est...\', Object(EstoqueDeposito), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: EstoqueDepositoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'EstoqueDepositoForm', 'apache2handler', '66095bbbd7dcc', '2024', '03', '31'),
	(77, '2024-03-31 12:50:47', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (produto_id, estoque_tipo_movimentacao_id, estoque_deposito_id, produto_lote_id, quantidade, observacao, estoque_origem_id, system_unit_id, data_lancamento, preco_venda, preco_custo, criado_por, criado_em) VALUES (\'5\', \'1\', \'2\', NULL, \'5.00\', \'CONTAGEM DE ESTOQUE\', \'1\', \'1\', \'2024-03-31\', 950, NULL, \'Administrador\', \'2024-03-31 09:50:47\')', 'INSERT', '127.0.0.1', '66095c279bff1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueLancamentosForm.php(204): Adianti\\Database\\TRecord->store()\n#3 [internal function]: EstoqueLancamentosForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'EstoqueLancamentosForm', 'apache2handler', '66095c273f81c', '2024', '03', '31'),
	(78, '2024-03-31 12:54:09', 'admin', 'kraftsoft', 'INSERT INTO natureza_operacao (natureza_operacao_finalidade_id, descricao, obs_padrao, criado_em, criado_por, alterado_em, alterado_por, cst_icms_id, cst_icms_nao_contribuinte_id, cfop, cfop_fora, icms_pCredSN, icms_aliquota, icms_base, notafiscal_item_modbc_id, icms_pICMSST, icms_baseST, icms_pMVAST, icms_pFCPST, icms_pFCPSTRet, icms_pRedBCEfet, cst_ipi_id, ipi_aliquota, ipi_codigo_enquadramento, cst_pis_id, pis_aliquota, pis_base, cst_cofins_id, cofins_aliquota, cofins_base) VALUES (\'1\', \'VENDA DE MERCADORIAS\', NULL, \'2024-03-31 09:54:09\', \'Administrador\', NULL, NULL, \'11\', \'2\', \'5102\', \'6102\', NULL, \'17.00\', \'100.00\', \'4\', NULL, NULL, NULL, NULL, NULL, NULL, \'10\', NULL, NULL, \'8\', NULL, NULL, \'8\', NULL, NULL)', 'INSERT', '127.0.0.1', '66095cf12b543', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO nat...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO nat...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\fiscal\\NaturezaOperacaoForm.php(304): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NaturezaOperacaoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'NaturezaOperacaoForm', 'apache2handler', '66095cf0b2410', '2024', '03', '31'),
	(79, '2024-03-31 12:57:12', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-03-31 09:57:12\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '66095da89fd10', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '66095da819563', '2024', '03', '31'),
	(80, '2024-03-31 12:57:12', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-03-31 09:57:12\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '66095da89fd10', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '66095da819563', '2024', '03', '31'),
	(81, '2024-03-31 12:57:12', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-03-31 09:57:12\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66095da89fd10', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '66095da819563', '2024', '03', '31'),
	(82, '2024-03-31 12:57:12', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = \'5\', system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-03-31 09:57:12\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '66095da89fd10', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '66095da819563', '2024', '03', '31'),
	(83, '2024-03-31 12:57:12', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-03-31 09:57:12\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66095da89fd10', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'bmr7hnb051fgsdjk46m621tlpm', 'ProdutoForm', 'apache2handler', '66095da819563', '2024', '03', '31'),
	(84, '2024-04-01 16:52:40', 'admin', 'kraftsoft', 'INSERT INTO vendedor (cpf, nome, vendedor_tipo_comissao_id, vendedor_tipo_pgto_comissao_id, percentual_comissao, criado_em, criado_por, alterado_em, alterado_por) VALUES (NULL, \'LOJA\', NULL, \'1\', NULL, \'2024-04-01 13:52:40\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '660ae658ca258', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cadastros_diversos\\VendedorForm.php(126): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendedorForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'VendedorForm', 'apache2handler', '660ae658a2f4f', '2024', '04', '01'),
	(85, '2024-04-01 16:53:35', 'admin', 'kraftsoft', 'INSERT INTO tabela_preco (tabela_preco_tipo_id, tabela_preco_tipo_alteracao_id, descricao, data_hora_promocao_inicial, data_hora_promocao_final, observacao, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'1\', \'1\', \'A VISTA\', NULL, NULL, NULL, \'2024-04-01 13:53:35\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '660ae68fc6261', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO tab...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO tab...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\TabelaPrecoForm.php(519): Adianti\\Database\\TRecord->store()\n#3 [internal function]: TabelaPrecoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'umas14pat3lib5roqevptplopl', 'TabelaPrecoForm', 'apache2handler', '660ae68f3fd5c', '2024', '04', '01'),
	(86, '2024-04-01 16:53:35', 'admin', 'kraftsoft', 'UPDATE tabela_preco_produto SET deletado_em = \'2024-04-01 13:53:35\' WHERE (tabela_preco_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '660ae68fc6261', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE tabela_p...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE tabela_p...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\TabelaPrecoForm.php(551): TabelaPrecoForm->storeMasterDetailItems(\'TabelaPrecoProd...\', \'tabela_preco_id\', \'tabela_preco_pr...\', Object(TabelaPreco), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: TabelaPrecoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'TabelaPrecoForm', 'apache2handler', '660ae68f3fd5c', '2024', '04', '01'),
	(87, '2024-04-01 16:54:20', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'2024-04-01\', \'1\', \'1\', NULL, \'1\', NULL, \'2024-04-01 13:54:20\', \'Administrador\', NULL, NULL, \'950.00\', \'0.00\', \'950.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '660ae6bc1a712', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(858): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'umas14pat3lib5roqevptplopl', 'OrcamentoForm', 'apache2handler', '660ae6bb9add9', '2024', '04', '01'),
	(88, '2024-04-01 16:54:20', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'1\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-04-01 13:54:20\')', 'INSERT', '127.0.0.1', '660ae6bc1a712', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(862): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'1\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'OrcamentoForm', 'apache2handler', '660ae6bb9add9', '2024', '04', '01'),
	(89, '2024-04-01 16:54:20', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'5\', \'1\', \'950.00\', NULL, NULL, \'950.00\', NULL, NULL, NULL, \'1\', \'2024-04-01 13:54:20\')', 'INSERT', '127.0.0.1', '660ae6bc1a712', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(882): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'OrcamentoForm', 'apache2handler', '660ae6bb9add9', '2024', '04', '01'),
	(90, '2024-04-01 17:02:38', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-04-01 14:02:38\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '660ae8aeac1ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660ae8ae78de0', '2024', '04', '01'),
	(91, '2024-04-01 17:02:38', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-01 14:02:38\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '660ae8aeac1ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660ae8ae78de0', '2024', '04', '01'),
	(92, '2024-04-01 17:02:38', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-04-01 14:02:38\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '660ae8aeac1ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660ae8ae78de0', '2024', '04', '01'),
	(93, '2024-04-01 17:02:38', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1140.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-04-01 14:02:38\')', 'INSERT', '127.0.0.1', '660ae8aeac1ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1141): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660ae8ae78de0', '2024', '04', '01'),
	(94, '2024-04-01 20:55:02', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-04-01 17:55:02\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '660b1f266514f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b1f25ac528', '2024', '04', '01'),
	(95, '2024-04-01 20:55:02', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-01 17:55:02\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '660b1f266514f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b1f25ac528', '2024', '04', '01'),
	(96, '2024-04-01 20:55:02', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-04-01 17:55:02\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '660b1f266514f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b1f25ac528', '2024', '04', '01'),
	(97, '2024-04-01 20:55:02', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'1.140,00\', \'1140.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-04-01 17:55:02\')', 'INSERT', '127.0.0.1', '660b1f266514f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1141): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b1f25ac528', '2024', '04', '01'),
	(98, '2024-04-01 21:13:01', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-04-01 18:13:01\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '660b235dc13a4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b235d5b355', '2024', '04', '01'),
	(99, '2024-04-01 21:13:02', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-01 18:13:02\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '660b235dc13a4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b235d5b355', '2024', '04', '01'),
	(100, '2024-04-01 21:13:02', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-04-01 18:13:02\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '660b235dc13a4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b235d5b355', '2024', '04', '01'),
	(101, '2024-04-01 21:13:02', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1235.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-04-01 18:13:02\')', 'INSERT', '127.0.0.1', '660b235dc13a4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1141): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660b235d5b355', '2024', '04', '01'),
	(102, '2024-04-01 22:58:37', 'admin', 'kraftsoft', 'INSERT INTO api_error (url, error_message) VALUES (\'/cnpj/api/v1/13347963000108\', NULL)', 'INSERT', '127.0.0.1', '660b3c1cb13d4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO api...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO api...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\service\\php_services\\CNPJService.php(27): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(559): CNPJService::get(\'13347963000108\')\n#4 [internal function]: ClienteForm::onConsultaCnpj(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ClienteForm', 'apache2handler', '660b3c1c9e266', '2024', '04', '01'),
	(103, '2024-04-01 22:59:03', 'admin', 'kraftsoft', 'INSERT INTO api_error (url, error_message) VALUES (\'/cnpj/api/v1/13347963000108\', NULL)', 'INSERT', '127.0.0.1', '660b3c37545d7', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO api...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO api...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\service\\php_services\\CNPJService.php(27): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(559): CNPJService::get(\'13.347.963/0001...\')\n#4 [internal function]: ClienteForm::onConsultaCnpj(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ClienteForm', 'apache2handler', '660b3c3734d62', '2024', '04', '01'),
	(104, '2024-04-03 14:42:16', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-04-03 11:42:16\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '660d6ac7f208d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660d6ac75284d', '2024', '04', '03'),
	(105, '2024-04-03 14:42:16', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-03 11:42:16\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '660d6ac7f208d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660d6ac75284d', '2024', '04', '03'),
	(106, '2024-04-03 14:42:16', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-04-03 11:42:16\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '660d6ac7f208d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660d6ac75284d', '2024', '04', '03'),
	(107, '2024-04-03 14:42:16', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = \'5\', system_unit_id = 1, margem = 0, preco_venda = 950, preco_venda_anterior = NULL, valor_custo = 950, valor_custo_anterior = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-04-03 11:42:16\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 1, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '660d6ac7f208d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660d6ac75284d', '2024', '04', '03'),
	(108, '2024-04-03 14:42:16', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-04-03 11:42:16\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '660d6ac7f208d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'umas14pat3lib5roqevptplopl', 'ProdutoForm', 'apache2handler', '660d6ac75284d', '2024', '04', '03'),
	(109, '2024-04-03 23:53:10', 'admin', 'kraftsoft', 'INSERT INTO caixa (system_users_abertura_id, data_hora_abertura, system_users_operador_id, caixa_situacao_id, system_unit_id, criado_em) VALUES (\'1\', \'2024-04-03 20:53:10\', \'1\', \'1\', \'1\', \'2024-04-03 20:53:10\')', 'INSERT', '127.0.0.1', '660debe6cf32c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cai...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cai...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\AberturaCaixaForm.php(108): Adianti\\Database\\TRecord->store()\n#3 [internal function]: AberturaCaixaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'umas14pat3lib5roqevptplopl', 'AberturaCaixaForm', 'apache2handler', '660debe6b3a46', '2024', '04', '03'),
	(110, '2024-04-19 18:31:36', 'admin', 'kraftsoft', 'INSERT INTO venda (venda_situacao_id, data_hora_venda, orcamento_id, data_prev_entrega, cliente_id, vendedor_id, filial_saida_id, venda_tipo_pagamento_id, observacao, observacao_nf, info_faturamento, criado_em, criado_por, alterado_em, alterado_por, tabela_preco_id, venda_modalidade_id, cliente_endereco_id, valor_produtos, frete_total, desconto, valor_total, peso_total, valor_troco, valor_avista, valor_aprazo, valor_comissao, comissao_avista, comissao_aprazo, system_unit_id) VALUES (\'1\', \'2024-04-19 15:29\', NULL, \'2024-04-19\', \'1\', \'1\', \'1\', \'1\', NULL, NULL, NULL, \'2024-04-19 15:31:36\', \'Administrador\', NULL, NULL, NULL, \'1\', NULL, \'950.00\', \'0.00\', \'0.00\', \'950.00\', \'0.00\', NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '6622b887dc09a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1236): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b886cb23c', '2024', '04', '19'),
	(111, '2024-04-19 18:31:36', 'admin', 'kraftsoft', 'INSERT INTO venda_formapgto (forma_pagamento_id, valor, venda_id, criado_em) VALUES (\'2\', \'500.00\', \'1\', \'2024-04-19 15:31:36\')', 'INSERT', '127.0.0.1', '6622b887dc09a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1254): VendaForm->storeMasterDetailItems(\'VendaFormapgto\', \'venda_id\', \'venda_formapgto...\', Object(Venda), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: VendaForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b886cb23c', '2024', '04', '19'),
	(112, '2024-04-19 18:31:36', 'admin', 'kraftsoft', 'INSERT INTO venda_formapgto (forma_pagamento_id, valor, venda_id, criado_em) VALUES (\'2\', \'950.00\', \'1\', \'2024-04-19 15:31:36\')', 'INSERT', '127.0.0.1', '6622b887dc09a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1254): VendaForm->storeMasterDetailItems(\'VendaFormapgto\', \'venda_id\', \'venda_formapgto...\', Object(Venda), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: VendaForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b886cb23c', '2024', '04', '19'),
	(113, '2024-04-19 18:31:36', 'admin', 'kraftsoft', 'DELETE FROM venda_formapgto WHERE (venda_id = \'1\' AND id not in (1,2))', 'DELETE', '127.0.0.1', '6622b887dc09a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1254): VendaForm->storeMasterDetailItems(\'VendaFormapgto\', \'venda_id\', \'venda_formapgto...\', Object(Venda), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: VendaForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b886cb23c', '2024', '04', '19'),
	(114, '2024-04-19 18:31:36', 'admin', 'kraftsoft', 'UPDATE venda SET venda_situacao_id = \'1\', data_hora_venda = \'2024-04-19 15:29\', orcamento_id = NULL, data_prev_entrega = \'2024-04-19\', cliente_id = \'1\', vendedor_id = \'1\', filial_saida_id = \'1\', venda_tipo_pagamento_id = \'1\', observacao = NULL, observacao_nf = NULL, info_faturamento = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:31:36\', alterado_por = NULL, tabela_preco_id = NULL, venda_modalidade_id = \'1\', cliente_endereco_id = NULL, valor_produtos = \'950.00\', frete_total = \'0.00\', desconto = \'0.00\', valor_total = \'950.00\', peso_total = \'0.00\', valor_troco = \'500,00\', valor_avista = \'0,00\', valor_aprazo = \'1.450,00\', valor_comissao = NULL, comissao_avista = NULL, comissao_aprazo = NULL, system_unit_id = \'1\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '6622b887dc09a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE venda SE...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE venda SE...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1294): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b886cb23c', '2024', '04', '19'),
	(115, '2024-04-19 18:32:04', 'admin', 'kraftsoft', 'INSERT INTO venda (venda_situacao_id, id, data_hora_venda, orcamento_id, data_prev_entrega, cliente_id, vendedor_id, filial_saida_id, venda_tipo_pagamento_id, observacao, observacao_nf, info_faturamento, criado_em, criado_por, alterado_em, alterado_por, tabela_preco_id, venda_modalidade_id, cliente_endereco_id, valor_produtos, frete_total, desconto, valor_total, peso_total, valor_troco, valor_avista, valor_aprazo, valor_comissao, comissao_avista, comissao_aprazo, system_unit_id) VALUES (\'1\', \'1\', \'2024-04-19 15:29\', NULL, \'2024-04-19\', \'1\', \'1\', \'1\', \'1\', NULL, NULL, NULL, \'2024-04-19 15:32:04\', \'Administrador\', \'2024-04-19 15:32:04\', \'Administrador\', NULL, \'1\', NULL, \'950.00\', \'0.00\', \'0.00\', \'950.00\', \'0.00\', NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '6622b8a469438', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1236): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b8a36e861', '2024', '04', '19'),
	(116, '2024-04-19 18:32:04', 'admin', 'kraftsoft', 'INSERT INTO venda_formapgto (forma_pagamento_id, id, valor, venda_id, criado_em) VALUES (\'2\', \'1\', \'500.00\', \'1\', \'2024-04-19 15:32:04\')', 'INSERT', '127.0.0.1', '6622b8a469438', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1254): VendaForm->storeMasterDetailItems(\'VendaFormapgto\', \'venda_id\', \'venda_formapgto...\', Object(Venda), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: VendaForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b8a36e861', '2024', '04', '19'),
	(117, '2024-04-19 18:32:04', 'admin', 'kraftsoft', 'INSERT INTO venda_formapgto (forma_pagamento_id, valor, venda_id, criado_em) VALUES (\'1\', \'450.00\', \'1\', \'2024-04-19 15:32:04\')', 'INSERT', '127.0.0.1', '6622b8a469438', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1254): VendaForm->storeMasterDetailItems(\'VendaFormapgto\', \'venda_id\', \'venda_formapgto...\', Object(Venda), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: VendaForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b8a36e861', '2024', '04', '19'),
	(118, '2024-04-19 18:32:04', 'admin', 'kraftsoft', 'DELETE FROM venda_formapgto WHERE (venda_id = \'1\' AND id not in (1,3))', 'DELETE', '127.0.0.1', '6622b8a469438', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1254): VendaForm->storeMasterDetailItems(\'VendaFormapgto\', \'venda_id\', \'venda_formapgto...\', Object(Venda), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: VendaForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b8a36e861', '2024', '04', '19'),
	(119, '2024-04-19 18:32:04', 'admin', 'kraftsoft', 'UPDATE venda SET venda_situacao_id = \'1\', data_hora_venda = \'2024-04-19 15:29\', orcamento_id = NULL, data_prev_entrega = \'2024-04-19\', cliente_id = \'1\', vendedor_id = \'1\', filial_saida_id = \'1\', venda_tipo_pagamento_id = \'1\', observacao = NULL, observacao_nf = NULL, info_faturamento = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:32:04\', alterado_por = \'Administrador\', tabela_preco_id = NULL, venda_modalidade_id = \'1\', cliente_endereco_id = NULL, valor_produtos = \'950.00\', frete_total = \'0.00\', desconto = \'0.00\', valor_total = \'950.00\', peso_total = \'0.00\', valor_troco = \'0,00\', valor_avista = \'0,00\', valor_aprazo = \'950,00\', valor_comissao = NULL, comissao_avista = NULL, comissao_aprazo = NULL, system_unit_id = \'1\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '6622b8a469438', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE venda SE...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE venda SE...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\VendaForm.php(1294): Adianti\\Database\\TRecord->store()\n#3 [internal function]: VendaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'VendaForm', 'apache2handler', '6622b8a36e861', '2024', '04', '19'),
	(120, '2024-04-19 18:32:54', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'2024-04-19\', \'1\', NULL, NULL, NULL, NULL, \'2024-04-19 15:32:54\', \'Administrador\', NULL, NULL, \'950.00\', \'0.00\', \'950.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6622b8d5c2488', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(858): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'OrcamentoForm', 'apache2handler', '6622b8d4f0105', '2024', '04', '19'),
	(121, '2024-04-19 18:32:54', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'2\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-04-19 15:32:54\')', 'INSERT', '127.0.0.1', '6622b8d5c2488', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(862): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'2\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'OrcamentoForm', 'apache2handler', '6622b8d4f0105', '2024', '04', '19'),
	(122, '2024-04-19 18:32:54', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'5\', \'1\', \'950.00\', NULL, NULL, \'950.00\', NULL, NULL, NULL, \'2\', \'2024-04-19 15:32:54\')', 'INSERT', '127.0.0.1', '6622b8d5c2488', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(882): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'OrcamentoForm', 'apache2handler', '6622b8d4f0105', '2024', '04', '19'),
	(123, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, criado_em, cpag_lancada) VALUES (\'1\', \'tmp/31230600328924000545550020009894361403898914-nfe.xml\', \'31230600328924000545550020009894361403898914\', \'2\', \'Venda Mercadoria\', 1, \'2\', \'989436\', \'2023-06-14 22:34:26\', \'2023-06-15 07:30:00\', 2, 1, 2, 1, 1, 2, \'IND V.2019\', \'48169520000159\', \'00328924000545\', \'BEBIDAS NOVA GERACAO LTDA\', \'0030773180010\', 3, \'AV. DAS INDUSTRIAS\', \'173\', NULL, \'DIST. INDUST\', \'3143302\', \'MONTES CLAROS\', \'MG\', \'39404621\', \'08006012355\', \'131235440033029\', \'2023-06-14 22:35:18\', NULL, NULL, \'MONTES CLAROS\', NULL, NULL, NULL, NULL, \'Administrador\', \'2024-04-19 15:33:42\', FALSE)', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1924): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(124, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'201106\', \'7894900531008\', \'AGUA CRYSTAL C/GAS 500ML 12X500ML\', \'22011000\', NULL, \'5405\', \'DZ\', \'1.0000\', \'17.2800\', \'17.28\', \'7894900531008\', \'UN\', \'12.0000\', \'1.44000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'18.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(125, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'201107\', \'7894900530001\', \'AGUA CRYSTAL S/GAS 500ML C/12 12X500ML\', \'22011000\', NULL, \'5405\', \'DZ\', \'10.0000\', \'15.3600\', \'153.60\', \'7894900530001\', \'UN\', \'120.0000\', \'1.28000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'18.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(126, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'055399\', \'7894900015034\', \'COCA COLA KS 290ML C/24 24X290ML\', \'22021000\', NULL, \'5405\', \'CX\', \'1.0000\', \'45.3600\', \'45.36\', \'7894900015034\', \'UN\', \'24.0000\', \'1.89000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'20.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'45.36\', \'1.8600\', \'0.84\', \'02\', \'45.36\', \'8.5400\', \'3.87\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(127, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'100415\', \'7894900011609\', \'COCA COLA PET 600ML C/6 06X600ML\', \'22021000\', NULL, \'5405\', \'FD\', \'3.0000\', \'24.0000\', \'72.00\', \'7894900011609\', \'UN\', \'18.0000\', \'4.00000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'20.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'72.00\', \'1.8600\', \'1.33\', \'02\', \'72.00\', \'8.5400\', \'6.14\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(128, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'118955\', \'7894900556056\', \'DV FRUT LARANJA PET 450ML C/6 06X450ML\', \'22021000\', NULL, \'5405\', \'FD\', \'1.0000\', \'17.1000\', \'17.10\', \'7894900556056\', \'UN\', \'6.0000\', \'2.85000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'18.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'17.10\', \'1.8600\', \'0.31\', \'02\', \'17.10\', \'8.5400\', \'1.46\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(129, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'118798\', \'7894900550054\', \'DV FRUT UVA PET 450ML C/6 06X450ML\', \'22021000\', NULL, \'5405\', \'FD\', \'1.0000\', \'17.1000\', \'17.10\', \'7894900550054\', \'UN\', \'6.0000\', \'2.85000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'18.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'17.10\', \'1.8600\', \'0.31\', \'02\', \'17.10\', \'8.5400\', \'1.46\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(130, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'139468\', \'7898367983615\', \'EISENBAHN 600ML C/24 RET 24X600ML\', \'22030000\', NULL, \'5405\', \'CX\', \'1.0000\', \'152.1600\', \'152.16\', \'7898367983615\', \'UN\', \'24.0000\', \'6.34000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'25.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'152.16\', \'1.8600\', \'2.83\', \'02\', \'152.16\', \'8.5400\', \'12.99\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(131, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'155441\', \'7894900030013\', \'FANTA LARANJA LATA 350ML C/12 12X350ML\', \'22021000\', NULL, \'5405\', \'DZ\', \'1.0000\', \'31.8000\', \'31.80\', \'7894900030013\', \'UN\', \'12.0000\', \'2.65000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'20.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'31.80\', \'1.8600\', \'0.59\', \'02\', \'31.80\', \'8.5400\', \'2.71\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(132, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'155761\', \'7894900050226\', \'FANTA UVA LT 350ML L+P- C/06 06X350ML\', \'22021000\', NULL, \'5405\', \'FD\', \'1.0000\', \'15.9000\', \'15.90\', \'7894900050226\', \'UN\', \'6.0000\', \'2.65000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'20.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'15.90\', \'1.8600\', \'0.29\', \'02\', \'15.90\', \'8.5400\', \'1.35\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(133, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'139649\', \'7896371000175\', \'THEREZOPOLIS GOLD LN 355ML 06X355ML\', \'22030000\', NULL, \'5405\', \'CX\', \'2.0000\', \'26.0400\', \'52.08\', \'7896371000175\', \'UN\', \'12.0000\', \'4.34000000\', 0, 0, 0, 0, NULL, NULL, 1, \'60\', NULL, 0, 0, 0, 0, \'23.00\', 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, \'02\', \'52.08\', \'1.8600\', \'0.96\', \'02\', \'52.08\', \'8.5400\', \'4.44\', \'6\', \'2024-04-19 15:33:42\')', 'INSERT', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(134, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = \'1\', xml = \'tmp/31230600328924000545550020009894361403898914-nfe.xml\', chave = \'31230600328924000545550020009894361403898914\', nota_fiscal_compra_situacao_id = \'2\', natop = \'Venda Mercadoria\', notafiscal_mod_id = 1, serie = \'2\', numero = \'989436\', data_emissao = \'2023-06-14 22:34:26\', data_saida = \'2023-06-15 07:30:00\', notafiscal_tipodocumento_id = 2, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'IND V.2019\', dest_cnpj = \'48169520000159\', cliente_cpfcnpj = \'00328924000545\', cliente_nome = \'BEBIDAS NOVA GERACAO LTDA\', cliente_inscest = \'0030773180010\', notafiscal_crt_id = 3, cliente_endereco = \'AV. DAS INDUSTRIAS\', cliente_numero = \'173\', cliente_complemento = NULL, cliente_bairro = \'DIST. INDUST\', cliente_cidade_codibge = \'3143302\', cliente_cidade = \'MONTES CLAROS\', cliente_estado = \'MG\', cliente_cep = \'39404621\', cliente_fone = \'08006012355\', protocolo_envio = \'131235440033029\', data_hora_envio = \'2023-06-14 22:35:18\', transp_nome = NULL, transp_endereco = NULL, transp_cidade = \'MONTES CLAROS\', transp_uf = NULL, transp_placaveiculo = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, criado_por = \'Administrador\', cpag_lancada = FALSE, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA CRYSTAL C/GAS 500ML 12X500ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA CRYSTAL S/GAS 500ML C/12 12X500ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COCA COLA KS 290ML C/24 24X290ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COCA COLA PET 600ML C/6 06X600ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto DV FRUT LARANJA PET 450ML C/6 06X450ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto DV FRUT UVA PET 450ML C/6 06X450ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto EISENBAHN 600ML C/24 RET 24X600ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FANTA LARANJA LATA 350ML C/12 12X350ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FANTA UVA LT 350ML L+P- C/06 06X350ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto THEREZOPOLIS GOLD LN 355ML 06X355ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', alterado_em = \'2024-04-19 15:33:42\' WHERE (id = \'6\')', 'UPDATE', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2150): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(135, '2024-04-19 18:33:42', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = NULL, numero = \'989436\', data_emissao = \'2023-06-14 22:34:26\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:33:42\', natop = \'Venda Mercadoria\', data_saida = \'2023-06-15 07:30:00\', infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'2\', valor_total_produtos = 574.38, valor_total_nota = 574.38, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = \'MONTES CLAROS\', transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = 2, notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA CRYSTAL C/GAS 500ML 12X500ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA CRYSTAL S/GAS 500ML C/12 12X500ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COCA COLA KS 290ML C/24 24X290ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COCA COLA PET 600ML C/6 06X600ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto DV FRUT LARANJA PET 450ML C/6 06X450ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto DV FRUT UVA PET 450ML C/6 06X450ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto EISENBAHN 600ML C/24 RET 24X600ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FANTA LARANJA LATA 350ML C/12 12X350ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FANTA UVA LT 350ML L+P- C/06 06X350ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto THEREZOPOLIS GOLD LN 355ML 06X355ML desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV. DAS INDUSTRIAS\', cliente_complemento = NULL, cliente_numero = \'173\', cliente_bairro = \'DIST. INDUST\', cliente_cidade = \'MONTES CLAROS\', cliente_cep = \'39404621\', cliente_estado = \'MG\', cliente_nome = \'BEBIDAS NOVA GERACAO LTDA\', cliente_cpfcnpj = \'00328924000545\', cliente_inscest = \'0030773180010\', cliente_fone = \'08006012355\', cliente_cidade_codibge = \'3143302\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230600328924000545550020009894361403898914\', protocolo_envio = \'131235440033029\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 0, pis_valor = 7.46, cofins_valor = 34.42, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 2, verproc = \'IND V.2019\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230600328924000545550020009894361403898914-nfe.xml\', data_hora_envio = \'2023-06-14 22:35:18\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 6)', 'UPDATE', '127.0.0.1', '6622b905d8945', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1564): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2152): NotaFiscalCompra::atualiza_totais_nota(\'6\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230600328...\')\n#5 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b905aa2c1', '2024', '04', '19'),
	(136, '2024-04-19 18:35:15', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET deletado_em = \'2024-04-19 15:35:15\' WHERE (id = 6)', 'UPDATE', '127.0.0.1', '6622b9633d442', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(1159): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraList.php(353): Adianti\\Database\\TRecord->delete()\n#3 [internal function]: NotaFiscalCompraList->onDelete(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraList.php(856): Adianti\\Control\\TPage->show()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): NotaFiscalCompraList->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraList', 'apache2handler', '6622b9629c1de', '2024', '04', '19'),
	(137, '2024-04-19 18:35:22', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (system_unit_id, xml, chave, nota_fiscal_compra_situacao_id, natop, notafiscal_mod_id, serie, numero, data_emissao, data_saida, notafiscal_tipodocumento_id, notafiscal_iddest_id, notafiscal_tpimp_id, notafiscal_finnfe_id, notafiscal_indfinal_id, notafiscal_indpres_id, verproc, dest_cnpj, cliente_cpfcnpj, cliente_nome, cliente_inscest, notafiscal_crt_id, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade_codibge, cliente_cidade, cliente_estado, cliente_cep, cliente_fone, protocolo_envio, data_hora_envio, transp_nome, transp_endereco, transp_cidade, transp_uf, transp_placaveiculo, transp_veiculouf, transp_veiculorntc, criado_por, criado_em, cpag_lancada) VALUES (\'1\', \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', \'31230604641376015915550010000180451000180469\', \'2\', \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', 1, \'1\', \'18045\', \'2023-06-03 00:00:00\', NULL, 2, 1, 2, 1, 1, 1, \'1.0.0.0\', \'48169520000159\', \'04641376015915\', \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', \'0020488295661\', 3, \'AV UM LOTE 10 QUAD 8\', \'48\', NULL, \'LOTEAMENTO RESIDENCIAL PARK SUL\', \'3107307\', \'BOCAIUVA\', \'MG\', \'39390000\', \'3131172600\', \'131235419061517\', \'2023-06-03 16:46:12\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'Administrador\', \'2024-04-19 15:35:22\', FALSE)', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1924): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(138, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'270054\', \'7893595535100\', \'FEIJAO CARIOCA TIA GRAM 1KG\', \'07133399\', NULL, \'5929\', \'PT\', \'3.0000\', \'6.9900000000\', \'20.97\', \'7893595535100\', \'PT\', \'3.0000\', \'6.9900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(139, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'188471\', \'7898507968748\', \'LARANJA PERA RIO 10KG PT\', \'08051000\', NULL, \'5929\', \'PT\', \'1.0000\', \'25.9000000000\', \'25.90\', \'7898507968748\', \'PT\', \'1.0000\', \'25.9000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(140, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'89506\', \'7896029046296\', \'RACAO GATOS WHISKAS SALMAO 85G SH\', \'23091000\', NULL, \'5929\', \'SH\', \'1.0000\', \'3.2900000000\', \'3.29\', \'7896029046296\', \'SH\', \'1.0000\', \'3.2900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(141, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'232210\', \'7898949747765\', \'COUVE FLOR NECTAR 300G BJ\', \'07041000\', NULL, \'5929\', \'BJ\', \'2.0000\', \'13.9800000000\', \'27.96\', \'7898949747765\', \'BJ\', \'2.0000\', \'13.9800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(142, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'87250\', \'7898949747284\', \'PIMENTA BIQUINHO NECTAR VITA 200G BJ\', \'07096000\', NULL, \'5929\', \'BJ\', \'2.0000\', \'5.9900000000\', \'11.98\', \'7898949747284\', \'BJ\', \'2.0000\', \'5.9900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(143, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'257183\', \'7896029046623\', \'RACAO GATOS WHISKAS CASTR.CARNE 85G\', \'23099010\', NULL, \'5929\', \'SH\', \'1.0000\', \'3.2900000000\', \'3.29\', \'7896029046623\', \'SH\', \'1.0000\', \'3.2900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(144, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'6745\', \'0000000067454\', \'CENOURA VERMELHA KG\', \'07061000\', NULL, \'5929\', \'KG\', \'1.6100\', \'4.9800000000\', \'8.02\', \'0000000067454\', \'KG\', \'1.6100\', \'4.9800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(145, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'10808\', \'7896417204239\', \'MAC.VILMA OVOS LINGUINE 500G PT\', \'19021100\', NULL, \'5929\', \'PT\', \'5.0000\', \'4.7800000000\', \'23.90\', \'7896417204239\', \'PT\', \'5.0000\', \'4.7800000000\', 0, 0, \'1.40\', 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(146, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'9684\', \'7896104999905\', \'GUARD.MILI 21X22CM PT\', \'48183000\', NULL, \'5929\', \'PT\', \'7.0000\', \'1.6500000000\', \'11.55\', \'7896104999905\', \'PT\', \'7.0000\', \'1.6500000000\', 0, 0, \'0.49\', 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(147, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'103186\', \'7896051111023\', \'LEITE L.V.BH INTEG.1L TP\', \'04012010\', NULL, \'5929\', \'TP\', \'2.0000\', \'4.2800000000\', \'8.56\', \'7896051111023\', \'TP\', \'2.0000\', \'4.2800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(148, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'73200\', \'7896029046197\', \'RACAO GATOS WHISKAS CORDEIRO 85G SH\', \'23091000\', NULL, \'5929\', \'SH\', \'1.0000\', \'3.2900000000\', \'3.29\', \'7896029046197\', \'SH\', \'1.0000\', \'3.2900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(149, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'263859\', \'7891132009367\', \'SAL CHURRASCO AJI SAL 2KG PT\', \'21039029\', NULL, \'5929\', \'PT\', \'1.0000\', \'26.7000000000\', \'26.70\', \'7891132009367\', \'PT\', \'1.0000\', \'26.7000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(150, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'10717\', \'7891050000101\', \'WHISKY PASSPORT 1L GF\', \'22083020\', NULL, \'5929\', \'GF\', \'1.0000\', \'64.9000000000\', \'64.90\', \'7891050000101\', \'GF\', \'1.0000\', \'64.9000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(151, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'266165\', \'7896029046555\', \'RACAO GATOS WHISKAS CASTR.PEIXE 85G SH\', \'23091000\', NULL, \'5929\', \'SH\', \'1.0000\', \'3.2900000000\', \'3.29\', \'7896029046555\', \'SH\', \'1.0000\', \'3.2900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(152, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'6716\', \'0000000067164\', \'BACON SADIA MANTA VACUO KG BAKN\', \'02101900\', NULL, \'5929\', \'KG\', \'3.0260\', \'26.9800000000\', \'81.64\', \'0000000067164\', \'KG\', \'3.0260\', \'26.9800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(153, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'12091\', \'7896417204437\', \'MAC.VILMA OVOS ESPAG.N9 500G PT\', \'19021100\', NULL, \'5929\', \'PT\', \'1.0000\', \'4.7800000000\', \'4.78\', \'7896417204437\', \'PT\', \'1.0000\', \'4.7800000000\', 0, 0, \'0.28\', 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(154, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'147363\', \'7896716311669\', \'LINGUICA PAMPLONA CALAB.1KG PT\', \'16010000\', NULL, \'5929\', \'PT\', \'4.0000\', \'18.9800000000\', \'75.92\', \'7896716311669\', \'PT\', \'4.0000\', \'18.9800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(155, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'88994\', \'0000000199933\', \'PIMENTAO AMARELO/VERMELHO KG\', \'07096000\', NULL, \'5929\', \'KG\', \'2.4700\', \'17.6800000000\', \'43.67\', \'0000000199933\', \'KG\', \'2.4700\', \'17.6800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(156, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'6424\', \'0000000064248\', \'TOMATE LONGA VIDA KG\', \'07020000\', NULL, \'5929\', \'KG\', \'3.4350\', \'7.8900000000\', \'27.10\', \'0000000064248\', \'KG\', \'3.4350\', \'7.8900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(157, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'132120\', \'7898921567411\', \'BATATA CONG.UAI 2KG PT\', \'20041000\', NULL, \'5929\', \'PT\', \'5.0000\', \'23.9800000000\', \'119.90\', \'7898921567411\', \'PT\', \'5.0000\', \'23.9800000000\', 0, 0, \'6.00\', 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(158, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'49651\', \'7896035210001\', \'SAL REFINADO CISNE 1KG PT\', \'25010020\', NULL, \'5929\', \'PT\', \'2.0000\', \'3.9800000000\', \'7.96\', \'7896035210001\', \'PT\', \'2.0000\', \'3.9800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(159, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'6741\', \'0000000067416\', \'CEBOLA AMARELA KG\', \'07031019\', NULL, \'5929\', \'KG\', \'2.2250\', \'4.9800000000\', \'11.08\', \'0000000067416\', \'KG\', \'2.2250\', \'4.9800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(160, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'88147\', \'7896029047279\', \'RACAO GATOS WHISKAS FILHOTE FRANGO 85G\', \'23099010\', NULL, \'5929\', \'SH\', \'1.0000\', \'3.2900000000\', \'3.29\', \'7896029047279\', \'SH\', \'1.0000\', \'3.2900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(161, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'258498\', \'7898904964077\', \'OVOS BCOS.SOMAI JUMBO C/40 CX\', \'04071100\', NULL, \'5929\', \'CX\', \'1.0000\', \'39.9000000000\', \'39.90\', \'7898904964077\', \'CX\', \'1.0000\', \'39.9000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(162, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'2261\', \'7896389905110\', \'FARINHA MAND.XAP CRUA 1KG PT\', \'11062000\', NULL, \'5929\', \'PT\', \'2.0000\', \'5.7800000000\', \'11.56\', \'7896389905110\', \'PT\', \'2.0000\', \'5.7800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(163, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'73197\', \'7896029077641\', \'RACAO GATOS WHISKAS ATUM 85G SH\', \'23099010\', NULL, \'5929\', \'SH\', \'1.0000\', \'3.2900000000\', \'3.29\', \'7896029077641\', \'SH\', \'1.0000\', \'3.2900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(164, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'141518\', \'7898915457063\', \'AGUA SANIT.BH 5L FR\', \'28289011\', NULL, \'5929\', \'FR\', \'1.0000\', \'8.9500000000\', \'8.95\', \'7898915457063\', \'FR\', \'1.0000\', \'8.9500000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(165, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'278525\', \'7896104992487\', \'TOALHA PAP.MILI GRAN CHEF C/200 PT\', \'48189090\', NULL, \'5929\', \'PT\', \'3.0000\', \'6.9000000000\', \'20.70\', \'7896104992487\', \'PT\', \'3.0000\', \'6.9000000000\', 0, 0, \'1.05\', 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(166, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'160427\', \'7898949747611\', \'BROCOLIS NINJA NECTAR VITA 200G BJ\', \'07041000\', NULL, \'5929\', \'BJ\', \'2.0000\', \'11.9800000000\', \'23.96\', \'7898949747611\', \'BJ\', \'2.0000\', \'11.9800000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(167, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'180578\', \'7897121000766\', \'ALHO FRITO ALHO ROXO 400G PT\', \'20059900\', NULL, \'5929\', \'PT\', \'1.0000\', \'23.9900000000\', \'23.99\', \'7897121000766\', \'PT\', \'1.0000\', \'23.9900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(168, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'6580\', \'7896242200048\', \'OLEO SOJA ABC 900ML FR\', \'15079011\', NULL, \'5929\', \'FR\', \'20.0000\', \'4.9900000000\', \'99.80\', \'7896242200048\', \'FR\', \'20.0000\', \'4.9900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(169, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'7131\', \'0000000071314\', \'TOMATE ITALIANO ANDREA KG\', \'07020000\', NULL, \'5929\', \'KG\', \'1.2150\', \'7.8900000000\', \'9.59\', \'0000000071314\', \'KG\', \'1.2150\', \'7.8900000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'06\', 0, 0, 0, \'06\', 0, 0, 0, \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(170, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, cean, xprod, ncm, nve, cfop, ucom, qcom, vuncom, vprod, ceantrib, utrib, qtrib, vuntrib, vfrete, vseg, vdesc, voutro, xped, nitemped, notafiscal_item_orig_id, icms_cst, notafiscal_item_modbc_id, icms_predbc, icms_basecalc, icms_aliquota, icms_valor, icms_pst, icms_vbcst, icms_picmsst, icms_vicmsst, icms_pcredsn, icms_vcredicmssn, icms_predbcst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, pis_cst, pis_valor_base, pis_aliquota, pis_valor, cofins_cst, cofins_valor_base, cofins_aliquota, cofins_valor, nota_fiscal_compra_id, criado_em) VALUES (\'271852\', \'7899306041724\', \'RACAO GATOS BAW WAW MIX 900G PT\', \'23099010\', NULL, \'5929\', \'PT\', \'1.0000\', \'19.9000000000\', \'19.90\', \'7899306041724\', \'PT\', \'1.0000\', \'19.9000000000\', 0, 0, 0, 0, NULL, NULL, 1, \'40\', NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, \'99\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'01\', \'0.00\', \'0.0000\', \'0.00\', \'7\', \'2024-04-19 15:35:23\')', 'INSERT', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2062): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(171, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = \'1\', xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', chave = \'31230604641376015915550010000180451000180469\', nota_fiscal_compra_situacao_id = \'2\', natop = \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', notafiscal_mod_id = 1, serie = \'1\', numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', data_saida = NULL, notafiscal_tipodocumento_id = 2, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', dest_cnpj = \'48169520000159\', cliente_cpfcnpj = \'04641376015915\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_inscest = \'0020488295661\', notafiscal_crt_id = 3, cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_numero = \'48\', cliente_complemento = NULL, cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade_codibge = \'3107307\', cliente_cidade = \'BOCAIUVA\', cliente_estado = \'MG\', cliente_cep = \'39390000\', cliente_fone = \'3131172600\', protocolo_envio = \'131235419061517\', data_hora_envio = \'2023-06-03 16:46:12\', transp_nome = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_uf = NULL, transp_placaveiculo = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, criado_por = \'Administrador\', cpag_lancada = FALSE, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto ALHO FRITO ALHO ROXO 400G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OLEO SOJA ABC 900ML FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE ITALIANO ANDREA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS BAW WAW MIX 900G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', alterado_em = \'2024-04-19 15:35:23\' WHERE (id = \'7\')', 'UPDATE', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2150): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#4 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(172, '2024-04-19 18:35:23', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = NULL, numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:35:23\', natop = \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = 2, notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto ALHO FRITO ALHO ROXO 400G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OLEO SOJA ABC 900ML FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE ITALIANO ANDREA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS BAW WAW MIX 900G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622b96ab0d47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1564): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(2152): NotaFiscalCompra::atualiza_totais_nota(\'7\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraImportarXML.php(76): NotaFiscalCompra::ImportarArquivoXML(Object(LeituraXmlNFe), \'tmp/31230604641...\')\n#5 [internal function]: NotaFiscalCompraImportarXML::onUploadXML(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraImportarXML', 'apache2handler', '6622b96a8e829', '2024', '04', '19'),
	(173, '2024-04-19 18:35:45', 'admin', 'kraftsoft', 'INSERT INTO api_error (url, error_message) VALUES (\'/cep/api/v1/39390000\', NULL)', 'INSERT', '127.0.0.1', '6622b98088b2a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO api...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO api...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\service\\php_services\\CEPService.php(25): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(161): CEPService::get(\'39390000\')\n#4 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '6622b9804387a', '2024', '04', '19'),
	(174, '2024-04-19 18:35:45', 'admin', 'kraftsoft', 'INSERT INTO fornecedor (nome, razao_social, cpf_cnpj, pessoa_tipo_id, insc_estadual, insc_municipal, fone, logradouro, cep, numero, bairro, complemento, criado_por, criado_em) VALUES (\'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', \'04.641.376/0159-15\', \'2\', \'0020488295661\', NULL, \'3131172600\', \'AV UM LOTE 10 QUAD 8\', \'39390000\', \'48\', \'LOTEAMENTO RESIDENCIAL PARK SUL\', NULL, \'Administrador\', \'2024-04-19 15:35:45\')', 'INSERT', '127.0.0.1', '6622b98088b2a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO for...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO for...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(175): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '6622b9804387a', '2024', '04', '19'),
	(175, '2024-04-19 18:35:45', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = \'2\', numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:35:45\', natop = \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = 2, notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-Fornecedor desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto ALHO FRITO ALHO ROXO 400G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OLEO SOJA ABC 900ML FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE ITALIANO ANDREA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS BAW WAW MIX 900G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622b98088b2a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(180): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '6622b9804387a', '2024', '04', '19'),
	(176, '2024-04-19 18:35:45', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 2, numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:35:45\', natop = \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'2\', notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto ALHO FRITO ALHO ROXO 400G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OLEO SOJA ABC 900ML FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE ITALIANO ANDREA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS BAW WAW MIX 900G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622b98088b2a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1756): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularFornecedor.php(183): NotaFiscalCompra::AnalisaVinculosNota(7)\n#4 [internal function]: NotaFiscalCompraVincularFornecedor->onBtnCadastrarNovoFornecedor(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularFornecedor', 'apache2handler', '6622b9804387a', '2024', '04', '19'),
	(177, '2024-04-19 18:36:18', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'RACAO GATOS BAW WAW MIX 900G PT\', \'23099010\', \'49\', \'1\', \'Administrador\', \'2024-04-19 15:36:18\')', 'INSERT', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9a1d6cba', '2024', '04', '19'),
	(178, '2024-04-19 18:36:19', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, preco_venda, criado_em) VALUES (\'1\', \'6\', \'2\', 0, 0, \'2024-04-19 15:36:19\')', 'INSERT', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9a1d6cba', '2024', '04', '19'),
	(179, '2024-04-19 18:36:19', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_itens SET nota_fiscal_compra_id = 7, produto_id = \'6\', nota_fiscal_compra_itens_situacao_id = NULL, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-04-19 15:36:19\', nitem = NULL, cean = \'7899306041724\', xprod = \'RACAO GATOS BAW WAW MIX 900G PT\', ncm = \'23099010\', nve = NULL, extipi = NULL, cfop = \'5929\', ucom = \'PT\', qcom = 1, vuncom = 19.9, vprod = 19.9, ceantrib = \'7899306041724\', utrib = \'PT\', qtrib = 1, vuntrib = 19.9, vfrete = 0, vseg = 0, vdesc = 0, vtottrib = NULL, xped = NULL, nitemped = NULL, notafiscal_item_indtot_id = NULL, notafiscal_item_orig_id = 1, notafiscal_item_modbc_id = NULL, icms_basecalc = 0, icms_cst = \'40\', icms_valor = 0, icms_aliquota = 0, icms_pcredsn = 0, icms_vcredicmssn = 0, icms_predbc = 0, icms_pst = 0, icms_pmvast = NULL, icms_predbcst = 0, icms_vbcst = 0, icms_picmsst = 0, icms_vicmsst = 0, fcp_pfcp = NULL, pis_cst = \'01\', pis_valor = 0, pis_aliquota = 0, pis_valor_base = 0, cofins_cst = \'01\', cofins_valor_base = 0, cofins_aliquota = 0, cofins_valor = 0, voutro = 0, infadprod = NULL, notafiscal_item_motDesICMS_id = NULL, cprod = \'271852\', ipi_cst = \'99\', ipi_valor_base = 0, ipi_aliquota = 0, ipi_vipidevol = NULL, ipi_valor = 0, ipi_pdevol = NULL, estoque_deposito_id = \'2\', produto_lote_id = NULL WHERE (id = 44)', 'UPDATE', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(167): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9a1d6cba', '2024', '04', '19'),
	(180, '2024-04-19 18:36:19', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 2, numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:36:19\', natop = \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'2\', notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto ALHO FRITO ALHO ROXO 400G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OLEO SOJA ABC 900ML FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE ITALIANO ANDREA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622b9a27363a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1756): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(170): NotaFiscalCompra::AnalisaVinculosNota(7)\n#4 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9a1d6cba', '2024', '04', '19'),
	(181, '2024-04-19 18:36:32', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'TOMATE ITALIANO ANDREA KG\', \'07020000\', \'26\', \'1\', \'Administrador\', \'2024-04-19 15:36:32\')', 'INSERT', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9afa700f', '2024', '04', '19'),
	(182, '2024-04-19 18:36:32', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, preco_venda, criado_em) VALUES (\'1\', \'7\', \'2\', 0, 0, \'2024-04-19 15:36:32\')', 'INSERT', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9afa700f', '2024', '04', '19'),
	(183, '2024-04-19 18:36:32', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_itens SET nota_fiscal_compra_id = 7, produto_id = \'7\', nota_fiscal_compra_itens_situacao_id = NULL, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-04-19 15:36:32\', nitem = NULL, cean = \'0000000071314\', xprod = \'TOMATE ITALIANO ANDREA KG\', ncm = \'07020000\', nve = NULL, extipi = NULL, cfop = \'5929\', ucom = \'KG\', qcom = 1.215, vuncom = 7.89, vprod = 9.59, ceantrib = \'0000000071314\', utrib = \'KG\', qtrib = 1.215, vuntrib = 7.89, vfrete = 0, vseg = 0, vdesc = 0, vtottrib = NULL, xped = NULL, nitemped = NULL, notafiscal_item_indtot_id = NULL, notafiscal_item_orig_id = 1, notafiscal_item_modbc_id = NULL, icms_basecalc = 0, icms_cst = \'40\', icms_valor = 0, icms_aliquota = 0, icms_pcredsn = 0, icms_vcredicmssn = 0, icms_predbc = 0, icms_pst = 0, icms_pmvast = NULL, icms_predbcst = 0, icms_vbcst = 0, icms_picmsst = 0, icms_vicmsst = 0, fcp_pfcp = NULL, pis_cst = \'06\', pis_valor = 0, pis_aliquota = 0, pis_valor_base = 0, cofins_cst = \'06\', cofins_valor_base = 0, cofins_aliquota = 0, cofins_valor = 0, voutro = 0, infadprod = NULL, notafiscal_item_motDesICMS_id = NULL, cprod = \'7131\', ipi_cst = \'99\', ipi_valor_base = 0, ipi_aliquota = 0, ipi_vipidevol = NULL, ipi_valor = 0, ipi_pdevol = NULL, estoque_deposito_id = \'2\', produto_lote_id = NULL WHERE (id = 43)', 'UPDATE', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(167): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9afa700f', '2024', '04', '19'),
	(184, '2024-04-19 18:36:32', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 2, numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:36:32\', natop = \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'2\', notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto ALHO FRITO ALHO ROXO 400G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OLEO SOJA ABC 900ML FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622b9b013c45', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1756): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(170): NotaFiscalCompra::AnalisaVinculosNota(7)\n#4 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9afa700f', '2024', '04', '19'),
	(185, '2024-04-19 18:37:04', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'OLEO SOJA ABC 900ML FR\', \'15079011\', \'49\', \'1\', \'Administrador\', \'2024-04-19 15:37:04\')', 'INSERT', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9cf9f140', '2024', '04', '19'),
	(186, '2024-04-19 18:37:04', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, preco_venda, criado_em) VALUES (\'1\', \'8\', \'2\', 0, 0, \'2024-04-19 15:37:04\')', 'INSERT', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9cf9f140', '2024', '04', '19'),
	(187, '2024-04-19 18:37:04', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_itens SET nota_fiscal_compra_id = 7, produto_id = \'8\', nota_fiscal_compra_itens_situacao_id = NULL, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-04-19 15:37:04\', nitem = NULL, cean = \'7896242200048\', xprod = \'OLEO SOJA ABC 900ML FR\', ncm = \'15079011\', nve = NULL, extipi = NULL, cfop = \'5929\', ucom = \'FR\', qcom = 20, vuncom = 4.99, vprod = 99.8, ceantrib = \'7896242200048\', utrib = \'FR\', qtrib = 20, vuntrib = 4.99, vfrete = 0, vseg = 0, vdesc = 0, vtottrib = NULL, xped = NULL, nitemped = NULL, notafiscal_item_indtot_id = NULL, notafiscal_item_orig_id = 1, notafiscal_item_modbc_id = NULL, icms_basecalc = 0, icms_cst = \'40\', icms_valor = 0, icms_aliquota = 0, icms_pcredsn = 0, icms_vcredicmssn = 0, icms_predbc = 0, icms_pst = 0, icms_pmvast = NULL, icms_predbcst = 0, icms_vbcst = 0, icms_picmsst = 0, icms_vicmsst = 0, fcp_pfcp = NULL, pis_cst = \'06\', pis_valor = 0, pis_aliquota = 0, pis_valor_base = 0, cofins_cst = \'06\', cofins_valor_base = 0, cofins_aliquota = 0, cofins_valor = 0, voutro = 0, infadprod = NULL, notafiscal_item_motDesICMS_id = NULL, cprod = \'6580\', ipi_cst = \'99\', ipi_valor_base = 0, ipi_aliquota = 0, ipi_vipidevol = NULL, ipi_valor = 0, ipi_pdevol = NULL, estoque_deposito_id = \'2\', produto_lote_id = NULL WHERE (id = 42)', 'UPDATE', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(167): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9cf9f140', '2024', '04', '19'),
	(188, '2024-04-19 18:37:04', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 2, numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:37:04\', natop = \'LANCAMENTO EFET DECORRENCIA EMISSAO CUPOM FISCAL\', data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'2\', notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto ALHO FRITO ALHO ROXO 400G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622b9cfd4ca0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1756): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(170): NotaFiscalCompra::AnalisaVinculosNota(7)\n#4 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622b9cf9f140', '2024', '04', '19'),
	(189, '2024-04-19 18:38:55', 'admin', 'kraftsoft', 'INSERT INTO estoque_lancamentos (produto_id, estoque_tipo_movimentacao_id, estoque_deposito_id, produto_lote_id, quantidade, observacao, estoque_origem_id, system_unit_id, data_lancamento, preco_venda, preco_custo, criado_por, criado_em) VALUES (\'8\', \'1\', \'2\', NULL, \'50.00\', \'hfhfghfghfghfg\', \'1\', \'1\', \'2024-04-19\', 0, NULL, \'Administrador\', \'2024-04-19 15:38:55\')', 'INSERT', '127.0.0.1', '6622ba3f38f47', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO est...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO est...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\estoque\\EstoqueLancamentosForm.php(204): Adianti\\Database\\TRecord->store()\n#3 [internal function]: EstoqueLancamentosForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'EstoqueLancamentosForm', 'apache2handler', '6622ba3eddbdd', '2024', '04', '19'),
	(190, '2024-04-19 18:44:16', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET nota_fiscal_compra_situacao_id = \'2\', numero = \'18045\', serie = \'1\', data_emissao = \'2023-06-03 00:00\', data_saida = NULL, notafiscal_mod_id = \'1\', natop = NULL, notafiscal_finnfe_id = \'1\', notafiscal_indpres_id = \'1\', notafiscal_modfrete_id = NULL, chave = \'31230604641376015915550010000180451000180469\', infcpl = NULL, infadfisco = NULL, criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:44:16\', alterado_por = \'Administrador\', notafiscal_indfinal_id = \'1\', notafiscal_tipodocumento_id = \'2\', notafiscal_iddest_id = \'1\', fornecedor_id = \'2\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_inscmuni = NULL, notafiscal_crt_id = \'3\', notafiscal_indiedest_id = NULL, cliente_cep = \'39390000\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_numero = \'48\', cliente_complemento = NULL, cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_estado = \'MG\', cliente_cidade_codibge = \'3107307\', notafiscal_indpag_id = NULL, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, icms_basecalc = \'0.00\', icms_valor = \'0.00\', icms_subst_base_calc = \'0.00\', icms_subst_valor = \'0.00\', frete_valor = \'0.00\', seguro_valor = \'0.00\', ipi_valor = \'0.00\', desconto_valor = \'9.22\', outras_despesas = \'0.00\', ipi_vipidevol = \'0.00\', valor_total_produtos = \'880.58\', valor_total_nota = \'871.36\', vtroco = NULL WHERE (id = \'7\')', 'UPDATE', '127.0.0.1', '6622bb80a0d2f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(970): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraForm', 'apache2handler', '6622bb7fc0df9', '2024', '04', '19'),
	(191, '2024-04-19 18:44:16', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_dup SET deletado_em = \'2024-04-19 15:44:16\' WHERE (nota_fiscal_compra_id = \'7\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6622bb80a0d2f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(980): NotaFiscalCompraForm->storeMasterDetailItems(\'NotaFiscalCompr...\', \'nota_fiscal_com...\', \'nota_fiscal_com...\', Object(NotaFiscalCompra), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraForm', 'apache2handler', '6622bb7fc0df9', '2024', '04', '19'),
	(192, '2024-04-19 18:44:16', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_pag SET deletado_em = \'2024-04-19 15:44:16\' WHERE (nota_fiscal_compra_id = \'7\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6622bb80a0d2f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(988): NotaFiscalCompraForm->storeMasterDetailItems(\'NotaFiscalCompr...\', \'nota_fiscal_com...\', \'nota_fiscal_com...\', Object(NotaFiscalCompra), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraForm', 'apache2handler', '6622bb7fc0df9', '2024', '04', '19'),
	(193, '2024-04-19 18:45:48', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'ALHO FRITO ALHO ROXO 400G PT\', \'20059900\', \'49\', \'1\', \'Administrador\', \'2024-04-19 15:45:48\')', 'INSERT', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbdbeb051', '2024', '04', '19'),
	(194, '2024-04-19 18:45:48', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, preco_venda, criado_em) VALUES (\'1\', \'9\', \'2\', 0, 0, \'2024-04-19 15:45:48\')', 'INSERT', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbdbeb051', '2024', '04', '19'),
	(195, '2024-04-19 18:45:48', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_itens SET nota_fiscal_compra_id = 7, produto_id = \'9\', nota_fiscal_compra_itens_situacao_id = NULL, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-04-19 15:45:48\', nitem = NULL, cean = \'7897121000766\', xprod = \'ALHO FRITO ALHO ROXO 400G PT\', ncm = \'20059900\', nve = NULL, extipi = NULL, cfop = \'5929\', ucom = \'PT\', qcom = 1, vuncom = 23.99, vprod = 23.99, ceantrib = \'7897121000766\', utrib = \'PT\', qtrib = 1, vuntrib = 23.99, vfrete = 0, vseg = 0, vdesc = 0, vtottrib = NULL, xped = NULL, nitemped = NULL, notafiscal_item_indtot_id = NULL, notafiscal_item_orig_id = 1, notafiscal_item_modbc_id = NULL, icms_basecalc = 0, icms_cst = \'40\', icms_valor = 0, icms_aliquota = 0, icms_pcredsn = 0, icms_vcredicmssn = 0, icms_predbc = 0, icms_pst = 0, icms_pmvast = NULL, icms_predbcst = 0, icms_vbcst = 0, icms_picmsst = 0, icms_vicmsst = 0, fcp_pfcp = NULL, pis_cst = \'01\', pis_valor = 0, pis_aliquota = 0, pis_valor_base = 0, cofins_cst = \'01\', cofins_valor_base = 0, cofins_aliquota = 0, cofins_valor = 0, voutro = 0, infadprod = NULL, notafiscal_item_motDesICMS_id = NULL, cprod = \'180578\', ipi_cst = \'99\', ipi_valor_base = 0, ipi_aliquota = 0, ipi_vipidevol = NULL, ipi_valor = 0, ipi_pdevol = NULL, estoque_deposito_id = \'2\', produto_lote_id = NULL WHERE (id = 41)', 'UPDATE', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(167): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbdbeb051', '2024', '04', '19'),
	(196, '2024-04-19 18:45:48', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 2, numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = \'Administrador\', criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:45:48\', natop = NULL, data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'2\', notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BROCOLIS NINJA NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622bbdc425cd', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1756): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(170): NotaFiscalCompra::AnalisaVinculosNota(7)\n#4 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbdbeb051', '2024', '04', '19'),
	(197, '2024-04-19 18:46:15', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, notafiscal_item_orig_id, produto_tipo_id, habilitado_id, nome, ncm, unidade_medida_id, produto_grupo_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'1\', \'1\', \'BROCOLIS NINJA NECTAR VITA 200G BJ\', \'07041000\', \'49\', \'1\', \'Administrador\', \'2024-04-19 15:46:15\')', 'INSERT', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(143): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbf627573', '2024', '04', '19'),
	(198, '2024-04-19 18:46:15', 'admin', 'kraftsoft', 'INSERT INTO produto_filial (system_unit_id, produto_id, estoque_deposito_padrao_id, margem, preco_venda, criado_em) VALUES (\'1\', \'10\', \'2\', 0, 0, \'2024-04-19 15:46:15\')', 'INSERT', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(161): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbf627573', '2024', '04', '19'),
	(199, '2024-04-19 18:46:15', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_itens SET nota_fiscal_compra_id = 7, produto_id = \'10\', nota_fiscal_compra_itens_situacao_id = NULL, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-04-19 15:46:15\', nitem = NULL, cean = \'7898949747611\', xprod = \'BROCOLIS NINJA NECTAR VITA 200G BJ\', ncm = \'07041000\', nve = NULL, extipi = NULL, cfop = \'5929\', ucom = \'BJ\', qcom = 2, vuncom = 11.98, vprod = 23.96, ceantrib = \'7898949747611\', utrib = \'BJ\', qtrib = 2, vuntrib = 11.98, vfrete = 0, vseg = 0, vdesc = 0, vtottrib = NULL, xped = NULL, nitemped = NULL, notafiscal_item_indtot_id = NULL, notafiscal_item_orig_id = 1, notafiscal_item_modbc_id = NULL, icms_basecalc = 0, icms_cst = \'40\', icms_valor = 0, icms_aliquota = 0, icms_pcredsn = 0, icms_vcredicmssn = 0, icms_predbc = 0, icms_pst = 0, icms_pmvast = NULL, icms_predbcst = 0, icms_vbcst = 0, icms_picmsst = 0, icms_vicmsst = 0, fcp_pfcp = NULL, pis_cst = \'06\', pis_valor = 0, pis_aliquota = 0, pis_valor_base = 0, cofins_cst = \'06\', cofins_valor_base = 0, cofins_aliquota = 0, cofins_valor = 0, voutro = 0, infadprod = NULL, notafiscal_item_motDesICMS_id = NULL, cprod = \'160427\', ipi_cst = \'99\', ipi_valor_base = 0, ipi_aliquota = 0, ipi_vipidevol = NULL, ipi_valor = 0, ipi_pdevol = NULL, estoque_deposito_id = \'2\', produto_lote_id = NULL WHERE (id = 40)', 'UPDATE', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(167): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbf627573', '2024', '04', '19'),
	(200, '2024-04-19 18:46:15', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 2, numero = \'18045\', data_emissao = \'2023-06-03 00:00:00\', deletado_em = NULL, alterado_por = \'Administrador\', criado_por = \'Administrador\', alterado_em = \'2024-04-19 15:46:15\', natop = NULL, data_saida = NULL, infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 880.58, valor_total_nota = 871.36, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = \'2\', notafiscal_crt_id = 3, obs_importacao_xml = \'-Esta nota fiscal não foi emitida para esta empresa!<br><br>-O Produto FEIJAO CARIOCA TIA GRAM 1KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LARANJA PERA RIO 10KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS SALMAO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto COUVE FLOR NECTAR 300G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTA BIQUINHO NECTAR VITA 200G BJ desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.CARNE 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CENOURA VERMELHA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS LINGUINE 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto GUARD.MILI 21X22CM PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LEITE L.V.BH INTEG.1L TP desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CORDEIRO 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL CHURRASCO AJI SAL 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto WHISKY PASSPORT 1L GF desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS CASTR.PEIXE 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BACON SADIA MANTA VACUO KG BAKN desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto MAC.VILMA OVOS ESPAG.N9 500G PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto LINGUICA PAMPLONA CALAB.1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto PIMENTAO AMARELO/VERMELHO KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOMATE LONGA VIDA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto BATATA CONG.UAI 2KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto SAL REFINADO CISNE 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto CEBOLA AMARELA KG desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS FILHOTE FRANGO 85G desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto OVOS BCOS.SOMAI JUMBO C/40 CX desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto FARINHA MAND.XAP CRUA 1KG PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto RACAO GATOS WHISKAS ATUM 85G SH desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto AGUA SANIT.BH 5L FR desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>-O Produto TOALHA PAP.MILI GRAN CHEF C/200 PT desta nota fiscal não foi encontrado no cadastro do sistema!<br><br>\', cliente_endereco = \'AV UM LOTE 10 QUAD 8\', cliente_complemento = NULL, cliente_numero = \'48\', cliente_bairro = \'LOTEAMENTO RESIDENCIAL PARK SUL\', cliente_cidade = \'BOCAIUVA\', cliente_cep = \'39390000\', cliente_estado = \'MG\', cliente_nome = \'SUPERMERCADOS BH COMERCIO DE ALIMENTOS S/A\', cliente_cpfcnpj = \'04641376015915\', cliente_inscest = \'0020488295661\', cliente_fone = \'3131172600\', cliente_cidade_codibge = \'3107307\', cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = \'31230604641376015915550010000180451000180469\', protocolo_envio = \'131235419061517\', notafiscal_indiedest_id = NULL, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 9.22, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = 2, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = \'1.0.0.0\', notafiscal_indpag_id = NULL, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = \'tmp/31230604641376015915550010000180451000180469-nfe.xml\', data_hora_envio = \'2023-06-03 16:46:12\', xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = NULL, cpag_lancada = 0, dest_cnpj = \'48169520000159\' WHERE (id = 7)', 'UPDATE', '127.0.0.1', '6622bbf6b7849', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1756): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraVincularProduto.php(170): NotaFiscalCompra::AnalisaVinculosNota(7)\n#4 [internal function]: NotaFiscalCompraVincularProduto->onBtnCadastrarNovoProduto(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'b8bk7b59fljc860mtvr5cb2ee3', 'NotaFiscalCompraVincularProduto', 'apache2handler', '6622bbf627573', '2024', '04', '19'),
	(201, '2024-05-30 21:37:07', 'admin', 'kraftsoft', 'INSERT INTO api_error (url, error_message) VALUES (\'/cep/api/v1/78250000\', NULL)', 'INSERT', '127.0.0.1', '6658f183383a5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO api...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO api...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\service\\php_services\\CEPService.php(25): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(635): CEPService::get(\'78250000\')\n#4 [internal function]: ClienteForm::onBuscarCEP(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '6658f1832d8dc', '2024', '05', '30'),
	(202, '2024-05-30 21:42:31', 'admin', 'kraftsoft', 'UPDATE cliente SET system_unit_id = \'1\', cliente_classificacao_id = \'1\', cliente_classificacao_subgrupo_id = NULL, nome = \'Fernando Ferreira Gomes Nascimento\', razao_social = NULL, pessoa_tipo_id = \'1\', cpf_cnpj = \'96947055172\', rg = \'96947055172\', cliente_exterior = \'N\', insc_municipal = \'96947055172\', insc_estadual = \'96947055172\', vendedor_id = NULL, data_nascimento = NULL, fone = NULL, email = \'fpasqueto@gmail.com\', notafiscal_crt_id = NULL, notafiscal_indiedest_id = \'3\', observacoes = NULL, criado_por = \'Administrador\', alterado_em = \'2024-05-30 18:42:31\', alterado_por = \'Administrador\', utilizar_endereco_cobranca = \'2\', cobranca_cnpj = NULL, cobranca_nome = NULL, cobranca_cep = NULL, cobranca_endereco = NULL, cobranca_bairro = NULL, cobranca_uf = NULL, cobranca_cidade = NULL, cobranca_fones = NULL, conjuge = NULL, conjuge_cpf = NULL, nome_pai = NULL, nome_mae = NULL, local_trabalho = NULL, renda = NULL, tempo_trabalho = NULL, residencia_propria = NULL, tabela_preco_id = NULL WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE cliente ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE cliente ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1051): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '6658f2c6bc124', '2024', '05', '30'),
	(203, '2024-05-30 21:42:31', 'admin', 'kraftsoft', 'DELETE FROM cliente_contato WHERE (cliente_id = \'1\')', 'DELETE', '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1068): ClienteForm->storeMasterDetailItems(\'ClienteContato\', \'cliente_id\', \'cliente_contato...\', Object(Cliente), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '6658f2c6bc124', '2024', '05', '30'),
	(204, '2024-05-30 21:42:31', 'admin', 'kraftsoft', 'DELETE FROM cliente_endereco WHERE (cliente_id = \'1\')', 'DELETE', '127.0.0.1', '6658f2c70b121', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(1080): ClienteForm->storeMasterDetailItems(\'ClienteEndereco\', \'cliente_id\', \'cliente_enderec...\', Object(Cliente), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '6658f2c6bc124', '2024', '05', '30'),
	(205, '2024-05-30 21:47:45', 'admin', 'kraftsoft', 'INSERT INTO cliente_classificacao (descricao, criado_em, criado_por, alterado_em, alterado_por, ativo_id) VALUES (\'LOJA\', \'2024-05-30 18:47:45\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '6658f4018198f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteClassificacaoForm.php(339): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteClassificacaoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteClassificacaoForm', 'apache2handler', '6658f401774fd', '2024', '05', '30'),
	(206, '2024-05-30 21:47:45', 'admin', 'kraftsoft', 'DELETE FROM cliente_classificacao_subgrupo WHERE (cliente_classificacao_id = \'2\')', 'DELETE', '127.0.0.1', '6658f4018198f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteClassificacaoForm.php(354): ClienteClassificacaoForm->storeMasterDetailItems(\'ClienteClassifi...\', \'cliente_classif...\', \'cliente_classif...\', Object(ClienteClassificacao), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteClassificacaoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteClassificacaoForm', 'apache2handler', '6658f401774fd', '2024', '05', '30'),
	(207, '2024-05-30 21:47:58', 'admin', 'kraftsoft', 'UPDATE cliente_classificacao SET descricao = \'LOJA\', criado_por = \'Administrador\', alterado_em = \'2024-05-30 18:47:58\', alterado_por = \'Administrador\', ativo_id = \'1\' WHERE (id = \'2\')', 'UPDATE', '127.0.0.1', '6658f40de78bb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE cliente_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE cliente_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteClassificacaoForm.php(339): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ClienteClassificacaoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteClassificacaoForm', 'apache2handler', '6658f40dda7f9', '2024', '05', '30'),
	(208, '2024-05-30 21:47:58', 'admin', 'kraftsoft', 'INSERT INTO cliente_classificacao_subgrupo (descricao, cliente_classificacao_id, criado_em) VALUES (\'LOJA\', \'2\', \'2024-05-30 18:47:58\')', 'INSERT', '127.0.0.1', '6658f40de78bb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteClassificacaoForm.php(354): ClienteClassificacaoForm->storeMasterDetailItems(\'ClienteClassifi...\', \'cliente_classif...\', \'cliente_classif...\', Object(ClienteClassificacao), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteClassificacaoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteClassificacaoForm', 'apache2handler', '6658f40dda7f9', '2024', '05', '30'),
	(209, '2024-05-30 21:47:58', 'admin', 'kraftsoft', 'DELETE FROM cliente_classificacao_subgrupo WHERE (cliente_classificacao_id = \'2\' AND id not in (1))', 'DELETE', '127.0.0.1', '6658f40de78bb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM cli...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM cli...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteClassificacaoForm.php(354): ClienteClassificacaoForm->storeMasterDetailItems(\'ClienteClassifi...\', \'cliente_classif...\', \'cliente_classif...\', Object(ClienteClassificacao), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ClienteClassificacaoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteClassificacaoForm', 'apache2handler', '6658f40dda7f9', '2024', '05', '30'),
	(210, '2024-05-30 21:49:12', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'2024-05-30\', \'1\', \'1\', NULL, \'1\', NULL, \'2024-05-30 18:49:12\', \'Administrador\', NULL, NULL, \'100.00\', \'0.00\', \'100.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f45856df1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(858): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f458187ff', '2024', '05', '30'),
	(211, '2024-05-30 21:49:12', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'3\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 18:49:12\')', 'INSERT', '127.0.0.1', '6658f45856df1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(862): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'3\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f458187ff', '2024', '05', '30'),
	(212, '2024-05-30 21:49:12', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'8\', \'1\', \'50.00\', NULL, NULL, \'50.00\', NULL, NULL, NULL, \'3\', \'2024-05-30 18:49:12\')', 'INSERT', '127.0.0.1', '6658f45856df1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(882): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f458187ff', '2024', '05', '30'),
	(213, '2024-05-30 21:55:57', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'3\', \'2024-05-30\', \'1\', \'1\', NULL, NULL, NULL, \'2024-05-30 18:55:57\', \'Administrador\', \'2024-05-30 18:55:57\', \'Administrador\', \'100.00\', \'0.00\', \'100.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f5ecea6b9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(858): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f5ec64ce3', '2024', '05', '30'),
	(214, '2024-05-30 21:55:57', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'3\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 18:55:57\')', 'INSERT', '127.0.0.1', '6658f5ecea6b9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(862): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'3\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f5ec64ce3', '2024', '05', '30'),
	(215, '2024-05-30 21:55:57', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'8\', \'1\', \'50.00\', NULL, NULL, \'50.00\', NULL, NULL, NULL, \'3\', \'2024-05-30 18:55:57\')', 'INSERT', '127.0.0.1', '6658f5ecea6b9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(882): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f5ec64ce3', '2024', '05', '30'),
	(216, '2024-05-30 21:56:46', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'3\', \'2024-05-30\', \'1\', \'1\', NULL, NULL, NULL, \'2024-05-30 18:56:46\', \'Administrador\', \'2024-05-30 18:56:46\', \'Administrador\', \'100.00\', \'0.00\', \'100.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f61e30aa3', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(858): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f61d9476a', '2024', '05', '30'),
	(217, '2024-05-30 21:56:46', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'3\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 18:56:46\')', 'INSERT', '127.0.0.1', '6658f61e30aa3', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(862): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'3\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f61d9476a', '2024', '05', '30'),
	(218, '2024-05-30 21:56:46', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'8\', \'1\', \'50.00\', NULL, NULL, \'50.00\', NULL, NULL, NULL, \'3\', \'2024-05-30 18:56:46\')', 'INSERT', '127.0.0.1', '6658f61e30aa3', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(882): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f61d9476a', '2024', '05', '30'),
	(219, '2024-05-30 21:58:33', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'3\', \'2024-05-30\', \'1\', \'1\', NULL, NULL, NULL, \'2024-05-30 18:58:33\', \'Administrador\', \'2024-05-30 18:58:33\', \'Administrador\', \'100.00\', \'0.00\', \'100.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f6896abe1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(858): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f68891088', '2024', '05', '30'),
	(220, '2024-05-30 21:58:33', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'3\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 18:58:33\')', 'INSERT', '127.0.0.1', '6658f6896abe1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(862): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'3\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f68891088', '2024', '05', '30'),
	(221, '2024-05-30 21:58:33', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'8\', \'1\', \'50.00\', NULL, NULL, \'50.00\', NULL, NULL, NULL, \'3\', \'2024-05-30 18:58:33\')', 'INSERT', '127.0.0.1', '6658f6896abe1', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(882): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f68891088', '2024', '05', '30'),
	(222, '2024-05-30 21:58:45', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'3\', \'2024-05-30\', \'1\', \'1\', NULL, NULL, NULL, \'2024-05-30 18:58:45\', \'Administrador\', \'2024-05-30 18:58:45\', \'Administrador\', \'100.00\', \'0.00\', \'100.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f6951355e', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(858): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f6944eee5', '2024', '05', '30'),
	(223, '2024-05-30 21:58:45', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'3\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 18:58:45\')', 'INSERT', '127.0.0.1', '6658f6951355e', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(862): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'3\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f6944eee5', '2024', '05', '30'),
	(224, '2024-05-30 21:58:45', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'8\', \'1\', \'50.00\', NULL, NULL, \'50.00\', NULL, NULL, NULL, \'3\', \'2024-05-30 18:58:45\')', 'INSERT', '127.0.0.1', '6658f6951355e', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(882): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f6944eee5', '2024', '05', '30'),
	(225, '2024-05-30 22:02:49', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'2024-05-30\', \'1\', \'1\', NULL, \'1\', NULL, \'2024-05-30 19:02:49\', \'Administrador\', NULL, NULL, \'60.00\', \'0.00\', \'60.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f789173d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(869): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f7882b455', '2024', '05', '30'),
	(226, '2024-05-30 22:02:49', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'4\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 19:02:49\')', 'INSERT', '127.0.0.1', '6658f789173d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(873): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'4\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f7882b455', '2024', '05', '30'),
	(227, '2024-05-30 22:02:49', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'10\', \'1\', \'60.00\', NULL, NULL, \'0.00\', NULL, NULL, NULL, \'4\', \'2024-05-30 19:02:49\')', 'INSERT', '127.0.0.1', '6658f789173d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f7882b455', '2024', '05', '30'),
	(228, '2024-05-30 22:07:14', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'2024-05-30\', \'1\', \'1\', NULL, \'1\', NULL, \'2024-05-30 19:07:14\', \'Administrador\', NULL, NULL, \'950.00\', \'0.00\', \'950.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f89205caf', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(869): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f890e0e2f', '2024', '05', '30'),
	(229, '2024-05-30 22:07:14', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'5\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 19:07:14\')', 'INSERT', '127.0.0.1', '6658f89205caf', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(873): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'5\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f890e0e2f', '2024', '05', '30'),
	(230, '2024-05-30 22:07:14', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'5\', \'1\', \'950.00\', NULL, NULL, \'950.00\', NULL, NULL, NULL, \'5\', \'2024-05-30 19:07:14\')', 'INSERT', '127.0.0.1', '6658f89205caf', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f890e0e2f', '2024', '05', '30'),
	(231, '2024-05-30 22:10:07', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'5\', \'2024-05-30\', \'1\', \'1\', NULL, NULL, NULL, \'2024-05-30 19:10:07\', \'Administrador\', \'2024-05-30 19:10:07\', \'Administrador\', \'950.00\', \'0.00\', \'950.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f93f1044a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(869): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f93e24397', '2024', '05', '30'),
	(232, '2024-05-30 22:10:07', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'5\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 19:10:07\')', 'INSERT', '127.0.0.1', '6658f93f1044a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(873): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'5\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f93e24397', '2024', '05', '30'),
	(233, '2024-05-30 22:10:07', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'5\', \'1\', \'950.00\', NULL, NULL, \'950.00\', NULL, NULL, NULL, \'5\', \'2024-05-30 19:10:07\')', 'INSERT', '127.0.0.1', '6658f93f1044a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f93e24397', '2024', '05', '30'),
	(234, '2024-05-30 22:11:12', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'5\', \'2024-05-30\', \'1\', \'1\', NULL, NULL, NULL, \'2024-05-30 19:11:12\', \'Administrador\', \'2024-05-30 19:11:12\', \'Administrador\', \'950.00\', \'0.00\', \'950.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6658f980b6cb0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(869): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f97fd9ff0', '2024', '05', '30'),
	(235, '2024-05-30 22:11:12', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'5\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-05-30 19:11:12\')', 'INSERT', '127.0.0.1', '6658f980b6cb0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(873): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'5\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f97fd9ff0', '2024', '05', '30'),
	(236, '2024-05-30 22:11:12', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'5\', \'1\', \'950.00\', NULL, NULL, \'950.00\', NULL, NULL, NULL, \'5\', \'2024-05-30 19:11:12\')', 'INSERT', '127.0.0.1', '6658f980b6cb0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f97fd9ff0', '2024', '05', '30'),
	(237, '2024-05-30 22:11:12', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET deletado_em = \'2024-05-30 19:11:12\' WHERE (orcamento_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6658f980b6cb0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f97fd9ff0', '2024', '05', '30'),
	(238, '2024-05-30 22:11:12', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = 5, produto_id = 5, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-05-30 19:11:12\', quantidade = 1, valor_unitario = 950, valor_total = 950, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '6658f980b6cb0', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(959): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(898): Orcamento::recalcula_itens_orcamento(Object(Orcamento))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '6658f97fd9ff0', '2024', '05', '30'),
	(239, '2024-05-31 05:22:46', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (nota_fiscal_compra_situacao_id, numero, serie, data_emissao, data_saida, notafiscal_mod_id, natop, notafiscal_finnfe_id, notafiscal_indpres_id, notafiscal_modfrete_id, chave, infcpl, infadfisco, criado_em, criado_por, alterado_em, alterado_por, notafiscal_indfinal_id, notafiscal_tipodocumento_id, notafiscal_iddest_id, fornecedor_id, cliente_nome, cliente_cpfcnpj, cliente_inscest, cliente_inscmuni, notafiscal_crt_id, notafiscal_indiedest_id, cliente_cep, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade, cliente_estado, cliente_cidade_codibge, notafiscal_indpag_id, fatura_numero, fatura_valor_original, fatura_valor_desconto, fatura_valor_liquido, icms_basecalc, icms_valor, icms_subst_base_calc, icms_subst_valor, frete_valor, seguro_valor, ipi_valor, desconto_valor, outras_despesas, ipi_vipidevol, valor_total_produtos, valor_total_nota, vtroco, system_unit_id) VALUES (\'1\', \'12541\', \'1\', \'2024-05-31 02:22\', \'2024-05-31 02:22\', \'1\', NULL, \'1\', \'1\', \'6\', NULL, NULL, NULL, \'2024-05-31 02:22:46\', \'Administrador\', NULL, NULL, \'1\', \'2\', \'1\', \'1\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'37.961.074/0001-02\', \'158478622\', NULL, NULL, NULL, \'68473000\', \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', NULL, NULL, NULL, \'1\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66595ea6a22e9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(970): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595ea5b430a', '2024', '05', '31'),
	(240, '2024-05-31 05:23:10', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (nota_fiscal_compra_situacao_id, numero, serie, data_emissao, data_saida, notafiscal_mod_id, natop, notafiscal_finnfe_id, notafiscal_indpres_id, notafiscal_modfrete_id, chave, infcpl, infadfisco, criado_em, criado_por, alterado_em, alterado_por, notafiscal_indfinal_id, notafiscal_tipodocumento_id, notafiscal_iddest_id, fornecedor_id, cliente_nome, cliente_cpfcnpj, cliente_inscest, cliente_inscmuni, notafiscal_crt_id, notafiscal_indiedest_id, cliente_cep, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade, cliente_estado, cliente_cidade_codibge, notafiscal_indpag_id, fatura_numero, fatura_valor_original, fatura_valor_desconto, fatura_valor_liquido, icms_basecalc, icms_valor, icms_subst_base_calc, icms_subst_valor, frete_valor, seguro_valor, ipi_valor, desconto_valor, outras_despesas, ipi_vipidevol, valor_total_produtos, valor_total_nota, vtroco, system_unit_id) VALUES (\'1\', \'12541\', \'1\', \'2024-05-31 02:22\', \'2024-05-31 02:22\', \'1\', NULL, \'1\', \'1\', \'6\', NULL, NULL, NULL, \'2024-05-31 02:23:10\', \'Administrador\', NULL, NULL, \'1\', \'2\', \'1\', \'1\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'37.961.074/0001-02\', \'158478622\', NULL, NULL, NULL, \'68473000\', \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', NULL, NULL, NULL, \'1\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66595ebe253a2', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(970): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595ebcc3696', '2024', '05', '31'),
	(241, '2024-05-31 05:23:36', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (nota_fiscal_compra_situacao_id, numero, serie, data_emissao, data_saida, notafiscal_mod_id, natop, notafiscal_finnfe_id, notafiscal_indpres_id, notafiscal_modfrete_id, chave, infcpl, infadfisco, criado_em, criado_por, alterado_em, alterado_por, notafiscal_indfinal_id, notafiscal_tipodocumento_id, notafiscal_iddest_id, fornecedor_id, cliente_nome, cliente_cpfcnpj, cliente_inscest, cliente_inscmuni, notafiscal_crt_id, notafiscal_indiedest_id, cliente_cep, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade, cliente_estado, cliente_cidade_codibge, notafiscal_indpag_id, fatura_numero, fatura_valor_original, fatura_valor_desconto, fatura_valor_liquido, icms_basecalc, icms_valor, icms_subst_base_calc, icms_subst_valor, frete_valor, seguro_valor, ipi_valor, desconto_valor, outras_despesas, ipi_vipidevol, valor_total_produtos, valor_total_nota, vtroco, system_unit_id) VALUES (\'1\', \'12541\', \'1\', \'2024-05-31 02:22\', \'2024-05-31 02:22\', \'1\', NULL, \'1\', \'1\', \'6\', NULL, NULL, NULL, \'2024-05-31 02:23:36\', \'Administrador\', NULL, NULL, \'1\', \'2\', \'1\', \'1\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'37.961.074/0001-02\', \'158478622\', NULL, NULL, NULL, \'68473000\', \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', NULL, NULL, NULL, \'1\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66595ed844ec7', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(970): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595ed6b51d2', '2024', '05', '31'),
	(242, '2024-05-31 05:24:14', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (nota_fiscal_compra_situacao_id, numero, serie, data_emissao, data_saida, notafiscal_mod_id, natop, notafiscal_finnfe_id, notafiscal_indpres_id, notafiscal_modfrete_id, chave, infcpl, infadfisco, criado_em, criado_por, alterado_em, alterado_por, notafiscal_indfinal_id, notafiscal_tipodocumento_id, notafiscal_iddest_id, fornecedor_id, cliente_nome, cliente_cpfcnpj, cliente_inscest, cliente_inscmuni, notafiscal_crt_id, notafiscal_indiedest_id, cliente_cep, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade, cliente_estado, cliente_cidade_codibge, notafiscal_indpag_id, fatura_numero, fatura_valor_original, fatura_valor_desconto, fatura_valor_liquido, icms_basecalc, icms_valor, icms_subst_base_calc, icms_subst_valor, frete_valor, seguro_valor, ipi_valor, desconto_valor, outras_despesas, ipi_vipidevol, valor_total_produtos, valor_total_nota, vtroco, system_unit_id) VALUES (\'1\', \'12541\', \'1\', \'2024-05-31 02:22\', \'2024-05-31 02:22\', \'1\', NULL, \'1\', \'1\', \'6\', NULL, NULL, NULL, \'2024-05-31 02:24:14\', \'Administrador\', NULL, NULL, \'1\', \'2\', \'1\', \'1\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'37.961.074/0001-02\', \'158478622\', NULL, \'3\', \'1\', \'68473000\', \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', NULL, NULL, NULL, \'1\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66595efe2949f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(970): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595efd2cb78', '2024', '05', '31'),
	(243, '2024-05-31 05:24:47', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (nota_fiscal_compra_situacao_id, numero, serie, data_emissao, data_saida, notafiscal_mod_id, natop, notafiscal_finnfe_id, notafiscal_indpres_id, notafiscal_modfrete_id, chave, infcpl, infadfisco, criado_em, criado_por, alterado_em, alterado_por, notafiscal_indfinal_id, notafiscal_tipodocumento_id, notafiscal_iddest_id, fornecedor_id, cliente_nome, cliente_cpfcnpj, cliente_inscest, cliente_inscmuni, notafiscal_crt_id, notafiscal_indiedest_id, cliente_cep, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade, cliente_estado, cliente_cidade_codibge, notafiscal_indpag_id, fatura_numero, fatura_valor_original, fatura_valor_desconto, fatura_valor_liquido, icms_basecalc, icms_valor, icms_subst_base_calc, icms_subst_valor, frete_valor, seguro_valor, ipi_valor, desconto_valor, outras_despesas, ipi_vipidevol, valor_total_produtos, valor_total_nota, vtroco, system_unit_id) VALUES (\'1\', \'12541\', \'1\', \'2024-05-31 02:22\', \'2024-05-31 02:22\', \'1\', NULL, \'1\', \'1\', \'6\', NULL, NULL, NULL, \'2024-05-31 02:24:47\', \'Administrador\', NULL, NULL, \'1\', \'2\', \'1\', \'1\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'37.961.074/0001-02\', \'158478622\', NULL, \'3\', \'1\', \'68473000\', \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', NULL, NULL, NULL, \'1\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66595f1fc42e7', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(970): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595f1eb9668', '2024', '05', '31'),
	(244, '2024-05-31 05:25:25', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra (nota_fiscal_compra_situacao_id, numero, serie, data_emissao, data_saida, notafiscal_mod_id, natop, notafiscal_finnfe_id, notafiscal_indpres_id, notafiscal_modfrete_id, chave, infcpl, infadfisco, criado_em, criado_por, alterado_em, alterado_por, notafiscal_indfinal_id, notafiscal_tipodocumento_id, notafiscal_iddest_id, fornecedor_id, cliente_nome, cliente_cpfcnpj, cliente_inscest, cliente_inscmuni, notafiscal_crt_id, notafiscal_indiedest_id, cliente_cep, cliente_endereco, cliente_numero, cliente_complemento, cliente_bairro, cliente_cidade, cliente_estado, cliente_cidade_codibge, notafiscal_indpag_id, fatura_numero, fatura_valor_original, fatura_valor_desconto, fatura_valor_liquido, icms_basecalc, icms_valor, icms_subst_base_calc, icms_subst_valor, frete_valor, seguro_valor, ipi_valor, desconto_valor, outras_despesas, ipi_vipidevol, valor_total_produtos, valor_total_nota, vtroco, system_unit_id) VALUES (\'1\', \'12541\', \'1\', \'2024-05-31 02:22\', \'2024-05-31 02:22\', \'1\', NULL, \'1\', \'1\', \'6\', NULL, NULL, NULL, \'2024-05-31 02:25:25\', \'Administrador\', NULL, NULL, \'1\', \'2\', \'1\', \'1\', \'SH PECAS E SERVICOS MECANICOS LTDA\', \'37.961.074/0001-02\', \'158478622\', NULL, \'3\', \'1\', \'68473000\', \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', \'S/N\', NULL, \'PARQUE MARAJO\', NULL, NULL, NULL, \'1\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66595f44e8386', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(970): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595f43c9d5c', '2024', '05', '31'),
	(245, '2024-05-31 05:25:25', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_dup (forma_pagamento_id, ndup, parcela, dvenc, vdup, plano_conta_id, centro_custo_id, nota_fiscal_compra_id, criado_por, criado_em) VALUES (\'2\', \'32156465\', NULL, \'2024-05-31\', \'100.00\', NULL, NULL, \'8\', \'Administrador\', \'2024-05-31 02:25:25\')', 'INSERT', '127.0.0.1', '66595f44e8386', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(980): NotaFiscalCompraForm->storeMasterDetailItems(\'NotaFiscalCompr...\', \'nota_fiscal_com...\', \'nota_fiscal_com...\', Object(NotaFiscalCompra), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595f43c9d5c', '2024', '05', '31'),
	(246, '2024-05-31 05:25:25', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_dup SET deletado_em = \'2024-05-31 02:25:25\' WHERE (nota_fiscal_compra_id = \'8\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66595f44e8386', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(980): NotaFiscalCompraForm->storeMasterDetailItems(\'NotaFiscalCompr...\', \'nota_fiscal_com...\', \'nota_fiscal_com...\', Object(NotaFiscalCompra), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595f43c9d5c', '2024', '05', '31'),
	(247, '2024-05-31 05:25:25', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_pag (notafiscal_tpag_id, vpag, xpag, nota_fiscal_compra_id, criado_por, criado_em) VALUES (\'1\', \'100.00\', NULL, \'8\', \'Administrador\', \'2024-05-31 02:25:25\')', 'INSERT', '127.0.0.1', '66595f44e8386', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(988): NotaFiscalCompraForm->storeMasterDetailItems(\'NotaFiscalCompr...\', \'nota_fiscal_com...\', \'nota_fiscal_com...\', Object(NotaFiscalCompra), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595f43c9d5c', '2024', '05', '31'),
	(248, '2024-05-31 05:25:25', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra_pag SET deletado_em = \'2024-05-31 02:25:25\' WHERE (nota_fiscal_compra_id = \'8\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '66595f44e8386', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraForm.php(988): NotaFiscalCompraForm->storeMasterDetailItems(\'NotaFiscalCompr...\', \'nota_fiscal_com...\', \'nota_fiscal_com...\', Object(NotaFiscalCompra), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: NotaFiscalCompraForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraForm', 'apache2handler', '66595f43c9d5c', '2024', '05', '31'),
	(249, '2024-05-31 05:26:07', 'admin', 'kraftsoft', 'INSERT INTO nota_fiscal_compra_itens (cprod, produto_id, cean, ncm, cfop, ucom, qcom, vuncom, xped, nitemped, vfrete, vdesc, vseg, estoque_deposito_id, produto_lote_id, nota_fiscal_compra_id, xprod, icms_cst, notafiscal_item_orig_id, icms_basecalc, icms_aliquota, icms_valor, icms_vbcst, icms_picmsst, icms_vicmsst, ipi_cst, ipi_valor_base, ipi_aliquota, ipi_valor, extipi, ipi_pdevol, ipi_vipidevol, utrib, qtrib, vuntrib, ceantrib, vprod, criado_em) VALUES (\'9\', \'9\', NULL, \'20059900\', NULL, \'UNID\', \'1.00\', \'50.00\', NULL, NULL, \'0.00\', \'5.00\', \'0.00\', \'2\', NULL, \'8\', \'ALHO FRITO ALHO ROXO 400G PT\', NULL, \'1\', \'0.00\', \'0.00\', \'0.00\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'UNID\', \'1.00\', \'50.00\', NULL, 50, \'2024-05-31 02:26:07\')', 'INSERT', '127.0.0.1', '66595f6fb446e', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO not...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO not...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraItensForm.php(346): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NotaFiscalCompraItensForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraItensForm', 'apache2handler', '66595f6f622c5', '2024', '05', '31'),
	(250, '2024-05-31 05:26:07', 'admin', 'kraftsoft', 'UPDATE nota_fiscal_compra SET system_unit_id = 1, fornecedor_id = 1, numero = \'12541\', data_emissao = \'2024-05-31 02:22:00\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-05-31 02:26:07\', natop = NULL, data_saida = \'2024-05-31 02:22:00\', infcpl = NULL, infadfisco = NULL, icms_basecalc = 0, icms_valor = 0, icms_subst_base_calc = 0, icms_subst_valor = 0, frete_valor = 0, seguro_valor = 0, outras_despesas = 0, ipi_valor = 0, serie = \'1\', valor_total_produtos = 50, valor_total_nota = 45, transp_nome = NULL, transp_cnpj = NULL, transp_inscest = NULL, transp_endereco = NULL, transp_cidade = NULL, transp_placaveiculo = NULL, transp_uf = NULL, transp_veiculouf = NULL, transp_veiculorntc = NULL, transp_numeracao = NULL, notafiscal_tipodocumento_id = 2, nota_fiscal_compra_situacao_id = 1, notafiscal_crt_id = 3, obs_importacao_xml = NULL, cliente_endereco = \'RUA RIO ARAGUAIA, 21 PARQUE MARAJO QUADRA15 LADO B\', cliente_complemento = NULL, cliente_numero = \'S/N\', cliente_bairro = \'PARQUE MARAJO\', cliente_cidade = NULL, cliente_cep = \'68473000\', cliente_estado = NULL, cliente_nome = \'SH PECAS E SERVICOS MECANICOS LTDA\', cliente_cpfcnpj = \'37.961.074/0001-02\', cliente_inscest = \'158478622\', cliente_fone = NULL, cliente_cidade_codibge = NULL, cliente_inscmuni = NULL, cliente_suframa = NULL, justificativa_cancelamento = NULL, chave = NULL, protocolo_envio = NULL, notafiscal_indiedest_id = 1, protocolo_cancelamento = NULL, datahora_cancelamento = NULL, cce_datahora_evento = NULL, cce_sequencial = NULL, cce_correcao = NULL, cce_protocolo = NULL, desconto_valor = 5, pis_valor = 0, cofins_valor = 0, fatura_numero = NULL, fatura_valor_original = NULL, fatura_valor_desconto = NULL, fatura_valor_liquido = NULL, notafiscal_iddest_id = 1, notafiscal_tpimp_id = NULL, notafiscal_finnfe_id = 1, notafiscal_indfinal_id = 1, notafiscal_indpres_id = 1, verproc = NULL, notafiscal_indpag_id = 1, retirada_marcado = NULL, retirada_cpfcnpj = NULL, retirada_xlgr = NULL, retirada_nro = NULL, retirada_xcpl = NULL, retirada_xbairro = NULL, retirada_cmun = NULL, retirada_xmun = NULL, retirada_uf = NULL, entrega_marcado = NULL, entrega_cpfcnpj = NULL, entrega_xlgr = NULL, entrega_nro = NULL, entrega_xcpl = NULL, entrega_xbairro = NULL, entrega_cmun = NULL, entrega_xmun = NULL, entrega_uf = NULL, vicmsufdest = 0, vicmsufremet = NULL, vfcpufdest = NULL, notafiscal_mod_id = 1, xml = NULL, data_hora_envio = NULL, xml_cancelamento = NULL, issqn_vserv = 0, issqn_vbc = 0, issqn_viss = 0, issqn_dcompet = NULL, issqn_reftrib = NULL, icms_vfcp = 0, icms_vfcpst = 0, icms_vfcpstret = 0, layout_versao = NULL, ipi_vipidevol = 0, vtroco = NULL, notafiscal_modfrete_id = 6, cpag_lancada = NULL, dest_cnpj = NULL WHERE (id = 8)', 'UPDATE', '127.0.0.1', '66595f6fb446e', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE nota_fis...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE nota_fis...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\NotaFiscalCompra.php(1564): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\compras\\NotaFiscalCompraItensForm.php(348): NotaFiscalCompra::atualiza_totais_nota(\'8\')\n#4 [internal function]: NotaFiscalCompraItensForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NotaFiscalCompraItensForm', 'apache2handler', '66595f6f622c5', '2024', '05', '31'),
	(251, '2024-06-01 14:39:12', 'admin', 'kraftsoft', 'INSERT INTO api_error (url, error_message) VALUES (\'/cep/api/v1/78250000\', NULL)', 'INSERT', '127.0.0.1', '665b329031c11', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO api...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO api...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\service\\php_services\\CEPService.php(25): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(635): CEPService::get(\'78250000\')\n#4 [internal function]: ClienteForm::onBuscarCEP(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ClienteForm', 'apache2handler', '665b32901c77e', '2024', '06', '01'),
	(252, '2024-06-03 00:27:41', 'admin', 'kraftsoft', 'UPDATE system_unit SET cnpj = \'14013224000142\', name = \'Matriz\', razao_social = \'Matriz\', notafiscal_crt_id = \'1\', sn_matriz = \'S\', inscricao_estadual = NULL, inscricao_municipal = NULL, fone = NULL, email = NULL, notafiscal_cprod_padrao_id = NULL, cnae = \'admin\', connection_name = \'matriz\', end_cep = NULL, end_municipio = NULL, end_mun_codibge = NULL, end_uf = NULL, end_logradouro = NULL, end_bairro = NULL, end_numero = NULL, end_complemento = NULL, vendas_natureza_operacao_id = \'1\', nfe_tpimp_id = \'2\', nfe_tpamb_id = \'2\', nfe_api_documentos_id = NULL, nfe_homologacao_series_id = NULL, nfe_producao_series_id = NULL, nfce_natureza_operacao_id = \'1\', nfce_tpimp_id = NULL, nfce_tpamb_id = \'2\', nfce_api_documentos_id = NULL, nfce_homologacao_series_id = NULL, nfce_producao_series_id = NULL, nfce_id_csc_homologacao = NULL, nfce_csc_homologacao = NULL, nfce_id_csc_producao = NULL, nfce_csc_producao = NULL, mdfe_api_documentos_id = NULL, mdfe_homologacao_series_id = NULL, mdfe_producao_series_id = NULL, mdfe_tpamb_id = NULL, mdfe_estadoini_id = NULL, veiculo_id = NULL, natureza_operacao_compra_id = NULL, aliquota_iss = NULL, aliquota_irrf = NULL, aliquota_csll = NULL, pc_credito_sn = NULL, certificadoA1 = NULL, senha_certificado = NULL, token_api = NULL, logo = NULL, contador_nome = NULL, contador_documento = NULL, contador_celular = NULL, contador_email = NULL, config_host = NULL, config_port = NULL, config_user = NULL, config_password = \'admin\', config_replyname = NULL, config_replyto = NULL WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665d0dfd4f3e4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE system_u...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE system_u...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\FilialForm.php(499): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FilialForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'FilialForm', 'apache2handler', '665d0dfce33ce', '2024', '06', '02'),
	(253, '2024-06-03 01:14:06', 'admin', 'kraftsoft', 'INSERT INTO centro_custo (numero, centro_custo_tipo_id, centro_custo_pai_id, descricao, criado_em, criado_por, alterado_em, alterado_por, system_unit_id) VALUES (\'1\', \'2\', NULL, \'CONTAS A RECEBER\', \'2024-06-02 22:14:06\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665d18de0077f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cen...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cen...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoForm.php(151): Adianti\\Database\\TRecord->store()\n#3 [internal function]: CentroCustoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'CentroCustoForm', 'apache2handler', '665d18ddcb688', '2024', '06', '02'),
	(254, '2024-06-03 01:15:19', 'admin', 'kraftsoft', 'INSERT INTO centro_custo (numero, centro_custo_tipo_id, centro_custo_pai_id, descricao, criado_em, criado_por, alterado_em, alterado_por, system_unit_id) VALUES (\'1.2\', \'2\', NULL, \'VENDAS\', \'2024-06-02 22:15:19\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665d192712b24', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cen...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cen...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoForm.php(151): Adianti\\Database\\TRecord->store()\n#3 [internal function]: CentroCustoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'CentroCustoForm', 'apache2handler', '665d1926dddba', '2024', '06', '02'),
	(255, '2024-06-03 01:15:27', 'admin', 'kraftsoft', 'UPDATE centro_custo SET deletado_em = \'2024-06-02 22:15:27\' WHERE (id = 2)', 'UPDATE', '127.0.0.1', '665d192f50590', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE centro_c...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(1159): Adianti\\Database\\TTransaction::log(\'UPDATE centro_c...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoList.php(197): Adianti\\Database\\TRecord->delete()\n#3 [internal function]: CentroCustoList->onDelete(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoList.php(616): Adianti\\Control\\TPage->show()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): CentroCustoList->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'CentroCustoList', 'apache2handler', '665d192f2d5aa', '2024', '06', '02'),
	(256, '2024-06-03 01:15:30', 'admin', 'kraftsoft', 'UPDATE centro_custo SET deletado_em = \'2024-06-02 22:15:30\' WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665d1932800ca', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE centro_c...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(1159): Adianti\\Database\\TTransaction::log(\'UPDATE centro_c...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoList.php(197): Adianti\\Database\\TRecord->delete()\n#3 [internal function]: CentroCustoList->onDelete(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoList.php(616): Adianti\\Control\\TPage->show()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): CentroCustoList->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'CentroCustoList', 'apache2handler', '665d193267efd', '2024', '06', '02'),
	(257, '2024-06-03 01:15:49', 'admin', 'kraftsoft', 'INSERT INTO centro_custo (numero, centro_custo_tipo_id, centro_custo_pai_id, descricao, criado_em, criado_por, alterado_em, alterado_por, system_unit_id) VALUES (\'1\', \'1\', NULL, \'RECEITAS\', \'2024-06-02 22:15:49\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665d1945481e3', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cen...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cen...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoForm.php(151): Adianti\\Database\\TRecord->store()\n#3 [internal function]: CentroCustoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'CentroCustoForm', 'apache2handler', '665d194526304', '2024', '06', '02'),
	(258, '2024-06-03 01:16:06', 'admin', 'kraftsoft', 'INSERT INTO centro_custo (numero, centro_custo_tipo_id, centro_custo_pai_id, descricao, criado_em, criado_por, alterado_em, alterado_por, system_unit_id) VALUES (\'1.2\', \'2\', \'3\', \'VENDAS\', \'2024-06-02 22:16:06\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665d1956366ce', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO cen...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO cen...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\CentroCustoForm.php(151): Adianti\\Database\\TRecord->store()\n#3 [internal function]: CentroCustoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'CentroCustoForm', 'apache2handler', '665d195610541', '2024', '06', '02'),
	(259, '2024-06-03 01:17:29', 'admin', 'kraftsoft', 'INSERT INTO plano_conta (numero, plano_conta_origem_id, plano_conta_tipo_id, descricao, plano_conta_pai_id, criado_em, criado_por, alterado_em, alterado_por, system_unit_id) VALUES (\'1\', \'1\', \'1\', \'RECEITAS\', NULL, \'2024-06-02 22:17:29\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665d19a9965ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pla...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pla...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\PlanoContaForm.php(160): Adianti\\Database\\TRecord->store()\n#3 [internal function]: PlanoContaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'PlanoContaForm', 'apache2handler', '665d19a966955', '2024', '06', '02'),
	(260, '2024-06-03 01:18:01', 'admin', 'kraftsoft', 'INSERT INTO plano_conta (numero, plano_conta_origem_id, plano_conta_tipo_id, descricao, plano_conta_pai_id, criado_em, criado_por, alterado_em, alterado_por, system_unit_id) VALUES (\'1.2\', \'1\', \'2\', \'RECEBIMENTOS\', \'1\', \'2024-06-02 22:18:01\', \'Administrador\', NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665d19c91a06b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pla...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pla...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\PlanoContaForm.php(160): Adianti\\Database\\TRecord->store()\n#3 [internal function]: PlanoContaForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'PlanoContaForm', 'apache2handler', '665d19c8e7336', '2024', '06', '02'),
	(261, '2024-06-03 01:19:06', 'admin', 'kraftsoft', 'INSERT INTO contasrec_bloco (numero_documento, cliente_id, forma_pagamento_id, valor, primeiro_vencimento, quantidade_parcelas, plano_conta_id, centro_custo_id, observacao, criado_por, criado_em, system_unit_id) VALUES (\'1245234\', \'1\', \'2\', \'500.00\', \'2024-06-02\', \'4\', \'2\', \'4\', NULL, \'Administrador\', \'2024-06-02 22:19:06\', \'1\')', 'INSERT', '127.0.0.1', '665d1a0a823d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(338): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecBlocoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1a0a5f3f9', '2024', '06', '02'),
	(262, '2024-06-03 01:19:06', 'admin', 'kraftsoft', 'INSERT INTO contasrec (forma_pagamento_id, numero_documento, parcela, data_competencia, data_vencimento, valor, contasrec_bloco_id, criado_por, criado_em, data_emissao, cliente_id, observacao, contasrec_origem_id, contasrec_situacao_id, system_unit_id, valor_aberto, data_venc_original, plano_conta_id, centro_custo_id, desconto, valor_multa, juros, valor_pago, ativo_id) VALUES (\'2\', \'1245234\', \'1/4\', \'2024-06-02\', \'2024-06-02\', \'500.00\', \'1\', \'Administrador\', \'2024-06-02 22:19:06\', \'2024-06-02\', \'1\', NULL, \'1\', \'1\', \'1\', \'500.00\', \'2024-06-02\', \'2\', \'4\', \'0,00\', \'0,00\', \'0,00\', \'0,00\', \'1\')', 'INSERT', '127.0.0.1', '665d1a0a823d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\include\\builder\\BuilderMasterDetailFieldListTrait.php(80): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(371): ContasrecBlocoForm->storeItems(\'Contasrec\', \'contasrec_bloco...\', Object(ContasrecBloco), Object(Adianti\\Widget\\Form\\TFieldList), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ContasrecBlocoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1a0a5f3f9', '2024', '06', '02'),
	(263, '2024-06-03 01:20:12', 'admin', 'kraftsoft', 'INSERT INTO contasrec_bloco (numero_documento, cliente_id, forma_pagamento_id, valor, primeiro_vencimento, quantidade_parcelas, plano_conta_id, centro_custo_id, observacao, criado_por, criado_em, system_unit_id) VALUES (\'1245234\', \'1\', \'2\', \'500.00\', \'2024-06-02\', \'4\', \'2\', \'4\', NULL, \'Administrador\', \'2024-06-02 22:20:12\', \'1\')', 'INSERT', '127.0.0.1', '665d1a4beffa9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(338): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecBlocoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1a4bc706d', '2024', '06', '02'),
	(264, '2024-06-03 01:20:12', 'admin', 'kraftsoft', 'INSERT INTO contasrec (forma_pagamento_id, numero_documento, parcela, data_competencia, data_vencimento, valor, contasrec_bloco_id, criado_por, criado_em, data_emissao, cliente_id, observacao, contasrec_origem_id, contasrec_situacao_id, system_unit_id, valor_aberto, data_venc_original, plano_conta_id, centro_custo_id, desconto, valor_multa, juros, valor_pago, ativo_id) VALUES (\'2\', \'1245234\', \'1/4\', \'2024-06-02\', \'2024-06-02\', \'500.00\', \'2\', \'Administrador\', \'2024-06-02 22:20:12\', \'2024-06-02\', \'1\', NULL, \'1\', \'1\', \'1\', \'500.00\', \'2024-06-02\', \'2\', \'4\', \'0,00\', \'0,00\', \'0,00\', \'0,00\', \'1\')', 'INSERT', '127.0.0.1', '665d1a4beffa9', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\include\\builder\\BuilderMasterDetailFieldListTrait.php(80): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(371): ContasrecBlocoForm->storeItems(\'Contasrec\', \'contasrec_bloco...\', Object(ContasrecBloco), Object(Adianti\\Widget\\Form\\TFieldList), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ContasrecBlocoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1a4bc706d', '2024', '06', '02'),
	(265, '2024-06-03 01:24:27', 'admin', 'kraftsoft', 'INSERT INTO contasrec_bloco (numero_documento, cliente_id, forma_pagamento_id, valor, primeiro_vencimento, quantidade_parcelas, plano_conta_id, centro_custo_id, observacao, criado_por, criado_em, system_unit_id) VALUES (\'1245234\', \'1\', \'2\', \'500.00\', \'2024-06-02\', \'4\', \'2\', \'4\', NULL, \'Administrador\', \'2024-06-02 22:24:27\', \'1\')', 'INSERT', '127.0.0.1', '665d1b4b92dc6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(338): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecBlocoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1b4b6183b', '2024', '06', '02'),
	(266, '2024-06-03 01:24:27', 'admin', 'kraftsoft', 'INSERT INTO contasrec (forma_pagamento_id, numero_documento, parcela, data_competencia, data_vencimento, valor, contasrec_bloco_id, criado_por, criado_em, data_emissao, cliente_id, observacao, contasrec_origem_id, contasrec_situacao_id, system_unit_id, valor_aberto, data_venc_original, plano_conta_id, centro_custo_id, desconto, valor_multa, juros, valor_pago, ativo_id) VALUES (\'2\', \'1245234\', \'1/4\', \'2024-06-02\', \'2024-06-02\', \'500.00\', \'3\', \'Administrador\', \'2024-06-02 22:24:27\', \'2024-06-02\', \'1\', NULL, \'1\', \'1\', \'1\', \'500.00\', \'2024-06-02\', \'2\', \'4\', \'0,00\', \'0,00\', \'0,00\', \'0,00\', \'1\')', 'INSERT', '127.0.0.1', '665d1b4b92dc6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\include\\builder\\BuilderMasterDetailFieldListTrait.php(80): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(371): ContasrecBlocoForm->storeItems(\'Contasrec\', \'contasrec_bloco...\', Object(ContasrecBloco), Object(Adianti\\Widget\\Form\\TFieldList), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ContasrecBlocoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1b4b6183b', '2024', '06', '02'),
	(267, '2024-06-03 01:28:42', 'admin', 'kraftsoft', 'INSERT INTO contasrec_bloco (numero_documento, cliente_id, forma_pagamento_id, valor, primeiro_vencimento, quantidade_parcelas, plano_conta_id, centro_custo_id, observacao, criado_por, criado_em, system_unit_id) VALUES (\'1245234\', \'1\', \'2\', \'500.00\', \'2024-06-02\', \'4\', \'2\', \'4\', NULL, \'Administrador\', \'2024-06-02 22:28:42\', \'1\')', 'INSERT', '127.0.0.1', '665d1c4a081c3', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(338): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecBlocoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1c49ce2b6', '2024', '06', '02'),
	(268, '2024-06-03 01:28:42', 'admin', 'kraftsoft', 'INSERT INTO contasrec (forma_pagamento_id, numero_documento, parcela, data_competencia, data_vencimento, valor, contasrec_bloco_id, criado_por, criado_em, data_emissao, cliente_id, observacao, contasrec_origem_id, contasrec_situacao_id, system_unit_id, valor_aberto, data_venc_original, plano_conta_id, centro_custo_id, desconto, valor_multa, juros, valor_pago, ativo_id) VALUES (\'2\', \'1245234\', \'1/4\', \'2024-06-02\', \'2024-06-02\', \'500.00\', \'4\', \'Administrador\', \'2024-06-02 22:28:42\', \'2024-06-02\', \'1\', NULL, \'1\', \'1\', \'1\', \'500.00\', \'2024-06-02\', \'2\', \'4\', \'0,00\', \'0,00\', \'0,00\', \'0,00\', \'1\')', 'INSERT', '127.0.0.1', '665d1c4a081c3', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\include\\builder\\BuilderMasterDetailFieldListTrait.php(80): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(371): ContasrecBlocoForm->storeItems(\'Contasrec\', \'contasrec_bloco...\', Object(ContasrecBloco), Object(Adianti\\Widget\\Form\\TFieldList), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ContasrecBlocoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1c49ce2b6', '2024', '06', '02'),
	(269, '2024-06-03 01:29:18', 'admin', 'kraftsoft', 'INSERT INTO contasrec_bloco (numero_documento, cliente_id, forma_pagamento_id, valor, primeiro_vencimento, quantidade_parcelas, plano_conta_id, centro_custo_id, observacao, criado_por, criado_em, system_unit_id) VALUES (\'1245234\', \'1\', \'2\', \'500.00\', \'2024-06-02\', \'5\', \'2\', \'4\', NULL, \'Administrador\', \'2024-06-02 22:29:18\', \'1\')', 'INSERT', '127.0.0.1', '665d1c6e4426c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(338): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecBlocoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1c6e245c9', '2024', '06', '02'),
	(270, '2024-06-03 01:29:18', 'admin', 'kraftsoft', 'INSERT INTO contasrec (forma_pagamento_id, numero_documento, parcela, data_competencia, data_vencimento, valor, contasrec_bloco_id, criado_por, criado_em, data_emissao, cliente_id, observacao, contasrec_origem_id, contasrec_situacao_id, system_unit_id, valor_aberto, data_venc_original, plano_conta_id, centro_custo_id, desconto, valor_multa, juros, valor_pago, ativo_id) VALUES (\'2\', \'1245234\', \'1/5\', \'2024-06-02\', \'2024-06-02\', \'500.00\', \'5\', \'Administrador\', \'2024-06-02 22:29:18\', \'2024-06-02\', \'1\', NULL, \'1\', \'1\', \'1\', \'500.00\', \'2024-06-02\', \'2\', \'4\', \'0,00\', \'0,00\', \'0,00\', \'0,00\', \'1\')', 'INSERT', '127.0.0.1', '665d1c6e4426c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\include\\builder\\BuilderMasterDetailFieldListTrait.php(80): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecBlocoForm.php(371): ContasrecBlocoForm->storeItems(\'Contasrec\', \'contasrec_bloco...\', Object(ContasrecBloco), Object(Adianti\\Widget\\Form\\TFieldList), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ContasrecBlocoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecBlocoForm', 'apache2handler', '665d1c6e245c9', '2024', '06', '02'),
	(271, '2024-06-03 01:31:28', 'admin', 'kraftsoft', 'INSERT INTO contasrec (contasrec_situacao_id, data_venc_original, data_pagamento, data_emissao, data_vencimento, data_competencia, cliente_id, forma_pagamento_id, contasrec_origem_id, plano_conta_id, centro_custo_id, numero_documento, parcela, valor, valor_pago, valor_aberto, desconto, valor_multa, juros, observacao, system_unit_id, criado_em, criado_por, alterado_em, alterado_por, cheque_banco_id, cheque_agencia, cheque_conta, cheque_cpfcnpj, cheque_emitente, ativo_id) VALUES (\'1\', \'2024-06-03\', NULL, \'2024-06-02\', \'2024-06-03\', \'2024-06-03\', \'1\', \'2\', \'1\', \'2\', \'4\', \'1245234\', \'1\', \'500.00\', \'0.00\', 500, \'0.00\', \'0.00\', \'0.00\', NULL, \'1\', \'2024-06-02 22:31:28\', \'Administrador\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665d1cf0a5af6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecForm.php(269): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecForm', 'apache2handler', '665d1cf070b8f', '2024', '06', '02'),
	(272, '2024-06-03 01:31:28', 'admin', 'kraftsoft', 'INSERT INTO contasrec_historico_venc (contasrec_id, vencimento_anterior, vencimento_atual, criado_por, criado_em) VALUES (\'1\', NULL, \'2024-06-03\', \'Administrador\', \'2024-06-02 22:31:28\')', 'INSERT', '127.0.0.1', '665d1cf0a5af6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecForm.php(283): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecForm', 'apache2handler', '665d1cf070b8f', '2024', '06', '02'),
	(273, '2024-06-03 01:31:28', 'admin', 'kraftsoft', 'INSERT INTO contabil_lancamentos (plano_conta_id, centro_custo_id, contabil_lancamentos_tipo_id, contabil_lancamentos_situacao_id, contabil_lancamentos_origem_id, data_lancamento, valor, contasrec_id, historico, criado_por, criado_em) VALUES (\'2\', \'4\', \'2\', \'2\', \'2\', \'2024-06-03\', \'500.00\', \'1\', \'Ref. Crédito Cliente: Fernando Ferreira Gomes Nascimento\', \'Administrador\', \'2024-06-02 22:31:28\')', 'INSERT', '127.0.0.1', '665d1cf0a5af6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\ContabilLancamentos.php(343): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecForm.php(295): ContabilLancamentos::LancamentoContabil(\'2\', \'4\', \'2\', \'2\', \'2\', \'1\', \'2024-06-03\', \'500.00\', \'Ref. Cr\\xC3\\xA9dito C...\')\n#4 [internal function]: ContasrecForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContasrecForm', 'apache2handler', '665d1cf070b8f', '2024', '06', '02'),
	(274, '2024-06-04 02:30:34', 'admin', 'kraftsoft', 'INSERT INTO banco (nome, numero, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'BANCO DO BRASIL\', \'001\', \'2024-06-03 23:30:34\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '665e7c4a6ba76', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ban...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ban...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\BancoForm.php(123): Adianti\\Database\\TRecord->store()\n#3 [internal function]: BancoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'BancoForm', 'apache2handler', '665e7c4a5a4ce', '2024', '06', '03'),
	(275, '2024-06-04 02:30:49', 'admin', 'kraftsoft', 'INSERT INTO conta_corrente (banco_id, nome, agencia, agencia_digito, conta, conta_digito, criado_em, criado_por, alterado_em, alterado_por, end_logradouro, end_numero, end_bairro, end_cidade, end_estado, end_cep, boleto_gerar, boleto_carteira, boleto_convenio, boleto_instrucoes, boleto_codigo_cedente, boleto_digito_cod_cedente, boleto_multa, boleto_juros_dia, boleto_digitos_nosso_numero, boleto_codigo_transmissao, boleto_local_pagamento, system_unit_id) VALUES (\'1\', \'Fernando Ferreira Gomes Nascimento\', NULL, NULL, NULL, NULL, \'2024-06-03 23:30:49\', \'Administrador\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665e7c599476f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContaCorrenteForm.php(212): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContaCorrenteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContaCorrenteForm', 'apache2handler', '665e7c5977f78', '2024', '06', '03'),
	(276, '2024-06-04 02:31:11', 'admin', 'kraftsoft', 'INSERT INTO conta_corrente (banco_id, nome, agencia, agencia_digito, conta, conta_digito, criado_em, criado_por, alterado_em, alterado_por, end_logradouro, end_numero, end_bairro, end_cidade, end_estado, end_cep, boleto_gerar, boleto_carteira, boleto_convenio, boleto_instrucoes, boleto_codigo_cedente, boleto_digito_cod_cedente, boleto_multa, boleto_juros_dia, boleto_digitos_nosso_numero, boleto_codigo_transmissao, boleto_local_pagamento, system_unit_id) VALUES (\'1\', \'CAIXA GERAL\', NULL, NULL, NULL, NULL, \'2024-06-03 23:31:11\', \'Administrador\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, FALSE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '665e7c6fbec0b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContaCorrenteForm.php(212): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContaCorrenteForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContaCorrenteForm', 'apache2handler', '665e7c6fa4374', '2024', '06', '03'),
	(277, '2024-06-04 02:32:02', 'admin', 'kraftsoft', 'INSERT INTO conta_corrente_lancamentos (conta_corrente_lanc_origem_id, documento, conta_corrente_id, conta_corrente_lanc_tipo_id, data_lancamento, valor, plano_conta_id, centro_custo_id, historico, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'1\', NULL, \'2\', \'2\', \'2024-06-03\', \'500.00\', \'2\', \'4\', \'DFDSFSDFSDF\', \'2024-06-03 23:32:02\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '665e7ca299a2d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContaCorrenteLancamentosForm.php(197): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContaCorrenteLancamentosForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContaCorrenteLancamentosForm', 'apache2handler', '665e7ca273783', '2024', '06', '03'),
	(278, '2024-06-04 02:32:02', 'admin', 'kraftsoft', 'INSERT INTO contabil_lancamentos (plano_conta_id, centro_custo_id, contabil_lancamentos_tipo_id, contabil_lancamentos_situacao_id, contabil_lancamentos_origem_id, data_lancamento, valor, conta_corrente_lancamentos_id, historico, criado_por, criado_em) VALUES (\'2\', \'4\', \'2\', \'1\', \'3\', \'2024-06-03\', \'500.00\', \'1\', \'Ref. Lançam. avulso em conta corrente\', \'Administrador\', \'2024-06-03 23:32:02\')', 'INSERT', '127.0.0.1', '665e7ca299a2d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\ContabilLancamentos.php(343): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContaCorrenteLancamentosForm.php(220): ContabilLancamentos::LancamentoContabil(\'2\', \'4\', \'2\', \'1\', \'3\', \'1\', \'2024-06-03\', \'500.00\', \'Ref. Lan\\xC3\\xA7am. a...\')\n#4 [internal function]: ContaCorrenteLancamentosForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ContaCorrenteLancamentosForm', 'apache2handler', '665e7ca273783', '2024', '06', '03'),
	(279, '2024-06-04 03:12:45', 'admin', 'kraftsoft', 'UPDATE orcamento SET orcamento_situacao_id = \'1\', data_orcamento = \'2024-05-30\', cliente_id = \'1\', vendedor_id = \'1\', cliente_contato_id = NULL, tabela_preco_id = \'1\', observacao = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:12:45\', alterado_por = \'Administrador\', valor_produtos = \'1250.00\', frete_total = \'0.00\', valor_total = \'1250.00\', peso_total = \'0.00\', desconto = \'0.00\', system_unit_id = \'1\' WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e862d13260', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(869): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e862cd65b9', '2024', '06', '04'),
	(280, '2024-06-04 03:12:45', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'5\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-06-04 00:12:45\')', 'INSERT', '127.0.0.1', '665e862d13260', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(873): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'5\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e862cd65b9', '2024', '06', '04'),
	(281, '2024-06-04 03:12:45', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = \'5\', produto_id = 5, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 00:12:45\', quantidade = 1, valor_unitario = 950, valor_total = 950, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e862d13260', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e862cd65b9', '2024', '06', '04'),
	(282, '2024-06-04 03:12:45', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'6\', \'3.00\', \'100.00\', NULL, NULL, \'300.00\', NULL, NULL, NULL, \'5\', \'2024-06-04 00:12:45\')', 'INSERT', '127.0.0.1', '665e862d13260', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e862cd65b9', '2024', '06', '04'),
	(283, '2024-06-04 03:12:45', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET deletado_em = \'2024-06-04 00:12:45\' WHERE (orcamento_id = \'5\' AND id not in (1,2) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e862d13260', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e862cd65b9', '2024', '06', '04'),
	(284, '2024-06-04 03:12:45', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = 5, produto_id = 5, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 00:12:45\', quantidade = 1, valor_unitario = 950, valor_total = 950, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e862d13260', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(959): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(898): Orcamento::recalcula_itens_orcamento(Object(Orcamento))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e862cd65b9', '2024', '06', '04'),
	(285, '2024-06-04 03:12:45', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = 5, produto_id = 6, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 00:12:45\', quantidade = 3, valor_unitario = 100, valor_total = 300, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 2)', 'UPDATE', '127.0.0.1', '665e862d13260', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(959): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(898): Orcamento::recalcula_itens_orcamento(Object(Orcamento))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e862cd65b9', '2024', '06', '04'),
	(286, '2024-06-04 03:13:25', 'admin', 'kraftsoft', 'INSERT INTO venda (system_unit_id, filial_saida_id, venda_situacao_id, orcamento_id, vendedor_id, cliente_id, data_hora_venda, data_prev_entrega, observacao, valor_produtos, desconto, peso_total, frete_total, valor_total, tabela_preco_id, venda_tipo_pagamento_id, venda_modalidade_id, movimentacao_origem_id, criado_por, criado_em) VALUES (1, 1, \'1\', 5, 1, 1, \'2024-06-04 00:13:25\', \'2024-06-04 00:13:25\', NULL, 1250, 0, 0, 0, 1250, 1, \'1\', \'1\', \'1\', \'Administrador\', \'2024-06-04 00:13:25\')', 'INSERT', '127.0.0.1', '665e8655c629e', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(1011): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoFormView.php(393): Orcamento::GerarVenda(Object(Orcamento))\n#4 [internal function]: OrcamentoFormView::onGerarVendaYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoFormView', 'apache2handler', '665e8655bddee', '2024', '06', '04'),
	(287, '2024-06-04 03:13:25', 'admin', 'kraftsoft', 'INSERT INTO venda_item (venda_id, produto_id, quantidade, valor_unitario, valor_total, valor_original, informacoes_adicionais, numero_pedido, numero_item_pedido, cancelado, valor_custo, estoque_deposito_id, desconto, valor_frete, peso_unitario, peso_total, criado_em) VALUES (\'2\', 5, 1, 950, 950, NULL, NULL, NULL, NULL, \'2\', \'950,00\', NULL, NULL, NULL, NULL, NULL, \'2024-06-04 00:13:25\')', 'INSERT', '127.0.0.1', '665e8655c629e', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(1050): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoFormView.php(393): Orcamento::GerarVenda(Object(Orcamento))\n#4 [internal function]: OrcamentoFormView::onGerarVendaYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoFormView', 'apache2handler', '665e8655bddee', '2024', '06', '04'),
	(288, '2024-06-04 03:24:23', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:24:23\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e88e7ae35d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e88e76b821', '2024', '06', '04'),
	(289, '2024-06-04 03:24:23', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:24:23\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e88e7ae35d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e88e76b821', '2024', '06', '04'),
	(290, '2024-06-04 03:24:23', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:24:23\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e88e7ae35d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e88e76b821', '2024', '06', '04'),
	(291, '2024-06-04 03:24:23', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1235.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-06-04 00:24:23\')', 'INSERT', '127.0.0.1', '665e88e7ae35d', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1141): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e88e76b821', '2024', '06', '04'),
	(292, '2024-06-04 03:28:57', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:28:57\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e89f9e88ea', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e89f9ba0ce', '2024', '06', '04'),
	(293, '2024-06-04 03:28:58', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:28:58\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e89f9e88ea', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e89f9ba0ce', '2024', '06', '04'),
	(294, '2024-06-04 03:28:58', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:28:58\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e89f9e88ea', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e89f9ba0ce', '2024', '06', '04'),
	(295, '2024-06-04 03:28:58', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1235.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-06-04 00:28:58\')', 'INSERT', '127.0.0.1', '665e89f9e88ea', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1141): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e89f9ba0ce', '2024', '06', '04'),
	(296, '2024-06-04 03:29:37', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:29:37\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8a2182b8a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8a214759a', '2024', '06', '04'),
	(297, '2024-06-04 03:29:37', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:29:37\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8a2182b8a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8a214759a', '2024', '06', '04'),
	(298, '2024-06-04 03:29:37', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:29:37\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8a2182b8a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8a214759a', '2024', '06', '04'),
	(299, '2024-06-04 03:29:37', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1235.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-06-04 00:29:37\')', 'INSERT', '127.0.0.1', '665e8a2182b8a', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1141): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1145): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8a214759a', '2024', '06', '04'),
	(300, '2024-06-04 03:32:39', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:32:39\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8ad7b21ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ad779c2b', '2024', '06', '04'),
	(301, '2024-06-04 03:32:39', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:32:39\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8ad7b21ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ad779c2b', '2024', '06', '04'),
	(302, '2024-06-04 03:32:39', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:32:39\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8ad7b21ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ad779c2b', '2024', '06', '04'),
	(303, '2024-06-04 03:32:39', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1235.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-06-04 00:32:39\')', 'INSERT', '127.0.0.1', '665e8ad7b21ef', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1142): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ad779c2b', '2024', '06', '04'),
	(304, '2024-06-04 03:34:11', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:34:11\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8b3349a9b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8b331821f', '2024', '06', '04'),
	(305, '2024-06-04 03:34:11', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:34:11\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8b3349a9b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8b331821f', '2024', '06', '04'),
	(306, '2024-06-04 03:34:11', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:34:11\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8b3349a9b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8b331821f', '2024', '06', '04'),
	(307, '2024-06-04 03:34:11', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1235.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-06-04 00:34:11\')', 'INSERT', '127.0.0.1', '665e8b3349a9b', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1143): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1147): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8b331821f', '2024', '06', '04'),
	(308, '2024-06-04 03:36:57', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:36:57\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8bd91cec5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8bd8d0b43', '2024', '06', '04'),
	(309, '2024-06-04 03:36:57', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:36:57\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8bd91cec5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8bd8d0b43', '2024', '06', '04'),
	(310, '2024-06-04 03:36:57', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:36:57\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8bd91cec5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8bd8d0b43', '2024', '06', '04'),
	(311, '2024-06-04 03:36:57', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', \'950,00\', \'1235.00\', \'950,00\', \'950.00\', \'Administrador\', \'2024-06-04 00:36:57\')', 'INSERT', '127.0.0.1', '665e8bd91cec5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1143): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1147): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8bd8d0b43', '2024', '06', '04'),
	(312, '2024-06-04 03:41:15', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:41:15\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8cdaee3d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cdabef4e', '2024', '06', '04'),
	(313, '2024-06-04 03:41:15', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:41:15\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8cdaee3d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cdabef4e', '2024', '06', '04'),
	(314, '2024-06-04 03:41:15', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:41:15\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8cdaee3d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cdabef4e', '2024', '06', '04'),
	(315, '2024-06-04 03:41:15', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:41:15\')', 'INSERT', '127.0.0.1', '665e8cdaee3d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cdabef4e', '2024', '06', '04'),
	(316, '2024-06-04 03:41:15', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:41:15\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8cdaee3d8', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cdabef4e', '2024', '06', '04'),
	(317, '2024-06-04 03:41:28', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:41:28\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8ce874148', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ce84a213', '2024', '06', '04'),
	(318, '2024-06-04 03:41:28', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:41:28\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8ce874148', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ce84a213', '2024', '06', '04'),
	(319, '2024-06-04 03:41:28', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:41:28\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8ce874148', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ce84a213', '2024', '06', '04'),
	(320, '2024-06-04 03:41:28', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:41:28\')', 'INSERT', '127.0.0.1', '665e8ce874148', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ce84a213', '2024', '06', '04'),
	(321, '2024-06-04 03:41:28', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:41:28\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8ce874148', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ce84a213', '2024', '06', '04'),
	(322, '2024-06-04 03:41:46', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:41:46\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8cf9f2678', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cf9b9607', '2024', '06', '04'),
	(323, '2024-06-04 03:41:46', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:41:46\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8cf9f2678', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cf9b9607', '2024', '06', '04'),
	(324, '2024-06-04 03:41:46', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:41:46\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8cf9f2678', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cf9b9607', '2024', '06', '04'),
	(325, '2024-06-04 03:41:46', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:41:46\')', 'INSERT', '127.0.0.1', '665e8cf9f2678', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cf9b9607', '2024', '06', '04'),
	(326, '2024-06-04 03:41:46', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:41:46\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8cf9f2678', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8cf9b9607', '2024', '06', '04'),
	(327, '2024-06-04 03:42:31', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:42:31\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8d272ca54', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d26deb4e', '2024', '06', '04'),
	(328, '2024-06-04 03:42:31', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:42:31\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8d272ca54', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d26deb4e', '2024', '06', '04'),
	(329, '2024-06-04 03:42:31', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:42:31\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8d272ca54', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d26deb4e', '2024', '06', '04'),
	(330, '2024-06-04 03:42:31', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 950, 950, 950, \'Administrador\', \'2024-06-04 00:42:31\')', 'INSERT', '127.0.0.1', '665e8d272ca54', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d26deb4e', '2024', '06', '04'),
	(331, '2024-06-04 03:42:31', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'0.00\', valor_custo = \'950.00\', preco_venda = \'950.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:42:31\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8d272ca54', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d26deb4e', '2024', '06', '04'),
	(332, '2024-06-04 03:42:46', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:42:46\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8d3604129', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d35bbbba', '2024', '06', '04'),
	(333, '2024-06-04 03:42:46', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:42:46\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8d3604129', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d35bbbba', '2024', '06', '04'),
	(334, '2024-06-04 03:42:46', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:42:46\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8d3604129', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d35bbbba', '2024', '06', '04'),
	(335, '2024-06-04 03:42:46', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 950, 950, 950, \'Administrador\', \'2024-06-04 00:42:46\')', 'INSERT', '127.0.0.1', '665e8d3604129', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d35bbbba', '2024', '06', '04'),
	(336, '2024-06-04 03:42:46', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'0.00\', valor_custo = \'950.00\', preco_venda = \'950.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:42:46\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8d3604129', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d35bbbba', '2024', '06', '04'),
	(337, '2024-06-04 03:43:28', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:43:28\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8d606f5e6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d6033374', '2024', '06', '04'),
	(338, '2024-06-04 03:43:28', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:43:28\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8d606f5e6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d6033374', '2024', '06', '04'),
	(339, '2024-06-04 03:43:28', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:43:28\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8d606f5e6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d6033374', '2024', '06', '04'),
	(340, '2024-06-04 03:43:28', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 950, 950, 950, \'Administrador\', \'2024-06-04 00:43:28\')', 'INSERT', '127.0.0.1', '665e8d606f5e6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d6033374', '2024', '06', '04'),
	(341, '2024-06-04 03:43:28', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'0.00\', valor_custo = \'950.00\', preco_venda = \'950.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:43:28\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8d606f5e6', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8d6033374', '2024', '06', '04'),
	(342, '2024-06-04 03:44:43', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:44:43\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8dab630ba', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dab23fc6', '2024', '06', '04'),
	(343, '2024-06-04 03:44:43', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:44:43\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8dab630ba', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dab23fc6', '2024', '06', '04'),
	(344, '2024-06-04 03:44:43', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:44:43\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8dab630ba', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dab23fc6', '2024', '06', '04'),
	(345, '2024-06-04 03:44:43', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:44:43\')', 'INSERT', '127.0.0.1', '665e8dab630ba', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dab23fc6', '2024', '06', '04'),
	(346, '2024-06-04 03:44:43', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:44:43\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8dab630ba', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dab23fc6', '2024', '06', '04'),
	(347, '2024-06-04 03:45:11', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:45:11\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8dc74d03f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dc70b0f1', '2024', '06', '04'),
	(348, '2024-06-04 03:45:11', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:45:11\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8dc74d03f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dc70b0f1', '2024', '06', '04'),
	(349, '2024-06-04 03:45:11', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:45:11\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8dc74d03f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dc70b0f1', '2024', '06', '04'),
	(350, '2024-06-04 03:45:11', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:45:11\')', 'INSERT', '127.0.0.1', '665e8dc74d03f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dc70b0f1', '2024', '06', '04'),
	(351, '2024-06-04 03:45:11', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:45:11\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8dc74d03f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dc70b0f1', '2024', '06', '04'),
	(352, '2024-06-04 03:45:23', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:45:23\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8dd3b8090', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dd37f0f5', '2024', '06', '04'),
	(353, '2024-06-04 03:45:23', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:45:23\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8dd3b8090', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dd37f0f5', '2024', '06', '04'),
	(354, '2024-06-04 03:45:23', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:45:23\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8dd3b8090', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dd37f0f5', '2024', '06', '04'),
	(355, '2024-06-04 03:45:23', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:45:23\')', 'INSERT', '127.0.0.1', '665e8dd3b8090', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dd37f0f5', '2024', '06', '04'),
	(356, '2024-06-04 03:45:23', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:45:23\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8dd3b8090', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8dd37f0f5', '2024', '06', '04'),
	(357, '2024-06-04 03:46:41', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:46:41\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8e2198631', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e215bdf6', '2024', '06', '04'),
	(358, '2024-06-04 03:46:41', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:46:41\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8e2198631', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e215bdf6', '2024', '06', '04'),
	(359, '2024-06-04 03:46:41', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:46:41\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8e2198631', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e215bdf6', '2024', '06', '04'),
	(360, '2024-06-04 03:46:41', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:46:41\')', 'INSERT', '127.0.0.1', '665e8e2198631', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1144): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e215bdf6', '2024', '06', '04'),
	(361, '2024-06-04 03:46:41', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:46:41\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8e2198631', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e215bdf6', '2024', '06', '04'),
	(362, '2024-06-04 03:47:03', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:47:03\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8e36ed7ad', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e36be5b5', '2024', '06', '04'),
	(363, '2024-06-04 03:47:03', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:47:03\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8e36ed7ad', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e36be5b5', '2024', '06', '04'),
	(364, '2024-06-04 03:47:03', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:47:03\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8e36ed7ad', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e36be5b5', '2024', '06', '04'),
	(365, '2024-06-04 03:47:03', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:47:03\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8e36ed7ad', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e36be5b5', '2024', '06', '04'),
	(366, '2024-06-04 03:47:19', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:47:19\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8e478086f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e4754986', '2024', '06', '04'),
	(367, '2024-06-04 03:47:19', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:47:19\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8e478086f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e4754986', '2024', '06', '04'),
	(368, '2024-06-04 03:47:19', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:47:19\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8e478086f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e4754986', '2024', '06', '04'),
	(369, '2024-06-04 03:47:19', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:47:19\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8e478086f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1148): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8e4754986', '2024', '06', '04'),
	(370, '2024-06-04 03:52:34', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:52:34\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8f82d4a2c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8f82a33f0', '2024', '06', '04'),
	(371, '2024-06-04 03:54:37', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'BATERIA 150 AMPERES MOURA\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:54:37\', alterado_por = \'Administrador\', ncm = \'85071090\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e8ffd1ada5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ffcd6783', '2024', '06', '04'),
	(372, '2024-06-04 03:54:37', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET produto_id = \'5\', fornecedor_id = 1, codigo_fornecedor = \'28\', descricao_produto_fornecedor = \'BATERIA 150 AMPERES MOURA\', deletado_em = NULL, alterado_por = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 00:54:37\', tempo_medio_fornecimento = NULL, quantidade_minima_compra = NULL, preco_venda = 950 WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e8ffd1ada5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ffcd6783', '2024', '06', '04'),
	(373, '2024-06-04 03:54:37', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 00:54:37\' WHERE (produto_id = \'5\' AND id not in (1) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e8ffd1ada5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ffcd6783', '2024', '06', '04'),
	(374, '2024-06-04 03:54:37', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'5\', \'1\', 950, 1235, 950, 950, \'Administrador\', \'2024-06-04 00:54:37\')', 'INSERT', '127.0.0.1', '665e8ffd1ada5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1142): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ffcd6783', '2024', '06', '04'),
	(375, '2024-06-04 03:54:37', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'950.00\', preco_venda = \'1235.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'1\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'950,00\', valor_custo_anterior = \'950,00\', produto_id = \'5\', alterado_em = \'2024-06-04 00:54:37\' WHERE (id = \'1\')', 'UPDATE', '127.0.0.1', '665e8ffd1ada5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e8ffcd6783', '2024', '06', '04'),
	(376, '2024-06-04 04:14:31', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'RACAO GATOS BAW WAW MIX 900G PT\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 01:14:31\', alterado_por = \'Administrador\', ncm = \'23099010\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'6\')', 'UPDATE', '127.0.0.1', '665e94a77d92c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94a7447d8', '2024', '06', '04'),
	(377, '2024-06-04 04:14:31', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 01:14:31\' WHERE (produto_id = \'6\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e94a77d92c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94a7447d8', '2024', '06', '04'),
	(378, '2024-06-04 04:14:31', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'6\', \'2\', 0, 325, 0, 250, \'Administrador\', \'2024-06-04 01:14:31\')', 'INSERT', '127.0.0.1', '665e94a77d92c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1142): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94a7447d8', '2024', '06', '04'),
	(379, '2024-06-04 04:14:31', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'250.00\', preco_venda = \'325.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'2\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'0.00\', valor_custo_anterior = NULL, produto_id = \'6\', alterado_em = \'2024-06-04 01:14:31\' WHERE (id = \'2\')', 'UPDATE', '127.0.0.1', '665e94a77d92c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94a7447d8', '2024', '06', '04'),
	(380, '2024-06-04 04:14:31', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-06-04 01:14:31\' WHERE (produto_id = \'6\' AND id not in (2) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e94a77d92c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94a7447d8', '2024', '06', '04'),
	(381, '2024-06-04 04:15:33', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'RACAO GATOS BAW WAW MIX 900G PT\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 01:15:33\', alterado_por = \'Administrador\', ncm = \'23099010\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = NULL, especificacao = NULL, link_site = NULL WHERE (id = \'6\')', 'UPDATE', '127.0.0.1', '665e94e57c499', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94e53b2a4', '2024', '06', '04'),
	(382, '2024-06-04 04:15:33', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 01:15:33\' WHERE (produto_id = \'6\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e94e57c499', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94e53b2a4', '2024', '06', '04'),
	(383, '2024-06-04 04:15:33', 'admin', 'kraftsoft', 'INSERT INTO produto_filial_historico (produto_id, produto_filial_id, preco_venda_antigo, preco_venda_novo, valor_custo_antigo, valor_custo_novo, criado_por, criado_em) VALUES (\'6\', \'2\', 325, 338, 250, 260, \'Administrador\', \'2024-06-04 01:15:33\')', 'INSERT', '127.0.0.1', '665e94e57c499', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1142): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(52): ProdutoForm->{closure}(Object(Produto), Object(ProdutoFilial))\n#4 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#5 [internal function]: ProdutoForm->onSave(Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94e53b2a4', '2024', '06', '04'),
	(384, '2024-06-04 04:15:33', 'admin', 'kraftsoft', 'UPDATE produto_filial SET system_unit_id = \'1\', margem = \'30.00\', valor_custo = \'260.00\', preco_venda = \'338.00\', estoque_minimo = NULL, estoque_maximo = NULL, codigo_balanca = NULL, estoque_deposito_padrao_id = \'2\', sob_encomenda_id = NULL, gerar_op_venda_id = NULL, preco_venda_anterior = \'325.00\', valor_custo_anterior = \'250.00\', produto_id = \'6\', alterado_em = \'2024-06-04 01:15:33\' WHERE (id = \'2\')', 'UPDATE', '127.0.0.1', '665e94e57c499', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94e53b2a4', '2024', '06', '04'),
	(385, '2024-06-04 04:15:33', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-06-04 01:15:33\' WHERE (produto_id = \'6\' AND id not in (2) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e94e57c499', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e94e53b2a4', '2024', '06', '04'),
	(386, '2024-06-04 04:16:23', 'admin', 'kraftsoft', 'UPDATE produto SET tipo_recurso_id = \'1\', referencia = NULL, codigo_sku = NULL, nome = \'RACAO GATOS BAW WAW MIX 900G PT\', codigo_EAN = NULL, produto_grupo_id = \'1\', produtogrupo_subgrupo_id = NULL, produto_fabricante_id = NULL, unidade_medida_id = \'49\', produto_tipo_id = \'1\', marca = NULL, nome_curto = NULL, peso_liquido = NULL, peso_bruto = NULL, produto_embalagem_id = NULL, largura = NULL, altura = NULL, comprimento = NULL, diametro = NULL, dias_preparacao = NULL, unidade_caixa = NULL, garantia = NULL, obs = NULL, habilitado_id = \'1\', criado_por = \'Administrador\', alterado_em = \'2024-06-04 01:16:23\', alterado_por = \'Administrador\', ncm = \'23099010\', cest = NULL, notafiscal_item_orig_id = \'1\', imagem = \'%7B%22newFile%22%3A%22tmp%2Ftravas_john.jpg%22%2C%22fileName%22%3A%22tmp%2Ftravas_john.jpg%22%7D\', especificacao = NULL, link_site = NULL WHERE (id = \'6\')', 'UPDATE', '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e95172689f', '2024', '06', '04'),
	(387, '2024-06-04 04:16:23', 'admin', 'kraftsoft', 'UPDATE produto SET imagem = \'app/files/kraft_arquivos/produtos/6/travas_john.jpg\', alterado_em = \'2024-06-04 01:16:23\' WHERE (id = \'6\')', 'UPDATE', '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto ...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto ...\')\n#2 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\base\\AdiantiFileSaveTrait.php(101): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1076): ProdutoForm->saveFile(Object(Produto), Object(stdClass), \'imagem\', \'app/files/kraft...\')\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e95172689f', '2024', '06', '04'),
	(388, '2024-06-04 04:16:23', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-04 01:16:23\' WHERE (produto_id = \'6\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e95172689f', '2024', '06', '04'),
	(389, '2024-06-04 04:16:23', 'admin', 'kraftsoft', 'UPDATE produto_filial SET produto_id = \'6\', system_unit_id = 1, margem = 30, preco_venda = 338, preco_venda_anterior = 325, valor_custo = 260, valor_custo_anterior = 250, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 01:16:23\', estoque_minimo = NULL, estoque_maximo = NULL, local_estoque = NULL, codigo_balanca = NULL, deletado_em = NULL, estoque_deposito_padrao_id = 2, sob_encomenda_id = NULL, gerar_op_venda_id = NULL WHERE (id = 2)', 'UPDATE', '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e95172689f', '2024', '06', '04'),
	(390, '2024-06-04 04:16:23', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-06-04 01:16:23\' WHERE (produto_id = \'6\' AND id not in (2) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e951766413', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'ProdutoForm', 'apache2handler', '665e95172689f', '2024', '06', '04'),
	(391, '2024-06-04 04:24:19', 'admin', 'kraftsoft', 'INSERT INTO negocio_origem (descricao, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'LOJA\', \'2024-06-04 01:24:19\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '665e96f31b6b5', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO neg...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO neg...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\crm\\NegocioOrigemForm.php(112): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NegocioOrigemForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NegocioOrigemForm', 'apache2handler', '665e96f3145c7', '2024', '06', '04'),
	(392, '2024-06-04 04:25:12', 'admin', 'kraftsoft', 'INSERT INTO funil (descricao, criado_em, criado_por, alterado_em, alterado_por) VALUES (\'LOJA\', \'2024-06-04 01:25:12\', \'Administrador\', NULL, NULL)', 'INSERT', '127.0.0.1', '665e97288ca8f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO fun...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO fun...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\crm\\FunilForm.php(189): Adianti\\Database\\TRecord->store()\n#3 [internal function]: FunilForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'FunilForm', 'apache2handler', '665e97287e3d2', '2024', '06', '04'),
	(393, '2024-06-04 04:25:12', 'admin', 'kraftsoft', 'INSERT INTO funil_etapas (descricao, numero_etapa, cor_etapa, cor_negocio, kanban, permite_edicao, permite_exclusao, etapa_ganha, etapa_perde, funil_id, criado_em) VALUES (\'GERAL\', \'1\', \'#9C27B0\', \'#2196F3\', \'S\', \'S\', \'S\', \'S\', \'S\', \'1\', \'2024-06-04 01:25:12\')', 'INSERT', '127.0.0.1', '665e97288ca8f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO fun...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO fun...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\include\\builder\\BuilderMasterDetailFieldListTrait.php(80): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\crm\\FunilForm.php(202): FunilForm->storeItems(\'FunilEtapas\', \'funil_id\', Object(Funil), Object(Adianti\\Widget\\Form\\TFieldList), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: FunilForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'FunilForm', 'apache2handler', '665e97287e3d2', '2024', '06', '04'),
	(394, '2024-06-04 04:25:12', 'admin', 'kraftsoft', 'DELETE FROM funil_etapas WHERE (funil_id = \'1\' AND id not in (1))', 'DELETE', '127.0.0.1', '665e97288ca8f', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'DELETE FROM fun...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'DELETE FROM fun...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\include\\builder\\BuilderMasterDetailFieldListTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\crm\\FunilForm.php(202): FunilForm->storeItems(\'FunilEtapas\', \'funil_id\', Object(Funil), Object(Adianti\\Widget\\Form\\TFieldList), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: FunilForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'FunilForm', 'apache2handler', '665e97287e3d2', '2024', '06', '04'),
	(395, '2024-06-04 04:26:12', 'admin', 'kraftsoft', 'INSERT INTO negocio (negocio_origem_id, funil_id, funil_etapas_id, data_abertura, data_fechamento_esperada, contato_nome, contato_fone, contato_email, titulo, valor, cliente_id, vendedor_id, criado_em, criado_por, alterado_em, alterado_por, negocio_motivo_perda_id, comentarios_motivo_perda, ordem, system_unit_id, arquivado, ativo_id) VALUES (\'1\', \'1\', \'1\', \'2024-06-04\', \'2024-06-04\', \'FERNANDO\', \'65996728882\', \'fpasqueto@gmail.com\', \'TESTE\', NULL, \'1\', \'1\', \'2024-06-04 01:26:12\', \'Administrador\', NULL, NULL, NULL, NULL, 1, \'1\', \'2\', \'1\')', 'INSERT', '127.0.0.1', '665e9764a3f56', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO neg...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO neg...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\crm\\NegocioForm.php(236): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NegocioForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NegocioForm', 'apache2handler', '665e97647bbe5', '2024', '06', '04'),
	(396, '2024-06-04 04:26:12', 'admin', 'kraftsoft', 'INSERT INTO negocio_etapas_historico (funil_etapas_id, negocio_id, criado_por, criado_em) VALUES (\'1\', \'1\', \'Administrador\', \'2024-06-04 01:26:12\')', 'INSERT', '127.0.0.1', '665e9764a3f56', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO neg...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO neg...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\crm\\NegocioForm.php(247): Adianti\\Database\\TRecord->store()\n#3 [internal function]: NegocioForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NegocioForm', 'apache2handler', '665e97647bbe5', '2024', '06', '04'),
	(397, '2024-06-04 04:26:51', 'admin', 'kraftsoft', 'INSERT INTO orcamento (system_unit_id, orcamento_situacao_id, vendedor_id, cliente_id, cliente_contato_id, data_orcamento, observacao, valor_produtos, desconto, peso_total, frete_total, valor_total, tabela_preco_id, criado_por, criado_em) VALUES (1, \'1\', 1, 1, NULL, \'2024-06-04\', NULL, NULL, 0, 0, 0, NULL, NULL, \'Administrador\', \'2024-06-04 01:26:51\')', 'INSERT', '127.0.0.1', '665e978b58249', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Negocio.php(652): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\crm\\NegocioFormView.php(529): Negocio::GerarOrcamento(Object(Negocio))\n#4 [internal function]: NegocioFormView->onGerarOrcamentoYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'NegocioFormView', 'apache2handler', '665e978b24742', '2024', '06', '04'),
	(398, '2024-06-04 04:27:11', 'admin', 'kraftsoft', 'UPDATE orcamento SET orcamento_situacao_id = \'1\', data_orcamento = \'2024-05-30\', cliente_id = \'1\', vendedor_id = \'1\', cliente_contato_id = \'1\', tabela_preco_id = NULL, observacao = NULL, criado_por = \'Administrador\', alterado_em = \'2024-06-04 01:27:11\', alterado_por = \'Administrador\', valor_produtos = \'1250.00\', frete_total = \'0.00\', valor_total = \'1250.00\', peso_total = \'0.00\', desconto = \'0.00\', system_unit_id = \'1\' WHERE (id = \'5\')', 'UPDATE', '127.0.0.1', '665e979f872f4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(869): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e979f4f85f', '2024', '06', '04'),
	(399, '2024-06-04 04:27:11', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'5\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-06-04 01:27:11\')', 'INSERT', '127.0.0.1', '665e979f872f4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(873): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'5\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e979f4f85f', '2024', '06', '04'),
	(400, '2024-06-04 04:27:11', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = \'5\', produto_id = 5, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 01:27:11\', quantidade = 1, valor_unitario = 950, valor_total = 950, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e979f872f4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e979f4f85f', '2024', '06', '04'),
	(401, '2024-06-04 04:27:11', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = \'5\', produto_id = 6, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 01:27:11\', quantidade = 3, valor_unitario = 100, valor_total = 300, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 2)', 'UPDATE', '127.0.0.1', '665e979f872f4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e979f4f85f', '2024', '06', '04'),
	(402, '2024-06-04 04:27:11', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET deletado_em = \'2024-06-04 01:27:11\' WHERE (orcamento_id = \'5\' AND id not in (1,2) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '665e979f872f4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e979f4f85f', '2024', '06', '04'),
	(403, '2024-06-04 04:27:11', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = 5, produto_id = 5, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 01:27:11\', quantidade = 1, valor_unitario = 950, valor_total = 950, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 1)', 'UPDATE', '127.0.0.1', '665e979f872f4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(959): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(898): Orcamento::recalcula_itens_orcamento(Object(Orcamento))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e979f4f85f', '2024', '06', '04'),
	(404, '2024-06-04 04:27:11', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = 5, produto_id = 6, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-04 01:27:11\', quantidade = 3, valor_unitario = 100, valor_total = 300, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 2)', 'UPDATE', '127.0.0.1', '665e979f872f4', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(959): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(898): Orcamento::recalcula_itens_orcamento(Object(Orcamento))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'nn3ubr66bae04jm80oasdeh9ns', 'OrcamentoForm', 'apache2handler', '665e979f4f85f', '2024', '06', '04'),
	(405, '2024-06-06 00:48:56', 'admin', 'kraftsoft', 'INSERT INTO system_program_permissoes (system_program_id, descricao, criado_por, criado_em) VALUES (213, \'Desfazer baixa de contas a pagar\', \'Administrador\', \'2024-06-05 21:48:56\')', 'INSERT', '127.0.0.1', '66610778b664c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO sys...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO sys...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(262): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\Contaspag.php(649): SystemProgramPermissoes::ProcessaPermissao(Object(SystemProgram), \'Desfazer baixa ...\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(237): Contaspag::SincronizaPermissoesEspeciais()\n#5 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(464): SystemProgramPermissoes::CarregaPermissoesEspeciais()\n#6 [internal function]: PermissoesEspeciaisList->onCarregarPermissoes(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#8 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#9 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(609): Adianti\\Control\\TPage->show()\n#10 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): PermissoesEspeciaisList->show(Array)\n#11 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#12 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#13 {main}', 'uiii886mjue4h5d4cnlh7hhugu', 'PermissoesEspeciaisList', 'apache2handler', '6661077893a5c', '2024', '06', '05'),
	(406, '2024-06-06 00:48:56', 'admin', 'kraftsoft', 'INSERT INTO system_program_permissoes (system_program_id, descricao, criado_por, criado_em) VALUES (217, \'Desfazer baixa de contas a receber\', \'Administrador\', \'2024-06-05 21:48:56\')', 'INSERT', '127.0.0.1', '66610778b664c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO sys...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO sys...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(262): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\Contasrec.php(975): SystemProgramPermissoes::ProcessaPermissao(Object(SystemProgram), \'Desfazer baixa ...\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(238): Contasrec::SincronizaPermissoesEspeciais()\n#5 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(464): SystemProgramPermissoes::CarregaPermissoesEspeciais()\n#6 [internal function]: PermissoesEspeciaisList->onCarregarPermissoes(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#8 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#9 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(609): Adianti\\Control\\TPage->show()\n#10 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): PermissoesEspeciaisList->show(Array)\n#11 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#12 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#13 {main}', 'uiii886mjue4h5d4cnlh7hhugu', 'PermissoesEspeciaisList', 'apache2handler', '6661077893a5c', '2024', '06', '05'),
	(407, '2024-06-06 00:48:56', 'admin', 'kraftsoft', 'INSERT INTO system_program_permissoes (system_program_id, descricao, criado_por, criado_em) VALUES (102, \'Desfazer atendimento de venda de certificado\', \'Administrador\', \'2024-06-05 21:48:56\')', 'INSERT', '127.0.0.1', '66610778b664c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO sys...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO sys...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(262): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\CertificadoVenda.php(695): SystemProgramPermissoes::ProcessaPermissao(Object(SystemProgram), \'Desfazer atendi...\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(239): CertificadoVenda::SincronizaPermissoesEspeciais()\n#5 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(464): SystemProgramPermissoes::CarregaPermissoesEspeciais()\n#6 [internal function]: PermissoesEspeciaisList->onCarregarPermissoes(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#8 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#9 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(609): Adianti\\Control\\TPage->show()\n#10 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): PermissoesEspeciaisList->show(Array)\n#11 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#12 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#13 {main}', 'uiii886mjue4h5d4cnlh7hhugu', 'PermissoesEspeciaisList', 'apache2handler', '6661077893a5c', '2024', '06', '05'),
	(408, '2024-06-06 00:48:56', 'admin', 'kraftsoft', 'INSERT INTO system_program_permissoes (system_program_id, descricao, criado_por, criado_em) VALUES (82, \'Desfazer atendimento de venda de certificado\', \'Administrador\', \'2024-06-05 21:48:56\')', 'INSERT', '127.0.0.1', '66610778b664c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO sys...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO sys...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(262): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\CertificadoVenda.php(696): SystemProgramPermissoes::ProcessaPermissao(Object(SystemProgram), \'Desfazer atendi...\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(239): CertificadoVenda::SincronizaPermissoesEspeciais()\n#5 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(464): SystemProgramPermissoes::CarregaPermissoesEspeciais()\n#6 [internal function]: PermissoesEspeciaisList->onCarregarPermissoes(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#8 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#9 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(609): Adianti\\Control\\TPage->show()\n#10 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): PermissoesEspeciaisList->show(Array)\n#11 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#12 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#13 {main}', 'uiii886mjue4h5d4cnlh7hhugu', 'PermissoesEspeciaisList', 'apache2handler', '6661077893a5c', '2024', '06', '05'),
	(409, '2024-06-06 00:48:56', 'admin', 'kraftsoft', 'INSERT INTO system_program_permissoes (system_program_id, descricao, criado_por, criado_em) VALUES (46, \'Excluir funil de CRM\', \'Administrador\', \'2024-06-05 21:48:56\')', 'INSERT', '127.0.0.1', '66610778b664c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO sys...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO sys...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(262): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\Funil.php(364): SystemProgramPermissoes::ProcessaPermissao(Object(SystemProgram), \'Excluir funil d...\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(240): Funil::SincronizaPermissoesEspeciais()\n#5 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(464): SystemProgramPermissoes::CarregaPermissoesEspeciais()\n#6 [internal function]: PermissoesEspeciaisList->onCarregarPermissoes(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#8 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#9 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(609): Adianti\\Control\\TPage->show()\n#10 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): PermissoesEspeciaisList->show(Array)\n#11 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#12 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#13 {main}', 'uiii886mjue4h5d4cnlh7hhugu', 'PermissoesEspeciaisList', 'apache2handler', '6661077893a5c', '2024', '06', '05'),
	(410, '2024-06-06 00:48:56', 'admin', 'kraftsoft', 'INSERT INTO system_program_permissoes (system_program_id, descricao, criado_por, criado_em) VALUES (104, \'Excluir Cliente\', \'Administrador\', \'2024-06-05 21:48:56\')', 'INSERT', '127.0.0.1', '66610778b664c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO sys...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO sys...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(262): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\model\\Cliente.php(3064): SystemProgramPermissoes::ProcessaPermissao(Object(SystemProgram), \'Excluir Cliente\')\n#4 C:\\laragon\\www\\erp_nuvem\\app\\model\\SystemProgramPermissoes.php(241): Cliente::SincronizaPermissoesEspeciais()\n#5 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(464): SystemProgramPermissoes::CarregaPermissoesEspeciais()\n#6 [internal function]: PermissoesEspeciaisList->onCarregarPermissoes(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#8 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#9 C:\\laragon\\www\\erp_nuvem\\app\\control\\configuracoes\\PermissoesEspeciaisList.php(609): Adianti\\Control\\TPage->show()\n#10 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): PermissoesEspeciaisList->show(Array)\n#11 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#12 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#13 {main}', 'uiii886mjue4h5d4cnlh7hhugu', 'PermissoesEspeciaisList', 'apache2handler', '6661077893a5c', '2024', '06', '05'),
	(411, '2024-06-06 00:51:04', 'admin', 'kraftsoft', 'INSERT INTO api_error (url, error_message) VALUES (\'/cep/api/v1/78250000\', NULL)', 'INSERT', '127.0.0.1', '666107f82c203', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO api...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO api...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\service\\php_services\\CEPService.php(25): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\cliente\\ClienteForm.php(635): CEPService::get(\'78250000\')\n#4 [internal function]: ClienteForm::onBuscarCEP(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'uiii886mjue4h5d4cnlh7hhugu', 'ClienteForm', 'apache2handler', '666107f82505c', '2024', '06', '05'),
	(412, '2024-06-06 13:48:19', 'admin', 'kraftsoft', 'INSERT INTO orcamento (orcamento_situacao_id, data_orcamento, cliente_id, vendedor_id, cliente_contato_id, tabela_preco_id, observacao, criado_em, criado_por, alterado_em, alterado_por, valor_produtos, frete_total, valor_total, peso_total, desconto, system_unit_id) VALUES (\'1\', \'2024-06-06\', \'1\', NULL, NULL, NULL, NULL, \'2024-06-06 10:48:19\', \'Administrador\', NULL, NULL, \'1235.00\', \'0.00\', \'1235.00\', \'0.00\', \'0.00\', \'1\')', 'INSERT', '127.0.0.1', '6661be235a49c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(869): Adianti\\Database\\TRecord->store()\n#3 [internal function]: OrcamentoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'OrcamentoForm', 'apache2handler', '6661be23224c7', '2024', '06', '06'),
	(413, '2024-06-06 13:48:19', 'admin', 'kraftsoft', 'INSERT INTO orcamento_situacao_historico (orcamento_situacao_id, orcamento_id, descricao, criado_por, criado_em) VALUES (\'1\', \'6\', \'Situação do Orçamento: Aberto\', \'Administrador\', \'2024-06-06 10:48:19\')', 'INSERT', '127.0.0.1', '6661be235a49c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\OrcamentoSituacaoHistorico.php(93): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(873): OrcamentoSituacaoHistorico::LancarHistorico(\'1\', \'6\', \'Situa\\xC3\\xA7\\xC3\\xA3o do O...\')\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'OrcamentoForm', 'apache2handler', '6661be23224c7', '2024', '06', '06'),
	(414, '2024-06-06 13:48:19', 'admin', 'kraftsoft', 'INSERT INTO orcamento_item (produto_id, quantidade, valor_unitario, desconto, valor_frete, valor_total, numero_pedido, numero_item_pedido, informacoes_adicionais, orcamento_id, criado_em) VALUES (\'5\', \'1\', \'1235.00\', NULL, NULL, \'1235.00\', NULL, NULL, NULL, \'6\', \'2024-06-06 10:48:19\')', 'INSERT', '127.0.0.1', '6661be235a49c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO orc...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO orc...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(55): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'OrcamentoForm', 'apache2handler', '6661be23224c7', '2024', '06', '06'),
	(415, '2024-06-06 13:48:19', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET deletado_em = \'2024-06-06 10:48:19\' WHERE (orcamento_id = \'6\' AND id not in (3) AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6661be235a49c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(84): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(893): OrcamentoForm->storeMasterDetailItems(\'OrcamentoItem\', \'orcamento_id\', \'orcamento_item_...\', Object(Orcamento), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'OrcamentoForm', 'apache2handler', '6661be23224c7', '2024', '06', '06'),
	(416, '2024-06-06 13:48:19', 'admin', 'kraftsoft', 'UPDATE orcamento_item SET orcamento_id = 6, produto_id = 5, deletado_em = NULL, alterado_por = NULL, criado_por = NULL, alterado_em = \'2024-06-06 10:48:19\', quantidade = 1, valor_unitario = 1235, valor_total = 1235, valor_original = NULL, valor_custo = NULL, desconto = NULL, informacoes_adicionais = NULL, numero_pedido = NULL, numero_item_pedido = NULL, valor_frete = NULL, peso_unitario = NULL, peso_total = NULL WHERE (id = 3)', 'UPDATE', '127.0.0.1', '6661be235a49c', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE orcament...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'UPDATE orcament...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(959): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoForm.php(898): Orcamento::recalcula_itens_orcamento(Object(Orcamento))\n#4 [internal function]: OrcamentoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'OrcamentoForm', 'apache2handler', '6661be23224c7', '2024', '06', '06'),
	(417, '2024-06-06 13:48:26', 'admin', 'kraftsoft', 'INSERT INTO venda (system_unit_id, filial_saida_id, venda_situacao_id, orcamento_id, vendedor_id, cliente_id, data_hora_venda, data_prev_entrega, observacao, valor_produtos, desconto, peso_total, frete_total, valor_total, tabela_preco_id, venda_tipo_pagamento_id, venda_modalidade_id, movimentacao_origem_id, criado_por, criado_em) VALUES (1, 1, \'1\', 6, NULL, 1, \'2024-06-06 10:48:26\', \'2024-06-06 10:48:26\', NULL, 1235, 0, 0, 0, 1235, NULL, \'1\', \'1\', \'1\', \'Administrador\', \'2024-06-06 10:48:26\')', 'INSERT', '127.0.0.1', '6661be2a90001', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(1011): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoFormView.php(393): Orcamento::GerarVenda(Object(Orcamento))\n#4 [internal function]: OrcamentoFormView::onGerarVendaYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'OrcamentoFormView', 'apache2handler', '6661be2a86127', '2024', '06', '06'),
	(418, '2024-06-06 13:48:26', 'admin', 'kraftsoft', 'INSERT INTO venda_item (venda_id, produto_id, quantidade, valor_unitario, valor_total, valor_original, informacoes_adicionais, numero_pedido, numero_item_pedido, cancelado, valor_custo, estoque_deposito_id, desconto, valor_frete, peso_unitario, peso_total, criado_em) VALUES (\'3\', 5, 1, 1235, 1235, NULL, NULL, NULL, NULL, \'2\', \'950,00\', NULL, NULL, NULL, NULL, NULL, \'2024-06-06 10:48:26\')', 'INSERT', '127.0.0.1', '6661be2a90001', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO ven...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO ven...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Orcamento.php(1050): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\vendas\\OrcamentoFormView.php(393): Orcamento::GerarVenda(Object(Orcamento))\n#4 [internal function]: OrcamentoFormView::onGerarVendaYes(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(82): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'OrcamentoFormView', 'apache2handler', '6661be2a86127', '2024', '06', '06'),
	(419, '2024-06-06 13:52:00', 'admin', 'kraftsoft', 'INSERT INTO contaspag (contaspag_situacao_id, data_venc_original, data_pagamento, data_emissao, data_vencimento, data_competencia, fornecedor_id, forma_pagamento_id, contaspag_origem_id, numero_documento, parcela, valor, valor_pago, valor_aberto, desconto, valor_multa, juros, observacao, system_unit_id, criado_em, criado_por, alterado_em, alterado_por, cheque_banco_id, cheque_agencia, cheque_conta, cheque_cpfcnpj, cheque_emitente, data_vencimento_calendario) VALUES (\'1\', \'2024-06-20\', NULL, \'2024-06-06\', \'2024-06-20\', NULL, \'1\', \'2\', \'1\', \'111\', NULL, \'1000.00\', \'0.00\', 1000, \'0.00\', \'0.00\', \'0.00\', NULL, \'1\', \'2024-06-06 10:52:00\', \'Administrador\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'2024-06-20\')', 'INSERT', '127.0.0.1', '6661bf0090fdb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\Contaspag.php(540): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContaspagForm.php(493): Contaspag->store()\n#4 [internal function]: ContaspagForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ContaspagForm', 'apache2handler', '6661bf0054f61', '2024', '06', '06'),
	(420, '2024-06-06 13:52:00', 'admin', 'kraftsoft', 'INSERT INTO contaspag_historico_venc (contaspag_id, vencimento_anterior, vencimento_atual, criado_por, criado_em) VALUES (\'1\', NULL, \'2024-06-20\', \'Administrador\', \'2024-06-06 10:52:00\')', 'INSERT', '127.0.0.1', '6661bf0090fdb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContaspagForm.php(507): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContaspagForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ContaspagForm', 'apache2handler', '6661bf0054f61', '2024', '06', '06'),
	(421, '2024-06-06 13:52:00', 'admin', 'kraftsoft', 'UPDATE contaspag_contabil SET deletado_em = \'2024-06-06 10:52:00\' WHERE (contaspag_id = \'1\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6661bf0090fdb', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE contaspa...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE contaspa...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContaspagForm.php(524): ContaspagForm->storeMasterDetailItems(\'ContaspagContab...\', \'contaspag_id\', \'contaspag_conta...\', Object(Contaspag), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ContaspagForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ContaspagForm', 'apache2handler', '6661bf0054f61', '2024', '06', '06'),
	(422, '2024-06-06 13:55:07', 'admin', 'kraftsoft', 'INSERT INTO produto (tipo_recurso_id, referencia, codigo_sku, nome, codigo_EAN, produto_grupo_id, produtogrupo_subgrupo_id, produto_fabricante_id, unidade_medida_id, produto_tipo_id, marca, nome_curto, peso_liquido, peso_bruto, produto_embalagem_id, largura, altura, comprimento, diametro, dias_preparacao, unidade_caixa, garantia, obs, habilitado_id, criado_em, criado_por, alterado_em, alterado_por, ncm, cest, notafiscal_item_orig_id, imagem, especificacao, link_site) VALUES (\'1\', NULL, NULL, \'ETIQUETA 120X120\', NULL, \'1\', NULL, NULL, \'7\', \'2\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\', \'2024-06-06 10:55:07\', \'Administrador\', NULL, NULL, NULL, NULL, \'1\', NULL, NULL, NULL)', 'INSERT', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO pro...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO pro...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1072): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ProdutoForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#7 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '6661bfbb15a51', '2024', '06', '06'),
	(423, '2024-06-06 13:55:07', 'admin', 'kraftsoft', 'UPDATE produto_fornecedor SET deletado_em = \'2024-06-06 10:55:07\' WHERE (produto_id = \'11\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1090): ProdutoForm->storeMasterDetailItems(\'ProdutoForneced...\', \'produto_id\', \'produto_fornece...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '6661bfbb15a51', '2024', '06', '06'),
	(424, '2024-06-06 13:55:07', 'admin', 'kraftsoft', 'UPDATE produto_filial SET deletado_em = \'2024-06-06 10:55:07\' WHERE (produto_id = \'11\' AND deletado_em IS NULL)', 'UPDATE', '127.0.0.1', '6661bfbb681c2', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'UPDATE produto_...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRepository.php(564): Adianti\\Database\\TTransaction::log(\'UPDATE produto_...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\lib\\builder\\BuilderMasterDetailTrait.php(91): Adianti\\Database\\TRepository->delete(Object(Adianti\\Database\\TCriteria))\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\produto\\ProdutoForm.php(1146): ProdutoForm->storeMasterDetailItems(\'ProdutoFilial\', \'produto_id\', \'produto_filial_...\', Object(Produto), Array, Object(Adianti\\Wrapper\\BootstrapFormBuilder), Object(Adianti\\Wrapper\\BootstrapDatagridWrapper), Object(Closure), Object(Adianti\\Database\\TCriteria))\n#4 [internal function]: ProdutoForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(86): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#8 {main}', 'tg61ol9faabbai3f96evjkn37u', 'ProdutoForm', 'apache2handler', '6661bfbb15a51', '2024', '06', '06'),
	(425, '2024-07-30 17:46:01', 'admin', 'kraftsoft', 'INSERT INTO contasrec (contasrec_situacao_id, data_venc_original, data_pagamento, data_emissao, data_vencimento, data_competencia, cliente_id, forma_pagamento_id, contasrec_origem_id, plano_conta_id, centro_custo_id, numero_documento, parcela, valor, valor_pago, valor_aberto, desconto, valor_multa, juros, observacao, system_unit_id, criado_em, criado_por, alterado_em, alterado_por, cheque_banco_id, cheque_agencia, cheque_conta, cheque_cpfcnpj, cheque_emitente, ativo_id) VALUES (\'1\', \'2024-07-31\', NULL, \'2024-07-30\', \'2024-07-31\', \'2024-07-31\', \'1\', \'2\', \'1\', \'2\', \'4\', \'11121254\', \'1\', \'500.00\', \'0.00\', 500, \'0.00\', \'0.00\', \'0.00\', NULL, \'1\', \'2024-07-30 14:46:01\', \'Administrador\', NULL, NULL, NULL, NULL, NULL, NULL, NULL, \'1\')', 'INSERT', '127.0.0.1', '66a926d94a478', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecForm.php(269): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', '34t9q80ekelhn5c4vnho4t6ld1', 'ContasrecForm', 'apache2handler', '66a926d8b5a8a', '2024', '07', '30'),
	(426, '2024-07-30 17:46:01', 'admin', 'kraftsoft', 'INSERT INTO contasrec_historico_venc (contasrec_id, vencimento_anterior, vencimento_atual, criado_por, criado_em) VALUES (\'2\', NULL, \'2024-07-31\', \'Administrador\', \'2024-07-30 14:46:01\')', 'INSERT', '127.0.0.1', '66a926d94a478', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecForm.php(283): Adianti\\Database\\TRecord->store()\n#3 [internal function]: ContasrecForm->onSave(Array)\n#4 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#7 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#9 {main}', '34t9q80ekelhn5c4vnho4t6ld1', 'ContasrecForm', 'apache2handler', '66a926d8b5a8a', '2024', '07', '30'),
	(427, '2024-07-30 17:46:01', 'admin', 'kraftsoft', 'INSERT INTO contabil_lancamentos (plano_conta_id, centro_custo_id, contabil_lancamentos_tipo_id, contabil_lancamentos_situacao_id, contabil_lancamentos_origem_id, data_lancamento, valor, contasrec_id, historico, criado_por, criado_em) VALUES (\'2\', \'4\', \'2\', \'2\', \'2\', \'2024-07-31\', \'500.00\', \'2\', \'Ref. Crédito Cliente: Fernando Ferreira Gomes Nascimento\', \'Administrador\', \'2024-07-30 14:46:01\')', 'INSERT', '127.0.0.1', '66a926d94a478', '#0 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TTransaction.php(245): SystemSqlLogService->write(\'INSERT INTO con...\')\n#1 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\database\\TRecord.php(832): Adianti\\Database\\TTransaction::log(\'INSERT INTO con...\')\n#2 C:\\laragon\\www\\erp_nuvem\\app\\model\\ContabilLancamentos.php(343): Adianti\\Database\\TRecord->store()\n#3 C:\\laragon\\www\\erp_nuvem\\app\\control\\financeiro\\ContasrecForm.php(295): ContabilLancamentos::LancamentoContabil(\'2\', \'4\', \'2\', \'2\', \'2\', \'2\', \'2024-07-31\', \'500.00\', \'Ref. Cr\\xC3\\xA9dito C...\')\n#4 [internal function]: ContasrecForm->onSave(Array)\n#5 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(107): call_user_func(Array, Array)\n#6 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\control\\TPage.php(269): Adianti\\Control\\TPage->run()\n#7 C:\\laragon\\www\\erp_nuvem\\lib\\adianti\\core\\AdiantiCoreApplication.php(96): Adianti\\Control\\TPage->show(Array)\n#8 C:\\laragon\\www\\erp_nuvem\\engine.php(43): Adianti\\Core\\AdiantiCoreApplication::run(\'0\')\n#9 C:\\laragon\\www\\erp_nuvem\\engine.php(99): TApplication::run()\n#10 {main}', '34t9q80ekelhn5c4vnho4t6ld1', 'ContasrecForm', 'apache2handler', '66a926d8b5a8a', '2024', '07', '30');

/*!40103 SET TIME_ZONE=IFNULL(@OLD_TIME_ZONE, 'system') */;
/*!40101 SET SQL_MODE=IFNULL(@OLD_SQL_MODE, '') */;
/*!40014 SET FOREIGN_KEY_CHECKS=IFNULL(@OLD_FOREIGN_KEY_CHECKS, 1) */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40111 SET SQL_NOTES=IFNULL(@OLD_SQL_NOTES, 1) */;
